/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/editor/common/core/range","vs/base/common/charCode","vs/base/common/errors","vs/editor/common/core/position","vs/editor/common/core/offsetRange","vs/base/common/arrays","vs/base/common/strings","vs/base/common/arraysFind","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/uint","vs/editor/common/core/lineRange","vs/base/common/map","vs/base/common/platform","vs/base/common/objects","vs/base/common/uri","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/types","vs/base/common/codiconsUtil","vs/base/common/diff/diff","vs/editor/common/core/characterClassifier","vs/editor/common/core/textLength","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/marshallingIds","vs/base/common/process","vs/base/common/path","vs/base/common/cache","vs/base/common/codiconsLibrary","vs/base/common/codicons","vs/base/common/hash","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/positionToOffset","vs/editor/common/core/textEdit","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/encodedTokenAttributes","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/findSectionHeaders","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],re=function(x){for(var i=[],t=0,n=x.length;t<n;t++)i[t]=ie[x[t]];return i};const Je=this,Ze=typeof global=="object"?global:{};var Le;(function(x){x.global=Je;class i{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=i._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof x.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}x.Environment=i})(Le||(Le={}));var Le;(function(x){class i{constructor(g,L,d){this.type=g,this.detail=L,this.timestamp=d}}x.LoaderEvent=i;class t{constructor(g){this._events=[new i(1,"",g)]}record(g,L){this._events.push(new i(g,L,x.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}x.LoaderEventRecorder=t;class n{record(g,L){}getEvents(){return[]}}n.INSTANCE=new n,x.NullLoaderEventRecorder=n})(Le||(Le={}));var Le;(function(x){class i{static fileUriToFilePath(n,T){if(T=decodeURI(T).replace(/%23/g,"#"),n){if(/^file:\/\/\//.test(T))return T.substr(8);if(/^file:\/\//.test(T))return T.substr(5)}else if(/^file:\/\//.test(T))return T.substr(7);return T}static startsWith(n,T){return n.length>=T.length&&n.substr(0,T.length)===T}static endsWith(n,T){return n.length>=T.length&&n.substr(n.length-T.length)===T}static containsQueryString(n){return/^[^\#]*\?/gi.test(n)}static isAbsolutePath(n){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(n)}static forEachProperty(n,T){if(n){let g;for(g in n)n.hasOwnProperty(g)&&T(g,n[g])}}static isEmpty(n){let T=!0;return i.forEachProperty(n,()=>{T=!1}),T}static recursiveClone(n){if(!n||typeof n!="object"||n instanceof RegExp||!Array.isArray(n)&&Object.getPrototypeOf(n)!==Object.prototype)return n;let T=Array.isArray(n)?[]:{};return i.forEachProperty(n,(g,L)=>{L&&typeof L=="object"?T[g]=i.recursiveClone(L):T[g]=L}),T}static generateAnonymousModule(){return"===anonymous"+i.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(n){return i.startsWith(n,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=x.global.performance&&typeof x.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?x.global.performance.now():Date.now()}}i.NEXT_ANONYMOUS_ID=1,i.PERFORMANCE_NOW_PROBED=!1,i.HAS_PERFORMANCE_NOW=!1,x.Utilities=i})(Le||(Le={}));var Le;(function(x){function i(T){if(T instanceof Error)return T;const g=new Error(T.message||String(T)||"Unknown Error");return T.stack&&(g.stack=T.stack),g}x.ensureError=i;class t{static validateConfigurationOptions(g){function L(d){if(d.phase==="loading"){console.error('Loading "'+d.moduleId+'" failed'),console.error(d),console.error("Here are the modules that depend on it:"),console.error(d.neededBy);return}if(d.phase==="factory"){console.error('The factory function of "'+d.moduleId+'" has thrown an exception'),console.error(d),console.error("Here are the modules that depend on it:"),console.error(d.neededBy);return}}if(g=g||{},typeof g.baseUrl!="string"&&(g.baseUrl=""),typeof g.isBuild!="boolean"&&(g.isBuild=!1),typeof g.paths!="object"&&(g.paths={}),typeof g.config!="object"&&(g.config={}),typeof g.catchError>"u"&&(g.catchError=!1),typeof g.recordStats>"u"&&(g.recordStats=!1),typeof g.urlArgs!="string"&&(g.urlArgs=""),typeof g.onError!="function"&&(g.onError=L),Array.isArray(g.ignoreDuplicateModules)||(g.ignoreDuplicateModules=[]),g.baseUrl.length>0&&(x.Utilities.endsWith(g.baseUrl,"/")||(g.baseUrl+="/")),typeof g.cspNonce!="string"&&(g.cspNonce=""),typeof g.preferScriptTags>"u"&&(g.preferScriptTags=!1),g.nodeCachedData&&typeof g.nodeCachedData=="object"&&(typeof g.nodeCachedData.seed!="string"&&(g.nodeCachedData.seed="seed"),(typeof g.nodeCachedData.writeDelay!="number"||g.nodeCachedData.writeDelay<0)&&(g.nodeCachedData.writeDelay=1e3*7),!g.nodeCachedData.path||typeof g.nodeCachedData.path!="string")){const d=i(new Error("INVALID cached data configuration, 'path' MUST be set"));d.phase="configuration",g.onError(d),g.nodeCachedData=void 0}return g}static mergeConfigurationOptions(g=null,L=null){let d=x.Utilities.recursiveClone(L||{});return x.Utilities.forEachProperty(g,(a,u)=>{a==="ignoreDuplicateModules"&&typeof d.ignoreDuplicateModules<"u"?d.ignoreDuplicateModules=d.ignoreDuplicateModules.concat(u):a==="paths"&&typeof d.paths<"u"?x.Utilities.forEachProperty(u,(c,$)=>d.paths[c]=$):a==="config"&&typeof d.config<"u"?x.Utilities.forEachProperty(u,(c,$)=>d.config[c]=$):d[a]=x.Utilities.recursiveClone(u)}),t.validateConfigurationOptions(d)}}x.ConfigurationOptionsUtil=t;class n{constructor(g,L){if(this._env=g,this.options=t.mergeConfigurationOptions(L),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let d=this.options.nodeRequire.main.filename,a=Math.max(d.lastIndexOf("/"),d.lastIndexOf("\\"));this.options.baseUrl=d.substring(0,a+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let g=0;g<this.options.ignoreDuplicateModules.length;g++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[g]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],x.Utilities.forEachProperty(this.options.paths,(g,L)=>{Array.isArray(L)?this.sortedPathsRules.push({from:g,to:L}):this.sortedPathsRules.push({from:g,to:[L]})}),this.sortedPathsRules.sort((g,L)=>L.from.length-g.from.length)}cloneAndMerge(g){return new n(this._env,t.mergeConfigurationOptions(g,this.options))}getOptionsLiteral(){return this.options}_applyPaths(g){let L;for(let d=0,a=this.sortedPathsRules.length;d<a;d++)if(L=this.sortedPathsRules[d],x.Utilities.startsWith(g,L.from)){let u=[];for(let c=0,$=L.to.length;c<$;c++)u.push(L.to[c]+g.substr(L.from.length));return u}return[g]}_addUrlArgsToUrl(g){return x.Utilities.containsQueryString(g)?g+"&"+this.options.urlArgs:g+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(g){return this.options.urlArgs?this._addUrlArgsToUrl(g):g}_addUrlArgsIfNecessaryToUrls(g){if(this.options.urlArgs)for(let L=0,d=g.length;L<d;L++)g[L]=this._addUrlArgsToUrl(g[L]);return g}moduleIdToPaths(g){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(g))return this.isBuild()?["empty:"]:["node|"+g];let L=g,d;if(!x.Utilities.endsWith(L,".js")&&!x.Utilities.isAbsolutePath(L)){d=this._applyPaths(L);for(let a=0,u=d.length;a<u;a++)this.isBuild()&&d[a]==="empty:"||(x.Utilities.isAbsolutePath(d[a])||(d[a]=this.options.baseUrl+d[a]),!x.Utilities.endsWith(d[a],".js")&&!x.Utilities.containsQueryString(d[a])&&(d[a]=d[a]+".js"))}else!x.Utilities.endsWith(L,".js")&&!x.Utilities.containsQueryString(L)&&(L=L+".js"),d=[L];return this._addUrlArgsIfNecessaryToUrls(d)}requireToUrl(g){let L=g;return x.Utilities.isAbsolutePath(L)||(L=this._applyPaths(L)[0],x.Utilities.isAbsolutePath(L)||(L=this.options.baseUrl+L)),this._addUrlArgsIfNecessaryToUrl(L)}isBuild(){return this.options.isBuild}shouldInvokeFactory(g){return!!(!this.options.isBuild||x.Utilities.isAnonymousModule(g)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[g])}isDuplicateMessageIgnoredFor(g){return this.ignoreDuplicateModulesMap.hasOwnProperty(g)}getConfigForModule(g){if(this.options.config)return this.options.config[g]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(g){this.options.onError(g)}}x.Configuration=n})(Le||(Le={}));var Le;(function(x){class i{constructor(u){this._env=u,this._scriptLoader=null,this._callbackMap={}}load(u,c,$,m){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new T;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=u.getConfig().getOptionsLiteral();e?this._scriptLoader=new t:this._scriptLoader=new g(this._env)}else this._env.isNode?this._scriptLoader=new g(this._env):this._scriptLoader=new t;let w={callback:$,errorback:m};if(this._callbackMap.hasOwnProperty(c)){this._callbackMap[c].push(w);return}this._callbackMap[c]=[w],this._scriptLoader.load(u,c,()=>this.triggerCallback(c),e=>this.triggerErrorback(c,e))}triggerCallback(u){let c=this._callbackMap[u];delete this._callbackMap[u];for(let $=0;$<c.length;$++)c[$].callback()}triggerErrorback(u,c){let $=this._callbackMap[u];delete this._callbackMap[u];for(let m=0;m<$.length;m++)$[m].errorback(c)}}class t{attachListeners(u,c,$){let m=()=>{u.removeEventListener("load",w),u.removeEventListener("error",e)},w=b=>{m(),c()},e=b=>{m(),$(b)};u.addEventListener("load",w),u.addEventListener("error",e)}load(u,c,$,m){if(/^node\|/.test(c)){let w=u.getConfig().getOptionsLiteral(),e=L(u.getRecorder(),w.nodeRequire||x.global.nodeRequire),b=c.split("|"),N=null;try{N=e(b[1])}catch(_){m(_);return}u.enqueueDefineAnonymousModule([],()=>N),$()}else{let w=document.createElement("script");w.setAttribute("async","async"),w.setAttribute("type","text/javascript"),this.attachListeners(w,$,m);const{trustedTypesPolicy:e}=u.getConfig().getOptionsLiteral();e&&(c=e.createScriptURL(c)),w.setAttribute("src",c);const{cspNonce:b}=u.getConfig().getOptionsLiteral();b&&w.setAttribute("nonce",b),document.getElementsByTagName("head")[0].appendChild(w)}}}function n(a){const{trustedTypesPolicy:u}=a.getConfig().getOptionsLiteral();try{return(u?self.eval(u.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class T{constructor(){this._cachedCanUseEval=null}_canUseEval(u){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=n(u)),this._cachedCanUseEval}load(u,c,$,m){if(/^node\|/.test(c)){const w=u.getConfig().getOptionsLiteral(),e=L(u.getRecorder(),w.nodeRequire||x.global.nodeRequire),b=c.split("|");let N=null;try{N=e(b[1])}catch(_){m(_);return}u.enqueueDefineAnonymousModule([],function(){return N}),$()}else{const{trustedTypesPolicy:w}=u.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(c)&&c.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(u)){fetch(c).then(b=>{if(b.status!==200)throw new Error(b.statusText);return b.text()}).then(b=>{b=`${b}
//# sourceURL=${c}`,(w?self.eval(w.createScript("",b)):new Function(b)).call(self),$()}).then(void 0,m);return}try{w&&(c=w.createScriptURL(c)),importScripts(c),$()}catch(b){m(b)}}}}class g{constructor(u){this._env=u,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(u){this._didInitialize||(this._didInitialize=!0,this._fs=u("fs"),this._vm=u("vm"),this._path=u("path"),this._crypto=u("crypto"))}_initNodeRequire(u,c){const{nodeCachedData:$}=c.getConfig().getOptionsLiteral();if(!$||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const m=this,w=u("module");function e(b){const N=b.constructor;let _=function(E){try{return b.require(E)}finally{}};return _.resolve=function(E,v){return N._resolveFilename(E,b,!1,v)},_.resolve.paths=function(E){return N._resolveLookupPaths(E,b)},_.main=process.mainModule,_.extensions=N._extensions,_.cache=N._cache,_}w.prototype._compile=function(b,N){const _=w.wrap(b.replace(/^#!.*/,"")),A=c.getRecorder(),E=m._getCachedDataPath($,N),v={filename:N};let h;try{const p=m._fs.readFileSync(E);h=p.slice(0,16),v.cachedData=p.slice(16),A.record(60,E)}catch{A.record(61,E)}const o=new m._vm.Script(_,v),r=o.runInThisContext(v),l=m._path.dirname(N),f=e(this),D=[this.exports,f,this,N,l,process,Ze,Buffer],R=r.apply(this.exports,D);return m._handleCachedData(o,_,E,!v.cachedData,c),m._verifyCachedData(o,_,E,h,c),R}}load(u,c,$,m){const w=u.getConfig().getOptionsLiteral(),e=L(u.getRecorder(),w.nodeRequire||x.global.nodeRequire),b=w.nodeInstrumenter||function(_){return _};this._init(e),this._initNodeRequire(e,u);let N=u.getRecorder();if(/^node\|/.test(c)){let _=c.split("|"),A=null;try{A=e(_[1])}catch(E){m(E);return}u.enqueueDefineAnonymousModule([],()=>A),$()}else{c=x.Utilities.fileUriToFilePath(this._env.isWindows,c);const _=this._path.normalize(c),A=this._getElectronRendererScriptPathOrUri(_),E=!!w.nodeCachedData,v=E?this._getCachedDataPath(w.nodeCachedData,c):void 0;this._readSourceAndCachedData(_,v,N,(h,o,r,l)=>{if(h){m(h);return}let f;o.charCodeAt(0)===g._BOM?f=g._PREFIX+o.substring(1)+g._SUFFIX:f=g._PREFIX+o+g._SUFFIX,f=b(f,_);const D={filename:A,cachedData:r},R=this._createAndEvalScript(u,f,D,$,m);this._handleCachedData(R,f,v,E&&!r,u),this._verifyCachedData(R,f,v,l,u)})}}_createAndEvalScript(u,c,$,m,w){const e=u.getRecorder();e.record(31,$.filename);const b=new this._vm.Script(c,$),N=b.runInThisContext($),_=u.getGlobalAMDDefineFunc();let A=!1;const E=function(){return A=!0,_.apply(null,arguments)};return E.amd=_.amd,N.call(x.global,u.getGlobalAMDRequireFunc(),E,$.filename,this._path.dirname($.filename)),e.record(32,$.filename),A?m():w(new Error(`Didn't receive define call in ${$.filename}!`)),b}_getElectronRendererScriptPathOrUri(u){if(!this._env.isElectronRenderer)return u;let c=u.match(/^([a-z])\:(.*)/i);return c?`file:///${(c[1].toUpperCase()+":"+c[2]).replace(/\\/g,"/")}`:`file://${u}`}_getCachedDataPath(u,c){const $=this._crypto.createHash("md5").update(c,"utf8").update(u.seed,"utf8").update(process.arch,"").digest("hex"),m=this._path.basename(c).replace(/\.js$/,"");return this._path.join(u.path,`${m}-${$}.code`)}_handleCachedData(u,c,$,m,w){u.cachedDataRejected?this._fs.unlink($,e=>{w.getRecorder().record(62,$),this._createAndWriteCachedData(u,c,$,w),e&&w.getConfig().onError(e)}):m&&this._createAndWriteCachedData(u,c,$,w)}_createAndWriteCachedData(u,c,$,m){let w=Math.ceil(m.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,b=0,N;const _=()=>{setTimeout(()=>{N||(N=this._crypto.createHash("md5").update(c,"utf8").digest());const A=u.createCachedData();if(!(A.length===0||A.length===e||b>=5)){if(A.length<e){_();return}e=A.length,this._fs.writeFile($,Buffer.concat([N,A]),E=>{E&&m.getConfig().onError(E),m.getRecorder().record(63,$),_()})}},w*Math.pow(4,b++))};_()}_readSourceAndCachedData(u,c,$,m){if(!c)this._fs.readFile(u,{encoding:"utf8"},m);else{let w,e,b,N=2;const _=A=>{A?m(A):--N===0&&m(void 0,w,e,b)};this._fs.readFile(u,{encoding:"utf8"},(A,E)=>{w=E,_(A)}),this._fs.readFile(c,(A,E)=>{!A&&E&&E.length>0?(b=E.slice(0,16),e=E.slice(16),$.record(60,c)):$.record(61,c),_()})}}_verifyCachedData(u,c,$,m,w){m&&(u.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(c,"utf8").digest();m.equals(e)||(w.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${$}' now, but a RESTART IS REQUIRED`)),this._fs.unlink($,b=>{b&&w.getConfig().onError(b)}))},Math.ceil(5e3*(1+Math.random()))))}}g._BOM=65279,g._PREFIX="(function (require, define, __filename, __dirname) { ",g._SUFFIX=`
});`;function L(a,u){if(u.__$__isRecorded)return u;const c=function(m){a.record(33,m);try{return u(m)}finally{a.record(34,m)}};return c.__$__isRecorded=!0,c}x.ensureRecordedNodeRequire=L;function d(a){return new i(a)}x.createScriptLoader=d})(Le||(Le={}));var Le;(function(x){class i{constructor(a){let u=a.lastIndexOf("/");u!==-1?this.fromModulePath=a.substr(0,u+1):this.fromModulePath=""}static _normalizeModuleId(a){let u=a,c;for(c=/\/\.\//;c.test(u);)u=u.replace(c,"/");for(u=u.replace(/^\.\//g,""),c=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;c.test(u);)u=u.replace(c,"/");return u=u.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),u}resolveModule(a){let u=a;return x.Utilities.isAbsolutePath(u)||(x.Utilities.startsWith(u,"./")||x.Utilities.startsWith(u,"../"))&&(u=i._normalizeModuleId(this.fromModulePath+u)),u}}i.ROOT=new i(""),x.ModuleIdResolver=i;class t{constructor(a,u,c,$,m,w){this.id=a,this.strId=u,this.dependencies=c,this._callback=$,this._errorback=m,this.moduleIdResolver=w,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(a,u){try{return{returnedValue:a.apply(x.global,u),producedError:null}}catch(c){return{returnedValue:null,producedError:c}}}static _invokeFactory(a,u,c,$){return a.shouldInvokeFactory(u)?a.shouldCatchError()?this._safeInvokeFunction(c,$):{returnedValue:c.apply(x.global,$),producedError:null}:{returnedValue:null,producedError:null}}complete(a,u,c,$){this._isComplete=!0;let m=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);let w=t._invokeFactory(u,this.strId,this._callback,c);m=w.producedError,a.record(22,this.strId),!m&&typeof w.returnedValue<"u"&&(!this.exportsPassedIn||x.Utilities.isEmpty(this.exports))&&(this.exports=w.returnedValue)}else this.exports=this._callback;if(m){let w=x.ensureError(m);w.phase="factory",w.moduleId=this.strId,w.neededBy=$(this.id),this.error=w,u.onError(w)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1}isComplete(){return this._isComplete}}x.Module=t;class n{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(a){let u=this._strModuleIdToIntModuleId.get(a);return typeof u>"u"&&(u=this._nextId++,this._strModuleIdToIntModuleId.set(a,u),this._intModuleIdToStrModuleId[u]=a),u}getStrModuleId(a){return this._intModuleIdToStrModuleId[a]}}class T{constructor(a){this.id=a}}T.EXPORTS=new T(0),T.MODULE=new T(1),T.REQUIRE=new T(2),x.RegularDependency=T;class g{constructor(a,u,c){this.id=a,this.pluginId=u,this.pluginParam=c}}x.PluginDependency=g;class L{constructor(a,u,c,$,m=0){this._env=a,this._scriptLoader=u,this._loaderAvailableTimestamp=m,this._defineFunc=c,this._requireFunc=$,this._moduleIdProvider=new n,this._config=new x.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new L(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(a,u){let c=w=>w.replace(/\\/g,"/"),$=c(a),m=u.split(/\n/);for(let w=0;w<m.length;w++){let e=m[w].match(/(.*):(\d+):(\d+)\)?$/);if(e){let b=e[1],N=e[2],_=e[3],A=Math.max(b.lastIndexOf(" ")+1,b.lastIndexOf("(")+1);if(b=b.substr(A),b=c(b),b===$){let E={line:parseInt(N,10),col:parseInt(_,10)};return E.line===1&&(E.col-=53),E}}}throw new Error("Could not correlate define call site for needle "+a)}getBuildInfo(){if(!this._config.isBuild())return null;let a=[],u=0;for(let c=0,$=this._modules2.length;c<$;c++){let m=this._modules2[c];if(!m)continue;let w=this._buildInfoPath[m.id]||null,e=this._buildInfoDefineStack[m.id]||null,b=this._buildInfoDependencies[m.id];a[u++]={id:m.strId,path:w,defineLocation:w&&e?L._findRelevantLocationInStack(w,e):null,dependencies:b,shim:null,exports:m.exports}}return a}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new x.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=x.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(a,u){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let c=null;this._config.isBuild()&&(c=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:c,dependencies:a,callback:u}}defineModule(a,u,c,$,m,w=new i(a)){let e=this._moduleIdProvider.getModuleId(a);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}let b=new t(e,a,this._normalizeDependencies(u,w),c,$,w);this._modules2[e]=b,this._config.isBuild()&&(this._buildInfoDefineStack[e]=m,this._buildInfoDependencies[e]=(b.dependencies||[]).map(N=>this._moduleIdProvider.getStrModuleId(N.id))),this._resolve(b)}_normalizeDependency(a,u){if(a==="exports")return T.EXPORTS;if(a==="module")return T.MODULE;if(a==="require")return T.REQUIRE;let c=a.indexOf("!");if(c>=0){let $=u.resolveModule(a.substr(0,c)),m=u.resolveModule(a.substr(c+1)),w=this._moduleIdProvider.getModuleId($+"!"+m),e=this._moduleIdProvider.getModuleId($);return new g(w,e,m)}return new T(this._moduleIdProvider.getModuleId(u.resolveModule(a)))}_normalizeDependencies(a,u){let c=[],$=0;for(let m=0,w=a.length;m<w;m++)c[$++]=this._normalizeDependency(a[m],u);return c}_relativeRequire(a,u,c,$){if(typeof u=="string")return this.synchronousRequire(u,a);this.defineModule(x.Utilities.generateAnonymousModule(),u,c,$,null,a)}synchronousRequire(a,u=new i(a)){let c=this._normalizeDependency(a,u),$=this._modules2[c.id];if(!$)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!$.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if($.error)throw $.error;return $.exports}configure(a,u){let c=this._config.shouldRecordStats();u?this._config=new x.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!c&&(this._recorder=null)}getConfig(){return this._config}_onLoad(a){if(this._currentAnonymousDefineCall!==null){let u=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),u.dependencies,u.callback,null,u.stack)}}_createLoadError(a,u){let c=this._moduleIdProvider.getStrModuleId(a),$=(this._inverseDependencies2[a]||[]).map(w=>this._moduleIdProvider.getStrModuleId(w));const m=x.ensureError(u);return m.phase="loading",m.moduleId=c,m.neededBy=$,m}_onLoadError(a,u){const c=this._createLoadError(a,u);this._modules2[a]||(this._modules2[a]=new t(a,this._moduleIdProvider.getStrModuleId(a),[],()=>{},null,null));let $=[];for(let e=0,b=this._moduleIdProvider.getMaxModuleId();e<b;e++)$[e]=!1;let m=!1,w=[];for(w.push(a),$[a]=!0;w.length>0;){let e=w.shift(),b=this._modules2[e];b&&(m=b.onDependencyError(c)||m);let N=this._inverseDependencies2[e];if(N)for(let _=0,A=N.length;_<A;_++){let E=N[_];$[E]||(w.push(E),$[E]=!0)}}m||this._config.onError(c)}_hasDependencyPath(a,u){let c=this._modules2[a];if(!c)return!1;let $=[];for(let w=0,e=this._moduleIdProvider.getMaxModuleId();w<e;w++)$[w]=!1;let m=[];for(m.push(c),$[a]=!0;m.length>0;){let e=m.shift().dependencies;if(e)for(let b=0,N=e.length;b<N;b++){let _=e[b];if(_.id===u)return!0;let A=this._modules2[_.id];A&&!$[_.id]&&($[_.id]=!0,m.push(A))}}return!1}_findCyclePath(a,u,c){if(a===u||c===50)return[a];let $=this._modules2[a];if(!$)return null;let m=$.dependencies;if(m)for(let w=0,e=m.length;w<e;w++){let b=this._findCyclePath(m[w].id,u,c+1);if(b!==null)return b.push(a),b}return null}_createRequire(a){let u=(c,$,m)=>this._relativeRequire(a,c,$,m);return u.toUrl=c=>this._config.requireToUrl(a.resolveModule(c)),u.getStats=()=>this.getLoaderEvents(),u.hasDependencyCycle=()=>this._hasDependencyCycle,u.config=(c,$=!1)=>{this.configure(c,$)},u.__$__nodeRequire=x.global.nodeRequire,u}_loadModule(a){if(this._modules2[a]||this._knownModules2[a])return;this._knownModules2[a]=!0;let u=this._moduleIdProvider.getStrModuleId(a),c=this._config.moduleIdToPaths(u),$=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(u.indexOf("/")===-1||$.test(u))&&c.push("node|"+u);let m=-1,w=e=>{if(m++,m>=c.length)this._onLoadError(a,e);else{let b=c[m],N=this.getRecorder();if(this._config.isBuild()&&b==="empty:"){this._buildInfoPath[a]=b,this.defineModule(this._moduleIdProvider.getStrModuleId(a),[],null,null,null),this._onLoad(a);return}N.record(10,b),this._scriptLoader.load(this,b,()=>{this._config.isBuild()&&(this._buildInfoPath[a]=b),N.record(11,b),this._onLoad(a)},_=>{N.record(12,b),w(_)})}};w(null)}_loadPluginDependency(a,u){if(this._modules2[u.id]||this._knownModules2[u.id])return;this._knownModules2[u.id]=!0;let c=$=>{this.defineModule(this._moduleIdProvider.getStrModuleId(u.id),[],$,null,null)};c.error=$=>{this._config.onError(this._createLoadError(u.id,$))},a.load(u.pluginParam,this._createRequire(i.ROOT),c,this._config.getOptionsLiteral())}_resolve(a){let u=a.dependencies;if(u)for(let c=0,$=u.length;c<$;c++){let m=u[c];if(m===T.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(m===T.MODULE){a.unresolvedDependenciesCount--;continue}if(m===T.REQUIRE){a.unresolvedDependenciesCount--;continue}let w=this._modules2[m.id];if(w&&w.isComplete()){if(w.error){a.onDependencyError(w.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(m.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(m.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");let e=this._findCyclePath(m.id,a.id,0)||[];e.reverse(),e.push(m.id),console.warn(e.map(b=>this._moduleIdProvider.getStrModuleId(b)).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[m.id]=this._inverseDependencies2[m.id]||[],this._inverseDependencies2[m.id].push(a.id),m instanceof g){let e=this._modules2[m.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,m);continue}let b=this._inversePluginDependencies2.get(m.pluginId);b||(b=[],this._inversePluginDependencies2.set(m.pluginId,b)),b.push(m),this._loadModule(m.pluginId);continue}this._loadModule(m.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)}_onModuleComplete(a){let u=this.getRecorder();if(a.isComplete())return;let c=a.dependencies,$=[];if(c)for(let b=0,N=c.length;b<N;b++){let _=c[b];if(_===T.EXPORTS){$[b]=a.exports;continue}if(_===T.MODULE){$[b]={id:a.strId,config:()=>this._config.getConfigForModule(a.strId)};continue}if(_===T.REQUIRE){$[b]=this._createRequire(a.moduleIdResolver);continue}let A=this._modules2[_.id];if(A){$[b]=A.exports;continue}$[b]=null}const m=b=>(this._inverseDependencies2[b]||[]).map(N=>this._moduleIdProvider.getStrModuleId(N));a.complete(u,this._config,$,m);let w=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,w)for(let b=0,N=w.length;b<N;b++){let _=w[b],A=this._modules2[_];A.unresolvedDependenciesCount--,A.unresolvedDependenciesCount===0&&this._onModuleComplete(A)}let e=this._inversePluginDependencies2.get(a.id);if(e){this._inversePluginDependencies2.delete(a.id);for(let b=0,N=e.length;b<N;b++)this._loadPluginDependency(a.exports,e[b])}}}x.ModuleManager=L})(Le||(Le={}));var ne,Le;(function(x){const i=new x.Environment;let t=null;const n=function(d,a,u){typeof d!="string"&&(u=a,a=d,d=null),(typeof a!="object"||!Array.isArray(a))&&(u=a,a=null),a||(a=["require","exports","module"]),d?t.defineModule(d,a,u,null,null):t.enqueueDefineAnonymousModule(a,u)};n.amd={jQuery:!0};const T=function(d,a=!1){t.configure(d,a)},g=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){T(arguments[0]);return}if(typeof arguments[0]=="string")return t.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){t.defineModule(x.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};g.config=T,g.getConfig=function(){return t.getConfig().getOptionsLiteral()},g.reset=function(){t=t.reset()},g.getBuildInfo=function(){return t.getBuildInfo()},g.getStats=function(){return t.getLoaderEvents()},g.define=n;function L(){if(typeof x.global.require<"u"||typeof require<"u"){const d=x.global.require||require;if(typeof d=="function"&&typeof d.resolve=="function"){const a=x.ensureRecordedNodeRequire(t.getRecorder(),d);x.global.nodeRequire=a,g.nodeRequire=a,g.__$__nodeRequire=a}}i.isNode&&!i.isElectronRenderer&&!i.isElectronNodeIntegrationWebWorker?module.exports=g:(i.isElectronRenderer||(x.global.define=n),x.global.require=g)}x.init=L,(typeof x.global.define!="function"||!x.global.define.amd)&&(t=new x.ModuleManager(i,x.createScriptLoader(i),n,g,x.Utilities.getHighPerformanceTimestamp()),typeof x.global.require<"u"&&typeof x.global.require!="function"&&g.config(x.global.require),ne=function(){return n.apply(null,arguments)},ne.amd=n.amd,typeof doNotInitLoader>"u"&&L())})(Le||(Le={})),ne(ie[75],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.load=t;function t(d,a,u,c){if(c=c||{},(c["vs/css"]||{}).disabled){u({});return}const m=a.toUrl(d+".css");n(d,m,()=>{u({})},w=>{typeof u.error=="function"&&u.error("Could not find "+m+".")})}function n(d,a,u,c){if(T(d,a)){u();return}g(d,a,u,c)}function T(d,a){const u=window.document.getElementsByTagName("link");for(let c=0,$=u.length;c<$;c++){const m=u[c].getAttribute("data-name"),w=u[c].getAttribute("href");if(m===d||w===a)return!0}return!1}function g(d,a,u,c){const $=document.createElement("link");$.setAttribute("rel","stylesheet"),$.setAttribute("type","text/css"),$.setAttribute("data-name",d),L(d,$,u,c),$.setAttribute("href",a),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild($)}function L(d,a,u,c){const $=()=>{a.removeEventListener("load",m),a.removeEventListener("error",w)},m=e=>{$(),u()},w=e=>{$(),c(e)};a.addEventListener("load",m),a.addEventListener("error",w)}}),function(){const x=globalThis.MonacoEnvironment,i=x&&x.baseUrl?x.baseUrl:"../../../";function t(c,$){if(x?.createTrustedTypesPolicy)try{return x.createTrustedTypesPolicy(c,$)}catch(m){console.warn(m);return}try{return self.trustedTypes?.createPolicy(c,$)}catch(m){console.warn(m);return}}const n=t("amdLoader",{createScriptURL:c=>c,createScript:(c,...$)=>{const m=$.slice(0,-1).join(","),w=$.pop().toString();return`(function anonymous(${m}) { ${w}
})`}});function T(){try{return(n?globalThis.eval(n.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function g(){return new Promise((c,$)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return c();const m=i+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(m)&&m.substring(0,globalThis.origin.length)!==globalThis.origin)&&T()){fetch(m).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${m}`,(n?globalThis.eval(n.createScript("",e)):new Function(e)).call(globalThis),c()}).then(void 0,$);return}n?importScripts(n.createScriptURL(m)):importScripts(m),c()})}function L(){require.config({baseUrl:i,catchError:!0,trustedTypesPolicy:n,amdModulesPattern:/^vs\//})}function d(c){g().then(()=>{L(),require([c],function($){setTimeout(function(){const m=$.create((w,e)=>{globalThis.postMessage(w,e)},null);for(globalThis.onmessage=w=>m.onmessage(w.data,w.ports);u.length>0;){const w=u.shift();m.onmessage(w.data,w.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&L();let a=!0;const u=[];globalThis.onmessage=c=>{if(!a){u.push(c);return}a=!1,d(c.data)}}(),ne(ie[9],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$lb=void 0,i.$eb=t,i.$fb=n,i.$gb=T,i.$hb=g,i.$ib=L,i.$jb=d,i.$kb=a,i.$mb=c,i.$nb=$,i.$ob=m,i.$pb=w,i.$qb=e;function t(b,N){const _=n(b,N);if(_!==-1)return b[_]}function n(b,N,_=b.length-1){for(let A=_;A>=0;A--){const E=b[A];if(N(E))return A}return-1}function T(b,N){const _=g(b,N);return _===-1?void 0:b[_]}function g(b,N,_=0,A=b.length){let E=_,v=A;for(;E<v;){const h=Math.floor((E+v)/2);N(b[h])?E=h+1:v=h}return E-1}function L(b,N){const _=d(b,N);return _===b.length?void 0:b[_]}function d(b,N,_=0,A=b.length){let E=_,v=A;for(;E<v;){const h=Math.floor((E+v)/2);N(b[h])?v=h:E=h+1}return E}function a(b,N,_=0,A=b.length){const E=d(b,N,_,A);return E===b.length?-1:E}class u{static{this.assertInvariants=!1}constructor(N){this.e=N,this.c=0}findLastMonotonous(N){if(u.assertInvariants){if(this.d){for(const A of this.e)if(this.d(A)&&!N(A))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=N}const _=g(this.e,N,this.c);return this.c=_+1,_===-1?void 0:this.e[_]}}i.$lb=u;function c(b,N){if(b.length===0)return;let _=b[0];for(let A=1;A<b.length;A++){const E=b[A];N(E,_)>0&&(_=E)}return _}function $(b,N){if(b.length===0)return;let _=b[0];for(let A=1;A<b.length;A++){const E=b[A];N(E,_)>=0&&(_=E)}return _}function m(b,N){return c(b,(_,A)=>-N(_,A))}function w(b,N){if(b.length===0)return-1;let _=0;for(let A=1;A<b.length;A++){const E=b[A];N(E,b[_])>0&&(_=A)}return _}function e(b,N){for(const _ of b){const A=N(_);if(A!==void 0)return A}}}),ne(ie[3],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.CharCode=void 0;var t;(function(n){n[n.Null=0]="Null",n[n.Backspace=8]="Backspace",n[n.Tab=9]="Tab",n[n.LineFeed=10]="LineFeed",n[n.CarriageReturn=13]="CarriageReturn",n[n.Space=32]="Space",n[n.ExclamationMark=33]="ExclamationMark",n[n.DoubleQuote=34]="DoubleQuote",n[n.Hash=35]="Hash",n[n.DollarSign=36]="DollarSign",n[n.PercentSign=37]="PercentSign",n[n.Ampersand=38]="Ampersand",n[n.SingleQuote=39]="SingleQuote",n[n.OpenParen=40]="OpenParen",n[n.CloseParen=41]="CloseParen",n[n.Asterisk=42]="Asterisk",n[n.Plus=43]="Plus",n[n.Comma=44]="Comma",n[n.Dash=45]="Dash",n[n.Period=46]="Period",n[n.Slash=47]="Slash",n[n.Digit0=48]="Digit0",n[n.Digit1=49]="Digit1",n[n.Digit2=50]="Digit2",n[n.Digit3=51]="Digit3",n[n.Digit4=52]="Digit4",n[n.Digit5=53]="Digit5",n[n.Digit6=54]="Digit6",n[n.Digit7=55]="Digit7",n[n.Digit8=56]="Digit8",n[n.Digit9=57]="Digit9",n[n.Colon=58]="Colon",n[n.Semicolon=59]="Semicolon",n[n.LessThan=60]="LessThan",n[n.Equals=61]="Equals",n[n.GreaterThan=62]="GreaterThan",n[n.QuestionMark=63]="QuestionMark",n[n.AtSign=64]="AtSign",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.OpenSquareBracket=91]="OpenSquareBracket",n[n.Backslash=92]="Backslash",n[n.CloseSquareBracket=93]="CloseSquareBracket",n[n.Caret=94]="Caret",n[n.Underline=95]="Underline",n[n.BackTick=96]="BackTick",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.OpenCurlyBrace=123]="OpenCurlyBrace",n[n.Pipe=124]="Pipe",n[n.CloseCurlyBrace=125]="CloseCurlyBrace",n[n.Tilde=126]="Tilde",n[n.NoBreakSpace=160]="NoBreakSpace",n[n.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",n[n.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",n[n.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",n[n.U_Combining_Tilde=771]="U_Combining_Tilde",n[n.U_Combining_Macron=772]="U_Combining_Macron",n[n.U_Combining_Overline=773]="U_Combining_Overline",n[n.U_Combining_Breve=774]="U_Combining_Breve",n[n.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",n[n.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",n[n.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",n[n.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",n[n.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",n[n.U_Combining_Caron=780]="U_Combining_Caron",n[n.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",n[n.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",n[n.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",n[n.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",n[n.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",n[n.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",n[n.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",n[n.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",n[n.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",n[n.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",n[n.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",n[n.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",n[n.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",n[n.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",n[n.U_Combining_Horn=795]="U_Combining_Horn",n[n.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",n[n.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",n[n.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",n[n.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",n[n.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",n[n.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",n[n.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",n[n.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",n[n.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",n[n.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",n[n.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",n[n.U_Combining_Cedilla=807]="U_Combining_Cedilla",n[n.U_Combining_Ogonek=808]="U_Combining_Ogonek",n[n.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",n[n.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",n[n.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",n[n.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",n[n.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",n[n.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",n[n.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",n[n.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",n[n.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",n[n.U_Combining_Low_Line=818]="U_Combining_Low_Line",n[n.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",n[n.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",n[n.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",n[n.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",n[n.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",n[n.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",n[n.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",n[n.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",n[n.U_Combining_Square_Below=827]="U_Combining_Square_Below",n[n.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",n[n.U_Combining_X_Above=829]="U_Combining_X_Above",n[n.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",n[n.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",n[n.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",n[n.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",n[n.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",n[n.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",n[n.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",n[n.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",n[n.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",n[n.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",n[n.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",n[n.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",n[n.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",n[n.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",n[n.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",n[n.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",n[n.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",n[n.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",n[n.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",n[n.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",n[n.U_Combining_Fermata=850]="U_Combining_Fermata",n[n.U_Combining_X_Below=851]="U_Combining_X_Below",n[n.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",n[n.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",n[n.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",n[n.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",n[n.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",n[n.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",n[n.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",n[n.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",n[n.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",n[n.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",n[n.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",n[n.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",n[n.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",n[n.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",n[n.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",n[n.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",n[n.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",n[n.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",n[n.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",n[n.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",n[n.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",n[n.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",n[n.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",n[n.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",n[n.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",n[n.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",n[n.LINE_SEPARATOR=8232]="LINE_SEPARATOR",n[n.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",n[n.NEXT_LINE=133]="NEXT_LINE",n[n.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",n[n.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",n[n.U_DIAERESIS=168]="U_DIAERESIS",n[n.U_MACRON=175]="U_MACRON",n[n.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",n[n.U_CEDILLA=184]="U_CEDILLA",n[n.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",n[n.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",n[n.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",n[n.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",n[n.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",n[n.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",n[n.U_BREVE=728]="U_BREVE",n[n.U_DOT_ABOVE=729]="U_DOT_ABOVE",n[n.U_RING_ABOVE=730]="U_RING_ABOVE",n[n.U_OGONEK=731]="U_OGONEK",n[n.U_SMALL_TILDE=732]="U_SMALL_TILDE",n[n.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",n[n.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",n[n.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",n[n.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",n[n.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",n[n.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",n[n.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",n[n.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",n[n.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",n[n.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",n[n.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",n[n.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",n[n.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",n[n.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",n[n.U_GREEK_TONOS=900]="U_GREEK_TONOS",n[n.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",n[n.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",n[n.U_GREEK_PSILI=8127]="U_GREEK_PSILI",n[n.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",n[n.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",n[n.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",n[n.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",n[n.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",n[n.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",n[n.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",n[n.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",n[n.U_GREEK_VARIA=8175]="U_GREEK_VARIA",n[n.U_GREEK_OXIA=8189]="U_GREEK_OXIA",n[n.U_GREEK_DASIA=8190]="U_GREEK_DASIA",n[n.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",n[n.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",n[n.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",n[n.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",n[n.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",n[n.U_OVERLINE=8254]="U_OVERLINE",n[n.UTF8_BOM=65279]="UTF8_BOM",n[n.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",n[n.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(t||(i.CharCode=t={}))}),ne(ie[37],re([0,1]),function(x,i){"use strict";var t;Object.defineProperty(i,"__esModule",{value:!0}),i.$g=void 0,i.$c=n,i.$d=T,i.$e=g,i.$f=L;function n(a,u){const c=Object.create(null);for(const $ of a){const m=u($);let w=c[m];w||(w=c[m]=[]),w.push($)}return c}function T(a,u){const c=[],$=[];for(const m of a)u.has(m)||c.push(m);for(const m of u)a.has(m)||$.push(m);return{removed:c,added:$}}function g(a,u){const c=[],$=[];for(const[m,w]of a)u.has(m)||c.push(w);for(const[m,w]of u)a.has(m)||$.push(w);return{removed:c,added:$}}function L(a,u){const c=new Set;for(const $ of u)a.has($)&&c.add($);return c}class d{static{t=Symbol.toStringTag}constructor(u,c){this.b=c,this.a=new Map,this[t]="SetWithKey";for(const $ of u)this.add($)}get size(){return this.a.size}add(u){const c=this.b(u);return this.a.set(c,u),this}delete(u){return this.a.delete(this.b(u))}has(u){return this.a.has(this.b(u))}*entries(){for(const u of this.a.values())yield[u,u]}keys(){return this.values()}*values(){for(const u of this.a.values())yield u}clear(){this.a.clear()}forEach(u,c){this.a.forEach($=>u.call(c,$,$,this))}[Symbol.iterator](){return this.values()}}i.$g=d}),ne(ie[38],re([0,1,3]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$ju=i.$iu=i.$hu=i.$gu=void 0;function n(a,u){const c=Math.pow(10,u);return Math.round(a*c)/c}class T{constructor(u,c,$,m=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,u))|0,this.g=Math.min(255,Math.max(0,c))|0,this.b=Math.min(255,Math.max(0,$))|0,this.a=n(Math.max(Math.min(1,m),0),3)}static equals(u,c){return u.r===c.r&&u.g===c.g&&u.b===c.b&&u.a===c.a}}i.$gu=T;class g{constructor(u,c,$,m){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=n(Math.max(Math.min(1,c),0),3),this.l=n(Math.max(Math.min(1,$),0),3),this.a=n(Math.max(Math.min(1,m),0),3)}static equals(u,c){return u.h===c.h&&u.s===c.s&&u.l===c.l&&u.a===c.a}static fromRGBA(u){const c=u.r/255,$=u.g/255,m=u.b/255,w=u.a,e=Math.max(c,$,m),b=Math.min(c,$,m);let N=0,_=0;const A=(b+e)/2,E=e-b;if(E>0){switch(_=Math.min(A<=.5?E/(2*A):E/(2-2*A),1),e){case c:N=($-m)/E+($<m?6:0);break;case $:N=(m-c)/E+2;break;case m:N=(c-$)/E+4;break}N*=60,N=Math.round(N)}return new g(N,_,A,w)}static i(u,c,$){return $<0&&($+=1),$>1&&($-=1),$<1/6?u+(c-u)*6*$:$<1/2?c:$<2/3?u+(c-u)*(2/3-$)*6:u}static toRGBA(u){const c=u.h/360,{s:$,l:m,a:w}=u;let e,b,N;if($===0)e=b=N=m;else{const _=m<.5?m*(1+$):m+$-m*$,A=2*m-_;e=g.i(A,_,c+1/3),b=g.i(A,_,c),N=g.i(A,_,c-1/3)}return new T(Math.round(e*255),Math.round(b*255),Math.round(N*255),w)}}i.$hu=g;class L{constructor(u,c,$,m){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=n(Math.max(Math.min(1,c),0),3),this.v=n(Math.max(Math.min(1,$),0),3),this.a=n(Math.max(Math.min(1,m),0),3)}static equals(u,c){return u.h===c.h&&u.s===c.s&&u.v===c.v&&u.a===c.a}static fromRGBA(u){const c=u.r/255,$=u.g/255,m=u.b/255,w=Math.max(c,$,m),e=Math.min(c,$,m),b=w-e,N=w===0?0:b/w;let _;return b===0?_=0:w===c?_=(($-m)/b%6+6)%6:w===$?_=(m-c)/b+2:_=(c-$)/b+4,new L(Math.round(_*60),N,w,u.a)}static toRGBA(u){const{h:c,s:$,v:m,a:w}=u,e=m*$,b=e*(1-Math.abs(c/60%2-1)),N=m-e;let[_,A,E]=[0,0,0];return c<60?(_=e,A=b):c<120?(_=b,A=e):c<180?(A=e,E=b):c<240?(A=b,E=e):c<300?(_=b,E=e):c<=360&&(_=e,E=b),_=Math.round((_+N)*255),A=Math.round((A+N)*255),E=Math.round((E+N)*255),new T(_,A,E,w)}}i.$iu=L;class d{static fromHex(u){return d.Format.CSS.parseHex(u)||d.red}static equals(u,c){return!u&&!c?!0:!u||!c?!1:u.equals(c)}get hsla(){return this.i?this.i:g.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:L.fromRGBA(this.rgba)}constructor(u){if(u)if(u instanceof T)this.rgba=u;else if(u instanceof g)this.i=u,this.rgba=g.toRGBA(u);else if(u instanceof L)this.j=u,this.rgba=L.toRGBA(u);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(u){return!!u&&T.equals(this.rgba,u.rgba)&&g.equals(this.hsla,u.hsla)&&L.equals(this.hsva,u.hsva)}getRelativeLuminance(){const u=d.k(this.rgba.r),c=d.k(this.rgba.g),$=d.k(this.rgba.b),m=.2126*u+.7152*c+.0722*$;return n(m,4)}static k(u){const c=u/255;return c<=.03928?c/12.92:Math.pow((c+.055)/1.055,2.4)}getContrastRatio(u){const c=this.getRelativeLuminance(),$=u.getRelativeLuminance();return c>$?(c+.05)/($+.05):($+.05)/(c+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(u){const c=this.getRelativeLuminance(),$=u.getRelativeLuminance();return c>$}isDarkerThan(u){const c=this.getRelativeLuminance(),$=u.getRelativeLuminance();return c<$}lighten(u){return new d(new g(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*u,this.hsla.a))}darken(u){return new d(new g(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*u,this.hsla.a))}transparent(u){const{r:c,g:$,b:m,a:w}=this.rgba;return new d(new T(c,$,m,w*u))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new d(new T(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(u){const c=u.rgba,$=this.rgba.a,m=c.a,w=$+m*(1-$);if(w<1e-6)return d.transparent;const e=this.rgba.r*$/w+c.r*m*(1-$)/w,b=this.rgba.g*$/w+c.g*m*(1-$)/w,N=this.rgba.b*$/w+c.b*m*(1-$)/w;return new d(new T(e,b,N,w))}makeOpaque(u){if(this.isOpaque()||u.rgba.a!==1)return this;const{r:c,g:$,b:m,a:w}=this.rgba;return new d(new T(u.rgba.r-w*(u.rgba.r-c),u.rgba.g-w*(u.rgba.g-$),u.rgba.b-w*(u.rgba.b-m),1))}flatten(...u){const c=u.reduceRight(($,m)=>d.o(m,$));return d.o(this,c)}static o(u,c){const $=1-u.rgba.a;return new d(new T($*c.rgba.r+u.rgba.a*u.rgba.r,$*c.rgba.g+u.rgba.a*u.rgba.g,$*c.rgba.b+u.rgba.a*u.rgba.b))}toString(){return this.u||(this.u=d.Format.CSS.format(this)),this.u}static getLighterColor(u,c,$){if(u.isLighterThan(c))return u;$=$||.5;const m=u.getRelativeLuminance(),w=c.getRelativeLuminance();return $=$*(w-m)/w,u.lighten($)}static getDarkerColor(u,c,$){if(u.isDarkerThan(c))return u;$=$||.5;const m=u.getRelativeLuminance(),w=c.getRelativeLuminance();return $=$*(m-w)/m,u.darken($)}static{this.white=new d(new T(255,255,255,1))}static{this.black=new d(new T(0,0,0,1))}static{this.red=new d(new T(255,0,0,1))}static{this.blue=new d(new T(0,0,255,1))}static{this.green=new d(new T(0,255,0,1))}static{this.cyan=new d(new T(0,255,255,1))}static{this.lightgrey=new d(new T(211,211,211,1))}static{this.transparent=new d(new T(0,0,0,0))}}i.$ju=d,function(a){let u;(function(c){let $;(function(m){function w(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:a.Format.CSS.formatRGBA(r)}m.formatRGB=w;function e(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}m.formatRGBA=e;function b(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:a.Format.CSS.formatHSLA(r)}m.formatHSL=b;function N(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}m.formatHSLA=N;function _(r){const l=r.toString(16);return l.length!==2?"0"+l:l}function A(r){return`#${_(r.rgba.r)}${_(r.rgba.g)}${_(r.rgba.b)}`}m.formatHex=A;function E(r,l=!1){return l&&r.rgba.a===1?a.Format.CSS.formatHex(r):`#${_(r.rgba.r)}${_(r.rgba.g)}${_(r.rgba.b)}${_(Math.round(r.rgba.a*255))}`}m.formatHexA=E;function v(r){return r.isOpaque()?a.Format.CSS.formatHex(r):a.Format.CSS.formatRGBA(r)}m.format=v;function h(r){const l=r.length;if(l===0||r.charCodeAt(0)!==t.CharCode.Hash)return null;if(l===7){const f=16*o(r.charCodeAt(1))+o(r.charCodeAt(2)),D=16*o(r.charCodeAt(3))+o(r.charCodeAt(4)),R=16*o(r.charCodeAt(5))+o(r.charCodeAt(6));return new a(new T(f,D,R,1))}if(l===9){const f=16*o(r.charCodeAt(1))+o(r.charCodeAt(2)),D=16*o(r.charCodeAt(3))+o(r.charCodeAt(4)),R=16*o(r.charCodeAt(5))+o(r.charCodeAt(6)),p=16*o(r.charCodeAt(7))+o(r.charCodeAt(8));return new a(new T(f,D,R,p/255))}if(l===4){const f=o(r.charCodeAt(1)),D=o(r.charCodeAt(2)),R=o(r.charCodeAt(3));return new a(new T(16*f+f,16*D+D,16*R+R))}if(l===5){const f=o(r.charCodeAt(1)),D=o(r.charCodeAt(2)),R=o(r.charCodeAt(3)),p=o(r.charCodeAt(4));return new a(new T(16*f+f,16*D+D,16*R+R,(16*p+p)/255))}return null}m.parseHex=h;function o(r){switch(r){case t.CharCode.Digit0:return 0;case t.CharCode.Digit1:return 1;case t.CharCode.Digit2:return 2;case t.CharCode.Digit3:return 3;case t.CharCode.Digit4:return 4;case t.CharCode.Digit5:return 5;case t.CharCode.Digit6:return 6;case t.CharCode.Digit7:return 7;case t.CharCode.Digit8:return 8;case t.CharCode.Digit9:return 9;case t.CharCode.a:return 10;case t.CharCode.A:return 10;case t.CharCode.b:return 11;case t.CharCode.B:return 11;case t.CharCode.c:return 12;case t.CharCode.C:return 12;case t.CharCode.d:return 13;case t.CharCode.D:return 13;case t.CharCode.e:return 14;case t.CharCode.E:return 14;case t.CharCode.f:return 15;case t.CharCode.F:return 15}return 0}})($=c.CSS||(c.CSS={}))})(u=a.Format||(a.Format={}))}(d||(i.$ju=d={}))}),ne(ie[39],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Nt=void 0;class t{constructor(T,g,L,d){this.originalStart=T,this.originalLength=g,this.modifiedStart=L,this.modifiedLength=d}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}i.$Nt=t}),ne(ie[4],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$bb=i.$ab=i.$_=i.$$=i.$0=i.$8=i.$4=i.$V=i.$U=void 0,i.setUnexpectedErrorHandler=n,i.$X=T,i.$Y=g,i.$Z=L,i.$1=d,i.$2=a,i.$3=c,i.$5=m,i.$6=w,i.$7=e,i.$9=N;class t{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?v.isErrorNoTelemetry(r)?new v(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(l=>{l(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}i.$U=t,i.$V=new t;function n(o){i.$V.setUnexpectedErrorHandler(o)}function T(o){if(!o||typeof o!="object")return!1;const r=o;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}function g(o){c(o)||i.$V.onUnexpectedError(o)}function L(o){c(o)||i.$V.onUnexpectedExternalError(o)}function d(o){if(o instanceof Error){const{name:r,message:l}=o,f=o.stacktrace||o.stack;return{$isError:!0,name:r,message:l,stack:f,noTelemetry:v.isErrorNoTelemetry(o)}}return o}function a(o){let r;return o.noTelemetry?r=new v:(r=new Error,r.name=o.name),r.message=o.message,r.stack=o.stack,r}const u="Canceled";function c(o){return o instanceof $?!0:o instanceof Error&&o.name===u&&o.message===u}class $ extends Error{constructor(){super(u),this.name=this.message}}i.$4=$;function m(){const o=new Error(u);return o.name=o.message,o}function w(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}function e(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}class b extends TypeError{constructor(r){super(r?`${r} is read-only and cannot be changed`:"Cannot change read-only property")}}i.$8=b;function N(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}class _ extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}i.$0=_;class A extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}i.$$=A;class E extends Error{constructor(){super(...arguments),this.isExpected=!0}}i.$_=E;class v extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof v)return r;const l=new v;return l.message=r.message,l.stack=r.stack,l}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}i.$ab=v;class h extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,h.prototype)}}i.$bb=h}),ne(ie[7],re([0,1,4,9]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$_b=i.$$b=i.$0b=i.$8b=i.$7b=i.CompareResult=void 0,i.$rb=T,i.$sb=g,i.$tb=L,i.$ub=d,i.$vb=a,i.$wb=u,i.$xb=c,i.$yb=$,i.$zb=m,i.$Ab=w,i.$Bb=e,i.$Cb=b,i.$Db=N,i.top=_,i.$Fb=A,i.$Gb=v,i.$Hb=h,i.$Ib=o,i.$Jb=r,i.$Kb=l,i.$Lb=f,i.$Mb=D,i.$Nb=R,i.$Ob=p,i.$Pb=M,i.$Qb=j,i.$Rb=S,i.$Sb=I,i.$Tb=W,i.$Ub=P,i.$Vb=H,i.$Wb=B,i.$Xb=y,i.$Yb=Y,i.$Zb=J,i.$1b=G,i.$2b=Z,i.$3b=C,i.$4b=F,i.$5b=oe,i.$6b=we,i.$9b=ke;function T(q,V=0){return q[q.length-(1+V)]}function g(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}function L(q,V,U=(Q,ee)=>Q===ee){if(q===V)return!0;if(!q||!V||q.length!==V.length)return!1;for(let Q=0,ee=q.length;Q<ee;Q++)if(!U(q[Q],V[Q]))return!1;return!0}function d(q,V){const U=q.length-1;V<U&&(q[V]=q[U]),q.pop()}function a(q,V,U){return u(q.length,Q=>U(q[Q],V))}function u(q,V){let U=0,Q=q-1;for(;U<=Q;){const ee=(U+Q)/2|0,he=V(ee);if(he<0)U=ee+1;else if(he>0)Q=ee-1;else return ee}return-(U+1)}function c(q,V,U){if(q=q|0,q>=V.length)throw new TypeError("invalid index");const Q=V[Math.floor(V.length*Math.random())],ee=[],he=[],de=[];for(const Ee of V){const ve=U(Ee,Q);ve<0?ee.push(Ee):ve>0?he.push(Ee):de.push(Ee)}return q<ee.length?c(q,ee,U):q<ee.length+de.length?de[0]:c(q-(ee.length+de.length),he,U)}function $(q,V){const U=[];let Q;for(const ee of q.slice(0).sort(V))!Q||V(Q[0],ee)!==0?(Q=[ee],U.push(Q)):Q.push(ee);return U}function*m(q,V){let U,Q;for(const ee of q)Q!==void 0&&V(Q,ee)?U.push(ee):(U&&(yield U),U=[ee]),Q=ee;U&&(yield U)}function w(q,V){for(let U=0;U<=q.length;U++)V(U===0?void 0:q[U-1],U===q.length?void 0:q[U])}function e(q,V){for(let U=0;U<q.length;U++)V(U===0?void 0:q[U-1],q[U],U+1===q.length?void 0:q[U+1])}function b(q,V,U){const Q=[];function ee(Ee,ve,_e){if(ve===0&&_e.length===0)return;const se=Q[Q.length-1];se&&se.start+se.deleteCount===Ee?(se.deleteCount+=ve,se.toInsert.push(..._e)):Q.push({start:Ee,deleteCount:ve,toInsert:_e})}let he=0,de=0;for(;;){if(he===q.length){ee(he,0,V.slice(de));break}if(de===V.length){ee(he,q.length-he,[]);break}const Ee=q[he],ve=V[de],_e=U(Ee,ve);_e===0?(he+=1,de+=1):_e<0?(ee(he,1,[]),he+=1):_e>0&&(ee(he,0,[ve]),de+=1)}return Q}function N(q,V,U){const Q=b(q,V,U),ee=[],he=[];for(const de of Q)ee.push(...q.slice(de.start,de.start+de.deleteCount)),he.push(...de.toInsert);return{removed:ee,added:he}}function _(q,V,U){if(U===0)return[];const Q=q.slice(0,U).sort(V);return E(q,V,Q,U,q.length),Q}function A(q,V,U,Q,ee){return U===0?Promise.resolve([]):new Promise((he,de)=>{(async()=>{const Ee=q.length,ve=q.slice(0,U).sort(V);for(let _e=U,se=Math.min(U+Q,Ee);_e<Ee;_e=se,se=Math.min(se+Q,Ee)){if(_e>U&&await new Promise(te=>setTimeout(te)),ee&&ee.isCancellationRequested)throw new t.$4;E(q,V,ve,_e,se)}return ve})().then(he,de)})}function E(q,V,U,Q,ee){for(const he=U.length;Q<ee;Q++){const de=q[Q];if(V(de,U[he-1])<0){U.pop();const Ee=(0,n.$jb)(U,ve=>V(de,ve)<0);U.splice(Ee,0,de)}}}function v(q){return q.filter(V=>!!V)}function h(q){let V=0;for(let U=0;U<q.length;U++)q[U]&&(q[V]=q[U],V+=1);q.length=V}function o(q,V,U){q.splice(U,0,q.splice(V,1)[0])}function r(q){return!Array.isArray(q)||q.length===0}function l(q){return Array.isArray(q)&&q.length>0}function f(q,V=U=>U){const U=new Set;return q.filter(Q=>{const ee=V(Q);return U.has(ee)?!1:(U.add(ee),!0)})}function D(q){const V=new Set;return U=>{const Q=q(U);return V.has(Q)?!1:(V.add(Q),!0)}}function R(q,V){return q.length>0?q[0]:V}function p(q,V){return q.length>0?q[q.length-1]:V}function M(q,V,U=(Q,ee)=>Q===ee){let Q=0;for(let ee=0,he=Math.min(q.length,V.length);ee<he&&U(q[ee],V[ee]);ee++)Q++;return Q}function j(q,V){let U=typeof V=="number"?q:0;typeof V=="number"?U=q:(U=0,V=q);const Q=[];if(U<=V)for(let ee=U;ee<V;ee++)Q.push(ee);else for(let ee=U;ee>V;ee--)Q.push(ee);return Q}function S(q,V,U){return q.reduce((Q,ee)=>(Q[V(ee)]=U?U(ee):ee,Q),Object.create(null))}function I(q,V){return q.push(V),()=>W(q,V)}function W(q,V){const U=q.indexOf(V);if(U>-1)return q.splice(U,1),V}function P(q,V,U){const Q=q.slice(0,V),ee=q.slice(V);return Q.concat(U,ee)}function H(q,V){let U;if(typeof V=="number"){let Q=V;U=()=>{const ee=Math.sin(Q++)*179426549;return ee-Math.floor(ee)}}else U=Math.random;for(let Q=q.length-1;Q>0;Q-=1){const ee=Math.floor(U()*(Q+1)),he=q[Q];q[Q]=q[ee],q[ee]=he}}function B(q,V){const U=q.indexOf(V);U>-1&&(q.splice(U,1),q.unshift(V))}function y(q,V){const U=q.indexOf(V);U>-1&&(q.splice(U,1),q.push(V))}function Y(q,V){for(const U of V)q.push(U)}function J(q,V){return Array.isArray(q)?q.map(V):V(q)}function G(q){return Array.isArray(q)?q:[q]}function Z(q){return q[Math.floor(Math.random()*q.length)]}function C(q,V,U){const Q=X(q,V),ee=q.length,he=U.length;q.length=ee+he;for(let de=ee-1;de>=Q;de--)q[de+he]=q[de];for(let de=0;de<he;de++)q[de+Q]=U[de]}function F(q,V,U,Q){const ee=X(q,V);let he=q.splice(ee,U);return he===void 0&&(he=[]),C(q,ee,Q),he}function X(q,V){return V<0?Math.max(V+q.length,0):Math.min(V,q.length)}var fe;(function(q){function V(he){return he<0}q.isLessThan=V;function U(he){return he<=0}q.isLessThanOrEqual=U;function Q(he){return he>0}q.isGreaterThan=Q;function ee(he){return he===0}q.isNeitherLessOrGreaterThan=ee,q.greaterThan=1,q.lessThan=-1,q.neitherLessOrGreaterThan=0})(fe||(i.CompareResult=fe={}));function oe(q,V){return(U,Q)=>V(q(U),q(Q))}function we(...q){return(V,U)=>{for(const Q of q){const ee=Q(V,U);if(!fe.isNeitherLessOrGreaterThan(ee))return ee}return fe.neitherLessOrGreaterThan}}const s=(q,V)=>q-V;i.$7b=s;const Te=(q,V)=>(0,i.$7b)(q?1:0,V?1:0);i.$8b=Te;function ke(q){return(V,U)=>-q(V,U)}class Ve{constructor(V){this.g=V,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(V){let U=this.c;for(;U<this.g.length&&V(this.g[U]);)U++;const Q=U===this.c?null:this.g.slice(this.c,U);return this.c=U,Q}takeFromEndWhile(V){let U=this.d;for(;U>=0&&V(this.g[U]);)U--;const Q=U===this.d?null:this.g.slice(U+1,this.d+1);return this.d=U,Q}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const V=this.g[this.c];return this.c++,V}removeLast(){const V=this.g[this.d];return this.d--,V}takeCount(V){const U=this.g.slice(this.c,this.c+V);return this.c+=V,U}}i.$0b=Ve;class De{static{this.empty=new De(V=>{})}constructor(V){this.iterate=V}forEach(V){this.iterate(U=>(V(U),!0))}toArray(){const V=[];return this.iterate(U=>(V.push(U),!0)),V}filter(V){return new De(U=>this.iterate(Q=>V(Q)?U(Q):!0))}map(V){return new De(U=>this.iterate(Q=>U(V(Q))))}some(V){let U=!1;return this.iterate(Q=>(U=V(Q),!U)),U}findFirst(V){let U;return this.iterate(Q=>V(Q)?(U=Q,!1):!0),U}findLast(V){let U;return this.iterate(Q=>(V(Q)&&(U=Q),!0)),U}findLastMaxBy(V){let U,Q=!0;return this.iterate(ee=>((Q||fe.isGreaterThan(V(ee,U)))&&(Q=!1,U=ee),!0)),U}}i.$$b=De;class ye{constructor(V){this.c=V}static createSortPermutation(V,U){const Q=Array.from(V.keys()).sort((ee,he)=>U(V[ee],V[he]));return new ye(Q)}apply(V){return V.map((U,Q)=>V[this.c[Q]])}inverse(){const V=this.c.slice();for(let U=0;U<this.c.length;U++)V[this.c[U]]=U;return new ye(V)}}i.$_b=ye}),ne(ie[11],re([0,1,4]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ok=n,i.$dd=T,i.$ed=g,i.$fd=L,i.$gd=d,i.$hd=a;function n(u,c){if(!u)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}function T(u,c="Unreachable"){throw new Error(c)}function g(u,c="unexpected state"){if(!u)throw new t.$bb(`Assertion Failed: ${c}`)}function L(u){u||(0,t.$Y)(new t.$bb("Soft Assertion Failed"))}function d(u){if(!u()){debugger;u(),(0,t.$Y)(new t.$bb("Assertion Failed"))}}function a(u,c){let $=0;for(;$<u.length-1;){const m=u[$],w=u[$+1];if(!c(m,w))return!1;$++}return!0}}),ne(ie[22],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$cb=t;function t(n,T){const g=this;let L=!1,d;return function(){if(L)return d;if(L=!0,T)try{d=n.apply(g,arguments)}finally{T()}else d=n.apply(g,arguments);return d}}}),ne(ie[23],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Iterable=void 0;var t;(function(n){function T(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}n.is=T;const g=Object.freeze([]);function L(){return g}n.empty=L;function*d(r){yield r}n.single=d;function a(r){return T(r)?r:d(r)}n.wrap=a;function u(r){return r||g}n.from=u;function*c(r){for(let l=r.length-1;l>=0;l--)yield r[l]}n.reverse=c;function $(r){return!r||r[Symbol.iterator]().next().done===!0}n.isEmpty=$;function m(r){return r[Symbol.iterator]().next().value}n.first=m;function w(r,l){let f=0;for(const D of r)if(l(D,f++))return!0;return!1}n.some=w;function e(r,l){for(const f of r)if(l(f))return f}n.find=e;function*b(r,l){for(const f of r)l(f)&&(yield f)}n.filter=b;function*N(r,l){let f=0;for(const D of r)yield l(D,f++)}n.map=N;function*_(r,l){let f=0;for(const D of r)yield*l(D,f++)}n.flatMap=_;function*A(...r){for(const l of r)yield*l}n.concat=A;function E(r,l,f){let D=f;for(const R of r)D=l(D,R);return D}n.reduce=E;function*v(r,l,f=r.length){for(l<0&&(l+=r.length),f<0?f+=r.length:f>r.length&&(f=r.length);l<f;l++)yield r[l]}n.slice=v;function h(r,l=Number.POSITIVE_INFINITY){const f=[];if(l===0)return[f,r];const D=r[Symbol.iterator]();for(let R=0;R<l;R++){const p=D.next();if(p.done)return[f,n.empty()];f.push(p.value)}return[f,{[Symbol.iterator](){return D}}]}n.consume=h;async function o(r){const l=[];for await(const f of r)l.push(f);return Promise.resolve(l)}n.asyncToArray=o})(t||(i.Iterable=t={}))}),ne(ie[40],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.KeyMod=i.KeyCodeUtils=i.$Tr=i.$Sr=i.$Rr=i.$Qr=i.$Pr=i.ScanCode=i.KeyCode=void 0,i.$Ur=w;var t;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(t||(i.KeyCode=t={}));var n;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(n||(i.ScanCode=n={}));class T{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(b,N){this._keyCodeToStr[b]=N,this._strToKeyCode[N.toLowerCase()]=b}keyCodeToStr(b){return this._keyCodeToStr[b]}strToKeyCode(b){return this._strToKeyCode[b.toLowerCase()]||t.Unknown}}const g=new T,L=new T,d=new T;i.$Pr=new Array(230),i.$Qr={};const a=[],u=Object.create(null),c=Object.create(null);i.$Rr={lowerCaseToEnum:e=>c[e]||n.None,toEnum:e=>u[e]||n.None,toString:e=>a[e]||"None"},i.$Sr=[],i.$Tr=[];for(let e=0;e<=n.MAX_VALUE;e++)i.$Sr[e]=t.DependsOnKbLayout;for(let e=0;e<=t.MAX_VALUE;e++)i.$Tr[e]=n.DependsOnKbLayout;(function(){const e="",b=[[1,n.None,"None",t.Unknown,"unknown",0,"VK_UNKNOWN",e,e],[1,n.Hyper,"Hyper",t.Unknown,e,0,e,e,e],[1,n.Super,"Super",t.Unknown,e,0,e,e,e],[1,n.Fn,"Fn",t.Unknown,e,0,e,e,e],[1,n.FnLock,"FnLock",t.Unknown,e,0,e,e,e],[1,n.Suspend,"Suspend",t.Unknown,e,0,e,e,e],[1,n.Resume,"Resume",t.Unknown,e,0,e,e,e],[1,n.Turbo,"Turbo",t.Unknown,e,0,e,e,e],[1,n.Sleep,"Sleep",t.Unknown,e,0,"VK_SLEEP",e,e],[1,n.WakeUp,"WakeUp",t.Unknown,e,0,e,e,e],[0,n.KeyA,"KeyA",t.KeyA,"A",65,"VK_A",e,e],[0,n.KeyB,"KeyB",t.KeyB,"B",66,"VK_B",e,e],[0,n.KeyC,"KeyC",t.KeyC,"C",67,"VK_C",e,e],[0,n.KeyD,"KeyD",t.KeyD,"D",68,"VK_D",e,e],[0,n.KeyE,"KeyE",t.KeyE,"E",69,"VK_E",e,e],[0,n.KeyF,"KeyF",t.KeyF,"F",70,"VK_F",e,e],[0,n.KeyG,"KeyG",t.KeyG,"G",71,"VK_G",e,e],[0,n.KeyH,"KeyH",t.KeyH,"H",72,"VK_H",e,e],[0,n.KeyI,"KeyI",t.KeyI,"I",73,"VK_I",e,e],[0,n.KeyJ,"KeyJ",t.KeyJ,"J",74,"VK_J",e,e],[0,n.KeyK,"KeyK",t.KeyK,"K",75,"VK_K",e,e],[0,n.KeyL,"KeyL",t.KeyL,"L",76,"VK_L",e,e],[0,n.KeyM,"KeyM",t.KeyM,"M",77,"VK_M",e,e],[0,n.KeyN,"KeyN",t.KeyN,"N",78,"VK_N",e,e],[0,n.KeyO,"KeyO",t.KeyO,"O",79,"VK_O",e,e],[0,n.KeyP,"KeyP",t.KeyP,"P",80,"VK_P",e,e],[0,n.KeyQ,"KeyQ",t.KeyQ,"Q",81,"VK_Q",e,e],[0,n.KeyR,"KeyR",t.KeyR,"R",82,"VK_R",e,e],[0,n.KeyS,"KeyS",t.KeyS,"S",83,"VK_S",e,e],[0,n.KeyT,"KeyT",t.KeyT,"T",84,"VK_T",e,e],[0,n.KeyU,"KeyU",t.KeyU,"U",85,"VK_U",e,e],[0,n.KeyV,"KeyV",t.KeyV,"V",86,"VK_V",e,e],[0,n.KeyW,"KeyW",t.KeyW,"W",87,"VK_W",e,e],[0,n.KeyX,"KeyX",t.KeyX,"X",88,"VK_X",e,e],[0,n.KeyY,"KeyY",t.KeyY,"Y",89,"VK_Y",e,e],[0,n.KeyZ,"KeyZ",t.KeyZ,"Z",90,"VK_Z",e,e],[0,n.Digit1,"Digit1",t.Digit1,"1",49,"VK_1",e,e],[0,n.Digit2,"Digit2",t.Digit2,"2",50,"VK_2",e,e],[0,n.Digit3,"Digit3",t.Digit3,"3",51,"VK_3",e,e],[0,n.Digit4,"Digit4",t.Digit4,"4",52,"VK_4",e,e],[0,n.Digit5,"Digit5",t.Digit5,"5",53,"VK_5",e,e],[0,n.Digit6,"Digit6",t.Digit6,"6",54,"VK_6",e,e],[0,n.Digit7,"Digit7",t.Digit7,"7",55,"VK_7",e,e],[0,n.Digit8,"Digit8",t.Digit8,"8",56,"VK_8",e,e],[0,n.Digit9,"Digit9",t.Digit9,"9",57,"VK_9",e,e],[0,n.Digit0,"Digit0",t.Digit0,"0",48,"VK_0",e,e],[1,n.Enter,"Enter",t.Enter,"Enter",13,"VK_RETURN",e,e],[1,n.Escape,"Escape",t.Escape,"Escape",27,"VK_ESCAPE",e,e],[1,n.Backspace,"Backspace",t.Backspace,"Backspace",8,"VK_BACK",e,e],[1,n.Tab,"Tab",t.Tab,"Tab",9,"VK_TAB",e,e],[1,n.Space,"Space",t.Space,"Space",32,"VK_SPACE",e,e],[0,n.Minus,"Minus",t.Minus,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,n.Equal,"Equal",t.Equal,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,n.BracketLeft,"BracketLeft",t.BracketLeft,"[",219,"VK_OEM_4","[","OEM_4"],[0,n.BracketRight,"BracketRight",t.BracketRight,"]",221,"VK_OEM_6","]","OEM_6"],[0,n.Backslash,"Backslash",t.Backslash,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,n.IntlHash,"IntlHash",t.Unknown,e,0,e,e,e],[0,n.Semicolon,"Semicolon",t.Semicolon,";",186,"VK_OEM_1",";","OEM_1"],[0,n.Quote,"Quote",t.Quote,"'",222,"VK_OEM_7","'","OEM_7"],[0,n.Backquote,"Backquote",t.Backquote,"`",192,"VK_OEM_3","`","OEM_3"],[0,n.Comma,"Comma",t.Comma,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,n.Period,"Period",t.Period,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,n.Slash,"Slash",t.Slash,"/",191,"VK_OEM_2","/","OEM_2"],[1,n.CapsLock,"CapsLock",t.CapsLock,"CapsLock",20,"VK_CAPITAL",e,e],[1,n.F1,"F1",t.F1,"F1",112,"VK_F1",e,e],[1,n.F2,"F2",t.F2,"F2",113,"VK_F2",e,e],[1,n.F3,"F3",t.F3,"F3",114,"VK_F3",e,e],[1,n.F4,"F4",t.F4,"F4",115,"VK_F4",e,e],[1,n.F5,"F5",t.F5,"F5",116,"VK_F5",e,e],[1,n.F6,"F6",t.F6,"F6",117,"VK_F6",e,e],[1,n.F7,"F7",t.F7,"F7",118,"VK_F7",e,e],[1,n.F8,"F8",t.F8,"F8",119,"VK_F8",e,e],[1,n.F9,"F9",t.F9,"F9",120,"VK_F9",e,e],[1,n.F10,"F10",t.F10,"F10",121,"VK_F10",e,e],[1,n.F11,"F11",t.F11,"F11",122,"VK_F11",e,e],[1,n.F12,"F12",t.F12,"F12",123,"VK_F12",e,e],[1,n.PrintScreen,"PrintScreen",t.Unknown,e,0,e,e,e],[1,n.ScrollLock,"ScrollLock",t.ScrollLock,"ScrollLock",145,"VK_SCROLL",e,e],[1,n.Pause,"Pause",t.PauseBreak,"PauseBreak",19,"VK_PAUSE",e,e],[1,n.Insert,"Insert",t.Insert,"Insert",45,"VK_INSERT",e,e],[1,n.Home,"Home",t.Home,"Home",36,"VK_HOME",e,e],[1,n.PageUp,"PageUp",t.PageUp,"PageUp",33,"VK_PRIOR",e,e],[1,n.Delete,"Delete",t.Delete,"Delete",46,"VK_DELETE",e,e],[1,n.End,"End",t.End,"End",35,"VK_END",e,e],[1,n.PageDown,"PageDown",t.PageDown,"PageDown",34,"VK_NEXT",e,e],[1,n.ArrowRight,"ArrowRight",t.RightArrow,"RightArrow",39,"VK_RIGHT","Right",e],[1,n.ArrowLeft,"ArrowLeft",t.LeftArrow,"LeftArrow",37,"VK_LEFT","Left",e],[1,n.ArrowDown,"ArrowDown",t.DownArrow,"DownArrow",40,"VK_DOWN","Down",e],[1,n.ArrowUp,"ArrowUp",t.UpArrow,"UpArrow",38,"VK_UP","Up",e],[1,n.NumLock,"NumLock",t.NumLock,"NumLock",144,"VK_NUMLOCK",e,e],[1,n.NumpadDivide,"NumpadDivide",t.NumpadDivide,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,n.NumpadMultiply,"NumpadMultiply",t.NumpadMultiply,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,n.NumpadSubtract,"NumpadSubtract",t.NumpadSubtract,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,n.NumpadAdd,"NumpadAdd",t.NumpadAdd,"NumPad_Add",107,"VK_ADD",e,e],[1,n.NumpadEnter,"NumpadEnter",t.Enter,e,0,e,e,e],[1,n.Numpad1,"Numpad1",t.Numpad1,"NumPad1",97,"VK_NUMPAD1",e,e],[1,n.Numpad2,"Numpad2",t.Numpad2,"NumPad2",98,"VK_NUMPAD2",e,e],[1,n.Numpad3,"Numpad3",t.Numpad3,"NumPad3",99,"VK_NUMPAD3",e,e],[1,n.Numpad4,"Numpad4",t.Numpad4,"NumPad4",100,"VK_NUMPAD4",e,e],[1,n.Numpad5,"Numpad5",t.Numpad5,"NumPad5",101,"VK_NUMPAD5",e,e],[1,n.Numpad6,"Numpad6",t.Numpad6,"NumPad6",102,"VK_NUMPAD6",e,e],[1,n.Numpad7,"Numpad7",t.Numpad7,"NumPad7",103,"VK_NUMPAD7",e,e],[1,n.Numpad8,"Numpad8",t.Numpad8,"NumPad8",104,"VK_NUMPAD8",e,e],[1,n.Numpad9,"Numpad9",t.Numpad9,"NumPad9",105,"VK_NUMPAD9",e,e],[1,n.Numpad0,"Numpad0",t.Numpad0,"NumPad0",96,"VK_NUMPAD0",e,e],[1,n.NumpadDecimal,"NumpadDecimal",t.NumpadDecimal,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,n.IntlBackslash,"IntlBackslash",t.IntlBackslash,"OEM_102",226,"VK_OEM_102",e,e],[1,n.ContextMenu,"ContextMenu",t.ContextMenu,"ContextMenu",93,e,e,e],[1,n.Power,"Power",t.Unknown,e,0,e,e,e],[1,n.NumpadEqual,"NumpadEqual",t.Unknown,e,0,e,e,e],[1,n.F13,"F13",t.F13,"F13",124,"VK_F13",e,e],[1,n.F14,"F14",t.F14,"F14",125,"VK_F14",e,e],[1,n.F15,"F15",t.F15,"F15",126,"VK_F15",e,e],[1,n.F16,"F16",t.F16,"F16",127,"VK_F16",e,e],[1,n.F17,"F17",t.F17,"F17",128,"VK_F17",e,e],[1,n.F18,"F18",t.F18,"F18",129,"VK_F18",e,e],[1,n.F19,"F19",t.F19,"F19",130,"VK_F19",e,e],[1,n.F20,"F20",t.F20,"F20",131,"VK_F20",e,e],[1,n.F21,"F21",t.F21,"F21",132,"VK_F21",e,e],[1,n.F22,"F22",t.F22,"F22",133,"VK_F22",e,e],[1,n.F23,"F23",t.F23,"F23",134,"VK_F23",e,e],[1,n.F24,"F24",t.F24,"F24",135,"VK_F24",e,e],[1,n.Open,"Open",t.Unknown,e,0,e,e,e],[1,n.Help,"Help",t.Unknown,e,0,e,e,e],[1,n.Select,"Select",t.Unknown,e,0,e,e,e],[1,n.Again,"Again",t.Unknown,e,0,e,e,e],[1,n.Undo,"Undo",t.Unknown,e,0,e,e,e],[1,n.Cut,"Cut",t.Unknown,e,0,e,e,e],[1,n.Copy,"Copy",t.Unknown,e,0,e,e,e],[1,n.Paste,"Paste",t.Unknown,e,0,e,e,e],[1,n.Find,"Find",t.Unknown,e,0,e,e,e],[1,n.AudioVolumeMute,"AudioVolumeMute",t.AudioVolumeMute,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,n.AudioVolumeUp,"AudioVolumeUp",t.AudioVolumeUp,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,n.AudioVolumeDown,"AudioVolumeDown",t.AudioVolumeDown,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,n.NumpadComma,"NumpadComma",t.NUMPAD_SEPARATOR,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,n.IntlRo,"IntlRo",t.ABNT_C1,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,n.KanaMode,"KanaMode",t.Unknown,e,0,e,e,e],[0,n.IntlYen,"IntlYen",t.Unknown,e,0,e,e,e],[1,n.Convert,"Convert",t.Unknown,e,0,e,e,e],[1,n.NonConvert,"NonConvert",t.Unknown,e,0,e,e,e],[1,n.Lang1,"Lang1",t.Unknown,e,0,e,e,e],[1,n.Lang2,"Lang2",t.Unknown,e,0,e,e,e],[1,n.Lang3,"Lang3",t.Unknown,e,0,e,e,e],[1,n.Lang4,"Lang4",t.Unknown,e,0,e,e,e],[1,n.Lang5,"Lang5",t.Unknown,e,0,e,e,e],[1,n.Abort,"Abort",t.Unknown,e,0,e,e,e],[1,n.Props,"Props",t.Unknown,e,0,e,e,e],[1,n.NumpadParenLeft,"NumpadParenLeft",t.Unknown,e,0,e,e,e],[1,n.NumpadParenRight,"NumpadParenRight",t.Unknown,e,0,e,e,e],[1,n.NumpadBackspace,"NumpadBackspace",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryStore,"NumpadMemoryStore",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryRecall,"NumpadMemoryRecall",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryClear,"NumpadMemoryClear",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryAdd,"NumpadMemoryAdd",t.Unknown,e,0,e,e,e],[1,n.NumpadMemorySubtract,"NumpadMemorySubtract",t.Unknown,e,0,e,e,e],[1,n.NumpadClear,"NumpadClear",t.Clear,"Clear",12,"VK_CLEAR",e,e],[1,n.NumpadClearEntry,"NumpadClearEntry",t.Unknown,e,0,e,e,e],[1,n.None,e,t.Ctrl,"Ctrl",17,"VK_CONTROL",e,e],[1,n.None,e,t.Shift,"Shift",16,"VK_SHIFT",e,e],[1,n.None,e,t.Alt,"Alt",18,"VK_MENU",e,e],[1,n.None,e,t.Meta,"Meta",91,"VK_COMMAND",e,e],[1,n.ControlLeft,"ControlLeft",t.Ctrl,e,0,"VK_LCONTROL",e,e],[1,n.ShiftLeft,"ShiftLeft",t.Shift,e,0,"VK_LSHIFT",e,e],[1,n.AltLeft,"AltLeft",t.Alt,e,0,"VK_LMENU",e,e],[1,n.MetaLeft,"MetaLeft",t.Meta,e,0,"VK_LWIN",e,e],[1,n.ControlRight,"ControlRight",t.Ctrl,e,0,"VK_RCONTROL",e,e],[1,n.ShiftRight,"ShiftRight",t.Shift,e,0,"VK_RSHIFT",e,e],[1,n.AltRight,"AltRight",t.Alt,e,0,"VK_RMENU",e,e],[1,n.MetaRight,"MetaRight",t.Meta,e,0,"VK_RWIN",e,e],[1,n.BrightnessUp,"BrightnessUp",t.Unknown,e,0,e,e,e],[1,n.BrightnessDown,"BrightnessDown",t.Unknown,e,0,e,e,e],[1,n.MediaPlay,"MediaPlay",t.Unknown,e,0,e,e,e],[1,n.MediaRecord,"MediaRecord",t.Unknown,e,0,e,e,e],[1,n.MediaFastForward,"MediaFastForward",t.Unknown,e,0,e,e,e],[1,n.MediaRewind,"MediaRewind",t.Unknown,e,0,e,e,e],[1,n.MediaTrackNext,"MediaTrackNext",t.MediaTrackNext,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,n.MediaTrackPrevious,"MediaTrackPrevious",t.MediaTrackPrevious,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,n.MediaStop,"MediaStop",t.MediaStop,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,n.Eject,"Eject",t.Unknown,e,0,e,e,e],[1,n.MediaPlayPause,"MediaPlayPause",t.MediaPlayPause,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,n.MediaSelect,"MediaSelect",t.LaunchMediaPlayer,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,n.LaunchMail,"LaunchMail",t.LaunchMail,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,n.LaunchApp2,"LaunchApp2",t.LaunchApp2,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,n.LaunchApp1,"LaunchApp1",t.Unknown,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,n.SelectTask,"SelectTask",t.Unknown,e,0,e,e,e],[1,n.LaunchScreenSaver,"LaunchScreenSaver",t.Unknown,e,0,e,e,e],[1,n.BrowserSearch,"BrowserSearch",t.BrowserSearch,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,n.BrowserHome,"BrowserHome",t.BrowserHome,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,n.BrowserBack,"BrowserBack",t.BrowserBack,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,n.BrowserForward,"BrowserForward",t.BrowserForward,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,n.BrowserStop,"BrowserStop",t.Unknown,e,0,"VK_BROWSER_STOP",e,e],[1,n.BrowserRefresh,"BrowserRefresh",t.Unknown,e,0,"VK_BROWSER_REFRESH",e,e],[1,n.BrowserFavorites,"BrowserFavorites",t.Unknown,e,0,"VK_BROWSER_FAVORITES",e,e],[1,n.ZoomToggle,"ZoomToggle",t.Unknown,e,0,e,e,e],[1,n.MailReply,"MailReply",t.Unknown,e,0,e,e,e],[1,n.MailForward,"MailForward",t.Unknown,e,0,e,e,e],[1,n.MailSend,"MailSend",t.Unknown,e,0,e,e,e],[1,n.None,e,t.KEY_IN_COMPOSITION,"KeyInComposition",229,e,e,e],[1,n.None,e,t.ABNT_C2,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,n.None,e,t.OEM_8,"OEM_8",223,"VK_OEM_8",e,e],[1,n.None,e,t.Unknown,e,0,"VK_KANA",e,e],[1,n.None,e,t.Unknown,e,0,"VK_HANGUL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_JUNJA",e,e],[1,n.None,e,t.Unknown,e,0,"VK_FINAL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_HANJA",e,e],[1,n.None,e,t.Unknown,e,0,"VK_KANJI",e,e],[1,n.None,e,t.Unknown,e,0,"VK_CONVERT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_NONCONVERT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_ACCEPT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_MODECHANGE",e,e],[1,n.None,e,t.Unknown,e,0,"VK_SELECT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PRINT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_EXECUTE",e,e],[1,n.None,e,t.Unknown,e,0,"VK_SNAPSHOT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_HELP",e,e],[1,n.None,e,t.Unknown,e,0,"VK_APPS",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PROCESSKEY",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PACKET",e,e],[1,n.None,e,t.Unknown,e,0,"VK_DBE_SBCSCHAR",e,e],[1,n.None,e,t.Unknown,e,0,"VK_DBE_DBCSCHAR",e,e],[1,n.None,e,t.Unknown,e,0,"VK_ATTN",e,e],[1,n.None,e,t.Unknown,e,0,"VK_CRSEL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_EXSEL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_EREOF",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PLAY",e,e],[1,n.None,e,t.Unknown,e,0,"VK_ZOOM",e,e],[1,n.None,e,t.Unknown,e,0,"VK_NONAME",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PA1",e,e],[1,n.None,e,t.Unknown,e,0,"VK_OEM_CLEAR",e,e]],N=[],_=[];for(const A of b){const[E,v,h,o,r,l,f,D,R]=A;if(_[v]||(_[v]=!0,a[v]=h,u[h]=v,c[h.toLowerCase()]=v,E&&(i.$Sr[v]=o,o!==t.Unknown&&o!==t.Enter&&o!==t.Ctrl&&o!==t.Shift&&o!==t.Alt&&o!==t.Meta&&(i.$Tr[o]=v))),!N[o]){if(N[o]=!0,!r)throw new Error(`String representation missing for key code ${o} around scan code ${h}`);g.define(o,r),L.define(o,D||r),d.define(o,R||D||r)}l&&(i.$Pr[l]=o),f&&(i.$Qr[f]=o)}i.$Tr[t.Enter]=n.Enter})();var $;(function(e){function b(h){return g.keyCodeToStr(h)}e.toString=b;function N(h){return g.strToKeyCode(h)}e.fromString=N;function _(h){return L.keyCodeToStr(h)}e.toUserSettingsUS=_;function A(h){return d.keyCodeToStr(h)}e.toUserSettingsGeneral=A;function E(h){return L.strToKeyCode(h)||d.strToKeyCode(h)}e.fromUserSettings=E;function v(h){if(h>=t.Numpad0&&h<=t.NumpadDivide)return null;switch(h){case t.UpArrow:return"Up";case t.DownArrow:return"Down";case t.LeftArrow:return"Left";case t.RightArrow:return"Right"}return g.keyCodeToStr(h)}e.toElectronAccelerator=v})($||(i.KeyCodeUtils=$={}));var m;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(m||(i.KeyMod=m={}));function w(e,b){const N=(b&65535)<<16>>>0;return(e|N)>>>0}}),ne(ie[41],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$T=void 0;class t{constructor(T){this.d=T,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(T){this.c=T}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}i.$T=t}),ne(ie[24],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$4c=void 0;class t{static{this.Undefined=new t(void 0)}constructor(g){this.element=g,this.next=t.Undefined,this.prev=t.Undefined}}class n{constructor(){this.a=t.Undefined,this.b=t.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===t.Undefined}clear(){let g=this.a;for(;g!==t.Undefined;){const L=g.next;g.prev=t.Undefined,g.next=t.Undefined,g=L}this.a=t.Undefined,this.b=t.Undefined,this.c=0}unshift(g){return this.d(g,!1)}push(g){return this.d(g,!0)}d(g,L){const d=new t(g);if(this.a===t.Undefined)this.a=d,this.b=d;else if(L){const u=this.b;this.b=d,d.prev=u,u.next=d}else{const u=this.a;this.a=d,d.next=u,u.prev=d}this.c+=1;let a=!1;return()=>{a||(a=!0,this.e(d))}}shift(){if(this.a!==t.Undefined){const g=this.a.element;return this.e(this.a),g}}pop(){if(this.b!==t.Undefined){const g=this.b.element;return this.e(this.b),g}}e(g){if(g.prev!==t.Undefined&&g.next!==t.Undefined){const L=g.prev;L.next=g.next,g.next.prev=L}else g.prev===t.Undefined&&g.next===t.Undefined?(this.a=t.Undefined,this.b=t.Undefined):g.next===t.Undefined?(this.b=this.b.prev,this.b.next=t.Undefined):g.prev===t.Undefined&&(this.a=this.a.next,this.a.prev=t.Undefined);this.c-=1}*[Symbol.iterator](){let g=this.a;for(;g!==t.Undefined;)yield g.element,g=g.next}}i.$4c=n}),ne(ie[16],re([0,1]),function(x,i){"use strict";var t,n,T;Object.defineProperty(i,"__esModule",{value:!0}),i.$Gc=i.$Fc=i.$Ec=i.$Dc=i.$Cc=i.$Bc=i.Touch=i.$Ac=i.$zc=void 0,i.$wc=g,i.$xc=L,i.$yc=d,i.$Hc=v;function g(h,o,r){let l=h.get(o);return l===void 0&&(l=r,h.set(o,l)),l}function L(h){const o=[];return h.forEach((r,l)=>{o.push(`${l} => ${r}`)}),`Map(${h.size}) {${o.join(", ")}}`}function d(h){const o=[];return h.forEach(r=>{o.push(r)}),`Set(${h.size}) {${o.join(", ")}}`}class a{constructor(o,r){this.uri=o,this.value=r}}function u(h){return Array.isArray(h)}class c{static{this.c=o=>o.toString()}constructor(o,r){if(this[t]="ResourceMap",o instanceof c)this.d=new Map(o.d),this.e=r??c.c;else if(u(o)){this.d=new Map,this.e=r??c.c;for(const[l,f]of o)this.set(l,f)}else this.d=new Map,this.e=o??c.c}set(o,r){return this.d.set(this.e(o),new a(o,r)),this}get(o){return this.d.get(this.e(o))?.value}has(o){return this.d.has(this.e(o))}get size(){return this.d.size}clear(){this.d.clear()}delete(o){return this.d.delete(this.e(o))}forEach(o,r){typeof r<"u"&&(o=o.bind(r));for(const[l,f]of this.d)o(f.value,f.uri,this)}*values(){for(const o of this.d.values())yield o.value}*keys(){for(const o of this.d.values())yield o.uri}*entries(){for(const o of this.d.values())yield[o.uri,o.value]}*[(t=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.d)yield[o.uri,o.value]}}i.$zc=c;class ${constructor(o,r){this[n]="ResourceSet",!o||typeof o=="function"?this.c=new c(o):(this.c=new c(r),o.forEach(this.add,this))}get size(){return this.c.size}add(o){return this.c.set(o,o),this}clear(){this.c.clear()}delete(o){return this.c.delete(o)}forEach(o,r){this.c.forEach((l,f)=>o.call(r,f,f,this))}has(o){return this.c.has(o)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}i.$Ac=$;var m;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(m||(i.Touch=m={}));class w{constructor(){this[T]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(o){return this.c.has(o)}get(o,r=m.None){const l=this.c.get(o);if(l)return r!==m.None&&this.m(l,r),l.value}set(o,r,l=m.None){let f=this.c.get(o);if(f)f.value=r,l!==m.None&&this.m(f,l);else{switch(f={key:o,value:r,next:void 0,previous:void 0},l){case m.None:this.k(f);break;case m.AsOld:this.j(f);break;case m.AsNew:this.k(f);break;default:this.k(f);break}this.c.set(o,f),this.f++}return this}delete(o){return!!this.remove(o)}remove(o){const r=this.c.get(o);if(r)return this.c.delete(o),this.l(r),this.f--,r.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const o=this.d;return this.c.delete(o.key),this.l(o),this.f--,o.value}forEach(o,r){const l=this.g;let f=this.d;for(;f;){if(r?o.bind(r)(f.value,f.key,this):o(f.value,f.key,this),this.g!==l)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const o=this,r=this.g;let l=this.d;const f={[Symbol.iterator](){return f},next(){if(o.g!==r)throw new Error("LinkedMap got modified during iteration.");if(l){const D={value:l.key,done:!1};return l=l.next,D}else return{value:void 0,done:!0}}};return f}values(){const o=this,r=this.g;let l=this.d;const f={[Symbol.iterator](){return f},next(){if(o.g!==r)throw new Error("LinkedMap got modified during iteration.");if(l){const D={value:l.value,done:!1};return l=l.next,D}else return{value:void 0,done:!0}}};return f}entries(){const o=this,r=this.g;let l=this.d;const f={[Symbol.iterator](){return f},next(){if(o.g!==r)throw new Error("LinkedMap got modified during iteration.");if(l){const D={value:[l.key,l.value],done:!1};return l=l.next,D}else return{value:void 0,done:!0}}};return f}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(o){if(o>=this.size)return;if(o===0){this.clear();return}let r=this.d,l=this.size;for(;r&&l>o;)this.c.delete(r.key),r=r.next,l--;this.d=r,this.f=l,r&&(r.previous=void 0),this.g++}i(o){if(o>=this.size)return;if(o===0){this.clear();return}let r=this.e,l=this.size;for(;r&&l>o;)this.c.delete(r.key),r=r.previous,l--;this.e=r,this.f=l,r&&(r.next=void 0),this.g++}j(o){if(!this.d&&!this.e)this.e=o;else if(this.d)o.next=this.d,this.d.previous=o;else throw new Error("Invalid list");this.d=o,this.g++}k(o){if(!this.d&&!this.e)this.d=o;else if(this.e)o.previous=this.e,this.e.next=o;else throw new Error("Invalid list");this.e=o,this.g++}l(o){if(o===this.d&&o===this.e)this.d=void 0,this.e=void 0;else if(o===this.d){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.d=o.next}else if(o===this.e){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.e=o.previous}else{const r=o.next,l=o.previous;if(!r||!l)throw new Error("Invalid list");r.previous=l,l.next=r}o.next=void 0,o.previous=void 0,this.g++}m(o,r){if(!this.d||!this.e)throw new Error("Invalid list");if(!(r!==m.AsOld&&r!==m.AsNew)){if(r===m.AsOld){if(o===this.d)return;const l=o.next,f=o.previous;o===this.e?(f.next=void 0,this.e=f):(l.previous=f,f.next=l),o.previous=void 0,o.next=this.d,this.d.previous=o,this.d=o,this.g++}else if(r===m.AsNew){if(o===this.e)return;const l=o.next,f=o.previous;o===this.d?(l.previous=void 0,this.d=l):(l.previous=f,f.next=l),o.next=void 0,o.previous=this.e,this.e.next=o,this.e=o,this.g++}}}toJSON(){const o=[];return this.forEach((r,l)=>{o.push([l,r])}),o}fromJSON(o){this.clear();for(const[r,l]of o)this.set(r,l)}}i.$Bc=w;class e extends w{constructor(o,r=1){super(),this.n=o,this.o=Math.min(Math.max(0,r),1)}get limit(){return this.n}set limit(o){this.n=o,this.p()}get ratio(){return this.o}set ratio(o){this.o=Math.min(Math.max(0,o),1),this.p()}get(o,r=m.AsNew){return super.get(o,r)}peek(o){return super.get(o,m.None)}set(o,r){return super.set(o,r,m.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class b extends e{constructor(o,r=1){super(o,r)}q(o){this.h(o)}set(o,r){return super.set(o,r),this.p(),this}}i.$Cc=b;class N extends e{constructor(o,r=1){super(o,r)}q(o){this.i(o)}set(o,r){return this.n<=this.size&&!this.has(o)&&this.q(Math.round(this.n*this.o)-1),super.set(o,r),this}}i.$Dc=N;class _{constructor(){this.c=new Map}add(o){return this.c.set(o,(this.c.get(o)||0)+1),this}delete(o){let r=this.c.get(o)||0;return r===0?!1:(r--,r===0?this.c.delete(o):this.c.set(o,r),!0)}has(o){return this.c.has(o)}}i.$Ec=_;class A{constructor(o){if(this.c=new Map,this.d=new Map,o)for(const[r,l]of o)this.set(r,l)}clear(){this.c.clear(),this.d.clear()}set(o,r){this.c.set(o,r),this.d.set(r,o)}get(o){return this.c.get(o)}getKey(o){return this.d.get(o)}delete(o){const r=this.c.get(o);return r===void 0?!1:(this.c.delete(o),this.d.delete(r),!0)}forEach(o,r){this.c.forEach((l,f)=>{o.call(r,l,f,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}i.$Fc=A;class E{constructor(){this.c=new Map}add(o,r){let l=this.c.get(o);l||(l=new Set,this.c.set(o,l)),l.add(r)}delete(o,r){const l=this.c.get(o);l&&(l.delete(r),l.size===0&&this.c.delete(o))}forEach(o,r){const l=this.c.get(o);l&&l.forEach(r)}get(o){const r=this.c.get(o);return r||new Set}}i.$Gc=E;function v(h,o){if(h===o)return!0;if(h.size!==o.size)return!1;for(const[r,l]of h)if(!o.has(r)||o.get(r)!==l)return!1;for(const[r]of o)if(!h.has(r))return!1;return!0}}),ne(ie[12],re([0,1,7,37,16,22,23]),function(x,i,t,n,T,g,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$3c=i.$1c=i.$Zc=i.$Yc=i.$Xc=i.$Wc=i.$Vc=i.$Uc=i.$Tc=i.$Sc=i.$Ic=void 0,i.$Jc=c,i.$Kc=$,i.$Lc=m,i.$Mc=b,i.$Nc=N,i.$Oc=_,i.$Pc=A,i.$Qc=E,i.$Rc=v,i.$2c=j;const d=!1;let a=null;class u{constructor(){this.b=new Map}static{this.a=0}c(W){let P=this.b.get(W);return P||(P={parent:null,source:null,isSingleton:!1,value:W,idx:u.a++},this.b.set(W,P)),P}trackDisposable(W){const P=this.c(W);P.source||(P.source=new Error().stack)}setParent(W,P){const H=this.c(W);H.parent=P}markAsDisposed(W){this.b.delete(W)}markAsSingleton(W){this.c(W).isSingleton=!0}f(W,P){const H=P.get(W);if(H)return H;const B=W.parent?this.f(this.c(W.parent),P):W;return P.set(W,B),B}getTrackedDisposables(){const W=new Map;return[...this.b.entries()].filter(([,H])=>H.source!==null&&!this.f(H,W).isSingleton).flatMap(([H])=>H)}computeLeakingDisposables(W=10,P){let H;if(P)H=P;else{const G=new Map,Z=[...this.b.values()].filter(F=>F.source!==null&&!this.f(F,G).isSingleton);if(Z.length===0)return;const C=new Set(Z.map(F=>F.value));if(H=Z.filter(F=>!(F.parent&&C.has(F.parent))),H.length===0)throw new Error("There are cyclic diposable chains!")}if(!H)return;function B(G){function Z(F,X){for(;F.length>0&&X.some(fe=>typeof fe=="string"?fe===F[0]:F[0].match(fe));)F.shift()}const C=G.source.split(`
`).map(F=>F.trim().replace("at ","")).filter(F=>F!=="");return Z(C,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),C.reverse()}const y=new T.$Gc;for(const G of H){const Z=B(G);for(let C=0;C<=Z.length;C++)y.add(Z.slice(0,C).join(`
`),G)}H.sort((0,t.$5b)(G=>G.idx,t.$7b));let Y="",J=0;for(const G of H.slice(0,W)){J++;const Z=B(G),C=[];for(let F=0;F<Z.length;F++){let X=Z[F];X=`(shared with ${y.get(Z.slice(0,F+1).join(`
`)).size}/${H.length} leaks) at ${X}`;const oe=y.get(Z.slice(0,F).join(`
`)),we=(0,n.$c)([...oe].map(s=>B(s)[F]),s=>s);delete we[Z[F]];for(const[s,Te]of Object.entries(we))C.unshift(`    - stacktraces of ${Te.length} other leaks continue with ${s}`);C.unshift(X)}Y+=`


==================== Leaking disposable ${J}/${H.length}: ${G.value.constructor.name} ====================
${C.join(`
`)}
============================================================

`}return H.length>W&&(Y+=`


... and ${H.length-W} more leaking disposables

`),{leaks:H,details:Y}}}i.$Ic=u;function c(I){a=I}if(d){const I="__is_disposable_tracked__";c(new class{trackDisposable(W){const P=new Error("Potentially leaked disposable").stack;setTimeout(()=>{W[I]||console.log(P)},3e3)}setParent(W,P){if(W&&W!==o.None)try{W[I]=!0}catch{}}markAsDisposed(W){if(W&&W!==o.None)try{W[I]=!0}catch{}}markAsSingleton(W){}})}function $(I){return a?.trackDisposable(I),I}function m(I){a?.markAsDisposed(I)}function w(I,W){a?.setParent(I,W)}function e(I,W){if(a)for(const P of I)a.setParent(P,W)}function b(I){return a?.markAsSingleton(I),I}function N(I){return typeof I=="object"&&I!==null&&typeof I.dispose=="function"&&I.dispose.length===0}function _(I){if(L.Iterable.is(I)){const W=[];for(const P of I)if(P)try{P.dispose()}catch(H){W.push(H)}if(W.length===1)throw W[0];if(W.length>1)throw new AggregateError(W,"Encountered errors while disposing of store");return Array.isArray(I)?[]:I}else if(I)return I.dispose(),I}function A(I){for(const W of I)N(W)&&W.dispose();return[]}function E(...I){const W=v(()=>_(I));return e(I,W),W}function v(I){const W=$({dispose:(0,g.$cb)(()=>{m(W),I()})});return W}class h{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,$(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{_(this.f)}finally{this.f.clear()}}add(W){if(!W)return W;if(W===this)throw new Error("Cannot register a disposable on itself!");return w(W,this),this.g?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(W),W}delete(W){if(W){if(W===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(W),W.dispose()}}deleteAndLeak(W){W&&this.f.has(W)&&(this.f.delete(W),w(W,null))}}i.$Sc=h;class o{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new h,$(this),w(this.q,this)}dispose(){m(this),this.q.dispose()}B(W){if(W===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(W)}}i.$Tc=o;class r{constructor(){this.b=!1,$(this)}get value(){return this.b?void 0:this.a}set value(W){this.b||W===this.a||(this.a?.dispose(),W&&w(W,this),this.a=W)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const W=this.a;return this.a=void 0,W&&w(W,null),W}}i.$Uc=r;class l{constructor(W){this.a=new r,this.b=!1,this.a.value=W}get value(){return this.a.value}set value(W){this.b||W===this.a.value||(this.a.value=W)}dispose(){this.b=!0,this.a.dispose()}}i.$Vc=l;class f{constructor(W){this.b=W,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}i.$Wc=f;class D{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,$(this)}set(W){let P=W;return this.unset=()=>P=void 0,this.isset=()=>P!==void 0,this.dispose=()=>{P&&(P(),P=void 0,m(this))},this}}i.$Xc=D;class R{constructor(){this.a=new Map}acquire(W,...P){let H=this.a.get(W);H||(H={counter:0,object:this.b(W,...P)},this.a.set(W,H));const{object:B}=H,y=(0,g.$cb)(()=>{--H.counter===0&&(this.c(W,H.object),this.a.delete(W))});return H.counter++,{object:B,dispose:y}}}i.$Yc=R;class p{constructor(W){this.a=W}async acquire(W,...P){const H=this.a.acquire(W,...P);try{return{object:await H.object,dispose:()=>H.dispose()}}catch(B){throw H.dispose(),B}}}i.$Zc=p;class M{constructor(W){this.object=W}dispose(){}}i.$1c=M;function j(I){const W=new h;try{I(W)}finally{W.dispose()}}class S{constructor(){this.a=new Map,this.b=!1,$(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{_(this.a.values())}finally{this.a.clear()}}has(W){return this.a.has(W)}get size(){return this.a.size}get(W){return this.a.get(W)}set(W,P,H=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),H||this.a.get(W)?.dispose(),this.a.set(W,P)}deleteAndDispose(W){this.a.get(W)?.dispose(),this.a.delete(W)}deleteAndLeak(W){const P=this.a.get(W);return this.a.delete(W),P}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}i.$3c=S}),ne(ie[42],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.MarshalledId=void 0;var t;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadInstance=8]="CommentThreadInstance",n[n.CommentThreadReply=9]="CommentThreadReply",n[n.CommentNode=10]="CommentNode",n[n.CommentThreadNode=11]="CommentThreadNode",n[n.TimelineActionContext=12]="TimelineActionContext",n[n.NotebookCellActionContext=13]="NotebookCellActionContext",n[n.NotebookActionContext=14]="NotebookActionContext",n[n.TerminalContext=15]="TerminalContext",n[n.TestItemContext=16]="TestItemContext",n[n.Date=17]="Date",n[n.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(t||(i.MarshalledId=t={}))}),ne(ie[17],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$J=i.$I=i.$H=i.$G=i.$F=i.OS=i.OperatingSystem=i.$C=i.$B=i.$A=i.$z=i.$y=i.Language=i.$x=i.$w=i.$v=i.$u=i.$t=i.$s=i.$r=i.$q=i.$p=i.$o=i.$n=i.$m=i.$l=i.$k=i.$j=i.Platform=i.$h=void 0,i.$i=o,i.$E=p,i.$K=M,i.$h="en";let t=!1,n=!1,T=!1,g=!1,L=!1,d=!1,a=!1,u=!1,c=!1,$=!1,m,w=i.$h,e=i.$h,b,N;const _=globalThis;let A;typeof _.vscode<"u"&&typeof _.vscode.process<"u"?A=_.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(A=process);const E=typeof A?.versions?.electron=="string",v=E&&A?.type==="renderer";if(typeof A=="object"){t=A.platform==="win32",n=A.platform==="darwin",T=A.platform==="linux",g=T&&!!A.env.SNAP&&!!A.env.SNAP_REVISION,a=E,c=!!A.env.CI||!!A.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=i.$h,w=i.$h;const j=A.env.VSCODE_NLS_CONFIG;if(j)try{const S=JSON.parse(j);m=S.userLocale,e=S.osLocale,w=S.resolvedLanguage||i.$h,b=S.languagePack?.translationsConfigFile}catch{}L=!0}else typeof navigator=="object"&&!v?(N=navigator.userAgent,t=N.indexOf("Windows")>=0,n=N.indexOf("Macintosh")>=0,u=(N.indexOf("Macintosh")>=0||N.indexOf("iPad")>=0||N.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=N.indexOf("Linux")>=0,$=N?.indexOf("Mobi")>=0,d=!0,w=globalThis._VSCODE_NLS_LANGUAGE||i.$h,m=navigator.language.toLowerCase(),e=m):console.error("Unable to resolve platform.");var h;(function(j){j[j.Web=0]="Web",j[j.Mac=1]="Mac",j[j.Linux=2]="Linux",j[j.Windows=3]="Windows"})(h||(i.Platform=h={}));function o(j){switch(j){case h.Web:return"Web";case h.Mac:return"Mac";case h.Linux:return"Linux";case h.Windows:return"Windows"}}let r=h.Web;n?r=h.Mac:t?r=h.Windows:T&&(r=h.Linux),i.$j=t,i.$k=n,i.$l=T,i.$m=g,i.$n=L,i.$o=a,i.$p=d,i.$q=d&&typeof _.importScripts=="function",i.$r=i.$q?_.origin:void 0,i.$s=u,i.$t=$,i.$u=c,i.$v=r,i.$w=N,i.$x=w;var l;(function(j){function S(){return i.$x}j.value=S;function I(){return i.$x.length===2?i.$x==="en":i.$x.length>=3?i.$x[0]==="e"&&i.$x[1]==="n"&&i.$x[2]==="-":!1}j.isDefaultVariant=I;function W(){return i.$x==="en"}j.isDefault=W})(l||(i.Language=l={})),i.$y=m,i.$z=e,i.$A=b,i.$B=typeof _.postMessage=="function"&&!_.importScripts,i.$C=(()=>{if(i.$B){const j=[];_.addEventListener("message",I=>{if(I.data&&I.data.vscodeScheduleAsyncWork)for(let W=0,P=j.length;W<P;W++){const H=j[W];if(H.id===I.data.vscodeScheduleAsyncWork){j.splice(W,1),H.callback();return}}});let S=0;return I=>{const W=++S;j.push({id:W,callback:I}),_.postMessage({vscodeScheduleAsyncWork:W},"*")}}return j=>setTimeout(j)})();var f;(function(j){j[j.Windows=1]="Windows",j[j.Macintosh=2]="Macintosh",j[j.Linux=3]="Linux"})(f||(i.OperatingSystem=f={})),i.OS=n||u?f.Macintosh:t?f.Windows:f.Linux;let D=!0,R=!1;function p(){if(!R){R=!0;const j=new Uint8Array(2);j[0]=1,j[1]=2,D=new Uint16Array(j.buffer)[0]===513}return D}i.$F=!!(i.$w&&i.$w.indexOf("Chrome")>=0),i.$G=!!(i.$w&&i.$w.indexOf("Firefox")>=0),i.$H=!!(!i.$F&&i.$w&&i.$w.indexOf("Safari")>=0),i.$I=!!(i.$w&&i.$w.indexOf("Edg/")>=0),i.$J=!!(i.$w&&i.$w.indexOf("Android")>=0);function M(j){return parseFloat(j)>=20}}),ne(ie[43],re([0,1,17]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$dc=i.$cc=i.env=i.cwd=void 0;let n;const T=globalThis.vscode;if(typeof T<"u"&&typeof T.process<"u"){const g=T.process;n={get platform(){return g.platform},get arch(){return g.arch},get env(){return g.env},cwd(){return g.cwd()}}}else typeof process<"u"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return t.$j?"win32":t.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};i.cwd=n.cwd,i.env=n.env,i.$cc=n.platform,i.$dc=n.arch});var Qe=this&&this.__createBinding||(Object.create?function(x,i,t,n){n===void 0&&(n=t);var T=Object.getOwnPropertyDescriptor(i,t);(!T||("get"in T?!i.__esModule:T.writable||T.configurable))&&(T={enumerable:!0,get:function(){return i[t]}}),Object.defineProperty(x,n,T)}:function(x,i,t,n){n===void 0&&(n=t),x[n]=i[t]}),Ke=this&&this.__setModuleDefault||(Object.create?function(x,i){Object.defineProperty(x,"default",{enumerable:!0,value:i})}:function(x,i){x.default=i}),Pe=this&&this.__importStar||function(x){if(x&&x.__esModule)return x;var i={};if(x!=null)for(var t in x)t!=="default"&&Object.prototype.hasOwnProperty.call(x,t)&&Qe(i,x,t);return Ke(i,x),i};ne(ie[44],re([0,1,43]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$sc=i.sep=i.$qc=i.$pc=i.$oc=i.$nc=i.$mc=i.$lc=i.$kc=i.$jc=i.$ic=i.$hc=i.$gc=i.$fc=i.$ec=void 0,t=Pe(t);const n=65,T=97,g=90,L=122,d=46,a=47,u=92,c=58,$=63;class m extends Error{constructor(l,f,D){let R;typeof f=="string"&&f.indexOf("not ")===0?(R="must not be",f=f.replace(/^not /,"")):R="must be";const p=l.indexOf(".")!==-1?"property":"argument";let M=`The "${l}" ${p} ${R} of type ${f}`;M+=`. Received type ${typeof D}`,super(M),this.code="ERR_INVALID_ARG_TYPE"}}function w(r,l){if(r===null||typeof r!="object")throw new m(l,"Object",r)}function e(r,l){if(typeof r!="string")throw new m(l,"string",r)}const b=t.$cc==="win32";function N(r){return r===a||r===u}function _(r){return r===a}function A(r){return r>=n&&r<=g||r>=T&&r<=L}function E(r,l,f,D){let R="",p=0,M=-1,j=0,S=0;for(let I=0;I<=r.length;++I){if(I<r.length)S=r.charCodeAt(I);else{if(D(S))break;S=a}if(D(S)){if(!(M===I-1||j===1))if(j===2){if(R.length<2||p!==2||R.charCodeAt(R.length-1)!==d||R.charCodeAt(R.length-2)!==d){if(R.length>2){const W=R.lastIndexOf(f);W===-1?(R="",p=0):(R=R.slice(0,W),p=R.length-1-R.lastIndexOf(f)),M=I,j=0;continue}else if(R.length!==0){R="",p=0,M=I,j=0;continue}}l&&(R+=R.length>0?`${f}..`:"..",p=2)}else R.length>0?R+=`${f}${r.slice(M+1,I)}`:R=r.slice(M+1,I),p=I-M-1;M=I,j=0}else S===d&&j!==-1?++j:j=-1}return R}function v(r){return r?`${r[0]==="."?"":"."}${r}`:""}function h(r,l){w(l,"pathObject");const f=l.dir||l.root,D=l.base||`${l.name||""}${v(l.ext)}`;return f?f===l.root?`${f}${D}`:`${f}${r}${D}`:D}i.$ec={resolve(...r){let l="",f="",D=!1;for(let R=r.length-1;R>=-1;R--){let p;if(R>=0){if(p=r[R],e(p,`paths[${R}]`),p.length===0)continue}else l.length===0?p=t.cwd():(p=t.env[`=${l}`]||t.cwd(),(p===void 0||p.slice(0,2).toLowerCase()!==l.toLowerCase()&&p.charCodeAt(2)===u)&&(p=`${l}\\`));const M=p.length;let j=0,S="",I=!1;const W=p.charCodeAt(0);if(M===1)N(W)&&(j=1,I=!0);else if(N(W))if(I=!0,N(p.charCodeAt(1))){let P=2,H=P;for(;P<M&&!N(p.charCodeAt(P));)P++;if(P<M&&P!==H){const B=p.slice(H,P);for(H=P;P<M&&N(p.charCodeAt(P));)P++;if(P<M&&P!==H){for(H=P;P<M&&!N(p.charCodeAt(P));)P++;(P===M||P!==H)&&(S=`\\\\${B}\\${p.slice(H,P)}`,j=P)}}}else j=1;else A(W)&&p.charCodeAt(1)===c&&(S=p.slice(0,2),j=2,M>2&&N(p.charCodeAt(2))&&(I=!0,j=3));if(S.length>0)if(l.length>0){if(S.toLowerCase()!==l.toLowerCase())continue}else l=S;if(D){if(l.length>0)break}else if(f=`${p.slice(j)}\\${f}`,D=I,I&&l.length>0)break}return f=E(f,!D,"\\",N),D?`${l}\\${f}`:`${l}${f}`||"."},normalize(r){e(r,"path");const l=r.length;if(l===0)return".";let f=0,D,R=!1;const p=r.charCodeAt(0);if(l===1)return _(p)?"\\":r;if(N(p))if(R=!0,N(r.charCodeAt(1))){let j=2,S=j;for(;j<l&&!N(r.charCodeAt(j));)j++;if(j<l&&j!==S){const I=r.slice(S,j);for(S=j;j<l&&N(r.charCodeAt(j));)j++;if(j<l&&j!==S){for(S=j;j<l&&!N(r.charCodeAt(j));)j++;if(j===l)return`\\\\${I}\\${r.slice(S)}\\`;j!==S&&(D=`\\\\${I}\\${r.slice(S,j)}`,f=j)}}}else f=1;else A(p)&&r.charCodeAt(1)===c&&(D=r.slice(0,2),f=2,l>2&&N(r.charCodeAt(2))&&(R=!0,f=3));let M=f<l?E(r.slice(f),!R,"\\",N):"";return M.length===0&&!R&&(M="."),M.length>0&&N(r.charCodeAt(l-1))&&(M+="\\"),D===void 0?R?`\\${M}`:M:R?`${D}\\${M}`:`${D}${M}`},isAbsolute(r){e(r,"path");const l=r.length;if(l===0)return!1;const f=r.charCodeAt(0);return N(f)||l>2&&A(f)&&r.charCodeAt(1)===c&&N(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let l,f;for(let p=0;p<r.length;++p){const M=r[p];e(M,"path"),M.length>0&&(l===void 0?l=f=M:l+=`\\${M}`)}if(l===void 0)return".";let D=!0,R=0;if(typeof f=="string"&&N(f.charCodeAt(0))){++R;const p=f.length;p>1&&N(f.charCodeAt(1))&&(++R,p>2&&(N(f.charCodeAt(2))?++R:D=!1))}if(D){for(;R<l.length&&N(l.charCodeAt(R));)R++;R>=2&&(l=`\\${l.slice(R)}`)}return i.$ec.normalize(l)},relative(r,l){if(e(r,"from"),e(l,"to"),r===l)return"";const f=i.$ec.resolve(r),D=i.$ec.resolve(l);if(f===D||(r=f.toLowerCase(),l=D.toLowerCase(),r===l))return"";let R=0;for(;R<r.length&&r.charCodeAt(R)===u;)R++;let p=r.length;for(;p-1>R&&r.charCodeAt(p-1)===u;)p--;const M=p-R;let j=0;for(;j<l.length&&l.charCodeAt(j)===u;)j++;let S=l.length;for(;S-1>j&&l.charCodeAt(S-1)===u;)S--;const I=S-j,W=M<I?M:I;let P=-1,H=0;for(;H<W;H++){const y=r.charCodeAt(R+H);if(y!==l.charCodeAt(j+H))break;y===u&&(P=H)}if(H!==W){if(P===-1)return D}else{if(I>W){if(l.charCodeAt(j+H)===u)return D.slice(j+H+1);if(H===2)return D.slice(j+H)}M>W&&(r.charCodeAt(R+H)===u?P=H:H===2&&(P=3)),P===-1&&(P=0)}let B="";for(H=R+P+1;H<=p;++H)(H===p||r.charCodeAt(H)===u)&&(B+=B.length===0?"..":"\\..");return j+=P,B.length>0?`${B}${D.slice(j,S)}`:(D.charCodeAt(j)===u&&++j,D.slice(j,S))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const l=i.$ec.resolve(r);if(l.length<=2)return r;if(l.charCodeAt(0)===u){if(l.charCodeAt(1)===u){const f=l.charCodeAt(2);if(f!==$&&f!==d)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(A(l.charCodeAt(0))&&l.charCodeAt(1)===c&&l.charCodeAt(2)===u)return`\\\\?\\${l}`;return r},dirname(r){e(r,"path");const l=r.length;if(l===0)return".";let f=-1,D=0;const R=r.charCodeAt(0);if(l===1)return N(R)?r:".";if(N(R)){if(f=D=1,N(r.charCodeAt(1))){let j=2,S=j;for(;j<l&&!N(r.charCodeAt(j));)j++;if(j<l&&j!==S){for(S=j;j<l&&N(r.charCodeAt(j));)j++;if(j<l&&j!==S){for(S=j;j<l&&!N(r.charCodeAt(j));)j++;if(j===l)return r;j!==S&&(f=D=j+1)}}}}else A(R)&&r.charCodeAt(1)===c&&(f=l>2&&N(r.charCodeAt(2))?3:2,D=f);let p=-1,M=!0;for(let j=l-1;j>=D;--j)if(N(r.charCodeAt(j))){if(!M){p=j;break}}else M=!1;if(p===-1){if(f===-1)return".";p=f}return r.slice(0,p)},basename(r,l){l!==void 0&&e(l,"suffix"),e(r,"path");let f=0,D=-1,R=!0,p;if(r.length>=2&&A(r.charCodeAt(0))&&r.charCodeAt(1)===c&&(f=2),l!==void 0&&l.length>0&&l.length<=r.length){if(l===r)return"";let M=l.length-1,j=-1;for(p=r.length-1;p>=f;--p){const S=r.charCodeAt(p);if(N(S)){if(!R){f=p+1;break}}else j===-1&&(R=!1,j=p+1),M>=0&&(S===l.charCodeAt(M)?--M===-1&&(D=p):(M=-1,D=j))}return f===D?D=j:D===-1&&(D=r.length),r.slice(f,D)}for(p=r.length-1;p>=f;--p)if(N(r.charCodeAt(p))){if(!R){f=p+1;break}}else D===-1&&(R=!1,D=p+1);return D===-1?"":r.slice(f,D)},extname(r){e(r,"path");let l=0,f=-1,D=0,R=-1,p=!0,M=0;r.length>=2&&r.charCodeAt(1)===c&&A(r.charCodeAt(0))&&(l=D=2);for(let j=r.length-1;j>=l;--j){const S=r.charCodeAt(j);if(N(S)){if(!p){D=j+1;break}continue}R===-1&&(p=!1,R=j+1),S===d?f===-1?f=j:M!==1&&(M=1):f!==-1&&(M=-1)}return f===-1||R===-1||M===0||M===1&&f===R-1&&f===D+1?"":r.slice(f,R)},format:h.bind(null,"\\"),parse(r){e(r,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return l;const f=r.length;let D=0,R=r.charCodeAt(0);if(f===1)return N(R)?(l.root=l.dir=r,l):(l.base=l.name=r,l);if(N(R)){if(D=1,N(r.charCodeAt(1))){let P=2,H=P;for(;P<f&&!N(r.charCodeAt(P));)P++;if(P<f&&P!==H){for(H=P;P<f&&N(r.charCodeAt(P));)P++;if(P<f&&P!==H){for(H=P;P<f&&!N(r.charCodeAt(P));)P++;P===f?D=P:P!==H&&(D=P+1)}}}}else if(A(R)&&r.charCodeAt(1)===c){if(f<=2)return l.root=l.dir=r,l;if(D=2,N(r.charCodeAt(2))){if(f===3)return l.root=l.dir=r,l;D=3}}D>0&&(l.root=r.slice(0,D));let p=-1,M=D,j=-1,S=!0,I=r.length-1,W=0;for(;I>=D;--I){if(R=r.charCodeAt(I),N(R)){if(!S){M=I+1;break}continue}j===-1&&(S=!1,j=I+1),R===d?p===-1?p=I:W!==1&&(W=1):p!==-1&&(W=-1)}return j!==-1&&(p===-1||W===0||W===1&&p===j-1&&p===M+1?l.base=l.name=r.slice(M,j):(l.name=r.slice(M,p),l.base=r.slice(M,j),l.ext=r.slice(p,j))),M>0&&M!==D?l.dir=r.slice(0,M-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const o=(()=>{if(b){const r=/\\/g;return()=>{const l=t.cwd().replace(r,"/");return l.slice(l.indexOf("/"))}}return()=>t.cwd()})();i.$fc={resolve(...r){let l="",f=!1;for(let D=r.length-1;D>=-1&&!f;D--){const R=D>=0?r[D]:o();e(R,`paths[${D}]`),R.length!==0&&(l=`${R}/${l}`,f=R.charCodeAt(0)===a)}return l=E(l,!f,"/",_),f?`/${l}`:l.length>0?l:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const l=r.charCodeAt(0)===a,f=r.charCodeAt(r.length-1)===a;return r=E(r,!l,"/",_),r.length===0?l?"/":f?"./":".":(f&&(r+="/"),l?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===a},join(...r){if(r.length===0)return".";let l;for(let f=0;f<r.length;++f){const D=r[f];e(D,"path"),D.length>0&&(l===void 0?l=D:l+=`/${D}`)}return l===void 0?".":i.$fc.normalize(l)},relative(r,l){if(e(r,"from"),e(l,"to"),r===l||(r=i.$fc.resolve(r),l=i.$fc.resolve(l),r===l))return"";const f=1,D=r.length,R=D-f,p=1,M=l.length-p,j=R<M?R:M;let S=-1,I=0;for(;I<j;I++){const P=r.charCodeAt(f+I);if(P!==l.charCodeAt(p+I))break;P===a&&(S=I)}if(I===j)if(M>j){if(l.charCodeAt(p+I)===a)return l.slice(p+I+1);if(I===0)return l.slice(p+I)}else R>j&&(r.charCodeAt(f+I)===a?S=I:I===0&&(S=0));let W="";for(I=f+S+1;I<=D;++I)(I===D||r.charCodeAt(I)===a)&&(W+=W.length===0?"..":"/..");return`${W}${l.slice(p+S)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const l=r.charCodeAt(0)===a;let f=-1,D=!0;for(let R=r.length-1;R>=1;--R)if(r.charCodeAt(R)===a){if(!D){f=R;break}}else D=!1;return f===-1?l?"/":".":l&&f===1?"//":r.slice(0,f)},basename(r,l){l!==void 0&&e(l,"ext"),e(r,"path");let f=0,D=-1,R=!0,p;if(l!==void 0&&l.length>0&&l.length<=r.length){if(l===r)return"";let M=l.length-1,j=-1;for(p=r.length-1;p>=0;--p){const S=r.charCodeAt(p);if(S===a){if(!R){f=p+1;break}}else j===-1&&(R=!1,j=p+1),M>=0&&(S===l.charCodeAt(M)?--M===-1&&(D=p):(M=-1,D=j))}return f===D?D=j:D===-1&&(D=r.length),r.slice(f,D)}for(p=r.length-1;p>=0;--p)if(r.charCodeAt(p)===a){if(!R){f=p+1;break}}else D===-1&&(R=!1,D=p+1);return D===-1?"":r.slice(f,D)},extname(r){e(r,"path");let l=-1,f=0,D=-1,R=!0,p=0;for(let M=r.length-1;M>=0;--M){const j=r.charCodeAt(M);if(j===a){if(!R){f=M+1;break}continue}D===-1&&(R=!1,D=M+1),j===d?l===-1?l=M:p!==1&&(p=1):l!==-1&&(p=-1)}return l===-1||D===-1||p===0||p===1&&l===D-1&&l===f+1?"":r.slice(l,D)},format:h.bind(null,"/"),parse(r){e(r,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return l;const f=r.charCodeAt(0)===a;let D;f?(l.root="/",D=1):D=0;let R=-1,p=0,M=-1,j=!0,S=r.length-1,I=0;for(;S>=D;--S){const W=r.charCodeAt(S);if(W===a){if(!j){p=S+1;break}continue}M===-1&&(j=!1,M=S+1),W===d?R===-1?R=S:I!==1&&(I=1):R!==-1&&(I=-1)}if(M!==-1){const W=p===0&&f?1:p;R===-1||I===0||I===1&&R===M-1&&R===p+1?l.base=l.name=r.slice(W,M):(l.name=r.slice(W,R),l.base=r.slice(W,M),l.ext=r.slice(R,M))}return p>0?l.dir=r.slice(0,p-1):f&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},i.$fc.win32=i.$ec.win32=i.$ec,i.$fc.posix=i.$ec.posix=i.$fc,i.$gc=b?i.$ec.normalize:i.$fc.normalize,i.$hc=b?i.$ec.isAbsolute:i.$fc.isAbsolute,i.$ic=b?i.$ec.join:i.$fc.join,i.$jc=b?i.$ec.resolve:i.$fc.resolve,i.$kc=b?i.$ec.relative:i.$fc.relative,i.$lc=b?i.$ec.dirname:i.$fc.dirname,i.$mc=b?i.$ec.basename:i.$fc.basename,i.$nc=b?i.$ec.extname:i.$fc.extname,i.$oc=b?i.$ec.format:i.$fc.format,i.$pc=b?i.$ec.parse:i.$fc.parse,i.$qc=b?i.$ec.toNamespacedPath:i.$fc.toNamespacedPath,i.sep=b?i.$ec.sep:i.$fc.sep,i.$sc=b?i.$ec.delimiter:i.$fc.delimiter}),ne(ie[25],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$de=void 0;const t=globalThis.performance&&typeof globalThis.performance.now=="function";class n{static create(g){return new n(g)}constructor(g){this.c=t&&g===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}i.$de=n}),ne(ie[13],re([0,1,4,22,12,24,25]),function(x,i,t,n,T,g,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$te=i.$se=i.$re=i.$qe=i.$pe=i.$oe=i.$ne=i.$me=i.$le=i.$ke=i.$je=i.$ie=i.$he=i.$fe=i.Event=void 0,i.$ge=w;const d=!1,a=!1,u=!1;var c;(function(B){B.None=()=>T.$Tc.None;function y(se){if(u){const{onDidAddListener:te}=se,ae=b.create();let ue=0;se.onDidAddListener=()=>{++ue===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ae.print()),te?.()}}}function Y(se,te){return s(se,()=>{},0,void 0,!0,void 0,te)}B.defer=Y;function J(se){return(te,ae=null,ue)=>{let ce=!1,me;return me=se($e=>{if(!ce)return me?me.dispose():ce=!0,te.call(ae,$e)},null,ue),ce&&me.dispose(),me}}B.once=J;function G(se,te,ae){return oe((ue,ce=null,me)=>se($e=>ue.call(ce,te($e)),null,me),ae)}B.map=G;function Z(se,te,ae){return oe((ue,ce=null,me)=>se($e=>{te($e),ue.call(ce,$e)},null,me),ae)}B.forEach=Z;function C(se,te,ae){return oe((ue,ce=null,me)=>se($e=>te($e)&&ue.call(ce,$e),null,me),ae)}B.filter=C;function F(se){return se}B.signal=F;function X(...se){return(te,ae=null,ue)=>{const ce=(0,T.$Qc)(...se.map(me=>me($e=>te.call(ae,$e))));return we(ce,ue)}}B.any=X;function fe(se,te,ae,ue){let ce=ae;return G(se,me=>(ce=te(ce,me),ce),ue)}B.reduce=fe;function oe(se,te){let ae;const ue={onWillAddFirstListener(){ae=se(ce.fire,ce)},onDidRemoveLastListener(){ae?.dispose()}};te||y(ue);const ce=new r(ue);return te?.add(ce),ce.event}function we(se,te){return te instanceof Array?te.push(se):te&&te.add(se),se}function s(se,te,ae=100,ue=!1,ce=!1,me,$e){let Ne,Ae,Oe,Be=0,ge;const je={leakWarningThreshold:me,onWillAddFirstListener(){Ne=se(ze=>{Be++,Ae=te(Ae,ze),ue&&!Oe&&(xe.fire(Ae),Ae=void 0),ge=()=>{const Xe=Ae;Ae=void 0,Oe=void 0,(!ue||Be>1)&&xe.fire(Xe),Be=0},typeof ae=="number"?(clearTimeout(Oe),Oe=setTimeout(ge,ae)):Oe===void 0&&(Oe=0,queueMicrotask(ge))})},onWillRemoveListener(){ce&&Be>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,Ne.dispose()}};$e||y(je);const xe=new r(je);return $e?.add(xe),xe.event}B.debounce=s;function Te(se,te=0,ae){return B.debounce(se,(ue,ce)=>ue?(ue.push(ce),ue):[ce],te,void 0,!0,void 0,ae)}B.accumulate=Te;function ke(se,te=(ue,ce)=>ue===ce,ae){let ue=!0,ce;return C(se,me=>{const $e=ue||!te(me,ce);return ue=!1,ce=me,$e},ae)}B.latch=ke;function Ve(se,te,ae){return[B.filter(se,te,ae),B.filter(se,ue=>!te(ue),ae)]}B.split=Ve;function De(se,te=!1,ae=[],ue){let ce=ae.slice(),me=se(Ae=>{ce?ce.push(Ae):Ne.fire(Ae)});ue&&ue.add(me);const $e=()=>{ce?.forEach(Ae=>Ne.fire(Ae)),ce=null},Ne=new r({onWillAddFirstListener(){me||(me=se(Ae=>Ne.fire(Ae)),ue&&ue.add(me))},onDidAddFirstListener(){ce&&(te?setTimeout($e):$e())},onDidRemoveLastListener(){me&&me.dispose(),me=null}});return ue&&ue.add(Ne),Ne.event}B.buffer=De;function ye(se,te){return(ue,ce,me)=>{const $e=te(new V);return se(function(Ne){const Ae=$e.evaluate(Ne);Ae!==q&&ue.call(ce,Ae)},void 0,me)}}B.chain=ye;const q=Symbol("HaltChainable");class V{constructor(){this.f=[]}map(te){return this.f.push(te),this}forEach(te){return this.f.push(ae=>(te(ae),ae)),this}filter(te){return this.f.push(ae=>te(ae)?ae:q),this}reduce(te,ae){let ue=ae;return this.f.push(ce=>(ue=te(ue,ce),ue)),this}latch(te=(ae,ue)=>ae===ue){let ae=!0,ue;return this.f.push(ce=>{const me=ae||!te(ce,ue);return ae=!1,ue=ce,me?ce:q}),this}evaluate(te){for(const ae of this.f)if(te=ae(te),te===q)break;return te}}function U(se,te,ae=ue=>ue){const ue=(...Ne)=>$e.fire(ae(...Ne)),ce=()=>se.on(te,ue),me=()=>se.removeListener(te,ue),$e=new r({onWillAddFirstListener:ce,onDidRemoveLastListener:me});return $e.event}B.fromNodeEventEmitter=U;function Q(se,te,ae=ue=>ue){const ue=(...Ne)=>$e.fire(ae(...Ne)),ce=()=>se.addEventListener(te,ue),me=()=>se.removeEventListener(te,ue),$e=new r({onWillAddFirstListener:ce,onDidRemoveLastListener:me});return $e.event}B.fromDOMEventEmitter=Q;function ee(se){return new Promise(te=>J(se)(te))}B.toPromise=ee;function he(se){const te=new r;return se.then(ae=>{te.fire(ae)},()=>{te.fire(void 0)}).finally(()=>{te.dispose()}),te.event}B.fromPromise=he;function de(se,te,ae){return te(ae),se(ue=>te(ue))}B.runAndSubscribe=de;class Ee{constructor(te,ae){this._observable=te,this.f=0,this.g=!1;const ue={onWillAddFirstListener:()=>{te.addObserver(this)},onDidRemoveLastListener:()=>{te.removeObserver(this)}};ae||y(ue),this.emitter=new r(ue),ae&&ae.add(this.emitter)}beginUpdate(te){this.f++}handlePossibleChange(te){}handleChange(te,ae){this.g=!0}endUpdate(te){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ve(se,te){return new Ee(se,te).emitter.event}B.fromObservable=ve;function _e(se){return(te,ae,ue)=>{let ce=0,me=!1;const $e={beginUpdate(){ce++},endUpdate(){ce--,ce===0&&(se.reportChanges(),me&&(me=!1,te.call(ae)))},handlePossibleChange(){},handleChange(){me=!0}};se.addObserver($e),se.reportChanges();const Ne={dispose(){se.removeObserver($e)}};return ue instanceof T.$Sc?ue.add(Ne):Array.isArray(ue)&&ue.push(Ne),Ne}}B.fromObservableLight=_e})(c||(i.Event=c={}));class ${static{this.all=new Set}static{this.f=0}constructor(y){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${y}_${$.f++}`,$.all.add(this)}start(y){this.g=new L.$de,this.listenerCount=y}stop(){if(this.g){const y=this.g.elapsed();this.durations.push(y),this.elapsedOverall+=y,this.invocationCount+=1,this.g=void 0}}}i.$fe=$;let m=-1;function w(B){const y=m;return m=B,{dispose(){m=y}}}class e{static{this.f=1}constructor(y,Y,J=(e.f++).toString(16).padStart(3,"0")){this.j=y,this.threshold=Y,this.name=J,this.h=0}dispose(){this.g?.clear()}check(y,Y){const J=this.threshold;if(J<=0||Y<J)return;this.g||(this.g=new Map);const G=this.g.get(y.value)||0;if(this.g.set(y.value,G+1),this.h-=1,this.h<=0){this.h=J*.5;const[Z,C]=this.getMostFrequentStack(),F=`[${this.name}] potential listener LEAK detected, having ${Y} listeners already. MOST frequent listener (${C}):`;console.warn(F),console.warn(Z);const X=new N(F,Z);this.j(X)}return()=>{const Z=this.g.get(y.value)||0;this.g.set(y.value,Z-1)}}getMostFrequentStack(){if(!this.g)return;let y,Y=0;for(const[J,G]of this.g)(!y||Y<G)&&(y=[J,G],Y=G);return y}}class b{static create(){const y=new Error;return new b(y.stack??"")}constructor(y){this.value=y}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class N extends Error{constructor(y,Y){super(y),this.name="ListenerLeakError",this.stack=Y}}i.$he=N;class _ extends Error{constructor(y,Y){super(y),this.name="ListenerRefusalError",this.stack=Y}}i.$ie=_;let A=0;class E{constructor(y){this.value=y,this.id=A++}}const v=2,h=(B,y)=>{if(B instanceof E)y(B);else for(let Y=0;Y<B.length;Y++){const J=B[Y];J&&y(J)}};let o;if(d){const B=[];setInterval(()=>{B.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(B.join(`
`)),B.length=0)},3e3),o=new FinalizationRegistry(y=>{typeof y=="string"&&B.push(y)})}class r{constructor(y){this.z=0,this.f=y,this.g=m>0||this.f?.leakWarningThreshold?new e(y?.onListenerError??t.$Y,this.f?.leakWarningThreshold??m):void 0,this.j=this.f?._profName?new $(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(a){const y=this.u;queueMicrotask(()=>{h(y,Y=>Y.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(y,Y,J)=>{if(this.g&&this.z>this.g.threshold**2){const X=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(X);const fe=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],oe=new _(`${X}. HINT: Stack shows most frequent listener (${fe[1]}-times)`,fe[0]);return(this.f?.onListenerError||t.$Y)(oe),T.$Tc.None}if(this.m)return T.$Tc.None;Y&&(y=y.bind(Y));const G=new E(y);let Z,C;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(G.stack=b.create(),Z=this.g.check(G.stack,this.z+1)),a&&(G.stack=C??b.create()),this.u?this.u instanceof E?(this.w??=new f,this.u=[this.u,G]):this.u.push(G):(this.f?.onWillAddFirstListener?.(this),this.u=G,this.f?.onDidAddFirstListener?.(this)),this.z++;const F=(0,T.$Rc)(()=>{o?.unregister(F),Z?.(),this.A(G)});if(J instanceof T.$Sc?J.add(F):Array.isArray(J)&&J.push(F),o){const X=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),fe=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(X);o.register(F,fe?.[2]??X,F)}return F},this.q}A(y){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const Y=this.u,J=Y.indexOf(y);if(J===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,Y[J]=void 0;const G=this.w.current===this;if(this.z*v<=Y.length){let Z=0;for(let C=0;C<Y.length;C++)Y[C]?Y[Z++]=Y[C]:G&&(this.w.end--,Z<this.w.i&&this.w.i--);Y.length=Z}}B(y,Y){if(!y)return;const J=this.f?.onListenerError||t.$Y;if(!J){y.value(Y);return}try{y.value(Y)}catch(G){J(G)}}C(y){const Y=y.current.u;for(;y.i<y.end;)this.B(Y[y.i++],y.value);y.reset()}fire(y){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof E)this.B(this.u,y);else{const Y=this.w;Y.enqueue(this,y,this.u.length),this.C(Y)}this.j?.stop()}hasListeners(){return this.z>0}}i.$je=r;const l=()=>new f;i.$ke=l;class f{constructor(){this.i=-1,this.end=0}enqueue(y,Y,J){this.i=0,this.end=J,this.current=y,this.value=Y}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class D extends r{async fireAsync(y,Y,J){if(this.u)for(this.h||(this.h=new g.$4c),h(this.u,G=>this.h.push([G.value,y]));this.h.size>0&&!Y.isCancellationRequested;){const[G,Z]=this.h.shift(),C=[],F={...Z,token:Y,waitUntil:X=>{if(Object.isFrozen(C))throw new Error("waitUntil can NOT be called asynchronous");J&&(X=J(X,G)),C.push(X)}};try{G(F)}catch(X){(0,t.$Y)(X);continue}Object.freeze(C),await Promise.allSettled(C).then(X=>{for(const fe of X)fe.status==="rejected"&&(0,t.$Y)(fe.reason)})}}}i.$le=D;class R extends r{get isPaused(){return this.h!==0}constructor(y){super(y),this.h=0,this.s=new g.$4c,this.t=y?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const y=Array.from(this.s);this.s.clear(),super.fire(this.t(y))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(y){this.z&&(this.h!==0?this.s.push(y):super.fire(y))}}i.$me=R;class p extends R{constructor(y){super(y),this.k=y.delay??100}fire(y){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(y)}}i.$ne=p;class M extends r{constructor(y){super(y),this.h=[],this.k=y?.merge}fire(y){this.hasListeners()&&(this.h.push(y),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(Y=>super.fire(Y)),this.h=[]}))}}i.$oe=M;class j{constructor(){this.g=!1,this.h=[],this.f=new r({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(y){const Y={event:y,listener:null};this.h.push(Y),this.g&&this.m(Y);const J=()=>{this.g&&this.o(Y);const G=this.h.indexOf(Y);this.h.splice(G,1)};return(0,T.$Rc)((0,n.$cb)(J))}j(){this.g=!0,this.h.forEach(y=>this.m(y))}k(){this.g=!1,this.h.forEach(y=>this.o(y))}m(y){y.listener=y.event(Y=>this.f.fire(Y))}o(y){y.listener?.dispose(),y.listener=null}dispose(){this.f.dispose();for(const y of this.h)y.listener?.dispose();this.h=[]}}i.$pe=j;class S{constructor(y,Y,J,G){this.f=new T.$Sc;const Z=this.f.add(new j),C=this.f.add(new T.$3c);function F(X){C.set(X,Z.add(G(X)))}for(const X of y)F(X);this.f.add(Y(X=>{F(X)})),this.f.add(J(X=>{C.deleteAndDispose(X)})),this.event=Z.event}dispose(){this.f.dispose()}}i.$qe=S;class I{constructor(){this.f=[]}wrapEvent(y,Y,J){return(G,Z,C)=>y(F=>{const X=this.f[this.f.length-1];if(!Y){X?X.buffers.push(()=>G.call(Z,F)):G.call(Z,F);return}const fe=X;if(!fe){G.call(Z,Y(J,F));return}fe.items??=[],fe.items.push(F),fe.buffers.length===0&&X.buffers.push(()=>{fe.reducedResult??=J?fe.items.reduce(Y,J):fe.items.reduce(Y),G.call(Z,fe.reducedResult)})},void 0,C)}bufferEvents(y){const Y={buffers:new Array};this.f.push(Y);const J=y();return this.f.pop(),Y.buffers.forEach(G=>G()),J}}i.$re=I;class W{constructor(){this.f=!1,this.g=c.None,this.h=T.$Tc.None,this.j=new r({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(y){this.g=y,this.f&&(this.h.dispose(),this.h=y(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}i.$se=W;class P{static const(y){return new H(y)}constructor(y){this.g=y,this.f=new r,this.onDidChange=this.f.event}get value(){return this.g}set value(y){y!==this.g&&(this.g=y,this.f.fire(void 0))}}i.$te=P;class H{constructor(y){this.value=y,this.onDidChange=c.None}}}),ne(ie[26],re([0,1,13]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$ue=i.CancellationToken=void 0,i.$ve=d;const n=Object.freeze(function(a,u){const c=setTimeout(a.bind(u),0);return{dispose(){clearTimeout(c)}}});var T;(function(a){function u(c){return c===a.None||c===a.Cancelled||c instanceof g?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}a.isCancellationToken=u,a.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:t.Event.None}),a.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(T||(i.CancellationToken=T={}));class g{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?n:(this.b||(this.b=new t.$je),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor(u){this.f=void 0,this.g=void 0,this.g=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new g),this.f}cancel(){this.f?this.f instanceof g&&this.f.cancel():this.f=T.Cancelled}dispose(u=!1){u&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof g&&this.f.dispose():this.f=T.None}}i.$ue=L;function d(a){const u=new L;return a.add({dispose(){u.cancel()}}),u.token}}),ne(ie[45],re([0,1,26]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$0e=i.$9e=i.$7e=void 0,i.$8e=T;class n{constructor(a){this.b=a,this.a=null}get(){if(this.a)return this.a;const a=new t.$ue,u=this.b(a.token);return this.a={promise:u,dispose:()=>{this.a=null,a.cancel(),a.dispose()}},this.a}}i.$7e=n;function T(d){return d}class g{constructor(a,u){this.a=void 0,this.b=void 0,typeof a=="function"?(this.c=a,this.d=T):(this.c=u,this.d=a.getCacheKey)}get(a){const u=this.d(a);return this.b!==u&&(this.b=u,this.a=this.c(a)),this.a}}i.$9e=g;class L{get cachedValues(){return this.a}constructor(a,u){this.a=new Map,this.b=new Map,typeof a=="function"?(this.c=a,this.d=T):(this.c=u,this.d=a.getCacheKey)}get(a){const u=this.d(a);if(this.b.has(u))return this.b.get(u);const c=this.c(a);return this.a.set(a,c),this.b.set(u,c),c}}i.$0e=L}),ne(ie[27],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$cg=t,i.$dg=n,i.$eg=T,i.$fg=g,i.$gg=L,i.$hg=d,i.$ig=a,i.$jg=u,i.$kg=c,i.$lg=$,i.$mg=m,i.$ng=w,i.$og=e,i.$pg=N,i.$qg=_,i.$rg=A,i.$sg=E,i.$tg=v;function t(h){return typeof h=="string"}function n(h){return Array.isArray(h)&&h.every(o=>t(o))}function T(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}function g(h){const o=Object.getPrototypeOf(Uint8Array);return typeof h=="object"&&h instanceof o}function L(h){return typeof h=="number"&&!isNaN(h)}function d(h){return!!h&&typeof h[Symbol.iterator]=="function"}function a(h){return h===!0||h===!1}function u(h){return typeof h>"u"}function c(h){return!$(h)}function $(h){return u(h)||h===null}function m(h,o){if(!h)throw new Error(o?`Unexpected type, expected '${o}'`:"Unexpected type")}function w(h){if($(h))throw new Error("Assertion Failed: argument is undefined or null");return h}function e(...h){const o=[];for(let r=0;r<h.length;r++){const l=h[r];if($(l))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);o.push(l)}return o}const b=Object.prototype.hasOwnProperty;function N(h){if(!T(h))return!1;for(const o in h)if(b.call(h,o))return!1;return!0}function _(h){return typeof h=="function"}function A(...h){return h.length>0&&h.every(_)}function E(h,o){const r=Math.min(h.length,o.length);for(let l=0;l<r;l++)v(h[l],o[l])}function v(h,o){if(t(o)){if(typeof h!==o)throw new Error(`argument does not match constraint: typeof ${o}`)}else if(_(o)){try{if(h instanceof o)return}catch{}if(!$(h)&&h.constructor===o||o.length===1&&o.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),ne(ie[28],re([0,1,27]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Wj=T,i.$Xj=g;const n=Object.create(null);function T(L,d){if((0,t.$cg)(d)){const a=n[d];if(a===void 0)throw new Error(`${L} references an unknown codicon: ${d}`);d=a}return n[L]=d,{id:L}}function g(){return n}}),ne(ie[46],re([0,1,28]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Yj=void 0,i.$Yj={add:(0,t.$Wj)("add",6e4),plus:(0,t.$Wj)("plus",6e4),gistNew:(0,t.$Wj)("gist-new",6e4),repoCreate:(0,t.$Wj)("repo-create",6e4),lightbulb:(0,t.$Wj)("lightbulb",60001),lightBulb:(0,t.$Wj)("light-bulb",60001),repo:(0,t.$Wj)("repo",60002),repoDelete:(0,t.$Wj)("repo-delete",60002),gistFork:(0,t.$Wj)("gist-fork",60003),repoForked:(0,t.$Wj)("repo-forked",60003),gitPullRequest:(0,t.$Wj)("git-pull-request",60004),gitPullRequestAbandoned:(0,t.$Wj)("git-pull-request-abandoned",60004),recordKeys:(0,t.$Wj)("record-keys",60005),keyboard:(0,t.$Wj)("keyboard",60005),tag:(0,t.$Wj)("tag",60006),gitPullRequestLabel:(0,t.$Wj)("git-pull-request-label",60006),tagAdd:(0,t.$Wj)("tag-add",60006),tagRemove:(0,t.$Wj)("tag-remove",60006),person:(0,t.$Wj)("person",60007),personFollow:(0,t.$Wj)("person-follow",60007),personOutline:(0,t.$Wj)("person-outline",60007),personFilled:(0,t.$Wj)("person-filled",60007),gitBranch:(0,t.$Wj)("git-branch",60008),gitBranchCreate:(0,t.$Wj)("git-branch-create",60008),gitBranchDelete:(0,t.$Wj)("git-branch-delete",60008),sourceControl:(0,t.$Wj)("source-control",60008),mirror:(0,t.$Wj)("mirror",60009),mirrorPublic:(0,t.$Wj)("mirror-public",60009),star:(0,t.$Wj)("star",60010),starAdd:(0,t.$Wj)("star-add",60010),starDelete:(0,t.$Wj)("star-delete",60010),starEmpty:(0,t.$Wj)("star-empty",60010),comment:(0,t.$Wj)("comment",60011),commentAdd:(0,t.$Wj)("comment-add",60011),alert:(0,t.$Wj)("alert",60012),warning:(0,t.$Wj)("warning",60012),search:(0,t.$Wj)("search",60013),searchSave:(0,t.$Wj)("search-save",60013),logOut:(0,t.$Wj)("log-out",60014),signOut:(0,t.$Wj)("sign-out",60014),logIn:(0,t.$Wj)("log-in",60015),signIn:(0,t.$Wj)("sign-in",60015),eye:(0,t.$Wj)("eye",60016),eyeUnwatch:(0,t.$Wj)("eye-unwatch",60016),eyeWatch:(0,t.$Wj)("eye-watch",60016),circleFilled:(0,t.$Wj)("circle-filled",60017),primitiveDot:(0,t.$Wj)("primitive-dot",60017),closeDirty:(0,t.$Wj)("close-dirty",60017),debugBreakpoint:(0,t.$Wj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,t.$Wj)("debug-breakpoint-disabled",60017),debugHint:(0,t.$Wj)("debug-hint",60017),terminalDecorationSuccess:(0,t.$Wj)("terminal-decoration-success",60017),primitiveSquare:(0,t.$Wj)("primitive-square",60018),edit:(0,t.$Wj)("edit",60019),pencil:(0,t.$Wj)("pencil",60019),info:(0,t.$Wj)("info",60020),issueOpened:(0,t.$Wj)("issue-opened",60020),gistPrivate:(0,t.$Wj)("gist-private",60021),gitForkPrivate:(0,t.$Wj)("git-fork-private",60021),lock:(0,t.$Wj)("lock",60021),mirrorPrivate:(0,t.$Wj)("mirror-private",60021),close:(0,t.$Wj)("close",60022),removeClose:(0,t.$Wj)("remove-close",60022),x:(0,t.$Wj)("x",60022),repoSync:(0,t.$Wj)("repo-sync",60023),sync:(0,t.$Wj)("sync",60023),clone:(0,t.$Wj)("clone",60024),desktopDownload:(0,t.$Wj)("desktop-download",60024),beaker:(0,t.$Wj)("beaker",60025),microscope:(0,t.$Wj)("microscope",60025),vm:(0,t.$Wj)("vm",60026),deviceDesktop:(0,t.$Wj)("device-desktop",60026),file:(0,t.$Wj)("file",60027),fileText:(0,t.$Wj)("file-text",60027),more:(0,t.$Wj)("more",60028),ellipsis:(0,t.$Wj)("ellipsis",60028),kebabHorizontal:(0,t.$Wj)("kebab-horizontal",60028),mailReply:(0,t.$Wj)("mail-reply",60029),reply:(0,t.$Wj)("reply",60029),organization:(0,t.$Wj)("organization",60030),organizationFilled:(0,t.$Wj)("organization-filled",60030),organizationOutline:(0,t.$Wj)("organization-outline",60030),newFile:(0,t.$Wj)("new-file",60031),fileAdd:(0,t.$Wj)("file-add",60031),newFolder:(0,t.$Wj)("new-folder",60032),fileDirectoryCreate:(0,t.$Wj)("file-directory-create",60032),trash:(0,t.$Wj)("trash",60033),trashcan:(0,t.$Wj)("trashcan",60033),history:(0,t.$Wj)("history",60034),clock:(0,t.$Wj)("clock",60034),folder:(0,t.$Wj)("folder",60035),fileDirectory:(0,t.$Wj)("file-directory",60035),symbolFolder:(0,t.$Wj)("symbol-folder",60035),logoGithub:(0,t.$Wj)("logo-github",60036),markGithub:(0,t.$Wj)("mark-github",60036),github:(0,t.$Wj)("github",60036),terminal:(0,t.$Wj)("terminal",60037),console:(0,t.$Wj)("console",60037),repl:(0,t.$Wj)("repl",60037),zap:(0,t.$Wj)("zap",60038),symbolEvent:(0,t.$Wj)("symbol-event",60038),error:(0,t.$Wj)("error",60039),stop:(0,t.$Wj)("stop",60039),variable:(0,t.$Wj)("variable",60040),symbolVariable:(0,t.$Wj)("symbol-variable",60040),array:(0,t.$Wj)("array",60042),symbolArray:(0,t.$Wj)("symbol-array",60042),symbolModule:(0,t.$Wj)("symbol-module",60043),symbolPackage:(0,t.$Wj)("symbol-package",60043),symbolNamespace:(0,t.$Wj)("symbol-namespace",60043),symbolObject:(0,t.$Wj)("symbol-object",60043),symbolMethod:(0,t.$Wj)("symbol-method",60044),symbolFunction:(0,t.$Wj)("symbol-function",60044),symbolConstructor:(0,t.$Wj)("symbol-constructor",60044),symbolBoolean:(0,t.$Wj)("symbol-boolean",60047),symbolNull:(0,t.$Wj)("symbol-null",60047),symbolNumeric:(0,t.$Wj)("symbol-numeric",60048),symbolNumber:(0,t.$Wj)("symbol-number",60048),symbolStructure:(0,t.$Wj)("symbol-structure",60049),symbolStruct:(0,t.$Wj)("symbol-struct",60049),symbolParameter:(0,t.$Wj)("symbol-parameter",60050),symbolTypeParameter:(0,t.$Wj)("symbol-type-parameter",60050),symbolKey:(0,t.$Wj)("symbol-key",60051),symbolText:(0,t.$Wj)("symbol-text",60051),symbolReference:(0,t.$Wj)("symbol-reference",60052),goToFile:(0,t.$Wj)("go-to-file",60052),symbolEnum:(0,t.$Wj)("symbol-enum",60053),symbolValue:(0,t.$Wj)("symbol-value",60053),symbolRuler:(0,t.$Wj)("symbol-ruler",60054),symbolUnit:(0,t.$Wj)("symbol-unit",60054),activateBreakpoints:(0,t.$Wj)("activate-breakpoints",60055),archive:(0,t.$Wj)("archive",60056),arrowBoth:(0,t.$Wj)("arrow-both",60057),arrowDown:(0,t.$Wj)("arrow-down",60058),arrowLeft:(0,t.$Wj)("arrow-left",60059),arrowRight:(0,t.$Wj)("arrow-right",60060),arrowSmallDown:(0,t.$Wj)("arrow-small-down",60061),arrowSmallLeft:(0,t.$Wj)("arrow-small-left",60062),arrowSmallRight:(0,t.$Wj)("arrow-small-right",60063),arrowSmallUp:(0,t.$Wj)("arrow-small-up",60064),arrowUp:(0,t.$Wj)("arrow-up",60065),bell:(0,t.$Wj)("bell",60066),bold:(0,t.$Wj)("bold",60067),book:(0,t.$Wj)("book",60068),bookmark:(0,t.$Wj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,t.$Wj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,t.$Wj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,t.$Wj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,t.$Wj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,t.$Wj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,t.$Wj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,t.$Wj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,t.$Wj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,t.$Wj)("debug-breakpoint-log-disabled",60075),briefcase:(0,t.$Wj)("briefcase",60076),broadcast:(0,t.$Wj)("broadcast",60077),browser:(0,t.$Wj)("browser",60078),bug:(0,t.$Wj)("bug",60079),calendar:(0,t.$Wj)("calendar",60080),caseSensitive:(0,t.$Wj)("case-sensitive",60081),check:(0,t.$Wj)("check",60082),checklist:(0,t.$Wj)("checklist",60083),chevronDown:(0,t.$Wj)("chevron-down",60084),chevronLeft:(0,t.$Wj)("chevron-left",60085),chevronRight:(0,t.$Wj)("chevron-right",60086),chevronUp:(0,t.$Wj)("chevron-up",60087),chromeClose:(0,t.$Wj)("chrome-close",60088),chromeMaximize:(0,t.$Wj)("chrome-maximize",60089),chromeMinimize:(0,t.$Wj)("chrome-minimize",60090),chromeRestore:(0,t.$Wj)("chrome-restore",60091),circleOutline:(0,t.$Wj)("circle-outline",60092),circle:(0,t.$Wj)("circle",60092),debugBreakpointUnverified:(0,t.$Wj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,t.$Wj)("terminal-decoration-incomplete",60092),circleSlash:(0,t.$Wj)("circle-slash",60093),circuitBoard:(0,t.$Wj)("circuit-board",60094),clearAll:(0,t.$Wj)("clear-all",60095),clippy:(0,t.$Wj)("clippy",60096),closeAll:(0,t.$Wj)("close-all",60097),cloudDownload:(0,t.$Wj)("cloud-download",60098),cloudUpload:(0,t.$Wj)("cloud-upload",60099),code:(0,t.$Wj)("code",60100),collapseAll:(0,t.$Wj)("collapse-all",60101),colorMode:(0,t.$Wj)("color-mode",60102),commentDiscussion:(0,t.$Wj)("comment-discussion",60103),creditCard:(0,t.$Wj)("credit-card",60105),dash:(0,t.$Wj)("dash",60108),dashboard:(0,t.$Wj)("dashboard",60109),database:(0,t.$Wj)("database",60110),debugContinue:(0,t.$Wj)("debug-continue",60111),debugDisconnect:(0,t.$Wj)("debug-disconnect",60112),debugPause:(0,t.$Wj)("debug-pause",60113),debugRestart:(0,t.$Wj)("debug-restart",60114),debugStart:(0,t.$Wj)("debug-start",60115),debugStepInto:(0,t.$Wj)("debug-step-into",60116),debugStepOut:(0,t.$Wj)("debug-step-out",60117),debugStepOver:(0,t.$Wj)("debug-step-over",60118),debugStop:(0,t.$Wj)("debug-stop",60119),debug:(0,t.$Wj)("debug",60120),deviceCameraVideo:(0,t.$Wj)("device-camera-video",60121),deviceCamera:(0,t.$Wj)("device-camera",60122),deviceMobile:(0,t.$Wj)("device-mobile",60123),diffAdded:(0,t.$Wj)("diff-added",60124),diffIgnored:(0,t.$Wj)("diff-ignored",60125),diffModified:(0,t.$Wj)("diff-modified",60126),diffRemoved:(0,t.$Wj)("diff-removed",60127),diffRenamed:(0,t.$Wj)("diff-renamed",60128),diff:(0,t.$Wj)("diff",60129),diffSidebyside:(0,t.$Wj)("diff-sidebyside",60129),discard:(0,t.$Wj)("discard",60130),editorLayout:(0,t.$Wj)("editor-layout",60131),emptyWindow:(0,t.$Wj)("empty-window",60132),exclude:(0,t.$Wj)("exclude",60133),extensions:(0,t.$Wj)("extensions",60134),eyeClosed:(0,t.$Wj)("eye-closed",60135),fileBinary:(0,t.$Wj)("file-binary",60136),fileCode:(0,t.$Wj)("file-code",60137),fileMedia:(0,t.$Wj)("file-media",60138),filePdf:(0,t.$Wj)("file-pdf",60139),fileSubmodule:(0,t.$Wj)("file-submodule",60140),fileSymlinkDirectory:(0,t.$Wj)("file-symlink-directory",60141),fileSymlinkFile:(0,t.$Wj)("file-symlink-file",60142),fileZip:(0,t.$Wj)("file-zip",60143),files:(0,t.$Wj)("files",60144),filter:(0,t.$Wj)("filter",60145),flame:(0,t.$Wj)("flame",60146),foldDown:(0,t.$Wj)("fold-down",60147),foldUp:(0,t.$Wj)("fold-up",60148),fold:(0,t.$Wj)("fold",60149),folderActive:(0,t.$Wj)("folder-active",60150),folderOpened:(0,t.$Wj)("folder-opened",60151),gear:(0,t.$Wj)("gear",60152),gift:(0,t.$Wj)("gift",60153),gistSecret:(0,t.$Wj)("gist-secret",60154),gist:(0,t.$Wj)("gist",60155),gitCommit:(0,t.$Wj)("git-commit",60156),gitCompare:(0,t.$Wj)("git-compare",60157),compareChanges:(0,t.$Wj)("compare-changes",60157),gitMerge:(0,t.$Wj)("git-merge",60158),githubAction:(0,t.$Wj)("github-action",60159),githubAlt:(0,t.$Wj)("github-alt",60160),globe:(0,t.$Wj)("globe",60161),grabber:(0,t.$Wj)("grabber",60162),graph:(0,t.$Wj)("graph",60163),gripper:(0,t.$Wj)("gripper",60164),heart:(0,t.$Wj)("heart",60165),home:(0,t.$Wj)("home",60166),horizontalRule:(0,t.$Wj)("horizontal-rule",60167),hubot:(0,t.$Wj)("hubot",60168),inbox:(0,t.$Wj)("inbox",60169),issueReopened:(0,t.$Wj)("issue-reopened",60171),issues:(0,t.$Wj)("issues",60172),italic:(0,t.$Wj)("italic",60173),jersey:(0,t.$Wj)("jersey",60174),json:(0,t.$Wj)("json",60175),kebabVertical:(0,t.$Wj)("kebab-vertical",60176),key:(0,t.$Wj)("key",60177),law:(0,t.$Wj)("law",60178),lightbulbAutofix:(0,t.$Wj)("lightbulb-autofix",60179),linkExternal:(0,t.$Wj)("link-external",60180),link:(0,t.$Wj)("link",60181),listOrdered:(0,t.$Wj)("list-ordered",60182),listUnordered:(0,t.$Wj)("list-unordered",60183),liveShare:(0,t.$Wj)("live-share",60184),loading:(0,t.$Wj)("loading",60185),location:(0,t.$Wj)("location",60186),mailRead:(0,t.$Wj)("mail-read",60187),mail:(0,t.$Wj)("mail",60188),markdown:(0,t.$Wj)("markdown",60189),megaphone:(0,t.$Wj)("megaphone",60190),mention:(0,t.$Wj)("mention",60191),milestone:(0,t.$Wj)("milestone",60192),gitPullRequestMilestone:(0,t.$Wj)("git-pull-request-milestone",60192),mortarBoard:(0,t.$Wj)("mortar-board",60193),move:(0,t.$Wj)("move",60194),multipleWindows:(0,t.$Wj)("multiple-windows",60195),mute:(0,t.$Wj)("mute",60196),noNewline:(0,t.$Wj)("no-newline",60197),note:(0,t.$Wj)("note",60198),octoface:(0,t.$Wj)("octoface",60199),openPreview:(0,t.$Wj)("open-preview",60200),package:(0,t.$Wj)("package",60201),paintcan:(0,t.$Wj)("paintcan",60202),pin:(0,t.$Wj)("pin",60203),play:(0,t.$Wj)("play",60204),run:(0,t.$Wj)("run",60204),plug:(0,t.$Wj)("plug",60205),preserveCase:(0,t.$Wj)("preserve-case",60206),preview:(0,t.$Wj)("preview",60207),project:(0,t.$Wj)("project",60208),pulse:(0,t.$Wj)("pulse",60209),question:(0,t.$Wj)("question",60210),quote:(0,t.$Wj)("quote",60211),radioTower:(0,t.$Wj)("radio-tower",60212),reactions:(0,t.$Wj)("reactions",60213),references:(0,t.$Wj)("references",60214),refresh:(0,t.$Wj)("refresh",60215),regex:(0,t.$Wj)("regex",60216),remoteExplorer:(0,t.$Wj)("remote-explorer",60217),remote:(0,t.$Wj)("remote",60218),remove:(0,t.$Wj)("remove",60219),replaceAll:(0,t.$Wj)("replace-all",60220),replace:(0,t.$Wj)("replace",60221),repoClone:(0,t.$Wj)("repo-clone",60222),repoForcePush:(0,t.$Wj)("repo-force-push",60223),repoPull:(0,t.$Wj)("repo-pull",60224),repoPush:(0,t.$Wj)("repo-push",60225),report:(0,t.$Wj)("report",60226),requestChanges:(0,t.$Wj)("request-changes",60227),rocket:(0,t.$Wj)("rocket",60228),rootFolderOpened:(0,t.$Wj)("root-folder-opened",60229),rootFolder:(0,t.$Wj)("root-folder",60230),rss:(0,t.$Wj)("rss",60231),ruby:(0,t.$Wj)("ruby",60232),saveAll:(0,t.$Wj)("save-all",60233),saveAs:(0,t.$Wj)("save-as",60234),save:(0,t.$Wj)("save",60235),screenFull:(0,t.$Wj)("screen-full",60236),screenNormal:(0,t.$Wj)("screen-normal",60237),searchStop:(0,t.$Wj)("search-stop",60238),server:(0,t.$Wj)("server",60240),settingsGear:(0,t.$Wj)("settings-gear",60241),settings:(0,t.$Wj)("settings",60242),shield:(0,t.$Wj)("shield",60243),smiley:(0,t.$Wj)("smiley",60244),sortPrecedence:(0,t.$Wj)("sort-precedence",60245),splitHorizontal:(0,t.$Wj)("split-horizontal",60246),splitVertical:(0,t.$Wj)("split-vertical",60247),squirrel:(0,t.$Wj)("squirrel",60248),starFull:(0,t.$Wj)("star-full",60249),starHalf:(0,t.$Wj)("star-half",60250),symbolClass:(0,t.$Wj)("symbol-class",60251),symbolColor:(0,t.$Wj)("symbol-color",60252),symbolConstant:(0,t.$Wj)("symbol-constant",60253),symbolEnumMember:(0,t.$Wj)("symbol-enum-member",60254),symbolField:(0,t.$Wj)("symbol-field",60255),symbolFile:(0,t.$Wj)("symbol-file",60256),symbolInterface:(0,t.$Wj)("symbol-interface",60257),symbolKeyword:(0,t.$Wj)("symbol-keyword",60258),symbolMisc:(0,t.$Wj)("symbol-misc",60259),symbolOperator:(0,t.$Wj)("symbol-operator",60260),symbolProperty:(0,t.$Wj)("symbol-property",60261),wrench:(0,t.$Wj)("wrench",60261),wrenchSubaction:(0,t.$Wj)("wrench-subaction",60261),symbolSnippet:(0,t.$Wj)("symbol-snippet",60262),tasklist:(0,t.$Wj)("tasklist",60263),telescope:(0,t.$Wj)("telescope",60264),textSize:(0,t.$Wj)("text-size",60265),threeBars:(0,t.$Wj)("three-bars",60266),thumbsdown:(0,t.$Wj)("thumbsdown",60267),thumbsup:(0,t.$Wj)("thumbsup",60268),tools:(0,t.$Wj)("tools",60269),triangleDown:(0,t.$Wj)("triangle-down",60270),triangleLeft:(0,t.$Wj)("triangle-left",60271),triangleRight:(0,t.$Wj)("triangle-right",60272),triangleUp:(0,t.$Wj)("triangle-up",60273),twitter:(0,t.$Wj)("twitter",60274),unfold:(0,t.$Wj)("unfold",60275),unlock:(0,t.$Wj)("unlock",60276),unmute:(0,t.$Wj)("unmute",60277),unverified:(0,t.$Wj)("unverified",60278),verified:(0,t.$Wj)("verified",60279),versions:(0,t.$Wj)("versions",60280),vmActive:(0,t.$Wj)("vm-active",60281),vmOutline:(0,t.$Wj)("vm-outline",60282),vmRunning:(0,t.$Wj)("vm-running",60283),watch:(0,t.$Wj)("watch",60284),whitespace:(0,t.$Wj)("whitespace",60285),wholeWord:(0,t.$Wj)("whole-word",60286),window:(0,t.$Wj)("window",60287),wordWrap:(0,t.$Wj)("word-wrap",60288),zoomIn:(0,t.$Wj)("zoom-in",60289),zoomOut:(0,t.$Wj)("zoom-out",60290),listFilter:(0,t.$Wj)("list-filter",60291),listFlat:(0,t.$Wj)("list-flat",60292),listSelection:(0,t.$Wj)("list-selection",60293),selection:(0,t.$Wj)("selection",60293),listTree:(0,t.$Wj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,t.$Wj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,t.$Wj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,t.$Wj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,t.$Wj)("debug-stackframe-active",60297),circleSmallFilled:(0,t.$Wj)("circle-small-filled",60298),debugStackframeDot:(0,t.$Wj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,t.$Wj)("terminal-decoration-mark",60298),debugStackframe:(0,t.$Wj)("debug-stackframe",60299),debugStackframeFocused:(0,t.$Wj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,t.$Wj)("debug-breakpoint-unsupported",60300),symbolString:(0,t.$Wj)("symbol-string",60301),debugReverseContinue:(0,t.$Wj)("debug-reverse-continue",60302),debugStepBack:(0,t.$Wj)("debug-step-back",60303),debugRestartFrame:(0,t.$Wj)("debug-restart-frame",60304),debugAlt:(0,t.$Wj)("debug-alt",60305),callIncoming:(0,t.$Wj)("call-incoming",60306),callOutgoing:(0,t.$Wj)("call-outgoing",60307),menu:(0,t.$Wj)("menu",60308),expandAll:(0,t.$Wj)("expand-all",60309),feedback:(0,t.$Wj)("feedback",60310),gitPullRequestReviewer:(0,t.$Wj)("git-pull-request-reviewer",60310),groupByRefType:(0,t.$Wj)("group-by-ref-type",60311),ungroupByRefType:(0,t.$Wj)("ungroup-by-ref-type",60312),account:(0,t.$Wj)("account",60313),gitPullRequestAssignee:(0,t.$Wj)("git-pull-request-assignee",60313),bellDot:(0,t.$Wj)("bell-dot",60314),debugConsole:(0,t.$Wj)("debug-console",60315),library:(0,t.$Wj)("library",60316),output:(0,t.$Wj)("output",60317),runAll:(0,t.$Wj)("run-all",60318),syncIgnored:(0,t.$Wj)("sync-ignored",60319),pinned:(0,t.$Wj)("pinned",60320),githubInverted:(0,t.$Wj)("github-inverted",60321),serverProcess:(0,t.$Wj)("server-process",60322),serverEnvironment:(0,t.$Wj)("server-environment",60323),pass:(0,t.$Wj)("pass",60324),issueClosed:(0,t.$Wj)("issue-closed",60324),stopCircle:(0,t.$Wj)("stop-circle",60325),playCircle:(0,t.$Wj)("play-circle",60326),record:(0,t.$Wj)("record",60327),debugAltSmall:(0,t.$Wj)("debug-alt-small",60328),vmConnect:(0,t.$Wj)("vm-connect",60329),cloud:(0,t.$Wj)("cloud",60330),merge:(0,t.$Wj)("merge",60331),export:(0,t.$Wj)("export",60332),graphLeft:(0,t.$Wj)("graph-left",60333),magnet:(0,t.$Wj)("magnet",60334),notebook:(0,t.$Wj)("notebook",60335),redo:(0,t.$Wj)("redo",60336),checkAll:(0,t.$Wj)("check-all",60337),pinnedDirty:(0,t.$Wj)("pinned-dirty",60338),passFilled:(0,t.$Wj)("pass-filled",60339),circleLargeFilled:(0,t.$Wj)("circle-large-filled",60340),circleLarge:(0,t.$Wj)("circle-large",60341),circleLargeOutline:(0,t.$Wj)("circle-large-outline",60341),combine:(0,t.$Wj)("combine",60342),gather:(0,t.$Wj)("gather",60342),table:(0,t.$Wj)("table",60343),variableGroup:(0,t.$Wj)("variable-group",60344),typeHierarchy:(0,t.$Wj)("type-hierarchy",60345),typeHierarchySub:(0,t.$Wj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,t.$Wj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,t.$Wj)("git-pull-request-create",60348),runAbove:(0,t.$Wj)("run-above",60349),runBelow:(0,t.$Wj)("run-below",60350),notebookTemplate:(0,t.$Wj)("notebook-template",60351),debugRerun:(0,t.$Wj)("debug-rerun",60352),workspaceTrusted:(0,t.$Wj)("workspace-trusted",60353),workspaceUntrusted:(0,t.$Wj)("workspace-untrusted",60354),workspaceUnknown:(0,t.$Wj)("workspace-unknown",60355),terminalCmd:(0,t.$Wj)("terminal-cmd",60356),terminalDebian:(0,t.$Wj)("terminal-debian",60357),terminalLinux:(0,t.$Wj)("terminal-linux",60358),terminalPowershell:(0,t.$Wj)("terminal-powershell",60359),terminalTmux:(0,t.$Wj)("terminal-tmux",60360),terminalUbuntu:(0,t.$Wj)("terminal-ubuntu",60361),terminalBash:(0,t.$Wj)("terminal-bash",60362),arrowSwap:(0,t.$Wj)("arrow-swap",60363),copy:(0,t.$Wj)("copy",60364),personAdd:(0,t.$Wj)("person-add",60365),filterFilled:(0,t.$Wj)("filter-filled",60366),wand:(0,t.$Wj)("wand",60367),debugLineByLine:(0,t.$Wj)("debug-line-by-line",60368),inspect:(0,t.$Wj)("inspect",60369),layers:(0,t.$Wj)("layers",60370),layersDot:(0,t.$Wj)("layers-dot",60371),layersActive:(0,t.$Wj)("layers-active",60372),compass:(0,t.$Wj)("compass",60373),compassDot:(0,t.$Wj)("compass-dot",60374),compassActive:(0,t.$Wj)("compass-active",60375),azure:(0,t.$Wj)("azure",60376),issueDraft:(0,t.$Wj)("issue-draft",60377),gitPullRequestClosed:(0,t.$Wj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,t.$Wj)("git-pull-request-draft",60379),debugAll:(0,t.$Wj)("debug-all",60380),debugCoverage:(0,t.$Wj)("debug-coverage",60381),runErrors:(0,t.$Wj)("run-errors",60382),folderLibrary:(0,t.$Wj)("folder-library",60383),debugContinueSmall:(0,t.$Wj)("debug-continue-small",60384),beakerStop:(0,t.$Wj)("beaker-stop",60385),graphLine:(0,t.$Wj)("graph-line",60386),graphScatter:(0,t.$Wj)("graph-scatter",60387),pieChart:(0,t.$Wj)("pie-chart",60388),bracket:(0,t.$Wj)("bracket",60175),bracketDot:(0,t.$Wj)("bracket-dot",60389),bracketError:(0,t.$Wj)("bracket-error",60390),lockSmall:(0,t.$Wj)("lock-small",60391),azureDevops:(0,t.$Wj)("azure-devops",60392),verifiedFilled:(0,t.$Wj)("verified-filled",60393),newline:(0,t.$Wj)("newline",60394),layout:(0,t.$Wj)("layout",60395),layoutActivitybarLeft:(0,t.$Wj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,t.$Wj)("layout-activitybar-right",60397),layoutPanelLeft:(0,t.$Wj)("layout-panel-left",60398),layoutPanelCenter:(0,t.$Wj)("layout-panel-center",60399),layoutPanelJustify:(0,t.$Wj)("layout-panel-justify",60400),layoutPanelRight:(0,t.$Wj)("layout-panel-right",60401),layoutPanel:(0,t.$Wj)("layout-panel",60402),layoutSidebarLeft:(0,t.$Wj)("layout-sidebar-left",60403),layoutSidebarRight:(0,t.$Wj)("layout-sidebar-right",60404),layoutStatusbar:(0,t.$Wj)("layout-statusbar",60405),layoutMenubar:(0,t.$Wj)("layout-menubar",60406),layoutCentered:(0,t.$Wj)("layout-centered",60407),target:(0,t.$Wj)("target",60408),indent:(0,t.$Wj)("indent",60409),recordSmall:(0,t.$Wj)("record-small",60410),errorSmall:(0,t.$Wj)("error-small",60411),terminalDecorationError:(0,t.$Wj)("terminal-decoration-error",60411),arrowCircleDown:(0,t.$Wj)("arrow-circle-down",60412),arrowCircleLeft:(0,t.$Wj)("arrow-circle-left",60413),arrowCircleRight:(0,t.$Wj)("arrow-circle-right",60414),arrowCircleUp:(0,t.$Wj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,t.$Wj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,t.$Wj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,t.$Wj)("layout-sidebar-left-off",60418),blank:(0,t.$Wj)("blank",60419),heartFilled:(0,t.$Wj)("heart-filled",60420),map:(0,t.$Wj)("map",60421),mapHorizontal:(0,t.$Wj)("map-horizontal",60421),foldHorizontal:(0,t.$Wj)("fold-horizontal",60421),mapFilled:(0,t.$Wj)("map-filled",60422),mapHorizontalFilled:(0,t.$Wj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,t.$Wj)("fold-horizontal-filled",60422),circleSmall:(0,t.$Wj)("circle-small",60423),bellSlash:(0,t.$Wj)("bell-slash",60424),bellSlashDot:(0,t.$Wj)("bell-slash-dot",60425),commentUnresolved:(0,t.$Wj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,t.$Wj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,t.$Wj)("git-pull-request-new-changes",60428),searchFuzzy:(0,t.$Wj)("search-fuzzy",60429),commentDraft:(0,t.$Wj)("comment-draft",60430),send:(0,t.$Wj)("send",60431),sparkle:(0,t.$Wj)("sparkle",60432),insert:(0,t.$Wj)("insert",60433),mic:(0,t.$Wj)("mic",60434),thumbsdownFilled:(0,t.$Wj)("thumbsdown-filled",60435),thumbsupFilled:(0,t.$Wj)("thumbsup-filled",60436),coffee:(0,t.$Wj)("coffee",60437),snake:(0,t.$Wj)("snake",60438),game:(0,t.$Wj)("game",60439),vr:(0,t.$Wj)("vr",60440),chip:(0,t.$Wj)("chip",60441),piano:(0,t.$Wj)("piano",60442),music:(0,t.$Wj)("music",60443),micFilled:(0,t.$Wj)("mic-filled",60444),repoFetch:(0,t.$Wj)("repo-fetch",60445),copilot:(0,t.$Wj)("copilot",60446),lightbulbSparkle:(0,t.$Wj)("lightbulb-sparkle",60447),robot:(0,t.$Wj)("robot",60448),sparkleFilled:(0,t.$Wj)("sparkle-filled",60449),diffSingle:(0,t.$Wj)("diff-single",60450),diffMultiple:(0,t.$Wj)("diff-multiple",60451),surroundWith:(0,t.$Wj)("surround-with",60452),share:(0,t.$Wj)("share",60453),gitStash:(0,t.$Wj)("git-stash",60454),gitStashApply:(0,t.$Wj)("git-stash-apply",60455),gitStashPop:(0,t.$Wj)("git-stash-pop",60456),vscode:(0,t.$Wj)("vscode",60457),vscodeInsiders:(0,t.$Wj)("vscode-insiders",60458),codeOss:(0,t.$Wj)("code-oss",60459),runCoverage:(0,t.$Wj)("run-coverage",60460),runAllCoverage:(0,t.$Wj)("run-all-coverage",60461),coverage:(0,t.$Wj)("coverage",60462),githubProject:(0,t.$Wj)("github-project",60463),mapVertical:(0,t.$Wj)("map-vertical",60464),foldVertical:(0,t.$Wj)("fold-vertical",60464),mapVerticalFilled:(0,t.$Wj)("map-vertical-filled",60465),foldVerticalFilled:(0,t.$Wj)("fold-vertical-filled",60465),goToSearch:(0,t.$Wj)("go-to-search",60466),percentage:(0,t.$Wj)("percentage",60467),sortPercentage:(0,t.$Wj)("sort-percentage",60467),attach:(0,t.$Wj)("attach",60468)}}),ne(ie[47],re([0,1,28,46]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$2j=i.$1j=void 0,i.$Zj=T;function T(){return Object.values(i.$2j)}i.$1j={dialogError:(0,t.$Wj)("dialog-error","error"),dialogWarning:(0,t.$Wj)("dialog-warning","warning"),dialogInfo:(0,t.$Wj)("dialog-info","info"),dialogClose:(0,t.$Wj)("dialog-close","close"),treeItemExpanded:(0,t.$Wj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,t.$Wj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,t.$Wj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,t.$Wj)("tree-filter-clear","close"),treeItemLoading:(0,t.$Wj)("tree-item-loading","loading"),menuSelection:(0,t.$Wj)("menu-selection","check"),menuSubmenu:(0,t.$Wj)("menu-submenu","chevron-right"),menuBarMore:(0,t.$Wj)("menubar-more","more"),scrollbarButtonLeft:(0,t.$Wj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,t.$Wj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,t.$Wj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,t.$Wj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,t.$Wj)("toolbar-more","more"),quickInputBack:(0,t.$Wj)("quick-input-back","arrow-left"),dropDownButton:(0,t.$Wj)("drop-down-button",60084),symbolCustomColor:(0,t.$Wj)("symbol-customcolor",60252),exportIcon:(0,t.$Wj)("export",60332),workspaceUnspecified:(0,t.$Wj)("workspace-unspecified",60355),newLine:(0,t.$Wj)("newline",60394),thumbsDownFilled:(0,t.$Wj)("thumbsdown-filled",60435),thumbsUpFilled:(0,t.$Wj)("thumbsup-filled",60436),gitFetch:(0,t.$Wj)("git-fetch",60445),lightbulbSparkleAutofix:(0,t.$Wj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,t.$Wj)("debug-breakpoint-pending",60377)},i.$2j={...n.$Yj,...i.$1j}}),ne(ie[18],re([0,1,27]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$ao=n,i.$bo=T,i.$co=L,i.$do=a,i.$eo=u,i.$fo=c,i.$go=$,i.$ho=m,i.$io=w,i.$jo=e,i.$ko=b,i.$lo=N,i.$mo=_;function n(A){if(!A||typeof A!="object"||A instanceof RegExp)return A;const E=Array.isArray(A)?[]:{};return Object.entries(A).forEach(([v,h])=>{E[v]=h&&typeof h=="object"?n(h):h}),E}function T(A){if(!A||typeof A!="object")return A;const E=[A];for(;E.length>0;){const v=E.shift();Object.freeze(v);for(const h in v)if(g.call(v,h)){const o=v[h];typeof o=="object"&&!Object.isFrozen(o)&&!(0,t.$fg)(o)&&E.push(o)}}return A}const g=Object.prototype.hasOwnProperty;function L(A,E){return d(A,E,new Set)}function d(A,E,v){if((0,t.$lg)(A))return A;const h=E(A);if(typeof h<"u")return h;if(Array.isArray(A)){const o=[];for(const r of A)o.push(d(r,E,v));return o}if((0,t.$eg)(A)){if(v.has(A))throw new Error("Cannot clone recursive data-structure");v.add(A);const o={};for(const r in A)g.call(A,r)&&(o[r]=d(A[r],E,v));return v.delete(A),o}return A}function a(A,E,v=!0){return(0,t.$eg)(A)?((0,t.$eg)(E)&&Object.keys(E).forEach(h=>{h in A?v&&((0,t.$eg)(A[h])&&(0,t.$eg)(E[h])?a(A[h],E[h],v):A[h]=E[h]):A[h]=E[h]}),A):E}function u(A,E){if(A===E)return!0;if(A==null||E===null||E===void 0||typeof A!=typeof E||typeof A!="object"||Array.isArray(A)!==Array.isArray(E))return!1;let v,h;if(Array.isArray(A)){if(A.length!==E.length)return!1;for(v=0;v<A.length;v++)if(!u(A[v],E[v]))return!1}else{const o=[];for(h in A)o.push(h);o.sort();const r=[];for(h in E)r.push(h);if(r.sort(),!u(o,r))return!1;for(v=0;v<o.length;v++)if(!u(A[o[v]],E[o[v]]))return!1}return!0}function c(A){const E=new Set;return JSON.stringify(A,(v,h)=>{if((0,t.$eg)(h)||Array.isArray(h)){if(E.has(h))return"[Circular]";E.add(h)}return typeof h=="bigint"?`[BigInt ${h.toString()}]`:h})}function $(A,E){const v=Object.create(null);return!A||!E||Object.keys(E).forEach(o=>{const r=A[o],l=E[o];u(r,l)||(v[o]=l)}),v}function m(A,E){const v=E.toLowerCase(),h=Object.keys(A).find(o=>o.toLowerCase()===v);return h?A[h]:A[E]}function w(A,E){const v=Object.create(null);for(const[h,o]of Object.entries(A))E(h,o)&&(v[h]=o);return v}function e(A){let E=[];for(;Object.prototype!==A;)E=E.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return E}function b(A){const E=[];for(const v of e(A))typeof A[v]=="function"&&E.push(v);return E}function N(A,E){const v=o=>function(){const r=Array.prototype.slice.call(arguments,0);return E(o,r)},h={};for(const o of A)h[o]=v(o);return h}function _(A,E){const v={};for(const[h,o]of Object.entries(A))v[h]=E(o,h);return v}}),ne(ie[14],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Constants=void 0,i.$$e=n,i.$_e=T;var t;(function(g){g[g.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",g[g.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",g[g.MAX_UINT_8=255]="MAX_UINT_8",g[g.MAX_UINT_16=65535]="MAX_UINT_16",g[g.MAX_UINT_32=4294967295]="MAX_UINT_32",g[g.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(t||(i.Constants=t={}));function n(g){return g<0?0:g>t.MAX_UINT_8?t.MAX_UINT_8:g|0}function T(g){return g<0?0:g>t.MAX_UINT_32?t.MAX_UINT_32:g|0}}),ne(ie[8],re([0,1,45,3,41,14]),function(x,i,t,n,T,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$bg=i.$ag=i.$_f=i.GraphemeBreakType=i.$2f=i.$Tf=i.$Mf=i.$Lf=void 0,i.$af=L,i.$bf=a,i.$cf=c,i.$df=$,i.$ef=m,i.$ff=w,i.$gf=e,i.$hf=b,i.$if=N,i.$jf=_,i.$kf=A,i.$lf=E,i.$mf=v,i.$nf=h,i.$of=o,i.$pf=r,i.$qf=l,i.$rf=f,i.$sf=D,i.$tf=R,i.$uf=p,i.$vf=M,i.$wf=j,i.$xf=S,i.$yf=I,i.$zf=W,i.$Af=P,i.$Bf=H,i.$Cf=B,i.$Df=y,i.$Ef=Y,i.$Ff=J,i.$Gf=G,i.$Hf=Z,i.$If=C,i.$Jf=F,i.$Kf=X,i.$Nf=s,i.$Of=Te,i.$Pf=ke,i.$Qf=Ve,i.$Rf=q,i.$Sf=U,i.$Uf=Q,i.$Vf=ee,i.$Wf=he,i.$Xf=de,i.$Yf=ve,i.$Zf=_e,i.$1f=te,i.$3f=ae,i.$4f=ue,i.$5f=ce,i.$6f=me,i.$7f=$e,i.$8f=Ne,i.$9f=Ae,i.$0f=Oe,i.$$f=ze;function L(k){return!k||typeof k!="string"?!0:k.trim().length===0}const d=/{(\d+)}/g;function a(k,...O){return O.length===0?k:k.replace(d,function(z,K){const le=parseInt(K,10);return isNaN(le)||le<0||le>=O.length?z:O[le]})}const u=/{([^}]+)}/g;function c(k,O){return Object.keys(O).length===0?k:k.replace(u,(z,K)=>O[K]??z)}function $(k){return k.replace(/[<>"'&]/g,O=>{switch(O){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return O})}function m(k){return k.replace(/[<>&]/g,function(O){switch(O){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return O}})}function w(k){return k.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function e(k,O){let z=0,K=k.indexOf(O);for(;K!==-1;)z++,K=k.indexOf(O,K+O.length);return z}function b(k,O,z="\u2026"){return k.length<=O?k:`${k.substr(0,O)}${z}`}function N(k,O,z="\u2026"){if(k.length<=O)return k;const K=Math.ceil(O/2)-z.length/2,le=Math.floor(O/2)-z.length/2;return`${k.substr(0,K)}${z}${k.substr(k.length-le)}`}function _(k,O=" "){const z=A(k,O);return E(z,O)}function A(k,O){if(!k||!O)return k;const z=O.length;if(z===0||k.length===0)return k;let K=0;for(;k.indexOf(O,K)===K;)K=K+z;return k.substring(K)}function E(k,O){if(!k||!O)return k;const z=O.length,K=k.length;if(z===0||K===0)return k;let le=K,be=-1;for(;be=k.lastIndexOf(O,le-1),!(be===-1||be+z!==le);){if(be===0)return"";le=be}return k.substring(0,le)}function v(k){return k.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function h(k){return k.replace(/\*/g,"")}function o(k,O,z={}){if(!k)throw new Error("Cannot create regex from empty string");O||(k=w(k)),z.wholeWord&&(/\B/.test(k.charAt(0))||(k="\\b"+k),/\B/.test(k.charAt(k.length-1))||(k=k+"\\b"));let K="";return z.global&&(K+="g"),z.matchCase||(K+="i"),z.multiline&&(K+="m"),z.unicode&&(K+="u"),new RegExp(k,K)}function r(k){return k.source==="^"||k.source==="^$"||k.source==="$"||k.source==="^\\s*$"?!1:!!(k.exec("")&&k.lastIndex===0)}function l(k){return k.split(/\r\n|\r|\n/)}function f(k){const O=[],z=k.split(/(\r\n|\r|\n)/);for(let K=0;K<Math.ceil(z.length/2);K++)O.push(z[2*K]+(z[2*K+1]??""));return O}function D(k){for(let O=0,z=k.length;O<z;O++){const K=k.charCodeAt(O);if(K!==n.CharCode.Space&&K!==n.CharCode.Tab)return O}return-1}function R(k,O=0,z=k.length){for(let K=O;K<z;K++){const le=k.charCodeAt(K);if(le!==n.CharCode.Space&&le!==n.CharCode.Tab)return k.substring(O,K)}return k.substring(O,z)}function p(k,O=k.length-1){for(let z=O;z>=0;z--){const K=k.charCodeAt(z);if(K!==n.CharCode.Space&&K!==n.CharCode.Tab)return z}return-1}function M(k,O,z){const K=[];let le=0;for(const be of k.matchAll(O)){if(K.push(k.slice(le,be.index)),be.index===void 0)throw new Error("match.index should be defined");le=be.index+be[0].length,K.push(z(be[0],...be.slice(1),be.index,k,be.groups))}return K.push(k.slice(le)),Promise.all(K).then(be=>be.join(""))}function j(k,O){return k<O?-1:k>O?1:0}function S(k,O,z=0,K=k.length,le=0,be=O.length){for(;z<K&&le<be;z++,le++){const Me=k.charCodeAt(z),We=O.charCodeAt(le);if(Me<We)return-1;if(Me>We)return 1}const Re=K-z,Ie=be-le;return Re<Ie?-1:Re>Ie?1:0}function I(k,O){return W(k,O,0,k.length,0,O.length)}function W(k,O,z=0,K=k.length,le=0,be=O.length){for(;z<K&&le<be;z++,le++){let Me=k.charCodeAt(z),We=O.charCodeAt(le);if(Me===We)continue;if(Me>=128||We>=128)return S(k.toLowerCase(),O.toLowerCase(),z,K,le,be);H(Me)&&(Me-=32),H(We)&&(We-=32);const pe=Me-We;if(pe!==0)return pe}const Re=K-z,Ie=be-le;return Re<Ie?-1:Re>Ie?1:0}function P(k){return k>=n.CharCode.Digit0&&k<=n.CharCode.Digit9}function H(k){return k>=n.CharCode.a&&k<=n.CharCode.z}function B(k){return k>=n.CharCode.A&&k<=n.CharCode.Z}function y(k,O){return k.length===O.length&&W(k,O)===0}function Y(k,O){const z=O.length;return O.length>k.length?!1:W(k,O,0,z)===0}function J(k,O){const z=Math.min(k.length,O.length);let K;for(K=0;K<z;K++)if(k.charCodeAt(K)!==O.charCodeAt(K))return K;return z}function G(k,O){const z=Math.min(k.length,O.length);let K;const le=k.length-1,be=O.length-1;for(K=0;K<z;K++)if(k.charCodeAt(le-K)!==O.charCodeAt(be-K))return K;return z}function Z(k){return 55296<=k&&k<=56319}function C(k){return 56320<=k&&k<=57343}function F(k,O){return(k-55296<<10)+(O-56320)+65536}function X(k,O,z){const K=k.charCodeAt(z);if(Z(K)&&z+1<O){const le=k.charCodeAt(z+1);if(C(le))return F(K,le)}return K}function fe(k,O){const z=k.charCodeAt(O-1);if(C(z)&&O>1){const K=k.charCodeAt(O-2);if(Z(K))return F(K,z)}return z}class oe{get offset(){return this.e}constructor(O,z=0){this.c=O,this.d=O.length,this.e=z}setOffset(O){this.e=O}prevCodePoint(){const O=fe(this.c,this.e);return this.e-=O>=g.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,O}nextCodePoint(){const O=X(this.c,this.d,this.e);return this.e+=O>=g.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,O}eol(){return this.e>=this.d}}i.$Lf=oe;class we{get offset(){return this.c.offset}constructor(O,z=0){this.c=new oe(O,z)}nextGraphemeLength(){const O=je.getInstance(),z=this.c,K=z.offset;let le=O.getGraphemeBreakType(z.nextCodePoint());for(;!z.eol();){const be=z.offset,Re=O.getGraphemeBreakType(z.nextCodePoint());if(Be(le,Re)){z.setOffset(be);break}le=Re}return z.offset-K}prevGraphemeLength(){const O=je.getInstance(),z=this.c,K=z.offset;let le=O.getGraphemeBreakType(z.prevCodePoint());for(;z.offset>0;){const be=z.offset,Re=O.getGraphemeBreakType(z.prevCodePoint());if(Be(Re,le)){z.setOffset(be);break}le=Re}return K-z.offset}eol(){return this.c.eol()}}i.$Mf=we;function s(k,O){return new we(k,O).nextGraphemeLength()}function Te(k,O){return new we(k,O).prevGraphemeLength()}function ke(k,O){O>0&&C(k.charCodeAt(O))&&O--;const z=O+s(k,O);return[z-Te(k,z),z]}function Ve(k){const O=new we(k);let z=0;for(;!O.eol();)z++,O.nextGraphemeLength();return z}let De;function ye(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function q(k){return De||(De=ye()),De.test(k)}const V=/^[\t\n\r\x20-\x7E]*$/;function U(k){return V.test(k)}i.$Tf=/[\u2028\u2029]/;function Q(k){return i.$Tf.test(k)}function ee(k){return k>=11904&&k<=55215||k>=63744&&k<=64255||k>=65281&&k<=65374}function he(k){return k>=127462&&k<=127487||k===8986||k===8987||k===9200||k===9203||k>=9728&&k<=10175||k===11088||k===11093||k>=127744&&k<=128591||k>=128640&&k<=128764||k>=128992&&k<=129008||k>=129280&&k<=129535||k>=129648&&k<=129782}function de(k,O,z=""){const K=k.trimStart();if(K.length<O)return K;const le=/\b/g;let be=0;for(;le.test(K)&&!(K.length-le.lastIndex<O);)be=le.lastIndex,le.lastIndex+=1;return be===0?K:z+K.substring(be).trimStart()}const Ee=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*ve(k){let O=0;for(const z of k.matchAll(Ee))O!==z.index&&(yield{isCode:!1,str:k.substring(O,z.index)}),yield{isCode:!0,str:z[0]},O=z.index+z[0].length;O!==k.length&&(yield{isCode:!1,str:k.substring(O)})}function _e(k){return k&&(k=k.replace(Ee,"")),k}const se=/\\\[.*?\\\]/g;function te(k){return _e(k).replace(se,"")}i.$2f=String.fromCharCode(n.CharCode.UTF8_BOM);function ae(k){return!!(k&&k.length>0&&k.charCodeAt(0)===n.CharCode.UTF8_BOM)}function ue(k){return ae(k)?k.substr(1):k}function ce(k,O){if(!k||!O||k.length<O.length)return!1;const z=O.length,K=k.toLowerCase();let le=0,be=-1;for(;le<z;){const Re=K.indexOf(O[le],be+1);if(Re<0)return!1;be=Re,le++}return!0}function me(k,O=!1){return k?(O&&(k=k.replace(/\\./g,"")),k.toLowerCase()!==k):!1}function $e(k){return k.charAt(0).toUpperCase()+k.slice(1)}function Ne(k,O=1){if(O===0)return"";let z=-1;do z=k.indexOf(`
`,z+1),O--;while(O>0&&z>=0);return z===-1?k:(k[z-1]==="\r"&&z--,k.substr(0,z))}function Ae(k){const O=n.CharCode.Z-n.CharCode.A+1;return k=k%(2*O),k<O?String.fromCharCode(n.CharCode.a+k):String.fromCharCode(n.CharCode.A+k-O)}function Oe(k){return je.getInstance().getGraphemeBreakType(k)}function Be(k,O){return k===ge.Other?O!==ge.Extend&&O!==ge.SpacingMark:k===ge.CR&&O===ge.LF?!1:k===ge.Control||k===ge.CR||k===ge.LF||O===ge.Control||O===ge.CR||O===ge.LF?!0:!(k===ge.L&&(O===ge.L||O===ge.V||O===ge.LV||O===ge.LVT)||(k===ge.LV||k===ge.V)&&(O===ge.V||O===ge.T)||(k===ge.LVT||k===ge.T)&&O===ge.T||O===ge.Extend||O===ge.ZWJ||O===ge.SpacingMark||k===ge.Prepend||k===ge.ZWJ&&O===ge.Extended_Pictographic||k===ge.Regional_Indicator&&O===ge.Regional_Indicator)}var ge;(function(k){k[k.Other=0]="Other",k[k.Prepend=1]="Prepend",k[k.CR=2]="CR",k[k.LF=3]="LF",k[k.Control=4]="Control",k[k.Extend=5]="Extend",k[k.Regional_Indicator=6]="Regional_Indicator",k[k.SpacingMark=7]="SpacingMark",k[k.L=8]="L",k[k.V=9]="V",k[k.T=10]="T",k[k.LV=11]="LV",k[k.LVT=12]="LVT",k[k.ZWJ=13]="ZWJ",k[k.Extended_Pictographic=14]="Extended_Pictographic"})(ge||(i.GraphemeBreakType=ge={}));class je{static{this.c=null}static getInstance(){return je.c||(je.c=new je),je.c}constructor(){this.d=xe()}getGraphemeBreakType(O){if(O<32)return O===n.CharCode.LineFeed?ge.LF:O===n.CharCode.CarriageReturn?ge.CR:ge.Control;if(O<127)return ge.Other;const z=this.d,K=z.length/3;let le=1;for(;le<=K;)if(O<z[3*le])le=2*le;else if(O>z[3*le+1])le=2*le+1;else return z[3*le+2];return ge.Other}}function xe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(k,O){if(k===0)return 0;const z=Xe(k,O);if(z!==void 0)return z;const K=new oe(O,k);return K.prevCodePoint(),K.offset}function Xe(k,O){const z=new oe(O,k);let K=z.prevCodePoint();for(;Ce(K)||K===He.emojiVariantSelector||K===He.enclosingKeyCap;){if(z.offset===0)return;K=z.prevCodePoint()}if(!he(K))return;let le=z.offset;return le>0&&z.prevCodePoint()===He.zwj&&(le=z.offset),le}function Ce(k){return 127995<=k&&k<=127999}var He;(function(k){k[k.zwj=8205]="zwj",k[k.emojiVariantSelector=65039]="emojiVariantSelector",k[k.enclosingKeyCap=8419]="enclosingKeyCap"})(He||(He={})),i.$_f="\xA0";class qe{static{this.c=new T.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new t.$9e({getCacheKey:JSON.stringify},O=>{function z(pe){const Se=new Map;for(let Fe=0;Fe<pe.length;Fe+=2)Se.set(pe[Fe],pe[Fe+1]);return Se}function K(pe,Se){const Fe=new Map(pe);for(const[Ge,Ye]of Se)Fe.set(Ge,Ye);return Fe}function le(pe,Se){if(!pe)return Se;const Fe=new Map;for(const[Ge,Ye]of pe)Se.has(Ge)&&Fe.set(Ge,Ye);return Fe}const be=this.c.value;let Re=O.filter(pe=>!pe.startsWith("_")&&pe in be);Re.length===0&&(Re=["_default"]);let Ie;for(const pe of Re){const Se=z(be[pe]);Ie=le(Ie,Se)}const Me=z(be._common),We=K(Me,Ie);return new qe(We)})}static getInstance(O){return qe.d.get(Array.from(O))}static{this.e=new T.$T(()=>Object.keys(qe.c.value).filter(O=>!O.startsWith("_")))}static getLocales(){return qe.e.value}constructor(O){this.f=O}isAmbiguous(O){return this.f.has(O)}containsAmbiguousCharacter(O){for(let z=0;z<O.length;z++){const K=O.codePointAt(z);if(typeof K=="number"&&this.isAmbiguous(K))return!0}return!1}getPrimaryConfusable(O){return this.f.get(O)}getConfusableCodePoints(){return new Set(this.f.keys())}}i.$ag=qe;class Ue{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ue.c())),this.d}static isInvisibleCharacter(O){return Ue.e().has(O)}static containsInvisibleCharacter(O){for(let z=0;z<O.length;z++){const K=O.codePointAt(z);if(typeof K=="number"&&Ue.isInvisibleCharacter(K))return!0}return!1}static get codePoints(){return Ue.e()}}i.$bg=Ue}),ne(ie[48],re([0,1,8]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$wj=i.$uj=void 0,i.$qj=n,i.$rj=T,i.$sj=g,i.$tj=d,i.$vj=b,t=Pe(t);function n(_){return T(_,0)}function T(_,A){switch(typeof _){case"object":return _===null?g(349,A):Array.isArray(_)?a(_,A):u(_,A);case"string":return d(_,A);case"boolean":return L(_,A);case"number":return g(_,A);case"undefined":return g(937,A);default:return g(617,A)}}function g(_,A){return(A<<5)-A+_|0}function L(_,A){return g(_?433:863,A)}function d(_,A){A=g(149417,A);for(let E=0,v=_.length;E<v;E++)A=g(_.charCodeAt(E),A);return A}function a(_,A){return A=g(104579,A),_.reduce((E,v)=>T(v,E),A)}function u(_,A){return A=g(181387,A),Object.keys(_).sort().reduce((E,v)=>(E=d(v,E),T(_[v],E)),A)}class c{constructor(){this.g=0}get value(){return this.g}hash(A){return this.g=T(A,this.g),this.g}}i.$uj=c;var $;(function(_){_[_.BLOCK_SIZE=64]="BLOCK_SIZE",_[_.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})($||($={}));function m(_,A,E=32){const v=E-A,h=~((1<<v)-1);return(_<<A|(h&_)>>>v)>>>0}function w(_,A=0,E=_.byteLength,v=0){for(let h=0;h<E;h++)_[A+h]=v}function e(_,A,E="0"){for(;_.length<A;)_=E+_;return _}function b(_,A=32){return _ instanceof ArrayBuffer?Array.from(new Uint8Array(_)).map(E=>E.toString(16).padStart(2,"0")).join(""):e((_>>>0).toString(16),A/4)}class N{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array($.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(A){const E=A.length;if(E===0)return;const v=this.p;let h=this.r,o=this.u,r,l;for(o!==0?(r=o,l=-1,o=0):(r=A.charCodeAt(0),l=0);;){let f=r;if(t.$Hf(r))if(l+1<E){const D=A.charCodeAt(l+1);t.$If(D)?(l++,f=t.$Jf(r,D)):f=$.UNICODE_REPLACEMENT}else{o=r;break}else t.$If(r)&&(f=$.UNICODE_REPLACEMENT);if(h=this.w(v,h,f),l++,l<E)r=A.charCodeAt(l);else break}this.r=h,this.u=o}w(A,E,v){return v<128?A[E++]=v:v<2048?(A[E++]=192|(v&1984)>>>6,A[E++]=128|(v&63)>>>0):v<65536?(A[E++]=224|(v&61440)>>>12,A[E++]=128|(v&4032)>>>6,A[E++]=128|(v&63)>>>0):(A[E++]=240|(v&1835008)>>>18,A[E++]=128|(v&258048)>>>12,A[E++]=128|(v&4032)>>>6,A[E++]=128|(v&63)>>>0),E>=$.BLOCK_SIZE&&(this.y(),E-=$.BLOCK_SIZE,this.t+=$.BLOCK_SIZE,A[0]=A[$.BLOCK_SIZE+0],A[1]=A[$.BLOCK_SIZE+1],A[2]=A[$.BLOCK_SIZE+2]),E}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,$.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),b(this.h)+b(this.l)+b(this.m)+b(this.n)+b(this.o)}x(){this.p[this.r++]=128,w(this.p,this.r),this.r>56&&(this.y(),w(this.p));const A=8*this.t;this.q.setUint32(56,Math.floor(A/4294967296),!1),this.q.setUint32(60,A%4294967296,!1),this.y()}y(){const A=N.g,E=this.q;for(let p=0;p<64;p+=4)A.setUint32(p,E.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)A.setUint32(p,m(A.getUint32(p-12,!1)^A.getUint32(p-32,!1)^A.getUint32(p-56,!1)^A.getUint32(p-64,!1),1),!1);let v=this.h,h=this.l,o=this.m,r=this.n,l=this.o,f,D,R;for(let p=0;p<80;p++)p<20?(f=h&o|~h&r,D=1518500249):p<40?(f=h^o^r,D=1859775393):p<60?(f=h&o|h&r|o&r,D=2400959708):(f=h^o^r,D=3395469782),R=m(v,5)+f+l+D+A.getUint32(p*4,!1)&4294967295,l=r,r=o,o=m(h,30),h=v,v=R;this.h=this.h+v&4294967295,this.l=this.l+h&4294967295,this.m=this.m+o&4294967295,this.n=this.n+r&4294967295,this.o=this.o+l&4294967295}}i.$wj=N}),ne(ie[29],re([0,1,39,48,14]),function(x,i,t,n,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Qt=i.$Ot=void 0,i.$Pt=L;class g{constructor(w){this.a=w}getElements(){const w=this.a,e=new Int32Array(w.length);for(let b=0,N=w.length;b<N;b++)e[b]=w.charCodeAt(b);return e}}i.$Ot=g;function L(m,w,e){return new $(new g(m),new g(w)).ComputeDiff(e).changes}class d{static Assert(w,e){if(!w)throw new Error(e)}}class a{static Copy(w,e,b,N,_){for(let A=0;A<_;A++)b[N+A]=w[e+A]}static Copy2(w,e,b,N,_){for(let A=0;A<_;A++)b[N+A]=w[e+A]}}var u;(function(m){m[m.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(u||(u={}));class c{constructor(){this.a=[],this.b=T.Constants.MAX_SAFE_SMALL_INTEGER,this.c=T.Constants.MAX_SAFE_SMALL_INTEGER,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new t.$Nt(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=T.Constants.MAX_SAFE_SMALL_INTEGER,this.c=T.Constants.MAX_SAFE_SMALL_INTEGER}AddOriginalElement(w,e){this.b=Math.min(this.b,w),this.c=Math.min(this.c,e),this.d++}AddModifiedElement(w,e){this.b=Math.min(this.b,w),this.c=Math.min(this.c,e),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class ${constructor(w,e,b=null){this.a=b,this.b=w,this.c=e;const[N,_,A]=$.o(w),[E,v,h]=$.o(e);this.d=A&&h,this.e=N,this.f=_,this.g=E,this.h=v,this.k=[],this.m=[]}static n(w){return w.length>0&&typeof w[0]=="string"}static o(w){const e=w.getElements();if($.n(e)){const b=new Int32Array(e.length);for(let N=0,_=e.length;N<_;N++)b[N]=(0,n.$tj)(e[N],0);return[e,b,!0]}return e instanceof Int32Array?[[],e,!1]:[[],new Int32Array(e),!1]}p(w,e){return this.f[w]!==this.h[e]?!1:this.d?this.e[w]===this.g[e]:!0}q(w,e){if(!this.p(w,e))return!1;const b=$.r(this.b,w),N=$.r(this.c,e);return b===N}static r(w,e){return typeof w.getStrictElement=="function"?w.getStrictElement(e):null}s(w,e){return this.f[w]!==this.f[e]?!1:this.d?this.e[w]===this.e[e]:!0}u(w,e){return this.h[w]!==this.h[e]?!1:this.d?this.g[w]===this.g[e]:!0}ComputeDiff(w){return this.v(0,this.f.length-1,0,this.h.length-1,w)}v(w,e,b,N,_){const A=[!1];let E=this.w(w,e,b,N,A);return _&&(E=this.z(E)),{quitEarly:A[0],changes:E}}w(w,e,b,N,_){for(_[0]=!1;w<=e&&b<=N&&this.p(w,b);)w++,b++;for(;e>=w&&N>=b&&this.p(e,N);)e--,N--;if(w>e||b>N){let r;return b<=N?(d.Assert(w===e+1,"originalStart should only be one more than originalEnd"),r=[new t.$Nt(w,0,b,N-b+1)]):w<=e?(d.Assert(b===N+1,"modifiedStart should only be one more than modifiedEnd"),r=[new t.$Nt(w,e-w+1,b,0)]):(d.Assert(w===e+1,"originalStart should only be one more than originalEnd"),d.Assert(b===N+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const A=[0],E=[0],v=this.y(w,e,b,N,A,E,_),h=A[0],o=E[0];if(v!==null)return v;if(!_[0]){const r=this.w(w,h,b,o,_);let l=[];return _[0]?l=[new t.$Nt(h+1,e-(h+1)+1,o+1,N-(o+1)+1)]:l=this.w(h+1,e,o+1,N,_),this.H(r,l)}return[new t.$Nt(w,e-w+1,b,N-b+1)]}x(w,e,b,N,_,A,E,v,h,o,r,l,f,D,R,p,M,j){let S=null,I=null,W=new c,P=e,H=b,B=f[0]-p[0]-N,y=T.Constants.MIN_SAFE_SMALL_INTEGER,Y=this.k.length-1;do{const J=B+w;J===P||J<H&&h[J-1]<h[J+1]?(r=h[J+1],D=r-B-N,r<y&&W.MarkNextChange(),y=r,W.AddModifiedElement(r+1,D),B=J+1-w):(r=h[J-1]+1,D=r-B-N,r<y&&W.MarkNextChange(),y=r-1,W.AddOriginalElement(r,D+1),B=J-1-w),Y>=0&&(h=this.k[Y],w=h[0],P=1,H=h.length-1)}while(--Y>=-1);if(S=W.getReverseChanges(),j[0]){let J=f[0]+1,G=p[0]+1;if(S!==null&&S.length>0){const Z=S[S.length-1];J=Math.max(J,Z.getOriginalEnd()),G=Math.max(G,Z.getModifiedEnd())}I=[new t.$Nt(J,l-J+1,G,R-G+1)]}else{W=new c,P=A,H=E,B=f[0]-p[0]-v,y=T.Constants.MAX_SAFE_SMALL_INTEGER,Y=M?this.m.length-1:this.m.length-2;do{const J=B+_;J===P||J<H&&o[J-1]>=o[J+1]?(r=o[J+1]-1,D=r-B-v,r>y&&W.MarkNextChange(),y=r+1,W.AddOriginalElement(r+1,D+1),B=J+1-_):(r=o[J-1],D=r-B-v,r>y&&W.MarkNextChange(),y=r,W.AddModifiedElement(r+1,D+1),B=J-1-_),Y>=0&&(o=this.m[Y],_=o[0],P=1,H=o.length-1)}while(--Y>=-1);I=W.getChanges()}return this.H(S,I)}y(w,e,b,N,_,A,E){let v=0,h=0,o=0,r=0,l=0,f=0;w--,b--,_[0]=0,A[0]=0,this.k=[],this.m=[];const D=e-w+(N-b),R=D+1,p=new Int32Array(R),M=new Int32Array(R),j=N-b,S=e-w,I=w-b,W=e-N,H=(S-j)%2===0;p[j]=w,M[S]=e,E[0]=!1;for(let B=1;B<=D/2+1;B++){let y=0,Y=0;o=this.J(j-B,B,j,R),r=this.J(j+B,B,j,R);for(let G=o;G<=r;G+=2){G===o||G<r&&p[G-1]<p[G+1]?v=p[G+1]:v=p[G-1]+1,h=v-(G-j)-I;const Z=v;for(;v<e&&h<N&&this.p(v+1,h+1);)v++,h++;if(p[G]=v,v+h>y+Y&&(y=v,Y=h),!H&&Math.abs(G-S)<=B-1&&v>=M[G])return _[0]=v,A[0]=h,Z<=M[G]&&u.MaxDifferencesHistory>0&&B<=u.MaxDifferencesHistory+1?this.x(j,o,r,I,S,l,f,W,p,M,v,e,_,h,N,A,H,E):null}const J=(y-w+(Y-b)-B)/2;if(this.a!==null&&!this.a(y,J))return E[0]=!0,_[0]=y,A[0]=Y,J>0&&u.MaxDifferencesHistory>0&&B<=u.MaxDifferencesHistory+1?this.x(j,o,r,I,S,l,f,W,p,M,v,e,_,h,N,A,H,E):(w++,b++,[new t.$Nt(w,e-w+1,b,N-b+1)]);l=this.J(S-B,B,S,R),f=this.J(S+B,B,S,R);for(let G=l;G<=f;G+=2){G===l||G<f&&M[G-1]>=M[G+1]?v=M[G+1]-1:v=M[G-1],h=v-(G-S)-W;const Z=v;for(;v>w&&h>b&&this.p(v,h);)v--,h--;if(M[G]=v,H&&Math.abs(G-j)<=B&&v<=p[G])return _[0]=v,A[0]=h,Z>=p[G]&&u.MaxDifferencesHistory>0&&B<=u.MaxDifferencesHistory+1?this.x(j,o,r,I,S,l,f,W,p,M,v,e,_,h,N,A,H,E):null}if(B<=u.MaxDifferencesHistory){let G=new Int32Array(r-o+2);G[0]=j-o+1,a.Copy2(p,o,G,1,r-o+1),this.k.push(G),G=new Int32Array(f-l+2),G[0]=S-l+1,a.Copy2(M,l,G,1,f-l+1),this.m.push(G)}}return this.x(j,o,r,I,S,l,f,W,p,M,v,e,_,h,N,A,H,E)}z(w){for(let e=0;e<w.length;e++){const b=w[e],N=e<w.length-1?w[e+1].originalStart:this.f.length,_=e<w.length-1?w[e+1].modifiedStart:this.h.length,A=b.originalLength>0,E=b.modifiedLength>0;for(;b.originalStart+b.originalLength<N&&b.modifiedStart+b.modifiedLength<_&&(!A||this.s(b.originalStart,b.originalStart+b.originalLength))&&(!E||this.u(b.modifiedStart,b.modifiedStart+b.modifiedLength));){const h=this.q(b.originalStart,b.modifiedStart);if(this.q(b.originalStart+b.originalLength,b.modifiedStart+b.modifiedLength)&&!h)break;b.originalStart++,b.modifiedStart++}const v=[null];if(e<w.length-1&&this.I(w[e],w[e+1],v)){w[e]=v[0],w.splice(e+1,1),e--;continue}}for(let e=w.length-1;e>=0;e--){const b=w[e];let N=0,_=0;if(e>0){const r=w[e-1];N=r.originalStart+r.originalLength,_=r.modifiedStart+r.modifiedLength}const A=b.originalLength>0,E=b.modifiedLength>0;let v=0,h=this.G(b.originalStart,b.originalLength,b.modifiedStart,b.modifiedLength);for(let r=1;;r++){const l=b.originalStart-r,f=b.modifiedStart-r;if(l<N||f<_||A&&!this.s(l,l+b.originalLength)||E&&!this.u(f,f+b.modifiedLength))break;const R=(l===N&&f===_?5:0)+this.G(l,b.originalLength,f,b.modifiedLength);R>h&&(h=R,v=r)}b.originalStart-=v,b.modifiedStart-=v;const o=[null];if(e>0&&this.I(w[e-1],w[e],o)){w[e-1]=o[0],w.splice(e,1),e++;continue}}if(this.d)for(let e=1,b=w.length;e<b;e++){const N=w[e-1],_=w[e],A=_.originalStart-N.originalStart-N.originalLength,E=N.originalStart,v=_.originalStart+_.originalLength,h=v-E,o=N.modifiedStart,r=_.modifiedStart+_.modifiedLength,l=r-o;if(A<5&&h<20&&l<20){const f=this.A(E,h,o,l,A);if(f){const[D,R]=f;(D!==N.originalStart+N.originalLength||R!==N.modifiedStart+N.modifiedLength)&&(N.originalLength=D-N.originalStart,N.modifiedLength=R-N.modifiedStart,_.originalStart=D+A,_.modifiedStart=R+A,_.originalLength=v-_.originalStart,_.modifiedLength=r-_.modifiedStart)}}}return w}A(w,e,b,N,_){if(e<_||N<_)return null;const A=w+e-_+1,E=b+N-_+1;let v=0,h=0,o=0;for(let r=w;r<A;r++)for(let l=b;l<E;l++){const f=this.B(r,l,_);f>0&&f>v&&(v=f,h=r,o=l)}return v>0?[h,o]:null}B(w,e,b){let N=0;for(let _=0;_<b;_++){if(!this.p(w+_,e+_))return 0;N+=this.e[w+_].length}return N}C(w){return w<=0||w>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[w])}D(w,e){if(this.C(w)||this.C(w-1))return!0;if(e>0){const b=w+e;if(this.C(b-1)||this.C(b))return!0}return!1}E(w){return w<=0||w>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[w])}F(w,e){if(this.E(w)||this.E(w-1))return!0;if(e>0){const b=w+e;if(this.E(b-1)||this.E(b))return!0}return!1}G(w,e,b,N){const _=this.D(w,e)?1:0,A=this.F(b,N)?1:0;return _+A}H(w,e){const b=[];if(w.length===0||e.length===0)return e.length>0?e:w;if(this.I(w[w.length-1],e[0],b)){const N=new Array(w.length+e.length-1);return a.Copy(w,0,N,0,w.length-1),N[w.length-1]=b[0],a.Copy(e,1,N,w.length,e.length-1),N}else{const N=new Array(w.length+e.length);return a.Copy(w,0,N,0,w.length),a.Copy(e,0,N,w.length,e.length),N}}I(w,e,b){if(d.Assert(w.originalStart<=e.originalStart,"Left change is not less than or equal to right change"),d.Assert(w.modifiedStart<=e.modifiedStart,"Left change is not less than or equal to right change"),w.originalStart+w.originalLength>=e.originalStart||w.modifiedStart+w.modifiedLength>=e.modifiedStart){const N=w.originalStart;let _=w.originalLength;const A=w.modifiedStart;let E=w.modifiedLength;return w.originalStart+w.originalLength>=e.originalStart&&(_=e.originalStart+e.originalLength-w.originalStart),w.modifiedStart+w.modifiedLength>=e.modifiedStart&&(E=e.modifiedStart+e.modifiedLength-w.modifiedStart),b[0]=new t.$Nt(N,_,A,E),!0}else return b[0]=null,!1}J(w,e,b,N){if(w>=0&&w<N)return w;const _=b,A=N-b-1,E=e%2===0;if(w<0){const v=_%2===0;return E===v?0:1}else{const v=A%2===0;return E===v?N-1:N-2}}}i.$Qt=$}),ne(ie[19],re([0,1,3,42,44,17]),function(x,i,t,n,T,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.URI=void 0,i.$uc=N,i.$vc=o,T=Pe(T);const L=/^\w[\w\d+.-]*$/,d=/^\//,a=/^\/\//;function u(R,p){if(!R.scheme&&p)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${R.authority}", path: "${R.path}", query: "${R.query}", fragment: "${R.fragment}"}`);if(R.scheme&&!L.test(R.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(R.path){if(R.authority){if(!d.test(R.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(a.test(R.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function c(R,p){return!R&&!p?"file":R}function $(R,p){switch(R){case"https":case"http":case"file":p?p[0]!==w&&(p=w+p):p=w;break}return p}const m="",w="/",e=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{static isUri(p){return p instanceof b?!0:p?typeof p.authority=="string"&&typeof p.fragment=="string"&&typeof p.path=="string"&&typeof p.query=="string"&&typeof p.scheme=="string"&&typeof p.fsPath=="string"&&typeof p.with=="function"&&typeof p.toString=="function":!1}constructor(p,M,j,S,I,W=!1){typeof p=="object"?(this.scheme=p.scheme||m,this.authority=p.authority||m,this.path=p.path||m,this.query=p.query||m,this.fragment=p.fragment||m):(this.scheme=c(p,W),this.authority=M||m,this.path=$(this.scheme,j||m),this.query=S||m,this.fragment=I||m,u(this,W))}get fsPath(){return o(this,!1)}with(p){if(!p)return this;let{scheme:M,authority:j,path:S,query:I,fragment:W}=p;return M===void 0?M=this.scheme:M===null&&(M=m),j===void 0?j=this.authority:j===null&&(j=m),S===void 0?S=this.path:S===null&&(S=m),I===void 0?I=this.query:I===null&&(I=m),W===void 0?W=this.fragment:W===null&&(W=m),M===this.scheme&&j===this.authority&&S===this.path&&I===this.query&&W===this.fragment?this:new A(M,j,S,I,W)}static parse(p,M=!1){const j=e.exec(p);return j?new A(j[2]||m,D(j[4]||m),D(j[5]||m),D(j[7]||m),D(j[9]||m),M):new A(m,m,m,m,m)}static file(p){let M=m;if(g.$j&&(p=p.replace(/\\/g,w)),p[0]===w&&p[1]===w){const j=p.indexOf(w,2);j===-1?(M=p.substring(2),p=w):(M=p.substring(2,j),p=p.substring(j)||w)}return new A("file",M,p,m,m)}static from(p,M){return new A(p.scheme,p.authority,p.path,p.query,p.fragment,M)}static joinPath(p,...M){if(!p.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let j;return g.$j&&p.scheme==="file"?j=b.file(T.$ec.join(o(p,!0),...M)).path:j=T.$fc.join(p.path,...M),p.with({path:j})}toString(p=!1){return r(this,p)}toJSON(){return this}static revive(p){if(p){if(p instanceof b)return p;{const M=new A(p);return M._formatted=p.external??null,M._fsPath=p._sep===_?p.fsPath??null:null,M}}else return p}}i.URI=b;function N(R){return!R||typeof R!="object"?!1:typeof R.scheme=="string"&&(typeof R.authority=="string"||typeof R.authority>"u")&&(typeof R.path=="string"||typeof R.path>"u")&&(typeof R.query=="string"||typeof R.query>"u")&&(typeof R.fragment=="string"||typeof R.fragment>"u")}const _=g.$j?1:void 0;class A extends b{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(p=!1){return p?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const p={$mid:n.MarshalledId.Uri};return this._fsPath&&(p.fsPath=this._fsPath,p._sep=_),this._formatted&&(p.external=this._formatted),this.path&&(p.path=this.path),this.scheme&&(p.scheme=this.scheme),this.authority&&(p.authority=this.authority),this.query&&(p.query=this.query),this.fragment&&(p.fragment=this.fragment),p}}const E={[t.CharCode.Colon]:"%3A",[t.CharCode.Slash]:"%2F",[t.CharCode.QuestionMark]:"%3F",[t.CharCode.Hash]:"%23",[t.CharCode.OpenSquareBracket]:"%5B",[t.CharCode.CloseSquareBracket]:"%5D",[t.CharCode.AtSign]:"%40",[t.CharCode.ExclamationMark]:"%21",[t.CharCode.DollarSign]:"%24",[t.CharCode.Ampersand]:"%26",[t.CharCode.SingleQuote]:"%27",[t.CharCode.OpenParen]:"%28",[t.CharCode.CloseParen]:"%29",[t.CharCode.Asterisk]:"%2A",[t.CharCode.Plus]:"%2B",[t.CharCode.Comma]:"%2C",[t.CharCode.Semicolon]:"%3B",[t.CharCode.Equals]:"%3D",[t.CharCode.Space]:"%20"};function v(R,p,M){let j,S=-1;for(let I=0;I<R.length;I++){const W=R.charCodeAt(I);if(W>=t.CharCode.a&&W<=t.CharCode.z||W>=t.CharCode.A&&W<=t.CharCode.Z||W>=t.CharCode.Digit0&&W<=t.CharCode.Digit9||W===t.CharCode.Dash||W===t.CharCode.Period||W===t.CharCode.Underline||W===t.CharCode.Tilde||p&&W===t.CharCode.Slash||M&&W===t.CharCode.OpenSquareBracket||M&&W===t.CharCode.CloseSquareBracket||M&&W===t.CharCode.Colon)S!==-1&&(j+=encodeURIComponent(R.substring(S,I)),S=-1),j!==void 0&&(j+=R.charAt(I));else{j===void 0&&(j=R.substr(0,I));const P=E[W];P!==void 0?(S!==-1&&(j+=encodeURIComponent(R.substring(S,I)),S=-1),j+=P):S===-1&&(S=I)}}return S!==-1&&(j+=encodeURIComponent(R.substring(S))),j!==void 0?j:R}function h(R){let p;for(let M=0;M<R.length;M++){const j=R.charCodeAt(M);j===t.CharCode.Hash||j===t.CharCode.QuestionMark?(p===void 0&&(p=R.substr(0,M)),p+=E[j]):p!==void 0&&(p+=R[M])}return p!==void 0?p:R}function o(R,p){let M;return R.authority&&R.path.length>1&&R.scheme==="file"?M=`//${R.authority}${R.path}`:R.path.charCodeAt(0)===t.CharCode.Slash&&(R.path.charCodeAt(1)>=t.CharCode.A&&R.path.charCodeAt(1)<=t.CharCode.Z||R.path.charCodeAt(1)>=t.CharCode.a&&R.path.charCodeAt(1)<=t.CharCode.z)&&R.path.charCodeAt(2)===t.CharCode.Colon?p?M=R.path.substr(1):M=R.path[1].toLowerCase()+R.path.substr(2):M=R.path,g.$j&&(M=M.replace(/\//g,"\\")),M}function r(R,p){const M=p?h:v;let j="",{scheme:S,authority:I,path:W,query:P,fragment:H}=R;if(S&&(j+=S,j+=":"),(I||S==="file")&&(j+=w,j+=w),I){let B=I.indexOf("@");if(B!==-1){const y=I.substr(0,B);I=I.substr(B+1),B=y.lastIndexOf(":"),B===-1?j+=M(y,!1,!1):(j+=M(y.substr(0,B),!1,!1),j+=":",j+=M(y.substr(B+1),!1,!0)),j+="@"}I=I.toLowerCase(),B=I.lastIndexOf(":"),B===-1?j+=M(I,!1,!0):(j+=M(I.substr(0,B),!1,!0),j+=I.substr(B))}if(W){if(W.length>=3&&W.charCodeAt(0)===t.CharCode.Slash&&W.charCodeAt(2)===t.CharCode.Colon){const B=W.charCodeAt(1);B>=t.CharCode.A&&B<=t.CharCode.Z&&(W=`/${String.fromCharCode(B+32)}:${W.substr(3)}`)}else if(W.length>=2&&W.charCodeAt(1)===t.CharCode.Colon){const B=W.charCodeAt(0);B>=t.CharCode.A&&B<=t.CharCode.Z&&(W=`${String.fromCharCode(B+32)}:${W.substr(2)}`)}j+=M(W,!0,!1)}return P&&(j+="?",j+=M(P,!1,!1)),H&&(j+="#",j+=p?H:v(H,!1,!1)),j}function l(R){try{return decodeURIComponent(R)}catch{return R.length>3?R.substr(0,3)+l(R.substr(3)):R}}const f=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function D(R){return R.match(f)?R.replace(f,p=>l(p)):R}}),ne(ie[76],re([0,1,4,13,12,18,17,8]),function(x,i,t,n,T,g,L,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SimpleWorkerServer=i.SimpleWorkerClient=void 0,i.logOnceWebWorkerWarning=c,i.create=r,d=Pe(d);const a="$initialize";let u=!1;function c(l){L.$p&&(u||(u=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(l.message))}var $;(function(l){l[l.Request=0]="Request",l[l.Reply=1]="Reply",l[l.SubscribeEvent=2]="SubscribeEvent",l[l.Event=3]="Event",l[l.UnsubscribeEvent=4]="UnsubscribeEvent"})($||($={}));class m{constructor(f,D,R,p){this.vsWorker=f,this.req=D,this.method=R,this.args=p,this.type=$.Request}}class w{constructor(f,D,R,p){this.vsWorker=f,this.seq=D,this.res=R,this.err=p,this.type=$.Reply}}class e{constructor(f,D,R,p){this.vsWorker=f,this.req=D,this.eventName=R,this.arg=p,this.type=$.SubscribeEvent}}class b{constructor(f,D,R){this.vsWorker=f,this.req=D,this.event=R,this.type=$.Event}}class N{constructor(f,D){this.vsWorker=f,this.req=D,this.type=$.UnsubscribeEvent}}class _{constructor(f){this.a=-1,this.g=f,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(f){this.a=f}sendMessage(f,D){const R=String(++this.b);return new Promise((p,M)=>{this.c[R]={resolve:p,reject:M},this.o(new m(this.a,R,f,D))})}listen(f,D){let R=null;const p=new n.$je({onWillAddFirstListener:()=>{R=String(++this.b),this.d.set(R,p),this.o(new e(this.a,R,f,D))},onDidRemoveLastListener:()=>{this.d.delete(R),this.o(new N(this.a,R)),R=null}});return p.event}handleMessage(f){!f||!f.vsWorker||this.a!==-1&&f.vsWorker!==this.a||this.h(f)}h(f){switch(f.type){case $.Reply:return this.j(f);case $.Request:return this.k(f);case $.SubscribeEvent:return this.l(f);case $.Event:return this.m(f);case $.UnsubscribeEvent:return this.n(f)}}j(f){if(!this.c[f.seq]){console.warn("Got reply to unknown seq");return}const D=this.c[f.seq];if(delete this.c[f.seq],f.err){let R=f.err;f.err.$isError&&(R=new Error,R.name=f.err.name,R.message=f.err.message,R.stack=f.err.stack),D.reject(R);return}D.resolve(f.res)}k(f){const D=f.req;this.g.handleMessage(f.method,f.args).then(p=>{this.o(new w(this.a,D,p,void 0))},p=>{p.detail instanceof Error&&(p.detail=(0,t.$1)(p.detail)),this.o(new w(this.a,D,void 0,(0,t.$1)(p)))})}l(f){const D=f.req,R=this.g.handleEvent(f.eventName,f.arg)(p=>{this.o(new b(this.a,D,p))});this.f.set(D,R)}m(f){if(!this.d.has(f.req)){console.warn("Got event for unknown req");return}this.d.get(f.req).fire(f.event)}n(f){if(!this.f.has(f.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(f.req).dispose(),this.f.delete(f.req)}o(f){const D=[];if(f.type===$.Request)for(let R=0;R<f.args.length;R++)f.args[R]instanceof ArrayBuffer&&D.push(f.args[R]);else f.type===$.Reply&&f.res instanceof ArrayBuffer&&D.push(f.res);this.g.sendMessage(f,D)}}class A extends T.$Tc{constructor(f,D,R){super();let p=null;this.a=this.B(f.create("vs/base/common/worker/simpleWorker",P=>{this.c.handleMessage(P)},P=>{p?.(P)})),this.c=new _({sendMessage:(P,H)=>{this.a.postMessage(P,H)},handleMessage:(P,H)=>{if(typeof R[P]!="function")return Promise.reject(new Error("Missing method "+P+" on main thread host."));try{return Promise.resolve(R[P].apply(R,H))}catch(B){return Promise.reject(B)}},handleEvent:(P,H)=>{if(v(P)){const B=R[P].call(R,H);if(typeof B!="function")throw new Error(`Missing dynamic event ${P} on main thread host.`);return B}if(E(P)){const B=R[P];if(typeof B!="function")throw new Error(`Missing event ${P} on main thread host.`);return B}throw new Error(`Malformed event name ${P}`)}}),this.c.setWorkerId(this.a.getId());let M=null;const j=globalThis.require;typeof j<"u"&&typeof j.getConfig=="function"?M=j.getConfig():typeof globalThis.requirejs<"u"&&(M=globalThis.requirejs.s.contexts._.config);const S=(0,g.$ko)(R);this.b=this.c.sendMessage(a,[this.a.getId(),JSON.parse(JSON.stringify(M)),D,S]);const I=(P,H)=>this.g(P,H),W=(P,H)=>this.c.listen(P,H);this.f=new Promise((P,H)=>{p=H,this.b.then(B=>{P(h(B,I,W))},B=>{H(B),this.h("Worker failed to load "+D,B)})})}getProxyObject(){return this.f}g(f,D){return new Promise((R,p)=>{this.b.then(()=>{this.c.sendMessage(f,D).then(R,p)},p)})}h(f,D){console.error(f),console.info(D)}}i.SimpleWorkerClient=A;function E(l){return l[0]==="o"&&l[1]==="n"&&d.$Cf(l.charCodeAt(2))}function v(l){return/^onDynamic/.test(l)&&d.$Cf(l.charCodeAt(9))}function h(l,f,D){const R=j=>function(){const S=Array.prototype.slice.call(arguments,0);return f(j,S)},p=j=>function(S){return D(j,S)},M={};for(const j of l){if(v(j)){M[j]=p(j);continue}if(E(j)){M[j]=D(j,void 0);continue}M[j]=R(j)}return M}class o{constructor(f,D){this.a=D,this.b=null,this.c=new _({sendMessage:(R,p)=>{f(R,p)},handleMessage:(R,p)=>this.d(R,p),handleEvent:(R,p)=>this.f(R,p)})}onmessage(f){this.c.handleMessage(f)}d(f,D){if(f===a)return this.g(D[0],D[1],D[2],D[3]);if(!this.b||typeof this.b[f]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+f));try{return Promise.resolve(this.b[f].apply(this.b,D))}catch(R){return Promise.reject(R)}}f(f,D){if(!this.b)throw new Error("Missing requestHandler");if(v(f)){const R=this.b[f].call(this.b,D);if(typeof R!="function")throw new Error(`Missing dynamic event ${f} on request handler.`);return R}if(E(f)){const R=this.b[f];if(typeof R!="function")throw new Error(`Missing event ${f} on request handler.`);return R}throw new Error(`Malformed event name ${f}`)}g(f,D,R,p){this.c.setWorkerId(f);const S=h(p,(I,W)=>this.c.sendMessage(I,W),(I,W)=>this.c.listen(I,W));return this.a?(this.b=this.a(S),Promise.resolve((0,g.$ko)(this.b))):(D&&(typeof D.baseUrl<"u"&&delete D.baseUrl,typeof D.paths<"u"&&typeof D.paths.vs<"u"&&delete D.paths.vs,typeof D.trustedTypesPolicy<"u"&&delete D.trustedTypesPolicy,D.catchError=!0,globalThis.require.config(D)),new Promise((I,W)=>{(globalThis.require||x)([R],H=>{if(this.b=H.create(S),!this.b){W(new Error("No RequestHandler!"));return}I((0,g.$ko)(this.b))},W)}))}}i.SimpleWorkerServer=o;function r(l){return new o(l,null)}}),ne(ie[30],re([0,1,14]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$du=i.$cu=void 0;class n{constructor(d){const a=(0,t.$$e)(d);this.c=a,this.a=n.d(a),this.b=new Map}static d(d){const a=new Uint8Array(256);return a.fill(d),a}set(d,a){const u=(0,t.$$e)(a);d>=0&&d<256?this.a[d]=u:this.b.set(d,u)}get(d){return d>=0&&d<256?this.a[d]:this.b.get(d)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}i.$cu=n;var T;(function(L){L[L.False=0]="False",L[L.True=1]="True"})(T||(T={}));class g{constructor(){this.a=new n(T.False)}add(d){this.a.set(d,T.True)}has(d){return this.a.get(d)===T.True}clear(){return this.a.clear()}}i.$du=g}),ne(ie[6],re([0,1,4]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$St=i.$Rt=void 0;class n{static addRange(L,d){let a=0;for(;a<d.length&&d[a].endExclusive<L.start;)a++;let u=a;for(;u<d.length&&d[u].start<=L.endExclusive;)u++;if(a===u)d.splice(a,0,L);else{const c=Math.min(L.start,d[a].start),$=Math.max(L.endExclusive,d[u-1].endExclusive);d.splice(a,u-a,new n(c,$))}}static tryCreate(L,d){if(!(L>d))return new n(L,d)}static ofLength(L){return new n(0,L)}static ofStartAndLength(L,d){return new n(L,L+d)}constructor(L,d){if(this.start=L,this.endExclusive=d,L>d)throw new t.$bb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(L){return new n(this.start+L,this.endExclusive+L)}deltaStart(L){return new n(this.start+L,this.endExclusive)}deltaEnd(L){return new n(this.start,this.endExclusive+L)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(L){return this.start===L.start&&this.endExclusive===L.endExclusive}containsRange(L){return this.start<=L.start&&L.endExclusive<=this.endExclusive}contains(L){return this.start<=L&&L<this.endExclusive}join(L){return new n(Math.min(this.start,L.start),Math.max(this.endExclusive,L.endExclusive))}intersect(L){const d=Math.max(this.start,L.start),a=Math.min(this.endExclusive,L.endExclusive);if(d<=a)return new n(d,a)}intersects(L){const d=Math.max(this.start,L.start),a=Math.min(this.endExclusive,L.endExclusive);return d<a}intersectsOrTouches(L){const d=Math.max(this.start,L.start),a=Math.min(this.endExclusive,L.endExclusive);return d<=a}isBefore(L){return this.endExclusive<=L.start}isAfter(L){return this.start>=L.endExclusive}slice(L){return L.slice(this.start,this.endExclusive)}substring(L){return L.substring(this.start,this.endExclusive)}clip(L){if(this.isEmpty)throw new t.$bb(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,L))}clipCyclic(L){if(this.isEmpty)throw new t.$bb(`Invalid clipping range: ${this.toString()}`);return L<this.start?this.endExclusive-(this.start-L)%this.length:L>=this.endExclusive?this.start+(L-this.start)%this.length:L}map(L){const d=[];for(let a=this.start;a<this.endExclusive;a++)d.push(L(a));return d}forEach(L){for(let d=this.start;d<this.endExclusive;d++)L(d)}}i.$Rt=n;class T{constructor(){this.a=[]}addRange(L){let d=0;for(;d<this.a.length&&this.a[d].endExclusive<L.start;)d++;let a=d;for(;a<this.a.length&&this.a[a].start<=L.endExclusive;)a++;if(d===a)this.a.splice(d,0,L);else{const u=Math.min(L.start,this.a[d].start),c=Math.max(L.endExclusive,this.a[a-1].endExclusive);this.a.splice(d,a-d,new n(u,c))}}toString(){return this.a.map(L=>L.toString()).join(", ")}intersectsStrict(L){let d=0;for(;d<this.a.length&&this.a[d].endExclusive<=L.start;)d++;return d<this.a.length&&this.a[d].start<L.endExclusive}intersectWithRange(L){const d=new T;for(const a of this.a){const u=a.intersect(L);u&&d.addRange(u)}return d}intersectWithRangeLength(L){return this.intersectWithRange(L).length}get length(){return this.a.reduce((L,d)=>L+d.length,0)}}i.$St=T}),ne(ie[5],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Jt=void 0;class t{constructor(T,g){this.lineNumber=T,this.column=g}with(T=this.lineNumber,g=this.column){return T===this.lineNumber&&g===this.column?this:new t(T,g)}delta(T=0,g=0){return this.with(this.lineNumber+T,this.column+g)}equals(T){return t.equals(this,T)}static equals(T,g){return!T&&!g?!0:!!T&&!!g&&T.lineNumber===g.lineNumber&&T.column===g.column}isBefore(T){return t.isBefore(this,T)}static isBefore(T,g){return T.lineNumber<g.lineNumber?!0:g.lineNumber<T.lineNumber?!1:T.column<g.column}isBeforeOrEqual(T){return t.isBeforeOrEqual(this,T)}static isBeforeOrEqual(T,g){return T.lineNumber<g.lineNumber?!0:g.lineNumber<T.lineNumber?!1:T.column<=g.column}static compare(T,g){const L=T.lineNumber|0,d=g.lineNumber|0;if(L===d){const a=T.column|0,u=g.column|0;return a-u}return L-d}clone(){return new t(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(T){return new t(T.lineNumber,T.column)}static isIPosition(T){return T&&typeof T.lineNumber=="number"&&typeof T.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}i.$Jt=t}),ne(ie[2],re([0,1,5]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Kt=void 0;class n{constructor(g,L,d,a){g>d||g===d&&L>a?(this.startLineNumber=d,this.startColumn=a,this.endLineNumber=g,this.endColumn=L):(this.startLineNumber=g,this.startColumn=L,this.endLineNumber=d,this.endColumn=a)}isEmpty(){return n.isEmpty(this)}static isEmpty(g){return g.startLineNumber===g.endLineNumber&&g.startColumn===g.endColumn}containsPosition(g){return n.containsPosition(this,g)}static containsPosition(g,L){return!(L.lineNumber<g.startLineNumber||L.lineNumber>g.endLineNumber||L.lineNumber===g.startLineNumber&&L.column<g.startColumn||L.lineNumber===g.endLineNumber&&L.column>g.endColumn)}static strictContainsPosition(g,L){return!(L.lineNumber<g.startLineNumber||L.lineNumber>g.endLineNumber||L.lineNumber===g.startLineNumber&&L.column<=g.startColumn||L.lineNumber===g.endLineNumber&&L.column>=g.endColumn)}containsRange(g){return n.containsRange(this,g)}static containsRange(g,L){return!(L.startLineNumber<g.startLineNumber||L.endLineNumber<g.startLineNumber||L.startLineNumber>g.endLineNumber||L.endLineNumber>g.endLineNumber||L.startLineNumber===g.startLineNumber&&L.startColumn<g.startColumn||L.endLineNumber===g.endLineNumber&&L.endColumn>g.endColumn)}strictContainsRange(g){return n.strictContainsRange(this,g)}static strictContainsRange(g,L){return!(L.startLineNumber<g.startLineNumber||L.endLineNumber<g.startLineNumber||L.startLineNumber>g.endLineNumber||L.endLineNumber>g.endLineNumber||L.startLineNumber===g.startLineNumber&&L.startColumn<=g.startColumn||L.endLineNumber===g.endLineNumber&&L.endColumn>=g.endColumn)}plusRange(g){return n.plusRange(this,g)}static plusRange(g,L){let d,a,u,c;return L.startLineNumber<g.startLineNumber?(d=L.startLineNumber,a=L.startColumn):L.startLineNumber===g.startLineNumber?(d=L.startLineNumber,a=Math.min(L.startColumn,g.startColumn)):(d=g.startLineNumber,a=g.startColumn),L.endLineNumber>g.endLineNumber?(u=L.endLineNumber,c=L.endColumn):L.endLineNumber===g.endLineNumber?(u=L.endLineNumber,c=Math.max(L.endColumn,g.endColumn)):(u=g.endLineNumber,c=g.endColumn),new n(d,a,u,c)}intersectRanges(g){return n.intersectRanges(this,g)}static intersectRanges(g,L){let d=g.startLineNumber,a=g.startColumn,u=g.endLineNumber,c=g.endColumn;const $=L.startLineNumber,m=L.startColumn,w=L.endLineNumber,e=L.endColumn;return d<$?(d=$,a=m):d===$&&(a=Math.max(a,m)),u>w?(u=w,c=e):u===w&&(c=Math.min(c,e)),d>u||d===u&&a>c?null:new n(d,a,u,c)}equalsRange(g){return n.equalsRange(this,g)}static equalsRange(g,L){return!g&&!L?!0:!!g&&!!L&&g.startLineNumber===L.startLineNumber&&g.startColumn===L.startColumn&&g.endLineNumber===L.endLineNumber&&g.endColumn===L.endColumn}getEndPosition(){return n.getEndPosition(this)}static getEndPosition(g){return new t.$Jt(g.endLineNumber,g.endColumn)}getStartPosition(){return n.getStartPosition(this)}static getStartPosition(g){return new t.$Jt(g.startLineNumber,g.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(g,L){return new n(this.startLineNumber,this.startColumn,g,L)}setStartPosition(g,L){return new n(g,L,this.endLineNumber,this.endColumn)}collapseToStart(){return n.collapseToStart(this)}static collapseToStart(g){return new n(g.startLineNumber,g.startColumn,g.startLineNumber,g.startColumn)}collapseToEnd(){return n.collapseToEnd(this)}static collapseToEnd(g){return new n(g.endLineNumber,g.endColumn,g.endLineNumber,g.endColumn)}delta(g){return new n(this.startLineNumber+g,this.startColumn,this.endLineNumber+g,this.endColumn)}static fromPositions(g,L=g){return new n(g.lineNumber,g.column,L.lineNumber,L.column)}static lift(g){return g?new n(g.startLineNumber,g.startColumn,g.endLineNumber,g.endColumn):null}static isIRange(g){return g&&typeof g.startLineNumber=="number"&&typeof g.startColumn=="number"&&typeof g.endLineNumber=="number"&&typeof g.endColumn=="number"}static areIntersectingOrTouching(g,L){return!(g.endLineNumber<L.startLineNumber||g.endLineNumber===L.startLineNumber&&g.endColumn<L.startColumn||L.endLineNumber<g.startLineNumber||L.endLineNumber===g.startLineNumber&&L.endColumn<g.startColumn)}static areIntersecting(g,L){return!(g.endLineNumber<L.startLineNumber||g.endLineNumber===L.startLineNumber&&g.endColumn<=L.startColumn||L.endLineNumber<g.startLineNumber||L.endLineNumber===g.startLineNumber&&L.endColumn<=g.startColumn)}static compareRangesUsingStarts(g,L){if(g&&L){const u=g.startLineNumber|0,c=L.startLineNumber|0;if(u===c){const $=g.startColumn|0,m=L.startColumn|0;if($===m){const w=g.endLineNumber|0,e=L.endLineNumber|0;if(w===e){const b=g.endColumn|0,N=L.endColumn|0;return b-N}return w-e}return $-m}return u-c}return(g?1:0)-(L?1:0)}static compareRangesUsingEnds(g,L){return g.endLineNumber===L.endLineNumber?g.endColumn===L.endColumn?g.startLineNumber===L.startLineNumber?g.startColumn-L.startColumn:g.startLineNumber-L.startLineNumber:g.endColumn-L.endColumn:g.endLineNumber-L.endLineNumber}static spansMultipleLines(g){return g.endLineNumber>g.startLineNumber}toJSON(){return this}}i.$Kt=n}),ne(ie[49],re([0,1,2]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Lt=void 0;class n{static insert(g,L){return{range:new t.$Kt(g.lineNumber,g.column,g.lineNumber,g.column),text:L,forceMoveMarkers:!0}}static delete(g){return{range:g,text:null}}static replace(g,L){return{range:g,text:L}}static replaceMove(g,L){return{range:g,text:L,forceMoveMarkers:!0}}}i.$Lt=n}),ne(ie[15],re([0,1,4,6,2,9]),function(x,i,t,n,T,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Ut=i.$Tt=void 0;class L{static fromRange(u){return new L(u.startLineNumber,u.endLineNumber)}static fromRangeInclusive(u){return new L(u.startLineNumber,u.endLineNumber+1)}static subtract(u,c){return c?u.startLineNumber<c.startLineNumber&&c.endLineNumberExclusive<u.endLineNumberExclusive?[new L(u.startLineNumber,c.startLineNumber),new L(c.endLineNumberExclusive,u.endLineNumberExclusive)]:c.startLineNumber<=u.startLineNumber&&u.endLineNumberExclusive<=c.endLineNumberExclusive?[]:c.endLineNumberExclusive<u.endLineNumberExclusive?[new L(Math.max(c.endLineNumberExclusive,u.startLineNumber),u.endLineNumberExclusive)]:[new L(u.startLineNumber,Math.min(c.startLineNumber,u.endLineNumberExclusive))]:[u]}static joinMany(u){if(u.length===0)return[];let c=new d(u[0].slice());for(let $=1;$<u.length;$++)c=c.getUnion(new d(u[$].slice()));return c.ranges}static join(u){if(u.length===0)throw new t.$bb("lineRanges cannot be empty");let c=u[0].startLineNumber,$=u[0].endLineNumberExclusive;for(let m=1;m<u.length;m++)c=Math.min(c,u[m].startLineNumber),$=Math.max($,u[m].endLineNumberExclusive);return new L(c,$)}static ofLength(u,c){return new L(u,u+c)}static deserialize(u){return new L(u[0],u[1])}constructor(u,c){if(u>c)throw new t.$bb(`startLineNumber ${u} cannot be after endLineNumberExclusive ${c}`);this.startLineNumber=u,this.endLineNumberExclusive=c}contains(u){return this.startLineNumber<=u&&u<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(u){return new L(this.startLineNumber+u,this.endLineNumberExclusive+u)}deltaLength(u){return new L(this.startLineNumber,this.endLineNumberExclusive+u)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(u){return new L(Math.min(this.startLineNumber,u.startLineNumber),Math.max(this.endLineNumberExclusive,u.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(u){const c=Math.max(this.startLineNumber,u.startLineNumber),$=Math.min(this.endLineNumberExclusive,u.endLineNumberExclusive);if(c<=$)return new L(c,$)}intersectsStrict(u){return this.startLineNumber<u.endLineNumberExclusive&&u.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(u){return this.startLineNumber<=u.endLineNumberExclusive&&u.startLineNumber<=this.endLineNumberExclusive}equals(u){return this.startLineNumber===u.startLineNumber&&this.endLineNumberExclusive===u.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new T.$Kt(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new T.$Kt(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(u){const c=[];for(let $=this.startLineNumber;$<this.endLineNumberExclusive;$++)c.push(u($));return c}forEach(u){for(let c=this.startLineNumber;c<this.endLineNumberExclusive;c++)u(c)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(u){return this.startLineNumber<=u&&u<this.endLineNumberExclusive}toOffsetRange(){return new n.$Rt(this.startLineNumber-1,this.endLineNumberExclusive-1)}}i.$Tt=L;class d{constructor(u=[]){this.c=u}get ranges(){return this.c}addRange(u){if(u.length===0)return;const c=(0,g.$jb)(this.c,m=>m.endLineNumberExclusive>=u.startLineNumber),$=(0,g.$hb)(this.c,m=>m.startLineNumber<=u.endLineNumberExclusive)+1;if(c===$)this.c.splice(c,0,u);else if(c===$-1){const m=this.c[c];this.c[c]=m.join(u)}else{const m=this.c[c].join(this.c[$-1]).join(u);this.c.splice(c,$-c,m)}}contains(u){const c=(0,g.$gb)(this.c,$=>$.startLineNumber<=u);return!!c&&c.endLineNumberExclusive>u}intersects(u){const c=(0,g.$gb)(this.c,$=>$.startLineNumber<u.endLineNumberExclusive);return!!c&&c.endLineNumberExclusive>u.startLineNumber}getUnion(u){if(this.c.length===0)return u;if(u.c.length===0)return this;const c=[];let $=0,m=0,w=null;for(;$<this.c.length||m<u.c.length;){let e=null;if($<this.c.length&&m<u.c.length){const b=this.c[$],N=u.c[m];b.startLineNumber<N.startLineNumber?(e=b,$++):(e=N,m++)}else $<this.c.length?(e=this.c[$],$++):(e=u.c[m],m++);w===null?w=e:w.endLineNumberExclusive>=e.startLineNumber?w=new L(w.startLineNumber,Math.max(w.endLineNumberExclusive,e.endLineNumberExclusive)):(c.push(w),w=e)}return w!==null&&c.push(w),new d(c)}subtractFrom(u){const c=(0,g.$jb)(this.c,e=>e.endLineNumberExclusive>=u.startLineNumber),$=(0,g.$hb)(this.c,e=>e.startLineNumber<=u.endLineNumberExclusive)+1;if(c===$)return new d([u]);const m=[];let w=u.startLineNumber;for(let e=c;e<$;e++){const b=this.c[e];b.startLineNumber>w&&m.push(new L(w,b.startLineNumber)),w=b.endLineNumberExclusive}return w<u.endLineNumberExclusive&&m.push(new L(w,u.endLineNumberExclusive)),new d(m)}toString(){return this.c.map(u=>u.toString()).join(", ")}getIntersection(u){const c=[];let $=0,m=0;for(;$<this.c.length&&m<u.c.length;){const w=this.c[$],e=u.c[m],b=w.intersect(e);b&&!b.isEmpty&&c.push(b),w.endLineNumberExclusive<e.endLineNumberExclusive?$++:m++}return new d(c)}getWithDelta(u){return new d(this.c.map(c=>c.delta(u)))}}i.$Ut=d}),ne(ie[50],re([0,1,5,2]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Mt=i.SelectionDirection=void 0;var T;(function(L){L[L.LTR=0]="LTR",L[L.RTL=1]="RTL"})(T||(i.SelectionDirection=T={}));class g extends n.$Kt{constructor(d,a,u,c){super(d,a,u,c),this.selectionStartLineNumber=d,this.selectionStartColumn=a,this.positionLineNumber=u,this.positionColumn=c}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(d){return g.selectionsEqual(this,d)}static selectionsEqual(d,a){return d.selectionStartLineNumber===a.selectionStartLineNumber&&d.selectionStartColumn===a.selectionStartColumn&&d.positionLineNumber===a.positionLineNumber&&d.positionColumn===a.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?T.LTR:T.RTL}setEndPosition(d,a){return this.getDirection()===T.LTR?new g(this.startLineNumber,this.startColumn,d,a):new g(d,a,this.startLineNumber,this.startColumn)}getPosition(){return new t.$Jt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new t.$Jt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(d,a){return this.getDirection()===T.LTR?new g(d,a,this.endLineNumber,this.endColumn):new g(this.endLineNumber,this.endColumn,d,a)}static fromPositions(d,a=d){return new g(d.lineNumber,d.column,a.lineNumber,a.column)}static fromRange(d,a){return a===T.LTR?new g(d.startLineNumber,d.startColumn,d.endLineNumber,d.endColumn):new g(d.endLineNumber,d.endColumn,d.startLineNumber,d.startColumn)}static liftSelection(d){return new g(d.selectionStartLineNumber,d.selectionStartColumn,d.positionLineNumber,d.positionColumn)}static selectionsArrEqual(d,a){if(d&&!a||!d&&a)return!1;if(!d&&!a)return!0;if(d.length!==a.length)return!1;for(let u=0,c=d.length;u<c;u++)if(!this.selectionsEqual(d[u],a[u]))return!1;return!0}static isISelection(d){return d&&typeof d.selectionStartLineNumber=="number"&&typeof d.selectionStartColumn=="number"&&typeof d.positionLineNumber=="number"&&typeof d.positionColumn=="number"}static createWithDirection(d,a,u,c,$){return $===T.LTR?new g(d,a,u,c):new g(u,c,d,a)}}i.$Mt=g}),ne(ie[31],re([0,1,5,2]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Vt=void 0;class T{static{this.zero=new T(0,0)}static lengthDiffNonNegative(L,d){return d.isLessThan(L)?T.zero:L.lineCount===d.lineCount?new T(0,d.columnCount-L.columnCount):new T(d.lineCount-L.lineCount,d.columnCount)}static betweenPositions(L,d){return L.lineNumber===d.lineNumber?new T(0,d.column-L.column):new T(d.lineNumber-L.lineNumber,d.column-1)}static ofRange(L){return T.betweenPositions(L.getStartPosition(),L.getEndPosition())}static ofText(L){let d=0,a=0;for(const u of L)u===`
`?(d++,a=0):a++;return new T(d,a)}constructor(L,d){this.lineCount=L,this.columnCount=d}isZero(){return this.lineCount===0&&this.columnCount===0}isLessThan(L){return this.lineCount!==L.lineCount?this.lineCount<L.lineCount:this.columnCount<L.columnCount}isGreaterThan(L){return this.lineCount!==L.lineCount?this.lineCount>L.lineCount:this.columnCount>L.columnCount}isGreaterThanOrEqualTo(L){return this.lineCount!==L.lineCount?this.lineCount>L.lineCount:this.columnCount>=L.columnCount}equals(L){return this.lineCount===L.lineCount&&this.columnCount===L.columnCount}compare(L){return this.lineCount!==L.lineCount?this.lineCount-L.lineCount:this.columnCount-L.columnCount}add(L){return L.lineCount===0?new T(this.lineCount,this.columnCount+L.columnCount):new T(this.lineCount+L.lineCount,L.columnCount)}createRange(L){return this.lineCount===0?new n.$Kt(L.lineNumber,L.column,L.lineNumber,L.column+this.columnCount):new n.$Kt(L.lineNumber,L.column,L.lineNumber+this.lineCount,this.columnCount+1)}toRange(){return new n.$Kt(1,1,this.lineCount+1,this.columnCount+1)}addToPosition(L){return this.lineCount===0?new t.$Jt(L.lineNumber,L.column+this.columnCount):new t.$Jt(L.lineNumber+this.lineCount,this.columnCount+1)}toString(){return`${this.lineCount},${this.columnCount}`}}i.$Vt=T}),ne(ie[51],re([0,1,9,6,5,2,31]),function(x,i,t,n,T,g,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Wt=void 0;class d{constructor(u){this.text=u,this.a=[],this.a.push(0);for(let c=0;c<u.length;c++)u.charAt(c)===`
`&&this.a.push(c+1)}getOffset(u){return this.a[u.lineNumber-1]+u.column-1}getOffsetRange(u){return new n.$Rt(this.getOffset(u.getStartPosition()),this.getOffset(u.getEndPosition()))}getPosition(u){const c=(0,t.$hb)(this.a,w=>w<=u),$=c+1,m=u-this.a[c]+1;return new T.$Jt($,m)}getRange(u){return g.$Kt.fromPositions(this.getPosition(u.start),this.getPosition(u.endExclusive))}getTextLength(u){return L.$Vt.ofRange(this.getRange(u))}get textLength(){const u=this.a.length-1;return new L.$Vt(u,this.text.length-this.a[u])}}i.$Wt=d}),ne(ie[52],re([0,1,11,4,5,51,2,31]),function(x,i,t,n,T,g,L,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$2t=i.$1t=i.$Zt=i.$Yt=i.$Xt=void 0;class a{static single(b,N){return new a([new u(b,N)])}constructor(b){this.edits=b,(0,t.$gd)(()=>(0,t.$hd)(b,(N,_)=>N.range.getEndPosition().isBeforeOrEqual(_.range.getStartPosition())))}normalize(){const b=[];for(const N of this.edits)if(b.length>0&&b[b.length-1].range.getEndPosition().equals(N.range.getStartPosition())){const _=b[b.length-1];b[b.length-1]=new u(_.range.plusRange(N.range),_.text+N.text)}else N.isEmpty||b.push(N);return new a(b)}mapPosition(b){let N=0,_=0,A=0;for(const E of this.edits){const v=E.range.getStartPosition(),h=E.range.getEndPosition();if(b.isBeforeOrEqual(v))break;const o=d.$Vt.ofText(E.text);if(b.isBefore(h)){const r=new T.$Jt(v.lineNumber+N,v.column+(v.lineNumber+N===_?A:0)),l=o.addToPosition(r);return c(r,l)}N+=o.lineCount-(E.range.endLineNumber-E.range.startLineNumber),o.lineCount===0?h.lineNumber!==v.lineNumber?A+=o.columnCount-(h.column-1):A+=o.columnCount-(h.column-v.column):A=o.columnCount,_=h.lineNumber+N}return new T.$Jt(b.lineNumber+N,b.column+(b.lineNumber+N===_?A:0))}mapRange(b){function N(v){return v instanceof T.$Jt?v:v.getStartPosition()}function _(v){return v instanceof T.$Jt?v:v.getEndPosition()}const A=N(this.mapPosition(b.getStartPosition())),E=_(this.mapPosition(b.getEndPosition()));return c(A,E)}inverseMapPosition(b,N){return this.inverse(N).mapPosition(b)}inverseMapRange(b,N){return this.inverse(N).mapRange(b)}apply(b){let N="",_=new T.$Jt(1,1);for(const E of this.edits){const v=E.range,h=v.getStartPosition(),o=v.getEndPosition(),r=c(_,h);r.isEmpty()||(N+=b.getValueOfRange(r)),N+=E.text,_=o}const A=c(_,b.endPositionExclusive);return A.isEmpty()||(N+=b.getValueOfRange(A)),N}applyToString(b){const N=new w(b);return this.apply(N)}inverse(b){const N=this.getNewRanges();return new a(this.edits.map((_,A)=>new u(N[A],b.getValueOfRange(_.range))))}getNewRanges(){const b=[];let N=0,_=0,A=0;for(const E of this.edits){const v=d.$Vt.ofText(E.text),h=T.$Jt.lift({lineNumber:E.range.startLineNumber+_,column:E.range.startColumn+(E.range.startLineNumber===N?A:0)}),o=v.createRange(h);b.push(o),_=o.endLineNumber-E.range.endLineNumber,A=o.endColumn-E.range.endColumn,N=E.range.endLineNumber}return b}}i.$Xt=a;class u{constructor(b,N){this.range=b,this.text=N}get isEmpty(){return this.range.isEmpty()&&this.text.length===0}static equals(b,N){return b.range.equalsRange(N.range)&&b.text===N.text}toSingleEditOperation(){return{range:this.range,text:this.text}}}i.$Yt=u;function c(e,b){if(e.lineNumber===b.lineNumber&&e.column===Number.MAX_SAFE_INTEGER)return L.$Kt.fromPositions(b,b);if(!e.isBeforeOrEqual(b))throw new n.$bb("start must be before end");return new L.$Kt(e.lineNumber,e.column,b.lineNumber,b.column)}class ${get endPositionExclusive(){return this.length.addToPosition(new T.$Jt(1,1))}getValue(){return this.getValueOfRange(this.length.toRange())}}i.$Zt=$;class m extends ${constructor(b,N){(0,t.$ed)(N>=1),super(),this.c=b,this.d=N}getValueOfRange(b){if(b.startLineNumber===b.endLineNumber)return this.c(b.startLineNumber).substring(b.startColumn-1,b.endColumn-1);let N=this.c(b.startLineNumber).substring(b.startColumn-1);for(let _=b.startLineNumber+1;_<b.endLineNumber;_++)N+=`
`+this.c(_);return N+=`
`+this.c(b.endLineNumber).substring(0,b.endColumn-1),N}get length(){const b=this.c(this.d);return new d.$Vt(this.d-1,b.length)}}i.$1t=m;class w extends ${constructor(b){super(),this.value=b,this.c=new g.$Wt(this.value)}getValueOfRange(b){return this.c.getOffsetRange(b).substring(this.value)}get length(){return this.c.textLength}}i.$2t=w}),ne(ie[53],re([0,1,3,16,30]),function(x,i,t,n,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$eu=i.WordCharacterClass=void 0,i.$fu=a;var g;(function(u){u[u.Regular=0]="Regular",u[u.Whitespace=1]="Whitespace",u[u.WordSeparator=2]="WordSeparator"})(g||(i.WordCharacterClass=g={}));class L extends T.$cu{constructor(c,$){super(g.Regular),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=$,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let m=0,w=c.length;m<w;m++)this.set(c.charCodeAt(m),g.WordSeparator);this.set(t.CharCode.Space,g.Whitespace),this.set(t.CharCode.Tab,g.Whitespace)}findPrevIntlWordBeforeOrAtOffset(c,$){let m=null;for(const w of this.h(c)){if(w.index>$)break;m=w}return m}findNextIntlWordAtOrAfterOffset(c,$){for(const m of this.h(c))if(!(m.index<$))return m;return null}h(c){return this.e?this.f===c?this.g:(this.f=c,this.g=this.j(this.e.segment(c)),this.g):[]}j(c){const $=[];for(const m of c)this.k(m)&&$.push(m);return $}k(c){return!!c.isWordLike}}i.$eu=L;const d=new n.$Cc(10);function a(u,c){const $=`${u}/${c.join(",")}`;let m=d.get($);return m||(m=new L(u,c),d.set($,m)),m}}),ne(ie[32],re([0,1,23,12,24]),function(x,i,t,n,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$jt=i.$it=void 0,i.$kt=L,i.$lt=a,i.$mt=u,i.$it="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function g($=""){let m="(-?\\d*\\.\\d\\w*)|([^";for(const w of i.$it)$.indexOf(w)>=0||(m+="\\"+w);return m+="\\s]+)",new RegExp(m,"g")}i.$jt=g();function L($){let m=i.$jt;if($&&$ instanceof RegExp)if($.global)m=$;else{let w="g";$.ignoreCase&&(w+="i"),$.multiline&&(w+="m"),$.unicode&&(w+="u"),m=new RegExp($.source,w)}return m.lastIndex=0,m}const d=new T.$4c;d.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function a($){const m=d.unshift($);return(0,n.$Rc)(m)}function u($,m,w,e,b){if(m=L(m),b||(b=t.Iterable.first(d)),w.length>b.maxLen){let v=$-b.maxLen/2;return v<0?v=0:e+=v,w=w.substring(v,$+b.maxLen/2),u($,m,w,e,b)}const N=Date.now(),_=$-1-e;let A=-1,E=null;for(let v=1;!(Date.now()-N>=b.timeBudget);v++){const h=_-b.windowSize*v;m.lastIndex=Math.max(0,h);const o=c(m,w,_,A);if(!o&&E||(E=o,h<=0))break;A=h}if(E){const v={word:E[0],startColumn:e+1+E.index,endColumn:e+1+E.index+E[0].length};return m.lastIndex=0,v}return null}function c($,m,w,e){let b;for(;b=$.exec(m);){const N=b.index||0;if(N<=w&&$.lastIndex>=w)return b;if(e>0&&N>e)return null}return null}}),ne(ie[10],re([0,1,7,4,6]),function(x,i,t,n,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$p4=i.$o4=i.$n4=i.$m4=i.$l4=void 0;class g{static trivial($,m){return new g([new L(T.$Rt.ofLength($.length),T.$Rt.ofLength(m.length))],!1)}static trivialTimedOut($,m){return new g([new L(T.$Rt.ofLength($.length),T.$Rt.ofLength(m.length))],!0)}constructor($,m){this.diffs=$,this.hitTimeout=m}}i.$l4=g;class L{static invert($,m){const w=[];return(0,t.$Ab)($,(e,b)=>{w.push(L.fromOffsetPairs(e?e.getEndExclusives():d.zero,b?b.getStarts():new d(m,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+m)))}),w}static fromOffsetPairs($,m){return new L(new T.$Rt($.offset1,m.offset1),new T.$Rt($.offset2,m.offset2))}constructor($,m){this.seq1Range=$,this.seq2Range=m}swap(){return new L(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join($){return new L(this.seq1Range.join($.seq1Range),this.seq2Range.join($.seq2Range))}delta($){return $===0?this:new L(this.seq1Range.delta($),this.seq2Range.delta($))}deltaStart($){return $===0?this:new L(this.seq1Range.deltaStart($),this.seq2Range.deltaStart($))}deltaEnd($){return $===0?this:new L(this.seq1Range.deltaEnd($),this.seq2Range.deltaEnd($))}intersectsOrTouches($){return this.seq1Range.intersectsOrTouches($.seq1Range)||this.seq2Range.intersectsOrTouches($.seq2Range)}intersect($){const m=this.seq1Range.intersect($.seq1Range),w=this.seq2Range.intersect($.seq2Range);if(!(!m||!w))return new L(m,w)}getStarts(){return new d(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new d(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}i.$m4=L;class d{static{this.zero=new d(0,0)}static{this.max=new d(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor($,m){this.offset1=$,this.offset2=m}toString(){return`${this.offset1} <-> ${this.offset2}`}delta($){return $===0?this:new d(this.offset1+$,this.offset2+$)}equals($){return this.offset1===$.offset1&&this.offset2===$.offset2}}i.$n4=d;class a{static{this.instance=new a}isValid(){return!0}}i.$o4=a;class u{constructor($){if(this.e=$,this.c=Date.now(),this.d=!0,$<=0)throw new n.$bb("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}i.$p4=u}),ne(ie[33],re([0,1,6,10]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$u4=void 0;class T{compute(u,c,$=n.$o4.instance){if(u.length===0||c.length===0)return n.$l4.trivial(u,c);const m=u,w=c;function e(r,l){for(;r<m.length&&l<w.length&&m.getElement(r)===w.getElement(l);)r++,l++;return r}let b=0;const N=new L;N.set(0,e(0,0));const _=new d;_.set(0,N.get(0)===0?null:new g(null,0,0,N.get(0)));let A=0;e:for(;;){if(b++,!$.isValid())return n.$l4.trivialTimedOut(m,w);const r=-Math.min(b,w.length+b%2),l=Math.min(b,m.length+b%2);for(A=r;A<=l;A+=2){let f=0;const D=A===l?-1:N.get(A+1),R=A===r?-1:N.get(A-1)+1;f++;const p=Math.min(Math.max(D,R),m.length),M=p-A;if(f++,p>m.length||M>w.length)continue;const j=e(p,M);N.set(A,j);const S=p===D?_.get(A+1):_.get(A-1);if(_.set(A,j!==p?new g(S,p,M,j-p):S),N.get(A)===m.length&&N.get(A)-A===w.length)break e}}let E=_.get(A);const v=[];let h=m.length,o=w.length;for(;;){const r=E?E.x+E.length:0,l=E?E.y+E.length:0;if((r!==h||l!==o)&&v.push(new n.$m4(new t.$Rt(r,h),new t.$Rt(l,o))),!E)break;h=E.x,o=E.y,E=E.prev}return v.reverse(),new n.$l4(v,!1)}}i.$u4=T;class g{constructor(u,c,$,m){this.prev=u,this.x=c,this.y=$,this.length=m}}class L{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(u){return u<0?(u=-u-1,this.b[u]):this.a[u]}set(u,c){if(u<0){if(u=-u-1,u>=this.b.length){const $=this.b;this.b=new Int32Array($.length*2),this.b.set($)}this.b[u]=c}else{if(u>=this.a.length){const $=this.a;this.a=new Int32Array($.length*2),this.a.set($)}this.a[u]=c}}}class d{constructor(){this.a=[],this.b=[]}get(u){return u<0?(u=-u-1,this.b[u]):this.a[u]}set(u,c){u<0?(u=-u-1,this.b[u]=c):this.a[u]=c}}}),ne(ie[54],re([0,1,7,6,10]),function(x,i,t,n,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$y4=g,i.$z4=u,i.$A4=c,i.$B4=m,i.$C4=w;function g(e,b,N){let _=N;return _=L(e,b,_),_=L(e,b,_),_=d(e,b,_),_}function L(e,b,N){if(N.length===0)return N;const _=[];_.push(N[0]);for(let E=1;E<N.length;E++){const v=_[_.length-1];let h=N[E];if(h.seq1Range.isEmpty||h.seq2Range.isEmpty){const o=h.seq1Range.start-v.seq1Range.endExclusive;let r;for(r=1;r<=o&&!(e.getElement(h.seq1Range.start-r)!==e.getElement(h.seq1Range.endExclusive-r)||b.getElement(h.seq2Range.start-r)!==b.getElement(h.seq2Range.endExclusive-r));r++);if(r--,r===o){_[_.length-1]=new T.$m4(new n.$Rt(v.seq1Range.start,h.seq1Range.endExclusive-o),new n.$Rt(v.seq2Range.start,h.seq2Range.endExclusive-o));continue}h=h.delta(-r)}_.push(h)}const A=[];for(let E=0;E<_.length-1;E++){const v=_[E+1];let h=_[E];if(h.seq1Range.isEmpty||h.seq2Range.isEmpty){const o=v.seq1Range.start-h.seq1Range.endExclusive;let r;for(r=0;r<o&&!(!e.isStronglyEqual(h.seq1Range.start+r,h.seq1Range.endExclusive+r)||!b.isStronglyEqual(h.seq2Range.start+r,h.seq2Range.endExclusive+r));r++);if(r===o){_[E+1]=new T.$m4(new n.$Rt(h.seq1Range.start+o,v.seq1Range.endExclusive),new n.$Rt(h.seq2Range.start+o,v.seq2Range.endExclusive));continue}r>0&&(h=h.delta(r))}A.push(h)}return _.length>0&&A.push(_[_.length-1]),A}function d(e,b,N){if(!e.getBoundaryScore||!b.getBoundaryScore)return N;for(let _=0;_<N.length;_++){const A=_>0?N[_-1]:void 0,E=N[_],v=_+1<N.length?N[_+1]:void 0,h=new n.$Rt(A?A.seq1Range.endExclusive+1:0,v?v.seq1Range.start-1:e.length),o=new n.$Rt(A?A.seq2Range.endExclusive+1:0,v?v.seq2Range.start-1:b.length);E.seq1Range.isEmpty?N[_]=a(E,e,b,h,o):E.seq2Range.isEmpty&&(N[_]=a(E.swap(),b,e,o,h).swap())}return N}function a(e,b,N,_,A){let v=1;for(;e.seq1Range.start-v>=_.start&&e.seq2Range.start-v>=A.start&&N.isStronglyEqual(e.seq2Range.start-v,e.seq2Range.endExclusive-v)&&v<100;)v++;v--;let h=0;for(;e.seq1Range.start+h<_.endExclusive&&e.seq2Range.endExclusive+h<A.endExclusive&&N.isStronglyEqual(e.seq2Range.start+h,e.seq2Range.endExclusive+h)&&h<100;)h++;if(v===0&&h===0)return e;let o=0,r=-1;for(let l=-v;l<=h;l++){const f=e.seq2Range.start+l,D=e.seq2Range.endExclusive+l,R=e.seq1Range.start+l,p=b.getBoundaryScore(R)+N.getBoundaryScore(f)+N.getBoundaryScore(D);p>r&&(r=p,o=l)}return e.delta(o)}function u(e,b,N){const _=[];for(const A of N){const E=_[_.length-1];if(!E){_.push(A);continue}A.seq1Range.start-E.seq1Range.endExclusive<=2||A.seq2Range.start-E.seq2Range.endExclusive<=2?_[_.length-1]=new T.$m4(E.seq1Range.join(A.seq1Range),E.seq2Range.join(A.seq2Range)):_.push(A)}return _}function c(e,b,N){const _=T.$m4.invert(N,e.length),A=[];let E=new T.$n4(0,0);function v(o,r){if(o.offset1<E.offset1||o.offset2<E.offset2)return;const l=e.findWordContaining(o.offset1),f=b.findWordContaining(o.offset2);if(!l||!f)return;let D=new T.$m4(l,f);const R=D.intersect(r);let p=R.seq1Range.length,M=R.seq2Range.length;for(;_.length>0;){const j=_[0];if(!(j.seq1Range.intersects(D.seq1Range)||j.seq2Range.intersects(D.seq2Range)))break;const I=e.findWordContaining(j.seq1Range.start),W=b.findWordContaining(j.seq2Range.start),P=new T.$m4(I,W),H=P.intersect(j);if(p+=H.seq1Range.length,M+=H.seq2Range.length,D=D.join(P),D.seq1Range.endExclusive>=j.seq1Range.endExclusive)_.shift();else break}p+M<(D.seq1Range.length+D.seq2Range.length)*2/3&&A.push(D),E=D.getEndExclusives()}for(;_.length>0;){const o=_.shift();o.seq1Range.isEmpty||(v(o.getStarts(),o),v(o.getEndExclusives().delta(-1),o))}return $(N,A)}function $(e,b){const N=[];for(;e.length>0||b.length>0;){const _=e[0],A=b[0];let E;_&&(!A||_.seq1Range.start<A.seq1Range.start)?E=e.shift():E=b.shift(),N.length>0&&N[N.length-1].seq1Range.endExclusive>=E.seq1Range.start?N[N.length-1]=N[N.length-1].join(E):N.push(E)}return N}function m(e,b,N){let _=N;if(_.length===0)return _;let A=0,E;do{E=!1;const v=[_[0]];for(let h=1;h<_.length;h++){let l=function(D,R){const p=new n.$Rt(r.seq1Range.endExclusive,o.seq1Range.start);return e.getText(p).replace(/\s/g,"").length<=4&&(D.seq1Range.length+D.seq2Range.length>5||R.seq1Range.length+R.seq2Range.length>5)};const o=_[h],r=v[v.length-1];l(r,o)?(E=!0,v[v.length-1]=v[v.length-1].join(o)):v.push(o)}_=v}while(A++<10&&E);return _}function w(e,b,N){let _=N;if(_.length===0)return _;let A=0,E;do{E=!1;const h=[_[0]];for(let o=1;o<_.length;o++){let f=function(R,p){const M=new n.$Rt(l.seq1Range.endExclusive,r.seq1Range.start);if(e.countLinesIn(M)>5||M.length>500)return!1;const S=e.getText(M).trim();if(S.length>20||S.split(/\r\n|\r|\n/).length>1)return!1;const I=e.countLinesIn(R.seq1Range),W=R.seq1Range.length,P=b.countLinesIn(R.seq2Range),H=R.seq2Range.length,B=e.countLinesIn(p.seq1Range),y=p.seq1Range.length,Y=b.countLinesIn(p.seq2Range),J=p.seq2Range.length,G=2*40+50;function Z(C){return Math.min(C,G)}return Math.pow(Math.pow(Z(I*40+W),1.5)+Math.pow(Z(P*40+H),1.5),1.5)+Math.pow(Math.pow(Z(B*40+y),1.5)+Math.pow(Z(Y*40+J),1.5),1.5)>(G**1.5)**1.5*1.3};const r=_[o],l=h[h.length-1];f(l,r)?(E=!0,h[h.length-1]=h[h.length-1].join(r)):h.push(r)}_=h}while(A++<10&&E);const v=[];return(0,t.$Bb)(_,(h,o,r)=>{let l=o;function f(S){return S.length>0&&S.trim().length<=3&&o.seq1Range.length+o.seq2Range.length>100}const D=e.extendToFullLines(o.seq1Range),R=e.getText(new n.$Rt(D.start,o.seq1Range.start));f(R)&&(l=l.deltaStart(-R.length));const p=e.getText(new n.$Rt(o.seq1Range.endExclusive,D.endExclusive));f(p)&&(l=l.deltaEnd(p.length));const M=T.$m4.fromOffsetPairs(h?h.getEndExclusives():T.$n4.zero,r?r.getStarts():T.$n4.max),j=l.intersect(M);v.length>0&&j.getStarts().equals(v[v.length-1].getEndExclusives())?v[v.length-1]=v[v.length-1].join(j):v.push(j)}),v}}),ne(ie[55],re([0,1,3]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$x4=void 0;class n{constructor(L,d){this.a=L,this.b=d}getElement(L){return this.a[L]}get length(){return this.a.length}getBoundaryScore(L){const d=L===0?0:T(this.b[L-1]),a=L===this.b.length?0:T(this.b[L]);return 1e3-(d+a)}getText(L){return this.b.slice(L.start,L.endExclusive).join(`
`)}isStronglyEqual(L,d){return this.b[L]===this.b[d]}}i.$x4=n;function T(g){let L=0;for(;L<g.length&&(g.charCodeAt(L)===t.CharCode.Space||g.charCodeAt(L)===t.CharCode.Tab);)L++;return L}}),ne(ie[20],re([0,1,3]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$s4=i.$q4=void 0,i.$r4=T;class n{constructor(d,a){this.width=d,this.height=a,this.a=[],this.a=new Array(d*a)}get(d,a){return this.a[d+a*this.width]}set(d,a,u){this.a[d+a*this.width]=u}}i.$q4=n;function T(L){return L===t.CharCode.Space||L===t.CharCode.Tab}class g{static{this.a=new Map}static b(d){let a=this.a.get(d);return a===void 0&&(a=this.a.size,this.a.set(d,a)),a}constructor(d,a,u){this.range=d,this.lines=a,this.source=u,this.d=[];let c=0;for(let $=d.startLineNumber-1;$<d.endLineNumberExclusive-1;$++){const m=a[$];for(let e=0;e<m.length;e++){c++;const b=m[e],N=g.b(b);this.d[N]=(this.d[N]||0)+1}c++;const w=g.b(`
`);this.d[w]=(this.d[w]||0)+1}this.c=c}computeSimilarity(d){let a=0;const u=Math.max(this.d.length,d.d.length);for(let c=0;c<u;c++)a+=Math.abs((this.d[c]??0)-(d.d[c]??0));return 1-a/(this.c+d.c)}}i.$s4=g}),ne(ie[56],re([0,1,6,10,20]),function(x,i,t,n,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$t4=void 0;class g{compute(d,a,u=n.$o4.instance,c){if(d.length===0||a.length===0)return n.$l4.trivial(d,a);const $=new T.$q4(d.length,a.length),m=new T.$q4(d.length,a.length),w=new T.$q4(d.length,a.length);for(let v=0;v<d.length;v++)for(let h=0;h<a.length;h++){if(!u.isValid())return n.$l4.trivialTimedOut(d,a);const o=v===0?0:$.get(v-1,h),r=h===0?0:$.get(v,h-1);let l;d.getElement(v)===a.getElement(h)?(v===0||h===0?l=0:l=$.get(v-1,h-1),v>0&&h>0&&m.get(v-1,h-1)===3&&(l+=w.get(v-1,h-1)),l+=c?c(v,h):1):l=-1;const f=Math.max(o,r,l);if(f===l){const D=v>0&&h>0?w.get(v-1,h-1):0;w.set(v,h,D+1),m.set(v,h,3)}else f===o?(w.set(v,h,0),m.set(v,h,1)):f===r&&(w.set(v,h,0),m.set(v,h,2));$.set(v,h,f)}const e=[];let b=d.length,N=a.length;function _(v,h){(v+1!==b||h+1!==N)&&e.push(new n.$m4(new t.$Rt(v+1,b),new t.$Rt(h+1,N))),b=v,N=h}let A=d.length-1,E=a.length-1;for(;A>=0&&E>=0;)m.get(A,E)===3?(_(A,E),A--,E--):m.get(A,E)===1?A--:E--;return _(-1,-1),e.reverse(),new n.$l4(e,!1)}}i.$t4=g}),ne(ie[34],re([0,1,9,3,6,5,2,20]),function(x,i,t,n,T,g,L,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$v4=void 0;class a{constructor(b,N,_){this.lines=b,this.considerWhitespaceChanges=_,this.b=[],this.c=[],this.d=[];let A=!1;N.start>0&&N.endExclusive>=b.length&&(N=new T.$Rt(N.start-1,N.endExclusive),A=!0),this.lineRange=N,this.c[0]=0;for(let E=this.lineRange.start;E<this.lineRange.endExclusive;E++){let v=b[E],h=0;if(A)h=v.length,v="",A=!1;else if(!_){const o=v.trimStart();h=v.length-o.length,v=o.trimEnd()}this.d.push(h);for(let o=0;o<v.length;o++)this.b.push(v.charCodeAt(o));E<b.length-1&&(this.b.push(10),this.c[E-this.lineRange.start+1]=this.b.length)}this.d.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new T.$Rt(0,this.length))}getText(b){return this.b.slice(b.start,b.endExclusive).map(N=>String.fromCharCode(N)).join("")}getElement(b){return this.b[b]}get length(){return this.b.length}getBoundaryScore(b){const N=w(b>0?this.b[b-1]:-1),_=w(b<this.b.length?this.b[b]:-1);if(N===c.LineBreakCR&&_===c.LineBreakLF)return 0;if(N===c.LineBreakLF)return 150;let A=0;return N!==_&&(A+=10,N===c.WordLower&&_===c.WordUpper&&(A+=1)),A+=m(N),A+=m(_),A}translateOffset(b){if(this.lineRange.isEmpty)return new g.$Jt(this.lineRange.start+1,1);const N=(0,t.$hb)(this.c,_=>_<=b);return new g.$Jt(this.lineRange.start+N+1,b-this.c[N]+this.d[N]+1)}translateRange(b){return L.$Kt.fromPositions(this.translateOffset(b.start),this.translateOffset(b.endExclusive))}findWordContaining(b){if(b<0||b>=this.b.length||!u(this.b[b]))return;let N=b;for(;N>0&&u(this.b[N-1]);)N--;let _=b;for(;_<this.b.length&&u(this.b[_]);)_++;return new T.$Rt(N,_)}countLinesIn(b){return this.translateOffset(b.endExclusive).lineNumber-this.translateOffset(b.start).lineNumber}isStronglyEqual(b,N){return this.b[b]===this.b[N]}extendToFullLines(b){const N=(0,t.$gb)(this.c,A=>A<=b.start)??0,_=(0,t.$ib)(this.c,A=>b.endExclusive<=A)??this.b.length;return new T.$Rt(N,_)}}i.$v4=a;function u(e){return e>=n.CharCode.a&&e<=n.CharCode.z||e>=n.CharCode.A&&e<=n.CharCode.Z||e>=n.CharCode.Digit0&&e<=n.CharCode.Digit9}var c;(function(e){e[e.WordLower=0]="WordLower",e[e.WordUpper=1]="WordUpper",e[e.WordNumber=2]="WordNumber",e[e.End=3]="End",e[e.Other=4]="Other",e[e.Separator=5]="Separator",e[e.Space=6]="Space",e[e.LineBreakCR=7]="LineBreakCR",e[e.LineBreakLF=8]="LineBreakLF"})(c||(c={}));const $={[c.WordLower]:0,[c.WordUpper]:0,[c.WordNumber]:0,[c.End]:10,[c.Other]:2,[c.Separator]:30,[c.Space]:3,[c.LineBreakCR]:10,[c.LineBreakLF]:10};function m(e){return $[e]}function w(e){return e===n.CharCode.LineFeed?c.LineBreakLF:e===n.CharCode.CarriageReturn?c.LineBreakCR:(0,d.$r4)(e)?c.Space:e>=n.CharCode.a&&e<=n.CharCode.z?c.WordLower:e>=n.CharCode.A&&e<=n.CharCode.Z?c.WordUpper:e>=n.CharCode.Digit0&&e<=n.CharCode.Digit9?c.WordNumber:e===-1?c.End:e===n.CharCode.Comma||e===n.CharCode.Semicolon?c.Separator:c.Other}}),ne(ie[35],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$7t=i.$6t=void 0;class t{constructor(g,L,d){this.changes=g,this.moves=L,this.hitTimeout=d}}i.$6t=t;class n{constructor(g,L){this.lineRangeMapping=g,this.changes=L}flip(){return new n(this.lineRangeMapping.flip(),this.changes.map(g=>g.flip()))}}i.$7t=n}),ne(ie[21],re([0,1,4,15,2,52]),function(x,i,t,n,T,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$5t=i.$4t=i.$3t=void 0;class L{static inverse(c,$,m){const w=[];let e=1,b=1;for(const _ of c){const A=new L(new n.$Tt(e,_.original.startLineNumber),new n.$Tt(b,_.modified.startLineNumber));A.modified.isEmpty||w.push(A),e=_.original.endLineNumberExclusive,b=_.modified.endLineNumberExclusive}const N=new L(new n.$Tt(e,$+1),new n.$Tt(b,m+1));return N.modified.isEmpty||w.push(N),w}static clip(c,$,m){const w=[];for(const e of c){const b=e.original.intersect($),N=e.modified.intersect(m);b&&!b.isEmpty&&N&&!N.isEmpty&&w.push(new L(b,N))}return w}constructor(c,$){this.original=c,this.modified=$}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new L(this.modified,this.original)}join(c){return new L(this.original.join(c.original),this.modified.join(c.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}toRangeMapping(){const c=this.original.toInclusiveRange(),$=this.modified.toInclusiveRange();if(c&&$)return new a(c,$);if(this.original.startLineNumber===1||this.modified.startLineNumber===1){if(!(this.modified.startLineNumber===1&&this.original.startLineNumber===1))throw new t.$bb("not a valid diff");return new a(new T.$Kt(this.original.startLineNumber,1,this.original.endLineNumberExclusive,1),new T.$Kt(this.modified.startLineNumber,1,this.modified.endLineNumberExclusive,1))}else return new a(new T.$Kt(this.original.startLineNumber-1,Number.MAX_SAFE_INTEGER,this.original.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),new T.$Kt(this.modified.startLineNumber-1,Number.MAX_SAFE_INTEGER,this.modified.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER))}}i.$3t=L;class d extends L{static fromRangeMappings(c){const $=n.$Tt.join(c.map(w=>n.$Tt.fromRangeInclusive(w.originalRange))),m=n.$Tt.join(c.map(w=>n.$Tt.fromRangeInclusive(w.modifiedRange)));return new d($,m,c)}constructor(c,$,m){super(c,$),this.innerChanges=m}flip(){return new d(this.modified,this.original,this.innerChanges?.map(c=>c.flip()))}withInnerChangesFromLineRanges(){return new d(this.original,this.modified,[this.toRangeMapping()])}}i.$4t=d;class a{constructor(c,$){this.originalRange=c,this.modifiedRange=$}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new a(this.modifiedRange,this.originalRange)}toTextEdit(c){const $=c.getValueOfRange(this.modifiedRange);return new g.$Yt(this.originalRange,$)}}i.$5t=a}),ne(ie[57],re([0,1,10,21,7,9,16,15,6,34,20,33]),function(x,i,t,n,T,g,L,d,a,u,c,$){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$w4=m;function m(E,v,h,o,r,l){let{moves:f,excludedChanges:D}=e(E,v,h,l);if(!l.isValid())return[];const R=E.filter(M=>!D.has(M)),p=b(R,o,r,v,h,l);return(0,T.$Yb)(f,p),f=_(f),f=f.filter(M=>{const j=M.original.toOffsetRange().slice(v).map(I=>I.trim());return j.join(`
`).length>=15&&w(j,I=>I.length>=2)>=2}),f=A(E,f),f}function w(E,v){let h=0;for(const o of E)v(o)&&h++;return h}function e(E,v,h,o){const r=[],l=E.filter(R=>R.modified.isEmpty&&R.original.length>=3).map(R=>new c.$s4(R.original,v,R)),f=new Set(E.filter(R=>R.original.isEmpty&&R.modified.length>=3).map(R=>new c.$s4(R.modified,h,R))),D=new Set;for(const R of l){let p=-1,M;for(const j of f){const S=R.computeSimilarity(j);S>p&&(p=S,M=j)}if(p>.9&&M&&(f.delete(M),r.push(new n.$3t(R.range,M.range)),D.add(R.source),D.add(M.source)),!o.isValid())return{moves:r,excludedChanges:D}}return{moves:r,excludedChanges:D}}function b(E,v,h,o,r,l){const f=[],D=new L.$Gc;for(const S of E)for(let I=S.original.startLineNumber;I<S.original.endLineNumberExclusive-2;I++){const W=`${v[I-1]}:${v[I+1-1]}:${v[I+2-1]}`;D.add(W,{range:new d.$Tt(I,I+3)})}const R=[];E.sort((0,T.$5b)(S=>S.modified.startLineNumber,T.$7b));for(const S of E){let I=[];for(let W=S.modified.startLineNumber;W<S.modified.endLineNumberExclusive-2;W++){const P=`${h[W-1]}:${h[W+1-1]}:${h[W+2-1]}`,H=new d.$Tt(W,W+3),B=[];D.forEach(P,({range:y})=>{for(const J of I)if(J.originalLineRange.endLineNumberExclusive+1===y.endLineNumberExclusive&&J.modifiedLineRange.endLineNumberExclusive+1===H.endLineNumberExclusive){J.originalLineRange=new d.$Tt(J.originalLineRange.startLineNumber,y.endLineNumberExclusive),J.modifiedLineRange=new d.$Tt(J.modifiedLineRange.startLineNumber,H.endLineNumberExclusive),B.push(J);return}const Y={modifiedLineRange:H,originalLineRange:y};R.push(Y),B.push(Y)}),I=B}if(!l.isValid())return[]}R.sort((0,T.$9b)((0,T.$5b)(S=>S.modifiedLineRange.length,T.$7b)));const p=new d.$Ut,M=new d.$Ut;for(const S of R){const I=S.modifiedLineRange.startLineNumber-S.originalLineRange.startLineNumber,W=p.subtractFrom(S.modifiedLineRange),P=M.subtractFrom(S.originalLineRange).getWithDelta(I),H=W.getIntersection(P);for(const B of H.ranges){if(B.length<3)continue;const y=B,Y=B.delta(-I);f.push(new n.$3t(Y,y)),p.addRange(y),M.addRange(Y)}}f.sort((0,T.$5b)(S=>S.original.startLineNumber,T.$7b));const j=new g.$lb(E);for(let S=0;S<f.length;S++){const I=f[S],W=j.findLastMonotonous(Z=>Z.original.startLineNumber<=I.original.startLineNumber),P=(0,g.$gb)(E,Z=>Z.modified.startLineNumber<=I.modified.startLineNumber),H=Math.max(I.original.startLineNumber-W.original.startLineNumber,I.modified.startLineNumber-P.modified.startLineNumber),B=j.findLastMonotonous(Z=>Z.original.startLineNumber<I.original.endLineNumberExclusive),y=(0,g.$gb)(E,Z=>Z.modified.startLineNumber<I.modified.endLineNumberExclusive),Y=Math.max(B.original.endLineNumberExclusive-I.original.endLineNumberExclusive,y.modified.endLineNumberExclusive-I.modified.endLineNumberExclusive);let J;for(J=0;J<H;J++){const Z=I.original.startLineNumber-J-1,C=I.modified.startLineNumber-J-1;if(Z>o.length||C>r.length||p.contains(C)||M.contains(Z)||!N(o[Z-1],r[C-1],l))break}J>0&&(M.addRange(new d.$Tt(I.original.startLineNumber-J,I.original.startLineNumber)),p.addRange(new d.$Tt(I.modified.startLineNumber-J,I.modified.startLineNumber)));let G;for(G=0;G<Y;G++){const Z=I.original.endLineNumberExclusive+G,C=I.modified.endLineNumberExclusive+G;if(Z>o.length||C>r.length||p.contains(C)||M.contains(Z)||!N(o[Z-1],r[C-1],l))break}G>0&&(M.addRange(new d.$Tt(I.original.endLineNumberExclusive,I.original.endLineNumberExclusive+G)),p.addRange(new d.$Tt(I.modified.endLineNumberExclusive,I.modified.endLineNumberExclusive+G))),(J>0||G>0)&&(f[S]=new n.$3t(new d.$Tt(I.original.startLineNumber-J,I.original.endLineNumberExclusive+G),new d.$Tt(I.modified.startLineNumber-J,I.modified.endLineNumberExclusive+G)))}return f}function N(E,v,h){if(E.trim()===v.trim())return!0;if(E.length>300&&v.length>300)return!1;const r=new $.$u4().compute(new u.$v4([E],new a.$Rt(0,1),!1),new u.$v4([v],new a.$Rt(0,1),!1),h);let l=0;const f=t.$m4.invert(r.diffs,E.length);for(const M of f)M.seq1Range.forEach(j=>{(0,c.$r4)(E.charCodeAt(j))||l++});function D(M){let j=0;for(let S=0;S<E.length;S++)(0,c.$r4)(M.charCodeAt(S))||j++;return j}const R=D(E.length>v.length?E:v);return l/R>.6&&R>10}function _(E){if(E.length===0)return E;E.sort((0,T.$5b)(h=>h.original.startLineNumber,T.$7b));const v=[E[0]];for(let h=1;h<E.length;h++){const o=v[v.length-1],r=E[h],l=r.original.startLineNumber-o.original.endLineNumberExclusive,f=r.modified.startLineNumber-o.modified.endLineNumberExclusive;if(l>=0&&f>=0&&l+f<=2){v[v.length-1]=o.join(r);continue}v.push(r)}return v}function A(E,v){const h=new g.$lb(E);return v=v.filter(o=>{const r=h.findLastMonotonous(D=>D.original.startLineNumber<o.original.endLineNumberExclusive)||new n.$3t(new d.$Tt(1,1),new d.$Tt(1,1)),l=(0,g.$gb)(E,D=>D.modified.startLineNumber<o.modified.endLineNumberExclusive);return r!==l}),v}}),ne(ie[58],re([0,1,7,11,15,6,2,10,56,33,57,54,55,34,35,21]),function(x,i,t,n,T,g,L,d,a,u,c,$,m,w,e,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$D4=void 0,i.$E4=_,i.$F4=A;class N{constructor(){this.e=new a.$t4,this.f=new u.$u4}computeDiff(v,h,o){if(v.length<=1&&(0,t.$tb)(v,h,(G,Z)=>G===Z))return new e.$6t([],[],!1);if(v.length===1&&v[0].length===0||h.length===1&&h[0].length===0)return new e.$6t([new b.$4t(new T.$Tt(1,v.length+1),new T.$Tt(1,h.length+1),[new b.$5t(new L.$Kt(1,1,v.length,v[v.length-1].length+1),new L.$Kt(1,1,h.length,h[h.length-1].length+1))])],[],!1);const r=o.maxComputationTimeMs===0?d.$o4.instance:new d.$p4(o.maxComputationTimeMs),l=!o.ignoreTrimWhitespace,f=new Map;function D(G){let Z=f.get(G);return Z===void 0&&(Z=f.size,f.set(G,Z)),Z}const R=v.map(G=>D(G.trim())),p=h.map(G=>D(G.trim())),M=new m.$x4(R,v),j=new m.$x4(p,h),S=M.length+j.length<1700?this.e.compute(M,j,r,(G,Z)=>v[G]===h[Z]?h[Z].length===0?.1:1+Math.log(1+h[Z].length):.99):this.f.compute(M,j,r);let I=S.diffs,W=S.hitTimeout;I=(0,$.$y4)(M,j,I),I=(0,$.$B4)(M,j,I);const P=[],H=G=>{if(l)for(let Z=0;Z<G;Z++){const C=B+Z,F=y+Z;if(v[C]!==h[F]){const X=this.j(v,h,new d.$m4(new g.$Rt(C,C+1),new g.$Rt(F,F+1)),r,l);for(const fe of X.mappings)P.push(fe);X.hitTimeout&&(W=!0)}}};let B=0,y=0;for(const G of I){(0,n.$gd)(()=>G.seq1Range.start-B===G.seq2Range.start-y);const Z=G.seq1Range.start-B;H(Z),B=G.seq1Range.endExclusive,y=G.seq2Range.endExclusive;const C=this.j(v,h,G,r,l);C.hitTimeout&&(W=!0);for(const F of C.mappings)P.push(F)}H(v.length-B);const Y=_(P,v,h);let J=[];return o.computeMoves&&(J=this.h(Y,v,h,R,p,r,l)),(0,n.$gd)(()=>{function G(C,F){if(C.lineNumber<1||C.lineNumber>F.length)return!1;const X=F[C.lineNumber-1];return!(C.column<1||C.column>X.length+1)}function Z(C,F){return!(C.startLineNumber<1||C.startLineNumber>F.length+1||C.endLineNumberExclusive<1||C.endLineNumberExclusive>F.length+1)}for(const C of Y){if(!C.innerChanges)return!1;for(const F of C.innerChanges)if(!(G(F.modifiedRange.getStartPosition(),h)&&G(F.modifiedRange.getEndPosition(),h)&&G(F.originalRange.getStartPosition(),v)&&G(F.originalRange.getEndPosition(),v)))return!1;if(!Z(C.modified,h)||!Z(C.original,v))return!1}return!0}),new e.$6t(Y,J,W)}h(v,h,o,r,l,f,D){return(0,c.$w4)(v,h,o,r,l,f).map(M=>{const j=this.j(h,o,new d.$m4(M.original.toOffsetRange(),M.modified.toOffsetRange()),f,D),S=_(j.mappings,h,o,!0);return new e.$7t(M,S)})}j(v,h,o,r,l){const f=new w.$v4(v,o.seq1Range,l),D=new w.$v4(h,o.seq2Range,l),R=f.length+D.length<500?this.e.compute(f,D,r):this.f.compute(f,D,r);let p=R.diffs;return p=(0,$.$y4)(f,D,p),p=(0,$.$A4)(f,D,p),p=(0,$.$z4)(f,D,p),p=(0,$.$C4)(f,D,p),{mappings:p.map(j=>new b.$5t(f.translateRange(j.seq1Range),D.translateRange(j.seq2Range))),hitTimeout:R.hitTimeout}}}i.$D4=N;function _(E,v,h,o=!1){const r=[];for(const l of(0,t.$zb)(E.map(f=>A(f,v,h)),(f,D)=>f.original.overlapOrTouch(D.original)||f.modified.overlapOrTouch(D.modified))){const f=l[0],D=l[l.length-1];r.push(new b.$4t(f.original.join(D.original),f.modified.join(D.modified),l.map(R=>R.innerChanges[0])))}return(0,n.$gd)(()=>!o&&r.length>0&&(r[0].modified.startLineNumber!==r[0].original.startLineNumber||h.length-r[r.length-1].modified.endLineNumberExclusive!==v.length-r[r.length-1].original.endLineNumberExclusive)?!1:(0,n.$hd)(r,(l,f)=>f.original.startLineNumber-l.original.endLineNumberExclusive===f.modified.startLineNumber-l.modified.endLineNumberExclusive&&l.original.endLineNumberExclusive<f.original.startLineNumber&&l.modified.endLineNumberExclusive<f.modified.startLineNumber)),r}function A(E,v,h){let o=0,r=0;E.modifiedRange.endColumn===1&&E.originalRange.endColumn===1&&E.originalRange.startLineNumber+o<=E.originalRange.endLineNumber&&E.modifiedRange.startLineNumber+o<=E.modifiedRange.endLineNumber&&(r=-1),E.modifiedRange.startColumn-1>=h[E.modifiedRange.startLineNumber-1].length&&E.originalRange.startColumn-1>=v[E.originalRange.startLineNumber-1].length&&E.originalRange.startLineNumber<=E.originalRange.endLineNumber+r&&E.modifiedRange.startLineNumber<=E.modifiedRange.endLineNumber+r&&(o=1);const l=new T.$Tt(E.originalRange.startLineNumber+o,E.originalRange.endLineNumber+1+r),f=new T.$Tt(E.modifiedRange.startLineNumber+o,E.modifiedRange.endLineNumber+1+r);return new b.$4t(l,f,[E])}}),ne(ie[36],re([0,1,3,29,35,21,8,2,11,15]),function(x,i,t,n,T,g,L,d,a,u){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$9t=i.$8t=void 0,L=Pe(L);const c=3;class ${computeDiff(r,l,f){const R=new A(r,l,{maxComputationTime:f.maxComputationTimeMs,shouldIgnoreTrimWhitespace:f.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),p=[];let M=null;for(const j of R.changes){let S;j.originalEndLineNumber===0?S=new u.$Tt(j.originalStartLineNumber+1,j.originalStartLineNumber+1):S=new u.$Tt(j.originalStartLineNumber,j.originalEndLineNumber+1);let I;j.modifiedEndLineNumber===0?I=new u.$Tt(j.modifiedStartLineNumber+1,j.modifiedStartLineNumber+1):I=new u.$Tt(j.modifiedStartLineNumber,j.modifiedEndLineNumber+1);let W=new g.$4t(S,I,j.charChanges?.map(P=>new g.$5t(new d.$Kt(P.originalStartLineNumber,P.originalStartColumn,P.originalEndLineNumber,P.originalEndColumn),new d.$Kt(P.modifiedStartLineNumber,P.modifiedStartColumn,P.modifiedEndLineNumber,P.modifiedEndColumn))));M&&(M.modified.endLineNumberExclusive===W.modified.startLineNumber||M.original.endLineNumberExclusive===W.original.startLineNumber)&&(W=new g.$4t(M.original.join(W.original),M.modified.join(W.modified),M.innerChanges&&W.innerChanges?M.innerChanges.concat(W.innerChanges):void 0),p.pop()),p.push(W),M=W}return(0,a.$gd)(()=>(0,a.$hd)(p,(j,S)=>S.original.startLineNumber-j.original.endLineNumberExclusive===S.modified.startLineNumber-j.modified.endLineNumberExclusive&&j.original.endLineNumberExclusive<S.original.startLineNumber&&j.modified.endLineNumberExclusive<S.modified.startLineNumber)),new T.$6t(p,[],R.quitEarly)}}i.$8t=$;function m(o,r,l,f){return new n.$Qt(o,r,l).ComputeDiff(f)}class w{constructor(r){const l=[],f=[];for(let D=0,R=r.length;D<R;D++)l[D]=E(r[D],1),f[D]=v(r[D],1);this.lines=r,this.a=l,this.b=f}getElements(){const r=[];for(let l=0,f=this.lines.length;l<f;l++)r[l]=this.lines[l].substring(this.a[l]-1,this.b[l]-1);return r}getStrictElement(r){return this.lines[r]}getStartLineNumber(r){return r+1}getEndLineNumber(r){return r+1}createCharSequence(r,l,f){const D=[],R=[],p=[];let M=0;for(let j=l;j<=f;j++){const S=this.lines[j],I=r?this.a[j]:1,W=r?this.b[j]:S.length+1;for(let P=I;P<W;P++)D[M]=S.charCodeAt(P-1),R[M]=j+1,p[M]=P,M++;!r&&j<f&&(D[M]=t.CharCode.LineFeed,R[M]=j+1,p[M]=S.length+1,M++)}return new e(D,R,p)}}class e{constructor(r,l,f){this.a=r,this.b=l,this.d=f}toString(){return"["+this.a.map((r,l)=>(r===t.CharCode.LineFeed?"\\n":String.fromCharCode(r))+`-(${this.b[l]},${this.d[l]})`).join(", ")+"]"}e(r,l){if(r<0||r>=l.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(r){return r>0&&r===this.b.length?this.getEndLineNumber(r-1):(this.e(r,this.b),this.b[r])}getEndLineNumber(r){return r===-1?this.getStartLineNumber(r+1):(this.e(r,this.b),this.a[r]===t.CharCode.LineFeed?this.b[r]+1:this.b[r])}getStartColumn(r){return r>0&&r===this.d.length?this.getEndColumn(r-1):(this.e(r,this.d),this.d[r])}getEndColumn(r){return r===-1?this.getStartColumn(r+1):(this.e(r,this.d),this.a[r]===t.CharCode.LineFeed?1:this.d[r]+1)}}class b{constructor(r,l,f,D,R,p,M,j){this.originalStartLineNumber=r,this.originalStartColumn=l,this.originalEndLineNumber=f,this.originalEndColumn=D,this.modifiedStartLineNumber=R,this.modifiedStartColumn=p,this.modifiedEndLineNumber=M,this.modifiedEndColumn=j}static createFromDiffChange(r,l,f){const D=l.getStartLineNumber(r.originalStart),R=l.getStartColumn(r.originalStart),p=l.getEndLineNumber(r.originalStart+r.originalLength-1),M=l.getEndColumn(r.originalStart+r.originalLength-1),j=f.getStartLineNumber(r.modifiedStart),S=f.getStartColumn(r.modifiedStart),I=f.getEndLineNumber(r.modifiedStart+r.modifiedLength-1),W=f.getEndColumn(r.modifiedStart+r.modifiedLength-1);return new b(D,R,p,M,j,S,I,W)}}function N(o){if(o.length<=1)return o;const r=[o[0]];let l=r[0];for(let f=1,D=o.length;f<D;f++){const R=o[f],p=R.originalStart-(l.originalStart+l.originalLength),M=R.modifiedStart-(l.modifiedStart+l.modifiedLength);Math.min(p,M)<c?(l.originalLength=R.originalStart+R.originalLength-l.originalStart,l.modifiedLength=R.modifiedStart+R.modifiedLength-l.modifiedStart):(r.push(R),l=R)}return r}class _{constructor(r,l,f,D,R){this.originalStartLineNumber=r,this.originalEndLineNumber=l,this.modifiedStartLineNumber=f,this.modifiedEndLineNumber=D,this.charChanges=R}static createFromDiffResult(r,l,f,D,R,p,M){let j,S,I,W,P;if(l.originalLength===0?(j=f.getStartLineNumber(l.originalStart)-1,S=0):(j=f.getStartLineNumber(l.originalStart),S=f.getEndLineNumber(l.originalStart+l.originalLength-1)),l.modifiedLength===0?(I=D.getStartLineNumber(l.modifiedStart)-1,W=0):(I=D.getStartLineNumber(l.modifiedStart),W=D.getEndLineNumber(l.modifiedStart+l.modifiedLength-1)),p&&l.originalLength>0&&l.originalLength<20&&l.modifiedLength>0&&l.modifiedLength<20&&R()){const H=f.createCharSequence(r,l.originalStart,l.originalStart+l.originalLength-1),B=D.createCharSequence(r,l.modifiedStart,l.modifiedStart+l.modifiedLength-1);if(H.getElements().length>0&&B.getElements().length>0){let y=m(H,B,R,!0).changes;M&&(y=N(y)),P=[];for(let Y=0,J=y.length;Y<J;Y++)P.push(b.createFromDiffChange(y[Y],H,B))}}return new _(j,S,I,W,P)}}class A{constructor(r,l,f){this.a=f.shouldComputeCharChanges,this.b=f.shouldPostProcessCharChanges,this.d=f.shouldIgnoreTrimWhitespace,this.e=f.shouldMakePrettyDiff,this.f=r,this.g=l,this.h=new w(r),this.j=new w(l),this.k=h(f.maxComputationTime),this.l=h(f.maxComputationTime===0?0:Math.min(f.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const r=m(this.h,this.j,this.k,this.e),l=r.changes,f=r.quitEarly;if(this.d){const M=[];for(let j=0,S=l.length;j<S;j++)M.push(_.createFromDiffResult(this.d,l[j],this.h,this.j,this.l,this.a,this.b));return{quitEarly:f,changes:M}}const D=[];let R=0,p=0;for(let M=-1,j=l.length;M<j;M++){const S=M+1<j?l[M+1]:null,I=S?S.originalStart:this.f.length,W=S?S.modifiedStart:this.g.length;for(;R<I&&p<W;){const P=this.f[R],H=this.g[p];if(P!==H){{let B=E(P,1),y=E(H,1);for(;B>1&&y>1;){const Y=P.charCodeAt(B-2),J=H.charCodeAt(y-2);if(Y!==J)break;B--,y--}(B>1||y>1)&&this.m(D,R+1,1,B,p+1,1,y)}{let B=v(P,1),y=v(H,1);const Y=P.length+1,J=H.length+1;for(;B<Y&&y<J;){const G=P.charCodeAt(B-1),Z=P.charCodeAt(y-1);if(G!==Z)break;B++,y++}(B<Y||y<J)&&this.m(D,R+1,B,Y,p+1,y,J)}}R++,p++}S&&(D.push(_.createFromDiffResult(this.d,S,this.h,this.j,this.l,this.a,this.b)),R+=S.originalLength,p+=S.modifiedLength)}return{quitEarly:f,changes:D}}m(r,l,f,D,R,p,M){if(this.n(r,l,f,D,R,p,M))return;let j;this.a&&(j=[new b(l,f,l,D,R,p,R,M)]),r.push(new _(l,l,R,R,j))}n(r,l,f,D,R,p,M){const j=r.length;if(j===0)return!1;const S=r[j-1];return S.originalEndLineNumber===0||S.modifiedEndLineNumber===0?!1:S.originalEndLineNumber===l&&S.modifiedEndLineNumber===R?(this.a&&S.charChanges&&S.charChanges.push(new b(l,f,l,D,R,p,R,M)),!0):S.originalEndLineNumber+1===l&&S.modifiedEndLineNumber+1===R?(S.originalEndLineNumber=l,S.modifiedEndLineNumber=R,this.a&&S.charChanges&&S.charChanges.push(new b(l,f,l,D,R,p,R,M)),!0):!1}}i.$9t=A;function E(o,r){const l=L.$sf(o);return l===-1?r:l+1}function v(o,r){const l=L.$uf(o);return l===-1?r:l+2}function h(o){if(o===0)return()=>!0;const r=Date.now();return()=>Date.now()-r<o}}),ne(ie[59],re([0,1,36,58]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$G4=void 0,i.$G4={getLegacy:()=>new t.$8t,getDefault:()=>new n.$D4}}),ne(ie[60],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$qu=i.MetadataConsts=i.StandardTokenType=i.ColorId=i.FontStyle=i.LanguageId=void 0;var t;(function(a){a[a.Null=0]="Null",a[a.PlainText=1]="PlainText"})(t||(i.LanguageId=t={}));var n;(function(a){a[a.NotSet=-1]="NotSet",a[a.None=0]="None",a[a.Italic=1]="Italic",a[a.Bold=2]="Bold",a[a.Underline=4]="Underline",a[a.Strikethrough=8]="Strikethrough"})(n||(i.FontStyle=n={}));var T;(function(a){a[a.None=0]="None",a[a.DefaultForeground=1]="DefaultForeground",a[a.DefaultBackground=2]="DefaultBackground"})(T||(i.ColorId=T={}));var g;(function(a){a[a.Other=0]="Other",a[a.Comment=1]="Comment",a[a.String=2]="String",a[a.RegEx=3]="RegEx"})(g||(i.StandardTokenType=g={}));var L;(function(a){a[a.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",a[a.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",a[a.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",a[a.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",a[a.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",a[a.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",a[a.ITALIC_MASK=2048]="ITALIC_MASK",a[a.BOLD_MASK=4096]="BOLD_MASK",a[a.UNDERLINE_MASK=8192]="UNDERLINE_MASK",a[a.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",a[a.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",a[a.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",a[a.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",a[a.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",a[a.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",a[a.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",a[a.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",a[a.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",a[a.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",a[a.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",a[a.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",a[a.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(L||(i.MetadataConsts=L={}));class d{static getLanguageId(u){return(u&L.LANGUAGEID_MASK)>>>L.LANGUAGEID_OFFSET}static getTokenType(u){return(u&L.TOKEN_TYPE_MASK)>>>L.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(u){return(u&L.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(u){return(u&L.FONT_STYLE_MASK)>>>L.FONT_STYLE_OFFSET}static getForeground(u){return(u&L.FOREGROUND_MASK)>>>L.FOREGROUND_OFFSET}static getBackground(u){return(u&L.BACKGROUND_MASK)>>>L.BACKGROUND_OFFSET}static getClassNameFromMetadata(u){let $="mtk"+this.getForeground(u);const m=this.getFontStyle(u);return m&n.Italic&&($+=" mtki"),m&n.Bold&&($+=" mtkb"),m&n.Underline&&($+=" mtku"),m&n.Strikethrough&&($+=" mtks"),$}static getInlineStyleFromMetadata(u,c){const $=this.getForeground(u),m=this.getFontStyle(u);let w=`color: ${c[$]};`;m&n.Italic&&(w+="font-style: italic;"),m&n.Bold&&(w+="font-weight: bold;");let e="";return m&n.Underline&&(e+=" underline"),m&n.Strikethrough&&(e+=" line-through"),e&&(w+=`text-decoration:${e};`),w}static getPresentationFromMetadata(u){const c=this.getForeground(u),$=this.getFontStyle(u);return{foreground:c,italic:!!($&n.Italic),bold:!!($&n.Bold),underline:!!($&n.Underline),strikethrough:!!($&n.Strikethrough)}}}i.$qu=d}),ne(ie[61],re([0,1,38]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$H4=$;function n(m){const w=[];for(const e of m){const b=Number(e);(b||b===0&&e.replace(/\s/g,"")!=="")&&w.push(b)}return w}function T(m,w,e,b){return{red:m/255,blue:e/255,green:w/255,alpha:b}}function g(m,w){const e=w.index,b=w[0].length;if(!e)return;const N=m.positionAt(e);return{startLineNumber:N.lineNumber,startColumn:N.column,endLineNumber:N.lineNumber,endColumn:N.column+b}}function L(m,w){if(!m)return;const e=t.$ju.Format.CSS.parseHex(w);if(e)return{range:m,color:T(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function d(m,w,e){if(!m||w.length!==1)return;const N=w[0].values(),_=n(N);return{range:m,color:T(_[0],_[1],_[2],e?_[3]:1)}}function a(m,w,e){if(!m||w.length!==1)return;const N=w[0].values(),_=n(N),A=new t.$ju(new t.$hu(_[0],_[1]/100,_[2]/100,e?_[3]:1));return{range:m,color:T(A.rgba.r,A.rgba.g,A.rgba.b,A.rgba.a)}}function u(m,w){return typeof m=="string"?[...m.matchAll(w)]:m.findMatches(w)}function c(m){const w=[],b=u(m,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(b.length>0)for(const N of b){const _=N.filter(h=>h!==void 0),A=_[1],E=_[2];if(!E)continue;let v;if(A==="rgb"){const h=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;v=d(g(m,N),u(E,h),!1)}else if(A==="rgba"){const h=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;v=d(g(m,N),u(E,h),!0)}else if(A==="hsl"){const h=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;v=a(g(m,N),u(E,h),!1)}else if(A==="hsla"){const h=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;v=a(g(m,N),u(E,h),!0)}else A==="#"&&(v=L(g(m,N),A+E));v&&w.push(v)}return w}function $(m){return!m||typeof m.getValue!="function"||typeof m.positionAt!="function"?[]:c(m)}}),ne(ie[62],re([0,1,3,30]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$g4=i.$f4=i.State=void 0,i.$h4=w;var T;(function(e){e[e.Invalid=0]="Invalid",e[e.Start=1]="Start",e[e.H=2]="H",e[e.HT=3]="HT",e[e.HTT=4]="HTT",e[e.HTTP=5]="HTTP",e[e.F=6]="F",e[e.FI=7]="FI",e[e.FIL=8]="FIL",e[e.BeforeColon=9]="BeforeColon",e[e.AfterColon=10]="AfterColon",e[e.AlmostThere=11]="AlmostThere",e[e.End=12]="End",e[e.Accept=13]="Accept",e[e.LastKnownState=14]="LastKnownState"})(T||(i.State=T={}));class g{constructor(b,N,_){const A=new Uint8Array(b*N);for(let E=0,v=b*N;E<v;E++)A[E]=_;this.a=A,this.rows=b,this.cols=N}get(b,N){return this.a[b*this.cols+N]}set(b,N,_){this.a[b*this.cols+N]=_}}class L{constructor(b){let N=0,_=T.Invalid;for(let E=0,v=b.length;E<v;E++){const[h,o,r]=b[E];o>N&&(N=o),h>_&&(_=h),r>_&&(_=r)}N++,_++;const A=new g(_,N,T.Invalid);for(let E=0,v=b.length;E<v;E++){const[h,o,r]=b[E];A.set(h,o,r)}this.a=A,this.b=N}nextState(b,N){return N<0||N>=this.b?T.Invalid:this.a.get(b,N)}}i.$f4=L;let d=null;function a(){return d===null&&(d=new L([[T.Start,t.CharCode.h,T.H],[T.Start,t.CharCode.H,T.H],[T.Start,t.CharCode.f,T.F],[T.Start,t.CharCode.F,T.F],[T.H,t.CharCode.t,T.HT],[T.H,t.CharCode.T,T.HT],[T.HT,t.CharCode.t,T.HTT],[T.HT,t.CharCode.T,T.HTT],[T.HTT,t.CharCode.p,T.HTTP],[T.HTT,t.CharCode.P,T.HTTP],[T.HTTP,t.CharCode.s,T.BeforeColon],[T.HTTP,t.CharCode.S,T.BeforeColon],[T.HTTP,t.CharCode.Colon,T.AfterColon],[T.F,t.CharCode.i,T.FI],[T.F,t.CharCode.I,T.FI],[T.FI,t.CharCode.l,T.FIL],[T.FI,t.CharCode.L,T.FIL],[T.FIL,t.CharCode.e,T.BeforeColon],[T.FIL,t.CharCode.E,T.BeforeColon],[T.BeforeColon,t.CharCode.Colon,T.AfterColon],[T.AfterColon,t.CharCode.Slash,T.AlmostThere],[T.AlmostThere,t.CharCode.Slash,T.End]])),d}var u;(function(e){e[e.None=0]="None",e[e.ForceTermination=1]="ForceTermination",e[e.CannotEndIn=2]="CannotEndIn"})(u||(u={}));let c=null;function $(){if(c===null){c=new n.$cu(u.None);const e=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let N=0;N<e.length;N++)c.set(e.charCodeAt(N),u.ForceTermination);const b=".,;:";for(let N=0;N<b.length;N++)c.set(b.charCodeAt(N),u.CannotEndIn)}return c}class m{static a(b,N,_,A,E){let v=E-1;do{const h=N.charCodeAt(v);if(b.get(h)!==u.CannotEndIn)break;v--}while(v>A);if(A>0){const h=N.charCodeAt(A-1),o=N.charCodeAt(v);(h===t.CharCode.OpenParen&&o===t.CharCode.CloseParen||h===t.CharCode.OpenSquareBracket&&o===t.CharCode.CloseSquareBracket||h===t.CharCode.OpenCurlyBrace&&o===t.CharCode.CloseCurlyBrace)&&v--}return{range:{startLineNumber:_,startColumn:A+1,endLineNumber:_,endColumn:v+2},url:N.substring(A,v+1)}}static computeLinks(b,N=a()){const _=$(),A=[];for(let E=1,v=b.getLineCount();E<=v;E++){const h=b.getLineContent(E),o=h.length;let r=0,l=0,f=0,D=T.Start,R=!1,p=!1,M=!1,j=!1;for(;r<o;){let S=!1;const I=h.charCodeAt(r);if(D===T.Accept){let W;switch(I){case t.CharCode.OpenParen:R=!0,W=u.None;break;case t.CharCode.CloseParen:W=R?u.None:u.ForceTermination;break;case t.CharCode.OpenSquareBracket:M=!0,p=!0,W=u.None;break;case t.CharCode.CloseSquareBracket:M=!1,W=p?u.None:u.ForceTermination;break;case t.CharCode.OpenCurlyBrace:j=!0,W=u.None;break;case t.CharCode.CloseCurlyBrace:W=j?u.None:u.ForceTermination;break;case t.CharCode.SingleQuote:case t.CharCode.DoubleQuote:case t.CharCode.BackTick:f===I?W=u.ForceTermination:f===t.CharCode.SingleQuote||f===t.CharCode.DoubleQuote||f===t.CharCode.BackTick?W=u.None:W=u.ForceTermination;break;case t.CharCode.Asterisk:W=f===t.CharCode.Asterisk?u.ForceTermination:u.None;break;case t.CharCode.Pipe:W=f===t.CharCode.Pipe?u.ForceTermination:u.None;break;case t.CharCode.Space:W=M?u.None:u.ForceTermination;break;default:W=_.get(I)}W===u.ForceTermination&&(A.push(m.a(_,h,E,l,r)),S=!0)}else if(D===T.End){let W;I===t.CharCode.OpenSquareBracket?(p=!0,W=u.None):W=_.get(I),W===u.ForceTermination?S=!0:D=T.Accept}else D=N.nextState(D,I),D===T.Invalid&&(S=!0);S&&(D=T.Start,R=!1,p=!1,j=!1,l=r+1,f=I),r++}D===T.Accept&&A.push(m.a(_,h,E,l,o))}return A}}i.$g4=m;function w(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:m.computeLinks(e)}}),ne(ie[63],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$i4=void 0;class t{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new t}navigateValueSet(T,g,L,d,a){if(T&&g){const u=this.a(g,a);if(u)return{range:T,value:u}}if(L&&d){const u=this.a(d,a);if(u)return{range:L,value:u}}return null}a(T,g){const L=this.b(T,g);return L!==null?L:this.d(T,g)}b(T,g){const L=Math.pow(10,T.length-(T.lastIndexOf(".")+1));let d=Number(T);const a=parseFloat(T);return!isNaN(d)&&!isNaN(a)&&d===a?d===0&&!g?null:(d=Math.floor(d*L),d+=g?L:-L,String(d/L)):null}d(T,g){return this.e(this.c,T,g)}e(T,g,L){let d=null;for(let a=0,u=T.length;d===null&&a<u;a++)d=this.f(T[a],g,L);return d}f(T,g,L){let d=T.indexOf(g);return d>=0?(d+=L?1:-1,d<0?d=T.length-1:d%=T.length,T[d]):null}}i.$i4=t}),ne(ie[64],re([0,1,18]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$dw=i.$cw=i.$bw=i.ModelConstants=i.PositionAffinity=i.TrackedRangeStickiness=i.$_v=i.$$v=i.EndOfLineSequence=i.DefaultEndOfLine=i.EndOfLinePreference=i.InjectedTextCursorStops=i.MinimapSectionHeaderStyle=i.MinimapPosition=i.GlyphMarginLane=i.OverviewRulerLane=void 0,i.$aw=e,i.$ew=v;var n;(function(h){h[h.Left=1]="Left",h[h.Center=2]="Center",h[h.Right=4]="Right",h[h.Full=7]="Full"})(n||(i.OverviewRulerLane=n={}));var T;(function(h){h[h.Left=1]="Left",h[h.Center=2]="Center",h[h.Right=3]="Right"})(T||(i.GlyphMarginLane=T={}));var g;(function(h){h[h.Inline=1]="Inline",h[h.Gutter=2]="Gutter"})(g||(i.MinimapPosition=g={}));var L;(function(h){h[h.Normal=1]="Normal",h[h.Underlined=2]="Underlined"})(L||(i.MinimapSectionHeaderStyle=L={}));var d;(function(h){h[h.Both=0]="Both",h[h.Right=1]="Right",h[h.Left=2]="Left",h[h.None=3]="None"})(d||(i.InjectedTextCursorStops=d={}));var a;(function(h){h[h.TextDefined=0]="TextDefined",h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(a||(i.EndOfLinePreference=a={}));var u;(function(h){h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(u||(i.DefaultEndOfLine=u={}));var c;(function(h){h[h.LF=0]="LF",h[h.CRLF=1]="CRLF"})(c||(i.EndOfLineSequence=c={}));class ${get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(o){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,o.tabSize|0),o.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,o.indentSize|0),this.a=!1),this.insertSpaces=!!o.insertSpaces,this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=!!o.trimAutoWhitespace,this.bracketPairColorizationOptions=o.bracketPairColorizationOptions}equals(o){return this.tabSize===o.tabSize&&this.a===o.a&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace&&(0,t.$eo)(this.bracketPairColorizationOptions,o.bracketPairColorizationOptions)}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}i.$$v=$;class m{constructor(o,r){this._findMatchBrand=void 0,this.range=o,this.matches=r}}i.$_v=m;var w;(function(h){h[h.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",h[h.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",h[h.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",h[h.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(w||(i.TrackedRangeStickiness=w={}));function e(h){return h&&typeof h.read=="function"}var b;(function(h){h[h.Left=0]="Left",h[h.Right=1]="Right",h[h.None=2]="None",h[h.LeftOfInjectedText=3]="LeftOfInjectedText",h[h.RightOfInjectedText=4]="RightOfInjectedText"})(b||(i.PositionAffinity=b={}));var N;(function(h){h[h.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(N||(i.ModelConstants=N={}));class _{constructor(o,r,l,f,D,R){this.identifier=o,this.range=r,this.text=l,this.forceMoveMarkers=f,this.isAutoWhitespaceEdit=D,this._isTracked=R}}i.$bw=_;class A{constructor(o,r,l){this.regex=o,this.wordSeparators=r,this.simpleSearch=l}}i.$cw=A;class E{constructor(o,r,l){this.reverseEdits=o,this.changes=r,this.trimAutoWhitespaceLineNumbers=l}}i.$dw=E;function v(h){return!h.isTooLargeForSyncing()&&!h.isForSimpleWidget}}),ne(ie[65],re([0,1,7,14]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$jw=i.$iw=i.$hw=void 0;class T{constructor(a){this.a=a,this.b=new Uint32Array(a.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(a,u){a=(0,n.$_e)(a);const c=this.a,$=this.b,m=u.length;return m===0?!1:(this.a=new Uint32Array(c.length+m),this.a.set(c.subarray(0,a),0),this.a.set(c.subarray(a),a+m),this.a.set(u,a),a-1<this.c[0]&&(this.c[0]=a-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set($.subarray(0,this.c[0]+1)),!0)}setValue(a,u){return a=(0,n.$_e)(a),u=(0,n.$_e)(u),this.a[a]===u?!1:(this.a[a]=u,a-1<this.c[0]&&(this.c[0]=a-1),!0)}removeValues(a,u){a=(0,n.$_e)(a),u=(0,n.$_e)(u);const c=this.a,$=this.b;if(a>=c.length)return!1;const m=c.length-a;return u>=m&&(u=m),u===0?!1:(this.a=new Uint32Array(c.length-u),this.a.set(c.subarray(0,a),0),this.a.set(c.subarray(a+u),a),this.b=new Uint32Array(this.a.length),a-1<this.c[0]&&(this.c[0]=a-1),this.c[0]>=0&&this.b.set($.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(a){return a<0?0:(a=(0,n.$_e)(a),this.d(a))}d(a){if(a<=this.c[0])return this.b[a];let u=this.c[0]+1;u===0&&(this.b[0]=this.a[0],u++),a>=this.a.length&&(a=this.a.length-1);for(let c=u;c<=a;c++)this.b[c]=this.b[c-1]+this.a[c];return this.c[0]=Math.max(this.c[0],a),this.b[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let u=0,c=this.a.length-1,$=0,m=0,w=0;for(;u<=c;)if($=u+(c-u)/2|0,m=this.b[$],w=m-this.a[$],a<w)c=$-1;else if(a>=m)u=$+1;else break;return new L($,a-w)}}i.$hw=T;class g{constructor(a){this.a=a,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(a){return this.g(),a===0?0:this.d[a-1]}getIndexOf(a){this.g();const u=this.e[a],c=u>0?this.d[u-1]:0;return new L(u,a-c)}removeValues(a,u){this.a.splice(a,u),this.f(a)}insertValues(a,u){this.a=(0,t.$Ub)(this.a,a,u),this.f(a)}f(a){this.b=!1,this.c=Math.min(this.c,a-1)}g(){if(!this.b){for(let a=this.c+1,u=this.a.length;a<u;a++){const c=this.a[a],$=a>0?this.d[a-1]:0;this.d[a]=$+c;for(let m=0;m<c;m++)this.e[$+m]=a}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(a,u){this.a[a]!==u&&(this.a[a]=u,this.f(a))}}i.$iw=g;class L{constructor(a,u){this.index=a,this.remainder=u,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=u}}i.$jw=L}),ne(ie[66],re([0,1,8,5,65]),function(x,i,t,n,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$kw=void 0;class g{constructor(d,a,u,c){this.d=d,this.f=a,this.g=u,this.h=c,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(d){d.eol&&d.eol!==this.g&&(this.g=d.eol,this.j=null);const a=d.changes;for(const u of a)this.o(u.range),this.p(new n.$Jt(u.range.startLineNumber,u.range.startColumn),u.text);this.h=d.versionId,this.k=null}l(){if(!this.j){const d=this.g.length,a=this.f.length,u=new Uint32Array(a);for(let c=0;c<a;c++)u[c]=this.f[c].length+d;this.j=new T.$hw(u)}}n(d,a){this.f[d]=a,this.j&&this.j.setValue(d,this.f[d].length+this.g.length)}o(d){if(d.startLineNumber===d.endLineNumber){if(d.startColumn===d.endColumn)return;this.n(d.startLineNumber-1,this.f[d.startLineNumber-1].substring(0,d.startColumn-1)+this.f[d.startLineNumber-1].substring(d.endColumn-1));return}this.n(d.startLineNumber-1,this.f[d.startLineNumber-1].substring(0,d.startColumn-1)+this.f[d.endLineNumber-1].substring(d.endColumn-1)),this.f.splice(d.startLineNumber,d.endLineNumber-d.startLineNumber),this.j&&this.j.removeValues(d.startLineNumber,d.endLineNumber-d.startLineNumber)}p(d,a){if(a.length===0)return;const u=(0,t.$qf)(a);if(u.length===1){this.n(d.lineNumber-1,this.f[d.lineNumber-1].substring(0,d.column-1)+u[0]+this.f[d.lineNumber-1].substring(d.column-1));return}u[u.length-1]+=this.f[d.lineNumber-1].substring(d.column-1),this.n(d.lineNumber-1,this.f[d.lineNumber-1].substring(0,d.column-1)+u[0]);const c=new Uint32Array(u.length-1);for(let $=1;$<u.length;$++)this.f.splice(d.lineNumber+$-1,0,u[$]),c[$-1]=u[$].length+this.g.length;this.j&&this.j.insertValues(d.lineNumber,c)}}i.$kw=g}),ne(ie[67],re([0,1,3,8,53,5,2,64]),function(x,i,t,n,T,g,L,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$dD=i.$bD=i.$$C=void 0,i.$_C=c,i.$aD=$,i.$cD=N,n=Pe(n);const a=999;class u{constructor(E,v,h,o){this.searchString=E,this.isRegex=v,this.matchCase=h,this.wordSeparators=o}parseSearchRequest(){if(this.searchString==="")return null;let E;this.isRegex?E=c(this.searchString):E=this.searchString.indexOf(`
`)>=0;let v=null;try{v=n.$of(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:E,global:!0,unicode:!0})}catch{return null}if(!v)return null;let h=!this.isRegex&&!E;return h&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(h=this.matchCase),new d.$cw(v,this.wordSeparators?(0,T.$fu)(this.wordSeparators,[]):null,h?this.searchString:null)}}i.$$C=u;function c(A){if(!A||A.length===0)return!1;for(let E=0,v=A.length;E<v;E++){const h=A.charCodeAt(E);if(h===t.CharCode.LineFeed)return!0;if(h===t.CharCode.Backslash){if(E++,E>=v)break;const o=A.charCodeAt(E);if(o===t.CharCode.n||o===t.CharCode.r||o===t.CharCode.W)return!0}}return!1}function $(A,E,v){if(!v)return new d.$_v(A,null);const h=[];for(let o=0,r=E.length;o<r;o++)h[o]=E[o];return new d.$_v(A,h)}class m{constructor(E){const v=[];let h=0;for(let o=0,r=E.length;o<r;o++)E.charCodeAt(o)===t.CharCode.LineFeed&&(v[h++]=o);this.a=v}findLineFeedCountBeforeOffset(E){const v=this.a;let h=0,o=v.length-1;if(o===-1||E<=v[0])return 0;for(;h<o;){const r=h+((o-h)/2>>0);v[r]>=E?o=r-1:v[r+1]>=E?(h=r,o=r):h=r+1}return h+1}}class w{static findMatches(E,v,h,o,r){const l=v.parseSearchRequest();return l?l.regex.multiline?this.b(E,h,new _(l.wordSeparators,l.regex),o,r):this.c(E,h,l,o,r):[]}static a(E,v,h,o,r,l){let f,D=0;o?(D=o.findLineFeedCountBeforeOffset(r),f=v+r+D):f=v+r;let R;if(o){const S=o.findLineFeedCountBeforeOffset(r+l.length)-D;R=f+l.length+S}else R=f+l.length;const p=E.getPositionAt(f),M=E.getPositionAt(R);return new L.$Kt(p.lineNumber,p.column,M.lineNumber,M.column)}static b(E,v,h,o,r){const l=E.getOffsetAt(v.getStartPosition()),f=E.getValueInRange(v,d.EndOfLinePreference.LF),D=E.getEOL()===`\r
`?new m(f):null,R=[];let p=0,M;for(h.reset(0);M=h.next(f);)if(R[p++]=$(this.a(E,l,f,D,M.index,M[0]),M,o),p>=r)return R;return R}static c(E,v,h,o,r){const l=[];let f=0;if(v.startLineNumber===v.endLineNumber){const R=E.getLineContent(v.startLineNumber).substring(v.startColumn-1,v.endColumn-1);return f=this.d(h,R,v.startLineNumber,v.startColumn-1,f,l,o,r),l}const D=E.getLineContent(v.startLineNumber).substring(v.startColumn-1);f=this.d(h,D,v.startLineNumber,v.startColumn-1,f,l,o,r);for(let R=v.startLineNumber+1;R<v.endLineNumber&&f<r;R++)f=this.d(h,E.getLineContent(R),R,0,f,l,o,r);if(f<r){const R=E.getLineContent(v.endLineNumber).substring(0,v.endColumn-1);f=this.d(h,R,v.endLineNumber,0,f,l,o,r)}return l}static d(E,v,h,o,r,l,f,D){const R=E.wordSeparators;if(!f&&E.simpleSearch){const j=E.simpleSearch,S=j.length,I=v.length;let W=-S;for(;(W=v.indexOf(j,W+S))!==-1;)if((!R||N(R,v,I,W,S))&&(l[r++]=new d.$_v(new L.$Kt(h,W+1+o,h,W+1+S+o),null),r>=D))return r;return r}const p=new _(E.wordSeparators,E.regex);let M;p.reset(0);do if(M=p.next(v),M&&(l[r++]=$(new L.$Kt(h,M.index+1+o,h,M.index+1+M[0].length+o),M,f),r>=D))return r;while(M);return r}static findNextMatch(E,v,h,o){const r=v.parseSearchRequest();if(!r)return null;const l=new _(r.wordSeparators,r.regex);return r.regex.multiline?this.e(E,h,l,o):this.f(E,h,l,o)}static e(E,v,h,o){const r=new g.$Jt(v.lineNumber,1),l=E.getOffsetAt(r),f=E.getLineCount(),D=E.getValueInRange(new L.$Kt(r.lineNumber,r.column,f,E.getLineMaxColumn(f)),d.EndOfLinePreference.LF),R=E.getEOL()===`\r
`?new m(D):null;h.reset(v.column-1);const p=h.next(D);return p?$(this.a(E,l,D,R,p.index,p[0]),p,o):v.lineNumber!==1||v.column!==1?this.e(E,new g.$Jt(1,1),h,o):null}static f(E,v,h,o){const r=E.getLineCount(),l=v.lineNumber,f=E.getLineContent(l),D=this.g(h,f,l,v.column,o);if(D)return D;for(let R=1;R<=r;R++){const p=(l+R-1)%r,M=E.getLineContent(p+1),j=this.g(h,M,p+1,1,o);if(j)return j}return null}static g(E,v,h,o,r){E.reset(o-1);const l=E.next(v);return l?$(new L.$Kt(h,l.index+1,h,l.index+1+l[0].length),l,r):null}static findPreviousMatch(E,v,h,o){const r=v.parseSearchRequest();if(!r)return null;const l=new _(r.wordSeparators,r.regex);return r.regex.multiline?this.h(E,h,l,o):this.j(E,h,l,o)}static h(E,v,h,o){const r=this.b(E,new L.$Kt(1,1,v.lineNumber,v.column),h,o,10*a);if(r.length>0)return r[r.length-1];const l=E.getLineCount();return v.lineNumber!==l||v.column!==E.getLineMaxColumn(l)?this.h(E,new g.$Jt(l,E.getLineMaxColumn(l)),h,o):null}static j(E,v,h,o){const r=E.getLineCount(),l=v.lineNumber,f=E.getLineContent(l).substring(0,v.column-1),D=this.k(h,f,l,o);if(D)return D;for(let R=1;R<=r;R++){const p=(r+l-R-1)%r,M=E.getLineContent(p+1),j=this.k(h,M,p+1,o);if(j)return j}return null}static k(E,v,h,o){let r=null,l;for(E.reset(0);l=E.next(v);)r=$(new L.$Kt(h,l.index+1,h,l.index+1+l[0].length),l,o);return r}}i.$bD=w;function e(A,E,v,h,o){if(h===0)return!0;const r=E.charCodeAt(h-1);if(A.get(r)!==T.WordCharacterClass.Regular||r===t.CharCode.CarriageReturn||r===t.CharCode.LineFeed)return!0;if(o>0){const l=E.charCodeAt(h);if(A.get(l)!==T.WordCharacterClass.Regular)return!0}return!1}function b(A,E,v,h,o){if(h+o===v)return!0;const r=E.charCodeAt(h+o);if(A.get(r)!==T.WordCharacterClass.Regular||r===t.CharCode.CarriageReturn||r===t.CharCode.LineFeed)return!0;if(o>0){const l=E.charCodeAt(h+o-1);if(A.get(l)!==T.WordCharacterClass.Regular)return!0}return!1}function N(A,E,v,h,o){return e(A,E,v,h,o)&&b(A,E,v,h,o)}class _{constructor(E,v){this._wordSeparators=E,this.a=v,this.b=-1,this.c=0}reset(E){this.a.lastIndex=E,this.b=-1,this.c=0}next(E){const v=E.length;let h;do{if(this.b+this.c===v||(h=this.a.exec(E),!h))return null;const o=h.index,r=h[0].length;if(o===this.b&&r===this.c){if(r===0){n.$Kf(E,v,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=o,this.c=r,!this._wordSeparators||N(this._wordSeparators,E,v,o,r))return h}while(h);return null}}i.$dD=_}),ne(ie[68],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$I4=T;const t=new RegExp("\\bMARK:\\s*(.*)$","d"),n=/^-+|-+$/g;function T(u,c){let $=[];if(c.findRegionSectionHeaders&&c.foldingRules?.markers){const m=g(u,c);$=$.concat(m)}if(c.findMarkSectionHeaders){const m=L(u);$=$.concat(m)}return $}function g(u,c){const $=[],m=u.getLineCount();for(let w=1;w<=m;w++){const e=u.getLineContent(w),b=e.match(c.foldingRules.markers.start);if(b){const N={startLineNumber:w,startColumn:b[0].length+1,endLineNumber:w,endColumn:e.length+1};if(N.endColumn>N.startColumn){const _={range:N,...a(e.substring(b[0].length)),shouldBeInComments:!1};(_.text||_.hasSeparatorLine)&&$.push(_)}}}return $}function L(u){const c=[],$=u.getLineCount();for(let m=1;m<=$;m++){const w=u.getLineContent(m);d(w,m,c)}return c}function d(u,c,$){t.lastIndex=0;const m=t.exec(u);if(m){const w=m.indices[1][0]+1,e=m.indices[1][1]+1,b={startLineNumber:c,startColumn:w,endLineNumber:c,endColumn:e};if(b.endColumn>b.startColumn){const N={range:b,...a(m[1]),shouldBeInComments:!0};(N.text||N.hasSeparatorLine)&&$.push(N)}}}function a(u){u=u.trim();const c=u.startsWith("-");return u=u.replace(n,""),{text:u,hasSeparatorLine:c}}}),ne(ie[69],re([0,1,2,67,8,11,32]),function(x,i,t,n,T,g,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UnicodeHighlighterReasonKind=i.$e4=void 0,T=Pe(T);class d{static computeUnicodeHighlights(e,b,N){const _=N?N.startLineNumber:1,A=N?N.endLineNumber:e.getLineCount(),E=new c(b),v=E.getCandidateCodePoints();let h;v==="allNonBasicAscii"?h=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):h=new RegExp(`${a(Array.from(v))}`,"g");const o=new n.$dD(null,h),r=[];let l=!1,f,D=0,R=0,p=0;e:for(let M=_,j=A;M<=j;M++){const S=e.getLineContent(M),I=S.length;o.reset(0);do if(f=o.next(S),f){let W=f.index,P=f.index+f[0].length;if(W>0){const Y=S.charCodeAt(W-1);T.$Hf(Y)&&W--}if(P+1<I){const Y=S.charCodeAt(P-1);T.$Hf(Y)&&P++}const H=S.substring(W,P);let B=(0,L.$mt)(W+1,L.$jt,S,0);B&&B.endColumn<=W+1&&(B=null);const y=E.shouldHighlightNonBasicASCII(H,B?B.word:null);if(y!==m.None){if(y===m.Ambiguous?D++:y===m.Invisible?R++:y===m.NonBasicASCII?p++:(0,g.$dd)(y),r.length>=1e3){l=!0;break e}r.push(new t.$Kt(M,W+1,M,P+1))}}while(f)}return{ranges:r,hasMore:l,ambiguousCharacterCount:D,invisibleCharacterCount:R,nonBasicAsciiCharacterCount:p}}static computeUnicodeHighlightReason(e,b){const N=new c(b);switch(N.shouldHighlightNonBasicASCII(e,null)){case m.None:return null;case m.Invisible:return{kind:u.Invisible};case m.Ambiguous:{const A=e.codePointAt(0),E=N.ambiguousCharacters.getPrimaryConfusable(A),v=T.$ag.getLocales().filter(h=>!T.$ag.getInstance(new Set([...b.allowedLocales,h])).isAmbiguous(A));return{kind:u.Ambiguous,confusableWith:String.fromCodePoint(E),notAmbiguousInLocales:v}}case m.NonBasicASCII:return{kind:u.NonBasicAscii}}}}i.$e4=d;function a(w,e){return`[${T.$ff(w.map(N=>String.fromCodePoint(N)).join(""))}]`}var u;(function(w){w[w.Ambiguous=0]="Ambiguous",w[w.Invisible=1]="Invisible",w[w.NonBasicAscii=2]="NonBasicAscii"})(u||(i.UnicodeHighlighterReasonKind=u={}));class c{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=T.$ag.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const b of T.$bg.codePoints)$(String.fromCodePoint(b))||e.add(b);if(this.b.ambiguousCharacters)for(const b of this.ambiguousCharacters.getConfusableCodePoints())e.add(b);for(const b of this.a)e.delete(b);return e}shouldHighlightNonBasicASCII(e,b){const N=e.codePointAt(0);if(this.a.has(N))return m.None;if(this.b.nonBasicASCII)return m.NonBasicASCII;let _=!1,A=!1;if(b)for(const E of b){const v=E.codePointAt(0),h=T.$Sf(E);_=_||h,!h&&!this.ambiguousCharacters.isAmbiguous(v)&&!T.$bg.isInvisibleCharacter(v)&&(A=!0)}return!_&&A?m.None:this.b.invisibleCharacters&&!$(e)&&T.$bg.isInvisibleCharacter(N)?m.Invisible:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(N)?m.Ambiguous:m.None}}function $(w){return w===" "||w===`
`||w==="	"}var m;(function(w){w[w.None=0]="None",w[w.NonBasicASCII=1]="NonBasicASCII",w[w.Invisible=2]="Invisible",w[w.Ambiguous=3]="Ambiguous"})(m||(m={}))}),ne(ie[70],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.WrappingIndent=i.TrackedRangeStickiness=i.TextEditorCursorStyle=i.TextEditorCursorBlinkingStyle=i.SymbolTag=i.SymbolKind=i.SignatureHelpTriggerKind=i.ShowLightbulbIconMode=i.SelectionDirection=i.ScrollbarVisibility=i.ScrollType=i.RenderMinimap=i.RenderLineNumbersType=i.PositionAffinity=i.PartialAcceptTriggerKind=i.OverviewRulerLane=i.OverlayWidgetPositionPreference=i.NewSymbolNameTriggerKind=i.NewSymbolNameTag=i.MouseTargetType=i.MinimapSectionHeaderStyle=i.MinimapPosition=i.MarkerTag=i.MarkerSeverity=i.KeyCode=i.InlineEditTriggerKind=i.InlineCompletionTriggerKind=i.InlayHintKind=i.InjectedTextCursorStops=i.IndentAction=i.HoverVerbosityAction=i.GlyphMarginLane=i.EndOfLineSequence=i.EndOfLinePreference=i.EditorOption=i.EditorAutoIndentStrategy=i.DocumentHighlightKind=i.DefaultEndOfLine=i.CursorChangeReason=i.ContentWidgetPositionPreference=i.CompletionTriggerKind=i.CompletionItemTag=i.CompletionItemKind=i.CompletionItemInsertTextRule=i.CodeActionTriggerType=i.AccessibilitySupport=void 0;var t;(function(s){s[s.Unknown=0]="Unknown",s[s.Disabled=1]="Disabled",s[s.Enabled=2]="Enabled"})(t||(i.AccessibilitySupport=t={}));var n;(function(s){s[s.Invoke=1]="Invoke",s[s.Auto=2]="Auto"})(n||(i.CodeActionTriggerType=n={}));var T;(function(s){s[s.None=0]="None",s[s.KeepWhitespace=1]="KeepWhitespace",s[s.InsertAsSnippet=4]="InsertAsSnippet"})(T||(i.CompletionItemInsertTextRule=T={}));var g;(function(s){s[s.Method=0]="Method",s[s.Function=1]="Function",s[s.Constructor=2]="Constructor",s[s.Field=3]="Field",s[s.Variable=4]="Variable",s[s.Class=5]="Class",s[s.Struct=6]="Struct",s[s.Interface=7]="Interface",s[s.Module=8]="Module",s[s.Property=9]="Property",s[s.Event=10]="Event",s[s.Operator=11]="Operator",s[s.Unit=12]="Unit",s[s.Value=13]="Value",s[s.Constant=14]="Constant",s[s.Enum=15]="Enum",s[s.EnumMember=16]="EnumMember",s[s.Keyword=17]="Keyword",s[s.Text=18]="Text",s[s.Color=19]="Color",s[s.File=20]="File",s[s.Reference=21]="Reference",s[s.Customcolor=22]="Customcolor",s[s.Folder=23]="Folder",s[s.TypeParameter=24]="TypeParameter",s[s.User=25]="User",s[s.Issue=26]="Issue",s[s.Snippet=27]="Snippet"})(g||(i.CompletionItemKind=g={}));var L;(function(s){s[s.Deprecated=1]="Deprecated"})(L||(i.CompletionItemTag=L={}));var d;(function(s){s[s.Invoke=0]="Invoke",s[s.TriggerCharacter=1]="TriggerCharacter",s[s.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(d||(i.CompletionTriggerKind=d={}));var a;(function(s){s[s.EXACT=0]="EXACT",s[s.ABOVE=1]="ABOVE",s[s.BELOW=2]="BELOW"})(a||(i.ContentWidgetPositionPreference=a={}));var u;(function(s){s[s.NotSet=0]="NotSet",s[s.ContentFlush=1]="ContentFlush",s[s.RecoverFromMarkers=2]="RecoverFromMarkers",s[s.Explicit=3]="Explicit",s[s.Paste=4]="Paste",s[s.Undo=5]="Undo",s[s.Redo=6]="Redo"})(u||(i.CursorChangeReason=u={}));var c;(function(s){s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(c||(i.DefaultEndOfLine=c={}));var $;(function(s){s[s.Text=0]="Text",s[s.Read=1]="Read",s[s.Write=2]="Write"})($||(i.DocumentHighlightKind=$={}));var m;(function(s){s[s.None=0]="None",s[s.Keep=1]="Keep",s[s.Brackets=2]="Brackets",s[s.Advanced=3]="Advanced",s[s.Full=4]="Full"})(m||(i.EditorAutoIndentStrategy=m={}));var w;(function(s){s[s.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",s[s.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",s[s.accessibilitySupport=2]="accessibilitySupport",s[s.accessibilityPageSize=3]="accessibilityPageSize",s[s.ariaLabel=4]="ariaLabel",s[s.ariaRequired=5]="ariaRequired",s[s.autoClosingBrackets=6]="autoClosingBrackets",s[s.autoClosingComments=7]="autoClosingComments",s[s.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",s[s.autoClosingDelete=9]="autoClosingDelete",s[s.autoClosingOvertype=10]="autoClosingOvertype",s[s.autoClosingQuotes=11]="autoClosingQuotes",s[s.autoIndent=12]="autoIndent",s[s.automaticLayout=13]="automaticLayout",s[s.autoSurround=14]="autoSurround",s[s.bracketPairColorization=15]="bracketPairColorization",s[s.guides=16]="guides",s[s.codeLens=17]="codeLens",s[s.codeLensFontFamily=18]="codeLensFontFamily",s[s.codeLensFontSize=19]="codeLensFontSize",s[s.colorDecorators=20]="colorDecorators",s[s.colorDecoratorsLimit=21]="colorDecoratorsLimit",s[s.columnSelection=22]="columnSelection",s[s.comments=23]="comments",s[s.contextmenu=24]="contextmenu",s[s.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",s[s.cursorBlinking=26]="cursorBlinking",s[s.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",s[s.cursorStyle=28]="cursorStyle",s[s.cursorSurroundingLines=29]="cursorSurroundingLines",s[s.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",s[s.cursorWidth=31]="cursorWidth",s[s.disableLayerHinting=32]="disableLayerHinting",s[s.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",s[s.domReadOnly=34]="domReadOnly",s[s.dragAndDrop=35]="dragAndDrop",s[s.dropIntoEditor=36]="dropIntoEditor",s[s.emptySelectionClipboard=37]="emptySelectionClipboard",s[s.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",s[s.extraEditorClassName=39]="extraEditorClassName",s[s.fastScrollSensitivity=40]="fastScrollSensitivity",s[s.find=41]="find",s[s.fixedOverflowWidgets=42]="fixedOverflowWidgets",s[s.folding=43]="folding",s[s.foldingStrategy=44]="foldingStrategy",s[s.foldingHighlight=45]="foldingHighlight",s[s.foldingImportsByDefault=46]="foldingImportsByDefault",s[s.foldingMaximumRegions=47]="foldingMaximumRegions",s[s.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",s[s.fontFamily=49]="fontFamily",s[s.fontInfo=50]="fontInfo",s[s.fontLigatures=51]="fontLigatures",s[s.fontSize=52]="fontSize",s[s.fontWeight=53]="fontWeight",s[s.fontVariations=54]="fontVariations",s[s.formatOnPaste=55]="formatOnPaste",s[s.formatOnType=56]="formatOnType",s[s.glyphMargin=57]="glyphMargin",s[s.gotoLocation=58]="gotoLocation",s[s.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",s[s.hover=60]="hover",s[s.inDiffEditor=61]="inDiffEditor",s[s.inlineSuggest=62]="inlineSuggest",s[s.inlineEdit=63]="inlineEdit",s[s.letterSpacing=64]="letterSpacing",s[s.lightbulb=65]="lightbulb",s[s.lineDecorationsWidth=66]="lineDecorationsWidth",s[s.lineHeight=67]="lineHeight",s[s.lineNumbers=68]="lineNumbers",s[s.lineNumbersMinChars=69]="lineNumbersMinChars",s[s.linkedEditing=70]="linkedEditing",s[s.links=71]="links",s[s.matchBrackets=72]="matchBrackets",s[s.minimap=73]="minimap",s[s.mouseStyle=74]="mouseStyle",s[s.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",s[s.mouseWheelZoom=76]="mouseWheelZoom",s[s.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",s[s.multiCursorModifier=78]="multiCursorModifier",s[s.multiCursorPaste=79]="multiCursorPaste",s[s.multiCursorLimit=80]="multiCursorLimit",s[s.occurrencesHighlight=81]="occurrencesHighlight",s[s.overviewRulerBorder=82]="overviewRulerBorder",s[s.overviewRulerLanes=83]="overviewRulerLanes",s[s.padding=84]="padding",s[s.pasteAs=85]="pasteAs",s[s.parameterHints=86]="parameterHints",s[s.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",s[s.placeholder=88]="placeholder",s[s.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",s[s.quickSuggestions=90]="quickSuggestions",s[s.quickSuggestionsDelay=91]="quickSuggestionsDelay",s[s.readOnly=92]="readOnly",s[s.readOnlyMessage=93]="readOnlyMessage",s[s.renameOnType=94]="renameOnType",s[s.renderControlCharacters=95]="renderControlCharacters",s[s.renderFinalNewline=96]="renderFinalNewline",s[s.renderLineHighlight=97]="renderLineHighlight",s[s.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",s[s.renderValidationDecorations=99]="renderValidationDecorations",s[s.renderWhitespace=100]="renderWhitespace",s[s.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",s[s.roundedSelection=102]="roundedSelection",s[s.rulers=103]="rulers",s[s.scrollbar=104]="scrollbar",s[s.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",s[s.scrollBeyondLastLine=106]="scrollBeyondLastLine",s[s.scrollPredominantAxis=107]="scrollPredominantAxis",s[s.selectionClipboard=108]="selectionClipboard",s[s.selectionHighlight=109]="selectionHighlight",s[s.selectOnLineNumbers=110]="selectOnLineNumbers",s[s.showFoldingControls=111]="showFoldingControls",s[s.showUnused=112]="showUnused",s[s.snippetSuggestions=113]="snippetSuggestions",s[s.smartSelect=114]="smartSelect",s[s.smoothScrolling=115]="smoothScrolling",s[s.stickyScroll=116]="stickyScroll",s[s.stickyTabStops=117]="stickyTabStops",s[s.stopRenderingLineAfter=118]="stopRenderingLineAfter",s[s.suggest=119]="suggest",s[s.suggestFontSize=120]="suggestFontSize",s[s.suggestLineHeight=121]="suggestLineHeight",s[s.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",s[s.suggestSelection=123]="suggestSelection",s[s.tabCompletion=124]="tabCompletion",s[s.tabIndex=125]="tabIndex",s[s.unicodeHighlighting=126]="unicodeHighlighting",s[s.unusualLineTerminators=127]="unusualLineTerminators",s[s.useShadowDOM=128]="useShadowDOM",s[s.useTabStops=129]="useTabStops",s[s.wordBreak=130]="wordBreak",s[s.wordSegmenterLocales=131]="wordSegmenterLocales",s[s.wordSeparators=132]="wordSeparators",s[s.wordWrap=133]="wordWrap",s[s.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",s[s.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",s[s.wordWrapColumn=136]="wordWrapColumn",s[s.wordWrapOverride1=137]="wordWrapOverride1",s[s.wordWrapOverride2=138]="wordWrapOverride2",s[s.wrappingIndent=139]="wrappingIndent",s[s.wrappingStrategy=140]="wrappingStrategy",s[s.showDeprecated=141]="showDeprecated",s[s.inlayHints=142]="inlayHints",s[s.editorClassName=143]="editorClassName",s[s.pixelRatio=144]="pixelRatio",s[s.tabFocusMode=145]="tabFocusMode",s[s.layoutInfo=146]="layoutInfo",s[s.wrappingInfo=147]="wrappingInfo",s[s.defaultColorDecorators=148]="defaultColorDecorators",s[s.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",s[s.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(w||(i.EditorOption=w={}));var e;(function(s){s[s.TextDefined=0]="TextDefined",s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(e||(i.EndOfLinePreference=e={}));var b;(function(s){s[s.LF=0]="LF",s[s.CRLF=1]="CRLF"})(b||(i.EndOfLineSequence=b={}));var N;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=3]="Right"})(N||(i.GlyphMarginLane=N={}));var _;(function(s){s[s.Increase=0]="Increase",s[s.Decrease=1]="Decrease"})(_||(i.HoverVerbosityAction=_={}));var A;(function(s){s[s.None=0]="None",s[s.Indent=1]="Indent",s[s.IndentOutdent=2]="IndentOutdent",s[s.Outdent=3]="Outdent"})(A||(i.IndentAction=A={}));var E;(function(s){s[s.Both=0]="Both",s[s.Right=1]="Right",s[s.Left=2]="Left",s[s.None=3]="None"})(E||(i.InjectedTextCursorStops=E={}));var v;(function(s){s[s.Type=1]="Type",s[s.Parameter=2]="Parameter"})(v||(i.InlayHintKind=v={}));var h;(function(s){s[s.Automatic=0]="Automatic",s[s.Explicit=1]="Explicit"})(h||(i.InlineCompletionTriggerKind=h={}));var o;(function(s){s[s.Invoke=0]="Invoke",s[s.Automatic=1]="Automatic"})(o||(i.InlineEditTriggerKind=o={}));var r;(function(s){s[s.DependsOnKbLayout=-1]="DependsOnKbLayout",s[s.Unknown=0]="Unknown",s[s.Backspace=1]="Backspace",s[s.Tab=2]="Tab",s[s.Enter=3]="Enter",s[s.Shift=4]="Shift",s[s.Ctrl=5]="Ctrl",s[s.Alt=6]="Alt",s[s.PauseBreak=7]="PauseBreak",s[s.CapsLock=8]="CapsLock",s[s.Escape=9]="Escape",s[s.Space=10]="Space",s[s.PageUp=11]="PageUp",s[s.PageDown=12]="PageDown",s[s.End=13]="End",s[s.Home=14]="Home",s[s.LeftArrow=15]="LeftArrow",s[s.UpArrow=16]="UpArrow",s[s.RightArrow=17]="RightArrow",s[s.DownArrow=18]="DownArrow",s[s.Insert=19]="Insert",s[s.Delete=20]="Delete",s[s.Digit0=21]="Digit0",s[s.Digit1=22]="Digit1",s[s.Digit2=23]="Digit2",s[s.Digit3=24]="Digit3",s[s.Digit4=25]="Digit4",s[s.Digit5=26]="Digit5",s[s.Digit6=27]="Digit6",s[s.Digit7=28]="Digit7",s[s.Digit8=29]="Digit8",s[s.Digit9=30]="Digit9",s[s.KeyA=31]="KeyA",s[s.KeyB=32]="KeyB",s[s.KeyC=33]="KeyC",s[s.KeyD=34]="KeyD",s[s.KeyE=35]="KeyE",s[s.KeyF=36]="KeyF",s[s.KeyG=37]="KeyG",s[s.KeyH=38]="KeyH",s[s.KeyI=39]="KeyI",s[s.KeyJ=40]="KeyJ",s[s.KeyK=41]="KeyK",s[s.KeyL=42]="KeyL",s[s.KeyM=43]="KeyM",s[s.KeyN=44]="KeyN",s[s.KeyO=45]="KeyO",s[s.KeyP=46]="KeyP",s[s.KeyQ=47]="KeyQ",s[s.KeyR=48]="KeyR",s[s.KeyS=49]="KeyS",s[s.KeyT=50]="KeyT",s[s.KeyU=51]="KeyU",s[s.KeyV=52]="KeyV",s[s.KeyW=53]="KeyW",s[s.KeyX=54]="KeyX",s[s.KeyY=55]="KeyY",s[s.KeyZ=56]="KeyZ",s[s.Meta=57]="Meta",s[s.ContextMenu=58]="ContextMenu",s[s.F1=59]="F1",s[s.F2=60]="F2",s[s.F3=61]="F3",s[s.F4=62]="F4",s[s.F5=63]="F5",s[s.F6=64]="F6",s[s.F7=65]="F7",s[s.F8=66]="F8",s[s.F9=67]="F9",s[s.F10=68]="F10",s[s.F11=69]="F11",s[s.F12=70]="F12",s[s.F13=71]="F13",s[s.F14=72]="F14",s[s.F15=73]="F15",s[s.F16=74]="F16",s[s.F17=75]="F17",s[s.F18=76]="F18",s[s.F19=77]="F19",s[s.F20=78]="F20",s[s.F21=79]="F21",s[s.F22=80]="F22",s[s.F23=81]="F23",s[s.F24=82]="F24",s[s.NumLock=83]="NumLock",s[s.ScrollLock=84]="ScrollLock",s[s.Semicolon=85]="Semicolon",s[s.Equal=86]="Equal",s[s.Comma=87]="Comma",s[s.Minus=88]="Minus",s[s.Period=89]="Period",s[s.Slash=90]="Slash",s[s.Backquote=91]="Backquote",s[s.BracketLeft=92]="BracketLeft",s[s.Backslash=93]="Backslash",s[s.BracketRight=94]="BracketRight",s[s.Quote=95]="Quote",s[s.OEM_8=96]="OEM_8",s[s.IntlBackslash=97]="IntlBackslash",s[s.Numpad0=98]="Numpad0",s[s.Numpad1=99]="Numpad1",s[s.Numpad2=100]="Numpad2",s[s.Numpad3=101]="Numpad3",s[s.Numpad4=102]="Numpad4",s[s.Numpad5=103]="Numpad5",s[s.Numpad6=104]="Numpad6",s[s.Numpad7=105]="Numpad7",s[s.Numpad8=106]="Numpad8",s[s.Numpad9=107]="Numpad9",s[s.NumpadMultiply=108]="NumpadMultiply",s[s.NumpadAdd=109]="NumpadAdd",s[s.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",s[s.NumpadSubtract=111]="NumpadSubtract",s[s.NumpadDecimal=112]="NumpadDecimal",s[s.NumpadDivide=113]="NumpadDivide",s[s.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",s[s.ABNT_C1=115]="ABNT_C1",s[s.ABNT_C2=116]="ABNT_C2",s[s.AudioVolumeMute=117]="AudioVolumeMute",s[s.AudioVolumeUp=118]="AudioVolumeUp",s[s.AudioVolumeDown=119]="AudioVolumeDown",s[s.BrowserSearch=120]="BrowserSearch",s[s.BrowserHome=121]="BrowserHome",s[s.BrowserBack=122]="BrowserBack",s[s.BrowserForward=123]="BrowserForward",s[s.MediaTrackNext=124]="MediaTrackNext",s[s.MediaTrackPrevious=125]="MediaTrackPrevious",s[s.MediaStop=126]="MediaStop",s[s.MediaPlayPause=127]="MediaPlayPause",s[s.LaunchMediaPlayer=128]="LaunchMediaPlayer",s[s.LaunchMail=129]="LaunchMail",s[s.LaunchApp2=130]="LaunchApp2",s[s.Clear=131]="Clear",s[s.MAX_VALUE=132]="MAX_VALUE"})(r||(i.KeyCode=r={}));var l;(function(s){s[s.Hint=1]="Hint",s[s.Info=2]="Info",s[s.Warning=4]="Warning",s[s.Error=8]="Error"})(l||(i.MarkerSeverity=l={}));var f;(function(s){s[s.Unnecessary=1]="Unnecessary",s[s.Deprecated=2]="Deprecated"})(f||(i.MarkerTag=f={}));var D;(function(s){s[s.Inline=1]="Inline",s[s.Gutter=2]="Gutter"})(D||(i.MinimapPosition=D={}));var R;(function(s){s[s.Normal=1]="Normal",s[s.Underlined=2]="Underlined"})(R||(i.MinimapSectionHeaderStyle=R={}));var p;(function(s){s[s.UNKNOWN=0]="UNKNOWN",s[s.TEXTAREA=1]="TEXTAREA",s[s.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",s[s.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",s[s.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",s[s.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",s[s.CONTENT_TEXT=6]="CONTENT_TEXT",s[s.CONTENT_EMPTY=7]="CONTENT_EMPTY",s[s.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",s[s.CONTENT_WIDGET=9]="CONTENT_WIDGET",s[s.OVERVIEW_RULER=10]="OVERVIEW_RULER",s[s.SCROLLBAR=11]="SCROLLBAR",s[s.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",s[s.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(p||(i.MouseTargetType=p={}));var M;(function(s){s[s.AIGenerated=1]="AIGenerated"})(M||(i.NewSymbolNameTag=M={}));var j;(function(s){s[s.Invoke=0]="Invoke",s[s.Automatic=1]="Automatic"})(j||(i.NewSymbolNameTriggerKind=j={}));var S;(function(s){s[s.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",s[s.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",s[s.TOP_CENTER=2]="TOP_CENTER"})(S||(i.OverlayWidgetPositionPreference=S={}));var I;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=4]="Right",s[s.Full=7]="Full"})(I||(i.OverviewRulerLane=I={}));var W;(function(s){s[s.Word=0]="Word",s[s.Line=1]="Line",s[s.Suggest=2]="Suggest"})(W||(i.PartialAcceptTriggerKind=W={}));var P;(function(s){s[s.Left=0]="Left",s[s.Right=1]="Right",s[s.None=2]="None",s[s.LeftOfInjectedText=3]="LeftOfInjectedText",s[s.RightOfInjectedText=4]="RightOfInjectedText"})(P||(i.PositionAffinity=P={}));var H;(function(s){s[s.Off=0]="Off",s[s.On=1]="On",s[s.Relative=2]="Relative",s[s.Interval=3]="Interval",s[s.Custom=4]="Custom"})(H||(i.RenderLineNumbersType=H={}));var B;(function(s){s[s.None=0]="None",s[s.Text=1]="Text",s[s.Blocks=2]="Blocks"})(B||(i.RenderMinimap=B={}));var y;(function(s){s[s.Smooth=0]="Smooth",s[s.Immediate=1]="Immediate"})(y||(i.ScrollType=y={}));var Y;(function(s){s[s.Auto=1]="Auto",s[s.Hidden=2]="Hidden",s[s.Visible=3]="Visible"})(Y||(i.ScrollbarVisibility=Y={}));var J;(function(s){s[s.LTR=0]="LTR",s[s.RTL=1]="RTL"})(J||(i.SelectionDirection=J={}));var G;(function(s){s.Off="off",s.OnCode="onCode",s.On="on"})(G||(i.ShowLightbulbIconMode=G={}));var Z;(function(s){s[s.Invoke=1]="Invoke",s[s.TriggerCharacter=2]="TriggerCharacter",s[s.ContentChange=3]="ContentChange"})(Z||(i.SignatureHelpTriggerKind=Z={}));var C;(function(s){s[s.File=0]="File",s[s.Module=1]="Module",s[s.Namespace=2]="Namespace",s[s.Package=3]="Package",s[s.Class=4]="Class",s[s.Method=5]="Method",s[s.Property=6]="Property",s[s.Field=7]="Field",s[s.Constructor=8]="Constructor",s[s.Enum=9]="Enum",s[s.Interface=10]="Interface",s[s.Function=11]="Function",s[s.Variable=12]="Variable",s[s.Constant=13]="Constant",s[s.String=14]="String",s[s.Number=15]="Number",s[s.Boolean=16]="Boolean",s[s.Array=17]="Array",s[s.Object=18]="Object",s[s.Key=19]="Key",s[s.Null=20]="Null",s[s.EnumMember=21]="EnumMember",s[s.Struct=22]="Struct",s[s.Event=23]="Event",s[s.Operator=24]="Operator",s[s.TypeParameter=25]="TypeParameter"})(C||(i.SymbolKind=C={}));var F;(function(s){s[s.Deprecated=1]="Deprecated"})(F||(i.SymbolTag=F={}));var X;(function(s){s[s.Hidden=0]="Hidden",s[s.Blink=1]="Blink",s[s.Smooth=2]="Smooth",s[s.Phase=3]="Phase",s[s.Expand=4]="Expand",s[s.Solid=5]="Solid"})(X||(i.TextEditorCursorBlinkingStyle=X={}));var fe;(function(s){s[s.Line=1]="Line",s[s.Block=2]="Block",s[s.Underline=3]="Underline",s[s.LineThin=4]="LineThin",s[s.BlockOutline=5]="BlockOutline",s[s.UnderlineThin=6]="UnderlineThin"})(fe||(i.TextEditorCursorStyle=fe={}));var oe;(function(s){s[s.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",s[s.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",s[s.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",s[s.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(oe||(i.TrackedRangeStickiness=oe={}));var we;(function(s){s[s.None=0]="None",s[s.Same=1]="Same",s[s.Indent=2]="Indent",s[s.DeepIndent=3]="DeepIndent"})(we||(i.WrappingIndent=we={}))}),ne(ie[71],re([0,1,13,12,60]),function(x,i,t,n,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$tu=void 0;class g{constructor(){this.a=new Map,this.b=new Map,this.c=new t.$je,this.onDidChange=this.c.event,this.d=null}handleChange(a){this.c.fire({changedLanguages:a,changedColorMap:!1})}register(a,u){return this.a.set(a,u),this.handleChange([a]),(0,n.$Rc)(()=>{this.a.get(a)===u&&(this.a.delete(a),this.handleChange([a]))})}get(a){return this.a.get(a)||null}registerFactory(a,u){this.b.get(a)?.dispose();const c=new L(this,a,u);return this.b.set(a,c),(0,n.$Rc)(()=>{const $=this.b.get(a);!$||$!==c||(this.b.delete(a),$.dispose())})}async getOrCreate(a){const u=this.get(a);if(u)return u;const c=this.b.get(a);return!c||c.isResolved?null:(await c.resolve(),this.get(a))}isResolved(a){if(this.get(a))return!0;const c=this.b.get(a);return!!(!c||c.isResolved)}setColorMap(a){this.d=a,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>T.ColorId.DefaultBackground?this.d[T.ColorId.DefaultBackground]:null}}i.$tu=g;class L extends n.$Tc{get isResolved(){return this.c}constructor(a,u,c){super(),this.f=a,this.g=u,this.h=c,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const a=await this.h.tokenizationSupport;this.c=!0,a&&!this.a&&this.B(this.f.register(this.g,a))}}}),ne(ie[72],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.localize=T,i.localize2=L;const t=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function n(d,a){let u;return a.length===0?u=d:u=d.replace(/\{(\d+)\}/g,(c,$)=>{const m=$[0],w=a[m];let e=c;return typeof w=="string"?e=w:(typeof w=="number"||typeof w=="boolean"||w===void 0||w===null)&&(e=String(w)),e}),t&&(u="\uFF3B"+u.replace(/[aouei]/g,"$&$&")+"\uFF3D"),u}function T(d,a,...u){return n(typeof d=="number"?g(d,a):a,u)}function g(d,a){const u=globalThis._VSCODE_NLS_MESSAGES?.[d];if(typeof u!="string"){if(typeof a=="string")return a;throw new Error(`!!! NLS MISSING: ${d} !!!`)}return u}function L(d,a,...u){let c;typeof d=="number"?c=g(d,a):c=a;const $=n(c,u);return{value:$,original:a===c?$:n(a,u)}}}),ne(ie[73],re([0,1,47,19,49,2,71,72]),function(x,i,t,n,T,g,L,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InlineEditTriggerKind=i.ExternalUriOpenerPriority=i.$Mu=i.$Lu=i.InlayHintKind=i.CommentState=i.CommentMode=i.CommentThreadApplicability=i.CommentThreadState=i.CommentThreadCollapsibleState=i.Command=i.NewSymbolNameTriggerKind=i.NewSymbolNameTag=i.$Ku=i.$Ju=i.SymbolKinds=i.SymbolTag=i.$Hu=i.SymbolKind=i.DocumentHighlightKind=i.SignatureHelpTriggerKind=i.DocumentPasteTriggerKind=i.CodeActionTriggerType=i.$Fu=i.InlineCompletionTriggerKind=i.CompletionTriggerKind=i.PartialAcceptTriggerKind=i.CompletionItemInsertTextRule=i.CompletionItemTag=i.CompletionItemKinds=i.CompletionItemKind=i.HoverVerbosityAction=i.$Eu=i.$Du=i.$Cu=void 0,i.$Gu=l,i.$Iu=D;class a{constructor(X,fe,oe){this.offset=X,this.type=fe,this.language=oe,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}i.$Cu=a;class u{constructor(X,fe){this.tokens=X,this.endState=fe,this._tokenizationResultBrand=void 0}}i.$Du=u;class c{constructor(X,fe){this.tokens=X,this.endState=fe,this._encodedTokenizationResultBrand=void 0}}i.$Eu=c;var $;(function(F){F[F.Increase=0]="Increase",F[F.Decrease=1]="Decrease"})($||(i.HoverVerbosityAction=$={}));var m;(function(F){F[F.Method=0]="Method",F[F.Function=1]="Function",F[F.Constructor=2]="Constructor",F[F.Field=3]="Field",F[F.Variable=4]="Variable",F[F.Class=5]="Class",F[F.Struct=6]="Struct",F[F.Interface=7]="Interface",F[F.Module=8]="Module",F[F.Property=9]="Property",F[F.Event=10]="Event",F[F.Operator=11]="Operator",F[F.Unit=12]="Unit",F[F.Value=13]="Value",F[F.Constant=14]="Constant",F[F.Enum=15]="Enum",F[F.EnumMember=16]="EnumMember",F[F.Keyword=17]="Keyword",F[F.Text=18]="Text",F[F.Color=19]="Color",F[F.File=20]="File",F[F.Reference=21]="Reference",F[F.Customcolor=22]="Customcolor",F[F.Folder=23]="Folder",F[F.TypeParameter=24]="TypeParameter",F[F.User=25]="User",F[F.Issue=26]="Issue",F[F.Snippet=27]="Snippet"})(m||(i.CompletionItemKind=m={}));var w;(function(F){const X=new Map;X.set(m.Method,t.$2j.symbolMethod),X.set(m.Function,t.$2j.symbolFunction),X.set(m.Constructor,t.$2j.symbolConstructor),X.set(m.Field,t.$2j.symbolField),X.set(m.Variable,t.$2j.symbolVariable),X.set(m.Class,t.$2j.symbolClass),X.set(m.Struct,t.$2j.symbolStruct),X.set(m.Interface,t.$2j.symbolInterface),X.set(m.Module,t.$2j.symbolModule),X.set(m.Property,t.$2j.symbolProperty),X.set(m.Event,t.$2j.symbolEvent),X.set(m.Operator,t.$2j.symbolOperator),X.set(m.Unit,t.$2j.symbolUnit),X.set(m.Value,t.$2j.symbolValue),X.set(m.Enum,t.$2j.symbolEnum),X.set(m.Constant,t.$2j.symbolConstant),X.set(m.Enum,t.$2j.symbolEnum),X.set(m.EnumMember,t.$2j.symbolEnumMember),X.set(m.Keyword,t.$2j.symbolKeyword),X.set(m.Snippet,t.$2j.symbolSnippet),X.set(m.Text,t.$2j.symbolText),X.set(m.Color,t.$2j.symbolColor),X.set(m.File,t.$2j.symbolFile),X.set(m.Reference,t.$2j.symbolReference),X.set(m.Customcolor,t.$2j.symbolCustomColor),X.set(m.Folder,t.$2j.symbolFolder),X.set(m.TypeParameter,t.$2j.symbolTypeParameter),X.set(m.User,t.$2j.account),X.set(m.Issue,t.$2j.issues);function fe(s){let Te=X.get(s);return Te||(console.info("No codicon found for CompletionItemKind "+s),Te=t.$2j.symbolProperty),Te}F.toIcon=fe;const oe=new Map;oe.set("method",m.Method),oe.set("function",m.Function),oe.set("constructor",m.Constructor),oe.set("field",m.Field),oe.set("variable",m.Variable),oe.set("class",m.Class),oe.set("struct",m.Struct),oe.set("interface",m.Interface),oe.set("module",m.Module),oe.set("property",m.Property),oe.set("event",m.Event),oe.set("operator",m.Operator),oe.set("unit",m.Unit),oe.set("value",m.Value),oe.set("constant",m.Constant),oe.set("enum",m.Enum),oe.set("enum-member",m.EnumMember),oe.set("enumMember",m.EnumMember),oe.set("keyword",m.Keyword),oe.set("snippet",m.Snippet),oe.set("text",m.Text),oe.set("color",m.Color),oe.set("file",m.File),oe.set("reference",m.Reference),oe.set("customcolor",m.Customcolor),oe.set("folder",m.Folder),oe.set("type-parameter",m.TypeParameter),oe.set("typeParameter",m.TypeParameter),oe.set("account",m.User),oe.set("issue",m.Issue);function we(s,Te){let ke=oe.get(s);return typeof ke>"u"&&!Te&&(ke=m.Property),ke}F.fromString=we})(w||(i.CompletionItemKinds=w={}));var e;(function(F){F[F.Deprecated=1]="Deprecated"})(e||(i.CompletionItemTag=e={}));var b;(function(F){F[F.None=0]="None",F[F.KeepWhitespace=1]="KeepWhitespace",F[F.InsertAsSnippet=4]="InsertAsSnippet"})(b||(i.CompletionItemInsertTextRule=b={}));var N;(function(F){F[F.Word=0]="Word",F[F.Line=1]="Line",F[F.Suggest=2]="Suggest"})(N||(i.PartialAcceptTriggerKind=N={}));var _;(function(F){F[F.Invoke=0]="Invoke",F[F.TriggerCharacter=1]="TriggerCharacter",F[F.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(_||(i.CompletionTriggerKind=_={}));var A;(function(F){F[F.Automatic=0]="Automatic",F[F.Explicit=1]="Explicit"})(A||(i.InlineCompletionTriggerKind=A={}));class E{constructor(X,fe,oe,we){this.range=X,this.text=fe,this.completionKind=oe,this.isSnippetText=we}equals(X){return g.$Kt.lift(this.range).equalsRange(X.range)&&this.text===X.text&&this.completionKind===X.completionKind&&this.isSnippetText===X.isSnippetText}}i.$Fu=E;var v;(function(F){F[F.Invoke=1]="Invoke",F[F.Auto=2]="Auto"})(v||(i.CodeActionTriggerType=v={}));var h;(function(F){F[F.Automatic=0]="Automatic",F[F.PasteAs=1]="PasteAs"})(h||(i.DocumentPasteTriggerKind=h={}));var o;(function(F){F[F.Invoke=1]="Invoke",F[F.TriggerCharacter=2]="TriggerCharacter",F[F.ContentChange=3]="ContentChange"})(o||(i.SignatureHelpTriggerKind=o={}));var r;(function(F){F[F.Text=0]="Text",F[F.Read=1]="Read",F[F.Write=2]="Write"})(r||(i.DocumentHighlightKind=r={}));function l(F){return F&&n.URI.isUri(F.uri)&&g.$Kt.isIRange(F.range)&&(g.$Kt.isIRange(F.originSelectionRange)||g.$Kt.isIRange(F.targetSelectionRange))}var f;(function(F){F[F.File=0]="File",F[F.Module=1]="Module",F[F.Namespace=2]="Namespace",F[F.Package=3]="Package",F[F.Class=4]="Class",F[F.Method=5]="Method",F[F.Property=6]="Property",F[F.Field=7]="Field",F[F.Constructor=8]="Constructor",F[F.Enum=9]="Enum",F[F.Interface=10]="Interface",F[F.Function=11]="Function",F[F.Variable=12]="Variable",F[F.Constant=13]="Constant",F[F.String=14]="String",F[F.Number=15]="Number",F[F.Boolean=16]="Boolean",F[F.Array=17]="Array",F[F.Object=18]="Object",F[F.Key=19]="Key",F[F.Null=20]="Null",F[F.EnumMember=21]="EnumMember",F[F.Struct=22]="Struct",F[F.Event=23]="Event",F[F.Operator=24]="Operator",F[F.TypeParameter=25]="TypeParameter"})(f||(i.SymbolKind=f={})),i.$Hu={[f.Array]:(0,d.localize)(12678,null),[f.Boolean]:(0,d.localize)(12679,null),[f.Class]:(0,d.localize)(12680,null),[f.Constant]:(0,d.localize)(12681,null),[f.Constructor]:(0,d.localize)(12682,null),[f.Enum]:(0,d.localize)(12683,null),[f.EnumMember]:(0,d.localize)(12684,null),[f.Event]:(0,d.localize)(12685,null),[f.Field]:(0,d.localize)(12686,null),[f.File]:(0,d.localize)(12687,null),[f.Function]:(0,d.localize)(12688,null),[f.Interface]:(0,d.localize)(12689,null),[f.Key]:(0,d.localize)(12690,null),[f.Method]:(0,d.localize)(12691,null),[f.Module]:(0,d.localize)(12692,null),[f.Namespace]:(0,d.localize)(12693,null),[f.Null]:(0,d.localize)(12694,null),[f.Number]:(0,d.localize)(12695,null),[f.Object]:(0,d.localize)(12696,null),[f.Operator]:(0,d.localize)(12697,null),[f.Package]:(0,d.localize)(12698,null),[f.Property]:(0,d.localize)(12699,null),[f.String]:(0,d.localize)(12700,null),[f.Struct]:(0,d.localize)(12701,null),[f.TypeParameter]:(0,d.localize)(12702,null),[f.Variable]:(0,d.localize)(12703,null)};function D(F,X){return(0,d.localize)(12704,null,F,i.$Hu[X])}var R;(function(F){F[F.Deprecated=1]="Deprecated"})(R||(i.SymbolTag=R={}));var p;(function(F){const X=new Map;X.set(f.File,t.$2j.symbolFile),X.set(f.Module,t.$2j.symbolModule),X.set(f.Namespace,t.$2j.symbolNamespace),X.set(f.Package,t.$2j.symbolPackage),X.set(f.Class,t.$2j.symbolClass),X.set(f.Method,t.$2j.symbolMethod),X.set(f.Property,t.$2j.symbolProperty),X.set(f.Field,t.$2j.symbolField),X.set(f.Constructor,t.$2j.symbolConstructor),X.set(f.Enum,t.$2j.symbolEnum),X.set(f.Interface,t.$2j.symbolInterface),X.set(f.Function,t.$2j.symbolFunction),X.set(f.Variable,t.$2j.symbolVariable),X.set(f.Constant,t.$2j.symbolConstant),X.set(f.String,t.$2j.symbolString),X.set(f.Number,t.$2j.symbolNumber),X.set(f.Boolean,t.$2j.symbolBoolean),X.set(f.Array,t.$2j.symbolArray),X.set(f.Object,t.$2j.symbolObject),X.set(f.Key,t.$2j.symbolKey),X.set(f.Null,t.$2j.symbolNull),X.set(f.EnumMember,t.$2j.symbolEnumMember),X.set(f.Struct,t.$2j.symbolStruct),X.set(f.Event,t.$2j.symbolEvent),X.set(f.Operator,t.$2j.symbolOperator),X.set(f.TypeParameter,t.$2j.symbolTypeParameter);function fe(oe){let we=X.get(oe);return we||(console.info("No codicon found for SymbolKind "+oe),we=t.$2j.symbolProperty),we}F.toIcon=fe})(p||(i.SymbolKinds=p={}));class M{static asEditOperation(X){return T.$Lt.replace(g.$Kt.lift(X.range),X.text)}}i.$Ju=M;class j{static{this.Comment=new j("comment")}static{this.Imports=new j("imports")}static{this.Region=new j("region")}static fromValue(X){switch(X){case"comment":return j.Comment;case"imports":return j.Imports;case"region":return j.Region}return new j(X)}constructor(X){this.value=X}}i.$Ku=j;var S;(function(F){F[F.AIGenerated=1]="AIGenerated"})(S||(i.NewSymbolNameTag=S={}));var I;(function(F){F[F.Invoke=0]="Invoke",F[F.Automatic=1]="Automatic"})(I||(i.NewSymbolNameTriggerKind=I={}));var W;(function(F){function X(fe){return!fe||typeof fe!="object"?!1:typeof fe.id=="string"&&typeof fe.title=="string"}F.is=X})(W||(i.Command=W={}));var P;(function(F){F[F.Collapsed=0]="Collapsed",F[F.Expanded=1]="Expanded"})(P||(i.CommentThreadCollapsibleState=P={}));var H;(function(F){F[F.Unresolved=0]="Unresolved",F[F.Resolved=1]="Resolved"})(H||(i.CommentThreadState=H={}));var B;(function(F){F[F.Current=0]="Current",F[F.Outdated=1]="Outdated"})(B||(i.CommentThreadApplicability=B={}));var y;(function(F){F[F.Editing=0]="Editing",F[F.Preview=1]="Preview"})(y||(i.CommentMode=y={}));var Y;(function(F){F[F.Published=0]="Published",F[F.Draft=1]="Draft"})(Y||(i.CommentState=Y={}));var J;(function(F){F[F.Type=1]="Type",F[F.Parameter=2]="Parameter"})(J||(i.InlayHintKind=J={}));class G{constructor(X){this.b=X,this.a=null}dispose(){this.a&&this.a.then(X=>{X&&X.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}i.$Lu=G,i.$Mu=new L.$tu;var Z;(function(F){F[F.None=0]="None",F[F.Option=1]="Option",F[F.Default=2]="Default",F[F.Preferred=3]="Preferred"})(Z||(i.ExternalUriOpenerPriority=Z={}));var C;(function(F){F[F.Invoke=0]="Invoke",F[F.Automatic=1]="Automatic"})(C||(i.InlineEditTriggerKind=C={}))}),ne(ie[74],re([0,1,26,13,40,19,5,2,50,73,70]),function(x,i,t,n,T,g,L,d,a,u,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$j4=void 0,i.$k4=m,c=Pe(c);class ${static{this.CtrlCmd=T.KeyMod.CtrlCmd}static{this.Shift=T.KeyMod.Shift}static{this.Alt=T.KeyMod.Alt}static{this.WinCtrl=T.KeyMod.WinCtrl}static chord(e,b){return(0,T.$Ur)(e,b)}}i.$j4=$;function m(){return{editor:void 0,languages:void 0,CancellationTokenSource:t.$ue,Emitter:n.$je,KeyCode:c.KeyCode,KeyMod:$,Position:L.$Jt,Range:d.$Kt,Selection:a.$Mt,SelectionDirection:c.SelectionDirection,MarkerSeverity:c.MarkerSeverity,MarkerTag:c.MarkerTag,Uri:g.URI,Token:u.$Cu}}}),ne(ie[77],re([0,1,29,19,5,2,66,32,62,63,74,25,69,36,59,18,4,61,68]),function(x,i,t,n,T,g,L,d,a,u,c,$,m,w,e,b,N,_,A){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.EditorSimpleWorker=void 0,i.create=h;class E extends L.$kw{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(r){const l=[];for(let f=0;f<this.f.length;f++){const D=this.f[f],R=this.offsetAt(new T.$Jt(f+1,1)),p=D.matchAll(r);for(const M of p)(M.index||M.index===0)&&(M.index=M.index+R),l.push(M)}return l}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(r){return this.f[r-1]}getWordAtPosition(r,l){const f=(0,d.$mt)(r.column,(0,d.$kt)(l),this.f[r.lineNumber-1],0);return f?new g.$Kt(r.lineNumber,f.startColumn,r.lineNumber,f.endColumn):null}getWordUntilPosition(r,l){const f=this.getWordAtPosition(r,l);return f?{word:this.f[r.lineNumber-1].substring(f.startColumn-1,r.column-1),startColumn:f.startColumn,endColumn:r.column}:{word:"",startColumn:r.column,endColumn:r.column}}words(r){const l=this.f,f=this.q.bind(this);let D=0,R="",p=0,M=[];return{*[Symbol.iterator](){for(;;)if(p<M.length){const j=R.substring(M[p].start,M[p].end);p+=1,yield j}else if(D<l.length)R=l[D],M=f(R,r),p=0,D+=1;else break}}}getLineWords(r,l){const f=this.f[r-1],D=this.q(f,l),R=[];for(const p of D)R.push({word:f.substring(p.start,p.end),startColumn:p.start+1,endColumn:p.end+1});return R}q(r,l){const f=[];let D;for(l.lastIndex=0;(D=l.exec(r))&&D[0].length!==0;)f.push({start:D.index,end:D.index+D[0].length});return f}getValueInRange(r){if(r=this.r(r),r.startLineNumber===r.endLineNumber)return this.f[r.startLineNumber-1].substring(r.startColumn-1,r.endColumn-1);const l=this.g,f=r.startLineNumber-1,D=r.endLineNumber-1,R=[];R.push(this.f[f].substring(r.startColumn-1));for(let p=f+1;p<D;p++)R.push(this.f[p]);return R.push(this.f[D].substring(0,r.endColumn-1)),R.join(l)}offsetAt(r){return r=this.s(r),this.l(),this.j.getPrefixSum(r.lineNumber-2)+(r.column-1)}positionAt(r){r=Math.floor(r),r=Math.max(0,r),this.l();const l=this.j.getIndexOf(r),f=this.f[l.index].length;return{lineNumber:1+l.index,column:1+Math.min(l.remainder,f)}}r(r){const l=this.s({lineNumber:r.startLineNumber,column:r.startColumn}),f=this.s({lineNumber:r.endLineNumber,column:r.endColumn});return l.lineNumber!==r.startLineNumber||l.column!==r.startColumn||f.lineNumber!==r.endLineNumber||f.column!==r.endColumn?{startLineNumber:l.lineNumber,startColumn:l.column,endLineNumber:f.lineNumber,endColumn:f.column}:r}s(r){if(!T.$Jt.isIPosition(r))throw new Error("bad position");let{lineNumber:l,column:f}=r,D=!1;if(l<1)l=1,f=1,D=!0;else if(l>this.f.length)l=this.f.length,f=this.f[l-1].length+1,D=!0;else{const R=this.f[l-1].length+1;f<1?(f=1,D=!0):f>R&&(f=R,D=!0)}return D?{lineNumber:l,column:f}:r}}class v{constructor(r,l){this.d=r,this.f=Object.create(null),this.g=l,this.h=null}dispose(){this.f=Object.create(null)}j(r){return this.f[r]}k(){const r=[];return Object.keys(this.f).forEach(l=>r.push(this.f[l])),r}acceptNewModel(r){this.f[r.url]=new E(n.URI.parse(r.url),r.lines,r.EOL,r.versionId)}acceptModelChanged(r,l){if(!this.f[r])return;this.f[r].onEvents(l)}acceptRemovedModel(r){this.f[r]&&delete this.f[r]}async computeUnicodeHighlights(r,l,f){const D=this.j(r);return D?m.$e4.computeUnicodeHighlights(D,l,f):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async findSectionHeaders(r,l){const f=this.j(r);return f?(0,A.$I4)(f,l):[]}async computeDiff(r,l,f,D){const R=this.j(r),p=this.j(l);return!R||!p?null:v.l(R,p,f,D)}static l(r,l,f,D){const R=D==="advanced"?e.$G4.getDefault():e.$G4.getLegacy(),p=r.getLinesContent(),M=l.getLinesContent(),j=R.computeDiff(p,M,f),S=j.changes.length>0?!1:this.n(r,l);function I(W){return W.map(P=>[P.original.startLineNumber,P.original.endLineNumberExclusive,P.modified.startLineNumber,P.modified.endLineNumberExclusive,P.innerChanges?.map(H=>[H.originalRange.startLineNumber,H.originalRange.startColumn,H.originalRange.endLineNumber,H.originalRange.endColumn,H.modifiedRange.startLineNumber,H.modifiedRange.startColumn,H.modifiedRange.endLineNumber,H.modifiedRange.endColumn])])}return{identical:S,quitEarly:j.hitTimeout,changes:I(j.changes),moves:j.moves.map(W=>[W.lineRangeMapping.original.startLineNumber,W.lineRangeMapping.original.endLineNumberExclusive,W.lineRangeMapping.modified.startLineNumber,W.lineRangeMapping.modified.endLineNumberExclusive,I(W.changes)])}}static n(r,l){const f=r.getLineCount(),D=l.getLineCount();if(f!==D)return!1;for(let R=1;R<=f;R++){const p=r.getLineContent(R),M=l.getLineContent(R);if(p!==M)return!1}return!0}async computeDirtyDiff(r,l,f){const D=this.j(r),R=this.j(l);if(!D||!R)return null;const p=D.getLinesContent(),M=R.getLinesContent();return new w.$9t(p,M,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:f,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this.o=1e5}async computeMoreMinimalEdits(r,l,f){const D=this.j(r);if(!D)return l;const R=[];let p;l=l.slice(0).sort((j,S)=>{if(j.range&&S.range)return g.$Kt.compareRangesUsingStarts(j.range,S.range);const I=j.range?0:1,W=S.range?0:1;return I-W});let M=0;for(let j=1;j<l.length;j++)g.$Kt.getEndPosition(l[M].range).equals(g.$Kt.getStartPosition(l[j].range))?(l[M].range=g.$Kt.fromPositions(g.$Kt.getStartPosition(l[M].range),g.$Kt.getEndPosition(l[j].range)),l[M].text+=l[j].text):(M++,l[M]=l[j]);l.length=M+1;for(let{range:j,text:S,eol:I}of l){if(typeof I=="number"&&(p=I),g.$Kt.isEmpty(j)&&!S)continue;const W=D.getValueInRange(j);if(S=S.replace(/\r\n|\n|\r/g,D.eol),W===S)continue;if(Math.max(S.length,W.length)>v.o){R.push({range:j,text:S});continue}const P=(0,t.$Pt)(W,S,f),H=D.offsetAt(g.$Kt.lift(j).getStartPosition());for(const B of P){const y=D.positionAt(H+B.originalStart),Y=D.positionAt(H+B.originalStart+B.originalLength),J={text:S.substr(B.modifiedStart,B.modifiedLength),range:{startLineNumber:y.lineNumber,startColumn:y.column,endLineNumber:Y.lineNumber,endColumn:Y.column}};D.getValueInRange(J.range)!==J.text&&R.push(J)}}return typeof p=="number"&&R.push({eol:p,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),R}computeHumanReadableDiff(r,l,f){const D=this.j(r);if(!D)return l;const R=[];let p;l=l.slice(0).sort((M,j)=>{if(M.range&&j.range)return g.$Kt.compareRangesUsingStarts(M.range,j.range);const S=M.range?0:1,I=j.range?0:1;return S-I});for(let{range:M,text:j,eol:S}of l){let y=function(J,G){return new T.$Jt(J.lineNumber+G.lineNumber-1,G.lineNumber===1?J.column+G.column-1:G.column)},Y=function(J,G){const Z=[];for(let C=G.startLineNumber;C<=G.endLineNumber;C++){const F=J[C-1];C===G.startLineNumber&&C===G.endLineNumber?Z.push(F.substring(G.startColumn-1,G.endColumn-1)):C===G.startLineNumber?Z.push(F.substring(G.startColumn-1)):C===G.endLineNumber?Z.push(F.substring(0,G.endColumn-1)):Z.push(F)}return Z};if(typeof S=="number"&&(p=S),g.$Kt.isEmpty(M)&&!j)continue;const I=D.getValueInRange(M);if(j=j.replace(/\r\n|\n|\r/g,D.eol),I===j)continue;if(Math.max(j.length,I.length)>v.o){R.push({range:M,text:j});continue}const W=I.split(/\r\n|\n|\r/),P=j.split(/\r\n|\n|\r/),H=e.$G4.getDefault().computeDiff(W,P,f),B=g.$Kt.lift(M).getStartPosition();for(const J of H.changes)if(J.innerChanges)for(const G of J.innerChanges)R.push({range:g.$Kt.fromPositions(y(B,G.originalRange.getStartPosition()),y(B,G.originalRange.getEndPosition())),text:Y(P,G.modifiedRange).join(D.eol)});else throw new N.$bb("The experimental diff algorithm always produces inner changes")}return typeof p=="number"&&R.push({eol:p,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),R}async computeLinks(r){const l=this.j(r);return l?(0,a.$h4)(l):null}async computeDefaultDocumentColors(r){const l=this.j(r);return l?(0,_.$H4)(l):null}static{this.p=1e4}async textualSuggest(r,l,f,D){const R=new $.$de,p=new RegExp(f,D),M=new Set;e:for(const j of r){const S=this.j(j);if(S){for(const I of S.words(p))if(!(I===l||!isNaN(Number(I)))&&(M.add(I),M.size>v.p))break e}}return{words:Array.from(M),duration:R.elapsed()}}async computeWordRanges(r,l,f,D){const R=this.j(r);if(!R)return Object.create(null);const p=new RegExp(f,D),M=Object.create(null);for(let j=l.startLineNumber;j<l.endLineNumber;j++){const S=R.getLineWords(j,p);for(const I of S){if(!isNaN(Number(I.word)))continue;let W=M[I.word];W||(W=[],M[I.word]=W),W.push({startLineNumber:j,startColumn:I.startColumn,endLineNumber:j,endColumn:I.endColumn})}}return M}async navigateValueSet(r,l,f,D,R){const p=this.j(r);if(!p)return null;const M=new RegExp(D,R);l.startColumn===l.endColumn&&(l={startLineNumber:l.startLineNumber,startColumn:l.startColumn,endLineNumber:l.endLineNumber,endColumn:l.endColumn+1});const j=p.getValueInRange(l),S=p.getWordAtPosition({lineNumber:l.startLineNumber,column:l.startColumn},M);if(!S)return null;const I=p.getValueInRange(S);return u.$i4.INSTANCE.navigateValueSet(l,j,S,I,f)}loadForeignModule(r,l,f){const D=(M,j)=>this.d.fhr(M,j),p={host:(0,b.$lo)(f,D),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(p,l),Promise.resolve((0,b.$ko)(this.h))):new Promise((M,j)=>{x([r],S=>{this.h=S.create(p,l),M((0,b.$ko)(this.h))},j)})}fmr(r,l){if(!this.h||typeof this.h[r]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+r));try{return Promise.resolve(this.h[r].apply(this.h,l))}catch(f){return Promise.reject(f)}}}i.EditorSimpleWorker=v;function h(o){return new v(o,null)}typeof importScripts=="function"&&(globalThis.monaco=(0,c.$k4)())})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/e6a828c5957959b7a18de37a567d850880101641/core/vs/base/worker/workerMain.js.map
