/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls","vs/base/common/network","vs/base/common/types","electron","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/base/common/strings","fs","os","vs/platform/product/common/productService","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/extpath","vs/base/common/uuid","vs/platform/state/node/state","vs/base/parts/ipc/electron-main/ipcMain","vs/base/common/process","vs/base/common/objects","vs/platform/environment/common/environment","vs/base/common/charCode","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/platform/window/common/window","vs/platform/window/electron-main/window","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/decorators","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/files/common/watcher","vs/platform/storage/common/storage","vs/platform/utilityProcess/electron-main/utilityProcess","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/remote/common/remoteHosts","vs/platform/terminal/common/terminal","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/processes","vs/base/common/codicons","vs/base/common/severity","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/marshallingIds","crypto","vs/base/node/id","net","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ports","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagement","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/uint","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/crypto","vs/base/node/macAddress","util","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/base/common/date","vs/base/common/jsonErrorMessages","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/issue/electron-main/processMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","string_decoder","vs/base/common/jsonc","vs/code/electron-main/main"],ue=function(Y){for(var e=[],n=0,r=Y.length;n<r;n++)e[n]=le[Y[n]];return e};define(le[137],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lb=void 0,e.$eb=n,e.$fb=r,e.$gb=E,e.$hb=D,e.$ib=T,e.$jb=I,e.$kb=p,e.$mb=g,e.$nb=h,e.$ob=m,e.$pb=w,e.$qb=f;function n(d,v){const b=r(d,v);if(b!==-1)return d[b]}function r(d,v,b=d.length-1){for(let $=b;$>=0;$--){const P=d[$];if(v(P))return $}return-1}function E(d,v){const b=D(d,v);return b===-1?void 0:d[b]}function D(d,v,b=0,$=d.length){let P=b,S=$;for(;P<S;){const t=Math.floor((P+S)/2);v(d[t])?P=t+1:S=t}return P-1}function T(d,v){const b=I(d,v);return b===d.length?void 0:d[b]}function I(d,v,b=0,$=d.length){let P=b,S=$;for(;P<S;){const t=Math.floor((P+S)/2);v(d[t])?S=t:P=t+1}return P}function p(d,v,b=0,$=d.length){const P=I(d,v,b,$);return P===d.length?-1:P}class a{static{this.assertInvariants=!1}constructor(v){this.e=v,this.c=0}findLastMonotonous(v){if(a.assertInvariants){if(this.d){for(const $ of this.e)if(this.d($)&&!v($))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=v}const b=D(this.e,v,this.c);return this.c=b+1,b===-1?void 0:this.e[b]}}e.$lb=a;function g(d,v){if(d.length===0)return;let b=d[0];for(let $=1;$<d.length;$++){const P=d[$];v(P,b)>0&&(b=P)}return b}function h(d,v){if(d.length===0)return;let b=d[0];for(let $=1;$<d.length;$++){const P=d[$];v(P,b)>=0&&(b=P)}return b}function m(d,v){return g(d,(b,$)=>-v(b,$))}function w(d,v){if(d.length===0)return-1;let b=0;for(let $=1;$<d.length;$++){const P=d[$];v(P,d[b])>0&&(b=$)}return b}function f(d,v){for(const b of d){const $=v(b);if($!==void 0)return $}}}),define(le[39],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var n;(function(r){r[r.Null=0]="Null",r[r.Backspace=8]="Backspace",r[r.Tab=9]="Tab",r[r.LineFeed=10]="LineFeed",r[r.CarriageReturn=13]="CarriageReturn",r[r.Space=32]="Space",r[r.ExclamationMark=33]="ExclamationMark",r[r.DoubleQuote=34]="DoubleQuote",r[r.Hash=35]="Hash",r[r.DollarSign=36]="DollarSign",r[r.PercentSign=37]="PercentSign",r[r.Ampersand=38]="Ampersand",r[r.SingleQuote=39]="SingleQuote",r[r.OpenParen=40]="OpenParen",r[r.CloseParen=41]="CloseParen",r[r.Asterisk=42]="Asterisk",r[r.Plus=43]="Plus",r[r.Comma=44]="Comma",r[r.Dash=45]="Dash",r[r.Period=46]="Period",r[r.Slash=47]="Slash",r[r.Digit0=48]="Digit0",r[r.Digit1=49]="Digit1",r[r.Digit2=50]="Digit2",r[r.Digit3=51]="Digit3",r[r.Digit4=52]="Digit4",r[r.Digit5=53]="Digit5",r[r.Digit6=54]="Digit6",r[r.Digit7=55]="Digit7",r[r.Digit8=56]="Digit8",r[r.Digit9=57]="Digit9",r[r.Colon=58]="Colon",r[r.Semicolon=59]="Semicolon",r[r.LessThan=60]="LessThan",r[r.Equals=61]="Equals",r[r.GreaterThan=62]="GreaterThan",r[r.QuestionMark=63]="QuestionMark",r[r.AtSign=64]="AtSign",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.OpenSquareBracket=91]="OpenSquareBracket",r[r.Backslash=92]="Backslash",r[r.CloseSquareBracket=93]="CloseSquareBracket",r[r.Caret=94]="Caret",r[r.Underline=95]="Underline",r[r.BackTick=96]="BackTick",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.OpenCurlyBrace=123]="OpenCurlyBrace",r[r.Pipe=124]="Pipe",r[r.CloseCurlyBrace=125]="CloseCurlyBrace",r[r.Tilde=126]="Tilde",r[r.NoBreakSpace=160]="NoBreakSpace",r[r.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",r[r.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",r[r.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",r[r.U_Combining_Tilde=771]="U_Combining_Tilde",r[r.U_Combining_Macron=772]="U_Combining_Macron",r[r.U_Combining_Overline=773]="U_Combining_Overline",r[r.U_Combining_Breve=774]="U_Combining_Breve",r[r.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",r[r.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",r[r.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",r[r.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",r[r.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",r[r.U_Combining_Caron=780]="U_Combining_Caron",r[r.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",r[r.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",r[r.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",r[r.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",r[r.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",r[r.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",r[r.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",r[r.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",r[r.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",r[r.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",r[r.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",r[r.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",r[r.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",r[r.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",r[r.U_Combining_Horn=795]="U_Combining_Horn",r[r.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",r[r.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",r[r.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",r[r.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",r[r.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",r[r.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",r[r.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",r[r.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",r[r.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",r[r.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",r[r.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",r[r.U_Combining_Cedilla=807]="U_Combining_Cedilla",r[r.U_Combining_Ogonek=808]="U_Combining_Ogonek",r[r.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",r[r.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",r[r.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",r[r.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",r[r.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",r[r.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",r[r.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",r[r.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",r[r.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",r[r.U_Combining_Low_Line=818]="U_Combining_Low_Line",r[r.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",r[r.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",r[r.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",r[r.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",r[r.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",r[r.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",r[r.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",r[r.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",r[r.U_Combining_Square_Below=827]="U_Combining_Square_Below",r[r.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",r[r.U_Combining_X_Above=829]="U_Combining_X_Above",r[r.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",r[r.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",r[r.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",r[r.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",r[r.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",r[r.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",r[r.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",r[r.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",r[r.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",r[r.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",r[r.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",r[r.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",r[r.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",r[r.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",r[r.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",r[r.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",r[r.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",r[r.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",r[r.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",r[r.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",r[r.U_Combining_Fermata=850]="U_Combining_Fermata",r[r.U_Combining_X_Below=851]="U_Combining_X_Below",r[r.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",r[r.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",r[r.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",r[r.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",r[r.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",r[r.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",r[r.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",r[r.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",r[r.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",r[r.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",r[r.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",r[r.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",r[r.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",r[r.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",r[r.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",r[r.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",r[r.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",r[r.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",r[r.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",r[r.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",r[r.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",r[r.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",r[r.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",r[r.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",r[r.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",r[r.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",r[r.LINE_SEPARATOR=8232]="LINE_SEPARATOR",r[r.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",r[r.NEXT_LINE=133]="NEXT_LINE",r[r.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",r[r.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",r[r.U_DIAERESIS=168]="U_DIAERESIS",r[r.U_MACRON=175]="U_MACRON",r[r.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",r[r.U_CEDILLA=184]="U_CEDILLA",r[r.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",r[r.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",r[r.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",r[r.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",r[r.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",r[r.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",r[r.U_BREVE=728]="U_BREVE",r[r.U_DOT_ABOVE=729]="U_DOT_ABOVE",r[r.U_RING_ABOVE=730]="U_RING_ABOVE",r[r.U_OGONEK=731]="U_OGONEK",r[r.U_SMALL_TILDE=732]="U_SMALL_TILDE",r[r.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",r[r.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",r[r.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",r[r.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",r[r.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",r[r.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",r[r.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",r[r.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",r[r.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",r[r.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",r[r.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",r[r.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",r[r.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",r[r.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",r[r.U_GREEK_TONOS=900]="U_GREEK_TONOS",r[r.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",r[r.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",r[r.U_GREEK_PSILI=8127]="U_GREEK_PSILI",r[r.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",r[r.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",r[r.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",r[r.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",r[r.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",r[r.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",r[r.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",r[r.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",r[r.U_GREEK_VARIA=8175]="U_GREEK_VARIA",r[r.U_GREEK_OXIA=8189]="U_GREEK_OXIA",r[r.U_GREEK_DASIA=8190]="U_GREEK_DASIA",r[r.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",r[r.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",r[r.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",r[r.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",r[r.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",r[r.U_OVERLINE=8254]="U_OVERLINE",r[r.UTF8_BOM=65279]="UTF8_BOM",r[r.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",r[r.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(n||(e.CharCode=n={}))}),define(le[138],ue([0,1]),function(Y,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$g=void 0,e.$c=r,e.$d=E,e.$e=D,e.$f=T;function r(p,a){const g=Object.create(null);for(const h of p){const m=a(h);let w=g[m];w||(w=g[m]=[]),w.push(h)}return g}function E(p,a){const g=[],h=[];for(const m of p)a.has(m)||g.push(m);for(const m of a)p.has(m)||h.push(m);return{removed:g,added:h}}function D(p,a){const g=[],h=[];for(const[m,w]of p)a.has(m)||g.push(w);for(const[m,w]of a)p.has(m)||h.push(w);return{removed:g,added:h}}function T(p,a){const g=new Set;for(const h of a)p.has(h)&&g.add(h);return g}class I{static{n=Symbol.toStringTag}constructor(a,g){this.b=g,this.a=new Map,this[n]="SetWithKey";for(const h of a)this.add(h)}get size(){return this.a.size}add(a){const g=this.b(a);return this.a.set(g,a),this}delete(a){return this.a.delete(this.b(a))}has(a){return this.a.has(this.b(a))}*entries(){for(const a of this.a.values())yield[a,a]}keys(){return this.values()}*values(){for(const a of this.a.values())yield a}clear(){this.a.clear()}forEach(a,g){this.a.forEach(h=>a.call(g,h,h,this))}[Symbol.iterator](){return this.values()}}e.$g=I}),define(le[139],ue([0,1,39]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ju=e.$iu=e.$hu=e.$gu=void 0;function r(p,a){const g=Math.pow(10,a);return Math.round(p*g)/g}class E{constructor(a,g,h,m=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,a))|0,this.g=Math.min(255,Math.max(0,g))|0,this.b=Math.min(255,Math.max(0,h))|0,this.a=r(Math.max(Math.min(1,m),0),3)}static equals(a,g){return a.r===g.r&&a.g===g.g&&a.b===g.b&&a.a===g.a}}e.$gu=E;class D{constructor(a,g,h,m){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=r(Math.max(Math.min(1,g),0),3),this.l=r(Math.max(Math.min(1,h),0),3),this.a=r(Math.max(Math.min(1,m),0),3)}static equals(a,g){return a.h===g.h&&a.s===g.s&&a.l===g.l&&a.a===g.a}static fromRGBA(a){const g=a.r/255,h=a.g/255,m=a.b/255,w=a.a,f=Math.max(g,h,m),d=Math.min(g,h,m);let v=0,b=0;const $=(d+f)/2,P=f-d;if(P>0){switch(b=Math.min($<=.5?P/(2*$):P/(2-2*$),1),f){case g:v=(h-m)/P+(h<m?6:0);break;case h:v=(m-g)/P+2;break;case m:v=(g-h)/P+4;break}v*=60,v=Math.round(v)}return new D(v,b,$,w)}static i(a,g,h){return h<0&&(h+=1),h>1&&(h-=1),h<1/6?a+(g-a)*6*h:h<1/2?g:h<2/3?a+(g-a)*(2/3-h)*6:a}static toRGBA(a){const g=a.h/360,{s:h,l:m,a:w}=a;let f,d,v;if(h===0)f=d=v=m;else{const b=m<.5?m*(1+h):m+h-m*h,$=2*m-b;f=D.i($,b,g+1/3),d=D.i($,b,g),v=D.i($,b,g-1/3)}return new E(Math.round(f*255),Math.round(d*255),Math.round(v*255),w)}}e.$hu=D;class T{constructor(a,g,h,m){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=r(Math.max(Math.min(1,g),0),3),this.v=r(Math.max(Math.min(1,h),0),3),this.a=r(Math.max(Math.min(1,m),0),3)}static equals(a,g){return a.h===g.h&&a.s===g.s&&a.v===g.v&&a.a===g.a}static fromRGBA(a){const g=a.r/255,h=a.g/255,m=a.b/255,w=Math.max(g,h,m),f=Math.min(g,h,m),d=w-f,v=w===0?0:d/w;let b;return d===0?b=0:w===g?b=((h-m)/d%6+6)%6:w===h?b=(m-g)/d+2:b=(g-h)/d+4,new T(Math.round(b*60),v,w,a.a)}static toRGBA(a){const{h:g,s:h,v:m,a:w}=a,f=m*h,d=f*(1-Math.abs(g/60%2-1)),v=m-f;let[b,$,P]=[0,0,0];return g<60?(b=f,$=d):g<120?(b=d,$=f):g<180?($=f,P=d):g<240?($=d,P=f):g<300?(b=d,P=f):g<=360&&(b=f,P=d),b=Math.round((b+v)*255),$=Math.round(($+v)*255),P=Math.round((P+v)*255),new E(b,$,P,w)}}e.$iu=T;class I{static fromHex(a){return I.Format.CSS.parseHex(a)||I.red}static equals(a,g){return!a&&!g?!0:!a||!g?!1:a.equals(g)}get hsla(){return this.i?this.i:D.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:T.fromRGBA(this.rgba)}constructor(a){if(a)if(a instanceof E)this.rgba=a;else if(a instanceof D)this.i=a,this.rgba=D.toRGBA(a);else if(a instanceof T)this.j=a,this.rgba=T.toRGBA(a);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(a){return!!a&&E.equals(this.rgba,a.rgba)&&D.equals(this.hsla,a.hsla)&&T.equals(this.hsva,a.hsva)}getRelativeLuminance(){const a=I.k(this.rgba.r),g=I.k(this.rgba.g),h=I.k(this.rgba.b),m=.2126*a+.7152*g+.0722*h;return r(m,4)}static k(a){const g=a/255;return g<=.03928?g/12.92:Math.pow((g+.055)/1.055,2.4)}getContrastRatio(a){const g=this.getRelativeLuminance(),h=a.getRelativeLuminance();return g>h?(g+.05)/(h+.05):(h+.05)/(g+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(a){const g=this.getRelativeLuminance(),h=a.getRelativeLuminance();return g>h}isDarkerThan(a){const g=this.getRelativeLuminance(),h=a.getRelativeLuminance();return g<h}lighten(a){return new I(new D(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*a,this.hsla.a))}darken(a){return new I(new D(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*a,this.hsla.a))}transparent(a){const{r:g,g:h,b:m,a:w}=this.rgba;return new I(new E(g,h,m,w*a))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new I(new E(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(a){const g=a.rgba,h=this.rgba.a,m=g.a,w=h+m*(1-h);if(w<1e-6)return I.transparent;const f=this.rgba.r*h/w+g.r*m*(1-h)/w,d=this.rgba.g*h/w+g.g*m*(1-h)/w,v=this.rgba.b*h/w+g.b*m*(1-h)/w;return new I(new E(f,d,v,w))}makeOpaque(a){if(this.isOpaque()||a.rgba.a!==1)return this;const{r:g,g:h,b:m,a:w}=this.rgba;return new I(new E(a.rgba.r-w*(a.rgba.r-g),a.rgba.g-w*(a.rgba.g-h),a.rgba.b-w*(a.rgba.b-m),1))}flatten(...a){const g=a.reduceRight((h,m)=>I.o(m,h));return I.o(this,g)}static o(a,g){const h=1-a.rgba.a;return new I(new E(h*g.rgba.r+a.rgba.a*a.rgba.r,h*g.rgba.g+a.rgba.a*a.rgba.g,h*g.rgba.b+a.rgba.a*a.rgba.b))}toString(){return this.u||(this.u=I.Format.CSS.format(this)),this.u}static getLighterColor(a,g,h){if(a.isLighterThan(g))return a;h=h||.5;const m=a.getRelativeLuminance(),w=g.getRelativeLuminance();return h=h*(w-m)/w,a.lighten(h)}static getDarkerColor(a,g,h){if(a.isDarkerThan(g))return a;h=h||.5;const m=a.getRelativeLuminance(),w=g.getRelativeLuminance();return h=h*(m-w)/m,a.darken(h)}static{this.white=new I(new E(255,255,255,1))}static{this.black=new I(new E(0,0,0,1))}static{this.red=new I(new E(255,0,0,1))}static{this.blue=new I(new E(0,0,255,1))}static{this.green=new I(new E(0,255,0,1))}static{this.cyan=new I(new E(0,255,255,1))}static{this.lightgrey=new I(new E(211,211,211,1))}static{this.transparent=new I(new E(0,0,0,0))}}e.$ju=I,function(p){let a;(function(g){let h;(function(m){function w(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:p.Format.CSS.formatRGBA(i)}m.formatRGB=w;function f(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}m.formatRGBA=f;function d(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:p.Format.CSS.formatHSLA(i)}m.formatHSL=d;function v(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}m.formatHSLA=v;function b(i){const o=i.toString(16);return o.length!==2?"0"+o:o}function $(i){return`#${b(i.rgba.r)}${b(i.rgba.g)}${b(i.rgba.b)}`}m.formatHex=$;function P(i,o=!1){return o&&i.rgba.a===1?p.Format.CSS.formatHex(i):`#${b(i.rgba.r)}${b(i.rgba.g)}${b(i.rgba.b)}${b(Math.round(i.rgba.a*255))}`}m.formatHexA=P;function S(i){return i.isOpaque()?p.Format.CSS.formatHex(i):p.Format.CSS.formatRGBA(i)}m.format=S;function t(i){const o=i.length;if(o===0||i.charCodeAt(0)!==n.CharCode.Hash)return null;if(o===7){const s=16*u(i.charCodeAt(1))+u(i.charCodeAt(2)),c=16*u(i.charCodeAt(3))+u(i.charCodeAt(4)),l=16*u(i.charCodeAt(5))+u(i.charCodeAt(6));return new p(new E(s,c,l,1))}if(o===9){const s=16*u(i.charCodeAt(1))+u(i.charCodeAt(2)),c=16*u(i.charCodeAt(3))+u(i.charCodeAt(4)),l=16*u(i.charCodeAt(5))+u(i.charCodeAt(6)),k=16*u(i.charCodeAt(7))+u(i.charCodeAt(8));return new p(new E(s,c,l,k/255))}if(o===4){const s=u(i.charCodeAt(1)),c=u(i.charCodeAt(2)),l=u(i.charCodeAt(3));return new p(new E(16*s+s,16*c+c,16*l+l))}if(o===5){const s=u(i.charCodeAt(1)),c=u(i.charCodeAt(2)),l=u(i.charCodeAt(3)),k=u(i.charCodeAt(4));return new p(new E(16*s+s,16*c+c,16*l+l,(16*k+k)/255))}return null}m.parseHex=t;function u(i){switch(i){case n.CharCode.Digit0:return 0;case n.CharCode.Digit1:return 1;case n.CharCode.Digit2:return 2;case n.CharCode.Digit3:return 3;case n.CharCode.Digit4:return 4;case n.CharCode.Digit5:return 5;case n.CharCode.Digit6:return 6;case n.CharCode.Digit7:return 7;case n.CharCode.Digit8:return 8;case n.CharCode.Digit9:return 9;case n.CharCode.a:return 10;case n.CharCode.A:return 10;case n.CharCode.b:return 11;case n.CharCode.B:return 11;case n.CharCode.c:return 12;case n.CharCode.C:return 12;case n.CharCode.d:return 13;case n.CharCode.D:return 13;case n.CharCode.e:return 14;case n.CharCode.E:return 14;case n.CharCode.f:return 15;case n.CharCode.F:return 15}return 0}})(h=g.CSS||(g.CSS={}))})(a=p.Format||(p.Format={}))}(I||(e.$ju=I={}))}),define(le[53],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=r,e.$8h=E,e.$9h=D;function n(T){return(I,p,a)=>{let g=null,h=null;if(typeof a.value=="function"?(g="value",h=a.value):typeof a.get=="function"&&(g="get",h=a.get),!h)throw new Error("not supported");a[g]=T(h,p)}}function r(T,I,p){let a=null,g=null;if(typeof p.value=="function"?(a="value",g=p.value,g.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(a="get",g=p.get),!g)throw new Error("not supported");const h=`$memoize$${I}`;p[a]=function(...m){return this.hasOwnProperty(h)||Object.defineProperty(this,h,{configurable:!1,enumerable:!1,writable:!1,value:g.apply(this,m)}),this[h]}}function E(T,I,p){return n((a,g)=>{const h=`$debounce$${g}`,m=`$debounce$result$${g}`;return function(...w){this[m]||(this[m]=p?p():void 0),clearTimeout(this[h]),I&&(this[m]=I(this[m],...w),w=[this[m]]),this[h]=setTimeout(()=>{a.apply(this,w),this[m]=p?p():void 0},T)}})}function D(T,I,p){return n((a,g)=>{const h=`$throttle$timer$${g}`,m=`$throttle$result$${g}`,w=`$throttle$lastRun$${g}`,f=`$throttle$pending$${g}`;return function(...d){if(this[m]||(this[m]=p?p():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),I&&(this[m]=I(this[m],...d)),this[f])return;const v=this[w]+T;v<=Date.now()?(this[w]=Date.now(),a.apply(this,[this[m]]),this[m]=p?p():void 0):(this[f]=!0,this[h]=setTimeout(()=>{this[f]=!1,this[w]=Date.now(),a.apply(this,[this[m]]),this[m]=p?p():void 0},v-Date.now()))}})}}),define(le[15],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$8=e.$4=e.$V=e.$U=void 0,e.setUnexpectedErrorHandler=r,e.$X=E,e.$Y=D,e.$Z=T,e.$1=I,e.$2=p,e.$3=g,e.$5=m,e.$6=w,e.$7=f,e.$9=v;class n{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?S.isErrorNoTelemetry(i)?new S(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(o=>{o(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$U=n,e.$V=new n;function r(u){e.$V.setUnexpectedErrorHandler(u)}function E(u){if(!u||typeof u!="object")return!1;const i=u;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function D(u){g(u)||e.$V.onUnexpectedError(u)}function T(u){g(u)||e.$V.onUnexpectedExternalError(u)}function I(u){if(u instanceof Error){const{name:i,message:o}=u,s=u.stacktrace||u.stack;return{$isError:!0,name:i,message:o,stack:s,noTelemetry:S.isErrorNoTelemetry(u)}}return u}function p(u){let i;return u.noTelemetry?i=new S:(i=new Error,i.name=u.name),i.message=u.message,i.stack=u.stack,i}const a="Canceled";function g(u){return u instanceof h?!0:u instanceof Error&&u.name===a&&u.message===a}class h extends Error{constructor(){super(a),this.name=this.message}}e.$4=h;function m(){const u=new Error(a);return u.name=u.message,u}function w(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}function f(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}class d extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=d;function v(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}class b extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$0=b;class $ extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$$=$;class P extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=P;class S extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof S)return i;const o=new S;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$ab=S;class t extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,t.prototype)}}e.$bb=t}),define(le[20],ue([0,1,15,137]),function(Y,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$8b=e.$7b=e.CompareResult=void 0,e.$rb=E,e.$sb=D,e.$tb=T,e.$ub=I,e.$vb=p,e.$wb=a,e.$xb=g,e.$yb=h,e.$zb=m,e.$Ab=w,e.$Bb=f,e.$Cb=d,e.$Db=v,e.top=b,e.$Fb=$,e.$Gb=S,e.$Hb=t,e.$Ib=u,e.$Jb=i,e.$Kb=o,e.$Lb=s,e.$Mb=c,e.$Nb=l,e.$Ob=k,e.$Pb=y,e.$Qb=R,e.$Rb=L,e.$Sb=A,e.$Tb=O,e.$Ub=W,e.$Vb=x,e.$Wb=C,e.$Xb=B,e.$Yb=ee,e.$Zb=X,e.$1b=ae,e.$2b=K,e.$3b=te,e.$4b=z,e.$5b=V,e.$6b=oe,e.$9b=re;function E(U,q=0){return U[U.length-(1+q)]}function D(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}function T(U,q,Q=(J,H)=>J===H){if(U===q)return!0;if(!U||!q||U.length!==q.length)return!1;for(let J=0,H=U.length;J<H;J++)if(!Q(U[J],q[J]))return!1;return!0}function I(U,q){const Q=U.length-1;q<Q&&(U[q]=U[Q]),U.pop()}function p(U,q,Q){return a(U.length,J=>Q(U[J],q))}function a(U,q){let Q=0,J=U-1;for(;Q<=J;){const H=(Q+J)/2|0,ne=q(H);if(ne<0)Q=H+1;else if(ne>0)J=H-1;else return H}return-(Q+1)}function g(U,q,Q){if(U=U|0,U>=q.length)throw new TypeError("invalid index");const J=q[Math.floor(q.length*Math.random())],H=[],ne=[],de=[];for(const me of q){const we=Q(me,J);we<0?H.push(me):we>0?ne.push(me):de.push(me)}return U<H.length?g(U,H,Q):U<H.length+de.length?de[0]:g(U-(H.length+de.length),ne,Q)}function h(U,q){const Q=[];let J;for(const H of U.slice(0).sort(q))!J||q(J[0],H)!==0?(J=[H],Q.push(J)):J.push(H);return Q}function*m(U,q){let Q,J;for(const H of U)J!==void 0&&q(J,H)?Q.push(H):(Q&&(yield Q),Q=[H]),J=H;Q&&(yield Q)}function w(U,q){for(let Q=0;Q<=U.length;Q++)q(Q===0?void 0:U[Q-1],Q===U.length?void 0:U[Q])}function f(U,q){for(let Q=0;Q<U.length;Q++)q(Q===0?void 0:U[Q-1],U[Q],Q+1===U.length?void 0:U[Q+1])}function d(U,q,Q){const J=[];function H(me,we,Re){if(we===0&&Re.length===0)return;const ke=J[J.length-1];ke&&ke.start+ke.deleteCount===me?(ke.deleteCount+=we,ke.toInsert.push(...Re)):J.push({start:me,deleteCount:we,toInsert:Re})}let ne=0,de=0;for(;;){if(ne===U.length){H(ne,0,q.slice(de));break}if(de===q.length){H(ne,U.length-ne,[]);break}const me=U[ne],we=q[de],Re=Q(me,we);Re===0?(ne+=1,de+=1):Re<0?(H(ne,1,[]),ne+=1):Re>0&&(H(ne,0,[we]),de+=1)}return J}function v(U,q,Q){const J=d(U,q,Q),H=[],ne=[];for(const de of J)H.push(...U.slice(de.start,de.start+de.deleteCount)),ne.push(...de.toInsert);return{removed:H,added:ne}}function b(U,q,Q){if(Q===0)return[];const J=U.slice(0,Q).sort(q);return P(U,q,J,Q,U.length),J}function $(U,q,Q,J,H){return Q===0?Promise.resolve([]):new Promise((ne,de)=>{(async()=>{const me=U.length,we=U.slice(0,Q).sort(q);for(let Re=Q,ke=Math.min(Q+J,me);Re<me;Re=ke,ke=Math.min(ke+J,me)){if(Re>Q&&await new Promise(Pe=>setTimeout(Pe)),H&&H.isCancellationRequested)throw new n.$4;P(U,q,we,Re,ke)}return we})().then(ne,de)})}function P(U,q,Q,J,H){for(const ne=Q.length;J<H;J++){const de=U[J];if(q(de,Q[ne-1])<0){Q.pop();const me=(0,r.$jb)(Q,we=>q(de,we)<0);Q.splice(me,0,de)}}}function S(U){return U.filter(q=>!!q)}function t(U){let q=0;for(let Q=0;Q<U.length;Q++)U[Q]&&(U[q]=U[Q],q+=1);U.length=q}function u(U,q,Q){U.splice(Q,0,U.splice(q,1)[0])}function i(U){return!Array.isArray(U)||U.length===0}function o(U){return Array.isArray(U)&&U.length>0}function s(U,q=Q=>Q){const Q=new Set;return U.filter(J=>{const H=q(J);return Q.has(H)?!1:(Q.add(H),!0)})}function c(U){const q=new Set;return Q=>{const J=U(Q);return q.has(J)?!1:(q.add(J),!0)}}function l(U,q){return U.length>0?U[0]:q}function k(U,q){return U.length>0?U[U.length-1]:q}function y(U,q,Q=(J,H)=>J===H){let J=0;for(let H=0,ne=Math.min(U.length,q.length);H<ne&&Q(U[H],q[H]);H++)J++;return J}function R(U,q){let Q=typeof q=="number"?U:0;typeof q=="number"?Q=U:(Q=0,q=U);const J=[];if(Q<=q)for(let H=Q;H<q;H++)J.push(H);else for(let H=Q;H>q;H--)J.push(H);return J}function L(U,q,Q){return U.reduce((J,H)=>(J[q(H)]=Q?Q(H):H,J),Object.create(null))}function A(U,q){return U.push(q),()=>O(U,q)}function O(U,q){const Q=U.indexOf(q);if(Q>-1)return U.splice(Q,1),q}function W(U,q,Q){const J=U.slice(0,q),H=U.slice(q);return J.concat(Q,H)}function x(U,q){let Q;if(typeof q=="number"){let J=q;Q=()=>{const H=Math.sin(J++)*179426549;return H-Math.floor(H)}}else Q=Math.random;for(let J=U.length-1;J>0;J-=1){const H=Math.floor(Q()*(J+1)),ne=U[J];U[J]=U[H],U[H]=ne}}function C(U,q){const Q=U.indexOf(q);Q>-1&&(U.splice(Q,1),U.unshift(q))}function B(U,q){const Q=U.indexOf(q);Q>-1&&(U.splice(Q,1),U.push(q))}function ee(U,q){for(const Q of q)U.push(Q)}function X(U,q){return Array.isArray(U)?U.map(q):q(U)}function ae(U){return Array.isArray(U)?U:[U]}function K(U){return U[Math.floor(Math.random()*U.length)]}function te(U,q,Q){const J=j(U,q),H=U.length,ne=Q.length;U.length=H+ne;for(let de=H-1;de>=J;de--)U[de+ne]=U[de];for(let de=0;de<ne;de++)U[de+J]=Q[de]}function z(U,q,Q,J){const H=j(U,q);let ne=U.splice(H,Q);return ne===void 0&&(ne=[]),te(U,H,J),ne}function j(U,q){return q<0?Math.max(q+U.length,0):Math.min(q,U.length)}var N;(function(U){function q(ne){return ne<0}U.isLessThan=q;function Q(ne){return ne<=0}U.isLessThanOrEqual=Q;function J(ne){return ne>0}U.isGreaterThan=J;function H(ne){return ne===0}U.isNeitherLessOrGreaterThan=H,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(N||(e.CompareResult=N={}));function V(U,q){return(Q,J)=>q(U(Q),U(J))}function oe(...U){return(q,Q)=>{for(const J of U){const H=J(q,Q);if(!N.isNeitherLessOrGreaterThan(H))return H}return N.neitherLessOrGreaterThan}}const G=(U,q)=>U-q;e.$7b=G;const he=(U,q)=>(0,e.$7b)(U?1:0,q?1:0);e.$8b=he;function re(U){return(q,Q)=>-U(q,Q)}class _{constructor(q){this.g=q,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(q){let Q=this.c;for(;Q<this.g.length&&q(this.g[Q]);)Q++;const J=Q===this.c?null:this.g.slice(this.c,Q);return this.c=Q,J}takeFromEndWhile(q){let Q=this.d;for(;Q>=0&&q(this.g[Q]);)Q--;const J=Q===this.d?null:this.g.slice(Q+1,this.d+1);return this.d=Q,J}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const q=this.g[this.c];return this.c++,q}removeLast(){const q=this.g[this.d];return this.d--,q}takeCount(q){const Q=this.g.slice(this.c,this.c+q);return this.c+=q,Q}}e.$0b=_;class M{static{this.empty=new M(q=>{})}constructor(q){this.iterate=q}forEach(q){this.iterate(Q=>(q(Q),!0))}toArray(){const q=[];return this.iterate(Q=>(q.push(Q),!0)),q}filter(q){return new M(Q=>this.iterate(J=>q(J)?Q(J):!0))}map(q){return new M(Q=>this.iterate(J=>Q(q(J))))}some(q){let Q=!1;return this.iterate(J=>(Q=q(J),!Q)),Q}findFirst(q){let Q;return this.iterate(J=>q(J)?(Q=J,!1):!0),Q}findLast(q){let Q;return this.iterate(J=>(q(J)&&(Q=J),!0)),Q}findLastMaxBy(q){let Q,J=!0;return this.iterate(H=>((J||N.isGreaterThan(q(H,Q)))&&(J=!1,Q=H),!0)),Q}}e.$$b=M;class F{constructor(q){this.c=q}static createSortPermutation(q,Q){const J=Array.from(q.keys()).sort((H,ne)=>Q(q[H],q[ne]));return new F(J)}apply(q){return q.map((Q,J)=>q[this.c[J]])}inverse(){const q=this.c.slice();for(let Q=0;Q<this.c.length;Q++)q[this.c[Q]]=Q;return new F(q)}}e.$_b=F}),define(le[140],ue([0,1,15]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=r,e.$dd=E,e.$ed=D,e.$fd=T,e.$gd=I,e.$hd=p;function r(a,g){if(!a)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}function E(a,g="Unreachable"){throw new Error(g)}function D(a,g="unexpected state"){if(!a)throw new n.$bb(`Assertion Failed: ${g}`)}function T(a){a||(0,n.$Y)(new n.$bb("Soft Assertion Failed"))}function I(a){if(!a()){debugger;a(),(0,n.$Y)(new n.$bb("Assertion Failed"))}}function p(a,g){let h=0;for(;h<a.length-1;){const m=a[h],w=a[h+1];if(!g(m,w))return!1;h++}return!0}}),define(le[89],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=n;function n(r,E){const D=this;let T=!1,I;return function(){if(T)return I;if(T=!0,E)try{I=r.apply(D,arguments)}finally{E()}else I=r.apply(D,arguments);return I}}}),define(le[77],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var n;(function(r){function E(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}r.is=E;const D=Object.freeze([]);function T(){return D}r.empty=T;function*I(i){yield i}r.single=I;function p(i){return E(i)?i:I(i)}r.wrap=p;function a(i){return i||D}r.from=a;function*g(i){for(let o=i.length-1;o>=0;o--)yield i[o]}r.reverse=g;function h(i){return!i||i[Symbol.iterator]().next().done===!0}r.isEmpty=h;function m(i){return i[Symbol.iterator]().next().value}r.first=m;function w(i,o){let s=0;for(const c of i)if(o(c,s++))return!0;return!1}r.some=w;function f(i,o){for(const s of i)if(o(s))return s}r.find=f;function*d(i,o){for(const s of i)o(s)&&(yield s)}r.filter=d;function*v(i,o){let s=0;for(const c of i)yield o(c,s++)}r.map=v;function*b(i,o){let s=0;for(const c of i)yield*o(c,s++)}r.flatMap=b;function*$(...i){for(const o of i)yield*o}r.concat=$;function P(i,o,s){let c=s;for(const l of i)c=o(c,l);return c}r.reduce=P;function*S(i,o,s=i.length){for(o<0&&(o+=i.length),s<0?s+=i.length:s>i.length&&(s=i.length);o<s;o++)yield i[o]}r.slice=S;function t(i,o=Number.POSITIVE_INFINITY){const s=[];if(o===0)return[s,i];const c=i[Symbol.iterator]();for(let l=0;l<o;l++){const k=c.next();if(k.done)return[s,r.empty()];s.push(k.value)}return[s,{[Symbol.iterator](){return c}}]}r.consume=t;async function u(i){const o=[];for await(const s of i)o.push(s);return Promise.resolve(o)}r.asyncToArray=u})(n||(e.Iterable=n={}))}),define(le[43],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Sn=T,e.$Tn=h,e.$Un=m,e.$Vn=w,e.$Wn=f,e.$Xn=d,e.$Yn=v,e.$Zn=b,e.$1n=$,e.$2n=P,e.$3n=S;var n;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(n||(e.ScanError=n={}));var r;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(r||(e.SyntaxKind=r={}));var E;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(E||(e.ParseErrorCode=E={}));var D;(function(t){t.DEFAULT={allowTrailingComma:!0}})(D||(e.ParseOptions=D={}));function T(t,u=!1){let i=0;const o=t.length;let s="",c=0,l=r.Unknown,k=n.None;function y(C){let B=0,ee=0;for(;B<C;){const X=t.charCodeAt(i);if(X>=g._0&&X<=g._9)ee=ee*16+X-g._0;else if(X>=g.A&&X<=g.F)ee=ee*16+X-g.A+10;else if(X>=g.a&&X<=g.f)ee=ee*16+X-g.a+10;else break;i++,B++}return B<C&&(ee=-1),ee}function R(C){i=C,s="",c=0,l=r.Unknown,k=n.None}function L(){const C=i;if(t.charCodeAt(i)===g._0)i++;else for(i++;i<t.length&&a(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===g.dot)if(i++,i<t.length&&a(t.charCodeAt(i)))for(i++;i<t.length&&a(t.charCodeAt(i));)i++;else return k=n.UnexpectedEndOfNumber,t.substring(C,i);let B=i;if(i<t.length&&(t.charCodeAt(i)===g.E||t.charCodeAt(i)===g.e))if(i++,(i<t.length&&t.charCodeAt(i)===g.plus||t.charCodeAt(i)===g.minus)&&i++,i<t.length&&a(t.charCodeAt(i))){for(i++;i<t.length&&a(t.charCodeAt(i));)i++;B=i}else k=n.UnexpectedEndOfNumber;return t.substring(C,B)}function A(){let C="",B=i;for(;;){if(i>=o){C+=t.substring(B,i),k=n.UnexpectedEndOfString;break}const ee=t.charCodeAt(i);if(ee===g.doubleQuote){C+=t.substring(B,i),i++;break}if(ee===g.backslash){if(C+=t.substring(B,i),i++,i>=o){k=n.UnexpectedEndOfString;break}switch(t.charCodeAt(i++)){case g.doubleQuote:C+='"';break;case g.backslash:C+="\\";break;case g.slash:C+="/";break;case g.b:C+="\b";break;case g.f:C+="\f";break;case g.n:C+=`
`;break;case g.r:C+="\r";break;case g.t:C+="	";break;case g.u:{const ae=y(4);ae>=0?C+=String.fromCharCode(ae):k=n.InvalidUnicode;break}default:k=n.InvalidEscapeCharacter}B=i;continue}if(ee>=0&&ee<=31)if(p(ee)){C+=t.substring(B,i),k=n.UnexpectedEndOfString;break}else k=n.InvalidCharacter;i++}return C}function O(){if(s="",k=n.None,c=i,i>=o)return c=o,l=r.EOF;let C=t.charCodeAt(i);if(I(C)){do i++,s+=String.fromCharCode(C),C=t.charCodeAt(i);while(I(C));return l=r.Trivia}if(p(C))return i++,s+=String.fromCharCode(C),C===g.carriageReturn&&t.charCodeAt(i)===g.lineFeed&&(i++,s+=`
`),l=r.LineBreakTrivia;switch(C){case g.openBrace:return i++,l=r.OpenBraceToken;case g.closeBrace:return i++,l=r.CloseBraceToken;case g.openBracket:return i++,l=r.OpenBracketToken;case g.closeBracket:return i++,l=r.CloseBracketToken;case g.colon:return i++,l=r.ColonToken;case g.comma:return i++,l=r.CommaToken;case g.doubleQuote:return i++,s=A(),l=r.StringLiteral;case g.slash:{const B=i-1;if(t.charCodeAt(i+1)===g.slash){for(i+=2;i<o&&!p(t.charCodeAt(i));)i++;return s=t.substring(B,i),l=r.LineCommentTrivia}if(t.charCodeAt(i+1)===g.asterisk){i+=2;const ee=o-1;let X=!1;for(;i<ee;){if(t.charCodeAt(i)===g.asterisk&&t.charCodeAt(i+1)===g.slash){i+=2,X=!0;break}i++}return X||(i++,k=n.UnexpectedEndOfComment),s=t.substring(B,i),l=r.BlockCommentTrivia}return s+=String.fromCharCode(C),i++,l=r.Unknown}case g.minus:if(s+=String.fromCharCode(C),i++,i===o||!a(t.charCodeAt(i)))return l=r.Unknown;case g._0:case g._1:case g._2:case g._3:case g._4:case g._5:case g._6:case g._7:case g._8:case g._9:return s+=L(),l=r.NumericLiteral;default:for(;i<o&&W(C);)i++,C=t.charCodeAt(i);if(c!==i){switch(s=t.substring(c,i),s){case"true":return l=r.TrueKeyword;case"false":return l=r.FalseKeyword;case"null":return l=r.NullKeyword}return l=r.Unknown}return s+=String.fromCharCode(C),i++,l=r.Unknown}}function W(C){if(I(C)||p(C))return!1;switch(C){case g.closeBrace:case g.closeBracket:case g.openBrace:case g.openBracket:case g.doubleQuote:case g.colon:case g.comma:case g.slash:return!1}return!0}function x(){let C;do C=O();while(C>=r.LineCommentTrivia&&C<=r.Trivia);return C}return{setPosition:R,getPosition:()=>i,scan:u?x:O,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>c,getTokenLength:()=>i-c,getTokenError:()=>k}}function I(t){return t===g.space||t===g.tab||t===g.verticalTab||t===g.formFeed||t===g.nonBreakingSpace||t===g.ogham||t>=g.enQuad&&t<=g.zeroWidthSpace||t===g.narrowNoBreakSpace||t===g.mathematicalSpace||t===g.ideographicSpace||t===g.byteOrderMark}function p(t){return t===g.lineFeed||t===g.carriageReturn||t===g.lineSeparator||t===g.paragraphSeparator}function a(t){return t>=g._0&&t<=g._9}var g;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(g||(g={}));function h(t,u){const i=[],o=new Object;let s;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function k(y,R,L,A){c.value=y,c.offset=R,c.length=L,c.type=A,c.colonOffset=void 0,s=c}try{P(t,{onObjectBegin:(y,R)=>{if(u<=y)throw o;s=void 0,l=u>y,i.push("")},onObjectProperty:(y,R,L)=>{if(u<R||(k(y,R,L,"property"),i[i.length-1]=y,u<=R+L))throw o},onObjectEnd:(y,R)=>{if(u<=y)throw o;s=void 0,i.pop()},onArrayBegin:(y,R)=>{if(u<=y)throw o;s=void 0,i.push(0)},onArrayEnd:(y,R)=>{if(u<=y)throw o;s=void 0,i.pop()},onLiteralValue:(y,R,L)=>{if(u<R||(k(y,R,L,S(y)),u<=R+L))throw o},onSeparator:(y,R,L)=>{if(u<=R)throw o;if(y===":"&&s&&s.type==="property")s.colonOffset=R,l=!1,s=void 0;else if(y===","){const A=i[i.length-1];typeof A=="number"?i[i.length-1]=A+1:(l=!0,i[i.length-1]=""),s=void 0}}})}catch(y){if(y!==o)throw y}return{path:i,previousNode:s,isAtPropertyKey:l,matches:y=>{let R=0;for(let L=0;R<y.length&&L<i.length;L++)if(y[R]===i[L]||y[R]==="*")R++;else if(y[R]!=="**")return!1;return R===y.length}}}function m(t,u=[],i=D.DEFAULT){let o=null,s=[];const c=[];function l(y){Array.isArray(s)?s.push(y):o!==null&&(s[o]=y)}return P(t,{onObjectBegin:()=>{const y={};l(y),c.push(s),s=y,o=null},onObjectProperty:y=>{o=y},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{const y=[];l(y),c.push(s),s=y,o=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:l,onError:(y,R,L)=>{u.push({error:y,offset:R,length:L})}},i),s[0]}function w(t,u=[],i=D.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(y){o.type==="property"&&(o.length=y-o.offset,o=o.parent)}function c(y){return o.children.push(y),y}P(t,{onObjectBegin:y=>{o=c({type:"object",offset:y,length:-1,parent:o,children:[]})},onObjectProperty:(y,R,L)=>{o=c({type:"property",offset:R,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:y,offset:R,length:L,parent:o})},onObjectEnd:(y,R)=>{o.length=y+R-o.offset,o=o.parent,s(y+R)},onArrayBegin:(y,R)=>{o=c({type:"array",offset:y,length:-1,parent:o,children:[]})},onArrayEnd:(y,R)=>{o.length=y+R-o.offset,o=o.parent,s(y+R)},onLiteralValue:(y,R,L)=>{c({type:S(y),offset:R,length:L,parent:o,value:y}),s(R+L)},onSeparator:(y,R,L)=>{o.type==="property"&&(y===":"?o.colonOffset=R:y===","&&s(R))},onError:(y,R,L)=>{u.push({error:y,offset:R,length:L})}},i);const k=o.children[0];return k&&delete k.parent,k}function f(t,u){if(!t)return;let i=t;for(const o of u)if(typeof o=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const c of i.children)if(Array.isArray(c.children)&&c.children[0].value===o){i=c.children[1],s=!0;break}if(!s)return}else{const s=o;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}function d(t){if(!t.parent||!t.parent.children)return[];const u=d(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;u.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&u.push(i)}return u}function v(t){switch(t.type){case"array":return t.children.map(v);case"object":{const u=Object.create(null);for(const i of t.children){const o=i.children[1];o&&(u[i.children[0].value]=v(o))}return u}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function b(t,u,i=!1){return u>=t.offset&&u<t.offset+t.length||i&&u===t.offset+t.length}function $(t,u,i=!1){if(b(t,u,i)){const o=t.children;if(Array.isArray(o))for(let s=0;s<o.length&&o[s].offset<=u;s++){const c=$(o[s],u,i);if(c)return c}return t}}function P(t,u,i=D.DEFAULT){const o=T(t,!1);function s(V){return V?()=>V(o.getTokenOffset(),o.getTokenLength()):()=>!0}function c(V){return V?oe=>V(oe,o.getTokenOffset(),o.getTokenLength()):()=>!0}const l=s(u.onObjectBegin),k=c(u.onObjectProperty),y=s(u.onObjectEnd),R=s(u.onArrayBegin),L=s(u.onArrayEnd),A=c(u.onLiteralValue),O=c(u.onSeparator),W=s(u.onComment),x=c(u.onError),C=i&&i.disallowComments,B=i&&i.allowTrailingComma;function ee(){for(;;){const V=o.scan();switch(o.getTokenError()){case n.InvalidUnicode:X(E.InvalidUnicode);break;case n.InvalidEscapeCharacter:X(E.InvalidEscapeCharacter);break;case n.UnexpectedEndOfNumber:X(E.UnexpectedEndOfNumber);break;case n.UnexpectedEndOfComment:C||X(E.UnexpectedEndOfComment);break;case n.UnexpectedEndOfString:X(E.UnexpectedEndOfString);break;case n.InvalidCharacter:X(E.InvalidCharacter);break}switch(V){case r.LineCommentTrivia:case r.BlockCommentTrivia:C?X(E.InvalidCommentToken):W();break;case r.Unknown:X(E.InvalidSymbol);break;case r.Trivia:case r.LineBreakTrivia:break;default:return V}}}function X(V,oe=[],G=[]){if(x(V),oe.length+G.length>0){let he=o.getToken();for(;he!==r.EOF;){if(oe.indexOf(he)!==-1){ee();break}else if(G.indexOf(he)!==-1)break;he=ee()}}}function ae(V){const oe=o.getTokenValue();return V?A(oe):k(oe),ee(),!0}function K(){switch(o.getToken()){case r.NumericLiteral:{let V=0;try{V=JSON.parse(o.getTokenValue()),typeof V!="number"&&(X(E.InvalidNumberFormat),V=0)}catch{X(E.InvalidNumberFormat)}A(V);break}case r.NullKeyword:A(null);break;case r.TrueKeyword:A(!0);break;case r.FalseKeyword:A(!1);break;default:return!1}return ee(),!0}function te(){return o.getToken()!==r.StringLiteral?(X(E.PropertyNameExpected,[],[r.CloseBraceToken,r.CommaToken]),!1):(ae(!1),o.getToken()===r.ColonToken?(O(":"),ee(),N()||X(E.ValueExpected,[],[r.CloseBraceToken,r.CommaToken])):X(E.ColonExpected,[],[r.CloseBraceToken,r.CommaToken]),!0)}function z(){l(),ee();let V=!1;for(;o.getToken()!==r.CloseBraceToken&&o.getToken()!==r.EOF;){if(o.getToken()===r.CommaToken){if(V||X(E.ValueExpected,[],[]),O(","),ee(),o.getToken()===r.CloseBraceToken&&B)break}else V&&X(E.CommaExpected,[],[]);te()||X(E.ValueExpected,[],[r.CloseBraceToken,r.CommaToken]),V=!0}return y(),o.getToken()!==r.CloseBraceToken?X(E.CloseBraceExpected,[r.CloseBraceToken],[]):ee(),!0}function j(){R(),ee();let V=!1;for(;o.getToken()!==r.CloseBracketToken&&o.getToken()!==r.EOF;){if(o.getToken()===r.CommaToken){if(V||X(E.ValueExpected,[],[]),O(","),ee(),o.getToken()===r.CloseBracketToken&&B)break}else V&&X(E.CommaExpected,[],[]);N()||X(E.ValueExpected,[],[r.CloseBracketToken,r.CommaToken]),V=!0}return L(),o.getToken()!==r.CloseBracketToken?X(E.CloseBracketExpected,[r.CloseBracketToken],[]):ee(),!0}function N(){switch(o.getToken()){case r.OpenBracketToken:return j();case r.OpenBraceToken:return z();case r.StringLiteral:return ae(!0);default:return K()}}return ee(),o.getToken()===r.EOF?i.allowEmptyContent?!0:(X(E.ValueExpected,[],[]),!1):N()?(o.getToken()!==r.EOF&&X(E.EndOfFileExpected,[],[]),!0):(X(E.ValueExpected,[],[]),!1)}function S(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(le[141],ue([0,1,43]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4n=r,e.$5n=E,e.$6n=I,e.$7n=p;function r(a,g,h){let m,w,f,d,v;if(g){for(d=g.offset,v=d+g.length,f=d;f>0&&!p(a,f-1);)f--;let k=v;for(;k<a.length&&!p(a,k);)k++;w=a.substring(f,k),m=T(w,h)}else w=a,m=0,f=0,d=0,v=a.length;const b=I(h,a);let $=!1,P=0,S;h.insertSpaces?S=D(" ",h.tabSize||4):S="	";const t=(0,n.$Sn)(w,!1);let u=!1;function i(){return b+D(S,m+P)}function o(){let k=t.scan();for($=!1;k===n.SyntaxKind.Trivia||k===n.SyntaxKind.LineBreakTrivia;)$=$||k===n.SyntaxKind.LineBreakTrivia,k=t.scan();return u=k===n.SyntaxKind.Unknown||t.getTokenError()!==n.ScanError.None,k}const s=[];function c(k,y,R){!u&&y<v&&R>d&&a.substring(y,R)!==k&&s.push({offset:y,length:R-y,content:k})}let l=o();if(l!==n.SyntaxKind.EOF){const k=t.getTokenOffset()+f,y=D(S,m);c(y,f,k)}for(;l!==n.SyntaxKind.EOF;){let k=t.getTokenOffset()+t.getTokenLength()+f,y=o(),R="";for(;!$&&(y===n.SyntaxKind.LineCommentTrivia||y===n.SyntaxKind.BlockCommentTrivia);){const A=t.getTokenOffset()+f;c(" ",k,A),k=t.getTokenOffset()+t.getTokenLength()+f,R=y===n.SyntaxKind.LineCommentTrivia?i():"",y=o()}if(y===n.SyntaxKind.CloseBraceToken)l!==n.SyntaxKind.OpenBraceToken&&(P--,R=i());else if(y===n.SyntaxKind.CloseBracketToken)l!==n.SyntaxKind.OpenBracketToken&&(P--,R=i());else{switch(l){case n.SyntaxKind.OpenBracketToken:case n.SyntaxKind.OpenBraceToken:P++,R=i();break;case n.SyntaxKind.CommaToken:case n.SyntaxKind.LineCommentTrivia:R=i();break;case n.SyntaxKind.BlockCommentTrivia:$?R=i():R=" ";break;case n.SyntaxKind.ColonToken:R=" ";break;case n.SyntaxKind.StringLiteral:if(y===n.SyntaxKind.ColonToken){R="";break}case n.SyntaxKind.NullKeyword:case n.SyntaxKind.TrueKeyword:case n.SyntaxKind.FalseKeyword:case n.SyntaxKind.NumericLiteral:case n.SyntaxKind.CloseBraceToken:case n.SyntaxKind.CloseBracketToken:y===n.SyntaxKind.LineCommentTrivia||y===n.SyntaxKind.BlockCommentTrivia?R=" ":y!==n.SyntaxKind.CommaToken&&y!==n.SyntaxKind.EOF&&(u=!0);break;case n.SyntaxKind.Unknown:u=!0;break}$&&(y===n.SyntaxKind.LineCommentTrivia||y===n.SyntaxKind.BlockCommentTrivia)&&(R=i())}const L=t.getTokenOffset()+f;c(R,k,L),l=y}return s}function E(a,g){const h=JSON.stringify(a,void 0,g.insertSpaces?g.tabSize||4:"	");return g.eol!==void 0?h.replace(/\r\n|\r|\n/g,g.eol):h}function D(a,g){let h="";for(let m=0;m<g;m++)h+=a;return h}function T(a,g){let h=0,m=0;const w=g.tabSize||4;for(;h<a.length;){const f=a.charAt(h);if(f===" ")m++;else if(f==="	")m+=w;else break;h++}return Math.floor(m/w)}function I(a,g){for(let h=0;h<g.length;h++){const m=g.charAt(h);if(m==="\r")return h+1<g.length&&g.charAt(h+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return a&&a.eol||`
`}function p(a,g){return`\r
`.indexOf(a.charAt(g))!==-1}}),define(le[107],ue([0,1,43,141]),function(Y,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8n=E,e.$9n=D,e.$0n=T,e.$$n=I,e.$_n=p;function E(a,g,h){return D(a,g,void 0,h)}function D(a,g,h,m,w){const f=g.slice(),d=[],v=(0,n.$Vn)(a,d);let b,$;for(;f.length>0&&($=f.pop(),b=(0,n.$Wn)(v,f),b===void 0&&h!==void 0);)typeof $=="string"?h={[$]:h}:h=[h];if(b)if(b.type==="object"&&typeof $=="string"&&Array.isArray(b.children)){const P=(0,n.$Wn)(b,[$]);if(P!==void 0)if(h===void 0){if(!P.parent)throw new Error("Malformed AST");const S=b.children.indexOf(P.parent);let t,u=P.parent.offset+P.parent.length;if(S>0){const i=b.children[S-1];t=i.offset+i.length}else t=b.offset+1,b.children.length>1&&(u=b.children[1].offset);return T(a,{offset:t,length:u-t,content:""},m)}else return T(a,{offset:P.offset,length:P.length,content:JSON.stringify(h)},m);else{if(h===void 0)return[];const S=`${JSON.stringify($)}: ${JSON.stringify(h)}`,t=w?w(b.children.map(i=>i.children[0].value)):b.children.length;let u;if(t>0){const i=b.children[t-1];u={offset:i.offset+i.length,length:0,content:","+S}}else b.children.length===0?u={offset:b.offset+1,length:0,content:S}:u={offset:b.offset+1,length:0,content:S+","};return T(a,u,m)}}else if(b.type==="array"&&typeof $=="number"&&Array.isArray(b.children))if(h!==void 0){const P=`${JSON.stringify(h)}`;let S;if(b.children.length===0||$===0)S={offset:b.offset+1,length:0,content:b.children.length===0?P:P+","};else{const t=$===-1||$>b.children.length?b.children.length:$,u=b.children[t-1];S={offset:u.offset+u.length,length:0,content:","+P}}return T(a,S,m)}else{const P=$,S=b.children[P];let t;if(b.children.length===1)t={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===P){const u=b.children[P-1],i=u.offset+u.length,o=b.offset+b.length;t={offset:i,length:o-2-i,content:""}}else t={offset:S.offset,length:b.children[P+1].offset-S.offset,content:""};return T(a,t,m)}else throw new Error(`Can not add ${typeof $!="number"?"index":"property"} to parent of type ${b.type}`);else return h===void 0?[]:T(a,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(h)},m)}function T(a,g,h){let m=I(a,g),w=g.offset,f=g.offset+g.content.length;if(g.length===0||g.content.length===0){for(;w>0&&!(0,r.$7n)(m,w-1);)w--;for(;f<m.length&&!(0,r.$7n)(m,f);)f++}const d=(0,r.$4n)(m,{offset:w,length:f-w},h);for(let b=d.length-1;b>=0;b--){const $=d[b];m=I(m,$),w=Math.min(w,$.offset),f=Math.max(f,$.offset+$.length),f+=$.content.length-$.length}const v=a.length-(m.length-f)-w;return[{offset:w,length:v,content:m.substring(w,f)}]}function I(a,g){return a.substring(0,g.offset)+g.content+a.substring(g.offset+g.length)}function p(a,g){const h=g.slice(0).sort((w,f)=>{const d=w.offset-f.offset;return d===0?w.length-f.length:d});let m=a.length;for(let w=h.length-1;w>=0;w--){const f=h[w];if(f.offset+f.length<=m)a=I(a,f);else throw new Error("Overlapping edit");m=f.offset}return a}}),function(){function Y(e,n,r,E){const D=/("[^"\\]*(?:\\.[^"\\]*)*")|('[^'\\]*(?:\\.[^'\\]*)*')|(\/\*[^\/\*]*(?:(?:\*|\/)[^\/\*]*)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))|(,\s*[}\]])/g;function T(p){return p.replace(D,function(a,g,h,m,w,f){if(m)return"";if(w){const d=w.length;return w[d-1]===`
`?w[d-2]==="\r"?`\r
`:`
`:""}else return f?a.substring(1):a})}function I(p){const a=T(p);try{return JSON.parse(a)}catch{const h=a.replace(/,\s*([}\]])/g,"$1");return JSON.parse(h)}}return{stripComments:T,parse:I}}typeof define=="function"?define("vs/base/common/jsonc",[],function(){return Y()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=Y():console.trace("jsonc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(le[65],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class n{constructor(E){this.d=E,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(E){this.c=E}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=n}),define(le[108],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class n{static{this.Undefined=new n(void 0)}constructor(D){this.element=D,this.next=n.Undefined,this.prev=n.Undefined}}class r{constructor(){this.a=n.Undefined,this.b=n.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===n.Undefined}clear(){let D=this.a;for(;D!==n.Undefined;){const T=D.next;D.prev=n.Undefined,D.next=n.Undefined,D=T}this.a=n.Undefined,this.b=n.Undefined,this.c=0}unshift(D){return this.d(D,!1)}push(D){return this.d(D,!0)}d(D,T){const I=new n(D);if(this.a===n.Undefined)this.a=I,this.b=I;else if(T){const a=this.b;this.b=I,I.prev=a,a.next=I}else{const a=this.a;this.a=I,I.next=a,a.prev=I}this.c+=1;let p=!1;return()=>{p||(p=!0,this.e(I))}}shift(){if(this.a!==n.Undefined){const D=this.a.element;return this.e(this.a),D}}pop(){if(this.b!==n.Undefined){const D=this.b.element;return this.e(this.b),D}}e(D){if(D.prev!==n.Undefined&&D.next!==n.Undefined){const T=D.prev;T.next=D.next,D.next.prev=T}else D.prev===n.Undefined&&D.next===n.Undefined?(this.a=n.Undefined,this.b=n.Undefined):D.next===n.Undefined?(this.b=this.b.prev,this.b.next=n.Undefined):D.prev===n.Undefined&&(this.a=this.a.next,this.a.prev=n.Undefined);this.c-=1}*[Symbol.iterator](){let D=this.a;for(;D!==n.Undefined;)yield D.element,D=D.next}}e.$4c=r}),define(le[31],ue([0,1]),function(Y,e){"use strict";var n,r,E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=void 0,e.$wc=D,e.$xc=T,e.$yc=I,e.$Hc=S;function D(t,u,i){let o=t.get(u);return o===void 0&&(o=i,t.set(u,o)),o}function T(t){const u=[];return t.forEach((i,o)=>{u.push(`${o} => ${i}`)}),`Map(${t.size}) {${u.join(", ")}}`}function I(t){const u=[];return t.forEach(i=>{u.push(i)}),`Set(${t.size}) {${u.join(", ")}}`}class p{constructor(u,i){this.uri=u,this.value=i}}function a(t){return Array.isArray(t)}class g{static{this.c=u=>u.toString()}constructor(u,i){if(this[n]="ResourceMap",u instanceof g)this.d=new Map(u.d),this.e=i??g.c;else if(a(u)){this.d=new Map,this.e=i??g.c;for(const[o,s]of u)this.set(o,s)}else this.d=new Map,this.e=u??g.c}set(u,i){return this.d.set(this.e(u),new p(u,i)),this}get(u){return this.d.get(this.e(u))?.value}has(u){return this.d.has(this.e(u))}get size(){return this.d.size}clear(){this.d.clear()}delete(u){return this.d.delete(this.e(u))}forEach(u,i){typeof i<"u"&&(u=u.bind(i));for(const[o,s]of this.d)u(s.value,s.uri,this)}*values(){for(const u of this.d.values())yield u.value}*keys(){for(const u of this.d.values())yield u.uri}*entries(){for(const u of this.d.values())yield[u.uri,u.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,u]of this.d)yield[u.uri,u.value]}}e.$zc=g;class h{constructor(u,i){this[r]="ResourceSet",!u||typeof u=="function"?this.c=new g(u):(this.c=new g(i),u.forEach(this.add,this))}get size(){return this.c.size}add(u){return this.c.set(u,u),this}clear(){this.c.clear()}delete(u){return this.c.delete(u)}forEach(u,i){this.c.forEach((o,s)=>u.call(i,s,s,this))}has(u){return this.c.has(u)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=h;var m;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class w{constructor(){this[E]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(u){return this.c.has(u)}get(u,i=m.None){const o=this.c.get(u);if(o)return i!==m.None&&this.m(o,i),o.value}set(u,i,o=m.None){let s=this.c.get(u);if(s)s.value=i,o!==m.None&&this.m(s,o);else{switch(s={key:u,value:i,next:void 0,previous:void 0},o){case m.None:this.k(s);break;case m.AsOld:this.j(s);break;case m.AsNew:this.k(s);break;default:this.k(s);break}this.c.set(u,s),this.f++}return this}delete(u){return!!this.remove(u)}remove(u){const i=this.c.get(u);if(i)return this.c.delete(u),this.l(i),this.f--,i.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const u=this.d;return this.c.delete(u.key),this.l(u),this.f--,u.value}forEach(u,i){const o=this.g;let s=this.d;for(;s;){if(i?u.bind(i)(s.value,s.key,this):u(s.value,s.key,this),this.g!==o)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const u=this,i=this.g;let o=this.d;const s={[Symbol.iterator](){return s},next(){if(u.g!==i)throw new Error("LinkedMap got modified during iteration.");if(o){const c={value:o.key,done:!1};return o=o.next,c}else return{value:void 0,done:!0}}};return s}values(){const u=this,i=this.g;let o=this.d;const s={[Symbol.iterator](){return s},next(){if(u.g!==i)throw new Error("LinkedMap got modified during iteration.");if(o){const c={value:o.value,done:!1};return o=o.next,c}else return{value:void 0,done:!0}}};return s}entries(){const u=this,i=this.g;let o=this.d;const s={[Symbol.iterator](){return s},next(){if(u.g!==i)throw new Error("LinkedMap got modified during iteration.");if(o){const c={value:[o.key,o.value],done:!1};return o=o.next,c}else return{value:void 0,done:!0}}};return s}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(u){if(u>=this.size)return;if(u===0){this.clear();return}let i=this.d,o=this.size;for(;i&&o>u;)this.c.delete(i.key),i=i.next,o--;this.d=i,this.f=o,i&&(i.previous=void 0),this.g++}i(u){if(u>=this.size)return;if(u===0){this.clear();return}let i=this.e,o=this.size;for(;i&&o>u;)this.c.delete(i.key),i=i.previous,o--;this.e=i,this.f=o,i&&(i.next=void 0),this.g++}j(u){if(!this.d&&!this.e)this.e=u;else if(this.d)u.next=this.d,this.d.previous=u;else throw new Error("Invalid list");this.d=u,this.g++}k(u){if(!this.d&&!this.e)this.d=u;else if(this.e)u.previous=this.e,this.e.next=u;else throw new Error("Invalid list");this.e=u,this.g++}l(u){if(u===this.d&&u===this.e)this.d=void 0,this.e=void 0;else if(u===this.d){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this.d=u.next}else if(u===this.e){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this.e=u.previous}else{const i=u.next,o=u.previous;if(!i||!o)throw new Error("Invalid list");i.previous=o,o.next=i}u.next=void 0,u.previous=void 0,this.g++}m(u,i){if(!this.d||!this.e)throw new Error("Invalid list");if(!(i!==m.AsOld&&i!==m.AsNew)){if(i===m.AsOld){if(u===this.d)return;const o=u.next,s=u.previous;u===this.e?(s.next=void 0,this.e=s):(o.previous=s,s.next=o),u.previous=void 0,u.next=this.d,this.d.previous=u,this.d=u,this.g++}else if(i===m.AsNew){if(u===this.e)return;const o=u.next,s=u.previous;u===this.d?(o.previous=void 0,this.d=o):(o.previous=s,s.next=o),u.next=void 0,u.previous=this.e,this.e.next=u,this.e=u,this.g++}}}toJSON(){const u=[];return this.forEach((i,o)=>{u.push([o,i])}),u}fromJSON(u){this.clear();for(const[i,o]of u)this.set(i,o)}}e.$Bc=w;class f extends w{constructor(u,i=1){super(),this.n=u,this.o=Math.min(Math.max(0,i),1)}get limit(){return this.n}set limit(u){this.n=u,this.p()}get ratio(){return this.o}set ratio(u){this.o=Math.min(Math.max(0,u),1),this.p()}get(u,i=m.AsNew){return super.get(u,i)}peek(u){return super.get(u,m.None)}set(u,i){return super.set(u,i,m.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class d extends f{constructor(u,i=1){super(u,i)}q(u){this.h(u)}set(u,i){return super.set(u,i),this.p(),this}}e.$Cc=d;class v extends f{constructor(u,i=1){super(u,i)}q(u){this.i(u)}set(u,i){return this.n<=this.size&&!this.has(u)&&this.q(Math.round(this.n*this.o)-1),super.set(u,i),this}}e.$Dc=v;class b{constructor(){this.c=new Map}add(u){return this.c.set(u,(this.c.get(u)||0)+1),this}delete(u){let i=this.c.get(u)||0;return i===0?!1:(i--,i===0?this.c.delete(u):this.c.set(u,i),!0)}has(u){return this.c.has(u)}}e.$Ec=b;class ${constructor(u){if(this.c=new Map,this.d=new Map,u)for(const[i,o]of u)this.set(i,o)}clear(){this.c.clear(),this.d.clear()}set(u,i){this.c.set(u,i),this.d.set(i,u)}get(u){return this.c.get(u)}getKey(u){return this.d.get(u)}delete(u){const i=this.c.get(u);return i===void 0?!1:(this.c.delete(u),this.d.delete(i),!0)}forEach(u,i){this.c.forEach((o,s)=>{u.call(i,o,s,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=$;class P{constructor(){this.c=new Map}add(u,i){let o=this.c.get(u);o||(o=new Set,this.c.set(u,o)),o.add(i)}delete(u,i){const o=this.c.get(u);o&&(o.delete(i),o.size===0&&this.c.delete(u))}forEach(u,i){const o=this.c.get(u);o&&o.forEach(i)}get(u){const i=this.c.get(u);return i||new Set}}e.$Gc=P;function S(t,u){if(t===u)return!0;if(t.size!==u.size)return!1;for(const[i,o]of t)if(!u.has(i)||u.get(i)!==o)return!1;for(const[i]of u)if(!t.has(i))return!1;return!0}}),define(le[2],ue([0,1,20,138,31,89,77]),function(Y,e,n,r,E,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Ic=void 0,e.$Jc=g,e.$Kc=h,e.$Lc=m,e.$Mc=d,e.$Nc=v,e.$Oc=b,e.$Pc=$,e.$Qc=P,e.$Rc=S,e.$2c=R;const I=!1;let p=null;class a{constructor(){this.b=new Map}static{this.a=0}c(O){let W=this.b.get(O);return W||(W={parent:null,source:null,isSingleton:!1,value:O,idx:a.a++},this.b.set(O,W)),W}trackDisposable(O){const W=this.c(O);W.source||(W.source=new Error().stack)}setParent(O,W){const x=this.c(O);x.parent=W}markAsDisposed(O){this.b.delete(O)}markAsSingleton(O){this.c(O).isSingleton=!0}f(O,W){const x=W.get(O);if(x)return x;const C=O.parent?this.f(this.c(O.parent),W):O;return W.set(O,C),C}getTrackedDisposables(){const O=new Map;return[...this.b.entries()].filter(([,x])=>x.source!==null&&!this.f(x,O).isSingleton).flatMap(([x])=>x)}computeLeakingDisposables(O=10,W){let x;if(W)x=W;else{const ae=new Map,K=[...this.b.values()].filter(z=>z.source!==null&&!this.f(z,ae).isSingleton);if(K.length===0)return;const te=new Set(K.map(z=>z.value));if(x=K.filter(z=>!(z.parent&&te.has(z.parent))),x.length===0)throw new Error("There are cyclic diposable chains!")}if(!x)return;function C(ae){function K(z,j){for(;z.length>0&&j.some(N=>typeof N=="string"?N===z[0]:z[0].match(N));)z.shift()}const te=ae.source.split(`
`).map(z=>z.trim().replace("at ","")).filter(z=>z!=="");return K(te,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),te.reverse()}const B=new E.$Gc;for(const ae of x){const K=C(ae);for(let te=0;te<=K.length;te++)B.add(K.slice(0,te).join(`
`),ae)}x.sort((0,n.$5b)(ae=>ae.idx,n.$7b));let ee="",X=0;for(const ae of x.slice(0,O)){X++;const K=C(ae),te=[];for(let z=0;z<K.length;z++){let j=K[z];j=`(shared with ${B.get(K.slice(0,z+1).join(`
`)).size}/${x.length} leaks) at ${j}`;const V=B.get(K.slice(0,z).join(`
`)),oe=(0,r.$c)([...V].map(G=>C(G)[z]),G=>G);delete oe[K[z]];for(const[G,he]of Object.entries(oe))te.unshift(`    - stacktraces of ${he.length} other leaks continue with ${G}`);te.unshift(j)}ee+=`


==================== Leaking disposable ${X}/${x.length}: ${ae.value.constructor.name} ====================
${te.join(`
`)}
============================================================

`}return x.length>O&&(ee+=`


... and ${x.length-O} more leaking disposables

`),{leaks:x,details:ee}}}e.$Ic=a;function g(A){p=A}if(I){const A="__is_disposable_tracked__";g(new class{trackDisposable(O){const W=new Error("Potentially leaked disposable").stack;setTimeout(()=>{O[A]||console.log(W)},3e3)}setParent(O,W){if(O&&O!==u.None)try{O[A]=!0}catch{}}markAsDisposed(O){if(O&&O!==u.None)try{O[A]=!0}catch{}}markAsSingleton(O){}})}function h(A){return p?.trackDisposable(A),A}function m(A){p?.markAsDisposed(A)}function w(A,O){p?.setParent(A,O)}function f(A,O){if(p)for(const W of A)p.setParent(W,O)}function d(A){return p?.markAsSingleton(A),A}function v(A){return typeof A=="object"&&A!==null&&typeof A.dispose=="function"&&A.dispose.length===0}function b(A){if(T.Iterable.is(A)){const O=[];for(const W of A)if(W)try{W.dispose()}catch(x){O.push(x)}if(O.length===1)throw O[0];if(O.length>1)throw new AggregateError(O,"Encountered errors while disposing of store");return Array.isArray(A)?[]:A}else if(A)return A.dispose(),A}function $(A){for(const O of A)v(O)&&O.dispose();return[]}function P(...A){const O=S(()=>b(A));return f(A,O),O}function S(A){const O=h({dispose:(0,D.$cb)(()=>{m(O),A()})});return O}class t{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,h(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{b(this.f)}finally{this.f.clear()}}add(O){if(!O)return O;if(O===this)throw new Error("Cannot register a disposable on itself!");return w(O,this),this.g?t.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(O),O}delete(O){if(O){if(O===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(O),O.dispose()}}deleteAndLeak(O){O&&this.f.has(O)&&(this.f.delete(O),w(O,null))}}e.$Sc=t;class u{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new t,h(this),w(this.q,this)}dispose(){m(this),this.q.dispose()}B(O){if(O===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(O)}}e.$Tc=u;class i{constructor(){this.b=!1,h(this)}get value(){return this.b?void 0:this.a}set value(O){this.b||O===this.a||(this.a?.dispose(),O&&w(O,this),this.a=O)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const O=this.a;return this.a=void 0,O&&w(O,null),O}}e.$Uc=i;class o{constructor(O){this.a=new i,this.b=!1,this.a.value=O}get value(){return this.a.value}set value(O){this.b||O===this.a.value||(this.a.value=O)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=o;class s{constructor(O){this.b=O,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=s;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,h(this)}set(O){let W=O;return this.unset=()=>W=void 0,this.isset=()=>W!==void 0,this.dispose=()=>{W&&(W(),W=void 0,m(this))},this}}e.$Xc=c;class l{constructor(){this.a=new Map}acquire(O,...W){let x=this.a.get(O);x||(x={counter:0,object:this.b(O,...W)},this.a.set(O,x));const{object:C}=x,B=(0,D.$cb)(()=>{--x.counter===0&&(this.c(O,x.object),this.a.delete(O))});return x.counter++,{object:C,dispose:B}}}e.$Yc=l;class k{constructor(O){this.a=O}async acquire(O,...W){const x=this.a.acquire(O,...W);try{return{object:await x.object,dispose:()=>x.dispose()}}catch(C){throw x.dispose(),C}}}e.$Zc=k;class y{constructor(O){this.object=O}dispose(){}}e.$1c=y;function R(A){const O=new t;try{A(O)}finally{O.dispose()}}class L{constructor(){this.a=new Map,this.b=!1,h(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{b(this.a.values())}finally{this.a.clear()}}has(O){return this.a.has(O)}get size(){return this.a.size}get(O){return this.a.get(O)}set(O,W,x=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),x||this.a.get(O)?.dispose(),this.a.set(O,W)}deleteAndDispose(O){this.a.get(O)?.dispose(),this.a.delete(O)}deleteAndLeak(O){const W=this.a.get(O);return this.a.delete(O),W}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=L}),define(le[90],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var n;(function(r){r[r.Uri=1]="Uri",r[r.Regexp=2]="Regexp",r[r.ScmResource=3]="ScmResource",r[r.ScmResourceGroup=4]="ScmResourceGroup",r[r.ScmProvider=5]="ScmProvider",r[r.CommentController=6]="CommentController",r[r.CommentThread=7]="CommentThread",r[r.CommentThreadInstance=8]="CommentThreadInstance",r[r.CommentThreadReply=9]="CommentThreadReply",r[r.CommentNode=10]="CommentNode",r[r.CommentThreadNode=11]="CommentThreadNode",r[r.TimelineActionContext=12]="TimelineActionContext",r[r.NotebookCellActionContext=13]="NotebookCellActionContext",r[r.NotebookActionContext=14]="NotebookActionContext",r[r.TerminalContext=15]="TerminalContext",r[r.TestItemContext=16]="TestItemContext",r[r.Date=17]="Date",r[r.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(n||(e.MarshalledId=n={}))}),define(le[78],ue([0,1,31]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lm=void 0,e.$jm=E,e.$km=T;const r=new n.$Cc(1e4);function E(a){return p(a,"NFC",r)}const D=new n.$Cc(1e4);function T(a){return p(a,"NFD",D)}const I=/[^\u0000-\u0080]/;function p(a,g,h){if(!a)return a;const m=h.get(a);if(m)return m;let w;return I.test(a)?w=a.normalize(g):w=a,h.set(a,w),w}e.$lm=function(){const a=/[\u0300-\u036f]/g;return function(g){return T(g).replace(a,"")}}()}),define(le[142],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=e.$Km=e.$Jm=void 0,e.$Hm=n,e.rot=r,e.$Mm=I;function n(p,a,g){return Math.min(Math.max(p,a),g)}function r(p,a){return(a+p%a)%a}class E{constructor(){this.a=0}getNext(){return this.a++}}e.$Jm=E;class D{constructor(){this.a=1,this.b=0}update(a){return this.b=this.b+(a-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Km=D;class T{constructor(a){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(a),this.c.fill(0,0,a)}update(a){const g=this.c[this.d];return this.c[this.d]=a,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=a,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Lm=T;function I(p,a,g,h,m,w,f,d){const v=f-g,b=d-h,$=m-g,P=w-h,S=p-g,t=a-h,u=v*v+b*b,i=v*$+b*P,o=v*S+b*t,s=$*$+P*P,c=$*S+P*t,l=1/(u*s-i*i),k=(s*o-i*c)*l,y=(u*c-i*o)*l;return k>=0&&y>=0&&k+y<1}}),function(){function Y(E){const D=[];typeof E=="number"&&D.push("code/timeOrigin",E);function T(p){D.push(p,Date.now())}function I(){const p=[];for(let a=0;a<D.length;a+=2)p.push({name:D[a],startTime:D[a+1]});return p}return{mark:T,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const T of performance.getEntriesByType("mark"))D.push({name:T.name,startTime:Math.round(E+T.startTime)});return D}};if(typeof process=="object"){const E=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function n(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=e()),E.MonacoPerformanceMarks}var r;typeof global=="object"?r=global:typeof self=="object"?r=self:r={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(r)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(r):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),r.perf=n(r))}(),define(le[3],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.OS=e.OperatingSystem=e.$C=e.$B=e.$A=e.$z=e.$y=e.Language=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.Platform=e.$h=void 0,e.$i=u,e.$E=k,e.$K=y,e.$h="en";let n=!1,r=!1,E=!1,D=!1,T=!1,I=!1,p=!1,a=!1,g=!1,h=!1,m,w=e.$h,f=e.$h,d,v;const b=globalThis;let $;typeof b.vscode<"u"&&typeof b.vscode.process<"u"?$=b.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&($=process);const P=typeof $?.versions?.electron=="string",S=P&&$?.type==="renderer";if(typeof $=="object"){n=$.platform==="win32",r=$.platform==="darwin",E=$.platform==="linux",D=E&&!!$.env.SNAP&&!!$.env.SNAP_REVISION,p=P,g=!!$.env.CI||!!$.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=e.$h,w=e.$h;const R=$.env.VSCODE_NLS_CONFIG;if(R)try{const L=JSON.parse(R);m=L.userLocale,f=L.osLocale,w=L.resolvedLanguage||e.$h,d=L.languagePack?.translationsConfigFile}catch{}T=!0}else typeof navigator=="object"&&!S?(v=navigator.userAgent,n=v.indexOf("Windows")>=0,r=v.indexOf("Macintosh")>=0,a=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,E=v.indexOf("Linux")>=0,h=v?.indexOf("Mobi")>=0,I=!0,w=globalThis._VSCODE_NLS_LANGUAGE||e.$h,m=navigator.language.toLowerCase(),f=m):console.error("Unable to resolve platform.");var t;(function(R){R[R.Web=0]="Web",R[R.Mac=1]="Mac",R[R.Linux=2]="Linux",R[R.Windows=3]="Windows"})(t||(e.Platform=t={}));function u(R){switch(R){case t.Web:return"Web";case t.Mac:return"Mac";case t.Linux:return"Linux";case t.Windows:return"Windows"}}let i=t.Web;r?i=t.Mac:n?i=t.Windows:E&&(i=t.Linux),e.$j=n,e.$k=r,e.$l=E,e.$m=D,e.$n=T,e.$o=p,e.$p=I,e.$q=I&&typeof b.importScripts=="function",e.$r=e.$q?b.origin:void 0,e.$s=a,e.$t=h,e.$u=g,e.$v=i,e.$w=v,e.$x=w;var o;(function(R){function L(){return e.$x}R.value=L;function A(){return e.$x.length===2?e.$x==="en":e.$x.length>=3?e.$x[0]==="e"&&e.$x[1]==="n"&&e.$x[2]==="-":!1}R.isDefaultVariant=A;function O(){return e.$x==="en"}R.isDefault=O})(o||(e.Language=o={})),e.$y=m,e.$z=f,e.$A=d,e.$B=typeof b.postMessage=="function"&&!b.importScripts,e.$C=(()=>{if(e.$B){const R=[];b.addEventListener("message",A=>{if(A.data&&A.data.vscodeScheduleAsyncWork)for(let O=0,W=R.length;O<W;O++){const x=R[O];if(x.id===A.data.vscodeScheduleAsyncWork){R.splice(O,1),x.callback();return}}});let L=0;return A=>{const O=++L;R.push({id:O,callback:A}),b.postMessage({vscodeScheduleAsyncWork:O},"*")}}return R=>setTimeout(R)})();var s;(function(R){R[R.Windows=1]="Windows",R[R.Macintosh=2]="Macintosh",R[R.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=r||a?s.Macintosh:n?s.Windows:s.Linux;let c=!0,l=!1;function k(){if(!l){l=!0;const R=new Uint8Array(2);R[0]=1,R[1]=2,c=new Uint16Array(R.buffer)[0]===513}return c}e.$F=!!(e.$w&&e.$w.indexOf("Chrome")>=0),e.$G=!!(e.$w&&e.$w.indexOf("Firefox")>=0),e.$H=!!(!e.$F&&e.$w&&e.$w.indexOf("Safari")>=0),e.$I=!!(e.$w&&e.$w.indexOf("Edg/")>=0),e.$J=!!(e.$w&&e.$w.indexOf("Android")>=0);function y(R){return parseFloat(R)>=20}}),define(le[36],ue([0,1,3]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let r;const E=globalThis.vscode;if(typeof E<"u"&&typeof E.process<"u"){const D=E.process;r={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?r={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:r={get platform(){return n.$j?"win32":n.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=r.cwd,e.env=r.env,e.$cc=r.platform,e.$dc=r.arch});var Dt=this&&this.__createBinding||(Object.create?function(Y,e,n,r){r===void 0&&(r=n);var E=Object.getOwnPropertyDescriptor(e,n);(!E||("get"in E?!e.__esModule:E.writable||E.configurable))&&(E={enumerable:!0,get:function(){return e[n]}}),Object.defineProperty(Y,r,E)}:function(Y,e,n,r){r===void 0&&(r=n),Y[r]=e[n]}),At=this&&this.__setModuleDefault||(Object.create?function(Y,e){Object.defineProperty(Y,"default",{enumerable:!0,value:e})}:function(Y,e){Y.default=e}),Ie=this&&this.__importStar||function(Y){if(Y&&Y.__esModule)return Y;var e={};if(Y!=null)for(var n in Y)n!=="default"&&Object.prototype.hasOwnProperty.call(Y,n)&&Dt(e,Y,n);return At(e,Y),e};define(le[9],ue([0,1,36]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0,n=Ie(n);const r=65,E=97,D=90,T=122,I=46,p=47,a=92,g=58,h=63;class m extends Error{constructor(o,s,c){let l;typeof s=="string"&&s.indexOf("not ")===0?(l="must not be",s=s.replace(/^not /,"")):l="must be";const k=o.indexOf(".")!==-1?"property":"argument";let y=`The "${o}" ${k} ${l} of type ${s}`;y+=`. Received type ${typeof c}`,super(y),this.code="ERR_INVALID_ARG_TYPE"}}function w(i,o){if(i===null||typeof i!="object")throw new m(o,"Object",i)}function f(i,o){if(typeof i!="string")throw new m(o,"string",i)}const d=n.$cc==="win32";function v(i){return i===p||i===a}function b(i){return i===p}function $(i){return i>=r&&i<=D||i>=E&&i<=T}function P(i,o,s,c){let l="",k=0,y=-1,R=0,L=0;for(let A=0;A<=i.length;++A){if(A<i.length)L=i.charCodeAt(A);else{if(c(L))break;L=p}if(c(L)){if(!(y===A-1||R===1))if(R===2){if(l.length<2||k!==2||l.charCodeAt(l.length-1)!==I||l.charCodeAt(l.length-2)!==I){if(l.length>2){const O=l.lastIndexOf(s);O===-1?(l="",k=0):(l=l.slice(0,O),k=l.length-1-l.lastIndexOf(s)),y=A,R=0;continue}else if(l.length!==0){l="",k=0,y=A,R=0;continue}}o&&(l+=l.length>0?`${s}..`:"..",k=2)}else l.length>0?l+=`${s}${i.slice(y+1,A)}`:l=i.slice(y+1,A),k=A-y-1;y=A,R=0}else L===I&&R!==-1?++R:R=-1}return l}function S(i){return i?`${i[0]==="."?"":"."}${i}`:""}function t(i,o){w(o,"pathObject");const s=o.dir||o.root,c=o.base||`${o.name||""}${S(o.ext)}`;return s?s===o.root?`${s}${c}`:`${s}${i}${c}`:c}e.$ec={resolve(...i){let o="",s="",c=!1;for(let l=i.length-1;l>=-1;l--){let k;if(l>=0){if(k=i[l],f(k,`paths[${l}]`),k.length===0)continue}else o.length===0?k=n.cwd():(k=n.env[`=${o}`]||n.cwd(),(k===void 0||k.slice(0,2).toLowerCase()!==o.toLowerCase()&&k.charCodeAt(2)===a)&&(k=`${o}\\`));const y=k.length;let R=0,L="",A=!1;const O=k.charCodeAt(0);if(y===1)v(O)&&(R=1,A=!0);else if(v(O))if(A=!0,v(k.charCodeAt(1))){let W=2,x=W;for(;W<y&&!v(k.charCodeAt(W));)W++;if(W<y&&W!==x){const C=k.slice(x,W);for(x=W;W<y&&v(k.charCodeAt(W));)W++;if(W<y&&W!==x){for(x=W;W<y&&!v(k.charCodeAt(W));)W++;(W===y||W!==x)&&(L=`\\\\${C}\\${k.slice(x,W)}`,R=W)}}}else R=1;else $(O)&&k.charCodeAt(1)===g&&(L=k.slice(0,2),R=2,y>2&&v(k.charCodeAt(2))&&(A=!0,R=3));if(L.length>0)if(o.length>0){if(L.toLowerCase()!==o.toLowerCase())continue}else o=L;if(c){if(o.length>0)break}else if(s=`${k.slice(R)}\\${s}`,c=A,A&&o.length>0)break}return s=P(s,!c,"\\",v),c?`${o}\\${s}`:`${o}${s}`||"."},normalize(i){f(i,"path");const o=i.length;if(o===0)return".";let s=0,c,l=!1;const k=i.charCodeAt(0);if(o===1)return b(k)?"\\":i;if(v(k))if(l=!0,v(i.charCodeAt(1))){let R=2,L=R;for(;R<o&&!v(i.charCodeAt(R));)R++;if(R<o&&R!==L){const A=i.slice(L,R);for(L=R;R<o&&v(i.charCodeAt(R));)R++;if(R<o&&R!==L){for(L=R;R<o&&!v(i.charCodeAt(R));)R++;if(R===o)return`\\\\${A}\\${i.slice(L)}\\`;R!==L&&(c=`\\\\${A}\\${i.slice(L,R)}`,s=R)}}}else s=1;else $(k)&&i.charCodeAt(1)===g&&(c=i.slice(0,2),s=2,o>2&&v(i.charCodeAt(2))&&(l=!0,s=3));let y=s<o?P(i.slice(s),!l,"\\",v):"";return y.length===0&&!l&&(y="."),y.length>0&&v(i.charCodeAt(o-1))&&(y+="\\"),c===void 0?l?`\\${y}`:y:l?`${c}\\${y}`:`${c}${y}`},isAbsolute(i){f(i,"path");const o=i.length;if(o===0)return!1;const s=i.charCodeAt(0);return v(s)||o>2&&$(s)&&i.charCodeAt(1)===g&&v(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,s;for(let k=0;k<i.length;++k){const y=i[k];f(y,"path"),y.length>0&&(o===void 0?o=s=y:o+=`\\${y}`)}if(o===void 0)return".";let c=!0,l=0;if(typeof s=="string"&&v(s.charCodeAt(0))){++l;const k=s.length;k>1&&v(s.charCodeAt(1))&&(++l,k>2&&(v(s.charCodeAt(2))?++l:c=!1))}if(c){for(;l<o.length&&v(o.charCodeAt(l));)l++;l>=2&&(o=`\\${o.slice(l)}`)}return e.$ec.normalize(o)},relative(i,o){if(f(i,"from"),f(o,"to"),i===o)return"";const s=e.$ec.resolve(i),c=e.$ec.resolve(o);if(s===c||(i=s.toLowerCase(),o=c.toLowerCase(),i===o))return"";let l=0;for(;l<i.length&&i.charCodeAt(l)===a;)l++;let k=i.length;for(;k-1>l&&i.charCodeAt(k-1)===a;)k--;const y=k-l;let R=0;for(;R<o.length&&o.charCodeAt(R)===a;)R++;let L=o.length;for(;L-1>R&&o.charCodeAt(L-1)===a;)L--;const A=L-R,O=y<A?y:A;let W=-1,x=0;for(;x<O;x++){const B=i.charCodeAt(l+x);if(B!==o.charCodeAt(R+x))break;B===a&&(W=x)}if(x!==O){if(W===-1)return c}else{if(A>O){if(o.charCodeAt(R+x)===a)return c.slice(R+x+1);if(x===2)return c.slice(R+x)}y>O&&(i.charCodeAt(l+x)===a?W=x:x===2&&(W=3)),W===-1&&(W=0)}let C="";for(x=l+W+1;x<=k;++x)(x===k||i.charCodeAt(x)===a)&&(C+=C.length===0?"..":"\\..");return R+=W,C.length>0?`${C}${c.slice(R,L)}`:(c.charCodeAt(R)===a&&++R,c.slice(R,L))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.$ec.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===a){if(o.charCodeAt(1)===a){const s=o.charCodeAt(2);if(s!==h&&s!==I)return`\\\\?\\UNC\\${o.slice(2)}`}}else if($(o.charCodeAt(0))&&o.charCodeAt(1)===g&&o.charCodeAt(2)===a)return`\\\\?\\${o}`;return i},dirname(i){f(i,"path");const o=i.length;if(o===0)return".";let s=-1,c=0;const l=i.charCodeAt(0);if(o===1)return v(l)?i:".";if(v(l)){if(s=c=1,v(i.charCodeAt(1))){let R=2,L=R;for(;R<o&&!v(i.charCodeAt(R));)R++;if(R<o&&R!==L){for(L=R;R<o&&v(i.charCodeAt(R));)R++;if(R<o&&R!==L){for(L=R;R<o&&!v(i.charCodeAt(R));)R++;if(R===o)return i;R!==L&&(s=c=R+1)}}}}else $(l)&&i.charCodeAt(1)===g&&(s=o>2&&v(i.charCodeAt(2))?3:2,c=s);let k=-1,y=!0;for(let R=o-1;R>=c;--R)if(v(i.charCodeAt(R))){if(!y){k=R;break}}else y=!1;if(k===-1){if(s===-1)return".";k=s}return i.slice(0,k)},basename(i,o){o!==void 0&&f(o,"suffix"),f(i,"path");let s=0,c=-1,l=!0,k;if(i.length>=2&&$(i.charCodeAt(0))&&i.charCodeAt(1)===g&&(s=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let y=o.length-1,R=-1;for(k=i.length-1;k>=s;--k){const L=i.charCodeAt(k);if(v(L)){if(!l){s=k+1;break}}else R===-1&&(l=!1,R=k+1),y>=0&&(L===o.charCodeAt(y)?--y===-1&&(c=k):(y=-1,c=R))}return s===c?c=R:c===-1&&(c=i.length),i.slice(s,c)}for(k=i.length-1;k>=s;--k)if(v(i.charCodeAt(k))){if(!l){s=k+1;break}}else c===-1&&(l=!1,c=k+1);return c===-1?"":i.slice(s,c)},extname(i){f(i,"path");let o=0,s=-1,c=0,l=-1,k=!0,y=0;i.length>=2&&i.charCodeAt(1)===g&&$(i.charCodeAt(0))&&(o=c=2);for(let R=i.length-1;R>=o;--R){const L=i.charCodeAt(R);if(v(L)){if(!k){c=R+1;break}continue}l===-1&&(k=!1,l=R+1),L===I?s===-1?s=R:y!==1&&(y=1):s!==-1&&(y=-1)}return s===-1||l===-1||y===0||y===1&&s===l-1&&s===c+1?"":i.slice(s,l)},format:t.bind(null,"\\"),parse(i){f(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const s=i.length;let c=0,l=i.charCodeAt(0);if(s===1)return v(l)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(v(l)){if(c=1,v(i.charCodeAt(1))){let W=2,x=W;for(;W<s&&!v(i.charCodeAt(W));)W++;if(W<s&&W!==x){for(x=W;W<s&&v(i.charCodeAt(W));)W++;if(W<s&&W!==x){for(x=W;W<s&&!v(i.charCodeAt(W));)W++;W===s?c=W:W!==x&&(c=W+1)}}}}else if($(l)&&i.charCodeAt(1)===g){if(s<=2)return o.root=o.dir=i,o;if(c=2,v(i.charCodeAt(2))){if(s===3)return o.root=o.dir=i,o;c=3}}c>0&&(o.root=i.slice(0,c));let k=-1,y=c,R=-1,L=!0,A=i.length-1,O=0;for(;A>=c;--A){if(l=i.charCodeAt(A),v(l)){if(!L){y=A+1;break}continue}R===-1&&(L=!1,R=A+1),l===I?k===-1?k=A:O!==1&&(O=1):k!==-1&&(O=-1)}return R!==-1&&(k===-1||O===0||O===1&&k===R-1&&k===y+1?o.base=o.name=i.slice(y,R):(o.name=i.slice(y,k),o.base=i.slice(y,R),o.ext=i.slice(k,R))),y>0&&y!==c?o.dir=i.slice(0,y-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(d){const i=/\\/g;return()=>{const o=n.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>n.cwd()})();e.$fc={resolve(...i){let o="",s=!1;for(let c=i.length-1;c>=-1&&!s;c--){const l=c>=0?i[c]:u();f(l,`paths[${c}]`),l.length!==0&&(o=`${l}/${o}`,s=l.charCodeAt(0)===p)}return o=P(o,!s,"/",b),s?`/${o}`:o.length>0?o:"."},normalize(i){if(f(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===p,s=i.charCodeAt(i.length-1)===p;return i=P(i,!o,"/",b),i.length===0?o?"/":s?"./":".":(s&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return f(i,"path"),i.length>0&&i.charCodeAt(0)===p},join(...i){if(i.length===0)return".";let o;for(let s=0;s<i.length;++s){const c=i[s];f(c,"path"),c.length>0&&(o===void 0?o=c:o+=`/${c}`)}return o===void 0?".":e.$fc.normalize(o)},relative(i,o){if(f(i,"from"),f(o,"to"),i===o||(i=e.$fc.resolve(i),o=e.$fc.resolve(o),i===o))return"";const s=1,c=i.length,l=c-s,k=1,y=o.length-k,R=l<y?l:y;let L=-1,A=0;for(;A<R;A++){const W=i.charCodeAt(s+A);if(W!==o.charCodeAt(k+A))break;W===p&&(L=A)}if(A===R)if(y>R){if(o.charCodeAt(k+A)===p)return o.slice(k+A+1);if(A===0)return o.slice(k+A)}else l>R&&(i.charCodeAt(s+A)===p?L=A:A===0&&(L=0));let O="";for(A=s+L+1;A<=c;++A)(A===c||i.charCodeAt(A)===p)&&(O+=O.length===0?"..":"/..");return`${O}${o.slice(k+L)}`},toNamespacedPath(i){return i},dirname(i){if(f(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===p;let s=-1,c=!0;for(let l=i.length-1;l>=1;--l)if(i.charCodeAt(l)===p){if(!c){s=l;break}}else c=!1;return s===-1?o?"/":".":o&&s===1?"//":i.slice(0,s)},basename(i,o){o!==void 0&&f(o,"ext"),f(i,"path");let s=0,c=-1,l=!0,k;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let y=o.length-1,R=-1;for(k=i.length-1;k>=0;--k){const L=i.charCodeAt(k);if(L===p){if(!l){s=k+1;break}}else R===-1&&(l=!1,R=k+1),y>=0&&(L===o.charCodeAt(y)?--y===-1&&(c=k):(y=-1,c=R))}return s===c?c=R:c===-1&&(c=i.length),i.slice(s,c)}for(k=i.length-1;k>=0;--k)if(i.charCodeAt(k)===p){if(!l){s=k+1;break}}else c===-1&&(l=!1,c=k+1);return c===-1?"":i.slice(s,c)},extname(i){f(i,"path");let o=-1,s=0,c=-1,l=!0,k=0;for(let y=i.length-1;y>=0;--y){const R=i.charCodeAt(y);if(R===p){if(!l){s=y+1;break}continue}c===-1&&(l=!1,c=y+1),R===I?o===-1?o=y:k!==1&&(k=1):o!==-1&&(k=-1)}return o===-1||c===-1||k===0||k===1&&o===c-1&&o===s+1?"":i.slice(o,c)},format:t.bind(null,"/"),parse(i){f(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const s=i.charCodeAt(0)===p;let c;s?(o.root="/",c=1):c=0;let l=-1,k=0,y=-1,R=!0,L=i.length-1,A=0;for(;L>=c;--L){const O=i.charCodeAt(L);if(O===p){if(!R){k=L+1;break}continue}y===-1&&(R=!1,y=L+1),O===I?l===-1?l=L:A!==1&&(A=1):l!==-1&&(A=-1)}if(y!==-1){const O=k===0&&s?1:k;l===-1||A===0||A===1&&l===y-1&&l===k+1?o.base=o.name=i.slice(O,y):(o.name=i.slice(O,l),o.base=i.slice(O,y),o.ext=i.slice(l,y))}return k>0?o.dir=i.slice(0,k-1):s&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=d?e.$ec.normalize:e.$fc.normalize,e.$hc=d?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=d?e.$ec.join:e.$fc.join,e.$jc=d?e.$ec.resolve:e.$fc.resolve,e.$kc=d?e.$ec.relative:e.$fc.relative,e.$lc=d?e.$ec.dirname:e.$fc.dirname,e.$mc=d?e.$ec.basename:e.$fc.basename,e.$nc=d?e.$ec.extname:e.$fc.extname,e.$oc=d?e.$ec.format:e.$fc.format,e.$pc=d?e.$ec.parse:e.$fc.parse,e.$qc=d?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=d?e.$ec.sep:e.$fc.sep,e.$sc=d?e.$ec.delimiter:e.$fc.delimiter}),define(le[79],ue([0,1,3]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$hm=D,e.$im=T;var r;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(r||(e.Source=r={}));var E;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(E||(e.TerminateResponseCode=E={}));function D(I,...p){const a=p.reduce((m,w)=>(m[w]=!0,m),{}),g=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(m=>!a[m]).forEach(m=>{for(let w=0;w<g.length;w++)if(m.search(g[w])!==-1){delete I[m];break}})}function T(I){I&&(delete I.DEBUG,n.$k&&delete I.DYLD_LIBRARY_PATH,n.$l&&delete I.LD_PRELOAD)}}),function(Y,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var r in n)(typeof exports=="object"?exports:Y)[r]=n[r]}}(typeof self<"u"?self:this,function(){return function(Y){var e={};function n(r){if(e[r])return e[r].exports;var E=e[r]={i:r,l:!1,exports:{}};return Y[r].call(E.exports,E,E.exports,n),E.l=!0,E.exports}return n.m=Y,n.c=e,n.d=function(r,E,D){n.o(r,E)||Object.defineProperty(r,E,{enumerable:!0,get:D})},n.r=function(r){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(r,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(r,"__esModule",{value:!0})},n.t=function(r,E){if(1&E&&(r=n(r)),8&E||4&E&&typeof r=="object"&&r&&r.__esModule)return r;var D=Object.create(null);if(n.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:r}),2&E&&typeof r!="string")for(var T in r)n.d(D,T,function(I){return r[I]}.bind(null,T));return D},n.n=function(r){var E=r&&r.__esModule?function(){return r.default}:function(){return r};return n.d(E,"a",E),E},n.o=function(r,E){return Object.prototype.hasOwnProperty.call(r,E)},n.p="",n(n.s=0)}([function(Y,e,n){(function(r){var E;e=Y.exports=he,E=typeof r=="object"&&r.env&&r.env.NODE_DEBUG&&/\bsemver\b/i.test(r.env.NODE_DEBUG)?function(){var Z=Array.prototype.slice.call(arguments,0);Z.unshift("SEMVER"),console.log.apply(console,Z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var D=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],p=e.src=[],a=0,g=a++;p[g]="0|[1-9]\\d*";var h=a++;p[h]="[0-9]+";var m=a++;p[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=a++;p[w]="("+p[g]+")\\.("+p[g]+")\\.("+p[g]+")";var f=a++;p[f]="("+p[h]+")\\.("+p[h]+")\\.("+p[h]+")";var d=a++;p[d]="(?:"+p[g]+"|"+p[m]+")";var v=a++;p[v]="(?:"+p[h]+"|"+p[m]+")";var b=a++;p[b]="(?:-("+p[d]+"(?:\\."+p[d]+")*))";var $=a++;p[$]="(?:-?("+p[v]+"(?:\\."+p[v]+")*))";var P=a++;p[P]="[0-9A-Za-z-]+";var S=a++;p[S]="(?:\\+("+p[P]+"(?:\\."+p[P]+")*))";var t=a++,u="v?"+p[w]+p[b]+"?"+p[S]+"?";p[t]="^"+u+"$";var i="[v=\\s]*"+p[f]+p[$]+"?"+p[S]+"?",o=a++;p[o]="^"+i+"$";var s=a++;p[s]="((?:<|>)?=?)";var c=a++;p[c]=p[h]+"|x|X|\\*";var l=a++;p[l]=p[g]+"|x|X|\\*";var k=a++;p[k]="[v=\\s]*("+p[l]+")(?:\\.("+p[l]+")(?:\\.("+p[l]+")(?:"+p[b]+")?"+p[S]+"?)?)?";var y=a++;p[y]="[v=\\s]*("+p[c]+")(?:\\.("+p[c]+")(?:\\.("+p[c]+")(?:"+p[$]+")?"+p[S]+"?)?)?";var R=a++;p[R]="^"+p[s]+"\\s*"+p[k]+"$";var L=a++;p[L]="^"+p[s]+"\\s*"+p[y]+"$";var A=a++;p[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=a++;p[O]="(?:~>?)";var W=a++;p[W]="(\\s*)"+p[O]+"\\s+",I[W]=new RegExp(p[W],"g");var x=a++;p[x]="^"+p[O]+p[k]+"$";var C=a++;p[C]="^"+p[O]+p[y]+"$";var B=a++;p[B]="(?:\\^)";var ee=a++;p[ee]="(\\s*)"+p[B]+"\\s+",I[ee]=new RegExp(p[ee],"g");var X=a++;p[X]="^"+p[B]+p[k]+"$";var ae=a++;p[ae]="^"+p[B]+p[y]+"$";var K=a++;p[K]="^"+p[s]+"\\s*("+i+")$|^$";var te=a++;p[te]="^"+p[s]+"\\s*("+u+")$|^$";var z=a++;p[z]="(\\s*)"+p[s]+"\\s*("+i+"|"+p[k]+")",I[z]=new RegExp(p[z],"g");var j=a++;p[j]="^\\s*("+p[k]+")\\s+-\\s+("+p[k]+")\\s*$";var N=a++;p[N]="^\\s*("+p[y]+")\\s+-\\s+("+p[y]+")\\s*$";var V=a++;p[V]="(<|>)?=?\\s*\\*";for(var oe=0;oe<35;oe++)E(oe,p[oe]),I[oe]||(I[oe]=new RegExp(p[oe]));function G(Z,ce){if(Z instanceof he)return Z;if(typeof Z!="string"||Z.length>D||!(ce?I[o]:I[t]).test(Z))return null;try{return new he(Z,ce)}catch{return null}}function he(Z,ce){if(Z instanceof he){if(Z.loose===ce)return Z;Z=Z.version}else if(typeof Z!="string")throw new TypeError("Invalid Version: "+Z);if(Z.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof he))return new he(Z,ce);E("SemVer",Z,ce),this.loose=ce;var fe=Z.trim().match(ce?I[o]:I[t]);if(!fe)throw new TypeError("Invalid Version: "+Z);if(this.raw=Z,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Ae=+be;if(Ae>=0&&Ae<T)return Ae}return be}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=G,e.valid=function(Z,ce){var fe=G(Z,ce);return fe?fe.version:null},e.clean=function(Z,ce){var fe=G(Z.trim().replace(/^[=v]+/,""),ce);return fe?fe.version:null},e.SemVer=he,he.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},he.prototype.toString=function(){return this.version},he.prototype.compare=function(Z){return E("SemVer.compare",this.version,this.loose,Z),Z instanceof he||(Z=new he(Z,this.loose)),this.compareMain(Z)||this.comparePre(Z)},he.prototype.compareMain=function(Z){return Z instanceof he||(Z=new he(Z,this.loose)),_(this.major,Z.major)||_(this.minor,Z.minor)||_(this.patch,Z.patch)},he.prototype.comparePre=function(Z){if(Z instanceof he||(Z=new he(Z,this.loose)),this.prerelease.length&&!Z.prerelease.length)return-1;if(!this.prerelease.length&&Z.prerelease.length)return 1;if(!this.prerelease.length&&!Z.prerelease.length)return 0;var ce=0;do{var fe=this.prerelease[ce],be=Z.prerelease[ce];if(E("prerelease compare",ce,fe,be),fe===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(fe===void 0)return-1;if(fe!==be)return _(fe,be)}while(++ce)},he.prototype.inc=function(Z,ce){switch(Z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ce),this.inc("pre",ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ce),this.inc("pre",ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}ce&&(this.prerelease[0]===ce?isNaN(this.prerelease[1])&&(this.prerelease=[ce,0]):this.prerelease=[ce,0]);break;default:throw new Error("invalid increment argument: "+Z)}return this.format(),this.raw=this.version,this},e.inc=function(Z,ce,fe,be){typeof fe=="string"&&(be=fe,fe=void 0);try{return new he(Z,fe).inc(ce,be).version}catch{return null}},e.diff=function(Z,ce){if(q(Z,ce))return null;var fe=G(Z),be=G(ce);if(fe.prerelease.length||be.prerelease.length){for(var Ae in fe)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&fe[Ae]!==be[Ae])return"pre"+Ae;return"prerelease"}for(var Ae in fe)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&fe[Ae]!==be[Ae])return Ae},e.compareIdentifiers=_;var re=/^[0-9]+$/;function _(Z,ce){var fe=re.test(Z),be=re.test(ce);return fe&&be&&(Z=+Z,ce=+ce),fe&&!be?-1:be&&!fe?1:Z<ce?-1:Z>ce?1:0}function M(Z,ce,fe){return new he(Z,fe).compare(new he(ce,fe))}function F(Z,ce,fe){return M(Z,ce,fe)>0}function U(Z,ce,fe){return M(Z,ce,fe)<0}function q(Z,ce,fe){return M(Z,ce,fe)===0}function Q(Z,ce,fe){return M(Z,ce,fe)!==0}function J(Z,ce,fe){return M(Z,ce,fe)>=0}function H(Z,ce,fe){return M(Z,ce,fe)<=0}function ne(Z,ce,fe,be){var Ae;switch(ce){case"===":typeof Z=="object"&&(Z=Z.version),typeof fe=="object"&&(fe=fe.version),Ae=Z===fe;break;case"!==":typeof Z=="object"&&(Z=Z.version),typeof fe=="object"&&(fe=fe.version),Ae=Z!==fe;break;case"":case"=":case"==":Ae=q(Z,fe,be);break;case"!=":Ae=Q(Z,fe,be);break;case">":Ae=F(Z,fe,be);break;case">=":Ae=J(Z,fe,be);break;case"<":Ae=U(Z,fe,be);break;case"<=":Ae=H(Z,fe,be);break;default:throw new TypeError("Invalid operator: "+ce)}return Ae}function de(Z,ce){if(Z instanceof de){if(Z.loose===ce)return Z;Z=Z.value}if(!(this instanceof de))return new de(Z,ce);E("comparator",Z,ce),this.loose=ce,this.parse(Z),this.semver===me?this.value="":this.value=this.operator+this.semver.version,E("comp",this)}e.rcompareIdentifiers=function(Z,ce){return _(ce,Z)},e.major=function(Z,ce){return new he(Z,ce).major},e.minor=function(Z,ce){return new he(Z,ce).minor},e.patch=function(Z,ce){return new he(Z,ce).patch},e.compare=M,e.compareLoose=function(Z,ce){return M(Z,ce,!0)},e.rcompare=function(Z,ce,fe){return M(ce,Z,fe)},e.sort=function(Z,ce){return Z.sort(function(fe,be){return e.compare(fe,be,ce)})},e.rsort=function(Z,ce){return Z.sort(function(fe,be){return e.rcompare(fe,be,ce)})},e.gt=F,e.lt=U,e.eq=q,e.neq=Q,e.gte=J,e.lte=H,e.cmp=ne,e.Comparator=de;var me={};function we(Z,ce){if(Z instanceof we)return Z.loose===ce?Z:new we(Z.raw,ce);if(Z instanceof de)return new we(Z.value,ce);if(!(this instanceof we))return new we(Z,ce);if(this.loose=ce,this.raw=Z,this.set=Z.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Z);this.format()}function Re(Z){return!Z||Z.toLowerCase()==="x"||Z==="*"}function ke(Z,ce,fe,be,Ae,Ce,Me,Oe,Be,Ge,Qe,qe,Je){return((ce=Re(fe)?"":Re(be)?">="+fe+".0.0":Re(Ae)?">="+fe+"."+be+".0":">="+ce)+" "+(Oe=Re(Be)?"":Re(Ge)?"<"+(+Be+1)+".0.0":Re(Qe)?"<"+Be+"."+(+Ge+1)+".0":qe?"<="+Be+"."+Ge+"."+Qe+"-"+qe:"<="+Oe)).trim()}function Pe(Z,ce){for(var fe=0;fe<Z.length;fe++)if(!Z[fe].test(ce))return!1;if(ce.prerelease.length){for(fe=0;fe<Z.length;fe++)if(E(Z[fe].semver),Z[fe].semver!==me&&Z[fe].semver.prerelease.length>0){var be=Z[fe].semver;if(be.major===ce.major&&be.minor===ce.minor&&be.patch===ce.patch)return!0}return!1}return!0}function De(Z,ce,fe){try{ce=new we(ce,fe)}catch{return!1}return ce.test(Z)}function $e(Z,ce,fe,be){var Ae,Ce,Me,Oe,Be;switch(Z=new he(Z,be),ce=new we(ce,be),fe){case">":Ae=F,Ce=H,Me=U,Oe=">",Be=">=";break;case"<":Ae=U,Ce=J,Me=F,Oe="<",Be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(De(Z,ce,be))return!1;for(var Ge=0;Ge<ce.set.length;++Ge){var Qe=ce.set[Ge],qe=null,Je=null;if(Qe.forEach(function(Xe){Xe.semver===me&&(Xe=new de(">=0.0.0")),qe=qe||Xe,Je=Je||Xe,Ae(Xe.semver,qe.semver,be)?qe=Xe:Me(Xe.semver,Je.semver,be)&&(Je=Xe)}),qe.operator===Oe||qe.operator===Be||(!Je.operator||Je.operator===Oe)&&Ce(Z,Je.semver)||Je.operator===Be&&Me(Z,Je.semver))return!1}return!0}de.prototype.parse=function(Z){var ce=this.loose?I[K]:I[te],fe=Z.match(ce);if(!fe)throw new TypeError("Invalid comparator: "+Z);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new he(fe[2],this.loose):this.semver=me},de.prototype.toString=function(){return this.value},de.prototype.test=function(Z){return E("Comparator.test",Z,this.loose),this.semver===me||(typeof Z=="string"&&(Z=new he(Z,this.loose)),ne(Z,this.operator,this.semver,this.loose))},de.prototype.intersects=function(Z,ce){if(!(Z instanceof de))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new we(Z.value,ce),De(this.value,fe,ce);if(Z.operator==="")return fe=new we(this.value,ce),De(Z.semver,fe,ce);var be=!(this.operator!==">="&&this.operator!==">"||Z.operator!==">="&&Z.operator!==">"),Ae=!(this.operator!=="<="&&this.operator!=="<"||Z.operator!=="<="&&Z.operator!=="<"),Ce=this.semver.version===Z.semver.version,Me=!(this.operator!==">="&&this.operator!=="<="||Z.operator!==">="&&Z.operator!=="<="),Oe=ne(this.semver,"<",Z.semver,ce)&&(this.operator===">="||this.operator===">")&&(Z.operator==="<="||Z.operator==="<"),Be=ne(this.semver,">",Z.semver,ce)&&(this.operator==="<="||this.operator==="<")&&(Z.operator===">="||Z.operator===">");return be||Ae||Ce&&Me||Oe||Be},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(Z){return Z.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(Z){var ce=this.loose;Z=Z.trim(),E("range",Z,ce);var fe=ce?I[N]:I[j];Z=Z.replace(fe,ke),E("hyphen replace",Z),Z=Z.replace(I[z],"$1$2$3"),E("comparator trim",Z,I[z]),Z=(Z=(Z=Z.replace(I[W],"$1~")).replace(I[ee],"$1^")).split(/\s+/).join(" ");var be=ce?I[K]:I[te],Ae=Z.split(" ").map(function(Ce){return function(Me,Oe){return E("comp",Me),Me=function(Be,Ge){return Be.trim().split(/\s+/).map(function(Qe){return function(qe,Je){E("caret",qe,Je);var Xe=Je?I[ae]:I[X];return qe.replace(Xe,function(Ye,Ne,ie,ge,pe){var ye;return E("caret",qe,Ye,Ne,ie,ge,pe),Re(Ne)?ye="":Re(ie)?ye=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":Re(ge)?ye=Ne==="0"?">="+Ne+"."+ie+".0 <"+Ne+"."+(+ie+1)+".0":">="+Ne+"."+ie+".0 <"+(+Ne+1)+".0.0":pe?(E("replaceCaret pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),ye=Ne==="0"?ie==="0"?">="+Ne+"."+ie+"."+ge+pe+" <"+Ne+"."+ie+"."+(+ge+1):">="+Ne+"."+ie+"."+ge+pe+" <"+Ne+"."+(+ie+1)+".0":">="+Ne+"."+ie+"."+ge+pe+" <"+(+Ne+1)+".0.0"):(E("no pr"),ye=Ne==="0"?ie==="0"?">="+Ne+"."+ie+"."+ge+" <"+Ne+"."+ie+"."+(+ge+1):">="+Ne+"."+ie+"."+ge+" <"+Ne+"."+(+ie+1)+".0":">="+Ne+"."+ie+"."+ge+" <"+(+Ne+1)+".0.0"),E("caret return",ye),ye})}(Qe,Ge)}).join(" ")}(Me,Oe),E("caret",Me),Me=function(Be,Ge){return Be.trim().split(/\s+/).map(function(Qe){return function(qe,Je){var Xe=Je?I[C]:I[x];return qe.replace(Xe,function(Ye,Ne,ie,ge,pe){var ye;return E("tilde",qe,Ye,Ne,ie,ge,pe),Re(Ne)?ye="":Re(ie)?ye=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":Re(ge)?ye=">="+Ne+"."+ie+".0 <"+Ne+"."+(+ie+1)+".0":pe?(E("replaceTilde pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),ye=">="+Ne+"."+ie+"."+ge+pe+" <"+Ne+"."+(+ie+1)+".0"):ye=">="+Ne+"."+ie+"."+ge+" <"+Ne+"."+(+ie+1)+".0",E("tilde return",ye),ye})}(Qe,Ge)}).join(" ")}(Me,Oe),E("tildes",Me),Me=function(Be,Ge){return E("replaceXRanges",Be,Ge),Be.split(/\s+/).map(function(Qe){return function(qe,Je){qe=qe.trim();var Xe=Je?I[L]:I[R];return qe.replace(Xe,function(Ye,Ne,ie,ge,pe,ye){E("xRange",qe,Ye,Ne,ie,ge,pe,ye);var We=Re(ie),Ue=We||Re(ge),Ze=Ue||Re(pe);return Ne==="="&&Ze&&(Ne=""),We?Ye=Ne===">"||Ne==="<"?"<0.0.0":"*":Ne&&Ze?(Ue&&(ge=0),Ze&&(pe=0),Ne===">"?(Ne=">=",Ue?(ie=+ie+1,ge=0,pe=0):Ze&&(ge=+ge+1,pe=0)):Ne==="<="&&(Ne="<",Ue?ie=+ie+1:ge=+ge+1),Ye=Ne+ie+"."+ge+"."+pe):Ue?Ye=">="+ie+".0.0 <"+(+ie+1)+".0.0":Ze&&(Ye=">="+ie+"."+ge+".0 <"+ie+"."+(+ge+1)+".0"),E("xRange return",Ye),Ye})}(Qe,Ge)}).join(" ")}(Me,Oe),E("xrange",Me),Me=function(Be,Ge){return E("replaceStars",Be,Ge),Be.trim().replace(I[V],"")}(Me,Oe),E("stars",Me),Me}(Ce,ce)}).join(" ").split(/\s+/);return this.loose&&(Ae=Ae.filter(function(Ce){return!!Ce.match(be)})),Ae=Ae.map(function(Ce){return new de(Ce,ce)})},we.prototype.intersects=function(Z,ce){if(!(Z instanceof we))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(be){return Z.set.some(function(Ae){return Ae.every(function(Ce){return be.intersects(Ce,ce)})})})})},e.toComparators=function(Z,ce){return new we(Z,ce).set.map(function(fe){return fe.map(function(be){return be.value}).join(" ").trim().split(" ")})},we.prototype.test=function(Z){if(!Z)return!1;typeof Z=="string"&&(Z=new he(Z,this.loose));for(var ce=0;ce<this.set.length;ce++)if(Pe(this.set[ce],Z))return!0;return!1},e.satisfies=De,e.maxSatisfying=function(Z,ce,fe){var be=null,Ae=null;try{var Ce=new we(ce,fe)}catch{return null}return Z.forEach(function(Me){Ce.test(Me)&&(be&&Ae.compare(Me)!==-1||(Ae=new he(be=Me,fe)))}),be},e.minSatisfying=function(Z,ce,fe){var be=null,Ae=null;try{var Ce=new we(ce,fe)}catch{return null}return Z.forEach(function(Me){Ce.test(Me)&&(be&&Ae.compare(Me)!==1||(Ae=new he(be=Me,fe)))}),be},e.validRange=function(Z,ce){try{return new we(Z,ce).range||"*"}catch{return null}},e.ltr=function(Z,ce,fe){return $e(Z,ce,"<",fe)},e.gtr=function(Z,ce,fe){return $e(Z,ce,">",fe)},e.outside=$e,e.prerelease=function(Z,ce){var fe=G(Z,ce);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(Z,ce,fe){return Z=new we(Z,fe),ce=new we(ce,fe),Z.intersects(ce)},e.coerce=function(Z){if(Z instanceof he)return Z;if(typeof Z!="string")return null;var ce=Z.match(I[A]);return ce==null?null:G((ce[1]||"0")+"."+(ce[2]||"0")+"."+(ce[3]||"0"))}}).call(this,n(1))},function(Y,e){var n,r,E=Y.exports={};function D(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function I(v){if(n===setTimeout)return setTimeout(v,0);if((n===D||!n)&&setTimeout)return n=setTimeout,setTimeout(v,0);try{return n(v,0)}catch{try{return n.call(null,v,0)}catch{return n.call(this,v,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:D}catch{n=D}try{r=typeof clearTimeout=="function"?clearTimeout:T}catch{r=T}})();var p,a=[],g=!1,h=-1;function m(){g&&p&&(g=!1,p.length?a=p.concat(a):h=-1,a.length&&w())}function w(){if(!g){var v=I(m);g=!0;for(var b=a.length;b;){for(p=a,a=[];++h<b;)p&&p[h].run();h=-1,b=a.length}p=null,g=!1,function($){if(r===clearTimeout)return clearTimeout($);if((r===T||!r)&&clearTimeout)return r=clearTimeout,clearTimeout($);try{r($)}catch{try{return r.call(null,$)}catch{return r.call(this,$)}}}(v)}}function f(v,b){this.fun=v,this.array=b}function d(){}E.nextTick=function(v){var b=new Array(arguments.length-1);if(arguments.length>1)for(var $=1;$<arguments.length;$++)b[$-1]=arguments[$];a.push(new f(v,b)),a.length!==1||g||I(w)},f.prototype.run=function(){this.fun.apply(null,this.array)},E.title="browser",E.browser=!0,E.env={},E.argv=[],E.version="",E.versions={},E.on=d,E.addListener=d,E.once=d,E.off=d,E.removeListener=d,E.removeAllListeners=d,E.emit=d,E.prependListener=d,E.prependOnceListener=d,E.listeners=function(v){return[]},E.binding=function(v){throw new Error("process.binding is not supported")},E.cwd=function(){return"/"},E.chdir=function(v){throw new Error("process.chdir is not supported")},E.umask=function(){return 0}}])}),define(le[143],ue([0,1]),function(Y,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ps=void 0;class r{constructor(I,p,a){this.level=I,this.key=p,this.value=a,this.forward=[]}}const E=void 0;class D{constructor(I,p=2**16){this.comparator=I,this[n]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(p)|0),this.e=new r(this.c,E,E)}get size(){return this.f}clear(){this.e=new r(this.c,E,E),this.f=0}has(I){return!!D.g(this,I,this.comparator)}get(I){return D.g(this,I,this.comparator)?.value}set(I,p){return D.h(this,I,p,this.comparator)&&(this.f+=1),this}delete(I){const p=D.k(this,I,this.comparator);return p&&(this.f-=1),p}forEach(I,p){let a=this.e.forward[0];for(;a;)I.call(p,a.value,a.key,this),a=a.forward[0]}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",p=this.e.forward[0];for(;p;)I+=`node(${p.key}, ${p.value}, lvl:${p.level})`,p=p.forward[0];return I}static g(I,p,a){let g=I.e;for(let h=I.d-1;h>=0;h--)for(;g.forward[h]&&a(g.forward[h].key,p)<0;)g=g.forward[h];if(g=g.forward[0],g&&a(g.key,p)===0)return g}static h(I,p,a,g){const h=[];let m=I.e;for(let w=I.d-1;w>=0;w--){for(;m.forward[w]&&g(m.forward[w].key,p)<0;)m=m.forward[w];h[w]=m}if(m=m.forward[0],m&&g(m.key,p)===0)return m.value=a,!1;{const w=D.j(I);if(w>I.d){for(let f=I.d;f<w;f++)h[f]=I.e;I.d=w}m=new r(w,p,a);for(let f=0;f<w;f++)m.forward[f]=h[f].forward[f],h[f].forward[f]=m;return!0}}static j(I,p=.5){let a=1;for(;Math.random()<p&&a<I.c;)a+=1;return a}static k(I,p,a){const g=[];let h=I.e;for(let m=I.d-1;m>=0;m--){for(;h.forward[m]&&a(h.forward[m].key,p)<0;)h=h.forward[m];g[m]=h}if(h=h.forward[0],!h||a(h.key,p)!==0)return!1;for(let m=0;m<I.d&&g[m].forward[m]===h;m++)g[m].forward[m]=h.forward[m];for(;I.d>0&&I.e.forward[I.d-1]===E;)I.d-=1;return!0}}e.$Ps=D}),define(le[66],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class r{static create(D){return new r(D)}constructor(D){this.c=n&&D===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$de=r}),define(le[4],ue([0,1,15,89,2,108,66]),function(Y,e,n,r,E,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$fe=e.Event=void 0,e.$ge=w;const I=!1,p=!1,a=!1;var g;(function(C){C.None=()=>E.$Tc.None;function B(ke){if(a){const{onDidAddListener:Pe}=ke,De=d.create();let $e=0;ke.onDidAddListener=()=>{++$e===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),De.print()),Pe?.()}}}function ee(ke,Pe){return G(ke,()=>{},0,void 0,!0,void 0,Pe)}C.defer=ee;function X(ke){return(Pe,De=null,$e)=>{let Z=!1,ce;return ce=ke(fe=>{if(!Z)return ce?ce.dispose():Z=!0,Pe.call(De,fe)},null,$e),Z&&ce.dispose(),ce}}C.once=X;function ae(ke,Pe,De){return V(($e,Z=null,ce)=>ke(fe=>$e.call(Z,Pe(fe)),null,ce),De)}C.map=ae;function K(ke,Pe,De){return V(($e,Z=null,ce)=>ke(fe=>{Pe(fe),$e.call(Z,fe)},null,ce),De)}C.forEach=K;function te(ke,Pe,De){return V(($e,Z=null,ce)=>ke(fe=>Pe(fe)&&$e.call(Z,fe),null,ce),De)}C.filter=te;function z(ke){return ke}C.signal=z;function j(...ke){return(Pe,De=null,$e)=>{const Z=(0,E.$Qc)(...ke.map(ce=>ce(fe=>Pe.call(De,fe))));return oe(Z,$e)}}C.any=j;function N(ke,Pe,De,$e){let Z=De;return ae(ke,ce=>(Z=Pe(Z,ce),Z),$e)}C.reduce=N;function V(ke,Pe){let De;const $e={onWillAddFirstListener(){De=ke(Z.fire,Z)},onDidRemoveLastListener(){De?.dispose()}};Pe||B($e);const Z=new i($e);return Pe?.add(Z),Z.event}function oe(ke,Pe){return Pe instanceof Array?Pe.push(ke):Pe&&Pe.add(ke),ke}function G(ke,Pe,De=100,$e=!1,Z=!1,ce,fe){let be,Ae,Ce,Me=0,Oe;const Be={leakWarningThreshold:ce,onWillAddFirstListener(){be=ke(Qe=>{Me++,Ae=Pe(Ae,Qe),$e&&!Ce&&(Ge.fire(Ae),Ae=void 0),Oe=()=>{const qe=Ae;Ae=void 0,Ce=void 0,(!$e||Me>1)&&Ge.fire(qe),Me=0},typeof De=="number"?(clearTimeout(Ce),Ce=setTimeout(Oe,De)):Ce===void 0&&(Ce=0,queueMicrotask(Oe))})},onWillRemoveListener(){Z&&Me>0&&Oe?.()},onDidRemoveLastListener(){Oe=void 0,be.dispose()}};fe||B(Be);const Ge=new i(Be);return fe?.add(Ge),Ge.event}C.debounce=G;function he(ke,Pe=0,De){return C.debounce(ke,($e,Z)=>$e?($e.push(Z),$e):[Z],Pe,void 0,!0,void 0,De)}C.accumulate=he;function re(ke,Pe=($e,Z)=>$e===Z,De){let $e=!0,Z;return te(ke,ce=>{const fe=$e||!Pe(ce,Z);return $e=!1,Z=ce,fe},De)}C.latch=re;function _(ke,Pe,De){return[C.filter(ke,Pe,De),C.filter(ke,$e=>!Pe($e),De)]}C.split=_;function M(ke,Pe=!1,De=[],$e){let Z=De.slice(),ce=ke(Ae=>{Z?Z.push(Ae):be.fire(Ae)});$e&&$e.add(ce);const fe=()=>{Z?.forEach(Ae=>be.fire(Ae)),Z=null},be=new i({onWillAddFirstListener(){ce||(ce=ke(Ae=>be.fire(Ae)),$e&&$e.add(ce))},onDidAddFirstListener(){Z&&(Pe?setTimeout(fe):fe())},onDidRemoveLastListener(){ce&&ce.dispose(),ce=null}});return $e&&$e.add(be),be.event}C.buffer=M;function F(ke,Pe){return($e,Z,ce)=>{const fe=Pe(new q);return ke(function(be){const Ae=fe.evaluate(be);Ae!==U&&$e.call(Z,Ae)},void 0,ce)}}C.chain=F;const U=Symbol("HaltChainable");class q{constructor(){this.f=[]}map(Pe){return this.f.push(Pe),this}forEach(Pe){return this.f.push(De=>(Pe(De),De)),this}filter(Pe){return this.f.push(De=>Pe(De)?De:U),this}reduce(Pe,De){let $e=De;return this.f.push(Z=>($e=Pe($e,Z),$e)),this}latch(Pe=(De,$e)=>De===$e){let De=!0,$e;return this.f.push(Z=>{const ce=De||!Pe(Z,$e);return De=!1,$e=Z,ce?Z:U}),this}evaluate(Pe){for(const De of this.f)if(Pe=De(Pe),Pe===U)break;return Pe}}function Q(ke,Pe,De=$e=>$e){const $e=(...be)=>fe.fire(De(...be)),Z=()=>ke.on(Pe,$e),ce=()=>ke.removeListener(Pe,$e),fe=new i({onWillAddFirstListener:Z,onDidRemoveLastListener:ce});return fe.event}C.fromNodeEventEmitter=Q;function J(ke,Pe,De=$e=>$e){const $e=(...be)=>fe.fire(De(...be)),Z=()=>ke.addEventListener(Pe,$e),ce=()=>ke.removeEventListener(Pe,$e),fe=new i({onWillAddFirstListener:Z,onDidRemoveLastListener:ce});return fe.event}C.fromDOMEventEmitter=J;function H(ke){return new Promise(Pe=>X(ke)(Pe))}C.toPromise=H;function ne(ke){const Pe=new i;return ke.then(De=>{Pe.fire(De)},()=>{Pe.fire(void 0)}).finally(()=>{Pe.dispose()}),Pe.event}C.fromPromise=ne;function de(ke,Pe,De){return Pe(De),ke($e=>Pe($e))}C.runAndSubscribe=de;class me{constructor(Pe,De){this._observable=Pe,this.f=0,this.g=!1;const $e={onWillAddFirstListener:()=>{Pe.addObserver(this)},onDidRemoveLastListener:()=>{Pe.removeObserver(this)}};De||B($e),this.emitter=new i($e),De&&De.add(this.emitter)}beginUpdate(Pe){this.f++}handlePossibleChange(Pe){}handleChange(Pe,De){this.g=!0}endUpdate(Pe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function we(ke,Pe){return new me(ke,Pe).emitter.event}C.fromObservable=we;function Re(ke){return(Pe,De,$e)=>{let Z=0,ce=!1;const fe={beginUpdate(){Z++},endUpdate(){Z--,Z===0&&(ke.reportChanges(),ce&&(ce=!1,Pe.call(De)))},handlePossibleChange(){},handleChange(){ce=!0}};ke.addObserver(fe),ke.reportChanges();const be={dispose(){ke.removeObserver(fe)}};return $e instanceof E.$Sc?$e.add(be):Array.isArray($e)&&$e.push(be),be}}C.fromObservableLight=Re})(g||(e.Event=g={}));class h{static{this.all=new Set}static{this.f=0}constructor(B){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${B}_${h.f++}`,h.all.add(this)}start(B){this.g=new T.$de,this.listenerCount=B}stop(){if(this.g){const B=this.g.elapsed();this.durations.push(B),this.elapsedOverall+=B,this.invocationCount+=1,this.g=void 0}}}e.$fe=h;let m=-1;function w(C){const B=m;return m=C,{dispose(){m=B}}}class f{static{this.f=1}constructor(B,ee,X=(f.f++).toString(16).padStart(3,"0")){this.j=B,this.threshold=ee,this.name=X,this.h=0}dispose(){this.g?.clear()}check(B,ee){const X=this.threshold;if(X<=0||ee<X)return;this.g||(this.g=new Map);const ae=this.g.get(B.value)||0;if(this.g.set(B.value,ae+1),this.h-=1,this.h<=0){this.h=X*.5;const[K,te]=this.getMostFrequentStack(),z=`[${this.name}] potential listener LEAK detected, having ${ee} listeners already. MOST frequent listener (${te}):`;console.warn(z),console.warn(K);const j=new v(z,K);this.j(j)}return()=>{const K=this.g.get(B.value)||0;this.g.set(B.value,K-1)}}getMostFrequentStack(){if(!this.g)return;let B,ee=0;for(const[X,ae]of this.g)(!B||ee<ae)&&(B=[X,ae],ee=ae);return B}}class d{static create(){const B=new Error;return new d(B.stack??"")}constructor(B){this.value=B}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class v extends Error{constructor(B,ee){super(B),this.name="ListenerLeakError",this.stack=ee}}e.$he=v;class b extends Error{constructor(B,ee){super(B),this.name="ListenerRefusalError",this.stack=ee}}e.$ie=b;let $=0;class P{constructor(B){this.value=B,this.id=$++}}const S=2,t=(C,B)=>{if(C instanceof P)B(C);else for(let ee=0;ee<C.length;ee++){const X=C[ee];X&&B(X)}};let u;if(I){const C=[];setInterval(()=>{C.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(C.join(`
`)),C.length=0)},3e3),u=new FinalizationRegistry(B=>{typeof B=="string"&&C.push(B)})}class i{constructor(B){this.z=0,this.f=B,this.g=m>0||this.f?.leakWarningThreshold?new f(B?.onListenerError??n.$Y,this.f?.leakWarningThreshold??m):void 0,this.j=this.f?._profName?new h(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(p){const B=this.u;queueMicrotask(()=>{t(B,ee=>ee.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(B,ee,X)=>{if(this.g&&this.z>this.g.threshold**2){const j=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(j);const N=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],V=new b(`${j}. HINT: Stack shows most frequent listener (${N[1]}-times)`,N[0]);return(this.f?.onListenerError||n.$Y)(V),E.$Tc.None}if(this.m)return E.$Tc.None;ee&&(B=B.bind(ee));const ae=new P(B);let K,te;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(ae.stack=d.create(),K=this.g.check(ae.stack,this.z+1)),p&&(ae.stack=te??d.create()),this.u?this.u instanceof P?(this.w??=new s,this.u=[this.u,ae]):this.u.push(ae):(this.f?.onWillAddFirstListener?.(this),this.u=ae,this.f?.onDidAddFirstListener?.(this)),this.z++;const z=(0,E.$Rc)(()=>{u?.unregister(z),K?.(),this.A(ae)});if(X instanceof E.$Sc?X.add(z):Array.isArray(X)&&X.push(z),u){const j=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),N=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(j);u.register(z,N?.[2]??j,z)}return z},this.q}A(B){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const ee=this.u,X=ee.indexOf(B);if(X===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,ee[X]=void 0;const ae=this.w.current===this;if(this.z*S<=ee.length){let K=0;for(let te=0;te<ee.length;te++)ee[te]?ee[K++]=ee[te]:ae&&(this.w.end--,K<this.w.i&&this.w.i--);ee.length=K}}B(B,ee){if(!B)return;const X=this.f?.onListenerError||n.$Y;if(!X){B.value(ee);return}try{B.value(ee)}catch(ae){X(ae)}}C(B){const ee=B.current.u;for(;B.i<B.end;)this.B(ee[B.i++],B.value);B.reset()}fire(B){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof P)this.B(this.u,B);else{const ee=this.w;ee.enqueue(this,B,this.u.length),this.C(ee)}this.j?.stop()}hasListeners(){return this.z>0}}e.$je=i;const o=()=>new s;e.$ke=o;class s{constructor(){this.i=-1,this.end=0}enqueue(B,ee,X){this.i=0,this.end=X,this.current=B,this.value=ee}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class c extends i{async fireAsync(B,ee,X){if(this.u)for(this.h||(this.h=new D.$4c),t(this.u,ae=>this.h.push([ae.value,B]));this.h.size>0&&!ee.isCancellationRequested;){const[ae,K]=this.h.shift(),te=[],z={...K,token:ee,waitUntil:j=>{if(Object.isFrozen(te))throw new Error("waitUntil can NOT be called asynchronous");X&&(j=X(j,ae)),te.push(j)}};try{ae(z)}catch(j){(0,n.$Y)(j);continue}Object.freeze(te),await Promise.allSettled(te).then(j=>{for(const N of j)N.status==="rejected"&&(0,n.$Y)(N.reason)})}}}e.$le=c;class l extends i{get isPaused(){return this.h!==0}constructor(B){super(B),this.h=0,this.s=new D.$4c,this.t=B?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const B=Array.from(this.s);this.s.clear(),super.fire(this.t(B))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(B){this.z&&(this.h!==0?this.s.push(B):super.fire(B))}}e.$me=l;class k extends l{constructor(B){super(B),this.k=B.delay??100}fire(B){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(B)}}e.$ne=k;class y extends i{constructor(B){super(B),this.h=[],this.k=B?.merge}fire(B){this.hasListeners()&&(this.h.push(B),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(ee=>super.fire(ee)),this.h=[]}))}}e.$oe=y;class R{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(B){const ee={event:B,listener:null};this.h.push(ee),this.g&&this.m(ee);const X=()=>{this.g&&this.o(ee);const ae=this.h.indexOf(ee);this.h.splice(ae,1)};return(0,E.$Rc)((0,r.$cb)(X))}j(){this.g=!0,this.h.forEach(B=>this.m(B))}k(){this.g=!1,this.h.forEach(B=>this.o(B))}m(B){B.listener=B.event(ee=>this.f.fire(ee))}o(B){B.listener?.dispose(),B.listener=null}dispose(){this.f.dispose();for(const B of this.h)B.listener?.dispose();this.h=[]}}e.$pe=R;class L{constructor(B,ee,X,ae){this.f=new E.$Sc;const K=this.f.add(new R),te=this.f.add(new E.$3c);function z(j){te.set(j,K.add(ae(j)))}for(const j of B)z(j);this.f.add(ee(j=>{z(j)})),this.f.add(X(j=>{te.deleteAndDispose(j)})),this.event=K.event}dispose(){this.f.dispose()}}e.$qe=L;class A{constructor(){this.f=[]}wrapEvent(B,ee,X){return(ae,K,te)=>B(z=>{const j=this.f[this.f.length-1];if(!ee){j?j.buffers.push(()=>ae.call(K,z)):ae.call(K,z);return}const N=j;if(!N){ae.call(K,ee(X,z));return}N.items??=[],N.items.push(z),N.buffers.length===0&&j.buffers.push(()=>{N.reducedResult??=X?N.items.reduce(ee,X):N.items.reduce(ee),ae.call(K,N.reducedResult)})},void 0,te)}bufferEvents(B){const ee={buffers:new Array};this.f.push(ee);const X=B();return this.f.pop(),ee.buffers.forEach(ae=>ae()),X}}e.$re=A;class O{constructor(){this.f=!1,this.g=g.None,this.h=E.$Tc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(B){this.g=B,this.f&&(this.h.dispose(),this.h=B(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$se=O;class W{static const(B){return new x(B)}constructor(B){this.g=B,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(B){B!==this.g&&(this.g=B,this.f.fire(void 0))}}e.$te=W;class x{constructor(B){this.value=B,this.onDidChange=g.None}}}),define(le[21],ue([0,1,4]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=e.CancellationToken=void 0,e.$ve=I;const r=Object.freeze(function(p,a){const g=setTimeout(p.bind(a),0);return{dispose(){clearTimeout(g)}}});var E;(function(p){function a(g){return g===p.None||g===p.Cancelled||g instanceof D?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}p.isCancellationToken=a,p.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),p.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:r})})(E||(e.CancellationToken=E={}));class D{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?r:(this.b||(this.b=new n.$je),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class T{constructor(a){this.f=void 0,this.g=void 0,this.g=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new D),this.f}cancel(){this.f?this.f instanceof D&&this.f.cancel():this.f=E.Cancelled}dispose(a=!1){a&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof D&&this.f.dispose():this.f=E.None}}e.$ue=T;function I(p){const a=new T;return p.add({dispose(){a.cancel()}}),a.token}}),define(le[144],ue([0,1,21]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0e=e.$9e=e.$7e=void 0,e.$8e=E;class r{constructor(p){this.b=p,this.a=null}get(){if(this.a)return this.a;const p=new n.$ue,a=this.b(p.token);return this.a={promise:a,dispose:()=>{this.a=null,p.cancel(),p.dispose()}},this.a}}e.$7e=r;function E(I){return I}class D{constructor(p,a){this.a=void 0,this.b=void 0,typeof p=="function"?(this.c=p,this.d=E):(this.c=a,this.d=p.getCacheKey)}get(p){const a=this.d(p);return this.b!==a&&(this.b=a,this.a=this.c(p)),this.a}}e.$9e=D;class T{get cachedValues(){return this.a}constructor(p,a){this.a=new Map,this.b=new Map,typeof p=="function"?(this.c=p,this.d=E):(this.c=a,this.d=p.getCacheKey)}get(p){const a=this.d(p);if(this.b.has(a))return this.b.get(a);const g=this.c(p);return this.a.set(p,g),this.b.set(a,g),g}}e.$0e=T}),define(le[67],ue([0,1,15,2]),function(Y,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=E,e.$xe=D,e.$ye=T,e.$ze=I,e.$Ae=a,e.$Be=g,e.$Ce=h,e.$De=m,e.$Ee=w,e.$Fe=f,e.$Ge=d,e.$He=v,e.$Ie=b,e.$Je=$,e.$Ke=P;function E(S){const t=S;return t?typeof t.read=="function":!1}function D(S){const t=S;return t?[t.on,t.pause,t.resume,t.destroy].every(u=>typeof u=="function"):!1}function T(S){const t=S;return t?D(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function I(S,t){return new p(S,t)}class p{constructor(t,u){this.e=t,this.f=u,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(u=>this.d.push(u))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(u=>u(t))}h(t){this.c.error.length===0?(0,n.$Y)(t):this.c.error.slice(0).forEach(u=>u(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,u){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(u),this.resume();break;case"end":this.c.end.push(u),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(u),this.a.flowing&&this.k();break}}removeListener(t,u){if(this.a.destroyed)return;let i;switch(t){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const o=i.indexOf(u);o>=0&&i.splice(o,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const u=[...this.d];this.d.length=0,u.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(S,t){const u=[];let i;for(;(i=S.read())!==null;)u.push(i);return t(u)}function g(S,t,u){const i=[];let o;for(;(o=S.read())!==null&&i.length<u;)i.push(o);return o===null&&i.length>0?t(i):{read:()=>{if(i.length>0)return i.shift();if(typeof o<"u"){const s=o;return o=void 0,s}return S.read()}}}function h(S,t){return new Promise((u,i)=>{const o=[];m(S,{onData:s=>{t&&o.push(s)},onError:s=>{t?i(s):u(void 0)},onEnd:()=>{u(t?t(o):void 0)}})})}function m(S,t,u){S.on("error",i=>{u?.isCancellationRequested||t.onError(i)}),S.on("end",()=>{u?.isCancellationRequested||t.onEnd()}),S.on("data",i=>{u?.isCancellationRequested||t.onData(i)})}function w(S,t){return new Promise((u,i)=>{const o=new r.$Sc,s=[],c=y=>{if(s.push(y),s.length>t)return o.dispose(),S.pause(),u({stream:S,buffer:s,ended:!1})},l=y=>(o.dispose(),i(y)),k=()=>(o.dispose(),u({stream:S,buffer:s,ended:!0}));o.add((0,r.$Rc)(()=>S.removeListener("error",l))),S.on("error",l),o.add((0,r.$Rc)(()=>S.removeListener("end",k))),S.on("end",k),o.add((0,r.$Rc)(()=>S.removeListener("data",c))),S.on("data",c)})}function f(S,t){const u=I(t);return u.end(S),u}function d(){const S=I(()=>{throw new Error("not supported")});return S.end(),S}function v(S){let t=!1;return{read:()=>t?null:(t=!0,S)}}function b(S,t,u){const i=I(u);return m(S,{onData:o=>i.write(t.data(o)),onError:o=>i.error(t.error?t.error(o):o),onEnd:()=>i.end()}),i}function $(S,t,u){let i=!1;return{read:()=>{const o=t.read();return i?o:(i=!0,o!==null?u([S,o]):S)}}}function P(S,t,u){let i=!1;const o=I(u);return m(t,{onData:s=>i?o.write(s):(i=!0,o.write(u([S,s]))),onError:s=>o.error(s),onEnd:()=>{i||(i=!0,o.write(S)),o.end()}}),o}}),define(le[16],ue([0,1,65,67]),function(Y,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Le=void 0,e.$Me=a,e.$Ne=g,e.$Oe=h,e.$Pe=m,e.$Qe=w,e.$Re=f,e.$Se=d,e.$Te=v,e.$Ue=b,e.$Ve=$,e.$We=P,e.$Xe=S,e.$Ye=t,e.$Ze=u,e.$1e=i,e.$2e=o,e.$3e=s,e.$4e=c,e.$5e=l,e.$6e=R,r=Ie(r);const E=typeof Buffer<"u",D=new n.$T(()=>new Uint8Array(256));let T,I;class p{static alloc(A){return E?new p(Buffer.allocUnsafe(A)):new p(new Uint8Array(A))}static wrap(A){return E&&!Buffer.isBuffer(A)&&(A=Buffer.from(A.buffer,A.byteOffset,A.byteLength)),new p(A)}static fromString(A,O){return!(O?.dontUseNodeBuffer||!1)&&E?new p(Buffer.from(A)):(T||(T=new TextEncoder),new p(T.encode(A)))}static fromByteArray(A){const O=p.alloc(A.length);for(let W=0,x=A.length;W<x;W++)O.buffer[W]=A[W];return O}static concat(A,O){if(typeof O>"u"){O=0;for(let C=0,B=A.length;C<B;C++)O+=A[C].byteLength}const W=p.alloc(O);let x=0;for(let C=0,B=A.length;C<B;C++){const ee=A[C];W.set(ee,x),x+=ee.byteLength}return W}constructor(A){this.buffer=A,this.byteLength=this.buffer.byteLength}clone(){const A=p.alloc(this.byteLength);return A.set(this),A}toString(){return E?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(A,O){return new p(this.buffer.subarray(A,O))}set(A,O){if(A instanceof p)this.buffer.set(A.buffer,O);else if(A instanceof Uint8Array)this.buffer.set(A,O);else if(A instanceof ArrayBuffer)this.buffer.set(new Uint8Array(A),O);else if(ArrayBuffer.isView(A))this.buffer.set(new Uint8Array(A.buffer,A.byteOffset,A.byteLength),O);else throw new Error("Unknown argument 'array'")}readUInt32BE(A){return m(this.buffer,A)}writeUInt32BE(A,O){w(this.buffer,A,O)}readUInt32LE(A){return f(this.buffer,A)}writeUInt32LE(A,O){d(this.buffer,A,O)}readUInt8(A){return v(this.buffer,A)}writeUInt8(A,O){b(this.buffer,A,O)}indexOf(A,O=0){return a(this.buffer,A instanceof p?A.buffer:A,O)}}e.$Le=p;function a(L,A,O=0){const W=A.byteLength,x=L.byteLength;if(W===0)return 0;if(W===1)return L.indexOf(A[0]);if(W>x-O)return-1;const C=D.value;C.fill(A.length);for(let ae=0;ae<A.length;ae++)C[A[ae]]=A.length-ae-1;let B=O+A.length-1,ee=B,X=-1;for(;B<x;)if(L[B]===A[ee]){if(ee===0){X=B;break}B--,ee--}else B+=Math.max(A.length-ee,C[L[B]]),ee=A.length-1;return X}function g(L,A){return L[A+0]<<0>>>0|L[A+1]<<8>>>0}function h(L,A,O){L[O+0]=A&255,A=A>>>8,L[O+1]=A&255}function m(L,A){return L[A]*2**24+L[A+1]*2**16+L[A+2]*2**8+L[A+3]}function w(L,A,O){L[O+3]=A,A=A>>>8,L[O+2]=A,A=A>>>8,L[O+1]=A,A=A>>>8,L[O]=A}function f(L,A){return L[A+0]<<0>>>0|L[A+1]<<8>>>0|L[A+2]<<16>>>0|L[A+3]<<24>>>0}function d(L,A,O){L[O+0]=A&255,A=A>>>8,L[O+1]=A&255,A=A>>>8,L[O+2]=A&255,A=A>>>8,L[O+3]=A&255}function v(L,A){return L[A]}function b(L,A,O){L[O]=A}function $(L){return r.$Ae(L,A=>p.concat(A))}function P(L){return r.$He(L)}function S(L){return r.$Ce(L,A=>p.concat(A))}async function t(L){return L.ended?p.concat(L.buffer):p.concat([...L.buffer,await S(L.stream)])}function u(L){return r.$Fe(L,A=>p.concat(A))}function i(L){return r.$Ie(L,{data:A=>typeof A=="string"?p.fromString(A):p.wrap(A)},A=>p.concat(A))}function o(L){return r.$ze(A=>p.concat(A),L)}function s(L,A){return r.$Je(L,A,O=>p.concat(O))}function c(L,A){return r.$Ke(L,A,O=>p.concat(O))}function l(L){let A=0,O=0,W=0;const x=new Uint8Array(Math.floor(L.length/4*3)),C=ee=>{switch(O){case 3:x[W++]=A|ee,O=0;break;case 2:x[W++]=A|ee>>>2,A=ee<<6,O=3;break;case 1:x[W++]=A|ee>>>4,A=ee<<4,O=2;break;default:A=ee<<2,O=1}};for(let ee=0;ee<L.length;ee++){const X=L.charCodeAt(ee);if(X>=65&&X<=90)C(X-65);else if(X>=97&&X<=122)C(X-97+26);else if(X>=48&&X<=57)C(X-48+52);else if(X===43||X===45)C(62);else if(X===47||X===95)C(63);else{if(X===61)break;throw new SyntaxError(`Unexpected base64 character ${L[ee]}`)}}const B=W;for(;O>0;)C(0);return p.wrap(x).slice(0,B)}const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function R({buffer:L},A=!0,O=!1){const W=O?y:k;let x="";const C=L.byteLength%3;let B=0;for(;B<L.byteLength-C;B+=3){const ee=L[B+0],X=L[B+1],ae=L[B+2];x+=W[ee>>>2],x+=W[(ee<<4|X>>>4)&63],x+=W[(X<<2|ae>>>6)&63],x+=W[ae&63]}if(C===1){const ee=L[B+0];x+=W[ee>>>2],x+=W[ee<<4&63],A&&(x+="==")}else if(C===2){const ee=L[B+0],X=L[B+1];x+=W[ee>>>2],x+=W[(ee<<4|X>>>4)&63],x+=W[X<<2&63],A&&(x+="=")}return x}}),define(le[145],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=void 0,e.$ee=Symbol("MicrotaskDelay")}),define(le[12],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cg=n,e.$dg=r,e.$eg=E,e.$fg=D,e.$gg=T,e.$hg=I,e.$ig=p,e.$jg=a,e.$kg=g,e.$lg=h,e.$mg=m,e.$ng=w,e.$og=f,e.$pg=v,e.$qg=b,e.$rg=$,e.$sg=P,e.$tg=S;function n(t){return typeof t=="string"}function r(t){return Array.isArray(t)&&t.every(u=>n(u))}function E(t){return typeof t=="object"&&t!==null&&!Array.isArray(t)&&!(t instanceof RegExp)&&!(t instanceof Date)}function D(t){const u=Object.getPrototypeOf(Uint8Array);return typeof t=="object"&&t instanceof u}function T(t){return typeof t=="number"&&!isNaN(t)}function I(t){return!!t&&typeof t[Symbol.iterator]=="function"}function p(t){return t===!0||t===!1}function a(t){return typeof t>"u"}function g(t){return!h(t)}function h(t){return a(t)||t===null}function m(t,u){if(!t)throw new Error(u?`Unexpected type, expected '${u}'`:"Unexpected type")}function w(t){if(h(t))throw new Error("Assertion Failed: argument is undefined or null");return t}function f(...t){const u=[];for(let i=0;i<t.length;i++){const o=t[i];if(h(o))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);u.push(o)}return u}const d=Object.prototype.hasOwnProperty;function v(t){if(!E(t))return!1;for(const u in t)if(d.call(t,u))return!1;return!0}function b(t){return typeof t=="function"}function $(...t){return t.length>0&&t.every(b)}function P(t,u){const i=Math.min(t.length,u.length);for(let o=0;o<i;o++)S(t[o],u[o])}function S(t,u){if(n(u)){if(typeof t!==u)throw new Error(`argument does not match constraint: typeof ${u}`)}else if(b(u)){try{if(t instanceof u)return}catch{}if(!h(t)&&t.constructor===u||u.length===1&&u.call(void 0,t)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(le[109],ue([0,1,12]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wj=E,e.$Xj=D;const r=Object.create(null);function E(T,I){if((0,n.$cg)(I)){const p=r[I];if(p===void 0)throw new Error(`${T} references an unknown codicon: ${I}`);I=p}return r[T]=I,{id:T}}function D(){return r}}),define(le[146],ue([0,1,109]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yj=void 0,e.$Yj={add:(0,n.$Wj)("add",6e4),plus:(0,n.$Wj)("plus",6e4),gistNew:(0,n.$Wj)("gist-new",6e4),repoCreate:(0,n.$Wj)("repo-create",6e4),lightbulb:(0,n.$Wj)("lightbulb",60001),lightBulb:(0,n.$Wj)("light-bulb",60001),repo:(0,n.$Wj)("repo",60002),repoDelete:(0,n.$Wj)("repo-delete",60002),gistFork:(0,n.$Wj)("gist-fork",60003),repoForked:(0,n.$Wj)("repo-forked",60003),gitPullRequest:(0,n.$Wj)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.$Wj)("git-pull-request-abandoned",60004),recordKeys:(0,n.$Wj)("record-keys",60005),keyboard:(0,n.$Wj)("keyboard",60005),tag:(0,n.$Wj)("tag",60006),gitPullRequestLabel:(0,n.$Wj)("git-pull-request-label",60006),tagAdd:(0,n.$Wj)("tag-add",60006),tagRemove:(0,n.$Wj)("tag-remove",60006),person:(0,n.$Wj)("person",60007),personFollow:(0,n.$Wj)("person-follow",60007),personOutline:(0,n.$Wj)("person-outline",60007),personFilled:(0,n.$Wj)("person-filled",60007),gitBranch:(0,n.$Wj)("git-branch",60008),gitBranchCreate:(0,n.$Wj)("git-branch-create",60008),gitBranchDelete:(0,n.$Wj)("git-branch-delete",60008),sourceControl:(0,n.$Wj)("source-control",60008),mirror:(0,n.$Wj)("mirror",60009),mirrorPublic:(0,n.$Wj)("mirror-public",60009),star:(0,n.$Wj)("star",60010),starAdd:(0,n.$Wj)("star-add",60010),starDelete:(0,n.$Wj)("star-delete",60010),starEmpty:(0,n.$Wj)("star-empty",60010),comment:(0,n.$Wj)("comment",60011),commentAdd:(0,n.$Wj)("comment-add",60011),alert:(0,n.$Wj)("alert",60012),warning:(0,n.$Wj)("warning",60012),search:(0,n.$Wj)("search",60013),searchSave:(0,n.$Wj)("search-save",60013),logOut:(0,n.$Wj)("log-out",60014),signOut:(0,n.$Wj)("sign-out",60014),logIn:(0,n.$Wj)("log-in",60015),signIn:(0,n.$Wj)("sign-in",60015),eye:(0,n.$Wj)("eye",60016),eyeUnwatch:(0,n.$Wj)("eye-unwatch",60016),eyeWatch:(0,n.$Wj)("eye-watch",60016),circleFilled:(0,n.$Wj)("circle-filled",60017),primitiveDot:(0,n.$Wj)("primitive-dot",60017),closeDirty:(0,n.$Wj)("close-dirty",60017),debugBreakpoint:(0,n.$Wj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.$Wj)("debug-breakpoint-disabled",60017),debugHint:(0,n.$Wj)("debug-hint",60017),terminalDecorationSuccess:(0,n.$Wj)("terminal-decoration-success",60017),primitiveSquare:(0,n.$Wj)("primitive-square",60018),edit:(0,n.$Wj)("edit",60019),pencil:(0,n.$Wj)("pencil",60019),info:(0,n.$Wj)("info",60020),issueOpened:(0,n.$Wj)("issue-opened",60020),gistPrivate:(0,n.$Wj)("gist-private",60021),gitForkPrivate:(0,n.$Wj)("git-fork-private",60021),lock:(0,n.$Wj)("lock",60021),mirrorPrivate:(0,n.$Wj)("mirror-private",60021),close:(0,n.$Wj)("close",60022),removeClose:(0,n.$Wj)("remove-close",60022),x:(0,n.$Wj)("x",60022),repoSync:(0,n.$Wj)("repo-sync",60023),sync:(0,n.$Wj)("sync",60023),clone:(0,n.$Wj)("clone",60024),desktopDownload:(0,n.$Wj)("desktop-download",60024),beaker:(0,n.$Wj)("beaker",60025),microscope:(0,n.$Wj)("microscope",60025),vm:(0,n.$Wj)("vm",60026),deviceDesktop:(0,n.$Wj)("device-desktop",60026),file:(0,n.$Wj)("file",60027),fileText:(0,n.$Wj)("file-text",60027),more:(0,n.$Wj)("more",60028),ellipsis:(0,n.$Wj)("ellipsis",60028),kebabHorizontal:(0,n.$Wj)("kebab-horizontal",60028),mailReply:(0,n.$Wj)("mail-reply",60029),reply:(0,n.$Wj)("reply",60029),organization:(0,n.$Wj)("organization",60030),organizationFilled:(0,n.$Wj)("organization-filled",60030),organizationOutline:(0,n.$Wj)("organization-outline",60030),newFile:(0,n.$Wj)("new-file",60031),fileAdd:(0,n.$Wj)("file-add",60031),newFolder:(0,n.$Wj)("new-folder",60032),fileDirectoryCreate:(0,n.$Wj)("file-directory-create",60032),trash:(0,n.$Wj)("trash",60033),trashcan:(0,n.$Wj)("trashcan",60033),history:(0,n.$Wj)("history",60034),clock:(0,n.$Wj)("clock",60034),folder:(0,n.$Wj)("folder",60035),fileDirectory:(0,n.$Wj)("file-directory",60035),symbolFolder:(0,n.$Wj)("symbol-folder",60035),logoGithub:(0,n.$Wj)("logo-github",60036),markGithub:(0,n.$Wj)("mark-github",60036),github:(0,n.$Wj)("github",60036),terminal:(0,n.$Wj)("terminal",60037),console:(0,n.$Wj)("console",60037),repl:(0,n.$Wj)("repl",60037),zap:(0,n.$Wj)("zap",60038),symbolEvent:(0,n.$Wj)("symbol-event",60038),error:(0,n.$Wj)("error",60039),stop:(0,n.$Wj)("stop",60039),variable:(0,n.$Wj)("variable",60040),symbolVariable:(0,n.$Wj)("symbol-variable",60040),array:(0,n.$Wj)("array",60042),symbolArray:(0,n.$Wj)("symbol-array",60042),symbolModule:(0,n.$Wj)("symbol-module",60043),symbolPackage:(0,n.$Wj)("symbol-package",60043),symbolNamespace:(0,n.$Wj)("symbol-namespace",60043),symbolObject:(0,n.$Wj)("symbol-object",60043),symbolMethod:(0,n.$Wj)("symbol-method",60044),symbolFunction:(0,n.$Wj)("symbol-function",60044),symbolConstructor:(0,n.$Wj)("symbol-constructor",60044),symbolBoolean:(0,n.$Wj)("symbol-boolean",60047),symbolNull:(0,n.$Wj)("symbol-null",60047),symbolNumeric:(0,n.$Wj)("symbol-numeric",60048),symbolNumber:(0,n.$Wj)("symbol-number",60048),symbolStructure:(0,n.$Wj)("symbol-structure",60049),symbolStruct:(0,n.$Wj)("symbol-struct",60049),symbolParameter:(0,n.$Wj)("symbol-parameter",60050),symbolTypeParameter:(0,n.$Wj)("symbol-type-parameter",60050),symbolKey:(0,n.$Wj)("symbol-key",60051),symbolText:(0,n.$Wj)("symbol-text",60051),symbolReference:(0,n.$Wj)("symbol-reference",60052),goToFile:(0,n.$Wj)("go-to-file",60052),symbolEnum:(0,n.$Wj)("symbol-enum",60053),symbolValue:(0,n.$Wj)("symbol-value",60053),symbolRuler:(0,n.$Wj)("symbol-ruler",60054),symbolUnit:(0,n.$Wj)("symbol-unit",60054),activateBreakpoints:(0,n.$Wj)("activate-breakpoints",60055),archive:(0,n.$Wj)("archive",60056),arrowBoth:(0,n.$Wj)("arrow-both",60057),arrowDown:(0,n.$Wj)("arrow-down",60058),arrowLeft:(0,n.$Wj)("arrow-left",60059),arrowRight:(0,n.$Wj)("arrow-right",60060),arrowSmallDown:(0,n.$Wj)("arrow-small-down",60061),arrowSmallLeft:(0,n.$Wj)("arrow-small-left",60062),arrowSmallRight:(0,n.$Wj)("arrow-small-right",60063),arrowSmallUp:(0,n.$Wj)("arrow-small-up",60064),arrowUp:(0,n.$Wj)("arrow-up",60065),bell:(0,n.$Wj)("bell",60066),bold:(0,n.$Wj)("bold",60067),book:(0,n.$Wj)("book",60068),bookmark:(0,n.$Wj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.$Wj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.$Wj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.$Wj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.$Wj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.$Wj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.$Wj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.$Wj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.$Wj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.$Wj)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.$Wj)("briefcase",60076),broadcast:(0,n.$Wj)("broadcast",60077),browser:(0,n.$Wj)("browser",60078),bug:(0,n.$Wj)("bug",60079),calendar:(0,n.$Wj)("calendar",60080),caseSensitive:(0,n.$Wj)("case-sensitive",60081),check:(0,n.$Wj)("check",60082),checklist:(0,n.$Wj)("checklist",60083),chevronDown:(0,n.$Wj)("chevron-down",60084),chevronLeft:(0,n.$Wj)("chevron-left",60085),chevronRight:(0,n.$Wj)("chevron-right",60086),chevronUp:(0,n.$Wj)("chevron-up",60087),chromeClose:(0,n.$Wj)("chrome-close",60088),chromeMaximize:(0,n.$Wj)("chrome-maximize",60089),chromeMinimize:(0,n.$Wj)("chrome-minimize",60090),chromeRestore:(0,n.$Wj)("chrome-restore",60091),circleOutline:(0,n.$Wj)("circle-outline",60092),circle:(0,n.$Wj)("circle",60092),debugBreakpointUnverified:(0,n.$Wj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.$Wj)("terminal-decoration-incomplete",60092),circleSlash:(0,n.$Wj)("circle-slash",60093),circuitBoard:(0,n.$Wj)("circuit-board",60094),clearAll:(0,n.$Wj)("clear-all",60095),clippy:(0,n.$Wj)("clippy",60096),closeAll:(0,n.$Wj)("close-all",60097),cloudDownload:(0,n.$Wj)("cloud-download",60098),cloudUpload:(0,n.$Wj)("cloud-upload",60099),code:(0,n.$Wj)("code",60100),collapseAll:(0,n.$Wj)("collapse-all",60101),colorMode:(0,n.$Wj)("color-mode",60102),commentDiscussion:(0,n.$Wj)("comment-discussion",60103),creditCard:(0,n.$Wj)("credit-card",60105),dash:(0,n.$Wj)("dash",60108),dashboard:(0,n.$Wj)("dashboard",60109),database:(0,n.$Wj)("database",60110),debugContinue:(0,n.$Wj)("debug-continue",60111),debugDisconnect:(0,n.$Wj)("debug-disconnect",60112),debugPause:(0,n.$Wj)("debug-pause",60113),debugRestart:(0,n.$Wj)("debug-restart",60114),debugStart:(0,n.$Wj)("debug-start",60115),debugStepInto:(0,n.$Wj)("debug-step-into",60116),debugStepOut:(0,n.$Wj)("debug-step-out",60117),debugStepOver:(0,n.$Wj)("debug-step-over",60118),debugStop:(0,n.$Wj)("debug-stop",60119),debug:(0,n.$Wj)("debug",60120),deviceCameraVideo:(0,n.$Wj)("device-camera-video",60121),deviceCamera:(0,n.$Wj)("device-camera",60122),deviceMobile:(0,n.$Wj)("device-mobile",60123),diffAdded:(0,n.$Wj)("diff-added",60124),diffIgnored:(0,n.$Wj)("diff-ignored",60125),diffModified:(0,n.$Wj)("diff-modified",60126),diffRemoved:(0,n.$Wj)("diff-removed",60127),diffRenamed:(0,n.$Wj)("diff-renamed",60128),diff:(0,n.$Wj)("diff",60129),diffSidebyside:(0,n.$Wj)("diff-sidebyside",60129),discard:(0,n.$Wj)("discard",60130),editorLayout:(0,n.$Wj)("editor-layout",60131),emptyWindow:(0,n.$Wj)("empty-window",60132),exclude:(0,n.$Wj)("exclude",60133),extensions:(0,n.$Wj)("extensions",60134),eyeClosed:(0,n.$Wj)("eye-closed",60135),fileBinary:(0,n.$Wj)("file-binary",60136),fileCode:(0,n.$Wj)("file-code",60137),fileMedia:(0,n.$Wj)("file-media",60138),filePdf:(0,n.$Wj)("file-pdf",60139),fileSubmodule:(0,n.$Wj)("file-submodule",60140),fileSymlinkDirectory:(0,n.$Wj)("file-symlink-directory",60141),fileSymlinkFile:(0,n.$Wj)("file-symlink-file",60142),fileZip:(0,n.$Wj)("file-zip",60143),files:(0,n.$Wj)("files",60144),filter:(0,n.$Wj)("filter",60145),flame:(0,n.$Wj)("flame",60146),foldDown:(0,n.$Wj)("fold-down",60147),foldUp:(0,n.$Wj)("fold-up",60148),fold:(0,n.$Wj)("fold",60149),folderActive:(0,n.$Wj)("folder-active",60150),folderOpened:(0,n.$Wj)("folder-opened",60151),gear:(0,n.$Wj)("gear",60152),gift:(0,n.$Wj)("gift",60153),gistSecret:(0,n.$Wj)("gist-secret",60154),gist:(0,n.$Wj)("gist",60155),gitCommit:(0,n.$Wj)("git-commit",60156),gitCompare:(0,n.$Wj)("git-compare",60157),compareChanges:(0,n.$Wj)("compare-changes",60157),gitMerge:(0,n.$Wj)("git-merge",60158),githubAction:(0,n.$Wj)("github-action",60159),githubAlt:(0,n.$Wj)("github-alt",60160),globe:(0,n.$Wj)("globe",60161),grabber:(0,n.$Wj)("grabber",60162),graph:(0,n.$Wj)("graph",60163),gripper:(0,n.$Wj)("gripper",60164),heart:(0,n.$Wj)("heart",60165),home:(0,n.$Wj)("home",60166),horizontalRule:(0,n.$Wj)("horizontal-rule",60167),hubot:(0,n.$Wj)("hubot",60168),inbox:(0,n.$Wj)("inbox",60169),issueReopened:(0,n.$Wj)("issue-reopened",60171),issues:(0,n.$Wj)("issues",60172),italic:(0,n.$Wj)("italic",60173),jersey:(0,n.$Wj)("jersey",60174),json:(0,n.$Wj)("json",60175),kebabVertical:(0,n.$Wj)("kebab-vertical",60176),key:(0,n.$Wj)("key",60177),law:(0,n.$Wj)("law",60178),lightbulbAutofix:(0,n.$Wj)("lightbulb-autofix",60179),linkExternal:(0,n.$Wj)("link-external",60180),link:(0,n.$Wj)("link",60181),listOrdered:(0,n.$Wj)("list-ordered",60182),listUnordered:(0,n.$Wj)("list-unordered",60183),liveShare:(0,n.$Wj)("live-share",60184),loading:(0,n.$Wj)("loading",60185),location:(0,n.$Wj)("location",60186),mailRead:(0,n.$Wj)("mail-read",60187),mail:(0,n.$Wj)("mail",60188),markdown:(0,n.$Wj)("markdown",60189),megaphone:(0,n.$Wj)("megaphone",60190),mention:(0,n.$Wj)("mention",60191),milestone:(0,n.$Wj)("milestone",60192),gitPullRequestMilestone:(0,n.$Wj)("git-pull-request-milestone",60192),mortarBoard:(0,n.$Wj)("mortar-board",60193),move:(0,n.$Wj)("move",60194),multipleWindows:(0,n.$Wj)("multiple-windows",60195),mute:(0,n.$Wj)("mute",60196),noNewline:(0,n.$Wj)("no-newline",60197),note:(0,n.$Wj)("note",60198),octoface:(0,n.$Wj)("octoface",60199),openPreview:(0,n.$Wj)("open-preview",60200),package:(0,n.$Wj)("package",60201),paintcan:(0,n.$Wj)("paintcan",60202),pin:(0,n.$Wj)("pin",60203),play:(0,n.$Wj)("play",60204),run:(0,n.$Wj)("run",60204),plug:(0,n.$Wj)("plug",60205),preserveCase:(0,n.$Wj)("preserve-case",60206),preview:(0,n.$Wj)("preview",60207),project:(0,n.$Wj)("project",60208),pulse:(0,n.$Wj)("pulse",60209),question:(0,n.$Wj)("question",60210),quote:(0,n.$Wj)("quote",60211),radioTower:(0,n.$Wj)("radio-tower",60212),reactions:(0,n.$Wj)("reactions",60213),references:(0,n.$Wj)("references",60214),refresh:(0,n.$Wj)("refresh",60215),regex:(0,n.$Wj)("regex",60216),remoteExplorer:(0,n.$Wj)("remote-explorer",60217),remote:(0,n.$Wj)("remote",60218),remove:(0,n.$Wj)("remove",60219),replaceAll:(0,n.$Wj)("replace-all",60220),replace:(0,n.$Wj)("replace",60221),repoClone:(0,n.$Wj)("repo-clone",60222),repoForcePush:(0,n.$Wj)("repo-force-push",60223),repoPull:(0,n.$Wj)("repo-pull",60224),repoPush:(0,n.$Wj)("repo-push",60225),report:(0,n.$Wj)("report",60226),requestChanges:(0,n.$Wj)("request-changes",60227),rocket:(0,n.$Wj)("rocket",60228),rootFolderOpened:(0,n.$Wj)("root-folder-opened",60229),rootFolder:(0,n.$Wj)("root-folder",60230),rss:(0,n.$Wj)("rss",60231),ruby:(0,n.$Wj)("ruby",60232),saveAll:(0,n.$Wj)("save-all",60233),saveAs:(0,n.$Wj)("save-as",60234),save:(0,n.$Wj)("save",60235),screenFull:(0,n.$Wj)("screen-full",60236),screenNormal:(0,n.$Wj)("screen-normal",60237),searchStop:(0,n.$Wj)("search-stop",60238),server:(0,n.$Wj)("server",60240),settingsGear:(0,n.$Wj)("settings-gear",60241),settings:(0,n.$Wj)("settings",60242),shield:(0,n.$Wj)("shield",60243),smiley:(0,n.$Wj)("smiley",60244),sortPrecedence:(0,n.$Wj)("sort-precedence",60245),splitHorizontal:(0,n.$Wj)("split-horizontal",60246),splitVertical:(0,n.$Wj)("split-vertical",60247),squirrel:(0,n.$Wj)("squirrel",60248),starFull:(0,n.$Wj)("star-full",60249),starHalf:(0,n.$Wj)("star-half",60250),symbolClass:(0,n.$Wj)("symbol-class",60251),symbolColor:(0,n.$Wj)("symbol-color",60252),symbolConstant:(0,n.$Wj)("symbol-constant",60253),symbolEnumMember:(0,n.$Wj)("symbol-enum-member",60254),symbolField:(0,n.$Wj)("symbol-field",60255),symbolFile:(0,n.$Wj)("symbol-file",60256),symbolInterface:(0,n.$Wj)("symbol-interface",60257),symbolKeyword:(0,n.$Wj)("symbol-keyword",60258),symbolMisc:(0,n.$Wj)("symbol-misc",60259),symbolOperator:(0,n.$Wj)("symbol-operator",60260),symbolProperty:(0,n.$Wj)("symbol-property",60261),wrench:(0,n.$Wj)("wrench",60261),wrenchSubaction:(0,n.$Wj)("wrench-subaction",60261),symbolSnippet:(0,n.$Wj)("symbol-snippet",60262),tasklist:(0,n.$Wj)("tasklist",60263),telescope:(0,n.$Wj)("telescope",60264),textSize:(0,n.$Wj)("text-size",60265),threeBars:(0,n.$Wj)("three-bars",60266),thumbsdown:(0,n.$Wj)("thumbsdown",60267),thumbsup:(0,n.$Wj)("thumbsup",60268),tools:(0,n.$Wj)("tools",60269),triangleDown:(0,n.$Wj)("triangle-down",60270),triangleLeft:(0,n.$Wj)("triangle-left",60271),triangleRight:(0,n.$Wj)("triangle-right",60272),triangleUp:(0,n.$Wj)("triangle-up",60273),twitter:(0,n.$Wj)("twitter",60274),unfold:(0,n.$Wj)("unfold",60275),unlock:(0,n.$Wj)("unlock",60276),unmute:(0,n.$Wj)("unmute",60277),unverified:(0,n.$Wj)("unverified",60278),verified:(0,n.$Wj)("verified",60279),versions:(0,n.$Wj)("versions",60280),vmActive:(0,n.$Wj)("vm-active",60281),vmOutline:(0,n.$Wj)("vm-outline",60282),vmRunning:(0,n.$Wj)("vm-running",60283),watch:(0,n.$Wj)("watch",60284),whitespace:(0,n.$Wj)("whitespace",60285),wholeWord:(0,n.$Wj)("whole-word",60286),window:(0,n.$Wj)("window",60287),wordWrap:(0,n.$Wj)("word-wrap",60288),zoomIn:(0,n.$Wj)("zoom-in",60289),zoomOut:(0,n.$Wj)("zoom-out",60290),listFilter:(0,n.$Wj)("list-filter",60291),listFlat:(0,n.$Wj)("list-flat",60292),listSelection:(0,n.$Wj)("list-selection",60293),selection:(0,n.$Wj)("selection",60293),listTree:(0,n.$Wj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.$Wj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.$Wj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.$Wj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.$Wj)("debug-stackframe-active",60297),circleSmallFilled:(0,n.$Wj)("circle-small-filled",60298),debugStackframeDot:(0,n.$Wj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.$Wj)("terminal-decoration-mark",60298),debugStackframe:(0,n.$Wj)("debug-stackframe",60299),debugStackframeFocused:(0,n.$Wj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.$Wj)("debug-breakpoint-unsupported",60300),symbolString:(0,n.$Wj)("symbol-string",60301),debugReverseContinue:(0,n.$Wj)("debug-reverse-continue",60302),debugStepBack:(0,n.$Wj)("debug-step-back",60303),debugRestartFrame:(0,n.$Wj)("debug-restart-frame",60304),debugAlt:(0,n.$Wj)("debug-alt",60305),callIncoming:(0,n.$Wj)("call-incoming",60306),callOutgoing:(0,n.$Wj)("call-outgoing",60307),menu:(0,n.$Wj)("menu",60308),expandAll:(0,n.$Wj)("expand-all",60309),feedback:(0,n.$Wj)("feedback",60310),gitPullRequestReviewer:(0,n.$Wj)("git-pull-request-reviewer",60310),groupByRefType:(0,n.$Wj)("group-by-ref-type",60311),ungroupByRefType:(0,n.$Wj)("ungroup-by-ref-type",60312),account:(0,n.$Wj)("account",60313),gitPullRequestAssignee:(0,n.$Wj)("git-pull-request-assignee",60313),bellDot:(0,n.$Wj)("bell-dot",60314),debugConsole:(0,n.$Wj)("debug-console",60315),library:(0,n.$Wj)("library",60316),output:(0,n.$Wj)("output",60317),runAll:(0,n.$Wj)("run-all",60318),syncIgnored:(0,n.$Wj)("sync-ignored",60319),pinned:(0,n.$Wj)("pinned",60320),githubInverted:(0,n.$Wj)("github-inverted",60321),serverProcess:(0,n.$Wj)("server-process",60322),serverEnvironment:(0,n.$Wj)("server-environment",60323),pass:(0,n.$Wj)("pass",60324),issueClosed:(0,n.$Wj)("issue-closed",60324),stopCircle:(0,n.$Wj)("stop-circle",60325),playCircle:(0,n.$Wj)("play-circle",60326),record:(0,n.$Wj)("record",60327),debugAltSmall:(0,n.$Wj)("debug-alt-small",60328),vmConnect:(0,n.$Wj)("vm-connect",60329),cloud:(0,n.$Wj)("cloud",60330),merge:(0,n.$Wj)("merge",60331),export:(0,n.$Wj)("export",60332),graphLeft:(0,n.$Wj)("graph-left",60333),magnet:(0,n.$Wj)("magnet",60334),notebook:(0,n.$Wj)("notebook",60335),redo:(0,n.$Wj)("redo",60336),checkAll:(0,n.$Wj)("check-all",60337),pinnedDirty:(0,n.$Wj)("pinned-dirty",60338),passFilled:(0,n.$Wj)("pass-filled",60339),circleLargeFilled:(0,n.$Wj)("circle-large-filled",60340),circleLarge:(0,n.$Wj)("circle-large",60341),circleLargeOutline:(0,n.$Wj)("circle-large-outline",60341),combine:(0,n.$Wj)("combine",60342),gather:(0,n.$Wj)("gather",60342),table:(0,n.$Wj)("table",60343),variableGroup:(0,n.$Wj)("variable-group",60344),typeHierarchy:(0,n.$Wj)("type-hierarchy",60345),typeHierarchySub:(0,n.$Wj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.$Wj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.$Wj)("git-pull-request-create",60348),runAbove:(0,n.$Wj)("run-above",60349),runBelow:(0,n.$Wj)("run-below",60350),notebookTemplate:(0,n.$Wj)("notebook-template",60351),debugRerun:(0,n.$Wj)("debug-rerun",60352),workspaceTrusted:(0,n.$Wj)("workspace-trusted",60353),workspaceUntrusted:(0,n.$Wj)("workspace-untrusted",60354),workspaceUnknown:(0,n.$Wj)("workspace-unknown",60355),terminalCmd:(0,n.$Wj)("terminal-cmd",60356),terminalDebian:(0,n.$Wj)("terminal-debian",60357),terminalLinux:(0,n.$Wj)("terminal-linux",60358),terminalPowershell:(0,n.$Wj)("terminal-powershell",60359),terminalTmux:(0,n.$Wj)("terminal-tmux",60360),terminalUbuntu:(0,n.$Wj)("terminal-ubuntu",60361),terminalBash:(0,n.$Wj)("terminal-bash",60362),arrowSwap:(0,n.$Wj)("arrow-swap",60363),copy:(0,n.$Wj)("copy",60364),personAdd:(0,n.$Wj)("person-add",60365),filterFilled:(0,n.$Wj)("filter-filled",60366),wand:(0,n.$Wj)("wand",60367),debugLineByLine:(0,n.$Wj)("debug-line-by-line",60368),inspect:(0,n.$Wj)("inspect",60369),layers:(0,n.$Wj)("layers",60370),layersDot:(0,n.$Wj)("layers-dot",60371),layersActive:(0,n.$Wj)("layers-active",60372),compass:(0,n.$Wj)("compass",60373),compassDot:(0,n.$Wj)("compass-dot",60374),compassActive:(0,n.$Wj)("compass-active",60375),azure:(0,n.$Wj)("azure",60376),issueDraft:(0,n.$Wj)("issue-draft",60377),gitPullRequestClosed:(0,n.$Wj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.$Wj)("git-pull-request-draft",60379),debugAll:(0,n.$Wj)("debug-all",60380),debugCoverage:(0,n.$Wj)("debug-coverage",60381),runErrors:(0,n.$Wj)("run-errors",60382),folderLibrary:(0,n.$Wj)("folder-library",60383),debugContinueSmall:(0,n.$Wj)("debug-continue-small",60384),beakerStop:(0,n.$Wj)("beaker-stop",60385),graphLine:(0,n.$Wj)("graph-line",60386),graphScatter:(0,n.$Wj)("graph-scatter",60387),pieChart:(0,n.$Wj)("pie-chart",60388),bracket:(0,n.$Wj)("bracket",60175),bracketDot:(0,n.$Wj)("bracket-dot",60389),bracketError:(0,n.$Wj)("bracket-error",60390),lockSmall:(0,n.$Wj)("lock-small",60391),azureDevops:(0,n.$Wj)("azure-devops",60392),verifiedFilled:(0,n.$Wj)("verified-filled",60393),newline:(0,n.$Wj)("newline",60394),layout:(0,n.$Wj)("layout",60395),layoutActivitybarLeft:(0,n.$Wj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.$Wj)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.$Wj)("layout-panel-left",60398),layoutPanelCenter:(0,n.$Wj)("layout-panel-center",60399),layoutPanelJustify:(0,n.$Wj)("layout-panel-justify",60400),layoutPanelRight:(0,n.$Wj)("layout-panel-right",60401),layoutPanel:(0,n.$Wj)("layout-panel",60402),layoutSidebarLeft:(0,n.$Wj)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.$Wj)("layout-sidebar-right",60404),layoutStatusbar:(0,n.$Wj)("layout-statusbar",60405),layoutMenubar:(0,n.$Wj)("layout-menubar",60406),layoutCentered:(0,n.$Wj)("layout-centered",60407),target:(0,n.$Wj)("target",60408),indent:(0,n.$Wj)("indent",60409),recordSmall:(0,n.$Wj)("record-small",60410),errorSmall:(0,n.$Wj)("error-small",60411),terminalDecorationError:(0,n.$Wj)("terminal-decoration-error",60411),arrowCircleDown:(0,n.$Wj)("arrow-circle-down",60412),arrowCircleLeft:(0,n.$Wj)("arrow-circle-left",60413),arrowCircleRight:(0,n.$Wj)("arrow-circle-right",60414),arrowCircleUp:(0,n.$Wj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.$Wj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.$Wj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.$Wj)("layout-sidebar-left-off",60418),blank:(0,n.$Wj)("blank",60419),heartFilled:(0,n.$Wj)("heart-filled",60420),map:(0,n.$Wj)("map",60421),mapHorizontal:(0,n.$Wj)("map-horizontal",60421),foldHorizontal:(0,n.$Wj)("fold-horizontal",60421),mapFilled:(0,n.$Wj)("map-filled",60422),mapHorizontalFilled:(0,n.$Wj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,n.$Wj)("fold-horizontal-filled",60422),circleSmall:(0,n.$Wj)("circle-small",60423),bellSlash:(0,n.$Wj)("bell-slash",60424),bellSlashDot:(0,n.$Wj)("bell-slash-dot",60425),commentUnresolved:(0,n.$Wj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.$Wj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.$Wj)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.$Wj)("search-fuzzy",60429),commentDraft:(0,n.$Wj)("comment-draft",60430),send:(0,n.$Wj)("send",60431),sparkle:(0,n.$Wj)("sparkle",60432),insert:(0,n.$Wj)("insert",60433),mic:(0,n.$Wj)("mic",60434),thumbsdownFilled:(0,n.$Wj)("thumbsdown-filled",60435),thumbsupFilled:(0,n.$Wj)("thumbsup-filled",60436),coffee:(0,n.$Wj)("coffee",60437),snake:(0,n.$Wj)("snake",60438),game:(0,n.$Wj)("game",60439),vr:(0,n.$Wj)("vr",60440),chip:(0,n.$Wj)("chip",60441),piano:(0,n.$Wj)("piano",60442),music:(0,n.$Wj)("music",60443),micFilled:(0,n.$Wj)("mic-filled",60444),repoFetch:(0,n.$Wj)("repo-fetch",60445),copilot:(0,n.$Wj)("copilot",60446),lightbulbSparkle:(0,n.$Wj)("lightbulb-sparkle",60447),robot:(0,n.$Wj)("robot",60448),sparkleFilled:(0,n.$Wj)("sparkle-filled",60449),diffSingle:(0,n.$Wj)("diff-single",60450),diffMultiple:(0,n.$Wj)("diff-multiple",60451),surroundWith:(0,n.$Wj)("surround-with",60452),share:(0,n.$Wj)("share",60453),gitStash:(0,n.$Wj)("git-stash",60454),gitStashApply:(0,n.$Wj)("git-stash-apply",60455),gitStashPop:(0,n.$Wj)("git-stash-pop",60456),vscode:(0,n.$Wj)("vscode",60457),vscodeInsiders:(0,n.$Wj)("vscode-insiders",60458),codeOss:(0,n.$Wj)("code-oss",60459),runCoverage:(0,n.$Wj)("run-coverage",60460),runAllCoverage:(0,n.$Wj)("run-all-coverage",60461),coverage:(0,n.$Wj)("coverage",60462),githubProject:(0,n.$Wj)("github-project",60463),mapVertical:(0,n.$Wj)("map-vertical",60464),foldVertical:(0,n.$Wj)("fold-vertical",60464),mapVerticalFilled:(0,n.$Wj)("map-vertical-filled",60465),foldVerticalFilled:(0,n.$Wj)("fold-vertical-filled",60465),goToSearch:(0,n.$Wj)("go-to-search",60466),percentage:(0,n.$Wj)("percentage",60467),sortPercentage:(0,n.$Wj)("sort-percentage",60467),attach:(0,n.$Wj)("attach",60468)}}),define(le[80],ue([0,1,109,146]),function(Y,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=e.$1j=void 0,e.$Zj=E;function E(){return Object.values(e.$2j)}e.$1j={dialogError:(0,n.$Wj)("dialog-error","error"),dialogWarning:(0,n.$Wj)("dialog-warning","warning"),dialogInfo:(0,n.$Wj)("dialog-info","info"),dialogClose:(0,n.$Wj)("dialog-close","close"),treeItemExpanded:(0,n.$Wj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.$Wj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.$Wj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.$Wj)("tree-filter-clear","close"),treeItemLoading:(0,n.$Wj)("tree-item-loading","loading"),menuSelection:(0,n.$Wj)("menu-selection","check"),menuSubmenu:(0,n.$Wj)("menu-submenu","chevron-right"),menuBarMore:(0,n.$Wj)("menubar-more","more"),scrollbarButtonLeft:(0,n.$Wj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.$Wj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.$Wj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.$Wj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.$Wj)("toolbar-more","more"),quickInputBack:(0,n.$Wj)("quick-input-back","arrow-left"),dropDownButton:(0,n.$Wj)("drop-down-button",60084),symbolCustomColor:(0,n.$Wj)("symbol-customcolor",60252),exportIcon:(0,n.$Wj)("export",60332),workspaceUnspecified:(0,n.$Wj)("workspace-unspecified",60355),newLine:(0,n.$Wj)("newline",60394),thumbsDownFilled:(0,n.$Wj)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.$Wj)("thumbsup-filled",60436),gitFetch:(0,n.$Wj)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.$Wj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.$Wj)("debug-breakpoint-pending",60377)},e.$2j={...r.$Yj,...e.$1j}}),define(le[37],ue([0,1,12]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ao=r,e.$bo=E,e.$co=T,e.$do=p,e.$eo=a,e.$fo=g,e.$go=h,e.$ho=m,e.$io=w,e.$jo=f,e.$ko=d,e.$lo=v,e.$mo=b;function r($){if(!$||typeof $!="object"||$ instanceof RegExp)return $;const P=Array.isArray($)?[]:{};return Object.entries($).forEach(([S,t])=>{P[S]=t&&typeof t=="object"?r(t):t}),P}function E($){if(!$||typeof $!="object")return $;const P=[$];for(;P.length>0;){const S=P.shift();Object.freeze(S);for(const t in S)if(D.call(S,t)){const u=S[t];typeof u=="object"&&!Object.isFrozen(u)&&!(0,n.$fg)(u)&&P.push(u)}}return $}const D=Object.prototype.hasOwnProperty;function T($,P){return I($,P,new Set)}function I($,P,S){if((0,n.$lg)($))return $;const t=P($);if(typeof t<"u")return t;if(Array.isArray($)){const u=[];for(const i of $)u.push(I(i,P,S));return u}if((0,n.$eg)($)){if(S.has($))throw new Error("Cannot clone recursive data-structure");S.add($);const u={};for(const i in $)D.call($,i)&&(u[i]=I($[i],P,S));return S.delete($),u}return $}function p($,P,S=!0){return(0,n.$eg)($)?((0,n.$eg)(P)&&Object.keys(P).forEach(t=>{t in $?S&&((0,n.$eg)($[t])&&(0,n.$eg)(P[t])?p($[t],P[t],S):$[t]=P[t]):$[t]=P[t]}),$):P}function a($,P){if($===P)return!0;if($==null||P===null||P===void 0||typeof $!=typeof P||typeof $!="object"||Array.isArray($)!==Array.isArray(P))return!1;let S,t;if(Array.isArray($)){if($.length!==P.length)return!1;for(S=0;S<$.length;S++)if(!a($[S],P[S]))return!1}else{const u=[];for(t in $)u.push(t);u.sort();const i=[];for(t in P)i.push(t);if(i.sort(),!a(u,i))return!1;for(S=0;S<u.length;S++)if(!a($[u[S]],P[u[S]]))return!1}return!0}function g($){const P=new Set;return JSON.stringify($,(S,t)=>{if((0,n.$eg)(t)||Array.isArray(t)){if(P.has(t))return"[Circular]";P.add(t)}return typeof t=="bigint"?`[BigInt ${t.toString()}]`:t})}function h($,P){const S=Object.create(null);return!$||!P||Object.keys(P).forEach(u=>{const i=$[u],o=P[u];a(i,o)||(S[u]=o)}),S}function m($,P){const S=P.toLowerCase(),t=Object.keys($).find(u=>u.toLowerCase()===S);return t?$[t]:$[P]}function w($,P){const S=Object.create(null);for(const[t,u]of Object.entries($))P(t,u)&&(S[t]=u);return S}function f($){let P=[];for(;Object.prototype!==$;)P=P.concat(Object.getOwnPropertyNames($)),$=Object.getPrototypeOf($);return P}function d($){const P=[];for(const S of f($))typeof $[S]=="function"&&P.push(S);return P}function v($,P){const S=u=>function(){const i=Array.prototype.slice.call(arguments,0);return P(u,i)},t={};for(const u of $)t[u]=S(u);return t}function b($,P){const S={};for(const[t,u]of Object.entries($))S[t]=P(u,t);return S}}),define(le[110],ue([0,1,80]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$3j=E;var r;(function(T){function I(p){return p&&typeof p=="object"&&typeof p.id=="string"}T.isThemeColor=I})(r||(e.ThemeColor=r={}));function E(T){return{id:T}}var D;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function p($){const P=I.exec($.id);if(!P)return p(n.$2j.error);const[,S,t]=P,u=["codicon","codicon-"+S];return t&&u.push("codicon-modifier-"+t.substring(1)),u}T.asClassNameArray=p;function a($){return p($).join(" ")}T.asClassName=a;function g($){return"."+p($).join(".")}T.asCSSSelector=g;function h($){return $&&typeof $=="object"&&typeof $.id=="string"&&(typeof $.color>"u"||r.isThemeColor($.color))}T.isThemeIcon=h;const m=new RegExp(`^\\$\\((${T.iconNameExpression}(?:${T.iconModifierExpression})?)\\)$`);function w($){const P=m.exec($);if(!P)return;const[,S]=P;return{id:S}}T.fromString=w;function f($){return{id:$}}T.fromId=f;function d($,P){let S=$.id;const t=S.lastIndexOf("~");return t!==-1&&(S=S.substring(0,t)),P&&(S=`${S}~${P}`),{id:S}}T.modify=d;function v($){const P=$.id.lastIndexOf("~");if(P!==-1)return $.id.substring(P+1)}T.getModifier=v;function b($,P){return $.id===P.id&&$.color?.id===P.color?.id}T.isEqual=b})(D||(e.ThemeIcon=D={}))}),define(le[147],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$$e=r,e.$_e=E;var n;(function(D){D[D.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",D[D.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",D[D.MAX_UINT_8=255]="MAX_UINT_8",D[D.MAX_UINT_16=65535]="MAX_UINT_16",D[D.MAX_UINT_32=4294967295]="MAX_UINT_32",D[D.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(n||(e.Constants=n={}));function r(D){return D<0?0:D>n.MAX_UINT_8?n.MAX_UINT_8:D|0}function E(D){return D<0?0:D>n.MAX_UINT_32?n.MAX_UINT_32:D|0}}),define(le[25],ue([0,1,144,39,65,147]),function(Y,e,n,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bg=e.$ag=e.$_f=e.GraphemeBreakType=e.$2f=e.$Tf=e.$Mf=e.$Lf=void 0,e.$af=T,e.$bf=p,e.$cf=g,e.$df=h,e.$ef=m,e.$ff=w,e.$gf=f,e.$hf=d,e.$if=v,e.$jf=b,e.$kf=$,e.$lf=P,e.$mf=S,e.$nf=t,e.$of=u,e.$pf=i,e.$qf=o,e.$rf=s,e.$sf=c,e.$tf=l,e.$uf=k,e.$vf=y,e.$wf=R,e.$xf=L,e.$yf=A,e.$zf=O,e.$Af=W,e.$Bf=x,e.$Cf=C,e.$Df=B,e.$Ef=ee,e.$Ff=X,e.$Gf=ae,e.$Hf=K,e.$If=te,e.$Jf=z,e.$Kf=j,e.$Nf=G,e.$Of=he,e.$Pf=re,e.$Qf=_,e.$Rf=U,e.$Sf=Q,e.$Uf=J,e.$Vf=H,e.$Wf=ne,e.$Xf=de,e.$Yf=we,e.$Zf=Re,e.$1f=Pe,e.$3f=De,e.$4f=$e,e.$5f=Z,e.$6f=ce,e.$7f=fe,e.$8f=be,e.$9f=Ae,e.$0f=Ce,e.$$f=Qe;function T(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}const I=/{(\d+)}/g;function p(ie,...ge){return ge.length===0?ie:ie.replace(I,function(pe,ye){const We=parseInt(ye,10);return isNaN(We)||We<0||We>=ge.length?pe:ge[We]})}const a=/{([^}]+)}/g;function g(ie,ge){return Object.keys(ge).length===0?ie:ie.replace(a,(pe,ye)=>ge[ye]??pe)}function h(ie){return ie.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function m(ie){return ie.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function w(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function f(ie,ge){let pe=0,ye=ie.indexOf(ge);for(;ye!==-1;)pe++,ye=ie.indexOf(ge,ye+ge.length);return pe}function d(ie,ge,pe="\u2026"){return ie.length<=ge?ie:`${ie.substr(0,ge)}${pe}`}function v(ie,ge,pe="\u2026"){if(ie.length<=ge)return ie;const ye=Math.ceil(ge/2)-pe.length/2,We=Math.floor(ge/2)-pe.length/2;return`${ie.substr(0,ye)}${pe}${ie.substr(ie.length-We)}`}function b(ie,ge=" "){const pe=$(ie,ge);return P(pe,ge)}function $(ie,ge){if(!ie||!ge)return ie;const pe=ge.length;if(pe===0||ie.length===0)return ie;let ye=0;for(;ie.indexOf(ge,ye)===ye;)ye=ye+pe;return ie.substring(ye)}function P(ie,ge){if(!ie||!ge)return ie;const pe=ge.length,ye=ie.length;if(pe===0||ye===0)return ie;let We=ye,Ue=-1;for(;Ue=ie.lastIndexOf(ge,We-1),!(Ue===-1||Ue+pe!==We);){if(Ue===0)return"";We=Ue}return ie.substring(0,We)}function S(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function t(ie){return ie.replace(/\*/g,"")}function u(ie,ge,pe={}){if(!ie)throw new Error("Cannot create regex from empty string");ge||(ie=w(ie)),pe.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let ye="";return pe.global&&(ye+="g"),pe.matchCase||(ye+="i"),pe.multiline&&(ye+="m"),pe.unicode&&(ye+="u"),new RegExp(ie,ye)}function i(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}function o(ie){return ie.split(/\r\n|\r|\n/)}function s(ie){const ge=[],pe=ie.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil(pe.length/2);ye++)ge.push(pe[2*ye]+(pe[2*ye+1]??""));return ge}function c(ie){for(let ge=0,pe=ie.length;ge<pe;ge++){const ye=ie.charCodeAt(ge);if(ye!==r.CharCode.Space&&ye!==r.CharCode.Tab)return ge}return-1}function l(ie,ge=0,pe=ie.length){for(let ye=ge;ye<pe;ye++){const We=ie.charCodeAt(ye);if(We!==r.CharCode.Space&&We!==r.CharCode.Tab)return ie.substring(ge,ye)}return ie.substring(ge,pe)}function k(ie,ge=ie.length-1){for(let pe=ge;pe>=0;pe--){const ye=ie.charCodeAt(pe);if(ye!==r.CharCode.Space&&ye!==r.CharCode.Tab)return pe}return-1}function y(ie,ge,pe){const ye=[];let We=0;for(const Ue of ie.matchAll(ge)){if(ye.push(ie.slice(We,Ue.index)),Ue.index===void 0)throw new Error("match.index should be defined");We=Ue.index+Ue[0].length,ye.push(pe(Ue[0],...Ue.slice(1),Ue.index,ie,Ue.groups))}return ye.push(ie.slice(We)),Promise.all(ye).then(Ue=>Ue.join(""))}function R(ie,ge){return ie<ge?-1:ie>ge?1:0}function L(ie,ge,pe=0,ye=ie.length,We=0,Ue=ge.length){for(;pe<ye&&We<Ue;pe++,We++){const rt=ie.charCodeAt(pe),at=ge.charCodeAt(We);if(rt<at)return-1;if(rt>at)return 1}const Ze=ye-pe,lt=Ue-We;return Ze<lt?-1:Ze>lt?1:0}function A(ie,ge){return O(ie,ge,0,ie.length,0,ge.length)}function O(ie,ge,pe=0,ye=ie.length,We=0,Ue=ge.length){for(;pe<ye&&We<Ue;pe++,We++){let rt=ie.charCodeAt(pe),at=ge.charCodeAt(We);if(rt===at)continue;if(rt>=128||at>=128)return L(ie.toLowerCase(),ge.toLowerCase(),pe,ye,We,Ue);x(rt)&&(rt-=32),x(at)&&(at-=32);const tt=rt-at;if(tt!==0)return tt}const Ze=ye-pe,lt=Ue-We;return Ze<lt?-1:Ze>lt?1:0}function W(ie){return ie>=r.CharCode.Digit0&&ie<=r.CharCode.Digit9}function x(ie){return ie>=r.CharCode.a&&ie<=r.CharCode.z}function C(ie){return ie>=r.CharCode.A&&ie<=r.CharCode.Z}function B(ie,ge){return ie.length===ge.length&&O(ie,ge)===0}function ee(ie,ge){const pe=ge.length;return ge.length>ie.length?!1:O(ie,ge,0,pe)===0}function X(ie,ge){const pe=Math.min(ie.length,ge.length);let ye;for(ye=0;ye<pe;ye++)if(ie.charCodeAt(ye)!==ge.charCodeAt(ye))return ye;return pe}function ae(ie,ge){const pe=Math.min(ie.length,ge.length);let ye;const We=ie.length-1,Ue=ge.length-1;for(ye=0;ye<pe;ye++)if(ie.charCodeAt(We-ye)!==ge.charCodeAt(Ue-ye))return ye;return pe}function K(ie){return 55296<=ie&&ie<=56319}function te(ie){return 56320<=ie&&ie<=57343}function z(ie,ge){return(ie-55296<<10)+(ge-56320)+65536}function j(ie,ge,pe){const ye=ie.charCodeAt(pe);if(K(ye)&&pe+1<ge){const We=ie.charCodeAt(pe+1);if(te(We))return z(ye,We)}return ye}function N(ie,ge){const pe=ie.charCodeAt(ge-1);if(te(pe)&&ge>1){const ye=ie.charCodeAt(ge-2);if(K(ye))return z(ye,pe)}return pe}class V{get offset(){return this.e}constructor(ge,pe=0){this.c=ge,this.d=ge.length,this.e=pe}setOffset(ge){this.e=ge}prevCodePoint(){const ge=N(this.c,this.e);return this.e-=ge>=D.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}nextCodePoint(){const ge=j(this.c,this.d,this.e);return this.e+=ge>=D.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}eol(){return this.e>=this.d}}e.$Lf=V;class oe{get offset(){return this.c.offset}constructor(ge,pe=0){this.c=new V(ge,pe)}nextGraphemeLength(){const ge=Be.getInstance(),pe=this.c,ye=pe.offset;let We=ge.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Ue=pe.offset,Ze=ge.getGraphemeBreakType(pe.nextCodePoint());if(Me(We,Ze)){pe.setOffset(Ue);break}We=Ze}return pe.offset-ye}prevGraphemeLength(){const ge=Be.getInstance(),pe=this.c,ye=pe.offset;let We=ge.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Ue=pe.offset,Ze=ge.getGraphemeBreakType(pe.prevCodePoint());if(Me(Ze,We)){pe.setOffset(Ue);break}We=Ze}return ye-pe.offset}eol(){return this.c.eol()}}e.$Mf=oe;function G(ie,ge){return new oe(ie,ge).nextGraphemeLength()}function he(ie,ge){return new oe(ie,ge).prevGraphemeLength()}function re(ie,ge){ge>0&&te(ie.charCodeAt(ge))&&ge--;const pe=ge+G(ie,ge);return[pe-he(ie,pe),pe]}function _(ie){const ge=new oe(ie);let pe=0;for(;!ge.eol();)pe++,ge.nextGraphemeLength();return pe}let M;function F(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function U(ie){return M||(M=F()),M.test(ie)}const q=/^[\t\n\r\x20-\x7E]*$/;function Q(ie){return q.test(ie)}e.$Tf=/[\u2028\u2029]/;function J(ie){return e.$Tf.test(ie)}function H(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}function ne(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}function de(ie,ge,pe=""){const ye=ie.trimStart();if(ye.length<ge)return ye;const We=/\b/g;let Ue=0;for(;We.test(ye)&&!(ye.length-We.lastIndex<ge);)Ue=We.lastIndex,We.lastIndex+=1;return Ue===0?ye:pe+ye.substring(Ue).trimStart()}const me=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*we(ie){let ge=0;for(const pe of ie.matchAll(me))ge!==pe.index&&(yield{isCode:!1,str:ie.substring(ge,pe.index)}),yield{isCode:!0,str:pe[0]},ge=pe.index+pe[0].length;ge!==ie.length&&(yield{isCode:!1,str:ie.substring(ge)})}function Re(ie){return ie&&(ie=ie.replace(me,"")),ie}const ke=/\\\[.*?\\\]/g;function Pe(ie){return Re(ie).replace(ke,"")}e.$2f=String.fromCharCode(r.CharCode.UTF8_BOM);function De(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===r.CharCode.UTF8_BOM)}function $e(ie){return De(ie)?ie.substr(1):ie}function Z(ie,ge){if(!ie||!ge||ie.length<ge.length)return!1;const pe=ge.length,ye=ie.toLowerCase();let We=0,Ue=-1;for(;We<pe;){const Ze=ye.indexOf(ge[We],Ue+1);if(Ze<0)return!1;Ue=Ze,We++}return!0}function ce(ie,ge=!1){return ie?(ge&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}function fe(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}function be(ie,ge=1){if(ge===0)return"";let pe=-1;do pe=ie.indexOf(`
`,pe+1),ge--;while(ge>0&&pe>=0);return pe===-1?ie:(ie[pe-1]==="\r"&&pe--,ie.substr(0,pe))}function Ae(ie){const ge=r.CharCode.Z-r.CharCode.A+1;return ie=ie%(2*ge),ie<ge?String.fromCharCode(r.CharCode.a+ie):String.fromCharCode(r.CharCode.A+ie-ge)}function Ce(ie){return Be.getInstance().getGraphemeBreakType(ie)}function Me(ie,ge){return ie===Oe.Other?ge!==Oe.Extend&&ge!==Oe.SpacingMark:ie===Oe.CR&&ge===Oe.LF?!1:ie===Oe.Control||ie===Oe.CR||ie===Oe.LF||ge===Oe.Control||ge===Oe.CR||ge===Oe.LF?!0:!(ie===Oe.L&&(ge===Oe.L||ge===Oe.V||ge===Oe.LV||ge===Oe.LVT)||(ie===Oe.LV||ie===Oe.V)&&(ge===Oe.V||ge===Oe.T)||(ie===Oe.LVT||ie===Oe.T)&&ge===Oe.T||ge===Oe.Extend||ge===Oe.ZWJ||ge===Oe.SpacingMark||ie===Oe.Prepend||ie===Oe.ZWJ&&ge===Oe.Extended_Pictographic||ie===Oe.Regional_Indicator&&ge===Oe.Regional_Indicator)}var Oe;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(Oe||(e.GraphemeBreakType=Oe={}));class Be{static{this.c=null}static getInstance(){return Be.c||(Be.c=new Be),Be.c}constructor(){this.d=Ge()}getGraphemeBreakType(ge){if(ge<32)return ge===r.CharCode.LineFeed?Oe.LF:ge===r.CharCode.CarriageReturn?Oe.CR:Oe.Control;if(ge<127)return Oe.Other;const pe=this.d,ye=pe.length/3;let We=1;for(;We<=ye;)if(ge<pe[3*We])We=2*We;else if(ge>pe[3*We+1])We=2*We+1;else return pe[3*We+2];return Oe.Other}}function Ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Qe(ie,ge){if(ie===0)return 0;const pe=qe(ie,ge);if(pe!==void 0)return pe;const ye=new V(ge,ie);return ye.prevCodePoint(),ye.offset}function qe(ie,ge){const pe=new V(ge,ie);let ye=pe.prevCodePoint();for(;Je(ye)||ye===Xe.emojiVariantSelector||ye===Xe.enclosingKeyCap;){if(pe.offset===0)return;ye=pe.prevCodePoint()}if(!ne(ye))return;let We=pe.offset;return We>0&&pe.prevCodePoint()===Xe.zwj&&(We=pe.offset),We}function Je(ie){return 127995<=ie&&ie<=127999}var Xe;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(Xe||(Xe={})),e.$_f="\xA0";class Ye{static{this.c=new E.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new n.$9e({getCacheKey:JSON.stringify},ge=>{function pe(tt){const ut=new Map;for(let ct=0;ct<tt.length;ct+=2)ut.set(tt[ct],tt[ct+1]);return ut}function ye(tt,ut){const ct=new Map(tt);for(const[ft,gt]of ut)ct.set(ft,gt);return ct}function We(tt,ut){if(!tt)return ut;const ct=new Map;for(const[ft,gt]of tt)ut.has(ft)&&ct.set(ft,gt);return ct}const Ue=this.c.value;let Ze=ge.filter(tt=>!tt.startsWith("_")&&tt in Ue);Ze.length===0&&(Ze=["_default"]);let lt;for(const tt of Ze){const ut=pe(Ue[tt]);lt=We(lt,ut)}const rt=pe(Ue._common),at=ye(rt,lt);return new Ye(at)})}static getInstance(ge){return Ye.d.get(Array.from(ge))}static{this.e=new E.$T(()=>Object.keys(Ye.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return Ye.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}containsAmbiguousCharacter(ge){for(let pe=0;pe<ge.length;pe++){const ye=ge.codePointAt(pe);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$ag=Ye;class Ne{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ne.c())),this.d}static isInvisibleCharacter(ge){return Ne.e().has(ge)}static containsInvisibleCharacter(ge){for(let pe=0;pe<ge.length;pe++){const ye=ge.codePointAt(pe);if(typeof ye=="number"&&Ne.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return Ne.e()}}e.$bg=Ne}),define(le[32],ue([0,1,39,9,3,25,12]),function(Y,e,n,r,E,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ug=I,e.$vg=p,e.$wg=a,e.$xg=g,e.$yg=h,e.$zg=d,e.$Ag=v,e.$Bg=b,e.$Cg=$,e.$Dg=P,e.$Eg=S,e.$Fg=t,e.$Gg=u,e.$Hg=i,e.$Ig=o,e.$Jg=s,e.$Kg=k;function I(y){return y===n.CharCode.Slash||y===n.CharCode.Backslash}function p(y){return y.replace(/[\\/]/g,r.$fc.sep)}function a(y){return y.indexOf("/")===-1&&(y=p(y)),/^[a-zA-Z]:(\/|$)/.test(y)&&(y="/"+y),y}function g(y,R=r.$fc.sep){if(!y)return"";const L=y.length,A=y.charCodeAt(0);if(I(A)){if(I(y.charCodeAt(1))&&!I(y.charCodeAt(2))){let W=3;const x=W;for(;W<L&&!I(y.charCodeAt(W));W++);if(x!==W&&!I(y.charCodeAt(W+1))){for(W+=1;W<L;W++)if(I(y.charCodeAt(W)))return y.slice(0,W+1).replace(/[\\/]/g,R)}}return R}else if($(A)&&y.charCodeAt(1)===n.CharCode.Colon)return I(y.charCodeAt(2))?y.slice(0,2)+R:y.slice(0,2);let O=y.indexOf("://");if(O!==-1){for(O+=3;O<L;O++)if(I(y.charCodeAt(O)))return y.slice(0,O+1)}return""}function h(y){if(!E.$j||!y||y.length<5)return!1;let R=y.charCodeAt(0);if(R!==n.CharCode.Backslash||(R=y.charCodeAt(1),R!==n.CharCode.Backslash))return!1;let L=2;const A=L;for(;L<y.length&&(R=y.charCodeAt(L),R!==n.CharCode.Backslash);L++);return!(A===L||(R=y.charCodeAt(L+1),isNaN(R)||R===n.CharCode.Backslash))}const m=/[\\/:\*\?"<>\|]/g,w=/[/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(y,R=E.$j){const L=R?m:w;return!(!y||y.length===0||/^\s+$/.test(y)||(L.lastIndex=0,L.test(y))||R&&f.test(y)||y==="."||y===".."||R&&y[y.length-1]==="."||R&&y.length!==y.trim().length||y.length>255)}function v(y,R,L){const A=y===R;return!L||A?A:!y||!R?!1:(0,D.$Df)(y,R)}function b(y,R,L,A=r.sep){if(y===R)return!0;if(!y||!R||R.length>y.length)return!1;if(L){if(!(0,D.$Ef)(y,R))return!1;if(R.length===y.length)return!0;let W=R.length;return R.charAt(R.length-1)===A&&W--,y.charAt(W)===A}return R.charAt(R.length-1)!==A&&(R+=A),y.indexOf(R)===0}function $(y){return y>=n.CharCode.A&&y<=n.CharCode.Z||y>=n.CharCode.a&&y<=n.CharCode.z}function P(y,R){return E.$j&&y.endsWith(":")&&(y+=r.sep),(0,r.$hc)(y)||(y=(0,r.$ic)(R,y)),y=(0,r.$gc)(y),S(y)}function S(y){return E.$j?(y=(0,D.$lf)(y,r.sep),y.endsWith(":")&&(y+=r.sep)):(y=(0,D.$lf)(y,r.sep),y||(y=r.sep)),y}function t(y){const R=(0,r.$gc)(y);return E.$j?y.length>3?!1:u(R)&&(y.length===2||R.charCodeAt(2)===n.CharCode.Backslash):R===r.$fc.sep}function u(y,R=E.$j){return R?$(y.charCodeAt(0))&&y.charCodeAt(1)===n.CharCode.Colon:!1}function i(y,R=E.$j){return u(y,R)?y[0]:void 0}function o(y,R,L){return R.length>y.length?-1:y===R?0:(L&&(y=y.toLowerCase(),R=R.toLowerCase()),y.indexOf(R))}function s(y){const R=y.split(":");let L,A,O;for(const W of R){const x=Number(W);(0,T.$gg)(x)?A===void 0?A=x:O===void 0&&(O=x):L=L?[L,W].join(":"):W}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:A!==void 0?A:void 0,column:O!==void 0?O:A!==void 0?1:void 0}}const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",l="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function k(y,R,L=8){let A="";for(let W=0;W<L;W++){let x;W===0&&E.$j&&!R&&(L===3||L===4)?x=l:x=c,A+=x.charAt(Math.floor(Math.random()*x.length))}let O;return R?O=`${R}-${A}`:O=A,y?(0,r.$ic)(y,O):O}}),define(le[46],ue([0,1,25]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$uj=void 0,e.$qj=r,e.$rj=E,e.$sj=D,e.$tj=I,e.$vj=d,n=Ie(n);function r(b){return E(b,0)}function E(b,$){switch(typeof b){case"object":return b===null?D(349,$):Array.isArray(b)?p(b,$):a(b,$);case"string":return I(b,$);case"boolean":return T(b,$);case"number":return D(b,$);case"undefined":return D(937,$);default:return D(617,$)}}function D(b,$){return($<<5)-$+b|0}function T(b,$){return D(b?433:863,$)}function I(b,$){$=D(149417,$);for(let P=0,S=b.length;P<S;P++)$=D(b.charCodeAt(P),$);return $}function p(b,$){return $=D(104579,$),b.reduce((P,S)=>E(S,P),$)}function a(b,$){return $=D(181387,$),Object.keys(b).sort().reduce((P,S)=>(P=I(S,P),E(b[S],P)),$)}class g{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=E($,this.g),this.g}}e.$uj=g;var h;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(h||(h={}));function m(b,$,P=32){const S=P-$,t=~((1<<S)-1);return(b<<$|(t&b)>>>S)>>>0}function w(b,$=0,P=b.byteLength,S=0){for(let t=0;t<P;t++)b[$+t]=S}function f(b,$,P="0"){for(;b.length<$;)b=P+b;return b}function d(b,$=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(P=>P.toString(16).padStart(2,"0")).join(""):f((b>>>0).toString(16),$/4)}class v{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(h.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const P=$.length;if(P===0)return;const S=this.p;let t=this.r,u=this.u,i,o;for(u!==0?(i=u,o=-1,u=0):(i=$.charCodeAt(0),o=0);;){let s=i;if(n.$Hf(i))if(o+1<P){const c=$.charCodeAt(o+1);n.$If(c)?(o++,s=n.$Jf(i,c)):s=h.UNICODE_REPLACEMENT}else{u=i;break}else n.$If(i)&&(s=h.UNICODE_REPLACEMENT);if(t=this.w(S,t,s),o++,o<P)i=$.charCodeAt(o);else break}this.r=t,this.u=u}w($,P,S){return S<128?$[P++]=S:S<2048?($[P++]=192|(S&1984)>>>6,$[P++]=128|(S&63)>>>0):S<65536?($[P++]=224|(S&61440)>>>12,$[P++]=128|(S&4032)>>>6,$[P++]=128|(S&63)>>>0):($[P++]=240|(S&1835008)>>>18,$[P++]=128|(S&258048)>>>12,$[P++]=128|(S&4032)>>>6,$[P++]=128|(S&63)>>>0),P>=h.BLOCK_SIZE&&(this.y(),P-=h.BLOCK_SIZE,this.t+=h.BLOCK_SIZE,$[0]=$[h.BLOCK_SIZE+0],$[1]=$[h.BLOCK_SIZE+1],$[2]=$[h.BLOCK_SIZE+2]),P}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,h.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),d(this.h)+d(this.l)+d(this.m)+d(this.n)+d(this.o)}x(){this.p[this.r++]=128,w(this.p,this.r),this.r>56&&(this.y(),w(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=v.g,P=this.q;for(let k=0;k<64;k+=4)$.setUint32(k,P.getUint32(k,!1),!1);for(let k=64;k<320;k+=4)$.setUint32(k,m($.getUint32(k-12,!1)^$.getUint32(k-32,!1)^$.getUint32(k-56,!1)^$.getUint32(k-64,!1),1),!1);let S=this.h,t=this.l,u=this.m,i=this.n,o=this.o,s,c,l;for(let k=0;k<80;k++)k<20?(s=t&u|~t&i,c=1518500249):k<40?(s=t^u^i,c=1859775393):k<60?(s=t&u|t&i|u&i,c=2400959708):(s=t^u^i,c=3395469782),l=m(S,5)+s+o+c+$.getUint32(k*4,!1)&4294967295,o=i,i=u,u=m(t,30),t=S,S=l;this.h=this.h+S&4294967295,this.l=this.l+t&4294967295,this.m=this.m+u&4294967295,this.n=this.n+i&4294967295,this.o=this.o+o&4294967295}}e.$wj=v}),define(le[81],ue([0,1,25]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),n=Ie(n);var r;(function(E){E[E.Ignore=0]="Ignore",E[E.Info=1]="Info",E[E.Warning=2]="Warning",E[E.Error=3]="Error"})(r||(r={})),function(E){const D="error",T="warning",I="warn",p="info",a="ignore";function g(m){return m?n.$Df(D,m)?E.Error:n.$Df(T,m)||n.$Df(I,m)?E.Warning:n.$Df(p,m)?E.Info:E.Ignore:E.Ignore}E.fromValue=g;function h(m){switch(m){case E.Error:return D;case E.Warning:return T;case E.Info:return p;default:return a}}E.toString=h}(r||(r={})),e.default=r}),define(le[60],ue([0,1,20,39,25]),function(Y,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=void 0;class D{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const d=f.charCodeAt(0),v=this.b.charCodeAt(this.c);return d-v}value(){return this.b[this.c]}}e.$Ei=D;class T{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===r.CharCode.Period)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,E.$xf)(f,this.b,0,f.length,this.c,this.d):(0,E.$zf)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Fi=T;class I{constructor(f=!0,d=!0){this.f=f,this.g=d}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let d=f.length-1;d>=0;d--,this.c--){const v=this.b.charCodeAt(d);if(!(v===r.CharCode.Slash||this.f&&v===r.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===r.CharCode.Slash||this.f&&d===r.CharCode.Backslash)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,E.$xf)(f,this.b,0,f.length,this.d,this.e):(0,E.$zf)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Gi=I;var p;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(p||(p={}));class a{constructor(f,d){this.f=f,this.g=d,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(p.Scheme),this.c.authority&&this.d.push(p.Authority),this.c.path&&(this.b=new I(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(p.Path)),this.g(f)||(this.c.query&&this.d.push(p.Query),this.c.fragment&&this.d.push(p.Fragment)),this.e=0,this}next(){return this.d[this.e]===p.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===p.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===p.Scheme)return(0,E.$yf)(f,this.c.scheme);if(this.d[this.e]===p.Authority)return(0,E.$yf)(f,this.c.authority);if(this.d[this.e]===p.Path)return this.b.cmp(f);if(this.d[this.e]===p.Query)return(0,E.$wf)(f,this.c.query);if(this.d[this.e]===p.Fragment)return(0,E.$wf)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===p.Scheme)return this.c.scheme;if(this.d[this.e]===p.Authority)return this.c.authority;if(this.d[this.e]===p.Path)return this.b.value();if(this.d[this.e]===p.Query)return this.c.query;if(this.d[this.e]===p.Fragment)return this.c.fragment;throw new Error}}e.$Hi=a;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var h;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(h||(h={}));class m{static forUris(f=()=>!1,d=()=>!1){return new m(new a(f,d))}static forPaths(f=!1){return new m(new I(void 0,!f))}static forStrings(){return new m(new D)}static forConfigKeys(){return new m(new T)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,d){if(d){const v=d.slice(0);(0,n.$Vb)(v);for(const b of v)this.set(b,f)}else{const v=f.slice(0);(0,n.$Vb)(v);for(const b of v)this.set(b[0],b[1])}}set(f,d){const v=this.b.reset(f);let b;this.c||(this.c=new g,this.c.segment=v.value());const $=[];for(b=this.c;;){const S=v.cmp(b.segment);if(S>0)b.left||(b.left=new g,b.left.segment=v.value()),$.push([h.Left,b]),b=b.left;else if(S<0)b.right||(b.right=new g,b.right.segment=v.value()),$.push([h.Right,b]),b=b.right;else if(v.hasNext())v.next(),b.mid||(b.mid=new g,b.mid.segment=v.value()),$.push([h.Mid,b]),b=b.mid;else break}const P=b.value;b.value=d,b.key=f;for(let S=$.length-1;S>=0;S--){const t=$[S][1];t.updateHeight();const u=t.balanceFactor();if(u<-1||u>1){const i=$[S][0],o=$[S+1][0];if(i===h.Right&&o===h.Right)$[S][1]=t.rotateLeft();else if(i===h.Left&&o===h.Left)$[S][1]=t.rotateRight();else if(i===h.Right&&o===h.Left)t.right=$[S+1][1]=$[S+1][1].rotateRight(),$[S][1]=t.rotateLeft();else if(i===h.Left&&o===h.Right)t.left=$[S+1][1]=$[S+1][1].rotateLeft(),$[S][1]=t.rotateRight();else throw new Error;if(S>0)switch($[S-1][0]){case h.Left:$[S-1][1].left=$[S][1];break;case h.Right:$[S-1][1].right=$[S][1];break;case h.Mid:$[S-1][1].mid=$[S][1];break}else this.c=$[0][1]}}return P}get(f){return this.d(f)?.value}d(f){const d=this.b.reset(f);let v=this.c;for(;v;){const b=d.cmp(v.segment);if(b>0)v=v.left;else if(b<0)v=v.right;else if(d.hasNext())d.next(),v=v.mid;else break}return v}has(f){const d=this.d(f);return!(d?.value===void 0&&d?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,d){const v=this.b.reset(f),b=[];let $=this.c;for(;$;){const P=v.cmp($.segment);if(P>0)b.push([h.Left,$]),$=$.left;else if(P<0)b.push([h.Right,$]),$=$.right;else if(v.hasNext())v.next(),b.push([h.Mid,$]),$=$.mid;else break}if($){if(d?($.left=void 0,$.mid=void 0,$.right=void 0,$.height=1):($.key=void 0,$.value=void 0),!$.mid&&!$.value)if($.left&&$.right){const P=this.f($.right);if(P.key){const{key:S,value:t,segment:u}=P;this.e(P.key,!1),$.key=S,$.value=t,$.segment=u}}else{const P=$.left??$.right;if(b.length>0){const[S,t]=b[b.length-1];switch(S){case h.Left:t.left=P;break;case h.Mid:t.mid=P;break;case h.Right:t.right=P;break}}else this.c=P}for(let P=b.length-1;P>=0;P--){const S=b[P][1];S.updateHeight();const t=S.balanceFactor();if(t>1?(S.right.balanceFactor()>=0||(S.right=S.right.rotateRight()),b[P][1]=S.rotateLeft()):t<-1&&(S.left.balanceFactor()<=0||(S.left=S.left.rotateLeft()),b[P][1]=S.rotateRight()),P>0)switch(b[P-1][0]){case h.Left:b[P-1][1].left=b[P][1];break;case h.Right:b[P-1][1].right=b[P][1];break;case h.Mid:b[P-1][1].mid=b[P][1];break}else this.c=b[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const d=this.b.reset(f);let v=this.c,b;for(;v;){const $=d.cmp(v.segment);if($>0)v=v.left;else if($<0)v=v.right;else if(d.hasNext())d.next(),b=v.value||b,v=v.mid;else break}return v&&v.value||b}findSuperstr(f){return this.g(f,!1)}g(f,d){const v=this.b.reset(f);let b=this.c;for(;b;){const $=v.cmp(b.segment);if($>0)b=b.left;else if($<0)b=b.right;else if(v.hasNext())v.next(),b=b.mid;else return b.mid?this.h(b.mid):d?b.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[d,v]of this)f(v,d)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const d=[];return this.j(f,d),d[Symbol.iterator]()}j(f,d){f&&(f.left&&this.j(f.left,d),f.value&&d.push([f.key,f.value]),f.mid&&this.j(f.mid,d),f.right&&this.j(f.right,d))}_isBalanced(){const f=d=>{if(!d)return!0;const v=d.balanceFactor();return v<-1||v>1?!1:f(d.left)&&f(d.right)};return f(this.c)}}e.$Ii=m}),define(le[7],ue([0,1,39,90,9,3]),function(Y,e,n,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$uc=v,e.$vc=u,E=Ie(E);const T=/^\w[\w\d+.-]*$/,I=/^\//,p=/^\/\//;function a(l,k){if(!l.scheme&&k)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!T.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!I.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(p.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function g(l,k){return!l&&!k?"file":l}function h(l,k){switch(l){case"https":case"http":case"file":k?k[0]!==w&&(k=w+k):k=w;break}return k}const m="",w="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(k){return k instanceof d?!0:k?typeof k.authority=="string"&&typeof k.fragment=="string"&&typeof k.path=="string"&&typeof k.query=="string"&&typeof k.scheme=="string"&&typeof k.fsPath=="string"&&typeof k.with=="function"&&typeof k.toString=="function":!1}constructor(k,y,R,L,A,O=!1){typeof k=="object"?(this.scheme=k.scheme||m,this.authority=k.authority||m,this.path=k.path||m,this.query=k.query||m,this.fragment=k.fragment||m):(this.scheme=g(k,O),this.authority=y||m,this.path=h(this.scheme,R||m),this.query=L||m,this.fragment=A||m,a(this,O))}get fsPath(){return u(this,!1)}with(k){if(!k)return this;let{scheme:y,authority:R,path:L,query:A,fragment:O}=k;return y===void 0?y=this.scheme:y===null&&(y=m),R===void 0?R=this.authority:R===null&&(R=m),L===void 0?L=this.path:L===null&&(L=m),A===void 0?A=this.query:A===null&&(A=m),O===void 0?O=this.fragment:O===null&&(O=m),y===this.scheme&&R===this.authority&&L===this.path&&A===this.query&&O===this.fragment?this:new $(y,R,L,A,O)}static parse(k,y=!1){const R=f.exec(k);return R?new $(R[2]||m,c(R[4]||m),c(R[5]||m),c(R[7]||m),c(R[9]||m),y):new $(m,m,m,m,m)}static file(k){let y=m;if(D.$j&&(k=k.replace(/\\/g,w)),k[0]===w&&k[1]===w){const R=k.indexOf(w,2);R===-1?(y=k.substring(2),k=w):(y=k.substring(2,R),k=k.substring(R)||w)}return new $("file",y,k,m,m)}static from(k,y){return new $(k.scheme,k.authority,k.path,k.query,k.fragment,y)}static joinPath(k,...y){if(!k.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let R;return D.$j&&k.scheme==="file"?R=d.file(E.$ec.join(u(k,!0),...y)).path:R=E.$fc.join(k.path,...y),k.with({path:R})}toString(k=!1){return i(this,k)}toJSON(){return this}static revive(k){if(k){if(k instanceof d)return k;{const y=new $(k);return y._formatted=k.external??null,y._fsPath=k._sep===b?k.fsPath??null:null,y}}else return k}}e.URI=d;function v(l){return!l||typeof l!="object"?!1:typeof l.scheme=="string"&&(typeof l.authority=="string"||typeof l.authority>"u")&&(typeof l.path=="string"||typeof l.path>"u")&&(typeof l.query=="string"||typeof l.query>"u")&&(typeof l.fragment=="string"||typeof l.fragment>"u")}const b=D.$j?1:void 0;class $ extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(k=!1){return k?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const k={$mid:r.MarshalledId.Uri};return this._fsPath&&(k.fsPath=this._fsPath,k._sep=b),this._formatted&&(k.external=this._formatted),this.path&&(k.path=this.path),this.scheme&&(k.scheme=this.scheme),this.authority&&(k.authority=this.authority),this.query&&(k.query=this.query),this.fragment&&(k.fragment=this.fragment),k}}const P={[n.CharCode.Colon]:"%3A",[n.CharCode.Slash]:"%2F",[n.CharCode.QuestionMark]:"%3F",[n.CharCode.Hash]:"%23",[n.CharCode.OpenSquareBracket]:"%5B",[n.CharCode.CloseSquareBracket]:"%5D",[n.CharCode.AtSign]:"%40",[n.CharCode.ExclamationMark]:"%21",[n.CharCode.DollarSign]:"%24",[n.CharCode.Ampersand]:"%26",[n.CharCode.SingleQuote]:"%27",[n.CharCode.OpenParen]:"%28",[n.CharCode.CloseParen]:"%29",[n.CharCode.Asterisk]:"%2A",[n.CharCode.Plus]:"%2B",[n.CharCode.Comma]:"%2C",[n.CharCode.Semicolon]:"%3B",[n.CharCode.Equals]:"%3D",[n.CharCode.Space]:"%20"};function S(l,k,y){let R,L=-1;for(let A=0;A<l.length;A++){const O=l.charCodeAt(A);if(O>=n.CharCode.a&&O<=n.CharCode.z||O>=n.CharCode.A&&O<=n.CharCode.Z||O>=n.CharCode.Digit0&&O<=n.CharCode.Digit9||O===n.CharCode.Dash||O===n.CharCode.Period||O===n.CharCode.Underline||O===n.CharCode.Tilde||k&&O===n.CharCode.Slash||y&&O===n.CharCode.OpenSquareBracket||y&&O===n.CharCode.CloseSquareBracket||y&&O===n.CharCode.Colon)L!==-1&&(R+=encodeURIComponent(l.substring(L,A)),L=-1),R!==void 0&&(R+=l.charAt(A));else{R===void 0&&(R=l.substr(0,A));const W=P[O];W!==void 0?(L!==-1&&(R+=encodeURIComponent(l.substring(L,A)),L=-1),R+=W):L===-1&&(L=A)}}return L!==-1&&(R+=encodeURIComponent(l.substring(L))),R!==void 0?R:l}function t(l){let k;for(let y=0;y<l.length;y++){const R=l.charCodeAt(y);R===n.CharCode.Hash||R===n.CharCode.QuestionMark?(k===void 0&&(k=l.substr(0,y)),k+=P[R]):k!==void 0&&(k+=l[y])}return k!==void 0?k:l}function u(l,k){let y;return l.authority&&l.path.length>1&&l.scheme==="file"?y=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===n.CharCode.Slash&&(l.path.charCodeAt(1)>=n.CharCode.A&&l.path.charCodeAt(1)<=n.CharCode.Z||l.path.charCodeAt(1)>=n.CharCode.a&&l.path.charCodeAt(1)<=n.CharCode.z)&&l.path.charCodeAt(2)===n.CharCode.Colon?k?y=l.path.substr(1):y=l.path[1].toLowerCase()+l.path.substr(2):y=l.path,D.$j&&(y=y.replace(/\//g,"\\")),y}function i(l,k){const y=k?t:S;let R="",{scheme:L,authority:A,path:O,query:W,fragment:x}=l;if(L&&(R+=L,R+=":"),(A||L==="file")&&(R+=w,R+=w),A){let C=A.indexOf("@");if(C!==-1){const B=A.substr(0,C);A=A.substr(C+1),C=B.lastIndexOf(":"),C===-1?R+=y(B,!1,!1):(R+=y(B.substr(0,C),!1,!1),R+=":",R+=y(B.substr(C+1),!1,!0)),R+="@"}A=A.toLowerCase(),C=A.lastIndexOf(":"),C===-1?R+=y(A,!1,!0):(R+=y(A.substr(0,C),!1,!0),R+=A.substr(C))}if(O){if(O.length>=3&&O.charCodeAt(0)===n.CharCode.Slash&&O.charCodeAt(2)===n.CharCode.Colon){const C=O.charCodeAt(1);C>=n.CharCode.A&&C<=n.CharCode.Z&&(O=`/${String.fromCharCode(C+32)}:${O.substr(3)}`)}else if(O.length>=2&&O.charCodeAt(1)===n.CharCode.Colon){const C=O.charCodeAt(0);C>=n.CharCode.A&&C<=n.CharCode.Z&&(O=`${String.fromCharCode(C+32)}:${O.substr(2)}`)}R+=y(O,!0,!1)}return W&&(R+="?",R+=y(W,!1,!1)),x&&(R+="#",R+=k?x:S(x,!1,!1)),R}function o(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+o(l.substr(3)):l}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(l){return l.match(s)?l.replace(s,k=>o(k)):l}}),define(le[148],ue([0,1,7]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=r,e.$ar=E,e.$br=D,e.log=I;function r(a){const g=a;return g&&typeof g.type=="string"&&typeof g.severity=="string"}function E(a){const g=[];let h;try{const m=JSON.parse(a.arguments),w=m[m.length-1];w&&w.__$stack&&(m.pop(),h=w.__$stack),g.push(...m)}catch{g.push("Unable to log remote console arguments",a.arguments)}return{args:g,stack:h}}function D(a){if(typeof a!="string")return D(E(a).stack);const g=a;if(g){const h=T(g),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(h||"");if(m&&m.length===4)return{uri:n.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}function T(a){if(!a)return a;const g=a.indexOf(`
`);return g===-1?a:a.substring(0,g)}function I(a,g){const{args:h,stack:m}=E(a),w=typeof h[0]=="string"&&h.length===1;let f=T(m);f&&(f=`(${f.trim()})`);let d=[];if(typeof h[0]=="string"?f&&w?d=[`%c[${g}] %c${h[0]} %c${f}`,p("blue"),p(""),p("grey")]:d=[`%c[${g}] %c${h[0]}`,p("blue"),p(""),...h.slice(1)]:d=[`%c[${g}]%`,p("blue"),...h],f&&!w&&d.push(f),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,d)}function p(a){return`color: ${a}`}}),define(le[82],ue([0,1,16,7,90]),function(Y,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=D,e.$$h=T,e.$_h=p;function D(a){return JSON.stringify(a,I)}function T(a){let g=JSON.parse(a);return g=p(g),g}function I(a,g){return g instanceof RegExp?{$mid:E.MarshalledId.Regexp,source:g.source,flags:g.flags}:g}function p(a,g=0){if(!a||g>200)return a;if(typeof a=="object"){switch(a.$mid){case E.MarshalledId.Uri:return r.URI.revive(a);case E.MarshalledId.Regexp:return new RegExp(a.source,a.flags);case E.MarshalledId.Date:return new Date(a.source)}if(a instanceof n.$Le||a instanceof Uint8Array)return a;if(Array.isArray(a))for(let h=0;h<a.length;++h)a[h]=p(a[h],g+1);else for(const h in a)Object.hasOwnProperty.call(a,h)&&(a[h]=p(a[h],g+1))}return a}}),define(le[11],ue([0,1,15,3,25,7,9]),function(Y,e,n,r,E,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Pg=e.$Og=e.$Ng=e.Schemas=void 0,e.$Lg=p,e.$Mg=a,e.$Qg=h,n=Ie(n),r=Ie(r),T=Ie(T);var I;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatCodeBlock="vscode-chat-code-block",f.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",f.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm",f.commentsInput="comment",f.codeSetting="code-setting"})(I||(e.Schemas=I={}));function p(f,d){return D.URI.isUri(f)?(0,E.$Df)(f.scheme,d):(0,E.$Ef)(f,d+":")}function a(f,...d){return d.some(v=>p(f,v))}e.$Ng="vscode-tkn",e.$Og="tkn";class g{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(d){this.d=d}setDelegate(d){this.e=d}setServerRootPath(d,v){this.f=h(d,v)}getServerRootPath(){return this.f}get g(){return T.$fc.join(this.f,I.vscodeRemoteResource)}set(d,v,b){this.a[d]=v,this.b[d]=b}setConnectionToken(d,v){this.c[d]=v}getPreferredWebSchema(){return this.d}rewrite(d){if(this.e)try{return this.e(d)}catch(t){return n.$Y(t),d}const v=d.authority;let b=this.a[v];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const $=this.b[v],P=this.c[v];let S=`path=${encodeURIComponent(d.path)}`;return typeof P=="string"&&(S+=`&${e.$Og}=${encodeURIComponent(P)}`),D.URI.from({scheme:r.$p?this.d:I.vscodeRemoteResource,authority:`${b}:${$}`,path:this.g,query:S})}}e.$Pg=new g;function h(f,d){return T.$fc.join(d??"/",`${f.quality??"oss"}-${f.commit??"dev"}`)}e.$Rg="vs/../../extensions",e.$Sg="vs/../../node_modules",e.$Tg="vs/../../node_modules.asar",e.$Ug="vs/../../node_modules.asar.unpacked",e.$Vg="vscode-app";class m{static{this.a=e.$Vg}asBrowserUri(d){const v=this.b(d,Y);return this.uriToBrowserUri(v)}uriToBrowserUri(d){return d.scheme===I.vscodeRemote?e.$Pg.rewrite(d):d.scheme===I.file&&(r.$n||r.$r===`${I.vscodeFileResource}://${m.a}`)?d.with({scheme:I.vscodeFileResource,authority:d.authority||m.a,query:null,fragment:null}):d}asFileUri(d){const v=this.b(d,Y);return this.uriToFileUri(v)}uriToFileUri(d){return d.scheme===I.vscodeFileResource?d.with({scheme:I.file,authority:d.authority!==m.a?d.authority:null,query:null,fragment:null}):d}b(d,v){return D.URI.isUri(d)?d:D.URI.parse(v.toUrl(d))}}e.$Wg=new m;var w;(function(f){const d=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(d.get("3"));const v="vscode-coi";function b(P){let S;typeof P=="string"?S=new URL(P).searchParams:P instanceof URL?S=P.searchParams:D.URI.isUri(P)&&(S=new URL(P.toString(!0)).searchParams);const t=S?.get(v);if(t)return d.get(t)}f.getHeadersFromQuery=b;function $(P,S,t){if(!globalThis.crossOriginIsolated)return;const u=S&&t?"3":t?"2":"1";P instanceof URLSearchParams?P.set(v,u):P[v]=u}f.addSearchParam=$})(w||(e.COI=w={}))}),define(le[18],ue([0,1,39,32,11,9,3,25,7]),function(Y,e,n,r,E,D,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=void 0,e.$4g=a,e.$mh=h,e.$nh=w,r=Ie(r),D=Ie(D);function a(f){return(0,p.$vc)(f,!0)}class g{constructor(d){this.a=d}compare(d,v,b=!1){return d===v?0:(0,I.$wf)(this.getComparisonKey(d,b),this.getComparisonKey(v,b))}isEqual(d,v,b=!1){return d===v?!0:!d||!v?!1:this.getComparisonKey(d,b)===this.getComparisonKey(v,b)}getComparisonKey(d,v=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,v,b=!1){if(d.scheme===v.scheme){if(d.scheme===E.Schemas.file)return r.$Bg(a(d),a(v),this.a(d))&&d.query===v.query&&(b||d.fragment===v.fragment);if((0,e.$ih)(d.authority,v.authority))return r.$Bg(d.path,v.path,this.a(d),"/")&&d.query===v.query&&(b||d.fragment===v.fragment)}return!1}joinPath(d,...v){return p.URI.joinPath(d,...v)}basenameOrAuthority(d){return(0,e.$ah)(d)||d.authority}basename(d){return D.$fc.basename(d.path)}extname(d){return D.$fc.extname(d.path)}dirname(d){if(d.path.length===0)return d;let v;return d.scheme===E.Schemas.file?v=p.URI.file(D.$lc(a(d))).path:(v=D.$fc.dirname(d.path),d.authority&&v.length&&v.charCodeAt(0)!==n.CharCode.Slash&&(console.error(`dirname("${d.toString})) resulted in a relative path`),v="/")),d.with({path:v})}normalizePath(d){if(!d.path.length)return d;let v;return d.scheme===E.Schemas.file?v=p.URI.file(D.$gc(a(d))).path:v=D.$fc.normalize(d.path),d.with({path:v})}relativePath(d,v){if(d.scheme!==v.scheme||!(0,e.$ih)(d.authority,v.authority))return;if(d.scheme===E.Schemas.file){const P=D.$kc(a(d),a(v));return T.$j?r.$vg(P):P}let b=d.path||"/";const $=v.path||"/";if(this.a(d)){let P=0;for(const S=Math.min(b.length,$.length);P<S&&!(b.charCodeAt(P)!==$.charCodeAt(P)&&b.charAt(P).toLowerCase()!==$.charAt(P).toLowerCase());P++);b=$.substr(0,P)+b.substr(P)}return D.$fc.relative(b,$)}resolvePath(d,v){if(d.scheme===E.Schemas.file){const b=p.URI.file(D.$jc(a(d),v));return d.with({authority:b.authority,path:b.path})}return v=r.$wg(v),d.with({path:D.$fc.resolve(d.path,v)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,v){return d===v||d!==void 0&&v!==void 0&&(0,I.$Df)(d,v)}hasTrailingPathSeparator(d,v=D.sep){if(d.scheme===E.Schemas.file){const b=a(d);return b.length>r.$xg(b).length&&b[b.length-1]===v}else{const b=d.path;return b.length>1&&b.charCodeAt(b.length-1)===n.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,v=D.sep){return(0,e.$jh)(d,v)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,v=D.sep){let b=!1;if(d.scheme===E.Schemas.file){const $=a(d);b=$!==void 0&&$.length===r.$xg($).length&&$[$.length-1]===v}else{v="/";const $=d.path;b=$.length===1&&$.charCodeAt($.length-1)===n.CharCode.Slash}return!b&&!(0,e.$jh)(d,v)?d.with({path:d.path+"/"}):d}}e.$5g=g,e.$6g=new g(()=>!1),e.$7g=new g(f=>f.scheme===E.Schemas.file?!T.$l:!0),e.$8g=new g(f=>!0),e.$9g=e.$6g.isEqual.bind(e.$6g),e.$0g=e.$6g.isEqualOrParent.bind(e.$6g),e.$$g=e.$6g.getComparisonKey.bind(e.$6g),e.$_g=e.$6g.basenameOrAuthority.bind(e.$6g),e.$ah=e.$6g.basename.bind(e.$6g),e.$bh=e.$6g.extname.bind(e.$6g),e.$ch=e.$6g.dirname.bind(e.$6g),e.$dh=e.$6g.joinPath.bind(e.$6g),e.$eh=e.$6g.normalizePath.bind(e.$6g),e.$fh=e.$6g.relativePath.bind(e.$6g),e.$gh=e.$6g.resolvePath.bind(e.$6g),e.$hh=e.$6g.isAbsolutePath.bind(e.$6g),e.$ih=e.$6g.isEqualAuthority.bind(e.$6g),e.$jh=e.$6g.hasTrailingPathSeparator.bind(e.$6g),e.$kh=e.$6g.removeTrailingPathSeparator.bind(e.$6g),e.$lh=e.$6g.addTrailingPathSeparator.bind(e.$6g);function h(f,d){const v=[];for(let b=0;b<f.length;b++){const $=d(f[b]);f.some((P,S)=>S===b?!1:(0,e.$0g)($,d(P)))||v.push(f[b])}return v}var m;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function d(v){const b=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(S=>{const[t,u]=S.split(":");t&&u&&b.set(t,u)});const P=v.path.substring(0,v.path.indexOf(";"));return P&&b.set(f.META_DATA_MIME,P),b}f.parseMetaData=d})(m||(e.DataUri=m={}));function w(f,d,v){if(d){let b=f.path;return b&&b[0]!==D.$fc.sep&&(b=D.$fc.sep+b),f.with({scheme:v,authority:d,path:b})}return f.with({scheme:v})}}),define(le[8],ue([0,1,21,15,4,2,18,3,145,65]),function(Y,e,n,r,E,D,T,I,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$4h=e.$3h=e.$2h=e.$1h=e.Promises=e.$Zh=e.$Yh=e.$Xh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=void 0,e.$oh=g,e.$ph=h,e.$qh=m,e.$rh=w,e.$sh=f,e.$th=d,e.$uh=v,e.$vh=b,e.$Dh=l,e.$Eh=k,e.$Fh=y,e.$Gh=R,e.$Hh=L,e.$Wh=j,e.$5h=q;function g(J){return!!J&&typeof J.then=="function"}function h(J){const H=new n.$ue,ne=J(H.token),de=new Promise((me,we)=>{const Re=H.token.onCancellationRequested(()=>{Re.dispose(),we(new r.$4)});Promise.resolve(ne).then(ke=>{Re.dispose(),H.dispose(),me(ke)},ke=>{Re.dispose(),H.dispose(),we(ke)})});return new class{cancel(){H.cancel(),H.dispose()}then(me,we){return de.then(me,we)}catch(me){return this.then(void 0,me)}finally(me){return de.finally(me)}}}function m(J,H,ne){return new Promise((de,me)=>{const we=H.onCancellationRequested(()=>{we.dispose(),de(ne)});J.then(de,me).finally(()=>we.dispose())})}function w(J,H){return new Promise((ne,de)=>{const me=H.onCancellationRequested(()=>{me.dispose(),de(new r.$4)});J.then(ne,de).finally(()=>me.dispose())})}async function f(J){let H=-1;const ne=J.map((de,me)=>de.then(we=>(H=me,we)));try{return await Promise.race(ne)}finally{J.forEach((de,me)=>{me!==H&&de.cancel()})}}function d(J,H,ne){let de;const me=setTimeout(()=>{de?.(void 0),ne?.()},H);return Promise.race([J.finally(()=>clearTimeout(me)),new Promise(we=>de=we)])}function v(J){return new Promise((H,ne)=>{const de=J();g(de)?de.then(H,ne):H(de)})}function b(){let J,H;return{promise:new Promise((de,me)=>{J=de,H=me}),resolve:J,reject:H}}class ${constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(H){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=H,!this.b){const ne=()=>{if(this.b=null,this.f)return;const de=this.queue(this.d);return this.d=null,de};this.b=new Promise(de=>{this.a.then(ne,ne).then(de)})}return new Promise((ne,de)=>{this.b.then(ne,de)})}return this.a=H(),new Promise((ne,de)=>{this.a.then(me=>{this.a=null,ne(me)},me=>{this.a=null,de(me)})})}dispose(){this.f=!0}}e.$wh=$;class P{constructor(){this.a=Promise.resolve(null)}queue(H){return this.a=this.a.then(()=>H(),()=>H())}}e.$xh=P;class S{constructor(){this.a=new Map}queue(H,ne){const me=(this.a.get(H)??Promise.resolve()).catch(()=>{}).then(ne).finally(()=>{this.a.get(H)===me&&this.a.delete(H)});return this.a.set(H,me),me}}e.$yh=S;const t=(J,H)=>{let ne=!0;const de=setTimeout(()=>{ne=!1,H()},J);return{isTriggered:()=>ne,dispose:()=>{clearTimeout(de),ne=!1}}},u=J=>{let H=!0;return queueMicrotask(()=>{H&&(H=!1,J())}),{isTriggered:()=>H,dispose:()=>{H=!1}}};class i{constructor(H){this.defaultDelay=H,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(H,ne=this.defaultDelay){this.g=H,this.h(),this.b||(this.b=new Promise((me,we)=>{this.d=me,this.f=we}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const de=()=>{this.a=null,this.d?.(null)};return this.a=ne===p.$ee?u(de):t(ne,de),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new r.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$zh=i;class o{constructor(H){this.a=new i(H),this.b=new $}trigger(H,ne){return this.a.trigger(()=>this.b.queue(H),ne)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ah=o;class s{constructor(){this.a=!1,this.b=new Promise((H,ne)=>{this.d=H})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Bh=s;class c extends s{constructor(H){super(),this.f=setTimeout(()=>this.open(),H)}open(){clearTimeout(this.f),super.open()}}e.$Ch=c;function l(J,H){return H?new Promise((ne,de)=>{const me=setTimeout(()=>{we.dispose(),ne()},J),we=H.onCancellationRequested(()=>{clearTimeout(me),we.dispose(),de(new r.$4)})}):h(ne=>l(J,ne))}function k(J,H=0,ne){const de=setTimeout(()=>{J(),ne&&me.dispose()},H),me=(0,D.$Rc)(()=>{clearTimeout(de),ne?.deleteAndLeak(me)});return ne?.add(me),me}function y(J){const H=[];let ne=0;const de=J.length;function me(){return ne<de?J[ne++]():null}function we(Re){Re!=null&&H.push(Re);const ke=me();return ke?ke.then(we):Promise.resolve(H)}return Promise.resolve(null).then(we)}function R(J,H=de=>!!de,ne=null){let de=0;const me=J.length,we=()=>{if(de>=me)return Promise.resolve(ne);const Re=J[de++];return Promise.resolve(Re()).then(Pe=>H(Pe)?Promise.resolve(Pe):we())};return we()}function L(J,H=de=>!!de,ne=null){if(J.length===0)return Promise.resolve(ne);let de=J.length;const me=()=>{de=-1;for(const we of J)we.cancel?.()};return new Promise((we,Re)=>{for(const ke of J)ke.then(Pe=>{--de>=0&&H(Pe)?(me(),we(Pe)):de===0&&we(ne)}).catch(Pe=>{--de>=0&&(me(),Re(Pe))})})}class A{constructor(H){this.a=0,this.b=!1,this.f=H,this.g=[],this.d=0,this.h=new E.$je}whenIdle(){return this.size>0?E.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(H){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ne,de)=>{this.g.push({factory:H,c:ne,e:de}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const H=this.g.shift();this.d++;const ne=H.factory();ne.then(H.c,H.e),ne.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ih=A;class O extends A{constructor(){super(1)}}e.$Jh=O;class W{constructor(){this.a=new N,this.b=0}queue(H){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,H())):this.a.run(this.b++,H())}}e.$Kh=W;class x{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const H=new G;return this.b.add(H),H.p}g(){for(const[,H]of this.a)if(H.size>0)return!1;return!0}queueSize(H,ne=T.$6g){const de=ne.getComparisonKey(H);return this.a.get(de)?.size??0}queueFor(H,ne,de=T.$6g){const me=de.getComparisonKey(H);let we=this.a.get(me);if(!we){we=new O;const Re=this.f++,ke=E.Event.once(we.onDrained)(()=>{we?.dispose(),this.a.delete(me),this.h(),this.d?.deleteAndDispose(Re),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new D.$3c),this.d.set(Re,ke),this.a.set(me,we)}return we.queue(ne)}h(){this.g()&&this.j()}j(){for(const H of this.b)H.complete();this.b.clear()}dispose(){for(const[,H]of this.a)H.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Lh=x;class C{constructor(H,ne){this.b=!1,this.a=-1,typeof H=="function"&&typeof ne=="number"&&this.setIfNotSet(H,ne)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(H,ne){if(this.b)throw new r.$bb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,H()},ne)}setIfNotSet(H,ne){if(this.b)throw new r.$bb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,H()},ne))}}e.$Mh=C;class B{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(H,ne,de=globalThis){if(this.f)throw new r.$bb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const me=de.setInterval(()=>{H()},ne);this.d=(0,D.$Rc)(()=>{de.clearInterval(me),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Nh=B;class ee{constructor(H,ne){this.b=-1,this.a=H,this.d=ne,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(H=this.d){this.cancel(),this.b=setTimeout(this.f,H)}get delay(){return this.d}set delay(H){this.d=H}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Oh=ee;class X{constructor(H,ne){ne%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.a=H,this.b=ne,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(H=this.b){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(H/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Ph=X;class ae extends ee{constructor(H,ne){super(H,ne),this.j=[]}work(H){this.j.push(H),this.isScheduled()||this.schedule()}h(){const H=this.j;this.j=[],this.a?.(H)}dispose(){this.j=[],super.dispose()}}e.$Qh=ae;class K extends D.$Tc{constructor(H,ne){super(),this.g=H,this.h=ne,this.a=[],this.b=this.B(new D.$Uc),this.f=!1}get pending(){return this.a.length}work(H){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+H.length>this.g.maxBufferedWork)return!1}else if(this.pending+H.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ne of H)this.a.push(ne);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ee(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Rh=K,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Th=(J,H)=>{(0,I.$C)(()=>{if(ne)return;const de=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,de-Date.now())}}))});let ne=!1;return{dispose(){ne||(ne=!0)}}}:e.$Th=(J,H,ne)=>{const de=J.requestIdleCallback(H,typeof ne=="number"?{timeout:ne}:void 0);let me=!1;return{dispose(){me||(me=!0,J.cancelIdleCallback(de))}}},e.$Sh=J=>(0,e.$Th)(globalThis,J)}();class te{constructor(H,ne){this.g=!1,this.d=()=>{try{this.j=ne()}catch(de){this.l=de}finally{this.g=!0}},this.f=(0,e.$Th)(H,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Uh=te;class z extends te{constructor(H){super(globalThis,H)}}e.$Vh=z;async function j(J,H,ne){let de;for(let me=0;me<ne;me++)try{return await J()}catch(we){de=we,await l(H)}throw de}class N{isRunning(H){return typeof H=="number"?this.a?.taskId===H:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(H,ne,de){return this.a={taskId:H,cancel:()=>de?.(),promise:ne},ne.then(()=>this.d(H),()=>this.d(H)),ne}d(H){this.a&&H===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const H=this.b;this.b=void 0,H.run().then(H.promiseResolve,H.promiseReject)}}queue(H){if(this.b)this.b.run=H;else{const{promise:ne,resolve:de,reject:me}=b();this.b={run:H,promise:ne,promiseResolve:de,promiseReject:me}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Xh=N;class V{constructor(H,ne=()=>Date.now()){this.d=H,this.f=ne,this.a=0,this.b=0}increment(){const H=this.f();return H-this.a>this.d&&(this.a=H,this.b=0),this.b++,this.b}}e.$Yh=V;var oe;(function(J){J[J.Resolved=0]="Resolved",J[J.Rejected=1]="Rejected"})(oe||(oe={}));class G{get isRejected(){return this.d?.outcome===oe.Rejected}get isResolved(){return this.d?.outcome===oe.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===oe.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((H,ne)=>{this.a=H,this.b=ne})}complete(H){return new Promise(ne=>{this.a(H),this.d={outcome:oe.Resolved,value:H},ne()})}error(H){return new Promise(ne=>{this.b(H),this.d={outcome:oe.Rejected,value:H},ne()})}cancel(){return this.error(new r.$4)}}e.$Zh=G;var he;(function(J){async function H(de){let me;const we=await Promise.all(de.map(Re=>Re.then(ke=>ke,ke=>{me||(me=ke)})));if(typeof me<"u")throw me;return we}J.settled=H;function ne(de){return new Promise(async(me,we)=>{try{await de(me,we)}catch(Re){we(Re)}})}J.withAsyncBody=ne})(he||(e.Promises=he={}));class re{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(H){this.a=void 0,this.b=void 0,this.d=!1,this.promise=H.then(ne=>(this.a=ne,this.d=!0,ne),ne=>{throw this.b=ne,this.d=!0,ne})}requireValue(){if(!this.d)throw new r.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$1h=re;class _{constructor(H){this.b=H,this.a=new a.$T(()=>new re(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$2h=_;var M;(function(J){J[J.Initial=0]="Initial",J[J.DoneOK=1]="DoneOK",J[J.DoneError=2]="DoneError"})(M||(M={}));class F{static fromArray(H){return new F(ne=>{ne.emitMany(H)})}static fromPromise(H){return new F(async ne=>{ne.emitMany(await H)})}static fromPromises(H){return new F(async ne=>{await Promise.all(H.map(async de=>ne.emitOne(await de)))})}static merge(H){return new F(async ne=>{await Promise.all(H.map(async de=>{for await(const me of de)ne.emitOne(me)}))})}static{this.EMPTY=F.fromArray([])}constructor(H,ne){this.a=M.Initial,this.b=[],this.d=null,this.f=ne,this.g=new E.$je,queueMicrotask(async()=>{const de={emitOne:me=>this.h(me),emitMany:me=>this.j(me),reject:me=>this.l(me)};try{await Promise.resolve(H(de)),this.k()}catch(me){this.l(me)}finally{de.emitOne=void 0,de.emitMany=void 0,de.reject=void 0}})}[Symbol.asyncIterator](){let H=0;return{next:async()=>{do{if(this.a===M.DoneError)throw this.d;if(H<this.b.length)return{done:!1,value:this.b[H++]};if(this.a===M.DoneOK)return{done:!0,value:void 0};await E.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(H,ne){return new F(async de=>{for await(const me of H)de.emitOne(ne(me))})}map(H){return F.map(this,H)}static filter(H,ne){return new F(async de=>{for await(const me of H)ne(me)&&de.emitOne(me)})}filter(H){return F.filter(this,H)}static coalesce(H){return F.filter(H,ne=>!!ne)}coalesce(){return F.coalesce(this)}static async toPromise(H){const ne=[];for await(const de of H)ne.push(de);return ne}toPromise(){return F.toPromise(this)}h(H){this.a===M.Initial&&(this.b.push(H),this.g.fire())}j(H){this.a===M.Initial&&(this.b=this.b.concat(H),this.g.fire())}k(){this.a===M.Initial&&(this.a=M.DoneOK,this.g.fire())}l(H){this.a===M.Initial&&(this.a=M.DoneError,this.d=H,this.g.fire())}}e.$3h=F;class U extends F{constructor(H,ne){super(ne),this.m=H}cancel(){this.m.cancel()}}e.$4h=U;function q(J){const H=new n.$ue,ne=J(H.token);return new U(H,async de=>{const me=H.token.onCancellationRequested(()=>{me.dispose(),H.dispose(),de.reject(new r.$4)});try{for await(const we of ne){if(H.token.isCancellationRequested)return;de.emitOne(we)}me.dispose(),H.dispose()}catch(we){me.dispose(),H.dispose(),de.reject(we)}})}class Q{constructor(H){this.a=new G,this.b=new F(me=>{if(ne){me.reject(ne);return}return de&&me.emitMany(de),this.d=we=>me.reject(we),this.f=we=>me.emitOne(we),this.a.p},H);let ne,de;this.f=me=>{de||(de=[]),de.push(me)},this.d=me=>{ne||(ne=me)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(H){this.d(H),this.a.complete()}emitOne(H){this.f(H)}}e.$6h=Q}),define(le[111],ue([0,1,20,8,39,32,31,9,3,25]),function(Y,e,n,r,E,D,T,I,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$sk=void 0,e.$rk=g,e.$uk=d,e.$vk=W,e.$wk=x,e.$xk=C,e.$yk=B,e.$zk=ee,e.$Ak=te;function g(){return Object.create(null)}e.$sk="**",e.$tk="/";const h="[/\\\\]",m="[^/\\\\]",w=/\//g;function f(z,j){switch(z){case 0:return"";case 1:return`${m}*?`;default:return`(?:${h}|${m}+${h}${j?`|${h}${m}+`:""})*?`}}function d(z,j){if(!z)return[];const N=[];let V=!1,oe=!1,G="";for(const he of z){switch(he){case j:if(!V&&!oe){N.push(G),G="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}G+=he}return G&&N.push(G),N}function v(z){if(!z)return"";let j="";const N=d(z,e.$tk);if(N.every(V=>V===e.$sk))j=".*";else{let V=!1;N.forEach((oe,G)=>{if(oe===e.$sk){if(V)return;j+=f(2,G===N.length-1)}else{let he=!1,re="",_=!1,M="";for(const F of oe){if(F!=="}"&&he){re+=F;continue}if(_&&(F!=="]"||!M)){let U;F==="-"?U=F:(F==="^"||F==="!")&&!M?U="^":F===e.$tk?U="":U=(0,a.$ff)(F),M+=U;continue}switch(F){case"{":he=!0;continue;case"[":_=!0;continue;case"}":{const q=`(?:${d(re,",").map(Q=>v(Q)).join("|")})`;j+=q,he=!1,re="";break}case"]":{j+="["+M+"]",_=!1,M="";break}case"?":j+=m;continue;case"*":j+=f(1);continue;default:j+=(0,a.$ff)(F)}}G<N.length-1&&(N[G+1]!==e.$sk||G+2<N.length)&&(j+=h)}V=oe===e.$sk})}return j}const b=/^\*\*\/\*\.[\w\.-]+$/,$=/^\*\*\/([\w\.-]+)\/?$/,P=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,S=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new T.$Cc(1e4),o=function(){return!1},s=function(){return null};function c(z,j){if(!z)return s;let N;typeof z!="string"?N=z.pattern:N=z,N=N.trim();const V=`${N}_${!!j.trimForExclusions}`;let oe=i.get(V);if(oe)return l(oe,z);let G;return b.test(N)?oe=y(N.substr(4),N):(G=$.exec(k(N,j)))?oe=R(G[1],N):(j.trimForExclusions?S:P).test(N)?oe=L(N,j):(G=t.exec(k(N,j)))?oe=A(G[1].substr(1),N,!0):(G=u.exec(k(N,j)))?oe=A(G[1],N,!1):oe=O(N),i.set(V,oe),l(oe,z)}function l(z,j){if(typeof j=="string")return z;const N=function(V,oe){return(0,D.$Bg)(V,j.base,!p.$l)?z((0,a.$kf)(V.substr(j.base.length),I.sep),oe):null};return N.allBasenames=z.allBasenames,N.allPaths=z.allPaths,N.basenames=z.basenames,N.patterns=z.patterns,N}function k(z,j){return j.trimForExclusions&&z.endsWith("/**")?z.substr(0,z.length-2):z}function y(z,j){return function(N,V){return typeof N=="string"&&N.endsWith(z)?j:null}}function R(z,j){const N=`/${z}`,V=`\\${z}`,oe=function(he,re){return typeof he!="string"?null:re?re===z?j:null:he===z||he.endsWith(N)||he.endsWith(V)?j:null},G=[z];return oe.basenames=G,oe.patterns=[j],oe.allBasenames=G,oe}function L(z,j){const N=K(z.slice(1,-1).split(",").map(re=>c(re,j)).filter(re=>re!==s),z),V=N.length;if(!V)return s;if(V===1)return N[0];const oe=function(re,_){for(let M=0,F=N.length;M<F;M++)if(N[M](re,_))return z;return null},G=N.find(re=>!!re.allBasenames);G&&(oe.allBasenames=G.allBasenames);const he=N.reduce((re,_)=>_.allPaths?re.concat(_.allPaths):re,[]);return he.length&&(oe.allPaths=he),oe}function A(z,j,N){const V=I.sep===I.$fc.sep,oe=V?z:z.replace(w,I.sep),G=I.sep+oe,he=I.$fc.sep+z;let re;return N?re=function(_,M){return typeof _=="string"&&(_===oe||_.endsWith(G)||!V&&(_===z||_.endsWith(he)))?j:null}:re=function(_,M){return typeof _=="string"&&(_===oe||!V&&_===z)?j:null},re.allPaths=[(N?"*/":"./")+z],re}function O(z){try{const j=new RegExp(`^${v(z)}$`);return function(N){return j.lastIndex=0,typeof N=="string"&&j.test(N)?z:null}}catch{return s}}function W(z,j,N){return!z||typeof j!="string"?!1:x(z)(j,void 0,N)}function x(z,j={}){if(!z)return o;if(typeof z=="string"||C(z)){const N=c(z,j);if(N===s)return o;const V=function(oe,G){return!!N(oe,G)};return N.allBasenames&&(V.allBasenames=N.allBasenames),N.allPaths&&(V.allPaths=N.allPaths),V}return X(z,j)}function C(z){const j=z;return j?typeof j.base=="string"&&typeof j.pattern=="string":!1}function B(z){return z.allBasenames||[]}function ee(z){return z.allPaths||[]}function X(z,j){const N=K(Object.getOwnPropertyNames(z).map(re=>ae(re,z[re],j)).filter(re=>re!==s)),V=N.length;if(!V)return s;if(!N.some(re=>!!re.requiresSiblings)){if(V===1)return N[0];const re=function(F,U){let q;for(let Q=0,J=N.length;Q<J;Q++){const H=N[Q](F,U);if(typeof H=="string")return H;(0,r.$oh)(H)&&(q||(q=[]),q.push(H))}return q?(async()=>{for(const Q of q){const J=await Q;if(typeof J=="string")return J}return null})():null},_=N.find(F=>!!F.allBasenames);_&&(re.allBasenames=_.allBasenames);const M=N.reduce((F,U)=>U.allPaths?F.concat(U.allPaths):F,[]);return M.length&&(re.allPaths=M),re}const oe=function(re,_,M){let F,U;for(let q=0,Q=N.length;q<Q;q++){const J=N[q];J.requiresSiblings&&M&&(_||(_=(0,I.$mc)(re)),F||(F=_.substr(0,_.length-(0,I.$nc)(re).length)));const H=J(re,_,F,M);if(typeof H=="string")return H;(0,r.$oh)(H)&&(U||(U=[]),U.push(H))}return U?(async()=>{for(const q of U){const Q=await q;if(typeof Q=="string")return Q}return null})():null},G=N.find(re=>!!re.allBasenames);G&&(oe.allBasenames=G.allBasenames);const he=N.reduce((re,_)=>_.allPaths?re.concat(_.allPaths):re,[]);return he.length&&(oe.allPaths=he),oe}function ae(z,j,N){if(j===!1)return s;const V=c(z,N);if(V===s)return s;if(typeof j=="boolean")return V;if(j){const oe=j.when;if(typeof oe=="string"){const G=(he,re,_,M)=>{if(!M||!V(he,re))return null;const F=oe.replace("$(basename)",()=>_),U=M(F);return(0,r.$oh)(U)?U.then(q=>q?z:null):U?z:null};return G.requiresSiblings=!0,G}}return V}function K(z,j){const N=z.filter(re=>!!re.basenames);if(N.length<2)return z;const V=N.reduce((re,_)=>{const M=_.basenames;return M?re.concat(M):re},[]);let oe;if(j){oe=[];for(let re=0,_=V.length;re<_;re++)oe.push(j)}else oe=N.reduce((re,_)=>{const M=_.patterns;return M?re.concat(M):re},[]);const G=function(re,_){if(typeof re!="string")return null;if(!_){let F;for(F=re.length;F>0;F--){const U=re.charCodeAt(F-1);if(U===E.CharCode.Slash||U===E.CharCode.Backslash)break}_=re.substr(F)}const M=V.indexOf(_);return M!==-1?oe[M]:null};G.basenames=V,G.patterns=oe,G.allBasenames=V;const he=z.filter(re=>!re.basenames);return he.push(G),he}function te(z,j){return(0,n.$tb)(z,j,(N,V)=>typeof N=="string"&&typeof V=="string"?N===V:typeof N!="string"&&typeof V!="string"?N.base===V.base&&N.pattern===V.pattern:!1)}}),define(le[47],ue([0,1,20,32,9,3,18,25]),function(Y,e,n,r,E,D,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uw=p,e.$Vw=g,e.$Ww=m,e.$Xw=w,e.$Yw=b,e.$Zw=P,e.$1w=S,e.$2w=t,e.$3w=u,e.$4w=i;function p(s,c){const{os:l,tildify:k,relative:y}=c;if(y){const A=a(s,y,l);if(typeof A=="string")return A}let R=s.fsPath;if(l===D.OperatingSystem.Windows&&!D.$j?R=R.replace(/\//g,"\\"):l!==D.OperatingSystem.Windows&&D.$j&&(R=R.replace(/\\/g,"/")),l!==D.OperatingSystem.Windows&&k?.userHome){const A=k.userHome.fsPath;let O;s.scheme!==k.userHome.scheme&&s.path[0]===E.$fc.sep&&s.path[1]!==E.$fc.sep?O=k.userHome.with({path:s.path}).fsPath:O=R,R=m(O,A,l)}return(l===D.OperatingSystem.Windows?E.$ec:E.$fc).normalize(g(R,l===D.OperatingSystem.Windows))}function a(s,c,l){const k=l===D.OperatingSystem.Windows?E.$ec:E.$fc,y=l===D.OperatingSystem.Linux?T.$6g:T.$8g,R=c.getWorkspace(),L=(0,n.$Nb)(R.folders);if(!L)return;s.scheme!==L.uri.scheme&&s.path[0]===E.$fc.sep&&s.path[1]!==E.$fc.sep&&(s=L.uri.with({path:s.path}));const A=c.getWorkspaceFolder(s);if(!A)return;let O;if(y.isEqual(A.uri,s)?O="":O=y.relativePath(A.uri,s)??"",O&&(O=k.normalize(O)),R.folders.length>1&&!c.noPrefix){const W=A.name?A.name:y.basenameOrAuthority(A.uri);O=O?`${W} \u2022 ${O}`:W}return O}function g(s,c=D.$j){return(0,r.$Gg)(s,c)?s.charAt(0).toUpperCase()+s.slice(1):s}let h=Object.create(null);function m(s,c,l=D.OS){if(l===D.OperatingSystem.Windows||!s||!c)return s;let k=h.original===c?h.normalized:void 0;k||(k=c,D.$j&&(k=(0,r.$vg)(k)),k=`${(0,I.$lf)(k,E.$fc.sep)}${E.$fc.sep}`,h={original:c,normalized:k});let y=s;return D.$j&&(y=(0,r.$vg)(y)),(l===D.OperatingSystem.Linux?y.startsWith(k):(0,I.$Ef)(y,k))?`~/${y.substr(k.length)}`:s}function w(s,c){return s.replace(/^~($|\/|\\)/,`${c}$1`)}const f="\u2026",d="\\\\",v="~";function b(s,c=E.sep){const l=new Array(s.length);let k=!1;for(let y=0;y<s.length;y++){const R=s[y];if(R===""){l[y]=`.${c}`;continue}if(!R){l[y]=R;continue}k=!0;let L="",A=R;A.indexOf(d)===0?(L=A.substr(0,A.indexOf(d)+d.length),A=A.substr(A.indexOf(d)+d.length)):A.indexOf(c)===0?(L=A.substr(0,A.indexOf(c)+c.length),A=A.substr(A.indexOf(c)+c.length)):A.indexOf(v)===0&&(L=A.substr(0,A.indexOf(v)+v.length),A=A.substr(A.indexOf(v)+v.length));const O=A.split(c);for(let W=1;k&&W<=O.length;W++)for(let x=O.length-W;k&&x>=0;x--){k=!1;let C=O.slice(x,x+W).join(c);for(let B=0;!k&&B<s.length;B++)if(B!==y&&s[B]&&s[B].indexOf(C)>-1){const ee=x+W===O.length,X=x>0&&s[B].indexOf(c)>-1?c+C:C,ae=s[B].endsWith(X);k=!ee||ae}if(!k){let B="";(O[0].endsWith(":")||L!=="")&&(x===1&&(x=0,W++,C=O[0]+c+C),x>0&&(B=O[0]+c),B=L+B),x>0&&(B=B+f+c),B=B+C,x+W<O.length&&(B=B+c+f),l[y]=B}}k&&(l[y]=R)}return l}var $;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})($||($={}));function P(s,c=Object.create(null)){const l=[];let k=!1,y="";for(const R of s)if(R==="$"||k&&R==="{")y&&l.push({value:y,type:$.TEXT}),y="",k=!0;else if(R==="}"&&k){const L=c[y];if(typeof L=="string")L.length&&l.push({value:L,type:$.VARIABLE});else if(L){const A=l[l.length-1];(!A||A.type!==$.SEPARATOR)&&l.push({value:L.label,type:$.SEPARATOR})}y="",k=!1}else y+=R;return y&&!k&&l.push({value:y,type:$.TEXT}),l.filter((R,L)=>{if(R.type===$.SEPARATOR){const A=l[L-1],O=l[L+1];return[A,O].every(W=>W&&(W.type===$.VARIABLE||W.type===$.TEXT)&&W.value.length>0)}return!0}).map(R=>R.value).join("")}function S(s,c){return D.$k||c?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.$k?"&":"&&"):s.replace(/&&|&/g,l=>l==="&"?"&&":"&")}function t(s,c){return D.$k||c?s.replace(/\(&&\w\)|&&/g,""):D.$j?s.replace(/&&|&/g,l=>l==="&"?"&&":"&"):s.replace(/&&/g,"_")}function u(s){return s.replace(/&/g,"&&")}function i(s){if(s.endsWith("]")){const c=s.lastIndexOf(" [",s.length-2);if(c!==-1){const l=o(s.substring(0,c)),k=s.substring(c);return{name:l.name+k,parentPath:l.parentPath}}}return o(s)}function o(s){const c=s.indexOf("/")!==-1?E.$fc:E.$ec,l=c.basename(s),k=c.dirname(s);return l.length?{name:l,parentPath:k}:{name:k,parentPath:""}}}),define(le[149],ue([0,1,16,90,7]),function(Y,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=void 0,e.$Kn=p,e.$Ln=g,e.$Mn=h;function D(m){return m.toJSON()}class T{constructor(w){this.a=w}transformIncoming(w){const f=this.a.transformIncoming(w);return f===w?w:D(E.URI.from(f))}transformOutgoing(w){const f=this.a.transformOutgoing(w);return f===w?w:D(E.URI.from(f))}transformOutgoingURI(w){const f=this.a.transformOutgoing(w);return f===w?w:E.URI.from(f)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$In=T,e.$Jn=new class{transformIncoming(m){return m}transformOutgoing(m){return m}transformOutgoingURI(m){return m}transformOutgoingScheme(m){return m}};function I(m,w,f){if(!m||f>200)return null;if(typeof m=="object"){if(m instanceof E.URI)return w.transformOutgoing(m);for(const d in m)if(Object.hasOwnProperty.call(m,d)){const v=I(m[d],w,f+1);v!==null&&(m[d]=v)}}return null}function p(m,w){const f=I(m,w,0);return f===null?m:f}function a(m,w,f,d){if(!m||d>200)return null;if(typeof m=="object"){if(m.$mid===r.MarshalledId.Uri)return f?E.URI.revive(w.transformIncoming(m)):w.transformIncoming(m);if(m instanceof n.$Le)return null;for(const v in m)if(Object.hasOwnProperty.call(m,v)){const b=a(m[v],w,f,d+1);b!==null&&(m[v]=b)}}return null}function g(m,w){const f=a(m,w,!1,0);return f===null?m:f}function h(m,w){const f=a(m,w,!0,0);return f===null?m:f}}),define(le[33],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yg=void 0,e.$Xg=r;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function r(E){return n.test(E)}e.$Yg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let E;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?E=crypto.getRandomValues.bind(crypto):E=function(I){for(let p=0;p<I.length;p++)I[p]=Math.floor(Math.random()*256);return I};const D=new Uint8Array(16),T=[];for(let I=0;I<256;I++)T.push(I.toString(16).padStart(2,"0"));return function(){E(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let p=0,a="";return a+=T[D[p++]],a+=T[D[p++]],a+=T[D[p++]],a+=T[D[p++]],a+="-",a+=T[D[p++]],a+=T[D[p++]],a+="-",a+=T[D[p++]],a+=T[D[p++]],a+="-",a+=T[D[p++]],a+=T[D[p++]],a+="-",a+=T[D[p++]],a+=T[D[p++]],a+=T[D[p++]],a+=T[D[p++]],a+=T[D[p++]],a+=T[D[p++]],a}}()}),define(le[150],ue([0,1,91,26,89]),function(Y,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qX=D,n=Ie(n),r=Ie(r);async function D(T,I){if(await new Promise((g,h)=>{const m=r.createReadStream(T),w=n.createHash("sha256");m.pipe(w);const f=(0,E.$cb)((d,v)=>{m.removeAllListeners(),w.removeAllListeners(),d?h(d):g(v)});m.once("error",f),m.once("end",f),w.once("error",f),w.once("data",d=>f(void 0,d.toString("hex")))})!==I)throw new Error("Hash mismatch")}}),define(le[151],ue([0,1,27]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=D;const r=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function E(T){const I=T.replace(/\-/g,":").toLowerCase();return!r.has(I)}function D(){const T=(0,n.networkInterfaces)();for(const I in T){const p=T[I];if(p){for(const{mac:a}of p)if(E(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(le[92],ue([0,1,27,60,33,151,3]),function(Y,e,n,r,E,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=void 0,e.$Pn=p,e.$Qn=h,e.$Rn=m,E=Ie(E),e.$On=new class{c(w){return this.a||(this.a=r.$Ii.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(w)}value(){if(this.b===void 0){let w=0,f=0;const d=(0,n.networkInterfaces)();for(const v in d){const b=d[v];if(b)for(const{mac:$,internal:P}of b)P||(f+=1,this.c($.toUpperCase())&&(w+=1))}this.b=f>0?w/f:0}return this.b}};let I;async function p(w){return I||(I=(async()=>await a(w)||E.$Yg())()),I}async function a(w){try{const f=await new Promise((v,b)=>{Y(["crypto"],v,b)}).then(Ie),d=(0,D.$Nn)();return f.createHash("sha256").update(d,"utf8").digest("hex")}catch(f){w(f);return}}const g="Software\\Microsoft\\SQMClient";async function h(w){if(T.$j){const f=await new Promise((d,v)=>{Y(["@vscode/windows-registry"],d,v)}).then(Ie);try{return f.GetStringRegKey("HKEY_LOCAL_MACHINE",g,"MachineId")||""}catch(d){return w(d),""}}return""}async function m(w){try{return await(await new Promise((v,b)=>{Y(["@vscode/deviceid"],v,b)}).then(Ie)).getDeviceId()}catch(f){return w(f),""}}}),define(le[23],ue([0,1,26,27,152,8,32,78,9,3,18,7]),function(Y,e,n,r,E,D,T,I,p,a,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=v,e.readdirSync=P,e.whenDeleted=u,e.configureFlushOnWrite=l,e.writeFileSync=y,n=Ie(n);var m;(function(X){X[X.UNLINK=0]="UNLINK",X[X.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function w(X,ae=m.UNLINK,K){if((0,T.$Fg)(X))throw new Error("rimraf - will refuse to recursively delete root");return ae===m.UNLINK?d(X):f(X,K)}async function f(X,ae=(0,T.$Kg)((0,r.tmpdir)())){try{try{await n.promises.rename(X,ae)}catch(K){return K.code==="ENOENT"?void 0:d(X)}d(ae).catch(K=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function d(X){return n.promises.rm(X,{recursive:!0,force:!0,maxRetries:3})}function v(X){if((0,T.$Fg)(X))throw new Error("rimraf - will refuse to recursively delete root");n.rmSync(X,{recursive:!0,force:!0,maxRetries:3})}async function b(X,ae){return S(await(ae?$(X):n.promises.readdir(X)))}async function $(X){try{return await n.promises.readdir(X,{withFileTypes:!0})}catch(te){console.warn("[node.js fs] readdir with filetypes failed with error: ",te)}const ae=[],K=await b(X);for(const te of K){let z=!1,j=!1,N=!1;try{const V=await n.promises.lstat((0,p.$ic)(X,te));z=V.isFile(),j=V.isDirectory(),N=V.isSymbolicLink()}catch(V){console.warn("[node.js fs] unexpected error from lstat after readdir: ",V)}ae.push({name:te,isFile:()=>z,isDirectory:()=>j,isSymbolicLink:()=>N})}return ae}function P(X){return S(n.readdirSync(X))}function S(X){return X.map(ae=>typeof ae=="string"?a.$k?(0,I.$jm)(ae):ae:(ae.name=a.$k?(0,I.$jm)(ae.name):ae.name,ae))}async function t(X){const ae=await b(X),K=[];for(const te of ae)await i.existsDirectory((0,p.$ic)(X,te))&&K.push(te);return K}function u(X,ae=1e3){return new Promise(K=>{let te=!1;const z=setInterval(()=>{te||(te=!0,n.access(X,j=>{te=!1,j&&(clearInterval(z),K(void 0))}))},ae)})}var i;(function(X){async function ae(z){let j;try{if(j=await n.promises.lstat(z),!j.isSymbolicLink())return{stat:j}}catch{}try{return{stat:await n.promises.stat(z),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(N){if(N.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(a.$j&&N.code==="EACCES")try{return{stat:await n.promises.stat(await n.promises.readlink(z)),symbolicLink:{dangling:!1}}}catch(V){if(V.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw V}throw N}}X.stat=ae;async function K(z){try{const{stat:j,symbolicLink:N}=await X.stat(z);return j.isFile()&&N?.dangling!==!0}catch{}return!1}X.existsFile=K;async function te(z){try{const{stat:j,symbolicLink:N}=await X.stat(z);return j.isDirectory()&&N?.dangling!==!0}catch{}return!1}X.existsDirectory=te})(i||(e.SymlinkSupport=i={}));const o=new D.$Lh;function s(X,ae,K){return o.queueFor(h.URI.file(X),()=>{const te=R(K);return new Promise((z,j)=>k(X,ae,te,N=>N?j(N):z()))},g.$7g)}let c=!0;function l(X){c=X}function k(X,ae,K,te){if(!c)return n.writeFile(X,ae,{mode:K.mode,flag:K.flag},te);n.open(X,K.flag,K.mode,(z,j)=>{if(z)return te(z);n.writeFile(j,ae,N=>{if(N)return n.close(j,()=>te(N));n.fdatasync(j,V=>(V&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",V),l(!1)),n.close(j,oe=>te(oe))))})})}function y(X,ae,K){const te=R(K);if(!c)return n.writeFileSync(X,ae,{mode:te.mode,flag:te.flag});const z=n.openSync(X,te.flag,te.mode);try{n.writeFileSync(z,ae);try{n.fdatasyncSync(z)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),l(!1)}}finally{n.closeSync(z)}}function R(X){return X?{mode:typeof X.mode=="number"?X.mode:438,flag:typeof X.flag=="string"?X.flag:"w"}:{mode:438,flag:"w"}}async function L(X,ae,K=6e4){if(X!==ae)try{a.$j&&typeof K=="number"?await A(X,ae,Date.now(),K):await n.promises.rename(X,ae)}catch(te){if(X.toLowerCase()!==ae.toLowerCase()&&te.code==="EXDEV"||X.endsWith("."))await O(X,ae,{preserveSymlinks:!1}),await w(X,m.MOVE);else throw te}}async function A(X,ae,K,te,z=0){try{return await n.promises.rename(X,ae)}catch(j){if(j.code!=="EACCES"&&j.code!=="EPERM"&&j.code!=="EBUSY")throw j;if(Date.now()-K>=te)throw console.error(`[node.js fs] rename failed after ${z} retries with error: ${j}`),j;if(z===0){let N=!1;try{const{stat:V}=await i.stat(ae);V.isFile()||(N=!0)}catch{}if(N)throw j}return await(0,D.$Dh)(Math.min(100,z*10)),A(X,ae,K,te,z+1)}}async function O(X,ae,K){return x(X,ae,{root:{source:X,target:ae},options:K,handledSourcePaths:new Set})}const W=511;async function x(X,ae,K){if(K.handledSourcePaths.has(X))return;K.handledSourcePaths.add(X);const{stat:te,symbolicLink:z}=await i.stat(X);if(z){if(K.options.preserveSymlinks)try{return await ee(X,ae,K)}catch{}if(z.dangling)return}return te.isDirectory()?C(X,ae,te.mode&W,K):B(X,ae,te.mode&W)}async function C(X,ae,K,te){await n.promises.mkdir(ae,{recursive:!0,mode:K});const z=await b(X);for(const j of z)await x((0,p.$ic)(X,j),(0,p.$ic)(ae,j),te)}async function B(X,ae,K){await n.promises.copyFile(X,ae),await n.promises.chmod(ae,K)}async function ee(X,ae,K){let te=await n.promises.readlink(X);(0,T.$Bg)(te,K.root.source,!a.$l)&&(te=(0,p.$ic)(K.root.target,te.substr(K.root.source.length+1))),await n.promises.symlink(te,ae)}e.Promises=new class{get read(){return(X,ae,K,te,z)=>new Promise((j,N)=>{n.read(X,ae,K,te,z,(V,oe,G)=>V?N(V):j({bytesRead:oe,buffer:G}))})}get write(){return(X,ae,K,te,z)=>new Promise((j,N)=>{n.write(X,ae,K,te,z,(V,oe,G)=>V?N(V):j({bytesWritten:oe,buffer:G}))})}get fdatasync(){return(0,E.promisify)(n.fdatasync)}get open(){return(0,E.promisify)(n.open)}get close(){return(0,E.promisify)(n.close)}get realpath(){return(0,E.promisify)(n.realpath)}async exists(X){try{return await n.promises.access(X),!0}catch{return!1}}get readdir(){return b}get readDirsInDir(){return t}get writeFile(){return s}get rm(){return w}get rename(){return L}get copy(){return O}}}),define(le[112],ue([0,1,26,9,3,25,23]),function(Y,e,n,r,E,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=I,e.$ir=p,e.$jr=a,e.$kr=g,n=Ie(n);function I(m){if(E.$l)return m;const w=(0,r.$lc)(m);if(m===w)return m;const f=((0,r.$mc)(m)||m).toLowerCase();try{const v=(0,T.readdirSync)(w).filter(b=>b.toLowerCase()===f);if(v.length===1){const b=I(w);if(b)return(0,r.$ic)(b,v[0])}else if(v.length>1){const b=v.indexOf(f);if(b>=0){const $=I(w);if($)return(0,r.$ic)($,v[b])}}}catch{}return null}async function p(m,w){if(E.$l)return m;const f=(0,r.$lc)(m);if(m===f)return m;const d=((0,r.$mc)(m)||m).toLowerCase();try{if(w?.isCancellationRequested)return null;const b=(await T.Promises.readdir(f)).filter($=>$.toLowerCase()===d);if(b.length===1){const $=await p(f,w);if($)return(0,r.$ic)($,b[0])}else if(b.length>1){const $=b.indexOf(d);if($>=0){const P=await p(f,w);if(P)return(0,r.$ic)(P,b[$])}}}catch{}return null}async function a(m){try{return await T.Promises.realpath(m)}catch{const f=h(m);return await n.promises.access(f,n.constants.R_OK),f}}function g(m){try{return n.realpathSync(m)}catch{const f=h(m);return n.accessSync(f,n.constants.R_OK),f}}function h(m){return(0,D.$lf)((0,r.$gc)(m),r.sep)}}),define(le[113],ue([0,1,93]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=void 0,e.$1g=r,e.$3g=D,n=Ie(n);function r(I,p,a,g=1){let h=!1;return new Promise(m=>{const w=setTimeout(()=>{if(!h)return h=!0,m(0)},a);E(I,p,g,f=>{if(!h)return h=!0,clearTimeout(w),m(f)})})}function E(I,p,a,g){if(p===0)return g(0);const h=new n.Socket;h.once("connect",()=>(T(h),E(I+a,p-1,a,g))),h.once("data",()=>{}),h.once("error",m=>(T(h),m.code!=="ECONNREFUSED"?E(I+a,p-1,a,g):g(I))),h.connect(I,"127.0.0.1")}e.$2g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function D(I,p,a,g="127.0.0.1"){let h=!1,m,w=1;const f=n.createServer({pauseOnConnect:!0});function d(v,b){h||(h=!0,f.removeAllListeners(),f.close(),m&&clearTimeout(m),b(v))}return new Promise(v=>{m=setTimeout(()=>{d(0,v)},a),f.on("listening",()=>{d(I,v)}),f.on("error",b=>{b&&(b.code==="EADDRINUSE"||b.code==="EACCES")&&w<p?(I++,w++,f.listen(I,g)):d(0,v)}),f.on("close",()=>{d(0,v)}),f.listen(I,g)})}function T(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(p){console.error(p)}}}),define(le[114],ue([0,1,27,9,23]),function(Y,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=$,e.$tm=P,n=Ie(n),r=Ie(r),E=Ie(E);const D=/^\d+$/,T=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var p;(function(S){S[S.x64=0]="x64",S[S.x86=1]="x86",S[S.ARM=2]="ARM"})(p||(p={}));let a;switch(process.arch){case"ia32":a=p.x86;break;case"arm":case"arm64":a=p.ARM;break;default:a=p.x64;break}let g;process.env.PROCESSOR_ARCHITEW6432?g=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?p.ARM:p.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?g=p.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?g=p.x86:g=p.x64;class h{constructor(t,u,i){this.exePath=t,this.displayName=u,this.a=i}async exists(){return this.a===void 0&&(this.a=await E.SymlinkSupport.existsFile(this.exePath)),this.a}}function m({useAlternateBitness:S=!1}={}){return S?a===p.x64?process.env["ProgramFiles(x86)"]||null:g===p.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:S=!1,findPreview:t=!1}={}){const u=m({useAlternateBitness:S});if(!u)return null;const i=r.$ic(u,"PowerShell");if(!await E.SymlinkSupport.existsDirectory(i))return null;let o=-1,s=null;for(const k of await E.Promises.readdir(i)){let y=-1;if(t){const L=k.indexOf("-");if(L<0)continue;const A=k.substring(0,L);if(!D.test(A)||k.substring(L+1)!=="preview")continue;y=parseInt(A,10)}else{if(!D.test(k))continue;y=parseInt(k,10)}if(y<=o)continue;const R=r.$ic(i,k,"pwsh.exe");await E.SymlinkSupport.existsFile(R)&&(s=R,o=y)}if(!s)return null;const c=u.includes("x86")?" (x86)":"",l=t?" Preview":"";return new h(s,`PowerShell${l}${c}`,!0)}async function f({findPreview:S}={}){if(!process.env.LOCALAPPDATA)return null;const t=r.$ic(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await E.SymlinkSupport.existsDirectory(t))return null;const{pwshMsixDirRegex:u,pwshMsixName:i}=S?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const o of await E.Promises.readdir(t))if(u.test(o)){const s=r.$ic(t,o,"pwsh.exe");return new h(s,i)}return null}function d(){const S=r.$ic(n.homedir(),".dotnet","tools","pwsh.exe");return new h(S,".NET Core PowerShell Global Tool")}function v(){const S=r.$ic(process.env.windir,a===p.x86&&g!==p.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new h(S,"Windows PowerShell",!0)}async function*b(){let S=await w();S&&(yield S),S=await w({useAlternateBitness:!0}),S&&(yield S),S=await f(),S&&(yield S),S=d(),S&&(yield S),S=await w({findPreview:!0}),S&&(yield S),S=await f({findPreview:!0}),S&&(yield S),S=await w({useAlternateBitness:!0,findPreview:!0}),S&&(yield S),S=v(),S&&(yield S)}async function*$(){for await(const S of b())await S.exists()&&(yield S)}async function P(){for await(const S of $())return S;return null}}),define(le[94],ue([0,1,26,9,3,36,79,12,23]),function(Y,e,n,r,E,D,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$um=a,e.$vm=g,r=Ie(r),E=Ie(E),D=Ie(D),I=Ie(I),p=Ie(p),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function a(m=D.env){return m.comspec||"cmd.exe"}function g(m){let w=[],f=!1;const d=function(v){if(f){w.push(v);return}(!m.send(v,$=>{if($&&console.error($),f=!1,w.length>0){const P=w.slice(0);w=[],P.forEach(S=>d(S))}})||E.$j)&&(f=!0)};return{send:d}}var h;(function(m){async function w(f,d,v){if(r.$hc(f))return f;if(d===void 0&&(d=D.cwd()),r.$lc(f)!=="."||(v===void 0&&I.$cg(D.env.PATH)&&(v=D.env.PATH.split(r.$sc)),v===void 0||v.length===0))return r.$ic(d,f);async function $(P){if(await p.Promises.exists(P)){let S;try{S=await n.promises.stat(P)}catch(t){t.message.startsWith("EACCES")&&(S=await n.promises.lstat(P))}return S?!S.isDirectory():!1}return!1}for(const P of v){let S;if(r.$hc(P)?S=r.$ic(P,f):S=r.$ic(d,P,f),await $(S))return S;let t=S+".com";if(await $(t)||(t=S+".exe",await $(t)))return t}return r.$ic(d,f)}m.findExecutable=w})(h||(e.win32=h={}))}),define(le[115],ue([0,1,48,11]),function(Y,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=E;function E(T){return new Promise((I,p)=>{let a;const g=new Map;function h(w,f,d,v,b){const $=g.get(f);if(w===T||$){const P={name:m(d),cmd:d,pid:w,ppid:f,load:v,mem:b};g.set(w,P),w===T&&(a=P),$&&($.children||($.children=[]),$.children.push(P),$.children.length>1&&($.children=$.children.sort((S,t)=>S.pid-t.pid)))}}function m(w){const f=/--utility-sub-type=network/i,d=/--crashes-directory/i,v=/\\pipe\\winpty-control/i,b=/conhost\.exe.+--headless/i,$=/--type=([a-zA-Z-]+)/;if(d.exec(w))return"electron-crash-reporter";if(v.exec(w))return"winpty-agent";if(b.exec(w))return"conpty-agent";let P=$.exec(w);if(P&&P.length===2)return P[1]==="renderer"?"window":P[1]==="utility"?f.exec(w)?"utility-network-service":"utility-process":P[1]==="extensionHost"?"extension-host":P[1];const S=/[a-zA-Z-]+\.js/g;let t="";do P=S.exec(w),P&&(t+=P+" ");while(P);return t&&w.indexOf("node ")<0&&w.indexOf("node.exe")<0?`electron-nodejs (${t})`:w}if(process.platform==="win32"){const w=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substring(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substring(5):f;new Promise((f,d)=>{Y(["@vscode/windows-process-tree"],f,d)}).then(Ie).then(f=>{f.getProcessList(T,d=>{if(!d){p(new Error(`Root process ${T} not found`));return}f.getProcessCpuUsage(d,v=>{const b=new Map;v.forEach($=>{const P=w($.commandLine||"");b.set($.pid,{name:m(P),cmd:P,pid:$.pid,ppid:$.ppid,load:$.cpu||0,mem:$.memory||0})}),a=b.get(T),a?(b.forEach($=>{const P=b.get($.ppid);P&&(P.children||(P.children=[]),P.children.push($))}),b.forEach($=>{$.children&&($.children=$.children.sort((P,S)=>P.pid-S.pid))}),I(a)):p(new Error(`Root process ${T} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let w=function(){let f=[a];const d=[];for(;f.length;){const b=f.shift();b&&(d.push(b.pid),b.children&&(f=f.concat(b.children)))}let v=JSON.stringify(r.$Wg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);v+=" "+d.join(" "),(0,n.exec)(v,{},(b,$,P)=>{if(b||P)p(b||new Error(P.toString()));else{const S=$.toString().split(`
`);for(let t=0;t<d.length;t++){const u=g.get(d[t]);u.load=parseFloat(S[t])}if(!a){p(new Error(`Root process ${T} not found`));return}I(a)}})};(0,n.exec)("which ps",{},(f,d,v)=>{if(f||v)if(process.platform!=="linux")p(f||new Error(v.toString()));else{const b=JSON.stringify(r.$Wg.asFileUri("vs/base/node/ps.sh").fsPath);(0,n.exec)(b,{},($,P,S)=>{$||S?p($||new Error(S.toString())):(D(P,h),w())})}else{const b=d.toString().trim();(0,n.exec)(`${b} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(P,S,t)=>{P||t&&!t.includes("screen size is bogus")?p(P||new Error(t.toString())):(D(S,h),process.platform==="linux"?w():a?I(a):p(new Error(`Root process ${T} not found`)))})}})}})}function D(T,I){const p=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,a=T.toString().split(`
`);for(const g of a){const h=p.exec(g.trim());h&&h.length===6&&I(parseInt(h[1]),parseInt(h[2]),h[5],parseFloat(h[3]),parseFloat(h[4]))}}}),define(le[116],ue([0,1,27,3,114,94]),function(Y,e,n,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=T,r=Ie(r),D=Ie(D);async function T(h,m){return h===r.OperatingSystem.Windows?r.$j?g():D.$um(m):p(h,m)}let I=null;function p(h,m){if(r.$l&&h===r.OperatingSystem.Macintosh||r.$k&&h===r.OperatingSystem.Linux)return"/bin/bash";if(!I){let w;if(r.$j)w="/bin/bash";else{if(w=m.SHELL,!w)try{w=(0,n.userInfo)().shell}catch{}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}I=w}return I}let a=null;async function g(){return a||(a=(await(0,E.$tm)()).exePath),a}}),function(){function Y(){function e(){return process.uncHostAllowlist}function n(p){const a=new Set;if(Array.isArray(p))for(const g of p)typeof g=="string"&&a.add(g);return Array.from(a)}function r(){const p=e();return p?Array.from(p):[]}function E(p){if(process.platform!=="win32")return;const a=e();if(a)if(typeof p=="string")a.add(p.toLowerCase());else for(const g of n(p))E(g)}function D(p){if(typeof p!="string")return;const a=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let g;for(const h of a){if(p.indexOf(h)!==0)continue;const w=p.indexOf("\\",h.length);if(w===-1)continue;const f=p.substring(h.length,w);if(f){g=f;break}}return g}function T(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function I(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:r,addUNCHostToAllowlist:E,getUNCHost:D,disableUNCAccessRestrictions:T,isUNCAccessRestrictionsDisabled:I}}typeof define=="function"?define("vs/base/node/unc",[],function(){return Y()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=Y():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(le[153],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wX=e.$vX=void 0,e.$vX="vscode:contextmenu",e.$wX="vscode:onCloseContextMenu"});var Ee=this&&this.__decorate||function(Y,e,n,r){var E=arguments.length,D=E<3?e:r===null?r=Object.getOwnPropertyDescriptor(e,n):r,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(Y,e,n,r);else for(var I=Y.length-1;I>=0;I--)(T=Y[I])&&(D=(E<3?T(D):E>3?T(e,n,D):T(e,n))||D);return E>3&&D&&Object.defineProperty(e,n,D),D};define(le[44],ue([0,1,20,8,16,21,53,15,4,2,82,25,12]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=e.ProxyChannel=e.$ki=e.$hi=e.$gi=e.$fi=e.RequestInitiator=e.$ei=e.$bi=e.$ai=void 0,e.$ci=l,e.$di=k,e.$ii=W,e.$ji=x,h=Ie(h);var w;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(w||(w={}));function f(z){switch(z){case w.Promise:return"req";case w.PromiseCancel:return"cancel";case w.EventListen:return"subscribe";case w.EventDispose:return"unsubscribe"}}var d;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(d||(d={}));function v(z){switch(z){case d.Initialize:return"init";case d.PromiseSuccess:return"reply:";case d.PromiseError:case d.PromiseErrorObj:return"replyErr:";case d.EventFire:return"event:"}}var b;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(b||(b={}));function $(z){let j=0;for(let N=0;;N+=7){const V=z.read(1);if(j|=(V.buffer[0]&127)<<N,!(V.buffer[0]&128))return j}}const P=o(0);function S(z,j){if(j===0){z.write(P);return}let N=0;for(let oe=j;oe!==0;oe=oe>>>7)N++;const V=E.$Le.alloc(N);for(let oe=0;j!==0;oe++)V.buffer[oe]=j&127,j=j>>>7,j>0&&(V.buffer[oe]|=128);z.write(V)}class t{constructor(j){this.b=j,this.a=0}read(j){const N=this.b.slice(this.a,this.a+j);return this.a+=N.byteLength,N}}e.$ai=t;class u{constructor(){this.a=[]}get buffer(){return E.$Le.concat(this.a)}write(j){this.a.push(j)}}e.$bi=u;var i;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object",z[z.Int=6]="Int"})(i||(i={}));function o(z){const j=E.$Le.alloc(1);return j.writeUInt8(z,0),j}const s={Undefined:o(i.Undefined),String:o(i.String),Buffer:o(i.Buffer),VSBuffer:o(i.VSBuffer),Array:o(i.Array),Object:o(i.Object),Uint:o(i.Int)},c=typeof Buffer<"u";function l(z,j){if(typeof j>"u")z.write(s.Undefined);else if(typeof j=="string"){const N=E.$Le.fromString(j);z.write(s.String),S(z,N.byteLength),z.write(N)}else if(c&&Buffer.isBuffer(j)){const N=E.$Le.wrap(j);z.write(s.Buffer),S(z,N.byteLength),z.write(N)}else if(j instanceof E.$Le)z.write(s.VSBuffer),S(z,j.byteLength),z.write(j);else if(Array.isArray(j)){z.write(s.Array),S(z,j.length);for(const N of j)l(z,N)}else if(typeof j=="number"&&(j|0)===j)z.write(s.Uint),S(z,j);else{const N=E.$Le.fromString(JSON.stringify(j));z.write(s.Object),S(z,N.byteLength),z.write(N)}}function k(z){switch(z.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return z.read($(z)).toString();case i.Buffer:return z.read($(z)).buffer;case i.VSBuffer:return z.read($(z));case i.Array:{const N=$(z),V=[];for(let oe=0;oe<N;oe++)V.push(k(z));return V}case i.Object:return JSON.parse(z.read($(z)).toString());case i.Int:return $(z)}}class y{constructor(j,N,V=null,oe=1e3){this.h=j,this.j=N,this.k=V,this.l=oe,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(G=>this.q(G)),this.m({type:d.Initialize})}registerChannel(j,N){this.b.set(j,N),setTimeout(()=>this.w(j),0)}m(j){switch(j.type){case d.Initialize:{const N=this.o([j.type]);this.k?.logOutgoing(N,0,R.OtherSide,v(j.type));return}case d.PromiseSuccess:case d.PromiseError:case d.EventFire:case d.PromiseErrorObj:{const N=this.o([j.type,j.id],j.data);this.k?.logOutgoing(N,j.id,R.OtherSide,v(j.type),j.data);return}}}o(j,N=void 0){const V=new u;return l(V,j),l(V,N),this.p(V.buffer)}p(j){try{return this.h.send(j),j.byteLength}catch{return 0}}q(j){const N=new t(j),V=k(N),oe=k(N),G=V[0];switch(G){case w.Promise:return this.k?.logIncoming(j.byteLength,V[1],R.OtherSide,`${f(G)}: ${V[2]}.${V[3]}`,oe),this.s({type:G,id:V[1],channelName:V[2],name:V[3],arg:oe});case w.EventListen:return this.k?.logIncoming(j.byteLength,V[1],R.OtherSide,`${f(G)}: ${V[2]}.${V[3]}`,oe),this.t({type:G,id:V[1],channelName:V[2],name:V[3],arg:oe});case w.PromiseCancel:return this.k?.logIncoming(j.byteLength,V[1],R.OtherSide,`${f(G)}`),this.u({type:G,id:V[1]});case w.EventDispose:return this.k?.logIncoming(j.byteLength,V[1],R.OtherSide,`${f(G)}`),this.u({type:G,id:V[1]})}}s(j){const N=this.b.get(j.channelName);if(!N){this.v(j);return}const V=new D.$ue;let oe;try{oe=N.call(this.j,j.name,j.arg,V.token)}catch(re){oe=Promise.reject(re)}const G=j.id;oe.then(re=>{this.m({id:G,data:re,type:d.PromiseSuccess})},re=>{re instanceof Error?this.m({id:G,data:{message:re.message,name:re.name,stack:re.stack?re.stack.split(`
`):void 0},type:d.PromiseError}):this.m({id:G,data:re,type:d.PromiseErrorObj})}).finally(()=>{he.dispose(),this.d.delete(j.id)});const he=(0,a.$Rc)(()=>V.cancel());this.d.set(j.id,he)}t(j){const N=this.b.get(j.channelName);if(!N){this.v(j);return}const V=j.id,G=N.listen(this.j,j.name,j.arg)(he=>this.m({id:V,data:he,type:d.EventFire}));this.d.set(j.id,G)}u(j){const N=this.d.get(j.id);N&&(N.dispose(),this.d.delete(j.id))}v(j){let N=this.g.get(j.channelName);N||(N=[],this.g.set(j.channelName,N));const V=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===w.Promise&&this.m({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.l}ms`,stack:void 0},type:d.PromiseError})},this.l);N.push({request:j,timeoutTimer:V})}w(j){const N=this.g.get(j);if(N){for(const V of N)switch(clearTimeout(V.timeoutTimer),V.request.type){case w.Promise:this.s(V.request);break;case w.EventListen:this.t(V.request);break}this.g.delete(j)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Oc)(this.d.values()),this.d.clear()}}e.$ei=y;var R;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(R||(e.RequestInitiator=R={}));class L{constructor(j,N=null){this.l=j,this.a=!1,this.b=b.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new p.$je,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(V=>this.s(V)),this.j=N}getChannel(j){const N=this;return{call(V,oe,G){return N.a?Promise.reject(new I.$4):N.m(j,V,oe,G)},listen(V,oe){return N.a?p.Event.None:N.o(j,V,oe)}}}m(j,N,V,oe=D.CancellationToken.None){const G=this.g++,he=w.Promise,re={id:G,type:he,channelName:j,name:N,arg:V};if(oe.isCancellationRequested)return Promise.reject(new I.$4);let _;return new Promise((F,U)=>{if(oe.isCancellationRequested)return U(new I.$4);const q=()=>{const ne=de=>{switch(de.type){case d.PromiseSuccess:this.f.delete(G),F(de.data);break;case d.PromiseError:{this.f.delete(G);const me=new Error(de.data.message);me.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,me.name=de.data.name,U(me);break}case d.PromiseErrorObj:this.f.delete(G),U(de.data);break}};this.f.set(G,ne),this.p(re)};let Q=null;this.b===b.Idle?q():(Q=(0,r.$ph)(ne=>this.u()),Q.then(()=>{Q=null,q()}));const J=()=>{Q?(Q.cancel(),Q=null):this.p({id:G,type:w.PromiseCancel}),U(new I.$4)},H=oe.onCancellationRequested(J);_=(0,a.$Qc)((0,a.$Rc)(J),H),this.d.add(_)}).finally(()=>{_.dispose(),this.d.delete(_)})}o(j,N,V){const oe=this.g++,G=w.EventListen,he={id:oe,type:G,channelName:j,name:N,arg:V};let re=null;const _=new p.$je({onWillAddFirstListener:()=>{re=(0,r.$ph)(F=>this.u()),re.then(()=>{re=null,this.d.add(_),this.p(he)})},onDidRemoveLastListener:()=>{re?(re.cancel(),re=null):(this.d.delete(_),this.p({id:oe,type:w.EventDispose}))}}),M=F=>_.fire(F.data);return this.f.set(oe,M),_.event}p(j){switch(j.type){case w.Promise:case w.EventListen:{const N=this.q([j.type,j.id,j.channelName,j.name],j.arg);this.j?.logOutgoing(N,j.id,R.LocalSide,`${f(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case w.PromiseCancel:case w.EventDispose:{const N=this.q([j.type,j.id]);this.j?.logOutgoing(N,j.id,R.LocalSide,f(j.type));return}}}q(j,N=void 0){const V=new u;return l(V,j),l(V,N),this.r(V.buffer)}r(j){try{return this.l.send(j),j.byteLength}catch{return 0}}s(j){const N=new t(j),V=k(N),oe=k(N),G=V[0];switch(G){case d.Initialize:return this.j?.logIncoming(j.byteLength,0,R.LocalSide,v(G)),this.t({type:V[0]});case d.PromiseSuccess:case d.PromiseError:case d.EventFire:case d.PromiseErrorObj:return this.j?.logIncoming(j.byteLength,V[1],R.LocalSide,v(G),oe),this.t({type:V[0],id:V[1],data:oe})}}t(j){if(j.type===d.Initialize){this.b=b.Idle,this.k.fire();return}this.f.get(j.id)?.(j)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}u(){return this.b===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Oc)(this.d.values()),this.d.clear()}}e.$fi=L,Ee([T.$7h],L.prototype,"onDidInitializePromise",null);class A{get connections(){const j=[];return this.f.forEach(N=>j.push(N)),j}constructor(j,N,V){this.a=new Map,this.f=new Set,this.g=new p.$je,this.onDidAddConnection=this.g.event,this.h=new p.$je,this.onDidRemoveConnection=this.h.event,this.j=new a.$Sc,this.j.add(j(({protocol:oe,onDidClientDisconnect:G})=>{const he=p.Event.once(oe.onMessage);this.j.add(he(re=>{const _=new t(re),M=k(_),F=new y(oe,M,N,V),U=new L(oe,N);this.a.forEach((Q,J)=>F.registerChannel(J,Q));const q={channelServer:F,channelClient:U,ctx:M};this.f.add(q),this.g.fire(q),this.j.add(G(()=>{F.dispose(),U.dispose(),this.f.delete(q),this.h.fire(q)}))}))}))}getChannel(j,N){const V=this;return{call(oe,G,he){let re;if((0,m.$qg)(N)){const M=(0,n.$2b)(V.connections.filter(N));re=M?Promise.resolve(M):p.Event.toPromise(p.Event.filter(V.onDidAddConnection,N))}else re=N.routeCall(V,oe,G);const _=re.then(M=>M.channelClient.getChannel(j));return W(_).call(oe,G,he)},listen(oe,G){if((0,m.$qg)(N))return V.k(j,N,oe,G);const he=N.routeEvent(V,oe,G).then(re=>re.channelClient.getChannel(j));return W(he).listen(oe,G)}}}k(j,N,V,oe){const G=this;let he;const re=new p.$je({onWillAddFirstListener:()=>{he=new a.$Sc;const _=new p.$pe,M=new Map,F=q=>{const J=q.channelClient.getChannel(j).listen(V,oe),H=_.add(J);M.set(q,H)},U=q=>{const Q=M.get(q);Q&&(Q.dispose(),M.delete(q))};G.connections.filter(N).forEach(F),p.Event.filter(G.onDidAddConnection,N)(F,void 0,he),G.onDidRemoveConnection(U,void 0,he),_.event(re.fire,re,he),he.add(_)},onDidRemoveLastListener:()=>{he?.dispose(),he=void 0}});return re.event}registerChannel(j,N){this.a.set(j,N);for(const V of this.f)V.channelServer.registerChannel(j,N)}dispose(){this.j.dispose();for(const j of this.f)j.channelClient.dispose(),j.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$gi=A;class O{constructor(j,N,V=null){const oe=new u;l(oe,N),j.send(oe.buffer),this.a=new L(j,V),this.d=new y(j,N,V)}getChannel(j){return this.a.getChannel(j)}registerChannel(j,N){this.d.registerChannel(j,N)}dispose(){this.a.dispose(),this.d.dispose()}}e.$hi=O;function W(z){return{call(j,N,V){return z.then(oe=>oe.call(j,N,V))},listen(j,N){const V=new p.$se;return z.then(oe=>V.input=oe.listen(j,N)),V.event}}}function x(z){let j=!1;return{call(N,V,oe){return j?z.call(N,V,oe):(0,r.$Dh)(0).then(()=>j=!0).then(()=>z.call(N,V,oe))},listen(N,V){if(j)return z.listen(N,V);const oe=new p.$se;return(0,r.$Dh)(0).then(()=>j=!0).then(()=>oe.input=z.listen(N,V)),oe.event}}}class C{constructor(j){this.a=j}routeCall(j){return this.b(j)}routeEvent(j){return this.b(j)}async b(j){for(const N of j.connections)if(await Promise.resolve(this.a(N.ctx)))return Promise.resolve(N);return await p.Event.toPromise(j.onDidAddConnection),await this.b(j)}}e.$ki=C;var B;(function(z){function j(G,he,re){const _=G,M=re&&re.disableMarshalling,F=new Map;for(const U in _)V(U)&&F.set(U,p.Event.buffer(_[U],!0,void 0,he));return new class{listen(U,q,Q){const J=F.get(q);if(J)return J;const H=_[q];if(typeof H=="function"){if(oe(q))return H.call(_,Q);if(V(q))return F.set(q,p.Event.buffer(_[q],!0,void 0,he)),F.get(q)}throw new I.$ab(`Event not found: ${q}`)}call(U,q,Q){const J=_[q];if(typeof J=="function"){if(!M&&Array.isArray(Q))for(let ne=0;ne<Q.length;ne++)Q[ne]=(0,g.$_h)(Q[ne]);let H=J.apply(_,Q);return H instanceof Promise||(H=Promise.resolve(H)),H}throw new I.$ab(`Method not found: ${q}`)}}}z.fromService=j;function N(G,he){const re=he&&he.disableMarshalling;return new Proxy({},{get(_,M){if(typeof M=="string")return he?.properties?.has(M)?he.properties.get(M):oe(M)?function(F){return G.listen(M,F)}:V(M)?G.listen(M):async function(...F){let U;he&&!(0,m.$lg)(he.context)?U=[he.context,...F]:U=F;const q=await G.call(M,U);return re?q:(0,g.$_h)(q)};throw new I.$ab(`Property not found: ${String(M)}`)}})}z.toService=N;function V(G){return G[0]==="o"&&G[1]==="n"&&h.$Cf(G.charCodeAt(2))}function oe(G){return/^onDynamic/.test(G)&&h.$Cf(G.charCodeAt(9))}})(B||(e.ProxyChannel=B={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function X(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){const j=z.toString();if(j!=="[object Object]")return j}return z}function ae(z){return Array.isArray(z)?z.map(X):X(z)}function K(z,j,N,V,oe,G,he){he=ae(he);const re=ee[oe],_=re[V%re.length];let M=[`%c[${z}]%c[${String(j).padStart(7," ")}]%c[len: ${String(N).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${_}`];/\($/.test(G)?(M=M.concat(he),M.push(")")):M.push(he),console.log.apply(console,M)}class te{constructor(j,N){this.d=j,this.f=N,this.a=0,this.b=0}logOutgoing(j,N,V,oe,G){this.b+=j,K(this.d,this.b,j,N,V,oe,G)}logIncoming(j,N,V,oe,G){this.a+=j,K(this.f,this.a,j,N,V,oe,G)}}e.$li=te}),define(le[154],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DX=void 0;class n{constructor(E,D){this.a=E,this.onMessage=D}send(E){try{this.a.send("vscode:message",E.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$DX=n}),define(le[155],ue([0,1,16,4,44]),function(Y,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BX=e.$AX=void 0;class D{constructor(p){this.a=p,this.onMessage=r.Event.fromDOMEventEmitter(this.a,"message",a=>a.data?n.$Le.wrap(a.data):n.$Le.alloc(0)),p.start()}send(p){this.a.postMessage(p.buffer)}disconnect(){this.a.close()}}e.$AX=D;class T extends E.$hi{constructor(p,a){const g=new D(p);super(g,a),this.b=g}dispose(){this.b.disconnect(),super.dispose()}}e.$BX=T}),define(le[117],ue([0,1,16,4,2,44]),function(Y,e,n,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$pi=e.$oi=e.$ni=e.ProtocolConstants=e.$mi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(T||(e.SocketDiagnosticsEventType=T={}));var I;(function(s){s.enableDiagnostics=!1,s.records=[];const c=new WeakMap;let l=0;function k(R,L){if(!c.has(R)){const A=String(++l);c.set(R,A)}return c.get(R)}function y(R,L,A,O){if(!s.enableDiagnostics)return;const W=k(R,L);if(O instanceof n.$Le||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const x=n.$Le.alloc(O.byteLength);x.set(O),s.records.push({timestamp:Date.now(),id:W,label:L,type:A,buff:x})}else s.records.push({timestamp:Date.now(),id:W,label:L,type:A,data:O})}s.traceSocketEvent=y})(I||(e.SocketDiagnostics=I={}));var p;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p||(e.SocketCloseEventType=p={}));let a=null;function g(){return a||(a=n.$Le.alloc(0)),a}class h{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(c){this.a.push(c),this.b+=c.byteLength}read(c){return this.c(c,!0)}peek(c){return this.c(c,!1)}c(c,l){if(c===0)return g();if(c>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===c){const L=this.a[0];return l&&(this.a.shift(),this.b-=c),L}if(this.a[0].byteLength>c){const L=this.a[0].slice(0,c);return l&&(this.a[0]=this.a[0].slice(c),this.b-=c),L}const k=n.$Le.alloc(c);let y=0,R=0;for(;c>0;){const L=this.a[R];if(L.byteLength>c){const A=L.slice(0,c);k.set(A,y),y+=c,l&&(this.a[R]=L.slice(c),this.b-=c),c-=c}else k.set(L,y),y+=L.byteLength,l?(this.a.shift(),this.b-=L.byteLength):R++,c-=L.byteLength}return k}}e.$mi=h;var m;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(m||(m={}));function w(s){switch(s){case m.None:return"None";case m.Regular:return"Regular";case m.Control:return"Control";case m.Ack:return"Ack";case m.Disconnect:return"Disconnect";case m.ReplayRequest:return"ReplayRequest";case m.Pause:return"PauseWriting";case m.Resume:return"ResumeWriting";case m.KeepAlive:return"KeepAlive"}}var f;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(f||(e.ProtocolConstants=f={}));class d{constructor(c,l,k,y){this.type=c,this.id=l,this.ack=k,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends E.$Tc{constructor(c){super(),this.f=this.B(new r.$je),this.onMessage=this.f.event,this.g={readHead:!0,readLen:f.HeaderLength,messageType:m.None,id:0,ack:0},this.a=c,this.b=!1,this.c=new h,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(c);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent(T.ProtocolHeaderRead,{messageType:w(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const k=this.g.messageType,y=this.g.id,R=this.g.ack;if(this.g.readHead=!0,this.g.readLen=f.HeaderLength,this.g.messageType=m.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(T.ProtocolMessageRead,l),this.f.fire(new d(k,y,R,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class b{constructor(c){this.k=null,this.a=!1,this.b=!1,this.c=c,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(c){if(this.a)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=n.$Le.alloc(f.HeaderLength);l.writeUInt8(c.type,0),l.writeUInt32BE(c.id,1),l.writeUInt32BE(c.ack,5),l.writeUInt32BE(c.data.byteLength,9),this.c.traceSocketEvent(T.ProtocolHeaderWrite,{messageType:w(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this.c.traceSocketEvent(T.ProtocolMessageWrite,c.data),this.j(l,c.data)}g(c,l){const k=this.f===0;return this.d.push(c,l),this.f+=c.byteLength+l.byteLength,k}h(){const c=n.$Le.concat(this.d,this.f);return this.d.length=0,this.f=0,c}j(c,l){this.g(c,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const c=this.h();this.c.traceSocketEvent(T.ProtocolWrite,{byteLength:c.byteLength}),this.c.write(c)}}class $ extends E.$Tc{constructor(c){super(),this.f=new r.$je,this.onMessage=this.f.event,this.g=new r.$je,this.onDidDispose=this.g.event,this.a=c,this.b=this.B(new b(this.a)),this.c=this.B(new v(this.a)),this.B(this.c.onMessage(l=>{l.type===m.Regular&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(c){this.b.write(new d(m.Regular,0,0,c))}}e.$ni=$;class P extends D.$hi{static fromSocket(c,l){return new P(new $(c),l)}get onDidDispose(){return this.b.onDidDispose}constructor(c,l,k=null){super(c,l,k),this.b=c}dispose(){super.dispose();const c=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),c.end()}}e.$oi=P;class S{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new r.$je({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(c){this.b?this.d.length>0?this.d.push(c):this.a.fire(c):this.d.push(c)}flushBuffer(){this.d=[]}}e.$pi=S;class t{constructor(c){this.data=c,this.next=null}}class u{constructor(){this.a=null,this.b=null}length(){let c=0,l=this.a;for(;l;)l=l.next,c++;return c}peek(){return this.a?this.a.data:null}toArray(){const c=[];let l=0,k=this.a;for(;k;)c[l++]=k.data,k=k.next;return c}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(c){const l=new t(c);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class i{static{this.a=10}static{this.b=null}static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const c=Date.now();for(let l=0;l<i.a;l++)this.c[l]=c-1e3*l;setInterval(()=>{for(let l=i.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const c=Date.now(),l=(1+i.a)*1e3;let k=0;for(let y=0;y<i.a;y++)c-this.c[y]<=l&&k++;return 1-k/i.a}hasHighLoad(){return this.d()>=.5}}class o{get unacknowledgedCount(){return this.d-this.f}constructor(c){this.v=new S,this.onControlMessage=this.v.event,this.w=new S,this.onMessage=this.w.event,this.x=new S,this.onDidDispose=this.x.event,this.y=new S,this.onSocketClose=this.y.event,this.z=new S,this.onSocketTimeout=this.z.event,this.t=c.loadEstimator??i.getInstance(),this.u=c.sendKeepAlive??!0,this.a=!1,this.c=new u,this.d=0,this.f=0,this.g=null,this.h=0,this.j=0,this.k=0,this.l=null,this.n=0,this.o=Date.now(),this.s=new E.$Sc,this.p=c.socket,this.q=this.s.add(new b(this.p)),this.r=this.s.add(new v(this.p)),this.s.add(this.r.onMessage(l=>this.A(l))),this.s.add(this.p.onClose(l=>this.y.fire(l))),c.initialChunk&&this.r.acceptChunk(c.initialChunk),this.u?this.m=setInterval(()=>{this.E()},f.KeepAliveSendTime):this.m=null}dispose(){this.g&&(clearTimeout(this.g),this.g=null),this.l&&(clearTimeout(this.l),this.l=null),this.m&&(clearInterval(this.m),this.m=null),this.s.dispose()}drain(){return this.q.drain()}sendDisconnect(){if(!this.b){this.b=!0;const c=new d(m.Disconnect,0,0,g());this.q.write(c),this.q.flush()}}sendPause(){const c=new d(m.Pause,0,0,g());this.q.write(c)}sendResume(){const c=new d(m.Resume,0,0,g());this.q.write(c)}pauseSocketWriting(){this.q.pause()}getSocket(){return this.p}getMillisSinceLastIncomingData(){return Date.now()-this.r.lastReadTime}beginAcceptReconnection(c,l){this.a=!0,this.s.dispose(),this.s=new E.$Sc,this.v.flushBuffer(),this.y.flushBuffer(),this.z.flushBuffer(),this.p.dispose(),this.n=0,this.o=Date.now(),this.p=c,this.q=this.s.add(new b(this.p)),this.r=this.s.add(new v(this.p)),this.s.add(this.r.onMessage(k=>this.A(k))),this.s.add(this.p.onClose(k=>this.y.fire(k))),this.r.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.j=this.h;const c=new d(m.Ack,0,this.j,g());this.q.write(c);const l=this.c.toArray();for(let k=0,y=l.length;k<y;k++)this.q.write(l[k]);this.C()}acceptDisconnect(){this.x.fire()}A(c){if(c.ack>this.f){this.f=c.ack;do{const l=this.c.peek();if(l&&l.id<=c.ack)this.c.pop();else break}while(!0)}switch(c.type){case m.None:break;case m.Regular:{if(c.id>this.h)if(c.id!==this.h+1){const l=Date.now();l-this.n>1e4&&(this.n=l,this.q.write(new d(m.ReplayRequest,0,0,g())))}else this.h=c.id,this.k=Date.now(),this.B(),this.w.fire(c.data);break}case m.Control:{this.v.fire(c.data);break}case m.Ack:break;case m.Disconnect:{this.x.fire();break}case m.ReplayRequest:{const l=this.c.toArray();for(let k=0,y=l.length;k<y;k++)this.q.write(l[k]);this.C();break}case m.Pause:{this.q.pause();break}case m.Resume:{this.q.resume();break}case m.KeepAlive:break}}readEntireBuffer(){return this.r.readEntireBuffer()}flush(){this.q.flush()}send(c){const l=++this.d;this.j=this.h;const k=new d(m.Regular,l,this.j,c);this.c.push(k),this.a||(this.q.write(k),this.C())}sendControl(c){const l=new d(m.Control,0,0,c);this.q.write(l)}B(){if(this.h<=this.j||this.l)return;const c=Date.now()-this.k;if(c>=f.AcknowledgeTime){this.D();return}this.l=setTimeout(()=>{this.l=null,this.B()},f.AcknowledgeTime-c+5)}C(){if(this.d<=this.f||this.g||this.a)return;const c=this.c.peek(),l=Date.now()-c.writtenTime,k=Date.now()-this.r.lastReadTime,y=Date.now()-this.o;if(l>=f.TimeoutTime&&k>=f.TimeoutTime&&y>=f.TimeoutTime&&!this.t.hasHighLoad()){this.o=Date.now(),this.z.fire({unacknowledgedMsgCount:this.c.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:k});return}const R=Math.max(f.TimeoutTime-l,f.TimeoutTime-k,f.TimeoutTime-y,500);this.g=setTimeout(()=>{this.g=null,this.C()},R)}D(){if(this.h<=this.j)return;this.j=this.h;const c=new d(m.Ack,0,this.j,g());this.q.write(c)}E(){this.j=this.h;const c=new d(m.KeepAlive,0,this.j,g());this.q.write(c)}}e.$qi=o}),define(le[35],ue([0,1,13,15,11]),function(Y,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xX=void 0;class D{constructor(){this.a=new WeakMap}on(I,p){const a=(g,...h)=>{this.b(I,g)&&p(g,...h)};return this.a.set(p,a),n.ipcMain.on(I,a),this}once(I,p){return n.ipcMain.once(I,(a,...g)=>{this.b(I,a)&&p(a,...g)}),this}handle(I,p){return n.ipcMain.handle(I,(a,...g)=>this.b(I,a)?p(a,...g):Promise.reject(`Invalid channel '${I}' or sender for ipcMain.handle() usage.`)),this}removeHandler(I){return n.ipcMain.removeHandler(I),this}removeListener(I,p){const a=this.a.get(p);return a&&(n.ipcMain.removeListener(I,a),this.a.delete(p)),this}b(I,p){if(!I||!I.startsWith("vscode:"))return(0,r.$Y)(`Refused to handle ipcMain event for channel '${I}' because the channel is unknown.`),!1;const a=p.senderFrame,g=a.url;if(!g||g==="about:blank")return!0;let h="unknown";try{h=new URL(g).host}catch{return(0,r.$Y)(`Refused to handle ipcMain event for channel '${I}' because of a malformed URL '${g}'.`),!1}return h!==E.$Vg?((0,r.$Y)(`Refused to handle ipcMain event for channel '${I}' because of a bad origin of '${h}'.`),!1):a.parent!==null?((0,r.$Y)(`Refused to handle ipcMain event for channel '${I}' because sender of origin '${h}' is not a main frame.`),!1):!0}}e.$xX=new D}),define(le[156],ue([0,1,13,35,153]),function(Y,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yX=D;function D(){r.$xX.on(E.$vX,(I,p,a,g,h)=>{const m=T(I,g,a);m.popup({x:h?h.x:void 0,y:h?h.y:void 0,positioningItem:h?h.positioningItem:void 0,callback:()=>{m&&I.sender.send(E.$wX,p)}})})}function T(I,p,a){const g=new n.Menu;return a.forEach(h=>{let m;h.type==="separator"?m=new n.MenuItem({type:h.type}):Array.isArray(h.submenu)?m=new n.MenuItem({submenu:T(I,p,h.submenu),label:h.label}):m=new n.MenuItem({label:h.label,type:h.type,accelerator:h.accelerator,checked:h.checked,enabled:h.enabled,visible:h.visible,click:(w,f,d)=>I.sender.send(p,h.id,d)}),g.append(m)}),g}}),define(le[157],ue([0,1,35,16,4,2,44,154]),function(Y,e,n,r,E,D,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EX=void 0;function p(g,h){const m=E.Event.fromNodeEventEmitter(n.$xX,h,(f,d)=>({event:f,message:d})),w=E.Event.filter(m,({event:f})=>f.sender.id===g);return E.Event.map(w,({message:f})=>f&&r.$Le.wrap(f))}class a extends T.$gi{static{this.b=new Map}static d(){const h=E.Event.fromNodeEventEmitter(n.$xX,"vscode:hello",({sender:m})=>m);return E.Event.map(h,m=>{const w=m.id;a.b.get(w)?.dispose();const d=new E.$je;a.b.set(w,(0,D.$Rc)(()=>d.fire()));const v=p(w,"vscode:message"),b=E.Event.any(E.Event.signal(p(w,"vscode:disconnect")),d.event);return{protocol:new I.$DX(m,v),onDidClientDisconnect:b}})}constructor(){super(a.d())}}e.$EX=a}),define(le[118],ue([0,1,35,4,33,155]),function(Y,e,n,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FX=void 0,e.$GX=I;class T extends D.$BX{constructor(a,g){super({addEventListener:(h,m)=>a.addListener(h,m),removeEventListener:(h,m)=>a.removeListener(h,m),postMessage:h=>a.postMessage(h),start:()=>a.start(),close:()=>a.close()},g)}}e.$FX=T;async function I(p){if(p.isDestroyed()||p.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const a=(0,E.$Yg)();p.webContents.send("vscode:createMessageChannel",a);const g=r.Event.fromNodeEventEmitter(n.$xX,"vscode:createMessageChannelResult",(m,w)=>({nonce:w,port:m.ports[0]})),{port:h}=await r.Event.toPromise(r.Event.once(r.Event.filter(g,m=>m.nonce===a)));return h}}),define(le[158],ue([0,1,48,8,16,21,148,15,4,2,37,94,79,44]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=e.$dr=void 0,I=Ie(I);class f extends w.$ei{constructor(b){super({send:$=>{try{process.send?.($.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",$=>E.$Le.wrap(Buffer.from($,"base64")))},b),process.once("disconnect",()=>this.dispose())}}e.$dr=f;class d{constructor(b,$){this.i=b,this.j=$,this.c=new Set,this.g=new Map,this.h=new p.$je,this.onDidProcessExit=this.h.event;const P=$&&$.timeout?$.timeout:6e4;this.b=new r.$zh(P),this.d=null,this.f=null}getChannel(b){const $=this;return{call(P,S,t){return $.k(b,P,S,t)},listen(P,S){return $.l(b,P,S)}}}k(b,$,P,S=D.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(S.isCancellationRequested)return Promise.reject(I.$5());this.b.cancel();const t=this.n(b),u=(0,r.$ph)(s=>t.call($,P,s)),i=S.onCancellationRequested(()=>u.cancel()),o=(0,a.$Rc)(()=>u.cancel());return this.c.add(o),u.finally(()=>{i.dispose(),this.c.delete(o),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),u}l(b,$,P){if(!this.b)return p.Event.None;this.b.cancel();let S;const t=new p.$je({onWillAddFirstListener:()=>{S=this.n(b).listen($,P)(t.fire,t),this.c.add(S)},onDidRemoveLastListener:()=>{this.c.delete(S),S.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return t.event}get m(){if(!this.f){const b=this.j&&this.j.args?this.j.args:[],$=Object.create(null);$.env={...(0,g.$ao)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&($.env={...$.env,...this.j.env}),this.j&&this.j.freshExecArgv&&($.execArgv=[]),this.j&&typeof this.j.debug=="number"&&($.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&($.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),$.execArgv===void 0&&($.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l)).filter(l=>!l.startsWith("--vscode-"))),(0,m.$im)($.env),this.d=(0,n.fork)(this.i,b,$);const P=new p.$je,t=p.Event.fromNodeEventEmitter(this.d,"message",l=>l)(l=>{if((0,T.$_q)(l)){(0,T.log)(l,`IPC Library: ${this.j.serverName}`);return}P.fire(E.$Le.wrap(Buffer.from(l,"base64")))}),u=this.j.useQueue?(0,h.$vm)(this.d):this.d,i=l=>this.d&&this.d.connected&&u.send(l.buffer.toString("base64")),o=P.event,s={send:i,onMessage:o};this.f=new w.$fi(s);const c=()=>this.o();process.once("exit",c),this.d.on("error",l=>console.warn('IPC "'+this.j.serverName+'" errored with '+l)),this.d.on("exit",(l,k)=>{process.removeListener("exit",c),t.dispose(),this.c.forEach(y=>(0,a.$Oc)(y)),this.c.clear(),l!==0&&k!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+l+" and signal "+k),this.b?.cancel(),this.o(),this.h.fire({code:l,signal:k})})}return this.f}n(b){let $=this.g.get(b);return $||($=this.m.getChannel(b),this.g.set(b,$)),$}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$er=d}),define(le[119],ue([0,1,8,4,2,82,12]),function(Y,e,n,r,E,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=e.StorageState=e.StorageHint=void 0,e.$_p=p;var I;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function p(m){const w=m;return w?.changed instanceof Map||w?.deleted instanceof Set}var a;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(a||(e.StorageState=a={}));class g extends E.$Tc{static{this.a=100}constructor(w,f=Object.create(null)){super(),this.r=w,this.s=f,this.b=this.B(new r.$me),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new n.$Ah(g.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(w=>this.u(w)))}u(w){this.b.pause();try{w.changed?.forEach((f,d)=>this.w(d,f)),w.deleted?.forEach(f=>this.w(f,void 0))}finally{this.b.resume()}}w(w,f){if(this.c===a.Closed)return;let d=!1;(0,T.$lg)(f)?d=this.f.delete(w):this.f.get(w)!==f&&(this.f.set(w,f),d=!0),d&&this.b.fire({key:w,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(w,f){const d=this.f.get(w);return(0,T.$lg)(d)?f:d}getBoolean(w,f){const d=this.get(w);return(0,T.$lg)(d)?f:d==="true"}getNumber(w,f){const d=this.get(w);return(0,T.$lg)(d)?f:parseInt(d,10)}getObject(w,f){const d=this.get(w);return(0,T.$lg)(d)?f:(0,D.$$h)(d)}async set(w,f,d=!1){if(this.c===a.Closed)return;if((0,T.$lg)(f))return this.delete(w,d);const v=(0,T.$eg)(f)||Array.isArray(f)?(0,D.$0h)(f):String(f);if(this.f.get(w)!==v)return this.f.set(w,v),this.j.set(w,v),this.h.delete(w),this.b.fire({key:w,external:d}),this.D()}async delete(w,f=!1){if(!(this.c===a.Closed||!this.f.delete(w)))return this.h.has(w)||this.h.add(w),this.j.delete(w),this.b.fire({key:w,external:f}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const w={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(w).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(w){if(!(this.c===a.Closed||this.m))return this.D(w)}async D(w){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),w)}async whenFlushed(){if(this.z)return new Promise(w=>this.n.push(w))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}e.$aq=g;class h{constructor(){this.onDidChangeItemsExternal=r.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(w){w.insert?.forEach((f,d)=>this.a.set(d,f)),w.delete?.forEach(f=>this.a.delete(f))}async optimize(){}async close(){}}e.$bq=h}),define(le[159],ue([0,1,26,8,4,31,9,23]),function(Y,e,n,r,E,D,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3X=void 0,n=Ie(n);class p{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return E.Event.None}static{this.a=2e3}static{this.b=256}constructor(h,m=Object.create(null)){this.g=h,this.h=m,this.c=(0,T.$mc)(this.g),this.d=new a(this.h.logging),this.f=this.n(this.g)}async getItems(){const h=await this.f,m=new Map;return(await this.s(h,"SELECT * FROM ItemTable")).forEach(f=>m.set(f.key,f.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${m.size} rows`),m}async updateItems(h){const m=await this.f;return this.j(m,h)}j(h,m){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${m.insert?(0,D.$xc)(m.insert):"0"}), delete(${m.delete?(0,D.$yc)(m.delete):"0"})`),this.t(h,()=>{const w=m.insert,f=m.delete;if(w&&w.size>0){const d=[];d.push([]);let v=0;w.forEach((b,$)=>{let P=d[v];P.length>p.b&&(v++,P=[],d.push(P)),P.push($,b)}),d.forEach(b=>{this.u(h,`INSERT INTO ItemTable VALUES ${new Array(b.length/2).fill("(?,?)").join(",")}`,$=>$.run(b),()=>{const $=[];let P=0;return w.forEach((S,t)=>{$.push(t),P+=S.length}),`Keys: ${$.join(", ")} Length: ${P}`})})}if(f&&f.size){const d=[];d.push([]);let v=0;f.forEach(b=>{let $=d[v];$.length>p.b&&(v++,$=[],d.push($)),$.push(b)}),d.forEach(b=>{this.u(h,`DELETE FROM ItemTable WHERE key IN (${new Array(b.length).fill("?").join(",")})`,$=>$.run(b),()=>{const $=[];return f.forEach(P=>{$.push(P)}),`Keys: ${$.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const h=await this.f;return this.q(h,"VACUUM")}async close(h){this.d.trace(`[storage ${this.c}] close()`);const m=await this.f;return this.k(m,h)}k(h,m){return new Promise((w,f)=>{h.db.close(d=>(d&&this.o(h,`[storage ${this.c}] close(): ${d}`),this.g===p.IN_MEMORY_PATH?w():!h.isErroneous&&!h.isInMemory?this.l().then(w,v=>(this.d.error(`[storage ${this.c}] backup(): ${v}`),w())):typeof m=="function"?n.promises.unlink(this.g).then(()=>this.p(this.g).then(v=>{const b=()=>this.k(v,void 0);return this.j(v,{insert:m()}).then(()=>b(),$=>(b(),Promise.reject($)))})).then(w,f):f(d||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const h=this.m(this.g);return I.Promises.copy(this.g,h,{preserveSymlinks:!1})}m(h){return`${h}.backup`}async checkIntegrity(h){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${h})`);const m=await this.f,w=await this.r(m,h?"PRAGMA integrity_check":"PRAGMA quick_check"),f=h?w.integrity_check:w.quick_check;return m.isErroneous?`${f} (last error: ${m.lastError})`:m.isInMemory?`${f} (in-memory!)`:f}async n(h,m=!0){this.d.trace(`[storage ${this.c}] open(${h}, retryOnBusy: ${m})`);try{return await this.p(h)}catch(w){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${w}`),w.code==="SQLITE_BUSY"&&m)return await(0,r.$Dh)(p.a),this.n(h,!1);try{await n.promises.unlink(h);try{await I.Promises.rename(this.m(h),h,!1)}catch{}return await this.p(h)}catch(f){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${f}`),this.p(p.IN_MEMORY_PATH)}}}o(h,m){h.isErroneous=!0,h.lastError=m,this.d.error(m)}p(h){return new Promise((m,w)=>{new Promise((f,d)=>{Y(["@vscode/sqlite3"],f,d)}).then(Ie).then(f=>{const d={db:new(this.d.isTracing?f.verbose().Database:f.Database)(h,v=>v?d.db&&v.code!=="SQLITE_CANTOPEN"?d.db.close(()=>w(v)):w(v):this.q(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>m(d),b=>d.db.close(()=>w(b)))),isInMemory:h===p.IN_MEMORY_PATH};d.db.on("error",v=>this.o(d,`[storage ${this.c}] Error (event): ${v}`)),this.d.isTracing&&d.db.on("trace",v=>this.d.trace(`[storage ${this.c}] Trace (event): ${v}`))},w)})}q(h,m){return new Promise((w,f)=>{h.db.exec(m,d=>d?(this.o(h,`[storage ${this.c}] exec(): ${d}`),f(d)):w())})}r(h,m){return new Promise((w,f)=>{h.db.get(m,(d,v)=>d?(this.o(h,`[storage ${this.c}] get(): ${d}`),f(d)):w(v))})}s(h,m){return new Promise((w,f)=>{h.db.all(m,(d,v)=>d?(this.o(h,`[storage ${this.c}] all(): ${d}`),f(d)):w(v))})}t(h,m){return new Promise((w,f)=>{h.db.serialize(()=>{h.db.run("BEGIN TRANSACTION"),m(),h.db.run("END TRANSACTION",d=>d?(this.o(h,`[storage ${this.c}] transaction(): ${d}`),f(d)):w())})})}u(h,m,w,f){const d=h.db.prepare(m),v=b=>{this.o(h,`[storage ${this.c}] prepare(): ${b} (${m}). Details: ${f()}`)};d.on("error",v),w(d),d.finalize(b=>{b&&v(b),d.removeListener("error",v)})}}e.$3X=p;class a{static{this.a="VSCODE_TRACE_STORAGE"}constructor(h){h&&typeof h.logTrace=="function"&&process.env[a.a]&&(this.b=h.logTrace),h&&typeof h.logError=="function"&&(this.c=h.logError)}get isTracing(){return!!this.b}trace(h){this.b?.(h)}error(h){this.c?.(h)}}}),define(le[10],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=E,e.localize2=T;const n=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function r(I,p){let a;return p.length===0?a=I:a=I.replace(/\{(\d+)\}/g,(g,h)=>{const m=h[0],w=p[m];let f=g;return typeof w=="string"?f=w:(typeof w=="number"||typeof w=="boolean"||w===void 0||w===null)&&(f=String(w)),f}),n&&(a="\uFF3B"+a.replace(/[aouei]/g,"$&$&")+"\uFF3D"),a}function E(I,p,...a){return r(typeof I=="number"?D(I,p):p,a)}function D(I,p){const a=globalThis._VSCODE_NLS_MESSAGES?.[I];if(typeof a!="string"){if(typeof p=="string")return p;throw new Error(`!!! NLS MISSING: ${I} !!!`)}return a}function T(I,p,...a){let g;typeof I=="number"?g=D(I,p):g=p;const h=r(g,a);return{value:h,original:p===g?h:r(p,a)}}}),define(le[160],ue([0,1,10]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=a,e.$Ym=g,e.$Zm=h;const r=60,E=r*60,D=E*24,T=D*7,I=D*30,p=D*365;function a(m,w,f,d){typeof m!="number"&&(m=m.getTime());const v=Math.round((new Date().getTime()-m)/1e3);if(v<-30)return(0,n.localize)(12817,null,a(new Date().getTime()+v*1e3,!1));if(!d&&v<30)return(0,n.localize)(12818,null);let b;return v<r?(b=v,w?b===1?f?(0,n.localize)(12819,null,b):(0,n.localize)(12820,null,b):f?(0,n.localize)(12821,null,b):(0,n.localize)(12822,null,b):b===1?f?(0,n.localize)(12823,null,b):(0,n.localize)(12824,null,b):f?(0,n.localize)(12825,null,b):(0,n.localize)(12826,null,b)):v<E?(b=Math.floor(v/r),w?b===1?f?(0,n.localize)(12827,null,b):(0,n.localize)(12828,null,b):f?(0,n.localize)(12829,null,b):(0,n.localize)(12830,null,b):b===1?f?(0,n.localize)(12831,null,b):(0,n.localize)(12832,null,b):f?(0,n.localize)(12833,null,b):(0,n.localize)(12834,null,b)):v<D?(b=Math.floor(v/E),w?b===1?f?(0,n.localize)(12835,null,b):(0,n.localize)(12836,null,b):f?(0,n.localize)(12837,null,b):(0,n.localize)(12838,null,b):b===1?f?(0,n.localize)(12839,null,b):(0,n.localize)(12840,null,b):f?(0,n.localize)(12841,null,b):(0,n.localize)(12842,null,b)):v<T?(b=Math.floor(v/D),w?b===1?(0,n.localize)(12843,null,b):(0,n.localize)(12844,null,b):b===1?(0,n.localize)(12845,null,b):(0,n.localize)(12846,null,b)):v<I?(b=Math.floor(v/T),w?b===1?f?(0,n.localize)(12847,null,b):(0,n.localize)(12848,null,b):f?(0,n.localize)(12849,null,b):(0,n.localize)(12850,null,b):b===1?f?(0,n.localize)(12851,null,b):(0,n.localize)(12852,null,b):f?(0,n.localize)(12853,null,b):(0,n.localize)(12854,null,b)):v<p?(b=Math.floor(v/I),w?b===1?f?(0,n.localize)(12855,null,b):(0,n.localize)(12856,null,b):f?(0,n.localize)(12857,null,b):(0,n.localize)(12858,null,b):b===1?f?(0,n.localize)(12859,null,b):(0,n.localize)(12860,null,b):f?(0,n.localize)(12861,null,b):(0,n.localize)(12862,null,b)):(b=Math.floor(v/p),w?b===1?f?(0,n.localize)(12863,null,b):(0,n.localize)(12864,null,b):f?(0,n.localize)(12865,null,b):(0,n.localize)(12866,null,b):b===1?f?(0,n.localize)(12867,null,b):(0,n.localize)(12868,null,b):f?(0,n.localize)(12869,null,b):(0,n.localize)(12870,null,b))}function g(m,w){const f=Math.abs(m/1e3);return f<1?w?(0,n.localize)(12871,null,m):(0,n.localize)(12872,null,m):f<r?w?(0,n.localize)(12873,null,Math.round(m)/1e3):(0,n.localize)(12874,null,Math.round(m)/1e3):f<E?w?(0,n.localize)(12875,null,Math.round(m/(1e3*r))):(0,n.localize)(12876,null,Math.round(m/(1e3*r))):f<D?w?(0,n.localize)(12877,null,Math.round(m/(1e3*E))):(0,n.localize)(12878,null,Math.round(m/(1e3*E))):(0,n.localize)(12879,null,Math.round(m/(1e3*D)))}function h(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(le[54],ue([0,1,20,12,10]),function(Y,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=p,e.$oj=a,e.$pj=g,n=Ie(n),r=Ie(r),E=Ie(E);function D(h,m){return m&&(h.stack||h.stacktrace)?E.localize(12811,null,I(h),T(h.stack)||T(h.stacktrace)):I(h)}function T(h){return Array.isArray(h)?h.join(`
`):h}function I(h){return h.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${h.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof h.code=="string"&&typeof h.errno=="number"&&typeof h.syscall=="string"?E.localize(12812,null,h.message):h.message||E.localize(12813,null)}function p(h=null,m=!1){if(!h)return E.localize(12814,null);if(Array.isArray(h)){const w=n.$Gb(h),f=p(w[0],m);return w.length>1?E.localize(12815,null,f,w.length):f}if(r.$cg(h))return h;if(h.detail){const w=h.detail;if(w.error)return D(w.error,m);if(w.exception)return D(w.exception,m)}return h.stack?D(h,m):h.message?h.message:E.localize(12816,null)}function a(h){const m=h;return m instanceof Error&&Array.isArray(m.actions)}function g(h,m){let w;return typeof h=="string"?w=new Error(h):w=h,w.actions=m,w}}),define(le[161],ue([0,1,10,43]),function(Y,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=E;function E(D){switch(D){case r.ParseErrorCode.InvalidSymbol:return(0,n.localize)(12802,null);case r.ParseErrorCode.InvalidNumberFormat:return(0,n.localize)(12803,null);case r.ParseErrorCode.PropertyNameExpected:return(0,n.localize)(12804,null);case r.ParseErrorCode.ValueExpected:return(0,n.localize)(12805,null);case r.ParseErrorCode.ColonExpected:return(0,n.localize)(12806,null);case r.ParseErrorCode.CommaExpected:return(0,n.localize)(12807,null);case r.ParseErrorCode.CloseBraceExpected:return(0,n.localize)(12808,null);case r.ParseErrorCode.CloseBracketExpected:return(0,n.localize)(12809,null);case r.ParseErrorCode.EndOfFileExpected:return(0,n.localize)(12810,null);default:return""}}}),define(le[162],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ohb=n,e.$Phb=r;function n(E){return E&&E.hasOwnProperty("folderUri")}function r(E){return E&&E.hasOwnProperty("workspace")}}),define(le[163],ue([0,1,7]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pec=r,e.$Qec=E,e.$Rec=D;function r(T){return typeof T?.backupFolder=="string"}function E(T){let I=[];try{Array.isArray(T.workspaces)&&(I=T.workspaces.map(p=>({workspace:{id:p.id,configPath:n.URI.parse(p.configURIPath)},remoteAuthority:p.remoteAuthority})))}catch{}return I}function D(T){let I=[];try{Array.isArray(T.folders)&&(I=T.folders.map(p=>({folderUri:n.URI.parse(p.folderUri),remoteAuthority:p.remoteAuthority})))}catch{}return I}}),define(le[164],ue([0,1,39,15,10]),function(Y,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.TokenType=void 0;var D;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(D||(e.TokenType=D={}));function T(...g){switch(g.length){case 1:return(0,E.localize)(11418,null,g[0]);case 2:return(0,E.localize)(11419,null,g[0],g[1]);case 3:return(0,E.localize)(11420,null,g[0],g[1],g[2]);default:return}}const I=(0,E.localize)(11421,null),p=(0,E.localize)(11422,null);class a{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(h){switch(h.type){case D.LParen:return"(";case D.RParen:return")";case D.Neg:return"!";case D.Eq:return h.isTripleEq?"===":"==";case D.NotEq:return h.isTripleEq?"!==":"!=";case D.Lt:return"<";case D.LtEq:return"<=";case D.Gt:return">=";case D.GtEq:return">=";case D.RegexOp:return"=~";case D.RegexStr:return h.lexeme;case D.True:return"true";case D.False:return"false";case D.In:return"in";case D.Not:return"not";case D.And:return"&&";case D.Or:return"||";case D.Str:return h.lexeme;case D.QuotedStr:return h.lexeme;case D.Error:return h.lexeme;case D.EOF:return"EOF";default:throw(0,r.$7)(`unhandled token type: ${JSON.stringify(h)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(h=>h.charCodeAt(0)))}static{this.b=new Map([["not",D.Not],["in",D.In],["false",D.False],["true",D.True]])}get errors(){return this.g}reset(h){return this.c=h,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case n.CharCode.OpenParen:this.k(D.LParen);break;case n.CharCode.CloseParen:this.k(D.RParen);break;case n.CharCode.ExclamationMark:if(this.h(n.CharCode.Equals)){const m=this.h(n.CharCode.Equals);this.f.push({type:D.NotEq,offset:this.d,isTripleEq:m})}else this.k(D.Neg);break;case n.CharCode.SingleQuote:this.o();break;case n.CharCode.Slash:this.q();break;case n.CharCode.Equals:if(this.h(n.CharCode.Equals)){const m=this.h(n.CharCode.Equals);this.f.push({type:D.Eq,offset:this.d,isTripleEq:m})}else this.h(n.CharCode.Tilde)?this.k(D.RegexOp):this.l(T("==","=~"));break;case n.CharCode.LessThan:this.k(this.h(n.CharCode.Equals)?D.LtEq:D.Lt);break;case n.CharCode.GreaterThan:this.k(this.h(n.CharCode.Equals)?D.GtEq:D.Gt);break;case n.CharCode.Ampersand:this.h(n.CharCode.Ampersand)?this.k(D.And):this.l(T("&&"));break;case n.CharCode.Pipe:this.h(n.CharCode.Pipe)?this.k(D.Or):this.l(T("||"));break;case n.CharCode.Space:case n.CharCode.CarriageReturn:case n.CharCode.Tab:case n.CharCode.LineFeed:case n.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(D.EOF),Array.from(this.f)}h(h){return this.r()||this.c.charCodeAt(this.e)!==h?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?n.CharCode.Null:this.c.charCodeAt(this.e)}k(h){this.f.push({type:h,offset:this.d})}l(h){const m=this.d,w=this.c.substring(this.d,this.e),f={type:D.Error,offset:this.d,lexeme:w};this.g.push({offset:m,lexeme:w,additionalInfo:h}),this.f.push(f)}n(){this.m.lastIndex=this.d;const h=this.m.exec(this.c);if(h){this.e=this.d+h[0].length;const m=this.c.substring(this.d,this.e),w=a.b.get(m);w?this.k(w):this.f.push({type:D.Str,lexeme:m,offset:this.d})}}o(){for(;this.j()!==n.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:D.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let h=this.e,m=!1,w=!1;for(;;){if(h>=this.c.length){this.e=h,this.l(p);return}const d=this.c.charCodeAt(h);if(m)m=!1;else if(d===n.CharCode.Slash&&!w){h++;break}else d===n.CharCode.OpenSquareBracket?w=!0:d===n.CharCode.Backslash?m=!0:d===n.CharCode.CloseSquareBracket&&(w=!1);h++}for(;h<this.c.length&&a.a.has(this.c.charCodeAt(h));)h++;this.e=h;const f=this.c.substring(this.d,this.e);this.f.push({type:D.RegexStr,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$xj=a}),define(le[165],ue([0,1,4,2]),function(Y,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=e.$Vo=void 0;class E{constructor(){this.a=new n.$je,this.b=new n.$je,this.c=new n.$je,this.d=new n.$je}static{this.ChannelName="extensionhostdebugservice"}call(I,p,a){switch(p){case"close":return Promise.resolve(this.a.fire({sessionId:a[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:a[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:a[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:a[0],port:a[1],subId:a[2]}))}throw new Error("Method not implemented.")}listen(I,p,a){switch(p){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Vo=E;class D extends r.$Tc{constructor(I){super(),this.b=I}reload(I){this.b.call("reload",[I])}get onReload(){return this.b.listen("reload")}close(I){this.b.call("close",[I])}get onClose(){return this.b.listen("close")}attachSession(I,p,a){this.b.call("attach",[I,p,a])}get onAttachSession(){return this.b.listen("attach")}terminateSession(I,p){this.b.call("terminate",[I,p])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(I,p){return this.b.call("openExtensionDevelopmentHostWindow",[I,p])}}e.$Wo=D}),define(le[166],ue([0,1,160,53,11,9,36,18,7]),function(Y,e,n,r,E,D,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=e.$1m=void 0,e.$3m=g,e.$4m=h,e.$1m=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,D.$lc)(E.$Wg.asFileUri("").fsPath)}get userHome(){return p.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return p.URI.file((0,D.$ic)(this.userDataPath,"User"))}get tmpDir(){return p.URI.file(this.b.tmpDir)}get cacheHome(){return p.URI.file(this.userDataPath)}get stateResource(){return(0,I.$dh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:E.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$dh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const w=(0,n.$Zm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.$ic)(this.userDataPath,"logs",w)}return p.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$dh)(p.URI.file((0,D.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$dh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$dh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$dh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=T.env.VSCODE_PORTABLE;return w?p.URI.file((0,D.$ic)(w,"argv.json")):(0,I.$dh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return p.URI.file((0,D.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const w=this.args["builtin-extensions-dir"];return w?(0,D.$jc)(w):(0,D.$gc)((0,D.$ic)(E.$Wg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const w=this.args["extensions-download-dir"];return w?p.URI.file((0,D.$jc)(w)):p.URI.file((0,D.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const w=this.args["extensions-dir"];if(w)return(0,D.$jc)(w);const f=T.env.VSCODE_EXTENSIONS;if(f)return f;const d=T.env.VSCODE_PORTABLE;return d?(0,D.$ic)(d,"extensions"):(0,I.$dh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const w=this.args.extensionDevelopmentPath;if(Array.isArray(w))return w.map(f=>/^[^:/?#]+?:\/\//.test(f)?p.URI.parse(f):p.URI.file((0,D.$gc)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const w=this.args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?p.URI.parse(w):p.URI.file((0,D.$gc)(w))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const w=this.args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return g(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(w=>!e.$1m.test(w))}get extensionLogLevel(){const w=[];for(const f of this.args.log||[]){const d=e.$1m.exec(f);d&&d[1]&&d[2]&&w.push([d[1],d[2]])}return w.length?w:void 0}get serviceMachineIdResource(){return(0,I.$dh)(p.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const w=T.env.VSCODE_PORTABLE;return w?p.URI.file((0,D.$ic)(w,"policy.json")):(0,I.$dh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(w){this.args.continueOn=w}get args(){return this.a}constructor(w,f,d){this.a=w,this.b=f,this.c=d,this.editSessionId=this.args.editSessionId}}e.$2m=a,Ee([r.$7h],a.prototype,"appRoot",null),Ee([r.$7h],a.prototype,"userHome",null),Ee([r.$7h],a.prototype,"userDataPath",null),Ee([r.$7h],a.prototype,"appSettingsHome",null),Ee([r.$7h],a.prototype,"tmpDir",null),Ee([r.$7h],a.prototype,"cacheHome",null),Ee([r.$7h],a.prototype,"stateResource",null),Ee([r.$7h],a.prototype,"userRoamingDataHome",null),Ee([r.$7h],a.prototype,"userDataSyncHome",null),Ee([r.$7h],a.prototype,"sync",null),Ee([r.$7h],a.prototype,"machineSettingsResource",null),Ee([r.$7h],a.prototype,"workspaceStorageHome",null),Ee([r.$7h],a.prototype,"localHistoryHome",null),Ee([r.$7h],a.prototype,"keyboardLayoutResource",null),Ee([r.$7h],a.prototype,"argvResource",null),Ee([r.$7h],a.prototype,"isExtensionDevelopment",null),Ee([r.$7h],a.prototype,"untitledWorkspacesHome",null),Ee([r.$7h],a.prototype,"builtinExtensionsPath",null),Ee([r.$7h],a.prototype,"extensionsPath",null),Ee([r.$7h],a.prototype,"extensionDevelopmentLocationURI",null),Ee([r.$7h],a.prototype,"extensionDevelopmentKind",null),Ee([r.$7h],a.prototype,"extensionTestsLocationURI",null),Ee([r.$7h],a.prototype,"debugExtensionHost",null),Ee([r.$7h],a.prototype,"logLevel",null),Ee([r.$7h],a.prototype,"extensionLogLevel",null),Ee([r.$7h],a.prototype,"serviceMachineIdResource",null),Ee([r.$7h],a.prototype,"disableTelemetry",null),Ee([r.$7h],a.prototype,"disableWorkspaceTrust",null),Ee([r.$7h],a.prototype,"useInMemorySecretStorage",null),Ee([r.$7h],a.prototype,"policyFile",null);function g(m,w){return h(m["inspect-extensions"],m["inspect-brk-extensions"],5870,w,m.debugId,m.extensionEnvironment)}function h(m,w,f,d,v,b){const P=Number(w||m)||(d?null:f),S=P?!!w:!1;let t;if(b)try{t=JSON.parse(b)}catch{}return{port:P,break:S,debugId:v,env:t}}});var et=this&&this.__importDefault||function(Y){return Y&&Y.__esModule?Y:{default:Y}};define(le[120],ue([0,1,279,3,10]),function(Y,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ym=e.$xm=void 0,e.$zm=I,e.$Am=a,e.$Bm=w,e.$Cm=f,n=et(n);const D={o:(0,E.localize)(11355,null),e:(0,E.localize)(11356,null),t:(0,E.localize)(11357,null)};e.$xm=["tunnel","serve-web"],e.$ym={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,E.localize)(11358,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,E.localize)(11359,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,E.localize)(11360,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,E.localize)(11361,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,E.localize)(11362,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,E.localize)(11363,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,E.localize)(11364,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,E.localize)(11365,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,E.localize)(11366,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,E.localize)(11367,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,E.localize)(11368,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,E.localize)(11369,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,E.localize)(11370,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,E.localize)(11371,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,E.localize)(11372,null)},"show-versions":{type:"boolean",cat:"e",description:(0,E.localize)(11373,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,E.localize)(11374,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,E.localize)(11375,null)},"pre-release":{type:"boolean",cat:"e",description:(0,E.localize)(11376,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,E.localize)(11377,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,E.localize)(11378,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,E.localize)(11379,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,E.localize)(11380,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,E.localize)(11381,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,E.localize)(11382,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,E.localize)(11383,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,E.localize)(11384,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,E.localize)(11385,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,E.localize)(11386,null)},sync:{type:"string",cat:"t",description:(0,E.localize)(11387,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,E.localize)(11388,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,E.localize)(11389,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,E.localize)(11390,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,E.localize)(11391,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,E.localize)(11392,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,E.localize)(11393,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const T={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(d,v,b=T){const $=d.find(l=>l.length>0&&l[0]!=="-"),P={},S=["_"],t=[],u={};let i;for(const l in v){const k=v[l];k.type==="subcommand"?l===$&&(i=k):(k.alias&&(P[l]=k.alias),k.type==="string"||k.type==="string[]"?(S.push(l),k.deprecates&&S.push(...k.deprecates)):k.type==="boolean"&&(t.push(l),k.deprecates&&t.push(...k.deprecates)),k.global&&(u[l]=k))}if(i&&$){const l=u;for(const L in i.options)l[L]=i.options[L];const k=d.filter(L=>L!==$),y=b.getSubcommandReporter?b.getSubcommandReporter($):void 0,R=I(k,l,y);return{[$]:R,_:[]}}const o=(0,n.default)(d,{string:S,boolean:t,alias:P}),s={},c=o;s._=o._.map(l=>String(l)).filter(l=>l.length>0),delete c._;for(const l in v){const k=v[l];if(k.type==="subcommand")continue;k.alias&&delete c[k.alias];let y=c[l];if(k.deprecates)for(const R of k.deprecates)c.hasOwnProperty(R)&&(y||(y=c[R],y&&b.onDeprecatedOption(R,k.deprecationMessage||(0,E.localize)(11394,null,l))),delete c[R]);if(typeof y<"u"){if(k.type==="string[]"){if(Array.isArray(y)||(y=[y]),!k.allowEmptyValue){const R=y.filter(L=>L.length>0);R.length!==y.length&&(b.onEmptyValue(l),y=R.length>0?R:void 0)}}else k.type==="string"&&(Array.isArray(y)?(y=y.pop(),b.onMultipleValues(l,y)):!y&&!k.allowEmptyValue&&(b.onEmptyValue(l),y=void 0));s[l]=y,k.deprecationMessage&&b.onDeprecatedOption(l,k.deprecationMessage)}delete c[l]}for(const l in c)b.onUnknownOption(l);return s}function p(d,v){let b="";return v.args&&(Array.isArray(v.args)?b=` <${v.args.join("> <")}>`:b=` <${v.args}>`),v.alias?`-${v.alias} --${d}${b}`:`--${d}${b}`}function a(d,v){const b=[];for(const $ in d){const P=d[$],S=p($,P);b.push([S,P.description])}return g(b,v)}function g(d,v){const $=d.reduce((t,u)=>Math.max(t,u[0].length),12)+2+1;if(v-$<25)return d.reduce((t,u)=>t.concat([`  ${u[0]}`,`      ${u[1]}`]),[]);const P=v-$-1,S=[];for(const t of d){const u=t[0],i=m(t[1],P),o=h($-u.length-2);S.push("  "+u+o+i[0]);for(let s=1;s<i.length;s++)S.push(h($)+i[s])}return S}function h(d){return" ".repeat(d)}function m(d,v){const b=[];for(;d.length;){const $=d.length<v?d.length:d.lastIndexOf(" ",v),P=d.slice(0,$).trim();d=d.slice($),b.push(P)}return b}function w(d,v,b,$,P){const S=process.stdout.isTTY&&process.stdout.columns||80,t=P?.noInputFiles!==!0?`[${(0,E.localize)(11395,null)}...]`:"",u=[`${d} ${b}`];u.push(""),u.push(`${(0,E.localize)(11396,null)}: ${v} [${(0,E.localize)(11397,null)}]${t}`),u.push(""),P?.noPipe!==!0&&(r.$j?u.push((0,E.localize)(11398,null,v)):u.push((0,E.localize)(11399,null,v)),u.push(""));const i={},o=[];for(const s in $){const c=$[s];if(c.type==="subcommand")c.description&&o.push({command:s,description:c.description});else if(c.description&&c.cat){let l=i[c.cat];l||(i[c.cat]=l={}),l[s]=c}}for(const s in i){const c=s,l=i[c];l&&(u.push(D[c]),u.push(...a(l,S)),u.push(""))}return o.length&&(u.push((0,E.localize)(11400,null)),u.push(...g(o.map(s=>[s.command,s.description]),S)),u.push("")),u.join(`
`)}function f(d,v){return`${d||(0,E.localize)(11401,null)}
${v||(0,E.localize)(11402,null)}
${process.arch}`}});var et=this&&this.__importDefault||function(Y){return Y&&Y.__esModule?Y:{default:Y}};define(le[68],ue([0,1,280,10,120]),function(Y,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=I,e.$Em=p,e.$Fm=a,e.$Gm=g,n=et(n);function D(h,m){const w=(P,S)=>{console.warn((0,r.localize)(11349,null,P,S))},f=P=>{console.warn((0,r.localize)(11350,null,P))},d=(P,S)=>{console.warn((0,r.localize)(11351,null,P,S))},v=P=>({onUnknownOption:S=>{E.$xm.includes(P)||console.warn((0,r.localize)(11352,null,S,P))},onMultipleValues:w,onEmptyValue:f,onDeprecatedOption:d,getSubcommandReporter:E.$xm.includes(P)?v:void 0}),b={onUnknownOption:P=>{console.warn((0,r.localize)(11353,null,P))},onMultipleValues:w,onEmptyValue:f,onDeprecatedOption:d,getSubcommandReporter:v},$=(0,E.$zm)(h,E.$ym,m?b:void 0);return $.goto&&$._.forEach(P=>(0,n.default)(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(P),(0,r.localize)(11354,null))),$}function T(h){const m=h.findIndex(w=>!/^-/.test(w));if(m>-1)return[...h.slice(0,m),...h.slice(m+1)]}function I(h){let[,...m]=h;process.env.VSCODE_DEV&&(m=T(m)||[]);const w=!g(process.env);return D(m,w)}function p(h){let[,,...m]=h;return process.env.VSCODE_DEV&&(m=T(m)||[]),D(m,!0)}function a(h,...m){const w=h.indexOf("--");return w===-1?h.push(...m):h.splice(w,0,...m),h}function g(h){return h.VSCODE_CLI==="1"}}),function(){"use strict";function Y(e,n,r){function E(T,I){const p=D(T,I),a=[p];return e.isAbsolute(p)||a.unshift(r),e.resolve(...a)}function D(T,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const p=process.env.VSCODE_PORTABLE;if(p)return e.join(p,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,I);const g=T["user-data-dir"];if(g)return g;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const h=process.env.USERPROFILE;if(typeof h!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(h,"AppData","Roaming")}break;case"darwin":a=e.join(n.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(n.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,I)}return{getUserDataPath:E}}if(typeof define=="function")define(le[167],ue([121,27,36]),function(e,n,r){return Y(e,n,r.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("os");module.exports=Y(e,n,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[95],ue([0,1,27,166,167]),function(Y,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=void 0,e.$6m=T,e.$7m=I;class D extends r.$2m{constructor(a,g){super(a,{homeDir:(0,n.homedir)(),tmpDir:(0,n.tmpdir)(),userDataDir:(0,E.getUserDataPath)(a,g.nameShort)},g)}}e.$5m=D;function T(p,a){return(0,r.$4m)(p["inspect-ptyhost"],p["inspect-brk-ptyhost"],5877,a,p.extensionEnvironment)}function I(p,a){return(0,r.$4m)(p["inspect-sharedprocess"],p["inspect-brk-sharedprocess"],5879,a,p.extensionEnvironment)}}),define(le[168],ue([0,1,26,27,32]),function(Y,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ngc=D;function D(T){const I=(0,E.$Kg)((0,r.tmpdir)());try{return(0,n.writeFileSync)(I,""),T&&console.log(`Marker file for --wait created: ${I}`),I}catch(p){T&&console.error(`Failed to create marker file for --wait: ${p}`);return}}}),define(le[169],ue([0,1,12,10]),function(Y,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=E;function E(T,I,p,a){try{D(T,I,p,a)}catch(g){T.error(g?.message??g)}return I}function D(T,I,p,a){const g=(h,m,w)=>{const f=h[m];if((0,n.$cg)(f)){const d=f,v=d.length;if(v>1&&d[0]==="%"&&d[v-1]==="%"){const b=d.substr(1,v-2);let $=p[b];$===void 0&&a&&($=a[b]);const P=typeof $=="string"?$:$?.message,S=a?.[b],t=typeof S=="string"?S:S?.message;if(!P){t||T.warn(`[${I.name}]: ${(0,r.localize)(11301,null,b)}`);return}if(w&&(m==="title"||m==="category")&&t&&t!==P){const u={value:P,original:t};h[m]=u}else h[m]=P}}else if((0,n.$eg)(f))for(const d in f)f.hasOwnProperty(d)&&(d==="commands"?g(f,d,!0):g(f,d,w));else if(Array.isArray(f))for(let d=0;d<f.length;d++)g(f,d,w)};for(const h in I)I.hasOwnProperty(h)&&g(I,h)}}),define(le[170],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const n={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(n)}),define(le[83],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=void 0;class n{constructor(E,D=[],T=!1){this.ctor=E,this.staticArguments=D,this.supportsDelayedInstantiation=T}}e.$zi=n}),define(le[171],ue([0,1,83]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ns=D,e.$Os=T;const r=[];var E;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(E||(e.InstantiationType=E={}));function D(I,p,a){p instanceof n.$zi||(p=new n.$zi(p,[],!!a)),r.push([I,p])}function T(){return r}}),define(le[172],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=e.$qr=void 0;class n{constructor(D,T){this.key=D,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.$qr=n;class r{constructor(D){this.b=D,this.a=new Map}roots(){const D=[];for(const T of this.a.values())T.outgoing.size===0&&D.push(T);return D}insertEdge(D,T){const I=this.lookupOrInsertNode(D),p=this.lookupOrInsertNode(T);I.outgoing.set(p.key,p),p.incoming.set(I.key,I)}removeNode(D){const T=this.b(D);this.a.delete(T);for(const I of this.a.values())I.outgoing.delete(T),I.incoming.delete(T)}lookupOrInsertNode(D){const T=this.b(D);let I=this.a.get(T);return I||(I=new n(T,D),this.a.set(T,I)),I}lookup(D){return this.a.get(this.b(D))}isEmpty(){return this.a.size===0}toString(){const D=[];for(const[T,I]of this.a)D.push(`${T}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return D.join(`
`)}findCycleSlow(){for(const[D,T]of this.a){const I=new Set([D]),p=this.c(T,I);if(p)return p}}c(D,T){for(const[I,p]of D.outgoing){if(T.has(I))return[...T,I].join(" -> ");T.add(I);const a=this.c(p,T);if(a)return a;T.delete(I)}}}e.$rr=r}),define(le[6],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=e._util=void 0,e.$Ci=E,e.$Di=D;var n;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function I(p){return p[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=I})(n||(e._util=n={})),e.$Bi=E("instantiationService");function r(T,I,p){I[n.DI_TARGET]===I?I[n.DI_DEPENDENCIES].push({id:T,index:p}):(I[n.DI_DEPENDENCIES]=[{id:T,index:p}],I[n.DI_TARGET]=I)}function E(T){if(n.serviceIds.has(T))return n.serviceIds.get(T);const I=function(p,a,g){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");r(I,p,g)};return I.toString=()=>T,n.serviceIds.set(T,I),I}function D(T){return T}}),define(le[84],ue([0,1,6]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jfc=void 0,e.$Jfc=(0,n.$Ci)("auxiliaryWindowsMainService")}),define(le[69],ue([0,1,6]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sec=void 0,e.$Sec=(0,n.$Ci)("backupMainService")}),define(le[17],ue([0,1,12,7,6]),function(Y,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$9i=void 0,e.$0i=D,e.$$i=T,e.$_i=p,e.$aj=a,e.$bj=g,e.$cj=h,e.$dj=m,e.$ej=f,e.$fj=d,e.$gj=v,n=Ie(n),e.$9i=(0,E.$Ci)("configurationService");function D(b){return b&&typeof b=="object"&&(!b.overrideIdentifier||typeof b.overrideIdentifier=="string")&&(!b.resource||b.resource instanceof r.URI)}function T(b){return b&&typeof b=="object"&&(!b.overrideIdentifiers||Array.isArray(b.overrideIdentifiers))&&!b.overrideIdentifier&&(!b.resource||b.resource instanceof r.URI)}var I;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.USER=2]="USER",b[b.USER_LOCAL=3]="USER_LOCAL",b[b.USER_REMOTE=4]="USER_REMOTE",b[b.WORKSPACE=5]="WORKSPACE",b[b.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",b[b.DEFAULT=7]="DEFAULT",b[b.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function p(b){switch(b){case I.APPLICATION:return"APPLICATION";case I.USER:return"USER";case I.USER_LOCAL:return"USER_LOCAL";case I.USER_REMOTE:return"USER_REMOTE";case I.WORKSPACE:return"WORKSPACE";case I.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case I.DEFAULT:return"DEFAULT";case I.MEMORY:return"MEMORY"}}function a(b){return b.applicationValue!==void 0||b.userValue!==void 0||b.userLocalValue!==void 0||b.userRemoteValue!==void 0||b.workspaceValue!==void 0||b.workspaceFolderValue!==void 0}function g(b,$){const P=Object.create(null);for(const S in b)h(P,S,b[S],$);return P}function h(b,$,P,S){const t=$.split("."),u=t.pop();let i=b;for(let o=0;o<t.length;o++){const s=t[o];let c=i[s];switch(typeof c){case"undefined":c=i[s]=Object.create(null);break;case"object":if(c===null){S(`Ignoring ${$} as ${t.slice(0,o+1).join(".")} is null`);return}break;default:S(`Ignoring ${$} as ${t.slice(0,o+1).join(".")} is ${JSON.stringify(c)}`);return}i=c}if(typeof i=="object"&&i!==null)try{i[u]=P}catch{S(`Ignoring ${$} as ${t.join(".")} is ${JSON.stringify(i)}`)}else S(`Ignoring ${$} as ${t.join(".")} is ${JSON.stringify(i)}`)}function m(b,$){const P=$.split(".");w(b,P)}function w(b,$){const P=$.shift();if($.length===0){delete b[P];return}if(Object.keys(b).indexOf(P)!==-1){const S=b[P];typeof S=="object"&&!Array.isArray(S)&&(w(S,$),Object.keys(S).length===0&&delete b[P])}}function f(b,$,P){function S(i,o){let s=i;for(const c of o){if(typeof s!="object"||s===null)return;s=s[c]}return s}const t=$.split("."),u=S(b,t);return typeof u>"u"?P:u}function d(b,$,P){Object.keys($).forEach(S=>{S!=="__proto__"&&(S in b?n.$eg(b[S])&&n.$eg($[S])?d(b[S],$[S],P):P&&(b[S]=$[S]):b[S]=$[S])})}function v(b){return b.replace(/[\[\]]/g,"")}}),define(le[122],ue([0,1,39,3,25,164,6,10,15]),function(Y,e,n,r,E,D,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Aj=e.$zj=e.ContextKeyExprType=void 0,e.$yj=g,e.$Bj=o,e.$Cj=s,e.$Vj=G;const a=new Map;a.set("false",!1),a.set("true",!0),a.set("isMac",r.$k),a.set("isLinux",r.$l),a.set("isWindows",r.$j),a.set("isWeb",r.$p),a.set("isMacNative",r.$k&&!r.$p),a.set("isEdge",r.$I),a.set("isFirefox",r.$G),a.set("isChrome",r.$F),a.set("isSafari",r.$H);function g(_,M){if(a.get(_)!==void 0)throw(0,p.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");a.set(_,M)}const h=Object.prototype.hasOwnProperty;var m;(function(_){_[_.False=0]="False",_[_.True=1]="True",_[_.Defined=2]="Defined",_[_.Not=3]="Not",_[_.Equals=4]="Equals",_[_.NotEquals=5]="NotEquals",_[_.And=6]="And",_[_.Regex=7]="Regex",_[_.NotRegex=8]="NotRegex",_[_.Or=9]="Or",_[_.In=10]="In",_[_.NotIn=11]="NotIn",_[_.Greater=12]="Greater",_[_.GreaterEquals=13]="GreaterEquals",_[_.Smaller=14]="Smaller",_[_.SmallerEquals=15]="SmallerEquals"})(m||(e.ContextKeyExprType=m={}));const w={regexParsingWithErrorRecovery:!0},f=(0,I.localize)(11432,null),d=(0,I.localize)(11433,null),v=(0,I.localize)(11434,null),b=(0,I.localize)(11435,null),$=(0,I.localize)(11436,null),P=(0,I.localize)(11437,null),S=(0,I.localize)(11438,null),t=(0,I.localize)(11439,null);class u{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(M=w){this.k=M,this.d=new D.$xj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(M){if(M===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:d});return}this.f=this.d.reset(M).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const U=this.D(),q=U.type===D.TokenType.Str?P:void 0;throw this.h.push({message:$,offset:U.offset,lexeme:D.$xj.getLexeme(U),additionalInfo:q}),u.c}return F}catch(F){if(F!==u.c)throw F;return}}l(){return this.m()}m(){const M=[this.o()];for(;this.y(D.TokenType.Or);){const F=this.o();M.push(F)}return M.length===1?M[0]:i.or(...M)}o(){const M=[this.s()];for(;this.y(D.TokenType.And);){const F=this.s();M.push(F)}return M.length===1?M[0]:i.and(...M)}s(){if(this.y(D.TokenType.Neg)){const M=this.D();switch(M.type){case D.TokenType.True:return this.z(),l.INSTANCE;case D.TokenType.False:return this.z(),k.INSTANCE;case D.TokenType.LParen:{this.z();const F=this.l();return this.A(D.TokenType.RParen,b),F?.negate()}case D.TokenType.Str:return this.z(),W.create(M.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",M)}}return this.t()}t(){const M=this.D();switch(M.type){case D.TokenType.True:return this.z(),i.true();case D.TokenType.False:return this.z(),i.false();case D.TokenType.LParen:{this.z();const F=this.l();return this.A(D.TokenType.RParen,b),F}case D.TokenType.Str:{const F=M.lexeme;if(this.z(),this.y(D.TokenType.RegexOp)){const q=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),q.type!==D.TokenType.RegexStr)throw this.B("REGEX",q);const Q=q.lexeme,J=Q.lastIndexOf("/"),H=J===Q.length-1?void 0:this.w(Q.substring(J+1));let ne;try{ne=new RegExp(Q.substring(1,J),H)}catch{throw this.B("REGEX",q)}return ae.create(F,ne)}switch(q.type){case D.TokenType.RegexStr:case D.TokenType.Error:{const Q=[q.lexeme];this.z();let J=this.D(),H=0;for(let Re=0;Re<q.lexeme.length;Re++)q.lexeme.charCodeAt(Re)===n.CharCode.OpenParen?H++:q.lexeme.charCodeAt(Re)===n.CharCode.CloseParen&&H--;for(;!this.E()&&J.type!==D.TokenType.And&&J.type!==D.TokenType.Or;){switch(J.type){case D.TokenType.LParen:H++;break;case D.TokenType.RParen:H--;break;case D.TokenType.RegexStr:case D.TokenType.QuotedStr:for(let Re=0;Re<J.lexeme.length;Re++)J.lexeme.charCodeAt(Re)===n.CharCode.OpenParen?H++:q.lexeme.charCodeAt(Re)===n.CharCode.CloseParen&&H--}if(H<0)break;Q.push(D.$xj.getLexeme(J)),this.z(),J=this.D()}const ne=Q.join(""),de=ne.lastIndexOf("/"),me=de===ne.length-1?void 0:this.w(ne.substring(de+1));let we;try{we=new RegExp(ne.substring(1,de),me)}catch{throw this.B("REGEX",q)}return i.regex(F,we)}case D.TokenType.QuotedStr:{const Q=q.lexeme;this.z();let J=null;if(!(0,E.$af)(Q)){const H=Q.indexOf("/"),ne=Q.lastIndexOf("/");if(H!==ne&&H>=0){const de=Q.slice(H+1,ne),me=Q[ne+1]==="i"?"i":"";try{J=new RegExp(de,me)}catch{throw this.B("REGEX",q)}}}if(J===null)throw this.B("REGEX",q);return ae.create(F,J)}default:throw this.B("REGEX",this.D())}}if(this.y(D.TokenType.Not)){this.A(D.TokenType.In,v);const q=this.u();return i.notIn(F,q)}switch(this.D().type){case D.TokenType.Eq:{this.z();const q=this.u();if(this.x().type===D.TokenType.QuotedStr)return i.equals(F,q);switch(q){case"true":return i.has(F);case"false":return i.not(F);default:return i.equals(F,q)}}case D.TokenType.NotEq:{this.z();const q=this.u();if(this.x().type===D.TokenType.QuotedStr)return i.notEquals(F,q);switch(q){case"true":return i.not(F);case"false":return i.has(F);default:return i.notEquals(F,q)}}case D.TokenType.Lt:return this.z(),ee.create(F,this.u());case D.TokenType.LtEq:return this.z(),X.create(F,this.u());case D.TokenType.Gt:return this.z(),C.create(F,this.u());case D.TokenType.GtEq:return this.z(),B.create(F,this.u());case D.TokenType.In:return this.z(),i.in(F,this.u());default:return i.has(F)}}case D.TokenType.EOF:throw this.h.push({message:S,offset:M.offset,lexeme:"",additionalInfo:t}),u.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const M=this.D();switch(M.type){case D.TokenType.Str:case D.TokenType.QuotedStr:return this.z(),M.lexeme;case D.TokenType.True:return this.z(),"true";case D.TokenType.False:return this.z(),"false";case D.TokenType.In:return this.z(),"in";default:return""}}w(M){return M.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(M){return this.C(M)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(M,F){if(this.C(M))return this.z();throw this.B(F,this.D())}B(M,F,U){const q=(0,I.localize)(11440,null,M,D.$xj.getLexeme(F)),Q=F.offset,J=D.$xj.getLexeme(F);return this.h.push({message:q,offset:Q,lexeme:J,additionalInfo:U}),u.c}C(M){return this.D().type===M}D(){return this.f[this.g]}E(){return this.D().type===D.TokenType.EOF}}e.$zj=u;class i{static false(){return l.INSTANCE}static true(){return k.INSTANCE}static has(M){return y.create(M)}static equals(M,F){return R.create(M,F)}static notEquals(M,F){return O.create(M,F)}static regex(M,F){return ae.create(M,F)}static in(M,F){return L.create(M,F)}static notIn(M,F){return A.create(M,F)}static not(M){return W.create(M)}static and(...M){return z.create(M,null,!0)}static or(...M){return j.create(M,null,!0)}static greater(M,F){return C.create(M,F)}static greaterEquals(M,F){return B.create(M,F)}static smaller(M,F){return ee.create(M,F)}static smallerEquals(M,F){return X.create(M,F)}static{this.c=new u({regexParsingWithErrorRecovery:!1})}static deserialize(M){return M==null?void 0:this.c.parse(M)}}e.$Aj=i;function o(_){const M=new u({regexParsingWithErrorRecovery:!1});return _.map(F=>(M.parse(F),M.lexingErrors.length>0?M.lexingErrors.map(U=>({errorMessage:U.additionalInfo?(0,I.localize)(11441,null,U.additionalInfo):(0,I.localize)(11442,null),offset:U.offset,length:U.lexeme.length})):M.parsingErrors.length>0?M.parsingErrors.map(U=>({errorMessage:U.additionalInfo?`${U.message}. ${U.additionalInfo}`:U.message,offset:U.offset,length:U.lexeme.length})):[]))}function s(_,M){const F=_?_.substituteConstants():void 0,U=M?M.substituteConstants():void 0;return!F&&!U?!0:!F||!U?!1:F.equals(U)}function c(_,M){return _.cmp(M)}class l{static{this.INSTANCE=new l}constructor(){this.type=m.False}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!1}serialize(){return"false"}keys(){return[]}map(M){return this}negate(){return k.INSTANCE}}e.$Dj=l;class k{static{this.INSTANCE=new k}constructor(){this.type=m.True}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!0}serialize(){return"true"}keys(){return[]}map(M){return this}negate(){return l.INSTANCE}}e.$Ej=k;class y{static create(M,F=null){const U=a.get(M);return typeof U=="boolean"?U?k.INSTANCE:l.INSTANCE:new y(M,F)}constructor(M,F){this.key=M,this.c=F,this.type=m.Defined}cmp(M){return M.type!==this.type?this.type-M.type:V(this.key,M.key)}equals(M){return M.type===this.type?this.key===M.key:!1}substituteConstants(){const M=a.get(this.key);return typeof M=="boolean"?M?k.INSTANCE:l.INSTANCE:this}evaluate(M){return!!M.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(M){return M.mapDefined(this.key)}negate(){return this.c||(this.c=W.create(this.key,this)),this.c}}e.$Fj=y;class R{static create(M,F,U=null){if(typeof F=="boolean")return F?y.create(M,U):W.create(M,U);const q=a.get(M);return typeof q=="boolean"?F===(q?"true":"false")?k.INSTANCE:l.INSTANCE:new R(M,F,U)}constructor(M,F,U){this.c=M,this.d=F,this.f=U,this.type=m.Equals}cmp(M){return M.type!==this.type?this.type-M.type:oe(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=a.get(this.c);if(typeof M=="boolean"){const F=M?"true":"false";return this.d===F?k.INSTANCE:l.INSTANCE}return this}evaluate(M){return M.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(M){return M.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Gj=R;class L{static create(M,F){return new L(M,F)}constructor(M,F){this.d=M,this.f=F,this.type=m.In,this.c=null}cmp(M){return M.type!==this.type?this.type-M.type:oe(this.d,this.f,M.d,M.f)}equals(M){return M.type===this.type?this.d===M.d&&this.f===M.f:!1}substituteConstants(){return this}evaluate(M){const F=M.getValue(this.f),U=M.getValue(this.d);return Array.isArray(F)?F.includes(U):typeof U=="string"&&typeof F=="object"&&F!==null?h.call(F,U):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(M){return M.mapIn(this.d,this.f)}negate(){return this.c||(this.c=A.create(this.d,this.f)),this.c}}e.$Hj=L;class A{static create(M,F){return new A(M,F)}constructor(M,F){this.d=M,this.f=F,this.type=m.NotIn,this.c=L.create(M,F)}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(M){return M.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ij=A;class O{static create(M,F,U=null){if(typeof F=="boolean")return F?W.create(M,U):y.create(M,U);const q=a.get(M);return typeof q=="boolean"?F===(q?"true":"false")?l.INSTANCE:k.INSTANCE:new O(M,F,U)}constructor(M,F,U){this.c=M,this.d=F,this.f=U,this.type=m.NotEquals}cmp(M){return M.type!==this.type?this.type-M.type:oe(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=a.get(this.c);if(typeof M=="boolean"){const F=M?"true":"false";return this.d===F?l.INSTANCE:k.INSTANCE}return this}evaluate(M){return M.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(M){return M.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$Jj=O;class W{static create(M,F=null){const U=a.get(M);return typeof U=="boolean"?U?l.INSTANCE:k.INSTANCE:new W(M,F)}constructor(M,F){this.c=M,this.d=F,this.type=m.Not}cmp(M){return M.type!==this.type?this.type-M.type:V(this.c,M.c)}equals(M){return M.type===this.type?this.c===M.c:!1}substituteConstants(){const M=a.get(this.c);return typeof M=="boolean"?M?l.INSTANCE:k.INSTANCE:this}evaluate(M){return!M.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(M){return M.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.$Kj=W;function x(_,M){if(typeof _=="string"){const F=parseFloat(_);isNaN(F)||(_=F)}return typeof _=="string"||typeof _=="number"?M(_):l.INSTANCE}class C{static create(M,F,U=null){return x(F,q=>new C(M,q,U))}constructor(M,F,U){this.c=M,this.d=F,this.f=U,this.type=m.Greater}cmp(M){return M.type!==this.type?this.type-M.type:oe(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=X.create(this.c,this.d,this)),this.f}}e.$Lj=C;class B{static create(M,F,U=null){return x(F,q=>new B(M,q,U))}constructor(M,F,U){this.c=M,this.d=F,this.f=U,this.type=m.GreaterEquals}cmp(M){return M.type!==this.type?this.type-M.type:oe(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ee.create(this.c,this.d,this)),this.f}}e.$Mj=B;class ee{static create(M,F,U=null){return x(F,q=>new ee(M,q,U))}constructor(M,F,U){this.c=M,this.d=F,this.f=U,this.type=m.Smaller}cmp(M){return M.type!==this.type?this.type-M.type:oe(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Nj=ee;class X{static create(M,F,U=null){return x(F,q=>new X(M,q,U))}constructor(M,F,U){this.c=M,this.d=F,this.f=U,this.type=m.SmallerEquals}cmp(M){return M.type!==this.type?this.type-M.type:oe(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$Oj=X;class ae{static create(M,F){return new ae(M,F)}constructor(M,F){this.d=M,this.f=F,this.type=m.Regex,this.c=null}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.d<M.d)return-1;if(this.d>M.d)return 1;const F=this.f?this.f.source:"",U=M.f?M.f.source:"";return F<U?-1:F>U?1:0}equals(M){if(M.type===this.type){const F=this.f?this.f.source:"",U=M.f?M.f.source:"";return this.d===M.d&&F===U}return!1}substituteConstants(){return this}evaluate(M){const F=M.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const M=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${M}`}keys(){return[this.d]}map(M){return M.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$Pj=ae;class K{static create(M){return new K(M)}constructor(M){this.c=M,this.type=m.NotRegex}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(M){return new K(this.c.map(M))}negate(){return this.c}}e.$Qj=K;function te(_){let M=null;for(let F=0,U=_.length;F<U;F++){const q=_[F].substituteConstants();if(_[F]!==q&&M===null){M=[];for(let Q=0;Q<F;Q++)M[Q]=_[Q]}M!==null&&(M[F]=q)}return M===null?_:M}class z{static create(M,F,U){return z.d(M,F,U)}constructor(M,F){this.expr=M,this.c=F,this.type=m.And}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let F=0,U=this.expr.length;F<U;F++){const q=c(this.expr[F],M.expr[F]);if(q!==0)return q}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let F=0,U=this.expr.length;F<U;F++)if(!this.expr[F].equals(M.expr[F]))return!1;return!0}return!1}substituteConstants(){const M=te(this.expr);return M===this.expr?this:z.create(M,this.c,!1)}evaluate(M){for(let F=0,U=this.expr.length;F<U;F++)if(!this.expr[F].evaluate(M))return!1;return!0}static d(M,F,U){const q=[];let Q=!1;for(const J of M)if(J){if(J.type===m.True){Q=!0;continue}if(J.type===m.False)return l.INSTANCE;if(J.type===m.And){q.push(...J.expr);continue}q.push(J)}if(q.length===0&&Q)return k.INSTANCE;if(q.length!==0){if(q.length===1)return q[0];q.sort(c);for(let J=1;J<q.length;J++)q[J-1].equals(q[J])&&(q.splice(J,1),J--);if(q.length===1)return q[0];for(;q.length>1;){const J=q[q.length-1];if(J.type!==m.Or)break;q.pop();const H=q.pop(),ne=q.length===0,de=j.create(J.expr.map(me=>z.create([me,H],null,U)),null,ne);de&&(q.push(de),q.sort(c))}if(q.length===1)return q[0];if(U){for(let J=0;J<q.length;J++)for(let H=J+1;H<q.length;H++)if(q[J].negate().equals(q[H]))return l.INSTANCE;if(q.length===1)return q[0]}return new z(q,F)}}serialize(){return this.expr.map(M=>M.serialize()).join(" && ")}keys(){const M=[];for(const F of this.expr)M.push(...F.keys());return M}map(M){return new z(this.expr.map(F=>F.map(M)),null)}negate(){if(!this.c){const M=[];for(const F of this.expr)M.push(F.negate());this.c=j.create(M,this,!0)}return this.c}}e.$Rj=z;class j{static create(M,F,U){return j.d(M,F,U)}constructor(M,F){this.expr=M,this.c=F,this.type=m.Or}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let F=0,U=this.expr.length;F<U;F++){const q=c(this.expr[F],M.expr[F]);if(q!==0)return q}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let F=0,U=this.expr.length;F<U;F++)if(!this.expr[F].equals(M.expr[F]))return!1;return!0}return!1}substituteConstants(){const M=te(this.expr);return M===this.expr?this:j.create(M,this.c,!1)}evaluate(M){for(let F=0,U=this.expr.length;F<U;F++)if(this.expr[F].evaluate(M))return!0;return!1}static d(M,F,U){let q=[],Q=!1;if(M){for(let J=0,H=M.length;J<H;J++){const ne=M[J];if(ne){if(ne.type===m.False){Q=!0;continue}if(ne.type===m.True)return k.INSTANCE;if(ne.type===m.Or){q=q.concat(ne.expr);continue}q.push(ne)}}if(q.length===0&&Q)return l.INSTANCE;q.sort(c)}if(q.length!==0){if(q.length===1)return q[0];for(let J=1;J<q.length;J++)q[J-1].equals(q[J])&&(q.splice(J,1),J--);if(q.length===1)return q[0];if(U){for(let J=0;J<q.length;J++)for(let H=J+1;H<q.length;H++)if(q[J].negate().equals(q[H]))return k.INSTANCE;if(q.length===1)return q[0]}return new j(q,F)}}serialize(){return this.expr.map(M=>M.serialize()).join(" || ")}keys(){const M=[];for(const F of this.expr)M.push(...F.keys());return M}map(M){return new j(this.expr.map(F=>F.map(M)),null)}negate(){if(!this.c){const M=[];for(const F of this.expr)M.push(F.negate());for(;M.length>1;){const F=M.shift(),U=M.shift(),q=[];for(const Q of re(F))for(const J of re(U))q.push(z.create([Q,J],null,!1));M.unshift(j.create(q,null,!1))}this.c=j.create(M,this,!0)}return this.c}}e.$Sj=j;class N extends y{static{this.d=[]}static all(){return N.d.values()}constructor(M,F,U){super(M,null),this.f=F,typeof U=="object"?N.d.push({...U,key:M}):U!==!0&&N.d.push({key:M,description:U,type:F!=null?typeof F:void 0})}bindTo(M){return M.createKey(this.key,this.f)}getValue(M){return M.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(M){return R.create(this.key,M)}notEqualsTo(M){return O.create(this.key,M)}}e.$Tj=N,e.$Uj=(0,T.$Ci)("contextKeyService");function V(_,M){return _<M?-1:_>M?1:0}function oe(_,M,F,U){return _<F?-1:_>F?1:M<U?-1:M>U?1:0}function G(_,M){if(_.type===m.False||M.type===m.True)return!0;if(_.type===m.Or)return M.type===m.Or?he(_.expr,M.expr):!1;if(M.type===m.Or){for(const F of M.expr)if(G(_,F))return!0;return!1}if(_.type===m.And){if(M.type===m.And)return he(M.expr,_.expr);for(const F of _.expr)if(G(F,M))return!0;return!1}return _.equals(M)}function he(_,M){let F=0,U=0;for(;F<_.length&&U<M.length;){const q=_[F].cmp(M[U]);if(q<0)return!1;q===0&&F++,U++}return F===_.length}function re(_){return _.type===m.Or?_.expr:[_]}}),define(le[96],ue([0,1,6]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rm=e.$Pm=e.ID=void 0,e.$Qm=r,e.ID="diagnosticsService",e.$Pm=(0,n.$Ci)(e.ID);function r(D){return!!D.hostName&&!!D.errorMessage}class E{async getPerformanceInfo(T,I){return{}}async getSystemInfo(T,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,I){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.$Rm=E});var et=this&&this.__importDefault||function(Y){return Y&&Y.__esModule?Y:{default:Y}};define(le[123],ue([0,1,18,81,10,6,47,3,37]),function(Y,e,n,r,E,D,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$7w=e.$6w=e.$5w=void 0,e.$8w=w,e.$9w=f,r=et(r),e.$5w=(0,D.$Ci)("dialogService");var a;(function(d){d[d.Confirmation=1]="Confirmation",d[d.Prompt=2]="Prompt",d[d.Input=3]="Input"})(a||(a={}));class g{a(v){return this.d(v,a.Confirmation)}b(v){return this.d(v,a.Prompt)}c(v){return this.d(v,a.Input)}d(v,b){const $=[];switch(b){case a.Confirmation:{const P=v;P.primaryButton?$.push(P.primaryButton):$.push((0,E.localize)(11409,null)),P.cancelButton?$.push(P.cancelButton):$.push((0,E.localize)(11410,null));break}case a.Prompt:{const P=v;Array.isArray(P.buttons)&&P.buttons.length>0&&$.push(...P.buttons.map(S=>S.label)),P.cancelButton&&(P.cancelButton===!0?$.push((0,E.localize)(11411,null)):typeof P.cancelButton=="string"?$.push(P.cancelButton):P.cancelButton.label?$.push(P.cancelButton.label):$.push((0,E.localize)(11412,null))),$.length===0&&$.push((0,E.localize)(11413,null));break}case a.Input:{const P=v;P.primaryButton?$.push(P.primaryButton):$.push((0,E.localize)(11414,null)),P.cancelButton?$.push(P.cancelButton):$.push((0,E.localize)(11415,null));break}}return $}e(v){if(typeof v=="string")return v;if(typeof v=="number")return v===r.default.Info?"info":v===r.default.Error?"error":v===r.default.Warning?"warning":"none"}f(v,b,$){const P=[...v.buttons??[]];v.cancelButton&&typeof v.cancelButton!="string"&&typeof v.cancelButton!="boolean"&&P.push(v.cancelButton);let S=P[b]?.run({checkboxChecked:$});return S instanceof Promise||(S=Promise.resolve(S)),{result:S,checkboxChecked:$}}}e.$6w=g,e.$7w=(0,D.$Ci)("fileDialogService");var h;(function(d){d[d.SAVE=0]="SAVE",d[d.DONT_SAVE=1]="DONT_SAVE",d[d.CANCEL=2]="CANCEL"})(h||(e.ConfirmResult=h={}));const m=10;function w(d){const v=[];return v.push(...d.slice(0,m).map(b=>typeof b=="string"?b:(0,n.$ah)(b))),d.length>m&&(d.length-m===1?v.push((0,E.localize)(11416,null)):v.push((0,E.localize)(11417,null,d.length-m))),v.push(""),v.join(`
`)}function f(d,v){const b=(0,p.$ao)(d);let $=(b.buttons??[]).map(u=>(0,T.$2w)(u)),P=(d.buttons||[]).map((u,i)=>i),S=0,t=b.cancelId??$.length-1;if($.length>1){const u=typeof t=="number"?$[t]:void 0;if(I.$l||I.$k){if(typeof u=="string"&&$.length>1&&t!==1){$.splice(t,1),$.splice(1,0,u);const i=P[t];P.splice(t,1),P.splice(1,0,i),t=1}I.$l&&$.length>1&&($=$.reverse(),P=P.reverse(),S=$.length-1,typeof u=="string"&&(t=S-1))}else if(I.$j&&typeof u=="string"&&$.length>1&&t!==$.length-1){$.splice(t,1),$.push(u);const i=P[t];P.splice(t,1),P.push(i),t=$.length-1}}return b.buttons=$,b.defaultId=S,b.cancelId=t,b.noLink=!0,b.title=b.title||v.nameLong,{options:b,buttonIndeces:P}}}),define(le[97],ue([0,1,6]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$gY=e.$fY=void 0,e.$hY=D,e.$iY=T,e.$fY=(0,n.$Ci)("encryptionService"),e.$gY=(0,n.$Ci)("encryptionMainService");var r;(function(I){I.kwallet="kwallet",I.kwallet5="kwallet5",I.gnomeLibsecret="gnome-libsecret",I.basic="basic"})(r||(e.PasswordStoreCLIOption=r={}));var E;(function(I){I.unknown="unknown",I.basicText="basic_text",I.gnomeAny="gnome_any",I.gnomeLibsecret="gnome_libsecret",I.gnomeKeyring="gnome_keyring",I.kwallet="kwallet",I.kwallet5="kwallet5",I.kwallet6="kwallet6",I.dplib="dpapi",I.keychainAccess="keychain_access"})(E||(e.KnownStorageProvider=E={}));function D(I){return I===E.kwallet||I===E.kwallet5||I===E.kwallet6}function T(I){return I===E.gnomeAny||I===E.gnomeLibsecret||I===E.gnomeKeyring}}),define(le[38],ue([0,1,6]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=void 0,e.$Ji=(0,n.$Ci)("environmentService"),e.$Ki=(0,n.$Di)(e.$Ji)}),define(le[173],ue([0,1,6]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zfc=e.$yfc=void 0,e.$yfc=(0,n.$Ci)("extensionHostStarter"),e.$zfc="extensionHostStarter"}),define(le[174],ue([0,1,6]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q9b=e.$P9b=void 0,e.$P9b=(0,n.$Ci)("externalTerminal"),e.$Q9b="Terminal.app"}),define(le[175],ue([0,1,6]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bfc=void 0,e.$Bfc=(0,n.$Ci)("externalTerminal")}),define(le[176],ue([0,1,48,53,11,9,3,79,23,94,10,174]),function(Y,e,n,r,E,D,T,I,p,a,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efc=e.$Dfc=e.$Cfc=void 0,n=Ie(n),D=Ie(D),T=Ie(T),p=Ie(p),a=Ie(a),g=Ie(g);const m=g.localize(11260,null);class w{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends w{static{this.b="cmd.exe"}openTerminal(t,u){return this.spawnTerminal(n,t,a.$um(),u)}spawnTerminal(t,u,i,o){const s=u.windowsExec||f.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const c=D.$mc(s,".exe").toLowerCase();if(c==="cmder")return t.spawn(s,o?[o]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return s.indexOf(" ")>=0&&l.push('""'),l.push(s),c==="wt"&&l.push("-d ."),new Promise((k,y)=>{const R=b(process),L=t.spawn(i,l,{cwd:o,env:R,detached:!0});L.on("error",y),L.on("exit",()=>k())})}async runInTerminal(t,u,i,o,s){const c="windowsExec"in s&&s.windowsExec?s.windowsExec:f.getDefaultTerminalWindows(),l=await f.f();return new Promise((k,y)=>{const R=`"${u} - ${m}"`,L=`"${i.join('" "')}" & pause`,A=Object.assign({},b(process),o);Object.keys(A).filter(B=>A[B]===null).forEach(B=>delete A[B]);const O={cwd:u,env:A,windowsVerbatimArguments:!0};let W,x;D.$mc(c,".exe")==="wt"?(W=c,x=["-d",".",f.b,"/c",L]):l?(W=l,x=["-d",".",c,"/c",L]):(W=f.b,x=["/c","start",R,"/wait",c,"/c",`"${L}"`]),n.spawn(W,x,O).on("error",B=>{y($(B))}),k(void 0)})}static getDefaultTerminalWindows(){if(!f.d){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return f.d}static async f(){try{const t=await a.win32.findExecutable("wt");return await p.Promises.exists(t)?t:void 0}catch{return}}}e.$Cfc=f,Ee([r.$7h],f,"f",null);class d extends w{static{this.b="/usr/bin/osascript"}openTerminal(t,u){return this.spawnTerminal(n,t,u)}runInTerminal(t,u,i,o,s){const c=s.osxExec||h.$Q9b;return new Promise((l,k)=>{if(c===h.$Q9b||c==="iTerm.app"){const y=c===h.$Q9b?"TerminalHelper":"iTermHelper",L=[E.$Wg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${y}.scpt`).fsPath,"-t",t||m,"-w",u];for(const W of i)L.push("-a"),L.push(W);if(o){const W=Object.assign({},b(process),o);for(const x in W){const C=W[x];C===null?(L.push("-u"),L.push(x)):(L.push("-e"),L.push(`${x}=${C}`))}}let A="";const O=n.spawn(d.b,L);O.on("error",W=>{k($(W))}),O.stderr.on("data",W=>{A+=W.toString()}),O.on("exit",W=>{if(W===0)l(void 0);else if(A){const x=A.split(`
`,1);k(new Error(x[0]))}else k(new Error(g.localize(11261,null,y,W)))})}else k(new Error(g.localize(11262,null,c)))})}spawnTerminal(t,u,i){const o=u.osxExec||h.$Q9b;return new Promise((s,c)=>{const l=["-a",o];i&&l.push(i);const k=b(process),y=t.spawn("/usr/bin/open",l,{cwd:i,env:k});y.on("error",c),y.on("exit",()=>s())})}}e.$Dfc=d;class v extends w{static{this.b=g.localize(11263,null)}openTerminal(t,u){return this.spawnTerminal(n,t,u)}runInTerminal(t,u,i,o,s){const c=s.linuxExec?Promise.resolve(s.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((l,k)=>{const y=[];c.then(R=>{R.indexOf("gnome-terminal")>=0?y.push("-x"):y.push("-e"),y.push("bash"),y.push("-c");const L=`${P(i)}; echo; read -p "${v.b}" -n1;`;y.push(`''${L}''`);const A=Object.assign({},b(process),o);Object.keys(A).filter(C=>A[C]===null).forEach(C=>delete A[C]);const O={cwd:u,env:A};let W="";const x=n.spawn(R,y,O);x.on("error",C=>{k($(C))}),x.stderr.on("data",C=>{W+=C.toString()}),x.on("exit",C=>{if(C===0)l(void 0);else if(W){const B=W.split(`
`,1);k(new Error(B[0]))}else k(new Error(g.localize(11264,null,R,C)))})})})}static async getDefaultTerminalLinuxReady(){if(!v.d)if(!T.$l)v.d=Promise.resolve("xterm");else{const t=await p.Promises.exists("/etc/debian_version");v.d=new Promise(u=>{t?u("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?u("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?u("konsole"):process.env.COLORTERM?u(process.env.COLORTERM):process.env.TERM?u(process.env.TERM):u("xterm")})}return v.d}spawnTerminal(t,u,i){const o=u.linuxExec?Promise.resolve(u.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((s,c)=>{o.then(l=>{const k=b(process),y=t.spawn(l,[],{cwd:i,env:k});y.on("error",c),y.on("exit",()=>s())})})}}e.$Efc=v;function b(S){const t={...S.env};return(0,I.$hm)(t),t}function $(S){return"errno"in S&&S.errno==="ENOENT"&&"path"in S&&typeof S.path=="string"?new Error(g.localize(11265,null,S.path)):S}function P(S){let t="";for(const u of S)u.indexOf(" ")>=0?t+='"'+u+'"':t+=u,t+=" ";return t}}),define(le[14],ue([0,1,60,9,25,12,7,10,6,3,11,65]),function(Y,e,n,r,E,D,T,I,p,a,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.$Bl=e.FileKind=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.FileOperationResult=e.$tl=e.$sl=e.$rl=e.$pl=e.FileChangeType=e.$ol=e.FileOperation=e.$il=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$9k=void 0,e.$0k=m,e.$$k=v,e.$_k=$,e.$al=P,e.$bl=S,e.$cl=t,e.$dl=u,e.$el=i,e.$fl=o,e.$gl=s,e.$hl=c,e.$jl=y,e.$kl=R,e.$ll=L,e.$ml=A,e.$nl=O,e.$ql=ee,e.$Cl=j,e.$Dl=N,e.$Fl=oe,e.$9k=(0,p.$Ci)("fileService");function m(G){return G.create===!0}var w;(function(G){G[G.Unknown=0]="Unknown",G[G.File=1]="File",G[G.Directory=2]="Directory",G[G.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var f;(function(G){G[G.Readonly=1]="Readonly",G[G.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var d;(function(G){G[G.UPDATED=2]="UPDATED",G[G.ADDED=4]="ADDED",G[G.DELETED=8]="DELETED"})(d||(e.FileChangeFilter=d={}));function v(G){const he=G;return!!he&&typeof he.onDidChange=="function"}var b;(function(G){G[G.None=0]="None",G[G.FileReadWrite=2]="FileReadWrite",G[G.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",G[G.FileReadStream=16]="FileReadStream",G[G.FileFolderCopy=8]="FileFolderCopy",G[G.PathCaseSensitive=1024]="PathCaseSensitive",G[G.Readonly=2048]="Readonly",G[G.Trash=4096]="Trash",G[G.FileWriteUnlock=8192]="FileWriteUnlock",G[G.FileAtomicRead=16384]="FileAtomicRead",G[G.FileAtomicWrite=32768]="FileAtomicWrite",G[G.FileAtomicDelete=65536]="FileAtomicDelete",G[G.FileClone=131072]="FileClone"})(b||(e.FileSystemProviderCapabilities=b={}));function $(G){return!!(G.capabilities&b.FileReadWrite)}function P(G){return!!(G.capabilities&b.FileFolderCopy)}function S(G){return!!(G.capabilities&b.FileClone)}function t(G){return!!(G.capabilities&b.FileOpenReadWriteClose)}function u(G){return!!(G.capabilities&b.FileReadStream)}function i(G){return $(G)?!!(G.capabilities&b.FileAtomicRead):!1}function o(G){return $(G)?!!(G.capabilities&b.FileAtomicWrite):!1}function s(G){return!!(G.capabilities&b.FileAtomicDelete)}function c(G){return!!(G.capabilities&b.Readonly)}var l;(function(G){G.FileExists="EntryExists",G.FileNotFound="EntryNotFound",G.FileNotADirectory="EntryNotADirectory",G.FileIsADirectory="EntryIsADirectory",G.FileExceedsStorageQuota="EntryExceedsStorageQuota",G.FileTooLarge="EntryTooLarge",G.FileWriteLocked="EntryWriteLocked",G.NoPermissions="NoPermissions",G.Unavailable="Unavailable",G.Unknown="Unknown"})(l||(e.FileSystemProviderErrorCode=l={}));class k extends Error{static create(he,re){const _=new k(he.toString(),re);return L(_,re),_}constructor(he,re){super(he),this.code=re}}e.$il=k;function y(G,he){return k.create(G,he)}function R(G){return G||y((0,I.localize)(11219,null),l.Unknown)}function L(G,he){return G.name=he?`${he} (FileSystemError)`:"FileSystemError",G}function A(G){if(!G)return l.Unknown;if(G instanceof k)return G.code;const he=/^(.+) \(FileSystemError\)$/.exec(G.name);if(!he)return l.Unknown;switch(he[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}function O(G){if(G instanceof X)return G.fileOperationResult;switch(A(G)){case l.FileNotFound:return te.FILE_NOT_FOUND;case l.FileIsADirectory:return te.FILE_IS_DIRECTORY;case l.FileNotADirectory:return te.FILE_NOT_DIRECTORY;case l.FileWriteLocked:return te.FILE_WRITE_LOCKED;case l.NoPermissions:return te.FILE_PERMISSION_DENIED;case l.FileExists:return te.FILE_MOVE_CONFLICT;case l.FileTooLarge:return te.FILE_TOO_LARGE;default:return te.FILE_OTHER_ERROR}}var W;(function(G){G[G.CREATE=0]="CREATE",G[G.DELETE=1]="DELETE",G[G.MOVE=2]="MOVE",G[G.COPY=3]="COPY",G[G.WRITE=4]="WRITE"})(W||(e.FileOperation=W={}));class x{constructor(he,re,_){this.resource=he,this.operation=re,this.target=_}isOperation(he){return this.operation===he}}e.$ol=x;var C;(function(G){G[G.UPDATED=0]="UPDATED",G[G.ADDED=1]="ADDED",G[G.DELETED=2]="DELETED"})(C||(e.FileChangeType=C={}));class B{static{this.a=null}constructor(he,re){this.c=re,this.b=void 0,this.d=new h.$T(()=>{const _=n.$Ii.forUris(()=>this.c);return _.fill(this.rawAdded.map(M=>[M,!0])),_}),this.f=new h.$T(()=>{const _=n.$Ii.forUris(()=>this.c);return _.fill(this.rawUpdated.map(M=>[M,!0])),_}),this.g=new h.$T(()=>{const _=n.$Ii.forUris(()=>this.c);return _.fill(this.rawDeleted.map(M=>[M,!0])),_}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const _ of he){switch(_.type){case C.ADDED:this.rawAdded.push(_.resource);break;case C.UPDATED:this.rawUpdated.push(_.resource);break;case C.DELETED:this.rawDeleted.push(_.resource);break}this.b!==B.a&&(typeof _.cId=="number"?this.b===void 0?this.b=_.cId:this.b!==_.cId&&(this.b=B.a):this.b!==void 0&&(this.b=B.a))}}contains(he,...re){return this.h(he,{includeChildren:!1},...re)}affects(he,...re){return this.h(he,{includeChildren:!0},...re)}h(he,re,..._){if(!he)return!1;const M=_.length>0;return!!((!M||_.includes(C.ADDED))&&(this.d.value.get(he)||re.includeChildren&&this.d.value.findSuperstr(he))||(!M||_.includes(C.UPDATED))&&(this.f.value.get(he)||re.includeChildren&&this.f.value.findSuperstr(he))||(!M||_.includes(C.DELETED))&&(this.g.value.findSubstr(he)||re.includeChildren&&this.g.value.findSuperstr(he)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(he){return this.b===he}hasCorrelation(){return typeof this.b=="number"}}e.$pl=B;function ee(G,he,re){return!G||!he||G===he||he.length>G.length?!1:(he.charAt(he.length-1)!==r.sep&&(he+=r.sep),re?(0,E.$Ef)(G,he):G.indexOf(he)===0)}class X extends Error{constructor(he,re,_){super(he),this.fileOperationResult=re,this.options=_}}e.$rl=X;class ae extends X{constructor(he,re,_,M){super(he,re,M),this.fileOperationResult=re,this.size=_}}e.$sl=ae;class K extends X{constructor(he,re,_){super(he,te.FILE_NOT_MODIFIED_SINCE,_),this.stat=re}}e.$tl=K;var te;(function(G){G[G.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",G[G.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",G[G.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",G[G.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",G[G.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",G[G.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",G[G.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",G[G.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",G[G.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",G[G.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",G[G.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(te||(e.FileOperationResult=te={})),e.$ul={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$vl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$wl="files.associations",e.$xl="files.exclude",e.$yl="files.readonlyInclude",e.$zl="files.readonlyExclude",e.$Al="files.readonlyFromPermissions";var z;(function(G){G[G.FILE=0]="FILE",G[G.FOLDER=1]="FOLDER",G[G.ROOT_FOLDER=2]="ROOT_FOLDER"})(z||(e.FileKind=z={})),e.$Bl="";function j(G){if(!(typeof G.size!="number"||typeof G.mtime!="number"))return G.mtime.toString(29)+G.size.toString(31)}async function N(G,he){if(!he.hasProvider(T.URI.from({scheme:G.scheme})))return new Promise(re=>{const _=he.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===G.scheme&&M.added&&(_.dispose(),re())})})}class V{static{this.KB=1024}static{this.MB=V.KB*V.KB}static{this.GB=V.MB*V.KB}static{this.TB=V.GB*V.KB}static formatSize(he){return(0,D.$gg)(he)||(he=0),he<V.KB?(0,I.localize)(11220,null,he.toFixed(0)):he<V.MB?(0,I.localize)(11221,null,(he/V.KB).toFixed(2)):he<V.GB?(0,I.localize)(11222,null,(he/V.MB).toFixed(2)):he<V.TB?(0,I.localize)(11223,null,(he/V.GB).toFixed(2)):(0,I.localize)(11224,null,(he/V.TB).toFixed(2))}}e.$El=V;function oe(G){const he=typeof G=="string"||G?.scheme===g.Schemas.vscodeRemote;return typeof G!="string"&&G?.scheme===g.Schemas.file?1024*V.MB:he?10*V.MB:a.$p?50*V.MB:1024*V.MB}}),define(le[124],ue([0,1,16,15,10,14]),function(Y,e,n,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=T;async function T(g,h,m,w,f,d){let v;try{await I(g,h,m,w,f,d)}catch(b){v=b}finally{v&&f.errorTransformer&&(v=f.errorTransformer(v)),typeof v<"u"&&m.error(v),m.end()}}async function I(g,h,m,w,f,d){p(d);const v=await g.open(h,{create:!1});try{p(d);let b=0,$=0,P=f&&typeof f.length=="number"?f.length:void 0,S=n.$Le.alloc(Math.min(f.bufferSize,typeof P=="number"?P:f.bufferSize)),t=f&&typeof f.position=="number"?f.position:0,u=0;do $=await g.read(v,t,S.buffer,u,S.byteLength-u),t+=$,u+=$,b+=$,typeof P=="number"&&(P-=$),u===S.byteLength&&(await m.write(w(S)),S=n.$Le.alloc(Math.min(f.bufferSize,typeof P=="number"?P:f.bufferSize)),u=0);while($>0&&(typeof P!="number"||P>0)&&p(d)&&a(b,f));if(u>0){let i=u;typeof P=="number"&&(i=Math.min(u,P)),m.write(w(S.slice(0,i)))}}catch(b){throw(0,D.$kl)(b)}finally{await g.close(v)}}function p(g){if(g.isCancellationRequested)throw(0,r.$5)();return!0}function a(g,h){if(typeof h?.limits?.size=="number"&&g>h.limits.size)throw(0,D.$jl)((0,E.localize)(11218,null),D.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[61],ue([0,1,111,2,9,3,7,14]),function(Y,e,n,r,E,D,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=e.$3q=e.$2q=void 0,e.$Zq=p,e.$1q=a,e.$5q=w,e.$6q=f,e.$7q=d,e.$8q=v,e.$9q=$,e.$0q=P;function p(S){return typeof S.correlationId=="number"}function a(S){return S.recursive===!0}class g extends r.$Tc{static{this.a=5}constructor(t,u,i,o){super(),this.h=t,this.j=u,this.m=i,this.n=o,this.c=this.B(new r.$Uc),this.f=void 0,this.g=0}s(){const t=new r.$Sc;this.c.value=t,this.b=this.r(t),this.b.setVerboseLogging(this.m),t.add(this.b.onDidChangeFile(u=>this.h(u))),t.add(this.b.onDidLogMessage(u=>this.j(u))),t.add(this.b.onDidError(u=>this.t(u.error,u.request)))}t(t,u){this.u(t,u)?this.g<g.a&&this.f?(this.y(`restarting watcher after unexpected error: ${t}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${t}`):this.y(t)}u(t,u){return!(!this.n.restartOnError||u||t.indexOf("No space left on device")!==-1||t.indexOf("EMFILE")!==-1)}w(t){this.g++,this.s(),this.watch(t)}async watch(t){this.f=t,await this.b?.watch(t)}async setVerboseLogging(t){this.m=t,await this.b?.setVerboseLogging(t)}y(t){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${t}`})}z(t){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${t}`})}dispose(){return this.b=void 0,super.dispose()}}e.$2q=g;class h extends g{constructor(t,u,i){super(t,u,i,{type:"node.js",restartOnError:!1})}}e.$3q=h;class m extends g{constructor(t,u,i){super(t,u,i,{type:"universal",restartOnError:!0})}}e.$4q=m;function w(S){return S.map(t=>({type:t.type,resource:T.URI.revive(t.resource),cId:t.cId}))}function f(S){const t=new b;for(const u of S)t.processEvent(u);return t.coalesce()}function d(S,t){return typeof t=="string"&&!t.startsWith(n.$sk)&&!(0,E.$hc)(t)?{base:S,pattern:t}:t}function v(S,t){const u=[];for(const i of t)u.push((0,n.$wk)(d(S,i)));return u}class b{constructor(){this.a=new Set,this.b=new Map}c(t){return D.$l?t.resource.fsPath:t.resource.fsPath.toLowerCase()}processEvent(t){const u=this.b.get(this.c(t));let i=!1;if(u){const o=u.type,s=t.type;u.resource.fsPath!==t.resource.fsPath&&(t.type===I.FileChangeType.DELETED||t.type===I.FileChangeType.ADDED)?i=!0:o===I.FileChangeType.ADDED&&s===I.FileChangeType.DELETED?(this.b.delete(this.c(t)),this.a.delete(u)):o===I.FileChangeType.DELETED&&s===I.FileChangeType.ADDED?u.type=I.FileChangeType.UPDATED:o===I.FileChangeType.ADDED&&s===I.FileChangeType.UPDATED||(u.type=s)}else i=!0;i&&(this.a.add(t),this.b.set(this.c(t),t))}coalesce(){const t=[],u=[];return Array.from(this.a).filter(i=>i.type!==I.FileChangeType.DELETED?(t.push(i),!1):!0).sort((i,o)=>i.resource.fsPath.length-o.resource.fsPath.length).filter(i=>u.some(o=>(0,I.$ql)(i.resource.fsPath,o,!D.$l))?!1:(u.push(i.resource.fsPath),!0)).concat(t)}}function $(S,t){if(typeof t=="number")switch(S.type){case I.FileChangeType.ADDED:return(t&I.FileChangeFilter.ADDED)===0;case I.FileChangeType.DELETED:return(t&I.FileChangeFilter.DELETED)===0;case I.FileChangeType.UPDATED:return(t&I.FileChangeFilter.UPDATED)===0}return!1}function P(S){if(typeof S=="number"){const t=[];return S&I.FileChangeFilter.ADDED&&t.push("Added"),S&I.FileChangeFilter.DELETED&&t.push("Deleted"),S&I.FileChangeFilter.UPDATED&&t.push("Updated"),t.length===0?"<all>":`[${t.join(", ")}]`}return"<none>"}}),define(le[177],ue([0,1,16,54,15,4,2,67,33,14,61]),function(Y,e,n,r,E,D,T,I,p,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Q=e.$9Q=void 0,e.$9Q="localFilesystem";class h extends T.$Tc{constructor(w,f){super(),this.a=w,this.b=f,this.onDidChangeCapabilities=D.Event.None,this.f=this.B(new D.$je),this.onDidChangeFile=this.f.event,this.g=this.B(new D.$je),this.onDidWatchError=this.g.event,this.h=(0,p.$Yg)(),this.j()}get capabilities(){return this.c||(this.c=a.FileSystemProviderCapabilities.FileReadWrite|a.FileSystemProviderCapabilities.FileOpenReadWriteClose|a.FileSystemProviderCapabilities.FileReadStream|a.FileSystemProviderCapabilities.FileFolderCopy|a.FileSystemProviderCapabilities.FileWriteUnlock|a.FileSystemProviderCapabilities.FileAtomicRead|a.FileSystemProviderCapabilities.FileAtomicWrite|a.FileSystemProviderCapabilities.FileAtomicDelete|a.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=a.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=a.FileSystemProviderCapabilities.Trash)),this.c}stat(w){return this.a.call("stat",[w])}readdir(w){return this.a.call("readdir",[w])}async readFile(w,f){const{buffer:d}=await this.a.call("readFile",[w,f]);return d}readFileStream(w,f,d){const v=(0,I.$ze)($=>n.$Le.concat($.map(P=>n.$Le.wrap(P))).buffer),b=new T.$Sc;return b.add(this.a.listen("readFileStream",[w,f])($=>{if($ instanceof n.$Le)v.write($.buffer);else{if($==="end")v.end();else{let P;if($ instanceof Error)P=$;else{const S=$;P=(0,a.$jl)(S.message??(0,r.$nj)(S),S.code??a.FileSystemProviderErrorCode.Unknown)}v.error(P),v.end()}b.dispose()}})),b.add(d.onCancellationRequested(()=>{v.error((0,E.$5)()),v.end(),b.dispose()})),v}writeFile(w,f,d){return this.a.call("writeFile",[w,n.$Le.wrap(f),d])}open(w,f){return this.a.call("open",[w,f])}close(w){return this.a.call("close",[w])}async read(w,f,d,v,b){const[$,P]=await this.a.call("read",[w,f,b]);return d.set($.buffer.slice(0,P),v),P}write(w,f,d,v,b){return this.a.call("write",[w,f,n.$Le.wrap(d),v,b])}mkdir(w){return this.a.call("mkdir",[w])}delete(w,f){return this.a.call("delete",[w,f])}rename(w,f,d){return this.a.call("rename",[w,f,d])}copy(w,f,d){return this.a.call("copy",[w,f,d])}cloneFile(w,f){return this.a.call("cloneFile",[w,f])}j(){this.B(this.a.listen("fileChange",[this.h])(w=>{if(Array.isArray(w)){const f=w;this.f.fire((0,g.$5q)(f))}else{const f=w;this.g.fire(f)}}))}watch(w,f){const d=(0,p.$Yg)();return this.a.call("watch",[this.h,d,w,f]),(0,T.$Rc)(()=>this.a.call("unwatch",[this.h,d]))}}e.$0Q=h}),define(le[178],ue([0,1,26,2,61,4,14,7,8]),function(Y,e,n,r,E,D,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=void 0;class a extends r.$Tc{constructor(){super(),this.a=this.B(new D.$je),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$je),this.onDidLogMessage=this.b.event,this.c=this.B(new D.$je),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new r.$3c),this.m=new Set,this.n=this.B(new p.$Ah(this.y())),this.r=5007,this.s=new p.$Zh,this.R=!1,this.B(this.f(h=>this.t(h)))}t(h){this.u(h)&&this.z(h)}u(h){return(0,E.$Zq)(h)}async watch(h){this.s.isSettled||this.s.complete(),this.s=new p.$Zh;try{this.h.clear(),this.g.clear();for(const m of h)this.u(m)?this.h.set(m.correlationId,m):this.g.add(m);for(const[m]of this.j)this.h.has(m)||(this.j.deleteAndDispose(m),this.m.delete(m));return await this.w(!1)}finally{this.s.complete()}}w(h){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(m=>!this.j.has(m.correlationId))]),h?this.y():0)}y(){return 800}isSuspended(h){return typeof h.correlationId!="number"?!1:this.m.has(h.correlationId)?"polling":this.j.has(h.correlationId)}async z(h){if(this.j.has(h.correlationId))return;const m=new r.$Sc;this.j.set(h.correlationId,m),await this.s.p,!m.isDisposed&&(this.D(h,m),this.w(!0))}C(h){this.j.deleteAndDispose(h.correlationId),this.m.delete(h.correlationId),this.w(!1)}D(h,m){this.F(h,m)?(this.P(`reusing an existing recursive watcher to monitor ${h.path}`),this.m.delete(h.correlationId)):(this.G(h,m),this.m.add(h.correlationId))}F(h,m){const w=this.O?.subscribe(h.path,(f,d)=>{m.isDisposed||(f?this.D(h,m):d?.type===T.FileChangeType.ADDED&&this.H(h))});return w?(m.add(w),!0):!1}G(h,m){let w=!1;const f=(d,v)=>{if(m.isDisposed)return;const b=this.I(d),$=this.I(v),P=w;w=b,!b&&($||P)&&this.H(h)};this.P(`starting fs.watchFile() on ${h.path} (correlationId: ${h.correlationId})`);try{(0,n.watchFile)(h.path,{persistent:!1,interval:this.r},f)}catch(d){this.Q(`fs.watchFile() failed with error ${d} on path ${h.path} (correlationId: ${h.correlationId})`)}m.add((0,r.$Rc)(()=>{this.P(`stopping fs.watchFile() on ${h.path} (correlationId: ${h.correlationId})`);try{(0,n.unwatchFile)(h.path,f)}catch(d){this.Q(`fs.unwatchFile() failed with error ${d} on path ${h.path} (correlationId: ${h.correlationId})`)}}))}H(h){this.P(`detected ${h.path} exists again, resuming watcher (correlationId: ${h.correlationId})`);const m={resource:I.URI.file(h.path),type:T.FileChangeType.ADDED,cId:h.correlationId};this.a.fire([m]),this.J(m,h),this.C(h)}I(h){return h.ctimeMs===0&&h.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(h,m){if(this.R){const w=` >> normalized ${h.type===T.FileChangeType.ADDED?"[ADDED]":h.type===T.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`;this.L(w,m)}}L(h,m){this.R&&this.P(`${h}${typeof m.correlationId=="number"?` <${m.correlationId}> `:""}`)}M(h){return`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"}, filter: ${(0,E.$0q)(h.filter)}, correlationId: ${typeof h.correlationId=="number"?h.correlationId:"<none>"})`}async setVerboseLogging(h){this.R=h}}e.$gr=a}),define(le[179],ue([0,1,26,8,21,32,2,78,9,3,18,7,112,23,14,61]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=void 0,e.$mr=b;class v extends T.$Tc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(P,S,t,u,i,o){super(),this.s=P,this.t=S,this.u=t,this.w=u,this.y=i,this.z=o,this.c=this.B(new r.$Rh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.u(s))),this.f=this.B(new r.$Qh(s=>this.M(s),v.b)),this.g=(0,d.$8q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,d.$8q)(this.s.path,this.s.includes):void 0,this.j=(0,d.$Zq)(this.s)?this.s.filter:void 0,this.m=new E.$ue,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const P=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const S=await n.promises.stat(P);if(this.m.token.isCancellationRequested)return;this.B(await this.G(P,S.isDirectory()))}catch(P){P.code!=="ENOENT"?this.O(P):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${P})`),this.D()}}D(){this.r=!0,this.w?.()}async F(P){let S=P.path;try{S=await w.Promises.realpath(P.path),P.path===S&&(S=await(0,m.$ir)(P.path,this.m.token)??P.path),P.path!==S&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${P.path}, real: ${S})`)}catch{}return S}async G(P,S){const t=new T.$Sc;return this.H(P,S,t)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(P,S,t)),t}H(P,S,t){if(S)return!1;const u=h.URI.file(this.s.path),i=this.t?.subscribe(this.s.path,async(o,s)=>{if(!t.isDisposed)if(o){const c=await this.G(P,S);t.isDisposed?c.dispose():t.add(c)}else s&&(typeof s.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:u,type:s.type,cId:this.s.correlationId},!0)});return i?(t.add(i),!0):!1}async I(P,S,t){if(a.$k&&(0,D.$Bg)(P,"/Volumes/",!0)){this.O(`Refusing to watch ${P} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const u=new E.$ue(this.m.token);t.add((0,T.$Rc)(()=>u.dispose(!0)));const i=new T.$Sc;t.add(i);try{const o=h.URI.file(this.s.path),s=(0,p.$mc)(P),c=(0,n.watch)(P);i.add((0,T.$Rc)(()=>{c.removeAllListeners(),c.close()})),this.Q(`Started watching: '${P}'`);const l=new Set;if(S)try{for(const y of await w.Promises.readdir(P))l.add(y)}catch(y){this.O(y)}if(u.token.isCancellationRequested)return;const k=new Map;i.add((0,T.$Rc)(()=>{for(const[,y]of k)y.dispose();k.clear()})),c.on("error",(y,R)=>{u.token.isCancellationRequested||(this.O(`Failed to watch ${P} for changes using fs.watch() (${y}, ${R})`),this.D())}),c.on("change",(y,R)=>{if(u.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${y}"] ${R}`);let L="";if(R&&(L=R.toString(),a.$k&&(L=(0,I.$jm)(L))),!(!L||y!=="change"&&y!=="rename"))if(S)if(y==="rename"){k.get(L)?.dispose();const A=setTimeout(async()=>{if(k.delete(L),L===s&&!await w.Promises.exists(P)){this.J(o);return}if(u.token.isCancellationRequested)return;const O=await this.N((0,p.$ic)(P,L));if(u.token.isCancellationRequested)return;let W;O?l.has(L)?W=f.FileChangeType.UPDATED:(W=f.FileChangeType.ADDED,l.add(L)):(l.delete(L),W=f.FileChangeType.DELETED),this.L({resource:(0,g.$dh)(o,L),type:W,cId:this.s.correlationId})},v.a);k.set(L,(0,T.$Rc)(()=>clearTimeout(A)))}else{let A;l.has(L)?A=f.FileChangeType.UPDATED:(A=f.FileChangeType.ADDED,l.add(L)),this.L({resource:(0,g.$dh)(o,L),type:A,cId:this.s.correlationId})}else if(y==="rename"||L!==s){const A=setTimeout(async()=>{const O=await w.Promises.exists(P);u.token.isCancellationRequested||(O?(this.L({resource:o,type:f.FileChangeType.UPDATED,cId:this.s.correlationId},!0),i.add(await this.G(P,!1))):this.J(o))},v.a);i.clear(),i.add((0,T.$Rc)(()=>clearTimeout(A)))}else this.L({resource:o,type:f.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(o){u.token.isCancellationRequested||this.O(`Failed to watch ${P} for changes using fs.watch() (${o.toString()})`),this.D()}}J(P){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:P,type:f.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(P,S=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${P.type===f.FileChangeType.ADDED?"[ADDED]":P.type===f.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${P.resource.fsPath}`),!S&&this.g.some(t=>t(P.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${P.resource.fsPath}`):!S&&this.h&&this.h.length>0&&!this.h.some(t=>t(P.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${P.resource.fsPath}`):this.f.work(P))}M(P){const S=(0,d.$6q)(P),t=[];for(const i of S){if((0,d.$9q)(i,this.j)){this.z&&this.R(` >> ignored (filtered) ${i.resource.fsPath}`);continue}t.push(i)}if(t.length===0)return;if(this.z)for(const i of t)this.R(` >> normalized ${i.type===f.FileChangeType.ADDED?"[ADDED]":i.type===f.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`);this.c.work(t)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${t.length}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(P){if(a.$l)return w.Promises.exists(P);try{const S=(0,p.$mc)(P);return(await w.Promises.readdir((0,p.$lc)(P))).some(u=>u===S)}catch(S){return this.Q(S),!1}}setVerboseLogging(P){this.z=P}O(P){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${P}`})}P(P){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${P}`})}Q(P){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${P}`})}R(P){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${P}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$lr=v;async function b($,P,S,t,u=512){const i=await w.Promises.open($,"r"),o=Buffer.allocUnsafe(u),s=new E.$ue(t);let c,l=!1;const k={path:$,excludes:[],recursive:!1},y=new v(k,void 0,R=>{(async()=>{for(const{type:L}of R)if(L===f.FileChangeType.UPDATED){if(l)return;l=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:A}=await w.Promises.read(i,o,0,u,null);if(!A||s.token.isCancellationRequested)break;P(o.slice(0,A))}}catch(A){c=new Error(A),s.dispose(!0)}finally{l=!1}}})()});return await y.ready,S(),new Promise((R,L)=>{s.token.onCancellationRequested(async()=>{y.dispose();try{await w.Promises.close(i)}catch(A){c=new Error(A)}c?L(c):R()})})}}),define(le[180],ue([0,1,4,111,178,3,179,32]),function(Y,e,n,r,E,D,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=void 0;class p extends E.$gr{constructor(g){super(),this.O=g,this.onDidError=n.Event.None,this.watchers=new Set}async N(g){g=this.Z(g);const h=[],m=new Set(Array.from(this.watchers));for(const w of g){const f=this.W(w);f&&(0,r.$Ak)(f.request.excludes,w.excludes)&&(0,r.$Ak)(f.request.includes,w.includes)?m.delete(f):h.push(w)}h.length&&this.P(`Request to start watching: ${h.map(w=>this.M(w)).join(",")}`),m.size&&this.P(`Request to stop watching: ${Array.from(m).map(w=>this.M(w.request)).join(",")}`);for(const w of m)this.Y(w);for(const w of h)this.X(w)}W(g){for(const h of this.watchers)if(typeof g.correlationId=="number"||typeof h.request.correlationId=="number"){if(h.request.correlationId===g.correlationId)return h}else if((0,I.$Ag)(h.request.path,g.path,!D.$l))return h}X(g){const h=new T.$lr(g,this.O,w=>this.a.fire(w),()=>this.c.fire(g),w=>this.b.fire(w),this.R),m={request:g,instance:h};this.watchers.add(m)}async stop(){await super.stop();for(const g of this.watchers)this.Y(g)}Y(g){this.P("stopping file watcher",g),this.watchers.delete(g),g.instance.dispose()}Z(g){const h=new Map;for(const m of g){const w=D.$l?m.path:m.path.toLowerCase();let f=h.get(m.correlationId);f||(f=new Map,h.set(m.correlationId,f)),f.has(w)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(m)}`),f.set(w,m)}return Array.from(h.values()).map(m=>Array.from(m.values())).flat()}async setVerboseLogging(g){super.setVerboseLogging(g);for(const h of this.watchers)h.instance.setVerboseLogging(g)}P(g,h){this.R&&this.b.fire({type:"trace",message:this.bb(g,h)})}Q(g){this.b.fire({type:"warn",message:this.bb(g)})}bb(g,h){return h?`[File Watcher (node.js)] ${g} (${this.M(h.request)})`:`[File Watcher (node.js)] ${g}`}}e.$nr=p}),define(le[181],ue([0,1,61,180]),function(Y,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;class E extends n.$3q{constructor(T,I,p){super(T,I,p),this.s()}r(T){return T.add(new r.$nr(void 0))}}e.$or=E}),define(le[182],ue([0,1,11,44,158,61]),function(Y,e,n,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=void 0;class T extends D.$4q{constructor(p,a,g){super(p,a,g),this.s()}r(p){const a=p.add(new E.$er(n.$Wg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(a.onDidProcessExit(({code:g,signal:h})=>this.t(`terminated by itself with code ${g}, signal: ${h} (ETERM)`))),r.ProxyChannel.toService((0,r.$ji)(a.getChannel("watcher")))}}e.$fr=T}),define(le[98],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=void 0;class n{constructor(...E){this.a=new Map;for(const[D,T]of E)this.set(D,T)}set(E,D){const T=this.a.get(E);return this.a.set(E,D),T}has(E){return this.a.has(E)}get(E){return this.a.get(E)}}e.$Ai=n}),define(le[183],ue([0,1,8,15,2,83,172,6,98,108]),function(Y,e,n,r,E,D,T,I,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=e.$sr=void 0;const g=!1;class h extends Error{constructor(v){super("cyclic dependency between services"),this.message=v.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${v.toString()}`}}class m{constructor(v=new p.$Ai,b=!1,$,P=g){this.i=v,this.j=b,this.k=$,this.l=P,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(I.$Bi,this),this._globalGraph=P?$?._globalGraph??new T.$rr(S=>S):void 0}dispose(){if(!this.f){this.f=!0,(0,E.$Oc)(this.h),this.h.clear();for(const v of this.g)(0,E.$Nc)(v)&&v.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(v,b){this.m();const $=this,P=new class extends m{dispose(){$.h.delete(P),super.dispose()}}(v,this.j,this,this.l);return this.h.add(P),b?.add(P),P}invokeFunction(v,...b){this.m();const $=f.traceInvocation(this.l,v);let P=!1;try{return v({get:t=>{if(P)throw(0,r.$7)("service accessor is only valid during the invocation of its target method");const u=this.s(t,$);if(!u)throw new Error(`[invokeFunction] unknown service '${t}'`);return u}},...b)}finally{P=!0,$.stop()}}createInstance(v,...b){this.m();let $,P;return v instanceof D.$zi?($=f.traceCreation(this.l,v.ctor),P=this.o(v.ctor,v.staticArguments.concat(b),$)):($=f.traceCreation(this.l,v),P=this.o(v,b,$)),$.stop(),P}o(v,b=[],$){const P=I._util.getServiceDependencies(v).sort((u,i)=>u.index-i.index),S=[];for(const u of P){const i=this.s(u.id,$);i||this.y(`[createInstance] ${v.name} depends on UNKNOWN service ${u.id}.`,!1),S.push(i)}const t=P.length>0?P[0].index:b.length;if(b.length!==t){console.trace(`[createInstance] First service dependency of ${v.name} at position ${t+1} conflicts with ${b.length} static arguments`);const u=t-b.length;u>0?b=b.concat(new Array(u)):b=b.slice(0,t)}return Reflect.construct(v,b.concat(S))}q(v,b){if(this.i.get(v)instanceof D.$zi)this.i.set(v,b);else if(this.k)this.k.q(v,b);else throw new Error("illegalState - setting UNKNOWN service instance")}r(v){const b=this.i.get(v);return!b&&this.k?this.k.r(v):b}s(v,b){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(v));const $=this.r(v);return $ instanceof D.$zi?this.u(v,$,b.branch(v,!0)):(b.branch(v,!1),$)}u(v,b,$){if(this.t.has(v))throw new Error(`illegal state - RECURSIVELY instantiating service '${v}'`);this.t.add(v);try{return this.v(v,b,$)}finally{this.t.delete(v)}}v(v,b,$){const P=new T.$rr(i=>i.id.toString());let S=0;const t=[{id:v,desc:b,_trace:$}],u=new Set;for(;t.length;){const i=t.pop();if(!u.has(String(i.id))){if(u.add(String(i.id)),P.lookupOrInsertNode(i),S++>1e3)throw new h(P);for(const o of I._util.getServiceDependencies(i.desc.ctor)){const s=this.r(o.id);if(s||this.y(`[createInstance] ${v} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),s instanceof D.$zi){const c={id:o.id,desc:s,_trace:i._trace.branch(o.id,!0)};P.insertEdge(i,c),t.push(c)}}}}for(;;){const i=P.roots();if(i.length===0){if(!P.isEmpty())throw new h(P);break}for(const{data:o}of i){if(this.r(o.id)instanceof D.$zi){const c=this.w(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.q(o.id,c)}P.removeNode(o)}}return this.r(v)}w(v,b,$=[],P,S){if(this.i.get(v)instanceof D.$zi)return this.x(v,b,$,P,S,this.g);if(this.k)return this.k.w(v,b,$,P,S);throw new Error(`illegalState - creating UNKNOWN service instance ${b.name}`)}x(v,b,$=[],P,S,t){if(P){const u=new m(void 0,this.j,this,this.l);u.c=String(v);const i=new Map,o=new n.$Vh(()=>{const s=u.o(b,$,S);for(const[c,l]of i){const k=s[c];if(typeof k=="function")for(const y of l)y.disposable=k.apply(s,y.listener)}return i.clear(),t.add(s),s});return new Proxy(Object.create(null),{get(s,c){if(!o.isInitialized&&typeof c=="string"&&(c.startsWith("onDid")||c.startsWith("onWill"))){let y=i.get(c);return y||(y=new a.$4c,i.set(c,y)),(L,A,O)=>{if(o.isInitialized)return o.value[c](L,A,O);{const W={listener:[L,A,O],disposable:void 0},x=y.push(W);return(0,E.$Rc)(()=>{x(),W.disposable?.dispose()})}}}if(c in s)return s[c];const l=o.value;let k=l[c];return typeof k!="function"||(k=k.bind(l),s[c]=k),k},set(s,c,l){return o.value[c]=l,!0},getPrototypeOf(s){return b.prototype}})}else{const u=this.o(b,$,S);return t.add(u),u}}y(v,b){if(b&&console.warn(v),this.j)throw new Error(v)}}e.$sr=m;var w;(function(d){d[d.None=0]="None",d[d.Creation=1]="Creation",d[d.Invocation=2]="Invocation",d[d.Branch=3]="Branch"})(w||(w={}));class f{static{this.all=new Set}static{this.c=new class extends f{constructor(){super(w.None,null)}stop(){}branch(){return this}}}static traceInvocation(v,b){return v?new f(w.Invocation,b.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(v,b){return v?new f(w.Creation,b.name):f.c}static{this.f=0}constructor(v,b){this.type=v,this.name=b,this.g=Date.now(),this.h=[]}branch(v,b){const $=new f(w.Branch,v.toString());return this.h.push([v,b,$]),$}stop(){const v=Date.now()-this.g;f.f+=v;let b=!1;function $(S,t){const u=[],i=new Array(S+1).join("	");for(const[o,s,c]of t.h)if(s&&c){b=!0,u.push(`${i}CREATES -> ${o}`);const l=$(S+1,c);l&&u.push(l)}else u.push(`${i}uses -> ${o}`);return u.join(`
`)}const P=[`${this.type===w.Creation?"CREATE":"CALL"} ${this.name}`,`${$(1,this)}`,`DONE, took ${v.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(v>2||b)&&f.all.add(P.join(`
`))}}e.$tr=f}),define(le[184],ue([0,1,6]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k_b=e.$j_b=e.IssueSource=e.IssueType=void 0;var r;(function(D){D[D.Bug=0]="Bug",D[D.PerformanceIssue=1]="PerformanceIssue",D[D.FeatureRequest=2]="FeatureRequest"})(r||(e.IssueType=r={}));var E;(function(D){D.VSCode="vscode",D.Extension="extension",D.Marketplace="marketplace"})(E||(e.IssueSource=E={})),e.$j_b=(0,n.$Ci)("issueService"),e.$k_b=(0,n.$Ci)("processService")}),define(le[5],ue([0,1,10,54,4,46,2,31,3,18,12,7,122,6]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$_j=e.LogLevel=e.$0j=e.$9j=void 0,e.$$j=d,e.log=b,e.$kk=k,e.$lk=y,e.$mk=R,e.$nk=L,n=Ie(n),e.$9j=(0,w.$Ci)("logService"),e.$0j=(0,w.$Ci)("loggerService");function f(){return new Date().toISOString()}function d(A){return(0,g.$gg)(A)}var v;(function(A){A[A.Off=0]="Off",A[A.Trace=1]="Trace",A[A.Debug=2]="Debug",A[A.Info=3]="Info",A[A.Warning=4]="Warning",A[A.Error=5]="Error"})(v||(e.LogLevel=v={})),e.$_j=v.Info;function b(A,O,W){switch(O){case v.Trace:A.trace(W);break;case v.Debug:A.debug(W);break;case v.Info:A.info(W);break;case v.Warning:A.warn(W);break;case v.Error:A.error(W);break;case v.Off:break;default:throw new Error(`Invalid log level ${O}`)}}function $(A,O=!1){let W="";for(let x=0;x<A.length;x++){let C=A[x];if(C instanceof Error&&(C=(0,r.$nj)(C,O)),typeof C=="object")try{C=JSON.stringify(C)}catch{}W+=(x>0?" ":"")+C}return W}class P extends T.$Tc{constructor(){super(...arguments),this.b=e.$_j,this.c=this.B(new E.$je),this.onDidChangeLogLevel=this.c.event}setLevel(O){this.b!==O&&(this.b=O,this.c.fire(this.b))}getLevel(){return this.b}f(O){return this.b!==v.Off&&this.b<=O}}e.$bk=P;class S extends P{constructor(O){super(),this.h=O}f(O){return this.h||super.f(O)}trace(O,...W){this.f(v.Trace)&&this.g(v.Trace,$([O,...W],!0))}debug(O,...W){this.f(v.Debug)&&this.g(v.Debug,$([O,...W]))}info(O,...W){this.f(v.Info)&&this.g(v.Info,$([O,...W]))}warn(O,...W){this.f(v.Warning)&&this.g(v.Warning,$([O,...W]))}error(O,...W){if(this.f(v.Error))if(O instanceof Error){const x=Array.prototype.slice.call(arguments);x[0]=O.stack,this.g(v.Error,$(x))}else this.g(v.Error,$([O,...W]))}flush(){}}e.$ck=S;class t extends P{constructor(O=e.$_j){super(),this.setLevel(O),this.g=!p.$j}trace(O,...W){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,O,...W):console.log(`[main ${f()}]`,O,...W))}debug(O,...W){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,O,...W):console.log(`[main ${f()}]`,O,...W))}info(O,...W){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,O,...W):console.log(`[main ${f()}]`,O,...W))}warn(O,...W){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,O,...W):console.warn(`[main ${f()}]`,O,...W))}error(O,...W){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,O,...W):console.error(`[main ${f()}]`,O,...W))}flush(){}}e.$dk=t;class u extends P{constructor(O=e.$_j,W=!0){super(),this.g=W,this.setLevel(O)}trace(O,...W){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",O,...W):console.log(O,...W))}debug(O,...W){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",O,...W):console.log(O,...W))}info(O,...W){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",O,...W):console.log(O,...W))}warn(O,...W){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",O,...W):console.log(O,...W))}error(O,...W){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",O,...W):console.error(O,...W))}flush(){}}e.$ek=u;class i extends P{constructor(O,W=e.$_j){super(),this.g=O,this.setLevel(W)}trace(O,...W){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(O),...W])}debug(O,...W){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(O),...W])}info(O,...W){this.f(v.Info)&&this.g.log(v.Info,[this.h(O),...W])}warn(O,...W){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(O),...W])}error(O,...W){this.f(v.Error)&&this.g.log(v.Error,[this.h(O),...W])}h(O){return typeof O=="string"?O:(0,r.$nj)(O,this.f(v.Trace))}flush(){}}e.$fk=i;class o extends P{constructor(O){super(),this.g=O,O.length&&this.setLevel(O[0].getLevel())}setLevel(O){for(const W of this.g)W.setLevel(O);super.setLevel(O)}trace(O,...W){for(const x of this.g)x.trace(O,...W)}debug(O,...W){for(const x of this.g)x.debug(O,...W)}info(O,...W){for(const x of this.g)x.info(O,...W)}warn(O,...W){for(const x of this.g)x.warn(O,...W)}error(O,...W){for(const x of this.g)x.error(O,...W)}flush(){for(const O of this.g)O.flush()}dispose(){for(const O of this.g)O.dispose();super.dispose()}}e.$gk=o;class s extends T.$Tc{constructor(O,W,x){if(super(),this.h=O,this.j=W,this.b=new I.$zc,this.c=this.B(new E.$je),this.onDidChangeLoggers=this.c.event,this.f=this.B(new E.$je),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new E.$je),this.onDidChangeVisibility=this.g.event,x)for(const C of x)this.b.set(C.resource,{logger:void 0,info:C})}m(O){return(0,g.$cg)(O)?[...this.b.values()].find(W=>W.info.id===O):this.b.get(O)}getLogger(O){return this.m(O)?.logger}createLogger(O,W){const x=this.n(O),C=(0,g.$cg)(O)?O:W?.id??(0,D.$qj)(x.toString()).toString(16);let B=this.b.get(x)?.logger;const ee=W?.logLevel==="always"?v.Trace:W?.logLevel;B||(B=this.s(x,ee??this.getLogLevel(x)??this.h,{...W,id:C}));const X={logger:B,info:{resource:x,id:C,logLevel:ee,name:W?.name,hidden:W?.hidden,extensionId:W?.extensionId,when:W?.when}};return this.registerLogger(X.info),this.b.set(x,X),B}n(O){return(0,g.$cg)(O)?(0,a.$dh)(this.j,`${O}.log`):O}setLogLevel(O,W){if(h.URI.isUri(O)){const x=O,C=W,B=this.b.get(x);B&&C!==B.info.logLevel&&(B.info.logLevel=C===this.h?void 0:C,B.logger?.setLevel(C),this.b.set(B.info.resource,B),this.f.fire([x,C]))}else{this.h=O;for(const[x,C]of this.b.entries())this.b.get(x)?.info.logLevel===void 0&&C.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(O,W){const x=this.m(O);x&&W!==!x.info.hidden&&(x.info.hidden=!W,this.b.set(x.info.resource,x),this.g.fire([x.info.resource,W]))}getLogLevel(O){let W;return O&&(W=this.b.get(O)?.info.logLevel),W??this.h}registerLogger(O){const W=this.b.get(O.resource);W?W.info.hidden!==O.hidden&&this.setVisibility(O.resource,!O.hidden):(this.b.set(O.resource,{info:O,logger:void 0}),this.c.fire({added:[O],removed:[]}))}deregisterLogger(O){const W=this.b.get(O);W&&(W.logger&&W.logger.dispose(),this.b.delete(O),this.c.fire({added:[],removed:[W.info]}))}*getRegisteredLoggers(){for(const O of this.b.values())yield O.info}getRegisteredLogger(O){return this.b.get(O)?.info}dispose(){this.b.forEach(O=>O.logger?.dispose()),this.b.clear(),super.dispose()}}e.$hk=s;class c{constructor(){this.onDidChangeLogLevel=new E.$je().event}setLevel(O){}getLevel(){return v.Info}trace(O,...W){}debug(O,...W){}info(O,...W){}warn(O,...W){}error(O,...W){}critical(O,...W){}dispose(){}flush(){}}e.$ik=c;class l extends c{}e.$jk=l;function k(A){if(A.verbose)return v.Trace;if(typeof A.logLevel=="string"){const O=L(A.logLevel.toLowerCase());if(O!==void 0)return O}return e.$_j}function y(A){switch(A){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}function R(A){switch(A){case v.Trace:return{original:"Trace",value:n.localize(11152,null)};case v.Debug:return{original:"Debug",value:n.localize(11153,null)};case v.Info:return{original:"Info",value:n.localize(11154,null)};case v.Warning:return{original:"Warning",value:n.localize(11155,null)};case v.Error:return{original:"Error",value:n.localize(11156,null)};case v.Off:return{original:"Off",value:n.localize(11157,null)}}}function L(A){switch(A){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.$ok=new m.$Tj("logLevel",y(v.Info))});var se=this&&this.__param||function(Y,e){return function(n,r){e(n,r,Y)}};define(le[185],ue([0,1,13,3,97,5]),function(Y,e,n,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xfc=void 0;const T=n.safeStorage;let I=class{constructor(a){this.a=a,n.app.commandLine.getSwitchValue("password-store")===E.PasswordStoreCLIOption.basic&&T.setUsePlainTextEncryption?.(!0)}async encrypt(a){this.a.trace("[EncryptionMainService] Encrypting value.");try{const g=JSON.stringify(T.encryptString(a));return this.a.trace("[EncryptionMainService] Encrypted value."),g}catch(g){throw this.a.error(g),g}}async decrypt(a){let g;try{if(g=JSON.parse(a),!g.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${a}`);const h=Buffer.from(g.data);this.a.trace("[EncryptionMainService] Decrypting value.");const m=T.decryptString(h);return this.a.trace("[EncryptionMainService] Decrypted value."),m}catch(h){throw this.a.error(h),h}}isEncryptionAvailable(){return Promise.resolve(T.isEncryptionAvailable())}getKeyStorageProvider(){if(r.$j)return Promise.resolve(E.KnownStorageProvider.dplib);if(r.$k)return Promise.resolve(E.KnownStorageProvider.keychainAccess);if(T.getSelectedStorageBackend)try{const a=T.getSelectedStorageBackend();return Promise.resolve(a)}catch(a){this.a.error(a)}return Promise.resolve(E.KnownStorageProvider.unknown)}async setUsePlainTextEncryption(){if(r.$j)throw new Error("Setting plain text encryption is not supported on Windows.");if(r.$k)throw new Error("Setting plain text encryption is not supported on macOS.");if(!T.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");T.setUsePlainTextEncryption(!0)}};e.$xfc=I,e.$xfc=I=Ee([se(0,D.$9j)],I)}),define(le[186],ue([0,1,20,8,15,4,32,2,9,61,5]),function(Y,e,n,r,E,D,T,I,p,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;class h extends I.$Tc{constructor(w,f){super(),this.a=w,this.b=f,this.c=this.B(new D.$je),this.onDidChangeFile=this.c.event,this.g=this.B(new D.$je),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new r.$Ah(0)),this.w=[],this.y=this.B(new r.$Ah(0))}watch(w,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(w,f):this.z(w,f)}n(w,f){const d={path:this.J(w),excludes:f.excludes,includes:f.includes,recursive:f.recursive,filter:f.filter,correlationId:f.correlationId},v=(0,n.$Sb)(this.j,d);return this.r(),(0,I.$Rc)(()=>{v(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,E.$Y)(w))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,a.$5q)(f)),f=>this.G(f),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const f of this.j)(0,a.$1q)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const f of this.j)(0,a.$1q)(f)&&w.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,f){const d={path:this.J(w),excludes:f.excludes,includes:f.includes,recursive:!1,filter:f.filter,correlationId:f.correlationId},v=(0,n.$Sb)(this.w,d);return this.C(),(0,I.$Rc)(()=>{v(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,E.$Y)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,a.$5q)(w)),w=>this.G(w),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.H(w)}H(w){this.a[w.type](w.message)}I(w){return(0,p.$gc)(w.fsPath)}J(w){const f=this.I(w);return(0,T.$Eg)(f)}}e.$$q=h}),define(le[187],ue([0,1,20,8,16,21,4,46,77,2,60,11,70,18,67,10,14,124,5,15]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w,f,d,v,b,$,P){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=void 0;let t=class extends a.$Tc{static{S=this}constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new T.$je),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new T.$je),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new T.$je),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new T.$je),this.onDidRunOperation=this.r.event,this.X=this.B(new T.$je),this.Y=this.B(new T.$je),this.onDidFilesChange=this.Y.event,this.Z=this.B(new T.$je),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new r.$Lh)}registerProvider(i,o){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${i}`);const s=new a.$Sc;return this.h.set(i,o),this.c.fire({added:!0,scheme:i,provider:o}),s.add(o.onDidChangeFile(c=>{const l=new v.$pl(c,!this.S(o));this.X.fire(l),l.hasCorrelation()||this.Y.fire(l)})),typeof o.onDidWatchError=="function"&&s.add(o.onDidWatchError(c=>this.Z.fire(new Error(c)))),s.add(o.onDidChangeCapabilities(()=>this.g.fire({provider:o,scheme:i}))),(0,a.$Rc)(()=>{this.c.fire({added:!1,scheme:i,provider:o}),this.h.delete(i),(0,a.$Oc)(s)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const o=[];this.f.fire({scheme:i,join(s){o.push(s)}}),!this.h.has(i)&&await r.Promises.settled(o)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,o){const s=this.h.get(i.scheme);return!!(s&&s.capabilities&o)}listCapabilities(){return p.Iterable.map(this.h,([i,o])=>({scheme:i,capabilities:o.capabilities}))}async j(i){if(!(0,w.$hh)(i))throw new v.$rl((0,d.localize)(11225,null,this.sb(i)),v.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(i.scheme);const o=this.h.get(i.scheme);if(!o){const s=new P.$ab;throw s.message=(0,d.localize)(11226,null,i.toString()),s}return o}async m(i){const o=await this.j(i);if((0,v.$cl)(o)||(0,v.$_k)(o)||(0,v.$dl)(o))return o;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(i){const o=await this.j(i);if((0,v.$cl)(o)||(0,v.$_k)(o))return o;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,o){try{return await this.s(i,o)}catch(s){throw(0,v.$ml)(s)===v.FileSystemProviderErrorCode.FileNotFound?new v.$rl((0,d.localize)(11227,null,this.sb(i)),v.FileOperationResult.FILE_NOT_FOUND):(0,v.$kl)(s)}}async s(i,o){const s=await this.j(i),c=this.S(s),l=o?.resolveTo,k=o?.resolveSingleChildDescendants,y=o?.resolveMetadata,R=await s.stat(i);let L;return this.t(s,i,R,void 0,!!y,(A,O)=>(L||(L=g.$Ii.forUris(()=>!c),L.set(i,!0),l&&L.fill(!0,l)),L.get(A.resource)||L.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&k?O===1:!1))}async t(i,o,s,c,l,k){const{providerExtUri:y}=this.R(i),R={resource:o,name:y.basename(o),isFile:(s.type&v.FileType.File)!==0,isDirectory:(s.type&v.FileType.Directory)!==0,isSymbolicLink:(s.type&v.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&v.FilePermission.Readonly)||!!(i.capabilities&v.FileSystemProviderCapabilities.Readonly),locked:!!((s.permissions??0)&v.FilePermission.Locked),etag:(0,v.$Cl)({mtime:s.mtime,size:s.size}),children:void 0};if(R.isDirectory&&k(R,c)){try{const L=await i.readdir(o),A=await r.Promises.settled(L.map(async([O,W])=>{try{const x=y.joinPath(o,O),C=l?await i.stat(x):{type:W};return await this.t(i,x,C,L.length,l,k)}catch(x){return this.b.trace(x),null}}));R.children=(0,n.$Gb)(A)}catch(L){this.b.trace(L),R.children=[]}return R}return R}async resolveAll(i){return r.Promises.settled(i.map(async o=>{try{return{stat:await this.s(o.resource,o.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(i){const o=await this.j(i),s=await o.stat(i);return this.t(o,i,s,void 0,!0,()=>!1)}async exists(i){const o=await this.j(i);try{return!!await o.stat(i)}catch{return!1}}async canCreateFile(i,o){try{await this.u(i,o)}catch(s){return s}return!0}async u(i,o){if(!o?.overwrite&&await this.exists(i))throw new v.$rl((0,d.localize)(11228,null,this.sb(i)),v.FileOperationResult.FILE_MODIFIED_SINCE,o)}async createFile(i,o=E.$Le.fromString(""),s){await this.u(i,s);const c=await this.writeFile(i,o);return this.r.fire(new v.$ol(i,v.FileOperation.CREATE,c)),c}async writeFile(i,o,s){const c=this.qb(await this.n(i),i),{providerExtUri:l}=this.R(c);let k=s;if((0,v.$fl)(c)&&!k?.atomic){const y=c.enforceAtomicWriteFile?.(i);y&&(k={...s,atomic:y})}try{await this.w(c,i,k)||await this.U(c,l.dirname(i));let R;if((0,v.$_k)(c)&&!(o instanceof E.$Le))if((0,f.$xe)(o)){const L=await(0,f.$Ee)(o,3);L.ended?R=E.$Le.concat(L.buffer):R=L}else R=(0,f.$Be)(o,L=>E.$Le.concat(L),3);else R=o;!(0,v.$cl)(c)||(0,v.$_k)(c)&&R instanceof E.$Le||(0,v.$_k)(c)&&(0,v.$fl)(c)&&k?.atomic?await this.hb(c,i,k,R):await this.db(c,i,k,R instanceof E.$Le?(0,E.$We)(R):R),this.r.fire(new v.$ol(i,v.FileOperation.WRITE))}catch(y){throw new v.$rl((0,d.localize)(11229,null,this.sb(i),(0,v.$kl)(y).toString()),(0,v.$nl)(y),k)}return this.resolve(i,{resolveMetadata:!0})}async w(i,o,s){const c=!!s?.unlock;if(c&&!(i.capabilities&v.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,d.localize)(11230,null,this.sb(o)));if(!!s?.atomic){if(!(i.capabilities&v.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,d.localize)(11231,null,this.sb(o)));if(!(i.capabilities&v.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,d.localize)(11232,null,this.sb(o)));if(c)throw new Error((0,d.localize)(11233,null,this.sb(o)))}let k;try{k=await i.stat(o)}catch{return}if(k.type&v.FileType.Directory)throw new v.$rl((0,d.localize)(11234,null,this.sb(o)),v.FileOperationResult.FILE_IS_DIRECTORY,s);if(this.rb(o,k),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==v.$Bl&&typeof k.mtime=="number"&&typeof k.size=="number"&&s.mtime<k.mtime&&s.etag!==(0,v.$Cl)({mtime:s.mtime,size:k.size}))throw new v.$rl((0,d.localize)(11235,null),v.FileOperationResult.FILE_MODIFIED_SINCE,s);return k}async readFile(i,o,s){const c=await this.m(i);return o?.atomic?this.z(c,i,o,s):this.C(c,i,o,s)}async z(i,o,s,c){return new Promise((l,k)=>{this.cb.queueFor(o,async()=>{try{const y=await this.C(i,o,s,c);l(y)}catch(y){k(y)}},this.R(i).providerExtUri)})}async C(i,o,s,c){const l=await this.D(i,o,{...s,preferUnbuffered:!0},c);return{...l,value:await(0,E.$Xe)(l.value)}}async readFileStream(i,o,s){const c=await this.m(i);return this.D(c,i,o,s)}async D(i,o,s,c){const l=new D.$ue(c);let k=s;(0,v.$el)(i)&&i.enforceAtomicReadFile?.(o)&&(k={...s,atomic:!0});const y=this.J(o,k).then(L=>L,L=>{throw l.dispose(!0),L});let R;try{return typeof k?.etag=="string"&&k.etag!==v.$Bl&&await y,k?.atomic&&(0,v.$el)(i)||!((0,v.$cl)(i)||(0,v.$dl)(i))||(0,v.$_k)(i)&&k?.preferUnbuffered?R=this.I(i,o,k):(0,v.$dl)(i)?R=this.G(i,o,l.token,k):R=this.H(i,o,l.token,k),R.on("end",()=>l.dispose()),R.on("error",()=>l.dispose()),{...await y,value:R}}catch(L){throw R&&await(0,f.$Ce)(R),this.F(L,o,k)}}F(i,o,s){const c=(0,d.localize)(11236,null,this.sb(o),(0,v.$kl)(i).toString());return i instanceof v.$tl?new v.$tl(c,i.stat,s):i instanceof v.$sl?new v.$sl(c,i.fileOperationResult,i.size,i.options):new v.$rl(c,(0,v.$nl)(i),s)}G(i,o,s,c=Object.create(null)){const l=i.readFileStream(o,c,s);return(0,f.$Ie)(l,{data:k=>k instanceof E.$Le?k:E.$Le.wrap(k),error:k=>this.F(k,o,c)},k=>E.$Le.concat(k))}H(i,o,s,c=Object.create(null)){const l=(0,E.$2e)();return(0,b.$Xq)(i,o,l,k=>k,{...c,bufferSize:this.a,errorTransformer:k=>this.F(k,o,c)},s),l}I(i,o,s){const c=(0,f.$ze)(l=>E.$Le.concat(l));return(async()=>{try{let l;s?.atomic&&(0,v.$el)(i)?l=await i.readFile(o,{atomic:!0}):l=await i.readFile(o),typeof s?.position=="number"&&(l=l.slice(s.position)),typeof s?.length=="number"&&(l=l.slice(0,s.length)),this.L(o,l.byteLength,s),c.end(E.$Le.wrap(l))}catch(l){c.error(l),c.end()}})(),c}async J(i,o){const s=await this.resolve(i,{resolveMetadata:!0});if(s.isDirectory)throw new v.$rl((0,d.localize)(11237,null,this.sb(i)),v.FileOperationResult.FILE_IS_DIRECTORY,o);if(typeof o?.etag=="string"&&o.etag!==v.$Bl&&o.etag===s.etag)throw new v.$tl((0,d.localize)(11238,null),s,o);return this.L(i,s.size,o),s}L(i,o,s){if(typeof s?.limits?.size=="number"&&o>s.limits.size)throw new v.$sl((0,d.localize)(11239,null,this.sb(i)),v.FileOperationResult.FILE_TOO_LARGE,o,s)}async canMove(i,o,s){return this.M(i,o,"move",s)}async canCopy(i,o,s){return this.M(i,o,"copy",s)}async M(i,o,s,c){if(i.toString()!==o.toString())try{const l=s==="move"?this.qb(await this.n(i),i):await this.m(i),k=this.qb(await this.n(o),o);await this.Q(l,i,k,o,s,c)}catch(l){return l}return!0}async move(i,o,s){const c=this.qb(await this.n(i),i),l=this.qb(await this.n(o),o),k=await this.N(c,i,l,o,"move",!!s),y=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new v.$ol(i,k==="move"?v.FileOperation.MOVE:v.FileOperation.COPY,y)),y}async copy(i,o,s){const c=await this.m(i),l=this.qb(await this.n(o),o),k=await this.N(c,i,l,o,"copy",!!s),y=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new v.$ol(i,k==="copy"?v.FileOperation.COPY:v.FileOperation.MOVE,y)),y}async N(i,o,s,c,l,k){if(o.toString()===c.toString())return l;const{exists:y,isSameResourceWithDifferentPathCase:R}=await this.Q(i,o,s,c,l,k);if(y&&!R&&k&&await this.del(c,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(c)),l==="copy"){if(i===s&&(0,v.$al)(i))await i.copy(o,c,{overwrite:k});else{const L=await this.resolve(o);L.isDirectory?await this.P(i,L,s,c):await this.O(i,o,s,c)}return l}else return i===s?(await i.rename(o,c,{overwrite:k}),l):(await this.N(i,o,s,c,"copy",k),await this.del(o,{recursive:!0}),"copy")}async O(i,o,s,c){if((0,v.$cl)(i)&&(0,v.$cl)(s))return this.jb(i,o,s,c);if((0,v.$cl)(i)&&(0,v.$_k)(s))return this.pb(i,o,s,c);if((0,v.$_k)(i)&&(0,v.$cl)(s))return this.nb(i,o,s,c);if((0,v.$_k)(i)&&(0,v.$_k)(s))return this.lb(i,o,s,c)}async P(i,o,s,c){await s.mkdir(c),Array.isArray(o.children)&&await r.Promises.settled(o.children.map(async l=>{const k=this.R(s).providerExtUri.joinPath(c,l.name);return l.isDirectory?this.P(i,await this.resolve(l.resource),s,k):this.O(i,l.resource,s,k)}))}async Q(i,o,s,c,l,k){let y=!1;if(i===s){const{providerExtUri:L,isPathCaseSensitive:A}=this.R(i);if(A||(y=L.isEqual(o,c)),y&&l==="copy")throw new Error((0,d.localize)(11240,null,this.sb(o),this.sb(c)));if(!y&&L.isEqualOrParent(c,o))throw new Error((0,d.localize)(11241,null,this.sb(o),this.sb(c)))}const R=await this.exists(c);if(R&&!y){if(!k)throw new v.$rl((0,d.localize)(11242,null,this.sb(o),this.sb(c)),v.FileOperationResult.FILE_MOVE_CONFLICT);if(i===s){const{providerExtUri:L}=this.R(i);if(L.isEqualOrParent(o,c))throw new Error((0,d.localize)(11243,null,this.sb(o),this.sb(c)))}}return{exists:R,isSameResourceWithDifferentPathCase:y}}R(i){const o=this.S(i);return{providerExtUri:o?w.$6g:w.$8g,isPathCaseSensitive:o}}S(i){return!!(i.capabilities&v.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(i){const o=this.qb(await this.j(i),i);await this.U(o,i);const s=await this.resolve(i,{resolveMetadata:!0});return this.r.fire(new v.$ol(i,v.FileOperation.CREATE,s)),s}async U(i,o){const s=[],{providerExtUri:c}=this.R(i);for(;!c.isEqual(o,c.dirname(o));)try{if(!((await i.stat(o)).type&v.FileType.Directory))throw new Error((0,d.localize)(11244,null,this.sb(o)));break}catch(l){if((0,v.$ml)(l)!==v.FileSystemProviderErrorCode.FileNotFound)throw l;s.push(c.basename(o)),o=c.dirname(o)}for(let l=s.length-1;l>=0;l--){o=c.joinPath(o,s[l]);try{await i.mkdir(o)}catch(k){if((0,v.$ml)(k)!==v.FileSystemProviderErrorCode.FileExists)throw k}}}async canDelete(i,o){try{await this.W(i,o)}catch(s){return s}return!0}async W(i,o){const s=this.qb(await this.j(i),i),c=!!o?.useTrash;if(c&&!(s.capabilities&v.FileSystemProviderCapabilities.Trash))throw new Error((0,d.localize)(11245,null,this.sb(i)));const l=o?.atomic;if(l&&!(s.capabilities&v.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,d.localize)(11246,null,this.sb(i)));if(c&&l)throw new Error((0,d.localize)(11247,null,this.sb(i)));let k;try{k=await s.stat(i)}catch{}if(k)this.rb(i,k);else throw new v.$rl((0,d.localize)(11248,null,this.sb(i)),v.FileOperationResult.FILE_NOT_FOUND);if(!!!o?.recursive){const R=await this.resolve(i);if(R.isDirectory&&Array.isArray(R.children)&&R.children.length>0)throw new Error((0,d.localize)(11249,null,this.sb(i)))}return s}async del(i,o){const s=await this.W(i,o);let c=o;if((0,v.$gl)(s)&&!c?.atomic){const R=s.enforceAtomicDelete?.(i);R&&(c={...o,atomic:R})}const l=!!c?.useTrash,k=!!c?.recursive,y=c?.atomic??!1;await s.delete(i,{recursive:k,useTrash:l,atomic:y}),this.r.fire(new v.$ol(i,v.FileOperation.DELETE))}async cloneFile(i,o){const s=await this.j(i),c=this.qb(await this.n(o),o);if(!(s===c&&this.R(s).providerExtUri.isEqual(i,o)))return s===c&&(0,v.$bl)(s)?s.cloneFile(i,o):(await this.U(c,this.R(c).providerExtUri.dirname(o)),s===c&&(0,v.$al)(s)?this.cb.queueFor(i,()=>s.copy(i,o,{overwrite:!0}),this.R(s).providerExtUri):this.cb.queueFor(i,()=>this.O(s,i,c,o),this.R(s).providerExtUri))}static{this.ab=0}createWatcher(i,o){return this.watch(i,{...o,correlationId:S.ab++})}watch(i,o={recursive:!1,excludes:[]}){const s=new a.$Sc;let c=!1,l=()=>{c=!0};s.add((0,a.$Rc)(()=>l())),(async()=>{try{const y=await this.bb(i,o);c?(0,a.$Oc)(y):l=()=>(0,a.$Oc)(y)}catch(y){this.b.error(y)}})();const k=o.correlationId;if(typeof k=="number"){const y=s.add(new T.$je);return s.add(this.X.event(L=>{L.correlates(k)&&y.fire(L)})),{onDidChange:y.event,dispose:()=>s.dispose()}}return s}async bb(i,o){const s=await this.j(i),c=(0,I.$qj)([this.R(s).providerExtUri.getComparisonKey(i),o]);let l=this.$.get(c);return l||(l={count:0,disposable:s.watch(i,o)},this.$.set(c,l)),l.count+=1,(0,a.$Rc)(()=>{l&&(l.count--,l.count===0&&((0,a.$Oc)(l.disposable),this.$.delete(c)))})}dispose(){super.dispose();for(const[,i]of this.$)(0,a.$Oc)(i.disposable);this.$.clear()}async db(i,o,s,c){return this.cb.queueFor(o,async()=>{const l=await i.open(o,{create:!0,unlock:s?.unlock??!1});try{(0,f.$xe)(c)||(0,f.$ye)(c)?await this.eb(i,l,c):await this.fb(i,l,c)}catch(k){throw(0,v.$kl)(k)}finally{await i.close(l)}},this.R(i).providerExtUri)}async eb(i,o,s){let c=0,l;if((0,f.$ye)(s)){if(s.buffer.length>0){const k=E.$Le.concat(s.buffer);await this.gb(i,o,k,k.byteLength,c,0),c+=k.byteLength}if(s.ended)return;l=s.stream}else l=s;return new Promise((k,y)=>{(0,f.$De)(l,{onData:async R=>{l.pause();try{await this.gb(i,o,R,R.byteLength,c,0)}catch(L){return y(L)}c+=R.byteLength,setTimeout(()=>l.resume())},onError:R=>y(R),onEnd:()=>k()})})}async fb(i,o,s){let c=0,l;for(;(l=s.read())!==null;)await this.gb(i,o,l,l.byteLength,c,0),c+=l.byteLength}async gb(i,o,s,c,l,k){let y=0;for(;y<c;){const R=await i.write(o,l+y,s.buffer,k+y,c-y);y+=R}}async hb(i,o,s,c){return this.cb.queueFor(o,()=>this.ib(i,o,s,c),this.R(i).providerExtUri)}async ib(i,o,s,c){let l;c instanceof E.$Le?l=c:(0,f.$xe)(c)?l=await(0,E.$Xe)(c):(0,f.$ye)(c)?l=await(0,E.$Ye)(c):l=(0,E.$Ve)(c),await i.writeFile(o,l.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(i,o,s,c){return this.cb.queueFor(c,()=>this.kb(i,o,s,c),this.R(s).providerExtUri)}async kb(i,o,s,c){let l,k;try{l=await i.open(o,{create:!1}),k=await s.open(c,{create:!0,unlock:!1});const y=E.$Le.alloc(this.a);let R=0,L=0,A=0;do A=await i.read(l,R,y.buffer,L,y.byteLength-L),await this.gb(s,k,y,A,R,L),R+=A,L+=A,L===y.byteLength&&(L=0);while(A>0)}catch(y){throw(0,v.$kl)(y)}finally{await r.Promises.settled([typeof l=="number"?i.close(l):Promise.resolve(),typeof k=="number"?s.close(k):Promise.resolve()])}}async lb(i,o,s,c){return this.cb.queueFor(c,()=>this.mb(i,o,s,c),this.R(s).providerExtUri)}async mb(i,o,s,c){return s.writeFile(c,await i.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(i,o,s,c){return this.cb.queueFor(c,()=>this.ob(i,o,s,c),this.R(s).providerExtUri)}async ob(i,o,s,c){const l=await s.open(c,{create:!0,unlock:!1});try{const k=await i.readFile(o);await this.gb(s,l,E.$Le.wrap(k),k.byteLength,0,0)}catch(k){throw(0,v.$kl)(k)}finally{await s.close(l)}}async pb(i,o,s,c){const l=await(0,E.$Xe)(this.H(i,o,D.CancellationToken.None));await this.hb(s,c,void 0,l)}qb(i,o){if(i.capabilities&v.FileSystemProviderCapabilities.Readonly)throw new v.$rl((0,d.localize)(11250,null,this.sb(o)),v.FileOperationResult.FILE_PERMISSION_DENIED);return i}rb(i,o){if((o.permissions??0)&v.FilePermission.Readonly)throw new v.$rl((0,d.localize)(11251,null,this.sb(i)),v.FileOperationResult.FILE_PERMISSION_DENIED)}sb(i){return i.scheme===h.Schemas.file?i.fsPath:i.toString(!0)}};e.$Yq=t,e.$Yq=t=S=Ee([se(0,$.$9j)],t)}),define(le[99],ue([0,1,26,8,31,16,4,32,2,9,3,18,67,23,10,14,124,186,182,181]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w,f,d,v,b,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class S extends b.$$q{static{this.L=!1}constructor(u,i){super(u,i),this.onDidChangeCapabilities=T.Event.None,this.P=new E.$zc(o=>h.$7g.getComparisonKey(o)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=d.FileSystemProviderCapabilities.FileReadWrite|d.FileSystemProviderCapabilities.FileOpenReadWriteClose|d.FileSystemProviderCapabilities.FileReadStream|d.FileSystemProviderCapabilities.FileFolderCopy|d.FileSystemProviderCapabilities.FileWriteUnlock|d.FileSystemProviderCapabilities.FileAtomicRead|d.FileSystemProviderCapabilities.FileAtomicWrite|d.FileSystemProviderCapabilities.FileAtomicDelete|d.FileSystemProviderCapabilities.FileClone,g.$l&&(this.M|=d.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(u){try{const{stat:i,symbolicLink:o}=await w.SymlinkSupport.stat(this.I(u));return{type:this.O(i,o),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:d.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(u){try{return await this.stat(u)}catch{return}}async readdir(u){try{const i=await w.Promises.readdir(this.I(u),{withFileTypes:!0}),o=[];return await Promise.all(i.map(async s=>{try{let c;s.isSymbolicLink()?c=(await this.stat((0,h.$dh)(u,s.name))).type:c=this.O(s),o.push([s.name,c])}catch(c){this.a.trace(c)}})),o}catch(i){throw this.hb(i)}}O(u,i){let o;return i?.dangling?o=d.FileType.Unknown:u.isFile()?o=d.FileType.File:u.isDirectory()?o=d.FileType.Directory:o=d.FileType.Unknown,i&&(o|=d.FileType.SymbolicLink),o}async Q(u){const i=this.I(u);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let o;for(;o=this.P.get(u);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await o.wait();const s=new r.$Bh;return this.P.set(u,s),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,p.$Rc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(u)===s&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(u)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),s.open()})}async readFile(u,i){let o;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(u)})`),o=await this.Q(u));const s=this.I(u);return await n.promises.readFile(s)}catch(s){throw this.hb(s)}finally{o?.dispose()}}R(u){S.L&&this.a.trace(u)}readFileStream(u,i,o){const s=(0,m.$ze)(c=>D.$Le.concat(c.map(l=>D.$Le.wrap(l))).buffer);return(0,v.$Xq)(this,u,s,c=>c.buffer,{...i,bufferSize:256*1024},o),s}async writeFile(u,i,o){return o?.atomic!==!1&&o?.atomic?.postfix&&await this.S(u)?this.U(u,(0,h.$dh)((0,h.$ch)(u),`${(0,h.$ah)(u)}${o.atomic.postfix}`),i,o):this.W(u,i,o)}async S(u){try{const i=this.I(u),{symbolicLink:o}=await w.SymlinkSupport.stat(i);if(o)return!1}catch{}return!0}async U(u,i,o,s){const c=new p.$Sc;try{c.add(await this.Q(u)),c.add(await this.Q(i)),await this.W(i,o,s,!0);try{await this.rename(i,u,{overwrite:!0})}catch(l){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw l}}finally{c.dispose()}}async W(u,i,o,s){let c;try{const l=this.I(u);if(!o.create||!o.overwrite){if(await w.Promises.exists(l)){if(!o.overwrite)throw(0,d.$jl)((0,f.localize)(11209,null),d.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,d.$jl)((0,f.localize)(11210,null),d.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(u,{create:!0,unlock:o.unlock},s),await this.write(c,0,i,0,i.byteLength)}catch(l){throw await this.ib(u,l)}finally{typeof c=="number"&&await this.close(c)}}static{this.$=!0}static configureFlushOnWrite(u){S.$=u}async open(u,i,o){const s=this.I(u);let c;(0,d.$0k)(i)&&!o&&(c=await this.Q(u));let l;try{if((0,d.$0k)(i)&&i.unlock)try{const{stat:y}=await w.SymlinkSupport.stat(s);y.mode&128||await n.promises.chmod(s,y.mode|128)}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}let k;if((0,d.$0k)(i)){if(g.$j)try{await n.promises.truncate(s,0),k="r+"}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}k||(k="w")}else k="r";l=await w.Promises.open(s,k)}catch(k){throw c?.dispose(),(0,d.$0k)(i)?await this.ib(u,k):this.hb(k)}if(this.X.set(l,0),(0,d.$0k)(i)&&this.Z.set(l,u),c){const k=this.Y.get(l);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${s})`),this.Y.set(l,c),k&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${s})`),k.dispose())}return l}async close(u){const i=this.Y.get(u);try{if(this.X.delete(u),this.Z.delete(u)&&S.$)try{await w.Promises.fdatasync(u)}catch(o){S.configureFlushOnWrite(!1),this.a.error(o)}return await w.Promises.close(u)}catch(o){throw this.hb(o)}finally{i&&(this.Y.get(u)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${u}`),this.Y.delete(u)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${u}`),i.dispose())}}async read(u,i,o,s,c){const l=this.ab(u,i);let k=null;try{k=(await w.Promises.read(u,o,s,c,l)).bytesRead}catch(y){throw this.hb(y)}finally{this.bb(u,l,k)}return k}ab(u,i){return i===this.X.get(u)?null:i}bb(u,i,o){const s=this.X.get(u);typeof s=="number"&&(typeof i=="number"||(typeof o=="number"?this.X.set(u,s+o):this.X.delete(u)))}async write(u,i,o,s,c){return(0,r.$Wh)(()=>this.cb(u,i,o,s,c),100,3)}async cb(u,i,o,s,c){const l=this.ab(u,i);let k=null;try{k=(await w.Promises.write(u,o,s,c,l)).bytesWritten}catch(y){throw await this.ib(this.Z.get(u),y)}finally{this.bb(u,l,k)}return k}async mkdir(u){try{await n.promises.mkdir(this.I(u))}catch(i){throw this.hb(i)}}async delete(u,i){try{const o=this.I(u);if(i.recursive){let s;i?.atomic!==!1&&i.atomic.postfix&&(s=(0,a.$ic)((0,a.$lc)(o),`${(0,a.$mc)(o)}${i.atomic.postfix}`)),await w.Promises.rm(o,w.RimRafMode.MOVE,s)}else try{await n.promises.unlink(o)}catch(s){if(s.code==="EPERM"||s.code==="EISDIR"){let c=!1;try{const{stat:l,symbolicLink:k}=await w.SymlinkSupport.stat(o);c=l.isDirectory()&&!k}catch{}if(c)await n.promises.rmdir(o);else throw s}else throw s}}catch(o){throw this.hb(o)}}async rename(u,i,o){const s=this.I(u),c=this.I(i);if(s!==c)try{await this.db(u,i,"move",o.overwrite),await w.Promises.rename(s,c)}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,f.localize)(11211,null,(0,a.$mc)(s),(0,a.$mc)((0,a.$lc)(c)),l.toString()))),this.hb(l)}}async copy(u,i,o){const s=this.I(u),c=this.I(i);if(s!==c)try{await this.db(u,i,"copy",o.overwrite),await w.Promises.copy(s,c,{preserveSymlinks:!0})}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,f.localize)(11212,null,(0,a.$mc)(s),(0,a.$mc)((0,a.$lc)(c)),l.toString()))),this.hb(l)}}async db(u,i,o,s){const c=this.I(u),l=this.I(i);let k=!1;if(!!(this.capabilities&d.FileSystemProviderCapabilities.PathCaseSensitive)||(k=(0,I.$Ag)(c,l,!0)),k){if(o==="copy")throw(0,d.$jl)((0,f.localize)(11213,null),d.FileSystemProviderErrorCode.FileExists);if(o==="move")return}const R=await this.N(u);if(!R)throw(0,d.$jl)((0,f.localize)(11214,null),d.FileSystemProviderErrorCode.FileNotFound);const L=await this.N(i);if(L){if(!s)throw(0,d.$jl)((0,f.localize)(11215,null),d.FileSystemProviderErrorCode.FileExists);R.type&d.FileType.File&&L.type&d.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(u,i){return this.eb(u,i,!1)}async eb(u,i,o){const s=this.I(u),c=this.I(i),l=!!(this.capabilities&d.FileSystemProviderCapabilities.PathCaseSensitive);if((0,I.$Ag)(s,c,!l))return;const k=new p.$Sc;try{k.add(await this.Q(u)),k.add(await this.Q(i)),o&&await n.promises.mkdir((0,a.$lc)(c),{recursive:!0}),await n.promises.copyFile(s,c)}catch(y){if(y.code==="ENOENT"&&!o)return this.eb(u,i,!0);throw this.hb(y)}finally{k.dispose()}}t(u,i,o){return new $.$fr(s=>u(s),s=>i(s),o)}F(u,i,o){return new P.$or(s=>u(s),s=>i(s),o)}hb(u){if(u instanceof d.$il)return u;let i=u,o;switch(u.code){case"ENOENT":o=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=d.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${u.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,o=d.FileSystemProviderErrorCode.Unknown;break;default:o=d.FileSystemProviderErrorCode.Unknown}return(0,d.$jl)(i,o)}async ib(u,i){let o=this.hb(i);if(u&&o.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await w.SymlinkSupport.stat(this.I(u));s.mode&128||(o=(0,d.$jl)(i,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.a.trace(s)}return o}}e.$pr=S}),define(le[188],ue([0,1,4,99,2,16,67,21]),function(Y,e,n,r,E,D,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1s=e.$Zs=void 0;class p extends E.$Tc{constructor(h,m){super(),this.a=h,this.b=m,this.F=new Map,this.G=new Map}call(h,m,w){const f=this.c(h);switch(m){case"stat":return this.g(f,w[0]);case"readdir":return this.h(f,w[0]);case"open":return this.r(f,w[0],w[1]);case"close":return this.s(w[0]);case"read":return this.t(w[0],w[1],w[2]);case"readFile":return this.j(f,w[0],w[1]);case"write":return this.u(w[0],w[1],w[2],w[3],w[4]);case"writeFile":return this.n(f,w[0],w[1],w[2]);case"rename":return this.z(f,w[0],w[1],w[2]);case"copy":return this.C(f,w[0],w[1],w[2]);case"cloneFile":return this.D(f,w[0],w[1]);case"mkdir":return this.w(f,w[0]);case"delete":return this.y(f,w[0],w[1]);case"watch":return this.I(f,w[0],w[1],w[2],w[3]);case"unwatch":return this.J(w[0],w[1])}throw new Error(`IPC Command ${m} not found`)}listen(h,m,w){const f=this.c(h);switch(m){case"fileChange":return this.H(f,w[0]);case"readFileStream":return this.m(f,w[0],w[1])}throw new Error(`Unknown event ${m}`)}g(h,m){const w=this.f(h,m,!0);return this.a.stat(w)}h(h,m){const w=this.f(h,m);return this.a.readdir(w)}async j(h,m,w){const f=this.f(h,m,!0),d=await this.a.readFile(f,w);return D.$Le.wrap(d)}m(h,m,w){const f=this.f(h,m,!0),d=new I.$ue,v=new n.$je({onDidRemoveLastListener:()=>{d.cancel()}}),b=this.a.readFileStream(f,w,d.token);return(0,T.$De)(b,{onData:$=>v.fire(D.$Le.wrap($)),onError:$=>v.fire($),onEnd:()=>{v.fire("end"),v.dispose(),d.dispose()}}),v.event}n(h,m,w,f){const d=this.f(h,m);return this.a.writeFile(d,w.buffer,f)}r(h,m,w){const f=this.f(h,m,!0);return this.a.open(f,w)}s(h){return this.a.close(h)}async t(h,m,w){const f=D.$Le.alloc(w),v=await this.a.read(h,m,f.buffer,0,w);return[f,v]}u(h,m,w,f,d){return this.a.write(h,m,w.buffer,f,d)}w(h,m){const w=this.f(h,m);return this.a.mkdir(w)}y(h,m,w){const f=this.f(h,m);return this.a.delete(f,w)}z(h,m,w,f){const d=this.f(h,m),v=this.f(h,w);return this.a.rename(d,v,f)}C(h,m,w,f){const d=this.f(h,m),v=this.f(h,w);return this.a.copy(d,v,f)}D(h,m,w){const f=this.f(h,m),d=this.f(h,w);return this.a.cloneFile(f,d)}H(h,m){const w=new n.$je({onWillAddFirstListener:()=>{this.F.set(m,this.L(h,w))},onDidRemoveLastListener:()=>{(0,E.$Oc)(this.F.get(m)),this.F.delete(m)}});return w.event}async I(h,m,w,f,d){const v=this.F.get(m);if(v){const b=this.f(h,f),$=v.watch(w,b,d);this.G.set(m+w,$)}}async J(h,m){const w=h+m,f=this.G.get(w);f&&((0,E.$Oc)(f),this.G.delete(w))}dispose(){super.dispose();for(const[,h]of this.G)h.dispose();this.G.clear();for(const[,h]of this.F)h.dispose();this.F.clear()}}e.$Zs=p;class a extends E.$Tc{constructor(h,m,w,f){super(),this.c=h,this.f=w,this.g=f,this.a=new Map,this.b=this.B(new r.$pr(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(m)}h(h){const m=this.B(new n.$je);this.B(m.event(w=>{h.fire(w.map(f=>({resource:this.c.transformOutgoingURI(f.resource),type:f.type,cId:f.cId})))})),this.B(this.b.onDidChangeFile(w=>m.fire(w))),this.B(this.b.onDidWatchError(w=>h.fire(w)))}j(h){}m(h){}watch(h,m,w){const f=this.m(this.g);return Array.isArray(f)&&(w.excludes=[...w.excludes,...f]),this.a.set(h,this.b.watch(m,w)),(0,E.$Rc)(()=>{(0,E.$Oc)(this.a.get(h)),this.a.delete(h)})}dispose(){for(const[,h]of this.a)h.dispose();this.a.clear(),super.dispose()}}e.$1s=a}),define(le[189],ue([0,1,13,10,3,7,14,9,188,149,54]),function(Y,e,n,r,E,D,T,I,p,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ffc=void 0;class h extends p.$Zs{constructor(f,d,v){super(f,d),this.M=v}c(f){return a.$Jn}f(f,d){return D.URI.revive(d)}async y(f,d,v){if(!v.useTrash)return super.y(f,d,v);const b=this.f(f,d),$=(0,I.$gc)(b.fsPath);try{await n.shell.trashItem($)}catch(P){throw(0,T.$jl)(E.$j?(0,r.localize)(11216,null,(0,I.$mc)($),(0,g.$nj)(P)):(0,r.localize)(11217,null,(0,I.$mc)($),(0,g.$nj)(P)),T.FileSystemProviderErrorCode.Unknown)}}L(f,d){return new m(f,d,this.b,this.M)}}e.$Ffc=h;class m extends p.$1s{watch(f,d,v){if(v.recursive)throw(0,T.$jl)("Recursive file watching is not supported from main process for performance reasons.",T.FileSystemProviderErrorCode.Unavailable);return super.watch(f,d,v)}}}),define(le[190],ue([0,1,5]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mcc=void 0;class r extends n.$ck{constructor(D=n.$_j){super(),this.m=[],this.n=void 0,this.setLevel(D),this.B(this.onDidChangeLogLevel(T=>{this.n?.setLevel(T)}))}set logger(D){this.n=D;for(const{level:T,message:I}of this.m)(0,n.log)(D,T,I);this.m=[]}g(D,T){this.n?(0,n.log)(this.n,D,T):this.getLevel()<=D&&this.m.push({level:D,message:T})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$mcc=r}),define(le[191],ue([0,1,7,4,5,2]),function(Y,e,n,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=e.$qs=e.$ps=void 0;class T extends E.$hk{constructor(h,m,w,f,d){super(m,w,f),this.r=h,this.t=d,this.B(d.listen("onDidChangeLogLevel",h)(v=>{(0,E.$$j)(v)?super.setLogLevel(v):super.setLogLevel(n.URI.revive(v[0]),v[1])})),this.B(d.listen("onDidChangeVisibility",h)(([v,b])=>super.setVisibility(n.URI.revive(v),b))),this.B(d.listen("onDidChangeLoggers",h)(({added:v,removed:b})=>{for(const $ of v)super.registerLogger({...$,resource:n.URI.revive($.resource)});for(const $ of b)super.deregisterLogger($.resource)}))}createConsoleMainLogger(){return new E.$fk({log:(h,m)=>{this.t.call("consoleLog",[h,m])}})}registerLogger(h){super.registerLogger(h),this.t.call("registerLogger",[h,this.r])}deregisterLogger(h){super.deregisterLogger(h),this.t.call("deregisterLogger",[h,this.r])}setLogLevel(h,m){super.setLogLevel(h,m),this.t.call("setLogLevel",[h,m])}setVisibility(h,m){super.setVisibility(h,m),this.t.call("setVisibility",[this.n(h),m])}s(h,m,w){return new I(this.t,h,m,w,this.r)}static setLogLevel(h,m,w){return h.call("setLogLevel",[m,w])}}e.$ps=T;class I extends E.$ck{constructor(h,m,w,f,d){super(f?.logLevel==="always"),this.r=h,this.s=m,this.m=!1,this.n=[],this.setLevel(w),this.r.call("createLogger",[m,f,d]).then(()=>{this.u(this.n),this.m=!0})}g(h,m){const w=[[h,m]];this.m?this.u(w):this.n.push(...w)}u(h){this.r.call("log",[this.s,h])}}class p{constructor(h,m){this.a=h,this.b=m}listen(h,m){const w=this.b(h);switch(m){case"onDidChangeLoggers":return r.Event.map(this.a.onDidChangeLoggers,f=>({added:[...f.added].map(d=>this.c(d,w)),removed:[...f.removed].map(d=>this.c(d,w))}));case"onDidChangeVisibility":return r.Event.map(this.a.onDidChangeVisibility,f=>[w.transformOutgoingURI(f[0]),f[1]]);case"onDidChangeLogLevel":return r.Event.map(this.a.onDidChangeLogLevel,f=>(0,E.$$j)(f)?f:[w.transformOutgoingURI(f[0]),f[1]])}throw new Error(`Event not found: ${m}`)}async call(h,m,w){const f=this.b(h);switch(m){case"setLogLevel":return(0,E.$$j)(w[0])?this.a.setLogLevel(w[0]):this.a.setLogLevel(n.URI.revive(f.transformIncoming(w[0][0])),w[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(d=>this.c(d,f)))}throw new Error(`Call not found: ${m}`)}c(h,m){return{...h,resource:m.transformOutgoingURI(h.resource)}}}e.$qs=p;class a extends D.$Tc{constructor(h,m){super(),m.call("setLogLevel",[h.getLogLevel()]),this.B(h.onDidChangeLogLevel(w=>m.call("setLogLevel",[w]))),m.call("getRegisteredLoggers").then(w=>{for(const f of w)h.registerLogger({...f,resource:n.URI.revive(f.resource)})}),this.B(m.listen("onDidChangeVisibility")(([w,f])=>h.setVisibility(n.URI.revive(w),f))),this.B(m.listen("onDidChangeLoggers")(({added:w,removed:f})=>{for(const d of w)h.registerLogger({...d,resource:n.URI.revive(d.resource)});for(const d of f)h.deregisterLogger(d.resource)}))}}e.$rs=a}),define(le[192],ue([0,1,2,5]),function(Y,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oR=void 0;class E extends n.$Tc{constructor(T,I=[]){super(),this.a=new r.$gk([T,...I]),this.B(T.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(T){this.a.setLevel(T)}getLevel(){return this.a.getLevel()}trace(T,...I){this.a.trace(T,...I)}debug(T,...I){this.a.debug(T,...I)}info(T,...I){this.a.info(T,...I)}warn(T,...I){this.a.warn(T,...I)}error(T,...I){this.a.error(T,...I)}flush(){this.a.flush()}}e.$oR=E}),define(le[193],ue([0,1,31,7,5]),function(Y,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dgc=void 0;class D{constructor(I){this.b=I,this.a=new n.$zc}listen(I,p,a){switch(p){case"onDidChangeLoggers":return a?this.b.getOnDidChangeLoggersEvent(a):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return a?this.b.getOnDidChangeLogLevelEvent(a):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return a?this.b.getOnDidChangeVisibilityEvent(a):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${p}`)}async call(I,p,a){switch(p){case"createLogger":this.c(r.URI.revive(a[0]),a[1],a[2]);return;case"log":return this.e(r.URI.revive(a[0]),a[1]);case"consoleLog":return this.d(a[0],a[1]);case"setLogLevel":return(0,E.$$j)(a[0])?this.b.setLogLevel(a[0]):this.b.setLogLevel(r.URI.revive(a[0]),a[1]);case"setVisibility":return this.b.setVisibility(r.URI.revive(a[0]),a[1]);case"registerLogger":return this.b.registerLogger({...a[0],resource:r.URI.revive(a[0].resource)},a[1]);case"deregisterLogger":return this.b.deregisterLogger(r.URI.revive(a[0]))}throw new Error(`Call not found: ${p}`)}c(I,p,a){this.a.set(I,this.b.createLogger(I,p,a))}d(I,p){let a=console.log;switch(I){case E.LogLevel.Error:a=console.error;break;case E.LogLevel.Warning:a=console.warn;break;case E.LogLevel.Info:a=console.info;break}a.call(console,...p)}e(I,p){const a=this.a.get(I);if(!a)throw new Error("Create the logger before logging");for(const[g,h]of p)(0,E.log)(a,g,h)}}e.$Dgc=D}),define(le[194],ue([0,1,14,5]),function(Y,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dR=void 0;var E;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(E||(E={}));async function D(a,g,h,m,w){try{const f=await new Promise((v,b)=>{Y(["@vscode/spdlog"],v,b)}).then(Ie);f.setFlushOn(E.Trace);const d=await f.createAsyncRotatingLogger(a,g,h,m);return w?d.clearFormatters():d.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),d}catch(f){console.error(f)}return null}function T(a,g,h){switch(g){case r.LogLevel.Trace:a.trace(h);break;case r.LogLevel.Debug:a.debug(h);break;case r.LogLevel.Info:a.info(h);break;case r.LogLevel.Warning:a.warn(h);break;case r.LogLevel.Error:a.error(h);break;case r.LogLevel.Off:break;default:throw new Error(`Invalid log level ${g}`)}}function I(a,g){switch(g){case r.LogLevel.Trace:a.setLevel(E.Trace);break;case r.LogLevel.Debug:a.setLevel(E.Debug);break;case r.LogLevel.Info:a.setLevel(E.Info);break;case r.LogLevel.Warning:a.setLevel(E.Warning);break;case r.LogLevel.Error:a.setLevel(E.Error);break;case r.LogLevel.Off:a.setLevel(E.Off);break;default:throw new Error(`Invalid log level ${g}`)}}class p extends r.$ck{constructor(g,h,m,w,f){super(),this.m=[],this.setLevel(f),this.n=this.s(g,h,m,w),this.B(this.onDidChangeLogLevel(d=>{this.r&&I(this.r,d)}))}async s(g,h,m,w){const f=m?6:1,d=30/f*n.$El.MB,v=await D(g,h,d,f,w);if(v){this.r=v,I(this.r,this.getLevel());for(const{level:b,message:$}of this.m)T(this.r,b,$);this.m=[]}}g(g,h){this.r?T(this.r,g,h):this.getLevel()<=g&&this.m.push({level:g,message:h})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$dR=p}),define(le[195],ue([0,1,33,5,194]),function(Y,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eR=void 0;class D extends r.$hk{s(I,p,a){return new E.$dR((0,n.$Yg)(),I.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,p)}}e.$eR=D}),define(le[71],ue([0,1,31,4,6,5,195]),function(Y,e,n,r,E,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=e.$afc=void 0,e.$afc=(0,E.$Di)(D.$0j);class I extends T.$eR{constructor(){super(...arguments),this.u=new n.$zc}createLogger(a,g,h){h!==void 0&&this.u.set(this.n(a),h);try{return super.createLogger(a,g)}catch(m){throw this.u.delete(this.n(a)),m}}registerLogger(a,g){g!==void 0&&this.u.set(a.resource,g),super.registerLogger(a)}deregisterLogger(a){this.u.delete(a),super.deregisterLogger(a)}getRegisteredLoggers(a){const g=[];for(const h of super.getRegisteredLoggers())a===this.u.get(h.resource)&&g.push(h);return g}getOnDidChangeLogLevelEvent(a){return r.Event.filter(this.onDidChangeLogLevel,g=>(0,D.$$j)(g)||this.w(g[0],a))}getOnDidChangeVisibilityEvent(a){return r.Event.filter(this.onDidChangeVisibility,([g])=>this.w(g,a))}getOnDidChangeLoggersEvent(a){return r.Event.filter(r.Event.map(this.onDidChangeLoggers,g=>({added:[...g.added].filter(m=>this.w(m.resource,a)),removed:[...g.removed].filter(m=>this.w(m.resource,a))})),g=>g.added.length>0||g.removed.length>0)}deregisterLoggers(a){for(const[g,h]of this.u)h===a&&this.deregisterLogger(g)}w(a,g){const h=this.u.get(a);return h===void 0||h===g}dispose(){super.dispose(),this.u.clear()}}e.$bfc=I}),define(le[196],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tfc=n,e.$Ufc=r,e.$Vfc=E,e.$Wfc=D;function n(T){return T.submenu!==void 0}function r(T){return T.id==="vscode.menubar.separator"}function E(T){return T.uri!==void 0}function D(T){return!n(T)&&!r(T)&&!E(T)}}),define(le[40],ue([0,1,4,77,2,6]),function(Y,e,n,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=e.$qo=e.$po=void 0,e.$po=(0,D.$Ci)("policy");class T extends E.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new n.$je),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const g=Object.keys(this.f).length;return this.f={...a,...this.f},g!==Object.keys(this.f).length&&await this.j(a),r.Iterable.reduce(this.g.entries(),(h,[m,w])=>({...h,[m]:w}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return r.Iterable.reduce(Object.entries(this.f),(a,[g,h])=>({...a,[g]:{definition:h,value:this.g.get(g)}}),{})}}e.$qo=T;class I{constructor(){this.onDidChange=n.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$ro=I}),define(le[197],ue([0,1,8,4,77,12,14,5,40]),function(Y,e,n,r,E,D,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=void 0;function a(h,m){const w=[];for(const f of new Set(E.Iterable.concat(h.keys(),m.keys())))h.get(f)!==m.get(f)&&w.push(f);return w}let g=class extends p.$qo{constructor(m,w,f){super(),this.m=m,this.n=w,this.s=f,this.c=this.B(new n.$Ah(500));const d=r.Event.filter(w.onDidFilesChange,v=>v.affects(m));this.B(w.watch(m)),this.B(d(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const m=new Map;try{const w=await this.n.readFile(this.m),f=JSON.parse(w.value.toString());if(!(0,D.$eg)(f))throw new Error("Policy file isn't a JSON object");for(const d of Object.keys(f))this.f[d]&&m.set(d,f[d])}catch(w){w.fileOperationResult!==T.FileOperationResult.FILE_NOT_FOUND&&this.s.error("[FilePolicyService] Failed to read policies",w)}return m}async w(){const m=await this.u(),w=a(this.g,m);this.g=m,w.length>0&&this.h.fire(w)}};e.$Wgc=g,e.$Wgc=g=Ee([se(1,T.$9k),se(2,I.$9j)],g)}),define(le[198],ue([0,1,4,2,40]),function(Y,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=e.$sgc=void 0;class D{constructor(p){this.b=p,this.a=new r.$Sc}listen(p,a){switch(a){case"onDidChange":return n.Event.map(this.b.onDidChange,g=>g.reduce((h,m)=>({...h,[m]:this.b.getPolicyValue(m)??null}),{}),this.a)}throw new Error(`Event not found: ${a}`)}call(p,a,g){switch(a){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(g)}throw new Error(`Call not found: ${a}`)}dispose(){this.a.dispose()}}e.$sgc=D;class T extends E.$qo{constructor(p,a){super(),this.a=a;for(const g in p){const{definition:h,value:m}=p[g];this.f[g]=h,m!==void 0&&this.g.set(g,m)}this.a.listen("onDidChange")(g=>{for(const h in g){const m=g[h];m===null?this.g.delete(h):this.g.set(h,m)}this.h.fire(Object.keys(g))})}async j(p){const a=await this.a.call("updatePolicyDefinitions",p);for(const g in a)this.g.set(g,a[g])}}e.$tgc=T}),define(le[199],ue([0,1,40,8,2,5]),function(Y,e,n,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=void 0;let T=class extends n.$qo{constructor(p,a){super(),this.m=p,this.n=a,this.a=new r.$wh,this.b=this.B(new E.$Uc)}async j(p){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(p).length} policy definitions`);const{createWatcher:a}=await new Promise((g,h)=>{Y(["@vscode/policy-watcher"],g,h)}).then(Ie);await this.a.queue(()=>new Promise((g,h)=>{try{this.b.value=a(this.n,p,m=>{this.t(m),g()})}catch(m){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",m),h(m)}}))}t(p){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(p)}`);for(const a in p){const g=p[a];g===void 0?this.g.delete(a):this.g.set(a,g)}this.h.fire(Object.keys(p))}};e.$Vgc=T,e.$Vgc=T=Ee([se(0,D.$9j)],T)}),define(le[72],ue([0,1,36]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;const E=globalThis.vscode;if(typeof E<"u"&&typeof E.context<"u"){const D=E.context.configuration();if(D)r=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(r=globalThis._VSCODE_PRODUCT_JSON,n.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`,serverDataFolderName:r.serverDataFolderName?`${r.serverDataFolderName}-dev`:void 0}),!r.version){const D=globalThis._VSCODE_PACKAGE_JSON;Object.assign(r,{version:D.version})}}else r={},Object.keys(r).length===0&&Object.assign(r,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=r}),define(le[28],ue([0,1,6]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qk=e.$pk=void 0,e.$pk=(0,n.$Ci)("productService"),e.$qk="vscode://schemas/vscode-product"}),define(le[200],ue([0,1,8,5]),function(Y,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ifc=void 0;let E=class{constructor(T,I,p){this.a=T,this.b=I,this.c=p}async inspect(T){await this.d();const I=this.a.webContents.debugger;await I.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,n.$Dh)(T);const p=await I.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),p.profile}async d(){const T=this.a.webContents.debugger;T.attach(),await T.sendCommand("Profiler.enable")}async e(){const T=this.a.webContents.debugger;await T.sendCommand("Profiler.disable"),T.detach()}};e.$Ifc=E,e.$Ifc=E=Ee([se(2,r.$9j)],E)}),define(le[73],ue([0,1,6]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vec=void 0,e.$Vec=(0,n.$Ci)("protocolMainService")}),define(le[45],ue([0,1,140,12]),function(Y,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=void 0,n=Ie(n),r=Ie(r);class E{constructor(){this.a=new Map}add(T,I){n.ok(r.$cg(T)),n.ok(r.$eg(I)),n.ok(!this.a.has(T),"There is already an extension with this id"),this.a.set(T,I)}knows(T){return this.a.has(T)}as(T){return this.a.get(T)||null}}e.$no=new E}),define(le[201],ue([0,1,4,45]),function(Y,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=void 0,r=Ie(r),e.$oo={JSONContribution:"base.contributions.json"};function E(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class D{constructor(){this.b=new n.$je,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(p,a){this.a[E(p)]=a,this.b.fire(p)}notifySchemaChanged(p){this.b.fire(p)}getSchemaContributions(){return{schemas:this.a}}}const T=new D;r.$no.add(e.$oo.JSONContribution,T)}),define(le[55],ue([0,1,20,4,12,10,17,201,45]),function(Y,e,n,r,E,D,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.ConfigurationScope=e.$so=e.EditPresentationTypes=void 0,e.$Do=d,e.$Eo=v,e.$Fo=b,e.$Go=P,e.$Ho=S,e.$Io=t,e.$Jo=u,E=Ie(E),D=Ie(D);var a;(function(i){i.Multiline="multilineText",i.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$so={Configuration:"base.contributions.configuration"};var g;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.MACHINE=2]="MACHINE",i[i.WINDOW=3]="WINDOW",i[i.RESOURCE=4]="RESOURCE",i[i.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",i[i.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(g||(e.ConfigurationScope=g={})),e.$to={properties:{},patternProperties:{}},e.$uo={properties:{},patternProperties:{}},e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo="vscode://schemas/settings/resourceLanguage",e.$Ao="vscode://schemas/settings/configurationDefaults";const h=p.$no.as(I.$oo.JSONContribution);class m{constructor(){this.h=new Set,this.i=new r.$je,this.onDidSchemaChange=this.i.event,this.j=new r.$je,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:D.localize(11444,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},h.registerSchema(e.$zo,this.g),this.v()}registerConfiguration(o,s=!0){this.registerConfigurations([o],s)}registerConfigurations(o,s=!0){const c=new Set;this.n(o,s,c),h.registerSchema(e.$zo,this.g),this.i.fire(),this.j.fire({properties:c})}deregisterConfigurations(o){const s=new Set;this.o(o,s),h.registerSchema(e.$zo,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:o,remove:s}){const c=new Set;this.o(s,c),this.n(o,!1,c),h.registerSchema(e.$zo,this.g),this.i.fire(),this.j.fire({properties:c})}registerDefaultConfigurations(o){const s=new Set;this.k(o,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(o,s){const c=[];for(const{overrides:l,source:k}of o)for(const y in l)if(s.add(y),e.$Co.test(y)){const R=this.a.get(y),L=R?.valuesSources??new Map,A=R?.value||{};for(const x of Object.keys(l[y])){const C=l[y][x];if(E.$eg(C)&&(E.$jg(A[x])||E.$eg(A[x]))){if(A[x]={...A[x]??{},...C},k){let ee=L.get(x);if(ee||(ee=new Map,L.set(x,ee)),!(ee instanceof Map)){console.error("objectConfigurationSources is not a Map");continue}for(const X in C)ee.set(X,k)}}else A[x]=C,k&&L.set(x,k)}this.a.set(y,{source:k,value:A,valuesSources:L});const O=(0,T.$gj)(y),W={type:"object",default:A,description:D.localize(11445,null,O),$ref:e.$zo,defaultDefaultValue:A,source:E.$cg(k)?void 0:k,defaultValueSource:k};c.push(...d(y)),this.d[y]=W,this.b.properties[y]=W}else{const R=this.d[y],L=this.a.get(y);let A=L?.value??R?.defaultDefaultValue,O=l[y],W=k;if(E.$eg(O)&&(R!==void 0&&R.type==="object"||R===void 0&&(E.$jg(A)||E.$eg(A)))){if(E.$eg(A)||(A={}),O={...A,...O},W=L?.source??new Map,!(W instanceof Map)){console.error("defaultValueSource is not a Map");continue}for(const C in l[y])k?W.set(C,k):W.delete(C)}this.a.set(y,{value:O,source:W}),R&&(this.w(y,R),this.r(y,R))}this.m(c)}deregisterDefaultConfigurations(o){const s=new Set;this.l(o,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(o,s){for(const{overrides:c,source:l}of o)for(const k in c){const y=E.$cg(l)?l:l?.id,R=this.a.get(k);if(R){if(e.$Co.test(k)){for(const A of Object.keys(c[k])){const O=c[k][A];if(E.$eg(O)){const W=R.valuesSources?.get(A);for(const x of Object.keys(O)){const C=W?.get(x);(E.$cg(C)?C:C?.id)===y&&(W?.delete(x),delete R.value[A][x])}Object.keys(R.value[A]).length===0&&(delete R.value[A],R.valuesSources?.delete(A))}else{const W=R.valuesSources?.get(A);(E.$cg(W)?W:W?.id)===y&&(R.valuesSources?.delete(A),delete R.value[A])}}const L=this.a.get(k);L&&Object.keys(L.value).length===0&&(this.a.delete(k),delete this.d[k],delete this.b.properties[k])}else{if(R.source instanceof Map){const A=R.source;for(const O in c[k]){const W=A.get(O);(E.$cg(W)?W:W?.id)===y&&(A.delete(O),delete R.value[O])}A.size===0&&this.a.delete(k)}else{const A=E.$cg(R.source)?R.source:R.source?.id;if(y!==A)continue;this.a.delete(k)}const L=this.d[k];L&&(this.w(k,L),this.r(k,L))}s.add(k)}}this.u()}deltaConfiguration(o){let s=!1;const c=new Set;o.removedDefaults&&(this.l(o.removedDefaults,c),s=!0),o.addedDefaults&&(this.k(o.addedDefaults,c),s=!0),o.removedConfigurations&&this.o(o.removedConfigurations,c),o.addedConfigurations&&this.n(o.addedConfigurations,!1,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...o){this.i.fire()}registerOverrideIdentifiers(o){this.m(o),this.i.fire()}m(o){for(const s of o)this.h.add(s);this.u()}n(o,s,c){o.forEach(l=>{this.p(l,s,l.extensionInfo,l.restrictedProperties,void 0,c),this.c.push(l),this.q(l)})}o(o,s){const c=l=>{if(l.properties)for(const k in l.properties){s.add(k);const y=this.d[k];y?.policy?.name&&this.e.delete(y.policy.name),delete this.d[k],this.s(k,l.properties[k])}l.allOf?.forEach(k=>c(k))};for(const l of o){c(l);const k=this.c.indexOf(l);k!==-1&&this.c.splice(k,1)}}p(o,s=!0,c,l,k=g.WINDOW,y){k=E.$lg(o.scope)?k:o.scope;const R=o.properties;if(R)for(const A in R){const O=R[A];if(s&&P(A,O)){delete R[A];continue}if(O.source=c,O.defaultDefaultValue=R[A].default,this.w(A,O),e.$Co.test(A)?O.scope=void 0:(O.scope=E.$lg(O.scope)?k:O.scope,O.restricted=E.$lg(O.restricted)?!!l?.includes(A):O.restricted),R[A].hasOwnProperty("included")&&!R[A].included){this.f[A]=R[A],delete R[A];continue}else this.d[A]=R[A],R[A].policy?.name&&this.e.set(R[A].policy.name,A);!R[A].deprecationMessage&&R[A].markdownDeprecationMessage&&(R[A].deprecationMessage=R[A].markdownDeprecationMessage),y.add(A)}const L=o.allOf;if(L)for(const A of L)this.p(A,s,c,l,k,y)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(o){const s=c=>{const l=c.properties;if(l)for(const y in l)this.r(y,l[y]);c.allOf?.forEach(s)};s(o)}r(o,s){switch(e.$to.properties[o]=s,s.scope){case g.APPLICATION:e.$uo.properties[o]=s;break;case g.MACHINE:e.$vo.properties[o]=s;break;case g.MACHINE_OVERRIDABLE:e.$wo.properties[o]=s;break;case g.WINDOW:e.$xo.properties[o]=s;break;case g.RESOURCE:e.$yo.properties[o]=s;break;case g.LANGUAGE_OVERRIDABLE:e.$yo.properties[o]=s,this.g.properties[o]=s;break}}s(o,s){switch(delete e.$to.properties[o],s.scope){case g.APPLICATION:delete e.$uo.properties[o];break;case g.MACHINE:delete e.$vo.properties[o];break;case g.MACHINE_OVERRIDABLE:delete e.$wo.properties[o];break;case g.WINDOW:delete e.$xo.properties[o];break;case g.RESOURCE:case g.LANGUAGE_OVERRIDABLE:delete e.$yo.properties[o],delete this.g.properties[o];break}}u(){for(const o of this.h.values()){const s=`[${o}]`,c={type:"object",description:D.localize(11446,null),errorMessage:D.localize(11447,null),$ref:e.$zo};this.w(s,c),e.$to.properties[s]=c,e.$uo.properties[s]=c,e.$vo.properties[s]=c,e.$wo.properties[s]=c,e.$xo.properties[s]=c,e.$yo.properties[s]=c}}v(){const o={type:"object",description:D.localize(11448,null),errorMessage:D.localize(11449,null),$ref:e.$zo};e.$to.patternProperties[e.$Bo]=o,e.$uo.patternProperties[e.$Bo]=o,e.$vo.patternProperties[e.$Bo]=o,e.$wo.patternProperties[e.$Bo]=o,e.$xo.patternProperties[e.$Bo]=o,e.$yo.patternProperties[e.$Bo]=o,this.i.fire()}w(o,s){const c=this.a.get(o);let l=c?.value,k=c?.source;E.$jg(l)&&(l=s.defaultDefaultValue,k=void 0),E.$jg(l)&&(l=b(s.type)),s.default=l,s.defaultValueSource=k}}const w="\\[([^\\]]+)\\]",f=new RegExp(w,"g");e.$Bo=`^(${w})+$`,e.$Co=new RegExp(e.$Bo);function d(i){const o=[];if(e.$Co.test(i)){let s=f.exec(i);for(;s?.length;){const c=s[1].trim();c&&o.push(c),s=f.exec(i)}}return(0,n.$Lb)(o)}function v(i){return i.reduce((o,s)=>`${o}[${s}]`,"")}function b(i){switch(Array.isArray(i)?i[0]:i){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const $=new m;p.$no.add(e.$so.Configuration,$);function P(i,o){return i.trim()?e.$Co.test(i)?D.localize(11451,null,i):$.getConfigurationProperties()[i]!==void 0?D.localize(11452,null,i):o.policy?.name&&$.getPolicyConfigurations().get(o.policy?.name)!==void 0?D.localize(11453,null,i,o.policy?.name,$.getPolicyConfigurations().get(o.policy?.name)):null:D.localize(11450,null)}function S(){const i=[],o=$.getConfigurationProperties();for(const s of Object.keys(o))i.push([s,o[s].scope]);return i.push(["launch",g.RESOURCE]),i.push(["task",g.RESOURCE]),i}function t(i){const o={};for(const s of i){const c=s.properties;if(E.$eg(c))for(const l in c)o[l]=c[l];s.allOf&&Object.assign(o,t(s.allOf))}return o}function u(i){switch(i){case"application":return g.APPLICATION;case"machine":return g.MACHINE;case"resource":return g.RESOURCE;case"machine-overridable":return g.MACHINE_OVERRIDABLE;case"language-overridable":return g.LANGUAGE_OVERRIDABLE;default:return g.WINDOW}}}),define(le[125],ue([0,1,20,4,43,2,31,37,12,7,17,55,14,45]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$No=e.$Mo=e.$Lo=e.$Ko=void 0,e.$Oo=S,n=Ie(n),E=Ie(E),I=Ie(I),p=Ie(p);function f(o){return Object.isFrozen(o)?o:I.$bo(o)}class d{static createEmptyModel(s){return new d({},[],[],void 0,s)}constructor(s,c,l,k,y){this.b=s,this.c=c,this.d=l,this.raw=k,this.f=y,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(c=>{if(c instanceof d)return c;const l=new v("",this.f);return l.parseRaw(c),l.configurationModel});this.g=s.reduce((c,l)=>l===c?l:c.merge(l),s[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,g.$ej)(this.contents,s):this.contents}inspect(s,c){const l=this;return{get value(){return f(l.rawConfiguration.getValue(s))},get override(){return c?f(l.rawConfiguration.getOverrideValue(s,c)):void 0},get merged(){return f(c?l.rawConfiguration.override(c).getValue(s):l.rawConfiguration.getValue(s))},get overrides(){const k=[];for(const{contents:y,identifiers:R,keys:L}of l.rawConfiguration.overrides){const A=new d(y,L,[],void 0,l.f).getValue(s);A!==void 0&&k.push({identifiers:R,value:A})}return k.length?f(k):void 0}}}getOverrideValue(s,c){const l=this.j(c);return l?s?(0,g.$ej)(l,s):l:void 0}getKeysForOverrideIdentifier(s){const c=[];for(const l of this.overrides)l.identifiers.includes(s)&&c.push(...l.keys);return n.$Lb(c)}getAllOverrideIdentifiers(){const s=[];for(const c of this.overrides)s.push(...c.identifiers);return n.$Lb(s)}override(s){let c=this.a.get(s);return c||(c=this.h(s),this.a.set(s,c)),c}merge(...s){const c=I.$ao(this.contents),l=I.$ao(this.overrides),k=[...this.keys],y=this.raw?.length?[...this.raw]:[this];for(const R of s)if(y.push(...R.raw?.length?R.raw:[R]),!R.isEmpty()){this.i(c,R.contents);for(const L of R.overrides){const[A]=l.filter(O=>n.$tb(O.identifiers,L.identifiers));A?(this.i(A.contents,L.contents),A.keys.push(...L.keys),A.keys=n.$Lb(A.keys)):l.push(I.$ao(L))}for(const L of R.keys)k.indexOf(L)===-1&&k.push(L)}return new d(c,k,l,y.every(R=>R instanceof d)?void 0:y,this.f)}h(s){const c=this.j(s);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const l={};for(const k of n.$Lb([...Object.keys(this.contents),...Object.keys(c)])){let y=this.contents[k];const R=c[k];R&&(typeof y=="object"&&typeof R=="object"?(y=I.$ao(y),this.i(y,R)):y=R),l[k]=y}return new d(l,this.keys,this.overrides,void 0,this.f)}i(s,c){for(const l of Object.keys(c)){if(l in s&&p.$eg(s[l])&&p.$eg(c[l])){this.i(s[l],c[l]);continue}s[l]=I.$ao(c[l])}}j(s){let c=null,l=null;const k=y=>{y&&(l?this.i(l,y):l=I.$ao(y))};for(const y of this.overrides)y.identifiers.length===1&&y.identifiers[0]===s?c=y.contents:y.identifiers.includes(s)&&k(y.contents);return k(c),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,c){this.k(s,c,!0)}setValue(s,c){this.k(s,c,!1)}removeValue(s){const c=this.keys.indexOf(s);c!==-1&&(this.keys.splice(c,1),(0,g.$dj)(this.contents,s),h.$Co.test(s)&&this.overrides.splice(this.overrides.findIndex(l=>n.$tb(l.identifiers,(0,h.$Do)(s))),1))}k(s,c,l){(0,g.$cj)(this.contents,s,c,k=>this.f.error(k)),l=l||this.keys.indexOf(s)===-1,l&&this.keys.push(s),h.$Co.test(s)&&this.overrides.push({identifiers:(0,h.$Do)(s),keys:Object.keys(this.contents[s]),contents:(0,g.$bj)(this.contents[s],k=>this.f.error(k))})}}e.$Ko=d;class v{constructor(s,c){this.f=s,this.g=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||d.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,c){if(!p.$lg(s)){const l=this.h(s);this.parseRaw(l,c)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,c){this.a=s;const{contents:l,keys:k,overrides:y,restricted:R,hasExcludedProperties:L}=this.i(s,c);this.b=new d(l,k,y,L?[s]:void 0,this.g),this.c=R||[]}h(s){let c={},l=null,k=[];const y=[],R=[];function L(O){Array.isArray(k)?k.push(O):l!==null&&(k[l]=O)}const A={onObjectBegin:()=>{const O={};L(O),y.push(k),k=O,l=null},onObjectProperty:O=>{l=O},onObjectEnd:()=>{k=y.pop()},onArrayBegin:()=>{const O=[];L(O),y.push(k),k=O,l=null},onArrayEnd:()=>{k=y.pop()},onLiteralValue:L,onError:(O,W,x)=>{R.push({error:O,offset:W,length:x})}};if(s)try{E.$2n(s,A),c=k[0]||{}}catch(O){this.g.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return c}i(s,c){const l=w.$no.as(h.$so.Configuration).getConfigurationProperties(),k=this.j(s,l,!0,c);s=k.raw;const y=(0,g.$bj)(s,A=>this.g.error(`Conflict in settings file ${this.f}: ${A}`)),R=Object.keys(s),L=this.l(s,A=>this.g.error(`Conflict in settings file ${this.f}: ${A}`));return{contents:y,keys:R,overrides:L,restricted:k.restricted,hasExcludedProperties:k.hasExcludedProperties}}j(s,c,l,k){let y=!1;if(!k?.scopes&&!k?.skipRestricted&&!k?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:y};const R={},L=[];for(const A in s)if(h.$Co.test(A)&&l){const O=this.j(s[A],c,!1,k);R[A]=O.raw,y=y||O.hasExcludedProperties,L.push(...O.restricted)}else{const O=c[A],W=O?typeof O.scope<"u"?O.scope:h.ConfigurationScope.WINDOW:void 0;O?.restricted&&L.push(A),!k.exclude?.includes(A)&&(k.include?.includes(A)||(W===void 0||k.scopes===void 0||k.scopes.includes(W))&&!(k.skipRestricted&&O?.restricted))?R[A]=s[A]:y=!0}return{raw:R,restricted:L,hasExcludedProperties:y}}l(s,c){const l=[];for(const k of Object.keys(s))if(h.$Co.test(k)){const y={};for(const R in s[k])y[R]=s[k][R];l.push({identifiers:(0,h.$Do)(k),keys:Object.keys(y),contents:(0,g.$bj)(y,c)})}return l}}e.$Lo=v;class b extends D.$Tc{constructor(s,c,l,k,y){super(),this.c=s,this.f=c,this.g=k,this.h=y,this.b=this.B(new r.$je),this.onDidChange=this.b.event,this.a=new v(this.c.toString(),y),this.B(this.g.watch(l.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(r.Event.any(r.Event.filter(this.g.onDidFilesChange,R=>R.contains(this.c)),r.Event.filter(this.g.onDidRunOperation,R=>(R.isOperation(m.FileOperation.CREATE)||R.isOperation(m.FileOperation.COPY)||R.isOperation(m.FileOperation.DELETE)||R.isOperation(m.FileOperation.WRITE))&&l.isEqual(R.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return d.createEmptyModel(this.h)}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Mo=b;class ${constructor(s,c,l,k,y,R,L,A,O,W,x,C,B){this.a=s,this.b=c,this.c=l,this.overrideIdentifiers=k,this.d=y,this.f=R,this.g=L,this.h=A,this.i=O,this.j=W,this.k=x,this.l=C,this.m=B}get value(){return f(this.c)}n(s){return s?.value!==void 0||s?.override!==void 0||s?.overrides!==void 0?s:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class P{constructor(s,c,l,k,y,R,L,A,O,W){this.j=s,this.l=c,this.m=l,this.n=k,this.p=y,this.q=R,this.r=L,this.s=A,this.t=O,this.u=W,this.h=null,this.i=new T.$zc,this.v=null}getValue(s,c,l){return this.w(s,c,l).getValue(s)}updateValue(s,c,l={}){let k;l.resource?(k=this.t.get(l.resource),k||(k=d.createEmptyModel(this.u),this.t.set(l.resource,k))):k=this.s,c===void 0?k.removeValue(s):k.setValue(s,c),l.resource||(this.h=null)}inspect(s,c,l){const k=this.w(s,c,l),y=this.A(c.resource,l),R=c.resource?this.t.get(c.resource)||this.s:this.s,L=new Set;for(const A of k.overrides)for(const O of A.identifiers)k.getOverrideValue(s,O)!==void 0&&L.add(O);return new $(s,c,k.getValue(s),L.size?[...L]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,l?this.q:void 0,y||void 0,R)}keys(s){const c=this.A(void 0,s);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:c?c.keys.slice(0):[]}}updateDefaultConfiguration(s){this.j=s,this.h=null,this.i.clear()}updatePolicyConfiguration(s){this.l=s}updateApplicationConfiguration(s){this.m=s,this.h=null,this.i.clear()}updateLocalUserConfiguration(s){this.n=s,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(s){this.p=s,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(s){this.q=s,this.h=null,this.i.clear()}updateFolderConfiguration(s,c){this.r.set(s,c),this.i.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.i.delete(s)}compareAndUpdateDefaultConfiguration(s,c){const l=[];if(!c){const{added:k,updated:y,removed:R}=u(this.j,s);c=[...k,...y,...R]}for(const k of c)for(const y of(0,h.$Do)(k)){const R=this.j.getKeysForOverrideIdentifier(y),L=s.getKeysForOverrideIdentifier(y),A=[...L.filter(O=>R.indexOf(O)===-1),...R.filter(O=>L.indexOf(O)===-1),...R.filter(O=>!I.$eo(this.j.override(y).getValue(O),s.override(y).getValue(O)))];l.push([y,A])}return this.updateDefaultConfiguration(s),{keys:c,overrides:l}}compareAndUpdatePolicyConfiguration(s){const{added:c,updated:l,removed:k}=u(this.l,s),y=[...c,...l,...k];return y.length&&this.updatePolicyConfiguration(s),{keys:y,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:c,updated:l,removed:k,overrides:y}=u(this.applicationConfiguration,s),R=[...c,...l,...k];return R.length&&this.updateApplicationConfiguration(s),{keys:R,overrides:y}}compareAndUpdateLocalUserConfiguration(s){const{added:c,updated:l,removed:k,overrides:y}=u(this.localUserConfiguration,s),R=[...c,...l,...k];return R.length&&this.updateLocalUserConfiguration(s),{keys:R,overrides:y}}compareAndUpdateRemoteUserConfiguration(s){const{added:c,updated:l,removed:k,overrides:y}=u(this.remoteUserConfiguration,s),R=[...c,...l,...k];return R.length&&this.updateRemoteUserConfiguration(s),{keys:R,overrides:y}}compareAndUpdateWorkspaceConfiguration(s){const{added:c,updated:l,removed:k,overrides:y}=u(this.workspaceConfiguration,s),R=[...c,...l,...k];return R.length&&this.updateWorkspaceConfiguration(s),{keys:R,overrides:y}}compareAndUpdateFolderConfiguration(s,c){const l=this.folderConfigurations.get(s),{added:k,updated:y,removed:R,overrides:L}=u(l,c),A=[...k,...y,...R];return(A.length||!l)&&this.updateFolderConfiguration(s,c),{keys:A,overrides:L}}compareAndDeleteFolderConfiguration(s){const c=this.folderConfigurations.get(s);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:l,updated:k,removed:y,overrides:R}=u(c,void 0);return{keys:[...l,...k,...y],overrides:R}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(s,c,l){let k=this.x(c,l);return c.overrideIdentifier&&(k=k.override(c.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(s)!==void 0&&(k=k.merge(this.l)),k}x({resource:s},c){let l=this.y();if(c&&s){const k=c.getFolder(s);k&&(l=this.z(k.uri)||l);const y=this.t.get(s);y&&(l=l.merge(y))}return l}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(s){let c=this.i.get(s);if(!c){const l=this.y(),k=this.r.get(s);k?(c=l.merge(k),this.i.set(s,c)):c=l}return c}A(s,c){if(c&&s){const l=c.getFolder(s);if(l)return this.r.get(l.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((s,c)=>{const{contents:l,overrides:k,keys:y}=this.r.get(c);return s.push([c,{contents:l,overrides:k,keys:y}]),s},[])}}allKeys(){const s=new Set;return this.j.keys.forEach(c=>s.add(c)),this.userConfiguration.keys.forEach(c=>s.add(c)),this.q.keys.forEach(c=>s.add(c)),this.r.forEach(c=>c.keys.forEach(l=>s.add(l))),[...s.values()]}B(){const s=new Set;return this.j.getAllOverrideIdentifiers().forEach(c=>s.add(c)),this.userConfiguration.getAllOverrideIdentifiers().forEach(c=>s.add(c)),this.q.getAllOverrideIdentifiers().forEach(c=>s.add(c)),this.r.forEach(c=>c.getAllOverrideIdentifiers().forEach(l=>s.add(l))),[...s.values()]}D(s){const c=new Set;return this.j.getKeysForOverrideIdentifier(s).forEach(l=>c.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(l=>c.add(l)),this.q.getKeysForOverrideIdentifier(s).forEach(l=>c.add(l)),this.r.forEach(l=>l.getKeysForOverrideIdentifier(s).forEach(k=>c.add(k))),[...c.values()]}static parse(s,c){const l=this.E(s.defaults,c),k=this.E(s.policy,c),y=this.E(s.application,c),R=this.E(s.user,c),L=this.E(s.workspace,c),A=s.folders.reduce((O,W)=>(O.set(a.URI.revive(W[0]),this.E(W[1],c)),O),new T.$zc);return new P(l,k,y,R,d.createEmptyModel(c),L,A,d.createEmptyModel(c),new T.$zc,c)}static E(s,c){return new d(s.contents,s.keys,s.overrides,void 0,c)}}e.$No=P;function S(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const s=new Set,c=new Map;for(const k of o)k.keys.forEach(y=>s.add(y)),k.overrides.forEach(([y,R])=>{const L=(0,T.$wc)(c,y,new Set);R.forEach(A=>L.add(A))});const l=[];return c.forEach((k,y)=>l.push([y,[...k.values()]])),{keys:[...s.values()],overrides:l}}class t{constructor(s,c,l,k,y){this.change=s,this.f=c,this.g=l,this.h=k,this.i=y,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const R of s.keys)this.affectedKeys.add(R);for(const[,R]of s.overrides)for(const L of R)this.affectedKeys.add(L);this.d=this.a;for(const R of this.affectedKeys)this.d+=R+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=P.parse(this.f.data,this.i)),this.j}affectsConfiguration(s,c){const l=this.a+s,k=this.d.indexOf(l);if(k<0)return!1;const y=k+l.length;if(y>=this.d.length)return!1;const R=this.d.charCodeAt(y);if(R!==this.b&&R!==this.c)return!1;if(c){const L=this.previousConfiguration?this.previousConfiguration.getValue(s,c,this.f?.workspace):void 0,A=this.g.getValue(s,c,this.h);return!I.$eo(L,A)}return!0}}e.$Po=t;function u(o,s){const{added:c,removed:l,updated:k}=i(s?.rawConfiguration,o?.rawConfiguration),y=[],R=o?.getAllOverrideIdentifiers()||[],L=s?.getAllOverrideIdentifiers()||[];if(s){const A=L.filter(O=>!R.includes(O));for(const O of A)y.push([O,s.getKeysForOverrideIdentifier(O)])}if(o){const A=R.filter(O=>!L.includes(O));for(const O of A)y.push([O,o.getKeysForOverrideIdentifier(O)])}if(s&&o){for(const A of R)if(L.includes(A)){const O=i({contents:o.getOverrideValue(void 0,A)||{},keys:o.getKeysForOverrideIdentifier(A)},{contents:s.getOverrideValue(void 0,A)||{},keys:s.getKeysForOverrideIdentifier(A)});y.push([A,[...O.added,...O.removed,...O.updated]])}}return{added:c,removed:l,updated:k,overrides:y}}function i(o,s){const c=o?s?o.keys.filter(y=>s.keys.indexOf(y)===-1):[...o.keys]:[],l=s?o?s.keys.filter(y=>o.keys.indexOf(y)===-1):[...s.keys]:[],k=[];if(o&&s){for(const y of s.keys)if(o.keys.indexOf(y)!==-1){const R=(0,g.$ej)(s.contents,y),L=(0,g.$ej)(o.contents,y);I.$eo(R,L)||k.push(y)}}return{added:c,removed:l,updated:k}}}),define(le[202],ue([0,1,20,4,2,37,12,125,55,5,40,45]),function(Y,e,n,r,E,D,T,I,p,a,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Ro=e.$Qo=void 0;class m extends E.$Tc{get configurationModel(){return this.b}constructor(v){super(),this.c=v,this.a=this.B(new r.$je),this.onDidChangeConfiguration=this.a.event,this.b=I.$Ko.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(h.$no.as(p.$so.Configuration).onDidUpdateConfiguration(({properties:v,defaultsOverrides:b})=>this.f(Array.from(v),b))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(v,b){this.j(v,h.$no.as(p.$so.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:v})}g(){return{}}h(){this.b=I.$Ko.createEmptyModel(this.c);const v=h.$no.as(p.$so.Configuration).getConfigurationProperties();this.j(Object.keys(v),v)}j(v,b){const $=this.g();for(const P of v){const S=$[P],t=b[P];S!==void 0?this.b.addValue(P,S):t?this.b.addValue(P,t.default):this.b.removeValue(P)}}}e.$Qo=m;class w{constructor(){this.onDidChangeConfiguration=r.Event.None,this.configurationModel=I.$Ko.createEmptyModel(new a.$jk)}async initialize(){return this.configurationModel}}e.$Ro=w;let f=class extends E.$Tc{get configurationModel(){return this.b}constructor(v,b,$){super(),this.c=v,this.f=b,this.g=$,this.a=this.B(new r.$je),this.onDidChangeConfiguration=this.a.event,this.b=I.$Ko.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(v=>this.j(v))),this.B(this.c.onDidChangeConfiguration(async({properties:v})=>this.m(await this.h(v),!0))),this.b}async h(v){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",v);const b={},$=[],P=h.$no.as(p.$so.Configuration).getConfigurationProperties();for(const S of v){const t=P[S];if(!t){$.push(S);continue}if(t.policy){if(t.type!=="string"&&t.type!=="number"){this.g.warn(`Policy ${t.policy.name} has unsupported type ${t.type}`);continue}$.push(S),b[t.policy.name]={type:t.type}}}return(0,T.$pg)(b)||await this.f.updatePolicyDefinitions(b),$}j(v){this.g.trace("PolicyConfiguration#onDidChangePolicies",v);const b=h.$no.as(p.$so.Configuration).getPolicyConfigurations(),$=(0,n.$Gb)(v.map(P=>b.get(P)));this.m($,!0)}m(v,b){this.g.trace("PolicyConfiguration#update",v);const $=h.$no.as(p.$so.Configuration).getConfigurationProperties(),P=[],S=this.b.isEmpty();for(const t of v){const u=$[t]?.policy?.name;if(u){const i=this.f.getPolicyValue(u);(S?i!==void 0:!(0,D.$eo)(this.b.getValue(t),i))&&P.push([t,i])}else this.b.getValue(t)!==void 0&&P.push([t,void 0])}if(P.length){this.g.trace("PolicyConfiguration#changed",P);const t=this.b;this.b=I.$Ko.createEmptyModel(this.g);for(const u of t.keys)this.b.setValue(u,t.getValue(u));for(const[u,i]of P)i===void 0?this.b.removeValue(u):this.b.setValue(u,i);b&&this.a.fire(this.b)}}};e.$So=f,e.$So=f=Ee([se(1,g.$po),se(2,a.$9j)],f)}),define(le[203],ue([0,1,20,8,16,4,43,107,2,31,37,3,18,17,125,55,202,14,40]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w,f,d,v,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=void 0;class P extends p.$Tc{constructor(u,i,o,s){super(),this.m=u,this.n=s,this.h=this.B(new D.$je),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new v.$Qo(s)),this.c=o instanceof $.$ro?new v.$Ro:this.B(new v.$So(this.b,o,s)),this.f=this.B(new f.$Mo(this.m,{},m.$7g,i,s)),this.a=new f.$No(this.b.configurationModel,this.c.configurationModel,f.$Ko.createEmptyModel(s),f.$Ko.createEmptyModel(s),f.$Ko.createEmptyModel(s),f.$Ko.createEmptyModel(s),new a.$zc,f.$Ko.createEmptyModel(s),new a.$zc,s),this.j=new S(u,i,this),this.g=this.B(new r.$Oh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:c,properties:l})=>this.s(c,l))),this.B(this.c.onDidChangeConfiguration(c=>this.t(c))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[u,i,o]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new f.$No(u,i,f.$Ko.createEmptyModel(this.n),o,f.$Ko.createEmptyModel(this.n),f.$Ko.createEmptyModel(this.n),new a.$zc,f.$Ko.createEmptyModel(this.n),new a.$zc,this.n)}getConfigurationData(){return this.a.toData()}getValue(u,i){const o=typeof u=="string"?u:void 0,s=(0,w.$0i)(u)?u:(0,w.$0i)(i)?i:{};return this.a.getValue(o,s,void 0)}async updateValue(u,i,o,s,c){const l=(0,w.$$i)(o)?o:(0,w.$0i)(o)?{resource:o.resource,overrideIdentifiers:o.overrideIdentifier?[o.overrideIdentifier]:void 0}:void 0,k=l?s:o;if(k!==void 0&&k!==w.ConfigurationTarget.USER_LOCAL&&k!==w.ConfigurationTarget.USER)throw new Error(`Unable to write ${u} to target ${k}.`);l?.overrideIdentifiers&&(l.overrideIdentifiers=(0,n.$Lb)(l.overrideIdentifiers),l.overrideIdentifiers=l.overrideIdentifiers.length?l.overrideIdentifiers:void 0);const y=this.inspect(u,{resource:l?.resource,overrideIdentifier:l?.overrideIdentifiers?l.overrideIdentifiers[0]:void 0});if(y.policyValue!==void 0)throw new Error(`Unable to write ${u} because it is configured in system policy.`);if((0,g.$eo)(i,y.defaultValue)&&(i=void 0),l?.overrideIdentifiers?.length&&l.overrideIdentifiers.length>1){const L=l.overrideIdentifiers.sort(),A=this.a.localUserConfiguration.overrides.find(O=>(0,n.$tb)([...O.identifiers].sort(),L));A&&(l.overrideIdentifiers=A.identifiers)}const R=l?.overrideIdentifiers?.length?[(0,d.$Eo)(l.overrideIdentifiers),u]:[u];await this.j.write(R,i),await this.reloadConfiguration()}inspect(u,i={}){return this.a.inspect(u,i,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const u=await this.f.loadConfiguration();this.r(u)}r(u){const i=this.a.toData(),o=this.a.compareAndUpdateLocalUserConfiguration(u);this.u(o,i,w.ConfigurationTarget.USER)}s(u,i){const o=this.a.toData(),s=this.a.compareAndUpdateDefaultConfiguration(u,i);this.u(s,o,w.ConfigurationTarget.DEFAULT)}t(u){const i=this.a.toData(),o=this.a.compareAndUpdatePolicyConfiguration(u);this.u(o,i,w.ConfigurationTarget.DEFAULT)}u(u,i,o){const s=new f.$Po(u,{data:i},this.a,void 0,this.n);s.source=o,this.h.fire(s)}}e.$To=P;class S{constructor(u,i,o){this.b=u,this.c=i,this.d=o,this.a=new r.$Jh}write(u,i){return this.a.queue(()=>this.e(u,i))}async e(u,i){let o;try{o=(await this.c.readFile(this.b)).value.toString()}catch(l){if(l.fileOperationResult===b.FileOperationResult.FILE_NOT_FOUND)o="{}";else throw l}const s=[];if((0,T.$Un)(o,s,{allowTrailingComma:!0,allowEmptyContent:!0}),s.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const c=this.f(o,u,i);o=(0,I.$_n)(o,c),await this.c.writeFile(this.b,E.$Le.fromString(o))}f(u,i,o){const{tabSize:s,insertSpaces:c,eol:l}=this.h;if(!i.length){const k=JSON.stringify(o,null,c?" ".repeat(s):"	");return[{content:k,length:k.length,offset:0}]}return(0,I.$9n)(u,i,o,{tabSize:s,insertSpaces:c,eol:l})}get h(){if(!this.g){let u=h.OS===h.OperatingSystem.Linux||h.OS===h.OperatingSystem.Macintosh?`
`:`\r
`;const i=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});i&&typeof i=="string"&&i!=="auto"&&(u=i),this.g={eol:u,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(le[204],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kgc=e.$Jgc=e.$Igc=void 0,e.$Igc="request",e.$Jgc="remoteResourceHandler";class n{async routeCall(E,D,T){if(D!==e.$Igc)throw new Error(`Call not found: ${D}`);const I=T[0];if(I?.authority){const p=E.connections.find(a=>a.ctx===I.authority);if(p)return p}throw new Error("Caller not found")}routeEvent(E,D){throw new Error(`Event not found: ${D}`)}}e.$Kgc=n}),define(le[205],ue([0,1,15,6]),function(Y,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.RemoteAuthorityResolverErrorCode=e.$Pl=e.$Ol=e.RemoteConnectionType=e.$Nl=void 0,e.$Rl=a,e.$Nl=(0,r.$Ci)("remoteAuthorityResolverService");var E;(function(g){g[g.WebSocket=0]="WebSocket",g[g.Managed=1]="Managed"})(E||(e.RemoteConnectionType=E={}));class D{constructor(h){this.id=h,this.type=E.Managed}toString(){return`Managed(${this.id})`}}e.$Ol=D;class T{constructor(h,m){this.host=h,this.port=m,this.type=E.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Pl=T;var I;(function(g){g.Unknown="Unknown",g.NotAvailable="NotAvailable",g.TemporarilyNotAvailable="TemporarilyNotAvailable",g.NoResolverFound="NoResolverFound",g.InvalidAuthority="InvalidAuthority"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class p extends n.$ab{static isNotAvailable(h){return h instanceof p&&h._code===I.NotAvailable}static isTemporarilyNotAvailable(h){return h instanceof p&&h._code===I.TemporarilyNotAvailable}static isNoResolverFound(h){return h instanceof p&&h._code===I.NoResolverFound}static isInvalidAuthority(h){return h instanceof p&&h._code===I.InvalidAuthority}static isHandled(h){return h instanceof p&&h.isHandled}constructor(h,m=I.Unknown,w){super(h),this._message=h,this._code=m,this._detail=w,this.isHandled=m===I.NotAvailable&&w===!0,Object.setPrototypeOf(this,p.prototype)}}e.$Ql=p;function a(g){const h=g.indexOf("+");return h===-1?g:g.substring(0,h)}}),define(le[206],ue([0,1,8,16,21,15,4,2,11,70,66,33,117,205]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Wl=y,e.$Xl=R,e.$Yl=A,a=Ie(a);const f=30*1e3;var d;(function(re){re[re.Management=1]="Management",re[re.ExtensionHost=2]="ExtensionHost",re[re.Tunnel=3]="Tunnel"})(d||(e.ConnectionType=d={}));function v(re){switch(re){case d.Management:return"Management";case d.ExtensionHost:return"ExtensionHost";case d.Tunnel:return"Tunnel"}}function b(re){const _=new E.$ue;return setTimeout(()=>_.cancel(),re),_.token}function $(re,_){if(re.isCancellationRequested||_.isCancellationRequested)return E.CancellationToken.Cancelled;const M=new E.$ue;return re.onCancellationRequested(()=>M.cancel()),_.onCancellationRequested(()=>M.cancel()),M.token}class P{get didTimeout(){return this.c==="timedout"}constructor(_){this.c="pending",this.d=new I.$Sc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,n.$vh)(),_.isCancellationRequested?this.h():this.d.add(_.onCancellationRequested(()=>this.h()))}registerDisposable(_){this.c==="pending"?this.d.add(_):_.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const _=new Error("Time limit reached");return _.code="ETIMEDOUT",_.syscall="connect",_}resolve(_){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(_))}reject(_){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(_))}}function S(re,_){const M=new P(_);return M.registerDisposable(re.onControlMessage(F=>{const U=JSON.parse(F.toString()),q=j(U);q?M.reject(q):M.resolve(U)})),M.promise}function t(re,_,M,F,U,q,Q,J){const H=new P(J),ne=g.$de.create(!1);return re.info(`Creating a socket (${Q})...`),a.mark(`code/willCreateSocket/${q}`),_.connect(M,F,U,Q).then(de=>{H.didTimeout?(a.mark(`code/didCreateSocketError/${q}`),re.info(`Creating a socket (${Q}) finished after ${ne.elapsed()} ms, but this is too late and has timed out already.`),de?.dispose()):(a.mark(`code/didCreateSocketOK/${q}`),re.info(`Creating a socket (${Q}) was successful after ${ne.elapsed()} ms.`),H.resolve(de))},de=>{a.mark(`code/didCreateSocketError/${q}`),re.info(`Creating a socket (${Q}) returned an error after ${ne.elapsed()} ms.`),re.error(de),H.reject(de)}),H.promise}function u(re,_){const M=new P(_);return re.then(F=>{M.didTimeout||M.resolve(F)},F=>{M.didTimeout||M.reject(F)}),M.promise}async function i(re,_,M,F){const U=G(re,_);re.logService.trace(`${U} 1/6. invoking socketFactory.connect().`);let q;try{q=await t(re.logService,re.remoteSocketFactoryService,re.connectTo,p.$Pg.getServerRootPath(),`reconnectionToken=${re.reconnectionToken}&reconnection=${re.reconnectionProtocol?"true":"false"}`,v(_),`renderer-${v(_)}-${re.reconnectionToken}`,F)}catch(de){throw re.logService.error(`${U} socketFactory.connect() failed or timed out. Error:`),re.logService.error(de),de}re.logService.trace(`${U} 2/6. socketFactory.connect() was successful.`);let Q,J;re.reconnectionProtocol?(re.reconnectionProtocol.beginAcceptReconnection(q,null),Q=re.reconnectionProtocol,J=!1):(Q=new m.$qi({socket:q}),J=!0),re.logService.trace(`${U} 3/6. sending AuthRequest control message.`);const H=await u(re.signService.createNewMessage((0,h.$Yg)()),F),ne={type:"auth",auth:re.connectionToken||"00000000000000000000",data:H.data};Q.sendControl(r.$Le.fromString(JSON.stringify(ne)));try{const de=await S(Q,$(F,b(1e4)));if(de.type!=="sign"||typeof de.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(re.logService.trace(`${U} 4/6. received SignRequest control message.`),!await u(re.signService.validate(H,de.signedData),F)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const we=await u(re.signService.sign(de.data),F),Re={type:"connectionType",commit:re.commit,signedData:we,desiredConnectionType:_};return M&&(Re.args=M),re.logService.trace(`${U} 5/6. sending ConnectionTypeRequest control message.`),Q.sendControl(r.$Le.fromString(JSON.stringify(Re))),{protocol:Q,ownsProtocol:J}}catch(de){throw de&&de.code==="ETIMEDOUT"&&(re.logService.error(`${U} the handshake timed out. Error:`),re.logService.error(de)),de&&de.code==="VSCODE_CONNECTION_ERROR"&&(re.logService.error(`${U} received error control message when negotiating connection. Error:`),re.logService.error(de)),J&&z(Q),de}}async function o(re,_,M,F){const U=Date.now(),q=G(re,_),{protocol:Q,ownsProtocol:J}=await i(re,_,M,F),H=new P(F);return H.registerDisposable(Q.onControlMessage(ne=>{const de=JSON.parse(ne.toString()),me=j(de);me?(re.logService.error(`${q} received error control message when negotiating connection. Error:`),re.logService.error(me),J&&z(Q),H.reject(me)):(re.reconnectionProtocol?.endAcceptReconnection(),re.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${he(U)}!`),H.resolve({protocol:Q,firstMessage:de}))})),H.promise}async function s(re,_){const{protocol:M}=await o(re,d.Management,void 0,_);return{protocol:M}}async function c(re,_,M){const{protocol:F,firstMessage:U}=await o(re,d.ExtensionHost,_,M),q=U&&U.debugPort;return{protocol:F,debugPort:q}}async function l(re,_,M){const F=Date.now(),U=G(re,d.Tunnel),{protocol:q}=await i(re,d.Tunnel,_,M);return re.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${he(F)}!`),q}async function k(re,_,M){const{connectTo:F,connectionToken:U}=await re.addressProvider.getAddress();return{commit:re.commit,quality:re.quality,connectTo:F,connectionToken:U,reconnectionToken:_,reconnectionProtocol:M,remoteSocketFactoryService:re.remoteSocketFactoryService,signService:re.signService,logService:re.logService}}async function y(re,_,M){return L(re,async F=>{const{protocol:U}=await s(F,E.CancellationToken.None);return new K(re,_,M,F.reconnectionToken,U)})}async function R(re,_){return L(re,async M=>{const{protocol:F,debugPort:U}=await c(M,_,E.CancellationToken.None);return new te(re,_,M.reconnectionToken,F,U)})}async function L(re,_){for(let F=1;;F++)try{const U=(0,h.$Yg)(),q=await k(re,U,null);return await _(q)}catch(U){if(F<5)re.logService.error(`[remote-connection][attempt ${F}] An error occurred in initial connection! Will retry... Error:`),re.logService.error(U);else throw re.logService.error(`[remote-connection][attempt ${F}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),re.logService.error(U),ae.triggerPermanentFailure(0,0,w.$Ql.isHandled(U)),U}}async function A(re,_,M){const F=await k(re,(0,h.$Yg)(),null);return await l(F,{host:_,port:M},E.CancellationToken.None)}function O(re){return(0,n.$ph)(_=>new Promise((M,F)=>{const U=setTimeout(M,re*1e3);_.onCancellationRequested(()=>{clearTimeout(U),M()})}))}var W;(function(re){re[re.ConnectionLost=0]="ConnectionLost",re[re.ReconnectionWait=1]="ReconnectionWait",re[re.ReconnectionRunning=2]="ReconnectionRunning",re[re.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",re[re.ConnectionGain=4]="ConnectionGain"})(W||(e.PersistentConnectionEventType=W={}));class x{constructor(_,M){this.reconnectionToken=_,this.millisSinceLastIncomingData=M,this.type=W.ConnectionLost}}e.$Zl=x;class C{constructor(_,M,F,U){this.reconnectionToken=_,this.millisSinceLastIncomingData=M,this.durationSeconds=F,this.c=U,this.type=W.ReconnectionWait}skipWait(){this.c.cancel()}}e.$1l=C;class B{constructor(_,M,F){this.reconnectionToken=_,this.millisSinceLastIncomingData=M,this.attempt=F,this.type=W.ReconnectionRunning}}e.$2l=B;class ee{constructor(_,M,F){this.reconnectionToken=_,this.millisSinceLastIncomingData=M,this.attempt=F,this.type=W.ConnectionGain}}e.$3l=ee;class X{constructor(_,M,F,U){this.reconnectionToken=_,this.millisSinceLastIncomingData=M,this.attempt=F,this.handled=U,this.type=W.ReconnectionPermanentFailure}}e.$4l=X;class ae extends I.$Tc{static triggerPermanentFailure(_,M,F){this._permanentFailure=!0,this.f=_,this.g=M,this.h=F,this.j.forEach(U=>U.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(_=>_.y())}static debugPauseSocketWriting(){this.j.forEach(_=>_.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ae._permanentFailure}constructor(_,M,F,U,q){super(),this.t=_,this.u=M,this.reconnectionToken=F,this.protocol=U,this.w=q,this.m=this.B(new T.$je),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new ee(this.reconnectionToken,0,0)),this.B(U.onSocketClose(Q=>{const J=oe(this.t,this.reconnectionToken,!0);Q?Q.type===m.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${J} received socket close event (hadError: ${Q.hadError}).`),Q.error&&this.u.logService.error(Q.error)):(this.u.logService.info(`${J} received socket close event (wasClean: ${Q.wasClean}, code: ${Q.code}, reason: ${Q.reason}).`),Q.event&&this.u.logService.error(Q.event)):this.u.logService.info(`${J} received socket close event.`),this.y()})),this.B(U.onSocketTimeout(Q=>{const J=oe(this.t,this.reconnectionToken,!0);this.u.logService.info(`${J} received socket timeout event (unacknowledgedMsgCount: ${Q.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Q.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Q.timeSinceLastReceivedSomeData}).`),this.y()})),ae.j.push(this),this.B((0,I.$Rc)(()=>{const Q=ae.j.indexOf(this);Q>=0&&ae.j.splice(Q,1)})),this.n&&this.D(ae.f,ae.g,ae.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const _=oe(this.t,this.reconnectionToken,!0);this.u.logService.info(`${_} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const M=[0,5,5,10,10,10,10,10,30];let F=-1;do{F++;const U=F<M.length?M[F]:M[M.length-1];try{if(U>0){const Q=O(U);this.m.fire(new C(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U,Q)),this.u.logService.info(`${_} waiting for ${U} seconds before reconnecting...`);try{await Q}catch{}}if(this.n){this.u.logService.error(`${_} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1)),this.u.logService.info(`${_} resolving connection...`);const q=await k(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${_} connecting to ${q.connectTo}...`),await this.G(q,b(f)),this.u.logService.info(`${_} reconnected!`),this.m.fire(new ee(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1));break}catch(q){if(q.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${_} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(q),this.C(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(F>360){this.u.logService.error(`${_} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(q),this.C(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(w.$Ql.isTemporarilyNotAvailable(q)){this.u.logService.info(`${_} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(q);continue}if((q.code==="ETIMEDOUT"||q.code==="ENETUNREACH"||q.code==="ECONNREFUSED"||q.code==="ECONNRESET")&&q.syscall==="connect"){this.u.logService.info(`${_} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(q);continue}if((0,D.$3)(q)){this.u.logService.info(`${_} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(q);continue}if(q instanceof w.$Ql){this.u.logService.error(`${_} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(q),this.C(this.protocol.getMillisSinceLastIncomingData(),F+1,w.$Ql.isHandled(q));break}this.u.logService.error(`${_} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(q),this.C(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}}while(!this.n&&!this.s)}C(_,M,F){this.w?ae.triggerPermanentFailure(_,M,F):this.D(_,M,F)}D(_,M,F){this.m.fire(new X(this.reconnectionToken,_,M,F)),z(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$5l=ae;class K extends ae{constructor(_,M,F,U,q){super(d.Management,_,U,q,!0),this.client=this.B(new m.$oi(q,{remoteAuthority:M,clientId:F},_.ipcLogger))}async G(_,M){await s(_,M)}}e.$6l=K;class te extends ae{constructor(_,M,F,U,q){super(d.ExtensionHost,_,F,U,!1),this.H=M,this.debugPort=q}async G(_,M){await c(_,this.H,M)}}e.$7l=te;function z(re){try{re.acceptDisconnect();const _=re.getSocket();re.dispose(),_.dispose()}catch(_){(0,D.$Y)(_)}}function j(re){if(re&&re.type==="error"){const _=new Error(`Connection error: ${re.reason}`);return _.code="VSCODE_CONNECTION_ERROR",_}return null}function N(re,_){for(;re.length<_;)re+=" ";return re}function V(re,_){return`[remote-connection][${N(v(re),13)}][${_.substr(0,5)}\u2026]`}function oe(re,_,M){return`${V(re,_)}[${M?"reconnect":"initial"}]`}function G(re,_){return`${oe(_,re.reconnectionToken,!!re.reconnectionProtocol)}[${re.connectTo}]`}function he(re){return`${Date.now()-re} ms`}}),define(le[74],ue([0,1,11]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=r,e.$en=E,e.$fn=D,e.$gn=T;function r(p){return p.scheme===n.Schemas.vscodeRemote?p.authority:void 0}function E(p){if(!p)return;const a=p.indexOf("+");return a<0?p:p.substr(0,a)}function D(p){const{host:a,port:g}=I(p);if(typeof g>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:g}}function T(p,a){let{host:g,port:h}=I(p);return typeof h>"u"&&(h=a),{host:g,port:h}}function I(p){const a=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const g=p.match(/^(\[[0-9a-z:]+\])$/);if(g)return{host:g[1],port:void 0};const h=p.match(/(.*):(\d+)$/);return h?{host:h[1],port:parseInt(h[2],10)}:{host:p,port:void 0}}}),define(le[85],ue([0,1,25,6,74]),function(Y,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=e.$pn=e.$on=e.$nn=e.TargetPlatform=e.ExtensionType=e.$mn=e.$kn=e.$jn=e.$in=e.$hn=void 0,e.$ln=D,e.$qn=h,e.$rn=m,e.$sn=w,e.$tn=f,e.$un=d,e.$vn=v,n=Ie(n),e.$hn="extensions.user.cache",e.$in="extensions.builtin.cache",e.$jn="undefined_publisher",e.$kn=["ui","workspace","web"];function D(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.$mn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(T||(e.ExtensionType=T={}));var I;(function(b){b.WIN32_X64="win32-x64",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class p{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,P){if(typeof $>"u"||$===null)return typeof P>"u"||P===null;if(typeof P>"u"||P===null)return!1;if(typeof $=="string"||typeof P=="string"){const S=typeof $=="string"?$:$.value,t=typeof P=="string"?P:P.value;return n.$Df(S,t)}return $._lower===P._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$nn=p;class a{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const P of $)this.add(P)}add($){this.c.add(p.toKey($))}delete($){return this.c.delete(p.toKey($))}has($){return this.c.has(p.toKey($))}}e.$on=a;class g{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(p.toKey($))}get($){return this.c.get(p.toKey($))}has($){return this.c.has(p.toKey($))}set($,P){this.c.set(p.toKey($),P)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$pn=g;function h(b){return m(b)}function m(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}function w(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}function f(b,$){if($){const P=`onResolveRemoteAuthority:${(0,E.$en)($)}`;return!!b.activationEvents?.includes(P)}return!1}function d(b){return b.map($=>{const[P,S]=$.split("@");return{proposalName:P,version:S?parseInt(S):void 0}})}function v(b){return b.map($=>$.split("@")[0])}e.$wn=(0,r.$Ci)("IBuiltinExtensionsScannerService")}),define(le[126],ue([0,1,3,10,85,6]),function(Y,e,n,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.ExtensionManagementErrorCode=e.$ip=e.ExtensionGalleryErrorCode=e.$hp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=void 0,e.$bp=I,e.$cp=p,e.$dp=a,e.$ep=g,e.$fp=h,e.$gp=m,e.$7o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$8o=new RegExp(e.$7o),e.$9o="__web_extension",e.$0o="skipWalkthrough",e.$$o="extensionInstallSource",e.$_o="dependecyOrPackExtensionInstall",e.$ap="clientTargetPlatform";var T;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(T||(e.ExtensionInstallSource=T={}));function I(t){switch(t){case E.TargetPlatform.WIN32_X64:return"Windows 64 bit";case E.TargetPlatform.WIN32_ARM64:return"Windows ARM";case E.TargetPlatform.LINUX_X64:return"Linux 64 bit";case E.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case E.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case E.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case E.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case E.TargetPlatform.DARWIN_X64:return"Mac";case E.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case E.TargetPlatform.WEB:return"Web";case E.TargetPlatform.UNIVERSAL:return E.TargetPlatform.UNIVERSAL;case E.TargetPlatform.UNKNOWN:return E.TargetPlatform.UNKNOWN;case E.TargetPlatform.UNDEFINED:return E.TargetPlatform.UNDEFINED}}function p(t){switch(t){case E.TargetPlatform.WIN32_X64:return E.TargetPlatform.WIN32_X64;case E.TargetPlatform.WIN32_ARM64:return E.TargetPlatform.WIN32_ARM64;case E.TargetPlatform.LINUX_X64:return E.TargetPlatform.LINUX_X64;case E.TargetPlatform.LINUX_ARM64:return E.TargetPlatform.LINUX_ARM64;case E.TargetPlatform.LINUX_ARMHF:return E.TargetPlatform.LINUX_ARMHF;case E.TargetPlatform.ALPINE_X64:return E.TargetPlatform.ALPINE_X64;case E.TargetPlatform.ALPINE_ARM64:return E.TargetPlatform.ALPINE_ARM64;case E.TargetPlatform.DARWIN_X64:return E.TargetPlatform.DARWIN_X64;case E.TargetPlatform.DARWIN_ARM64:return E.TargetPlatform.DARWIN_ARM64;case E.TargetPlatform.WEB:return E.TargetPlatform.WEB;case E.TargetPlatform.UNIVERSAL:return E.TargetPlatform.UNIVERSAL;default:return E.TargetPlatform.UNKNOWN}}function a(t,u){switch(t){case n.Platform.Windows:return u==="x64"?E.TargetPlatform.WIN32_X64:u==="arm64"?E.TargetPlatform.WIN32_ARM64:E.TargetPlatform.UNKNOWN;case n.Platform.Linux:return u==="x64"?E.TargetPlatform.LINUX_X64:u==="arm64"?E.TargetPlatform.LINUX_ARM64:u==="arm"?E.TargetPlatform.LINUX_ARMHF:E.TargetPlatform.UNKNOWN;case"alpine":return u==="x64"?E.TargetPlatform.ALPINE_X64:u==="arm64"?E.TargetPlatform.ALPINE_ARM64:E.TargetPlatform.UNKNOWN;case n.Platform.Mac:return u==="x64"?E.TargetPlatform.DARWIN_X64:u==="arm64"?E.TargetPlatform.DARWIN_ARM64:E.TargetPlatform.UNKNOWN;case n.Platform.Web:return E.TargetPlatform.WEB}}function g(t,u){return u===E.TargetPlatform.WEB&&!t.includes(E.TargetPlatform.WEB)}function h(t,u,i){return g(u,i)?!1:t===E.TargetPlatform.UNDEFINED||t===E.TargetPlatform.UNIVERSAL?!0:t===E.TargetPlatform.UNKNOWN?!1:t===i}function m(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var w;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(w||(e.SortBy=w={}));var f;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(f||(e.SortOrder=f={}));var d;(function(t){t.Install="install",t.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var v;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$hp=(0,D.$Ci)("extensionGalleryService");var b;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})(b||(e.ExtensionGalleryErrorCode=b={}));class $ extends Error{constructor(u,i){super(u),this.code=i,this.name=i}}e.$ip=$;var P;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateExistingMetadata="UpdateExistingMetadata",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(P||(e.ExtensionManagementErrorCode=P={}));class S extends Error{constructor(u,i){super(u),this.code=i,this.name=i}}e.$jp=S,e.$kp=(0,D.$Ci)("extensionManagementService"),e.$lp="extensionsIdentifiers/disabled",e.$mp="extensionsIdentifiers/enabled",e.$np=(0,D.$Ci)("IGlobalExtensionEnablementService"),e.$op=(0,D.$Ci)("IExtensionTipsService"),e.$pp=(0,r.localize2)(11334,"Extensions"),e.$qp=(0,r.localize2)(11335,"Preferences")});var et=this&&this.__importDefault||function(Y){return Y&&Y.__esModule?Y:{default:Y}};define(le[207],ue([0,1,18,81,10,208,85,170]),function(Y,e,n,r,E,D,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=g,e.$Wp=h,e.$Xp=m,e.$Yp=w,e.$Zp=f,e.$1p=d,e.$2p=v,e.$3p=b,r=et(r),E=Ie(E),D=Ie(D);const p=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,a=/^-(\d{4})(\d{2})(\d{2})$/;function g(S){return S=S.trim(),S==="*"||p.test(S)}function h(S){if(!g(S))return null;if(S=S.trim(),S==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=S.match(p);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function m(S){if(!S)return null;const t=S.majorBase,u=S.majorMustEqual,i=S.minorBase;let o=S.minorMustEqual;const s=S.patchBase;let c=S.patchMustEqual;S.hasCaret&&(t===0||(o=!1),c=!1);let l=0;if(S.preRelease){const k=a.exec(S.preRelease);if(k){const[,y,R,L]=k;l=Date.UTC(Number(y),Number(R)-1,Number(L))}}return{majorBase:t,majorMustEqual:u,minorBase:i,minorMustEqual:o,patchBase:s,patchMustEqual:c,isMinimum:S.hasGreaterEquals,notBefore:l}}function w(S,t,u){let i;typeof S=="string"?i=m(h(S)):i=S;let o;t instanceof Date?o=t.getTime():typeof t=="string"&&(o=new Date(t).getTime());let s;if(typeof u=="string"?s=m(h(u)):s=u,!i||!s)return!1;const c=i.majorBase,l=i.minorBase,k=i.patchBase;let y=s.majorBase,R=s.minorBase,L=s.patchBase;const A=s.notBefore;let O=s.majorMustEqual,W=s.minorMustEqual,x=s.patchMustEqual;return s.isMinimum?c>y?!0:c<y?!1:l>R?!0:l<R||o&&o<A?!1:k>=L:(c===1&&y===0&&(!O||!W||!x)&&(y=1,R=0,L=0,O=!0,W=!1,x=!1),c<y?!1:c>y?!O:l<R?!1:l>R?!W:k<L?!1:k>L?!x:!(o&&o<A))}function f(S,t,u,i,o,s){const c=[];if(typeof i.publisher<"u"&&typeof i.publisher!="string")return c.push([r.default.Error,E.localize(11266,null)]),c;if(typeof i.name!="string")return c.push([r.default.Error,E.localize(11267,null,"name")]),c;if(typeof i.version!="string")return c.push([r.default.Error,E.localize(11268,null,"version")]),c;if(!i.engines)return c.push([r.default.Error,E.localize(11269,null,"engines")]),c;if(typeof i.engines.vscode!="string")return c.push([r.default.Error,E.localize(11270,null,"engines.vscode")]),c;if(typeof i.extensionDependencies<"u"&&!P(i.extensionDependencies))return c.push([r.default.Error,E.localize(11271,null,"extensionDependencies")]),c;if(typeof i.activationEvents<"u"){if(!P(i.activationEvents))return c.push([r.default.Error,E.localize(11272,null,"activationEvents")]),c;if(typeof i.main>"u"&&typeof i.browser>"u")return c.push([r.default.Error,E.localize(11273,null,"activationEvents","main","browser")]),c}if(typeof i.extensionKind<"u"&&typeof i.main>"u"&&c.push([r.default.Warning,E.localize(11274,null,"extensionKind")]),typeof i.main<"u"){if(typeof i.main!="string")return c.push([r.default.Error,E.localize(11275,null,"main")]),c;{const y=(0,n.$dh)(u,i.main);(0,n.$0g)(y,u)||c.push([r.default.Warning,E.localize(11276,null,y.path,u.path)])}}if(typeof i.browser<"u"){if(typeof i.browser!="string")return c.push([r.default.Error,E.localize(11277,null,"browser")]),c;{const y=(0,n.$dh)(u,i.browser);(0,n.$0g)(y,u)||c.push([r.default.Warning,E.localize(11278,null,y.path,u.path)])}}if(!D.valid(i.version))return c.push([r.default.Error,E.localize(11279,null)]),c;const l=[];if(!d(S,t,i,o,l))for(const y of l)c.push([r.default.Error,y]);if(s&&i.enabledApiProposals?.length){const y=[];if(!b([...i.enabledApiProposals],y))for(const R of y)c.push([r.default.Error,R])}return c}function d(S,t,u,i,o){return i||typeof u.main>"u"&&typeof u.browser>"u"?!0:$(S,t,u.engines.vscode,o)}function v(S,t,u){return S==="*"||$(t,u,S)}function b(S,t){if(S.length===0)return!0;const u=Array.isArray(t)?t:void 0,i=(u?void 0:t)??I.allApiProposals,o=[],s=(0,T.$un)(S);for(const{proposalName:c,version:l}of s){const k=i[c];k&&l&&k.version!==l&&o.push(E.localize(11280,null,c))}return u?.push(...o),o.length===0}function $(S,t,u,i=[]){const o=m(h(u));if(!o)return i.push(E.localize(11281,null,u)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return i.push(E.localize(11282,null,u)),!1}else if(!o.majorMustEqual)return i.push(E.localize(11283,null,u)),!1;return w(S,t,o)?!0:(i.push(E.localize(11284,null,S,u)),!1)}function P(S){if(!Array.isArray(S))return!1;for(let t=0,u=S.length;t<u;t++)if(typeof S[t]!="string")return!1;return!0}}),define(le[209],ue([0,1,2,6]),function(Y,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=void 0,e.$Sl=(0,r.$Ci)("remoteSocketFactoryService");class E{constructor(){this.a={}}register(T,I){return this.a[T]??=[],this.a[T].push(I),(0,n.$Rc)(()=>{const p=this.a[T]?.indexOf(I);typeof p=="number"&&p>=0&&this.a[T]?.splice(p,1)})}b(T){return(this.a[T.type]||[]).find(p=>p.supports(T))}connect(T,I,p,a){const g=this.b(T);if(!g)throw new Error(`No socket factory found for ${T}`);return g.connect(T,I,p,a)}}e.$Tl=E}),define(le[210],ue([0,1,26,27,48,121]),function(Y,e,n,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=I,n=Ie(n),r=Ie(r),E=Ie(E),D=Ie(D);let T;async function I(w=!1){return(T===void 0||w)&&(T=p()),T}async function p(){const w=a();if(w===void 0)return!1;if(w>=22e3){const f=h();if(f)return new Promise(d=>{E.execFile(f,["--status"],v=>d(!v))})}else{const f=m();if(f)try{if((await n.promises.stat(f)).isFile())return!0}catch{}}return!1}function a(){const w=/(\d+)\.(\d+)\.(\d+)/g.exec(r.release());if(w)return parseInt(w[3])}function g(w){const f=process.env.SystemRoot;if(f){const d=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return D.join(f,d?"Sysnative":"System32",w)}}function h(){return g("wsl.exe")}function m(){return g("lxss\\LxssManager.dll")}}),define(le[56],ue([0,1,16,15,2,10,55,6,5,45]),function(Y,e,n,r,E,D,T,I,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=void 0,e.$6p=m,e.$7p=w,e.$8p=f,e.$9p=d,e.$0p=v,e.$$p=b,e.$4p=(0,I.$Ci)("requestService");class g{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const u in this.b)u.toLowerCase()==="authorization"||u.toLowerCase()==="proxy-authorization"?t[u]="*****":t[u]=this.b[u];this.a=t}return this.a}}class h extends E.$Tc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,D.localize)(11053,null),when:p.$ok.isEqualTo((0,p.$lk)(p.LogLevel.Trace)).serialize()})}async c(t,u,i){const o=`${t} #${++this.b}: ${u.url}`;this.a.trace(`${o} - begin`,u.type,new g(u.headers??{}));try{const s=await i();return this.a.trace(`${o} - end`,u.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${o} - error`,u.type,(0,r.$9)(s)),s}}}e.$5p=h;function m(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}function w(S){return S.res.statusCode===204}async function f(S){return w(S)?null:(await(0,n.$Xe)(S.stream)).toString()}async function d(S){if(!m(S))throw new Error("Server returned "+S.res.statusCode);return f(S)}async function v(S){if(!m(S))throw new Error("Server returned "+S.res.statusCode);if(w(S))return null;const u=(await(0,n.$Xe)(S.stream)).toString();try{return JSON.parse(u)}catch(i){throw i.message+=`:
`+u,i}}function b(S){P(S)}let $;function P(S){const t=a.$no.as(T.$so.Configuration),u=$;$={id:"http",order:15,title:(0,D.localize)(11054,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(11055,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(11056,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,D.localize)(11057,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,D.localize)(11058,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(11059,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(11060,null),(0,D.localize)(11061,null),(0,D.localize)(11062,null),(0,D.localize)(11063,null)],default:"override",description:(0,D.localize)(11064,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(11065,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,D.localize)(11066,null),restricted:!0}}},t.updateConfigurations({add:[$],remove:u?[u]:[]})}P(T.ConfigurationScope.APPLICATION)}),define(le[211],ue([0,1,16,21]),function(Y,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=e.$$r=void 0;class E{constructor(I){this.a=I}listen(I,p){throw new Error("Invalid listen")}call(I,p,a,g=r.CancellationToken.None){switch(p){case"request":return this.a.request(a[0],g).then(async({res:h,stream:m})=>{const w=await(0,n.$Xe)(m);return[{statusCode:h.statusCode,headers:h.headers},w]});case"resolveProxy":return this.a.resolveProxy(a[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$$r=E;class D{constructor(I){this.a=I}async request(I,p){const[a,g]=await this.a.call("request",[I],p);return{res:a,stream:(0,n.$Ze)(g)}}async resolveProxy(I){return this.a.call("resolveProxy",[I])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$_r=D}),define(le[212],ue([0,1,213,12]),function(Y,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=D;function E(T,I){return T.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:T.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function D(T,I,p={}){const a=(0,n.parse)(T),g=p.proxyUrl||E(a,I);if(!g)return null;const h=(0,n.parse)(g);if(!/^https?:$/.test(h.protocol||""))return null;const m={host:h.hostname||"",port:(h.port?+h.port:0)||(h.protocol==="https"?443:80),auth:h.auth,rejectUnauthorized:(0,r.$ig)(p.strictSSL)?p.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((w,f)=>{Y(["http-proxy-agent"],w,f)}).then(Ie)).HttpProxyAgent(g,m):new(await new Promise((w,f)=>{Y(["https-proxy-agent"],w,f)}).then(Ie)).HttpsProxyAgent(g,m)}}),define(le[214],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5fc=e.$4fc=e.$3fc=void 0,e.$3fc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$4fc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$5fc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(le[100],ue([0,1,48,9,10,21,54,15,3,33,116,68,8,142]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=d;let f;async function d(b,$,P,S){return P["force-disable-user-env"]?($.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):p.$j?($.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,h.$Gm)(S)&&!P["force-user-env"]?($.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,h.$Gm)(S)?$.trace("resolveShellEnv(): running (--force-user-env)"):$.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=m.Promises.withAsyncBody(async(t,u)=>{const i=new D.$ue;let o=1e4;const s=b.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(o=(0,w.$Hm)(s,1,120)*1e3);const c=setTimeout(()=>{i.dispose(!0),u(new Error((0,E.localize)(11050,null)))},o);try{t(await v($,i.token))}catch(l){!(0,I.$3)(l)&&!i.token.isCancellationRequested?u(new Error((0,E.localize)(11051,null,(0,T.$nj)(l)))):t({})}finally{clearTimeout(c),i.dispose()}})),f)}async function v(b,$){const P=process.env.ELECTRON_RUN_AS_NODE;b.trace("getUnixShellEnvironment#runAsNode",P);const S=process.env.ELECTRON_NO_ATTACH_CONSOLE;b.trace("getUnixShellEnvironment#noAttach",S);const t=(0,a.$Yg)().replace(/-/g,"").substr(0,12),u=new RegExp(t+"({.*})"+t),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};b.trace("getUnixShellEnvironment#env",i);const o=await(0,g.$wm)(p.OS,i);return b.trace("getUnixShellEnvironment#shell",o),new Promise((s,c)=>{if($.isCancellationRequested)return c(new I.$4);const l=(0,r.$mc)(o);let k,y;const R="";/^pwsh(-preview)?$/.test(l)?(k=`& '${process.execPath}' ${R} -p '''${t}'' + JSON.stringify(process.env) + ''${t}'''`,y=["-Login","-Command"]):l==="nu"?(k=`^'${process.execPath}' ${R} -p '"${t}" + JSON.stringify(process.env) + "${t}"'`,y=["-i","-l","-c"]):l==="xonsh"?(k=`import os, json; print("${t}", json.dumps(dict(os.environ)), "${t}")`,y=["-i","-l","-c"]):(k=`'${process.execPath}' ${R} -p '"${t}" + JSON.stringify(process.env) + "${t}"'`,l==="tcsh"||l==="csh"?y=["-ic"]:y=["-i","-l","-c"]),b.trace("getUnixShellEnvironment#spawn",JSON.stringify(y),k);const L=(0,n.spawn)(o,[...y,k],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});$.onCancellationRequested(()=>(L.kill(),c(new I.$4))),L.on("error",W=>{b.error("getUnixShellEnvironment#errorChildProcess",(0,T.$nj)(W)),c(W)});const A=[];L.stdout.on("data",W=>A.push(W));const O=[];L.stderr.on("data",W=>O.push(W)),L.on("close",(W,x)=>{const C=Buffer.concat(A).toString("utf8");b.trace("getUnixShellEnvironment#raw",C);const B=Buffer.concat(O).toString("utf8");if(B.trim()&&b.trace("getUnixShellEnvironment#stderr",B),W||x)return c(new Error((0,E.localize)(11052,null,W,x)));const ee=u.exec(C),X=ee?ee[1]:"{}";try{const ae=JSON.parse(X);P?ae.ELECTRON_RUN_AS_NODE=P:delete ae.ELECTRON_RUN_AS_NODE,S?ae.ELECTRON_NO_ATTACH_CONSOLE=S:delete ae.ELECTRON_NO_ATTACH_CONSOLE,delete ae.VSCODE_RESOLVING_ENVIRONMENT,delete ae.XDG_RUNTIME_DIR,b.trace("getUnixShellEnvironment#result",ae),s(ae)}catch(ae){b.error("getUnixShellEnvironment#errorCaught",(0,T.$nj)(ae)),c(ae)}})})}}),define(le[215],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Obc=void 0;class n{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(E){try{const D=await this.c();if(D){const T=String(n.a++);return this.b.set(T,D),{id:T,data:D.createNewMessage(E)}}}catch{}return{id:"",data:E}}async validate(E,D){if(!E.id)return!0;const T=this.b.get(E.id);if(!T)return!1;this.b.delete(E.id);try{return T.validate(D)==="ok"}catch{return!1}finally{T.dispose?.()}}async sign(E){try{return await this.d(E)}catch{}return E}}e.$Obc=n}),define(le[101],ue([0,1,6]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.$Ul=void 0,e.$Ul="signService",e.$Vl=(0,n.$Ci)(e.$Ul)}),define(le[216],ue([0,1,215]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ugc=void 0;class r extends n.$Obc{c(){return this.h().then(D=>new D.validator)}d(D){return this.h().then(T=>new T.signer().sign(D))}h(){return new Promise((D,T)=>Y(["vsda"],D,T))}}e.$Ugc=r}),define(le[34],ue([0,1,6]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gR=e.$fR=void 0,e.$fR=(0,n.$Ci)("stateReadService"),e.$gR=(0,n.$Ci)("stateService")}),define(le[127],ue([0,1,8,16,2,12,38,14,5]),function(Y,e,n,r,E,D,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jR=e.$iR=e.$hR=e.SaveStrategy=void 0;var a;(function(w){w[w.IMMEDIATE=0]="IMMEDIATE",w[w.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class g extends E.$Tc{constructor(f,d,v,b){super(),this.h=f,this.j=d,this.m=v,this.n=b,this.a=Object.create(null),this.b="",this.c=this.B(new n.$Ah(this.j===a.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(f){f.fileOperationResult!==I.FileOperationResult.FILE_NOT_FOUND&&this.m.error(f)}}getItem(f,d){const v=this.a[f];return(0,D.$lg)(v)?d:v}setItem(f,d){this.setItems([{key:f,data:d}])}setItems(f){let d=!1;for(const{key:v,data:b}of f)this.a[v]!==b&&((0,D.$lg)(b)?(0,D.$jg)(this.a[v])||(this.a[v]=void 0,d=!0):(this.a[v]=b,d=!0));d&&this.s()}removeItem(f){(0,D.$jg)(this.a[f])||(this.a[f]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const f=JSON.stringify(this.a,null,4);if(f!==this.b)try{await this.n.writeFile(this.h,r.$Le.fromString(f),{atomic:{postfix:".vsctmp"}}),this.b=f}catch(d){this.m.error(d)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$hR=g;let h=class extends E.$Tc{constructor(f,d,v,b){super(),this.a=this.B(new g(d.stateResource,f,v,b))}async init(){await this.a.init()}getItem(f,d){return this.a.getItem(f,d)}};e.$iR=h,e.$iR=h=Ee([se(1,T.$Ji),se(2,p.$9j),se(3,I.$9k)],h);class m extends h{setItem(f,d){this.a.setItem(f,d)}setItems(f){this.a.setItems(f)}removeItem(f){this.a.removeItem(f)}close(){return this.a.close()}}e.$jR=m}),define(le[128],ue([0,1,3,36,33]),function(Y,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=T,e.$sp=I;function D(p){if(n.$v===n.Platform.Linux&&/^penguin(\.|$)/i.test(p))return"chromebook"}function T(p,a,g,h,m,w,f,d,v,b){const $=Object.create(null);$["common.machineId"]=w,$["common.sqmId"]=f,$["common.devDeviceId"]=d,$.sessionID=(0,E.$Yg)()+Date.now(),$.commitHash=h,$.version=m,$["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,n.$i)(n.$v),$["common.nodePlatform"]=r.$cc,$["common.nodeArch"]=g,$["common.product"]=b||"desktop",v&&($["common.msftInternal"]=v);let P=0;const S=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-S,enumerable:!0},"common.sequence":{get:()=>P++,enumerable:!0}}),n.$m&&($["common.snap"]="true");const t=D(a);return t&&($["common.platformDetail"]=t),$}function I(p){const a=r.env.USERDNSDOMAIN;if(!a)return!1;const g=a.toLowerCase();return p.some(h=>g===h)}}),define(le[24],ue([0,1,6]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=void 0,e.$8l=(0,n.$Ci)("telemetryService"),e.$9l=(0,n.$Ci)("customEndpointTelemetryService"),e.$0l="telemetry.currentSessionDate",e.$$l="telemetry.firstSessionDate",e.$_l="telemetry.lastSessionDate",e.$am="telemetry.machineId",e.$bm="telemetry.sqmId",e.$cm="telemetry.devDeviceId",e.$dm="telemetry",e.$em="telemetry.telemetryLevel",e.$fm="telemetry.enableCrashReporter",e.$gm="telemetry.enableTelemetry";var r;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(r||(e.TelemetryLevel=r={}));var E;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(E||(e.TelemetryConfiguration=E={}))}),define(le[217],ue([0,1,26,27,8,43,11,9,3,66,7,92,23,115,96,14,28,24]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w,f,d,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=void 0,e.$Us=P,e.$Vs=t,e.$Ws=u,n=Ie(n),r=Ie(r);const $=new Map;async function P(o,s){const c=`${o}::${s.join(":")}`,l=$.get(c);if(l)return l;const k=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],y=new Map,R=new Map,L=2e4;function A(W,x,C,B){const ee=x.substring(W.length+1);return E.Promises.withAsyncBody(async X=>{let ae;B.readdirCount++;try{ae=await m.Promises.readdir(x,{withFileTypes:!0})}catch{X();return}if(B.count>=L){B.count+=ae.length,B.maxReached=!0,X();return}let K=ae.length;if(K===0){X();return}let te=ae;B.count+ae.length>L&&(B.maxReached=!0,K=L-B.count,te=ae.slice(0,K)),B.count+=ae.length;for(const z of te)if(z.isDirectory()){if(C.includes(z.name)||await A(W,(0,I.$ic)(x,z.name),C,B),--K===0){X();return}}else{const j=z.name.lastIndexOf(".");if(j>=0){const N=z.name.substring(j+1);N&&y.set(N,(y.get(N)??0)+1)}for(const N of k)N.relativePathPattern?.test(ee)!==!1&&N.filePattern.test(z.name)&&R.set(N.tag,(R.get(N.tag)??0)+1);if(--K===0){X();return}}})}const O=E.Promises.withAsyncBody(async W=>{const x={count:0,maxReached:!1,readdirCount:0},C=new a.$de(!0);await A(o,o,s,x);const B=await u(o);W({configFiles:S(R),fileTypes:S(y),fileCount:x.count,maxFilesReached:x.maxReached,launchConfigFiles:B,totalScanTime:C.elapsed(),totalReaddirCount:x.readdirCount})});return $.set(c,O),O}function S(o){return Array.from(o.entries(),([s,c])=>({name:s,count:c})).sort((s,c)=>c.count-s.count)}function t(){const o={os:`${r.type()} ${r.arch()} ${r.release()}`,memory:`${(r.totalmem()/d.$El.GB).toFixed(2)}GB (${(r.freemem()/d.$El.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(h.$On.value()*100)}%`},s=r.cpus();return s&&s.length>0&&(o.cpus=`${s[0].model} (${s.length} x ${s[0].speed})`),o}async function u(o){try{const s=new Map,c=(0,I.$ic)(o,".vscode","launch.json"),l=await n.promises.readFile(c),k=[],y=(0,D.$Un)(l.toString(),k);if(k.length)return console.log(`Unable to parse ${c}`),[];if((0,D.$3n)(y)==="object"&&y.configurations)for(const R of y.configurations){const L=R.type;L&&(s.has(L)?s.set(L,s.get(L)+1):s.set(L,1))}return S(s)}catch{return[]}}let i=class{constructor(s,c){this.c=s,this.d=c}f(s){const c=[];return c.push(`OS Version:       ${s.os}`),c.push(`CPUs:             ${s.cpus}`),c.push(`Memory (System):  ${s.memory}`),c.push(`VM:               ${s.vmHint}`),c.join(`
`)}g(s){const c=[];c.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),c.push(`OS Version:       ${r.type()} ${r.arch()} ${r.release()}`);const l=r.cpus();return l&&l.length>0&&c.push(`CPUs:             ${l[0].model} (${l.length} x ${l[0].speed})`),c.push(`Memory (System):  ${(r.totalmem()/d.$El.GB).toFixed(2)}GB (${(r.freemem()/d.$El.GB).toFixed(2)}GB free)`),p.$j||c.push(`Load (avg):       ${r.loadavg().map(k=>Math.round(k)).join(", ")}`),c.push(`VM:               ${Math.round(h.$On.value()*100)}%`),c.push(`Screen Reader:    ${s.screenReader?"yes":"no"}`),c.push(`Process Argv:     ${s.mainArguments.join(" ")}`),c.push(`GPU Status:       ${this.j(s.gpuFeatureStatus)}`),c.join(`
`)}async getPerformanceInfo(s,c){return Promise.all([(0,w.$Ts)(s.mainPID),this.k(s)]).then(async l=>{let[k,y]=l,R=this.m(s,k);return c.forEach(L=>{if((0,f.$Qm)(L))R+=`
${L.errorMessage}`,y+=`
${L.errorMessage}`;else if(R+=`

Remote: ${L.hostName}`,L.processes&&(R+=`
${this.m(s,L.processes)}`),L.workspaceMetadata){y+=`
|  Remote: ${L.hostName}`;for(const A of Object.keys(L.workspaceMetadata)){const O=L.workspaceMetadata[A];let W=`${O.fileCount} files`;O.maxFilesReached&&(W=`more than ${W}`),y+=`|    Folder (${A}): ${W}`,y+=this.h(O)}}}),{processInfo:R,workspaceInfo:y}})}async getSystemInfo(s,c){const{memory:l,vmHint:k,os:y,cpus:R}=t(),L={os:y,memory:l,cpus:R,vmHint:k,processArgs:`${s.mainArguments.join(" ")}`,gpuStatus:s.gpuFeatureStatus,screenReader:`${s.screenReader?"yes":"no"}`,remoteData:c};return p.$j||(L.load=`${r.loadavg().map(A=>Math.round(A)).join(", ")}`),p.$l&&(L.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(L)}async getDiagnostics(s,c){const l=[];return(0,w.$Ts)(s.mainPID).then(async k=>(l.push(""),l.push(this.g(s)),l.push(""),l.push(this.m(s,k)),s.windows.some(y=>y.folderURIs&&y.folderURIs.length>0&&!y.remoteAuthority)&&(l.push(""),l.push("Workspace Stats: "),l.push(await this.k(s))),c.forEach(y=>{if((0,f.$Qm)(y))l.push(`
${y.errorMessage}`);else if(l.push(`

`),l.push(`Remote:           ${y.hostName}`),l.push(this.f(y.machineInfo)),y.processes&&l.push(this.m(s,y.processes)),y.workspaceMetadata)for(const R of Object.keys(y.workspaceMetadata)){const L=y.workspaceMetadata[R];let A=`${L.fileCount} files`;L.maxFilesReached&&(A=`more than ${A}`),l.push(`Folder (${R}): ${A}`),l.push(this.h(L))}}),l.push(""),l.push(""),l.join(`
`)))}h(s){const c=[];let k=0;const y=(O,W)=>{const x=` ${O}(${W})`;k+x.length>60?(c.push(R),R="|                 ",k=R.length):k+=x.length,R+=x};let R="|      File types:";const L=10,A=s.fileTypes.length>L?L:s.fileTypes.length;for(let O=0;O<A;O++){const W=s.fileTypes[O];y(W.name,W.count)}if(c.push(R),s.configFiles.length>=0&&(R="|      Conf files:",k=0,s.configFiles.forEach(O=>{y(O.name,O.count)}),c.push(R)),s.launchConfigFiles.length>0){let O="|      Launch Configs:";s.launchConfigFiles.forEach(W=>{const x=W.count>1?` ${W.name}(${W.count})`:` ${W.name}`;O+=x}),c.push(O)}return c.join(`
`)}j(s){const c=Math.max(...Object.keys(s).map(l=>l.length));return Object.keys(s).map(l=>`${l}:  ${" ".repeat(c-l.length)}  ${s[l]}`).join(`
                  `)}k(s){const c=[],l=[];return s.windows.forEach(k=>{k.folderURIs.length===0||k.remoteAuthority||(c.push(`|  Window (${k.title})`),k.folderURIs.forEach(y=>{const R=g.URI.revive(y);if(R.scheme===T.Schemas.file){const L=R.fsPath;l.push(P(L,["node_modules",".git"]).then(A=>{let O=`${A.fileCount} files`;A.maxFilesReached&&(O=`more than ${O}`),c.push(`|    Folder (${(0,I.$mc)(L)}): ${O}`),c.push(this.h(A))}).catch(A=>{c.push(`|      Error: Unable to collect workspace stats for folder ${L} (${A.toString()})`)}))}else c.push(`|    Folder (${R.toString()}): Workspace stats not available.`)}))}),Promise.all(l).then(k=>c.join(`
`)).catch(k=>`Unable to collect workspace stats: ${k}`)}m(s,c){const l=new Map;s.windows.forEach(y=>l.set(y.pid,`window [${y.id}] (${y.title})`)),s.pidToNames.forEach(({pid:y,name:R})=>l.set(y,R));const k=[];return k.push("CPU %	Mem MB	   PID	Process"),c&&this.n(s.mainPID,l,k,c,0),k.join(`
`)}n(s,c,l,k,y){const R=y===0;let L;R?L=k.pid===s?`${this.d.applicationName} main`:"remote agent":c.has(k.pid)?L=c.get(k.pid):L=`${"  ".repeat(y)} ${k.name}`;const A=process.platform==="win32"?k.mem:r.totalmem()*(k.mem/100);l.push(`${k.load.toFixed(0).padStart(5," ")}	${(A/d.$El.MB).toFixed(0).padStart(6," ")}	${k.pid.toFixed(0).padStart(6," ")}	${L}`),Array.isArray(k.children)&&k.children.forEach(O=>this.n(s,c,l,O,y+1))}async getWorkspaceFileExtensions(s){const c=new Set;for(const{uri:l}of s.folders){const k=g.URI.revive(l);if(k.scheme!==T.Schemas.file)continue;const y=k.fsPath;try{(await P(y,["node_modules",".git"])).fileTypes.forEach(L=>c.add(L.name))}catch{}}return{extensions:[...c]}}async reportWorkspaceStats(s){for(const{uri:c}of s.folders){const l=g.URI.revive(c);if(l.scheme!==T.Schemas.file)continue;const k=l.fsPath;try{const y=await P(k,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":s.telemetryId,rendererSessionId:s.rendererSessionId}),y.fileTypes.forEach(R=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:s.rendererSessionId,type:R.name,count:R.count})}),y.launchConfigFiles.forEach(R=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:s.rendererSessionId,type:R.name,count:R.count})}),y.configFiles.forEach(R=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:s.rendererSessionId,type:R.name,count:R.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:y.totalScanTime,reachedLimit:y.maxFilesReached,fileCount:y.fileCount,readdirCount:y.totalReaddirCount})}catch{}}}};e.$Xs=i,e.$Xs=i=Ee([se(0,b.$8l),se(1,v.$pk)],i)}),define(le[218],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9fc=e.$8fc=void 0;class n{constructor(D){this.b=D}listen(D,T){throw new Error(`Event not found: ${T}`)}call(D,T,{eventName:I,data:p}){return this.b.forEach(a=>a.log(I,p)),Promise.resolve(null)}}e.$8fc=n;class r{constructor(D){this.b=D}log(D,T){return this.b.call("log",{eventName:D,data:T}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$9fc=r}),define(le[57],ue([0,1,37,12,74,128,24]),function(Y,e,n,r,E,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=void 0,e.$Ap=g,e.$Bp=h,e.$Cp=m,e.$Dp=w,e.$Ep=d,e.$Fp=b,e.$Gp=$,e.$Hp=t;class I{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.$tp=I;class p{constructor(){this.telemetryLevel=T.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$up=p,e.$vp=new p;class a{async publicLog(i,o,s){}async publicLogError(i,o,s){}}e.$wp=a,e.$xp="telemetry",e.$yp="extensionTelemetryLog",e.$zp={log:()=>null,flush:()=>Promise.resolve(null)};function g(u,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!u.enableTelemetry)}function h(u,i){return i.extensionTestsLocationURI?!0:!(i.isBuilt||i.disableTelemetry||u.enableTelemetry&&u.aiConfig?.ariaKey)}function m(u){const i=u.getValue(T.$em),o=u.getValue(T.$fm);if(u.getValue(T.$gm)===!1||o===!1)return T.TelemetryLevel.NONE;switch(i??T.TelemetryConfiguration.ON){case T.TelemetryConfiguration.ON:return T.TelemetryLevel.USAGE;case T.TelemetryConfiguration.ERROR:return T.TelemetryLevel.ERROR;case T.TelemetryConfiguration.CRASH:return T.TelemetryLevel.CRASH;case T.TelemetryConfiguration.OFF:return T.TelemetryLevel.NONE}}function w(u){const i={},o={},s={};v(u,s);for(let c in s){c=c.length>150?c.substr(c.length-149):c;const l=s[c];typeof l=="number"?o[c]=l:typeof l=="boolean"?o[c]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${c} has been trimmed to 8192, the original length is ${l.length}`),i[c]=l.substring(0,8191)):typeof l<"u"&&l!==null&&(i[c]=l)}return{properties:i,measurements:o}}const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function d(u){if(!u)return"none";const i=(0,E.$en)(u);return f.has(i)?i:"other"}function v(u,i,o=0,s){if(u)for(const c of Object.getOwnPropertyNames(u)){const l=u[c],k=s?s+c:c;Array.isArray(l)?i[k]=(0,n.$fo)(l):l instanceof Date?i[k]=l.toISOString():(0,r.$eg)(l)?o<2?v(l,i,o+1,k+"."):i[k]=(0,n.$fo)(l):i[k]=l}}function b(u,i){const o=u.msftInternalDomains||[],s=i.getValue("telemetry.internalTesting");return(0,D.$sp)(o)||s}function $(u){return[u.appRoot,u.extensionsPath,u.userHome.fsPath,u.tmpDir.fsPath,u.userDataPath]}function P(u,i){if(!u||!u.includes("/")&&!u.includes("\\"))return u;let o=u;const s=[];for(const y of i)for(;;){const R=y.exec(u);if(!R)break;s.push([R.index,y.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(o="";;){const y=l.exec(u);if(!y)break;const R=s.some(([L,A])=>y.index<A&&L<l.lastIndex);!c.test(y[0])&&!R&&(o+=u.substring(k,y.index)+"<REDACTED: user-file-path>",k=l.lastIndex)}return k<u.length&&(o+=u.substr(k)),o}function S(u){if(!u)return u;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of i)if(o.regex.test(u))return`<REDACTED: ${o.label}>`;return u}function t(u,i){return(0,n.$co)(u,o=>{if(o instanceof I||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let s=o.replaceAll("%20"," ");s=P(s,i);for(const c of i)s=s.replace(c,"");return s=S(s),s}})}}),define(le[129],ue([0,1,25,126,85,3,7,15,36,57]),function(Y,e,n,r,E,D,T,I,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Jp=void 0,e.$Ip=g,e.$Kp=f,e.$Lp=d,e.$Mp=v,e.$Np=b,e.$Op=$,e.$Pp=P,e.$Qp=S,e.$Sp=t,e.$Tp=i;function g(o,s){return o.uuid&&s.uuid?o.uuid===s.uuid:o.id===s.id?!0:(0,n.$yf)(o.id,s.id)===0}const h=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(s){const c=s.manifest?s.manifest.version:s.version,l=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new m(s.identifier,c,l)}static parse(s){const c=h.exec(s);return c&&c[1]&&c[2]?new m({id:c[1]},c[2],c[4]||void 0):null}constructor(s,c,l=E.TargetPlatform.UNDEFINED){this.identifier=s,this.version=c,this.targetPlatform=l,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==E.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof m?g(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$Jp=m;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(o){const s=w.exec(o);return s&&s[1]?[v(s[1]),s[2]]:[v(o),void 0]}function d(o,s){return`${o}.${s}`}function v(o){return o.toLowerCase()}function b(o,s){return v(d(o??E.$jn,s))}function $(o,s){const c=[],l=k=>{for(const y of c)if(y.some(R=>g(s(R),s(k))))return y;return null};for(const k of o){const y=l(k);y?y.push(k):c.push([k])}return c}function P(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}function S(o){return{id:new a.$tp(o.identifier.id),name:new a.$tp(o.name),version:o.version,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.$Rp=new E.$nn("pprice.better-merge");function t(o,s){const c=[],l=s.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const k=l.shift();if(k&&c.every(y=>!g(y.identifier,{id:k}))){const y=o.filter(R=>g(R.identifier,{id:k}));y.length===1&&(c.push(y[0]),l.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}async function u(o,s){if(!D.$l)return!1;let c;try{c=(await o.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await o.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){s.debug("Error while getting the os-release file.",(0,I.$9)(k))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(o,s){const c=await u(o,s),l=(0,r.$dp)(c?"alpine":D.$v,p.$dc);return s.debug("ComputeTargetPlatform:",l),l}});var et=this&&this.__importDefault||function(Y){return Y&&Y.__esModule?Y:{default:Y}};define(le[219],ue([0,1,2,37,3,25,10,17,55,72,28,45,24,57]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ds=void 0,a=et(a);let f=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(b,$,P){this.k=$,this.l=P,this.d={},this.i=new n.$Sc,this.j=[],this.b=b.appenders,this.c=b.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=b.piiPaths||[],this.g=m.TelemetryLevel.USAGE,this.h=!!b.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const S of this.f)this.j.push(new RegExp((0,D.$ff)(S),"gi")),S.indexOf("\\")>=0&&this.j.push(new RegExp((0,D.$ff)(S.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(S=>{(S.affectsConfiguration(m.$em)||S.affectsConfiguration(m.$gm)||S.affectsConfiguration(m.$fm))&&this.m()}))}setExperimentProperty(b,$){this.d[b]=$}m(){let b=(0,w.$Cp)(this.k);const $=this.l.enabledTelemetryLevels;if($){this.h=this.sendErrorTelemetry?$.error:!1;const P=$.usage?m.TelemetryLevel.USAGE:$.error?m.TelemetryLevel.ERROR:m.TelemetryLevel.NONE;b=Math.min(b,P)}this.g=b}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(b,$,P){this.g<$||(P=(0,r.$do)(P,this.d),P=(0,w.$Hp)(P,this.j),P=(0,r.$do)(P,this.c),this.b.forEach(S=>S.log(b,P)))}publicLog(b,$){this.n(b,m.TelemetryLevel.USAGE,$)}publicLog2(b,$){this.publicLog(b,$)}publicLogError(b,$){this.h&&this.n(b,m.TelemetryLevel.ERROR,$)}publicLogError2(b,$){this.publicLogError(b,$)}};e.$ds=f,e.$ds=f=Ee([se(1,I.$9i),se(2,g.$pk)],f);function d(){const v=(0,T.localize)(11031,null,a.default.nameLong),b=a.default.privacyStatementUrl?(0,T.localize)(11033,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,T.localize)(11032,null,"https://aka.ms/vscode-telemetry"),$=E.$p?"":(0,T.localize)(11034,null),P=(0,T.localize)(11035,null),S=(0,T.localize)(11036,null),t=(0,T.localize)(11037,null),u=(0,T.localize)(11038,null),i=`
|       | ${P} | ${S} | ${t} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,T.localize)(11039,null);return`
${v} ${b} ${$}

&nbsp;

${u}
${i}

&nbsp;

${o}
`}h.$no.as(p.$so.Configuration).registerConfiguration({id:m.$dm,order:1,type:"object",title:(0,T.localize)(11040,null),properties:{[m.$em]:{type:"string",enum:[m.TelemetryConfiguration.ON,m.TelemetryConfiguration.ERROR,m.TelemetryConfiguration.CRASH,m.TelemetryConfiguration.OFF],enumDescriptions:[(0,T.localize)(11041,null),(0,T.localize)(11042,null),(0,T.localize)(11043,null),(0,T.localize)(11044,null)],markdownDescription:d(),default:m.TelemetryConfiguration.ON,restricted:!0,scope:p.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),h.$no.as(p.$so.Configuration).registerConfiguration({id:m.$dm,order:110,type:"object",title:(0,T.localize)(11045,null),properties:{[m.$gm]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,T.localize)(11047,null,a.default.nameLong,a.default.privacyStatementUrl):(0,T.localize)(11046,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(11048,null,`\`#${m.$em}#\``),scope:p.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(le[220],ue([0,1,3,92,24]),function(Y,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xgc=D,e.$ygc=T,e.$zgc=I;async function D(p,a){let g=p.getItem(E.$am);return(typeof g!="string"||n.$k&&g==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(g=await(0,r.$Pn)(a.error.bind(a))),g}async function T(p,a){let g=p.getItem(E.$bm);return typeof g!="string"&&(g=await(0,r.$Qn)(a.error.bind(a))),g}async function I(p,a){let g=p.getItem(E.$cm);return typeof g!="string"&&(g=await(0,r.$Rn)(a.error.bind(a))),g}}),define(le[221],ue([0,1,24,220]),function(Y,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Agc=E,e.$Bgc=D,e.$Cgc=T;async function E(I,p){const a=await(0,r.$xgc)(I,p);return I.setItem(n.$am,a),a}async function D(I,p){const a=await(0,r.$ygc)(I,p);return I.setItem(n.$bm,a),a}async function T(I,p){const a=await(0,r.$zgc)(I,p);return I.setItem(n.$cm,a),a}}),define(le[130],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var n;(function(r){r[r.Replace=1]="Replace",r[r.Append=2]="Append",r[r.Prepend=3]="Prepend"})(n||(e.EnvironmentVariableMutatorType=n={}))}),define(le[222],ue([0,1,3,130]),function(Y,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=void 0;const E=new Map([[r.EnvironmentVariableMutatorType.Append,"APPEND"],[r.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[r.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class D{constructor(g){this.collections=g,this.a=new Map,this.b=new Map,g.forEach((h,m)=>{this.d(h,m);const w=h.map.entries();let f=w.next();for(;!f.done;){const d=f.value[1],v=f.value[0];let b=this.a.get(v);if(b||(b=[],this.a.set(v,b)),b.length>0&&b[0].type===r.EnvironmentVariableMutatorType.Replace){f=w.next();continue}const $={extensionIdentifier:m,value:d.value,type:d.type,scope:d.scope,variable:d.variable,options:d.options};$.scope||delete $.scope,b.unshift($),f=w.next()}})}async applyToProcessEnvironment(g,h,m){let w;n.$j&&(w={},Object.keys(g).forEach(f=>w[f.toLowerCase()]=f));for(const[f,d]of this.getVariableMap(h)){const v=n.$j&&w[f.toLowerCase()]||f;for(const b of d){const $=m?await m(b.value):b.value;if(b.options?.applyAtProcessCreation??!0)switch(b.type){case r.EnvironmentVariableMutatorType.Append:g[v]=(g[v]||"")+$;break;case r.EnvironmentVariableMutatorType.Prepend:g[v]=$+(g[v]||"");break;case r.EnvironmentVariableMutatorType.Replace:g[v]=$;break}if(b.options?.applyAtShellIntegration??!1){const P=`VSCODE_ENV_${E.get(b.type)}`;g[P]=(g[P]?g[P]+":":"")+f+"="+this.c($)}}}}c(g){return g.replaceAll(":","\\x3a")}diff(g,h){const m=new Map,w=new Map,f=new Map;if(g.getVariableMap(h).forEach((d,v)=>{const b=this.getVariableMap(h).get(v),$=I(d,b);$&&m.set(v,$)}),this.getVariableMap(h).forEach((d,v)=>{const b=g.getVariableMap(h).get(v),$=I(d,b);$&&f.set(v,$)}),this.getVariableMap(h).forEach((d,v)=>{const b=g.getVariableMap(h).get(v),$=p(d,b);$&&w.set(v,$)}),!(m.size===0&&w.size===0&&f.size===0))return{added:m,changed:w,removed:f}}getVariableMap(g){const h=new Map;for(const m of this.a.values()){const w=m.filter(f=>T(f,g));w.length>0&&h.set(w[0].variable,w)}return h}getDescriptionMap(g){const h=new Map;for(const m of this.b.values()){const w=m.filter(f=>T(f,g,!0));for(const f of w)h.set(f.extensionIdentifier,f.description)}return h}d(g,h){if(!g.descriptionMap)return;const m=g.descriptionMap.entries();let w=m.next();for(;!w.done;){const f=w.value[1],d=w.value[0];let v=this.b.get(d);v||(v=[],this.b.set(d,v));const b={extensionIdentifier:h,scope:f.scope,description:f.description};b.scope||delete b.scope,v.push(b),w=m.next()}}}e.$Hs=D;function T(a,g,h=!1){return a.scope?!!(a.scope.workspaceFolder&&g?.workspaceFolder&&a.scope.workspaceFolder.index===g.workspaceFolder.index):h?g===a.scope:!0}function I(a,g){if(!g)return a;const h=new Set;g.forEach(w=>h.add(w.extensionIdentifier));const m=[];return a.forEach(w=>{h.has(w.extensionIdentifier)||m.push(w)}),m.length===0?void 0:m}function p(a,g){if(!g)return;const h=new Map;g.forEach(w=>h.set(w.extensionIdentifier,w));const m=[];return a.forEach(w=>{const f=h.get(w.extensionIdentifier);f&&(w.type!==f.type||w.value!==f.value||w.scope?.workspaceFolder?.index!==f.scope?.workspaceFolder?.index)&&m.push(f)}),m.length===0?void 0:m}}),define(le[223],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bs=n,e.$Cs=r,e.$Ds=E,e.$Es=D,e.$Fs=T,e.$Gs=I;function n(p){return[...p.entries()]}function r(p){return p?[...p.entries()]:[]}function E(p){return new Map(p)}function D(p){return new Map(p??[])}function T(p){return Array.from(p.entries()).map(a=>[a[0],n(a[1].map),r(a[1].descriptionMap)])}function I(p){return new Map(p.map(a=>[a[0],{map:E(a[1]),descriptionMap:D(a[2])}]))}}),define(le[224],ue([0,1,8,21,4,2,5]),function(Y,e,n,r,E,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=void 0;let I=class extends D.$Tc{constructor(a,g){super(),this.h=g,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new E.$je),this.onCreateRequest=this.g.event,this.b=a===void 0?15e3:a,this.B((0,D.$Rc)(()=>{for(const h of this.f.values())(0,D.$Oc)(h)}))}createRequest(a){return new Promise((g,h)=>{const m=++this.a;this.c.set(m,g),this.g.fire({requestId:m,...a});const w=new r.$ue;(0,n.$Dh)(this.b,w.token).then(()=>h(`Request ${m} timed out (${this.b}ms)`)),this.f.set(m,[(0,D.$Rc)(()=>w.cancel())])})}acceptReply(a,g){const h=this.c.get(a);h?(this.c.delete(a),(0,D.$Oc)(this.f.get(a)||[]),this.f.delete(a),h(g)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${a}`)}};e.$ss=I,e.$ss=I=Ee([se(1,T.$9j)],I)}),define(le[75],ue([0,1,6,122,45]),function(Y,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$os=e.$ns=e.$ms=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ls=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ks=void 0,e.$ks=new r.$Tj("terminalTabFocusMode",!1,!0);var D;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(D||(e.TerminalSettingPrefix=D={}));var T;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(T||(e.TerminalSettingId=T={}));var I;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(I||(e.PosixShellType=I={}));var p;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})(p||(e.WindowsShellType=p={}));var a;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(a||(e.TitleEventSource=a={}));var g;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(g||(e.TerminalIpcChannels=g={}));var h;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(h||(e.ProcessPropertyType=h={})),e.$ls=(0,n.$Ci)("ptyService");var m;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(m||(e.HeartbeatConstants=m={}));var w;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(w||(e.TerminalLocation=w={}));var f;(function(t){t.TerminalView="view",t.Editor="editor"})(f||(e.TerminalLocationString=f={}));var d;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(d||(e.LocalReconnectConstants=d={}));var v;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(v||(e.FlowControlConstants=v={}));var b;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(b||(e.ProfileSource=b={}));var $;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})($||(e.ShellIntegrationStatus=$={}));var P;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(P||(e.TerminalExitReason=P={})),e.$ms={Backend:"workbench.contributions.terminal.processBackend"};class S{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(u){const i=this.b(u.remoteAuthority);if(this.a.has(i))throw new Error(`A terminal backend with remote authority '${i}' was already registered.`);this.a.set(i,u)}getTerminalBackend(u){return this.a.get(this.b(u))}b(u){return u?.toLowerCase()??""}}E.$no.add(e.$ms.Backend,new S),e.$ns=(0,n.$Ci)("localPtyService"),e.$os=(0,n.$Ci)("terminalLogService")}),define(le[225],ue([0,1,80,7,10,110]),function(Y,e,n,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ts=T,e.$us=a,e.$vs=g,e.$ws=h;function T(m,w){const f=[{name:null,description:(0,E.localize)(10998,null)}];return f.push(...m.map(d=>({name:d.profileName,description:I(d)}))),w&&f.push(...w.map(d=>({name:d.title,description:p(d)}))),{values:f.map(d=>d.name),markdownDescriptions:f.map(d=>d.description)}}function I(m){let w=`$(${D.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:n.$2j.terminal.id}) ${m.profileName}
- path: ${m.path}`;return m.args&&(typeof m.args=="string"?w+=`
- args: "${m.args}"`:w+=`
- args: [${m.args.length===0?"":`'${m.args.join("','")}'`}]`),m.overrideName!==void 0&&(w+=`
- overrideName: ${m.overrideName}`),m.color&&(w+=`
- color: ${m.color}`),m.env&&(w+=`
- env: ${JSON.stringify(m.env)}`),w}function p(m){return`$(${D.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:n.$2j.terminal.id}) ${m.title}
- extensionIdentifier: ${m.extensionIdentifier}`}function a(m,w){if(!m&&!w)return!0;if(typeof m=="string"&&typeof w=="string")return m===w;if(Array.isArray(m)&&Array.isArray(w)){if(m.length!==w.length)return!1;for(let f=0;f<m.length;f++)if(m[f]!==w[f])return!1;return!0}return!1}function g(m,w){if(!m&&!w)return!0;if(!m||!w)return!1;if(D.ThemeIcon.isThemeIcon(m)&&D.ThemeIcon.isThemeIcon(w))return m.id===w.id&&m.color===w.color;if(typeof m=="object"&&"light"in m&&"dark"in m&&typeof w=="object"&&"light"in w&&"dark"in w){const f=m,d=w;if((r.URI.isUri(f.light)||h(f.light))&&(r.URI.isUri(f.dark)||h(f.dark))&&(r.URI.isUri(d.light)||h(d.light))&&(r.URI.isUri(d.dark)||h(d.dark)))return f.light.path===d.light.path&&f.dark.path===d.dark.path}if(r.URI.isUri(m)&&r.URI.isUri(w)||h(m)||h(w)){const f=m,d=w;return f.path===d.path&&f.scheme===d.scheme}return!1}function h(m){return m?typeof m.path=="string"&&typeof m.scheme=="string":!1}}),define(le[226],ue([0,1,80,3,10,55,45,75,225]),function(Y,e,n,r,E,D,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=e.$xs=void 0,e.$zs=f,e.$As=v,e.$xs={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$ys={type:"string",enum:Array.from((0,n.$Zj)(),b=>b.id),markdownEnumDescriptions:Array.from((0,n.$Zj)(),b=>`$(${b.id})`)};const a={args:{description:(0,E.localize)(10999,null),type:"array",items:{type:"string"}},overrideName:{description:(0,E.localize)(11e3,null),type:"boolean"},icon:{description:(0,E.localize)(11001,null),...e.$ys},color:{description:(0,E.localize)(11002,null),...e.$xs},env:{markdownDescription:(0,E.localize)(11003,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},g={type:"object",required:["path"],properties:{path:{description:(0,E.localize)(11004,null),type:["string","array"],items:{type:"string"}},...a}},h={type:"object",required:["path"],properties:{path:{description:(0,E.localize)(11005,null),type:["string"],items:{type:"string"}},...a}};function m(b){const $=b===r.Platform.Linux?"linux":b===r.Platform.Mac?"osx":"windows";return(0,E.localize)(11006,null,(0,r.$i)(b),'```json\n"terminal.integrated.profile.'+$+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const w={id:"terminal",order:100,title:(0,E.localize)(11007,null),type:"object",properties:{[I.TerminalSettingId.AutomationProfileLinux]:{restricted:!0,markdownDescription:(0,E.localize)(11008,null),type:["object","null"],default:null,anyOf:[{type:"null"},h],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.AutomationProfileMacOs]:{restricted:!0,markdownDescription:(0,E.localize)(11009,null),type:["object","null"],default:null,anyOf:[{type:"null"},h],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.AutomationProfileWindows]:{restricted:!0,markdownDescription:(0,E.localize)(11010,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},h],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.ProfilesWindows]:{restricted:!0,markdownDescription:m(r.Platform.Windows),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,E.localize)(11011,null),enum:["PowerShell","Git Bash"]},...a}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,E.localize)(11012,null),type:"string"},id:{description:(0,E.localize)(11013,null),type:"string"},title:{description:(0,E.localize)(11014,null),type:"string"},...a}},{type:"null"},g]}},[I.TerminalSettingId.ProfilesMacOs]:{restricted:!0,markdownDescription:m(r.Platform.Mac),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,E.localize)(11015,null),type:"string"},id:{description:(0,E.localize)(11016,null),type:"string"},title:{description:(0,E.localize)(11017,null),type:"string"},...a}},{type:"null"},g]}},[I.TerminalSettingId.ProfilesLinux]:{restricted:!0,markdownDescription:m(r.Platform.Linux),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,E.localize)(11018,null),type:"string"},id:{description:(0,E.localize)(11019,null),type:"string"},title:{description:(0,E.localize)(11020,null),type:"string"},...a}},{type:"null"},g]}},[I.TerminalSettingId.UseWslProfiles]:{description:(0,E.localize)(11021,null),type:"boolean",default:!0},[I.TerminalSettingId.InheritEnv]:{scope:D.ConfigurationScope.APPLICATION,description:(0,E.localize)(11022,null),type:"boolean",default:!0},[I.TerminalSettingId.PersistentSessionScrollback]:{scope:D.ConfigurationScope.APPLICATION,markdownDescription:(0,E.localize)(11023,null),type:"number",default:100},[I.TerminalSettingId.ShowLinkHover]:{scope:D.ConfigurationScope.APPLICATION,description:(0,E.localize)(11024,null),type:"boolean",default:!0},[I.TerminalSettingId.IgnoreProcessNames]:{markdownDescription:(0,E.localize)(11025,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function f(){T.$no.as(D.$so.Configuration).registerConfiguration(w),v()}let d;function v(b,$){const P=T.$no.as(D.$so.Configuration);let S;b&&(S=(0,p.$ts)(b?.profiles,$));const t=d;d={id:"terminal",order:100,title:(0,E.localize)(11026,null),type:"object",properties:{[I.TerminalSettingId.DefaultProfileLinux]:{restricted:!0,markdownDescription:(0,E.localize)(11027,null),type:["string","null"],default:null,enum:b?.os===r.OperatingSystem.Linux?S?.values:void 0,markdownEnumDescriptions:b?.os===r.OperatingSystem.Linux?S?.markdownDescriptions:void 0},[I.TerminalSettingId.DefaultProfileMacOs]:{restricted:!0,markdownDescription:(0,E.localize)(11028,null),type:["string","null"],default:null,enum:b?.os===r.OperatingSystem.Macintosh?S?.values:void 0,markdownEnumDescriptions:b?.os===r.OperatingSystem.Macintosh?S?.markdownDescriptions:void 0},[I.TerminalSettingId.DefaultProfileWindows]:{restricted:!0,markdownDescription:(0,E.localize)(11029,null),type:["string","null"],default:null,enum:b?.os===r.OperatingSystem.Windows?S?.values:void 0,markdownEnumDescriptions:b?.os===r.OperatingSystem.Windows?S?.markdownDescriptions:void 0}}},P.updateConfigurations({add:[d],remove:t?[t]:[]})}}),define(le[227],ue([0,1,27,11,37,9,3,36,25,12,23,130,223,222]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Is=f,e.$Js=d,e.$Ks=v,n=Ie(n),D=Ie(D),I=Ie(I),g=Ie(g);function f(){const l=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());let k=0;return l&&l.length===4&&(k=parseInt(l[3])),k}async function d(l,k,y,R=I.env,L=g.Promises.exists){if(D.$hc(l))return await L(l)?l:void 0;if(k===void 0&&(k=I.cwd()),D.$lc(l)!=="."){const x=D.$ic(k,l);return await L(x)?x:void 0}const O=(0,E.$ho)(R,"PATH");if(y===void 0&&(0,a.$cg)(O)&&(y=O.split(D.$sc)),y===void 0||y.length===0){const x=D.$ic(k,l);return await L(x)?x:void 0}for(const x of y){let C;if(D.$hc(x)?C=D.$ic(x,l):C=D.$ic(k,x,l),await L(C))return C;if(T.$j){let B=C+".com";if(await L(B)||(B=C+".exe",await L(B)))return B}}const W=D.$ic(k,l);return await L(W)?W:void 0}function v(l,k,y,R,L){const A=T.$j&&(!k.windowsEnableConpty||f()<18309);if(!k.shellIntegration.enabled||!l.executable||l.isFeatureTerminal&&!l.forceShellIntegration||l.ignoreShellIntegration||A)return;const O=l.args,W=I.$cc==="win32"?D.$mc(l.executable).toLowerCase():D.$mc(l.executable),x=D.$lc(r.$Wg.asFileUri("").fsPath);let C;const B={VSCODE_INJECTION:"1"};if(k.shellIntegration.nonce&&(B.VSCODE_NONCE=k.shellIntegration.nonce),T.$j){if(W==="pwsh.exe"||W==="powershell.exe")return!O||s(O)?C=P.get($.WindowsPwsh):o(O)&&(C=P.get($.WindowsPwshLogin)),C?(C=[...C],C[C.length-1]=(0,p.$bf)(C[C.length-1],x,""),B.VSCODE_STABLE=L.quality==="stable"?"1":"0",k.shellIntegration.suggestEnabled&&(B.VSCODE_SUGGEST="1"),{newArgs:C,envMixin:B}):void 0;if(W==="bash.exe")return!O||O.length===0?C=P.get($.Bash):c(O)&&(B.VSCODE_SHELL_LOGIN="1",b(k,B),C=P.get($.Bash)),C?(C=[...C],C[C.length-1]=(0,p.$bf)(C[C.length-1],x),B.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:C,envMixin:B}):void 0;R.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args);return}switch(W){case"bash":return!O||O.length===0?C=P.get($.Bash):c(O)&&(B.VSCODE_SHELL_LOGIN="1",b(k,B),C=P.get($.Bash)),C?(C=[...C],C[C.length-1]=(0,p.$bf)(C[C.length-1],x),B.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:C,envMixin:B}):void 0;case"fish":{const ee=y?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",X=D.$ic(x,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return B.XDG_DATA_DIRS=`${ee}:${X}`,b(k,B),{newArgs:void 0,envMixin:B}}case"pwsh":return!O||s(O)?C=P.get($.Pwsh):o(O)&&(C=P.get($.PwshLogin)),C?(k.shellIntegration.suggestEnabled&&(B.VSCODE_SUGGEST="1"),C=[...C],C[C.length-1]=(0,p.$bf)(C[C.length-1],x,""),B.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:C,envMixin:B}):void 0;case"zsh":{if(!O||O.length===0?C=P.get($.Zsh):c(O)?(C=P.get($.ZshLogin),b(k,B)):(O===P.get($.Zsh)||O===P.get($.ZshLogin))&&(C=O),!C)return;C=[...C],C[C.length-1]=(0,p.$bf)(C[C.length-1],x);let ee;try{ee=n.userInfo().username}catch{ee="unknown"}const X=D.$ic(n.tmpdir(),`${ee}-${L.applicationName}-zsh`);B.ZDOTDIR=X;const ae=y?.ZDOTDIR??n.homedir()??"~";B.USER_ZDOTDIR=ae;const K=[];return K.push({source:D.$ic(x,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:D.$ic(X,".zshrc")}),K.push({source:D.$ic(x,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:D.$ic(X,".zprofile")}),K.push({source:D.$ic(x,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:D.$ic(X,".zshenv")}),K.push({source:D.$ic(x,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:D.$ic(X,".zlogin")}),{newArgs:C,envMixin:B,filesToCopy:K}}}R.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args)}function b(l,k){if(T.$k&&l.environmentVariableCollections){const y=(0,m.$Gs)(l.environmentVariableCollections),L=new w.$Hs(y).getVariableMap({workspaceFolder:l.workspaceFolder}).get("PATH"),A=[];if(L)for(const O of L)O.type===h.EnvironmentVariableMutatorType.Prepend&&A.push(O.value);A.length>0&&(k.VSCODE_PATH_PREFIX=A.join(""))}}var $;(function(l){l.WindowsPwsh="windows-pwsh",l.WindowsPwshLogin="windows-pwsh-login",l.Pwsh="pwsh",l.PwshLogin="pwsh-login",l.Zsh="zsh",l.ZshLogin="zsh-login",l.Bash="bash"})($||($={}));const P=new Map;P.set($.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),P.set($.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),P.set($.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),P.set($.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),P.set($.Zsh,["-i"]),P.set($.ZshLogin,["-il"]),P.set($.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const S=["-login","-l"],t=["--login","-l"],u=["-i","--interactive"],i=["-nol","-nologo"];function o(l){return typeof l=="string"?S.includes(l.toLowerCase()):l.length===1&&S.includes(l[0].toLowerCase())||l.length===2&&(S.includes(l[0].toLowerCase())||S.includes(l[1].toLowerCase()))&&(i.includes(l[0].toLowerCase())||i.includes(l[1].toLowerCase()))}function s(l){return typeof l=="string"?i.includes(l.toLowerCase()):l.length===0||l?.length===1&&i.includes(l[0].toLowerCase())}function c(l){return typeof l!="string"&&(l=l.filter(k=>!u.includes(k.toLowerCase()))),l==="string"&&t.includes(l.toLowerCase())||typeof l!="string"&&l.length===1&&t.includes(l[0].toLowerCase())}}),define(le[228],ue([0,1,26,48,80,9,3,12,23,114,75,227,121]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ls=v,n=Ie(n),r=Ie(r),p=Ie(p);var w;(function(y){y.UnixShellsPath="/etc/shells"})(w||(w={}));let f,d=!0;function v(y,R,L,A,O=process.env,W,x,C,B){return W=W||{existsFile:p.SymlinkSupport.existsFile,readFile:n.promises.readFile},T.$j?b(L,W,O,x,A.getValue(g.TerminalSettingId.UseWslProfiles)!==!1,y&&typeof y=="object"?{...y}:A.getValue(g.TerminalSettingId.ProfilesWindows),typeof R=="string"?R:A.getValue(g.TerminalSettingId.DefaultProfileWindows),B,C):c(W,x,L,y&&typeof y=="object"?{...y}:A.getValue(T.$l?g.TerminalSettingId.ProfilesLinux:g.TerminalSettingId.ProfilesMacOs),typeof R=="string"?R:A.getValue(T.$l?g.TerminalSettingId.DefaultProfileLinux:g.TerminalSettingId.DefaultProfileMacOs),B,C,O)}async function b(y,R,L,A,O,W,x,C,B){const ee=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),X=`${process.env.windir}\\${ee?"Sysnative":"System32"}`;let ae=!1;(0,h.$Is)()>=16299&&(ae=!0),await t(C);const K=new Map;if(y){K.set("PowerShell",{source:g.ProfileSource.Pwsh,icon:E.$2j.terminalPowershell,isAutoDetected:!0}),K.set("Windows PowerShell",{path:`${X}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:E.$2j.terminalPowershell,isAutoDetected:!0}),K.set("Git Bash",{source:g.ProfileSource.GitBash,isAutoDetected:!0}),K.set("Command Prompt",{path:`${X}\\cmd.exe`,icon:E.$2j.terminalCmd,isAutoDetected:!0}),K.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),K.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:E.$2j.terminalBash,isAutoDetected:!0});const z=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;K.set("Cmder",{path:`${X}\\cmd.exe`,args:["/K",z],requiresPath:process.env.CMDER_ROOT?z:{path:z,isUnsafe:!0},isAutoDetected:!0})}l(W,K);const te=await $(K.entries(),x,R,L,A,B);if(y&&O)try{const z=await o(`${X}\\${ae?"wsl":"bash"}.exe`,x);for(const j of z)(!W||!(j.profileName in W))&&te.push(j)}catch{d&&(A?.trace("WSL is not installed, so could not detect WSL profiles"),d=!1)}return te}async function $(y,R,L,A=process.env,O,W){const x=[];for(const[C,B]of y)x.push(P(C,B,R,L,A,O,W));return(await Promise.all(x)).filter(C=>!!C)}async function P(y,R,L,A,O=process.env,W,x){if(R===null)return;let C,B,ee;if("source"in R&&!("path"in R)){const te=f?.get(R.source);if(!te)return;C=te.paths,B=R.args||te.args,R.icon?ee=S(R.icon):te.icon&&(ee=te.icon)}else C=Array.isArray(R.path)?R.path:[R.path],B=T.$j||Array.isArray(R.args)?R.args:void 0,ee=S(R.icon);let X;if(x){const te=C.map(j=>typeof j=="string"?j:j.path),z=await x(te);X=new Array(C.length);for(let j=0;j<C.length;j++)typeof C[j]=="string"?X[j]=z[j]:X[j]={path:z[j],isUnsafe:!0}}else X=C.slice();let ae;if(R.requiresPath){let te;if((0,I.$cg)(R.requiresPath)?te=R.requiresPath:(te=R.requiresPath.path,R.requiresPath.isUnsafe&&(ae=te)),!await A.existsFile(te))return}const K=await k(y,L,X,A,O,B,R.env,R.overrideName,R.isAutoDetected,ae);if(!K){W?.debug("Terminal profile not validated",y,C);return}return K.isAutoDetected=R.isAutoDetected,K.icon=ee,K.color=R.color,K}function S(y){return typeof y=="string"?{id:y}:y}async function t(y){if(f&&!y)return;const[R,L]=await Promise.all([u(),y||i()]);f=new Map,f.set(g.ProfileSource.GitBash,{profileName:"Git Bash",paths:R,args:["--login","-i"]}),f.set(g.ProfileSource.Pwsh,{profileName:"PowerShell",paths:L,icon:E.$2j.terminalPowershell})}async function u(){const y=new Set,R=await(0,h.$Js)("git.exe");if(R){const O=(0,m.dirname)(R);y.add((0,m.resolve)(O,"../.."))}function L(O,W){W&&O.add(W)}L(y,process.env.ProgramW6432),L(y,process.env.ProgramFiles),L(y,process.env["ProgramFiles(X86)"]),L(y,`${process.env.LocalAppData}\\Program`);const A=[];for(const O of y)A.push(`${O}\\Git\\bin\\bash.exe`,`${O}\\Git\\usr\\bin\\bash.exe`,`${O}\\usr\\bin\\bash.exe`);return A.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),A.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),A}async function i(){const y=[];for await(const R of(0,a.$sm)())y.push(R.exePath);return y}async function o(y,R){const L=[],A=await new Promise((x,C)=>{r.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(B,ee)=>{if(B)return C("Problem occurred when getting wsl distros");x(ee)})});if(!A)return[];const O=new RegExp(/[\r?\n]/),W=A.split(O).filter(x=>x.trim().length>0&&x!=="");for(const x of W){if(x===""||x.startsWith("docker-desktop"))continue;const C=`${x} (WSL)`,B={profileName:C,path:y,args:["-d",`${x}`],isDefault:C===R,icon:s(x),isAutoDetected:!1};L.push(B)}return L}function s(y){return y.includes("Ubuntu")?E.$2j.terminalUbuntu:y.includes("Debian")?E.$2j.terminalDebian:E.$2j.terminalLinux}async function c(y,R,L,A,O,W,x,C){const B=new Map;if(L&&await y.existsFile(w.UnixShellsPath)){const ee=(await y.readFile(w.UnixShellsPath)).toString(),X=(W||ee.split(`
`)).map(K=>{const te=K.indexOf("#");return te===-1?K:K.substring(0,te)}).filter(K=>K.trim().length>0),ae=new Map;for(const K of X){let te=(0,D.$mc)(K),z=ae.get(te)||0;z++,z>1&&(te=`${te} (${z})`),ae.set(te,z),B.set(te,{path:K,isAutoDetected:!0})}}return l(A,B),await $(B.entries(),O,y,C,R,x)}function l(y,R){if(y)for(const[L,A]of Object.entries(y))A===null||typeof A!="object"||!("path"in A)&&!("source"in A)?R.delete(L):(A.icon=A.icon||R.get(L)?.icon,R.set(L,A))}async function k(y,R,L,A,O,W,x,C,B,ee){if(L.length===0)return Promise.resolve(void 0);const X=L.shift();if(X==="")return k(y,R,L,A,O,W,x,C,B);const ae=typeof X!="string"&&X.isUnsafe,K=typeof X=="string"?X:X.path,te={profileName:y,path:K,args:W,env:x,overrideName:C,isAutoDetected:B,isDefault:y===R,isUnsafePath:ae,requiresUnsafePath:ee};if((0,D.$mc)(K)===K){const j=O.PATH?O.PATH.split(D.$sc):void 0,N=await(0,h.$Js)(K,void 0,j,void 0,A.existsFile);return N?(te.path=N,te.isFromPath=!0,te):k(y,R,L,A,O,W)}return await A.existsFile((0,D.$gc)(K))?te:k(y,R,L,A,O,W,x,C,B)}}),define(le[229],ue([0,1,4,2,3,44,17,5,191,100,224,75,226,228,116,66]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ms=void 0;var v;(function($){$[$.MaxRestarts=5]="MaxRestarts"})(v||(v={}));let b=class extends r.$Tc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(P,S,t,u){super(),this.M=P,this.N=S,this.O=t,this.P=u,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new n.$je),this.onPtyHostExit=this.u.event,this.w=this.B(new n.$je),this.onPtyHostStart=this.w.event,this.y=this.B(new n.$je),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new n.$je),this.onPtyHostResponsive=this.z.event,this.C=this.B(new n.$je),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new n.$je),this.onProcessData=this.D.event,this.F=this.B(new n.$je),this.onProcessReady=this.F.event,this.G=this.B(new n.$je),this.onProcessReplay=this.G.event,this.H=this.B(new n.$je),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new n.$je),this.onDidRequestDetach=this.I.event,this.J=this.B(new n.$je),this.onDidChangeProperty=this.J.event,this.L=this.B(new n.$je),this.onProcessExit=this.L.event,(0,m.$zs)(),this.B(this.M),this.B((0,r.$Rc)(()=>this.W())),this.j=this.B(new g.$ss(void 0,this.O)),this.B(this.j.onCreateRequest(this.C.fire,this.C)),this.M.onRequestConnection&&this.B(n.Event.once(this.M.onRequestConnection)(()=>this.h())),this.M.onWillShutdown&&this.B(this.M.onWillShutdown(()=>this.m=!0))}get Q(){return this.N.getValue(h.TerminalSettingId.IgnoreProcessNames)}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(E.$j)return process.env;try{return await(0,a.$Nm)(this.N,this.O,{_:[]},process.env)}catch(P){return this.O.error("ptyHost was unable to resolve shell environment",P),{}}}U(){const P=this.M.start(),S=P.client;this.O.getLevel()===I.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),D.ProxyChannel.toService(S.getChannel(h.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(P.onDidProcessExit(i=>{this.u.fire(i.code),!this.m&&!this.q.isDisposed&&(this.n<=v.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${i.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${i.code}, giving up`))}));const u=D.ProxyChannel.toService(S.getChannel(h.TerminalIpcChannels.PtyHost));return this.B(u.onProcessData(i=>this.D.fire(i))),this.B(u.onProcessReady(i=>this.F.fire(i))),this.B(u.onProcessExit(i=>this.L.fire(i))),this.B(u.onDidChangeProperty(i=>this.J.fire(i))),this.B(u.onProcessReplay(i=>this.G.fire(i))),this.B(u.onProcessOrphanQuestion(i=>this.H.fire(i))),this.B(u.onDidRequestDetach(i=>this.I.fire(i))),this.B(new p.$rs(this.P,S.getChannel(h.TerminalIpcChannels.Logger))),this.a=P,this.b=u,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async i=>{i.affectsConfiguration(h.TerminalSettingId.IgnoreProcessNames)&&await this.R()})),this.R(),[P,u]}async createProcess(P,S,t,u,i,o,s,c,l,k,y){const R=setTimeout(()=>this.$(),h.HeartbeatConstants.CreateProcessTimeout),L=await this.f.createProcess(P,S,t,u,i,o,s,c,l,k,y);return clearTimeout(R),L}updateTitle(P,S,t){return this.f.updateTitle(P,S,t)}updateIcon(P,S,t,u){return this.f.updateIcon(P,S,t,u)}attachToProcess(P){return this.f.attachToProcess(P)}detachFromProcess(P,S){return this.f.detachFromProcess(P,S)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(P){return this.f.start(P)}shutdown(P,S){return this.f.shutdown(P,S)}input(P,S){return this.f.input(P,S)}processBinary(P,S){return this.f.processBinary(P,S)}resize(P,S,t){return this.f.resize(P,S,t)}clearBuffer(P){return this.f.clearBuffer(P)}acknowledgeDataEvent(P,S){return this.f.acknowledgeDataEvent(P,S)}setUnicodeVersion(P,S){return this.f.setUnicodeVersion(P,S)}getInitialCwd(P){return this.f.getInitialCwd(P)}getCwd(P){return this.f.getCwd(P)}async getLatency(){const P=new d.$de,S=await this.f.getLatency();return P.stop(),[{label:"ptyhostservice<->ptyhost",latency:P.elapsed()},...S]}orphanQuestionReply(P){return this.f.orphanQuestionReply(P)}installAutoReply(P,S){return this.f.installAutoReply(P,S)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(P){return this.f.uninstallAutoReply(P)}getDefaultSystemShell(P){return this.g?.getDefaultSystemShell(P)??(0,f.$wm)(P??E.OS,process.env)}async getProfiles(P,S,t,u=!1){const i=await this.S();return(0,w.$Ls)(S,t,u,this.N,i,void 0,this.O,this.bb.bind(this,P))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(P,S){return this.f.getWslPath(P,S)}getRevivedPtyNewId(P,S){return this.f.getRevivedPtyNewId(P,S)}setTerminalLayoutInfo(P){return this.f.setTerminalLayoutInfo(P)}async getTerminalLayoutInfo(P){return this.g?.getTerminalLayoutInfo(P)}async requestDetachInstance(P,S){return this.f.requestDetachInstance(P,S)}async acceptDetachInstanceReply(P,S){return this.f.acceptDetachInstanceReply(P,S)}async freePortKillProcess(P){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(P)}async serializeTerminalState(P){return this.f.serializeTerminalState(P)}async reviveTerminalProcesses(P,S,t){return this.f.reviveTerminalProcesses(P,S,t)}async refreshProperty(P,S){return this.f.refreshProperty(P,S)}async updateProperty(P,S,t){return this.f.updateProperty(P,S,t)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(P){this.ab(),this.s=setTimeout(()=>this.Y(),P?h.HeartbeatConstants.ConnectingBeatInterval:h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier+h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${h.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(P,S){return this.j.createRequest({workspaceId:P,originalText:S})}async acceptPtyHostResolvedVariables(P,S){this.j.acceptReply(P,S)}};e.$Ms=b,e.$Ms=b=Ee([se(1,T.$9i),se(2,I.$9j),se(3,I.$0j)],b)}),define(le[76],ue([0,1,13,4,2,3,17,6,34]),function(Y,e,n,r,E,D,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xec=e.$Wec=void 0;const a="#FFFFFF",g="#1E1E1E",h="#000000",m="#FFFFFF",w="theme",f="themeBackground",d="windowSplash";var v;(function($){$.DETECT_COLOR_SCHEME="window.autoDetectColorScheme",$.SYSTEM_COLOR_THEME="window.systemColorTheme"})(v||(v={})),e.$Wec=(0,I.$Ci)("themeMainService");let b=class extends E.$Tc{constructor(P,S){super(),this.b=P,this.c=S,this.a=this.B(new r.$je),this.onDidChangeColorScheme=this.a.event,D.$l||this.B(this.c.onDidChangeConfiguration(t=>{(t.affectsConfiguration(v.SYSTEM_COLOR_THEME)||t.affectsConfiguration(v.DETECT_COLOR_SCHEME))&&this.f()})),this.f(),this.B(r.Event.fromNodeEventEmitter(n.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){if(D.$l||this.c.getValue(v.DETECT_COLOR_SCHEME))n.nativeTheme.themeSource="system";else switch(this.c.getValue(v.SYSTEM_COLOR_THEME)){case"dark":n.nativeTheme.themeSource="dark";break;case"light":n.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":n.nativeTheme.themeSource="light";break;case"vs-dark":n.nativeTheme.themeSource="dark";break;default:n.nativeTheme.themeSource="system"}break;default:n.nativeTheme.themeSource="system";break}}getColorScheme(){if(D.$j){if(n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(D.$k){if(n.nativeTheme.shouldUseInvertedColorScheme||n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(D.$l&&n.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const P=this.getColorScheme();if(P.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return P.dark?h:m;let S=this.b.getItem(f,null);if(!S)switch(this.g()){case"vs":S=a;break;case"hc-black":S=h;break;case"hc-light":S=m;break;default:S=g}return D.$k&&S.toUpperCase()===g&&(S="#171717"),S}g(){switch(this.b.getItem(w,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(P,S){this.b.setItems([{key:w,data:S.baseTheme},{key:f,data:S.colorInfo.background},{key:d,data:S}]),typeof P=="number"&&this.h(P,S),this.f()}h(P,S){for(const t of n.BrowserWindow.getAllWindows())if(t.id===P){t.setBackgroundColor(S.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(d)}};e.$Xec=b,e.$Xec=b=Ee([se(0,p.$gR),se(1,T.$9i)],b)}),define(le[131],ue([0,1,4,2,3,7,17,6,5]),function(Y,e,n,r,E,D,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kw=e.$Jw=e.$Gw=e.$Ew=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Aw=e.$zw=void 0,e.$Bw=h,e.$Cw=w,e.$Dw=f,e.$Fw=d,e.$Hw=v,e.$Iw=b,e.$zw=(0,I.$Ci)("tunnelService"),e.$Aw=(0,I.$Ci)("sharedTunnelsService");var a;(function(S){S.Http="http",S.Https="https"})(a||(e.TunnelProtocol=a={}));var g;(function(S){S.ConstantPrivate="constantPrivate",S.Private="private",S.Public="public"})(g||(e.TunnelPrivacyId=g={}));function h(S){return!!S.forwardPort}var m;(function(S){S[S.Notify=1]="Notify",S[S.OpenBrowser=2]="OpenBrowser",S[S.OpenPreview=3]="OpenPreview",S[S.Silent=4]="Silent",S[S.Ignore=5]="Ignore",S[S.OpenBrowserOnce=6]="OpenBrowserOnce"})(m||(e.ProvidedOnAutoForward=m={}));function w(S){if(S.scheme!=="http"&&S.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(S.authority);if(t)return{address:t[1],port:+t[2]}}function f(S){if(S.scheme!=="http"&&S.scheme!=="https"||!S.query)return;const t=S.query.split("&");for(const u of t){const i=u.split("=")[1];if(/^https?:/.exec(i)){const o=w(D.URI.parse(i));if(o)return o}}}e.$Ew=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function d(S){return e.$Ew.indexOf(S)>=0}e.$Gw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(S){return e.$Gw.indexOf(S)>=0}function b(S,t,u,i){if(u===E.OperatingSystem.Windows)return!1;if(u===E.OperatingSystem.Macintosh&&v(t)){const o=/(\d+)\.(\d+)\.(\d+)/g.exec(i);if(o?.length===4&&parseInt(o[1])>=18)return!1}return S<1024}class ${constructor(t,u,i){this.remoteAddress=t,this.localAddress=u,this.b=i,this.a=new n.$je,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Jw=$;let P=class extends r.$Tc{constructor(t,u){super(),this.r=t,this.s=u,this.a=new n.$je,this.onTunnelOpened=this.a.event,this.b=new n.$je,this.onTunnelClosed=this.b.event,this.c=new n.$je,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],u=Array.from(this.f.values());for(const i of u){const o=Array.from(i.values());for(const s of o){const c=await s.value;c&&typeof c!="string"&&t.push(c)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:u}of t.values())await u.then(i=>typeof i!="string"?i?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,u,i,o,s){this.z(t,u,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:u,localAddress:i,privacy:o,protocol:s,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,u){(v(t)||d(t))&&(t=e.$Ew[0]);const i=this.D(t,u);if(i)return++i.refcount,i.value}openTunnel(t,u,i,o,s,c=!1,l,k){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${i} on local port ${s}.`);const y=this.g??t;if(!y)return;if(u||(u="localhost"),o||(o=this.t),this.g&&this.n.has(i)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const R=this.F(y,u,i,o,s,c,l,k);return R?R.then(L=>{if(L){if(typeof L=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(u,i),L}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(u,i);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const A=this.w(L);return(L.tunnelRemoteHost!==u||L.tunnelRemotePort!==i)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),l&&L.privacy!==l&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(A),A}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),R)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const u=this.f.get(t.tunnelRemoteHost);if(u){const i=u.get(t.tunnelRemotePort);i&&(i.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,i))}}}}async y(t,u,i){if(i.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${u}.`);const o=i.value.then(async s=>{s&&typeof s!="string"&&(await s.dispose(!0),this.b.fire({host:s.tunnelRemoteHost,port:s.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(u),o}}async closeTunnel(t,u){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${u} `);const i=this.f.get(t);if(i&&i.has(u)){const o=i.get(u);o.refcount=0,await this.y(t,u,o)}}z(t,u,i){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(u,{refcount:1,value:i})}async C(t,u){const i=this.f.get(t);if(i){const o=i.get(u),s=o?await o.value:void 0;(!s||typeof s=="string")&&i.delete(u),i.size===0&&this.f.delete(t)}}D(t,u){const i=[t];d(t)?(i.push(...e.$Ew),i.push(...e.$Gw)):v(t)&&i.push(...e.$Gw);const o=i.map(s=>this.f.get(s));for(const s of o){const c=s?.get(u);if(c)return c}}canTunnel(t){return!!w(t)}G(t,u,i,o,s,c,l){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${i} on local port ${o}.`);const k=i;this.n.add(k);const y=o===void 0?i:o,R={elevationRequired:s?this.isPortPrivileged(y):!1},L={remoteAddress:{host:u,port:i},localAddressPort:o,privacy:c,public:c?c!==g.Private:void 0,protocol:l},A=t.forwardPort(L,R);return A?(this.z(u,i,A),A.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(k)})):this.n.delete(k),A}};e.$Kw=P,e.$Kw=P=Ee([se(0,p.$9j),se(1,T.$9i)],P)}),define(le[49],ue([0,1,6]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wY=e.$vY=e.DisablementReason=e.UpdateType=e.StateType=void 0;var r;(function(T){T.Uninitialized="uninitialized",T.Idle="idle",T.Disabled="disabled",T.CheckingForUpdates="checking for updates",T.AvailableForDownload="available for download",T.Downloading="downloading",T.Downloaded="downloaded",T.Updating="updating",T.Ready="ready"})(r||(e.StateType=r={}));var E;(function(T){T[T.Setup=0]="Setup",T[T.Archive=1]="Archive",T[T.Snap=2]="Snap"})(E||(e.UpdateType=E={}));var D;(function(T){T[T.NotBuilt=0]="NotBuilt",T[T.DisabledByEnvironment=1]="DisabledByEnvironment",T[T.ManuallyDisabled=2]="ManuallyDisabled",T[T.MissingConfiguration=3]="MissingConfiguration",T[T.InvalidConfiguration=4]="InvalidConfiguration",T[T.RunningAsAdmin=5]="RunningAsAdmin"})(D||(e.DisablementReason=D={})),e.$vY={Uninitialized:{type:r.Uninitialized},Disabled:T=>({type:r.Disabled,reason:T}),Idle:(T,I)=>({type:r.Idle,updateType:T,error:I}),CheckingForUpdates:T=>({type:r.CheckingForUpdates,explicit:T}),AvailableForDownload:T=>({type:r.AvailableForDownload,update:T}),Downloading:{type:r.Downloading},Downloaded:T=>({type:r.Downloaded,update:T}),Updating:T=>({type:r.Updating,update:T}),Ready:T=>({type:r.Ready,update:T})},e.$wY=(0,n.$Ci)("updateService")}),define(le[230],ue([0,1,3,10,55,45]),function(Y,e,n,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),D.$no.as(E.$so.Configuration).registerConfiguration({id:"update",order:15,title:(0,r.localize)(10912,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:E.ConfigurationScope.APPLICATION,description:(0,r.localize)(10913,null),tags:["usesOnlineServices"],enumDescriptions:[(0,r.localize)(10914,null),(0,r.localize)(10915,null),(0,r.localize)(10916,null),(0,r.localize)(10917,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:E.ConfigurationScope.APPLICATION,description:(0,r.localize)(10918,null),deprecationMessage:(0,r.localize)(10919,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:E.ConfigurationScope.APPLICATION,title:(0,r.localize)(10920,null),description:(0,r.localize)(10921,null),included:n.$j&&!n.$p},"update.showReleaseNotes":{type:"boolean",default:!0,scope:E.ConfigurationScope.APPLICATION,description:(0,r.localize)(10922,null),tags:["usesOnlineServices"]}}})}),define(le[231],ue([0,1,4,49]),function(Y,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$fc=e.$0fc=void 0;class E{constructor(I){this.a=I}listen(I,p){switch(p){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${p}`)}call(I,p,a){switch(p){case"checkForUpdates":return this.a.checkForUpdates(a);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(a)}throw new Error(`Call not found: ${p}`)}}e.$0fc=E;class D{get state(){return this.b}set state(I){this.b=I,this.a.fire(I)}constructor(I){this.c=I,this.a=new n.$je,this.onStateChange=this.a.event,this.b=r.$vY.Uninitialized,this.c.listen("onStateChange")(p=>this.state=p),this.c.call("_getInitialState").then(p=>this.state=p)}checkForUpdates(I){return this.c.call("checkForUpdates",I)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(I){return this.c.call("_applySpecificUpdate",I)}}e.$$fc=D}),define(le[41],ue([0,1,6]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=void 0,e.$Gl=(0,n.$Ci)("IUriIdentityService")}),define(le[232],ue([0,1,41,171,14,18,143,4,2]),function(Y,e,n,r,E,D,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=void 0;class a{static{this._clock=0}constructor(m){this.uri=m,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let g=class{constructor(m){this.g=m,this.c=new p.$Sc,this.f=2**16;const w=new Map,f=d=>{let v=w.get(d.scheme);return v===void 0&&(v=m.hasProvider(d)&&!this.g.hasCapability(d,E.FileSystemProviderCapabilities.PathCaseSensitive),w.set(d.scheme,v)),v};this.c.add(I.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(d=>{w.delete(d.scheme)})),this.extUri=new D.$5g(f),this.d=new T.$Ps((d,v)=>this.extUri.compare(d,v,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,D.$eh)(m));const w=this.d.get(m);return w?w.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new a(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((f,d)=>f[1].time<d[1].time?1:f[1].time>d[1].time?-1:0);a._clock=0,this.d.clear();const w=this.f*.5;for(let f=0;f<w;f++)this.d.set(m[f][0],m[f][1].touch())}};e.$Qs=g,e.$Qs=g=Ee([se(0,E.$9k)],g),(0,r.$Ns)(n.$Gl,g,r.InstantiationType.Delayed)}),define(le[132],ue([0,1,6]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mY=void 0,e.$mY=(0,n.$Ci)("urlService")}),define(le[233],ue([0,1,7]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hgc=e.$ggc=e.$fgc=void 0;class r{constructor(I){this.a=I}listen(I,p){throw new Error(`Event not found: ${p}`)}call(I,p,a){switch(p){case"handleURL":return this.a.handleURL(n.URI.revive(a[0]),a[1])}throw new Error(`Call not found: ${p}`)}}e.$fgc=r;class E{constructor(I){this.a=I}handleURL(I,p){return this.a.call("handleURL",[I.toJSON(),p])}}e.$ggc=E;class D{constructor(I,p){this.a=I,this.b=p}async routeCall(I,p,a,g){if(p!=="handleURL")throw new Error(`Call not found: ${p}`);if(Array.isArray(a)&&a.length>0){const h=n.URI.revive(a[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",h.toString(!0)),h.query){const m=/\bwindowId=(\d+)/.exec(h.query);if(m){const w=m[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${w}"`,h.toString(!0));const f=new RegExp(`window:${w}`),d=I.connections.find(v=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",v.ctx),f.test(v.ctx)));if(d)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",h.toString(!0)),d;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",h.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",h.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(I,p,a,g)}routeEvent(I,p){throw new Error(`Event not found: ${p}`)}}e.$hgc=D}),define(le[234],ue([0,1,8,2,7,28]),function(Y,e,n,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oY=e.$nY=void 0;class T extends r.$Tc{constructor(){super(...arguments),this.a=new Set}open(a,g){const h=[...this.a.values()];return(0,n.$Gh)(h.map(m=>()=>m.handleURL(a,g)),void 0,!1).then(m=>m||!1)}registerHandler(a){return this.a.add(a),(0,r.$Rc)(()=>this.a.delete(a))}}e.$nY=T;let I=class extends T{constructor(a){super(),this.b=a}create(a){let{authority:g,path:h,query:m,fragment:w}=a||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return g&&h&&h.indexOf("/")!==0&&(h=`/${h}`),E.URI.from({scheme:this.b.urlProtocol,authority:g,path:h,query:m,fragment:w})}};e.$oY=I,e.$oY=I=Ee([se(0,D.$pk)],I)}),define(le[235],ue([0,1,13,8,4,2,3,7]),function(Y,e,n,r,E,D,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$igc=void 0;class p extends D.$Tc{constructor(g,h,m,w,f,d){if(super(),this.c=h,this.f=d,this.a=[],this.b=0,g&&(d.trace("ElectronURLListener initialUrisToHandle:",g.map($=>$.originalUrl)),this.a=g),T.$j){const $=w.isBuilt?[]:[`"${w.appRoot}"`];$.push("--open-url","--"),n.app.setAsDefaultProtocolClient(f.urlProtocol,process.execPath,$)}const v=E.Event.map(E.Event.fromNodeEventEmitter(n.app,"open-url",($,P)=>({event:$,url:P})),({event:$,url:P})=>($.preventDefault(),P));this.B(v($=>{const P=this.g($);P&&this.c.open(P,{originalUrl:$})})),m.getWindows().filter($=>$.isReady).length>0?(d.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(d.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(E.Event.once(m.onDidSignalReadyWindow)(()=>this.h())))}g(g){try{return I.URI.parse(g)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const g=[];for(const h of this.a)await this.c.open(h.uri,{originalUrl:h.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",h.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",h.originalUrl),g.push(h));g.length!==0&&(this.a=g,(0,r.$Eh)(()=>this.h(),500,this.q))}}e.$igc=p}),define(le[236],ue([0,1,4,2,14,60,31]),function(Y,e,n,r,E,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=void 0;class I extends r.$Tc{constructor(a,g,h,m,w,f){super(),this.f=a,this.g=g,this.h=h,this.j=m,this.m=w,this.n=f,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new n.$je),this.onDidChangeFile=this.a.event,this.b=D.$Ii.forUris(()=>!(this.capabilities&E.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new T.$Ac(d=>this.m.extUri.getComparisonKey(this.t(d))),this.r(),this.B(m.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(d=>this.s(d)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,g){return this.g.open(this.t(a),g)}close(a){return this.g.close(a)}read(a,g,h,m,w){return this.g.read(a,g,h,m,w)}write(a,g,h,m,w){return this.g.write(a,g,h,m,w)}watch(a,g){this.b.set(a,a);const h=this.g.watch(this.t(a),g);return(0,r.$Rc)(()=>{this.b.delete(a),h.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,g,h){return this.g.rename(this.t(a),this.t(g),h)}readFile(a,g){return this.g.readFile(this.t(a),g)}readFileStream(a,g,h){return this.g.readFileStream(this.t(a),g,h)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,g,h){return this.g.writeFile(this.t(a),g,h)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,g){return this.g.delete(this.t(a),g)}copy(a,g,h){if((0,E.$al)(this.g))return this.g.copy(this.t(a),this.t(g),h);throw new Error("copy not supported")}cloneFile(a,g){if((0,E.$bl)(this.g))return this.g.cloneFile(this.t(a),this.t(g));throw new Error("clone not supported")}s(a){const g=[];for(const h of a){if(h.resource.scheme!==this.f)continue;const m=this.u(h.resource);this.b.findSubstr(m)&&g.push({resource:m,type:h.type,cId:h.cId})}g.length&&(this.n.debug("User data changed"),this.a.fire(g))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$Xgc=I}),define(le[237],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=void 0,e.$Egc="utilityProcessWorker"}),define(le[238],ue([0,1,6]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jgc=void 0,e.$jgc=(0,n.$Ci)("webviewManagerService")}),define(le[239],ue([0,1,13,2,11,7]),function(Y,e,n,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=void 0;class T extends r.$Tc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const p=this.b.bind(this);n.protocol.registerFileProtocol(E.Schemas.vscodeWebview,p)}b(p,a){try{const g=D.URI.parse(p.url),h=T.a.get(g.path);if(typeof h=="string"){const m=`vs/workbench/contrib/webview/browser/pre/${h}`,w=E.$Wg.asFileUri(m);return a({path:w.fsPath,headers:{...E.COI.getHeadersFromQuery(p.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return a({error:-10})}catch{}return a({error:-2})}}e.$kgc=T}),define(le[50],ue([0,1,3]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5D=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$VD=void 0,e.$WD=r,e.$XD=E,e.$YD=D,e.$ZD=T,e.$1D=I,e.$2D=h,e.$3D=m,e.$4D=w,e.$6D=f,e.$7D=d,e.$8D=v,e.$VD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function r(b){return typeof b.parentId=="number"}function E(b){return!!b.workspaceUri}function D(b){return!!b.folderUri}function T(b){return!!b.fileUri}function I(b){const $=m(b),P=b.getValue("window.menuBarVisibility");return P==="default"||$&&P==="compact"||n.$k&&n.$n?"classic":P}var p;(function(b){b.TITLE_BAR_STYLE="window.titleBarStyle",b.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(p||(e.TitleBarSetting=p={}));var a;(function(b){b.NATIVE="native",b.CUSTOM="custom"})(a||(e.TitlebarStyle=a={}));var g;(function(b){b.AUTO="auto",b.WINDOWED="windowed",b.NEVER="never"})(g||(e.CustomTitleBarVisibility=g={}));function h(b,$){return!0}function m(b,$){return $||($=w(b)),$===a.NATIVE}function w(b){if(n.$p)return a.CUSTOM;const $=b.getValue("window");if($){if(n.$k&&$.nativeTabs===!0||n.$k&&$.nativeFullScreen===!1)return a.NATIVE;const t=$.titleBarStyle;if(t===a.NATIVE||t===a.CUSTOM)return t}return n.$l?a.NATIVE:a.CUSTOM}e.$5D=35;function f(b){return!(!n.$j||n.$p||m(b))}function d(b){const $=b.getValue("window");return!$||typeof $.nativeFullScreen!="boolean"||$.nativeTabs?!0:$.nativeFullScreen!==!1}function v(b=0){return Math.pow(1.2,b)}}),define(le[51],ue([0,1,13]),function(Y,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$Mec=e.$Lec=e.UnloadReason=e.LoadReason=void 0;var r;(function(a){a[a.INITIAL=1]="INITIAL",a[a.LOAD=2]="LOAD",a[a.RELOAD=3]="RELOAD"})(r||(e.LoadReason=r={}));var E;(function(a){a[a.CLOSE=1]="CLOSE",a[a.QUIT=2]="QUIT",a[a.RELOAD=3]="RELOAD",a[a.LOAD=4]="LOAD"})(E||(e.UnloadReason=E={}));const D=function(a=I.Normal){return{width:1024,height:768,mode:a}};e.$Lec=D;const T=function(){const h=n.screen.getPrimaryDisplay().workArea,m=Math.max(h.x+h.width/2-800/2,0),w=Math.max(h.y+h.height/2-600/2,0);return{x:m,y:w,width:800,height:600,mode:I.Normal}};e.$Mec=T;var I;(function(a){a[a.Maximized=0]="Maximized",a[a.Normal=1]="Normal",a[a.Minimized=2]="Minimized",a[a.Fullscreen=3]="Fullscreen"})(I||(e.WindowMode=I={}));var p;(function(a){a[a.UNRESPONSIVE=1]="UNRESPONSIVE",a[a.PROCESS_GONE=2]="PROCESS_GONE",a[a.LOAD=3]="LOAD"})(p||(e.WindowError=p={}))}),define(le[240],ue([0,1,8,4,2]),function(Y,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=void 0;class D extends E.$Tc{constructor({onDidOpenMainWindow:I,onDidFocusMainWindow:p,getActiveWindowId:a}){super(),this.a=this.B(new E.$Sc),r.Event.latch(r.Event.any(I,p))(this.f,this,this.a),this.b=(0,n.$ph)(()=>a()),(async()=>{try{const h=await this.b;this.c=typeof this.c=="number"?this.c:h}catch{}finally{this.b=void 0}})()}f(I){this.b&&(this.b.cancel(),this.b=void 0),this.c=I}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$qgc=D}),define(le[30],ue([0,1,10,9,60,18,7,6,11]),function(Y,e,n,r,E,D,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Wi=e.$Vi=e.WorkbenchState=e.$Pi=e.$Oi=e.$Li=void 0,e.$Mi=a,e.$Ni=g,e.$Qi=h,e.$Ri=m,e.$Si=w,e.$Ti=d,e.$Ui=v,e.$Xi=P,e.$3i=S,e.$4i=t,e.$6i=u,e.$7i=i,e.$8i=o,e.$Li=(0,I.$Ci)("contextService");function a(s){const c=s;return typeof c?.id=="string"&&T.URI.isUri(c.uri)}function g(s){return typeof s?.id=="string"&&!a(s)&&!m(s)}e.$Oi={id:"ext-dev"},e.$Pi={id:"empty-window"};function h(s,c){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,r.$mc)(s)}:c?e.$Oi:e.$Pi;const l=s;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}function m(s){const c=s;return typeof c?.id=="string"&&T.URI.isUri(c.configPath)}function w(s){const c=s;if(c?.uri)return{id:c.id,uri:T.URI.revive(c.uri)};const l=s;if(l?.configPath)return{id:l.id,configPath:T.URI.revive(l.configPath)};if(s?.id)return{id:s.id}}var f;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function d(s){const c=s;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}function v(s){const c=s;return!!(c&&typeof c=="object"&&T.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}class b{constructor(c,l,k,y,R){this.h=c,this.j=k,this.k=y,this.l=R,this.c=E.$Ii.forUris(this.l,()=>!0),this.folders=l}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=E.$Ii.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Vi=b;class ${constructor(c,l){this.raw=l,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,D.$dh)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Wi=$;function P(s){return new $({uri:s,index:0,name:(0,D.$_g)(s)},{uri:s.toString()})}e.$Yi="code-workspace",e.$Zi=`.${e.$Yi}`,e.$1i=[{name:(0,n.localize)(10864,null),extensions:[e.$Yi]}],e.$2i="workspace.json";function S(s,c){return D.$7g.isEqualOrParent(s,c.untitledWorkspacesHome)}function t(s){let c;return T.URI.isUri(s)?c=s:c=s.configuration,c?.scheme===p.Schemas.tmp}e.$5i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function u(s){return s.id===e.$5i}function i(s,c){return!S(s,c)&&!t(s)}function o(s){return(typeof s=="string"?(0,r.$nc)(s):(0,D.$bh)(s))===e.$Zi}}),define(le[52],ue([0,1,13,8,46,47,2,78,3,23,10,123,6,5,28,30]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uec=e.$Tec=void 0,e.$Tec=(0,m.$Ci)("dialogMainService");let v=class{constructor($,P){this.d=$,this.e=P,this.a=new Map,this.b=new Map,this.c=new r.$Jh}pickFileFolder($,P){return this.f({...$,pickFolders:!0,pickFiles:!0,title:(0,g.localize)(11404,null)},P)}pickFolder($,P){return this.f({...$,pickFolders:!0,title:(0,g.localize)(11405,null)},P)}pickFile($,P){return this.f({...$,pickFiles:!0,title:(0,g.localize)(11406,null)},P)}pickWorkspace($,P){const S=(0,g.localize)(11407,null),t=(0,D.$2w)((0,g.localize)(11408,null)),u=d.$1i;return this.f({...$,pickFiles:!0,title:S,filters:u,buttonLabel:t},P)}async f($,P){const S={title:$.title,buttonLabel:$.buttonLabel,filters:$.filters,defaultPath:$.defaultPath};(typeof $.pickFiles=="boolean"||typeof $.pickFolders=="boolean")&&(S.properties=void 0,$.pickFiles&&$.pickFolders&&(S.properties=["multiSelections","openDirectory","openFile","createDirectory"])),S.properties||(S.properties=["multiSelections",$.pickFolders?"openDirectory":"openFile","createDirectory"]),p.$k&&S.properties.push("treatPackageAsDirectory");const t=await this.showOpenDialog(S,(P||n.BrowserWindow.getFocusedWindow())??void 0);if(t&&t.filePaths&&t.filePaths.length>0)return t.filePaths}g($){if($){let P=this.b.get($.id);return P||(P=new r.$Jh,this.b.set($.id,P)),P}else return this.c}showMessageBox($,P){return this.g(P).queue(async()=>{const{options:S,buttonIndeces:t}=(0,h.$9w)($,this.e);let u;return P?u=await n.dialog.showMessageBox(P,S):u=await n.dialog.showMessageBox(S),{response:t[u.response],checkboxChecked:u.checkboxChecked}})}async showSaveDialog($,P){const S=this.j($,P);if(!S)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePath:""};try{return await this.g(P).queue(async()=>{let t;return P?t=await n.dialog.showSaveDialog(P,$):t=await n.dialog.showSaveDialog($),t.filePath=this.h(t.filePath),t})}finally{(0,T.$Oc)(S)}}h($){return $&&p.$k&&($=(0,I.$jm)($)),$}i($){return $.map(P=>this.h(P))}async showOpenDialog($,P){$.defaultPath&&(await a.Promises.exists($.defaultPath)||($.defaultPath=void 0));const S=this.j($,P);if(!S)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(P).queue(async()=>{let t;return P?t=await n.dialog.showOpenDialog(P,$):t=await n.dialog.showOpenDialog($),t.filePaths=this.i(t.filePaths),t})}finally{(0,T.$Oc)(S)}}j($,P){if(!P)return T.$Tc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",$);let S=this.a.get(P.id);S||(S=new Set,this.a.set(P.id,S));const t=(0,E.$qj)($);if(!S.has(t))return this.d.trace("[DialogMainService]: new file dialog lock created",$),S.add(t),(0,T.$Rc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",$),S?.delete(t),S?.size===0&&this.a.delete(P.id)})}};e.$Uec=v,e.$Uec=v=Ee([se(0,w.$9j),se(1,f.$pk)],v)}),define(le[241],ue([0,1,4,2,82,30]),function(Y,e,n,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7fc=void 0;class T extends r.$Tc{static{this.a=100}constructor(p,a){super(),this.f=p,this.g=a,this.b=this.B(new n.$je),this.c=new Map,this.h(a.applicationStorage,this.b)}h(p,a){this.B(n.Event.debounce(p.onDidChangeStorage,(g,h)=>(g?g.push(h):g=[h],g),T.a)(g=>{g.length&&a.fire(this.j(g,p))}))}j(p,a){const g=new Map,h=new Set;return p.forEach(m=>{const w=a.get(m.key);typeof w=="string"?g.set(m.key,w):h.add(m.key)}),{changed:Array.from(g.entries()),deleted:Array.from(h.values())}}listen(p,a,g){switch(a){case"onDidChangeStorage":{const h=g.profile?(0,E.$_h)(g.profile):void 0;if(!h)return this.b.event;let m=this.c.get(h.id);return m||(m=this.B(new n.$je),this.h(this.g.profileStorage(h),m),this.c.set(h.id,m)),m.event}}throw new Error(`Event not found: ${a}`)}async call(p,a,g){const h=g.profile?(0,E.$_h)(g.profile):void 0,m=(0,D.$Si)(g.workspace),w=await this.m(h,m);switch(a){case"getItems":return Array.from(w.items.entries());case"updateItems":{const f=g;if(f.insert)for(const[d,v]of f.insert)w.set(d,v);f.delete?.forEach(d=>w.delete(d));break}case"optimize":return w.optimize();case"isUsed":{const f=g.payload;if(typeof f=="string")return this.g.isUsed(f)}default:throw new Error(`Call not found: ${a}`)}}async m(p,a){let g;a?g=this.g.workspaceStorage(a):p?g=this.g.profileStorage(p):g=this.g.applicationStorage;try{await g.init()}catch(h){this.f.error(`StorageIPC#init: Unable to init ${a?"workspace":p?"profile":"application"} storage due to ${h}`)}return g}}e.$7fc=T}),define(le[42],ue([0,1,46,4,2,18,7,10,38,14,6,5,30,31,41,8,33,25,12]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w,f,d,v,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=e.$Il=e.ProfileResourceType=void 0,e.$Hl=S,e.$Jl=t,e.$Kl=u;var P;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(P||(e.ProfileResourceType=P={}));function S(s){const c=s;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&typeof c.isDefault=="boolean"&&typeof c.name=="string"&&T.URI.isUri(c.location)&&T.URI.isUri(c.globalStorageHome)&&T.URI.isUri(c.settingsResource)&&T.URI.isUri(c.keybindingsResource)&&T.URI.isUri(c.tasksResource)&&T.URI.isUri(c.snippetsHome)&&T.URI.isUri(c.extensionsResource))}e.$Il=(0,g.$Ci)("IUserDataProfilesService");function t(s,c){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:T.URI.revive(s.location).with({scheme:c}),globalStorageHome:T.URI.revive(s.globalStorageHome).with({scheme:c}),settingsResource:T.URI.revive(s.settingsResource).with({scheme:c}),keybindingsResource:T.URI.revive(s.keybindingsResource).with({scheme:c}),tasksResource:T.URI.revive(s.tasksResource).with({scheme:c}),snippetsHome:T.URI.revive(s.snippetsHome).with({scheme:c}),extensionsResource:T.URI.revive(s.extensionsResource).with({scheme:c}),cacheHome:T.URI.revive(s.cacheHome).with({scheme:c}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}function u(s,c,l,k,y,R){return{id:s,name:c,location:l,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:R&&y?.useDefaultFlags?.globalState?R.globalStorageHome:(0,D.$dh)(l,"globalStorage"),settingsResource:R&&y?.useDefaultFlags?.settings?R.settingsResource:(0,D.$dh)(l,"settings.json"),keybindingsResource:R&&y?.useDefaultFlags?.keybindings?R.keybindingsResource:(0,D.$dh)(l,"keybindings.json"),tasksResource:R&&y?.useDefaultFlags?.tasks?R.tasksResource:(0,D.$dh)(l,"tasks.json"),snippetsHome:R&&y?.useDefaultFlags?.snippets?R.snippetsHome:(0,D.$dh)(l,"snippets"),extensionsResource:R&&y?.useDefaultFlags?.extensions?R.extensionsResource:(0,D.$dh)(l,"extensions.json"),cacheHome:(0,D.$dh)(k,s),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let i=class extends E.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(c,l,k,y){super(),this.t=c,this.u=l,this.w=k,this.y=y,this.f=!0,this.h=this.B(new r.$je),this.onDidChangeProfiles=this.h.event,this.j=this.B(new r.$je),this.onWillCreateProfile=this.j.event,this.m=this.B(new r.$je),this.onWillRemoveProfile=this.m.event,this.n=this.B(new r.$je),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new w.$zc,workspaces:new w.$zc,emptyWindows:new Map},this.profilesHome=(0,D.$dh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,D.$dh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(c){this.f!==c&&(this.z=void 0,this.f=c)}isEnabled(){return this.f}get C(){if(!this.z){const c=this.D(),l=[c];if(this.f)try{for(const R of this.O()){if(!R.name||!(0,$.$cg)(R.name)||!R.location){this.y.warn("Skipping the invalid stored profile",R.location||R.name);continue}l.push(u((0,D.$ah)(R.location),R.name,R.location,this.g,{shortName:R.shortName,icon:R.icon,useDefaultFlags:R.useDefaultFlags},c))}}catch(R){this.y.error(R)}const k=new w.$zc,y=new Map;if(l.length)try{const R=this.Q();if(R.workspaces)for(const[L,A]of Object.entries(R.workspaces)){const O=T.URI.parse(L),W=l.find(x=>x.id===A);W&&k.set(O,W)}if(R.emptyWindows)for(const[L,A]of Object.entries(R.emptyWindows)){const O=l.find(W=>W.id===A);O&&y.set(L,O)}}catch(R){this.y.error(R)}this.z={profiles:l,workspaces:k,emptyWindows:y}}return this.z}D(){const c=u("__default__profile__",(0,I.localize)(10911,null),this.t.userRoamingDataHome,this.g);return{...c,extensionsResource:this.S()??c.extensionsResource,isDefault:!0}}async createTransientProfile(c){const l="Temp",k=new RegExp(`${(0,b.$ff)(l)}\\s(\\d+)`);let y=0;for(const L of this.profiles){const A=k.exec(L.name),O=A?parseInt(A[1]):0;y=O>y?O:y}const R=`${l} ${y+1}`;return this.createProfile((0,n.$qj)((0,v.$Yg)()).toString(16),R,{transient:!0},c)}async createNamedProfile(c,l,k){return this.createProfile((0,n.$qj)((0,v.$Yg)()).toString(16),c,l,k)}async createProfile(c,l,k,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const R=await this.F(c,l,k);return y&&await this.setProfileForWorkspace(y,R),R}async F(c,l,k){if(!(0,$.$cg)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(l);return y||(y=(async()=>{try{if(this.profiles.find(O=>O.name===l||O.id===c))throw new Error(`Profile with ${l} name already exists`);const L=u(c,l,(0,D.$dh)(this.profilesHome,c),this.g,k,this.defaultProfile);await this.u.createFolder(L.location);const A=[];return this.j.fire({profile:L,join(O){A.push(O)}}),await d.Promises.settled(A),this.I([L],[],[]),L}finally{this.r.delete(l)}})(),this.r.set(l,y)),y}async updateProfile(c,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let k=this.profiles.find(y=>y.id===c.id);if(!k)throw new Error(`Profile '${c.name}' does not exist`);return k=u(k.id,l.name??k.name,k.location,this.g,{shortName:l.shortName??k.shortName,icon:l.icon===null?void 0:l.icon??k.icon,transient:l.transient??k.isTransient,useDefaultFlags:l.useDefaultFlags??k.useDefaultFlags},this.defaultProfile),this.I([],[],[k]),k}async removeProfile(c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(c.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(y=>y.id===c.id);if(!l)throw new Error(`Profile '${c.name}' does not exist`);const k=[];this.m.fire({profile:l,join(y){k.push(y)}});try{await Promise.allSettled(k)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])l.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])l.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[l],[]);try{await this.u.del(l.cacheHome,{recursive:!0})}catch(y){(0,a.$nl)(y)!==a.FileOperationResult.FILE_NOT_FOUND&&this.y.error(y)}}async setProfileForWorkspace(c,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=this.profiles.find(y=>y.id===l.id);if(!k)throw new Error(`Profile '${l.name}' does not exist`);this.L(c,k)}unsetWorkspace(c,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(c,void 0,l)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const c=await this.u.resolve(this.profilesHome);await Promise.all((c.children||[]).filter(l=>l.isDirectory&&this.profiles.every(k=>!this.w.extUri.isEqual(k.location,l.resource))).map(l=>this.u.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const c=this.s.profiles.filter(l=>!this.H(l));await Promise.allSettled(c.map(l=>this.removeProfile(l)))}getProfileForWorkspace(c){const l=this.G(c),k=T.URI.isUri(l)?this.C.workspaces.get(l):this.C.emptyWindows.get(l);return k||((0,m.$Mi)(c)?this.s.folders.get(c.uri):(0,m.$Ri)(c)?this.s.workspaces.get(c.configPath):this.s.emptyWindows.get(c.id))}G(c){return(0,m.$Mi)(c)?c.uri:(0,m.$Ri)(c)?c.configPath:c.id}H(c){return!!([...this.C.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,c.location))||[...this.C.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,c.location))||[...this.s.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,c.location))||[...this.s.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,c.location))||[...this.s.folders.values()].some(l=>this.w.extUri.isEqual(l.location,c.location)))}I(c,l,k){const y=[...this.profiles,...c],R=[],L=this.s.profiles;this.s.profiles=[];for(let A of y){if(A.isDefault||l.some(W=>A.id===W.id))continue;A=k.find(W=>A.id===W.id)??A;const O=L.find(W=>A.id===W.id);if(A.isTransient)this.s.profiles.push(A);else{if(O){for(const[W,x]of this.s.emptyWindows.entries())if(A.id===x.id){this.L({id:W},A);break}for(const[W,x]of this.s.workspaces.entries())if(A.id===x.id){this.L({id:"",configPath:W},A);break}for(const[W,x]of this.s.folders.entries())if(A.id===x.id){this.L({id:"",uri:W},A);break}}R.push({location:A.location,name:A.name,shortName:A.shortName,icon:A.icon,useDefaultFlags:A.useDefaultFlags})}}this.P(R),this.z=void 0,this.J(c,l,k)}J(c,l,k){this.h.fire({added:c,removed:l,updated:k,all:this.profiles})}L(c,l,k){if(k=l?.isTransient?!0:k,k)(0,m.$Mi)(c)?(this.s.folders.delete(c.uri),l&&this.s.folders.set(c.uri,l)):(0,m.$Ri)(c)?(this.s.workspaces.delete(c.configPath),l&&this.s.workspaces.set(c.configPath,l)):(this.s.emptyWindows.delete(c.id),l&&this.s.emptyWindows.set(c.id,l));else{this.L(c,void 0,!0);const y=this.G(c);T.URI.isUri(y)?(this.C.workspaces.delete(y),l&&this.C.workspaces.set(y,l)):(this.C.emptyWindows.delete(y),l&&this.C.emptyWindows.set(y,l)),this.M()}}M(){const c={};for(const[k,y]of this.C.workspaces.entries())c[k.toString()]=y.id;const l={};for(const[k,y]of this.C.emptyWindows.entries())l[k.toString()]=y.id;this.R({workspaces:c,emptyWindows:l}),this.z=void 0}N(c){const l={},k=this.D();if(c.workspaces)for(const[R,L]of Object.entries(c.workspaces)){const A=T.URI.parse(L);l[R]=this.w.extUri.isEqual(A,k.location)?k.id:this.w.extUri.basename(A)}const y={};if(c.emptyWindows)for(const[R,L]of Object.entries(c.emptyWindows)){const A=T.URI.parse(L);y[R]=this.w.extUri.isEqual(A,k.location)?k.id:this.w.extUri.basename(A)}return{workspaces:l,emptyWindows:y}}O(){return[]}P(c){throw new Error("not implemented")}Q(){return{}}R(c){throw new Error("not implemented")}S(){}};e.$Ll=i,e.$Ll=i=Ee([se(0,p.$Ji),se(1,a.$9k),se(2,f.$Gl),se(3,h.$9j)],i);class o extends i{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(c){this.a=c}Q(){return this.X}R(c){this.X=c}}e.$Ml=o}),define(le[86],ue([0,1,8,16,2,4,31,7,126,129,14,6,5,42,41,12,15,24]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w,f,d,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=e.$Fq=e.$Eq=e.ExtensionsProfileScanningErrorCode=void 0;var $;(function(i){i.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",i.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})($||(e.ExtensionsProfileScanningErrorCode=$={}));class P extends Error{constructor(o,s){super(o),this.code=s}}e.$Eq=P,e.$Fq=(0,h.$Ci)("IExtensionsProfileScannerService");let S=class extends E.$Tc{constructor(o,s,c,l,k,y){super(),this.j=o,this.m=s,this.n=c,this.r=l,this.s=k,this.t=y,this.b=this.B(new D.$je),this.onAddExtensions=this.b.event,this.c=this.B(new D.$je),this.onDidAddExtensions=this.c.event,this.f=this.B(new D.$je),this.onRemoveExtensions=this.f.event,this.g=this.B(new D.$je),this.onDidRemoveExtensions=this.g.event,this.h=new T.$zc}scanProfileExtensions(o,s){return this.u(o,void 0,s)}async addExtensionsToProfile(o,s,c){const l=[],k=[];try{return await this.u(s,y=>{const R=[];if(c)R.push(...y);else for(const L of y)o.some(([A])=>(0,a.$Ip)(A.identifier,L.identifier)&&A.manifest.version!==L.version)?l.push(L):R.push(L);for(const[L,A]of o){const O=R.findIndex(x=>(0,a.$Ip)(x.identifier,L.identifier)&&x.version===L.manifest.version),W={identifier:L.identifier,version:L.manifest.version,location:L.location,metadata:A};O===-1?(k.push(W),R.push(W)):R.splice(O,1,W)}return k.length&&this.b.fire({extensions:k,profileLocation:s}),l.length&&this.f.fire({extensions:l,profileLocation:s}),R}),k.length&&this.c.fire({extensions:k,profileLocation:s}),l.length&&this.g.fire({extensions:l,profileLocation:s}),k}catch(y){throw k.length&&this.c.fire({extensions:k,error:y,profileLocation:s}),l.length&&this.g.fire({extensions:l,error:y,profileLocation:s}),y}}async updateMetadata(o,s){const c=[];return await this.u(s,l=>{const k=[];for(const y of l){const R=o.find(([L])=>(0,a.$Ip)(L.identifier,y.identifier)&&L.manifest.version===y.version);R&&(y.metadata={...y.metadata,...R[1]},c.push(y)),k.push(y)}return k}),c}async removeExtensionFromProfile(o,s){const c=[];try{await this.u(s,l=>{const k=[];for(const y of l)(0,a.$Ip)(y.identifier,o.identifier)?c.push(y):k.push(y);return c.length&&this.f.fire({extensions:c,profileLocation:s}),k}),c.length&&this.g.fire({extensions:c,profileLocation:s})}catch(l){throw c.length&&this.g.fire({extensions:c,error:l,profileLocation:s}),l}}async u(o,s,c){return this.F(o).queue(async()=>{let l=[],k;try{const y=await this.m.readFile(o);k=JSON.parse(y.value.toString().trim()||"[]")}catch(y){if((0,g.$nl)(y)!==g.FileOperationResult.FILE_NOT_FOUND)throw y;if(this.r.extUri.isEqual(o,this.n.defaultProfile.extensionsResource)&&(k=await this.D()),!k&&c?.bailOutWhenFileNotFound)throw new P((0,v.$9)(y),$.ERROR_PROFILE_NOT_FOUND)}if(k){Array.isArray(k)||this.w(o);let y=!1;for(const R of k){t(R)||this.w(o);let L;if((0,d.$cg)(R.relativeLocation)&&R.relativeLocation)L=this.z(R.relativeLocation);else if((0,d.$cg)(R.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${R.location}`);continue}else{L=I.URI.revive(R.location);const A=this.y(L);A&&(y=!0,R.relativeLocation=A)}(0,d.$jg)(R.metadata?.hasPreReleaseVersion)&&R.metadata?.preRelease&&(y=!0,R.metadata.hasPreReleaseVersion=!0),l.push({identifier:R.identifier,location:L,version:R.version,metadata:R.metadata})}y&&await this.m.writeFile(o,r.$Le.fromString(JSON.stringify(k)))}if(s){l=s(l);const y=l.map(R=>({identifier:R.identifier,version:R.version,location:R.location.toJSON(),relativeLocation:this.y(R.location),metadata:R.metadata}));await this.m.writeFile(o,r.$Le.fromString(JSON.stringify(y)))}return l})}w(o){const s=new P(`Invalid extensions content in ${o.toString()}`,$.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(o){return this.r.extUri.isEqual(this.r.extUri.dirname(o),this.j)?this.r.extUri.basename(o):void 0}z(o){return this.r.extUri.joinPath(this.j,o)}async D(){return this.C||(this.C=(async()=>{const o=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let c;try{c=(await this.m.readFile(o)).value.toString()}catch(k){if((0,g.$nl)(k)===g.FileOperationResult.FILE_NOT_FOUND)return;throw k}this.t.info("Migrating extensions from old default profile location",o.toString());let l;try{const k=JSON.parse(c);Array.isArray(k)&&k.every(y=>t(y))?l=k:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",k)}catch(k){this.t.error(k)}if(l)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,r.$Le.fromString(JSON.stringify(l)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",o.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(k){if((0,g.$nl)(k)===g.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",o.toString(),this.n.defaultProfile.extensionsResource.toString());else throw k}try{await this.m.del(o)}catch(k){(0,g.$nl)(k)!==g.FileOperationResult.FILE_NOT_FOUND&&this.t.error(k)}try{await this.m.del(s)}catch(k){(0,g.$nl)(k)!==g.FileOperationResult.FILE_NOT_FOUND&&this.t.error(k)}return l})()),this.C}F(o){let s=this.h.get(o);return s||(s=new n.$Jh,this.h.set(o,s)),s}};e.$Gq=S,e.$Gq=S=Ee([se(1,g.$9k),se(2,w.$Il),se(3,f.$Gl),se(4,b.$8l),se(5,m.$9j)],S);function t(i){return(0,d.$eg)(i)&&(0,p.$gp)(i.identifier)&&(u(i.location)||(0,d.$cg)(i.location)&&i.location)&&((0,d.$jg)(i.relativeLocation)||(0,d.$cg)(i.relativeLocation))&&i.version&&(0,d.$cg)(i.version)}function u(i){return i?(0,d.$cg)(i.path)&&(0,d.$cg)(i.scheme):!1}});var et=this&&this.__importDefault||function(Y){return Y&&Y.__esModule?Y:{default:Y}};define(le[133],ue([0,1,20,8,37,16,15,43,161,2,11,9,3,18,208,81,12,7,10,38,129,85,207,14,6,5,28,4,82,86,42,41,169]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w,f,d,v,b,$,P,S,t,u,i,o,s,c,l,k,y,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=e.$Lq=e.$Kq=e.$Jq=e.Translations=void 0,e.$Mq=ee,E=Ie(E),h=Ie(h),m=Ie(m),f=Ie(f),d=et(d);var O;(function(ae){function K(te,z){if(te===z)return!0;const j=Object.keys(te),N=new Set;for(const V of Object.keys(z))N.add(V);if(j.length!==N.size)return!1;for(const V of j){if(te[V]!==z[V])return!1;N.delete(V)}return N.size===0}ae.equals=K})(O||(e.Translations=O={})),e.$Jq=(0,o.$Ci)("IExtensionsScannerService");let W=class extends a.$Tc{constructor(K,te,z,j,N,V,oe,G,he,re,_,M){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=te,this.r=z,this.s=j,this.t=N,this.u=V,this.w=oe,this.y=G,this.z=he,this.C=re,this.D=_,this.F=M,this.g=this.B(new l.$je),this.onDidChangeCache=this.g.event,this.h=(0,w.$dh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(B,this.s,this.h)),this.m=this.B(this.F.createInstance(B,this.s,this.h)),this.n=this.B(this.F.createInstance(C,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(t.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(t.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,S.$Tp)(this.w,this.y)),this.G}async scanAllExtensions(K,te,z){const[j,N]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(te)]),V=z?await this.scanExtensionsUnderDevelopment(K,[...j,...N]):[];return this.L(j,N,V,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const te=[];te.push(this.M(!!K.useCache,K.language)),te.push(this.N(K.language,!!K.checkControlFile));const[z,j]=await Promise.all(te);return this.J([...z,...j],t.ExtensionType.System,K,!1)}async scanUserExtensions(K){const te=K.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",te);const z=this.D.extUri.isEqual(K.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,j=await this.P(te,!!K.profileLocation,t.ExtensionType.User,!K.includeUninstalled,K.language,!0,z,K.productVersion??this.R()),N=K.useCache&&!j.devMode&&j.excludeObsolete?this.m:this.n;let V;try{V=await N.scanExtensions(j)}catch(oe){if(oe instanceof y.$Eq&&oe.code===y.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),V=await N.scanExtensions(j);else throw oe}return V=await this.J(V,t.ExtensionType.User,K,!0),this.y.trace("Scanned user extensions:",V.length),V}async scanExtensionsUnderDevelopment(K,te){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const z=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(j=>j.scheme===g.Schemas.file).map(async j=>{const N=await this.P(j,!1,t.ExtensionType.User,!0,K.language,!1,void 0,K.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(N)).map(oe=>(oe.type=te.find(G=>(0,S.$Ip)(G.identifier,oe.identifier))?.type??oe.type,this.n.validate(oe,N)))}))).flat();return this.J(z,"development",K,!0)}return[]}async scanExistingExtension(K,te,z){const j=await this.P(K,!1,te,!0,z.language,!0,void 0,z.productVersion??this.R()),N=await this.n.scanExtension(j);return!N||!z.includeInvalid&&!N.isValid?null:N}async scanOneOrMultipleExtensions(K,te,z){const j=await this.P(K,!1,te,!0,z.language,!0,void 0,z.productVersion??this.R()),N=await this.n.scanOneOrMultipleExtensions(j);return this.J(N,te,z,!0)}async scanMultipleExtensions(K,te,z){const j=[];return await Promise.all(K.map(async N=>{const V=await this.scanOneOrMultipleExtensions(N,te,z);j.push(...V)})),this.J(j,te,z,!0)}async scanMetadata(K){const te=(0,w.$dh)(K,"package.json"),z=(await this.w.readFile(te)).value.toString();return JSON.parse(z).__metadata}async updateMetadata(K,te){const z=(0,w.$dh)(K,"package.json"),j=(await this.w.readFile(z)).value.toString(),N=JSON.parse(j);te.isMachineScoped===!1&&delete te.isMachineScoped,te.isBuiltin===!1&&delete te.isBuiltin,N.__metadata={...N.__metadata,...te},await this.w.writeFile((0,w.$dh)(K,"package.json"),D.$Le.fromString(JSON.stringify(N,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(K){if(K instanceof y.$Eq&&K.code===y.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw K}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const K=await this.scanUserExtensions({includeInvalid:!0});if(K.length)await this.u.addExtensionsToProfile(K.map(te=>[te,te.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,D.$Le.fromString(JSON.stringify([])))}catch(te){(0,i.$nl)(te)!==i.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,T.$9)(te))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(K){this.y.error(K)}finally{this.H=void 0}})()),this.H}async J(K,te,z,j){return z.includeAllVersions||(K=this.L(te===t.ExtensionType.System?K:void 0,te===t.ExtensionType.User?K:void 0,te==="development"?K:void 0,await this.getTargetPlatform(),j)),z.includeInvalid||(K=K.filter(N=>N.isValid)),K.sort((N,V)=>{const oe=h.$mc(N.location.fsPath),G=h.$mc(V.location.fsPath);return oe<G?-1:oe>G?1:0})}L(K,te,z,j,N){const V=(G,he,re)=>{if(G.isValid&&!he.isValid)return!1;if(G.isValid===he.isValid){if(N&&f.gt(G.manifest.version,he.manifest.version))return this.y.debug(`Skipping extension ${he.location.path} with lower version ${he.manifest.version} in favour of ${G.location.path} with version ${G.manifest.version}`),!1;if(f.eq(G.manifest.version,he.manifest.version)){if(G.type===t.ExtensionType.System)return this.y.debug(`Skipping extension ${he.location.path} in favour of system extension ${G.location.path} with same version`),!1;if(G.targetPlatform===j)return this.y.debug(`Skipping extension ${he.location.path} from different target platform ${he.targetPlatform}`),!1}}return re?this.y.warn(`Overwriting user extension ${G.location.path} with ${he.location.path}.`):this.y.debug(`Overwriting user extension ${G.location.path} with ${he.location.path}.`),!0},oe=new t.$pn;return K?.forEach(G=>{const he=oe.get(G.identifier.id);(!he||V(he,G,!1))&&oe.set(G.identifier.id,G)}),te?.forEach(G=>{const he=oe.get(G.identifier.id);if(!he&&K&&G.type===t.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${G.location.path}.`);return}(!he||V(he,G,!1))&&oe.set(G.identifier.id,G)}),z?.forEach(G=>{const he=oe.get(G.identifier.id);(!he||V(he,G,!0))&&oe.set(G.identifier.id,G),oe.set(G.identifier.id,G)}),[...oe.values()]}async M(K,te){this.y.trace("Started scanning system extensions");const z=await this.P(this.systemExtensionsLocation,!1,t.ExtensionType.System,!0,te,!0,void 0,this.R()),N=await(K&&!z.devMode?this.j:this.n).scanExtensions(z);return this.y.trace("Scanned system extensions:",N.length),N}async N(K,te){const z=this.z.isBuilt?[]:this.C.builtInExtensions;if(!z?.length)return[];this.y.trace("Started scanning dev system extensions");const j=te?await this.O():{},N=[],V=b.URI.file(h.$gc(h.$ic(g.$Wg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const G of z){const he=j[G.name]||"marketplace";switch(he){case"disabled":break;case"marketplace":N.push((0,w.$dh)(V,G.name));break;default:N.push(b.URI.file(he));break}}const oe=await Promise.all(N.map(async G=>this.n.scanExtension(await this.P(G,!1,t.ExtensionType.System,!0,K,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",oe.length),(0,n.$Gb)(oe)}async O(){try{const K=await this.w.readFile(this.r);return JSON.parse(K.value.toString())}catch{return{}}}async P(K,te,z,j,N,V,oe,G){const he=await this.f(N??m.$x),re=await this.Q(K),_=te&&!this.D.extUri.isEqual(K,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,M=_?await this.Q(_):void 0;return new x(K,re,_,M,te,oe,z,j,V,G.version,G.date,this.C.commit,!this.z.isBuilt,N,he)}async Q(K){try{const te=await this.w.stat(K);if(typeof te.mtime=="number")return te.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Kq=W,e.$Kq=W=Ee([se(4,R.$Il),se(5,y.$Fq),se(6,i.$9k),se(7,s.$9j),se(8,P.$Ji),se(9,c.$pk),se(10,L.$Gl),se(11,o.$Bi)],W);class x{constructor(K,te,z,j,N,V,oe,G,he,re,_,M,F,U,q){this.location=K,this.mtime=te,this.applicationExtensionslocation=z,this.applicationExtensionslocationMtime=j,this.profile=N,this.profileScanOptions=V,this.type=oe,this.excludeObsolete=G,this.validate=he,this.productVersion=re,this.productDate=_,this.productCommit=M,this.devMode=F,this.language=U,this.translations=q}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,te){return(0,w.$9g)(K.location,te.location)&&K.mtime===te.mtime&&(0,w.$9g)(K.applicationExtensionslocation,te.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===te.applicationExtensionslocationMtime&&K.profile===te.profile&&E.$eo(K.profileScanOptions,te.profileScanOptions)&&K.type===te.type&&K.excludeObsolete===te.excludeObsolete&&K.validate===te.validate&&K.productVersion===te.productVersion&&K.productDate===te.productDate&&K.productCommit===te.productCommit&&K.devMode===te.devMode&&K.language===te.language&&O.equals(K.translations,te.translations)}}e.$Lq=x;let C=class extends a.$Tc{constructor(K,te,z,j,N,V,oe){super(),this.g=K,this.h=te,this.j=z,this.m=j,this.n=V,this.r=oe,this.f=N.extensionsEnabledWithApiProposalVersion?.map(G=>G.toLowerCase())??[]}async scanExtensions(K){const te=K.profile?await this.t(K):await this.s(K);let z={};if(K.excludeObsolete&&K.type===t.ExtensionType.User)try{const j=(await this.m.readFile(this.g)).value.toString();z=JSON.parse(j)}catch{}return(0,v.$pg)(z)?te:te.filter(j=>!z[S.$Jp.create(j).toString()])}async s(K){const te=await this.m.resolve(K.location);if(!te.children?.length)return[];const z=await Promise.all(te.children.map(async j=>{if(!j.isDirectory||K.type===t.ExtensionType.User&&(0,w.$ah)(j.resource).indexOf(".")===0)return null;const N=new x(j.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.profileScanOptions,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(N)}));return(0,n.$Gb)(z).sort((j,N)=>j.location.path<N.location.path?-1:1)}async t(K){let te=await this.u(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.j.extUri.isEqual(K.location,K.applicationExtensionslocation)){te=te.filter(j=>!j.metadata?.isApplicationScoped);const z=await this.u(K.applicationExtensionslocation,j=>!!j.metadata?.isBuiltin||!!j.metadata?.isApplicationScoped,K);te.push(...z)}return te}async u(K,te,z){const j=await this.h.scanProfileExtensions(K,z.profileScanOptions);if(!j.length)return[];const N=await Promise.all(j.map(async V=>{if(te(V)){const oe=new x(V.location,z.mtime,z.applicationExtensionslocation,z.applicationExtensionslocationMtime,z.profile,z.profileScanOptions,z.type,z.excludeObsolete,z.validate,z.productVersion,z.productDate,z.productCommit,z.devMode,z.language,z.translations);return this.scanExtension(oe,V.metadata)}return null}));return(0,n.$Gb)(N)}async scanOneOrMultipleExtensions(K){try{if(await this.m.exists((0,w.$dh)(K.location,"package.json"))){const te=await this.scanExtension(K);return te?[te]:[]}else return await this.scanExtensions(K)}catch(te){return this.r.error(`Error scanning extensions at ${K.location.path}:`,(0,T.$9)(te)),[]}}async scanExtension(K,te){try{let z=await this.w(K.location);if(z){z.publisher||(z.publisher=t.$jn),te=te??z.__metadata,delete z.__metadata;const j=(0,S.$Np)(z.publisher,z.name),N=te?.id?{id:j,uuid:te.id}:{id:j},V=te?.isSystem?t.ExtensionType.System:K.type,oe=V===t.ExtensionType.System||!!te?.isBuiltin;z=await this.y(K.location,z,x.createNlsConfiguration(K));let G={type:V,identifier:N,manifest:z,location:K.location,isBuiltin:oe,targetPlatform:te?.targetPlatform??t.TargetPlatform.UNDEFINED,publisherDisplayName:te?.publisherDisplayName,metadata:te,isValid:!0,validations:[]};return K.validate&&(G=this.validate(G,K)),z.enabledApiProposals&&(!this.n.isBuilt||this.f.includes(j.toLowerCase()))&&(z.enabledApiProposals=(0,t.$vn)([...z.enabledApiProposals])),G}}catch(z){K.type!==t.ExtensionType.System&&this.r.error(z)}return null}validate(K,te){let z=!0;const j=this.n.isBuilt&&this.f.includes(K.identifier.id.toLowerCase()),N=(0,u.$Zp)(te.productVersion,te.productDate,te.location,K.manifest,K.isBuiltin,j);for(const[V,oe]of N)V===d.default.Error&&(z=!1,this.r.error(this.F(te.location,oe)));return K.isValid=z,K.validations=N,K}async w(K){const te=(0,w.$dh)(K,"package.json");let z;try{z=(await this.m.readFile(te)).value.toString()}catch(N){return(0,i.$nl)(N)!==i.FileOperationResult.FILE_NOT_FOUND&&this.r.error(this.F(K,(0,$.localize)(11294,null,te.path,N.message))),null}let j;try{j=JSON.parse(z)}catch{const V=[];(0,I.$Un)(z,V);for(const oe of V)this.r.error(this.F(K,(0,$.localize)(11295,null,te.path,oe.offset,oe.length,(0,p.$Hq)(oe.error))));return null}return(0,I.$3n)(j)!=="object"?(this.r.error(this.F(K,(0,$.localize)(11296,null,te.path))),null):j}async y(K,te,z){const j=await this.z(K,te,z);if(j)try{const N=[],V=await this.C(j.default,N);if(N.length>0)return N.forEach(G=>{this.r.error(this.F(K,(0,$.localize)(11297,null,j.default?.path,(0,p.$Hq)(G.error))))}),te;if((0,I.$3n)(j)!=="object")return this.r.error(this.F(K,(0,$.localize)(11298,null,j.default?.path))),te;const oe=j.values||Object.create(null);return(0,A.$Iq)(this.r,te,oe,V)}catch{}return te}async z(K,te,z){const j=(0,w.$dh)(K,"package.nls.json"),N=(he,re)=>{re.forEach(_=>{this.r.error(this.F(K,(0,$.localize)(11299,null,he?.path,(0,p.$Hq)(_.error))))})},V=he=>{this.r.error(this.F(K,(0,$.localize)(11300,null,he?.path)))},oe=`${te.publisher}.${te.name}`,G=z.translations[oe];if(G)try{const he=b.URI.file(G),re=(await this.m.readFile(he)).value.toString(),_=[],M=(0,I.$Un)(re,_);return _.length>0?(N(he,_),{values:void 0,default:j}):(0,I.$3n)(M)!=="object"?(V(he),{values:void 0,default:j}):{values:M.contents?M.contents.package:void 0,default:j}}catch{return{values:void 0,default:j}}else{if(!await this.m.exists(j))return;let re;try{re=await this.D(K,z)}catch{return}if(!re.localized)return{values:void 0,default:re.original};try{const _=(await this.m.readFile(re.localized)).value.toString(),M=[],F=(0,I.$Un)(_,M);return M.length>0?(N(re.localized,M),{values:void 0,default:re.original}):(0,I.$3n)(F)!=="object"?(V(re.localized),{values:void 0,default:re.original}):{values:F,default:re.original}}catch{return{values:void 0,default:re.original}}}}async C(K,te){if(K)try{const z=(await this.m.readFile(K)).value.toString();return(0,I.$Un)(z,te)}catch{}}D(K,te){return new Promise((z,j)=>{const N=V=>{const oe=(0,w.$dh)(K,`package.nls.${V}.json`);this.m.exists(oe).then(G=>{G&&z({localized:oe,original:(0,w.$dh)(K,"package.nls.json")});const he=V.lastIndexOf("-");he===-1?z({localized:(0,w.$dh)(K,"package.nls.json"),original:null}):(V=V.substring(0,he),N(V))})};if(te.devMode||te.pseudo||!te.language)return z({localized:(0,w.$dh)(K,"package.nls.json"),original:null});N(te.language)})}F(K,te){return`[${K.path}]: ${te}`}};C=Ee([se(1,y.$Fq),se(2,L.$Gl),se(3,i.$9k),se(4,c.$pk),se(5,P.$Ji),se(6,s.$9j)],C);let B=class extends C{constructor(K,te,z,j,N,V,oe,G,he){super(te,j,N,V,oe,G,he),this.J=K,this.L=z,this.H=this.B(new r.$Ah(3e3)),this.I=this.B(new l.$je),this.onDidChangeCache=this.I.event}async scanExtensions(K){const te=this.P(K),z=await this.M(te);if(this.G=K,z&&z.input&&x.equals(z.input,this.G))return this.r.debug("Using cached extensions scan result",K.type===t.ExtensionType.System?"system":"user",K.location.toString()),this.H.trigger(()=>this.O()),z.result.map(N=>(N.location=b.URI.revive(N.location),N));const j=await super.scanExtensions(K);return await this.N(te,{input:K,result:j}),j}async M(K){try{const te=await this.m.readFile(K),z=JSON.parse(te.value.toString());return{result:z.result,input:(0,k.$_h)(z.input)}}catch(te){this.r.debug("Error while reading the extension cache file:",K.path,(0,T.$9)(te))}return null}async N(K,te){try{await this.m.writeFile(K,D.$Le.fromString(JSON.stringify(te)))}catch(z){this.r.debug("Error while writing the extension cache file:",K.path,(0,T.$9)(z))}}async O(){if(!this.G)return;const K=this.P(this.G),te=await this.M(K);if(!te)return;const z=te.result,j=JSON.parse(JSON.stringify(await super.scanExtensions(this.G)));if(!E.$eo(j,z))try{this.r.info("Invalidating Cache",z,j),await this.m.del(K),this.I.fire()}catch(N){this.r.error(N)}}P(K){const te=this.Q(K);return this.j.extUri.joinPath(te.cacheHome,K.type===t.ExtensionType.System?t.$in:t.$hn)}Q(K){return K.type===t.ExtensionType.System?this.L.defaultProfile:K.profile?this.j.extUri.isEqual(K.location,this.J.extensionsResource)?this.J:this.L.profiles.find(te=>this.j.extUri.isEqual(K.location,te.extensionsResource))??this.J:this.L.defaultProfile}};B=Ee([se(2,R.$Il),se(3,y.$Fq),se(4,L.$Gl),se(5,i.$9k),se(6,c.$pk),se(7,P.$Ji),se(8,s.$9j)],B);function ee(ae,K){const te=(0,S.$Lp)(ae.manifest.publisher,ae.manifest.name);return{id:te,identifier:new t.$nn(te),isBuiltin:ae.type===t.ExtensionType.System,isUserBuiltin:ae.type===t.ExtensionType.User&&ae.isBuiltin,isUnderDevelopment:K,extensionLocation:ae.location,uuid:ae.identifier.uuid,targetPlatform:ae.targetPlatform,publisherDisplayName:ae.publisherDisplayName,...ae.manifest}}class X extends W{constructor(K,te,z,j,N,V,oe,G,he,re,_,M){super(K,te,(0,w.$dh)(z,".vscode-oss-dev","extensions","control.json"),j,N,V,oe,G,he,re,_,M),this.S=(async()=>{if(m.$A)try{const F=await this.w.readFile(b.URI.file(m.$A));return JSON.parse(F.value.toString())}catch{}return Object.create(null)})()}f(K){return this.S}}e.$Nq=X}),define(le[242],ue([0,1,5,42,41,24,86,14,38,7]),function(Y,e,n,r,E,D,T,I,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nR=void 0;let g=class extends T.$Gq{constructor(m,w,f,d,v,b){super(a.URI.file(m.extensionsPath),w,f,d,v,b)}};e.$nR=g,e.$nR=g=Ee([se(0,p.$Ki),se(1,I.$9k),se(2,r.$Il),se(3,E.$Gl),se(4,D.$8l),se(5,n.$9j)],g)}),define(le[243],ue([0,1,7,38,86,133,14,6,5,28,41,42]),function(Y,e,n,r,E,D,T,I,p,a,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ugc=void 0;let m=class extends D.$Nq{constructor(f,d,v,b,$,P,S,t){super(n.URI.file($.builtinExtensionsPath),n.URI.file($.extensionsPath),$.userHome,f.defaultProfile,f,d,v,b,$,P,S,t)}};e.$ugc=m,e.$ugc=m=Ee([se(0,h.$Il),se(1,E.$Fq),se(2,T.$9k),se(3,p.$9j),se(4,r.$Ki),se(5,a.$pk),se(6,g.$Gl),se(7,I.$Bi)],m)}),define(le[244],ue([0,1,13,2,11,9,3,60,7,33,35,38,5,42]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=void 0;let f=class extends r.$Tc{constructor(v,b,$){super(),this.c=v,this.f=$,this.a=I.$Ii.forPaths(!T.$l),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp",".mp4"]),this.addValidFileRoot(v.appRoot),this.addValidFileRoot(v.extensionsPath),this.addValidFileRoot(b.defaultProfile.globalStorageHome.with({scheme:E.Schemas.file}).fsPath),this.addValidFileRoot(v.workspaceStorageHome.with({scheme:E.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:v}=n.session;v.protocol.registerFileProtocol(E.Schemas.vscodeFileResource,(b,$)=>this.j(b,$)),v.protocol.interceptFileProtocol(E.Schemas.file,(b,$)=>this.h(b,$)),this.B((0,r.$Rc)(()=>{v.protocol.unregisterProtocol(E.Schemas.vscodeFileResource),v.protocol.uninterceptProtocol(E.Schemas.file)}))}addValidFileRoot(v){const b=(0,D.$gc)(v);return this.a.get(b)?r.$Tc.None:(this.a.set(b,!0),(0,r.$Rc)(()=>this.a.delete(b)))}h(v,b){const $=p.URI.parse(v.url);return this.f.error(`Refused to load resource ${$.fsPath} from ${E.Schemas.file}: protocol (original URL: ${v.url})`),b({error:-3})}j(v,b){const $=this.m(v);let P;return this.c.crossOriginIsolated&&((0,D.$mc)($)==="workbench.html"||(0,D.$mc)($)==="workbench-dev.html"?P=E.COI.CoopAndCoep:P=E.COI.getHeadersFromQuery(v.url)),this.a.findSubstr($)?b({path:$,headers:P}):this.b.has((0,D.$nc)($).toLowerCase())?b({path:$}):(this.f.error(`${E.Schemas.vscodeFileResource}: Refused to load resource ${$} from ${E.Schemas.vscodeFileResource}: protocol (original URL: ${v.url})`),b({error:-3}))}m(v){const b=p.URI.parse(v.url),$=E.$Wg.uriToFileUri(b);return(0,D.$gc)($.fsPath)}createIPCObjectUrl(){let v;const b=p.URI.from({scheme:"vscode",path:(0,a.$Yg)()}),$=b.toString(),P=async()=>v;return g.$xX.handle($,P),this.f.trace(`IPC Object URL: Registered new channel ${$}.`),{resource:b,update:S=>v=S,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${$}.`),g.$xX.removeHandler($)}}}};e.$Ogc=f,e.$Ogc=f=Ee([se(0,h.$Ki),se(1,w.$Il),se(2,m.$9j)],f)}),define(le[62],ue([0,1,8,4,2,70,12,119,6,42]),function(Y,e,n,r,E,D,T,I,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$gq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$eq=e.$dq=e.$cq=void 0,e.$fq=w,e.$hq=d,e.$jq=b,e.$cq="__$__isNewStorageMarker",e.$dq="__$__targetStorageMarker",e.$eq=(0,p.$Ci)("storageService");var g;(function($){$[$.NONE=0]="NONE",$[$.SHUTDOWN=1]="SHUTDOWN"})(g||(e.WillSaveStateReason=g={}));var h;(function($){$[$.APPLICATION=-1]="APPLICATION",$[$.PROFILE=0]="PROFILE",$[$.WORKSPACE=1]="WORKSPACE"})(h||(e.StorageScope=h={}));var m;(function($){$[$.USER=0]="USER",$[$.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function w($){const P=$.get(e.$dq);if(P)try{return JSON.parse(P)}catch{}return Object.create(null)}class f extends E.$Tc{static{this.a=60*1e3}constructor(P={flushInterval:f.a}){super(),this.m=P,this.b=this.B(new r.$me),this.c=this.B(new r.$me),this.onDidChangeTarget=this.c.event,this.f=this.B(new r.$je),this.onWillSaveState=this.f.event,this.h=this.B(new n.$Oh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new E.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(P,S,t){return r.Event.filter(this.b.event,u=>u.scope===P&&(S===void 0||u.key===S),t)}n(){this.j.value=(0,n.$Sh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,E.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.O()}finally{(0,D.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(P,S){const{key:t,external:u}=S;if(t===e.$dq){switch(P){case h.APPLICATION:this.H=void 0;break;case h.PROFILE:this.F=void 0;break;case h.WORKSPACE:this.C=void 0;break}this.c.fire({scope:P})}else this.b.fire({scope:P,key:t,target:this.J(P)[t],external:u})}w(P){this.f.fire({reason:P})}get(P,S,t){return this.P(S)?.get(P,t)}getBoolean(P,S,t){return this.P(S)?.getBoolean(P,t)}getNumber(P,S,t){return this.P(S)?.getNumber(P,t)}getObject(P,S,t){return this.P(S)?.getObject(P,t)}storeAll(P,S){this.y(()=>{for(const t of P)this.store(t.key,t.value,t.scope,t.target,S)})}store(P,S,t,u,i=!1){if((0,T.$lg)(S)){this.remove(P,t,i);return}this.y(()=>{this.z(P,t,u),this.P(t)?.set(P,S,i)})}remove(P,S,t=!1){this.y(()=>{this.z(P,S,void 0),this.P(S)?.delete(P,t)})}y(P){this.b.pause(),this.c.pause();try{P()}finally{this.b.resume(),this.c.resume()}}keys(P,S){const t=[],u=this.J(P);for(const i of Object.keys(u))u[i]===S&&t.push(i);return t}z(P,S,t,u=!1){const i=this.J(S);typeof t=="number"?i[P]!==t&&(i[P]=t,this.P(S)?.set(e.$dq,JSON.stringify(i),u)):typeof i[P]=="number"&&(delete i[P],this.P(S)?.set(e.$dq,JSON.stringify(i),u))}get D(){return this.C||(this.C=this.L(h.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(h.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(h.APPLICATION)),this.H}J(P){switch(P){case h.APPLICATION:return this.I;case h.PROFILE:return this.G;default:return this.D}}L(P){const S=this.P(P);return S?w(S):Object.create(null)}isNew(P){return this.getBoolean(e.$cq,P)===!0}async flush(P=g.NONE){this.f.fire({reason:P});const S=this.P(h.APPLICATION),t=this.P(h.PROFILE),u=this.P(h.WORKSPACE);switch(P){case g.NONE:await n.Promises.settled([S?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve()]);break;case g.SHUTDOWN:await n.Promises.settled([S?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve()]);break}}async log(){const P=this.P(h.APPLICATION)?.items??new Map,S=this.P(h.PROFILE)?.items??new Map,t=this.P(h.WORKSPACE)?.items??new Map;return b(P,S,t,this.Q(h.APPLICATION)??"",this.Q(h.PROFILE)??"",this.Q(h.WORKSPACE)??"")}async optimize(P){return await this.flush(),this.P(P)?.optimize()}async switch(P,S){return this.w(g.NONE),(0,a.$Hl)(P)?this.R(P,S):this.S(P,S)}M(P,S){return!(P.id===S.id||d(S)&&d(P))}N(P,S,t){this.y(()=>{const u=new Set;for(const[i,o]of P)u.add(i),S.get(i)!==o&&this.u(t,{key:i,external:!0});for(const[i]of S.items)u.has(i)||this.u(t,{key:i,external:!0})})}}e.$gq=f;function d($){return $.isDefault||!!$.useDefaultFlags?.globalState}class v extends f{constructor(){super(),this.U=this.B(new I.$aq(new I.$bq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$aq(new I.$bq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$aq(new I.$bq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(P=>this.u(h.WORKSPACE,P))),this.B(this.W.onDidChangeStorage(P=>this.u(h.PROFILE,P))),this.B(this.U.onDidChangeStorage(P=>this.u(h.APPLICATION,P)))}P(P){switch(P){case h.APPLICATION:return this.U;case h.PROFILE:return this.W;default:return this.X}}Q(P){switch(P){case h.APPLICATION:return"inMemory (application)";case h.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(P){return!1}}e.$iq=v;async function b($,P,S,t,u,i){const o=O=>{try{return JSON.parse(O)}catch{return O}},s=new Map,c=new Map;$.forEach((O,W)=>{s.set(W,O),c.set(W,o(O))});const l=new Map,k=new Map;P.forEach((O,W)=>{l.set(W,O),k.set(W,o(O))});const y=new Map,R=new Map;S.forEach((O,W)=>{y.set(W,O),R.set(W,o(O))}),console.group(t!==u?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const L=[];if(s.forEach((O,W)=>{L.push({key:W,value:O})}),console.table(L),console.groupEnd(),console.log(c),t!==u){console.group(`Storage: Profile (path: ${u}, profile specific)`);const O=[];l.forEach((W,x)=>{O.push({key:x,value:W})}),console.table(O),console.groupEnd(),console.log(k)}console.group(`Storage: Workspace (path: ${i})`);const A=[];y.forEach((O,W)=>{A.push({key:W,value:O})}),console.table(A),console.groupEnd(),console.log(R)}}),define(le[245],ue([0,1,16,33,62]),function(Y,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=D;async function D(T,I,p){let a=p&&p.get("storage.serviceMachineId",E.StorageScope.APPLICATION)||null;if(a)return a;try{const h=(await I.readFile(T.serviceMachineIdResource)).value.toString();a=(0,r.$Xg)(h)?h:null}catch{a=null}if(!a){a=(0,r.$Yg)();try{await I.writeFile(T.serviceMachineIdResource,n.$Le.fromString(a))}catch{}}return p?.store("storage.serviceMachineId",a,E.StorageScope.APPLICATION,E.StorageTarget.MACHINE),a}}),define(le[246],ue([0,1,245,24,57]),function(Y,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=D;async function D(T,I,p,a,g,h,m){const w={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${I.nameShort})`};if((0,E.$Ap)(I,p)&&(0,E.$Cp)(a)===r.TelemetryLevel.USAGE){const f=await(0,n.$kq)(p,g,h);w["X-Market-User-Id"]=f,w["VSCode-SessionId"]=m.machineId||f}return w}}),define(le[247],ue([0,1,26,20,8,4,2,9,66,7,23,119,159,5,62,24,30,11]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w,f,d,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kfc=e.$jfc=e.$ifc=e.$hfc=void 0,n=Ie(n);class $ extends T.$Tc{static{this.a=2e3}get storage(){return this.f}constructor(s,c){super(),this.m=s,this.n=c,this.b=this.B(new D.$je),this.onDidChangeStorage=this.b.event,this.c=this.B(new D.$je),this.onDidCloseStorage=this.c.event,this.f=this.B(new h.$aq(new h.$bq,{hint:h.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new E.$Zh,this.whenInit=this.h.p,this.j=h.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===h.StorageState.None)try{const s=this.B(await this.t());this.f.dispose(),this.f=s,this.B(s.onDidChangeStorage(l=>this.b.fire(l))),await this.s(s);const c=s.getBoolean(f.$cq);c===void 0?s.set(f.$cq,!0):c&&s.set(f.$cq,!1)}catch(s){this.m.error(`[storage main] initialize(): Unable to init storage due to ${s}`)}finally{this.j=h.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===w.LogLevel.Trace?s=>this.m.trace(s):void 0,logError:s=>this.m.error(s)}}s(s){return s.init()}get items(){return this.f.items}get(s,c){return this.f.get(s,c)}set(s,c){return this.f.set(s,c)}delete(s){return this.f.delete(s)}optimize(){return this.f.optimize()}async close(){const s=new p.$de(!1);await this.w(),s.stop(),s.elapsed()>$.a&&await this.u(s),this.c.fire()}async u(s){if(this.path)try{const c=(0,r.top)(Array.from(this.f.items.entries()).map(([k,y])=>({key:k,length:y.length})),(k,y)=>y.length-k.length,5).map(k=>`${k.key}:${k.length}`).join(", "),l=(await this.n.stat(a.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${s.elapsed()}ms, DB size: ${l}b, Large Keys: ${c}`)}catch(c){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",c)}}async w(){this.g&&await this.g,this.j=h.StorageState.Closed,await this.f.close()}}class P extends ${static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,I.$ic)(this.z.globalStorageHome.with({scheme:b.Schemas.file}).fsPath,P.y)}constructor(s,c,l,k){super(l,k),this.z=s,this.C=c}async t(){return new h.$aq(new m.$3X(this.path??m.$3X.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:h.StorageHint.STORAGE_IN_MEMORY})}}class S extends P{constructor(s,c,l,k){super(s,c,l,k)}}e.$hfc=S;class t extends P{constructor(s,c,l,k){super(c.defaultProfile,s,l,k)}async s(s){await super.s(s),this.G(s)}G(s){s.get(d.$$l,void 0)===void 0&&s.set(d.$$l,new Date().toUTCString());const l=s.get(d.$0l,void 0),k=new Date().toUTCString();s.set(d.$_l,typeof l>"u"?null:l),s.set(d.$0l,k)}}e.$ifc=t;class u extends ${static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,I.$ic)(this.F.workspaceStorageHome.with({scheme:b.Schemas.file}).fsPath,this.C.id,u.y)}constructor(s,c,l,k,y){super(l,y),this.C=s,this.D=c,this.F=k}async t(){const{storageFilePath:s,wasCreated:c}=await this.H();return new h.$aq(new m.$3X(s,{logging:this.r()}),{hint:this.D.useInMemoryStorage?h.StorageHint.STORAGE_IN_MEMORY:c?h.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:m.$3X.IN_MEMORY_PATH,wasCreated:!0};const s=(0,I.$ic)(this.F.workspaceStorageHome.with({scheme:b.Schemas.file}).fsPath,this.C.id),c=(0,I.$ic)(s,u.y);return await g.Promises.exists(s)?{storageFilePath:c,wasCreated:!1}:(await n.promises.mkdir(s,{recursive:!0}),this.I(s),{storageFilePath:c,wasCreated:!0})}async I(s){let c;if((0,v.$Mi)(this.C)?c={folder:this.C.uri.toString()}:(0,v.$Ri)(this.C)&&(c={workspace:this.C.configPath.toString()}),c)try{const l=(0,I.$ic)(s,u.z);await g.Promises.exists(l)||await g.Promises.writeFile(l,JSON.stringify(c,void 0,2))}catch(l){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${l}`)}}}e.$jfc=u;class i extends ${get path(){}async t(){return new h.$aq(new h.$bq,{hint:h.StorageHint.STORAGE_IN_MEMORY})}}e.$kfc=i}),define(le[248],ue([0,1,4,2,62]),function(Y,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=void 0;class D extends r.$Tc{constructor(I,p,a){super(),this.b=I,this.c=p,this.f=a;const g=this.B(new r.$Uc);this.a=this.B(new n.$je({onWillAddFirstListener:()=>g.value=this.g(),onDidRemoveLastListener:()=>g.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const I=new r.$Sc;return I.add(n.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(p,a)=>(p?p.push(a.key):p=[a.key],p),100)(p=>this.h(p))),I.add(n.Event.debounce(this.b.onDidChangeProfileStorage,(p,a)=>{p||(p=new Map);let g=p.get(a.profile.id);return g||p.set(a.profile.id,g={profile:a.profile,keys:[],storage:a.storage}),g.keys.push(a.key),p},100)(p=>this.j(p))),I}h(I){const p=I.includes(E.$dq)?[this.c.defaultProfile]:[],a=[];if(I=I.filter(g=>g!==E.$dq),I.length){const g=(0,E.$fq)(this.b.applicationStorage.storage);a.push({profile:this.c.defaultProfile,changes:I.map(h=>({key:h,scope:E.StorageScope.PROFILE,target:g[h]}))})}this.m(p,a)}j(I){const p=[],a=new Map;for(const[g,h]of I.entries()){h.keys.includes(E.$dq)&&p.push(h.profile);const m=h.keys.filter(w=>w!==E.$dq);if(m.length){const w=(0,E.$fq)(h.storage.storage);a.set(g,{profile:h.profile,changes:m.map(f=>({key:f,scope:E.StorageScope.PROFILE,target:w[f]}))})}}this.m(p,[...a.values()])}m(I,p){(I.length||p.length)&&this.a.fire({valueChanges:p,targetChanges:I})}listen(I,p,a){switch(p){case"onDidChange":return this.a.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${p}`)}async call(I,p){throw new Error(`Call not found: ${p}`)}}e.$wgc=D}),define(le[249],ue([0,1,7,38,14,5,34,41,42,12,127]),function(Y,e,n,r,E,D,T,I,p,a,g){"use strict";var h,m;Object.defineProperty(e,"__esModule",{value:!0}),e.$mR=e.$lR=e.$kR=void 0;let w=class extends p.$Ll{static{h=this}static{this.a="profileAssociationsMigration"}constructor(b,$,P,S,t){super(P,S,$,t),this.U=b,this.W=P}O(){return this.U.getItem(h.b,[]).map($=>({...$,location:(0,a.$cg)($.location)?this.w.extUri.joinPath(this.profilesHome,$.location):n.URI.revive($.location)}))}Q(){const b=this.U.getItem(h.c,{});return this.U.getItem(h.a,!1)?b:this.N(b)}S(){return this.w.extUri.joinPath(n.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$kR=w,e.$kR=w=h=Ee([se(0,T.$fR),se(1,I.$Gl),se(2,r.$Ki),se(3,E.$9k),se(4,D.$9j)],w);let f=m=class extends w{constructor(b,$,P,S,t){super(b,$,P,S,t),this.$=b}P(b){b.length?this.$.setItem(m.b,b.map($=>({...$,location:this.w.extUri.basename($.location)}))):this.$.removeItem(m.b)}O(){const b=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(b),this.$.setItem("userDataProfilesMigration",!0)),b}R(b){b.emptyWindows||b.workspaces?this.$.setItem(m.c,b):this.$.removeItem(m.c)}Q(){const b="workspaceAndProfileInfo",$=this.$.getItem(b,void 0);if($){this.$.removeItem(b);const S=$.reduce((t,{workspace:u,profile:i})=>(t[n.URI.revive(u).toString()]=n.URI.revive(i).toString(),t),{});this.$.setItem(m.c,{workspaces:S})}const P=super.Q();return this.$.getItem(m.a,!1)||(this.R(P),this.$.setItem(m.a,!0)),P}};e.$lR=f,e.$lR=f=m=Ee([se(0,T.$gR),se(1,I.$Gl),se(2,r.$Ki),se(3,E.$9k),se(4,D.$9j)],f);let d=class extends f{constructor(b,$,P,S){super(new g.$jR(g.SaveStrategy.IMMEDIATE,$,S,P),b,$,P,S)}async init(){return await this.$.init(),super.init()}};e.$mR=d,e.$mR=d=Ee([se(0,I.$Gl),se(1,r.$Ki),se(2,E.$9k),se(3,D.$9j)],d)}),define(le[58],ue([0,1,38,14,6,5,41,42,249,34]),function(Y,e,n,r,E,D,T,I,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ec=e.$2ec=void 0,e.$2ec=(0,E.$Di)(I.$Il);let g=class extends p.$lR{constructor(m,w,f,d,v){super(m,w,f,d,v)}getAssociatedEmptyWindows(){const m=[];for(const w of this.C.emptyWindows.keys())m.push({id:w});return m}};e.$3ec=g,e.$3ec=g=Ee([se(0,a.$gR),se(1,T.$Gl),se(2,n.$Ki),se(3,r.$9k),se(4,D.$9j)],g)}),define(le[134],ue([0,1,18,7,30]),function(Y,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ec=D,e.$5ec=T,e.$6ec=I;async function D(p,a,g){for(const m of p){const w=m.openedWorkspace;if((0,E.$Ri)(w)){const f=await g(w);if(f){if(f.folders.some(d=>n.$7g.isEqualOrParent(a,d.uri)))return m}else if(n.$7g.isEqualOrParent(a,w.configPath))return m}}const h=p.filter(m=>(0,E.$Mi)(m.openedWorkspace)&&n.$7g.isEqualOrParent(a,m.openedWorkspace.uri));if(h.length)return h.sort((m,w)=>-(m.openedWorkspace.uri.path.length-w.openedWorkspace.uri.path.length))[0]}function T(p,a){for(const g of p)if((0,E.$Ri)(g.openedWorkspace)&&n.$7g.isEqual(g.openedWorkspace.configPath,a)||(0,E.$Mi)(g.openedWorkspace)&&n.$7g.isEqual(g.openedWorkspace.uri,a))return g}function I(p,a){const g=h=>a.some(m=>n.$7g.isEqual(r.URI.file(m),r.URI.file(h)));for(const h of p)if(h.config?.extensionDevelopmentPath?.some(m=>g(m)))return h}}),define(le[102],ue([0,1,32,43,107,47,11,9,3,18,7,6,74,30]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qhb=void 0,e.$Rhb=f,e.$Shb=d,e.$Thb=v,e.$Uhb=b,e.$Vhb=S,e.$Whb=u,e.$Xhb=i,e.$Yhb=k,e.$Zhb=y,r=Ie(r),E=Ie(E),e.$Qhb=(0,h.$Ci)("workspacesService");function f(R){return R.hasOwnProperty("workspace")}function d(R){return R.hasOwnProperty("folderUri")}function v(R){return R.hasOwnProperty("fileUri")}function b(R){return $(R)||P(R)}function $(R){const L=R;return typeof L?.path=="string"&&(!L.name||typeof L.name=="string")}function P(R){const L=R;return typeof L?.uri=="string"&&(!L.name||typeof L.name=="string")}function S(R,L,A,O,W){if(R.scheme!==O.scheme)return{name:A,uri:R.toString(!0)};let x=L?void 0:W.relativePath(O,R);if(x!==void 0)x.length===0?x=".":p.$j&&(x=t(x));else if(R.scheme===T.Schemas.file)x=R.fsPath,p.$j&&(x=t(x));else if(W.isEqualAuthority(R.authority,O.authority))x=R.path;else return{name:A,uri:R.toString(!0)};return{name:A,path:x}}function t(R){return R=(0,D.$Vw)(R),(0,n.$yg)(R)||(R=(0,n.$vg)(R)),R}function u(R,L,A){const O=[],W=new Set,x=A.dirname(L);for(const C of R){let B;if($(C))C.path&&(B=A.resolvePath(x,C.path));else if(P(C))try{B=g.URI.parse(C.uri),B.path[0]!==I.$fc.sep&&(B=B.with({path:I.$fc.sep+B.path}))}catch(ee){console.warn(ee)}if(B){const ee=A.getComparisonKey(B);if(!W.has(ee)){W.add(ee);const X=C.name||A.basenameOrAuthority(B);O.push(new w.$Wi({uri:B,name:X,index:O.length},C))}}}return O}function i(R,L,A,O,W){const x=o(L,R),C=W.dirname(L),B=W.dirname(O),ee=[];for(const te of x.folders){const z=$(te)?W.resolvePath(C,te.path):g.URI.parse(te.uri);let j;A?j=!1:j=!$(te)||(0,I.$hc)(te.path),ee.push(S(z,j,te.name,B,W))}const X={insertSpaces:!1,tabSize:4,eol:p.$l||p.$k?`
`:`\r
`},ae=E.$9n(R,["folders"],ee,X);let K=E.$_n(R,ae);return(0,a.$ih)(x.remoteAuthority,(0,m.$dn)(O))&&(K=E.$_n(K,E.$8n(K,["remoteAuthority"],X))),K}function o(R,L){const A=r.$Un(L);if(A&&Array.isArray(A.folders))A.folders=A.folders.filter(O=>b(O));else throw new Error(`${R} looks like an invalid workspace file.`);return A}function s(R){return R.workspace&&typeof R.workspace=="object"&&typeof R.workspace.id=="string"&&typeof R.workspace.configPath=="string"}function c(R){return typeof R.folderUri=="string"}function l(R){return typeof R.fileUri=="string"}function k(R,L){const A={workspaces:[],files:[]};if(R){const O=function(x,C){for(let B=0;B<x.length;B++)try{C(x[B],B)}catch(ee){L.warn(`Error restoring recent entry ${JSON.stringify(x[B])}: ${ee.toString()}. Skip entry.`)}},W=R;Array.isArray(W.entries)&&O(W.entries,x=>{const C=x.label,B=x.remoteAuthority;s(x)?A.workspaces.push({label:C,remoteAuthority:B,workspace:{id:x.workspace.id,configPath:g.URI.parse(x.workspace.configPath)}}):c(x)?A.workspaces.push({label:C,remoteAuthority:B,folderUri:g.URI.parse(x.folderUri)}):l(x)&&A.files.push({label:C,remoteAuthority:B,fileUri:g.URI.parse(x.fileUri)})})}return A}function y(R){const L={entries:[]};for(const A of R.workspaces)d(A)?L.entries.push({folderUri:A.folderUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority}):L.entries.push({workspace:{id:A.workspace.id,configPath:A.workspace.configPath.toString()},label:A.label,remoteAuthority:A.remoteAuthority});for(const A of R.files)L.entries.push({fileUri:A.fileUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority});return L}}),define(le[103],ue([0,1,91,11,3,18]),function(Y,e,n,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ec=void 0,e.$8ec=T,e.$9ec=I,e.$0ec=p,e.$7ec=128/4;function T(a){function g(){let h=a.scheme===r.Schemas.file?(0,D.$4g)(a):a.toString();return E.$l||(h=h.toLowerCase()),(0,n.createHash)("md5").update(h).digest("hex")}return{id:g(),configPath:a}}function I(a,g){function h(){if(a.scheme!==r.Schemas.file)return(0,n.createHash)("md5").update(a.toString()).digest("hex");if(!g)return;let w;return E.$l?w=g.ino:E.$k?w=g.birthtime.getTime():E.$j&&(typeof g.birthtimeMs=="number"?w=Math.floor(g.birthtimeMs):w=g.birthtime.getTime()),(0,n.createHash)("md5").update(a.fsPath).update(w?String(w):"").digest("hex")}const m=h();if(typeof m=="string")return{id:m,uri:a}}function p(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(le[104],ue([0,1,91,93,27,250,16,15,4,2,9,3,33,44,117]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$ti=e.$si=e.$ri=void 0,e.$ui=s,e.$vi=c,e.$xi=y,e.$yi=R;const d=3e4;class v{traceSocketEvent(A,O){f.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,A,O)}constructor(A,O=""){this.f=!0,this.debugLabel=O,this.socket=A,this.traceSocketEvent(f.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=x=>{if(this.traceSocketEvent(f.SocketDiagnosticsEventType.Error,{code:x?.code,message:x?.message}),x){if(x.code==="EPIPE")return;(0,I.$Y)(x)}},this.socket.on("error",this.a);let W;this.b=x=>{this.traceSocketEvent(f.SocketDiagnosticsEventType.Close,{hadError:x}),this.f=!1,W&&clearTimeout(W)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,W=setTimeout(()=>A.destroy(),d)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(A){const O=W=>{this.traceSocketEvent(f.SocketDiagnosticsEventType.Read,W),A(T.$Le.wrap(W))};return this.socket.on("data",O),{dispose:()=>this.socket.off("data",O)}}onClose(A){const O=W=>{A({type:f.SocketCloseEventType.NodeSocketCloseEvent,hadError:W,error:void 0})};return this.socket.on("close",O),{dispose:()=>this.socket.off("close",O)}}onEnd(A){const O=()=>{A()};return this.socket.on("end",O),{dispose:()=>this.socket.off("end",O)}}write(A){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(f.SocketDiagnosticsEventType.Write,A),this.socket.write(A.buffer,O=>{if(O){if(O.code==="EPIPE")return;(0,I.$Y)(O)}})}catch(O){if(O.code==="EPIPE")return;(0,I.$Y)(O)}}end(){this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((A,O)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeDrainEnd),A();return}const W=()=>{this.socket.off("close",W),this.socket.off("end",W),this.socket.off("error",W),this.socket.off("timeout",W),this.socket.off("drain",W),this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeDrainEnd),A()};this.socket.on("close",W),this.socket.on("end",W),this.socket.on("error",W),this.socket.on("timeout",W),this.socket.on("drain",W)})}}e.$ri=v;var b;(function(L){L[L.MinHeaderByteSize=2]="MinHeaderByteSize",L[L.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(b||(b={}));var $;(function(L){L[L.PeekHeader=1]="PeekHeader",L[L.ReadHeader=2]="ReadHeader",L[L.ReadBody=3]="ReadBody",L[L.Fin=4]="Fin"})($||($={}));class P extends a.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(A,O){this.socket.traceSocketEvent(A,O)}constructor(A,O,W,x){super(),this.f=this.B(new p.$je),this.g=this.B(new p.$je),this.h=!1,this.j={state:$.PeekHeader,readLen:b.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=A,this.traceSocketEvent(f.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:O,inflateBytesLength:W?.byteLength||0,recordInflateBytes:x}),this.a=this.B(new S(this,O,W,x,this.f,(C,B)=>this.m(C,B))),this.B(this.a.onError(C=>{console.error(C),(0,I.$Y)(C),this.g.fire({type:f.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:C})})),this.b=new f.$mi,this.B(this.socket.onData(C=>this.n(C))),this.B(this.socket.onClose(async C=>{this.a.isProcessingReadQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(C)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(A){return this.f.event(A)}onClose(A){return this.g.event(A)}onEnd(A){return this.socket.onEnd(A)}write(A){let O=0;for(;O<A.byteLength;)this.a.writeMessage(A.slice(O,Math.min(O+b.MaxWebSocketMessageLength,A.byteLength)),{compressed:!0,opcode:2}),O+=b.MaxWebSocketMessageLength}m(A,{compressed:O,opcode:W}){if(this.h)return;this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,A);let x=b.MinHeaderByteSize;A.byteLength<126?x+=0:A.byteLength<2**16?x+=2:x+=8;const C=T.$Le.alloc(x),B=O?64:0,ee=W&15;if(C.writeUInt8(128|B|ee,0),A.byteLength<126)C.writeUInt8(A.byteLength,1);else if(A.byteLength<2**16){C.writeUInt8(126,1);let X=1;C.writeUInt8(A.byteLength>>>8&255,++X),C.writeUInt8(A.byteLength>>>0&255,++X)}else{C.writeUInt8(127,1);let X=1;C.writeUInt8(0,++X),C.writeUInt8(0,++X),C.writeUInt8(0,++X),C.writeUInt8(0,++X),C.writeUInt8(A.byteLength>>>24&255,++X),C.writeUInt8(A.byteLength>>>16&255,++X),C.writeUInt8(A.byteLength>>>8&255,++X),C.writeUInt8(A.byteLength>>>0&255,++X)}this.socket.write(T.$Le.concat([C,A]))}end(){this.h=!0,this.socket.end()}n(A){if(A.byteLength!==0){for(this.b.acceptChunk(A);this.b.byteLength>=this.j.readLen;)if(this.j.state===$.PeekHeader){const O=this.b.peek(this.j.readLen),W=O.readUInt8(0),x=(W&128)>>>7,C=(W&64)>>>6,B=W&15,ee=O.readUInt8(1),X=(ee&128)>>>7,ae=ee&127;this.j.state=$.ReadHeader,this.j.readLen=b.MinHeaderByteSize+(X?4:0)+(ae===126?2:0)+(ae===127?8:0),this.j.fin=x,this.j.firstFrameOfMessage&&(this.j.compressed=!!C),this.j.firstFrameOfMessage=!!x,this.j.mask=0,this.j.opcode=B,this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===$.ReadHeader){const O=this.b.read(this.j.readLen),W=O.readUInt8(1),x=(W&128)>>>7;let C=W&127,B=1;C===126?C=O.readUInt8(++B)*2**8+O.readUInt8(++B):C===127&&(C=O.readUInt8(++B)*0+O.readUInt8(++B)*0+O.readUInt8(++B)*0+O.readUInt8(++B)*0+O.readUInt8(++B)*2**24+O.readUInt8(++B)*2**16+O.readUInt8(++B)*2**8+O.readUInt8(++B));let ee=0;x&&(ee=O.readUInt8(++B)*2**24+O.readUInt8(++B)*2**16+O.readUInt8(++B)*2**8+O.readUInt8(++B)),this.j.state=$.ReadBody,this.j.readLen=C,this.j.mask=ee,this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===$.ReadBody){const O=this.b.read(this.j.readLen);this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,O),i(O,this.j.mask),this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,O),this.j.state=$.PeekHeader,this.j.readLen=b.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(O,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(O,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$si=P;class S extends a.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:T.$Le.alloc(0)}constructor(A,O,W,x,C,B){super(),this.n=A,this.r=C,this.s=B,this.a=this.B(new p.$je),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new p.$je),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new p.$je),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,O?(this.b=this.B(new t(this.n,x,W,{windowBits:15})),this.f=this.B(new u(this.n,{windowBits:15})),this.B(this.b.onError(ee=>this.a.fire(ee))),this.B(this.f.onError(ee=>this.a.fire(ee)))):(this.b=null,this.f=null)}writeMessage(A,O){this.g.push({data:A,options:O}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:A,options:O}=this.g.shift();if(this.f&&O.compressed){const W=await this.w(this.f,A);this.s(W,O)}else this.s(A,{...O,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(A,O){return new Promise((W,x)=>{A.write(O),A.flush(C=>W(C))})}acceptFrame(A,O,W){this.h.push({data:A,isCompressed:O,isLastFrameOfMessage:W}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const A=this.h.shift();if(this.b&&A.isCompressed){const O=await this.C(this.b,A.data,A.isLastFrameOfMessage);this.r.fire(O)}else this.r.fire(A.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(A,O,W){return new Promise((x,C)=>{A.write(O),W&&A.write(T.$Le.fromByteArray([0,0,255,255])),A.flush(B=>x(B))})}}class t extends a.$Tc{get recordedInflateBytes(){return this.j?T.$Le.concat(this.f):T.$Le.alloc(0)}constructor(A,O,W,x){super(),this.h=A,this.j=O,this.a=this.B(new p.$je),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,D.createInflateRaw)(x),this.b.on("error",C=>{this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateError,{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateData,C),this.g.push(T.$Le.wrap(C))}),W&&(this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateInitialWrite,W.buffer),this.b.write(W.buffer),this.b.flush(()=>{this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(A){this.j&&this.f.push(A.clone()),this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateWrite,A),this.b.write(A.buffer)}flush(A){this.b.flush(()=>{this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateFlushFired);const O=T.$Le.concat(this.g);this.g.length=0,A(O)})}}class u extends a.$Tc{constructor(A,O){super(),this.g=A,this.a=this.B(new p.$je),this.onError=this.a.event,this.f=[],this.b=(0,D.createDeflateRaw)({windowBits:15}),this.b.on("error",W=>{this.g.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateError,{message:W?.message,code:W?.code}),this.a.fire(W)}),this.b.on("data",W=>{this.g.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateData,W),this.f.push(T.$Le.wrap(W))})}write(A){this.g.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateWrite,A.buffer),this.b.write(A.buffer)}flush(A){this.b.flush(2,()=>{this.g.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateFlushFired);let O=T.$Le.concat(this.f);this.f.length=0,O=O.slice(0,O.byteLength-4),A(O)})}}function i(L,A){if(A===0)return;const O=L.byteLength>>>2;for(let X=0;X<O;X++){const ae=L.readUInt32BE(X*4);L.writeUInt32BE(ae^A,X*4)}const W=O*4,x=L.byteLength-W,C=A>>>24&255,B=A>>>16&255,ee=A>>>8&255;x>=1&&L.writeUInt8(L.readUInt8(W)^C,W),x>=2&&L.writeUInt8(L.readUInt8(W+1)^B,W+1),x>=3&&L.writeUInt8(L.readUInt8(W+2)^ee,W+2)}e.$ti=process.env.XDG_RUNTIME_DIR;const o={[h.Platform.Linux]:107,[h.Platform.Mac]:103};function s(){const L=(0,m.$Yg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${L}-sock`;const A=process.platform!=="darwin"&&e.$ti?e.$ti:(0,E.tmpdir)(),O=(0,g.$ic)(A,`vscode-ipc-${L}.sock`);return l(O),O}function c(L,A,O){const x=(0,n.createHash)("sha256").update(L).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${x}-${O}-${A}-sock`;const C=O.substr(0,4),B=A.substr(0,6);let ee;return process.platform!=="darwin"&&e.$ti&&!process.env.VSCODE_PORTABLE?ee=(0,g.$ic)(e.$ti,`vscode-${x}-${C}-${B}.sock`):ee=(0,g.$ic)(L,`${C}-${B}.sock`),l(ee),ee}function l(L){const A=o[h.$v];typeof A=="number"&&L.length>=A&&console.warn(`WARNING: IPC handle "${L}" is longer than ${A} chars, try a shorter --user-data-dir`)}class k extends w.$gi{static b(A){const O=p.Event.fromNodeEventEmitter(A,"connection");return p.Event.map(O,W=>({protocol:new f.$ni(new v(W,"ipc-server-connection")),onDidClientDisconnect:p.Event.once(p.Event.fromNodeEventEmitter(W,"close"))}))}constructor(A){super(k.b(A)),this.d=A}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$wi=k;function y(L){return new Promise((A,O)=>{const W=(0,r.createServer)();W.on("error",O),W.listen(L,()=>{W.removeListener("error",O),A(new k(W))})})}function R(L,A){return new Promise((O,W)=>{const x=(0,r.createConnection)(L,()=>{x.removeListener("error",W),O(f.$oi.fromSocket(new v(x,`ipc-client${A}`),A))});x.once("error",W)})}}),define(le[22],ue([0,1,53,9,3,104,38,95,6]),function(Y,e,n,r,E,D,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oec=e.$Nec=void 0,e.$Nec=(0,p.$Di)(T.$Ji);class a extends I.$5m{constructor(){super(...arguments),this.d={}}get backupHome(){return(0,r.$ic)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,D.$vi)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,r.$ic)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(E.$l){for(const h in process.env)if(h.endsWith("_VSCODE_SNAP_ORIG")){const m=h.slice(0,-17);if(this.d[m])continue;process.env[m]&&(this.d[m]=process.env[m]),process.env[h]?process.env[m]=process.env[h]:delete process.env[m]}}}restoreSnapExportedVariables(){if(E.$l)for(const h in this.d)process.env[h]=this.d[h],delete this.d[h]}}e.$Oec=a,Ee([n.$7h],a.prototype,"backupHome",null),Ee([n.$7h],a.prototype,"mainIPCHandle",null),Ee([n.$7h],a.prototype,"mainLockfile",null),Ee([n.$7h],a.prototype,"disableUpdates",null),Ee([n.$7h],a.prototype,"crossOriginIsolated",null),Ee([n.$7h],a.prototype,"codeCachePath",null),Ee([n.$7h],a.prototype,"useCodeCache",null)}),define(le[251],ue([0,1,91,32,11,9,3,18,23,163,17,22,34,14,5,162,30,103]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w,f,d,v,b){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$qfc=void 0;let P=class{static{$=this}static{this.a="backupWorkspaces"}constructor(t,u,i,o){this.j=t,this.k=u,this.l=i,this.m=o,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=I.$7g,this.i={isEqual:(s,c)=>(0,r.$Ag)(s,c,!T.$l)}}async initialize(){const t=this.m.getItem($.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(t.emptyWindows),this.d=await this.u((0,a.$Qec)(t)),this.e=await this.v((0,a.$Rec)(t)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==w.$vl.OFF}q(){return this.s()===w.$vl.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||w.$vl.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(t,u){this.d.some(o=>t.workspace.id===o.workspace.id)||(this.d.push(t),this.C());const i=(0,D.$ic)(this.c,t.workspace.id);return u?this.t(i,u).then(()=>i):i}async t(t,u){if(await p.Promises.exists(t)&&await this.z(t),await p.Promises.exists(u))try{await p.Promises.rename(u,t,!1)}catch(i){this.l.error(`Backup: Could not move backup folder to new location: ${i.toString()}`)}}registerFolderBackup(t){return this.e.some(u=>this.h.isEqual(t.folderUri,u.folderUri))||(this.e.push(t),this.C()),(0,D.$ic)(this.c,this.D(t))}registerEmptyWindowBackup(t){return this.g.some(u=>!!u.backupFolder&&this.i.isEqual(u.backupFolder,t.backupFolder))||(this.g.push(t),this.C()),(0,D.$ic)(this.c,t.backupFolder)}async u(t){if(!Array.isArray(t))return[];const u=new Set,i=[];for(const o of t){const s=o.workspace;if(!(0,v.$Ri)(s))return[];if(!u.has(s.id)){u.add(s.id);const c=(0,D.$ic)(this.c,s.id);await this.B(c)?s.configPath.scheme!==E.Schemas.file||await p.Promises.exists(s.configPath.fsPath)?i.push(o):await this.z(c):await this.x(c)}}return i}async v(t){if(!Array.isArray(t))return[];const u=[],i=new Set;for(const o of t){const s=o.folderUri,c=this.h.getComparisonKey(s);if(!i.has(c)){i.add(c);const l=(0,D.$ic)(this.c,this.D(o));await this.B(l)?s.scheme!==E.Schemas.file||await p.Promises.exists(s.fsPath)?u.push(o):await this.z(l):await this.x(l)}}return u}async w(t){if(!Array.isArray(t))return[];const u=[],i=new Set;for(const o of t){const s=o.backupFolder;if(typeof s!="string")return[];if(!i.has(s)){i.add(s);const c=(0,D.$ic)(this.c,s);await this.B(c)?u.push(o):await this.x(c)}}return u}async x(t){try{await p.Promises.rm(t,p.RimRafMode.MOVE)}catch(u){this.l.error(`Backup: Could not delete stale backup: ${u.toString()}`)}}y(){let t=(0,b.$0ec)();for(;this.g.some(u=>!!u.backupFolder&&this.i.isEqual(u.backupFolder,t.id));)t=(0,b.$0ec)();return{backupFolder:t.id}}async z(t){const u=this.y(),i=(0,D.$ic)(this.c,u.backupFolder);try{await p.Promises.rename(t,i,!1)}catch(o){return this.l.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.g.push(u),!0}async getDirtyWorkspaces(){const t=[];for(const u of this.d)await this.A(u)&&t.push(u);for(const u of this.e)await this.A(u)&&t.push(u);return t}A(t){let u;return(0,a.$Pec)(t)?u=(0,D.$ic)(this.c,t.backupFolder):(0,d.$Ohb)(t)?u=(0,D.$ic)(this.c,this.D(t)):u=(0,D.$ic)(this.c,t.workspace.id),this.B(u)}async B(t){try{const u=await p.Promises.readdir(t);for(const i of u)try{if((await p.Promises.readdir((0,D.$ic)(t,i))).length>0)return!0}catch{}}catch{}return!1}C(){const t={workspaces:this.d.map(({workspace:u,remoteAuthority:i})=>{const o={id:u.id,configURIPath:u.configPath.toString()};return i&&(o.remoteAuthority=i),o}),folders:this.e.map(({folderUri:u,remoteAuthority:i})=>{const o={folderUri:u.toString()};return i&&(o.remoteAuthority=i),o}),emptyWindows:this.g.map(({backupFolder:u,remoteAuthority:i})=>{const o={backupFolder:u};return i&&(o.remoteAuthority=i),o})};this.m.setItem($.a,t)}D(t){const u=t.folderUri;let i;return u.scheme===E.Schemas.file?i=T.$l?u.fsPath:u.fsPath.toLowerCase():i=u.toString().toLowerCase(),(0,n.createHash)("md5").update(i).digest("hex")}};e.$qfc=P,e.$qfc=P=$=Ee([se(0,h.$Nec),se(1,g.$9i),se(2,f.$9j),se(3,m.$gR)],P)}),define(le[19],ue([0,1,13,35,8,4,2,3,36,12,6,5,34,51,22]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w,f){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$gfc=e.LifecycleMainPhase=e.ShutdownReason=e.$ffc=void 0,e.$ffc=(0,g.$Ci)("lifecycleMainService");var v;(function(P){P[P.QUIT=1]="QUIT",P[P.KILL=2]="KILL"})(v||(e.ShutdownReason=v={}));var b;(function(P){P[P.Starting=1]="Starting",P[P.Ready=2]="Ready",P[P.AfterWindowOpen=3]="AfterWindowOpen",P[P.Eventually=4]="Eventually"})(b||(e.LifecycleMainPhase=b={}));let $=class extends T.$Tc{static{d=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(S,t,u){super(),this.F=S,this.G=t,this.H=u,this.c=this.B(new D.$je),this.onBeforeShutdown=this.c.event,this.f=this.B(new D.$je),this.onWillShutdown=this.f.event,this.g=this.B(new D.$je),this.onWillLoadWindow=this.g.event,this.h=this.B(new D.$je),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=b.Starting,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(b.Ready).then(()=>this.J())}I(){this.m=!!this.G.getItem(d.b),this.m&&this.G.removeItem(d.b)}J(){const S=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),I.$k&&this.t===0&&this.L(v.QUIT))};n.app.addListener("before-quit",S);const t=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!I.$k)&&n.app.quit()};n.app.addListener("window-all-closed",t),n.app.once("will-quit",u=>{this.S("Lifecycle#app.on(will-quit) - begin"),u.preventDefault(),this.L(v.QUIT).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),n.app.removeListener("before-quit",S),n.app.removeListener("window-all-closed",t),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),n.app.quit()})})}L(S){if(this.y)return this.y;const t=this.F;this.S("Lifecycle#onWillShutdown.fire()");const u=[];return this.f.fire({reason:S,join(i,o){t.trace(`Lifecycle#onWillShutdown - begin '${i}'`),u.push(o.finally(()=>{t.trace(`Lifecycle#onWillShutdown - end '${i}'`)}))}}),this.y=(async()=>{try{await E.Promises.settled(u)}catch(i){this.F.error(i)}try{await this.G.close()}catch(i){this.F.error(i)}})(),this.y}set phase(S){if(S<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===S)return;this.S(`lifecycle (main): phase changed (value: ${S})`),this.n=S;const t=this.C.get(this.n);t&&(t.open(),this.C.delete(this.n))}async when(S){if(S<=this.n)return;let t=this.C.get(S);t||(t=new E.$Bh,this.C.set(S,t)),await t.wait()}registerWindow(S){const t=new T.$Sc;this.t++,t.add(S.onWillLoad(i=>this.g.fire({window:S,workspace:i.workspace,reason:i.reason})));const u=(0,a.$ng)(S.win);t.add(D.Event.fromNodeEventEmitter(u,"close")(i=>{const o=S.id;if(this.r.has(o)){this.r.delete(o);return}this.S(`Lifecycle#window.on('close') - window ID ${S.id}`),i.preventDefault(),this.unload(S,w.UnloadReason.CLOSE).then(s=>{if(s){this.r.delete(o);return}this.r.add(o),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this.h.fire(S),S.close()})})),t.add(D.Event.fromNodeEventEmitter(u,"closed")(()=>{this.S(`Lifecycle#window.on('closed') - window ID ${S.id}`),this.t--,t.dispose(),this.t===0&&(!I.$k||this.j)&&this.L(v.QUIT)}))}registerAuxWindow(S){const t=(0,a.$ng)(S.win),u=new T.$Sc;u.add(D.Event.fromNodeEventEmitter(t,"close")(i=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${S.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),i.preventDefault())})),u.add(D.Event.fromNodeEventEmitter(t,"closed")(()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${S.id}`),u.dispose()}))}async reload(S,t){await this.unload(S,w.UnloadReason.RELOAD)||S.reload(t)}unload(S,t){const u=this.z.get(S.id);if(u)return u;const i=this.M(S,t).finally(()=>{this.z.delete(S.id)});return this.z.set(S.id,i),i}async M(S,t){if(!S.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${S.id}`);const u=this.j?w.UnloadReason.QUIT:t,i=await this.P(S,u);return i?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${S.id})`),this.N(i)):(await this.Q(S,u),!1)}N(S){return S?(this.O(!0),this.j=!1,!0):!1}O(S){this.w&&(this.w(S),this.w=void 0,this.u=void 0)}P(S,t){return new Promise(u=>{const i=this.s++,o=`vscode:ok${i}`,s=`vscode:cancel${i}`;r.$xX.once(o,()=>{u(!1)}),r.$xX.once(s,()=>{u(!0)}),S.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:s,reason:t})})}Q(S,t){return new Promise(u=>{const o=`vscode:reply${this.s++}`;r.$xX.once(o,()=>u()),S.send("vscode:onWillUnload",{replyChannel:o,reason:t})})}quit(S){return this.R(S).then(t=>{if(!t&&S)try{if(I.$j){const u=(0,p.cwd)();u!==process.cwd()&&process.chdir(u)}}catch(u){this.F.error(u)}return t})}R(S){return this.S(`Lifecycle#quit() - begin (willRestart: ${S})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(S&&this.G.setItem(d.b,!0),this.u=new Promise(t=>{this.w=t,this.S("Lifecycle#quit() - calling app.quit()"),n.app.quit()}),this.u)}S(S){this.H.args["enable-smoke-test-driver"]?this.F.info(S):this.F.trace(S)}setRelaunchHandler(S){this.D=S}async relaunch(S){this.S("Lifecycle#relaunch()");const t=process.argv.slice(1);if(S?.addArgs&&t.push(...S.addArgs),S?.removeArgs)for(const o of S.removeArgs){const s=t.indexOf(o);s>=0&&t.splice(s,1)}const u=()=>{this.D?.handleRelaunch(S)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),n.app.relaunch({args:t}))};n.app.once("quit",u),await this.quit(!0)&&n.app.removeListener("quit",u)}async kill(S){this.S("Lifecycle#kill()"),await this.L(v.KILL),await Promise.race([(0,E.$Dh)(1e3),(async()=>{for(const t of n.BrowserWindow.getAllWindows())if(t&&!t.isDestroyed()){let u;t.webContents&&!t.webContents.isDestroyed()?u=new Promise(i=>t.once("closed",i)):u=Promise.resolve(),t.destroy(),await u}})()]),n.app.exit(S)}};e.$gfc=$,e.$gfc=$=d=Ee([se(0,h.$9j),se(1,m.$gR),se(2,f.$Nec)],$)}),define(le[252],ue([0,1,3,4,2,6,19]),function(Y,e,n,r,E,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pfc=e.$Ofc=void 0,n=Ie(n),e.$Ofc=(0,D.$Ci)("keyboardLayoutMainService");let I=class extends E.$Tc{constructor(g){super(),this.a=this.B(new r.$je),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,g.when(T.LifecycleMainPhase.AfterWindowOpen).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const g=await new Promise((h,m)=>{Y(["native-keymap"],h,m)}).then(Ie);this.c=p(g),n.$u||g.onDidChangeKeyboardLayout(()=>{this.c=p(g),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$Pfc=I,e.$Pfc=I=Ee([se(0,T.$ffc)],I);function p(a){const g=a.getKeyMap(),h=a.getCurrentKeyboardLayout();return{keyboardMapping:g,keyboardLayoutInfo:h}}}),define(le[253],ue([0,1,213,8,16,15,12,17,38,100,5,56,212,250]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=void 0,e.$cs=v;let f=class extends h.$5p{constructor($,P,S,t){super(t),this.m=$,this.n=P,this.r=S,this.s(),this.B($.onDidChangeConfiguration(u=>{u.affectsConfiguration("http")&&this.s()}))}s(){const $=this.m.getValue("http");this.f=$?.proxy,this.g=!!$?.proxyStrictSSL,this.h=$?.proxyAuthorization}async request($,P){const{f:S,g:t}=this;let u;try{u=await(0,a.$Nm)(this.m,this.r,this.n.args,process.env)}catch(s){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,D.$9)(s)))}const i={...process.env,...u},o=$.agent?$.agent:await(0,m.$as)($.url||"",i,{proxyUrl:S,strictSSL:t});return $.agent=o,$.strictSSL=t,this.h&&($.headers={...$.headers||{},"Proxy-Authorization":this.h}),this.c($.isChromiumNetwork?"electron":"node",$,()=>v($,P))}async resolveProxy($){}async loadCertificates(){return(await new Promise((P,S)=>{Y(["@vscode/proxy-agent"],P,S)}).then(Ie)).loadSystemCertificates({log:this.r})}};e.$bs=f,e.$bs=f=Ee([se(0,I.$9i),se(1,p.$Ki),se(2,g.$9j),se(3,g.$0j)],f);async function d(b){return((0,n.parse)(b.url).protocol==="https:"?await new Promise((S,t)=>{Y(["https"],S,t)}).then(Ie):await new Promise((S,t)=>{Y(["http"],S,t)}).then(Ie)).request}async function v(b,$){return r.Promises.withAsyncBody(async(P,S)=>{const t=(0,n.parse)(b.url),u=b.getRawRequest?b.getRawRequest(b):await d(b),i={hostname:t.hostname,port:t.port?parseInt(t.port):t.protocol==="https:"?443:80,protocol:t.protocol,path:t.path,method:b.type||"GET",headers:b.headers,agent:b.agent,rejectUnauthorized:(0,T.$ig)(b.strictSSL)?b.strictSSL:!0};b.user&&b.password&&(i.auth=b.user+":"+b.password);const o=u(i,s=>{const c=(0,T.$gg)(b.followRedirects)?b.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&c>0&&s.headers.location)v({...b,url:s.headers.location,followRedirects:c-1},$).then(P,S);else{let l=s;!b.isChromiumNetwork&&s.headers["content-encoding"]==="gzip"&&(l=s.pipe((0,w.createGunzip)())),P({res:s,stream:(0,E.$1e)(l)})}});o.on("error",S),b.timeout&&o.setTimeout(b.timeout),b.isChromiumNetwork&&o.removeHeader("Content-Length"),b.data&&typeof b.data=="string"&&o.write(b.data),o.end(),$.onCancellationRequested(()=>{o.abort(),S(new D.$4)})})}}),define(le[254],ue([0,1,13,253]),function(Y,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tgc=void 0;function E(T){return n.net.request}class D extends r.$bs{request(I,p){return super.request({...I||{},getRawRequest:E,isChromiumNetwork:!0},p)}}e.$Tgc=D}),define(le[87],ue([0,1,7,4,2,38,14,6,19,5,62,247,42,58,41,11]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=e.$nfc=e.$mfc=e.$lfc=void 0,e.$lfc=(0,I.$Ci)("storageMainService");let v=class extends E.$Tc{constructor(P,S,t,u,i,o){super(),this.c=P,this.f=S,this.g=t,this.h=u,this.j=i,this.m=o,this.a=void 0,this.b=this.B(new r.$je),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(p.LifecycleMainPhase.AfterWindowOpen),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(P=>{P.window.profile&&this.profileStorage(P.window.profile).init(),P.workspace&&this.workspaceStorage(P.workspace).init()})),this.B(this.h.onWillShutdown(P=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=P.reason,P.join("applicationStorage",this.applicationStorage.close());for(const[,S]of this.t)P.join("profileStorage",S.close());for(const[,S]of this.w)P.join("workspaceStorage",S.close())})),this.B(this.g.onWillCreateProfile(P=>{P.join((async()=>{await this.j.exists(P.profile.globalStorageHome)||await this.j.createFolder(P.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(P=>{const S=this.t.get(P.profile.id);S&&P.join(S.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const P=new h.$ifc(this.n(),this.g,this.c,this.j);return this.B(r.Event.once(P.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),P}profileStorage(P){if((0,g.$hq)(P))return this.applicationStorage;let S=this.t.get(P.id);if(!S){this.c.trace(`StorageMainService: creating profile storage (${P.name})`),S=this.B(this.u(P)),this.t.set(P.id,S);const t=this.B(S.onDidChangeStorage(u=>this.b.fire({...u,storage:S,profile:P})));this.B(r.Event.once(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${P.name})`),this.t.delete(P.id),t.dispose()}))}return S}u(P){return this.a===p.ShutdownReason.KILL?new h.$kfc(this.c,this.j):new h.$hfc(P,this.n(),this.c,this.j)}workspaceStorage(P){let S=this.w.get(P.id);return S||(this.c.trace(`StorageMainService: creating workspace storage (${P.id})`),S=this.B(this.y(P)),this.w.set(P.id,S),this.B(r.Event.once(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${P.id})`),this.w.delete(P.id)}))),S}y(P){return this.a===p.ShutdownReason.KILL?new h.$kfc(this.c,this.j):new h.$jfc(P,this.n(),this.c,this.f,this.j)}isUsed(P){const S=n.URI.file(P);for(const t of[this.applicationStorage,...this.t.values(),...this.w.values()])if(t.path&&this.m.extUri.isEqualOrParent(n.URI.file(t.path),S))return!0;return!1}};e.$mfc=v,e.$mfc=v=Ee([se(0,a.$9j),se(1,D.$Ji),se(2,w.$2ec),se(3,p.$ffc),se(4,T.$9k),se(5,f.$Gl)],v),e.$nfc=(0,I.$Ci)("applicationStorageMainService");let b=class extends g.$gq{constructor(P,S){super(),this.s=P,this.U=S,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(P){if(P===g.StorageScope.APPLICATION)return this.U.applicationStorage.storage}Q(P){if(P===g.StorageScope.APPLICATION)return this.s.defaultProfile.globalStorageHome.with({scheme:d.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$ofc=b,e.$ofc=b=Ee([se(0,m.$Il),se(1,e.$lfc)],b)}),define(le[255],ue([0,1,93,27,113,104,8,2,3,17,5,28,206,209,101,131,16]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w,f,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sgc=e.$Rgc=e.$Qgc=e.$Pgc=void 0,n=Ie(n),r=Ie(r);async function b(u,i,o,s,c){let l;for(let k=3;k&&(l?.dispose(),l=await new $(u,i,o,s,c).waitForReady(),!(c&&E.$2g[c]||!E.$2g[l.tunnelLocalPort]));k--);return l}class $ extends I.$Tc{constructor(i,o,s,c,l){super(),this.m=o,this.n=l,this.privacy=d.TunnelPrivacyId.Private,this.j=new Map,this.a=i,this.b=n.createServer(),this.c=new T.$Bh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=k=>this.r(k),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=c,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(o=>{o()})}async waitForReady(){const i=this.n??this.tunnelRemotePort,o=(0,d.$Hw)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,E.$3g)(i,2,1e3,o),c=null;return this.b.listen(s,this.m),await this.c.wait(),c=this.b.address(),c||(s=0,this.b.listen(s,this.m),await this.c.wait(),c=this.b.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async r(i){i.pause();const o=(0,d.$Fw)(this.tunnelRemoteHost)||(0,d.$Hw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,m.$Yl)(this.a,o,this.tunnelRemotePort),c=s.getSocket(),l=s.readEntireBuffer();s.dispose(),l.byteLength>0&&i.write(l.buffer),i.on("end",()=>{i.localAddress&&this.j.delete(i.localAddress),c.end()}),i.on("close",()=>c.end()),i.on("error",()=>{i.localAddress&&this.j.delete(i.localAddress),c instanceof D.$ri?c.socket.destroy():c.end()}),c instanceof D.$ri?this.t(i,c):this.s(i,c),i.localAddress&&this.j.set(i.localAddress,()=>{i.end(),c.end()})}s(i,o){o.onClose(()=>i.destroy()),o.onEnd(()=>i.end()),o.onData(s=>i.write(s.buffer)),i.on("data",s=>o.write(v.$Le.wrap(s))),i.resume()}t(i,o){const s=o.socket;s.on("end",()=>i.end()),s.on("close",()=>i.end()),s.on("error",()=>{i.destroy()}),s.pipe(i),i.pipe(s)}}e.$Pgc=$;let P=class extends d.$Kw{constructor(i,o,s,c,l){super(o,l),this.H=i,this.I=s,this.J=c}isPortPrivileged(i){return(0,d.$Iw)(i,this.t,p.OS,r.release())}F(i,o,s,c,l,k,y,R){const L=this.D(o,s);if(L)return++L.refcount,L.value;if((0,d.$Bw)(i))return this.G(i,o,s,l,k,y,R);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${o}:${s} on local port ${l}.`);const A={commit:this.J.commit,quality:this.J.quality,addressProvider:i,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},O=b(A,c,o,s,l);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(o,s,O),O}}};e.$Qgc=P,e.$Qgc=P=Ee([se(0,w.$Sl),se(1,g.$9j),se(2,f.$Vl),se(3,h.$pk),se(4,a.$9i)],P);let S=class extends P{constructor(i,o,s,c,l){super(i,o,s,c,l)}};e.$Rgc=S,e.$Rgc=S=Ee([se(0,w.$Sl),se(1,g.$9j),se(2,f.$Vl),se(3,h.$pk),se(4,a.$9i)],S);let t=class extends I.$Tc{constructor(i,o,s,c,l){super(),this.b=i,this.c=o,this.f=s,this.g=c,this.h=l,this.a=new Map}async openTunnel(i,o,s,c,l,k,y,R,L){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${c} on local port ${k}.`),!this.a.has(i)){const A=new S(this.b,this.c,this.g,this.f,this.h);this.B(A),this.a.set(i,A),A.onTunnelClosed(async()=>{(await A.tunnels).length===0&&(A.dispose(),this.a.delete(i))})}return this.a.get(i).openTunnel(o,s,c,l,k,y,R,L)}};e.$Sgc=t,e.$Sgc=t=Ee([se(0,w.$Sl),se(1,g.$9j),se(2,h.$pk),se(3,f.$Vl),se(4,a.$9i)],t)}),define(le[105],ue([0,1,8,21,4,17,22,19,5,28,56,49]),function(Y,e,n,r,E,D,T,I,p,a,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$agc=void 0,e.$_fc=m;function m(f,d,v){return`${v.updateUrl}/api/update/${f}/${d}/${v.commit}`}let w=class{get state(){return this.b}d(d){this.j.info("update#setState",d.type),this.b=d,this.c.fire(d)}constructor(d,v,b,$,P,S){this.f=d,this.g=v,this.h=b,this.i=$,this.j=P,this.k=S,this.b=h.$vY.Uninitialized,this.c=new E.$je,this.onStateChange=this.c.event,d.when(I.LifecycleMainPhase.AfterWindowOpen).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(h.$vY.Disabled(h.DisablementReason.NotBuilt));return}if(this.h.disableUpdates){this.d(h.$vY.Disabled(h.DisablementReason.DisabledByEnvironment)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(h.$vY.Disabled(h.DisablementReason.MissingConfiguration)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const d=this.g.getValue("update.mode"),v=this.m(d);if(!v){this.d(h.$vY.Disabled(h.DisablementReason.ManuallyDisabled)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(v),!this.a){this.d(h.$vY.Disabled(h.DisablementReason.InvalidConfiguration)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const b=new URL(this.a);b.searchParams.set("prss","true"),this.a=b.toString()}if(this.d(h.$vY.Idle(this.q())),d==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}d==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,b=>this.j.error(b))}m(d){return d==="none"?void 0:this.k.quality}n(d=60*60*1e3){return(0,n.$Dh)(d).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(d){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===h.StateType.Idle&&this.t(d)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===h.StateType.AvailableForDownload&&await this.o(this.state)}async o(d){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type===h.StateType.Downloaded&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==h.StateType.Ready||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(d=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${d}`),!d&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},r.CancellationToken.None)).res.statusCode===204}catch(v){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(v);return}}async _applySpecificUpdate(d){}q(){return h.UpdateType.Archive}r(){}};e.$agc=w,e.$agc=w=Ee([se(0,I.$ffc),se(1,D.$9i),se(2,T.$Nec),se(3,g.$4p),se(4,p.$9j),se(5,a.$pk)],w)}),define(le[256],ue([0,1,13,53,4,46,2,17,22,19,5,28,56,24,49,105]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bgc=void 0,n=Ie(n);let v=class extends d.$agc{get v(){return E.Event.fromNodeEventEmitter(n.autoUpdater,"error",($,P)=>P)}get w(){return E.Event.fromNodeEventEmitter(n.autoUpdater,"update-not-available")}get x(){return E.Event.fromNodeEventEmitter(n.autoUpdater,"update-available")}get y(){return E.Event.fromNodeEventEmitter(n.autoUpdater,"update-downloaded",($,P,S,t)=>({version:S,productVersion:S,timestamp:t}))}constructor($,P,S,t,u,i,o){super($,P,t,u,i,o),this.z=S,this.u=new T.$Sc,$.setRelaunchHandler(this)}handleRelaunch($){return $?.addArgs||$?.removeArgs||this.state.type!==f.StateType.Ready?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B($){this.z.publicLog2("update:error",{messageHash:String((0,D.$qj)(String($)))}),this.j.error("UpdateService error:",$);const P=this.state.type===f.StateType.CheckingForUpdates&&this.state.explicit?$:void 0;this.d(f.$vY.Idle(f.UpdateType.Archive,P))}s($){let P;this.k.darwinUniversalAssetId?P=this.k.darwinUniversalAssetId:P=process.arch==="x64"?"darwin":"darwin-arm64";const S=(0,d.$_fc)(P,$,this.k);try{n.autoUpdater.setFeedURL({url:S})}catch(t){this.j.error("Failed to set update feed URL",t);return}return S}t($){this.d(f.$vY.CheckingForUpdates($)),n.autoUpdater.checkForUpdates()}E(){this.state.type===f.StateType.CheckingForUpdates&&this.d(f.$vY.Downloading)}F($){this.state.type===f.StateType.Downloading&&(this.d(f.$vY.Downloaded($)),this.z.publicLog2("update:downloaded",{version:$.version}),this.d(f.$vY.Ready($)))}G(){this.state.type===f.StateType.CheckingForUpdates&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(f.$vY.Idle(f.UpdateType.Archive)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),n.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$bgc=v,Ee([r.$7h],v.prototype,"v",null),Ee([r.$7h],v.prototype,"w",null),Ee([r.$7h],v.prototype,"x",null),Ee([r.$7h],v.prototype,"y",null),e.$bgc=v=Ee([se(0,a.$ffc),se(1,I.$9i),se(2,w.$8l),se(3,p.$Nec),se(4,m.$4p),se(5,g.$9j),se(6,h.$pk)],v)}),define(le[257],ue([0,1,48,26,8,4,9,22,19,5,24,49]),function(Y,e,n,r,E,D,T,I,p,a,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dgc=void 0,T=Ie(T);let m=class{get state(){return this.a}d(d){this.g.info("update#setState",d.type),this.a=d,this.b.fire(d)}constructor(d,v,b){if(this.f=d,this.g=b,this.a=h.$vY.Uninitialized,this.b=new D.$je,this.onStateChange=this.b.event,v.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(h.$vY.Idle(this.k())),this.h(30*1e3).then(void 0,$=>this.g.error($))}h(d=60*60*1e3){return(0,E.$Dh)(d).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(d){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===h.StateType.Idle&&this.m(d)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===h.StateType.AvailableForDownload&&await this.i(this.state)}i(d){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type===h.StateType.Downloaded&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==h.StateType.Ready||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(d=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${d}`),!d&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return h.UpdateType.Snap}l(){}async _applySpecificUpdate(d){}};m=Ee([se(0,p.$ffc),se(1,I.$Nec),se(2,a.$9j)],m);let w=class extends m{constructor(d,v,b,$,P,S){super(b,$,P),this.o=d,this.p=v,this.q=S;const t=(0,r.watch)(T.$lc(this.o)),u=D.Event.fromNodeEventEmitter(t,"change",(c,l)=>l),i=D.Event.filter(u,c=>c==="current"),s=D.Event.debounce(i,(c,l)=>l,2e3)(()=>this.checkForUpdates(!1));b.onWillShutdown(()=>{s.dispose(),t.close()})}m(){this.d(h.$vY.CheckingForUpdates(!1)),this.u().then(d=>{d?this.d(h.$vY.Ready({version:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(h.$vY.Idle(h.UpdateType.Snap)))},d=>{this.g.error(d),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(h.$vY.Idle(h.UpdateType.Snap,d.message||d))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,n.spawn)("sleep 3 && "+T.$mc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const d=await new Promise((b,$)=>(0,r.realpath)(`${T.$lc(this.o)}/current`,(P,S)=>P?$(P):b(S))),v=T.$mc(d);return this.p!==v}isLatestVersion(){return this.u().then(void 0,d=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$dgc=w,e.$dgc=w=Ee([se(2,p.$ffc),se(3,I.$Nec),se(4,a.$9j),se(5,g.$8l)],w)}),define(le[29],ue([0,1,13,3,6,51,50,76,28,17,22,9,139]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.$Yec=void 0,e.$Zec=f,e.$1ec=d,e.$Yec=(0,E.$Ci)("windowsMainService");var w;(function(b){b[b.CLI=0]="CLI",b[b.DOCK=1]="DOCK",b[b.MENU=2]="MENU",b[b.DIALOG=3]="DIALOG",b[b.DESKTOP=4]="DESKTOP",b[b.API=5]="API"})(w||(e.OpenContext=w={}));function f(b,$,P){const S=b.get(I.$Wec),t=b.get(p.$pk),u=b.get(a.$9i),i=b.get(g.$Nec),o=u.getValue("window"),s={backgroundColor:S.getBackgroundColor(),minWidth:T.$VD.WIDTH,minHeight:T.$VD.HEIGHT,title:t.nameLong,show:$.mode!==D.WindowMode.Maximized&&$.mode!==D.WindowMode.Fullscreen,x:$.x,y:$.y,width:$.width,height:$.height,webPreferences:{...P,enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,T.$8D)($.zoomLevel??o?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};if(r.$l?s.icon=(0,h.$ic)(i.appRoot,"resources/linux/code.png"):r.$j&&!i.isBuilt&&(s.icon=(0,h.$ic)(i.appRoot,"resources/win32/code_150x150.png")),r.$k&&(s.acceptFirstMouse=!0,o?.clickThroughInactive===!1&&(s.acceptFirstMouse=!1)),r.$k&&!(0,T.$7D)(u)&&(s.fullscreenable=!1),r.$k&&o?.nativeTabs===!0&&(s.tabbingIdentifier=t.nameShort),!(0,T.$3D)(u)&&(s.titleBarStyle="hidden",r.$k||(s.frame=!1),(0,T.$6D)(u))){const k=S.getWindowSplash()?.colorInfo.titleBarBackground??S.getBackgroundColor(),y=m.$ju.fromHex(k).isDarker()?"#FFFFFF":"#000000";s.titleBarOverlay={height:29,color:k,symbolColor:y}}return s}function d(b){let $,P=Number.MIN_VALUE;for(const S of b)S.lastFocusTime>P&&(P=S.lastFocusTime,$=S);return $}var v;(function(b){function $(S,t,u=n.screen.getAllDisplays()){if(S.trace(`window#validateWindowState: validating window state on ${u.length} display(s)`,t),typeof t.x!="number"||typeof t.y!="number"||typeof t.width!="number"||typeof t.height!="number"){S.trace("window#validateWindowState: unexpected type of state values");return}if(t.width<=0||t.height<=0){S.trace("window#validateWindowState: unexpected negative values");return}if(u.length===1){const s=P(u[0]);if(S.trace("window#validateWindowState: single monitor working area",s),s){let c=function(){!t||typeof t.x!="number"||typeof t.y!="number"||!s||(t.x<s.x&&(t.x=s.x),t.y<s.y&&(t.y=s.y))};c(),t.width>s.width&&(t.width=s.width),t.height>s.height&&(t.height=s.height),t.x>s.x+s.width-128&&(t.x=s.x+s.width-t.width),t.y>s.y+s.height-128&&(t.y=s.y+s.height-t.height),c()}return t}if(t.display&&t.mode===D.WindowMode.Fullscreen){const s=u.find(c=>c.id===t.display);if(s&&typeof s.bounds?.x=="number"&&typeof s.bounds?.y=="number"){S.trace("window#validateWindowState: restoring fullscreen to previous display");const c=(0,D.$Lec)(D.WindowMode.Fullscreen);return c.x=s.bounds.x,c.y=s.bounds.y,c}}let i,o;try{i=n.screen.getDisplayMatching({x:t.x,y:t.y,width:t.width,height:t.height}),o=P(i),S.trace("window#validateWindowState: multi-monitor working area",o)}catch(s){S.error("window#validateWindowState: error finding display for window state",s)}if(i&&o&&t.x+t.width>o.x&&t.y+t.height>o.y&&t.x<o.x+o.width&&t.y<o.y+o.height)return t;S.trace("window#validateWindowState: state is outside of the multi-monitor working area")}b.validateWindowState=$;function P(S){if(S.workArea.width>0&&S.workArea.height>0)return S.workArea;if(S.bounds.width>0&&S.bounds.height>0)return S.bounds}})(v||(e.WindowStateValidator=v={}))}),define(le[258],ue([0,1,13,21,4,46,2,33,97,5,62,87,29]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pfc=void 0;var w;(function(d){d[d.Initial=1]="Initial",d[d.StoredCredentialsUsed=2]="StoredCredentialsUsed",d[d.LoginDialogShown=3]="LoginDialogShown"})(w||(w={}));let f=class extends T.$Tc{constructor(v,b,$,P){super(),this.g=v,this.h=b,this.j=$,this.m=P,this.a="proxy-credentials://",this.b=void 0,this.c=w.Initial,this.f=void 0,this.n()}n(){const v=E.Event.fromNodeEventEmitter(n.app,"login",(b,$,P,S,t)=>({event:b,webContents:$,req:P,authInfo:S,callback:t}));this.B(v(this.r,this))}async r({event:v,authInfo:b,req:$,callback:P}){if(!b.isProxy)return;if(!this.b&&this.c===w.LoginDialogShown&&$.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}v.preventDefault();let S;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),S=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(b);try{S=await this.b}finally{this.b=void 0}}P(S?.username,S?.password)}async s(v){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const b=await this.t(v);if(b)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),b;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(v){this.g.trace("auth#doResolveProxyCredentials - enter",v);const b=String((0,D.$qj)({scheme:v.scheme,host:v.host,port:v.port}));let $,P;try{const i=this.m.get(this.a+b,g.StorageScope.APPLICATION);if(i){const o=JSON.parse(await this.j.decrypt(i));$=o.username,P=o.password}}catch(i){this.g.error(i)}if(this.c!==w.StoredCredentialsUsed&&typeof $=="string"&&typeof P=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=w.StoredCredentialsUsed,{username:$,password:P};const S=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!S){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${S.id} to handle proxy login`);const t={authInfo:v,username:this.f?.username??$,password:this.f?.password??P,replyChannel:`vscode:proxyAuthResponse:${(0,I.$Yg)()}`};S.sendWhenReady("vscode:openProxyAuthenticationDialog",r.CancellationToken.None,t),this.c=w.LoginDialogShown;const u=await new Promise(i=>{const o=async(s,c,l)=>{if(c===t.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${S.id}`),S.win?.webContents.off("ipc-message",o),l){const k={username:l.username,password:l.password};try{if(l.remember){const y=await this.j.encrypt(JSON.stringify(k));this.m.store(this.a+b,y,g.StorageScope.APPLICATION,g.StorageTarget.MACHINE)}else this.m.remove(this.a+b,g.StorageScope.APPLICATION)}catch(y){this.g.error(y)}i({username:k.username,password:k.password})}else i(void 0)};S.win?.webContents.on("ipc-message",o)});return this.f=u,u}};e.$pfc=f,e.$pfc=f=Ee([se(0,a.$9j),se(1,m.$Yec),se(2,p.$gY),se(3,h.$nfc)],f)}),define(le[259],ue([0,1,93,165,120,29]),function(Y,e,n,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rfc=void 0;class T extends r.$Vo{constructor(p){super(),this.f=p}call(p,a,g){return a==="openExtensionDevelopmentHostWindow"?this.g(g[0],g[1]):super.call(p,a,g)}async g(p,a){const g=(0,E.$zm)(p,E.$ym);g.debugRenderer=a;const h=g.extensionDevelopmentPath;if(!h)return{success:!1};const[m]=await this.f.openExtensionDevelopmentHostWindow(h,{context:D.OpenContext.API,cli:g,forceProfile:g.profile,forceTempProfile:g["profile-temp"]});if(!a)return{success:!0};const w=m.win;if(!w)return{success:!0};const f=w.webContents.debugger;let d=f.isAttached()?1/0:0;const v=(0,n.createServer)(b=>{d++===0&&f.attach();let $=!1;const P=u=>{$||b.write(JSON.stringify(u)+"\0")},S=(u,i,o,s)=>P({method:i,params:o,sessionId:s});w.on("close",()=>{f.removeListener("message",S),b.end(),$=!0}),f.addListener("message",S);let t=Buffer.alloc(0);b.on("data",u=>{t=Buffer.concat([t,u]);for(let i=t.indexOf(0);i!==-1;i=t.indexOf(0)){let o;try{const s=t.slice(0,i).toString("utf8");t=t.slice(i+1),o=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}f.sendCommand(o.method,o.params,o.sessionId).then(s=>P({id:o.id,sessionId:o.sessionId,result:s})).catch(s=>P({id:o.id,sessionId:o.sessionId,error:{code:0,message:s.message}}))}}),b.on("error",u=>{console.error("error on cdp pipe:",u)}),b.on("close",()=>{$=!0,--d===0&&f.detach()})});return await new Promise(b=>v.listen(0,b)),w.on("close",()=>v.close()),{rendererDebugPort:v.address().port,success:!0}}}e.$rfc=T}),define(le[260],ue([0,1,13,20,3,7,23,17,68,6,5,132,29]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sfc=e.$Rfc=e.ID=void 0,e.ID="launchMainService",e.$Rfc=(0,a.$Ci)(e.ID);let w=class{constructor(d,v,b,$){this.a=d,this.b=v,this.c=b,this.d=$}async start(d,v){this.a.trace("Received data from other instance: ",d,v),E.$k&&n.app.focus({steal:!0});const b=this.e(d);if(b.length){let $=Promise.resolve();if(this.b.getWindowCount()===0){const P=(0,r.$Nb)(await this.b.openEmptyWindow({context:m.OpenContext.DESKTOP}));P&&($=P.ready())}$.then(()=>{for(const{uri:P,originalUrl:S}of b)this.c.open(P,{originalUrl:S})})}else return this.f(d,v)}e(d){return d["open-url"]&&d._urls&&d._urls.length>0?(0,r.$Gb)(d._urls.map(v=>{try{return{uri:D.URI.parse(v),originalUrl:v}}catch{return null}})):[]}async f(d,v){const b=(0,p.$Gm)(v)?m.OpenContext.CLI:m.OpenContext.DESKTOP;let $=[];const P=d.wait&&d.waitMarkerFilePath?D.URI.file(d.waitMarkerFilePath):void 0,S=d.remote||void 0,t={context:b,cli:d,userEnv:d["preserve-env"]||b===m.OpenContext.CLI?v:void 0,waitMarkerFileURI:P,remoteAuthority:S,forceProfile:d.profile,forceTempProfile:d["profile-temp"]};if(d.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(d.extensionDevelopmentPath,t);else if(!d._.length&&!d["folder-uri"]&&!d["file-uri"]){let u=!1;if(d["new-window"]||t.forceProfile||t.forceTempProfile)u=!0;else if(d["reuse-window"])u=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":u=!0;break;case"off":u=!1;break;default:u=!E.$k}if(u)$=await this.b.open({...t,forceNewWindow:!0,forceEmpty:!0});else{const i=this.b.getLastActiveWindow();i?(this.b.openExistingWindow(i,t),$=[i]):$=await this.b.open({...t,forceEmpty:!0})}}else $=await this.b.open({...t,forceNewWindow:d["new-window"],preferNewWindow:!d["reuse-window"]&&!d.wait,forceReuseWindow:d["reuse-window"],diffMode:d.diff,mergeMode:d.merge,addMode:d.add,noRecentEntry:!!d["skip-add-to-recently-opened"],gotoLineMode:d.goto});if(P&&$.length===1&&$[0])return Promise.race([$[0].whenClosedOrLoaded,(0,T.whenDeleted)(P.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$Sfc=w,e.$Sfc=w=Ee([se(0,g.$9j),se(1,m.$Yec),se(2,h.$mY),se(3,I.$9i)],w)}),define(le[261],ue([0,1,2,19,51,58,30,8,29]),function(Y,e,n,r,E,D,T,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=void 0;let a=class extends n.$Tc{constructor(h,m,w){super(),this.a=m,this.b=w,this.B(h.onWillLoadWindow(f=>{f.reason===E.LoadReason.LOAD&&this.c(f.window)})),this.B(h.onBeforeCloseWindow(f=>this.c(f))),this.B(new I.$Oh(()=>this.g(),30*1e3)).schedule()}async c(h){const m=this.f(h),w=this.a.getProfileForWorkspace(m);w?.isTransient&&(this.a.unsetWorkspace(m,w.isTransient),w.isTransient&&await this.a.cleanUpTransientProfiles())}f(h){return h.openedWorkspace??(0,T.$Qi)(h.backupPath,h.isExtensionDevelopmentHost)}g(){const h=this.a.getAssociatedEmptyWindows();if(h.length===0)return;const m=this.b.getWindows().map(w=>this.f(w));for(const w of h)m.some(f=>f.id===w.id)||this.a.unsetWorkspace(w,!1)}};e.$vgc=a,e.$vgc=a=Ee([se(0,r.$ffc),se(1,D.$2ec),se(2,p.$Yec)],a)});var et=this&&this.__importDefault||function(Y){return Y&&Y.__esModule?Y:{default:Y}};define(le[63],ue([0,1,13,2,4,5,281,8,11,29,81,24,19,79,37,3,106]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w,f,d,v){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$tfc=e.$sfc=void 0,g=et(g);function $(t){return typeof t.responseWindowId=="number"}let P=class extends r.$Tc{static{b=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(b.b.values())}constructor(u,i,o){super(),this.w=u,this.y=i,this.z=o,this.c=String(++b.a),this.f=this.B(new E.$je),this.onStdout=this.f.event,this.g=this.B(new E.$je),this.onStderr=this.g.event,this.h=this.B(new E.$je),this.onMessage=this.h.event,this.j=this.B(new E.$je),this.onSpawn=this.j.event,this.m=this.B(new E.$je),this.onExit=this.m.event,this.n=this.B(new E.$je),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0,this.u=!1}C(u,i){let o;switch(this.t?.correlationId?o=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${u}`:o=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${u}`,i){case g.default.Error:this.w.error(o);break;case g.default.Warning:this.w.warn(o);break;case g.default.Info:this.w.trace(o);break}}D(){return this.r?(this.C("Cannot start utility process because it is already running...",g.default.Error),!1):!0}start(u){const i=this.F(u);return i&&u.payload&&this.postMessage(u.payload)&&this.C("payload sent via postMessage()",g.default.Info),i}F(u){if(!this.D())return!1;this.t=u;const i=`${this.t.type}-${this.c}`,o=p.$Wg.asFileUri("bootstrap-fork.js").fsPath,s=this.t.args??[],c=this.t.execArgv??[],l=this.t.allowLoadingUnsignedLibraries,k=this.t.forceAllocationsToV8Sandbox,y="pipe",R=this.G(u);return this.C("creating new...",g.default.Info),this.r=n.utilityProcess.fork(o,s,{serviceName:i,env:R,execArgv:c,allowLoadingUnsignedLibraries:l,forceAllocationsToV8Sandbox:k,stdio:y}),this.H(this.r,this.t,i),!0}G(u){const i=u.env?{...u.env}:{...(0,f.$ao)(process.env)};i.VSCODE_AMD_ENTRYPOINT=u.entryPoint,typeof u.parentLifecycleBound=="number"&&(i.VSCODE_PARENT_PID=String(u.parentLifecycleBound)),i.VSCODE_CRASH_REPORTER_PROCESS_TYPE=u.type,d.$j&&((0,v.isUNCAccessRestrictionsDisabled)()?i.NODE_DISABLE_UNC_ACCESS_CHECKS="1":i.NODE_UNC_HOST_ALLOWLIST=(0,v.getUNCHostAllowlist)().join("\\")),(0,w.$im)(i);for(const o of Object.keys(i))i[o]=String(i[o]);return i}H(u,i,o){if(u.stdout){const s=new T.StringDecoder("utf-8");this.B(E.Event.fromNodeEventEmitter(u.stdout,"data")(c=>this.f.fire(typeof c=="string"?c:s.write(c))))}if(u.stderr){const s=new T.StringDecoder("utf-8");this.B(E.Event.fromNodeEventEmitter(u.stderr,"data")(c=>this.g.fire(typeof c=="string"?c:s.write(c))))}this.B(E.Event.fromNodeEventEmitter(u,"message")(s=>this.h.fire(s))),this.B(E.Event.fromNodeEventEmitter(u,"spawn")(()=>{this.s=u.pid,typeof u.pid=="number"&&b.b.set(u.pid,{pid:u.pid,name:$(i)?`${i.type} [${i.responseWindowId}]`:i.type}),this.C("successfully created",g.default.Info),this.j.fire(u.pid)})),this.B(E.Event.fromNodeEventEmitter(u,"exit")(s=>{const c=this.I(s)?0:s;this.C(`received exit event with code ${c}`,g.default.Info),this.m.fire({pid:this.s,code:c,signal:"unknown"}),this.J()})),this.B(E.Event.fromNodeEventEmitter(n.app,"child-process-gone",(s,c)=>({event:s,details:c}))(({details:s})=>{s.type==="Utility"&&s.name===o&&!this.I(s.exitCode)&&(this.C(`crashed with code ${s.exitCode} and reason '${s.reason}'`,g.default.Error),this.y.publicLog2("utilityprocesscrash",{type:i.type,reason:s.reason,code:s.exitCode}),this.n.fire({pid:this.s,code:s.exitCode,reason:s.reason}),this.J())}))}once(u,i){const o=this.B(this.h.event(s=>{s===u&&(o.dispose(),i())}))}postMessage(u,i){return this.r?(this.r.postMessage(u,i),!0):!1}connect(u){const{port1:i,port2:o}=new n.MessageChannelMain;return this.postMessage(u,[o]),i}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.C("enabling inspect port",g.default.Info);const u=process;return typeof u._debugProcess=="function"?(u._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.C("attempting to kill the process...",g.default.Info),this.r.kill()?(this.C("successfully killed the process",g.default.Info),this.u=!0,this.J()):this.C("unable to kill the process",g.default.Warning)}I(u){return u===0?!0:this.u&&u===15}J(){typeof this.s=="number"&&b.b.delete(this.s),this.r=void 0}async waitForExit(u){this.r&&(this.C("waiting to exit...",g.default.Info),await Promise.race([E.Event.toPromise(this.onExit),(0,I.$Dh)(u)]),this.r&&(this.C(`did not exit within ${u}ms, will kill it now...`,g.default.Info),this.kill()))}};e.$sfc=P,e.$sfc=P=b=Ee([se(0,D.$9j),se(1,h.$8l),se(2,m.$ffc)],P);let S=class extends P{constructor(u,i,o,s){super(u,o,s),this.L=i}start(u){const i=this.L.getWindowById(u.responseWindowId);if(!i?.win||i.win.isDestroyed()||i.win.webContents.isDestroyed())return this.C("Refusing to start utility process because requesting window cannot be found or is destroyed...",g.default.Error),!0;if(!super.F(u))return!1;this.M(i.win,u);const s=this.connect(u.payload);return i.win.webContents.postMessage(u.responseChannel,u.responseNonce,[s]),!0}M(u,i){i.windowLifecycleBound&&(this.B(E.Event.filter(this.z.onWillLoadWindow,o=>o.window.win===u)(()=>this.kill())),this.B(E.Event.fromNodeEventEmitter(u,"closed")(()=>this.kill())))}};e.$tfc=S,e.$tfc=S=Ee([se(0,D.$9j),se(1,a.$Yec),se(2,h.$8l),se(3,m.$ffc)],S)}),define(le[262],ue([0,1,8,15,4,2,19,5,24,63,29]),function(Y,e,n,r,E,D,T,I,p,a,g){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=void 0;let m=class extends D.$Tc{static{h=this}static{this.a=0}constructor(f,d,v,b){super(),this.f=f,this.g=d,this.h=v,this.j=b,this.b=new Map,this.c=!1,this.B(this.g.onWillShutdown($=>{this.c=!0,$.join("extHostStarter",this._waitForAllExit(6e3))}))}dispose(){super.dispose()}m(f){const d=this.b.get(f);if(!d)throw new Error("Unknown extension host!");return d}onDynamicStdout(f){return this.m(f).onStdout}onDynamicStderr(f){return this.m(f).onStderr}onDynamicMessage(f){return this.m(f).onMessage}onDynamicExit(f){return this.m(f).onExit}async createExtensionHost(){if(this.c)throw(0,r.$5)();const f=String(++h.a),d=new a.$tfc(this.f,this.h,this.j,this.g);this.b.set(f,d);const v=d.onExit(({pid:b,code:$,signal:P})=>{v.dispose(),this.f.info(`Extension host with pid ${b} exited with code: ${$}, signal: ${P}.`),setTimeout(()=>{d.dispose(),this.b.delete(f)}),setTimeout(()=>{try{process.kill(b,0),this.f.error(`Extension host with pid ${b} still exists, forcefully killing it...`),process.kill(b)}catch{}},1e3)});return{id:f}}async start(f,d){if(this.c)throw(0,r.$5)();const v=this.m(f);return v.start({...d,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:d.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:f}),{pid:await E.Event.toPromise(v.onSpawn)}}async enableInspectPort(f){if(this.c)throw(0,r.$5)();const d=this.b.get(f);return d?d.enableInspectPort():!1}async kill(f){if(this.c)throw(0,r.$5)();const d=this.b.get(f);d&&d.kill()}async _killAllNow(){for(const[,f]of this.b)f.kill()}async _waitForAllExit(f){const d=[];for(const[,v]of this.b)d.push(v.waitForExit(f));return n.Promises.settled(d).then(()=>{})}};e.$Afc=m,e.$Afc=m=h=Ee([se(0,I.$9j),se(1,T.$ffc),se(2,g.$Yec),se(3,p.$8l)],m)}),define(le[263],ue([0,1,35,8,2,22,19,5,42,40,71,63,57,95,12,214,4]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w,f,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=void 0;let b=class extends E.$Tc{constructor(P,S,t,u,i,o,s,c,l){super(),this.g=P,this.h=S,this.j=t,this.m=u,this.n=i,this.r=o,this.s=s,this.t=c,this.u=l,this.a=new r.$Bh,this.b=void 0,this.c=void 0,this.f=this.B(new v.$je),this.onDidCrash=this.f.event,this.C=void 0,this.D=void 0,this.w()}w(){n.$xX.on(d.$4fc.request,(P,S)=>this.y(P,S,d.$4fc.response)),n.$xX.on(d.$5fc.request,(P,S)=>this.y(P,S,d.$5fc.response)),this.B(this.r.onWillShutdown(()=>this.z()))}async y(P,S,t){this.s.trace(`[SharedProcess] onWindowConnection for: ${t}`),this.a.isOpen()||this.a.open(),await this.whenReady();const u=await this.connect(t);if(P.sender.isDestroyed())return u.close();P.sender.postMessage(t,S,[u])}z(){this.s.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(d.$3fc.exit),this.b=void 0}whenReady(){return this.C||(this.C=(async()=>{await this.F;const P=new r.$Zh;this.b?.once(d.$3fc.initDone,()=>P.complete()),await P.p,this.c?.dispose(),this.s.trace("[SharedProcess] Overall ready")})()),this.C}get F(){return this.D||(this.D=(async()=>{await this.a.wait(),this.G();const P=new r.$Zh;this.b?.once(d.$3fc.ipcReady,()=>P.complete()),await P.p,this.s.trace("[SharedProcess] IPC ready")})()),this.D}G(){this.b=this.B(new h.$sfc(this.s,m.$vp,this.r)),this.c=this.b.onMessage(t=>{typeof t.warning=="string"?this.s.warn(t.warning):typeof t.error=="string"&&this.s.error(t.error)});const P=(0,w.$7m)(this.m.args,this.m.isBuilt);let S;P.port&&(S=["--nolazy"],P.break?S.push(`--inspect-brk=${P.port}`):S.push(`--inspect=${P.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.H(),execArgv:S}),this.B(this.b.onCrash(()=>this.f.fire()))}H(){return{machineId:this.g,sqmId:this.h,devDeviceId:this.j,codeCachePath:this.m.codeCachePath,profiles:{home:this.n.profilesHome,all:this.n.profiles},args:this.m.args,logLevel:this.t.getLogLevel(),loggers:this.t.getRegisteredLoggers(),policiesData:this.u.serialize()}}async connect(P){return await this.F,(0,f.$ng)(this.b).connect(P)}};e.$6fc=b,e.$6fc=b=Ee([se(3,D.$Nec),se(4,p.$Il),se(5,T.$ffc),se(6,I.$9j),se(7,g.$afc),se(8,a.$po)],b)}),define(le[264],ue([0,1,22,95,19,5,57,75,63,118,35,2,4,37,17,11]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hgc=void 0;let v=class extends h.$Tc{constructor($,P,S,t,u){super(),this.f=$,this.g=P,this.h=S,this.j=t,this.m=u,this.a=void 0,this.b=new m.$je,this.onRequestConnection=this.b.event,this.c=new m.$je,this.onWillShutdown=this.c.event,this.B(this.j.onWillShutdown(()=>this.c.fire())),g.$xX.on("vscode:createPtyHostMessageChannel",(i,o)=>this.r(i,o)),this.B((0,h.$Rc)(()=>{g.$xX.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new p.$sfc(this.m,T.$vp,this.j);const $=(0,r.$6m)(this.h.args,this.h.isBuilt),P=$.port?["--nolazy",`--inspect${$.break?"-brk":""}=${$.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:P,args:["--logsPath",this.h.logsHome.with({scheme:d.Schemas.file}).fsPath],env:this.n()});const S=this.a.connect(),t=new a.$FX(S,"ptyHost"),u=new h.$Sc;return u.add(t),u.add((0,h.$Rc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:t,store:u,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const $={...(0,w.$ao)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},P=this.g.getValue(I.TerminalSettingId.DeveloperPtyHostLatency);P&&typeof P=="number"&&($.VSCODE_LATENCY=String(P));const S=this.g.getValue(I.TerminalSettingId.DeveloperPtyHostStartupDelay);return S&&typeof S=="number"&&($.VSCODE_STARTUP_DELAY=String(S)),this.h.restoreSnapExportedVariables(),$}r($,P){this.b.fire();const S=this.a.connect();if($.sender.isDestroyed()){S.close();return}$.sender.postMessage("vscode:createPtyHostMessageChannelResult",P,[S])}};e.$Hgc=v,e.$Hgc=v=Ee([se(1,f.$9i),se(2,n.$Nec),se(3,E.$ffc),se(4,D.$9j)],v)}),define(le[265],ue([0,1,2,6,5,29,63,24,46,4,8,19]),function(Y,e,n,r,E,D,T,I,p,a,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ggc=e.$Fgc=void 0,e.$Fgc=(0,r.$Ci)("utilityProcessWorker");let m=class extends n.$Tc{constructor(d,v,b,$){super(),this.b=d,this.c=v,this.f=b,this.g=$,this.a=new Map}async createWorker(d){const v=`window: ${d.reply.windowId}, moduleId: ${d.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${v})`);const b=this.h(d);this.a.has(b)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${v})`),this.disposeWorker(d));const $=new w(this.b,this.c,this.f,this.g,d);if(!$.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(b,$);const P=new g.$Zh;return a.Event.once($.onDidTerminate)(S=>{S.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${S.code}, signal: ${S.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${S.code}, signal: ${S.signal}`),this.a.delete(b),P.complete({reason:S})}),P.p}h(d){return(0,p.$qj)({moduleId:d.process.moduleId,windowId:d.reply.windowId})}async disposeWorker(d){const v=this.h(d),b=this.a.get(v);b&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${d.reply.windowId}, moduleId: ${d.process.moduleId})`),b.kill(),b.dispose(),this.a.delete(v))}};e.$Ggc=m,e.$Ggc=m=Ee([se(0,E.$9j),se(1,D.$Yec),se(2,I.$8l),se(3,h.$ffc)],m);let w=class extends n.$Tc{constructor(d,v,b,$,P){super(),this.c=d,this.f=v,this.g=b,this.h=$,this.j=P,this.a=this.B(new a.$je),this.onDidTerminate=this.a.event,this.b=this.B(new T.$tfc(this.c,this.f,this.g,this.h)),this.m()}m(){this.B(this.b.onExit(d=>this.a.fire({code:d.code,signal:d.signal}))),this.B(this.b.onCrash(d=>this.a.fire({code:d.code,signal:"ECRASH"})))}spawn(){const v=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:v,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};w=Ee([se(0,E.$9j),se(1,D.$Yec),se(2,I.$8l),se(3,h.$ffc)],w)}),define(le[266],ue([0,1,13,4,2,239,29]),function(Y,e,n,r,E,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lgc=void 0;let I=class extends E.$Tc{constructor(a){super(),this.b=a,this.a=this.B(new r.$je),this.onFoundInFrame=this.a.event,this.B(new D.$kgc)}async setIgnoreMenuShortcuts(a,g){let h;if(typeof a.windowId=="number"){const{windowId:m}=a,w=this.b.getWindowById(m);if(!w?.win)throw new Error(`Invalid windowId: ${m}`);h=w.win.webContents}else{const{webContentsId:m}=a;if(h=n.webContents.fromId(m),!h)throw new Error(`Invalid webContentsId: ${m}`)}h.isDestroyed()||h.setIgnoreMenuShortcuts(g)}async findInFrame(a,g,h,m){const f=this.c(a,g);if(typeof f.findInFrame=="function"){f.findInFrame(h,{findNext:m.findNext,forward:m.forward});const d=(v,b)=>{b.finalUpdate&&(this.a.fire(b),f.removeListener("found-in-frame",d))};f.on("found-in-frame",d)}}async stopFindInFrame(a,g,h){const w=this.c(a,g);typeof w.stopFindInFrame=="function"&&w.stopFindInFrame(h.keepSelection?"keepSelection":"clearSelection")}c(a,g){const h=this.b.getWindowById(a.windowId);if(!h?.win)throw new Error(`Invalid windowId: ${a}`);const m=h.win.webContents.mainFrame.framesInSubtree.find(w=>w.name===g);if(!m)throw new Error(`Unknown frame: ${g}`);return m}};e.$lgc=I,e.$lgc=I=Ee([se(0,T.$Yec)],I)}),define(le[267],ue([0,1,13,2,3,18,7,17,19,5,34,29,51,30]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$mgc=void 0,e.$ngc=v,e.$ogc=$;let d=class extends r.$Tc{static{f=this}static{this.a="windowsState"}get state(){return this.b}constructor(t,u,i,o,s){super(),this.g=t,this.h=u,this.j=i,this.m=o,this.n=s,this.b=v(this.h.getItem(f.a)),this.c=void 0,this.f=!1,this.r()}r(){n.app.on("browser-window-blur",()=>{this.f||this.t()}),this.B(this.j.onBeforeCloseWindow(t=>this.u(t))),this.B(this.j.onBeforeShutdown(()=>this.s())),this.B(this.g.onDidChangeWindowsCount(t=>{t.newCount-t.oldCount>0&&(this.c=void 0)})),this.B(this.g.onDidDestroyWindow(t=>this.u(t)))}s(){this.f=!0,this.t()}t(){const t=new Set,u={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!u.lastActiveWindow){let s=this.g.getLastActiveWindow();(!s||s.isExtensionDevelopmentHost)&&(s=this.g.getWindows().find(c=>!c.isExtensionDevelopmentHost)),s&&(u.lastActiveWindow=this.w(s),u.lastActiveWindow.uiState.mode===m.WindowMode.Fullscreen&&t.add(u.lastActiveWindow.uiState.display))}const i=this.g.getWindows().find(s=>s.isExtensionDevelopmentHost&&!s.isExtensionTestHost);i&&(u.lastPluginDevelopmentHostWindow=this.w(i),u.lastPluginDevelopmentHostWindow.uiState.mode===m.WindowMode.Fullscreen&&(t.has(u.lastPluginDevelopmentHostWindow.uiState.display)?E.$k&&!i.win?.isSimpleFullScreen()&&(u.lastPluginDevelopmentHostWindow.uiState.mode=m.WindowMode.Normal):t.add(u.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(u.openedWindows=this.g.getWindows().filter(s=>!s.isExtensionDevelopmentHost).map(s=>{const c=this.w(s);return c.uiState.mode===m.WindowMode.Fullscreen&&(t.has(c.uiState.display)?E.$k&&c.windowId!==u.lastActiveWindow?.windowId&&!s.win?.isSimpleFullScreen()&&(c.uiState.mode=m.WindowMode.Normal):t.add(c.uiState.display)),c}));const o=$(u);this.h.setItem(f.a,o),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",o)}u(t){if(this.j.quitRequested)return;const u=this.w(t);t.isExtensionDevelopmentHost&&!t.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=u:!t.isExtensionDevelopmentHost&&t.openedWorkspace&&this.b.openedWindows.forEach(i=>{const o=(0,w.$Ri)(t.openedWorkspace)&&i.workspace?.id===t.openedWorkspace.id,s=(0,w.$Mi)(t.openedWorkspace)&&i.folderUri&&D.$7g.isEqual(i.folderUri,t.openedWorkspace.uri);(o||s)&&(i.uiState=u.uiState)}),this.g.getWindowCount()===1&&(this.c=u)}w(t){return{windowId:t.id,workspace:(0,w.$Ri)(t.openedWorkspace)?t.openedWorkspace:void 0,folderUri:(0,w.$Mi)(t.openedWorkspace)?t.openedWorkspace.uri:void 0,backupPath:t.backupPath,remoteAuthority:t.remoteAuthority,uiState:t.serializeWindowState()}}getNewWindowState(t){const u=this.z(t),i=this.n.getValue("window");if(u.mode===m.WindowMode.Fullscreen){let o;u.hasDefaultState?o=!!(i?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(i.newWindowDimensions)>=0):o=!!(this.j.wasRestarted||i?.restoreFullscreen),o||(u.mode=m.WindowMode.Normal)}return u}z(t){const u=this.g.getLastActiveWindow();if(!t.extensionTestsPath){if(t.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const k=t.workspace;if((0,w.$Ri)(k)){const R=this.state.openedWindows.filter(L=>L.workspace&&L.workspace.id===k.id).map(L=>L.uiState);if(R.length)return R[0]}if((0,w.$Mi)(k)){const R=this.state.openedWindows.filter(L=>L.folderUri&&D.$7g.isEqual(L.folderUri,k.uri)).map(L=>L.uiState);if(R.length)return R[0]}else if(t.backupPath){const R=this.state.openedWindows.filter(L=>L.backupPath===t.backupPath).map(L=>L.uiState);if(R.length)return R[0]}const y=this.c||this.state.lastActiveWindow;if(!u&&y)return y.uiState}let i;const o=n.screen.getAllDisplays();if(o.length===1)i=o[0];else{if(E.$k){const k=n.screen.getCursorScreenPoint();i=n.screen.getDisplayNearestPoint(k)}!i&&u&&(i=n.screen.getDisplayMatching(u.getBounds())),i||(i=n.screen.getPrimaryDisplay()||o[0])}let s=(0,m.$Lec)();s.x=Math.round(i.bounds.x+i.bounds.width/2-s.width/2),s.y=Math.round(i.bounds.y+i.bounds.height/2-s.height/2);const c=this.n.getValue("window");let l=!0;if(c?.newWindowDimensions){if(c.newWindowDimensions==="maximized")s.mode=m.WindowMode.Maximized,l=!1;else if(c.newWindowDimensions==="fullscreen")s.mode=m.WindowMode.Fullscreen,l=!1;else if((c.newWindowDimensions==="inherit"||c.newWindowDimensions==="offset")&&u){const k=u.serializeWindowState();k.mode===m.WindowMode.Fullscreen?s.mode=m.WindowMode.Fullscreen:s={...k,zoomLevel:void 0},l=s.mode!==m.WindowMode.Fullscreen&&c.newWindowDimensions==="offset"}}return l&&(s=this.C(s)),s.hasDefaultState=!0,s}C(t){if(this.g.getWindows().length===0)return t;t.x=typeof t.x=="number"?t.x:0,t.y=typeof t.y=="number"?t.y:0;const u=this.g.getWindows().map(i=>i.getBounds());for(;u.some(i=>i.x===t.x||i.y===t.y);)t.x+=30,t.y+=30;return t}};e.$mgc=d,e.$mgc=d=f=Ee([se(0,h.$Yec),se(1,g.$gR),se(2,p.$ffc),se(3,a.$9j),se(4,I.$9i)],d);function v(S){const t={openedWindows:[]},u=S||{openedWindows:[]};return u.lastActiveWindow&&(t.lastActiveWindow=b(u.lastActiveWindow)),u.lastPluginDevelopmentHostWindow&&(t.lastPluginDevelopmentHostWindow=b(u.lastPluginDevelopmentHostWindow)),Array.isArray(u.openedWindows)&&(t.openedWindows=u.openedWindows.map(i=>b(i))),t}function b(S){const t={uiState:S.uiState};return S.backupPath&&(t.backupPath=S.backupPath),S.remoteAuthority&&(t.remoteAuthority=S.remoteAuthority),S.folder&&(t.folderUri=T.URI.parse(S.folder)),S.workspaceIdentifier&&(t.workspace={id:S.workspaceIdentifier.id,configPath:T.URI.parse(S.workspaceIdentifier.configURIPath)}),t}function $(S){return{lastActiveWindow:S.lastActiveWindow&&P(S.lastActiveWindow),lastPluginDevelopmentHostWindow:S.lastPluginDevelopmentHostWindow&&P(S.lastPluginDevelopmentHostWindow),openedWindows:S.openedWindows.map(t=>P(t))}}function P(S){return{workspaceIdentifier:S.workspace&&{id:S.workspace.id,configURIPath:S.workspace.configPath.toString()},folder:S.folderUri&&S.folderUri.toString(),backupPath:S.backupPath,remoteAuthority:S.remoteAuthority,uiState:S.uiState}}}),define(le[59],ue([0,1,26,13,4,43,2,11,9,18,23,10,69,52,22,6,5,58,134,30,102,103]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w,f,d,v,b,$,P,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ec=e.$$ec=void 0,n=Ie(n),e.$$ec=(0,d.$Ci)("workspacesManagementMainService");let u=class extends T.$Tc{constructor(o,s,c,l,k){super(),this.g=o,this.h=s,this.j=c,this.m=l,this.n=k,this.a=this.B(new E.$je),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new E.$je),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const o=(await g.Promises.readdir(this.c.with({scheme:I.Schemas.file}).fsPath)).map(s=>(0,a.$dh)(this.c,s,P.$2i));for(const s of o){const c=(0,t.$8ec)(s),l=await this.resolveLocalWorkspace(s);l?this.f.push({workspace:c,remoteAuthority:l.remoteAuthority}):await this.deleteUntitledWorkspace(c)}}catch(o){o.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${o}).`)}}resolveLocalWorkspace(o){return this.r(o,s=>n.promises.readFile(s,"utf8"))}r(o,s){if(this.s(o)&&o.scheme===I.Schemas.file)try{const c=s(o.fsPath);return c instanceof Promise?c.then(l=>this.t(o,l),l=>{}):this.t(o,c)}catch{return}}s(o){return(0,P.$3i)(o,this.g)||(0,P.$8i)(o)}t(o,s){try{const c=this.u(o,s),l=(0,t.$8ec)(o);return{id:l.id,configPath:l.configPath,folders:(0,S.$Whb)(c.folders,l.configPath,a.$7g),remoteAuthority:c.remoteAuthority,transient:c.transient}}catch(c){this.h.warn(c.toString())}}u(o,s){const c=(0,D.$Un)(s);if(c&&Array.isArray(c.folders))c.folders=c.folders.filter(l=>(0,S.$Uhb)(l));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return c}async createUntitledWorkspace(o,s){const{workspace:c,storedWorkspace:l}=this.w(o,s),k=c.configPath.fsPath;return await n.promises.mkdir((0,p.$lc)(k),{recursive:!0}),await g.Promises.writeFile(k,JSON.stringify(l,null,"	")),this.f.push({workspace:c,remoteAuthority:s}),c}w(o=[],s){const c=(Date.now()+Math.round(Math.random()*1e3)).toString(),l=(0,a.$dh)(this.c,c),k=(0,a.$dh)(l,P.$2i),y=[];for(const R of o)y.push((0,S.$Vhb)(R.uri,!0,R.name,l,a.$7g));return{workspace:(0,t.$8ec)(k),storedWorkspace:{folders:y,remoteAuthority:s}}}async getWorkspaceIdentifier(o){return(0,t.$8ec)(o)}isUntitledWorkspace(o){return(0,P.$3i)(o.configPath,this.g)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.y(o),this.j.isEnabled()&&this.j.unsetWorkspace(o),this.a.fire(o))}async y(o){const s=(0,a.$4g)(o.configPath);try{await g.Promises.rm((0,p.$lc)(s));const c=(0,p.$ic)(this.g.workspaceStorageHome.with({scheme:I.Schemas.file}).fsPath,o.id);await g.Promises.exists(c)&&await g.Promises.writeFile((0,p.$ic)(c,"obsolete"),""),this.f=this.f.filter(l=>l.workspace.id!==o.id)}catch(c){this.h.warn(`Unable to delete untitled workspace ${s} (${c}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(o,s,c){if(!o||!o.win||!o.isReady||!await this.z(o,s,c))return;const k=await this.C(o,(0,t.$8ec)(c));if(k)return this.b.fire({window:o,workspace:k.workspace}),k}async z(o,s,c){return c?(0,P.$Ri)(o.openedWorkspace)&&a.$7g.isEqual(o.openedWorkspace.configPath,c)?!1:(0,$.$5ec)(s,c)?(await this.n.showMessageBox({type:"info",buttons:[(0,h.localize)(10851,null)],message:(0,h.localize)(10852,null,(0,a.$ah)(c)),detail:(0,h.localize)(10853,null)},r.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(o,s){if(!o.config)return;o.focus();let c;return o.config.extensionDevelopmentPath||(o.config.backupPath?c=await this.m.registerWorkspaceBackup({workspace:s,remoteAuthority:o.remoteAuthority},o.config.backupPath):c=this.m.registerWorkspaceBackup({workspace:s,remoteAuthority:o.remoteAuthority})),(0,P.$Ri)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=s,o.config.backupPath=c,{workspace:s,backupPath:c}}};e.$_ec=u,e.$_ec=u=Ee([se(0,f.$Nec),se(1,v.$9j),se(2,b.$2ec),se(3,m.$Sec),se(4,w.$Tec)],u)}),define(le[135],ue([0,1,13,35,21,6,29,30,59,12,5,63]),function(Y,e,n,r,E,D,T,I,p,a,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wfc=e.$vfc=e.ID=void 0,e.ID="diagnosticsMainService",e.$vfc=(0,D.$Ci)(e.ID);let m=class{constructor(f,d,v){this.a=f,this.b=d,this.c=v}async getRemoteDiagnostics(f){const d=this.a.getWindows();return(await Promise.all(d.map(async b=>{const $=b.remoteAuthority;if(!$)return;const P=`vscode:getDiagnosticInfoResponse${b.id}`,S={includeProcesses:f.includeProcesses,folders:f.includeWorkspaceMetadata?await this.f(b):void 0};return new Promise(t=>{b.sendWhenReady("vscode:getDiagnosticInfo",E.CancellationToken.None,{replyChannel:P,args:S}),r.$xX.once(P,(u,i)=>{i||t({hostName:$,errorMessage:`Unable to resolve connection to '${$}'.`}),t(i)}),setTimeout(()=>{t({hostName:$,errorMessage:`Connection to '${$}' could not be established`})},5e3)})}))).filter(b=>!!b)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const f=[];for(const v of n.BrowserWindow.getAllWindows()){const b=this.a.getWindowById(v.id);b?f.push(await this.d(b)):f.push(this.e(v))}const d=[];for(const{pid:v,name:b}of h.$sfc.getAll())d.push({pid:v,name:b});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:f,pidToNames:d,screenReader:!!n.app.accessibilitySupportEnabled,gpuFeatureStatus:n.app.getGPUFeatureStatus()}}async d(f){const d=await this.f(f),v=(0,a.$ng)(f.win);return this.e(v,d,f.remoteAuthority)}e(f,d=[],v){return{id:f.id,pid:f.webContents.getOSProcessId(),title:f.getTitle(),folderURIs:d,remoteAuthority:v}}async f(f){const d=[],v=f.openedWorkspace;if((0,I.$Mi)(v))d.push(v.uri);else if((0,I.$Ri)(v)){const b=await this.b.resolveLocalWorkspace(v.configPath);b&&b.folders.forEach(P=>{d.push(P.uri)})}return d}};e.$wfc=m,e.$wfc=m=Ee([se(0,T.$Yec),se(1,p.$$ec),se(2,g.$9j)],m)}),define(le[64],ue([0,1,26,48,13,27,152,53,4,2,11,9,3,7,112,92,23,113,10,52,22,6,19,5,28,76,29,30,59,16,210,200,84,15]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w,f,d,v,b,$,P,S,t,u,i,o,s,c,l,k,y,R,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lfc=e.$Kfc=void 0,n=Ie(n),e.$Kfc=(0,t.$Ci)("nativeHostMainService");let W=class extends a.$Tc{constructor(C,B,ee,X,ae,K,te,z,j){super(),this.a=C,this.b=B,this.c=ee,this.f=X,this.g=ae,this.h=K,this.j=te,this.m=z,this.n=j,this.onDidOpenMainWindow=p.Event.map(this.a.onDidOpenWindow,N=>N.id),this.onDidTriggerWindowSystemContextMenu=p.Event.any(p.Event.map(this.a.onDidTriggerSystemContextMenu,({window:N,x:V,y:oe})=>({windowId:N.id,x:V,y:oe})),p.Event.map(this.b.onDidTriggerSystemContextMenu,({window:N,x:V,y:oe})=>({windowId:N.id,x:V,y:oe}))),this.onDidMaximizeWindow=p.Event.any(p.Event.map(this.a.onDidMaximizeWindow,N=>N.id),p.Event.map(this.b.onDidMaximizeWindow,N=>N.id)),this.onDidUnmaximizeWindow=p.Event.any(p.Event.map(this.a.onDidUnmaximizeWindow,N=>N.id),p.Event.map(this.b.onDidUnmaximizeWindow,N=>N.id)),this.onDidChangeWindowFullScreen=p.Event.any(p.Event.map(this.a.onDidChangeFullScreen,N=>({windowId:N.window.id,fullscreen:N.fullscreen})),p.Event.map(this.b.onDidChangeFullScreen,N=>({windowId:N.window.id,fullscreen:N.fullscreen}))),this.onDidBlurMainWindow=p.Event.filter(p.Event.fromNodeEventEmitter(E.app,"browser-window-blur",(N,V)=>V.id),N=>!!this.a.getWindowById(N)),this.onDidFocusMainWindow=p.Event.any(p.Event.map(p.Event.filter(p.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),N=>!!N),N=>N.id),p.Event.filter(p.Event.fromNodeEventEmitter(E.app,"browser-window-focus",(N,V)=>V.id),N=>!!this.a.getWindowById(N))),this.onDidBlurMainOrAuxiliaryWindow=p.Event.any(this.onDidBlurMainWindow,p.Event.map(p.Event.filter(p.Event.fromNodeEventEmitter(E.app,"browser-window-blur",(N,V)=>this.b.getWindowByWebContents(V.webContents)),N=>!!N),N=>N.id)),this.onDidFocusMainOrAuxiliaryWindow=p.Event.any(this.onDidFocusMainWindow,p.Event.map(p.Event.filter(p.Event.fromNodeEventEmitter(E.app,"browser-window-focus",(N,V)=>this.b.getWindowByWebContents(V.webContents)),N=>!!N),N=>N.id)),this.onDidResumeOS=p.Event.fromNodeEventEmitter(E.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.r=this.B(new p.$je),this.onDidChangePassword=this.r.event,this.onDidChangeDisplay=p.Event.debounce(p.Event.any(p.Event.filter(p.Event.fromNodeEventEmitter(E.screen,"display-metrics-changed",(N,V,oe)=>oe),N=>!(Array.isArray(N)&&N.length===1&&N[0]==="workArea")),p.Event.fromNodeEventEmitter(E.screen,"display-added"),p.Event.fromNodeEventEmitter(E.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(C,B){const ee=this.a.getWindows().map(ae=>({id:ae.id,workspace:ae.openedWorkspace??(0,l.$Qi)(ae.backupPath,ae.isExtensionDevelopmentHost),title:ae.win?.getTitle()??"",filename:ae.getRepresentedFilename(),dirty:ae.isDocumentEdited()})),X=[];return B.includeAuxiliaryWindows&&X.push(...this.b.getWindows().map(ae=>({id:ae.id,parentId:ae.parentId,title:ae.win?.getTitle()??"",filename:ae.getRepresentedFilename()}))),[...ee,...X]}async getWindowCount(C){return this.a.getWindowCount()}async getActiveWindowId(C){const B=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(B)return B.id}openWindow(C,B,ee){return Array.isArray(B)?this.s(C,B,ee):this.t(C,B)}async s(C,B,ee=Object.create(null)){B.length>0&&await this.a.open({context:c.OpenContext.API,contextWindowId:C,urisToOpen:B,cli:this.g.args,forceNewWindow:ee.forceNewWindow,forceReuseWindow:ee.forceReuseWindow,preferNewWindow:ee.preferNewWindow,diffMode:ee.diffMode,mergeMode:ee.mergeMode,addMode:ee.addMode,gotoLineMode:ee.gotoLineMode,noRecentEntry:ee.noRecentEntry,waitMarkerFileURI:ee.waitMarkerFileURI,remoteAuthority:ee.remoteAuthority||void 0,forceProfile:ee.forceProfile,forceTempProfile:ee.forceTempProfile})}async t(C,B){await this.a.openEmptyWindow({context:c.OpenContext.API,contextWindowId:C},B)}async isFullScreen(C,B){return this.C(B?.targetWindowId,C)?.isFullScreen??!1}async toggleFullScreen(C,B){this.C(B?.targetWindowId,C)?.toggleFullScreen()}async handleTitleDoubleClick(C,B){this.C(B?.targetWindowId,C)?.handleTitleDoubleClick()}async getCursorScreenPoint(C){const B=E.screen.getCursorScreenPoint(),ee=E.screen.getDisplayNearestPoint(B);return{point:B,display:ee.bounds}}async isMaximized(C,B){return this.C(B?.targetWindowId,C)?.win?.isMaximized()??!1}async maximizeWindow(C,B){this.C(B?.targetWindowId,C)?.win?.maximize()}async unmaximizeWindow(C,B){this.C(B?.targetWindowId,C)?.win?.unmaximize()}async minimizeWindow(C,B){this.C(B?.targetWindowId,C)?.win?.minimize()}async moveWindowTop(C,B){this.C(B?.targetWindowId,C)?.win?.moveTop()}async positionWindow(C,B,ee){const X=this.C(ee?.targetWindowId,C);if(X?.win){if(X.win.isFullScreen()){const ae=p.Event.toPromise(p.Event.once(p.Event.fromNodeEventEmitter(X.win,"leave-full-screen")));X.win.setFullScreen(!1),await ae}X.win.setBounds(B)}}async updateWindowControls(C,B){this.C(B?.targetWindowId,C)?.updateWindowControls(B)}async focusWindow(C,B){this.C(B?.targetWindowId,C)?.focus({force:B?.force??!1})}async setMinimumSize(C,B,ee){const X=this.D(C);if(X?.win){const[ae,K]=X.win.getSize(),[te,z]=X.win.getMinimumSize(),[j,N]=[B??te,ee??z],[V,oe]=[Math.max(ae,j),Math.max(K,N)];(te!==j||z!==N)&&X.win.setMinimumSize(j,N),(ae!==V||K!==oe)&&X.win.setSize(V,oe)}}async saveWindowSplash(C,B){this.m.saveWindowSplash(C,B)}async installShellCommand(C){const{source:B,target:ee}=await this.u();try{const{symbolicLink:X}=await v.SymlinkSupport.stat(B);if(X&&!X.dangling){const ae=await(0,f.$jr)(B);if(ee===ae)return}await n.promises.unlink(B)}catch(X){if(X.code!=="ENOENT")throw X}try{await n.promises.symlink(ee,B)}catch(X){if(X.code!=="EACCES"&&X.code!=="ENOENT")throw X;const{response:ae}=await this.showMessageBox(C,{type:"info",message:(0,$.localize)(11104,null,this.j.nameShort),buttons:[(0,$.localize)(11105,null),(0,$.localize)(11106,null)]});if(ae===1)throw new O.$4;try{const K=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${ee}' '${B}'\\" with administrator privileges"`;await(0,T.promisify)(r.exec)(K)}catch{throw new Error((0,$.localize)(11107,null,B))}}}async uninstallShellCommand(C){const{source:B}=await this.u();try{await n.promises.unlink(B)}catch(ee){switch(ee.code){case"EACCES":{const{response:X}=await this.showMessageBox(C,{type:"info",message:(0,$.localize)(11108,null,this.j.nameShort),buttons:[(0,$.localize)(11109,null),(0,$.localize)(11110,null)]});if(X===1)throw new O.$4;try{const ae=`osascript -e "do shell script \\"rm '${B}'\\" with administrator privileges"`;await(0,T.promisify)(r.exec)(ae)}catch{throw new Error((0,$.localize)(11111,null,B))}break}case"ENOENT":break;default:throw ee}}}async u(){const C=(0,h.$jc)(this.g.appRoot,"bin","code"),B=`/usr/local/bin/${this.j.applicationName}`;if(!await v.Promises.exists(C))throw new Error((0,$.localize)(11112,null,C));return{source:B,target:C}}async showMessageBox(C,B){const ee=this.C(B?.targetWindowId,C);return this.c.showMessageBox(B,ee?.win??void 0)}async showSaveDialog(C,B){const ee=this.C(B?.targetWindowId,C);return this.c.showSaveDialog(B,ee?.win??void 0)}async showOpenDialog(C,B){const ee=this.C(B?.targetWindowId,C);return this.c.showOpenDialog(B,ee?.win??void 0)}async pickFileFolderAndOpen(C,B){const ee=await this.c.pickFileFolder(B);ee&&await this.w(await Promise.all(ee.map(async X=>await v.SymlinkSupport.existsDirectory(X)?{folderUri:w.URI.file(X)}:{fileUri:w.URI.file(X)})),B,C)}async pickFolderAndOpen(C,B){const ee=await this.c.pickFolder(B);ee&&await this.w(ee.map(X=>({folderUri:w.URI.file(X)})),B,C)}async pickFileAndOpen(C,B){const ee=await this.c.pickFile(B);ee&&await this.w(ee.map(X=>({fileUri:w.URI.file(X)})),B,C)}async pickWorkspaceAndOpen(C,B){const ee=await this.c.pickWorkspace(B);ee&&await this.w(ee.map(X=>({workspaceUri:w.URI.file(X)})),B,C)}async w(C,B,ee){await this.a.open({context:c.OpenContext.DIALOG,contextWindowId:ee,cli:this.g.args,urisToOpen:C,forceNewWindow:B.forceNewWindow})}async showItemInFolder(C,B){E.shell.showItemInFolder(B)}async setRepresentedFilename(C,B,ee){this.C(ee?.targetWindowId,C)?.setRepresentedFilename(B)}async setDocumentEdited(C,B,ee){this.C(ee?.targetWindowId,C)?.setDocumentEdited(B)}async openExternal(C,B){return this.g.unsetSnapExportedVariables(),E.shell.openExternal(B),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(C,B){return E.shell.trashItem(B)}async isAdmin(){let C;return m.$j?C=(await new Promise((B,ee)=>{Y(["native-is-elevated"],B,ee)}).then(Ie)).default():C=process.getuid?.()===0,C}async writeElevated(C,B,ee,X){const ae=await new Promise((K,te)=>{Y(["@vscode/sudo-prompt"],K,te)}).then(Ie);return new Promise((K,te)=>{const z=[`"${this.z}"`];X?.unlock&&z.push("--file-chmod"),z.push("--file-write",`"${B.fsPath}"`,`"${ee.fsPath}"`);const j={name:this.j.nameLong.replace("-",""),icns:m.$k&&this.g.isBuilt?(0,h.$ic)((0,h.$lc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};ae.exec(z.join(" "),j,(N,V,oe)=>{V&&this.h.trace(`[sudo-prompt] received stdout: ${V}`),oe&&this.h.trace(`[sudo-prompt] received stderr: ${oe}`),N?te(N):K(void 0)})})}async isRunningUnderARM64Translation(){return m.$l||m.$j?!1:E.app.runningUnderARM64Translation}get z(){return m.$j?this.g.isBuilt?(0,h.$ic)((0,h.$lc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,h.$ic)(this.g.appRoot,"scripts","code-cli.bat"):m.$l?this.g.isBuilt?(0,h.$ic)((0,h.$lc)(process.execPath),"bin",`${this.j.applicationName}`):(0,h.$ic)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,h.$ic)(this.g.appRoot,"bin","code"):(0,h.$ic)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,D.totalmem)(),freemem:(0,D.freemem)(),loadavg:(0,D.loadavg)()}}async getOSProperties(){return{arch:(0,D.arch)(),platform:(0,D.platform)(),release:(0,D.release)(),type:(0,D.type)(),cpus:(0,D.cpus)()}}async getOSVirtualMachineHint(){return d.$On.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return m.$j&&(0,R.$Hfc)()}async getProcessId(C){return this.C(void 0,C)?.win?.webContents.getOSProcessId()}async killProcess(C,B,ee){process.kill(B,ee)}async readClipboardText(C,B){return E.clipboard.readText(B)}async writeClipboardText(C,B,ee){return E.clipboard.writeText(B,ee)}async readClipboardFindText(C){return E.clipboard.readFindText()}async writeClipboardFindText(C,B){return E.clipboard.writeFindText(B)}async writeClipboardBuffer(C,B,ee,X){return E.clipboard.writeBuffer(B,Buffer.from(ee.buffer),X)}async readClipboardBuffer(C,B){return y.$Le.wrap(E.clipboard.readBuffer(B))}async hasClipboard(C,B,ee){return E.clipboard.has(B,ee)}async newWindowTab(){await this.a.open({context:c.OpenContext.API,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){E.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){E.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){E.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){E.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){E.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(C,B){this.D(C)?.updateTouchBar(B)}async notifyReady(C){this.D(C)?.setReady()}async relaunch(C,B){return this.f.relaunch(B)}async reload(C,B){const ee=this.D(C);if(ee){if((0,l.$Ri)(ee.openedWorkspace)){const X=ee.openedWorkspace.configPath;if(X.scheme===g.Schemas.file&&(await this.n.resolveLocalWorkspace(X))?.transient)return this.openWindow(ee.id,{forceReuseWindow:!0})}return this.f.reload(ee,B?.disableExtensions!==void 0?{_:[],"disable-extensions":B.disableExtensions}:void 0)}}async closeWindow(C,B){return this.C(B?.targetWindowId,C)?.win?.close()}async quit(C){const B=this.a.getLastActiveWindow();B?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&B.win?B.win.close():this.f.quit()}async exit(C,B){await this.f.kill(B)}async resolveProxy(C,B){return this.D(C)?.win?.webContents?.session?.resolveProxy(B)}async loadCertificates(C){return(await new Promise((ee,X)=>{Y(["@vscode/proxy-agent"],ee,X)}).then(Ie)).loadSystemCertificates({log:this.h})}findFreePort(C,B,ee,X,ae=1){return(0,b.$1g)(B,ee,X,ae)}async openDevTools(C,B){this.C(B?.targetWindowId,C)?.win?.webContents.openDevTools(B?.mode?{mode:B.mode,activate:B.activate}:void 0)}async toggleDevTools(C,B){this.C(B?.targetWindowId,C)?.win?.webContents.toggleDevTools()}async profileRenderer(C,B,ee){const X=this.D(C);if(!X||!X.win)throw new Error;return await new L.$Ifc(X.win,B,this.h).inspect(ee)}async windowsGetStringRegKey(C,B,ee,X){if(!m.$j)return;const ae=await new Promise((K,te)=>{Y(["@vscode/windows-registry"],K,te)}).then(Ie);try{return ae.GetStringRegKey(B,ee,X)}catch{return}}C(C,B){return this.D(C)??this.F(C)??this.D(B)}D(C){if(typeof C=="number")return this.a.getWindowById(C)}F(C){if(typeof C!="number")return;const B=E.webContents.fromId(C);if(B)return this.b.getWindowByWebContents(B)}};e.$Lfc=W,Ee([I.$7h],W.prototype,"z",null),e.$Lfc=W=Ee([se(0,c.$Yec),se(1,A.$Jfc),se(2,P.$Tec),se(3,u.$ffc),se(4,S.$Nec),se(5,i.$9j),se(6,o.$pk),se(7,s.$Wec),se(8,k.$$ec)],W)});var et=this&&this.__importDefault||function(Y){return Y&&Y.__esModule?Y:{default:Y}};define(le[268],ue([0,1,13,27,8,21,2,11,3,35,10,52,22,5,64,72,73,50,29]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w,f,d,v,b,$){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mfc=void 0,d=et(d);let S=class{static{P=this}static{this.a="#1E1E1E"}constructor(u,i,o,s,c,l,k){this.d=u,this.e=i,this.f=o,this.g=s,this.h=c,this.i=l,this.j=k,this.b=null,this.c=null}async openReporter(u){if(this.b)this.b&&this.k(this.b);else if(this.c=n.BrowserWindow.getFocusedWindow(),this.c){const i=new T.$Sc,o=i.add(this.i.createIPCObjectUrl()),s=this.m(this.c,700,800);this.b=this.l(s,o,{backgroundColor:u.styles.backgroundColor,title:(0,g.localize)(11201,null),zoomLevel:u.zoomLevel,alwaysOnTop:!1},"issue-reporter"),o.update({appRoot:this.e.appRoot,windowId:this.b.id,userEnv:this.d,data:u,disableExtensions:!!this.e.disableExtensions,os:{type:(0,r.type)(),arch:(0,r.arch)(),release:(0,r.release)()},product:d.default,nls:{messages:globalThis._VSCODE_NLS_MESSAGES,language:globalThis._VSCODE_NLS_LANGUAGE}}),this.b.loadURL(I.$Wg.asBrowserUri(`vs/workbench/contrib/issue/electron-sandbox/issueReporter${this.e.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,i.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,i.dispose())})}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.h.reload(this.c.id,{disableExtensions:!0})}catch(u){this.f.error(u)}}async $showConfirmCloseDialog(){if(this.b){const{response:u}=await this.g.showMessageBox({type:"warning",message:(0,g.localize)(11202,null),buttons:[(0,g.localize)(11203,null),(0,g.localize)(11204,null)]},this.b);u===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:u}=await this.g.showMessageBox({type:"warning",message:(0,g.localize)(11205,null),buttons:[(0,g.localize)(11206,null),(0,g.localize)(11207,null)]},this.b);return u===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const u=this.j.getWindowById(this.c.id);if(!u)throw new Error("Window not found");return u}async $sendReporterMenu(u,i){const o=this.issueReporterWindowCheck(),s="vscode:triggerReporterMenu",c=new D.$ue;return o.sendWhenReady(s,c.token,{replyChannel:s,extensionId:u,extensionName:i}),await(0,E.$th)(new Promise(k=>a.$xX.once(`vscode:triggerReporterMenuResponse:${u}`,(y,R)=>k(R))),5e3,()=>{this.f.error(`Error: Extension ${u} timed out waiting for menu response`),c.cancel()})}async $closeReporter(){this.b?.close()}k(u){u.isMinimized()&&u.restore(),u.focus()}l(u,i,o,s){const c=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:u.width,height:u.height,minWidth:300,minHeight:200,x:u.x,y:u.y,title:o.title,backgroundColor:o.backgroundColor||P.a,webPreferences:{preload:I.$Wg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${i.resource.toString()}`],v8CacheOptions:this.e.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,b.$8D)(o.zoomLevel),sandbox:!0},alwaysOnTop:o.alwaysOnTop,experimentalDarkMode:!0});return c.setMenuBarVisibility(!1),c}m(u,i,o){let s;const c=n.screen.getAllDisplays();if(c.length===1)s=c[0];else{if(p.$k){const y=n.screen.getCursorScreenPoint();s=n.screen.getDisplayNearestPoint(y)}!s&&u&&(s=n.screen.getDisplayMatching(u.getBounds())),s||(s=n.screen.getPrimaryDisplay()||c[0])}const l=s.bounds,k={width:i,height:o,x:l.x+l.width/2-i/2,y:l.y+l.height/2-o/2};return l.width>0&&l.height>0&&(k.x<l.x&&(k.x=l.x),k.y<l.y&&(k.y=l.y),k.x>l.x+l.width&&(k.x=l.x),k.y>l.y+l.height&&(k.y=l.y),k.width>l.width&&(k.width=l.width),k.height>l.height&&(k.height=l.height)),k}};e.$Mfc=S,e.$Mfc=S=P=Ee([se(1,m.$Nec),se(2,w.$9j),se(3,h.$Tec),se(4,f.$Kfc),se(5,v.$Vec),se(6,$.$Yec)],S)});var et=this&&this.__importDefault||function(Y){return Y&&Y.__esModule?Y:{default:Y}};define(le[269],ue([0,1,13,32,2,11,3,115,35,10,96,135,52,22,5,64,72,28,73,34,63,50]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w,f,d,v,b,$,P,S,t){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Nfc=void 0,v=et(v);const i="issue.processExplorerWindowState";let o=class{static{u=this}static{this.a="#1E1E1E"}constructor(l,k,y,R,L,A,O,W,x,C){this.d=l,this.f=k,this.g=y,this.h=R,this.i=L,this.j=A,this.k=O,this.l=W,this.m=x,this.n=C,this.b=null,this.c=null,this.o()}o(){p.$xX.on("vscode:listProcesses",async l=>{const k=[];try{k.push({name:(0,a.localize)(11196,null),rootProcess:await(0,I.$Ts)(process.pid)}),(await this.i.getRemoteDiagnostics({includeProcesses:!0})).forEach(R=>{(0,g.$Qm)(R)?k.push({name:R.hostName,rootProcess:R}):R.processes&&k.push({name:R.hostName,rootProcess:R.processes})})}catch(y){this.g.error(`Listing processes failed: ${y}`)}this.s(l,"vscode:listProcessesResponse",k)}),p.$xX.on("vscode:workbenchCommand",(l,k)=>{const{id:y,from:R,args:L}=k;let A;switch(R){case"processExplorer":A=this.c;break;default:throw new Error(`Unexpected command source: ${R}`)}A?.webContents.send("vscode:runAction",{id:y,from:R,args:L})}),p.$xX.on("vscode:closeProcessExplorer",l=>{this.b?.close()}),p.$xX.on("vscode:pidToNameRequest",async l=>{const k=await this.i.getMainDiagnostics(),y=[];for(const R of k.windows)y.push([R.pid,`window [${R.id}] (${R.title})`]);for(const{pid:R,name:L}of S.$sfc.getAll())y.push([R,L]);this.s(l,"vscode:pidToNameResponse",y)})}async openProcessExplorer(l){if(!this.b&&(this.c=n.BrowserWindow.getFocusedWindow(),this.c)){const k=new E.$Sc,y=k.add(this.l.createIPCObjectUrl()),R=this.n.getItem(i,void 0),L=s(R)?R:this.q(this.c,800,500);this.b=this.r(L,y,{backgroundColor:l.styles.backgroundColor,title:(0,a.localize)(11197,null),zoomLevel:l.zoomLevel,alwaysOnTop:!0},"process-explorer"),y.update({appRoot:this.f.appRoot,windowId:this.b.id,userEnv:this.d,data:l,product:v.default,nls:{messages:globalThis._VSCODE_NLS_MESSAGES,language:globalThis._VSCODE_NLS_LANGUAGE}}),this.b.loadURL(D.$Wg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.f.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,k.dispose()}),this.c.on("close",()=>{this.b&&(this.b.close(),this.b=null,k.dispose())});const A=()=>{if(!this.b)return;const O=this.b.getSize(),W=this.b.getPosition();if(!O||!W)return;const x={width:O[0],height:O[1],x:W[0],y:W[1]};this.n.setItem(i,x)};this.b.on("moved",A),this.b.on("resized",A)}this.b&&this.p(this.b)}p(l){l.isMinimized()&&l.restore(),l.focus()}q(l,k,y){let R;const L=n.screen.getAllDisplays();if(L.length===1)R=L[0];else{if(T.$k){const W=n.screen.getCursorScreenPoint();R=n.screen.getDisplayNearestPoint(W)}!R&&l&&(R=n.screen.getDisplayMatching(l.getBounds())),R||(R=n.screen.getPrimaryDisplay()||L[0])}const A=R.bounds,O={width:k,height:y,x:A.x+A.width/2-k/2,y:A.y+A.height/2-y/2};return A.width>0&&A.height>0&&(O.x<A.x&&(O.x=A.x),O.y<A.y&&(O.y=A.y),O.x>A.x+A.width&&(O.x=A.x),O.y>A.y+A.height&&(O.y=A.y),O.width>A.width&&(O.width=A.width),O.height>A.height&&(O.height=A.height)),O}async stopTracing(){if(!this.f.args.trace)return;const l=await n.contentTracing.stopRecording(`${(0,r.$Kg)(this.f.userHome.fsPath,this.m.applicationName)}.trace.txt`);await this.j.showMessageBox({type:"info",message:(0,a.localize)(11198,null),detail:(0,a.localize)(11199,null,l),buttons:[(0,a.localize)(11200,null)]},n.BrowserWindow.getFocusedWindow()??void 0),this.k.showItemInFolder(void 0,l)}async getSystemStatus(){const[l,k]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.h.getDiagnostics(l,k)}async $getSystemInfo(){const[l,k]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.h.getSystemInfo(l,k)}async $getPerformanceInfo(){try{const[l,k]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.h.getPerformanceInfo(l,k)}catch(l){throw this.g.warn("issueService#getPerformanceInfo ",l.message),l}}r(l,k,y,R){const L=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:l.width,height:l.height,minWidth:300,minHeight:200,x:l.x,y:l.y,title:y.title,backgroundColor:y.backgroundColor||u.a,webPreferences:{preload:D.$Wg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${k.resource.toString()}`],v8CacheOptions:this.f.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,t.$8D)(y.zoomLevel),sandbox:!0},alwaysOnTop:y.alwaysOnTop,experimentalDarkMode:!0});return L.setMenuBarVisibility(!1),L}s(l,k,...y){l.sender.isDestroyed()||l.sender.send(k,...y)}async closeProcessExplorer(){this.b?.close()}};e.$Nfc=o,e.$Nfc=o=u=Ee([se(1,w.$Nec),se(2,f.$9j),se(3,g.$Pm),se(4,h.$vfc),se(5,m.$Tec),se(6,d.$Kfc),se(7,$.$Vec),se(8,b.$pk),se(9,P.$gR)],o);function s(c){return typeof c!="object"||c===null?!1:"x"in c&&"y"in c&&"width"in c&&"height"in c}}),define(le[270],ue([0,1,21,17,22,19,5,64,28,56,24,49,105]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=void 0;let w=class extends m.$agc{constructor(d,v,b,$,P,S,t,u){super(d,v,$,P,S,u),this.e=b,this.u=t}s(d){return(0,m.$_fc)(`linux-${process.arch}`,d,this.k)}t(d){this.a&&(this.d(h.$vY.CheckingForUpdates(d)),this.i.request({url:this.a},n.CancellationToken.None).then(a.$0p).then(v=>{!v||!v.url||!v.version||!v.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!d}),this.d(h.$vY.Idle(h.UpdateType.Archive))):this.d(h.$vY.AvailableForDownload(v))}).then(void 0,v=>{this.j.error(v);const b=d?v.message||v:void 0;this.d(h.$vY.Idle(h.UpdateType.Archive,b))}))}async o(d){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):d.update.url&&this.u.openExternal(void 0,d.update.url),this.d(h.$vY.Idle(h.UpdateType.Archive))}};e.$cgc=w,e.$cgc=w=Ee([se(0,D.$ffc),se(1,r.$9i),se(2,g.$8l),se(3,E.$Nec),se(4,a.$4p),se(5,T.$9j),se(6,I.$Kfc),se(7,p.$pk)],w)}),define(le[271],ue([0,1,48,26,27,8,21,53,46,9,7,150,23,17,22,14,19,5,64,28,56,24,49,105]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w,f,d,v,b,$,P,S,t,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$egc=void 0,r=Ie(r),a=Ie(a),m=Ie(m);async function o(k,y=1e3){for(;!k();)await(0,D.$Dh)(y)}let s;function c(){return typeof s>"u"&&(s=r.existsSync(a.$ic(a.$lc(process.execPath),"unins000.exe"))?u.UpdateType.Setup:u.UpdateType.Archive),s}let l=class extends i.$agc{get cachePath(){const y=a.$ic((0,E.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return r.promises.mkdir(y,{recursive:!0}).then(()=>y)}constructor(y,R,L,A,O,W,x,C,B){super(y,R,A,O,W,B),this.u=L,this.v=x,this.w=C,y.setRelaunchHandler(this)}handleRelaunch(y){return y?.addArgs||y?.removeArgs||this.state.type!==u.StateType.Ready||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(u.$vY.Disabled(u.DisablementReason.RunningAsAdmin)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(y){let R=`win32-${process.arch}`;return c()===u.UpdateType.Archive?R+="-archive":this.k.target==="user"&&(R+="-user"),(0,i.$_fc)(R,y,this.k)}t(y){this.a&&(this.d(u.$vY.CheckingForUpdates(y)),this.i.request({url:this.a},T.CancellationToken.None).then(S.$0p).then(R=>{const L=c();return!R||!R.url||!R.version||!R.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!y}),this.d(u.$vY.Idle(L)),Promise.resolve(null)):L===u.UpdateType.Archive?(this.d(u.$vY.AvailableForDownload(R)),Promise.resolve(null)):(this.d(u.$vY.Downloading),this.C(R.version).then(()=>this.B(R.version).then(A=>m.Promises.exists(A).then(O=>{if(O)return Promise.resolve(A);const W=`${A}.tmp`;return this.i.request({url:R.url},T.CancellationToken.None).then(x=>this.v.writeFile(g.URI.file(W),x.stream)).then(R.sha256hash?()=>(0,h.$qX)(W,R.sha256hash):()=>{}).then(()=>m.Promises.rename(W,A,!1)).then(()=>A)})).then(A=>{this.e={packagePath:A},this.d(u.$vY.Downloaded(R)),this.g.getValue("update.enableWindowsBackgroundUpdates")?this.k.target==="user"&&this.p():this.d(u.$vY.Ready(R))})))}).then(void 0,R=>{this.u.publicLog2("update:error",{messageHash:String((0,p.$qj)(String(R)))}),this.j.error(R);const L=y?R.message||R:void 0;this.d(u.$vY.Idle(c(),L))}))}async o(y){y.update.url&&this.w.openExternal(void 0,y.update.url),this.d(u.$vY.Idle(c()))}async B(y){const R=await this.cachePath;return a.$ic(R,`CodeSetup-${this.k.quality}-${y}.exe`)}async C(y=null){const R=y?W=>!new RegExp(`${this.k.quality}-${y}\\.exe$`).test(W):()=>!0,L=await this.cachePath,O=(await m.Promises.readdir(L)).filter(R).map(async W=>{try{await r.promises.unlink(a.$ic(L,W))}catch{}});await Promise.all(O)}async p(){if(this.state.type!==u.StateType.Downloaded||!this.e)return Promise.resolve(void 0);const y=this.state.update;this.d(u.$vY.Updating(y));const R=await this.cachePath;this.e.updateFilePath=a.$ic(R,`CodeSetup-${this.k.quality}-${y.version}.flag`),await m.Promises.writeFile(this.e.updateFilePath,"flag"),(0,n.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(u.$vY.Idle(c()))});const A=`${this.k.win32MutexName}-ready`,O=await new Promise((W,x)=>{Y(["@vscode/windows-mutex"],W,x)}).then(Ie);o(()=>O.isActive(A)).then(()=>this.d(u.$vY.Ready(y)))}r(){this.state.type!==u.StateType.Ready||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?r.unlinkSync(this.e.updateFilePath):(0,n.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return c()}async _applySpecificUpdate(y){if(this.state.type!==u.StateType.Idle)return;const R=this.g.getValue("update.enableWindowsBackgroundUpdates"),L={version:"unknown",productVersion:"unknown"};this.d(u.$vY.Downloading),this.e={packagePath:y},this.d(u.$vY.Downloaded(L)),R?this.k.target==="user"&&this.p():this.d(u.$vY.Ready(L))}};e.$egc=l,Ee([I.$7h],l.prototype,"cachePath",null),e.$egc=l=Ee([se(0,v.$ffc),se(1,w.$9i),se(2,t.$8l),se(3,f.$Nec),se(4,S.$4p),se(5,b.$9j),se(6,d.$9k),se(7,$.$Kfc),se(8,P.$pk)],l)}),define(le[136],ue([0,1,13,8,21,54,4,2,11,70,3,7,10,27,69,17,52,22,68,14,19,5,28,73,246,87,24,110,76,50,29,30,59,51,40,34,58,71,20,6]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w,f,d,v,b,$,P,S,t,u,i,o,s,c,l,k,y,R,L,A,O,W,x,C,B,ee,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=e.$cfc=void 0;var ae;(function(z){z[z.NONE=0]="NONE",z[z.NAVIGATING=1]="NAVIGATING",z[z.READY=2]="READY"})(ae||(ae={}));class K extends I.$Tc{get lastFocusTime(){return this.j}get win(){return this.m}n(j){this.m=j,this.B(T.Event.fromNodeEventEmitter(j,"maximize")(()=>this.b.fire())),this.B(T.Event.fromNodeEventEmitter(j,"unmaximize")(()=>this.c.fire())),this.B(T.Event.fromNodeEventEmitter(j,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(T.Event.fromNodeEventEmitter(j,"focus")(()=>{this.j=Date.now()})),this.B(T.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(T.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const N=!(0,y.$3D)(this.r);if(g.$k&&N&&j.setSheetOffset((0,g.$K)((0,w.release)())?28:22),N&&(g.$j&&(0,y.$6D)(this.r)||g.$k)){const V=this.s.getItem(K.D);V?this.updateWindowControls({height:V}):this.updateWindowControls({height:y.$5D})}g.$j&&N&&j.hookWindowMessage(278,()=>{const[oe,G]=j.getPosition(),he=n.screen.getCursorScreenPoint(),re=he.x-oe,_=he.y-G;return!(re>30&&_>=0&&_<=Math.max(j.getBounds().height*.15,35))||(j.setEnabled(!1),j.setEnabled(!0),this.f.fire({x:re,y:_})),0}),this.t.args["open-devtools"]===!0&&j.webContents.openDevTools(),g.$k&&(this.B(this.onDidEnterFullScreen(()=>{this.H?.complete(!0)})),this.B(this.onDidLeaveFullScreen(()=>{this.H?.complete(!0)})))}constructor(j,N,V,oe){super(),this.r=j,this.s=N,this.t=V,this.u=oe,this.a=this.B(new T.$je),this.onDidClose=this.a.event,this.b=this.B(new T.$je),this.onDidMaximize=this.b.event,this.c=this.B(new T.$je),this.onDidUnmaximize=this.c.event,this.f=this.B(new T.$je),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new T.$je),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new T.$je),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.F=(0,y.$6D)(this.r),this.G=void 0,this.H=void 0}w(j,N=n.screen.getAllDisplays().length>0){const V=this.r.getValue("window"),oe=g.$k&&V?.nativeTabs===!0;(g.$k||g.$j)&&N&&(!oe||n.BrowserWindow.getAllWindows().length===1)&&[j.width,j.height,j.x,j.y].every(G=>typeof G=="number")&&this.m?.setBounds({width:j.width,height:j.height,x:j.x,y:j.y}),(j.mode===O.WindowMode.Maximized||j.mode===O.WindowMode.Fullscreen)&&(this.m?.maximize(),j.mode===O.WindowMode.Fullscreen&&this.I(!0,!0),this.m?.show())}setRepresentedFilename(j){g.$k?this.win?.setRepresentedFilename(j):this.z=j}getRepresentedFilename(){return g.$k?this.win?.getRepresentedFilename():this.z}setDocumentEdited(j){g.$k&&this.win?.setDocumentEdited(j),this.C=j}isDocumentEdited(){return g.$k?!!this.win?.isDocumentEdited():!!this.C}focus(j){g.$k&&j?.force&&n.app.focus({steal:!0});const N=this.win;N&&(N.isMinimized()&&N.restore(),N.focus())}handleTitleDoubleClick(){const j=this.win;if(j)if(g.$k)switch(n.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":j.minimize();break;case"None":break;case"Maximize":default:j.isMaximized()?j.unmaximize():j.maximize()}else j.isMaximized()?j.unmaximize():j.maximize()}static{this.D="windowControlHeight"}updateWindowControls(j){const N=this.win;if(N){if(j.height&&this.s.setItem(te.D,j.height),g.$j&&this.F)N.setTitleBarOverlay({color:j.backgroundColor?.trim()===""?void 0:j.backgroundColor,symbolColor:j.foregroundColor?.trim()===""?void 0:j.foregroundColor,height:j.height?j.height-1:void 0});else if(g.$k&&j.height!==void 0){const V=(j.height-15)/2;V?N.setWindowButtonPosition({x:V,y:V}):N.setWindowButtonPosition(null)}}}toggleFullScreen(){this.I(!this.isFullScreen,!1)}I(j,N){(0,y.$7D)(this.r)?this.J(j,N):this.M(j)}get isFullScreen(){if(g.$k&&typeof this.G=="boolean")return this.G;const j=this.win,N=j?.isFullScreen(),V=j?.isSimpleFullScreen();return!!(N||V)}J(j,N){const V=this.win;V?.isSimpleFullScreen()&&V?.setSimpleFullScreen(!1),this.L(j,N)}L(j,N){if(g.$k){this.G=j;const oe=this.H=new r.$Zh;(async()=>{const G=await Promise.race([oe.p,(0,r.$Dh)(1e4).then(()=>!1)]);this.H===oe&&(this.G=void 0,this.H=void 0,!G&&j&&N&&this.win&&!this.win.isFullScreen()&&(this.u.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this.h.fire()))})()}this.win?.setFullScreen(j)}M(j){const N=this.win;N?.isFullScreen()&&this.L(!1,!1),N?.setSimpleFullScreen(j),N?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$cfc=K;let te=class extends K{get id(){return this.Q}get backupPath(){return this.S?.backupPath}get openedWorkspace(){return this.S?.workspace}get profile(){if(!this.config)return;const j=this.hb.profiles.find(N=>N.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&j?j:this.hb.getProfileForWorkspace(this.config.workspace??(0,L.$Qi)(this.backupPath,this.isExtensionDevelopmentHost))??this.hb.defaultProfile}get remoteAuthority(){return this.S?.remoteAuthority}get config(){return this.S}get isExtensionDevelopmentHost(){return!!this.S?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.S?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.S?.debugId}constructor(j,N,V,oe,G,he,re,_,M,F,U,q,Q,J,H,ne,de,me,we,Re,ke){super(F,Re,oe,N),this.fb=V,this.gb=G,this.hb=he,this.ib=re,this.jb=_,this.kb=M,this.lb=U,this.mb=q,this.nb=Q,this.ob=J,this.pb=H,this.qb=ne,this.rb=de,this.sb=me,this.tb=we,this.N=this.B(new T.$je),this.onWillLoad=this.N.event,this.O=this.B(new T.$je),this.onDidSignalReady=this.O.event,this.P=this.B(new T.$je),this.onDidDestroy=this.P.event,this.X=[],this.Y=[],this.Z=void 0,this.$=void 0,this.ab=void 0,this.bb=this.B(this.sb.createIPCObjectUrl()),this.eb=!1,this.ub=ae.NONE;{const[Pe,De]=this.Eb(j.state);this.U=Pe,this.u.trace("window#ctor: using window state",Pe);const $e=ke.invokeFunction(R.$Zec,this.U,{preload:p.$Wg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.bb.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"});(0,a.mark)("code/willCreateCodeBrowserWindow"),this.m=new n.BrowserWindow($e),(0,a.mark)("code/didCreateCodeBrowserWindow"),this.Q=this.m.id,this.n(this.m),this.w(this.U,De),this.j=Date.now()}this.Bb(),this.Kb(),this.vb()}setReady(){for(this.u.trace(`window#load: window reported ready (id: ${this.Q})`),this.ub=ae.READY;this.X.length;)this.X.pop()(this);this.O.fire()}ready(){return new Promise(j=>{if(this.isReady)return j(this);this.X.push(j)})}get isReady(){return this.ub===ae.READY}get whenClosedOrLoaded(){return new Promise(j=>{function N(){V.dispose(),oe.dispose(),j()}const V=this.onDidClose(()=>N()),oe=this.onWillLoad(()=>N())})}vb(){this.B(T.Event.fromNodeEventEmitter(this.m,"unresponsive")(()=>this.yb(O.WindowError.UNRESPONSIVE))),this.B(T.Event.fromNodeEventEmitter(this.m.webContents,"render-process-gone",(N,V)=>V)(N=>this.yb(O.WindowError.PROCESS_GONE,{...N}))),this.B(T.Event.fromNodeEventEmitter(this.m.webContents,"did-fail-load",(N,V,oe)=>({exitCode:V,reason:oe}))(({exitCode:N,reason:V})=>this.yb(O.WindowError.LOAD,{reason:V,exitCode:N}))),this.B(T.Event.fromNodeEventEmitter(this.m.webContents,"will-prevent-unload")(N=>N.preventDefault())),this.B(T.Event.fromNodeEventEmitter(this.m.webContents,"did-finish-load")(()=>{this.db&&(this.S=this.db,this.db=void 0)})),this.B(this.onDidMaximize(()=>{this.S&&(this.S.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.S&&(this.S.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",E.CancellationToken.None)})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",E.CancellationToken.None)})),this.B(this.r.onDidChangeConfiguration(N=>this.Bb(N))),this.B(this.mb.onDidDeleteUntitledWorkspace(N=>this.Ab(N)));const j=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:j},async(N,V)=>{const oe=await this.xb();V({cancel:!1,requestHeaders:Object.assign(N.requestHeaders,oe)})})}xb(){return this.wb||(this.wb=(0,o.$lq)(this.rb.version,this.rb,this.t,this.r,this.ib,this.jb,this.ob)),this.wb}async yb(j,N){switch(j){case O.WindowError.PROCESS_GONE:this.u.error(`CodeWindow: renderer process gone (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break;case O.WindowError.UNRESPONSIVE:this.u.error("CodeWindow: detected unresponsive");break;case O.WindowError.LOAD:this.u.error(`CodeWindow: failed to load (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break}switch(this.ob.publicLog2("windowerror",{type:j,reason:N?.reason,code:N?.exitCode}),j){case O.WindowError.UNRESPONSIVE:case O.WindowError.PROCESS_GONE:if(this.isExtensionDevelopmentTestFromCli){this.qb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.zb(!1,!1),this.qb.quit();return}if(j===O.WindowError.UNRESPONSIVE){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:V,checkboxChecked:oe}=await this.pb.showMessageBox({type:"warning",buttons:[(0,m.localize)(10876,null),(0,m.localize)(10877,null),(0,m.localize)(10878,null)],message:(0,m.localize)(10879,null),detail:(0,m.localize)(10880,null),checkboxLabel:this.S?.workspace?(0,m.localize)(10881,null):void 0},this.m);if(V!==2){const G=V===0;await this.zb(G,oe)}}else if(j===O.WindowError.PROCESS_GONE){let V;N?V=(0,m.localize)(10883,null,N.reason,N.exitCode??"<unknown>"):V=(0,m.localize)(10882,null);const{response:oe,checkboxChecked:G}=await this.pb.showMessageBox({type:"warning",buttons:[this.S?.workspace?(0,m.localize)(10884,null):(0,m.localize)(10885,null),(0,m.localize)(10886,null)],message:V,detail:this.S?.workspace?(0,m.localize)(10887,null):(0,m.localize)(10888,null),checkboxLabel:this.S?.workspace?(0,m.localize)(10889,null):void 0},this.m),he=oe===0;await this.zb(he,G)}break}}async zb(j,N){const V=this.S?.workspace;if(N&&V)try{const oe=this.kb.workspaceStorage(V);await oe.init(),oe.delete("memento/workbench.parts.editor"),await oe.close()}catch(oe){this.u.error(oe)}this.P.fire();try{if(j&&this.S){let oe,G;(0,L.$Mi)(V)?oe={folderUri:V.uri}:(0,L.$Ri)(V)?oe={workspaceUri:V.configPath}:G=!0,(0,ee.$Nb)(await this.tb.open({context:R.OpenContext.API,userEnv:this.S.userEnv,cli:{...this.t.args,_:[]},urisToOpen:oe?[oe]:void 0,forceEmpty:G,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}Ab(j){this.S?.workspace?.id===j.id&&(this.S.workspace=void 0)}Bb(j){if(!j||j.affectsConfiguration("window.menuBarVisibility")){const N=this.Gb();N!==this.W&&(this.W=N,this.Hb(N))}if(!j||j.affectsConfiguration("http.proxy")||j.affectsConfiguration("http.noProxy")){let N=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;N?.endsWith("/")&&(N=N.substr(0,N.length-1));const V=(this.r.getValue("http.noProxy")||[]).map(oe=>oe.trim()).join(",")||(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((N||"").indexOf("@")===-1&&(N!==this.Z||V!==this.$)){this.Z=N,this.$=V;const oe=N||"",G=V?`${V},<local>`:"<local>";this.u.trace(`Setting proxy to '${oe}', bypassing '${G}'`),this.m.webContents.session.setProxy({proxyRules:oe,proxyBypassRules:G,pacScript:""}),typeof n.app.setProxy=="function"&&n.app.setProxy({proxyRules:oe,proxyBypassRules:G,pacScript:""})}}}addTabbedWindow(j){g.$k&&j.win&&this.m.addTabbedWindow(j.win)}load(j,N=Object.create(null)){this.u.trace(`window#load: attempt to load window (id: ${this.Q})`),this.isDocumentEdited()&&(!N.isReload||!this.nb.isHotExitEnabled())&&this.setDocumentEdited(!1),N.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.rb.nameLong)),this.Cb(j,N),this.ub===ae.NONE?this.S=j:this.db=j,this.ub=ae.NAVIGATING,this.m.loadURL(p.$Wg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.html`).toString(!0));const V=this.eb;this.eb=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new r.$Oh(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.N.fire({workspace:j.workspace,reason:N.isReload?O.LoadReason.RELOAD:V?O.LoadReason.LOAD:O.LoadReason.INITIAL})}Cb(j,N){const V=(this.S??this.db)?.userEnv;if(V){const oe=(0,$.$Gm)(V)&&!(0,$.$Gm)(j.userEnv),G=this.isExtensionDevelopmentHost;(oe||G)&&(j.userEnv={...V,...j.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(j.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),N.disableExtensions!==void 0&&(j["disable-extensions"]=N.disableExtensions),j.fullscreen=this.isFullScreen,j.maximized=this.m.isMaximized(),j.partsSplash=this.lb.getWindowSplash(),j.zoomLevel=this.Jb(),j.isCustomZoomLevel=typeof this.ab=="number",j.isCustomZoomLevel&&j.partsSplash&&(j.partsSplash.zoomLevel=j.zoomLevel),(0,a.mark)("code/willOpenNewWindow"),j.perfMarks=(0,a.getMarks)(),this.bb.update(j)}async reload(j){const N=Object.assign({},this.S);N.workspace=await this.Db(N),delete N.filesToOpenOrCreate,delete N.filesToDiff,delete N.filesToMerge,delete N.filesToWait,this.isExtensionDevelopmentHost&&j&&(N.verbose=j.verbose,N.debugId=j.debugId,N.extensionEnvironment=j.extensionEnvironment,N["inspect-extensions"]=j["inspect-extensions"],N["inspect-brk-extensions"]=j["inspect-brk-extensions"],N["extensions-dir"]=j["extensions-dir"]),N.accessibilitySupport=n.app.isAccessibilitySupportEnabled(),N.isInitialStartup=!1,N.policiesData=this.gb.serialize(),N.continueOn=this.t.continueOn,N.profiles={all:this.hb.profiles,profile:this.profile||this.hb.defaultProfile,home:this.hb.profilesHome},N.logLevel=this.fb.getLogLevel(),N.loggers={window:this.fb.getRegisteredLoggers(this.id),global:this.fb.getRegisteredLoggers()},this.load(N,{isReload:!0,disableExtensions:j?.["disable-extensions"]})}async Db(j){if((0,L.$Ri)(j.workspace)){const N=j.workspace.configPath;if(N.scheme===p.Schemas.file&&!await this.ib.exists(N))return}else if((0,L.$Mi)(j.workspace)){const N=j.workspace.uri;if(N.scheme===p.Schemas.file&&!await this.ib.exists(N))return}return j.workspace}serializeWindowState(){if(!this.m)return(0,O.$Lec)();if(this.isFullScreen){let V;try{V=n.screen.getDisplayMatching(this.getBounds())}catch{}const oe=(0,O.$Lec)();return{mode:O.WindowMode.Fullscreen,display:V?V.id:void 0,width:this.U.width||oe.width,height:this.U.height||oe.height,x:this.U.x||0,y:this.U.y||0,zoomLevel:this.ab}}const j=Object.create(null);let N;if(!g.$k&&this.m.isMaximized()?N=O.WindowMode.Maximized:N=O.WindowMode.Normal,N===O.WindowMode.Maximized?j.mode=O.WindowMode.Maximized:j.mode=O.WindowMode.Normal,N===O.WindowMode.Normal||N===O.WindowMode.Maximized){let V;N===O.WindowMode.Normal?V=this.getBounds():V=this.m.getNormalBounds(),j.x=V.x,j.y=V.y,j.width=V.width,j.height=V.height}return j.zoomLevel=this.ab,j}Eb(j){(0,a.mark)("code/willRestoreCodeWindowState");let N=!1;if(j){this.ab=j.zoomLevel;try{const V=n.screen.getAllDisplays();N=V.length>1,j=R.WindowStateValidator.validateWindowState(this.u,j,V)}catch(V){this.u.warn(`Unexpected error validating window state: ${V}
${V.stack}`)}}return(0,a.mark)("code/didRestoreCodeWindowState"),[j||(0,O.$Lec)(),N]}getBounds(){const[j,N]=this.m.getPosition(),[V,oe]=this.m.getSize();return{x:j,y:N,width:V,height:oe}}I(j,N){super.I(j,N),this.sendWhenReady(j?"vscode:enterFullScreen":"vscode:leaveFullScreen",E.CancellationToken.None),this.W&&this.Hb(this.W,!1)}Gb(){let j=(0,y.$1D)(this.r);return["visible","toggle","hidden"].indexOf(j)<0&&(j="classic"),j}Hb(j,N=!0){g.$k||(j==="toggle"&&N&&this.send("vscode:showInfoMessage",(0,m.localize)(10890,null)),j==="hidden"?setTimeout(()=>{this.Ib(j)}):this.Ib(j))}Ib(j){const N=this.isFullScreen;switch(j){case"classic":this.m.setMenuBarVisibility(!N),this.m.autoHideMenuBar=N;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(j){this.ab=j}Jb(){return typeof this.ab=="number"?this.ab:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(j,N,...V){this.isReady?this.send(j,...V):this.ready().then(()=>{N.isCancellationRequested||this.send(j,...V)})}send(j,...N){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.u.warn(`Sending IPC message to channel '${j}' for window that is destroyed`);return}try{this.m.webContents.send(j,...N)}catch(V){this.u.warn(`Error sending IPC message to channel '${j}' of window ${this.Q}: ${(0,D.$nj)(V)}`)}}}updateTouchBar(j){g.$k&&this.Y.forEach((N,V)=>{const oe=j[V];N.segments=this.Mb(oe)})}Kb(){if(g.$k){for(let j=0;j<10;j++){const N=this.Lb();this.Y.push(N)}this.m.setTouchBar(new n.TouchBar({items:this.Y}))}}Lb(j=[]){const N=this.Mb(j),V=new n.TouchBar.TouchBarSegmentedControl({segments:N,mode:"buttons",segmentStyle:"automatic",change:oe=>{this.sendWhenReady("vscode:runAction",E.CancellationToken.None,{id:V.segments[oe].id,from:"touchbar"})}});return V}Mb(j=[]){return j.map(V=>{let oe;V.icon&&!l.ThemeIcon.isThemeIcon(V.icon)&&V.icon?.dark?.scheme===p.Schemas.file&&(oe=n.nativeImage.createFromPath(h.URI.revive(V.icon.dark).fsPath),oe.isEmpty()&&(oe=void 0));let G;return typeof V.title=="string"?G=V.title:G=V.title.value,{id:V.id,label:oe?void 0:G,icon:oe}})}matches(j){return this.m?.webContents.id===j.id}dispose(){super.dispose(),this.fb.deregisterLoggers(this.id)}};e.$dfc=te,e.$dfc=te=Ee([se(1,t.$9j),se(2,B.$afc),se(3,b.$Nec),se(4,W.$po),se(5,C.$2ec),se(6,P.$9k),se(7,s.$nfc),se(8,s.$lfc),se(9,d.$9i),se(10,k.$Wec),se(11,A.$$ec),se(12,f.$Sec),se(13,c.$8l),se(14,v.$Tec),se(15,S.$ffc),se(16,u.$pk),se(17,i.$Vec),se(18,R.$Yec),se(19,x.$gR),se(20,X.$Bi)],te)}),define(le[272],ue([0,1,13,3,17,22,19,5,34,50,51,136]),function(Y,e,n,r,E,D,T,I,p,a,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=void 0;let m=class extends h.$cfc{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(f,d,v,b,$,P){super(b,$,d,v),this.O=f,this.P=P,this.id=this.O.id,this.parentId=-1,this.N=!1,this.tryClaimWindow()}tryClaimWindow(f){this.q.isDisposed||this.O.isDestroyed()||(this.Q(),f&&!this.N&&(this.N=!0,this.w({x:f.x,y:f.y,width:f.width,height:f.height,mode:f.show===!1?g.WindowMode.Maximized:g.WindowMode.Normal})))}Q(){if(this.m)return;const f=n.BrowserWindow.fromWebContents(this.O);f&&(this.u.trace("[aux window] Claimed browser window instance"),this.n(f),f.setMenu(null),(r.$j||r.$l)&&(0,a.$3D)(this.r)&&f.setAutoHideMenuBar(!0),this.P.registerAuxWindow(this))}matches(f){return this.O.id===f.id}};e.$efc=m,e.$efc=m=Ee([se(1,D.$Nec),se(2,I.$9j),se(3,E.$9i),se(4,p.$gR),se(5,T.$ffc)],m)}),define(le[273],ue([0,1,13,4,2,11,35,272,6,5,51,29]),function(Y,e,n,r,E,D,T,I,p,a,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lgc=void 0;let m=class extends E.$Tc{constructor(f,d){super(),this.h=f,this.j=d,this.a=this.B(new r.$je),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new r.$je),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new r.$je),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new r.$je),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){n.app.on("browser-window-created",(f,d)=>{const v=this.getWindowByWebContents(d.webContents);if(v)this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),v.tryClaimWindow();else{const b=new E.$Sc;b.add(r.Event.fromNodeEventEmitter(d.webContents,"did-create-window",($,P)=>({browserWindow:$,details:P}))(({browserWindow:$,details:P})=>{const S=this.getWindowByWebContents($.webContents);S&&(this.j.trace('[aux window] window.on("did-create-window"): Trying to claim auxiliary window'),S.tryClaimWindow(P.options))})),b.add(r.Event.fromNodeEventEmitter(d,"closed")(()=>b.dispose()))}}),T.$xX.handle("vscode:registerAuxiliaryWindow",async(f,d)=>{const v=this.getWindowByWebContents(f.sender);return v&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),v.parentId=d),f.sender.id})}createWindow(f){return this.h.invokeFunction(h.$Zec,this.n(f),{preload:D.$Wg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath})}n(f){const d={},v=f.features.split(",");for(const $ of v){const[P,S]=$.split("=");switch(P){case"width":d.width=parseInt(S,10);break;case"height":d.height=parseInt(S,10);break;case"left":d.x=parseInt(S,10);break;case"top":d.y=parseInt(S,10);break;case"window-maximized":d.mode=g.WindowMode.Maximized;break;case"window-fullscreen":d.mode=g.WindowMode.Fullscreen;break}}const b=h.WindowStateValidator.validateWindowState(this.j,d)??(0,g.$Mec)();return this.j.trace("[aux window] using window state",b),b}registerWindow(f){const d=new E.$Sc,v=this.h.createInstance(I.$efc,f);this.g.set(v.id,v),d.add((0,E.$Rc)(()=>this.g.delete(v.id))),d.add(v.onDidMaximize(()=>this.a.fire(v))),d.add(v.onDidUnmaximize(()=>this.b.fire(v))),d.add(v.onDidEnterFullScreen(()=>this.c.fire({window:v,fullscreen:!0}))),d.add(v.onDidLeaveFullScreen(()=>this.c.fire({window:v,fullscreen:!1}))),d.add(v.onDidTriggerSystemContextMenu(({x:b,y:$})=>this.f.fire({window:v,x:b,y:$}))),r.Event.once(v.onDidClose)(()=>d.dispose())}getWindowByWebContents(f){const d=this.g.get(f.id);return d?.matches(f)?d:void 0}getFocusedWindow(){const f=n.BrowserWindow.getFocusedWindow();if(f)return this.getWindowByWebContents(f.webContents)}getLastActiveWindow(){return(0,h.$1ec)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$Lgc=m,e.$Lgc=m=Ee([se(0,p.$Bi),se(1,a.$9j)],m)}),define(le[88],ue([0,1,13,20,8,4,47,2,11,3,18,7,23,10,6,19,5,62,87,102,30,59,31,52]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w,f,d,v,b,$,P,S,t,u,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Yfc=e.$Xfc=void 0,e.$Xfc=(0,f.$Ci)("workspacesHistoryMainService");let s=class extends I.$Tc{static{o=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(l,k,y,R,L){super(),this.f=l,this.g=k,this.h=y,this.j=R,this.m=L,this.c=this.B(new D.$je),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new E.$Ah(800)),this.n()}n(){this.h.when(d.LifecycleMainPhase.Eventually).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(l=>this.addRecentlyOpened([{workspace:l.workspace,remoteAuthority:l.window.remoteAuthority}])))}async addRecentlyOpened(l){let k=[],y=[];for(const L of l)if((0,P.$Rhb)(L))!this.g.isUntitledWorkspace(L.workspace)&&!this.w(k,L.workspace)&&k.push(L);else if((0,P.$Shb)(L))this.y(k,L.folderUri)||k.push(L);else{const A=this.z(y,L.fileUri),O=L.fileUri.scheme===p.Schemas.file&&o.G.indexOf((0,g.$ah)(L.fileUri))>=0;!A&&!O&&(y.push(L),a.$j&&L.fileUri.scheme===p.Schemas.file&&n.app.addRecentDocument(L.fileUri.fsPath))}const R=await this.r({workspaces:k,files:y});k=R.workspaces,y=R.files,k.length>o.a&&(k.length=o.a),y.length>o.a&&(y.length=o.a),await this.t({workspaces:k,files:y}),this.c.fire(),a.$k&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(l){const k=A=>{const O=this.u(A);for(const W of l)if(g.$7g.isEqual(W,O))return!1;return!0},y=await this.getRecentlyOpened(),R=y.workspaces.filter(k),L=y.files.filter(k);(R.length!==y.workspaces.length||L.length!==y.files.length)&&(await this.t({files:L,workspaces:R}),this.c.fire(),a.$k&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(l){if(l?.confirm){const{response:k}=await this.m.showMessageBox({type:"warning",buttons:[(0,w.localize)(10854,null),(0,w.localize)(10855,null)],message:(0,w.localize)(10856,null),detail:(0,w.localize)(10857,null),cancelId:1});if(k!==0)return}await this.t({workspaces:[],files:[]}),n.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(l){const k=new u.$zc(L=>g.$7g.getComparisonKey(L));if(l?.workspaces)for(const L of l.workspaces)k.set(this.u(L),L);const y=new u.$zc(L=>g.$7g.getComparisonKey(L));if(l?.files)for(const L of l.files)y.set(this.u(L),L);const R=await this.s();for(const L of R.workspaces){const A=k.get(this.u(L));A?A.label=A.label??L.label:k.set(this.u(L),L)}for(const L of R.files){const A=y.get(this.u(L));A?A.label=A.label??L.label:y.set(this.u(L),L)}return{workspaces:[...k.values()],files:[...y.values()]}}async s(){await this.j.whenReady;let l;const k=this.j.get(o.b,b.StorageScope.APPLICATION);if(typeof k=="string")try{l=JSON.parse(k)}catch(y){this.f.error("Unexpected error parsing opened paths list",y)}return(0,P.$Yhb)(l,this.f)}async t(l){await this.j.whenReady,this.j.store(o.b,JSON.stringify((0,P.$Zhb)(l)),b.StorageScope.APPLICATION,b.StorageTarget.MACHINE)}u(l){return(0,P.$Shb)(l)?l.folderUri:(0,P.$Thb)(l)?l.fileUri:l.workspace.configPath}w(l,k){return!!l.find(y=>(0,P.$Rhb)(y)&&y.workspace.id===k.id)}y(l,k){return!!l.find(y=>(0,P.$Shb)(y)&&g.$7g.isEqual(y.folderUri,k))}z(l,k){return!!l.find(y=>g.$7g.isEqual(y.fileUri,k))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG","git-rebase-todo"]}async I(){a.$j&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!a.$j)return;const l=[];if(l.push({type:"tasks",items:[{type:"task",title:(0,w.localize)(10858,null),description:(0,w.localize)(10859,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const k=[];for(const L of n.app.getJumpListSettings().removedItems){const A=L.args;if(A){const O=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(A);O&&k.push(h.URI.parse(O[2]))}}await this.removeRecentlyOpened(k);let y=!1;const R=(0,r.$Gb)((await this.getRecentlyOpened()).workspaces.slice(0,o.F).map(L=>{const A=(0,P.$Rhb)(L)?L.workspace:L.folderUri,{title:O,description:W}=this.L(A,L.label);let x;return h.URI.isUri(A)?x=`--folder-uri "${A.toString()}"`:(y=!0,x=`--file-uri "${A.configPath.toString()}"`),{type:"task",title:O.substr(0,255),description:W.substr(0,255),program:process.execPath,args:x,iconPath:"explorer.exe",iconIndex:0}}));R.length>0&&l.push({type:"custom",name:y?(0,w.localize)(10860,null):(0,w.localize)(10861,null),items:R})}l.push({type:"recent"});try{const k=n.app.setJumpList(l);k&&k!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${k}`)}catch(k){this.f.warn("updateWindowsJumpList#setJumpList",k)}}L(l,k){if(k)return{title:(0,T.$4w)(k).name,description:k};if(h.URI.isUri(l))return{title:(0,g.$ah)(l),description:this.M(l)};if(this.g.isUntitledWorkspace(l))return{title:(0,w.localize)(10862,null),description:""};let y=(0,g.$ah)(l.configPath);return y.endsWith(S.$Yi)&&(y=y.substr(0,y.length-S.$Yi.length-1)),{title:(0,w.localize)(10863,null,y),description:this.M(l.configPath)}}M(l){return l.scheme==="file"?(0,T.$Vw)(l.fsPath):l.toString()}async N(){if(!a.$k)return;n.app.clearRecentDocuments();const l=await this.getRecentlyOpened(),k=[];let y=0;for(let L=0;L<l.workspaces.length&&y<o.C;L++){const A=this.u(l.workspaces[L]);if(A.scheme===p.Schemas.file){const O=(0,g.$4g)(A);await m.Promises.exists(O)&&(k.push(O),y++)}}const R=[];for(let L=0;L<l.files.length&&y<o.D;L++){const A=this.u(l.files[L]);if(A.scheme===p.Schemas.file){const O=(0,g.$4g)(A);if(o.G.includes((0,g.$ah)(A))||k.includes(O))continue;await m.Promises.exists(O)&&(R.push(O),y++)}}R.reverse().forEach(L=>n.app.addRecentDocument(L)),k.reverse().forEach(L=>n.app.addRecentDocument(L))}};e.$Yfc=s,e.$Yfc=s=o=Ee([se(0,v.$9j),se(1,t.$$ec),se(2,d.$ffc),se(3,$.$nfc),se(4,i.$Tec)],s)}),define(le[274],ue([0,1,13,8,21,47,3,7,10,84,17,22,19,5,196,64,28,34,24,49,50,29,88,2]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w,f,d,v,b,$,P,S,t,u,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zfc=void 0,p=Ie(p);const s="menu";let c=class extends i.$Tc{static{o=this}static{this.a="lastKnownMenubarData"}constructor(y,R,L,A,O,W,x,C,B,ee,X,ae){super(),this.t=y,this.u=R,this.w=L,this.y=A,this.z=O,this.C=W,this.D=x,this.F=C,this.G=B,this.H=ee,this.I=X,this.J=ae,this.s=Object.create(null),this.h=new r.$Oh(()=>this.R(),0),this.j=new r.$Oh(()=>{this.m=[]},1e4),this.n=Object.create(null),this.r=Object.create(null),(T.$k||(0,S.$3D)(R))&&this.L(),this.M(),this.f=!1,this.g=!1,this.m=[],this.W(),this.N()}L(){const y=this.D.getItem(o.a);y&&(y.menus&&(this.n=y.menus),y.keybindings&&(this.r=y.keybindings))}M(){this.s["workbench.action.files.newUntitledFile"]=(W,x,C)=>{this.lb({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.w.openEmptyWindow({context:t.OpenContext.MENU,contextWindowId:x?.id})},this.s["workbench.action.newWindow"]=(W,x,C)=>this.w.openEmptyWindow({context:t.OpenContext.MENU,contextWindowId:x?.id}),this.s["workbench.action.files.openFileFolder"]=(W,x,C)=>this.H.pickFileFolderAndOpen(void 0,{forceNewWindow:this.eb(C),telemetryExtraData:{from:s}}),this.s["workbench.action.files.openFolder"]=(W,x,C)=>this.H.pickFolderAndOpen(void 0,{forceNewWindow:this.eb(C),telemetryExtraData:{from:s}}),this.s["workbench.action.openWorkspace"]=(W,x,C)=>this.H.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.eb(C),telemetryExtraData:{from:s}}),this.s["workbench.action.clearRecentFiles"]=()=>this.C.clearRecentlyOpened({confirm:!0});const y=this.I.youTubeUrl;y&&(this.s["workbench.action.openYouTubeUrl"]=()=>this.ob(y,"openYouTubeUrl"));const R=this.I.requestFeatureUrl;R&&(this.s["workbench.action.openRequestFeatureUrl"]=()=>this.ob(R,"openUserVoiceUrl"));const L=this.I.reportIssueUrl;L&&(this.s["workbench.action.openIssueReporter"]=()=>this.ob(L,"openReportIssues"));const A=this.I.licenseUrl;A&&(this.s["workbench.action.openLicenseUrl"]=()=>{if(T.$x){const W=A.indexOf("?")>0?"&":"?";this.ob(`${A}${W}lang=${T.$x}`,"openLicenseUrl")}else this.ob(A,"openLicenseUrl")});const O=this.I.privacyStatementUrl;O&&A&&(this.s["workbench.action.openPrivacyStatementUrl"]=()=>{this.ob(O,"openPrivacyStatement")})}N(){this.B(this.F.onWillShutdown(()=>this.b=!0)),this.B(this.w.onDidChangeWindowsCount(y=>this.S(y))),this.B(this.H.onDidBlurMainWindow(()=>this.U())),this.B(this.H.onDidFocusMainWindow(()=>this.U()))}get O(){const y=this.u.getValue("window.enableMenuBarMnemonics");return typeof y!="boolean"?!0:y}get P(){if(!T.$k)return!1;const y=this.u.getValue("window.nativeTabs");return typeof y!="boolean"?!1:y}updateMenu(y,R){this.n=y.menus,this.r=y.keybindings,this.D.setItem(o.a,y),this.Q()}Q(){this.h.schedule()}R(){this.b||setTimeout(()=>{this.b||this.W()},10)}S(y){T.$k&&(y.oldCount===0&&y.newCount>0||y.oldCount>0&&y.newCount===0)&&(this.f=y.newCount===0,this.Q())}U(){if(!T.$k)return;const y=n.BrowserWindow.getFocusedWindow();this.g=!y||!!this.J.getWindowByWebContents(y.webContents),this.Q()}W(){const y=n.Menu.getApplicationMenu();if(y&&this.m.push(y),Object.keys(this.n).length===0){this.X(T.$k?new n.Menu:null);return}const R=new n.Menu;let L;if(T.$k){const O=new n.Menu;L=new n.MenuItem({label:this.I.nameShort,submenu:O}),this.Y(O),R.append(L)}if(T.$k&&!this.c){this.c=!0;const O=new n.Menu;O.append(new n.MenuItem({label:this.qb(p.localize(11113,null)),click:()=>this.w.openEmptyWindow({context:t.OpenContext.DOCK})})),n.app.dock.setMenu(O)}if(this.$("File")){const O=new n.Menu,W=new n.MenuItem({label:this.qb(p.localize(11114,null)),submenu:O});this.bb(O,"File"),R.append(W)}if(this.$("Edit")){const O=new n.Menu,W=new n.MenuItem({label:this.qb(p.localize(11115,null)),submenu:O});this.bb(O,"Edit"),R.append(W)}if(this.$("Selection")){const O=new n.Menu,W=new n.MenuItem({label:this.qb(p.localize(11116,null)),submenu:O});this.bb(O,"Selection"),R.append(W)}if(this.$("View")){const O=new n.Menu,W=new n.MenuItem({label:this.qb(p.localize(11117,null)),submenu:O});this.bb(O,"View"),R.append(W)}if(this.$("Go")){const O=new n.Menu,W=new n.MenuItem({label:this.qb(p.localize(11118,null)),submenu:O});this.bb(O,"Go"),R.append(W)}if(this.$("Run")){const O=new n.Menu,W=new n.MenuItem({label:this.qb(p.localize(11119,null)),submenu:O});this.bb(O,"Run"),R.append(W)}if(this.$("Terminal")){const O=new n.Menu,W=new n.MenuItem({label:this.qb(p.localize(11120,null)),submenu:O});this.bb(O,"Terminal"),R.append(W)}let A;if(this.$("Window")){const O=new n.Menu;A=new n.MenuItem({label:this.qb(p.localize(11121,null)),submenu:O,role:"window"}),this.hb(O)}if(A&&R.append(A),this.$("Help")){const O=new n.Menu,W=new n.MenuItem({label:this.qb(p.localize(11122,null)),submenu:O,role:"help"});this.bb(O,"Help"),R.append(W)}R.items&&R.items.length>0?this.X(R):this.X(null),this.j.schedule()}X(y){if(n.Menu.setApplicationMenu(y),y)for(const R of this.J.getWindows())R.win?.setMenu(null)}Y(y){const R=this.jb(p.localize(11123,null,this.I.nameLong),"workbench.action.showAboutDialog"),L=this.ib();let A;if(this.$("Preferences")){const ae=new n.Menu;this.bb(ae,"Preferences"),A=new n.MenuItem({label:this.qb(p.localize(11124,null)),submenu:ae})}const O=new n.Menu,W=new n.MenuItem({label:p.localize(11125,null),role:"services",submenu:O}),x=new n.MenuItem({label:p.localize(11126,null,this.I.nameLong),role:"hide",accelerator:"Command+H"}),C=new n.MenuItem({label:p.localize(11127,null),role:"hideOthers",accelerator:"Command+Alt+H"}),B=new n.MenuItem({label:p.localize(11128,null),role:"unhide"}),ee=new n.MenuItem(this.nb("workbench.action.quit",{label:p.localize(11129,null,this.I.nameLong),click:async(ae,K,te)=>{const z=this.w.getLastActiveWindow();(this.w.getWindowCount()===0||n.BrowserWindow.getFocusedWindow()||z?.win?.isMinimized())&&await this.Z(te)&&this.H.quit(void 0)}})),X=[R];X.push(...L),A&&X.push(l(),A),X.push(l(),W,l(),x,C,B,l(),ee),X.forEach(ae=>y.append(ae))}async Z(y){if(this.w.getWindowCount()===0)return!0;const R=this.u.getValue("window.confirmBeforeClose");if(R==="always"||R==="keyboardOnly"&&this.fb(y)){const{response:L}=await this.H.showMessageBox(this.w.getFocusedWindow()?.id,{type:"question",buttons:[p.localize(11130,null),p.localize(11131,null)],message:p.localize(11132,null)});return L===0}return!0}$(y){if(!T.$k&&!(0,S.$3D)(this.u))return!1;switch(y){case"File":case"Help":if(T.$k)return this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g||!!this.n&&!!this.n[y];case"Window":if(T.$k)return this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g||!!this.n;default:return this.w.getWindowCount()>0&&!!this.n&&!!this.n[y]}}ab(y,R){R.forEach(L=>{if((0,f.$Ufc)(L))y.append(l());else if((0,f.$Tfc)(L)){const A=new n.Menu,O=new n.MenuItem({label:this.qb(L.label),submenu:A});this.ab(A,L.submenu.items),y.append(O)}else(0,f.$Vfc)(L)?y.append(this.db(L)):(0,f.$Wfc)(L)&&(L.id==="workbench.action.showAboutDialog"&&this.cb(y),T.$k?this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g?this.s[L.id]?y.append(new n.MenuItem(this.nb(L.id,{label:this.qb(L.label),click:this.s[L.id]}))):y.append(this.jb(L.label,L.id,!1,L.checked)):y.append(this.jb(L.label,L.id,L.enabled!==!1,!!L.checked)):y.append(this.jb(L.label,L.id,L.enabled!==!1,!!L.checked)))})}bb(y,R){this.n&&this.n[R]&&this.ab(y,this.n[R].items)}cb(y){const R=this.ib();R.length&&(R.forEach(L=>y.append(L)),y.append(l()))}db(y){const R=I.URI.revive(y.uri),L=y.id,A=L==="openRecentFile"?{fileUri:R}:L==="openRecentWorkspace"?{workspaceUri:R}:{folderUri:R};return new n.MenuItem(this.nb(L,{label:y.label,click:async(O,W,x)=>{const C=this.eb(x);(await this.w.open({context:t.OpenContext.MENU,cli:this.y.args,urisToOpen:[A],forceNewWindow:C,gotoLineMode:!1,remoteAuthority:y.remoteAuthority})).length>0||await this.C.removeRecentlyOpened([R])}},!1))}eb(y){return!!(y&&(!T.$k&&(y.ctrlKey||y.shiftKey)||T.$k&&(y.metaKey||y.altKey)))}fb(y){return!!(y.triggeredByAccelerator||y.altKey||y.ctrlKey||y.metaKey||y.shiftKey)}gb(y,R,L){const A={label:this.qb(y),role:L,enabled:!0};return new n.MenuItem(this.mb(R,A))}hb(y){const R=new n.MenuItem({label:p.localize(11133,null),role:"minimize",accelerator:"Command+M",enabled:this.w.getWindowCount()>0}),L=new n.MenuItem({label:p.localize(11134,null),role:"zoom",enabled:this.w.getWindowCount()>0}),A=new n.MenuItem({label:p.localize(11135,null),role:"front",enabled:this.w.getWindowCount()>0}),O=this.jb(p.localize(11136,null),"workbench.action.switchWindow"),W=[];this.P&&(W.push(l()),W.push(this.jb(p.localize(11137,null),"workbench.action.newWindowTab")),W.push(this.gb(p.localize(11138,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),W.push(this.gb(p.localize(11139,null),"workbench.action.showNextWindowTab","selectNextTab")),W.push(this.gb(p.localize(11140,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),W.push(this.gb(p.localize(11141,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[R,L,l(),O,...W,l(),A].forEach(x=>y.append(x))}ib(){switch(this.t.state.type){case P.StateType.Idle:return[new n.MenuItem({label:this.qb(p.localize(11142,null)),click:()=>setTimeout(()=>{this.pb("CheckForUpdate"),this.t.checkForUpdates(!0)},0)})];case P.StateType.CheckingForUpdates:return[new n.MenuItem({label:p.localize(11143,null),enabled:!1})];case P.StateType.AvailableForDownload:return[new n.MenuItem({label:this.qb(p.localize(11144,null)),click:()=>{this.t.downloadUpdate()}})];case P.StateType.Downloading:return[new n.MenuItem({label:p.localize(11145,null),enabled:!1})];case P.StateType.Downloaded:return T.$k?[]:[new n.MenuItem({label:this.qb(p.localize(11146,null)),click:()=>{this.pb("InstallUpdate"),this.t.applyUpdate()}})];case P.StateType.Updating:return[new n.MenuItem({label:p.localize(11147,null),enabled:!1})];case P.StateType.Ready:return[new n.MenuItem({label:this.qb(p.localize(11148,null)),click:()=>{this.pb("RestartToUpdate"),this.t.quitAndInstall()}})];default:return[]}}jb(y,R,L,A){const O=this.qb(y),W=typeof R=="function"?R:(X,ae,K)=>{const te=X?X.userSettingsLabel:null;let z=R;Array.isArray(R)&&(z=this.eb(K)?R[1]:R[0]),te&&K.triggeredByAccelerator?this.lb({type:"keybinding",userSettingsLabel:te}):this.lb({type:"commandId",commandId:z})},x=typeof L=="boolean"?L:this.w.getWindowCount()>0,C=typeof A=="boolean"?A:!1,B={label:O,click:W,enabled:x};C&&(B.type="checkbox",B.checked=C);let ee;return typeof R=="string"?ee=R:Array.isArray(R)&&(ee=R[0]),T.$k&&(ee==="editor.action.clipboardCutAction"?B.role="cut":ee==="editor.action.clipboardCopyAction"?B.role="copy":ee==="editor.action.clipboardPasteAction"&&(B.role="paste"),ee==="undo"?B.click=this.kb(W,{inDevTools:X=>X.undo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("undo:")}):ee==="redo"?B.click=this.kb(W,{inDevTools:X=>X.redo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("redo:")}):ee==="editor.action.selectAll"&&(B.click=this.kb(W,{inDevTools:X=>X.selectAll(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("selectAll:")}))),new n.MenuItem(this.mb(ee,B))}kb(y,R){return(L,A,O)=>{const W=n.BrowserWindow.getFocusedWindow();if(!W)return R.inNoWindow();if(W.webContents.isDevToolsFocused()&&W.webContents.devToolsWebContents)return R.inDevTools(W.webContents.devToolsWebContents);y(L,A||W,O)}}lb(y){let R=n.BrowserWindow.getFocusedWindow();if(R){const A=this.J.getWindowByWebContents(R.webContents);A&&(R=this.w.getWindowById(A.parentId)?.win??null)}if(!R){const A=this.w.getLastActiveWindow();A?.win?.isMinimized()&&(R=A.win)}const L=R?this.w.getWindowById(R.id):void 0;if(L){if(this.G.trace("menubar#runActionInRenderer",y),T.$k&&!this.y.isBuilt&&!L.isReady&&(y.type==="commandId"&&y.commandId==="workbench.action.toggleDevTools"||y.type!=="commandId"&&y.userSettingsLabel==="alt+cmd+i"))return!1;if(y.type==="commandId"){const A={id:y.commandId,from:"menu"};L.sendWhenReady("vscode:runAction",E.CancellationToken.None,A)}else{const A={userSettingsLabel:y.userSettingsLabel};L.sendWhenReady("vscode:runKeybinding",E.CancellationToken.None,A)}return!0}else return this.G.trace("menubar#runActionInRenderer: no active window found",y),!1}mb(y,R){const L=typeof y=="string"?this.r[y]:void 0;if(L?.label){if(L.isNative!==!1)R.accelerator=L.label,R.userSettingsLabel=L.userSettingsLabel;else if(typeof R.label=="string"){const A=R.label.indexOf("[");A>=0?R.label=`${R.label.substr(0,A)} [${L.label}]`:R.label=`${R.label} [${L.label}]`}}else R.accelerator=void 0;return R}nb(y,R,L=!R.accelerator){L&&(R=this.mb(y,R));const A=R.click;return R.click=(O,W,x)=>{this.pb(y),A?.(O,W,x)},R}ob(y,R){this.H.openExternal(void 0,y),this.pb(R)}pb(y){this.z.publicLog2("workbenchActionExecuted",{id:y,from:s})}qb(y){return(0,D.$1w)(y,!this.O)}};e.$Zfc=c,e.$Zfc=c=o=Ee([se(0,P.$wY),se(1,g.$9i),se(2,t.$Yec),se(3,h.$Nec),se(4,$.$8l),se(5,u.$Xfc),se(6,b.$gR),se(7,m.$ffc),se(8,w.$9j),se(9,d.$Kfc),se(10,v.$pk),se(11,a.$Jfc)],c);function l(){return new n.MenuItem({type:"separator"})}}),define(le[275],ue([0,1,6,19,5,274,2]),function(Y,e,n,r,E,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2fc=e.$1fc=void 0,e.$1fc=(0,n.$Ci)("menubarMainService");let I=class extends T.$Tc{constructor(a,g,h){super(),this.b=a,this.c=g,this.f=h,this.a=this.g()}async g(){return await this.c.when(r.LifecycleMainPhase.AfterWindowOpen),this.B(this.b.createInstance(D.$Zfc))}async updateMenubar(a,g){this.f.trace("menubarService#updateMenubar",a),(await this.a).updateMenu(g,a)}};e.$2fc=I,e.$2fc=I=Ee([se(0,n.$Bi),se(1,r.$ffc),se(2,E.$9j)],I)});var et=this&&this.__importDefault||function(Y){return Y&&Y.__esModule?Y:{default:Y}};define(le[276],ue([0,1,26,13,106,27,20,21,39,4,32,47,2,11,9,70,3,36,18,12,7,10,69,17,52,22,14,6,19,5,72,73,74,34,50,136,29,134,267,30,103,88,59,51,76,40,58,71,84]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w,f,d,v,b,$,P,S,t,u,i,o,s,c,l,k,y,R,L,A,O,W,x,C,B,ee,X,ae,K,te,z,j,N,V,oe,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pgc=void 0,n=Ie(n),R=et(R);function he(M){return(0,X.$Ri)(M?.workspace)}function re(M){return(0,X.$Mi)(M?.workspace)}let _=class extends m.$Tc{constructor(F,U,q,Q,J,H,ne,de,me,we,Re,ke,Pe,De,$e,Z,ce,fe,be,Ae,Ce){super(),this.s=F,this.t=U,this.u=q,this.w=Q,this.z=J,this.C=H,this.D=ne,this.F=de,this.G=me,this.H=we,this.I=Re,this.J=ke,this.L=Pe,this.M=De,this.N=$e,this.O=Z,this.P=ce,this.Q=fe,this.R=be,this.S=Ae,this.U=Ce,this.a=this.B(new a.$je),this.onDidOpenWindow=this.a.event,this.b=this.B(new a.$je),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new a.$je),this.onDidDestroyWindow=this.c.event,this.f=this.B(new a.$je),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new a.$je),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new a.$je),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new a.$je),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new a.$je),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new ee.$mgc(this,this.D,this.I,this.z,this.L)),this.W()}W(){this.B(this.N.onDidEnterWorkspace(F=>this.b.fire(F.window))),this.B(this.onDidSignalReadyWindow(F=>{if(F.config?.extensionDevelopmentPath||F.config?.extensionTestsPath){const U=new m.$Sc;if(U.add(a.Event.any(F.onDidClose,F.onDidDestroy)(()=>U.dispose())),F.config.extensionDevelopmentPath)for(const q of F.config.extensionDevelopmentPath)U.add(this.R.addValidFileRoot(q));F.config.extensionTestsPath&&U.add(this.R.addValidFileRoot(F.config.extensionTestsPath))}}))}openEmptyWindow(F,U){const q=this.G.args,Q=U?.remoteAuthority||void 0,J=!0,H=U?.forceReuseWindow,ne=!H;return this.open({...F,cli:q,forceEmpty:J,forceNewWindow:ne,forceReuseWindow:H,remoteAuthority:Q,forceTempProfile:U?.forceTempProfile,forceProfile:U?.forceProfile})}openExistingWindow(F,U){F.focus(),this.X(U,[F])}async open(F){this.z.trace("windowsManager#open"),F.addMode&&(F.initialStartup||!this.getLastActiveWindow())&&(F.addMode=!1);const U=[],q=[],Q=[],J=[],H=[];let ne,de=0;const me=await this.db(F);this.z.trace("windowsManager#open pathsToOpen",me);for(const De of me)re(De)?F.addMode?U.push(De):q.push(De):he(De)?Q.push(De):De.fileUri?(ne||(ne={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:De.remoteAuthority}),ne.filesToOpenOrCreate.push(De)):De.backupPath?H.push({backupFolder:(0,f.$mc)(De.backupPath),remoteAuthority:De.remoteAuthority}):de++;F.diffMode&&ne&&ne.filesToOpenOrCreate.length>=2&&(ne.filesToDiff=ne.filesToOpenOrCreate.slice(0,2),ne.filesToOpenOrCreate=[]),F.mergeMode&&ne&&ne.filesToOpenOrCreate.length===4&&(ne.filesToMerge=ne.filesToOpenOrCreate.slice(0,4),ne.filesToOpenOrCreate=[],ne.filesToDiff=[]),ne&&F.waitMarkerFileURI&&(ne.filesToWait={paths:(0,T.$Gb)([...ne.filesToDiff,ne.filesToMerge[3],...ne.filesToOpenOrCreate]),waitMarkerFileUri:F.waitMarkerFileURI}),F.initialStartup?(J.push(...this.N.getUntitledWorkspaces()),Q.push(...J),H.push(...this.J.getEmptyWindowBackups())):H.length=0;const{windows:we,filesOpenedInWindow:Re}=await this.Y(F,Q,q,H,de,ne,U);if(this.z.trace(`windowsManager#open used window count ${we.length} (workspacesToOpen: ${Q.length}, foldersToOpen: ${q.length}, emptyToRestore: ${H.length}, emptyToOpen: ${de})`),we.length>1)if(Re)Re.focus();else{const De=this.r.state.lastActiveWindow&&!F.forceEmpty&&!F.cli._.length&&!F.cli["file-uri"]&&!F.cli["folder-uri"]&&!(F.urisToOpen&&F.urisToOpen.length);let $e=!0,Z=!0;if(De){const ce=we.filter(fe=>this.r.state.lastActiveWindow&&fe.backupPath===this.r.state.lastActiveWindow.backupPath);ce.length&&(ce[0].focus(),$e=!1,Z=!1)}if($e)for(let ce=we.length-1;ce>=0;ce--){const fe=we[ce];if(!(fe.openedWorkspace&&J.some(be=>fe.openedWorkspace&&be.workspace.id===fe.openedWorkspace.id)||fe.backupPath&&H.some(be=>fe.backupPath&&be.backupFolder===(0,f.$mc)(fe.backupPath)))){fe.focus(),Z=!1;break}}Z&&we[we.length-1].focus()}const ke=ne&&ne.filesToDiff.length>0,Pe=ne&&ne.filesToMerge.length>0;if(!we.some(De=>De.isExtensionDevelopmentHost)&&!ke&&!Pe&&!F.noRecentEntry){const De=[];for(const $e of me)he($e)&&!$e.transient?De.push({label:$e.label,workspace:$e.workspace,remoteAuthority:$e.remoteAuthority}):re($e)?De.push({label:$e.label,folderUri:$e.workspace.uri,remoteAuthority:$e.remoteAuthority}):$e.fileUri&&De.push({label:$e.label,fileUri:$e.fileUri,remoteAuthority:$e.remoteAuthority});this.M.addRecentlyOpened(De)}return this.X(F,we),we}X(F,U){const q=F.waitMarkerFileURI;F.context===C.OpenContext.CLI&&q&&U.length===1&&U[0]&&(async()=>{await U[0].whenClosedOrLoaded;try{await this.Q.del(q)}catch{}})()}async Y(F,U,q,Q,J,H,ne){const de=[];let me;function we(ce,fe){de.push(ce),fe&&(me=ce,H=void 0)}let{openFolderInNewWindow:Re,openFilesInNewWindow:ke}=this.pb(F);if(!F.initialStartup&&ne.length>0){const ce=ne[0].remoteAuthority,fe=this.vb(ce);fe&&we(this.ab(fe,ne.map(be=>be.workspace.uri)))}const Pe=q.length+U.length+Q.length;if(H&&Pe===0){const ce=H.filesToOpenOrCreate[0]||H.filesToDiff[0]||H.filesToMerge[3],fe=this.getWindows().filter(Ae=>H&&(0,$.$ih)(Ae.remoteAuthority,H.remoteAuthority));let be;ce?.fileUri&&!ke&&((F.context===C.OpenContext.DESKTOP||F.context===C.OpenContext.CLI||F.context===C.OpenContext.DOCK)&&(be=await(0,B.$4ec)(fe,ce.fileUri,async Ae=>Ae.configPath.scheme===w.Schemas.file?this.N.resolveLocalWorkspace(Ae.configPath):void 0)),be||(be=this.wb(fe))),be?(0,X.$Ri)(be.openedWorkspace)?U.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):(0,X.$Mi)(be.openedWorkspace)?q.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):we(this.Z(F,be,H),!0):we(await this.qb({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,filesToOpen:H,forceNewWindow:!0,remoteAuthority:H.remoteAuthority,forceNewTabbedWindow:F.forceNewTabbedWindow,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile}),!0)}const De=(0,T.$Lb)(U,ce=>ce.workspace.id);if(De.length>0){const ce=(0,T.$Gb)(De.map(fe=>(0,B.$5ec)(this.getWindows(),fe.workspace.configPath)));if(ce.length>0){const fe=ce[0],be=(0,$.$ih)(H?.remoteAuthority,fe.remoteAuthority)?H:void 0;we(this.Z(F,fe,be),!!be),Re=!0}for(const fe of De){if(ce.some(Ce=>Ce.openedWorkspace&&Ce.openedWorkspace.id===fe.workspace.id))continue;const be=fe.remoteAuthority,Ae=(0,$.$ih)(H?.remoteAuthority,be)?H:void 0;we(await this.cb(F,fe,Re,Ae),!!Ae),Re=!0}}const $e=(0,T.$Lb)(q,ce=>$.$7g.getComparisonKey(ce.workspace.uri));if($e.length>0){const ce=(0,T.$Gb)($e.map(fe=>(0,B.$5ec)(this.getWindows(),fe.workspace.uri)));if(ce.length>0){const fe=ce[0],be=(0,$.$ih)(H?.remoteAuthority,fe.remoteAuthority)?H:void 0;we(this.Z(F,fe,be),!!be),Re=!0}for(const fe of $e){if(ce.some(Ce=>(0,X.$Mi)(Ce.openedWorkspace)&&$.$7g.isEqual(Ce.openedWorkspace.uri,fe.workspace.uri)))continue;const be=fe.remoteAuthority,Ae=(0,$.$ih)(H?.remoteAuthority,be)?H:void 0;we(await this.cb(F,fe,Re,Ae),!!Ae),Re=!0}}const Z=(0,T.$Lb)(Q,ce=>ce.backupFolder);if(Z.length>0)for(const ce of Z){const fe=ce.remoteAuthority,be=(0,$.$ih)(H?.remoteAuthority,fe)?H:void 0;we(await this.bb(F,!0,fe,be,ce),!!be),Re=!0}if(de.length===0||H){H&&!J&&J++;const ce=H?H.remoteAuthority:F.remoteAuthority;for(let fe=0;fe<J;fe++)we(await this.bb(F,Re,ce,H),!!H),Re=!0}return{windows:(0,T.$Lb)(de),filesOpenedInWindow:me}}Z(F,U,q){this.z.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:q}),this.$(U);const Q={filesToOpenOrCreate:q?.filesToOpenOrCreate,filesToDiff:q?.filesToDiff,filesToMerge:q?.filesToMerge,filesToWait:q?.filesToWait,termProgram:F?.userEnv?.TERM_PROGRAM};return U.sendWhenReady("vscode:openFiles",I.CancellationToken.None,Q),U}$(F){let U=F;const q=r.BrowserWindow.getFocusedWindow();if(q&&q.id!==F.id){const Q=this.U.getWindowByWebContents(q.webContents);Q&&Q.parentId===F.id&&(U=Q)}U.focus()}ab(F,U){this.z.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:U}),F.focus();const q={foldersToAdd:U};return F.sendWhenReady("vscode:addFolders",I.CancellationToken.None,q),F}bb(F,U,q,Q,J){this.z.trace("windowsManager#doOpenEmpty",{restore:!!J,remoteAuthority:q,filesToOpen:Q,forceNewWindow:U});let H;return!U&&typeof F.contextWindowId=="number"&&(H=this.getWindowById(F.contextWindowId)),this.qb({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:q,forceNewWindow:U,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:Q,windowToUse:H,emptyWindowBackupInfo:J,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile})}cb(F,U,q,Q,J){return this.z.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:U,filesToOpen:Q}),!q&&!J&&typeof F.contextWindowId=="number"&&(J=this.getWindowById(F.contextWindowId)),this.qb({workspace:U.workspace,userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:U.remoteAuthority,forceNewWindow:q,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:Q,windowToUse:J,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile})}async db(F){let U,q=!1,Q=!1;if(F.urisToOpen&&F.urisToOpen.length>0?(U=await this.eb(F),q=!0):F.forceEmpty?U=[Object.create(null)]:F.cli._.length||F.cli["folder-uri"]||F.cli["file-uri"]?(U=await this.fb(F.cli),U.length===0&&U.push(Object.create(null)),q=!0):(U=await this.hb(),U.length===0&&U.push(Object.create(null)),Q=!0),!F.addMode&&q){const J=U.filter(H=>re(H));if(J.length>1){const H=J[0].remoteAuthority;if(J.every(ne=>(0,$.$ih)(ne.remoteAuthority,H))){const ne=await this.N.createUntitledWorkspace(J.map(de=>({uri:de.workspace.uri})));U.push({workspace:ne,remoteAuthority:H}),U=U.filter(de=>!re(de))}}}if(F.initialStartup&&!Q&&this.L.getValue("window")?.restoreWindows==="preserve"){const J=await this.hb();U.unshift(...J.filter(H=>he(H)||re(H)||H.backupPath))}return U}async eb(F){const U={gotoLineMode:F.gotoLineMode,remoteAuthority:F.remoteAuthority},q=await Promise.all((0,T.$Gb)(F.urisToOpen||[]).map(async Q=>{const J=await this.jb(Q,U);if(J)return J.label=Q.label,J;const H=this.lb(Q);this.P.showMessageBox({type:"info",buttons:[(0,t.localize)(10865,null)],message:H.scheme===w.Schemas.file?(0,t.localize)(10866,null):(0,t.localize)(10867,null),detail:H.scheme===w.Schemas.file?(0,t.localize)(10868,null,(0,h.$Uw)(H,{os:v.OS,tildify:this.G})):(0,t.localize)(10869,null,H.toString(!0))},r.BrowserWindow.getFocusedWindow()??void 0)}));return(0,T.$Gb)(q)}async fb(F){const U=[],q={ignoreFileNotFound:!0,gotoLineMode:F.goto,remoteAuthority:F.remote||void 0,forceOpenWorkspaceAsFile:F.diff&&F._.length===2||F.merge&&F._.length===4},Q=F["folder-uri"];if(Q){const ne=await Promise.all(Q.map(de=>{const me=this.gb(de);if(me)return this.jb({folderUri:me},q)}));U.push(...(0,T.$Gb)(ne))}const J=F["file-uri"];if(J){const ne=await Promise.all(J.map(de=>{const me=this.gb(de);if(me)return this.jb((0,X.$8i)(de)?{workspaceUri:me}:{fileUri:me},q)}));U.push(...(0,T.$Gb)(ne))}const H=await Promise.all(F._.map(ne=>q.remoteAuthority?this.ob(ne,q):this.mb(ne,q)));return U.push(...(0,T.$Gb)(H)),U}gb(F){try{const U=S.URI.parse(F);if(!U.scheme){this.z.error(`Invalid URI input string, scheme missing: ${F}`);return}return U.path?U:U.with({path:"/"})}catch(U){this.z.error(`Invalid URI input string: ${F}, ${U.message}`)}}async hb(){const F=this.ib();switch(F){case"none":return[];case"one":case"all":case"preserve":case"folders":{const U=[];F!=="one"&&U.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&U.push(this.r.state.lastActiveWindow);const q=await Promise.all(U.map(async Q=>{if(Q.workspace){const J=await this.jb({workspaceUri:Q.workspace.configPath},{remoteAuthority:Q.remoteAuthority,rejectTransientWorkspaces:!0});if(he(J))return J}else if(Q.folderUri){const J=await this.jb({folderUri:Q.folderUri},{remoteAuthority:Q.remoteAuthority});if(re(J))return J}else if(F!=="folders"&&Q.backupPath)return{backupPath:Q.backupPath,remoteAuthority:Q.remoteAuthority}}));return(0,T.$Gb)(q)}}}ib(){let F;return this.I.wasRestarted?F="all":(F=this.L.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(F)||(F="all")),F}async jb(F,U=Object.create(null)){const q=this.lb(F);return q.scheme===w.Schemas.file?((0,W.$ZD)(F)&&(U={...U,forceOpenWorkspaceAsFile:!0}),this.mb(q.fsPath,U)):this.kb(F,U)}kb(F,U){let q=this.lb(F);const Q=(0,A.$dn)(q)||U.remoteAuthority;if(q=(0,$.$kh)((0,$.$eh)(q)),(0,W.$ZD)(F)){if(U.gotoLineMode){const{path:J,line:H,column:ne}=(0,g.$Jg)(q.path);return{fileUri:q.with({path:J}),options:{selection:H?{startLineNumber:H,startColumn:ne||1}:void 0},remoteAuthority:Q}}return{fileUri:q,remoteAuthority:Q}}else if((0,W.$XD)(F))return{workspace:(0,ae.$8ec)(q),remoteAuthority:Q};return{workspace:(0,ae.$9ec)(q),remoteAuthority:Q}}lb(F){return(0,W.$XD)(F)?F.workspaceUri:(0,W.$YD)(F)?F.folderUri:F.fileUri}async mb(F,U,q){let Q,J;U.gotoLineMode&&({path:F,line:Q,column:J}=(0,g.$Jg)(F)),F=(0,g.$Dg)((0,f.$gc)(F),(0,b.cwd)());try{const H=await n.promises.stat(F);if(H.isFile()){if(!U.forceOpenWorkspaceAsFile){const ne=await this.N.resolveLocalWorkspace(S.URI.file(F));if(ne)return ne.transient&&U.rejectTransientWorkspaces?void 0:{workspace:{id:ne.id,configPath:ne.configPath},type:c.FileType.File,exists:!0,remoteAuthority:ne.remoteAuthority,transient:ne.transient}}return{fileUri:S.URI.file(F),type:c.FileType.File,exists:!0,options:{selection:Q?{startLineNumber:Q,startColumn:J||1}:void 0}}}else{if(H.isDirectory())return{workspace:(0,ae.$9ec)(S.URI.file(F),H),type:c.FileType.Directory,exists:!0};if(!v.$j&&F==="/dev/null")return{fileUri:S.URI.file(F),type:c.FileType.File,exists:!0}}}catch(H){if(H.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!q)return this.nb(F,U);const ne=S.URI.file(F);if(this.M.removeRecentlyOpened([ne]),U.ignoreFileNotFound)return{fileUri:ne,type:c.FileType.File,exists:!1}}}async nb(F,U){const q=S.URI.file(F),{response:Q,checkboxChecked:J}=await this.P.showMessageBox({type:"warning",buttons:[(0,t.localize)(10870,null),(0,t.localize)(10871,null),(0,t.localize)(10872,null)],message:(0,t.localize)(10873,null,q.authority),detail:(0,t.localize)(10874,null,(0,h.$Uw)(q,{os:v.OS,tildify:this.G})),checkboxLabel:(0,t.localize)(10875,null,q.authority),cancelId:1});if(Q===0){if((0,E.addUNCHostToAllowlist)(q.authority),J){const H={channel:"vscode:configureAllowedUNCHost",args:q.authority};this.sendToFocused(H.channel,H.args),this.sendToOpeningWindow(H.channel,H.args)}return this.mb(F,U,!0)}if(Q===2)return r.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.nb(F,U)}ob(F,U){const q=F.charCodeAt(0),Q=U.remoteAuthority;let J,H;U.gotoLineMode&&({path:F,line:J,column:H}=(0,g.$Jg)(F)),q!==p.CharCode.Slash&&((0,g.$Cg)(q)&&F.charCodeAt(F.charCodeAt(1))===p.CharCode.Colon&&(F=(0,g.$vg)(F)),F=`/${F}`);const ne=S.URI.from({scheme:w.Schemas.vscodeRemote,authority:Q,path:F});if(F.charCodeAt(F.length-1)!==p.CharCode.Slash){if((0,X.$8i)(F))return U.forceOpenWorkspaceAsFile?{fileUri:ne,options:{selection:J?{startLineNumber:J,startColumn:H||1}:void 0},remoteAuthority:U.remoteAuthority}:{workspace:(0,ae.$8ec)(ne),remoteAuthority:Q};if(U.gotoLineMode||f.$fc.basename(F).indexOf(".")!==-1)return{fileUri:ne,options:{selection:J?{startLineNumber:J,startColumn:H||1}:void 0},remoteAuthority:Q}}return{workspace:(0,ae.$9ec)(ne),remoteAuthority:Q}}pb(F){const U=this.L.getValue("window"),q=U?.openFoldersInNewWindow||"default",Q=U?.openFilesInNewWindow||"off";let J=(F.preferNewWindow||F.forceNewWindow)&&!F.forceReuseWindow;!F.forceNewWindow&&!F.forceReuseWindow&&(q==="on"||q==="off")&&(J=q==="on");let H=!1;return F.forceNewWindow||F.forceReuseWindow?H=!!F.forceNewWindow&&!F.forceReuseWindow:(v.$k?F.context===C.OpenContext.DOCK&&(H=!0):F.context!==C.OpenContext.DIALOG&&F.context!==C.OpenContext.MENU&&!(F.userEnv&&F.userEnv.TERM_PROGRAM==="vscode")&&(H=!0),!F.cli.extensionDevelopmentPath&&(Q==="on"||Q==="off")&&(H=Q==="on")),{openFolderInNewWindow:!!J,openFilesInNewWindow:H}}async openExtensionDevelopmentHostWindow(F,U){const q=(0,B.$6ec)(this.getWindows(),F);if(q)return this.I.reload(q,U.cli),q.focus(),[q];let Q=U.cli["folder-uri"]||[],J=U.cli["file-uri"]||[],H=U.cli._;if(!H.length&&!Q.length&&!J.length&&!U.cli.extensionTestsPath){const me=this.r.state.lastPluginDevelopmentHostWindow,we=me?.workspace??me?.folderUri;we&&(S.URI.isUri(we)?we.scheme===w.Schemas.file?H=[we.fsPath]:Q=[we.toString()]:we.configPath.scheme===w.Schemas.file?H=[(0,$.$4g)(we.configPath)]:J=[we.configPath.toString()])}let ne=U.remoteAuthority;for(const me of F)if(me.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const we=S.URI.parse(me),Re=(0,A.$dn)(we);Re&&(ne?(0,$.$ih)(Re,ne)||this.z.error("more than one extension development path authority"):ne=Re)}H=H.filter(me=>{const we=S.URI.file(me);return(0,B.$5ec)(this.getWindows(),we)?!1:(0,$.$ih)((0,A.$dn)(we),ne)}),Q=Q.filter(me=>{const we=this.gb(me);return we&&(0,B.$5ec)(this.getWindows(),we)?!1:we?(0,$.$ih)((0,A.$dn)(we),ne):!1}),J=J.filter(me=>{const we=this.gb(me);return we&&(0,B.$5ec)(this.getWindows(),we)?!1:we?(0,$.$ih)((0,A.$dn)(we),ne):!1}),U.cli._=H,U.cli["folder-uri"]=Q,U.cli["file-uri"]=J;const de={context:U.context,cli:U.cli,forceNewWindow:!0,forceEmpty:!H.length&&!Q.length&&!J.length,userEnv:U.userEnv,noRecentEntry:!0,waitMarkerFileURI:U.waitMarkerFileURI,remoteAuthority:ne,forceProfile:U.forceProfile,forceTempProfile:U.forceTempProfile};return this.open(de)}async qb(F){const U=this.L.getValue("window"),q=this.getLastActiveWindow(),J=(U?.newWindowProfile?this.H.profiles.find(de=>de.name===U.newWindowProfile):void 0)??q?.profile??this.H.defaultProfile;let H;!F.forceNewWindow&&!F.forceNewTabbedWindow&&(H=F.windowToUse||q,H&&H.focus());const ne={...this.G.args,...F.cli,machineId:this.s,sqmId:this.t,devDeviceId:this.u,windowId:-1,mainPid:process.pid,appRoot:this.G.appRoot,execPath:process.execPath,codeCachePath:this.G.codeCachePath,backupPath:F.emptyWindowBackupInfo?(0,f.$ic)(this.G.backupHome,F.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.H.profilesHome,all:this.H.profiles,profile:J},homeDir:this.G.userHome.with({scheme:w.Schemas.file}).fsPath,tmpDir:this.G.tmpDir.with({scheme:w.Schemas.file}).fsPath,userDataDir:this.G.userDataPath,remoteAuthority:F.remoteAuthority,workspace:F.workspace,userEnv:{...this.w,...F.userEnv},nls:{messages:globalThis._VSCODE_NLS_MESSAGES,language:globalThis._VSCODE_NLS_LANGUAGE},filesToOpenOrCreate:F.filesToOpen?.filesToOpenOrCreate,filesToDiff:F.filesToOpen?.filesToDiff,filesToMerge:F.filesToOpen?.filesToMerge,filesToWait:F.filesToOpen?.filesToWait,logLevel:this.C.getLogLevel(),loggers:{window:[],global:this.C.getRegisteredLoggers()},logsPath:this.G.logsHome.with({scheme:w.Schemas.file}).fsPath,product:R.default,isInitialStartup:F.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,D.release)(),hostname:(0,D.hostname)(),arch:(0,D.arch)()},autoDetectHighContrast:U?.autoDetectHighContrast??!0,autoDetectColorScheme:U?.autoDetectColorScheme??!1,accessibilitySupport:r.app.accessibilitySupportEnabled,colorScheme:this.S.getColorScheme(),policiesData:this.F.serialize(),continueOn:this.G.continueOn};if(H){const de=H.config;!ne.extensionDevelopmentPath&&de?.extensionDevelopmentPath&&(ne.extensionDevelopmentPath=de.extensionDevelopmentPath,ne.extensionDevelopmentKind=de.extensionDevelopmentKind,ne["enable-proposed-api"]=de["enable-proposed-api"],ne.verbose=de.verbose,ne["inspect-extensions"]=de["inspect-extensions"],ne["inspect-brk-extensions"]=de["inspect-brk-extensions"],ne.debugId=de.debugId,ne.extensionEnvironment=de.extensionEnvironment,ne["extensions-dir"]=de["extensions-dir"],ne["disable-extensions"]=de["disable-extensions"]),ne.loggers={global:ne.loggers.global,window:de?.loggers.window??ne.loggers.window}}else{const de=this.r.getNewWindowState(ne);(0,d.mark)("code/willCreateCodeWindow");const me=H=this.O.createInstance(x.$dfc,{state:de,extensionDevelopmentPath:ne.extensionDevelopmentPath,isExtensionTestHost:!!ne.extensionTestsPath});(0,d.mark)("code/didCreateCodeWindow"),F.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(me),this.n.set(me.id,me),this.a.fire(me),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const we=new m.$Sc;we.add(me.onDidSignalReady(()=>this.b.fire(me))),we.add(a.Event.once(me.onDidClose)(()=>this.tb(me,we))),we.add(a.Event.once(me.onDidDestroy)(()=>this.ub(me))),we.add(me.onDidMaximize(()=>this.g.fire(me))),we.add(me.onDidUnmaximize(()=>this.h.fire(me))),we.add(me.onDidEnterFullScreen(()=>this.j.fire({window:me,fullscreen:!0}))),we.add(me.onDidLeaveFullScreen(()=>this.j.fire({window:me,fullscreen:!1}))),we.add(me.onDidTriggerSystemContextMenu(({x:ke,y:Pe})=>this.m.fire({window:me,x:ke,y:Pe})));const Re=(0,P.$ng)(me.win?.webContents);Re.removeAllListeners("devtools-reload-page"),we.add(a.Event.fromNodeEventEmitter(Re,"devtools-reload-page")(()=>this.I.reload(me))),this.I.registerWindow(me)}return ne.windowId=H.id,H.isReady?this.I.unload(H,z.UnloadReason.LOAD).then(async de=>{de||await this.rb(H,ne,F,J)}):await this.rb(H,ne,F,J),H}async rb(F,U,q,Q){if(U.extensionDevelopmentPath||((0,X.$Ri)(U.workspace)?U.backupPath=this.J.registerWorkspaceBackup({workspace:U.workspace,remoteAuthority:U.remoteAuthority}):(0,X.$Mi)(U.workspace)?U.backupPath=this.J.registerFolderBackup({folderUri:U.workspace.uri,remoteAuthority:U.remoteAuthority}):U.backupPath=this.J.registerEmptyWindowBackup({backupFolder:q.emptyWindowBackupInfo?.backupFolder??(0,ae.$0ec)().id,remoteAuthority:U.remoteAuthority})),this.H.isEnabled()){const J=U.workspace??(0,X.$Qi)(U.backupPath,!1),H=this.sb(q,J,Q),ne=H instanceof Promise?await H:H;U.profiles.profile=ne,U.extensionDevelopmentPath||await this.H.setProfileForWorkspace(J,ne)}F.load(U)}sb(F,U,q){return F.forceProfile?this.H.profiles.find(Q=>Q.name===F.forceProfile)??this.H.createNamedProfile(F.forceProfile):F.forceTempProfile?this.H.createTransientProfile():this.H.getProfileForWorkspace(U)??q}tb(F,U){this.n.delete(F.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),U.dispose()}ub(F){this.n.delete(F.id),this.c.fire(F)}getFocusedWindow(){const F=r.BrowserWindow.getFocusedWindow();if(F)return this.getWindowById(F.id)}getLastActiveWindow(){return this.wb(this.getWindows())}vb(F){return this.wb(this.getWindows().filter(U=>(0,$.$ih)(U.remoteAuthority,F)))}wb(F){return(0,C.$1ec)(F)}sendToFocused(F,...U){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(F,I.CancellationToken.None,...U)}sendToOpeningWindow(F,...U){this.B(a.Event.once(this.onDidSignalReadyWindow)(q=>{q.sendWhenReady(F,I.CancellationToken.None,...U)}))}sendToAll(F,U,q){for(const Q of this.getWindows())q&&q.indexOf(Q.id)>=0||Q.sendWhenReady(F,I.CancellationToken.None,U)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(F){return this.n.get(F)}getWindowByWebContents(F){const U=r.BrowserWindow.fromWebContents(F);if(!U)return;const q=this.getWindowById(U.id);return q?.matches(F)?q:void 0}};e.$pgc=_,e.$pgc=_=Ee([se(4,y.$9j),se(5,oe.$afc),se(6,O.$gR),se(7,N.$po),se(8,s.$Nec),se(9,V.$2ec),se(10,k.$ffc),se(11,u.$Sec),se(12,i.$9i),se(13,K.$Xfc),se(14,te.$$ec),se(15,l.$Bi),se(16,o.$Tec),se(17,c.$9k),se(18,L.$Vec),se(19,j.$Wec),se(20,G.$Jfc)],_)}),define(le[277],ue([0,1,69,29,88,59]),function(Y,e,n,r,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=void 0;let T=class{constructor(p,a,g,h){this.a=p,this.b=a,this.c=g,this.d=h,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(p,a){const g=this.b.getWindowById(p);if(g)return this.a.enterWorkspace(g,this.b.getWindows(),a)}createUntitledWorkspace(p,a,g){return this.a.createUntitledWorkspace(a,g)}deleteUntitledWorkspace(p,a){return this.a.deleteUntitledWorkspace(a)}getWorkspaceIdentifier(p,a){return this.a.getWorkspaceIdentifier(a)}getRecentlyOpened(p){return this.c.getRecentlyOpened()}addRecentlyOpened(p,a){return this.c.addRecentlyOpened(a)}removeRecentlyOpened(p,a){return this.c.removeRecentlyOpened(a)}clearRecentlyOpened(p){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$rgc=T,e.$rgc=T=Ee([se(0,D.$$ec),se(1,r.$Yec),se(2,E.$Xfc),se(3,n.$Sec)],T)}),define(le[278],ue([0,1,13,106,35,27,16,54,15,4,282,47,2,11,9,3,12,7,33,156,44,157,118,258,10,69,251,17,259,96,135,52,97,185,22,68,100,173,262,175,176,177,14,189,99,83,6,98,184,268,269,252,260,19,5,275,64,28,74,263,101,34,241,87,128,24,218,219,57,49,231,256,270,257,271,132,233,234,235,238,266,50,29,276,240,30,102,88,277,59,40,198,58,211,56,86,133,243,261,248,8,221,242,193,71,265,237,20,75,264,229,204,65,84,273,78]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w,f,d,v,b,$,P,S,t,u,i,o,s,c,l,k,y,R,L,A,O,W,x,C,B,ee,X,ae,K,te,z,j,N,V,oe,G,he,re,_,M,F,U,q,Q,J,H,ne,de,me,we,Re,ke,Pe,De,$e,Z,ce,fe,be,Ae,Ce,Me,Oe,Be,Ge,Qe,qe,Je,Xe,Ye,Ne,ie,ge,pe,ye,We,Ue,Ze,lt,rt,at,tt,ut,ct,ft,gt,Ot,mt,$t,Tt,Lt,jt,pt,Wt,Et,dt,Mt,Ft,wt,Nt,St,Ct,kt){"use strict";var bt;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mgc=void 0;let yt=class extends m.$Tc{static{bt=this}static{this.a={[w.Schemas.file]:"security.promptForLocalFileProtocolHandling",[w.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Te,Le,je,ve,Se,He,Ve,Ke,Fe,xe,ze,_e){super(),this.g=Te,this.h=Le,this.j=je,this.m=ve,this.n=Se,this.s=He,this.t=Ve,this.u=Ke,this.w=Fe,this.y=xe,this.z=ze,this.C=_e,this.D(),this.F()}D(){const Te=Fe=>Fe?.startsWith(`${w.Schemas.vscodeWebview}://`),Le=new Set(["clipboard-read","clipboard-sanitized-write"]);n.session.defaultSession.setPermissionRequestHandler((Fe,xe,ze,_e)=>Te(_e.requestingUrl)?ze(Le.has(xe)):ze(!1)),n.session.defaultSession.setPermissionCheckHandler((Fe,xe,ze,_e)=>Te(_e.requestingUrl)?Le.has(xe):!1);const je=new Set([w.Schemas.file,w.Schemas.vscodeFileResource,w.Schemas.vscodeRemoteResource,w.Schemas.vscodeManagedRemoteResource,"devtools"]),ve=Fe=>{for(let xe=Fe;xe;xe=xe.parent)if(xe.url.startsWith(`${w.Schemas.vscodeWebview}://`))return!0;return!1},Se=Fe=>Fe.resourceType==="xhr"||ve(Fe.frame),He=Fe=>{const xe=Fe.frame;if(!xe||!this.b)return!1;const ze=n.BrowserWindow.getAllWindows();for(const _e of ze)if(xe.processId===_e.webContents.mainFrame.processId)return!0;return!1},Ve=(Fe,xe)=>{if(Fe.path!=="/index.html")return!0;const ze=xe.frame;if(!ze||!this.b)return!1;for(const _e of this.b.getWindows())if(_e.win&&ze.processId===_e.win.webContents.mainFrame.processId)return!0;return!1};n.session.defaultSession.webRequest.onBeforeRequest((Fe,xe)=>{const ze=b.URI.parse(Fe.url);return ze.scheme===w.Schemas.vscodeWebview&&!Ve(ze,Fe)?(this.m.error("Blocked vscode-webview request",Fe.url),xe({cancel:!0})):ze.scheme===w.Schemas.vscodeFileResource&&!He(Fe)?(this.m.error("Blocked vscode-file request",Fe.url),xe({cancel:!0})):ze.path.endsWith(".svg")&&!je.has(ze.scheme)?xe({cancel:!Se(Fe)}):xe({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Fe,xe)=>{const ze=Fe.responseHeaders,_e=ze["content-type"]||ze["Content-Type"];if(_e&&Array.isArray(_e)){const it=b.URI.parse(Fe.url);if(it.path.endsWith(".svg")&&je.has(it.scheme))return ze["Content-Type"]=["image/svg+xml"],xe({cancel:!1,responseHeaders:ze});if(!it.path.endsWith(w.Schemas.vscodeRemoteResource)&&_e.some(ot=>ot.toLowerCase().includes("image/svg")))return xe({cancel:!Se(Fe)})}return xe({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Fe,xe)=>{if(Fe.url.startsWith("https://vscode.download.prss.microsoft.com/")){const ze=Fe.responseHeaders??Object.create(null);if(ze["Access-Control-Allow-Origin"]===void 0)return ze["Access-Control-Allow-Origin"]=["*"],xe({cancel:!1,responseHeaders:ze})}return xe({cancel:!1})});const Ke=n.session.defaultSession;typeof Ke.setCodeCachePath=="function"&&this.s.codeCachePath&&Ke.setCodeCachePath((0,f.$ic)(this.s.codeCachePath,"chrome")),d.$j&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,r.disableUNCAccessRestrictions)():(0,r.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,p.setUnexpectedErrorHandler)(je=>this.G(je)),process.on("uncaughtException",je=>{(0,p.$X)(je)||(0,p.$Y)(je)}),process.on("unhandledRejection",je=>(0,p.$Y)(je)),a.Event.once(this.t.onWillShutdown)(()=>this.dispose()),(0,P.$yX)(),n.app.on("accessibility-support-changed",(je,ve)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",ve)}),n.app.on("activate",async(je,ve)=>{this.m.trace("app#activate"),ve||await this.b?.openEmptyWindow({context:Ye.OpenContext.DOCK})}),n.app.on("web-contents-created",(je,ve)=>{ve?.opener?.url.startsWith(`${w.Schemas.vscodeFileResource}://${w.$Vg}/`)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(ve)),ve.on("will-navigate",Se=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Se.preventDefault()}),ve.setWindowOpenHandler(Se=>Se.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow(Se)}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Se.url}}`),this.f?.openExternal(void 0,Se.url),{action:"deny"}))});let Te=[],Le;n.app.on("open-file",(je,ve)=>{ve=(0,kt.$jm)(ve),this.m.trace("app#open-file: ",ve),je.preventDefault(),Te.push((0,ge.$8i)(ve)?{workspaceUri:b.URI.file(ve)}:{fileUri:b.URI.file(ve)}),Le!==void 0&&(clearTimeout(Le),Le=void 0),Le=setTimeout(async()=>{await this.b?.open({context:Ye.OpenContext.DOCK,cli:this.s.args,urisToOpen:Te,gotoLineMode:!1,preferNewWindow:!0}),Te=[],Le=void 0},100)}),n.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:Ye.OpenContext.DESKTOP})}),E.$xX.handle("vscode:fetchShellEnv",je=>{const ve=this.b?.getWindowByWebContents(je.sender);let Se,He;return ve?.config?(Se=ve.config,He={...process.env,...ve.config.userEnv}):(Se=this.s.args,He=process.env),this.W(Se,He,!1)}),E.$xX.on("vscode:toggleDevTools",je=>je.sender.toggleDevTools()),E.$xX.on("vscode:openDevTools",je=>je.sender.openDevTools()),E.$xX.on("vscode:reloadWindow",je=>je.sender.reload()),E.$xX.handle("vscode:notifyZoomLevel",async(je,ve)=>{const Se=this.b?.getWindowByWebContents(je.sender);Se&&Se.notifyZoomLevel(ve)})}G(Te){if(Te){const Le={message:`[uncaught exception in main]: ${Te.message}`,stack:Te.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Le))}this.m.error(`[uncaught exception in main]: ${Te}`),Te.stack&&this.m.error(Te.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Te=this.z.win32AppUserModelId;d.$j&&Te&&n.app.setAppUserModelId(Te);try{d.$k&&this.u.getValue("window.nativeTabs")===!0&&!n.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&n.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(ze){this.m.error(ze)}const Le=new t.$EX;a.Event.once(this.t.onWillShutdown)(ze=>{ze.reason===F.ShutdownReason.KILL&&Le.dispose()}),this.m.trace("Resolving machine identifier...");const[je,ve,Se]=await Promise.all([(0,$t.$Agc)(this.w,this.m),(0,$t.$Bgc)(this.w,this.m),(0,$t.$Cgc)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${je}`);const{sharedProcessReady:He,sharedProcessClient:Ve}=this.O(je,ve,Se),Ke=await this.P(je,ve,Se,He);this.B(Ke.createInstance(i.$pfc)),this.B(Ke.createInstance(gt.$vgc)),Ke.invokeFunction(ze=>this.Q(ze,Le,Ve));const Fe=await Ke.invokeFunction(ze=>this.H(ze,Le));this.I(Le),this.t.phase=F.LifecycleMainPhase.Ready,await Ke.invokeFunction(ze=>this.R(ze,Fe)),this.t.phase=F.LifecycleMainPhase.AfterWindowOpen,this.S(),this.B(new mt.$Oh(()=>{this.B((0,mt.$Sh)(()=>this.t.phase=F.LifecycleMainPhase.Eventually,2500))},2500)).schedule()}async H(Te,Le){const je=this.b=Te.get(Ye.$Yec),ve=Te.get(Oe.$mY),Se=this.f=Te.get(Q.$Kfc),He=Te.get(L.$Tec),Ve=this;ve.registerHandler({async handleURL(it,ot){return Ve.N(je,He,ve,it,ot)}});const Ke=this.B(new ie.$qgc({onDidOpenMainWindow:Se.onDidOpenMainWindow,onDidFocusMainWindow:Se.onDidFocusMainWindow,getActiveWindowId:()=>Se.getActiveWindowId(-1)})),Fe=new S.$ki(it=>Ke.getActiveClientId().then(ot=>it===ot)),xe=new Be.$hgc(Fe,this.m),ze=Le.getChannel("urlHandler",xe);ve.registerHandler(new Be.$ggc(ze));const _e=await this.J(je,He);return this.B(new Qe.$igc(_e?.urls,ve,je,this.s,this.z,this.m)),_e}I(Te){const Le=()=>({statusCode:404,data:"Not found"}),je=new Nt.$T(()=>Te.getChannel(wt.$Jgc,new wt.$Kgc));n.protocol.registerBufferProtocol(w.Schemas.vscodeManagedRemoteResource,(ve,Se)=>{const He=b.URI.parse(ve.url);if(!He.authority.startsWith("window:"))return Se(Le());je.value.call(wt.$Igc,[He]).then(Ve=>Se({...Ve,data:Buffer.from(Ve.body,"base64")}),Ve=>{this.m.warn("error dispatching remote resource call",Ve),Se({statusCode:500,data:String(Ve)})})})}async J(Te,Le){const je=this.s.args["open-url"]?this.s.args._urls||[]:[];je.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",je);const ve=global.getOpenUrls()||[];if(ve.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",ve),je.length+ve.length===0)return;const Se=[...je,...ve].map(Ke=>{try{return{uri:b.URI.parse(Ke),originalUrl:Ke}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ke);return}}),He=[],Ve=[];for(const Ke of Se){if(!Ke)continue;const Fe=this.M(Ke.uri);if(Fe)if(await this.L(Fe,Te,Le)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ke.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ke.uri.toString(!0),Fe),He.push(Fe);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ke.uri.toString(!0)),Ve.push(Ke)}return{urls:Ve,openables:He}}async L(Te,Le,je){let ve,Se;if((0,Xe.$XD)(Te)?(ve=Te.workspaceUri,Se=(0,o.localize)(12771,null,ve.scheme===w.Schemas.file?(0,h.$Uw)(ve,{os:d.OS,tildify:this.s}):ve.toString(!0),this.z.nameShort)):(0,Xe.$YD)(Te)?(ve=Te.folderUri,Se=(0,o.localize)(12772,null,ve.scheme===w.Schemas.file?(0,h.$Uw)(ve,{os:d.OS,tildify:this.s}):ve.toString(!0),this.z.nameShort)):(ve=Te.fileUri,Se=(0,o.localize)(12773,null,ve.scheme===w.Schemas.file?(0,h.$Uw)(ve,{os:d.OS,tildify:this.s}):ve.toString(!0),this.z.nameShort)),ve.scheme!==w.Schemas.file&&ve.scheme!==w.Schemas.vscodeRemote||this.u.getValue(bt.a[ve.scheme])===!1)return!1;const{response:Ve,checkboxChecked:Ke}=await je.showMessageBox({type:"warning",buttons:[(0,o.localize)(12774,null),(0,o.localize)(12775,null)],message:Se,detail:(0,o.localize)(12776,null),checkboxLabel:ve.scheme===w.Schemas.file?(0,o.localize)(12777,null):(0,o.localize)(12778,null),cancelId:1});if(Ve!==0)return!0;if(Ke){const Fe={channel:"vscode:disablePromptForProtocolHandling",args:ve.scheme===w.Schemas.file?"local":"remote"};Le.sendToFocused(Fe.channel,Fe.args),Le.sendToOpeningWindow(Fe.channel,Fe.args)}return!1}M(Te){if(Te.path){if(Te.authority===w.Schemas.file){const Le=b.URI.file(Te.fsPath);return(0,ge.$8i)(Le)?{workspaceUri:Le}:{fileUri:Le}}else if(Te.authority===w.Schemas.vscodeRemote){const Le=Te.path.indexOf(f.$fc.sep,1);if(Le!==-1){const je=Te.path.substring(1,Le),ve=Te.path.substring(Le);let Se=Te.query;const He=new URLSearchParams(Te.query);He.get("windowId")==="_blank"&&(He.delete("windowId"),Se=He.toString());const Ve=b.URI.from({scheme:w.Schemas.vscodeRemote,authority:je,path:ve,query:Se,fragment:Te.fragment});return(0,ge.$8i)(ve)?{workspaceUri:Ve}:/:[\d]+$/.test(ve)?{fileUri:Ve}:{folderUri:Ve}}}}}async N(Te,Le,je,ve,Se){this.m.trace("app#handleProtocolUrl():",ve.toString(!0),Se),ve.scheme===this.z.urlProtocol&&ve.path==="workspace"&&(ve=ve.with({authority:"file",path:b.URI.parse(ve.query).path,query:""}));let He=!1;const Ve=new URLSearchParams(ve.query);Ve.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",ve.toString(!0)),Ve.delete("windowId"),ve=ve.with({query:Ve.toString()}),He=!0):d.$k&&Te.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",ve.toString(!0)),He=!0);const Ke=Ve.get("continueOn");Ke!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",ve.toString(!0)),Ve.delete("continueOn"),ve=ve.with({query:Ve.toString()}),this.s.continueOn=Ke??void 0);const Fe=this.M(ve);return Fe?await this.L(Fe,Te,Le)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",ve.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",Fe,ve.toString(!0)),(0,Et.$Nb)(await Te.open({context:Ye.OpenContext.API,cli:{...this.s.args},urisToOpen:[Fe],forceNewWindow:He,gotoLineMode:!0}))?.focus(),!0):He?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",ve.toString(!0)),await(0,Et.$Nb)(await Te.open({context:Ye.OpenContext.API,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,H.$dn)(ve)}))?.ready(),je.open(ve,Se)):(this.m.trace("app#handleProtocolUrl(): not handled",ve.toString(!0),Se),!1)}O(Te,Le,je){const ve=this.B(this.j.createInstance(ne.$6fc,Te,Le,je));this.B(ve.onDidCrash(()=>this.b?.sendToFocused("vscode:reportSharedProcessCrash")));const Se=(async()=>{this.m.trace("Main->SharedProcess#connect");const Ve=await ve.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new u.$FX(Ve,"main")})();return{sharedProcessReady:(async()=>(await ve.whenReady(),Se))(),sharedProcessClient:Se}}async P(Te,Le,je,ve){const Se=new oe.$Ai;switch(process.platform){case"win32":Se.set(ce.$wY,new N.$zi(Me.$egc));break;case"linux":d.$m?Se.set(ce.$wY,new N.$zi(Ce.$dgc,[process.env.SNAP,process.env.SNAP_REVISION])):Se.set(ce.$wY,new N.$zi(Ae.$cgc));break;case"darwin":Se.set(ce.$wY,new N.$zi(be.$bgc));break}Se.set(Ye.$Yec,new N.$zi(Ne.$pgc,[Te,Le,je,this.h],!1)),Se.set(St.$Jfc,new N.$zi(Ct.$Lgc,void 0,!1));const He=new L.$Uec(this.m,this.z);Se.set(L.$Tec,He),Se.set(M.$Rfc,new N.$zi(M.$Sfc,void 0,!1)),Se.set(R.$vfc,new N.$zi(R.$wfc,void 0,!1)),Se.set(y.$Pm,S.ProxyChannel.toService((0,S.$ii)(ve.then(ze=>ze.getChannel("diagnostics"))))),Se.set(G.$j_b,new N.$zi(he.$Mfc,[this.h])),Se.set(G.$k_b,new N.$zi(re.$Nfc,[this.h])),Se.set(A.$gY,new N.$zi(O.$xfc)),Se.set(_.$Ofc,new N.$zi(_.$Pfc)),Se.set(Q.$Kfc,new N.$zi(Q.$Lfc,void 0,!1)),Se.set(qe.$jgc,new N.$zi(Je.$lgc)),Se.set(q.$1fc,new N.$zi(q.$2fc)),Se.set(B.$yfc,new N.$zi(ee.$Afc)),Se.set(Re.$lfc,new N.$zi(Re.$mfc)),Se.set(Re.$nfc,new N.$zi(Re.$ofc));const Ve=new Mt.$Hgc({graceTime:dt.LocalReconnectConstants.GraceTime,shortGraceTime:dt.LocalReconnectConstants.ShortGraceTime,scrollback:this.u.getValue(dt.TerminalSettingId.PersistentSessionScrollback)??100},this.u,this.s,this.t,this.m),Ke=new Ft.$Ms(Ve,this.u,this.m,this.n);Se.set(dt.$ns,Ke),d.$j?Se.set(X.$Bfc,new N.$zi(ae.$Cfc)):d.$k?Se.set(X.$Bfc,new N.$zi(ae.$Dfc)):d.$l&&Se.set(X.$Bfc,new N.$zi(ae.$Efc));const Fe=new c.$qfc(this.s,this.u,this.m,this.w);Se.set(s.$Sec,Fe);const xe=new Ue.$_ec(this.s,this.m,this.C,Fe,He);if(Se.set(Ue.$$ec,xe),Se.set(pe.$Qhb,new N.$zi(We.$rgc,void 0,!1)),Se.set(ye.$Xfc,new N.$zi(ye.$Yfc,void 0,!1)),Se.set(Oe.$mY,new N.$zi(Ge.$oY,void 0,!1)),(0,Z.$Ap)(this.z,this.s)){const ze=(0,Z.$Fp)(this.z,this.u),_e=(0,S.$ii)(ve.then(vt=>vt.getChannel("telemetryAppender"))),it=new De.$9fc(_e),ot=(0,ke.$rp)((0,D.release)(),(0,D.hostname)(),process.arch,this.z.commit,this.z.version,Te,Le,je,ze),nt=(0,Z.$Gp)(this.s),ht={appenders:[it],commonProperties:ot,piiPaths:nt,sendErrorTelemetry:!0};Se.set(Pe.$8l,new N.$zi($e.$ds,[ht],!1))}else Se.set(Pe.$8l,Z.$vp);return Se.set(ut.$Fq,new N.$zi(Tt.$nR,void 0,!0)),Se.set(ct.$Jq,new N.$zi(ft.$ugc,void 0,!0)),Se.set(pt.$Fgc,new N.$zi(pt.$Ggc,void 0,!0)),await mt.Promises.settled([Fe.initialize(),xe.initialize()]),this.j.createChild(Se)}Q(Te,Le,je){const ve=this.B(new m.$Sc),Se=S.ProxyChannel.fromService(Te.get(M.$Rfc),ve,{disableMarshalling:!0});this.g.registerChannel("launch",Se);const He=S.ProxyChannel.fromService(Te.get(R.$vfc),ve,{disableMarshalling:!0});this.g.registerChannel("diagnostics",He);const Ve=ve.add(new lt.$sgc(Te.get(Ze.$po)));Le.registerChannel("policy",Ve),je.then(st=>st.registerChannel("policy",Ve));const Ke=this.y.getProvider(w.Schemas.file);(0,v.$mg)(Ke instanceof j.$pr);const Fe=ve.add(new z.$Ffc(Ke,this.m,this.s));Le.registerChannel(K.$9Q,Fe),je.then(st=>st.registerChannel(K.$9Q,Fe));const xe=S.ProxyChannel.fromService(Te.get(rt.$2ec),ve);Le.registerChannel("userDataProfiles",xe),je.then(st=>st.registerChannel("userDataProfiles",xe));const ze=new at.$$r(Te.get(tt.$4p));je.then(st=>st.registerChannel("request",ze));const _e=new fe.$0fc(Te.get(ce.$wY));Le.registerChannel("update",_e);const it=S.ProxyChannel.fromService(Te.get(G.$j_b),ve);Le.registerChannel("issue",it);const ot=S.ProxyChannel.fromService(Te.get(G.$k_b),ve);Le.registerChannel("process",ot);const nt=S.ProxyChannel.fromService(Te.get(A.$gY),ve);Le.registerChannel("encryption",nt);const ht=S.ProxyChannel.fromService(Te.get(de.$Vl),ve);Le.registerChannel("sign",ht);const vt=S.ProxyChannel.fromService(Te.get(_.$Ofc),ve);Le.registerChannel("keyboardLayout",vt),this.f=Te.get(Q.$Kfc);const Pt=S.ProxyChannel.fromService(this.f,ve);Le.registerChannel("nativeHost",Pt),je.then(st=>st.registerChannel("nativeHost",Pt));const Bt=S.ProxyChannel.fromService(Te.get(pe.$Qhb),ve);Le.registerChannel("workspaces",Bt);const Ut=S.ProxyChannel.fromService(Te.get(q.$1fc),ve);Le.registerChannel("menubar",Ut);const zt=S.ProxyChannel.fromService(Te.get(Oe.$mY),ve);Le.registerChannel("url",zt);const qt=S.ProxyChannel.fromService(Te.get(qe.$jgc),ve);Le.registerChannel("webview",qt);const It=ve.add(new we.$7fc(this.m,Te.get(Re.$lfc)));Le.registerChannel("storage",It),je.then(st=>st.registerChannel("storage",It));const Ht=ve.add(new Ot.$wgc(Te.get(Re.$lfc),Te.get(rt.$2ec),this.m));je.then(st=>st.registerChannel("profileStorageListener",Ht));const xt=S.ProxyChannel.fromService(Te.get(dt.$ns),ve);Le.registerChannel(dt.TerminalIpcChannels.LocalPty,xt);const Vt=S.ProxyChannel.fromService(Te.get(X.$Bfc),ve);Le.registerChannel("externalTerminal",Vt);const Rt=new Lt.$Dgc(Te.get(jt.$afc));Le.registerChannel("logger",Rt),je.then(st=>st.registerChannel("logger",Rt));const Gt=new k.$rfc(Te.get(Ye.$Yec));Le.registerChannel("extensionhostdebugservice",Gt);const Kt=S.ProxyChannel.fromService(Te.get(B.$yfc),ve);Le.registerChannel(B.$zfc,Kt);const Yt=S.ProxyChannel.fromService(Te.get(pt.$Fgc),ve);Le.registerChannel(Wt.$Egc,Yt)}async R(Te,Le){const je=this.b=Te.get(Ye.$Yec);this.c=Te.get(St.$Jfc);const ve=(0,x.$Gm)(process.env)?Ye.OpenContext.CLI:Ye.OpenContext.DESKTOP,Se=this.s.args;if(Le){if(Le.openables.length>0)return je.open({context:ve,cli:Se,urisToOpen:Le.openables,gotoLineMode:!0,initialStartup:!0});if(Le.urls.length>0)for(const nt of Le.urls){const ht=new URLSearchParams(nt.uri.query);if(ht.get("windowId")==="_blank")return ht.delete("windowId"),nt.originalUrl=nt.uri.toString(!0),nt.uri=nt.uri.with({query:ht.toString()}),je.open({context:ve,cli:Se,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const He=global.macOpenFiles,Ve=Se._.length,Ke=!!Se["folder-uri"],Fe=!!Se["file-uri"],xe=Se["skip-add-to-recently-opened"]===!0,ze=Se.wait&&Se.waitMarkerFilePath?b.URI.file(Se.waitMarkerFilePath):void 0,_e=Se.remote||void 0,it=Se.profile,ot=Se["profile-temp"];if(!Ve&&!Ke&&!Fe){if(Se["new-window"]||it||ot)return je.open({context:ve,cli:Se,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:xe,waitMarkerFileURI:ze,initialStartup:!0,remoteAuthority:_e,forceProfile:it,forceTempProfile:ot});if(He.length)return je.open({context:Ye.OpenContext.DOCK,cli:Se,urisToOpen:He.map(nt=>(nt=(0,kt.$jm)(nt),(0,ge.$8i)(nt)?{workspaceUri:b.URI.file(nt)}:{fileUri:b.URI.file(nt)})),noRecentEntry:xe,waitMarkerFileURI:ze,initialStartup:!0})}return je.open({context:ve,cli:Se,forceNewWindow:Se["new-window"],diffMode:Se.diff,mergeMode:Se.merge,noRecentEntry:xe,waitMarkerFileURI:ze,gotoLineMode:Se.goto,initialStartup:!0,remoteAuthority:_e,forceProfile:it,forceTempProfile:ot})}S(){this.U(),n.protocol.registerHttpProtocol(w.Schemas.vscodeRemoteResource,(Te,Le)=>{Le({url:Te.url.replace(/^vscode-remote-resource:/,"http:"),method:Te.method})}),this.W(this.s.args,process.env,!0),this.X(),d.$k&&n.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async U(){const Te=this.z.win32MutexName;if(d.$j&&Te)try{const Le=await new Promise((ve,Se)=>{Y(["@vscode/windows-mutex"],ve,Se)}).then(Ie),je=new Le.Mutex(Te);a.Event.once(this.t.onWillShutdown)(()=>je.release())}catch(Le){this.m.error(Le)}}async W(Te,Le,je){try{return await(0,C.$Nm)(this.u,this.m,Te,Le)}catch(ve){const Se=(0,I.$nj)(ve);je?this.b?.sendToFocused("vscode:showResolveShellEnvError",Se):this.m.error(Se)}return{}}async X(){try{const Le=(await this.y.readFile(this.s.argvResource)).value.toString(),je=(0,g.parse)(Le),Se=(0,Z.$Cp)(this.u)>=Pe.TelemetryLevel.CRASH;if(je["enable-crash-reporter"]===void 0){const He=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Se},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,$.$Yg)()}"`,"}"],Ve=Le.substring(0,Le.length-2).concat(`,
`,He.join(`
`));await this.y.writeFile(this.s.argvResource,T.$Le.fromString(Ve))}else{const He=Le.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Se},`);He!==Le&&await this.y.writeFile(this.s.argvResource,T.$Le.fromString(He))}}catch(Te){this.m.error(Te),this.b?.sendToFocused("vscode:showArgvParseWarning")}}};e.$Mgc=yt,e.$Mgc=yt=bt=Ee([se(2,V.$Bi),se(3,U.$9j),se(4,U.$0j),se(5,W.$Nec),se(6,F.$ffc),se(7,l.$9i),se(8,me.$gR),se(9,te.$9k),se(10,J.$pk),se(11,rt.$2ec)],yt)});var et=this&&this.__importDefault||function(Y){return Y&&Y.__esModule?Y:{default:Y}};define(le[283],ue([0,1,13,26,7,20,8,54,15,32,4,47,11,9,70,3,36,25,23,44,104,278,10,17,203,217,22,68,168,14,187,99,83,183,98,19,190,5,72,28,73,244,131,255,56,254,101,216,34,57,76,58,40,199,197,2,41,232,71,192,123,127,236,106,230]),function(Y,e,n,r,E,D,T,I,p,a,g,h,m,w,f,d,v,b,$,P,S,t,u,i,o,s,c,l,k,y,R,L,A,O,W,x,C,B,ee,X,ae,K,te,z,j,N,V,oe,G,he,re,_,M,F,U,q,Q,J,H,ne,de,me,we,Re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),ee=et(ee);class ke{main(){try{this.a()}catch($e){console.error($e.message),n.app.exit(1)}}async a(){(0,p.setUnexpectedErrorHandler)(Oe=>console.error(Oe));const[$e,Z,ce,fe,be,Ae,Ce,Me]=this.b();try{try{await this.d(ce,Me,fe,be,Ce)}catch(Oe){throw this.g(ce,Ce,Oe),Oe}await $e.invokeFunction(async Oe=>{const Be=Oe.get(B.$9j),Ge=Oe.get(x.$ffc),Qe=Oe.get(y.$9k),qe=Oe.get(B.$0j),Je=await this.f(Be,ce,Ge,$e,Ce,!0);return $.Promises.writeFile(ce.mainLockfile,String(process.pid)).catch(Xe=>{Be.warn(`app#startup(): Error writing main lockfile: ${Xe.stack}`)}),Ae.logger=qe.createLogger("main",{name:(0,u.localize)(12762,null)}),g.Event.once(Ge.onWillShutdown)(Xe=>{Qe.dispose(),fe.dispose(),Xe.join("instanceLockfile",r.promises.unlink(ce.mainLockfile).catch(()=>{}))}),$e.createInstance(t.$Mgc,Je,Z).startup()})}catch(Oe){$e.invokeFunction(this.j,Oe)}}b(){const $e=new W.$Ai,Z=new q.$Sc;process.once("exit",()=>Z.dispose());const ce={_serviceBrand:void 0,...ee.default};$e.set(X.$pk,ce);const fe=new c.$Oec(this.k(),ce),be=this.c(fe);$e.set(c.$Nec,fe);const Ae=new H.$bfc((0,B.$kk)(fe),fe.logsHome);$e.set(H.$afc,Ae);const Ce=new C.$mcc(Ae.getLogLevel()),Me=Z.add(new ne.$oR(Ce,[new B.$dk(Ae.getLogLevel())]));$e.set(B.$9j,Me);const Oe=new R.$Yq(Me);$e.set(y.$9k,Oe);const Be=new L.$pr(Me);Oe.registerProvider(m.Schemas.file,Be);const Ge=new J.$Qs(Oe);$e.set(Q.$Gl,Ge);const Qe=new me.$jR(me.SaveStrategy.DELAYED,fe,Me,Oe);$e.set(G.$fR,Qe),$e.set(G.$gR,Qe);const qe=new _.$3ec(Qe,Ge,fe,Oe,Me);$e.set(_.$2ec,qe),Oe.registerProvider(m.Schemas.vscodeUserData,new we.$Xgc(m.Schemas.file,Be,m.Schemas.vscodeUserData,qe,Ge,Me));const Je=d.$j&&ce.win32RegValueName?Z.add(new F.$Vgc(Me,ce.win32RegValueName)):fe.policyFile?Z.add(new U.$Wgc(fe.policyFile,Oe,Me)):new M.$ro;$e.set(M.$po,Je);const Xe=new o.$To(qe.defaultProfile.settingsResource,Oe,Je,Me);return $e.set(i.$9i,Xe),$e.set(x.$ffc,new A.$zi(x.$gfc,void 0,!1)),$e.set(j.$4p,new A.$zi(N.$Tgc,void 0,!0)),$e.set(re.$Wec,new A.$zi(re.$Xec)),$e.set(V.$Vl,new A.$zi(oe.$Ugc,void 0,!1)),$e.set(te.$zw,new A.$zi(z.$Rgc)),$e.set(ae.$Vec,new K.$Ogc(fe,qe,Me)),[new O.$sr($e,!0),be,fe,Xe,Qe,Ce,ce,qe]}c($e){const Z={VSCODE_IPC_HOOK:$e.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ce=>{const fe=process.env[ce];typeof fe=="string"&&(Z[ce]=fe)}),Object.assign(process.env,Z),Z}async d($e,Z,ce,fe,be){await T.Promises.settled([Promise.all([this.e($e.extensionsPath),$e.codeCachePath,$e.logsHome.with({scheme:m.Schemas.file}).fsPath,Z.defaultProfile.globalStorageHome.with({scheme:m.Schemas.file}).fsPath,$e.workspaceStorageHome.with({scheme:m.Schemas.file}).fsPath,$e.localHistoryHome.with({scheme:m.Schemas.file}).fsPath,$e.backupHome].map(Ae=>Ae?r.promises.mkdir(Ae,{recursive:!0}):void 0)),fe.init(),ce.initialize()]),Z.init()}e($e){if(d.$j){const Z=(0,Re.getUNCHost)($e);Z&&(0,Re.addUNCHostToAllowlist)(Z)}return $e}async f($e,Z,ce,fe,be,Ae){let Ce;try{(0,f.mark)("code/willStartMainServer"),Ce=await(0,S.$xi)(Z.mainIPCHandle),(0,f.mark)("code/didStartMainServer"),g.Event.once(ce.onWillShutdown)(()=>Ce.dispose())}catch(Me){if(Me.code!=="EADDRINUSE")throw this.g(Z,be,Me),Me;let Oe;try{Oe=await(0,S.$yi)(Z.mainIPCHandle,"main")}catch(qe){if(!Ae||d.$j||qe.code!=="ECONNREFUSED")throw qe.code==="EPERM"&&this.h((0,u.localize)(12763,null,be.nameShort),(0,u.localize)(12764,null),be),qe;try{(0,r.unlinkSync)(Z.mainIPCHandle)}catch(Je){throw $e.warn("Could not delete obsolete instance handle",Je),Je}return this.f($e,Z,ce,fe,be,!1)}if(Z.extensionTestsLocationURI&&!Z.debugExtensionHost.break){const qe=`Running extension tests from the command line is currently only supported if no other instance of ${be.nameShort} is running.`;throw $e.error(qe),Oe.dispose(),new Error(qe)}let Be;!Z.args.wait&&!Z.args.status&&(Be=setTimeout(()=>{this.h((0,u.localize)(12765,null,be.nameShort),(0,u.localize)(12766,null),be)},1e4));const Ge=P.ProxyChannel.toService(Oe.getChannel("launch"),{disableMarshalling:!0}),Qe=P.ProxyChannel.toService(Oe.getChannel("diagnostics"),{disableMarshalling:!0});if(Z.args.status)return fe.invokeFunction(async()=>{const qe=new s.$Xs(he.$vp,be),Je=await Qe.getMainDiagnostics(),Xe=await Qe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ye=await qe.getDiagnostics(Je,Xe);throw console.log(Ye),new p.$_});throw d.$j&&await this.i(Ge,$e),$e.trace("Sending env to running instance..."),await Ge.start(Z.args,process.env),Oe.dispose(),Be&&clearTimeout(Be),new p.$_("Sent env to running instance. Terminating...")}if(Z.args.status)throw console.log((0,u.localize)(12767,null,be.nameShort)),new p.$_("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ce}g($e,Z,ce){if(ce.code==="EACCES"||ce.code==="EPERM"){const fe=(0,D.$Gb)([$e.userDataPath,$e.extensionsPath,S.$ti]).map(be=>(0,h.$Uw)(E.URI.file(be),{os:d.OS,tildify:$e}));this.h((0,u.localize)(12768,null),(0,u.localize)(12769,null,(0,I.$nj)(ce),fe.join(`
`)),Z)}}h($e,Z,ce){n.dialog.showMessageBoxSync((0,de.$9w)({type:"warning",buttons:[(0,u.localize)(12770,null)],message:$e,detail:Z},ce).options)}async i($e,Z){if(d.$j){const ce=await $e.getMainProcessId();Z.trace("Sending some foreground love to the running instance:",ce);try{(await new Promise((fe,be)=>{Y(["windows-foreground-love"],fe,be)}).then(Ie)).allowSetForegroundWindow(ce)}catch(fe){Z.error(fe)}}}j($e,Z){const ce=$e.get(B.$9j),fe=$e.get(x.$ffc);let be=0;Z&&(Z.isExpected?Z.message&&ce.trace(Z.message):(be=1,Z.stack?ce.error(Z.stack):ce.error(`Startup error: ${Z.toString()}`))),fe.kill(be)}k(){const $e=this.l((0,l.$Dm)(process.argv));if($e.wait&&!$e.waitMarkerFilePath){const Z=(0,k.$Ngc)($e.verbose);Z&&((0,l.$Fm)(process.argv,"--waitMarkerFilePath",Z),$e.waitMarkerFilePath=Z)}return $e}l($e){if($e["open-url"]&&($e._urls=$e._,$e._=[]),!$e.remote){const Z=this.m($e._,$e.goto);$e._=Z}return $e}m($e,Z){const ce=(0,v.cwd)(),fe=$e.map(Ce=>{let Me=String(Ce),Oe;Z&&(Oe=(0,a.$Jg)(Me),Me=Oe.path),Me&&(Me=this.n(ce,Me));const Be=(0,a.$Dg)(Me,ce),Ge=(0,w.$mc)(Be);return Ge&&!(0,a.$zg)(Ge)?null:Z&&Oe?(Oe.path=Be,this.o(Oe)):Be}),be=d.$j||d.$k,Ae=(0,D.$Lb)(fe,Ce=>Ce&&be?Ce.toLowerCase():Ce||"");return(0,D.$Gb)(Ae)}n($e,Z){return d.$j&&(Z=(0,b.$lf)(Z,'"')),Z=(0,b.$jf)((0,b.$jf)(Z," "),"	"),d.$j&&(Z=(0,w.$jc)($e,Z),Z=(0,b.$lf)(Z,".")),Z}o($e){const Z=[$e.path];return typeof $e.line=="number"&&Z.push(String($e.line)),typeof $e.column=="number"&&Z.push(String($e.column)),Z.join(":")}}new ke().main()})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/e6a828c5957959b7a18de37a567d850880101641/core/vs/code/electron-main/main.js.map
