/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/async","vs/platform/files/common/files","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/base/common/map","vs/base/common/strings","fs","vs/platform/product/common/productService","vs/base/common/json","os","vs/base/common/process","vs/platform/registry/common/platform","vs/base/common/errorMessage","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/processes","vs/base/common/severity","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/extpath","vs/platform/instantiation/common/serviceCollection","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/languagePacks/common/languagePacks","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/storage/common/storage","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/console","vs/amdX","vs/base/node/macAddress","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/base/common/date","vs/base/common/jsonErrorMessages","vs/platform/contextkey/common/scanner","vs/base/common/charCode","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","vs/base/common/marshallingIds","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],ue=function(Y){for(var e=[],S=0,P=Y.length;S<P;S++)e[S]=le[Y[S]];return e};define(le[74],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.LoaderEventType=e.$R=void 0,e.$R=!1;var S;(function($){$[$.LoaderAvailable=1]="LoaderAvailable",$[$.BeginLoadingScript=10]="BeginLoadingScript",$[$.EndLoadingScriptOK=11]="EndLoadingScriptOK",$[$.EndLoadingScriptError=12]="EndLoadingScriptError",$[$.BeginInvokeFactory=21]="BeginInvokeFactory",$[$.EndInvokeFactory=22]="EndInvokeFactory",$[$.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",$[$.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",$[$.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",$[$.NodeEndNativeRequire=34]="NodeEndNativeRequire",$[$.CachedDataFound=60]="CachedDataFound",$[$.CachedDataMissed=61]="CachedDataMissed",$[$.CachedDataRejected=62]="CachedDataRejected",$[$.CachedDataCreated=63]="CachedDataCreated"})(S||(e.LoaderEventType=S={}));class P{static get(){const I=new Map,L=new Map,k=new Map,g=new Map;function a(y,R){y.has(R.detail)||y.set(R.detail,-R.timestamp)}function f(y,R){const E=y.get(R.detail);E&&(E>=0||y.set(R.detail,E+R.timestamp))}let c=[];typeof Y=="function"&&typeof Y.getStats=="function"&&(c=Y.getStats().slice(0).sort((y,R)=>y.timestamp-R.timestamp));for(const y of c)switch(y.type){case S.BeginLoadingScript:a(I,y);break;case S.EndLoadingScriptOK:case S.EndLoadingScriptError:f(I,y);break;case S.BeginInvokeFactory:a(L,y);break;case S.EndInvokeFactory:f(L,y);break;case S.NodeBeginNativeRequire:a(k,y);break;case S.NodeEndNativeRequire:f(k,y);break;case S.NodeBeginEvaluatingScript:a(g,y);break;case S.NodeEndEvaluatingScript:f(g,y);break}let h=0;k.forEach(y=>h+=y);function p(y){const R=[];return y.forEach((E,d)=>R.push([d,E])),R}return{amdLoad:p(I),amdInvoke:p(L),nodeRequire:p(k),nodeEval:p(g),nodeRequireTotal:h}}static toMarkdownTable(I,L){let k="";const g=[];return I.forEach((a,f)=>{g[f]=a.length}),L.forEach(a=>{a.forEach((f,c)=>{typeof f>"u"&&(f=a[c]="-");const h=f.toString().length;g[c]=Math.max(h,g[c])})}),I.forEach((a,f)=>{k+=`| ${a+" ".repeat(g[f]-a.toString().length)} `}),k+=`|
`,I.forEach((a,f)=>{k+=`| ${"-".repeat(g[f])} `}),k+=`|
`,L.forEach(a=>{a.forEach((f,c)=>{typeof f<"u"&&(k+=`| ${f+" ".repeat(g[c]-f.toString().length)} `)}),k+=`|
`}),k}}e.$S=P}),define(le[55],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=P,e.$8h=$,e.$9h=I;function S(L){return(k,g,a)=>{let f=null,c=null;if(typeof a.value=="function"?(f="value",c=a.value):typeof a.get=="function"&&(f="get",c=a.get),!c)throw new Error("not supported");a[f]=L(c,g)}}function P(L,k,g){let a=null,f=null;if(typeof g.value=="function"?(a="value",f=g.value,f.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(a="get",f=g.get),!f)throw new Error("not supported");const c=`$memoize$${k}`;g[a]=function(...h){return this.hasOwnProperty(c)||Object.defineProperty(this,c,{configurable:!1,enumerable:!1,writable:!1,value:f.apply(this,h)}),this[c]}}function $(L,k,g){return S((a,f)=>{const c=`$debounce$${f}`,h=`$debounce$result$${f}`;return function(...p){this[h]||(this[h]=g?g():void 0),clearTimeout(this[c]),k&&(this[h]=k(this[h],...p),p=[this[h]]),this[c]=setTimeout(()=>{a.apply(this,p),this[h]=g?g():void 0},L)}})}function I(L,k,g){return S((a,f)=>{const c=`$throttle$timer$${f}`,h=`$throttle$result$${f}`,p=`$throttle$lastRun$${f}`,y=`$throttle$pending$${f}`;return function(...R){if(this[h]||(this[h]=g?g():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),k&&(this[h]=k(this[h],...R)),this[y])return;const E=this[p]+L;E<=Date.now()?(this[p]=Date.now(),a.apply(this,[this[h]]),this[h]=g?g():void 0):(this[y]=!0,this[c]=setTimeout(()=>{this[y]=!1,this[p]=Date.now(),a.apply(this,[this[h]]),this[h]=g?g():void 0},E-Date.now()))}})}}),define(le[75],ue([0,1,7]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=P,e.$dd=$,e.$ed=I,e.$fd=L,e.$gd=k,e.$hd=g;function P(a,f){if(!a)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}function $(a,f="Unreachable"){throw new Error(f)}function I(a,f="unexpected state"){if(!a)throw new S.$bb(`Assertion Failed: ${f}`)}function L(a){a||(0,S.$Y)(new S.$bb("Soft Assertion Failed"))}function k(a){if(!a()){debugger;a(),(0,S.$Y)(new S.$bb("Assertion Failed"))}}function g(a,f){let c=0;for(;c<a.length-1;){const h=a[c],p=a[c+1];if(!f(h,p))return!1;c++}return!0}}),define(le[34],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Sn=L,e.$Tn=c,e.$Un=h,e.$Vn=p,e.$Wn=y,e.$Xn=R,e.$Yn=E,e.$Zn=d,e.$1n=m,e.$2n=A,e.$3n=w;var S;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var P;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(P||(e.SyntaxKind=P={}));var $;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})($||(e.ParseErrorCode=$={}));var I;(function(i){i.DEFAULT={allowTrailingComma:!0}})(I||(e.ParseOptions=I={}));function L(i,l=!1){let n=0;const r=i.length;let t="",s=0,o=P.Unknown,u=S.None;function v(J){let re=0,ae=0;for(;re<J;){const ce=i.charCodeAt(n);if(ce>=f._0&&ce<=f._9)ae=ae*16+ce-f._0;else if(ce>=f.A&&ce<=f.F)ae=ae*16+ce-f.A+10;else if(ce>=f.a&&ce<=f.f)ae=ae*16+ce-f.a+10;else break;n++,re++}return re<J&&(ae=-1),ae}function N(J){n=J,t="",s=0,o=P.Unknown,u=S.None}function T(){const J=n;if(i.charCodeAt(n)===f._0)n++;else for(n++;n<i.length&&a(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===f.dot)if(n++,n<i.length&&a(i.charCodeAt(n)))for(n++;n<i.length&&a(i.charCodeAt(n));)n++;else return u=S.UnexpectedEndOfNumber,i.substring(J,n);let re=n;if(n<i.length&&(i.charCodeAt(n)===f.E||i.charCodeAt(n)===f.e))if(n++,(n<i.length&&i.charCodeAt(n)===f.plus||i.charCodeAt(n)===f.minus)&&n++,n<i.length&&a(i.charCodeAt(n))){for(n++;n<i.length&&a(i.charCodeAt(n));)n++;re=n}else u=S.UnexpectedEndOfNumber;return i.substring(J,re)}function O(){let J="",re=n;for(;;){if(n>=r){J+=i.substring(re,n),u=S.UnexpectedEndOfString;break}const ae=i.charCodeAt(n);if(ae===f.doubleQuote){J+=i.substring(re,n),n++;break}if(ae===f.backslash){if(J+=i.substring(re,n),n++,n>=r){u=S.UnexpectedEndOfString;break}switch(i.charCodeAt(n++)){case f.doubleQuote:J+='"';break;case f.backslash:J+="\\";break;case f.slash:J+="/";break;case f.b:J+="\b";break;case f.f:J+="\f";break;case f.n:J+=`
`;break;case f.r:J+="\r";break;case f.t:J+="	";break;case f.u:{const de=v(4);de>=0?J+=String.fromCharCode(de):u=S.InvalidUnicode;break}default:u=S.InvalidEscapeCharacter}re=n;continue}if(ae>=0&&ae<=31)if(g(ae)){J+=i.substring(re,n),u=S.UnexpectedEndOfString;break}else u=S.InvalidCharacter;n++}return J}function D(){if(t="",u=S.None,s=n,n>=r)return s=r,o=P.EOF;let J=i.charCodeAt(n);if(k(J)){do n++,t+=String.fromCharCode(J),J=i.charCodeAt(n);while(k(J));return o=P.Trivia}if(g(J))return n++,t+=String.fromCharCode(J),J===f.carriageReturn&&i.charCodeAt(n)===f.lineFeed&&(n++,t+=`
`),o=P.LineBreakTrivia;switch(J){case f.openBrace:return n++,o=P.OpenBraceToken;case f.closeBrace:return n++,o=P.CloseBraceToken;case f.openBracket:return n++,o=P.OpenBracketToken;case f.closeBracket:return n++,o=P.CloseBracketToken;case f.colon:return n++,o=P.ColonToken;case f.comma:return n++,o=P.CommaToken;case f.doubleQuote:return n++,t=O(),o=P.StringLiteral;case f.slash:{const re=n-1;if(i.charCodeAt(n+1)===f.slash){for(n+=2;n<r&&!g(i.charCodeAt(n));)n++;return t=i.substring(re,n),o=P.LineCommentTrivia}if(i.charCodeAt(n+1)===f.asterisk){n+=2;const ae=r-1;let ce=!1;for(;n<ae;){if(i.charCodeAt(n)===f.asterisk&&i.charCodeAt(n+1)===f.slash){n+=2,ce=!0;break}n++}return ce||(n++,u=S.UnexpectedEndOfComment),t=i.substring(re,n),o=P.BlockCommentTrivia}return t+=String.fromCharCode(J),n++,o=P.Unknown}case f.minus:if(t+=String.fromCharCode(J),n++,n===r||!a(i.charCodeAt(n)))return o=P.Unknown;case f._0:case f._1:case f._2:case f._3:case f._4:case f._5:case f._6:case f._7:case f._8:case f._9:return t+=T(),o=P.NumericLiteral;default:for(;n<r&&q(J);)n++,J=i.charCodeAt(n);if(s!==n){switch(t=i.substring(s,n),t){case"true":return o=P.TrueKeyword;case"false":return o=P.FalseKeyword;case"null":return o=P.NullKeyword}return o=P.Unknown}return t+=String.fromCharCode(J),n++,o=P.Unknown}}function q(J){if(k(J)||g(J))return!1;switch(J){case f.closeBrace:case f.closeBracket:case f.openBrace:case f.openBracket:case f.doubleQuote:case f.colon:case f.comma:case f.slash:return!1}return!0}function K(){let J;do J=D();while(J>=P.LineCommentTrivia&&J<=P.Trivia);return J}return{setPosition:N,getPosition:()=>n,scan:l?K:D,getToken:()=>o,getTokenValue:()=>t,getTokenOffset:()=>s,getTokenLength:()=>n-s,getTokenError:()=>u}}function k(i){return i===f.space||i===f.tab||i===f.verticalTab||i===f.formFeed||i===f.nonBreakingSpace||i===f.ogham||i>=f.enQuad&&i<=f.zeroWidthSpace||i===f.narrowNoBreakSpace||i===f.mathematicalSpace||i===f.ideographicSpace||i===f.byteOrderMark}function g(i){return i===f.lineFeed||i===f.carriageReturn||i===f.lineSeparator||i===f.paragraphSeparator}function a(i){return i>=f._0&&i<=f._9}var f;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(f||(f={}));function c(i,l){const n=[],r=new Object;let t;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function u(v,N,T,O){s.value=v,s.offset=N,s.length=T,s.type=O,s.colonOffset=void 0,t=s}try{A(i,{onObjectBegin:(v,N)=>{if(l<=v)throw r;t=void 0,o=l>v,n.push("")},onObjectProperty:(v,N,T)=>{if(l<N||(u(v,N,T,"property"),n[n.length-1]=v,l<=N+T))throw r},onObjectEnd:(v,N)=>{if(l<=v)throw r;t=void 0,n.pop()},onArrayBegin:(v,N)=>{if(l<=v)throw r;t=void 0,n.push(0)},onArrayEnd:(v,N)=>{if(l<=v)throw r;t=void 0,n.pop()},onLiteralValue:(v,N,T)=>{if(l<N||(u(v,N,T,w(v)),l<=N+T))throw r},onSeparator:(v,N,T)=>{if(l<=N)throw r;if(v===":"&&t&&t.type==="property")t.colonOffset=N,o=!1,t=void 0;else if(v===","){const O=n[n.length-1];typeof O=="number"?n[n.length-1]=O+1:(o=!0,n[n.length-1]=""),t=void 0}}})}catch(v){if(v!==r)throw v}return{path:n,previousNode:t,isAtPropertyKey:o,matches:v=>{let N=0;for(let T=0;N<v.length&&T<n.length;T++)if(v[N]===n[T]||v[N]==="*")N++;else if(v[N]!=="**")return!1;return N===v.length}}}function h(i,l=[],n=I.DEFAULT){let r=null,t=[];const s=[];function o(v){Array.isArray(t)?t.push(v):r!==null&&(t[r]=v)}return A(i,{onObjectBegin:()=>{const v={};o(v),s.push(t),t=v,r=null},onObjectProperty:v=>{r=v},onObjectEnd:()=>{t=s.pop()},onArrayBegin:()=>{const v=[];o(v),s.push(t),t=v,r=null},onArrayEnd:()=>{t=s.pop()},onLiteralValue:o,onError:(v,N,T)=>{l.push({error:v,offset:N,length:T})}},n),t[0]}function p(i,l=[],n=I.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(v){r.type==="property"&&(r.length=v-r.offset,r=r.parent)}function s(v){return r.children.push(v),v}A(i,{onObjectBegin:v=>{r=s({type:"object",offset:v,length:-1,parent:r,children:[]})},onObjectProperty:(v,N,T)=>{r=s({type:"property",offset:N,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:v,offset:N,length:T,parent:r})},onObjectEnd:(v,N)=>{r.length=v+N-r.offset,r=r.parent,t(v+N)},onArrayBegin:(v,N)=>{r=s({type:"array",offset:v,length:-1,parent:r,children:[]})},onArrayEnd:(v,N)=>{r.length=v+N-r.offset,r=r.parent,t(v+N)},onLiteralValue:(v,N,T)=>{s({type:w(v),offset:N,length:T,parent:r,value:v}),t(N+T)},onSeparator:(v,N,T)=>{r.type==="property"&&(v===":"?r.colonOffset=N:v===","&&t(N))},onError:(v,N,T)=>{l.push({error:v,offset:N,length:T})}},n);const u=r.children[0];return u&&delete u.parent,u}function y(i,l){if(!i)return;let n=i;for(const r of l)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const s of n.children)if(Array.isArray(s.children)&&s.children[0].value===r){n=s.children[1],t=!0;break}if(!t)return}else{const t=r;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}function R(i){if(!i.parent||!i.parent.children)return[];const l=R(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;l.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&l.push(n)}return l}function E(i){switch(i.type){case"array":return i.children.map(E);case"object":{const l=Object.create(null);for(const n of i.children){const r=n.children[1];r&&(l[n.children[0].value]=E(r))}return l}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function d(i,l,n=!1){return l>=i.offset&&l<i.offset+i.length||n&&l===i.offset+i.length}function m(i,l,n=!1){if(d(i,l,n)){const r=i.children;if(Array.isArray(r))for(let t=0;t<r.length&&r[t].offset<=l;t++){const s=m(r[t],l,n);if(s)return s}return i}}function A(i,l,n=I.DEFAULT){const r=L(i,!1);function t(X){return X?()=>X(r.getTokenOffset(),r.getTokenLength()):()=>!0}function s(X){return X?te=>X(te,r.getTokenOffset(),r.getTokenLength()):()=>!0}const o=t(l.onObjectBegin),u=s(l.onObjectProperty),v=t(l.onObjectEnd),N=t(l.onArrayBegin),T=t(l.onArrayEnd),O=s(l.onLiteralValue),D=s(l.onSeparator),q=t(l.onComment),K=s(l.onError),J=n&&n.disallowComments,re=n&&n.allowTrailingComma;function ae(){for(;;){const X=r.scan();switch(r.getTokenError()){case S.InvalidUnicode:ce($.InvalidUnicode);break;case S.InvalidEscapeCharacter:ce($.InvalidEscapeCharacter);break;case S.UnexpectedEndOfNumber:ce($.UnexpectedEndOfNumber);break;case S.UnexpectedEndOfComment:J||ce($.UnexpectedEndOfComment);break;case S.UnexpectedEndOfString:ce($.UnexpectedEndOfString);break;case S.InvalidCharacter:ce($.InvalidCharacter);break}switch(X){case P.LineCommentTrivia:case P.BlockCommentTrivia:J?ce($.InvalidCommentToken):q();break;case P.Unknown:ce($.InvalidSymbol);break;case P.Trivia:case P.LineBreakTrivia:break;default:return X}}}function ce(X,te=[],ne=[]){if(K(X),te.length+ne.length>0){let j=r.getToken();for(;j!==P.EOF;){if(te.indexOf(j)!==-1){ae();break}else if(ne.indexOf(j)!==-1)break;j=ae()}}}function de(X){const te=r.getTokenValue();return X?O(te):u(te),ae(),!0}function H(){switch(r.getToken()){case P.NumericLiteral:{let X=0;try{X=JSON.parse(r.getTokenValue()),typeof X!="number"&&(ce($.InvalidNumberFormat),X=0)}catch{ce($.InvalidNumberFormat)}O(X);break}case P.NullKeyword:O(null);break;case P.TrueKeyword:O(!0);break;case P.FalseKeyword:O(!1);break;default:return!1}return ae(),!0}function Z(){return r.getToken()!==P.StringLiteral?(ce($.PropertyNameExpected,[],[P.CloseBraceToken,P.CommaToken]),!1):(de(!1),r.getToken()===P.ColonToken?(D(":"),ae(),G()||ce($.ValueExpected,[],[P.CloseBraceToken,P.CommaToken])):ce($.ColonExpected,[],[P.CloseBraceToken,P.CommaToken]),!0)}function B(){o(),ae();let X=!1;for(;r.getToken()!==P.CloseBraceToken&&r.getToken()!==P.EOF;){if(r.getToken()===P.CommaToken){if(X||ce($.ValueExpected,[],[]),D(","),ae(),r.getToken()===P.CloseBraceToken&&re)break}else X&&ce($.CommaExpected,[],[]);Z()||ce($.ValueExpected,[],[P.CloseBraceToken,P.CommaToken]),X=!0}return v(),r.getToken()!==P.CloseBraceToken?ce($.CloseBraceExpected,[P.CloseBraceToken],[]):ae(),!0}function z(){N(),ae();let X=!1;for(;r.getToken()!==P.CloseBracketToken&&r.getToken()!==P.EOF;){if(r.getToken()===P.CommaToken){if(X||ce($.ValueExpected,[],[]),D(","),ae(),r.getToken()===P.CloseBracketToken&&re)break}else X&&ce($.CommaExpected,[],[]);G()||ce($.ValueExpected,[],[P.CloseBracketToken,P.CommaToken]),X=!0}return T(),r.getToken()!==P.CloseBracketToken?ce($.CloseBracketExpected,[P.CloseBracketToken],[]):ae(),!0}function G(){switch(r.getToken()){case P.OpenBracketToken:return z();case P.OpenBraceToken:return B();case P.StringLiteral:return de(!0);default:return H()}}return ae(),r.getToken()===P.EOF?n.allowEmptyContent?!0:(ce($.ValueExpected,[],[]),!1):G()?(r.getToken()!==P.EOF&&ce($.EndOfFileExpected,[],[]),!0):(ce($.ValueExpected,[],[]),!1)}function w(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(le[76],ue([0,1,34]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4n=P,e.$5n=$,e.$6n=k,e.$7n=g;function P(a,f,c){let h,p,y,R,E;if(f){for(R=f.offset,E=R+f.length,y=R;y>0&&!g(a,y-1);)y--;let u=E;for(;u<a.length&&!g(a,u);)u++;p=a.substring(y,u),h=L(p,c)}else p=a,h=0,y=0,R=0,E=a.length;const d=k(c,a);let m=!1,A=0,w;c.insertSpaces?w=I(" ",c.tabSize||4):w="	";const i=(0,S.$Sn)(p,!1);let l=!1;function n(){return d+I(w,h+A)}function r(){let u=i.scan();for(m=!1;u===S.SyntaxKind.Trivia||u===S.SyntaxKind.LineBreakTrivia;)m=m||u===S.SyntaxKind.LineBreakTrivia,u=i.scan();return l=u===S.SyntaxKind.Unknown||i.getTokenError()!==S.ScanError.None,u}const t=[];function s(u,v,N){!l&&v<E&&N>R&&a.substring(v,N)!==u&&t.push({offset:v,length:N-v,content:u})}let o=r();if(o!==S.SyntaxKind.EOF){const u=i.getTokenOffset()+y,v=I(w,h);s(v,y,u)}for(;o!==S.SyntaxKind.EOF;){let u=i.getTokenOffset()+i.getTokenLength()+y,v=r(),N="";for(;!m&&(v===S.SyntaxKind.LineCommentTrivia||v===S.SyntaxKind.BlockCommentTrivia);){const O=i.getTokenOffset()+y;s(" ",u,O),u=i.getTokenOffset()+i.getTokenLength()+y,N=v===S.SyntaxKind.LineCommentTrivia?n():"",v=r()}if(v===S.SyntaxKind.CloseBraceToken)o!==S.SyntaxKind.OpenBraceToken&&(A--,N=n());else if(v===S.SyntaxKind.CloseBracketToken)o!==S.SyntaxKind.OpenBracketToken&&(A--,N=n());else{switch(o){case S.SyntaxKind.OpenBracketToken:case S.SyntaxKind.OpenBraceToken:A++,N=n();break;case S.SyntaxKind.CommaToken:case S.SyntaxKind.LineCommentTrivia:N=n();break;case S.SyntaxKind.BlockCommentTrivia:m?N=n():N=" ";break;case S.SyntaxKind.ColonToken:N=" ";break;case S.SyntaxKind.StringLiteral:if(v===S.SyntaxKind.ColonToken){N="";break}case S.SyntaxKind.NullKeyword:case S.SyntaxKind.TrueKeyword:case S.SyntaxKind.FalseKeyword:case S.SyntaxKind.NumericLiteral:case S.SyntaxKind.CloseBraceToken:case S.SyntaxKind.CloseBracketToken:v===S.SyntaxKind.LineCommentTrivia||v===S.SyntaxKind.BlockCommentTrivia?N=" ":v!==S.SyntaxKind.CommaToken&&v!==S.SyntaxKind.EOF&&(l=!0);break;case S.SyntaxKind.Unknown:l=!0;break}m&&(v===S.SyntaxKind.LineCommentTrivia||v===S.SyntaxKind.BlockCommentTrivia)&&(N=n())}const T=i.getTokenOffset()+y;s(N,u,T),o=v}return t}function $(a,f){const c=JSON.stringify(a,void 0,f.insertSpaces?f.tabSize||4:"	");return f.eol!==void 0?c.replace(/\r\n|\r|\n/g,f.eol):c}function I(a,f){let c="";for(let h=0;h<f;h++)c+=a;return c}function L(a,f){let c=0,h=0;const p=f.tabSize||4;for(;c<a.length;){const y=a.charAt(c);if(y===" ")h++;else if(y==="	")h+=p;else break;c++}return Math.floor(h/p)}function k(a,f){for(let c=0;c<f.length;c++){const h=f.charAt(c);if(h==="\r")return c+1<f.length&&f.charAt(c+1)===`
`?`\r
`:"\r";if(h===`
`)return`
`}return a&&a.eol||`
`}function g(a,f){return`\r
`.indexOf(a.charAt(f))!==-1}}),define(le[77],ue([0,1,34,76]),function(Y,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8n=$,e.$9n=I,e.$0n=L,e.$$n=k,e.$_n=g;function $(a,f,c){return I(a,f,void 0,c)}function I(a,f,c,h,p){const y=f.slice(),R=[],E=(0,S.$Vn)(a,R);let d,m;for(;y.length>0&&(m=y.pop(),d=(0,S.$Wn)(E,y),d===void 0&&c!==void 0);)typeof m=="string"?c={[m]:c}:c=[c];if(d)if(d.type==="object"&&typeof m=="string"&&Array.isArray(d.children)){const A=(0,S.$Wn)(d,[m]);if(A!==void 0)if(c===void 0){if(!A.parent)throw new Error("Malformed AST");const w=d.children.indexOf(A.parent);let i,l=A.parent.offset+A.parent.length;if(w>0){const n=d.children[w-1];i=n.offset+n.length}else i=d.offset+1,d.children.length>1&&(l=d.children[1].offset);return L(a,{offset:i,length:l-i,content:""},h)}else return L(a,{offset:A.offset,length:A.length,content:JSON.stringify(c)},h);else{if(c===void 0)return[];const w=`${JSON.stringify(m)}: ${JSON.stringify(c)}`,i=p?p(d.children.map(n=>n.children[0].value)):d.children.length;let l;if(i>0){const n=d.children[i-1];l={offset:n.offset+n.length,length:0,content:","+w}}else d.children.length===0?l={offset:d.offset+1,length:0,content:w}:l={offset:d.offset+1,length:0,content:w+","};return L(a,l,h)}}else if(d.type==="array"&&typeof m=="number"&&Array.isArray(d.children))if(c!==void 0){const A=`${JSON.stringify(c)}`;let w;if(d.children.length===0||m===0)w={offset:d.offset+1,length:0,content:d.children.length===0?A:A+","};else{const i=m===-1||m>d.children.length?d.children.length:m,l=d.children[i-1];w={offset:l.offset+l.length,length:0,content:","+A}}return L(a,w,h)}else{const A=m,w=d.children[A];let i;if(d.children.length===1)i={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===A){const l=d.children[A-1],n=l.offset+l.length,r=d.offset+d.length;i={offset:n,length:r-2-n,content:""}}else i={offset:w.offset,length:d.children[A+1].offset-w.offset,content:""};return L(a,i,h)}else throw new Error(`Can not add ${typeof m!="number"?"index":"property"} to parent of type ${d.type}`);else return c===void 0?[]:L(a,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(c)},h)}function L(a,f,c){let h=k(a,f),p=f.offset,y=f.offset+f.content.length;if(f.length===0||f.content.length===0){for(;p>0&&!(0,P.$7n)(h,p-1);)p--;for(;y<h.length&&!(0,P.$7n)(h,y);)y++}const R=(0,P.$4n)(h,{offset:p,length:y-p},c);for(let d=R.length-1;d>=0;d--){const m=R[d];h=k(h,m),p=Math.min(p,m.offset),y=Math.max(y,m.offset+m.length),y+=m.content.length-m.length}const E=a.length-(h.length-y)-p;return[{offset:p,length:E,content:h.substring(p,y)}]}function k(a,f){return a.substring(0,f.offset)+f.content+a.substring(f.offset+f.length)}function g(a,f){const c=f.slice(0).sort((p,y)=>{const R=p.offset-y.offset;return R===0?p.length-y.length:R});let h=a.length;for(let p=c.length-1;p>=0;p--){const y=c[p];if(y.offset+y.length<=h)a=k(a,y);else throw new Error("Overlapping edit");h=y.offset}return a}}),define(le[78],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=e.$Km=e.$Jm=void 0,e.$Hm=S,e.rot=P,e.$Mm=k;function S(g,a,f){return Math.min(Math.max(g,a),f)}function P(g,a){return(a+g%a)%a}class ${constructor(){this.a=0}getNext(){return this.a++}}e.$Jm=$;class I{constructor(){this.a=1,this.b=0}update(a){return this.b=this.b+(a-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Km=I;class L{constructor(a){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(a),this.c.fill(0,0,a)}update(a){const f=this.c[this.d];return this.c[this.d]=a,this.d=(this.d+1)%this.c.length,this.e-=f,this.e+=a,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Lm=L;function k(g,a,f,c,h,p,y,R){const E=y-f,d=R-c,m=h-f,A=p-c,w=g-f,i=a-c,l=E*E+d*d,n=E*m+d*A,r=E*w+d*i,t=m*m+A*A,s=m*w+A*i,o=1/(l*t-n*n),u=(t*r-n*s)*o,v=(l*s-n*r)*o;return u>=0&&v>=0&&u+v<1}}),function(){function Y($){const I=[];typeof $=="number"&&I.push("code/timeOrigin",$);function L(g){I.push(g,Date.now())}function k(){const g=[];for(let a=0;a<I.length;a+=2)g.push({name:I[a],startTime:I[a+1]});return g}return{mark:L,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark($){performance.mark($)},getMarks(){let $=performance.timeOrigin;typeof $!="number"&&($=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round($)}];for(const L of performance.getEntriesByType("mark"))I.push({name:L.name,startTime:Math.round($+L.startTime)});return I}};if(typeof process=="object"){const $=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y($)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function S($){return $.MonacoPerformanceMarks||($.MonacoPerformanceMarks=e()),$.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=S(P))}(),define(le[56],ue([0,1,12]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$hm=I,e.$im=L;var P;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(P||(e.Source=P={}));var $;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})($||(e.TerminateResponseCode=$={}));function I(k,...g){const a=g.reduce((h,p)=>(h[p]=!0,h),{}),f=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(h=>!a[h]).forEach(h=>{for(let p=0;p<f.length;p++)if(h.search(f[p])!==-1){delete k[h];break}})}function L(k){k&&(delete k.DEBUG,S.$k&&delete k.DYLD_LIBRARY_PATH,S.$l&&delete k.LD_PRELOAD)}}),function(Y,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var P in S)(typeof exports=="object"?exports:Y)[P]=S[P]}}(typeof self<"u"?self:this,function(){return function(Y){var e={};function S(P){if(e[P])return e[P].exports;var $=e[P]={i:P,l:!1,exports:{}};return Y[P].call($.exports,$,$.exports,S),$.l=!0,$.exports}return S.m=Y,S.c=e,S.d=function(P,$,I){S.o(P,$)||Object.defineProperty(P,$,{enumerable:!0,get:I})},S.r=function(P){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(P,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(P,"__esModule",{value:!0})},S.t=function(P,$){if(1&$&&(P=S(P)),8&$||4&$&&typeof P=="object"&&P&&P.__esModule)return P;var I=Object.create(null);if(S.r(I),Object.defineProperty(I,"default",{enumerable:!0,value:P}),2&$&&typeof P!="string")for(var L in P)S.d(I,L,function(k){return P[k]}.bind(null,L));return I},S.n=function(P){var $=P&&P.__esModule?function(){return P.default}:function(){return P};return S.d($,"a",$),$},S.o=function(P,$){return Object.prototype.hasOwnProperty.call(P,$)},S.p="",S(S.s=0)}([function(Y,e,S){(function(P){var $;e=Y.exports=j,$=typeof P=="object"&&P.env&&P.env.NODE_DEBUG&&/\bsemver\b/i.test(P.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var I=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],g=e.src=[],a=0,f=a++;g[f]="0|[1-9]\\d*";var c=a++;g[c]="[0-9]+";var h=a++;g[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=a++;g[p]="("+g[f]+")\\.("+g[f]+")\\.("+g[f]+")";var y=a++;g[y]="("+g[c]+")\\.("+g[c]+")\\.("+g[c]+")";var R=a++;g[R]="(?:"+g[f]+"|"+g[h]+")";var E=a++;g[E]="(?:"+g[c]+"|"+g[h]+")";var d=a++;g[d]="(?:-("+g[R]+"(?:\\."+g[R]+")*))";var m=a++;g[m]="(?:-?("+g[E]+"(?:\\."+g[E]+")*))";var A=a++;g[A]="[0-9A-Za-z-]+";var w=a++;g[w]="(?:\\+("+g[A]+"(?:\\."+g[A]+")*))";var i=a++,l="v?"+g[p]+g[d]+"?"+g[w]+"?";g[i]="^"+l+"$";var n="[v=\\s]*"+g[y]+g[m]+"?"+g[w]+"?",r=a++;g[r]="^"+n+"$";var t=a++;g[t]="((?:<|>)?=?)";var s=a++;g[s]=g[c]+"|x|X|\\*";var o=a++;g[o]=g[f]+"|x|X|\\*";var u=a++;g[u]="[v=\\s]*("+g[o]+")(?:\\.("+g[o]+")(?:\\.("+g[o]+")(?:"+g[d]+")?"+g[w]+"?)?)?";var v=a++;g[v]="[v=\\s]*("+g[s]+")(?:\\.("+g[s]+")(?:\\.("+g[s]+")(?:"+g[m]+")?"+g[w]+"?)?)?";var N=a++;g[N]="^"+g[t]+"\\s*"+g[u]+"$";var T=a++;g[T]="^"+g[t]+"\\s*"+g[v]+"$";var O=a++;g[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var D=a++;g[D]="(?:~>?)";var q=a++;g[q]="(\\s*)"+g[D]+"\\s+",k[q]=new RegExp(g[q],"g");var K=a++;g[K]="^"+g[D]+g[u]+"$";var J=a++;g[J]="^"+g[D]+g[v]+"$";var re=a++;g[re]="(?:\\^)";var ae=a++;g[ae]="(\\s*)"+g[re]+"\\s+",k[ae]=new RegExp(g[ae],"g");var ce=a++;g[ce]="^"+g[re]+g[u]+"$";var de=a++;g[de]="^"+g[re]+g[v]+"$";var H=a++;g[H]="^"+g[t]+"\\s*("+n+")$|^$";var Z=a++;g[Z]="^"+g[t]+"\\s*("+l+")$|^$";var B=a++;g[B]="(\\s*)"+g[t]+"\\s*("+n+"|"+g[u]+")",k[B]=new RegExp(g[B],"g");var z=a++;g[z]="^\\s*("+g[u]+")\\s+-\\s+("+g[u]+")\\s*$";var G=a++;g[G]="^\\s*("+g[v]+")\\s+-\\s+("+g[v]+")\\s*$";var X=a++;g[X]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)$(te,g[te]),k[te]||(k[te]=new RegExp(g[te]));function ne(V,_){if(V instanceof j)return V;if(typeof V!="string"||V.length>I||!(_?k[r]:k[i]).test(V))return null;try{return new j(V,_)}catch{return null}}function j(V,_){if(V instanceof j){if(V.loose===_)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>I)throw new TypeError("version is longer than "+I+" characters");if(!(this instanceof j))return new j(V,_);$("SemVer",V,_),this.loose=_;var ie=V.trim().match(_?k[r]:k[i]);if(!ie)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+ie[1],this.minor=+ie[2],this.patch=+ie[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");ie[4]?this.prerelease=ie[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var Ee=+$e;if(Ee>=0&&Ee<L)return Ee}return $e}):this.prerelease=[],this.build=ie[5]?ie[5].split("."):[],this.format()}e.parse=ne,e.valid=function(V,_){var ie=ne(V,_);return ie?ie.version:null},e.clean=function(V,_){var ie=ne(V.trim().replace(/^[=v]+/,""),_);return ie?ie.version:null},e.SemVer=j,j.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},j.prototype.toString=function(){return this.version},j.prototype.compare=function(V){return $("SemVer.compare",this.version,this.loose,V),V instanceof j||(V=new j(V,this.loose)),this.compareMain(V)||this.comparePre(V)},j.prototype.compareMain=function(V){return V instanceof j||(V=new j(V,this.loose)),M(this.major,V.major)||M(this.minor,V.minor)||M(this.patch,V.patch)},j.prototype.comparePre=function(V){if(V instanceof j||(V=new j(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var _=0;do{var ie=this.prerelease[_],$e=V.prerelease[_];if($("prerelease compare",_,ie,$e),ie===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(ie===void 0)return-1;if(ie!==$e)return M(ie,$e)}while(++_)},j.prototype.inc=function(V,_){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",_);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",_);break;case"prepatch":this.prerelease.length=0,this.inc("patch",_),this.inc("pre",_);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",_),this.inc("pre",_);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ie=this.prerelease.length;--ie>=0;)typeof this.prerelease[ie]=="number"&&(this.prerelease[ie]++,ie=-2);ie===-1&&this.prerelease.push(0)}_&&(this.prerelease[0]===_?isNaN(this.prerelease[1])&&(this.prerelease=[_,0]):this.prerelease=[_,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,_,ie,$e){typeof ie=="string"&&($e=ie,ie=void 0);try{return new j(V,ie).inc(_,$e).version}catch{return null}},e.diff=function(V,_){if(C(V,_))return null;var ie=ne(V),$e=ne(_);if(ie.prerelease.length||$e.prerelease.length){for(var Ee in ie)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&ie[Ee]!==$e[Ee])return"pre"+Ee;return"prerelease"}for(var Ee in ie)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&ie[Ee]!==$e[Ee])return Ee},e.compareIdentifiers=M;var W=/^[0-9]+$/;function M(V,_){var ie=W.test(V),$e=W.test(_);return ie&&$e&&(V=+V,_=+_),ie&&!$e?-1:$e&&!ie?1:V<_?-1:V>_?1:0}function b(V,_,ie){return new j(V,ie).compare(new j(_,ie))}function F(V,_,ie){return b(V,_,ie)>0}function U(V,_,ie){return b(V,_,ie)<0}function C(V,_,ie){return b(V,_,ie)===0}function x(V,_,ie){return b(V,_,ie)!==0}function Q(V,_,ie){return b(V,_,ie)>=0}function ee(V,_,ie){return b(V,_,ie)<=0}function oe(V,_,ie,$e){var Ee;switch(_){case"===":typeof V=="object"&&(V=V.version),typeof ie=="object"&&(ie=ie.version),Ee=V===ie;break;case"!==":typeof V=="object"&&(V=V.version),typeof ie=="object"&&(ie=ie.version),Ee=V!==ie;break;case"":case"=":case"==":Ee=C(V,ie,$e);break;case"!=":Ee=x(V,ie,$e);break;case">":Ee=F(V,ie,$e);break;case">=":Ee=Q(V,ie,$e);break;case"<":Ee=U(V,ie,$e);break;case"<=":Ee=ee(V,ie,$e);break;default:throw new TypeError("Invalid operator: "+_)}return Ee}function fe(V,_){if(V instanceof fe){if(V.loose===_)return V;V=V.value}if(!(this instanceof fe))return new fe(V,_);$("comparator",V,_),this.loose=_,this.parse(V),this.semver===me?this.value="":this.value=this.operator+this.semver.version,$("comp",this)}e.rcompareIdentifiers=function(V,_){return M(_,V)},e.major=function(V,_){return new j(V,_).major},e.minor=function(V,_){return new j(V,_).minor},e.patch=function(V,_){return new j(V,_).patch},e.compare=b,e.compareLoose=function(V,_){return b(V,_,!0)},e.rcompare=function(V,_,ie){return b(_,V,ie)},e.sort=function(V,_){return V.sort(function(ie,$e){return e.compare(ie,$e,_)})},e.rsort=function(V,_){return V.sort(function(ie,$e){return e.rcompare(ie,$e,_)})},e.gt=F,e.lt=U,e.eq=C,e.neq=x,e.gte=Q,e.lte=ee,e.cmp=oe,e.Comparator=fe;var me={};function ge(V,_){if(V instanceof ge)return V.loose===_?V:new ge(V.raw,_);if(V instanceof fe)return new ge(V.value,_);if(!(this instanceof ge))return new ge(V,_);if(this.loose=_,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(ie){return this.parseRange(ie.trim())},this).filter(function(ie){return ie.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function we(V){return!V||V.toLowerCase()==="x"||V==="*"}function he(V,_,ie,$e,Ee,De,ke,Ce,Oe,Le,ze,Ne,Te){return((_=we(ie)?"":we($e)?">="+ie+".0.0":we(Ee)?">="+ie+"."+$e+".0":">="+_)+" "+(Ce=we(Oe)?"":we(Le)?"<"+(+Oe+1)+".0.0":we(ze)?"<"+Oe+"."+(+Le+1)+".0":Ne?"<="+Oe+"."+Le+"."+ze+"-"+Ne:"<="+Ce)).trim()}function pe(V,_){for(var ie=0;ie<V.length;ie++)if(!V[ie].test(_))return!1;if(_.prerelease.length){for(ie=0;ie<V.length;ie++)if($(V[ie].semver),V[ie].semver!==me&&V[ie].semver.prerelease.length>0){var $e=V[ie].semver;if($e.major===_.major&&$e.minor===_.minor&&$e.patch===_.patch)return!0}return!1}return!0}function be(V,_,ie){try{_=new ge(_,ie)}catch{return!1}return _.test(V)}function Se(V,_,ie,$e){var Ee,De,ke,Ce,Oe;switch(V=new j(V,$e),_=new ge(_,$e),ie){case">":Ee=F,De=ee,ke=U,Ce=">",Oe=">=";break;case"<":Ee=U,De=Q,ke=F,Ce="<",Oe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(be(V,_,$e))return!1;for(var Le=0;Le<_.set.length;++Le){var ze=_.set[Le],Ne=null,Te=null;if(ze.forEach(function(je){je.semver===me&&(je=new fe(">=0.0.0")),Ne=Ne||je,Te=Te||je,Ee(je.semver,Ne.semver,$e)?Ne=je:ke(je.semver,Te.semver,$e)&&(Te=je)}),Ne.operator===Ce||Ne.operator===Oe||(!Te.operator||Te.operator===Ce)&&De(V,Te.semver)||Te.operator===Oe&&ke(V,Te.semver))return!1}return!0}fe.prototype.parse=function(V){var _=this.loose?k[H]:k[Z],ie=V.match(_);if(!ie)throw new TypeError("Invalid comparator: "+V);this.operator=ie[1],this.operator==="="&&(this.operator=""),ie[2]?this.semver=new j(ie[2],this.loose):this.semver=me},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(V){return $("Comparator.test",V,this.loose),this.semver===me||(typeof V=="string"&&(V=new j(V,this.loose)),oe(V,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(V,_){if(!(V instanceof fe))throw new TypeError("a Comparator is required");var ie;if(this.operator==="")return ie=new ge(V.value,_),be(this.value,ie,_);if(V.operator==="")return ie=new ge(this.value,_),be(V.semver,ie,_);var $e=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),Ee=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),De=this.semver.version===V.semver.version,ke=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Ce=oe(this.semver,"<",V.semver,_)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Oe=oe(this.semver,">",V.semver,_)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return $e||Ee||De&&ke||Ce||Oe},e.Range=ge,ge.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},ge.prototype.toString=function(){return this.range},ge.prototype.parseRange=function(V){var _=this.loose;V=V.trim(),$("range",V,_);var ie=_?k[G]:k[z];V=V.replace(ie,he),$("hyphen replace",V),V=V.replace(k[B],"$1$2$3"),$("comparator trim",V,k[B]),V=(V=(V=V.replace(k[q],"$1~")).replace(k[ae],"$1^")).split(/\s+/).join(" ");var $e=_?k[H]:k[Z],Ee=V.split(" ").map(function(De){return function(ke,Ce){return $("comp",ke),ke=function(Oe,Le){return Oe.trim().split(/\s+/).map(function(ze){return function(Ne,Te){$("caret",Ne,Te);var je=Te?k[de]:k[ce];return Ne.replace(je,function(Ue,Pe,Ie,Re,Ae){var Fe;return $("caret",Ne,Ue,Pe,Ie,Re,Ae),we(Pe)?Fe="":we(Ie)?Fe=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":we(Re)?Fe=Pe==="0"?">="+Pe+"."+Ie+".0 <"+Pe+"."+(+Ie+1)+".0":">="+Pe+"."+Ie+".0 <"+(+Pe+1)+".0.0":Ae?($("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Fe=Pe==="0"?Ie==="0"?">="+Pe+"."+Ie+"."+Re+Ae+" <"+Pe+"."+Ie+"."+(+Re+1):">="+Pe+"."+Ie+"."+Re+Ae+" <"+Pe+"."+(+Ie+1)+".0":">="+Pe+"."+Ie+"."+Re+Ae+" <"+(+Pe+1)+".0.0"):($("no pr"),Fe=Pe==="0"?Ie==="0"?">="+Pe+"."+Ie+"."+Re+" <"+Pe+"."+Ie+"."+(+Re+1):">="+Pe+"."+Ie+"."+Re+" <"+Pe+"."+(+Ie+1)+".0":">="+Pe+"."+Ie+"."+Re+" <"+(+Pe+1)+".0.0"),$("caret return",Fe),Fe})}(ze,Le)}).join(" ")}(ke,Ce),$("caret",ke),ke=function(Oe,Le){return Oe.trim().split(/\s+/).map(function(ze){return function(Ne,Te){var je=Te?k[J]:k[K];return Ne.replace(je,function(Ue,Pe,Ie,Re,Ae){var Fe;return $("tilde",Ne,Ue,Pe,Ie,Re,Ae),we(Pe)?Fe="":we(Ie)?Fe=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":we(Re)?Fe=">="+Pe+"."+Ie+".0 <"+Pe+"."+(+Ie+1)+".0":Ae?($("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Fe=">="+Pe+"."+Ie+"."+Re+Ae+" <"+Pe+"."+(+Ie+1)+".0"):Fe=">="+Pe+"."+Ie+"."+Re+" <"+Pe+"."+(+Ie+1)+".0",$("tilde return",Fe),Fe})}(ze,Le)}).join(" ")}(ke,Ce),$("tildes",ke),ke=function(Oe,Le){return $("replaceXRanges",Oe,Le),Oe.split(/\s+/).map(function(ze){return function(Ne,Te){Ne=Ne.trim();var je=Te?k[T]:k[N];return Ne.replace(je,function(Ue,Pe,Ie,Re,Ae,Fe){$("xRange",Ne,Ue,Pe,Ie,Re,Ae,Fe);var Ve=we(Ie),Me=Ve||we(Re),Be=Me||we(Ae);return Pe==="="&&Be&&(Pe=""),Ve?Ue=Pe===">"||Pe==="<"?"<0.0.0":"*":Pe&&Be?(Me&&(Re=0),Be&&(Ae=0),Pe===">"?(Pe=">=",Me?(Ie=+Ie+1,Re=0,Ae=0):Be&&(Re=+Re+1,Ae=0)):Pe==="<="&&(Pe="<",Me?Ie=+Ie+1:Re=+Re+1),Ue=Pe+Ie+"."+Re+"."+Ae):Me?Ue=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":Be&&(Ue=">="+Ie+"."+Re+".0 <"+Ie+"."+(+Re+1)+".0"),$("xRange return",Ue),Ue})}(ze,Le)}).join(" ")}(ke,Ce),$("xrange",ke),ke=function(Oe,Le){return $("replaceStars",Oe,Le),Oe.trim().replace(k[X],"")}(ke,Ce),$("stars",ke),ke}(De,_)}).join(" ").split(/\s+/);return this.loose&&(Ee=Ee.filter(function(De){return!!De.match($e)})),Ee=Ee.map(function(De){return new fe(De,_)})},ge.prototype.intersects=function(V,_){if(!(V instanceof ge))throw new TypeError("a Range is required");return this.set.some(function(ie){return ie.every(function($e){return V.set.some(function(Ee){return Ee.every(function(De){return $e.intersects(De,_)})})})})},e.toComparators=function(V,_){return new ge(V,_).set.map(function(ie){return ie.map(function($e){return $e.value}).join(" ").trim().split(" ")})},ge.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new j(V,this.loose));for(var _=0;_<this.set.length;_++)if(pe(this.set[_],V))return!0;return!1},e.satisfies=be,e.maxSatisfying=function(V,_,ie){var $e=null,Ee=null;try{var De=new ge(_,ie)}catch{return null}return V.forEach(function(ke){De.test(ke)&&($e&&Ee.compare(ke)!==-1||(Ee=new j($e=ke,ie)))}),$e},e.minSatisfying=function(V,_,ie){var $e=null,Ee=null;try{var De=new ge(_,ie)}catch{return null}return V.forEach(function(ke){De.test(ke)&&($e&&Ee.compare(ke)!==1||(Ee=new j($e=ke,ie)))}),$e},e.validRange=function(V,_){try{return new ge(V,_).range||"*"}catch{return null}},e.ltr=function(V,_,ie){return Se(V,_,"<",ie)},e.gtr=function(V,_,ie){return Se(V,_,">",ie)},e.outside=Se,e.prerelease=function(V,_){var ie=ne(V,_);return ie&&ie.prerelease.length?ie.prerelease:null},e.intersects=function(V,_,ie){return V=new ge(V,ie),_=new ge(_,ie),V.intersects(_)},e.coerce=function(V){if(V instanceof j)return V;if(typeof V!="string")return null;var _=V.match(k[O]);return _==null?null:ne((_[1]||"0")+"."+(_[2]||"0")+"."+(_[3]||"0"))}}).call(this,S(1))},function(Y,e){var S,P,$=Y.exports={};function I(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function k(E){if(S===setTimeout)return setTimeout(E,0);if((S===I||!S)&&setTimeout)return S=setTimeout,setTimeout(E,0);try{return S(E,0)}catch{try{return S.call(null,E,0)}catch{return S.call(this,E,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:I}catch{S=I}try{P=typeof clearTimeout=="function"?clearTimeout:L}catch{P=L}})();var g,a=[],f=!1,c=-1;function h(){f&&g&&(f=!1,g.length?a=g.concat(a):c=-1,a.length&&p())}function p(){if(!f){var E=k(h);f=!0;for(var d=a.length;d;){for(g=a,a=[];++c<d;)g&&g[c].run();c=-1,d=a.length}g=null,f=!1,function(m){if(P===clearTimeout)return clearTimeout(m);if((P===L||!P)&&clearTimeout)return P=clearTimeout,clearTimeout(m);try{P(m)}catch{try{return P.call(null,m)}catch{return P.call(this,m)}}}(E)}}function y(E,d){this.fun=E,this.array=d}function R(){}$.nextTick=function(E){var d=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)d[m-1]=arguments[m];a.push(new y(E,d)),a.length!==1||f||k(p)},y.prototype.run=function(){this.fun.apply(null,this.array)},$.title="browser",$.browser=!0,$.env={},$.argv=[],$.version="",$.versions={},$.on=R,$.addListener=R,$.once=R,$.off=R,$.removeListener=R,$.removeAllListeners=R,$.emit=R,$.prependListener=R,$.prependOnceListener=R,$.listeners=function(E){return[]},$.binding=function(E){throw new Error("process.binding is not supported")},$.cwd=function(){return"/"},$.chdir=function(E){throw new Error("process.chdir is not supported")},$.umask=function(){return 0}}])}),define(le[79],ue([0,1]),function(Y,e){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ps=void 0;class P{constructor(k,g,a){this.level=k,this.key=g,this.value=a,this.forward=[]}}const $=void 0;class I{constructor(k,g=2**16){this.comparator=k,this[S]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(g)|0),this.e=new P(this.c,$,$)}get size(){return this.f}clear(){this.e=new P(this.c,$,$),this.f=0}has(k){return!!I.g(this,k,this.comparator)}get(k){return I.g(this,k,this.comparator)?.value}set(k,g){return I.h(this,k,g,this.comparator)&&(this.f+=1),this}delete(k){const g=I.k(this,k,this.comparator);return g&&(this.f-=1),g}forEach(k,g){let a=this.e.forward[0];for(;a;)k.call(g,a.value,a.key,this),a=a.forward[0]}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this.e.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this.e.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this.e.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",g=this.e.forward[0];for(;g;)k+=`node(${g.key}, ${g.value}, lvl:${g.level})`,g=g.forward[0];return k}static g(k,g,a){let f=k.e;for(let c=k.d-1;c>=0;c--)for(;f.forward[c]&&a(f.forward[c].key,g)<0;)f=f.forward[c];if(f=f.forward[0],f&&a(f.key,g)===0)return f}static h(k,g,a,f){const c=[];let h=k.e;for(let p=k.d-1;p>=0;p--){for(;h.forward[p]&&f(h.forward[p].key,g)<0;)h=h.forward[p];c[p]=h}if(h=h.forward[0],h&&f(h.key,g)===0)return h.value=a,!1;{const p=I.j(k);if(p>k.d){for(let y=k.d;y<p;y++)c[y]=k.e;k.d=p}h=new P(p,g,a);for(let y=0;y<p;y++)h.forward[y]=c[y].forward[y],c[y].forward[y]=h;return!0}}static j(k,g=.5){let a=1;for(;Math.random()<g&&a<k.c;)a+=1;return a}static k(k,g,a){const f=[];let c=k.e;for(let h=k.d-1;h>=0;h--){for(;c.forward[h]&&a(c.forward[h].key,g)<0;)c=c.forward[h];f[h]=c}if(c=c.forward[0],!c||a(c.key,g)!==0)return!1;for(let h=0;h<k.d&&f[h].forward[h]===c;h++)f[h].forward[h]=c.forward[h];for(;k.d>0&&k.e.forward[k.d-1]===$;)k.d-=1;return!0}}e.$Ps=I}),define(le[47],ue([0,1,7,2]),function(Y,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=$,e.$xe=I,e.$ye=L,e.$ze=k,e.$Ae=a,e.$Be=f,e.$Ce=c,e.$De=h,e.$Ee=p,e.$Fe=y,e.$Ge=R,e.$He=E,e.$Ie=d,e.$Je=m,e.$Ke=A;function $(w){const i=w;return i?typeof i.read=="function":!1}function I(w){const i=w;return i?[i.on,i.pause,i.resume,i.destroy].every(l=>typeof l=="function"):!1}function L(w){const i=w;return i?I(i.stream)&&Array.isArray(i.buffer)&&typeof i.ended=="boolean":!1}function k(w,i){return new g(w,i)}class g{constructor(i,l){this.e=i,this.f=l,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(i){if(!this.a.destroyed){if(this.a.flowing)this.g(i);else if(this.b.data.push(i),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(l=>this.d.push(l))}}error(i){this.a.destroyed||(this.a.flowing?this.h(i):this.b.error.push(i))}end(i){this.a.destroyed||(typeof i<"u"&&this.write(i),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(i){this.c.data.slice(0).forEach(l=>l(i))}h(i){this.c.error.length===0?(0,S.$Y)(i):this.c.error.slice(0).forEach(l=>l(i))}i(){this.c.end.slice(0).forEach(i=>i())}on(i,l){if(!this.a.destroyed)switch(i){case"data":this.c.data.push(l),this.resume();break;case"end":this.c.end.push(l),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(l),this.a.flowing&&this.k();break}}removeListener(i,l){if(this.a.destroyed)return;let n;switch(i){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const r=n.indexOf(l);r>=0&&n.splice(r,1)}}j(){if(this.b.data.length>0){const i=this.e(this.b.data);this.g(i),this.b.data.length=0;const l=[...this.d];this.d.length=0,l.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const i of this.b.error)this.h(i);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(w,i){const l=[];let n;for(;(n=w.read())!==null;)l.push(n);return i(l)}function f(w,i,l){const n=[];let r;for(;(r=w.read())!==null&&n.length<l;)n.push(r);return r===null&&n.length>0?i(n):{read:()=>{if(n.length>0)return n.shift();if(typeof r<"u"){const t=r;return r=void 0,t}return w.read()}}}function c(w,i){return new Promise((l,n)=>{const r=[];h(w,{onData:t=>{i&&r.push(t)},onError:t=>{i?n(t):l(void 0)},onEnd:()=>{l(i?i(r):void 0)}})})}function h(w,i,l){w.on("error",n=>{l?.isCancellationRequested||i.onError(n)}),w.on("end",()=>{l?.isCancellationRequested||i.onEnd()}),w.on("data",n=>{l?.isCancellationRequested||i.onData(n)})}function p(w,i){return new Promise((l,n)=>{const r=new P.$Sc,t=[],s=v=>{if(t.push(v),t.length>i)return r.dispose(),w.pause(),l({stream:w,buffer:t,ended:!1})},o=v=>(r.dispose(),n(v)),u=()=>(r.dispose(),l({stream:w,buffer:t,ended:!0}));r.add((0,P.$Rc)(()=>w.removeListener("error",o))),w.on("error",o),r.add((0,P.$Rc)(()=>w.removeListener("end",u))),w.on("end",u),r.add((0,P.$Rc)(()=>w.removeListener("data",s))),w.on("data",s)})}function y(w,i){const l=k(i);return l.end(w),l}function R(){const w=k(()=>{throw new Error("not supported")});return w.end(),w}function E(w){let i=!1;return{read:()=>i?null:(i=!0,w)}}function d(w,i,l){const n=k(l);return h(w,{onData:r=>n.write(i.data(r)),onError:r=>n.error(i.error?i.error(r):r),onEnd:()=>n.end()}),n}function m(w,i,l){let n=!1;return{read:()=>{const r=i.read();return n?r:(n=!0,r!==null?l([w,r]):w)}}}function A(w,i,l){let n=!1;const r=k(l);return h(i,{onData:t=>n?r.write(t):(n=!0,r.write(l([w,t]))),onError:t=>r.error(t),onEnd:()=>{n||(n=!0,r.write(w)),r.end()}}),r}});var We=this&&this.__createBinding||(Object.create?function(Y,e,S,P){P===void 0&&(P=S);var $=Object.getOwnPropertyDescriptor(e,S);(!$||("get"in $?!e.__esModule:$.writable||$.configurable))&&($={enumerable:!0,get:function(){return e[S]}}),Object.defineProperty(Y,P,$)}:function(Y,e,S,P){P===void 0&&(P=S),Y[P]=e[S]}),He=this&&this.__setModuleDefault||(Object.create?function(Y,e){Object.defineProperty(Y,"default",{enumerable:!0,value:e})}:function(Y,e){Y.default=e}),ye=this&&this.__importStar||function(Y){if(Y&&Y.__esModule)return Y;var e={};if(Y!=null)for(var S in Y)S!=="default"&&Object.prototype.hasOwnProperty.call(Y,S)&&We(e,Y,S);return He(e,Y),e};define(le[13],ue([0,1,145,47]),function(Y,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Le=void 0,e.$Me=a,e.$Ne=f,e.$Oe=c,e.$Pe=h,e.$Qe=p,e.$Re=y,e.$Se=R,e.$Te=E,e.$Ue=d,e.$Ve=m,e.$We=A,e.$Xe=w,e.$Ye=i,e.$Ze=l,e.$1e=n,e.$2e=r,e.$3e=t,e.$4e=s,e.$5e=o,e.$6e=N,P=ye(P);const $=typeof Buffer<"u",I=new S.$T(()=>new Uint8Array(256));let L,k;class g{static alloc(O){return $?new g(Buffer.allocUnsafe(O)):new g(new Uint8Array(O))}static wrap(O){return $&&!Buffer.isBuffer(O)&&(O=Buffer.from(O.buffer,O.byteOffset,O.byteLength)),new g(O)}static fromString(O,D){return!(D?.dontUseNodeBuffer||!1)&&$?new g(Buffer.from(O)):(L||(L=new TextEncoder),new g(L.encode(O)))}static fromByteArray(O){const D=g.alloc(O.length);for(let q=0,K=O.length;q<K;q++)D.buffer[q]=O[q];return D}static concat(O,D){if(typeof D>"u"){D=0;for(let J=0,re=O.length;J<re;J++)D+=O[J].byteLength}const q=g.alloc(D);let K=0;for(let J=0,re=O.length;J<re;J++){const ae=O[J];q.set(ae,K),K+=ae.byteLength}return q}constructor(O){this.buffer=O,this.byteLength=this.buffer.byteLength}clone(){const O=g.alloc(this.byteLength);return O.set(this),O}toString(){return $?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(O,D){return new g(this.buffer.subarray(O,D))}set(O,D){if(O instanceof g)this.buffer.set(O.buffer,D);else if(O instanceof Uint8Array)this.buffer.set(O,D);else if(O instanceof ArrayBuffer)this.buffer.set(new Uint8Array(O),D);else if(ArrayBuffer.isView(O))this.buffer.set(new Uint8Array(O.buffer,O.byteOffset,O.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(O){return h(this.buffer,O)}writeUInt32BE(O,D){p(this.buffer,O,D)}readUInt32LE(O){return y(this.buffer,O)}writeUInt32LE(O,D){R(this.buffer,O,D)}readUInt8(O){return E(this.buffer,O)}writeUInt8(O,D){d(this.buffer,O,D)}indexOf(O,D=0){return a(this.buffer,O instanceof g?O.buffer:O,D)}}e.$Le=g;function a(T,O,D=0){const q=O.byteLength,K=T.byteLength;if(q===0)return 0;if(q===1)return T.indexOf(O[0]);if(q>K-D)return-1;const J=I.value;J.fill(O.length);for(let de=0;de<O.length;de++)J[O[de]]=O.length-de-1;let re=D+O.length-1,ae=re,ce=-1;for(;re<K;)if(T[re]===O[ae]){if(ae===0){ce=re;break}re--,ae--}else re+=Math.max(O.length-ae,J[T[re]]),ae=O.length-1;return ce}function f(T,O){return T[O+0]<<0>>>0|T[O+1]<<8>>>0}function c(T,O,D){T[D+0]=O&255,O=O>>>8,T[D+1]=O&255}function h(T,O){return T[O]*2**24+T[O+1]*2**16+T[O+2]*2**8+T[O+3]}function p(T,O,D){T[D+3]=O,O=O>>>8,T[D+2]=O,O=O>>>8,T[D+1]=O,O=O>>>8,T[D]=O}function y(T,O){return T[O+0]<<0>>>0|T[O+1]<<8>>>0|T[O+2]<<16>>>0|T[O+3]<<24>>>0}function R(T,O,D){T[D+0]=O&255,O=O>>>8,T[D+1]=O&255,O=O>>>8,T[D+2]=O&255,O=O>>>8,T[D+3]=O&255}function E(T,O){return T[O]}function d(T,O,D){T[D]=O}function m(T){return P.$Ae(T,O=>g.concat(O))}function A(T){return P.$He(T)}function w(T){return P.$Ce(T,O=>g.concat(O))}async function i(T){return T.ended?g.concat(T.buffer):g.concat([...T.buffer,await w(T.stream)])}function l(T){return P.$Fe(T,O=>g.concat(O))}function n(T){return P.$Ie(T,{data:O=>typeof O=="string"?g.fromString(O):g.wrap(O)},O=>g.concat(O))}function r(T){return P.$ze(O=>g.concat(O),T)}function t(T,O){return P.$Je(T,O,D=>g.concat(D))}function s(T,O){return P.$Ke(T,O,D=>g.concat(D))}function o(T){let O=0,D=0,q=0;const K=new Uint8Array(Math.floor(T.length/4*3)),J=ae=>{switch(D){case 3:K[q++]=O|ae,D=0;break;case 2:K[q++]=O|ae>>>2,O=ae<<6,D=3;break;case 1:K[q++]=O|ae>>>4,O=ae<<4,D=2;break;default:O=ae<<2,D=1}};for(let ae=0;ae<T.length;ae++){const ce=T.charCodeAt(ae);if(ce>=65&&ce<=90)J(ce-65);else if(ce>=97&&ce<=122)J(ce-97+26);else if(ce>=48&&ce<=57)J(ce-48+52);else if(ce===43||ce===45)J(62);else if(ce===47||ce===95)J(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${T[ae]}`)}}const re=q;for(;D>0;)J(0);return g.wrap(K).slice(0,re)}const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function N({buffer:T},O=!0,D=!1){const q=D?v:u;let K="";const J=T.byteLength%3;let re=0;for(;re<T.byteLength-J;re+=3){const ae=T[re+0],ce=T[re+1],de=T[re+2];K+=q[ae>>>2],K+=q[(ae<<4|ce>>>4)&63],K+=q[(ce<<2|de>>>6)&63],K+=q[de&63]}if(J===1){const ae=T[re+0];K+=q[ae>>>2],K+=q[ae<<4&63],O&&(K+="==")}else if(J===2){const ae=T[re+0],ce=T[re+1];K+=q[ae>>>2],K+=q[(ae<<4|ce>>>4)&63],K+=q[ce<<2&63],O&&(K+="=")}return K}}),define(le[26],ue([0,1,3]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ao=P,e.$bo=$,e.$co=L,e.$do=g,e.$eo=a,e.$fo=f,e.$go=c,e.$ho=h,e.$io=p,e.$jo=y,e.$ko=R,e.$lo=E,e.$mo=d;function P(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const A=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([w,i])=>{A[w]=i&&typeof i=="object"?P(i):i}),A}function $(m){if(!m||typeof m!="object")return m;const A=[m];for(;A.length>0;){const w=A.shift();Object.freeze(w);for(const i in w)if(I.call(w,i)){const l=w[i];typeof l=="object"&&!Object.isFrozen(l)&&!(0,S.$fg)(l)&&A.push(l)}}return m}const I=Object.prototype.hasOwnProperty;function L(m,A){return k(m,A,new Set)}function k(m,A,w){if((0,S.$lg)(m))return m;const i=A(m);if(typeof i<"u")return i;if(Array.isArray(m)){const l=[];for(const n of m)l.push(k(n,A,w));return l}if((0,S.$eg)(m)){if(w.has(m))throw new Error("Cannot clone recursive data-structure");w.add(m);const l={};for(const n in m)I.call(m,n)&&(l[n]=k(m[n],A,w));return w.delete(m),l}return m}function g(m,A,w=!0){return(0,S.$eg)(m)?((0,S.$eg)(A)&&Object.keys(A).forEach(i=>{i in m?w&&((0,S.$eg)(m[i])&&(0,S.$eg)(A[i])?g(m[i],A[i],w):m[i]=A[i]):m[i]=A[i]}),m):A}function a(m,A){if(m===A)return!0;if(m==null||A===null||A===void 0||typeof m!=typeof A||typeof m!="object"||Array.isArray(m)!==Array.isArray(A))return!1;let w,i;if(Array.isArray(m)){if(m.length!==A.length)return!1;for(w=0;w<m.length;w++)if(!a(m[w],A[w]))return!1}else{const l=[];for(i in m)l.push(i);l.sort();const n=[];for(i in A)n.push(i);if(n.sort(),!a(l,n))return!1;for(w=0;w<l.length;w++)if(!a(m[l[w]],A[l[w]]))return!1}return!0}function f(m){const A=new Set;return JSON.stringify(m,(w,i)=>{if((0,S.$eg)(i)||Array.isArray(i)){if(A.has(i))return"[Circular]";A.add(i)}return typeof i=="bigint"?`[BigInt ${i.toString()}]`:i})}function c(m,A){const w=Object.create(null);return!m||!A||Object.keys(A).forEach(l=>{const n=m[l],r=A[l];a(n,r)||(w[l]=r)}),w}function h(m,A){const w=A.toLowerCase(),i=Object.keys(m).find(l=>l.toLowerCase()===w);return i?m[i]:m[A]}function p(m,A){const w=Object.create(null);for(const[i,l]of Object.entries(m))A(i,l)&&(w[i]=l);return w}function y(m){let A=[];for(;Object.prototype!==m;)A=A.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return A}function R(m){const A=[];for(const w of y(m))typeof m[w]=="function"&&A.push(w);return A}function E(m,A){const w=l=>function(){const n=Array.prototype.slice.call(arguments,0);return A(l,n)},i={};for(const l of m)i[l]=w(l);return i}function d(m,A){const w={};for(const[i,l]of Object.entries(m))w[i]=A(l,i);return w}}),define(le[43],ue([0,1,31]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$uj=void 0,e.$qj=P,e.$rj=$,e.$sj=I,e.$tj=k,e.$vj=R,S=ye(S);function P(d){return $(d,0)}function $(d,m){switch(typeof d){case"object":return d===null?I(349,m):Array.isArray(d)?g(d,m):a(d,m);case"string":return k(d,m);case"boolean":return L(d,m);case"number":return I(d,m);case"undefined":return I(937,m);default:return I(617,m)}}function I(d,m){return(m<<5)-m+d|0}function L(d,m){return I(d?433:863,m)}function k(d,m){m=I(149417,m);for(let A=0,w=d.length;A<w;A++)m=I(d.charCodeAt(A),m);return m}function g(d,m){return m=I(104579,m),d.reduce((A,w)=>$(w,A),m)}function a(d,m){return m=I(181387,m),Object.keys(d).sort().reduce((A,w)=>(A=k(w,A),$(d[w],A)),m)}class f{constructor(){this.g=0}get value(){return this.g}hash(m){return this.g=$(m,this.g),this.g}}e.$uj=f;var c;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(c||(c={}));function h(d,m,A=32){const w=A-m,i=~((1<<w)-1);return(d<<m|(i&d)>>>w)>>>0}function p(d,m=0,A=d.byteLength,w=0){for(let i=0;i<A;i++)d[m+i]=w}function y(d,m,A="0"){for(;d.length<m;)d=A+d;return d}function R(d,m=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(A=>A.toString(16).padStart(2,"0")).join(""):y((d>>>0).toString(16),m/4)}class E{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(c.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(m){const A=m.length;if(A===0)return;const w=this.p;let i=this.r,l=this.u,n,r;for(l!==0?(n=l,r=-1,l=0):(n=m.charCodeAt(0),r=0);;){let t=n;if(S.$Hf(n))if(r+1<A){const s=m.charCodeAt(r+1);S.$If(s)?(r++,t=S.$Jf(n,s)):t=c.UNICODE_REPLACEMENT}else{l=n;break}else S.$If(n)&&(t=c.UNICODE_REPLACEMENT);if(i=this.w(w,i,t),r++,r<A)n=m.charCodeAt(r);else break}this.r=i,this.u=l}w(m,A,w){return w<128?m[A++]=w:w<2048?(m[A++]=192|(w&1984)>>>6,m[A++]=128|(w&63)>>>0):w<65536?(m[A++]=224|(w&61440)>>>12,m[A++]=128|(w&4032)>>>6,m[A++]=128|(w&63)>>>0):(m[A++]=240|(w&1835008)>>>18,m[A++]=128|(w&258048)>>>12,m[A++]=128|(w&4032)>>>6,m[A++]=128|(w&63)>>>0),A>=c.BLOCK_SIZE&&(this.y(),A-=c.BLOCK_SIZE,this.t+=c.BLOCK_SIZE,m[0]=m[c.BLOCK_SIZE+0],m[1]=m[c.BLOCK_SIZE+1],m[2]=m[c.BLOCK_SIZE+2]),A}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,c.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),R(this.h)+R(this.l)+R(this.m)+R(this.n)+R(this.o)}x(){this.p[this.r++]=128,p(this.p,this.r),this.r>56&&(this.y(),p(this.p));const m=8*this.t;this.q.setUint32(56,Math.floor(m/4294967296),!1),this.q.setUint32(60,m%4294967296,!1),this.y()}y(){const m=E.g,A=this.q;for(let u=0;u<64;u+=4)m.setUint32(u,A.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)m.setUint32(u,h(m.getUint32(u-12,!1)^m.getUint32(u-32,!1)^m.getUint32(u-56,!1)^m.getUint32(u-64,!1),1),!1);let w=this.h,i=this.l,l=this.m,n=this.n,r=this.o,t,s,o;for(let u=0;u<80;u++)u<20?(t=i&l|~i&n,s=1518500249):u<40?(t=i^l^n,s=1859775393):u<60?(t=i&l|i&n|l&n,s=2400959708):(t=i^l^n,s=3395469782),o=h(w,5)+t+r+s+m.getUint32(u*4,!1)&4294967295,r=n,n=l,l=h(i,30),i=w,w=o;this.h=this.h+w&4294967295,this.l=this.l+i&4294967295,this.m=this.m+l&4294967295,this.n=this.n+n&4294967295,this.o=this.o+r&4294967295}}e.$wj=E}),define(le[57],ue([0,1,31]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),S=ye(S);var P;(function($){$[$.Ignore=0]="Ignore",$[$.Info=1]="Info",$[$.Warning=2]="Warning",$[$.Error=3]="Error"})(P||(P={})),function($){const I="error",L="warning",k="warn",g="info",a="ignore";function f(h){return h?S.$Df(I,h)?$.Error:S.$Df(L,h)||S.$Df(k,h)?$.Warning:S.$Df(g,h)?$.Info:$.Ignore:$.Ignore}$.fromValue=f;function c(h){switch(h){case $.Error:return I;case $.Warning:return L;case $.Info:return g;default:return a}}$.toString=c}(P||(P={})),e.default=P}),define(le[80],ue([0,1,11]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=P,e.$ar=$,e.$br=I,e.log=k;function P(a){const f=a;return f&&typeof f.type=="string"&&typeof f.severity=="string"}function $(a){const f=[];let c;try{const h=JSON.parse(a.arguments),p=h[h.length-1];p&&p.__$stack&&(h.pop(),c=p.__$stack),f.push(...h)}catch{f.push("Unable to log remote console arguments",a.arguments)}return{args:f,stack:c}}function I(a){if(typeof a!="string")return I($(a).stack);const f=a;if(f){const c=L(f),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(c||"");if(h&&h.length===4)return{uri:S.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}function L(a){if(!a)return a;const f=a.indexOf(`
`);return f===-1?a:a.substring(0,f)}function k(a,f){const{args:c,stack:h}=$(a),p=typeof c[0]=="string"&&c.length===1;let y=L(h);y&&(y=`(${y.trim()})`);let R=[];if(typeof c[0]=="string"?y&&p?R=[`%c[${f}] %c${c[0]} %c${y}`,g("blue"),g(""),g("grey")]:R=[`%c[${f}] %c${c[0]}`,g("blue"),g(""),...c.slice(1)]:R=[`%c[${f}]%`,g("blue"),...c],y&&!p&&R.push(y),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,R)}function g(a){return`color: ${a}`}}),define(le[48],ue([0,1,13,11,146]),function(Y,e,S,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=I,e.$$h=L,e.$_h=g;function I(a){return JSON.stringify(a,k)}function L(a){let f=JSON.parse(a);return f=g(f),f}function k(a,f){return f instanceof RegExp?{$mid:$.MarshalledId.Regexp,source:f.source,flags:f.flags}:f}function g(a,f=0){if(!a||f>200)return a;if(typeof a=="object"){switch(a.$mid){case $.MarshalledId.Uri:return P.URI.revive(a);case $.MarshalledId.Regexp:return new RegExp(a.source,a.flags);case $.MarshalledId.Date:return new Date(a.source)}if(a instanceof S.$Le||a instanceof Uint8Array)return a;if(Array.isArray(a))for(let c=0;c<a.length;++c)a[c]=g(a[c],f+1);else for(const c in a)Object.hasOwnProperty.call(a,c)&&(a[c]=g(a[c],f+1))}return a}}),define(le[81],ue([0,1,74,14,12,11]),function(Y,e,S,P,$,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qE=f,$=ye($);class L{constructor(h,p,y){this.id=h,this.dependencies=p,this.callback=y}}class k{static{this.INSTANCE=new k}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(h,p,y)=>{typeof h!="string"&&(y=p,p=h,h=null),(typeof p!="object"||!Array.isArray(p))&&(y=p,p=null),this.c.push(new L(h,p,y))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){if(h.startsWith(window.location.origin)||h.startsWith("vscode-file://vscode-app"))return h;throw new Error(`[trusted_script_src] Invalid script url: ${h}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){return h}})))}async load(h){this.g();const p=await(this.a?this.i(h):this.b?this.h(h):this.j(h));if(!p)throw new Error(`Did not receive a define call from script ${h}`);if(Array.isArray(p.dependencies)&&p.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${h}. The dependencies are: ${p.dependencies.join(", ")}`);return typeof p.callback=="function"?p.callback([]):p.callback}h(h){return new Promise((p,y)=>{const R=document.createElement("script");R.setAttribute("async","async"),R.setAttribute("type","text/javascript");const E=()=>{R.removeEventListener("load",d),R.removeEventListener("error",m)},d=A=>{E(),p(this.c.pop())},m=A=>{E(),y(A)};R.addEventListener("load",d),R.addEventListener("error",m),this.f&&(h=this.f.createScriptURL(h)),R.setAttribute("src",h),window.document.getElementsByTagName("head")[0].appendChild(R)})}i(h){return new Promise((p,y)=>{try{this.f&&(h=this.f.createScriptURL(h)),importScripts(h),p(this.c.pop())}catch(R){y(R)}})}async j(h){try{const p=globalThis._VSCODE_NODE_MODULES.fs,y=globalThis._VSCODE_NODE_MODULES.vm,R=globalThis._VSCODE_NODE_MODULES.module,E=I.URI.parse(h).fsPath,d=p.readFileSync(E).toString(),m=R.wrap(d.replace(/^#!.*/,""));return new y.Script(m).runInThisContext().apply(),this.c.pop()}catch(p){throw p}}}const g=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function f(c,h,p){if(S.$R){p===void 0&&(p=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[c]&&(c=a[c]);const y=`${c}/${h}`;if(g.has(y))return g.get(y);let R;if(/^\w[\w\d+.-]*:\/\//.test(y))R=y;else{const A=`${p&&!$.$p?P.$Tg:P.$Sg}/${y}`;R=P.$Wg.asBrowserUri(A).toString(!0)}const E=k.INSTANCE.load(R);return g.set(y,E),E}else return await new Promise((y,R)=>{Y([c],y,R)}).then(ye)}}),define(le[27],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yg=void 0,e.$Xg=P;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function P($){return S.test($)}e.$Yg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let $;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?$=crypto.getRandomValues.bind(crypto):$=function(k){for(let g=0;g<k.length;g++)k[g]=Math.floor(Math.random()*256);return k};const I=new Uint8Array(16),L=[];for(let k=0;k<256;k++)L.push(k.toString(16).padStart(2,"0"));return function(){$(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let g=0,a="";return a+=L[I[g++]],a+=L[I[g++]],a+=L[I[g++]],a+=L[I[g++]],a+="-",a+=L[I[g++]],a+=L[I[g++]],a+="-",a+=L[I[g++]],a+=L[I[g++]],a+="-",a+=L[I[g++]],a+=L[I[g++]],a+="-",a+=L[I[g++]],a+=L[I[g++]],a+=L[I[g++]],a+=L[I[g++]],a+=L[I[g++]],a+=L[I[g++]],a}}()}),define(le[82],ue([0,1,35]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=I;const P=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function $(L){const k=L.replace(/\-/g,":").toLowerCase();return!P.has(k)}function I(){const L=(0,S.networkInterfaces)();for(const k in L){const g=L[k];if(g){for(const{mac:a}of g)if($(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(le[83],ue([0,1,35,49,27,82,12]),function(Y,e,S,P,$,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=void 0,e.$Pn=g,e.$Qn=c,e.$Rn=h,$=ye($),e.$On=new class{c(p){return this.a||(this.a=P.$Ii.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(p)}value(){if(this.b===void 0){let p=0,y=0;const R=(0,S.networkInterfaces)();for(const E in R){const d=R[E];if(d)for(const{mac:m,internal:A}of d)A||(y+=1,this.c(m.toUpperCase())&&(p+=1))}this.b=y>0?p/y:0}return this.b}};let k;async function g(p){return k||(k=(async()=>await a(p)||$.$Yg())()),k}async function a(p){try{const y=await new Promise((E,d)=>{Y(["crypto"],E,d)}).then(ye),R=(0,I.$Nn)();return y.createHash("sha256").update(R,"utf8").digest("hex")}catch(y){p(y);return}}const f="Software\\Microsoft\\SQMClient";async function c(p){if(L.$j){const y=await new Promise((R,E)=>{Y(["@vscode/windows-registry"],R,E)}).then(ye);try{return y.GetStringRegKey("HKEY_LOCAL_MACHINE",f,"MachineId")||""}catch(R){return p(R),""}}return""}async function h(p){try{return await(await new Promise((E,d)=>{Y(["@vscode/deviceid"],E,d)}).then(ye)).getDeviceId()}catch(y){return p(y),""}}}),define(le[84],ue([0,1,35,15,28]),function(Y,e,S,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=m,e.$tm=A,S=ye(S),P=ye(P),$=ye($);const I=/^\d+$/,L=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var g;(function(w){w[w.x64=0]="x64",w[w.x86=1]="x86",w[w.ARM=2]="ARM"})(g||(g={}));let a;switch(process.arch){case"ia32":a=g.x86;break;case"arm":case"arm64":a=g.ARM;break;default:a=g.x64;break}let f;process.env.PROCESSOR_ARCHITEW6432?f=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?g.ARM:g.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?f=g.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?f=g.x86:f=g.x64;class c{constructor(i,l,n){this.exePath=i,this.displayName=l,this.a=n}async exists(){return this.a===void 0&&(this.a=await $.SymlinkSupport.existsFile(this.exePath)),this.a}}function h({useAlternateBitness:w=!1}={}){return w?a===g.x64?process.env["ProgramFiles(x86)"]||null:f===g.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:w=!1,findPreview:i=!1}={}){const l=h({useAlternateBitness:w});if(!l)return null;const n=P.$ic(l,"PowerShell");if(!await $.SymlinkSupport.existsDirectory(n))return null;let r=-1,t=null;for(const u of await $.Promises.readdir(n)){let v=-1;if(i){const T=u.indexOf("-");if(T<0)continue;const O=u.substring(0,T);if(!I.test(O)||u.substring(T+1)!=="preview")continue;v=parseInt(O,10)}else{if(!I.test(u))continue;v=parseInt(u,10)}if(v<=r)continue;const N=P.$ic(n,u,"pwsh.exe");await $.SymlinkSupport.existsFile(N)&&(t=N,r=v)}if(!t)return null;const s=l.includes("x86")?" (x86)":"",o=i?" Preview":"";return new c(t,`PowerShell${o}${s}`,!0)}async function y({findPreview:w}={}){if(!process.env.LOCALAPPDATA)return null;const i=P.$ic(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await $.SymlinkSupport.existsDirectory(i))return null;const{pwshMsixDirRegex:l,pwshMsixName:n}=w?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const r of await $.Promises.readdir(i))if(l.test(r)){const t=P.$ic(i,r,"pwsh.exe");return new c(t,n)}return null}function R(){const w=P.$ic(S.homedir(),".dotnet","tools","pwsh.exe");return new c(w,".NET Core PowerShell Global Tool")}function E(){const w=P.$ic(process.env.windir,a===g.x86&&f!==g.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new c(w,"Windows PowerShell",!0)}async function*d(){let w=await p();w&&(yield w),w=await p({useAlternateBitness:!0}),w&&(yield w),w=await y(),w&&(yield w),w=R(),w&&(yield w),w=await p({findPreview:!0}),w&&(yield w),w=await y({findPreview:!0}),w&&(yield w),w=await p({useAlternateBitness:!0,findPreview:!0}),w&&(yield w),w=E(),w&&(yield w)}async function*m(){for await(const w of d())await w.exists()&&(yield w)}async function A(){for await(const w of m())return w;return null}}),define(le[58],ue([0,1,32,15,12,36,56,3,28]),function(Y,e,S,P,$,I,L,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$um=a,e.$vm=f,P=ye(P),$=ye($),I=ye(I),k=ye(k),g=ye(g),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function a(h=I.env){return h.comspec||"cmd.exe"}function f(h){let p=[],y=!1;const R=function(E){if(y){p.push(E);return}(!h.send(E,m=>{if(m&&console.error(m),y=!1,p.length>0){const A=p.slice(0);p=[],A.forEach(w=>R(w))}})||$.$j)&&(y=!0)};return{send:R}}var c;(function(h){async function p(y,R,E){if(P.$hc(y))return y;if(R===void 0&&(R=I.cwd()),P.$lc(y)!=="."||(E===void 0&&k.$cg(I.env.PATH)&&(E=I.env.PATH.split(P.$sc)),E===void 0||E.length===0))return P.$ic(R,y);async function m(A){if(await g.Promises.exists(A)){let w;try{w=await S.promises.stat(A)}catch(i){i.message.startsWith("EACCES")&&(w=await S.promises.lstat(A))}return w?!w.isDirectory():!1}return!1}for(const A of E){let w;if(P.$hc(A)?w=P.$ic(A,y):w=P.$ic(R,A,y),await m(w))return w;let i=w+".com";if(await m(i)||(i=w+".exe",await m(i)))return i}return P.$ic(R,y)}h.findExecutable=p})(c||(e.win32=c={}))}),define(le[85],ue([0,1,35,12,84,58]),function(Y,e,S,P,$,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=L,P=ye(P),I=ye(I);async function L(c,h){return c===P.OperatingSystem.Windows?P.$j?f():I.$um(h):g(c,h)}let k=null;function g(c,h){if(P.$l&&c===P.OperatingSystem.Macintosh||P.$k&&c===P.OperatingSystem.Linux)return"/bin/bash";if(!k){let p;if(P.$j)p="/bin/bash";else{if(p=h.SHELL,!p)try{p=(0,S.userInfo)().shell}catch{}p||(p="sh"),p==="/bin/false"&&(p="/bin/bash")}k=p}return k}let a=null;async function f(){return a||(a=(await(0,$.$tm)()).exePath),a}});var ve=this&&this.__decorate||function(Y,e,S,P){var $=arguments.length,I=$<3?e:P===null?P=Object.getOwnPropertyDescriptor(e,S):P,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(Y,e,S,P);else for(var k=Y.length-1;k>=0;k--)(L=Y[k])&&(I=($<3?L(I):$>3?L(e,S,I):L(e,S))||I);return $>3&&I&&Object.defineProperty(e,S,I),I};define(le[59],ue([0,1,19,8,13,21,55,7,4,2,48,31,3]),function(Y,e,S,P,$,I,L,k,g,a,f,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=e.ProxyChannel=e.$ki=e.$hi=e.$gi=e.$fi=e.RequestInitiator=e.$ei=e.$bi=e.$ai=void 0,e.$ci=o,e.$di=u,e.$ii=q,e.$ji=K,c=ye(c);var p;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(p||(p={}));function y(B){switch(B){case p.Promise:return"req";case p.PromiseCancel:return"cancel";case p.EventListen:return"subscribe";case p.EventDispose:return"unsubscribe"}}var R;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(R||(R={}));function E(B){switch(B){case R.Initialize:return"init";case R.PromiseSuccess:return"reply:";case R.PromiseError:case R.PromiseErrorObj:return"replyErr:";case R.EventFire:return"event:"}}var d;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(d||(d={}));function m(B){let z=0;for(let G=0;;G+=7){const X=B.read(1);if(z|=(X.buffer[0]&127)<<G,!(X.buffer[0]&128))return z}}const A=r(0);function w(B,z){if(z===0){B.write(A);return}let G=0;for(let te=z;te!==0;te=te>>>7)G++;const X=$.$Le.alloc(G);for(let te=0;z!==0;te++)X.buffer[te]=z&127,z=z>>>7,z>0&&(X.buffer[te]|=128);B.write(X)}class i{constructor(z){this.b=z,this.a=0}read(z){const G=this.b.slice(this.a,this.a+z);return this.a+=G.byteLength,G}}e.$ai=i;class l{constructor(){this.a=[]}get buffer(){return $.$Le.concat(this.a)}write(z){this.a.push(z)}}e.$bi=l;var n;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(n||(n={}));function r(B){const z=$.$Le.alloc(1);return z.writeUInt8(B,0),z}const t={Undefined:r(n.Undefined),String:r(n.String),Buffer:r(n.Buffer),VSBuffer:r(n.VSBuffer),Array:r(n.Array),Object:r(n.Object),Uint:r(n.Int)},s=typeof Buffer<"u";function o(B,z){if(typeof z>"u")B.write(t.Undefined);else if(typeof z=="string"){const G=$.$Le.fromString(z);B.write(t.String),w(B,G.byteLength),B.write(G)}else if(s&&Buffer.isBuffer(z)){const G=$.$Le.wrap(z);B.write(t.Buffer),w(B,G.byteLength),B.write(G)}else if(z instanceof $.$Le)B.write(t.VSBuffer),w(B,z.byteLength),B.write(z);else if(Array.isArray(z)){B.write(t.Array),w(B,z.length);for(const G of z)o(B,G)}else if(typeof z=="number"&&(z|0)===z)B.write(t.Uint),w(B,z);else{const G=$.$Le.fromString(JSON.stringify(z));B.write(t.Object),w(B,G.byteLength),B.write(G)}}function u(B){switch(B.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return B.read(m(B)).toString();case n.Buffer:return B.read(m(B)).buffer;case n.VSBuffer:return B.read(m(B));case n.Array:{const G=m(B),X=[];for(let te=0;te<G;te++)X.push(u(B));return X}case n.Object:return JSON.parse(B.read(m(B)).toString());case n.Int:return m(B)}}class v{constructor(z,G,X=null,te=1e3){this.h=z,this.j=G,this.k=X,this.l=te,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ne=>this.q(ne)),this.m({type:R.Initialize})}registerChannel(z,G){this.b.set(z,G),setTimeout(()=>this.w(z),0)}m(z){switch(z.type){case R.Initialize:{const G=this.o([z.type]);this.k?.logOutgoing(G,0,N.OtherSide,E(z.type));return}case R.PromiseSuccess:case R.PromiseError:case R.EventFire:case R.PromiseErrorObj:{const G=this.o([z.type,z.id],z.data);this.k?.logOutgoing(G,z.id,N.OtherSide,E(z.type),z.data);return}}}o(z,G=void 0){const X=new l;return o(X,z),o(X,G),this.p(X.buffer)}p(z){try{return this.h.send(z),z.byteLength}catch{return 0}}q(z){const G=new i(z),X=u(G),te=u(G),ne=X[0];switch(ne){case p.Promise:return this.k?.logIncoming(z.byteLength,X[1],N.OtherSide,`${y(ne)}: ${X[2]}.${X[3]}`,te),this.s({type:ne,id:X[1],channelName:X[2],name:X[3],arg:te});case p.EventListen:return this.k?.logIncoming(z.byteLength,X[1],N.OtherSide,`${y(ne)}: ${X[2]}.${X[3]}`,te),this.t({type:ne,id:X[1],channelName:X[2],name:X[3],arg:te});case p.PromiseCancel:return this.k?.logIncoming(z.byteLength,X[1],N.OtherSide,`${y(ne)}`),this.u({type:ne,id:X[1]});case p.EventDispose:return this.k?.logIncoming(z.byteLength,X[1],N.OtherSide,`${y(ne)}`),this.u({type:ne,id:X[1]})}}s(z){const G=this.b.get(z.channelName);if(!G){this.v(z);return}const X=new I.$ue;let te;try{te=G.call(this.j,z.name,z.arg,X.token)}catch(W){te=Promise.reject(W)}const ne=z.id;te.then(W=>{this.m({id:ne,data:W,type:R.PromiseSuccess})},W=>{W instanceof Error?this.m({id:ne,data:{message:W.message,name:W.name,stack:W.stack?W.stack.split(`
`):void 0},type:R.PromiseError}):this.m({id:ne,data:W,type:R.PromiseErrorObj})}).finally(()=>{j.dispose(),this.d.delete(z.id)});const j=(0,a.$Rc)(()=>X.cancel());this.d.set(z.id,j)}t(z){const G=this.b.get(z.channelName);if(!G){this.v(z);return}const X=z.id,ne=G.listen(this.j,z.name,z.arg)(j=>this.m({id:X,data:j,type:R.EventFire}));this.d.set(z.id,ne)}u(z){const G=this.d.get(z.id);G&&(G.dispose(),this.d.delete(z.id))}v(z){let G=this.g.get(z.channelName);G||(G=[],this.g.set(z.channelName,G));const X=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===p.Promise&&this.m({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:R.PromiseError})},this.l);G.push({request:z,timeoutTimer:X})}w(z){const G=this.g.get(z);if(G){for(const X of G)switch(clearTimeout(X.timeoutTimer),X.request.type){case p.Promise:this.s(X.request);break;case p.EventListen:this.t(X.request);break}this.g.delete(z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Oc)(this.d.values()),this.d.clear()}}e.$ei=v;var N;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(N||(e.RequestInitiator=N={}));class T{constructor(z,G=null){this.l=z,this.a=!1,this.b=d.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new g.$je,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(X=>this.s(X)),this.j=G}getChannel(z){const G=this;return{call(X,te,ne){return G.a?Promise.reject(new k.$4):G.m(z,X,te,ne)},listen(X,te){return G.a?g.Event.None:G.o(z,X,te)}}}m(z,G,X,te=I.CancellationToken.None){const ne=this.g++,j=p.Promise,W={id:ne,type:j,channelName:z,name:G,arg:X};if(te.isCancellationRequested)return Promise.reject(new k.$4);let M;return new Promise((F,U)=>{if(te.isCancellationRequested)return U(new k.$4);const C=()=>{const oe=fe=>{switch(fe.type){case R.PromiseSuccess:this.f.delete(ne),F(fe.data);break;case R.PromiseError:{this.f.delete(ne);const me=new Error(fe.data.message);me.stack=Array.isArray(fe.data.stack)?fe.data.stack.join(`
`):fe.data.stack,me.name=fe.data.name,U(me);break}case R.PromiseErrorObj:this.f.delete(ne),U(fe.data);break}};this.f.set(ne,oe),this.p(W)};let x=null;this.b===d.Idle?C():(x=(0,P.$ph)(oe=>this.u()),x.then(()=>{x=null,C()}));const Q=()=>{x?(x.cancel(),x=null):this.p({id:ne,type:p.PromiseCancel}),U(new k.$4)},ee=te.onCancellationRequested(Q);M=(0,a.$Qc)((0,a.$Rc)(Q),ee),this.d.add(M)}).finally(()=>{M.dispose(),this.d.delete(M)})}o(z,G,X){const te=this.g++,ne=p.EventListen,j={id:te,type:ne,channelName:z,name:G,arg:X};let W=null;const M=new g.$je({onWillAddFirstListener:()=>{W=(0,P.$ph)(F=>this.u()),W.then(()=>{W=null,this.d.add(M),this.p(j)})},onDidRemoveLastListener:()=>{W?(W.cancel(),W=null):(this.d.delete(M),this.p({id:te,type:p.EventDispose}))}}),b=F=>M.fire(F.data);return this.f.set(te,b),M.event}p(z){switch(z.type){case p.Promise:case p.EventListen:{const G=this.q([z.type,z.id,z.channelName,z.name],z.arg);this.j?.logOutgoing(G,z.id,N.LocalSide,`${y(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case p.PromiseCancel:case p.EventDispose:{const G=this.q([z.type,z.id]);this.j?.logOutgoing(G,z.id,N.LocalSide,y(z.type));return}}}q(z,G=void 0){const X=new l;return o(X,z),o(X,G),this.r(X.buffer)}r(z){try{return this.l.send(z),z.byteLength}catch{return 0}}s(z){const G=new i(z),X=u(G),te=u(G),ne=X[0];switch(ne){case R.Initialize:return this.j?.logIncoming(z.byteLength,0,N.LocalSide,E(ne)),this.t({type:X[0]});case R.PromiseSuccess:case R.PromiseError:case R.EventFire:case R.PromiseErrorObj:return this.j?.logIncoming(z.byteLength,X[1],N.LocalSide,E(ne),te),this.t({type:X[0],id:X[1],data:te})}}t(z){if(z.type===R.Initialize){this.b=d.Idle,this.k.fire();return}this.f.get(z.id)?.(z)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}u(){return this.b===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Oc)(this.d.values()),this.d.clear()}}e.$fi=T,ve([L.$7h],T.prototype,"onDidInitializePromise",null);class O{get connections(){const z=[];return this.f.forEach(G=>z.push(G)),z}constructor(z,G,X){this.a=new Map,this.f=new Set,this.g=new g.$je,this.onDidAddConnection=this.g.event,this.h=new g.$je,this.onDidRemoveConnection=this.h.event,this.j=new a.$Sc,this.j.add(z(({protocol:te,onDidClientDisconnect:ne})=>{const j=g.Event.once(te.onMessage);this.j.add(j(W=>{const M=new i(W),b=u(M),F=new v(te,b,G,X),U=new T(te,G);this.a.forEach((x,Q)=>F.registerChannel(Q,x));const C={channelServer:F,channelClient:U,ctx:b};this.f.add(C),this.g.fire(C),this.j.add(ne(()=>{F.dispose(),U.dispose(),this.f.delete(C),this.h.fire(C)}))}))}))}getChannel(z,G){const X=this;return{call(te,ne,j){let W;if((0,h.$qg)(G)){const b=(0,S.$2b)(X.connections.filter(G));W=b?Promise.resolve(b):g.Event.toPromise(g.Event.filter(X.onDidAddConnection,G))}else W=G.routeCall(X,te,ne);const M=W.then(b=>b.channelClient.getChannel(z));return q(M).call(te,ne,j)},listen(te,ne){if((0,h.$qg)(G))return X.k(z,G,te,ne);const j=G.routeEvent(X,te,ne).then(W=>W.channelClient.getChannel(z));return q(j).listen(te,ne)}}}k(z,G,X,te){const ne=this;let j;const W=new g.$je({onWillAddFirstListener:()=>{j=new a.$Sc;const M=new g.$pe,b=new Map,F=C=>{const Q=C.channelClient.getChannel(z).listen(X,te),ee=M.add(Q);b.set(C,ee)},U=C=>{const x=b.get(C);x&&(x.dispose(),b.delete(C))};ne.connections.filter(G).forEach(F),g.Event.filter(ne.onDidAddConnection,G)(F,void 0,j),ne.onDidRemoveConnection(U,void 0,j),M.event(W.fire,W,j),j.add(M)},onDidRemoveLastListener:()=>{j?.dispose(),j=void 0}});return W.event}registerChannel(z,G){this.a.set(z,G);for(const X of this.f)X.channelServer.registerChannel(z,G)}dispose(){this.j.dispose();for(const z of this.f)z.channelClient.dispose(),z.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$gi=O;class D{constructor(z,G,X=null){const te=new l;o(te,G),z.send(te.buffer),this.a=new T(z,X),this.d=new v(z,G,X)}getChannel(z){return this.a.getChannel(z)}registerChannel(z,G){this.d.registerChannel(z,G)}dispose(){this.a.dispose(),this.d.dispose()}}e.$hi=D;function q(B){return{call(z,G,X){return B.then(te=>te.call(z,G,X))},listen(z,G){const X=new g.$se;return B.then(te=>X.input=te.listen(z,G)),X.event}}}function K(B){let z=!1;return{call(G,X,te){return z?B.call(G,X,te):(0,P.$Dh)(0).then(()=>z=!0).then(()=>B.call(G,X,te))},listen(G,X){if(z)return B.listen(G,X);const te=new g.$se;return(0,P.$Dh)(0).then(()=>z=!0).then(()=>te.input=B.listen(G,X)),te.event}}}class J{constructor(z){this.a=z}routeCall(z){return this.b(z)}routeEvent(z){return this.b(z)}async b(z){for(const G of z.connections)if(await Promise.resolve(this.a(G.ctx)))return Promise.resolve(G);return await g.Event.toPromise(z.onDidAddConnection),await this.b(z)}}e.$ki=J;var re;(function(B){function z(ne,j,W){const M=ne,b=W&&W.disableMarshalling,F=new Map;for(const U in M)X(U)&&F.set(U,g.Event.buffer(M[U],!0,void 0,j));return new class{listen(U,C,x){const Q=F.get(C);if(Q)return Q;const ee=M[C];if(typeof ee=="function"){if(te(C))return ee.call(M,x);if(X(C))return F.set(C,g.Event.buffer(M[C],!0,void 0,j)),F.get(C)}throw new k.$ab(`Event not found: ${C}`)}call(U,C,x){const Q=M[C];if(typeof Q=="function"){if(!b&&Array.isArray(x))for(let oe=0;oe<x.length;oe++)x[oe]=(0,f.$_h)(x[oe]);let ee=Q.apply(M,x);return ee instanceof Promise||(ee=Promise.resolve(ee)),ee}throw new k.$ab(`Method not found: ${C}`)}}}B.fromService=z;function G(ne,j){const W=j&&j.disableMarshalling;return new Proxy({},{get(M,b){if(typeof b=="string")return j?.properties?.has(b)?j.properties.get(b):te(b)?function(F){return ne.listen(b,F)}:X(b)?ne.listen(b):async function(...F){let U;j&&!(0,h.$lg)(j.context)?U=[j.context,...F]:U=F;const C=await ne.call(b,U);return W?C:(0,f.$_h)(C)};throw new k.$ab(`Property not found: ${String(b)}`)}})}B.toService=G;function X(ne){return ne[0]==="o"&&ne[1]==="n"&&c.$Cf(ne.charCodeAt(2))}function te(ne){return/^onDynamic/.test(ne)&&c.$Cf(ne.charCodeAt(9))}})(re||(e.ProxyChannel=re={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const z=B.toString();if(z!=="[object Object]")return z}return B}function de(B){return Array.isArray(B)?B.map(ce):ce(B)}function H(B,z,G,X,te,ne,j){j=de(j);const W=ae[te],M=W[X%W.length];let b=[`%c[${B}]%c[${String(z).padStart(7," ")}]%c[len: ${String(G).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${ne}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(ne)?(b=b.concat(j),b.push(")")):b.push(j),console.log.apply(console,b)}class Z{constructor(z,G){this.d=z,this.f=G,this.a=0,this.b=0}logOutgoing(z,G,X,te,ne){this.b+=z,H(this.d,this.b,z,G,X,te,ne)}logIncoming(z,G,X,te,ne){this.a+=z,H(this.f,this.a,z,G,X,te,ne)}}e.$li=Z}),define(le[86],ue([0,1,60,8,13,21,80,7,4,2,26,58,56,59]),function(Y,e,S,P,$,I,L,k,g,a,f,c,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=e.$dr=void 0,k=ye(k);class y extends p.$ei{constructor(d){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",m=>$.$Le.wrap(Buffer.from(m,"base64")))},d),process.once("disconnect",()=>this.dispose())}}e.$dr=y;class R{constructor(d,m){this.i=d,this.j=m,this.c=new Set,this.g=new Map,this.h=new g.$je,this.onDidProcessExit=this.h.event;const A=m&&m.timeout?m.timeout:6e4;this.b=new P.$zh(A),this.d=null,this.f=null}getChannel(d){const m=this;return{call(A,w,i){return m.k(d,A,w,i)},listen(A,w){return m.l(d,A,w)}}}k(d,m,A,w=I.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(w.isCancellationRequested)return Promise.reject(k.$5());this.b.cancel();const i=this.n(d),l=(0,P.$ph)(t=>i.call(m,A,t)),n=w.onCancellationRequested(()=>l.cancel()),r=(0,a.$Rc)(()=>l.cancel());return this.c.add(r),l.finally(()=>{n.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),l}l(d,m,A){if(!this.b)return g.Event.None;this.b.cancel();let w;const i=new g.$je({onWillAddFirstListener:()=>{w=this.n(d).listen(m,A)(i.fire,i),this.c.add(w)},onDidRemoveLastListener:()=>{this.c.delete(w),w.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return i.event}get m(){if(!this.f){const d=this.j&&this.j.args?this.j.args:[],m=Object.create(null);m.env={...(0,f.$ao)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(m.env={...m.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(m.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,h.$im)(m.env),this.d=(0,S.fork)(this.i,d,m);const A=new g.$je,i=g.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,L.$_q)(o)){(0,L.log)(o,`IPC Library: ${this.j.serverName}`);return}A.fire($.$Le.wrap(Buffer.from(o,"base64")))}),l=this.j.useQueue?(0,c.$vm)(this.d):this.d,n=o=>this.d&&this.d.connected&&l.send(o.buffer.toString("base64")),r=A.event,t={send:n,onMessage:r};this.f=new p.$fi(t);const s=()=>this.o();process.once("exit",s),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,u)=>{process.removeListener("exit",s),i.dispose(),this.c.forEach(v=>(0,a.$Oc)(v)),this.c.clear(),o!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+u),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:u})})}return this.f}n(d){let m=this.g.get(d);return m||(m=this.m.getChannel(d),this.g.set(d,m)),m}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$er=R}),define(le[87],ue([0,1,8,4,2,48,3]),function(Y,e,S,P,$,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=e.StorageState=e.StorageHint=void 0,e.$_p=g;var k;(function(h){h[h.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",h[h.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(k||(e.StorageHint=k={}));function g(h){const p=h;return p?.changed instanceof Map||p?.deleted instanceof Set}var a;(function(h){h[h.None=0]="None",h[h.Initialized=1]="Initialized",h[h.Closed=2]="Closed"})(a||(e.StorageState=a={}));class f extends $.$Tc{static{this.a=100}constructor(p,y=Object.create(null)){super(),this.r=p,this.s=y,this.b=this.B(new P.$me),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new S.$Ah(f.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(p=>this.u(p)))}u(p){this.b.pause();try{p.changed?.forEach((y,R)=>this.w(R,y)),p.deleted?.forEach(y=>this.w(y,void 0))}finally{this.b.resume()}}w(p,y){if(this.c===a.Closed)return;let R=!1;(0,L.$lg)(y)?R=this.f.delete(p):this.f.get(p)!==y&&(this.f.set(p,y),R=!0),R&&this.b.fire({key:p,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(p,y){const R=this.f.get(p);return(0,L.$lg)(R)?y:R}getBoolean(p,y){const R=this.get(p);return(0,L.$lg)(R)?y:R==="true"}getNumber(p,y){const R=this.get(p);return(0,L.$lg)(R)?y:parseInt(R,10)}getObject(p,y){const R=this.get(p);return(0,L.$lg)(R)?y:(0,I.$$h)(R)}async set(p,y,R=!1){if(this.c===a.Closed)return;if((0,L.$lg)(y))return this.delete(p,R);const E=(0,L.$eg)(y)||Array.isArray(y)?(0,I.$0h)(y):String(y);if(this.f.get(p)!==E)return this.f.set(p,E),this.j.set(p,E),this.h.delete(p),this.b.fire({key:p,external:R}),this.D()}async delete(p,y=!1){if(!(this.c===a.Closed||!this.f.delete(p)))return this.h.has(p)||this.h.add(p),this.j.delete(p),this.b.fire({key:p,external:y}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const p={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(p).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(p){if(!(this.c===a.Closed||this.m))return this.D(p)}async D(p){return this.s.hint===k.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),p)}async whenFlushed(){if(this.z)return new Promise(p=>this.n.push(p))}isInMemory(){return this.s.hint===k.STORAGE_IN_MEMORY}}e.$aq=f;class c{constructor(){this.onDidChangeItemsExternal=P.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(p){p.insert?.forEach((y,R)=>this.a.set(R,y)),p.delete?.forEach(y=>this.a.delete(y))}async optimize(){}async close(){}}e.$bq=c}),define(le[88],ue([0,1,5]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=a,e.$Ym=f,e.$Zm=c;const P=60,$=P*60,I=$*24,L=I*7,k=I*30,g=I*365;function a(h,p,y,R){typeof h!="number"&&(h=h.getTime());const E=Math.round((new Date().getTime()-h)/1e3);if(E<-30)return(0,S.localize)(12817,null,a(new Date().getTime()+E*1e3,!1));if(!R&&E<30)return(0,S.localize)(12818,null);let d;return E<P?(d=E,p?d===1?y?(0,S.localize)(12819,null,d):(0,S.localize)(12820,null,d):y?(0,S.localize)(12821,null,d):(0,S.localize)(12822,null,d):d===1?y?(0,S.localize)(12823,null,d):(0,S.localize)(12824,null,d):y?(0,S.localize)(12825,null,d):(0,S.localize)(12826,null,d)):E<$?(d=Math.floor(E/P),p?d===1?y?(0,S.localize)(12827,null,d):(0,S.localize)(12828,null,d):y?(0,S.localize)(12829,null,d):(0,S.localize)(12830,null,d):d===1?y?(0,S.localize)(12831,null,d):(0,S.localize)(12832,null,d):y?(0,S.localize)(12833,null,d):(0,S.localize)(12834,null,d)):E<I?(d=Math.floor(E/$),p?d===1?y?(0,S.localize)(12835,null,d):(0,S.localize)(12836,null,d):y?(0,S.localize)(12837,null,d):(0,S.localize)(12838,null,d):d===1?y?(0,S.localize)(12839,null,d):(0,S.localize)(12840,null,d):y?(0,S.localize)(12841,null,d):(0,S.localize)(12842,null,d)):E<L?(d=Math.floor(E/I),p?d===1?(0,S.localize)(12843,null,d):(0,S.localize)(12844,null,d):d===1?(0,S.localize)(12845,null,d):(0,S.localize)(12846,null,d)):E<k?(d=Math.floor(E/L),p?d===1?y?(0,S.localize)(12847,null,d):(0,S.localize)(12848,null,d):y?(0,S.localize)(12849,null,d):(0,S.localize)(12850,null,d):d===1?y?(0,S.localize)(12851,null,d):(0,S.localize)(12852,null,d):y?(0,S.localize)(12853,null,d):(0,S.localize)(12854,null,d)):E<g?(d=Math.floor(E/k),p?d===1?y?(0,S.localize)(12855,null,d):(0,S.localize)(12856,null,d):y?(0,S.localize)(12857,null,d):(0,S.localize)(12858,null,d):d===1?y?(0,S.localize)(12859,null,d):(0,S.localize)(12860,null,d):y?(0,S.localize)(12861,null,d):(0,S.localize)(12862,null,d)):(d=Math.floor(E/g),p?d===1?y?(0,S.localize)(12863,null,d):(0,S.localize)(12864,null,d):y?(0,S.localize)(12865,null,d):(0,S.localize)(12866,null,d):d===1?y?(0,S.localize)(12867,null,d):(0,S.localize)(12868,null,d):y?(0,S.localize)(12869,null,d):(0,S.localize)(12870,null,d))}function f(h,p){const y=Math.abs(h/1e3);return y<1?p?(0,S.localize)(12871,null,h):(0,S.localize)(12872,null,h):y<P?p?(0,S.localize)(12873,null,Math.round(h)/1e3):(0,S.localize)(12874,null,Math.round(h)/1e3):y<$?p?(0,S.localize)(12875,null,Math.round(h/(1e3*P))):(0,S.localize)(12876,null,Math.round(h/(1e3*P))):y<I?p?(0,S.localize)(12877,null,Math.round(h/(1e3*$))):(0,S.localize)(12878,null,Math.round(h/(1e3*$))):(0,S.localize)(12879,null,Math.round(h/(1e3*I)))}function c(h){return h.getFullYear()+"-"+String(h.getMonth()+1).padStart(2,"0")+"-"+String(h.getDate()).padStart(2,"0")+"T"+String(h.getHours()).padStart(2,"0")+":"+String(h.getMinutes()).padStart(2,"0")+":"+String(h.getSeconds()).padStart(2,"0")+"."+(h.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(le[38],ue([0,1,19,3,5]),function(Y,e,S,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=g,e.$oj=a,e.$pj=f,S=ye(S),P=ye(P),$=ye($);function I(c,h){return h&&(c.stack||c.stacktrace)?$.localize(12811,null,k(c),L(c.stack)||L(c.stacktrace)):k(c)}function L(c){return Array.isArray(c)?c.join(`
`):c}function k(c){return c.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${c.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof c.code=="string"&&typeof c.errno=="number"&&typeof c.syscall=="string"?$.localize(12812,null,c.message):c.message||$.localize(12813,null)}function g(c=null,h=!1){if(!c)return $.localize(12814,null);if(Array.isArray(c)){const p=S.$Gb(c),y=g(p[0],h);return p.length>1?$.localize(12815,null,y,p.length):y}if(P.$cg(c))return c;if(c.detail){const p=c.detail;if(p.error)return I(p.error,h);if(p.exception)return I(p.exception,h)}return c.stack?I(c,h):c.message?c.message:$.localize(12816,null)}function a(c){const h=c;return h instanceof Error&&Array.isArray(h.actions)}function f(c,h){let p;return typeof c=="string"?p=new Error(c):p=c,p.actions=h,p}}),define(le[89],ue([0,1,5,34]),function(Y,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=$;function $(I){switch(I){case P.ParseErrorCode.InvalidSymbol:return(0,S.localize)(12802,null);case P.ParseErrorCode.InvalidNumberFormat:return(0,S.localize)(12803,null);case P.ParseErrorCode.PropertyNameExpected:return(0,S.localize)(12804,null);case P.ParseErrorCode.ValueExpected:return(0,S.localize)(12805,null);case P.ParseErrorCode.ColonExpected:return(0,S.localize)(12806,null);case P.ParseErrorCode.CommaExpected:return(0,S.localize)(12807,null);case P.ParseErrorCode.CloseBraceExpected:return(0,S.localize)(12808,null);case P.ParseErrorCode.CloseBracketExpected:return(0,S.localize)(12809,null);case P.ParseErrorCode.EndOfFileExpected:return(0,S.localize)(12810,null);default:return""}}}),define(le[50],ue([0,1,32,8,15,3,28,5]),function(Y,e,S,P,$,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=e.$wq=void 0,e.zip=E,e.$zq=d,e.$Aq=A,$=ye($),k=ye(k),e.$wq="end of central directory record signature not found";const g=new RegExp(e.$wq);class a extends Error{constructor(i,l){let n=l.message;switch(i){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=i,this.cause=l}}e.$xq=a;function f(w){const i=w.externalFileAttributes>>16||33188;return[448,56,7].map(l=>i&l).reduce((l,n)=>l+n,i&61440)}function c(w){if(w instanceof a)return w;let i;return g.test(w.message)&&(i="CorruptZip"),new a(i,w)}function h(w,i,l,n,r,t){const s=$.$lc(i),o=$.$ic(n,s);if(!o.startsWith(n))return Promise.reject(new Error(k.localize(12779,null,i)));const u=$.$ic(n,i);let v;return t.onCancellationRequested(()=>{v?.destroy()}),Promise.resolve(S.promises.mkdir(o,{recursive:!0})).then(()=>new Promise((N,T)=>{if(!t.isCancellationRequested)try{v=(0,S.createWriteStream)(u,{mode:l}),v.once("close",()=>N()),v.once("error",T),w.once("error",T),w.pipe(v)}catch(O){T(O)}}))}function p(w,i,l,n){let r=(0,P.$ph)(()=>Promise.resolve()),t=0;const s=n.onCancellationRequested(()=>{r.cancel(),w.close()});return new Promise((o,u)=>{const v=new P.$xh,N=T=>{T.isCancellationRequested||(t++,w.readEntry())};w.once("error",u),w.once("close",()=>r.then(()=>{n.isCancellationRequested||w.entryCount===t?o():u(new a("Incomplete",new Error(k.localize(12780,null,t,w.entryCount))))},u)),w.readEntry(),w.on("entry",T=>{if(n.isCancellationRequested)return;if(!l.sourcePathRegex.test(T.fileName)){N(n);return}const O=T.fileName.replace(l.sourcePathRegex,"");if(/\/$/.test(O)){const K=$.$ic(i,O);r=(0,P.$ph)(J=>S.promises.mkdir(K,{recursive:!0}).then(()=>N(J)).then(void 0,u));return}const D=R(w,T),q=f(T);r=(0,P.$ph)(K=>v.queue(()=>D.then(J=>h(J,O,q,i,l,K).then(()=>N(K)))).then(null,u))})}).finally(()=>s.dispose())}async function y(w,i=!1){const{open:l}=await new Promise((n,r)=>{Y(["yauzl"],n,r)}).then(ye);return new Promise((n,r)=>{l(w,i?{lazyEntries:!0}:void 0,(t,s)=>{t?r(c(t)):n((0,I.$ng)(s))})})}function R(w,i){return new Promise((l,n)=>{w.openReadStream(i,(r,t)=>{r?n(c(r)):l((0,I.$ng)(t))})})}async function E(w,i){const{ZipFile:l}=await new Promise((n,r)=>{Y(["yazl"],n,r)}).then(ye);return new Promise((n,r)=>{const t=new l;i.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const s=(0,S.createWriteStream)(w);t.outputStream.pipe(s),t.outputStream.once("error",r),s.once("error",r),s.once("finish",()=>n(w))})}function d(w,i,l={},n){const r=new RegExp(l.sourcePath?`^${l.sourcePath}`:"");let t=y(w,!0);return l.overwrite&&(t=t.then(s=>L.Promises.rm(i).then(()=>s))),t.then(s=>p(s,i,{sourcePathRegex:r},n))}function m(w,i){return y(w).then(l=>new Promise((n,r)=>{l.on("entry",t=>{t.fileName===i&&R(l,t).then(s=>n(s),s=>r(s))}),l.once("close",()=>r(new Error(k.localize(12781,null,i))))}))}function A(w,i){return m(w,i).then(l=>new Promise((n,r)=>{const t=[];l.once("error",r),l.on("data",s=>t.push(s)),l.on("end",()=>n(Buffer.concat(t)))}))}}),define(le[90],ue([0,1,91,7,5]),function(Y,e,S,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.TokenType=void 0;var I;(function(f){f[f.LParen=0]="LParen",f[f.RParen=1]="RParen",f[f.Neg=2]="Neg",f[f.Eq=3]="Eq",f[f.NotEq=4]="NotEq",f[f.Lt=5]="Lt",f[f.LtEq=6]="LtEq",f[f.Gt=7]="Gt",f[f.GtEq=8]="GtEq",f[f.RegexOp=9]="RegexOp",f[f.RegexStr=10]="RegexStr",f[f.True=11]="True",f[f.False=12]="False",f[f.In=13]="In",f[f.Not=14]="Not",f[f.And=15]="And",f[f.Or=16]="Or",f[f.Str=17]="Str",f[f.QuotedStr=18]="QuotedStr",f[f.Error=19]="Error",f[f.EOF=20]="EOF"})(I||(e.TokenType=I={}));function L(...f){switch(f.length){case 1:return(0,$.localize)(11418,null,f[0]);case 2:return(0,$.localize)(11419,null,f[0],f[1]);case 3:return(0,$.localize)(11420,null,f[0],f[1],f[2]);default:return}}const k=(0,$.localize)(11421,null),g=(0,$.localize)(11422,null);class a{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(c){switch(c.type){case I.LParen:return"(";case I.RParen:return")";case I.Neg:return"!";case I.Eq:return c.isTripleEq?"===":"==";case I.NotEq:return c.isTripleEq?"!==":"!=";case I.Lt:return"<";case I.LtEq:return"<=";case I.Gt:return">=";case I.GtEq:return">=";case I.RegexOp:return"=~";case I.RegexStr:return c.lexeme;case I.True:return"true";case I.False:return"false";case I.In:return"in";case I.Not:return"not";case I.And:return"&&";case I.Or:return"||";case I.Str:return c.lexeme;case I.QuotedStr:return c.lexeme;case I.Error:return c.lexeme;case I.EOF:return"EOF";default:throw(0,P.$7)(`unhandled token type: ${JSON.stringify(c)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(c=>c.charCodeAt(0)))}static{this.b=new Map([["not",I.Not],["in",I.In],["false",I.False],["true",I.True]])}get errors(){return this.g}reset(c){return this.c=c,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case S.CharCode.OpenParen:this.k(I.LParen);break;case S.CharCode.CloseParen:this.k(I.RParen);break;case S.CharCode.ExclamationMark:if(this.h(S.CharCode.Equals)){const h=this.h(S.CharCode.Equals);this.f.push({type:I.NotEq,offset:this.d,isTripleEq:h})}else this.k(I.Neg);break;case S.CharCode.SingleQuote:this.o();break;case S.CharCode.Slash:this.q();break;case S.CharCode.Equals:if(this.h(S.CharCode.Equals)){const h=this.h(S.CharCode.Equals);this.f.push({type:I.Eq,offset:this.d,isTripleEq:h})}else this.h(S.CharCode.Tilde)?this.k(I.RegexOp):this.l(L("==","=~"));break;case S.CharCode.LessThan:this.k(this.h(S.CharCode.Equals)?I.LtEq:I.Lt);break;case S.CharCode.GreaterThan:this.k(this.h(S.CharCode.Equals)?I.GtEq:I.Gt);break;case S.CharCode.Ampersand:this.h(S.CharCode.Ampersand)?this.k(I.And):this.l(L("&&"));break;case S.CharCode.Pipe:this.h(S.CharCode.Pipe)?this.k(I.Or):this.l(L("||"));break;case S.CharCode.Space:case S.CharCode.CarriageReturn:case S.CharCode.Tab:case S.CharCode.LineFeed:case S.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(I.EOF),Array.from(this.f)}h(c){return this.r()||this.c.charCodeAt(this.e)!==c?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?S.CharCode.Null:this.c.charCodeAt(this.e)}k(c){this.f.push({type:c,offset:this.d})}l(c){const h=this.d,p=this.c.substring(this.d,this.e),y={type:I.Error,offset:this.d,lexeme:p};this.g.push({offset:h,lexeme:p,additionalInfo:c}),this.f.push(y)}n(){this.m.lastIndex=this.d;const c=this.m.exec(this.c);if(c){this.e=this.d+c[0].length;const h=this.c.substring(this.d,this.e),p=a.b.get(h);p?this.k(p):this.f.push({type:I.Str,lexeme:h,offset:this.d})}}o(){for(;this.j()!==S.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(k);return}this.i(),this.f.push({type:I.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let c=this.e,h=!1,p=!1;for(;;){if(c>=this.c.length){this.e=c,this.l(g);return}const R=this.c.charCodeAt(c);if(h)h=!1;else if(R===S.CharCode.Slash&&!p){c++;break}else R===S.CharCode.OpenSquareBracket?p=!0:R===S.CharCode.Backslash?h=!0:R===S.CharCode.CloseSquareBracket&&(p=!1);c++}for(;c<this.c.length&&a.a.has(this.c.charCodeAt(c));)c++;this.e=c;const y=this.c.substring(this.d,this.e);this.f.push({type:I.RegexStr,lexeme:y,offset:this.d})}r(){return this.e>=this.c.length}}e.$xj=a}),define(le[92],ue([0,1,88,55,14,15,36,16,11]),function(Y,e,S,P,$,I,L,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=e.$1m=void 0,e.$3m=f,e.$4m=c,e.$1m=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,I.$lc)($.$Wg.asFileUri("").fsPath)}get userHome(){return g.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return g.URI.file((0,I.$ic)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.b.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get stateResource(){return(0,k.$dh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:$.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,k.$dh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const p=(0,S.$Zm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,I.$ic)(this.userDataPath,"logs",p)}return g.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.$dh)(g.URI.file((0,I.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.$dh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.$dh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.$dh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const p=L.env.VSCODE_PORTABLE;return p?g.URI.file((0,I.$ic)(p,"argv.json")):(0,k.$dh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,I.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const p=this.args["builtin-extensions-dir"];return p?(0,I.$jc)(p):(0,I.$gc)((0,I.$ic)($.$Wg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const p=this.args["extensions-download-dir"];return p?g.URI.file((0,I.$jc)(p)):g.URI.file((0,I.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const p=this.args["extensions-dir"];if(p)return(0,I.$jc)(p);const y=L.env.VSCODE_EXTENSIONS;if(y)return y;const R=L.env.VSCODE_PORTABLE;return R?(0,I.$ic)(R,"extensions"):(0,k.$dh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const p=this.args.extensionDevelopmentPath;if(Array.isArray(p))return p.map(y=>/^[^:/?#]+?:\/\//.test(y)?g.URI.parse(y):g.URI.file((0,I.$gc)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(p=>p==="ui"||p==="workspace"||p==="web"?p:"workspace")}get extensionTestsLocationURI(){const p=this.args.extensionTestsPath;if(p)return/^[^:/?#]+?:\/\//.test(p)?g.URI.parse(p):g.URI.file((0,I.$gc)(p))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const p=this.args["disable-extension"];if(p){if(typeof p=="string")return[p];if(Array.isArray(p)&&p.length>0)return p}return!1}get debugExtensionHost(){return f(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(p=>!e.$1m.test(p))}get extensionLogLevel(){const p=[];for(const y of this.args.log||[]){const R=e.$1m.exec(y);R&&R[1]&&R[2]&&p.push([R[1],R[2]])}return p.length?p:void 0}get serviceMachineIdResource(){return(0,k.$dh)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const p=L.env.VSCODE_PORTABLE;return p?g.URI.file((0,I.$ic)(p,"policy.json")):(0,k.$dh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(p){this.args.continueOn=p}get args(){return this.a}constructor(p,y,R){this.a=p,this.b=y,this.c=R,this.editSessionId=this.args.editSessionId}}e.$2m=a,ve([P.$7h],a.prototype,"appRoot",null),ve([P.$7h],a.prototype,"userHome",null),ve([P.$7h],a.prototype,"userDataPath",null),ve([P.$7h],a.prototype,"appSettingsHome",null),ve([P.$7h],a.prototype,"tmpDir",null),ve([P.$7h],a.prototype,"cacheHome",null),ve([P.$7h],a.prototype,"stateResource",null),ve([P.$7h],a.prototype,"userRoamingDataHome",null),ve([P.$7h],a.prototype,"userDataSyncHome",null),ve([P.$7h],a.prototype,"sync",null),ve([P.$7h],a.prototype,"machineSettingsResource",null),ve([P.$7h],a.prototype,"workspaceStorageHome",null),ve([P.$7h],a.prototype,"localHistoryHome",null),ve([P.$7h],a.prototype,"keyboardLayoutResource",null),ve([P.$7h],a.prototype,"argvResource",null),ve([P.$7h],a.prototype,"isExtensionDevelopment",null),ve([P.$7h],a.prototype,"untitledWorkspacesHome",null),ve([P.$7h],a.prototype,"builtinExtensionsPath",null),ve([P.$7h],a.prototype,"extensionsPath",null),ve([P.$7h],a.prototype,"extensionDevelopmentLocationURI",null),ve([P.$7h],a.prototype,"extensionDevelopmentKind",null),ve([P.$7h],a.prototype,"extensionTestsLocationURI",null),ve([P.$7h],a.prototype,"debugExtensionHost",null),ve([P.$7h],a.prototype,"logLevel",null),ve([P.$7h],a.prototype,"extensionLogLevel",null),ve([P.$7h],a.prototype,"serviceMachineIdResource",null),ve([P.$7h],a.prototype,"disableTelemetry",null),ve([P.$7h],a.prototype,"disableWorkspaceTrust",null),ve([P.$7h],a.prototype,"useInMemorySecretStorage",null),ve([P.$7h],a.prototype,"policyFile",null);function f(h,p){return c(h["inspect-extensions"],h["inspect-brk-extensions"],5870,p,h.debugId,h.extensionEnvironment)}function c(h,p,y,R,E,d){const A=Number(p||h)||(R?null:y),w=A?!!p:!1;let i;if(d)try{i=JSON.parse(d)}catch{}return{port:A,break:w,debugId:E,env:i}}}),function(){"use strict";function Y(e,S,P){function $(L,k){const g=I(L,k),a=[g];return e.isAbsolute(g)||a.unshift(P),e.resolve(...a)}function I(L,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,k);const f=L["user-data-dir"];if(f)return f;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const c=process.env.USERPROFILE;if(typeof c!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(c,"AppData","Roaming")}break;case"darwin":a=e.join(S.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,k)}return{getUserDataPath:$}}if(typeof define=="function")define(le[93],ue([147,35,36]),function(e,S,P){return Y(e,S,P.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),S=require("os");module.exports=Y(e,S,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[94],ue([0,1,35,92,93]),function(Y,e,S,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=void 0,e.$6m=L,e.$7m=k;class I extends P.$2m{constructor(a,f){super(a,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,$.getUserDataPath)(a,f.nameShort)},f)}}e.$5m=I;function L(g,a){return(0,P.$4m)(g["inspect-ptyhost"],g["inspect-brk-ptyhost"],5877,a,g.extensionEnvironment)}function k(g,a){return(0,P.$4m)(g["inspect-sharedprocess"],g["inspect-brk-sharedprocess"],5879,a,g.extensionEnvironment)}}),define(le[95],ue([0,1,3,5]),function(Y,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=$;function $(L,k,g,a){try{I(L,k,g,a)}catch(f){L.error(f?.message??f)}return k}function I(L,k,g,a){const f=(c,h,p)=>{const y=c[h];if((0,S.$cg)(y)){const R=y,E=R.length;if(E>1&&R[0]==="%"&&R[E-1]==="%"){const d=R.substr(1,E-2);let m=g[d];m===void 0&&a&&(m=a[d]);const A=typeof m=="string"?m:m?.message,w=a?.[d],i=typeof w=="string"?w:w?.message;if(!A){i||L.warn(`[${k.name}]: ${(0,P.localize)(11301,null,d)}`);return}if(p&&(h==="title"||h==="category")&&i&&i!==A){const l={value:A,original:i};c[h]=l}else c[h]=A}}else if((0,S.$eg)(y))for(const R in y)y.hasOwnProperty(R)&&(R==="commands"?f(y,R,!0):f(y,R,p));else if(Array.isArray(y))for(let R=0;R<y.length;R++)f(y,R,p)};for(const c in k)k.hasOwnProperty(c)&&f(k,c)}}),define(le[96],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const S={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(S)}),define(le[51],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=void 0;class S{constructor($,I=[],L=!1){this.ctor=$,this.staticArguments=I,this.supportsDelayedInstantiation=L}}e.$zi=S}),define(le[97],ue([0,1,51]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ns=I,e.$Os=L;const P=[];var $;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})($||(e.InstantiationType=$={}));function I(k,g,a){g instanceof S.$zi||(g=new S.$zi(g,[],!!a)),P.push([k,g])}function L(){return P}}),define(le[98],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=e.$qr=void 0;class S{constructor(I,L){this.key=I,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.$qr=S;class P{constructor(I){this.b=I,this.a=new Map}roots(){const I=[];for(const L of this.a.values())L.outgoing.size===0&&I.push(L);return I}insertEdge(I,L){const k=this.lookupOrInsertNode(I),g=this.lookupOrInsertNode(L);k.outgoing.set(g.key,g),g.incoming.set(k.key,k)}removeNode(I){const L=this.b(I);this.a.delete(L);for(const k of this.a.values())k.outgoing.delete(L),k.incoming.delete(L)}lookupOrInsertNode(I){const L=this.b(I);let k=this.a.get(L);return k||(k=new S(L,I),this.a.set(L,k)),k}lookup(I){return this.a.get(this.b(I))}isEmpty(){return this.a.size===0}toString(){const I=[];for(const[L,k]of this.a)I.push(`${L}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return I.join(`
`)}findCycleSlow(){for(const[I,L]of this.a){const k=new Set([I]),g=this.c(L,k);if(g)return g}}c(I,L){for(const[k,g]of I.outgoing){if(L.has(k))return[...L,k].join(" -> ");L.add(k);const a=this.c(g,L);if(a)return a;L.delete(k)}}}e.$rr=P}),define(le[29],ue([0,1,3,11,10]),function(Y,e,S,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$9i=void 0,e.$0i=I,e.$$i=L,e.$_i=g,e.$aj=a,e.$bj=f,e.$cj=c,e.$dj=h,e.$ej=y,e.$fj=R,e.$gj=E,S=ye(S),e.$9i=(0,$.$Ci)("configurationService");function I(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof P.URI)}function L(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof P.URI)}var k;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(k||(e.ConfigurationTarget=k={}));function g(d){switch(d){case k.APPLICATION:return"APPLICATION";case k.USER:return"USER";case k.USER_LOCAL:return"USER_LOCAL";case k.USER_REMOTE:return"USER_REMOTE";case k.WORKSPACE:return"WORKSPACE";case k.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case k.DEFAULT:return"DEFAULT";case k.MEMORY:return"MEMORY"}}function a(d){return d.applicationValue!==void 0||d.userValue!==void 0||d.userLocalValue!==void 0||d.userRemoteValue!==void 0||d.workspaceValue!==void 0||d.workspaceFolderValue!==void 0}function f(d,m){const A=Object.create(null);for(const w in d)c(A,w,d[w],m);return A}function c(d,m,A,w){const i=m.split("."),l=i.pop();let n=d;for(let r=0;r<i.length;r++){const t=i[r];let s=n[t];switch(typeof s){case"undefined":s=n[t]=Object.create(null);break;case"object":if(s===null){w(`Ignoring ${m} as ${i.slice(0,r+1).join(".")} is null`);return}break;default:w(`Ignoring ${m} as ${i.slice(0,r+1).join(".")} is ${JSON.stringify(s)}`);return}n=s}if(typeof n=="object"&&n!==null)try{n[l]=A}catch{w(`Ignoring ${m} as ${i.join(".")} is ${JSON.stringify(n)}`)}else w(`Ignoring ${m} as ${i.join(".")} is ${JSON.stringify(n)}`)}function h(d,m){const A=m.split(".");p(d,A)}function p(d,m){const A=m.shift();if(m.length===0){delete d[A];return}if(Object.keys(d).indexOf(A)!==-1){const w=d[A];typeof w=="object"&&!Array.isArray(w)&&(p(w,m),Object.keys(w).length===0&&delete d[A])}}function y(d,m,A){function w(n,r){let t=n;for(const s of r){if(typeof t!="object"||t===null)return;t=t[s]}return t}const i=m.split("."),l=w(d,i);return typeof l>"u"?A:l}function R(d,m,A){Object.keys(m).forEach(w=>{w!=="__proto__"&&(w in d?S.$eg(d[w])&&S.$eg(m[w])?R(d[w],m[w],A):A&&(d[w]=m[w]):d[w]=m[w])})}function E(d){return d.replace(/[\[\]]/g,"")}}),define(le[99],ue([0,1,91,12,31,90,10,5,7]),function(Y,e,S,P,$,I,L,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Aj=e.$zj=e.ContextKeyExprType=void 0,e.$yj=f,e.$Bj=r,e.$Cj=t,e.$Vj=ne;const a=new Map;a.set("false",!1),a.set("true",!0),a.set("isMac",P.$k),a.set("isLinux",P.$l),a.set("isWindows",P.$j),a.set("isWeb",P.$p),a.set("isMacNative",P.$k&&!P.$p),a.set("isEdge",P.$I),a.set("isFirefox",P.$G),a.set("isChrome",P.$F),a.set("isSafari",P.$H);function f(M,b){if(a.get(M)!==void 0)throw(0,g.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");a.set(M,b)}const c=Object.prototype.hasOwnProperty;var h;(function(M){M[M.False=0]="False",M[M.True=1]="True",M[M.Defined=2]="Defined",M[M.Not=3]="Not",M[M.Equals=4]="Equals",M[M.NotEquals=5]="NotEquals",M[M.And=6]="And",M[M.Regex=7]="Regex",M[M.NotRegex=8]="NotRegex",M[M.Or=9]="Or",M[M.In=10]="In",M[M.NotIn=11]="NotIn",M[M.Greater=12]="Greater",M[M.GreaterEquals=13]="GreaterEquals",M[M.Smaller=14]="Smaller",M[M.SmallerEquals=15]="SmallerEquals"})(h||(e.ContextKeyExprType=h={}));const p={regexParsingWithErrorRecovery:!0},y=(0,k.localize)(11432,null),R=(0,k.localize)(11433,null),E=(0,k.localize)(11434,null),d=(0,k.localize)(11435,null),m=(0,k.localize)(11436,null),A=(0,k.localize)(11437,null),w=(0,k.localize)(11438,null),i=(0,k.localize)(11439,null);class l{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(b=p){this.k=b,this.d=new I.$xj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(b){if(b===""){this.h.push({message:y,offset:0,lexeme:"",additionalInfo:R});return}this.f=this.d.reset(b).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const U=this.D(),C=U.type===I.TokenType.Str?A:void 0;throw this.h.push({message:m,offset:U.offset,lexeme:I.$xj.getLexeme(U),additionalInfo:C}),l.c}return F}catch(F){if(F!==l.c)throw F;return}}l(){return this.m()}m(){const b=[this.o()];for(;this.y(I.TokenType.Or);){const F=this.o();b.push(F)}return b.length===1?b[0]:n.or(...b)}o(){const b=[this.s()];for(;this.y(I.TokenType.And);){const F=this.s();b.push(F)}return b.length===1?b[0]:n.and(...b)}s(){if(this.y(I.TokenType.Neg)){const b=this.D();switch(b.type){case I.TokenType.True:return this.z(),o.INSTANCE;case I.TokenType.False:return this.z(),u.INSTANCE;case I.TokenType.LParen:{this.z();const F=this.l();return this.A(I.TokenType.RParen,d),F?.negate()}case I.TokenType.Str:return this.z(),q.create(b.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",b)}}return this.t()}t(){const b=this.D();switch(b.type){case I.TokenType.True:return this.z(),n.true();case I.TokenType.False:return this.z(),n.false();case I.TokenType.LParen:{this.z();const F=this.l();return this.A(I.TokenType.RParen,d),F}case I.TokenType.Str:{const F=b.lexeme;if(this.z(),this.y(I.TokenType.RegexOp)){const C=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),C.type!==I.TokenType.RegexStr)throw this.B("REGEX",C);const x=C.lexeme,Q=x.lastIndexOf("/"),ee=Q===x.length-1?void 0:this.w(x.substring(Q+1));let oe;try{oe=new RegExp(x.substring(1,Q),ee)}catch{throw this.B("REGEX",C)}return de.create(F,oe)}switch(C.type){case I.TokenType.RegexStr:case I.TokenType.Error:{const x=[C.lexeme];this.z();let Q=this.D(),ee=0;for(let we=0;we<C.lexeme.length;we++)C.lexeme.charCodeAt(we)===S.CharCode.OpenParen?ee++:C.lexeme.charCodeAt(we)===S.CharCode.CloseParen&&ee--;for(;!this.E()&&Q.type!==I.TokenType.And&&Q.type!==I.TokenType.Or;){switch(Q.type){case I.TokenType.LParen:ee++;break;case I.TokenType.RParen:ee--;break;case I.TokenType.RegexStr:case I.TokenType.QuotedStr:for(let we=0;we<Q.lexeme.length;we++)Q.lexeme.charCodeAt(we)===S.CharCode.OpenParen?ee++:C.lexeme.charCodeAt(we)===S.CharCode.CloseParen&&ee--}if(ee<0)break;x.push(I.$xj.getLexeme(Q)),this.z(),Q=this.D()}const oe=x.join(""),fe=oe.lastIndexOf("/"),me=fe===oe.length-1?void 0:this.w(oe.substring(fe+1));let ge;try{ge=new RegExp(oe.substring(1,fe),me)}catch{throw this.B("REGEX",C)}return n.regex(F,ge)}case I.TokenType.QuotedStr:{const x=C.lexeme;this.z();let Q=null;if(!(0,$.$af)(x)){const ee=x.indexOf("/"),oe=x.lastIndexOf("/");if(ee!==oe&&ee>=0){const fe=x.slice(ee+1,oe),me=x[oe+1]==="i"?"i":"";try{Q=new RegExp(fe,me)}catch{throw this.B("REGEX",C)}}}if(Q===null)throw this.B("REGEX",C);return de.create(F,Q)}default:throw this.B("REGEX",this.D())}}if(this.y(I.TokenType.Not)){this.A(I.TokenType.In,E);const C=this.u();return n.notIn(F,C)}switch(this.D().type){case I.TokenType.Eq:{this.z();const C=this.u();if(this.x().type===I.TokenType.QuotedStr)return n.equals(F,C);switch(C){case"true":return n.has(F);case"false":return n.not(F);default:return n.equals(F,C)}}case I.TokenType.NotEq:{this.z();const C=this.u();if(this.x().type===I.TokenType.QuotedStr)return n.notEquals(F,C);switch(C){case"true":return n.not(F);case"false":return n.has(F);default:return n.notEquals(F,C)}}case I.TokenType.Lt:return this.z(),ae.create(F,this.u());case I.TokenType.LtEq:return this.z(),ce.create(F,this.u());case I.TokenType.Gt:return this.z(),J.create(F,this.u());case I.TokenType.GtEq:return this.z(),re.create(F,this.u());case I.TokenType.In:return this.z(),n.in(F,this.u());default:return n.has(F)}}case I.TokenType.EOF:throw this.h.push({message:w,offset:b.offset,lexeme:"",additionalInfo:i}),l.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const b=this.D();switch(b.type){case I.TokenType.Str:case I.TokenType.QuotedStr:return this.z(),b.lexeme;case I.TokenType.True:return this.z(),"true";case I.TokenType.False:return this.z(),"false";case I.TokenType.In:return this.z(),"in";default:return""}}w(b){return b.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(b){return this.C(b)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(b,F){if(this.C(b))return this.z();throw this.B(F,this.D())}B(b,F,U){const C=(0,k.localize)(11440,null,b,I.$xj.getLexeme(F)),x=F.offset,Q=I.$xj.getLexeme(F);return this.h.push({message:C,offset:x,lexeme:Q,additionalInfo:U}),l.c}C(b){return this.D().type===b}D(){return this.f[this.g]}E(){return this.D().type===I.TokenType.EOF}}e.$zj=l;class n{static false(){return o.INSTANCE}static true(){return u.INSTANCE}static has(b){return v.create(b)}static equals(b,F){return N.create(b,F)}static notEquals(b,F){return D.create(b,F)}static regex(b,F){return de.create(b,F)}static in(b,F){return T.create(b,F)}static notIn(b,F){return O.create(b,F)}static not(b){return q.create(b)}static and(...b){return B.create(b,null,!0)}static or(...b){return z.create(b,null,!0)}static greater(b,F){return J.create(b,F)}static greaterEquals(b,F){return re.create(b,F)}static smaller(b,F){return ae.create(b,F)}static smallerEquals(b,F){return ce.create(b,F)}static{this.c=new l({regexParsingWithErrorRecovery:!1})}static deserialize(b){return b==null?void 0:this.c.parse(b)}}e.$Aj=n;function r(M){const b=new l({regexParsingWithErrorRecovery:!1});return M.map(F=>(b.parse(F),b.lexingErrors.length>0?b.lexingErrors.map(U=>({errorMessage:U.additionalInfo?(0,k.localize)(11441,null,U.additionalInfo):(0,k.localize)(11442,null),offset:U.offset,length:U.lexeme.length})):b.parsingErrors.length>0?b.parsingErrors.map(U=>({errorMessage:U.additionalInfo?`${U.message}. ${U.additionalInfo}`:U.message,offset:U.offset,length:U.lexeme.length})):[]))}function t(M,b){const F=M?M.substituteConstants():void 0,U=b?b.substituteConstants():void 0;return!F&&!U?!0:!F||!U?!1:F.equals(U)}function s(M,b){return M.cmp(b)}class o{static{this.INSTANCE=new o}constructor(){this.type=h.False}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}substituteConstants(){return this}evaluate(b){return!1}serialize(){return"false"}keys(){return[]}map(b){return this}negate(){return u.INSTANCE}}e.$Dj=o;class u{static{this.INSTANCE=new u}constructor(){this.type=h.True}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}substituteConstants(){return this}evaluate(b){return!0}serialize(){return"true"}keys(){return[]}map(b){return this}negate(){return o.INSTANCE}}e.$Ej=u;class v{static create(b,F=null){const U=a.get(b);return typeof U=="boolean"?U?u.INSTANCE:o.INSTANCE:new v(b,F)}constructor(b,F){this.key=b,this.c=F,this.type=h.Defined}cmp(b){return b.type!==this.type?this.type-b.type:X(this.key,b.key)}equals(b){return b.type===this.type?this.key===b.key:!1}substituteConstants(){const b=a.get(this.key);return typeof b=="boolean"?b?u.INSTANCE:o.INSTANCE:this}evaluate(b){return!!b.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(b){return b.mapDefined(this.key)}negate(){return this.c||(this.c=q.create(this.key,this)),this.c}}e.$Fj=v;class N{static create(b,F,U=null){if(typeof F=="boolean")return F?v.create(b,U):q.create(b,U);const C=a.get(b);return typeof C=="boolean"?F===(C?"true":"false")?u.INSTANCE:o.INSTANCE:new N(b,F,U)}constructor(b,F,U){this.c=b,this.d=F,this.f=U,this.type=h.Equals}cmp(b){return b.type!==this.type?this.type-b.type:te(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){const b=a.get(this.c);if(typeof b=="boolean"){const F=b?"true":"false";return this.d===F?u.INSTANCE:o.INSTANCE}return this}evaluate(b){return b.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(b){return b.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$Gj=N;class T{static create(b,F){return new T(b,F)}constructor(b,F){this.d=b,this.f=F,this.type=h.In,this.c=null}cmp(b){return b.type!==this.type?this.type-b.type:te(this.d,this.f,b.d,b.f)}equals(b){return b.type===this.type?this.d===b.d&&this.f===b.f:!1}substituteConstants(){return this}evaluate(b){const F=b.getValue(this.f),U=b.getValue(this.d);return Array.isArray(F)?F.includes(U):typeof U=="string"&&typeof F=="object"&&F!==null?c.call(F,U):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(b){return b.mapIn(this.d,this.f)}negate(){return this.c||(this.c=O.create(this.d,this.f)),this.c}}e.$Hj=T;class O{static create(b,F){return new O(b,F)}constructor(b,F){this.d=b,this.f=F,this.type=h.NotIn,this.c=T.create(b,F)}cmp(b){return b.type!==this.type?this.type-b.type:this.c.cmp(b.c)}equals(b){return b.type===this.type?this.c.equals(b.c):!1}substituteConstants(){return this}evaluate(b){return!this.c.evaluate(b)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(b){return b.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ij=O;class D{static create(b,F,U=null){if(typeof F=="boolean")return F?q.create(b,U):v.create(b,U);const C=a.get(b);return typeof C=="boolean"?F===(C?"true":"false")?o.INSTANCE:u.INSTANCE:new D(b,F,U)}constructor(b,F,U){this.c=b,this.d=F,this.f=U,this.type=h.NotEquals}cmp(b){return b.type!==this.type?this.type-b.type:te(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){const b=a.get(this.c);if(typeof b=="boolean"){const F=b?"true":"false";return this.d===F?o.INSTANCE:u.INSTANCE}return this}evaluate(b){return b.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(b){return b.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Jj=D;class q{static create(b,F=null){const U=a.get(b);return typeof U=="boolean"?U?o.INSTANCE:u.INSTANCE:new q(b,F)}constructor(b,F){this.c=b,this.d=F,this.type=h.Not}cmp(b){return b.type!==this.type?this.type-b.type:X(this.c,b.c)}equals(b){return b.type===this.type?this.c===b.c:!1}substituteConstants(){const b=a.get(this.c);return typeof b=="boolean"?b?o.INSTANCE:u.INSTANCE:this}evaluate(b){return!b.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(b){return b.mapNot(this.c)}negate(){return this.d||(this.d=v.create(this.c,this)),this.d}}e.$Kj=q;function K(M,b){if(typeof M=="string"){const F=parseFloat(M);isNaN(F)||(M=F)}return typeof M=="string"||typeof M=="number"?b(M):o.INSTANCE}class J{static create(b,F,U=null){return K(F,C=>new J(b,C,U))}constructor(b,F,U){this.c=b,this.d=F,this.f=U,this.type=h.Greater}cmp(b){return b.type!==this.type?this.type-b.type:te(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){return this}evaluate(b){return typeof this.d=="string"?!1:parseFloat(b.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(b){return b.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ce.create(this.c,this.d,this)),this.f}}e.$Lj=J;class re{static create(b,F,U=null){return K(F,C=>new re(b,C,U))}constructor(b,F,U){this.c=b,this.d=F,this.f=U,this.type=h.GreaterEquals}cmp(b){return b.type!==this.type?this.type-b.type:te(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){return this}evaluate(b){return typeof this.d=="string"?!1:parseFloat(b.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(b){return b.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Mj=re;class ae{static create(b,F,U=null){return K(F,C=>new ae(b,C,U))}constructor(b,F,U){this.c=b,this.d=F,this.f=U,this.type=h.Smaller}cmp(b){return b.type!==this.type?this.type-b.type:te(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){return this}evaluate(b){return typeof this.d=="string"?!1:parseFloat(b.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(b){return b.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.$Nj=ae;class ce{static create(b,F,U=null){return K(F,C=>new ce(b,C,U))}constructor(b,F,U){this.c=b,this.d=F,this.f=U,this.type=h.SmallerEquals}cmp(b){return b.type!==this.type?this.type-b.type:te(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){return this}evaluate(b){return typeof this.d=="string"?!1:parseFloat(b.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(b){return b.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.$Oj=ce;class de{static create(b,F){return new de(b,F)}constructor(b,F){this.d=b,this.f=F,this.type=h.Regex,this.c=null}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.d<b.d)return-1;if(this.d>b.d)return 1;const F=this.f?this.f.source:"",U=b.f?b.f.source:"";return F<U?-1:F>U?1:0}equals(b){if(b.type===this.type){const F=this.f?this.f.source:"",U=b.f?b.f.source:"";return this.d===b.d&&F===U}return!1}substituteConstants(){return this}evaluate(b){const F=b.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const b=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${b}`}keys(){return[this.d]}map(b){return b.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=H.create(this)),this.c}}e.$Pj=de;class H{static create(b){return new H(b)}constructor(b){this.c=b,this.type=h.NotRegex}cmp(b){return b.type!==this.type?this.type-b.type:this.c.cmp(b.c)}equals(b){return b.type===this.type?this.c.equals(b.c):!1}substituteConstants(){return this}evaluate(b){return!this.c.evaluate(b)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(b){return new H(this.c.map(b))}negate(){return this.c}}e.$Qj=H;function Z(M){let b=null;for(let F=0,U=M.length;F<U;F++){const C=M[F].substituteConstants();if(M[F]!==C&&b===null){b=[];for(let x=0;x<F;x++)b[x]=M[x]}b!==null&&(b[F]=C)}return b===null?M:b}class B{static create(b,F,U){return B.d(b,F,U)}constructor(b,F){this.expr=b,this.c=F,this.type=h.And}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let F=0,U=this.expr.length;F<U;F++){const C=s(this.expr[F],b.expr[F]);if(C!==0)return C}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let F=0,U=this.expr.length;F<U;F++)if(!this.expr[F].equals(b.expr[F]))return!1;return!0}return!1}substituteConstants(){const b=Z(this.expr);return b===this.expr?this:B.create(b,this.c,!1)}evaluate(b){for(let F=0,U=this.expr.length;F<U;F++)if(!this.expr[F].evaluate(b))return!1;return!0}static d(b,F,U){const C=[];let x=!1;for(const Q of b)if(Q){if(Q.type===h.True){x=!0;continue}if(Q.type===h.False)return o.INSTANCE;if(Q.type===h.And){C.push(...Q.expr);continue}C.push(Q)}if(C.length===0&&x)return u.INSTANCE;if(C.length!==0){if(C.length===1)return C[0];C.sort(s);for(let Q=1;Q<C.length;Q++)C[Q-1].equals(C[Q])&&(C.splice(Q,1),Q--);if(C.length===1)return C[0];for(;C.length>1;){const Q=C[C.length-1];if(Q.type!==h.Or)break;C.pop();const ee=C.pop(),oe=C.length===0,fe=z.create(Q.expr.map(me=>B.create([me,ee],null,U)),null,oe);fe&&(C.push(fe),C.sort(s))}if(C.length===1)return C[0];if(U){for(let Q=0;Q<C.length;Q++)for(let ee=Q+1;ee<C.length;ee++)if(C[Q].negate().equals(C[ee]))return o.INSTANCE;if(C.length===1)return C[0]}return new B(C,F)}}serialize(){return this.expr.map(b=>b.serialize()).join(" && ")}keys(){const b=[];for(const F of this.expr)b.push(...F.keys());return b}map(b){return new B(this.expr.map(F=>F.map(b)),null)}negate(){if(!this.c){const b=[];for(const F of this.expr)b.push(F.negate());this.c=z.create(b,this,!0)}return this.c}}e.$Rj=B;class z{static create(b,F,U){return z.d(b,F,U)}constructor(b,F){this.expr=b,this.c=F,this.type=h.Or}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let F=0,U=this.expr.length;F<U;F++){const C=s(this.expr[F],b.expr[F]);if(C!==0)return C}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let F=0,U=this.expr.length;F<U;F++)if(!this.expr[F].equals(b.expr[F]))return!1;return!0}return!1}substituteConstants(){const b=Z(this.expr);return b===this.expr?this:z.create(b,this.c,!1)}evaluate(b){for(let F=0,U=this.expr.length;F<U;F++)if(this.expr[F].evaluate(b))return!0;return!1}static d(b,F,U){let C=[],x=!1;if(b){for(let Q=0,ee=b.length;Q<ee;Q++){const oe=b[Q];if(oe){if(oe.type===h.False){x=!0;continue}if(oe.type===h.True)return u.INSTANCE;if(oe.type===h.Or){C=C.concat(oe.expr);continue}C.push(oe)}}if(C.length===0&&x)return o.INSTANCE;C.sort(s)}if(C.length!==0){if(C.length===1)return C[0];for(let Q=1;Q<C.length;Q++)C[Q-1].equals(C[Q])&&(C.splice(Q,1),Q--);if(C.length===1)return C[0];if(U){for(let Q=0;Q<C.length;Q++)for(let ee=Q+1;ee<C.length;ee++)if(C[Q].negate().equals(C[ee]))return u.INSTANCE;if(C.length===1)return C[0]}return new z(C,F)}}serialize(){return this.expr.map(b=>b.serialize()).join(" || ")}keys(){const b=[];for(const F of this.expr)b.push(...F.keys());return b}map(b){return new z(this.expr.map(F=>F.map(b)),null)}negate(){if(!this.c){const b=[];for(const F of this.expr)b.push(F.negate());for(;b.length>1;){const F=b.shift(),U=b.shift(),C=[];for(const x of W(F))for(const Q of W(U))C.push(B.create([x,Q],null,!1));b.unshift(z.create(C,null,!1))}this.c=z.create(b,this,!0)}return this.c}}e.$Sj=z;class G extends v{static{this.d=[]}static all(){return G.d.values()}constructor(b,F,U){super(b,null),this.f=F,typeof U=="object"?G.d.push({...U,key:b}):U!==!0&&G.d.push({key:b,description:U,type:F!=null?typeof F:void 0})}bindTo(b){return b.createKey(this.key,this.f)}getValue(b){return b.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(b){return N.create(this.key,b)}notEqualsTo(b){return D.create(this.key,b)}}e.$Tj=G,e.$Uj=(0,L.$Ci)("contextKeyService");function X(M,b){return M<b?-1:M>b?1:0}function te(M,b,F,U){return M<F?-1:M>F?1:b<U?-1:b>U?1:0}function ne(M,b){if(M.type===h.False||b.type===h.True)return!0;if(M.type===h.Or)return b.type===h.Or?j(M.expr,b.expr):!1;if(b.type===h.Or){for(const F of b.expr)if(ne(M,F))return!0;return!1}if(M.type===h.And){if(b.type===h.And)return j(b.expr,M.expr);for(const F of M.expr)if(ne(F,b))return!0;return!1}return M.equals(b)}function j(M,b){let F=0,U=0;for(;F<M.length&&U<b.length;){const C=M[F].cmp(b[U]);if(C<0)return!1;C===0&&F++,U++}return F===M.length}function W(M){return M.type===h.Or?M.expr:[M]}}),define(le[61],ue([0,1,10]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=void 0,e.$Xo=(0,S.$Ci)("downloadService")}),define(le[17],ue([0,1,10]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=void 0,e.$Ji=(0,S.$Ci)("environmentService"),e.$Ki=(0,S.$Di)(e.$Ji)}),define(le[62],ue([0,1,13,7,5,9]),function(Y,e,S,P,$,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=L;async function L(f,c,h,p,y,R){let E;try{await k(f,c,h,p,y,R)}catch(d){E=d}finally{E&&y.errorTransformer&&(E=y.errorTransformer(E)),typeof E<"u"&&h.error(E),h.end()}}async function k(f,c,h,p,y,R){g(R);const E=await f.open(c,{create:!1});try{g(R);let d=0,m=0,A=y&&typeof y.length=="number"?y.length:void 0,w=S.$Le.alloc(Math.min(y.bufferSize,typeof A=="number"?A:y.bufferSize)),i=y&&typeof y.position=="number"?y.position:0,l=0;do m=await f.read(E,i,w.buffer,l,w.byteLength-l),i+=m,l+=m,d+=m,typeof A=="number"&&(A-=m),l===w.byteLength&&(await h.write(p(w)),w=S.$Le.alloc(Math.min(y.bufferSize,typeof A=="number"?A:y.bufferSize)),l=0);while(m>0&&(typeof A!="number"||A>0)&&g(R)&&a(d,y));if(l>0){let n=l;typeof A=="number"&&(n=Math.min(l,A)),h.write(p(w.slice(0,n)))}}catch(d){throw(0,I.$kl)(d)}finally{await f.close(E)}}function g(f){if(f.isCancellationRequested)throw(0,P.$5)();return!0}function a(f,c){if(typeof c?.limits?.size=="number"&&f>c.limits.size)throw(0,I.$jl)((0,$.localize)(11218,null),I.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[100],ue([0,1,32,2,52,4,9,11,8]),function(Y,e,S,P,$,I,L,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=void 0;class a extends P.$Tc{constructor(){super(),this.a=this.B(new I.$je),this.onDidChangeFile=this.a.event,this.b=this.B(new I.$je),this.onDidLogMessage=this.b.event,this.c=this.B(new I.$je),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new P.$3c),this.m=new Set,this.n=this.B(new g.$Ah(this.y())),this.r=5007,this.s=new g.$Zh,this.R=!1,this.B(this.f(c=>this.t(c)))}t(c){this.u(c)&&this.z(c)}u(c){return(0,$.$Zq)(c)}async watch(c){this.s.isSettled||this.s.complete(),this.s=new g.$Zh;try{this.h.clear(),this.g.clear();for(const h of c)this.u(h)?this.h.set(h.correlationId,h):this.g.add(h);for(const[h]of this.j)this.h.has(h)||(this.j.deleteAndDispose(h),this.m.delete(h));return await this.w(!1)}finally{this.s.complete()}}w(c){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(h=>!this.j.has(h.correlationId))]),c?this.y():0)}y(){return 800}isSuspended(c){return typeof c.correlationId!="number"?!1:this.m.has(c.correlationId)?"polling":this.j.has(c.correlationId)}async z(c){if(this.j.has(c.correlationId))return;const h=new P.$Sc;this.j.set(c.correlationId,h),await this.s.p,!h.isDisposed&&(this.D(c,h),this.w(!0))}C(c){this.j.deleteAndDispose(c.correlationId),this.m.delete(c.correlationId),this.w(!1)}D(c,h){this.F(c,h)?(this.P(`reusing an existing recursive watcher to monitor ${c.path}`),this.m.delete(c.correlationId)):(this.G(c,h),this.m.add(c.correlationId))}F(c,h){const p=this.O?.subscribe(c.path,(y,R)=>{h.isDisposed||(y?this.D(c,h):R?.type===L.FileChangeType.ADDED&&this.H(c))});return p?(h.add(p),!0):!1}G(c,h){let p=!1;const y=(R,E)=>{if(h.isDisposed)return;const d=this.I(R),m=this.I(E),A=p;p=d,!d&&(m||A)&&this.H(c)};this.P(`starting fs.watchFile() on ${c.path} (correlationId: ${c.correlationId})`);try{(0,S.watchFile)(c.path,{persistent:!1,interval:this.r},y)}catch(R){this.Q(`fs.watchFile() failed with error ${R} on path ${c.path} (correlationId: ${c.correlationId})`)}h.add((0,P.$Rc)(()=>{this.P(`stopping fs.watchFile() on ${c.path} (correlationId: ${c.correlationId})`);try{(0,S.unwatchFile)(c.path,y)}catch(R){this.Q(`fs.unwatchFile() failed with error ${R} on path ${c.path} (correlationId: ${c.correlationId})`)}}))}H(c){this.P(`detected ${c.path} exists again, resuming watcher (correlationId: ${c.correlationId})`);const h={resource:k.URI.file(c.path),type:L.FileChangeType.ADDED,cId:c.correlationId};this.a.fire([h]),this.J(h,c),this.C(c)}I(c){return c.ctimeMs===0&&c.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(c,h){if(this.R){const p=` >> normalized ${c.type===L.FileChangeType.ADDED?"[ADDED]":c.type===L.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`;this.L(p,h)}}L(c,h){this.R&&this.P(`${c}${typeof h.correlationId=="number"?` <${h.correlationId}> `:""}`)}M(c){return`${c.path} (excludes: ${c.excludes.length>0?c.excludes:"<none>"}, includes: ${c.includes&&c.includes.length>0?JSON.stringify(c.includes):"<all>"}, filter: ${(0,$.$0q)(c.filter)}, correlationId: ${typeof c.correlationId=="number"?c.correlationId:"<none>"})`}async setVerboseLogging(c){this.R=c}}e.$gr=a}),define(le[101],ue([0,1,4,148,100,12,149,63]),function(Y,e,S,P,$,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=void 0;class g extends $.$gr{constructor(f){super(),this.O=f,this.onDidError=S.Event.None,this.watchers=new Set}async N(f){f=this.Z(f);const c=[],h=new Set(Array.from(this.watchers));for(const p of f){const y=this.W(p);y&&(0,P.$Ak)(y.request.excludes,p.excludes)&&(0,P.$Ak)(y.request.includes,p.includes)?h.delete(y):c.push(p)}c.length&&this.P(`Request to start watching: ${c.map(p=>this.M(p)).join(",")}`),h.size&&this.P(`Request to stop watching: ${Array.from(h).map(p=>this.M(p.request)).join(",")}`);for(const p of h)this.Y(p);for(const p of c)this.X(p)}W(f){for(const c of this.watchers)if(typeof f.correlationId=="number"||typeof c.request.correlationId=="number"){if(c.request.correlationId===f.correlationId)return c}else if((0,k.$Ag)(c.request.path,f.path,!I.$l))return c}X(f){const c=new L.$lr(f,this.O,p=>this.a.fire(p),()=>this.c.fire(f),p=>this.b.fire(p),this.R),h={request:f,instance:c};this.watchers.add(h)}async stop(){await super.stop();for(const f of this.watchers)this.Y(f)}Y(f){this.P("stopping file watcher",f),this.watchers.delete(f),f.instance.dispose()}Z(f){const c=new Map;for(const h of f){const p=I.$l?h.path:h.path.toLowerCase();let y=c.get(h.correlationId);y||(y=new Map,c.set(h.correlationId,y)),y.has(p)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(h)}`),y.set(p,h)}return Array.from(c.values()).map(h=>Array.from(h.values())).flat()}async setVerboseLogging(f){super.setVerboseLogging(f);for(const c of this.watchers)c.instance.setVerboseLogging(f)}P(f,c){this.R&&this.b.fire({type:"trace",message:this.bb(f,c)})}Q(f){this.b.fire({type:"warn",message:this.bb(f)})}bb(f,c){return c?`[File Watcher (node.js)] ${f} (${this.M(c.request)})`:`[File Watcher (node.js)] ${f}`}}e.$nr=g}),define(le[102],ue([0,1,52,101]),function(Y,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;class $ extends S.$3q{constructor(L,k,g){super(L,k,g),this.s()}r(L){return L.add(new P.$nr(void 0))}}e.$or=$}),define(le[103],ue([0,1,14,59,86,52]),function(Y,e,S,P,$,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=void 0;class L extends I.$4q{constructor(g,a,f){super(g,a,f),this.s()}r(g){const a=g.add(new $.$er(S.$Wg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(a.onDidProcessExit(({code:f,signal:c})=>this.t(`terminated by itself with code ${f}, signal: ${c} (ETERM)`))),P.ProxyChannel.toService((0,P.$ji)(a.getChannel("watcher")))}}e.$fr=L}),define(le[64],ue([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=void 0;class S{constructor(...$){this.a=new Map;for(const[I,L]of $)this.set(I,L)}set($,I){const L=this.a.get($);return this.a.set($,I),L}has($){return this.a.has($)}get($){return this.a.get($)}}e.$Ai=S}),define(le[104],ue([0,1,8,7,2,51,98,10,64,150]),function(Y,e,S,P,$,I,L,k,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=e.$sr=void 0;const f=!1;class c extends Error{constructor(E){super("cyclic dependency between services"),this.message=E.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${E.toString()}`}}class h{constructor(E=new g.$Ai,d=!1,m,A=f){this.i=E,this.j=d,this.k=m,this.l=A,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(k.$Bi,this),this._globalGraph=A?m?._globalGraph??new L.$rr(w=>w):void 0}dispose(){if(!this.f){this.f=!0,(0,$.$Oc)(this.h),this.h.clear();for(const E of this.g)(0,$.$Nc)(E)&&E.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(E,d){this.m();const m=this,A=new class extends h{dispose(){m.h.delete(A),super.dispose()}}(E,this.j,this,this.l);return this.h.add(A),d?.add(A),A}invokeFunction(E,...d){this.m();const m=y.traceInvocation(this.l,E);let A=!1;try{return E({get:i=>{if(A)throw(0,P.$7)("service accessor is only valid during the invocation of its target method");const l=this.s(i,m);if(!l)throw new Error(`[invokeFunction] unknown service '${i}'`);return l}},...d)}finally{A=!0,m.stop()}}createInstance(E,...d){this.m();let m,A;return E instanceof I.$zi?(m=y.traceCreation(this.l,E.ctor),A=this.o(E.ctor,E.staticArguments.concat(d),m)):(m=y.traceCreation(this.l,E),A=this.o(E,d,m)),m.stop(),A}o(E,d=[],m){const A=k._util.getServiceDependencies(E).sort((l,n)=>l.index-n.index),w=[];for(const l of A){const n=this.s(l.id,m);n||this.y(`[createInstance] ${E.name} depends on UNKNOWN service ${l.id}.`,!1),w.push(n)}const i=A.length>0?A[0].index:d.length;if(d.length!==i){console.trace(`[createInstance] First service dependency of ${E.name} at position ${i+1} conflicts with ${d.length} static arguments`);const l=i-d.length;l>0?d=d.concat(new Array(l)):d=d.slice(0,i)}return Reflect.construct(E,d.concat(w))}q(E,d){if(this.i.get(E)instanceof I.$zi)this.i.set(E,d);else if(this.k)this.k.q(E,d);else throw new Error("illegalState - setting UNKNOWN service instance")}r(E){const d=this.i.get(E);return!d&&this.k?this.k.r(E):d}s(E,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(E));const m=this.r(E);return m instanceof I.$zi?this.u(E,m,d.branch(E,!0)):(d.branch(E,!1),m)}u(E,d,m){if(this.t.has(E))throw new Error(`illegal state - RECURSIVELY instantiating service '${E}'`);this.t.add(E);try{return this.v(E,d,m)}finally{this.t.delete(E)}}v(E,d,m){const A=new L.$rr(n=>n.id.toString());let w=0;const i=[{id:E,desc:d,_trace:m}],l=new Set;for(;i.length;){const n=i.pop();if(!l.has(String(n.id))){if(l.add(String(n.id)),A.lookupOrInsertNode(n),w++>1e3)throw new c(A);for(const r of k._util.getServiceDependencies(n.desc.ctor)){const t=this.r(r.id);if(t||this.y(`[createInstance] ${E} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),t instanceof I.$zi){const s={id:r.id,desc:t,_trace:n._trace.branch(r.id,!0)};A.insertEdge(n,s),i.push(s)}}}}for(;;){const n=A.roots();if(n.length===0){if(!A.isEmpty())throw new c(A);break}for(const{data:r}of n){if(this.r(r.id)instanceof I.$zi){const s=this.w(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.q(r.id,s)}A.removeNode(r)}}return this.r(E)}w(E,d,m=[],A,w){if(this.i.get(E)instanceof I.$zi)return this.x(E,d,m,A,w,this.g);if(this.k)return this.k.w(E,d,m,A,w);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}x(E,d,m=[],A,w,i){if(A){const l=new h(void 0,this.j,this,this.l);l.c=String(E);const n=new Map,r=new S.$Vh(()=>{const t=l.o(d,m,w);for(const[s,o]of n){const u=t[s];if(typeof u=="function")for(const v of o)v.disposable=u.apply(t,v.listener)}return n.clear(),i.add(t),t});return new Proxy(Object.create(null),{get(t,s){if(!r.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let v=n.get(s);return v||(v=new a.$4c,n.set(s,v)),(T,O,D)=>{if(r.isInitialized)return r.value[s](T,O,D);{const q={listener:[T,O,D],disposable:void 0},K=v.push(q);return(0,$.$Rc)(()=>{K(),q.disposable?.dispose()})}}}if(s in t)return t[s];const o=r.value;let u=o[s];return typeof u!="function"||(u=u.bind(o),t[s]=u),u},set(t,s,o){return r.value[s]=o,!0},getPrototypeOf(t){return d.prototype}})}else{const l=this.o(d,m,w);return i.add(l),l}}y(E,d){if(d&&console.warn(E),this.j)throw new Error(E)}}e.$sr=h;var p;(function(R){R[R.None=0]="None",R[R.Creation=1]="Creation",R[R.Invocation=2]="Invocation",R[R.Branch=3]="Branch"})(p||(p={}));class y{static{this.all=new Set}static{this.c=new class extends y{constructor(){super(p.None,null)}stop(){}branch(){return this}}}static traceInvocation(E,d){return E?new y(p.Invocation,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y.c}static traceCreation(E,d){return E?new y(p.Creation,d.name):y.c}static{this.f=0}constructor(E,d){this.type=E,this.name=d,this.g=Date.now(),this.h=[]}branch(E,d){const m=new y(p.Branch,E.toString());return this.h.push([E,d,m]),m}stop(){const E=Date.now()-this.g;y.f+=E;let d=!1;function m(w,i){const l=[],n=new Array(w+1).join("	");for(const[r,t,s]of i.h)if(t&&s){d=!0,l.push(`${n}CREATES -> ${r}`);const o=m(w+1,s);o&&l.push(o)}else l.push(`${n}uses -> ${r}`);return l.join(`
`)}const A=[`${this.type===p.Creation?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${E.toFixed(2)}ms (grand total ${y.f.toFixed(2)}ms)`];(E>2||d)&&y.all.add(A.join(`
`))}}e.$tr=y}),define(le[6],ue([0,1,5,38,4,43,2,30,12,16,3,11,99,10]),function(Y,e,S,P,$,I,L,k,g,a,f,c,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$_j=e.LogLevel=e.$0j=e.$9j=void 0,e.$$j=R,e.log=d,e.$kk=u,e.$lk=v,e.$mk=N,e.$nk=T,S=ye(S),e.$9j=(0,p.$Ci)("logService"),e.$0j=(0,p.$Ci)("loggerService");function y(){return new Date().toISOString()}function R(O){return(0,f.$gg)(O)}var E;(function(O){O[O.Off=0]="Off",O[O.Trace=1]="Trace",O[O.Debug=2]="Debug",O[O.Info=3]="Info",O[O.Warning=4]="Warning",O[O.Error=5]="Error"})(E||(e.LogLevel=E={})),e.$_j=E.Info;function d(O,D,q){switch(D){case E.Trace:O.trace(q);break;case E.Debug:O.debug(q);break;case E.Info:O.info(q);break;case E.Warning:O.warn(q);break;case E.Error:O.error(q);break;case E.Off:break;default:throw new Error(`Invalid log level ${D}`)}}function m(O,D=!1){let q="";for(let K=0;K<O.length;K++){let J=O[K];if(J instanceof Error&&(J=(0,P.$nj)(J,D)),typeof J=="object")try{J=JSON.stringify(J)}catch{}q+=(K>0?" ":"")+J}return q}class A extends L.$Tc{constructor(){super(...arguments),this.b=e.$_j,this.c=this.B(new $.$je),this.onDidChangeLogLevel=this.c.event}setLevel(D){this.b!==D&&(this.b=D,this.c.fire(this.b))}getLevel(){return this.b}f(D){return this.b!==E.Off&&this.b<=D}}e.$bk=A;class w extends A{constructor(D){super(),this.h=D}f(D){return this.h||super.f(D)}trace(D,...q){this.f(E.Trace)&&this.g(E.Trace,m([D,...q],!0))}debug(D,...q){this.f(E.Debug)&&this.g(E.Debug,m([D,...q]))}info(D,...q){this.f(E.Info)&&this.g(E.Info,m([D,...q]))}warn(D,...q){this.f(E.Warning)&&this.g(E.Warning,m([D,...q]))}error(D,...q){if(this.f(E.Error))if(D instanceof Error){const K=Array.prototype.slice.call(arguments);K[0]=D.stack,this.g(E.Error,m(K))}else this.g(E.Error,m([D,...q]))}flush(){}}e.$ck=w;class i extends A{constructor(D=e.$_j){super(),this.setLevel(D),this.g=!g.$j}trace(D,...q){this.f(E.Trace)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,D,...q):console.log(`[main ${y()}]`,D,...q))}debug(D,...q){this.f(E.Debug)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,D,...q):console.log(`[main ${y()}]`,D,...q))}info(D,...q){this.f(E.Info)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,D,...q):console.log(`[main ${y()}]`,D,...q))}warn(D,...q){this.f(E.Warning)&&(this.g?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,D,...q):console.warn(`[main ${y()}]`,D,...q))}error(D,...q){this.f(E.Error)&&(this.g?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,D,...q):console.error(`[main ${y()}]`,D,...q))}flush(){}}e.$dk=i;class l extends A{constructor(D=e.$_j,q=!0){super(),this.g=q,this.setLevel(D)}trace(D,...q){this.f(E.Trace)&&(this.g?console.log("%cTRACE","color: #888",D,...q):console.log(D,...q))}debug(D,...q){this.f(E.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",D,...q):console.log(D,...q))}info(D,...q){this.f(E.Info)&&(this.g?console.log("%c INFO","color: #33f",D,...q):console.log(D,...q))}warn(D,...q){this.f(E.Warning)&&(this.g?console.log("%c WARN","color: #993",D,...q):console.log(D,...q))}error(D,...q){this.f(E.Error)&&(this.g?console.log("%c  ERR","color: #f33",D,...q):console.error(D,...q))}flush(){}}e.$ek=l;class n extends A{constructor(D,q=e.$_j){super(),this.g=D,this.setLevel(q)}trace(D,...q){this.f(E.Trace)&&this.g.log(E.Trace,[this.h(D),...q])}debug(D,...q){this.f(E.Debug)&&this.g.log(E.Debug,[this.h(D),...q])}info(D,...q){this.f(E.Info)&&this.g.log(E.Info,[this.h(D),...q])}warn(D,...q){this.f(E.Warning)&&this.g.log(E.Warning,[this.h(D),...q])}error(D,...q){this.f(E.Error)&&this.g.log(E.Error,[this.h(D),...q])}h(D){return typeof D=="string"?D:(0,P.$nj)(D,this.f(E.Trace))}flush(){}}e.$fk=n;class r extends A{constructor(D){super(),this.g=D,D.length&&this.setLevel(D[0].getLevel())}setLevel(D){for(const q of this.g)q.setLevel(D);super.setLevel(D)}trace(D,...q){for(const K of this.g)K.trace(D,...q)}debug(D,...q){for(const K of this.g)K.debug(D,...q)}info(D,...q){for(const K of this.g)K.info(D,...q)}warn(D,...q){for(const K of this.g)K.warn(D,...q)}error(D,...q){for(const K of this.g)K.error(D,...q)}flush(){for(const D of this.g)D.flush()}dispose(){for(const D of this.g)D.dispose();super.dispose()}}e.$gk=r;class t extends L.$Tc{constructor(D,q,K){if(super(),this.h=D,this.j=q,this.b=new k.$zc,this.c=this.B(new $.$je),this.onDidChangeLoggers=this.c.event,this.f=this.B(new $.$je),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new $.$je),this.onDidChangeVisibility=this.g.event,K)for(const J of K)this.b.set(J.resource,{logger:void 0,info:J})}m(D){return(0,f.$cg)(D)?[...this.b.values()].find(q=>q.info.id===D):this.b.get(D)}getLogger(D){return this.m(D)?.logger}createLogger(D,q){const K=this.n(D),J=(0,f.$cg)(D)?D:q?.id??(0,I.$qj)(K.toString()).toString(16);let re=this.b.get(K)?.logger;const ae=q?.logLevel==="always"?E.Trace:q?.logLevel;re||(re=this.s(K,ae??this.getLogLevel(K)??this.h,{...q,id:J}));const ce={logger:re,info:{resource:K,id:J,logLevel:ae,name:q?.name,hidden:q?.hidden,extensionId:q?.extensionId,when:q?.when}};return this.registerLogger(ce.info),this.b.set(K,ce),re}n(D){return(0,f.$cg)(D)?(0,a.$dh)(this.j,`${D}.log`):D}setLogLevel(D,q){if(c.URI.isUri(D)){const K=D,J=q,re=this.b.get(K);re&&J!==re.info.logLevel&&(re.info.logLevel=J===this.h?void 0:J,re.logger?.setLevel(J),this.b.set(re.info.resource,re),this.f.fire([K,J]))}else{this.h=D;for(const[K,J]of this.b.entries())this.b.get(K)?.info.logLevel===void 0&&J.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(D,q){const K=this.m(D);K&&q!==!K.info.hidden&&(K.info.hidden=!q,this.b.set(K.info.resource,K),this.g.fire([K.info.resource,q]))}getLogLevel(D){let q;return D&&(q=this.b.get(D)?.info.logLevel),q??this.h}registerLogger(D){const q=this.b.get(D.resource);q?q.info.hidden!==D.hidden&&this.setVisibility(D.resource,!D.hidden):(this.b.set(D.resource,{info:D,logger:void 0}),this.c.fire({added:[D],removed:[]}))}deregisterLogger(D){const q=this.b.get(D);q&&(q.logger&&q.logger.dispose(),this.b.delete(D),this.c.fire({added:[],removed:[q.info]}))}*getRegisteredLoggers(){for(const D of this.b.values())yield D.info}getRegisteredLogger(D){return this.b.get(D)?.info}dispose(){this.b.forEach(D=>D.logger?.dispose()),this.b.clear(),super.dispose()}}e.$hk=t;class s{constructor(){this.onDidChangeLogLevel=new $.$je().event}setLevel(D){}getLevel(){return E.Info}trace(D,...q){}debug(D,...q){}info(D,...q){}warn(D,...q){}error(D,...q){}critical(D,...q){}dispose(){}flush(){}}e.$ik=s;class o extends s{}e.$jk=o;function u(O){if(O.verbose)return E.Trace;if(typeof O.logLevel=="string"){const D=T(O.logLevel.toLowerCase());if(D!==void 0)return D}return e.$_j}function v(O){switch(O){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}function N(O){switch(O){case E.Trace:return{original:"Trace",value:S.localize(11152,null)};case E.Debug:return{original:"Debug",value:S.localize(11153,null)};case E.Info:return{original:"Info",value:S.localize(11154,null)};case E.Warning:return{original:"Warning",value:S.localize(11155,null)};case E.Error:return{original:"Error",value:S.localize(11156,null)};case E.Off:return{original:"Off",value:S.localize(11157,null)}}}function T(O){switch(O){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}e.$ok=new h.$Tj("logLevel",v(E.Info))}),define(le[105],ue([0,1,19,8,7,4,63,2,15,52,6]),function(Y,e,S,P,$,I,L,k,g,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;class c extends k.$Tc{constructor(p,y){super(),this.a=p,this.b=y,this.c=this.B(new I.$je),this.onDidChangeFile=this.c.event,this.g=this.B(new I.$je),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new P.$Ah(0)),this.w=[],this.y=this.B(new P.$Ah(0))}watch(p,y){return y.recursive||this.b?.watcher?.forceUniversal?this.n(p,y):this.z(p,y)}n(p,y){const R={path:this.J(p),excludes:y.excludes,includes:y.includes,recursive:y.recursive,filter:y.filter,correlationId:y.correlationId},E=(0,S.$Sb)(this.j,R);return this.r(),(0,k.$Rc)(()=>{E(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(p=>(0,$.$Y)(p))}s(){this.h||(this.h=this.B(this.t(y=>this.c.fire((0,a.$5q)(y)),y=>this.G(y),this.a.getLevel()===f.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===f.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const y of this.j)(0,a.$1q)(y)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const y of this.j)(0,a.$1q)(y)&&p.includes(y.path)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(p,y){const R={path:this.J(p),excludes:y.excludes,includes:y.includes,recursive:!1,filter:y.filter,correlationId:y.correlationId},E=(0,S.$Sb)(this.w,R);return this.C(),(0,k.$Rc)(()=>{E(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(p=>(0,$.$Y)(p))}D(){return this.u||(this.u=this.B(this.F(p=>this.c.fire((0,a.$5q)(p)),p=>this.G(p),this.a.getLevel()===f.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===f.LogLevel.Trace)}))),this.u.watch(this.w)}G(p){p.type==="error"&&this.g.fire(p.message),this.H(p)}H(p){this.a[p.type](p.message)}I(p){return(0,g.$gc)(p.fsPath)}J(p){const y=this.I(p);return(0,L.$Eg)(y)}}e.$$q=c});var se=this&&this.__param||function(Y,e){return function(S,P){e(S,P,Y)}};define(le[106],ue([0,1,19,8,13,21,4,43,65,2,49,14,107,16,47,5,9,62,6,7]),function(Y,e,S,P,$,I,L,k,g,a,f,c,h,p,y,R,E,d,m,A){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=void 0;let i=class extends a.$Tc{static{w=this}constructor(n){super(),this.b=n,this.a=256*1024,this.c=this.B(new L.$je),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new L.$je),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new L.$je),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new L.$je),this.onDidRunOperation=this.r.event,this.X=this.B(new L.$je),this.Y=this.B(new L.$je),this.onDidFilesChange=this.Y.event,this.Z=this.B(new L.$je),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new P.$Lh)}registerProvider(n,r){if(this.h.has(n))throw new Error(`A filesystem provider for the scheme '${n}' is already registered.`);(0,h.mark)(`code/registerFilesystem/${n}`);const t=new a.$Sc;return this.h.set(n,r),this.c.fire({added:!0,scheme:n,provider:r}),t.add(r.onDidChangeFile(s=>{const o=new E.$pl(s,!this.S(r));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof r.onDidWatchError=="function"&&t.add(r.onDidWatchError(s=>this.Z.fire(new Error(s)))),t.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:n}))),(0,a.$Rc)(()=>{this.c.fire({added:!1,scheme:n,provider:r}),this.h.delete(n),(0,a.$Oc)(t)})}getProvider(n){return this.h.get(n)}async activateProvider(n){const r=[];this.f.fire({scheme:n,join(t){r.push(t)}}),!this.h.has(n)&&await P.Promises.settled(r)}async canHandleResource(n){return await this.activateProvider(n.scheme),this.hasProvider(n)}hasProvider(n){return this.h.has(n.scheme)}hasCapability(n,r){const t=this.h.get(n.scheme);return!!(t&&t.capabilities&r)}listCapabilities(){return g.Iterable.map(this.h,([n,r])=>({scheme:n,capabilities:r.capabilities}))}async j(n){if(!(0,p.$hh)(n))throw new E.$rl((0,R.localize)(11225,null,this.sb(n)),E.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(n.scheme);const r=this.h.get(n.scheme);if(!r){const t=new A.$ab;throw t.message=(0,R.localize)(11226,null,n.toString()),t}return r}async m(n){const r=await this.j(n);if((0,E.$cl)(r)||(0,E.$_k)(r)||(0,E.$dl)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(n){const r=await this.j(n);if((0,E.$cl)(r)||(0,E.$_k)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(n,r){try{return await this.s(n,r)}catch(t){throw(0,E.$ml)(t)===E.FileSystemProviderErrorCode.FileNotFound?new E.$rl((0,R.localize)(11227,null,this.sb(n)),E.FileOperationResult.FILE_NOT_FOUND):(0,E.$kl)(t)}}async s(n,r){const t=await this.j(n),s=this.S(t),o=r?.resolveTo,u=r?.resolveSingleChildDescendants,v=r?.resolveMetadata,N=await t.stat(n);let T;return this.t(t,n,N,void 0,!!v,(O,D)=>(T||(T=f.$Ii.forUris(()=>!s),T.set(n,!0),o&&T.fill(!0,o)),T.get(O.resource)||T.findSuperstr(O.resource.with({query:null,fragment:null}))?!0:O.isDirectory&&u?D===1:!1))}async t(n,r,t,s,o,u){const{providerExtUri:v}=this.R(n),N={resource:r,name:v.basename(r),isFile:(t.type&E.FileType.File)!==0,isDirectory:(t.type&E.FileType.Directory)!==0,isSymbolicLink:(t.type&E.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&E.FilePermission.Readonly)||!!(n.capabilities&E.FileSystemProviderCapabilities.Readonly),locked:!!((t.permissions??0)&E.FilePermission.Locked),etag:(0,E.$Cl)({mtime:t.mtime,size:t.size}),children:void 0};if(N.isDirectory&&u(N,s)){try{const T=await n.readdir(r),O=await P.Promises.settled(T.map(async([D,q])=>{try{const K=v.joinPath(r,D),J=o?await n.stat(K):{type:q};return await this.t(n,K,J,T.length,o,u)}catch(K){return this.b.trace(K),null}}));N.children=(0,S.$Gb)(O)}catch(T){this.b.trace(T),N.children=[]}return N}return N}async resolveAll(n){return P.Promises.settled(n.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(n){const r=await this.j(n),t=await r.stat(n);return this.t(r,n,t,void 0,!0,()=>!1)}async exists(n){const r=await this.j(n);try{return!!await r.stat(n)}catch{return!1}}async canCreateFile(n,r){try{await this.u(n,r)}catch(t){return t}return!0}async u(n,r){if(!r?.overwrite&&await this.exists(n))throw new E.$rl((0,R.localize)(11228,null,this.sb(n)),E.FileOperationResult.FILE_MODIFIED_SINCE,r)}async createFile(n,r=$.$Le.fromString(""),t){await this.u(n,t);const s=await this.writeFile(n,r);return this.r.fire(new E.$ol(n,E.FileOperation.CREATE,s)),s}async writeFile(n,r,t){const s=this.qb(await this.n(n),n),{providerExtUri:o}=this.R(s);let u=t;if((0,E.$fl)(s)&&!u?.atomic){const v=s.enforceAtomicWriteFile?.(n);v&&(u={...t,atomic:v})}try{await this.w(s,n,u)||await this.U(s,o.dirname(n));let N;if((0,E.$_k)(s)&&!(r instanceof $.$Le))if((0,y.$xe)(r)){const T=await(0,y.$Ee)(r,3);T.ended?N=$.$Le.concat(T.buffer):N=T}else N=(0,y.$Be)(r,T=>$.$Le.concat(T),3);else N=r;!(0,E.$cl)(s)||(0,E.$_k)(s)&&N instanceof $.$Le||(0,E.$_k)(s)&&(0,E.$fl)(s)&&u?.atomic?await this.hb(s,n,u,N):await this.db(s,n,u,N instanceof $.$Le?(0,$.$We)(N):N),this.r.fire(new E.$ol(n,E.FileOperation.WRITE))}catch(v){throw new E.$rl((0,R.localize)(11229,null,this.sb(n),(0,E.$kl)(v).toString()),(0,E.$nl)(v),u)}return this.resolve(n,{resolveMetadata:!0})}async w(n,r,t){const s=!!t?.unlock;if(s&&!(n.capabilities&E.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,R.localize)(11230,null,this.sb(r)));if(!!t?.atomic){if(!(n.capabilities&E.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,R.localize)(11231,null,this.sb(r)));if(!(n.capabilities&E.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,R.localize)(11232,null,this.sb(r)));if(s)throw new Error((0,R.localize)(11233,null,this.sb(r)))}let u;try{u=await n.stat(r)}catch{return}if(u.type&E.FileType.Directory)throw new E.$rl((0,R.localize)(11234,null,this.sb(r)),E.FileOperationResult.FILE_IS_DIRECTORY,t);if(this.rb(r,u),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==E.$Bl&&typeof u.mtime=="number"&&typeof u.size=="number"&&t.mtime<u.mtime&&t.etag!==(0,E.$Cl)({mtime:t.mtime,size:u.size}))throw new E.$rl((0,R.localize)(11235,null),E.FileOperationResult.FILE_MODIFIED_SINCE,t);return u}async readFile(n,r,t){const s=await this.m(n);return r?.atomic?this.z(s,n,r,t):this.C(s,n,r,t)}async z(n,r,t,s){return new Promise((o,u)=>{this.cb.queueFor(r,async()=>{try{const v=await this.C(n,r,t,s);o(v)}catch(v){u(v)}},this.R(n).providerExtUri)})}async C(n,r,t,s){const o=await this.D(n,r,{...t,preferUnbuffered:!0},s);return{...o,value:await(0,$.$Xe)(o.value)}}async readFileStream(n,r,t){const s=await this.m(n);return this.D(s,n,r,t)}async D(n,r,t,s){const o=new I.$ue(s);let u=t;(0,E.$el)(n)&&n.enforceAtomicReadFile?.(r)&&(u={...t,atomic:!0});const v=this.J(r,u).then(T=>T,T=>{throw o.dispose(!0),T});let N;try{return typeof u?.etag=="string"&&u.etag!==E.$Bl&&await v,u?.atomic&&(0,E.$el)(n)||!((0,E.$cl)(n)||(0,E.$dl)(n))||(0,E.$_k)(n)&&u?.preferUnbuffered?N=this.I(n,r,u):(0,E.$dl)(n)?N=this.G(n,r,o.token,u):N=this.H(n,r,o.token,u),N.on("end",()=>o.dispose()),N.on("error",()=>o.dispose()),{...await v,value:N}}catch(T){throw N&&await(0,y.$Ce)(N),this.F(T,r,u)}}F(n,r,t){const s=(0,R.localize)(11236,null,this.sb(r),(0,E.$kl)(n).toString());return n instanceof E.$tl?new E.$tl(s,n.stat,t):n instanceof E.$sl?new E.$sl(s,n.fileOperationResult,n.size,n.options):new E.$rl(s,(0,E.$nl)(n),t)}G(n,r,t,s=Object.create(null)){const o=n.readFileStream(r,s,t);return(0,y.$Ie)(o,{data:u=>u instanceof $.$Le?u:$.$Le.wrap(u),error:u=>this.F(u,r,s)},u=>$.$Le.concat(u))}H(n,r,t,s=Object.create(null)){const o=(0,$.$2e)();return(0,d.$Xq)(n,r,o,u=>u,{...s,bufferSize:this.a,errorTransformer:u=>this.F(u,r,s)},t),o}I(n,r,t){const s=(0,y.$ze)(o=>$.$Le.concat(o));return(async()=>{try{let o;t?.atomic&&(0,E.$el)(n)?o=await n.readFile(r,{atomic:!0}):o=await n.readFile(r),typeof t?.position=="number"&&(o=o.slice(t.position)),typeof t?.length=="number"&&(o=o.slice(0,t.length)),this.L(r,o.byteLength,t),s.end($.$Le.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async J(n,r){const t=await this.resolve(n,{resolveMetadata:!0});if(t.isDirectory)throw new E.$rl((0,R.localize)(11237,null,this.sb(n)),E.FileOperationResult.FILE_IS_DIRECTORY,r);if(typeof r?.etag=="string"&&r.etag!==E.$Bl&&r.etag===t.etag)throw new E.$tl((0,R.localize)(11238,null),t,r);return this.L(n,t.size,r),t}L(n,r,t){if(typeof t?.limits?.size=="number"&&r>t.limits.size)throw new E.$sl((0,R.localize)(11239,null,this.sb(n)),E.FileOperationResult.FILE_TOO_LARGE,r,t)}async canMove(n,r,t){return this.M(n,r,"move",t)}async canCopy(n,r,t){return this.M(n,r,"copy",t)}async M(n,r,t,s){if(n.toString()!==r.toString())try{const o=t==="move"?this.qb(await this.n(n),n):await this.m(n),u=this.qb(await this.n(r),r);await this.Q(o,n,u,r,t,s)}catch(o){return o}return!0}async move(n,r,t){const s=this.qb(await this.n(n),n),o=this.qb(await this.n(r),r),u=await this.N(s,n,o,r,"move",!!t),v=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new E.$ol(n,u==="move"?E.FileOperation.MOVE:E.FileOperation.COPY,v)),v}async copy(n,r,t){const s=await this.m(n),o=this.qb(await this.n(r),r),u=await this.N(s,n,o,r,"copy",!!t),v=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new E.$ol(n,u==="copy"?E.FileOperation.COPY:E.FileOperation.MOVE,v)),v}async N(n,r,t,s,o,u){if(r.toString()===s.toString())return o;const{exists:v,isSameResourceWithDifferentPathCase:N}=await this.Q(n,r,t,s,o,u);if(v&&!N&&u&&await this.del(s,{recursive:!0}),await this.U(t,this.R(t).providerExtUri.dirname(s)),o==="copy"){if(n===t&&(0,E.$al)(n))await n.copy(r,s,{overwrite:u});else{const T=await this.resolve(r);T.isDirectory?await this.P(n,T,t,s):await this.O(n,r,t,s)}return o}else return n===t?(await n.rename(r,s,{overwrite:u}),o):(await this.N(n,r,t,s,"copy",u),await this.del(r,{recursive:!0}),"copy")}async O(n,r,t,s){if((0,E.$cl)(n)&&(0,E.$cl)(t))return this.jb(n,r,t,s);if((0,E.$cl)(n)&&(0,E.$_k)(t))return this.pb(n,r,t,s);if((0,E.$_k)(n)&&(0,E.$cl)(t))return this.nb(n,r,t,s);if((0,E.$_k)(n)&&(0,E.$_k)(t))return this.lb(n,r,t,s)}async P(n,r,t,s){await t.mkdir(s),Array.isArray(r.children)&&await P.Promises.settled(r.children.map(async o=>{const u=this.R(t).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.P(n,await this.resolve(o.resource),t,u):this.O(n,o.resource,t,u)}))}async Q(n,r,t,s,o,u){let v=!1;if(n===t){const{providerExtUri:T,isPathCaseSensitive:O}=this.R(n);if(O||(v=T.isEqual(r,s)),v&&o==="copy")throw new Error((0,R.localize)(11240,null,this.sb(r),this.sb(s)));if(!v&&T.isEqualOrParent(s,r))throw new Error((0,R.localize)(11241,null,this.sb(r),this.sb(s)))}const N=await this.exists(s);if(N&&!v){if(!u)throw new E.$rl((0,R.localize)(11242,null,this.sb(r),this.sb(s)),E.FileOperationResult.FILE_MOVE_CONFLICT);if(n===t){const{providerExtUri:T}=this.R(n);if(T.isEqualOrParent(r,s))throw new Error((0,R.localize)(11243,null,this.sb(r),this.sb(s)))}}return{exists:N,isSameResourceWithDifferentPathCase:v}}R(n){const r=this.S(n);return{providerExtUri:r?p.$6g:p.$8g,isPathCaseSensitive:r}}S(n){return!!(n.capabilities&E.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(n){const r=this.qb(await this.j(n),n);await this.U(r,n);const t=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new E.$ol(n,E.FileOperation.CREATE,t)),t}async U(n,r){const t=[],{providerExtUri:s}=this.R(n);for(;!s.isEqual(r,s.dirname(r));)try{if(!((await n.stat(r)).type&E.FileType.Directory))throw new Error((0,R.localize)(11244,null,this.sb(r)));break}catch(o){if((0,E.$ml)(o)!==E.FileSystemProviderErrorCode.FileNotFound)throw o;t.push(s.basename(r)),r=s.dirname(r)}for(let o=t.length-1;o>=0;o--){r=s.joinPath(r,t[o]);try{await n.mkdir(r)}catch(u){if((0,E.$ml)(u)!==E.FileSystemProviderErrorCode.FileExists)throw u}}}async canDelete(n,r){try{await this.W(n,r)}catch(t){return t}return!0}async W(n,r){const t=this.qb(await this.j(n),n),s=!!r?.useTrash;if(s&&!(t.capabilities&E.FileSystemProviderCapabilities.Trash))throw new Error((0,R.localize)(11245,null,this.sb(n)));const o=r?.atomic;if(o&&!(t.capabilities&E.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,R.localize)(11246,null,this.sb(n)));if(s&&o)throw new Error((0,R.localize)(11247,null,this.sb(n)));let u;try{u=await t.stat(n)}catch{}if(u)this.rb(n,u);else throw new E.$rl((0,R.localize)(11248,null,this.sb(n)),E.FileOperationResult.FILE_NOT_FOUND);if(!!!r?.recursive){const N=await this.resolve(n);if(N.isDirectory&&Array.isArray(N.children)&&N.children.length>0)throw new Error((0,R.localize)(11249,null,this.sb(n)))}return t}async del(n,r){const t=await this.W(n,r);let s=r;if((0,E.$gl)(t)&&!s?.atomic){const N=t.enforceAtomicDelete?.(n);N&&(s={...r,atomic:N})}const o=!!s?.useTrash,u=!!s?.recursive,v=s?.atomic??!1;await t.delete(n,{recursive:u,useTrash:o,atomic:v}),this.r.fire(new E.$ol(n,E.FileOperation.DELETE))}async cloneFile(n,r){const t=await this.j(n),s=this.qb(await this.n(r),r);if(!(t===s&&this.R(t).providerExtUri.isEqual(n,r)))return t===s&&(0,E.$bl)(t)?t.cloneFile(n,r):(await this.U(s,this.R(s).providerExtUri.dirname(r)),t===s&&(0,E.$al)(t)?this.cb.queueFor(n,()=>t.copy(n,r,{overwrite:!0}),this.R(t).providerExtUri):this.cb.queueFor(n,()=>this.O(t,n,s,r),this.R(t).providerExtUri))}static{this.ab=0}createWatcher(n,r){return this.watch(n,{...r,correlationId:w.ab++})}watch(n,r={recursive:!1,excludes:[]}){const t=new a.$Sc;let s=!1,o=()=>{s=!0};t.add((0,a.$Rc)(()=>o())),(async()=>{try{const v=await this.bb(n,r);s?(0,a.$Oc)(v):o=()=>(0,a.$Oc)(v)}catch(v){this.b.error(v)}})();const u=r.correlationId;if(typeof u=="number"){const v=t.add(new L.$je);return t.add(this.X.event(T=>{T.correlates(u)&&v.fire(T)})),{onDidChange:v.event,dispose:()=>t.dispose()}}return t}async bb(n,r){const t=await this.j(n),s=(0,k.$qj)([this.R(t).providerExtUri.getComparisonKey(n),r]);let o=this.$.get(s);return o||(o={count:0,disposable:t.watch(n,r)},this.$.set(s,o)),o.count+=1,(0,a.$Rc)(()=>{o&&(o.count--,o.count===0&&((0,a.$Oc)(o.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,n]of this.$)(0,a.$Oc)(n.disposable);this.$.clear()}async db(n,r,t,s){return this.cb.queueFor(r,async()=>{const o=await n.open(r,{create:!0,unlock:t?.unlock??!1});try{(0,y.$xe)(s)||(0,y.$ye)(s)?await this.eb(n,o,s):await this.fb(n,o,s)}catch(u){throw(0,E.$kl)(u)}finally{await n.close(o)}},this.R(n).providerExtUri)}async eb(n,r,t){let s=0,o;if((0,y.$ye)(t)){if(t.buffer.length>0){const u=$.$Le.concat(t.buffer);await this.gb(n,r,u,u.byteLength,s,0),s+=u.byteLength}if(t.ended)return;o=t.stream}else o=t;return new Promise((u,v)=>{(0,y.$De)(o,{onData:async N=>{o.pause();try{await this.gb(n,r,N,N.byteLength,s,0)}catch(T){return v(T)}s+=N.byteLength,setTimeout(()=>o.resume())},onError:N=>v(N),onEnd:()=>u()})})}async fb(n,r,t){let s=0,o;for(;(o=t.read())!==null;)await this.gb(n,r,o,o.byteLength,s,0),s+=o.byteLength}async gb(n,r,t,s,o,u){let v=0;for(;v<s;){const N=await n.write(r,o+v,t.buffer,u+v,s-v);v+=N}}async hb(n,r,t,s){return this.cb.queueFor(r,()=>this.ib(n,r,t,s),this.R(n).providerExtUri)}async ib(n,r,t,s){let o;s instanceof $.$Le?o=s:(0,y.$xe)(s)?o=await(0,$.$Xe)(s):(0,y.$ye)(s)?o=await(0,$.$Ye)(s):o=(0,$.$Ve)(s),await n.writeFile(r,o.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async jb(n,r,t,s){return this.cb.queueFor(s,()=>this.kb(n,r,t,s),this.R(t).providerExtUri)}async kb(n,r,t,s){let o,u;try{o=await n.open(r,{create:!1}),u=await t.open(s,{create:!0,unlock:!1});const v=$.$Le.alloc(this.a);let N=0,T=0,O=0;do O=await n.read(o,N,v.buffer,T,v.byteLength-T),await this.gb(t,u,v,O,N,T),N+=O,T+=O,T===v.byteLength&&(T=0);while(O>0)}catch(v){throw(0,E.$kl)(v)}finally{await P.Promises.settled([typeof o=="number"?n.close(o):Promise.resolve(),typeof u=="number"?t.close(u):Promise.resolve()])}}async lb(n,r,t,s){return this.cb.queueFor(s,()=>this.mb(n,r,t,s),this.R(t).providerExtUri)}async mb(n,r,t,s){return t.writeFile(s,await n.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(n,r,t,s){return this.cb.queueFor(s,()=>this.ob(n,r,t,s),this.R(t).providerExtUri)}async ob(n,r,t,s){const o=await t.open(s,{create:!0,unlock:!1});try{const u=await n.readFile(r);await this.gb(t,o,$.$Le.wrap(u),u.byteLength,0,0)}catch(u){throw(0,E.$kl)(u)}finally{await t.close(o)}}async pb(n,r,t,s){const o=await(0,$.$Xe)(this.H(n,r,I.CancellationToken.None));await this.hb(t,s,void 0,o)}qb(n,r){if(n.capabilities&E.FileSystemProviderCapabilities.Readonly)throw new E.$rl((0,R.localize)(11250,null,this.sb(r)),E.FileOperationResult.FILE_PERMISSION_DENIED);return n}rb(n,r){if((r.permissions??0)&E.FilePermission.Readonly)throw new E.$rl((0,R.localize)(11251,null,this.sb(n)),E.FileOperationResult.FILE_PERMISSION_DENIED)}sb(n){return n.scheme===c.Schemas.file?n.fsPath:n.toString(!0)}};e.$Yq=i,e.$Yq=i=w=ve([se(0,m.$9j)],i)}),define(le[108],ue([0,1,32,8,30,13,4,63,2,15,12,16,47,28,5,9,62,105,103,102]),function(Y,e,S,P,$,I,L,k,g,a,f,c,h,p,y,R,E,d,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class w extends d.$$q{static{this.L=!1}constructor(l,n){super(l,n),this.onDidChangeCapabilities=L.Event.None,this.P=new $.$zc(r=>c.$7g.getComparisonKey(r)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=R.FileSystemProviderCapabilities.FileReadWrite|R.FileSystemProviderCapabilities.FileOpenReadWriteClose|R.FileSystemProviderCapabilities.FileReadStream|R.FileSystemProviderCapabilities.FileFolderCopy|R.FileSystemProviderCapabilities.FileWriteUnlock|R.FileSystemProviderCapabilities.FileAtomicRead|R.FileSystemProviderCapabilities.FileAtomicWrite|R.FileSystemProviderCapabilities.FileAtomicDelete|R.FileSystemProviderCapabilities.FileClone,f.$l&&(this.M|=R.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(l){try{const{stat:n,symbolicLink:r}=await p.SymlinkSupport.stat(this.I(l));return{type:this.O(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:R.FilePermission.Locked}}catch(n){throw this.hb(n)}}async N(l){try{return await this.stat(l)}catch{return}}async readdir(l){try{const n=await p.Promises.readdir(this.I(l),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async t=>{try{let s;t.isSymbolicLink()?s=(await this.stat((0,c.$dh)(l,t.name))).type:s=this.O(t),r.push([t.name,s])}catch(s){this.a.trace(s)}})),r}catch(n){throw this.hb(n)}}O(l,n){let r;return n?.dangling?r=R.FileType.Unknown:l.isFile()?r=R.FileType.File:l.isDirectory()?r=R.FileType.Directory:r=R.FileType.Unknown,n&&(r|=R.FileType.SymbolicLink),r}async Q(l){const n=this.I(l);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.P.get(l);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const t=new P.$Bh;return this.P.set(l,t),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,g.$Rc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.P.get(l)===t&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.P.delete(l)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),t.open()})}async readFile(l,n){let r;try{n?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(l)})`),r=await this.Q(l));const t=this.I(l);return await S.promises.readFile(t)}catch(t){throw this.hb(t)}finally{r?.dispose()}}R(l){w.L&&this.a.trace(l)}readFileStream(l,n,r){const t=(0,h.$ze)(s=>I.$Le.concat(s.map(o=>I.$Le.wrap(o))).buffer);return(0,E.$Xq)(this,l,t,s=>s.buffer,{...n,bufferSize:256*1024},r),t}async writeFile(l,n,r){return r?.atomic!==!1&&r?.atomic?.postfix&&await this.S(l)?this.U(l,(0,c.$dh)((0,c.$ch)(l),`${(0,c.$ah)(l)}${r.atomic.postfix}`),n,r):this.W(l,n,r)}async S(l){try{const n=this.I(l),{symbolicLink:r}=await p.SymlinkSupport.stat(n);if(r)return!1}catch{}return!0}async U(l,n,r,t){const s=new g.$Sc;try{s.add(await this.Q(l)),s.add(await this.Q(n)),await this.W(n,r,t,!0);try{await this.rename(n,l,{overwrite:!0})}catch(o){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw o}}finally{s.dispose()}}async W(l,n,r,t){let s;try{const o=this.I(l);if(!r.create||!r.overwrite){if(await p.Promises.exists(o)){if(!r.overwrite)throw(0,R.$jl)((0,y.localize)(11209,null),R.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,R.$jl)((0,y.localize)(11210,null),R.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(l,{create:!0,unlock:r.unlock},t),await this.write(s,0,n,0,n.byteLength)}catch(o){throw await this.ib(l,o)}finally{typeof s=="number"&&await this.close(s)}}static{this.$=!0}static configureFlushOnWrite(l){w.$=l}async open(l,n,r){const t=this.I(l);let s;(0,R.$0k)(n)&&!r&&(s=await this.Q(l));let o;try{if((0,R.$0k)(n)&&n.unlock)try{const{stat:v}=await p.SymlinkSupport.stat(t);v.mode&128||await S.promises.chmod(t,v.mode|128)}catch(v){v.code!=="ENOENT"&&this.a.trace(v)}let u;if((0,R.$0k)(n)){if(f.$j)try{await S.promises.truncate(t,0),u="r+"}catch(v){v.code!=="ENOENT"&&this.a.trace(v)}u||(u="w")}else u="r";o=await p.Promises.open(t,u)}catch(u){throw s?.dispose(),(0,R.$0k)(n)?await this.ib(l,u):this.hb(u)}if(this.X.set(o,0),(0,R.$0k)(n)&&this.Z.set(o,l),s){const u=this.Y.get(o);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${t})`),this.Y.set(o,s),u&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${t})`),u.dispose())}return o}async close(l){const n=this.Y.get(l);try{if(this.X.delete(l),this.Z.delete(l)&&w.$)try{await p.Promises.fdatasync(l)}catch(r){w.configureFlushOnWrite(!1),this.a.error(r)}return await p.Promises.close(l)}catch(r){throw this.hb(r)}finally{n&&(this.Y.get(l)===n&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${l}`),this.Y.delete(l)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${l}`),n.dispose())}}async read(l,n,r,t,s){const o=this.ab(l,n);let u=null;try{u=(await p.Promises.read(l,r,t,s,o)).bytesRead}catch(v){throw this.hb(v)}finally{this.bb(l,o,u)}return u}ab(l,n){return n===this.X.get(l)?null:n}bb(l,n,r){const t=this.X.get(l);typeof t=="number"&&(typeof n=="number"||(typeof r=="number"?this.X.set(l,t+r):this.X.delete(l)))}async write(l,n,r,t,s){return(0,P.$Wh)(()=>this.cb(l,n,r,t,s),100,3)}async cb(l,n,r,t,s){const o=this.ab(l,n);let u=null;try{u=(await p.Promises.write(l,r,t,s,o)).bytesWritten}catch(v){throw await this.ib(this.Z.get(l),v)}finally{this.bb(l,o,u)}return u}async mkdir(l){try{await S.promises.mkdir(this.I(l))}catch(n){throw this.hb(n)}}async delete(l,n){try{const r=this.I(l);if(n.recursive){let t;n?.atomic!==!1&&n.atomic.postfix&&(t=(0,a.$ic)((0,a.$lc)(r),`${(0,a.$mc)(r)}${n.atomic.postfix}`)),await p.Promises.rm(r,p.RimRafMode.MOVE,t)}else try{await S.promises.unlink(r)}catch(t){if(t.code==="EPERM"||t.code==="EISDIR"){let s=!1;try{const{stat:o,symbolicLink:u}=await p.SymlinkSupport.stat(r);s=o.isDirectory()&&!u}catch{}if(s)await S.promises.rmdir(r);else throw t}else throw t}}catch(r){throw this.hb(r)}}async rename(l,n,r){const t=this.I(l),s=this.I(n);if(t!==s)try{await this.db(l,n,"move",r.overwrite),await p.Promises.rename(t,s)}catch(o){throw(o.code==="EINVAL"||o.code==="EBUSY"||o.code==="ENAMETOOLONG")&&(o=new Error((0,y.localize)(11211,null,(0,a.$mc)(t),(0,a.$mc)((0,a.$lc)(s)),o.toString()))),this.hb(o)}}async copy(l,n,r){const t=this.I(l),s=this.I(n);if(t!==s)try{await this.db(l,n,"copy",r.overwrite),await p.Promises.copy(t,s,{preserveSymlinks:!0})}catch(o){throw(o.code==="EINVAL"||o.code==="EBUSY"||o.code==="ENAMETOOLONG")&&(o=new Error((0,y.localize)(11212,null,(0,a.$mc)(t),(0,a.$mc)((0,a.$lc)(s)),o.toString()))),this.hb(o)}}async db(l,n,r,t){const s=this.I(l),o=this.I(n);let u=!1;if(!!(this.capabilities&R.FileSystemProviderCapabilities.PathCaseSensitive)||(u=(0,k.$Ag)(s,o,!0)),u){if(r==="copy")throw(0,R.$jl)((0,y.localize)(11213,null),R.FileSystemProviderErrorCode.FileExists);if(r==="move")return}const N=await this.N(l);if(!N)throw(0,R.$jl)((0,y.localize)(11214,null),R.FileSystemProviderErrorCode.FileNotFound);const T=await this.N(n);if(T){if(!t)throw(0,R.$jl)((0,y.localize)(11215,null),R.FileSystemProviderErrorCode.FileExists);N.type&R.FileType.File&&T.type&R.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(l,n){return this.eb(l,n,!1)}async eb(l,n,r){const t=this.I(l),s=this.I(n),o=!!(this.capabilities&R.FileSystemProviderCapabilities.PathCaseSensitive);if((0,k.$Ag)(t,s,!o))return;const u=new g.$Sc;try{u.add(await this.Q(l)),u.add(await this.Q(n)),r&&await S.promises.mkdir((0,a.$lc)(s),{recursive:!0}),await S.promises.copyFile(t,s)}catch(v){if(v.code==="ENOENT"&&!r)return this.eb(l,n,!0);throw this.hb(v)}finally{u.dispose()}}t(l,n,r){return new m.$fr(t=>l(t),t=>n(t),r)}F(l,n,r){return new A.$or(t=>l(t),t=>n(t),r)}hb(l){if(l instanceof R.$il)return l;let n=l,r;switch(l.code){case"ENOENT":r=R.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=R.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=R.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=R.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=R.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${l.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,r=R.FileSystemProviderErrorCode.Unknown;break;default:r=R.FileSystemProviderErrorCode.Unknown}return(0,R.$jl)(n,r)}async ib(l,n){let r=this.hb(n);if(l&&r.code===R.FileSystemProviderErrorCode.NoPermissions)try{const{stat:t}=await p.SymlinkSupport.stat(this.I(l));t.mode&128||(r=(0,R.$jl)(n,R.FileSystemProviderErrorCode.FileWriteLocked))}catch(t){this.a.trace(t)}return r}}e.$pr=w}),define(le[109],ue([0,1,2,6]),function(Y,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oR=void 0;class $ extends S.$Tc{constructor(L,k=[]){super(),this.a=new P.$gk([L,...k]),this.B(L.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...k){this.a.trace(L,...k)}debug(L,...k){this.a.debug(L,...k)}info(L,...k){this.a.info(L,...k)}warn(L,...k){this.a.warn(L,...k)}error(L,...k){this.a.error(L,...k)}flush(){this.a.flush()}}e.$oR=$}),define(le[110],ue([0,1,9,6]),function(Y,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dR=void 0;var $;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})($||($={}));async function I(a,f,c,h,p){try{const y=await new Promise((E,d)=>{Y(["@vscode/spdlog"],E,d)}).then(ye);y.setFlushOn($.Trace);const R=await y.createAsyncRotatingLogger(a,f,c,h);return p?R.clearFormatters():R.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),R}catch(y){console.error(y)}return null}function L(a,f,c){switch(f){case P.LogLevel.Trace:a.trace(c);break;case P.LogLevel.Debug:a.debug(c);break;case P.LogLevel.Info:a.info(c);break;case P.LogLevel.Warning:a.warn(c);break;case P.LogLevel.Error:a.error(c);break;case P.LogLevel.Off:break;default:throw new Error(`Invalid log level ${f}`)}}function k(a,f){switch(f){case P.LogLevel.Trace:a.setLevel($.Trace);break;case P.LogLevel.Debug:a.setLevel($.Debug);break;case P.LogLevel.Info:a.setLevel($.Info);break;case P.LogLevel.Warning:a.setLevel($.Warning);break;case P.LogLevel.Error:a.setLevel($.Error);break;case P.LogLevel.Off:a.setLevel($.Off);break;default:throw new Error(`Invalid log level ${f}`)}}class g extends P.$ck{constructor(f,c,h,p,y){super(),this.m=[],this.setLevel(y),this.n=this.s(f,c,h,p),this.B(this.onDidChangeLogLevel(R=>{this.r&&k(this.r,R)}))}async s(f,c,h,p){const y=h?6:1,R=30/y*S.$El.MB,E=await I(f,c,R,y,p);if(E){this.r=E,k(this.r,this.getLevel());for(const{level:d,message:m}of this.m)L(this.r,d,m);this.m=[]}}g(f,c){this.r?L(this.r,f,c):this.getLevel()<=f&&this.m.push({level:f,message:c})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$dR=g}),define(le[111],ue([0,1,27,6,110]),function(Y,e,S,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eR=void 0;class I extends P.$hk{s(k,g,a){return new $.$dR((0,S.$Yg)(),k.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,g)}}e.$eR=I}),define(le[39],ue([0,1,4,65,2,10]),function(Y,e,S,P,$,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=e.$qo=e.$po=void 0,e.$po=(0,I.$Ci)("policy");class L extends $.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new S.$je),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const f=Object.keys(this.f).length;return this.f={...a,...this.f},f!==Object.keys(this.f).length&&await this.j(a),P.Iterable.reduce(this.g.entries(),(c,[h,p])=>({...c,[h]:p}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return P.Iterable.reduce(Object.entries(this.f),(a,[f,c])=>({...a,[f]:{definition:c,value:this.g.get(f)}}),{})}}e.$qo=L;class k{constructor(){this.onDidChange=S.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$ro=k}),define(le[112],ue([0,1,8,4,65,3,9,6,39]),function(Y,e,S,P,$,I,L,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=void 0;function a(c,h){const p=[];for(const y of new Set($.Iterable.concat(c.keys(),h.keys())))c.get(y)!==h.get(y)&&p.push(y);return p}let f=class extends g.$qo{constructor(h,p,y){super(),this.m=h,this.n=p,this.s=y,this.c=this.B(new S.$Ah(500));const R=P.Event.filter(p.onDidFilesChange,E=>E.affects(h));this.B(p.watch(h)),this.B(R(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const h=new Map;try{const p=await this.n.readFile(this.m),y=JSON.parse(p.value.toString());if(!(0,I.$eg)(y))throw new Error("Policy file isn't a JSON object");for(const R of Object.keys(y))this.f[R]&&h.set(R,y[R])}catch(p){p.fileOperationResult!==L.FileOperationResult.FILE_NOT_FOUND&&this.s.error("[FilePolicyService] Failed to read policies",p)}return h}async w(){const h=await this.u(),p=a(this.g,h);this.g=h,p.length>0&&this.h.fire(p)}};e.$Wgc=f,e.$Wgc=f=ve([se(1,L.$9k),se(2,k.$9j)],f)}),define(le[113],ue([0,1,39,8,2,6]),function(Y,e,S,P,$,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=void 0;let L=class extends S.$qo{constructor(g,a){super(),this.m=g,this.n=a,this.a=new P.$wh,this.b=this.B(new $.$Uc)}async j(g){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(g).length} policy definitions`);const{createWatcher:a}=await new Promise((f,c)=>{Y(["@vscode/policy-watcher"],f,c)}).then(ye);await this.a.queue(()=>new Promise((f,c)=>{try{this.b.value=a(this.n,g,h=>{this.t(h),f()})}catch(h){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",h),c(h)}}))}t(g){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(g)}`);for(const a in g){const f=g[a];f===void 0?this.g.delete(a):this.g.set(a,f)}this.h.fire(Object.keys(g))}};e.$Vgc=L,e.$Vgc=L=ve([se(0,I.$9j)],L)}),define(le[33],ue([0,1,10]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qk=e.$pk=void 0,e.$pk=(0,S.$Ci)("productService"),e.$qk="vscode://schemas/vscode-product"}),define(le[37],ue([0,1,75,3]),function(Y,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=void 0,S=ye(S),P=ye(P);class ${constructor(){this.a=new Map}add(L,k){S.ok(P.$cg(L)),S.ok(P.$eg(k)),S.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,k)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.$no=new $}),define(le[114],ue([0,1,4,37]),function(Y,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=void 0,P=ye(P),e.$oo={JSONContribution:"base.contributions.json"};function $(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class I{constructor(){this.b=new S.$je,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,a){this.a[$(g)]=a,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const L=new I;P.$no.add(e.$oo.JSONContribution,L)}),define(le[40],ue([0,1,19,4,3,5,29,114,37]),function(Y,e,S,P,$,I,L,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.ConfigurationScope=e.$so=e.EditPresentationTypes=void 0,e.$Do=R,e.$Eo=E,e.$Fo=d,e.$Go=A,e.$Ho=w,e.$Io=i,e.$Jo=l,$=ye($),I=ye(I);var a;(function(n){n.Multiline="multilineText",n.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$so={Configuration:"base.contributions.configuration"};var f;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.MACHINE=2]="MACHINE",n[n.WINDOW=3]="WINDOW",n[n.RESOURCE=4]="RESOURCE",n[n.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",n[n.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(f||(e.ConfigurationScope=f={})),e.$to={properties:{},patternProperties:{}},e.$uo={properties:{},patternProperties:{}},e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo="vscode://schemas/settings/resourceLanguage",e.$Ao="vscode://schemas/settings/configurationDefaults";const c=g.$no.as(k.$oo.JSONContribution);class h{constructor(){this.h=new Set,this.i=new P.$je,this.onDidSchemaChange=this.i.event,this.j=new P.$je,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:I.localize(11444,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},c.registerSchema(e.$zo,this.g),this.v()}registerConfiguration(r,t=!0){this.registerConfigurations([r],t)}registerConfigurations(r,t=!0){const s=new Set;this.n(r,t,s),c.registerSchema(e.$zo,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(r){const t=new Set;this.o(r,t),c.registerSchema(e.$zo,this.g),this.i.fire(),this.j.fire({properties:t})}updateConfigurations({add:r,remove:t}){const s=new Set;this.o(t,s),this.n(r,!1,s),c.registerSchema(e.$zo,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(r){const t=new Set;this.k(r,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:!0})}k(r,t){const s=[];for(const{overrides:o,source:u}of r)for(const v in o)if(t.add(v),e.$Co.test(v)){const N=this.a.get(v),T=N?.valuesSources??new Map,O=N?.value||{};for(const K of Object.keys(o[v])){const J=o[v][K];if($.$eg(J)&&($.$jg(O[K])||$.$eg(O[K]))){if(O[K]={...O[K]??{},...J},u){let ae=T.get(K);if(ae||(ae=new Map,T.set(K,ae)),!(ae instanceof Map)){console.error("objectConfigurationSources is not a Map");continue}for(const ce in J)ae.set(ce,u)}}else O[K]=J,u&&T.set(K,u)}this.a.set(v,{source:u,value:O,valuesSources:T});const D=(0,L.$gj)(v),q={type:"object",default:O,description:I.localize(11445,null,D),$ref:e.$zo,defaultDefaultValue:O,source:$.$cg(u)?void 0:u,defaultValueSource:u};s.push(...R(v)),this.d[v]=q,this.b.properties[v]=q}else{const N=this.d[v],T=this.a.get(v);let O=T?.value??N?.defaultDefaultValue,D=o[v],q=u;if($.$eg(D)&&(N!==void 0&&N.type==="object"||N===void 0&&($.$jg(O)||$.$eg(O)))){if($.$eg(O)||(O={}),D={...O,...D},q=T?.source??new Map,!(q instanceof Map)){console.error("defaultValueSource is not a Map");continue}for(const J in o[v])u?q.set(J,u):q.delete(J)}this.a.set(v,{value:D,source:q}),N&&(this.w(v,N),this.r(v,N))}this.m(s)}deregisterDefaultConfigurations(r){const t=new Set;this.l(r,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:!0})}l(r,t){for(const{overrides:s,source:o}of r)for(const u in s){const v=$.$cg(o)?o:o?.id,N=this.a.get(u);if(N){if(e.$Co.test(u)){for(const O of Object.keys(s[u])){const D=s[u][O];if($.$eg(D)){const q=N.valuesSources?.get(O);for(const K of Object.keys(D)){const J=q?.get(K);($.$cg(J)?J:J?.id)===v&&(q?.delete(K),delete N.value[O][K])}Object.keys(N.value[O]).length===0&&(delete N.value[O],N.valuesSources?.delete(O))}else{const q=N.valuesSources?.get(O);($.$cg(q)?q:q?.id)===v&&(N.valuesSources?.delete(O),delete N.value[O])}}const T=this.a.get(u);T&&Object.keys(T.value).length===0&&(this.a.delete(u),delete this.d[u],delete this.b.properties[u])}else{if(N.source instanceof Map){const O=N.source;for(const D in s[u]){const q=O.get(D);($.$cg(q)?q:q?.id)===v&&(O.delete(D),delete N.value[D])}O.size===0&&this.a.delete(u)}else{const O=$.$cg(N.source)?N.source:N.source?.id;if(v!==O)continue;this.a.delete(u)}const T=this.d[u];T&&(this.w(u,T),this.r(u,T))}t.add(u)}}this.u()}deltaConfiguration(r){let t=!1;const s=new Set;r.removedDefaults&&(this.l(r.removedDefaults,s),t=!0),r.addedDefaults&&(this.k(r.addedDefaults,s),t=!0),r.removedConfigurations&&this.o(r.removedConfigurations,s),r.addedConfigurations&&this.n(r.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:t})}notifyConfigurationSchemaUpdated(...r){this.i.fire()}registerOverrideIdentifiers(r){this.m(r),this.i.fire()}m(r){for(const t of r)this.h.add(t);this.u()}n(r,t,s){r.forEach(o=>{this.p(o,t,o.extensionInfo,o.restrictedProperties,void 0,s),this.c.push(o),this.q(o)})}o(r,t){const s=o=>{if(o.properties)for(const u in o.properties){t.add(u);const v=this.d[u];v?.policy?.name&&this.e.delete(v.policy.name),delete this.d[u],this.s(u,o.properties[u])}o.allOf?.forEach(u=>s(u))};for(const o of r){s(o);const u=this.c.indexOf(o);u!==-1&&this.c.splice(u,1)}}p(r,t=!0,s,o,u=f.WINDOW,v){u=$.$lg(r.scope)?u:r.scope;const N=r.properties;if(N)for(const O in N){const D=N[O];if(t&&A(O,D)){delete N[O];continue}if(D.source=s,D.defaultDefaultValue=N[O].default,this.w(O,D),e.$Co.test(O)?D.scope=void 0:(D.scope=$.$lg(D.scope)?u:D.scope,D.restricted=$.$lg(D.restricted)?!!o?.includes(O):D.restricted),N[O].hasOwnProperty("included")&&!N[O].included){this.f[O]=N[O],delete N[O];continue}else this.d[O]=N[O],N[O].policy?.name&&this.e.set(N[O].policy.name,O);!N[O].deprecationMessage&&N[O].markdownDeprecationMessage&&(N[O].deprecationMessage=N[O].markdownDeprecationMessage),v.add(O)}const T=r.allOf;if(T)for(const O of T)this.p(O,t,s,o,u,v)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(r){const t=s=>{const o=s.properties;if(o)for(const v in o)this.r(v,o[v]);s.allOf?.forEach(t)};t(r)}r(r,t){switch(e.$to.properties[r]=t,t.scope){case f.APPLICATION:e.$uo.properties[r]=t;break;case f.MACHINE:e.$vo.properties[r]=t;break;case f.MACHINE_OVERRIDABLE:e.$wo.properties[r]=t;break;case f.WINDOW:e.$xo.properties[r]=t;break;case f.RESOURCE:e.$yo.properties[r]=t;break;case f.LANGUAGE_OVERRIDABLE:e.$yo.properties[r]=t,this.g.properties[r]=t;break}}s(r,t){switch(delete e.$to.properties[r],t.scope){case f.APPLICATION:delete e.$uo.properties[r];break;case f.MACHINE:delete e.$vo.properties[r];break;case f.MACHINE_OVERRIDABLE:delete e.$wo.properties[r];break;case f.WINDOW:delete e.$xo.properties[r];break;case f.RESOURCE:case f.LANGUAGE_OVERRIDABLE:delete e.$yo.properties[r],delete this.g.properties[r];break}}u(){for(const r of this.h.values()){const t=`[${r}]`,s={type:"object",description:I.localize(11446,null),errorMessage:I.localize(11447,null),$ref:e.$zo};this.w(t,s),e.$to.properties[t]=s,e.$uo.properties[t]=s,e.$vo.properties[t]=s,e.$wo.properties[t]=s,e.$xo.properties[t]=s,e.$yo.properties[t]=s}}v(){const r={type:"object",description:I.localize(11448,null),errorMessage:I.localize(11449,null),$ref:e.$zo};e.$to.patternProperties[e.$Bo]=r,e.$uo.patternProperties[e.$Bo]=r,e.$vo.patternProperties[e.$Bo]=r,e.$wo.patternProperties[e.$Bo]=r,e.$xo.patternProperties[e.$Bo]=r,e.$yo.patternProperties[e.$Bo]=r,this.i.fire()}w(r,t){const s=this.a.get(r);let o=s?.value,u=s?.source;$.$jg(o)&&(o=t.defaultDefaultValue,u=void 0),$.$jg(o)&&(o=d(t.type)),t.default=o,t.defaultValueSource=u}}const p="\\[([^\\]]+)\\]",y=new RegExp(p,"g");e.$Bo=`^(${p})+$`,e.$Co=new RegExp(e.$Bo);function R(n){const r=[];if(e.$Co.test(n)){let t=y.exec(n);for(;t?.length;){const s=t[1].trim();s&&r.push(s),t=y.exec(n)}}return(0,S.$Lb)(r)}function E(n){return n.reduce((r,t)=>`${r}[${t}]`,"")}function d(n){switch(Array.isArray(n)?n[0]:n){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const m=new h;g.$no.add(e.$so.Configuration,m);function A(n,r){return n.trim()?e.$Co.test(n)?I.localize(11451,null,n):m.getConfigurationProperties()[n]!==void 0?I.localize(11452,null,n):r.policy?.name&&m.getPolicyConfigurations().get(r.policy?.name)!==void 0?I.localize(11453,null,n,r.policy?.name,m.getPolicyConfigurations().get(r.policy?.name)):null:I.localize(11450,null)}function w(){const n=[],r=m.getConfigurationProperties();for(const t of Object.keys(r))n.push([t,r[t].scope]);return n.push(["launch",f.RESOURCE]),n.push(["task",f.RESOURCE]),n}function i(n){const r={};for(const t of n){const s=t.properties;if($.$eg(s))for(const o in s)r[o]=s[o];t.allOf&&Object.assign(r,i(t.allOf))}return r}function l(n){switch(n){case"application":return f.APPLICATION;case"machine":return f.MACHINE;case"resource":return f.RESOURCE;case"machine-overridable":return f.MACHINE_OVERRIDABLE;case"language-overridable":return f.LANGUAGE_OVERRIDABLE;default:return f.WINDOW}}}),define(le[66],ue([0,1,19,4,34,2,30,26,3,11,29,40,9,37]),function(Y,e,S,P,$,I,L,k,g,a,f,c,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$No=e.$Mo=e.$Lo=e.$Ko=void 0,e.$Oo=w,S=ye(S),$=ye($),k=ye(k),g=ye(g);function y(r){return Object.isFrozen(r)?r:k.$bo(r)}class R{static createEmptyModel(t){return new R({},[],[],void 0,t)}constructor(t,s,o,u,v){this.b=t,this.c=s,this.d=o,this.raw=u,this.f=v,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const t=this.raw.map(s=>{if(s instanceof R)return s;const o=new E("",this.f);return o.parseRaw(s),o.configurationModel});this.g=t.reduce((s,o)=>o===s?o:s.merge(o),t[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,f.$ej)(this.contents,t):this.contents}inspect(t,s){const o=this;return{get value(){return y(o.rawConfiguration.getValue(t))},get override(){return s?y(o.rawConfiguration.getOverrideValue(t,s)):void 0},get merged(){return y(s?o.rawConfiguration.override(s).getValue(t):o.rawConfiguration.getValue(t))},get overrides(){const u=[];for(const{contents:v,identifiers:N,keys:T}of o.rawConfiguration.overrides){const O=new R(v,T,[],void 0,o.f).getValue(t);O!==void 0&&u.push({identifiers:N,value:O})}return u.length?y(u):void 0}}}getOverrideValue(t,s){const o=this.j(s);return o?t?(0,f.$ej)(o,t):o:void 0}getKeysForOverrideIdentifier(t){const s=[];for(const o of this.overrides)o.identifiers.includes(t)&&s.push(...o.keys);return S.$Lb(s)}getAllOverrideIdentifiers(){const t=[];for(const s of this.overrides)t.push(...s.identifiers);return S.$Lb(t)}override(t){let s=this.a.get(t);return s||(s=this.h(t),this.a.set(t,s)),s}merge(...t){const s=k.$ao(this.contents),o=k.$ao(this.overrides),u=[...this.keys],v=this.raw?.length?[...this.raw]:[this];for(const N of t)if(v.push(...N.raw?.length?N.raw:[N]),!N.isEmpty()){this.i(s,N.contents);for(const T of N.overrides){const[O]=o.filter(D=>S.$tb(D.identifiers,T.identifiers));O?(this.i(O.contents,T.contents),O.keys.push(...T.keys),O.keys=S.$Lb(O.keys)):o.push(k.$ao(T))}for(const T of N.keys)u.indexOf(T)===-1&&u.push(T)}return new R(s,u,o,v.every(N=>N instanceof R)?void 0:v,this.f)}h(t){const s=this.j(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const o={};for(const u of S.$Lb([...Object.keys(this.contents),...Object.keys(s)])){let v=this.contents[u];const N=s[u];N&&(typeof v=="object"&&typeof N=="object"?(v=k.$ao(v),this.i(v,N)):v=N),o[u]=v}return new R(o,this.keys,this.overrides,void 0,this.f)}i(t,s){for(const o of Object.keys(s)){if(o in t&&g.$eg(t[o])&&g.$eg(s[o])){this.i(t[o],s[o]);continue}t[o]=k.$ao(s[o])}}j(t){let s=null,o=null;const u=v=>{v&&(o?this.i(o,v):o=k.$ao(v))};for(const v of this.overrides)v.identifiers.length===1&&v.identifiers[0]===t?s=v.contents:v.identifiers.includes(t)&&u(v.contents);return u(s),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,s){this.k(t,s,!0)}setValue(t,s){this.k(t,s,!1)}removeValue(t){const s=this.keys.indexOf(t);s!==-1&&(this.keys.splice(s,1),(0,f.$dj)(this.contents,t),c.$Co.test(t)&&this.overrides.splice(this.overrides.findIndex(o=>S.$tb(o.identifiers,(0,c.$Do)(t))),1))}k(t,s,o){(0,f.$cj)(this.contents,t,s,u=>this.f.error(u)),o=o||this.keys.indexOf(t)===-1,o&&this.keys.push(t),c.$Co.test(t)&&this.overrides.push({identifiers:(0,c.$Do)(t),keys:Object.keys(this.contents[t]),contents:(0,f.$bj)(this.contents[t],u=>this.f.error(u))})}}e.$Ko=R;class E{constructor(t,s){this.f=t,this.g=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||R.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,s){if(!g.$lg(t)){const o=this.h(t);this.parseRaw(o,s)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,s){this.a=t;const{contents:o,keys:u,overrides:v,restricted:N,hasExcludedProperties:T}=this.i(t,s);this.b=new R(o,u,v,T?[t]:void 0,this.g),this.c=N||[]}h(t){let s={},o=null,u=[];const v=[],N=[];function T(D){Array.isArray(u)?u.push(D):o!==null&&(u[o]=D)}const O={onObjectBegin:()=>{const D={};T(D),v.push(u),u=D,o=null},onObjectProperty:D=>{o=D},onObjectEnd:()=>{u=v.pop()},onArrayBegin:()=>{const D=[];T(D),v.push(u),u=D,o=null},onArrayEnd:()=>{u=v.pop()},onLiteralValue:T,onError:(D,q,K)=>{N.push({error:D,offset:q,length:K})}};if(t)try{$.$2n(t,O),s=u[0]||{}}catch(D){this.g.error(`Error while parsing settings file ${this.f}: ${D}`),this.d=[D]}return s}i(t,s){const o=p.$no.as(c.$so.Configuration).getConfigurationProperties(),u=this.j(t,o,!0,s);t=u.raw;const v=(0,f.$bj)(t,O=>this.g.error(`Conflict in settings file ${this.f}: ${O}`)),N=Object.keys(t),T=this.l(t,O=>this.g.error(`Conflict in settings file ${this.f}: ${O}`));return{contents:v,keys:N,overrides:T,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}j(t,s,o,u){let v=!1;if(!u?.scopes&&!u?.skipRestricted&&!u?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:v};const N={},T=[];for(const O in t)if(c.$Co.test(O)&&o){const D=this.j(t[O],s,!1,u);N[O]=D.raw,v=v||D.hasExcludedProperties,T.push(...D.restricted)}else{const D=s[O],q=D?typeof D.scope<"u"?D.scope:c.ConfigurationScope.WINDOW:void 0;D?.restricted&&T.push(O),!u.exclude?.includes(O)&&(u.include?.includes(O)||(q===void 0||u.scopes===void 0||u.scopes.includes(q))&&!(u.skipRestricted&&D?.restricted))?N[O]=t[O]:v=!0}return{raw:N,restricted:T,hasExcludedProperties:v}}l(t,s){const o=[];for(const u of Object.keys(t))if(c.$Co.test(u)){const v={};for(const N in t[u])v[N]=t[u][N];o.push({identifiers:(0,c.$Do)(u),keys:Object.keys(v),contents:(0,f.$bj)(v,s)})}return o}}e.$Lo=E;class d extends I.$Tc{constructor(t,s,o,u,v){super(),this.c=t,this.f=s,this.g=u,this.h=v,this.b=this.B(new P.$je),this.onDidChange=this.b.event,this.a=new E(this.c.toString(),v),this.B(this.g.watch(o.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(P.Event.any(P.Event.filter(this.g.onDidFilesChange,N=>N.contains(this.c)),P.Event.filter(this.g.onDidRunOperation,N=>(N.isOperation(h.FileOperation.CREATE)||N.isOperation(h.FileOperation.COPY)||N.isOperation(h.FileOperation.DELETE)||N.isOperation(h.FileOperation.WRITE))&&o.isEqual(N.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return R.createEmptyModel(this.h)}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Mo=d;class m{constructor(t,s,o,u,v,N,T,O,D,q,K,J,re){this.a=t,this.b=s,this.c=o,this.overrideIdentifiers=u,this.d=v,this.f=N,this.g=T,this.h=O,this.i=D,this.j=q,this.k=K,this.l=J,this.m=re}get value(){return y(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class A{constructor(t,s,o,u,v,N,T,O,D,q){this.j=t,this.l=s,this.m=o,this.n=u,this.p=v,this.q=N,this.r=T,this.s=O,this.t=D,this.u=q,this.h=null,this.i=new L.$zc,this.v=null}getValue(t,s,o){return this.w(t,s,o).getValue(t)}updateValue(t,s,o={}){let u;o.resource?(u=this.t.get(o.resource),u||(u=R.createEmptyModel(this.u),this.t.set(o.resource,u))):u=this.s,s===void 0?u.removeValue(t):u.setValue(t,s),o.resource||(this.h=null)}inspect(t,s,o){const u=this.w(t,s,o),v=this.A(s.resource,o),N=s.resource?this.t.get(s.resource)||this.s:this.s,T=new Set;for(const O of u.overrides)for(const D of O.identifiers)u.getOverrideValue(t,D)!==void 0&&T.add(D);return new m(t,s,u.getValue(t),T.size?[...T]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.q:void 0,v||void 0,N)}keys(t){const s=this.A(void 0,t);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(t){this.j=t,this.h=null,this.i.clear()}updatePolicyConfiguration(t){this.l=t}updateApplicationConfiguration(t){this.m=t,this.h=null,this.i.clear()}updateLocalUserConfiguration(t){this.n=t,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(t){this.p=t,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(t){this.q=t,this.h=null,this.i.clear()}updateFolderConfiguration(t,s){this.r.set(t,s),this.i.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.i.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const o=[];if(!s){const{added:u,updated:v,removed:N}=l(this.j,t);s=[...u,...v,...N]}for(const u of s)for(const v of(0,c.$Do)(u)){const N=this.j.getKeysForOverrideIdentifier(v),T=t.getKeysForOverrideIdentifier(v),O=[...T.filter(D=>N.indexOf(D)===-1),...N.filter(D=>T.indexOf(D)===-1),...N.filter(D=>!k.$eo(this.j.override(v).getValue(D),t.override(v).getValue(D)))];o.push([v,O])}return this.updateDefaultConfiguration(t),{keys:s,overrides:o}}compareAndUpdatePolicyConfiguration(t){const{added:s,updated:o,removed:u}=l(this.l,t),v=[...s,...o,...u];return v.length&&this.updatePolicyConfiguration(t),{keys:v,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:s,updated:o,removed:u,overrides:v}=l(this.applicationConfiguration,t),N=[...s,...o,...u];return N.length&&this.updateApplicationConfiguration(t),{keys:N,overrides:v}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:o,removed:u,overrides:v}=l(this.localUserConfiguration,t),N=[...s,...o,...u];return N.length&&this.updateLocalUserConfiguration(t),{keys:N,overrides:v}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:o,removed:u,overrides:v}=l(this.remoteUserConfiguration,t),N=[...s,...o,...u];return N.length&&this.updateRemoteUserConfiguration(t),{keys:N,overrides:v}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:o,removed:u,overrides:v}=l(this.workspaceConfiguration,t),N=[...s,...o,...u];return N.length&&this.updateWorkspaceConfiguration(t),{keys:N,overrides:v}}compareAndUpdateFolderConfiguration(t,s){const o=this.folderConfigurations.get(t),{added:u,updated:v,removed:N,overrides:T}=l(o,s),O=[...u,...v,...N];return(O.length||!o)&&this.updateFolderConfiguration(t,s),{keys:O,overrides:T}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:u,removed:v,overrides:N}=l(s,void 0);return{keys:[...o,...u,...v],overrides:N}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(t,s,o){let u=this.x(s,o);return s.overrideIdentifier&&(u=u.override(s.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(t)!==void 0&&(u=u.merge(this.l)),u}x({resource:t},s){let o=this.y();if(s&&t){const u=s.getFolder(t);u&&(o=this.z(u.uri)||o);const v=this.t.get(t);v&&(o=o.merge(v))}return o}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(t){let s=this.i.get(t);if(!s){const o=this.y(),u=this.r.get(t);u?(s=o.merge(u),this.i.set(t,s)):s=o}return s}A(t,s){if(s&&t){const o=s.getFolder(t);if(o)return this.r.get(o.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((t,s)=>{const{contents:o,overrides:u,keys:v}=this.r.get(s);return t.push([s,{contents:o,overrides:u,keys:v}]),t},[])}}allKeys(){const t=new Set;return this.j.keys.forEach(s=>t.add(s)),this.userConfiguration.keys.forEach(s=>t.add(s)),this.q.keys.forEach(s=>t.add(s)),this.r.forEach(s=>s.keys.forEach(o=>t.add(o))),[...t.values()]}B(){const t=new Set;return this.j.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.q.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.r.forEach(s=>s.getAllOverrideIdentifiers().forEach(o=>t.add(o))),[...t.values()]}D(t){const s=new Set;return this.j.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o)),this.q.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o)),this.r.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(u=>s.add(u))),[...s.values()]}static parse(t,s){const o=this.E(t.defaults,s),u=this.E(t.policy,s),v=this.E(t.application,s),N=this.E(t.user,s),T=this.E(t.workspace,s),O=t.folders.reduce((D,q)=>(D.set(a.URI.revive(q[0]),this.E(q[1],s)),D),new L.$zc);return new A(o,u,v,N,R.createEmptyModel(s),T,O,R.createEmptyModel(s),new L.$zc,s)}static E(t,s){return new R(t.contents,t.keys,t.overrides,void 0,s)}}e.$No=A;function w(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,s=new Map;for(const u of r)u.keys.forEach(v=>t.add(v)),u.overrides.forEach(([v,N])=>{const T=(0,L.$wc)(s,v,new Set);N.forEach(O=>T.add(O))});const o=[];return s.forEach((u,v)=>o.push([v,[...u.values()]])),{keys:[...t.values()],overrides:o}}class i{constructor(t,s,o,u,v){this.change=t,this.f=s,this.g=o,this.h=u,this.i=v,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const N of t.keys)this.affectedKeys.add(N);for(const[,N]of t.overrides)for(const T of N)this.affectedKeys.add(T);this.d=this.a;for(const N of this.affectedKeys)this.d+=N+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=A.parse(this.f.data,this.i)),this.j}affectsConfiguration(t,s){const o=this.a+t,u=this.d.indexOf(o);if(u<0)return!1;const v=u+o.length;if(v>=this.d.length)return!1;const N=this.d.charCodeAt(v);if(N!==this.b&&N!==this.c)return!1;if(s){const T=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.f?.workspace):void 0,O=this.g.getValue(t,s,this.h);return!k.$eo(T,O)}return!0}}e.$Po=i;function l(r,t){const{added:s,removed:o,updated:u}=n(t?.rawConfiguration,r?.rawConfiguration),v=[],N=r?.getAllOverrideIdentifiers()||[],T=t?.getAllOverrideIdentifiers()||[];if(t){const O=T.filter(D=>!N.includes(D));for(const D of O)v.push([D,t.getKeysForOverrideIdentifier(D)])}if(r){const O=N.filter(D=>!T.includes(D));for(const D of O)v.push([D,r.getKeysForOverrideIdentifier(D)])}if(t&&r){for(const O of N)if(T.includes(O)){const D=n({contents:r.getOverrideValue(void 0,O)||{},keys:r.getKeysForOverrideIdentifier(O)},{contents:t.getOverrideValue(void 0,O)||{},keys:t.getKeysForOverrideIdentifier(O)});v.push([O,[...D.added,...D.removed,...D.updated]])}}return{added:s,removed:o,updated:u,overrides:v}}function n(r,t){const s=r?t?r.keys.filter(v=>t.keys.indexOf(v)===-1):[...r.keys]:[],o=t?r?t.keys.filter(v=>r.keys.indexOf(v)===-1):[...t.keys]:[],u=[];if(r&&t){for(const v of t.keys)if(r.keys.indexOf(v)!==-1){const N=(0,f.$ej)(t.contents,v),T=(0,f.$ej)(r.contents,v);k.$eo(N,T)||u.push(v)}}return{added:s,removed:o,updated:u}}}),define(le[115],ue([0,1,19,4,2,26,3,66,40,6,39,37]),function(Y,e,S,P,$,I,L,k,g,a,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Ro=e.$Qo=void 0;class h extends $.$Tc{get configurationModel(){return this.b}constructor(E){super(),this.c=E,this.a=this.B(new P.$je),this.onDidChangeConfiguration=this.a.event,this.b=k.$Ko.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(c.$no.as(g.$so.Configuration).onDidUpdateConfiguration(({properties:E,defaultsOverrides:d})=>this.f(Array.from(E),d))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(E,d){this.j(E,c.$no.as(g.$so.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:E})}g(){return{}}h(){this.b=k.$Ko.createEmptyModel(this.c);const E=c.$no.as(g.$so.Configuration).getConfigurationProperties();this.j(Object.keys(E),E)}j(E,d){const m=this.g();for(const A of E){const w=m[A],i=d[A];w!==void 0?this.b.addValue(A,w):i?this.b.addValue(A,i.default):this.b.removeValue(A)}}}e.$Qo=h;class p{constructor(){this.onDidChangeConfiguration=P.Event.None,this.configurationModel=k.$Ko.createEmptyModel(new a.$jk)}async initialize(){return this.configurationModel}}e.$Ro=p;let y=class extends $.$Tc{get configurationModel(){return this.b}constructor(E,d,m){super(),this.c=E,this.f=d,this.g=m,this.a=this.B(new P.$je),this.onDidChangeConfiguration=this.a.event,this.b=k.$Ko.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(E=>this.j(E))),this.B(this.c.onDidChangeConfiguration(async({properties:E})=>this.m(await this.h(E),!0))),this.b}async h(E){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",E);const d={},m=[],A=c.$no.as(g.$so.Configuration).getConfigurationProperties();for(const w of E){const i=A[w];if(!i){m.push(w);continue}if(i.policy){if(i.type!=="string"&&i.type!=="number"){this.g.warn(`Policy ${i.policy.name} has unsupported type ${i.type}`);continue}m.push(w),d[i.policy.name]={type:i.type}}}return(0,L.$pg)(d)||await this.f.updatePolicyDefinitions(d),m}j(E){this.g.trace("PolicyConfiguration#onDidChangePolicies",E);const d=c.$no.as(g.$so.Configuration).getPolicyConfigurations(),m=(0,S.$Gb)(E.map(A=>d.get(A)));this.m(m,!0)}m(E,d){this.g.trace("PolicyConfiguration#update",E);const m=c.$no.as(g.$so.Configuration).getConfigurationProperties(),A=[],w=this.b.isEmpty();for(const i of E){const l=m[i]?.policy?.name;if(l){const n=this.f.getPolicyValue(l);(w?n!==void 0:!(0,I.$eo)(this.b.getValue(i),n))&&A.push([i,n])}else this.b.getValue(i)!==void 0&&A.push([i,void 0])}if(A.length){this.g.trace("PolicyConfiguration#changed",A);const i=this.b;this.b=k.$Ko.createEmptyModel(this.g);for(const l of i.keys)this.b.setValue(l,i.getValue(l));for(const[l,n]of A)n===void 0?this.b.removeValue(l):this.b.setValue(l,n);d&&this.a.fire(this.b)}}};e.$So=y,e.$So=y=ve([se(1,f.$po),se(2,a.$9j)],y)}),define(le[116],ue([0,1,19,8,13,4,34,77,2,30,26,12,16,29,66,40,115,9,39]),function(Y,e,S,P,$,I,L,k,g,a,f,c,h,p,y,R,E,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=void 0;class A extends g.$Tc{constructor(l,n,r,t){super(),this.m=l,this.n=t,this.h=this.B(new I.$je),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new E.$Qo(t)),this.c=r instanceof m.$ro?new E.$Ro:this.B(new E.$So(this.b,r,t)),this.f=this.B(new y.$Mo(this.m,{},h.$7g,n,t)),this.a=new y.$No(this.b.configurationModel,this.c.configurationModel,y.$Ko.createEmptyModel(t),y.$Ko.createEmptyModel(t),y.$Ko.createEmptyModel(t),y.$Ko.createEmptyModel(t),new a.$zc,y.$Ko.createEmptyModel(t),new a.$zc,t),this.j=new w(l,n,this),this.g=this.B(new P.$Oh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:s,properties:o})=>this.s(s,o))),this.B(this.c.onDidChangeConfiguration(s=>this.t(s))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[l,n,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new y.$No(l,n,y.$Ko.createEmptyModel(this.n),r,y.$Ko.createEmptyModel(this.n),y.$Ko.createEmptyModel(this.n),new a.$zc,y.$Ko.createEmptyModel(this.n),new a.$zc,this.n)}getConfigurationData(){return this.a.toData()}getValue(l,n){const r=typeof l=="string"?l:void 0,t=(0,p.$0i)(l)?l:(0,p.$0i)(n)?n:{};return this.a.getValue(r,t,void 0)}async updateValue(l,n,r,t,s){const o=(0,p.$$i)(r)?r:(0,p.$0i)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,u=o?t:r;if(u!==void 0&&u!==p.ConfigurationTarget.USER_LOCAL&&u!==p.ConfigurationTarget.USER)throw new Error(`Unable to write ${l} to target ${u}.`);o?.overrideIdentifiers&&(o.overrideIdentifiers=(0,S.$Lb)(o.overrideIdentifiers),o.overrideIdentifiers=o.overrideIdentifiers.length?o.overrideIdentifiers:void 0);const v=this.inspect(l,{resource:o?.resource,overrideIdentifier:o?.overrideIdentifiers?o.overrideIdentifiers[0]:void 0});if(v.policyValue!==void 0)throw new Error(`Unable to write ${l} because it is configured in system policy.`);if((0,f.$eo)(n,v.defaultValue)&&(n=void 0),o?.overrideIdentifiers?.length&&o.overrideIdentifiers.length>1){const T=o.overrideIdentifiers.sort(),O=this.a.localUserConfiguration.overrides.find(D=>(0,S.$tb)([...D.identifiers].sort(),T));O&&(o.overrideIdentifiers=O.identifiers)}const N=o?.overrideIdentifiers?.length?[(0,R.$Eo)(o.overrideIdentifiers),l]:[l];await this.j.write(N,n),await this.reloadConfiguration()}inspect(l,n={}){return this.a.inspect(l,n,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const l=await this.f.loadConfiguration();this.r(l)}r(l){const n=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration(l);this.u(r,n,p.ConfigurationTarget.USER)}s(l,n){const r=this.a.toData(),t=this.a.compareAndUpdateDefaultConfiguration(l,n);this.u(t,r,p.ConfigurationTarget.DEFAULT)}t(l){const n=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration(l);this.u(r,n,p.ConfigurationTarget.DEFAULT)}u(l,n,r){const t=new y.$Po(l,{data:n},this.a,void 0,this.n);t.source=r,this.h.fire(t)}}e.$To=A;class w{constructor(l,n,r){this.b=l,this.c=n,this.d=r,this.a=new P.$Jh}write(l,n){return this.a.queue(()=>this.e(l,n))}async e(l,n){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(o){if(o.fileOperationResult===d.FileOperationResult.FILE_NOT_FOUND)r="{}";else throw o}const t=[];if((0,L.$Un)(r,t,{allowTrailingComma:!0,allowEmptyContent:!0}),t.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.f(r,l,n);r=(0,k.$_n)(r,s),await this.c.writeFile(this.b,$.$Le.fromString(r))}f(l,n,r){const{tabSize:t,insertSpaces:s,eol:o}=this.h;if(!n.length){const u=JSON.stringify(r,null,s?" ".repeat(t):"	");return[{content:u,length:u.length,offset:0}]}return(0,k.$9n)(l,n,r,{tabSize:t,insertSpaces:s,eol:o})}get h(){if(!this.g){let l=c.OS===c.OperatingSystem.Linux||c.OS===c.OperatingSystem.Macintosh?`
`:`\r
`;const n=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});n&&typeof n=="string"&&n!=="auto"&&(l=n),this.g={eol:l,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(le[67],ue([0,1,14]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=P,e.$en=$,e.$fn=I,e.$gn=L;function P(g){return g.scheme===S.Schemas.vscodeRemote?g.authority:void 0}function $(g){if(!g)return;const a=g.indexOf("+");return a<0?g:g.substr(0,a)}function I(g){const{host:a,port:f}=k(g);if(typeof f>"u")throw new Error(`Invalid remote authority: ${g}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:f}}function L(g,a){let{host:f,port:c}=k(g);return typeof c>"u"&&(c=a),{host:f,port:c}}function k(g){const a=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const f=g.match(/^(\[[0-9a-z:]+\])$/);if(f)return{host:f[1],port:void 0};const c=g.match(/(.*):(\d+)$/);return c?{host:c[1],port:parseInt(c[2],10)}:{host:g,port:void 0}}}),define(le[22],ue([0,1,31,10,67]),function(Y,e,S,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=e.$pn=e.$on=e.$nn=e.TargetPlatform=e.ExtensionType=e.$mn=e.$kn=e.$jn=e.$in=e.$hn=void 0,e.$ln=I,e.$qn=c,e.$rn=h,e.$sn=p,e.$tn=y,e.$un=R,e.$vn=E,S=ye(S),e.$hn="extensions.user.cache",e.$in="extensions.builtin.cache",e.$jn="undefined_publisher",e.$kn=["ui","workspace","web"];function I(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.$mn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(L||(e.ExtensionType=L={}));var k;(function(d){d.WIN32_X64="win32-x64",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(k||(e.TargetPlatform=k={}));class g{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,A){if(typeof m>"u"||m===null)return typeof A>"u"||A===null;if(typeof A>"u"||A===null)return!1;if(typeof m=="string"||typeof A=="string"){const w=typeof m=="string"?m:m.value,i=typeof A=="string"?A:A.value;return S.$Df(w,i)}return m._lower===A._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$nn=g;class a{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const A of m)this.add(A)}add(m){this.c.add(g.toKey(m))}delete(m){return this.c.delete(g.toKey(m))}has(m){return this.c.has(g.toKey(m))}}e.$on=a;class f{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete(g.toKey(m))}get(m){return this.c.get(g.toKey(m))}has(m){return this.c.has(g.toKey(m))}set(m,A){this.c.set(g.toKey(m),A)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$pn=f;function c(d){return h(d)}function h(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}function p(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}function y(d,m){if(m){const A=`onResolveRemoteAuthority:${(0,$.$en)(m)}`;return!!d.activationEvents?.includes(A)}return!1}function R(d){return d.map(m=>{const[A,w]=m.split("@");return{proposalName:A,version:w?parseInt(w):void 0}})}function E(d){return d.map(m=>m.split("@")[0])}e.$wn=(0,P.$Ci)("IBuiltinExtensionsScannerService")}),define(le[20],ue([0,1,12,5,22,10]),function(Y,e,S,P,$,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.ExtensionManagementErrorCode=e.$ip=e.ExtensionGalleryErrorCode=e.$hp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=void 0,e.$bp=k,e.$cp=g,e.$dp=a,e.$ep=f,e.$fp=c,e.$gp=h,e.$7o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$8o=new RegExp(e.$7o),e.$9o="__web_extension",e.$0o="skipWalkthrough",e.$$o="extensionInstallSource",e.$_o="dependecyOrPackExtensionInstall",e.$ap="clientTargetPlatform";var L;(function(i){i.COMMAND="command",i.SETTINGS_SYNC="settingsSync"})(L||(e.ExtensionInstallSource=L={}));function k(i){switch(i){case $.TargetPlatform.WIN32_X64:return"Windows 64 bit";case $.TargetPlatform.WIN32_ARM64:return"Windows ARM";case $.TargetPlatform.LINUX_X64:return"Linux 64 bit";case $.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case $.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case $.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case $.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case $.TargetPlatform.DARWIN_X64:return"Mac";case $.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case $.TargetPlatform.WEB:return"Web";case $.TargetPlatform.UNIVERSAL:return $.TargetPlatform.UNIVERSAL;case $.TargetPlatform.UNKNOWN:return $.TargetPlatform.UNKNOWN;case $.TargetPlatform.UNDEFINED:return $.TargetPlatform.UNDEFINED}}function g(i){switch(i){case $.TargetPlatform.WIN32_X64:return $.TargetPlatform.WIN32_X64;case $.TargetPlatform.WIN32_ARM64:return $.TargetPlatform.WIN32_ARM64;case $.TargetPlatform.LINUX_X64:return $.TargetPlatform.LINUX_X64;case $.TargetPlatform.LINUX_ARM64:return $.TargetPlatform.LINUX_ARM64;case $.TargetPlatform.LINUX_ARMHF:return $.TargetPlatform.LINUX_ARMHF;case $.TargetPlatform.ALPINE_X64:return $.TargetPlatform.ALPINE_X64;case $.TargetPlatform.ALPINE_ARM64:return $.TargetPlatform.ALPINE_ARM64;case $.TargetPlatform.DARWIN_X64:return $.TargetPlatform.DARWIN_X64;case $.TargetPlatform.DARWIN_ARM64:return $.TargetPlatform.DARWIN_ARM64;case $.TargetPlatform.WEB:return $.TargetPlatform.WEB;case $.TargetPlatform.UNIVERSAL:return $.TargetPlatform.UNIVERSAL;default:return $.TargetPlatform.UNKNOWN}}function a(i,l){switch(i){case S.Platform.Windows:return l==="x64"?$.TargetPlatform.WIN32_X64:l==="arm64"?$.TargetPlatform.WIN32_ARM64:$.TargetPlatform.UNKNOWN;case S.Platform.Linux:return l==="x64"?$.TargetPlatform.LINUX_X64:l==="arm64"?$.TargetPlatform.LINUX_ARM64:l==="arm"?$.TargetPlatform.LINUX_ARMHF:$.TargetPlatform.UNKNOWN;case"alpine":return l==="x64"?$.TargetPlatform.ALPINE_X64:l==="arm64"?$.TargetPlatform.ALPINE_ARM64:$.TargetPlatform.UNKNOWN;case S.Platform.Mac:return l==="x64"?$.TargetPlatform.DARWIN_X64:l==="arm64"?$.TargetPlatform.DARWIN_ARM64:$.TargetPlatform.UNKNOWN;case S.Platform.Web:return $.TargetPlatform.WEB}}function f(i,l){return l===$.TargetPlatform.WEB&&!i.includes($.TargetPlatform.WEB)}function c(i,l,n){return f(l,n)?!1:i===$.TargetPlatform.UNDEFINED||i===$.TargetPlatform.UNIVERSAL?!0:i===$.TargetPlatform.UNKNOWN?!1:i===n}function h(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var p;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(p||(e.SortBy=p={}));var y;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(y||(e.SortOrder=y={}));var R;(function(i){i.Install="install",i.Uninstall="uninstall"})(R||(e.StatisticType=R={}));var E;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(E||(e.InstallOperation=E={})),e.$hp=(0,I.$Ci)("extensionGalleryService");var d;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed",i.DownloadFailedWriting="DownloadFailedWriting"})(d||(e.ExtensionGalleryErrorCode=d={}));class m extends Error{constructor(l,n){super(l),this.code=n,this.name=n}}e.$ip=m;var A;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleApi="IncompatibleApi",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.DownloadFailedWriting="DownloadFailedWriting",i.UpdateExistingMetadata="UpdateExistingMetadata",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.ScanningExtension="ScanningExtension",i.ReadUninstalled="ReadUninstalled",i.UnsetUninstalled="UnsetUninstalled",i.Delete="Delete",i.Rename="Rename",i.IntializeDefaultProfile="IntializeDefaultProfile",i.AddToProfile="AddToProfile",i.InstalledExtensionNotFound="InstalledExtensionNotFound",i.PostInstall="PostInstall",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Cancelled="Cancelled",i.Unknown="Unknown",i.Internal="Internal"})(A||(e.ExtensionManagementErrorCode=A={}));class w extends Error{constructor(l,n){super(l),this.code=n,this.name=n}}e.$jp=w,e.$kp=(0,I.$Ci)("extensionManagementService"),e.$lp="extensionsIdentifiers/disabled",e.$mp="extensionsIdentifiers/enabled",e.$np=(0,I.$Ci)("IGlobalExtensionEnablementService"),e.$op=(0,I.$Ci)("IExtensionTipsService"),e.$pp=(0,P.localize2)(11334,"Extensions"),e.$qp=(0,P.localize2)(11335,"Preferences")}),define(le[117],ue([0,1,2,22,9]),function(Y,e,S,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=void 0;class I extends S.$Tc{constructor(k,g,a,f,c){super(),this.a=k,this.b=g,this.c=a,this.f=c,this.B(f.onDidInstallExtensions(h=>this.g(h))),this.B(f.onDidUninstallExtension(h=>this.h(h)))}g(k){for(const g of k)g.local&&this.invalidate(g.profileLocation)}h(k){k.error||this.invalidate(k.profileLocation)}async invalidate(k){if(k)for(const g of this.a.profiles)this.c.extUri.isEqual(g.extensionsResource,k)&&await this.j(g);else await this.j(this.a.defaultProfile)}async j(k){try{await this.b.del(this.c.extUri.joinPath(k.cacheHome,P.$hn))}catch(g){(0,$.$nl)(g)!==$.FileOperationResult.FILE_NOT_FOUND&&this.f.error(g)}}}e.$Sq=I});var qe=this&&this.__importDefault||function(Y){return Y&&Y.__esModule?Y:{default:Y}};define(le[44],ue([0,1,16,57,5,45,22,96]),function(Y,e,S,P,$,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=f,e.$Wp=c,e.$Xp=h,e.$Yp=p,e.$Zp=y,e.$1p=R,e.$2p=E,e.$3p=d,P=qe(P),$=ye($),I=ye(I);const g=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,a=/^-(\d{4})(\d{2})(\d{2})$/;function f(w){return w=w.trim(),w==="*"||g.test(w)}function c(w){if(!f(w))return null;if(w=w.trim(),w==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=w.match(g);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}function h(w){if(!w)return null;const i=w.majorBase,l=w.majorMustEqual,n=w.minorBase;let r=w.minorMustEqual;const t=w.patchBase;let s=w.patchMustEqual;w.hasCaret&&(i===0||(r=!1),s=!1);let o=0;if(w.preRelease){const u=a.exec(w.preRelease);if(u){const[,v,N,T]=u;o=Date.UTC(Number(v),Number(N)-1,Number(T))}}return{majorBase:i,majorMustEqual:l,minorBase:n,minorMustEqual:r,patchBase:t,patchMustEqual:s,isMinimum:w.hasGreaterEquals,notBefore:o}}function p(w,i,l){let n;typeof w=="string"?n=h(c(w)):n=w;let r;i instanceof Date?r=i.getTime():typeof i=="string"&&(r=new Date(i).getTime());let t;if(typeof l=="string"?t=h(c(l)):t=l,!n||!t)return!1;const s=n.majorBase,o=n.minorBase,u=n.patchBase;let v=t.majorBase,N=t.minorBase,T=t.patchBase;const O=t.notBefore;let D=t.majorMustEqual,q=t.minorMustEqual,K=t.patchMustEqual;return t.isMinimum?s>v?!0:s<v?!1:o>N?!0:o<N||r&&r<O?!1:u>=T:(s===1&&v===0&&(!D||!q||!K)&&(v=1,N=0,T=0,D=!0,q=!1,K=!1),s<v?!1:s>v?!D:o<N?!1:o>N?!q:u<T?!1:u>T?!K:!(r&&r<O))}function y(w,i,l,n,r,t){const s=[];if(typeof n.publisher<"u"&&typeof n.publisher!="string")return s.push([P.default.Error,$.localize(11266,null)]),s;if(typeof n.name!="string")return s.push([P.default.Error,$.localize(11267,null,"name")]),s;if(typeof n.version!="string")return s.push([P.default.Error,$.localize(11268,null,"version")]),s;if(!n.engines)return s.push([P.default.Error,$.localize(11269,null,"engines")]),s;if(typeof n.engines.vscode!="string")return s.push([P.default.Error,$.localize(11270,null,"engines.vscode")]),s;if(typeof n.extensionDependencies<"u"&&!A(n.extensionDependencies))return s.push([P.default.Error,$.localize(11271,null,"extensionDependencies")]),s;if(typeof n.activationEvents<"u"){if(!A(n.activationEvents))return s.push([P.default.Error,$.localize(11272,null,"activationEvents")]),s;if(typeof n.main>"u"&&typeof n.browser>"u")return s.push([P.default.Error,$.localize(11273,null,"activationEvents","main","browser")]),s}if(typeof n.extensionKind<"u"&&typeof n.main>"u"&&s.push([P.default.Warning,$.localize(11274,null,"extensionKind")]),typeof n.main<"u"){if(typeof n.main!="string")return s.push([P.default.Error,$.localize(11275,null,"main")]),s;{const v=(0,S.$dh)(l,n.main);(0,S.$0g)(v,l)||s.push([P.default.Warning,$.localize(11276,null,v.path,l.path)])}}if(typeof n.browser<"u"){if(typeof n.browser!="string")return s.push([P.default.Error,$.localize(11277,null,"browser")]),s;{const v=(0,S.$dh)(l,n.browser);(0,S.$0g)(v,l)||s.push([P.default.Warning,$.localize(11278,null,v.path,l.path)])}}if(!I.valid(n.version))return s.push([P.default.Error,$.localize(11279,null)]),s;const o=[];if(!R(w,i,n,r,o))for(const v of o)s.push([P.default.Error,v]);if(t&&n.enabledApiProposals?.length){const v=[];if(!d([...n.enabledApiProposals],v))for(const N of v)s.push([P.default.Error,N])}return s}function R(w,i,l,n,r){return n||typeof l.main>"u"&&typeof l.browser>"u"?!0:m(w,i,l.engines.vscode,r)}function E(w,i,l){return w==="*"||m(i,l,w)}function d(w,i){if(w.length===0)return!0;const l=Array.isArray(i)?i:void 0,n=(l?void 0:i)??k.allApiProposals,r=[],t=(0,L.$un)(w);for(const{proposalName:s,version:o}of t){const u=n[s];u&&o&&u.version!==o&&r.push($.localize(11280,null,s))}return l?.push(...r),r.length===0}function m(w,i,l,n=[]){const r=h(c(l));if(!r)return n.push($.localize(11281,null,l)),!1;if(r.majorBase===0){if(!r.majorMustEqual||!r.minorMustEqual)return n.push($.localize(11282,null,l)),!1}else if(!r.majorMustEqual)return n.push($.localize(11283,null,l)),!1;return p(w,i,r)?!0:(n.push($.localize(11284,null,w,l)),!1)}function A(w){if(!Array.isArray(w))return!1;for(let i=0,l=w.length;i<l;i++)if(typeof w[i]!="string")return!1;return!0}}),define(le[68],ue([0,1,21,2,12,5,20,10]),function(Y,e,S,P,$,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9r=e.$8r=void 0,e.$7r=g;function g(f){return f.tags.find(c=>c.startsWith("lp-"))?.split("lp-")[1]}e.$8r=(0,k.$Ci)("languagePackService");let a=class extends P.$Tc{constructor(c){super(),this.c=c}async getAvailableLanguages(){const c=new S.$ue;setTimeout(()=>c.cancel(),1e3);let h;try{h=await this.c.query({text:'category:"language packs"',pageSize:20},c.token)}catch{return[]}const y=h.firstPage.filter(R=>R.properties.localizedLanguages?.length&&R.tags.some(E=>E.startsWith("lp-"))).map(R=>{const E=R.properties.localizedLanguages?.[0],d=g(R);return{...this.f(d,E,R),extensionId:R.identifier.id,galleryExtension:R}});return y.push(this.f("en","English")),y}f(c,h,p){const y=h??c;let R;if(y!==c&&(R=`(${c})`),c.toLowerCase()===$.$x.toLowerCase()&&(R??="",R+=(0,I.localize)(11188,null)),p?.installCount){R??="";const E=p.installCount;let d;E>1e6?d=`${Math.floor(E/1e5)/10}M`:E>1e3?d=`${Math.floor(E/1e3)}K`:d=String(E),R+=` $(cloud-download) ${d}`}return{id:c,label:y,description:R}}};e.$9r=a,e.$9r=a=ve([se(0,L.$hp)],a)}),define(le[46],ue([0,1,13,7,2,5,40,10,6,37]),function(Y,e,S,P,$,I,L,k,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=void 0,e.$6p=h,e.$7p=p,e.$8p=y,e.$9p=R,e.$0p=E,e.$$p=d,e.$4p=(0,k.$Ci)("requestService");class f{constructor(i){this.b=i}toJSON(){if(!this.a){const i=Object.create(null);for(const l in this.b)l.toLowerCase()==="authorization"||l.toLowerCase()==="proxy-authorization"?i[l]="*****":i[l]=this.b[l];this.a=i}return this.a}}class c extends $.$Tc{constructor(i){super(),this.b=0,this.a=i.createLogger("network",{name:(0,I.localize)(11053,null),when:g.$ok.isEqualTo((0,g.$lk)(g.LogLevel.Trace)).serialize()})}async c(i,l,n){const r=`${i} #${++this.b}: ${l.url}`;this.a.trace(`${r} - begin`,l.type,new f(l.headers??{}));try{const t=await n();return this.a.trace(`${r} - end`,l.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${r} - error`,l.type,(0,P.$9)(t)),t}}}e.$5p=c;function h(w){return w.res.statusCode&&w.res.statusCode>=200&&w.res.statusCode<300||w.res.statusCode===1223}function p(w){return w.res.statusCode===204}async function y(w){return p(w)?null:(await(0,S.$Xe)(w.stream)).toString()}async function R(w){if(!h(w))throw new Error("Server returned "+w.res.statusCode);return y(w)}async function E(w){if(!h(w))throw new Error("Server returned "+w.res.statusCode);if(p(w))return null;const l=(await(0,S.$Xe)(w.stream)).toString();try{return JSON.parse(l)}catch(n){throw n.message+=`:
`+l,n}}function d(w){A(w)}let m;function A(w){const i=a.$no.as(L.$so.Configuration),l=m;m={id:"http",order:15,title:(0,I.localize)(11054,null),type:"object",scope:w,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,I.localize)(11055,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,I.localize)(11056,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,I.localize)(11057,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,I.localize)(11058,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,I.localize)(11059,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,I.localize)(11060,null),(0,I.localize)(11061,null),(0,I.localize)(11062,null),(0,I.localize)(11063,null)],default:"override",description:(0,I.localize)(11064,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,I.localize)(11065,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,I.localize)(11066,null),restricted:!0}}},i.updateConfigurations({add:[m],remove:l?[l]:[]})}A(L.ConfigurationScope.APPLICATION)}),define(le[118],ue([0,1,21,14,9,46]),function(Y,e,S,P,$,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DR=void 0;let L=class{constructor(g,a){this.a=g,this.b=a}async download(g,a,f=S.CancellationToken.None){if(g.scheme===P.Schemas.file||g.scheme===P.Schemas.vscodeRemote){await this.b.copy(g,a);return}const c={type:"GET",url:g.toString(!0)},h=await this.a.request(c,f);if(h.res.statusCode===200)await this.b.writeFile(a,h.stream);else{const p=await(0,I.$9p)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${p}`)}}};e.$DR=L,e.$DR=L=ve([se(0,I.$4p),se(1,$.$9k)],L)}),define(le[119],ue([0,1,120,3]),function(Y,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=I;function $(L,k){return L.protocol==="http:"?k.HTTP_PROXY||k.http_proxy||null:L.protocol==="https:"&&(k.HTTPS_PROXY||k.https_proxy||k.HTTP_PROXY||k.http_proxy)||null}async function I(L,k,g={}){const a=(0,S.parse)(L),f=g.proxyUrl||$(a,k);if(!f)return null;const c=(0,S.parse)(f);if(!/^https?:$/.test(c.protocol||""))return null;const h={host:c.hostname||"",port:(c.port?+c.port:0)||(c.protocol==="https"?443:80),auth:c.auth,rejectUnauthorized:(0,P.$ig)(g.strictSSL)?g.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((p,y)=>{Y(["http-proxy-agent"],p,y)}).then(ye)).HttpProxyAgent(f,h):new(await new Promise((p,y)=>{Y(["https-proxy-agent"],p,y)}).then(ye)).HttpsProxyAgent(f,h)}}),define(le[121],ue([0,1,60,15,5,21,38,7,12,27,85,151,8,78]),function(Y,e,S,P,$,I,L,k,g,a,f,c,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=R;let y;async function R(d,m,A,w){return A["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.$j?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,c.$Gm)(w)&&!A["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,c.$Gm)(w)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=h.Promises.withAsyncBody(async(i,l)=>{const n=new I.$ue;let r=1e4;const t=d.getValue("application.shellEnvironmentResolutionTimeout");typeof t=="number"&&(r=(0,p.$Hm)(t,1,120)*1e3);const s=setTimeout(()=>{n.dispose(!0),l(new Error((0,$.localize)(11050,null)))},r);try{i(await E(m,n.token))}catch(o){!(0,k.$3)(o)&&!n.token.isCancellationRequested?l(new Error((0,$.localize)(11051,null,(0,L.$nj)(o)))):i({})}finally{clearTimeout(s),n.dispose()}})),y)}async function E(d,m){const A=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",A);const w=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",w);const i=(0,a.$Yg)().replace(/-/g,"").substr(0,12),l=new RegExp(i+"({.*})"+i),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};d.trace("getUnixShellEnvironment#env",n);const r=await(0,f.$wm)(g.OS,n);return d.trace("getUnixShellEnvironment#shell",r),new Promise((t,s)=>{if(m.isCancellationRequested)return s(new k.$4);const o=(0,P.$mc)(r);let u,v;const N="";/^pwsh(-preview)?$/.test(o)?(u=`& '${process.execPath}' ${N} -p '''${i}'' + JSON.stringify(process.env) + ''${i}'''`,v=["-Login","-Command"]):o==="nu"?(u=`^'${process.execPath}' ${N} -p '"${i}" + JSON.stringify(process.env) + "${i}"'`,v=["-i","-l","-c"]):o==="xonsh"?(u=`import os, json; print("${i}", json.dumps(dict(os.environ)), "${i}")`,v=["-i","-l","-c"]):(u=`'${process.execPath}' ${N} -p '"${i}" + JSON.stringify(process.env) + "${i}"'`,o==="tcsh"||o==="csh"?v=["-ic"]:v=["-i","-l","-c"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(v),u);const T=(0,S.spawn)(r,[...v,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});m.onCancellationRequested(()=>(T.kill(),s(new k.$4))),T.on("error",q=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,L.$nj)(q)),s(q)});const O=[];T.stdout.on("data",q=>O.push(q));const D=[];T.stderr.on("data",q=>D.push(q)),T.on("close",(q,K)=>{const J=Buffer.concat(O).toString("utf8");d.trace("getUnixShellEnvironment#raw",J);const re=Buffer.concat(D).toString("utf8");if(re.trim()&&d.trace("getUnixShellEnvironment#stderr",re),q||K)return s(new Error((0,$.localize)(11052,null,q,K)));const ae=l.exec(J),ce=ae?ae[1]:"{}";try{const de=JSON.parse(ce);A?de.ELECTRON_RUN_AS_NODE=A:delete de.ELECTRON_RUN_AS_NODE,w?de.ELECTRON_NO_ATTACH_CONSOLE=w:delete de.ELECTRON_NO_ATTACH_CONSOLE,delete de.VSCODE_RESOLVING_ENVIRONMENT,delete de.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",de),t(de)}catch(de){d.error("getUnixShellEnvironment#errorCaught",(0,L.$nj)(de)),s(de)}})})}}),define(le[122],ue([0,1,10]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gR=e.$fR=void 0,e.$fR=(0,S.$Ci)("stateReadService"),e.$gR=(0,S.$Ci)("stateService")}),define(le[69],ue([0,1,8,13,2,3,17,9,6]),function(Y,e,S,P,$,I,L,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jR=e.$iR=e.$hR=e.SaveStrategy=void 0;var a;(function(p){p[p.IMMEDIATE=0]="IMMEDIATE",p[p.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class f extends $.$Tc{constructor(y,R,E,d){super(),this.h=y,this.j=R,this.m=E,this.n=d,this.a=Object.create(null),this.b="",this.c=this.B(new S.$Ah(this.j===a.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(y){y.fileOperationResult!==k.FileOperationResult.FILE_NOT_FOUND&&this.m.error(y)}}getItem(y,R){const E=this.a[y];return(0,I.$lg)(E)?R:E}setItem(y,R){this.setItems([{key:y,data:R}])}setItems(y){let R=!1;for(const{key:E,data:d}of y)this.a[E]!==d&&((0,I.$lg)(d)?(0,I.$jg)(this.a[E])||(this.a[E]=void 0,R=!0):(this.a[E]=d,R=!0));R&&this.s()}removeItem(y){(0,I.$jg)(this.a[y])||(this.a[y]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const y=JSON.stringify(this.a,null,4);if(y!==this.b)try{await this.n.writeFile(this.h,P.$Le.fromString(y),{atomic:{postfix:".vsctmp"}}),this.b=y}catch(R){this.m.error(R)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$hR=f;let c=class extends $.$Tc{constructor(y,R,E,d){super(),this.a=this.B(new f(R.stateResource,y,E,d))}async init(){await this.a.init()}getItem(y,R){return this.a.getItem(y,R)}};e.$iR=c,e.$iR=c=ve([se(1,L.$Ji),se(2,g.$9j),se(3,k.$9k)],c);class h extends c{setItem(y,R){this.a.setItem(y,R)}setItems(y){this.a.setItems(y)}removeItem(y){this.a.removeItem(y)}close(){return this.a.close()}}e.$jR=h}),define(le[70],ue([0,1,12,36,27]),function(Y,e,S,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=L,e.$sp=k;function I(g){if(S.$v===S.Platform.Linux&&/^penguin(\.|$)/i.test(g))return"chromebook"}function L(g,a,f,c,h,p,y,R,E,d){const m=Object.create(null);m["common.machineId"]=p,m["common.sqmId"]=y,m["common.devDeviceId"]=R,m.sessionID=(0,$.$Yg)()+Date.now(),m.commitHash=c,m.version=h,m["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,S.$i)(S.$v),m["common.nodePlatform"]=P.$cc,m["common.nodeArch"]=f,m["common.product"]=d||"desktop",E&&(m["common.msftInternal"]=E);let A=0;const w=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-w,enumerable:!0},"common.sequence":{get:()=>A++,enumerable:!0}}),S.$m&&(m["common.snap"]="true");const i=I(a);return i&&(m["common.platformDetail"]=i),m}function k(g){const a=P.env.USERDNSDOMAIN;if(!a)return!1;const f=a.toLowerCase();return g.some(c=>f===c)}}),define(le[18],ue([0,1,10]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=void 0,e.$8l=(0,S.$Ci)("telemetryService"),e.$9l=(0,S.$Ci)("customEndpointTelemetryService"),e.$0l="telemetry.currentSessionDate",e.$$l="telemetry.firstSessionDate",e.$_l="telemetry.lastSessionDate",e.$am="telemetry.machineId",e.$bm="telemetry.sqmId",e.$cm="telemetry.devDeviceId",e.$dm="telemetry",e.$em="telemetry.telemetryLevel",e.$fm="telemetry.enableCrashReporter",e.$gm="telemetry.enableTelemetry";var P;(function(I){I[I.NONE=0]="NONE",I[I.CRASH=1]="CRASH",I[I.ERROR=2]="ERROR",I[I.USAGE=3]="USAGE"})(P||(e.TelemetryLevel=P={}));var $;(function(I){I.OFF="off",I.CRASH="crash",I.ERROR="error",I.ON="all"})($||(e.TelemetryConfiguration=$={}))}),define(le[71],ue([0,1,7,10,6,18]),function(Y,e,S,P,$,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$qq=e.ExtensionSignatureVerificationCode=e.$pq=void 0,e.$pq=(0,P.$Ci)("IExtensionSignatureVerificationService");var L;(function(a){a.Success="Success",a.RequiredArgumentMissing="RequiredArgumentMissing",a.InvalidArgument="InvalidArgument",a.PackageIsUnreadable="PackageIsUnreadable",a.UnhandledException="UnhandledException",a.SignatureManifestIsMissing="SignatureManifestIsMissing",a.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",a.SignatureIsMissing="SignatureIsMissing",a.SignatureIsUnreadable="SignatureIsUnreadable",a.CertificateIsUnreadable="CertificateIsUnreadable",a.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",a.FileAlreadyExists="FileAlreadyExists",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",a.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",a.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",a.SignatureIsInvalid="SignatureIsInvalid",a.SignatureManifestIsInvalid="SignatureManifestIsInvalid",a.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",a.EntryIsMissing="EntryIsMissing",a.EntryIsTampered="EntryIsTampered",a.Untrusted="Untrusted",a.CertificateRevoked="CertificateRevoked",a.SignatureIsNotValid="SignatureIsNotValid",a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(L||(e.ExtensionSignatureVerificationCode=L={}));class k extends Error{constructor(f){super(f),this.code=f}}e.$qq=k;let g=class{constructor(f,c){this.b=f,this.c=c}d(){return this.a||(this.a=new Promise((f,c)=>Y(["@vscode/vsce-sign"],async h=>f(h),c))),this.a}async verify(f,c,h,p){let y;const R=f.identifier.id;try{y=await this.d()}catch(A){return this.b.error("Could not load vsce-sign module",(0,S.$9)(A)),this.b.info(`Extension signature verification is not done: ${R}`),!1}const E=new Date().getTime();let d;try{this.b.trace(`Verifying extension signature for ${R}...`),d=await y.verify(c,h,this.b.getLevel()===$.LogLevel.Trace)}catch(A){d={code:L.UnknownError,didExecute:!1,output:(0,S.$9)(A)}}const m=new Date().getTime()-E;if(this.b.info(`Extension signature verification result for ${R}: ${d.code}. Executed: ${d.didExecute}. Duration: ${m}ms.`),this.b.trace(`Extension signature verification output for ${R}:
${d.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:R,extensionVersion:f.version,code:d.code,internalCode:d.internalCode,duration:m,didExecute:d.didExecute,clientTargetPlatform:p}),d.code===L.Success)return!0;throw new k(d.code)}};e.$rq=g,e.$rq=g=ve([se(0,$.$9j),se(1,I.$8l)],g)}),define(le[41],ue([0,1,26,3,67,70,18]),function(Y,e,S,P,$,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=void 0,e.$Ap=f,e.$Bp=c,e.$Cp=h,e.$Dp=p,e.$Ep=R,e.$Fp=d,e.$Gp=m,e.$Hp=i;class k{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$tp=k;class g{constructor(){this.telemetryLevel=L.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$up=g,e.$vp=new g;class a{async publicLog(n,r,t){}async publicLogError(n,r,t){}}e.$wp=a,e.$xp="telemetry",e.$yp="extensionTelemetryLog",e.$zp={log:()=>null,flush:()=>Promise.resolve(null)};function f(l,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!l.enableTelemetry)}function c(l,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||l.enableTelemetry&&l.aiConfig?.ariaKey)}function h(l){const n=l.getValue(L.$em),r=l.getValue(L.$fm);if(l.getValue(L.$gm)===!1||r===!1)return L.TelemetryLevel.NONE;switch(n??L.TelemetryConfiguration.ON){case L.TelemetryConfiguration.ON:return L.TelemetryLevel.USAGE;case L.TelemetryConfiguration.ERROR:return L.TelemetryLevel.ERROR;case L.TelemetryConfiguration.CRASH:return L.TelemetryLevel.CRASH;case L.TelemetryConfiguration.OFF:return L.TelemetryLevel.NONE}}function p(l){const n={},r={},t={};E(l,t);for(let s in t){s=s.length>150?s.substr(s.length-149):s;const o=t[s];typeof o=="number"?r[s]=o:typeof o=="boolean"?r[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),n[s]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(n[s]=o)}return{properties:n,measurements:r}}const y=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function R(l){if(!l)return"none";const n=(0,$.$en)(l);return y.has(n)?n:"other"}function E(l,n,r=0,t){if(l)for(const s of Object.getOwnPropertyNames(l)){const o=l[s],u=t?t+s:s;Array.isArray(o)?n[u]=(0,S.$fo)(o):o instanceof Date?n[u]=o.toISOString():(0,P.$eg)(o)?r<2?E(o,n,r+1,u+"."):n[u]=(0,S.$fo)(o):n[u]=o}}function d(l,n){const r=l.msftInternalDomains||[],t=n.getValue("telemetry.internalTesting");return(0,I.$sp)(r)||t}function m(l){return[l.appRoot,l.extensionsPath,l.userHome.fsPath,l.tmpDir.fsPath,l.userDataPath]}function A(l,n){if(!l||!l.includes("/")&&!l.includes("\\"))return l;let r=l;const t=[];for(const v of n)for(;;){const N=v.exec(l);if(!N)break;t.push([N.index,v.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(r="";;){const v=o.exec(l);if(!v)break;const N=t.some(([T,O])=>v.index<O&&T<o.lastIndex);!s.test(v[0])&&!N&&(r+=l.substring(u,v.index)+"<REDACTED: user-file-path>",u=o.lastIndex)}return u<l.length&&(r+=l.substr(u)),r}function w(l){if(!l)return l;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(l))return`<REDACTED: ${r.label}>`;return l}function i(l,n){return(0,S.$co)(l,r=>{if(r instanceof k||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let t=r.replaceAll("%20"," ");t=A(t,n);for(const s of n)t=t.replace(s,"");return t=w(t),t}})}}),define(le[25],ue([0,1,31,20,22,12,11,7,36,41]),function(Y,e,S,P,$,I,L,k,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Jp=void 0,e.$Ip=f,e.$Kp=y,e.$Lp=R,e.$Mp=E,e.$Np=d,e.$Op=m,e.$Pp=A,e.$Qp=w,e.$Sp=i,e.$Tp=n;function f(r,t){return r.uuid&&t.uuid?r.uuid===t.uuid:r.id===t.id?!0:(0,S.$yf)(r.id,t.id)===0}const c=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class h{static create(t){const s=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new h(t.identifier,s,o)}static parse(t){const s=c.exec(t);return s&&s[1]&&s[2]?new h({id:s[1]},s[2],s[4]||void 0):null}constructor(t,s,o=$.TargetPlatform.UNDEFINED){this.identifier=t,this.version=s,this.targetPlatform=o,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==$.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof h?f(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$Jp=h;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(r){const t=p.exec(r);return t&&t[1]?[E(t[1]),t[2]]:[E(r),void 0]}function R(r,t){return`${r}.${t}`}function E(r){return r.toLowerCase()}function d(r,t){return E(R(r??$.$jn,t))}function m(r,t){const s=[],o=u=>{for(const v of s)if(v.some(N=>f(t(N),t(u))))return v;return null};for(const u of r){const v=o(u);v?v.push(u):s.push([u])}return s}function A(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}function w(r){return{id:new a.$tp(r.identifier.id),name:new a.$tp(r.name),version:r.version,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$Rp=new $.$nn("pprice.better-merge");function i(r,t){const s=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const u=o.shift();if(u&&s.every(v=>!f(v.identifier,{id:u}))){const v=r.filter(N=>f(N.identifier,{id:u}));v.length===1&&(s.push(v[0]),o.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function l(r,t){if(!I.$l)return!1;let s;try{s=(await r.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await r.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){t.debug("Error while getting the os-release file.",(0,k.$9)(u))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(r,t){const s=await l(r,t),o=(0,P.$dp)(s?"alpine":I.$v,g.$dc);return t.debug("ComputeTargetPlatform:",o),o}}),define(le[123],ue([0,1,21,7,14,16,45,11,5,20,25,22]),function(Y,e,S,P,$,I,L,k,g,a,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=void 0;const h=R=>(0,g.localize)(11302,null,R),p=(0,g.localize)(11303,null,"ms-dotnettools.csharp");let y=class{constructor(E,d,m){this.a=E,this.b=d,this.d=m}get f(){}async listExtensions(E,d,m){let A=await this.b.getInstalled(c.ExtensionType.User,m);const w=c.$mn.map(l=>l.toLowerCase());if(d&&d!==""){if(w.indexOf(d.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}A=A.filter(l=>l.manifest.categories?l.manifest.categories.map(r=>r.toLowerCase()).indexOf(d.toLowerCase())>-1:!1)}else if(d===""){this.a.info("Possible Categories: "),w.forEach(l=>{this.a.info(l)});return}this.f&&this.a.info((0,g.localize)(11304,null,this.f)),A=A.sort((l,n)=>l.identifier.id.localeCompare(n.identifier.id));let i;for(const l of A)i!==l.identifier.id&&(i=l.identifier.id,this.a.info(E?`${i}@${l.manifest.version}`:i))}async installExtensions(E,d,m,A){const w=[];try{E.length&&this.a.info(this.f?(0,g.localize)(11305,null,this.f):(0,g.localize)(11306,null));const i=[],l=[],n=(t,s,o)=>{l.push({id:t,version:s!=="prerelease"?s:void 0,installOptions:{...m,isBuiltin:o,installPreReleaseVersion:s==="prerelease"||m.installPreReleaseVersion}})};for(const t of E)if(t instanceof k.URI)i.push({vsix:t,installOptions:m});else{const[s,o]=(0,f.$Kp)(t);n(s,o,!1)}for(const t of d)if(t instanceof k.URI)i.push({vsix:t,installOptions:{...m,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[s,o]=(0,f.$Kp)(t);n(s,o,!0)}const r=await this.b.getInstalled(void 0,m.profileLocation);if(i.length&&await Promise.all(i.map(async({vsix:t,installOptions:s})=>{try{await this.h(t,s,A,r)}catch(o){this.a.error(o),w.push(t.toString())}})),l.length){const t=await this.g(l,r,A);w.push(...t)}}catch(i){throw this.a.error((0,g.localize)(11307,null,(0,P.$9)(i))),i}if(w.length)throw new Error((0,g.localize)(11308,null,w.join(", ")))}async updateExtensions(E){const d=await this.b.getInstalled(c.ExtensionType.User,E),m=[];for(const l of d)l.identifier.uuid&&m.push({...l.identifier,preRelease:l.preRelease});this.a.trace((0,g.localize)(11309,null,m.length));const A=await this.d.getExtensions(m,{compatible:!0},S.CancellationToken.None),w=[];for(const l of A)for(const n of d)(0,f.$Ip)(n.identifier,l.identifier)&&(0,L.gt)(l.version,n.manifest.version)&&w.push({extension:l,options:{operation:a.InstallOperation.Update,installPreReleaseVersion:n.preRelease,profileLocation:E,isApplicationScoped:n.isApplicationScoped}});if(!w.length){this.a.info((0,g.localize)(11310,null));return}this.a.info((0,g.localize)(11311,null,w.map(l=>l.extension.identifier.id).join(", ")));const i=await this.b.installGalleryExtensions(w);for(const l of i)l.error?this.a.error((0,g.localize)(11312,null,l.identifier.id,(0,P.$9)(l.error))):this.a.info((0,g.localize)(11313,null,l.identifier.id,l.local?.manifest.version))}async g(E,d,m){if(E=E.filter(({id:l,version:n})=>{const r=d.find(t=>(0,f.$Ip)(t.identifier,{id:l}));if(r){if(!m&&(!n||n==="prerelease"&&r.preRelease))return this.a.info((0,g.localize)(11314,null,l,r.manifest.version,l)),!1;if(n&&r.manifest.version===n)return this.a.info((0,g.localize)(11315,null,`${l}@${n}`)),!1}return!0}),!E.length)return[];const A=[],w=[],i=await this.j(E);if(await Promise.all(E.map(async({id:l,version:n,installOptions:r})=>{const t=i.get(l.toLowerCase());if(!t){this.a.error(`${h(n?`${l}@${n}`:l)}
${p}`),A.push(l);return}try{const o=await this.d.getManifest(t,S.CancellationToken.None);if(o&&!this.k(o))return}catch(o){this.a.error(o.message||o.stack||o),A.push(l);return}const s=d.find(o=>(0,f.$Ip)(o.identifier,t.identifier));if(s){if(t.version===s.manifest.version){this.a.info((0,g.localize)(11316,null,n?`${l}@${n}`:l));return}this.a.info((0,g.localize)(11317,null,l,t.version))}r.isBuiltin?this.a.info(n?(0,g.localize)(11318,null,l,n):(0,g.localize)(11319,null,l)):this.a.info(n?(0,g.localize)(11320,null,l,n):(0,g.localize)(11321,null,l)),w.push({extension:t,options:{...r,installGivenVersion:!!n,isApplicationScoped:s?.isApplicationScoped}})})),w.length){const l=await this.b.installGalleryExtensions(w);for(const n of l)n.error?(this.a.error((0,g.localize)(11322,null,n.identifier.id,(0,P.$9)(n.error))),A.push(n.identifier.id)):this.a.info((0,g.localize)(11323,null,n.identifier.id,n.local?.manifest.version))}return A}async h(E,d,m,A){const w=await this.b.getManifest(E);if(!w)throw new Error("Invalid vsix");if(await this.l(w,m,d.profileLocation,A))try{await this.b.install(E,d),this.a.info((0,g.localize)(11324,null,(0,I.$ah)(E)))}catch(l){if((0,P.$3)(l))this.a.info((0,g.localize)(11325,null,(0,I.$ah)(E)));else throw l}}async j(E){const d=new Map,m=E.some(i=>i.installOptions.installPreReleaseVersion),A=await this.b.getTargetPlatform(),w=[];for(const i of E)a.$8o.test(i.id)&&w.push({...i,preRelease:m});if(w.length){const i=await this.d.getExtensions(w,{targetPlatform:A},S.CancellationToken.None);for(const l of i)d.set(l.identifier.id.toLowerCase(),l)}return d}k(E){return!0}async l(E,d,m,A){if(!d){const w={id:(0,f.$Np)(E.publisher,E.name)},i=A.find(l=>(0,f.$Ip)(w,l.identifier)&&(0,L.gt)(l.manifest.version,E.version));if(i)return this.a.info((0,g.localize)(11326,null,i.identifier.id,i.manifest.version,E.version)),!1}return this.k(E)}async uninstallExtensions(E,d,m){const A=async i=>{if(i instanceof k.URI){const l=await this.b.getManifest(i);return(0,f.$Lp)(l.publisher,l.name)}return i},w=[];for(const i of E){const l=await A(i),r=(await this.b.getInstalled(void 0,m)).filter(t=>(0,f.$Ip)(t.identifier,{id:l}));if(!r.length)throw new Error(`${this.m(l)}
${p}`);if(r.some(t=>t.type===c.ExtensionType.System)){this.a.info((0,g.localize)(11327,null,l));return}if(!d&&r.some(t=>t.isBuiltin)){this.a.info((0,g.localize)(11328,null,l));return}this.a.info((0,g.localize)(11329,null,l));for(const t of r)await this.b.uninstall(t,{profileLocation:m}),w.push(t);this.f?this.a.info((0,g.localize)(11330,null,l,this.f)):this.a.info((0,g.localize)(11331,null,l))}}async locateExtension(E){const d=await this.b.getInstalled();E.forEach(m=>{d.forEach(A=>{if(A.identifier.id===m&&A.location.scheme===$.Schemas.file){this.a.info(A.location.fsPath);return}})})}m(E){return this.f?(0,g.localize)(11332,null,E,this.f):(0,g.localize)(11333,null,E)}};e.$sq=y,e.$sq=y=ve([se(1,a.$kp),se(2,a.$hp)],y)}),define(le[124],ue([0,1,7,4,2,30,25,22,9]),function(Y,e,S,P,$,I,L,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;class a extends $.$Tc{constructor(c,h,p,y,R,E,d){super(),this.f=c,this.g=h,this.h=p,this.j=y,this.m=R,this.n=E,this.r=d,this.a=this.B(new P.$je),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new $.$3c),this.s().then(null,m=>d.error("Error while initializing Extensions Watcher",(0,S.$9)(m)))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(c=>this.u(c.added))),this.B(this.j.onAddExtensions(c=>this.w(c))),this.B(this.j.onDidAddExtensions(c=>this.y(c))),this.B(this.j.onRemoveExtensions(c=>this.z(c))),this.B(this.j.onDidRemoveExtensions(c=>this.C(c))),this.B(this.n.onDidFilesChange(c=>this.D(c)))}async u(c){try{c.length&&await Promise.all(c.map(h=>(this.c.set(h.id,(0,$.$Qc)(this.n.watch(this.m.extUri.dirname(h.extensionsResource)),this.n.watch(h.extensionsResource))),this.G(h.extensionsResource))))}catch(h){throw this.r.error(h),h}}async w(c){for(const h of c.extensions)this.I(this.L(h.identifier,h.version),c.profileLocation)}async y(c){for(const h of c.extensions){const p=this.L(h.identifier,h.version);c.error?this.J(p,c.profileLocation):this.I(p,c.profileLocation)}}async z(c){for(const h of c.extensions)this.J(this.L(h.identifier,h.version),c.profileLocation)}async C(c){const h=[],p=[];for(const y of c.extensions){const R=this.L(y.identifier,y.version);c.error?this.I(R,c.profileLocation):(this.J(R,c.profileLocation),this.b.has(R)||(this.r.debug("Extension is removed from all profiles",y.identifier.id,y.version),p.push(this.f.scanInstalledExtensionAtLocation(y.location).then(E=>{E?h.push(E):this.r.info("Extension not found at the location",y.location.toString())},E=>this.r.error(E)))))}try{await Promise.all(p),h.length&&await this.H(h)}catch(y){this.r.error(y)}}D(c){for(const h of this.h.profiles)c.contains(h.extensionsResource,g.FileChangeType.UPDATED,g.FileChangeType.ADDED)&&this.F(h.extensionsResource)}async F(c){const h=[],p=[],y=await this.j.scanProfileExtensions(c),R=new Set,E=new Set;for(const[d,m]of this.b)m.has(c)&&E.add(d);for(const d of y){const m=this.L(d.identifier,d.version);R.add(m),E.has(m)||(h.push(d.identifier),this.I(m,c))}for(const d of E)if(!R.has(d)){const m=this.M(d);m&&(p.push(m.identifier),this.J(d,c))}(h.length||p.length)&&this.a.fire({added:h.length?{extensions:h,profileLocation:c}:void 0,removed:p.length?{extensions:p,profileLocation:c}:void 0})}async G(c){const h=await this.j.scanProfileExtensions(c);for(const p of h)this.I(this.L(p.identifier,p.version),c)}async H(c){c||(c=(await this.f.scanAllUserInstalledExtensions()).filter(p=>!this.b.has(this.L(p.identifier,p.manifest.version)))),c.length&&await this.f.markAsUninstalled(...c)}I(c,h){let p=this.b.get(c);p||this.b.set(c,p=new I.$Ac(y=>this.m.extUri.getComparisonKey(y))),p.add(h)}J(c,h){const p=this.b.get(c);p&&p.delete(h),p?.size||this.b.delete(c)}L(c,h){return`${k.$nn.toKey(c.id)}@${h}`}M(c){const[h,p]=(0,L.$Kp)(c);return p?{identifier:{id:h},version:p}:void 0}}e.$Tq=a}),define(le[125],ue([0,1,32,152,19,8,2,14,15,28,17,20,25,6,68,11]),function(Y,e,S,P,$,I,L,k,g,a,f,c,h,p,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0r=void 0,S=ye(S);let E=class extends y.$9r{constructor(w,i,l,n){super(l),this.h=w,this.j=n,this.g=this.B(new d(i,n)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri(w,i){const n=(await this.g.getLanguagePacks())[i];if(!n){this.j.warn(`No language pack found for ${i}`);return}const r=n.translations[w];return r?R.URI.file(r):void 0}async getInstalledLanguages(){const w=await this.g.getLanguagePacks(),i=Object.keys(w).map(l=>{const n=w[l];return{...this.f(l,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return i.push(this.f("en","English")),i.sort((l,n)=>l.label.localeCompare(n.label)),i}async m(w){w&&w.manifest&&w.manifest.contributes&&w.manifest.contributes.localizations&&w.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",w.identifier.id),await this.update())}async n(w){const i=await this.g.getLanguagePacks();Object.keys(i).some(l=>i[l]&&i[l].extensions.some(n=>(0,h.$Ip)(n.extensionIdentifier,w.identifier)))&&(this.j.info("Removing language packs from the extension",w.identifier.id),await this.update())}async update(){const[w,i]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),l=await this.g.update(i);return!(0,$.$tb)(Object.keys(w),Object.keys(l))}};e.$0r=E,e.$0r=E=ve([se(0,c.$kp),se(1,f.$Ki),se(2,c.$hp),se(3,p.$9j)],E);let d=class extends L.$Tc{constructor(w,i){super(),this.j=i,this.c={},this.f=(0,g.$ic)(w.userDataPath,"languagepacks.json"),this.g=new I.$Jh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(w){return this.s(i=>{Object.keys(i).forEach(l=>delete i[l]),this.m(i,...w)}).then(()=>this.c)}m(w,...i){for(const l of i)l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&this.n(w,l);Object.keys(w).forEach(l=>this.r(w[l]))}n(w,i){const l=i.identifier,n=i.manifest.contributes&&i.manifest.contributes.localizations?i.manifest.contributes.localizations:[];for(const r of n)if(i.location.scheme===k.Schemas.file&&m(r)){let t=w[r.languageId];t||(t={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},w[r.languageId]=t);const s=t.extensions.filter(o=>(0,h.$Ip)(o.extensionIdentifier,l))[0];s?s.version=i.manifest.version:t.extensions.push({extensionIdentifier:l,version:i.manifest.version});for(const o of r.translations)t.translations[o.id]=(0,g.$ic)(i.location.fsPath,o.path)}}r(w){if(w){const i=(0,P.createHash)("md5");for(const l of w.extensions)i.update(l.extensionIdentifier.uuid||l.extensionIdentifier.id).update(l.version);w.hash=i.digest("hex")}}s(w=()=>null){return this.g.queue(()=>{let i=null;return S.promises.readFile(this.f,"utf8").then(void 0,l=>l.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(l)).then(l=>{try{return JSON.parse(l)}catch{return{}}}).then(l=>(i=w(l),l)).then(l=>{for(const r of Object.keys(l))l[r]||delete l[r];this.c=l,this.h=!0;const n=JSON.stringify(this.c);return this.j.debug("Writing language packs",n),a.Promises.writeFile(this.f,n)}).then(()=>i,l=>this.j.error(l))})}};d=ve([se(0,f.$Ki),se(1,p.$9j)],d);function m(A){if(typeof A.languageId!="string"||!Array.isArray(A.translations)||A.translations.length===0)return!1;for(const w of A.translations)if(typeof w.id!="string"||typeof w.path!="string")return!1;return!(A.languageName&&typeof A.languageName!="string"||A.localizedLanguageName&&typeof A.localizedLanguageName!="string")}}),define(le[126],ue([0,1,81,7,26,41]),function(Y,e,S,P,$,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bR=void 0;const L="https://mobile.events.data.microsoft.com/OneCollector/1.0",k="https://mobile.events.data.microsoft.com/ping";async function g(f,c,h){const p=await(0,S.$qE)("@microsoft/1ds-core-js","dist/ms.core.js"),y=await(0,S.$qE)("@microsoft/1ds-post-js","dist/ms.post.js"),R=new p.AppInsightsCore,E=new y.PostChannel,d={instrumentationKey:f,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[E]]};if(h){d.extensionConfig={};const m={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:h};d.extensionConfig[E.identifier]=m}return R.initialize(d,[]),R.addTelemetryInitializer(m=>{m.ext=m.ext??{},m.ext.web=m.ext.web??{},m.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',c&&(m.ext.utc=m.ext.utc??{},m.ext.utc.flags=8462029)}),R}class a{constructor(c,h,p,y,R){this.e=c,this.f=h,this.g=p,this.h=R,this.c=L,this.d=k,this.g||(this.g={}),typeof y=="function"?this.a=y():this.a=y,this.b=null}i(c){if(this.a){if(typeof this.a!="string"){c(this.a);return}this.b||(this.b=g(this.a,this.e,this.h)),this.b.then(h=>{c(h)},h=>{(0,P.$Y)(h),console.error(h)})}}log(c,h){if(!this.a)return;h=(0,$.$do)(h,this.g),h=(0,I.$Dp)(h);const p=this.f+"/"+c;try{this.i(y=>{y.pluginVersionString=h?.properties.version??"Unknown",y.track({name:p,baseData:{name:p,properties:h?.properties,measurements:h?.measurements}})})}catch{}}flush(){return this.a?new Promise(c=>{this.i(h=>{h.unload(!0,()=>{this.a=void 0,c(void 0)})})}):Promise.resolve(void 0)}}e.$bR=a});var qe=this&&this.__importDefault||function(Y){return Y&&Y.__esModule?Y:{default:Y}};define(le[127],ue([0,1,2,26,12,31,5,29,40,128,33,37,18,41]),function(Y,e,S,P,$,I,L,k,g,a,f,c,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ds=void 0,a=qe(a);let y=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(d,m,A){this.k=m,this.l=A,this.d={},this.i=new S.$Sc,this.j=[],this.b=d.appenders,this.c=d.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=d.piiPaths||[],this.g=h.TelemetryLevel.USAGE,this.h=!!d.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const w of this.f)this.j.push(new RegExp((0,I.$ff)(w),"gi")),w.indexOf("\\")>=0&&this.j.push(new RegExp((0,I.$ff)(w.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(w=>{(w.affectsConfiguration(h.$em)||w.affectsConfiguration(h.$gm)||w.affectsConfiguration(h.$fm))&&this.m()}))}setExperimentProperty(d,m){this.d[d]=m}m(){let d=(0,p.$Cp)(this.k);const m=this.l.enabledTelemetryLevels;if(m){this.h=this.sendErrorTelemetry?m.error:!1;const A=m.usage?h.TelemetryLevel.USAGE:m.error?h.TelemetryLevel.ERROR:h.TelemetryLevel.NONE;d=Math.min(d,A)}this.g=d}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(d,m,A){this.g<m||(A=(0,P.$do)(A,this.d),A=(0,p.$Hp)(A,this.j),A=(0,P.$do)(A,this.c),this.b.forEach(w=>w.log(d,A)))}publicLog(d,m){this.n(d,h.TelemetryLevel.USAGE,m)}publicLog2(d,m){this.publicLog(d,m)}publicLogError(d,m){this.h&&this.n(d,h.TelemetryLevel.ERROR,m)}publicLogError2(d,m){this.publicLogError(d,m)}};e.$ds=y,e.$ds=y=ve([se(1,k.$9i),se(2,f.$pk)],y);function R(){const E=(0,L.localize)(11031,null,a.default.nameLong),d=a.default.privacyStatementUrl?(0,L.localize)(11033,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,L.localize)(11032,null,"https://aka.ms/vscode-telemetry"),m=$.$p?"":(0,L.localize)(11034,null),A=(0,L.localize)(11035,null),w=(0,L.localize)(11036,null),i=(0,L.localize)(11037,null),l=(0,L.localize)(11038,null),n=`
|       | ${A} | ${w} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,L.localize)(11039,null);return`
${E} ${d} ${m}

&nbsp;

${l}
${n}

&nbsp;

${r}
`}c.$no.as(g.$so.Configuration).registerConfiguration({id:h.$dm,order:1,type:"object",title:(0,L.localize)(11040,null),properties:{[h.$em]:{type:"string",enum:[h.TelemetryConfiguration.ON,h.TelemetryConfiguration.ERROR,h.TelemetryConfiguration.CRASH,h.TelemetryConfiguration.OFF],enumDescriptions:[(0,L.localize)(11041,null),(0,L.localize)(11042,null),(0,L.localize)(11043,null),(0,L.localize)(11044,null)],markdownDescription:R(),default:h.TelemetryConfiguration.ON,restricted:!0,scope:g.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),c.$no.as(g.$so.Configuration).registerConfiguration({id:h.$dm,order:110,type:"object",title:(0,L.localize)(11045,null),properties:{[h.$gm]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,L.localize)(11047,null,a.default.nameLong,a.default.privacyStatementUrl):(0,L.localize)(11046,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(11048,null,`\`#${h.$em}#\``),scope:g.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(le[129],ue([0,1,13,21,153,126]),function(Y,e,S,P,$,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cR=void 0,$=ye($);async function L(f,c){const h=await c.request(f,P.CancellationToken.None),p=(await(0,S.$Xe)(h.stream)).toString(),y=h.res.statusCode??200;return{headers:h.res.headers,statusCode:y,responseData:p}}async function k(f){const c={method:f.type,headers:f.headers};return new Promise((p,y)=>{const R=$.request(f.url??"",c,E=>{E.on("data",function(d){p({headers:E.headers,statusCode:E.statusCode??200,responseData:d.toString()})}),E.on("error",function(d){y(d)})});R.write(f.data,E=>{E&&y(E)}),R.end()})}async function g(f,c,h){const p=typeof c.data=="string"?c.data:new TextDecoder().decode(c.data),y={type:"POST",headers:{...c.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(c.data).toString()},url:c.urlString,data:p};try{const R=f?await L(y,f):await k(y);h(R.statusCode,R.headers,R.responseData)}catch{h(0,{})}}class a extends I.$bR{constructor(c,h,p,y,R){const E={sendPOST:(d,m)=>{g(c,d,m)}};super(h,p,y,R,E)}}e.$cR=a}),define(le[130],ue([0,1,32,15,28]),function(Y,e,S,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=I,S=ye(S);async function I(L,k){const g=Object.create(null),a=(c,h)=>{const p=JSON.parse(c);g[h]=p};if(k){const c=[],h=await $.Promises.readdir(k);for(const y of h)try{(await S.promises.stat((0,P.$ic)(k,y))).isDirectory()&&c.push(y)}catch{}const p=[];for(const y of c)(await $.Promises.readdir((0,P.$ic)(k,y))).filter(E=>E==="telemetry.json").length===1&&p.push(y);for(const y of p){const R=(await S.promises.readFile((0,P.$ic)(k,y,"telemetry.json"))).toString();a(R,y)}}let f=(await S.promises.readFile((0,P.$ic)(L,"telemetry-core.json"))).toString();return a(f,"vscode-core"),f=(await S.promises.readFile((0,P.$ic)(L,"telemetry-extensions.json"))).toString(),a(f,"vscode-extensions"),JSON.stringify(g,null,4)}}),define(le[131],ue([0,1,12,83,18]),function(Y,e,S,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xgc=I,e.$ygc=L,e.$zgc=k;async function I(g,a){let f=g.getItem($.$am);return(typeof f!="string"||S.$k&&f==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(f=await(0,P.$Pn)(a.error.bind(a))),f}async function L(g,a){let f=g.getItem($.$bm);return typeof f!="string"&&(f=await(0,P.$Qn)(a.error.bind(a))),f}async function k(g,a){let f=g.getItem($.$cm);return typeof f!="string"&&(f=await(0,P.$Rn)(a.error.bind(a))),f}}),define(le[23],ue([0,1,10]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=void 0,e.$Gl=(0,S.$Ci)("IUriIdentityService")}),define(le[132],ue([0,1,23,97,9,16,79,4,2]),function(Y,e,S,P,$,I,L,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=void 0;class a{static{this._clock=0}constructor(h){this.uri=h,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let f=class{constructor(h){this.g=h,this.c=new g.$Sc,this.f=2**16;const p=new Map,y=R=>{let E=p.get(R.scheme);return E===void 0&&(E=h.hasProvider(R)&&!this.g.hasCapability(R,$.FileSystemProviderCapabilities.PathCaseSensitive),p.set(R.scheme,E)),E};this.c.add(k.Event.any(h.onDidChangeFileSystemProviderRegistrations,h.onDidChangeFileSystemProviderCapabilities)(R=>{p.delete(R.scheme)})),this.extUri=new I.$5g(y),this.d=new L.$Ps((R,E)=>this.extUri.compare(R,E,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(h){this.g.hasProvider(h)&&(h=(0,I.$eh)(h));const p=this.d.get(h);return p?p.touch().uri.with({fragment:h.fragment}):(this.d.set(h,new a(h)),this.h(),h)}h(){if(this.d.size<this.f)return;const h=[...this.d.entries()].sort((y,R)=>y[1].time<R[1].time?1:y[1].time>R[1].time?-1:0);a._clock=0,this.d.clear();const p=this.f*.5;for(let y=0;y<p;y++)this.d.set(h[y][0],h[y][1].touch())}};e.$Qs=f,e.$Qs=f=ve([se(0,$.$9k)],f),(0,P.$Ns)(S.$Gl,f,P.InstantiationType.Delayed)}),define(le[133],ue([0,1,4,2,9,49,30]),function(Y,e,S,P,$,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=void 0;class k extends P.$Tc{constructor(a,f,c,h,p,y){super(),this.f=a,this.g=f,this.h=c,this.j=h,this.m=p,this.n=y,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new S.$je),this.onDidChangeFile=this.a.event,this.b=I.$Ii.forUris(()=>!(this.capabilities&$.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new L.$Ac(R=>this.m.extUri.getComparisonKey(this.t(R))),this.r(),this.B(h.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(R=>this.s(R)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,f){return this.g.open(this.t(a),f)}close(a){return this.g.close(a)}read(a,f,c,h,p){return this.g.read(a,f,c,h,p)}write(a,f,c,h,p){return this.g.write(a,f,c,h,p)}watch(a,f){this.b.set(a,a);const c=this.g.watch(this.t(a),f);return(0,P.$Rc)(()=>{this.b.delete(a),c.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,f,c){return this.g.rename(this.t(a),this.t(f),c)}readFile(a,f){return this.g.readFile(this.t(a),f)}readFileStream(a,f,c){return this.g.readFileStream(this.t(a),f,c)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,f,c){return this.g.writeFile(this.t(a),f,c)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,f){return this.g.delete(this.t(a),f)}copy(a,f,c){if((0,$.$al)(this.g))return this.g.copy(this.t(a),this.t(f),c);throw new Error("copy not supported")}cloneFile(a,f){if((0,$.$bl)(this.g))return this.g.cloneFile(this.t(a),this.t(f));throw new Error("clone not supported")}s(a){const f=[];for(const c of a){if(c.resource.scheme!==this.f)continue;const h=this.u(c.resource);this.b.findSubstr(h)&&f.push({resource:h,type:c.type,cId:c.cId})}f.length&&(this.n.debug("User data changed"),this.a.fire(f))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$Xgc=k}),define(le[134],ue([0,1,5,15,49,16,11,10,14]),function(Y,e,S,P,$,I,L,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Wi=e.$Vi=e.WorkbenchState=e.$Pi=e.$Oi=e.$Li=void 0,e.$Mi=a,e.$Ni=f,e.$Qi=c,e.$Ri=h,e.$Si=p,e.$Ti=R,e.$Ui=E,e.$Xi=A,e.$3i=w,e.$4i=i,e.$6i=l,e.$7i=n,e.$8i=r,e.$Li=(0,k.$Ci)("contextService");function a(t){const s=t;return typeof s?.id=="string"&&L.URI.isUri(s.uri)}function f(t){return typeof t?.id=="string"&&!a(t)&&!h(t)}e.$Oi={id:"ext-dev"},e.$Pi={id:"empty-window"};function c(t,s){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,P.$mc)(t)}:s?e.$Oi:e.$Pi;const o=t;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function h(t){const s=t;return typeof s?.id=="string"&&L.URI.isUri(s.configPath)}function p(t){const s=t;if(s?.uri)return{id:s.id,uri:L.URI.revive(s.uri)};const o=t;if(o?.configPath)return{id:o.id,configPath:L.URI.revive(o.configPath)};if(t?.id)return{id:t.id}}var y;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(y||(e.WorkbenchState=y={}));function R(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function E(t){const s=t;return!!(s&&typeof s=="object"&&L.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class d{constructor(s,o,u,v,N){this.h=s,this.j=u,this.k=v,this.l=N,this.c=$.$Ii.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=$.$Ii.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Vi=d;class m{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,I.$dh)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Wi=m;function A(t){return new m({uri:t,index:0,name:(0,I.$_g)(t)},{uri:t.toString()})}e.$Yi="code-workspace",e.$Zi=`.${e.$Yi}`,e.$1i=[{name:(0,S.localize)(10864,null),extensions:[e.$Yi]}],e.$2i="workspace.json";function w(t,s){return I.$7g.isEqualOrParent(t,s.untitledWorkspacesHome)}function i(t){let s;return L.URI.isUri(t)?s=t:s=t.configuration,s?.scheme===g.Schemas.tmp}e.$5i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function l(t){return t.id===e.$5i}function n(t,s){return!w(t,s)&&!i(t)}function r(t){return(typeof t=="string"?(0,P.$nc)(t):(0,I.$bh)(t))===e.$Zi}}),define(le[24],ue([0,1,43,4,2,16,11,5,17,9,10,6,134,30,23,8,27,31,3]),function(Y,e,S,P,$,I,L,k,g,a,f,c,h,p,y,R,E,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=e.$Il=e.ProfileResourceType=void 0,e.$Hl=w,e.$Jl=i,e.$Kl=l;var A;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(A||(e.ProfileResourceType=A={}));function w(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&L.URI.isUri(s.location)&&L.URI.isUri(s.globalStorageHome)&&L.URI.isUri(s.settingsResource)&&L.URI.isUri(s.keybindingsResource)&&L.URI.isUri(s.tasksResource)&&L.URI.isUri(s.snippetsHome)&&L.URI.isUri(s.extensionsResource))}e.$Il=(0,f.$Ci)("IUserDataProfilesService");function i(t,s){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:L.URI.revive(t.location).with({scheme:s}),globalStorageHome:L.URI.revive(t.globalStorageHome).with({scheme:s}),settingsResource:L.URI.revive(t.settingsResource).with({scheme:s}),keybindingsResource:L.URI.revive(t.keybindingsResource).with({scheme:s}),tasksResource:L.URI.revive(t.tasksResource).with({scheme:s}),snippetsHome:L.URI.revive(t.snippetsHome).with({scheme:s}),extensionsResource:L.URI.revive(t.extensionsResource).with({scheme:s}),cacheHome:L.URI.revive(t.cacheHome).with({scheme:s}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}function l(t,s,o,u,v,N){return{id:t,name:s,location:o,isDefault:!1,shortName:v?.shortName,icon:v?.icon,globalStorageHome:N&&v?.useDefaultFlags?.globalState?N.globalStorageHome:(0,I.$dh)(o,"globalStorage"),settingsResource:N&&v?.useDefaultFlags?.settings?N.settingsResource:(0,I.$dh)(o,"settings.json"),keybindingsResource:N&&v?.useDefaultFlags?.keybindings?N.keybindingsResource:(0,I.$dh)(o,"keybindings.json"),tasksResource:N&&v?.useDefaultFlags?.tasks?N.tasksResource:(0,I.$dh)(o,"tasks.json"),snippetsHome:N&&v?.useDefaultFlags?.snippets?N.snippetsHome:(0,I.$dh)(o,"snippets"),extensionsResource:N&&v?.useDefaultFlags?.extensions?N.extensionsResource:(0,I.$dh)(o,"extensions.json"),cacheHome:(0,I.$dh)(u,t),useDefaultFlags:v?.useDefaultFlags,isTransient:v?.transient}}let n=class extends $.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,o,u,v){super(),this.t=s,this.u=o,this.w=u,this.y=v,this.f=!0,this.h=this.B(new P.$je),this.onDidChangeProfiles=this.h.event,this.j=this.B(new P.$je),this.onWillCreateProfile=this.j.event,this.m=this.B(new P.$je),this.onWillRemoveProfile=this.m.event,this.n=this.B(new P.$je),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new p.$zc,workspaces:new p.$zc,emptyWindows:new Map},this.profilesHome=(0,I.$dh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,I.$dh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),o=[s];if(this.f)try{for(const N of this.O()){if(!N.name||!(0,m.$cg)(N.name)||!N.location){this.y.warn("Skipping the invalid stored profile",N.location||N.name);continue}o.push(l((0,I.$ah)(N.location),N.name,N.location,this.g,{shortName:N.shortName,icon:N.icon,useDefaultFlags:N.useDefaultFlags},s))}}catch(N){this.y.error(N)}const u=new p.$zc,v=new Map;if(o.length)try{const N=this.Q();if(N.workspaces)for(const[T,O]of Object.entries(N.workspaces)){const D=L.URI.parse(T),q=o.find(K=>K.id===O);q&&u.set(D,q)}if(N.emptyWindows)for(const[T,O]of Object.entries(N.emptyWindows)){const D=o.find(q=>q.id===O);D&&v.set(T,D)}}catch(N){this.y.error(N)}this.z={profiles:o,workspaces:u,emptyWindows:v}}return this.z}D(){const s=l("__default__profile__",(0,k.localize)(10911,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const o="Temp",u=new RegExp(`${(0,d.$ff)(o)}\\s(\\d+)`);let v=0;for(const T of this.profiles){const O=u.exec(T.name),D=O?parseInt(O[1]):0;v=D>v?D:v}const N=`${o} ${v+1}`;return this.createProfile((0,S.$qj)((0,E.$Yg)()).toString(16),N,{transient:!0},s)}async createNamedProfile(s,o,u){return this.createProfile((0,S.$qj)((0,E.$Yg)()).toString(16),s,o,u)}async createProfile(s,o,u,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const N=await this.F(s,o,u);return v&&await this.setProfileForWorkspace(v,N),N}async F(s,o,u){if(!(0,m.$cg)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let v=this.r.get(o);return v||(v=(async()=>{try{if(this.profiles.find(D=>D.name===o||D.id===s))throw new Error(`Profile with ${o} name already exists`);const T=l(s,o,(0,I.$dh)(this.profilesHome,s),this.g,u,this.defaultProfile);await this.u.createFolder(T.location);const O=[];return this.j.fire({profile:T,join(D){O.push(D)}}),await R.Promises.settled(O),this.I([T],[],[]),T}finally{this.r.delete(o)}})(),this.r.set(o,v)),v}async updateProfile(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let u=this.profiles.find(v=>v.id===s.id);if(!u)throw new Error(`Profile '${s.name}' does not exist`);return u=l(u.id,o.name??u.name,u.location,this.g,{shortName:o.shortName??u.shortName,icon:o.icon===null?void 0:o.icon??u.icon,transient:o.transient??u.isTransient,useDefaultFlags:o.useDefaultFlags??u.useDefaultFlags},this.defaultProfile),this.I([],[],[u]),u}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(v=>v.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const u=[];this.m.fire({profile:o,join(v){u.push(v)}});try{await Promise.allSettled(u)}catch(v){this.y.error(v)}for(const v of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(v)?.id&&this.C.emptyWindows.delete(v);for(const v of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(v)?.id&&this.C.workspaces.delete(v);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(v){(0,a.$nl)(v)!==a.FileOperationResult.FILE_NOT_FOUND&&this.y.error(v)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const u=this.profiles.find(v=>v.id===o.id);if(!u)throw new Error(`Profile '${o.name}' does not exist`);this.L(s,u)}unsetWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,o)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(u=>!this.w.extUri.isEqual(u.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.G(s),u=L.URI.isUri(o)?this.C.workspaces.get(o):this.C.emptyWindows.get(o);return u||((0,h.$Mi)(s)?this.s.folders.get(s.uri):(0,h.$Ri)(s)?this.s.workspaces.get(s.configPath):this.s.emptyWindows.get(s.id))}G(s){return(0,h.$Mi)(s)?s.uri:(0,h.$Ri)(s)?s.configPath:s.id}H(s){return!!([...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.folders.values()].some(o=>this.w.extUri.isEqual(o.location,s.location)))}I(s,o,u){const v=[...this.profiles,...s],N=[],T=this.s.profiles;this.s.profiles=[];for(let O of v){if(O.isDefault||o.some(q=>O.id===q.id))continue;O=u.find(q=>O.id===q.id)??O;const D=T.find(q=>O.id===q.id);if(O.isTransient)this.s.profiles.push(O);else{if(D){for(const[q,K]of this.s.emptyWindows.entries())if(O.id===K.id){this.L({id:q},O);break}for(const[q,K]of this.s.workspaces.entries())if(O.id===K.id){this.L({id:"",configPath:q},O);break}for(const[q,K]of this.s.folders.entries())if(O.id===K.id){this.L({id:"",uri:q},O);break}}N.push({location:O.location,name:O.name,shortName:O.shortName,icon:O.icon,useDefaultFlags:O.useDefaultFlags})}}this.P(N),this.z=void 0,this.J(s,o,u)}J(s,o,u){this.h.fire({added:s,removed:o,updated:u,all:this.profiles})}L(s,o,u){if(u=o?.isTransient?!0:u,u)(0,h.$Mi)(s)?(this.s.folders.delete(s.uri),o&&this.s.folders.set(s.uri,o)):(0,h.$Ri)(s)?(this.s.workspaces.delete(s.configPath),o&&this.s.workspaces.set(s.configPath,o)):(this.s.emptyWindows.delete(s.id),o&&this.s.emptyWindows.set(s.id,o));else{this.L(s,void 0,!0);const v=this.G(s);L.URI.isUri(v)?(this.C.workspaces.delete(v),o&&this.C.workspaces.set(v,o)):(this.C.emptyWindows.delete(v),o&&this.C.emptyWindows.set(v,o)),this.M()}}M(){const s={};for(const[u,v]of this.C.workspaces.entries())s[u.toString()]=v.id;const o={};for(const[u,v]of this.C.emptyWindows.entries())o[u.toString()]=v.id;this.R({workspaces:s,emptyWindows:o}),this.z=void 0}N(s){const o={},u=this.D();if(s.workspaces)for(const[N,T]of Object.entries(s.workspaces)){const O=L.URI.parse(T);o[N]=this.w.extUri.isEqual(O,u.location)?u.id:this.w.extUri.basename(O)}const v={};if(s.emptyWindows)for(const[N,T]of Object.entries(s.emptyWindows)){const O=L.URI.parse(T);v[N]=this.w.extUri.isEqual(O,u.location)?u.id:this.w.extUri.basename(O)}return{workspaces:o,emptyWindows:v}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$Ll=n,e.$Ll=n=ve([se(0,g.$Ji),se(1,a.$9k),se(2,y.$Gl),se(3,c.$9j)],n);class r extends n{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$Ml=r}),define(le[53],ue([0,1,19,8,21,7,4,2,12,3,11,5,20,25,22,44,6,33,18,23,24]),function(Y,e,S,P,$,I,L,k,g,a,f,c,h,p,y,R,E,d,m,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Bq=void 0,e.$Cq=l,c=ye(c);let i=class extends k.$Tc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(s,o,u,v,N,T){super(),this.z=s,this.C=o,this.D=u,this.F=v,this.G=N,this.H=T,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new L.$je),this.s=this.B(new L.$je),this.t=this.B(new L.$je),this.u=this.B(new L.$je),this.w=this.B(new L.$je),this.y=[],this.B((0,k.$Rc)(()=>{this.j.forEach(({task:O})=>O.cancel()),this.m.forEach(O=>O.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(s){const o=await this.getTargetPlatform();return s.allTargetPlatforms.some(u=>(0,h.$fp)(u,s.allTargetPlatforms,o))}async installFromGallery(s,o={}){try{const v=(await this.installGalleryExtensions([{extension:s,options:o}])).find(({identifier:N})=>(0,p.$Ip)(N,s.identifier));if(v?.local)return v?.local;throw v?.error?v.error:new h.$jp(`Unknown error while installing extension ${s.identifier.id}`,h.ExtensionManagementErrorCode.Unknown)}catch(u){throw l(u)}}async installGalleryExtensions(s){if(!this.z.isEnabled())throw new h.$jp(c.localize(11336,null),h.ExtensionManagementErrorCode.NotAllowed);const o=[],u=[];return await Promise.allSettled(s.map(async({extension:v,options:N})=>{try{const T=await this.N(v,!!N?.installGivenVersion,!!N?.installPreReleaseVersion,N.productVersion??{version:this.G.version,date:this.G.date});u.push({...T,options:N})}catch(T){o.push({identifier:v.identifier,operation:h.InstallOperation.Install,source:v,error:T,profileLocation:N.profileLocation??this.X()})}})),u.length&&o.push(...await this.I(u)),o}async uninstall(s,o={}){return this.F.trace("ExtensionManagementService#uninstall",s.identifier.id),this.P(s,o)}async toggleAppliationScope(s,o){if((0,y.$qn)(s.manifest)||s.isBuiltin)return s;if(s.isApplicationScoped){let u=await this.updateMetadata(s,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)||(u=await this.$(s,this.H.defaultProfile.extensionsResource,o));for(const v of this.H.profiles){const N=(await this.getInstalled(y.ExtensionType.User,v.extensionsResource)).find(T=>(0,p.$Ip)(T.identifier,s.identifier));N?this.w.fire({local:N,profileLocation:v.extensionsResource}):this.u.fire({identifier:s.identifier,profileLocation:v.extensionsResource})}return u}else{const u=this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(s,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(s,o,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:u.identifier,operation:h.InstallOperation.Install,local:u,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),u}}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.g||s-this.h>1e3*60*5)&&(this.g=this.W(),this.h=s),this.g}registerParticipant(s){this.y.push(s)}async resetPinnedStateForAllUserExtensions(s){try{await this.L(this.H.profiles.map(async o=>{const u=await this.getInstalled(y.ExtensionType.User,o.extensionsResource);await this.L(u.map(async v=>{v.pinned!==s&&await this.updateMetadata(v,{pinned:s},o.extensionsResource)}))}))}catch(o){throw this.F.error("Error while resetting pinned state for all user extensions",(0,I.$9)(o)),o}}async I(s){const o=new Map,u=new Map,v=[],N=(O,D)=>`${p.$Jp.create(O).toString()}-${D.toString()}`,T=(O,D,q,K)=>{const J=this.Y(O,D,q),re=`${(0,p.$Np)(O.publisher,O.name)}-${q.profileLocation.toString()}`;u.set(re,{task:J,root:K}),this.n.fire({identifier:J.identifier,source:D,profileLocation:q.profileLocation}),this.F.info("Installing extension:",J.identifier.id,q),f.URI.isUri(D)||this.j.set(N(D,q.profileLocation),{task:J,waitingTasks:[]})};try{for(const{manifest:O,extension:D,options:q}of s){const K=q.isApplicationScoped||q.isBuiltin||(0,y.$qn)(O),J={...q,installOnlyNewlyAddedFromExtensionPack:q.installOnlyNewlyAddedFromExtensionPack??!f.URI.isUri(D),isApplicationScoped:K,profileLocation:K?this.H.defaultProfile.extensionsResource:q.profileLocation??this.X(),productVersion:q.productVersion??{version:this.G.version,date:this.G.date}},re=f.URI.isUri(D)?void 0:this.j.get(N(D,J.profileLocation));re?(this.F.info("Extension is already requested to install",re.task.identifier.id,J.profileLocation.toString()),v.push(re.task.waitUntilTaskIsFinished())):T(O,D,J,void 0)}return await Promise.all([...u.values()].map(async({task:O})=>{if(O.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",O.identifier.id);else try{const D=await this.M(O.identifier,O.manifest,!!O.options.installOnlyNewlyAddedFromExtensionPack,!!O.options.installPreReleaseVersion,O.options.profileLocation,O.options.productVersion),q=await this.getInstalled(void 0,O.options.profileLocation,O.options.productVersion),K={...O.options,context:{...O.options.context,[h.$_o]:!0}};for(const{gallery:J,manifest:re}of(0,S.$Lb)(D,({gallery:ae})=>ae.identifier.id)){if(u.has(`${J.identifier.id.toLowerCase()}-${K.profileLocation.toString()}`))continue;const ae=this.j.get(N(J,K.profileLocation));if(ae){if(this.J(O,ae.task)){const ce=ae.task.identifier;this.F.info("Waiting for already requested installing extension",ce.id,O.identifier.id,K.profileLocation.toString()),ae.waitingTasks.push(O),v.push(L.Event.toPromise(L.Event.filter(this.onDidInstallExtensions,de=>de.some(H=>(0,p.$Ip)(H.identifier,ce)))).then(de=>{if(this.F.info("Finished waiting for already requested installing extension",ce.id,O.identifier.id,K.profileLocation.toString()),!de.find(Z=>(0,p.$Ip)(Z.identifier,ce))?.local)throw new Error(`Extension ${ce.id} is not installed`)}))}}else q.some(({identifier:ce})=>(0,p.$Ip)(ce,J.identifier))||T(re,J,K,O)}}catch(D){if(f.URI.isUri(O.source))(0,S.$Kb)(O.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",O.identifier.id,D.message),(0,S.$Kb)(O.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",O.identifier.id,D.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",O.identifier.id),D}})),await this.L([...u.entries()].map(async([O,{task:D}])=>{const q=new Date().getTime();let K;try{K=await D.run(),await this.L(this.y.map(J=>J.postInstall(K,D.source,D.options,$.CancellationToken.None)),h.ExtensionManagementErrorCode.PostInstall)}catch(J){const re=l(J);throw f.URI.isUri(D.source)||n(this.C,D.operation===h.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.$Qp)(D.source),error:re,source:D.options.context?.[h.$$o]}),o.set(O,{error:re,identifier:D.identifier,operation:D.operation,source:D.source,context:D.options.context,profileLocation:D.options.profileLocation,applicationScoped:D.options.isApplicationScoped}),this.F.error("Error while installing the extension",D.identifier.id,(0,I.$9)(re),D.options.profileLocation.toString()),re}if(!f.URI.isUri(D.source)){const J=D.operation===h.InstallOperation.Update,re=J?void 0:(new Date().getTime()-D.source.lastUpdated)/1e3;if(n(this.C,J?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.$Qp)(D.source),verificationStatus:D.verificationStatus,duration:new Date().getTime()-q,durationSinceUpdate:re,source:D.options.context?.[h.$$o]}),g.$p&&D.operation!==h.InstallOperation.Update)try{await this.z.reportStatistic(K.manifest.publisher,K.manifest.name,K.manifest.version,h.StatisticType.Install)}catch{}}o.set(O,{local:K,identifier:D.identifier,operation:D.operation,source:D.source,context:D.options.context,profileLocation:D.options.profileLocation,applicationScoped:K.isApplicationScoped})})),v.length&&await this.L(v),[...o.values()]}catch(O){const D=(J,re,ae)=>{const ce=[];J.manifest.extensionDependencies?.length&&ce.push(...J.manifest.extensionDependencies),J.manifest.extensionPack?.length&&ce.push(...J.manifest.extensionPack);for(const de of ce){if(ae.includes(de.toLowerCase()))continue;ae.push(de.toLowerCase());const H=o.get(`${de.toLowerCase()}-${re.toString()}`);H?.local&&(ae=D(H.local,re,ae))}return ae},q=J=>({identifier:J.identifier,operation:h.InstallOperation.Install,source:J.source,context:J.options.context,profileLocation:J.options.profileLocation,error:O}),K=[];for(const[J,{task:re,root:ae}]of u){const ce=o.get(J);ce?ce.local&&ae&&!o.get(`${ae.identifier.id.toLowerCase()}-${re.options.profileLocation.toString()}`)?.local&&(K.push(this.Z(ce.local,{versionOnly:!0,profileLocation:re.options.profileLocation})),o.set(J,q(re))):(re.cancel(),o.set(J,q(re)))}for(const[J,{task:re}]of u){const ae=o.get(J);if(!ae?.local||re.options.donotIncludePackAndDependencies)continue;D(ae.local,re.options.profileLocation,[ae.local.identifier.id.toLowerCase()]).slice(1).some(de=>u.has(`${de.toLowerCase()}-${re.options.profileLocation.toString()}`)&&!o.get(`${de.toLowerCase()}-${re.options.profileLocation.toString()}`)?.local)&&(K.push(this.Z(ae.local,{versionOnly:!0,profileLocation:re.options.profileLocation})),o.set(J,q(re)))}throw K.length&&await Promise.allSettled(K.map(async J=>{try{await J.run(),this.F.info("Rollback: Uninstalled extension",J.extension.identifier.id)}catch(re){this.F.warn("Rollback: Error while uninstalling extension",J.extension.identifier.id,(0,I.$9)(re))}})),O}finally{for(const{task:O}of u.values())O.source&&!f.URI.isUri(O.source)&&this.j.delete(N(O.source,O.options.profileLocation));if(o.size){const O=[...o.values()];for(const D of O)D.local&&this.F.info("Extension installed successfully:",D.identifier.id,D.profileLocation.toString());this.s.fire(O)}}}J(s,o){for(const[,{task:u,waitingTasks:v}]of this.j.entries())if(u===s&&(v.includes(o)||v.some(N=>this.J(N,o)))||u===o&&v[0]&&!this.J(s,v[0]))return!1;return!0}async L(s,o){const u=[],v=[],N=await Promise.allSettled(s);for(const O of N)O.status==="fulfilled"?u.push(O.value):v.push(l(O.reason,o));if(!v.length)return u;if(v.length===1)throw v[0];let T=new h.$jp("",h.ExtensionManagementErrorCode.Unknown);for(const O of v)T=new h.$jp(T.message?`${T.message}, ${O.message}`:O.message,O.code!==h.ExtensionManagementErrorCode.Unknown&&O.code!==h.ExtensionManagementErrorCode.Internal?O.code:T.code);throw T}async M(s,o,u,v,N,T){if(!this.z.isEnabled())return[];const O=await this.getInstalled(void 0,N,T),D=[],q=[],K=async(J,re)=>{D.push(J);const ae=re.extensionDependencies||[],ce=[...ae];if(re.extensionPack){const de=u?O.find(H=>(0,p.$Ip)(H.identifier,J)):void 0;for(const H of re.extensionPack)de&&de.manifest.extensionPack&&de.manifest.extensionPack.some(Z=>(0,p.$Ip)({id:Z},{id:H}))||ce.every(Z=>!(0,p.$Ip)({id:Z},{id:H}))&&ce.push(H)}if(ce.length){const de=ce.filter(H=>D.every(Z=>!(0,p.$Ip)(Z,{id:H})));if(de.length){const H=await this.z.getExtensions(de.map(Z=>({id:Z,preRelease:v})),$.CancellationToken.None);for(const Z of H){if(D.find(G=>(0,p.$Ip)(G,Z.identifier)))continue;const B=ae.some(G=>(0,p.$Ip)({id:G},Z.identifier));let z;try{z=await this.N(Z,!1,v,T)}catch(G){if(B)throw G;this.F.info("Skipping the packed extension as it cannot be installed",Z.identifier.id,(0,I.$9)(G));continue}q.push({gallery:z.extension,manifest:z.manifest}),await K(z.extension.identifier,z.manifest)}}}};return await K(s,o),q}async N(s,o,u,v){let N;const T=await this.getExtensionsControlManifest();if(T.malicious.some(q=>(0,p.$Ip)(s.identifier,q)))throw new h.$jp(c.localize(11337,null,s.identifier.id),h.ExtensionManagementErrorCode.Malicious);const O=T.deprecated[s.identifier.id.toLowerCase()];if(O?.extension?.autoMigrate){if(this.F.info(`The '${s.identifier.id}' extension is deprecated, fetching the compatible '${O.extension.id}' extension instead.`),N=(await this.z.getExtensions([{id:O.extension.id,preRelease:O.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:v},$.CancellationToken.None))[0],!N)throw new h.$jp(c.localize(11338,null,s.identifier.id,O.extension.id),h.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(s)){const q=await this.getTargetPlatform();throw new h.$jp(c.localize(11339,null,s.identifier.id,this.G.nameLong,(0,h.$bp)(q)),h.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(N=await this.O(s,o,u,v),!N){const q=[];throw(0,R.$3p)(s.properties.enabledApiProposals??[],q)?!u&&s.properties.isPreReleaseVersion&&(await this.z.getExtensions([s.identifier],$.CancellationToken.None))[0]?new h.$jp(c.localize(11341,null,s.displayName??s.identifier.id),h.ExtensionManagementErrorCode.ReleaseVersionNotFound):new h.$jp(c.localize(11342,null,s.identifier.id,this.G.nameLong,this.G.version),h.ExtensionManagementErrorCode.Incompatible):new h.$jp(c.localize(11340,null,s.displayName??s.identifier.id,q[0]),h.ExtensionManagementErrorCode.IncompatibleApi)}}this.F.info("Getting Manifest...",N.identifier.id);const D=await this.z.getManifest(N,$.CancellationToken.None);if(D===null)throw new h.$jp(`Missing manifest for extension ${N.identifier.id}`,h.ExtensionManagementErrorCode.Invalid);if(D.version!==N.version)throw new h.$jp(`Cannot install '${N.identifier.id}' extension because of version mismatch in Marketplace`,h.ExtensionManagementErrorCode.Invalid);return{extension:N,manifest:D}}async O(s,o,u,v){const N=await this.getTargetPlatform();let T=null;return!o&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==u&&(T=(await this.z.getExtensions([{...s.identifier,preRelease:u}],{targetPlatform:N,compatible:!0,productVersion:v},$.CancellationToken.None))[0]||null),!T&&await this.z.isExtensionCompatible(s,u,N,v)&&(T=s),T||(o?T=(await this.z.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:N,compatible:!0,productVersion:v},$.CancellationToken.None))[0]||null:T=await this.z.getCompatibleExtension(s,u,N,v)),T}async P(s,o){const u={...o,profileLocation:s.isApplicationScoped?this.H.defaultProfile.extensionsResource:o.profileLocation??this.X()},v=K=>`${K.id.toLowerCase()}${u.versionOnly?`-${s.manifest.version}`:""}${u.profileLocation?`@${u.profileLocation.toString()}`:""}`,N=this.m.get(v(s.identifier));if(N)return this.F.info("Extensions is already requested to uninstall",s.identifier.id),N.waitUntilTaskIsFinished();const T=K=>{const J=this.Z(K,u);return this.m.set(v(J.extension.identifier),J),u.profileLocation?this.F.info("Uninstalling extension from the profile:",`${K.identifier.id}@${K.manifest.version}`,u.profileLocation.toString()):this.F.info("Uninstalling extension:",`${K.identifier.id}@${K.manifest.version}`),this.t.fire({identifier:K.identifier,profileLocation:u.profileLocation,applicationScoped:K.isApplicationScoped}),J},O=(K,J)=>{J?u.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${K.identifier.id}@${K.manifest.version}`,u.profileLocation.toString(),J.message):this.F.error("Failed to uninstall extension:",`${K.identifier.id}@${K.manifest.version}`,J.message):u.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${K.identifier.id}@${K.manifest.version}`,u.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${K.identifier.id}@${K.manifest.version}`),n(this.C,"extensionGallery:uninstall",{extensionData:(0,p.$Pp)(K),error:J}),this.u.fire({identifier:K.identifier,error:J?.code,profileLocation:u.profileLocation,applicationScoped:K.isApplicationScoped})},D=[],q=[];try{D.push(T(s));const K=await this.getInstalled(y.ExtensionType.User,u.profileLocation);if(u.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const J=this.S(s,K);for(const re of J)this.m.has(v(re.identifier))?this.F.info("Extensions is already requested to uninstall",re.identifier.id):D.push(T(re))}u.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.Q(D.map(J=>J.extension),K,s),await this.L(D.map(async J=>{try{if(await J.run(),await this.L(this.y.map(re=>re.postUninstall(J.extension,u,$.CancellationToken.None))),J.extension.identifier.uuid)try{await this.z.reportStatistic(J.extension.manifest.publisher,J.extension.manifest.name,J.extension.manifest.version,h.StatisticType.Uninstall)}catch{}O(J.extension)}catch(re){const ae=l(re);throw O(J.extension,ae),ae}finally{q.push(J)}}))}catch(K){const J=l(K);for(const re of D){try{re.cancel()}catch{}q.includes(re)||O(re.extension,J)}throw J}finally{for(const K of D)this.m.delete(v(K.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",K.extension.identifier.id)}}Q(s,o,u){for(const v of s){const N=this.U(v,o);if(N.length){const T=N.filter(O=>!s.some(D=>(0,p.$Ip)(D.identifier,O.identifier)));if(T.length)throw new Error(this.R(v,T,u))}}}R(s,o,u){return u===s?o.length===1?c.localize(11343,null,u.manifest.displayName||u.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?c.localize(11344,null,u.manifest.displayName||u.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):c.localize(11345,null,u.manifest.displayName||u.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?c.localize(11346,null,u.manifest.displayName||u.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?c.localize(11347,null,u.manifest.displayName||u.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):c.localize(11348,null,u.manifest.displayName||u.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}S(s,o,u=[]){if(u.indexOf(s)!==-1)return[];u.push(s);const v=s.manifest.extensionPack?s.manifest.extensionPack:[];if(v.length){const N=o.filter(O=>!O.isBuiltin&&v.some(D=>(0,p.$Ip)({id:D},O.identifier))),T=[];for(const O of N)T.push(...this.S(O,o,u));return[...N,...T]}return[]}U(s,o){return o.filter(u=>u.manifest.extensionDependencies&&u.manifest.extensionDependencies.some(v=>(0,p.$Ip)({id:v},s.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(s){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,I.$9)(s)),{malicious:[],deprecated:{},search:[]}}}};e.$Bq=i,e.$Bq=i=ve([se(0,h.$hp),se(1,m.$8l),se(2,A.$Gl),se(3,E.$9j),se(4,d.$pk),se(5,w.$Il)],i);function l(t,s){if(t instanceof h.$jp)return t;let o;return t instanceof h.$ip?o=new h.$jp(t.message,t.code===h.ExtensionGalleryErrorCode.DownloadFailedWriting?h.ExtensionManagementErrorCode.DownloadFailedWriting:h.ExtensionManagementErrorCode.Gallery):o=new h.$jp(t.message,(0,I.$3)(t)?h.ExtensionManagementErrorCode.Cancelled:s??h.ExtensionManagementErrorCode.Internal),o.stack=t.stack,o}function n(t,s,{extensionData:o,verificationStatus:u,duration:v,error:N,source:T,durationSinceUpdate:O}){let D,q;(0,a.$kg)(u)&&(u===!0?u="Verified":(u===!1||(D=h.ExtensionManagementErrorCode.Signature,q=u),u="Unverified")),N&&(D=N.code,N.code===h.ExtensionManagementErrorCode.Signature&&(q=N.message)),t.publicLog(s,{...o,verificationStatus:u,success:!N,duration:v,errorcode:D,errorcodeDetail:q,durationSinceUpdate:O,source:T})}class r{constructor(){this.d=new P.$Bh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,P.$ph)(s=>this.h(s))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,P.$ph)(s=>new Promise((o,u)=>{const v=s.onCancellationRequested(()=>{v.dispose(),u(new I.$4)})})),this.d.open()),this.g.cancel()}}e.$Dq=r}),define(le[42],ue([0,1,8,13,2,4,30,11,20,25,9,10,6,24,23,3,7,18]),function(Y,e,S,P,$,I,L,k,g,a,f,c,h,p,y,R,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=e.$Fq=e.$Eq=e.ExtensionsProfileScanningErrorCode=void 0;var m;(function(n){n.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",n.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(m||(e.ExtensionsProfileScanningErrorCode=m={}));class A extends Error{constructor(r,t){super(r),this.code=t}}e.$Eq=A,e.$Fq=(0,c.$Ci)("IExtensionsProfileScannerService");let w=class extends $.$Tc{constructor(r,t,s,o,u,v){super(),this.j=r,this.m=t,this.n=s,this.r=o,this.s=u,this.t=v,this.b=this.B(new I.$je),this.onAddExtensions=this.b.event,this.c=this.B(new I.$je),this.onDidAddExtensions=this.c.event,this.f=this.B(new I.$je),this.onRemoveExtensions=this.f.event,this.g=this.B(new I.$je),this.onDidRemoveExtensions=this.g.event,this.h=new L.$zc}scanProfileExtensions(r,t){return this.u(r,void 0,t)}async addExtensionsToProfile(r,t,s){const o=[],u=[];try{return await this.u(t,v=>{const N=[];if(s)N.push(...v);else for(const T of v)r.some(([O])=>(0,a.$Ip)(O.identifier,T.identifier)&&O.manifest.version!==T.version)?o.push(T):N.push(T);for(const[T,O]of r){const D=N.findIndex(K=>(0,a.$Ip)(K.identifier,T.identifier)&&K.version===T.manifest.version),q={identifier:T.identifier,version:T.manifest.version,location:T.location,metadata:O};D===-1?(u.push(q),N.push(q)):N.splice(D,1,q)}return u.length&&this.b.fire({extensions:u,profileLocation:t}),o.length&&this.f.fire({extensions:o,profileLocation:t}),N}),u.length&&this.c.fire({extensions:u,profileLocation:t}),o.length&&this.g.fire({extensions:o,profileLocation:t}),u}catch(v){throw u.length&&this.c.fire({extensions:u,error:v,profileLocation:t}),o.length&&this.g.fire({extensions:o,error:v,profileLocation:t}),v}}async updateMetadata(r,t){const s=[];return await this.u(t,o=>{const u=[];for(const v of o){const N=r.find(([T])=>(0,a.$Ip)(T.identifier,v.identifier)&&T.manifest.version===v.version);N&&(v.metadata={...v.metadata,...N[1]},s.push(v)),u.push(v)}return u}),s}async removeExtensionFromProfile(r,t){const s=[];try{await this.u(t,o=>{const u=[];for(const v of o)(0,a.$Ip)(v.identifier,r.identifier)?s.push(v):u.push(v);return s.length&&this.f.fire({extensions:s,profileLocation:t}),u}),s.length&&this.g.fire({extensions:s,profileLocation:t})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:t}),o}}async u(r,t,s){return this.F(r).queue(async()=>{let o=[],u;try{const v=await this.m.readFile(r);u=JSON.parse(v.value.toString().trim()||"[]")}catch(v){if((0,f.$nl)(v)!==f.FileOperationResult.FILE_NOT_FOUND)throw v;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(u=await this.D()),!u&&s?.bailOutWhenFileNotFound)throw new A((0,E.$9)(v),m.ERROR_PROFILE_NOT_FOUND)}if(u){Array.isArray(u)||this.w(r);let v=!1;for(const N of u){i(N)||this.w(r);let T;if((0,R.$cg)(N.relativeLocation)&&N.relativeLocation)T=this.z(N.relativeLocation);else if((0,R.$cg)(N.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${N.location}`);continue}else{T=k.URI.revive(N.location);const O=this.y(T);O&&(v=!0,N.relativeLocation=O)}(0,R.$jg)(N.metadata?.hasPreReleaseVersion)&&N.metadata?.preRelease&&(v=!0,N.metadata.hasPreReleaseVersion=!0),o.push({identifier:N.identifier,location:T,version:N.version,metadata:N.metadata})}v&&await this.m.writeFile(r,P.$Le.fromString(JSON.stringify(u)))}if(t){o=t(o);const v=o.map(N=>({identifier:N.identifier,version:N.version,location:N.location.toJSON(),relativeLocation:this.y(N.location),metadata:N.metadata}));await this.m.writeFile(r,P.$Le.fromString(JSON.stringify(v)))}return o})}w(r){const t=new A(`Invalid extensions content in ${r.toString()}`,m.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),t=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(r)).value.toString()}catch(u){if((0,f.$nl)(u)===f.FileOperationResult.FILE_NOT_FOUND)return;throw u}this.t.info("Migrating extensions from old default profile location",r.toString());let o;try{const u=JSON.parse(s);Array.isArray(u)&&u.every(v=>i(v))?o=u:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",u)}catch(u){this.t.error(u)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,P.$Le.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(u){if((0,f.$nl)(u)===f.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw u}try{await this.m.del(r)}catch(u){(0,f.$nl)(u)!==f.FileOperationResult.FILE_NOT_FOUND&&this.t.error(u)}try{await this.m.del(t)}catch(u){(0,f.$nl)(u)!==f.FileOperationResult.FILE_NOT_FOUND&&this.t.error(u)}return o})()),this.C}F(r){let t=this.h.get(r);return t||(t=new S.$Jh,this.h.set(r,t)),t}};e.$Gq=w,e.$Gq=w=ve([se(1,f.$9k),se(2,p.$Il),se(3,y.$Gl),se(4,d.$8l),se(5,h.$9j)],w);function i(n){return(0,R.$eg)(n)&&(0,g.$gp)(n.identifier)&&(l(n.location)||(0,R.$cg)(n.location)&&n.location)&&((0,R.$jg)(n.relativeLocation)||(0,R.$cg)(n.relativeLocation))&&n.version&&(0,R.$cg)(n.version)}function l(n){return n?(0,R.$cg)(n.path)&&(0,R.$cg)(n.scheme):!1}});var qe=this&&this.__importDefault||function(Y){return Y&&Y.__esModule?Y:{default:Y}};define(le[54],ue([0,1,19,8,26,13,7,34,89,2,14,15,12,16,45,57,3,11,5,17,25,22,44,9,10,6,33,4,48,42,24,23,95]),function(Y,e,S,P,$,I,L,k,g,a,f,c,h,p,y,R,E,d,m,A,w,i,l,n,r,t,s,o,u,v,N,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=e.$Lq=e.$Kq=e.$Jq=e.Translations=void 0,e.$Mq=ae,$=ye($),c=ye(c),h=ye(h),y=ye(y),R=qe(R);var D;(function(de){function H(Z,B){if(Z===B)return!0;const z=Object.keys(Z),G=new Set;for(const X of Object.keys(B))G.add(X);if(z.length!==G.size)return!1;for(const X of z){if(Z[X]!==B[X])return!1;G.delete(X)}return G.size===0}de.equals=H})(D||(e.Translations=D={})),e.$Jq=(0,r.$Ci)("IExtensionsScannerService");let q=class extends a.$Tc{constructor(H,Z,B,z,G,X,te,ne,j,W,M,b){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=Z,this.r=B,this.s=z,this.t=G,this.u=X,this.w=te,this.y=ne,this.z=j,this.C=W,this.D=M,this.F=b,this.g=this.B(new o.$je),this.onDidChangeCache=this.g.event,this.h=(0,p.$dh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(re,this.s,this.h)),this.m=this.B(this.F.createInstance(re,this.s,this.h)),this.n=this.B(this.F.createInstance(J,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(i.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(i.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,w.$Tp)(this.w,this.y)),this.G}async scanAllExtensions(H,Z,B){const[z,G]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(Z)]),X=B?await this.scanExtensionsUnderDevelopment(H,[...z,...G]):[];return this.L(z,G,X,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const Z=[];Z.push(this.M(!!H.useCache,H.language)),Z.push(this.N(H.language,!!H.checkControlFile));const[B,z]=await Promise.all(Z);return this.J([...B,...z],i.ExtensionType.System,H,!1)}async scanUserExtensions(H){const Z=H.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Z);const B=this.D.extUri.isEqual(H.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.P(Z,!!H.profileLocation,i.ExtensionType.User,!H.includeUninstalled,H.language,!0,B,H.productVersion??this.R()),G=H.useCache&&!z.devMode&&z.excludeObsolete?this.m:this.n;let X;try{X=await G.scanExtensions(z)}catch(te){if(te instanceof v.$Eq&&te.code===v.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),X=await G.scanExtensions(z);else throw te}return X=await this.J(X,i.ExtensionType.User,H,!0),this.y.trace("Scanned user extensions:",X.length),X}async scanExtensionsUnderDevelopment(H,Z){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const B=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(z=>z.scheme===f.Schemas.file).map(async z=>{const G=await this.P(z,!1,i.ExtensionType.User,!0,H.language,!1,void 0,H.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(G)).map(te=>(te.type=Z.find(ne=>(0,w.$Ip)(ne.identifier,te.identifier))?.type??te.type,this.n.validate(te,G)))}))).flat();return this.J(B,"development",H,!0)}return[]}async scanExistingExtension(H,Z,B){const z=await this.P(H,!1,Z,!0,B.language,!0,void 0,B.productVersion??this.R()),G=await this.n.scanExtension(z);return!G||!B.includeInvalid&&!G.isValid?null:G}async scanOneOrMultipleExtensions(H,Z,B){const z=await this.P(H,!1,Z,!0,B.language,!0,void 0,B.productVersion??this.R()),G=await this.n.scanOneOrMultipleExtensions(z);return this.J(G,Z,B,!0)}async scanMultipleExtensions(H,Z,B){const z=[];return await Promise.all(H.map(async G=>{const X=await this.scanOneOrMultipleExtensions(G,Z,B);z.push(...X)})),this.J(z,Z,B,!0)}async scanMetadata(H){const Z=(0,p.$dh)(H,"package.json"),B=(await this.w.readFile(Z)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(H,Z){const B=(0,p.$dh)(H,"package.json"),z=(await this.w.readFile(B)).value.toString(),G=JSON.parse(z);Z.isMachineScoped===!1&&delete Z.isMachineScoped,Z.isBuiltin===!1&&delete Z.isBuiltin,G.__metadata={...G.__metadata,...Z},await this.w.writeFile((0,p.$dh)(H,"package.json"),I.$Le.fromString(JSON.stringify(G,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(H){if(H instanceof v.$Eq&&H.code===v.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw H}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const H=await this.scanUserExtensions({includeInvalid:!0});if(H.length)await this.u.addExtensionsToProfile(H.map(Z=>[Z,Z.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,I.$Le.fromString(JSON.stringify([])))}catch(Z){(0,n.$nl)(Z)!==n.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,L.$9)(Z))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(H){this.y.error(H)}finally{this.H=void 0}})()),this.H}async J(H,Z,B,z){return B.includeAllVersions||(H=this.L(Z===i.ExtensionType.System?H:void 0,Z===i.ExtensionType.User?H:void 0,Z==="development"?H:void 0,await this.getTargetPlatform(),z)),B.includeInvalid||(H=H.filter(G=>G.isValid)),H.sort((G,X)=>{const te=c.$mc(G.location.fsPath),ne=c.$mc(X.location.fsPath);return te<ne?-1:te>ne?1:0})}L(H,Z,B,z,G){const X=(ne,j,W)=>{if(ne.isValid&&!j.isValid)return!1;if(ne.isValid===j.isValid){if(G&&y.gt(ne.manifest.version,j.manifest.version))return this.y.debug(`Skipping extension ${j.location.path} with lower version ${j.manifest.version} in favour of ${ne.location.path} with version ${ne.manifest.version}`),!1;if(y.eq(ne.manifest.version,j.manifest.version)){if(ne.type===i.ExtensionType.System)return this.y.debug(`Skipping extension ${j.location.path} in favour of system extension ${ne.location.path} with same version`),!1;if(ne.targetPlatform===z)return this.y.debug(`Skipping extension ${j.location.path} from different target platform ${j.targetPlatform}`),!1}}return W?this.y.warn(`Overwriting user extension ${ne.location.path} with ${j.location.path}.`):this.y.debug(`Overwriting user extension ${ne.location.path} with ${j.location.path}.`),!0},te=new i.$pn;return H?.forEach(ne=>{const j=te.get(ne.identifier.id);(!j||X(j,ne,!1))&&te.set(ne.identifier.id,ne)}),Z?.forEach(ne=>{const j=te.get(ne.identifier.id);if(!j&&H&&ne.type===i.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${ne.location.path}.`);return}(!j||X(j,ne,!1))&&te.set(ne.identifier.id,ne)}),B?.forEach(ne=>{const j=te.get(ne.identifier.id);(!j||X(j,ne,!0))&&te.set(ne.identifier.id,ne),te.set(ne.identifier.id,ne)}),[...te.values()]}async M(H,Z){this.y.trace("Started scanning system extensions");const B=await this.P(this.systemExtensionsLocation,!1,i.ExtensionType.System,!0,Z,!0,void 0,this.R()),G=await(H&&!B.devMode?this.j:this.n).scanExtensions(B);return this.y.trace("Scanned system extensions:",G.length),G}async N(H,Z){const B=this.z.isBuilt?[]:this.C.builtInExtensions;if(!B?.length)return[];this.y.trace("Started scanning dev system extensions");const z=Z?await this.O():{},G=[],X=d.URI.file(c.$gc(c.$ic(f.$Wg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ne of B){const j=z[ne.name]||"marketplace";switch(j){case"disabled":break;case"marketplace":G.push((0,p.$dh)(X,ne.name));break;default:G.push(d.URI.file(j));break}}const te=await Promise.all(G.map(async ne=>this.n.scanExtension(await this.P(ne,!1,i.ExtensionType.System,!0,H,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",te.length),(0,S.$Gb)(te)}async O(){try{const H=await this.w.readFile(this.r);return JSON.parse(H.value.toString())}catch{return{}}}async P(H,Z,B,z,G,X,te,ne){const j=await this.f(G??h.$x),W=await this.Q(H),M=Z&&!this.D.extUri.isEqual(H,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,b=M?await this.Q(M):void 0;return new K(H,W,M,b,Z,te,B,z,X,ne.version,ne.date,this.C.commit,!this.z.isBuilt,G,j)}async Q(H){try{const Z=await this.w.stat(H);if(typeof Z.mtime=="number")return Z.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Kq=q,e.$Kq=q=ve([se(4,N.$Il),se(5,v.$Fq),se(6,n.$9k),se(7,t.$9j),se(8,A.$Ji),se(9,s.$pk),se(10,T.$Gl),se(11,r.$Bi)],q);class K{constructor(H,Z,B,z,G,X,te,ne,j,W,M,b,F,U,C){this.location=H,this.mtime=Z,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=z,this.profile=G,this.profileScanOptions=X,this.type=te,this.excludeObsolete=ne,this.validate=j,this.productVersion=W,this.productDate=M,this.productCommit=b,this.devMode=F,this.language=U,this.translations=C}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,Z){return(0,p.$9g)(H.location,Z.location)&&H.mtime===Z.mtime&&(0,p.$9g)(H.applicationExtensionslocation,Z.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===Z.applicationExtensionslocationMtime&&H.profile===Z.profile&&$.$eo(H.profileScanOptions,Z.profileScanOptions)&&H.type===Z.type&&H.excludeObsolete===Z.excludeObsolete&&H.validate===Z.validate&&H.productVersion===Z.productVersion&&H.productDate===Z.productDate&&H.productCommit===Z.productCommit&&H.devMode===Z.devMode&&H.language===Z.language&&D.equals(H.translations,Z.translations)}}e.$Lq=K;let J=class extends a.$Tc{constructor(H,Z,B,z,G,X,te){super(),this.g=H,this.h=Z,this.j=B,this.m=z,this.n=X,this.r=te,this.f=G.extensionsEnabledWithApiProposalVersion?.map(ne=>ne.toLowerCase())??[]}async scanExtensions(H){const Z=H.profile?await this.t(H):await this.s(H);let B={};if(H.excludeObsolete&&H.type===i.ExtensionType.User)try{const z=(await this.m.readFile(this.g)).value.toString();B=JSON.parse(z)}catch{}return(0,E.$pg)(B)?Z:Z.filter(z=>!B[w.$Jp.create(z).toString()])}async s(H){const Z=await this.m.resolve(H.location);if(!Z.children?.length)return[];const B=await Promise.all(Z.children.map(async z=>{if(!z.isDirectory||H.type===i.ExtensionType.User&&(0,p.$ah)(z.resource).indexOf(".")===0)return null;const G=new K(z.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(G)}));return(0,S.$Gb)(B).sort((z,G)=>z.location.path<G.location.path?-1:1)}async t(H){let Z=await this.u(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.j.extUri.isEqual(H.location,H.applicationExtensionslocation)){Z=Z.filter(z=>!z.metadata?.isApplicationScoped);const B=await this.u(H.applicationExtensionslocation,z=>!!z.metadata?.isBuiltin||!!z.metadata?.isApplicationScoped,H);Z.push(...B)}return Z}async u(H,Z,B){const z=await this.h.scanProfileExtensions(H,B.profileScanOptions);if(!z.length)return[];const G=await Promise.all(z.map(async X=>{if(Z(X)){const te=new K(X.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(te,X.metadata)}return null}));return(0,S.$Gb)(G)}async scanOneOrMultipleExtensions(H){try{if(await this.m.exists((0,p.$dh)(H.location,"package.json"))){const Z=await this.scanExtension(H);return Z?[Z]:[]}else return await this.scanExtensions(H)}catch(Z){return this.r.error(`Error scanning extensions at ${H.location.path}:`,(0,L.$9)(Z)),[]}}async scanExtension(H,Z){try{let B=await this.w(H.location);if(B){B.publisher||(B.publisher=i.$jn),Z=Z??B.__metadata,delete B.__metadata;const z=(0,w.$Np)(B.publisher,B.name),G=Z?.id?{id:z,uuid:Z.id}:{id:z},X=Z?.isSystem?i.ExtensionType.System:H.type,te=X===i.ExtensionType.System||!!Z?.isBuiltin;B=await this.y(H.location,B,K.createNlsConfiguration(H));let ne={type:X,identifier:G,manifest:B,location:H.location,isBuiltin:te,targetPlatform:Z?.targetPlatform??i.TargetPlatform.UNDEFINED,publisherDisplayName:Z?.publisherDisplayName,metadata:Z,isValid:!0,validations:[]};return H.validate&&(ne=this.validate(ne,H)),B.enabledApiProposals&&(!this.n.isBuilt||this.f.includes(z.toLowerCase()))&&(B.enabledApiProposals=(0,i.$vn)([...B.enabledApiProposals])),ne}}catch(B){H.type!==i.ExtensionType.System&&this.r.error(B)}return null}validate(H,Z){let B=!0;const z=this.n.isBuilt&&this.f.includes(H.identifier.id.toLowerCase()),G=(0,l.$Zp)(Z.productVersion,Z.productDate,Z.location,H.manifest,H.isBuiltin,z);for(const[X,te]of G)X===R.default.Error&&(B=!1,this.r.error(this.F(Z.location,te)));return H.isValid=B,H.validations=G,H}async w(H){const Z=(0,p.$dh)(H,"package.json");let B;try{B=(await this.m.readFile(Z)).value.toString()}catch(G){return(0,n.$nl)(G)!==n.FileOperationResult.FILE_NOT_FOUND&&this.r.error(this.F(H,(0,m.localize)(11294,null,Z.path,G.message))),null}let z;try{z=JSON.parse(B)}catch{const X=[];(0,k.$Un)(B,X);for(const te of X)this.r.error(this.F(H,(0,m.localize)(11295,null,Z.path,te.offset,te.length,(0,g.$Hq)(te.error))));return null}return(0,k.$3n)(z)!=="object"?(this.r.error(this.F(H,(0,m.localize)(11296,null,Z.path))),null):z}async y(H,Z,B){const z=await this.z(H,Z,B);if(z)try{const G=[],X=await this.C(z.default,G);if(G.length>0)return G.forEach(ne=>{this.r.error(this.F(H,(0,m.localize)(11297,null,z.default?.path,(0,g.$Hq)(ne.error))))}),Z;if((0,k.$3n)(z)!=="object")return this.r.error(this.F(H,(0,m.localize)(11298,null,z.default?.path))),Z;const te=z.values||Object.create(null);return(0,O.$Iq)(this.r,Z,te,X)}catch{}return Z}async z(H,Z,B){const z=(0,p.$dh)(H,"package.nls.json"),G=(j,W)=>{W.forEach(M=>{this.r.error(this.F(H,(0,m.localize)(11299,null,j?.path,(0,g.$Hq)(M.error))))})},X=j=>{this.r.error(this.F(H,(0,m.localize)(11300,null,j?.path)))},te=`${Z.publisher}.${Z.name}`,ne=B.translations[te];if(ne)try{const j=d.URI.file(ne),W=(await this.m.readFile(j)).value.toString(),M=[],b=(0,k.$Un)(W,M);return M.length>0?(G(j,M),{values:void 0,default:z}):(0,k.$3n)(b)!=="object"?(X(j),{values:void 0,default:z}):{values:b.contents?b.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.m.exists(z))return;let W;try{W=await this.D(H,B)}catch{return}if(!W.localized)return{values:void 0,default:W.original};try{const M=(await this.m.readFile(W.localized)).value.toString(),b=[],F=(0,k.$Un)(M,b);return b.length>0?(G(W.localized,b),{values:void 0,default:W.original}):(0,k.$3n)(F)!=="object"?(X(W.localized),{values:void 0,default:W.original}):{values:F,default:W.original}}catch{return{values:void 0,default:W.original}}}}async C(H,Z){if(H)try{const B=(await this.m.readFile(H)).value.toString();return(0,k.$Un)(B,Z)}catch{}}D(H,Z){return new Promise((B,z)=>{const G=X=>{const te=(0,p.$dh)(H,`package.nls.${X}.json`);this.m.exists(te).then(ne=>{ne&&B({localized:te,original:(0,p.$dh)(H,"package.nls.json")});const j=X.lastIndexOf("-");j===-1?B({localized:(0,p.$dh)(H,"package.nls.json"),original:null}):(X=X.substring(0,j),G(X))})};if(Z.devMode||Z.pseudo||!Z.language)return B({localized:(0,p.$dh)(H,"package.nls.json"),original:null});G(Z.language)})}F(H,Z){return`[${H.path}]: ${Z}`}};J=ve([se(1,v.$Fq),se(2,T.$Gl),se(3,n.$9k),se(4,s.$pk),se(5,A.$Ji),se(6,t.$9j)],J);let re=class extends J{constructor(H,Z,B,z,G,X,te,ne,j){super(Z,z,G,X,te,ne,j),this.J=H,this.L=B,this.H=this.B(new P.$Ah(3e3)),this.I=this.B(new o.$je),this.onDidChangeCache=this.I.event}async scanExtensions(H){const Z=this.P(H),B=await this.M(Z);if(this.G=H,B&&B.input&&K.equals(B.input,this.G))return this.r.debug("Using cached extensions scan result",H.type===i.ExtensionType.System?"system":"user",H.location.toString()),this.H.trigger(()=>this.O()),B.result.map(G=>(G.location=d.URI.revive(G.location),G));const z=await super.scanExtensions(H);return await this.N(Z,{input:H,result:z}),z}async M(H){try{const Z=await this.m.readFile(H),B=JSON.parse(Z.value.toString());return{result:B.result,input:(0,u.$_h)(B.input)}}catch(Z){this.r.debug("Error while reading the extension cache file:",H.path,(0,L.$9)(Z))}return null}async N(H,Z){try{await this.m.writeFile(H,I.$Le.fromString(JSON.stringify(Z)))}catch(B){this.r.debug("Error while writing the extension cache file:",H.path,(0,L.$9)(B))}}async O(){if(!this.G)return;const H=this.P(this.G),Z=await this.M(H);if(!Z)return;const B=Z.result,z=JSON.parse(JSON.stringify(await super.scanExtensions(this.G)));if(!$.$eo(z,B))try{this.r.info("Invalidating Cache",B,z),await this.m.del(H),this.I.fire()}catch(G){this.r.error(G)}}P(H){const Z=this.Q(H);return this.j.extUri.joinPath(Z.cacheHome,H.type===i.ExtensionType.System?i.$in:i.$hn)}Q(H){return H.type===i.ExtensionType.System?this.L.defaultProfile:H.profile?this.j.extUri.isEqual(H.location,this.J.extensionsResource)?this.J:this.L.profiles.find(Z=>this.j.extUri.isEqual(H.location,Z.extensionsResource))??this.J:this.L.defaultProfile}};re=ve([se(2,N.$Il),se(3,v.$Fq),se(4,T.$Gl),se(5,n.$9k),se(6,s.$pk),se(7,A.$Ji),se(8,t.$9j)],re);function ae(de,H){const Z=(0,w.$Lp)(de.manifest.publisher,de.manifest.name);return{id:Z,identifier:new i.$nn(Z),isBuiltin:de.type===i.ExtensionType.System,isUserBuiltin:de.type===i.ExtensionType.User&&de.isBuiltin,isUnderDevelopment:H,extensionLocation:de.location,uuid:de.identifier.uuid,targetPlatform:de.targetPlatform,publisherDisplayName:de.publisherDisplayName,...de.manifest}}class ce extends q{constructor(H,Z,B,z,G,X,te,ne,j,W,M,b){super(H,Z,(0,p.$dh)(B,".vscode-oss-dev","extensions","control.json"),z,G,X,te,ne,j,W,M,b),this.S=(async()=>{if(h.$A)try{const F=await this.w.readFile(d.URI.file(h.$A));return JSON.parse(F.value.toString())}catch{}return Object.create(null)})()}f(H){return this.S}}e.$Nq=ce}),define(le[135],ue([0,1,60,8,38,4,2,14,15,28,6,24]),function(Y,e,S,P,$,I,L,k,g,a,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0;let h=class extends L.$Tc{constructor(y,R){super(),this.b=y,this.f=R,this.a=new P.$Ih(5)}async postUninstall(y){const R=this.g(y,"uninstall");R&&(this.f.info(y.identifier.id,y.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(R.script,"uninstall",R.args,!0,y),this.f.info("Finished running post uninstall script",y.identifier.id,y.manifest.version)}catch(E){this.f.error("Failed to run post uninstall script",y.identifier.id,y.manifest.version),this.f.error(E)}}));try{await a.Promises.rm(this.m(y))}catch(E){this.f.error("Error while removing extension storage path",y.identifier.id),this.f.error(E)}}g(y,R){const E=`vscode:${R}`;if(y.location.scheme===k.Schemas.file&&y.manifest&&y.manifest.scripts&&typeof y.manifest.scripts[E]=="string"){const d=y.manifest.scripts[E].split(" ");return d.length<2||d[0]!=="node"||!d[1]?(this.f.warn(y.identifier.id,y.manifest.version,`${E} should be a node script`),null):{script:(0,g.$ic)(y.location.fsPath,d[1]),args:d.slice(2)||[]}}return null}h(y,R,E,d,m){return new Promise((A,w)=>{const i=this.j(y,R,E,m);let l;const n=r=>{l&&(clearTimeout(l),l=null),r?w(r):A(void 0)};i.on("error",r=>{n((0,$.$nj)(r)||"Unknown")}),i.on("exit",(r,t)=>{n(r?`post-${R} process exited with code ${r}`:void 0)}),d&&(l=setTimeout(()=>{l=null,i.kill(),w("timed out")},5e3))})}j(y,R,E,d){const m={silent:!0,execArgv:void 0},A=(0,S.fork)(y,[`--type=extension-post-${R}`,...E],m);A.stdout.setEncoding("utf8"),A.stderr.setEncoding("utf8");const w=I.Event.fromNodeEventEmitter(A.stdout,"data"),i=I.Event.fromNodeEventEmitter(A.stderr,"data");this.B(w(r=>this.f.info(d.identifier.id,d.manifest.version,`post-${R}`,r))),this.B(i(r=>this.f.error(d.identifier.id,d.manifest.version,`post-${R}`,r)));const l=I.Event.any(I.Event.map(w,r=>({data:`%c${r}`,format:[""]}),this.q),I.Event.map(i,r=>({data:`%c${r}`,format:["color: red"]}),this.q));return I.Event.debounce(l,(r,t)=>r?{data:r.data+t.data,format:[...r.format,...t.format]}:{data:t.data,format:t.format},100,void 0,void 0,void 0,this.q)(r=>{console.group(d.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),A}m(y){return(0,g.$ic)(this.b.defaultProfile.globalStorageHome.fsPath,y.identifier.id.toLowerCase())}};e.$Rq=h,e.$Rq=h=ve([se(0,c.$Il),se(1,f.$9j)],h)}),define(le[72],ue([0,1,50,5,53,20]),function(Y,e,S,P,$,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=L,e.$Pq=k;function L(g){let a=I.ExtensionManagementErrorCode.Extract;return g instanceof S.$xq&&(g.type==="CorruptZip"?a=I.ExtensionManagementErrorCode.CorruptZip:g.type==="Incomplete"&&(a=I.ExtensionManagementErrorCode.IncompleteZip)),(0,$.$Cq)(g,a)}async function k(g){let a;try{a=await(0,S.$Aq)(g,"extension/package.json")}catch(f){throw L(f)}try{return JSON.parse(a.toString("utf8"))}catch{throw new I.$jp((0,P.localize)(11285,null),I.ExtensionManagementErrorCode.Invalid)}}}),define(le[136],ue([0,1,8,7,2,14,16,45,3,27,28,50,29,17,53,20,25,72,71,9,6,18]),function(Y,e,S,P,$,I,L,k,g,a,f,c,h,p,y,R,E,d,m,A,w,i){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0,k=ye(k);let n=class extends $.$Tc{static{l=this}static{this.c=".sigzip"}constructor(t,s,o,u,v,N,T){super(),this.h=s,this.j=o,this.m=u,this.n=v,this.r=N,this.t=T,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(t,s,o,u){await this.g;const v=await this.w(t,s);let N=!1;if(o&&this.u(t)){let T;try{T=await this.y(t)}catch(O){try{await this.delete(v)}catch(D){this.t.error(D)}throw O}try{N=await this.n.verify(t,v.fsPath,T.fsPath,u)}catch(O){if(N=O.code,N===m.ExtensionSignatureVerificationCode.PackageIsInvalidZip||N===m.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(v)}catch(D){this.t.error(D)}throw new R.$jp(c.$wq,R.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(T)}catch(O){this.t.error(O)}}}return{location:v,verificationStatus:N}}u(t){if(!t.isSigned)return this.t.info(`Extension is not signed: ${t.identifier.id}`),!1;const s=this.m.getValue("extensions.verifySignature");return(0,g.$ig)(s)?s:!0}async w(t,s){try{const o=(0,L.$dh)(this.extensionsDownloadDir,this.G(t)),u=await this.C(t,"vsix",async()=>{await this.z(t,o,v=>this.j.download(t,v,s));try{await this.D(o.fsPath,"extension/package.json")}catch(v){try{await this.h.del(o)}catch(N){this.t.warn(`Error while deleting: ${o.path}`,(0,P.$9)(N))}throw v}},2);return u>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:t.identifier.id,attempts:u}),o}catch(o){throw(0,y.$Cq)(o,R.ExtensionManagementErrorCode.Download)}}async y(t){try{const s=(0,L.$dh)(this.extensionsDownloadDir,`.${(0,a.$Yg)()}`),o=await this.C(t,"sigzip",async()=>{await this.j.downloadSignatureArchive(t,s);try{await this.D(s.fsPath,".signature.p7s")}catch(u){try{await this.h.del(s)}catch(v){this.t.warn(`Error while deleting: ${s.path}`,(0,P.$9)(v))}throw u}},2);return o>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:t.identifier.id,attempts:o}),s}catch(s){throw(0,y.$Cq)(s,R.ExtensionManagementErrorCode.DownloadSignature)}}async z(t,s,o){if(await this.h.exists(s))return;if(s.scheme!==I.Schemas.file){await o(s);return}const u=(0,L.$dh)(this.extensionsDownloadDir,`.${(0,a.$Yg)()}`);try{await o(u)}catch(v){try{await this.h.del(u)}catch{}throw v}try{await f.Promises.rename(u.fsPath,s.fsPath,2*60*1e3)}catch(v){try{await this.h.del(u)}catch{}let N=!1;try{N=await this.h.exists(s)}catch{}if(N)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,s.path);else throw this.t.info(`Rename failed because of ${(0,P.$9)(v)}. Deleted the file from downloaded location`,u.path),v}}async C(t,s,o,u){let v=1;for(;;)try{return await o(),v}catch(N){if(v++>u)throw N;this.t.warn(`Failed downloading ${s}. ${(0,P.$9)(N)}. Retry again...`,t.identifier.id)}}async D(t,s){try{await(0,c.$Aq)(t,s)}catch(o){throw(0,d.$Oq)(o)}}async delete(t){await this.g,await this.h.del(t)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const s=[],o=[],u=[];for(const T of t.children)if(T.name.endsWith(l.c))u.push(T.resource);else{const O=E.$Jp.parse(T.name);O&&o.push([O,T])}const v=(0,E.$Op)(o,([T])=>T),N=[];for(const T of v)T.sort((O,D)=>k.rcompare(O[0].version,D[0].version)),s.push(...T.slice(1).map(O=>O[1].resource)),N.push(T[0][1]);N.sort((T,O)=>T.mtime-O.mtime),s.push(...N.slice(0,Math.max(0,N.length-this.f)).map(T=>T.resource)),s.push(...u),await S.Promises.settled(s.map(T=>(this.t.trace("Deleting from cache",T.path),this.h.del(T))))}}catch(t){this.t.error(t)}}G(t){return this.f?E.$Jp.create(t).toString().toLowerCase():(0,a.$Yg)()}};e.$Qq=n,e.$Qq=n=l=ve([se(0,p.$Ki),se(1,A.$9k),se(2,R.$hp),se(3,h.$9i),se(4,m.$pq),se(5,i.$8l),se(6,w.$9j)],n)}),define(le[137],ue([0,1,32,8,13,21,38,7,4,43,2,30,14,15,16,45,3,11,27,28,50,5,61,17,53,20,25,42,54,136,135,72,117,124,22,44,9,10,6,33,18,23,24]),function(Y,e,S,P,$,I,L,k,g,a,f,c,h,p,y,R,E,d,m,A,w,i,l,n,r,t,s,o,u,v,N,T,O,D,q,K,J,re,ae,ce,de,H,Z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=e.$Vq=e.$Uq=void 0,S=ye(S),p=ye(p),R=ye(R),A=ye(A),i=ye(i),e.$Uq=(0,re.$Di)(t.$kp);const B=".vsctmp";let z=class extends r.$Bq{constructor(j,W,M,b,F,U,C,x,Q,ee,oe,fe){super(j,W,oe,M,ee,fe),this.eb=F,this.fb=U,this.gb=C,this.hb=x,this.ib=Q,this.db=new Map,this.tb=new c.$Ac;const me=this.B(x.createInstance(N.$Rq));this.ab=this.B(x.createInstance(G,we=>me.postUninstall(we))),this.bb=this.B(new O.$Sq(fe,Q,oe,this,this.F)),this.cb=this.B(x.createInstance(v.$Qq));const ge=this.B(new D.$Tq(this,this.eb,fe,U,oe,Q,M));this.B(ge.onDidChangeExtensionsByAnotherSource(we=>this.sb(we))),this.ub()}getTargetPlatform(){return this.jb||(this.jb=(0,s.$Tp)(this.ib,this.F)),this.jb}async zip(j){this.F.trace("ExtensionManagementService#zip",j.identifier.id);const W=await this.rb(j),M=await(0,w.zip)((0,y.$dh)(this.cb.extensionsDownloadDir,(0,m.$Yg)()).fsPath,W);return d.URI.file(M)}async unzip(j){return this.F.trace("ExtensionManagementService#unzip",j.toString()),(await this.install(j)).identifier}async getManifest(j){const{location:W,cleanup:M}=await this.lb(j),b=p.$jc(W.fsPath);try{return await(0,T.$Pq)(b)}finally{await M()}}getInstalled(j,W=this.H.defaultProfile.extensionsResource,M={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(j??null,W,M)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(j){return this.ab.scanUserExtensionAtLocation(j)}async install(j,W={}){this.F.trace("ExtensionManagementService#install",j.toString());const{location:M,cleanup:b}=await this.lb(j);try{const F=await(0,T.$Pq)(p.$jc(M.fsPath)),U=(0,s.$Np)(F.publisher,F.name);if(F.engines&&F.engines.vscode&&!(0,K.$2p)(F.engines.vscode,this.G.version,this.G.date))throw new Error(i.localize(11286,null,U,this.G.version));const x=(await this.I([{manifest:F,extension:M,options:W}])).find(({identifier:Q})=>(0,s.$Ip)(Q,{id:U}));if(x?.local)return x.local;throw x?.error?x.error:(0,r.$Cq)(new Error(`Unknown error while installing extension ${U}`))}finally{await b()}}async installFromLocation(j,W){this.F.trace("ExtensionManagementService#installFromLocation",j.toString());const M=await this.ab.scanUserExtensionAtLocation(j);if(!M||!M.manifest.name||!M.manifest.version)throw new Error(`Cannot find a valid extension from the location ${j.toString()}`);return await this.wb([[M,{source:"resource"}]],W),this.F.info("Successfully installed extension",M.identifier.id,W.toString()),M}async installExtensionsFromProfile(j,W,M){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",j,W.toString(),M.toString());const b=(await this.getInstalled(q.ExtensionType.User,W)).filter(F=>j.some(U=>(0,s.$Ip)(U,F.identifier)));if(b.length){const F=await Promise.all(b.map(U=>this.ab.scanMetadata(U,W)));await this.wb(b.map((U,C)=>[U,F[C]]),M),this.F.info("Successfully installed extensions",b.map(U=>U.identifier.id),M.toString())}return b}async updateMetadata(j,W,M){return this.F.trace("ExtensionManagementService#updateMetadata",j.identifier.id),W.isPreReleaseVersion&&(W.preRelease=!0,W.hasPreReleaseVersion=!0),W.isMachineScoped===!1&&(W.isMachineScoped=void 0),W.isBuiltin===!1&&(W.isBuiltin=void 0),W.pinned===!1&&(W.pinned=void 0),j=await this.ab.updateMetadata(j,W,M),this.bb.invalidate(M),this.w.fire({local:j,profileLocation:M}),j}async reinstallFromGallery(j){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",j.identifier.id),!this.z.isEnabled())throw new Error(i.localize(11287,null));const W=await this.getTargetPlatform(),[M]=await this.z.getExtensions([{...j.identifier,preRelease:j.preRelease}],{targetPlatform:W,compatible:!0},I.CancellationToken.None);if(!M)throw new Error(i.localize(11288,null));await this.ab.setUninstalled(j);try{await this.ab.removeUninstalledExtension(j)}catch(b){throw new Error(i.localize(11289,null,(0,L.$nj)(b)))}return this.installFromGallery(M)}$(j,W,M,b){return this.ab.copyExtension(j,W,M,b)}copyExtensions(j,W){return this.ab.copyExtensions(j,W,{version:this.G.version,date:this.G.date})}markAsUninstalled(...j){return this.ab.setUninstalled(...j)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(j){this.F.error(j)}}async download(j,W,M){const{location:b}=await this.cb.download(j,W,!M);return b}async lb(j){if(j.scheme===h.Schemas.file)return{location:j,async cleanup(){}};this.F.trace("Downloading extension from",j.toString());const W=(0,y.$dh)(this.cb.extensionsDownloadDir,(0,m.$Yg)());return await this.gb.download(j,W),this.F.info("Downloaded extension to",W.toString()),{location:W,cleanup:async()=>{try{await this.ib.del(W)}catch(b){this.F.error(b)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(j,W,M){const b=W instanceof d.URI?new s.$Jp({id:(0,s.$Np)(j.publisher,j.name)},j.version):s.$Jp.create(W);return this.hb.createInstance(X,b,j,W,M,(F,U)=>{if(W instanceof d.URI)return this.qb(b,W,M,U);let C=this.db.get(b.toString());return C||(this.db.set(b.toString(),C=this.pb(b,W,F,M,U)),C.finally(()=>this.db.delete(b.toString()))),C},this.ab)}Z(j,W){return new te(j,W.profileLocation,this.fb)}async pb(j,W,M,b,F){const{verificationStatus:U,location:C}=await this.cb.download(W,M,!b.donotVerifySignature,b.context?.[t.$ap]);try{if(F.isCancellationRequested)throw new k.$4;return await(0,T.$Pq)(C.fsPath),{local:await this.ab.extractUserExtension(j,C.fsPath,{id:W.identifier.uuid,publisherId:W.publisherId,publisherDisplayName:W.publisherDisplayName,targetPlatform:W.properties.targetPlatform,isApplicationScoped:b.isApplicationScoped,isMachineScoped:b.isMachineScoped,isBuiltin:b.isBuiltin,isPreReleaseVersion:W.properties.isPreReleaseVersion,hasPreReleaseVersion:W.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:b.installGivenVersion?!0:!!b.pinned,preRelease:(0,E.$ig)(b.preRelease)?b.preRelease:b.installPreReleaseVersion||W.properties.isPreReleaseVersion,source:"gallery"},!1,F),verificationStatus:U}}catch(x){try{await this.cb.delete(C)}catch(Q){this.F.warn("Error while deleting the downloaded file",C.toString(),(0,k.$9)(Q))}throw(0,r.$Cq)(x)}}async qb(j,W,M,b){return{local:await this.ab.extractUserExtension(j,p.$jc(W.fsPath),{isApplicationScoped:M.isApplicationScoped,isMachineScoped:M.isMachineScoped,isBuiltin:M.isBuiltin,installedTimestamp:Date.now(),pinned:M.installGivenVersion?!0:!!M.pinned,source:"vsix"},!0,b)}}async rb(j){const W=async b=>{let F=await A.Promises.readdir(b);F=F.map(x=>p.$ic(b,x));const U=await Promise.all(F.map(x=>S.promises.stat(x)));let C=Promise.resolve([]);return U.forEach((x,Q)=>{const ee=F[Q];x.isFile()&&(C=C.then(oe=>[...oe,ee])),x.isDirectory()&&(C=C.then(oe=>W(ee).then(fe=>[...oe,...fe])))}),C};return(await W(j.location.fsPath)).map(b=>({path:`extension/${p.$kc(j.location.fsPath,b)}`,localPath:b}))}async sb({added:j,removed:W}){if(W){const M=j&&this.D.extUri.isEqual(W.profileLocation,j.profileLocation)?W.extensions.filter(b=>j.extensions.every(F=>!(0,s.$Ip)(F,b))):W.extensions;for(const b of M)this.F.info("Extensions removed from another source",b.id,W.profileLocation.toString()),this.u.fire({identifier:b,profileLocation:W.profileLocation})}if(j){const b=(await this.getInstalled(q.ExtensionType.User,j.profileLocation)).filter(F=>j.extensions.some(U=>(0,s.$Ip)(U,F.identifier)));this.s.fire(b.map(F=>(this.F.info("Extensions added from another source",F.identifier.id,j.profileLocation.toString()),{identifier:F.identifier,local:F,profileLocation:j.profileLocation,operation:t.InstallOperation.None})))}}async ub(){this.B(this.ab.onExtract(W=>this.tb.add(W)));const j=await this.ib.resolve(this.eb.userExtensionsLocation);for(const W of j.children??[])W.isDirectory&&this.tb.add(W.resource);this.B(this.ib.watch(this.eb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(W=>this.vb(W)))}async vb(j){if(!j.affects(this.eb.userExtensionsLocation,J.FileChangeType.ADDED))return;const W=[];for(const M of j.rawAdded){if(this.tb.has(M)||!this.D.extUri.isEqual(this.D.extUri.dirname(M),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(M,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(M).startsWith(".")||!(await this.ib.stat(M)).isDirectory)continue;const b=await this.ab.scanUserExtensionAtLocation(M);b&&b.installedTimestamp===void 0&&(this.tb.add(M),W.push(b))}W.length&&(await this.wb(W.map(M=>[M,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",W.map(M=>M.identifier.id)))}async wb(j,W){const M=j.map(b=>b[0]);await this.xb(M),await this.fb.addExtensionsToProfile(j,W),this.s.fire(M.map(b=>({local:b,identifier:b.identifier,operation:t.InstallOperation.None,profileLocation:W})))}async xb(j){const W=await this.ab.getUninstalledExtensions();for(const M of j){const b=s.$Jp.create(M);W[b.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",b.id),await this.ab.setInstalled(b),this.F.info("Removed the extension from uninstalled list:",b.id))}}};e.$Vq=z,e.$Vq=z=ve([se(0,t.$hp),se(1,de.$8l),se(2,ae.$9j),se(3,n.$Ki),se(4,u.$Jq),se(5,o.$Fq),se(6,l.$Xo),se(7,re.$Bi),se(8,J.$9k),se(9,ce.$pk),se(10,H.$Gl),se(11,Z.$Il)],z);let G=class extends f.$Tc{constructor(j,W,M,b,F,U,C){super(),this.n=j,this.s=W,this.t=M,this.u=b,this.w=F,this.y=U,this.z=C,this.h=this.B(new g.$je),this.onExtract=this.h.event,this.j=new c.$zc,this.m=new c.$zc,this.c=(0,y.$dh)(this.t.userExtensionsLocation,".obsolete"),this.g=new P.$Jh}async cleanUp(){await this.J(),await this.I()}async scanExtensions(j,W,M){try{const b={includeInvalid:!0,profileLocation:W,productVersion:M};let F=[];if(j===null||j===q.ExtensionType.System){let U=this.j.get(W);U||(U=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},b,!1).finally(()=>this.j.delete(W)),this.j.set(W,U)),F.push(...await U)}else if(j===q.ExtensionType.User){let U=this.m.get(W);U||(U=this.t.scanUserExtensions(b).finally(()=>this.m.delete(W)),this.m.set(W,U)),F.push(...await U)}return F=j!==null?F.filter(U=>U.type===j):F,await Promise.all(F.map(U=>this.H(U)))}catch(b){throw(0,r.$Cq)(b,t.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(j){try{const W=await this.t.scanUserExtensions({includeAllVersions:!j,includeInvalid:!0});return await Promise.all(W.map(M=>this.H(M)))}catch(W){throw(0,r.$Cq)(W,t.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(j){try{const W=await this.t.scanExistingExtension(j,q.ExtensionType.User,{includeInvalid:!0});if(W)return await this.H(W)}catch(W){this.z.error(W)}return null}async extractUserExtension(j,W,M,b,F){const U=j.toString(),C=d.URI.file(p.$ic(this.t.userExtensionsLocation.fsPath,`.${(0,m.$Yg)()}`)),x=d.URI.file(p.$ic(this.t.userExtensionsLocation.fsPath,U));let Q=await this.s.exists(x);if(Q&&b){try{await this.D(j.id,x,"removeExisting")}catch{throw new t.$jp(i.localize(11290,null,x.fsPath,j.id),t.ExtensionManagementErrorCode.Delete)}Q=!1}if(Q)try{await this.t.updateMetadata(x,M)}catch(ee){throw this.y.publicLog2("extension:extract",{extensionId:j.id,code:`${(0,J.$nl)(ee)}`}),(0,r.$Cq)(ee,t.ExtensionManagementErrorCode.UpdateExistingMetadata)}else try{if(F.isCancellationRequested)throw new k.$4;try{this.z.trace(`Started extracting the extension from ${W} to ${x.fsPath}`),await(0,w.$zq)(W,C.fsPath,{sourcePath:"extension",overwrite:!0},F),this.z.info(`Extracted extension to ${x}:`,j.id)}catch(ee){throw(0,T.$Oq)(ee)}try{await this.t.updateMetadata(C,M)}catch(ee){throw this.y.publicLog2("extension:extract",{extensionId:j.id,code:`${(0,J.$nl)(ee)}`}),(0,r.$Cq)(ee,t.ExtensionManagementErrorCode.UpdateMetadata)}if(F.isCancellationRequested)throw new k.$4;try{this.z.trace(`Started renaming the extension from ${C.fsPath} to ${x.fsPath}`),await this.G(C.fsPath,x.fsPath),this.z.info("Renamed to",x.fsPath)}catch(ee){if(ee.code==="ENOTEMPTY"){this.z.info("Rename failed because extension was installed by another source. So ignoring renaming.",j.id);try{await this.s.del(C,{recursive:!0})}catch{}}else throw this.z.info(`Rename failed because of ${(0,k.$9)(ee)}. Deleted from extracted location`,C),ee}this.h.fire(x)}catch(ee){try{await this.s.del(C,{recursive:!0})}catch{}throw ee}return this.scanLocalExtension(x,q.ExtensionType.User)}async scanMetadata(j,W){return W?(await this.C(j,W))?.metadata:this.t.scanMetadata(j.location)}async C(j,W){return(await this.u.scanProfileExtensions(W)).find(b=>(0,s.$Ip)(b.identifier,j.identifier))}async updateMetadata(j,W,M){try{M?await this.u.updateMetadata([[j,W]],M):await this.t.updateMetadata(j.location,W)}catch(b){throw this.y.publicLog2("extension:extract",{extensionId:j.identifier.id,code:`${(0,J.$nl)(b)}`}),(0,r.$Cq)(b,t.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(j.location,j.type,M)}async getUninstalledExtensions(){try{return await this.F()}catch(j){throw(0,r.$Cq)(j,t.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...j){const W=j.map(M=>s.$Jp.create(M));await this.F(M=>W.forEach(b=>{M[b.toString()]=!0,this.z.info("Marked extension as uninstalled",b.toString())}))}async setInstalled(j){try{await this.F(W=>delete W[j.toString()])}catch(W){throw(0,r.$Cq)(W,t.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(j,W){if(this.w.extUri.isEqualOrParent(j.location,this.t.userExtensionsLocation))return this.D(j.identifier.id,j.location,W)}async removeUninstalledExtension(j){await this.removeExtension(j,"uninstalled"),await this.F(W=>delete W[s.$Jp.create(j).toString()])}async copyExtension(j,W,M,b){const F=await this.C(j,W),U=await this.C(j,M);if(b={...F?.metadata,...b},U)if(this.w.extUri.isEqual(U.location,j.location))await this.u.updateMetadata([[j,{...U.metadata,...b}]],M);else{const C=await this.scanLocalExtension(U.location,j.type,M);await this.u.removeExtensionFromProfile(C,M),await this.u.addExtensionsToProfile([[j,{...U.metadata,...b}]],M)}else await this.u.addExtensionsToProfile([[j,b]],M);return this.scanLocalExtension(j.location,j.type,M)}async copyExtensions(j,W,M){const b=await this.scanExtensions(q.ExtensionType.User,j,M),F=await Promise.all(b.filter(U=>!U.isApplicationScoped).map(async U=>[U,await this.scanMetadata(U,j)]));await this.u.addExtensionsToProfile(F,W)}async D(j,W,M){this.z.trace(`Deleting ${M} extension from disk`,j,W.fsPath);const b=this.w.extUri.joinPath(this.w.extUri.dirname(W),`${this.w.extUri.basename(W)}.${(0,a.$qj)((0,m.$Yg)()).toString(16)}${B}`);await this.G(W.fsPath,b.fsPath),await this.s.del(b,{recursive:!0}),this.z.info(`Deleted ${M} extension from disk`,j,W.fsPath)}F(j){return this.g.queue(async()=>{let W;try{W=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(b){if((0,J.$nl)(b)!==J.FileOperationResult.FILE_NOT_FOUND)throw b}let M={};if(W)try{M=JSON.parse(W)}catch{}return j&&(j(M),Object.keys(M).length?await this.s.writeFile(this.c,$.$Le.fromString(JSON.stringify(M))):await this.s.del(this.c)),M})}async G(j,W){try{await A.Promises.rename(j,W,2*60*1e3)}catch(M){throw(0,r.$Cq)(M,t.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(j,W,M){try{if(M){const F=(await this.t.scanUserExtensions({profileLocation:M})).find(U=>this.w.extUri.isEqual(U.location,j));if(F)return await this.H(F)}else{const b=await this.t.scanExistingExtension(j,W,{includeInvalid:!0});if(b)return await this.H(b)}throw new t.$jp(i.localize(11291,null,j.path),t.ExtensionManagementErrorCode.ScanningExtension)}catch(b){throw(0,r.$Cq)(b,t.ExtensionManagementErrorCode.ScanningExtension)}}async H(j){const W=await this.s.resolve(j.location);let M,b;return W.children&&(M=W.children.find(({name:F})=>/^readme(\.txt|\.md|)$/i.test(F))?.resource,b=W.children.find(({name:F})=>/^changelog(\.txt|\.md|)$/i.test(F))?.resource),{identifier:j.identifier,type:j.type,isBuiltin:j.isBuiltin||!!j.metadata?.isBuiltin,location:j.location,manifest:j.manifest,targetPlatform:j.targetPlatform,validations:j.validations,isValid:j.isValid,readmeUrl:M,changelogUrl:b,publisherDisplayName:j.metadata?.publisherDisplayName,publisherId:j.metadata?.publisherId||null,isApplicationScoped:!!j.metadata?.isApplicationScoped,isMachineScoped:!!j.metadata?.isMachineScoped,isPreReleaseVersion:!!j.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!j.metadata?.hasPreReleaseVersion,preRelease:!!j.metadata?.preRelease,installedTimestamp:j.metadata?.installedTimestamp,updated:!!j.metadata?.updated,pinned:!!j.metadata?.pinned,isWorkspaceScoped:!1,source:j.metadata?.source??(j.identifier.uuid?"gallery":"vsix")}}async I(){const j=await this.getUninstalledExtensions();if(Object.keys(j).length===0){this.z.debug("No uninstalled extensions found.");return}this.z.debug("Removing uninstalled extensions:",Object.keys(j));const W=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),M=new Set;for(const F of W)j[s.$Jp.create(F).toString()]||M.add(F.identifier.id.toLowerCase());try{const F=(0,s.$Op)(W,U=>U.identifier);await P.Promises.settled(F.map(async U=>{const C=U.sort((x,Q)=>R.rcompare(x.manifest.version,Q.manifest.version))[0];M.has(C.identifier.id.toLowerCase())||await this.n(await this.H(C))}))}catch(F){this.z.error(F)}const b=W.filter(F=>F.metadata&&j[s.$Jp.create(F).toString()]);await Promise.allSettled(b.map(F=>this.removeUninstalledExtension(F)))}async J(){this.z.trace("ExtensionManagementService#removeTempDeleteFolders");let j;try{j=await this.s.resolve(this.t.userExtensionsLocation)}catch(W){(0,J.$nl)(W)!==J.FileOperationResult.FILE_NOT_FOUND&&this.z.error(W);return}if(j?.children)try{await Promise.allSettled(j.children.map(async W=>{if(!(!W.isDirectory||!W.name.endsWith(B))){this.z.trace("Deleting the temporarily deleted folder",W.resource.toString());try{await this.s.del(W.resource,{recursive:!0}),this.z.trace("Deleted the temporarily deleted folder",W.resource.toString())}catch(M){(0,J.$nl)(M)!==J.FileOperationResult.FILE_NOT_FOUND&&this.z.error(M)}}}))}catch{}}};e.$Wq=G,e.$Wq=G=ve([se(1,J.$9k),se(2,u.$Jq),se(3,o.$Fq),se(4,H.$Gl),se(5,de.$8l),se(6,ae.$9j)],G);let X=class extends r.$Dq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(j,W,M,b,F,U,C,x,Q,ee,oe,fe){super(),this.l=j,this.manifest=W,this.source=M,this.options=b,this.m=F,this.n=U,this.o=C,this.p=x,this.q=Q,this.s=ee,this.t=oe,this.u=fe,this.j=t.InstallOperation.Install,this.identifier=this.l.identifier}async h(j){const M=(await this.n.scanExtensions(q.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(C=>(0,s.$Ip)(C.identifier,this.identifier));M&&(this.j=t.InstallOperation.Update);const b={isApplicationScoped:this.options.isApplicationScoped||M?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||M?.isMachineScoped,isBuiltin:this.options.isBuiltin||M?.isBuiltin,isSystem:M?.type===q.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??M?.pinned,source:this.source instanceof d.URI?"vsix":"gallery"};let F;if(this.source instanceof d.URI){if(M&&this.l.equals(new s.$Jp(M.identifier,M.manifest.version)))try{await this.n.removeExtension(M,"existing")}catch{throw new Error(i.localize(11292,null,this.manifest.displayName||this.manifest.name))}const C=await this.w(this.l);if(C)try{await this.n.removeExtension(C,"existing")}catch{throw new Error(i.localize(11293,null,this.manifest.displayName||this.manifest.name))}}else{if(b.id=this.source.identifier.uuid,b.publisherId=this.source.publisherId,b.publisherDisplayName=this.source.publisherDisplayName,b.targetPlatform=this.source.properties.targetPlatform,b.updated=!!M,b.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,b.hasPreReleaseVersion=M?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,b.preRelease=(0,E.$ig)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||M?.preRelease,M&&M.type!==q.ExtensionType.System&&M.manifest.version===this.source.version)return this.n.updateMetadata(M,b,this.options.profileLocation);F=await this.w(this.l)}if(j.isCancellationRequested)throw(0,r.$Cq)(new k.$4);if(!F){const C=await this.m(this.operation,j);F=C.local,this.k=C.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(C){throw(0,r.$Cq)(C,t.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(j.isCancellationRequested)throw(0,r.$Cq)(new k.$4);try{await this.t.addExtensionsToProfile([[F,b]],this.options.profileLocation,!F.isValid)}catch(C){throw(0,r.$Cq)(C,t.ExtensionManagementErrorCode.AddToProfile)}const U=await this.n.scanLocalExtension(F.location,q.ExtensionType.User,this.options.profileLocation);if(!U)throw new t.$jp("Cannot find the installed extension",t.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof d.URI&&this.x(F,j),U}async w(j){return(await this.n.getUninstalledExtensions())[j.toString()]?(this.u.trace("Removing the extension from uninstalled list:",j.id),await this.n.setInstalled(j),this.u.info("Removed the extension from uninstalled list:",j.id),(await this.n.scanAllUserExtensions(!0)).find(b=>s.$Jp.create(b).equals(j))):void 0}async x(j,W){try{let[M]=await this.p.getExtensions([{id:j.identifier.id,version:j.manifest.version}],W);if(M||([M]=await this.p.getExtensions([{id:j.identifier.id}],W)),M){const b={id:M.identifier.uuid,publisherDisplayName:M.publisherDisplayName,publisherId:M.publisherId,isPreReleaseVersion:M.properties.isPreReleaseVersion,hasPreReleaseVersion:j.hasPreReleaseVersion||M.properties.isPreReleaseVersion,preRelease:M.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(j,b,this.options.profileLocation)}}catch{}}};X=ve([se(6,H.$Gl),se(7,t.$hp),se(8,Z.$Il),se(9,u.$Jq),se(10,o.$Fq),se(11,ae.$9j)],X);class te extends r.$Dq{constructor(j,W,M){super(),this.extension=j,this.j=W,this.k=M}async h(j){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(le[138],ue([0,1,6,24,23,18,42,9,17,11]),function(Y,e,S,P,$,I,L,k,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nR=void 0;let f=class extends L.$Gq{constructor(h,p,y,R,E,d){super(a.URI.file(h.extensionsPath),p,y,R,E,d)}};e.$nR=f,e.$nR=f=ve([se(0,g.$Ki),se(1,k.$9k),se(2,P.$Il),se(3,$.$Gl),se(4,I.$8l),se(5,S.$9j)],f)}),define(le[139],ue([0,1,11,17,42,54,9,10,6,33,23,24]),function(Y,e,S,P,$,I,L,k,g,a,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ugc=void 0;let h=class extends I.$Nq{constructor(y,R,E,d,m,A,w,i){super(S.URI.file(m.builtinExtensionsPath),S.URI.file(m.extensionsPath),m.userHome,y.defaultProfile,y,R,E,d,m,A,w,i)}};e.$ugc=h,e.$ugc=h=ve([se(0,c.$Il),se(1,$.$Fq),se(2,L.$9k),se(3,g.$9j),se(4,P.$Ki),se(5,a.$pk),se(6,f.$Gl),se(7,k.$Bi)],h)}),define(le[73],ue([0,1,8,4,2,107,3,87,10,24]),function(Y,e,S,P,$,I,L,k,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$gq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$eq=e.$dq=e.$cq=void 0,e.$fq=p,e.$hq=R,e.$jq=d,e.$cq="__$__isNewStorageMarker",e.$dq="__$__targetStorageMarker",e.$eq=(0,g.$Ci)("storageService");var f;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(f||(e.WillSaveStateReason=f={}));var c;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(c||(e.StorageScope=c={}));var h;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(h||(e.StorageTarget=h={}));function p(m){const A=m.get(e.$dq);if(A)try{return JSON.parse(A)}catch{}return Object.create(null)}class y extends $.$Tc{static{this.a=60*1e3}constructor(A={flushInterval:y.a}){super(),this.m=A,this.b=this.B(new P.$me),this.c=this.B(new P.$me),this.onDidChangeTarget=this.c.event,this.f=this.B(new P.$je),this.onWillSaveState=this.f.event,this.h=this.B(new S.$Oh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new $.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(A,w,i){return P.Event.filter(this.b.event,l=>l.scope===A&&(w===void 0||l.key===w),i)}n(){this.j.value=(0,S.$Sh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,$.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,I.mark)("code/willInitStorage");try{await this.O()}finally{(0,I.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(A,w){const{key:i,external:l}=w;if(i===e.$dq){switch(A){case c.APPLICATION:this.H=void 0;break;case c.PROFILE:this.F=void 0;break;case c.WORKSPACE:this.C=void 0;break}this.c.fire({scope:A})}else this.b.fire({scope:A,key:i,target:this.J(A)[i],external:l})}w(A){this.f.fire({reason:A})}get(A,w,i){return this.P(w)?.get(A,i)}getBoolean(A,w,i){return this.P(w)?.getBoolean(A,i)}getNumber(A,w,i){return this.P(w)?.getNumber(A,i)}getObject(A,w,i){return this.P(w)?.getObject(A,i)}storeAll(A,w){this.y(()=>{for(const i of A)this.store(i.key,i.value,i.scope,i.target,w)})}store(A,w,i,l,n=!1){if((0,L.$lg)(w)){this.remove(A,i,n);return}this.y(()=>{this.z(A,i,l),this.P(i)?.set(A,w,n)})}remove(A,w,i=!1){this.y(()=>{this.z(A,w,void 0),this.P(w)?.delete(A,i)})}y(A){this.b.pause(),this.c.pause();try{A()}finally{this.b.resume(),this.c.resume()}}keys(A,w){const i=[],l=this.J(A);for(const n of Object.keys(l))l[n]===w&&i.push(n);return i}z(A,w,i,l=!1){const n=this.J(w);typeof i=="number"?n[A]!==i&&(n[A]=i,this.P(w)?.set(e.$dq,JSON.stringify(n),l)):typeof n[A]=="number"&&(delete n[A],this.P(w)?.set(e.$dq,JSON.stringify(n),l))}get D(){return this.C||(this.C=this.L(c.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(c.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(c.APPLICATION)),this.H}J(A){switch(A){case c.APPLICATION:return this.I;case c.PROFILE:return this.G;default:return this.D}}L(A){const w=this.P(A);return w?p(w):Object.create(null)}isNew(A){return this.getBoolean(e.$cq,A)===!0}async flush(A=f.NONE){this.f.fire({reason:A});const w=this.P(c.APPLICATION),i=this.P(c.PROFILE),l=this.P(c.WORKSPACE);switch(A){case f.NONE:await S.Promises.settled([w?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve()]);break;case f.SHUTDOWN:await S.Promises.settled([w?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve()]);break}}async log(){const A=this.P(c.APPLICATION)?.items??new Map,w=this.P(c.PROFILE)?.items??new Map,i=this.P(c.WORKSPACE)?.items??new Map;return d(A,w,i,this.Q(c.APPLICATION)??"",this.Q(c.PROFILE)??"",this.Q(c.WORKSPACE)??"")}async optimize(A){return await this.flush(),this.P(A)?.optimize()}async switch(A,w){return this.w(f.NONE),(0,a.$Hl)(A)?this.R(A,w):this.S(A,w)}M(A,w){return!(A.id===w.id||R(w)&&R(A))}N(A,w,i){this.y(()=>{const l=new Set;for(const[n,r]of A)l.add(n),w.get(n)!==r&&this.u(i,{key:n,external:!0});for(const[n]of w.items)l.has(n)||this.u(i,{key:n,external:!0})})}}e.$gq=y;function R(m){return m.isDefault||!!m.useDefaultFlags?.globalState}class E extends y{constructor(){super(),this.U=this.B(new k.$aq(new k.$bq,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new k.$aq(new k.$bq,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new k.$aq(new k.$bq,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(A=>this.u(c.WORKSPACE,A))),this.B(this.W.onDidChangeStorage(A=>this.u(c.PROFILE,A))),this.B(this.U.onDidChangeStorage(A=>this.u(c.APPLICATION,A)))}P(A){switch(A){case c.APPLICATION:return this.U;case c.PROFILE:return this.W;default:return this.X}}Q(A){switch(A){case c.APPLICATION:return"inMemory (application)";case c.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(A){return!1}}e.$iq=E;async function d(m,A,w,i,l,n){const r=D=>{try{return JSON.parse(D)}catch{return D}},t=new Map,s=new Map;m.forEach((D,q)=>{t.set(q,D),s.set(q,r(D))});const o=new Map,u=new Map;A.forEach((D,q)=>{o.set(q,D),u.set(q,r(D))});const v=new Map,N=new Map;w.forEach((D,q)=>{v.set(q,D),N.set(q,r(D))}),console.group(i!==l?`Storage: Application (path: ${i})`:`Storage: Application & Profile (path: ${i}, default profile)`);const T=[];if(t.forEach((D,q)=>{T.push({key:q,value:D})}),console.table(T),console.groupEnd(),console.log(s),i!==l){console.group(`Storage: Profile (path: ${l}, profile specific)`);const D=[];o.forEach((q,K)=>{D.push({key:K,value:q})}),console.table(D),console.groupEnd(),console.log(u)}console.group(`Storage: Workspace (path: ${n})`);const O=[];v.forEach((D,q)=>{O.push({key:q,value:D})}),console.table(O),console.groupEnd(),console.log(N)}}),define(le[140],ue([0,1,13,27,73]),function(Y,e,S,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=I;async function I(L,k,g){let a=g&&g.get("storage.serviceMachineId",$.StorageScope.APPLICATION)||null;if(a)return a;try{const c=(await k.readFile(L.serviceMachineIdResource)).value.toString();a=(0,P.$Xg)(c)?c:null}catch{a=null}if(!a){a=(0,P.$Yg)();try{await k.writeFile(L.serviceMachineIdResource,S.$Le.fromString(a))}catch{}}return g?.store("storage.serviceMachineId",a,$.StorageScope.APPLICATION,$.StorageTarget.MACHINE),a}}),define(le[141],ue([0,1,140,18,41]),function(Y,e,S,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=I;async function I(L,k,g,a,f,c,h){const p={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${k.nameShort})`};if((0,$.$Ap)(k,g)&&(0,$.$Cp)(a)===P.TelemetryLevel.USAGE){const y=await(0,S.$kq)(g,f,c);p["X-Market-User-Id"]=y,p["VSCode-SessionId"]=h.machineId||y}return p}}),define(le[142],ue([0,1,19,21,7,12,36,3,11,29,17,20,25,22,44,9,6,33,46,141,73,18,154]),function(Y,e,S,P,$,I,L,k,g,a,f,c,h,p,y,R,E,d,m,A,w,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=e.$nq=void 0,e.$mq=ne;const n=I.$p?p.TargetPlatform.WEB:(0,c.$dp)(I.$v,L.$dc),r="X-Market-Search-Activity-Id";var t;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished",U[U.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function s(...U){return String(U.reduce((C,x)=>C|x,0))}var o;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const u={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},v={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},T={pageNumber:1,pageSize:10,sortBy:c.SortBy.NoneOrRelevance,sortOrder:c.SortOrder.Default,flags:t.None,criteria:[],assetTypes:[]};class O{constructor(C=T){this.d=C}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(C,x=this.d.pageSize){return new O({...this.d,pageNumber:C,pageSize:x})}withFilter(C,...x){const Q=[...this.d.criteria,...x.length?x.map(ee=>({filterType:C,value:ee})):[{filterType:C}]];return new O({...this.d,criteria:Q})}withSortBy(C){return new O({...this.d,sortBy:C})}withSortOrder(C){return new O({...this.d,sortOrder:C})}withFlags(...C){return new O({...this.d,flags:C.reduce((x,Q)=>x|Q,0)})}withAssetTypes(...C){return new O({...this.d,assetTypes:C})}withSource(C){return new O({...this.d,source:C})}get raw(){const{criteria:C,pageNumber:x,pageSize:Q,sortBy:ee,sortOrder:oe,flags:fe,assetTypes:me}=this.d;return{filters:[{criteria:C,pageNumber:x,pageSize:Q,sortBy:ee,sortOrder:oe}],assetTypes:me,flags:fe}}get searchText(){const C=this.d.criteria.filter(x=>x.filterType===o.SearchText)[0];return C&&C.value?C.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(C=>String(C.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function D(U,C){const x=(U||[]).filter(Q=>Q.statisticName===C)[0];return x?x.value:0}function q(U){const C="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(Q=>Q.assetType.indexOf(C)===0).reduce((Q,ee)=>{const oe=re(U,ee.assetType);return oe&&Q.push([ee.assetType.substring(C.length),oe]),Q},[])}function K(U){if(U.properties){const C=U.properties.filter(ee=>ee.key===u.Repository),x=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),Q=C.filter(ee=>x.test(ee.value))[0];return Q?{uri:Q.value,fallbackUri:Q.value}:null}return re(U,u.Repository)}function J(U){return{uri:`${U.fallbackAssetUri}/${u.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${u.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function re(U,C){return U.files.filter(Q=>Q.assetType===C)[0]?{uri:`${U.assetUri}/${C}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${C}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}:null}function ae(U,C){const x=U.properties?U.properties.filter(ee=>ee.key===C):[],Q=x.length>0&&x[0].value;return Q?Q.split(",").map(ee=>(0,h.$Mp)(ee)):[]}function ce(U){const C=U.properties?U.properties.filter(x=>x.key===v.Engine):[];return C.length>0&&C[0].value||""}function de(U){const C=U.properties?U.properties.filter(x=>x.key===v.PreRelease):[];return C.length>0&&C[0].value==="true"}function H(U){const C=U.properties?U.properties.filter(Q=>Q.key===v.EnabledApiProposals):[],x=C.length>0&&C[0].value||"";return x?x.split(","):[]}function Z(U){const C=U.properties?U.properties.filter(Q=>Q.key===v.LocalizedLanguages):[],x=C.length>0&&C[0].value||"";return x?x.split(","):[]}function B(U){return U.properties?.find(C=>C.key===v.SponsorLink)?.value}function z(U){return U.properties?.find(C=>C.key===v.SupportLink)?.value}function G(U){return U.indexOf("preview")!==-1}function X(U){return U.targetPlatform?(0,c.$cp)(U.targetPlatform):p.TargetPlatform.UNDEFINED}function te(U){const C=(0,S.$Lb)(U.versions.map(X)),x=!!U.tags?.includes(c.$9o),Q=C.indexOf(p.TargetPlatform.WEB);return x?Q===-1&&C.push(p.TargetPlatform.WEB):Q!==-1&&C.splice(Q,1),C}function ne(U,C){for(let x=0;x<U.length;x++){const Q=U[x];if(Q.version===U[x-1]?.version){let ee=x;if(X(Q)===C)for(;ee>0&&U[ee-1].version===Q.version;)ee--;ee!==x&&(U.splice(x,1),U.splice(ee,0,Q))}}return U}function j(U,C,x){U.telemetryData={index:C,querySource:x,queryActivityId:U.queryContext?.[r]}}function W(U,C,x,Q){const ee=U.versions[0],oe={manifest:re(C,u.Manifest),readme:re(C,u.Details),changelog:re(C,u.Changelog),license:re(C,u.License),repository:K(C),download:J(C),icon:re(C,u.Icon),signature:re(C,u.Signature),coreTranslations:q(C)};return{type:"gallery",identifier:{id:(0,h.$Np)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:C.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,publisherSponsorLink:B(ee),description:U.shortDescription??"",installCount:D(U.statistics,"install"),rating:D(U.statistics,"averagerating"),ratingCount:D(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:x,assets:oe,properties:{dependencies:ae(C,v.Dependency),extensionPack:ae(C,v.ExtensionPack),engine:ce(C),enabledApiProposals:H(C),localizedLanguages:Z(C),targetPlatform:X(C),isPreReleaseVersion:de(C)},hasPreReleaseVersion:de(ee),hasReleaseVersion:!0,preview:G(U.flags),isSigned:!!oe.signature,queryContext:Q,supportLink:z(ee)}}let M=class{constructor(C,x,Q,ee,oe,fe,me,ge){this.l=x,this.n=Q,this.o=ee,this.q=oe,this.u=fe,this.w=me,this.x=ge;const we=me.extensionsGallery,he=we?.servicePPEUrl&&ge.getValue("_extensionsGallery.enablePPE");this.d=he?we.servicePPEUrl:we?.serviceUrl,this.g=he?void 0:we?.searchUrl,this.h=we?.controlUrl,this.k=me.extensionsEnabledWithApiProposalVersion?.map(pe=>pe.toLowerCase())??[],this.j=(0,A.$lq)(me.version,me,this.o,this.x,this.u,C,this.q)}y(C=""){return`${this.d}${C}`}isEnabled(){return!!this.d}async getExtensions(C,x,Q){const ee=P.CancellationToken.isCancellationToken(x)?{}:x,oe=P.CancellationToken.isCancellationToken(x)?x:Q,fe=[],me=[],ge=[],we=[];let he=!0;for(const Se of C){Se.uuid?me.push(Se.uuid):fe.push(Se.id);const V=!!(Se.version||Se.preRelease);ge.push({id:Se.id,uuid:Se.uuid,includePreRelease:V}),Se.version&&we.push({id:Se.id,uuid:Se.uuid,version:Se.version}),he=he&&!!Se.hasPreRelease&&!V}if(!me.length&&!fe.length)return[];let pe=new O().withPage(1,C.length);me.length&&(pe=pe.withFilter(o.ExtensionId,...me)),fe.length&&(pe=pe.withFilter(o.ExtensionName,...fe)),(ee.queryAllVersions||he)&&(pe=pe.withFlags(pe.flags,t.IncludeVersions)),ee.source&&(pe=pe.withSource(ee.source));const{extensions:be}=await this.B(pe,{targetPlatform:ee.targetPlatform??n,includePreRelease:ge,versions:we,compatible:!!ee.compatible,productVersion:ee.productVersion??{version:this.w.version,date:this.w.date}},oe);return ee.source&&be.forEach((Se,V)=>j(Se,V,ee.source)),be}async getCompatibleExtension(C,x,Q,ee={version:this.w.version,date:this.w.date}){if((0,c.$ep)(C.allTargetPlatforms,Q))return null;if(await this.isExtensionCompatible(C,x,Q))return C;const oe=new O().withFlags(t.IncludeVersions).withPage(1,1).withFilter(o.ExtensionId,C.identifier.uuid),{extensions:fe}=await this.B(oe,{targetPlatform:Q,compatible:!0,includePreRelease:x,productVersion:ee},P.CancellationToken.None);return fe[0]||null}async isExtensionCompatible(C,x,Q,ee={version:this.w.version,date:this.w.date}){if(!(0,c.$fp)(C.properties.targetPlatform,C.allTargetPlatforms,Q)||!x&&C.properties.isPreReleaseVersion)return!1;let oe=C.properties.engine;if(!oe){const fe=await this.getManifest(C,P.CancellationToken.None);if(!fe)throw new Error("Manifest was not found");oe=fe.engines.vscode}return!(!(0,y.$2p)(oe,ee.version,ee.date)||!this.z(C.identifier,C.properties.enabledApiProposals))}z(C,x){return!x||!this.k.includes(C.id.toLowerCase())?!0:(0,y.$3p)(x)}async A(C,x,Q,ee,oe,fe,me={version:this.w.version,date:this.w.date}){if(!(0,c.$fp)(X(x),oe,fe)||Q!=="any"&&de(x)!==(Q==="prerelease"))return!1;if(ee)try{const ge=await this.G(C,x);if(!(0,y.$2p)(ge,me.version,me.date))return!1}catch(ge){return this.n.error(`Error while getting the engine for the version ${x.version}.`,(0,$.$9)(ge)),!1}return!0}async query(C,x){let Q=C.text||"";const ee=C.pageSize??50;let oe=new O().withPage(1,ee);Q?(Q=Q.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,pe,be)=>(oe=oe.withFilter(o.Category,be||pe),"")),Q=Q.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,pe,be)=>(oe=oe.withFilter(o.Tag,be||pe),"")),Q=Q.replace(/\bfeatured(\s+|\b|$)/g,()=>(oe=oe.withFilter(o.Featured),"")),Q=Q.trim(),Q&&(Q=Q.length<200?Q:Q.substring(0,200),oe=oe.withFilter(o.SearchText,Q)),oe=oe.withSortBy(c.SortBy.NoneOrRelevance)):C.ids?oe=oe.withFilter(o.ExtensionId,...C.ids):C.names?oe=oe.withFilter(o.ExtensionName,...C.names):oe=oe.withSortBy(c.SortBy.InstallCount),typeof C.sortBy=="number"&&(oe=oe.withSortBy(C.sortBy)),typeof C.sortOrder=="number"&&(oe=oe.withSortOrder(C.sortOrder)),C.source&&(oe=oe.withSource(C.source));const fe=async(he,pe)=>{const{extensions:be,total:Se}=await this.B(he,{targetPlatform:n,compatible:!1,includePreRelease:!!C.includePreRelease,productVersion:C.productVersion??{version:this.w.version,date:this.w.date}},pe);return be.forEach((V,_)=>j(V,(he.pageNumber-1)*he.pageSize+_,C.source)),{extensions:be,total:Se}},{extensions:me,total:ge}=await fe(oe,x),we=async(he,pe)=>{if(pe.isCancellationRequested)throw new $.$4;const{extensions:be}=await fe(oe.withPage(he+1),pe);return be};return{firstPage:me,total:ge,pageSize:oe.pageSize,getPage:we}}async B(C,x,Q){const ee=C.flags;C.flags&t.IncludeLatestVersionOnly&&C.flags&t.IncludeVersions&&(C=C.withFlags(C.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(C.flags&t.IncludeLatestVersionOnly)&&!(C.flags&t.IncludeVersions)&&(C=C.withFlags(C.flags,t.IncludeLatestVersionOnly)),x.versions?.length&&(C=C.withFlags(C.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),C=C.withFlags(C.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:oe,total:fe,context:me}=await this.D(C,Q);if(!(C.flags&t.IncludeLatestVersionOnly)){const pe=[];for(const be of oe){const Se=await this.C(be,x,me);Se&&pe.push(Se)}return{extensions:pe,total:fe}}const we=[],he=new Map;for(let pe=0;pe<oe.length;pe++){const be=oe[pe],Se={id:(0,h.$Np)(be.publisher.publisherName,be.extensionName),uuid:be.extensionId},V=(0,k.$ig)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(ie=>(0,h.$Ip)(ie,Se))?.includePreRelease;if(x.compatible&&(0,c.$ep)(te(be),x.targetPlatform))continue;const _=await this.C(be,x,me);!_||_.properties.isPreReleaseVersion&&(!V||!_.hasReleaseVersion)||!_.properties.isPreReleaseVersion&&_.properties.targetPlatform!==x.targetPlatform&&_.hasPreReleaseVersion?he.set(be.extensionId,pe):we.push([pe,_])}if(he.size){const pe=new l.$de,be=new O().withFlags(ee&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,he.size).withFilter(o.ExtensionId,...he.keys()),{extensions:Se}=await this.B(be,x,Q);this.q.publicLog2("galleryService:additionalQuery",{duration:pe.elapsed(),count:he.size});for(const V of Se){const _=he.get(V.identifier.uuid);we.push([_,V])}}return{extensions:we.sort((pe,be)=>pe[0]-be[0]).map(([,pe])=>pe),total:fe}}async C(C,x,Q){const ee={id:(0,h.$Np)(C.publisher.publisherName,C.extensionName),uuid:C.extensionId},oe=x.versions?.find(we=>(0,h.$Ip)(we,ee))?.version,fe=(0,k.$ig)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(we=>(0,h.$Ip)(we,ee))?.includePreRelease,me=te(C),ge=ne(C.versions,x.targetPlatform);if(x.compatible&&(0,c.$ep)(me,x.targetPlatform))return null;for(let we=0;we<ge.length;we++){const he=ge[we];if(!(oe&&he.version!==oe)){if(await this.A(ee.id,he,fe?"any":"release",x.compatible,me,x.targetPlatform,x.productVersion))return x.compatible&&!this.z(ee,H(he))?null:W(C,he,me,Q);if(oe&&he.version===oe)return null}}return oe||x.compatible?null:W(C,C.versions[0],me)}async D(C,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");C=C.withFlags(C.flags,t.ExcludeNonValidated).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExcludeWithFlags,s(t.Unpublished));const Q=await this.j,ee=JSON.stringify(C.raw),oe={...Q,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ee.length)},fe=new l.$de;let me,ge,we=0;try{if(me=await this.l.request({type:"POST",url:this.g&&C.criteria.some(pe=>pe.filterType===o.SearchText)?this.g:this.y("/extensionquery"),data:ee,headers:oe},x),me.res.statusCode&&me.res.statusCode>=400&&me.res.statusCode<500)return{galleryExtensions:[],total:we};const he=await(0,m.$0p)(me);if(he){const pe=he.results[0],be=pe.extensions,Se=pe.resultMetadata&&pe.resultMetadata.filter(V=>V.metadataType==="ResultCount")[0];return we=Se&&Se.metadataItems.filter(V=>V.name==="TotalCount")[0].count||0,{galleryExtensions:be,total:we,context:{[r]:me.res.headers.activityid}}}return{galleryExtensions:[],total:we}}catch(he){if((0,$.$3)(he))throw ge=c.ExtensionGalleryErrorCode.Cancelled,he;{const pe=(0,$.$9)(he);throw ge=pe.startsWith("XHR timeout")?c.ExtensionGalleryErrorCode.Timeout:c.ExtensionGalleryErrorCode.Failed,new c.$ip(pe,ge)}}finally{this.q.publicLog2("galleryService:query",{...C.telemetryData,requestBodySize:String(ee.length),duration:fe.elapsed(),success:!!me&&(0,m.$6p)(me),responseBodySize:me?.res.headers["Content-Length"],statusCode:me?String(me.res.statusCode):void 0,errorCode:ge,count:String(we)})}}async reportStatistic(C,x,Q,ee){if(!this.isEnabled())return;const oe=I.$p?this.y(`/itemName/${C}.${x}/version/${Q}/statType/${ee===c.StatisticType.Install?"1":"3"}/vscodewebextension`):this.y(`/publishers/${C}/extensions/${x}/${Q}/stats?statType=${ee}`),fe=I.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.j,Accept:fe};try{await this.l.request({type:"POST",url:oe,headers:ge},P.CancellationToken.None)}catch{}}async download(C,x,Q){this.n.trace("ExtensionGalleryService#download",C.identifier.id);const ee=(0,h.$Qp)(C),oe=new Date().getTime(),fe=Q===c.InstallOperation.Install?"install":Q===c.InstallOperation.Update?"update":"",me=fe?{uri:`${C.assets.download.uri}${g.URI.parse(C.assets.download.uri).query?"&":"?"}${fe}=true`,fallbackUri:`${C.assets.download.fallbackUri}${g.URI.parse(C.assets.download.fallbackUri).query?"&":"?"}${fe}=true`}:C.assets.download,ge=C.queryContext?.[r]?{[r]:C.queryContext[r]}:void 0,we=await this.F(C.identifier.id,me,u.VSIX,ge?{headers:ge}:void 0);try{await this.u.writeFile(x,we.stream)}catch(he){try{await this.u.del(x)}catch(pe){this.n.warn(`Error while deleting the file ${x.toString()}`,(0,$.$9)(pe))}throw new c.$ip((0,$.$9)(he),c.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.q.publicLog("galleryService:downloadVSIX",{...ee,duration:new Date().getTime()-oe})}async downloadSignatureArchive(C,x){if(!C.assets.signature)throw new Error("No signature asset found");this.n.trace("ExtensionGalleryService#downloadSignatureArchive",C.identifier.id);const Q=await this.F(C.identifier.id,C.assets.signature,u.Signature);try{await this.u.writeFile(x,Q.stream)}catch(ee){try{await this.u.del(x)}catch(oe){this.n.warn(`Error while deleting the file ${x.toString()}`,(0,$.$9)(oe))}throw new c.$ip((0,$.$9)(ee),c.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(C,x){if(C.assets.readme){const Q=await this.F(C.identifier.id,C.assets.readme,u.Details,{},x);return await(0,m.$9p)(Q)||""}return""}async getManifest(C,x){if(C.assets.manifest){const Q=await this.F(C.identifier.id,C.assets.manifest,u.Manifest,{},x),ee=await(0,m.$9p)(Q);return ee?JSON.parse(ee):null}return null}async E(C,x,Q){const ee=re(x,u.Manifest);if(!ee)throw new Error("Manifest was not found");const oe={"Accept-Encoding":"gzip"},fe=await this.F(C,ee,u.Manifest,{headers:oe});return await(0,m.$0p)(fe)}async getCoreTranslation(C,x){const Q=C.assets.coreTranslations.filter(ee=>ee[0]===x.toUpperCase())[0];if(Q){const ee=await this.F(C.identifier.id,Q[1],Q[0]),oe=await(0,m.$9p)(ee);return oe?JSON.parse(oe):null}return null}async getChangelog(C,x){if(C.assets.changelog){const Q=await this.F(C.identifier.id,C.assets.changelog,u.Changelog,{},x);return await(0,m.$9p)(Q)||""}return""}async getAllCompatibleVersions(C,x,Q){let ee=new O().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);C.uuid?ee=ee.withFilter(o.ExtensionId,C.uuid):ee=ee.withFilter(o.ExtensionName,C.id);const{galleryExtensions:oe}=await this.D(ee,P.CancellationToken.None);if(!oe.length)return[];const fe=te(oe[0]);if((0,c.$ep)(fe,Q))return[];const me=[];await Promise.all(oe[0].versions.map(async he=>{try{await this.A(C.id,he,x?"any":"release",!0,fe,Q)&&this.z(C,H(he))&&me.push(he)}catch{}}));const ge=[],we=new Set;for(const he of ne(me,Q))we.has(he.version)||(we.add(he.version),ge.push({version:he.version,date:he.lastUpdated,isPreReleaseVersion:de(he)}));return ge}async F(C,x,Q,ee={},oe=P.CancellationToken.None){const fe=await this.j,me={type:"GET"},ge={...fe,...ee.headers||{}};ee={...ee,...me,headers:ge};const we=x.uri,he=x.fallbackUri,pe={...ee,url:we};try{const be=await this.l.request(pe,oe);if(be.res.statusCode===200)return be;const Se=await(0,m.$9p)(be);throw new Error(`Expected 200, got back ${be.res.statusCode} instead.

${Se}`)}catch(be){if((0,$.$3)(be))throw be;const Se=(0,$.$9)(be);this.q.publicLog2("galleryService:cdnFallback",{extension:C,assetType:Q,message:Se});const V={...ee,url:he};return this.l.request(V,oe)}}async G(C,x){let Q=ce(x);if(!Q){this.q.publicLog2("galleryService:engineFallback",{extension:C,version:x.version});const ee=await this.E(C,x,P.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");Q=ee.engines.vscode}return Q}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const C=await this.l.request({type:"GET",url:this.h},P.CancellationToken.None);if(C.res.statusCode!==200)throw new Error("Could not get extensions report.");const x=await(0,m.$0p)(C),Q=[],ee={},oe=[],fe=[];if(x){for(const me of x.malicious)Q.push({id:me});if(x.migrateToPreRelease)for(const[me,ge]of Object.entries(x.migrateToPreRelease))(!ge.engine||(0,y.$2p)(ge.engine,this.w.version,this.w.date))&&(ee[me.toLowerCase()]={disallowInstall:!0,extension:{id:ge.id,displayName:ge.displayName,autoMigrate:{storage:!!ge.migrateStorage},preRelease:!0}});if(x.deprecated)for(const[me,ge]of Object.entries(x.deprecated))ge&&(ee[me.toLowerCase()]=(0,k.$ig)(ge)?{}:ge);if(x.search)for(const me of x.search)oe.push(me);if(Array.isArray(x.extensionsEnabledWithPreRelease))for(const me of x.extensionsEnabledWithPreRelease)fe.push(me.toLowerCase())}return{malicious:Q,deprecated:ee,search:oe,extensionsEnabledWithPreRelease:fe}}};M=ve([se(1,m.$4p),se(2,E.$9j),se(3,f.$Ji),se(4,i.$8l),se(5,R.$9k),se(6,d.$pk),se(7,a.$9i)],M);let b=class extends M{constructor(C,x,Q,ee,oe,fe,me,ge){super(C,x,Q,ee,oe,fe,me,ge)}};e.$nq=b,e.$nq=b=ve([se(0,w.$eq),se(1,m.$4p),se(2,E.$9j),se(3,f.$Ji),se(4,i.$8l),se(5,R.$9k),se(6,d.$pk),se(7,a.$9i)],b);let F=class extends M{constructor(C,x,Q,ee,oe,fe,me){super(void 0,C,x,Q,ee,oe,fe,me)}};e.$oq=F,e.$oq=F=ve([se(0,m.$4p),se(1,E.$9j),se(2,f.$Ji),se(3,i.$8l),se(4,R.$9k),se(5,d.$pk),se(6,a.$9i)],F)}),define(le[143],ue([0,1,11,17,9,6,122,23,24,3,69]),function(Y,e,S,P,$,I,L,k,g,a,f){"use strict";var c,h;Object.defineProperty(e,"__esModule",{value:!0}),e.$mR=e.$lR=e.$kR=void 0;let p=class extends g.$Ll{static{c=this}static{this.a="profileAssociationsMigration"}constructor(d,m,A,w,i){super(A,w,m,i),this.U=d,this.W=A}O(){return this.U.getItem(c.b,[]).map(m=>({...m,location:(0,a.$cg)(m.location)?this.w.extUri.joinPath(this.profilesHome,m.location):S.URI.revive(m.location)}))}Q(){const d=this.U.getItem(c.c,{});return this.U.getItem(c.a,!1)?d:this.N(d)}S(){return this.w.extUri.joinPath(S.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$kR=p,e.$kR=p=c=ve([se(0,L.$fR),se(1,k.$Gl),se(2,P.$Ki),se(3,$.$9k),se(4,I.$9j)],p);let y=h=class extends p{constructor(d,m,A,w,i){super(d,m,A,w,i),this.$=d}P(d){d.length?this.$.setItem(h.b,d.map(m=>({...m,location:this.w.extUri.basename(m.location)}))):this.$.removeItem(h.b)}O(){const d=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(d),this.$.setItem("userDataProfilesMigration",!0)),d}R(d){d.emptyWindows||d.workspaces?this.$.setItem(h.c,d):this.$.removeItem(h.c)}Q(){const d="workspaceAndProfileInfo",m=this.$.getItem(d,void 0);if(m){this.$.removeItem(d);const w=m.reduce((i,{workspace:l,profile:n})=>(i[S.URI.revive(l).toString()]=S.URI.revive(n).toString(),i),{});this.$.setItem(h.c,{workspaces:w})}const A=super.Q();return this.$.getItem(h.a,!1)||(this.R(A),this.$.setItem(h.a,!0)),A}};e.$lR=y,e.$lR=y=h=ve([se(0,L.$gR),se(1,k.$Gl),se(2,P.$Ki),se(3,$.$9k),se(4,I.$9j)],y);let R=class extends y{constructor(d,m,A,w){super(new f.$jR(f.SaveStrategy.IMMEDIATE,m,w,A),d,m,A,w)}async init(){return await this.$.init(),super.init()}};e.$mR=R,e.$mR=R=ve([se(0,k.$Gl),se(1,P.$Ki),se(2,$.$9k),se(3,I.$9j)],R)}),define(le[144],ue([0,1,120,8,13,7,3,29,17,121,6,46,119,155]),function(Y,e,S,P,$,I,L,k,g,a,f,c,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=void 0,e.$cs=E;let y=class extends c.$5p{constructor(m,A,w,i){super(i),this.m=m,this.n=A,this.r=w,this.s(),this.B(m.onDidChangeConfiguration(l=>{l.affectsConfiguration("http")&&this.s()}))}s(){const m=this.m.getValue("http");this.f=m?.proxy,this.g=!!m?.proxyStrictSSL,this.h=m?.proxyAuthorization}async request(m,A){const{f:w,g:i}=this;let l;try{l=await(0,a.$Nm)(this.m,this.r,this.n.args,process.env)}catch(t){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,I.$9)(t)))}const n={...process.env,...l},r=m.agent?m.agent:await(0,h.$as)(m.url||"",n,{proxyUrl:w,strictSSL:i});return m.agent=r,m.strictSSL=i,this.h&&(m.headers={...m.headers||{},"Proxy-Authorization":this.h}),this.c(m.isChromiumNetwork?"electron":"node",m,()=>E(m,A))}async resolveProxy(m){}async loadCertificates(){return(await new Promise((A,w)=>{Y(["@vscode/proxy-agent"],A,w)}).then(ye)).loadSystemCertificates({log:this.r})}};e.$bs=y,e.$bs=y=ve([se(0,k.$9i),se(1,g.$Ki),se(2,f.$9j),se(3,f.$0j)],y);async function R(d){return((0,S.parse)(d.url).protocol==="https:"?await new Promise((w,i)=>{Y(["https"],w,i)}).then(ye):await new Promise((w,i)=>{Y(["http"],w,i)}).then(ye)).request}async function E(d,m){return P.Promises.withAsyncBody(async(A,w)=>{const i=(0,S.parse)(d.url),l=d.getRawRequest?d.getRawRequest(d):await R(d),n={hostname:i.hostname,port:i.port?parseInt(i.port):i.protocol==="https:"?443:80,protocol:i.protocol,path:i.path,method:d.type||"GET",headers:d.headers,agent:d.agent,rejectUnauthorized:(0,L.$ig)(d.strictSSL)?d.strictSSL:!0};d.user&&d.password&&(n.auth=d.user+":"+d.password);const r=l(n,t=>{const s=(0,L.$gg)(d.followRedirects)?d.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&s>0&&t.headers.location)E({...d,url:t.headers.location,followRedirects:s-1},m).then(A,w);else{let o=t;!d.isChromiumNetwork&&t.headers["content-encoding"]==="gzip"&&(o=t.pipe((0,p.createGunzip)())),A({res:t,stream:(0,$.$1e)(o)})}});r.on("error",w),d.timeout&&r.setTimeout(d.timeout),d.isChromiumNetwork&&r.removeHeader("Content-Length"),d.data&&typeof d.data=="string"&&r.write(d.data),r.end(),m.onCancellationRequested(()=>{r.abort(),w(new I.$4)})})}});var qe=this&&this.__importDefault||function(Y){return Y&&Y.__esModule?Y:{default:Y}};define(le[156],ue([0,1,32,35,8,38,7,2,14,15,12,36,11,29,116,61,118,17,94,142,20,71,123,42,54,137,139,9,106,108,51,104,64,68,125,6,112,39,113,128,33,46,144,69,70,18,127,41,129,130,23,132,24,143,131,138,109,111,5,133,157]),function(Y,e,S,P,$,I,L,k,g,a,f,c,h,p,y,R,E,d,m,A,w,i,l,n,r,t,s,o,u,v,N,T,O,D,q,K,J,re,ae,ce,de,H,Z,B,z,G,X,te,ne,j,W,M,b,F,U,C,x,Q,ee,oe,fe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=ge,S=ye(S),ce=qe(ce);class me extends k.$Tc{constructor(he){super(),this.b=he,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[he,pe]=await this.f();return he.invokeFunction(async be=>{const Se=be.get(K.$9j),V=be.get(o.$9k),_=be.get(d.$Ki),ie=be.get(b.$Il);Se.info("CLI main",this.b),this.h(Se),await this.j(_,V,ie,he),await Promise.all(pe.map($e=>{(0,$.$th)($e.flush(),1e3)}))})}async f(){const he=new O.$Ai,pe={_serviceBrand:void 0,...ce.default};he.set(de.$pk,pe);const be=new m.$5m(this.b,pe);he.set(d.$Ki,be),await Promise.all([this.g(be.appSettingsHome.with({scheme:g.Schemas.file}).fsPath),this.g(be.extensionsPath)].map(Ie=>Ie?S.promises.mkdir(Ie,{recursive:!0}):void 0));const Se=new Q.$eR((0,K.$kk)(be),be.logsHome);he.set(K.$0j,Se);const V=this.B(Se.createLogger("cli",{name:(0,ee.localize)(12761,null)})),_=[];Se.getLogLevel()===K.LogLevel.Trace&&_.push(new K.$ek(Se.getLogLevel()));const ie=this.B(new x.$oR(V,_));he.set(K.$9j,ie);const $e=this.B(new u.$Yq(ie));he.set(o.$9k,$e);const Ee=this.B(new v.$pr(ie));$e.registerProvider(g.Schemas.file,Ee);const De=new M.$Qs($e);he.set(W.$Gl,De);const ke=new B.$iR(B.SaveStrategy.DELAYED,be,ie,$e),Ce=new F.$kR(ke,De,be,$e,ie);he.set(b.$Il,Ce),$e.registerProvider(g.Schemas.vscodeUserData,new oe.$Xgc(g.Schemas.file,Ee,g.Schemas.vscodeUserData,Ce,De,ie));const Oe=f.$j&&pe.win32RegValueName?this.B(new ae.$Vgc(ie,pe.win32RegValueName)):be.policyFile?this.B(new J.$Wgc(be.policyFile,$e,ie)):new re.$ro;he.set(re.$po,Oe);const Le=this.B(new y.$To(Ce.defaultProfile.settingsResource,$e,Oe,ie));he.set(p.$9i,Le),await Promise.all([ke.init(),Le.initialize()]);let ze;try{ze=await(0,U.$xgc)(ke,ie)}catch(Ie){Ie.code!=="ENOENT"&&ie.error(Ie)}const Ne=await(0,U.$ygc)(ke,ie),Te=await(0,U.$zgc)(ke,ie);Ce.init(),he.set(W.$Gl,new M.$Qs($e));const je=new Z.$bs(Le,be,ie,Se);he.set(H.$4p,je),he.set(R.$Xo,new N.$zi(E.$DR,void 0,!0)),he.set(n.$Fq,new N.$zi(C.$nR,void 0,!0)),he.set(r.$Jq,new N.$zi(s.$ugc,void 0,!0)),he.set(i.$pq,new N.$zi(i.$rq,void 0,!0)),he.set(t.$Uq,new N.$zi(t.$Vq,void 0,!0)),he.set(w.$hp,new N.$zi(A.$oq,void 0,!0)),he.set(D.$8r,new N.$zi(q.$0r,void 0,!1));const Ue=[],Pe=(0,te.$Fp)(pe,Le);if((0,te.$Ap)(pe,be)){pe.aiConfig&&pe.aiConfig.ariaKey&&Ue.push(new ne.$cR(je,Pe,"monacoworkbench",null,pe.aiConfig.ariaKey));const Ie={appenders:Ue,sendErrorTelemetry:!1,commonProperties:(0,z.$rp)((0,P.release)(),(0,P.hostname)(),process.arch,pe.commit,pe.version,ze,Ne,Te,Pe),piiPaths:(0,te.$Gp)(be)};he.set(G.$8l,new N.$zi(X.$ds,[Ie],!1))}else he.set(G.$8l,te.$vp);return[new T.$sr(he),Ue]}g(he){if(f.$j){const pe=(0,fe.getUNCHost)(he);pe&&(0,fe.addUNCHostToAllowlist)(pe)}return he}h(he){(0,L.setUnexpectedErrorHandler)(pe=>{const be=(0,I.$nj)(pe,!0);be&&he.error(`[uncaught exception in CLI]: ${be}`)}),process.on("uncaughtException",pe=>{(0,L.$X)(pe)||(0,L.$Y)(pe)}),process.on("unhandledRejection",pe=>(0,L.$Y)(pe))}async j(he,pe,be,Se){let V;if(he.args.profile&&(V=be.profiles.find(ie=>ie.name===he.args.profile),!V))throw new Error(`Profile '${he.args.profile}' not found.`);const _=(V??be.defaultProfile).extensionsResource;if(this.b["list-extensions"])return Se.createInstance(l.$sq,new K.$ek(K.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,_);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const ie={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:_};return Se.createInstance(l.$sq,new K.$ek(K.LogLevel.Info,!1)).installExtensions(this.m(this.b["install-extension"]||[]),this.m(this.b["install-builtin-extension"]||[]),ie,!!this.b.force)}else{if(this.b["uninstall-extension"])return Se.createInstance(l.$sq,new K.$ek(K.LogLevel.Info,!1)).uninstallExtensions(this.m(this.b["uninstall-extension"]),!!this.b.force,_);if(this.b["update-extensions"])return Se.createInstance(l.$sq,new K.$ek(K.LogLevel.Info,!1)).updateExtensions(_);if(this.b["locate-extension"])return Se.createInstance(l.$sq,new K.$ek(K.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,j.$bhc)(he.appRoot,he.extensionsPath))}}m(he){return he.map(pe=>/\.vsix$/i.test(pe)?h.URI.file((0,a.$hc)(pe)?pe:(0,a.$ic)((0,c.cwd)(),pe)):pe)}}async function ge(we){const he=new me(we);try{await he.run()}finally{he.dispose()}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/e6a828c5957959b7a18de37a567d850880101641/core/vs/code/node/cliProcessMain.js.map
