/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var he=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls","vs/base/common/types","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/platform/storage/common/storage","vs/base/common/arrays","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","fs","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","vs/base/common/process","os","vs/base/common/charCode","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/externalServices/common/serviceMachineId","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/hash","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/marshallingIds","vs/base/common/marshalling","net","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/common/date","vs/base/node/zip","vs/platform/instantiation/common/descriptors","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationModels","vs/platform/languagePacks/common/languagePacks","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/processes","vs/base/common/severity","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/uint","vs/base/common/console","vs/amdX","vs/base/node/macAddress","vs/base/node/id","vs/base/node/nodeStreams","vs/base/node/osDisplayProtocolInfo","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/ports","vs/base/node/processes","vs/base/node/ps","vs/base/parts/sandbox/node/electronTypes","vs/base/parts/ipc/node/ipc.mp","vs/base/common/jsonErrorMessages","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionsManifestCache","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","readline","util","path","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ue=function(oe){for(var e=[],I=0,c=oe.length;I<c;I++)e[I]=he[oe[I]];return e};define(he[128],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.LoaderEventType=e.$R=void 0,e.$R=!1;var I;(function(A){A[A.LoaderAvailable=1]="LoaderAvailable",A[A.BeginLoadingScript=10]="BeginLoadingScript",A[A.EndLoadingScriptOK=11]="EndLoadingScriptOK",A[A.EndLoadingScriptError=12]="EndLoadingScriptError",A[A.BeginInvokeFactory=21]="BeginInvokeFactory",A[A.EndInvokeFactory=22]="EndInvokeFactory",A[A.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",A[A.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",A[A.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",A[A.NodeEndNativeRequire=34]="NodeEndNativeRequire",A[A.CachedDataFound=60]="CachedDataFound",A[A.CachedDataMissed=61]="CachedDataMissed",A[A.CachedDataRejected=62]="CachedDataRejected",A[A.CachedDataCreated=63]="CachedDataCreated"})(I||(e.LoaderEventType=I={}));class c{static get(){const L=new Map,N=new Map,O=new Map,k=new Map;function y(l,p){l.has(p.detail)||l.set(p.detail,-p.timestamp)}function R(l,p){const S=l.get(p.detail);S&&(S>=0||l.set(p.detail,S+p.timestamp))}let d=[];typeof oe=="function"&&typeof oe.getStats=="function"&&(d=oe.getStats().slice(0).sort((l,p)=>l.timestamp-p.timestamp));for(const l of d)switch(l.type){case I.BeginLoadingScript:y(L,l);break;case I.EndLoadingScriptOK:case I.EndLoadingScriptError:R(L,l);break;case I.BeginInvokeFactory:y(N,l);break;case I.EndInvokeFactory:R(N,l);break;case I.NodeBeginNativeRequire:y(O,l);break;case I.NodeEndNativeRequire:R(O,l);break;case I.NodeBeginEvaluatingScript:y(k,l);break;case I.NodeEndEvaluatingScript:R(k,l);break}let u=0;O.forEach(l=>u+=l);function $(l){const p=[];return l.forEach((S,g)=>p.push([g,S])),p}return{amdLoad:$(L),amdInvoke:$(N),nodeRequire:$(O),nodeEval:$(k),nodeRequireTotal:u}}static toMarkdownTable(L,N){let O="";const k=[];return L.forEach((y,R)=>{k[R]=y.length}),N.forEach(y=>{y.forEach((R,d)=>{typeof R>"u"&&(R=y[d]="-");const u=R.toString().length;k[d]=Math.max(u,k[d])})}),L.forEach((y,R)=>{O+=`| ${y+" ".repeat(k[R]-y.toString().length)} `}),O+=`|
`,L.forEach((y,R)=>{O+=`| ${"-".repeat(k[R])} `}),O+=`|
`,N.forEach(y=>{y.forEach((R,d)=>{typeof R<"u"&&(O+=`| ${R+" ".repeat(k[d]-R.toString().length)} `)}),O+=`|
`}),O}}e.$S=c}),define(he[129],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lb=void 0,e.$eb=I,e.$fb=c,e.$gb=A,e.$hb=L,e.$ib=N,e.$jb=O,e.$kb=k,e.$mb=R,e.$nb=d,e.$ob=u,e.$pb=$,e.$qb=l;function I(p,S){const g=c(p,S);if(g!==-1)return p[g]}function c(p,S,g=p.length-1){for(let w=g;w>=0;w--){const P=p[w];if(S(P))return w}return-1}function A(p,S){const g=L(p,S);return g===-1?void 0:p[g]}function L(p,S,g=0,w=p.length){let P=g,m=w;for(;P<m;){const o=Math.floor((P+m)/2);S(p[o])?P=o+1:m=o}return P-1}function N(p,S){const g=O(p,S);return g===p.length?void 0:p[g]}function O(p,S,g=0,w=p.length){let P=g,m=w;for(;P<m;){const o=Math.floor((P+m)/2);S(p[o])?m=o:P=o+1}return P}function k(p,S,g=0,w=p.length){const P=O(p,S,g,w);return P===p.length?-1:P}class y{static{this.assertInvariants=!1}constructor(S){this.e=S,this.c=0}findLastMonotonous(S){if(y.assertInvariants){if(this.d){for(const w of this.e)if(this.d(w)&&!S(w))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=S}const g=L(this.e,S,this.c);return this.c=g+1,g===-1?void 0:this.e[g]}}e.$lb=y;function R(p,S){if(p.length===0)return;let g=p[0];for(let w=1;w<p.length;w++){const P=p[w];S(P,g)>0&&(g=P)}return g}function d(p,S){if(p.length===0)return;let g=p[0];for(let w=1;w<p.length;w++){const P=p[w];S(P,g)>=0&&(g=P)}return g}function u(p,S){return R(p,(g,w)=>-S(g,w))}function $(p,S){if(p.length===0)return-1;let g=0;for(let w=1;w<p.length;w++){const P=p[w];S(P,p[g])>0&&(g=w)}return g}function l(p,S){for(const g of p){const w=S(g);if(w!==void 0)return w}}}),define(he[39],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var I;(function(c){c[c.Null=0]="Null",c[c.Backspace=8]="Backspace",c[c.Tab=9]="Tab",c[c.LineFeed=10]="LineFeed",c[c.CarriageReturn=13]="CarriageReturn",c[c.Space=32]="Space",c[c.ExclamationMark=33]="ExclamationMark",c[c.DoubleQuote=34]="DoubleQuote",c[c.Hash=35]="Hash",c[c.DollarSign=36]="DollarSign",c[c.PercentSign=37]="PercentSign",c[c.Ampersand=38]="Ampersand",c[c.SingleQuote=39]="SingleQuote",c[c.OpenParen=40]="OpenParen",c[c.CloseParen=41]="CloseParen",c[c.Asterisk=42]="Asterisk",c[c.Plus=43]="Plus",c[c.Comma=44]="Comma",c[c.Dash=45]="Dash",c[c.Period=46]="Period",c[c.Slash=47]="Slash",c[c.Digit0=48]="Digit0",c[c.Digit1=49]="Digit1",c[c.Digit2=50]="Digit2",c[c.Digit3=51]="Digit3",c[c.Digit4=52]="Digit4",c[c.Digit5=53]="Digit5",c[c.Digit6=54]="Digit6",c[c.Digit7=55]="Digit7",c[c.Digit8=56]="Digit8",c[c.Digit9=57]="Digit9",c[c.Colon=58]="Colon",c[c.Semicolon=59]="Semicolon",c[c.LessThan=60]="LessThan",c[c.Equals=61]="Equals",c[c.GreaterThan=62]="GreaterThan",c[c.QuestionMark=63]="QuestionMark",c[c.AtSign=64]="AtSign",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.OpenSquareBracket=91]="OpenSquareBracket",c[c.Backslash=92]="Backslash",c[c.CloseSquareBracket=93]="CloseSquareBracket",c[c.Caret=94]="Caret",c[c.Underline=95]="Underline",c[c.BackTick=96]="BackTick",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z",c[c.OpenCurlyBrace=123]="OpenCurlyBrace",c[c.Pipe=124]="Pipe",c[c.CloseCurlyBrace=125]="CloseCurlyBrace",c[c.Tilde=126]="Tilde",c[c.NoBreakSpace=160]="NoBreakSpace",c[c.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",c[c.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",c[c.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",c[c.U_Combining_Tilde=771]="U_Combining_Tilde",c[c.U_Combining_Macron=772]="U_Combining_Macron",c[c.U_Combining_Overline=773]="U_Combining_Overline",c[c.U_Combining_Breve=774]="U_Combining_Breve",c[c.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",c[c.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",c[c.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",c[c.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",c[c.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",c[c.U_Combining_Caron=780]="U_Combining_Caron",c[c.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",c[c.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",c[c.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",c[c.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",c[c.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",c[c.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",c[c.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",c[c.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",c[c.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",c[c.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",c[c.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",c[c.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",c[c.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",c[c.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",c[c.U_Combining_Horn=795]="U_Combining_Horn",c[c.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",c[c.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",c[c.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",c[c.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",c[c.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",c[c.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",c[c.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",c[c.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",c[c.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",c[c.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",c[c.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",c[c.U_Combining_Cedilla=807]="U_Combining_Cedilla",c[c.U_Combining_Ogonek=808]="U_Combining_Ogonek",c[c.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",c[c.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",c[c.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",c[c.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",c[c.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",c[c.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",c[c.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",c[c.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",c[c.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",c[c.U_Combining_Low_Line=818]="U_Combining_Low_Line",c[c.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",c[c.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",c[c.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",c[c.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",c[c.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",c[c.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",c[c.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",c[c.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",c[c.U_Combining_Square_Below=827]="U_Combining_Square_Below",c[c.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",c[c.U_Combining_X_Above=829]="U_Combining_X_Above",c[c.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",c[c.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",c[c.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",c[c.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",c[c.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",c[c.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",c[c.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",c[c.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",c[c.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",c[c.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",c[c.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",c[c.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",c[c.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",c[c.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",c[c.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",c[c.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",c[c.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",c[c.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",c[c.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",c[c.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",c[c.U_Combining_Fermata=850]="U_Combining_Fermata",c[c.U_Combining_X_Below=851]="U_Combining_X_Below",c[c.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",c[c.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",c[c.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",c[c.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",c[c.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",c[c.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",c[c.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",c[c.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",c[c.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",c[c.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",c[c.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",c[c.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",c[c.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",c[c.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",c[c.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",c[c.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",c[c.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",c[c.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",c[c.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",c[c.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",c[c.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",c[c.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",c[c.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",c[c.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",c[c.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",c[c.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",c[c.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",c[c.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",c[c.LINE_SEPARATOR=8232]="LINE_SEPARATOR",c[c.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",c[c.NEXT_LINE=133]="NEXT_LINE",c[c.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",c[c.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",c[c.U_DIAERESIS=168]="U_DIAERESIS",c[c.U_MACRON=175]="U_MACRON",c[c.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",c[c.U_CEDILLA=184]="U_CEDILLA",c[c.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",c[c.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",c[c.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",c[c.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",c[c.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",c[c.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",c[c.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",c[c.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",c[c.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",c[c.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",c[c.U_BREVE=728]="U_BREVE",c[c.U_DOT_ABOVE=729]="U_DOT_ABOVE",c[c.U_RING_ABOVE=730]="U_RING_ABOVE",c[c.U_OGONEK=731]="U_OGONEK",c[c.U_SMALL_TILDE=732]="U_SMALL_TILDE",c[c.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",c[c.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",c[c.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",c[c.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",c[c.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",c[c.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",c[c.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",c[c.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",c[c.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",c[c.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",c[c.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",c[c.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",c[c.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",c[c.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",c[c.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",c[c.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",c[c.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",c[c.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",c[c.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",c[c.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",c[c.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",c[c.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",c[c.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",c[c.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",c[c.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",c[c.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",c[c.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",c[c.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",c[c.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",c[c.U_GREEK_TONOS=900]="U_GREEK_TONOS",c[c.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",c[c.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",c[c.U_GREEK_PSILI=8127]="U_GREEK_PSILI",c[c.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",c[c.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",c[c.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",c[c.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",c[c.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",c[c.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",c[c.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",c[c.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",c[c.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",c[c.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",c[c.U_GREEK_VARIA=8175]="U_GREEK_VARIA",c[c.U_GREEK_OXIA=8189]="U_GREEK_OXIA",c[c.U_GREEK_DASIA=8190]="U_GREEK_DASIA",c[c.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",c[c.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",c[c.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",c[c.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",c[c.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",c[c.U_OVERLINE=8254]="U_OVERLINE",c[c.UTF8_BOM=65279]="UTF8_BOM",c[c.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",c[c.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(I||(e.CharCode=I={}))}),define(he[130],ue([0,1]),function(oe,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$g=void 0,e.$c=c,e.$d=A,e.$e=L,e.$f=N;function c(k,y){const R=Object.create(null);for(const d of k){const u=y(d);let $=R[u];$||($=R[u]=[]),$.push(d)}return R}function A(k,y){const R=[],d=[];for(const u of k)y.has(u)||R.push(u);for(const u of y)k.has(u)||d.push(u);return{removed:R,added:d}}function L(k,y){const R=[],d=[];for(const[u,$]of k)y.has(u)||R.push($);for(const[u,$]of y)k.has(u)||d.push($);return{removed:R,added:d}}function N(k,y){const R=new Set;for(const d of y)k.has(d)&&R.add(d);return R}class O{static{I=Symbol.toStringTag}constructor(y,R){this.b=R,this.a=new Map,this[I]="SetWithKey";for(const d of y)this.add(d)}get size(){return this.a.size}add(y){const R=this.b(y);return this.a.set(R,y),this}delete(y){return this.a.delete(this.b(y))}has(y){return this.a.has(this.b(y))}*entries(){for(const y of this.a.values())yield[y,y]}keys(){return this.values()}*values(){for(const y of this.a.values())yield y}clear(){this.a.clear()}forEach(y,R){this.a.forEach(d=>y.call(R,d,d,this))}[Symbol.iterator](){return this.values()}}e.$g=O}),define(he[87],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=c,e.$8h=A,e.$9h=L;function I(N){return(O,k,y)=>{let R=null,d=null;if(typeof y.value=="function"?(R="value",d=y.value):typeof y.get=="function"&&(R="get",d=y.get),!d)throw new Error("not supported");y[R]=N(d,k)}}function c(N,O,k){let y=null,R=null;if(typeof k.value=="function"?(y="value",R=k.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof k.get=="function"&&(y="get",R=k.get),!R)throw new Error("not supported");const d=`$memoize$${O}`;k[y]=function(...u){return this.hasOwnProperty(d)||Object.defineProperty(this,d,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,u)}),this[d]}}function A(N,O,k){return I((y,R)=>{const d=`$debounce$${R}`,u=`$debounce$result$${R}`;return function(...$){this[u]||(this[u]=k?k():void 0),clearTimeout(this[d]),O&&(this[u]=O(this[u],...$),$=[this[u]]),this[d]=setTimeout(()=>{y.apply(this,$),this[u]=k?k():void 0},N)}})}function L(N,O,k){return I((y,R)=>{const d=`$throttle$timer$${R}`,u=`$throttle$result$${R}`,$=`$throttle$lastRun$${R}`,l=`$throttle$pending$${R}`;return function(...p){if(this[u]||(this[u]=k?k():void 0),(this[$]===null||this[$]===void 0)&&(this[$]=-Number.MAX_VALUE),O&&(this[u]=O(this[u],...p)),this[l])return;const S=this[$]+N;S<=Date.now()?(this[$]=Date.now(),y.apply(this,[this[u]]),this[u]=k?k():void 0):(this[l]=!0,this[d]=setTimeout(()=>{this[l]=!1,this[$]=Date.now(),y.apply(this,[this[u]]),this[u]=k?k():void 0},S-Date.now()))}})}}),define(he[8],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$8=e.$4=e.$V=e.$U=void 0,e.setUnexpectedErrorHandler=c,e.$X=A,e.$Y=L,e.$Z=N,e.$1=O,e.$2=k,e.$3=R,e.$5=u,e.$6=$,e.$7=l,e.$9=S;class I{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?m.isErrorNoTelemetry(i)?new m(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(s=>{s(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$U=I,e.$V=new I;function c(h){e.$V.setUnexpectedErrorHandler(h)}function A(h){if(!h||typeof h!="object")return!1;const i=h;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function L(h){R(h)||e.$V.onUnexpectedError(h)}function N(h){R(h)||e.$V.onUnexpectedExternalError(h)}function O(h){if(h instanceof Error){const{name:i,message:s}=h,t=h.stacktrace||h.stack;return{$isError:!0,name:i,message:s,stack:t,noTelemetry:m.isErrorNoTelemetry(h)}}return h}function k(h){let i;return h.noTelemetry?i=new m:(i=new Error,i.name=h.name),i.message=h.message,i.stack=h.stack,i}const y="Canceled";function R(h){return h instanceof d?!0:h instanceof Error&&h.name===y&&h.message===y}class d extends Error{constructor(){super(y),this.name=this.message}}e.$4=d;function u(){const h=new Error(y);return h.name=h.message,h}function $(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}function l(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}class p extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=p;function S(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}class g extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$0=g;class w extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$$=w;class P extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=P;class m extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof m)return i;const s=new m;return s.message=i.message,s.stack=i.stack,s}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$ab=m;class o extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}e.$bb=o}),define(he[17],ue([0,1,8,129]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$8b=e.$7b=e.CompareResult=void 0,e.$rb=A,e.$sb=L,e.$tb=N,e.$ub=O,e.$vb=k,e.$wb=y,e.$xb=R,e.$yb=d,e.$zb=u,e.$Ab=$,e.$Bb=l,e.$Cb=p,e.$Db=S,e.top=g,e.$Fb=w,e.$Gb=m,e.$Hb=o,e.$Ib=h,e.$Jb=i,e.$Kb=s,e.$Lb=t,e.$Mb=n,e.$Nb=r,e.$Ob=a,e.$Pb=f,e.$Qb=v,e.$Rb=C,e.$Sb=b,e.$Tb=E,e.$Ub=T,e.$Vb=j,e.$Wb=U,e.$Xb=F,e.$Yb=K,e.$Zb=W,e.$1b=x,e.$2b=G,e.$3b=ie,e.$4b=V,e.$5b=ne,e.$6b=ce,e.$9b=H;function A(q,M=0){return q[q.length-(1+M)]}function L(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}function N(q,M,Z=(ee,X)=>ee===X){if(q===M)return!0;if(!q||!M||q.length!==M.length)return!1;for(let ee=0,X=q.length;ee<X;ee++)if(!Z(q[ee],M[ee]))return!1;return!0}function O(q,M){const Z=q.length-1;M<Z&&(q[M]=q[Z]),q.pop()}function k(q,M,Z){return y(q.length,ee=>Z(q[ee],M))}function y(q,M){let Z=0,ee=q-1;for(;Z<=ee;){const X=(Z+ee)/2|0,re=M(X);if(re<0)Z=X+1;else if(re>0)ee=X-1;else return X}return-(Z+1)}function R(q,M,Z){if(q=q|0,q>=M.length)throw new TypeError("invalid index");const ee=M[Math.floor(M.length*Math.random())],X=[],re=[],le=[];for(const ge of M){const pe=Z(ge,ee);pe<0?X.push(ge):pe>0?re.push(ge):le.push(ge)}return q<X.length?R(q,X,Z):q<X.length+le.length?le[0]:R(q-(X.length+le.length),re,Z)}function d(q,M){const Z=[];let ee;for(const X of q.slice(0).sort(M))!ee||M(ee[0],X)!==0?(ee=[X],Z.push(ee)):ee.push(X);return Z}function*u(q,M){let Z,ee;for(const X of q)ee!==void 0&&M(ee,X)?Z.push(X):(Z&&(yield Z),Z=[X]),ee=X;Z&&(yield Z)}function $(q,M){for(let Z=0;Z<=q.length;Z++)M(Z===0?void 0:q[Z-1],Z===q.length?void 0:q[Z])}function l(q,M){for(let Z=0;Z<q.length;Z++)M(Z===0?void 0:q[Z-1],q[Z],Z+1===q.length?void 0:q[Z+1])}function p(q,M,Z){const ee=[];function X(ge,pe,Ee){if(pe===0&&Ee.length===0)return;const we=ee[ee.length-1];we&&we.start+we.deleteCount===ge?(we.deleteCount+=pe,we.toInsert.push(...Ee)):ee.push({start:ge,deleteCount:pe,toInsert:Ee})}let re=0,le=0;for(;;){if(re===q.length){X(re,0,M.slice(le));break}if(le===M.length){X(re,q.length-re,[]);break}const ge=q[re],pe=M[le],Ee=Z(ge,pe);Ee===0?(re+=1,le+=1):Ee<0?(X(re,1,[]),re+=1):Ee>0&&(X(re,0,[pe]),le+=1)}return ee}function S(q,M,Z){const ee=p(q,M,Z),X=[],re=[];for(const le of ee)X.push(...q.slice(le.start,le.start+le.deleteCount)),re.push(...le.toInsert);return{removed:X,added:re}}function g(q,M,Z){if(Z===0)return[];const ee=q.slice(0,Z).sort(M);return P(q,M,ee,Z,q.length),ee}function w(q,M,Z,ee,X){return Z===0?Promise.resolve([]):new Promise((re,le)=>{(async()=>{const ge=q.length,pe=q.slice(0,Z).sort(M);for(let Ee=Z,we=Math.min(Z+ee,ge);Ee<ge;Ee=we,we=Math.min(we+ee,ge)){if(Ee>Z&&await new Promise(be=>setTimeout(be)),X&&X.isCancellationRequested)throw new I.$4;P(q,M,pe,Ee,we)}return pe})().then(re,le)})}function P(q,M,Z,ee,X){for(const re=Z.length;ee<X;ee++){const le=q[ee];if(M(le,Z[re-1])<0){Z.pop();const ge=(0,c.$jb)(Z,pe=>M(le,pe)<0);Z.splice(ge,0,le)}}}function m(q){return q.filter(M=>!!M)}function o(q){let M=0;for(let Z=0;Z<q.length;Z++)q[Z]&&(q[M]=q[Z],M+=1);q.length=M}function h(q,M,Z){q.splice(Z,0,q.splice(M,1)[0])}function i(q){return!Array.isArray(q)||q.length===0}function s(q){return Array.isArray(q)&&q.length>0}function t(q,M=Z=>Z){const Z=new Set;return q.filter(ee=>{const X=M(ee);return Z.has(X)?!1:(Z.add(X),!0)})}function n(q){const M=new Set;return Z=>{const ee=q(Z);return M.has(ee)?!1:(M.add(ee),!0)}}function r(q,M){return q.length>0?q[0]:M}function a(q,M){return q.length>0?q[q.length-1]:M}function f(q,M,Z=(ee,X)=>ee===X){let ee=0;for(let X=0,re=Math.min(q.length,M.length);X<re&&Z(q[X],M[X]);X++)ee++;return ee}function v(q,M){let Z=typeof M=="number"?q:0;typeof M=="number"?Z=q:(Z=0,M=q);const ee=[];if(Z<=M)for(let X=Z;X<M;X++)ee.push(X);else for(let X=Z;X>M;X--)ee.push(X);return ee}function C(q,M,Z){return q.reduce((ee,X)=>(ee[M(X)]=Z?Z(X):X,ee),Object.create(null))}function b(q,M){return q.push(M),()=>E(q,M)}function E(q,M){const Z=q.indexOf(M);if(Z>-1)return q.splice(Z,1),M}function T(q,M,Z){const ee=q.slice(0,M),X=q.slice(M);return ee.concat(Z,X)}function j(q,M){let Z;if(typeof M=="number"){let ee=M;Z=()=>{const X=Math.sin(ee++)*179426549;return X-Math.floor(X)}}else Z=Math.random;for(let ee=q.length-1;ee>0;ee-=1){const X=Math.floor(Z()*(ee+1)),re=q[ee];q[ee]=q[X],q[X]=re}}function U(q,M){const Z=q.indexOf(M);Z>-1&&(q.splice(Z,1),q.unshift(M))}function F(q,M){const Z=q.indexOf(M);Z>-1&&(q.splice(Z,1),q.push(M))}function K(q,M){for(const Z of M)q.push(Z)}function W(q,M){return Array.isArray(q)?q.map(M):M(q)}function x(q){return Array.isArray(q)?q:[q]}function G(q){return q[Math.floor(Math.random()*q.length)]}function ie(q,M,Z){const ee=z(q,M),X=q.length,re=Z.length;q.length=X+re;for(let le=X-1;le>=ee;le--)q[le+re]=q[le];for(let le=0;le<re;le++)q[le+ee]=Z[le]}function V(q,M,Z,ee){const X=z(q,M);let re=q.splice(X,Z);return re===void 0&&(re=[]),ie(q,X,ee),re}function z(q,M){return M<0?Math.max(M+q.length,0):Math.min(M,q.length)}var _;(function(q){function M(re){return re<0}q.isLessThan=M;function Z(re){return re<=0}q.isLessThanOrEqual=Z;function ee(re){return re>0}q.isGreaterThan=ee;function X(re){return re===0}q.isNeitherLessOrGreaterThan=X,q.greaterThan=1,q.lessThan=-1,q.neitherLessOrGreaterThan=0})(_||(e.CompareResult=_={}));function ne(q,M){return(Z,ee)=>M(q(Z),q(ee))}function ce(...q){return(M,Z)=>{for(const ee of q){const X=ee(M,Z);if(!_.isNeitherLessOrGreaterThan(X))return X}return _.neitherLessOrGreaterThan}}const te=(q,M)=>q-M;e.$7b=te;const Y=(q,M)=>(0,e.$7b)(q?1:0,M?1:0);e.$8b=Y;function H(q){return(M,Z)=>-q(M,Z)}class B{constructor(M){this.g=M,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(M){let Z=this.c;for(;Z<this.g.length&&M(this.g[Z]);)Z++;const ee=Z===this.c?null:this.g.slice(this.c,Z);return this.c=Z,ee}takeFromEndWhile(M){let Z=this.d;for(;Z>=0&&M(this.g[Z]);)Z--;const ee=Z===this.d?null:this.g.slice(Z+1,this.d+1);return this.d=Z,ee}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const M=this.g[this.c];return this.c++,M}removeLast(){const M=this.g[this.d];return this.d--,M}takeCount(M){const Z=this.g.slice(this.c,this.c+M);return this.c+=M,Z}}e.$0b=B;class D{static{this.empty=new D(M=>{})}constructor(M){this.iterate=M}forEach(M){this.iterate(Z=>(M(Z),!0))}toArray(){const M=[];return this.iterate(Z=>(M.push(Z),!0)),M}filter(M){return new D(Z=>this.iterate(ee=>M(ee)?Z(ee):!0))}map(M){return new D(Z=>this.iterate(ee=>Z(M(ee))))}some(M){let Z=!1;return this.iterate(ee=>(Z=M(ee),!Z)),Z}findFirst(M){let Z;return this.iterate(ee=>M(ee)?(Z=ee,!1):!0),Z}findLast(M){let Z;return this.iterate(ee=>(M(ee)&&(Z=ee),!0)),Z}findLastMaxBy(M){let Z,ee=!0;return this.iterate(X=>((ee||_.isGreaterThan(M(X,Z)))&&(ee=!1,Z=X),!0)),Z}}e.$$b=D;class J{constructor(M){this.c=M}static createSortPermutation(M,Z){const ee=Array.from(M.keys()).sort((X,re)=>Z(M[X],M[re]));return new J(ee)}apply(M){return M.map((Z,ee)=>M[this.c[ee]])}inverse(){const M=this.c.slice();for(let Z=0;Z<this.c.length;Z++)M[this.c[Z]]=Z;return new J(M)}}e.$_b=J}),define(he[131],ue([0,1,8]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=c,e.$dd=A,e.$ed=L,e.$fd=N,e.$gd=O,e.$hd=k;function c(y,R){if(!y)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}function A(y,R="Unreachable"){throw new Error(R)}function L(y,R="unexpected state"){if(!y)throw new I.$bb(`Assertion Failed: ${R}`)}function N(y){y||(0,I.$Y)(new I.$bb("Soft Assertion Failed"))}function O(y){if(!y()){debugger;y(),(0,I.$Y)(new I.$bb("Assertion Failed"))}}function k(y,R){let d=0;for(;d<y.length-1;){const u=y[d],$=y[d+1];if(!R(u,$))return!1;d++}return!0}}),define(he[88],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=I;function I(c,A){const L=this;let N=!1,O;return function(){if(N)return O;if(N=!0,A)try{O=c.apply(L,arguments)}finally{A()}else O=c.apply(L,arguments);return O}}}),define(he[63],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(c){function A(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}c.is=A;const L=Object.freeze([]);function N(){return L}c.empty=N;function*O(i){yield i}c.single=O;function k(i){return A(i)?i:O(i)}c.wrap=k;function y(i){return i||L}c.from=y;function*R(i){for(let s=i.length-1;s>=0;s--)yield i[s]}c.reverse=R;function d(i){return!i||i[Symbol.iterator]().next().done===!0}c.isEmpty=d;function u(i){return i[Symbol.iterator]().next().value}c.first=u;function $(i,s){let t=0;for(const n of i)if(s(n,t++))return!0;return!1}c.some=$;function l(i,s){for(const t of i)if(s(t))return t}c.find=l;function*p(i,s){for(const t of i)s(t)&&(yield t)}c.filter=p;function*S(i,s){let t=0;for(const n of i)yield s(n,t++)}c.map=S;function*g(i,s){let t=0;for(const n of i)yield*s(n,t++)}c.flatMap=g;function*w(...i){for(const s of i)yield*s}c.concat=w;function P(i,s,t){let n=t;for(const r of i)n=s(n,r);return n}c.reduce=P;function*m(i,s,t=i.length){for(s<0&&(s+=i.length),t<0?t+=i.length:t>i.length&&(t=i.length);s<t;s++)yield i[s]}c.slice=m;function o(i,s=Number.POSITIVE_INFINITY){const t=[];if(s===0)return[t,i];const n=i[Symbol.iterator]();for(let r=0;r<s;r++){const a=n.next();if(a.done)return[t,c.empty()];t.push(a.value)}return[t,{[Symbol.iterator](){return n}}]}c.consume=o;async function h(i){const s=[];for await(const t of i)s.push(t);return Promise.resolve(s)}c.asyncToArray=h})(I||(e.Iterable=I={}))}),define(he[35],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Sn=N,e.$Tn=d,e.$Un=u,e.$Vn=$,e.$Wn=l,e.$Xn=p,e.$Yn=S,e.$Zn=g,e.$1n=w,e.$2n=P,e.$3n=m;var I;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var c;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(c||(e.SyntaxKind=c={}));var A;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(A||(e.ParseErrorCode=A={}));var L;(function(o){o.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function N(o,h=!1){let i=0;const s=o.length;let t="",n=0,r=c.Unknown,a=I.None;function f(U){let F=0,K=0;for(;F<U;){const W=o.charCodeAt(i);if(W>=R._0&&W<=R._9)K=K*16+W-R._0;else if(W>=R.A&&W<=R.F)K=K*16+W-R.A+10;else if(W>=R.a&&W<=R.f)K=K*16+W-R.a+10;else break;i++,F++}return F<U&&(K=-1),K}function v(U){i=U,t="",n=0,r=c.Unknown,a=I.None}function C(){const U=i;if(o.charCodeAt(i)===R._0)i++;else for(i++;i<o.length&&y(o.charCodeAt(i));)i++;if(i<o.length&&o.charCodeAt(i)===R.dot)if(i++,i<o.length&&y(o.charCodeAt(i)))for(i++;i<o.length&&y(o.charCodeAt(i));)i++;else return a=I.UnexpectedEndOfNumber,o.substring(U,i);let F=i;if(i<o.length&&(o.charCodeAt(i)===R.E||o.charCodeAt(i)===R.e))if(i++,(i<o.length&&o.charCodeAt(i)===R.plus||o.charCodeAt(i)===R.minus)&&i++,i<o.length&&y(o.charCodeAt(i))){for(i++;i<o.length&&y(o.charCodeAt(i));)i++;F=i}else a=I.UnexpectedEndOfNumber;return o.substring(U,F)}function b(){let U="",F=i;for(;;){if(i>=s){U+=o.substring(F,i),a=I.UnexpectedEndOfString;break}const K=o.charCodeAt(i);if(K===R.doubleQuote){U+=o.substring(F,i),i++;break}if(K===R.backslash){if(U+=o.substring(F,i),i++,i>=s){a=I.UnexpectedEndOfString;break}switch(o.charCodeAt(i++)){case R.doubleQuote:U+='"';break;case R.backslash:U+="\\";break;case R.slash:U+="/";break;case R.b:U+="\b";break;case R.f:U+="\f";break;case R.n:U+=`
`;break;case R.r:U+="\r";break;case R.t:U+="	";break;case R.u:{const x=f(4);x>=0?U+=String.fromCharCode(x):a=I.InvalidUnicode;break}default:a=I.InvalidEscapeCharacter}F=i;continue}if(K>=0&&K<=31)if(k(K)){U+=o.substring(F,i),a=I.UnexpectedEndOfString;break}else a=I.InvalidCharacter;i++}return U}function E(){if(t="",a=I.None,n=i,i>=s)return n=s,r=c.EOF;let U=o.charCodeAt(i);if(O(U)){do i++,t+=String.fromCharCode(U),U=o.charCodeAt(i);while(O(U));return r=c.Trivia}if(k(U))return i++,t+=String.fromCharCode(U),U===R.carriageReturn&&o.charCodeAt(i)===R.lineFeed&&(i++,t+=`
`),r=c.LineBreakTrivia;switch(U){case R.openBrace:return i++,r=c.OpenBraceToken;case R.closeBrace:return i++,r=c.CloseBraceToken;case R.openBracket:return i++,r=c.OpenBracketToken;case R.closeBracket:return i++,r=c.CloseBracketToken;case R.colon:return i++,r=c.ColonToken;case R.comma:return i++,r=c.CommaToken;case R.doubleQuote:return i++,t=b(),r=c.StringLiteral;case R.slash:{const F=i-1;if(o.charCodeAt(i+1)===R.slash){for(i+=2;i<s&&!k(o.charCodeAt(i));)i++;return t=o.substring(F,i),r=c.LineCommentTrivia}if(o.charCodeAt(i+1)===R.asterisk){i+=2;const K=s-1;let W=!1;for(;i<K;){if(o.charCodeAt(i)===R.asterisk&&o.charCodeAt(i+1)===R.slash){i+=2,W=!0;break}i++}return W||(i++,a=I.UnexpectedEndOfComment),t=o.substring(F,i),r=c.BlockCommentTrivia}return t+=String.fromCharCode(U),i++,r=c.Unknown}case R.minus:if(t+=String.fromCharCode(U),i++,i===s||!y(o.charCodeAt(i)))return r=c.Unknown;case R._0:case R._1:case R._2:case R._3:case R._4:case R._5:case R._6:case R._7:case R._8:case R._9:return t+=C(),r=c.NumericLiteral;default:for(;i<s&&T(U);)i++,U=o.charCodeAt(i);if(n!==i){switch(t=o.substring(n,i),t){case"true":return r=c.TrueKeyword;case"false":return r=c.FalseKeyword;case"null":return r=c.NullKeyword}return r=c.Unknown}return t+=String.fromCharCode(U),i++,r=c.Unknown}}function T(U){if(O(U)||k(U))return!1;switch(U){case R.closeBrace:case R.closeBracket:case R.openBrace:case R.openBracket:case R.doubleQuote:case R.colon:case R.comma:case R.slash:return!1}return!0}function j(){let U;do U=E();while(U>=c.LineCommentTrivia&&U<=c.Trivia);return U}return{setPosition:v,getPosition:()=>i,scan:h?j:E,getToken:()=>r,getTokenValue:()=>t,getTokenOffset:()=>n,getTokenLength:()=>i-n,getTokenError:()=>a}}function O(o){return o===R.space||o===R.tab||o===R.verticalTab||o===R.formFeed||o===R.nonBreakingSpace||o===R.ogham||o>=R.enQuad&&o<=R.zeroWidthSpace||o===R.narrowNoBreakSpace||o===R.mathematicalSpace||o===R.ideographicSpace||o===R.byteOrderMark}function k(o){return o===R.lineFeed||o===R.carriageReturn||o===R.lineSeparator||o===R.paragraphSeparator}function y(o){return o>=R._0&&o<=R._9}var R;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(R||(R={}));function d(o,h){const i=[],s=new Object;let t;const n={value:{},offset:0,length:0,type:"object",parent:void 0};let r=!1;function a(f,v,C,b){n.value=f,n.offset=v,n.length=C,n.type=b,n.colonOffset=void 0,t=n}try{P(o,{onObjectBegin:(f,v)=>{if(h<=f)throw s;t=void 0,r=h>f,i.push("")},onObjectProperty:(f,v,C)=>{if(h<v||(a(f,v,C,"property"),i[i.length-1]=f,h<=v+C))throw s},onObjectEnd:(f,v)=>{if(h<=f)throw s;t=void 0,i.pop()},onArrayBegin:(f,v)=>{if(h<=f)throw s;t=void 0,i.push(0)},onArrayEnd:(f,v)=>{if(h<=f)throw s;t=void 0,i.pop()},onLiteralValue:(f,v,C)=>{if(h<v||(a(f,v,C,m(f)),h<=v+C))throw s},onSeparator:(f,v,C)=>{if(h<=v)throw s;if(f===":"&&t&&t.type==="property")t.colonOffset=v,r=!1,t=void 0;else if(f===","){const b=i[i.length-1];typeof b=="number"?i[i.length-1]=b+1:(r=!0,i[i.length-1]=""),t=void 0}}})}catch(f){if(f!==s)throw f}return{path:i,previousNode:t,isAtPropertyKey:r,matches:f=>{let v=0;for(let C=0;v<f.length&&C<i.length;C++)if(f[v]===i[C]||f[v]==="*")v++;else if(f[v]!=="**")return!1;return v===f.length}}}function u(o,h=[],i=L.DEFAULT){let s=null,t=[];const n=[];function r(f){Array.isArray(t)?t.push(f):s!==null&&(t[s]=f)}return P(o,{onObjectBegin:()=>{const f={};r(f),n.push(t),t=f,s=null},onObjectProperty:f=>{s=f},onObjectEnd:()=>{t=n.pop()},onArrayBegin:()=>{const f=[];r(f),n.push(t),t=f,s=null},onArrayEnd:()=>{t=n.pop()},onLiteralValue:r,onError:(f,v,C)=>{h.push({error:f,offset:v,length:C})}},i),t[0]}function $(o,h=[],i=L.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(f){s.type==="property"&&(s.length=f-s.offset,s=s.parent)}function n(f){return s.children.push(f),f}P(o,{onObjectBegin:f=>{s=n({type:"object",offset:f,length:-1,parent:s,children:[]})},onObjectProperty:(f,v,C)=>{s=n({type:"property",offset:v,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:f,offset:v,length:C,parent:s})},onObjectEnd:(f,v)=>{s.length=f+v-s.offset,s=s.parent,t(f+v)},onArrayBegin:(f,v)=>{s=n({type:"array",offset:f,length:-1,parent:s,children:[]})},onArrayEnd:(f,v)=>{s.length=f+v-s.offset,s=s.parent,t(f+v)},onLiteralValue:(f,v,C)=>{n({type:m(f),offset:v,length:C,parent:s,value:f}),t(v+C)},onSeparator:(f,v,C)=>{s.type==="property"&&(f===":"?s.colonOffset=v:f===","&&t(v))},onError:(f,v,C)=>{h.push({error:f,offset:v,length:C})}},i);const a=s.children[0];return a&&delete a.parent,a}function l(o,h){if(!o)return;let i=o;for(const s of h)if(typeof s=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let t=!1;for(const n of i.children)if(Array.isArray(n.children)&&n.children[0].value===s){i=n.children[1],t=!0;break}if(!t)return}else{const t=s;if(i.type!=="array"||t<0||!Array.isArray(i.children)||t>=i.children.length)return;i=i.children[t]}return i}function p(o){if(!o.parent||!o.parent.children)return[];const h=p(o.parent);if(o.parent.type==="property"){const i=o.parent.children[0].value;h.push(i)}else if(o.parent.type==="array"){const i=o.parent.children.indexOf(o);i!==-1&&h.push(i)}return h}function S(o){switch(o.type){case"array":return o.children.map(S);case"object":{const h=Object.create(null);for(const i of o.children){const s=i.children[1];s&&(h[i.children[0].value]=S(s))}return h}case"null":case"string":case"number":case"boolean":return o.value;default:return}}function g(o,h,i=!1){return h>=o.offset&&h<o.offset+o.length||i&&h===o.offset+o.length}function w(o,h,i=!1){if(g(o,h,i)){const s=o.children;if(Array.isArray(s))for(let t=0;t<s.length&&s[t].offset<=h;t++){const n=w(s[t],h,i);if(n)return n}return o}}function P(o,h,i=L.DEFAULT){const s=N(o,!1);function t(ne){return ne?()=>ne(s.getTokenOffset(),s.getTokenLength()):()=>!0}function n(ne){return ne?ce=>ne(ce,s.getTokenOffset(),s.getTokenLength()):()=>!0}const r=t(h.onObjectBegin),a=n(h.onObjectProperty),f=t(h.onObjectEnd),v=t(h.onArrayBegin),C=t(h.onArrayEnd),b=n(h.onLiteralValue),E=n(h.onSeparator),T=t(h.onComment),j=n(h.onError),U=i&&i.disallowComments,F=i&&i.allowTrailingComma;function K(){for(;;){const ne=s.scan();switch(s.getTokenError()){case I.InvalidUnicode:W(A.InvalidUnicode);break;case I.InvalidEscapeCharacter:W(A.InvalidEscapeCharacter);break;case I.UnexpectedEndOfNumber:W(A.UnexpectedEndOfNumber);break;case I.UnexpectedEndOfComment:U||W(A.UnexpectedEndOfComment);break;case I.UnexpectedEndOfString:W(A.UnexpectedEndOfString);break;case I.InvalidCharacter:W(A.InvalidCharacter);break}switch(ne){case c.LineCommentTrivia:case c.BlockCommentTrivia:U?W(A.InvalidCommentToken):T();break;case c.Unknown:W(A.InvalidSymbol);break;case c.Trivia:case c.LineBreakTrivia:break;default:return ne}}}function W(ne,ce=[],te=[]){if(j(ne),ce.length+te.length>0){let Y=s.getToken();for(;Y!==c.EOF;){if(ce.indexOf(Y)!==-1){K();break}else if(te.indexOf(Y)!==-1)break;Y=K()}}}function x(ne){const ce=s.getTokenValue();return ne?b(ce):a(ce),K(),!0}function G(){switch(s.getToken()){case c.NumericLiteral:{let ne=0;try{ne=JSON.parse(s.getTokenValue()),typeof ne!="number"&&(W(A.InvalidNumberFormat),ne=0)}catch{W(A.InvalidNumberFormat)}b(ne);break}case c.NullKeyword:b(null);break;case c.TrueKeyword:b(!0);break;case c.FalseKeyword:b(!1);break;default:return!1}return K(),!0}function ie(){return s.getToken()!==c.StringLiteral?(W(A.PropertyNameExpected,[],[c.CloseBraceToken,c.CommaToken]),!1):(x(!1),s.getToken()===c.ColonToken?(E(":"),K(),_()||W(A.ValueExpected,[],[c.CloseBraceToken,c.CommaToken])):W(A.ColonExpected,[],[c.CloseBraceToken,c.CommaToken]),!0)}function V(){r(),K();let ne=!1;for(;s.getToken()!==c.CloseBraceToken&&s.getToken()!==c.EOF;){if(s.getToken()===c.CommaToken){if(ne||W(A.ValueExpected,[],[]),E(","),K(),s.getToken()===c.CloseBraceToken&&F)break}else ne&&W(A.CommaExpected,[],[]);ie()||W(A.ValueExpected,[],[c.CloseBraceToken,c.CommaToken]),ne=!0}return f(),s.getToken()!==c.CloseBraceToken?W(A.CloseBraceExpected,[c.CloseBraceToken],[]):K(),!0}function z(){v(),K();let ne=!1;for(;s.getToken()!==c.CloseBracketToken&&s.getToken()!==c.EOF;){if(s.getToken()===c.CommaToken){if(ne||W(A.ValueExpected,[],[]),E(","),K(),s.getToken()===c.CloseBracketToken&&F)break}else ne&&W(A.CommaExpected,[],[]);_()||W(A.ValueExpected,[],[c.CloseBracketToken,c.CommaToken]),ne=!0}return C(),s.getToken()!==c.CloseBracketToken?W(A.CloseBracketExpected,[c.CloseBracketToken],[]):K(),!0}function _(){switch(s.getToken()){case c.OpenBracketToken:return z();case c.OpenBraceToken:return V();case c.StringLiteral:return x(!0);default:return G()}}return K(),s.getToken()===c.EOF?i.allowEmptyContent?!0:(W(A.ValueExpected,[],[]),!1):_()?(s.getToken()!==c.EOF&&W(A.EndOfFileExpected,[],[]),!0):(W(A.ValueExpected,[],[]),!1)}function m(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}}),define(he[45],ue([0,1,35]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4n=c,e.$5n=A,e.$6n=O,e.$7n=k;function c(y,R,d){let u,$,l,p,S;if(R){for(p=R.offset,S=p+R.length,l=p;l>0&&!k(y,l-1);)l--;let a=S;for(;a<y.length&&!k(y,a);)a++;$=y.substring(l,a),u=N($,d)}else $=y,u=0,l=0,p=0,S=y.length;const g=O(d,y);let w=!1,P=0,m;d.insertSpaces?m=L(" ",d.tabSize||4):m="	";const o=(0,I.$Sn)($,!1);let h=!1;function i(){return g+L(m,u+P)}function s(){let a=o.scan();for(w=!1;a===I.SyntaxKind.Trivia||a===I.SyntaxKind.LineBreakTrivia;)w=w||a===I.SyntaxKind.LineBreakTrivia,a=o.scan();return h=a===I.SyntaxKind.Unknown||o.getTokenError()!==I.ScanError.None,a}const t=[];function n(a,f,v){!h&&f<S&&v>p&&y.substring(f,v)!==a&&t.push({offset:f,length:v-f,content:a})}let r=s();if(r!==I.SyntaxKind.EOF){const a=o.getTokenOffset()+l,f=L(m,u);n(f,l,a)}for(;r!==I.SyntaxKind.EOF;){let a=o.getTokenOffset()+o.getTokenLength()+l,f=s(),v="";for(;!w&&(f===I.SyntaxKind.LineCommentTrivia||f===I.SyntaxKind.BlockCommentTrivia);){const b=o.getTokenOffset()+l;n(" ",a,b),a=o.getTokenOffset()+o.getTokenLength()+l,v=f===I.SyntaxKind.LineCommentTrivia?i():"",f=s()}if(f===I.SyntaxKind.CloseBraceToken)r!==I.SyntaxKind.OpenBraceToken&&(P--,v=i());else if(f===I.SyntaxKind.CloseBracketToken)r!==I.SyntaxKind.OpenBracketToken&&(P--,v=i());else{switch(r){case I.SyntaxKind.OpenBracketToken:case I.SyntaxKind.OpenBraceToken:P++,v=i();break;case I.SyntaxKind.CommaToken:case I.SyntaxKind.LineCommentTrivia:v=i();break;case I.SyntaxKind.BlockCommentTrivia:w?v=i():v=" ";break;case I.SyntaxKind.ColonToken:v=" ";break;case I.SyntaxKind.StringLiteral:if(f===I.SyntaxKind.ColonToken){v="";break}case I.SyntaxKind.NullKeyword:case I.SyntaxKind.TrueKeyword:case I.SyntaxKind.FalseKeyword:case I.SyntaxKind.NumericLiteral:case I.SyntaxKind.CloseBraceToken:case I.SyntaxKind.CloseBracketToken:f===I.SyntaxKind.LineCommentTrivia||f===I.SyntaxKind.BlockCommentTrivia?v=" ":f!==I.SyntaxKind.CommaToken&&f!==I.SyntaxKind.EOF&&(h=!0);break;case I.SyntaxKind.Unknown:h=!0;break}w&&(f===I.SyntaxKind.LineCommentTrivia||f===I.SyntaxKind.BlockCommentTrivia)&&(v=i())}const C=o.getTokenOffset()+l;n(v,a,C),r=f}return t}function A(y,R){const d=JSON.stringify(y,void 0,R.insertSpaces?R.tabSize||4:"	");return R.eol!==void 0?d.replace(/\r\n|\r|\n/g,R.eol):d}function L(y,R){let d="";for(let u=0;u<R;u++)d+=y;return d}function N(y,R){let d=0,u=0;const $=R.tabSize||4;for(;d<y.length;){const l=y.charAt(d);if(l===" ")u++;else if(l==="	")u+=$;else break;d++}return Math.floor(u/$)}function O(y,R){for(let d=0;d<R.length;d++){const u=R.charAt(d);if(u==="\r")return d+1<R.length&&R.charAt(d+1)===`
`?`\r
`:"\r";if(u===`
`)return`
`}return y&&y.eol||`
`}function k(y,R){return`\r
`.indexOf(y.charAt(R))!==-1}}),define(he[64],ue([0,1,35,45]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8n=A,e.$9n=L,e.$0n=N,e.$$n=O,e.$_n=k;function A(y,R,d){return L(y,R,void 0,d)}function L(y,R,d,u,$){const l=R.slice(),p=[],S=(0,I.$Vn)(y,p);let g,w;for(;l.length>0&&(w=l.pop(),g=(0,I.$Wn)(S,l),g===void 0&&d!==void 0);)typeof w=="string"?d={[w]:d}:d=[d];if(g)if(g.type==="object"&&typeof w=="string"&&Array.isArray(g.children)){const P=(0,I.$Wn)(g,[w]);if(P!==void 0)if(d===void 0){if(!P.parent)throw new Error("Malformed AST");const m=g.children.indexOf(P.parent);let o,h=P.parent.offset+P.parent.length;if(m>0){const i=g.children[m-1];o=i.offset+i.length}else o=g.offset+1,g.children.length>1&&(h=g.children[1].offset);return N(y,{offset:o,length:h-o,content:""},u)}else return N(y,{offset:P.offset,length:P.length,content:JSON.stringify(d)},u);else{if(d===void 0)return[];const m=`${JSON.stringify(w)}: ${JSON.stringify(d)}`,o=$?$(g.children.map(i=>i.children[0].value)):g.children.length;let h;if(o>0){const i=g.children[o-1];h={offset:i.offset+i.length,length:0,content:","+m}}else g.children.length===0?h={offset:g.offset+1,length:0,content:m}:h={offset:g.offset+1,length:0,content:m+","};return N(y,h,u)}}else if(g.type==="array"&&typeof w=="number"&&Array.isArray(g.children))if(d!==void 0){const P=`${JSON.stringify(d)}`;let m;if(g.children.length===0||w===0)m={offset:g.offset+1,length:0,content:g.children.length===0?P:P+","};else{const o=w===-1||w>g.children.length?g.children.length:w,h=g.children[o-1];m={offset:h.offset+h.length,length:0,content:","+P}}return N(y,m,u)}else{const P=w,m=g.children[P];let o;if(g.children.length===1)o={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===P){const h=g.children[P-1],i=h.offset+h.length,s=g.offset+g.length;o={offset:i,length:s-2-i,content:""}}else o={offset:m.offset,length:g.children[P+1].offset-m.offset,content:""};return N(y,o,u)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${g.type}`);else return d===void 0?[]:N(y,{offset:S?S.offset:0,length:S?S.length:0,content:JSON.stringify(d)},u)}function N(y,R,d){let u=O(y,R),$=R.offset,l=R.offset+R.content.length;if(R.length===0||R.content.length===0){for(;$>0&&!(0,c.$7n)(u,$-1);)$--;for(;l<u.length&&!(0,c.$7n)(u,l);)l++}const p=(0,c.$4n)(u,{offset:$,length:l-$},d);for(let g=p.length-1;g>=0;g--){const w=p[g];u=O(u,w),$=Math.min($,w.offset),l=Math.max(l,w.offset+w.length),l+=w.content.length-w.length}const S=y.length-(u.length-l)-$;return[{offset:$,length:S,content:u.substring($,l)}]}function O(y,R){return y.substring(0,R.offset)+R.content+y.substring(R.offset+R.length)}function k(y,R){const d=R.slice(0).sort(($,l)=>{const p=$.offset-l.offset;return p===0?$.length-l.length:p});let u=y.length;for(let $=d.length-1;$>=0;$--){const l=d[$];if(l.offset+l.length<=u)y=O(y,l);else throw new Error("Overlapping edit");u=l.offset}return y}}),define(he[53],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class I{constructor(A){this.d=A,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(A){this.c=A}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=I}),define(he[89],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class I{static{this.Undefined=new I(void 0)}constructor(L){this.element=L,this.next=I.Undefined,this.prev=I.Undefined}}class c{constructor(){this.a=I.Undefined,this.b=I.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===I.Undefined}clear(){let L=this.a;for(;L!==I.Undefined;){const N=L.next;L.prev=I.Undefined,L.next=I.Undefined,L=N}this.a=I.Undefined,this.b=I.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,N){const O=new I(L);if(this.a===I.Undefined)this.a=O,this.b=O;else if(N){const y=this.b;this.b=O,O.prev=y,y.next=O}else{const y=this.a;this.a=O,O.next=y,y.prev=O}this.c+=1;let k=!1;return()=>{k||(k=!0,this.e(O))}}shift(){if(this.a!==I.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==I.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==I.Undefined&&L.next!==I.Undefined){const N=L.prev;N.next=L.next,L.next.prev=N}else L.prev===I.Undefined&&L.next===I.Undefined?(this.a=I.Undefined,this.b=I.Undefined):L.next===I.Undefined?(this.b=this.b.prev,this.b.next=I.Undefined):L.prev===I.Undefined&&(this.a=this.a.next,this.a.prev=I.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==I.Undefined;)yield L.element,L=L.next}}e.$4c=c}),define(he[36],ue([0,1]),function(oe,e){"use strict";var I,c,A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=void 0,e.$wc=L,e.$xc=N,e.$yc=O,e.$Hc=m;function L(o,h,i){let s=o.get(h);return s===void 0&&(s=i,o.set(h,s)),s}function N(o){const h=[];return o.forEach((i,s)=>{h.push(`${s} => ${i}`)}),`Map(${o.size}) {${h.join(", ")}}`}function O(o){const h=[];return o.forEach(i=>{h.push(i)}),`Set(${o.size}) {${h.join(", ")}}`}class k{constructor(h,i){this.uri=h,this.value=i}}function y(o){return Array.isArray(o)}class R{static{this.c=h=>h.toString()}constructor(h,i){if(this[I]="ResourceMap",h instanceof R)this.d=new Map(h.d),this.e=i??R.c;else if(y(h)){this.d=new Map,this.e=i??R.c;for(const[s,t]of h)this.set(s,t)}else this.d=new Map,this.e=h??R.c}set(h,i){return this.d.set(this.e(h),new k(h,i)),this}get(h){return this.d.get(this.e(h))?.value}has(h){return this.d.has(this.e(h))}get size(){return this.d.size}clear(){this.d.clear()}delete(h){return this.d.delete(this.e(h))}forEach(h,i){typeof i<"u"&&(h=h.bind(i));for(const[s,t]of this.d)h(t.value,t.uri,this)}*values(){for(const h of this.d.values())yield h.value}*keys(){for(const h of this.d.values())yield h.uri}*entries(){for(const h of this.d.values())yield[h.uri,h.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,h]of this.d)yield[h.uri,h.value]}}e.$zc=R;class d{constructor(h,i){this[c]="ResourceSet",!h||typeof h=="function"?this.c=new R(h):(this.c=new R(i),h.forEach(this.add,this))}get size(){return this.c.size}add(h){return this.c.set(h,h),this}clear(){this.c.clear()}delete(h){return this.c.delete(h)}forEach(h,i){this.c.forEach((s,t)=>h.call(i,t,t,this))}has(h){return this.c.has(h)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(c=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=d;var u;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(u||(e.Touch=u={}));class ${constructor(){this[A]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(h){return this.c.has(h)}get(h,i=u.None){const s=this.c.get(h);if(s)return i!==u.None&&this.m(s,i),s.value}set(h,i,s=u.None){let t=this.c.get(h);if(t)t.value=i,s!==u.None&&this.m(t,s);else{switch(t={key:h,value:i,next:void 0,previous:void 0},s){case u.None:this.k(t);break;case u.AsOld:this.j(t);break;case u.AsNew:this.k(t);break;default:this.k(t);break}this.c.set(h,t),this.f++}return this}delete(h){return!!this.remove(h)}remove(h){const i=this.c.get(h);if(i)return this.c.delete(h),this.l(i),this.f--,i.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const h=this.d;return this.c.delete(h.key),this.l(h),this.f--,h.value}forEach(h,i){const s=this.g;let t=this.d;for(;t;){if(i?h.bind(i)(t.value,t.key,this):h(t.value,t.key,this),this.g!==s)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const h=this,i=this.g;let s=this.d;const t={[Symbol.iterator](){return t},next(){if(h.g!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const n={value:s.key,done:!1};return s=s.next,n}else return{value:void 0,done:!0}}};return t}values(){const h=this,i=this.g;let s=this.d;const t={[Symbol.iterator](){return t},next(){if(h.g!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const n={value:s.value,done:!1};return s=s.next,n}else return{value:void 0,done:!0}}};return t}entries(){const h=this,i=this.g;let s=this.d;const t={[Symbol.iterator](){return t},next(){if(h.g!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const n={value:[s.key,s.value],done:!1};return s=s.next,n}else return{value:void 0,done:!0}}};return t}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(h){if(h>=this.size)return;if(h===0){this.clear();return}let i=this.d,s=this.size;for(;i&&s>h;)this.c.delete(i.key),i=i.next,s--;this.d=i,this.f=s,i&&(i.previous=void 0),this.g++}i(h){if(h>=this.size)return;if(h===0){this.clear();return}let i=this.e,s=this.size;for(;i&&s>h;)this.c.delete(i.key),i=i.previous,s--;this.e=i,this.f=s,i&&(i.next=void 0),this.g++}j(h){if(!this.d&&!this.e)this.e=h;else if(this.d)h.next=this.d,this.d.previous=h;else throw new Error("Invalid list");this.d=h,this.g++}k(h){if(!this.d&&!this.e)this.d=h;else if(this.e)h.previous=this.e,this.e.next=h;else throw new Error("Invalid list");this.e=h,this.g++}l(h){if(h===this.d&&h===this.e)this.d=void 0,this.e=void 0;else if(h===this.d){if(!h.next)throw new Error("Invalid list");h.next.previous=void 0,this.d=h.next}else if(h===this.e){if(!h.previous)throw new Error("Invalid list");h.previous.next=void 0,this.e=h.previous}else{const i=h.next,s=h.previous;if(!i||!s)throw new Error("Invalid list");i.previous=s,s.next=i}h.next=void 0,h.previous=void 0,this.g++}m(h,i){if(!this.d||!this.e)throw new Error("Invalid list");if(!(i!==u.AsOld&&i!==u.AsNew)){if(i===u.AsOld){if(h===this.d)return;const s=h.next,t=h.previous;h===this.e?(t.next=void 0,this.e=t):(s.previous=t,t.next=s),h.previous=void 0,h.next=this.d,this.d.previous=h,this.d=h,this.g++}else if(i===u.AsNew){if(h===this.e)return;const s=h.next,t=h.previous;h===this.d?(s.previous=void 0,this.d=s):(s.previous=t,t.next=s),h.next=void 0,h.previous=this.e,this.e.next=h,this.e=h,this.g++}}}toJSON(){const h=[];return this.forEach((i,s)=>{h.push([s,i])}),h}fromJSON(h){this.clear();for(const[i,s]of h)this.set(i,s)}}e.$Bc=$;class l extends ${constructor(h,i=1){super(),this.n=h,this.o=Math.min(Math.max(0,i),1)}get limit(){return this.n}set limit(h){this.n=h,this.p()}get ratio(){return this.o}set ratio(h){this.o=Math.min(Math.max(0,h),1),this.p()}get(h,i=u.AsNew){return super.get(h,i)}peek(h){return super.get(h,u.None)}set(h,i){return super.set(h,i,u.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class p extends l{constructor(h,i=1){super(h,i)}q(h){this.h(h)}set(h,i){return super.set(h,i),this.p(),this}}e.$Cc=p;class S extends l{constructor(h,i=1){super(h,i)}q(h){this.i(h)}set(h,i){return this.n<=this.size&&!this.has(h)&&this.q(Math.round(this.n*this.o)-1),super.set(h,i),this}}e.$Dc=S;class g{constructor(){this.c=new Map}add(h){return this.c.set(h,(this.c.get(h)||0)+1),this}delete(h){let i=this.c.get(h)||0;return i===0?!1:(i--,i===0?this.c.delete(h):this.c.set(h,i),!0)}has(h){return this.c.has(h)}}e.$Ec=g;class w{constructor(h){if(this.c=new Map,this.d=new Map,h)for(const[i,s]of h)this.set(i,s)}clear(){this.c.clear(),this.d.clear()}set(h,i){this.c.set(h,i),this.d.set(i,h)}get(h){return this.c.get(h)}getKey(h){return this.d.get(h)}delete(h){const i=this.c.get(h);return i===void 0?!1:(this.c.delete(h),this.d.delete(i),!0)}forEach(h,i){this.c.forEach((s,t)=>{h.call(i,s,t,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=w;class P{constructor(){this.c=new Map}add(h,i){let s=this.c.get(h);s||(s=new Set,this.c.set(h,s)),s.add(i)}delete(h,i){const s=this.c.get(h);s&&(s.delete(i),s.size===0&&this.c.delete(h))}forEach(h,i){const s=this.c.get(h);s&&s.forEach(i)}get(h){const i=this.c.get(h);return i||new Set}}e.$Gc=P;function m(o,h){if(o===h)return!0;if(o.size!==h.size)return!1;for(const[i,s]of o)if(!h.has(i)||h.get(i)!==s)return!1;for(const[i]of h)if(!o.has(i))return!1;return!0}}),define(he[2],ue([0,1,17,130,36,88,63]),function(oe,e,I,c,A,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Ic=void 0,e.$Jc=R,e.$Kc=d,e.$Lc=u,e.$Mc=p,e.$Nc=S,e.$Oc=g,e.$Pc=w,e.$Qc=P,e.$Rc=m,e.$2c=v;const O=!1;let k=null;class y{constructor(){this.b=new Map}static{this.a=0}c(E){let T=this.b.get(E);return T||(T={parent:null,source:null,isSingleton:!1,value:E,idx:y.a++},this.b.set(E,T)),T}trackDisposable(E){const T=this.c(E);T.source||(T.source=new Error().stack)}setParent(E,T){const j=this.c(E);j.parent=T}markAsDisposed(E){this.b.delete(E)}markAsSingleton(E){this.c(E).isSingleton=!0}f(E,T){const j=T.get(E);if(j)return j;const U=E.parent?this.f(this.c(E.parent),T):E;return T.set(E,U),U}getTrackedDisposables(){const E=new Map;return[...this.b.entries()].filter(([,j])=>j.source!==null&&!this.f(j,E).isSingleton).flatMap(([j])=>j)}computeLeakingDisposables(E=10,T){let j;if(T)j=T;else{const x=new Map,G=[...this.b.values()].filter(V=>V.source!==null&&!this.f(V,x).isSingleton);if(G.length===0)return;const ie=new Set(G.map(V=>V.value));if(j=G.filter(V=>!(V.parent&&ie.has(V.parent))),j.length===0)throw new Error("There are cyclic diposable chains!")}if(!j)return;function U(x){function G(V,z){for(;V.length>0&&z.some(_=>typeof _=="string"?_===V[0]:V[0].match(_));)V.shift()}const ie=x.source.split(`
`).map(V=>V.trim().replace("at ","")).filter(V=>V!=="");return G(ie,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ie.reverse()}const F=new A.$Gc;for(const x of j){const G=U(x);for(let ie=0;ie<=G.length;ie++)F.add(G.slice(0,ie).join(`
`),x)}j.sort((0,I.$5b)(x=>x.idx,I.$7b));let K="",W=0;for(const x of j.slice(0,E)){W++;const G=U(x),ie=[];for(let V=0;V<G.length;V++){let z=G[V];z=`(shared with ${F.get(G.slice(0,V+1).join(`
`)).size}/${j.length} leaks) at ${z}`;const ne=F.get(G.slice(0,V).join(`
`)),ce=(0,c.$c)([...ne].map(te=>U(te)[V]),te=>te);delete ce[G[V]];for(const[te,Y]of Object.entries(ce))ie.unshift(`    - stacktraces of ${Y.length} other leaks continue with ${te}`);ie.unshift(z)}K+=`


==================== Leaking disposable ${W}/${j.length}: ${x.value.constructor.name} ====================
${ie.join(`
`)}
============================================================

`}return j.length>E&&(K+=`


... and ${j.length-E} more leaking disposables

`),{leaks:j,details:K}}}e.$Ic=y;function R(b){k=b}if(O){const b="__is_disposable_tracked__";R(new class{trackDisposable(E){const T=new Error("Potentially leaked disposable").stack;setTimeout(()=>{E[b]||console.log(T)},3e3)}setParent(E,T){if(E&&E!==h.None)try{E[b]=!0}catch{}}markAsDisposed(E){if(E&&E!==h.None)try{E[b]=!0}catch{}}markAsSingleton(E){}})}function d(b){return k?.trackDisposable(b),b}function u(b){k?.markAsDisposed(b)}function $(b,E){k?.setParent(b,E)}function l(b,E){if(k)for(const T of b)k.setParent(T,E)}function p(b){return k?.markAsSingleton(b),b}function S(b){return typeof b=="object"&&b!==null&&typeof b.dispose=="function"&&b.dispose.length===0}function g(b){if(N.Iterable.is(b)){const E=[];for(const T of b)if(T)try{T.dispose()}catch(j){E.push(j)}if(E.length===1)throw E[0];if(E.length>1)throw new AggregateError(E,"Encountered errors while disposing of store");return Array.isArray(b)?[]:b}else if(b)return b.dispose(),b}function w(b){for(const E of b)S(E)&&E.dispose();return[]}function P(...b){const E=m(()=>g(b));return l(b,E),E}function m(b){const E=d({dispose:(0,L.$cb)(()=>{u(E),b()})});return E}class o{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,d(this)}dispose(){this.g||(u(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{g(this.f)}finally{this.f.clear()}}add(E){if(!E)return E;if(E===this)throw new Error("Cannot register a disposable on itself!");return $(E,this),this.g?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(E),E}delete(E){if(E){if(E===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(E),E.dispose()}}deleteAndLeak(E){E&&this.f.has(E)&&(this.f.delete(E),$(E,null))}}e.$Sc=o;class h{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new o,d(this),$(this.q,this)}dispose(){u(this),this.q.dispose()}B(E){if(E===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(E)}}e.$Tc=h;class i{constructor(){this.b=!1,d(this)}get value(){return this.b?void 0:this.a}set value(E){this.b||E===this.a||(this.a?.dispose(),E&&$(E,this),this.a=E)}clear(){this.value=void 0}dispose(){this.b=!0,u(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const E=this.a;return this.a=void 0,E&&$(E,null),E}}e.$Uc=i;class s{constructor(E){this.a=new i,this.b=!1,this.a.value=E}get value(){return this.a.value}set value(E){this.b||E===this.a.value||(this.a.value=E)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=s;class t{constructor(E){this.b=E,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=t;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,d(this)}set(E){let T=E;return this.unset=()=>T=void 0,this.isset=()=>T!==void 0,this.dispose=()=>{T&&(T(),T=void 0,u(this))},this}}e.$Xc=n;class r{constructor(){this.a=new Map}acquire(E,...T){let j=this.a.get(E);j||(j={counter:0,object:this.b(E,...T)},this.a.set(E,j));const{object:U}=j,F=(0,L.$cb)(()=>{--j.counter===0&&(this.c(E,j.object),this.a.delete(E))});return j.counter++,{object:U,dispose:F}}}e.$Yc=r;class a{constructor(E){this.a=E}async acquire(E,...T){const j=this.a.acquire(E,...T);try{return{object:await j.object,dispose:()=>j.dispose()}}catch(U){throw j.dispose(),U}}}e.$Zc=a;class f{constructor(E){this.object=E}dispose(){}}e.$1c=f;function v(b){const E=new o;try{b(E)}finally{E.dispose()}}class C{constructor(){this.a=new Map,this.b=!1,d(this)}dispose(){u(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{g(this.a.values())}finally{this.a.clear()}}has(E){return this.a.has(E)}get size(){return this.a.size}get(E){return this.a.get(E)}set(E,T,j=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),j||this.a.get(E)?.dispose(),this.a.set(E,T)}deleteAndDispose(E){this.a.get(E)?.dispose(),this.a.delete(E)}deleteAndLeak(E){const T=this.a.get(E);return this.a.delete(E),T}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=C}),define(he[65],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var I;(function(c){c[c.Uri=1]="Uri",c[c.Regexp=2]="Regexp",c[c.ScmResource=3]="ScmResource",c[c.ScmResourceGroup=4]="ScmResourceGroup",c[c.ScmProvider=5]="ScmProvider",c[c.CommentController=6]="CommentController",c[c.CommentThread=7]="CommentThread",c[c.CommentThreadInstance=8]="CommentThreadInstance",c[c.CommentThreadReply=9]="CommentThreadReply",c[c.CommentNode=10]="CommentNode",c[c.CommentThreadNode=11]="CommentThreadNode",c[c.TimelineActionContext=12]="TimelineActionContext",c[c.NotebookCellActionContext=13]="NotebookCellActionContext",c[c.NotebookActionContext=14]="NotebookActionContext",c[c.TerminalContext=15]="TerminalContext",c[c.TestItemContext=16]="TestItemContext",c[c.Date=17]="Date",c[c.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(I||(e.MarshalledId=I={}))}),define(he[90],ue([0,1,36]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lm=void 0,e.$jm=A,e.$km=N;const c=new I.$Cc(1e4);function A(y){return k(y,"NFC",c)}const L=new I.$Cc(1e4);function N(y){return k(y,"NFD",L)}const O=/[^\u0000-\u0080]/;function k(y,R,d){if(!y)return y;const u=d.get(y);if(u)return u;let $;return O.test(y)?$=y.normalize(R):$=y,d.set(y,$),$}e.$lm=function(){const y=/[\u0300-\u036f]/g;return function(R){return N(R).replace(y,"")}}()}),function(){function oe(A){const L=[];typeof A=="number"&&L.push("code/timeOrigin",A);function N(k){L.push(k,Date.now())}function O(){const k=[];for(let y=0;y<L.length;y+=2)k.push({name:L[y],startTime:L[y+1]});return k}return{mark:N,getMarks:O}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const N of performance.getEntriesByType("mark"))L.push({name:N.name,startTime:Math.round(A+N.startTime)});return L}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function I(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var c;typeof global=="object"?c=global:typeof self=="object"?c=self:c={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(c)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(c):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),c.perf=I(c))}(),define(he[5],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.OS=e.OperatingSystem=e.$C=e.$B=e.$A=e.$z=e.$y=e.Language=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.Platform=e.$h=void 0,e.$i=h,e.$E=a,e.$K=f,e.$h="en";let I=!1,c=!1,A=!1,L=!1,N=!1,O=!1,k=!1,y=!1,R=!1,d=!1,u,$=e.$h,l=e.$h,p,S;const g=globalThis;let w;typeof g.vscode<"u"&&typeof g.vscode.process<"u"?w=g.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(w=process);const P=typeof w?.versions?.electron=="string",m=P&&w?.type==="renderer";if(typeof w=="object"){I=w.platform==="win32",c=w.platform==="darwin",A=w.platform==="linux",L=A&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,k=P,R=!!w.env.CI||!!w.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=e.$h,$=e.$h;const v=w.env.VSCODE_NLS_CONFIG;if(v)try{const C=JSON.parse(v);u=C.userLocale,l=C.osLocale,$=C.resolvedLanguage||e.$h,p=C.languagePack?.translationsConfigFile}catch{}N=!0}else typeof navigator=="object"&&!m?(S=navigator.userAgent,I=S.indexOf("Windows")>=0,c=S.indexOf("Macintosh")>=0,y=(S.indexOf("Macintosh")>=0||S.indexOf("iPad")>=0||S.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=S.indexOf("Linux")>=0,d=S?.indexOf("Mobi")>=0,O=!0,$=globalThis._VSCODE_NLS_LANGUAGE||e.$h,u=navigator.language.toLowerCase(),l=u):console.error("Unable to resolve platform.");var o;(function(v){v[v.Web=0]="Web",v[v.Mac=1]="Mac",v[v.Linux=2]="Linux",v[v.Windows=3]="Windows"})(o||(e.Platform=o={}));function h(v){switch(v){case o.Web:return"Web";case o.Mac:return"Mac";case o.Linux:return"Linux";case o.Windows:return"Windows"}}let i=o.Web;c?i=o.Mac:I?i=o.Windows:A&&(i=o.Linux),e.$j=I,e.$k=c,e.$l=A,e.$m=L,e.$n=N,e.$o=k,e.$p=O,e.$q=O&&typeof g.importScripts=="function",e.$r=e.$q?g.origin:void 0,e.$s=y,e.$t=d,e.$u=R,e.$v=i,e.$w=S,e.$x=$;var s;(function(v){function C(){return e.$x}v.value=C;function b(){return e.$x.length===2?e.$x==="en":e.$x.length>=3?e.$x[0]==="e"&&e.$x[1]==="n"&&e.$x[2]==="-":!1}v.isDefaultVariant=b;function E(){return e.$x==="en"}v.isDefault=E})(s||(e.Language=s={})),e.$y=u,e.$z=l,e.$A=p,e.$B=typeof g.postMessage=="function"&&!g.importScripts,e.$C=(()=>{if(e.$B){const v=[];g.addEventListener("message",b=>{if(b.data&&b.data.vscodeScheduleAsyncWork)for(let E=0,T=v.length;E<T;E++){const j=v[E];if(j.id===b.data.vscodeScheduleAsyncWork){v.splice(E,1),j.callback();return}}});let C=0;return b=>{const E=++C;v.push({id:E,callback:b}),g.postMessage({vscodeScheduleAsyncWork:E},"*")}}return v=>setTimeout(v)})();var t;(function(v){v[v.Windows=1]="Windows",v[v.Macintosh=2]="Macintosh",v[v.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=c||y?t.Macintosh:I?t.Windows:t.Linux;let n=!0,r=!1;function a(){if(!r){r=!0;const v=new Uint8Array(2);v[0]=1,v[1]=2,n=new Uint16Array(v.buffer)[0]===513}return n}e.$F=!!(e.$w&&e.$w.indexOf("Chrome")>=0),e.$G=!!(e.$w&&e.$w.indexOf("Firefox")>=0),e.$H=!!(!e.$F&&e.$w&&e.$w.indexOf("Safari")>=0),e.$I=!!(e.$w&&e.$w.indexOf("Edg/")>=0),e.$J=!!(e.$w&&e.$w.indexOf("Android")>=0);function f(v){return parseFloat(v)>=20}}),define(he[37],ue([0,1,5]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let c;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.process<"u"){const L=A.process;c={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process<"u"?c={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:c={get platform(){return I.$j?"win32":I.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=c.cwd,e.env=c.env,e.$cc=c.platform,e.$dc=c.arch}),define(he[132],ue([0,1,37]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9W=N;var c;(function(O){O.UNKNOWN="UNKNOWN",O.CINNAMON="CINNAMON",O.DEEPIN="DEEPIN",O.GNOME="GNOME",O.KDE3="KDE3",O.KDE4="KDE4",O.KDE5="KDE5",O.KDE6="KDE6",O.PANTHEON="PANTHEON",O.UNITY="UNITY",O.XFCE="XFCE",O.UKUI="UKUI",O.LXQT="LXQT"})(c||(c={}));const A="XDG_CURRENT_DESKTOP",L="KDE_SESSION_VERSION";function N(){const O=I.env[A];if(O){const y=O.split(":").map(R=>R.trim()).filter(R=>R.length>0);for(const R of y)switch(R){case"Unity":{const d=I.env.DESKTOP_SESSION;return d&&d.includes("gnome-fallback")?c.GNOME:c.UNITY}case"Deepin":return c.DEEPIN;case"GNOME":return c.GNOME;case"X-Cinnamon":return c.CINNAMON;case"KDE":{const d=I.env[L];return d==="5"?c.KDE5:d==="6"?c.KDE6:c.KDE4}case"Pantheon":return c.PANTHEON;case"XFCE":return c.XFCE;case"UKUI":return c.UKUI;case"LXQt":return c.LXQT}}const k=I.env.DESKTOP_SESSION;if(k)switch(k){case"deepin":return c.DEEPIN;case"gnome":case"mate":return c.GNOME;case"kde4":case"kde-plasma":return c.KDE4;case"kde":return L in I.env?c.KDE4:c.KDE3;case"xfce":case"xubuntu":return c.XFCE;case"ukui":return c.UKUI}return"GNOME_DESKTOP_SESSION_ID"in I.env?c.GNOME:"KDE_FULL_SESSION"in I.env?L in I.env?c.KDE4:c.KDE3:c.UNKNOWN}});var Ot=this&&this.__createBinding||(Object.create?function(oe,e,I,c){c===void 0&&(c=I);var A=Object.getOwnPropertyDescriptor(e,I);(!A||("get"in A?!e.__esModule:A.writable||A.configurable))&&(A={enumerable:!0,get:function(){return e[I]}}),Object.defineProperty(oe,c,A)}:function(oe,e,I,c){c===void 0&&(c=I),oe[c]=e[I]}),At=this&&this.__setModuleDefault||(Object.create?function(oe,e){Object.defineProperty(oe,"default",{enumerable:!0,value:e})}:function(oe,e){oe.default=e}),ke=this&&this.__importStar||function(oe){if(oe&&oe.__esModule)return oe;var e={};if(oe!=null)for(var I in oe)I!=="default"&&Object.prototype.hasOwnProperty.call(oe,I)&&Ot(e,oe,I);return At(e,oe),e};define(he[13],ue([0,1,37]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0,I=ke(I);const c=65,A=97,L=90,N=122,O=46,k=47,y=92,R=58,d=63;class u extends Error{constructor(s,t,n){let r;typeof t=="string"&&t.indexOf("not ")===0?(r="must not be",t=t.replace(/^not /,"")):r="must be";const a=s.indexOf(".")!==-1?"property":"argument";let f=`The "${s}" ${a} ${r} of type ${t}`;f+=`. Received type ${typeof n}`,super(f),this.code="ERR_INVALID_ARG_TYPE"}}function $(i,s){if(i===null||typeof i!="object")throw new u(s,"Object",i)}function l(i,s){if(typeof i!="string")throw new u(s,"string",i)}const p=I.$cc==="win32";function S(i){return i===k||i===y}function g(i){return i===k}function w(i){return i>=c&&i<=L||i>=A&&i<=N}function P(i,s,t,n){let r="",a=0,f=-1,v=0,C=0;for(let b=0;b<=i.length;++b){if(b<i.length)C=i.charCodeAt(b);else{if(n(C))break;C=k}if(n(C)){if(!(f===b-1||v===1))if(v===2){if(r.length<2||a!==2||r.charCodeAt(r.length-1)!==O||r.charCodeAt(r.length-2)!==O){if(r.length>2){const E=r.lastIndexOf(t);E===-1?(r="",a=0):(r=r.slice(0,E),a=r.length-1-r.lastIndexOf(t)),f=b,v=0;continue}else if(r.length!==0){r="",a=0,f=b,v=0;continue}}s&&(r+=r.length>0?`${t}..`:"..",a=2)}else r.length>0?r+=`${t}${i.slice(f+1,b)}`:r=i.slice(f+1,b),a=b-f-1;f=b,v=0}else C===O&&v!==-1?++v:v=-1}return r}function m(i){return i?`${i[0]==="."?"":"."}${i}`:""}function o(i,s){$(s,"pathObject");const t=s.dir||s.root,n=s.base||`${s.name||""}${m(s.ext)}`;return t?t===s.root?`${t}${n}`:`${t}${i}${n}`:n}e.$ec={resolve(...i){let s="",t="",n=!1;for(let r=i.length-1;r>=-1;r--){let a;if(r>=0){if(a=i[r],l(a,`paths[${r}]`),a.length===0)continue}else s.length===0?a=I.cwd():(a=I.env[`=${s}`]||I.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==s.toLowerCase()&&a.charCodeAt(2)===y)&&(a=`${s}\\`));const f=a.length;let v=0,C="",b=!1;const E=a.charCodeAt(0);if(f===1)S(E)&&(v=1,b=!0);else if(S(E))if(b=!0,S(a.charCodeAt(1))){let T=2,j=T;for(;T<f&&!S(a.charCodeAt(T));)T++;if(T<f&&T!==j){const U=a.slice(j,T);for(j=T;T<f&&S(a.charCodeAt(T));)T++;if(T<f&&T!==j){for(j=T;T<f&&!S(a.charCodeAt(T));)T++;(T===f||T!==j)&&(C=`\\\\${U}\\${a.slice(j,T)}`,v=T)}}}else v=1;else w(E)&&a.charCodeAt(1)===R&&(C=a.slice(0,2),v=2,f>2&&S(a.charCodeAt(2))&&(b=!0,v=3));if(C.length>0)if(s.length>0){if(C.toLowerCase()!==s.toLowerCase())continue}else s=C;if(n){if(s.length>0)break}else if(t=`${a.slice(v)}\\${t}`,n=b,b&&s.length>0)break}return t=P(t,!n,"\\",S),n?`${s}\\${t}`:`${s}${t}`||"."},normalize(i){l(i,"path");const s=i.length;if(s===0)return".";let t=0,n,r=!1;const a=i.charCodeAt(0);if(s===1)return g(a)?"\\":i;if(S(a))if(r=!0,S(i.charCodeAt(1))){let v=2,C=v;for(;v<s&&!S(i.charCodeAt(v));)v++;if(v<s&&v!==C){const b=i.slice(C,v);for(C=v;v<s&&S(i.charCodeAt(v));)v++;if(v<s&&v!==C){for(C=v;v<s&&!S(i.charCodeAt(v));)v++;if(v===s)return`\\\\${b}\\${i.slice(C)}\\`;v!==C&&(n=`\\\\${b}\\${i.slice(C,v)}`,t=v)}}}else t=1;else w(a)&&i.charCodeAt(1)===R&&(n=i.slice(0,2),t=2,s>2&&S(i.charCodeAt(2))&&(r=!0,t=3));let f=t<s?P(i.slice(t),!r,"\\",S):"";return f.length===0&&!r&&(f="."),f.length>0&&S(i.charCodeAt(s-1))&&(f+="\\"),n===void 0?r?`\\${f}`:f:r?`${n}\\${f}`:`${n}${f}`},isAbsolute(i){l(i,"path");const s=i.length;if(s===0)return!1;const t=i.charCodeAt(0);return S(t)||s>2&&w(t)&&i.charCodeAt(1)===R&&S(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let s,t;for(let a=0;a<i.length;++a){const f=i[a];l(f,"path"),f.length>0&&(s===void 0?s=t=f:s+=`\\${f}`)}if(s===void 0)return".";let n=!0,r=0;if(typeof t=="string"&&S(t.charCodeAt(0))){++r;const a=t.length;a>1&&S(t.charCodeAt(1))&&(++r,a>2&&(S(t.charCodeAt(2))?++r:n=!1))}if(n){for(;r<s.length&&S(s.charCodeAt(r));)r++;r>=2&&(s=`\\${s.slice(r)}`)}return e.$ec.normalize(s)},relative(i,s){if(l(i,"from"),l(s,"to"),i===s)return"";const t=e.$ec.resolve(i),n=e.$ec.resolve(s);if(t===n||(i=t.toLowerCase(),s=n.toLowerCase(),i===s))return"";let r=0;for(;r<i.length&&i.charCodeAt(r)===y;)r++;let a=i.length;for(;a-1>r&&i.charCodeAt(a-1)===y;)a--;const f=a-r;let v=0;for(;v<s.length&&s.charCodeAt(v)===y;)v++;let C=s.length;for(;C-1>v&&s.charCodeAt(C-1)===y;)C--;const b=C-v,E=f<b?f:b;let T=-1,j=0;for(;j<E;j++){const F=i.charCodeAt(r+j);if(F!==s.charCodeAt(v+j))break;F===y&&(T=j)}if(j!==E){if(T===-1)return n}else{if(b>E){if(s.charCodeAt(v+j)===y)return n.slice(v+j+1);if(j===2)return n.slice(v+j)}f>E&&(i.charCodeAt(r+j)===y?T=j:j===2&&(T=3)),T===-1&&(T=0)}let U="";for(j=r+T+1;j<=a;++j)(j===a||i.charCodeAt(j)===y)&&(U+=U.length===0?"..":"\\..");return v+=T,U.length>0?`${U}${n.slice(v,C)}`:(n.charCodeAt(v)===y&&++v,n.slice(v,C))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const s=e.$ec.resolve(i);if(s.length<=2)return i;if(s.charCodeAt(0)===y){if(s.charCodeAt(1)===y){const t=s.charCodeAt(2);if(t!==d&&t!==O)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(w(s.charCodeAt(0))&&s.charCodeAt(1)===R&&s.charCodeAt(2)===y)return`\\\\?\\${s}`;return i},dirname(i){l(i,"path");const s=i.length;if(s===0)return".";let t=-1,n=0;const r=i.charCodeAt(0);if(s===1)return S(r)?i:".";if(S(r)){if(t=n=1,S(i.charCodeAt(1))){let v=2,C=v;for(;v<s&&!S(i.charCodeAt(v));)v++;if(v<s&&v!==C){for(C=v;v<s&&S(i.charCodeAt(v));)v++;if(v<s&&v!==C){for(C=v;v<s&&!S(i.charCodeAt(v));)v++;if(v===s)return i;v!==C&&(t=n=v+1)}}}}else w(r)&&i.charCodeAt(1)===R&&(t=s>2&&S(i.charCodeAt(2))?3:2,n=t);let a=-1,f=!0;for(let v=s-1;v>=n;--v)if(S(i.charCodeAt(v))){if(!f){a=v;break}}else f=!1;if(a===-1){if(t===-1)return".";a=t}return i.slice(0,a)},basename(i,s){s!==void 0&&l(s,"suffix"),l(i,"path");let t=0,n=-1,r=!0,a;if(i.length>=2&&w(i.charCodeAt(0))&&i.charCodeAt(1)===R&&(t=2),s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let f=s.length-1,v=-1;for(a=i.length-1;a>=t;--a){const C=i.charCodeAt(a);if(S(C)){if(!r){t=a+1;break}}else v===-1&&(r=!1,v=a+1),f>=0&&(C===s.charCodeAt(f)?--f===-1&&(n=a):(f=-1,n=v))}return t===n?n=v:n===-1&&(n=i.length),i.slice(t,n)}for(a=i.length-1;a>=t;--a)if(S(i.charCodeAt(a))){if(!r){t=a+1;break}}else n===-1&&(r=!1,n=a+1);return n===-1?"":i.slice(t,n)},extname(i){l(i,"path");let s=0,t=-1,n=0,r=-1,a=!0,f=0;i.length>=2&&i.charCodeAt(1)===R&&w(i.charCodeAt(0))&&(s=n=2);for(let v=i.length-1;v>=s;--v){const C=i.charCodeAt(v);if(S(C)){if(!a){n=v+1;break}continue}r===-1&&(a=!1,r=v+1),C===O?t===-1?t=v:f!==1&&(f=1):t!==-1&&(f=-1)}return t===-1||r===-1||f===0||f===1&&t===r-1&&t===n+1?"":i.slice(t,r)},format:o.bind(null,"\\"),parse(i){l(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const t=i.length;let n=0,r=i.charCodeAt(0);if(t===1)return S(r)?(s.root=s.dir=i,s):(s.base=s.name=i,s);if(S(r)){if(n=1,S(i.charCodeAt(1))){let T=2,j=T;for(;T<t&&!S(i.charCodeAt(T));)T++;if(T<t&&T!==j){for(j=T;T<t&&S(i.charCodeAt(T));)T++;if(T<t&&T!==j){for(j=T;T<t&&!S(i.charCodeAt(T));)T++;T===t?n=T:T!==j&&(n=T+1)}}}}else if(w(r)&&i.charCodeAt(1)===R){if(t<=2)return s.root=s.dir=i,s;if(n=2,S(i.charCodeAt(2))){if(t===3)return s.root=s.dir=i,s;n=3}}n>0&&(s.root=i.slice(0,n));let a=-1,f=n,v=-1,C=!0,b=i.length-1,E=0;for(;b>=n;--b){if(r=i.charCodeAt(b),S(r)){if(!C){f=b+1;break}continue}v===-1&&(C=!1,v=b+1),r===O?a===-1?a=b:E!==1&&(E=1):a!==-1&&(E=-1)}return v!==-1&&(a===-1||E===0||E===1&&a===v-1&&a===f+1?s.base=s.name=i.slice(f,v):(s.name=i.slice(f,a),s.base=i.slice(f,v),s.ext=i.slice(a,v))),f>0&&f!==n?s.dir=i.slice(0,f-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const h=(()=>{if(p){const i=/\\/g;return()=>{const s=I.cwd().replace(i,"/");return s.slice(s.indexOf("/"))}}return()=>I.cwd()})();e.$fc={resolve(...i){let s="",t=!1;for(let n=i.length-1;n>=-1&&!t;n--){const r=n>=0?i[n]:h();l(r,`paths[${n}]`),r.length!==0&&(s=`${r}/${s}`,t=r.charCodeAt(0)===k)}return s=P(s,!t,"/",g),t?`/${s}`:s.length>0?s:"."},normalize(i){if(l(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===k,t=i.charCodeAt(i.length-1)===k;return i=P(i,!s,"/",g),i.length===0?s?"/":t?"./":".":(t&&(i+="/"),s?`/${i}`:i)},isAbsolute(i){return l(i,"path"),i.length>0&&i.charCodeAt(0)===k},join(...i){if(i.length===0)return".";let s;for(let t=0;t<i.length;++t){const n=i[t];l(n,"path"),n.length>0&&(s===void 0?s=n:s+=`/${n}`)}return s===void 0?".":e.$fc.normalize(s)},relative(i,s){if(l(i,"from"),l(s,"to"),i===s||(i=e.$fc.resolve(i),s=e.$fc.resolve(s),i===s))return"";const t=1,n=i.length,r=n-t,a=1,f=s.length-a,v=r<f?r:f;let C=-1,b=0;for(;b<v;b++){const T=i.charCodeAt(t+b);if(T!==s.charCodeAt(a+b))break;T===k&&(C=b)}if(b===v)if(f>v){if(s.charCodeAt(a+b)===k)return s.slice(a+b+1);if(b===0)return s.slice(a+b)}else r>v&&(i.charCodeAt(t+b)===k?C=b:b===0&&(C=0));let E="";for(b=t+C+1;b<=n;++b)(b===n||i.charCodeAt(b)===k)&&(E+=E.length===0?"..":"/..");return`${E}${s.slice(a+C)}`},toNamespacedPath(i){return i},dirname(i){if(l(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===k;let t=-1,n=!0;for(let r=i.length-1;r>=1;--r)if(i.charCodeAt(r)===k){if(!n){t=r;break}}else n=!1;return t===-1?s?"/":".":s&&t===1?"//":i.slice(0,t)},basename(i,s){s!==void 0&&l(s,"ext"),l(i,"path");let t=0,n=-1,r=!0,a;if(s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let f=s.length-1,v=-1;for(a=i.length-1;a>=0;--a){const C=i.charCodeAt(a);if(C===k){if(!r){t=a+1;break}}else v===-1&&(r=!1,v=a+1),f>=0&&(C===s.charCodeAt(f)?--f===-1&&(n=a):(f=-1,n=v))}return t===n?n=v:n===-1&&(n=i.length),i.slice(t,n)}for(a=i.length-1;a>=0;--a)if(i.charCodeAt(a)===k){if(!r){t=a+1;break}}else n===-1&&(r=!1,n=a+1);return n===-1?"":i.slice(t,n)},extname(i){l(i,"path");let s=-1,t=0,n=-1,r=!0,a=0;for(let f=i.length-1;f>=0;--f){const v=i.charCodeAt(f);if(v===k){if(!r){t=f+1;break}continue}n===-1&&(r=!1,n=f+1),v===O?s===-1?s=f:a!==1&&(a=1):s!==-1&&(a=-1)}return s===-1||n===-1||a===0||a===1&&s===n-1&&s===t+1?"":i.slice(s,n)},format:o.bind(null,"/"),parse(i){l(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const t=i.charCodeAt(0)===k;let n;t?(s.root="/",n=1):n=0;let r=-1,a=0,f=-1,v=!0,C=i.length-1,b=0;for(;C>=n;--C){const E=i.charCodeAt(C);if(E===k){if(!v){a=C+1;break}continue}f===-1&&(v=!1,f=C+1),E===O?r===-1?r=C:b!==1&&(b=1):r!==-1&&(b=-1)}if(f!==-1){const E=a===0&&t?1:a;r===-1||b===0||b===1&&r===f-1&&r===a+1?s.base=s.name=i.slice(E,f):(s.name=i.slice(E,r),s.base=i.slice(E,f),s.ext=i.slice(r,f))}return a>0?s.dir=i.slice(0,a-1):t&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=p?e.$ec.normalize:e.$fc.normalize,e.$hc=p?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=p?e.$ec.join:e.$fc.join,e.$jc=p?e.$ec.resolve:e.$fc.resolve,e.$kc=p?e.$ec.relative:e.$fc.relative,e.$lc=p?e.$ec.dirname:e.$fc.dirname,e.$mc=p?e.$ec.basename:e.$fc.basename,e.$nc=p?e.$ec.extname:e.$fc.extname,e.$oc=p?e.$ec.format:e.$fc.format,e.$pc=p?e.$ec.parse:e.$fc.parse,e.$qc=p?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=p?e.$ec.sep:e.$fc.sep,e.$sc=p?e.$ec.delimiter:e.$fc.delimiter}),define(he[133],ue([0,1,13]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7s=void 0,e.$8s=L,e.$9s=N,e.$0s=O,e.$$s=y,e.$7s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const c={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(R){const d=(0,I.$nc)(R),u=c[d.toLowerCase()];return u!==void 0?u:N(R)}function N(R){const d=(0,I.$nc)(R);return A[d.toLowerCase()]}function O(R){for(const d in A)if(A[d]===R)return d}const k=/^(.+)\/(.+?)(;.+)?$/;function y(R,d){const u=k.exec(R);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:d?void 0:R}}),define(he[91],ue([0,1,5]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$hm=L,e.$im=N;var c;(function(O){O[O.stdout=0]="stdout",O[O.stderr=1]="stderr"})(c||(e.Source=c={}));var A;(function(O){O[O.Success=0]="Success",O[O.Unknown=1]="Unknown",O[O.AccessDenied=2]="AccessDenied",O[O.ProcessNotFound=3]="ProcessNotFound"})(A||(e.TerminateResponseCode=A={}));function L(O,...k){const y=k.reduce((u,$)=>(u[$]=!0,u),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(O).filter(u=>!y[u]).forEach(u=>{for(let $=0;$<R.length;$++)if(u.search(R[$])!==-1){delete O[u];break}})}function N(O){O&&(delete O.DEBUG,I.$k&&delete O.DYLD_LIBRARY_PATH,I.$l&&delete O.LD_PRELOAD)}}),function(oe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var c in I)(typeof exports=="object"?exports:oe)[c]=I[c]}}(typeof self<"u"?self:this,function(){return function(oe){var e={};function I(c){if(e[c])return e[c].exports;var A=e[c]={i:c,l:!1,exports:{}};return oe[c].call(A.exports,A,A.exports,I),A.l=!0,A.exports}return I.m=oe,I.c=e,I.d=function(c,A,L){I.o(c,A)||Object.defineProperty(c,A,{enumerable:!0,get:L})},I.r=function(c){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(c,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(c,"__esModule",{value:!0})},I.t=function(c,A){if(1&A&&(c=I(c)),8&A||4&A&&typeof c=="object"&&c&&c.__esModule)return c;var L=Object.create(null);if(I.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:c}),2&A&&typeof c!="string")for(var N in c)I.d(L,N,function(O){return c[O]}.bind(null,N));return L},I.n=function(c){var A=c&&c.__esModule?function(){return c.default}:function(){return c};return I.d(A,"a",A),A},I.o=function(c,A){return Object.prototype.hasOwnProperty.call(c,A)},I.p="",I(I.s=0)}([function(oe,e,I){(function(c){var A;e=oe.exports=Y,A=typeof c=="object"&&c.env&&c.env.NODE_DEBUG&&/\bsemver\b/i.test(c.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,O=e.re=[],k=e.src=[],y=0,R=y++;k[R]="0|[1-9]\\d*";var d=y++;k[d]="[0-9]+";var u=y++;k[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var $=y++;k[$]="("+k[R]+")\\.("+k[R]+")\\.("+k[R]+")";var l=y++;k[l]="("+k[d]+")\\.("+k[d]+")\\.("+k[d]+")";var p=y++;k[p]="(?:"+k[R]+"|"+k[u]+")";var S=y++;k[S]="(?:"+k[d]+"|"+k[u]+")";var g=y++;k[g]="(?:-("+k[p]+"(?:\\."+k[p]+")*))";var w=y++;k[w]="(?:-?("+k[S]+"(?:\\."+k[S]+")*))";var P=y++;k[P]="[0-9A-Za-z-]+";var m=y++;k[m]="(?:\\+("+k[P]+"(?:\\."+k[P]+")*))";var o=y++,h="v?"+k[$]+k[g]+"?"+k[m]+"?";k[o]="^"+h+"$";var i="[v=\\s]*"+k[l]+k[w]+"?"+k[m]+"?",s=y++;k[s]="^"+i+"$";var t=y++;k[t]="((?:<|>)?=?)";var n=y++;k[n]=k[d]+"|x|X|\\*";var r=y++;k[r]=k[R]+"|x|X|\\*";var a=y++;k[a]="[v=\\s]*("+k[r]+")(?:\\.("+k[r]+")(?:\\.("+k[r]+")(?:"+k[g]+")?"+k[m]+"?)?)?";var f=y++;k[f]="[v=\\s]*("+k[n]+")(?:\\.("+k[n]+")(?:\\.("+k[n]+")(?:"+k[w]+")?"+k[m]+"?)?)?";var v=y++;k[v]="^"+k[t]+"\\s*"+k[a]+"$";var C=y++;k[C]="^"+k[t]+"\\s*"+k[f]+"$";var b=y++;k[b]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var E=y++;k[E]="(?:~>?)";var T=y++;k[T]="(\\s*)"+k[E]+"\\s+",O[T]=new RegExp(k[T],"g");var j=y++;k[j]="^"+k[E]+k[a]+"$";var U=y++;k[U]="^"+k[E]+k[f]+"$";var F=y++;k[F]="(?:\\^)";var K=y++;k[K]="(\\s*)"+k[F]+"\\s+",O[K]=new RegExp(k[K],"g");var W=y++;k[W]="^"+k[F]+k[a]+"$";var x=y++;k[x]="^"+k[F]+k[f]+"$";var G=y++;k[G]="^"+k[t]+"\\s*("+i+")$|^$";var ie=y++;k[ie]="^"+k[t]+"\\s*("+h+")$|^$";var V=y++;k[V]="(\\s*)"+k[t]+"\\s*("+i+"|"+k[a]+")",O[V]=new RegExp(k[V],"g");var z=y++;k[z]="^\\s*("+k[a]+")\\s+-\\s+("+k[a]+")\\s*$";var _=y++;k[_]="^\\s*("+k[f]+")\\s+-\\s+("+k[f]+")\\s*$";var ne=y++;k[ne]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)A(ce,k[ce]),O[ce]||(O[ce]=new RegExp(k[ce]));function te(ae,de){if(ae instanceof Y)return ae;if(typeof ae!="string"||ae.length>L||!(de?O[s]:O[o]).test(ae))return null;try{return new Y(ae,de)}catch{return null}}function Y(ae,de){if(ae instanceof Y){if(ae.loose===de)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof Y))return new Y(ae,de);A("SemVer",ae,de),this.loose=de;var me=ae.trim().match(de?O[s]:O[o]);if(!me)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+me[1],this.minor=+me[2],this.patch=+me[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");me[4]?this.prerelease=me[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Oe=+Pe;if(Oe>=0&&Oe<N)return Oe}return Pe}):this.prerelease=[],this.build=me[5]?me[5].split("."):[],this.format()}e.parse=te,e.valid=function(ae,de){var me=te(ae,de);return me?me.version:null},e.clean=function(ae,de){var me=te(ae.trim().replace(/^[=v]+/,""),de);return me?me.version:null},e.SemVer=Y,Y.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Y.prototype.toString=function(){return this.version},Y.prototype.compare=function(ae){return A("SemVer.compare",this.version,this.loose,ae),ae instanceof Y||(ae=new Y(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},Y.prototype.compareMain=function(ae){return ae instanceof Y||(ae=new Y(ae,this.loose)),B(this.major,ae.major)||B(this.minor,ae.minor)||B(this.patch,ae.patch)},Y.prototype.comparePre=function(ae){if(ae instanceof Y||(ae=new Y(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var de=0;do{var me=this.prerelease[de],Pe=ae.prerelease[de];if(A("prerelease compare",de,me,Pe),me===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(me===void 0)return-1;if(me!==Pe)return B(me,Pe)}while(++de)},Y.prototype.inc=function(ae,de){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var me=this.prerelease.length;--me>=0;)typeof this.prerelease[me]=="number"&&(this.prerelease[me]++,me=-2);me===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,de,me,Pe){typeof me=="string"&&(Pe=me,me=void 0);try{return new Y(ae,me).inc(de,Pe).version}catch{return null}},e.diff=function(ae,de){if(M(ae,de))return null;var me=te(ae),Pe=te(de);if(me.prerelease.length||Pe.prerelease.length){for(var Oe in me)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&me[Oe]!==Pe[Oe])return"pre"+Oe;return"prerelease"}for(var Oe in me)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&me[Oe]!==Pe[Oe])return Oe},e.compareIdentifiers=B;var H=/^[0-9]+$/;function B(ae,de){var me=H.test(ae),Pe=H.test(de);return me&&Pe&&(ae=+ae,de=+de),me&&!Pe?-1:Pe&&!me?1:ae<de?-1:ae>de?1:0}function D(ae,de,me){return new Y(ae,me).compare(new Y(de,me))}function J(ae,de,me){return D(ae,de,me)>0}function q(ae,de,me){return D(ae,de,me)<0}function M(ae,de,me){return D(ae,de,me)===0}function Z(ae,de,me){return D(ae,de,me)!==0}function ee(ae,de,me){return D(ae,de,me)>=0}function X(ae,de,me){return D(ae,de,me)<=0}function re(ae,de,me,Pe){var Oe;switch(de){case"===":typeof ae=="object"&&(ae=ae.version),typeof me=="object"&&(me=me.version),Oe=ae===me;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof me=="object"&&(me=me.version),Oe=ae!==me;break;case"":case"=":case"==":Oe=M(ae,me,Pe);break;case"!=":Oe=Z(ae,me,Pe);break;case">":Oe=J(ae,me,Pe);break;case">=":Oe=ee(ae,me,Pe);break;case"<":Oe=q(ae,me,Pe);break;case"<=":Oe=X(ae,me,Pe);break;default:throw new TypeError("Invalid operator: "+de)}return Oe}function le(ae,de){if(ae instanceof le){if(ae.loose===de)return ae;ae=ae.value}if(!(this instanceof le))return new le(ae,de);A("comparator",ae,de),this.loose=de,this.parse(ae),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(ae,de){return B(de,ae)},e.major=function(ae,de){return new Y(ae,de).major},e.minor=function(ae,de){return new Y(ae,de).minor},e.patch=function(ae,de){return new Y(ae,de).patch},e.compare=D,e.compareLoose=function(ae,de){return D(ae,de,!0)},e.rcompare=function(ae,de,me){return D(de,ae,me)},e.sort=function(ae,de){return ae.sort(function(me,Pe){return e.compare(me,Pe,de)})},e.rsort=function(ae,de){return ae.sort(function(me,Pe){return e.rcompare(me,Pe,de)})},e.gt=J,e.lt=q,e.eq=M,e.neq=Z,e.gte=ee,e.lte=X,e.cmp=re,e.Comparator=le;var ge={};function pe(ae,de){if(ae instanceof pe)return ae.loose===de?ae:new pe(ae.raw,de);if(ae instanceof le)return new pe(ae.value,de);if(!(this instanceof pe))return new pe(ae,de);if(this.loose=de,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(me){return this.parseRange(me.trim())},this).filter(function(me){return me.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function Ee(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function we(ae,de,me,Pe,Oe,je,Ne,Le,Ue,qe,Ge,Fe,Be){return((de=Ee(me)?"":Ee(Pe)?">="+me+".0.0":Ee(Oe)?">="+me+"."+Pe+".0":">="+de)+" "+(Le=Ee(Ue)?"":Ee(qe)?"<"+(+Ue+1)+".0.0":Ee(Ge)?"<"+Ue+"."+(+qe+1)+".0":Fe?"<="+Ue+"."+qe+"."+Ge+"-"+Fe:"<="+Le)).trim()}function be(ae,de){for(var me=0;me<ae.length;me++)if(!ae[me].test(de))return!1;if(de.prerelease.length){for(me=0;me<ae.length;me++)if(A(ae[me].semver),ae[me].semver!==ge&&ae[me].semver.prerelease.length>0){var Pe=ae[me].semver;if(Pe.major===de.major&&Pe.minor===de.minor&&Pe.patch===de.patch)return!0}return!1}return!0}function Se(ae,de,me){try{de=new pe(de,me)}catch{return!1}return de.test(ae)}function Ie(ae,de,me,Pe){var Oe,je,Ne,Le,Ue;switch(ae=new Y(ae,Pe),de=new pe(de,Pe),me){case">":Oe=J,je=X,Ne=q,Le=">",Ue=">=";break;case"<":Oe=q,je=ee,Ne=J,Le="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Se(ae,de,Pe))return!1;for(var qe=0;qe<de.set.length;++qe){var Ge=de.set[qe],Fe=null,Be=null;if(Ge.forEach(function(ze){ze.semver===ge&&(ze=new le(">=0.0.0")),Fe=Fe||ze,Be=Be||ze,Oe(ze.semver,Fe.semver,Pe)?Fe=ze:Ne(ze.semver,Be.semver,Pe)&&(Be=ze)}),Fe.operator===Le||Fe.operator===Ue||(!Be.operator||Be.operator===Le)&&je(ae,Be.semver)||Be.operator===Ue&&Ne(ae,Be.semver))return!1}return!0}le.prototype.parse=function(ae){var de=this.loose?O[G]:O[ie],me=ae.match(de);if(!me)throw new TypeError("Invalid comparator: "+ae);this.operator=me[1],this.operator==="="&&(this.operator=""),me[2]?this.semver=new Y(me[2],this.loose):this.semver=ge},le.prototype.toString=function(){return this.value},le.prototype.test=function(ae){return A("Comparator.test",ae,this.loose),this.semver===ge||(typeof ae=="string"&&(ae=new Y(ae,this.loose)),re(ae,this.operator,this.semver,this.loose))},le.prototype.intersects=function(ae,de){if(!(ae instanceof le))throw new TypeError("a Comparator is required");var me;if(this.operator==="")return me=new pe(ae.value,de),Se(this.value,me,de);if(ae.operator==="")return me=new pe(this.value,de),Se(ae.semver,me,de);var Pe=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),Oe=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),je=this.semver.version===ae.semver.version,Ne=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),Le=re(this.semver,"<",ae.semver,de)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),Ue=re(this.semver,">",ae.semver,de)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return Pe||Oe||je&&Ne||Le||Ue},e.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(ae){var de=this.loose;ae=ae.trim(),A("range",ae,de);var me=de?O[_]:O[z];ae=ae.replace(me,we),A("hyphen replace",ae),ae=ae.replace(O[V],"$1$2$3"),A("comparator trim",ae,O[V]),ae=(ae=(ae=ae.replace(O[T],"$1~")).replace(O[K],"$1^")).split(/\s+/).join(" ");var Pe=de?O[G]:O[ie],Oe=ae.split(" ").map(function(je){return function(Ne,Le){return A("comp",Ne),Ne=function(Ue,qe){return Ue.trim().split(/\s+/).map(function(Ge){return function(Fe,Be){A("caret",Fe,Be);var ze=Be?O[x]:O[W];return Fe.replace(ze,function(We,Ce,se,fe,$e){var ye;return A("caret",Fe,We,Ce,se,fe,$e),Ee(Ce)?ye="":Ee(se)?ye=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":Ee(fe)?ye=Ce==="0"?">="+Ce+"."+se+".0 <"+Ce+"."+(+se+1)+".0":">="+Ce+"."+se+".0 <"+(+Ce+1)+".0.0":$e?(A("replaceCaret pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),ye=Ce==="0"?se==="0"?">="+Ce+"."+se+"."+fe+$e+" <"+Ce+"."+se+"."+(+fe+1):">="+Ce+"."+se+"."+fe+$e+" <"+Ce+"."+(+se+1)+".0":">="+Ce+"."+se+"."+fe+$e+" <"+(+Ce+1)+".0.0"):(A("no pr"),ye=Ce==="0"?se==="0"?">="+Ce+"."+se+"."+fe+" <"+Ce+"."+se+"."+(+fe+1):">="+Ce+"."+se+"."+fe+" <"+Ce+"."+(+se+1)+".0":">="+Ce+"."+se+"."+fe+" <"+(+Ce+1)+".0.0"),A("caret return",ye),ye})}(Ge,qe)}).join(" ")}(Ne,Le),A("caret",Ne),Ne=function(Ue,qe){return Ue.trim().split(/\s+/).map(function(Ge){return function(Fe,Be){var ze=Be?O[U]:O[j];return Fe.replace(ze,function(We,Ce,se,fe,$e){var ye;return A("tilde",Fe,We,Ce,se,fe,$e),Ee(Ce)?ye="":Ee(se)?ye=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":Ee(fe)?ye=">="+Ce+"."+se+".0 <"+Ce+"."+(+se+1)+".0":$e?(A("replaceTilde pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),ye=">="+Ce+"."+se+"."+fe+$e+" <"+Ce+"."+(+se+1)+".0"):ye=">="+Ce+"."+se+"."+fe+" <"+Ce+"."+(+se+1)+".0",A("tilde return",ye),ye})}(Ge,qe)}).join(" ")}(Ne,Le),A("tildes",Ne),Ne=function(Ue,qe){return A("replaceXRanges",Ue,qe),Ue.split(/\s+/).map(function(Ge){return function(Fe,Be){Fe=Fe.trim();var ze=Be?O[C]:O[v];return Fe.replace(ze,function(We,Ce,se,fe,$e,ye){A("xRange",Fe,We,Ce,se,fe,$e,ye);var Ae=Ee(se),Te=Ae||Ee(fe),Me=Te||Ee($e);return Ce==="="&&Me&&(Ce=""),Ae?We=Ce===">"||Ce==="<"?"<0.0.0":"*":Ce&&Me?(Te&&(fe=0),Me&&($e=0),Ce===">"?(Ce=">=",Te?(se=+se+1,fe=0,$e=0):Me&&(fe=+fe+1,$e=0)):Ce==="<="&&(Ce="<",Te?se=+se+1:fe=+fe+1),We=Ce+se+"."+fe+"."+$e):Te?We=">="+se+".0.0 <"+(+se+1)+".0.0":Me&&(We=">="+se+"."+fe+".0 <"+se+"."+(+fe+1)+".0"),A("xRange return",We),We})}(Ge,qe)}).join(" ")}(Ne,Le),A("xrange",Ne),Ne=function(Ue,qe){return A("replaceStars",Ue,qe),Ue.trim().replace(O[ne],"")}(Ne,Le),A("stars",Ne),Ne}(je,de)}).join(" ").split(/\s+/);return this.loose&&(Oe=Oe.filter(function(je){return!!je.match(Pe)})),Oe=Oe.map(function(je){return new le(je,de)})},pe.prototype.intersects=function(ae,de){if(!(ae instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(me){return me.every(function(Pe){return ae.set.some(function(Oe){return Oe.every(function(je){return Pe.intersects(je,de)})})})})},e.toComparators=function(ae,de){return new pe(ae,de).set.map(function(me){return me.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new Y(ae,this.loose));for(var de=0;de<this.set.length;de++)if(be(this.set[de],ae))return!0;return!1},e.satisfies=Se,e.maxSatisfying=function(ae,de,me){var Pe=null,Oe=null;try{var je=new pe(de,me)}catch{return null}return ae.forEach(function(Ne){je.test(Ne)&&(Pe&&Oe.compare(Ne)!==-1||(Oe=new Y(Pe=Ne,me)))}),Pe},e.minSatisfying=function(ae,de,me){var Pe=null,Oe=null;try{var je=new pe(de,me)}catch{return null}return ae.forEach(function(Ne){je.test(Ne)&&(Pe&&Oe.compare(Ne)!==1||(Oe=new Y(Pe=Ne,me)))}),Pe},e.validRange=function(ae,de){try{return new pe(ae,de).range||"*"}catch{return null}},e.ltr=function(ae,de,me){return Ie(ae,de,"<",me)},e.gtr=function(ae,de,me){return Ie(ae,de,">",me)},e.outside=Ie,e.prerelease=function(ae,de){var me=te(ae,de);return me&&me.prerelease.length?me.prerelease:null},e.intersects=function(ae,de,me){return ae=new pe(ae,me),de=new pe(de,me),ae.intersects(de)},e.coerce=function(ae){if(ae instanceof Y)return ae;if(typeof ae!="string")return null;var de=ae.match(O[b]);return de==null?null:te((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,I(1))},function(oe,e){var I,c,A=oe.exports={};function L(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function O(S){if(I===setTimeout)return setTimeout(S,0);if((I===L||!I)&&setTimeout)return I=setTimeout,setTimeout(S,0);try{return I(S,0)}catch{try{return I.call(null,S,0)}catch{return I.call(this,S,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:L}catch{I=L}try{c=typeof clearTimeout=="function"?clearTimeout:N}catch{c=N}})();var k,y=[],R=!1,d=-1;function u(){R&&k&&(R=!1,k.length?y=k.concat(y):d=-1,y.length&&$())}function $(){if(!R){var S=O(u);R=!0;for(var g=y.length;g;){for(k=y,y=[];++d<g;)k&&k[d].run();d=-1,g=y.length}k=null,R=!1,function(w){if(c===clearTimeout)return clearTimeout(w);if((c===N||!c)&&clearTimeout)return c=clearTimeout,clearTimeout(w);try{c(w)}catch{try{return c.call(null,w)}catch{return c.call(this,w)}}}(S)}}function l(S,g){this.fun=S,this.array=g}function p(){}A.nextTick=function(S){var g=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)g[w-1]=arguments[w];y.push(new l(S,g)),y.length!==1||R||O($)},l.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=p,A.addListener=p,A.once=p,A.off=p,A.removeListener=p,A.removeAllListeners=p,A.emit=p,A.prependListener=p,A.prependOnceListener=p,A.listeners=function(S){return[]},A.binding=function(S){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(S){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(he[134],ue([0,1]),function(oe,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ps=void 0;class c{constructor(O,k,y){this.level=O,this.key=k,this.value=y,this.forward=[]}}const A=void 0;class L{constructor(O,k=2**16){this.comparator=O,this[I]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(k)|0),this.e=new c(this.c,A,A)}get size(){return this.f}clear(){this.e=new c(this.c,A,A),this.f=0}has(O){return!!L.g(this,O,this.comparator)}get(O){return L.g(this,O,this.comparator)?.value}set(O,k){return L.h(this,O,k,this.comparator)&&(this.f+=1),this}delete(O){const k=L.k(this,O,this.comparator);return k&&(this.f-=1),k}forEach(O,k){let y=this.e.forward[0];for(;y;)O.call(k,y.value,y.key,this),y=y.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let O=this.e.forward[0];for(;O;)yield[O.key,O.value],O=O.forward[0]}*keys(){let O=this.e.forward[0];for(;O;)yield O.key,O=O.forward[0]}*values(){let O=this.e.forward[0];for(;O;)yield O.value,O=O.forward[0]}toString(){let O="[SkipList]:",k=this.e.forward[0];for(;k;)O+=`node(${k.key}, ${k.value}, lvl:${k.level})`,k=k.forward[0];return O}static g(O,k,y){let R=O.e;for(let d=O.d-1;d>=0;d--)for(;R.forward[d]&&y(R.forward[d].key,k)<0;)R=R.forward[d];if(R=R.forward[0],R&&y(R.key,k)===0)return R}static h(O,k,y,R){const d=[];let u=O.e;for(let $=O.d-1;$>=0;$--){for(;u.forward[$]&&R(u.forward[$].key,k)<0;)u=u.forward[$];d[$]=u}if(u=u.forward[0],u&&R(u.key,k)===0)return u.value=y,!1;{const $=L.j(O);if($>O.d){for(let l=O.d;l<$;l++)d[l]=O.e;O.d=$}u=new c($,k,y);for(let l=0;l<$;l++)u.forward[l]=d[l].forward[l],d[l].forward[l]=u;return!0}}static j(O,k=.5){let y=1;for(;Math.random()<k&&y<O.c;)y+=1;return y}static k(O,k,y){const R=[];let d=O.e;for(let u=O.d-1;u>=0;u--){for(;d.forward[u]&&y(d.forward[u].key,k)<0;)d=d.forward[u];R[u]=d}if(d=d.forward[0],!d||y(d.key,k)!==0)return!1;for(let u=0;u<O.d&&R[u].forward[u]===d;u++)R[u].forward[u]=d.forward[u];for(;O.d>0&&O.e.forward[O.d-1]===A;)O.d-=1;return!0}}e.$Ps=L}),define(he[54],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=void 0;const I=globalThis.performance&&typeof globalThis.performance.now=="function";class c{static create(L){return new c(L)}constructor(L){this.c=I&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$de=c}),define(he[3],ue([0,1,8,88,2,89,54]),function(oe,e,I,c,A,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$fe=e.Event=void 0,e.$ge=$;const O=!1,k=!1,y=!1;var R;(function(U){U.None=()=>A.$Tc.None;function F(we){if(y){const{onDidAddListener:be}=we,Se=p.create();let Ie=0;we.onDidAddListener=()=>{++Ie===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Se.print()),be?.()}}}function K(we,be){return te(we,()=>{},0,void 0,!0,void 0,be)}U.defer=K;function W(we){return(be,Se=null,Ie)=>{let ae=!1,de;return de=we(me=>{if(!ae)return de?de.dispose():ae=!0,be.call(Se,me)},null,Ie),ae&&de.dispose(),de}}U.once=W;function x(we,be,Se){return ne((Ie,ae=null,de)=>we(me=>Ie.call(ae,be(me)),null,de),Se)}U.map=x;function G(we,be,Se){return ne((Ie,ae=null,de)=>we(me=>{be(me),Ie.call(ae,me)},null,de),Se)}U.forEach=G;function ie(we,be,Se){return ne((Ie,ae=null,de)=>we(me=>be(me)&&Ie.call(ae,me),null,de),Se)}U.filter=ie;function V(we){return we}U.signal=V;function z(...we){return(be,Se=null,Ie)=>{const ae=(0,A.$Qc)(...we.map(de=>de(me=>be.call(Se,me))));return ce(ae,Ie)}}U.any=z;function _(we,be,Se,Ie){let ae=Se;return x(we,de=>(ae=be(ae,de),ae),Ie)}U.reduce=_;function ne(we,be){let Se;const Ie={onWillAddFirstListener(){Se=we(ae.fire,ae)},onDidRemoveLastListener(){Se?.dispose()}};be||F(Ie);const ae=new i(Ie);return be?.add(ae),ae.event}function ce(we,be){return be instanceof Array?be.push(we):be&&be.add(we),we}function te(we,be,Se=100,Ie=!1,ae=!1,de,me){let Pe,Oe,je,Ne=0,Le;const Ue={leakWarningThreshold:de,onWillAddFirstListener(){Pe=we(Ge=>{Ne++,Oe=be(Oe,Ge),Ie&&!je&&(qe.fire(Oe),Oe=void 0),Le=()=>{const Fe=Oe;Oe=void 0,je=void 0,(!Ie||Ne>1)&&qe.fire(Fe),Ne=0},typeof Se=="number"?(clearTimeout(je),je=setTimeout(Le,Se)):je===void 0&&(je=0,queueMicrotask(Le))})},onWillRemoveListener(){ae&&Ne>0&&Le?.()},onDidRemoveLastListener(){Le=void 0,Pe.dispose()}};me||F(Ue);const qe=new i(Ue);return me?.add(qe),qe.event}U.debounce=te;function Y(we,be=0,Se){return U.debounce(we,(Ie,ae)=>Ie?(Ie.push(ae),Ie):[ae],be,void 0,!0,void 0,Se)}U.accumulate=Y;function H(we,be=(Ie,ae)=>Ie===ae,Se){let Ie=!0,ae;return ie(we,de=>{const me=Ie||!be(de,ae);return Ie=!1,ae=de,me},Se)}U.latch=H;function B(we,be,Se){return[U.filter(we,be,Se),U.filter(we,Ie=>!be(Ie),Se)]}U.split=B;function D(we,be=!1,Se=[],Ie){let ae=Se.slice(),de=we(Oe=>{ae?ae.push(Oe):Pe.fire(Oe)});Ie&&Ie.add(de);const me=()=>{ae?.forEach(Oe=>Pe.fire(Oe)),ae=null},Pe=new i({onWillAddFirstListener(){de||(de=we(Oe=>Pe.fire(Oe)),Ie&&Ie.add(de))},onDidAddFirstListener(){ae&&(be?setTimeout(me):me())},onDidRemoveLastListener(){de&&de.dispose(),de=null}});return Ie&&Ie.add(Pe),Pe.event}U.buffer=D;function J(we,be){return(Ie,ae,de)=>{const me=be(new M);return we(function(Pe){const Oe=me.evaluate(Pe);Oe!==q&&Ie.call(ae,Oe)},void 0,de)}}U.chain=J;const q=Symbol("HaltChainable");class M{constructor(){this.f=[]}map(be){return this.f.push(be),this}forEach(be){return this.f.push(Se=>(be(Se),Se)),this}filter(be){return this.f.push(Se=>be(Se)?Se:q),this}reduce(be,Se){let Ie=Se;return this.f.push(ae=>(Ie=be(Ie,ae),Ie)),this}latch(be=(Se,Ie)=>Se===Ie){let Se=!0,Ie;return this.f.push(ae=>{const de=Se||!be(ae,Ie);return Se=!1,Ie=ae,de?ae:q}),this}evaluate(be){for(const Se of this.f)if(be=Se(be),be===q)break;return be}}function Z(we,be,Se=Ie=>Ie){const Ie=(...Pe)=>me.fire(Se(...Pe)),ae=()=>we.on(be,Ie),de=()=>we.removeListener(be,Ie),me=new i({onWillAddFirstListener:ae,onDidRemoveLastListener:de});return me.event}U.fromNodeEventEmitter=Z;function ee(we,be,Se=Ie=>Ie){const Ie=(...Pe)=>me.fire(Se(...Pe)),ae=()=>we.addEventListener(be,Ie),de=()=>we.removeEventListener(be,Ie),me=new i({onWillAddFirstListener:ae,onDidRemoveLastListener:de});return me.event}U.fromDOMEventEmitter=ee;function X(we){return new Promise(be=>W(we)(be))}U.toPromise=X;function re(we){const be=new i;return we.then(Se=>{be.fire(Se)},()=>{be.fire(void 0)}).finally(()=>{be.dispose()}),be.event}U.fromPromise=re;function le(we,be,Se){return be(Se),we(Ie=>be(Ie))}U.runAndSubscribe=le;class ge{constructor(be,Se){this._observable=be,this.f=0,this.g=!1;const Ie={onWillAddFirstListener:()=>{be.addObserver(this)},onDidRemoveLastListener:()=>{be.removeObserver(this)}};Se||F(Ie),this.emitter=new i(Ie),Se&&Se.add(this.emitter)}beginUpdate(be){this.f++}handlePossibleChange(be){}handleChange(be,Se){this.g=!0}endUpdate(be){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function pe(we,be){return new ge(we,be).emitter.event}U.fromObservable=pe;function Ee(we){return(be,Se,Ie)=>{let ae=0,de=!1;const me={beginUpdate(){ae++},endUpdate(){ae--,ae===0&&(we.reportChanges(),de&&(de=!1,be.call(Se)))},handlePossibleChange(){},handleChange(){de=!0}};we.addObserver(me),we.reportChanges();const Pe={dispose(){we.removeObserver(me)}};return Ie instanceof A.$Sc?Ie.add(Pe):Array.isArray(Ie)&&Ie.push(Pe),Pe}}U.fromObservableLight=Ee})(R||(e.Event=R={}));class d{static{this.all=new Set}static{this.f=0}constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${d.f++}`,d.all.add(this)}start(F){this.g=new N.$de,this.listenerCount=F}stop(){if(this.g){const F=this.g.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this.g=void 0}}}e.$fe=d;let u=-1;function $(U){const F=u;return u=U,{dispose(){u=F}}}class l{static{this.f=1}constructor(F,K,W=(l.f++).toString(16).padStart(3,"0")){this.j=F,this.threshold=K,this.name=W,this.h=0}dispose(){this.g?.clear()}check(F,K){const W=this.threshold;if(W<=0||K<W)return;this.g||(this.g=new Map);const x=this.g.get(F.value)||0;if(this.g.set(F.value,x+1),this.h-=1,this.h<=0){this.h=W*.5;const[G,ie]=this.getMostFrequentStack(),V=`[${this.name}] potential listener LEAK detected, having ${K} listeners already. MOST frequent listener (${ie}):`;console.warn(V),console.warn(G);const z=new S(V,G);this.j(z)}return()=>{const G=this.g.get(F.value)||0;this.g.set(F.value,G-1)}}getMostFrequentStack(){if(!this.g)return;let F,K=0;for(const[W,x]of this.g)(!F||K<x)&&(F=[W,x],K=x);return F}}class p{static create(){const F=new Error;return new p(F.stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class S extends Error{constructor(F,K){super(F),this.name="ListenerLeakError",this.stack=K}}e.$he=S;class g extends Error{constructor(F,K){super(F),this.name="ListenerRefusalError",this.stack=K}}e.$ie=g;let w=0;class P{constructor(F){this.value=F,this.id=w++}}const m=2,o=(U,F)=>{if(U instanceof P)F(U);else for(let K=0;K<U.length;K++){const W=U[K];W&&F(W)}};let h;if(O){const U=[];setInterval(()=>{U.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(U.join(`
`)),U.length=0)},3e3),h=new FinalizationRegistry(F=>{typeof F=="string"&&U.push(F)})}class i{constructor(F){this.z=0,this.f=F,this.g=u>0||this.f?.leakWarningThreshold?new l(F?.onListenerError??I.$Y,this.f?.leakWarningThreshold??u):void 0,this.j=this.f?._profName?new d(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(k){const F=this.u;queueMicrotask(()=>{o(F,K=>K.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(F,K,W)=>{if(this.g&&this.z>this.g.threshold**2){const z=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(z);const _=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ne=new g(`${z}. HINT: Stack shows most frequent listener (${_[1]}-times)`,_[0]);return(this.f?.onListenerError||I.$Y)(ne),A.$Tc.None}if(this.m)return A.$Tc.None;K&&(F=F.bind(K));const x=new P(F);let G,ie;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(x.stack=p.create(),G=this.g.check(x.stack,this.z+1)),k&&(x.stack=ie??p.create()),this.u?this.u instanceof P?(this.w??=new t,this.u=[this.u,x]):this.u.push(x):(this.f?.onWillAddFirstListener?.(this),this.u=x,this.f?.onDidAddFirstListener?.(this)),this.z++;const V=(0,A.$Rc)(()=>{h?.unregister(V),G?.(),this.A(x)});if(W instanceof A.$Sc?W.add(V):Array.isArray(W)&&W.push(V),h){const z=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),_=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(z);h.register(V,_?.[2]??z,V)}return V},this.q}A(F){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const K=this.u,W=K.indexOf(F);if(W===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,K[W]=void 0;const x=this.w.current===this;if(this.z*m<=K.length){let G=0;for(let ie=0;ie<K.length;ie++)K[ie]?K[G++]=K[ie]:x&&(this.w.end--,G<this.w.i&&this.w.i--);K.length=G}}B(F,K){if(!F)return;const W=this.f?.onListenerError||I.$Y;if(!W){F.value(K);return}try{F.value(K)}catch(x){W(x)}}C(F){const K=F.current.u;for(;F.i<F.end;)this.B(K[F.i++],F.value);F.reset()}fire(F){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof P)this.B(this.u,F);else{const K=this.w;K.enqueue(this,F,this.u.length),this.C(K)}this.j?.stop()}hasListeners(){return this.z>0}}e.$je=i;const s=()=>new t;e.$ke=s;class t{constructor(){this.i=-1,this.end=0}enqueue(F,K,W){this.i=0,this.end=W,this.current=F,this.value=K}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends i{async fireAsync(F,K,W){if(this.u)for(this.h||(this.h=new L.$4c),o(this.u,x=>this.h.push([x.value,F]));this.h.size>0&&!K.isCancellationRequested;){const[x,G]=this.h.shift(),ie=[],V={...G,token:K,waitUntil:z=>{if(Object.isFrozen(ie))throw new Error("waitUntil can NOT be called asynchronous");W&&(z=W(z,x)),ie.push(z)}};try{x(V)}catch(z){(0,I.$Y)(z);continue}Object.freeze(ie),await Promise.allSettled(ie).then(z=>{for(const _ of z)_.status==="rejected"&&(0,I.$Y)(_.reason)})}}}e.$le=n;class r extends i{get isPaused(){return this.h!==0}constructor(F){super(F),this.h=0,this.s=new L.$4c,this.t=F?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const F=Array.from(this.s);this.s.clear(),super.fire(this.t(F))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(F){this.z&&(this.h!==0?this.s.push(F):super.fire(F))}}e.$me=r;class a extends r{constructor(F){super(F),this.k=F.delay??100}fire(F){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(F)}}e.$ne=a;class f extends i{constructor(F){super(F),this.h=[],this.k=F?.merge}fire(F){this.hasListeners()&&(this.h.push(F),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(K=>super.fire(K)),this.h=[]}))}}e.$oe=f;class v{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(F){const K={event:F,listener:null};this.h.push(K),this.g&&this.m(K);const W=()=>{this.g&&this.o(K);const x=this.h.indexOf(K);this.h.splice(x,1)};return(0,A.$Rc)((0,c.$cb)(W))}j(){this.g=!0,this.h.forEach(F=>this.m(F))}k(){this.g=!1,this.h.forEach(F=>this.o(F))}m(F){F.listener=F.event(K=>this.f.fire(K))}o(F){F.listener?.dispose(),F.listener=null}dispose(){this.f.dispose();for(const F of this.h)F.listener?.dispose();this.h=[]}}e.$pe=v;class C{constructor(F,K,W,x){this.f=new A.$Sc;const G=this.f.add(new v),ie=this.f.add(new A.$3c);function V(z){ie.set(z,G.add(x(z)))}for(const z of F)V(z);this.f.add(K(z=>{V(z)})),this.f.add(W(z=>{ie.deleteAndDispose(z)})),this.event=G.event}dispose(){this.f.dispose()}}e.$qe=C;class b{constructor(){this.f=[]}wrapEvent(F,K,W){return(x,G,ie)=>F(V=>{const z=this.f[this.f.length-1];if(!K){z?z.buffers.push(()=>x.call(G,V)):x.call(G,V);return}const _=z;if(!_){x.call(G,K(W,V));return}_.items??=[],_.items.push(V),_.buffers.length===0&&z.buffers.push(()=>{_.reducedResult??=W?_.items.reduce(K,W):_.items.reduce(K),x.call(G,_.reducedResult)})},void 0,ie)}bufferEvents(F){const K={buffers:new Array};this.f.push(K);const W=F();return this.f.pop(),K.buffers.forEach(x=>x()),W}}e.$re=b;class E{constructor(){this.f=!1,this.g=R.None,this.h=A.$Tc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(F){this.g=F,this.f&&(this.h.dispose(),this.h=F(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$se=E;class T{static const(F){return new j(F)}constructor(F){this.g=F,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(F){F!==this.g&&(this.g=F,this.f.fire(void 0))}}e.$te=T;class j{constructor(F){this.value=F,this.onDidChange=R.None}}}),define(he[25],ue([0,1,3]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=e.CancellationToken=void 0,e.$ve=O;const c=Object.freeze(function(k,y){const R=setTimeout(k.bind(y),0);return{dispose(){clearTimeout(R)}}});var A;(function(k){function y(R){return R===k.None||R===k.Cancelled||R instanceof L?!0:!R||typeof R!="object"?!1:typeof R.isCancellationRequested=="boolean"&&typeof R.onCancellationRequested=="function"}k.isCancellationToken=y,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:c})})(A||(e.CancellationToken=A={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?c:(this.b||(this.b=new I.$je),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class N{constructor(y){this.f=void 0,this.g=void 0,this.g=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new L),this.f}cancel(){this.f?this.f instanceof L&&this.f.cancel():this.f=A.Cancelled}dispose(y=!1){y&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof L&&this.f.dispose():this.f=A.None}}e.$ue=N;function O(k){const y=new N;return k.add({dispose(){y.cancel()}}),y.token}}),define(he[135],ue([0,1,25]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0e=e.$9e=e.$7e=void 0,e.$8e=A;class c{constructor(k){this.b=k,this.a=null}get(){if(this.a)return this.a;const k=new I.$ue,y=this.b(k.token);return this.a={promise:y,dispose:()=>{this.a=null,k.cancel(),k.dispose()}},this.a}}e.$7e=c;function A(O){return O}class L{constructor(k,y){this.a=void 0,this.b=void 0,typeof k=="function"?(this.c=k,this.d=A):(this.c=y,this.d=k.getCacheKey)}get(k){const y=this.d(k);return this.b!==y&&(this.b=y,this.a=this.c(k)),this.a}}e.$9e=L;class N{get cachedValues(){return this.a}constructor(k,y){this.a=new Map,this.b=new Map,typeof k=="function"?(this.c=k,this.d=A):(this.c=y,this.d=k.getCacheKey)}get(k){const y=this.d(k);if(this.b.has(y))return this.b.get(y);const R=this.c(k);return this.a.set(k,R),this.b.set(y,R),R}}e.$0e=N}),define(he[50],ue([0,1,8,2]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=A,e.$xe=L,e.$ye=N,e.$ze=O,e.$Ae=y,e.$Be=R,e.$Ce=d,e.$De=u,e.$Ee=$,e.$Fe=l,e.$Ge=p,e.$He=S,e.$Ie=g,e.$Je=w,e.$Ke=P;function A(m){const o=m;return o?typeof o.read=="function":!1}function L(m){const o=m;return o?[o.on,o.pause,o.resume,o.destroy].every(h=>typeof h=="function"):!1}function N(m){const o=m;return o?L(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}function O(m,o){return new k(m,o)}class k{constructor(o,h){this.e=o,this.f=h,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(o){if(!this.a.destroyed){if(this.a.flowing)this.g(o);else if(this.b.data.push(o),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(h=>this.d.push(h))}}error(o){this.a.destroyed||(this.a.flowing?this.h(o):this.b.error.push(o))}end(o){this.a.destroyed||(typeof o<"u"&&this.write(o),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(o){this.c.data.slice(0).forEach(h=>h(o))}h(o){this.c.error.length===0?(0,I.$Y)(o):this.c.error.slice(0).forEach(h=>h(o))}i(){this.c.end.slice(0).forEach(o=>o())}on(o,h){if(!this.a.destroyed)switch(o){case"data":this.c.data.push(h),this.resume();break;case"end":this.c.end.push(h),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(h),this.a.flowing&&this.k();break}}removeListener(o,h){if(this.a.destroyed)return;let i;switch(o){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const s=i.indexOf(h);s>=0&&i.splice(s,1)}}j(){if(this.b.data.length>0){const o=this.e(this.b.data);this.g(o),this.b.data.length=0;const h=[...this.d];this.d.length=0,h.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const o of this.b.error)this.h(o);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function y(m,o){const h=[];let i;for(;(i=m.read())!==null;)h.push(i);return o(h)}function R(m,o,h){const i=[];let s;for(;(s=m.read())!==null&&i.length<h;)i.push(s);return s===null&&i.length>0?o(i):{read:()=>{if(i.length>0)return i.shift();if(typeof s<"u"){const t=s;return s=void 0,t}return m.read()}}}function d(m,o){return new Promise((h,i)=>{const s=[];u(m,{onData:t=>{o&&s.push(t)},onError:t=>{o?i(t):h(void 0)},onEnd:()=>{h(o?o(s):void 0)}})})}function u(m,o,h){m.on("error",i=>{h?.isCancellationRequested||o.onError(i)}),m.on("end",()=>{h?.isCancellationRequested||o.onEnd()}),m.on("data",i=>{h?.isCancellationRequested||o.onData(i)})}function $(m,o){return new Promise((h,i)=>{const s=new c.$Sc,t=[],n=f=>{if(t.push(f),t.length>o)return s.dispose(),m.pause(),h({stream:m,buffer:t,ended:!1})},r=f=>(s.dispose(),i(f)),a=()=>(s.dispose(),h({stream:m,buffer:t,ended:!0}));s.add((0,c.$Rc)(()=>m.removeListener("error",r))),m.on("error",r),s.add((0,c.$Rc)(()=>m.removeListener("end",a))),m.on("end",a),s.add((0,c.$Rc)(()=>m.removeListener("data",n))),m.on("data",n)})}function l(m,o){const h=O(o);return h.end(m),h}function p(){const m=O(()=>{throw new Error("not supported")});return m.end(),m}function S(m){let o=!1;return{read:()=>o?null:(o=!0,m)}}function g(m,o,h){const i=O(h);return u(m,{onData:s=>i.write(o.data(s)),onError:s=>i.error(o.error?o.error(s):s),onEnd:()=>i.end()}),i}function w(m,o,h){let i=!1;return{read:()=>{const s=o.read();return i?s:(i=!0,s!==null?h([m,s]):m)}}}function P(m,o,h){let i=!1;const s=O(h);return u(o,{onData:t=>i?s.write(t):(i=!0,s.write(h([m,t]))),onError:t=>s.error(t),onEnd:()=>{i||(i=!0,s.write(m)),s.end()}}),s}}),define(he[14],ue([0,1,53,50]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Le=void 0,e.$Me=y,e.$Ne=R,e.$Oe=d,e.$Pe=u,e.$Qe=$,e.$Re=l,e.$Se=p,e.$Te=S,e.$Ue=g,e.$Ve=w,e.$We=P,e.$Xe=m,e.$Ye=o,e.$Ze=h,e.$1e=i,e.$2e=s,e.$3e=t,e.$4e=n,e.$5e=r,e.$6e=v,c=ke(c);const A=typeof Buffer<"u",L=new I.$T(()=>new Uint8Array(256));let N,O;class k{static alloc(b){return A?new k(Buffer.allocUnsafe(b)):new k(new Uint8Array(b))}static wrap(b){return A&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new k(b)}static fromString(b,E){return!(E?.dontUseNodeBuffer||!1)&&A?new k(Buffer.from(b)):(N||(N=new TextEncoder),new k(N.encode(b)))}static fromByteArray(b){const E=k.alloc(b.length);for(let T=0,j=b.length;T<j;T++)E.buffer[T]=b[T];return E}static concat(b,E){if(typeof E>"u"){E=0;for(let U=0,F=b.length;U<F;U++)E+=b[U].byteLength}const T=k.alloc(E);let j=0;for(let U=0,F=b.length;U<F;U++){const K=b[U];T.set(K,j),j+=K.byteLength}return T}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=k.alloc(this.byteLength);return b.set(this),b}toString(){return A?this.buffer.toString():(O||(O=new TextDecoder),O.decode(this.buffer))}slice(b,E){return new k(this.buffer.subarray(b,E))}set(b,E){if(b instanceof k)this.buffer.set(b.buffer,E);else if(b instanceof Uint8Array)this.buffer.set(b,E);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),E);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),E);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return u(this.buffer,b)}writeUInt32BE(b,E){$(this.buffer,b,E)}readUInt32LE(b){return l(this.buffer,b)}writeUInt32LE(b,E){p(this.buffer,b,E)}readUInt8(b){return S(this.buffer,b)}writeUInt8(b,E){g(this.buffer,b,E)}indexOf(b,E=0){return y(this.buffer,b instanceof k?b.buffer:b,E)}}e.$Le=k;function y(C,b,E=0){const T=b.byteLength,j=C.byteLength;if(T===0)return 0;if(T===1)return C.indexOf(b[0]);if(T>j-E)return-1;const U=L.value;U.fill(b.length);for(let x=0;x<b.length;x++)U[b[x]]=b.length-x-1;let F=E+b.length-1,K=F,W=-1;for(;F<j;)if(C[F]===b[K]){if(K===0){W=F;break}F--,K--}else F+=Math.max(b.length-K,U[C[F]]),K=b.length-1;return W}function R(C,b){return C[b+0]<<0>>>0|C[b+1]<<8>>>0}function d(C,b,E){C[E+0]=b&255,b=b>>>8,C[E+1]=b&255}function u(C,b){return C[b]*2**24+C[b+1]*2**16+C[b+2]*2**8+C[b+3]}function $(C,b,E){C[E+3]=b,b=b>>>8,C[E+2]=b,b=b>>>8,C[E+1]=b,b=b>>>8,C[E]=b}function l(C,b){return C[b+0]<<0>>>0|C[b+1]<<8>>>0|C[b+2]<<16>>>0|C[b+3]<<24>>>0}function p(C,b,E){C[E+0]=b&255,b=b>>>8,C[E+1]=b&255,b=b>>>8,C[E+2]=b&255,b=b>>>8,C[E+3]=b&255}function S(C,b){return C[b]}function g(C,b,E){C[E]=b}function w(C){return c.$Ae(C,b=>k.concat(b))}function P(C){return c.$He(C)}function m(C){return c.$Ce(C,b=>k.concat(b))}async function o(C){return C.ended?k.concat(C.buffer):k.concat([...C.buffer,await m(C.stream)])}function h(C){return c.$Fe(C,b=>k.concat(b))}function i(C){return c.$Ie(C,{data:b=>typeof b=="string"?k.fromString(b):k.wrap(b)},b=>k.concat(b))}function s(C){return c.$ze(b=>k.concat(b),C)}function t(C,b){return c.$Je(C,b,E=>k.concat(E))}function n(C,b){return c.$Ke(C,b,E=>k.concat(E))}function r(C){let b=0,E=0,T=0;const j=new Uint8Array(Math.floor(C.length/4*3)),U=K=>{switch(E){case 3:j[T++]=b|K,E=0;break;case 2:j[T++]=b|K>>>2,b=K<<6,E=3;break;case 1:j[T++]=b|K>>>4,b=K<<4,E=2;break;default:b=K<<2,E=1}};for(let K=0;K<C.length;K++){const W=C.charCodeAt(K);if(W>=65&&W<=90)U(W-65);else if(W>=97&&W<=122)U(W-97+26);else if(W>=48&&W<=57)U(W-48+52);else if(W===43||W===45)U(62);else if(W===47||W===95)U(63);else{if(W===61)break;throw new SyntaxError(`Unexpected base64 character ${C[K]}`)}}const F=T;for(;E>0;)U(0);return k.wrap(j).slice(0,F)}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function v({buffer:C},b=!0,E=!1){const T=E?f:a;let j="";const U=C.byteLength%3;let F=0;for(;F<C.byteLength-U;F+=3){const K=C[F+0],W=C[F+1],x=C[F+2];j+=T[K>>>2],j+=T[(K<<4|W>>>4)&63],j+=T[(W<<2|x>>>6)&63],j+=T[x&63]}if(U===1){const K=C[F+0];j+=T[K>>>2],j+=T[K<<4&63],b&&(j+="==")}else if(U===2){const K=C[F+0],W=C[F+1];j+=T[K>>>2],j+=T[(K<<4|W>>>4)&63],j+=T[W<<2&63],b&&(j+="=")}return j}}),define(he[136],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=void 0,e.$ee=Symbol("MicrotaskDelay")}),define(he[12],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cg=I,e.$dg=c,e.$eg=A,e.$fg=L,e.$gg=N,e.$hg=O,e.$ig=k,e.$jg=y,e.$kg=R,e.$lg=d,e.$mg=u,e.$ng=$,e.$og=l,e.$pg=S,e.$qg=g,e.$rg=w,e.$sg=P,e.$tg=m;function I(o){return typeof o=="string"}function c(o){return Array.isArray(o)&&o.every(h=>I(h))}function A(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}function L(o){const h=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof h}function N(o){return typeof o=="number"&&!isNaN(o)}function O(o){return!!o&&typeof o[Symbol.iterator]=="function"}function k(o){return o===!0||o===!1}function y(o){return typeof o>"u"}function R(o){return!d(o)}function d(o){return y(o)||o===null}function u(o,h){if(!o)throw new Error(h?`Unexpected type, expected '${h}'`:"Unexpected type")}function $(o){if(d(o))throw new Error("Assertion Failed: argument is undefined or null");return o}function l(...o){const h=[];for(let i=0;i<o.length;i++){const s=o[i];if(d(s))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);h.push(s)}return h}const p=Object.prototype.hasOwnProperty;function S(o){if(!A(o))return!1;for(const h in o)if(p.call(o,h))return!1;return!0}function g(o){return typeof o=="function"}function w(...o){return o.length>0&&o.every(g)}function P(o,h){const i=Math.min(o.length,h.length);for(let s=0;s<i;s++)m(o[s],h[s])}function m(o,h){if(I(h)){if(typeof o!==h)throw new Error(`argument does not match constraint: typeof ${h}`)}else if(g(h)){try{if(o instanceof h)return}catch{}if(!d(o)&&o.constructor===h||h.length===1&&h.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(he[29],ue([0,1,12]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ao=c,e.$bo=A,e.$co=N,e.$do=k,e.$eo=y,e.$fo=R,e.$go=d,e.$ho=u,e.$io=$,e.$jo=l,e.$ko=p,e.$lo=S,e.$mo=g;function c(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const P=Array.isArray(w)?[]:{};return Object.entries(w).forEach(([m,o])=>{P[m]=o&&typeof o=="object"?c(o):o}),P}function A(w){if(!w||typeof w!="object")return w;const P=[w];for(;P.length>0;){const m=P.shift();Object.freeze(m);for(const o in m)if(L.call(m,o)){const h=m[o];typeof h=="object"&&!Object.isFrozen(h)&&!(0,I.$fg)(h)&&P.push(h)}}return w}const L=Object.prototype.hasOwnProperty;function N(w,P){return O(w,P,new Set)}function O(w,P,m){if((0,I.$lg)(w))return w;const o=P(w);if(typeof o<"u")return o;if(Array.isArray(w)){const h=[];for(const i of w)h.push(O(i,P,m));return h}if((0,I.$eg)(w)){if(m.has(w))throw new Error("Cannot clone recursive data-structure");m.add(w);const h={};for(const i in w)L.call(w,i)&&(h[i]=O(w[i],P,m));return m.delete(w),h}return w}function k(w,P,m=!0){return(0,I.$eg)(w)?((0,I.$eg)(P)&&Object.keys(P).forEach(o=>{o in w?m&&((0,I.$eg)(w[o])&&(0,I.$eg)(P[o])?k(w[o],P[o],m):w[o]=P[o]):w[o]=P[o]}),w):P}function y(w,P){if(w===P)return!0;if(w==null||P===null||P===void 0||typeof w!=typeof P||typeof w!="object"||Array.isArray(w)!==Array.isArray(P))return!1;let m,o;if(Array.isArray(w)){if(w.length!==P.length)return!1;for(m=0;m<w.length;m++)if(!y(w[m],P[m]))return!1}else{const h=[];for(o in w)h.push(o);h.sort();const i=[];for(o in P)i.push(o);if(i.sort(),!y(h,i))return!1;for(m=0;m<h.length;m++)if(!y(w[h[m]],P[h[m]]))return!1}return!0}function R(w){const P=new Set;return JSON.stringify(w,(m,o)=>{if((0,I.$eg)(o)||Array.isArray(o)){if(P.has(o))return"[Circular]";P.add(o)}return typeof o=="bigint"?`[BigInt ${o.toString()}]`:o})}function d(w,P){const m=Object.create(null);return!w||!P||Object.keys(P).forEach(h=>{const i=w[h],s=P[h];y(i,s)||(m[h]=s)}),m}function u(w,P){const m=P.toLowerCase(),o=Object.keys(w).find(h=>h.toLowerCase()===m);return o?w[o]:w[P]}function $(w,P){const m=Object.create(null);for(const[o,h]of Object.entries(w))P(o,h)&&(m[o]=h);return m}function l(w){let P=[];for(;Object.prototype!==w;)P=P.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return P}function p(w){const P=[];for(const m of l(w))typeof w[m]=="function"&&P.push(m);return P}function S(w,P){const m=h=>function(){const i=Array.prototype.slice.call(arguments,0);return P(h,i)},o={};for(const h of w)o[h]=m(h);return o}function g(w,P){const m={};for(const[o,h]of Object.entries(w))m[o]=P(h,o);return m}}),define(he[137],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$$e=c,e.$_e=A;var I;(function(L){L[L.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",L[L.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",L[L.MAX_UINT_8=255]="MAX_UINT_8",L[L.MAX_UINT_16=65535]="MAX_UINT_16",L[L.MAX_UINT_32=4294967295]="MAX_UINT_32",L[L.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(I||(e.Constants=I={}));function c(L){return L<0?0:L>I.MAX_UINT_8?I.MAX_UINT_8:L|0}function A(L){return L<0?0:L>I.MAX_UINT_32?I.MAX_UINT_32:L|0}}),define(he[26],ue([0,1,135,39,53,137]),function(oe,e,I,c,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bg=e.$ag=e.$_f=e.GraphemeBreakType=e.$2f=e.$Tf=e.$Mf=e.$Lf=void 0,e.$af=N,e.$bf=k,e.$cf=R,e.$df=d,e.$ef=u,e.$ff=$,e.$gf=l,e.$hf=p,e.$if=S,e.$jf=g,e.$kf=w,e.$lf=P,e.$mf=m,e.$nf=o,e.$of=h,e.$pf=i,e.$qf=s,e.$rf=t,e.$sf=n,e.$tf=r,e.$uf=a,e.$vf=f,e.$wf=v,e.$xf=C,e.$yf=b,e.$zf=E,e.$Af=T,e.$Bf=j,e.$Cf=U,e.$Df=F,e.$Ef=K,e.$Ff=W,e.$Gf=x,e.$Hf=G,e.$If=ie,e.$Jf=V,e.$Kf=z,e.$Nf=te,e.$Of=Y,e.$Pf=H,e.$Qf=B,e.$Rf=q,e.$Sf=Z,e.$Uf=ee,e.$Vf=X,e.$Wf=re,e.$Xf=le,e.$Yf=pe,e.$Zf=Ee,e.$1f=be,e.$3f=Se,e.$4f=Ie,e.$5f=ae,e.$6f=de,e.$7f=me,e.$8f=Pe,e.$9f=Oe,e.$0f=je,e.$$f=Ge;function N(se){return!se||typeof se!="string"?!0:se.trim().length===0}const O=/{(\d+)}/g;function k(se,...fe){return fe.length===0?se:se.replace(O,function($e,ye){const Ae=parseInt(ye,10);return isNaN(Ae)||Ae<0||Ae>=fe.length?$e:fe[Ae]})}const y=/{([^}]+)}/g;function R(se,fe){return Object.keys(fe).length===0?se:se.replace(y,($e,ye)=>fe[ye]??$e)}function d(se){return se.replace(/[<>"'&]/g,fe=>{switch(fe){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return fe})}function u(se){return se.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}function $(se){return se.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function l(se,fe){let $e=0,ye=se.indexOf(fe);for(;ye!==-1;)$e++,ye=se.indexOf(fe,ye+fe.length);return $e}function p(se,fe,$e="\u2026"){return se.length<=fe?se:`${se.substr(0,fe)}${$e}`}function S(se,fe,$e="\u2026"){if(se.length<=fe)return se;const ye=Math.ceil(fe/2)-$e.length/2,Ae=Math.floor(fe/2)-$e.length/2;return`${se.substr(0,ye)}${$e}${se.substr(se.length-Ae)}`}function g(se,fe=" "){const $e=w(se,fe);return P($e,fe)}function w(se,fe){if(!se||!fe)return se;const $e=fe.length;if($e===0||se.length===0)return se;let ye=0;for(;se.indexOf(fe,ye)===ye;)ye=ye+$e;return se.substring(ye)}function P(se,fe){if(!se||!fe)return se;const $e=fe.length,ye=se.length;if($e===0||ye===0)return se;let Ae=ye,Te=-1;for(;Te=se.lastIndexOf(fe,Ae-1),!(Te===-1||Te+$e!==Ae);){if(Te===0)return"";Ae=Te}return se.substring(0,Ae)}function m(se){return se.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function o(se){return se.replace(/\*/g,"")}function h(se,fe,$e={}){if(!se)throw new Error("Cannot create regex from empty string");fe||(se=$(se)),$e.wholeWord&&(/\B/.test(se.charAt(0))||(se="\\b"+se),/\B/.test(se.charAt(se.length-1))||(se=se+"\\b"));let ye="";return $e.global&&(ye+="g"),$e.matchCase||(ye+="i"),$e.multiline&&(ye+="m"),$e.unicode&&(ye+="u"),new RegExp(se,ye)}function i(se){return se.source==="^"||se.source==="^$"||se.source==="$"||se.source==="^\\s*$"?!1:!!(se.exec("")&&se.lastIndex===0)}function s(se){return se.split(/\r\n|\r|\n/)}function t(se){const fe=[],$e=se.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil($e.length/2);ye++)fe.push($e[2*ye]+($e[2*ye+1]??""));return fe}function n(se){for(let fe=0,$e=se.length;fe<$e;fe++){const ye=se.charCodeAt(fe);if(ye!==c.CharCode.Space&&ye!==c.CharCode.Tab)return fe}return-1}function r(se,fe=0,$e=se.length){for(let ye=fe;ye<$e;ye++){const Ae=se.charCodeAt(ye);if(Ae!==c.CharCode.Space&&Ae!==c.CharCode.Tab)return se.substring(fe,ye)}return se.substring(fe,$e)}function a(se,fe=se.length-1){for(let $e=fe;$e>=0;$e--){const ye=se.charCodeAt($e);if(ye!==c.CharCode.Space&&ye!==c.CharCode.Tab)return $e}return-1}function f(se,fe,$e){const ye=[];let Ae=0;for(const Te of se.matchAll(fe)){if(ye.push(se.slice(Ae,Te.index)),Te.index===void 0)throw new Error("match.index should be defined");Ae=Te.index+Te[0].length,ye.push($e(Te[0],...Te.slice(1),Te.index,se,Te.groups))}return ye.push(se.slice(Ae)),Promise.all(ye).then(Te=>Te.join(""))}function v(se,fe){return se<fe?-1:se>fe?1:0}function C(se,fe,$e=0,ye=se.length,Ae=0,Te=fe.length){for(;$e<ye&&Ae<Te;$e++,Ae++){const Je=se.charCodeAt($e),Ye=fe.charCodeAt(Ae);if(Je<Ye)return-1;if(Je>Ye)return 1}const Me=ye-$e,xe=Te-Ae;return Me<xe?-1:Me>xe?1:0}function b(se,fe){return E(se,fe,0,se.length,0,fe.length)}function E(se,fe,$e=0,ye=se.length,Ae=0,Te=fe.length){for(;$e<ye&&Ae<Te;$e++,Ae++){let Je=se.charCodeAt($e),Ye=fe.charCodeAt(Ae);if(Je===Ye)continue;if(Je>=128||Ye>=128)return C(se.toLowerCase(),fe.toLowerCase(),$e,ye,Ae,Te);j(Je)&&(Je-=32),j(Ye)&&(Ye-=32);const Ve=Je-Ye;if(Ve!==0)return Ve}const Me=ye-$e,xe=Te-Ae;return Me<xe?-1:Me>xe?1:0}function T(se){return se>=c.CharCode.Digit0&&se<=c.CharCode.Digit9}function j(se){return se>=c.CharCode.a&&se<=c.CharCode.z}function U(se){return se>=c.CharCode.A&&se<=c.CharCode.Z}function F(se,fe){return se.length===fe.length&&E(se,fe)===0}function K(se,fe){const $e=fe.length;return fe.length>se.length?!1:E(se,fe,0,$e)===0}function W(se,fe){const $e=Math.min(se.length,fe.length);let ye;for(ye=0;ye<$e;ye++)if(se.charCodeAt(ye)!==fe.charCodeAt(ye))return ye;return $e}function x(se,fe){const $e=Math.min(se.length,fe.length);let ye;const Ae=se.length-1,Te=fe.length-1;for(ye=0;ye<$e;ye++)if(se.charCodeAt(Ae-ye)!==fe.charCodeAt(Te-ye))return ye;return $e}function G(se){return 55296<=se&&se<=56319}function ie(se){return 56320<=se&&se<=57343}function V(se,fe){return(se-55296<<10)+(fe-56320)+65536}function z(se,fe,$e){const ye=se.charCodeAt($e);if(G(ye)&&$e+1<fe){const Ae=se.charCodeAt($e+1);if(ie(Ae))return V(ye,Ae)}return ye}function _(se,fe){const $e=se.charCodeAt(fe-1);if(ie($e)&&fe>1){const ye=se.charCodeAt(fe-2);if(G(ye))return V(ye,$e)}return $e}class ne{get offset(){return this.e}constructor(fe,$e=0){this.c=fe,this.d=fe.length,this.e=$e}setOffset(fe){this.e=fe}prevCodePoint(){const fe=_(this.c,this.e);return this.e-=fe>=L.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,fe}nextCodePoint(){const fe=z(this.c,this.d,this.e);return this.e+=fe>=L.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,fe}eol(){return this.e>=this.d}}e.$Lf=ne;class ce{get offset(){return this.c.offset}constructor(fe,$e=0){this.c=new ne(fe,$e)}nextGraphemeLength(){const fe=Ue.getInstance(),$e=this.c,ye=$e.offset;let Ae=fe.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const Te=$e.offset,Me=fe.getGraphemeBreakType($e.nextCodePoint());if(Ne(Ae,Me)){$e.setOffset(Te);break}Ae=Me}return $e.offset-ye}prevGraphemeLength(){const fe=Ue.getInstance(),$e=this.c,ye=$e.offset;let Ae=fe.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const Te=$e.offset,Me=fe.getGraphemeBreakType($e.prevCodePoint());if(Ne(Me,Ae)){$e.setOffset(Te);break}Ae=Me}return ye-$e.offset}eol(){return this.c.eol()}}e.$Mf=ce;function te(se,fe){return new ce(se,fe).nextGraphemeLength()}function Y(se,fe){return new ce(se,fe).prevGraphemeLength()}function H(se,fe){fe>0&&ie(se.charCodeAt(fe))&&fe--;const $e=fe+te(se,fe);return[$e-Y(se,$e),$e]}function B(se){const fe=new ce(se);let $e=0;for(;!fe.eol();)$e++,fe.nextGraphemeLength();return $e}let D;function J(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function q(se){return D||(D=J()),D.test(se)}const M=/^[\t\n\r\x20-\x7E]*$/;function Z(se){return M.test(se)}e.$Tf=/[\u2028\u2029]/;function ee(se){return e.$Tf.test(se)}function X(se){return se>=11904&&se<=55215||se>=63744&&se<=64255||se>=65281&&se<=65374}function re(se){return se>=127462&&se<=127487||se===8986||se===8987||se===9200||se===9203||se>=9728&&se<=10175||se===11088||se===11093||se>=127744&&se<=128591||se>=128640&&se<=128764||se>=128992&&se<=129008||se>=129280&&se<=129535||se>=129648&&se<=129782}function le(se,fe,$e=""){const ye=se.trimStart();if(ye.length<fe)return ye;const Ae=/\b/g;let Te=0;for(;Ae.test(ye)&&!(ye.length-Ae.lastIndex<fe);)Te=Ae.lastIndex,Ae.lastIndex+=1;return Te===0?ye:$e+ye.substring(Te).trimStart()}const ge=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*pe(se){let fe=0;for(const $e of se.matchAll(ge))fe!==$e.index&&(yield{isCode:!1,str:se.substring(fe,$e.index)}),yield{isCode:!0,str:$e[0]},fe=$e.index+$e[0].length;fe!==se.length&&(yield{isCode:!1,str:se.substring(fe)})}function Ee(se){return se&&(se=se.replace(ge,"")),se}const we=/\\\[.*?\\\]/g;function be(se){return Ee(se).replace(we,"")}e.$2f=String.fromCharCode(c.CharCode.UTF8_BOM);function Se(se){return!!(se&&se.length>0&&se.charCodeAt(0)===c.CharCode.UTF8_BOM)}function Ie(se){return Se(se)?se.substr(1):se}function ae(se,fe){if(!se||!fe||se.length<fe.length)return!1;const $e=fe.length,ye=se.toLowerCase();let Ae=0,Te=-1;for(;Ae<$e;){const Me=ye.indexOf(fe[Ae],Te+1);if(Me<0)return!1;Te=Me,Ae++}return!0}function de(se,fe=!1){return se?(fe&&(se=se.replace(/\\./g,"")),se.toLowerCase()!==se):!1}function me(se){return se.charAt(0).toUpperCase()+se.slice(1)}function Pe(se,fe=1){if(fe===0)return"";let $e=-1;do $e=se.indexOf(`
`,$e+1),fe--;while(fe>0&&$e>=0);return $e===-1?se:(se[$e-1]==="\r"&&$e--,se.substr(0,$e))}function Oe(se){const fe=c.CharCode.Z-c.CharCode.A+1;return se=se%(2*fe),se<fe?String.fromCharCode(c.CharCode.a+se):String.fromCharCode(c.CharCode.A+se-fe)}function je(se){return Ue.getInstance().getGraphemeBreakType(se)}function Ne(se,fe){return se===Le.Other?fe!==Le.Extend&&fe!==Le.SpacingMark:se===Le.CR&&fe===Le.LF?!1:se===Le.Control||se===Le.CR||se===Le.LF||fe===Le.Control||fe===Le.CR||fe===Le.LF?!0:!(se===Le.L&&(fe===Le.L||fe===Le.V||fe===Le.LV||fe===Le.LVT)||(se===Le.LV||se===Le.V)&&(fe===Le.V||fe===Le.T)||(se===Le.LVT||se===Le.T)&&fe===Le.T||fe===Le.Extend||fe===Le.ZWJ||fe===Le.SpacingMark||se===Le.Prepend||se===Le.ZWJ&&fe===Le.Extended_Pictographic||se===Le.Regional_Indicator&&fe===Le.Regional_Indicator)}var Le;(function(se){se[se.Other=0]="Other",se[se.Prepend=1]="Prepend",se[se.CR=2]="CR",se[se.LF=3]="LF",se[se.Control=4]="Control",se[se.Extend=5]="Extend",se[se.Regional_Indicator=6]="Regional_Indicator",se[se.SpacingMark=7]="SpacingMark",se[se.L=8]="L",se[se.V=9]="V",se[se.T=10]="T",se[se.LV=11]="LV",se[se.LVT=12]="LVT",se[se.ZWJ=13]="ZWJ",se[se.Extended_Pictographic=14]="Extended_Pictographic"})(Le||(e.GraphemeBreakType=Le={}));class Ue{static{this.c=null}static getInstance(){return Ue.c||(Ue.c=new Ue),Ue.c}constructor(){this.d=qe()}getGraphemeBreakType(fe){if(fe<32)return fe===c.CharCode.LineFeed?Le.LF:fe===c.CharCode.CarriageReturn?Le.CR:Le.Control;if(fe<127)return Le.Other;const $e=this.d,ye=$e.length/3;let Ae=1;for(;Ae<=ye;)if(fe<$e[3*Ae])Ae=2*Ae;else if(fe>$e[3*Ae+1])Ae=2*Ae+1;else return $e[3*Ae+2];return Le.Other}}function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ge(se,fe){if(se===0)return 0;const $e=Fe(se,fe);if($e!==void 0)return $e;const ye=new ne(fe,se);return ye.prevCodePoint(),ye.offset}function Fe(se,fe){const $e=new ne(fe,se);let ye=$e.prevCodePoint();for(;Be(ye)||ye===ze.emojiVariantSelector||ye===ze.enclosingKeyCap;){if($e.offset===0)return;ye=$e.prevCodePoint()}if(!re(ye))return;let Ae=$e.offset;return Ae>0&&$e.prevCodePoint()===ze.zwj&&(Ae=$e.offset),Ae}function Be(se){return 127995<=se&&se<=127999}var ze;(function(se){se[se.zwj=8205]="zwj",se[se.emojiVariantSelector=65039]="emojiVariantSelector",se[se.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.$_f="\xA0";class We{static{this.c=new A.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new I.$9e({getCacheKey:JSON.stringify},fe=>{function $e(Ve){const _e=new Map;for(let Qe=0;Qe<Ve.length;Qe+=2)_e.set(Ve[Qe],Ve[Qe+1]);return _e}function ye(Ve,_e){const Qe=new Map(Ve);for(const[nt,at]of _e)Qe.set(nt,at);return Qe}function Ae(Ve,_e){if(!Ve)return _e;const Qe=new Map;for(const[nt,at]of Ve)_e.has(nt)&&Qe.set(nt,at);return Qe}const Te=this.c.value;let Me=fe.filter(Ve=>!Ve.startsWith("_")&&Ve in Te);Me.length===0&&(Me=["_default"]);let xe;for(const Ve of Me){const _e=$e(Te[Ve]);xe=Ae(xe,_e)}const Je=$e(Te._common),Ye=ye(Je,xe);return new We(Ye)})}static getInstance(fe){return We.d.get(Array.from(fe))}static{this.e=new A.$T(()=>Object.keys(We.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return We.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}containsAmbiguousCharacter(fe){for(let $e=0;$e<fe.length;$e++){const ye=fe.codePointAt($e);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$ag=We;class Ce{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ce.c())),this.d}static isInvisibleCharacter(fe){return Ce.e().has(fe)}static containsInvisibleCharacter(fe){for(let $e=0;$e<fe.length;$e++){const ye=fe.codePointAt($e);if(typeof ye=="number"&&Ce.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return Ce.e()}}e.$bg=Ce}),define(he[41],ue([0,1,39,13,5,26,12]),function(oe,e,I,c,A,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ug=O,e.$vg=k,e.$wg=y,e.$xg=R,e.$yg=d,e.$zg=p,e.$Ag=S,e.$Bg=g,e.$Cg=w,e.$Dg=P,e.$Eg=m,e.$Fg=o,e.$Gg=h,e.$Hg=i,e.$Ig=s,e.$Jg=t,e.$Kg=a;function O(f){return f===I.CharCode.Slash||f===I.CharCode.Backslash}function k(f){return f.replace(/[\\/]/g,c.$fc.sep)}function y(f){return f.indexOf("/")===-1&&(f=k(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}function R(f,v=c.$fc.sep){if(!f)return"";const C=f.length,b=f.charCodeAt(0);if(O(b)){if(O(f.charCodeAt(1))&&!O(f.charCodeAt(2))){let T=3;const j=T;for(;T<C&&!O(f.charCodeAt(T));T++);if(j!==T&&!O(f.charCodeAt(T+1))){for(T+=1;T<C;T++)if(O(f.charCodeAt(T)))return f.slice(0,T+1).replace(/[\\/]/g,v)}}return v}else if(w(b)&&f.charCodeAt(1)===I.CharCode.Colon)return O(f.charCodeAt(2))?f.slice(0,2)+v:f.slice(0,2);let E=f.indexOf("://");if(E!==-1){for(E+=3;E<C;E++)if(O(f.charCodeAt(E)))return f.slice(0,E+1)}return""}function d(f){if(!A.$j||!f||f.length<5)return!1;let v=f.charCodeAt(0);if(v!==I.CharCode.Backslash||(v=f.charCodeAt(1),v!==I.CharCode.Backslash))return!1;let C=2;const b=C;for(;C<f.length&&(v=f.charCodeAt(C),v!==I.CharCode.Backslash);C++);return!(b===C||(v=f.charCodeAt(C+1),isNaN(v)||v===I.CharCode.Backslash))}const u=/[\\/:\*\?"<>\|]/g,$=/[/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(f,v=A.$j){const C=v?u:$;return!(!f||f.length===0||/^\s+$/.test(f)||(C.lastIndex=0,C.test(f))||v&&l.test(f)||f==="."||f===".."||v&&f[f.length-1]==="."||v&&f.length!==f.trim().length||f.length>255)}function S(f,v,C){const b=f===v;return!C||b?b:!f||!v?!1:(0,L.$Df)(f,v)}function g(f,v,C,b=c.sep){if(f===v)return!0;if(!f||!v||v.length>f.length)return!1;if(C){if(!(0,L.$Ef)(f,v))return!1;if(v.length===f.length)return!0;let T=v.length;return v.charAt(v.length-1)===b&&T--,f.charAt(T)===b}return v.charAt(v.length-1)!==b&&(v+=b),f.indexOf(v)===0}function w(f){return f>=I.CharCode.A&&f<=I.CharCode.Z||f>=I.CharCode.a&&f<=I.CharCode.z}function P(f,v){return A.$j&&f.endsWith(":")&&(f+=c.sep),(0,c.$hc)(f)||(f=(0,c.$ic)(v,f)),f=(0,c.$gc)(f),m(f)}function m(f){return A.$j?(f=(0,L.$lf)(f,c.sep),f.endsWith(":")&&(f+=c.sep)):(f=(0,L.$lf)(f,c.sep),f||(f=c.sep)),f}function o(f){const v=(0,c.$gc)(f);return A.$j?f.length>3?!1:h(v)&&(f.length===2||v.charCodeAt(2)===I.CharCode.Backslash):v===c.$fc.sep}function h(f,v=A.$j){return v?w(f.charCodeAt(0))&&f.charCodeAt(1)===I.CharCode.Colon:!1}function i(f,v=A.$j){return h(f,v)?f[0]:void 0}function s(f,v,C){return v.length>f.length?-1:f===v?0:(C&&(f=f.toLowerCase(),v=v.toLowerCase()),f.indexOf(v))}function t(f){const v=f.split(":");let C,b,E;for(const T of v){const j=Number(T);(0,N.$gg)(j)?b===void 0?b=j:E===void 0&&(E=j):C=C?[C,T].join(":"):T}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:b!==void 0?b:void 0,column:E!==void 0?E:b!==void 0?1:void 0}}const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",r="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function a(f,v,C=8){let b="";for(let T=0;T<C;T++){let j;T===0&&A.$j&&!v&&(C===3||C===4)?j=r:j=n,b+=j.charAt(Math.floor(Math.random()*j.length))}let E;return v?E=`${v}-${b}`:E=b,f?(0,c.$ic)(f,E):E}}),define(he[55],ue([0,1,26]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$uj=void 0,e.$qj=c,e.$rj=A,e.$sj=L,e.$tj=O,e.$vj=p,I=ke(I);function c(g){return A(g,0)}function A(g,w){switch(typeof g){case"object":return g===null?L(349,w):Array.isArray(g)?k(g,w):y(g,w);case"string":return O(g,w);case"boolean":return N(g,w);case"number":return L(g,w);case"undefined":return L(937,w);default:return L(617,w)}}function L(g,w){return(w<<5)-w+g|0}function N(g,w){return L(g?433:863,w)}function O(g,w){w=L(149417,w);for(let P=0,m=g.length;P<m;P++)w=L(g.charCodeAt(P),w);return w}function k(g,w){return w=L(104579,w),g.reduce((P,m)=>A(m,P),w)}function y(g,w){return w=L(181387,w),Object.keys(g).sort().reduce((P,m)=>(P=O(m,P),A(g[m],P)),w)}class R{constructor(){this.g=0}get value(){return this.g}hash(w){return this.g=A(w,this.g),this.g}}e.$uj=R;var d;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(d||(d={}));function u(g,w,P=32){const m=P-w,o=~((1<<m)-1);return(g<<w|(o&g)>>>m)>>>0}function $(g,w=0,P=g.byteLength,m=0){for(let o=0;o<P;o++)g[w+o]=m}function l(g,w,P="0"){for(;g.length<w;)g=P+g;return g}function p(g,w=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(P=>P.toString(16).padStart(2,"0")).join(""):l((g>>>0).toString(16),w/4)}class S{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(d.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(w){const P=w.length;if(P===0)return;const m=this.p;let o=this.r,h=this.u,i,s;for(h!==0?(i=h,s=-1,h=0):(i=w.charCodeAt(0),s=0);;){let t=i;if(I.$Hf(i))if(s+1<P){const n=w.charCodeAt(s+1);I.$If(n)?(s++,t=I.$Jf(i,n)):t=d.UNICODE_REPLACEMENT}else{h=i;break}else I.$If(i)&&(t=d.UNICODE_REPLACEMENT);if(o=this.w(m,o,t),s++,s<P)i=w.charCodeAt(s);else break}this.r=o,this.u=h}w(w,P,m){return m<128?w[P++]=m:m<2048?(w[P++]=192|(m&1984)>>>6,w[P++]=128|(m&63)>>>0):m<65536?(w[P++]=224|(m&61440)>>>12,w[P++]=128|(m&4032)>>>6,w[P++]=128|(m&63)>>>0):(w[P++]=240|(m&1835008)>>>18,w[P++]=128|(m&258048)>>>12,w[P++]=128|(m&4032)>>>6,w[P++]=128|(m&63)>>>0),P>=d.BLOCK_SIZE&&(this.y(),P-=d.BLOCK_SIZE,this.t+=d.BLOCK_SIZE,w[0]=w[d.BLOCK_SIZE+0],w[1]=w[d.BLOCK_SIZE+1],w[2]=w[d.BLOCK_SIZE+2]),P}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,d.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,$(this.p,this.r),this.r>56&&(this.y(),$(this.p));const w=8*this.t;this.q.setUint32(56,Math.floor(w/4294967296),!1),this.q.setUint32(60,w%4294967296,!1),this.y()}y(){const w=S.g,P=this.q;for(let a=0;a<64;a+=4)w.setUint32(a,P.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)w.setUint32(a,u(w.getUint32(a-12,!1)^w.getUint32(a-32,!1)^w.getUint32(a-56,!1)^w.getUint32(a-64,!1),1),!1);let m=this.h,o=this.l,h=this.m,i=this.n,s=this.o,t,n,r;for(let a=0;a<80;a++)a<20?(t=o&h|~o&i,n=1518500249):a<40?(t=o^h^i,n=1859775393):a<60?(t=o&h|o&i|h&i,n=2400959708):(t=o^h^i,n=3395469782),r=u(m,5)+t+s+n+w.getUint32(a*4,!1)&4294967295,s=i,i=h,h=u(o,30),o=m,m=r;this.h=this.h+m&4294967295,this.l=this.l+o&4294967295,this.m=this.m+h&4294967295,this.n=this.n+i&4294967295,this.o=this.o+s&4294967295}}e.$wj=S}),define(he[92],ue([0,1,26]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),I=ke(I);var c;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(c||(c={})),function(A){const L="error",N="warning",O="warn",k="info",y="ignore";function R(u){return u?I.$Df(L,u)?A.Error:I.$Df(N,u)||I.$Df(O,u)?A.Warning:I.$Df(k,u)?A.Info:A.Ignore:A.Ignore}A.fromValue=R;function d(u){switch(u){case A.Error:return L;case A.Warning:return N;case A.Info:return k;default:return y}}A.toString=d}(c||(c={})),e.default=c}),define(he[51],ue([0,1,17,39,26]),function(oe,e,I,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=void 0;class L{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const p=l.charCodeAt(0),S=this.b.charCodeAt(this.c);return p-S}value(){return this.b[this.c]}}e.$Ei=L;class N{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===c.CharCode.Period)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,A.$xf)(l,this.b,0,l.length,this.c,this.d):(0,A.$zf)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Fi=N;class O{constructor(l=!0,p=!0){this.f=l,this.g=p}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let p=l.length-1;p>=0;p--,this.c--){const S=this.b.charCodeAt(p);if(!(S===c.CharCode.Slash||this.f&&S===c.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===c.CharCode.Slash||this.f&&p===c.CharCode.Backslash)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,A.$xf)(l,this.b,0,l.length,this.d,this.e):(0,A.$zf)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Gi=O;var k;(function($){$[$.Scheme=1]="Scheme",$[$.Authority=2]="Authority",$[$.Path=3]="Path",$[$.Query=4]="Query",$[$.Fragment=5]="Fragment"})(k||(k={}));class y{constructor(l,p){this.f=l,this.g=p,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(k.Scheme),this.c.authority&&this.d.push(k.Authority),this.c.path&&(this.b=new O(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(k.Path)),this.g(l)||(this.c.query&&this.d.push(k.Query),this.c.fragment&&this.d.push(k.Fragment)),this.e=0,this}next(){return this.d[this.e]===k.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===k.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===k.Scheme)return(0,A.$yf)(l,this.c.scheme);if(this.d[this.e]===k.Authority)return(0,A.$yf)(l,this.c.authority);if(this.d[this.e]===k.Path)return this.b.cmp(l);if(this.d[this.e]===k.Query)return(0,A.$wf)(l,this.c.query);if(this.d[this.e]===k.Fragment)return(0,A.$wf)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===k.Scheme)return this.c.scheme;if(this.d[this.e]===k.Authority)return this.c.authority;if(this.d[this.e]===k.Path)return this.b.value();if(this.d[this.e]===k.Query)return this.c.query;if(this.d[this.e]===k.Fragment)return this.c.fragment;throw new Error}}e.$Hi=y;class R{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function($){$[$.Left=-1]="Left",$[$.Mid=0]="Mid",$[$.Right=1]="Right"})(d||(d={}));class u{static forUris(l=()=>!1,p=()=>!1){return new u(new y(l,p))}static forPaths(l=!1){return new u(new O(void 0,!l))}static forStrings(){return new u(new L)}static forConfigKeys(){return new u(new N)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,p){if(p){const S=p.slice(0);(0,I.$Vb)(S);for(const g of S)this.set(g,l)}else{const S=l.slice(0);(0,I.$Vb)(S);for(const g of S)this.set(g[0],g[1])}}set(l,p){const S=this.b.reset(l);let g;this.c||(this.c=new R,this.c.segment=S.value());const w=[];for(g=this.c;;){const m=S.cmp(g.segment);if(m>0)g.left||(g.left=new R,g.left.segment=S.value()),w.push([d.Left,g]),g=g.left;else if(m<0)g.right||(g.right=new R,g.right.segment=S.value()),w.push([d.Right,g]),g=g.right;else if(S.hasNext())S.next(),g.mid||(g.mid=new R,g.mid.segment=S.value()),w.push([d.Mid,g]),g=g.mid;else break}const P=g.value;g.value=p,g.key=l;for(let m=w.length-1;m>=0;m--){const o=w[m][1];o.updateHeight();const h=o.balanceFactor();if(h<-1||h>1){const i=w[m][0],s=w[m+1][0];if(i===d.Right&&s===d.Right)w[m][1]=o.rotateLeft();else if(i===d.Left&&s===d.Left)w[m][1]=o.rotateRight();else if(i===d.Right&&s===d.Left)o.right=w[m+1][1]=w[m+1][1].rotateRight(),w[m][1]=o.rotateLeft();else if(i===d.Left&&s===d.Right)o.left=w[m+1][1]=w[m+1][1].rotateLeft(),w[m][1]=o.rotateRight();else throw new Error;if(m>0)switch(w[m-1][0]){case d.Left:w[m-1][1].left=w[m][1];break;case d.Right:w[m-1][1].right=w[m][1];break;case d.Mid:w[m-1][1].mid=w[m][1];break}else this.c=w[0][1]}}return P}get(l){return this.d(l)?.value}d(l){const p=this.b.reset(l);let S=this.c;for(;S;){const g=p.cmp(S.segment);if(g>0)S=S.left;else if(g<0)S=S.right;else if(p.hasNext())p.next(),S=S.mid;else break}return S}has(l){const p=this.d(l);return!(p?.value===void 0&&p?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,p){const S=this.b.reset(l),g=[];let w=this.c;for(;w;){const P=S.cmp(w.segment);if(P>0)g.push([d.Left,w]),w=w.left;else if(P<0)g.push([d.Right,w]),w=w.right;else if(S.hasNext())S.next(),g.push([d.Mid,w]),w=w.mid;else break}if(w){if(p?(w.left=void 0,w.mid=void 0,w.right=void 0,w.height=1):(w.key=void 0,w.value=void 0),!w.mid&&!w.value)if(w.left&&w.right){const P=this.f(w.right);if(P.key){const{key:m,value:o,segment:h}=P;this.e(P.key,!1),w.key=m,w.value=o,w.segment=h}}else{const P=w.left??w.right;if(g.length>0){const[m,o]=g[g.length-1];switch(m){case d.Left:o.left=P;break;case d.Mid:o.mid=P;break;case d.Right:o.right=P;break}}else this.c=P}for(let P=g.length-1;P>=0;P--){const m=g[P][1];m.updateHeight();const o=m.balanceFactor();if(o>1?(m.right.balanceFactor()>=0||(m.right=m.right.rotateRight()),g[P][1]=m.rotateLeft()):o<-1&&(m.left.balanceFactor()<=0||(m.left=m.left.rotateLeft()),g[P][1]=m.rotateRight()),P>0)switch(g[P-1][0]){case d.Left:g[P-1][1].left=g[P][1];break;case d.Right:g[P-1][1].right=g[P][1];break;case d.Mid:g[P-1][1].mid=g[P][1];break}else this.c=g[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const p=this.b.reset(l);let S=this.c,g;for(;S;){const w=p.cmp(S.segment);if(w>0)S=S.left;else if(w<0)S=S.right;else if(p.hasNext())p.next(),g=S.value||g,S=S.mid;else break}return S&&S.value||g}findSuperstr(l){return this.g(l,!1)}g(l,p){const S=this.b.reset(l);let g=this.c;for(;g;){const w=S.cmp(g.segment);if(w>0)g=g.left;else if(w<0)g=g.right;else if(S.hasNext())S.next(),g=g.mid;else return g.mid?this.h(g.mid):p?g.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[p,S]of this)l(S,p)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const p=[];return this.j(l,p),p[Symbol.iterator]()}j(l,p){l&&(l.left&&this.j(l.left,p),l.value&&p.push([l.key,l.value]),l.mid&&this.j(l.mid,p),l.right&&this.j(l.right,p))}_isBalanced(){const l=p=>{if(!p)return!0;const S=p.balanceFactor();return S<-1||S>1?!1:l(p.left)&&l(p.right)};return l(this.c)}}e.$Ii=u}),define(he[9],ue([0,1,39,65,13,5]),function(oe,e,I,c,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$uc=S,e.$vc=h,A=ke(A);const N=/^\w[\w\d+.-]*$/,O=/^\//,k=/^\/\//;function y(r,a){if(!r.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!N.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!O.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function R(r,a){return!r&&!a?"file":r}function d(r,a){switch(r){case"https":case"http":case"file":a?a[0]!==$&&(a=$+a):a=$;break}return a}const u="",$="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{static isUri(a){return a instanceof p?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,f,v,C,b,E=!1){typeof a=="object"?(this.scheme=a.scheme||u,this.authority=a.authority||u,this.path=a.path||u,this.query=a.query||u,this.fragment=a.fragment||u):(this.scheme=R(a,E),this.authority=f||u,this.path=d(this.scheme,v||u),this.query=C||u,this.fragment=b||u,y(this,E))}get fsPath(){return h(this,!1)}with(a){if(!a)return this;let{scheme:f,authority:v,path:C,query:b,fragment:E}=a;return f===void 0?f=this.scheme:f===null&&(f=u),v===void 0?v=this.authority:v===null&&(v=u),C===void 0?C=this.path:C===null&&(C=u),b===void 0?b=this.query:b===null&&(b=u),E===void 0?E=this.fragment:E===null&&(E=u),f===this.scheme&&v===this.authority&&C===this.path&&b===this.query&&E===this.fragment?this:new w(f,v,C,b,E)}static parse(a,f=!1){const v=l.exec(a);return v?new w(v[2]||u,n(v[4]||u),n(v[5]||u),n(v[7]||u),n(v[9]||u),f):new w(u,u,u,u,u)}static file(a){let f=u;if(L.$j&&(a=a.replace(/\\/g,$)),a[0]===$&&a[1]===$){const v=a.indexOf($,2);v===-1?(f=a.substring(2),a=$):(f=a.substring(2,v),a=a.substring(v)||$)}return new w("file",f,a,u,u)}static from(a,f){return new w(a.scheme,a.authority,a.path,a.query,a.fragment,f)}static joinPath(a,...f){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return L.$j&&a.scheme==="file"?v=p.file(A.$ec.join(h(a,!0),...f)).path:v=A.$fc.join(a.path,...f),a.with({path:v})}toString(a=!1){return i(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof p)return a;{const f=new w(a);return f._formatted=a.external??null,f._fsPath=a._sep===g?a.fsPath??null:null,f}}else return a}}e.URI=p;function S(r){return!r||typeof r!="object"?!1:typeof r.scheme=="string"&&(typeof r.authority=="string"||typeof r.authority>"u")&&(typeof r.path=="string"||typeof r.path>"u")&&(typeof r.query=="string"||typeof r.query>"u")&&(typeof r.fragment=="string"||typeof r.fragment>"u")}const g=L.$j?1:void 0;class w extends p{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(a=!1){return a?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const a={$mid:c.MarshalledId.Uri};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=g),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const P={[I.CharCode.Colon]:"%3A",[I.CharCode.Slash]:"%2F",[I.CharCode.QuestionMark]:"%3F",[I.CharCode.Hash]:"%23",[I.CharCode.OpenSquareBracket]:"%5B",[I.CharCode.CloseSquareBracket]:"%5D",[I.CharCode.AtSign]:"%40",[I.CharCode.ExclamationMark]:"%21",[I.CharCode.DollarSign]:"%24",[I.CharCode.Ampersand]:"%26",[I.CharCode.SingleQuote]:"%27",[I.CharCode.OpenParen]:"%28",[I.CharCode.CloseParen]:"%29",[I.CharCode.Asterisk]:"%2A",[I.CharCode.Plus]:"%2B",[I.CharCode.Comma]:"%2C",[I.CharCode.Semicolon]:"%3B",[I.CharCode.Equals]:"%3D",[I.CharCode.Space]:"%20"};function m(r,a,f){let v,C=-1;for(let b=0;b<r.length;b++){const E=r.charCodeAt(b);if(E>=I.CharCode.a&&E<=I.CharCode.z||E>=I.CharCode.A&&E<=I.CharCode.Z||E>=I.CharCode.Digit0&&E<=I.CharCode.Digit9||E===I.CharCode.Dash||E===I.CharCode.Period||E===I.CharCode.Underline||E===I.CharCode.Tilde||a&&E===I.CharCode.Slash||f&&E===I.CharCode.OpenSquareBracket||f&&E===I.CharCode.CloseSquareBracket||f&&E===I.CharCode.Colon)C!==-1&&(v+=encodeURIComponent(r.substring(C,b)),C=-1),v!==void 0&&(v+=r.charAt(b));else{v===void 0&&(v=r.substr(0,b));const T=P[E];T!==void 0?(C!==-1&&(v+=encodeURIComponent(r.substring(C,b)),C=-1),v+=T):C===-1&&(C=b)}}return C!==-1&&(v+=encodeURIComponent(r.substring(C))),v!==void 0?v:r}function o(r){let a;for(let f=0;f<r.length;f++){const v=r.charCodeAt(f);v===I.CharCode.Hash||v===I.CharCode.QuestionMark?(a===void 0&&(a=r.substr(0,f)),a+=P[v]):a!==void 0&&(a+=r[f])}return a!==void 0?a:r}function h(r,a){let f;return r.authority&&r.path.length>1&&r.scheme==="file"?f=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===I.CharCode.Slash&&(r.path.charCodeAt(1)>=I.CharCode.A&&r.path.charCodeAt(1)<=I.CharCode.Z||r.path.charCodeAt(1)>=I.CharCode.a&&r.path.charCodeAt(1)<=I.CharCode.z)&&r.path.charCodeAt(2)===I.CharCode.Colon?a?f=r.path.substr(1):f=r.path[1].toLowerCase()+r.path.substr(2):f=r.path,L.$j&&(f=f.replace(/\//g,"\\")),f}function i(r,a){const f=a?o:m;let v="",{scheme:C,authority:b,path:E,query:T,fragment:j}=r;if(C&&(v+=C,v+=":"),(b||C==="file")&&(v+=$,v+=$),b){let U=b.indexOf("@");if(U!==-1){const F=b.substr(0,U);b=b.substr(U+1),U=F.lastIndexOf(":"),U===-1?v+=f(F,!1,!1):(v+=f(F.substr(0,U),!1,!1),v+=":",v+=f(F.substr(U+1),!1,!0)),v+="@"}b=b.toLowerCase(),U=b.lastIndexOf(":"),U===-1?v+=f(b,!1,!0):(v+=f(b.substr(0,U),!1,!0),v+=b.substr(U))}if(E){if(E.length>=3&&E.charCodeAt(0)===I.CharCode.Slash&&E.charCodeAt(2)===I.CharCode.Colon){const U=E.charCodeAt(1);U>=I.CharCode.A&&U<=I.CharCode.Z&&(E=`/${String.fromCharCode(U+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===I.CharCode.Colon){const U=E.charCodeAt(0);U>=I.CharCode.A&&U<=I.CharCode.Z&&(E=`${String.fromCharCode(U+32)}:${E.substr(2)}`)}v+=f(E,!0,!1)}return T&&(v+="?",v+=f(T,!1,!1)),j&&(v+="#",v+=a?j:m(j,!1,!1)),v}function s(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+s(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(r){return r.match(t)?r.replace(t,a=>s(a)):r}}),define(he[138],ue([0,1,9]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=c,e.$ar=A,e.$br=L,e.log=O;function c(y){const R=y;return R&&typeof R.type=="string"&&typeof R.severity=="string"}function A(y){const R=[];let d;try{const u=JSON.parse(y.arguments),$=u[u.length-1];$&&$.__$stack&&(u.pop(),d=$.__$stack),R.push(...u)}catch{R.push("Unable to log remote console arguments",y.arguments)}return{args:R,stack:d}}function L(y){if(typeof y!="string")return L(A(y).stack);const R=y;if(R){const d=N(R),u=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(d||"");if(u&&u.length===4)return{uri:I.URI.file(u[1]),line:Number(u[2]),column:Number(u[3])}}}function N(y){if(!y)return y;const R=y.indexOf(`
`);return R===-1?y:y.substring(0,R)}function O(y,R){const{args:d,stack:u}=A(y),$=typeof d[0]=="string"&&d.length===1;let l=N(u);l&&(l=`(${l.trim()})`);let p=[];if(typeof d[0]=="string"?l&&$?p=[`%c[${R}] %c${d[0]} %c${l}`,k("blue"),k(""),k("grey")]:p=[`%c[${R}] %c${d[0]}`,k("blue"),k(""),...d.slice(1)]:p=[`%c[${R}]%`,k("blue"),...d],l&&!$&&p.push(l),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,p)}function k(y){return`color: ${y}`}}),define(he[66],ue([0,1,14,9,65]),function(oe,e,I,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=L,e.$$h=N,e.$_h=k;function L(y){return JSON.stringify(y,O)}function N(y){let R=JSON.parse(y);return R=k(R),R}function O(y,R){return R instanceof RegExp?{$mid:A.MarshalledId.Regexp,source:R.source,flags:R.flags}:R}function k(y,R=0){if(!y||R>200)return y;if(typeof y=="object"){switch(y.$mid){case A.MarshalledId.Uri:return c.URI.revive(y);case A.MarshalledId.Regexp:return new RegExp(y.source,y.flags);case A.MarshalledId.Date:return new Date(y.source)}if(y instanceof I.$Le||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let d=0;d<y.length;++d)y[d]=k(y[d],R+1);else for(const d in y)Object.hasOwnProperty.call(y,d)&&(y[d]=k(y[d],R+1))}return y}}),define(he[22],ue([0,1,8,5,26,9,13]),function(oe,e,I,c,A,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Pg=e.$Og=e.$Ng=e.Schemas=void 0,e.$Lg=k,e.$Mg=y,e.$Qg=d,I=ke(I),c=ke(c),N=ke(N);var O;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",l.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm",l.commentsInput="comment",l.codeSetting="code-setting"})(O||(e.Schemas=O={}));function k(l,p){return L.URI.isUri(l)?(0,A.$Df)(l.scheme,p):(0,A.$Ef)(l,p+":")}function y(l,...p){return p.some(S=>k(l,S))}e.$Ng="vscode-tkn",e.$Og="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(p){this.d=p}setDelegate(p){this.e=p}setServerRootPath(p,S){this.f=d(p,S)}getServerRootPath(){return this.f}get g(){return N.$fc.join(this.f,O.vscodeRemoteResource)}set(p,S,g){this.a[p]=S,this.b[p]=g}setConnectionToken(p,S){this.c[p]=S}getPreferredWebSchema(){return this.d}rewrite(p){if(this.e)try{return this.e(p)}catch(o){return I.$Y(o),p}const S=p.authority;let g=this.a[S];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const w=this.b[S],P=this.c[S];let m=`path=${encodeURIComponent(p.path)}`;return typeof P=="string"&&(m+=`&${e.$Og}=${encodeURIComponent(P)}`),L.URI.from({scheme:c.$p?this.d:O.vscodeRemoteResource,authority:`${g}:${w}`,path:this.g,query:m})}}e.$Pg=new R;function d(l,p){return N.$fc.join(p??"/",`${l.quality??"oss"}-${l.commit??"dev"}`)}e.$Rg="vs/../../extensions",e.$Sg="vs/../../node_modules",e.$Tg="vs/../../node_modules.asar",e.$Ug="vs/../../node_modules.asar.unpacked",e.$Vg="vscode-app";class u{static{this.a=e.$Vg}asBrowserUri(p){const S=this.b(p,oe);return this.uriToBrowserUri(S)}uriToBrowserUri(p){return p.scheme===O.vscodeRemote?e.$Pg.rewrite(p):p.scheme===O.file&&(c.$n||c.$r===`${O.vscodeFileResource}://${u.a}`)?p.with({scheme:O.vscodeFileResource,authority:p.authority||u.a,query:null,fragment:null}):p}asFileUri(p){const S=this.b(p,oe);return this.uriToFileUri(S)}uriToFileUri(p){return p.scheme===O.vscodeFileResource?p.with({scheme:O.file,authority:p.authority!==u.a?p.authority:null,query:null,fragment:null}):p}b(p,S){return L.URI.isUri(p)?p:L.URI.parse(S.toUrl(p))}}e.$Wg=new u;var $;(function(l){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(p.get("3"));const S="vscode-coi";function g(P){let m;typeof P=="string"?m=new URL(P).searchParams:P instanceof URL?m=P.searchParams:L.URI.isUri(P)&&(m=new URL(P.toString(!0)).searchParams);const o=m?.get(S);if(o)return p.get(o)}l.getHeadersFromQuery=g;function w(P,m,o){if(!globalThis.crossOriginIsolated)return;const h=m&&o?"3":o?"2":"1";P instanceof URLSearchParams?P.set(S,h):P[S]=h}l.addSearchParam=w})($||(e.COI=$={}))}),define(he[139],ue([0,1,128,22,5,9]),function(oe,e,I,c,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qE=R,A=ke(A);class N{constructor(u,$,l){this.id=u,this.dependencies=$,this.callback=l}}class O{static{this.INSTANCE=new O}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(u,$,l)=>{typeof u!="string"&&(l=$,$=u,u=null),(typeof $!="object"||!Array.isArray($))&&(l=$,$=null),this.c.push(new N(u,$,l))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){if(u.startsWith(window.location.origin)||u.startsWith("vscode-file://vscode-app"))return u;throw new Error(`[trusted_script_src] Invalid script url: ${u}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){return u}})))}async load(u){this.g();const $=await(this.a?this.i(u):this.b?this.h(u):this.j(u));if(!$)throw new Error(`Did not receive a define call from script ${u}`);if(Array.isArray($.dependencies)&&$.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${u}. The dependencies are: ${$.dependencies.join(", ")}`);return typeof $.callback=="function"?$.callback([]):$.callback}h(u){return new Promise(($,l)=>{const p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript");const S=()=>{p.removeEventListener("load",g),p.removeEventListener("error",w)},g=P=>{S(),$(this.c.pop())},w=P=>{S(),l(P)};p.addEventListener("load",g),p.addEventListener("error",w),this.f&&(u=this.f.createScriptURL(u)),p.setAttribute("src",u),window.document.getElementsByTagName("head")[0].appendChild(p)})}i(u){return new Promise(($,l)=>{try{this.f&&(u=this.f.createScriptURL(u)),importScripts(u),$(this.c.pop())}catch(p){l(p)}})}async j(u){try{const $=globalThis._VSCODE_NODE_MODULES.fs,l=globalThis._VSCODE_NODE_MODULES.vm,p=globalThis._VSCODE_NODE_MODULES.module,S=L.URI.parse(u).fsPath,g=$.readFileSync(S).toString(),w=p.wrap(g.replace(/^#!.*/,""));return new l.Script(w).runInThisContext().apply(),this.c.pop()}catch($){throw $}}}const k=new Map;let y={};typeof globalThis.require=="object"&&(y=globalThis.require.paths??{});async function R(d,u,$){if(I.$R){$===void 0&&($=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),y[d]&&(d=y[d]);const l=`${d}/${u}`;if(k.has(l))return k.get(l);let p;if(/^\w[\w\d+.-]*:\/\//.test(l))p=l;else{const P=`${$&&!A.$p?c.$Tg:c.$Sg}/${l}`;p=c.$Wg.asBrowserUri(P).toString(!0)}const S=O.INSTANCE.load(p);return k.set(l,S),S}else return await new Promise((l,p)=>{oe([d],l,p)}).then(ke)}}),define(he[20],ue([0,1,39,41,22,13,5,26,9]),function(oe,e,I,c,A,L,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=void 0,e.$4g=y,e.$mh=d,e.$nh=$,c=ke(c),L=ke(L);function y(l){return(0,k.$vc)(l,!0)}class R{constructor(p){this.a=p}compare(p,S,g=!1){return p===S?0:(0,O.$wf)(this.getComparisonKey(p,g),this.getComparisonKey(S,g))}isEqual(p,S,g=!1){return p===S?!0:!p||!S?!1:this.getComparisonKey(p,g)===this.getComparisonKey(S,g)}getComparisonKey(p,S=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:S?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,S,g=!1){if(p.scheme===S.scheme){if(p.scheme===A.Schemas.file)return c.$Bg(y(p),y(S),this.a(p))&&p.query===S.query&&(g||p.fragment===S.fragment);if((0,e.$ih)(p.authority,S.authority))return c.$Bg(p.path,S.path,this.a(p),"/")&&p.query===S.query&&(g||p.fragment===S.fragment)}return!1}joinPath(p,...S){return k.URI.joinPath(p,...S)}basenameOrAuthority(p){return(0,e.$ah)(p)||p.authority}basename(p){return L.$fc.basename(p.path)}extname(p){return L.$fc.extname(p.path)}dirname(p){if(p.path.length===0)return p;let S;return p.scheme===A.Schemas.file?S=k.URI.file(L.$lc(y(p))).path:(S=L.$fc.dirname(p.path),p.authority&&S.length&&S.charCodeAt(0)!==I.CharCode.Slash&&(console.error(`dirname("${p.toString})) resulted in a relative path`),S="/")),p.with({path:S})}normalizePath(p){if(!p.path.length)return p;let S;return p.scheme===A.Schemas.file?S=k.URI.file(L.$gc(y(p))).path:S=L.$fc.normalize(p.path),p.with({path:S})}relativePath(p,S){if(p.scheme!==S.scheme||!(0,e.$ih)(p.authority,S.authority))return;if(p.scheme===A.Schemas.file){const P=L.$kc(y(p),y(S));return N.$j?c.$vg(P):P}let g=p.path||"/";const w=S.path||"/";if(this.a(p)){let P=0;for(const m=Math.min(g.length,w.length);P<m&&!(g.charCodeAt(P)!==w.charCodeAt(P)&&g.charAt(P).toLowerCase()!==w.charAt(P).toLowerCase());P++);g=w.substr(0,P)+g.substr(P)}return L.$fc.relative(g,w)}resolvePath(p,S){if(p.scheme===A.Schemas.file){const g=k.URI.file(L.$jc(y(p),S));return p.with({authority:g.authority,path:g.path})}return S=c.$wg(S),p.with({path:L.$fc.resolve(p.path,S)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,S){return p===S||p!==void 0&&S!==void 0&&(0,O.$Df)(p,S)}hasTrailingPathSeparator(p,S=L.sep){if(p.scheme===A.Schemas.file){const g=y(p);return g.length>c.$xg(g).length&&g[g.length-1]===S}else{const g=p.path;return g.length>1&&g.charCodeAt(g.length-1)===I.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,S=L.sep){return(0,e.$jh)(p,S)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,S=L.sep){let g=!1;if(p.scheme===A.Schemas.file){const w=y(p);g=w!==void 0&&w.length===c.$xg(w).length&&w[w.length-1]===S}else{S="/";const w=p.path;g=w.length===1&&w.charCodeAt(w.length-1)===I.CharCode.Slash}return!g&&!(0,e.$jh)(p,S)?p.with({path:p.path+"/"}):p}}e.$5g=R,e.$6g=new R(()=>!1),e.$7g=new R(l=>l.scheme===A.Schemas.file?!N.$l:!0),e.$8g=new R(l=>!0),e.$9g=e.$6g.isEqual.bind(e.$6g),e.$0g=e.$6g.isEqualOrParent.bind(e.$6g),e.$$g=e.$6g.getComparisonKey.bind(e.$6g),e.$_g=e.$6g.basenameOrAuthority.bind(e.$6g),e.$ah=e.$6g.basename.bind(e.$6g),e.$bh=e.$6g.extname.bind(e.$6g),e.$ch=e.$6g.dirname.bind(e.$6g),e.$dh=e.$6g.joinPath.bind(e.$6g),e.$eh=e.$6g.normalizePath.bind(e.$6g),e.$fh=e.$6g.relativePath.bind(e.$6g),e.$gh=e.$6g.resolvePath.bind(e.$6g),e.$hh=e.$6g.isAbsolutePath.bind(e.$6g),e.$ih=e.$6g.isEqualAuthority.bind(e.$6g),e.$jh=e.$6g.hasTrailingPathSeparator.bind(e.$6g),e.$kh=e.$6g.removeTrailingPathSeparator.bind(e.$6g),e.$lh=e.$6g.addTrailingPathSeparator.bind(e.$6g);function d(l,p){const S=[];for(let g=0;g<l.length;g++){const w=p(l[g]);l.some((P,m)=>m===g?!1:(0,e.$0g)(w,p(P)))||S.push(l[g])}return S}var u;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function p(S){const g=new Map;S.path.substring(S.path.indexOf(";")+1,S.path.lastIndexOf(";")).split(";").forEach(m=>{const[o,h]=m.split(":");o&&h&&g.set(o,h)});const P=S.path.substring(0,S.path.indexOf(";"));return P&&g.set(l.META_DATA_MIME,P),g}l.parseMetaData=p})(u||(e.DataUri=u={}));function $(l,p,S){if(p){let g=l.path;return g&&g[0]!==L.$fc.sep&&(g=L.$fc.sep+g),l.with({scheme:S,authority:p,path:g})}return l.with({scheme:S})}}),define(he[6],ue([0,1,25,8,3,2,20,5,136,53]),function(oe,e,I,c,A,L,N,O,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$4h=e.$3h=e.$2h=e.$1h=e.Promises=e.$Zh=e.$Yh=e.$Xh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=void 0,e.$oh=R,e.$ph=d,e.$qh=u,e.$rh=$,e.$sh=l,e.$th=p,e.$uh=S,e.$vh=g,e.$Dh=r,e.$Eh=a,e.$Fh=f,e.$Gh=v,e.$Hh=C,e.$Wh=z,e.$5h=M;function R(ee){return!!ee&&typeof ee.then=="function"}function d(ee){const X=new I.$ue,re=ee(X.token),le=new Promise((ge,pe)=>{const Ee=X.token.onCancellationRequested(()=>{Ee.dispose(),pe(new c.$4)});Promise.resolve(re).then(we=>{Ee.dispose(),X.dispose(),ge(we)},we=>{Ee.dispose(),X.dispose(),pe(we)})});return new class{cancel(){X.cancel(),X.dispose()}then(ge,pe){return le.then(ge,pe)}catch(ge){return this.then(void 0,ge)}finally(ge){return le.finally(ge)}}}function u(ee,X,re){return new Promise((le,ge)=>{const pe=X.onCancellationRequested(()=>{pe.dispose(),le(re)});ee.then(le,ge).finally(()=>pe.dispose())})}function $(ee,X){return new Promise((re,le)=>{const ge=X.onCancellationRequested(()=>{ge.dispose(),le(new c.$4)});ee.then(re,le).finally(()=>ge.dispose())})}async function l(ee){let X=-1;const re=ee.map((le,ge)=>le.then(pe=>(X=ge,pe)));try{return await Promise.race(re)}finally{ee.forEach((le,ge)=>{ge!==X&&le.cancel()})}}function p(ee,X,re){let le;const ge=setTimeout(()=>{le?.(void 0),re?.()},X);return Promise.race([ee.finally(()=>clearTimeout(ge)),new Promise(pe=>le=pe)])}function S(ee){return new Promise((X,re)=>{const le=ee();R(le)?le.then(X,re):X(le)})}function g(){let ee,X;return{promise:new Promise((le,ge)=>{ee=le,X=ge}),resolve:ee,reject:X}}class w{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(X){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=X,!this.b){const re=()=>{if(this.b=null,this.f)return;const le=this.queue(this.d);return this.d=null,le};this.b=new Promise(le=>{this.a.then(re,re).then(le)})}return new Promise((re,le)=>{this.b.then(re,le)})}return this.a=X(),new Promise((re,le)=>{this.a.then(ge=>{this.a=null,re(ge)},ge=>{this.a=null,le(ge)})})}dispose(){this.f=!0}}e.$wh=w;class P{constructor(){this.a=Promise.resolve(null)}queue(X){return this.a=this.a.then(()=>X(),()=>X())}}e.$xh=P;class m{constructor(){this.a=new Map}queue(X,re){const ge=(this.a.get(X)??Promise.resolve()).catch(()=>{}).then(re).finally(()=>{this.a.get(X)===ge&&this.a.delete(X)});return this.a.set(X,ge),ge}}e.$yh=m;const o=(ee,X)=>{let re=!0;const le=setTimeout(()=>{re=!1,X()},ee);return{isTriggered:()=>re,dispose:()=>{clearTimeout(le),re=!1}}},h=ee=>{let X=!0;return queueMicrotask(()=>{X&&(X=!1,ee())}),{isTriggered:()=>X,dispose:()=>{X=!1}}};class i{constructor(X){this.defaultDelay=X,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(X,re=this.defaultDelay){this.g=X,this.h(),this.b||(this.b=new Promise((ge,pe)=>{this.d=ge,this.f=pe}).then(()=>{if(this.b=null,this.d=null,this.g){const ge=this.g;return this.g=null,ge()}}));const le=()=>{this.a=null,this.d?.(null)};return this.a=re===k.$ee?h(le):o(re,le),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new c.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$zh=i;class s{constructor(X){this.a=new i(X),this.b=new w}trigger(X,re){return this.a.trigger(()=>this.b.queue(X),re)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ah=s;class t{constructor(){this.a=!1,this.b=new Promise((X,re)=>{this.d=X})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Bh=t;class n extends t{constructor(X){super(),this.f=setTimeout(()=>this.open(),X)}open(){clearTimeout(this.f),super.open()}}e.$Ch=n;function r(ee,X){return X?new Promise((re,le)=>{const ge=setTimeout(()=>{pe.dispose(),re()},ee),pe=X.onCancellationRequested(()=>{clearTimeout(ge),pe.dispose(),le(new c.$4)})}):d(re=>r(ee,re))}function a(ee,X=0,re){const le=setTimeout(()=>{ee(),re&&ge.dispose()},X),ge=(0,L.$Rc)(()=>{clearTimeout(le),re?.deleteAndLeak(ge)});return re?.add(ge),ge}function f(ee){const X=[];let re=0;const le=ee.length;function ge(){return re<le?ee[re++]():null}function pe(Ee){Ee!=null&&X.push(Ee);const we=ge();return we?we.then(pe):Promise.resolve(X)}return Promise.resolve(null).then(pe)}function v(ee,X=le=>!!le,re=null){let le=0;const ge=ee.length,pe=()=>{if(le>=ge)return Promise.resolve(re);const Ee=ee[le++];return Promise.resolve(Ee()).then(be=>X(be)?Promise.resolve(be):pe())};return pe()}function C(ee,X=le=>!!le,re=null){if(ee.length===0)return Promise.resolve(re);let le=ee.length;const ge=()=>{le=-1;for(const pe of ee)pe.cancel?.()};return new Promise((pe,Ee)=>{for(const we of ee)we.then(be=>{--le>=0&&X(be)?(ge(),pe(be)):le===0&&pe(re)}).catch(be=>{--le>=0&&(ge(),Ee(be))})})}class b{constructor(X){this.a=0,this.b=!1,this.f=X,this.g=[],this.d=0,this.h=new A.$je}whenIdle(){return this.size>0?A.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(X){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((re,le)=>{this.g.push({factory:X,c:re,e:le}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const X=this.g.shift();this.d++;const re=X.factory();re.then(X.c,X.e),re.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ih=b;class E extends b{constructor(){super(1)}}e.$Jh=E;class T{constructor(){this.a=new _,this.b=0}queue(X){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,X())):this.a.run(this.b++,X())}}e.$Kh=T;class j{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const X=new te;return this.b.add(X),X.p}g(){for(const[,X]of this.a)if(X.size>0)return!1;return!0}queueSize(X,re=N.$6g){const le=re.getComparisonKey(X);return this.a.get(le)?.size??0}queueFor(X,re,le=N.$6g){const ge=le.getComparisonKey(X);let pe=this.a.get(ge);if(!pe){pe=new E;const Ee=this.f++,we=A.Event.once(pe.onDrained)(()=>{pe?.dispose(),this.a.delete(ge),this.h(),this.d?.deleteAndDispose(Ee),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$3c),this.d.set(Ee,we),this.a.set(ge,pe)}return pe.queue(re)}h(){this.g()&&this.j()}j(){for(const X of this.b)X.complete();this.b.clear()}dispose(){for(const[,X]of this.a)X.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Lh=j;class U{constructor(X,re){this.b=!1,this.a=-1,typeof X=="function"&&typeof re=="number"&&this.setIfNotSet(X,re)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(X,re){if(this.b)throw new c.$bb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,X()},re)}setIfNotSet(X,re){if(this.b)throw new c.$bb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,X()},re))}}e.$Mh=U;class F{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(X,re,le=globalThis){if(this.f)throw new c.$bb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const ge=le.setInterval(()=>{X()},re);this.d=(0,L.$Rc)(()=>{le.clearInterval(ge),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Nh=F;class K{constructor(X,re){this.b=-1,this.a=X,this.d=re,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(X=this.d){this.cancel(),this.b=setTimeout(this.f,X)}get delay(){return this.d}set delay(X){this.d=X}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Oh=K;class W{constructor(X,re){re%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${re}ms is not a multiple of 1000ms.`),this.a=X,this.b=re,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(X=this.b){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(X/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Ph=W;class x extends K{constructor(X,re){super(X,re),this.j=[]}work(X){this.j.push(X),this.isScheduled()||this.schedule()}h(){const X=this.j;this.j=[],this.a?.(X)}dispose(){this.j=[],super.dispose()}}e.$Qh=x;class G extends L.$Tc{constructor(X,re){super(),this.g=X,this.h=re,this.a=[],this.b=this.B(new L.$Uc),this.f=!1}get pending(){return this.a.length}work(X){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+X.length>this.g.maxBufferedWork)return!1}else if(this.pending+X.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const re of X)this.a.push(re);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new K(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Rh=G,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Th=(ee,X)=>{(0,O.$C)(()=>{if(re)return;const le=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let re=!1;return{dispose(){re||(re=!0)}}}:e.$Th=(ee,X,re)=>{const le=ee.requestIdleCallback(X,typeof re=="number"?{timeout:re}:void 0);let ge=!1;return{dispose(){ge||(ge=!0,ee.cancelIdleCallback(le))}}},e.$Sh=ee=>(0,e.$Th)(globalThis,ee)}();class ie{constructor(X,re){this.g=!1,this.d=()=>{try{this.j=re()}catch(le){this.l=le}finally{this.g=!0}},this.f=(0,e.$Th)(X,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Uh=ie;class V extends ie{constructor(X){super(globalThis,X)}}e.$Vh=V;async function z(ee,X,re){let le;for(let ge=0;ge<re;ge++)try{return await ee()}catch(pe){le=pe,await r(X)}throw le}class _{isRunning(X){return typeof X=="number"?this.a?.taskId===X:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(X,re,le){return this.a={taskId:X,cancel:()=>le?.(),promise:re},re.then(()=>this.d(X),()=>this.d(X)),re}d(X){this.a&&X===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const X=this.b;this.b=void 0,X.run().then(X.promiseResolve,X.promiseReject)}}queue(X){if(this.b)this.b.run=X;else{const{promise:re,resolve:le,reject:ge}=g();this.b={run:X,promise:re,promiseResolve:le,promiseReject:ge}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Xh=_;class ne{constructor(X,re=()=>Date.now()){this.d=X,this.f=re,this.a=0,this.b=0}increment(){const X=this.f();return X-this.a>this.d&&(this.a=X,this.b=0),this.b++,this.b}}e.$Yh=ne;var ce;(function(ee){ee[ee.Resolved=0]="Resolved",ee[ee.Rejected=1]="Rejected"})(ce||(ce={}));class te{get isRejected(){return this.d?.outcome===ce.Rejected}get isResolved(){return this.d?.outcome===ce.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ce.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((X,re)=>{this.a=X,this.b=re})}complete(X){return new Promise(re=>{this.a(X),this.d={outcome:ce.Resolved,value:X},re()})}error(X){return new Promise(re=>{this.b(X),this.d={outcome:ce.Rejected,value:X},re()})}cancel(){return this.error(new c.$4)}}e.$Zh=te;var Y;(function(ee){async function X(le){let ge;const pe=await Promise.all(le.map(Ee=>Ee.then(we=>we,we=>{ge||(ge=we)})));if(typeof ge<"u")throw ge;return pe}ee.settled=X;function re(le){return new Promise(async(ge,pe)=>{try{await le(ge,pe)}catch(Ee){pe(Ee)}})}ee.withAsyncBody=re})(Y||(e.Promises=Y={}));class H{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(X){this.a=void 0,this.b=void 0,this.d=!1,this.promise=X.then(re=>(this.a=re,this.d=!0,re),re=>{throw this.b=re,this.d=!0,re})}requireValue(){if(!this.d)throw new c.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$1h=H;class B{constructor(X){this.b=X,this.a=new y.$T(()=>new H(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$2h=B;var D;(function(ee){ee[ee.Initial=0]="Initial",ee[ee.DoneOK=1]="DoneOK",ee[ee.DoneError=2]="DoneError"})(D||(D={}));class J{static fromArray(X){return new J(re=>{re.emitMany(X)})}static fromPromise(X){return new J(async re=>{re.emitMany(await X)})}static fromPromises(X){return new J(async re=>{await Promise.all(X.map(async le=>re.emitOne(await le)))})}static merge(X){return new J(async re=>{await Promise.all(X.map(async le=>{for await(const ge of le)re.emitOne(ge)}))})}static{this.EMPTY=J.fromArray([])}constructor(X,re){this.a=D.Initial,this.b=[],this.d=null,this.f=re,this.g=new A.$je,queueMicrotask(async()=>{const le={emitOne:ge=>this.h(ge),emitMany:ge=>this.j(ge),reject:ge=>this.l(ge)};try{await Promise.resolve(X(le)),this.k()}catch(ge){this.l(ge)}finally{le.emitOne=void 0,le.emitMany=void 0,le.reject=void 0}})}[Symbol.asyncIterator](){let X=0;return{next:async()=>{do{if(this.a===D.DoneError)throw this.d;if(X<this.b.length)return{done:!1,value:this.b[X++]};if(this.a===D.DoneOK)return{done:!0,value:void 0};await A.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(X,re){return new J(async le=>{for await(const ge of X)le.emitOne(re(ge))})}map(X){return J.map(this,X)}static filter(X,re){return new J(async le=>{for await(const ge of X)re(ge)&&le.emitOne(ge)})}filter(X){return J.filter(this,X)}static coalesce(X){return J.filter(X,re=>!!re)}coalesce(){return J.coalesce(this)}static async toPromise(X){const re=[];for await(const le of X)re.push(le);return re}toPromise(){return J.toPromise(this)}h(X){this.a===D.Initial&&(this.b.push(X),this.g.fire())}j(X){this.a===D.Initial&&(this.b=this.b.concat(X),this.g.fire())}k(){this.a===D.Initial&&(this.a=D.DoneOK,this.g.fire())}l(X){this.a===D.Initial&&(this.a=D.DoneError,this.d=X,this.g.fire())}}e.$3h=J;class q extends J{constructor(X,re){super(re),this.m=X}cancel(){this.m.cancel()}}e.$4h=q;function M(ee){const X=new I.$ue,re=ee(X.token);return new q(X,async le=>{const ge=X.token.onCancellationRequested(()=>{ge.dispose(),X.dispose(),le.reject(new c.$4)});try{for await(const pe of re){if(X.token.isCancellationRequested)return;le.emitOne(pe)}ge.dispose(),X.dispose()}catch(pe){ge.dispose(),X.dispose(),le.reject(pe)}})}class Z{constructor(X){this.a=new te,this.b=new J(ge=>{if(re){ge.reject(re);return}return le&&ge.emitMany(le),this.d=pe=>ge.reject(pe),this.f=pe=>ge.emitOne(pe),this.a.p},X);let re,le;this.f=ge=>{le||(le=[]),le.push(ge)},this.d=ge=>{re||(re=ge)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(X){this.d(X),this.a.complete()}emitOne(X){this.f(X)}}e.$6h=Z}),define(he[93],ue([0,1,17,6,39,41,36,13,5,26]),function(oe,e,I,c,A,L,N,O,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$sk=void 0,e.$rk=R,e.$uk=p,e.$vk=T,e.$wk=j,e.$xk=U,e.$yk=F,e.$zk=K,e.$Ak=ie;function R(){return Object.create(null)}e.$sk="**",e.$tk="/";const d="[/\\\\]",u="[^/\\\\]",$=/\//g;function l(V,z){switch(V){case 0:return"";case 1:return`${u}*?`;default:return`(?:${d}|${u}+${d}${z?`|${d}${u}+`:""})*?`}}function p(V,z){if(!V)return[];const _=[];let ne=!1,ce=!1,te="";for(const Y of V){switch(Y){case z:if(!ne&&!ce){_.push(te),te="";continue}break;case"{":ne=!0;break;case"}":ne=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}te+=Y}return te&&_.push(te),_}function S(V){if(!V)return"";let z="";const _=p(V,e.$tk);if(_.every(ne=>ne===e.$sk))z=".*";else{let ne=!1;_.forEach((ce,te)=>{if(ce===e.$sk){if(ne)return;z+=l(2,te===_.length-1)}else{let Y=!1,H="",B=!1,D="";for(const J of ce){if(J!=="}"&&Y){H+=J;continue}if(B&&(J!=="]"||!D)){let q;J==="-"?q=J:(J==="^"||J==="!")&&!D?q="^":J===e.$tk?q="":q=(0,y.$ff)(J),D+=q;continue}switch(J){case"{":Y=!0;continue;case"[":B=!0;continue;case"}":{const M=`(?:${p(H,",").map(Z=>S(Z)).join("|")})`;z+=M,Y=!1,H="";break}case"]":{z+="["+D+"]",B=!1,D="";break}case"?":z+=u;continue;case"*":z+=l(1);continue;default:z+=(0,y.$ff)(J)}}te<_.length-1&&(_[te+1]!==e.$sk||te+2<_.length)&&(z+=d)}ne=ce===e.$sk})}return z}const g=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,P=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new N.$Cc(1e4),s=function(){return!1},t=function(){return null};function n(V,z){if(!V)return t;let _;typeof V!="string"?_=V.pattern:_=V,_=_.trim();const ne=`${_}_${!!z.trimForExclusions}`;let ce=i.get(ne);if(ce)return r(ce,V);let te;return g.test(_)?ce=f(_.substr(4),_):(te=w.exec(a(_,z)))?ce=v(te[1],_):(z.trimForExclusions?m:P).test(_)?ce=C(_,z):(te=o.exec(a(_,z)))?ce=b(te[1].substr(1),_,!0):(te=h.exec(a(_,z)))?ce=b(te[1],_,!1):ce=E(_),i.set(ne,ce),r(ce,V)}function r(V,z){if(typeof z=="string")return V;const _=function(ne,ce){return(0,L.$Bg)(ne,z.base,!k.$l)?V((0,y.$kf)(ne.substr(z.base.length),O.sep),ce):null};return _.allBasenames=V.allBasenames,_.allPaths=V.allPaths,_.basenames=V.basenames,_.patterns=V.patterns,_}function a(V,z){return z.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function f(V,z){return function(_,ne){return typeof _=="string"&&_.endsWith(V)?z:null}}function v(V,z){const _=`/${V}`,ne=`\\${V}`,ce=function(Y,H){return typeof Y!="string"?null:H?H===V?z:null:Y===V||Y.endsWith(_)||Y.endsWith(ne)?z:null},te=[V];return ce.basenames=te,ce.patterns=[z],ce.allBasenames=te,ce}function C(V,z){const _=G(V.slice(1,-1).split(",").map(H=>n(H,z)).filter(H=>H!==t),V),ne=_.length;if(!ne)return t;if(ne===1)return _[0];const ce=function(H,B){for(let D=0,J=_.length;D<J;D++)if(_[D](H,B))return V;return null},te=_.find(H=>!!H.allBasenames);te&&(ce.allBasenames=te.allBasenames);const Y=_.reduce((H,B)=>B.allPaths?H.concat(B.allPaths):H,[]);return Y.length&&(ce.allPaths=Y),ce}function b(V,z,_){const ne=O.sep===O.$fc.sep,ce=ne?V:V.replace($,O.sep),te=O.sep+ce,Y=O.$fc.sep+V;let H;return _?H=function(B,D){return typeof B=="string"&&(B===ce||B.endsWith(te)||!ne&&(B===V||B.endsWith(Y)))?z:null}:H=function(B,D){return typeof B=="string"&&(B===ce||!ne&&B===V)?z:null},H.allPaths=[(_?"*/":"./")+V],H}function E(V){try{const z=new RegExp(`^${S(V)}$`);return function(_){return z.lastIndex=0,typeof _=="string"&&z.test(_)?V:null}}catch{return t}}function T(V,z,_){return!V||typeof z!="string"?!1:j(V)(z,void 0,_)}function j(V,z={}){if(!V)return s;if(typeof V=="string"||U(V)){const _=n(V,z);if(_===t)return s;const ne=function(ce,te){return!!_(ce,te)};return _.allBasenames&&(ne.allBasenames=_.allBasenames),_.allPaths&&(ne.allPaths=_.allPaths),ne}return W(V,z)}function U(V){const z=V;return z?typeof z.base=="string"&&typeof z.pattern=="string":!1}function F(V){return V.allBasenames||[]}function K(V){return V.allPaths||[]}function W(V,z){const _=G(Object.getOwnPropertyNames(V).map(H=>x(H,V[H],z)).filter(H=>H!==t)),ne=_.length;if(!ne)return t;if(!_.some(H=>!!H.requiresSiblings)){if(ne===1)return _[0];const H=function(J,q){let M;for(let Z=0,ee=_.length;Z<ee;Z++){const X=_[Z](J,q);if(typeof X=="string")return X;(0,c.$oh)(X)&&(M||(M=[]),M.push(X))}return M?(async()=>{for(const Z of M){const ee=await Z;if(typeof ee=="string")return ee}return null})():null},B=_.find(J=>!!J.allBasenames);B&&(H.allBasenames=B.allBasenames);const D=_.reduce((J,q)=>q.allPaths?J.concat(q.allPaths):J,[]);return D.length&&(H.allPaths=D),H}const ce=function(H,B,D){let J,q;for(let M=0,Z=_.length;M<Z;M++){const ee=_[M];ee.requiresSiblings&&D&&(B||(B=(0,O.$mc)(H)),J||(J=B.substr(0,B.length-(0,O.$nc)(H).length)));const X=ee(H,B,J,D);if(typeof X=="string")return X;(0,c.$oh)(X)&&(q||(q=[]),q.push(X))}return q?(async()=>{for(const M of q){const Z=await M;if(typeof Z=="string")return Z}return null})():null},te=_.find(H=>!!H.allBasenames);te&&(ce.allBasenames=te.allBasenames);const Y=_.reduce((H,B)=>B.allPaths?H.concat(B.allPaths):H,[]);return Y.length&&(ce.allPaths=Y),ce}function x(V,z,_){if(z===!1)return t;const ne=n(V,_);if(ne===t)return t;if(typeof z=="boolean")return ne;if(z){const ce=z.when;if(typeof ce=="string"){const te=(Y,H,B,D)=>{if(!D||!ne(Y,H))return null;const J=ce.replace("$(basename)",()=>B),q=D(J);return(0,c.$oh)(q)?q.then(M=>M?V:null):q?V:null};return te.requiresSiblings=!0,te}}return ne}function G(V,z){const _=V.filter(H=>!!H.basenames);if(_.length<2)return V;const ne=_.reduce((H,B)=>{const D=B.basenames;return D?H.concat(D):H},[]);let ce;if(z){ce=[];for(let H=0,B=ne.length;H<B;H++)ce.push(z)}else ce=_.reduce((H,B)=>{const D=B.patterns;return D?H.concat(D):H},[]);const te=function(H,B){if(typeof H!="string")return null;if(!B){let J;for(J=H.length;J>0;J--){const q=H.charCodeAt(J-1);if(q===A.CharCode.Slash||q===A.CharCode.Backslash)break}B=H.substr(J)}const D=ne.indexOf(B);return D!==-1?ce[D]:null};te.basenames=ne,te.patterns=ce,te.allBasenames=ne;const Y=V.filter(H=>!H.basenames);return Y.push(te),Y}function ie(V,z){return(0,I.$tb)(V,z,(_,ne)=>typeof _=="string"&&typeof ne=="string"?_===ne:typeof _!="string"&&typeof ne!="string"?_.base===ne.base&&_.pattern===ne.pattern:!1)}}),define(he[94],ue([0,1,14,65,9]),function(oe,e,I,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=void 0,e.$Kn=k,e.$Ln=R,e.$Mn=d;function L(u){return u.toJSON()}class N{constructor($){this.a=$}transformIncoming($){const l=this.a.transformIncoming($);return l===$?$:L(A.URI.from(l))}transformOutgoing($){const l=this.a.transformOutgoing($);return l===$?$:L(A.URI.from(l))}transformOutgoingURI($){const l=this.a.transformOutgoing($);return l===$?$:A.URI.from(l)}transformOutgoingScheme($){return this.a.transformOutgoingScheme($)}}e.$In=N,e.$Jn=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function O(u,$,l){if(!u||l>200)return null;if(typeof u=="object"){if(u instanceof A.URI)return $.transformOutgoing(u);for(const p in u)if(Object.hasOwnProperty.call(u,p)){const S=O(u[p],$,l+1);S!==null&&(u[p]=S)}}return null}function k(u,$){const l=O(u,$,0);return l===null?u:l}function y(u,$,l,p){if(!u||p>200)return null;if(typeof u=="object"){if(u.$mid===c.MarshalledId.Uri)return l?A.URI.revive($.transformIncoming(u)):$.transformIncoming(u);if(u instanceof I.$Le)return null;for(const S in u)if(Object.hasOwnProperty.call(u,S)){const g=y(u[S],$,l,p+1);g!==null&&(u[S]=g)}}return null}function R(u,$){const l=y(u,$,!1,0);return l===null?u:l}function d(u,$){const l=y(u,$,!0,0);return l===null?u:l}}),define(he[31],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yg=void 0,e.$Xg=c;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function c(A){return I.test(A)}e.$Yg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(O){for(let k=0;k<O.length;k++)O[k]=Math.floor(Math.random()*256);return O};const L=new Uint8Array(16),N=[];for(let O=0;O<256;O++)N.push(O.toString(16).padStart(2,"0"));return function(){A(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let k=0,y="";return y+=N[L[k++]],y+=N[L[k++]],y+=N[L[k++]],y+=N[L[k++]],y+="-",y+=N[L[k++]],y+=N[L[k++]],y+="-",y+=N[L[k++]],y+=N[L[k++]],y+="-",y+=N[L[k++]],y+=N[L[k++]],y+="-",y+=N[L[k++]],y+=N[L[k++]],y+=N[L[k++]],y+=N[L[k++]],y+=N[L[k++]],y+=N[L[k++]],y}}()}),define(he[140],ue([0,1,38]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=L;const c=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function A(N){const O=N.replace(/\-/g,":").toLowerCase();return!c.has(O)}function L(){const N=(0,I.networkInterfaces)();for(const O in N){const k=N[O];if(k){for(const{mac:y}of k)if(A(y))return y}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(he[141],ue([0,1,38,51,31,140,5]),function(oe,e,I,c,A,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=void 0,e.$Pn=k,e.$Qn=d,e.$Rn=u,A=ke(A),e.$On=new class{c($){return this.a||(this.a=c.$Ii.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr($)}value(){if(this.b===void 0){let $=0,l=0;const p=(0,I.networkInterfaces)();for(const S in p){const g=p[S];if(g)for(const{mac:w,internal:P}of g)P||(l+=1,this.c(w.toUpperCase())&&($+=1))}this.b=l>0?$/l:0}return this.b}};let O;async function k($){return O||(O=(async()=>await y($)||A.$Yg())()),O}async function y($){try{const l=await new Promise((S,g)=>{oe(["crypto"],S,g)}).then(ke),p=(0,L.$Nn)();return l.createHash("sha256").update(p,"utf8").digest("hex")}catch(l){$(l);return}}const R="Software\\Microsoft\\SQMClient";async function d($){if(N.$j){const l=await new Promise((p,S)=>{oe(["@vscode/windows-registry"],p,S)}).then(ke);try{return l.GetStringRegKey("HKEY_LOCAL_MACHINE",R,"MachineId")||""}catch(p){return $(p),""}}return""}async function u($){try{return await(await new Promise((S,g)=>{oe(["@vscode/deviceid"],S,g)}).then(ke)).getDeviceId()}catch(l){return $(l),""}}}),define(he[142],ue([0,1,239,14]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rX=void 0;class A extends I.Transform{constructor(N){if(super(),typeof N=="number")this.b=N,this.c=1;else{const O=Buffer.isBuffer(N)?N:Buffer.from(N);this.b=O.length===1?O[0]:O,this.c=O.length}}_transform(N,O,k){this.a?this.a=Buffer.concat([this.a,N]):this.a=N;let y=0;for(;y<this.a.length;){const R=typeof this.b=="number"?this.a.indexOf(this.b,y):(0,c.$Me)(this.a,this.b,y);if(R===-1)break;this.push(this.a.slice(y,R+this.c)),y=R+this.c}this.a=y===this.a.length?void 0:this.a.slice(y),k()}_flush(N){this.a&&this.push(this.a),N()}}e.$rX=A}),define(he[143],ue([0,1,32,13,37]),function(oe,e,I,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sX=y,e.$tX=R;const L="XDG_SESSION_TYPE",N="WAYLAND_DISPLAY",O="XDG_RUNTIME_DIR";var k;(function(d){d.Wayland="wayland",d.XWayland="xwayland",d.X11="x11",d.Unknown="unknown"})(k||(k={}));async function y(d){const u=A.env[L];if(u)return u===k.Wayland||u===k.X11?u:k.Unknown;if(A.env[N]){const l=A.env[O];if(l){const p=(0,c.$ic)(l,"wayland-0");try{return await I.promises.access(p,I.constants.R_OK),k.Wayland}catch(S){return d(S),k.Unknown}}else return k.Unknown}else return k.X11}function R(d,u){if(u)switch(u){case"auto":return d;case"x11":return d===k.Wayland?k.XWayland:k.X11;case"wayland":return k.Wayland;default:return k.Unknown}else return d===k.Wayland?k.XWayland:k.X11}}),define(he[144],ue([0,1,32,240,5]),function(oe,e,I,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zg=L,A=ke(A);async function L(N){if(A.$k||A.$j)return;let O;for(const k of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{O=await I.promises.open(k,I.constants.R_OK);break}catch{}if(!O){N("Unable to retrieve release information from known identifier paths.");return}try{const k=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),y={id:"unknown"};for await(const R of(0,c.createInterface)({input:O.createReadStream(),crlfDelay:1/0})){if(!R.includes("="))continue;const d=R.split("=")[0].toUpperCase().trim();if(k.has(d)){const u=R.split("=")[1].replace(/"/g,"").toLowerCase().trim();d==="ID"||d==="DISTRIB_ID"?y.id=u:d==="ID_LIKE"?y.id_like=u:(d==="VERSION_ID"||d==="DISTRIB_RELEASE")&&(y.version_id=u)}}return y}catch(k){N(k)}}}),define(he[30],ue([0,1,32,38,241,6,41,90,13,5,20,9]),function(oe,e,I,c,A,L,N,O,k,y,R,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=S,e.readdirSync=P,e.whenDeleted=h,e.configureFlushOnWrite=r,e.writeFileSync=f,I=ke(I);var u;(function(W){W[W.UNLINK=0]="UNLINK",W[W.MOVE=1]="MOVE"})(u||(e.RimRafMode=u={}));async function $(W,x=u.UNLINK,G){if((0,N.$Fg)(W))throw new Error("rimraf - will refuse to recursively delete root");return x===u.UNLINK?p(W):l(W,G)}async function l(W,x=(0,N.$Kg)((0,c.tmpdir)())){try{try{await I.promises.rename(W,x)}catch(G){return G.code==="ENOENT"?void 0:p(W)}p(x).catch(G=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function p(W){return I.promises.rm(W,{recursive:!0,force:!0,maxRetries:3})}function S(W){if((0,N.$Fg)(W))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(W,{recursive:!0,force:!0,maxRetries:3})}async function g(W,x){return m(await(x?w(W):I.promises.readdir(W)))}async function w(W){try{return await I.promises.readdir(W,{withFileTypes:!0})}catch(ie){console.warn("[node.js fs] readdir with filetypes failed with error: ",ie)}const x=[],G=await g(W);for(const ie of G){let V=!1,z=!1,_=!1;try{const ne=await I.promises.lstat((0,k.$ic)(W,ie));V=ne.isFile(),z=ne.isDirectory(),_=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}x.push({name:ie,isFile:()=>V,isDirectory:()=>z,isSymbolicLink:()=>_})}return x}function P(W){return m(I.readdirSync(W))}function m(W){return W.map(x=>typeof x=="string"?y.$k?(0,O.$jm)(x):x:(x.name=y.$k?(0,O.$jm)(x.name):x.name,x))}async function o(W){const x=await g(W),G=[];for(const ie of x)await i.existsDirectory((0,k.$ic)(W,ie))&&G.push(ie);return G}function h(W,x=1e3){return new Promise(G=>{let ie=!1;const V=setInterval(()=>{ie||(ie=!0,I.access(W,z=>{ie=!1,z&&(clearInterval(V),G(void 0))}))},x)})}var i;(function(W){async function x(V){let z;try{if(z=await I.promises.lstat(V),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await I.promises.stat(V),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(_){if(_.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(y.$j&&_.code==="EACCES")try{return{stat:await I.promises.stat(await I.promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw ne}throw _}}W.stat=x;async function G(V){try{const{stat:z,symbolicLink:_}=await W.stat(V);return z.isFile()&&_?.dangling!==!0}catch{}return!1}W.existsFile=G;async function ie(V){try{const{stat:z,symbolicLink:_}=await W.stat(V);return z.isDirectory()&&_?.dangling!==!0}catch{}return!1}W.existsDirectory=ie})(i||(e.SymlinkSupport=i={}));const s=new L.$Lh;function t(W,x,G){return s.queueFor(d.URI.file(W),()=>{const ie=v(G);return new Promise((V,z)=>a(W,x,ie,_=>_?z(_):V()))},R.$7g)}let n=!0;function r(W){n=W}function a(W,x,G,ie){if(!n)return I.writeFile(W,x,{mode:G.mode,flag:G.flag},ie);I.open(W,G.flag,G.mode,(V,z)=>{if(V)return ie(V);I.writeFile(z,x,_=>{if(_)return I.close(z,()=>ie(_));I.fdatasync(z,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),r(!1)),I.close(z,ce=>ie(ce))))})})}function f(W,x,G){const ie=v(G);if(!n)return I.writeFileSync(W,x,{mode:ie.mode,flag:ie.flag});const V=I.openSync(W,ie.flag,ie.mode);try{I.writeFileSync(V,x);try{I.fdatasyncSync(V)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),r(!1)}}finally{I.closeSync(V)}}function v(W){return W?{mode:typeof W.mode=="number"?W.mode:438,flag:typeof W.flag=="string"?W.flag:"w"}:{mode:438,flag:"w"}}async function C(W,x,G=6e4){if(W!==x)try{y.$j&&typeof G=="number"?await b(W,x,Date.now(),G):await I.promises.rename(W,x)}catch(ie){if(W.toLowerCase()!==x.toLowerCase()&&ie.code==="EXDEV"||W.endsWith("."))await E(W,x,{preserveSymlinks:!1}),await $(W,u.MOVE);else throw ie}}async function b(W,x,G,ie,V=0){try{return await I.promises.rename(W,x)}catch(z){if(z.code!=="EACCES"&&z.code!=="EPERM"&&z.code!=="EBUSY")throw z;if(Date.now()-G>=ie)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${z}`),z;if(V===0){let _=!1;try{const{stat:ne}=await i.stat(x);ne.isFile()||(_=!0)}catch{}if(_)throw z}return await(0,L.$Dh)(Math.min(100,V*10)),b(W,x,G,ie,V+1)}}async function E(W,x,G){return j(W,x,{root:{source:W,target:x},options:G,handledSourcePaths:new Set})}const T=511;async function j(W,x,G){if(G.handledSourcePaths.has(W))return;G.handledSourcePaths.add(W);const{stat:ie,symbolicLink:V}=await i.stat(W);if(V){if(G.options.preserveSymlinks)try{return await K(W,x,G)}catch{}if(V.dangling)return}return ie.isDirectory()?U(W,x,ie.mode&T,G):F(W,x,ie.mode&T)}async function U(W,x,G,ie){await I.promises.mkdir(x,{recursive:!0,mode:G});const V=await g(W);for(const z of V)await j((0,k.$ic)(W,z),(0,k.$ic)(x,z),ie)}async function F(W,x,G){await I.promises.copyFile(W,x),await I.promises.chmod(x,G)}async function K(W,x,G){let ie=await I.promises.readlink(W);(0,N.$Bg)(ie,G.root.source,!y.$l)&&(ie=(0,k.$ic)(G.root.target,ie.substr(G.root.source.length+1))),await I.promises.symlink(ie,x)}e.Promises=new class{get read(){return(W,x,G,ie,V)=>new Promise((z,_)=>{I.read(W,x,G,ie,V,(ne,ce,te)=>ne?_(ne):z({bytesRead:ce,buffer:te}))})}get write(){return(W,x,G,ie,V)=>new Promise((z,_)=>{I.write(W,x,G,ie,V,(ne,ce,te)=>ne?_(ne):z({bytesWritten:ce,buffer:te}))})}get fdatasync(){return(0,A.promisify)(I.fdatasync)}get open(){return(0,A.promisify)(I.open)}get close(){return(0,A.promisify)(I.close)}get realpath(){return(0,A.promisify)(I.realpath)}async exists(W){try{return await I.promises.access(W),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return o}get writeFile(){return t}get rm(){return $}get rename(){return C}get copy(){return E}}}),define(he[145],ue([0,1,32,13,5,26,30]),function(oe,e,I,c,A,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=O,e.$ir=k,e.$jr=y,e.$kr=R,I=ke(I);function O(u){if(A.$l)return u;const $=(0,c.$lc)(u);if(u===$)return u;const l=((0,c.$mc)(u)||u).toLowerCase();try{const S=(0,N.readdirSync)($).filter(g=>g.toLowerCase()===l);if(S.length===1){const g=O($);if(g)return(0,c.$ic)(g,S[0])}else if(S.length>1){const g=S.indexOf(l);if(g>=0){const w=O($);if(w)return(0,c.$ic)(w,S[g])}}}catch{}return null}async function k(u,$){if(A.$l)return u;const l=(0,c.$lc)(u);if(u===l)return u;const p=((0,c.$mc)(u)||u).toLowerCase();try{if($?.isCancellationRequested)return null;const g=(await N.Promises.readdir(l)).filter(w=>w.toLowerCase()===p);if(g.length===1){const w=await k(l,$);if(w)return(0,c.$ic)(w,g[0])}else if(g.length>1){const w=g.indexOf(p);if(w>=0){const P=await k(l,$);if(P)return(0,c.$ic)(P,g[w])}}}catch{}return null}async function y(u){try{return await N.Promises.realpath(u)}catch{const l=d(u);return await I.promises.access(l,I.constants.R_OK),l}}function R(u){try{return I.realpathSync(u)}catch{const l=d(u);return I.accessSync(l,I.constants.R_OK),l}}function d(u){return(0,L.$lf)((0,c.$gc)(u),c.sep)}}),define(he[146],ue([0,1,67]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=void 0,e.$1g=c,e.$3g=L,I=ke(I);function c(O,k,y,R=1){let d=!1;return new Promise(u=>{const $=setTimeout(()=>{if(!d)return d=!0,u(0)},y);A(O,k,R,l=>{if(!d)return d=!0,clearTimeout($),u(l)})})}function A(O,k,y,R){if(k===0)return R(0);const d=new I.Socket;d.once("connect",()=>(N(d),A(O+y,k-1,y,R))),d.once("data",()=>{}),d.once("error",u=>(N(d),u.code!=="ECONNREFUSED"?A(O+y,k-1,y,R):R(O))),d.connect(O,"127.0.0.1")}e.$2g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(O,k,y,R="127.0.0.1"){let d=!1,u,$=1;const l=I.createServer({pauseOnConnect:!0});function p(S,g){d||(d=!0,l.removeAllListeners(),l.close(),u&&clearTimeout(u),g(S))}return new Promise(S=>{u=setTimeout(()=>{p(0,S)},y),l.on("listening",()=>{p(O,S)}),l.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&$<k?(O++,$++,l.listen(O,R)):p(0,S)}),l.on("close",()=>{p(0,S)}),l.listen(O,R)})}function N(O){try{O.removeAllListeners("connect"),O.removeAllListeners("error"),O.end(),O.destroy(),O.unref()}catch(k){console.error(k)}}}),define(he[147],ue([0,1,32,13,5,37,91,12,30]),function(oe,e,I,c,A,L,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$um=y,e.$vm=R,c=ke(c),A=ke(A),L=ke(L),O=ke(O),k=ke(k),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return N.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return N.TerminateResponseCode}});function y(u=L.env){return u.comspec||"cmd.exe"}function R(u){let $=[],l=!1;const p=function(S){if(l){$.push(S);return}(!u.send(S,w=>{if(w&&console.error(w),l=!1,$.length>0){const P=$.slice(0);$=[],P.forEach(m=>p(m))}})||A.$j)&&(l=!0)};return{send:p}}var d;(function(u){async function $(l,p,S){if(c.$hc(l))return l;if(p===void 0&&(p=L.cwd()),c.$lc(l)!=="."||(S===void 0&&O.$cg(L.env.PATH)&&(S=L.env.PATH.split(c.$sc)),S===void 0||S.length===0))return c.$ic(p,l);async function w(P){if(await k.Promises.exists(P)){let m;try{m=await I.promises.stat(P)}catch(o){o.message.startsWith("EACCES")&&(m=await I.promises.lstat(P))}return m?!m.isDirectory():!1}return!1}for(const P of S){let m;if(c.$hc(P)?m=c.$ic(P,l):m=c.$ic(p,P,l),await w(m))return m;let o=m+".com";if(await w(o)||(o=m+".exe",await w(o)))return o}return c.$ic(p,l)}u.findExecutable=$})(d||(e.win32=d={}))}),define(he[148],ue([0,1,68,22]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=A;function A(N){return new Promise((O,k)=>{let y;const R=new Map;function d($,l,p,S,g){const w=R.get(l);if($===N||w){const P={name:u(p),cmd:p,pid:$,ppid:l,load:S,mem:g};R.set($,P),$===N&&(y=P),w&&(w.children||(w.children=[]),w.children.push(P),w.children.length>1&&(w.children=w.children.sort((m,o)=>m.pid-o.pid)))}}function u($){const l=/--utility-sub-type=network/i,p=/--crashes-directory/i,S=/\\pipe\\winpty-control/i,g=/conhost\.exe.+--headless/i,w=/--type=([a-zA-Z-]+)/;if(p.exec($))return"electron-crash-reporter";if(S.exec($))return"winpty-agent";if(g.exec($))return"conpty-agent";let P=w.exec($);if(P&&P.length===2)return P[1]==="renderer"?"window":P[1]==="utility"?l.exec($)?"utility-network-service":"utility-process":P[1]==="extensionHost"?"extension-host":P[1];const m=/[a-zA-Z-]+\.js/g;let o="";do P=m.exec($),P&&(o+=P+" ");while(P);return o&&$.indexOf("node ")<0&&$.indexOf("node.exe")<0?`electron-nodejs (${o})`:$}if(process.platform==="win32"){const $=l=>l.indexOf("\\\\?\\")===0||l.indexOf("\\??\\")===0?l.substring(4):l.indexOf('"\\\\?\\')===0||l.indexOf('"\\??\\')===0?'"'+l.substring(5):l;new Promise((l,p)=>{oe(["@vscode/windows-process-tree"],l,p)}).then(ke).then(l=>{l.getProcessList(N,p=>{if(!p){k(new Error(`Root process ${N} not found`));return}l.getProcessCpuUsage(p,S=>{const g=new Map;S.forEach(w=>{const P=$(w.commandLine||"");g.set(w.pid,{name:u(P),cmd:P,pid:w.pid,ppid:w.ppid,load:w.cpu||0,mem:w.memory||0})}),y=g.get(N),y?(g.forEach(w=>{const P=g.get(w.ppid);P&&(P.children||(P.children=[]),P.children.push(w))}),g.forEach(w=>{w.children&&(w.children=w.children.sort((P,m)=>P.pid-m.pid))}),O(y)):k(new Error(`Root process ${N} not found`))})},l.ProcessDataFlag.CommandLine|l.ProcessDataFlag.Memory)})}else{let $=function(){let l=[y];const p=[];for(;l.length;){const g=l.shift();g&&(p.push(g.pid),g.children&&(l=l.concat(g.children)))}let S=JSON.stringify(c.$Wg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);S+=" "+p.join(" "),(0,I.exec)(S,{},(g,w,P)=>{if(g||P)k(g||new Error(P.toString()));else{const m=w.toString().split(`
`);for(let o=0;o<p.length;o++){const h=R.get(p[o]);h.load=parseFloat(m[o])}if(!y){k(new Error(`Root process ${N} not found`));return}O(y)}})};(0,I.exec)("which ps",{},(l,p,S)=>{if(l||S)if(process.platform!=="linux")k(l||new Error(S.toString()));else{const g=JSON.stringify(c.$Wg.asFileUri("vs/base/node/ps.sh").fsPath);(0,I.exec)(g,{},(w,P,m)=>{w||m?k(w||new Error(m.toString())):(L(P,d),$())})}else{const g=p.toString().trim();(0,I.exec)(`${g} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(P,m,o)=>{P||o&&!o.includes("screen size is bogus")?k(P||new Error(o.toString())):(L(m,d),process.platform==="linux"?$():y?O(y):k(new Error(`Root process ${N} not found`)))})}})}})}function L(N,O){const k=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,y=N.toString().split(`
`);for(const R of y){const d=k.exec(R.trim());d&&d.length===6&&O(parseInt(d[1]),parseInt(d[2]),d[5],parseFloat(d[3]),parseFloat(d[4]))}}});var ve=this&&this.__decorate||function(oe,e,I,c){var A=arguments.length,L=A<3?e:c===null?c=Object.getOwnPropertyDescriptor(e,I):c,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(oe,e,I,c);else for(var O=oe.length-1;O>=0;O--)(N=oe[O])&&(L=(A<3?N(L):A>3?N(e,I,L):N(e,I))||L);return A>3&&L&&Object.defineProperty(e,I,L),L};define(he[42],ue([0,1,17,6,14,25,87,8,3,2,66,26,12]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=e.ProxyChannel=e.$ki=e.$hi=e.$gi=e.$fi=e.RequestInitiator=e.$ei=e.$bi=e.$ai=void 0,e.$ci=r,e.$di=a,e.$ii=T,e.$ji=j,d=ke(d);var $;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})($||($={}));function l(V){switch(V){case $.Promise:return"req";case $.PromiseCancel:return"cancel";case $.EventListen:return"subscribe";case $.EventDispose:return"unsubscribe"}}var p;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(p||(p={}));function S(V){switch(V){case p.Initialize:return"init";case p.PromiseSuccess:return"reply:";case p.PromiseError:case p.PromiseErrorObj:return"replyErr:";case p.EventFire:return"event:"}}var g;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(g||(g={}));function w(V){let z=0;for(let _=0;;_+=7){const ne=V.read(1);if(z|=(ne.buffer[0]&127)<<_,!(ne.buffer[0]&128))return z}}const P=s(0);function m(V,z){if(z===0){V.write(P);return}let _=0;for(let ce=z;ce!==0;ce=ce>>>7)_++;const ne=A.$Le.alloc(_);for(let ce=0;z!==0;ce++)ne.buffer[ce]=z&127,z=z>>>7,z>0&&(ne.buffer[ce]|=128);V.write(ne)}class o{constructor(z){this.b=z,this.a=0}read(z){const _=this.b.slice(this.a,this.a+z);return this.a+=_.byteLength,_}}e.$ai=o;class h{constructor(){this.a=[]}get buffer(){return A.$Le.concat(this.a)}write(z){this.a.push(z)}}e.$bi=h;var i;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(i||(i={}));function s(V){const z=A.$Le.alloc(1);return z.writeUInt8(V,0),z}const t={Undefined:s(i.Undefined),String:s(i.String),Buffer:s(i.Buffer),VSBuffer:s(i.VSBuffer),Array:s(i.Array),Object:s(i.Object),Uint:s(i.Int)},n=typeof Buffer<"u";function r(V,z){if(typeof z>"u")V.write(t.Undefined);else if(typeof z=="string"){const _=A.$Le.fromString(z);V.write(t.String),m(V,_.byteLength),V.write(_)}else if(n&&Buffer.isBuffer(z)){const _=A.$Le.wrap(z);V.write(t.Buffer),m(V,_.byteLength),V.write(_)}else if(z instanceof A.$Le)V.write(t.VSBuffer),m(V,z.byteLength),V.write(z);else if(Array.isArray(z)){V.write(t.Array),m(V,z.length);for(const _ of z)r(V,_)}else if(typeof z=="number"&&(z|0)===z)V.write(t.Uint),m(V,z);else{const _=A.$Le.fromString(JSON.stringify(z));V.write(t.Object),m(V,_.byteLength),V.write(_)}}function a(V){switch(V.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return V.read(w(V)).toString();case i.Buffer:return V.read(w(V)).buffer;case i.VSBuffer:return V.read(w(V));case i.Array:{const _=w(V),ne=[];for(let ce=0;ce<_;ce++)ne.push(a(V));return ne}case i.Object:return JSON.parse(V.read(w(V)).toString());case i.Int:return w(V)}}class f{constructor(z,_,ne=null,ce=1e3){this.h=z,this.j=_,this.k=ne,this.l=ce,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(te=>this.q(te)),this.m({type:p.Initialize})}registerChannel(z,_){this.b.set(z,_),setTimeout(()=>this.w(z),0)}m(z){switch(z.type){case p.Initialize:{const _=this.o([z.type]);this.k?.logOutgoing(_,0,v.OtherSide,S(z.type));return}case p.PromiseSuccess:case p.PromiseError:case p.EventFire:case p.PromiseErrorObj:{const _=this.o([z.type,z.id],z.data);this.k?.logOutgoing(_,z.id,v.OtherSide,S(z.type),z.data);return}}}o(z,_=void 0){const ne=new h;return r(ne,z),r(ne,_),this.p(ne.buffer)}p(z){try{return this.h.send(z),z.byteLength}catch{return 0}}q(z){const _=new o(z),ne=a(_),ce=a(_),te=ne[0];switch(te){case $.Promise:return this.k?.logIncoming(z.byteLength,ne[1],v.OtherSide,`${l(te)}: ${ne[2]}.${ne[3]}`,ce),this.s({type:te,id:ne[1],channelName:ne[2],name:ne[3],arg:ce});case $.EventListen:return this.k?.logIncoming(z.byteLength,ne[1],v.OtherSide,`${l(te)}: ${ne[2]}.${ne[3]}`,ce),this.t({type:te,id:ne[1],channelName:ne[2],name:ne[3],arg:ce});case $.PromiseCancel:return this.k?.logIncoming(z.byteLength,ne[1],v.OtherSide,`${l(te)}`),this.u({type:te,id:ne[1]});case $.EventDispose:return this.k?.logIncoming(z.byteLength,ne[1],v.OtherSide,`${l(te)}`),this.u({type:te,id:ne[1]})}}s(z){const _=this.b.get(z.channelName);if(!_){this.v(z);return}const ne=new L.$ue;let ce;try{ce=_.call(this.j,z.name,z.arg,ne.token)}catch(H){ce=Promise.reject(H)}const te=z.id;ce.then(H=>{this.m({id:te,data:H,type:p.PromiseSuccess})},H=>{H instanceof Error?this.m({id:te,data:{message:H.message,name:H.name,stack:H.stack?H.stack.split(`
`):void 0},type:p.PromiseError}):this.m({id:te,data:H,type:p.PromiseErrorObj})}).finally(()=>{Y.dispose(),this.d.delete(z.id)});const Y=(0,y.$Rc)(()=>ne.cancel());this.d.set(z.id,Y)}t(z){const _=this.b.get(z.channelName);if(!_){this.v(z);return}const ne=z.id,te=_.listen(this.j,z.name,z.arg)(Y=>this.m({id:ne,data:Y,type:p.EventFire}));this.d.set(z.id,te)}u(z){const _=this.d.get(z.id);_&&(_.dispose(),this.d.delete(z.id))}v(z){let _=this.g.get(z.channelName);_||(_=[],this.g.set(z.channelName,_));const ne=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===$.Promise&&this.m({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:p.PromiseError})},this.l);_.push({request:z,timeoutTimer:ne})}w(z){const _=this.g.get(z);if(_){for(const ne of _)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case $.Promise:this.s(ne.request);break;case $.EventListen:this.t(ne.request);break}this.g.delete(z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,y.$Oc)(this.d.values()),this.d.clear()}}e.$ei=f;var v;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(v||(e.RequestInitiator=v={}));class C{constructor(z,_=null){this.l=z,this.a=!1,this.b=g.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new k.$je,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=_}getChannel(z){const _=this;return{call(ne,ce,te){return _.a?Promise.reject(new O.$4):_.m(z,ne,ce,te)},listen(ne,ce){return _.a?k.Event.None:_.o(z,ne,ce)}}}m(z,_,ne,ce=L.CancellationToken.None){const te=this.g++,Y=$.Promise,H={id:te,type:Y,channelName:z,name:_,arg:ne};if(ce.isCancellationRequested)return Promise.reject(new O.$4);let B;return new Promise((J,q)=>{if(ce.isCancellationRequested)return q(new O.$4);const M=()=>{const re=le=>{switch(le.type){case p.PromiseSuccess:this.f.delete(te),J(le.data);break;case p.PromiseError:{this.f.delete(te);const ge=new Error(le.data.message);ge.stack=Array.isArray(le.data.stack)?le.data.stack.join(`
`):le.data.stack,ge.name=le.data.name,q(ge);break}case p.PromiseErrorObj:this.f.delete(te),q(le.data);break}};this.f.set(te,re),this.p(H)};let Z=null;this.b===g.Idle?M():(Z=(0,c.$ph)(re=>this.u()),Z.then(()=>{Z=null,M()}));const ee=()=>{Z?(Z.cancel(),Z=null):this.p({id:te,type:$.PromiseCancel}),q(new O.$4)},X=ce.onCancellationRequested(ee);B=(0,y.$Qc)((0,y.$Rc)(ee),X),this.d.add(B)}).finally(()=>{B.dispose(),this.d.delete(B)})}o(z,_,ne){const ce=this.g++,te=$.EventListen,Y={id:ce,type:te,channelName:z,name:_,arg:ne};let H=null;const B=new k.$je({onWillAddFirstListener:()=>{H=(0,c.$ph)(J=>this.u()),H.then(()=>{H=null,this.d.add(B),this.p(Y)})},onDidRemoveLastListener:()=>{H?(H.cancel(),H=null):(this.d.delete(B),this.p({id:ce,type:$.EventDispose}))}}),D=J=>B.fire(J.data);return this.f.set(ce,D),B.event}p(z){switch(z.type){case $.Promise:case $.EventListen:{const _=this.q([z.type,z.id,z.channelName,z.name],z.arg);this.j?.logOutgoing(_,z.id,v.LocalSide,`${l(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case $.PromiseCancel:case $.EventDispose:{const _=this.q([z.type,z.id]);this.j?.logOutgoing(_,z.id,v.LocalSide,l(z.type));return}}}q(z,_=void 0){const ne=new h;return r(ne,z),r(ne,_),this.r(ne.buffer)}r(z){try{return this.l.send(z),z.byteLength}catch{return 0}}s(z){const _=new o(z),ne=a(_),ce=a(_),te=ne[0];switch(te){case p.Initialize:return this.j?.logIncoming(z.byteLength,0,v.LocalSide,S(te)),this.t({type:ne[0]});case p.PromiseSuccess:case p.PromiseError:case p.EventFire:case p.PromiseErrorObj:return this.j?.logIncoming(z.byteLength,ne[1],v.LocalSide,S(te),ce),this.t({type:ne[0],id:ne[1],data:ce})}}t(z){if(z.type===p.Initialize){this.b=g.Idle,this.k.fire();return}this.f.get(z.id)?.(z)}get onDidInitializePromise(){return k.Event.toPromise(this.onDidInitialize)}u(){return this.b===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,y.$Oc)(this.d.values()),this.d.clear()}}e.$fi=C,ve([N.$7h],C.prototype,"onDidInitializePromise",null);class b{get connections(){const z=[];return this.f.forEach(_=>z.push(_)),z}constructor(z,_,ne){this.a=new Map,this.f=new Set,this.g=new k.$je,this.onDidAddConnection=this.g.event,this.h=new k.$je,this.onDidRemoveConnection=this.h.event,this.j=new y.$Sc,this.j.add(z(({protocol:ce,onDidClientDisconnect:te})=>{const Y=k.Event.once(ce.onMessage);this.j.add(Y(H=>{const B=new o(H),D=a(B),J=new f(ce,D,_,ne),q=new C(ce,_);this.a.forEach((Z,ee)=>J.registerChannel(ee,Z));const M={channelServer:J,channelClient:q,ctx:D};this.f.add(M),this.g.fire(M),this.j.add(te(()=>{J.dispose(),q.dispose(),this.f.delete(M),this.h.fire(M)}))}))}))}getChannel(z,_){const ne=this;return{call(ce,te,Y){let H;if((0,u.$qg)(_)){const D=(0,I.$2b)(ne.connections.filter(_));H=D?Promise.resolve(D):k.Event.toPromise(k.Event.filter(ne.onDidAddConnection,_))}else H=_.routeCall(ne,ce,te);const B=H.then(D=>D.channelClient.getChannel(z));return T(B).call(ce,te,Y)},listen(ce,te){if((0,u.$qg)(_))return ne.k(z,_,ce,te);const Y=_.routeEvent(ne,ce,te).then(H=>H.channelClient.getChannel(z));return T(Y).listen(ce,te)}}}k(z,_,ne,ce){const te=this;let Y;const H=new k.$je({onWillAddFirstListener:()=>{Y=new y.$Sc;const B=new k.$pe,D=new Map,J=M=>{const ee=M.channelClient.getChannel(z).listen(ne,ce),X=B.add(ee);D.set(M,X)},q=M=>{const Z=D.get(M);Z&&(Z.dispose(),D.delete(M))};te.connections.filter(_).forEach(J),k.Event.filter(te.onDidAddConnection,_)(J,void 0,Y),te.onDidRemoveConnection(q,void 0,Y),B.event(H.fire,H,Y),Y.add(B)},onDidRemoveLastListener:()=>{Y?.dispose(),Y=void 0}});return H.event}registerChannel(z,_){this.a.set(z,_);for(const ne of this.f)ne.channelServer.registerChannel(z,_)}dispose(){this.j.dispose();for(const z of this.f)z.channelClient.dispose(),z.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$gi=b;class E{constructor(z,_,ne=null){const ce=new h;r(ce,_),z.send(ce.buffer),this.a=new C(z,ne),this.d=new f(z,_,ne)}getChannel(z){return this.a.getChannel(z)}registerChannel(z,_){this.d.registerChannel(z,_)}dispose(){this.a.dispose(),this.d.dispose()}}e.$hi=E;function T(V){return{call(z,_,ne){return V.then(ce=>ce.call(z,_,ne))},listen(z,_){const ne=new k.$se;return V.then(ce=>ne.input=ce.listen(z,_)),ne.event}}}function j(V){let z=!1;return{call(_,ne,ce){return z?V.call(_,ne,ce):(0,c.$Dh)(0).then(()=>z=!0).then(()=>V.call(_,ne,ce))},listen(_,ne){if(z)return V.listen(_,ne);const ce=new k.$se;return(0,c.$Dh)(0).then(()=>z=!0).then(()=>ce.input=V.listen(_,ne)),ce.event}}}class U{constructor(z){this.a=z}routeCall(z){return this.b(z)}routeEvent(z){return this.b(z)}async b(z){for(const _ of z.connections)if(await Promise.resolve(this.a(_.ctx)))return Promise.resolve(_);return await k.Event.toPromise(z.onDidAddConnection),await this.b(z)}}e.$ki=U;var F;(function(V){function z(te,Y,H){const B=te,D=H&&H.disableMarshalling,J=new Map;for(const q in B)ne(q)&&J.set(q,k.Event.buffer(B[q],!0,void 0,Y));return new class{listen(q,M,Z){const ee=J.get(M);if(ee)return ee;const X=B[M];if(typeof X=="function"){if(ce(M))return X.call(B,Z);if(ne(M))return J.set(M,k.Event.buffer(B[M],!0,void 0,Y)),J.get(M)}throw new O.$ab(`Event not found: ${M}`)}call(q,M,Z){const ee=B[M];if(typeof ee=="function"){if(!D&&Array.isArray(Z))for(let re=0;re<Z.length;re++)Z[re]=(0,R.$_h)(Z[re]);let X=ee.apply(B,Z);return X instanceof Promise||(X=Promise.resolve(X)),X}throw new O.$ab(`Method not found: ${M}`)}}}V.fromService=z;function _(te,Y){const H=Y&&Y.disableMarshalling;return new Proxy({},{get(B,D){if(typeof D=="string")return Y?.properties?.has(D)?Y.properties.get(D):ce(D)?function(J){return te.listen(D,J)}:ne(D)?te.listen(D):async function(...J){let q;Y&&!(0,u.$lg)(Y.context)?q=[Y.context,...J]:q=J;const M=await te.call(D,q);return H?M:(0,R.$_h)(M)};throw new O.$ab(`Property not found: ${String(D)}`)}})}V.toService=_;function ne(te){return te[0]==="o"&&te[1]==="n"&&d.$Cf(te.charCodeAt(2))}function ce(te){return/^onDynamic/.test(te)&&d.$Cf(te.charCodeAt(9))}})(F||(e.ProxyChannel=F={}));const K=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function W(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const z=V.toString();if(z!=="[object Object]")return z}return V}function x(V){return Array.isArray(V)?V.map(W):W(V)}function G(V,z,_,ne,ce,te,Y){Y=x(Y);const H=K[ce],B=H[ne%H.length];let D=[`%c[${V}]%c[${String(z).padStart(7," ")}]%c[len: ${String(_).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(te)?(D=D.concat(Y),D.push(")")):D.push(Y),console.log.apply(console,D)}class ie{constructor(z,_){this.d=z,this.f=_,this.a=0,this.b=0}logOutgoing(z,_,ne,ce,te){this.b+=z,G(this.d,this.b,z,_,ne,ce,te)}logIncoming(z,_,ne,ce,te){this.a+=z,G(this.f,this.a,z,_,ne,ce,te)}}e.$li=ie}),define(he[69],ue([0,1,14,3,2,42]),function(oe,e,I,c,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$pi=e.$oi=e.$ni=e.ProtocolConstants=e.$mi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var N;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(N||(e.SocketDiagnosticsEventType=N={}));var O;(function(t){t.enableDiagnostics=!1,t.records=[];const n=new WeakMap;let r=0;function a(v,C){if(!n.has(v)){const b=String(++r);n.set(v,b)}return n.get(v)}function f(v,C,b,E){if(!t.enableDiagnostics)return;const T=a(v,C);if(E instanceof I.$Le||E instanceof Uint8Array||E instanceof ArrayBuffer||ArrayBuffer.isView(E)){const j=I.$Le.alloc(E.byteLength);j.set(E),t.records.push({timestamp:Date.now(),id:T,label:C,type:b,buff:j})}else t.records.push({timestamp:Date.now(),id:T,label:C,type:b,data:E})}t.traceSocketEvent=f})(O||(e.SocketDiagnostics=O={}));var k;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(k||(e.SocketCloseEventType=k={}));let y=null;function R(){return y||(y=I.$Le.alloc(0)),y}class d{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,r){if(n===0)return R();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const C=this.a[0];return r&&(this.a.shift(),this.b-=n),C}if(this.a[0].byteLength>n){const C=this.a[0].slice(0,n);return r&&(this.a[0]=this.a[0].slice(n),this.b-=n),C}const a=I.$Le.alloc(n);let f=0,v=0;for(;n>0;){const C=this.a[v];if(C.byteLength>n){const b=C.slice(0,n);a.set(b,f),f+=n,r&&(this.a[v]=C.slice(n),this.b-=n),n-=n}else a.set(C,f),f+=C.byteLength,r?(this.a.shift(),this.b-=C.byteLength):v++,n-=C.byteLength}return a}}e.$mi=d;var u;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume",t[t.KeepAlive=9]="KeepAlive"})(u||(u={}));function $(t){switch(t){case u.None:return"None";case u.Regular:return"Regular";case u.Control:return"Control";case u.Ack:return"Ack";case u.Disconnect:return"Disconnect";case u.ReplayRequest:return"ReplayRequest";case u.Pause:return"PauseWriting";case u.Resume:return"ResumeWriting";case u.KeepAlive:return"KeepAlive"}}var l;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",t[t.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(l||(e.ProtocolConstants=l={}));class p{constructor(n,r,a,f){this.type=n,this.id=r,this.ack=a,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class S extends A.$Tc{constructor(n){super(),this.f=this.B(new c.$je),this.onMessage=this.f.event,this.g={readHead:!0,readLen:l.HeaderLength,messageType:u.None,id:0,ack:0},this.a=n,this.b=!1,this.c=new d,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent(N.ProtocolHeaderRead,{messageType:$(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,f=this.g.id,v=this.g.ack;if(this.g.readHead=!0,this.g.readLen=l.HeaderLength,this.g.messageType=u.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(N.ProtocolMessageRead,r),this.f.fire(new p(a,f,v,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class g{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=I.$Le.alloc(l.HeaderLength);r.writeUInt8(n.type,0),r.writeUInt32BE(n.id,1),r.writeUInt32BE(n.ack,5),r.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent(N.ProtocolHeaderWrite,{messageType:$(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent(N.ProtocolMessageWrite,n.data),this.j(r,n.data)}g(n,r){const a=this.f===0;return this.d.push(n,r),this.f+=n.byteLength+r.byteLength,a}h(){const n=I.$Le.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,r){this.g(n,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent(N.ProtocolWrite,{byteLength:n.byteLength}),this.c.write(n)}}class w extends A.$Tc{constructor(n){super(),this.f=new c.$je,this.onMessage=this.f.event,this.g=new c.$je,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new g(this.a)),this.c=this.B(new S(this.a)),this.B(this.c.onMessage(r=>{r.type===u.Regular&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new p(u.Regular,0,0,n))}}e.$ni=w;class P extends L.$hi{static fromSocket(n,r){return new P(new w(n),r)}get onDidDispose(){return this.b.onDidDispose}constructor(n,r,a=null){super(n,r,a),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$oi=P;class m{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new c.$je({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$pi=m;class o{constructor(n){this.data=n,this.next=null}}class h{constructor(){this.a=null,this.b=null}length(){let n=0,r=this.a;for(;r;)r=r.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let r=0,a=this.a;for(;a;)n[r++]=a.data,a=a.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const r=new o(n);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class i{static{this.a=10}static{this.b=null}static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const n=Date.now();for(let r=0;r<i.a;r++)this.c[r]=n-1e3*r;setInterval(()=>{for(let r=i.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),r=(1+i.a)*1e3;let a=0;for(let f=0;f<i.a;f++)n-this.c[f]<=r&&a++;return 1-a/i.a}hasHighLoad(){return this.d()>=.5}}class s{get unacknowledgedCount(){return this.d-this.f}constructor(n){this.v=new m,this.onControlMessage=this.v.event,this.w=new m,this.onMessage=this.w.event,this.x=new m,this.onDidDispose=this.x.event,this.y=new m,this.onSocketClose=this.y.event,this.z=new m,this.onSocketTimeout=this.z.event,this.t=n.loadEstimator??i.getInstance(),this.u=n.sendKeepAlive??!0,this.a=!1,this.c=new h,this.d=0,this.f=0,this.g=null,this.h=0,this.j=0,this.k=0,this.l=null,this.n=0,this.o=Date.now(),this.s=new A.$Sc,this.p=n.socket,this.q=this.s.add(new g(this.p)),this.r=this.s.add(new S(this.p)),this.s.add(this.r.onMessage(r=>this.A(r))),this.s.add(this.p.onClose(r=>this.y.fire(r))),n.initialChunk&&this.r.acceptChunk(n.initialChunk),this.u?this.m=setInterval(()=>{this.E()},l.KeepAliveSendTime):this.m=null}dispose(){this.g&&(clearTimeout(this.g),this.g=null),this.l&&(clearTimeout(this.l),this.l=null),this.m&&(clearInterval(this.m),this.m=null),this.s.dispose()}drain(){return this.q.drain()}sendDisconnect(){if(!this.b){this.b=!0;const n=new p(u.Disconnect,0,0,R());this.q.write(n),this.q.flush()}}sendPause(){const n=new p(u.Pause,0,0,R());this.q.write(n)}sendResume(){const n=new p(u.Resume,0,0,R());this.q.write(n)}pauseSocketWriting(){this.q.pause()}getSocket(){return this.p}getMillisSinceLastIncomingData(){return Date.now()-this.r.lastReadTime}beginAcceptReconnection(n,r){this.a=!0,this.s.dispose(),this.s=new A.$Sc,this.v.flushBuffer(),this.y.flushBuffer(),this.z.flushBuffer(),this.p.dispose(),this.n=0,this.o=Date.now(),this.p=n,this.q=this.s.add(new g(this.p)),this.r=this.s.add(new S(this.p)),this.s.add(this.r.onMessage(a=>this.A(a))),this.s.add(this.p.onClose(a=>this.y.fire(a))),this.r.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.j=this.h;const n=new p(u.Ack,0,this.j,R());this.q.write(n);const r=this.c.toArray();for(let a=0,f=r.length;a<f;a++)this.q.write(r[a]);this.C()}acceptDisconnect(){this.x.fire()}A(n){if(n.ack>this.f){this.f=n.ack;do{const r=this.c.peek();if(r&&r.id<=n.ack)this.c.pop();else break}while(!0)}switch(n.type){case u.None:break;case u.Regular:{if(n.id>this.h)if(n.id!==this.h+1){const r=Date.now();r-this.n>1e4&&(this.n=r,this.q.write(new p(u.ReplayRequest,0,0,R())))}else this.h=n.id,this.k=Date.now(),this.B(),this.w.fire(n.data);break}case u.Control:{this.v.fire(n.data);break}case u.Ack:break;case u.Disconnect:{this.x.fire();break}case u.ReplayRequest:{const r=this.c.toArray();for(let a=0,f=r.length;a<f;a++)this.q.write(r[a]);this.C();break}case u.Pause:{this.q.pause();break}case u.Resume:{this.q.resume();break}case u.KeepAlive:break}}readEntireBuffer(){return this.r.readEntireBuffer()}flush(){this.q.flush()}send(n){const r=++this.d;this.j=this.h;const a=new p(u.Regular,r,this.j,n);this.c.push(a),this.a||(this.q.write(a),this.C())}sendControl(n){const r=new p(u.Control,0,0,n);this.q.write(r)}B(){if(this.h<=this.j||this.l)return;const n=Date.now()-this.k;if(n>=l.AcknowledgeTime){this.D();return}this.l=setTimeout(()=>{this.l=null,this.B()},l.AcknowledgeTime-n+5)}C(){if(this.d<=this.f||this.g||this.a)return;const n=this.c.peek(),r=Date.now()-n.writtenTime,a=Date.now()-this.r.lastReadTime,f=Date.now()-this.o;if(r>=l.TimeoutTime&&a>=l.TimeoutTime&&f>=l.TimeoutTime&&!this.t.hasHighLoad()){this.o=Date.now(),this.z.fire({unacknowledgedMsgCount:this.c.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const v=Math.max(l.TimeoutTime-r,l.TimeoutTime-a,l.TimeoutTime-f,500);this.g=setTimeout(()=>{this.g=null,this.C()},v)}D(){if(this.h<=this.j)return;this.j=this.h;const n=new p(u.Ack,0,this.j,R());this.q.write(n)}E(){this.j=this.h;const n=new p(u.KeepAlive,0,this.j,R());this.q.write(n)}}e.$qi=s}),define(he[95],ue([0,1,68,6,14,25,138,8,3,2,29,147,91,42]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=e.$dr=void 0,O=ke(O);class l extends $.$ei{constructor(g){super({send:w=>{try{process.send?.(w.buffer.toString("base64"))}catch{}},onMessage:k.Event.fromNodeEventEmitter(process,"message",w=>A.$Le.wrap(Buffer.from(w,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.$dr=l;class p{constructor(g,w){this.i=g,this.j=w,this.c=new Set,this.g=new Map,this.h=new k.$je,this.onDidProcessExit=this.h.event;const P=w&&w.timeout?w.timeout:6e4;this.b=new c.$zh(P),this.d=null,this.f=null}getChannel(g){const w=this;return{call(P,m,o){return w.k(g,P,m,o)},listen(P,m){return w.l(g,P,m)}}}k(g,w,P,m=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject(O.$5());this.b.cancel();const o=this.n(g),h=(0,c.$ph)(t=>o.call(w,P,t)),i=m.onCancellationRequested(()=>h.cancel()),s=(0,y.$Rc)(()=>h.cancel());return this.c.add(s),h.finally(()=>{i.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),h}l(g,w,P){if(!this.b)return k.Event.None;this.b.cancel();let m;const o=new k.$je({onWillAddFirstListener:()=>{m=this.n(g).listen(w,P)(o.fire,o),this.c.add(m)},onDidRemoveLastListener:()=>{this.c.delete(m),m.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return o.event}get m(){if(!this.f){const g=this.j&&this.j.args?this.j.args:[],w=Object.create(null);w.env={...(0,R.$ao)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(w.env={...w.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(w.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(w.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(w.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),w.execArgv===void 0&&(w.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,u.$im)(w.env),this.d=(0,I.fork)(this.i,g,w);const P=new k.$je,o=k.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,N.$_q)(r)){(0,N.log)(r,`IPC Library: ${this.j.serverName}`);return}P.fire(A.$Le.wrap(Buffer.from(r,"base64")))}),h=this.j.useQueue?(0,d.$vm)(this.d):this.d,i=r=>this.d&&this.d.connected&&h.send(r.buffer.toString("base64")),s=P.event,t={send:i,onMessage:s};this.f=new $.$fi(t);const n=()=>this.o();process.once("exit",n),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,a)=>{process.removeListener("exit",n),o.dispose(),this.c.forEach(f=>(0,y.$Oc)(f)),this.c.clear(),r!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:a})})}return this.f}n(g){let w=this.g.get(g);return w||(w=this.m.getChannel(g),this.g.set(g,w)),w}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$er=p}),define(he[149],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JX=I;function I(c){return!!c.parentPort}}),define(he[150],ue([0,1,149,14,42,3,12,17]),function(oe,e,I,c,A,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KX=void 0,e.$LX=R;class k{constructor(u){this.a=u,this.onMessage=L.Event.fromNodeEventEmitter(this.a,"message",$=>$.data?c.$Le.wrap($.data):c.$Le.alloc(0)),u.start()}send(u){this.a.postMessage(u.buffer)}disconnect(){this.a.close()}}class y extends A.$gi{static b(u){(0,N.$mg)((0,I.$JX)(process),"Electron Utility Process");const $=new L.$je;return process.parentPort.on("message",l=>{if(u?.handledClientConnection(l))return;const p=(0,O.$Nb)(l.ports);p&&$.fire(p)}),L.Event.map($.event,l=>({protocol:new k(l),onDidClientDisconnect:L.Event.fromNodeEventEmitter(l,"close")}))}constructor(u){super(y.b(u))}}e.$KX=y;function R(d,u,$){const l=p=>{p.data===u&&(d.removeListener("message",l),$())};d.on("message",l)}}),define(he[70],ue([0,1,6,3,2,66,12]),function(oe,e,I,c,A,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=e.StorageState=e.StorageHint=void 0,e.$_p=k;var O;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(O||(e.StorageHint=O={}));function k(u){const $=u;return $?.changed instanceof Map||$?.deleted instanceof Set}var y;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(y||(e.StorageState=y={}));class R extends A.$Tc{static{this.a=100}constructor($,l=Object.create(null)){super(),this.r=$,this.s=l,this.b=this.B(new c.$me),this.onDidChangeStorage=this.b.event,this.c=y.None,this.f=new Map,this.g=this.B(new I.$Ah(R.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal($=>this.u($)))}u($){this.b.pause();try{$.changed?.forEach((l,p)=>this.w(p,l)),$.deleted?.forEach(l=>this.w(l,void 0))}finally{this.b.resume()}}w($,l){if(this.c===y.Closed)return;let p=!1;(0,N.$lg)(l)?p=this.f.delete($):this.f.get($)!==l&&(this.f.set($,l),p=!0),p&&this.b.fire({key:$,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===y.None&&(this.c=y.Initialized,this.s.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get($,l){const p=this.f.get($);return(0,N.$lg)(p)?l:p}getBoolean($,l){const p=this.get($);return(0,N.$lg)(p)?l:p==="true"}getNumber($,l){const p=this.get($);return(0,N.$lg)(p)?l:parseInt(p,10)}getObject($,l){const p=this.get($);return(0,N.$lg)(p)?l:(0,L.$$h)(p)}async set($,l,p=!1){if(this.c===y.Closed)return;if((0,N.$lg)(l))return this.delete($,p);const S=(0,N.$eg)(l)||Array.isArray(l)?(0,L.$0h)(l):String(l);if(this.f.get($)!==S)return this.f.set($,S),this.j.set($,S),this.h.delete($),this.b.fire({key:$,external:p}),this.D()}async delete($,l=!1){if(!(this.c===y.Closed||!this.f.delete($)))return this.h.has($)||this.h.add($),this.j.delete($),this.b.fire({key:$,external:l}),this.D()}async optimize(){if(this.c!==y.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=y.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const $={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems($).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush($){if(!(this.c===y.Closed||this.m))return this.D($)}async D($){return this.s.hint===O.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),$)}async whenFlushed(){if(this.z)return new Promise($=>this.n.push($))}isInMemory(){return this.s.hint===O.STORAGE_IN_MEMORY}}e.$aq=R;class d{constructor(){this.onDidChangeItemsExternal=c.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems($){$.insert?.forEach((l,p)=>this.a.set(p,l)),$.delete?.forEach(l=>this.a.delete(l))}async optimize(){}async close(){}}e.$bq=d}),define(he[11],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=A,e.localize2=N;const I=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function c(O,k){let y;return k.length===0?y=O:y=O.replace(/\{(\d+)\}/g,(R,d)=>{const u=d[0],$=k[u];let l=R;return typeof $=="string"?l=$:(typeof $=="number"||typeof $=="boolean"||$===void 0||$===null)&&(l=String($)),l}),I&&(y="\uFF3B"+y.replace(/[aouei]/g,"$&$&")+"\uFF3D"),y}function A(O,k,...y){return c(typeof O=="number"?L(O,k):k,y)}function L(O,k){const y=globalThis._VSCODE_NLS_MESSAGES?.[O];if(typeof y!="string"){if(typeof k=="string")return k;throw new Error(`!!! NLS MISSING: ${O} !!!`)}return y}function N(O,k,...y){let R;typeof O=="number"?R=L(O,k):R=k;const d=c(R,y);return{value:d,original:k===R?d:c(k,y)}}}),define(he[71],ue([0,1,11]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=y,e.$Ym=R,e.$Zm=d;const c=60,A=c*60,L=A*24,N=L*7,O=L*30,k=L*365;function y(u,$,l,p){typeof u!="number"&&(u=u.getTime());const S=Math.round((new Date().getTime()-u)/1e3);if(S<-30)return(0,I.localize)(12817,null,y(new Date().getTime()+S*1e3,!1));if(!p&&S<30)return(0,I.localize)(12818,null);let g;return S<c?(g=S,$?g===1?l?(0,I.localize)(12819,null,g):(0,I.localize)(12820,null,g):l?(0,I.localize)(12821,null,g):(0,I.localize)(12822,null,g):g===1?l?(0,I.localize)(12823,null,g):(0,I.localize)(12824,null,g):l?(0,I.localize)(12825,null,g):(0,I.localize)(12826,null,g)):S<A?(g=Math.floor(S/c),$?g===1?l?(0,I.localize)(12827,null,g):(0,I.localize)(12828,null,g):l?(0,I.localize)(12829,null,g):(0,I.localize)(12830,null,g):g===1?l?(0,I.localize)(12831,null,g):(0,I.localize)(12832,null,g):l?(0,I.localize)(12833,null,g):(0,I.localize)(12834,null,g)):S<L?(g=Math.floor(S/A),$?g===1?l?(0,I.localize)(12835,null,g):(0,I.localize)(12836,null,g):l?(0,I.localize)(12837,null,g):(0,I.localize)(12838,null,g):g===1?l?(0,I.localize)(12839,null,g):(0,I.localize)(12840,null,g):l?(0,I.localize)(12841,null,g):(0,I.localize)(12842,null,g)):S<N?(g=Math.floor(S/L),$?g===1?(0,I.localize)(12843,null,g):(0,I.localize)(12844,null,g):g===1?(0,I.localize)(12845,null,g):(0,I.localize)(12846,null,g)):S<O?(g=Math.floor(S/N),$?g===1?l?(0,I.localize)(12847,null,g):(0,I.localize)(12848,null,g):l?(0,I.localize)(12849,null,g):(0,I.localize)(12850,null,g):g===1?l?(0,I.localize)(12851,null,g):(0,I.localize)(12852,null,g):l?(0,I.localize)(12853,null,g):(0,I.localize)(12854,null,g)):S<k?(g=Math.floor(S/O),$?g===1?l?(0,I.localize)(12855,null,g):(0,I.localize)(12856,null,g):l?(0,I.localize)(12857,null,g):(0,I.localize)(12858,null,g):g===1?l?(0,I.localize)(12859,null,g):(0,I.localize)(12860,null,g):l?(0,I.localize)(12861,null,g):(0,I.localize)(12862,null,g)):(g=Math.floor(S/k),$?g===1?l?(0,I.localize)(12863,null,g):(0,I.localize)(12864,null,g):l?(0,I.localize)(12865,null,g):(0,I.localize)(12866,null,g):g===1?l?(0,I.localize)(12867,null,g):(0,I.localize)(12868,null,g):l?(0,I.localize)(12869,null,g):(0,I.localize)(12870,null,g))}function R(u,$){const l=Math.abs(u/1e3);return l<1?$?(0,I.localize)(12871,null,u):(0,I.localize)(12872,null,u):l<c?$?(0,I.localize)(12873,null,Math.round(u)/1e3):(0,I.localize)(12874,null,Math.round(u)/1e3):l<A?$?(0,I.localize)(12875,null,Math.round(u/(1e3*c))):(0,I.localize)(12876,null,Math.round(u/(1e3*c))):l<L?$?(0,I.localize)(12877,null,Math.round(u/(1e3*A))):(0,I.localize)(12878,null,Math.round(u/(1e3*A))):(0,I.localize)(12879,null,Math.round(u/(1e3*L)))}function d(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(he[43],ue([0,1,17,12,11]),function(oe,e,I,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=k,e.$oj=y,e.$pj=R,I=ke(I),c=ke(c),A=ke(A);function L(d,u){return u&&(d.stack||d.stacktrace)?A.localize(12811,null,O(d),N(d.stack)||N(d.stacktrace)):O(d)}function N(d){return Array.isArray(d)?d.join(`
`):d}function O(d){return d.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof d.code=="string"&&typeof d.errno=="number"&&typeof d.syscall=="string"?A.localize(12812,null,d.message):d.message||A.localize(12813,null)}function k(d=null,u=!1){if(!d)return A.localize(12814,null);if(Array.isArray(d)){const $=I.$Gb(d),l=k($[0],u);return $.length>1?A.localize(12815,null,l,$.length):l}if(c.$cg(d))return d;if(d.detail){const $=d.detail;if($.error)return L($.error,u);if($.exception)return L($.exception,u)}return d.stack?L(d,u):d.message?d.message:A.localize(12816,null)}function y(d){const u=d;return u instanceof Error&&Array.isArray(u.actions)}function R(d,u){let $;return typeof d=="string"?$=new Error(d):$=d,$.actions=u,$}}),define(he[151],ue([0,1,11,35]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=A;function A(L){switch(L){case c.ParseErrorCode.InvalidSymbol:return(0,I.localize)(12802,null);case c.ParseErrorCode.InvalidNumberFormat:return(0,I.localize)(12803,null);case c.ParseErrorCode.PropertyNameExpected:return(0,I.localize)(12804,null);case c.ParseErrorCode.ValueExpected:return(0,I.localize)(12805,null);case c.ParseErrorCode.ColonExpected:return(0,I.localize)(12806,null);case c.ParseErrorCode.CommaExpected:return(0,I.localize)(12807,null);case c.ParseErrorCode.CloseBraceExpected:return(0,I.localize)(12808,null);case c.ParseErrorCode.CloseBracketExpected:return(0,I.localize)(12809,null);case c.ParseErrorCode.EndOfFileExpected:return(0,I.localize)(12810,null);default:return""}}}),define(he[72],ue([0,1,32,6,13,12,30,11]),function(oe,e,I,c,A,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=e.$wq=void 0,e.zip=S,e.$zq=g,e.$Aq=P,A=ke(A),O=ke(O),e.$wq="end of central directory record signature not found";const k=new RegExp(e.$wq);class y extends Error{constructor(o,h){let i=h.message;switch(o){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=o,this.cause=h}}e.$xq=y;function R(m){const o=m.externalFileAttributes>>16||33188;return[448,56,7].map(h=>o&h).reduce((h,i)=>h+i,o&61440)}function d(m){if(m instanceof y)return m;let o;return k.test(m.message)&&(o="CorruptZip"),new y(o,m)}function u(m,o,h,i,s,t){const n=A.$lc(o),r=A.$ic(i,n);if(!r.startsWith(i))return Promise.reject(new Error(O.localize(12779,null,o)));const a=A.$ic(i,o);let f;return t.onCancellationRequested(()=>{f?.destroy()}),Promise.resolve(I.promises.mkdir(r,{recursive:!0})).then(()=>new Promise((v,C)=>{if(!t.isCancellationRequested)try{f=(0,I.createWriteStream)(a,{mode:h}),f.once("close",()=>v()),f.once("error",C),m.once("error",C),m.pipe(f)}catch(b){C(b)}}))}function $(m,o,h,i){let s=(0,c.$ph)(()=>Promise.resolve()),t=0;const n=i.onCancellationRequested(()=>{s.cancel(),m.close()});return new Promise((r,a)=>{const f=new c.$xh,v=C=>{C.isCancellationRequested||(t++,m.readEntry())};m.once("error",a),m.once("close",()=>s.then(()=>{i.isCancellationRequested||m.entryCount===t?r():a(new y("Incomplete",new Error(O.localize(12780,null,t,m.entryCount))))},a)),m.readEntry(),m.on("entry",C=>{if(i.isCancellationRequested)return;if(!h.sourcePathRegex.test(C.fileName)){v(i);return}const b=C.fileName.replace(h.sourcePathRegex,"");if(/\/$/.test(b)){const j=A.$ic(o,b);s=(0,c.$ph)(U=>I.promises.mkdir(j,{recursive:!0}).then(()=>v(U)).then(void 0,a));return}const E=p(m,C),T=R(C);s=(0,c.$ph)(j=>f.queue(()=>E.then(U=>u(U,b,T,o,h,j).then(()=>v(j)))).then(null,a))})}).finally(()=>n.dispose())}async function l(m,o=!1){const{open:h}=await new Promise((i,s)=>{oe(["yauzl"],i,s)}).then(ke);return new Promise((i,s)=>{h(m,o?{lazyEntries:!0}:void 0,(t,n)=>{t?s(d(t)):i((0,L.$ng)(n))})})}function p(m,o){return new Promise((h,i)=>{m.openReadStream(o,(s,t)=>{s?i(d(s)):h((0,L.$ng)(t))})})}async function S(m,o){const{ZipFile:h}=await new Promise((i,s)=>{oe(["yazl"],i,s)}).then(ke);return new Promise((i,s)=>{const t=new h;o.forEach(r=>{r.contents?t.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&t.addFile(r.localPath,r.path)}),t.end();const n=(0,I.createWriteStream)(m);t.outputStream.pipe(n),t.outputStream.once("error",s),n.once("error",s),n.once("finish",()=>i(m))})}function g(m,o,h={},i){const s=new RegExp(h.sourcePath?`^${h.sourcePath}`:"");let t=l(m,!0);return h.overwrite&&(t=t.then(n=>N.Promises.rm(o).then(()=>n))),t.then(n=>$(n,o,{sourcePathRegex:s},i))}function w(m,o){return l(m).then(h=>new Promise((i,s)=>{h.on("entry",t=>{t.fileName===o&&p(h,t).then(n=>i(n),n=>s(n))}),h.once("close",()=>s(new Error(O.localize(12781,null,o))))}))}function P(m,o){return w(m,o).then(h=>new Promise((i,s)=>{const t=[];h.once("error",s),h.on("data",n=>t.push(n)),h.on("end",()=>i(Buffer.concat(t)))}))}}),define(he[152],ue([0,1,39,8,11]),function(oe,e,I,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.TokenType=void 0;var L;(function(R){R[R.LParen=0]="LParen",R[R.RParen=1]="RParen",R[R.Neg=2]="Neg",R[R.Eq=3]="Eq",R[R.NotEq=4]="NotEq",R[R.Lt=5]="Lt",R[R.LtEq=6]="LtEq",R[R.Gt=7]="Gt",R[R.GtEq=8]="GtEq",R[R.RegexOp=9]="RegexOp",R[R.RegexStr=10]="RegexStr",R[R.True=11]="True",R[R.False=12]="False",R[R.In=13]="In",R[R.Not=14]="Not",R[R.And=15]="And",R[R.Or=16]="Or",R[R.Str=17]="Str",R[R.QuotedStr=18]="QuotedStr",R[R.Error=19]="Error",R[R.EOF=20]="EOF"})(L||(e.TokenType=L={}));function N(...R){switch(R.length){case 1:return(0,A.localize)(11418,null,R[0]);case 2:return(0,A.localize)(11419,null,R[0],R[1]);case 3:return(0,A.localize)(11420,null,R[0],R[1],R[2]);default:return}}const O=(0,A.localize)(11421,null),k=(0,A.localize)(11422,null);class y{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(d){switch(d.type){case L.LParen:return"(";case L.RParen:return")";case L.Neg:return"!";case L.Eq:return d.isTripleEq?"===":"==";case L.NotEq:return d.isTripleEq?"!==":"!=";case L.Lt:return"<";case L.LtEq:return"<=";case L.Gt:return">=";case L.GtEq:return">=";case L.RegexOp:return"=~";case L.RegexStr:return d.lexeme;case L.True:return"true";case L.False:return"false";case L.In:return"in";case L.Not:return"not";case L.And:return"&&";case L.Or:return"||";case L.Str:return d.lexeme;case L.QuotedStr:return d.lexeme;case L.Error:return d.lexeme;case L.EOF:return"EOF";default:throw(0,c.$7)(`unhandled token type: ${JSON.stringify(d)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(d=>d.charCodeAt(0)))}static{this.b=new Map([["not",L.Not],["in",L.In],["false",L.False],["true",L.True]])}get errors(){return this.g}reset(d){return this.c=d,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case I.CharCode.OpenParen:this.k(L.LParen);break;case I.CharCode.CloseParen:this.k(L.RParen);break;case I.CharCode.ExclamationMark:if(this.h(I.CharCode.Equals)){const u=this.h(I.CharCode.Equals);this.f.push({type:L.NotEq,offset:this.d,isTripleEq:u})}else this.k(L.Neg);break;case I.CharCode.SingleQuote:this.o();break;case I.CharCode.Slash:this.q();break;case I.CharCode.Equals:if(this.h(I.CharCode.Equals)){const u=this.h(I.CharCode.Equals);this.f.push({type:L.Eq,offset:this.d,isTripleEq:u})}else this.h(I.CharCode.Tilde)?this.k(L.RegexOp):this.l(N("==","=~"));break;case I.CharCode.LessThan:this.k(this.h(I.CharCode.Equals)?L.LtEq:L.Lt);break;case I.CharCode.GreaterThan:this.k(this.h(I.CharCode.Equals)?L.GtEq:L.Gt);break;case I.CharCode.Ampersand:this.h(I.CharCode.Ampersand)?this.k(L.And):this.l(N("&&"));break;case I.CharCode.Pipe:this.h(I.CharCode.Pipe)?this.k(L.Or):this.l(N("||"));break;case I.CharCode.Space:case I.CharCode.CarriageReturn:case I.CharCode.Tab:case I.CharCode.LineFeed:case I.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(L.EOF),Array.from(this.f)}h(d){return this.r()||this.c.charCodeAt(this.e)!==d?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?I.CharCode.Null:this.c.charCodeAt(this.e)}k(d){this.f.push({type:d,offset:this.d})}l(d){const u=this.d,$=this.c.substring(this.d,this.e),l={type:L.Error,offset:this.d,lexeme:$};this.g.push({offset:u,lexeme:$,additionalInfo:d}),this.f.push(l)}n(){this.m.lastIndex=this.d;const d=this.m.exec(this.c);if(d){this.e=this.d+d[0].length;const u=this.c.substring(this.d,this.e),$=y.b.get(u);$?this.k($):this.f.push({type:L.Str,lexeme:u,offset:this.d})}}o(){for(;this.j()!==I.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:L.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let d=this.e,u=!1,$=!1;for(;;){if(d>=this.c.length){this.e=d,this.l(k);return}const p=this.c.charCodeAt(d);if(u)u=!1;else if(p===I.CharCode.Slash&&!$){d++;break}else p===I.CharCode.OpenSquareBracket?$=!0:p===I.CharCode.Backslash?u=!0:p===I.CharCode.CloseSquareBracket&&($=!1);d++}for(;d<this.c.length&&y.a.has(this.c.charCodeAt(d));)d++;this.e=d;const l=this.c.substring(this.d,this.e);this.f.push({type:L.RegexStr,lexeme:l,offset:this.d})}r(){return this.e>=this.c.length}}e.$xj=y}),define(he[153],ue([0,1,71,87,22,13,37,20,9]),function(oe,e,I,c,A,L,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=e.$1m=void 0,e.$3m=R,e.$4m=d,e.$1m=/^([^.]+\..+)[:=](.+)$/;class y{get appRoot(){return(0,L.$lc)(A.$Wg.asFileUri("").fsPath)}get userHome(){return k.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return k.URI.file((0,L.$ic)(this.userDataPath,"User"))}get tmpDir(){return k.URI.file(this.b.tmpDir)}get cacheHome(){return k.URI.file(this.userDataPath)}get stateResource(){return(0,O.$dh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:A.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,O.$dh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const $=(0,I.$Zm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.$ic)(this.userDataPath,"logs",$)}return k.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,O.$dh)(k.URI.file((0,L.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,O.$dh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,O.$dh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,O.$dh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const $=N.env.VSCODE_PORTABLE;return $?k.URI.file((0,L.$ic)($,"argv.json")):(0,O.$dh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return k.URI.file((0,L.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const $=this.args["builtin-extensions-dir"];return $?(0,L.$jc)($):(0,L.$gc)((0,L.$ic)(A.$Wg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const $=this.args["extensions-download-dir"];return $?k.URI.file((0,L.$jc)($)):k.URI.file((0,L.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const $=this.args["extensions-dir"];if($)return(0,L.$jc)($);const l=N.env.VSCODE_EXTENSIONS;if(l)return l;const p=N.env.VSCODE_PORTABLE;return p?(0,L.$ic)(p,"extensions"):(0,O.$dh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const $=this.args.extensionDevelopmentPath;if(Array.isArray($))return $.map(l=>/^[^:/?#]+?:\/\//.test(l)?k.URI.parse(l):k.URI.file((0,L.$gc)(l)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map($=>$==="ui"||$==="workspace"||$==="web"?$:"workspace")}get extensionTestsLocationURI(){const $=this.args.extensionTestsPath;if($)return/^[^:/?#]+?:\/\//.test($)?k.URI.parse($):k.URI.file((0,L.$gc)($))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const $=this.args["disable-extension"];if($){if(typeof $=="string")return[$];if(Array.isArray($)&&$.length>0)return $}return!1}get debugExtensionHost(){return R(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!N.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find($=>!e.$1m.test($))}get extensionLogLevel(){const $=[];for(const l of this.args.log||[]){const p=e.$1m.exec(l);p&&p[1]&&p[2]&&$.push([p[1],p[2]])}return $.length?$:void 0}get serviceMachineIdResource(){return(0,O.$dh)(k.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const $=N.env.VSCODE_PORTABLE;return $?k.URI.file((0,L.$ic)($,"policy.json")):(0,O.$dh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn($){this.args.continueOn=$}get args(){return this.a}constructor($,l,p){this.a=$,this.b=l,this.c=p,this.editSessionId=this.args.editSessionId}}e.$2m=y,ve([c.$7h],y.prototype,"appRoot",null),ve([c.$7h],y.prototype,"userHome",null),ve([c.$7h],y.prototype,"userDataPath",null),ve([c.$7h],y.prototype,"appSettingsHome",null),ve([c.$7h],y.prototype,"tmpDir",null),ve([c.$7h],y.prototype,"cacheHome",null),ve([c.$7h],y.prototype,"stateResource",null),ve([c.$7h],y.prototype,"userRoamingDataHome",null),ve([c.$7h],y.prototype,"userDataSyncHome",null),ve([c.$7h],y.prototype,"sync",null),ve([c.$7h],y.prototype,"machineSettingsResource",null),ve([c.$7h],y.prototype,"workspaceStorageHome",null),ve([c.$7h],y.prototype,"localHistoryHome",null),ve([c.$7h],y.prototype,"keyboardLayoutResource",null),ve([c.$7h],y.prototype,"argvResource",null),ve([c.$7h],y.prototype,"isExtensionDevelopment",null),ve([c.$7h],y.prototype,"untitledWorkspacesHome",null),ve([c.$7h],y.prototype,"builtinExtensionsPath",null),ve([c.$7h],y.prototype,"extensionsPath",null),ve([c.$7h],y.prototype,"extensionDevelopmentLocationURI",null),ve([c.$7h],y.prototype,"extensionDevelopmentKind",null),ve([c.$7h],y.prototype,"extensionTestsLocationURI",null),ve([c.$7h],y.prototype,"debugExtensionHost",null),ve([c.$7h],y.prototype,"logLevel",null),ve([c.$7h],y.prototype,"extensionLogLevel",null),ve([c.$7h],y.prototype,"serviceMachineIdResource",null),ve([c.$7h],y.prototype,"disableTelemetry",null),ve([c.$7h],y.prototype,"disableWorkspaceTrust",null),ve([c.$7h],y.prototype,"useInMemorySecretStorage",null),ve([c.$7h],y.prototype,"policyFile",null);function R(u,$){return d(u["inspect-extensions"],u["inspect-brk-extensions"],5870,$,u.debugId,u.extensionEnvironment)}function d(u,$,l,p,S,g){const P=Number($||u)||(p?null:l),m=P?!!$:!1;let o;if(g)try{o=JSON.parse(g)}catch{}return{port:P,break:m,debugId:S,env:o}}}),function(){"use strict";function oe(e,I,c){function A(N,O){const k=L(N,O),y=[k];return e.isAbsolute(k)||y.unshift(c),e.resolve(...y)}function L(N,O){process.env.VSCODE_DEV&&(O="code-oss-dev");const k=process.env.VSCODE_PORTABLE;if(k)return e.join(k,"user-data");let y=process.env.VSCODE_APPDATA;if(y)return e.join(y,O);const R=N["user-data-dir"];if(R)return R;switch(process.platform){case"win32":if(y=process.env.APPDATA,!y){const d=process.env.USERPROFILE;if(typeof d!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");y=e.join(d,"AppData","Roaming")}break;case"darwin":y=e.join(I.homedir(),"Library","Application Support");break;case"linux":y=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(y,O)}return{getUserDataPath:A}}if(typeof define=="function")define(he[154],ue([242,38,37]),function(e,I,c){return oe(e,I,c.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("os");module.exports=oe(e,I,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(he[155],ue([0,1,38,153,154]),function(oe,e,I,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=void 0,e.$6m=N,e.$7m=O;class L extends c.$2m{constructor(y,R){super(y,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,A.getUserDataPath)(y,R.nameShort)},R)}}e.$5m=L;function N(k,y){return(0,c.$4m)(k["inspect-ptyhost"],k["inspect-brk-ptyhost"],5877,y,k.extensionEnvironment)}function O(k,y){return(0,c.$4m)(k["inspect-sharedprocess"],k["inspect-brk-sharedprocess"],5879,y,k.extensionEnvironment)}}),define(he[156],ue([0,1,12,11]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=A;function A(N,O,k,y){try{L(N,O,k,y)}catch(R){N.error(R?.message??R)}return O}function L(N,O,k,y){const R=(d,u,$)=>{const l=d[u];if((0,I.$cg)(l)){const p=l,S=p.length;if(S>1&&p[0]==="%"&&p[S-1]==="%"){const g=p.substr(1,S-2);let w=k[g];w===void 0&&y&&(w=y[g]);const P=typeof w=="string"?w:w?.message,m=y?.[g],o=typeof m=="string"?m:m?.message;if(!P){o||N.warn(`[${O.name}]: ${(0,c.localize)(11301,null,g)}`);return}if($&&(u==="title"||u==="category")&&o&&o!==P){const h={value:P,original:o};d[u]=h}else d[u]=P}}else if((0,I.$eg)(l))for(const p in l)l.hasOwnProperty(p)&&(p==="commands"?R(l,p,!0):R(l,p,$));else if(Array.isArray(l))for(let p=0;p<l.length;p++)R(l,p,$)};for(const d in O)O.hasOwnProperty(d)&&R(O,d)}}),define(he[157],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jhc=e.$Ihc=void 0;class I{constructor(L){this.a=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L){return this.a.call("promptImportantExtensionsInstallNotification",[L])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$Ihc=I;class c{constructor(L){this.a=L}listen(L,N){throw new Error(`Event not found: ${N}`)}call(L,N,O){switch(N){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(O[0])}throw new Error(`Call not found: ${N}`)}}e.$Jhc=c}),define(he[158],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const I={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(I)}),define(he[73],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=void 0;class I{constructor(A,L=[],N=!1){this.ctor=A,this.staticArguments=L,this.supportsDelayedInstantiation=N}}e.$zi=I}),define(he[159],ue([0,1,73]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ns=L,e.$Os=N;const c=[];var A;(function(O){O[O.Eager=0]="Eager",O[O.Delayed=1]="Delayed"})(A||(e.InstantiationType=A={}));function L(O,k,y){k instanceof I.$zi||(k=new I.$zi(k,[],!!y)),c.push([O,k])}function N(){return c}}),define(he[160],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=e.$qr=void 0;class I{constructor(L,N){this.key=L,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.$qr=I;class c{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const N of this.a.values())N.outgoing.size===0&&L.push(N);return L}insertEdge(L,N){const O=this.lookupOrInsertNode(L),k=this.lookupOrInsertNode(N);O.outgoing.set(k.key,k),k.incoming.set(O.key,O)}removeNode(L){const N=this.b(L);this.a.delete(N);for(const O of this.a.values())O.outgoing.delete(N),O.incoming.delete(N)}lookupOrInsertNode(L){const N=this.b(L);let O=this.a.get(N);return O||(O=new I(N,L),this.a.set(N,O)),O}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[N,O]of this.a)L.push(`${N}
	(-> incoming)[${[...O.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...O.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,N]of this.a){const O=new Set([L]),k=this.c(N,O);if(k)return k}}c(L,N){for(const[O,k]of L.outgoing){if(N.has(O))return[...N,O].join(" -> ");N.add(O);const y=this.c(k,N);if(y)return y;N.delete(O)}}}e.$rr=c}),define(he[4],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=e._util=void 0,e.$Ci=A,e.$Di=L;var I;(function(N){N.serviceIds=new Map,N.DI_TARGET="$di$target",N.DI_DEPENDENCIES="$di$dependencies";function O(k){return k[N.DI_DEPENDENCIES]||[]}N.getServiceDependencies=O})(I||(e._util=I={})),e.$Bi=A("instantiationService");function c(N,O,k){O[I.DI_TARGET]===O?O[I.DI_DEPENDENCIES].push({id:N,index:k}):(O[I.DI_DEPENDENCIES]=[{id:N,index:k}],O[I.DI_TARGET]=O)}function A(N){if(I.serviceIds.has(N))return I.serviceIds.get(N);const O=function(k,y,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");c(O,k,R)};return O.toString=()=>N,I.serviceIds.set(N,O),O}function L(N){return N}}),define(he[161],ue([0,1,4]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ihc=void 0,e.$ihc=(0,I.$Ci)("checksumService")}),define(he[21],ue([0,1,12,9,4]),function(oe,e,I,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$9i=void 0,e.$0i=L,e.$$i=N,e.$_i=k,e.$aj=y,e.$bj=R,e.$cj=d,e.$dj=u,e.$ej=l,e.$fj=p,e.$gj=S,I=ke(I),e.$9i=(0,A.$Ci)("configurationService");function L(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof c.URI)}function N(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||Array.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof c.URI)}var O;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.USER=2]="USER",g[g.USER_LOCAL=3]="USER_LOCAL",g[g.USER_REMOTE=4]="USER_REMOTE",g[g.WORKSPACE=5]="WORKSPACE",g[g.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",g[g.DEFAULT=7]="DEFAULT",g[g.MEMORY=8]="MEMORY"})(O||(e.ConfigurationTarget=O={}));function k(g){switch(g){case O.APPLICATION:return"APPLICATION";case O.USER:return"USER";case O.USER_LOCAL:return"USER_LOCAL";case O.USER_REMOTE:return"USER_REMOTE";case O.WORKSPACE:return"WORKSPACE";case O.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case O.DEFAULT:return"DEFAULT";case O.MEMORY:return"MEMORY"}}function y(g){return g.applicationValue!==void 0||g.userValue!==void 0||g.userLocalValue!==void 0||g.userRemoteValue!==void 0||g.workspaceValue!==void 0||g.workspaceFolderValue!==void 0}function R(g,w){const P=Object.create(null);for(const m in g)d(P,m,g[m],w);return P}function d(g,w,P,m){const o=w.split("."),h=o.pop();let i=g;for(let s=0;s<o.length;s++){const t=o[s];let n=i[t];switch(typeof n){case"undefined":n=i[t]=Object.create(null);break;case"object":if(n===null){m(`Ignoring ${w} as ${o.slice(0,s+1).join(".")} is null`);return}break;default:m(`Ignoring ${w} as ${o.slice(0,s+1).join(".")} is ${JSON.stringify(n)}`);return}i=n}if(typeof i=="object"&&i!==null)try{i[h]=P}catch{m(`Ignoring ${w} as ${o.join(".")} is ${JSON.stringify(i)}`)}else m(`Ignoring ${w} as ${o.join(".")} is ${JSON.stringify(i)}`)}function u(g,w){const P=w.split(".");$(g,P)}function $(g,w){const P=w.shift();if(w.length===0){delete g[P];return}if(Object.keys(g).indexOf(P)!==-1){const m=g[P];typeof m=="object"&&!Array.isArray(m)&&($(m,w),Object.keys(m).length===0&&delete g[P])}}function l(g,w,P){function m(i,s){let t=i;for(const n of s){if(typeof t!="object"||t===null)return;t=t[n]}return t}const o=w.split("."),h=m(g,o);return typeof h>"u"?P:h}function p(g,w,P){Object.keys(w).forEach(m=>{m!=="__proto__"&&(m in g?I.$eg(g[m])&&I.$eg(w[m])?p(g[m],w[m],P):P&&(g[m]=w[m]):g[m]=w[m])})}function S(g){return g.replace(/[\[\]]/g,"")}}),define(he[96],ue([0,1,39,5,26,152,4,11,8]),function(oe,e,I,c,A,L,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Aj=e.$zj=e.ContextKeyExprType=void 0,e.$yj=R,e.$Bj=s,e.$Cj=t,e.$Vj=te;const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",c.$k),y.set("isLinux",c.$l),y.set("isWindows",c.$j),y.set("isWeb",c.$p),y.set("isMacNative",c.$k&&!c.$p),y.set("isEdge",c.$I),y.set("isFirefox",c.$G),y.set("isChrome",c.$F),y.set("isSafari",c.$H);function R(B,D){if(y.get(B)!==void 0)throw(0,k.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");y.set(B,D)}const d=Object.prototype.hasOwnProperty;var u;(function(B){B[B.False=0]="False",B[B.True=1]="True",B[B.Defined=2]="Defined",B[B.Not=3]="Not",B[B.Equals=4]="Equals",B[B.NotEquals=5]="NotEquals",B[B.And=6]="And",B[B.Regex=7]="Regex",B[B.NotRegex=8]="NotRegex",B[B.Or=9]="Or",B[B.In=10]="In",B[B.NotIn=11]="NotIn",B[B.Greater=12]="Greater",B[B.GreaterEquals=13]="GreaterEquals",B[B.Smaller=14]="Smaller",B[B.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const $={regexParsingWithErrorRecovery:!0},l=(0,O.localize)(11432,null),p=(0,O.localize)(11433,null),S=(0,O.localize)(11434,null),g=(0,O.localize)(11435,null),w=(0,O.localize)(11436,null),P=(0,O.localize)(11437,null),m=(0,O.localize)(11438,null),o=(0,O.localize)(11439,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(D=$){this.k=D,this.d=new L.$xj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(D){if(D===""){this.h.push({message:l,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(D).scan(),this.g=0,this.h=[];try{const J=this.l();if(!this.E()){const q=this.D(),M=q.type===L.TokenType.Str?P:void 0;throw this.h.push({message:w,offset:q.offset,lexeme:L.$xj.getLexeme(q),additionalInfo:M}),h.c}return J}catch(J){if(J!==h.c)throw J;return}}l(){return this.m()}m(){const D=[this.o()];for(;this.y(L.TokenType.Or);){const J=this.o();D.push(J)}return D.length===1?D[0]:i.or(...D)}o(){const D=[this.s()];for(;this.y(L.TokenType.And);){const J=this.s();D.push(J)}return D.length===1?D[0]:i.and(...D)}s(){if(this.y(L.TokenType.Neg)){const D=this.D();switch(D.type){case L.TokenType.True:return this.z(),r.INSTANCE;case L.TokenType.False:return this.z(),a.INSTANCE;case L.TokenType.LParen:{this.z();const J=this.l();return this.A(L.TokenType.RParen,g),J?.negate()}case L.TokenType.Str:return this.z(),T.create(D.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",D)}}return this.t()}t(){const D=this.D();switch(D.type){case L.TokenType.True:return this.z(),i.true();case L.TokenType.False:return this.z(),i.false();case L.TokenType.LParen:{this.z();const J=this.l();return this.A(L.TokenType.RParen,g),J}case L.TokenType.Str:{const J=D.lexeme;if(this.z(),this.y(L.TokenType.RegexOp)){const M=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),M.type!==L.TokenType.RegexStr)throw this.B("REGEX",M);const Z=M.lexeme,ee=Z.lastIndexOf("/"),X=ee===Z.length-1?void 0:this.w(Z.substring(ee+1));let re;try{re=new RegExp(Z.substring(1,ee),X)}catch{throw this.B("REGEX",M)}return x.create(J,re)}switch(M.type){case L.TokenType.RegexStr:case L.TokenType.Error:{const Z=[M.lexeme];this.z();let ee=this.D(),X=0;for(let Ee=0;Ee<M.lexeme.length;Ee++)M.lexeme.charCodeAt(Ee)===I.CharCode.OpenParen?X++:M.lexeme.charCodeAt(Ee)===I.CharCode.CloseParen&&X--;for(;!this.E()&&ee.type!==L.TokenType.And&&ee.type!==L.TokenType.Or;){switch(ee.type){case L.TokenType.LParen:X++;break;case L.TokenType.RParen:X--;break;case L.TokenType.RegexStr:case L.TokenType.QuotedStr:for(let Ee=0;Ee<ee.lexeme.length;Ee++)ee.lexeme.charCodeAt(Ee)===I.CharCode.OpenParen?X++:M.lexeme.charCodeAt(Ee)===I.CharCode.CloseParen&&X--}if(X<0)break;Z.push(L.$xj.getLexeme(ee)),this.z(),ee=this.D()}const re=Z.join(""),le=re.lastIndexOf("/"),ge=le===re.length-1?void 0:this.w(re.substring(le+1));let pe;try{pe=new RegExp(re.substring(1,le),ge)}catch{throw this.B("REGEX",M)}return i.regex(J,pe)}case L.TokenType.QuotedStr:{const Z=M.lexeme;this.z();let ee=null;if(!(0,A.$af)(Z)){const X=Z.indexOf("/"),re=Z.lastIndexOf("/");if(X!==re&&X>=0){const le=Z.slice(X+1,re),ge=Z[re+1]==="i"?"i":"";try{ee=new RegExp(le,ge)}catch{throw this.B("REGEX",M)}}}if(ee===null)throw this.B("REGEX",M);return x.create(J,ee)}default:throw this.B("REGEX",this.D())}}if(this.y(L.TokenType.Not)){this.A(L.TokenType.In,S);const M=this.u();return i.notIn(J,M)}switch(this.D().type){case L.TokenType.Eq:{this.z();const M=this.u();if(this.x().type===L.TokenType.QuotedStr)return i.equals(J,M);switch(M){case"true":return i.has(J);case"false":return i.not(J);default:return i.equals(J,M)}}case L.TokenType.NotEq:{this.z();const M=this.u();if(this.x().type===L.TokenType.QuotedStr)return i.notEquals(J,M);switch(M){case"true":return i.not(J);case"false":return i.has(J);default:return i.notEquals(J,M)}}case L.TokenType.Lt:return this.z(),K.create(J,this.u());case L.TokenType.LtEq:return this.z(),W.create(J,this.u());case L.TokenType.Gt:return this.z(),U.create(J,this.u());case L.TokenType.GtEq:return this.z(),F.create(J,this.u());case L.TokenType.In:return this.z(),i.in(J,this.u());default:return i.has(J)}}case L.TokenType.EOF:throw this.h.push({message:m,offset:D.offset,lexeme:"",additionalInfo:o}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const D=this.D();switch(D.type){case L.TokenType.Str:case L.TokenType.QuotedStr:return this.z(),D.lexeme;case L.TokenType.True:return this.z(),"true";case L.TokenType.False:return this.z(),"false";case L.TokenType.In:return this.z(),"in";default:return""}}w(D){return D.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(D){return this.C(D)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(D,J){if(this.C(D))return this.z();throw this.B(J,this.D())}B(D,J,q){const M=(0,O.localize)(11440,null,D,L.$xj.getLexeme(J)),Z=J.offset,ee=L.$xj.getLexeme(J);return this.h.push({message:M,offset:Z,lexeme:ee,additionalInfo:q}),h.c}C(D){return this.D().type===D}D(){return this.f[this.g]}E(){return this.D().type===L.TokenType.EOF}}e.$zj=h;class i{static false(){return r.INSTANCE}static true(){return a.INSTANCE}static has(D){return f.create(D)}static equals(D,J){return v.create(D,J)}static notEquals(D,J){return E.create(D,J)}static regex(D,J){return x.create(D,J)}static in(D,J){return C.create(D,J)}static notIn(D,J){return b.create(D,J)}static not(D){return T.create(D)}static and(...D){return V.create(D,null,!0)}static or(...D){return z.create(D,null,!0)}static greater(D,J){return U.create(D,J)}static greaterEquals(D,J){return F.create(D,J)}static smaller(D,J){return K.create(D,J)}static smallerEquals(D,J){return W.create(D,J)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(D){return D==null?void 0:this.c.parse(D)}}e.$Aj=i;function s(B){const D=new h({regexParsingWithErrorRecovery:!1});return B.map(J=>(D.parse(J),D.lexingErrors.length>0?D.lexingErrors.map(q=>({errorMessage:q.additionalInfo?(0,O.localize)(11441,null,q.additionalInfo):(0,O.localize)(11442,null),offset:q.offset,length:q.lexeme.length})):D.parsingErrors.length>0?D.parsingErrors.map(q=>({errorMessage:q.additionalInfo?`${q.message}. ${q.additionalInfo}`:q.message,offset:q.offset,length:q.lexeme.length})):[]))}function t(B,D){const J=B?B.substituteConstants():void 0,q=D?D.substituteConstants():void 0;return!J&&!q?!0:!J||!q?!1:J.equals(q)}function n(B,D){return B.cmp(D)}class r{static{this.INSTANCE=new r}constructor(){this.type=u.False}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return a.INSTANCE}}e.$Dj=r;class a{static{this.INSTANCE=new a}constructor(){this.type=u.True}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return r.INSTANCE}}e.$Ej=a;class f{static create(D,J=null){const q=y.get(D);return typeof q=="boolean"?q?a.INSTANCE:r.INSTANCE:new f(D,J)}constructor(D,J){this.key=D,this.c=J,this.type=u.Defined}cmp(D){return D.type!==this.type?this.type-D.type:ne(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=y.get(this.key);return typeof D=="boolean"?D?a.INSTANCE:r.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.c||(this.c=T.create(this.key,this)),this.c}}e.$Fj=f;class v{static create(D,J,q=null){if(typeof J=="boolean")return J?f.create(D,q):T.create(D,q);const M=y.get(D);return typeof M=="boolean"?J===(M?"true":"false")?a.INSTANCE:r.INSTANCE:new v(D,J,q)}constructor(D,J,q){this.c=D,this.d=J,this.f=q,this.type=u.Equals}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=y.get(this.c);if(typeof D=="boolean"){const J=D?"true":"false";return this.d===J?a.INSTANCE:r.INSTANCE}return this}evaluate(D){return D.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(D){return D.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$Gj=v;class C{static create(D,J){return new C(D,J)}constructor(D,J){this.d=D,this.f=J,this.type=u.In,this.c=null}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.d,this.f,D.d,D.f)}equals(D){return D.type===this.type?this.d===D.d&&this.f===D.f:!1}substituteConstants(){return this}evaluate(D){const J=D.getValue(this.f),q=D.getValue(this.d);return Array.isArray(J)?J.includes(q):typeof q=="string"&&typeof J=="object"&&J!==null?d.call(J,q):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(D){return D.mapIn(this.d,this.f)}negate(){return this.c||(this.c=b.create(this.d,this.f)),this.c}}e.$Hj=C;class b{static create(D,J){return new b(D,J)}constructor(D,J){this.d=D,this.f=J,this.type=u.NotIn,this.c=C.create(D,J)}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(D){return D.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ij=b;class E{static create(D,J,q=null){if(typeof J=="boolean")return J?T.create(D,q):f.create(D,q);const M=y.get(D);return typeof M=="boolean"?J===(M?"true":"false")?r.INSTANCE:a.INSTANCE:new E(D,J,q)}constructor(D,J,q){this.c=D,this.d=J,this.f=q,this.type=u.NotEquals}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=y.get(this.c);if(typeof D=="boolean"){const J=D?"true":"false";return this.d===J?r.INSTANCE:a.INSTANCE}return this}evaluate(D){return D.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(D){return D.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Jj=E;class T{static create(D,J=null){const q=y.get(D);return typeof q=="boolean"?q?r.INSTANCE:a.INSTANCE:new T(D,J)}constructor(D,J){this.c=D,this.d=J,this.type=u.Not}cmp(D){return D.type!==this.type?this.type-D.type:ne(this.c,D.c)}equals(D){return D.type===this.type?this.c===D.c:!1}substituteConstants(){const D=y.get(this.c);return typeof D=="boolean"?D?r.INSTANCE:a.INSTANCE:this}evaluate(D){return!D.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(D){return D.mapNot(this.c)}negate(){return this.d||(this.d=f.create(this.c,this)),this.d}}e.$Kj=T;function j(B,D){if(typeof B=="string"){const J=parseFloat(B);isNaN(J)||(B=J)}return typeof B=="string"||typeof B=="number"?D(B):r.INSTANCE}class U{static create(D,J,q=null){return j(J,M=>new U(D,M,q))}constructor(D,J,q){this.c=D,this.d=J,this.f=q,this.type=u.Greater}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Lj=U;class F{static create(D,J,q=null){return j(J,M=>new F(D,M,q))}constructor(D,J,q){this.c=D,this.d=J,this.f=q,this.type=u.GreaterEquals}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$Mj=F;class K{static create(D,J,q=null){return j(J,M=>new K(D,M,q))}constructor(D,J,q){this.c=D,this.d=J,this.f=q,this.type=u.Smaller}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Nj=K;class W{static create(D,J,q=null){return j(J,M=>new W(D,M,q))}constructor(D,J,q){this.c=D,this.d=J,this.f=q,this.type=u.SmallerEquals}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Oj=W;class x{static create(D,J){return new x(D,J)}constructor(D,J){this.d=D,this.f=J,this.type=u.Regex,this.c=null}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.d<D.d)return-1;if(this.d>D.d)return 1;const J=this.f?this.f.source:"",q=D.f?D.f.source:"";return J<q?-1:J>q?1:0}equals(D){if(D.type===this.type){const J=this.f?this.f.source:"",q=D.f?D.f.source:"";return this.d===D.d&&J===q}return!1}substituteConstants(){return this}evaluate(D){const J=D.getValue(this.d);return this.f?this.f.test(J):!1}serialize(){const D=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${D}`}keys(){return[this.d]}map(D){return D.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=G.create(this)),this.c}}e.$Pj=x;class G{static create(D){return new G(D)}constructor(D){this.c=D,this.type=u.NotRegex}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(D){return new G(this.c.map(D))}negate(){return this.c}}e.$Qj=G;function ie(B){let D=null;for(let J=0,q=B.length;J<q;J++){const M=B[J].substituteConstants();if(B[J]!==M&&D===null){D=[];for(let Z=0;Z<J;Z++)D[Z]=B[Z]}D!==null&&(D[J]=M)}return D===null?B:D}class V{static create(D,J,q){return V.d(D,J,q)}constructor(D,J){this.expr=D,this.c=J,this.type=u.And}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let J=0,q=this.expr.length;J<q;J++){const M=n(this.expr[J],D.expr[J]);if(M!==0)return M}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let J=0,q=this.expr.length;J<q;J++)if(!this.expr[J].equals(D.expr[J]))return!1;return!0}return!1}substituteConstants(){const D=ie(this.expr);return D===this.expr?this:V.create(D,this.c,!1)}evaluate(D){for(let J=0,q=this.expr.length;J<q;J++)if(!this.expr[J].evaluate(D))return!1;return!0}static d(D,J,q){const M=[];let Z=!1;for(const ee of D)if(ee){if(ee.type===u.True){Z=!0;continue}if(ee.type===u.False)return r.INSTANCE;if(ee.type===u.And){M.push(...ee.expr);continue}M.push(ee)}if(M.length===0&&Z)return a.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(n);for(let ee=1;ee<M.length;ee++)M[ee-1].equals(M[ee])&&(M.splice(ee,1),ee--);if(M.length===1)return M[0];for(;M.length>1;){const ee=M[M.length-1];if(ee.type!==u.Or)break;M.pop();const X=M.pop(),re=M.length===0,le=z.create(ee.expr.map(ge=>V.create([ge,X],null,q)),null,re);le&&(M.push(le),M.sort(n))}if(M.length===1)return M[0];if(q){for(let ee=0;ee<M.length;ee++)for(let X=ee+1;X<M.length;X++)if(M[ee].negate().equals(M[X]))return r.INSTANCE;if(M.length===1)return M[0]}return new V(M,J)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(const J of this.expr)D.push(...J.keys());return D}map(D){return new V(this.expr.map(J=>J.map(D)),null)}negate(){if(!this.c){const D=[];for(const J of this.expr)D.push(J.negate());this.c=z.create(D,this,!0)}return this.c}}e.$Rj=V;class z{static create(D,J,q){return z.d(D,J,q)}constructor(D,J){this.expr=D,this.c=J,this.type=u.Or}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let J=0,q=this.expr.length;J<q;J++){const M=n(this.expr[J],D.expr[J]);if(M!==0)return M}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let J=0,q=this.expr.length;J<q;J++)if(!this.expr[J].equals(D.expr[J]))return!1;return!0}return!1}substituteConstants(){const D=ie(this.expr);return D===this.expr?this:z.create(D,this.c,!1)}evaluate(D){for(let J=0,q=this.expr.length;J<q;J++)if(this.expr[J].evaluate(D))return!0;return!1}static d(D,J,q){let M=[],Z=!1;if(D){for(let ee=0,X=D.length;ee<X;ee++){const re=D[ee];if(re){if(re.type===u.False){Z=!0;continue}if(re.type===u.True)return a.INSTANCE;if(re.type===u.Or){M=M.concat(re.expr);continue}M.push(re)}}if(M.length===0&&Z)return r.INSTANCE;M.sort(n)}if(M.length!==0){if(M.length===1)return M[0];for(let ee=1;ee<M.length;ee++)M[ee-1].equals(M[ee])&&(M.splice(ee,1),ee--);if(M.length===1)return M[0];if(q){for(let ee=0;ee<M.length;ee++)for(let X=ee+1;X<M.length;X++)if(M[ee].negate().equals(M[X]))return a.INSTANCE;if(M.length===1)return M[0]}return new z(M,J)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(const J of this.expr)D.push(...J.keys());return D}map(D){return new z(this.expr.map(J=>J.map(D)),null)}negate(){if(!this.c){const D=[];for(const J of this.expr)D.push(J.negate());for(;D.length>1;){const J=D.shift(),q=D.shift(),M=[];for(const Z of H(J))for(const ee of H(q))M.push(V.create([Z,ee],null,!1));D.unshift(z.create(M,null,!1))}this.c=z.create(D,this,!0)}return this.c}}e.$Sj=z;class _ extends f{static{this.d=[]}static all(){return _.d.values()}constructor(D,J,q){super(D,null),this.f=J,typeof q=="object"?_.d.push({...q,key:D}):q!==!0&&_.d.push({key:D,description:q,type:J!=null?typeof J:void 0})}bindTo(D){return D.createKey(this.key,this.f)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return v.create(this.key,D)}notEqualsTo(D){return E.create(this.key,D)}}e.$Tj=_,e.$Uj=(0,N.$Ci)("contextKeyService");function ne(B,D){return B<D?-1:B>D?1:0}function ce(B,D,J,q){return B<J?-1:B>J?1:D<q?-1:D>q?1:0}function te(B,D){if(B.type===u.False||D.type===u.True)return!0;if(B.type===u.Or)return D.type===u.Or?Y(B.expr,D.expr):!1;if(D.type===u.Or){for(const J of D.expr)if(te(B,J))return!0;return!1}if(B.type===u.And){if(D.type===u.And)return Y(D.expr,B.expr);for(const J of B.expr)if(te(J,D))return!0;return!1}return B.equals(D)}function Y(B,D){let J=0,q=0;for(;J<B.length&&q<D.length;){const M=B[J].cmp(D[q]);if(M<0)return!1;M===0&&J++,q++}return J===B.length}function H(B){return B.type===u.Or?B.expr:[B]}}),define(he[97],ue([0,1,4]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rm=e.$Pm=e.ID=void 0,e.$Qm=c,e.ID="diagnosticsService",e.$Pm=(0,I.$Ci)(e.ID);function c(L){return!!L.hostName&&!!L.errorMessage}class A{async getPerformanceInfo(N,O){return{}}async getSystemInfo(N,O){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(N,O){return""}async getWorkspaceFileExtensions(N){return{extensions:[]}}async reportWorkspaceStats(N){}}e.$Rm=A}),define(he[98],ue([0,1,4]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=void 0,e.$Xo=(0,I.$Ci)("downloadService")}),define(he[15],ue([0,1,4]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=void 0,e.$Ji=(0,I.$Ci)("environmentService"),e.$Ki=(0,I.$Di)(e.$Ji)}),define(he[74],ue([0,1,4]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I6b=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.$H6b=A;var c;(function(N){N[N.FILE=1]="FILE",N[N.WORKSPACE=2]="WORKSPACE",N[N.EXE=3]="EXE"})(c||(e.RecommendationSource=c={}));function A(N){switch(N){case c.FILE:return"file";case c.WORKSPACE:return"workspace";case c.EXE:return"exe"}}var L;(function(N){N.Ignored="ignored",N.Cancelled="cancelled",N.TooMany="toomany",N.IncompatibleWindow="incompatibleWindow",N.Accepted="reacted"})(L||(e.RecommendationsNotificationResult=L={})),e.$I6b=(0,I.$Ci)("IExtensionRecommendationNotificationService")}),define(he[7],ue([0,1,51,13,26,12,9,11,4,5,22,53]),function(oe,e,I,c,A,L,N,O,k,y,R,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.$Bl=e.FileKind=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.FileOperationResult=e.$tl=e.$sl=e.$rl=e.$pl=e.FileChangeType=e.$ol=e.FileOperation=e.$il=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$9k=void 0,e.$0k=u,e.$$k=S,e.$_k=w,e.$al=P,e.$bl=m,e.$cl=o,e.$dl=h,e.$el=i,e.$fl=s,e.$gl=t,e.$hl=n,e.$jl=f,e.$kl=v,e.$ll=C,e.$ml=b,e.$nl=E,e.$ql=K,e.$Cl=z,e.$Dl=_,e.$Fl=ce,e.$9k=(0,k.$Ci)("fileService");function u(te){return te.create===!0}var $;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})($||(e.FileType=$={}));var l;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(l||(e.FilePermission=l={}));var p;(function(te){te[te.UPDATED=2]="UPDATED",te[te.ADDED=4]="ADDED",te[te.DELETED=8]="DELETED"})(p||(e.FileChangeFilter=p={}));function S(te){const Y=te;return!!Y&&typeof Y.onDidChange=="function"}var g;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function w(te){return!!(te.capabilities&g.FileReadWrite)}function P(te){return!!(te.capabilities&g.FileFolderCopy)}function m(te){return!!(te.capabilities&g.FileClone)}function o(te){return!!(te.capabilities&g.FileOpenReadWriteClose)}function h(te){return!!(te.capabilities&g.FileReadStream)}function i(te){return w(te)?!!(te.capabilities&g.FileAtomicRead):!1}function s(te){return w(te)?!!(te.capabilities&g.FileAtomicWrite):!1}function t(te){return!!(te.capabilities&g.FileAtomicDelete)}function n(te){return!!(te.capabilities&g.Readonly)}var r;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class a extends Error{static create(Y,H){const B=new a(Y.toString(),H);return C(B,H),B}constructor(Y,H){super(Y),this.code=H}}e.$il=a;function f(te,Y){return a.create(te,Y)}function v(te){return te||f((0,O.localize)(11219,null),r.Unknown)}function C(te,Y){return te.name=Y?`${Y} (FileSystemError)`:"FileSystemError",te}function b(te){if(!te)return r.Unknown;if(te instanceof a)return te.code;const Y=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!Y)return r.Unknown;switch(Y[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}function E(te){if(te instanceof W)return te.fileOperationResult;switch(b(te)){case r.FileNotFound:return ie.FILE_NOT_FOUND;case r.FileIsADirectory:return ie.FILE_IS_DIRECTORY;case r.FileNotADirectory:return ie.FILE_NOT_DIRECTORY;case r.FileWriteLocked:return ie.FILE_WRITE_LOCKED;case r.NoPermissions:return ie.FILE_PERMISSION_DENIED;case r.FileExists:return ie.FILE_MOVE_CONFLICT;case r.FileTooLarge:return ie.FILE_TOO_LARGE;default:return ie.FILE_OTHER_ERROR}}var T;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(T||(e.FileOperation=T={}));class j{constructor(Y,H,B){this.resource=Y,this.operation=H,this.target=B}isOperation(Y){return this.operation===Y}}e.$ol=j;var U;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(U||(e.FileChangeType=U={}));class F{static{this.a=null}constructor(Y,H){this.c=H,this.b=void 0,this.d=new d.$T(()=>{const B=I.$Ii.forUris(()=>this.c);return B.fill(this.rawAdded.map(D=>[D,!0])),B}),this.f=new d.$T(()=>{const B=I.$Ii.forUris(()=>this.c);return B.fill(this.rawUpdated.map(D=>[D,!0])),B}),this.g=new d.$T(()=>{const B=I.$Ii.forUris(()=>this.c);return B.fill(this.rawDeleted.map(D=>[D,!0])),B}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const B of Y){switch(B.type){case U.ADDED:this.rawAdded.push(B.resource);break;case U.UPDATED:this.rawUpdated.push(B.resource);break;case U.DELETED:this.rawDeleted.push(B.resource);break}this.b!==F.a&&(typeof B.cId=="number"?this.b===void 0?this.b=B.cId:this.b!==B.cId&&(this.b=F.a):this.b!==void 0&&(this.b=F.a))}}contains(Y,...H){return this.h(Y,{includeChildren:!1},...H)}affects(Y,...H){return this.h(Y,{includeChildren:!0},...H)}h(Y,H,...B){if(!Y)return!1;const D=B.length>0;return!!((!D||B.includes(U.ADDED))&&(this.d.value.get(Y)||H.includeChildren&&this.d.value.findSuperstr(Y))||(!D||B.includes(U.UPDATED))&&(this.f.value.get(Y)||H.includeChildren&&this.f.value.findSuperstr(Y))||(!D||B.includes(U.DELETED))&&(this.g.value.findSubstr(Y)||H.includeChildren&&this.g.value.findSuperstr(Y)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Y){return this.b===Y}hasCorrelation(){return typeof this.b=="number"}}e.$pl=F;function K(te,Y,H){return!te||!Y||te===Y||Y.length>te.length?!1:(Y.charAt(Y.length-1)!==c.sep&&(Y+=c.sep),H?(0,A.$Ef)(te,Y):te.indexOf(Y)===0)}class W extends Error{constructor(Y,H,B){super(Y),this.fileOperationResult=H,this.options=B}}e.$rl=W;class x extends W{constructor(Y,H,B,D){super(Y,H,D),this.fileOperationResult=H,this.size=B}}e.$sl=x;class G extends W{constructor(Y,H,B){super(Y,ie.FILE_NOT_MODIFIED_SINCE,B),this.stat=H}}e.$tl=G;var ie;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ie||(e.FileOperationResult=ie={})),e.$ul={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$vl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$wl="files.associations",e.$xl="files.exclude",e.$yl="files.readonlyInclude",e.$zl="files.readonlyExclude",e.$Al="files.readonlyFromPermissions";var V;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(V||(e.FileKind=V={})),e.$Bl="";function z(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}async function _(te,Y){if(!Y.hasProvider(N.URI.from({scheme:te.scheme})))return new Promise(H=>{const B=Y.onDidChangeFileSystemProviderRegistrations(D=>{D.scheme===te.scheme&&D.added&&(B.dispose(),H())})})}class ne{static{this.KB=1024}static{this.MB=ne.KB*ne.KB}static{this.GB=ne.MB*ne.KB}static{this.TB=ne.GB*ne.KB}static formatSize(Y){return(0,L.$gg)(Y)||(Y=0),Y<ne.KB?(0,O.localize)(11220,null,Y.toFixed(0)):Y<ne.MB?(0,O.localize)(11221,null,(Y/ne.KB).toFixed(2)):Y<ne.GB?(0,O.localize)(11222,null,(Y/ne.MB).toFixed(2)):Y<ne.TB?(0,O.localize)(11223,null,(Y/ne.GB).toFixed(2)):(0,O.localize)(11224,null,(Y/ne.TB).toFixed(2))}}e.$El=ne;function ce(te){const Y=typeof te=="string"||te?.scheme===R.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===R.Schemas.file?1024*ne.MB:Y?10*ne.MB:y.$p?50*ne.MB:1024*ne.MB}});var Q=this&&this.__param||function(oe,e){return function(I,c){e(I,c,oe)}};define(he[162],ue([0,1,75,50,7]),function(oe,e,I,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jhc=void 0;let L=class{constructor(O){this.a=O}async checksum(O){const k=(await this.a.readFileStream(O)).value;return new Promise((y,R)=>{const d=(0,I.createHash)("sha256");(0,c.$De)(k,{onData:u=>d.update(u.buffer),onError:u=>R(u),onEnd:()=>y(d.digest("base64").replace(/=+$/,""))})})}};e.$jhc=L,e.$jhc=L=ve([Q(0,A.$9k)],L)}),define(he[99],ue([0,1,14,8,11,7]),function(oe,e,I,c,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=N;async function N(R,d,u,$,l,p){let S;try{await O(R,d,u,$,l,p)}catch(g){S=g}finally{S&&l.errorTransformer&&(S=l.errorTransformer(S)),typeof S<"u"&&u.error(S),u.end()}}async function O(R,d,u,$,l,p){k(p);const S=await R.open(d,{create:!1});try{k(p);let g=0,w=0,P=l&&typeof l.length=="number"?l.length:void 0,m=I.$Le.alloc(Math.min(l.bufferSize,typeof P=="number"?P:l.bufferSize)),o=l&&typeof l.position=="number"?l.position:0,h=0;do w=await R.read(S,o,m.buffer,h,m.byteLength-h),o+=w,h+=w,g+=w,typeof P=="number"&&(P-=w),h===m.byteLength&&(await u.write($(m)),m=I.$Le.alloc(Math.min(l.bufferSize,typeof P=="number"?P:l.bufferSize)),h=0);while(w>0&&(typeof P!="number"||P>0)&&k(p)&&y(g,l));if(h>0){let i=h;typeof P=="number"&&(i=Math.min(h,P)),u.write($(m.slice(0,i)))}}catch(g){throw(0,L.$kl)(g)}finally{await R.close(S)}}function k(R){if(R.isCancellationRequested)throw(0,c.$5)();return!0}function y(R,d){if(typeof d?.limits?.size=="number"&&R>d.limits.size)throw(0,L.$jl)((0,A.localize)(11218,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(he[46],ue([0,1,93,2,13,5,9,7]),function(oe,e,I,c,A,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=e.$3q=e.$2q=void 0,e.$Zq=k,e.$1q=y,e.$5q=$,e.$6q=l,e.$7q=p,e.$8q=S,e.$9q=w,e.$0q=P;function k(m){return typeof m.correlationId=="number"}function y(m){return m.recursive===!0}class R extends c.$Tc{static{this.a=5}constructor(o,h,i,s){super(),this.h=o,this.j=h,this.m=i,this.n=s,this.c=this.B(new c.$Uc),this.f=void 0,this.g=0}s(){const o=new c.$Sc;this.c.value=o,this.b=this.r(o),this.b.setVerboseLogging(this.m),o.add(this.b.onDidChangeFile(h=>this.h(h))),o.add(this.b.onDidLogMessage(h=>this.j(h))),o.add(this.b.onDidError(h=>this.t(h.error,h.request)))}t(o,h){this.u(o,h)?this.g<R.a&&this.f?(this.y(`restarting watcher after unexpected error: ${o}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${o}`):this.y(o)}u(o,h){return!(!this.n.restartOnError||h||o.indexOf("No space left on device")!==-1||o.indexOf("EMFILE")!==-1)}w(o){this.g++,this.s(),this.watch(o)}async watch(o){this.f=o,await this.b?.watch(o)}async setVerboseLogging(o){this.m=o,await this.b?.setVerboseLogging(o)}y(o){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${o}`})}z(o){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${o}`})}dispose(){return this.b=void 0,super.dispose()}}e.$2q=R;class d extends R{constructor(o,h,i){super(o,h,i,{type:"node.js",restartOnError:!1})}}e.$3q=d;class u extends R{constructor(o,h,i){super(o,h,i,{type:"universal",restartOnError:!0})}}e.$4q=u;function $(m){return m.map(o=>({type:o.type,resource:N.URI.revive(o.resource),cId:o.cId}))}function l(m){const o=new g;for(const h of m)o.processEvent(h);return o.coalesce()}function p(m,o){return typeof o=="string"&&!o.startsWith(I.$sk)&&!(0,A.$hc)(o)?{base:m,pattern:o}:o}function S(m,o){const h=[];for(const i of o)h.push((0,I.$wk)(p(m,i)));return h}class g{constructor(){this.a=new Set,this.b=new Map}c(o){return L.$l?o.resource.fsPath:o.resource.fsPath.toLowerCase()}processEvent(o){const h=this.b.get(this.c(o));let i=!1;if(h){const s=h.type,t=o.type;h.resource.fsPath!==o.resource.fsPath&&(o.type===O.FileChangeType.DELETED||o.type===O.FileChangeType.ADDED)?i=!0:s===O.FileChangeType.ADDED&&t===O.FileChangeType.DELETED?(this.b.delete(this.c(o)),this.a.delete(h)):s===O.FileChangeType.DELETED&&t===O.FileChangeType.ADDED?h.type=O.FileChangeType.UPDATED:s===O.FileChangeType.ADDED&&t===O.FileChangeType.UPDATED||(h.type=t)}else i=!0;i&&(this.a.add(o),this.b.set(this.c(o),o))}coalesce(){const o=[],h=[];return Array.from(this.a).filter(i=>i.type!==O.FileChangeType.DELETED?(o.push(i),!1):!0).sort((i,s)=>i.resource.fsPath.length-s.resource.fsPath.length).filter(i=>h.some(s=>(0,O.$ql)(i.resource.fsPath,s,!L.$l))?!1:(h.push(i.resource.fsPath),!0)).concat(o)}}function w(m,o){if(typeof o=="number")switch(m.type){case O.FileChangeType.ADDED:return(o&O.FileChangeFilter.ADDED)===0;case O.FileChangeType.DELETED:return(o&O.FileChangeFilter.DELETED)===0;case O.FileChangeType.UPDATED:return(o&O.FileChangeFilter.UPDATED)===0}return!1}function P(m){if(typeof m=="number"){const o=[];return m&O.FileChangeFilter.ADDED&&o.push("Added"),m&O.FileChangeFilter.DELETED&&o.push("Deleted"),m&O.FileChangeFilter.UPDATED&&o.push("Updated"),o.length===0?"<all>":`[${o.join(", ")}]`}return"<none>"}}),define(he[163],ue([0,1,14,43,8,3,2,50,31,7,46]),function(oe,e,I,c,A,L,N,O,k,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Q=e.$9Q=void 0,e.$9Q="localFilesystem";class d extends N.$Tc{constructor($,l){super(),this.a=$,this.b=l,this.onDidChangeCapabilities=L.Event.None,this.f=this.B(new L.$je),this.onDidChangeFile=this.f.event,this.g=this.B(new L.$je),this.onDidWatchError=this.g.event,this.h=(0,k.$Yg)(),this.j()}get capabilities(){return this.c||(this.c=y.FileSystemProviderCapabilities.FileReadWrite|y.FileSystemProviderCapabilities.FileOpenReadWriteClose|y.FileSystemProviderCapabilities.FileReadStream|y.FileSystemProviderCapabilities.FileFolderCopy|y.FileSystemProviderCapabilities.FileWriteUnlock|y.FileSystemProviderCapabilities.FileAtomicRead|y.FileSystemProviderCapabilities.FileAtomicWrite|y.FileSystemProviderCapabilities.FileAtomicDelete|y.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=y.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=y.FileSystemProviderCapabilities.Trash)),this.c}stat($){return this.a.call("stat",[$])}readdir($){return this.a.call("readdir",[$])}async readFile($,l){const{buffer:p}=await this.a.call("readFile",[$,l]);return p}readFileStream($,l,p){const S=(0,O.$ze)(w=>I.$Le.concat(w.map(P=>I.$Le.wrap(P))).buffer),g=new N.$Sc;return g.add(this.a.listen("readFileStream",[$,l])(w=>{if(w instanceof I.$Le)S.write(w.buffer);else{if(w==="end")S.end();else{let P;if(w instanceof Error)P=w;else{const m=w;P=(0,y.$jl)(m.message??(0,c.$nj)(m),m.code??y.FileSystemProviderErrorCode.Unknown)}S.error(P),S.end()}g.dispose()}})),g.add(p.onCancellationRequested(()=>{S.error((0,A.$5)()),S.end(),g.dispose()})),S}writeFile($,l,p){return this.a.call("writeFile",[$,I.$Le.wrap(l),p])}open($,l){return this.a.call("open",[$,l])}close($){return this.a.call("close",[$])}async read($,l,p,S,g){const[w,P]=await this.a.call("read",[$,l,g]);return p.set(w.buffer.slice(0,P),S),P}write($,l,p,S,g){return this.a.call("write",[$,l,I.$Le.wrap(p),S,g])}mkdir($){return this.a.call("mkdir",[$])}delete($,l){return this.a.call("delete",[$,l])}rename($,l,p){return this.a.call("rename",[$,l,p])}copy($,l,p){return this.a.call("copy",[$,l,p])}cloneFile($,l){return this.a.call("cloneFile",[$,l])}j(){this.B(this.a.listen("fileChange",[this.h])($=>{if(Array.isArray($)){const l=$;this.f.fire((0,R.$5q)(l))}else{const l=$;this.g.fire(l)}}))}watch($,l){const p=(0,k.$Yg)();return this.a.call("watch",[this.h,p,$,l]),(0,N.$Rc)(()=>this.a.call("unwatch",[this.h,p]))}}e.$0Q=d}),define(he[164],ue([0,1,32,2,46,3,7,9,6]),function(oe,e,I,c,A,L,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=void 0;class y extends c.$Tc{constructor(){super(),this.a=this.B(new L.$je),this.onDidChangeFile=this.a.event,this.b=this.B(new L.$je),this.onDidLogMessage=this.b.event,this.c=this.B(new L.$je),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new c.$3c),this.m=new Set,this.n=this.B(new k.$Ah(this.y())),this.r=5007,this.s=new k.$Zh,this.R=!1,this.B(this.f(d=>this.t(d)))}t(d){this.u(d)&&this.z(d)}u(d){return(0,A.$Zq)(d)}async watch(d){this.s.isSettled||this.s.complete(),this.s=new k.$Zh;try{this.h.clear(),this.g.clear();for(const u of d)this.u(u)?this.h.set(u.correlationId,u):this.g.add(u);for(const[u]of this.j)this.h.has(u)||(this.j.deleteAndDispose(u),this.m.delete(u));return await this.w(!1)}finally{this.s.complete()}}w(d){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(u=>!this.j.has(u.correlationId))]),d?this.y():0)}y(){return 800}isSuspended(d){return typeof d.correlationId!="number"?!1:this.m.has(d.correlationId)?"polling":this.j.has(d.correlationId)}async z(d){if(this.j.has(d.correlationId))return;const u=new c.$Sc;this.j.set(d.correlationId,u),await this.s.p,!u.isDisposed&&(this.D(d,u),this.w(!0))}C(d){this.j.deleteAndDispose(d.correlationId),this.m.delete(d.correlationId),this.w(!1)}D(d,u){this.F(d,u)?(this.P(`reusing an existing recursive watcher to monitor ${d.path}`),this.m.delete(d.correlationId)):(this.G(d,u),this.m.add(d.correlationId))}F(d,u){const $=this.O?.subscribe(d.path,(l,p)=>{u.isDisposed||(l?this.D(d,u):p?.type===N.FileChangeType.ADDED&&this.H(d))});return $?(u.add($),!0):!1}G(d,u){let $=!1;const l=(p,S)=>{if(u.isDisposed)return;const g=this.I(p),w=this.I(S),P=$;$=g,!g&&(w||P)&&this.H(d)};this.P(`starting fs.watchFile() on ${d.path} (correlationId: ${d.correlationId})`);try{(0,I.watchFile)(d.path,{persistent:!1,interval:this.r},l)}catch(p){this.Q(`fs.watchFile() failed with error ${p} on path ${d.path} (correlationId: ${d.correlationId})`)}u.add((0,c.$Rc)(()=>{this.P(`stopping fs.watchFile() on ${d.path} (correlationId: ${d.correlationId})`);try{(0,I.unwatchFile)(d.path,l)}catch(p){this.Q(`fs.unwatchFile() failed with error ${p} on path ${d.path} (correlationId: ${d.correlationId})`)}}))}H(d){this.P(`detected ${d.path} exists again, resuming watcher (correlationId: ${d.correlationId})`);const u={resource:O.URI.file(d.path),type:N.FileChangeType.ADDED,cId:d.correlationId};this.a.fire([u]),this.J(u,d),this.C(d)}I(d){return d.ctimeMs===0&&d.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(d,u){if(this.R){const $=` >> normalized ${d.type===N.FileChangeType.ADDED?"[ADDED]":d.type===N.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`;this.L($,u)}}L(d,u){this.R&&this.P(`${d}${typeof u.correlationId=="number"?` <${u.correlationId}> `:""}`)}M(d){return`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"}, filter: ${(0,A.$0q)(d.filter)}, correlationId: ${typeof d.correlationId=="number"?d.correlationId:"<none>"})`}async setVerboseLogging(d){this.R=d}}e.$gr=y}),define(he[165],ue([0,1,32,6,25,41,2,90,13,5,20,9,145,30,7,46]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=void 0,e.$mr=g;class S extends N.$Tc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(P,m,o,h,i,s){super(),this.s=P,this.t=m,this.u=o,this.w=h,this.y=i,this.z=s,this.c=this.B(new c.$Rh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.u(t))),this.f=this.B(new c.$Qh(t=>this.M(t),S.b)),this.g=(0,p.$8q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,p.$8q)(this.s.path,this.s.includes):void 0,this.j=(0,p.$Zq)(this.s)?this.s.filter:void 0,this.m=new A.$ue,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const P=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const m=await I.promises.stat(P);if(this.m.token.isCancellationRequested)return;this.B(await this.G(P,m.isDirectory()))}catch(P){P.code!=="ENOENT"?this.O(P):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${P})`),this.D()}}D(){this.r=!0,this.w?.()}async F(P){let m=P.path;try{m=await $.Promises.realpath(P.path),P.path===m&&(m=await(0,u.$ir)(P.path,this.m.token)??P.path),P.path!==m&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${P.path}, real: ${m})`)}catch{}return m}async G(P,m){const o=new N.$Sc;return this.H(P,m,o)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(P,m,o)),o}H(P,m,o){if(m)return!1;const h=d.URI.file(this.s.path),i=this.t?.subscribe(this.s.path,async(s,t)=>{if(!o.isDisposed)if(s){const n=await this.G(P,m);o.isDisposed?n.dispose():o.add(n)}else t&&(typeof t.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:h,type:t.type,cId:this.s.correlationId},!0)});return i?(o.add(i),!0):!1}async I(P,m,o){if(y.$k&&(0,L.$Bg)(P,"/Volumes/",!0)){this.O(`Refusing to watch ${P} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const h=new A.$ue(this.m.token);o.add((0,N.$Rc)(()=>h.dispose(!0)));const i=new N.$Sc;o.add(i);try{const s=d.URI.file(this.s.path),t=(0,k.$mc)(P),n=(0,I.watch)(P);i.add((0,N.$Rc)(()=>{n.removeAllListeners(),n.close()})),this.Q(`Started watching: '${P}'`);const r=new Set;if(m)try{for(const f of await $.Promises.readdir(P))r.add(f)}catch(f){this.O(f)}if(h.token.isCancellationRequested)return;const a=new Map;i.add((0,N.$Rc)(()=>{for(const[,f]of a)f.dispose();a.clear()})),n.on("error",(f,v)=>{h.token.isCancellationRequested||(this.O(`Failed to watch ${P} for changes using fs.watch() (${f}, ${v})`),this.D())}),n.on("change",(f,v)=>{if(h.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${f}"] ${v}`);let C="";if(v&&(C=v.toString(),y.$k&&(C=(0,O.$jm)(C))),!(!C||f!=="change"&&f!=="rename"))if(m)if(f==="rename"){a.get(C)?.dispose();const b=setTimeout(async()=>{if(a.delete(C),C===t&&!await $.Promises.exists(P)){this.J(s);return}if(h.token.isCancellationRequested)return;const E=await this.N((0,k.$ic)(P,C));if(h.token.isCancellationRequested)return;let T;E?r.has(C)?T=l.FileChangeType.UPDATED:(T=l.FileChangeType.ADDED,r.add(C)):(r.delete(C),T=l.FileChangeType.DELETED),this.L({resource:(0,R.$dh)(s,C),type:T,cId:this.s.correlationId})},S.a);a.set(C,(0,N.$Rc)(()=>clearTimeout(b)))}else{let b;r.has(C)?b=l.FileChangeType.UPDATED:(b=l.FileChangeType.ADDED,r.add(C)),this.L({resource:(0,R.$dh)(s,C),type:b,cId:this.s.correlationId})}else if(f==="rename"||C!==t){const b=setTimeout(async()=>{const E=await $.Promises.exists(P);h.token.isCancellationRequested||(E?(this.L({resource:s,type:l.FileChangeType.UPDATED,cId:this.s.correlationId},!0),i.add(await this.G(P,!1))):this.J(s))},S.a);i.clear(),i.add((0,N.$Rc)(()=>clearTimeout(b)))}else this.L({resource:s,type:l.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(s){h.token.isCancellationRequested||this.O(`Failed to watch ${P} for changes using fs.watch() (${s.toString()})`),this.D()}}J(P){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:P,type:l.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(P,m=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${P.type===l.FileChangeType.ADDED?"[ADDED]":P.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${P.resource.fsPath}`),!m&&this.g.some(o=>o(P.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${P.resource.fsPath}`):!m&&this.h&&this.h.length>0&&!this.h.some(o=>o(P.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${P.resource.fsPath}`):this.f.work(P))}M(P){const m=(0,p.$6q)(P),o=[];for(const i of m){if((0,p.$9q)(i,this.j)){this.z&&this.R(` >> ignored (filtered) ${i.resource.fsPath}`);continue}o.push(i)}if(o.length===0)return;if(this.z)for(const i of o)this.R(` >> normalized ${i.type===l.FileChangeType.ADDED?"[ADDED]":i.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`);this.c.work(o)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(P){if(y.$l)return $.Promises.exists(P);try{const m=(0,k.$mc)(P);return(await $.Promises.readdir((0,k.$lc)(P))).some(h=>h===m)}catch(m){return this.Q(m),!1}}setVerboseLogging(P){this.z=P}O(P){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${P}`})}P(P){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${P}`})}Q(P){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${P}`})}R(P){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${P}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$lr=S;async function g(w,P,m,o,h=512){const i=await $.Promises.open(w,"r"),s=Buffer.allocUnsafe(h),t=new A.$ue(o);let n,r=!1;const a={path:w,excludes:[],recursive:!1},f=new S(a,void 0,v=>{(async()=>{for(const{type:C}of v)if(C===l.FileChangeType.UPDATED){if(r)return;r=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:b}=await $.Promises.read(i,s,0,h,null);if(!b||t.token.isCancellationRequested)break;P(s.slice(0,b))}}catch(b){n=new Error(b),t.dispose(!0)}finally{r=!1}}})()});return await f.ready,m(),new Promise((v,C)=>{t.token.onCancellationRequested(async()=>{f.dispose();try{await $.Promises.close(i)}catch(b){n=new Error(b)}n?C(n):v()})})}}),define(he[166],ue([0,1,3,93,164,5,165,41]),function(oe,e,I,c,A,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=void 0;class k extends A.$gr{constructor(R){super(),this.O=R,this.onDidError=I.Event.None,this.watchers=new Set}async N(R){R=this.Z(R);const d=[],u=new Set(Array.from(this.watchers));for(const $ of R){const l=this.W($);l&&(0,c.$Ak)(l.request.excludes,$.excludes)&&(0,c.$Ak)(l.request.includes,$.includes)?u.delete(l):d.push($)}d.length&&this.P(`Request to start watching: ${d.map($=>this.M($)).join(",")}`),u.size&&this.P(`Request to stop watching: ${Array.from(u).map($=>this.M($.request)).join(",")}`);for(const $ of u)this.Y($);for(const $ of d)this.X($)}W(R){for(const d of this.watchers)if(typeof R.correlationId=="number"||typeof d.request.correlationId=="number"){if(d.request.correlationId===R.correlationId)return d}else if((0,O.$Ag)(d.request.path,R.path,!L.$l))return d}X(R){const d=new N.$lr(R,this.O,$=>this.a.fire($),()=>this.c.fire(R),$=>this.b.fire($),this.R),u={request:R,instance:d};this.watchers.add(u)}async stop(){await super.stop();for(const R of this.watchers)this.Y(R)}Y(R){this.P("stopping file watcher",R),this.watchers.delete(R),R.instance.dispose()}Z(R){const d=new Map;for(const u of R){const $=L.$l?u.path:u.path.toLowerCase();let l=d.get(u.correlationId);l||(l=new Map,d.set(u.correlationId,l)),l.has($)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(u)}`),l.set($,u)}return Array.from(d.values()).map(u=>Array.from(u.values())).flat()}async setVerboseLogging(R){super.setVerboseLogging(R);for(const d of this.watchers)d.instance.setVerboseLogging(R)}P(R,d){this.R&&this.b.fire({type:"trace",message:this.bb(R,d)})}Q(R){this.b.fire({type:"warn",message:this.bb(R)})}bb(R,d){return d?`[File Watcher (node.js)] ${R} (${this.M(d.request)})`:`[File Watcher (node.js)] ${R}`}}e.$nr=k}),define(he[167],ue([0,1,46,166]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;class A extends I.$3q{constructor(N,O,k){super(N,O,k),this.s()}r(N){return N.add(new c.$nr(void 0))}}e.$or=A}),define(he[168],ue([0,1,22,42,95,46]),function(oe,e,I,c,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=void 0;class N extends L.$4q{constructor(k,y,R){super(k,y,R),this.s()}r(k){const y=k.add(new A.$er(I.$Wg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return k.add(y.onDidProcessExit(({code:R,signal:d})=>this.t(`terminated by itself with code ${R}, signal: ${d} (ETERM)`))),c.ProxyChannel.toService((0,c.$ji)(y.getChannel("watcher")))}}e.$fr=N}),define(he[76],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=void 0;class I{constructor(...A){this.a=new Map;for(const[L,N]of A)this.set(L,N)}set(A,L){const N=this.a.get(A);return this.a.set(A,L),N}has(A){return this.a.has(A)}get(A){return this.a.get(A)}}e.$Ai=I}),define(he[169],ue([0,1,6,8,2,73,160,4,76,89]),function(oe,e,I,c,A,L,N,O,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=e.$sr=void 0;const R=!1;class d extends Error{constructor(S){super("cyclic dependency between services"),this.message=S.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${S.toString()}`}}class u{constructor(S=new k.$Ai,g=!1,w,P=R){this.i=S,this.j=g,this.k=w,this.l=P,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(O.$Bi,this),this._globalGraph=P?w?._globalGraph??new N.$rr(m=>m):void 0}dispose(){if(!this.f){this.f=!0,(0,A.$Oc)(this.h),this.h.clear();for(const S of this.g)(0,A.$Nc)(S)&&S.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(S,g){this.m();const w=this,P=new class extends u{dispose(){w.h.delete(P),super.dispose()}}(S,this.j,this,this.l);return this.h.add(P),g?.add(P),P}invokeFunction(S,...g){this.m();const w=l.traceInvocation(this.l,S);let P=!1;try{return S({get:o=>{if(P)throw(0,c.$7)("service accessor is only valid during the invocation of its target method");const h=this.s(o,w);if(!h)throw new Error(`[invokeFunction] unknown service '${o}'`);return h}},...g)}finally{P=!0,w.stop()}}createInstance(S,...g){this.m();let w,P;return S instanceof L.$zi?(w=l.traceCreation(this.l,S.ctor),P=this.o(S.ctor,S.staticArguments.concat(g),w)):(w=l.traceCreation(this.l,S),P=this.o(S,g,w)),w.stop(),P}o(S,g=[],w){const P=O._util.getServiceDependencies(S).sort((h,i)=>h.index-i.index),m=[];for(const h of P){const i=this.s(h.id,w);i||this.y(`[createInstance] ${S.name} depends on UNKNOWN service ${h.id}.`,!1),m.push(i)}const o=P.length>0?P[0].index:g.length;if(g.length!==o){console.trace(`[createInstance] First service dependency of ${S.name} at position ${o+1} conflicts with ${g.length} static arguments`);const h=o-g.length;h>0?g=g.concat(new Array(h)):g=g.slice(0,o)}return Reflect.construct(S,g.concat(m))}q(S,g){if(this.i.get(S)instanceof L.$zi)this.i.set(S,g);else if(this.k)this.k.q(S,g);else throw new Error("illegalState - setting UNKNOWN service instance")}r(S){const g=this.i.get(S);return!g&&this.k?this.k.r(S):g}s(S,g){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(S));const w=this.r(S);return w instanceof L.$zi?this.u(S,w,g.branch(S,!0)):(g.branch(S,!1),w)}u(S,g,w){if(this.t.has(S))throw new Error(`illegal state - RECURSIVELY instantiating service '${S}'`);this.t.add(S);try{return this.v(S,g,w)}finally{this.t.delete(S)}}v(S,g,w){const P=new N.$rr(i=>i.id.toString());let m=0;const o=[{id:S,desc:g,_trace:w}],h=new Set;for(;o.length;){const i=o.pop();if(!h.has(String(i.id))){if(h.add(String(i.id)),P.lookupOrInsertNode(i),m++>1e3)throw new d(P);for(const s of O._util.getServiceDependencies(i.desc.ctor)){const t=this.r(s.id);if(t||this.y(`[createInstance] ${S} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(s.id)),t instanceof L.$zi){const n={id:s.id,desc:t,_trace:i._trace.branch(s.id,!0)};P.insertEdge(i,n),o.push(n)}}}}for(;;){const i=P.roots();if(i.length===0){if(!P.isEmpty())throw new d(P);break}for(const{data:s}of i){if(this.r(s.id)instanceof L.$zi){const n=this.w(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.q(s.id,n)}P.removeNode(s)}}return this.r(S)}w(S,g,w=[],P,m){if(this.i.get(S)instanceof L.$zi)return this.x(S,g,w,P,m,this.g);if(this.k)return this.k.w(S,g,w,P,m);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}x(S,g,w=[],P,m,o){if(P){const h=new u(void 0,this.j,this,this.l);h.c=String(S);const i=new Map,s=new I.$Vh(()=>{const t=h.o(g,w,m);for(const[n,r]of i){const a=t[n];if(typeof a=="function")for(const f of r)f.disposable=a.apply(t,f.listener)}return i.clear(),o.add(t),t});return new Proxy(Object.create(null),{get(t,n){if(!s.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let f=i.get(n);return f||(f=new y.$4c,i.set(n,f)),(C,b,E)=>{if(s.isInitialized)return s.value[n](C,b,E);{const T={listener:[C,b,E],disposable:void 0},j=f.push(T);return(0,A.$Rc)(()=>{j(),T.disposable?.dispose()})}}}if(n in t)return t[n];const r=s.value;let a=r[n];return typeof a!="function"||(a=a.bind(r),t[n]=a),a},set(t,n,r){return s.value[n]=r,!0},getPrototypeOf(t){return g.prototype}})}else{const h=this.o(g,w,m);return o.add(h),h}}y(S,g){if(g&&console.warn(S),this.j)throw new Error(S)}}e.$sr=u;var $;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})($||($={}));class l{static{this.all=new Set}static{this.c=new class extends l{constructor(){super($.None,null)}stop(){}branch(){return this}}}static traceInvocation(S,g){return S?new l($.Invocation,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):l.c}static traceCreation(S,g){return S?new l($.Creation,g.name):l.c}static{this.f=0}constructor(S,g){this.type=S,this.name=g,this.g=Date.now(),this.h=[]}branch(S,g){const w=new l($.Branch,S.toString());return this.h.push([S,g,w]),w}stop(){const S=Date.now()-this.g;l.f+=S;let g=!1;function w(m,o){const h=[],i=new Array(m+1).join("	");for(const[s,t,n]of o.h)if(t&&n){g=!0,h.push(`${i}CREATES -> ${s}`);const r=w(m+1,n);r&&h.push(r)}else h.push(`${i}uses -> ${s}`);return h.join(`
`)}const P=[`${this.type===$.Creation?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${S.toFixed(2)}ms (grand total ${l.f.toFixed(2)}ms)`];(S>2||g)&&l.all.add(P.join(`
`))}}e.$tr=l}),define(he[56],ue([0,1,4]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgc=e.$Ygc=void 0,e.$Ygc=(0,I.$Ci)("mainProcessService");class c{constructor(L,N){this.a=L,this.b=N}getChannel(L){return this.a.getChannel(L,this.b)}registerChannel(L,N){this.a.registerChannel(L,N)}}e.$Zgc=c}),define(he[10],ue([0,1,11,43,3,55,2,36,5,20,12,9,96,4]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$_j=e.LogLevel=e.$0j=e.$9j=void 0,e.$$j=p,e.log=g,e.$kk=a,e.$lk=f,e.$mk=v,e.$nk=C,I=ke(I),e.$9j=(0,$.$Ci)("logService"),e.$0j=(0,$.$Ci)("loggerService");function l(){return new Date().toISOString()}function p(b){return(0,R.$gg)(b)}var S;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(S||(e.LogLevel=S={})),e.$_j=S.Info;function g(b,E,T){switch(E){case S.Trace:b.trace(T);break;case S.Debug:b.debug(T);break;case S.Info:b.info(T);break;case S.Warning:b.warn(T);break;case S.Error:b.error(T);break;case S.Off:break;default:throw new Error(`Invalid log level ${E}`)}}function w(b,E=!1){let T="";for(let j=0;j<b.length;j++){let U=b[j];if(U instanceof Error&&(U=(0,c.$nj)(U,E)),typeof U=="object")try{U=JSON.stringify(U)}catch{}T+=(j>0?" ":"")+U}return T}class P extends N.$Tc{constructor(){super(...arguments),this.b=e.$_j,this.c=this.B(new A.$je),this.onDidChangeLogLevel=this.c.event}setLevel(E){this.b!==E&&(this.b=E,this.c.fire(this.b))}getLevel(){return this.b}f(E){return this.b!==S.Off&&this.b<=E}}e.$bk=P;class m extends P{constructor(E){super(),this.h=E}f(E){return this.h||super.f(E)}trace(E,...T){this.f(S.Trace)&&this.g(S.Trace,w([E,...T],!0))}debug(E,...T){this.f(S.Debug)&&this.g(S.Debug,w([E,...T]))}info(E,...T){this.f(S.Info)&&this.g(S.Info,w([E,...T]))}warn(E,...T){this.f(S.Warning)&&this.g(S.Warning,w([E,...T]))}error(E,...T){if(this.f(S.Error))if(E instanceof Error){const j=Array.prototype.slice.call(arguments);j[0]=E.stack,this.g(S.Error,w(j))}else this.g(S.Error,w([E,...T]))}flush(){}}e.$ck=m;class o extends P{constructor(E=e.$_j){super(),this.setLevel(E),this.g=!k.$j}trace(E,...T){this.f(S.Trace)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,E,...T):console.log(`[main ${l()}]`,E,...T))}debug(E,...T){this.f(S.Debug)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,E,...T):console.log(`[main ${l()}]`,E,...T))}info(E,...T){this.f(S.Info)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,E,...T):console.log(`[main ${l()}]`,E,...T))}warn(E,...T){this.f(S.Warning)&&(this.g?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,E,...T):console.warn(`[main ${l()}]`,E,...T))}error(E,...T){this.f(S.Error)&&(this.g?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,E,...T):console.error(`[main ${l()}]`,E,...T))}flush(){}}e.$dk=o;class h extends P{constructor(E=e.$_j,T=!0){super(),this.g=T,this.setLevel(E)}trace(E,...T){this.f(S.Trace)&&(this.g?console.log("%cTRACE","color: #888",E,...T):console.log(E,...T))}debug(E,...T){this.f(S.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",E,...T):console.log(E,...T))}info(E,...T){this.f(S.Info)&&(this.g?console.log("%c INFO","color: #33f",E,...T):console.log(E,...T))}warn(E,...T){this.f(S.Warning)&&(this.g?console.log("%c WARN","color: #993",E,...T):console.log(E,...T))}error(E,...T){this.f(S.Error)&&(this.g?console.log("%c  ERR","color: #f33",E,...T):console.error(E,...T))}flush(){}}e.$ek=h;class i extends P{constructor(E,T=e.$_j){super(),this.g=E,this.setLevel(T)}trace(E,...T){this.f(S.Trace)&&this.g.log(S.Trace,[this.h(E),...T])}debug(E,...T){this.f(S.Debug)&&this.g.log(S.Debug,[this.h(E),...T])}info(E,...T){this.f(S.Info)&&this.g.log(S.Info,[this.h(E),...T])}warn(E,...T){this.f(S.Warning)&&this.g.log(S.Warning,[this.h(E),...T])}error(E,...T){this.f(S.Error)&&this.g.log(S.Error,[this.h(E),...T])}h(E){return typeof E=="string"?E:(0,c.$nj)(E,this.f(S.Trace))}flush(){}}e.$fk=i;class s extends P{constructor(E){super(),this.g=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const T of this.g)T.setLevel(E);super.setLevel(E)}trace(E,...T){for(const j of this.g)j.trace(E,...T)}debug(E,...T){for(const j of this.g)j.debug(E,...T)}info(E,...T){for(const j of this.g)j.info(E,...T)}warn(E,...T){for(const j of this.g)j.warn(E,...T)}error(E,...T){for(const j of this.g)j.error(E,...T)}flush(){for(const E of this.g)E.flush()}dispose(){for(const E of this.g)E.dispose();super.dispose()}}e.$gk=s;class t extends N.$Tc{constructor(E,T,j){if(super(),this.h=E,this.j=T,this.b=new O.$zc,this.c=this.B(new A.$je),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.$je),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.$je),this.onDidChangeVisibility=this.g.event,j)for(const U of j)this.b.set(U.resource,{logger:void 0,info:U})}m(E){return(0,R.$cg)(E)?[...this.b.values()].find(T=>T.info.id===E):this.b.get(E)}getLogger(E){return this.m(E)?.logger}createLogger(E,T){const j=this.n(E),U=(0,R.$cg)(E)?E:T?.id??(0,L.$qj)(j.toString()).toString(16);let F=this.b.get(j)?.logger;const K=T?.logLevel==="always"?S.Trace:T?.logLevel;F||(F=this.s(j,K??this.getLogLevel(j)??this.h,{...T,id:U}));const W={logger:F,info:{resource:j,id:U,logLevel:K,name:T?.name,hidden:T?.hidden,extensionId:T?.extensionId,when:T?.when}};return this.registerLogger(W.info),this.b.set(j,W),F}n(E){return(0,R.$cg)(E)?(0,y.$dh)(this.j,`${E}.log`):E}setLogLevel(E,T){if(d.URI.isUri(E)){const j=E,U=T,F=this.b.get(j);F&&U!==F.info.logLevel&&(F.info.logLevel=U===this.h?void 0:U,F.logger?.setLevel(U),this.b.set(F.info.resource,F),this.f.fire([j,U]))}else{this.h=E;for(const[j,U]of this.b.entries())this.b.get(j)?.info.logLevel===void 0&&U.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(E,T){const j=this.m(E);j&&T!==!j.info.hidden&&(j.info.hidden=!T,this.b.set(j.info.resource,j),this.g.fire([j.info.resource,T]))}getLogLevel(E){let T;return E&&(T=this.b.get(E)?.info.logLevel),T??this.h}registerLogger(E){const T=this.b.get(E.resource);T?T.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this.b.set(E.resource,{info:E,logger:void 0}),this.c.fire({added:[E],removed:[]}))}deregisterLogger(E){const T=this.b.get(E);T&&(T.logger&&T.logger.dispose(),this.b.delete(E),this.c.fire({added:[],removed:[T.info]}))}*getRegisteredLoggers(){for(const E of this.b.values())yield E.info}getRegisteredLogger(E){return this.b.get(E)?.info}dispose(){this.b.forEach(E=>E.logger?.dispose()),this.b.clear(),super.dispose()}}e.$hk=t;class n{constructor(){this.onDidChangeLogLevel=new A.$je().event}setLevel(E){}getLevel(){return S.Info}trace(E,...T){}debug(E,...T){}info(E,...T){}warn(E,...T){}error(E,...T){}critical(E,...T){}dispose(){}flush(){}}e.$ik=n;class r extends n{}e.$jk=r;function a(b){if(b.verbose)return S.Trace;if(typeof b.logLevel=="string"){const E=C(b.logLevel.toLowerCase());if(E!==void 0)return E}return e.$_j}function f(b){switch(b){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Off:return"off"}}function v(b){switch(b){case S.Trace:return{original:"Trace",value:I.localize(11152,null)};case S.Debug:return{original:"Debug",value:I.localize(11153,null)};case S.Info:return{original:"Info",value:I.localize(11154,null)};case S.Warning:return{original:"Warning",value:I.localize(11155,null)};case S.Error:return{original:"Error",value:I.localize(11156,null)};case S.Off:return{original:"Off",value:I.localize(11157,null)}}}function C(b){switch(b){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Error;case"off":return S.Off}}e.$ok=new u.$Tj("logLevel",f(S.Info))}),define(he[170],ue([0,1,6,8,2,22,13,20,30,15,10]),function(oe,e,I,c,A,L,N,O,k,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=void 0;let d=class extends A.$Tc{constructor($,l){super(),this.a=$,this.b=l,this.B(new I.$Oh(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const $=(0,O.$ah)(this.a.logsHome),l=(0,O.$ch)(this.a.logsHome.with({scheme:L.Schemas.file})).fsPath,g=(await k.Promises.readdir(l)).filter(P=>/^\d{8}T\d{6}$/.test(P)).sort().filter(P=>P!==$),w=g.slice(0,Math.max(0,g.length-9));w.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${w.join(", ")}'`),await Promise.all(w.map(P=>k.Promises.rm((0,N.$ic)(l,P)))))}catch($){(0,c.$Y)($)}}};e.$ghc=d,e.$ghc=d=ve([Q(0,y.$Ji),Q(1,R.$9j)],d)}),define(he[171],ue([0,1,17,6,8,3,41,2,13,46,10]),function(oe,e,I,c,A,L,N,O,k,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;class d extends O.$Tc{constructor($,l){super(),this.a=$,this.b=l,this.c=this.B(new L.$je),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$je),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new c.$Ah(0)),this.w=[],this.y=this.B(new c.$Ah(0))}watch($,l){return l.recursive||this.b?.watcher?.forceUniversal?this.n($,l):this.z($,l)}n($,l){const p={path:this.J($),excludes:l.excludes,includes:l.includes,recursive:l.recursive,filter:l.filter,correlationId:l.correlationId},S=(0,I.$Sb)(this.j,p);return this.r(),(0,O.$Rc)(()=>{S(),this.r()})}r(){this.m.trigger(()=>this.s()).catch($=>(0,A.$Y)($))}s(){this.h||(this.h=this.B(this.t(l=>this.c.fire((0,y.$5q)(l)),l=>this.G(l),this.a.getLevel()===R.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===R.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const l of this.j)(0,y.$1q)(l)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const l of this.j)(0,y.$1q)(l)&&$.includes(l.path)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z($,l){const p={path:this.J($),excludes:l.excludes,includes:l.includes,recursive:!1,filter:l.filter,correlationId:l.correlationId},S=(0,I.$Sb)(this.w,p);return this.C(),(0,O.$Rc)(()=>{S(),this.C()})}C(){this.y.trigger(()=>this.D()).catch($=>(0,A.$Y)($))}D(){return this.u||(this.u=this.B(this.F($=>this.c.fire((0,y.$5q)($)),$=>this.G($),this.a.getLevel()===R.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===R.LogLevel.Trace)}))),this.u.watch(this.w)}G($){$.type==="error"&&this.g.fire($.message),this.H($)}H($){this.a[$.type]($.message)}I($){return(0,k.$gc)($.fsPath)}J($){const l=this.I($);return(0,N.$Eg)(l)}}e.$$q=d}),define(he[172],ue([0,1,17,6,14,25,3,55,63,2,51,22,100,20,50,11,7,99,10,8]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$,l,p,S,g,w,P){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=void 0;let o=class extends y.$Tc{static{m=this}constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new N.$je),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new N.$je),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new N.$je),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new N.$je),this.onDidRunOperation=this.r.event,this.X=this.B(new N.$je),this.Y=this.B(new N.$je),this.onDidFilesChange=this.Y.event,this.Z=this.B(new N.$je),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new c.$Lh)}registerProvider(i,s){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,u.mark)(`code/registerFilesystem/${i}`);const t=new y.$Sc;return this.h.set(i,s),this.c.fire({added:!0,scheme:i,provider:s}),t.add(s.onDidChangeFile(n=>{const r=new S.$pl(n,!this.S(s));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof s.onDidWatchError=="function"&&t.add(s.onDidWatchError(n=>this.Z.fire(new Error(n)))),t.add(s.onDidChangeCapabilities(()=>this.g.fire({provider:s,scheme:i}))),(0,y.$Rc)(()=>{this.c.fire({added:!1,scheme:i,provider:s}),this.h.delete(i),(0,y.$Oc)(t)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const s=[];this.f.fire({scheme:i,join(t){s.push(t)}}),!this.h.has(i)&&await c.Promises.settled(s)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,s){const t=this.h.get(i.scheme);return!!(t&&t.capabilities&s)}listCapabilities(){return k.Iterable.map(this.h,([i,s])=>({scheme:i,capabilities:s.capabilities}))}async j(i){if(!(0,$.$hh)(i))throw new S.$rl((0,p.localize)(11225,null,this.sb(i)),S.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(i.scheme);const s=this.h.get(i.scheme);if(!s){const t=new P.$ab;throw t.message=(0,p.localize)(11226,null,i.toString()),t}return s}async m(i){const s=await this.j(i);if((0,S.$cl)(s)||(0,S.$_k)(s)||(0,S.$dl)(s))return s;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(i){const s=await this.j(i);if((0,S.$cl)(s)||(0,S.$_k)(s))return s;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,s){try{return await this.s(i,s)}catch(t){throw(0,S.$ml)(t)===S.FileSystemProviderErrorCode.FileNotFound?new S.$rl((0,p.localize)(11227,null,this.sb(i)),S.FileOperationResult.FILE_NOT_FOUND):(0,S.$kl)(t)}}async s(i,s){const t=await this.j(i),n=this.S(t),r=s?.resolveTo,a=s?.resolveSingleChildDescendants,f=s?.resolveMetadata,v=await t.stat(i);let C;return this.t(t,i,v,void 0,!!f,(b,E)=>(C||(C=R.$Ii.forUris(()=>!n),C.set(i,!0),r&&C.fill(!0,r)),C.get(b.resource)||C.findSuperstr(b.resource.with({query:null,fragment:null}))?!0:b.isDirectory&&a?E===1:!1))}async t(i,s,t,n,r,a){const{providerExtUri:f}=this.R(i),v={resource:s,name:f.basename(s),isFile:(t.type&S.FileType.File)!==0,isDirectory:(t.type&S.FileType.Directory)!==0,isSymbolicLink:(t.type&S.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&S.FilePermission.Readonly)||!!(i.capabilities&S.FileSystemProviderCapabilities.Readonly),locked:!!((t.permissions??0)&S.FilePermission.Locked),etag:(0,S.$Cl)({mtime:t.mtime,size:t.size}),children:void 0};if(v.isDirectory&&a(v,n)){try{const C=await i.readdir(s),b=await c.Promises.settled(C.map(async([E,T])=>{try{const j=f.joinPath(s,E),U=r?await i.stat(j):{type:T};return await this.t(i,j,U,C.length,r,a)}catch(j){return this.b.trace(j),null}}));v.children=(0,I.$Gb)(b)}catch(C){this.b.trace(C),v.children=[]}return v}return v}async resolveAll(i){return c.Promises.settled(i.map(async s=>{try{return{stat:await this.s(s.resource,s.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(i){const s=await this.j(i),t=await s.stat(i);return this.t(s,i,t,void 0,!0,()=>!1)}async exists(i){const s=await this.j(i);try{return!!await s.stat(i)}catch{return!1}}async canCreateFile(i,s){try{await this.u(i,s)}catch(t){return t}return!0}async u(i,s){if(!s?.overwrite&&await this.exists(i))throw new S.$rl((0,p.localize)(11228,null,this.sb(i)),S.FileOperationResult.FILE_MODIFIED_SINCE,s)}async createFile(i,s=A.$Le.fromString(""),t){await this.u(i,t);const n=await this.writeFile(i,s);return this.r.fire(new S.$ol(i,S.FileOperation.CREATE,n)),n}async writeFile(i,s,t){const n=this.qb(await this.n(i),i),{providerExtUri:r}=this.R(n);let a=t;if((0,S.$fl)(n)&&!a?.atomic){const f=n.enforceAtomicWriteFile?.(i);f&&(a={...t,atomic:f})}try{await this.w(n,i,a)||await this.U(n,r.dirname(i));let v;if((0,S.$_k)(n)&&!(s instanceof A.$Le))if((0,l.$xe)(s)){const C=await(0,l.$Ee)(s,3);C.ended?v=A.$Le.concat(C.buffer):v=C}else v=(0,l.$Be)(s,C=>A.$Le.concat(C),3);else v=s;!(0,S.$cl)(n)||(0,S.$_k)(n)&&v instanceof A.$Le||(0,S.$_k)(n)&&(0,S.$fl)(n)&&a?.atomic?await this.hb(n,i,a,v):await this.db(n,i,a,v instanceof A.$Le?(0,A.$We)(v):v),this.r.fire(new S.$ol(i,S.FileOperation.WRITE))}catch(f){throw new S.$rl((0,p.localize)(11229,null,this.sb(i),(0,S.$kl)(f).toString()),(0,S.$nl)(f),a)}return this.resolve(i,{resolveMetadata:!0})}async w(i,s,t){const n=!!t?.unlock;if(n&&!(i.capabilities&S.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,p.localize)(11230,null,this.sb(s)));if(!!t?.atomic){if(!(i.capabilities&S.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,p.localize)(11231,null,this.sb(s)));if(!(i.capabilities&S.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,p.localize)(11232,null,this.sb(s)));if(n)throw new Error((0,p.localize)(11233,null,this.sb(s)))}let a;try{a=await i.stat(s)}catch{return}if(a.type&S.FileType.Directory)throw new S.$rl((0,p.localize)(11234,null,this.sb(s)),S.FileOperationResult.FILE_IS_DIRECTORY,t);if(this.rb(s,a),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==S.$Bl&&typeof a.mtime=="number"&&typeof a.size=="number"&&t.mtime<a.mtime&&t.etag!==(0,S.$Cl)({mtime:t.mtime,size:a.size}))throw new S.$rl((0,p.localize)(11235,null),S.FileOperationResult.FILE_MODIFIED_SINCE,t);return a}async readFile(i,s,t){const n=await this.m(i);return s?.atomic?this.z(n,i,s,t):this.C(n,i,s,t)}async z(i,s,t,n){return new Promise((r,a)=>{this.cb.queueFor(s,async()=>{try{const f=await this.C(i,s,t,n);r(f)}catch(f){a(f)}},this.R(i).providerExtUri)})}async C(i,s,t,n){const r=await this.D(i,s,{...t,preferUnbuffered:!0},n);return{...r,value:await(0,A.$Xe)(r.value)}}async readFileStream(i,s,t){const n=await this.m(i);return this.D(n,i,s,t)}async D(i,s,t,n){const r=new L.$ue(n);let a=t;(0,S.$el)(i)&&i.enforceAtomicReadFile?.(s)&&(a={...t,atomic:!0});const f=this.J(s,a).then(C=>C,C=>{throw r.dispose(!0),C});let v;try{return typeof a?.etag=="string"&&a.etag!==S.$Bl&&await f,a?.atomic&&(0,S.$el)(i)||!((0,S.$cl)(i)||(0,S.$dl)(i))||(0,S.$_k)(i)&&a?.preferUnbuffered?v=this.I(i,s,a):(0,S.$dl)(i)?v=this.G(i,s,r.token,a):v=this.H(i,s,r.token,a),v.on("end",()=>r.dispose()),v.on("error",()=>r.dispose()),{...await f,value:v}}catch(C){throw v&&await(0,l.$Ce)(v),this.F(C,s,a)}}F(i,s,t){const n=(0,p.localize)(11236,null,this.sb(s),(0,S.$kl)(i).toString());return i instanceof S.$tl?new S.$tl(n,i.stat,t):i instanceof S.$sl?new S.$sl(n,i.fileOperationResult,i.size,i.options):new S.$rl(n,(0,S.$nl)(i),t)}G(i,s,t,n=Object.create(null)){const r=i.readFileStream(s,n,t);return(0,l.$Ie)(r,{data:a=>a instanceof A.$Le?a:A.$Le.wrap(a),error:a=>this.F(a,s,n)},a=>A.$Le.concat(a))}H(i,s,t,n=Object.create(null)){const r=(0,A.$2e)();return(0,g.$Xq)(i,s,r,a=>a,{...n,bufferSize:this.a,errorTransformer:a=>this.F(a,s,n)},t),r}I(i,s,t){const n=(0,l.$ze)(r=>A.$Le.concat(r));return(async()=>{try{let r;t?.atomic&&(0,S.$el)(i)?r=await i.readFile(s,{atomic:!0}):r=await i.readFile(s),typeof t?.position=="number"&&(r=r.slice(t.position)),typeof t?.length=="number"&&(r=r.slice(0,t.length)),this.L(s,r.byteLength,t),n.end(A.$Le.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async J(i,s){const t=await this.resolve(i,{resolveMetadata:!0});if(t.isDirectory)throw new S.$rl((0,p.localize)(11237,null,this.sb(i)),S.FileOperationResult.FILE_IS_DIRECTORY,s);if(typeof s?.etag=="string"&&s.etag!==S.$Bl&&s.etag===t.etag)throw new S.$tl((0,p.localize)(11238,null),t,s);return this.L(i,t.size,s),t}L(i,s,t){if(typeof t?.limits?.size=="number"&&s>t.limits.size)throw new S.$sl((0,p.localize)(11239,null,this.sb(i)),S.FileOperationResult.FILE_TOO_LARGE,s,t)}async canMove(i,s,t){return this.M(i,s,"move",t)}async canCopy(i,s,t){return this.M(i,s,"copy",t)}async M(i,s,t,n){if(i.toString()!==s.toString())try{const r=t==="move"?this.qb(await this.n(i),i):await this.m(i),a=this.qb(await this.n(s),s);await this.Q(r,i,a,s,t,n)}catch(r){return r}return!0}async move(i,s,t){const n=this.qb(await this.n(i),i),r=this.qb(await this.n(s),s),a=await this.N(n,i,r,s,"move",!!t),f=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new S.$ol(i,a==="move"?S.FileOperation.MOVE:S.FileOperation.COPY,f)),f}async copy(i,s,t){const n=await this.m(i),r=this.qb(await this.n(s),s),a=await this.N(n,i,r,s,"copy",!!t),f=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new S.$ol(i,a==="copy"?S.FileOperation.COPY:S.FileOperation.MOVE,f)),f}async N(i,s,t,n,r,a){if(s.toString()===n.toString())return r;const{exists:f,isSameResourceWithDifferentPathCase:v}=await this.Q(i,s,t,n,r,a);if(f&&!v&&a&&await this.del(n,{recursive:!0}),await this.U(t,this.R(t).providerExtUri.dirname(n)),r==="copy"){if(i===t&&(0,S.$al)(i))await i.copy(s,n,{overwrite:a});else{const C=await this.resolve(s);C.isDirectory?await this.P(i,C,t,n):await this.O(i,s,t,n)}return r}else return i===t?(await i.rename(s,n,{overwrite:a}),r):(await this.N(i,s,t,n,"copy",a),await this.del(s,{recursive:!0}),"copy")}async O(i,s,t,n){if((0,S.$cl)(i)&&(0,S.$cl)(t))return this.jb(i,s,t,n);if((0,S.$cl)(i)&&(0,S.$_k)(t))return this.pb(i,s,t,n);if((0,S.$_k)(i)&&(0,S.$cl)(t))return this.nb(i,s,t,n);if((0,S.$_k)(i)&&(0,S.$_k)(t))return this.lb(i,s,t,n)}async P(i,s,t,n){await t.mkdir(n),Array.isArray(s.children)&&await c.Promises.settled(s.children.map(async r=>{const a=this.R(t).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.P(i,await this.resolve(r.resource),t,a):this.O(i,r.resource,t,a)}))}async Q(i,s,t,n,r,a){let f=!1;if(i===t){const{providerExtUri:C,isPathCaseSensitive:b}=this.R(i);if(b||(f=C.isEqual(s,n)),f&&r==="copy")throw new Error((0,p.localize)(11240,null,this.sb(s),this.sb(n)));if(!f&&C.isEqualOrParent(n,s))throw new Error((0,p.localize)(11241,null,this.sb(s),this.sb(n)))}const v=await this.exists(n);if(v&&!f){if(!a)throw new S.$rl((0,p.localize)(11242,null,this.sb(s),this.sb(n)),S.FileOperationResult.FILE_MOVE_CONFLICT);if(i===t){const{providerExtUri:C}=this.R(i);if(C.isEqualOrParent(s,n))throw new Error((0,p.localize)(11243,null,this.sb(s),this.sb(n)))}}return{exists:v,isSameResourceWithDifferentPathCase:f}}R(i){const s=this.S(i);return{providerExtUri:s?$.$6g:$.$8g,isPathCaseSensitive:s}}S(i){return!!(i.capabilities&S.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(i){const s=this.qb(await this.j(i),i);await this.U(s,i);const t=await this.resolve(i,{resolveMetadata:!0});return this.r.fire(new S.$ol(i,S.FileOperation.CREATE,t)),t}async U(i,s){const t=[],{providerExtUri:n}=this.R(i);for(;!n.isEqual(s,n.dirname(s));)try{if(!((await i.stat(s)).type&S.FileType.Directory))throw new Error((0,p.localize)(11244,null,this.sb(s)));break}catch(r){if((0,S.$ml)(r)!==S.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(n.basename(s)),s=n.dirname(s)}for(let r=t.length-1;r>=0;r--){s=n.joinPath(s,t[r]);try{await i.mkdir(s)}catch(a){if((0,S.$ml)(a)!==S.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(i,s){try{await this.W(i,s)}catch(t){return t}return!0}async W(i,s){const t=this.qb(await this.j(i),i),n=!!s?.useTrash;if(n&&!(t.capabilities&S.FileSystemProviderCapabilities.Trash))throw new Error((0,p.localize)(11245,null,this.sb(i)));const r=s?.atomic;if(r&&!(t.capabilities&S.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,p.localize)(11246,null,this.sb(i)));if(n&&r)throw new Error((0,p.localize)(11247,null,this.sb(i)));let a;try{a=await t.stat(i)}catch{}if(a)this.rb(i,a);else throw new S.$rl((0,p.localize)(11248,null,this.sb(i)),S.FileOperationResult.FILE_NOT_FOUND);if(!!!s?.recursive){const v=await this.resolve(i);if(v.isDirectory&&Array.isArray(v.children)&&v.children.length>0)throw new Error((0,p.localize)(11249,null,this.sb(i)))}return t}async del(i,s){const t=await this.W(i,s);let n=s;if((0,S.$gl)(t)&&!n?.atomic){const v=t.enforceAtomicDelete?.(i);v&&(n={...s,atomic:v})}const r=!!n?.useTrash,a=!!n?.recursive,f=n?.atomic??!1;await t.delete(i,{recursive:a,useTrash:r,atomic:f}),this.r.fire(new S.$ol(i,S.FileOperation.DELETE))}async cloneFile(i,s){const t=await this.j(i),n=this.qb(await this.n(s),s);if(!(t===n&&this.R(t).providerExtUri.isEqual(i,s)))return t===n&&(0,S.$bl)(t)?t.cloneFile(i,s):(await this.U(n,this.R(n).providerExtUri.dirname(s)),t===n&&(0,S.$al)(t)?this.cb.queueFor(i,()=>t.copy(i,s,{overwrite:!0}),this.R(t).providerExtUri):this.cb.queueFor(i,()=>this.O(t,i,n,s),this.R(t).providerExtUri))}static{this.ab=0}createWatcher(i,s){return this.watch(i,{...s,correlationId:m.ab++})}watch(i,s={recursive:!1,excludes:[]}){const t=new y.$Sc;let n=!1,r=()=>{n=!0};t.add((0,y.$Rc)(()=>r())),(async()=>{try{const f=await this.bb(i,s);n?(0,y.$Oc)(f):r=()=>(0,y.$Oc)(f)}catch(f){this.b.error(f)}})();const a=s.correlationId;if(typeof a=="number"){const f=t.add(new N.$je);return t.add(this.X.event(C=>{C.correlates(a)&&f.fire(C)})),{onDidChange:f.event,dispose:()=>t.dispose()}}return t}async bb(i,s){const t=await this.j(i),n=(0,O.$qj)([this.R(t).providerExtUri.getComparisonKey(i),s]);let r=this.$.get(n);return r||(r={count:0,disposable:t.watch(i,s)},this.$.set(n,r)),r.count+=1,(0,y.$Rc)(()=>{r&&(r.count--,r.count===0&&((0,y.$Oc)(r.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,i]of this.$)(0,y.$Oc)(i.disposable);this.$.clear()}async db(i,s,t,n){return this.cb.queueFor(s,async()=>{const r=await i.open(s,{create:!0,unlock:t?.unlock??!1});try{(0,l.$xe)(n)||(0,l.$ye)(n)?await this.eb(i,r,n):await this.fb(i,r,n)}catch(a){throw(0,S.$kl)(a)}finally{await i.close(r)}},this.R(i).providerExtUri)}async eb(i,s,t){let n=0,r;if((0,l.$ye)(t)){if(t.buffer.length>0){const a=A.$Le.concat(t.buffer);await this.gb(i,s,a,a.byteLength,n,0),n+=a.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise((a,f)=>{(0,l.$De)(r,{onData:async v=>{r.pause();try{await this.gb(i,s,v,v.byteLength,n,0)}catch(C){return f(C)}n+=v.byteLength,setTimeout(()=>r.resume())},onError:v=>f(v),onEnd:()=>a()})})}async fb(i,s,t){let n=0,r;for(;(r=t.read())!==null;)await this.gb(i,s,r,r.byteLength,n,0),n+=r.byteLength}async gb(i,s,t,n,r,a){let f=0;for(;f<n;){const v=await i.write(s,r+f,t.buffer,a+f,n-f);f+=v}}async hb(i,s,t,n){return this.cb.queueFor(s,()=>this.ib(i,s,t,n),this.R(i).providerExtUri)}async ib(i,s,t,n){let r;n instanceof A.$Le?r=n:(0,l.$xe)(n)?r=await(0,A.$Xe)(n):(0,l.$ye)(n)?r=await(0,A.$Ye)(n):r=(0,A.$Ve)(n),await i.writeFile(s,r.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async jb(i,s,t,n){return this.cb.queueFor(n,()=>this.kb(i,s,t,n),this.R(t).providerExtUri)}async kb(i,s,t,n){let r,a;try{r=await i.open(s,{create:!1}),a=await t.open(n,{create:!0,unlock:!1});const f=A.$Le.alloc(this.a);let v=0,C=0,b=0;do b=await i.read(r,v,f.buffer,C,f.byteLength-C),await this.gb(t,a,f,b,v,C),v+=b,C+=b,C===f.byteLength&&(C=0);while(b>0)}catch(f){throw(0,S.$kl)(f)}finally{await c.Promises.settled([typeof r=="number"?i.close(r):Promise.resolve(),typeof a=="number"?t.close(a):Promise.resolve()])}}async lb(i,s,t,n){return this.cb.queueFor(n,()=>this.mb(i,s,t,n),this.R(t).providerExtUri)}async mb(i,s,t,n){return t.writeFile(n,await i.readFile(s),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(i,s,t,n){return this.cb.queueFor(n,()=>this.ob(i,s,t,n),this.R(t).providerExtUri)}async ob(i,s,t,n){const r=await t.open(n,{create:!0,unlock:!1});try{const a=await i.readFile(s);await this.gb(t,r,A.$Le.wrap(a),a.byteLength,0,0)}catch(a){throw(0,S.$kl)(a)}finally{await t.close(r)}}async pb(i,s,t,n){const r=await(0,A.$Xe)(this.H(i,s,L.CancellationToken.None));await this.hb(t,n,void 0,r)}qb(i,s){if(i.capabilities&S.FileSystemProviderCapabilities.Readonly)throw new S.$rl((0,p.localize)(11250,null,this.sb(s)),S.FileOperationResult.FILE_PERMISSION_DENIED);return i}rb(i,s){if((s.permissions??0)&S.FilePermission.Readonly)throw new S.$rl((0,p.localize)(11251,null,this.sb(i)),S.FileOperationResult.FILE_PERMISSION_DENIED)}sb(i){return i.scheme===d.Schemas.file?i.fsPath:i.toString(!0)}};e.$Yq=o,e.$Yq=o=m=ve([Q(0,w.$9j)],o)}),define(he[173],ue([0,1,32,6,36,14,3,41,2,13,5,20,50,30,11,7,99,171,168,167]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$,l,p,S,g,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class m extends g.$$q{static{this.L=!1}constructor(h,i){super(h,i),this.onDidChangeCapabilities=N.Event.None,this.P=new A.$zc(s=>d.$7g.getComparisonKey(s)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=p.FileSystemProviderCapabilities.FileReadWrite|p.FileSystemProviderCapabilities.FileOpenReadWriteClose|p.FileSystemProviderCapabilities.FileReadStream|p.FileSystemProviderCapabilities.FileFolderCopy|p.FileSystemProviderCapabilities.FileWriteUnlock|p.FileSystemProviderCapabilities.FileAtomicRead|p.FileSystemProviderCapabilities.FileAtomicWrite|p.FileSystemProviderCapabilities.FileAtomicDelete|p.FileSystemProviderCapabilities.FileClone,R.$l&&(this.M|=p.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(h){try{const{stat:i,symbolicLink:s}=await $.SymlinkSupport.stat(this.I(h));return{type:this.O(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:p.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(h){try{return await this.stat(h)}catch{return}}async readdir(h){try{const i=await $.Promises.readdir(this.I(h),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async t=>{try{let n;t.isSymbolicLink()?n=(await this.stat((0,d.$dh)(h,t.name))).type:n=this.O(t),s.push([t.name,n])}catch(n){this.a.trace(n)}})),s}catch(i){throw this.hb(i)}}O(h,i){let s;return i?.dangling?s=p.FileType.Unknown:h.isFile()?s=p.FileType.File:h.isDirectory()?s=p.FileType.Directory:s=p.FileType.Unknown,i&&(s|=p.FileType.SymbolicLink),s}async Q(h){const i=this.I(h);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.P.get(h);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const t=new c.$Bh;return this.P.set(h,t),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,k.$Rc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(h)===t&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(h)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),t.open()})}async readFile(h,i){let s;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(h)})`),s=await this.Q(h));const t=this.I(h);return await I.promises.readFile(t)}catch(t){throw this.hb(t)}finally{s?.dispose()}}R(h){m.L&&this.a.trace(h)}readFileStream(h,i,s){const t=(0,u.$ze)(n=>L.$Le.concat(n.map(r=>L.$Le.wrap(r))).buffer);return(0,S.$Xq)(this,h,t,n=>n.buffer,{...i,bufferSize:256*1024},s),t}async writeFile(h,i,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.S(h)?this.U(h,(0,d.$dh)((0,d.$ch)(h),`${(0,d.$ah)(h)}${s.atomic.postfix}`),i,s):this.W(h,i,s)}async S(h){try{const i=this.I(h),{symbolicLink:s}=await $.SymlinkSupport.stat(i);if(s)return!1}catch{}return!0}async U(h,i,s,t){const n=new k.$Sc;try{n.add(await this.Q(h)),n.add(await this.Q(i)),await this.W(i,s,t,!0);try{await this.rename(i,h,{overwrite:!0})}catch(r){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw r}}finally{n.dispose()}}async W(h,i,s,t){let n;try{const r=this.I(h);if(!s.create||!s.overwrite){if(await $.Promises.exists(r)){if(!s.overwrite)throw(0,p.$jl)((0,l.localize)(11209,null),p.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,p.$jl)((0,l.localize)(11210,null),p.FileSystemProviderErrorCode.FileNotFound)}n=await this.open(h,{create:!0,unlock:s.unlock},t),await this.write(n,0,i,0,i.byteLength)}catch(r){throw await this.ib(h,r)}finally{typeof n=="number"&&await this.close(n)}}static{this.$=!0}static configureFlushOnWrite(h){m.$=h}async open(h,i,s){const t=this.I(h);let n;(0,p.$0k)(i)&&!s&&(n=await this.Q(h));let r;try{if((0,p.$0k)(i)&&i.unlock)try{const{stat:f}=await $.SymlinkSupport.stat(t);f.mode&128||await I.promises.chmod(t,f.mode|128)}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}let a;if((0,p.$0k)(i)){if(R.$j)try{await I.promises.truncate(t,0),a="r+"}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}a||(a="w")}else a="r";r=await $.Promises.open(t,a)}catch(a){throw n?.dispose(),(0,p.$0k)(i)?await this.ib(h,a):this.hb(a)}if(this.X.set(r,0),(0,p.$0k)(i)&&this.Z.set(r,h),n){const a=this.Y.get(r);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${r} (${t})`),this.Y.set(r,n),a&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${r} (${t})`),a.dispose())}return r}async close(h){const i=this.Y.get(h);try{if(this.X.delete(h),this.Z.delete(h)&&m.$)try{await $.Promises.fdatasync(h)}catch(s){m.configureFlushOnWrite(!1),this.a.error(s)}return await $.Promises.close(h)}catch(s){throw this.hb(s)}finally{i&&(this.Y.get(h)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${h}`),this.Y.delete(h)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${h}`),i.dispose())}}async read(h,i,s,t,n){const r=this.ab(h,i);let a=null;try{a=(await $.Promises.read(h,s,t,n,r)).bytesRead}catch(f){throw this.hb(f)}finally{this.bb(h,r,a)}return a}ab(h,i){return i===this.X.get(h)?null:i}bb(h,i,s){const t=this.X.get(h);typeof t=="number"&&(typeof i=="number"||(typeof s=="number"?this.X.set(h,t+s):this.X.delete(h)))}async write(h,i,s,t,n){return(0,c.$Wh)(()=>this.cb(h,i,s,t,n),100,3)}async cb(h,i,s,t,n){const r=this.ab(h,i);let a=null;try{a=(await $.Promises.write(h,s,t,n,r)).bytesWritten}catch(f){throw await this.ib(this.Z.get(h),f)}finally{this.bb(h,r,a)}return a}async mkdir(h){try{await I.promises.mkdir(this.I(h))}catch(i){throw this.hb(i)}}async delete(h,i){try{const s=this.I(h);if(i.recursive){let t;i?.atomic!==!1&&i.atomic.postfix&&(t=(0,y.$ic)((0,y.$lc)(s),`${(0,y.$mc)(s)}${i.atomic.postfix}`)),await $.Promises.rm(s,$.RimRafMode.MOVE,t)}else try{await I.promises.unlink(s)}catch(t){if(t.code==="EPERM"||t.code==="EISDIR"){let n=!1;try{const{stat:r,symbolicLink:a}=await $.SymlinkSupport.stat(s);n=r.isDirectory()&&!a}catch{}if(n)await I.promises.rmdir(s);else throw t}else throw t}}catch(s){throw this.hb(s)}}async rename(h,i,s){const t=this.I(h),n=this.I(i);if(t!==n)try{await this.db(h,i,"move",s.overwrite),await $.Promises.rename(t,n)}catch(r){throw(r.code==="EINVAL"||r.code==="EBUSY"||r.code==="ENAMETOOLONG")&&(r=new Error((0,l.localize)(11211,null,(0,y.$mc)(t),(0,y.$mc)((0,y.$lc)(n)),r.toString()))),this.hb(r)}}async copy(h,i,s){const t=this.I(h),n=this.I(i);if(t!==n)try{await this.db(h,i,"copy",s.overwrite),await $.Promises.copy(t,n,{preserveSymlinks:!0})}catch(r){throw(r.code==="EINVAL"||r.code==="EBUSY"||r.code==="ENAMETOOLONG")&&(r=new Error((0,l.localize)(11212,null,(0,y.$mc)(t),(0,y.$mc)((0,y.$lc)(n)),r.toString()))),this.hb(r)}}async db(h,i,s,t){const n=this.I(h),r=this.I(i);let a=!1;if(!!(this.capabilities&p.FileSystemProviderCapabilities.PathCaseSensitive)||(a=(0,O.$Ag)(n,r,!0)),a){if(s==="copy")throw(0,p.$jl)((0,l.localize)(11213,null),p.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const v=await this.N(h);if(!v)throw(0,p.$jl)((0,l.localize)(11214,null),p.FileSystemProviderErrorCode.FileNotFound);const C=await this.N(i);if(C){if(!t)throw(0,p.$jl)((0,l.localize)(11215,null),p.FileSystemProviderErrorCode.FileExists);v.type&p.FileType.File&&C.type&p.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(h,i){return this.eb(h,i,!1)}async eb(h,i,s){const t=this.I(h),n=this.I(i),r=!!(this.capabilities&p.FileSystemProviderCapabilities.PathCaseSensitive);if((0,O.$Ag)(t,n,!r))return;const a=new k.$Sc;try{a.add(await this.Q(h)),a.add(await this.Q(i)),s&&await I.promises.mkdir((0,y.$lc)(n),{recursive:!0}),await I.promises.copyFile(t,n)}catch(f){if(f.code==="ENOENT"&&!s)return this.eb(h,i,!0);throw this.hb(f)}finally{a.dispose()}}t(h,i,s){return new w.$fr(t=>h(t),t=>i(t),s)}F(h,i,s){return new P.$or(t=>h(t),t=>i(t),s)}hb(h){if(h instanceof p.$il)return h;let i=h,s;switch(h.code){case"ENOENT":s=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=p.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${h.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=p.FileSystemProviderErrorCode.Unknown;break;default:s=p.FileSystemProviderErrorCode.Unknown}return(0,p.$jl)(i,s)}async ib(h,i){let s=this.hb(i);if(h&&s.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:t}=await $.SymlinkSupport.stat(this.I(h));t.mode&128||(s=(0,p.$jl)(i,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(t){this.a.trace(t)}return s}}e.$pr=m}),define(he[101],ue([0,1,3,2,4,10]),function(oe,e,I,c,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ghc=e.$Fhc=void 0,e.$Fhc=(0,A.$Ci)("sharedProcessLifecycleService");let N=class extends c.$Tc{constructor(k){super(),this.b=k,this.a=this.B(new I.$je),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$Ghc=N,e.$Ghc=N=ve([Q(0,L.$9j)],N)}),define(he[174],ue([0,1,9,3,10,2]),function(oe,e,I,c,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=e.$qs=e.$ps=void 0;class N extends A.$hk{constructor(d,u,$,l,p){super(u,$,l),this.r=d,this.t=p,this.B(p.listen("onDidChangeLogLevel",d)(S=>{(0,A.$$j)(S)?super.setLogLevel(S):super.setLogLevel(I.URI.revive(S[0]),S[1])})),this.B(p.listen("onDidChangeVisibility",d)(([S,g])=>super.setVisibility(I.URI.revive(S),g))),this.B(p.listen("onDidChangeLoggers",d)(({added:S,removed:g})=>{for(const w of S)super.registerLogger({...w,resource:I.URI.revive(w.resource)});for(const w of g)super.deregisterLogger(w.resource)}))}createConsoleMainLogger(){return new A.$fk({log:(d,u)=>{this.t.call("consoleLog",[d,u])}})}registerLogger(d){super.registerLogger(d),this.t.call("registerLogger",[d,this.r])}deregisterLogger(d){super.deregisterLogger(d),this.t.call("deregisterLogger",[d,this.r])}setLogLevel(d,u){super.setLogLevel(d,u),this.t.call("setLogLevel",[d,u])}setVisibility(d,u){super.setVisibility(d,u),this.t.call("setVisibility",[this.n(d),u])}s(d,u,$){return new O(this.t,d,u,$,this.r)}static setLogLevel(d,u,$){return d.call("setLogLevel",[u,$])}}e.$ps=N;class O extends A.$ck{constructor(d,u,$,l,p){super(l?.logLevel==="always"),this.r=d,this.s=u,this.m=!1,this.n=[],this.setLevel($),this.r.call("createLogger",[u,l,p]).then(()=>{this.u(this.n),this.m=!0})}g(d,u){const $=[[d,u]];this.m?this.u($):this.n.push(...$)}u(d){this.r.call("log",[this.s,d])}}class k{constructor(d,u){this.a=d,this.b=u}listen(d,u){const $=this.b(d);switch(u){case"onDidChangeLoggers":return c.Event.map(this.a.onDidChangeLoggers,l=>({added:[...l.added].map(p=>this.c(p,$)),removed:[...l.removed].map(p=>this.c(p,$))}));case"onDidChangeVisibility":return c.Event.map(this.a.onDidChangeVisibility,l=>[$.transformOutgoingURI(l[0]),l[1]]);case"onDidChangeLogLevel":return c.Event.map(this.a.onDidChangeLogLevel,l=>(0,A.$$j)(l)?l:[$.transformOutgoingURI(l[0]),l[1]])}throw new Error(`Event not found: ${u}`)}async call(d,u,$){const l=this.b(d);switch(u){case"setLogLevel":return(0,A.$$j)($[0])?this.a.setLogLevel($[0]):this.a.setLogLevel(I.URI.revive(l.transformIncoming($[0][0])),$[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(p=>this.c(p,l)))}throw new Error(`Call not found: ${u}`)}c(d,u){return{...d,resource:u.transformOutgoingURI(d.resource)}}}e.$qs=k;class y extends L.$Tc{constructor(d,u){super(),u.call("setLogLevel",[d.getLogLevel()]),this.B(d.onDidChangeLogLevel($=>u.call("setLogLevel",[$]))),u.call("getRegisteredLoggers").then($=>{for(const l of $)d.registerLogger({...l,resource:I.URI.revive(l.resource)})}),this.B(u.listen("onDidChangeVisibility")(([$,l])=>d.setVisibility(I.URI.revive($),l))),this.B(u.listen("onDidChangeLoggers")(({added:$,removed:l})=>{for(const p of $)d.registerLogger({...p,resource:I.URI.revive(p.resource)});for(const p of l)d.deregisterLogger(p.resource)}))}}e.$rs=y}),define(he[175],ue([0,1,2,10]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oR=void 0;class A extends I.$Tc{constructor(N,O=[]){super(),this.a=new c.$gk([N,...O]),this.B(N.onDidChangeLogLevel(k=>this.setLevel(k)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(N){this.a.setLevel(N)}getLevel(){return this.a.getLevel()}trace(N,...O){this.a.trace(N,...O)}debug(N,...O){this.a.debug(N,...O)}info(N,...O){this.a.info(N,...O)}warn(N,...O){this.a.warn(N,...O)}error(N,...O){this.a.error(N,...O)}flush(){this.a.flush()}}e.$oR=A}),define(he[57],ue([0,1,4]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gfc=void 0,e.$Gfc=(0,I.$Ci)("nativeHostService")}),define(he[176],ue([0,1,42,56]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2gc=void 0;let A=class{constructor(N,O){return this.windowId=N,I.ProxyChannel.toService(O.getChannel("nativeHost"),{context:N,properties:(()=>{const k=new Map;return k.set("windowId",N),k})()})}};e.$2gc=A,e.$2gc=A=ve([Q(1,c.$Ygc)],A)}),define(he[58],ue([0,1,3,63,2,4]),function(oe,e,I,c,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=e.$qo=e.$po=void 0,e.$po=(0,L.$Ci)("policy");class N extends A.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new I.$je),this.onDidChange=this.h.event}async updatePolicyDefinitions(y){const R=Object.keys(this.f).length;return this.f={...y,...this.f},R!==Object.keys(this.f).length&&await this.j(y),c.Iterable.reduce(this.g.entries(),(d,[u,$])=>({...d,[u]:$}),{})}getPolicyValue(y){return this.g.get(y)}serialize(){return c.Iterable.reduce(Object.entries(this.f),(y,[R,d])=>({...y,[R]:{definition:d,value:this.g.get(R)}}),{})}}e.$qo=N;class O{constructor(){this.onDidChange=I.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$ro=O}),define(he[177],ue([0,1,3,2,58]),function(oe,e,I,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=e.$sgc=void 0;class L{constructor(k){this.b=k,this.a=new c.$Sc}listen(k,y){switch(y){case"onDidChange":return I.Event.map(this.b.onDidChange,R=>R.reduce((d,u)=>({...d,[u]:this.b.getPolicyValue(u)??null}),{}),this.a)}throw new Error(`Event not found: ${y}`)}call(k,y,R){switch(y){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(R)}throw new Error(`Call not found: ${y}`)}dispose(){this.a.dispose()}}e.$sgc=L;class N extends A.$qo{constructor(k,y){super(),this.a=y;for(const R in k){const{definition:d,value:u}=k[R];this.f[R]=d,u!==void 0&&this.g.set(R,u)}this.a.listen("onDidChange")(R=>{for(const d in R){const u=R[d];u===null?this.g.delete(d):this.g.set(d,u)}this.h.fire(Object.keys(R))})}async j(k){const y=await this.a.call("updatePolicyDefinitions",k);for(const R in y)this.g.set(R,y[R])}}e.$tgc=N}),define(he[102],ue([0,1,37]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let c;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.context<"u"){const L=A.context.configuration();if(L)c=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(c=globalThis._VSCODE_PRODUCT_JSON,I.env.VSCODE_DEV&&Object.assign(c,{nameShort:`${c.nameShort} Dev`,nameLong:`${c.nameLong} Dev`,dataFolderName:`${c.dataFolderName}-dev`,serverDataFolderName:c.serverDataFolderName?`${c.serverDataFolderName}-dev`:void 0}),!c.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(c,{version:L.version})}}else c={},Object.keys(c).length===0&&Object.assign(c,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=c}),define(he[23],ue([0,1,4]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qk=e.$pk=void 0,e.$pk=(0,I.$Ci)("productService"),e.$qk="vscode://schemas/vscode-product"}),define(he[178],ue([0,1,32,6,8,2,13,30,10,23]),function(oe,e,I,c,A,L,N,O,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=void 0,I=ke(I);let R=class extends L.$Tc{constructor(u,$,l){super(),this.b=$,this.c=l,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,u&&this.B(new c.$Oh(()=>{this.f(u)},3e4)).schedule()}async f(u){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const $=Date.now(),l=(0,N.$lc)(u),p=(0,N.$mc)(u),S=await O.Promises.readdir(l);await Promise.all(S.map(async g=>{if(g===p)return;const w=(0,N.$ic)(l,g),P=await I.promises.stat(w);if(P.isDirectory()&&$-P.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${g}.`),O.Promises.rm(w)}))}catch($){(0,A.$Y)($)}}};e.$dhc=R,e.$dhc=R=ve([Q(1,y.$pk),Q(2,k.$9j)],R)}),define(he[179],ue([0,1,32,6,8,2,13,30,15,10,23]),function(oe,e,I,c,A,L,N,O,k,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ehc=void 0,I=ke(I);let d=class extends L.$Tc{constructor($,l,p){super(),this.b=$,this.c=l,this.f=p,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new c.$Oh(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const $=Object.create(null),l=JSON.parse(await I.promises.readFile((0,N.$ic)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const P of Object.keys(l)){const m=l[P];$[`${m.hash}.${P}`]=!0}const p=(0,N.$ic)(this.b.userDataPath,"clp");if(!await O.Promises.exists(p))return;const g=await O.Promises.readdir(p);for(const P of g){if($[P]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${P}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${P}`),await O.Promises.rm((0,N.$ic)(p,P))}const w=Date.now();for(const P of Object.keys($)){const m=(0,N.$ic)(p,P),o=await O.Promises.readdir(m);for(const h of o){if(h==="tcf.json")continue;const i=(0,N.$ic)(m,h),s=await I.promises.stat(i);s.isDirectory()&&w-s.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,N.$ic)(P,h)}`),await O.Promises.rm(i))}}}catch($){(0,A.$Y)($)}}};e.$ehc=d,e.$ehc=d=ve([Q(0,k.$Ki),Q(1,y.$9j),Q(2,R.$pk)],d)}),define(he[180],ue([0,1,13,4]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$LG=void 0,e.$LG=(0,c.$Ci)("IV8InspectProfilingService");var A;(function(L){function N(k){return!!(k.samples&&k.timeDeltas)}L.isValidProfile=N;function O(k,y="noAbsolutePaths"){for(const R of k.nodes)R.callFrame&&R.callFrame.url&&((0,I.$hc)(R.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(R.callFrame.url))&&(R.callFrame.url=(0,I.$ic)(y,(0,I.$mc)(R.callFrame.url)));return k}L.rewriteAbsolutePaths=O})(A||(e.Utils=A={}))}),define(he[181],ue([0,1,31]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=void 0;class c{constructor(){this.a=new Map}async startProfiling(L){const O=await(await new Promise((y,R)=>{oe(["v8-inspect-profiler"],y,R)}).then(ke)).startProfiling({host:L.host,port:L.port,checkForPaused:!0}),k=(0,I.$Yg)();return this.a.set(k,O),k}async stopProfiling(L){const N=this.a.get(L);if(!N)throw new Error(`UNKNOWN session '${L}'`);const O=await N.stop();return this.a.delete(L),O.profile}}e.$vhc=c}),define(he[44],ue([0,1,131,12]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=void 0,I=ke(I),c=ke(c);class A{constructor(){this.a=new Map}add(N,O){I.ok(c.$cg(N)),I.ok(c.$eg(O)),I.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,O)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}e.$no=new A}),define(he[103],ue([0,1,3,44]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=void 0,c=ke(c),e.$oo={JSONContribution:"base.contributions.json"};function A(O){return O.length>0&&O.charAt(O.length-1)==="#"?O.substring(0,O.length-1):O}class L{constructor(){this.b=new I.$je,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(k,y){this.a[A(k)]=y,this.b.fire(k)}notifySchemaChanged(k){this.b.fire(k)}getSchemaContributions(){return{schemas:this.a}}}const N=new L;c.$no.add(e.$oo.JSONContribution,N)}),define(he[47],ue([0,1,17,3,12,11,21,103,44]),function(oe,e,I,c,A,L,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.ConfigurationScope=e.$so=e.EditPresentationTypes=void 0,e.$Do=p,e.$Eo=S,e.$Fo=g,e.$Go=P,e.$Ho=m,e.$Io=o,e.$Jo=h,A=ke(A),L=ke(L);var y;(function(i){i.Multiline="multilineText",i.Singleline="singlelineText"})(y||(e.EditPresentationTypes=y={})),e.$so={Configuration:"base.contributions.configuration"};var R;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.MACHINE=2]="MACHINE",i[i.WINDOW=3]="WINDOW",i[i.RESOURCE=4]="RESOURCE",i[i.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",i[i.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$to={properties:{},patternProperties:{}},e.$uo={properties:{},patternProperties:{}},e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo="vscode://schemas/settings/resourceLanguage",e.$Ao="vscode://schemas/settings/configurationDefaults";const d=k.$no.as(O.$oo.JSONContribution);class u{constructor(){this.h=new Set,this.i=new c.$je,this.onDidSchemaChange=this.i.event,this.j=new c.$je,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(11444,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},d.registerSchema(e.$zo,this.g),this.v()}registerConfiguration(s,t=!0){this.registerConfigurations([s],t)}registerConfigurations(s,t=!0){const n=new Set;this.n(s,t,n),d.registerSchema(e.$zo,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(s){const t=new Set;this.o(s,t),d.registerSchema(e.$zo,this.g),this.i.fire(),this.j.fire({properties:t})}updateConfigurations({add:s,remove:t}){const n=new Set;this.o(t,n),this.n(s,!1,n),d.registerSchema(e.$zo,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(s){const t=new Set;this.k(s,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:!0})}k(s,t){const n=[];for(const{overrides:r,source:a}of s)for(const f in r)if(t.add(f),e.$Co.test(f)){const v=this.a.get(f),C=v?.valuesSources??new Map,b=v?.value||{};for(const j of Object.keys(r[f])){const U=r[f][j];if(A.$eg(U)&&(A.$jg(b[j])||A.$eg(b[j]))){if(b[j]={...b[j]??{},...U},a){let K=C.get(j);if(K||(K=new Map,C.set(j,K)),!(K instanceof Map)){console.error("objectConfigurationSources is not a Map");continue}for(const W in U)K.set(W,a)}}else b[j]=U,a&&C.set(j,a)}this.a.set(f,{source:a,value:b,valuesSources:C});const E=(0,N.$gj)(f),T={type:"object",default:b,description:L.localize(11445,null,E),$ref:e.$zo,defaultDefaultValue:b,source:A.$cg(a)?void 0:a,defaultValueSource:a};n.push(...p(f)),this.d[f]=T,this.b.properties[f]=T}else{const v=this.d[f],C=this.a.get(f);let b=C?.value??v?.defaultDefaultValue,E=r[f],T=a;if(A.$eg(E)&&(v!==void 0&&v.type==="object"||v===void 0&&(A.$jg(b)||A.$eg(b)))){if(A.$eg(b)||(b={}),E={...b,...E},T=C?.source??new Map,!(T instanceof Map)){console.error("defaultValueSource is not a Map");continue}for(const U in r[f])a?T.set(U,a):T.delete(U)}this.a.set(f,{value:E,source:T}),v&&(this.w(f,v),this.r(f,v))}this.m(n)}deregisterDefaultConfigurations(s){const t=new Set;this.l(s,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:!0})}l(s,t){for(const{overrides:n,source:r}of s)for(const a in n){const f=A.$cg(r)?r:r?.id,v=this.a.get(a);if(v){if(e.$Co.test(a)){for(const b of Object.keys(n[a])){const E=n[a][b];if(A.$eg(E)){const T=v.valuesSources?.get(b);for(const j of Object.keys(E)){const U=T?.get(j);(A.$cg(U)?U:U?.id)===f&&(T?.delete(j),delete v.value[b][j])}Object.keys(v.value[b]).length===0&&(delete v.value[b],v.valuesSources?.delete(b))}else{const T=v.valuesSources?.get(b);(A.$cg(T)?T:T?.id)===f&&(v.valuesSources?.delete(b),delete v.value[b])}}const C=this.a.get(a);C&&Object.keys(C.value).length===0&&(this.a.delete(a),delete this.d[a],delete this.b.properties[a])}else{if(v.source instanceof Map){const b=v.source;for(const E in n[a]){const T=b.get(E);(A.$cg(T)?T:T?.id)===f&&(b.delete(E),delete v.value[E])}b.size===0&&this.a.delete(a)}else{const b=A.$cg(v.source)?v.source:v.source?.id;if(f!==b)continue;this.a.delete(a)}const C=this.d[a];C&&(this.w(a,C),this.r(a,C))}t.add(a)}}this.u()}deltaConfiguration(s){let t=!1;const n=new Set;s.removedDefaults&&(this.l(s.removedDefaults,n),t=!0),s.addedDefaults&&(this.k(s.addedDefaults,n),t=!0),s.removedConfigurations&&this.o(s.removedConfigurations,n),s.addedConfigurations&&this.n(s.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:t})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){this.m(s),this.i.fire()}m(s){for(const t of s)this.h.add(t);this.u()}n(s,t,n){s.forEach(r=>{this.p(r,t,r.extensionInfo,r.restrictedProperties,void 0,n),this.c.push(r),this.q(r)})}o(s,t){const n=r=>{if(r.properties)for(const a in r.properties){t.add(a);const f=this.d[a];f?.policy?.name&&this.e.delete(f.policy.name),delete this.d[a],this.s(a,r.properties[a])}r.allOf?.forEach(a=>n(a))};for(const r of s){n(r);const a=this.c.indexOf(r);a!==-1&&this.c.splice(a,1)}}p(s,t=!0,n,r,a=R.WINDOW,f){a=A.$lg(s.scope)?a:s.scope;const v=s.properties;if(v)for(const b in v){const E=v[b];if(t&&P(b,E)){delete v[b];continue}if(E.source=n,E.defaultDefaultValue=v[b].default,this.w(b,E),e.$Co.test(b)?E.scope=void 0:(E.scope=A.$lg(E.scope)?a:E.scope,E.restricted=A.$lg(E.restricted)?!!r?.includes(b):E.restricted),v[b].hasOwnProperty("included")&&!v[b].included){this.f[b]=v[b],delete v[b];continue}else this.d[b]=v[b],v[b].policy?.name&&this.e.set(v[b].policy.name,b);!v[b].deprecationMessage&&v[b].markdownDeprecationMessage&&(v[b].deprecationMessage=v[b].markdownDeprecationMessage),f.add(b)}const C=s.allOf;if(C)for(const b of C)this.p(b,t,n,r,a,f)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(s){const t=n=>{const r=n.properties;if(r)for(const f in r)this.r(f,r[f]);n.allOf?.forEach(t)};t(s)}r(s,t){switch(e.$to.properties[s]=t,t.scope){case R.APPLICATION:e.$uo.properties[s]=t;break;case R.MACHINE:e.$vo.properties[s]=t;break;case R.MACHINE_OVERRIDABLE:e.$wo.properties[s]=t;break;case R.WINDOW:e.$xo.properties[s]=t;break;case R.RESOURCE:e.$yo.properties[s]=t;break;case R.LANGUAGE_OVERRIDABLE:e.$yo.properties[s]=t,this.g.properties[s]=t;break}}s(s,t){switch(delete e.$to.properties[s],t.scope){case R.APPLICATION:delete e.$uo.properties[s];break;case R.MACHINE:delete e.$vo.properties[s];break;case R.MACHINE_OVERRIDABLE:delete e.$wo.properties[s];break;case R.WINDOW:delete e.$xo.properties[s];break;case R.RESOURCE:case R.LANGUAGE_OVERRIDABLE:delete e.$yo.properties[s],delete this.g.properties[s];break}}u(){for(const s of this.h.values()){const t=`[${s}]`,n={type:"object",description:L.localize(11446,null),errorMessage:L.localize(11447,null),$ref:e.$zo};this.w(t,n),e.$to.properties[t]=n,e.$uo.properties[t]=n,e.$vo.properties[t]=n,e.$wo.properties[t]=n,e.$xo.properties[t]=n,e.$yo.properties[t]=n}}v(){const s={type:"object",description:L.localize(11448,null),errorMessage:L.localize(11449,null),$ref:e.$zo};e.$to.patternProperties[e.$Bo]=s,e.$uo.patternProperties[e.$Bo]=s,e.$vo.patternProperties[e.$Bo]=s,e.$wo.patternProperties[e.$Bo]=s,e.$xo.patternProperties[e.$Bo]=s,e.$yo.patternProperties[e.$Bo]=s,this.i.fire()}w(s,t){const n=this.a.get(s);let r=n?.value,a=n?.source;A.$jg(r)&&(r=t.defaultDefaultValue,a=void 0),A.$jg(r)&&(r=g(t.type)),t.default=r,t.defaultValueSource=a}}const $="\\[([^\\]]+)\\]",l=new RegExp($,"g");e.$Bo=`^(${$})+$`,e.$Co=new RegExp(e.$Bo);function p(i){const s=[];if(e.$Co.test(i)){let t=l.exec(i);for(;t?.length;){const n=t[1].trim();n&&s.push(n),t=l.exec(i)}}return(0,I.$Lb)(s)}function S(i){return i.reduce((s,t)=>`${s}[${t}]`,"")}function g(i){switch(Array.isArray(i)?i[0]:i){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const w=new u;k.$no.add(e.$so.Configuration,w);function P(i,s){return i.trim()?e.$Co.test(i)?L.localize(11451,null,i):w.getConfigurationProperties()[i]!==void 0?L.localize(11452,null,i):s.policy?.name&&w.getPolicyConfigurations().get(s.policy?.name)!==void 0?L.localize(11453,null,i,s.policy?.name,w.getPolicyConfigurations().get(s.policy?.name)):null:L.localize(11450,null)}function m(){const i=[],s=w.getConfigurationProperties();for(const t of Object.keys(s))i.push([t,s[t].scope]);return i.push(["launch",R.RESOURCE]),i.push(["task",R.RESOURCE]),i}function o(i){const s={};for(const t of i){const n=t.properties;if(A.$eg(n))for(const r in n)s[r]=n[r];t.allOf&&Object.assign(s,o(t.allOf))}return s}function h(i){switch(i){case"application":return R.APPLICATION;case"machine":return R.MACHINE;case"resource":return R.RESOURCE;case"machine-overridable":return R.MACHINE_OVERRIDABLE;case"language-overridable":return R.LANGUAGE_OVERRIDABLE;default:return R.WINDOW}}}),define(he[77],ue([0,1,17,3,35,2,36,29,12,9,21,47,7,44]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$No=e.$Mo=e.$Lo=e.$Ko=void 0,e.$Oo=m,I=ke(I),A=ke(A),O=ke(O),k=ke(k);function l(s){return Object.isFrozen(s)?s:O.$bo(s)}class p{static createEmptyModel(t){return new p({},[],[],void 0,t)}constructor(t,n,r,a,f){this.b=t,this.c=n,this.d=r,this.raw=a,this.f=f,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const t=this.raw.map(n=>{if(n instanceof p)return n;const r=new S("",this.f);return r.parseRaw(n),r.configurationModel});this.g=t.reduce((n,r)=>r===n?r:n.merge(r),t[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,R.$ej)(this.contents,t):this.contents}inspect(t,n){const r=this;return{get value(){return l(r.rawConfiguration.getValue(t))},get override(){return n?l(r.rawConfiguration.getOverrideValue(t,n)):void 0},get merged(){return l(n?r.rawConfiguration.override(n).getValue(t):r.rawConfiguration.getValue(t))},get overrides(){const a=[];for(const{contents:f,identifiers:v,keys:C}of r.rawConfiguration.overrides){const b=new p(f,C,[],void 0,r.f).getValue(t);b!==void 0&&a.push({identifiers:v,value:b})}return a.length?l(a):void 0}}}getOverrideValue(t,n){const r=this.j(n);return r?t?(0,R.$ej)(r,t):r:void 0}getKeysForOverrideIdentifier(t){const n=[];for(const r of this.overrides)r.identifiers.includes(t)&&n.push(...r.keys);return I.$Lb(n)}getAllOverrideIdentifiers(){const t=[];for(const n of this.overrides)t.push(...n.identifiers);return I.$Lb(t)}override(t){let n=this.a.get(t);return n||(n=this.h(t),this.a.set(t,n)),n}merge(...t){const n=O.$ao(this.contents),r=O.$ao(this.overrides),a=[...this.keys],f=this.raw?.length?[...this.raw]:[this];for(const v of t)if(f.push(...v.raw?.length?v.raw:[v]),!v.isEmpty()){this.i(n,v.contents);for(const C of v.overrides){const[b]=r.filter(E=>I.$tb(E.identifiers,C.identifiers));b?(this.i(b.contents,C.contents),b.keys.push(...C.keys),b.keys=I.$Lb(b.keys)):r.push(O.$ao(C))}for(const C of v.keys)a.indexOf(C)===-1&&a.push(C)}return new p(n,a,r,f.every(v=>v instanceof p)?void 0:f,this.f)}h(t){const n=this.j(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const r={};for(const a of I.$Lb([...Object.keys(this.contents),...Object.keys(n)])){let f=this.contents[a];const v=n[a];v&&(typeof f=="object"&&typeof v=="object"?(f=O.$ao(f),this.i(f,v)):f=v),r[a]=f}return new p(r,this.keys,this.overrides,void 0,this.f)}i(t,n){for(const r of Object.keys(n)){if(r in t&&k.$eg(t[r])&&k.$eg(n[r])){this.i(t[r],n[r]);continue}t[r]=O.$ao(n[r])}}j(t){let n=null,r=null;const a=f=>{f&&(r?this.i(r,f):r=O.$ao(f))};for(const f of this.overrides)f.identifiers.length===1&&f.identifiers[0]===t?n=f.contents:f.identifiers.includes(t)&&a(f.contents);return a(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,n){this.k(t,n,!0)}setValue(t,n){this.k(t,n,!1)}removeValue(t){const n=this.keys.indexOf(t);n!==-1&&(this.keys.splice(n,1),(0,R.$dj)(this.contents,t),d.$Co.test(t)&&this.overrides.splice(this.overrides.findIndex(r=>I.$tb(r.identifiers,(0,d.$Do)(t))),1))}k(t,n,r){(0,R.$cj)(this.contents,t,n,a=>this.f.error(a)),r=r||this.keys.indexOf(t)===-1,r&&this.keys.push(t),d.$Co.test(t)&&this.overrides.push({identifiers:(0,d.$Do)(t),keys:Object.keys(this.contents[t]),contents:(0,R.$bj)(this.contents[t],a=>this.f.error(a))})}}e.$Ko=p;class S{constructor(t,n){this.f=t,this.g=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||p.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,n){if(!k.$lg(t)){const r=this.h(t);this.parseRaw(r,n)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,n){this.a=t;const{contents:r,keys:a,overrides:f,restricted:v,hasExcludedProperties:C}=this.i(t,n);this.b=new p(r,a,f,C?[t]:void 0,this.g),this.c=v||[]}h(t){let n={},r=null,a=[];const f=[],v=[];function C(E){Array.isArray(a)?a.push(E):r!==null&&(a[r]=E)}const b={onObjectBegin:()=>{const E={};C(E),f.push(a),a=E,r=null},onObjectProperty:E=>{r=E},onObjectEnd:()=>{a=f.pop()},onArrayBegin:()=>{const E=[];C(E),f.push(a),a=E,r=null},onArrayEnd:()=>{a=f.pop()},onLiteralValue:C,onError:(E,T,j)=>{v.push({error:E,offset:T,length:j})}};if(t)try{A.$2n(t,b),n=a[0]||{}}catch(E){this.g.error(`Error while parsing settings file ${this.f}: ${E}`),this.d=[E]}return n}i(t,n){const r=$.$no.as(d.$so.Configuration).getConfigurationProperties(),a=this.j(t,r,!0,n);t=a.raw;const f=(0,R.$bj)(t,b=>this.g.error(`Conflict in settings file ${this.f}: ${b}`)),v=Object.keys(t),C=this.l(t,b=>this.g.error(`Conflict in settings file ${this.f}: ${b}`));return{contents:f,keys:v,overrides:C,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}j(t,n,r,a){let f=!1;if(!a?.scopes&&!a?.skipRestricted&&!a?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:f};const v={},C=[];for(const b in t)if(d.$Co.test(b)&&r){const E=this.j(t[b],n,!1,a);v[b]=E.raw,f=f||E.hasExcludedProperties,C.push(...E.restricted)}else{const E=n[b],T=E?typeof E.scope<"u"?E.scope:d.ConfigurationScope.WINDOW:void 0;E?.restricted&&C.push(b),!a.exclude?.includes(b)&&(a.include?.includes(b)||(T===void 0||a.scopes===void 0||a.scopes.includes(T))&&!(a.skipRestricted&&E?.restricted))?v[b]=t[b]:f=!0}return{raw:v,restricted:C,hasExcludedProperties:f}}l(t,n){const r=[];for(const a of Object.keys(t))if(d.$Co.test(a)){const f={};for(const v in t[a])f[v]=t[a][v];r.push({identifiers:(0,d.$Do)(a),keys:Object.keys(f),contents:(0,R.$bj)(f,n)})}return r}}e.$Lo=S;class g extends L.$Tc{constructor(t,n,r,a,f){super(),this.c=t,this.f=n,this.g=a,this.h=f,this.b=this.B(new c.$je),this.onDidChange=this.b.event,this.a=new S(this.c.toString(),f),this.B(this.g.watch(r.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(c.Event.any(c.Event.filter(this.g.onDidFilesChange,v=>v.contains(this.c)),c.Event.filter(this.g.onDidRunOperation,v=>(v.isOperation(u.FileOperation.CREATE)||v.isOperation(u.FileOperation.COPY)||v.isOperation(u.FileOperation.DELETE)||v.isOperation(u.FileOperation.WRITE))&&r.isEqual(v.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return p.createEmptyModel(this.h)}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Mo=g;class w{constructor(t,n,r,a,f,v,C,b,E,T,j,U,F){this.a=t,this.b=n,this.c=r,this.overrideIdentifiers=a,this.d=f,this.f=v,this.g=C,this.h=b,this.i=E,this.j=T,this.k=j,this.l=U,this.m=F}get value(){return l(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class P{constructor(t,n,r,a,f,v,C,b,E,T){this.j=t,this.l=n,this.m=r,this.n=a,this.p=f,this.q=v,this.r=C,this.s=b,this.t=E,this.u=T,this.h=null,this.i=new N.$zc,this.v=null}getValue(t,n,r){return this.w(t,n,r).getValue(t)}updateValue(t,n,r={}){let a;r.resource?(a=this.t.get(r.resource),a||(a=p.createEmptyModel(this.u),this.t.set(r.resource,a))):a=this.s,n===void 0?a.removeValue(t):a.setValue(t,n),r.resource||(this.h=null)}inspect(t,n,r){const a=this.w(t,n,r),f=this.A(n.resource,r),v=n.resource?this.t.get(n.resource)||this.s:this.s,C=new Set;for(const b of a.overrides)for(const E of b.identifiers)a.getOverrideValue(t,E)!==void 0&&C.add(E);return new w(t,n,a.getValue(t),C.size?[...C]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.q:void 0,f||void 0,v)}keys(t){const n=this.A(void 0,t);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(t){this.j=t,this.h=null,this.i.clear()}updatePolicyConfiguration(t){this.l=t}updateApplicationConfiguration(t){this.m=t,this.h=null,this.i.clear()}updateLocalUserConfiguration(t){this.n=t,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(t){this.p=t,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(t){this.q=t,this.h=null,this.i.clear()}updateFolderConfiguration(t,n){this.r.set(t,n),this.i.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.i.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const r=[];if(!n){const{added:a,updated:f,removed:v}=h(this.j,t);n=[...a,...f,...v]}for(const a of n)for(const f of(0,d.$Do)(a)){const v=this.j.getKeysForOverrideIdentifier(f),C=t.getKeysForOverrideIdentifier(f),b=[...C.filter(E=>v.indexOf(E)===-1),...v.filter(E=>C.indexOf(E)===-1),...v.filter(E=>!O.$eo(this.j.override(f).getValue(E),t.override(f).getValue(E)))];r.push([f,b])}return this.updateDefaultConfiguration(t),{keys:n,overrides:r}}compareAndUpdatePolicyConfiguration(t){const{added:n,updated:r,removed:a}=h(this.l,t),f=[...n,...r,...a];return f.length&&this.updatePolicyConfiguration(t),{keys:f,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:n,updated:r,removed:a,overrides:f}=h(this.applicationConfiguration,t),v=[...n,...r,...a];return v.length&&this.updateApplicationConfiguration(t),{keys:v,overrides:f}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:r,removed:a,overrides:f}=h(this.localUserConfiguration,t),v=[...n,...r,...a];return v.length&&this.updateLocalUserConfiguration(t),{keys:v,overrides:f}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:r,removed:a,overrides:f}=h(this.remoteUserConfiguration,t),v=[...n,...r,...a];return v.length&&this.updateRemoteUserConfiguration(t),{keys:v,overrides:f}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:r,removed:a,overrides:f}=h(this.workspaceConfiguration,t),v=[...n,...r,...a];return v.length&&this.updateWorkspaceConfiguration(t),{keys:v,overrides:f}}compareAndUpdateFolderConfiguration(t,n){const r=this.folderConfigurations.get(t),{added:a,updated:f,removed:v,overrides:C}=h(r,n),b=[...a,...f,...v];return(b.length||!r)&&this.updateFolderConfiguration(t,n),{keys:b,overrides:C}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:a,removed:f,overrides:v}=h(n,void 0);return{keys:[...r,...a,...f],overrides:v}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(t,n,r){let a=this.x(n,r);return n.overrideIdentifier&&(a=a.override(n.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(t)!==void 0&&(a=a.merge(this.l)),a}x({resource:t},n){let r=this.y();if(n&&t){const a=n.getFolder(t);a&&(r=this.z(a.uri)||r);const f=this.t.get(t);f&&(r=r.merge(f))}return r}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(t){let n=this.i.get(t);if(!n){const r=this.y(),a=this.r.get(t);a?(n=r.merge(a),this.i.set(t,n)):n=r}return n}A(t,n){if(n&&t){const r=n.getFolder(t);if(r)return this.r.get(r.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((t,n)=>{const{contents:r,overrides:a,keys:f}=this.r.get(n);return t.push([n,{contents:r,overrides:a,keys:f}]),t},[])}}allKeys(){const t=new Set;return this.j.keys.forEach(n=>t.add(n)),this.userConfiguration.keys.forEach(n=>t.add(n)),this.q.keys.forEach(n=>t.add(n)),this.r.forEach(n=>n.keys.forEach(r=>t.add(r))),[...t.values()]}B(){const t=new Set;return this.j.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.q.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.r.forEach(n=>n.getAllOverrideIdentifiers().forEach(r=>t.add(r))),[...t.values()]}D(t){const n=new Set;return this.j.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this.q.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this.r.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(a=>n.add(a))),[...n.values()]}static parse(t,n){const r=this.E(t.defaults,n),a=this.E(t.policy,n),f=this.E(t.application,n),v=this.E(t.user,n),C=this.E(t.workspace,n),b=t.folders.reduce((E,T)=>(E.set(y.URI.revive(T[0]),this.E(T[1],n)),E),new N.$zc);return new P(r,a,f,v,p.createEmptyModel(n),C,b,p.createEmptyModel(n),new N.$zc,n)}static E(t,n){return new p(t.contents,t.keys,t.overrides,void 0,n)}}e.$No=P;function m(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const t=new Set,n=new Map;for(const a of s)a.keys.forEach(f=>t.add(f)),a.overrides.forEach(([f,v])=>{const C=(0,N.$wc)(n,f,new Set);v.forEach(b=>C.add(b))});const r=[];return n.forEach((a,f)=>r.push([f,[...a.values()]])),{keys:[...t.values()],overrides:r}}class o{constructor(t,n,r,a,f){this.change=t,this.f=n,this.g=r,this.h=a,this.i=f,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const v of t.keys)this.affectedKeys.add(v);for(const[,v]of t.overrides)for(const C of v)this.affectedKeys.add(C);this.d=this.a;for(const v of this.affectedKeys)this.d+=v+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=P.parse(this.f.data,this.i)),this.j}affectsConfiguration(t,n){const r=this.a+t,a=this.d.indexOf(r);if(a<0)return!1;const f=a+r.length;if(f>=this.d.length)return!1;const v=this.d.charCodeAt(f);if(v!==this.b&&v!==this.c)return!1;if(n){const C=this.previousConfiguration?this.previousConfiguration.getValue(t,n,this.f?.workspace):void 0,b=this.g.getValue(t,n,this.h);return!O.$eo(C,b)}return!0}}e.$Po=o;function h(s,t){const{added:n,removed:r,updated:a}=i(t?.rawConfiguration,s?.rawConfiguration),f=[],v=s?.getAllOverrideIdentifiers()||[],C=t?.getAllOverrideIdentifiers()||[];if(t){const b=C.filter(E=>!v.includes(E));for(const E of b)f.push([E,t.getKeysForOverrideIdentifier(E)])}if(s){const b=v.filter(E=>!C.includes(E));for(const E of b)f.push([E,s.getKeysForOverrideIdentifier(E)])}if(t&&s){for(const b of v)if(C.includes(b)){const E=i({contents:s.getOverrideValue(void 0,b)||{},keys:s.getKeysForOverrideIdentifier(b)},{contents:t.getOverrideValue(void 0,b)||{},keys:t.getKeysForOverrideIdentifier(b)});f.push([b,[...E.added,...E.removed,...E.updated]])}}return{added:n,removed:r,updated:a,overrides:f}}function i(s,t){const n=s?t?s.keys.filter(f=>t.keys.indexOf(f)===-1):[...s.keys]:[],r=t?s?t.keys.filter(f=>s.keys.indexOf(f)===-1):[...t.keys]:[],a=[];if(s&&t){for(const f of t.keys)if(s.keys.indexOf(f)!==-1){const v=(0,R.$ej)(t.contents,f),C=(0,R.$ej)(s.contents,f);O.$eo(v,C)||a.push(f)}}return{added:n,removed:r,updated:a}}}),define(he[182],ue([0,1,17,3,2,29,12,77,47,10,58,44]),function(oe,e,I,c,A,L,N,O,k,y,R,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Ro=e.$Qo=void 0;class u extends A.$Tc{get configurationModel(){return this.b}constructor(S){super(),this.c=S,this.a=this.B(new c.$je),this.onDidChangeConfiguration=this.a.event,this.b=O.$Ko.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(d.$no.as(k.$so.Configuration).onDidUpdateConfiguration(({properties:S,defaultsOverrides:g})=>this.f(Array.from(S),g))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(S,g){this.j(S,d.$no.as(k.$so.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:S})}g(){return{}}h(){this.b=O.$Ko.createEmptyModel(this.c);const S=d.$no.as(k.$so.Configuration).getConfigurationProperties();this.j(Object.keys(S),S)}j(S,g){const w=this.g();for(const P of S){const m=w[P],o=g[P];m!==void 0?this.b.addValue(P,m):o?this.b.addValue(P,o.default):this.b.removeValue(P)}}}e.$Qo=u;class ${constructor(){this.onDidChangeConfiguration=c.Event.None,this.configurationModel=O.$Ko.createEmptyModel(new y.$jk)}async initialize(){return this.configurationModel}}e.$Ro=$;let l=class extends A.$Tc{get configurationModel(){return this.b}constructor(S,g,w){super(),this.c=S,this.f=g,this.g=w,this.a=this.B(new c.$je),this.onDidChangeConfiguration=this.a.event,this.b=O.$Ko.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(S=>this.j(S))),this.B(this.c.onDidChangeConfiguration(async({properties:S})=>this.m(await this.h(S),!0))),this.b}async h(S){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",S);const g={},w=[],P=d.$no.as(k.$so.Configuration).getConfigurationProperties();for(const m of S){const o=P[m];if(!o){w.push(m);continue}if(o.policy){if(o.type!=="string"&&o.type!=="number"){this.g.warn(`Policy ${o.policy.name} has unsupported type ${o.type}`);continue}w.push(m),g[o.policy.name]={type:o.type}}}return(0,N.$pg)(g)||await this.f.updatePolicyDefinitions(g),w}j(S){this.g.trace("PolicyConfiguration#onDidChangePolicies",S);const g=d.$no.as(k.$so.Configuration).getPolicyConfigurations(),w=(0,I.$Gb)(S.map(P=>g.get(P)));this.m(w,!0)}m(S,g){this.g.trace("PolicyConfiguration#update",S);const w=d.$no.as(k.$so.Configuration).getConfigurationProperties(),P=[],m=this.b.isEmpty();for(const o of S){const h=w[o]?.policy?.name;if(h){const i=this.f.getPolicyValue(h);(m?i!==void 0:!(0,L.$eo)(this.b.getValue(o),i))&&P.push([o,i])}else this.b.getValue(o)!==void 0&&P.push([o,void 0])}if(P.length){this.g.trace("PolicyConfiguration#changed",P);const o=this.b;this.b=O.$Ko.createEmptyModel(this.g);for(const h of o.keys)this.b.setValue(h,o.getValue(h));for(const[h,i]of P)i===void 0?this.b.removeValue(h):this.b.setValue(h,i);g&&this.a.fire(this.b)}}};e.$So=l,e.$So=l=ve([Q(1,R.$po),Q(2,y.$9j)],l)}),define(he[183],ue([0,1,17,6,14,3,35,64,2,36,29,5,20,21,77,47,182,7,58]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$,l,p,S,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=void 0;class P extends k.$Tc{constructor(h,i,s,t){super(),this.m=h,this.n=t,this.h=this.B(new L.$je),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new S.$Qo(t)),this.c=s instanceof w.$ro?new S.$Ro:this.B(new S.$So(this.b,s,t)),this.f=this.B(new l.$Mo(this.m,{},u.$7g,i,t)),this.a=new l.$No(this.b.configurationModel,this.c.configurationModel,l.$Ko.createEmptyModel(t),l.$Ko.createEmptyModel(t),l.$Ko.createEmptyModel(t),l.$Ko.createEmptyModel(t),new y.$zc,l.$Ko.createEmptyModel(t),new y.$zc,t),this.j=new m(h,i,this),this.g=this.B(new c.$Oh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:n,properties:r})=>this.s(n,r))),this.B(this.c.onDidChangeConfiguration(n=>this.t(n))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[h,i,s]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new l.$No(h,i,l.$Ko.createEmptyModel(this.n),s,l.$Ko.createEmptyModel(this.n),l.$Ko.createEmptyModel(this.n),new y.$zc,l.$Ko.createEmptyModel(this.n),new y.$zc,this.n)}getConfigurationData(){return this.a.toData()}getValue(h,i){const s=typeof h=="string"?h:void 0,t=(0,$.$0i)(h)?h:(0,$.$0i)(i)?i:{};return this.a.getValue(s,t,void 0)}async updateValue(h,i,s,t,n){const r=(0,$.$$i)(s)?s:(0,$.$0i)(s)?{resource:s.resource,overrideIdentifiers:s.overrideIdentifier?[s.overrideIdentifier]:void 0}:void 0,a=r?t:s;if(a!==void 0&&a!==$.ConfigurationTarget.USER_LOCAL&&a!==$.ConfigurationTarget.USER)throw new Error(`Unable to write ${h} to target ${a}.`);r?.overrideIdentifiers&&(r.overrideIdentifiers=(0,I.$Lb)(r.overrideIdentifiers),r.overrideIdentifiers=r.overrideIdentifiers.length?r.overrideIdentifiers:void 0);const f=this.inspect(h,{resource:r?.resource,overrideIdentifier:r?.overrideIdentifiers?r.overrideIdentifiers[0]:void 0});if(f.policyValue!==void 0)throw new Error(`Unable to write ${h} because it is configured in system policy.`);if((0,R.$eo)(i,f.defaultValue)&&(i=void 0),r?.overrideIdentifiers?.length&&r.overrideIdentifiers.length>1){const C=r.overrideIdentifiers.sort(),b=this.a.localUserConfiguration.overrides.find(E=>(0,I.$tb)([...E.identifiers].sort(),C));b&&(r.overrideIdentifiers=b.identifiers)}const v=r?.overrideIdentifiers?.length?[(0,p.$Eo)(r.overrideIdentifiers),h]:[h];await this.j.write(v,i),await this.reloadConfiguration()}inspect(h,i={}){return this.a.inspect(h,i,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const h=await this.f.loadConfiguration();this.r(h)}r(h){const i=this.a.toData(),s=this.a.compareAndUpdateLocalUserConfiguration(h);this.u(s,i,$.ConfigurationTarget.USER)}s(h,i){const s=this.a.toData(),t=this.a.compareAndUpdateDefaultConfiguration(h,i);this.u(t,s,$.ConfigurationTarget.DEFAULT)}t(h){const i=this.a.toData(),s=this.a.compareAndUpdatePolicyConfiguration(h);this.u(s,i,$.ConfigurationTarget.DEFAULT)}u(h,i,s){const t=new l.$Po(h,{data:i},this.a,void 0,this.n);t.source=s,this.h.fire(t)}}e.$To=P;class m{constructor(h,i,s){this.b=h,this.c=i,this.d=s,this.a=new c.$Jh}write(h,i){return this.a.queue(()=>this.e(h,i))}async e(h,i){let s;try{s=(await this.c.readFile(this.b)).value.toString()}catch(r){if(r.fileOperationResult===g.FileOperationResult.FILE_NOT_FOUND)s="{}";else throw r}const t=[];if((0,N.$Un)(s,t,{allowTrailingComma:!0,allowEmptyContent:!0}),t.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.f(s,h,i);s=(0,O.$_n)(s,n),await this.c.writeFile(this.b,A.$Le.fromString(s))}f(h,i,s){const{tabSize:t,insertSpaces:n,eol:r}=this.h;if(!i.length){const a=JSON.stringify(s,null,n?" ".repeat(t):"	");return[{content:a,length:a.length,offset:0}]}return(0,O.$9n)(h,i,s,{tabSize:t,insertSpaces:n,eol:r})}get h(){if(!this.g){let h=d.OS===d.OperatingSystem.Linux||d.OS===d.OperatingSystem.Macintosh?`
`:`\r
`;const i=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});i&&typeof i=="string"&&i!=="auto"&&(h=i),this.g={eol:h,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(he[184],ue([0,1,14,3,2,69]),function(oe,e,I,c,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dxb=e.$bxb=e.$axb=void 0,e.$cxb=O;const N=(y,R,d)=>{const u=new Uint8Array(16);for(let p=0;p<16;p++)u[p]=Math.round(Math.random()*256);const $=(0,I.$6e)(I.$Le.wrap(u));return[`GET ws://localhost${y}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${$}`].join(`\r
`)+`\r
\r
`};e.$axb=N,e.$bxb=I.$Le.fromString(`\r
\r
`);async function O(y,R,d,u,$){y.write(I.$Le.fromString((0,e.$axb)(R,d,u)));const l=new A.$Sc;try{return await new Promise((p,S)=>{let g;l.add(y.onData(w=>{g?g=I.$Le.concat([g,w],g.byteLength+w.byteLength):g=w;const P=g.indexOf(e.$bxb);if(P===-1)return;p(y),y.pauseData();const m=g.slice(P+e.$bxb.byteLength);m.byteLength&&$.onData.fire(m)})),l.add(y.onClose(w=>S(w??new Error("socket closed")))),l.add(y.onEnd(()=>S(new Error("socket ended"))))})}catch(p){throw y.dispose(),p}finally{l.dispose()}}class k extends A.$Tc{constructor(R,d){super(),this.g=R,this.a=this.B(new c.$me),this.onData=(...u)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...u)),this.b=this.B(new c.$je),this.onDidDispose=this.b.event,this.f=!1,this.B(d.onData),this.B(d.onData.event(u=>this.a.fire(u))),this.onClose=this.B(d.onClose).event,this.onEnd=this.B(d.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(R,d){L.SocketDiagnostics.traceSocketEvent(this,this.g,R,d)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$dxb=k}),define(he[104],ue([0,1,8,4]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.RemoteAuthorityResolverErrorCode=e.$Pl=e.$Ol=e.RemoteConnectionType=e.$Nl=void 0,e.$Rl=y,e.$Nl=(0,c.$Ci)("remoteAuthorityResolverService");var A;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(A||(e.RemoteConnectionType=A={}));class L{constructor(d){this.id=d,this.type=A.Managed}toString(){return`Managed(${this.id})`}}e.$Ol=L;class N{constructor(d,u){this.host=d,this.port=u,this.type=A.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Pl=N;var O;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(O||(e.RemoteAuthorityResolverErrorCode=O={}));class k extends I.$ab{static isNotAvailable(d){return d instanceof k&&d._code===O.NotAvailable}static isTemporarilyNotAvailable(d){return d instanceof k&&d._code===O.TemporarilyNotAvailable}static isNoResolverFound(d){return d instanceof k&&d._code===O.NoResolverFound}static isInvalidAuthority(d){return d instanceof k&&d._code===O.InvalidAuthority}static isHandled(d){return d instanceof k&&d.isHandled}constructor(d,u=O.Unknown,$){super(d),this._message=d,this._code=u,this._detail=$,this.isHandled=u===O.NotAvailable&&$===!0,Object.setPrototypeOf(this,k.prototype)}}e.$Ql=k;function y(R){const d=R.indexOf("+");return d===-1?R:R.substring(0,d)}}),define(he[185],ue([0,1,6,14,25,8,3,2,22,100,54,31,69,104]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Wl=f,e.$Xl=v,e.$Yl=b,y=ke(y);const l=30*1e3;var p;(function(H){H[H.Management=1]="Management",H[H.ExtensionHost=2]="ExtensionHost",H[H.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function S(H){switch(H){case p.Management:return"Management";case p.ExtensionHost:return"ExtensionHost";case p.Tunnel:return"Tunnel"}}function g(H){const B=new A.$ue;return setTimeout(()=>B.cancel(),H),B.token}function w(H,B){if(H.isCancellationRequested||B.isCancellationRequested)return A.CancellationToken.Cancelled;const D=new A.$ue;return H.onCancellationRequested(()=>D.cancel()),B.onCancellationRequested(()=>D.cancel()),D.token}class P{get didTimeout(){return this.c==="timedout"}constructor(B){this.c="pending",this.d=new O.$Sc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,I.$vh)(),B.isCancellationRequested?this.h():this.d.add(B.onCancellationRequested(()=>this.h()))}registerDisposable(B){this.c==="pending"?this.d.add(B):B.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(B))}reject(B){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(B))}}function m(H,B){const D=new P(B);return D.registerDisposable(H.onControlMessage(J=>{const q=JSON.parse(J.toString()),M=z(q);M?D.reject(M):D.resolve(q)})),D.promise}function o(H,B,D,J,q,M,Z,ee){const X=new P(ee),re=R.$de.create(!1);return H.info(`Creating a socket (${Z})...`),y.mark(`code/willCreateSocket/${M}`),B.connect(D,J,q,Z).then(le=>{X.didTimeout?(y.mark(`code/didCreateSocketError/${M}`),H.info(`Creating a socket (${Z}) finished after ${re.elapsed()} ms, but this is too late and has timed out already.`),le?.dispose()):(y.mark(`code/didCreateSocketOK/${M}`),H.info(`Creating a socket (${Z}) was successful after ${re.elapsed()} ms.`),X.resolve(le))},le=>{y.mark(`code/didCreateSocketError/${M}`),H.info(`Creating a socket (${Z}) returned an error after ${re.elapsed()} ms.`),H.error(le),X.reject(le)}),X.promise}function h(H,B){const D=new P(B);return H.then(J=>{D.didTimeout||D.resolve(J)},J=>{D.didTimeout||D.reject(J)}),D.promise}async function i(H,B,D,J){const q=te(H,B);H.logService.trace(`${q} 1/6. invoking socketFactory.connect().`);let M;try{M=await o(H.logService,H.remoteSocketFactoryService,H.connectTo,k.$Pg.getServerRootPath(),`reconnectionToken=${H.reconnectionToken}&reconnection=${H.reconnectionProtocol?"true":"false"}`,S(B),`renderer-${S(B)}-${H.reconnectionToken}`,J)}catch(le){throw H.logService.error(`${q} socketFactory.connect() failed or timed out. Error:`),H.logService.error(le),le}H.logService.trace(`${q} 2/6. socketFactory.connect() was successful.`);let Z,ee;H.reconnectionProtocol?(H.reconnectionProtocol.beginAcceptReconnection(M,null),Z=H.reconnectionProtocol,ee=!1):(Z=new u.$qi({socket:M}),ee=!0),H.logService.trace(`${q} 3/6. sending AuthRequest control message.`);const X=await h(H.signService.createNewMessage((0,d.$Yg)()),J),re={type:"auth",auth:H.connectionToken||"00000000000000000000",data:X.data};Z.sendControl(c.$Le.fromString(JSON.stringify(re)));try{const le=await m(Z,w(J,g(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(H.logService.trace(`${q} 4/6. received SignRequest control message.`),!await h(H.signService.validate(X,le.signedData),J)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const pe=await h(H.signService.sign(le.data),J),Ee={type:"connectionType",commit:H.commit,signedData:pe,desiredConnectionType:B};return D&&(Ee.args=D),H.logService.trace(`${q} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(c.$Le.fromString(JSON.stringify(Ee))),{protocol:Z,ownsProtocol:ee}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(H.logService.error(`${q} the handshake timed out. Error:`),H.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(H.logService.error(`${q} received error control message when negotiating connection. Error:`),H.logService.error(le)),ee&&V(Z),le}}async function s(H,B,D,J){const q=Date.now(),M=te(H,B),{protocol:Z,ownsProtocol:ee}=await i(H,B,D,J),X=new P(J);return X.registerDisposable(Z.onControlMessage(re=>{const le=JSON.parse(re.toString()),ge=z(le);ge?(H.logService.error(`${M} received error control message when negotiating connection. Error:`),H.logService.error(ge),ee&&V(Z),X.reject(ge)):(H.reconnectionProtocol?.endAcceptReconnection(),H.logService.trace(`${M} 6/6. handshake finished, connection is up and running after ${Y(q)}!`),X.resolve({protocol:Z,firstMessage:le}))})),X.promise}async function t(H,B){const{protocol:D}=await s(H,p.Management,void 0,B);return{protocol:D}}async function n(H,B,D){const{protocol:J,firstMessage:q}=await s(H,p.ExtensionHost,B,D),M=q&&q.debugPort;return{protocol:J,debugPort:M}}async function r(H,B,D){const J=Date.now(),q=te(H,p.Tunnel),{protocol:M}=await i(H,p.Tunnel,B,D);return H.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${Y(J)}!`),M}async function a(H,B,D){const{connectTo:J,connectionToken:q}=await H.addressProvider.getAddress();return{commit:H.commit,quality:H.quality,connectTo:J,connectionToken:q,reconnectionToken:B,reconnectionProtocol:D,remoteSocketFactoryService:H.remoteSocketFactoryService,signService:H.signService,logService:H.logService}}async function f(H,B,D){return C(H,async J=>{const{protocol:q}=await t(J,A.CancellationToken.None);return new G(H,B,D,J.reconnectionToken,q)})}async function v(H,B){return C(H,async D=>{const{protocol:J,debugPort:q}=await n(D,B,A.CancellationToken.None);return new ie(H,B,D.reconnectionToken,J,q)})}async function C(H,B){for(let J=1;;J++)try{const q=(0,d.$Yg)(),M=await a(H,q,null);return await B(M)}catch(q){if(J<5)H.logService.error(`[remote-connection][attempt ${J}] An error occurred in initial connection! Will retry... Error:`),H.logService.error(q);else throw H.logService.error(`[remote-connection][attempt ${J}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),H.logService.error(q),x.triggerPermanentFailure(0,0,$.$Ql.isHandled(q)),q}}async function b(H,B,D){const J=await a(H,(0,d.$Yg)(),null);return await r(J,{host:B,port:D},A.CancellationToken.None)}function E(H){return(0,I.$ph)(B=>new Promise((D,J)=>{const q=setTimeout(D,H*1e3);B.onCancellationRequested(()=>{clearTimeout(q),D()})}))}var T;(function(H){H[H.ConnectionLost=0]="ConnectionLost",H[H.ReconnectionWait=1]="ReconnectionWait",H[H.ReconnectionRunning=2]="ReconnectionRunning",H[H.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",H[H.ConnectionGain=4]="ConnectionGain"})(T||(e.PersistentConnectionEventType=T={}));class j{constructor(B,D){this.reconnectionToken=B,this.millisSinceLastIncomingData=D,this.type=T.ConnectionLost}}e.$Zl=j;class U{constructor(B,D,J,q){this.reconnectionToken=B,this.millisSinceLastIncomingData=D,this.durationSeconds=J,this.c=q,this.type=T.ReconnectionWait}skipWait(){this.c.cancel()}}e.$1l=U;class F{constructor(B,D,J){this.reconnectionToken=B,this.millisSinceLastIncomingData=D,this.attempt=J,this.type=T.ReconnectionRunning}}e.$2l=F;class K{constructor(B,D,J){this.reconnectionToken=B,this.millisSinceLastIncomingData=D,this.attempt=J,this.type=T.ConnectionGain}}e.$3l=K;class W{constructor(B,D,J,q){this.reconnectionToken=B,this.millisSinceLastIncomingData=D,this.attempt=J,this.handled=q,this.type=T.ReconnectionPermanentFailure}}e.$4l=W;class x extends O.$Tc{static triggerPermanentFailure(B,D,J){this._permanentFailure=!0,this.f=B,this.g=D,this.h=J,this.j.forEach(q=>q.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(B=>B.y())}static debugPauseSocketWriting(){this.j.forEach(B=>B.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||x._permanentFailure}constructor(B,D,J,q,M){super(),this.t=B,this.u=D,this.reconnectionToken=J,this.protocol=q,this.w=M,this.m=this.B(new N.$je),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new K(this.reconnectionToken,0,0)),this.B(q.onSocketClose(Z=>{const ee=ce(this.t,this.reconnectionToken,!0);Z?Z.type===u.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${ee} received socket close event (hadError: ${Z.hadError}).`),Z.error&&this.u.logService.error(Z.error)):(this.u.logService.info(`${ee} received socket close event (wasClean: ${Z.wasClean}, code: ${Z.code}, reason: ${Z.reason}).`),Z.event&&this.u.logService.error(Z.event)):this.u.logService.info(`${ee} received socket close event.`),this.y()})),this.B(q.onSocketTimeout(Z=>{const ee=ce(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ee} received socket timeout event (unacknowledgedMsgCount: ${Z.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Z.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Z.timeSinceLastReceivedSomeData}).`),this.y()})),x.j.push(this),this.B((0,O.$Rc)(()=>{const Z=x.j.indexOf(this);Z>=0&&x.j.splice(Z,1)})),this.n&&this.D(x.f,x.g,x.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const B=ce(this.t,this.reconnectionToken,!0);this.u.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const D=[0,5,5,10,10,10,10,10,30];let J=-1;do{J++;const q=J<D.length?D[J]:D[D.length-1];try{if(q>0){const Z=E(q);this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q,Z)),this.u.logService.info(`${B} waiting for ${q} seconds before reconnecting...`);try{await Z}catch{}}if(this.n){this.u.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),J+1)),this.u.logService.info(`${B} resolving connection...`);const M=await a(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${B} connecting to ${M.connectTo}...`),await this.G(M,g(l)),this.u.logService.info(`${B} reconnected!`),this.m.fire(new K(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),J+1));break}catch(M){if(M.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(M),this.C(this.protocol.getMillisSinceLastIncomingData(),J+1,!1);break}if(J>360){this.u.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(M),this.C(this.protocol.getMillisSinceLastIncomingData(),J+1,!1);break}if($.$Ql.isTemporarilyNotAvailable(M)){this.u.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(M);continue}if((M.code==="ETIMEDOUT"||M.code==="ENETUNREACH"||M.code==="ECONNREFUSED"||M.code==="ECONNRESET")&&M.syscall==="connect"){this.u.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(M);continue}if((0,L.$3)(M)){this.u.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(M);continue}if(M instanceof $.$Ql){this.u.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(M),this.C(this.protocol.getMillisSinceLastIncomingData(),J+1,$.$Ql.isHandled(M));break}this.u.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(M),this.C(this.protocol.getMillisSinceLastIncomingData(),J+1,!1);break}}while(!this.n&&!this.s)}C(B,D,J){this.w?x.triggerPermanentFailure(B,D,J):this.D(B,D,J)}D(B,D,J){this.m.fire(new W(this.reconnectionToken,B,D,J)),V(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$5l=x;class G extends x{constructor(B,D,J,q,M){super(p.Management,B,q,M,!0),this.client=this.B(new u.$oi(M,{remoteAuthority:D,clientId:J},B.ipcLogger))}async G(B,D){await t(B,D)}}e.$6l=G;class ie extends x{constructor(B,D,J,q,M){super(p.ExtensionHost,B,J,q,!1),this.H=D,this.debugPort=M}async G(B,D){await n(B,this.H,D)}}e.$7l=ie;function V(H){try{H.acceptDisconnect();const B=H.getSocket();H.dispose(),B.dispose()}catch(B){(0,L.$Y)(B)}}function z(H){if(H&&H.type==="error"){const B=new Error(`Connection error: ${H.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function _(H,B){for(;H.length<B;)H+=" ";return H}function ne(H,B){return`[remote-connection][${_(S(H),13)}][${B.substr(0,5)}\u2026]`}function ce(H,B,D){return`${ne(H,B)}[${D?"reconnect":"initial"}]`}function te(H,B){return`${ce(B,H.reconnectionToken,!!H.reconnectionProtocol)}[${H.connectTo}]`}function Y(H){return`${Date.now()-H} ms`}}),define(he[105],ue([0,1,22]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=c,e.$en=A,e.$fn=L,e.$gn=N;function c(k){return k.scheme===I.Schemas.vscodeRemote?k.authority:void 0}function A(k){if(!k)return;const y=k.indexOf("+");return y<0?k:k.substr(0,y)}function L(k){const{host:y,port:R}=O(k);if(typeof R>"u")throw new Error(`Invalid remote authority: ${k}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:y,port:R}}function N(k,y){let{host:R,port:d}=O(k);return typeof d>"u"&&(d=y),{host:R,port:d}}function O(k){const y=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(y)return{host:y[1],port:parseInt(y[2],10)};const R=k.match(/^(\[[0-9a-z:]+\])$/);if(R)return{host:R[1],port:void 0};const d=k.match(/(.*):(\d+)$/);return d?{host:d[1],port:parseInt(d[2],10)}:{host:k,port:void 0}}}),define(he[33],ue([0,1,26,4,105]),function(oe,e,I,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=e.$pn=e.$on=e.$nn=e.TargetPlatform=e.ExtensionType=e.$mn=e.$kn=e.$jn=e.$in=e.$hn=void 0,e.$ln=L,e.$qn=d,e.$rn=u,e.$sn=$,e.$tn=l,e.$un=p,e.$vn=S,I=ke(I),e.$hn="extensions.user.cache",e.$in="extensions.builtin.cache",e.$jn="undefined_publisher",e.$kn=["ui","workspace","web"];function L(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}e.$mn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var N;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(N||(e.ExtensionType=N={}));var O;(function(g){g.WIN32_X64="win32-x64",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(O||(e.TargetPlatform=O={}));class k{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,P){if(typeof w>"u"||w===null)return typeof P>"u"||P===null;if(typeof P>"u"||P===null)return!1;if(typeof w=="string"||typeof P=="string"){const m=typeof w=="string"?w:w.value,o=typeof P=="string"?P:P.value;return I.$Df(m,o)}return w._lower===P._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.$nn=k;class y{get size(){return this.c.size}constructor(w){if(this.c=new Set,w)for(const P of w)this.add(P)}add(w){this.c.add(k.toKey(w))}delete(w){return this.c.delete(k.toKey(w))}has(w){return this.c.has(k.toKey(w))}}e.$on=y;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(w){this.c.delete(k.toKey(w))}get(w){return this.c.get(k.toKey(w))}has(w){return this.c.has(k.toKey(w))}set(w,P){this.c.set(k.toKey(w),P)}values(){return this.c.values()}forEach(w){this.c.forEach(w)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$pn=R;function d(g){return u(g)}function u(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}function $(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}function l(g,w){if(w){const P=`onResolveRemoteAuthority:${(0,A.$en)(w)}`;return!!g.activationEvents?.includes(P)}return!1}function p(g){return g.map(w=>{const[P,m]=w.split("@");return{proposalName:P,version:m?parseInt(m):void 0}})}function S(g){return g.map(w=>w.split("@")[0])}e.$wn=(0,c.$Ci)("IBuiltinExtensionsScannerService")}),define(he[27],ue([0,1,5,11,33,4]),function(oe,e,I,c,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.ExtensionManagementErrorCode=e.$ip=e.ExtensionGalleryErrorCode=e.$hp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=void 0,e.$bp=O,e.$cp=k,e.$dp=y,e.$ep=R,e.$fp=d,e.$gp=u,e.$7o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$8o=new RegExp(e.$7o),e.$9o="__web_extension",e.$0o="skipWalkthrough",e.$$o="extensionInstallSource",e.$_o="dependecyOrPackExtensionInstall",e.$ap="clientTargetPlatform";var N;(function(o){o.COMMAND="command",o.SETTINGS_SYNC="settingsSync"})(N||(e.ExtensionInstallSource=N={}));function O(o){switch(o){case A.TargetPlatform.WIN32_X64:return"Windows 64 bit";case A.TargetPlatform.WIN32_ARM64:return"Windows ARM";case A.TargetPlatform.LINUX_X64:return"Linux 64 bit";case A.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case A.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case A.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case A.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case A.TargetPlatform.DARWIN_X64:return"Mac";case A.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case A.TargetPlatform.WEB:return"Web";case A.TargetPlatform.UNIVERSAL:return A.TargetPlatform.UNIVERSAL;case A.TargetPlatform.UNKNOWN:return A.TargetPlatform.UNKNOWN;case A.TargetPlatform.UNDEFINED:return A.TargetPlatform.UNDEFINED}}function k(o){switch(o){case A.TargetPlatform.WIN32_X64:return A.TargetPlatform.WIN32_X64;case A.TargetPlatform.WIN32_ARM64:return A.TargetPlatform.WIN32_ARM64;case A.TargetPlatform.LINUX_X64:return A.TargetPlatform.LINUX_X64;case A.TargetPlatform.LINUX_ARM64:return A.TargetPlatform.LINUX_ARM64;case A.TargetPlatform.LINUX_ARMHF:return A.TargetPlatform.LINUX_ARMHF;case A.TargetPlatform.ALPINE_X64:return A.TargetPlatform.ALPINE_X64;case A.TargetPlatform.ALPINE_ARM64:return A.TargetPlatform.ALPINE_ARM64;case A.TargetPlatform.DARWIN_X64:return A.TargetPlatform.DARWIN_X64;case A.TargetPlatform.DARWIN_ARM64:return A.TargetPlatform.DARWIN_ARM64;case A.TargetPlatform.WEB:return A.TargetPlatform.WEB;case A.TargetPlatform.UNIVERSAL:return A.TargetPlatform.UNIVERSAL;default:return A.TargetPlatform.UNKNOWN}}function y(o,h){switch(o){case I.Platform.Windows:return h==="x64"?A.TargetPlatform.WIN32_X64:h==="arm64"?A.TargetPlatform.WIN32_ARM64:A.TargetPlatform.UNKNOWN;case I.Platform.Linux:return h==="x64"?A.TargetPlatform.LINUX_X64:h==="arm64"?A.TargetPlatform.LINUX_ARM64:h==="arm"?A.TargetPlatform.LINUX_ARMHF:A.TargetPlatform.UNKNOWN;case"alpine":return h==="x64"?A.TargetPlatform.ALPINE_X64:h==="arm64"?A.TargetPlatform.ALPINE_ARM64:A.TargetPlatform.UNKNOWN;case I.Platform.Mac:return h==="x64"?A.TargetPlatform.DARWIN_X64:h==="arm64"?A.TargetPlatform.DARWIN_ARM64:A.TargetPlatform.UNKNOWN;case I.Platform.Web:return A.TargetPlatform.WEB}}function R(o,h){return h===A.TargetPlatform.WEB&&!o.includes(A.TargetPlatform.WEB)}function d(o,h,i){return R(h,i)?!1:o===A.TargetPlatform.UNDEFINED||o===A.TargetPlatform.UNIVERSAL?!0:o===A.TargetPlatform.UNKNOWN?!1:o===i}function u(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}var $;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})($||(e.SortBy=$={}));var l;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(l||(e.SortOrder=l={}));var p;(function(o){o.Install="install",o.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var S;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(S||(e.InstallOperation=S={})),e.$hp=(0,L.$Ci)("extensionGalleryService");var g;(function(o){o.Timeout="Timeout",o.Cancelled="Cancelled",o.Failed="Failed",o.DownloadFailedWriting="DownloadFailedWriting"})(g||(e.ExtensionGalleryErrorCode=g={}));class w extends Error{constructor(h,i){super(h),this.code=i,this.name=i}}e.$ip=w;var P;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatibleApi="IncompatibleApi",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.DownloadSignature="DownloadSignature",o.DownloadFailedWriting="DownloadFailedWriting",o.UpdateExistingMetadata="UpdateExistingMetadata",o.UpdateMetadata="UpdateMetadata",o.Extract="Extract",o.Scanning="Scanning",o.ScanningExtension="ScanningExtension",o.ReadUninstalled="ReadUninstalled",o.UnsetUninstalled="UnsetUninstalled",o.Delete="Delete",o.Rename="Rename",o.IntializeDefaultProfile="IntializeDefaultProfile",o.AddToProfile="AddToProfile",o.InstalledExtensionNotFound="InstalledExtensionNotFound",o.PostInstall="PostInstall",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Signature="Signature",o.NotAllowed="NotAllowed",o.Gallery="Gallery",o.Cancelled="Cancelled",o.Unknown="Unknown",o.Internal="Internal"})(P||(e.ExtensionManagementErrorCode=P={}));class m extends Error{constructor(h,i){super(h),this.code=i,this.name=i}}e.$jp=m,e.$kp=(0,L.$Ci)("extensionManagementService"),e.$lp="extensionsIdentifiers/disabled",e.$mp="extensionsIdentifiers/enabled",e.$np=(0,L.$Ci)("IGlobalExtensionEnablementService"),e.$op=(0,L.$Ci)("IExtensionTipsService"),e.$pp=(0,c.localize2)(11334,"Extensions"),e.$qp=(0,c.localize2)(11335,"Preferences")}),define(he[186],ue([0,1,3,2,29,9,94,27]),function(oe,e,I,c,A,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=e.$uq=e.$tq=void 0;function k(S,g){return S?L.URI.revive(g?g.transformIncoming(S):S):void 0}function y(S,g){return g?g.transformOutgoingURI(S):S}function R(S,g){g=g||N.$Jn;const w=S.manifest;return{...(0,N.$Mn)({...S,manifest:void 0},g),manifest:w}}function d(S,g){return S?.profileLocation?(0,N.$Mn)(S,g??N.$Jn):S}function u(S,g){return g?(0,A.$co)(S,w=>w instanceof L.URI?g.transformOutgoingURI(w):void 0):S}class ${constructor(g,w){this.a=g,this.b=w,this.onInstallExtension=I.Event.buffer(g.onInstallExtension,!0),this.onDidInstallExtensions=I.Event.buffer(g.onDidInstallExtensions,!0),this.onUninstallExtension=I.Event.buffer(g.onUninstallExtension,!0),this.onDidUninstallExtension=I.Event.buffer(g.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=I.Event.buffer(g.onDidUpdateExtensionMetadata,!0)}listen(g,w){const P=this.b(g);switch(w){case"onInstallExtension":return I.Event.map(this.onInstallExtension,m=>({...m,profileLocation:m.profileLocation?y(m.profileLocation,P):m.profileLocation}));case"onDidInstallExtensions":return I.Event.map(this.onDidInstallExtensions,m=>m.map(o=>({...o,local:o.local?u(o.local,P):o.local,profileLocation:o.profileLocation?y(o.profileLocation,P):o.profileLocation})));case"onUninstallExtension":return I.Event.map(this.onUninstallExtension,m=>({...m,profileLocation:m.profileLocation?y(m.profileLocation,P):m.profileLocation}));case"onDidUninstallExtension":return I.Event.map(this.onDidUninstallExtension,m=>({...m,profileLocation:m.profileLocation?y(m.profileLocation,P):m.profileLocation}));case"onDidUpdateExtensionMetadata":return I.Event.map(this.onDidUpdateExtensionMetadata,m=>({local:u(m.local,P),profileLocation:y(m.profileLocation,P)}))}throw new Error("Invalid listen")}async call(g,w,P){const m=this.b(g);switch(w){case"zip":{const o=R(P[0],m),h=await this.a.zip(o);return y(h,m)}case"unzip":return this.a.unzip(k(P[0],m));case"install":return this.a.install(k(P[0],m),d(P[1],m));case"installFromLocation":return this.a.installFromLocation(k(P[0],m),k(P[1],m));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(P[0],k(P[1],m),k(P[2],m));case"getManifest":return this.a.getManifest(k(P[0],m));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(P[0]);case"installFromGallery":return this.a.installFromGallery(P[0],d(P[1],m));case"installGalleryExtensions":{const o=P[0];return this.a.installGalleryExtensions(o.map(({extension:h,options:i})=>({extension:h,options:d(i,m)??{}})))}case"uninstall":return this.a.uninstall(R(P[0],m),d(P[1],m));case"reinstallFromGallery":return this.a.reinstallFromGallery(R(P[0],m));case"getInstalled":return(await this.a.getInstalled(P[0],k(P[1],m),P[2])).map(h=>u(h,m));case"toggleAppliationScope":{const o=await this.a.toggleAppliationScope(R(P[0],m),k(P[1],m));return u(o,m)}case"copyExtensions":return this.a.copyExtensions(k(P[0],m),k(P[1],m));case"updateMetadata":{const o=await this.a.updateMetadata(R(P[0],m),P[1],k(P[2],m));return u(o,m)}case"resetPinnedStateForAllUserExtensions":return this.a.resetPinnedStateForAllUserExtensions(P[0]);case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(P[0],P[1],P[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$tq=$;class l extends c.$Tc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(g){super(),this.m=g,this.c=this.B(new I.$je),this.f=this.B(new I.$je),this.g=this.B(new I.$je),this.h=this.B(new I.$je),this.j=this.B(new I.$je),this.B(this.m.listen("onInstallExtension")(w=>this.n(this.c,{...w,source:this.r(w.source)?L.URI.revive(w.source):w.source,profileLocation:L.URI.revive(w.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(w=>this.n(this.f,w.map(P=>({...P,local:P.local?R(P.local,null):P.local,source:this.r(P.source)?L.URI.revive(P.source):P.source,profileLocation:L.URI.revive(P.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(w=>this.n(this.g,{...w,profileLocation:L.URI.revive(w.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(w=>this.n(this.h,{...w,profileLocation:L.URI.revive(w.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(w=>this.n(this.j,{profileLocation:L.URI.revive(w.profileLocation),local:R(w.local,null)})))}n(g,w){g.fire(w)}r(g){return g?typeof g.path=="string"&&typeof g.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(g){const w=await this.getTargetPlatform();return g.allTargetPlatforms.some(P=>(0,O.$fp)(P,g.allTargetPlatforms,w))}zip(g){return Promise.resolve(this.m.call("zip",[g]).then(w=>L.URI.revive(w)))}unzip(g){return Promise.resolve(this.m.call("unzip",[g]))}install(g,w){return Promise.resolve(this.m.call("install",[g,w])).then(P=>R(P,null))}installFromLocation(g,w){return Promise.resolve(this.m.call("installFromLocation",[g,w])).then(P=>R(P,null))}async installExtensionsFromProfile(g,w,P){return(await this.m.call("installExtensionsFromProfile",[g,w,P])).map(o=>R(o,null))}getManifest(g){return Promise.resolve(this.m.call("getManifest",[g]))}installFromGallery(g,w){return Promise.resolve(this.m.call("installFromGallery",[g,w])).then(P=>R(P,null))}async installGalleryExtensions(g){return(await this.m.call("installGalleryExtensions",[g])).map(P=>({...P,local:P.local?R(P.local,null):P.local,source:this.r(P.source)?L.URI.revive(P.source):P.source,profileLocation:L.URI.revive(P.profileLocation)}))}uninstall(g,w){if(g.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[g,w]))}reinstallFromGallery(g){return Promise.resolve(this.m.call("reinstallFromGallery",[g])).then(w=>R(w,null))}getInstalled(g=null,w,P){return Promise.resolve(this.m.call("getInstalled",[g,w,P])).then(m=>m.map(o=>R(o,null)))}updateMetadata(g,w,P){return Promise.resolve(this.m.call("updateMetadata",[g,w,P])).then(m=>R(m,null))}resetPinnedStateForAllUserExtensions(g){return this.m.call("resetPinnedStateForAllUserExtensions",[g])}toggleAppliationScope(g,w){return this.m.call("toggleAppliationScope",[g,w]).then(P=>R(P,null))}copyExtensions(g,w){return this.m.call("copyExtensions",[g,w])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(g,w,P){const m=await this.m.call("download",[g,w,P]);return L.URI.revive(m)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$uq=l;class p{constructor(g){this.a=g}listen(g,w){throw new Error("Invalid listen")}call(g,w,P){switch(w){case"getConfigBasedTips":return this.a.getConfigBasedTips(L.URI.revive(P[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$vq=p}),define(he[187],ue([0,1,2,33,7]),function(oe,e,I,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=void 0;class L extends I.$Tc{constructor(O,k,y,R,d){super(),this.a=O,this.b=k,this.c=y,this.f=d,this.B(R.onDidInstallExtensions(u=>this.g(u))),this.B(R.onDidUninstallExtension(u=>this.h(u)))}g(O){for(const k of O)k.local&&this.invalidate(k.profileLocation)}h(O){O.error||this.invalidate(O.profileLocation)}async invalidate(O){if(O)for(const k of this.a.profiles)this.c.extUri.isEqual(k.extensionsResource,O)&&await this.j(k);else await this.j(this.a.defaultProfile)}async j(O){try{await this.b.del(this.c.extUri.joinPath(O.cacheHome,c.$hn))}catch(k){(0,A.$nl)(k)!==A.FileOperationResult.FILE_NOT_FOUND&&this.f.error(k)}}}e.$Sq=L});var it=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(he[59],ue([0,1,20,92,11,60,33,158]),function(oe,e,I,c,A,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=R,e.$Wp=d,e.$Xp=u,e.$Yp=$,e.$Zp=l,e.$1p=p,e.$2p=S,e.$3p=g,c=it(c),A=ke(A),L=ke(L);const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,y=/^-(\d{4})(\d{2})(\d{2})$/;function R(m){return m=m.trim(),m==="*"||k.test(m)}function d(m){if(!R(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const o=m.match(k);return o?{hasCaret:o[1]==="^",hasGreaterEquals:o[1]===">=",majorBase:o[2]==="x"?0:parseInt(o[2],10),majorMustEqual:o[2]!=="x",minorBase:o[4]==="x"?0:parseInt(o[4],10),minorMustEqual:o[4]!=="x",patchBase:o[6]==="x"?0:parseInt(o[6],10),patchMustEqual:o[6]!=="x",preRelease:o[8]||null}:null}function u(m){if(!m)return null;const o=m.majorBase,h=m.majorMustEqual,i=m.minorBase;let s=m.minorMustEqual;const t=m.patchBase;let n=m.patchMustEqual;m.hasCaret&&(o===0||(s=!1),n=!1);let r=0;if(m.preRelease){const a=y.exec(m.preRelease);if(a){const[,f,v,C]=a;r=Date.UTC(Number(f),Number(v)-1,Number(C))}}return{majorBase:o,majorMustEqual:h,minorBase:i,minorMustEqual:s,patchBase:t,patchMustEqual:n,isMinimum:m.hasGreaterEquals,notBefore:r}}function $(m,o,h){let i;typeof m=="string"?i=u(d(m)):i=m;let s;o instanceof Date?s=o.getTime():typeof o=="string"&&(s=new Date(o).getTime());let t;if(typeof h=="string"?t=u(d(h)):t=h,!i||!t)return!1;const n=i.majorBase,r=i.minorBase,a=i.patchBase;let f=t.majorBase,v=t.minorBase,C=t.patchBase;const b=t.notBefore;let E=t.majorMustEqual,T=t.minorMustEqual,j=t.patchMustEqual;return t.isMinimum?n>f?!0:n<f?!1:r>v?!0:r<v||s&&s<b?!1:a>=C:(n===1&&f===0&&(!E||!T||!j)&&(f=1,v=0,C=0,E=!0,T=!1,j=!1),n<f?!1:n>f?!E:r<v?!1:r>v?!T:a<C?!1:a>C?!j:!(s&&s<b))}function l(m,o,h,i,s,t){const n=[];if(typeof i.publisher<"u"&&typeof i.publisher!="string")return n.push([c.default.Error,A.localize(11266,null)]),n;if(typeof i.name!="string")return n.push([c.default.Error,A.localize(11267,null,"name")]),n;if(typeof i.version!="string")return n.push([c.default.Error,A.localize(11268,null,"version")]),n;if(!i.engines)return n.push([c.default.Error,A.localize(11269,null,"engines")]),n;if(typeof i.engines.vscode!="string")return n.push([c.default.Error,A.localize(11270,null,"engines.vscode")]),n;if(typeof i.extensionDependencies<"u"&&!P(i.extensionDependencies))return n.push([c.default.Error,A.localize(11271,null,"extensionDependencies")]),n;if(typeof i.activationEvents<"u"){if(!P(i.activationEvents))return n.push([c.default.Error,A.localize(11272,null,"activationEvents")]),n;if(typeof i.main>"u"&&typeof i.browser>"u")return n.push([c.default.Error,A.localize(11273,null,"activationEvents","main","browser")]),n}if(typeof i.extensionKind<"u"&&typeof i.main>"u"&&n.push([c.default.Warning,A.localize(11274,null,"extensionKind")]),typeof i.main<"u"){if(typeof i.main!="string")return n.push([c.default.Error,A.localize(11275,null,"main")]),n;{const f=(0,I.$dh)(h,i.main);(0,I.$0g)(f,h)||n.push([c.default.Warning,A.localize(11276,null,f.path,h.path)])}}if(typeof i.browser<"u"){if(typeof i.browser!="string")return n.push([c.default.Error,A.localize(11277,null,"browser")]),n;{const f=(0,I.$dh)(h,i.browser);(0,I.$0g)(f,h)||n.push([c.default.Warning,A.localize(11278,null,f.path,h.path)])}}if(!L.valid(i.version))return n.push([c.default.Error,A.localize(11279,null)]),n;const r=[];if(!p(m,o,i,s,r))for(const f of r)n.push([c.default.Error,f]);if(t&&i.enabledApiProposals?.length){const f=[];if(!g([...i.enabledApiProposals],f))for(const v of f)n.push([c.default.Error,v])}return n}function p(m,o,h,i,s){return i||typeof h.main>"u"&&typeof h.browser>"u"?!0:w(m,o,h.engines.vscode,s)}function S(m,o,h){return m==="*"||w(o,h,m)}function g(m,o){if(m.length===0)return!0;const h=Array.isArray(o)?o:void 0,i=(h?void 0:o)??O.allApiProposals,s=[],t=(0,N.$un)(m);for(const{proposalName:n,version:r}of t){const a=i[n];a&&r&&a.version!==r&&s.push(A.localize(11280,null,n))}return h?.push(...s),s.length===0}function w(m,o,h,i=[]){const s=u(d(h));if(!s)return i.push(A.localize(11281,null,h)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return i.push(A.localize(11282,null,h)),!1}else if(!s.majorMustEqual)return i.push(A.localize(11283,null,h)),!1;return $(m,o,s)?!0:(i.push(A.localize(11284,null,m,h)),!1)}function P(m){if(!Array.isArray(m))return!1;for(let o=0,h=m.length;o<h;o++)if(typeof m[o]!="string")return!1;return!0}}),define(he[78],ue([0,1,25,2,5,11,27,4]),function(oe,e,I,c,A,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9r=e.$8r=void 0,e.$7r=k;function k(R){return R.tags.find(d=>d.startsWith("lp-"))?.split("lp-")[1]}e.$8r=(0,O.$Ci)("languagePackService");let y=class extends c.$Tc{constructor(d){super(),this.c=d}async getAvailableLanguages(){const d=new I.$ue;setTimeout(()=>d.cancel(),1e3);let u;try{u=await this.c.query({text:'category:"language packs"',pageSize:20},d.token)}catch{return[]}const l=u.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(S=>S.startsWith("lp-"))).map(p=>{const S=p.properties.localizedLanguages?.[0],g=k(p);return{...this.f(g,S,p),extensionId:p.identifier.id,galleryExtension:p}});return l.push(this.f("en","English")),l}f(d,u,$){const l=u??d;let p;if(l!==d&&(p=`(${d})`),d.toLowerCase()===A.$x.toLowerCase()&&(p??="",p+=(0,L.localize)(11188,null)),$?.installCount){p??="";const S=$.installCount;let g;S>1e6?g=`${Math.floor(S/1e5)/10}M`:S>1e3?g=`${Math.floor(S/1e3)}K`:g=String(S),p+=` $(cloud-download) ${g}`}return{id:d,label:l,description:p}}};e.$9r=y,e.$9r=y=ve([Q(0,N.$hp)],y)}),define(he[188],ue([0,1,2,78]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=void 0;let A=class extends I.$Tc{constructor(N){super(),this.a=N,this.b()}b(){this.a.update()}};e.$fhc=A,e.$fhc=A=ve([Q(0,c.$8r)],A)}),define(he[106],ue([0,1,2,4]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=void 0,e.$Sl=(0,c.$Ci)("remoteSocketFactoryService");class A{constructor(){this.a={}}register(N,O){return this.a[N]??=[],this.a[N].push(O),(0,I.$Rc)(()=>{const k=this.a[N]?.indexOf(O);typeof k=="number"&&k>=0&&this.a[N]?.splice(k,1)})}b(N){return(this.a[N.type]||[]).find(k=>k.supports(N))}connect(N,O,k,y){const R=this.b(N);if(!R)throw new Error(`No socket factory found for ${N}`);return R.connect(N,O,k,y)}}e.$Tl=A}),define(he[189],ue([0,1,4]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$thc=e.$shc=void 0,e.$shc=(0,I.$Ci)("sharedProcessTunnelService"),e.$thc="sharedProcessTunnel"}),define(he[107],ue([0,1,4,11]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhc=e.$Chc=e.$Bhc=e.$Ahc=e.$zhc=e.TunnelStates=e.$yhc=e.$xhc=void 0,e.$xhc=(0,I.$Ci)("IRemoteTunnelService"),e.$yhc={active:!1};var A;(function(L){L.disconnected=N=>({type:"disconnected",onTokenFailed:N}),L.connected=(N,O)=>({type:"connected",info:N,serviceInstallFailed:O}),L.connecting=N=>({type:"connecting",progress:N}),L.uninitialized={type:"uninitialized"}})(A||(e.TunnelStates=A={})),e.$zhc="remote.tunnels.access",e.$Ahc=e.$zhc+".hostNameOverride",e.$Bhc=e.$zhc+".preventSleep",e.$Chc="remoteTunnelService",e.$Dhc=(0,c.localize)(11072,null)}),define(he[61],ue([0,1,14,8,2,11,47,4,10,44]),function(oe,e,I,c,A,L,N,O,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=void 0,e.$6p=u,e.$7p=$,e.$8p=l,e.$9p=p,e.$0p=S,e.$$p=g,e.$4p=(0,O.$Ci)("requestService");class R{constructor(o){this.b=o}toJSON(){if(!this.a){const o=Object.create(null);for(const h in this.b)h.toLowerCase()==="authorization"||h.toLowerCase()==="proxy-authorization"?o[h]="*****":o[h]=this.b[h];this.a=o}return this.a}}class d extends A.$Tc{constructor(o){super(),this.b=0,this.a=o.createLogger("network",{name:(0,L.localize)(11053,null),when:k.$ok.isEqualTo((0,k.$lk)(k.LogLevel.Trace)).serialize()})}async c(o,h,i){const s=`${o} #${++this.b}: ${h.url}`;this.a.trace(`${s} - begin`,h.type,new R(h.headers??{}));try{const t=await i();return this.a.trace(`${s} - end`,h.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${s} - error`,h.type,(0,c.$9)(t)),t}}}e.$5p=d;function u(m){return m.res.statusCode&&m.res.statusCode>=200&&m.res.statusCode<300||m.res.statusCode===1223}function $(m){return m.res.statusCode===204}async function l(m){return $(m)?null:(await(0,I.$Xe)(m.stream)).toString()}async function p(m){if(!u(m))throw new Error("Server returned "+m.res.statusCode);return l(m)}async function S(m){if(!u(m))throw new Error("Server returned "+m.res.statusCode);if($(m))return null;const h=(await(0,I.$Xe)(m.stream)).toString();try{return JSON.parse(h)}catch(i){throw i.message+=`:
`+h,i}}function g(m){P(m)}let w;function P(m){const o=y.$no.as(N.$so.Configuration),h=w;w={id:"http",order:15,title:(0,L.localize)(11054,null),type:"object",scope:m,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(11055,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(11056,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,L.localize)(11057,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,L.localize)(11058,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(11059,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(11060,null),(0,L.localize)(11061,null),(0,L.localize)(11062,null),(0,L.localize)(11063,null)],default:"override",description:(0,L.localize)(11064,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(11065,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,L.localize)(11066,null),restricted:!0}}},o.updateConfigurations({add:[w],remove:h?[h]:[]})}P(N.ConfigurationScope.APPLICATION)}),define(he[190],ue([0,1,25,22,7,61]),function(oe,e,I,c,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DR=void 0;let N=class{constructor(k,y){this.a=k,this.b=y}async download(k,y,R=I.CancellationToken.None){if(k.scheme===c.Schemas.file||k.scheme===c.Schemas.vscodeRemote){await this.b.copy(k,y);return}const d={type:"GET",url:k.toString(!0)},u=await this.a.request(d,R);if(u.res.statusCode===200)await this.b.writeFile(y,u.stream);else{const $=await(0,L.$9p)(u);throw new Error(`Expected 200, got back ${u.res.statusCode} instead.

${$}`)}}};e.$DR=N,e.$DR=N=ve([Q(0,L.$4p),Q(1,A.$9k)],N)}),define(he[191],ue([0,1,14,25]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=e.$$r=void 0;class A{constructor(O){this.a=O}listen(O,k){throw new Error("Invalid listen")}call(O,k,y,R=c.CancellationToken.None){switch(k){case"request":return this.a.request(y[0],R).then(async({res:d,stream:u})=>{const $=await(0,I.$Xe)(u);return[{statusCode:d.statusCode,headers:d.headers},$]});case"resolveProxy":return this.a.resolveProxy(y[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$$r=A;class L{constructor(O){this.a=O}async request(O,k){const[y,R]=await this.a.call("request",[O],k);return{res:y,stream:(0,I.$Ze)(R)}}async resolveProxy(O){return this.a.call("resolveProxy",[O])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$_r=L}),define(he[192],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5fc=e.$4fc=e.$3fc=void 0,e.$3fc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$4fc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$5fc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(he[193],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Obc=void 0;class I{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(A){try{const L=await this.c();if(L){const N=String(I.a++);return this.b.set(N,L),{id:N,data:L.createNewMessage(A)}}}catch{}return{id:"",data:A}}async validate(A,L){if(!A.id)return!0;const N=this.b.get(A.id);if(!N)return!1;this.b.delete(A.id);try{return N.validate(L)==="ok"}catch{return!1}finally{N.dispose?.()}}async sign(A){try{return await this.d(A)}catch{}return A}}e.$Obc=I}),define(he[108],ue([0,1,4]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.$Ul=void 0,e.$Ul="signService",e.$Vl=(0,I.$Ci)(e.$Ul)}),define(he[194],ue([0,1,193]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ugc=void 0;class c extends I.$Obc{c(){return this.h().then(L=>new L.validator)}d(L){return this.h().then(N=>new N.signer().sign(L))}h(){return new Promise((L,N)=>oe(["vsda"],L,N))}}e.$Ugc=c}),define(he[79],ue([0,1,3,2]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KMb=e.$JMb=e.$IMb=e.$HMb=void 0;class A extends c.$Tc{constructor(d,u,$){super(),this.a=d,this.b=u,this.c=$}async getItems(){const d={profile:this.b,workspace:this.c},u=await this.a.call("getItems",d);return new Map(u)}updateItems(d){const u={profile:this.b,workspace:this.c};return d.insert&&(u.insert=Array.from(d.insert.entries())),d.delete&&(u.delete=Array.from(d.delete.values())),this.a.call("updateItems",u)}optimize(){const d={profile:this.b,workspace:this.c};return this.a.call("optimize",d)}}class L extends A{constructor(d,u){super(d,u,void 0),this.f=this.B(new I.$je),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(d=>this.h(d)))}h(d){(Array.isArray(d.changed)||Array.isArray(d.deleted))&&this.f.fire({changed:d.changed?new Map(d.changed):void 0,deleted:d.deleted?new Set(d.deleted):void 0})}}class N extends L{constructor(d){super(d,void 0)}async close(){this.dispose()}}e.$HMb=N;class O extends L{constructor(d,u){super(d,u)}async close(){this.dispose()}}e.$IMb=O;class k extends A{constructor(d,u){super(d,void 0,u),this.onDidChangeItemsExternal=I.Event.None}async close(){this.dispose()}}e.$JMb=k;class y{constructor(d){this.a=d}isUsed(d){const u={payload:d,profile:void 0,workspace:void 0};return this.a.call("isUsed",u)}}e.$KMb=y}),define(he[109],ue([0,1,5,37,31]),function(oe,e,I,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=N,e.$sp=O;function L(k){if(I.$v===I.Platform.Linux&&/^penguin(\.|$)/i.test(k))return"chromebook"}function N(k,y,R,d,u,$,l,p,S,g){const w=Object.create(null);w["common.machineId"]=$,w["common.sqmId"]=l,w["common.devDeviceId"]=p,w.sessionID=(0,A.$Yg)()+Date.now(),w.commitHash=d,w.version=u,w["common.platformVersion"]=(k||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,I.$i)(I.$v),w["common.nodePlatform"]=c.$cc,w["common.nodeArch"]=R,w["common.product"]=g||"desktop",S&&(w["common.msftInternal"]=S);let P=0;const m=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-m,enumerable:!0},"common.sequence":{get:()=>P++,enumerable:!0}}),I.$m&&(w["common.snap"]="true");const o=L(y);return o&&(w["common.platformDetail"]=o),w}function O(k){const y=c.env.USERDNSDOMAIN;if(!y)return!1;const R=y.toLowerCase();return k.some(d=>R===d)}}),define(he[18],ue([0,1,4]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=void 0,e.$8l=(0,I.$Ci)("telemetryService"),e.$9l=(0,I.$Ci)("customEndpointTelemetryService"),e.$0l="telemetry.currentSessionDate",e.$$l="telemetry.firstSessionDate",e.$_l="telemetry.lastSessionDate",e.$am="telemetry.machineId",e.$bm="telemetry.sqmId",e.$cm="telemetry.devDeviceId",e.$dm="telemetry",e.$em="telemetry.telemetryLevel",e.$fm="telemetry.enableCrashReporter",e.$gm="telemetry.enableTelemetry";var c;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(c||(e.TelemetryLevel=c={}));var A;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(A||(e.TelemetryConfiguration=A={}))}),define(he[195],ue([0,1,32,38,6,35,22,13,5,54,9,141,30,148,97,7,23,18]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$,l,p,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=void 0,e.$Us=P,e.$Vs=o,e.$Ws=h,I=ke(I),c=ke(c);const w=new Map;async function P(s,t){const n=`${s}::${t.join(":")}`,r=w.get(n);if(r)return r;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],f=new Map,v=new Map,C=2e4;function b(T,j,U,F){const K=j.substring(T.length+1);return A.Promises.withAsyncBody(async W=>{let x;F.readdirCount++;try{x=await u.Promises.readdir(j,{withFileTypes:!0})}catch{W();return}if(F.count>=C){F.count+=x.length,F.maxReached=!0,W();return}let G=x.length;if(G===0){W();return}let ie=x;F.count+x.length>C&&(F.maxReached=!0,G=C-F.count,ie=x.slice(0,G)),F.count+=x.length;for(const V of ie)if(V.isDirectory()){if(U.includes(V.name)||await b(T,(0,O.$ic)(j,V.name),U,F),--G===0){W();return}}else{const z=V.name.lastIndexOf(".");if(z>=0){const _=V.name.substring(z+1);_&&f.set(_,(f.get(_)??0)+1)}for(const _ of a)_.relativePathPattern?.test(K)!==!1&&_.filePattern.test(V.name)&&v.set(_.tag,(v.get(_.tag)??0)+1);if(--G===0){W();return}}})}const E=A.Promises.withAsyncBody(async T=>{const j={count:0,maxReached:!1,readdirCount:0},U=new y.$de(!0);await b(s,s,t,j);const F=await h(s);T({configFiles:m(v),fileTypes:m(f),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:F,totalScanTime:U.elapsed(),totalReaddirCount:j.readdirCount})});return w.set(n,E),E}function m(s){return Array.from(s.entries(),([t,n])=>({name:t,count:n})).sort((t,n)=>n.count-t.count)}function o(){const s={os:`${c.type()} ${c.arch()} ${c.release()}`,memory:`${(c.totalmem()/p.$El.GB).toFixed(2)}GB (${(c.freemem()/p.$El.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(d.$On.value()*100)}%`},t=c.cpus();return t&&t.length>0&&(s.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),s}async function h(s){try{const t=new Map,n=(0,O.$ic)(s,".vscode","launch.json"),r=await I.promises.readFile(n),a=[],f=(0,L.$Un)(r.toString(),a);if(a.length)return console.log(`Unable to parse ${n}`),[];if((0,L.$3n)(f)==="object"&&f.configurations)for(const v of f.configurations){const C=v.type;C&&(t.has(C)?t.set(C,t.get(C)+1):t.set(C,1))}return m(t)}catch{return[]}}let i=class{constructor(t,n){this.c=t,this.d=n}f(t){const n=[];return n.push(`OS Version:       ${t.os}`),n.push(`CPUs:             ${t.cpus}`),n.push(`Memory (System):  ${t.memory}`),n.push(`VM:               ${t.vmHint}`),n.join(`
`)}g(t){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${c.type()} ${c.arch()} ${c.release()}`);const r=c.cpus();return r&&r.length>0&&n.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),n.push(`Memory (System):  ${(c.totalmem()/p.$El.GB).toFixed(2)}GB (${(c.freemem()/p.$El.GB).toFixed(2)}GB free)`),k.$j||n.push(`Load (avg):       ${c.loadavg().map(a=>Math.round(a)).join(", ")}`),n.push(`VM:               ${Math.round(d.$On.value()*100)}%`),n.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${t.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(t.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(t,n){return Promise.all([(0,$.$Ts)(t.mainPID),this.k(t)]).then(async r=>{let[a,f]=r,v=this.m(t,a);return n.forEach(C=>{if((0,l.$Qm)(C))v+=`
${C.errorMessage}`,f+=`
${C.errorMessage}`;else if(v+=`

Remote: ${C.hostName}`,C.processes&&(v+=`
${this.m(t,C.processes)}`),C.workspaceMetadata){f+=`
|  Remote: ${C.hostName}`;for(const b of Object.keys(C.workspaceMetadata)){const E=C.workspaceMetadata[b];let T=`${E.fileCount} files`;E.maxFilesReached&&(T=`more than ${T}`),f+=`|    Folder (${b}): ${T}`,f+=this.h(E)}}}),{processInfo:v,workspaceInfo:f}})}async getSystemInfo(t,n){const{memory:r,vmHint:a,os:f,cpus:v}=o(),C={os:f,memory:r,cpus:v,vmHint:a,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:n};return k.$j||(C.load=`${c.loadavg().map(b=>Math.round(b)).join(", ")}`),k.$l&&(C.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(C)}async getDiagnostics(t,n){const r=[];return(0,$.$Ts)(t.mainPID).then(async a=>(r.push(""),r.push(this.g(t)),r.push(""),r.push(this.m(t,a)),t.windows.some(f=>f.folderURIs&&f.folderURIs.length>0&&!f.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.k(t))),n.forEach(f=>{if((0,l.$Qm)(f))r.push(`
${f.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${f.hostName}`),r.push(this.f(f.machineInfo)),f.processes&&r.push(this.m(t,f.processes)),f.workspaceMetadata)for(const v of Object.keys(f.workspaceMetadata)){const C=f.workspaceMetadata[v];let b=`${C.fileCount} files`;C.maxFilesReached&&(b=`more than ${b}`),r.push(`Folder (${v}): ${b}`),r.push(this.h(C))}}),r.push(""),r.push(""),r.join(`
`)))}h(t){const n=[];let a=0;const f=(E,T)=>{const j=` ${E}(${T})`;a+j.length>60?(n.push(v),v="|                 ",a=v.length):a+=j.length,v+=j};let v="|      File types:";const C=10,b=t.fileTypes.length>C?C:t.fileTypes.length;for(let E=0;E<b;E++){const T=t.fileTypes[E];f(T.name,T.count)}if(n.push(v),t.configFiles.length>=0&&(v="|      Conf files:",a=0,t.configFiles.forEach(E=>{f(E.name,E.count)}),n.push(v)),t.launchConfigFiles.length>0){let E="|      Launch Configs:";t.launchConfigFiles.forEach(T=>{const j=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`;E+=j}),n.push(E)}return n.join(`
`)}j(t){const n=Math.max(...Object.keys(t).map(r=>r.length));return Object.keys(t).map(r=>`${r}:  ${" ".repeat(n-r.length)}  ${t[r]}`).join(`
                  `)}k(t){const n=[],r=[];return t.windows.forEach(a=>{a.folderURIs.length===0||a.remoteAuthority||(n.push(`|  Window (${a.title})`),a.folderURIs.forEach(f=>{const v=R.URI.revive(f);if(v.scheme===N.Schemas.file){const C=v.fsPath;r.push(P(C,["node_modules",".git"]).then(b=>{let E=`${b.fileCount} files`;b.maxFilesReached&&(E=`more than ${E}`),n.push(`|    Folder (${(0,O.$mc)(C)}): ${E}`),n.push(this.h(b))}).catch(b=>{n.push(`|      Error: Unable to collect workspace stats for folder ${C} (${b.toString()})`)}))}else n.push(`|    Folder (${v.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(a=>n.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}m(t,n){const r=new Map;t.windows.forEach(f=>r.set(f.pid,`window [${f.id}] (${f.title})`)),t.pidToNames.forEach(({pid:f,name:v})=>r.set(f,v));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),n&&this.n(t.mainPID,r,a,n,0),a.join(`
`)}n(t,n,r,a,f){const v=f===0;let C;v?C=a.pid===t?`${this.d.applicationName} main`:"remote agent":n.has(a.pid)?C=n.get(a.pid):C=`${"  ".repeat(f)} ${a.name}`;const b=process.platform==="win32"?a.mem:c.totalmem()*(a.mem/100);r.push(`${a.load.toFixed(0).padStart(5," ")}	${(b/p.$El.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${C}`),Array.isArray(a.children)&&a.children.forEach(E=>this.n(t,n,r,E,f+1))}async getWorkspaceFileExtensions(t){const n=new Set;for(const{uri:r}of t.folders){const a=R.URI.revive(r);if(a.scheme!==N.Schemas.file)continue;const f=a.fsPath;try{(await P(f,["node_modules",".git"])).fileTypes.forEach(C=>n.add(C.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(t){for(const{uri:n}of t.folders){const r=R.URI.revive(n);if(r.scheme!==N.Schemas.file)continue;const a=r.fsPath;try{const f=await P(a,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),f.fileTypes.forEach(v=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:v.name,count:v.count})}),f.launchConfigFiles.forEach(v=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:v.name,count:v.count})}),f.configFiles.forEach(v=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:v.name,count:v.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:f.totalScanTime,reachedLimit:f.maxFilesReached,fileCount:f.fileCount,readdirCount:f.totalReaddirCount})}catch{}}}};e.$Xs=i,e.$Xs=i=ve([Q(0,g.$8l),Q(1,S.$pk)],i)}),define(he[110],ue([0,1,8,4,10,18]),function(oe,e,I,c,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$qq=e.ExtensionSignatureVerificationCode=e.$pq=void 0,e.$pq=(0,c.$Ci)("IExtensionSignatureVerificationService");var N;(function(y){y.Success="Success",y.RequiredArgumentMissing="RequiredArgumentMissing",y.InvalidArgument="InvalidArgument",y.PackageIsUnreadable="PackageIsUnreadable",y.UnhandledException="UnhandledException",y.SignatureManifestIsMissing="SignatureManifestIsMissing",y.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",y.SignatureIsMissing="SignatureIsMissing",y.SignatureIsUnreadable="SignatureIsUnreadable",y.CertificateIsUnreadable="CertificateIsUnreadable",y.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",y.FileAlreadyExists="FileAlreadyExists",y.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",y.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",y.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",y.SignatureIsInvalid="SignatureIsInvalid",y.SignatureManifestIsInvalid="SignatureManifestIsInvalid",y.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",y.EntryIsMissing="EntryIsMissing",y.EntryIsTampered="EntryIsTampered",y.Untrusted="Untrusted",y.CertificateRevoked="CertificateRevoked",y.SignatureIsNotValid="SignatureIsNotValid",y.UnknownError="UnknownError",y.PackageIsInvalidZip="PackageIsInvalidZip",y.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(N||(e.ExtensionSignatureVerificationCode=N={}));class O extends Error{constructor(R){super(R),this.code=R}}e.$qq=O;let k=class{constructor(R,d){this.b=R,this.c=d}d(){return this.a||(this.a=new Promise((R,d)=>oe(["@vscode/vsce-sign"],async u=>R(u),d))),this.a}async verify(R,d,u,$){let l;const p=R.identifier.id;try{l=await this.d()}catch(P){return this.b.error("Could not load vsce-sign module",(0,I.$9)(P)),this.b.info(`Extension signature verification is not done: ${p}`),!1}const S=new Date().getTime();let g;try{this.b.trace(`Verifying extension signature for ${p}...`),g=await l.verify(d,u,this.b.getLevel()===A.LogLevel.Trace)}catch(P){g={code:N.UnknownError,didExecute:!1,output:(0,I.$9)(P)}}const w=new Date().getTime()-S;if(this.b.info(`Extension signature verification result for ${p}: ${g.code}. Executed: ${g.didExecute}. Duration: ${w}ms.`),this.b.trace(`Extension signature verification output for ${p}:
${g.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:p,extensionVersion:R.version,code:g.code,internalCode:g.internalCode,duration:w,didExecute:g.didExecute,clientTargetPlatform:$}),g.code===N.Success)return!0;throw new O(g.code)}};e.$rq=k,e.$rq=k=ve([Q(0,A.$9j),Q(1,L.$8l)],k)}),define(he[111],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9fc=e.$8fc=void 0;class I{constructor(L){this.b=L}listen(L,N){throw new Error(`Event not found: ${N}`)}call(L,N,{eventName:O,data:k}){return this.b.forEach(y=>y.log(O,k)),Promise.resolve(null)}}e.$8fc=I;class c{constructor(L){this.b=L}log(L,N){return this.b.call("log",{eventName:L,data:N}).then(void 0,O=>`Failed to log telemetry: ${console.warn(O)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$9fc=c}),define(he[48],ue([0,1,29,12,105,109,18]),function(oe,e,I,c,A,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=void 0,e.$Ap=R,e.$Bp=d,e.$Cp=u,e.$Dp=$,e.$Ep=p,e.$Fp=g,e.$Gp=w,e.$Hp=o;class O{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.$tp=O;class k{constructor(){this.telemetryLevel=N.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$up=k,e.$vp=new k;class y{async publicLog(i,s,t){}async publicLogError(i,s,t){}}e.$wp=y,e.$xp="telemetry",e.$yp="extensionTelemetryLog",e.$zp={log:()=>null,flush:()=>Promise.resolve(null)};function R(h,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!h.enableTelemetry)}function d(h,i){return i.extensionTestsLocationURI?!0:!(i.isBuilt||i.disableTelemetry||h.enableTelemetry&&h.aiConfig?.ariaKey)}function u(h){const i=h.getValue(N.$em),s=h.getValue(N.$fm);if(h.getValue(N.$gm)===!1||s===!1)return N.TelemetryLevel.NONE;switch(i??N.TelemetryConfiguration.ON){case N.TelemetryConfiguration.ON:return N.TelemetryLevel.USAGE;case N.TelemetryConfiguration.ERROR:return N.TelemetryLevel.ERROR;case N.TelemetryConfiguration.CRASH:return N.TelemetryLevel.CRASH;case N.TelemetryConfiguration.OFF:return N.TelemetryLevel.NONE}}function $(h){const i={},s={},t={};S(h,t);for(let n in t){n=n.length>150?n.substr(n.length-149):n;const r=t[n];typeof r=="number"?s[n]=r:typeof r=="boolean"?s[n]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${r.length}`),i[n]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(i[n]=r)}return{properties:i,measurements:s}}const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function p(h){if(!h)return"none";const i=(0,A.$en)(h);return l.has(i)?i:"other"}function S(h,i,s=0,t){if(h)for(const n of Object.getOwnPropertyNames(h)){const r=h[n],a=t?t+n:n;Array.isArray(r)?i[a]=(0,I.$fo)(r):r instanceof Date?i[a]=r.toISOString():(0,c.$eg)(r)?s<2?S(r,i,s+1,a+"."):i[a]=(0,I.$fo)(r):i[a]=r}}function g(h,i){const s=h.msftInternalDomains||[],t=i.getValue("telemetry.internalTesting");return(0,L.$sp)(s)||t}function w(h){return[h.appRoot,h.extensionsPath,h.userHome.fsPath,h.tmpDir.fsPath,h.userDataPath]}function P(h,i){if(!h||!h.includes("/")&&!h.includes("\\"))return h;let s=h;const t=[];for(const f of i)for(;;){const v=f.exec(h);if(!v)break;t.push([v.index,f.lastIndex])}const n=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(s="";;){const f=r.exec(h);if(!f)break;const v=t.some(([C,b])=>f.index<b&&C<r.lastIndex);!n.test(f[0])&&!v&&(s+=h.substring(a,f.index)+"<REDACTED: user-file-path>",a=r.lastIndex)}return a<h.length&&(s+=h.substr(a)),s}function m(h){if(!h)return h;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of i)if(s.regex.test(h))return`<REDACTED: ${s.label}>`;return h}function o(h,i){return(0,I.$co)(h,s=>{if(s instanceof O||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let t=s.replaceAll("%20"," ");t=P(t,i);for(const n of i)t=t.replace(n,"");return t=m(t),t}})}}),define(he[34],ue([0,1,26,27,33,5,9,8,37,48]),function(oe,e,I,c,A,L,N,O,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Jp=void 0,e.$Ip=R,e.$Kp=l,e.$Lp=p,e.$Mp=S,e.$Np=g,e.$Op=w,e.$Pp=P,e.$Qp=m,e.$Sp=o,e.$Tp=i;function R(s,t){return s.uuid&&t.uuid?s.uuid===t.uuid:s.id===t.id?!0:(0,I.$yf)(s.id,t.id)===0}const d=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(t){const n=t.manifest?t.manifest.version:t.version,r=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new u(t.identifier,n,r)}static parse(t){const n=d.exec(t);return n&&n[1]&&n[2]?new u({id:n[1]},n[2],n[4]||void 0):null}constructor(t,n,r=A.TargetPlatform.UNDEFINED){this.identifier=t,this.version=n,this.targetPlatform=r,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==A.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof u?R(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$Jp=u;const $=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function l(s){const t=$.exec(s);return t&&t[1]?[S(t[1]),t[2]]:[S(s),void 0]}function p(s,t){return`${s}.${t}`}function S(s){return s.toLowerCase()}function g(s,t){return S(p(s??A.$jn,t))}function w(s,t){const n=[],r=a=>{for(const f of n)if(f.some(v=>R(t(v),t(a))))return f;return null};for(const a of s){const f=r(a);f?f.push(a):n.push([a])}return n}function P(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}function m(s){return{id:new y.$tp(s.identifier.id),name:new y.$tp(s.name),version:s.version,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$Rp=new A.$nn("pprice.better-merge");function o(s,t){const n=[],r=t.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&n.every(f=>!R(f.identifier,{id:a}))){const f=s.filter(v=>R(v.identifier,{id:a}));f.length===1&&(n.push(f[0]),r.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}async function h(s,t){if(!L.$l)return!1;let n;try{n=(await s.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await s.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){t.debug("Error while getting the os-release file.",(0,O.$9)(a))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(s,t){const n=await h(s,t),r=(0,c.$dp)(n?"alpine":L.$v,k.$dc);return t.debug("ComputeTargetPlatform:",r),r}}),define(he[196],ue([0,1,25,27,34,33]),function(oe,e,I,c,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$16b=N;async function N(O,k,y,R,d){try{const u=await O.getExtensionsControlManifest();if(!u.deprecated)return;const $=await O.getInstalled(L.ExtensionType.User);for(const[l,p]of Object.entries(u.deprecated)){if(!p?.extension)continue;const{id:S,autoMigrate:g,preRelease:w}=p.extension;if(!g)continue;const P=$.find(o=>(0,A.$Ip)(o.identifier,{id:l}));if(!P)continue;const m=(await k.getExtensions([{id:S,preRelease:w}],{targetPlatform:await O.getTargetPlatform(),compatible:!0},I.CancellationToken.None))[0];if(!m){d.info(`Skipping migrating '${P.identifier.id}' extension because, the comaptible target '${S}' extension is not found`);continue}try{d.info(`Migrating '${P.identifier.id}' extension to '${S}' extension...`);const o=!R.getDisabledExtensions().some(i=>(0,A.$Ip)(i,P.identifier));await O.uninstall(P),d.info(`Uninstalled the unsupported extension '${P.identifier.id}'`);let h=$.find(i=>(0,A.$Ip)(i.identifier,{id:S}));(!h||!h.isPreReleaseVersion&&o)&&(h=await O.installFromGallery(m,{installPreReleaseVersion:!0,isMachineScoped:P.isMachineScoped,operation:c.InstallOperation.Migrate}),d.info(`Installed the pre-release extension '${h.identifier.id}'`),o||(await R.disableExtension(h.identifier),d.info(`Disabled the pre-release extension '${h.identifier.id}' because the unsupported extension '${P.identifier.id}' is disabled`)),g.storage&&(y.addToMigrationList((0,A.$Lp)(P.manifest.publisher,P.manifest.name),(0,A.$Lp)(h.manifest.publisher,h.manifest.name)),d.info("Added pre-release extension to the storage migration list"))),d.info(`Migrated '${P.identifier.id}' extension to '${S}' extension.`)}catch(o){d.error(o)}}}catch(u){d.error(u)}}}),define(he[197],ue([0,1,8,3,2,36,34,33,7]),function(oe,e,I,c,A,L,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;class y extends A.$Tc{constructor(d,u,$,l,p,S,g){super(),this.f=d,this.g=u,this.h=$,this.j=l,this.m=p,this.n=S,this.r=g,this.a=this.B(new c.$je),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new A.$3c),this.s().then(null,w=>g.error("Error while initializing Extensions Watcher",(0,I.$9)(w)))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(d=>this.u(d.added))),this.B(this.j.onAddExtensions(d=>this.w(d))),this.B(this.j.onDidAddExtensions(d=>this.y(d))),this.B(this.j.onRemoveExtensions(d=>this.z(d))),this.B(this.j.onDidRemoveExtensions(d=>this.C(d))),this.B(this.n.onDidFilesChange(d=>this.D(d)))}async u(d){try{d.length&&await Promise.all(d.map(u=>(this.c.set(u.id,(0,A.$Qc)(this.n.watch(this.m.extUri.dirname(u.extensionsResource)),this.n.watch(u.extensionsResource))),this.G(u.extensionsResource))))}catch(u){throw this.r.error(u),u}}async w(d){for(const u of d.extensions)this.I(this.L(u.identifier,u.version),d.profileLocation)}async y(d){for(const u of d.extensions){const $=this.L(u.identifier,u.version);d.error?this.J($,d.profileLocation):this.I($,d.profileLocation)}}async z(d){for(const u of d.extensions)this.J(this.L(u.identifier,u.version),d.profileLocation)}async C(d){const u=[],$=[];for(const l of d.extensions){const p=this.L(l.identifier,l.version);d.error?this.I(p,d.profileLocation):(this.J(p,d.profileLocation),this.b.has(p)||(this.r.debug("Extension is removed from all profiles",l.identifier.id,l.version),$.push(this.f.scanInstalledExtensionAtLocation(l.location).then(S=>{S?u.push(S):this.r.info("Extension not found at the location",l.location.toString())},S=>this.r.error(S)))))}try{await Promise.all($),u.length&&await this.H(u)}catch(l){this.r.error(l)}}D(d){for(const u of this.h.profiles)d.contains(u.extensionsResource,k.FileChangeType.UPDATED,k.FileChangeType.ADDED)&&this.F(u.extensionsResource)}async F(d){const u=[],$=[],l=await this.j.scanProfileExtensions(d),p=new Set,S=new Set;for(const[g,w]of this.b)w.has(d)&&S.add(g);for(const g of l){const w=this.L(g.identifier,g.version);p.add(w),S.has(w)||(u.push(g.identifier),this.I(w,d))}for(const g of S)if(!p.has(g)){const w=this.M(g);w&&($.push(w.identifier),this.J(g,d))}(u.length||$.length)&&this.a.fire({added:u.length?{extensions:u,profileLocation:d}:void 0,removed:$.length?{extensions:$,profileLocation:d}:void 0})}async G(d){const u=await this.j.scanProfileExtensions(d);for(const $ of u)this.I(this.L($.identifier,$.version),d)}async H(d){d||(d=(await this.f.scanAllUserInstalledExtensions()).filter($=>!this.b.has(this.L($.identifier,$.manifest.version)))),d.length&&await this.f.markAsUninstalled(...d)}I(d,u){let $=this.b.get(d);$||this.b.set(d,$=new L.$Ac(l=>this.m.extUri.getComparisonKey(l))),$.add(u)}J(d,u){const $=this.b.get(d);$&&$.delete(u),$?.size||this.b.delete(d)}L(d,u){return`${O.$nn.toKey(d.id)}@${u}`}M(d){const[u,$]=(0,N.$Kp)(d);return $?{identifier:{id:u},version:$}:void 0}}e.$Tq=y}),define(he[198],ue([0,1,32,75,17,6,2,22,13,30,15,27,34,10,78,9]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0r=void 0,I=ke(I);let S=class extends l.$9r{constructor(m,o,h,i){super(h),this.h=m,this.j=i,this.g=this.B(new g(o,i)),this.h.registerParticipant({postInstall:async s=>this.m(s),postUninstall:async s=>this.n(s)})}async getBuiltInExtensionTranslationsUri(m,o){const i=(await this.g.getLanguagePacks())[o];if(!i){this.j.warn(`No language pack found for ${o}`);return}const s=i.translations[m];return s?p.URI.file(s):void 0}async getInstalledLanguages(){const m=await this.g.getLanguagePacks(),o=Object.keys(m).map(h=>{const i=m[h];return{...this.f(h,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return o.push(this.f("en","English")),o.sort((h,i)=>h.label.localeCompare(i.label)),o}async m(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",m.identifier.id),await this.update())}async n(m){const o=await this.g.getLanguagePacks();Object.keys(o).some(h=>o[h]&&o[h].extensions.some(i=>(0,u.$Ip)(i.extensionIdentifier,m.identifier)))&&(this.j.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,o]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),h=await this.g.update(o);return!(0,A.$tb)(Object.keys(m),Object.keys(h))}};e.$0r=S,e.$0r=S=ve([Q(0,d.$kp),Q(1,R.$Ki),Q(2,d.$hp),Q(3,$.$9j)],S);let g=class extends N.$Tc{constructor(m,o){super(),this.j=o,this.c={},this.f=(0,k.$ic)(m.userDataPath,"languagepacks.json"),this.g=new L.$Jh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(m){return this.s(o=>{Object.keys(o).forEach(h=>delete o[h]),this.m(o,...m)}).then(()=>this.c)}m(m,...o){for(const h of o)h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&this.n(m,h);Object.keys(m).forEach(h=>this.r(m[h]))}n(m,o){const h=o.identifier,i=o.manifest.contributes&&o.manifest.contributes.localizations?o.manifest.contributes.localizations:[];for(const s of i)if(o.location.scheme===O.Schemas.file&&w(s)){let t=m[s.languageId];t||(t={hash:"",extensions:[],translations:{},label:s.localizedLanguageName??s.languageName},m[s.languageId]=t);const n=t.extensions.filter(r=>(0,u.$Ip)(r.extensionIdentifier,h))[0];n?n.version=o.manifest.version:t.extensions.push({extensionIdentifier:h,version:o.manifest.version});for(const r of s.translations)t.translations[r.id]=(0,k.$ic)(o.location.fsPath,r.path)}}r(m){if(m){const o=(0,c.createHash)("md5");for(const h of m.extensions)o.update(h.extensionIdentifier.uuid||h.extensionIdentifier.id).update(h.version);m.hash=o.digest("hex")}}s(m=()=>null){return this.g.queue(()=>{let o=null;return I.promises.readFile(this.f,"utf8").then(void 0,h=>h.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(h)).then(h=>{try{return JSON.parse(h)}catch{return{}}}).then(h=>(o=m(h),h)).then(h=>{for(const s of Object.keys(h))h[s]||delete h[s];this.c=h,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),y.Promises.writeFile(this.f,i)}).then(()=>o,h=>this.j.error(h))})}};g=ve([Q(0,R.$Ki),Q(1,$.$9j)],g);function w(P){if(typeof P.languageId!="string"||!Array.isArray(P.translations)||P.translations.length===0)return!1;for(const m of P.translations)if(typeof m.id!="string"||typeof m.path!="string")return!1;return!(P.languageName&&typeof P.languageName!="string"||P.localizedLanguageName&&typeof P.localizedLanguageName!="string")}}),define(he[199],ue([0,1,139,8,29,48]),function(oe,e,I,c,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bR=void 0;const N="https://mobile.events.data.microsoft.com/OneCollector/1.0",O="https://mobile.events.data.microsoft.com/ping";async function k(R,d,u){const $=await(0,I.$qE)("@microsoft/1ds-core-js","dist/ms.core.js"),l=await(0,I.$qE)("@microsoft/1ds-post-js","dist/ms.post.js"),p=new $.AppInsightsCore,S=new l.PostChannel,g={instrumentationKey:R,endpointUrl:N,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[S]]};if(u){g.extensionConfig={};const w={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:u};g.extensionConfig[S.identifier]=w}return p.initialize(g,[]),p.addTelemetryInitializer(w=>{w.ext=w.ext??{},w.ext.web=w.ext.web??{},w.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',d&&(w.ext.utc=w.ext.utc??{},w.ext.utc.flags=8462029)}),p}class y{constructor(d,u,$,l,p){this.e=d,this.f=u,this.g=$,this.h=p,this.c=N,this.d=O,this.g||(this.g={}),typeof l=="function"?this.a=l():this.a=l,this.b=null}i(d){if(this.a){if(typeof this.a!="string"){d(this.a);return}this.b||(this.b=k(this.a,this.e,this.h)),this.b.then(u=>{d(u)},u=>{(0,c.$Y)(u),console.error(u)})}}log(d,u){if(!this.a)return;u=(0,A.$do)(u,this.g),u=(0,L.$Dp)(u);const $=this.f+"/"+d;try{this.i(l=>{l.pluginVersionString=u?.properties.version??"Unknown",l.track({name:$,baseData:{name:$,properties:u?.properties,measurements:u?.measurements}})})}catch{}}flush(){return this.a?new Promise(d=>{this.i(u=>{u.unload(!0,()=>{this.a=void 0,d(void 0)})})}):Promise.resolve(void 0)}}e.$bR=y}),define(he[112],ue([0,1,2,11,15,10,23,48]),function(oe,e,I,c,A,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ldc=void 0;let k=class extends I.$Tc{constructor(R,d,u,$,l=""){super(),this.b=l;const p=d.getLogger(O.$xp);if(p)this.a=this.B(p);else{const g=(0,O.$Bp)($,u)?" (Not Sent)":"",w=()=>(0,O.$Ap)($,u)&&R.getLevel()===L.LogLevel.Trace;this.a=this.B(d.createLogger(O.$xp,{name:(0,c.localize)(11049,null,g),hidden:!w()})),this.B(R.onDidChangeLogLevel(()=>d.setVisibility(O.$xp,w()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(R,d){this.a.trace(`${this.b}telemetry/${R}`,(0,O.$Dp)(d))}};e.$ldc=k,e.$ldc=k=ve([Q(0,L.$9j),Q(1,L.$0j),Q(2,A.$Ji),Q(3,N.$pk)],k)});var it=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(he[113],ue([0,1,2,29,5,26,11,21,47,102,23,44,18,48]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ds=void 0,y=it(y);let l=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(g,w,P){this.k=w,this.l=P,this.d={},this.i=new I.$Sc,this.j=[],this.b=g.appenders,this.c=g.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=g.piiPaths||[],this.g=u.TelemetryLevel.USAGE,this.h=!!g.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const m of this.f)this.j.push(new RegExp((0,L.$ff)(m),"gi")),m.indexOf("\\")>=0&&this.j.push(new RegExp((0,L.$ff)(m.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(m=>{(m.affectsConfiguration(u.$em)||m.affectsConfiguration(u.$gm)||m.affectsConfiguration(u.$fm))&&this.m()}))}setExperimentProperty(g,w){this.d[g]=w}m(){let g=(0,$.$Cp)(this.k);const w=this.l.enabledTelemetryLevels;if(w){this.h=this.sendErrorTelemetry?w.error:!1;const P=w.usage?u.TelemetryLevel.USAGE:w.error?u.TelemetryLevel.ERROR:u.TelemetryLevel.NONE;g=Math.min(g,P)}this.g=g}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(g,w,P){this.g<w||(P=(0,c.$do)(P,this.d),P=(0,$.$Hp)(P,this.j),P=(0,c.$do)(P,this.c),this.b.forEach(m=>m.log(g,P)))}publicLog(g,w){this.n(g,u.TelemetryLevel.USAGE,w)}publicLog2(g,w){this.publicLog(g,w)}publicLogError(g,w){this.h&&this.n(g,u.TelemetryLevel.ERROR,w)}publicLogError2(g,w){this.publicLogError(g,w)}};e.$ds=l,e.$ds=l=ve([Q(1,O.$9i),Q(2,R.$pk)],l);function p(){const S=(0,N.localize)(11031,null,y.default.nameLong),g=y.default.privacyStatementUrl?(0,N.localize)(11033,null,"https://aka.ms/vscode-telemetry",y.default.privacyStatementUrl):(0,N.localize)(11032,null,"https://aka.ms/vscode-telemetry"),w=A.$p?"":(0,N.localize)(11034,null),P=(0,N.localize)(11035,null),m=(0,N.localize)(11036,null),o=(0,N.localize)(11037,null),h=(0,N.localize)(11038,null),i=`
|       | ${P} | ${m} | ${o} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,N.localize)(11039,null);return`
${S} ${g} ${w}

&nbsp;

${h}
${i}

&nbsp;

${s}
`}d.$no.as(k.$so.Configuration).registerConfiguration({id:u.$dm,order:1,type:"object",title:(0,N.localize)(11040,null),properties:{[u.$em]:{type:"string",enum:[u.TelemetryConfiguration.ON,u.TelemetryConfiguration.ERROR,u.TelemetryConfiguration.CRASH,u.TelemetryConfiguration.OFF],enumDescriptions:[(0,N.localize)(11041,null),(0,N.localize)(11042,null),(0,N.localize)(11043,null),(0,N.localize)(11044,null)],markdownDescription:p(),default:u.TelemetryConfiguration.ON,restricted:!0,scope:k.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),d.$no.as(k.$so.Configuration).registerConfiguration({id:u.$dm,order:110,type:"object",title:(0,N.localize)(11045,null),properties:{[u.$gm]:{type:"boolean",markdownDescription:y.default.privacyStatementUrl?(0,N.localize)(11047,null,y.default.nameLong,y.default.privacyStatementUrl):(0,N.localize)(11046,null,y.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,N.localize)(11048,null,`\`#${u.$em}#\``),scope:k.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(he[200],ue([0,1,14,25,243,199]),function(oe,e,I,c,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cR=void 0,A=ke(A);async function N(R,d){const u=await d.request(R,c.CancellationToken.None),$=(await(0,I.$Xe)(u.stream)).toString(),l=u.res.statusCode??200;return{headers:u.res.headers,statusCode:l,responseData:$}}async function O(R){const d={method:R.type,headers:R.headers};return new Promise(($,l)=>{const p=A.request(R.url??"",d,S=>{S.on("data",function(g){$({headers:S.headers,statusCode:S.statusCode??200,responseData:g.toString()})}),S.on("error",function(g){l(g)})});p.write(R.data,S=>{S&&l(S)}),p.end()})}async function k(R,d,u){const $=typeof d.data=="string"?d.data:new TextDecoder().decode(d.data),l={type:"POST",headers:{...d.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(d.data).toString()},url:d.urlString,data:$};try{const p=R?await N(l,R):await O(l);u(p.statusCode,p.headers,p.responseData)}catch{u(0,{})}}class y extends L.$bR{constructor(d,u,$,l,p){const S={sendPOST:(g,w)=>{k(d,g,w)}};super(u,$,l,p,S)}}e.$cR=y}),define(he[201],ue([0,1,22,95,21,15,10,23,18,111,112,113]),function(oe,e,I,c,A,L,N,O,k,y,R,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=void 0;let u=class{constructor(l,p,S,g,w,P){this.b=l,this.c=p,this.d=S,this.e=g,this.f=w,this.g=P,this.a=new Map}h(l){if(!this.a.has(l.id)){const p=Object.create(null);p["common.vscodemachineid"]=this.c.machineId,p["common.vscodesessionid"]=this.c.sessionId;const S=[l.id,JSON.stringify(p),l.aiKey],w=new c.$er(I.$Wg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:S,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),P=[new y.$9fc(w),new R.$ldc(this.d,this.e,this.f,this.g,`[${l.id}] `)];this.a.set(l.id,new d.$ds({appenders:P,sendErrorTelemetry:l.sendErrorTelemetry},this.b,this.g))}return this.a.get(l.id)}publicLog(l,p,S){this.h(l).publicLog(p,S)}publicLogError(l,p,S){this.h(l).publicLogError(p,S)}};e.$khc=u,e.$khc=u=ve([Q(0,A.$9i),Q(1,k.$8l),Q(2,N.$9j),Q(3,N.$0j),Q(4,L.$Ji),Q(5,O.$pk)],u)}),define(he[80],ue([0,1,3,2,5,9,21,4,10]),function(oe,e,I,c,A,L,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kw=e.$Jw=e.$Gw=e.$Ew=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Aw=e.$zw=void 0,e.$Bw=d,e.$Cw=$,e.$Dw=l,e.$Fw=p,e.$Hw=S,e.$Iw=g,e.$zw=(0,O.$Ci)("tunnelService"),e.$Aw=(0,O.$Ci)("sharedTunnelsService");var y;(function(m){m.Http="http",m.Https="https"})(y||(e.TunnelProtocol=y={}));var R;(function(m){m.ConstantPrivate="constantPrivate",m.Private="private",m.Public="public"})(R||(e.TunnelPrivacyId=R={}));function d(m){return!!m.forwardPort}var u;(function(m){m[m.Notify=1]="Notify",m[m.OpenBrowser=2]="OpenBrowser",m[m.OpenPreview=3]="OpenPreview",m[m.Silent=4]="Silent",m[m.Ignore=5]="Ignore",m[m.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function $(m){if(m.scheme!=="http"&&m.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(m.authority);if(o)return{address:o[1],port:+o[2]}}function l(m){if(m.scheme!=="http"&&m.scheme!=="https"||!m.query)return;const o=m.query.split("&");for(const h of o){const i=h.split("=")[1];if(/^https?:/.exec(i)){const s=$(L.URI.parse(i));if(s)return s}}}e.$Ew=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function p(m){return e.$Ew.indexOf(m)>=0}e.$Gw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function S(m){return e.$Gw.indexOf(m)>=0}function g(m,o,h,i){if(h===A.OperatingSystem.Windows)return!1;if(h===A.OperatingSystem.Macintosh&&S(o)){const s=/(\d+)\.(\d+)\.(\d+)/g.exec(i);if(s?.length===4&&parseInt(s[1])>=18)return!1}return m<1024}class w{constructor(o,h,i){this.remoteAddress=o,this.localAddress=h,this.b=i,this.a=new I.$je,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Jw=w;let P=class extends c.$Tc{constructor(o,h){super(),this.r=o,this.s=h,this.a=new I.$je,this.onTunnelOpened=this.a.event,this.b=new I.$je,this.onTunnelClosed=this.b.event,this.c=new I.$je,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const o=this.s.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.g=o,o?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.h=o.elevation,this.m=o.privacyOptions,this.j=o.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const o=[],h=Array.from(this.f.values());for(const i of h){const s=Array.from(i.values());for(const t of s){const n=await t.value;n&&typeof n!="string"&&o.push(n)}}return o}async dispose(){super.dispose();for(const o of this.f.values()){for(const{value:h}of o.values())await h.then(i=>typeof i!="string"?i?.dispose():void 0);o.clear()}this.f.clear()}setEnvironmentTunnel(o,h,i,s,t){this.z(o,h,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:h,localAddress:i,privacy:s,protocol:t,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,h){(S(o)||p(o))&&(o=e.$Ew[0]);const i=this.D(o,h);if(i)return++i.refcount,i.value}openTunnel(o,h,i,s,t,n=!1,r,a){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${i} on local port ${t}.`);const f=this.g??o;if(!f)return;if(h||(h="localhost"),s||(s=this.t),this.g&&this.n.has(i)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const v=this.F(f,h,i,s,t,n,r,a);return v?v.then(C=>{if(C){if(typeof C=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(h,i),C}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(h,i);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const b=this.w(C);return(C.tunnelRemoteHost!==h||C.tunnelRemotePort!==i)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&C.privacy!==r&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(b),b}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),v)}w(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const h=this.f.get(o.tunnelRemoteHost);if(h){const i=h.get(o.tunnelRemotePort);i&&(i.refcount--,await this.y(o.tunnelRemoteHost,o.tunnelRemotePort,i))}}}}async y(o,h,i){if(i.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${h}.`);const s=i.value.then(async t=>{t&&typeof t!="string"&&(await t.dispose(!0),this.b.fire({host:t.tunnelRemoteHost,port:t.tunnelRemotePort}))});return this.f.has(o)&&this.f.get(o).delete(h),s}}async closeTunnel(o,h){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${h} `);const i=this.f.get(o);if(i&&i.has(h)){const s=i.get(h);s.refcount=0,await this.y(o,h,s)}}z(o,h,i){this.f.has(o)||this.f.set(o,new Map),this.f.get(o).set(h,{refcount:1,value:i})}async C(o,h){const i=this.f.get(o);if(i){const s=i.get(h),t=s?await s.value:void 0;(!t||typeof t=="string")&&i.delete(h),i.size===0&&this.f.delete(o)}}D(o,h){const i=[o];p(o)?(i.push(...e.$Ew),i.push(...e.$Gw)):S(o)&&i.push(...e.$Gw);const s=i.map(t=>this.f.get(t));for(const t of s){const n=t?.get(h);if(n)return n}}canTunnel(o){return!!$(o)}G(o,h,i,s,t,n,r){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${i} on local port ${s}.`);const a=i;this.n.add(a);const f=s===void 0?i:s,v={elevationRequired:t?this.isPortPrivileged(f):!1},C={remoteAddress:{host:h,port:i},localAddressPort:s,privacy:n,public:n?n!==R.Private:void 0,protocol:r},b=o.forwardPort(C,v);return b?(this.z(h,i,b),b.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(a)})):this.n.delete(a),b}};e.$Kw=P,e.$Kw=P=ve([Q(0,k.$9j),Q(1,N.$9i)],P)}),define(he[202],ue([0,1,10,80,2,8,6]),function(oe,e,I,c,A,L,N){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.$uhc=void 0;class k extends A.$Tc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new N.$Zh),this.b.p)}setAddress(d){this.a=d,this.b&&(this.b.complete(d),this.b=null)}setTunnel(d){this.B(d)}}let y=class extends A.$Tc{static{O=this}static{this.a=0}constructor(d,u){super(),this.f=d,this.g=u,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(d=>d.dispose())}async createTunnel(){return{id:String(++O.a)}}async startTunnel(d,u,$,l,p,S,g){const w=new k,P=await Promise.resolve(this.f.openTunnel(d,w,$,l,p,S,g));if(!P||typeof P=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${$}:${l} (remote).`),w.dispose(),new Error("Could not create tunnel");if(this.c.has(u))throw this.c.delete(u),w.dispose(),await P.dispose(),(0,L.$5)();return w.setTunnel(P),this.b.set(u,w),this.g.info(`[SharedProcessTunnelService] Created tunnel ${u}: ${P.localAddress} (local) to ${$}:${l} (remote).`),{tunnelLocalPort:P.tunnelLocalPort,localAddress:P.localAddress}}async setAddress(d,u){const $=this.b.get(d);$&&$.setAddress(u)}async destroyTunnel(d){const u=this.b.get(d);if(u){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${d}.`),this.b.delete(d),await u.dispose();return}this.c.add(d)}};e.$uhc=y,e.$uhc=y=O=ve([Q(0,c.$Aw),Q(1,I.$9j)],y)}),define(he[28],ue([0,1,4]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=void 0,e.$Gl=(0,I.$Ci)("IUriIdentityService")}),define(he[203],ue([0,1,28,159,7,20,134,3,2]),function(oe,e,I,c,A,L,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=void 0;class y{static{this._clock=0}constructor(u){this.uri=u,this.time=y._clock++}touch(){return this.time=y._clock++,this}}let R=class{constructor(u){this.g=u,this.c=new k.$Sc,this.f=2**16;const $=new Map,l=p=>{let S=$.get(p.scheme);return S===void 0&&(S=u.hasProvider(p)&&!this.g.hasCapability(p,A.FileSystemProviderCapabilities.PathCaseSensitive),$.set(p.scheme,S)),S};this.c.add(O.Event.any(u.onDidChangeFileSystemProviderRegistrations,u.onDidChangeFileSystemProviderCapabilities)(p=>{$.delete(p.scheme)})),this.extUri=new L.$5g(l),this.d=new N.$Ps((p,S)=>this.extUri.compare(p,S,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(u){this.g.hasProvider(u)&&(u=(0,L.$eh)(u));const $=this.d.get(u);return $?$.touch().uri.with({fragment:u.fragment}):(this.d.set(u,new y(u)),this.h(),u)}h(){if(this.d.size<this.f)return;const u=[...this.d.entries()].sort((l,p)=>l[1].time<p[1].time?1:l[1].time>p[1].time?-1:0);y._clock=0,this.d.clear();const $=this.f*.5;for(let l=0;l<$;l++)this.d.set(u[l][0],u[l][1].touch())}};e.$Qs=R,e.$Qs=R=ve([Q(0,A.$9k)],R),(0,c.$Ns)(I.$Gl,R,c.InstantiationType.Delayed)}),define(he[204],ue([0,1,3,2,7,51,36]),function(oe,e,I,c,A,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=void 0;class O extends c.$Tc{constructor(y,R,d,u,$,l){super(),this.f=y,this.g=R,this.h=d,this.j=u,this.m=$,this.n=l,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new I.$je),this.onDidChangeFile=this.a.event,this.b=L.$Ii.forUris(()=>!(this.capabilities&A.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new N.$Ac(p=>this.m.extUri.getComparisonKey(this.t(p))),this.r(),this.B(u.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(p=>this.s(p)))}r(){this.c.clear();for(const y of this.j.profiles)this.c.add(y.settingsResource),this.c.add(y.keybindingsResource),this.c.add(y.tasksResource),this.c.add(y.extensionsResource)}open(y,R){return this.g.open(this.t(y),R)}close(y){return this.g.close(y)}read(y,R,d,u,$){return this.g.read(y,R,d,u,$)}write(y,R,d,u,$){return this.g.write(y,R,d,u,$)}watch(y,R){this.b.set(y,y);const d=this.g.watch(this.t(y),R);return(0,c.$Rc)(()=>{this.b.delete(y),d.dispose()})}stat(y){return this.g.stat(this.t(y))}mkdir(y){return this.g.mkdir(this.t(y))}rename(y,R,d){return this.g.rename(this.t(y),this.t(R),d)}readFile(y,R){return this.g.readFile(this.t(y),R)}readFileStream(y,R,d){return this.g.readFileStream(this.t(y),R,d)}readdir(y){return this.g.readdir(this.t(y))}enforceAtomicReadFile(y){return this.c.has(y)}writeFile(y,R,d){return this.g.writeFile(this.t(y),R,d)}enforceAtomicWriteFile(y){return this.c.has(y)?{postfix:".vsctmp"}:!1}delete(y,R){return this.g.delete(this.t(y),R)}copy(y,R,d){if((0,A.$al)(this.g))return this.g.copy(this.t(y),this.t(R),d);throw new Error("copy not supported")}cloneFile(y,R){if((0,A.$bl)(this.g))return this.g.cloneFile(this.t(y),this.t(R));throw new Error("clone not supported")}s(y){const R=[];for(const d of y){if(d.resource.scheme!==this.f)continue;const u=this.u(d.resource);this.b.findSubstr(u)&&R.push({resource:u,type:d.type,cId:d.cId})}R.length&&(this.n.debug("User data changed"),this.a.fire(R))}t(y){return y.with({scheme:this.f})}u(y){return y.with({scheme:this.h})}}e.$Xgc=O}),define(he[81],ue([0,1,64]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=c,e.$nMb=A,e.$oMb=L;function c(N,O,k,y){const R=(0,I.$9n)(N,O,k,y)[0];return R&&(N=N.substring(0,R.offset)+R.content+N.substring(R.offset+R.length)),N}function A(N,O,k){let y=k;for(;y>=0;){if(N.charAt(y)===O.charAt(O.length-1)&&O.length===1)return y+1;if(y--,O.length===2&&y>=0&&N.charAt(y)===O.charAt(0))return y+2}return 0}function L(N,O,k){let y=k;for(;y>=0;)if(N.charAt(y)===O.charAt(O.length-1)&&O.length===1||(y++,O.length===2&&y>=0&&N.charAt(y)===O.charAt(1)))return y;return N.length-1}}),define(he[205],ue([0,1,29,60,12]),function(oe,e,I,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2bc=L,c=ke(c);function L($,l,p,S,g,w){const P=[],m=[],o=[];if(!l){const F=$.filter(({identifier:K})=>g.every(W=>W.toLowerCase()!==K.id.toLowerCase()));return{local:{added:P,removed:m,updated:o},remote:F.length>0?{added:F,updated:[],removed:[],all:F}:null}}$=$.map(d),l=l.map(d),p=p?p.map(d):null;const h=new Map,i=F=>{F.uuid&&h.set(F.id.toLowerCase(),F.uuid)};$.forEach(({identifier:F})=>i(F)),l.forEach(({identifier:F})=>i(F)),p?.forEach(({identifier:F})=>i(F)),S?.forEach(({identifier:F})=>i(F)),w?.forEach(F=>i(F));const s=F=>{const K=F.identifier.uuid||h.get(F.identifier.id.toLowerCase());return K?`uuid:${K}`:`id:${F.identifier.id.toLowerCase()}`},t=(F,K)=>(F.set(s(K),K),F),n=$.reduce(t,new Map),r=l.reduce(t,new Map),a=l.reduce((F,K)=>t(F,(0,I.$ao)(K)),new Map),f=p?p.reduce(t,new Map):null,v=S.reduce(t,new Map),C=g.reduce((F,K)=>{const W=h.get(K.toLowerCase());return F.add(W?`uuid:${W}`:`id:${K.toLowerCase()}`)},new Set),b=w?w.reduce((F,{id:K,uuid:W})=>(W=W??h.get(K.toLowerCase()),F.add(W?`uuid:${W}`:`id:${K.toLowerCase()}`)),new Set):null,E=N(n,r,C,!1);if(E.added.size>0||E.removed.size>0||E.updated.size>0){const F=N(f,n,C,!1),K=N(f,r,C,!0),W=(x,G,ie,V)=>{let z,_,ne;return G.installed?(z=V.pinned,ne=V.preRelease,z&&(_=V.version)):(z=ie.pinned,ne=ie.preRelease,z&&(_=ie.version)),z===void 0&&(z=G.pinned,z&&(_=G.version)),ne===void 0&&(ne=G.preRelease),{...V,installed:G.installed||ie.installed,pinned:z,preRelease:ne,version:_??(ie.version&&(!G.installed||c.gt(ie.version,G.version))?ie.version:G.version),state:k(G,ie,f?.get(x))}};for(const x of K.removed.values()){const G=n.get(x);if(!G)continue;const ie=(0,A.$ng)(f?.get(x)),V=b&&!b.has(x)&&ie.installed;G.installed&&V?m.push(G.identifier):a.set(x,G)}for(const x of K.added.values()){const G=(0,A.$ng)(r.get(x)),ie=n.get(x);if(ie){if(E.updated.has(x)){const V=W(x,ie,G,G);O(ie,G,!1,!1)||o.push(u(V,x)),a.set(x,V)}}else G.installed&&P.push(u(G,x))}for(const x of K.updated.values()){const G=(0,A.$ng)(r.get(x)),ie=(0,A.$ng)(f?.get(x)),V=n.get(x);if(V)if(b&&!b.has(x)&&ie.installed&&V.installed&&!G.installed)m.push(V.identifier);else{const _=W(x,V,G,G);o.push(u(_,x)),a.set(x,_)}else G.installed&&P.push(u(G,x))}for(const x of F.added.values())K.added.has(x)||a.set(x,(0,A.$ng)(n.get(x)));for(const x of F.updated.values()){if(K.removed.has(x)||K.updated.has(x))continue;const G=(0,A.$ng)(n.get(x)),ie=(0,A.$ng)(r.get(x));a.set(x,W(x,G,ie,G))}for(const x of F.removed.values())K.updated.has(x)||K.removed.has(x)||v.has(x)||(0,A.$ng)(r.get(x)).installed&&b&&(b.has(x)||!(0,A.$ng)(f?.get(x)).installed||a.delete(x))}const T=[],j=N(r,a,new Set,!0),U=j.added.size>0||j.updated.size>0||j.removed.size>0;return U&&a.forEach((F,K)=>T.push(u(F,K))),{local:{added:P,removed:m,updated:o},remote:U?{added:[...j.added].map(F=>a.get(F)),updated:[...j.updated].map(F=>a.get(F)),removed:[...j.removed].map(F=>r.get(F)),all:T}:null}}function N($,l,p,S){const g=$?[...$.keys()].filter(h=>!p.has(h)):[],w=[...l.keys()].filter(h=>!p.has(h)),P=w.filter(h=>!g.includes(h)).reduce((h,i)=>(h.add(i),h),new Set),m=g.filter(h=>!w.includes(h)).reduce((h,i)=>(h.add(i),h),new Set),o=new Set;for(const h of g){if(m.has(h))continue;const i=$.get(h),s=l.get(h);(!s||!O(i,s,S,!0))&&o.add(h)}return{added:P,removed:m,updated:o}}function O($,l,p,S){return!($.disabled!==l.disabled||!!$.isApplicationScoped!=!!l.isApplicationScoped||S&&$.installed!==l.installed||$.installed&&l.installed&&($.preRelease!==l.preRelease||$.pinned!==l.pinned||l.pinned&&$.version!==l.version)||!R($.state,l.state)||p&&$.version!==l.version)}function k($,l,p){const S=$.state,g=l.state,w=p?.state;if(!l.version||S&&c.gt($.version,l.version))return S;if(g&&c.gt(l.version,$.version)||!S)return g;if(!g)return S;const P=(0,I.$ao)(S),m=w?y(w,g):{added:Object.keys(g).reduce((h,i)=>(h.add(i),h),new Set),removed:new Set,updated:new Set},o=w?y(w,S):{added:Object.keys(S).reduce((h,i)=>(h.add(i),h),new Set),removed:new Set,updated:new Set};for(const h of[...m.added.values(),...m.updated.values()])P[h]=g[h];for(const h of m.removed.values())o.updated.has(h)||delete P[h];return P}function y($,l){const p=Object.keys($),S=Object.keys(l),g=S.filter(m=>!p.includes(m)).reduce((m,o)=>(m.add(o),m),new Set),w=p.filter(m=>!S.includes(m)).reduce((m,o)=>(m.add(o),m),new Set),P=new Set;for(const m of p){if(w.has(m))continue;const o=$[m],h=l[m];(0,I.$eo)(o,h)||P.add(m)}return{added:g,removed:w,updated:P}}function R($={},l={}){const{added:p,removed:S,updated:g}=y($,l);return p.size===0&&S.size===0&&g.size===0}function d($){return{...$,disabled:!!$.disabled,installed:!!$.installed}}function u($,l){const p={...$,identifier:{id:$.identifier.id,uuid:l.startsWith("uuid:")?l.substring(5):void 0},preRelease:!!$.preRelease,pinned:!!$.pinned};return $.disabled||delete p.disabled,$.installed||delete p.installed,$.state||delete p.state,$.isApplicationScoped||delete p.isApplicationScoped,p}}),define(he[114],ue([0,1,17,21,4]),function(oe,e,I,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EOb=e.$DOb=void 0,e.$DOb=(0,A.$Ci)("IIgnoredExtensionsManagementService");let L=class{constructor(O){this.a=O}hasToNeverSyncExtension(O){return this.b().includes(O.toLowerCase())}hasToAlwaysSyncExtension(O){return this.b().includes(`-${O.toLowerCase()}`)}updateIgnoredExtensions(O,k){let y=[...this.a.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return y=y.filter(R=>R!==O&&R!==`-${O}`),k&&y.push(O.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",y.length?y:void 0,c.ConfigurationTarget.USER)}updateSynchronizedExtensions(O,k){let y=[...this.a.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return y=y.filter(R=>R!==O&&R!==`-${O}`),k&&y.push(`-${O.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",y.length?y:void 0,c.ConfigurationTarget.USER)}getIgnoredExtensions(O){const k=O.filter(u=>u.isMachineScoped).map(u=>u.identifier.id.toLowerCase()),y=this.b().map(u=>u.toLowerCase()),R=[],d=[];if(Array.isArray(y))for(const u of y)u.startsWith("-")?d.push(u.substring(1)):R.push(u);return(0,I.$Lb)([...k,...R].filter(u=>!d.includes(u)))}b(){let O=this.a.inspect("settingsSync.ignoredExtensions").userValue;return O!==void 0||(O=this.a.inspect("sync.ignoredExtensions").userValue,O!==void 0)?O:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(k=>k.toLowerCase())}};e.$EOb=L,e.$EOb=L=ve([Q(0,c.$9i)],L)}),define(he[206],ue([0,1,17,35,29,96,81]),function(oe,e,I,c,A,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8bc=k,A=ke(A),N=ke(N);function O(m){return(0,c.$Un)(m)||[]}async function k(m,o,h,i,s){const t=O(m),n=O(o),r=h?O(h):null,a=[...t,...n,...r||[]].map(W=>W.key),f=await s.resolveUserBindings(a),v=R(t,n,r,f);if(!v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:m,hasChanges:!1,hasConflicts:!1};if(!v.hasLocalForwarded&&v.hasRemoteForwarded)return{mergeContent:o,hasChanges:!0,hasConflicts:!1};if(v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:m,hasChanges:!0,hasConflicts:!1};const C=u(t),b=u(n),E=r?u(r):null,T=l(C,b,f),j=E?l(E,C,f):{added:[...C.keys()].reduce((W,x)=>(W.add(x),W),new Set),removed:new Set,updated:new Set},U=E?l(E,b,f):{added:[...b.keys()].reduce((W,x)=>(W.add(x),W),new Set),removed:new Set,updated:new Set},F=y(T,j,U);let K=m;for(const W of F.removed.values())F.conflicts.has(W)||(K=w(K,W,i));for(const W of F.added.values()){if(F.conflicts.has(W))continue;const x=b.get(W);if(x.some(G=>G.command!==`-${W}`&&v.conflicts.has(f[G.key]))){F.conflicts.add(W);continue}K=g(K,x,i)}for(const W of F.updated.values()){if(F.conflicts.has(W))continue;const x=b.get(W);if(x.some(G=>G.command!==`-${W}`&&v.conflicts.has(f[G.key]))){F.conflicts.add(W);continue}K=P(K,W,x,i)}return{mergeContent:K,hasChanges:!0,hasConflicts:F.conflicts.size>0}}function y(m,o,h){const i=new Set,s=new Set,t=new Set,n=new Set;for(const r of o.removed.values())h.updated.has(r)&&n.add(r);for(const r of h.removed.values())n.has(r)||(o.updated.has(r)?n.add(r):s.add(r));for(const r of o.added.values())n.has(r)||h.added.has(r)&&m.updated.has(r)&&n.add(r);for(const r of h.added.values())n.has(r)||(o.added.has(r)?m.updated.has(r)&&n.add(r):i.add(r));for(const r of o.updated.values())n.has(r)||h.updated.has(r)&&m.updated.has(r)&&n.add(r);for(const r of h.updated.values())n.has(r)||(o.updated.has(r)?m.updated.has(r)&&n.add(r):t.add(r));return{added:i,removed:s,updated:t,conflicts:n}}function R(m,o,h,i){const s=new Set,t=d(m,i),n=d(o,i),r=h?d(h,i):null,a=$(t,n);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:s,removed:s,updated:s,conflicts:s};const f=r?$(r,t):{added:[...t.keys()].reduce((j,U)=>(j.add(U),j),new Set),removed:new Set,updated:new Set};if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:s,removed:s,updated:s,conflicts:s};const v=r?$(r,n):{added:[...n.keys()].reduce((j,U)=>(j.add(U),j),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:s,removed:s,updated:s,conflicts:s};const{added:C,removed:b,updated:E,conflicts:T}=y(a,f,v);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:C,removed:b,updated:E,conflicts:T}}function d(m,o){const h=new Map;for(const i of m){const s=o[i.key];let t=h.get(s);t||(t=[],h.set(s,t)),t.push(i)}return h}function u(m){const o=new Map;for(const h of m){const i=h.command[0]==="-"?h.command.substring(1):h.command;let s=o.get(i);s||(s=[],o.set(i,s)),s.push(h)}return o}function $(m,o){const h=[...m.keys()],i=[...o.keys()],s=i.filter(r=>!h.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),t=h.filter(r=>!i.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),n=new Set;for(const r of h){if(t.has(r))continue;const a=m.get(r).map(v=>({...v,key:r})),f=o.get(r).map(v=>({...v,key:r}));(0,I.$tb)(a,f,(v,C)=>S(v,C))||n.add(r)}return{added:s,removed:t,updated:n}}function l(m,o,h){const i=[...m.keys()],s=[...o.keys()],t=s.filter(a=>!i.includes(a)).reduce((a,f)=>(a.add(f),a),new Set),n=i.filter(a=>!s.includes(a)).reduce((a,f)=>(a.add(f),a),new Set),r=new Set;for(const a of i){if(n.has(a))continue;const f=m.get(a).map(C=>({...C,key:h[C.key]})),v=o.get(a).map(C=>({...C,key:h[C.key]}));p(f,v)||r.add(a)}return{added:t,removed:n,updated:r}}function p(m,o){return!(!(0,I.$tb)(m.filter(({command:h})=>h[0]!=="-"),o.filter(({command:h})=>h[0]!=="-"),(h,i)=>S(h,i))||!(0,I.$tb)(m.filter(({command:h})=>h[0]==="-"),o.filter(({command:h})=>h[0]==="-"),(h,i)=>S(h,i)))}function S(m,o){if(m.command!==o.command||m.key!==o.key)return!1;const h=L.$Aj.deserialize(m.when),i=L.$Aj.deserialize(o.when);return!(h&&!i||!h&&i||h&&i&&!h.equals(i)||!A.$eo(m.args,o.args))}function g(m,o,h){for(const i of o)m=N.edit(m,[-1],i,h);return m}function w(m,o,h){const i=O(m);for(let s=i.length-1;s>=0;s--)(i[s].command===o||i[s].command===`-${o}`)&&(m=N.edit(m,[s],void 0,h));return m}function P(m,o,h,i){const s=O(m),t=s.findIndex(n=>n.command===o||n.command===`-${o}`);for(let n=s.length-1;n>=0;n--)(s[n].command===o||s[n].command===`-${o}`)&&(m=N.edit(m,[n],void 0,i));for(let n=h.length-1;n>=0;n--)m=N.edit(m,[t],h[n],i);return m}}),define(he[207],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ccc=I,e.$dcc=A;function I(L,N,O){const k={},y={},R=new Set;if(!N)return{local:{added:k,updated:y,removed:[...R.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const d=c(L,N);if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{local:{added:k,updated:y,removed:[...R.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const u=c(O,L),$=c(O,N),l={},p={},S=new Set,g=new Set;for(const w of u.removed.values())$.updated.has(w)?k[w]=N[w]:S.add(w);for(const w of $.removed.values())g.has(w)||(u.updated.has(w)?g.add(w):R.add(w));for(const w of u.updated.values())g.has(w)||($.updated.has(w)?d.updated.has(w)&&g.add(w):p[w]=L[w]);for(const w of $.updated.values())g.has(w)||(u.updated.has(w)?d.updated.has(w)&&g.add(w):L[w]!==void 0&&(y[w]=N[w]));for(const w of u.added.values())g.has(w)||($.added.has(w)?d.updated.has(w)&&g.add(w):l[w]=L[w]);for(const w of $.added.values())g.has(w)||(u.added.has(w)?d.updated.has(w)&&g.add(w):k[w]=N[w]);return{local:{added:k,removed:[...R.values()],updated:y},remote:{added:l,removed:[...S.values()],updated:p},conflicts:[...g.values()]}}function c(L,N){const O=L?Object.keys(L):[],k=N?Object.keys(N):[],y=k.filter(u=>!O.includes(u)).reduce((u,$)=>(u.add($),u),new Set),R=O.filter(u=>!k.includes(u)).reduce((u,$)=>(u.add($),u),new Set),d=new Set;for(const u of O){if(R.has(u))continue;const $=L[u],l=N[u];$!==l&&d.add(u)}return{added:y,removed:R,updated:d}}function A(L,N){const{added:O,removed:k,updated:y}=c(L,N);return O.size===0&&k.size===0&&y.size===0}}),define(he[208],ue([0,1,29]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2dc=c;function c(L,N,O,k){const y={added:[],removed:[],updated:[]};let R={added:[],removed:[],updated:[]};if(!N){const u=L.filter(({id:$})=>!k.includes($));return u.length?R.added=u:R=null,{local:y,remote:R}}const d=A(L,N,k);if(d.added.length>0||d.removed.length>0||d.updated.length>0){const u=A(O,L,k),$=A(O,N,k);for(const l of $.removed){const p=L.find(S=>S.id===l);p&&y.removed.push(p)}for(const l of $.added){const p=N.find(S=>S.id===l);u.added.includes(l)?d.updated.includes(l)&&y.updated.push(p):y.added.push(p)}for(const l of $.updated)y.updated.push(N.find(p=>p.id===l));for(const l of u.added)$.added.includes(l)||R.added.push(L.find(p=>p.id===l));for(const l of u.updated)$.removed.includes(l)||$.updated.includes(l)||R.updated.push(L.find(p=>p.id===l));for(const l of u.removed){const p=N.find(S=>S.id===l);p&&R.removed.push(p)}}return R.added.length===0&&R.removed.length===0&&R.updated.length===0&&(R=null),{local:y,remote:R}}function A(L,N,O){L=L?L.filter(({id:$})=>!O.includes($)):[],N=N.filter(({id:$})=>!O.includes($));const k=L.map(({id:$})=>$),y=N.map(({id:$})=>$),R=y.filter($=>!k.includes($)),d=k.filter($=>!y.includes($)),u=[];for(const{id:$,name:l,shortName:p,icon:S,useDefaultFlags:g}of L){if(d.includes($))continue;const w=N.find(P=>P.id===$);(!w||w.name!==l||w.shortName!==p||w.icon!==S||!(0,I.$eo)(w.useDefaultFlags,g))&&u.push($)}return{added:R,removed:d,updated:u}}}),define(he[24],ue([0,1,17,12,11,47,27,4,103,44]),function(oe,e,I,c,A,L,N,O,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fnb=e.$Enb=e.$Dnb=e.$Cnb=e.$Bnb=e.$Anb=e.$znb=e.$ynb=e.$xnb=e.$vnb=e.MergeState=e.Change=e.SyncStatus=e.$unb=e.$tnb=e.$snb=e.UserDataSyncErrorCode=e.$qnb=e.$pnb=e.$onb=e.$nnb=e.$mnb=e.$jnb=e.SyncResource=e.$gnb=e.$fnb=void 0,e.$cnb=R,e.$dnb=d,e.$enb=u,e.$hnb=l,e.$inb=p,e.$knb=g,e.$lnb=w,e.$rnb=P,e.$wnb=r;function R(){const a=y.$no.as(L.$so.Configuration).getConfigurationProperties();return Object.keys(a).filter(f=>!!a[f].disallowSyncIgnore)}function d(a=!1){const f=y.$no.as(L.$so.Configuration).getConfigurationProperties(),v=$(f,a),C=R();return(0,I.$Lb)([...v,...C])}function u(a){if(!a.contributes?.configuration)return[];const f=Array.isArray(a.contributes.configuration)?a.contributes.configuration:[a.contributes.configuration];if(!f.length)return[];const v=(0,L.$Io)(f);return $(v,!1)}function $(a,f){const v=new Set;for(const C in a){if(f&&a[C].source)continue;const b=(0,c.$cg)(a[C].scope)?(0,L.$Jo)(a[C].scope):a[C].scope;(a[C].ignoreSync||b===L.ConfigurationScope.MACHINE||b===L.ConfigurationScope.MACHINE_OVERRIDABLE)&&v.add(C)}return[...v.values()]}e.$fnb="settingsSync",e.$gnb="settingsSync.keybindingsPerPlatform";function l(){const a="vscode://schemas/ignoredSettings",f=y.$no.as(L.$so.Configuration);f.registerConfiguration({id:"settingsSync",order:30,title:(0,A.localize)(10894,null),type:"object",properties:{[e.$gnb]:{type:"boolean",description:(0,A.localize)(10895,null),default:!0,scope:L.ConfigurationScope.APPLICATION,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,A.localize)(10896,null),items:[{type:"string",pattern:N.$7o,errorMessage:(0,A.localize)(10897,null)}],default:[],scope:L.ConfigurationScope.APPLICATION,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,A.localize)(10898,null),default:[],scope:L.ConfigurationScope.APPLICATION,$ref:a,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const v=y.$no.as(k.$oo.JSONContribution),C=()=>{const b=R(),E=d(),T=Object.keys(L.$to.properties).filter(F=>!E.includes(F)),j=E.filter(F=>!b.includes(F)),U={items:{type:"string",enum:[...T,...j.map(F=>`-${F}`)]}};v.registerSchema(a,U)};return f.onDidUpdateConfiguration(()=>C())}function p(a){return a&&(0,c.$eg)(a)&&(0,c.$cg)(a.id)&&Array.isArray(a.scopes)}var S;(function(a){a.Settings="settings",a.Keybindings="keybindings",a.Snippets="snippets",a.Tasks="tasks",a.Extensions="extensions",a.GlobalState="globalState",a.Profiles="profiles",a.WorkspaceState="workspaceState"})(S||(e.SyncResource=S={})),e.$jnb=[S.Settings,S.Keybindings,S.Snippets,S.Tasks,S.Extensions,S.GlobalState,S.Profiles];function g(a,...f){return a?[a,...f]:f}function w(a,f,v,C){return C.joinPath(v.userDataSyncHome,...g(a,f,`lastSync${f}.json`))}e.$mnb=(0,O.$Ci)("IUserDataSyncStoreManagementService"),e.$nnb=(0,O.$Ci)("IUserDataSyncStoreService"),e.$onb=(0,O.$Ci)("IUserDataSyncLocalStoreService"),e.$pnb="x-operation-id",e.$qnb="X-Execution-Id";function P(a){const f={};return f[e.$qnb]=a,f}var m;(function(a){a.Unauthorized="Unauthorized",a.Forbidden="Forbidden",a.NotFound="NotFound",a.MethodNotFound="MethodNotFound",a.Conflict="Conflict",a.Gone="Gone",a.PreconditionFailed="PreconditionFailed",a.TooLarge="TooLarge",a.UpgradeRequired="UpgradeRequired",a.PreconditionRequired="PreconditionRequired",a.TooManyRequests="RemoteTooManyRequests",a.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",a.RequestFailed="RequestFailed",a.RequestCanceled="RequestCanceled",a.RequestTimeout="RequestTimeout",a.RequestProtocolNotSupported="RequestProtocolNotSupported",a.RequestPathNotEscaped="RequestPathNotEscaped",a.RequestHeadersNotObject="RequestHeadersNotObject",a.NoCollection="NoCollection",a.NoRef="NoRef",a.EmptyResponse="EmptyResponse",a.TurnedOff="TurnedOff",a.SessionExpired="SessionExpired",a.ServiceChanged="ServiceChanged",a.DefaultServiceChanged="DefaultServiceChanged",a.LocalTooManyProfiles="LocalTooManyProfiles",a.LocalTooManyRequests="LocalTooManyRequests",a.LocalPreconditionFailed="LocalPreconditionFailed",a.LocalInvalidContent="LocalInvalidContent",a.LocalError="LocalError",a.IncompatibleLocalContent="IncompatibleLocalContent",a.IncompatibleRemoteContent="IncompatibleRemoteContent",a.Unknown="Unknown"})(m||(e.UserDataSyncErrorCode=m={}));class o extends Error{constructor(f,v,C,b){super(f),this.code=v,this.resource=C,this.operationId=b,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$snb=o;class h extends o{constructor(f,v,C,b,E){super(f,C,void 0,E),this.url=v,this.serverCode=b}}e.$tnb=h;class i extends o{constructor(f,v){super(f,v)}}e.$unb=i,function(a){function f(v){if(v instanceof a)return v;const C=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(v.name);if(C&&C[1]){const b=C[2]==="unknown"?void 0:C[2],E=C[3]==="unknown"?void 0:C[3];return new a(v.message,C[1],b,E)}return new a(v.message,m.Unknown)}a.toUserDataSyncError=f}(o||(e.$snb=o={}));var s;(function(a){a.Uninitialized="uninitialized",a.Idle="idle",a.Syncing="syncing",a.HasConflicts="hasConflicts"})(s||(e.SyncStatus=s={}));var t;(function(a){a[a.None=0]="None",a[a.Added=1]="Added",a[a.Modified=2]="Modified",a[a.Deleted=3]="Deleted"})(t||(e.Change=t={}));var n;(function(a){a.Preview="preview",a.Conflict="conflict",a.Accepted="accepted"})(n||(e.MergeState=n={})),e.$vnb="sync.store.url.type";function r(a){return`sync.enable.${a}`}e.$xnb=(0,O.$Ci)("IUserDataSyncEnablementService"),e.$ynb=(0,O.$Ci)("IUserDataSyncService"),e.$znb=(0,O.$Ci)("IUserDataSyncResourceProviderService"),e.$Anb=(0,O.$Ci)("IUserDataAutoSyncService"),e.$Bnb=(0,O.$Ci)("IUserDataSyncUtilService"),e.$Cnb=(0,O.$Ci)("IUserDataSyncLogService"),e.$Dnb="userDataSync",e.$Enb="vscode-userdata-sync",e.$Fnb="preview"}),define(he[209],ue([0,1,29,24]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VNb=A,I=ke(I);function A(N,O,k,y,R){if(!O)return{remote:{added:Object.keys(N),removed:[],updated:[],all:Object.keys(N).length>0?N:null},local:{added:{},removed:[],updated:{}}};const d=L(N,O);if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const u=k?L(k,O):{added:Object.keys(O).reduce((w,P)=>(w.add(P),w),new Set),removed:new Set,updated:new Set},$=k?L(k,N):{added:Object.keys(N).reduce((w,P)=>(w.add(P),w),new Set),removed:new Set,updated:new Set},l={added:{},removed:[],updated:{}},p=I.$ao(O),S=!k;for(const w of $.added.values())w!==c.$vnb&&S&&u.added.has(w)||(p[w]=N[w]);for(const w of $.updated.values())p[w]=N[w];for(const w of $.removed.values())y.unregistered.includes(w)||delete p[w];for(const w of u.added.values()){const P=O[w];if(y.machine.includes(w)){R.info(`GlobalState: Skipped adding ${w} in local storage because it is declared as machine scoped.`);continue}if(k&&$.added.has(w))continue;const m=N[w];m&&m.value===P.value||w===c.$vnb&&S&&$.added.has(w)||(m?l.updated[w]=P:l.added[w]=P)}for(const w of u.updated.values()){const P=O[w];if(y.machine.includes(w)){R.info(`GlobalState: Skipped updating ${w} in local storage because it is declared as machine scoped.`);continue}if($.updated.has(w)||$.removed.has(w))continue;const m=N[w];m&&m.value===P.value||(l.updated[w]=P)}for(const w of u.removed.values()){if(y.machine.includes(w)){R.trace(`GlobalState: Skipped removing ${w} in local storage because it is declared as machine scoped.`);continue}$.updated.has(w)||$.removed.has(w)||l.removed.push(w)}const g=L(O,p);return{local:l,remote:{added:[...g.added],updated:[...g.updated],removed:[...g.removed],all:g.added.size===0&&g.removed.size===0&&g.updated.size===0?null:p}}}function L(N,O){const k=Object.keys(N),y=Object.keys(O),R=y.filter($=>!k.includes($)).reduce(($,l)=>($.add(l),$),new Set),d=k.filter($=>!y.includes($)).reduce(($,l)=>($.add(l),$),new Set),u=new Set;for(const $ of k){if(d.has($))continue;const l=N[$],p=O[$];I.$eo(l,p)||u.add($)}return{added:R,removed:d,updated:u}}}),define(he[210],ue([0,1,17,35,64,45,29,81,24]),function(oe,e,I,c,A,L,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pMb=y,e.$qMb=u,e.$rMb=$,e.$sMb=l,e.$tMb=S,e.$uMb=w,N=ke(N),O=ke(O);function y(a,f,v){let C=[];v?C=d(v):C=R(f);const b=[],E=[...(0,k.$cnb)()];if(Array.isArray(C))for(const T of C)T.startsWith("-")?E.push(T.substring(1)):b.push(T);return(0,I.$Lb)([...a,...b].filter(T=>!E.includes(T)))}function R(a){let f=a.inspect("settingsSync.ignoredSettings").userValue;return f!==void 0||(f=a.inspect("sync.ignoredSettings").userValue,f!==void 0)?f:a.getValue("settingsSync.ignoredSettings")||[]}function d(a){const f=(0,c.$Un)(a);return f?f["settingsSync.ignoredSettings"]||f["sync.ignoredSettings"]||[]:[]}function u(a,f){const v=(0,c.$Un)(a)||{};let C="{}";for(const b of Object.keys(v)){const E=(0,A.$9n)(C,[b],v[b],f);C=(0,A.$_n)(C,E)}return C}function $(a,f,v,C){if(v.length){const b=r(f),E=(0,c.$Un)(f)||{},T=(0,c.$Un)(a);if(!T)return a;const j=[];for(const U of v){const F=E[U],K=T[U];F===void 0?a=O.edit(a,[U],void 0,C):K!==void 0?a=O.edit(a,[U],F,C):j.push(h(U,b))}j.sort((U,F)=>U.startOffset-F.startOffset),j.forEach(U=>a=w(U.setting.key,f,a,C))}return a}function l(a,f,v,C,b,E){const T=$(a,f,C,E),j=v!==T,U=v!==f;if(!j&&!U)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(j&&!U)return{conflictsSettings:[],localContent:null,remoteContent:T,hasConflicts:!1};if(U&&!j)return{conflictsSettings:[],localContent:$(f,a,C,E),remoteContent:null,hasConflicts:!1};if(v===null&&S(a)){const D=p(a,f,C)?null:$(f,a,C,E);return{conflictsSettings:[],localContent:D,remoteContent:null,hasConflicts:!1}}let F=a,K=f;const W=(0,c.$Un)(a),x=(0,c.$Un)(f),G=v?(0,c.$Un)(v):null,ie=C.reduce((D,J)=>(D.add(J),D),new Set),V=g(W,x,ie),z=g(G,W,ie),_=g(G,x,ie),ne=new Map,ce=new Set,te=D=>{ce.add(D);const J=b.filter(({key:q})=>q===D)[0];J?(F=O.edit(F,[D],J.value,E),K=O.edit(K,[D],J.value,E)):ne.set(D,{key:D,localValue:W[D],remoteValue:x[D]})};for(const D of z.removed.values())_.updated.has(D)?te(D):K=O.edit(K,[D],void 0,E);for(const D of _.removed.values())ce.has(D)||(z.updated.has(D)?te(D):F=O.edit(F,[D],void 0,E));for(const D of z.updated.values())ce.has(D)||(_.updated.has(D)?V.updated.has(D)&&te(D):K=O.edit(K,[D],W[D],E));for(const D of _.updated.values())ce.has(D)||(z.updated.has(D)?V.updated.has(D)&&te(D):F=O.edit(F,[D],x[D],E));for(const D of z.added.values())ce.has(D)||(_.added.has(D)?V.updated.has(D)&&te(D):K=w(D,F,K,E));for(const D of _.added.values())ce.has(D)||(z.added.has(D)?V.updated.has(D)&&te(D):F=w(D,K,F,E));const Y=ne.size>0||!p(F,K,C),H=Y||!p(F,a,[]),B=Y||!p(K,f,[]);return{localContent:H?F:null,remoteContent:B?K:null,conflictsSettings:[...ne.values()],hasConflicts:Y}}function p(a,f,v){if(a===f)return!0;const C=(0,c.$Un)(a),b=(0,c.$Un)(f),E=v.reduce((U,F)=>(U.add(F),U),new Set),T=r(a).filter(U=>!(U.setting&&E.has(U.setting.key))),j=r(f).filter(U=>!(U.setting&&E.has(U.setting.key)));if(T.length!==j.length)return!1;for(let U=0;U<T.length;U++){const F=T[U],K=j[U];if(F.setting&&K.setting){if(F.setting.key!==K.setting.key||!N.$eo(C[F.setting.key],b[F.setting.key]))return!1}else if(!F.setting&&!K.setting){if(F.value!==K.value)return!1}else return!1}return!0}function S(a){return a?r(a).length===0:!0}function g(a,f,v){const C=a?Object.keys(a).filter(U=>!v.has(U)):[],b=Object.keys(f).filter(U=>!v.has(U)),E=b.filter(U=>!C.includes(U)).reduce((U,F)=>(U.add(F),U),new Set),T=C.filter(U=>!b.includes(U)).reduce((U,F)=>(U.add(F),U),new Set),j=new Set;if(a)for(const U of C){if(T.has(U))continue;const F=a[U],K=f[U];N.$eo(F,K)||j.add(U)}return{added:E,removed:T,updated:j}}function w(a,f,v,C){const b=(0,c.$Un)(f),E=r(f),T=r(v),j=P(a,E,T);return m(v,a,b[a],j,T,C)}function P(a,f,v){const C=f.findIndex(E=>E.setting?.key===a),b=f[C-1];if(b){if(b.setting){const T=h(b.setting.key,v);if(T)return{index:v.indexOf(T),insertAfter:!0}}else{const T=i(C,f);if(T){const j=h(T.setting.key,v);if(j){const U=s(v.indexOf(j),v),F=t(f,T,f[C]);if(U){const K=t(v,j,U),W=n(F,K);return W?{index:v.indexOf(W),insertAfter:!0}:{index:v.indexOf(U),insertAfter:!1}}else{const K=t(v,j,v[v.length-1]),W=n(F,K);return W?{index:v.indexOf(W),insertAfter:!0}:{index:v.length-1,insertAfter:!0}}}}}const E=f[C+1];if(E)if(E.setting){const T=h(E.setting.key,v);if(T)return{index:v.indexOf(T),insertAfter:!1}}else{const T=s(C,f);if(T){const j=h(T.setting.key,v);if(j){const U=i(v.indexOf(j),v),F=t(f,f[C],T);if(U){const K=t(v,U,j),W=n(F.reverse(),K.reverse());return W?{index:v.indexOf(W),insertAfter:!1}:{index:v.indexOf(U),insertAfter:!0}}else{const K=t(v,v[0],j),W=n(F.reverse(),K.reverse());return W?{index:v.indexOf(W),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:v.length-1,insertAfter:!0}}function m(a,f,v,C,b,E){let T;return C.index===-1?T=(0,A.$9n)(a,[f],v,E):T=o(a,f,v,C,b,E).map(j=>(0,A.$0n)(a,j,E)[0]),(0,A.$_n)(a,T)}function o(a,f,v,C,b,E){const T=`${JSON.stringify(f)}: ${JSON.stringify(v)}`,j=(0,L.$6n)(E,a),U=b[C.index];if(C.insertAfter){const F=[];if(U.setting)F.push({offset:U.endOffset,length:0,content:","+T});else{const K=s(C.index,b),W=i(C.index,b),x=W?.setting?.commaOffset;W&&x===void 0&&F.push({offset:W.endOffset,length:0,content:","});const G=x!==void 0&&x>U.endOffset;F.push({offset:G?x+1:U.endOffset,length:0,content:K?j+T+",":j+T})}return F}else{if(U.setting)return[{offset:U.startOffset,length:0,content:T+","}];const F=(b[C.index-1]&&!b[C.index-1].setting?j:"")+T+(s(C.index,b)?",":"")+j;return[{offset:U.startOffset,length:0,content:F}]}}function h(a,f){return f.filter(v=>v.setting?.key===a)[0]}function i(a,f){for(let v=a-1;v>=0;v--)if(f[v].setting)return f[v]}function s(a,f){for(let v=a+1;v<f.length;v++)if(f[v].setting)return f[v]}function t(a,f,v){const C=a.indexOf(f),b=a.indexOf(v);return a.filter((E,T)=>C<T&&T<b)}function n(a,f){if(a.length&&f.length){let v=0;for(;v<f.length&&v<a.length;v++)if(a[v].value!==f[v].value)return f[v-1];return f[v-1]}}function r(a){const f=[];let v=-1,C,b;const E={onObjectBegin:T=>{v++},onObjectProperty:(T,j,U)=>{v===0&&(C=j,b=T)},onObjectEnd:(T,j)=>{v--,v===0&&f.push({startOffset:C,endOffset:T+j,value:a.substring(C,T+j),setting:{key:b,commaOffset:void 0}})},onArrayBegin:(T,j)=>{v++},onArrayEnd:(T,j)=>{v--,v===0&&f.push({startOffset:C,endOffset:T+j,value:a.substring(C,T+j),setting:{key:b,commaOffset:void 0}})},onLiteralValue:(T,j,U)=>{v===0&&f.push({startOffset:C,endOffset:j+U,value:a.substring(C,j+U),setting:{key:b,commaOffset:void 0}})},onSeparator:(T,j,U)=>{if(v===0&&T===","){let F=f.length-1;for(;F>=0&&!f[F].setting;F--);const K=f[F];K&&f.splice(F,1,{startOffset:K.startOffset,endOffset:K.endOffset,value:K.value,setting:{key:K.setting.key,commaOffset:j}})}},onComment:(T,j)=>{v===0&&f.push({startOffset:T,endOffset:T+j,value:a.substring(T,T+j)})}};return(0,c.$2n)(a,E),f}}),define(he[82],ue([0,1,3,2,4,24]),function(oe,e,I,c,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aMb=e.$_Lb=void 0,e.$_Lb=(0,A.$Ci)("IUserDataSyncAccountService");let N=class extends c.$Tc{get account(){return this.a}constructor(k,y){super(),this.g=k,this.h=y,this.b=this.B(new I.$je),this.onDidChangeAccount=this.b.event,this.c=this.B(new I.$je),this.onTokenFailed=this.c.event,this.f=!1,this.B(k.onTokenFailed(R=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,R),this.updateAccount(void 0),R===L.UserDataSyncErrorCode.Forbidden?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(k.onTokenSucceed(()=>this.f=!1))}async updateAccount(k){(k&&this.a?k.token!==this.a.token||k.authenticationProviderId!==this.a.authenticationProviderId:k!==this.a)&&(this.a=k,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(k))}};e.$aMb=N,e.$aMb=N=ve([Q(0,L.$nnb),Q(1,L.$Cnb)],N)}),define(he[211],ue([0,1,20,11,15,10,24]),function(oe,e,I,c,A,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FOb=void 0;let O=class extends L.$bk{constructor(y,R){super(),this.g=this.B(y.createLogger((0,I.$dh)(R.logsHome,`${N.$Dnb}.log`),{id:N.$Dnb,name:(0,c.localize)(10893,null)}))}trace(y,...R){this.g.trace(y,...R)}debug(y,...R){this.g.debug(y,...R)}info(y,...R){this.g.info(y,...R)}warn(y,...R){this.g.warn(y,...R)}error(y,...R){this.g.error(y,...R)}flush(){this.g.flush()}};e.$FOb=O,e.$FOb=O=ve([Q(0,L.$0j),Q(1,A.$Ji)],O)}),define(he[212],ue([0,1,6,3,2]),function(oe,e,I,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=void 0;class L extends A.$Tc{constructor({onDidOpenMainWindow:O,onDidFocusMainWindow:k,getActiveWindowId:y}){super(),this.a=this.B(new A.$Sc),c.Event.latch(c.Event.any(O,k))(this.f,this,this.a),this.b=(0,I.$ph)(()=>y()),(async()=>{try{const d=await this.b;this.c=typeof this.c=="number"?this.c:d}catch{}finally{this.b=void 0}})()}f(O){this.b&&(this.b.cancel(),this.b=void 0),this.c=O}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$qgc=L}),define(he[115],ue([0,1,11,13,51,20,9,4,22]),function(oe,e,I,c,A,L,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Wi=e.$Vi=e.WorkbenchState=e.$Pi=e.$Oi=e.$Li=void 0,e.$Mi=y,e.$Ni=R,e.$Qi=d,e.$Ri=u,e.$Si=$,e.$Ti=p,e.$Ui=S,e.$Xi=P,e.$3i=m,e.$4i=o,e.$6i=h,e.$7i=i,e.$8i=s,e.$Li=(0,O.$Ci)("contextService");function y(t){const n=t;return typeof n?.id=="string"&&N.URI.isUri(n.uri)}function R(t){return typeof t?.id=="string"&&!y(t)&&!u(t)}e.$Oi={id:"ext-dev"},e.$Pi={id:"empty-window"};function d(t,n){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,c.$mc)(t)}:n?e.$Oi:e.$Pi;const r=t;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}function u(t){const n=t;return typeof n?.id=="string"&&N.URI.isUri(n.configPath)}function $(t){const n=t;if(n?.uri)return{id:n.id,uri:N.URI.revive(n.uri)};const r=t;if(r?.configPath)return{id:r.id,configPath:N.URI.revive(r.configPath)};if(t?.id)return{id:t.id}}var l;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(l||(e.WorkbenchState=l={}));function p(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}function S(t){const n=t;return!!(n&&typeof n=="object"&&N.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}class g{constructor(n,r,a,f,v){this.h=n,this.j=a,this.k=f,this.l=v,this.c=A.$Ii.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=A.$Ii.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Vi=g;class w{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,L.$dh)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Wi=w;function P(t){return new w({uri:t,index:0,name:(0,L.$_g)(t)},{uri:t.toString()})}e.$Yi="code-workspace",e.$Zi=`.${e.$Yi}`,e.$1i=[{name:(0,I.localize)(10864,null),extensions:[e.$Yi]}],e.$2i="workspace.json";function m(t,n){return L.$7g.isEqualOrParent(t,n.untitledWorkspacesHome)}function o(t){let n;return N.URI.isUri(t)?n=t:n=t.configuration,n?.scheme===k.Schemas.tmp}e.$5i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function h(t){return t.id===e.$5i}function i(t,n){return!m(t,n)&&!o(t)}function s(t){return(typeof t=="string"?(0,c.$nc)(t):(0,L.$bh)(t))===e.$Zi}}),define(he[19],ue([0,1,55,3,2,20,9,11,15,7,4,10,115,36,28,6,31,26,12]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$,l,p,S,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=e.$Il=e.ProfileResourceType=void 0,e.$Hl=m,e.$Jl=o,e.$Kl=h;var P;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(P||(e.ProfileResourceType=P={}));function m(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&N.URI.isUri(n.location)&&N.URI.isUri(n.globalStorageHome)&&N.URI.isUri(n.settingsResource)&&N.URI.isUri(n.keybindingsResource)&&N.URI.isUri(n.tasksResource)&&N.URI.isUri(n.snippetsHome)&&N.URI.isUri(n.extensionsResource))}e.$Il=(0,R.$Ci)("IUserDataProfilesService");function o(t,n){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:N.URI.revive(t.location).with({scheme:n}),globalStorageHome:N.URI.revive(t.globalStorageHome).with({scheme:n}),settingsResource:N.URI.revive(t.settingsResource).with({scheme:n}),keybindingsResource:N.URI.revive(t.keybindingsResource).with({scheme:n}),tasksResource:N.URI.revive(t.tasksResource).with({scheme:n}),snippetsHome:N.URI.revive(t.snippetsHome).with({scheme:n}),extensionsResource:N.URI.revive(t.extensionsResource).with({scheme:n}),cacheHome:N.URI.revive(t.cacheHome).with({scheme:n}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}function h(t,n,r,a,f,v){return{id:t,name:n,location:r,isDefault:!1,shortName:f?.shortName,icon:f?.icon,globalStorageHome:v&&f?.useDefaultFlags?.globalState?v.globalStorageHome:(0,L.$dh)(r,"globalStorage"),settingsResource:v&&f?.useDefaultFlags?.settings?v.settingsResource:(0,L.$dh)(r,"settings.json"),keybindingsResource:v&&f?.useDefaultFlags?.keybindings?v.keybindingsResource:(0,L.$dh)(r,"keybindings.json"),tasksResource:v&&f?.useDefaultFlags?.tasks?v.tasksResource:(0,L.$dh)(r,"tasks.json"),snippetsHome:v&&f?.useDefaultFlags?.snippets?v.snippetsHome:(0,L.$dh)(r,"snippets"),extensionsResource:v&&f?.useDefaultFlags?.extensions?v.extensionsResource:(0,L.$dh)(r,"extensions.json"),cacheHome:(0,L.$dh)(a,t),useDefaultFlags:f?.useDefaultFlags,isTransient:f?.transient}}let i=class extends A.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,r,a,f){super(),this.t=n,this.u=r,this.w=a,this.y=f,this.f=!0,this.h=this.B(new c.$je),this.onDidChangeProfiles=this.h.event,this.j=this.B(new c.$je),this.onWillCreateProfile=this.j.event,this.m=this.B(new c.$je),this.onWillRemoveProfile=this.m.event,this.n=this.B(new c.$je),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new $.$zc,workspaces:new $.$zc,emptyWindows:new Map},this.profilesHome=(0,L.$dh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$dh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),r=[n];if(this.f)try{for(const v of this.O()){if(!v.name||!(0,w.$cg)(v.name)||!v.location){this.y.warn("Skipping the invalid stored profile",v.location||v.name);continue}r.push(h((0,L.$ah)(v.location),v.name,v.location,this.g,{shortName:v.shortName,icon:v.icon,useDefaultFlags:v.useDefaultFlags},n))}}catch(v){this.y.error(v)}const a=new $.$zc,f=new Map;if(r.length)try{const v=this.Q();if(v.workspaces)for(const[C,b]of Object.entries(v.workspaces)){const E=N.URI.parse(C),T=r.find(j=>j.id===b);T&&a.set(E,T)}if(v.emptyWindows)for(const[C,b]of Object.entries(v.emptyWindows)){const E=r.find(T=>T.id===b);E&&f.set(C,E)}}catch(v){this.y.error(v)}this.z={profiles:r,workspaces:a,emptyWindows:f}}return this.z}D(){const n=h("__default__profile__",(0,O.localize)(10911,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const r="Temp",a=new RegExp(`${(0,g.$ff)(r)}\\s(\\d+)`);let f=0;for(const C of this.profiles){const b=a.exec(C.name),E=b?parseInt(b[1]):0;f=E>f?E:f}const v=`${r} ${f+1}`;return this.createProfile((0,I.$qj)((0,S.$Yg)()).toString(16),v,{transient:!0},n)}async createNamedProfile(n,r,a){return this.createProfile((0,I.$qj)((0,S.$Yg)()).toString(16),n,r,a)}async createProfile(n,r,a,f){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const v=await this.F(n,r,a);return f&&await this.setProfileForWorkspace(f,v),v}async F(n,r,a){if(!(0,w.$cg)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let f=this.r.get(r);return f||(f=(async()=>{try{if(this.profiles.find(E=>E.name===r||E.id===n))throw new Error(`Profile with ${r} name already exists`);const C=h(n,r,(0,L.$dh)(this.profilesHome,n),this.g,a,this.defaultProfile);await this.u.createFolder(C.location);const b=[];return this.j.fire({profile:C,join(E){b.push(E)}}),await p.Promises.settled(b),this.I([C],[],[]),C}finally{this.r.delete(r)}})(),this.r.set(r,f)),f}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(f=>f.id===n.id);if(!a)throw new Error(`Profile '${n.name}' does not exist`);return a=h(a.id,r.name??a.name,a.location,this.g,{shortName:r.shortName??a.shortName,icon:r.icon===null?void 0:r.icon??a.icon,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.I([],[],[a]),a}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(f=>f.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const a=[];this.m.fire({profile:r,join(f){a.push(f)}});try{await Promise.allSettled(a)}catch(f){this.y.error(f)}for(const f of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(f)?.id&&this.C.emptyWindows.delete(f);for(const f of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(f)?.id&&this.C.workspaces.delete(f);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(f){(0,y.$nl)(f)!==y.FileOperationResult.FILE_NOT_FOUND&&this.y.error(f)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(f=>f.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.L(n,a)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,r)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.w.extUri.isEqual(a.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.G(n),a=N.URI.isUri(r)?this.C.workspaces.get(r):this.C.emptyWindows.get(r);return a||((0,u.$Mi)(n)?this.s.folders.get(n.uri):(0,u.$Ri)(n)?this.s.workspaces.get(n.configPath):this.s.emptyWindows.get(n.id))}G(n){return(0,u.$Mi)(n)?n.uri:(0,u.$Ri)(n)?n.configPath:n.id}H(n){return!!([...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.s.folders.values()].some(r=>this.w.extUri.isEqual(r.location,n.location)))}I(n,r,a){const f=[...this.profiles,...n],v=[],C=this.s.profiles;this.s.profiles=[];for(let b of f){if(b.isDefault||r.some(T=>b.id===T.id))continue;b=a.find(T=>b.id===T.id)??b;const E=C.find(T=>b.id===T.id);if(b.isTransient)this.s.profiles.push(b);else{if(E){for(const[T,j]of this.s.emptyWindows.entries())if(b.id===j.id){this.L({id:T},b);break}for(const[T,j]of this.s.workspaces.entries())if(b.id===j.id){this.L({id:"",configPath:T},b);break}for(const[T,j]of this.s.folders.entries())if(b.id===j.id){this.L({id:"",uri:T},b);break}}v.push({location:b.location,name:b.name,shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags})}}this.P(v),this.z=void 0,this.J(n,r,a)}J(n,r,a){this.h.fire({added:n,removed:r,updated:a,all:this.profiles})}L(n,r,a){if(a=r?.isTransient?!0:a,a)(0,u.$Mi)(n)?(this.s.folders.delete(n.uri),r&&this.s.folders.set(n.uri,r)):(0,u.$Ri)(n)?(this.s.workspaces.delete(n.configPath),r&&this.s.workspaces.set(n.configPath,r)):(this.s.emptyWindows.delete(n.id),r&&this.s.emptyWindows.set(n.id,r));else{this.L(n,void 0,!0);const f=this.G(n);N.URI.isUri(f)?(this.C.workspaces.delete(f),r&&this.C.workspaces.set(f,r)):(this.C.emptyWindows.delete(f),r&&this.C.emptyWindows.set(f,r)),this.M()}}M(){const n={};for(const[a,f]of this.C.workspaces.entries())n[a.toString()]=f.id;const r={};for(const[a,f]of this.C.emptyWindows.entries())r[a.toString()]=f.id;this.R({workspaces:n,emptyWindows:r}),this.z=void 0}N(n){const r={},a=this.D();if(n.workspaces)for(const[v,C]of Object.entries(n.workspaces)){const b=N.URI.parse(C);r[v]=this.w.extUri.isEqual(b,a.location)?a.id:this.w.extUri.basename(b)}const f={};if(n.emptyWindows)for(const[v,C]of Object.entries(n.emptyWindows)){const b=N.URI.parse(C);f[v]=this.w.extUri.isEqual(b,a.location)?a.id:this.w.extUri.basename(b)}return{workspaces:r,emptyWindows:f}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Ll=i,e.$Ll=i=ve([Q(0,k.$Ji),Q(1,y.$9k),Q(2,l.$Gl),Q(3,d.$9j)],i);class s extends i{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Ml=s}),define(he[213],ue([0,1,6,2,19]),function(oe,e,I,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$whc=void 0;let L=class extends c.$Tc{constructor(O){super(),this.B(new I.$Oh(()=>{O.cleanUp()},10*1e3)).schedule()}};e.$whc=L,e.$whc=L=ve([Q(0,A.$Il)],L)}),define(he[83],ue([0,1,17,6,25,8,3,2,5,12,9,11,27,34,33,59,10,23,18,28,19]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$,l,p,S,g,w,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Bq=void 0,e.$Cq=h,d=ke(d);let o=class extends O.$Tc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(n,r,a,f,v,C){super(),this.z=n,this.C=r,this.D=a,this.F=f,this.G=v,this.H=C,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new N.$je),this.s=this.B(new N.$je),this.t=this.B(new N.$je),this.u=this.B(new N.$je),this.w=this.B(new N.$je),this.y=[],this.B((0,O.$Rc)(()=>{this.j.forEach(({task:b})=>b.cancel()),this.m.forEach(b=>b.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(a=>(0,u.$fp)(a,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{const f=(await this.installGalleryExtensions([{extension:n,options:r}])).find(({identifier:v})=>(0,$.$Ip)(v,n.identifier));if(f?.local)return f?.local;throw f?.error?f.error:new u.$jp(`Unknown error while installing extension ${n.identifier.id}`,u.ExtensionManagementErrorCode.Unknown)}catch(a){throw h(a)}}async installGalleryExtensions(n){if(!this.z.isEnabled())throw new u.$jp(d.localize(11336,null),u.ExtensionManagementErrorCode.NotAllowed);const r=[],a=[];return await Promise.allSettled(n.map(async({extension:f,options:v})=>{try{const C=await this.N(f,!!v?.installGivenVersion,!!v?.installPreReleaseVersion,v.productVersion??{version:this.G.version,date:this.G.date});a.push({...C,options:v})}catch(C){r.push({identifier:f.identifier,operation:u.InstallOperation.Install,source:f,error:C,profileLocation:v.profileLocation??this.X()})}})),a.length&&r.push(...await this.I(a)),r}async uninstall(n,r={}){return this.F.trace("ExtensionManagementService#uninstall",n.identifier.id),this.P(n,r)}async toggleAppliationScope(n,r){if((0,l.$qn)(n.manifest)||n.isBuiltin)return n;if(n.isApplicationScoped){let a=await this.updateMetadata(n,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(a=await this.$(n,this.H.defaultProfile.extensionsResource,r));for(const f of this.H.profiles){const v=(await this.getInstalled(l.ExtensionType.User,f.extensionsResource)).find(C=>(0,$.$Ip)(C.identifier,n.identifier));v?this.w.fire({local:v,profileLocation:f.extensionsResource}):this.u.fire({identifier:n.identifier,profileLocation:f.extensionsResource})}return a}else{const a=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(n,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:a.identifier,operation:u.InstallOperation.Install,local:a,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.W(),this.h=n),this.g}registerParticipant(n){this.y.push(n)}async resetPinnedStateForAllUserExtensions(n){try{await this.L(this.H.profiles.map(async r=>{const a=await this.getInstalled(l.ExtensionType.User,r.extensionsResource);await this.L(a.map(async f=>{f.pinned!==n&&await this.updateMetadata(f,{pinned:n},r.extensionsResource)}))}))}catch(r){throw this.F.error("Error while resetting pinned state for all user extensions",(0,L.$9)(r)),r}}async I(n){const r=new Map,a=new Map,f=[],v=(b,E)=>`${$.$Jp.create(b).toString()}-${E.toString()}`,C=(b,E,T,j)=>{const U=this.Y(b,E,T),F=`${(0,$.$Np)(b.publisher,b.name)}-${T.profileLocation.toString()}`;a.set(F,{task:U,root:j}),this.n.fire({identifier:U.identifier,source:E,profileLocation:T.profileLocation}),this.F.info("Installing extension:",U.identifier.id,T),R.URI.isUri(E)||this.j.set(v(E,T.profileLocation),{task:U,waitingTasks:[]})};try{for(const{manifest:b,extension:E,options:T}of n){const j=T.isApplicationScoped||T.isBuiltin||(0,l.$qn)(b),U={...T,installOnlyNewlyAddedFromExtensionPack:T.installOnlyNewlyAddedFromExtensionPack??!R.URI.isUri(E),isApplicationScoped:j,profileLocation:j?this.H.defaultProfile.extensionsResource:T.profileLocation??this.X(),productVersion:T.productVersion??{version:this.G.version,date:this.G.date}},F=R.URI.isUri(E)?void 0:this.j.get(v(E,U.profileLocation));F?(this.F.info("Extension is already requested to install",F.task.identifier.id,U.profileLocation.toString()),f.push(F.task.waitUntilTaskIsFinished())):C(b,E,U,void 0)}return await Promise.all([...a.values()].map(async({task:b})=>{if(b.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",b.identifier.id);else try{const E=await this.M(b.identifier,b.manifest,!!b.options.installOnlyNewlyAddedFromExtensionPack,!!b.options.installPreReleaseVersion,b.options.profileLocation,b.options.productVersion),T=await this.getInstalled(void 0,b.options.profileLocation,b.options.productVersion),j={...b.options,context:{...b.options.context,[u.$_o]:!0}};for(const{gallery:U,manifest:F}of(0,I.$Lb)(E,({gallery:K})=>K.identifier.id)){if(a.has(`${U.identifier.id.toLowerCase()}-${j.profileLocation.toString()}`))continue;const K=this.j.get(v(U,j.profileLocation));if(K){if(this.J(b,K.task)){const W=K.task.identifier;this.F.info("Waiting for already requested installing extension",W.id,b.identifier.id,j.profileLocation.toString()),K.waitingTasks.push(b),f.push(N.Event.toPromise(N.Event.filter(this.onDidInstallExtensions,x=>x.some(G=>(0,$.$Ip)(G.identifier,W)))).then(x=>{if(this.F.info("Finished waiting for already requested installing extension",W.id,b.identifier.id,j.profileLocation.toString()),!x.find(ie=>(0,$.$Ip)(ie.identifier,W))?.local)throw new Error(`Extension ${W.id} is not installed`)}))}}else T.some(({identifier:W})=>(0,$.$Ip)(W,U.identifier))||C(F,U,j,b)}}catch(E){if(R.URI.isUri(b.source))(0,I.$Kb)(b.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",b.identifier.id,E.message),(0,I.$Kb)(b.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",b.identifier.id,E.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",b.identifier.id),E}})),await this.L([...a.entries()].map(async([b,{task:E}])=>{const T=new Date().getTime();let j;try{j=await E.run(),await this.L(this.y.map(U=>U.postInstall(j,E.source,E.options,A.CancellationToken.None)),u.ExtensionManagementErrorCode.PostInstall)}catch(U){const F=h(U);throw R.URI.isUri(E.source)||i(this.C,E.operation===u.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,$.$Qp)(E.source),error:F,source:E.options.context?.[u.$$o]}),r.set(b,{error:F,identifier:E.identifier,operation:E.operation,source:E.source,context:E.options.context,profileLocation:E.options.profileLocation,applicationScoped:E.options.isApplicationScoped}),this.F.error("Error while installing the extension",E.identifier.id,(0,L.$9)(F),E.options.profileLocation.toString()),F}if(!R.URI.isUri(E.source)){const U=E.operation===u.InstallOperation.Update,F=U?void 0:(new Date().getTime()-E.source.lastUpdated)/1e3;if(i(this.C,U?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,$.$Qp)(E.source),verificationStatus:E.verificationStatus,duration:new Date().getTime()-T,durationSinceUpdate:F,source:E.options.context?.[u.$$o]}),k.$p&&E.operation!==u.InstallOperation.Update)try{await this.z.reportStatistic(j.manifest.publisher,j.manifest.name,j.manifest.version,u.StatisticType.Install)}catch{}}r.set(b,{local:j,identifier:E.identifier,operation:E.operation,source:E.source,context:E.options.context,profileLocation:E.options.profileLocation,applicationScoped:j.isApplicationScoped})})),f.length&&await this.L(f),[...r.values()]}catch(b){const E=(U,F,K)=>{const W=[];U.manifest.extensionDependencies?.length&&W.push(...U.manifest.extensionDependencies),U.manifest.extensionPack?.length&&W.push(...U.manifest.extensionPack);for(const x of W){if(K.includes(x.toLowerCase()))continue;K.push(x.toLowerCase());const G=r.get(`${x.toLowerCase()}-${F.toString()}`);G?.local&&(K=E(G.local,F,K))}return K},T=U=>({identifier:U.identifier,operation:u.InstallOperation.Install,source:U.source,context:U.options.context,profileLocation:U.options.profileLocation,error:b}),j=[];for(const[U,{task:F,root:K}]of a){const W=r.get(U);W?W.local&&K&&!r.get(`${K.identifier.id.toLowerCase()}-${F.options.profileLocation.toString()}`)?.local&&(j.push(this.Z(W.local,{versionOnly:!0,profileLocation:F.options.profileLocation})),r.set(U,T(F))):(F.cancel(),r.set(U,T(F)))}for(const[U,{task:F}]of a){const K=r.get(U);if(!K?.local||F.options.donotIncludePackAndDependencies)continue;E(K.local,F.options.profileLocation,[K.local.identifier.id.toLowerCase()]).slice(1).some(x=>a.has(`${x.toLowerCase()}-${F.options.profileLocation.toString()}`)&&!r.get(`${x.toLowerCase()}-${F.options.profileLocation.toString()}`)?.local)&&(j.push(this.Z(K.local,{versionOnly:!0,profileLocation:F.options.profileLocation})),r.set(U,T(F)))}throw j.length&&await Promise.allSettled(j.map(async U=>{try{await U.run(),this.F.info("Rollback: Uninstalled extension",U.extension.identifier.id)}catch(F){this.F.warn("Rollback: Error while uninstalling extension",U.extension.identifier.id,(0,L.$9)(F))}})),b}finally{for(const{task:b}of a.values())b.source&&!R.URI.isUri(b.source)&&this.j.delete(v(b.source,b.options.profileLocation));if(r.size){const b=[...r.values()];for(const E of b)E.local&&this.F.info("Extension installed successfully:",E.identifier.id,E.profileLocation.toString());this.s.fire(b)}}}J(n,r){for(const[,{task:a,waitingTasks:f}]of this.j.entries())if(a===n&&(f.includes(r)||f.some(v=>this.J(v,r)))||a===r&&f[0]&&!this.J(n,f[0]))return!1;return!0}async L(n,r){const a=[],f=[],v=await Promise.allSettled(n);for(const b of v)b.status==="fulfilled"?a.push(b.value):f.push(h(b.reason,r));if(!f.length)return a;if(f.length===1)throw f[0];let C=new u.$jp("",u.ExtensionManagementErrorCode.Unknown);for(const b of f)C=new u.$jp(C.message?`${C.message}, ${b.message}`:b.message,b.code!==u.ExtensionManagementErrorCode.Unknown&&b.code!==u.ExtensionManagementErrorCode.Internal?b.code:C.code);throw C}async M(n,r,a,f,v,C){if(!this.z.isEnabled())return[];const b=await this.getInstalled(void 0,v,C),E=[],T=[],j=async(U,F)=>{E.push(U);const K=F.extensionDependencies||[],W=[...K];if(F.extensionPack){const x=a?b.find(G=>(0,$.$Ip)(G.identifier,U)):void 0;for(const G of F.extensionPack)x&&x.manifest.extensionPack&&x.manifest.extensionPack.some(ie=>(0,$.$Ip)({id:ie},{id:G}))||W.every(ie=>!(0,$.$Ip)({id:ie},{id:G}))&&W.push(G)}if(W.length){const x=W.filter(G=>E.every(ie=>!(0,$.$Ip)(ie,{id:G})));if(x.length){const G=await this.z.getExtensions(x.map(ie=>({id:ie,preRelease:f})),A.CancellationToken.None);for(const ie of G){if(E.find(_=>(0,$.$Ip)(_,ie.identifier)))continue;const V=K.some(_=>(0,$.$Ip)({id:_},ie.identifier));let z;try{z=await this.N(ie,!1,f,C)}catch(_){if(V)throw _;this.F.info("Skipping the packed extension as it cannot be installed",ie.identifier.id,(0,L.$9)(_));continue}T.push({gallery:z.extension,manifest:z.manifest}),await j(z.extension.identifier,z.manifest)}}}};return await j(n,r),T}async N(n,r,a,f){let v;const C=await this.getExtensionsControlManifest();if(C.malicious.some(T=>(0,$.$Ip)(n.identifier,T)))throw new u.$jp(d.localize(11337,null,n.identifier.id),u.ExtensionManagementErrorCode.Malicious);const b=C.deprecated[n.identifier.id.toLowerCase()];if(b?.extension?.autoMigrate){if(this.F.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${b.extension.id}' extension instead.`),v=(await this.z.getExtensions([{id:b.extension.id,preRelease:b.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:f},A.CancellationToken.None))[0],!v)throw new u.$jp(d.localize(11338,null,n.identifier.id,b.extension.id),u.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(n)){const T=await this.getTargetPlatform();throw new u.$jp(d.localize(11339,null,n.identifier.id,this.G.nameLong,(0,u.$bp)(T)),u.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(v=await this.O(n,r,a,f),!v){const T=[];throw(0,p.$3p)(n.properties.enabledApiProposals??[],T)?!a&&n.properties.isPreReleaseVersion&&(await this.z.getExtensions([n.identifier],A.CancellationToken.None))[0]?new u.$jp(d.localize(11341,null,n.displayName??n.identifier.id),u.ExtensionManagementErrorCode.ReleaseVersionNotFound):new u.$jp(d.localize(11342,null,n.identifier.id,this.G.nameLong,this.G.version),u.ExtensionManagementErrorCode.Incompatible):new u.$jp(d.localize(11340,null,n.displayName??n.identifier.id,T[0]),u.ExtensionManagementErrorCode.IncompatibleApi)}}this.F.info("Getting Manifest...",v.identifier.id);const E=await this.z.getManifest(v,A.CancellationToken.None);if(E===null)throw new u.$jp(`Missing manifest for extension ${v.identifier.id}`,u.ExtensionManagementErrorCode.Invalid);if(E.version!==v.version)throw new u.$jp(`Cannot install '${v.identifier.id}' extension because of version mismatch in Marketplace`,u.ExtensionManagementErrorCode.Invalid);return{extension:v,manifest:E}}async O(n,r,a,f){const v=await this.getTargetPlatform();let C=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==a&&(C=(await this.z.getExtensions([{...n.identifier,preRelease:a}],{targetPlatform:v,compatible:!0,productVersion:f},A.CancellationToken.None))[0]||null),!C&&await this.z.isExtensionCompatible(n,a,v,f)&&(C=n),C||(r?C=(await this.z.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:v,compatible:!0,productVersion:f},A.CancellationToken.None))[0]||null:C=await this.z.getCompatibleExtension(n,a,v,f)),C}async P(n,r){const a={...r,profileLocation:n.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.X()},f=j=>`${j.id.toLowerCase()}${a.versionOnly?`-${n.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,v=this.m.get(f(n.identifier));if(v)return this.F.info("Extensions is already requested to uninstall",n.identifier.id),v.waitUntilTaskIsFinished();const C=j=>{const U=this.Z(j,a);return this.m.set(f(U.extension.identifier),U),a.profileLocation?this.F.info("Uninstalling extension from the profile:",`${j.identifier.id}@${j.manifest.version}`,a.profileLocation.toString()):this.F.info("Uninstalling extension:",`${j.identifier.id}@${j.manifest.version}`),this.t.fire({identifier:j.identifier,profileLocation:a.profileLocation,applicationScoped:j.isApplicationScoped}),U},b=(j,U)=>{U?a.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${j.identifier.id}@${j.manifest.version}`,a.profileLocation.toString(),U.message):this.F.error("Failed to uninstall extension:",`${j.identifier.id}@${j.manifest.version}`,U.message):a.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${j.identifier.id}@${j.manifest.version}`,a.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${j.identifier.id}@${j.manifest.version}`),i(this.C,"extensionGallery:uninstall",{extensionData:(0,$.$Pp)(j),error:U}),this.u.fire({identifier:j.identifier,error:U?.code,profileLocation:a.profileLocation,applicationScoped:j.isApplicationScoped})},E=[],T=[];try{E.push(C(n));const j=await this.getInstalled(l.ExtensionType.User,a.profileLocation);if(a.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const U=this.S(n,j);for(const F of U)this.m.has(f(F.identifier))?this.F.info("Extensions is already requested to uninstall",F.identifier.id):E.push(C(F))}a.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.Q(E.map(U=>U.extension),j,n),await this.L(E.map(async U=>{try{if(await U.run(),await this.L(this.y.map(F=>F.postUninstall(U.extension,a,A.CancellationToken.None))),U.extension.identifier.uuid)try{await this.z.reportStatistic(U.extension.manifest.publisher,U.extension.manifest.name,U.extension.manifest.version,u.StatisticType.Uninstall)}catch{}b(U.extension)}catch(F){const K=h(F);throw b(U.extension,K),K}finally{T.push(U)}}))}catch(j){const U=h(j);for(const F of E){try{F.cancel()}catch{}T.includes(F)||b(F.extension,U)}throw U}finally{for(const j of E)this.m.delete(f(j.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",j.extension.identifier.id)}}Q(n,r,a){for(const f of n){const v=this.U(f,r);if(v.length){const C=v.filter(b=>!n.some(E=>(0,$.$Ip)(E.identifier,b.identifier)));if(C.length)throw new Error(this.R(f,C,a))}}}R(n,r,a){return a===n?r.length===1?d.localize(11343,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?d.localize(11344,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):d.localize(11345,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?d.localize(11346,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?d.localize(11347,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):d.localize(11348,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}S(n,r,a=[]){if(a.indexOf(n)!==-1)return[];a.push(n);const f=n.manifest.extensionPack?n.manifest.extensionPack:[];if(f.length){const v=r.filter(b=>!b.isBuiltin&&f.some(E=>(0,$.$Ip)({id:E},b.identifier))),C=[];for(const b of v)C.push(...this.S(b,r,a));return[...v,...C]}return[]}U(n,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(f=>(0,$.$Ip)({id:f},n.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(n){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,L.$9)(n)),{malicious:[],deprecated:{},search:[]}}}};e.$Bq=o,e.$Bq=o=ve([Q(0,u.$hp),Q(1,w.$8l),Q(2,P.$Gl),Q(3,S.$9j),Q(4,g.$pk),Q(5,m.$Il)],o);function h(t,n){if(t instanceof u.$jp)return t;let r;return t instanceof u.$ip?r=new u.$jp(t.message,t.code===u.ExtensionGalleryErrorCode.DownloadFailedWriting?u.ExtensionManagementErrorCode.DownloadFailedWriting:u.ExtensionManagementErrorCode.Gallery):r=new u.$jp(t.message,(0,L.$3)(t)?u.ExtensionManagementErrorCode.Cancelled:n??u.ExtensionManagementErrorCode.Internal),r.stack=t.stack,r}function i(t,n,{extensionData:r,verificationStatus:a,duration:f,error:v,source:C,durationSinceUpdate:b}){let E,T;(0,y.$kg)(a)&&(a===!0?a="Verified":(a===!1||(E=u.ExtensionManagementErrorCode.Signature,T=a),a="Unverified")),v&&(E=v.code,v.code===u.ExtensionManagementErrorCode.Signature&&(T=v.message)),t.publicLog(n,{...r,verificationStatus:a,success:!v,duration:f,errorcode:E,errorcodeDetail:T,durationSinceUpdate:b,source:C})}class s{constructor(){this.d=new c.$Bh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,c.$ph)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,c.$ph)(n=>new Promise((r,a)=>{const f=n.onCancellationRequested(()=>{f.dispose(),a(new L.$4)})})),this.d.open()),this.g.cancel()}}e.$Dq=s}),define(he[52],ue([0,1,6,14,2,3,36,9,27,34,7,4,10,19,28,12,8,18]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$,l,p,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=e.$Fq=e.$Eq=e.ExtensionsProfileScanningErrorCode=void 0;var w;(function(i){i.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",i.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(w||(e.ExtensionsProfileScanningErrorCode=w={}));class P extends Error{constructor(s,t){super(s),this.code=t}}e.$Eq=P,e.$Fq=(0,d.$Ci)("IExtensionsProfileScannerService");let m=class extends A.$Tc{constructor(s,t,n,r,a,f){super(),this.j=s,this.m=t,this.n=n,this.r=r,this.s=a,this.t=f,this.b=this.B(new L.$je),this.onAddExtensions=this.b.event,this.c=this.B(new L.$je),this.onDidAddExtensions=this.c.event,this.f=this.B(new L.$je),this.onRemoveExtensions=this.f.event,this.g=this.B(new L.$je),this.onDidRemoveExtensions=this.g.event,this.h=new N.$zc}scanProfileExtensions(s,t){return this.u(s,void 0,t)}async addExtensionsToProfile(s,t,n){const r=[],a=[];try{return await this.u(t,f=>{const v=[];if(n)v.push(...f);else for(const C of f)s.some(([b])=>(0,y.$Ip)(b.identifier,C.identifier)&&b.manifest.version!==C.version)?r.push(C):v.push(C);for(const[C,b]of s){const E=v.findIndex(j=>(0,y.$Ip)(j.identifier,C.identifier)&&j.version===C.manifest.version),T={identifier:C.identifier,version:C.manifest.version,location:C.location,metadata:b};E===-1?(a.push(T),v.push(T)):v.splice(E,1,T)}return a.length&&this.b.fire({extensions:a,profileLocation:t}),r.length&&this.f.fire({extensions:r,profileLocation:t}),v}),a.length&&this.c.fire({extensions:a,profileLocation:t}),r.length&&this.g.fire({extensions:r,profileLocation:t}),a}catch(f){throw a.length&&this.c.fire({extensions:a,error:f,profileLocation:t}),r.length&&this.g.fire({extensions:r,error:f,profileLocation:t}),f}}async updateMetadata(s,t){const n=[];return await this.u(t,r=>{const a=[];for(const f of r){const v=s.find(([C])=>(0,y.$Ip)(C.identifier,f.identifier)&&C.manifest.version===f.version);v&&(f.metadata={...f.metadata,...v[1]},n.push(f)),a.push(f)}return a}),n}async removeExtensionFromProfile(s,t){const n=[];try{await this.u(t,r=>{const a=[];for(const f of r)(0,y.$Ip)(f.identifier,s.identifier)?n.push(f):a.push(f);return n.length&&this.f.fire({extensions:n,profileLocation:t}),a}),n.length&&this.g.fire({extensions:n,profileLocation:t})}catch(r){throw n.length&&this.g.fire({extensions:n,error:r,profileLocation:t}),r}}async u(s,t,n){return this.F(s).queue(async()=>{let r=[],a;try{const f=await this.m.readFile(s);a=JSON.parse(f.value.toString().trim()||"[]")}catch(f){if((0,R.$nl)(f)!==R.FileOperationResult.FILE_NOT_FOUND)throw f;if(this.r.extUri.isEqual(s,this.n.defaultProfile.extensionsResource)&&(a=await this.D()),!a&&n?.bailOutWhenFileNotFound)throw new P((0,S.$9)(f),w.ERROR_PROFILE_NOT_FOUND)}if(a){Array.isArray(a)||this.w(s);let f=!1;for(const v of a){o(v)||this.w(s);let C;if((0,p.$cg)(v.relativeLocation)&&v.relativeLocation)C=this.z(v.relativeLocation);else if((0,p.$cg)(v.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${v.location}`);continue}else{C=O.URI.revive(v.location);const b=this.y(C);b&&(f=!0,v.relativeLocation=b)}(0,p.$jg)(v.metadata?.hasPreReleaseVersion)&&v.metadata?.preRelease&&(f=!0,v.metadata.hasPreReleaseVersion=!0),r.push({identifier:v.identifier,location:C,version:v.version,metadata:v.metadata})}f&&await this.m.writeFile(s,c.$Le.fromString(JSON.stringify(a)))}if(t){r=t(r);const f=r.map(v=>({identifier:v.identifier,version:v.version,location:v.location.toJSON(),relativeLocation:this.y(v.location),metadata:v.metadata}));await this.m.writeFile(s,c.$Le.fromString(JSON.stringify(f)))}return r})}w(s){const t=new P(`Invalid extensions content in ${s.toString()}`,w.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}y(s){return this.r.extUri.isEqual(this.r.extUri.dirname(s),this.j)?this.r.extUri.basename(s):void 0}z(s){return this.r.extUri.joinPath(this.j,s)}async D(){return this.C||(this.C=(async()=>{const s=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),t=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(s)).value.toString()}catch(a){if((0,R.$nl)(a)===R.FileOperationResult.FILE_NOT_FOUND)return;throw a}this.t.info("Migrating extensions from old default profile location",s.toString());let r;try{const a=JSON.parse(n);Array.isArray(a)&&a.every(f=>o(f))?r=a:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.t.error(a)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,c.$Le.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",s.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(a){if((0,R.$nl)(a)===R.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",s.toString(),this.n.defaultProfile.extensionsResource.toString());else throw a}try{await this.m.del(s)}catch(a){(0,R.$nl)(a)!==R.FileOperationResult.FILE_NOT_FOUND&&this.t.error(a)}try{await this.m.del(t)}catch(a){(0,R.$nl)(a)!==R.FileOperationResult.FILE_NOT_FOUND&&this.t.error(a)}return r})()),this.C}F(s){let t=this.h.get(s);return t||(t=new I.$Jh,this.h.set(s,t)),t}};e.$Gq=m,e.$Gq=m=ve([Q(1,R.$9k),Q(2,$.$Il),Q(3,l.$Gl),Q(4,g.$8l),Q(5,u.$9j)],m);function o(i){return(0,p.$eg)(i)&&(0,k.$gp)(i.identifier)&&(h(i.location)||(0,p.$cg)(i.location)&&i.location)&&((0,p.$jg)(i.relativeLocation)||(0,p.$cg)(i.relativeLocation))&&i.version&&(0,p.$cg)(i.version)}function h(i){return i?(0,p.$cg)(i.path)&&(0,p.$cg)(i.scheme):!1}});var it=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(he[84],ue([0,1,17,6,29,14,8,35,151,2,22,13,5,20,60,92,12,9,11,15,34,33,59,7,4,10,23,3,66,52,19,28,156]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$,l,p,S,g,w,P,m,o,h,i,s,t,n,r,a,f,v,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=e.$Lq=e.$Kq=e.$Jq=e.Translations=void 0,e.$Mq=K,A=ke(A),d=ke(d),u=ke(u),l=ke(l),p=it(p);var E;(function(x){function G(ie,V){if(ie===V)return!0;const z=Object.keys(ie),_=new Set;for(const ne of Object.keys(V))_.add(ne);if(z.length!==_.size)return!1;for(const ne of z){if(ie[ne]!==V[ne])return!1;_.delete(ne)}return _.size===0}x.equals=G})(E||(e.Translations=E={})),e.$Jq=(0,s.$Ci)("IExtensionsScannerService");let T=class extends y.$Tc{constructor(G,ie,V,z,_,ne,ce,te,Y,H,B,D){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=ie,this.r=V,this.s=z,this.t=_,this.u=ne,this.w=ce,this.y=te,this.z=Y,this.C=H,this.D=B,this.F=D,this.g=this.B(new r.$je),this.onDidChangeCache=this.g.event,this.h=(0,$.$dh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(F,this.s,this.h)),this.m=this.B(this.F.createInstance(F,this.s,this.h)),this.n=this.B(this.F.createInstance(U,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(o.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(o.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,m.$Tp)(this.w,this.y)),this.G}async scanAllExtensions(G,ie,V){const[z,_]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(ie)]),ne=V?await this.scanExtensionsUnderDevelopment(G,[...z,..._]):[];return this.L(z,_,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const ie=[];ie.push(this.M(!!G.useCache,G.language)),ie.push(this.N(G.language,!!G.checkControlFile));const[V,z]=await Promise.all(ie);return this.J([...V,...z],o.ExtensionType.System,G,!1)}async scanUserExtensions(G){const ie=G.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",ie);const V=this.D.extUri.isEqual(G.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.P(ie,!!G.profileLocation,o.ExtensionType.User,!G.includeUninstalled,G.language,!0,V,G.productVersion??this.R()),_=G.useCache&&!z.devMode&&z.excludeObsolete?this.m:this.n;let ne;try{ne=await _.scanExtensions(z)}catch(ce){if(ce instanceof f.$Eq&&ce.code===f.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),ne=await _.scanExtensions(z);else throw ce}return ne=await this.J(ne,o.ExtensionType.User,G,!0),this.y.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(G,ie){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const V=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(z=>z.scheme===R.Schemas.file).map(async z=>{const _=await this.P(z,!1,o.ExtensionType.User,!0,G.language,!1,void 0,G.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(_)).map(ce=>(ce.type=ie.find(te=>(0,m.$Ip)(te.identifier,ce.identifier))?.type??ce.type,this.n.validate(ce,_)))}))).flat();return this.J(V,"development",G,!0)}return[]}async scanExistingExtension(G,ie,V){const z=await this.P(G,!1,ie,!0,V.language,!0,void 0,V.productVersion??this.R()),_=await this.n.scanExtension(z);return!_||!V.includeInvalid&&!_.isValid?null:_}async scanOneOrMultipleExtensions(G,ie,V){const z=await this.P(G,!1,ie,!0,V.language,!0,void 0,V.productVersion??this.R()),_=await this.n.scanOneOrMultipleExtensions(z);return this.J(_,ie,V,!0)}async scanMultipleExtensions(G,ie,V){const z=[];return await Promise.all(G.map(async _=>{const ne=await this.scanOneOrMultipleExtensions(_,ie,V);z.push(...ne)})),this.J(z,ie,V,!0)}async scanMetadata(G){const ie=(0,$.$dh)(G,"package.json"),V=(await this.w.readFile(ie)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(G,ie){const V=(0,$.$dh)(G,"package.json"),z=(await this.w.readFile(V)).value.toString(),_=JSON.parse(z);ie.isMachineScoped===!1&&delete ie.isMachineScoped,ie.isBuiltin===!1&&delete ie.isBuiltin,_.__metadata={..._.__metadata,...ie},await this.w.writeFile((0,$.$dh)(G,"package.json"),L.$Le.fromString(JSON.stringify(_,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(G){if(G instanceof f.$Eq&&G.code===f.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw G}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const G=await this.scanUserExtensions({includeInvalid:!0});if(G.length)await this.u.addExtensionsToProfile(G.map(ie=>[ie,ie.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,L.$Le.fromString(JSON.stringify([])))}catch(ie){(0,i.$nl)(ie)!==i.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,N.$9)(ie))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(G){this.y.error(G)}finally{this.H=void 0}})()),this.H}async J(G,ie,V,z){return V.includeAllVersions||(G=this.L(ie===o.ExtensionType.System?G:void 0,ie===o.ExtensionType.User?G:void 0,ie==="development"?G:void 0,await this.getTargetPlatform(),z)),V.includeInvalid||(G=G.filter(_=>_.isValid)),G.sort((_,ne)=>{const ce=d.$mc(_.location.fsPath),te=d.$mc(ne.location.fsPath);return ce<te?-1:ce>te?1:0})}L(G,ie,V,z,_){const ne=(te,Y,H)=>{if(te.isValid&&!Y.isValid)return!1;if(te.isValid===Y.isValid){if(_&&l.gt(te.manifest.version,Y.manifest.version))return this.y.debug(`Skipping extension ${Y.location.path} with lower version ${Y.manifest.version} in favour of ${te.location.path} with version ${te.manifest.version}`),!1;if(l.eq(te.manifest.version,Y.manifest.version)){if(te.type===o.ExtensionType.System)return this.y.debug(`Skipping extension ${Y.location.path} in favour of system extension ${te.location.path} with same version`),!1;if(te.targetPlatform===z)return this.y.debug(`Skipping extension ${Y.location.path} from different target platform ${Y.targetPlatform}`),!1}}return H?this.y.warn(`Overwriting user extension ${te.location.path} with ${Y.location.path}.`):this.y.debug(`Overwriting user extension ${te.location.path} with ${Y.location.path}.`),!0},ce=new o.$pn;return G?.forEach(te=>{const Y=ce.get(te.identifier.id);(!Y||ne(Y,te,!1))&&ce.set(te.identifier.id,te)}),ie?.forEach(te=>{const Y=ce.get(te.identifier.id);if(!Y&&G&&te.type===o.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${te.location.path}.`);return}(!Y||ne(Y,te,!1))&&ce.set(te.identifier.id,te)}),V?.forEach(te=>{const Y=ce.get(te.identifier.id);(!Y||ne(Y,te,!0))&&ce.set(te.identifier.id,te),ce.set(te.identifier.id,te)}),[...ce.values()]}async M(G,ie){this.y.trace("Started scanning system extensions");const V=await this.P(this.systemExtensionsLocation,!1,o.ExtensionType.System,!0,ie,!0,void 0,this.R()),_=await(G&&!V.devMode?this.j:this.n).scanExtensions(V);return this.y.trace("Scanned system extensions:",_.length),_}async N(G,ie){const V=this.z.isBuilt?[]:this.C.builtInExtensions;if(!V?.length)return[];this.y.trace("Started scanning dev system extensions");const z=ie?await this.O():{},_=[],ne=g.URI.file(d.$gc(d.$ic(R.$Wg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const te of V){const Y=z[te.name]||"marketplace";switch(Y){case"disabled":break;case"marketplace":_.push((0,$.$dh)(ne,te.name));break;default:_.push(g.URI.file(Y));break}}const ce=await Promise.all(_.map(async te=>this.n.scanExtension(await this.P(te,!1,o.ExtensionType.System,!0,G,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",ce.length),(0,I.$Gb)(ce)}async O(){try{const G=await this.w.readFile(this.r);return JSON.parse(G.value.toString())}catch{return{}}}async P(G,ie,V,z,_,ne,ce,te){const Y=await this.f(_??u.$x),H=await this.Q(G),B=ie&&!this.D.extUri.isEqual(G,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,D=B?await this.Q(B):void 0;return new j(G,H,B,D,ie,ce,V,z,ne,te.version,te.date,this.C.commit,!this.z.isBuilt,_,Y)}async Q(G){try{const ie=await this.w.stat(G);if(typeof ie.mtime=="number")return ie.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Kq=T,e.$Kq=T=ve([Q(4,v.$Il),Q(5,f.$Fq),Q(6,i.$9k),Q(7,t.$9j),Q(8,P.$Ji),Q(9,n.$pk),Q(10,C.$Gl),Q(11,s.$Bi)],T);class j{constructor(G,ie,V,z,_,ne,ce,te,Y,H,B,D,J,q,M){this.location=G,this.mtime=ie,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=z,this.profile=_,this.profileScanOptions=ne,this.type=ce,this.excludeObsolete=te,this.validate=Y,this.productVersion=H,this.productDate=B,this.productCommit=D,this.devMode=J,this.language=q,this.translations=M}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,ie){return(0,$.$9g)(G.location,ie.location)&&G.mtime===ie.mtime&&(0,$.$9g)(G.applicationExtensionslocation,ie.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===ie.applicationExtensionslocationMtime&&G.profile===ie.profile&&A.$eo(G.profileScanOptions,ie.profileScanOptions)&&G.type===ie.type&&G.excludeObsolete===ie.excludeObsolete&&G.validate===ie.validate&&G.productVersion===ie.productVersion&&G.productDate===ie.productDate&&G.productCommit===ie.productCommit&&G.devMode===ie.devMode&&G.language===ie.language&&E.equals(G.translations,ie.translations)}}e.$Lq=j;let U=class extends y.$Tc{constructor(G,ie,V,z,_,ne,ce){super(),this.g=G,this.h=ie,this.j=V,this.m=z,this.n=ne,this.r=ce,this.f=_.extensionsEnabledWithApiProposalVersion?.map(te=>te.toLowerCase())??[]}async scanExtensions(G){const ie=G.profile?await this.t(G):await this.s(G);let V={};if(G.excludeObsolete&&G.type===o.ExtensionType.User)try{const z=(await this.m.readFile(this.g)).value.toString();V=JSON.parse(z)}catch{}return(0,S.$pg)(V)?ie:ie.filter(z=>!V[m.$Jp.create(z).toString()])}async s(G){const ie=await this.m.resolve(G.location);if(!ie.children?.length)return[];const V=await Promise.all(ie.children.map(async z=>{if(!z.isDirectory||G.type===o.ExtensionType.User&&(0,$.$ah)(z.resource).indexOf(".")===0)return null;const _=new j(z.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(_)}));return(0,I.$Gb)(V).sort((z,_)=>z.location.path<_.location.path?-1:1)}async t(G){let ie=await this.u(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.j.extUri.isEqual(G.location,G.applicationExtensionslocation)){ie=ie.filter(z=>!z.metadata?.isApplicationScoped);const V=await this.u(G.applicationExtensionslocation,z=>!!z.metadata?.isBuiltin||!!z.metadata?.isApplicationScoped,G);ie.push(...V)}return ie}async u(G,ie,V){const z=await this.h.scanProfileExtensions(G,V.profileScanOptions);if(!z.length)return[];const _=await Promise.all(z.map(async ne=>{if(ie(ne)){const ce=new j(ne.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(ce,ne.metadata)}return null}));return(0,I.$Gb)(_)}async scanOneOrMultipleExtensions(G){try{if(await this.m.exists((0,$.$dh)(G.location,"package.json"))){const ie=await this.scanExtension(G);return ie?[ie]:[]}else return await this.scanExtensions(G)}catch(ie){return this.r.error(`Error scanning extensions at ${G.location.path}:`,(0,N.$9)(ie)),[]}}async scanExtension(G,ie){try{let V=await this.w(G.location);if(V){V.publisher||(V.publisher=o.$jn),ie=ie??V.__metadata,delete V.__metadata;const z=(0,m.$Np)(V.publisher,V.name),_=ie?.id?{id:z,uuid:ie.id}:{id:z},ne=ie?.isSystem?o.ExtensionType.System:G.type,ce=ne===o.ExtensionType.System||!!ie?.isBuiltin;V=await this.y(G.location,V,j.createNlsConfiguration(G));let te={type:ne,identifier:_,manifest:V,location:G.location,isBuiltin:ce,targetPlatform:ie?.targetPlatform??o.TargetPlatform.UNDEFINED,publisherDisplayName:ie?.publisherDisplayName,metadata:ie,isValid:!0,validations:[]};return G.validate&&(te=this.validate(te,G)),V.enabledApiProposals&&(!this.n.isBuilt||this.f.includes(z.toLowerCase()))&&(V.enabledApiProposals=(0,o.$vn)([...V.enabledApiProposals])),te}}catch(V){G.type!==o.ExtensionType.System&&this.r.error(V)}return null}validate(G,ie){let V=!0;const z=this.n.isBuilt&&this.f.includes(G.identifier.id.toLowerCase()),_=(0,h.$Zp)(ie.productVersion,ie.productDate,ie.location,G.manifest,G.isBuiltin,z);for(const[ne,ce]of _)ne===p.default.Error&&(V=!1,this.r.error(this.F(ie.location,ce)));return G.isValid=V,G.validations=_,G}async w(G){const ie=(0,$.$dh)(G,"package.json");let V;try{V=(await this.m.readFile(ie)).value.toString()}catch(_){return(0,i.$nl)(_)!==i.FileOperationResult.FILE_NOT_FOUND&&this.r.error(this.F(G,(0,w.localize)(11294,null,ie.path,_.message))),null}let z;try{z=JSON.parse(V)}catch{const ne=[];(0,O.$Un)(V,ne);for(const ce of ne)this.r.error(this.F(G,(0,w.localize)(11295,null,ie.path,ce.offset,ce.length,(0,k.$Hq)(ce.error))));return null}return(0,O.$3n)(z)!=="object"?(this.r.error(this.F(G,(0,w.localize)(11296,null,ie.path))),null):z}async y(G,ie,V){const z=await this.z(G,ie,V);if(z)try{const _=[],ne=await this.C(z.default,_);if(_.length>0)return _.forEach(te=>{this.r.error(this.F(G,(0,w.localize)(11297,null,z.default?.path,(0,k.$Hq)(te.error))))}),ie;if((0,O.$3n)(z)!=="object")return this.r.error(this.F(G,(0,w.localize)(11298,null,z.default?.path))),ie;const ce=z.values||Object.create(null);return(0,b.$Iq)(this.r,ie,ce,ne)}catch{}return ie}async z(G,ie,V){const z=(0,$.$dh)(G,"package.nls.json"),_=(Y,H)=>{H.forEach(B=>{this.r.error(this.F(G,(0,w.localize)(11299,null,Y?.path,(0,k.$Hq)(B.error))))})},ne=Y=>{this.r.error(this.F(G,(0,w.localize)(11300,null,Y?.path)))},ce=`${ie.publisher}.${ie.name}`,te=V.translations[ce];if(te)try{const Y=g.URI.file(te),H=(await this.m.readFile(Y)).value.toString(),B=[],D=(0,O.$Un)(H,B);return B.length>0?(_(Y,B),{values:void 0,default:z}):(0,O.$3n)(D)!=="object"?(ne(Y),{values:void 0,default:z}):{values:D.contents?D.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.m.exists(z))return;let H;try{H=await this.D(G,V)}catch{return}if(!H.localized)return{values:void 0,default:H.original};try{const B=(await this.m.readFile(H.localized)).value.toString(),D=[],J=(0,O.$Un)(B,D);return D.length>0?(_(H.localized,D),{values:void 0,default:H.original}):(0,O.$3n)(J)!=="object"?(ne(H.localized),{values:void 0,default:H.original}):{values:J,default:H.original}}catch{return{values:void 0,default:H.original}}}}async C(G,ie){if(G)try{const V=(await this.m.readFile(G)).value.toString();return(0,O.$Un)(V,ie)}catch{}}D(G,ie){return new Promise((V,z)=>{const _=ne=>{const ce=(0,$.$dh)(G,`package.nls.${ne}.json`);this.m.exists(ce).then(te=>{te&&V({localized:ce,original:(0,$.$dh)(G,"package.nls.json")});const Y=ne.lastIndexOf("-");Y===-1?V({localized:(0,$.$dh)(G,"package.nls.json"),original:null}):(ne=ne.substring(0,Y),_(ne))})};if(ie.devMode||ie.pseudo||!ie.language)return V({localized:(0,$.$dh)(G,"package.nls.json"),original:null});_(ie.language)})}F(G,ie){return`[${G.path}]: ${ie}`}};U=ve([Q(1,f.$Fq),Q(2,C.$Gl),Q(3,i.$9k),Q(4,n.$pk),Q(5,P.$Ji),Q(6,t.$9j)],U);let F=class extends U{constructor(G,ie,V,z,_,ne,ce,te,Y){super(ie,z,_,ne,ce,te,Y),this.J=G,this.L=V,this.H=this.B(new c.$Ah(3e3)),this.I=this.B(new r.$je),this.onDidChangeCache=this.I.event}async scanExtensions(G){const ie=this.P(G),V=await this.M(ie);if(this.G=G,V&&V.input&&j.equals(V.input,this.G))return this.r.debug("Using cached extensions scan result",G.type===o.ExtensionType.System?"system":"user",G.location.toString()),this.H.trigger(()=>this.O()),V.result.map(_=>(_.location=g.URI.revive(_.location),_));const z=await super.scanExtensions(G);return await this.N(ie,{input:G,result:z}),z}async M(G){try{const ie=await this.m.readFile(G),V=JSON.parse(ie.value.toString());return{result:V.result,input:(0,a.$_h)(V.input)}}catch(ie){this.r.debug("Error while reading the extension cache file:",G.path,(0,N.$9)(ie))}return null}async N(G,ie){try{await this.m.writeFile(G,L.$Le.fromString(JSON.stringify(ie)))}catch(V){this.r.debug("Error while writing the extension cache file:",G.path,(0,N.$9)(V))}}async O(){if(!this.G)return;const G=this.P(this.G),ie=await this.M(G);if(!ie)return;const V=ie.result,z=JSON.parse(JSON.stringify(await super.scanExtensions(this.G)));if(!A.$eo(z,V))try{this.r.info("Invalidating Cache",V,z),await this.m.del(G),this.I.fire()}catch(_){this.r.error(_)}}P(G){const ie=this.Q(G);return this.j.extUri.joinPath(ie.cacheHome,G.type===o.ExtensionType.System?o.$in:o.$hn)}Q(G){return G.type===o.ExtensionType.System?this.L.defaultProfile:G.profile?this.j.extUri.isEqual(G.location,this.J.extensionsResource)?this.J:this.L.profiles.find(ie=>this.j.extUri.isEqual(G.location,ie.extensionsResource))??this.J:this.L.defaultProfile}};F=ve([Q(2,v.$Il),Q(3,f.$Fq),Q(4,C.$Gl),Q(5,i.$9k),Q(6,n.$pk),Q(7,P.$Ji),Q(8,t.$9j)],F);function K(x,G){const ie=(0,m.$Lp)(x.manifest.publisher,x.manifest.name);return{id:ie,identifier:new o.$nn(ie),isBuiltin:x.type===o.ExtensionType.System,isUserBuiltin:x.type===o.ExtensionType.User&&x.isBuiltin,isUnderDevelopment:G,extensionLocation:x.location,uuid:x.identifier.uuid,targetPlatform:x.targetPlatform,publisherDisplayName:x.publisherDisplayName,...x.manifest}}class W extends T{constructor(G,ie,V,z,_,ne,ce,te,Y,H,B,D){super(G,ie,(0,$.$dh)(V,".vscode-oss-dev","extensions","control.json"),z,_,ne,ce,te,Y,H,B,D),this.S=(async()=>{if(u.$A)try{const J=await this.w.readFile(g.URI.file(u.$A));return JSON.parse(J.value.toString())}catch{}return Object.create(null)})()}f(G){return this.S}}e.$Nq=W}),define(he[214],ue([0,1,68,6,43,3,2,22,13,30,10,19]),function(oe,e,I,c,A,L,N,O,k,y,R,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0;let u=class extends N.$Tc{constructor(l,p){super(),this.b=l,this.f=p,this.a=new c.$Ih(5)}async postUninstall(l){const p=this.g(l,"uninstall");p&&(this.f.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(p.script,"uninstall",p.args,!0,l),this.f.info("Finished running post uninstall script",l.identifier.id,l.manifest.version)}catch(S){this.f.error("Failed to run post uninstall script",l.identifier.id,l.manifest.version),this.f.error(S)}}));try{await y.Promises.rm(this.m(l))}catch(S){this.f.error("Error while removing extension storage path",l.identifier.id),this.f.error(S)}}g(l,p){const S=`vscode:${p}`;if(l.location.scheme===O.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[S]=="string"){const g=l.manifest.scripts[S].split(" ");return g.length<2||g[0]!=="node"||!g[1]?(this.f.warn(l.identifier.id,l.manifest.version,`${S} should be a node script`),null):{script:(0,k.$ic)(l.location.fsPath,g[1]),args:g.slice(2)||[]}}return null}h(l,p,S,g,w){return new Promise((P,m)=>{const o=this.j(l,p,S,w);let h;const i=s=>{h&&(clearTimeout(h),h=null),s?m(s):P(void 0)};o.on("error",s=>{i((0,A.$nj)(s)||"Unknown")}),o.on("exit",(s,t)=>{i(s?`post-${p} process exited with code ${s}`:void 0)}),g&&(h=setTimeout(()=>{h=null,o.kill(),m("timed out")},5e3))})}j(l,p,S,g){const w={silent:!0,execArgv:void 0},P=(0,I.fork)(l,[`--type=extension-post-${p}`,...S],w);P.stdout.setEncoding("utf8"),P.stderr.setEncoding("utf8");const m=L.Event.fromNodeEventEmitter(P.stdout,"data"),o=L.Event.fromNodeEventEmitter(P.stderr,"data");this.B(m(s=>this.f.info(g.identifier.id,g.manifest.version,`post-${p}`,s))),this.B(o(s=>this.f.error(g.identifier.id,g.manifest.version,`post-${p}`,s)));const h=L.Event.any(L.Event.map(m,s=>({data:`%c${s}`,format:[""]}),this.q),L.Event.map(o,s=>({data:`%c${s}`,format:["color: red"]}),this.q));return L.Event.debounce(h,(s,t)=>s?{data:s.data+t.data,format:[...s.format,...t.format]}:{data:t.data,format:t.format},100,void 0,void 0,void 0,this.q)(s=>{console.group(g.identifier.id),console.log(s.data,...s.format),console.groupEnd()}),P}m(l){return(0,k.$ic)(this.b.defaultProfile.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};e.$Rq=u,e.$Rq=u=ve([Q(0,d.$Il),Q(1,R.$9j)],u)}),define(he[116],ue([0,1,72,11,83,27]),function(oe,e,I,c,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=N,e.$Pq=O;function N(k){let y=L.ExtensionManagementErrorCode.Extract;return k instanceof I.$xq&&(k.type==="CorruptZip"?y=L.ExtensionManagementErrorCode.CorruptZip:k.type==="Incomplete"&&(y=L.ExtensionManagementErrorCode.IncompleteZip)),(0,A.$Cq)(k,y)}async function O(k){let y;try{y=await(0,I.$Aq)(k,"extension/package.json")}catch(R){throw N(R)}try{return JSON.parse(y.toString("utf8"))}catch{throw new L.$jp((0,c.localize)(11285,null),L.ExtensionManagementErrorCode.Invalid)}}}),define(he[215],ue([0,1,6,8,2,22,20,60,12,31,30,72,21,15,83,27,34,116,110,7,10,18]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$,l,p,S,g,w,P,m,o){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0,O=ke(O);let i=class extends A.$Tc{static{h=this}static{this.c=".sigzip"}constructor(t,n,r,a,f,v,C){super(),this.h=n,this.j=r,this.m=a,this.n=f,this.r=v,this.t=C,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(t,n,r,a){await this.g;const f=await this.w(t,n);let v=!1;if(r&&this.u(t)){let C;try{C=await this.y(t)}catch(b){try{await this.delete(f)}catch(E){this.t.error(E)}throw b}try{v=await this.n.verify(t,f.fsPath,C.fsPath,a)}catch(b){if(v=b.code,v===w.ExtensionSignatureVerificationCode.PackageIsInvalidZip||v===w.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(f)}catch(E){this.t.error(E)}throw new p.$jp(d.$wq,p.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(C)}catch(b){this.t.error(b)}}}return{location:f,verificationStatus:v}}u(t){if(!t.isSigned)return this.t.info(`Extension is not signed: ${t.identifier.id}`),!1;const n=this.m.getValue("extensions.verifySignature");return(0,k.$ig)(n)?n:!0}async w(t,n){try{const r=(0,N.$dh)(this.extensionsDownloadDir,this.G(t)),a=await this.C(t,"vsix",async()=>{await this.z(t,r,f=>this.j.download(t,f,n));try{await this.D(r.fsPath,"extension/package.json")}catch(f){try{await this.h.del(r)}catch(v){this.t.warn(`Error while deleting: ${r.path}`,(0,c.$9)(v))}throw f}},2);return a>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:t.identifier.id,attempts:a}),r}catch(r){throw(0,l.$Cq)(r,p.ExtensionManagementErrorCode.Download)}}async y(t){try{const n=(0,N.$dh)(this.extensionsDownloadDir,`.${(0,y.$Yg)()}`),r=await this.C(t,"sigzip",async()=>{await this.j.downloadSignatureArchive(t,n);try{await this.D(n.fsPath,".signature.p7s")}catch(a){try{await this.h.del(n)}catch(f){this.t.warn(`Error while deleting: ${n.path}`,(0,c.$9)(f))}throw a}},2);return r>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:t.identifier.id,attempts:r}),n}catch(n){throw(0,l.$Cq)(n,p.ExtensionManagementErrorCode.DownloadSignature)}}async z(t,n,r){if(await this.h.exists(n))return;if(n.scheme!==L.Schemas.file){await r(n);return}const a=(0,N.$dh)(this.extensionsDownloadDir,`.${(0,y.$Yg)()}`);try{await r(a)}catch(f){try{await this.h.del(a)}catch{}throw f}try{await R.Promises.rename(a.fsPath,n.fsPath,2*60*1e3)}catch(f){try{await this.h.del(a)}catch{}let v=!1;try{v=await this.h.exists(n)}catch{}if(v)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,n.path);else throw this.t.info(`Rename failed because of ${(0,c.$9)(f)}. Deleted the file from downloaded location`,a.path),f}}async C(t,n,r,a){let f=1;for(;;)try{return await r(),f}catch(v){if(f++>a)throw v;this.t.warn(`Failed downloading ${n}. ${(0,c.$9)(v)}. Retry again...`,t.identifier.id)}}async D(t,n){try{await(0,d.$Aq)(t,n)}catch(r){throw(0,g.$Oq)(r)}}async delete(t){await this.g,await this.h.del(t)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const n=[],r=[],a=[];for(const C of t.children)if(C.name.endsWith(h.c))a.push(C.resource);else{const b=S.$Jp.parse(C.name);b&&r.push([b,C])}const f=(0,S.$Op)(r,([C])=>C),v=[];for(const C of f)C.sort((b,E)=>O.rcompare(b[0].version,E[0].version)),n.push(...C.slice(1).map(b=>b[1].resource)),v.push(C[0][1]);v.sort((C,b)=>C.mtime-b.mtime),n.push(...v.slice(0,Math.max(0,v.length-this.f)).map(C=>C.resource)),n.push(...a),await I.Promises.settled(n.map(C=>(this.t.trace("Deleting from cache",C.path),this.h.del(C))))}}catch(t){this.t.error(t)}}G(t){return this.f?S.$Jp.create(t).toString().toLowerCase():(0,y.$Yg)()}};e.$Qq=i,e.$Qq=i=h=ve([Q(0,$.$Ki),Q(1,P.$9k),Q(2,p.$hp),Q(3,u.$9i),Q(4,w.$pq),Q(5,o.$8l),Q(6,m.$9j)],i)}),define(he[117],ue([0,1,32,6,14,25,43,8,3,55,2,36,22,13,20,60,12,9,31,30,72,11,98,15,83,27,34,52,84,215,214,116,187,197,33,59,7,4,10,23,18,28,19]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$,l,p,S,g,w,P,m,o,h,i,s,t,n,r,a,f,v,C,b,E,T,j,U,F,K,W,x,G,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=e.$Vq=e.$Uq=void 0,I=ke(I),$=ke($),p=ke(p),P=ke(P),o=ke(o),e.$Uq=(0,F.$Di)(t.$kp);const V=".vsctmp";let z=class extends s.$Bq{constructor(Y,H,B,D,J,q,M,Z,ee,X,re,le){super(Y,H,re,B,X,le),this.eb=J,this.fb=q,this.gb=M,this.hb=Z,this.ib=ee,this.db=new Map,this.tb=new d.$Ac;const ge=this.B(Z.createInstance(v.$Rq));this.ab=this.B(Z.createInstance(_,Ee=>ge.postUninstall(Ee))),this.bb=this.B(new b.$Sq(le,ee,re,this,this.F)),this.cb=this.B(Z.createInstance(f.$Qq));const pe=this.B(new E.$Tq(this,this.eb,le,q,re,ee,B));this.B(pe.onDidChangeExtensionsByAnotherSource(Ee=>this.sb(Ee))),this.ub()}getTargetPlatform(){return this.jb||(this.jb=(0,n.$Tp)(this.ib,this.F)),this.jb}async zip(Y){this.F.trace("ExtensionManagementService#zip",Y.identifier.id);const H=await this.rb(Y),B=await(0,m.zip)((0,l.$dh)(this.cb.extensionsDownloadDir,(0,w.$Yg)()).fsPath,H);return g.URI.file(B)}async unzip(Y){return this.F.trace("ExtensionManagementService#unzip",Y.toString()),(await this.install(Y)).identifier}async getManifest(Y){const{location:H,cleanup:B}=await this.lb(Y),D=$.$jc(H.fsPath);try{return await(0,C.$Pq)(D)}finally{await B()}}getInstalled(Y,H=this.H.defaultProfile.extensionsResource,B={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(Y??null,H,B)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(Y){return this.ab.scanUserExtensionAtLocation(Y)}async install(Y,H={}){this.F.trace("ExtensionManagementService#install",Y.toString());const{location:B,cleanup:D}=await this.lb(Y);try{const J=await(0,C.$Pq)($.$jc(B.fsPath)),q=(0,n.$Np)(J.publisher,J.name);if(J.engines&&J.engines.vscode&&!(0,j.$2p)(J.engines.vscode,this.G.version,this.G.date))throw new Error(o.localize(11286,null,q,this.G.version));const Z=(await this.I([{manifest:J,extension:B,options:H}])).find(({identifier:ee})=>(0,n.$Ip)(ee,{id:q}));if(Z?.local)return Z.local;throw Z?.error?Z.error:(0,s.$Cq)(new Error(`Unknown error while installing extension ${q}`))}finally{await D()}}async installFromLocation(Y,H){this.F.trace("ExtensionManagementService#installFromLocation",Y.toString());const B=await this.ab.scanUserExtensionAtLocation(Y);if(!B||!B.manifest.name||!B.manifest.version)throw new Error(`Cannot find a valid extension from the location ${Y.toString()}`);return await this.wb([[B,{source:"resource"}]],H),this.F.info("Successfully installed extension",B.identifier.id,H.toString()),B}async installExtensionsFromProfile(Y,H,B){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",Y,H.toString(),B.toString());const D=(await this.getInstalled(T.ExtensionType.User,H)).filter(J=>Y.some(q=>(0,n.$Ip)(q,J.identifier)));if(D.length){const J=await Promise.all(D.map(q=>this.ab.scanMetadata(q,H)));await this.wb(D.map((q,M)=>[q,J[M]]),B),this.F.info("Successfully installed extensions",D.map(q=>q.identifier.id),B.toString())}return D}async updateMetadata(Y,H,B){return this.F.trace("ExtensionManagementService#updateMetadata",Y.identifier.id),H.isPreReleaseVersion&&(H.preRelease=!0,H.hasPreReleaseVersion=!0),H.isMachineScoped===!1&&(H.isMachineScoped=void 0),H.isBuiltin===!1&&(H.isBuiltin=void 0),H.pinned===!1&&(H.pinned=void 0),Y=await this.ab.updateMetadata(Y,H,B),this.bb.invalidate(B),this.w.fire({local:Y,profileLocation:B}),Y}async reinstallFromGallery(Y){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",Y.identifier.id),!this.z.isEnabled())throw new Error(o.localize(11287,null));const H=await this.getTargetPlatform(),[B]=await this.z.getExtensions([{...Y.identifier,preRelease:Y.preRelease}],{targetPlatform:H,compatible:!0},L.CancellationToken.None);if(!B)throw new Error(o.localize(11288,null));await this.ab.setUninstalled(Y);try{await this.ab.removeUninstalledExtension(Y)}catch(D){throw new Error(o.localize(11289,null,(0,N.$nj)(D)))}return this.installFromGallery(B)}$(Y,H,B,D){return this.ab.copyExtension(Y,H,B,D)}copyExtensions(Y,H){return this.ab.copyExtensions(Y,H,{version:this.G.version,date:this.G.date})}markAsUninstalled(...Y){return this.ab.setUninstalled(...Y)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(Y){this.F.error(Y)}}async download(Y,H,B){const{location:D}=await this.cb.download(Y,H,!B);return D}async lb(Y){if(Y.scheme===u.Schemas.file)return{location:Y,async cleanup(){}};this.F.trace("Downloading extension from",Y.toString());const H=(0,l.$dh)(this.cb.extensionsDownloadDir,(0,w.$Yg)());return await this.gb.download(Y,H),this.F.info("Downloaded extension to",H.toString()),{location:H,cleanup:async()=>{try{await this.ib.del(H)}catch(D){this.F.error(D)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(Y,H,B){const D=H instanceof g.URI?new n.$Jp({id:(0,n.$Np)(Y.publisher,Y.name)},Y.version):n.$Jp.create(H);return this.hb.createInstance(ne,D,Y,H,B,(J,q)=>{if(H instanceof g.URI)return this.qb(D,H,B,q);let M=this.db.get(D.toString());return M||(this.db.set(D.toString(),M=this.pb(D,H,J,B,q)),M.finally(()=>this.db.delete(D.toString()))),M},this.ab)}Z(Y,H){return new ce(Y,H.profileLocation,this.fb)}async pb(Y,H,B,D,J){const{verificationStatus:q,location:M}=await this.cb.download(H,B,!D.donotVerifySignature,D.context?.[t.$ap]);try{if(J.isCancellationRequested)throw new O.$4;return await(0,C.$Pq)(M.fsPath),{local:await this.ab.extractUserExtension(Y,M.fsPath,{id:H.identifier.uuid,publisherId:H.publisherId,publisherDisplayName:H.publisherDisplayName,targetPlatform:H.properties.targetPlatform,isApplicationScoped:D.isApplicationScoped,isMachineScoped:D.isMachineScoped,isBuiltin:D.isBuiltin,isPreReleaseVersion:H.properties.isPreReleaseVersion,hasPreReleaseVersion:H.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:D.installGivenVersion?!0:!!D.pinned,preRelease:(0,S.$ig)(D.preRelease)?D.preRelease:D.installPreReleaseVersion||H.properties.isPreReleaseVersion,source:"gallery"},!1,J),verificationStatus:q}}catch(Z){try{await this.cb.delete(M)}catch(ee){this.F.warn("Error while deleting the downloaded file",M.toString(),(0,O.$9)(ee))}throw(0,s.$Cq)(Z)}}async qb(Y,H,B,D){return{local:await this.ab.extractUserExtension(Y,$.$jc(H.fsPath),{isApplicationScoped:B.isApplicationScoped,isMachineScoped:B.isMachineScoped,isBuiltin:B.isBuiltin,installedTimestamp:Date.now(),pinned:B.installGivenVersion?!0:!!B.pinned,source:"vsix"},!0,D)}}async rb(Y){const H=async D=>{let J=await P.Promises.readdir(D);J=J.map(Z=>$.$ic(D,Z));const q=await Promise.all(J.map(Z=>I.promises.stat(Z)));let M=Promise.resolve([]);return q.forEach((Z,ee)=>{const X=J[ee];Z.isFile()&&(M=M.then(re=>[...re,X])),Z.isDirectory()&&(M=M.then(re=>H(X).then(le=>[...re,...le])))}),M};return(await H(Y.location.fsPath)).map(D=>({path:`extension/${$.$kc(Y.location.fsPath,D)}`,localPath:D}))}async sb({added:Y,removed:H}){if(H){const B=Y&&this.D.extUri.isEqual(H.profileLocation,Y.profileLocation)?H.extensions.filter(D=>Y.extensions.every(J=>!(0,n.$Ip)(J,D))):H.extensions;for(const D of B)this.F.info("Extensions removed from another source",D.id,H.profileLocation.toString()),this.u.fire({identifier:D,profileLocation:H.profileLocation})}if(Y){const D=(await this.getInstalled(T.ExtensionType.User,Y.profileLocation)).filter(J=>Y.extensions.some(q=>(0,n.$Ip)(q,J.identifier)));this.s.fire(D.map(J=>(this.F.info("Extensions added from another source",J.identifier.id,Y.profileLocation.toString()),{identifier:J.identifier,local:J,profileLocation:Y.profileLocation,operation:t.InstallOperation.None})))}}async ub(){this.B(this.ab.onExtract(H=>this.tb.add(H)));const Y=await this.ib.resolve(this.eb.userExtensionsLocation);for(const H of Y.children??[])H.isDirectory&&this.tb.add(H.resource);this.B(this.ib.watch(this.eb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(H=>this.vb(H)))}async vb(Y){if(!Y.affects(this.eb.userExtensionsLocation,U.FileChangeType.ADDED))return;const H=[];for(const B of Y.rawAdded){if(this.tb.has(B)||!this.D.extUri.isEqual(this.D.extUri.dirname(B),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(B,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(B).startsWith(".")||!(await this.ib.stat(B)).isDirectory)continue;const D=await this.ab.scanUserExtensionAtLocation(B);D&&D.installedTimestamp===void 0&&(this.tb.add(B),H.push(D))}H.length&&(await this.wb(H.map(B=>[B,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",H.map(B=>B.identifier.id)))}async wb(Y,H){const B=Y.map(D=>D[0]);await this.xb(B),await this.fb.addExtensionsToProfile(Y,H),this.s.fire(B.map(D=>({local:D,identifier:D.identifier,operation:t.InstallOperation.None,profileLocation:H})))}async xb(Y){const H=await this.ab.getUninstalledExtensions();for(const B of Y){const D=n.$Jp.create(B);H[D.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",D.id),await this.ab.setInstalled(D),this.F.info("Removed the extension from uninstalled list:",D.id))}}};e.$Vq=z,e.$Vq=z=ve([Q(0,t.$hp),Q(1,x.$8l),Q(2,K.$9j),Q(3,i.$Ki),Q(4,a.$Jq),Q(5,r.$Fq),Q(6,h.$Xo),Q(7,F.$Bi),Q(8,U.$9k),Q(9,W.$pk),Q(10,G.$Gl),Q(11,ie.$Il)],z);let _=class extends R.$Tc{constructor(Y,H,B,D,J,q,M){super(),this.n=Y,this.s=H,this.t=B,this.u=D,this.w=J,this.y=q,this.z=M,this.h=this.B(new k.$je),this.onExtract=this.h.event,this.j=new d.$zc,this.m=new d.$zc,this.c=(0,l.$dh)(this.t.userExtensionsLocation,".obsolete"),this.g=new c.$Jh}async cleanUp(){await this.J(),await this.I()}async scanExtensions(Y,H,B){try{const D={includeInvalid:!0,profileLocation:H,productVersion:B};let J=[];if(Y===null||Y===T.ExtensionType.System){let q=this.j.get(H);q||(q=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},D,!1).finally(()=>this.j.delete(H)),this.j.set(H,q)),J.push(...await q)}else if(Y===T.ExtensionType.User){let q=this.m.get(H);q||(q=this.t.scanUserExtensions(D).finally(()=>this.m.delete(H)),this.m.set(H,q)),J.push(...await q)}return J=Y!==null?J.filter(q=>q.type===Y):J,await Promise.all(J.map(q=>this.H(q)))}catch(D){throw(0,s.$Cq)(D,t.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(Y){try{const H=await this.t.scanUserExtensions({includeAllVersions:!Y,includeInvalid:!0});return await Promise.all(H.map(B=>this.H(B)))}catch(H){throw(0,s.$Cq)(H,t.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(Y){try{const H=await this.t.scanExistingExtension(Y,T.ExtensionType.User,{includeInvalid:!0});if(H)return await this.H(H)}catch(H){this.z.error(H)}return null}async extractUserExtension(Y,H,B,D,J){const q=Y.toString(),M=g.URI.file($.$ic(this.t.userExtensionsLocation.fsPath,`.${(0,w.$Yg)()}`)),Z=g.URI.file($.$ic(this.t.userExtensionsLocation.fsPath,q));let ee=await this.s.exists(Z);if(ee&&D){try{await this.D(Y.id,Z,"removeExisting")}catch{throw new t.$jp(o.localize(11290,null,Z.fsPath,Y.id),t.ExtensionManagementErrorCode.Delete)}ee=!1}if(ee)try{await this.t.updateMetadata(Z,B)}catch(X){throw this.y.publicLog2("extension:extract",{extensionId:Y.id,code:`${(0,U.$nl)(X)}`}),(0,s.$Cq)(X,t.ExtensionManagementErrorCode.UpdateExistingMetadata)}else try{if(J.isCancellationRequested)throw new O.$4;try{this.z.trace(`Started extracting the extension from ${H} to ${Z.fsPath}`),await(0,m.$zq)(H,M.fsPath,{sourcePath:"extension",overwrite:!0},J),this.z.info(`Extracted extension to ${Z}:`,Y.id)}catch(X){throw(0,C.$Oq)(X)}try{await this.t.updateMetadata(M,B)}catch(X){throw this.y.publicLog2("extension:extract",{extensionId:Y.id,code:`${(0,U.$nl)(X)}`}),(0,s.$Cq)(X,t.ExtensionManagementErrorCode.UpdateMetadata)}if(J.isCancellationRequested)throw new O.$4;try{this.z.trace(`Started renaming the extension from ${M.fsPath} to ${Z.fsPath}`),await this.G(M.fsPath,Z.fsPath),this.z.info("Renamed to",Z.fsPath)}catch(X){if(X.code==="ENOTEMPTY"){this.z.info("Rename failed because extension was installed by another source. So ignoring renaming.",Y.id);try{await this.s.del(M,{recursive:!0})}catch{}}else throw this.z.info(`Rename failed because of ${(0,O.$9)(X)}. Deleted from extracted location`,M),X}this.h.fire(Z)}catch(X){try{await this.s.del(M,{recursive:!0})}catch{}throw X}return this.scanLocalExtension(Z,T.ExtensionType.User)}async scanMetadata(Y,H){return H?(await this.C(Y,H))?.metadata:this.t.scanMetadata(Y.location)}async C(Y,H){return(await this.u.scanProfileExtensions(H)).find(D=>(0,n.$Ip)(D.identifier,Y.identifier))}async updateMetadata(Y,H,B){try{B?await this.u.updateMetadata([[Y,H]],B):await this.t.updateMetadata(Y.location,H)}catch(D){throw this.y.publicLog2("extension:extract",{extensionId:Y.identifier.id,code:`${(0,U.$nl)(D)}`}),(0,s.$Cq)(D,t.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(Y.location,Y.type,B)}async getUninstalledExtensions(){try{return await this.F()}catch(Y){throw(0,s.$Cq)(Y,t.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...Y){const H=Y.map(B=>n.$Jp.create(B));await this.F(B=>H.forEach(D=>{B[D.toString()]=!0,this.z.info("Marked extension as uninstalled",D.toString())}))}async setInstalled(Y){try{await this.F(H=>delete H[Y.toString()])}catch(H){throw(0,s.$Cq)(H,t.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(Y,H){if(this.w.extUri.isEqualOrParent(Y.location,this.t.userExtensionsLocation))return this.D(Y.identifier.id,Y.location,H)}async removeUninstalledExtension(Y){await this.removeExtension(Y,"uninstalled"),await this.F(H=>delete H[n.$Jp.create(Y).toString()])}async copyExtension(Y,H,B,D){const J=await this.C(Y,H),q=await this.C(Y,B);if(D={...J?.metadata,...D},q)if(this.w.extUri.isEqual(q.location,Y.location))await this.u.updateMetadata([[Y,{...q.metadata,...D}]],B);else{const M=await this.scanLocalExtension(q.location,Y.type,B);await this.u.removeExtensionFromProfile(M,B),await this.u.addExtensionsToProfile([[Y,{...q.metadata,...D}]],B)}else await this.u.addExtensionsToProfile([[Y,D]],B);return this.scanLocalExtension(Y.location,Y.type,B)}async copyExtensions(Y,H,B){const D=await this.scanExtensions(T.ExtensionType.User,Y,B),J=await Promise.all(D.filter(q=>!q.isApplicationScoped).map(async q=>[q,await this.scanMetadata(q,Y)]));await this.u.addExtensionsToProfile(J,H)}async D(Y,H,B){this.z.trace(`Deleting ${B} extension from disk`,Y,H.fsPath);const D=this.w.extUri.joinPath(this.w.extUri.dirname(H),`${this.w.extUri.basename(H)}.${(0,y.$qj)((0,w.$Yg)()).toString(16)}${V}`);await this.G(H.fsPath,D.fsPath),await this.s.del(D,{recursive:!0}),this.z.info(`Deleted ${B} extension from disk`,Y,H.fsPath)}F(Y){return this.g.queue(async()=>{let H;try{H=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(D){if((0,U.$nl)(D)!==U.FileOperationResult.FILE_NOT_FOUND)throw D}let B={};if(H)try{B=JSON.parse(H)}catch{}return Y&&(Y(B),Object.keys(B).length?await this.s.writeFile(this.c,A.$Le.fromString(JSON.stringify(B))):await this.s.del(this.c)),B})}async G(Y,H){try{await P.Promises.rename(Y,H,2*60*1e3)}catch(B){throw(0,s.$Cq)(B,t.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(Y,H,B){try{if(B){const J=(await this.t.scanUserExtensions({profileLocation:B})).find(q=>this.w.extUri.isEqual(q.location,Y));if(J)return await this.H(J)}else{const D=await this.t.scanExistingExtension(Y,H,{includeInvalid:!0});if(D)return await this.H(D)}throw new t.$jp(o.localize(11291,null,Y.path),t.ExtensionManagementErrorCode.ScanningExtension)}catch(D){throw(0,s.$Cq)(D,t.ExtensionManagementErrorCode.ScanningExtension)}}async H(Y){const H=await this.s.resolve(Y.location);let B,D;return H.children&&(B=H.children.find(({name:J})=>/^readme(\.txt|\.md|)$/i.test(J))?.resource,D=H.children.find(({name:J})=>/^changelog(\.txt|\.md|)$/i.test(J))?.resource),{identifier:Y.identifier,type:Y.type,isBuiltin:Y.isBuiltin||!!Y.metadata?.isBuiltin,location:Y.location,manifest:Y.manifest,targetPlatform:Y.targetPlatform,validations:Y.validations,isValid:Y.isValid,readmeUrl:B,changelogUrl:D,publisherDisplayName:Y.metadata?.publisherDisplayName,publisherId:Y.metadata?.publisherId||null,isApplicationScoped:!!Y.metadata?.isApplicationScoped,isMachineScoped:!!Y.metadata?.isMachineScoped,isPreReleaseVersion:!!Y.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!Y.metadata?.hasPreReleaseVersion,preRelease:!!Y.metadata?.preRelease,installedTimestamp:Y.metadata?.installedTimestamp,updated:!!Y.metadata?.updated,pinned:!!Y.metadata?.pinned,isWorkspaceScoped:!1,source:Y.metadata?.source??(Y.identifier.uuid?"gallery":"vsix")}}async I(){const Y=await this.getUninstalledExtensions();if(Object.keys(Y).length===0){this.z.debug("No uninstalled extensions found.");return}this.z.debug("Removing uninstalled extensions:",Object.keys(Y));const H=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),B=new Set;for(const J of H)Y[n.$Jp.create(J).toString()]||B.add(J.identifier.id.toLowerCase());try{const J=(0,n.$Op)(H,q=>q.identifier);await c.Promises.settled(J.map(async q=>{const M=q.sort((Z,ee)=>p.rcompare(Z.manifest.version,ee.manifest.version))[0];B.has(M.identifier.id.toLowerCase())||await this.n(await this.H(M))}))}catch(J){this.z.error(J)}const D=H.filter(J=>J.metadata&&Y[n.$Jp.create(J).toString()]);await Promise.allSettled(D.map(J=>this.removeUninstalledExtension(J)))}async J(){this.z.trace("ExtensionManagementService#removeTempDeleteFolders");let Y;try{Y=await this.s.resolve(this.t.userExtensionsLocation)}catch(H){(0,U.$nl)(H)!==U.FileOperationResult.FILE_NOT_FOUND&&this.z.error(H);return}if(Y?.children)try{await Promise.allSettled(Y.children.map(async H=>{if(!(!H.isDirectory||!H.name.endsWith(V))){this.z.trace("Deleting the temporarily deleted folder",H.resource.toString());try{await this.s.del(H.resource,{recursive:!0}),this.z.trace("Deleted the temporarily deleted folder",H.resource.toString())}catch(B){(0,U.$nl)(B)!==U.FileOperationResult.FILE_NOT_FOUND&&this.z.error(B)}}}))}catch{}}};e.$Wq=_,e.$Wq=_=ve([Q(1,U.$9k),Q(2,a.$Jq),Q(3,r.$Fq),Q(4,G.$Gl),Q(5,x.$8l),Q(6,K.$9j)],_);let ne=class extends s.$Dq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(Y,H,B,D,J,q,M,Z,ee,X,re,le){super(),this.l=Y,this.manifest=H,this.source=B,this.options=D,this.m=J,this.n=q,this.o=M,this.p=Z,this.q=ee,this.s=X,this.t=re,this.u=le,this.j=t.InstallOperation.Install,this.identifier=this.l.identifier}async h(Y){const B=(await this.n.scanExtensions(T.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(M=>(0,n.$Ip)(M.identifier,this.identifier));B&&(this.j=t.InstallOperation.Update);const D={isApplicationScoped:this.options.isApplicationScoped||B?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||B?.isMachineScoped,isBuiltin:this.options.isBuiltin||B?.isBuiltin,isSystem:B?.type===T.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??B?.pinned,source:this.source instanceof g.URI?"vsix":"gallery"};let J;if(this.source instanceof g.URI){if(B&&this.l.equals(new n.$Jp(B.identifier,B.manifest.version)))try{await this.n.removeExtension(B,"existing")}catch{throw new Error(o.localize(11292,null,this.manifest.displayName||this.manifest.name))}const M=await this.w(this.l);if(M)try{await this.n.removeExtension(M,"existing")}catch{throw new Error(o.localize(11293,null,this.manifest.displayName||this.manifest.name))}}else{if(D.id=this.source.identifier.uuid,D.publisherId=this.source.publisherId,D.publisherDisplayName=this.source.publisherDisplayName,D.targetPlatform=this.source.properties.targetPlatform,D.updated=!!B,D.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,D.hasPreReleaseVersion=B?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,D.preRelease=(0,S.$ig)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||B?.preRelease,B&&B.type!==T.ExtensionType.System&&B.manifest.version===this.source.version)return this.n.updateMetadata(B,D,this.options.profileLocation);J=await this.w(this.l)}if(Y.isCancellationRequested)throw(0,s.$Cq)(new O.$4);if(!J){const M=await this.m(this.operation,Y);J=M.local,this.k=M.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(M){throw(0,s.$Cq)(M,t.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(Y.isCancellationRequested)throw(0,s.$Cq)(new O.$4);try{await this.t.addExtensionsToProfile([[J,D]],this.options.profileLocation,!J.isValid)}catch(M){throw(0,s.$Cq)(M,t.ExtensionManagementErrorCode.AddToProfile)}const q=await this.n.scanLocalExtension(J.location,T.ExtensionType.User,this.options.profileLocation);if(!q)throw new t.$jp("Cannot find the installed extension",t.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof g.URI&&this.x(J,Y),q}async w(Y){return(await this.n.getUninstalledExtensions())[Y.toString()]?(this.u.trace("Removing the extension from uninstalled list:",Y.id),await this.n.setInstalled(Y),this.u.info("Removed the extension from uninstalled list:",Y.id),(await this.n.scanAllUserExtensions(!0)).find(D=>n.$Jp.create(D).equals(Y))):void 0}async x(Y,H){try{let[B]=await this.p.getExtensions([{id:Y.identifier.id,version:Y.manifest.version}],H);if(B||([B]=await this.p.getExtensions([{id:Y.identifier.id}],H)),B){const D={id:B.identifier.uuid,publisherDisplayName:B.publisherDisplayName,publisherId:B.publisherId,isPreReleaseVersion:B.properties.isPreReleaseVersion,hasPreReleaseVersion:Y.hasPreReleaseVersion||B.properties.isPreReleaseVersion,preRelease:B.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(Y,D,this.options.profileLocation)}}catch{}}};ne=ve([Q(6,G.$Gl),Q(7,t.$hp),Q(8,ie.$Il),Q(9,a.$Jq),Q(10,r.$Fq),Q(11,K.$9j)],ne);class ce extends s.$Dq{constructor(Y,H,B){super(),this.extension=Y,this.j=H,this.k=B}async h(Y){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(he[216],ue([0,1,10,19,28,18,52,7,15,9]),function(oe,e,I,c,A,L,N,O,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nR=void 0;let R=class extends N.$Gq{constructor(u,$,l,p,S,g){super(y.URI.file(u.extensionsPath),$,l,p,S,g)}};e.$nR=R,e.$nR=R=ve([Q(0,k.$Ki),Q(1,O.$9k),Q(2,c.$Il),Q(3,A.$Gl),Q(4,L.$8l),Q(5,I.$9j)],R)}),define(he[217],ue([0,1,9,15,52,84,7,4,10,23,28,19]),function(oe,e,I,c,A,L,N,O,k,y,R,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ugc=void 0;let u=class extends L.$Nq{constructor(l,p,S,g,w,P,m,o){super(I.URI.file(w.builtinExtensionsPath),I.URI.file(w.extensionsPath),w.userHome,l.defaultProfile,l,p,S,g,w,P,m,o)}};e.$ugc=u,e.$ugc=u=ve([Q(0,d.$Il),Q(1,A.$Fq),Q(2,N.$9k),Q(3,k.$9j),Q(4,c.$Ki),Q(5,y.$pk),Q(6,R.$Gl),Q(7,O.$Bi)],u)}),define(he[16],ue([0,1,6,3,2,100,12,70,4,19]),function(oe,e,I,c,A,L,N,O,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$gq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$eq=e.$dq=e.$cq=void 0,e.$fq=$,e.$hq=p,e.$jq=g,e.$cq="__$__isNewStorageMarker",e.$dq="__$__targetStorageMarker",e.$eq=(0,k.$Ci)("storageService");var R;(function(w){w[w.NONE=0]="NONE",w[w.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var d;(function(w){w[w.APPLICATION=-1]="APPLICATION",w[w.PROFILE=0]="PROFILE",w[w.WORKSPACE=1]="WORKSPACE"})(d||(e.StorageScope=d={}));var u;(function(w){w[w.USER=0]="USER",w[w.MACHINE=1]="MACHINE"})(u||(e.StorageTarget=u={}));function $(w){const P=w.get(e.$dq);if(P)try{return JSON.parse(P)}catch{}return Object.create(null)}class l extends A.$Tc{static{this.a=60*1e3}constructor(P={flushInterval:l.a}){super(),this.m=P,this.b=this.B(new c.$me),this.c=this.B(new c.$me),this.onDidChangeTarget=this.c.event,this.f=this.B(new c.$je),this.onWillSaveState=this.f.event,this.h=this.B(new I.$Oh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new A.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(P,m,o){return c.Event.filter(this.b.event,h=>h.scope===P&&(m===void 0||h.key===m),o)}n(){this.j.value=(0,I.$Sh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,A.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(P,m){const{key:o,external:h}=m;if(o===e.$dq){switch(P){case d.APPLICATION:this.H=void 0;break;case d.PROFILE:this.F=void 0;break;case d.WORKSPACE:this.C=void 0;break}this.c.fire({scope:P})}else this.b.fire({scope:P,key:o,target:this.J(P)[o],external:h})}w(P){this.f.fire({reason:P})}get(P,m,o){return this.P(m)?.get(P,o)}getBoolean(P,m,o){return this.P(m)?.getBoolean(P,o)}getNumber(P,m,o){return this.P(m)?.getNumber(P,o)}getObject(P,m,o){return this.P(m)?.getObject(P,o)}storeAll(P,m){this.y(()=>{for(const o of P)this.store(o.key,o.value,o.scope,o.target,m)})}store(P,m,o,h,i=!1){if((0,N.$lg)(m)){this.remove(P,o,i);return}this.y(()=>{this.z(P,o,h),this.P(o)?.set(P,m,i)})}remove(P,m,o=!1){this.y(()=>{this.z(P,m,void 0),this.P(m)?.delete(P,o)})}y(P){this.b.pause(),this.c.pause();try{P()}finally{this.b.resume(),this.c.resume()}}keys(P,m){const o=[],h=this.J(P);for(const i of Object.keys(h))h[i]===m&&o.push(i);return o}z(P,m,o,h=!1){const i=this.J(m);typeof o=="number"?i[P]!==o&&(i[P]=o,this.P(m)?.set(e.$dq,JSON.stringify(i),h)):typeof i[P]=="number"&&(delete i[P],this.P(m)?.set(e.$dq,JSON.stringify(i),h))}get D(){return this.C||(this.C=this.L(d.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(d.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(d.APPLICATION)),this.H}J(P){switch(P){case d.APPLICATION:return this.I;case d.PROFILE:return this.G;default:return this.D}}L(P){const m=this.P(P);return m?$(m):Object.create(null)}isNew(P){return this.getBoolean(e.$cq,P)===!0}async flush(P=R.NONE){this.f.fire({reason:P});const m=this.P(d.APPLICATION),o=this.P(d.PROFILE),h=this.P(d.WORKSPACE);switch(P){case R.NONE:await I.Promises.settled([m?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await I.Promises.settled([m?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve()]);break}}async log(){const P=this.P(d.APPLICATION)?.items??new Map,m=this.P(d.PROFILE)?.items??new Map,o=this.P(d.WORKSPACE)?.items??new Map;return g(P,m,o,this.Q(d.APPLICATION)??"",this.Q(d.PROFILE)??"",this.Q(d.WORKSPACE)??"")}async optimize(P){return await this.flush(),this.P(P)?.optimize()}async switch(P,m){return this.w(R.NONE),(0,y.$Hl)(P)?this.R(P,m):this.S(P,m)}M(P,m){return!(P.id===m.id||p(m)&&p(P))}N(P,m,o){this.y(()=>{const h=new Set;for(const[i,s]of P)h.add(i),m.get(i)!==s&&this.u(o,{key:i,external:!0});for(const[i]of m.items)h.has(i)||this.u(o,{key:i,external:!0})})}}e.$gq=l;function p(w){return w.isDefault||!!w.useDefaultFlags?.globalState}class S extends l{constructor(){super(),this.U=this.B(new O.$aq(new O.$bq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new O.$aq(new O.$bq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new O.$aq(new O.$bq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(P=>this.u(d.WORKSPACE,P))),this.B(this.W.onDidChangeStorage(P=>this.u(d.PROFILE,P))),this.B(this.U.onDidChangeStorage(P=>this.u(d.APPLICATION,P)))}P(P){switch(P){case d.APPLICATION:return this.U;case d.PROFILE:return this.W;default:return this.X}}Q(P){switch(P){case d.APPLICATION:return"inMemory (application)";case d.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(P){return!1}}e.$iq=S;async function g(w,P,m,o,h,i){const s=E=>{try{return JSON.parse(E)}catch{return E}},t=new Map,n=new Map;w.forEach((E,T)=>{t.set(T,E),n.set(T,s(E))});const r=new Map,a=new Map;P.forEach((E,T)=>{r.set(T,E),a.set(T,s(E))});const f=new Map,v=new Map;m.forEach((E,T)=>{f.set(T,E),v.set(T,s(E))}),console.group(o!==h?`Storage: Application (path: ${o})`:`Storage: Application & Profile (path: ${o}, default profile)`);const C=[];if(t.forEach((E,T)=>{C.push({key:T,value:E})}),console.table(C),console.groupEnd(),console.log(n),o!==h){console.group(`Storage: Profile (path: ${h}, profile specific)`);const E=[];r.forEach((T,j)=>{E.push({key:j,value:T})}),console.table(E),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${i})`);const b=[];f.forEach((E,T)=>{b.push({key:T,value:E})}),console.table(b),console.groupEnd(),console.log(v)}}),define(he[118],ue([0,1,3,2,12,27,34,16]),function(oe,e,I,c,A,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$Lb=e.$0Lb=void 0;let k=class extends c.$Tc{constructor(d,u){super(),this.a=new I.$je,this.onDidChangeEnablement=this.a.event,this.b=this.B(new y(d)),this.B(this.b.onDidChange($=>this.a.fire({extensions:$,source:"storage"}))),this.B(u.onDidInstallExtensions($=>$.forEach(({local:l,operation:p})=>{l&&p===L.InstallOperation.Migrate&&this.f(l.identifier)})))}async enableExtension(d,u){return this.f(d)?(this.a.fire({extensions:[d],source:u}),!0):!1}async disableExtension(d,u){return this.c(d)?(this.a.fire({extensions:[d],source:u}),!0):!1}getDisabledExtensions(){return this.h(L.$lp)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(d){const u=this.getDisabledExtensions();return u.every($=>!(0,N.$Ip)($,d))?(u.push(d),this.g(u),!0):!1}f(d){const u=this.getDisabledExtensions();for(let $=0;$<u.length;$++){const l=u[$];if((0,N.$Ip)(l,d))return u.splice($,1),this.g(u),!0}return!1}g(d){this.j(L.$lp,d)}h(d){return this.b.get(d,O.StorageScope.PROFILE)}j(d,u){this.b.set(d,u,O.StorageScope.PROFILE)}};e.$0Lb=k,e.$0Lb=k=ve([Q(0,O.$eq),Q(1,L.$kp)],k);class y extends c.$Tc{constructor(d){super(),this.c=d,this.a=Object.create(null),this.b=this.B(new I.$je),this.onDidChange=this.b.event,this.B(d.onDidChangeValue(O.StorageScope.PROFILE,void 0,this.B(new c.$Sc))(u=>this.f(u)))}get(d,u){let $;return u===O.StorageScope.PROFILE?((0,A.$lg)(this.a[d])&&(this.a[d]=this.g(d,u)),$=this.a[d]):$=this.g(d,u),JSON.parse($)}set(d,u,$){const l=JSON.stringify(u.map(({id:S,uuid:g})=>({id:S,uuid:g})));this.g(d,$)!==l&&($===O.StorageScope.PROFILE&&(u.length?this.a[d]=l:delete this.a[d]),this.h(d,u.length?l:void 0,$))}f(d){if(!(0,A.$lg)(this.a[d.key])&&this.g(d.key,d.scope)!==this.a[d.key]){const $=this.get(d.key,d.scope);delete this.a[d.key];const l=this.get(d.key,d.scope),p=$.filter(g=>!l.some(w=>(0,N.$Ip)(g,w))),S=l.filter(g=>!$.some(w=>(0,N.$Ip)(w,g)));(p.length||S.length)&&this.b.fire([...p,...S])}}g(d,u){return this.c.get(d,u,"[]")}h(d,u,$){u?this.c.store(d,u,$,O.StorageTarget.MACHINE):this.c.remove(d,$)}}e.$$Lb=y}),define(he[85],ue([0,1,4,3,2,16,34,23,17,10,12]),function(oe,e,I,c,A,L,N,O,k,y,R){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$mw=e.$lw=void 0,e.$lw=(0,I.$Ci)("IExtensionStorageService");const u=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let $=class extends A.$Tc{static{d=this}static{this.a=512*1024}static b(p){return`extensionKeys/${(0,N.$Mp)(p.id)}@${p.version}`}static c(p){const S=u.exec(p);if(S&&S[1])return{id:S[1],version:S[2]}}static async removeOutdatedExtensionVersions(p,S){const g=await p.getInstalled(),w=[];for(const[P,m]of d.f(S)){const o=g.find(h=>(0,N.$Ip)(h.identifier,{id:P}))?.manifest.version;for(const h of m)o!==h&&w.push(d.b({id:P,version:h}))}for(const P of w)S.remove(P,L.StorageScope.PROFILE)}static f(p){const S=new Map,g=p.keys(L.StorageScope.PROFILE,L.StorageTarget.MACHINE);for(const w of g){const P=d.c(w);if(P){let m=S.get(P.id.toLowerCase());m||S.set(P.id.toLowerCase(),m=[]),m.push(P.version)}}return S}constructor(p,S,g){super(),this.j=p,this.m=S,this.n=g,this.g=this.B(new c.$je),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=d.f(p),this.B(this.j.onDidChangeValue(L.StorageScope.PROFILE,void 0,this.B(new A.$Sc))(w=>this.r(w)))}r(p){if(this.h.has(p.key.toLowerCase())){this.g.fire();return}const S=d.c(p.key);if(S){if(this.j.get(p.key,L.StorageScope.PROFILE)===void 0)this.h.delete(S.id.toLowerCase());else{let g=this.h.get(S.id.toLowerCase());g||this.h.set(S.id.toLowerCase(),g=[]),g.push(S.version),this.g.fire()}return}}s(p){if((0,R.$cg)(p))return p;const S=p.manifest?p.manifest.publisher:p.publisher,g=p.manifest?p.manifest.name:p.name;return(0,N.$Lp)(S,g)}getExtensionState(p,S){const g=this.s(p),w=this.getExtensionStateRaw(p,S);if(w)try{return JSON.parse(w)}catch(P){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${g}, global: ${S}): ${P}`)}}getExtensionStateRaw(p,S){const g=this.s(p),w=this.j.get(g,S?L.StorageScope.PROFILE:L.StorageScope.WORKSPACE);return w&&w?.length>d.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${g}, global: ${S}): ${w.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),w}setExtensionState(p,S,g){const w=this.s(p);S===void 0?this.j.remove(w,g?L.StorageScope.PROFILE:L.StorageScope.WORKSPACE):this.j.store(w,JSON.stringify(S),g?L.StorageScope.PROFILE:L.StorageScope.WORKSPACE,L.StorageTarget.MACHINE)}setKeysForSync(p,S){this.j.store(d.b(p),JSON.stringify(S),L.StorageScope.PROFILE,L.StorageTarget.MACHINE)}getKeysForSync(p){const S=this.m.extensionSyncedKeys?.[p.id.toLowerCase()],g=this.j.get(d.b(p),L.StorageScope.PROFILE),w=g?JSON.parse(g):void 0;return w&&S?(0,k.$Lb)([...w,...S]):w||S}addToMigrationList(p,S){if(p!==S){const g=this.t.filter(w=>!w.includes(p)&&!w.includes(S));g.push([p,S]),this.t=g}}getSourceExtensionToMigrate(p){const S=this.t.find(([,g])=>p===g);return S?S[0]:void 0}get t(){const p=this.j.get("extensionStorage.migrationList",L.StorageScope.APPLICATION,"[]");try{const S=JSON.parse(p);if(Array.isArray(S))return S}catch{}return[]}set t(p){p.length?this.j.store("extensionStorage.migrationList",JSON.stringify(p),L.StorageScope.APPLICATION,L.StorageTarget.MACHINE):this.j.remove("extensionStorage.migrationList",L.StorageScope.APPLICATION)}};e.$mw=$,e.$mw=$=d=ve([Q(0,L.$eq),Q(1,O.$pk),Q(2,y.$9j)],$)}),define(he[218],ue([0,1,2,27,85,196,117,10,16]),function(oe,e,I,c,A,L,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ehc=void 0;let y=class extends I.$Tc{constructor(d,u,$,l,p,S){super(),d.cleanUp(),(0,L.$16b)(d,u,$,l,S),A.$mw.removeOutdatedExtensionVersions(d,p)}};e.$Ehc=y,e.$Ehc=y=ve([Q(0,N.$Uq),Q(1,c.$hp),Q(2,A.$lw),Q(3,c.$np),Q(4,k.$eq),Q(5,O.$9j)],y)}),define(he[219],ue([0,1,17,2,20,9,7,23,6,3,13,5,37,34,74,33,16]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$,l,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ydc=e.$Xdc=void 0;let g=class extends c.$Tc{constructor(h,i){super(),this.b=h,this.c=i,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,s])=>this.a.set(s.configPath,s))}getConfigBasedTips(h){return this.f(h)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(h){const i=[];for(const[s,t]of this.a)if(!(t.configScheme&&t.configScheme!==h.scheme))try{const n=(await this.b.readFile((0,A.$dh)(h,s))).value.toString();for(const[r,a]of Object.entries(t.recommendations))(!a.contentPattern||new RegExp(a.contentPattern,"mig").test(n))&&i.push({extensionId:r,extensionName:a.name,configName:t.configName,important:!!a.important,isExtensionPack:!!a.isExtensionPack,whenNotInstalled:a.whenNotInstalled})}catch{}return i}};e.$Xdc=g,e.$Xdc=g=ve([Q(0,N.$9k),Q(1,O.$pk)],g);const w="extensionTips/promptedExecutableTips",P="extensionTips/lastPromptedMediumImpExeTime";class m extends g{constructor(h,i,s,t,n,r,a,f){super(a,f),this.r=h,this.s=i,this.t=s,this.u=t,this.w=n,this.z=r,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,f.exeBasedExtensionTips&&Object.entries(f.exeBasedExtensionTips).forEach(([v,C])=>{const b=[],E=[],T=[];Object.entries(C.recommendations).forEach(([j,U])=>{U.important?C.important?b.push({extensionId:j,extensionName:U.name,isExtensionPack:!!U.isExtensionPack}):E.push({extensionId:j,extensionName:U.name,isExtensionPack:!!U.isExtensionPack}):T.push({extensionId:j,extensionName:U.name,isExtensionPack:!!U.isExtensionPack})}),b.length&&this.g.set(v,{exeFriendlyName:C.friendlyName,windowsPath:C.windowsPath,recommendations:b}),E.length&&this.h.set(v,{exeFriendlyName:C.friendlyName,windowsPath:C.windowsPath,recommendations:E}),T.length&&this.j.set(v,{exeFriendlyName:C.friendlyName,windowsPath:C.windowsPath,recommendations:T})}),(0,k.$Eh)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const h=await this.O(this.g),i=await this.O(this.h);return[...h,...i]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const h=await this.O(this.g),i=await this.O(this.h),s=await this.u.getInstalled();this.m=this.D(h,s),this.n=this.D(i,s)}D(h,i){const s=new Map;h.forEach(f=>s.set(f.extensionId.toLowerCase(),f));const{installed:t,uninstalled:n}=this.N([...s.keys()],i);for(const f of t){const v=s.get(f);v&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:f,exeName:v.exeName})}for(const f of n){const v=s.get(f);v&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:f,exeName:v.exeName})}const r=this.L(),a=new Map;for(const f of n){const v=s.get(f);if(v&&(!r[v.exeName]||!r[v.exeName].includes(v.extensionId))){let C=a.get(v.exeName);C||(C=[],a.set(v.exeName,C)),C.push(v)}}return a}F(){if(this.m.size===0)return;const[h,i]=[...this.m.entries()][0];this.H(i).then(s=>{switch(s){case l.RecommendationsNotificationResult.Accepted:this.M(i[0].exeName,i);break;case l.RecommendationsNotificationResult.Ignored:this.m.delete(h);break;case l.RecommendationsNotificationResult.IncompatibleWindow:{const t=y.Event.once(y.Event.latch(y.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(t(()=>this.F()));break}case l.RecommendationsNotificationResult.TooMany:{const t=this.B(new c.$Uc);t.value=(0,k.$Eh)(()=>{t.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const h=this.I(),i=Date.now()-h,s=7*24*60*60*1e3;if(i<s){const r=this.B(new c.$Uc);r.value=(0,k.$Eh)(()=>{r.dispose(),this.G()},s-i);return}const[t,n]=[...this.n.entries()][0];this.H(n).then(r=>{switch(r){case l.RecommendationsNotificationResult.Accepted:{this.J(Date.now()),this.n.delete(t),this.M(n[0].exeName,n);const a=this.B(new c.$Uc);a.value=(0,k.$Eh)(()=>{a.dispose(),this.G()},s);break}case l.RecommendationsNotificationResult.Ignored:this.n.delete(t),this.G();break;case l.RecommendationsNotificationResult.IncompatibleWindow:{const a=y.Event.once(y.Event.latch(y.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(a(()=>this.G()));break}case l.RecommendationsNotificationResult.TooMany:{const a=this.B(new c.$Uc);a.value=(0,k.$Eh)(()=>{a.dispose(),this.G()},60*60*1e3);break}}})}async H(h){const i=await this.u.getInstalled(p.ExtensionType.User),s=h.filter(t=>!t.whenNotInstalled||t.whenNotInstalled.every(n=>i.every(r=>!(0,$.$Ip)(r.identifier,{id:n})))).map(({extensionId:t})=>t.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:s,source:l.RecommendationSource.EXE,name:h[0].exeFriendlyName,searchValue:`@exe:"${h[0].exeName}"`})}I(){let h=this.w.getNumber(P,S.StorageScope.APPLICATION);return h||(h=Date.now(),this.J(h)),h}J(h){this.w.store(P,h,S.StorageScope.APPLICATION,S.StorageTarget.MACHINE)}L(){return JSON.parse(this.w.get(w,S.StorageScope.APPLICATION,"{}"))}M(h,i){const s=this.L();s[h]=i.map(({extensionId:t})=>t.toLowerCase()),this.w.store(w,JSON.stringify(s),S.StorageScope.APPLICATION,S.StorageTarget.USER)}N(h,i){const s=[],t=[],n=i.reduce((r,a)=>(r.add(a.identifier.id.toLowerCase()),r),new Set);return h.forEach(r=>{n.has(r.toLowerCase())?s.push(r):t.push(r)}),{installed:s,uninstalled:t}}async O(h){const i=[],s=new Map;for(const t of h.keys()){const n=h.get(t);if(!n||!(0,I.$Kb)(n.recommendations))continue;const r=[];d.$j?n.windowsPath&&r.push(n.windowsPath.replace("%USERPROFILE%",()=>u.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>u.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>u.env.ProgramFiles).replace("%APPDATA%",()=>u.env.APPDATA).replace("%WINDIR%",()=>u.env.WINDIR)):(r.push((0,R.$ic)("/usr/local/bin",t)),r.push((0,R.$ic)("/usr/bin",t)),r.push((0,R.$ic)(this.r.fsPath,t)));for(const a of r){let f=s.get(a);if(f===void 0&&(f=await this.b.exists(L.URI.file(a)),s.set(a,f)),f)for(const{extensionId:v,extensionName:C,isExtensionPack:b,whenNotInstalled:E}of n.recommendations)i.push({extensionId:v,extensionName:C,isExtensionPack:b,exeName:t,exeFriendlyName:n.exeFriendlyName,windowsPath:n.windowsPath,whenNotInstalled:E})}}return i}}e.$Ydc=m}),define(he[220],ue([0,1,27,7,23,15,74,57,16,18,219]),function(oe,e,I,c,A,L,N,O,k,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=void 0;let d=class extends R.$Ydc{constructor($,l,p,S,g,w,P,m){super($.userHome,g,l,p,S,w,P,m)}};e.$Lhc=d,e.$Lhc=d=ve([Q(0,L.$Ki),Q(1,y.$8l),Q(2,I.$kp),Q(3,k.$eq),Q(4,O.$Gfc),Q(5,N.$I6b),Q(6,c.$9k),Q(7,A.$pk)],d)}),define(he[49],ue([0,1,14,31,16]),function(oe,e,I,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=L;async function L(N,O,k){let y=k&&k.get("storage.serviceMachineId",A.StorageScope.APPLICATION)||null;if(y)return y;try{const d=(await O.readFile(N.serviceMachineIdResource)).value.toString();y=(0,c.$Xg)(d)?d:null}catch{y=null}if(!y){y=(0,c.$Yg)();try{await O.writeFile(N.serviceMachineIdResource,I.$Le.fromString(y))}catch{}}return k?.store("storage.serviceMachineId",y,A.StorageScope.APPLICATION,A.StorageTarget.MACHINE),y}}),define(he[221],ue([0,1,49,18,48]),function(oe,e,I,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=L;async function L(N,O,k,y,R,d,u){const $={"X-Market-Client-Id":`VSCode ${N}`,"User-Agent":`VSCode ${N} (${O.nameShort})`};if((0,A.$Ap)(O,k)&&(0,A.$Cp)(y)===c.TelemetryLevel.USAGE){const l=await(0,I.$kq)(k,R,d);$["X-Market-User-Id"]=l,$["VSCode-SessionId"]=u.machineId||l}return $}}),define(he[222],ue([0,1,17,25,8,5,37,12,9,21,15,27,34,33,59,7,10,23,61,221,16,18,54]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$,l,p,S,g,w,P,m,o,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=e.$nq=void 0,e.$mq=te;const i=L.$p?$.TargetPlatform.WEB:(0,d.$dp)(L.$v,N.$dc),s="X-Market-Search-Activity-Id";var t;(function(q){q[q.None=0]="None",q[q.IncludeVersions=1]="IncludeVersions",q[q.IncludeFiles=2]="IncludeFiles",q[q.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",q[q.IncludeSharedAccounts=8]="IncludeSharedAccounts",q[q.IncludeVersionProperties=16]="IncludeVersionProperties",q[q.ExcludeNonValidated=32]="ExcludeNonValidated",q[q.IncludeInstallationTargets=64]="IncludeInstallationTargets",q[q.IncludeAssetUri=128]="IncludeAssetUri",q[q.IncludeStatistics=256]="IncludeStatistics",q[q.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",q[q.Unpublished=4096]="Unpublished",q[q.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function n(...q){return String(q.reduce((M,Z)=>M|Z,0))}var r;(function(q){q[q.Tag=1]="Tag",q[q.ExtensionId=4]="ExtensionId",q[q.Category=5]="Category",q[q.ExtensionName=7]="ExtensionName",q[q.Target=8]="Target",q[q.Featured=9]="Featured",q[q.SearchText=10]="SearchText",q[q.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},f={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},C={pageNumber:1,pageSize:10,sortBy:d.SortBy.NoneOrRelevance,sortOrder:d.SortOrder.Default,flags:t.None,criteria:[],assetTypes:[]};class b{constructor(M=C){this.d=M}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(M,Z=this.d.pageSize){return new b({...this.d,pageNumber:M,pageSize:Z})}withFilter(M,...Z){const ee=[...this.d.criteria,...Z.length?Z.map(X=>({filterType:M,value:X})):[{filterType:M}]];return new b({...this.d,criteria:ee})}withSortBy(M){return new b({...this.d,sortBy:M})}withSortOrder(M){return new b({...this.d,sortOrder:M})}withFlags(...M){return new b({...this.d,flags:M.reduce((Z,ee)=>Z|ee,0)})}withAssetTypes(...M){return new b({...this.d,assetTypes:M})}withSource(M){return new b({...this.d,source:M})}get raw(){const{criteria:M,pageNumber:Z,pageSize:ee,sortBy:X,sortOrder:re,flags:le,assetTypes:ge}=this.d;return{filters:[{criteria:M,pageNumber:Z,pageSize:ee,sortBy:X,sortOrder:re}],assetTypes:ge,flags:le}}get searchText(){const M=this.d.criteria.filter(Z=>Z.filterType===r.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(M=>String(M.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function E(q,M){const Z=(q||[]).filter(ee=>ee.statisticName===M)[0];return Z?Z.value:0}function T(q){const M="Microsoft.VisualStudio.Code.Translation.";return q.files.filter(ee=>ee.assetType.indexOf(M)===0).reduce((ee,X)=>{const re=F(q,X.assetType);return re&&ee.push([X.assetType.substring(M.length),re]),ee},[])}function j(q){if(q.properties){const M=q.properties.filter(X=>X.key===a.Repository),Z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ee=M.filter(X=>Z.test(X.value))[0];return ee?{uri:ee.value,fallbackUri:ee.value}:null}return F(q,a.Repository)}function U(q){return{uri:`${q.fallbackAssetUri}/${a.VSIX}?redirect=true${q.targetPlatform?`&targetPlatform=${q.targetPlatform}`:""}`,fallbackUri:`${q.fallbackAssetUri}/${a.VSIX}${q.targetPlatform?`?targetPlatform=${q.targetPlatform}`:""}`}}function F(q,M){return q.files.filter(ee=>ee.assetType===M)[0]?{uri:`${q.assetUri}/${M}${q.targetPlatform?`?targetPlatform=${q.targetPlatform}`:""}`,fallbackUri:`${q.fallbackAssetUri}/${M}${q.targetPlatform?`?targetPlatform=${q.targetPlatform}`:""}`}:null}function K(q,M){const Z=q.properties?q.properties.filter(X=>X.key===M):[],ee=Z.length>0&&Z[0].value;return ee?ee.split(",").map(X=>(0,u.$Mp)(X)):[]}function W(q){const M=q.properties?q.properties.filter(Z=>Z.key===f.Engine):[];return M.length>0&&M[0].value||""}function x(q){const M=q.properties?q.properties.filter(Z=>Z.key===f.PreRelease):[];return M.length>0&&M[0].value==="true"}function G(q){const M=q.properties?q.properties.filter(ee=>ee.key===f.EnabledApiProposals):[],Z=M.length>0&&M[0].value||"";return Z?Z.split(","):[]}function ie(q){const M=q.properties?q.properties.filter(ee=>ee.key===f.LocalizedLanguages):[],Z=M.length>0&&M[0].value||"";return Z?Z.split(","):[]}function V(q){return q.properties?.find(M=>M.key===f.SponsorLink)?.value}function z(q){return q.properties?.find(M=>M.key===f.SupportLink)?.value}function _(q){return q.indexOf("preview")!==-1}function ne(q){return q.targetPlatform?(0,d.$cp)(q.targetPlatform):$.TargetPlatform.UNDEFINED}function ce(q){const M=(0,I.$Lb)(q.versions.map(ne)),Z=!!q.tags?.includes(d.$9o),ee=M.indexOf($.TargetPlatform.WEB);return Z?ee===-1&&M.push($.TargetPlatform.WEB):ee!==-1&&M.splice(ee,1),M}function te(q,M){for(let Z=0;Z<q.length;Z++){const ee=q[Z];if(ee.version===q[Z-1]?.version){let X=Z;if(ne(ee)===M)for(;X>0&&q[X-1].version===ee.version;)X--;X!==Z&&(q.splice(Z,1),q.splice(X,0,ee))}}return q}function Y(q,M,Z){q.telemetryData={index:M,querySource:Z,queryActivityId:q.queryContext?.[s]}}function H(q,M,Z,ee){const X=q.versions[0],re={manifest:F(M,a.Manifest),readme:F(M,a.Details),changelog:F(M,a.Changelog),license:F(M,a.License),repository:j(M),download:U(M),icon:F(M,a.Icon),signature:F(M,a.Signature),coreTranslations:T(M)};return{type:"gallery",identifier:{id:(0,u.$Np)(q.publisher.publisherName,q.extensionName),uuid:q.extensionId},name:q.extensionName,version:M.version,displayName:q.displayName,publisherId:q.publisher.publisherId,publisher:q.publisher.publisherName,publisherDisplayName:q.publisher.displayName,publisherDomain:q.publisher.domain?{link:q.publisher.domain,verified:!!q.publisher.isDomainVerified}:void 0,publisherSponsorLink:V(X),description:q.shortDescription??"",installCount:E(q.statistics,"install"),rating:E(q.statistics,"averagerating"),ratingCount:E(q.statistics,"ratingcount"),categories:q.categories||[],tags:q.tags||[],releaseDate:Date.parse(q.releaseDate),lastUpdated:Date.parse(q.lastUpdated),allTargetPlatforms:Z,assets:re,properties:{dependencies:K(M,f.Dependency),extensionPack:K(M,f.ExtensionPack),engine:W(M),enabledApiProposals:G(M),localizedLanguages:ie(M),targetPlatform:ne(M),isPreReleaseVersion:x(M)},hasPreReleaseVersion:x(X),hasReleaseVersion:!0,preview:_(q.flags),isSigned:!!re.signature,queryContext:ee,supportLink:z(X)}}let B=class{constructor(M,Z,ee,X,re,le,ge,pe){this.l=Z,this.n=ee,this.o=X,this.q=re,this.u=le,this.w=ge,this.x=pe;const Ee=ge.extensionsGallery,we=Ee?.servicePPEUrl&&pe.getValue("_extensionsGallery.enablePPE");this.d=we?Ee.servicePPEUrl:Ee?.serviceUrl,this.g=we?void 0:Ee?.searchUrl,this.h=Ee?.controlUrl,this.k=ge.extensionsEnabledWithApiProposalVersion?.map(be=>be.toLowerCase())??[],this.j=(0,P.$lq)(ge.version,ge,this.o,this.x,this.u,M,this.q)}y(M=""){return`${this.d}${M}`}isEnabled(){return!!this.d}async getExtensions(M,Z,ee){const X=c.CancellationToken.isCancellationToken(Z)?{}:Z,re=c.CancellationToken.isCancellationToken(Z)?Z:ee,le=[],ge=[],pe=[],Ee=[];let we=!0;for(const Ie of M){Ie.uuid?ge.push(Ie.uuid):le.push(Ie.id);const ae=!!(Ie.version||Ie.preRelease);pe.push({id:Ie.id,uuid:Ie.uuid,includePreRelease:ae}),Ie.version&&Ee.push({id:Ie.id,uuid:Ie.uuid,version:Ie.version}),we=we&&!!Ie.hasPreRelease&&!ae}if(!ge.length&&!le.length)return[];let be=new b().withPage(1,M.length);ge.length&&(be=be.withFilter(r.ExtensionId,...ge)),le.length&&(be=be.withFilter(r.ExtensionName,...le)),(X.queryAllVersions||we)&&(be=be.withFlags(be.flags,t.IncludeVersions)),X.source&&(be=be.withSource(X.source));const{extensions:Se}=await this.B(be,{targetPlatform:X.targetPlatform??i,includePreRelease:pe,versions:Ee,compatible:!!X.compatible,productVersion:X.productVersion??{version:this.w.version,date:this.w.date}},re);return X.source&&Se.forEach((Ie,ae)=>Y(Ie,ae,X.source)),Se}async getCompatibleExtension(M,Z,ee,X={version:this.w.version,date:this.w.date}){if((0,d.$ep)(M.allTargetPlatforms,ee))return null;if(await this.isExtensionCompatible(M,Z,ee))return M;const re=new b().withFlags(t.IncludeVersions).withPage(1,1).withFilter(r.ExtensionId,M.identifier.uuid),{extensions:le}=await this.B(re,{targetPlatform:ee,compatible:!0,includePreRelease:Z,productVersion:X},c.CancellationToken.None);return le[0]||null}async isExtensionCompatible(M,Z,ee,X={version:this.w.version,date:this.w.date}){if(!(0,d.$fp)(M.properties.targetPlatform,M.allTargetPlatforms,ee)||!Z&&M.properties.isPreReleaseVersion)return!1;let re=M.properties.engine;if(!re){const le=await this.getManifest(M,c.CancellationToken.None);if(!le)throw new Error("Manifest was not found");re=le.engines.vscode}return!(!(0,l.$2p)(re,X.version,X.date)||!this.z(M.identifier,M.properties.enabledApiProposals))}z(M,Z){return!Z||!this.k.includes(M.id.toLowerCase())?!0:(0,l.$3p)(Z)}async A(M,Z,ee,X,re,le,ge={version:this.w.version,date:this.w.date}){if(!(0,d.$fp)(ne(Z),re,le)||ee!=="any"&&x(Z)!==(ee==="prerelease"))return!1;if(X)try{const pe=await this.G(M,Z);if(!(0,l.$2p)(pe,ge.version,ge.date))return!1}catch(pe){return this.n.error(`Error while getting the engine for the version ${Z.version}.`,(0,A.$9)(pe)),!1}return!0}async query(M,Z){let ee=M.text||"";const X=M.pageSize??50;let re=new b().withPage(1,X);ee?(ee=ee.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(we,be,Se)=>(re=re.withFilter(r.Category,Se||be),"")),ee=ee.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(we,be,Se)=>(re=re.withFilter(r.Tag,Se||be),"")),ee=ee.replace(/\bfeatured(\s+|\b|$)/g,()=>(re=re.withFilter(r.Featured),"")),ee=ee.trim(),ee&&(ee=ee.length<200?ee:ee.substring(0,200),re=re.withFilter(r.SearchText,ee)),re=re.withSortBy(d.SortBy.NoneOrRelevance)):M.ids?re=re.withFilter(r.ExtensionId,...M.ids):M.names?re=re.withFilter(r.ExtensionName,...M.names):re=re.withSortBy(d.SortBy.InstallCount),typeof M.sortBy=="number"&&(re=re.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(re=re.withSortOrder(M.sortOrder)),M.source&&(re=re.withSource(M.source));const le=async(we,be)=>{const{extensions:Se,total:Ie}=await this.B(we,{targetPlatform:i,compatible:!1,includePreRelease:!!M.includePreRelease,productVersion:M.productVersion??{version:this.w.version,date:this.w.date}},be);return Se.forEach((ae,de)=>Y(ae,(we.pageNumber-1)*we.pageSize+de,M.source)),{extensions:Se,total:Ie}},{extensions:ge,total:pe}=await le(re,Z),Ee=async(we,be)=>{if(be.isCancellationRequested)throw new A.$4;const{extensions:Se}=await le(re.withPage(we+1),be);return Se};return{firstPage:ge,total:pe,pageSize:re.pageSize,getPage:Ee}}async B(M,Z,ee){const X=M.flags;M.flags&t.IncludeLatestVersionOnly&&M.flags&t.IncludeVersions&&(M=M.withFlags(M.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(M.flags&t.IncludeLatestVersionOnly)&&!(M.flags&t.IncludeVersions)&&(M=M.withFlags(M.flags,t.IncludeLatestVersionOnly)),Z.versions?.length&&(M=M.withFlags(M.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),M=M.withFlags(M.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:re,total:le,context:ge}=await this.D(M,ee);if(!(M.flags&t.IncludeLatestVersionOnly)){const be=[];for(const Se of re){const Ie=await this.C(Se,Z,ge);Ie&&be.push(Ie)}return{extensions:be,total:le}}const Ee=[],we=new Map;for(let be=0;be<re.length;be++){const Se=re[be],Ie={id:(0,u.$Np)(Se.publisher.publisherName,Se.extensionName),uuid:Se.extensionId},ae=(0,O.$ig)(Z.includePreRelease)?Z.includePreRelease:!!Z.includePreRelease.find(me=>(0,u.$Ip)(me,Ie))?.includePreRelease;if(Z.compatible&&(0,d.$ep)(ce(Se),Z.targetPlatform))continue;const de=await this.C(Se,Z,ge);!de||de.properties.isPreReleaseVersion&&(!ae||!de.hasReleaseVersion)||!de.properties.isPreReleaseVersion&&de.properties.targetPlatform!==Z.targetPlatform&&de.hasPreReleaseVersion?we.set(Se.extensionId,be):Ee.push([be,de])}if(we.size){const be=new h.$de,Se=new b().withFlags(X&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,we.size).withFilter(r.ExtensionId,...we.keys()),{extensions:Ie}=await this.B(Se,Z,ee);this.q.publicLog2("galleryService:additionalQuery",{duration:be.elapsed(),count:we.size});for(const ae of Ie){const de=we.get(ae.identifier.uuid);Ee.push([de,ae])}}return{extensions:Ee.sort((be,Se)=>be[0]-Se[0]).map(([,be])=>be),total:le}}async C(M,Z,ee){const X={id:(0,u.$Np)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},re=Z.versions?.find(Ee=>(0,u.$Ip)(Ee,X))?.version,le=(0,O.$ig)(Z.includePreRelease)?Z.includePreRelease:!!Z.includePreRelease.find(Ee=>(0,u.$Ip)(Ee,X))?.includePreRelease,ge=ce(M),pe=te(M.versions,Z.targetPlatform);if(Z.compatible&&(0,d.$ep)(ge,Z.targetPlatform))return null;for(let Ee=0;Ee<pe.length;Ee++){const we=pe[Ee];if(!(re&&we.version!==re)){if(await this.A(X.id,we,le?"any":"release",Z.compatible,ge,Z.targetPlatform,Z.productVersion))return Z.compatible&&!this.z(X,G(we))?null:H(M,we,ge,ee);if(re&&we.version===re)return null}}return re||Z.compatible?null:H(M,M.versions[0],ge)}async D(M,Z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,t.ExcludeNonValidated).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExcludeWithFlags,n(t.Unpublished));const ee=await this.j,X=JSON.stringify(M.raw),re={...ee,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(X.length)},le=new h.$de;let ge,pe,Ee=0;try{if(ge=await this.l.request({type:"POST",url:this.g&&M.criteria.some(be=>be.filterType===r.SearchText)?this.g:this.y("/extensionquery"),data:X,headers:re},Z),ge.res.statusCode&&ge.res.statusCode>=400&&ge.res.statusCode<500)return{galleryExtensions:[],total:Ee};const we=await(0,w.$0p)(ge);if(we){const be=we.results[0],Se=be.extensions,Ie=be.resultMetadata&&be.resultMetadata.filter(ae=>ae.metadataType==="ResultCount")[0];return Ee=Ie&&Ie.metadataItems.filter(ae=>ae.name==="TotalCount")[0].count||0,{galleryExtensions:Se,total:Ee,context:{[s]:ge.res.headers.activityid}}}return{galleryExtensions:[],total:Ee}}catch(we){if((0,A.$3)(we))throw pe=d.ExtensionGalleryErrorCode.Cancelled,we;{const be=(0,A.$9)(we);throw pe=be.startsWith("XHR timeout")?d.ExtensionGalleryErrorCode.Timeout:d.ExtensionGalleryErrorCode.Failed,new d.$ip(be,pe)}}finally{this.q.publicLog2("galleryService:query",{...M.telemetryData,requestBodySize:String(X.length),duration:le.elapsed(),success:!!ge&&(0,w.$6p)(ge),responseBodySize:ge?.res.headers["Content-Length"],statusCode:ge?String(ge.res.statusCode):void 0,errorCode:pe,count:String(Ee)})}}async reportStatistic(M,Z,ee,X){if(!this.isEnabled())return;const re=L.$p?this.y(`/itemName/${M}.${Z}/version/${ee}/statType/${X===d.StatisticType.Install?"1":"3"}/vscodewebextension`):this.y(`/publishers/${M}/extensions/${Z}/${ee}/stats?statType=${X}`),le=L.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.j,Accept:le};try{await this.l.request({type:"POST",url:re,headers:pe},c.CancellationToken.None)}catch{}}async download(M,Z,ee){this.n.trace("ExtensionGalleryService#download",M.identifier.id);const X=(0,u.$Qp)(M),re=new Date().getTime(),le=ee===d.InstallOperation.Install?"install":ee===d.InstallOperation.Update?"update":"",ge=le?{uri:`${M.assets.download.uri}${k.URI.parse(M.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${M.assets.download.fallbackUri}${k.URI.parse(M.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:M.assets.download,pe=M.queryContext?.[s]?{[s]:M.queryContext[s]}:void 0,Ee=await this.F(M.identifier.id,ge,a.VSIX,pe?{headers:pe}:void 0);try{await this.u.writeFile(Z,Ee.stream)}catch(we){try{await this.u.del(Z)}catch(be){this.n.warn(`Error while deleting the file ${Z.toString()}`,(0,A.$9)(be))}throw new d.$ip((0,A.$9)(we),d.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.q.publicLog("galleryService:downloadVSIX",{...X,duration:new Date().getTime()-re})}async downloadSignatureArchive(M,Z){if(!M.assets.signature)throw new Error("No signature asset found");this.n.trace("ExtensionGalleryService#downloadSignatureArchive",M.identifier.id);const ee=await this.F(M.identifier.id,M.assets.signature,a.Signature);try{await this.u.writeFile(Z,ee.stream)}catch(X){try{await this.u.del(Z)}catch(re){this.n.warn(`Error while deleting the file ${Z.toString()}`,(0,A.$9)(re))}throw new d.$ip((0,A.$9)(X),d.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(M,Z){if(M.assets.readme){const ee=await this.F(M.identifier.id,M.assets.readme,a.Details,{},Z);return await(0,w.$9p)(ee)||""}return""}async getManifest(M,Z){if(M.assets.manifest){const ee=await this.F(M.identifier.id,M.assets.manifest,a.Manifest,{},Z),X=await(0,w.$9p)(ee);return X?JSON.parse(X):null}return null}async E(M,Z,ee){const X=F(Z,a.Manifest);if(!X)throw new Error("Manifest was not found");const re={"Accept-Encoding":"gzip"},le=await this.F(M,X,a.Manifest,{headers:re});return await(0,w.$0p)(le)}async getCoreTranslation(M,Z){const ee=M.assets.coreTranslations.filter(X=>X[0]===Z.toUpperCase())[0];if(ee){const X=await this.F(M.identifier.id,ee[1],ee[0]),re=await(0,w.$9p)(X);return re?JSON.parse(re):null}return null}async getChangelog(M,Z){if(M.assets.changelog){const ee=await this.F(M.identifier.id,M.assets.changelog,a.Changelog,{},Z);return await(0,w.$9p)(ee)||""}return""}async getAllCompatibleVersions(M,Z,ee){let X=new b().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);M.uuid?X=X.withFilter(r.ExtensionId,M.uuid):X=X.withFilter(r.ExtensionName,M.id);const{galleryExtensions:re}=await this.D(X,c.CancellationToken.None);if(!re.length)return[];const le=ce(re[0]);if((0,d.$ep)(le,ee))return[];const ge=[];await Promise.all(re[0].versions.map(async we=>{try{await this.A(M.id,we,Z?"any":"release",!0,le,ee)&&this.z(M,G(we))&&ge.push(we)}catch{}}));const pe=[],Ee=new Set;for(const we of te(ge,ee))Ee.has(we.version)||(Ee.add(we.version),pe.push({version:we.version,date:we.lastUpdated,isPreReleaseVersion:x(we)}));return pe}async F(M,Z,ee,X={},re=c.CancellationToken.None){const le=await this.j,ge={type:"GET"},pe={...le,...X.headers||{}};X={...X,...ge,headers:pe};const Ee=Z.uri,we=Z.fallbackUri,be={...X,url:Ee};try{const Se=await this.l.request(be,re);if(Se.res.statusCode===200)return Se;const Ie=await(0,w.$9p)(Se);throw new Error(`Expected 200, got back ${Se.res.statusCode} instead.

${Ie}`)}catch(Se){if((0,A.$3)(Se))throw Se;const Ie=(0,A.$9)(Se);this.q.publicLog2("galleryService:cdnFallback",{extension:M,assetType:ee,message:Ie});const ae={...X,url:we};return this.l.request(ae,re)}}async G(M,Z){let ee=W(Z);if(!ee){this.q.publicLog2("galleryService:engineFallback",{extension:M,version:Z.version});const X=await this.E(M,Z,c.CancellationToken.None);if(!X)throw new Error("Manifest was not found");ee=X.engines.vscode}return ee}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const M=await this.l.request({type:"GET",url:this.h},c.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const Z=await(0,w.$0p)(M),ee=[],X={},re=[],le=[];if(Z){for(const ge of Z.malicious)ee.push({id:ge});if(Z.migrateToPreRelease)for(const[ge,pe]of Object.entries(Z.migrateToPreRelease))(!pe.engine||(0,l.$2p)(pe.engine,this.w.version,this.w.date))&&(X[ge.toLowerCase()]={disallowInstall:!0,extension:{id:pe.id,displayName:pe.displayName,autoMigrate:{storage:!!pe.migrateStorage},preRelease:!0}});if(Z.deprecated)for(const[ge,pe]of Object.entries(Z.deprecated))pe&&(X[ge.toLowerCase()]=(0,O.$ig)(pe)?{}:pe);if(Z.search)for(const ge of Z.search)re.push(ge);if(Array.isArray(Z.extensionsEnabledWithPreRelease))for(const ge of Z.extensionsEnabledWithPreRelease)le.push(ge.toLowerCase())}return{malicious:ee,deprecated:X,search:re,extensionsEnabledWithPreRelease:le}}};B=ve([Q(1,w.$4p),Q(2,S.$9j),Q(3,R.$Ji),Q(4,o.$8l),Q(5,p.$9k),Q(6,g.$pk),Q(7,y.$9i)],B);let D=class extends B{constructor(M,Z,ee,X,re,le,ge,pe){super(M,Z,ee,X,re,le,ge,pe)}};e.$nq=D,e.$nq=D=ve([Q(0,m.$eq),Q(1,w.$4p),Q(2,S.$9j),Q(3,R.$Ji),Q(4,o.$8l),Q(5,p.$9k),Q(6,g.$pk),Q(7,y.$9i)],D);let J=class extends B{constructor(M,Z,ee,X,re,le,ge){super(void 0,M,Z,ee,X,re,le,ge)}};e.$oq=J,e.$oq=J=ve([Q(0,w.$4p),Q(1,S.$9j),Q(2,R.$Ji),Q(3,o.$8l),Q(4,p.$9k),Q(5,g.$pk),Q(6,y.$9i)],J)}),define(he[223],ue([0,1,107,3,18,15,2,10,13,68,23,5,6,101,21,11,38,16,12,142,20]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$,l,p,S,g,w,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hhc=void 0;const o=[I.$Ahc,I.$Bhc],h="remoteTunnelSession",i="remoteTunnelIsService";let s=class extends N.$Tc{constructor(a,f,v,C,b,E,T){super(),this.y=a,this.z=f,this.C=v,this.D=E,this.F=T,this.f=new c.$je,this.onDidTokenFailed=this.f.event,this.g=new c.$je,this.onDidChangeTunnelStatus=this.g.event,this.h=new c.$je,this.onDidChangeMode=this.h.event,this.n=I.$yhc,this.w=!1,this.I=(j,U)=>{U?this.j.error(j):this.j.info(j)},this.j=this.B(C.createLogger((0,m.$dh)(v.logsHome,`${I.$Chc}.log`),{id:I.$Chc,name:I.$Dhc})),this.t=new u.$zh(100),this.B(this.j.onDidChangeLogLevel(j=>this.j.info("Log level changed to "+(0,O.$lk)(j)))),this.B(b.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(E.onDidChangeConfiguration(j=>{o.some(U=>j.affectsConfiguration(U))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=I.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(a){this.s=a,this.g.fire(a)}H(a){n(this.n,a)||(this.n=a,this.S(a),this.h.fire(this.n),a.active?(this.j.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this.j.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(a){if(this.w)return this.s;this.w=!0,this.H(a);try{await this.t.trigger(()=>this.L())}catch(f){this.j.error(f)}return this.s}J(){if(!this.u){let a;d.$k?a=this.C.appRoot:a=(0,k.$lc)((0,k.$lc)(this.C.appRoot)),this.u=(0,k.$ic)(a,"bin",`${this.z.tunnelApplicationName}${d.$j?".exe":""}`)}return this.u}async startTunnel(a){if(n(this.n,a)&&this.s.type!=="disconnected")return this.s;this.H(a);try{await this.t.trigger(()=>this.L())}catch(f){this.j.error(f)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const a=this.n.asService;this.H(I.$yhc);try{a&&this.O("uninstallService",["service","uninstall"])}catch(f){this.j.error(f)}}try{await this.O("stop",["kill"])}catch(a){this.j.error(a)}this.G(I.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let a="",f=!1;const v=(U,F)=>{F?this.j.error(U):a+=U,!this.C.isBuilt&&U.startsWith("   Compiling")&&this.G(I.TunnelStates.connecting((0,p.localize)(11067,null)))},C=this.O("status",["status"],v);this.r=C;try{if(await C,this.r!==C)return;let U;try{U=JSON.parse(a.trim().split(`
`).find(F=>F.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(a.trim())}`),this.G(I.TunnelStates.disconnected());return}if(f=U.service_installed,this.j.info(U.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!U.tunnel&&!this.n.active){this.G(I.TunnelStates.disconnected());return}}catch(U){this.j.error(U),this.G(I.TunnelStates.disconnected());return}finally{this.r===C&&(this.r=void 0)}const b=this.n.active?this.n.session:void 0;if(b&&b.token){const U=b.token;this.G(I.TunnelStates.connecting((0,p.localize)(11068,null,b.accountLabel,b.providerId)));const F=(W,x)=>{W=W.replaceAll(U,"*".repeat(4)),v(W,x)},K=this.O("login",["user","login","--provider",b.providerId,"--log",(0,O.$lk)(this.j.getLevel())],F,{VSCODE_CLI_ACCESS_TOKEN:U});this.r=K;try{if(await K,this.r!==K)return}catch(W){this.j.error(W),this.r=void 0,this.f.fire(b),this.G(I.TunnelStates.disconnected(b));return}}const E=this.Q();E?this.G(I.TunnelStates.connecting((0,p.localize)(11069,null,E))):this.G(I.TunnelStates.connecting((0,p.localize)(11070,null)));const T=["--accept-server-license-terms","--log",(0,O.$lk)(this.j.getLevel())];E?T.push("--name",E):T.push("--random-name");let j=!1;return this.n.active&&this.n.asService&&!f&&(j=await this.M(T)===!1),this.N(b,T,j)}async M(a){let f;try{f=await this.O("serviceInstall",["service","install",...a])}catch(v){this.j.error(v),f=1}if(f!==0){const v=(0,p.localize)(11071,null);return this.j.warn(v),this.G(I.TunnelStates.connecting(v)),!1}return!0}async N(a,f,v){f.push("--parent-process-id",String(process.pid)),this.P()&&f.push("--no-sleep");let C=!1;const b=this.O("tunnel",f,(E,T)=>{T?this.j.error(E):this.j.info(E),E.includes("Connected to an existing tunnel process")&&(C=!0);const j=E.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(j){const U={link:j[1],domain:j[2],tunnelName:j[4],isAttached:C};this.G(I.TunnelStates.connected(U,v))}else E.match(/error refreshing token/)&&(b.cancel(),this.f.fire(a),this.G(I.TunnelStates.disconnected(a)))});this.r=b,b.finally(()=>{b===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=I.$yhc,this.G(I.TunnelStates.disconnected()))})}O(a,f,v=this.I,C){return(0,u.$ph)(b=>new Promise((E,T)=>{b.isCancellationRequested&&E(-1);let j;const U=["ignore","pipe","pipe"];if(b.onCancellationRequested(()=>{j&&(this.j.info(`${a} terminating(${j.pid})`),j.kill())}),!this.C.isBuilt)v(`Building tunnel CLI from sources and run
`,!1),v(`${a} Spawning: cargo run -- tunnel ${f.join(" ")}
`,!1),j=(0,y.spawn)("cargo",["run","--","tunnel",...f],{cwd:(0,k.$ic)(this.C.appRoot,"cli"),stdio:U,env:{...process.env,RUST_BACKTRACE:"1",...C}});else{v(`Running tunnel CLI
`,!1);const F=this.J();v(`${a} Spawning: ${F} tunnel ${f.join(" ")}
`,!1),j=(0,y.spawn)(F,["tunnel",...f],{cwd:(0,S.homedir)(),stdio:U,env:{...process.env,...C}})}j.stdout.pipe(new P.$rX(`
`)).on("data",F=>{if(j){const K=F.toString();v(K,!1)}}),j.stderr.pipe(new P.$rX(`
`)).on("data",F=>{if(j){const K=F.toString();v(K,!0)}}),j.on("exit",F=>{j&&(v(`${a} exit(${j.pid}): + ${F} `,!1),j=void 0,E(F||0))}),j.on("error",F=>{j&&(v(`${a} error(${j.pid}): + ${F} `,!0),j=void 0,T())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(I.$Bhc)}Q(){let a=this.D.getValue(I.$Ahc)||(0,S.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}R(){try{const a=this.F.get(h,g.StorageScope.APPLICATION),f=this.F.getBoolean(i,g.StorageScope.APPLICATION,!1);if(a){const v=JSON.parse(a);if(v&&(0,w.$cg)(v.accountLabel)&&(0,w.$cg)(v.sessionId)&&(0,w.$cg)(v.providerId))return{active:!0,session:v,asService:f};this.j.error("Problems restoring session from storage, invalid format",v)}}catch(a){this.j.error("Problems restoring session from storage",a)}return I.$yhc}S(a){if(a.active){const f={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.F.store(h,JSON.stringify(f),g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),this.F.store(i,a.asService,g.StorageScope.APPLICATION,g.StorageTarget.MACHINE)}else this.F.remove(h,g.StorageScope.APPLICATION),this.F.remove(i,g.StorageScope.APPLICATION)}};e.$Hhc=s,e.$Hhc=s=ve([Q(0,A.$8l),Q(1,R.$pk),Q(2,L.$Ki),Q(3,O.$0j),Q(4,$.$Fhc),Q(5,l.$9i),Q(6,g.$eq)],s);function t(r,a){return r&&a?r.sessionId===a.sessionId&&r.providerId===a.providerId&&r.token===a.token:r===a}const n=(r,a)=>r.active!==a.active?!1:r.active&&a.active?r.asService===a.asService&&t(r.session,a.session):!0}),define(he[224],ue([0,1,6,2,22,20,70,16,79,19]),function(oe,e,I,c,A,L,N,O,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mhc=void 0;class R extends O.$gq{constructor(u,$,l,p){super(),this.bb=u,this.cb=$,this.db=l,this.eb=p,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new c.$Sc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new c.$Sc),this.ab=this.hb(this.bb)}fb(){const u=this.B(new k.$HMb(this.db.getChannel("storage"))),$=this.B(new N.$aq(u));return this.B($.onDidChangeStorage(l=>this.u(O.StorageScope.APPLICATION,l))),$}gb(u){this.X.clear(),this.W=u;let $;if((0,O.$hq)(u))$=this.U;else{const l=this.X.add(new k.$IMb(this.db.getChannel("storage"),u));$=this.X.add(new N.$aq(l))}return this.X.add($.onDidChangeStorage(l=>this.u(O.StorageScope.PROFILE,l))),$}hb(u){this.$.clear(),this.Z=u?.id;let $;if(u){const l=this.$.add(new k.$JMb(this.db.getChannel("storage"),u));$=this.$.add(new N.$aq(l)),this.$.add($.onDidChangeStorage(p=>this.u(O.StorageScope.WORKSPACE,p)))}return $}async O(){await I.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(u){switch(u){case O.StorageScope.APPLICATION:return this.U;case O.StorageScope.PROFILE:return this.Y;default:return this.ab}}Q(u){switch(u){case O.StorageScope.APPLICATION:return this.s.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;case O.StorageScope.PROFILE:return this.W?.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;default:return this.Z?`${(0,L.$dh)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:A.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(O.WillSaveStateReason.SHUTDOWN),await I.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(u){if(!this.M(this.W,u))return;const $=this.Y,l=$.items;$!==this.U&&await $.close(),this.Y=this.gb(u),await this.Y.init(),this.N(l,this.Y,O.StorageScope.PROFILE)}async S(u,$){const l=this.ab,p=l?.items??new Map;await l?.close(),this.ab=this.hb(u),await this.ab.init(),this.N(p,this.ab,O.StorageScope.WORKSPACE)}hasScope(u){return(0,y.$Hl)(u)?this.W.id===u.id:this.Z===u.id}}e.$Mhc=R}),define(he[225],ue([0,1,3,2,19,94]),function(oe,e,I,c,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vR=e.$uR=void 0;class N{constructor(y,R){this.a=y,this.b=R}listen(y,R){const d=this.b(y);switch(R){case"onDidChangeProfiles":return I.Event.map(this.a.onDidChangeProfiles,u=>({all:u.all.map($=>(0,L.$Kn)({...$},d)),added:u.added.map($=>(0,L.$Kn)({...$},d)),removed:u.removed.map($=>(0,L.$Kn)({...$},d)),updated:u.updated.map($=>(0,L.$Kn)({...$},d))}))}throw new Error(`Invalid listen ${R}`)}async call(y,R,d){const u=this.b(y);switch(R){case"createProfile":{const $=await this.a.createProfile(d[0],d[1],d[2]);return(0,L.$Kn)({...$},u)}case"updateProfile":{let $=(0,A.$Jl)((0,L.$Ln)(d[0],u),this.a.profilesHome.scheme);return $=await this.a.updateProfile($,d[1]),(0,L.$Kn)({...$},u)}case"removeProfile":{const $=(0,A.$Jl)((0,L.$Ln)(d[0],u),this.a.profilesHome.scheme);return this.a.removeProfile($)}}throw new Error(`Invalid call ${R}`)}}e.$uR=N;class O extends c.$Tc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(y,R,d){super(),this.profilesHome=R,this.f=d,this.a=[],this.b=this.B(new I.$je),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=y.map(u=>(0,A.$Jl)(u,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(u=>{const $=u.added.map(S=>(0,A.$Jl)(S,this.profilesHome.scheme)),l=u.removed.map(S=>(0,A.$Jl)(S,this.profilesHome.scheme)),p=u.updated.map(S=>(0,A.$Jl)(S,this.profilesHome.scheme));this.a=u.all.map(S=>(0,A.$Jl)(S,this.profilesHome.scheme)),this.b.fire({added:$,removed:l,updated:p,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(y){this.c=y}isEnabled(){return this.c}async createNamedProfile(y,R,d){const u=await this.f.call("createNamedProfile",[y,R,d]);return(0,A.$Jl)(u,this.profilesHome.scheme)}async createProfile(y,R,d,u){const $=await this.f.call("createProfile",[y,R,d,u]);return(0,A.$Jl)($,this.profilesHome.scheme)}async createTransientProfile(y){const R=await this.f.call("createTransientProfile",[y]);return(0,A.$Jl)(R,this.profilesHome.scheme)}async setProfileForWorkspace(y,R){await this.f.call("setProfileForWorkspace",[y,R])}removeProfile(y){return this.f.call("removeProfile",[y])}async updateProfile(y,R){const d=await this.f.call("updateProfile",[y,R]);return(0,A.$Jl)(d,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$vR=O}),define(he[62],ue([0,1,2,70,4,16,3,79,19]),function(oe,e,I,c,A,L,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NMb=e.$MMb=e.$LMb=void 0,e.$LMb=(0,A.$Ci)("IUserDataProfileStorageService");let y=class extends I.$Tc{constructor($,l){super(),this.b=l,$&&(this.a=this.B(new I.$3c))}async readStorageData($){return this.withProfileScopedStorageService($,async l=>this.c(l))}async updateStorageData($,l,p){return this.withProfileScopedStorageService($,async S=>this.f(S,l,p))}async withProfileScopedStorageService($,l){if(this.b.hasScope($))return l(this.b);let p=this.a?.get($.id);if(!p){p=new d(this.g($)),this.a?.set($.id,p);try{await p.initialize()}catch(S){throw this.a?.has($.id)?this.a.deleteAndDispose($.id):p.dispose(),S}}try{const S=await l(p);return await p.flush(),S}finally{this.a?.has($.id)||p.dispose()}}c($){const l=new Map,p=S=>{for(const g of $.keys(L.StorageScope.PROFILE,S))l.set(g,{value:$.get(g,L.StorageScope.PROFILE),target:S})};return p(L.StorageTarget.USER),p(L.StorageTarget.MACHINE),l}f($,l,p){$.storeAll(Array.from(l.entries()).map(([S,g])=>({key:S,value:g,scope:L.StorageScope.PROFILE,target:p})),!0)}};e.$MMb=y,e.$MMb=y=ve([Q(1,L.$eq)],y);class R extends y{constructor($,l,p,S,g){super($,S),this.j=l;const w=l.getChannel("profileStorageListener"),P=this.B(new I.$Uc);this.h=this.B(new N.$je({onWillAddFirstListener:()=>{P.value=w.listen("onDidChange")(m=>{g.trace("profile storage changes",m),this.h.fire({targetChanges:m.targetChanges.map(o=>(0,k.$Jl)(o,p.profilesHome.scheme)),valueChanges:m.valueChanges.map(o=>({...o,profile:(0,k.$Jl)(o.profile,p.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>P.value=void 0})),this.onDidChange=this.h.event}async g($){const l=this.j.getChannel("storage");return(0,L.$hq)($)?new O.$HMb(l):new O.$IMb(l,$)}}e.$NMb=R;class d extends L.$gq{constructor($){super({flushInterval:100}),this.U=$}async O(){const $=await this.U,l=new c.$aq($);return this.B(l.onDidChangeStorage(p=>{this.u(L.StorageScope.PROFILE,p)})),this.B((0,I.$Rc)(()=>{l.close(),l.dispose(),(0,I.$Nc)($)&&$.dispose()})),this.s=l,this.s.init()}P($){return $===L.StorageScope.PROFILE?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(he[226],ue([0,1,16,10,19,56,62]),function(oe,e,I,c,A,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rhc=void 0;let O=class extends N.$NMb{constructor(y,R,d,u){super(!0,y,R,d,u)}};e.$rhc=O,e.$rhc=O=ve([Q(0,L.$Ygc),Q(1,A.$Il),Q(2,I.$eq),Q(3,c.$9j)],O)}),define(he[40],ue([0,1,17,6,14,25,3,35,2,26,12,11,21,15,7,10,49,16,18,28,24,19]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$,l,p,S,g,w,P,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UNb=e.$TNb=e.$SNb=e.$RNb=void 0,e.$ONb=h,e.$PNb=i,e.$QNb=s;function h(f){return!!(f&&f.ref!==void 0&&typeof f.ref=="string"&&f.ref!==""&&f.syncData!==void 0&&(f.syncData===null||i(f.syncData)))}function i(f){return!!(f&&f.version!==void 0&&typeof f.version=="number"&&f.content!==void 0&&typeof f.content=="string"&&(Object.keys(f).length===2||Object.keys(f).length===3&&f.machineId!==void 0&&typeof f.machineId=="string"))}function s(f,v){return`${(0,y.$7f)(f)}${v.isDefault?"":` (${v.name})`}`}let t=class extends k.$Tc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(v,C,b,E,T,j,U,F,K,W,x,G){super(),this.syncResource=v,this.collection=C,this.G=b,this.H=E,this.I=T,this.J=j,this.L=U,this.M=F,this.N=K,this.O=W,this.P=x,this.c=null,this.m=m.SyncStatus.Idle,this.n=this.B(new N.$je),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new N.$je),this.onDidChangeConflicts=this.t.event,this.u=this.B(new c.$Ah(50)),this.w=this.B(new N.$je),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=s(v.syncResource,v.profile),this.h=G.extUri,this.f=this.h.joinPath(E.userDataSyncHome,...(0,m.$knb)(v.profile.isDefault?void 0:v.profile.id,v.syncResource)),this.g=this.h.joinPath(this.f,m.$Fnb),this.y=(0,m.$lnb)(v.profile.isDefault?void 0:v.profile.id,v.syncResource,E,this.h),this.j=(0,S.$kq)(E,b,T)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status===m.SyncStatus.HasConflicts){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const v=await this.c;this.c=null;const C=await this.Y(v.remoteUserData,v.lastSyncUserData,!0,this.ob());this.S(C)}else{this.O.trace(`${this.D}: Checking for local changes...`);const v=await this.getLastSyncUserData();(v?await this.ub(v):!0)&&this.w.fire()}}S(v){this.m!==v&&(this.m=v,this.n.fire(v))}async sync(v,C={}){await this.U(v,!0,this.ob(),C)}async preview(v,C,b={}){return this.U(v,!1,C,b)}async apply(v,C={}){try{this.F={...C};const b=await this.ab(v);return this.S(b),this.c}finally{this.F={}}}async U(v,C,b,E){try{if(this.F={...E},this.status===m.SyncStatus.HasConflicts)return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status===m.SyncStatus.Syncing)return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S(m.SyncStatus.Syncing);let T=m.SyncStatus.Idle;try{const j=await this.getLastSyncUserData(),U=await this.X(v,j);return T=await this.Y(U,j,C,b),T===m.SyncStatus.HasConflicts?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):T===m.SyncStatus.Idle&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(T)}}finally{this.F={}}}async replace(v){const C=this.kb(v);if(!C)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S(m.SyncStatus.Syncing);const b=await this.getLastSyncUserData(),E=await this.X(null,b),T=await this.W(E),j=await this.qb({ref:E.ref,syncData:C},b,T,this.ob(),L.CancellationToken.None),U=[];for(const F of j){const K=await this.sb(F,F.remoteResource,void 0,L.CancellationToken.None),{remoteChange:W}=await this.sb(F,F.previewResource,F.remoteContent,L.CancellationToken.None);U.push([F,{...K,remoteChange:W!==m.Change.None?W:m.Change.Modified}])}await this.tb(E,b,U,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S(m.SyncStatus.Idle)}return!0}async W(v){const C=await this.j;return!!v.syncData?.machineId&&v.syncData.machineId===C}async X(v,C){if(C){const b=v?v[this.resource]:void 0;if(C.ref===b||b===void 0&&C.syncData===null)return C}return this.getRemoteUserData(C)}async Y(v,C,b,E){if(v.syncData&&v.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new m.$snb((0,d.localize)(10909,null,this.resource,this.pb,v.syncData.version),m.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.Z(v,C,b,E)}catch(T){if(T instanceof m.$snb)switch(T.code){case m.UserDataSyncErrorCode.LocalPreconditionFailed:return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(v,C,b,E);case m.UserDataSyncErrorCode.Conflict:case m.UserDataSyncErrorCode.PreconditionFailed:return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),v=await this.getRemoteUserData(null),C=await this.getLastSyncUserData(),this.Y(v,C,b,E)}throw T}}async Z(v,C,b,E){try{const T=await this.W(v),j=!T&&C===null&&this.gb()!==void 0,U=b&&!j;this.c||(this.c=(0,c.$ph)(K=>this.eb(v,C,T,U,E,K)));let F=await this.c;if(b&&j){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const K of F.resourcePreviews)F=await this.accept(K.remoteResource)||F}return this.cb(F.resourcePreviews),F.resourcePreviews.some(({mergeState:K})=>K===m.MergeState.Conflict)?m.SyncStatus.HasConflicts:b?await this.ab(!1):m.SyncStatus.Syncing}catch(T){throw this.c=null,T}}async merge(v){return await this.$(v,async C=>{const b=await this.rb(C,L.CancellationToken.None);await this.G.writeFile(C.previewResource,A.$Le.fromString(b?.content||""));const E=b&&!b.hasConflicts?await this.sb(C,C.previewResource,void 0,L.CancellationToken.None):void 0;return C.acceptResult=E,C.mergeState=b.hasConflicts?m.MergeState.Conflict:E?m.MergeState.Accepted:m.MergeState.Preview,C.localChange=E?E.localChange:b.localChange,C.remoteChange=E?E.remoteChange:b.remoteChange,C}),this.c}async accept(v,C){return await this.$(v,async b=>{const E=await this.sb(b,v,C,L.CancellationToken.None);return b.acceptResult=E,b.mergeState=m.MergeState.Accepted,b.localChange=E.localChange,b.remoteChange=E.remoteChange,b}),this.c}async discard(v){return await this.$(v,async C=>{const b=await this.rb(C,L.CancellationToken.None);return await this.G.writeFile(C.previewResource,A.$Le.fromString(b.content||"")),C.acceptResult=void 0,C.mergeState=m.MergeState.Preview,C.localChange=b.localChange,C.remoteChange=b.remoteChange,C}),this.c}async $(v,C){if(!this.c)return;let b=await this.c;const E=b.resourcePreviews.findIndex(({localResource:T,remoteResource:j,previewResource:U})=>this.h.isEqual(T,v)||this.h.isEqual(j,v)||this.h.isEqual(U,v));E!==-1&&(this.c=(0,c.$ph)(async T=>{const j=[...b.resourcePreviews];return j[E]=await C(j[E]),{...b,resourcePreviews:j}}),b=await this.c,this.cb(b.resourcePreviews),b.resourcePreviews.some(({mergeState:T})=>T===m.MergeState.Conflict)?this.S(m.SyncStatus.HasConflicts):this.S(m.SyncStatus.Syncing))}async ab(v){if(!this.c)return m.SyncStatus.Idle;const C=await this.c;return C.resourcePreviews.some(({mergeState:b})=>b===m.MergeState.Conflict)?m.SyncStatus.HasConflicts:C.resourcePreviews.some(({mergeState:b})=>b!==m.MergeState.Accepted)?m.SyncStatus.Syncing:(await this.tb(C.remoteUserData,C.lastSyncUserData,C.resourcePreviews.map(b=>[b,b.acceptResult]),v),this.c=null,await this.bb(),m.SyncStatus.Idle)}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(v){const C=v.filter(({mergeState:b})=>b===m.MergeState.Conflict);(0,I.$tb)(this.s,C,(b,E)=>this.h.isEqual(b.previewResource,E.previewResource))||(this.s=C,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const v=await this.getLastSyncUserData();return!!v&&v.syncData!==null}async db(v){const C=this.c?await this.c:null;if(C)for(const b of C.resourcePreviews){if(this.h.isEqual(b.acceptedResource,v))return b.acceptResult?b.acceptResult.content:null;if(this.h.isEqual(b.remoteResource,v))return b.remoteContent;if(this.h.isEqual(b.localResource,v))return b.localContent;if(this.h.isEqual(b.baseResource,v))return b.baseContent}return null}async resetLocal(){this.I.remove(this.z,g.StorageScope.APPLICATION);try{await this.G.del(this.y)}catch(v){(0,l.$nl)(v)!==l.FileOperationResult.FILE_NOT_FOUND&&this.O.error(v)}}async eb(v,C,b,E,T,j){const U=await this.qb(v,C,b,T,j),F=[];for(const K of U){const W=K.previewResource.with({scheme:m.$Enb,authority:"accepted"});if(K.localChange===m.Change.None&&K.remoteChange===m.Change.None)F.push({...K,acceptedResource:W,acceptResult:{content:null,localChange:m.Change.None,remoteChange:m.Change.None},mergeState:m.MergeState.Accepted});else{const x=E?await this.rb(K,j):void 0;if(j.isCancellationRequested)break;await this.G.writeFile(K.previewResource,A.$Le.fromString(x?.content||""));const G=x&&!x.hasConflicts?await this.sb(K,K.previewResource,void 0,j):void 0;F.push({...K,acceptResult:G,mergeState:x?.hasConflicts?m.MergeState.Conflict:G?m.MergeState.Accepted:m.MergeState.Preview,localChange:G?G.localChange:x?x.localChange:K.localChange,remoteChange:G?G.remoteChange:x?x.remoteChange:K.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:v,lastSyncUserData:C,resourcePreviews:F,isLastSyncFromCurrentMachine:b}}async getLastSyncUserData(){let v=this.gb();if(v||(v=await this.jb()),!v)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const C=JSON.parse(v),b=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!C.version&&!!b&&C.version!==b,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${C.version} is not compatible with current sync state version ${b}.`),await this.resetLocal(),null;let E,T=1;for(;E===void 0&&T++<6;)try{const j=await this.hb();j&&(j.ref===C.ref?E=j.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(j){if(j instanceof l.$rl&&j.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(j instanceof m.$snb)throw j;this.O.error(j,T)}}if(E===void 0)try{const j=await this.J.resolveResourceContent(this.resource,C.ref,this.collection,this.F);E=j===null?null:this.kb(j),await this.ib({ref:C.ref,syncData:E})}catch(j){if(j instanceof m.$snb&&j.code===m.UserDataSyncErrorCode.NotFound)this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw j}return E===void 0?null:{...C,syncData:E}}async fb(v,C={}){if(C.ref||C.version)throw new Error("Cannot have core properties as additional");const b=this.M.getResourceSyncStateVersion(this.resource),E={ref:v.ref,version:b,...C};this.I.store(this.z,JSON.stringify(E),g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),await this.ib(v)}gb(){return this.I.get(this.z,g.StorageScope.APPLICATION)}async hb(){const v=(await this.G.readFile(this.y)).value.toString();try{const C=v?JSON.parse(v):void 0;if(h(C))return C}catch(C){this.O.error(C)}}async ib(v){await this.G.writeFile(this.y,A.$Le.fromString(JSON.stringify(v)))}async jb(){try{const v=await this.G.readFile(this.y),C=JSON.parse(v.value.toString());await this.G.del(this.y),C.ref&&C.content!==void 0?(this.I.store(this.z,JSON.stringify({...C,content:void 0}),g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),await this.ib({ref:C.ref,syncData:C.content===null?null:JSON.parse(C.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,C)}catch(v){v instanceof l.$rl&&v.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(v)}return this.I.get(this.z,g.StorageScope.APPLICATION)}async getRemoteUserData(v){const{ref:C,content:b}=await this.lb(v);let E=null;return b!==null&&(E=this.kb(b)),{ref:C,syncData:E}}kb(v){try{const C=JSON.parse(v);if(i(C))return C}catch(C){this.O.error(C)}throw new m.$snb((0,d.localize)(10910,null),m.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async lb(v){const C=v?{ref:v.ref,content:v.syncData?JSON.stringify(v.syncData):null}:null;return this.J.readResource(this.resource,C,this.collection,this.F)}async mb(v,C){const b=await this.j,E={version:this.pb,machineId:b,content:v};try{return C=await this.J.writeResource(this.resource,JSON.stringify(E),C,this.collection,this.F),{ref:C,syncData:E}}catch(T){throw T instanceof m.$snb&&T.code===m.UserDataSyncErrorCode.TooLarge&&(T=new m.$snb(T.message,T.code,this.resource)),T}}async nb(v){const C={version:this.pb,content:v};return this.L.writeResource(this.resource,JSON.stringify(C),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!==m.SyncStatus.Idle&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S(m.SyncStatus.Idle),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(m.$fnb)}};e.$RNb=t,e.$RNb=t=ve([Q(2,l.$9k),Q(3,$.$Ji),Q(4,g.$eq),Q(5,m.$nnb),Q(6,m.$onb),Q(7,m.$xnb),Q(8,w.$8l),Q(9,m.$Cnb),Q(10,u.$9i),Q(11,P.$Gl)],t);let n=class extends t{constructor(v,C,b,E,T,j,U,F,K,W,x,G,ie){super(C,b,E,T,j,U,F,K,W,x,G,ie),this.r=v,this.B(this.G.watch(this.h.dirname(v))),this.B(this.G.onDidFilesChange(V=>this.yb(V)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(v,C,b){try{C?await this.G.writeFile(this.r,A.$Le.fromString(v),b?void 0:C):await this.G.createFile(this.r,A.$Le.fromString(v),{overwrite:b})}catch(E){throw E instanceof l.$rl&&E.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND||E instanceof l.$rl&&E.fileOperationResult===l.FileOperationResult.FILE_MODIFIED_SINCE?new m.$snb(E.message,m.UserDataSyncErrorCode.LocalPreconditionFailed):E}}async xb(){try{await this.G.del(this.r)}catch(v){if(!(v instanceof l.$rl&&v.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND))throw v}}yb(v){v.contains(this.r)&&this.Q()}};e.$SNb=n,e.$SNb=n=ve([Q(3,l.$9k),Q(4,$.$Ji),Q(5,g.$eq),Q(6,m.$nnb),Q(7,m.$onb),Q(8,m.$xnb),Q(9,w.$8l),Q(10,m.$Cnb),Q(11,u.$9i),Q(12,P.$Gl)],n);let r=class extends n{constructor(v,C,b,E,T,j,U,F,K,W,x,G,ie,V){super(v,C,b,E,T,j,U,F,K,W,x,ie,V),this.zb=G,this.Bb=void 0}Ab(v,C){const b=[],E=(0,O.$Un)(v,b,{allowEmptyContent:!0,allowTrailingComma:!0});return b.length>0||!(0,R.$jg)(E)&&C!==Array.isArray(E)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$TNb=r,e.$TNb=r=ve([Q(3,l.$9k),Q(4,$.$Ji),Q(5,g.$eq),Q(6,m.$nnb),Q(7,m.$onb),Q(8,m.$xnb),Q(9,w.$8l),Q(10,m.$Cnb),Q(11,m.$Bnb),Q(12,u.$9i),Q(13,P.$Gl)],r);let a=class{constructor(v,C,b,E,T,j,U){this.resource=v,this.g=C,this.h=b,this.j=E,this.k=T,this.l=j,this.d=U.extUri,this.f=(0,m.$lnb)(void 0,this.resource,b,this.d)}async initialize({ref:v,content:C}){if(!C){this.j.info("Remote content does not exist.",this.resource);return}const b=this.m(C);if(b)try{await this.o({ref:v,syncData:b})}catch(E){this.j.error(E)}}m(v){try{const C=JSON.parse(v);if(i(C))return C}catch(C){this.j.error(C)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(v,C={}){if(C.ref||C.version)throw new Error("Cannot have core properties as additional");const b={ref:v.ref,version:void 0,...C};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(b),g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),await this.k.writeFile(this.f,A.$Le.fromString(JSON.stringify(v)))}};e.$UNb=a,e.$UNb=a=ve([Q(1,o.$Il),Q(2,$.$Ji),Q(3,p.$9j),Q(4,l.$9k),Q(5,g.$eq),Q(6,P.$Gl)],a)}),define(he[119],ue([0,1,6,25,8,3,45,2,26,21,15,118,27,34,85,33,7,4,76,10,16,18,28,19,40,205,114,24,62]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$,l,p,S,g,w,P,m,o,h,i,s,t,n,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7bc=e.$6bc=e.$5bc=void 0,e.$3bc=v,e.$4bc=C;async function f(j,U){const F=JSON.parse(j.content);if(j.version===1||j.version===2){const K=(await U.getInstalled(p.ExtensionType.System)).filter(W=>W.isBuiltin);for(const W of F)j.version===1&&(W.enabled===!1&&(W.disabled=!0),delete W.enabled),j.version===2&&K.every(x=>!(0,$.$Ip)(x.identifier,W.identifier))&&(W.installed=!0)}return F}function v(j){return JSON.parse(j.content)}function C(j,U){return j.sort((F,K)=>!F.identifier.uuid&&K.identifier.uuid?-1:F.identifier.uuid&&!K.identifier.uuid?1:(0,k.$wf)(F.identifier.id,K.identifier.id)),U?(0,N.$5n)(j,{}):JSON.stringify(j)}let b=class extends s.$RNb{constructor(U,F,K,W,x,G,ie,V,z,_,ne,ce,te,Y,H,B,D){super({syncResource:r.SyncResource.Extensions,profile:U},F,W,K,x,G,ie,ce,te,_,ne,H),this.Cb=V,this.Db=z,this.Eb=D,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$Enb,authority:"base"}),this.yb=this.wb.with({scheme:r.$Enb,authority:"local"}),this.zb=this.wb.with({scheme:r.$Enb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$Enb,authority:"accepted"}),this.Bb=this.Eb.createInstance(E),this.B(L.Event.any(L.Event.filter(this.Cb.onDidInstallExtensions,J=>J.some(({local:q})=>!!q)),L.Event.filter(this.Cb.onDidUninstallExtension,J=>!J.error),L.Event.filter(B.onDidChange,J=>J.valueChanges.some(({profile:q,changes:M})=>this.syncResource.profile.id===q.id&&M.some(Z=>Z.key===u.$lp))),Y.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(U,F){const K=U.syncData?await f(U.syncData,this.Cb):null,W=F?.skippedExtensions??[],x=F?.builtinExtensions??null,G=F?.syncData?await f(F.syncData,this.Cb):null,{localExtensions:ie,ignoredExtensions:V}=await this.Bb.getLocalExtensions(this.syncResource.profile);K?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:z,remote:_}=(0,t.$2bc)(ie,K,G,W,V,x),ne={local:z,remote:_,content:this.Hb(ie,z.added,z.updated,z.removed),localChange:z.added.length>0||z.removed.length>0||z.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:_!==null?r.Change.Modified:r.Change.None},ce=this.Ob(ie,!1);return[{skippedExtensions:W,builtinExtensions:x,baseResource:this.xb,baseContent:G?this.Ob(G,!1):ce,localResource:this.yb,localContent:ce,localExtensions:ie,remoteResource:this.zb,remoteExtensions:K,remoteContent:K?this.Ob(K,!1):null,previewResource:this.wb,previewResult:ne,localChange:ne.localChange,remoteChange:ne.remoteChange,acceptedResource:this.Ab}]}async ub(U){const F=U.syncData?await f(U.syncData,this.Cb):null,{localExtensions:K,ignoredExtensions:W}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,t.$2bc)(K,F,F,U.skippedExtensions||[],W,U.builtinExtensions||[]);return x!==null}Hb(U,F,K,W){const x=[...F,...K],G=new Set,ie=V=>{G.add(V.id.toLowerCase()),V.uuid&&G.add(V.uuid)};x.forEach(({identifier:V})=>ie(V)),W.forEach(ie);for(const V of U)G.has(V.identifier.id.toLowerCase())||V.identifier.uuid&&G.has(V.identifier.uuid)||x.push(V);return this.Ob(x,!1)}async rb(U,F){return{...U.previewResult,hasConflicts:!1}}async sb(U,F,K,W){if(this.h.isEqual(F,this.yb))return this.Kb(U);if(this.h.isEqual(F,this.zb))return this.Lb(U);if(this.h.isEqual(F,this.wb))return U.previewResult;throw new Error(`Invalid Resource: ${F.toString()}`)}async Kb(U){const F=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),K=this.Db.getIgnoredExtensions(F),W=(0,t.$2bc)(U.localExtensions,null,null,U.skippedExtensions,K,U.builtinExtensions),{local:x,remote:G}=W;return{content:U.localContent,local:x,remote:G,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:G!==null?r.Change.Modified:r.Change.None}}async Lb(U){const F=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),K=this.Db.getIgnoredExtensions(F),W=U.remoteContent?JSON.parse(U.remoteContent):null;if(W!==null){const x=(0,t.$2bc)(U.localExtensions,W,U.localExtensions,[],K,U.builtinExtensions),{local:G,remote:ie}=x;return{content:U.remoteContent,local:G,remote:ie,localChange:G.added.length>0||G.removed.length>0||G.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:ie!==null?r.Change.Modified:r.Change.None}}else return{content:U.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:r.Change.None,remoteChange:r.Change.None}}async tb(U,F,K,W){let{skippedExtensions:x,builtinExtensions:G,localExtensions:ie}=K[0][0];const{local:V,remote:z,localChange:_,remoteChange:ne}=K[0][1];if(_===r.Change.None&&ne===r.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),_!==r.Change.None&&(await this.nb(JSON.stringify(ie)),x=await this.Bb.updateLocalExtensions(V.added,V.removed,V.updated,x,this.syncResource.profile)),z){this.O.trace(`${this.D}: Updating remote extensions...`);const ce=JSON.stringify(z.all);U=await this.mb(ce,W?null:U.ref),this.O.info(`${this.D}: Updated remote extensions.${z.added.length?` Added: ${JSON.stringify(z.added.map(te=>te.identifier.id))}.`:""}${z.updated.length?` Updated: ${JSON.stringify(z.updated.map(te=>te.identifier.id))}.`:""}${z.removed.length?` Removed: ${JSON.stringify(z.removed.map(te=>te.identifier.id))}.`:""}`)}F?.ref!==U.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),G=this.Nb(ie,G),await this.fb(U,{skippedExtensions:x,builtinExtensions:G}),this.O.info(`${this.D}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(ce=>ce.identifier.id))}.`:""}`))}Nb(U,F){const K=new Set,W=[];for(const x of U)K.add(x.identifier.id.toLowerCase()),x.installed||W.push(x.identifier);if(F)for(const x of F)K.has(x.id.toLowerCase())||W.push(x);return W}async resolveContent(U){if(this.h.isEqual(this.zb,U)||this.h.isEqual(this.xb,U)||this.h.isEqual(this.yb,U)||this.h.isEqual(this.Ab,U)){const F=await this.db(U);return F&&this.Ob(JSON.parse(F),!0)}return null}Ob(U,F){return C(U,F)}async hasLocalData(){try{const{localExtensions:U}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(U.some(F=>F.installed||F.disabled))return!0}catch{}return!1}};e.$5bc=b,e.$5bc=b=ve([Q(2,R.$Ji),Q(3,S.$9k),Q(4,m.$eq),Q(5,r.$nnb),Q(6,r.$onb),Q(7,u.$kp),Q(8,n.$DOb),Q(9,r.$Cnb),Q(10,y.$9i),Q(11,r.$xnb),Q(12,o.$8l),Q(13,l.$lw),Q(14,h.$Gl),Q(15,a.$LMb),Q(16,g.$Bi)],b);let E=class{constructor(U,F,K,W,x,G){this.a=U,this.b=F,this.c=K,this.d=W,this.f=x,this.g=G}async getLocalExtensions(U){const F=await this.a.getInstalled(void 0,U.extensionsResource),K=this.d.getIgnoredExtensions(F);return{localExtensions:await this.j(U,async(x,G)=>{const ie=x.getDisabledExtensions();return F.map(V=>{const{identifier:z,isBuiltin:_,manifest:ne,preRelease:ce,pinned:te,isApplicationScoped:Y}=V,H={identifier:z,preRelease:ce,version:ne.version,pinned:!!te};Y&&!(0,p.$qn)(ne)&&(H.isApplicationScoped=Y),ie.some(B=>(0,$.$Ip)(B,z))&&(H.disabled=!0),_||(H.installed=!0);try{const B=G.getKeysForSync({id:z.id,version:ne.version});if(B){const D=G.getExtensionState(V,!0)||{};H.state=Object.keys(D).reduce((J,q)=>(B.includes(q)&&(J[q]=D[q]),J),{})}}catch(B){this.g.info(`${(0,s.$QNb)(r.SyncResource.Extensions,U)}: Error while parsing extension state`,(0,A.$9)(B))}return H})}),ignoredExtensions:K}}async updateLocalExtensions(U,F,K,W,x){const G=(0,s.$QNb)(r.SyncResource.Extensions,x),ie=[],V=new Map,z=[],_=[],ne=await this.a.getInstalled(void 0,x.extensionsResource);if((U.length||K.length)&&await this.j(x,async(Y,H)=>{await I.Promises.settled([...U,...K].map(async B=>{const D=ne.find(M=>(0,$.$Ip)(M.identifier,B.identifier));if(D&&D.isBuiltin){B.state&&D.manifest.version===B.version&&this.h(B.state,D,D.manifest.version,H),Y.getDisabledExtensions().some(Z=>(0,$.$Ip)(Z,B.identifier))!==!!B.disabled&&(B.disabled?(this.g.trace(`${G}: Disabling extension...`,B.identifier.id),await Y.disableExtension(B.identifier),this.g.info(`${G}: Disabled extension`,B.identifier.id)):(this.g.trace(`${G}: Enabling extension...`,B.identifier.id),await Y.enableExtension(B.identifier),this.g.info(`${G}: Enabled extension`,B.identifier.id))),z.push(B.identifier);return}const J=B.pinned?B.version:void 0,q=(await this.c.getExtensions([{...B.identifier,version:J,preRelease:J?void 0:B.preRelease}],c.CancellationToken.None))[0];if(B.state&&(D?D.manifest.version===B.version:q)&&this.h(B.state,D||q,D?.manifest.version,H),q)try{Y.getDisabledExtensions().some(Z=>(0,$.$Ip)(Z,B.identifier))!==!!B.disabled&&(B.disabled?(this.g.trace(`${G}: Disabling extension...`,B.identifier.id,q.version),await Y.disableExtension(q.identifier),this.g.info(`${G}: Disabled extension`,B.identifier.id,q.version)):(this.g.trace(`${G}: Enabling extension...`,B.identifier.id,q.version),await Y.enableExtension(q.identifier),this.g.info(`${G}: Enabled extension`,B.identifier.id,q.version))),(!D||D.preRelease!==B.preRelease||D.pinned!==B.pinned||J&&D.manifest.version!==J)&&(await this.a.canInstall(q)?(ie.push({extension:q,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:B.pinned&&!!B.version,pinned:B.pinned,installPreReleaseVersion:B.preRelease,profileLocation:x.extensionsResource,isApplicationScoped:B.isApplicationScoped,context:{[u.$0o]:!0,[u.$$o]:u.ExtensionInstallSource.SETTINGS_SYNC}}}),V.set(q.identifier.id.toLowerCase(),B)):(this.g.info(`${G}: Skipped synchronizing extension because it cannot be installed.`,q.displayName||q.identifier.id),_.push(B)))}catch(M){_.push(B),this.g.error(M),this.g.info(`${G}: Skipped synchronizing extension`,q.displayName||q.identifier.id)}else _.push(B),this.g.info(`${G}: Skipped synchronizing extension because the extension is not found.`,B.identifier.id)}))}),F.length){const Y=ne.filter(({identifier:H,isBuiltin:B})=>!B&&F.some(D=>(0,$.$Ip)(H,D)));await I.Promises.settled(Y.map(async H=>{this.g.trace(`${G}: Uninstalling local extension...`,H.identifier.id),await this.a.uninstall(H,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${G}: Uninstalled local extension.`,H.identifier.id),z.push(H.identifier)}))}const ce=await this.a.installGalleryExtensions(ie);for(const{identifier:Y,local:H,error:B,source:D}of ce){const J=D;if(H)this.g.info(`${G}: Installed extension.`,Y.id,J.version),z.push(Y);else{const q=V.get(Y.id.toLowerCase());q&&(_.push(q),this.g.info(`${G}: Skipped synchronizing extension`,J.displayName||J.identifier.id)),B instanceof u.$jp&&[u.ExtensionManagementErrorCode.Incompatible,u.ExtensionManagementErrorCode.IncompatibleApi,u.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(B.code)?this.g.info(`${G}: Skipped synchronizing extension because the compatible extension is not found.`,J.displayName||J.identifier.id):B&&this.g.error(B)}}const te=[];for(const Y of W)z.some(H=>(0,$.$Ip)(H,Y.identifier))||te.push(Y);for(const Y of _)te.some(H=>(0,$.$Ip)(H.identifier,Y.identifier))||te.push(Y);return te}h(U,F,K,W){const x=W.getExtensionState(F,!0)||{},G=K?W.getKeysForSync({id:F.identifier.id,version:K}):void 0;G?G.forEach(ie=>{x[ie]=U[ie]}):Object.keys(U).forEach(ie=>x[ie]=U[ie]),W.setExtensionState(F,x,!0)}async j(U,F){return this.b.withProfileScopedStorageService(U,async K=>{const W=new O.$Sc,x=W.add(this.f.createChild(new w.$Ai([m.$eq,K]))),G=W.add(x.createInstance(d.$0Lb)),ie=W.add(x.createInstance(l.$mw));try{return await F(G,ie)}finally{W.dispose()}})}};e.$6bc=E,e.$6bc=E=ve([Q(0,u.$kp),Q(1,a.$LMb),Q(2,u.$hp),Q(3,n.$DOb),Q(4,g.$Bi),Q(5,r.$Cnb)],E);let T=class extends s.$UNb{constructor(U,F,K,W,x,G,ie,V){super(r.SyncResource.Extensions,W,x,G,K,ie,V),this.p=U,this.q=F}async t(U){return U.syncData?await f(U.syncData,this.p):null}u(U,F){const K=[],W=[],x=[];for(const G of U){if(this.q.hasToNeverSyncExtension(G.identifier.id))continue;const ie=F.find(V=>(0,$.$Ip)(V.identifier,G.identifier));ie?(K.push(ie),G.disabled&&x.push(G.identifier)):G.installed&&(W.push({...G.identifier,preRelease:!!G.preRelease}),G.disabled&&x.push(G.identifier))}return{installedExtensions:K,newExtensions:W,disabledExtensions:x,remoteExtensions:U}}};e.$7bc=T,e.$7bc=T=ve([Q(0,u.$kp),Q(1,n.$DOb),Q(2,S.$9k),Q(3,i.$Il),Q(4,R.$Ji),Q(5,P.$9j),Q(6,m.$eq),Q(7,h.$Gl)],T)}),define(he[120],ue([0,1,14,8,3,35,45,5,31,21,15,7,10,49,16,18,28,40,81,209,24,19,62,4]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$,l,p,S,g,w,P,m,o,h,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1Nb=e.$ZNb=e.$YNb=e.$XNb=void 0,e.$WNb=n;const s="globalState.argv.",t=["locale"];function n(b,E){const T=b.storage?Object.keys(b.storage).sort():[],j={};return T.forEach(U=>j[U]=b.storage[U]),b.storage=j,E?(0,N.$5n)(b,{}):JSON.stringify(b)}const r=1;let a=class extends g.$RNb{constructor(E,T,j,U,F,K,W,x,G,ie,V,z,_,ne){super({syncResource:m.SyncResource.GlobalState,profile:E},T,U,x,z,F,K,G,ie,W,V,_),this.Bb=j,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:m.$Enb,authority:"base"}),this.xb=this.vb.with({scheme:m.$Enb,authority:"local"}),this.yb=this.vb.with({scheme:m.$Enb,authority:"remote"}),this.zb=this.vb.with({scheme:m.$Enb,authority:"accepted"}),this.Ab=ne.createInstance(f),this.B(U.watch(this.h.dirname(this.H.argvResource))),this.B(A.Event.any(A.Event.filter(U.onDidFilesChange,ce=>ce.contains(this.H.argvResource)),A.Event.filter(j.onDidChange,ce=>!!(ce.targetChanges.some(te=>this.syncResource.profile.id===te.id)||ce.valueChanges.some(({profile:te,changes:Y})=>this.syncResource.profile.id===te.id&&Y.some(H=>H.target===l.StorageTarget.USER)))))(()=>this.Q()))}async qb(E,T,j){const U=E.syncData?JSON.parse(E.syncData.content):null;T=T===null&&j?E:T;const F=T&&T.syncData?JSON.parse(T.syncData.content):null,K=await this.Ab.getLocalGlobalState(this.syncResource.profile);U?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const W=await this.Jb(F),{local:x,remote:G}=(0,P.$VNb)(K.storage,U?U.storage:null,F?F.storage:null,W,this.O),ie={content:null,local:x,remote:G,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?m.Change.Modified:m.Change.None,remoteChange:G.all!==null?m.Change.Modified:m.Change.None},V=n(K,!1);return[{baseResource:this.wb,baseContent:F?n(F,!1):V,localResource:this.xb,localContent:V,localUserData:K,remoteResource:this.yb,remoteContent:U?n(U,!1):null,previewResource:this.vb,previewResult:ie,localChange:ie.localChange,remoteChange:ie.remoteChange,acceptedResource:this.zb,storageKeys:W}]}async ub(E){const T=E.syncData?JSON.parse(E.syncData.content):null;if(T===null)return!0;const j=await this.Ab.getLocalGlobalState(this.syncResource.profile),U=await this.Jb(T),{remote:F}=(0,P.$VNb)(j.storage,T.storage,T.storage,U,this.O);return F.all!==null}async rb(E,T){return{...E.previewResult,hasConflicts:!1}}async sb(E,T,j,U){if(this.h.isEqual(T,this.xb))return this.Gb(E);if(this.h.isEqual(T,this.yb))return this.Hb(E);if(this.h.isEqual(T,this.vb))return E.previewResult;throw new Error(`Invalid Resource: ${T.toString()}`)}async Gb(E){return{content:E.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(E.localUserData.storage),removed:[],updated:[],all:E.localUserData.storage},localChange:m.Change.None,remoteChange:m.Change.Modified}}async Hb(E){if(E.remoteContent!==null){const T=JSON.parse(E.remoteContent),{local:j,remote:U}=(0,P.$VNb)(E.localUserData.storage,T.storage,null,E.storageKeys,this.O);return{content:E.remoteContent,local:j,remote:U,localChange:Object.keys(j.added).length>0||Object.keys(j.updated).length>0||j.removed.length>0?m.Change.Modified:m.Change.None,remoteChange:U!==null?m.Change.Modified:m.Change.None}}else return{content:E.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:m.Change.None,remoteChange:m.Change.None}}async tb(E,T,j,U){const{localUserData:F}=j[0][0],{local:K,remote:W,localChange:x,remoteChange:G}=j[0][1];if(x===m.Change.None&&G===m.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),x!==m.Change.None&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(F)),await this.Ab.writeLocalGlobalState(K,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),G!==m.Change.None){this.O.trace(`${this.D}: Updating remote ui state...`);const ie=JSON.stringify({storage:W.all});E=await this.mb(ie,U?null:E.ref),this.O.info(`${this.D}: Updated remote ui state.${W.added.length?` Added: ${W.added}.`:""}${W.updated.length?` Updated: ${W.updated}.`:""}${W.removed.length?` Removed: ${W.removed}.`:""}`)}T?.ref!==E.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(E),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(E){if(this.h.isEqual(this.yb,E)||this.h.isEqual(this.wb,E)||this.h.isEqual(this.xb,E)||this.h.isEqual(this.zb,E)){const T=await this.db(E);return T&&n(JSON.parse(T),!0)}return null}async hasLocalData(){try{const{storage:E}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(E).length>1||E[`${s}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(E){const T=await this.Bb.readStorageData(this.syncResource.profile),j=[],U=[];for(const[W,x]of T)x.target===l.StorageTarget.USER?j.push(W):x.target===l.StorageTarget.MACHINE&&U.push(W);const F=[...j,...U],K=E?.storage?Object.keys(E.storage).filter(W=>!W.startsWith(s)&&!F.includes(W)&&T.get(W)!==void 0):[];if(!O.$p){const W=[...m.$jnb.map(x=>(0,m.$wnb)(x)),m.$vnb];K.push(...W),U.push(...W)}return{user:j,machine:U,unregistered:K}}};e.$XNb=a,e.$XNb=a=ve([Q(2,h.$LMb),Q(3,d.$9k),Q(4,m.$nnb),Q(5,m.$onb),Q(6,m.$Cnb),Q(7,R.$Ji),Q(8,m.$xnb),Q(9,p.$8l),Q(10,y.$9i),Q(11,l.$eq),Q(12,S.$Gl),Q(13,i.$Bi)],a);let f=class{constructor(E,T,j,U){this.a=E,this.b=T,this.c=j,this.d=U}async getLocalGlobalState(E){const T={};if(E.isDefault){const U=await this.f(),F=(0,L.$Un)(U);for(const K of t)F[K]!==void 0&&(T[`${s}${K}`]={version:1,value:F[K]})}const j=await this.c.readStorageData(E);for(const[U,F]of j)F.value&&F.target===l.StorageTarget.USER&&(T[U]={version:1,value:F.value});return{storage:T}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const E=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),E.value.toString()}catch(E){this.d.debug((0,c.$9)(E))}return"{}"}async writeLocalGlobalState({added:E,removed:T,updated:j},U){const F=(0,g.$QNb)(m.SyncResource.GlobalState,U),K={},W=new Map,x=await this.c.readStorageData(U),G=(ie,V)=>{for(const z of ie){if(z.startsWith(s)){K[z.substring(s.length)]=V?V[z].value:void 0;continue}if(V){const _=V[z];_.value!==x.get(z)?.value&&W.set(z,_.value)}else x.get(z)!==void 0&&W.set(z,void 0)}};if(G(Object.keys(E),E),G(Object.keys(j),j),G(T),Object.keys(K).length){this.d.trace(`${F}: Updating locale...`);const ie=await this.f();let V=ie;for(const z of Object.keys(K))V=(0,w.edit)(V,[z],K[z],{});ie!==V&&(this.d.trace(`${F}: Updating locale...`),await this.a.writeFile(this.b.argvResource,I.$Le.fromString(V)),this.d.info(`${F}: Updated locale.`)),this.d.info(`${F}: Updated locale`)}W.size&&(this.d.trace(`${F}: Updating global state...`),await this.c.updateStorageData(U,W,l.StorageTarget.USER),this.d.info(`${F}: Updated global state`,[...W.keys()]))}};e.$YNb=f,e.$YNb=f=ve([Q(0,d.$9k),Q(1,R.$Ji),Q(2,h.$LMb),Q(3,m.$Cnb)],f);let v=class extends g.$UNb{constructor(E,T,j,U,F,K){super(m.SyncResource.GlobalState,j,U,F,T,E,K)}async o(E){const T=E.syncData?JSON.parse(E.syncData.content):null;if(!T){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const j={},U={};for(const F of Object.keys(T.storage))F.startsWith(s)?j[F.substring(s.length)]=T.storage[F].value:this.l.get(F,l.StorageScope.PROFILE)===void 0&&(U[F]=T.storage[F].value);if(Object.keys(j).length){let F="{}";try{F=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const K of Object.keys(j))F=(0,w.edit)(F,[K],j[K],{});await this.k.writeFile(this.h.argvResource,I.$Le.fromString(F))}if(Object.keys(U).length){const F=[];for(const K of Object.keys(U))F.push({key:K,value:U[K],scope:l.StorageScope.PROFILE,target:l.StorageTarget.USER});this.l.storeAll(F,!0)}}};e.$ZNb=v,e.$ZNb=v=ve([Q(0,l.$eq),Q(1,d.$9k),Q(2,o.$Il),Q(3,R.$Ji),Q(4,m.$Cnb),Q(5,S.$Gl)],v);let C=class{constructor(E,T,j,U,F){this.a=E,this.b=T,this.c=j,this.d=U,this.f=F}getSyncStoreType(E){return this.h(E)?.storage[m.$vnb]?.value}async sync(E){const T=(0,m.$rnb)((0,k.$Yg)());try{return await this.g(E,T)}catch(j){if(j instanceof m.$snb)switch(j.code){case m.UserDataSyncErrorCode.PreconditionFailed:return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(E,T)}throw j}}async g(E,T){const j=await this.a.readResource(m.SyncResource.GlobalState,null,void 0,T),U=this.h(j)||{storage:{}};U.storage[m.$vnb]={value:E,version:r};const F=await(0,$.$kq)(this.c,this.d,this.b),K={version:r,machineId:F,content:n(U,!1)};await this.a.writeResource(m.SyncResource.GlobalState,JSON.stringify(K),j.ref,void 0,T)}h({content:E}){if(!E)return null;const T=JSON.parse(E);if((0,g.$PNb)(T))return T?JSON.parse(T.content):null;throw new Error("Invalid remote data")}};e.$1Nb=C,e.$1Nb=C=ve([Q(1,l.$eq),Q(2,R.$Ji),Q(3,d.$9k),Q(4,u.$9j)],C)}),define(he[121],ue([0,1,17,14,3,35,5,12,11,21,15,7,16,18,28,19,40,206,24]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$,l,p,S,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$bc=e.$0bc=void 0,e.$9bc=P;function P(h,i,s){try{const t=JSON.parse(h);if(!i)return(0,O.$jg)(t.all)?null:t.all;switch(N.OS){case N.OperatingSystem.Macintosh:return(0,O.$jg)(t.mac)?null:t.mac;case N.OperatingSystem.Linux:return(0,O.$jg)(t.linux)?null:t.linux;case N.OperatingSystem.Windows:return(0,O.$jg)(t.windows)?null:t.windows}}catch(t){return s.error(t),null}}let m=class extends S.$TNb{constructor(i,s,t,n,r,a,f,v,C,b,E,T,j){super(i.keybindingsResource,{syncResource:w.SyncResource.Keybindings,profile:i},s,v,C,b,t,n,f,T,r,E,a,j),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:w.$Enb,authority:"base"}),this.Gb=this.Eb.with({scheme:w.$Enb,authority:"local"}),this.Hb=this.Eb.with({scheme:w.$Enb,authority:"remote"}),this.Ib=this.Eb.with({scheme:w.$Enb,authority:"accepted"}),this.B(A.Event.filter(a.onDidChangeConfiguration,U=>U.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(i,s,t,n){const r=i.syncData?P(i.syncData.content,n.keybindingsPerPlatform??this.Qb(),this.O):null;s=s===null&&t?i:s;const a=s?this.Ob(s):null,f=await this.vb(),v=await this.Cb();let C=null,b=!1,E=!1,T=!1;if(r){let F=f?f.value.toString():"[]";if(F=F||"[]",this.Ab(F,!0))throw new w.$snb((0,k.localize)(10907,null),w.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!a||a!==F||a!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const K=await(0,g.$8bc)(F,r,a,v,this.zb);K.hasChanges&&(C=K.mergeContent,T=K.hasConflicts,b=T||K.mergeContent!==F,E=T||K.mergeContent!==r)}}else f&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),C=f.value.toString(),E=!0);const j={content:T?a:C,localChange:b?f?w.Change.Modified:w.Change.Added:w.Change.None,remoteChange:E?w.Change.Modified:w.Change.None,hasConflicts:T},U=f?f.value.toString():null;return[{fileContent:f,baseResource:this.Fb,baseContent:a,localResource:this.Gb,localContent:U,localChange:j.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:j.remoteChange,previewResource:this.Eb,previewResult:j,acceptedResource:this.Ib}]}async ub(i){const s=this.Ob(i);if(s===null)return!0;const t=await this.vb(),n=t?t.value.toString():"",r=await this.Cb(),a=await(0,g.$8bc)(n||"[]",s,s,r,this.zb);return a.hasConflicts||a.mergeContent!==s}async rb(i,s){return i.previewResult}async sb(i,s,t,n){if(this.h.isEqual(s,this.Gb))return{content:i.fileContent?i.fileContent.value.toString():null,localChange:w.Change.None,remoteChange:w.Change.Modified};if(this.h.isEqual(s,this.Hb))return{content:i.remoteContent,localChange:w.Change.Modified,remoteChange:w.Change.None};if(this.h.isEqual(s,this.Eb))return t===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:t,localChange:w.Change.Modified,remoteChange:w.Change.Modified};throw new Error(`Invalid Resource: ${s.toString()}`)}async tb(i,s,t,n){const{fileContent:r}=t[0][0];let{content:a,localChange:f,remoteChange:v}=t[0][1];if(f===w.Change.None&&v===w.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.Ab(a,!0)))throw new w.$snb((0,k.localize)(10908,null),w.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(f!==w.Change.None&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(a||"[]",r,n),this.O.info(`${this.D}: Updated local keybindings`)),v!==w.Change.None){this.O.trace(`${this.D}: Updating remote keybindings...`);const C=this.Pb(a||"[]",i.syncData?.content);i=await this.mb(C,n?null:i.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}s?.ref!==i.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(i,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const i=await this.vb();if(i){const s=(0,L.$Un)(i.value.toString());if((0,I.$Kb)(s))return!0}}catch(i){if(i.fileOperationResult!==d.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(i){return this.h.isEqual(this.Hb,i)||this.h.isEqual(this.Fb,i)||this.h.isEqual(this.Gb,i)||this.h.isEqual(this.Ib,i)?this.db(i):null}Ob(i){return!i.syncData||i.platformSpecific!==void 0&&i.platformSpecific!==this.Qb()?null:P(i.syncData.content,this.Qb(),this.O)}Pb(i,s){let t={};try{t=JSON.parse(s||"{}")}catch(n){this.O.error(n)}switch(this.Qb()?delete t.all:t.all=i,N.OS){case N.OperatingSystem.Macintosh:t.mac=i;break;case N.OperatingSystem.Linux:t.linux=i;break;case N.OperatingSystem.Windows:t.windows=i;break}return JSON.stringify(t)}Qb(){return!!this.P.getValue(w.$gnb)}};e.$0bc=m,e.$0bc=m=ve([Q(2,w.$nnb),Q(3,w.$onb),Q(4,w.$Cnb),Q(5,y.$9i),Q(6,w.$xnb),Q(7,d.$9k),Q(8,R.$Ji),Q(9,u.$eq),Q(10,w.$Bnb),Q(11,$.$8l),Q(12,l.$Gl)],m);let o=class extends S.$UNb{constructor(i,s,t,n,r,a){super(w.SyncResource.Keybindings,s,t,n,i,r,a)}async o(i){const s=i.syncData?this.p(i.syncData.content):null;if(!s){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,c.$Le.fromString(s)),await this.n(i)}async i(){try{const i=await this.k.readFile(this.g.defaultProfile.settingsResource),s=(0,L.$Un)(i.value.toString());return!(0,I.$Kb)(s)}catch(i){return i.fileOperationResult===d.FileOperationResult.FILE_NOT_FOUND}}p(i){try{return P(i,!0,this.j)}catch(s){return this.j.error(s),null}}};e.$$bc=o,e.$$bc=o=ve([Q(0,d.$9k),Q(1,p.$Il),Q(2,R.$Ji),Q(3,w.$Cnb),Q(4,u.$eq),Q(5,l.$Gl)],o)}),define(he[122],ue([0,1,17,14,3,11,21,77,15,27,33,7,16,18,28,19,40,210,24]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$,l,p,S,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bcc=e.$acc=void 0,e.$_bc=m;function P(i){return i&&i.settings&&typeof i.settings=="string"&&Object.keys(i).length===1}function m(i){const s=JSON.parse(i);return P(s)?s:{settings:i}}let o=class extends S.$TNb{constructor(s,t,n,r,a,f,v,C,b,E,T,j,U,F){super(s.settingsResource,{syncResource:w.SyncResource.Settings,profile:s},t,n,r,a,f,v,T,j,C,b,E,F),this.Eb=s,this.Fb=U,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:w.$Enb,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.$Enb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.$Enb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.$Enb,authority:"accepted"}),this.Pb=void 0,this.Qb=void 0,this.Rb=void 0}async getRemoteUserDataSyncConfiguration(s){const t=await this.getLastSyncUserData(),n=await this.X(s,t),r=this.Mb(n),a=new O.$Lo(w.$fnb,this.O);return r?.settings&&a.parse(r.settings),a.configurationModel.getValue(w.$fnb)||{}}async qb(s,t,n){const r=await this.vb(),a=await this.Cb(),f=this.Mb(s);t=t===null&&n?s:t;const v=t?this.Mb(t):null,C=await this.Sb();let b=null,E=!1,T=!1,j=!1;if(f){let W=r?r.value.toString().trim():"{}";W=W||"{}",this.Vb(W),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const x=(0,g.$sMb)(W,f.settings,v?v.settings:null,C,[],a);b=x.localContent||x.remoteContent,E=x.localContent!==null,T=x.remoteContent!==null,j=x.hasConflicts}else r&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),b=r.value.toString().trim()||"{}",this.Vb(b),T=!0);const U=r?r.value.toString():null,F=v?.settings??null,K={content:j?F:b,localChange:E?w.Change.Modified:w.Change.None,remoteChange:T?w.Change.Modified:w.Change.None,hasConflicts:j};return[{fileContent:r,baseResource:this.baseResource,baseContent:F,localResource:this.localResource,localContent:U,localChange:K.localChange,remoteResource:this.remoteResource,remoteContent:f?f.settings:null,remoteChange:K.remoteChange,previewResource:this.previewResource,previewResult:K,acceptedResource:this.acceptedResource}]}async ub(s){const t=this.Mb(s);if(t===null)return!0;const n=await this.vb(),r=n?n.value.toString().trim():"",a=await this.Sb(),f=await this.Cb();return(0,g.$sMb)(r||"{}",t.settings,t.settings,a,[],f).remoteContent!==null}async rb(s,t){const n=await this.Cb(),r=await this.Sb();return{...s.previewResult,content:s.previewResult.content?(0,g.$rMb)(s.previewResult.content,"{}",r,n):null}}async sb(s,t,n,r){const a=await this.Cb(),f=await this.Sb();if(this.h.isEqual(t,this.localResource))return{content:s.fileContent?(0,g.$rMb)(s.fileContent.value.toString(),"{}",f,a):null,localChange:w.Change.None,remoteChange:w.Change.Modified};if(this.h.isEqual(t,this.remoteResource))return{content:s.remoteContent!==null?(0,g.$rMb)(s.remoteContent,s.fileContent?s.fileContent.value.toString():"{}",f,a):null,localChange:w.Change.Modified,remoteChange:w.Change.None};if(this.h.isEqual(t,this.previewResource))return n===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:n!==null?(0,g.$rMb)(n,s.fileContent?s.fileContent.value.toString():"{}",f,a):null,localChange:w.Change.Modified,remoteChange:w.Change.Modified};throw new Error(`Invalid Resource: ${t.toString()}`)}async tb(s,t,n,r){const{fileContent:a}=n[0][0];let{content:f,localChange:v,remoteChange:C}=n[0][1];if(v===w.Change.None&&C===w.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),f=f?f.trim():"{}",f=f||"{}",this.Vb(f),v!==w.Change.None&&(this.O.trace(`${this.D}: Updating local settings...`),a&&await this.nb(JSON.stringify(this.Ob(a.value.toString()))),await this.wb(f,a,r),await this.P.reloadConfiguration(N.ConfigurationTarget.USER_LOCAL),this.O.info(`${this.D}: Updated local settings`)),C!==w.Change.None){const b=await this.Cb(),E=this.Mb(s),T=await this.Sb(f);f=(0,g.$rMb)(f,E?E.settings:"{}",T,b),this.O.trace(`${this.D}: Updating remote settings...`),s=await this.mb(JSON.stringify(this.Ob(f)),r?null:s.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}t?.ref!==s.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(s),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const s=await this.vb();if(s)return!(0,g.$tMb)(s.value.toString())}catch(s){if(s.fileOperationResult!==d.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(s){return this.h.isEqual(this.remoteResource,s)||this.h.isEqual(this.localResource,s)||this.h.isEqual(this.acceptedResource,s)||this.h.isEqual(this.baseResource,s)?this.db(s):null}async db(s){let t=await super.db(s);if(t){const n=await this.Cb(),r=await this.Sb();t=(0,g.$rMb)(t,"{}",r,n)}return t}Mb(s){return s.syncData?this.Nb(s.syncData.content):null}Nb(s){try{return m(s)}catch(t){this.O.error(t)}return null}Ob(s){return{settings:s}}async Sb(s){if(this.Pb||(this.Pb=this.zb.resolveDefaultCoreIgnoredSettings()),this.Qb||(this.Qb=this.Tb()),!this.Rb){this.Rb=this.Ub();const n=this.B(A.Event.any(A.Event.filter(this.Fb.onDidInstallExtensions,r=>r.some(({local:a})=>!!a)),A.Event.filter(this.Fb.onDidUninstallExtension,r=>!r.error))(()=>{n.dispose(),this.Rb=void 0}))}const t=(await Promise.all([this.Pb,this.Qb,this.Rb])).flat();return(0,g.$pMb)(t,this.P,s)}async Tb(){const s=await this.Fb.getInstalled(R.ExtensionType.System);return(0,I.$Lb)(s.map(t=>(0,w.$enb)(t.manifest)).flat())}async Ub(){const s=await this.Fb.getInstalled(R.ExtensionType.User,this.Eb.extensionsResource);return(0,I.$Lb)(s.map(t=>(0,w.$enb)(t.manifest)).flat())}Vb(s){if(this.Ab(s,!1))throw new w.$snb((0,L.localize)(10906,null),w.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}};e.$acc=o,e.$acc=o=ve([Q(2,d.$9k),Q(3,k.$Ji),Q(4,u.$eq),Q(5,w.$nnb),Q(6,w.$onb),Q(7,w.$Cnb),Q(8,w.$Bnb),Q(9,N.$9i),Q(10,w.$xnb),Q(11,$.$8l),Q(12,y.$kp),Q(13,l.$Gl)],o);let h=class extends S.$UNb{constructor(s,t,n,r,a,f){super(w.SyncResource.Settings,t,n,r,s,a,f)}async o(s){const t=s.syncData?this.p(s.syncData.content):null;if(!t){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,c.$Le.fromString(t.settings)),await this.n(s)}async i(){try{const s=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,g.$tMb)(s.value.toString().trim())}catch(s){return s.fileOperationResult===d.FileOperationResult.FILE_NOT_FOUND}}p(s){try{return m(s)}catch(t){this.j.error(t)}return null}};e.$bcc=h,e.$bcc=h=ve([Q(0,d.$9k),Q(1,p.$Il),Q(2,k.$Ji),Q(3,w.$Cnb),Q(4,u.$eq),Q(5,l.$Gl)],h)}),define(he[123],ue([0,1,14,3,29,21,15,7,16,18,28,19,40,207,24]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gcc=e.$fcc=void 0,e.$ecc=p;function p(w){return JSON.parse(w.content)}let S=class extends u.$RNb{constructor(P,m,o,h,i,s,t,n,r,a,f,v){super({syncResource:l.SyncResource.Snippets,profile:P},m,h,o,i,s,t,a,f,n,r,v),this.pb=1,this.vb=P.snippetsHome,this.B(this.G.watch(o.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(c.Event.filter(this.G.onDidFilesChange,C=>C.affects(this.vb))(()=>this.Q()))}async qb(P,m,o){const h=await this.Hb(),i=this.Gb(h),s=P.syncData?this.Fb(P.syncData):null;m=m===null&&o?P:m;const t=m&&m.syncData?this.Fb(m.syncData):null;s?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,$.$ccc)(i,s,t);return this.Bb(n,h,s||{},t||{})}async ub(P){const m=P.syncData?this.Fb(P.syncData):null;if(m===null)return!0;const o=await this.Hb(),h=this.Gb(o),i=(0,$.$ccc)(h,m,m);return Object.keys(i.remote.added).length>0||Object.keys(i.remote.updated).length>0||i.remote.removed.length>0||i.conflicts.length>0}async rb(P,m){return P.previewResult}async sb(P,m,o,h){if(this.h.isEqualOrParent(m,this.g.with({scheme:l.$Enb,authority:"local"})))return{content:P.fileContent?P.fileContent.value.toString():null,localChange:l.Change.None,remoteChange:P.fileContent?P.remoteContent!==null?l.Change.Modified:l.Change.Added:l.Change.Deleted};if(this.h.isEqualOrParent(m,this.g.with({scheme:l.$Enb,authority:"remote"})))return{content:P.remoteContent,localChange:P.remoteContent!==null?P.fileContent?l.Change.Modified:l.Change.Added:l.Change.Deleted,remoteChange:l.Change.None};if(this.h.isEqualOrParent(m,this.g))return o===void 0?{content:P.previewResult.content,localChange:P.previewResult.localChange,remoteChange:P.previewResult.remoteChange}:{content:o,localChange:o===null?P.fileContent!==null?l.Change.Deleted:l.Change.None:l.Change.Modified,remoteChange:o===null?P.remoteContent!==null?l.Change.Deleted:l.Change.None:l.Change.Modified};throw new Error(`Invalid Resource: ${m.toString()}`)}async tb(P,m,o,h){const i=o.map(([s,t])=>({...s,acceptResult:t}));i.every(({localChange:s,remoteChange:t})=>s===l.Change.None&&t===l.Change.None)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),i.some(({localChange:s})=>s!==l.Change.None)&&(await this.Cb(i),await this.Db(i,h)),i.some(({remoteChange:s})=>s!==l.Change.None)&&(P=await this.Eb(i,P,h)),m?.ref!==P.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(P),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:s}of i)try{await this.G.del(s)}catch{}}Bb(P,m,o,h){const i=new Map;for(const s of Object.keys(P.local.added)){const t={content:P.local.added[s],hasConflicts:!1,localChange:l.Change.Added,remoteChange:l.Change.None};i.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:l.$Enb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,s).with({scheme:l.$Enb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,s).with({scheme:l.$Enb,authority:"remote"}),remoteContent:o[s],previewResource:this.h.joinPath(this.g,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:l.$Enb,authority:"accepted"})})}for(const s of Object.keys(P.local.updated)){const t={content:P.local.updated[s],hasConflicts:!1,localChange:l.Change.Modified,remoteChange:l.Change.None},n=m[s]?m[s].value.toString():null;i.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:l.$Enb,authority:"base"}),baseContent:h[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:l.$Enb,authority:"local"}),fileContent:m[s],localContent:n,remoteResource:this.h.joinPath(this.g,s).with({scheme:l.$Enb,authority:"remote"}),remoteContent:o[s],previewResource:this.h.joinPath(this.g,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:l.$Enb,authority:"accepted"})})}for(const s of P.local.removed){const t={content:null,hasConflicts:!1,localChange:l.Change.Deleted,remoteChange:l.Change.None},n=m[s]?m[s].value.toString():null;i.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:l.$Enb,authority:"base"}),baseContent:h[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:l.$Enb,authority:"local"}),fileContent:m[s],localContent:n,remoteResource:this.h.joinPath(this.g,s).with({scheme:l.$Enb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:l.$Enb,authority:"accepted"})})}for(const s of Object.keys(P.remote.added)){const t={content:P.remote.added[s],hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Added},n=m[s]?m[s].value.toString():null;i.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:l.$Enb,authority:"base"}),baseContent:h[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:l.$Enb,authority:"local"}),fileContent:m[s],localContent:n,remoteResource:this.h.joinPath(this.g,s).with({scheme:l.$Enb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:l.$Enb,authority:"accepted"})})}for(const s of Object.keys(P.remote.updated)){const t={content:P.remote.updated[s],hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Modified},n=m[s]?m[s].value.toString():null;i.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:l.$Enb,authority:"base"}),baseContent:h[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:l.$Enb,authority:"local"}),fileContent:m[s],localContent:n,remoteResource:this.h.joinPath(this.g,s).with({scheme:l.$Enb,authority:"remote"}),remoteContent:o[s],previewResource:this.h.joinPath(this.g,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:l.$Enb,authority:"accepted"})})}for(const s of P.remote.removed){const t={content:null,hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Deleted};i.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:l.$Enb,authority:"base"}),baseContent:h[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:l.$Enb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,s).with({scheme:l.$Enb,authority:"remote"}),remoteContent:o[s],previewResource:this.h.joinPath(this.g,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:l.$Enb,authority:"accepted"})})}for(const s of P.conflicts){const t={content:h[s]??null,hasConflicts:!0,localChange:m[s]?l.Change.Modified:l.Change.Added,remoteChange:o[s]?l.Change.Modified:l.Change.Added},n=m[s]?m[s].value.toString():null;i.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:l.$Enb,authority:"base"}),baseContent:h[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:l.$Enb,authority:"local"}),fileContent:m[s]||null,localContent:n,remoteResource:this.h.joinPath(this.g,s).with({scheme:l.$Enb,authority:"remote"}),remoteContent:o[s]||null,previewResource:this.h.joinPath(this.g,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:l.$Enb,authority:"accepted"})})}for(const s of Object.keys(m))if(!i.has(s)){const t={content:m[s]?m[s].value.toString():null,hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.None},n=m[s]?m[s].value.toString():null;i.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:l.$Enb,authority:"base"}),baseContent:h[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:l.$Enb,authority:"local"}),fileContent:m[s]||null,localContent:n,remoteResource:this.h.joinPath(this.g,s).with({scheme:l.$Enb,authority:"remote"}),remoteContent:o[s]||null,previewResource:this.h.joinPath(this.g,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:l.$Enb,authority:"accepted"})})}return[...i.values()]}async resolveContent(P){return this.h.isEqualOrParent(P,this.g.with({scheme:l.$Enb,authority:"remote"}))||this.h.isEqualOrParent(P,this.g.with({scheme:l.$Enb,authority:"local"}))||this.h.isEqualOrParent(P,this.g.with({scheme:l.$Enb,authority:"base"}))||this.h.isEqualOrParent(P,this.g.with({scheme:l.$Enb,authority:"accepted"}))?this.db(P):null}async hasLocalData(){try{const P=await this.Hb();if(Object.keys(P).length)return!0}catch{}return!1}async Cb(P){const m={};for(const o of P)o.fileContent&&(m[this.h.basename(o.localResource)]=o.fileContent);await this.nb(JSON.stringify(this.Gb(m)))}async Db(P,m){for(const{fileContent:o,acceptResult:h,localResource:i,remoteResource:s,localChange:t}of P)if(t!==l.Change.None){const n=s?this.h.basename(s):this.h.basename(i),r=this.h.joinPath(this.vb,n);t===l.Change.Deleted?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):t===l.Change.Added?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,I.$Le.fromString(h.content),{overwrite:m}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,I.$Le.fromString(h.content),m?void 0:o),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(P,m,o){const h=m.syncData?this.Fb(m.syncData):{},i=(0,A.$ao)(h);for(const{acceptResult:s,localResource:t,remoteResource:n,remoteChange:r}of P)if(r!==l.Change.None){const a=t?this.h.basename(t):this.h.basename(n);r===l.Change.Deleted?delete i[a]:i[a]=s.content}return(0,$.$dcc)(h,i)||(this.O.trace(`${this.D}: Updating remote snippets...`),m=await this.mb(JSON.stringify(i),o?null:m.ref),this.O.info(`${this.D}: Updated remote snippets`)),m}Fb(P){return p(P)}Gb(P){const m={};for(const o of Object.keys(P))m[o]=P[o].value.toString();return m}async Hb(){const P={};let m;try{m=await this.G.resolve(this.vb)}catch(o){if(o instanceof O.$rl&&o.fileOperationResult===O.FileOperationResult.FILE_NOT_FOUND)return P;throw o}for(const o of m.children||[]){const h=o.resource,i=this.h.extname(h);if(i===".json"||i===".code-snippets"){const s=this.h.relativePath(this.vb,h),t=await this.G.readFile(h);P[s]=t}}return P}};e.$fcc=S,e.$fcc=S=ve([Q(2,N.$Ji),Q(3,O.$9k),Q(4,k.$eq),Q(5,l.$nnb),Q(6,l.$onb),Q(7,l.$Cnb),Q(8,L.$9i),Q(9,l.$xnb),Q(10,y.$8l),Q(11,R.$Gl)],S);let g=class extends u.$UNb{constructor(P,m,o,h,i,s){super(l.SyncResource.Snippets,m,o,h,P,i,s)}async o(P){const m=P.syncData?JSON.parse(P.syncData.content):null;if(!m){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const h of Object.keys(m)){const i=m[h];if(i){const s=this.d.joinPath(this.g.defaultProfile.snippetsHome,h);await this.k.createFile(s,I.$Le.fromString(i)),this.j.info("Created snippet",this.d.basename(s))}}await this.n(P)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(P){return P.fileOperationResult===O.FileOperationResult.FILE_NOT_FOUND}}};e.$gcc=g,e.$gcc=g=ve([Q(0,O.$9k),Q(1,d.$Il),Q(2,N.$Ji),Q(3,l.$Cnb),Q(4,k.$eq),Q(5,R.$Gl)],g)}),define(he[124],ue([0,1,14,21,15,7,16,18,28,19,40,24]),function(oe,e,I,c,A,L,N,O,k,y,R,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jcc=e.$icc=void 0,e.$hcc=u;function u(S,g){try{return JSON.parse(S).tasks??null}catch(w){return g.error(w),null}}let $=class extends R.$SNb{constructor(g,w,P,m,o,h,i,s,t,n,r,a){super(g.tasksResource,{syncResource:d.SyncResource.Tasks,profile:g},w,s,t,n,P,m,i,r,o,h,a),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:d.$Enb,authority:"base"}),this.Cb=this.Ab.with({scheme:d.$Enb,authority:"local"}),this.Db=this.Ab.with({scheme:d.$Enb,authority:"remote"}),this.Eb=this.Ab.with({scheme:d.$Enb,authority:"accepted"})}async qb(g,w,P,m){const o=g.syncData?u(g.syncData.content,this.O):null;w=w===null&&P?g:w;const h=w?.syncData?u(w.syncData.content,this.O):null,i=await this.vb();let s=null,t=!1,n=!1,r=!1;if(g.syncData){const v=i?i.value.toString():null;if(!h||h!==v||h!==o){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const C=p(v,o,h);s=C.content,r=C.hasConflicts,t=C.hasLocalChanged,n=C.hasRemoteChanged}}else i&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),s=i.value.toString(),n=!0);const a={content:r?h:s,localChange:t?i?d.Change.Modified:d.Change.Added:d.Change.None,remoteChange:n?d.Change.Modified:d.Change.None,hasConflicts:r},f=i?i.value.toString():null;return[{fileContent:i,baseResource:this.Bb,baseContent:h,localResource:this.Cb,localContent:f,localChange:a.localChange,remoteResource:this.Db,remoteContent:o,remoteChange:a.remoteChange,previewResource:this.Ab,previewResult:a,acceptedResource:this.Eb}]}async ub(g){const w=g?.syncData?u(g.syncData.content,this.O):null;if(w===null)return!0;const P=await this.vb(),m=P?P.value.toString():null,o=p(m,w,w);return o.hasLocalChanged||o.hasRemoteChanged}async rb(g,w){return g.previewResult}async sb(g,w,P,m){if(this.h.isEqual(w,this.Cb))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:d.Change.None,remoteChange:d.Change.Modified};if(this.h.isEqual(w,this.Db))return{content:g.remoteContent,localChange:d.Change.Modified,remoteChange:d.Change.None};if(this.h.isEqual(w,this.Ab))return P===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:P,localChange:d.Change.Modified,remoteChange:d.Change.Modified};throw new Error(`Invalid Resource: ${w.toString()}`)}async tb(g,w,P,m){const{fileContent:o}=P[0][0],{content:h,localChange:i,remoteChange:s}=P[0][1];if(i===d.Change.None&&s===d.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),i!==d.Change.None&&(this.O.trace(`${this.D}: Updating local tasks...`),o&&await this.nb(JSON.stringify(this.Kb(o.value.toString()))),h?await this.wb(h,o,m):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),s!==d.Change.None){this.O.trace(`${this.D}: Updating remote tasks...`);const t=JSON.stringify(this.Kb(h));g=await this.mb(t,m?null:g.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}w?.ref!==g.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(g),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(g){return this.h.isEqual(this.Db,g)||this.h.isEqual(this.Bb,g)||this.h.isEqual(this.Cb,g)||this.h.isEqual(this.Eb,g)?this.db(g):null}Kb(g){return g?{tasks:g}:{}}};e.$icc=$,e.$icc=$=ve([Q(2,d.$nnb),Q(3,d.$onb),Q(4,d.$Cnb),Q(5,c.$9i),Q(6,d.$xnb),Q(7,L.$9k),Q(8,A.$Ji),Q(9,N.$eq),Q(10,O.$8l),Q(11,k.$Gl)],$);let l=class extends R.$UNb{constructor(g,w,P,m,o,h){super(d.SyncResource.Tasks,w,P,m,g,o,h),this.c=this.g.defaultProfile.tasksResource}async o(g){const w=g.syncData?u(g.syncData.content,this.j):null;if(!w){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,I.$Le.fromString(w)),await this.n(g)}async p(){return this.k.exists(this.c)}};e.$jcc=l,e.$jcc=l=ve([Q(0,L.$9k),Q(1,y.$Il),Q(2,A.$Ji),Q(3,d.$Cnb),Q(4,N.$eq),Q(5,k.$Gl)],l);function p(S,g,w){if(S===null&&g===null&&w===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(S===g)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const P=w!==S,m=w!==g;return!P&&!m?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:P&&!m?{content:S,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:m&&!P?{content:g,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:S,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(he[125],ue([0,1,45,21,15,7,16,18,28,19,40,208,24]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=void 0,e.$4dc=l,e.$5dc=p;let $=class extends R.$RNb{constructor(g,w,P,m,o,h,i,s,t,n,r,a,f){super({syncResource:u.SyncResource.Profiles,profile:g},w,m,o,h,i,s,r,a,t,n,f),this.vb=P,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:u.$Enb,authority:"base"}),this.localResource=this.previewResource.with({scheme:u.$Enb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.$Enb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.$Enb,authority:"accepted"}),this.B(P.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const g=await this.getLastSyncUserData();return g?.syncData?p(g.syncData):null}async getRemoteSyncedProfiles(g){const w=await this.getLastSyncUserData(),P=await this.X(g,w);return P?.syncData?p(P.syncData):null}async qb(g,w,P){if(!this.vb.isEnabled())throw new u.$snb("Cannot sync profiles because they are disabled",u.UserDataSyncErrorCode.LocalError);const m=g.syncData?p(g.syncData):null,o=w?.syncData?p(w.syncData):null,h=this.Db(),{local:i,remote:s}=(0,d.$2dc)(h,m,o,[]),t={local:i,remote:s,content:o?this.Eb(o):null,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?u.Change.Modified:u.Change.None,remoteChange:s!==null?u.Change.Modified:u.Change.None},n=l(h,!1);return[{baseResource:this.baseResource,baseContent:o?this.Eb(o):null,localResource:this.localResource,localContent:n,remoteResource:this.remoteResource,remoteContent:m?this.Eb(m):null,remoteProfiles:m,previewResource:this.previewResource,previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.acceptedResource}]}async ub(g){const w=g?.syncData?p(g.syncData):null,P=this.Db(),{remote:m}=(0,d.$2dc)(P,w,w,[]);return!!m?.added.length||!!m?.removed.length||!!m?.updated.length}async rb(g,w){return{...g.previewResult,hasConflicts:!1}}async sb(g,w,P,m){if(this.h.isEqual(w,this.localResource))return this.Ab(g);if(this.h.isEqual(w,this.remoteResource))return this.Bb(g);if(this.h.isEqual(w,this.previewResource))return g.previewResult;throw new Error(`Invalid Resource: ${w.toString()}`)}async Ab(g){const w=this.Db(),P=(0,d.$2dc)(w,null,null,[]),{local:m,remote:o}=P;return{content:g.localContent,local:m,remote:o,localChange:m.added.length>0||m.removed.length>0||m.updated.length>0?u.Change.Modified:u.Change.None,remoteChange:o!==null?u.Change.Modified:u.Change.None}}async Bb(g){const w=g.remoteContent?JSON.parse(g.remoteContent):null,P=[],m=[];for(const o of this.Db()){const h=w?.find(i=>i.id===o.id);h&&(P.push({id:o.id,name:o.name,collection:h.collection}),m.push(o))}if(w!==null){const o=(0,d.$2dc)(m,w,P,[]),{local:h,remote:i}=o;return{content:g.remoteContent,local:h,remote:i,localChange:h.added.length>0||h.removed.length>0||h.updated.length>0?u.Change.Modified:u.Change.None,remoteChange:i!==null?u.Change.Modified:u.Change.None}}else return{content:g.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:u.Change.None,remoteChange:u.Change.None}}async tb(g,w,P,m){const{local:o,remote:h,localChange:i,remoteChange:s}=P[0][1];i===u.Change.None&&s===u.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const t=P[0][0].remoteProfiles||[];if(t.length+(h?.added.length??0)-(h?.removed.length??0)>20)throw new u.$snb("Too many profiles to sync. Please remove some profiles and try again.",u.UserDataSyncErrorCode.LocalTooManyProfiles);if(i!==u.Change.None&&(await this.nb(l(this.Db(),!1)),await Promise.all(o.removed.map(async n=>{this.O.trace(`${this.D}: Removing '${n.name}' profile...`),await this.vb.removeProfile(n),this.O.info(`${this.D}: Removed profile '${n.name}'.`)})),await Promise.all(o.added.map(async n=>{this.O.trace(`${this.D}: Creating '${n.name}' profile...`),await this.vb.createProfile(n.id,n.name,{shortName:n.shortName,icon:n.icon,useDefaultFlags:n.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${n.name}'.`)})),await Promise.all(o.updated.map(async n=>{const r=this.vb.profiles.find(a=>a.id===n.id);r?(this.O.trace(`${this.D}: Updating '${n.name}' profile...`),await this.vb.updateProfile(r,{name:n.name,shortName:n.shortName,icon:n.icon,useDefaultFlags:n.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${n.name}'.`)):this.O.info(`${this.D}: Could not find profile with id '${n.id}' to update.`)}))),s!==u.Change.None){this.O.trace(`${this.D}: Updating remote profiles...`);const n=[],r=t.length+(h?.added.length??0)<=20;if(r)for(const a of h?.added||[]){const f=await this.J.createCollection(this.F);n.push(f),t.push({id:a.id,name:a.name,collection:f,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const a of h?.removed||[])t.splice(t.findIndex(({id:f})=>a.id===f),1);for(const a of h?.updated||[]){const f=t.find(({id:v})=>a.id===v);f&&t.splice(t.indexOf(f),1,{...f,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{g=await this.updateRemoteProfiles(t,m?null:g.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&h?.added.length?` Added: ${JSON.stringify(h.added.map(a=>a.name))}.`:""}${h?.updated.length?` Updated: ${JSON.stringify(h.updated.map(a=>a.name))}.`:""}${h?.removed.length?` Removed: ${JSON.stringify(h.removed.map(a=>a.name))}.`:""}`)}catch(a){if(n.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const f of n)await this.J.deleteCollection(f,this.F)}throw a}for(const a of h?.removed||[])await this.J.deleteCollection(a.collection,this.F)}w?.ref!==g.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(g),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(g,w){return this.mb(this.Eb(g),w)}async hasLocalData(){return this.Db().length>0}async resolveContent(g){if(this.h.isEqual(this.remoteResource,g)||this.h.isEqual(this.baseResource,g)||this.h.isEqual(this.localResource,g)||this.h.isEqual(this.acceptedResource,g)){const w=await this.db(g);return w&&(0,I.$5n)(JSON.parse(w),{})}return null}Db(){return this.vb.profiles.filter(g=>!g.isDefault&&!g.isTransient)}Eb(g){return JSON.stringify([...g].sort((w,P)=>w.name.localeCompare(P.name)))}};e.$3dc=$,e.$3dc=$=ve([Q(2,y.$Il),Q(3,L.$9k),Q(4,A.$Ji),Q(5,N.$eq),Q(6,u.$nnb),Q(7,u.$onb),Q(8,u.$Cnb),Q(9,c.$9i),Q(10,u.$xnb),Q(11,O.$8l),Q(12,k.$Gl)],$);function l(S,g){const w=[...S].sort((P,m)=>P.name.localeCompare(m.name)).map(P=>({id:P.id,name:P.name}));return g?(0,I.$5n)(w,{}):JSON.stringify(w)}function p(S){return JSON.parse(S.content)}}),define(he[227],ue([0,1,3,2,5,15,16,18,24]),function(oe,e,I,c,A,L,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=void 0;const y="sync.enable";let R=class extends c.$Tc{constructor(u,$,l,p){super(),this.c=u,this.f=$,this.g=l,this.h=p,this.a=new I.$je,this.onDidChangeEnablement=this.a.event,this.b=new I.$je,this.onDidChangeResourceEnablement=this.b.event,this.B(u.onDidChangeValue(N.StorageScope.APPLICATION,void 0,this.B(new c.$Sc))(S=>this.m(S)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(y,N.StorageScope.APPLICATION,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(u){u&&!this.canToggleEnablement()||(this.f.publicLog2(y,{enabled:u}),this.c.store(y,u,N.StorageScope.APPLICATION,N.StorageTarget.MACHINE))}isResourceEnabled(u){return this.c.getBoolean((0,k.$wnb)(u),N.StorageScope.APPLICATION,!0)}setResourceEnablement(u,$){if(this.isResourceEnabled(u)!==$){const l=(0,k.$wnb)(u);this.j(l,$)}}getResourceSyncStateVersion(u){}j(u,$){this.c.store(u,$,N.StorageScope.APPLICATION,A.$p?N.StorageTarget.USER:N.StorageTarget.MACHINE)}m(u){if(y===u.key){this.a.fire(this.isEnabled());return}const $=k.$jnb.filter(l=>(0,k.$wnb)(l)===u.key)[0];if($){this.b.fire([$,this.isResourceEnabled($)]);return}}};e.$Pdc=R,e.$Pdc=R=ve([Q(0,N.$eq),Q(1,O.$8l),Q(2,L.$Ji),Q(3,k.$mnb)],R)}),define(he[228],ue([0,1,6,14,71,2,20,21,15,7,19,24]),function(oe,e,I,c,A,L,N,O,k,y,R,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=void 0;let u=class extends L.$Tc{constructor(l,p,S,g,w){super(),this.a=l,this.b=p,this.c=S,this.f=g,this.g=w,this.h()}async h(){for(const p of this.g.profiles)for(const S of d.$jnb)try{await this.m(this.j(S,p.isDefault?void 0:p.id))}catch(g){this.f.error(g)}let l;try{l=await this.b.resolve(this.a.userDataSyncHome)}catch(p){(0,y.$nl)(p)!==y.FileOperationResult.FILE_NOT_FOUND&&this.f.error(p);return}if(l.children){for(const p of l.children)if(p.isDirectory&&!this.g.profiles.some(S=>S.id===p.name))try{this.f.info("Deleting non existing profile from backup",p.resource.path),await this.b.del(p.resource,{recursive:!0})}catch(S){this.f.error(S)}}}async getAllResourceRefs(l,p,S){const g=this.j(l,p,S);try{const w=await this.b.resolve(g);if(w.children)return w.children.filter(m=>m.isFile&&!m.name.startsWith("lastSync")).sort().reverse().map(m=>({ref:m.name,created:this.n(m)}))}catch(w){if((0,y.$nl)(w)!==y.FileOperationResult.FILE_NOT_FOUND)throw w}return[]}async resolveResourceContent(l,p,S,g){const w=this.j(l,S,g),P=(0,N.$dh)(w,p);try{return(await this.b.readFile(P)).value.toString()}catch(m){return this.f.error(m),null}}async writeResource(l,p,S,g,w){const P=this.j(l,g,w),m=(0,N.$dh)(P,`${(0,A.$Zm)(S).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(m,c.$Le.fromString(p))}catch(o){this.f.error(o)}}j(l,p,S=this.a.userDataSyncHome){return(0,N.$dh)(S,...p?[p,l]:[l])}async m(l){try{try{if(!await this.b.exists(l))return}catch{return}const p=await this.b.resolve(l);if(p.children){const S=p.children.filter(m=>m.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(m.name)).sort(),g=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let w=S.filter(m=>Date.now()-this.n(m)>g);const P=S.length-w.length;P<10&&(w=w.slice(10-P)),await I.Promises.settled(w.map(async m=>{this.f.info("Deleting from backup",m.resource.path),await this.b.del(m.resource)}))}}catch(p){this.f.error(p)}}n(l){return new Date(parseInt(l.name.substring(0,4)),parseInt(l.name.substring(4,6))-1,parseInt(l.name.substring(6,8)),parseInt(l.name.substring(9,11)),parseInt(l.name.substring(11,13)),parseInt(l.name.substring(13,15))).getTime()}};e.$1dc=u,e.$1dc=u=ve([Q(0,k.$Ji),Q(1,y.$9k),Q(2,O.$9i),Q(3,d.$Cnb),Q(4,R.$Il)],u)}),define(he[86],ue([0,1,3,2,5,26,11,15,7,4,23,49,16,24]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$bnb=e.$_mb=void 0,e.$anb=o,e.$_mb=(0,y.$Ci)("IUserDataSyncMachinesService");const p="sync.currentMachineName",S="Safari",g="Chrome",w="Edge",P="Firefox",m="Android";function o(s){switch(s){case S:case g:case w:case P:case m:case(0,A.$i)(A.Platform.Web):return!0}return!1}function h(){return A.$H?S:A.$F?g:A.$I?w:A.$G?P:A.$J?m:(0,A.$i)(A.$p?A.Platform.Web:A.$v)}let i=class extends c.$Tc{static{l=this}static{this.a=1}static{this.b="machines"}constructor(t,n,r,a,f,v){super(),this.h=r,this.j=a,this.m=f,this.n=v,this.c=this.B(new I.$je),this.onDidChange=this.c.event,this.g=null,this.f=(0,d.$kq)(t,n,r)}async getMachines(t){const n=await this.f;return(await this.s(t)).machines.map(a=>({...a,isCurrent:a.id===n}))}async addCurrentMachine(t){const n=await this.f,r=await this.s(t);r.machines.some(({id:a})=>a===n)||(r.machines.push({id:n,name:this.r(r.machines),platform:h()}),await this.t(r))}async removeCurrentMachine(t){const n=await this.f,r=await this.s(t),a=r.machines.filter(({id:f})=>f!==n);a.length!==r.machines.length&&(r.machines=a,await this.t(r))}async renameMachine(t,n,r){const a=await this.s(r),f=a.machines.find(({id:v})=>v===t);if(f){f.name=n,await this.t(a);const v=await this.f;t===v&&this.h.store(p,n,u.StorageScope.APPLICATION,u.StorageTarget.MACHINE)}}async setEnablements(t){const n=await this.s();for(const[r,a]of t){const f=n.machines.find(v=>v.id===r);f&&(f.disabled=a?void 0:!0)}await this.t(n)}r(t){const n=this.h.get(p,u.StorageScope.APPLICATION);if(n)return n;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${h()} (${this.n.nameShort})`,a=new RegExp(`${(0,L.$ff)(r)}\\s#(\\d+)`);let f=0;for(const v of t){const C=a.exec(v.name),b=C?parseInt(C[1]):0;f=b>f?b:f}return`${r} #${f+1}`}async s(t){this.g=await this.u(t);const n=this.w(this.g);if(n.version!==l.a)throw new Error((0,N.localize)(10892,null,this.n.nameLong));return n}async t(t){const n=JSON.stringify(t),r=await this.j.writeResource(l.b,n,this.g?.ref||null);this.g={ref:r,content:n},this.c.fire()}async u(t){if(this.g){const n=t&&t.latest?t.latest[l.b]:void 0;if(this.g.ref===n)return this.g;if(n===void 0&&this.g.content===null)return this.g}return this.j.readResource(l.b,this.g)}w(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(n){this.m.error(n)}return{version:l.a,machines:[]}}};e.$bnb=i,e.$bnb=i=l=ve([Q(0,O.$Ji),Q(1,k.$9k),Q(2,u.$eq),Q(3,$.$nnb),Q(4,$.$Cnb),Q(5,R.$pk)],i)}),define(he[229],ue([0,1,6,71,43,8,3,2,5,20,9,11,23,16,18,24,82,86]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$,l,p,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=void 0;const w="sync.disableMachineEventually",P="sync.sessionId",m="sync.storeUrl",o="sync.productQuality";let h=class extends O.$Tc{get n(){const t=this.H.get(m,$.StorageScope.APPLICATION);return t?R.URI.parse(t):void 0}set n(t){t?this.H.store(m,t.toString(),$.StorageScope.APPLICATION,$.StorageTarget.MACHINE):this.H.remove(m,$.StorageScope.APPLICATION)}get s(){return this.H.get(o,$.StorageScope.APPLICATION)}set s(t){t?this.H.store(o,t,$.StorageScope.APPLICATION,$.StorageTarget.MACHINE):this.H.remove(o,$.StorageScope.APPLICATION)}constructor(t,n,r,a,f,v,C,b,E,T){super(),this.u=n,this.w=r,this.y=a,this.z=f,this.C=v,this.D=C,this.F=b,this.G=E,this.H=T,this.a=this.B(new O.$Uc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new N.$je),this.onError=this.h.event,this.S=[],this.f=this.B(new I.$Ah(this.U())),this.j=this.n,this.n=n.userDataSyncStore?.url,this.r=this.s,this.s=t.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(n.onDidChangeUserDataSyncStore(()=>{(0,y.$9g)(this.n,n.userDataSyncStore?.url)||(this.j=this.n,this.n=n.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(C.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(f.onDidChangeLocal(j=>this.triggerSync([j],!1,!1))),this.B(N.Event.filter(this.y.onDidChangeResourceEnablement,([,j])=>j)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:t,message:n}=this.L();t?this.a.value===void 0&&(this.a.value=new i(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(n&&this.C.info(n),this.a.clear()):n&&this.y.isEnabled()&&this.C.info(n))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,c.$Zm)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(t,n,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(P,$.StorageScope.APPLICATION),t?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(a){if(this.C.error(a),n)this.M(!1);else throw a}}M(t){this.y.isEnabled()!==t&&(this.y.setEnablement(t),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(t){if(!t){this.b=0;return}const n=p.$snb.toUserDataSyncError(t);n instanceof p.$unb&&this.F.publicLog2("autosync/error",{code:n.code,service:this.u.userDataSyncStore.url.toString()}),n.code===p.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):n.code===p.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):n.code===p.UserDataSyncErrorCode.LocalTooManyRequests?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):n.code===p.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):n.code===p.UserDataSyncErrorCode.MethodNotFound?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):n.code===p.UserDataSyncErrorCode.UpgradeRequired||n.code===p.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):n.code===p.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${n.resource} content with newer version than of client. Requires client upgrade.`)):n.code===p.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${n.resource} content with older version than of client. Requires server reset.`)):n.code===p.UserDataSyncErrorCode.ServiceChanged||n.code===p.UserDataSyncErrorCode.DefaultServiceChanged?k.$p&&n.code===p.UserDataSyncErrorCode.DefaultServiceChanged&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(n),this.b++),this.h.fire(n)}async P(){this.H.store(w,!0,$.StorageScope.APPLICATION,$.StorageTarget.MACHINE),await(0,I.$Dh)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(w,$.StorageScope.APPLICATION,!1)}R(){this.H.remove(w,$.StorageScope.APPLICATION)}async triggerSync(t,n,r){if(this.a.value===void 0)return this.f.cancel();if(n&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...t),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const a=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:a}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$7dc=h,e.$7dc=h=ve([Q(0,u.$pk),Q(1,p.$mnb),Q(2,p.$nnb),Q(3,p.$xnb),Q(4,p.$ynb),Q(5,p.$Cnb),Q(6,S.$_Lb),Q(7,l.$8l),Q(8,g.$_mb),Q(9,$.$eq)],h);class i extends O.$Tc{static{this.a="Interval"}constructor(t,n,r,a,f,v,C,b,E){super(),this.m=t,this.n=n,this.r=r,this.s=a,this.u=f,this.w=v,this.y=C,this.z=b,this.C=E,this.b=this.B(new O.$Uc),this.c=this.B(new N.$je),this.onDidStartSync=this.c.event,this.f=this.B(new N.$je),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,O.$Rc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(i.a,!1)}D(){this.b.value=(0,I.$Eh)(()=>{this.sync(i.a,!1),this.b.value=void 0},this.n)}sync(t,n){const r=(0,I.$ph)(async a=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(f){if((0,L.$3)(f))return}return this.H(t,n,a)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,y.$9g)(this.m,this.r.userDataSyncStore?.url)}async G(){const t=await this.r.getPreviousUserDataSyncStore(),n=this.r.userDataSyncStore;return!!n&&!!t&&(!(0,y.$9g)(n.defaultUrl,t.defaultUrl)||!(0,y.$9g)(n.insidersUrl,t.insidersUrl)||!(0,y.$9g)(n.stableUrl,t.stableUrl))}async H(t,n,r){this.y.info(`Auto Sync: Triggered by ${t}`),this.c.fire();let a;try{await this.I(n,r)}catch(f){if(this.y.error(f),a=f,p.$snb.toUserDataSyncError(f).code===p.UserDataSyncErrorCode.MethodNotFound)try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(n,r),a=void 0}catch(v){this.y.error(v),a=v}}this.f.fire(a)}async I(t,n){if(this.h=await this.u.createSyncTask(this.g,t),n.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new p.$unb((0,d.localize)(10899,null),p.UserDataSyncErrorCode.DefaultServiceChanged):new p.$unb((0,d.localize)(10900,null),p.UserDataSyncErrorCode.ServiceChanged):new p.$unb((0,d.localize)(10901,null),p.UserDataSyncErrorCode.TurnedOff);const r=this.C.get(P,$.StorageScope.APPLICATION);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new p.$unb((0,d.localize)(10902,null),p.UserDataSyncErrorCode.DefaultServiceChanged):new p.$unb((0,d.localize)(10903,null),p.UserDataSyncErrorCode.ServiceChanged):new p.$unb((0,d.localize)(10904,null),p.UserDataSyncErrorCode.SessionExpired);const a=await this.w.getMachines(this.g||void 0);if(n.isCancellationRequested)return;const f=a.find(C=>C.isCurrent);if(f?.disabled)throw new p.$unb((0,d.localize)(10905,null),p.UserDataSyncErrorCode.TurnedOff);const v=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-v}),this.g===null)try{this.g=await this.s.manifest(null)}catch(C){throw new p.$unb((0,A.$nj)(C),C instanceof p.$snb?C.code:p.UserDataSyncErrorCode.Unknown)}this.g&&this.g.session!==r&&this.C.store(P,this.g.session,$.StorageScope.APPLICATION,$.StorageTarget.MACHINE),!n.isCancellationRequested&&(f||await this.w.addCurrentMachine(this.g||void 0))}register(t){return super.B(t)}}}),define(he[230],ue([0,1,9,11,15,7,49,16,28,24,19,40,123,122,121,21,124,119,120,4,125,45,26]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$,l,p,S,g,w,P,m,o,h){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jec=void 0;let s=class{static{i=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(n,r,a,f,v,C,b,E,T,j){this.e=n,this.f=r,this.g=a,this.h=v,this.i=C,this.j=b,this.k=E,this.l=T,this.n=j,this.d=f.extUri}async getRemoteSyncedProfiles(){const n=await this.e.readResource(y.SyncResource.Profiles,null,void 0);if(n.content){const r=this.L(n.content,y.SyncResource.Profiles);return(0,m.$5dc)(r)}return[]}async getLocalSyncedProfiles(n){const r=await this.f.getAllResourceRefs(y.SyncResource.Profiles,void 0,n);if(r.length){const a=await this.f.resolveResourceContent(y.SyncResource.Profiles,r[0].ref,void 0,n);if(a){const f=this.L(a,y.SyncResource.Profiles);return(0,m.$5dc)(f)}}return[]}async getLocalSyncedMachines(n){const r=await this.f.getAllResourceRefs("machines",void 0,n);if(r.length){const a=await this.f.resolveResourceContent("machines",r[0].ref,void 0,n);if(a)return JSON.parse(a).machines.map(v=>({...v,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(n,r){return(await this.e.getAllResourceRefs(n,r?.collection)).map(({created:f,ref:v})=>({created:f,uri:this.J({remote:!0,syncResource:n,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:v,node:void 0})}))}async getLocalSyncResourceHandles(n,r,a){return(await this.f.getAllResourceRefs(n,r?.collection,a)).map(({created:v,ref:C})=>({created:v,uri:this.J({remote:!1,syncResource:n,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:C,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:n}){const r=this.K(n),a=r?this.k.profiles.find(f=>f.id===r.profile):void 0;return r&&a?{profile:a,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:n}){const r=this.K(n);if(!r)return[];const a=this.k.profiles.find(f=>f.id===r.profile);switch(r.syncResource){case y.SyncResource.Settings:return this.s(n,a);case y.SyncResource.Keybindings:return this.u(n,a);case y.SyncResource.Tasks:return this.w(n,a);case y.SyncResource.Snippets:return this.y(n,a);case y.SyncResource.GlobalState:return this.D(n,a);case y.SyncResource.Extensions:return this.A(n,a);case y.SyncResource.Profiles:return this.G(n,a);case y.SyncResource.WorkspaceState:return[]}}async getMachineId({uri:n}){const r=this.K(n);if(r){if(r.remote){if(r.ref){const{content:a}=await this.M(r.syncResource,r.ref,r.collection);if(a)return this.L(a,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const a=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(a)return this.L(a,r.syncResource)?.machineId}return}return(0,N.$kq)(this.h,this.j,this.i)}}async resolveContent(n){const r=this.K(n);if(!r||r.node===i.a)return null;if(r.ref){const a=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&a?this.q(r.syncResource,a,r.node):a}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(n,r,a,f,v){if(n){const{content:C}=await this.M(r,f,a);return C}return this.f.resolveResourceContent(r,f,a,v)}q(n,r,a){const f=this.L(r,n);switch(n){case y.SyncResource.Settings:return this.t(f,a);case y.SyncResource.Keybindings:return this.v(f,a);case y.SyncResource.Tasks:return this.x(f,a);case y.SyncResource.Snippets:return this.z(f,a);case y.SyncResource.GlobalState:return this.E(f,a);case y.SyncResource.Extensions:return this.B(f,a);case y.SyncResource.Profiles:return this.H(f,a);case y.SyncResource.WorkspaceState:return null}}async r(n,r){const a=this.k.profiles.find(f=>f.id===r);if(!a)return null;switch(n){case y.SyncResource.GlobalState:return this.F(a);case y.SyncResource.Extensions:return this.C(a);case y.SyncResource.Profiles:return this.I(a);case y.SyncResource.Settings:return null;case y.SyncResource.Keybindings:return null;case y.SyncResource.Tasks:return null;case y.SyncResource.Snippets:return null;case y.SyncResource.WorkspaceState:return null}}s(n,r){const a=this.d.joinPath(n,"settings.json"),f=r?r.settingsResource:this.d.joinPath(n,i.a);return[{resource:a,comparableResource:f}]}t(n,r){switch(r){case"settings.json":return(0,$.$_bc)(n.content).settings}return null}u(n,r){const a=this.d.joinPath(n,"keybindings.json"),f=r?r.keybindingsResource:this.d.joinPath(n,i.a);return[{resource:a,comparableResource:f}]}v(n,r){switch(r){case"keybindings.json":return(0,l.$9bc)(n.content,!!this.l.getValue(y.$gnb),this.g)}return null}w(n,r){const a=this.d.joinPath(n,"tasks.json"),f=r?r.tasksResource:this.d.joinPath(n,i.a);return[{resource:a,comparableResource:f}]}x(n,r){switch(r){case"tasks.json":return(0,S.$hcc)(n.content,this.g)}return null}async y(n,r){const a=await this.resolveContent(n);if(a){const f=this.L(a,y.SyncResource.Snippets);if(f){const v=(0,u.$ecc)(f),C=[];for(const b of Object.keys(v)){const E=this.d.joinPath(n,b),T=r?this.d.joinPath(r.snippetsHome,b):this.d.joinPath(n,i.a);C.push({resource:E,comparableResource:T})}return C}}return[]}z(n,r){return(0,u.$ecc)(n)[r]||null}A(n,r){const a=this.d.joinPath(n,"extensions.json"),f=r?this.J({remote:!1,syncResource:y.SyncResource.Extensions,profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(n,i.a);return[{resource:a,comparableResource:f}]}B(n,r){switch(r){case"extensions.json":return(0,g.$4bc)((0,g.$3bc)(n),!0)}return null}async C(n){const{localExtensions:r}=await this.n.createInstance(g.$6bc).getLocalExtensions(n);return(0,g.$4bc)(r,!0)}D(n,r){const a=this.d.joinPath(n,"globalState.json"),f=r?this.J({remote:!1,syncResource:y.SyncResource.GlobalState,profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(n,i.a);return[{resource:a,comparableResource:f}]}E(n,r){switch(r){case"globalState.json":return(0,w.$WNb)(JSON.parse(n.content),!0)}return null}async F(n){const r=await this.n.createInstance(w.$YNb).getLocalGlobalState(n);return(0,w.$WNb)(r,!0)}G(n,r){const a=this.d.joinPath(n,"profiles.json"),f=this.J({remote:!1,syncResource:y.SyncResource.Profiles,profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:f}]}H(n,r){switch(r){case"profiles.json":return(0,o.$5n)(JSON.parse(n.content),{})}return null}async I(n){return(0,m.$4dc)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(n){const r=n.remote?i.b:i.c,a=[];return n.location&&(a.push(`scheme:${n.location.scheme}`),a.push(`authority:${n.location.authority}`),a.push((0,h.$jf)(n.location.path,"/"))),a.push(`syncResource:${n.syncResource}`),a.push(`profile:${n.profile}`),n.collection&&a.push(`collection:${n.collection}`),n.ref&&a.push(`ref:${n.ref}`),n.node&&a.push(n.node),this.d.joinPath(I.URI.from({scheme:y.$Enb,authority:r,path:"/",query:n.location?.query,fragment:n.location?.fragment}),...a)}K(n){if(n.scheme!==y.$Enb)return;const r=[];for(;n.path!=="/";)r.unshift(this.d.basename(n)),n=this.d.dirname(n);if(r.length<2)return;const a=n.authority===i.b;let f,v;const C=[];let b,E,T,j,U;for(;r.length;){const F=r.shift();F.startsWith("scheme:")?f=F.substring(7):F.startsWith("authority:")?v=F.substring(10):F.startsWith("syncResource:")?b=F.substring(13):F.startsWith("profile:")?E=F.substring(8):F.startsWith("collection:")?T=F.substring(11):F.startsWith("ref:")?j=F.substring(4):b?U=F:C.push(F)}return{remote:a,syncResource:b,profile:E,collection:T,ref:j,node:U,location:f&&v!==void 0?this.d.joinPath(I.URI.from({scheme:f,authority:v,query:n.query,fragment:n.fragment,path:"/"}),...C):void 0}}L(n,r){try{const a=JSON.parse(n);if((0,d.$PNb)(a))return a}catch(a){this.g.error(a)}throw new y.$snb((0,c.localize)(10891,null),y.UserDataSyncErrorCode.IncompatibleRemoteContent,r)}async M(n,r,a){const f=await this.e.resolveResourceContent(n,r,a);return{ref:r,content:f}}};e.$Jec=s,e.$Jec=s=i=ve([Q(0,y.$nnb),Q(1,y.$onb),Q(2,y.$Cnb),Q(3,k.$Gl),Q(4,A.$Ji),Q(5,O.$eq),Q(6,L.$9k),Q(7,R.$Il),Q(8,p.$9i),Q(9,P.$Bi)],s)}),define(he[231],ue([0,1,17,6,25,43,3,2,20,12,31,21,27,7,4,16,18,19,119,120,121,122,123,124,125,24]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$,l,p,S,g,w,P,m,o,h,i,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6dc=void 0;const n="sync.lastSyncTime";let r=class extends O.$Tc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(b,E,T,j,U,F,K,W,x,G,ie){super(),this.C=b,this.D=E,this.F=T,this.G=j,this.H=U,this.I=F,this.J=K,this.L=W,this.M=x,this.N=G,this.O=ie,this.f=t.SyncStatus.Uninitialized,this.g=this.B(new N.$je),this.onDidChangeStatus=this.g.event,this.h=this.B(new N.$je),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new N.$je),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new N.$je),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new N.$je),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new N.$je),this.onDidResetLocal=this.w.event,this.y=this.B(new N.$je),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=T.userDataSyncStore?t.SyncStatus.Idle:t.SyncStatus.Uninitialized,this.t=this.J.getNumber(n,p.StorageScope.APPLICATION,void 0),this.B((0,O.$Rc)(()=>this.cb())),this.B(new c.$Oh(()=>this.W(),5*1e3)).schedule()}async createSyncTask(b,E){this.db(),this.H.info("Sync started.");const T=new Date().getTime(),j=(0,R.$Yg)();try{const W=(0,t.$rnb)(j);E&&(W["Cache-Control"]="no-cache"),b=await this.D.manifest(b,W)}catch(W){const x=t.$snb.toUserDataSyncError(W);throw v(x,j,this.F,this.I),x}const U=!1,F=this;let K;return{manifest:b,async run(){if(U)throw new Error("Can run a task only once");K=(0,c.$ph)(W=>F.P(b,!1,j,W)),await K.finally(()=>K=void 0),F.H.info(`Sync done. Took ${new Date().getTime()-T}ms`),F.ab()},stop(){return K?.cancel(),F.U()}}}async createManualSyncTask(){if(this.db(),this.L.isEnabled())throw new t.$snb("Cannot start manual sync when sync is enabled",t.UserDataSyncErrorCode.LocalError);this.H.info("Sync started.");const b=new Date().getTime(),E=(0,R.$Yg)(),T=(0,t.$rnb)(E);let j;try{j=await this.D.manifest(null,T)}catch(K){const W=t.$snb.toUserDataSyncError(K);throw v(W,E,this.F,this.I),W}await this.resetLocal();const U=this,F=new A.$ue;return{id:E,async merge(){return U.P(j,!0,E,F.token)},async apply(){try{try{await U.R(j,E,F.token)}catch(K){if(t.$snb.toUserDataSyncError(K).code===t.UserDataSyncErrorCode.MethodNotFound)U.H.info("Client is making invalid requests. Cleaning up data..."),await U.cleanUpRemoteData(),U.H.info("Applying manual sync again..."),await U.R(j,E,F.token);else throw K}}catch(K){throw U.H.error(K),K}U.H.info(`Sync done. Took ${new Date().getTime()-b}ms`),U.ab()},async stop(){F.cancel(),await U.U(),await U.resetLocal()}}}async P(b,E,T,j){this.n=[];try{this.status!==t.SyncStatus.HasConflicts&&this.Z(t.SyncStatus.Syncing);const U=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(U,b,E,T,j));const F=U.enabled.find(K=>K.resource===t.SyncResource.Profiles);if(F){const K=await F.getLastSyncedProfiles()||[];if(j.isCancellationRequested)return;await this.Q(K,b,E,T,j)}}finally{this.status!==t.SyncStatus.HasConflicts&&this.Z(t.SyncStatus.Idle),this.r.fire(this.n)}}async Q(b,E,T,j,U){for(const F of b){if(U.isCancellationRequested)return;const K=this.M.profiles.find(x=>x.id===F.id);if(!K){this.H.error(`Profile with id:${F.id} and name: ${F.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",F.name);const W=this.getOrCreateActiveProfileSynchronizer(K,F);this.n.push(...await this.S(W,E,T,j,U))}for(const[F,K]of this.z.entries())this.M.profiles.some(W=>W.id===K[0].profile.id)||(await K[0].resetLocal(),K[1].dispose(),this.z.delete(F))}async R(b,E,T){const j=this.bb();for(const x of j){if(T.isCancellationRequested)return;await x.apply(E,T)}const U=j.find(x=>x.profile.isDefault);if(!U)return;const F=U.enabled.find(x=>x.resource===t.SyncResource.Profiles);if(!F)return;const W=(await F.getRemoteSyncedProfiles(b?.latest??null)||[]).filter(x=>j.every(G=>G.profile.id!==x.id));W.length&&await this.Q(W,b,!1,E,T)}async S(b,E,T,j,U){return(await b.sync(E,T,j,U)).map(([K,W])=>({profile:b.profile,syncResource:K,error:W}))}async U(){this.status!==t.SyncStatus.Idle&&await Promise.allSettled(this.bb().map(b=>b.stop()))}async resolveContent(b){const E=await this.N.resolveContent(b);if(E)return E;for(const T of this.bb())for(const j of T.enabled){const U=await j.resolveContent(b);if(U)return U}return null}async replace(b){this.db();const E=this.N.resolveUserDataSyncResource(b);if(!E)return;const T=await this.resolveContent(b.uri);T&&await this.X(E.profile,async j=>{if(E.syncResource===j.resource)return await j.replace(T),!0})}async accept(b,E,T,j){this.db(),await this.X(b.profile,async U=>{if(b.syncResource===U.resource)return await U.accept(E,T),j&&await U.apply((0,y.$ig)(j)?!1:j.force,(0,t.$rnb)((0,R.$Yg)())),!0})}async hasLocalData(){return!!await this.X(this.M.defaultProfile,async E=>{if(E.resource!==t.SyncResource.GlobalState&&await E.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.X(this.M.defaultProfile,async E=>{if(await E.hasPreviouslySynced())return!0})}async reset(){this.db(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.db();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(b){this.H.error(b)}this.y.fire()}async resetLocal(){this.db(),this.t=void 0,this.J.remove(n,p.StorageScope.APPLICATION);for(const[b]of this.z.values())try{await b.resetLocal()}catch(E){this.H.error(E)}this.cb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async W(){const b=this.J.keys(p.StorageScope.APPLICATION,p.StorageTarget.MACHINE),E=[];for(const j of b){if(!j.endsWith(".lastSyncUserData"))continue;const U=j.split(".");U.length===3&&E.push([j,U[0]])}if(!E.length)return;const T=new O.$Sc;try{let j=this.z.get(this.M.defaultProfile.id)?.[0];j||(j=T.add(this.G.createInstance(a,this.M.defaultProfile,void 0)));const U=j.enabled.find(W=>W.resource===t.SyncResource.Profiles);if(!U)return;const K=(await U.getLastSyncedProfiles())?.map(W=>W.collection)??[];for(const[W,x]of E)K.includes(x)||(this.H.info(`Removing last sync state for stale profile: ${x}`),this.J.remove(W,p.StorageScope.APPLICATION))}finally{T.dispose()}}async cleanUpRemoteData(){const b=await this.N.getRemoteSyncedProfiles(),E=b.map(F=>F.collection),T=await this.D.getAllCollections(),j=T.filter(F=>!E.includes(F));j.length&&(this.H.info(`Deleting ${j.length} redundant collections on server`),await Promise.allSettled(j.map(F=>this.D.deleteCollection(F))),this.H.info("Deleted redundant collections on server"));const U=b.filter(F=>T.includes(F.collection));if(U.length!==b.length){const F=this.G.createInstance(s.$3dc,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await F.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await F.updateRemoteProfiles(U,null),this.H.info("Updated remote profiles on server")}finally{F.dispose()}}}async saveRemoteActivityData(b){this.db();const E=await this.D.getActivityData();await this.C.writeFile(b,E)}async extractActivityData(b,E){const T=(await this.C.readFile(b)).value.toString(),j=JSON.parse(T);if(j.resources)for(const U in j.resources)for(const F of j.resources[U])await this.O.writeResource(U,F.content,new Date(F.created*1e3),void 0,E);if(j.collections)for(const U in j.collections)for(const F in j.collections[U].resources)for(const K of j.collections[U].resources?.[F]??[])await this.O.writeResource(F,K.content,new Date(K.created*1e3),U,E)}async X(b,E){const T=new O.$Sc;try{const j=this.z.get(b.id);if(j){const x=await this.Y(j[0],E,T);return(0,y.$jg)(x)?null:x}if(b.isDefault){const x=T.add(this.G.createInstance(a,b,void 0)),G=await this.Y(x,E,T);return(0,y.$jg)(G)?null:G}if(this.M.isEnabled())return null;const U=T.add(this.G.createInstance(s.$3dc,b,void 0)),F=await this.D.manifest(null),W=(await U.getRemoteSyncedProfiles(F?.latest??null)||[]).find(x=>x.id===b.id);if(W){const x=T.add(this.G.createInstance(a,b,W.collection)),G=await this.Y(x,E,T);return(0,y.$jg)(G)?null:G}return null}finally{T.dispose()}}async Y(b,E,T){const j=[...b.enabled,...b.disabled.reduce((U,F)=>(F!==t.SyncResource.WorkspaceState&&U.push(T.add(b.createSynchronizer(F))),U),[])];for(const U of j){const F=await E(U);if(!(0,y.$jg)(F))return F}}Z(b){const E=this.f;this.f!==b&&(this.f=b,this.g.fire(b),E===t.SyncStatus.HasConflicts&&this.ab())}$(){const b=this.bb().map(E=>E.conflicts).flat();(0,I.$tb)(this.j,b,(E,T)=>E.profile.id===T.profile.id&&E.syncResource===T.syncResource&&(0,I.$tb)(E.conflicts,T.conflicts,(j,U)=>(0,k.$9g)(j.previewResource,U.previewResource)))||(this.j=b,this.m.fire(b))}ab(){this.status===t.SyncStatus.Idle&&(this.t=new Date().getTime(),this.J.store(n,this.t,p.StorageScope.APPLICATION,p.StorageTarget.MACHINE),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(b,E){let T=this.z.get(b.id);if(T&&T[0].collection!==E?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),T[1].dispose(),T=void 0,this.z.delete(b.id)),!T){const j=new O.$Sc,U=j.add(this.G.createInstance(a,b,E?.collection));j.add(U.onDidChangeStatus(F=>this.Z(F))),j.add(U.onDidChangeConflicts(F=>this.$())),j.add(U.onDidChangeLocal(F=>this.h.fire(F))),this.z.set(b.id,T=[U,j])}return T[0]}bb(){const b=[];for(const[E]of this.z.values())b.push(E);return b}cb(){this.z.forEach(([,b])=>b.dispose()),this.z.clear()}db(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$6dc=r,e.$6dc=r=ve([Q(0,$.$9k),Q(1,t.$nnb),Q(2,t.$mnb),Q(3,l.$Bi),Q(4,t.$Cnb),Q(5,S.$8l),Q(6,p.$eq),Q(7,t.$xnb),Q(8,g.$Il),Q(9,t.$znb),Q(10,t.$onb)],r);let a=class extends O.$Tc{get enabled(){return this.f.sort((b,E)=>b[1]-E[1]).map(([b])=>b)}get disabled(){return t.$jnb.filter(b=>!this.r.isResourceEnabled(b))}get status(){return this.g}get conflicts(){return this.m}constructor(b,E,T,j,U,F,K,W,x,G){super(),this.profile=b,this.collection=E,this.r=T,this.t=j,this.u=U,this.w=F,this.y=K,this.z=W,this.C=x,this.D=G,this.f=[],this.g=t.SyncStatus.Idle,this.h=this.B(new N.$je),this.onDidChangeStatus=this.h.event,this.j=this.B(new N.$je),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new N.$je),this.onDidChangeConflicts=this.n.event,this.B(T.onDidChangeResourceEnablement(([ie,V])=>this.F(ie,V))),this.B((0,O.$Rc)(()=>this.f.splice(0,this.f.length).forEach(([,,ie])=>ie.dispose())));for(const ie of t.$jnb)T.isResourceEnabled(ie)&&this.G(ie)}F(b,E){E?this.G(b):this.H(b)}G(b){if(this.f.some(([U])=>U.resource===b))return;if(b===t.SyncResource.Extensions&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(b===t.SyncResource.Profiles&&(!this.profile.isDefault||!this.C.isEnabled())||b===t.SyncResource.WorkspaceState)return;if(b!==t.SyncResource.Profiles&&this.profile.useDefaultFlags?.[b]){this.z.debug(`Skipping syncing ${b} in ${this.profile.name} because it is already synced by default profile`);return}const E=new O.$Sc,T=E.add(this.createSynchronizer(b));E.add(T.onDidChangeStatus(()=>this.L())),E.add(T.onDidChangeConflicts(()=>this.M())),E.add(T.onDidChangeLocal(()=>this.j.fire(b)));const j=this.N(b);this.f.push([T,j,E])}H(b){const E=this.f.findIndex(([T])=>T.resource===b);if(E!==-1){const[[T,,j]]=this.f.splice(E,1);j.dispose(),this.L(),Promise.allSettled([T.stop(),T.resetLocal()]).then(null,U=>this.z.error(U))}}createSynchronizer(b){switch(b){case t.SyncResource.Settings:return this.t.createInstance(o.$acc,this.profile,this.collection);case t.SyncResource.Keybindings:return this.t.createInstance(m.$0bc,this.profile,this.collection);case t.SyncResource.Snippets:return this.t.createInstance(h.$fcc,this.profile,this.collection);case t.SyncResource.Tasks:return this.t.createInstance(i.$icc,this.profile,this.collection);case t.SyncResource.GlobalState:return this.t.createInstance(P.$XNb,this.profile,this.collection);case t.SyncResource.Extensions:return this.t.createInstance(w.$5bc,this.profile,this.collection);case t.SyncResource.Profiles:return this.t.createInstance(s.$3dc,this.profile,this.collection)}}async sync(b,E,T,j){if(j.isCancellationRequested)return[];const U=this.enabled;if(!U.length)return[];try{const F=[],K=(0,t.$rnb)(T),W=(this.collection?b?.collections?.[this.collection]?.latest:b?.latest)??null,x=E?await this.I(W):{};for(const G of U){if(j.isCancellationRequested)return[];if(!this.r.isResourceEnabled(G.resource))return[];try{if(E){const ie=await G.preview(W,x,K);if(ie)for(const V of ie.resourcePreviews)(V.localChange!==t.Change.None||V.remoteChange!==t.Change.None)&&V.mergeState===t.MergeState.Preview&&await G.merge(V.previewResource)}else await G.sync(W,K)}catch(ie){const V=t.$snb.toUserDataSyncError(ie);if(v(V,T,this.w,this.y),f(ie))throw V;this.z.error(ie),this.z.error(`${G.resource}: ${(0,L.$nj)(ie)}`),F.push([G.resource,V])}}return F}finally{this.L()}}async apply(b,E){const T=(0,t.$rnb)(b);for(const j of this.enabled){if(E.isCancellationRequested)return;try{await j.apply(!1,T)}catch(U){const F=t.$snb.toUserDataSyncError(U);if(v(F,b,this.w,this.y),f(U))throw F;this.z.error(U),this.z.error(`${j.resource}: ${(0,L.$nj)(U)}`)}}}async stop(){for(const b of this.enabled)try{b.status!==t.SyncStatus.Idle&&await b.stop()}catch(E){this.z.error(E)}}async resetLocal(){for(const b of this.enabled)try{await b.resetLocal()}catch(E){this.z.error(`${b.resource}: ${(0,L.$nj)(E)}`),this.z.error(E)}}async I(b){if(!this.profile.isDefault)return{};const E=this.D.getValue(t.$fnb),T=this.enabled.find(j=>j instanceof o.$acc);if(T){const j=await T.getRemoteUserDataSyncConfiguration(b);return{...E,...j}}return E}J(b){this.g!==b&&(this.g=b,this.h.fire(b))}L(){return this.M(),this.enabled.some(b=>b.status===t.SyncStatus.HasConflicts)?this.J(t.SyncStatus.HasConflicts):this.enabled.some(b=>b.status===t.SyncStatus.Syncing)?this.J(t.SyncStatus.Syncing):this.J(t.SyncStatus.Idle)}M(){const b=this.enabled.filter(E=>E.status===t.SyncStatus.HasConflicts).filter(E=>E.conflicts.conflicts.length>0).map(E=>E.conflicts);(0,I.$tb)(this.m,b,(E,T)=>E.syncResource===T.syncResource&&(0,I.$tb)(E.conflicts,T.conflicts,(j,U)=>(0,k.$9g)(j.previewResource,U.previewResource)))||(this.m=b,this.n.fire(b))}N(b){switch(b){case t.SyncResource.Settings:return 0;case t.SyncResource.Keybindings:return 1;case t.SyncResource.Snippets:return 2;case t.SyncResource.Tasks:return 3;case t.SyncResource.GlobalState:return 4;case t.SyncResource.Extensions:return 5;case t.SyncResource.Profiles:return 6;case t.SyncResource.WorkspaceState:return 7}}};a=ve([Q(2,t.$xnb),Q(3,l.$Bi),Q(4,u.$hp),Q(5,t.$mnb),Q(6,S.$8l),Q(7,t.$Cnb),Q(8,g.$Il),Q(9,d.$9i)],a);function f(C){if(C instanceof t.$snb)switch(C.code){case t.UserDataSyncErrorCode.MethodNotFound:case t.UserDataSyncErrorCode.TooLarge:case t.UserDataSyncErrorCode.TooManyRequests:case t.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case t.UserDataSyncErrorCode.LocalTooManyRequests:case t.UserDataSyncErrorCode.LocalTooManyProfiles:case t.UserDataSyncErrorCode.Gone:case t.UserDataSyncErrorCode.UpgradeRequired:case t.UserDataSyncErrorCode.IncompatibleRemoteContent:case t.UserDataSyncErrorCode.IncompatibleLocalContent:return!0}return!1}function v(C,b,E,T){T.publicLog2("sync/error",{code:C.code,serverCode:C instanceof t.$tnb?String(C.serverCode):void 0,url:C instanceof t.$tnb?C.url:void 0,resource:C.resource,executionId:b,service:E.userDataSyncStore.url.toString()})}}),define(he[232],ue([0,1,3,2,9,19,24]),function(oe,e,I,c,A,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qhc=e.$phc=void 0;function O(u,$){return{...u,profile:(0,L.$Jl)(u.profile,$.profilesHome.scheme)}}function k(u){return{created:u.created,uri:A.URI.revive(u.uri)}}class y{constructor($,l,p){this.c=$,this.d=l,this.f=p,this.a=new Map,this.b=new I.$je}listen($,l){switch(l){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${l}`)}async call($,l,p){try{return await this.g($,l,p)}catch(S){throw this.f.error(S),S}}async g($,l,p){switch(l){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(A.URI.revive(p[0]));case"accept":return this.c.accept(O(p[0],this.d),A.URI.revive(p[1]),p[2],p[3]);case"replace":return this.c.replace(k(p[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(A.URI.revive(p[0]));case"extractActivityData":return this.c.extractActivityData(A.URI.revive(p[0]),A.URI.revive(p[1]));case"createManualSyncTask":return this.i()}if(l.startsWith("manualSync/")){const S=l.substring(11),g=p[0],w=this.h(g);switch(p=p.slice(1),S){case"merge":return w.merge();case"apply":return w.apply().then(()=>this.a.delete(this.j(w.id)));case"stop":return w.stop().finally(()=>this.a.delete(this.j(w.id)))}}throw new Error("Invalid call")}h($){const l=this.a.get(this.j($));if(!l)throw new Error(`Manual sync taks not found: ${$}`);return l}async i(){const $=await this.c.createManualSyncTask();return this.a.set(this.j($.id),$),$.id}j($){return`manualSyncTask-${$}`}}e.$phc=y;let R=class extends c.$Tc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor($,l){super(),this.n=l,this.b=N.SyncStatus.Uninitialized,this.c=this.B(new I.$je),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new I.$je),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new I.$je),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new I.$je),this.onSyncErrors=this.m.event,this.a={call(p,S,g){return $.call(p,S,g).then(null,w=>{throw N.$snb.toUserDataSyncError(w)})},listen(p,S){return $.listen(p,S)}},this.a.call("_getInitialData").then(([p,S,g])=>{this.s(p),this.t(S),g&&this.u(g),this.B(this.a.listen("onDidChangeStatus")(w=>this.s(w))),this.B(this.a.listen("onDidChangeLastSyncTime")(w=>this.u(w)))}),this.B(this.a.listen("onDidChangeConflicts")(p=>this.t(p))),this.B(this.a.listen("onSyncErrors")(p=>this.m.fire(p.map(S=>({...S,error:N.$snb.toUserDataSyncError(S.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const $=await this.a.call("createManualSyncTask"),l=this;return new d($,{async call(S,g,w){return l.a.call(`manualSync/${S}`,[$,...Array.isArray(g)?g:[g]],w)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept($,l,p,S){return this.a.call("accept",[$,l,p,S])}resolveContent($){return this.a.call("resolveContent",[$])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace($){return this.a.call("replace",[$])}saveRemoteActivityData($){return this.a.call("getRemoteActivityData",[$])}extractActivityData($,l){return this.a.call("extractActivityData",[$,l])}async s($){this.b=$,this.c.fire($)}async t($){this.f=$.map(l=>({syncResource:l.syncResource,profile:(0,L.$Jl)(l.profile,this.n.profilesHome.scheme),conflicts:l.conflicts.map(p=>({...p,baseResource:A.URI.revive(p.baseResource),localResource:A.URI.revive(p.localResource),remoteResource:A.URI.revive(p.remoteResource),previewResource:A.URI.revive(p.previewResource)}))})),this.g.fire(this.f)}u($){this.h!==$&&(this.h=$,this.j.fire($))}};e.$qhc=R,e.$qhc=R=ve([Q(1,L.$Il)],R);class d extends c.$Tc{constructor($,l){super(),this.id=$,this.a=l}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(he[126],ue([0,1,6,25,8,3,2,133,5,20,12,9,31,21,15,7,23,61,49,16,24]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$,l,p,S,g,w,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NNb=e.$MNb=e.$LNb=e.$KNb=e.$JNb=void 0;const o="configurationSync.store",h="sync.previous.store",i="sync.donot-make-requests-until",s="sync.user-session-id",t="sync.machine-session-id",n=100,r=1e3*60*5;let a=class extends N.$Tc{get userDataSyncStore(){return this.b}get c(){return this.h.get(m.$vnb,P.StorageScope.APPLICATION)}set c(T){this.h.store(m.$vnb,T,P.StorageScope.APPLICATION,k.$p?P.StorageTarget.USER:P.StorageTarget.MACHINE)}constructor(T,j,U){super(),this.f=T,this.g=j,this.h=U,this.a=this.B(new L.$je),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const F=this.B(new N.$Sc);this.B(L.Event.filter(U.onDidChangeValue(P.StorageScope.APPLICATION,m.$vnb,F),()=>this.c!==this.userDataSyncStore?.type,F)(()=>this.j()))}j(){this.b=this.m(this.f[o]),this.a.fire()}m(T){if(T&&(T=k.$p&&T.web?{...T,...T.web}:T,(0,R.$cg)(T.url)&&(0,R.$eg)(T.authenticationProviders)&&Object.keys(T.authenticationProviders).every(j=>Array.isArray(T.authenticationProviders[j].scopes)))){const j=T,U=!!j.canSwitch,F=j.url===j.insidersUrl?"insiders":"stable",K=(U?this.c:void 0)||F,W=K==="insiders"?j.insidersUrl:K==="stable"?j.stableUrl:j.url;return{url:d.URI.parse(W),type:K,defaultType:F,defaultUrl:d.URI.parse(j.url),stableUrl:d.URI.parse(j.stableUrl),insidersUrl:d.URI.parse(j.insidersUrl),canSwitch:U,authenticationProviders:Object.keys(j.authenticationProviders).reduce((x,G)=>(x.push({id:G,scopes:j.authenticationProviders[G].scopes}),x),[])}}}};e.$JNb=a,e.$JNb=a=ve([Q(0,S.$pk),Q(1,$.$9i),Q(2,P.$eq)],a);let f=class extends a{constructor(T,j,U){super(T,j,U);const F=this.h.get(h,P.StorageScope.APPLICATION);F&&(this.n=JSON.parse(F));const K=this.f[o];K?this.h.store(h,JSON.stringify(K),P.StorageScope.APPLICATION,P.StorageTarget.MACHINE):this.h.remove(h,P.StorageScope.APPLICATION)}async switch(T){T!==this.c&&(this.c=T,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$KNb=f,e.$KNb=f=ve([Q(0,S.$pk),Q(1,$.$9i),Q(2,P.$eq)],f);let v=class extends N.$Tc{get donotMakeRequestsUntil(){return this.j}constructor(T,j,U,F,K,W,x){super(),this.n=U,this.r=F,this.s=x,this.g=this.B(new L.$je),this.onTokenFailed=this.g.event,this.h=this.B(new L.$je),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new L.$je),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(T),this.c=(0,w.$kq)(K,W,x).then(G=>{const ie={"X-Client-Name":`${j.applicationName}${k.$p?"-web":""}`,"X-Client-Version":j.version};return j.commit&&(ie["X-Client-Commit"]=j.commit),ie}),this.f=new b(n,r,this.n,this.r),this.u(),this.B((0,N.$Rc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(T,j){this.b={token:T,type:j}}t(T){this.a=T?(0,y.$dh)(T,"v1"):void 0}u(){const T=this.s.getNumber(i,P.StorageScope.APPLICATION);T&&Date.now()<T&&this.y(new Date(T))}y(T){this.j?.getTime()!==T?.getTime()&&(this.j=T,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(i,this.j.getTime(),P.StorageScope.APPLICATION,P.StorageTarget.MACHINE),this.w=(0,I.$ph)(j=>(0,I.$Dh)(this.j.getTime()-Date.now(),j).then(()=>this.y(void 0))),this.w.then(null,j=>null)):this.s.remove(i,P.StorageScope.APPLICATION),this.m.fire())}async getAllCollections(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=(0,y.$dh)(this.a,"collection").toString();T={...T},T["Content-Type"]="application/json";const U=await this.D(j,{type:"GET",headers:T},[],c.CancellationToken.None);return(await(0,g.$0p)(U))?.map(({id:F})=>F)||[]}async createCollection(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=(0,y.$dh)(this.a,"collection").toString();T={...T},T["Content-Type"]=O.$7s.text;const U=await this.D(j,{type:"POST",headers:T},[],c.CancellationToken.None),F=await(0,g.$9p)(U);if(!F)throw new m.$tnb("Server did not return the collection id",j,m.UserDataSyncErrorCode.NoCollection,U.res.statusCode,U.res.headers[m.$pnb]);return F}async deleteCollection(T,j={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=T?(0,y.$dh)(this.a,"collection",T).toString():(0,y.$dh)(this.a,"collection").toString();j={...j},await this.D(U,{type:"DELETE",headers:j},[],c.CancellationToken.None)}async getAllResourceRefs(T,j){if(!this.a)throw new Error("No settings sync store url configured.");const U=this.z(this.a,j,T),F={},K=await this.D(U.toString(),{type:"GET",headers:F},[],c.CancellationToken.None);return(await(0,g.$0p)(K)||[]).map(({url:x,created:G})=>({ref:(0,y.$fh)(U,U.with({path:x})),created:G*1e3}))}async resolveResourceContent(T,j,U,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const K=(0,y.$dh)(this.z(this.a,U,T),j).toString();F={...F},F["Cache-Control"]="no-cache";const W=await this.D(K,{type:"GET",headers:F},[],c.CancellationToken.None);return await(0,g.$9p)(W)}async deleteResource(T,j,U){if(!this.a)throw new Error("No settings sync store url configured.");const F=j!==null?(0,y.$dh)(this.z(this.a,U,T),j).toString():this.z(this.a,U,T).toString(),K={};await this.D(F,{type:"DELETE",headers:K},[],c.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,y.$dh)(this.a,"resource").toString(),j={"Content-Type":O.$7s.text};await this.D(T,{type:"DELETE",headers:j},[],c.CancellationToken.None)}async readResource(T,j,U,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const K=(0,y.$dh)(this.z(this.a,U,T),"latest").toString();F={...F},F["Cache-Control"]="no-cache",j&&(F["If-None-Match"]=j.ref);const W=await this.D(K,{type:"GET",headers:F},[304],c.CancellationToken.None);let x=null;if(W.res.statusCode===304&&(x=j),x===null){const G=W.res.headers.etag;if(!G)throw new m.$tnb("Server did not return the ref",K,m.UserDataSyncErrorCode.NoRef,W.res.statusCode,W.res.headers[m.$pnb]);const ie=await(0,g.$9p)(W);if(!ie&&W.res.statusCode===304)throw new m.$tnb("Empty response",K,m.UserDataSyncErrorCode.EmptyResponse,W.res.statusCode,W.res.headers[m.$pnb]);x={ref:G,content:ie}}return x}async writeResource(T,j,U,F,K={}){if(!this.a)throw new Error("No settings sync store url configured.");const W=this.z(this.a,F,T).toString();K={...K},K["Content-Type"]=O.$7s.text,U&&(K["If-Match"]=U);const x=await this.D(W,{type:"POST",data:j,headers:K},[],c.CancellationToken.None),G=x.res.headers.etag;if(!G)throw new m.$tnb("Server did not return the ref",W,m.UserDataSyncErrorCode.NoRef,x.res.statusCode,x.res.headers[m.$pnb]);return G}async manifest(T,j={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,y.$dh)(this.a,"manifest").toString();j={...j},j["Content-Type"]="application/json",T&&(j["If-None-Match"]=T.ref);const F=await this.D(U,{type:"GET",headers:j},[304],c.CancellationToken.None);let K=null;if(F.res.statusCode===304&&(K=T),!K){const x=F.res.headers.etag;if(!x)throw new m.$tnb("Server did not return the ref",U,m.UserDataSyncErrorCode.NoRef,F.res.statusCode,F.res.headers[m.$pnb]);const G=await(0,g.$9p)(F);if(!G&&F.res.statusCode===304)throw new m.$tnb("Empty response",U,m.UserDataSyncErrorCode.EmptyResponse,F.res.statusCode,F.res.headers[m.$pnb]);G&&(K={...JSON.parse(G),ref:x})}const W=this.s.get(s,P.StorageScope.APPLICATION);return W&&K&&W!==K.session&&this.C(),K===null&&W&&this.C(),K&&this.s.store(s,K.session,P.StorageScope.APPLICATION,P.StorageTarget.MACHINE),K}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,y.$dh)(this.a,"download").toString(),j={},U=await this.D(T,{type:"GET",headers:j},[],c.CancellationToken.None);if(!(0,g.$6p)(U))throw new m.$tnb("Server returned "+U.res.statusCode,T,m.UserDataSyncErrorCode.EmptyResponse,U.res.statusCode,U.res.headers[m.$pnb]);if((0,g.$7p)(U))throw new m.$tnb("Empty response",T,m.UserDataSyncErrorCode.EmptyResponse,U.res.statusCode,U.res.headers[m.$pnb]);return U.stream}z(T,j,U){return j?(0,y.$dh)(T,"collection",j,"resource",U):(0,y.$dh)(T,"resource",U)}C(){this.s.remove(s,P.StorageScope.APPLICATION),this.s.remove(t,P.StorageScope.APPLICATION)}async D(T,j,U,F){if(!this.b)throw new m.$tnb("No Auth Token Available",T,m.UserDataSyncErrorCode.Unauthorized,void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new m.$tnb(`${j.type} request '${T}' failed because of too many requests (429).`,T,m.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0,void 0);this.y(void 0);const K=await this.c;j.headers={...j.headers||{},...K,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(j.headers),this.r.trace("Sending request to server",{url:T,type:j.type,headers:{...j.headers,authorization:void 0}});let W;try{W=await this.f.request(T,j,F)}catch(z){if(!(z instanceof m.$tnb)){let _=m.UserDataSyncErrorCode.RequestFailed;const ne=(0,A.$9)(z).toLowerCase();ne.includes("xhr timeout")?_=m.UserDataSyncErrorCode.RequestTimeout:ne.includes("protocol")&&ne.includes("not supported")?_=m.UserDataSyncErrorCode.RequestProtocolNotSupported:ne.includes("request path contains unescaped characters")?_=m.UserDataSyncErrorCode.RequestPathNotEscaped:ne.includes("headers must be an object")?_=m.UserDataSyncErrorCode.RequestHeadersNotObject:(0,A.$3)(z)&&(_=m.UserDataSyncErrorCode.RequestCanceled),z=new m.$tnb(`Connection refused for the request '${T}'.`,T,_,void 0,void 0)}throw this.r.info("Request failed",T),z}const x=W.res.headers[m.$pnb],G={url:T,status:W.res.statusCode,"execution-id":j.headers[m.$qnb],"operation-id":x},ie=(0,g.$6p)(W)||W.res.statusCode&&U.includes(W.res.statusCode);let V="";if(ie?this.r.trace("Request succeeded",G):(V=await(0,g.$8p)(W)||"",this.r.info("Request failed",G,V)),W.res.statusCode===401||W.res.statusCode===403){if(this.b=void 0,W.res.statusCode===401)throw this.g.fire(m.UserDataSyncErrorCode.Unauthorized),new m.$tnb(`${j.type} request '${T}' failed because of Unauthorized (401).`,T,m.UserDataSyncErrorCode.Unauthorized,W.res.statusCode,x);if(W.res.statusCode===403)throw this.g.fire(m.UserDataSyncErrorCode.Forbidden),new m.$tnb(`${j.type} request '${T}' failed because the access is forbidden (403).`,T,m.UserDataSyncErrorCode.Forbidden,W.res.statusCode,x)}if(this.h.fire(),W.res.statusCode===404)throw new m.$tnb(`${j.type} request '${T}' failed because the requested resource is not found (404).`,T,m.UserDataSyncErrorCode.NotFound,W.res.statusCode,x);if(W.res.statusCode===405)throw new m.$tnb(`${j.type} request '${T}' failed because the requested endpoint is not found (405). ${V}`,T,m.UserDataSyncErrorCode.MethodNotFound,W.res.statusCode,x);if(W.res.statusCode===409)throw new m.$tnb(`${j.type} request '${T}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,T,m.UserDataSyncErrorCode.Conflict,W.res.statusCode,x);if(W.res.statusCode===410)throw new m.$tnb(`${j.type} request '${T}' failed because the requested resource is not longer available (410).`,T,m.UserDataSyncErrorCode.Gone,W.res.statusCode,x);if(W.res.statusCode===412)throw new m.$tnb(`${j.type} request '${T}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,T,m.UserDataSyncErrorCode.PreconditionFailed,W.res.statusCode,x);if(W.res.statusCode===413)throw new m.$tnb(`${j.type} request '${T}' failed because of too large payload (413).`,T,m.UserDataSyncErrorCode.TooLarge,W.res.statusCode,x);if(W.res.statusCode===426)throw new m.$tnb(`${j.type} request '${T}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,T,m.UserDataSyncErrorCode.UpgradeRequired,W.res.statusCode,x);if(W.res.statusCode===429){const z=W.res.headers["retry-after"];throw z?(this.y(new Date(Date.now()+parseInt(z)*1e3)),new m.$tnb(`${j.type} request '${T}' failed because of too many requests (429).`,T,m.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,W.res.statusCode,x)):new m.$tnb(`${j.type} request '${T}' failed because of too many requests (429).`,T,m.UserDataSyncErrorCode.TooManyRequests,W.res.statusCode,x)}if(!ie)throw new m.$tnb("Server returned "+W.res.statusCode,T,m.UserDataSyncErrorCode.Unknown,W.res.statusCode,x);return W}F(T){let j=this.s.get(t,P.StorageScope.APPLICATION);j===void 0&&(j=(0,u.$Yg)(),this.s.store(t,j,P.StorageScope.APPLICATION,P.StorageTarget.MACHINE)),T["X-Machine-Session-Id"]=j;const U=this.s.get(s,P.StorageScope.APPLICATION);U!==void 0&&(T["X-User-Session-Id"]=U)}};e.$LNb=v,e.$LNb=v=ve([Q(1,S.$pk),Q(2,g.$4p),Q(3,m.$Cnb),Q(4,l.$Ji),Q(5,p.$9k),Q(6,P.$eq)],v);let C=class extends v{constructor(T,j,U,F,K,W,x){super(T.userDataSyncStore?.url,j,U,F,K,W,x),this.B(T.onDidChangeUserDataSyncStore(()=>this.t(T.userDataSyncStore?.url)))}};e.$MNb=C,e.$MNb=C=ve([Q(0,m.$mnb),Q(1,S.$pk),Q(2,g.$4p),Q(3,m.$Cnb),Q(4,l.$Ji),Q(5,p.$9k),Q(6,P.$eq)],C);class b{constructor(T,j,U,F){this.c=T,this.d=j,this.f=U,this.g=F,this.a=[],this.b=void 0}request(T,j,U){if(this.h()&&this.i(),j.url=T,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new m.$tnb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,T,m.UserDataSyncErrorCode.LocalTooManyRequests,void 0,void 0);return this.b=this.b||new Date,this.a.push(T),this.f.request(j,U)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$NNb=b}),define(he[233],ue([0,1,3,2,9,21,23,16,126]),function(oe,e,I,c,A,L,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ohc=e.$nhc=e.$mhc=e.$lhc=void 0;class y{constructor(l){this.a=l}listen(l,p){switch(p){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${p}`)}call(l,p,S){switch(p){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(S)}throw new Error("Invalid call")}}e.$lhc=y;class R extends c.$Tc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor(l){super(),this.c=l,this.b=this.B(new I.$je),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(p=>{this.a=p,this.B(this.c.listen("onDidChangeAccount")(S=>{this.a=S,this.b.fire(S)}))})}updateAccount(l){return this.c.call("updateAccount",l)}}e.$mhc=R;class d{constructor(l){this.a=l}listen(l,p){switch(p){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${p}`)}call(l,p,S){switch(p){case"switch":return this.a.switch(S[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$nhc=d;let u=class extends k.$JNb{constructor(l,p,S,g){super(p,S,g),this.n=l,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch(l){return this.n.call("switch",[l])}async getPreviousUserDataSyncStore(){const l=await this.n.call("getPreviousUserDataSyncStore");return this.r(l)}r(l){return{url:A.URI.revive(l.url),type:l.type,defaultUrl:A.URI.revive(l.defaultUrl),insidersUrl:A.URI.revive(l.insidersUrl),stableUrl:A.URI.revive(l.stableUrl),canSwitch:l.canSwitch,authenticationProviders:l.authenticationProviders}}};e.$ohc=u,e.$ohc=u=ve([Q(1,N.$pk),Q(2,L.$9i),Q(3,O.$eq)],u)}),define(he[234],ue([0,1,3,57,23,16,18,229,24,82,86]),function(oe,e,I,c,A,L,N,O,k,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Khc=void 0;let d=class extends O.$7dc{constructor($,l,p,S,g,w,P,m,o,h,i){super($,l,p,S,g,P,m,o,h,i),this.B(I.Event.debounce(I.Event.any(I.Event.map(w.onDidFocusMainWindow,()=>"windowFocus"),I.Event.map(w.onDidOpenMainWindow,()=>"windowOpen")),(s,t)=>s?[...s,t]:[t],1e3)(s=>this.triggerSync(s,!0,!1)))}};e.$Khc=d,e.$Khc=d=ve([Q(0,A.$pk),Q(1,k.$mnb),Q(2,k.$nnb),Q(3,k.$xnb),Q(4,k.$ynb),Q(5,c.$Gfc),Q(6,k.$Cnb),Q(7,y.$_Lb),Q(8,N.$8l),Q(9,R.$_mb),Q(10,L.$eq)],d)}),define(he[235],ue([0,1,75,22,5,20]),function(oe,e,I,c,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ec=void 0,e.$8ec=N,e.$9ec=O,e.$0ec=k,e.$7ec=128/4;function N(y){function R(){let d=y.scheme===c.Schemas.file?(0,L.$4g)(y):y.toString();return A.$l||(d=d.toLowerCase()),(0,I.createHash)("md5").update(d).digest("hex")}return{id:R(),configPath:y}}function O(y,R){function d(){if(y.scheme!==c.Schemas.file)return(0,I.createHash)("md5").update(y.toString()).digest("hex");if(!R)return;let $;return A.$l?$=R.ino:A.$k?$=R.birthtime.getTime():A.$j&&(typeof R.birthtimeMs=="number"?$=Math.floor(R.birthtimeMs):$=R.birthtime.getTime()),(0,I.createHash)("md5").update(y.fsPath).update($?String($):"").digest("hex")}const u=d();if(typeof u=="string")return{id:u,uri:y}}function k(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(he[236],ue([0,1,6,8,2,13,30,15,10,79,115,235,57,56,22]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hhc=void 0;let p=class extends A.$Tc{constructor(g,w,P,m){super(),this.a=g,this.b=w,this.c=P,this.f=m,this.B(new I.$Oh(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const g=this.a.workspaceStorageHome.with({scheme:l.Schemas.file}).fsPath,w=await N.Promises.readdir(g),P=new y.$KMb(this.f.getChannel("storage"));await Promise.all(w.map(async m=>{const o=(0,L.$ic)(g,m);m.length===d.$7ec||m===R.$Oi.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(s=>s.workspace?.id===m)||await P.isUsed(o)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${m} as it seems to be an unused empty workspace.`),await N.Promises.rm(o))}))}catch(g){(0,c.$Y)(g)}}};e.$hhc=p,e.$hhc=p=ve([Q(0,O.$Ki),Q(1,k.$9j),Q(2,u.$Gfc),Q(3,$.$Ygc)],p)}),define(he[127],ue([0,1,75,67,38,244,14,8,3,2,13,5,31,42,69]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$ti=e.$si=e.$ri=void 0,e.$ui=t,e.$vi=n,e.$xi=f,e.$yi=v;const p=3e4;class S{traceSocketEvent(b,E){l.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,b,E)}constructor(b,E=""){this.f=!0,this.debugLabel=E,this.socket=b,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=j=>{if(this.traceSocketEvent(l.SocketDiagnosticsEventType.Error,{code:j?.code,message:j?.message}),j){if(j.code==="EPIPE")return;(0,O.$Y)(j)}},this.socket.on("error",this.a);let T;this.b=j=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Close,{hadError:j}),this.f=!1,T&&clearTimeout(T)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,T=setTimeout(()=>b.destroy(),p)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(b){const E=T=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Read,T),b(N.$Le.wrap(T))};return this.socket.on("data",E),{dispose:()=>this.socket.off("data",E)}}onClose(b){const E=T=>{b({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:T,error:void 0})};return this.socket.on("close",E),{dispose:()=>this.socket.off("close",E)}}onEnd(b){const E=()=>{b()};return this.socket.on("end",E),{dispose:()=>this.socket.off("end",E)}}write(b){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(l.SocketDiagnosticsEventType.Write,b),this.socket.write(b.buffer,E=>{if(E){if(E.code==="EPIPE")return;(0,O.$Y)(E)}})}catch(E){if(E.code==="EPIPE")return;(0,O.$Y)(E)}}end(){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((b,E)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),b();return}const T=()=>{this.socket.off("close",T),this.socket.off("end",T),this.socket.off("error",T),this.socket.off("timeout",T),this.socket.off("drain",T),this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),b()};this.socket.on("close",T),this.socket.on("end",T),this.socket.on("error",T),this.socket.on("timeout",T),this.socket.on("drain",T)})}}e.$ri=S;var g;(function(C){C[C.MinHeaderByteSize=2]="MinHeaderByteSize",C[C.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(g||(g={}));var w;(function(C){C[C.PeekHeader=1]="PeekHeader",C[C.ReadHeader=2]="ReadHeader",C[C.ReadBody=3]="ReadBody",C[C.Fin=4]="Fin"})(w||(w={}));class P extends y.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(b,E){this.socket.traceSocketEvent(b,E)}constructor(b,E,T,j){super(),this.f=this.B(new k.$je),this.g=this.B(new k.$je),this.h=!1,this.j={state:w.PeekHeader,readLen:g.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=b,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:E,inflateBytesLength:T?.byteLength||0,recordInflateBytes:j}),this.a=this.B(new m(this,E,T,j,this.f,(U,F)=>this.m(U,F))),this.B(this.a.onError(U=>{console.error(U),(0,O.$Y)(U),this.g.fire({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:U})})),this.b=new l.$mi,this.B(this.socket.onData(U=>this.n(U))),this.B(this.socket.onClose(async U=>{this.a.isProcessingReadQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(U)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(b){return this.f.event(b)}onClose(b){return this.g.event(b)}onEnd(b){return this.socket.onEnd(b)}write(b){let E=0;for(;E<b.byteLength;)this.a.writeMessage(b.slice(E,Math.min(E+g.MaxWebSocketMessageLength,b.byteLength)),{compressed:!0,opcode:2}),E+=g.MaxWebSocketMessageLength}m(b,{compressed:E,opcode:T}){if(this.h)return;this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,b);let j=g.MinHeaderByteSize;b.byteLength<126?j+=0:b.byteLength<2**16?j+=2:j+=8;const U=N.$Le.alloc(j),F=E?64:0,K=T&15;if(U.writeUInt8(128|F|K,0),b.byteLength<126)U.writeUInt8(b.byteLength,1);else if(b.byteLength<2**16){U.writeUInt8(126,1);let W=1;U.writeUInt8(b.byteLength>>>8&255,++W),U.writeUInt8(b.byteLength>>>0&255,++W)}else{U.writeUInt8(127,1);let W=1;U.writeUInt8(0,++W),U.writeUInt8(0,++W),U.writeUInt8(0,++W),U.writeUInt8(0,++W),U.writeUInt8(b.byteLength>>>24&255,++W),U.writeUInt8(b.byteLength>>>16&255,++W),U.writeUInt8(b.byteLength>>>8&255,++W),U.writeUInt8(b.byteLength>>>0&255,++W)}this.socket.write(N.$Le.concat([U,b]))}end(){this.h=!0,this.socket.end()}n(b){if(b.byteLength!==0){for(this.b.acceptChunk(b);this.b.byteLength>=this.j.readLen;)if(this.j.state===w.PeekHeader){const E=this.b.peek(this.j.readLen),T=E.readUInt8(0),j=(T&128)>>>7,U=(T&64)>>>6,F=T&15,K=E.readUInt8(1),W=(K&128)>>>7,x=K&127;this.j.state=w.ReadHeader,this.j.readLen=g.MinHeaderByteSize+(W?4:0)+(x===126?2:0)+(x===127?8:0),this.j.fin=j,this.j.firstFrameOfMessage&&(this.j.compressed=!!U),this.j.firstFrameOfMessage=!!j,this.j.mask=0,this.j.opcode=F,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===w.ReadHeader){const E=this.b.read(this.j.readLen),T=E.readUInt8(1),j=(T&128)>>>7;let U=T&127,F=1;U===126?U=E.readUInt8(++F)*2**8+E.readUInt8(++F):U===127&&(U=E.readUInt8(++F)*0+E.readUInt8(++F)*0+E.readUInt8(++F)*0+E.readUInt8(++F)*0+E.readUInt8(++F)*2**24+E.readUInt8(++F)*2**16+E.readUInt8(++F)*2**8+E.readUInt8(++F));let K=0;j&&(K=E.readUInt8(++F)*2**24+E.readUInt8(++F)*2**16+E.readUInt8(++F)*2**8+E.readUInt8(++F)),this.j.state=w.ReadBody,this.j.readLen=U,this.j.mask=K,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===w.ReadBody){const E=this.b.read(this.j.readLen);this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,E),i(E,this.j.mask),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,E),this.j.state=w.PeekHeader,this.j.readLen=g.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(E,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(E,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$si=P;class m extends y.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:N.$Le.alloc(0)}constructor(b,E,T,j,U,F){super(),this.n=b,this.r=U,this.s=F,this.a=this.B(new k.$je),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new k.$je),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new k.$je),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,E?(this.b=this.B(new o(this.n,j,T,{windowBits:15})),this.f=this.B(new h(this.n,{windowBits:15})),this.B(this.b.onError(K=>this.a.fire(K))),this.B(this.f.onError(K=>this.a.fire(K)))):(this.b=null,this.f=null)}writeMessage(b,E){this.g.push({data:b,options:E}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:b,options:E}=this.g.shift();if(this.f&&E.compressed){const T=await this.w(this.f,b);this.s(T,E)}else this.s(b,{...E,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(b,E){return new Promise((T,j)=>{b.write(E),b.flush(U=>T(U))})}acceptFrame(b,E,T){this.h.push({data:b,isCompressed:E,isLastFrameOfMessage:T}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const b=this.h.shift();if(this.b&&b.isCompressed){const E=await this.C(this.b,b.data,b.isLastFrameOfMessage);this.r.fire(E)}else this.r.fire(b.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(b,E,T){return new Promise((j,U)=>{b.write(E),T&&b.write(N.$Le.fromByteArray([0,0,255,255])),b.flush(F=>j(F))})}}class o extends y.$Tc{get recordedInflateBytes(){return this.j?N.$Le.concat(this.f):N.$Le.alloc(0)}constructor(b,E,T,j){super(),this.h=b,this.j=E,this.a=this.B(new k.$je),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)(j),this.b.on("error",U=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateError,{message:U?.message,code:U?.code}),this.a.fire(U)}),this.b.on("data",U=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateData,U),this.g.push(N.$Le.wrap(U))}),T&&(this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialWrite,T.buffer),this.b.write(T.buffer),this.b.flush(()=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(b){this.j&&this.f.push(b.clone()),this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateWrite,b),this.b.write(b.buffer)}flush(b){this.b.flush(()=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateFlushFired);const E=N.$Le.concat(this.g);this.g.length=0,b(E)})}}class h extends y.$Tc{constructor(b,E){super(),this.g=b,this.a=this.B(new k.$je),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",T=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateError,{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateData,T),this.f.push(N.$Le.wrap(T))})}write(b){this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateWrite,b.buffer),this.b.write(b.buffer)}flush(b){this.b.flush(2,()=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateFlushFired);let E=N.$Le.concat(this.f);this.f.length=0,E=E.slice(0,E.byteLength-4),b(E)})}}function i(C,b){if(b===0)return;const E=C.byteLength>>>2;for(let W=0;W<E;W++){const x=C.readUInt32BE(W*4);C.writeUInt32BE(x^b,W*4)}const T=E*4,j=C.byteLength-T,U=b>>>24&255,F=b>>>16&255,K=b>>>8&255;j>=1&&C.writeUInt8(C.readUInt8(T)^U,T),j>=2&&C.writeUInt8(C.readUInt8(T+1)^F,T+1),j>=3&&C.writeUInt8(C.readUInt8(T+2)^K,T+2)}e.$ti=process.env.XDG_RUNTIME_DIR;const s={[d.Platform.Linux]:107,[d.Platform.Mac]:103};function t(){const C=(0,u.$Yg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${C}-sock`;const b=process.platform!=="darwin"&&e.$ti?e.$ti:(0,A.tmpdir)(),E=(0,R.$ic)(b,`vscode-ipc-${C}.sock`);return r(E),E}function n(C,b,E){const j=(0,I.createHash)("sha256").update(C).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${j}-${E}-${b}-sock`;const U=E.substr(0,4),F=b.substr(0,6);let K;return process.platform!=="darwin"&&e.$ti&&!process.env.VSCODE_PORTABLE?K=(0,R.$ic)(e.$ti,`vscode-${j}-${U}-${F}.sock`):K=(0,R.$ic)(C,`${U}-${F}.sock`),r(K),K}function r(C){const b=s[d.$v];typeof b=="number"&&C.length>=b&&console.warn(`WARNING: IPC handle "${C}" is longer than ${b} chars, try a shorter --user-data-dir`)}class a extends $.$gi{static b(b){const E=k.Event.fromNodeEventEmitter(b,"connection");return k.Event.map(E,T=>({protocol:new l.$ni(new S(T,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(T,"close"))}))}constructor(b){super(a.b(b)),this.d=b}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$wi=a;function f(C){return new Promise((b,E)=>{const T=(0,c.createServer)();T.on("error",E),T.listen(C,()=>{T.removeListener("error",E),b(new a(T))})})}function v(C,b){return new Promise((E,T)=>{const j=(0,c.createConnection)(C,()=>{j.removeListener("error",T),E(l.$oi.fromSocket(new S(j,`ipc-client${b}`),b))});j.once("error",T)})}}),define(he[237],ue([0,1,67,127,184]),function(oe,e,I,c,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nhc=void 0,I=ke(I),e.$Nhc=new class{supports(L){return!0}connect({host:L,port:N},O,k,y){return new Promise((R,d)=>{const u=I.createConnection({host:L,port:N},()=>{u.removeListener("error",d),u.write((0,A.$axb)(O,k,y));const $=l=>{l.toString().indexOf(`\r
\r
`)>=0&&(u.off("data",$),R(new c.$ri(u,y)))};u.on("data",$)});u.setNoDelay(!0),u.once("error",d)})}}}),define(he[238],ue([0,1,67,38,146,127,6,2,5,21,10,23,185,106,108,80,14]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$,l,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sgc=e.$Rgc=e.$Qgc=e.$Pgc=void 0,I=ke(I),c=ke(c);async function g(h,i,s,t,n){let r;for(let a=3;a&&(r?.dispose(),r=await new w(h,i,s,t,n).waitForReady(),!(n&&A.$2g[n]||!A.$2g[r.tunnelLocalPort]));a--);return r}class w extends O.$Tc{constructor(i,s,t,n,r){super(),this.m=s,this.n=r,this.privacy=p.TunnelPrivacyId.Private,this.j=new Map,this.a=i,this.b=I.createServer(),this.c=new N.$Bh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.r(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=t}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(s=>{s()})}async waitForReady(){const i=this.n??this.tunnelRemotePort,s=(0,p.$Hw)(this.m)?"0.0.0.0":"127.0.0.1";let t=await(0,A.$3g)(i,2,1e3,s),n=null;return this.b.listen(t,this.m),await this.c.wait(),n=this.b.address(),n||(t=0,this.b.listen(t,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(i){i.pause();const s=(0,p.$Fw)(this.tunnelRemoteHost)||(0,p.$Hw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,t=await(0,u.$Yl)(this.a,s,this.tunnelRemotePort),n=t.getSocket(),r=t.readEntireBuffer();t.dispose(),r.byteLength>0&&i.write(r.buffer),i.on("end",()=>{i.localAddress&&this.j.delete(i.localAddress),n.end()}),i.on("close",()=>n.end()),i.on("error",()=>{i.localAddress&&this.j.delete(i.localAddress),n instanceof L.$ri?n.socket.destroy():n.end()}),n instanceof L.$ri?this.t(i,n):this.s(i,n),i.localAddress&&this.j.set(i.localAddress,()=>{i.end(),n.end()})}s(i,s){s.onClose(()=>i.destroy()),s.onEnd(()=>i.end()),s.onData(t=>i.write(t.buffer)),i.on("data",t=>s.write(S.$Le.wrap(t))),i.resume()}t(i,s){const t=s.socket;t.on("end",()=>i.end()),t.on("close",()=>i.end()),t.on("error",()=>{i.destroy()}),t.pipe(i),i.pipe(t)}}e.$Pgc=w;let P=class extends p.$Kw{constructor(i,s,t,n,r){super(s,r),this.H=i,this.I=t,this.J=n}isPortPrivileged(i){return(0,p.$Iw)(i,this.t,k.OS,c.release())}F(i,s,t,n,r,a,f,v){const C=this.D(s,t);if(C)return++C.refcount,C.value;if((0,p.$Bw)(i))return this.G(i,s,t,r,a,f,v);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${t} on local port ${r}.`);const b={commit:this.J.commit,quality:this.J.quality,addressProvider:i,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},E=g(b,n,s,t,r);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(s,t,E),E}}};e.$Qgc=P,e.$Qgc=P=ve([Q(0,$.$Sl),Q(1,R.$9j),Q(2,l.$Vl),Q(3,d.$pk),Q(4,y.$9i)],P);let m=class extends P{constructor(i,s,t,n,r){super(i,s,t,n,r)}};e.$Rgc=m,e.$Rgc=m=ve([Q(0,$.$Sl),Q(1,R.$9j),Q(2,l.$Vl),Q(3,d.$pk),Q(4,y.$9i)],m);let o=class extends O.$Tc{constructor(i,s,t,n,r){super(),this.b=i,this.c=s,this.f=t,this.g=n,this.h=r,this.a=new Map}async openTunnel(i,s,t,n,r,a,f,v,C){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${t}:${n} on local port ${a}.`),!this.a.has(i)){const b=new m(this.b,this.c,this.g,this.f,this.h);this.B(b),this.a.set(i,b),b.onTunnelClosed(async()=>{(await b.tunnels).length===0&&(b.dispose(),this.a.delete(i))})}return this.a.get(i).openTunnel(s,t,n,r,a,f,v,C)}};e.$Sgc=o,e.$Sgc=o=ve([Q(0,$.$Sl),Q(1,R.$9j),Q(2,d.$pk),Q(3,l.$Vl),Q(4,y.$9i)],o)});var it=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(he[245],ue([0,1,38,43,8,2,22,9,17,3,42,150,178,179,188,170,236,161,162,21,183,97,195,98,190,15,118,222,27,110,186,117,74,7,172,173,73,4,169,76,78,198,10,174,102,23,61,16,109,18,111,112,113,48,201,85,114,24,82,228,233,211,86,227,231,232,126,62,226,212,108,194,80,238,189,202,28,203,5,204,163,181,180,84,217,19,52,177,58,225,200,213,107,230,218,11,175,101,223,216,191,157,57,176,234,220,56,224,106,104,237,155,192,144,132,143]),function(oe,e,I,c,A,L,N,O,k,y,R,d,u,$,l,p,S,g,w,P,m,o,h,i,s,t,n,r,a,f,v,C,b,E,T,j,U,F,K,W,x,G,ie,V,z,_,ne,ce,te,Y,H,B,D,J,q,M,Z,ee,X,re,le,ge,pe,Ee,we,be,Se,Ie,ae,de,me,Pe,Oe,je,Ne,Le,Ue,qe,Ge,Fe,Be,ze,We,Ce,se,fe,$e,ye,Ae,Te,Me,xe,Je,Ye,Ve,_e,Qe,nt,at,Lt,Ct,Tt,Nt,Dt,Ut,jt,yt,Ft,vt,Mt,qt,Bt,ht,zt,Wt,Et){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=St,z=it(z);class Vt extends L.$Tc{constructor(Re){super(),this.f=Re,this.a=this.B(new d.$KX(this)),this.b=void 0,this.c=this.B(new y.$je),this.g()}g(){let Re=!1;const De=()=>{Re||(Re=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",De),(0,d.$LX)(process.parentPort,ht.$3fc.exit,De)}async init(){const Re=await this.h();(0,ee.$hnb)(),Re.invokeFunction(De=>{const Ke=De.get(ie.$9j),He=De.get(Y.$8l),et=De.get(fe.$Il);Ke.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(De),this.m(Ke),this.n(He,et),this.B(et.onDidChangeProfiles(()=>this.n(He,et))),this.r(He,Ke)}),this.B((0,L.$Qc)(Re.createInstance(u.$dhc,this.f.codeCachePath),Re.createInstance($.$ehc),Re.createInstance(S.$hhc),Re.createInstance(p.$ghc),Re.createInstance(l.$fhc),Re.createInstance(Ve.$Ehc),Re.createInstance(xe.$whc)))}async h(){const Re=new W.$Ai,De={_serviceBrand:void 0,...z.default};Re.set(_.$pk,De);const Ke=new R.$ki(Ze=>Ze==="main"),He=new yt.$Zgc(this.a,Ke);Re.set(yt.$Ygc,He);const et=this.f.policiesData?new ye.$tgc(this.f.policiesData,He.getChannel("policy")):new Ae.$ro;Re.set(Ae.$po,et);const Xe=new Bt.$5m(this.f.args,De);Re.set(t.$Ki,Xe);const ot=new V.$ps(void 0,this.f.logLevel,Xe.logsHome,this.f.loggers.map(Ze=>({...Ze,resource:O.URI.revive(Ze.resource)})),He.getChannel("logger"));Re.set(ie.$0j,ot);const ft=this.B(ot.createLogger("sharedprocess",{name:(0,_e.localize)(12030,null)})),$t=this.B(new ie.$ek(ft.getLevel())),tt=this.B(new Qe.$oR(ft,[$t]));Re.set(ie.$9j,tt),this.b=this.B(new nt.$Ghc(tt)),Re.set(nt.$Fhc,this.b);const st=this.B(new T.$Yq(tt));Re.set(E.$9k,st);const pt=this.B(new j.$pr(tt));st.registerProvider(N.Schemas.file,pt);const dt=new qe.$Qs(st);Re.set(Ue.$Gl,dt);const rt=this.B(new Te.$vR(this.f.profiles.all,O.URI.revive(this.f.profiles.home).with({scheme:Xe.userRoamingDataHome.scheme}),He.getChannel("userDataProfiles")));Re.set(fe.$Il,rt);const wt=this.B(new Fe.$Xgc(N.Schemas.file,this.B(new Be.$0Q(He.getChannel(Be.$9Q),{pathCaseSensitive:Ge.$l})),N.Schemas.vscodeUserData,rt,dt,tt));st.registerProvider(N.Schemas.vscodeUserData,wt);const ct=this.B(new m.$To(rt.defaultProfile.settingsResource,st,et,tt));Re.set(P.$9i,ct);const bt=new Ft.$Mhc(void 0,{defaultProfile:rt.defaultProfile,currentProfile:rt.defaultProfile},He,Xe);Re.set(ce.$eq,bt),this.B((0,L.$Rc)(()=>bt.flush())),await Promise.all([ct.initialize(),bt.initialize()]);const It=new Ct.$_r(He.getChannel("request"));Re.set(ne.$4p,It),Re.set(g.$ihc,new U.$zi(w.$jhc,void 0,!1)),Re.set(We.$LG,new U.$zi(ze.$vhc,void 0,!1));const Rt=new Dt.$2gc(-1,He);Re.set(Nt.$Gfc,Rt),Re.set(i.$Xo,new U.$zi(s.$DR,void 0,!0));const Ht=this.B(new de.$qgc(Rt)),Kt=new R.$ki(Ze=>Ht.getActiveClientId().then(mt=>Ze===mt));Re.set(b.$I6b,new Tt.$Ihc(this.a.getChannel("extensionRecommendationNotification",Kt)));let gt;const lt=[],Pt=(0,J.$Fp)(De,ct);if((0,J.$Ap)(De,Xe)){const Ze=new B.$ldc(tt,ot,Xe,De);if(lt.push(Ze),!(0,J.$Bp)(De,Xe)&&De.aiConfig?.ariaKey){const mt=new Me.$cR(It,Pt,"monacoworkbench",null,De.aiConfig.ariaKey);this.B((0,L.$Rc)(()=>mt.flush())),lt.push(mt)}gt=new D.$ds({appenders:lt,commonProperties:(0,te.$rp)((0,I.release)(),(0,I.hostname)(),process.arch,De.commit,De.version,this.f.machineId,this.f.sqmId,this.f.devDeviceId,Pt),sendErrorTelemetry:!0,piiPaths:(0,J.$Gp)(Xe)},ct,De)}else{gt=J.$vp;const Ze=J.$zp;lt.push(Ze)}this.a.registerChannel("telemetryAppender",new H.$8fc(lt)),Re.set(Y.$8l,gt);const Jt=new q.$khc(ct,gt,tt,ot,Xe,De);Re.set(Y.$9l,Jt),Re.set($e.$Fq,new U.$zi(Lt.$nR,void 0,!0)),Re.set(Ce.$Jq,new U.$zi(se.$ugc,void 0,!0)),Re.set(f.$pq,new U.$zi(f.$rq,void 0,!0)),Re.set(C.$Uq,new U.$zi(C.$Vq,void 0,!0)),Re.set(a.$hp,new U.$zi(r.$nq,void 0,!0)),Re.set(a.$op,new U.$zi(jt.$Lhc,void 0,!1)),Re.set(x.$8r,new U.$zi(G.$0r,void 0,!1)),Re.set(o.$Pm,new U.$zi(h.$Xs,void 0,!1)),Re.set(X.$_Lb,new U.$zi(X.$aMb,void 0,!0)),Re.set(ee.$Cnb,new U.$zi(ge.$FOb,void 0,!0)),Re.set(ee.$Bnb,R.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",Ze=>Ze.ctx!=="main"))),Re.set(a.$np,new U.$zi(n.$0Lb,void 0,!1)),Re.set(Z.$DOb,new U.$zi(Z.$EOb,void 0,!0)),Re.set(M.$lw,new U.$zi(M.$mw)),Re.set(ee.$mnb,new U.$zi(Se.$KNb,void 0,!0)),Re.set(ee.$nnb,new U.$zi(Se.$MNb,void 0,!0)),Re.set(pe.$_mb,new U.$zi(pe.$bnb,void 0,!0)),Re.set(ee.$onb,new U.$zi(re.$1dc,void 0,!1)),Re.set(ee.$xnb,new U.$zi(Ee.$Pdc,void 0,!0)),Re.set(ee.$ynb,new U.$zi(we.$6dc,void 0,!1)),Re.set(Ie.$LMb,new U.$zi(ae.$rhc,void 0,!0)),Re.set(ee.$znb,new U.$zi(Ye.$Jec,void 0,!0)),Re.set(me.$Vl,new U.$zi(Pe.$Ugc,void 0,!1));const kt=new vt.$Tl;return Re.set(vt.$Sl,kt),kt.register(Mt.RemoteConnectionType.WebSocket,qt.$Nhc),Re.set(Oe.$Aw,new U.$zi(je.$Sgc)),Re.set(Ne.$shc,new U.$zi(Le.$uhc)),Re.set(Je.$xhc,new U.$zi(at.$Hhc)),new K.$sr(Re)}j(Re){const De=new v.$tq(Re.get(a.$kp),()=>null);this.a.registerChannel("extensions",De);const Ke=R.ProxyChannel.fromService(Re.get(x.$8r),this.q);this.a.registerChannel("languagePacks",Ke);const He=R.ProxyChannel.fromService(Re.get(o.$Pm),this.q);this.a.registerChannel("diagnostics",He);const et=new v.$vq(Re.get(a.$op));this.a.registerChannel("extensionTipsService",et);const Xe=R.ProxyChannel.fromService(Re.get(g.$ihc),this.q);this.a.registerChannel("checksum",Xe);const ot=R.ProxyChannel.fromService(Re.get(We.$LG),this.q);this.a.registerChannel("v8InspectProfiling",ot);const ft=R.ProxyChannel.fromService(Re.get(pe.$_mb),this.q);this.a.registerChannel("userDataSyncMachines",ft);const $t=R.ProxyChannel.fromService(Re.get(Y.$9l),this.q);this.a.registerChannel("customEndpointTelemetry",$t);const tt=new le.$lhc(Re.get(X.$_Lb));this.a.registerChannel("userDataSyncAccount",tt);const st=new le.$nhc(Re.get(ee.$mnb));this.a.registerChannel("userDataSyncStoreManagement",st);const pt=new be.$phc(Re.get(ee.$ynb),Re.get(fe.$Il),Re.get(ie.$9j));this.a.registerChannel("userDataSync",pt);const dt=this.B(Re.get(F.$Bi).createInstance(Ut.$Khc));this.a.registerChannel("userDataAutoSync",R.ProxyChannel.fromService(dt,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",R.ProxyChannel.fromService(Re.get(ee.$znb),this.q));const rt=R.ProxyChannel.fromService(Re.get(Ne.$shc),this.q);this.a.registerChannel(Ne.$thc,rt);const wt=R.ProxyChannel.fromService(Re.get(Je.$xhc),this.q);this.a.registerChannel("remoteTunnel",wt)}m(Re){process.on("uncaughtException",De=>(0,A.$Y)(De)),process.on("unhandledRejection",De=>(0,A.$Y)(De)),(0,A.setUnexpectedErrorHandler)(De=>{const Ke=(0,c.$nj)(De,!0);Ke&&Re.error(`[uncaught exception in sharedProcess]: ${Ke}`)})}n(Re,De){Re.publicLog2("profilesInfo",{count:De.profiles.length})}async r(Re,De){if(Ge.$l){const[Ke,He]=await Promise.all([(0,zt.$Zg)(De.error.bind(De)),(0,Et.$sX)(De.error.bind(De))]),et=(0,Wt.$9W)(),Xe=(0,Et.$tX)(He,this.f.args["ozone-platform"]);Ke&&Re.publicLog2("clientPlatformInfo",{platformId:Ke.id,platformVersionId:Ke.version_id,platformIdLike:Ke.id_like,desktopEnvironment:et,displayProtocol:He,codeDisplayProtocol:Xe})}}handledClientConnection(Re){if(Re.data!==ht.$5fc.response)return!1;const De=(0,k.$Nb)(Re.ports);return De?(this.c.fire(De),!0):!1}}async function St(ut){try{const Re=new Vt(ut);process.parentPort.postMessage(ht.$3fc.ipcReady),await Re.init(),process.parentPort.postMessage(ht.$3fc.initDone)}catch(Re){process.parentPort.postMessage({error:Re.toString()})}}const Gt=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",ut=>{clearTimeout(Gt),St(ut.data)})})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/e6a828c5957959b7a18de37a567d850880101641/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
