/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/async","vs/nls","vs/workbench/api/common/extHostTypes","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/base/common/charCode","vs/platform/files/common/files","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/extpath","vs/base/common/uuid","vs/base/node/pfs","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/iterator","vs/base/common/marshallingIds","vs/workbench/api/common/extHostConfiguration","vs/base/common/stopwatch","vs/base/common/severity","fs","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/base/common/lazy","vs/base/common/themables","vs/base/common/marshalling","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","child_process","vs/editor/common/core/position","vs/editor/common/model","vs/base/common/decorators","vs/base/common/hash","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","os","net","vs/base/parts/ipc/common/ipc.net","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/codicons","vs/base/common/uint","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/progress/common/progress","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTesting","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/codiconsUtil","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/textModelSearch","vs/platform/instantiation/common/descriptors","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/serviceCollection","vs/platform/product/common/productService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/comparers","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/common/editor","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/console","vs/amdX","vs/base/common/dataTransfer","vs/base/node/ports","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/base/common/actions","vs/base/common/date","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensionValidator","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/request/common/request","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ie=function(me){for(var e=[],r=0,h=me.length;r<h;r++)e[r]=ke[me[r]];return e};define(ke[174],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.LoaderEventType=e.$R=void 0,e.$R=!1;var r;(function(C){C[C.LoaderAvailable=1]="LoaderAvailable",C[C.BeginLoadingScript=10]="BeginLoadingScript",C[C.EndLoadingScriptOK=11]="EndLoadingScriptOK",C[C.EndLoadingScriptError=12]="EndLoadingScriptError",C[C.BeginInvokeFactory=21]="BeginInvokeFactory",C[C.EndInvokeFactory=22]="EndInvokeFactory",C[C.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",C[C.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",C[C.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",C[C.NodeEndNativeRequire=34]="NodeEndNativeRequire",C[C.CachedDataFound=60]="CachedDataFound",C[C.CachedDataMissed=61]="CachedDataMissed",C[C.CachedDataRejected=62]="CachedDataRejected",C[C.CachedDataCreated=63]="CachedDataCreated"})(r||(e.LoaderEventType=r={}));class h{static get(){const T=new Map,L=new Map,R=new Map,b=new Map;function c(w,a){w.has(a.detail)||w.set(a.detail,-a.timestamp)}function I(w,a){const $=w.get(a.detail);$&&($>=0||w.set(a.detail,$+a.timestamp))}let D=[];typeof me=="function"&&typeof me.getStats=="function"&&(D=me.getStats().slice(0).sort((w,a)=>w.timestamp-a.timestamp));for(const w of D)switch(w.type){case r.BeginLoadingScript:c(T,w);break;case r.EndLoadingScriptOK:case r.EndLoadingScriptError:I(T,w);break;case r.BeginInvokeFactory:c(L,w);break;case r.EndInvokeFactory:I(L,w);break;case r.NodeBeginNativeRequire:c(R,w);break;case r.NodeEndNativeRequire:I(R,w);break;case r.NodeBeginEvaluatingScript:c(b,w);break;case r.NodeEndEvaluatingScript:I(b,w);break}let u=0;R.forEach(w=>u+=w);function P(w){const a=[];return w.forEach(($,f)=>a.push([f,$])),a}return{amdLoad:P(T),amdInvoke:P(L),nodeRequire:P(R),nodeEval:P(b),nodeRequireTotal:u}}static toMarkdownTable(T,L){let R="";const b=[];return T.forEach((c,I)=>{b[I]=c.length}),L.forEach(c=>{c.forEach((I,D)=>{typeof I>"u"&&(I=c[D]="-");const u=I.toString().length;b[D]=Math.max(u,b[D])})}),T.forEach((c,I)=>{R+=`| ${c+" ".repeat(b[I]-c.toString().length)} `}),R+=`|
`,T.forEach((c,I)=>{R+=`| ${"-".repeat(b[I])} `}),R+=`|
`,L.forEach(c=>{c.forEach((I,D)=>{typeof I<"u"&&(R+=`| ${I+" ".repeat(b[D]-I.toString().length)} `)}),R+=`|
`}),R}}e.$S=h}),define(ke[131],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lb=void 0,e.$eb=r,e.$fb=h,e.$gb=C,e.$hb=T,e.$ib=L,e.$jb=R,e.$kb=b,e.$mb=I,e.$nb=D,e.$ob=u,e.$pb=P,e.$qb=w;function r(a,$){const f=h(a,$);if(f!==-1)return a[f]}function h(a,$,f=a.length-1){for(let g=f;g>=0;g--){const i=a[g];if($(i))return g}return-1}function C(a,$){const f=T(a,$);return f===-1?void 0:a[f]}function T(a,$,f=0,g=a.length){let i=f,o=g;for(;i<o;){const t=Math.floor((i+o)/2);$(a[t])?i=t+1:o=t}return i-1}function L(a,$){const f=R(a,$);return f===a.length?void 0:a[f]}function R(a,$,f=0,g=a.length){let i=f,o=g;for(;i<o;){const t=Math.floor((i+o)/2);$(a[t])?o=t:i=t+1}return i}function b(a,$,f=0,g=a.length){const i=R(a,$,f,g);return i===a.length?-1:i}class c{static{this.assertInvariants=!1}constructor($){this.e=$,this.c=0}findLastMonotonous($){if(c.assertInvariants){if(this.d){for(const g of this.e)if(this.d(g)&&!$(g))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=$}const f=T(this.e,$,this.c);return this.c=f+1,f===-1?void 0:this.e[f]}}e.$lb=c;function I(a,$){if(a.length===0)return;let f=a[0];for(let g=1;g<a.length;g++){const i=a[g];$(i,f)>0&&(f=i)}return f}function D(a,$){if(a.length===0)return;let f=a[0];for(let g=1;g<a.length;g++){const i=a[g];$(i,f)>=0&&(f=i)}return f}function u(a,$){return I(a,(f,g)=>-$(f,g))}function P(a,$){if(a.length===0)return-1;let f=0;for(let g=1;g<a.length;g++){const i=a[g];$(i,a[f])>0&&(f=g)}return f}function w(a,$){for(const f of a){const g=$(f);if(g!==void 0)return g}}}),define(ke[26],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var r;(function(h){h[h.Null=0]="Null",h[h.Backspace=8]="Backspace",h[h.Tab=9]="Tab",h[h.LineFeed=10]="LineFeed",h[h.CarriageReturn=13]="CarriageReturn",h[h.Space=32]="Space",h[h.ExclamationMark=33]="ExclamationMark",h[h.DoubleQuote=34]="DoubleQuote",h[h.Hash=35]="Hash",h[h.DollarSign=36]="DollarSign",h[h.PercentSign=37]="PercentSign",h[h.Ampersand=38]="Ampersand",h[h.SingleQuote=39]="SingleQuote",h[h.OpenParen=40]="OpenParen",h[h.CloseParen=41]="CloseParen",h[h.Asterisk=42]="Asterisk",h[h.Plus=43]="Plus",h[h.Comma=44]="Comma",h[h.Dash=45]="Dash",h[h.Period=46]="Period",h[h.Slash=47]="Slash",h[h.Digit0=48]="Digit0",h[h.Digit1=49]="Digit1",h[h.Digit2=50]="Digit2",h[h.Digit3=51]="Digit3",h[h.Digit4=52]="Digit4",h[h.Digit5=53]="Digit5",h[h.Digit6=54]="Digit6",h[h.Digit7=55]="Digit7",h[h.Digit8=56]="Digit8",h[h.Digit9=57]="Digit9",h[h.Colon=58]="Colon",h[h.Semicolon=59]="Semicolon",h[h.LessThan=60]="LessThan",h[h.Equals=61]="Equals",h[h.GreaterThan=62]="GreaterThan",h[h.QuestionMark=63]="QuestionMark",h[h.AtSign=64]="AtSign",h[h.A=65]="A",h[h.B=66]="B",h[h.C=67]="C",h[h.D=68]="D",h[h.E=69]="E",h[h.F=70]="F",h[h.G=71]="G",h[h.H=72]="H",h[h.I=73]="I",h[h.J=74]="J",h[h.K=75]="K",h[h.L=76]="L",h[h.M=77]="M",h[h.N=78]="N",h[h.O=79]="O",h[h.P=80]="P",h[h.Q=81]="Q",h[h.R=82]="R",h[h.S=83]="S",h[h.T=84]="T",h[h.U=85]="U",h[h.V=86]="V",h[h.W=87]="W",h[h.X=88]="X",h[h.Y=89]="Y",h[h.Z=90]="Z",h[h.OpenSquareBracket=91]="OpenSquareBracket",h[h.Backslash=92]="Backslash",h[h.CloseSquareBracket=93]="CloseSquareBracket",h[h.Caret=94]="Caret",h[h.Underline=95]="Underline",h[h.BackTick=96]="BackTick",h[h.a=97]="a",h[h.b=98]="b",h[h.c=99]="c",h[h.d=100]="d",h[h.e=101]="e",h[h.f=102]="f",h[h.g=103]="g",h[h.h=104]="h",h[h.i=105]="i",h[h.j=106]="j",h[h.k=107]="k",h[h.l=108]="l",h[h.m=109]="m",h[h.n=110]="n",h[h.o=111]="o",h[h.p=112]="p",h[h.q=113]="q",h[h.r=114]="r",h[h.s=115]="s",h[h.t=116]="t",h[h.u=117]="u",h[h.v=118]="v",h[h.w=119]="w",h[h.x=120]="x",h[h.y=121]="y",h[h.z=122]="z",h[h.OpenCurlyBrace=123]="OpenCurlyBrace",h[h.Pipe=124]="Pipe",h[h.CloseCurlyBrace=125]="CloseCurlyBrace",h[h.Tilde=126]="Tilde",h[h.NoBreakSpace=160]="NoBreakSpace",h[h.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",h[h.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",h[h.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",h[h.U_Combining_Tilde=771]="U_Combining_Tilde",h[h.U_Combining_Macron=772]="U_Combining_Macron",h[h.U_Combining_Overline=773]="U_Combining_Overline",h[h.U_Combining_Breve=774]="U_Combining_Breve",h[h.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",h[h.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",h[h.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",h[h.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",h[h.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",h[h.U_Combining_Caron=780]="U_Combining_Caron",h[h.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",h[h.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",h[h.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",h[h.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",h[h.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",h[h.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",h[h.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",h[h.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",h[h.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",h[h.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",h[h.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",h[h.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",h[h.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",h[h.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",h[h.U_Combining_Horn=795]="U_Combining_Horn",h[h.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",h[h.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",h[h.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",h[h.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",h[h.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",h[h.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",h[h.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",h[h.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",h[h.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",h[h.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",h[h.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",h[h.U_Combining_Cedilla=807]="U_Combining_Cedilla",h[h.U_Combining_Ogonek=808]="U_Combining_Ogonek",h[h.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",h[h.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",h[h.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",h[h.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",h[h.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",h[h.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",h[h.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",h[h.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",h[h.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",h[h.U_Combining_Low_Line=818]="U_Combining_Low_Line",h[h.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",h[h.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",h[h.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",h[h.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",h[h.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",h[h.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",h[h.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",h[h.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",h[h.U_Combining_Square_Below=827]="U_Combining_Square_Below",h[h.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",h[h.U_Combining_X_Above=829]="U_Combining_X_Above",h[h.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",h[h.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",h[h.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",h[h.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",h[h.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",h[h.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",h[h.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",h[h.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",h[h.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",h[h.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",h[h.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",h[h.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",h[h.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",h[h.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",h[h.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",h[h.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",h[h.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",h[h.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",h[h.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",h[h.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",h[h.U_Combining_Fermata=850]="U_Combining_Fermata",h[h.U_Combining_X_Below=851]="U_Combining_X_Below",h[h.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",h[h.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",h[h.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",h[h.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",h[h.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",h[h.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",h[h.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",h[h.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",h[h.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",h[h.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",h[h.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",h[h.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",h[h.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",h[h.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",h[h.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",h[h.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",h[h.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",h[h.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",h[h.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",h[h.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",h[h.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",h[h.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",h[h.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",h[h.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",h[h.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",h[h.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",h[h.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",h[h.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",h[h.LINE_SEPARATOR=8232]="LINE_SEPARATOR",h[h.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",h[h.NEXT_LINE=133]="NEXT_LINE",h[h.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",h[h.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",h[h.U_DIAERESIS=168]="U_DIAERESIS",h[h.U_MACRON=175]="U_MACRON",h[h.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",h[h.U_CEDILLA=184]="U_CEDILLA",h[h.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",h[h.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",h[h.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",h[h.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",h[h.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",h[h.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",h[h.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",h[h.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",h[h.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",h[h.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",h[h.U_BREVE=728]="U_BREVE",h[h.U_DOT_ABOVE=729]="U_DOT_ABOVE",h[h.U_RING_ABOVE=730]="U_RING_ABOVE",h[h.U_OGONEK=731]="U_OGONEK",h[h.U_SMALL_TILDE=732]="U_SMALL_TILDE",h[h.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",h[h.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",h[h.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",h[h.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",h[h.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",h[h.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",h[h.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",h[h.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",h[h.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",h[h.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",h[h.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",h[h.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",h[h.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",h[h.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",h[h.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",h[h.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",h[h.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",h[h.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",h[h.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",h[h.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",h[h.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",h[h.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",h[h.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",h[h.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",h[h.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",h[h.U_GREEK_TONOS=900]="U_GREEK_TONOS",h[h.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",h[h.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",h[h.U_GREEK_PSILI=8127]="U_GREEK_PSILI",h[h.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",h[h.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",h[h.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",h[h.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",h[h.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",h[h.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",h[h.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",h[h.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",h[h.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",h[h.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",h[h.U_GREEK_VARIA=8175]="U_GREEK_VARIA",h[h.U_GREEK_OXIA=8189]="U_GREEK_OXIA",h[h.U_GREEK_DASIA=8190]="U_GREEK_DASIA",h[h.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",h[h.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",h[h.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",h[h.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",h[h.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",h[h.U_OVERLINE=8254]="U_OVERLINE",h[h.UTF8_BOM=65279]="UTF8_BOM",h[h.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",h[h.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(r||(e.CharCode=r={}))}),define(ke[78],Ie([1,0]),function(me,e){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$g=void 0,e.$c=h,e.$d=C,e.$e=T,e.$f=L;function h(b,c){const I=Object.create(null);for(const D of b){const u=c(D);let P=I[u];P||(P=I[u]=[]),P.push(D)}return I}function C(b,c){const I=[],D=[];for(const u of b)c.has(u)||I.push(u);for(const u of c)b.has(u)||D.push(u);return{removed:I,added:D}}function T(b,c){const I=[],D=[];for(const[u,P]of b)c.has(u)||I.push(P);for(const[u,P]of c)b.has(u)||D.push(P);return{removed:I,added:D}}function L(b,c){const I=new Set;for(const D of c)b.has(D)&&I.add(D);return I}class R{static{r=Symbol.toStringTag}constructor(c,I){this.b=I,this.a=new Map,this[r]="SetWithKey";for(const D of c)this.add(D)}get size(){return this.a.size}add(c){const I=this.b(c);return this.a.set(I,c),this}delete(c){return this.a.delete(this.b(c))}has(c){return this.a.has(this.b(c))}*entries(){for(const c of this.a.values())yield[c,c]}keys(){return this.values()}*values(){for(const c of this.a.values())yield c}clear(){this.a.clear()}forEach(c,I){this.a.forEach(D=>c.call(I,D,D,this))}[Symbol.iterator](){return this.values()}}e.$g=R}),define(ke[59],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=h,e.$8h=C,e.$9h=T;function r(L){return(R,b,c)=>{let I=null,D=null;if(typeof c.value=="function"?(I="value",D=c.value):typeof c.get=="function"&&(I="get",D=c.get),!D)throw new Error("not supported");c[I]=L(D,b)}}function h(L,R,b){let c=null,I=null;if(typeof b.value=="function"?(c="value",I=b.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(c="get",I=b.get),!I)throw new Error("not supported");const D=`$memoize$${R}`;b[c]=function(...u){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,u)}),this[D]}}function C(L,R,b){return r((c,I)=>{const D=`$debounce$${I}`,u=`$debounce$result$${I}`;return function(...P){this[u]||(this[u]=b?b():void 0),clearTimeout(this[D]),R&&(this[u]=R(this[u],...P),P=[this[u]]),this[D]=setTimeout(()=>{c.apply(this,P),this[u]=b?b():void 0},L)}})}function T(L,R,b){return r((c,I)=>{const D=`$throttle$timer$${I}`,u=`$throttle$result$${I}`,P=`$throttle$lastRun$${I}`,w=`$throttle$pending$${I}`;return function(...a){if(this[u]||(this[u]=b?b():void 0),(this[P]===null||this[P]===void 0)&&(this[P]=-Number.MAX_VALUE),R&&(this[u]=R(this[u],...a)),this[w])return;const $=this[P]+L;$<=Date.now()?(this[P]=Date.now(),c.apply(this,[this[u]]),this[u]=b?b():void 0):(this[w]=!0,this[D]=setTimeout(()=>{this[w]=!1,this[P]=Date.now(),c.apply(this,[this[u]]),this[u]=b?b():void 0},$-Date.now()))}})}}),define(ke[13],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$8=e.$4=e.$V=e.$U=void 0,e.setUnexpectedErrorHandler=h,e.$X=C,e.$Y=T,e.$Z=L,e.$1=R,e.$2=b,e.$3=I,e.$5=u,e.$6=P,e.$7=w,e.$9=$;class r{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?o.isErrorNoTelemetry(n)?new o(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(d=>{d(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.$U=r,e.$V=new r;function h(s){e.$V.setUnexpectedErrorHandler(s)}function C(s){if(!s||typeof s!="object")return!1;const n=s;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function T(s){I(s)||e.$V.onUnexpectedError(s)}function L(s){I(s)||e.$V.onUnexpectedExternalError(s)}function R(s){if(s instanceof Error){const{name:n,message:d}=s,l=s.stacktrace||s.stack;return{$isError:!0,name:n,message:d,stack:l,noTelemetry:o.isErrorNoTelemetry(s)}}return s}function b(s){let n;return s.noTelemetry?n=new o:(n=new Error,n.name=s.name),n.message=s.message,n.stack=s.stack,n}const c="Canceled";function I(s){return s instanceof D?!0:s instanceof Error&&s.name===c&&s.message===c}class D extends Error{constructor(){super(c),this.name=this.message}}e.$4=D;function u(){const s=new Error(c);return s.name=s.message,s}function P(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}function w(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}class a extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=a;function $(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}class f extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.$0=f;class g extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.$$=g;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=i;class o extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof o)return n;const d=new o;return d.message=n.message,d.stack=n.stack,d}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.$ab=o;class t extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,t.prototype)}}e.$bb=t}),define(ke[18],Ie([1,0,13,131]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$8b=e.$7b=e.CompareResult=void 0,e.$rb=C,e.$sb=T,e.$tb=L,e.$ub=R,e.$vb=b,e.$wb=c,e.$xb=I,e.$yb=D,e.$zb=u,e.$Ab=P,e.$Bb=w,e.$Cb=a,e.$Db=$,e.top=f,e.$Fb=g,e.$Gb=o,e.$Hb=t,e.$Ib=s,e.$Jb=n,e.$Kb=d,e.$Lb=l,e.$Mb=m,e.$Nb=E,e.$Ob=S,e.$Pb=y,e.$Qb=k,e.$Rb=A,e.$Sb=p,e.$Tb=v,e.$Ub=F,e.$Vb=N,e.$Wb=O,e.$Xb=j,e.$Yb=z,e.$Zb=M,e.$1b=V,e.$2b=K,e.$3b=ne,e.$4b=B,e.$5b=ee,e.$6b=ue,e.$9b=$e;function C(ae,te=0){return ae[ae.length-(1+te)]}function T(ae){if(ae.length===0)throw new Error("Invalid tail call");return[ae.slice(0,ae.length-1),ae[ae.length-1]]}function L(ae,te,ce=(le,Z)=>le===Z){if(ae===te)return!0;if(!ae||!te||ae.length!==te.length)return!1;for(let le=0,Z=ae.length;le<Z;le++)if(!ce(ae[le],te[le]))return!1;return!0}function R(ae,te){const ce=ae.length-1;te<ce&&(ae[te]=ae[ce]),ae.pop()}function b(ae,te,ce){return c(ae.length,le=>ce(ae[le],te))}function c(ae,te){let ce=0,le=ae-1;for(;ce<=le;){const Z=(ce+le)/2|0,oe=te(Z);if(oe<0)ce=Z+1;else if(oe>0)le=Z-1;else return Z}return-(ce+1)}function I(ae,te,ce){if(ae=ae|0,ae>=te.length)throw new TypeError("invalid index");const le=te[Math.floor(te.length*Math.random())],Z=[],oe=[],pe=[];for(const we of te){const Fe=ce(we,le);Fe<0?Z.push(we):Fe>0?oe.push(we):pe.push(we)}return ae<Z.length?I(ae,Z,ce):ae<Z.length+pe.length?pe[0]:I(ae-(Z.length+pe.length),oe,ce)}function D(ae,te){const ce=[];let le;for(const Z of ae.slice(0).sort(te))!le||te(le[0],Z)!==0?(le=[Z],ce.push(le)):le.push(Z);return ce}function*u(ae,te){let ce,le;for(const Z of ae)le!==void 0&&te(le,Z)?ce.push(Z):(ce&&(yield ce),ce=[Z]),le=Z;ce&&(yield ce)}function P(ae,te){for(let ce=0;ce<=ae.length;ce++)te(ce===0?void 0:ae[ce-1],ce===ae.length?void 0:ae[ce])}function w(ae,te){for(let ce=0;ce<ae.length;ce++)te(ce===0?void 0:ae[ce-1],ae[ce],ce+1===ae.length?void 0:ae[ce+1])}function a(ae,te,ce){const le=[];function Z(we,Fe,We){if(Fe===0&&We.length===0)return;const Se=le[le.length-1];Se&&Se.start+Se.deleteCount===we?(Se.deleteCount+=Fe,Se.toInsert.push(...We)):le.push({start:we,deleteCount:Fe,toInsert:We})}let oe=0,pe=0;for(;;){if(oe===ae.length){Z(oe,0,te.slice(pe));break}if(pe===te.length){Z(oe,ae.length-oe,[]);break}const we=ae[oe],Fe=te[pe],We=ce(we,Fe);We===0?(oe+=1,pe+=1):We<0?(Z(oe,1,[]),oe+=1):We>0&&(Z(oe,0,[Fe]),pe+=1)}return le}function $(ae,te,ce){const le=a(ae,te,ce),Z=[],oe=[];for(const pe of le)Z.push(...ae.slice(pe.start,pe.start+pe.deleteCount)),oe.push(...pe.toInsert);return{removed:Z,added:oe}}function f(ae,te,ce){if(ce===0)return[];const le=ae.slice(0,ce).sort(te);return i(ae,te,le,ce,ae.length),le}function g(ae,te,ce,le,Z){return ce===0?Promise.resolve([]):new Promise((oe,pe)=>{(async()=>{const we=ae.length,Fe=ae.slice(0,ce).sort(te);for(let We=ce,Se=Math.min(ce+le,we);We<we;We=Se,Se=Math.min(Se+le,we)){if(We>ce&&await new Promise(De=>setTimeout(De)),Z&&Z.isCancellationRequested)throw new r.$4;i(ae,te,Fe,We,Se)}return Fe})().then(oe,pe)})}function i(ae,te,ce,le,Z){for(const oe=ce.length;le<Z;le++){const pe=ae[le];if(te(pe,ce[oe-1])<0){ce.pop();const we=(0,h.$jb)(ce,Fe=>te(pe,Fe)<0);ce.splice(we,0,pe)}}}function o(ae){return ae.filter(te=>!!te)}function t(ae){let te=0;for(let ce=0;ce<ae.length;ce++)ae[ce]&&(ae[te]=ae[ce],te+=1);ae.length=te}function s(ae,te,ce){ae.splice(ce,0,ae.splice(te,1)[0])}function n(ae){return!Array.isArray(ae)||ae.length===0}function d(ae){return Array.isArray(ae)&&ae.length>0}function l(ae,te=ce=>ce){const ce=new Set;return ae.filter(le=>{const Z=te(le);return ce.has(Z)?!1:(ce.add(Z),!0)})}function m(ae){const te=new Set;return ce=>{const le=ae(ce);return te.has(le)?!1:(te.add(le),!0)}}function E(ae,te){return ae.length>0?ae[0]:te}function S(ae,te){return ae.length>0?ae[ae.length-1]:te}function y(ae,te,ce=(le,Z)=>le===Z){let le=0;for(let Z=0,oe=Math.min(ae.length,te.length);Z<oe&&ce(ae[Z],te[Z]);Z++)le++;return le}function k(ae,te){let ce=typeof te=="number"?ae:0;typeof te=="number"?ce=ae:(ce=0,te=ae);const le=[];if(ce<=te)for(let Z=ce;Z<te;Z++)le.push(Z);else for(let Z=ce;Z>te;Z--)le.push(Z);return le}function A(ae,te,ce){return ae.reduce((le,Z)=>(le[te(Z)]=ce?ce(Z):Z,le),Object.create(null))}function p(ae,te){return ae.push(te),()=>v(ae,te)}function v(ae,te){const ce=ae.indexOf(te);if(ce>-1)return ae.splice(ce,1),te}function F(ae,te,ce){const le=ae.slice(0,te),Z=ae.slice(te);return le.concat(ce,Z)}function N(ae,te){let ce;if(typeof te=="number"){let le=te;ce=()=>{const Z=Math.sin(le++)*179426549;return Z-Math.floor(Z)}}else ce=Math.random;for(let le=ae.length-1;le>0;le-=1){const Z=Math.floor(ce()*(le+1)),oe=ae[le];ae[le]=ae[Z],ae[Z]=oe}}function O(ae,te){const ce=ae.indexOf(te);ce>-1&&(ae.splice(ce,1),ae.unshift(te))}function j(ae,te){const ce=ae.indexOf(te);ce>-1&&(ae.splice(ce,1),ae.push(te))}function z(ae,te){for(const ce of te)ae.push(ce)}function M(ae,te){return Array.isArray(ae)?ae.map(te):te(ae)}function V(ae){return Array.isArray(ae)?ae:[ae]}function K(ae){return ae[Math.floor(Math.random()*ae.length)]}function ne(ae,te,ce){const le=G(ae,te),Z=ae.length,oe=ce.length;ae.length=Z+oe;for(let pe=Z-1;pe>=le;pe--)ae[pe+oe]=ae[pe];for(let pe=0;pe<oe;pe++)ae[pe+le]=ce[pe]}function B(ae,te,ce,le){const Z=G(ae,te);let oe=ae.splice(Z,ce);return oe===void 0&&(oe=[]),ne(ae,Z,le),oe}function G(ae,te){return te<0?Math.max(te+ae.length,0):Math.min(te,ae.length)}var Y;(function(ae){function te(oe){return oe<0}ae.isLessThan=te;function ce(oe){return oe<=0}ae.isLessThanOrEqual=ce;function le(oe){return oe>0}ae.isGreaterThan=le;function Z(oe){return oe===0}ae.isNeitherLessOrGreaterThan=Z,ae.greaterThan=1,ae.lessThan=-1,ae.neitherLessOrGreaterThan=0})(Y||(e.CompareResult=Y={}));function ee(ae,te){return(ce,le)=>te(ae(ce),ae(le))}function ue(...ae){return(te,ce)=>{for(const le of ae){const Z=le(te,ce);if(!Y.isNeitherLessOrGreaterThan(Z))return Z}return Y.neitherLessOrGreaterThan}}const re=(ae,te)=>ae-te;e.$7b=re;const ye=(ae,te)=>(0,e.$7b)(ae?1:0,te?1:0);e.$8b=ye;function $e(ae){return(te,ce)=>-ae(te,ce)}class J{constructor(te){this.g=te,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(te){let ce=this.c;for(;ce<this.g.length&&te(this.g[ce]);)ce++;const le=ce===this.c?null:this.g.slice(this.c,ce);return this.c=ce,le}takeFromEndWhile(te){let ce=this.d;for(;ce>=0&&te(this.g[ce]);)ce--;const le=ce===this.d?null:this.g.slice(ce+1,this.d+1);return this.d=ce,le}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const te=this.g[this.c];return this.c++,te}removeLast(){const te=this.g[this.d];return this.d--,te}takeCount(te){const ce=this.g.slice(this.c,this.c+te);return this.c+=te,ce}}e.$0b=J;class W{static{this.empty=new W(te=>{})}constructor(te){this.iterate=te}forEach(te){this.iterate(ce=>(te(ce),!0))}toArray(){const te=[];return this.iterate(ce=>(te.push(ce),!0)),te}filter(te){return new W(ce=>this.iterate(le=>te(le)?ce(le):!0))}map(te){return new W(ce=>this.iterate(le=>ce(te(le))))}some(te){let ce=!1;return this.iterate(le=>(ce=te(le),!ce)),ce}findFirst(te){let ce;return this.iterate(le=>te(le)?(ce=le,!1):!0),ce}findLast(te){let ce;return this.iterate(le=>(te(le)&&(ce=le),!0)),ce}findLastMaxBy(te){let ce,le=!0;return this.iterate(Z=>((le||Y.isGreaterThan(te(Z,ce)))&&(le=!1,ce=Z),!0)),ce}}e.$$b=W;class se{constructor(te){this.c=te}static createSortPermutation(te,ce){const le=Array.from(te.keys()).sort((Z,oe)=>ce(te[Z],te[oe]));return new se(le)}apply(te){return te.map((ce,le)=>te[this.c[le]])}inverse(){const te=this.c.slice();for(let ce=0;ce<this.c.length;ce++)te[this.c[ce]]=ce;return new se(te)}}e.$_b=se}),define(ke[65],Ie([1,0,13]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=h,e.$dd=C,e.$ed=T,e.$fd=L,e.$gd=R,e.$hd=b;function h(c,I){if(!c)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}function C(c,I="Unreachable"){throw new Error(I)}function T(c,I="unexpected state"){if(!c)throw new r.$bb(`Assertion Failed: ${I}`)}function L(c){c||(0,r.$Y)(new r.$bb("Soft Assertion Failed"))}function R(c){if(!c()){debugger;c(),(0,r.$Y)(new r.$bb("Assertion Failed"))}}function b(c,I){let D=0;for(;D<c.length-1;){const u=c[D],P=c[D+1];if(!I(u,P))return!1;D++}return!0}});var Wn=this&&this.__createBinding||(Object.create?function(me,e,r,h){h===void 0&&(h=r);var C=Object.getOwnPropertyDescriptor(e,r);(!C||("get"in C?!e.__esModule:C.writable||C.configurable))&&(C={enumerable:!0,get:function(){return e[r]}}),Object.defineProperty(me,h,C)}:function(me,e,r,h){h===void 0&&(h=r),me[h]=e[r]}),Un=this&&this.__setModuleDefault||(Object.create?function(me,e){Object.defineProperty(me,"default",{enumerable:!0,value:e})}:function(me,e){me.default=e}),Ue=this&&this.__importStar||function(me){if(me&&me.__esModule)return me;var e={};if(me!=null)for(var r in me)r!=="default"&&Object.prototype.hasOwnProperty.call(me,r)&&Wn(e,me,r);return Un(e,me),e};define(ke[175],Ie([1,0,18]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0,e.$6c=C,e.$7c=T,e.$8c=L,e.$9c=R,e.$0c=b,e.$$c=c,r=Ue(r);const h=(P,w)=>P===w;e.$5c=h;function C(P=e.$5c){return(w,a)=>r.$tb(w,a,P)}function T(){return(P,w)=>JSON.stringify(P)===JSON.stringify(w)}function L(){return(P,w)=>P.equals(w)}function R(P,w,a){if(a!==void 0){const $=P;return $==null||w===void 0||w===null?w===$:a($,w)}else{const $=P;return(f,g)=>f==null||g===void 0||g===null?g===f:$(f,g)}}function b(P,w){if(P===w)return!0;if(Array.isArray(P)&&Array.isArray(w)){if(P.length!==w.length)return!1;for(let a=0;a<P.length;a++)if(!b(P[a],w[a]))return!1;return!0}if(P&&typeof P=="object"&&w&&typeof w=="object"&&Object.getPrototypeOf(P)===Object.prototype&&Object.getPrototypeOf(w)===Object.prototype){const a=P,$=w,f=Object.keys(a),g=Object.keys($),i=new Set(g);if(f.length!==g.length)return!1;for(const o of f)if(!i.has(o)||!b(a[o],$[o]))return!1;return!0}return!1}function c(P){return JSON.stringify(u(P))}let I=0;const D=new WeakMap;function u(P){if(Array.isArray(P))return P.map(u);if(P&&typeof P=="object")if(Object.getPrototypeOf(P)===Object.prototype){const w=P,a=Object.create(null);for(const $ of Object.keys(w).sort())a[$]=u(w[$]);return a}else{let w=D.get(P);return w===void 0&&(w=I++,D.set(P,w)),w+"----2b76a038c20c4bcc"}return P}}),define(ke[79],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=r;function r(h,C){const T=this;let L=!1,R;return function(){if(L)return R;if(L=!0,C)try{R=h.apply(T,arguments)}finally{C()}else R=h.apply(T,arguments);return R}}}),define(ke[132],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7P=e.$6P=void 0;class r{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$6P=r,e.$7P=new r("id#")}),define(ke[39],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var r;(function(h){function C(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}h.is=C;const T=Object.freeze([]);function L(){return T}h.empty=L;function*R(n){yield n}h.single=R;function b(n){return C(n)?n:R(n)}h.wrap=b;function c(n){return n||T}h.from=c;function*I(n){for(let d=n.length-1;d>=0;d--)yield n[d]}h.reverse=I;function D(n){return!n||n[Symbol.iterator]().next().done===!0}h.isEmpty=D;function u(n){return n[Symbol.iterator]().next().value}h.first=u;function P(n,d){let l=0;for(const m of n)if(d(m,l++))return!0;return!1}h.some=P;function w(n,d){for(const l of n)if(d(l))return l}h.find=w;function*a(n,d){for(const l of n)d(l)&&(yield l)}h.filter=a;function*$(n,d){let l=0;for(const m of n)yield d(m,l++)}h.map=$;function*f(n,d){let l=0;for(const m of n)yield*d(m,l++)}h.flatMap=f;function*g(...n){for(const d of n)yield*d}h.concat=g;function i(n,d,l){let m=l;for(const E of n)m=d(m,E);return m}h.reduce=i;function*o(n,d,l=n.length){for(d<0&&(d+=n.length),l<0?l+=n.length:l>n.length&&(l=n.length);d<l;d++)yield n[d]}h.slice=o;function t(n,d=Number.POSITIVE_INFINITY){const l=[];if(d===0)return[l,n];const m=n[Symbol.iterator]();for(let E=0;E<d;E++){const S=m.next();if(S.done)return[l,h.empty()];l.push(S.value)}return[l,{[Symbol.iterator](){return m}}]}h.consume=t;async function s(n){const d=[];for await(const l of n)d.push(l);return Promise.resolve(d)}h.asyncToArray=s})(r||(e.Iterable=r={}))}),define(ke[176],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Sn=L,e.$Tn=D,e.$Un=u,e.$Vn=P,e.$Wn=w,e.$Xn=a,e.$Yn=$,e.$Zn=f,e.$1n=g,e.$2n=i,e.$3n=o;var r;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(r||(e.ScanError=r={}));var h;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(h||(e.SyntaxKind=h={}));var C;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T||(e.ParseOptions=T={}));function L(t,s=!1){let n=0;const d=t.length;let l="",m=0,E=h.Unknown,S=r.None;function y(O){let j=0,z=0;for(;j<O;){const M=t.charCodeAt(n);if(M>=I._0&&M<=I._9)z=z*16+M-I._0;else if(M>=I.A&&M<=I.F)z=z*16+M-I.A+10;else if(M>=I.a&&M<=I.f)z=z*16+M-I.a+10;else break;n++,j++}return j<O&&(z=-1),z}function k(O){n=O,l="",m=0,E=h.Unknown,S=r.None}function A(){const O=n;if(t.charCodeAt(n)===I._0)n++;else for(n++;n<t.length&&c(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===I.dot)if(n++,n<t.length&&c(t.charCodeAt(n)))for(n++;n<t.length&&c(t.charCodeAt(n));)n++;else return S=r.UnexpectedEndOfNumber,t.substring(O,n);let j=n;if(n<t.length&&(t.charCodeAt(n)===I.E||t.charCodeAt(n)===I.e))if(n++,(n<t.length&&t.charCodeAt(n)===I.plus||t.charCodeAt(n)===I.minus)&&n++,n<t.length&&c(t.charCodeAt(n))){for(n++;n<t.length&&c(t.charCodeAt(n));)n++;j=n}else S=r.UnexpectedEndOfNumber;return t.substring(O,j)}function p(){let O="",j=n;for(;;){if(n>=d){O+=t.substring(j,n),S=r.UnexpectedEndOfString;break}const z=t.charCodeAt(n);if(z===I.doubleQuote){O+=t.substring(j,n),n++;break}if(z===I.backslash){if(O+=t.substring(j,n),n++,n>=d){S=r.UnexpectedEndOfString;break}switch(t.charCodeAt(n++)){case I.doubleQuote:O+='"';break;case I.backslash:O+="\\";break;case I.slash:O+="/";break;case I.b:O+="\b";break;case I.f:O+="\f";break;case I.n:O+=`
`;break;case I.r:O+="\r";break;case I.t:O+="	";break;case I.u:{const V=y(4);V>=0?O+=String.fromCharCode(V):S=r.InvalidUnicode;break}default:S=r.InvalidEscapeCharacter}j=n;continue}if(z>=0&&z<=31)if(b(z)){O+=t.substring(j,n),S=r.UnexpectedEndOfString;break}else S=r.InvalidCharacter;n++}return O}function v(){if(l="",S=r.None,m=n,n>=d)return m=d,E=h.EOF;let O=t.charCodeAt(n);if(R(O)){do n++,l+=String.fromCharCode(O),O=t.charCodeAt(n);while(R(O));return E=h.Trivia}if(b(O))return n++,l+=String.fromCharCode(O),O===I.carriageReturn&&t.charCodeAt(n)===I.lineFeed&&(n++,l+=`
`),E=h.LineBreakTrivia;switch(O){case I.openBrace:return n++,E=h.OpenBraceToken;case I.closeBrace:return n++,E=h.CloseBraceToken;case I.openBracket:return n++,E=h.OpenBracketToken;case I.closeBracket:return n++,E=h.CloseBracketToken;case I.colon:return n++,E=h.ColonToken;case I.comma:return n++,E=h.CommaToken;case I.doubleQuote:return n++,l=p(),E=h.StringLiteral;case I.slash:{const j=n-1;if(t.charCodeAt(n+1)===I.slash){for(n+=2;n<d&&!b(t.charCodeAt(n));)n++;return l=t.substring(j,n),E=h.LineCommentTrivia}if(t.charCodeAt(n+1)===I.asterisk){n+=2;const z=d-1;let M=!1;for(;n<z;){if(t.charCodeAt(n)===I.asterisk&&t.charCodeAt(n+1)===I.slash){n+=2,M=!0;break}n++}return M||(n++,S=r.UnexpectedEndOfComment),l=t.substring(j,n),E=h.BlockCommentTrivia}return l+=String.fromCharCode(O),n++,E=h.Unknown}case I.minus:if(l+=String.fromCharCode(O),n++,n===d||!c(t.charCodeAt(n)))return E=h.Unknown;case I._0:case I._1:case I._2:case I._3:case I._4:case I._5:case I._6:case I._7:case I._8:case I._9:return l+=A(),E=h.NumericLiteral;default:for(;n<d&&F(O);)n++,O=t.charCodeAt(n);if(m!==n){switch(l=t.substring(m,n),l){case"true":return E=h.TrueKeyword;case"false":return E=h.FalseKeyword;case"null":return E=h.NullKeyword}return E=h.Unknown}return l+=String.fromCharCode(O),n++,E=h.Unknown}}function F(O){if(R(O)||b(O))return!1;switch(O){case I.closeBrace:case I.closeBracket:case I.openBrace:case I.openBracket:case I.doubleQuote:case I.colon:case I.comma:case I.slash:return!1}return!0}function N(){let O;do O=v();while(O>=h.LineCommentTrivia&&O<=h.Trivia);return O}return{setPosition:k,getPosition:()=>n,scan:s?N:v,getToken:()=>E,getTokenValue:()=>l,getTokenOffset:()=>m,getTokenLength:()=>n-m,getTokenError:()=>S}}function R(t){return t===I.space||t===I.tab||t===I.verticalTab||t===I.formFeed||t===I.nonBreakingSpace||t===I.ogham||t>=I.enQuad&&t<=I.zeroWidthSpace||t===I.narrowNoBreakSpace||t===I.mathematicalSpace||t===I.ideographicSpace||t===I.byteOrderMark}function b(t){return t===I.lineFeed||t===I.carriageReturn||t===I.lineSeparator||t===I.paragraphSeparator}function c(t){return t>=I._0&&t<=I._9}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function D(t,s){const n=[],d=new Object;let l;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function S(y,k,A,p){m.value=y,m.offset=k,m.length=A,m.type=p,m.colonOffset=void 0,l=m}try{i(t,{onObjectBegin:(y,k)=>{if(s<=y)throw d;l=void 0,E=s>y,n.push("")},onObjectProperty:(y,k,A)=>{if(s<k||(S(y,k,A,"property"),n[n.length-1]=y,s<=k+A))throw d},onObjectEnd:(y,k)=>{if(s<=y)throw d;l=void 0,n.pop()},onArrayBegin:(y,k)=>{if(s<=y)throw d;l=void 0,n.push(0)},onArrayEnd:(y,k)=>{if(s<=y)throw d;l=void 0,n.pop()},onLiteralValue:(y,k,A)=>{if(s<k||(S(y,k,A,o(y)),s<=k+A))throw d},onSeparator:(y,k,A)=>{if(s<=k)throw d;if(y===":"&&l&&l.type==="property")l.colonOffset=k,E=!1,l=void 0;else if(y===","){const p=n[n.length-1];typeof p=="number"?n[n.length-1]=p+1:(E=!0,n[n.length-1]=""),l=void 0}}})}catch(y){if(y!==d)throw y}return{path:n,previousNode:l,isAtPropertyKey:E,matches:y=>{let k=0;for(let A=0;k<y.length&&A<n.length;A++)if(y[k]===n[A]||y[k]==="*")k++;else if(y[k]!=="**")return!1;return k===y.length}}}function u(t,s=[],n=T.DEFAULT){let d=null,l=[];const m=[];function E(y){Array.isArray(l)?l.push(y):d!==null&&(l[d]=y)}return i(t,{onObjectBegin:()=>{const y={};E(y),m.push(l),l=y,d=null},onObjectProperty:y=>{d=y},onObjectEnd:()=>{l=m.pop()},onArrayBegin:()=>{const y=[];E(y),m.push(l),l=y,d=null},onArrayEnd:()=>{l=m.pop()},onLiteralValue:E,onError:(y,k,A)=>{s.push({error:y,offset:k,length:A})}},n),l[0]}function P(t,s=[],n=T.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(y){d.type==="property"&&(d.length=y-d.offset,d=d.parent)}function m(y){return d.children.push(y),y}i(t,{onObjectBegin:y=>{d=m({type:"object",offset:y,length:-1,parent:d,children:[]})},onObjectProperty:(y,k,A)=>{d=m({type:"property",offset:k,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:y,offset:k,length:A,parent:d})},onObjectEnd:(y,k)=>{d.length=y+k-d.offset,d=d.parent,l(y+k)},onArrayBegin:(y,k)=>{d=m({type:"array",offset:y,length:-1,parent:d,children:[]})},onArrayEnd:(y,k)=>{d.length=y+k-d.offset,d=d.parent,l(y+k)},onLiteralValue:(y,k,A)=>{m({type:o(y),offset:k,length:A,parent:d,value:y}),l(k+A)},onSeparator:(y,k,A)=>{d.type==="property"&&(y===":"?d.colonOffset=k:y===","&&l(k))},onError:(y,k,A)=>{s.push({error:y,offset:k,length:A})}},n);const S=d.children[0];return S&&delete S.parent,S}function w(t,s){if(!t)return;let n=t;for(const d of s)if(typeof d=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let l=!1;for(const m of n.children)if(Array.isArray(m.children)&&m.children[0].value===d){n=m.children[1],l=!0;break}if(!l)return}else{const l=d;if(n.type!=="array"||l<0||!Array.isArray(n.children)||l>=n.children.length)return;n=n.children[l]}return n}function a(t){if(!t.parent||!t.parent.children)return[];const s=a(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;s.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&s.push(n)}return s}function $(t){switch(t.type){case"array":return t.children.map($);case"object":{const s=Object.create(null);for(const n of t.children){const d=n.children[1];d&&(s[n.children[0].value]=$(d))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function f(t,s,n=!1){return s>=t.offset&&s<t.offset+t.length||n&&s===t.offset+t.length}function g(t,s,n=!1){if(f(t,s,n)){const d=t.children;if(Array.isArray(d))for(let l=0;l<d.length&&d[l].offset<=s;l++){const m=g(d[l],s,n);if(m)return m}return t}}function i(t,s,n=T.DEFAULT){const d=L(t,!1);function l(ee){return ee?()=>ee(d.getTokenOffset(),d.getTokenLength()):()=>!0}function m(ee){return ee?ue=>ee(ue,d.getTokenOffset(),d.getTokenLength()):()=>!0}const E=l(s.onObjectBegin),S=m(s.onObjectProperty),y=l(s.onObjectEnd),k=l(s.onArrayBegin),A=l(s.onArrayEnd),p=m(s.onLiteralValue),v=m(s.onSeparator),F=l(s.onComment),N=m(s.onError),O=n&&n.disallowComments,j=n&&n.allowTrailingComma;function z(){for(;;){const ee=d.scan();switch(d.getTokenError()){case r.InvalidUnicode:M(C.InvalidUnicode);break;case r.InvalidEscapeCharacter:M(C.InvalidEscapeCharacter);break;case r.UnexpectedEndOfNumber:M(C.UnexpectedEndOfNumber);break;case r.UnexpectedEndOfComment:O||M(C.UnexpectedEndOfComment);break;case r.UnexpectedEndOfString:M(C.UnexpectedEndOfString);break;case r.InvalidCharacter:M(C.InvalidCharacter);break}switch(ee){case h.LineCommentTrivia:case h.BlockCommentTrivia:O?M(C.InvalidCommentToken):F();break;case h.Unknown:M(C.InvalidSymbol);break;case h.Trivia:case h.LineBreakTrivia:break;default:return ee}}}function M(ee,ue=[],re=[]){if(N(ee),ue.length+re.length>0){let ye=d.getToken();for(;ye!==h.EOF;){if(ue.indexOf(ye)!==-1){z();break}else if(re.indexOf(ye)!==-1)break;ye=z()}}}function V(ee){const ue=d.getTokenValue();return ee?p(ue):S(ue),z(),!0}function K(){switch(d.getToken()){case h.NumericLiteral:{let ee=0;try{ee=JSON.parse(d.getTokenValue()),typeof ee!="number"&&(M(C.InvalidNumberFormat),ee=0)}catch{M(C.InvalidNumberFormat)}p(ee);break}case h.NullKeyword:p(null);break;case h.TrueKeyword:p(!0);break;case h.FalseKeyword:p(!1);break;default:return!1}return z(),!0}function ne(){return d.getToken()!==h.StringLiteral?(M(C.PropertyNameExpected,[],[h.CloseBraceToken,h.CommaToken]),!1):(V(!1),d.getToken()===h.ColonToken?(v(":"),z(),Y()||M(C.ValueExpected,[],[h.CloseBraceToken,h.CommaToken])):M(C.ColonExpected,[],[h.CloseBraceToken,h.CommaToken]),!0)}function B(){E(),z();let ee=!1;for(;d.getToken()!==h.CloseBraceToken&&d.getToken()!==h.EOF;){if(d.getToken()===h.CommaToken){if(ee||M(C.ValueExpected,[],[]),v(","),z(),d.getToken()===h.CloseBraceToken&&j)break}else ee&&M(C.CommaExpected,[],[]);ne()||M(C.ValueExpected,[],[h.CloseBraceToken,h.CommaToken]),ee=!0}return y(),d.getToken()!==h.CloseBraceToken?M(C.CloseBraceExpected,[h.CloseBraceToken],[]):z(),!0}function G(){k(),z();let ee=!1;for(;d.getToken()!==h.CloseBracketToken&&d.getToken()!==h.EOF;){if(d.getToken()===h.CommaToken){if(ee||M(C.ValueExpected,[],[]),v(","),z(),d.getToken()===h.CloseBracketToken&&j)break}else ee&&M(C.CommaExpected,[],[]);Y()||M(C.ValueExpected,[],[h.CloseBracketToken,h.CommaToken]),ee=!0}return A(),d.getToken()!==h.CloseBracketToken?M(C.CloseBracketExpected,[h.CloseBracketToken],[]):z(),!0}function Y(){switch(d.getToken()){case h.OpenBracketToken:return G();case h.OpenBraceToken:return B();case h.StringLiteral:return V(!0);default:return K()}}return z(),d.getToken()===h.EOF?n.allowEmptyContent?!0:(M(C.ValueExpected,[],[]),!1):Y()?(d.getToken()!==h.EOF&&M(C.EndOfFileExpected,[],[]),!0):(M(C.ValueExpected,[],[]),!1)}function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ke[49],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class r{constructor(C){this.d=C,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(C){this.c=C}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=r}),define(ke[80],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class r{static{this.Undefined=new r(void 0)}constructor(T){this.element=T,this.next=r.Undefined,this.prev=r.Undefined}}class h{constructor(){this.a=r.Undefined,this.b=r.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===r.Undefined}clear(){let T=this.a;for(;T!==r.Undefined;){const L=T.next;T.prev=r.Undefined,T.next=r.Undefined,T=L}this.a=r.Undefined,this.b=r.Undefined,this.c=0}unshift(T){return this.d(T,!1)}push(T){return this.d(T,!0)}d(T,L){const R=new r(T);if(this.a===r.Undefined)this.a=R,this.b=R;else if(L){const c=this.b;this.b=R,R.prev=c,c.next=R}else{const c=this.a;this.a=R,R.next=c,c.prev=R}this.c+=1;let b=!1;return()=>{b||(b=!0,this.e(R))}}shift(){if(this.a!==r.Undefined){const T=this.a.element;return this.e(this.a),T}}pop(){if(this.b!==r.Undefined){const T=this.b.element;return this.e(this.b),T}}e(T){if(T.prev!==r.Undefined&&T.next!==r.Undefined){const L=T.prev;L.next=T.next,T.next.prev=L}else T.prev===r.Undefined&&T.next===r.Undefined?(this.a=r.Undefined,this.b=r.Undefined):T.next===r.Undefined?(this.b=this.b.prev,this.b.next=r.Undefined):T.prev===r.Undefined&&(this.a=this.a.next,this.a.prev=r.Undefined);this.c-=1}*[Symbol.iterator](){let T=this.a;for(;T!==r.Undefined;)yield T.element,T=T.next}}e.$4c=h}),define(ke[28],Ie([1,0]),function(me,e){"use strict";var r,h,C;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=void 0,e.$wc=T,e.$xc=L,e.$yc=R,e.$Hc=o;function T(t,s,n){let d=t.get(s);return d===void 0&&(d=n,t.set(s,d)),d}function L(t){const s=[];return t.forEach((n,d)=>{s.push(`${d} => ${n}`)}),`Map(${t.size}) {${s.join(", ")}}`}function R(t){const s=[];return t.forEach(n=>{s.push(n)}),`Set(${t.size}) {${s.join(", ")}}`}class b{constructor(s,n){this.uri=s,this.value=n}}function c(t){return Array.isArray(t)}class I{static{this.c=s=>s.toString()}constructor(s,n){if(this[r]="ResourceMap",s instanceof I)this.d=new Map(s.d),this.e=n??I.c;else if(c(s)){this.d=new Map,this.e=n??I.c;for(const[d,l]of s)this.set(d,l)}else this.d=new Map,this.e=s??I.c}set(s,n){return this.d.set(this.e(s),new b(s,n)),this}get(s){return this.d.get(this.e(s))?.value}has(s){return this.d.has(this.e(s))}get size(){return this.d.size}clear(){this.d.clear()}delete(s){return this.d.delete(this.e(s))}forEach(s,n){typeof n<"u"&&(s=s.bind(n));for(const[d,l]of this.d)s(l.value,l.uri,this)}*values(){for(const s of this.d.values())yield s.value}*keys(){for(const s of this.d.values())yield s.uri}*entries(){for(const s of this.d.values())yield[s.uri,s.value]}*[(r=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.d)yield[s.uri,s.value]}}e.$zc=I;class D{constructor(s,n){this[h]="ResourceSet",!s||typeof s=="function"?this.c=new I(s):(this.c=new I(n),s.forEach(this.add,this))}get size(){return this.c.size}add(s){return this.c.set(s,s),this}clear(){this.c.clear()}delete(s){return this.c.delete(s)}forEach(s,n){this.c.forEach((d,l)=>s.call(n,l,l,this))}has(s){return this.c.has(s)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(h=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=D;var u;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(u||(e.Touch=u={}));class P{constructor(){this[C]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(s){return this.c.has(s)}get(s,n=u.None){const d=this.c.get(s);if(d)return n!==u.None&&this.m(d,n),d.value}set(s,n,d=u.None){let l=this.c.get(s);if(l)l.value=n,d!==u.None&&this.m(l,d);else{switch(l={key:s,value:n,next:void 0,previous:void 0},d){case u.None:this.k(l);break;case u.AsOld:this.j(l);break;case u.AsNew:this.k(l);break;default:this.k(l);break}this.c.set(s,l),this.f++}return this}delete(s){return!!this.remove(s)}remove(s){const n=this.c.get(s);if(n)return this.c.delete(s),this.l(n),this.f--,n.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const s=this.d;return this.c.delete(s.key),this.l(s),this.f--,s.value}forEach(s,n){const d=this.g;let l=this.d;for(;l;){if(n?s.bind(n)(l.value,l.key,this):s(l.value,l.key,this),this.g!==d)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const s=this,n=this.g;let d=this.d;const l={[Symbol.iterator](){return l},next(){if(s.g!==n)throw new Error("LinkedMap got modified during iteration.");if(d){const m={value:d.key,done:!1};return d=d.next,m}else return{value:void 0,done:!0}}};return l}values(){const s=this,n=this.g;let d=this.d;const l={[Symbol.iterator](){return l},next(){if(s.g!==n)throw new Error("LinkedMap got modified during iteration.");if(d){const m={value:d.value,done:!1};return d=d.next,m}else return{value:void 0,done:!0}}};return l}entries(){const s=this,n=this.g;let d=this.d;const l={[Symbol.iterator](){return l},next(){if(s.g!==n)throw new Error("LinkedMap got modified during iteration.");if(d){const m={value:[d.key,d.value],done:!1};return d=d.next,m}else return{value:void 0,done:!0}}};return l}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(s){if(s>=this.size)return;if(s===0){this.clear();return}let n=this.d,d=this.size;for(;n&&d>s;)this.c.delete(n.key),n=n.next,d--;this.d=n,this.f=d,n&&(n.previous=void 0),this.g++}i(s){if(s>=this.size)return;if(s===0){this.clear();return}let n=this.e,d=this.size;for(;n&&d>s;)this.c.delete(n.key),n=n.previous,d--;this.e=n,this.f=d,n&&(n.next=void 0),this.g++}j(s){if(!this.d&&!this.e)this.e=s;else if(this.d)s.next=this.d,this.d.previous=s;else throw new Error("Invalid list");this.d=s,this.g++}k(s){if(!this.d&&!this.e)this.d=s;else if(this.e)s.previous=this.e,this.e.next=s;else throw new Error("Invalid list");this.e=s,this.g++}l(s){if(s===this.d&&s===this.e)this.d=void 0,this.e=void 0;else if(s===this.d){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this.d=s.next}else if(s===this.e){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this.e=s.previous}else{const n=s.next,d=s.previous;if(!n||!d)throw new Error("Invalid list");n.previous=d,d.next=n}s.next=void 0,s.previous=void 0,this.g++}m(s,n){if(!this.d||!this.e)throw new Error("Invalid list");if(!(n!==u.AsOld&&n!==u.AsNew)){if(n===u.AsOld){if(s===this.d)return;const d=s.next,l=s.previous;s===this.e?(l.next=void 0,this.e=l):(d.previous=l,l.next=d),s.previous=void 0,s.next=this.d,this.d.previous=s,this.d=s,this.g++}else if(n===u.AsNew){if(s===this.e)return;const d=s.next,l=s.previous;s===this.d?(d.previous=void 0,this.d=d):(d.previous=l,l.next=d),s.next=void 0,s.previous=this.e,this.e.next=s,this.e=s,this.g++}}}toJSON(){const s=[];return this.forEach((n,d)=>{s.push([d,n])}),s}fromJSON(s){this.clear();for(const[n,d]of s)this.set(n,d)}}e.$Bc=P;class w extends P{constructor(s,n=1){super(),this.n=s,this.o=Math.min(Math.max(0,n),1)}get limit(){return this.n}set limit(s){this.n=s,this.p()}get ratio(){return this.o}set ratio(s){this.o=Math.min(Math.max(0,s),1),this.p()}get(s,n=u.AsNew){return super.get(s,n)}peek(s){return super.get(s,u.None)}set(s,n){return super.set(s,n,u.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class a extends w{constructor(s,n=1){super(s,n)}q(s){this.h(s)}set(s,n){return super.set(s,n),this.p(),this}}e.$Cc=a;class $ extends w{constructor(s,n=1){super(s,n)}q(s){this.i(s)}set(s,n){return this.n<=this.size&&!this.has(s)&&this.q(Math.round(this.n*this.o)-1),super.set(s,n),this}}e.$Dc=$;class f{constructor(){this.c=new Map}add(s){return this.c.set(s,(this.c.get(s)||0)+1),this}delete(s){let n=this.c.get(s)||0;return n===0?!1:(n--,n===0?this.c.delete(s):this.c.set(s,n),!0)}has(s){return this.c.has(s)}}e.$Ec=f;class g{constructor(s){if(this.c=new Map,this.d=new Map,s)for(const[n,d]of s)this.set(n,d)}clear(){this.c.clear(),this.d.clear()}set(s,n){this.c.set(s,n),this.d.set(n,s)}get(s){return this.c.get(s)}getKey(s){return this.d.get(s)}delete(s){const n=this.c.get(s);return n===void 0?!1:(this.c.delete(s),this.d.delete(n),!0)}forEach(s,n){this.c.forEach((d,l)=>{s.call(n,d,l,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=g;class i{constructor(){this.c=new Map}add(s,n){let d=this.c.get(s);d||(d=new Set,this.c.set(s,d)),d.add(n)}delete(s,n){const d=this.c.get(s);d&&(d.delete(n),d.size===0&&this.c.delete(s))}forEach(s,n){const d=this.c.get(s);d&&d.forEach(n)}get(s){const n=this.c.get(s);return n||new Set}}e.$Gc=i;function o(t,s){if(t===s)return!0;if(t.size!==s.size)return!1;for(const[n,d]of t)if(!s.has(n)||s.get(n)!==d)return!1;for(const[n]of s)if(!t.has(n))return!1;return!0}}),define(ke[3],Ie([1,0,18,78,28,79,39]),function(me,e,r,h,C,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Ic=void 0,e.$Jc=I,e.$Kc=D,e.$Lc=u,e.$Mc=a,e.$Nc=$,e.$Oc=f,e.$Pc=g,e.$Qc=i,e.$Rc=o,e.$2c=k;const R=!1;let b=null;class c{constructor(){this.b=new Map}static{this.a=0}c(v){let F=this.b.get(v);return F||(F={parent:null,source:null,isSingleton:!1,value:v,idx:c.a++},this.b.set(v,F)),F}trackDisposable(v){const F=this.c(v);F.source||(F.source=new Error().stack)}setParent(v,F){const N=this.c(v);N.parent=F}markAsDisposed(v){this.b.delete(v)}markAsSingleton(v){this.c(v).isSingleton=!0}f(v,F){const N=F.get(v);if(N)return N;const O=v.parent?this.f(this.c(v.parent),F):v;return F.set(v,O),O}getTrackedDisposables(){const v=new Map;return[...this.b.entries()].filter(([,N])=>N.source!==null&&!this.f(N,v).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(v=10,F){let N;if(F)N=F;else{const V=new Map,K=[...this.b.values()].filter(B=>B.source!==null&&!this.f(B,V).isSingleton);if(K.length===0)return;const ne=new Set(K.map(B=>B.value));if(N=K.filter(B=>!(B.parent&&ne.has(B.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function O(V){function K(B,G){for(;B.length>0&&G.some(Y=>typeof Y=="string"?Y===B[0]:B[0].match(Y));)B.shift()}const ne=V.source.split(`
`).map(B=>B.trim().replace("at ","")).filter(B=>B!=="");return K(ne,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ne.reverse()}const j=new C.$Gc;for(const V of N){const K=O(V);for(let ne=0;ne<=K.length;ne++)j.add(K.slice(0,ne).join(`
`),V)}N.sort((0,r.$5b)(V=>V.idx,r.$7b));let z="",M=0;for(const V of N.slice(0,v)){M++;const K=O(V),ne=[];for(let B=0;B<K.length;B++){let G=K[B];G=`(shared with ${j.get(K.slice(0,B+1).join(`
`)).size}/${N.length} leaks) at ${G}`;const ee=j.get(K.slice(0,B).join(`
`)),ue=(0,h.$c)([...ee].map(re=>O(re)[B]),re=>re);delete ue[K[B]];for(const[re,ye]of Object.entries(ue))ne.unshift(`    - stacktraces of ${ye.length} other leaks continue with ${re}`);ne.unshift(G)}z+=`


==================== Leaking disposable ${M}/${N.length}: ${V.value.constructor.name} ====================
${ne.join(`
`)}
============================================================

`}return N.length>v&&(z+=`


... and ${N.length-v} more leaking disposables

`),{leaks:N,details:z}}}e.$Ic=c;function I(p){b=p}if(R){const p="__is_disposable_tracked__";I(new class{trackDisposable(v){const F=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[p]||console.log(F)},3e3)}setParent(v,F){if(v&&v!==s.None)try{v[p]=!0}catch{}}markAsDisposed(v){if(v&&v!==s.None)try{v[p]=!0}catch{}}markAsSingleton(v){}})}function D(p){return b?.trackDisposable(p),p}function u(p){b?.markAsDisposed(p)}function P(p,v){b?.setParent(p,v)}function w(p,v){if(b)for(const F of p)b.setParent(F,v)}function a(p){return b?.markAsSingleton(p),p}function $(p){return typeof p=="object"&&p!==null&&typeof p.dispose=="function"&&p.dispose.length===0}function f(p){if(L.Iterable.is(p)){const v=[];for(const F of p)if(F)try{F.dispose()}catch(N){v.push(N)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(p)?[]:p}else if(p)return p.dispose(),p}function g(p){for(const v of p)$(v)&&v.dispose();return[]}function i(...p){const v=o(()=>f(p));return w(p,v),v}function o(p){const v=D({dispose:(0,T.$cb)(()=>{u(v),p()})});return v}class t{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,D(this)}dispose(){this.g||(u(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{f(this.f)}finally{this.f.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return P(v,this),this.g?t.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(v),v}delete(v){if(v){if(v===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(v),v.dispose()}}deleteAndLeak(v){v&&this.f.has(v)&&(this.f.delete(v),P(v,null))}}e.$Sc=t;class s{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new t,D(this),P(this.q,this)}dispose(){u(this),this.q.dispose()}B(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(v)}}e.$Tc=s;class n{constructor(){this.b=!1,D(this)}get value(){return this.b?void 0:this.a}set value(v){this.b||v===this.a||(this.a?.dispose(),v&&P(v,this),this.a=v)}clear(){this.value=void 0}dispose(){this.b=!0,u(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const v=this.a;return this.a=void 0,v&&P(v,null),v}}e.$Uc=n;class d{constructor(v){this.a=new n,this.b=!1,this.a.value=v}get value(){return this.a.value}set value(v){this.b||v===this.a.value||(this.a.value=v)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=d;class l{constructor(v){this.b=v,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=l;class m{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,D(this)}set(v){let F=v;return this.unset=()=>F=void 0,this.isset=()=>F!==void 0,this.dispose=()=>{F&&(F(),F=void 0,u(this))},this}}e.$Xc=m;class E{constructor(){this.a=new Map}acquire(v,...F){let N=this.a.get(v);N||(N={counter:0,object:this.b(v,...F)},this.a.set(v,N));const{object:O}=N,j=(0,T.$cb)(()=>{--N.counter===0&&(this.c(v,N.object),this.a.delete(v))});return N.counter++,{object:O,dispose:j}}}e.$Yc=E;class S{constructor(v){this.a=v}async acquire(v,...F){const N=this.a.acquire(v,...F);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(O){throw N.dispose(),O}}}e.$Zc=S;class y{constructor(v){this.object=v}dispose(){}}e.$1c=y;function k(p){const v=new t;try{p(v)}finally{v.dispose()}}class A{constructor(){this.a=new Map,this.b=!1,D(this)}dispose(){u(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(v){return this.a.has(v)}get size(){return this.a.size}get(v){return this.a.get(v)}set(v,F,N=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this.a.get(v)?.dispose(),this.a.set(v,F)}deleteAndDispose(v){this.a.get(v)?.dispose(),this.a.delete(v)}deleteAndLeak(v){const F=this.a.get(v);return this.a.delete(v),F}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=A}),function(me,e){typeof define=="function"&&define.amd?define(ke[177],Ie([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(te,ce){for(var le=0;le<ce.length;le++){var Z=ce[le];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(te,Z.key,Z)}}function r(te,ce,le){return ce&&e(te.prototype,ce),le&&e(te,le),Object.defineProperty(te,"prototype",{writable:!1}),te}function h(te,ce){if(te){if(typeof te=="string")return C(te,ce);var le=Object.prototype.toString.call(te).slice(8,-1);if(le==="Object"&&te.constructor&&(le=te.constructor.name),le==="Map"||le==="Set")return Array.from(te);if(le==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(le))return C(te,ce)}}function C(te,ce){(ce==null||ce>te.length)&&(ce=te.length);for(var le=0,Z=new Array(ce);le<ce;le++)Z[le]=te[le];return Z}function T(te,ce){var le=typeof Symbol<"u"&&te[Symbol.iterator]||te["@@iterator"];if(le)return(le=le.call(te)).next.bind(le);if(Array.isArray(te)||(le=h(te))||ce&&te&&typeof te.length=="number"){le&&(te=le);var Z=0;return function(){return Z>=te.length?{done:!0}:{done:!1,value:te[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function L(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=L();function R(te){me.defaults=te}var b=/[&<>"']/,c=/[&<>"']/g,I=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},P=function(ce){return u[ce]};function w(te,ce){if(ce){if(b.test(te))return te.replace(c,P)}else if(I.test(te))return te.replace(D,P);return te}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function $(te){return te.replace(a,function(ce,le){return le=le.toLowerCase(),le==="colon"?":":le.charAt(0)==="#"?le.charAt(1)==="x"?String.fromCharCode(parseInt(le.substring(2),16)):String.fromCharCode(+le.substring(1)):""})}var f=/(^|[^\[])\^/g;function g(te,ce){te=typeof te=="string"?te:te.source,ce=ce||"";var le={replace:function(oe,pe){return pe=pe.source||pe,pe=pe.replace(f,"$1"),te=te.replace(oe,pe),le},getRegex:function(){return new RegExp(te,ce)}};return le}var i=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function t(te,ce,le){if(te){var Z;try{Z=decodeURIComponent($(le)).replace(i,"").toLowerCase()}catch{return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}ce&&!o.test(le)&&(le=m(ce,le));try{le=encodeURI(le).replace(/%25/g,"%")}catch{return null}return le}var s={},n=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function m(te,ce){s[" "+te]||(n.test(te)?s[" "+te]=te+"/":s[" "+te]=k(te,"/",!0)),te=s[" "+te];var le=te.indexOf(":")===-1;return ce.substring(0,2)==="//"?le?ce:te.replace(d,"$1")+ce:ce.charAt(0)==="/"?le?ce:te.replace(l,"$1")+ce:te+ce}var E={exec:function(){}};function S(te){for(var ce=1,le,Z;ce<arguments.length;ce++){le=arguments[ce];for(Z in le)Object.prototype.hasOwnProperty.call(le,Z)&&(te[Z]=le[Z])}return te}function y(te,ce){var le=te.replace(/\|/g,function(pe,we,Fe){for(var We=!1,Se=we;--Se>=0&&Fe[Se]==="\\";)We=!We;return We?"|":" |"}),Z=le.split(/ \|/),oe=0;if(Z[0].trim()||Z.shift(),Z.length>0&&!Z[Z.length-1].trim()&&Z.pop(),Z.length>ce)Z.splice(ce);else for(;Z.length<ce;)Z.push("");for(;oe<Z.length;oe++)Z[oe]=Z[oe].trim().replace(/\\\|/g,"|");return Z}function k(te,ce,le){var Z=te.length;if(Z===0)return"";for(var oe=0;oe<Z;){var pe=te.charAt(Z-oe-1);if(pe===ce&&!le)oe++;else if(pe!==ce&&le)oe++;else break}return te.slice(0,Z-oe)}function A(te,ce){if(te.indexOf(ce[1])===-1)return-1;for(var le=te.length,Z=0,oe=0;oe<le;oe++)if(te[oe]==="\\")oe++;else if(te[oe]===ce[0])Z++;else if(te[oe]===ce[1]&&(Z--,Z<0))return oe;return-1}function p(te){te&&te.sanitize&&!te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function v(te,ce){if(ce<1)return"";for(var le="";ce>1;)ce&1&&(le+=te),ce>>=1,te+=te;return le+te}function F(te,ce,le,Z){var oe=ce.href,pe=ce.title?w(ce.title):null,we=te[1].replace(/\\([\[\]])/g,"$1");if(te[0].charAt(0)!=="!"){Z.state.inLink=!0;var Fe={type:"link",raw:le,href:oe,title:pe,text:we,tokens:Z.inlineTokens(we)};return Z.state.inLink=!1,Fe}return{type:"image",raw:le,href:oe,title:pe,text:w(we)}}function N(te,ce){var le=te.match(/^(\s+)(?:```)/);if(le===null)return ce;var Z=le[1];return ce.split(`
`).map(function(oe){var pe=oe.match(/^\s+/);if(pe===null)return oe;var we=pe[0];return we.length>=Z.length?oe.slice(Z.length):oe}).join(`
`)}var O=function(){function te(le){this.options=le||me.defaults}var ce=te.prototype;return ce.space=function(Z){var oe=this.rules.block.newline.exec(Z);if(oe&&oe[0].length>0)return{type:"space",raw:oe[0]}},ce.code=function(Z){var oe=this.rules.block.code.exec(Z);if(oe){var pe=oe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:oe[0],codeBlockStyle:"indented",text:this.options.pedantic?pe:k(pe,`
`)}}},ce.fences=function(Z){var oe=this.rules.block.fences.exec(Z);if(oe){var pe=oe[0],we=N(pe,oe[3]||"");return{type:"code",raw:pe,lang:oe[2]?oe[2].trim():oe[2],text:we}}},ce.heading=function(Z){var oe=this.rules.block.heading.exec(Z);if(oe){var pe=oe[2].trim();if(/#$/.test(pe)){var we=k(pe,"#");(this.options.pedantic||!we||/ $/.test(we))&&(pe=we.trim())}return{type:"heading",raw:oe[0],depth:oe[1].length,text:pe,tokens:this.lexer.inline(pe)}}},ce.hr=function(Z){var oe=this.rules.block.hr.exec(Z);if(oe)return{type:"hr",raw:oe[0]}},ce.blockquote=function(Z){var oe=this.rules.block.blockquote.exec(Z);if(oe){var pe=oe[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:oe[0],tokens:this.lexer.blockTokens(pe,[]),text:pe}}},ce.list=function(Z){var oe=this.rules.block.list.exec(Z);if(oe){var pe,we,Fe,We,Se,De,Te,U,q,X,_,de,be=oe[1].trim(),Ne=be.length>1,Ge={type:"list",raw:"",ordered:Ne,start:Ne?+be.slice(0,-1):"",loose:!1,items:[]};be=Ne?"\\d{1,9}\\"+be.slice(-1):"\\"+be,this.options.pedantic&&(be=Ne?be:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+be+")((?:[	 ][^\\n]*)?(?:\\n|$))");Z&&(de=!1,!(!(oe=Ke.exec(Z))||this.rules.block.hr.test(Z)));){if(pe=oe[0],Z=Z.substring(pe.length),U=oe[2].split(`
`,1)[0],q=Z.split(`
`,1)[0],this.options.pedantic?(We=2,_=U.trimLeft()):(We=oe[2].search(/[^ ]/),We=We>4?1:We,_=U.slice(We),We+=oe[1].length),De=!1,!U&&/^ *$/.test(q)&&(pe+=q+`
`,Z=Z.substring(q.length+1),de=!0),!de)for(var tt=new RegExp("^ {0,"+Math.min(3,We-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),rt=new RegExp("^ {0,"+Math.min(3,We-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),ot=new RegExp("^ {0,"+Math.min(3,We-1)+"}(?:```|~~~)"),nt=new RegExp("^ {0,"+Math.min(3,We-1)+"}#");Z&&(X=Z.split(`
`,1)[0],U=X,this.options.pedantic&&(U=U.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(ot.test(U)||nt.test(U)||tt.test(U)||rt.test(Z)));){if(U.search(/[^ ]/)>=We||!U.trim())_+=`
`+U.slice(We);else if(!De)_+=`
`+U;else break;!De&&!U.trim()&&(De=!0),pe+=X+`
`,Z=Z.substring(X.length+1)}Ge.loose||(Te?Ge.loose=!0:/\n *\n *$/.test(pe)&&(Te=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(_),we&&(Fe=we[0]!=="[ ] ",_=_.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:pe,task:!!we,checked:Fe,loose:!1,text:_}),Ge.raw+=pe}Ge.items[Ge.items.length-1].raw=pe.trimRight(),Ge.items[Ge.items.length-1].text=_.trimRight(),Ge.raw=Ge.raw.trimRight();var at=Ge.items.length;for(Se=0;Se<at;Se++){this.lexer.state.top=!1,Ge.items[Se].tokens=this.lexer.blockTokens(Ge.items[Se].text,[]);var mt=Ge.items[Se].tokens.filter(function(ct){return ct.type==="space"}),ht=mt.every(function(ct){for(var Pe=ct.raw.split(""),ze=0,He=T(Pe),Oe;!(Oe=He()).done;){var je=Oe.value;if(je===`
`&&(ze+=1),ze>1)return!0}return!1});!Ge.loose&&mt.length&&ht&&(Ge.loose=!0,Ge.items[Se].loose=!0)}return Ge}},ce.html=function(Z){var oe=this.rules.block.html.exec(Z);if(oe){var pe={type:"html",raw:oe[0],pre:!this.options.sanitizer&&(oe[1]==="pre"||oe[1]==="script"||oe[1]==="style"),text:oe[0]};if(this.options.sanitize){var we=this.options.sanitizer?this.options.sanitizer(oe[0]):w(oe[0]);pe.type="paragraph",pe.text=we,pe.tokens=this.lexer.inline(we)}return pe}},ce.def=function(Z){var oe=this.rules.block.def.exec(Z);if(oe){oe[3]&&(oe[3]=oe[3].substring(1,oe[3].length-1));var pe=oe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:pe,raw:oe[0],href:oe[2],title:oe[3]}}},ce.table=function(Z){var oe=this.rules.block.table.exec(Z);if(oe){var pe={type:"table",header:y(oe[1]).map(function(Te){return{text:Te}}),align:oe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:oe[3]&&oe[3].trim()?oe[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(pe.header.length===pe.align.length){pe.raw=oe[0];var we=pe.align.length,Fe,We,Se,De;for(Fe=0;Fe<we;Fe++)/^ *-+: *$/.test(pe.align[Fe])?pe.align[Fe]="right":/^ *:-+: *$/.test(pe.align[Fe])?pe.align[Fe]="center":/^ *:-+ *$/.test(pe.align[Fe])?pe.align[Fe]="left":pe.align[Fe]=null;for(we=pe.rows.length,Fe=0;Fe<we;Fe++)pe.rows[Fe]=y(pe.rows[Fe],pe.header.length).map(function(Te){return{text:Te}});for(we=pe.header.length,We=0;We<we;We++)pe.header[We].tokens=this.lexer.inline(pe.header[We].text);for(we=pe.rows.length,We=0;We<we;We++)for(De=pe.rows[We],Se=0;Se<De.length;Se++)De[Se].tokens=this.lexer.inline(De[Se].text);return pe}}},ce.lheading=function(Z){var oe=this.rules.block.lheading.exec(Z);if(oe)return{type:"heading",raw:oe[0],depth:oe[2].charAt(0)==="="?1:2,text:oe[1],tokens:this.lexer.inline(oe[1])}},ce.paragraph=function(Z){var oe=this.rules.block.paragraph.exec(Z);if(oe){var pe=oe[1].charAt(oe[1].length-1)===`
`?oe[1].slice(0,-1):oe[1];return{type:"paragraph",raw:oe[0],text:pe,tokens:this.lexer.inline(pe)}}},ce.text=function(Z){var oe=this.rules.block.text.exec(Z);if(oe)return{type:"text",raw:oe[0],text:oe[0],tokens:this.lexer.inline(oe[0])}},ce.escape=function(Z){var oe=this.rules.inline.escape.exec(Z);if(oe)return{type:"escape",raw:oe[0],text:w(oe[1])}},ce.tag=function(Z){var oe=this.rules.inline.tag.exec(Z);if(oe)return!this.lexer.state.inLink&&/^<a /i.test(oe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(oe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(oe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(oe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:oe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):w(oe[0]):oe[0]}},ce.link=function(Z){var oe=this.rules.inline.link.exec(Z);if(oe){var pe=oe[2].trim();if(!this.options.pedantic&&/^</.test(pe)){if(!/>$/.test(pe))return;var we=k(pe.slice(0,-1),"\\");if((pe.length-we.length)%2===0)return}else{var Fe=A(oe[2],"()");if(Fe>-1){var We=oe[0].indexOf("!")===0?5:4,Se=We+oe[1].length+Fe;oe[2]=oe[2].substring(0,Fe),oe[0]=oe[0].substring(0,Se).trim(),oe[3]=""}}var De=oe[2],Te="";if(this.options.pedantic){var U=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(De);U&&(De=U[1],Te=U[3])}else Te=oe[3]?oe[3].slice(1,-1):"";return De=De.trim(),/^</.test(De)&&(this.options.pedantic&&!/>$/.test(pe)?De=De.slice(1):De=De.slice(1,-1)),F(oe,{href:De&&De.replace(this.rules.inline._escapes,"$1"),title:Te&&Te.replace(this.rules.inline._escapes,"$1")},oe[0],this.lexer)}},ce.reflink=function(Z,oe){var pe;if((pe=this.rules.inline.reflink.exec(Z))||(pe=this.rules.inline.nolink.exec(Z))){var we=(pe[2]||pe[1]).replace(/\s+/g," ");if(we=oe[we.toLowerCase()],!we||!we.href){var Fe=pe[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return F(pe,we,pe[0],this.lexer)}},ce.emStrong=function(Z,oe,pe){pe===void 0&&(pe="");var we=this.rules.inline.emStrong.lDelim.exec(Z);if(we&&!(we[3]&&pe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=we[1]||we[2]||"";if(!Fe||Fe&&(pe===""||this.rules.inline.punctuation.exec(pe))){var We=we[0].length-1,Se,De,Te=We,U=0,q=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(q.lastIndex=0,oe=oe.slice(-1*Z.length+We);(we=q.exec(oe))!=null;)if(Se=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!Se){if(De=Se.length,we[3]||we[4]){Te+=De;continue}else if((we[5]||we[6])&&We%3&&!((We+De)%3)){U+=De;continue}if(Te-=De,!(Te>0)){if(De=Math.min(De,De+Te+U),Math.min(We,De)%2){var X=Z.slice(1,We+we.index+De);return{type:"em",raw:Z.slice(0,We+we.index+De+1),text:X,tokens:this.lexer.inlineTokens(X)}}var _=Z.slice(2,We+we.index+De-1);return{type:"strong",raw:Z.slice(0,We+we.index+De+1),text:_,tokens:this.lexer.inlineTokens(_)}}}}}},ce.codespan=function(Z){var oe=this.rules.inline.code.exec(Z);if(oe){var pe=oe[2].replace(/\n/g," "),we=/[^ ]/.test(pe),Fe=/^ /.test(pe)&&/ $/.test(pe);return we&&Fe&&(pe=pe.substring(1,pe.length-1)),pe=w(pe,!0),{type:"codespan",raw:oe[0],text:pe}}},ce.br=function(Z){var oe=this.rules.inline.br.exec(Z);if(oe)return{type:"br",raw:oe[0]}},ce.del=function(Z){var oe=this.rules.inline.del.exec(Z);if(oe)return{type:"del",raw:oe[0],text:oe[2],tokens:this.lexer.inlineTokens(oe[2])}},ce.autolink=function(Z,oe){var pe=this.rules.inline.autolink.exec(Z);if(pe){var we,Fe;return pe[2]==="@"?(we=w(this.options.mangle?oe(pe[1]):pe[1]),Fe="mailto:"+we):(we=w(pe[1]),Fe=we),{type:"link",raw:pe[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},ce.url=function(Z,oe){var pe;if(pe=this.rules.inline.url.exec(Z)){var we,Fe;if(pe[2]==="@")we=w(this.options.mangle?oe(pe[0]):pe[0]),Fe="mailto:"+we;else{var We;do We=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])[0];while(We!==pe[0]);we=w(pe[0]),pe[1]==="www."?Fe="http://"+we:Fe=we}return{type:"link",raw:pe[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},ce.inlineText=function(Z,oe){var pe=this.rules.inline.text.exec(Z);if(pe){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):w(pe[0]):pe[0]:we=w(this.options.smartypants?oe(pe[0]):pe[0]),{type:"text",raw:pe[0],text:we}}},te}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:E,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=g(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=g(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=g(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=g(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=g(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=g(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=S({},j),j.gfm=S({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=g(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=g(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=S({},j.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:E,paragraph:g(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var z={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:E,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:E,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};z._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",z.punctuation=g(z.punctuation).replace(/punctuation/g,z._punctuation).getRegex(),z.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,z.escapedEmSt=/\\\*|\\_/g,z._comment=g(j._comment).replace("(?:-->|$)","-->").getRegex(),z.emStrong.lDelim=g(z.emStrong.lDelim).replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimAst=g(z.emStrong.rDelimAst,"g").replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimUnd=g(z.emStrong.rDelimUnd,"g").replace(/punct/g,z._punctuation).getRegex(),z._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,z._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,z._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,z.autolink=g(z.autolink).replace("scheme",z._scheme).replace("email",z._email).getRegex(),z._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,z.tag=g(z.tag).replace("comment",z._comment).replace("attribute",z._attribute).getRegex(),z._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,z._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,z._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,z.link=g(z.link).replace("label",z._label).replace("href",z._href).replace("title",z._title).getRegex(),z.reflink=g(z.reflink).replace("label",z._label).replace("ref",j._label).getRegex(),z.nolink=g(z.nolink).replace("ref",j._label).getRegex(),z.reflinkSearch=g(z.reflinkSearch,"g").replace("reflink",z.reflink).replace("nolink",z.nolink).getRegex(),z.normal=S({},z),z.pedantic=S({},z.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",z._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",z._label).getRegex()}),z.gfm=S({},z.normal,{escape:g(z.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),z.gfm.url=g(z.gfm.url,"i").replace("email",z.gfm._extended_email).getRegex(),z.breaks=S({},z.gfm,{br:g(z.br).replace("{2,}","*").getRegex(),text:g(z.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function M(te){return te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function V(te){var ce="",le,Z,oe=te.length;for(le=0;le<oe;le++)Z=te.charCodeAt(le),Math.random()>.5&&(Z="x"+Z.toString(16)),ce+="&#"+Z+";";return ce}var K=function(){function te(le){this.tokens=[],this.tokens.links=Object.create(null),this.options=le||me.defaults,this.options.tokenizer=this.options.tokenizer||new O,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:j.normal,inline:z.normal};this.options.pedantic?(Z.block=j.pedantic,Z.inline=z.pedantic):this.options.gfm&&(Z.block=j.gfm,this.options.breaks?Z.inline=z.breaks:Z.inline=z.gfm),this.tokenizer.rules=Z}te.lex=function(Z,oe){var pe=new te(oe);return pe.lex(Z)},te.lexInline=function(Z,oe){var pe=new te(oe);return pe.inlineTokens(Z)};var ce=te.prototype;return ce.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`),this.blockTokens(Z,this.tokens);for(var oe;oe=this.inlineQueue.shift();)this.inlineTokens(oe.src,oe.tokens);return this.tokens},ce.blockTokens=function(Z,oe){var pe=this;oe===void 0&&(oe=[]),this.options.pedantic?Z=Z.replace(/\t/g,"    ").replace(/^ +$/gm,""):Z=Z.replace(/^( *)(\t+)/gm,function(Te,U,q){return U+"    ".repeat(q.length)});for(var we,Fe,We,Se;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Te){return(we=Te.call({lexer:pe},Z,oe))?(Z=Z.substring(we.raw.length),oe.push(we),!0):!1}))){if(we=this.tokenizer.space(Z)){Z=Z.substring(we.raw.length),we.raw.length===1&&oe.length>0?oe[oe.length-1].raw+=`
`:oe.push(we);continue}if(we=this.tokenizer.code(Z)){Z=Z.substring(we.raw.length),Fe=oe[oe.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):oe.push(we);continue}if(we=this.tokenizer.fences(Z)){Z=Z.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.heading(Z)){Z=Z.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.hr(Z)){Z=Z.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.blockquote(Z)){Z=Z.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.list(Z)){Z=Z.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.html(Z)){Z=Z.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.def(Z)){Z=Z.substring(we.raw.length),Fe=oe[oe.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(Z)){Z=Z.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.lheading(Z)){Z=Z.substring(we.raw.length),oe.push(we);continue}if(We=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var Te=1/0,U=Z.slice(1),q=void 0;pe.options.extensions.startBlock.forEach(function(X){q=X.call({lexer:this},U),typeof q=="number"&&q>=0&&(Te=Math.min(Te,q))}),Te<1/0&&Te>=0&&(We=Z.substring(0,Te+1))}(),this.state.top&&(we=this.tokenizer.paragraph(We))){Fe=oe[oe.length-1],Se&&Fe.type==="paragraph"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):oe.push(we),Se=We.length!==Z.length,Z=Z.substring(we.raw.length);continue}if(we=this.tokenizer.text(Z)){Z=Z.substring(we.raw.length),Fe=oe[oe.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):oe.push(we);continue}if(Z){var De="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return this.state.top=!0,oe},ce.inline=function(Z,oe){return oe===void 0&&(oe=[]),this.inlineQueue.push({src:Z,tokens:oe}),oe},ce.inlineTokens=function(Z,oe){var pe=this;oe===void 0&&(oe=[]);var we,Fe,We,Se=Z,De,Te,U;if(this.tokens.links){var q=Object.keys(this.tokens.links);if(q.length>0)for(;(De=this.tokenizer.rules.inline.reflinkSearch.exec(Se))!=null;)q.includes(De[0].slice(De[0].lastIndexOf("[")+1,-1))&&(Se=Se.slice(0,De.index)+"["+v("a",De[0].length-2)+"]"+Se.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(De=this.tokenizer.rules.inline.blockSkip.exec(Se))!=null;)Se=Se.slice(0,De.index)+"["+v("a",De[0].length-2)+"]"+Se.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(De=this.tokenizer.rules.inline.escapedEmSt.exec(Se))!=null;)Se=Se.slice(0,De.index)+"++"+Se.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(Te||(U=""),Te=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(_){return(we=_.call({lexer:pe},Z,oe))?(Z=Z.substring(we.raw.length),oe.push(we),!0):!1}))){if(we=this.tokenizer.escape(Z)){Z=Z.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.tag(Z)){Z=Z.substring(we.raw.length),Fe=oe[oe.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):oe.push(we);continue}if(we=this.tokenizer.link(Z)){Z=Z.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(we.raw.length),Fe=oe[oe.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):oe.push(we);continue}if(we=this.tokenizer.emStrong(Z,Se,U)){Z=Z.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.codespan(Z)){Z=Z.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.br(Z)){Z=Z.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.del(Z)){Z=Z.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.autolink(Z,V)){Z=Z.substring(we.raw.length),oe.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(Z,V))){Z=Z.substring(we.raw.length),oe.push(we);continue}if(We=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var _=1/0,de=Z.slice(1),be=void 0;pe.options.extensions.startInline.forEach(function(Ne){be=Ne.call({lexer:this},de),typeof be=="number"&&be>=0&&(_=Math.min(_,be))}),_<1/0&&_>=0&&(We=Z.substring(0,_+1))}(),we=this.tokenizer.inlineText(We,M)){Z=Z.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(U=we.raw.slice(-1)),Te=!0,Fe=oe[oe.length-1],Fe&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):oe.push(we);continue}if(Z){var X="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return oe},r(te,null,[{key:"rules",get:function(){return{block:j,inline:z}}}]),te}(),ne=function(){function te(le){this.options=le||me.defaults}var ce=te.prototype;return ce.code=function(Z,oe,pe){var we=(oe||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(Z,we);Fe!=null&&Fe!==Z&&(pe=!0,Z=Fe)}return Z=Z.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+w(we,!0)+'">'+(pe?Z:w(Z,!0))+`</code></pre>
`:"<pre><code>"+(pe?Z:w(Z,!0))+`</code></pre>
`},ce.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},ce.html=function(Z){return Z},ce.heading=function(Z,oe,pe,we){if(this.options.headerIds){var Fe=this.options.headerPrefix+we.slug(pe);return"<h"+oe+' id="'+Fe+'">'+Z+"</h"+oe+`>
`}return"<h"+oe+">"+Z+"</h"+oe+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(Z,oe,pe){var we=oe?"ol":"ul",Fe=oe&&pe!==1?' start="'+pe+'"':"";return"<"+we+Fe+`>
`+Z+"</"+we+`>
`},ce.listitem=function(Z){return"<li>"+Z+`</li>
`},ce.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(Z){return"<p>"+Z+`</p>
`},ce.table=function(Z,oe){return oe&&(oe="<tbody>"+oe+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+oe+`</table>
`},ce.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},ce.tablecell=function(Z,oe){var pe=oe.header?"th":"td",we=oe.align?"<"+pe+' align="'+oe.align+'">':"<"+pe+">";return we+Z+("</"+pe+`>
`)},ce.strong=function(Z){return"<strong>"+Z+"</strong>"},ce.em=function(Z){return"<em>"+Z+"</em>"},ce.codespan=function(Z){return"<code>"+Z+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(Z){return"<del>"+Z+"</del>"},ce.link=function(Z,oe,pe){if(Z=t(this.options.sanitize,this.options.baseUrl,Z),Z===null)return pe;var we='<a href="'+w(Z)+'"';return oe&&(we+=' title="'+oe+'"'),we+=">"+pe+"</a>",we},ce.image=function(Z,oe,pe){if(Z=t(this.options.sanitize,this.options.baseUrl,Z),Z===null)return pe;var we='<img src="'+Z+'" alt="'+pe+'"';return oe&&(we+=' title="'+oe+'"'),we+=this.options.xhtml?"/>":">",we},ce.text=function(Z){return Z},te}(),B=function(){function te(){}var ce=te.prototype;return ce.strong=function(Z){return Z},ce.em=function(Z){return Z},ce.codespan=function(Z){return Z},ce.del=function(Z){return Z},ce.html=function(Z){return Z},ce.text=function(Z){return Z},ce.link=function(Z,oe,pe){return""+pe},ce.image=function(Z,oe,pe){return""+pe},ce.br=function(){return""},te}(),G=function(){function te(){this.seen={}}var ce=te.prototype;return ce.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(Z,oe){var pe=Z,we=0;if(this.seen.hasOwnProperty(pe)){we=this.seen[Z];do we++,pe=Z+"-"+we;while(this.seen.hasOwnProperty(pe))}return oe||(this.seen[Z]=we,this.seen[pe]=0),pe},ce.slug=function(Z,oe){oe===void 0&&(oe={});var pe=this.serialize(Z);return this.getNextSafeSlug(pe,oe.dryrun)},te}(),Y=function(){function te(le){this.options=le||me.defaults,this.options.renderer=this.options.renderer||new ne,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new B,this.slugger=new G}te.parse=function(Z,oe){var pe=new te(oe);return pe.parse(Z)},te.parseInline=function(Z,oe){var pe=new te(oe);return pe.parseInline(Z)};var ce=te.prototype;return ce.parse=function(Z,oe){oe===void 0&&(oe=!0);var pe="",we,Fe,We,Se,De,Te,U,q,X,_,de,be,Ne,Ge,Ke,tt,rt,ot,nt,at=Z.length;for(we=0;we<at;we++){if(_=Z[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[_.type]&&(nt=this.options.extensions.renderers[_.type].call({parser:this},_),nt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(_.type))){pe+=nt||"";continue}switch(_.type){case"space":continue;case"hr":{pe+=this.renderer.hr();continue}case"heading":{pe+=this.renderer.heading(this.parseInline(_.tokens),_.depth,$(this.parseInline(_.tokens,this.textRenderer)),this.slugger);continue}case"code":{pe+=this.renderer.code(_.text,_.lang,_.escaped);continue}case"table":{for(q="",U="",Se=_.header.length,Fe=0;Fe<Se;Fe++)U+=this.renderer.tablecell(this.parseInline(_.header[Fe].tokens),{header:!0,align:_.align[Fe]});for(q+=this.renderer.tablerow(U),X="",Se=_.rows.length,Fe=0;Fe<Se;Fe++){for(Te=_.rows[Fe],U="",De=Te.length,We=0;We<De;We++)U+=this.renderer.tablecell(this.parseInline(Te[We].tokens),{header:!1,align:_.align[We]});X+=this.renderer.tablerow(U)}pe+=this.renderer.table(q,X);continue}case"blockquote":{X=this.parse(_.tokens),pe+=this.renderer.blockquote(X);continue}case"list":{for(de=_.ordered,be=_.start,Ne=_.loose,Se=_.items.length,X="",Fe=0;Fe<Se;Fe++)Ke=_.items[Fe],tt=Ke.checked,rt=Ke.task,Ge="",Ke.task&&(ot=this.renderer.checkbox(tt),Ne?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=ot+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=ot+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:ot}):Ge+=ot),Ge+=this.parse(Ke.tokens,Ne),X+=this.renderer.listitem(Ge,rt,tt);pe+=this.renderer.list(X,de,be);continue}case"html":{pe+=this.renderer.html(_.text);continue}case"paragraph":{pe+=this.renderer.paragraph(this.parseInline(_.tokens));continue}case"text":{for(X=_.tokens?this.parseInline(_.tokens):_.text;we+1<at&&Z[we+1].type==="text";)_=Z[++we],X+=`
`+(_.tokens?this.parseInline(_.tokens):_.text);pe+=oe?this.renderer.paragraph(X):X;continue}default:{var mt='Token with "'+_.type+'" type was not found.';if(this.options.silent){console.error(mt);return}else throw new Error(mt)}}}return pe},ce.parseInline=function(Z,oe){oe=oe||this.renderer;var pe="",we,Fe,We,Se=Z.length;for(we=0;we<Se;we++){if(Fe=Z[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(We=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),We!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){pe+=We||"";continue}switch(Fe.type){case"escape":{pe+=oe.text(Fe.text);break}case"html":{pe+=oe.html(Fe.text);break}case"link":{pe+=oe.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,oe));break}case"image":{pe+=oe.image(Fe.href,Fe.title,Fe.text);break}case"strong":{pe+=oe.strong(this.parseInline(Fe.tokens,oe));break}case"em":{pe+=oe.em(this.parseInline(Fe.tokens,oe));break}case"codespan":{pe+=oe.codespan(Fe.text);break}case"br":{pe+=oe.br();break}case"del":{pe+=oe.del(this.parseInline(Fe.tokens,oe));break}case"text":{pe+=oe.text(Fe.text);break}default:{var De='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(De);return}else throw new Error(De)}}}return pe},te}();function ee(te,ce,le){if(typeof te>"u"||te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(te)+", string expected");if(typeof ce=="function"&&(le=ce,ce=null),ce=S({},ee.defaults,ce||{}),p(ce),le){var Z=ce.highlight,oe;try{oe=K.lex(te,ce)}catch(Se){return le(Se)}var pe=function(De){var Te;if(!De)try{ce.walkTokens&&ee.walkTokens(oe,ce.walkTokens),Te=Y.parse(oe,ce)}catch(U){De=U}return ce.highlight=Z,De?le(De):le(null,Te)};if(!Z||Z.length<3||(delete ce.highlight,!oe.length))return pe();var we=0;ee.walkTokens(oe,function(Se){Se.type==="code"&&(we++,setTimeout(function(){Z(Se.text,Se.lang,function(De,Te){if(De)return pe(De);Te!=null&&Te!==Se.text&&(Se.text=Te,Se.escaped=!0),we--,we===0&&pe()})},0))}),we===0&&pe();return}function Fe(Se){if(Se.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+w(Se.message+"",!0)+"</pre>";throw Se}try{var We=K.lex(te,ce);if(ce.walkTokens){if(ce.async)return Promise.all(ee.walkTokens(We,ce.walkTokens)).then(function(){return Y.parse(We,ce)}).catch(Fe);ee.walkTokens(We,ce.walkTokens)}return Y.parse(We,ce)}catch(Se){Fe(Se)}}ee.options=ee.setOptions=function(te){return S(ee.defaults,te),R(ee.defaults),ee},ee.getDefaults=L,ee.defaults=me.defaults,ee.use=function(){for(var te=arguments.length,ce=new Array(te),le=0;le<te;le++)ce[le]=arguments[le];var Z=S.apply(void 0,[{}].concat(ce)),oe=ee.defaults.extensions||{renderers:{},childTokens:{}},pe;ce.forEach(function(we){if(we.extensions&&(pe=!0,we.extensions.forEach(function(We){if(!We.name)throw new Error("extension name required");if(We.renderer){var Se=oe.renderers?oe.renderers[We.name]:null;Se?oe.renderers[We.name]=function(){for(var De=arguments.length,Te=new Array(De),U=0;U<De;U++)Te[U]=arguments[U];var q=We.renderer.apply(this,Te);return q===!1&&(q=Se.apply(this,Te)),q}:oe.renderers[We.name]=We.renderer}if(We.tokenizer){if(!We.level||We.level!=="block"&&We.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");oe[We.level]?oe[We.level].unshift(We.tokenizer):oe[We.level]=[We.tokenizer],We.start&&(We.level==="block"?oe.startBlock?oe.startBlock.push(We.start):oe.startBlock=[We.start]:We.level==="inline"&&(oe.startInline?oe.startInline.push(We.start):oe.startInline=[We.start]))}We.childTokens&&(oe.childTokens[We.name]=We.childTokens)})),we.renderer&&function(){var We=ee.defaults.renderer||new ne,Se=function(U){var q=We[U];We[U]=function(){for(var X=arguments.length,_=new Array(X),de=0;de<X;de++)_[de]=arguments[de];var be=we.renderer[U].apply(We,_);return be===!1&&(be=q.apply(We,_)),be}};for(var De in we.renderer)Se(De);Z.renderer=We}(),we.tokenizer&&function(){var We=ee.defaults.tokenizer||new O,Se=function(U){var q=We[U];We[U]=function(){for(var X=arguments.length,_=new Array(X),de=0;de<X;de++)_[de]=arguments[de];var be=we.tokenizer[U].apply(We,_);return be===!1&&(be=q.apply(We,_)),be}};for(var De in we.tokenizer)Se(De);Z.tokenizer=We}(),we.walkTokens){var Fe=ee.defaults.walkTokens;Z.walkTokens=function(We){var Se=[];return Se.push(we.walkTokens.call(this,We)),Fe&&(Se=Se.concat(Fe.call(this,We))),Se}}pe&&(Z.extensions=oe),ee.setOptions(Z)})},ee.walkTokens=function(te,ce){for(var le=[],Z=function(){var Fe=pe.value;switch(le=le.concat(ce.call(ee,Fe)),Fe.type){case"table":{for(var We=T(Fe.header),Se;!(Se=We()).done;){var De=Se.value;le=le.concat(ee.walkTokens(De.tokens,ce))}for(var Te=T(Fe.rows),U;!(U=Te()).done;)for(var q=U.value,X=T(q),_;!(_=X()).done;){var de=_.value;le=le.concat(ee.walkTokens(de.tokens,ce))}break}case"list":{le=le.concat(ee.walkTokens(Fe.items,ce));break}default:ee.defaults.extensions&&ee.defaults.extensions.childTokens&&ee.defaults.extensions.childTokens[Fe.type]?ee.defaults.extensions.childTokens[Fe.type].forEach(function(be){le=le.concat(ee.walkTokens(Fe[be],ce))}):Fe.tokens&&(le=le.concat(ee.walkTokens(Fe.tokens,ce)))}},oe=T(te),pe;!(pe=oe()).done;)Z();return le},ee.parseInline=function(te,ce){if(typeof te>"u"||te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(te)+", string expected");ce=S({},ee.defaults,ce||{}),p(ce);try{var le=K.lexInline(te,ce);return ce.walkTokens&&ee.walkTokens(le,ce.walkTokens),Y.parseInline(le,ce)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+w(Z.message+"",!0)+"</pre>";throw Z}},ee.Parser=Y,ee.parser=Y.parse,ee.Renderer=ne,ee.TextRenderer=B,ee.Lexer=K,ee.lexer=K.lex,ee.Tokenizer=O,ee.Slugger=G,ee.parse=ee;var ue=ee.options,re=ee.setOptions,ye=ee.use,$e=ee.walkTokens,J=ee.parseInline,W=ee,se=Y.parse,ae=K.lex;me.Lexer=K,me.Parser=Y,me.Renderer=ne,me.Slugger=G,me.TextRenderer=B,me.Tokenizer=O,me.getDefaults=L,me.lexer=ae,me.marked=ee,me.options=ue,me.parse=W,me.parseInline=J,me.parser=se,me.setOptions=re,me.use=ye,me.walkTokens=$e,Object.defineProperty(me,"__esModule",{value:!0})}),define(ke[40],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var r;(function(h){h[h.Uri=1]="Uri",h[h.Regexp=2]="Regexp",h[h.ScmResource=3]="ScmResource",h[h.ScmResourceGroup=4]="ScmResourceGroup",h[h.ScmProvider=5]="ScmProvider",h[h.CommentController=6]="CommentController",h[h.CommentThread=7]="CommentThread",h[h.CommentThreadInstance=8]="CommentThreadInstance",h[h.CommentThreadReply=9]="CommentThreadReply",h[h.CommentNode=10]="CommentNode",h[h.CommentThreadNode=11]="CommentThreadNode",h[h.TimelineActionContext=12]="TimelineActionContext",h[h.NotebookCellActionContext=13]="NotebookCellActionContext",h[h.NotebookActionContext=14]="NotebookActionContext",h[h.TerminalContext=15]="TerminalContext",h[h.TestItemContext=16]="TestItemContext",h[h.Date=17]="Date",h[h.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(r||(e.MarshalledId=r={}))}),define(ke[178],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bk=r;function r(a){const $=T(a);if($&&$.length>0)return new Uint32Array($)}let h=0;const C=new Uint32Array(10);function T(a){if(h=0,L(a,D,b.InitialConsonant),h>0||(L(a,u,b.Vowel),h>0)||(L(a,P,b.FinalConsonant),h>0)||(L(a,w,b.CompatibilityJamo),h))return C.subarray(0,h);if(a>=44032&&a<=55203){const $=a-44032,f=$%588,g=Math.floor($/588),i=Math.floor(f/28),o=f%28-1;if(g<D.length?L(g,D,0):b.InitialConsonant+g-b.CompatibilityJamo<w.length&&L(b.InitialConsonant+g,w,b.CompatibilityJamo),i<u.length?L(i,u,0):b.Vowel+i-b.CompatibilityJamo<w.length&&L(b.Vowel+i-b.CompatibilityJamo,w,b.CompatibilityJamo),o>=0&&(o<P.length?L(o,P,0):b.FinalConsonant+o-b.CompatibilityJamo<w.length&&L(b.FinalConsonant+o-b.CompatibilityJamo,w,b.CompatibilityJamo)),h>0)return C.subarray(0,h)}}function L(a,$,f){a>=f&&a<f+$.length&&R($[a-f])}function R(a){a!==c.NUL&&(C[h++]=a&255,a>>8&&(C[h++]=a>>8&255),a>>16&&(C[h++]=a>>16&255))}var b;(function(a){a[a.InitialConsonant=4352]="InitialConsonant",a[a.Vowel=4449]="Vowel",a[a.FinalConsonant=4520]="FinalConsonant",a[a.CompatibilityJamo=12593]="CompatibilityJamo"})(b||(b={}));var c;(function(a){a[a.NUL=0]="NUL",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z"})(c||(c={}));var I;(function(a){a[a.fa=24934]="fa",a[a.fg=26470]="fg",a[a.fq=29030]="fq",a[a.fr=29286]="fr",a[a.ft=29798]="ft",a[a.fv=30310]="fv",a[a.fx=30822]="fx",a[a.hk=27496]="hk",a[a.hl=27752]="hl",a[a.ho=28520]="ho",a[a.ml=27757]="ml",a[a.nj=27246]="nj",a[a.nl=27758]="nl",a[a.np=28782]="np",a[a.qt=29809]="qt",a[a.rt=29810]="rt",a[a.sg=26483]="sg",a[a.sw=30579]="sw"})(I||(I={}));const D=new Uint8Array([c.r,c.R,c.s,c.e,c.E,c.f,c.a,c.q,c.Q,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g]),u=new Uint16Array([c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,I.hk,I.ho,I.hl,c.y,c.n,I.nj,I.np,I.nl,c.b,c.m,I.ml,c.l]),P=new Uint16Array([c.r,c.R,I.rt,c.s,I.sw,I.sg,c.e,c.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,c.a,c.q,I.qt,c.t,c.T,c.d,c.w,c.c,c.z,c.x,c.v,c.g]),w=new Uint16Array([c.r,c.R,I.rt,c.s,I.sw,I.sg,c.e,c.E,c.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,c.a,c.q,c.Q,I.qt,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g,c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,I.hk,I.ho,I.hl,c.y,c.n,I.nj,I.np,I.nl,c.b,c.m,I.ml,c.l])}),define(ke[81],Ie([1,0,28]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lm=void 0,e.$jm=C,e.$km=L;const h=new r.$Cc(1e4);function C(c){return b(c,"NFC",h)}const T=new r.$Cc(1e4);function L(c){return b(c,"NFD",T)}const R=/[^\u0000-\u0080]/;function b(c,I,D){if(!c)return c;const u=D.get(c);if(u)return u;let P;return R.test(c)?P=c.normalize(I):P=c,D.set(c,P),P}e.$lm=function(){const c=/[\u0300-\u036f]/g;return function(I){return L(I).replace(c,"")}}()}),define(ke[133],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=e.$Km=e.$Jm=void 0,e.$Hm=r,e.rot=h,e.$Mm=R;function r(b,c,I){return Math.min(Math.max(b,c),I)}function h(b,c){return(c+b%c)%c}class C{constructor(){this.a=0}getNext(){return this.a++}}e.$Jm=C;class T{constructor(){this.a=1,this.b=0}update(c){return this.b=this.b+(c-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Km=T;class L{constructor(c){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(c),this.c.fill(0,0,c)}update(c){const I=this.c[this.d];return this.c[this.d]=c,this.d=(this.d+1)%this.c.length,this.e-=I,this.e+=c,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Lm=L;function R(b,c,I,D,u,P,w,a){const $=w-I,f=a-D,g=u-I,i=P-D,o=b-I,t=c-D,s=$*$+f*f,n=$*g+f*i,d=$*o+f*t,l=g*g+i*i,m=g*o+i*t,E=1/(s*l-n*n),S=(l*d-n*m)*E,y=(s*m-n*d)*E;return S>=0&&y>=0&&S+y<1}}),define(ke[179],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_c=void 0,e.$ad=T,e.$bd=u;class r{constructor(w,a,$){this.owner=w,this.debugNameSource=a,this.referenceFn=$}getDebugName(w){return T(w,this)}}e.$_c=r;const h=new Map,C=new WeakMap;function T(P,w){const a=C.get(P);if(a)return a;const $=L(P,w);if($){let f=h.get($)??0;f++,h.set($,f);const g=f===1?$:`${$}#${f}`;return C.set(P,g),g}}function L(P,w){const a=C.get(P);if(a)return a;const $=w.owner?I(w.owner)+".":"";let f;const g=w.debugNameSource;if(g!==void 0)if(typeof g=="function"){if(f=g(),f!==void 0)return $+f}else return $+g;const i=w.referenceFn;if(i!==void 0&&(f=u(i),f!==void 0))return $+f;if(w.owner!==void 0){const o=R(w.owner,P);if(o!==void 0)return $+o}}function R(P,w){for(const a in P)if(P[a]===w)return a}const b=new Map,c=new WeakMap;function I(P){const w=c.get(P);if(w)return w;const a=D(P);let $=b.get(a)??0;$++,b.set(a,$);const f=$===1?a:`${a}#${$}`;return c.set(P,f),f}function D(P){const w=P.constructor;return w?w.name:"Object"}function u(P){const w=P.toString(),$=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(w);return($?$[1]:void 0)?.trim()}}),define(ke[180],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Id=h,e.$Jd=C;let r;function h(a){r=a}function C(){return r}class T{constructor(){this.a=0,this.d=new WeakMap}b($){return L([R(P("|  ",this.a)),$])}c($){return $.hadValue?$.didChange?[R(" "),c(I($.oldValue,70),{color:"red",strikeThrough:!0}),R(" "),c(I($.newValue,60),{color:"green"})]:[R(" (unchanged)")]:[R(" "),c(I($.newValue,60),{color:"green"}),R(" (initial)")]}handleObservableChanged($,f){console.log(...this.b([b("observable value changed"),c($.debugName,{color:"BlueViolet"}),...this.c(f)]))}formatChanges($){if($.size!==0)return c(" (changed deps: "+[...$].map(f=>f.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated($){const f=$.handleChange;this.d.set($,new Set),$.handleChange=(g,i)=>(this.d.get($).add(g),f.apply($,[g,i]))}handleDerivedRecomputed($,f){const g=this.d.get($);console.log(...this.b([b("derived recomputed"),c($.debugName,{color:"BlueViolet"}),...this.c(f),this.formatChanges(g),{data:[{fn:$._debugNameData.referenceFn??$._computeFn}]}])),g.clear()}handleFromEventObservableTriggered($,f){console.log(...this.b([b("observable from event triggered"),c($.debugName,{color:"BlueViolet"}),...this.c(f),{data:[{fn:$._getValue}]}]))}handleAutorunCreated($){const f=$.handleChange;this.d.set($,new Set),$.handleChange=(g,i)=>(this.d.get($).add(g),f.apply($,[g,i]))}handleAutorunTriggered($){const f=this.d.get($);console.log(...this.b([b("autorun"),c($.debugName,{color:"BlueViolet"}),this.formatChanges(f),{data:[{fn:$._debugNameData.referenceFn??$._runFn}]}])),f.clear(),this.a++}handleAutorunFinished($){this.a--}handleBeginTransaction($){let f=$.getDebugName();f===void 0&&(f=""),console.log(...this.b([b("transaction"),c(f,{color:"BlueViolet"}),{data:[{fn:$._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Kd=T;function L(a){const $=new Array,f=[];let g="";function i(t){if("length"in t)for(const s of t)s&&i(s);else"text"in t?(g+=`%c${t.text}`,$.push(t.style),t.data&&f.push(...t.data)):"data"in t&&f.push(...t.data)}i(a);const o=[g,...$];return o.push(...f),o}function R(a){return c(a,{color:"black"})}function b(a){return c(w(`${a}: `,10),{color:"black",bold:!0})}function c(a,$={color:"black"}){function f(i){return Object.entries(i).reduce((o,[t,s])=>`${o}${t}:${s};`,"")}const g={color:$.color};return $.strikeThrough&&(g["text-decoration"]="line-through"),$.bold&&(g["font-weight"]="bold"),{text:a,style:f(g)}}function I(a,$){switch(typeof a){case"number":return""+a;case"string":return a.length+2<=$?`"${a}"`:`"${a.substr(0,$-7)}"+...`;case"boolean":return a?"true":"false";case"undefined":return"undefined";case"object":return a===null?"null":Array.isArray(a)?D(a,$):u(a,$);case"symbol":return a.toString();case"function":return`[[Function${a.name?" "+a.name:""}]]`;default:return""+a}}function D(a,$){let f="[ ",g=!0;for(const i of a){if(g||(f+=", "),f.length-5>$){f+="...";break}g=!1,f+=`${I(i,$-f.length)}`}return f+=" ]",f}function u(a,$){let f="{ ",g=!0;for(const[i,o]of Object.entries(a)){if(g||(f+=", "),f.length-5>$){f+="...";break}g=!1,f+=`${i}: ${I(o,$-f.length)}`}return f+=" }",f}function P(a,$){let f="";for(let g=1;g<=$;g++)f+=a;return f}function w(a,$){for(;a.length<$;)a+=" ";return a}}),define(ke[181],Ie([1,0,175,179,180]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.$5d=e.$3d=e.$Xd=e.$Wd=void 0,e.$Td=L,e.$Ud=b,e.$Vd=I,e.$Yd=P,e.$Zd=a,e.$1d=$,e.$2d=f,e.$4d=i,e.$6d=t;let T;function L(n){T=n}let R;function b(n){R=n}let c;function I(n){c=n}class D{get TChange(){return null}reportChanges(){this.get()}read(d){return d?d.readObservable(this):this.get()}map(d,l){const m=l===void 0?void 0:d,E=l===void 0?d:l;return c({owner:m,debugName:()=>{const S=(0,h.$bd)(E);if(S!==void 0)return S;const k=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(E.toString());if(k)return`${this.debugName}.${k[2]}`;if(!m)return`${this.debugName} (mapped)`},debugReferenceFn:E},S=>E(this.read(S),S))}recomputeInitiallyAndOnChange(d,l){return d.add(T(this,l)),this}keepObserved(d){return d.add(R(this)),this}get a(){return this.get()}}e.$Wd=D;class u extends D{constructor(){super(...arguments),this.b=new Set}addObserver(d){const l=this.b.size;this.b.add(d),l===0&&this.c()}removeObserver(d){this.b.delete(d)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Xd=u;function P(n,d){const l=new g(n,d);try{n(l)}finally{l.finish()}}let w;function a(n){if(w)n(w);else{const d=new g(n,void 0);w=d;try{n(d)}finally{d.finish(),w=void 0}}}async function $(n,d){const l=new g(n,d);try{await n(l)}finally{l.finish()}}function f(n,d,l){n?d(n):P(d,l)}class g{constructor(d,l){this._fn=d,this.b=l,this.a=[],(0,C.$Jd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,h.$bd)(this._fn)}updateObserver(d,l){this.a.push({observer:d,observable:l}),d.beginUpdate(l)}finish(){const d=this.a;for(let l=0;l<d.length;l++){const{observer:m,observable:E}=d[l];m.endUpdate(E)}this.a=null,(0,C.$Jd)()?.handleEndTransaction()}}e.$3d=g;function i(n,d){let l;return typeof n=="string"?l=new h.$_c(void 0,n,void 0):l=new h.$_c(n,void 0,void 0),new o(l,d,r.$5c)}class o extends u{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(d,l,m){super(),this.e=d,this.g=m,this.d=l}get(){return this.d}set(d,l,m){if(m===void 0&&this.g(this.d,d))return;let E;l||(l=E=new g(()=>{},()=>`Setting ${this.debugName}`));try{const S=this.d;this.h(d),(0,C.$Jd)()?.handleObservableChanged(this,{oldValue:S,newValue:d,change:m,didChange:!0,hadValue:!0});for(const y of this.b)l.updateObserver(y,this),y.handleChange(this,m)}finally{E&&E.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(d){this.d=d}}e.$5d=o;function t(n,d){let l;return typeof n=="string"?l=new h.$_c(void 0,n,void 0):l=new h.$_c(n,void 0,void 0),new s(l,d,r.$5c)}class s extends o{h(d){this.d!==d&&(this.d&&this.d.dispose(),this.d=d)}dispose(){this.d?.dispose()}}e.$7d=s}),function(){function me(C){const T=[];typeof C=="number"&&T.push("code/timeOrigin",C);function L(b){T.push(b,Date.now())}function R(){const b=[];for(let c=0;c<T.length;c+=2)b.push({name:T[c],startTime:T[c+1]});return b}return{mark:L,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const L of performance.getEntriesByType("mark"))T.push({name:L.name,startTime:Math.round(C+L.startTime)});return T}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function r(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var h;typeof global=="object"?h=global:typeof self=="object"?h=self:h={},typeof define=="function"?define("vs/base/common/performance",[],function(){return r(h)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=r(h):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),h.perf=r(h))}(),define(ke[10],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.OS=e.OperatingSystem=e.$C=e.$B=e.$A=e.$z=e.$y=e.Language=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.Platform=e.$h=void 0,e.$i=s,e.$E=S,e.$K=y,e.$h="en";let r=!1,h=!1,C=!1,T=!1,L=!1,R=!1,b=!1,c=!1,I=!1,D=!1,u,P=e.$h,w=e.$h,a,$;const f=globalThis;let g;typeof f.vscode<"u"&&typeof f.vscode.process<"u"?g=f.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(g=process);const i=typeof g?.versions?.electron=="string",o=i&&g?.type==="renderer";if(typeof g=="object"){r=g.platform==="win32",h=g.platform==="darwin",C=g.platform==="linux",T=C&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,b=i,I=!!g.env.CI||!!g.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=e.$h,P=e.$h;const k=g.env.VSCODE_NLS_CONFIG;if(k)try{const A=JSON.parse(k);u=A.userLocale,w=A.osLocale,P=A.resolvedLanguage||e.$h,a=A.languagePack?.translationsConfigFile}catch{}L=!0}else typeof navigator=="object"&&!o?($=navigator.userAgent,r=$.indexOf("Windows")>=0,h=$.indexOf("Macintosh")>=0,c=($.indexOf("Macintosh")>=0||$.indexOf("iPad")>=0||$.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=$.indexOf("Linux")>=0,D=$?.indexOf("Mobi")>=0,R=!0,P=globalThis._VSCODE_NLS_LANGUAGE||e.$h,u=navigator.language.toLowerCase(),w=u):console.error("Unable to resolve platform.");var t;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(t||(e.Platform=t={}));function s(k){switch(k){case t.Web:return"Web";case t.Mac:return"Mac";case t.Linux:return"Linux";case t.Windows:return"Windows"}}let n=t.Web;h?n=t.Mac:r?n=t.Windows:C&&(n=t.Linux),e.$j=r,e.$k=h,e.$l=C,e.$m=T,e.$n=L,e.$o=b,e.$p=R,e.$q=R&&typeof f.importScripts=="function",e.$r=e.$q?f.origin:void 0,e.$s=c,e.$t=D,e.$u=I,e.$v=n,e.$w=$,e.$x=P;var d;(function(k){function A(){return e.$x}k.value=A;function p(){return e.$x.length===2?e.$x==="en":e.$x.length>=3?e.$x[0]==="e"&&e.$x[1]==="n"&&e.$x[2]==="-":!1}k.isDefaultVariant=p;function v(){return e.$x==="en"}k.isDefault=v})(d||(e.Language=d={})),e.$y=u,e.$z=w,e.$A=a,e.$B=typeof f.postMessage=="function"&&!f.importScripts,e.$C=(()=>{if(e.$B){const k=[];f.addEventListener("message",p=>{if(p.data&&p.data.vscodeScheduleAsyncWork)for(let v=0,F=k.length;v<F;v++){const N=k[v];if(N.id===p.data.vscodeScheduleAsyncWork){k.splice(v,1),N.callback();return}}});let A=0;return p=>{const v=++A;k.push({id:v,callback:p}),f.postMessage({vscodeScheduleAsyncWork:v},"*")}}return k=>setTimeout(k)})();var l;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(l||(e.OperatingSystem=l={})),e.OS=h||c?l.Macintosh:r?l.Windows:l.Linux;let m=!0,E=!1;function S(){if(!E){E=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,m=new Uint16Array(k.buffer)[0]===513}return m}e.$F=!!(e.$w&&e.$w.indexOf("Chrome")>=0),e.$G=!!(e.$w&&e.$w.indexOf("Firefox")>=0),e.$H=!!(!e.$F&&e.$w&&e.$w.indexOf("Safari")>=0),e.$I=!!(e.$w&&e.$w.indexOf("Edg/")>=0),e.$J=!!(e.$w&&e.$w.indexOf("Android")>=0);function y(k){return parseFloat(k)>=20}}),define(ke[182],Ie([1,0,39]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QI=void 0;const h=Symbol("unset");class C{constructor(){this.a=new L,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||r.Iterable.empty()}get entries(){return this.a.children?.entries()||r.Iterable.empty()}insert(b,c,I){this.d(b,D=>D._value=c,I)}mutate(b,c){this.d(b,I=>I._value=c(I._value===h?void 0:I._value))}mutatePath(b,c){this.d(b,()=>{},I=>c(I))}delete(b){const c=this.c(b);if(!c)return;let I=c.length-1;const D=c[I].node._value;if(D!==h){for(this.b--,c[I].node._value=h;I>0;I--){const{node:u,part:P}=c[I];if(u.children?.size||u._value!==h)break;c[I-1].node.children.delete(P)}return D}}*deleteRecursive(b){const c=this.c(b);if(!c)return;const I=c[c.length-1].node;for(let D=c.length-1;D>0;D--){const u=c[D-1];if(u.node.children.delete(c[D].part),u.node.children.size>0||u.node._value!==h)break}for(const D of T(I))D._value!==h&&(this.b--,yield D._value)}find(b){let c=this.a;for(const I of b){const D=c.children?.get(I);if(!D)return;c=D}return c._value===h?void 0:c._value}hasKeyOrParent(b){let c=this.a;for(const I of b){const D=c.children?.get(I);if(!D)return!1;if(D._value!==h)return!0;c=D}return!1}hasKeyOrChildren(b){let c=this.a;for(const I of b){const D=c.children?.get(I);if(!D)return!1;c=D}return!0}hasKey(b){let c=this.a;for(const I of b){const D=c.children?.get(I);if(!D)return!1;c=D}return c._value!==h}c(b){const c=[{part:"",node:this.a}];let I=0;for(const D of b){const u=c[I].node.children?.get(D);if(!u)return;c.push({part:D,node:u}),I++}return c}d(b,c,I){let D=this.a;for(const w of b){if(D.children)if(D.children.has(w))D=D.children.get(w);else{const a=new L;D.children.set(w,a),D=a}else{const a=new L;D.children=new Map([[w,a]]),D=a}I?.(D)}const u=D._value===h?0:1;c(D);const P=D._value===h?0:1;this.b+=P-u}*values(){for(const{_value:b}of T(this.a))b!==h&&(yield b)}}e.$QI=C;function*T(R){const b=[R];for(;b.length>0;){const c=b.pop();if(yield c,c.children)for(const I of c.children.values())b.push(I)}}class L{constructor(){this._value=h}get value(){return this._value===h?void 0:this._value}set value(b){this._value=b===void 0?h:b}}}),define(ke[55],Ie([1,0,10]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let h;const C=globalThis.vscode;if(typeof C<"u"&&typeof C.process<"u"){const T=C.process;h={get platform(){return T.platform},get arch(){return T.arch},get env(){return T.env},cwd(){return T.cwd()}}}else typeof process<"u"?h={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:h={get platform(){return r.$j?"win32":r.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=h.cwd,e.env=h.env,e.$cc=h.platform,e.$dc=h.arch}),define(ke[16],Ie([1,0,55]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0,r=Ue(r);const h=65,C=97,T=90,L=122,R=46,b=47,c=92,I=58,D=63;class u extends Error{constructor(d,l,m){let E;typeof l=="string"&&l.indexOf("not ")===0?(E="must not be",l=l.replace(/^not /,"")):E="must be";const S=d.indexOf(".")!==-1?"property":"argument";let y=`The "${d}" ${S} ${E} of type ${l}`;y+=`. Received type ${typeof m}`,super(y),this.code="ERR_INVALID_ARG_TYPE"}}function P(n,d){if(n===null||typeof n!="object")throw new u(d,"Object",n)}function w(n,d){if(typeof n!="string")throw new u(d,"string",n)}const a=r.$cc==="win32";function $(n){return n===b||n===c}function f(n){return n===b}function g(n){return n>=h&&n<=T||n>=C&&n<=L}function i(n,d,l,m){let E="",S=0,y=-1,k=0,A=0;for(let p=0;p<=n.length;++p){if(p<n.length)A=n.charCodeAt(p);else{if(m(A))break;A=b}if(m(A)){if(!(y===p-1||k===1))if(k===2){if(E.length<2||S!==2||E.charCodeAt(E.length-1)!==R||E.charCodeAt(E.length-2)!==R){if(E.length>2){const v=E.lastIndexOf(l);v===-1?(E="",S=0):(E=E.slice(0,v),S=E.length-1-E.lastIndexOf(l)),y=p,k=0;continue}else if(E.length!==0){E="",S=0,y=p,k=0;continue}}d&&(E+=E.length>0?`${l}..`:"..",S=2)}else E.length>0?E+=`${l}${n.slice(y+1,p)}`:E=n.slice(y+1,p),S=p-y-1;y=p,k=0}else A===R&&k!==-1?++k:k=-1}return E}function o(n){return n?`${n[0]==="."?"":"."}${n}`:""}function t(n,d){P(d,"pathObject");const l=d.dir||d.root,m=d.base||`${d.name||""}${o(d.ext)}`;return l?l===d.root?`${l}${m}`:`${l}${n}${m}`:m}e.$ec={resolve(...n){let d="",l="",m=!1;for(let E=n.length-1;E>=-1;E--){let S;if(E>=0){if(S=n[E],w(S,`paths[${E}]`),S.length===0)continue}else d.length===0?S=r.cwd():(S=r.env[`=${d}`]||r.cwd(),(S===void 0||S.slice(0,2).toLowerCase()!==d.toLowerCase()&&S.charCodeAt(2)===c)&&(S=`${d}\\`));const y=S.length;let k=0,A="",p=!1;const v=S.charCodeAt(0);if(y===1)$(v)&&(k=1,p=!0);else if($(v))if(p=!0,$(S.charCodeAt(1))){let F=2,N=F;for(;F<y&&!$(S.charCodeAt(F));)F++;if(F<y&&F!==N){const O=S.slice(N,F);for(N=F;F<y&&$(S.charCodeAt(F));)F++;if(F<y&&F!==N){for(N=F;F<y&&!$(S.charCodeAt(F));)F++;(F===y||F!==N)&&(A=`\\\\${O}\\${S.slice(N,F)}`,k=F)}}}else k=1;else g(v)&&S.charCodeAt(1)===I&&(A=S.slice(0,2),k=2,y>2&&$(S.charCodeAt(2))&&(p=!0,k=3));if(A.length>0)if(d.length>0){if(A.toLowerCase()!==d.toLowerCase())continue}else d=A;if(m){if(d.length>0)break}else if(l=`${S.slice(k)}\\${l}`,m=p,p&&d.length>0)break}return l=i(l,!m,"\\",$),m?`${d}\\${l}`:`${d}${l}`||"."},normalize(n){w(n,"path");const d=n.length;if(d===0)return".";let l=0,m,E=!1;const S=n.charCodeAt(0);if(d===1)return f(S)?"\\":n;if($(S))if(E=!0,$(n.charCodeAt(1))){let k=2,A=k;for(;k<d&&!$(n.charCodeAt(k));)k++;if(k<d&&k!==A){const p=n.slice(A,k);for(A=k;k<d&&$(n.charCodeAt(k));)k++;if(k<d&&k!==A){for(A=k;k<d&&!$(n.charCodeAt(k));)k++;if(k===d)return`\\\\${p}\\${n.slice(A)}\\`;k!==A&&(m=`\\\\${p}\\${n.slice(A,k)}`,l=k)}}}else l=1;else g(S)&&n.charCodeAt(1)===I&&(m=n.slice(0,2),l=2,d>2&&$(n.charCodeAt(2))&&(E=!0,l=3));let y=l<d?i(n.slice(l),!E,"\\",$):"";return y.length===0&&!E&&(y="."),y.length>0&&$(n.charCodeAt(d-1))&&(y+="\\"),m===void 0?E?`\\${y}`:y:E?`${m}\\${y}`:`${m}${y}`},isAbsolute(n){w(n,"path");const d=n.length;if(d===0)return!1;const l=n.charCodeAt(0);return $(l)||d>2&&g(l)&&n.charCodeAt(1)===I&&$(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let d,l;for(let S=0;S<n.length;++S){const y=n[S];w(y,"path"),y.length>0&&(d===void 0?d=l=y:d+=`\\${y}`)}if(d===void 0)return".";let m=!0,E=0;if(typeof l=="string"&&$(l.charCodeAt(0))){++E;const S=l.length;S>1&&$(l.charCodeAt(1))&&(++E,S>2&&($(l.charCodeAt(2))?++E:m=!1))}if(m){for(;E<d.length&&$(d.charCodeAt(E));)E++;E>=2&&(d=`\\${d.slice(E)}`)}return e.$ec.normalize(d)},relative(n,d){if(w(n,"from"),w(d,"to"),n===d)return"";const l=e.$ec.resolve(n),m=e.$ec.resolve(d);if(l===m||(n=l.toLowerCase(),d=m.toLowerCase(),n===d))return"";let E=0;for(;E<n.length&&n.charCodeAt(E)===c;)E++;let S=n.length;for(;S-1>E&&n.charCodeAt(S-1)===c;)S--;const y=S-E;let k=0;for(;k<d.length&&d.charCodeAt(k)===c;)k++;let A=d.length;for(;A-1>k&&d.charCodeAt(A-1)===c;)A--;const p=A-k,v=y<p?y:p;let F=-1,N=0;for(;N<v;N++){const j=n.charCodeAt(E+N);if(j!==d.charCodeAt(k+N))break;j===c&&(F=N)}if(N!==v){if(F===-1)return m}else{if(p>v){if(d.charCodeAt(k+N)===c)return m.slice(k+N+1);if(N===2)return m.slice(k+N)}y>v&&(n.charCodeAt(E+N)===c?F=N:N===2&&(F=3)),F===-1&&(F=0)}let O="";for(N=E+F+1;N<=S;++N)(N===S||n.charCodeAt(N)===c)&&(O+=O.length===0?"..":"\\..");return k+=F,O.length>0?`${O}${m.slice(k,A)}`:(m.charCodeAt(k)===c&&++k,m.slice(k,A))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const d=e.$ec.resolve(n);if(d.length<=2)return n;if(d.charCodeAt(0)===c){if(d.charCodeAt(1)===c){const l=d.charCodeAt(2);if(l!==D&&l!==R)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(g(d.charCodeAt(0))&&d.charCodeAt(1)===I&&d.charCodeAt(2)===c)return`\\\\?\\${d}`;return n},dirname(n){w(n,"path");const d=n.length;if(d===0)return".";let l=-1,m=0;const E=n.charCodeAt(0);if(d===1)return $(E)?n:".";if($(E)){if(l=m=1,$(n.charCodeAt(1))){let k=2,A=k;for(;k<d&&!$(n.charCodeAt(k));)k++;if(k<d&&k!==A){for(A=k;k<d&&$(n.charCodeAt(k));)k++;if(k<d&&k!==A){for(A=k;k<d&&!$(n.charCodeAt(k));)k++;if(k===d)return n;k!==A&&(l=m=k+1)}}}}else g(E)&&n.charCodeAt(1)===I&&(l=d>2&&$(n.charCodeAt(2))?3:2,m=l);let S=-1,y=!0;for(let k=d-1;k>=m;--k)if($(n.charCodeAt(k))){if(!y){S=k;break}}else y=!1;if(S===-1){if(l===-1)return".";S=l}return n.slice(0,S)},basename(n,d){d!==void 0&&w(d,"suffix"),w(n,"path");let l=0,m=-1,E=!0,S;if(n.length>=2&&g(n.charCodeAt(0))&&n.charCodeAt(1)===I&&(l=2),d!==void 0&&d.length>0&&d.length<=n.length){if(d===n)return"";let y=d.length-1,k=-1;for(S=n.length-1;S>=l;--S){const A=n.charCodeAt(S);if($(A)){if(!E){l=S+1;break}}else k===-1&&(E=!1,k=S+1),y>=0&&(A===d.charCodeAt(y)?--y===-1&&(m=S):(y=-1,m=k))}return l===m?m=k:m===-1&&(m=n.length),n.slice(l,m)}for(S=n.length-1;S>=l;--S)if($(n.charCodeAt(S))){if(!E){l=S+1;break}}else m===-1&&(E=!1,m=S+1);return m===-1?"":n.slice(l,m)},extname(n){w(n,"path");let d=0,l=-1,m=0,E=-1,S=!0,y=0;n.length>=2&&n.charCodeAt(1)===I&&g(n.charCodeAt(0))&&(d=m=2);for(let k=n.length-1;k>=d;--k){const A=n.charCodeAt(k);if($(A)){if(!S){m=k+1;break}continue}E===-1&&(S=!1,E=k+1),A===R?l===-1?l=k:y!==1&&(y=1):l!==-1&&(y=-1)}return l===-1||E===-1||y===0||y===1&&l===E-1&&l===m+1?"":n.slice(l,E)},format:t.bind(null,"\\"),parse(n){w(n,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return d;const l=n.length;let m=0,E=n.charCodeAt(0);if(l===1)return $(E)?(d.root=d.dir=n,d):(d.base=d.name=n,d);if($(E)){if(m=1,$(n.charCodeAt(1))){let F=2,N=F;for(;F<l&&!$(n.charCodeAt(F));)F++;if(F<l&&F!==N){for(N=F;F<l&&$(n.charCodeAt(F));)F++;if(F<l&&F!==N){for(N=F;F<l&&!$(n.charCodeAt(F));)F++;F===l?m=F:F!==N&&(m=F+1)}}}}else if(g(E)&&n.charCodeAt(1)===I){if(l<=2)return d.root=d.dir=n,d;if(m=2,$(n.charCodeAt(2))){if(l===3)return d.root=d.dir=n,d;m=3}}m>0&&(d.root=n.slice(0,m));let S=-1,y=m,k=-1,A=!0,p=n.length-1,v=0;for(;p>=m;--p){if(E=n.charCodeAt(p),$(E)){if(!A){y=p+1;break}continue}k===-1&&(A=!1,k=p+1),E===R?S===-1?S=p:v!==1&&(v=1):S!==-1&&(v=-1)}return k!==-1&&(S===-1||v===0||v===1&&S===k-1&&S===y+1?d.base=d.name=n.slice(y,k):(d.name=n.slice(y,S),d.base=n.slice(y,k),d.ext=n.slice(S,k))),y>0&&y!==m?d.dir=n.slice(0,y-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null};const s=(()=>{if(a){const n=/\\/g;return()=>{const d=r.cwd().replace(n,"/");return d.slice(d.indexOf("/"))}}return()=>r.cwd()})();e.$fc={resolve(...n){let d="",l=!1;for(let m=n.length-1;m>=-1&&!l;m--){const E=m>=0?n[m]:s();w(E,`paths[${m}]`),E.length!==0&&(d=`${E}/${d}`,l=E.charCodeAt(0)===b)}return d=i(d,!l,"/",f),l?`/${d}`:d.length>0?d:"."},normalize(n){if(w(n,"path"),n.length===0)return".";const d=n.charCodeAt(0)===b,l=n.charCodeAt(n.length-1)===b;return n=i(n,!d,"/",f),n.length===0?d?"/":l?"./":".":(l&&(n+="/"),d?`/${n}`:n)},isAbsolute(n){return w(n,"path"),n.length>0&&n.charCodeAt(0)===b},join(...n){if(n.length===0)return".";let d;for(let l=0;l<n.length;++l){const m=n[l];w(m,"path"),m.length>0&&(d===void 0?d=m:d+=`/${m}`)}return d===void 0?".":e.$fc.normalize(d)},relative(n,d){if(w(n,"from"),w(d,"to"),n===d||(n=e.$fc.resolve(n),d=e.$fc.resolve(d),n===d))return"";const l=1,m=n.length,E=m-l,S=1,y=d.length-S,k=E<y?E:y;let A=-1,p=0;for(;p<k;p++){const F=n.charCodeAt(l+p);if(F!==d.charCodeAt(S+p))break;F===b&&(A=p)}if(p===k)if(y>k){if(d.charCodeAt(S+p)===b)return d.slice(S+p+1);if(p===0)return d.slice(S+p)}else E>k&&(n.charCodeAt(l+p)===b?A=p:p===0&&(A=0));let v="";for(p=l+A+1;p<=m;++p)(p===m||n.charCodeAt(p)===b)&&(v+=v.length===0?"..":"/..");return`${v}${d.slice(S+A)}`},toNamespacedPath(n){return n},dirname(n){if(w(n,"path"),n.length===0)return".";const d=n.charCodeAt(0)===b;let l=-1,m=!0;for(let E=n.length-1;E>=1;--E)if(n.charCodeAt(E)===b){if(!m){l=E;break}}else m=!1;return l===-1?d?"/":".":d&&l===1?"//":n.slice(0,l)},basename(n,d){d!==void 0&&w(d,"ext"),w(n,"path");let l=0,m=-1,E=!0,S;if(d!==void 0&&d.length>0&&d.length<=n.length){if(d===n)return"";let y=d.length-1,k=-1;for(S=n.length-1;S>=0;--S){const A=n.charCodeAt(S);if(A===b){if(!E){l=S+1;break}}else k===-1&&(E=!1,k=S+1),y>=0&&(A===d.charCodeAt(y)?--y===-1&&(m=S):(y=-1,m=k))}return l===m?m=k:m===-1&&(m=n.length),n.slice(l,m)}for(S=n.length-1;S>=0;--S)if(n.charCodeAt(S)===b){if(!E){l=S+1;break}}else m===-1&&(E=!1,m=S+1);return m===-1?"":n.slice(l,m)},extname(n){w(n,"path");let d=-1,l=0,m=-1,E=!0,S=0;for(let y=n.length-1;y>=0;--y){const k=n.charCodeAt(y);if(k===b){if(!E){l=y+1;break}continue}m===-1&&(E=!1,m=y+1),k===R?d===-1?d=y:S!==1&&(S=1):d!==-1&&(S=-1)}return d===-1||m===-1||S===0||S===1&&d===m-1&&d===l+1?"":n.slice(d,m)},format:t.bind(null,"/"),parse(n){w(n,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return d;const l=n.charCodeAt(0)===b;let m;l?(d.root="/",m=1):m=0;let E=-1,S=0,y=-1,k=!0,A=n.length-1,p=0;for(;A>=m;--A){const v=n.charCodeAt(A);if(v===b){if(!k){S=A+1;break}continue}y===-1&&(k=!1,y=A+1),v===R?E===-1?E=A:p!==1&&(p=1):E!==-1&&(p=-1)}if(y!==-1){const v=S===0&&l?1:S;E===-1||p===0||p===1&&E===y-1&&E===S+1?d.base=d.name=n.slice(v,y):(d.name=n.slice(v,E),d.base=n.slice(v,y),d.ext=n.slice(E,y))}return S>0?d.dir=n.slice(0,S-1):l&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=a?e.$ec.normalize:e.$fc.normalize,e.$hc=a?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=a?e.$ec.join:e.$fc.join,e.$jc=a?e.$ec.resolve:e.$fc.resolve,e.$kc=a?e.$ec.relative:e.$fc.relative,e.$lc=a?e.$ec.dirname:e.$fc.dirname,e.$mc=a?e.$ec.basename:e.$fc.basename,e.$nc=a?e.$ec.extname:e.$fc.extname,e.$oc=a?e.$ec.format:e.$fc.format,e.$pc=a?e.$ec.parse:e.$fc.parse,e.$qc=a?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=a?e.$ec.sep:e.$fc.sep,e.$sc=a?e.$ec.delimiter:e.$fc.delimiter}),define(ke[134],Ie([1,0,49,16]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=R,e.$xr=b,e.$yr=c,e.$zr=I,e.$Ar=D,e.$Br=u,e.$Cr=P,e.$Dr=w,e.$Er=a,e.$Fr=$,e.$Gr=m,e.$Hr=E,e.$Ir=S;const C=new r.$T(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),T=new r.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),L=new r.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function R(y,k,A=!1){const p=y||"",v=k||"",F=C.value.collator.compare(p,v);return C.value.collatorIsNumeric&&F===0&&p!==v?p<v?-1:1:F}function b(y,k){const A=T.value.collator;return y=y||"",k=k||"",o(A,y,k)}function c(y,k){const A=T.value.collator;return y=y||"",k=k||"",d(y,k)||o(A,y,k)}function I(y,k){const A=T.value.collator;return y=y||"",k=k||"",n(y,k)||o(A,y,k)}function D(y,k){return y=y||"",k=k||"",y===k?0:y<k?-1:1}function u(y,k){const[A,p]=g(y),[v,F]=g(k);let N=C.value.collator.compare(p,F);if(N===0){if(C.value.collatorIsNumeric&&p!==F)return p<F?-1:1;if(N=C.value.collator.compare(A,v),C.value.collatorIsNumeric&&N===0&&A!==v)return A<v?-1:1}return N}function P(y,k){y=y||"",k=k||"";const A=i(y),p=i(k),v=T.value.collator,F=L.value.collator;return o(F,A,p)||o(v,y,k)}function w(y,k){y=y||"",k=k||"";const A=i(y),p=i(k),v=T.value.collator,F=L.value.collator;return o(F,A,p)||d(y,k)||o(v,y,k)}function a(y,k){y=y||"",k=k||"";const A=i(y),p=i(k),v=T.value.collator,F=L.value.collator;return o(F,A,p)||n(y,k)||o(v,y,k)}function $(y,k){y=y||"",k=k||"";const A=i(y).toLowerCase(),p=i(k).toLowerCase();return A!==p?A<p?-1:1:y!==k?y<k?-1:1:0}const f=/^(.*?)(\.([^.]*))?$/;function g(y,k=!1){const A=y?f.exec(y):[];let p=[A&&A[1]||"",A&&A[3]||""];return k&&(!p[0]&&p[1]||p[0]&&p[0].charAt(0)===".")&&(p=[p[0]+"."+p[1],""]),p}function i(y){const k=y?f.exec(y):[];return k&&k[1]&&k[1].charAt(0)!=="."&&k[3]||""}function o(y,k,A){const p=y.compare(k,A);return p!==0?p:k.length!==A.length?k.length<A.length?-1:1:0}function t(y){const k=y.charAt(0);return k.toLocaleUpperCase()!==k}function s(y){const k=y.charAt(0);return k.toLocaleLowerCase()!==k}function n(y,k){return t(y)&&s(k)?-1:s(y)&&t(k)?1:0}function d(y,k){return s(y)&&t(k)?-1:t(y)&&s(k)?1:0}function l(y,k,A=!1){return A||(y=y&&y.toLowerCase(),k=k&&k.toLowerCase()),y===k?0:y<k?-1:1}function m(y,k,A=!1){const p=y.split(h.sep),v=k.split(h.sep),F=p.length-1,N=v.length-1;let O,j;for(let z=0;;z++){if(O=F===z,j=N===z,O&&j)return R(p[z],v[z],A);if(O)return-1;if(j)return 1;const M=l(p[z],v[z],A);if(M!==0)return M}}function E(y,k,A){const p=y.toLowerCase(),v=k.toLowerCase(),F=S(y,k,A);if(F)return F;const N=p.endsWith(A),O=v.endsWith(A);if(N!==O)return N?-1:1;const j=R(p,v);return j!==0?j:p.localeCompare(v)}function S(y,k,A){const p=y.toLowerCase(),v=k.toLowerCase(),F=p.startsWith(A),N=v.startsWith(A);if(F!==N)return F?-1:1;if(F&&N){if(p.length<v.length)return-1;if(p.length>v.length)return 1}return 0}}),define(ke[103],Ie([1,0,16]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7s=void 0,e.$8s=T,e.$9s=L,e.$0s=R,e.$$s=c,e.$7s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const h={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(I){const D=(0,r.$nc)(I),u=h[D.toLowerCase()];return u!==void 0?u:L(I)}function L(I){const D=(0,r.$nc)(I);return C[D.toLowerCase()]}function R(I){for(const D in C)if(C[D]===I)return D}const b=/^(.+)\/(.+?)(;.+)?$/;function c(I,D){const u=b.exec(I);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:D?void 0:I}}),define(ke[104],Ie([1,0,10]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$hm=T,e.$im=L;var h;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(h||(e.Source=h={}));var C;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(C||(e.TerminateResponseCode=C={}));function T(R,...b){const c=b.reduce((u,P)=>(u[P]=!0,u),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(u=>!c[u]).forEach(u=>{for(let P=0;P<I.length;P++)if(u.search(I[P])!==-1){delete R[u];break}})}function L(R){R&&(delete R.DEBUG,r.$k&&delete R.DYLD_LIBRARY_PATH,r.$l&&delete R.LD_PRELOAD)}}),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var r=e();for(var h in r)(typeof exports=="object"?exports:me)[h]=r[h]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function r(h){if(e[h])return e[h].exports;var C=e[h]={i:h,l:!1,exports:{}};return me[h].call(C.exports,C,C.exports,r),C.l=!0,C.exports}return r.m=me,r.c=e,r.d=function(h,C,T){r.o(h,C)||Object.defineProperty(h,C,{enumerable:!0,get:T})},r.r=function(h){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(h,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(h,"__esModule",{value:!0})},r.t=function(h,C){if(1&C&&(h=r(h)),8&C||4&C&&typeof h=="object"&&h&&h.__esModule)return h;var T=Object.create(null);if(r.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:h}),2&C&&typeof h!="string")for(var L in h)r.d(T,L,function(R){return h[R]}.bind(null,L));return T},r.n=function(h){var C=h&&h.__esModule?function(){return h.default}:function(){return h};return r.d(C,"a",C),C},r.o=function(h,C){return Object.prototype.hasOwnProperty.call(h,C)},r.p="",r(r.s=0)}([function(me,e,r){(function(h){var C;e=me.exports=ye,C=typeof h=="object"&&h.env&&h.env.NODE_DEBUG&&/\bsemver\b/i.test(h.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],b=e.src=[],c=0,I=c++;b[I]="0|[1-9]\\d*";var D=c++;b[D]="[0-9]+";var u=c++;b[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var P=c++;b[P]="("+b[I]+")\\.("+b[I]+")\\.("+b[I]+")";var w=c++;b[w]="("+b[D]+")\\.("+b[D]+")\\.("+b[D]+")";var a=c++;b[a]="(?:"+b[I]+"|"+b[u]+")";var $=c++;b[$]="(?:"+b[D]+"|"+b[u]+")";var f=c++;b[f]="(?:-("+b[a]+"(?:\\."+b[a]+")*))";var g=c++;b[g]="(?:-?("+b[$]+"(?:\\."+b[$]+")*))";var i=c++;b[i]="[0-9A-Za-z-]+";var o=c++;b[o]="(?:\\+("+b[i]+"(?:\\."+b[i]+")*))";var t=c++,s="v?"+b[P]+b[f]+"?"+b[o]+"?";b[t]="^"+s+"$";var n="[v=\\s]*"+b[w]+b[g]+"?"+b[o]+"?",d=c++;b[d]="^"+n+"$";var l=c++;b[l]="((?:<|>)?=?)";var m=c++;b[m]=b[D]+"|x|X|\\*";var E=c++;b[E]=b[I]+"|x|X|\\*";var S=c++;b[S]="[v=\\s]*("+b[E]+")(?:\\.("+b[E]+")(?:\\.("+b[E]+")(?:"+b[f]+")?"+b[o]+"?)?)?";var y=c++;b[y]="[v=\\s]*("+b[m]+")(?:\\.("+b[m]+")(?:\\.("+b[m]+")(?:"+b[g]+")?"+b[o]+"?)?)?";var k=c++;b[k]="^"+b[l]+"\\s*"+b[S]+"$";var A=c++;b[A]="^"+b[l]+"\\s*"+b[y]+"$";var p=c++;b[p]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var v=c++;b[v]="(?:~>?)";var F=c++;b[F]="(\\s*)"+b[v]+"\\s+",R[F]=new RegExp(b[F],"g");var N=c++;b[N]="^"+b[v]+b[S]+"$";var O=c++;b[O]="^"+b[v]+b[y]+"$";var j=c++;b[j]="(?:\\^)";var z=c++;b[z]="(\\s*)"+b[j]+"\\s+",R[z]=new RegExp(b[z],"g");var M=c++;b[M]="^"+b[j]+b[S]+"$";var V=c++;b[V]="^"+b[j]+b[y]+"$";var K=c++;b[K]="^"+b[l]+"\\s*("+n+")$|^$";var ne=c++;b[ne]="^"+b[l]+"\\s*("+s+")$|^$";var B=c++;b[B]="(\\s*)"+b[l]+"\\s*("+n+"|"+b[S]+")",R[B]=new RegExp(b[B],"g");var G=c++;b[G]="^\\s*("+b[S]+")\\s+-\\s+("+b[S]+")\\s*$";var Y=c++;b[Y]="^\\s*("+b[y]+")\\s+-\\s+("+b[y]+")\\s*$";var ee=c++;b[ee]="(<|>)?=?\\s*\\*";for(var ue=0;ue<35;ue++)C(ue,b[ue]),R[ue]||(R[ue]=new RegExp(b[ue]));function re(q,X){if(q instanceof ye)return q;if(typeof q!="string"||q.length>T||!(X?R[d]:R[t]).test(q))return null;try{return new ye(q,X)}catch{return null}}function ye(q,X){if(q instanceof ye){if(q.loose===X)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof ye))return new ye(q,X);C("SemVer",q,X),this.loose=X;var _=q.trim().match(X?R[d]:R[t]);if(!_)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+_[1],this.minor=+_[2],this.patch=+_[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");_[4]?this.prerelease=_[4].split(".").map(function(de){if(/^[0-9]+$/.test(de)){var be=+de;if(be>=0&&be<L)return be}return de}):this.prerelease=[],this.build=_[5]?_[5].split("."):[],this.format()}e.parse=re,e.valid=function(q,X){var _=re(q,X);return _?_.version:null},e.clean=function(q,X){var _=re(q.trim().replace(/^[=v]+/,""),X);return _?_.version:null},e.SemVer=ye,ye.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ye.prototype.toString=function(){return this.version},ye.prototype.compare=function(q){return C("SemVer.compare",this.version,this.loose,q),q instanceof ye||(q=new ye(q,this.loose)),this.compareMain(q)||this.comparePre(q)},ye.prototype.compareMain=function(q){return q instanceof ye||(q=new ye(q,this.loose)),J(this.major,q.major)||J(this.minor,q.minor)||J(this.patch,q.patch)},ye.prototype.comparePre=function(q){if(q instanceof ye||(q=new ye(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var X=0;do{var _=this.prerelease[X],de=q.prerelease[X];if(C("prerelease compare",X,_,de),_===void 0&&de===void 0)return 0;if(de===void 0)return 1;if(_===void 0)return-1;if(_!==de)return J(_,de)}while(++X)},ye.prototype.inc=function(q,X){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",X);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",X);break;case"prepatch":this.prerelease.length=0,this.inc("patch",X),this.inc("pre",X);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",X),this.inc("pre",X);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var _=this.prerelease.length;--_>=0;)typeof this.prerelease[_]=="number"&&(this.prerelease[_]++,_=-2);_===-1&&this.prerelease.push(0)}X&&(this.prerelease[0]===X?isNaN(this.prerelease[1])&&(this.prerelease=[X,0]):this.prerelease=[X,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,X,_,de){typeof _=="string"&&(de=_,_=void 0);try{return new ye(q,_).inc(X,de).version}catch{return null}},e.diff=function(q,X){if(te(q,X))return null;var _=re(q),de=re(X);if(_.prerelease.length||de.prerelease.length){for(var be in _)if((be==="major"||be==="minor"||be==="patch")&&_[be]!==de[be])return"pre"+be;return"prerelease"}for(var be in _)if((be==="major"||be==="minor"||be==="patch")&&_[be]!==de[be])return be},e.compareIdentifiers=J;var $e=/^[0-9]+$/;function J(q,X){var _=$e.test(q),de=$e.test(X);return _&&de&&(q=+q,X=+X),_&&!de?-1:de&&!_?1:q<X?-1:q>X?1:0}function W(q,X,_){return new ye(q,_).compare(new ye(X,_))}function se(q,X,_){return W(q,X,_)>0}function ae(q,X,_){return W(q,X,_)<0}function te(q,X,_){return W(q,X,_)===0}function ce(q,X,_){return W(q,X,_)!==0}function le(q,X,_){return W(q,X,_)>=0}function Z(q,X,_){return W(q,X,_)<=0}function oe(q,X,_,de){var be;switch(X){case"===":typeof q=="object"&&(q=q.version),typeof _=="object"&&(_=_.version),be=q===_;break;case"!==":typeof q=="object"&&(q=q.version),typeof _=="object"&&(_=_.version),be=q!==_;break;case"":case"=":case"==":be=te(q,_,de);break;case"!=":be=ce(q,_,de);break;case">":be=se(q,_,de);break;case">=":be=le(q,_,de);break;case"<":be=ae(q,_,de);break;case"<=":be=Z(q,_,de);break;default:throw new TypeError("Invalid operator: "+X)}return be}function pe(q,X){if(q instanceof pe){if(q.loose===X)return q;q=q.value}if(!(this instanceof pe))return new pe(q,X);C("comparator",q,X),this.loose=X,this.parse(q),this.semver===we?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(q,X){return J(X,q)},e.major=function(q,X){return new ye(q,X).major},e.minor=function(q,X){return new ye(q,X).minor},e.patch=function(q,X){return new ye(q,X).patch},e.compare=W,e.compareLoose=function(q,X){return W(q,X,!0)},e.rcompare=function(q,X,_){return W(X,q,_)},e.sort=function(q,X){return q.sort(function(_,de){return e.compare(_,de,X)})},e.rsort=function(q,X){return q.sort(function(_,de){return e.rcompare(_,de,X)})},e.gt=se,e.lt=ae,e.eq=te,e.neq=ce,e.gte=le,e.lte=Z,e.cmp=oe,e.Comparator=pe;var we={};function Fe(q,X){if(q instanceof Fe)return q.loose===X?q:new Fe(q.raw,X);if(q instanceof pe)return new Fe(q.value,X);if(!(this instanceof Fe))return new Fe(q,X);if(this.loose=X,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(_){return this.parseRange(_.trim())},this).filter(function(_){return _.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function We(q){return!q||q.toLowerCase()==="x"||q==="*"}function Se(q,X,_,de,be,Ne,Ge,Ke,tt,rt,ot,nt,at){return((X=We(_)?"":We(de)?">="+_+".0.0":We(be)?">="+_+"."+de+".0":">="+X)+" "+(Ke=We(tt)?"":We(rt)?"<"+(+tt+1)+".0.0":We(ot)?"<"+tt+"."+(+rt+1)+".0":nt?"<="+tt+"."+rt+"."+ot+"-"+nt:"<="+Ke)).trim()}function De(q,X){for(var _=0;_<q.length;_++)if(!q[_].test(X))return!1;if(X.prerelease.length){for(_=0;_<q.length;_++)if(C(q[_].semver),q[_].semver!==we&&q[_].semver.prerelease.length>0){var de=q[_].semver;if(de.major===X.major&&de.minor===X.minor&&de.patch===X.patch)return!0}return!1}return!0}function Te(q,X,_){try{X=new Fe(X,_)}catch{return!1}return X.test(q)}function U(q,X,_,de){var be,Ne,Ge,Ke,tt;switch(q=new ye(q,de),X=new Fe(X,de),_){case">":be=se,Ne=Z,Ge=ae,Ke=">",tt=">=";break;case"<":be=ae,Ne=le,Ge=se,Ke="<",tt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Te(q,X,de))return!1;for(var rt=0;rt<X.set.length;++rt){var ot=X.set[rt],nt=null,at=null;if(ot.forEach(function(mt){mt.semver===we&&(mt=new pe(">=0.0.0")),nt=nt||mt,at=at||mt,be(mt.semver,nt.semver,de)?nt=mt:Ge(mt.semver,at.semver,de)&&(at=mt)}),nt.operator===Ke||nt.operator===tt||(!at.operator||at.operator===Ke)&&Ne(q,at.semver)||at.operator===tt&&Ge(q,at.semver))return!1}return!0}pe.prototype.parse=function(q){var X=this.loose?R[K]:R[ne],_=q.match(X);if(!_)throw new TypeError("Invalid comparator: "+q);this.operator=_[1],this.operator==="="&&(this.operator=""),_[2]?this.semver=new ye(_[2],this.loose):this.semver=we},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(q){return C("Comparator.test",q,this.loose),this.semver===we||(typeof q=="string"&&(q=new ye(q,this.loose)),oe(q,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(q,X){if(!(q instanceof pe))throw new TypeError("a Comparator is required");var _;if(this.operator==="")return _=new Fe(q.value,X),Te(this.value,_,X);if(q.operator==="")return _=new Fe(this.value,X),Te(q.semver,_,X);var de=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),be=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),Ne=this.semver.version===q.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),Ke=oe(this.semver,"<",q.semver,X)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),tt=oe(this.semver,">",q.semver,X)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return de||be||Ne&&Ge||Ke||tt},e.Range=Fe,Fe.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},Fe.prototype.toString=function(){return this.range},Fe.prototype.parseRange=function(q){var X=this.loose;q=q.trim(),C("range",q,X);var _=X?R[Y]:R[G];q=q.replace(_,Se),C("hyphen replace",q),q=q.replace(R[B],"$1$2$3"),C("comparator trim",q,R[B]),q=(q=(q=q.replace(R[F],"$1~")).replace(R[z],"$1^")).split(/\s+/).join(" ");var de=X?R[K]:R[ne],be=q.split(" ").map(function(Ne){return function(Ge,Ke){return C("comp",Ge),Ge=function(tt,rt){return tt.trim().split(/\s+/).map(function(ot){return function(nt,at){C("caret",nt,at);var mt=at?R[V]:R[M];return nt.replace(mt,function(ht,ct,Pe,ze,He){var Oe;return C("caret",nt,ht,ct,Pe,ze,He),We(ct)?Oe="":We(Pe)?Oe=">="+ct+".0.0 <"+(+ct+1)+".0.0":We(ze)?Oe=ct==="0"?">="+ct+"."+Pe+".0 <"+ct+"."+(+Pe+1)+".0":">="+ct+"."+Pe+".0 <"+(+ct+1)+".0.0":He?(C("replaceCaret pr",He),He.charAt(0)!=="-"&&(He="-"+He),Oe=ct==="0"?Pe==="0"?">="+ct+"."+Pe+"."+ze+He+" <"+ct+"."+Pe+"."+(+ze+1):">="+ct+"."+Pe+"."+ze+He+" <"+ct+"."+(+Pe+1)+".0":">="+ct+"."+Pe+"."+ze+He+" <"+(+ct+1)+".0.0"):(C("no pr"),Oe=ct==="0"?Pe==="0"?">="+ct+"."+Pe+"."+ze+" <"+ct+"."+Pe+"."+(+ze+1):">="+ct+"."+Pe+"."+ze+" <"+ct+"."+(+Pe+1)+".0":">="+ct+"."+Pe+"."+ze+" <"+(+ct+1)+".0.0"),C("caret return",Oe),Oe})}(ot,rt)}).join(" ")}(Ge,Ke),C("caret",Ge),Ge=function(tt,rt){return tt.trim().split(/\s+/).map(function(ot){return function(nt,at){var mt=at?R[O]:R[N];return nt.replace(mt,function(ht,ct,Pe,ze,He){var Oe;return C("tilde",nt,ht,ct,Pe,ze,He),We(ct)?Oe="":We(Pe)?Oe=">="+ct+".0.0 <"+(+ct+1)+".0.0":We(ze)?Oe=">="+ct+"."+Pe+".0 <"+ct+"."+(+Pe+1)+".0":He?(C("replaceTilde pr",He),He.charAt(0)!=="-"&&(He="-"+He),Oe=">="+ct+"."+Pe+"."+ze+He+" <"+ct+"."+(+Pe+1)+".0"):Oe=">="+ct+"."+Pe+"."+ze+" <"+ct+"."+(+Pe+1)+".0",C("tilde return",Oe),Oe})}(ot,rt)}).join(" ")}(Ge,Ke),C("tildes",Ge),Ge=function(tt,rt){return C("replaceXRanges",tt,rt),tt.split(/\s+/).map(function(ot){return function(nt,at){nt=nt.trim();var mt=at?R[A]:R[k];return nt.replace(mt,function(ht,ct,Pe,ze,He,Oe){C("xRange",nt,ht,ct,Pe,ze,He,Oe);var je=We(Pe),he=je||We(ze),x=he||We(He);return ct==="="&&x&&(ct=""),je?ht=ct===">"||ct==="<"?"<0.0.0":"*":ct&&x?(he&&(ze=0),x&&(He=0),ct===">"?(ct=">=",he?(Pe=+Pe+1,ze=0,He=0):x&&(ze=+ze+1,He=0)):ct==="<="&&(ct="<",he?Pe=+Pe+1:ze=+ze+1),ht=ct+Pe+"."+ze+"."+He):he?ht=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":x&&(ht=">="+Pe+"."+ze+".0 <"+Pe+"."+(+ze+1)+".0"),C("xRange return",ht),ht})}(ot,rt)}).join(" ")}(Ge,Ke),C("xrange",Ge),Ge=function(tt,rt){return C("replaceStars",tt,rt),tt.trim().replace(R[ee],"")}(Ge,Ke),C("stars",Ge),Ge}(Ne,X)}).join(" ").split(/\s+/);return this.loose&&(be=be.filter(function(Ne){return!!Ne.match(de)})),be=be.map(function(Ne){return new pe(Ne,X)})},Fe.prototype.intersects=function(q,X){if(!(q instanceof Fe))throw new TypeError("a Range is required");return this.set.some(function(_){return _.every(function(de){return q.set.some(function(be){return be.every(function(Ne){return de.intersects(Ne,X)})})})})},e.toComparators=function(q,X){return new Fe(q,X).set.map(function(_){return _.map(function(de){return de.value}).join(" ").trim().split(" ")})},Fe.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new ye(q,this.loose));for(var X=0;X<this.set.length;X++)if(De(this.set[X],q))return!0;return!1},e.satisfies=Te,e.maxSatisfying=function(q,X,_){var de=null,be=null;try{var Ne=new Fe(X,_)}catch{return null}return q.forEach(function(Ge){Ne.test(Ge)&&(de&&be.compare(Ge)!==-1||(be=new ye(de=Ge,_)))}),de},e.minSatisfying=function(q,X,_){var de=null,be=null;try{var Ne=new Fe(X,_)}catch{return null}return q.forEach(function(Ge){Ne.test(Ge)&&(de&&be.compare(Ge)!==1||(be=new ye(de=Ge,_)))}),de},e.validRange=function(q,X){try{return new Fe(q,X).range||"*"}catch{return null}},e.ltr=function(q,X,_){return U(q,X,"<",_)},e.gtr=function(q,X,_){return U(q,X,">",_)},e.outside=U,e.prerelease=function(q,X){var _=re(q,X);return _&&_.prerelease.length?_.prerelease:null},e.intersects=function(q,X,_){return q=new Fe(q,_),X=new Fe(X,_),q.intersects(X)},e.coerce=function(q){if(q instanceof ye)return q;if(typeof q!="string")return null;var X=q.match(R[p]);return X==null?null:re((X[1]||"0")+"."+(X[2]||"0")+"."+(X[3]||"0"))}}).call(this,r(1))},function(me,e){var r,h,C=me.exports={};function T(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function R($){if(r===setTimeout)return setTimeout($,0);if((r===T||!r)&&setTimeout)return r=setTimeout,setTimeout($,0);try{return r($,0)}catch{try{return r.call(null,$,0)}catch{return r.call(this,$,0)}}}(function(){try{r=typeof setTimeout=="function"?setTimeout:T}catch{r=T}try{h=typeof clearTimeout=="function"?clearTimeout:L}catch{h=L}})();var b,c=[],I=!1,D=-1;function u(){I&&b&&(I=!1,b.length?c=b.concat(c):D=-1,c.length&&P())}function P(){if(!I){var $=R(u);I=!0;for(var f=c.length;f;){for(b=c,c=[];++D<f;)b&&b[D].run();D=-1,f=c.length}b=null,I=!1,function(g){if(h===clearTimeout)return clearTimeout(g);if((h===L||!h)&&clearTimeout)return h=clearTimeout,clearTimeout(g);try{h(g)}catch{try{return h.call(null,g)}catch{return h.call(this,g)}}}($)}}function w($,f){this.fun=$,this.array=f}function a(){}C.nextTick=function($){var f=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)f[g-1]=arguments[g];c.push(new w($,f)),c.length!==1||I||R(P)},w.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=a,C.addListener=a,C.once=a,C.off=a,C.removeListener=a,C.removeAllListeners=a,C.emit=a,C.prependListener=a,C.prependOnceListener=a,C.listeners=function($){return[]},C.binding=function($){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function($){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(ke[42],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=void 0;const r=globalThis.performance&&typeof globalThis.performance.now=="function";class h{static create(T){return new h(T)}constructor(T){this.c=r&&T===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$de=h}),define(ke[4],Ie([1,0,13,79,3,80,42]),function(me,e,r,h,C,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$fe=e.Event=void 0,e.$ge=P;const R=!1,b=!1,c=!1;var I;(function(O){O.None=()=>C.$Tc.None;function j(Se){if(c){const{onDidAddListener:De}=Se,Te=a.create();let U=0;Se.onDidAddListener=()=>{++U===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Te.print()),De?.()}}}function z(Se,De){return re(Se,()=>{},0,void 0,!0,void 0,De)}O.defer=z;function M(Se){return(De,Te=null,U)=>{let q=!1,X;return X=Se(_=>{if(!q)return X?X.dispose():q=!0,De.call(Te,_)},null,U),q&&X.dispose(),X}}O.once=M;function V(Se,De,Te){return ee((U,q=null,X)=>Se(_=>U.call(q,De(_)),null,X),Te)}O.map=V;function K(Se,De,Te){return ee((U,q=null,X)=>Se(_=>{De(_),U.call(q,_)},null,X),Te)}O.forEach=K;function ne(Se,De,Te){return ee((U,q=null,X)=>Se(_=>De(_)&&U.call(q,_),null,X),Te)}O.filter=ne;function B(Se){return Se}O.signal=B;function G(...Se){return(De,Te=null,U)=>{const q=(0,C.$Qc)(...Se.map(X=>X(_=>De.call(Te,_))));return ue(q,U)}}O.any=G;function Y(Se,De,Te,U){let q=Te;return V(Se,X=>(q=De(q,X),q),U)}O.reduce=Y;function ee(Se,De){let Te;const U={onWillAddFirstListener(){Te=Se(q.fire,q)},onDidRemoveLastListener(){Te?.dispose()}};De||j(U);const q=new n(U);return De?.add(q),q.event}function ue(Se,De){return De instanceof Array?De.push(Se):De&&De.add(Se),Se}function re(Se,De,Te=100,U=!1,q=!1,X,_){let de,be,Ne,Ge=0,Ke;const tt={leakWarningThreshold:X,onWillAddFirstListener(){de=Se(ot=>{Ge++,be=De(be,ot),U&&!Ne&&(rt.fire(be),be=void 0),Ke=()=>{const nt=be;be=void 0,Ne=void 0,(!U||Ge>1)&&rt.fire(nt),Ge=0},typeof Te=="number"?(clearTimeout(Ne),Ne=setTimeout(Ke,Te)):Ne===void 0&&(Ne=0,queueMicrotask(Ke))})},onWillRemoveListener(){q&&Ge>0&&Ke?.()},onDidRemoveLastListener(){Ke=void 0,de.dispose()}};_||j(tt);const rt=new n(tt);return _?.add(rt),rt.event}O.debounce=re;function ye(Se,De=0,Te){return O.debounce(Se,(U,q)=>U?(U.push(q),U):[q],De,void 0,!0,void 0,Te)}O.accumulate=ye;function $e(Se,De=(U,q)=>U===q,Te){let U=!0,q;return ne(Se,X=>{const _=U||!De(X,q);return U=!1,q=X,_},Te)}O.latch=$e;function J(Se,De,Te){return[O.filter(Se,De,Te),O.filter(Se,U=>!De(U),Te)]}O.split=J;function W(Se,De=!1,Te=[],U){let q=Te.slice(),X=Se(be=>{q?q.push(be):de.fire(be)});U&&U.add(X);const _=()=>{q?.forEach(be=>de.fire(be)),q=null},de=new n({onWillAddFirstListener(){X||(X=Se(be=>de.fire(be)),U&&U.add(X))},onDidAddFirstListener(){q&&(De?setTimeout(_):_())},onDidRemoveLastListener(){X&&X.dispose(),X=null}});return U&&U.add(de),de.event}O.buffer=W;function se(Se,De){return(U,q,X)=>{const _=De(new te);return Se(function(de){const be=_.evaluate(de);be!==ae&&U.call(q,be)},void 0,X)}}O.chain=se;const ae=Symbol("HaltChainable");class te{constructor(){this.f=[]}map(De){return this.f.push(De),this}forEach(De){return this.f.push(Te=>(De(Te),Te)),this}filter(De){return this.f.push(Te=>De(Te)?Te:ae),this}reduce(De,Te){let U=Te;return this.f.push(q=>(U=De(U,q),U)),this}latch(De=(Te,U)=>Te===U){let Te=!0,U;return this.f.push(q=>{const X=Te||!De(q,U);return Te=!1,U=q,X?q:ae}),this}evaluate(De){for(const Te of this.f)if(De=Te(De),De===ae)break;return De}}function ce(Se,De,Te=U=>U){const U=(...de)=>_.fire(Te(...de)),q=()=>Se.on(De,U),X=()=>Se.removeListener(De,U),_=new n({onWillAddFirstListener:q,onDidRemoveLastListener:X});return _.event}O.fromNodeEventEmitter=ce;function le(Se,De,Te=U=>U){const U=(...de)=>_.fire(Te(...de)),q=()=>Se.addEventListener(De,U),X=()=>Se.removeEventListener(De,U),_=new n({onWillAddFirstListener:q,onDidRemoveLastListener:X});return _.event}O.fromDOMEventEmitter=le;function Z(Se){return new Promise(De=>M(Se)(De))}O.toPromise=Z;function oe(Se){const De=new n;return Se.then(Te=>{De.fire(Te)},()=>{De.fire(void 0)}).finally(()=>{De.dispose()}),De.event}O.fromPromise=oe;function pe(Se,De,Te){return De(Te),Se(U=>De(U))}O.runAndSubscribe=pe;class we{constructor(De,Te){this._observable=De,this.f=0,this.g=!1;const U={onWillAddFirstListener:()=>{De.addObserver(this)},onDidRemoveLastListener:()=>{De.removeObserver(this)}};Te||j(U),this.emitter=new n(U),Te&&Te.add(this.emitter)}beginUpdate(De){this.f++}handlePossibleChange(De){}handleChange(De,Te){this.g=!0}endUpdate(De){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Fe(Se,De){return new we(Se,De).emitter.event}O.fromObservable=Fe;function We(Se){return(De,Te,U)=>{let q=0,X=!1;const _={beginUpdate(){q++},endUpdate(){q--,q===0&&(Se.reportChanges(),X&&(X=!1,De.call(Te)))},handlePossibleChange(){},handleChange(){X=!0}};Se.addObserver(_),Se.reportChanges();const de={dispose(){Se.removeObserver(_)}};return U instanceof C.$Sc?U.add(de):Array.isArray(U)&&U.push(de),de}}O.fromObservableLight=We})(I||(e.Event=I={}));class D{static{this.all=new Set}static{this.f=0}constructor(j){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${j}_${D.f++}`,D.all.add(this)}start(j){this.g=new L.$de,this.listenerCount=j}stop(){if(this.g){const j=this.g.elapsed();this.durations.push(j),this.elapsedOverall+=j,this.invocationCount+=1,this.g=void 0}}}e.$fe=D;let u=-1;function P(O){const j=u;return u=O,{dispose(){u=j}}}class w{static{this.f=1}constructor(j,z,M=(w.f++).toString(16).padStart(3,"0")){this.j=j,this.threshold=z,this.name=M,this.h=0}dispose(){this.g?.clear()}check(j,z){const M=this.threshold;if(M<=0||z<M)return;this.g||(this.g=new Map);const V=this.g.get(j.value)||0;if(this.g.set(j.value,V+1),this.h-=1,this.h<=0){this.h=M*.5;const[K,ne]=this.getMostFrequentStack(),B=`[${this.name}] potential listener LEAK detected, having ${z} listeners already. MOST frequent listener (${ne}):`;console.warn(B),console.warn(K);const G=new $(B,K);this.j(G)}return()=>{const K=this.g.get(j.value)||0;this.g.set(j.value,K-1)}}getMostFrequentStack(){if(!this.g)return;let j,z=0;for(const[M,V]of this.g)(!j||z<V)&&(j=[M,V],z=V);return j}}class a{static create(){const j=new Error;return new a(j.stack??"")}constructor(j){this.value=j}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class $ extends Error{constructor(j,z){super(j),this.name="ListenerLeakError",this.stack=z}}e.$he=$;class f extends Error{constructor(j,z){super(j),this.name="ListenerRefusalError",this.stack=z}}e.$ie=f;let g=0;class i{constructor(j){this.value=j,this.id=g++}}const o=2,t=(O,j)=>{if(O instanceof i)j(O);else for(let z=0;z<O.length;z++){const M=O[z];M&&j(M)}};let s;if(R){const O=[];setInterval(()=>{O.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(O.join(`
`)),O.length=0)},3e3),s=new FinalizationRegistry(j=>{typeof j=="string"&&O.push(j)})}class n{constructor(j){this.z=0,this.f=j,this.g=u>0||this.f?.leakWarningThreshold?new w(j?.onListenerError??r.$Y,this.f?.leakWarningThreshold??u):void 0,this.j=this.f?._profName?new D(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(b){const j=this.u;queueMicrotask(()=>{t(j,z=>z.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(j,z,M)=>{if(this.g&&this.z>this.g.threshold**2){const G=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(G);const Y=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ee=new f(`${G}. HINT: Stack shows most frequent listener (${Y[1]}-times)`,Y[0]);return(this.f?.onListenerError||r.$Y)(ee),C.$Tc.None}if(this.m)return C.$Tc.None;z&&(j=j.bind(z));const V=new i(j);let K,ne;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(V.stack=a.create(),K=this.g.check(V.stack,this.z+1)),b&&(V.stack=ne??a.create()),this.u?this.u instanceof i?(this.w??=new l,this.u=[this.u,V]):this.u.push(V):(this.f?.onWillAddFirstListener?.(this),this.u=V,this.f?.onDidAddFirstListener?.(this)),this.z++;const B=(0,C.$Rc)(()=>{s?.unregister(B),K?.(),this.A(V)});if(M instanceof C.$Sc?M.add(B):Array.isArray(M)&&M.push(B),s){const G=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),Y=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(G);s.register(B,Y?.[2]??G,B)}return B},this.q}A(j){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const z=this.u,M=z.indexOf(j);if(M===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,z[M]=void 0;const V=this.w.current===this;if(this.z*o<=z.length){let K=0;for(let ne=0;ne<z.length;ne++)z[ne]?z[K++]=z[ne]:V&&(this.w.end--,K<this.w.i&&this.w.i--);z.length=K}}B(j,z){if(!j)return;const M=this.f?.onListenerError||r.$Y;if(!M){j.value(z);return}try{j.value(z)}catch(V){M(V)}}C(j){const z=j.current.u;for(;j.i<j.end;)this.B(z[j.i++],j.value);j.reset()}fire(j){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof i)this.B(this.u,j);else{const z=this.w;z.enqueue(this,j,this.u.length),this.C(z)}this.j?.stop()}hasListeners(){return this.z>0}}e.$je=n;const d=()=>new l;e.$ke=d;class l{constructor(){this.i=-1,this.end=0}enqueue(j,z,M){this.i=0,this.end=M,this.current=j,this.value=z}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class m extends n{async fireAsync(j,z,M){if(this.u)for(this.h||(this.h=new T.$4c),t(this.u,V=>this.h.push([V.value,j]));this.h.size>0&&!z.isCancellationRequested;){const[V,K]=this.h.shift(),ne=[],B={...K,token:z,waitUntil:G=>{if(Object.isFrozen(ne))throw new Error("waitUntil can NOT be called asynchronous");M&&(G=M(G,V)),ne.push(G)}};try{V(B)}catch(G){(0,r.$Y)(G);continue}Object.freeze(ne),await Promise.allSettled(ne).then(G=>{for(const Y of G)Y.status==="rejected"&&(0,r.$Y)(Y.reason)})}}}e.$le=m;class E extends n{get isPaused(){return this.h!==0}constructor(j){super(j),this.h=0,this.s=new T.$4c,this.t=j?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const j=Array.from(this.s);this.s.clear(),super.fire(this.t(j))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(j){this.z&&(this.h!==0?this.s.push(j):super.fire(j))}}e.$me=E;class S extends E{constructor(j){super(j),this.k=j.delay??100}fire(j){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(j)}}e.$ne=S;class y extends n{constructor(j){super(j),this.h=[],this.k=j?.merge}fire(j){this.hasListeners()&&(this.h.push(j),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(z=>super.fire(z)),this.h=[]}))}}e.$oe=y;class k{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(j){const z={event:j,listener:null};this.h.push(z),this.g&&this.m(z);const M=()=>{this.g&&this.o(z);const V=this.h.indexOf(z);this.h.splice(V,1)};return(0,C.$Rc)((0,h.$cb)(M))}j(){this.g=!0,this.h.forEach(j=>this.m(j))}k(){this.g=!1,this.h.forEach(j=>this.o(j))}m(j){j.listener=j.event(z=>this.f.fire(z))}o(j){j.listener?.dispose(),j.listener=null}dispose(){this.f.dispose();for(const j of this.h)j.listener?.dispose();this.h=[]}}e.$pe=k;class A{constructor(j,z,M,V){this.f=new C.$Sc;const K=this.f.add(new k),ne=this.f.add(new C.$3c);function B(G){ne.set(G,K.add(V(G)))}for(const G of j)B(G);this.f.add(z(G=>{B(G)})),this.f.add(M(G=>{ne.deleteAndDispose(G)})),this.event=K.event}dispose(){this.f.dispose()}}e.$qe=A;class p{constructor(){this.f=[]}wrapEvent(j,z,M){return(V,K,ne)=>j(B=>{const G=this.f[this.f.length-1];if(!z){G?G.buffers.push(()=>V.call(K,B)):V.call(K,B);return}const Y=G;if(!Y){V.call(K,z(M,B));return}Y.items??=[],Y.items.push(B),Y.buffers.length===0&&G.buffers.push(()=>{Y.reducedResult??=M?Y.items.reduce(z,M):Y.items.reduce(z),V.call(K,Y.reducedResult)})},void 0,ne)}bufferEvents(j){const z={buffers:new Array};this.f.push(z);const M=j();return this.f.pop(),z.buffers.forEach(V=>V()),M}}e.$re=p;class v{constructor(){this.f=!1,this.g=I.None,this.h=C.$Tc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(j){this.g=j,this.f&&(this.h.dispose(),this.h=j(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$se=v;class F{static const(j){return new N(j)}constructor(j){this.g=j,this.f=new n,this.onDidChange=this.f.event}get value(){return this.g}set value(j){j!==this.g&&(this.g=j,this.f.fire(void 0))}}e.$te=F;class N{constructor(j){this.value=j,this.onDidChange=I.None}}}),define(ke[20],Ie([1,0,4]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=e.CancellationToken=void 0,e.$ve=R;const h=Object.freeze(function(b,c){const I=setTimeout(b.bind(c),0);return{dispose(){clearTimeout(I)}}});var C;(function(b){function c(I){return I===b.None||I===b.Cancelled||I instanceof T?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}b.isCancellationToken=c,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:r.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:h})})(C||(e.CancellationToken=C={}));class T{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?h:(this.b||(this.b=new r.$je),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor(c){this.f=void 0,this.g=void 0,this.g=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new T),this.f}cancel(){this.f?this.f instanceof T&&this.f.cancel():this.f=C.Cancelled}dispose(c=!1){c&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof T&&this.f.dispose():this.f=C.None}}e.$ue=L;function R(b){const c=new L;return b.add({dispose(){c.cancel()}}),c.token}}),define(ke[183],Ie([1,0,20]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0e=e.$9e=e.$7e=void 0,e.$8e=C;class h{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new r.$ue,c=this.b(b.token);return this.a={promise:c,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$7e=h;function C(R){return R}class T{constructor(b,c){this.a=void 0,this.b=void 0,typeof b=="function"?(this.c=b,this.d=C):(this.c=c,this.d=b.getCacheKey)}get(b){const c=this.d(b);return this.b!==c&&(this.b=c,this.a=this.c(b)),this.a}}e.$9e=T;class L{get cachedValues(){return this.a}constructor(b,c){this.a=new Map,this.b=new Map,typeof b=="function"?(this.c=b,this.d=C):(this.c=c,this.d=b.getCacheKey)}get(b){const c=this.d(b);if(this.b.has(c))return this.b.get(c);const I=this.c(b);return this.a.set(b,I),this.b.set(c,I),I}}e.$0e=L}),define(ke[184],Ie([1,0,4,3]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=e.$bt=e.$at=e.$_s=e.ScrollbarVisibility=void 0;var C;(function(P){P[P.Auto=1]="Auto",P[P.Hidden=2]="Hidden",P[P.Visible=3]="Visible"})(C||(e.ScrollbarVisibility=C={}));class T{constructor(w,a,$,f,g,i,o){this.c=w,this._scrollStateBrand=void 0,this.c&&(a=a|0,$=$|0,f=f|0,g=g|0,i=i|0,o=o|0),this.rawScrollLeft=f,this.rawScrollTop=o,a<0&&(a=0),f+a>$&&(f=$-a),f<0&&(f=0),g<0&&(g=0),o+g>i&&(o=i-g),o<0&&(o=0),this.width=a,this.scrollWidth=$,this.scrollLeft=f,this.height=g,this.scrollHeight=i,this.scrollTop=o}equals(w){return this.rawScrollLeft===w.rawScrollLeft&&this.rawScrollTop===w.rawScrollTop&&this.width===w.width&&this.scrollWidth===w.scrollWidth&&this.scrollLeft===w.scrollLeft&&this.height===w.height&&this.scrollHeight===w.scrollHeight&&this.scrollTop===w.scrollTop}withScrollDimensions(w,a){return new T(this.c,typeof w.width<"u"?w.width:this.width,typeof w.scrollWidth<"u"?w.scrollWidth:this.scrollWidth,a?this.rawScrollLeft:this.scrollLeft,typeof w.height<"u"?w.height:this.height,typeof w.scrollHeight<"u"?w.scrollHeight:this.scrollHeight,a?this.rawScrollTop:this.scrollTop)}withScrollPosition(w){return new T(this.c,this.width,this.scrollWidth,typeof w.scrollLeft<"u"?w.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof w.scrollTop<"u"?w.scrollTop:this.rawScrollTop)}createScrollEvent(w,a){const $=this.width!==w.width,f=this.scrollWidth!==w.scrollWidth,g=this.scrollLeft!==w.scrollLeft,i=this.height!==w.height,o=this.scrollHeight!==w.scrollHeight,t=this.scrollTop!==w.scrollTop;return{inSmoothScrolling:a,oldWidth:w.width,oldScrollWidth:w.scrollWidth,oldScrollLeft:w.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:w.height,oldScrollHeight:w.scrollHeight,oldScrollTop:w.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:$,scrollWidthChanged:f,scrollLeftChanged:g,heightChanged:i,scrollHeightChanged:o,scrollTopChanged:t}}}e.$_s=T;class L extends h.$Tc{constructor(w){super(),this._scrollableBrand=void 0,this.j=this.B(new r.$je),this.onScroll=this.j.event,this.c=w.smoothScrollDuration,this.f=w.scheduleAtNextAnimationFrame,this.g=new T(w.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(w){this.c=w}validateScrollPosition(w){return this.g.withScrollPosition(w)}getScrollDimensions(){return this.g}setScrollDimensions(w,a){const $=this.g.withScrollDimensions(w,a);this.n($,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(w){const a=this.g.withScrollPosition(w);this.h&&(this.h.dispose(),this.h=null),this.n(a,!1)}setScrollPositionSmooth(w,a){if(this.c===0)return this.setScrollPositionNow(w);if(this.h){w={scrollLeft:typeof w.scrollLeft>"u"?this.h.to.scrollLeft:w.scrollLeft,scrollTop:typeof w.scrollTop>"u"?this.h.to.scrollTop:w.scrollTop};const $=this.g.withScrollPosition(w);if(this.h.to.scrollLeft===$.scrollLeft&&this.h.to.scrollTop===$.scrollTop)return;let f;a?f=new I(this.h.from,$,this.h.startTime,this.h.duration):f=this.h.combine(this.g,$,this.c),this.h.dispose(),this.h=f}else{const $=this.g.withScrollPosition(w);this.h=I.start(this.g,$,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const w=this.h.tick(),a=this.g.withScrollPosition(w);if(this.n(a,!0),!!this.h){if(w.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(w,a){const $=this.g;$.equals(w)||(this.g=w,this.j.fire(this.g.createScrollEvent($,a)))}}e.$at=L;class R{constructor(w,a,$){this.scrollLeft=w,this.scrollTop=a,this.isDone=$}}e.$bt=R;function b(P,w){const a=w-P;return function($){return P+a*u($)}}function c(P,w,a){return function($){return $<a?P($/a):w(($-a)/(1-a))}}class I{constructor(w,a,$,f){this.from=w,this.to=a,this.duration=f,this.startTime=$,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(w,a,$){if(Math.abs(w-a)>2.5*$){let g,i;return w<a?(g=w+.75*$,i=a-.75*$):(g=w-.75*$,i=a+.75*$),c(b(w,g),b(i,a),.33)}return b(w,a)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(w){this.to=w.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(w){const a=(w-this.startTime)/this.duration;if(a<1){const $=this.c(a),f=this.d(a);return new R($,f,!1)}return new R(this.to.scrollLeft,this.to.scrollTop,!0)}combine(w,a,$){return I.start(w,a,$)}static start(w,a,$){$=$+10;const f=Date.now()-10;return new I(w,a,f,$)}}e.$ct=I;function D(P){return Math.pow(P,3)}function u(P){return 1-D(1-P)}}),define(ke[105],Ie([1,0,13,3]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=C,e.$xe=T,e.$ye=L,e.$ze=R,e.$Ae=c,e.$Be=I,e.$Ce=D,e.$De=u,e.$Ee=P,e.$Fe=w,e.$Ge=a,e.$He=$,e.$Ie=f,e.$Je=g,e.$Ke=i;function C(o){const t=o;return t?typeof t.read=="function":!1}function T(o){const t=o;return t?[t.on,t.pause,t.resume,t.destroy].every(s=>typeof s=="function"):!1}function L(o){const t=o;return t?T(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function R(o,t){return new b(o,t)}class b{constructor(t,s){this.e=t,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(s=>s(t))}h(t){this.c.error.length===0?(0,r.$Y)(t):this.c.error.slice(0).forEach(s=>s(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,s){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(t,s){if(this.a.destroyed)return;let n;switch(t){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const d=n.indexOf(s);d>=0&&n.splice(d,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(o,t){const s=[];let n;for(;(n=o.read())!==null;)s.push(n);return t(s)}function I(o,t,s){const n=[];let d;for(;(d=o.read())!==null&&n.length<s;)n.push(d);return d===null&&n.length>0?t(n):{read:()=>{if(n.length>0)return n.shift();if(typeof d<"u"){const l=d;return d=void 0,l}return o.read()}}}function D(o,t){return new Promise((s,n)=>{const d=[];u(o,{onData:l=>{t&&d.push(l)},onError:l=>{t?n(l):s(void 0)},onEnd:()=>{s(t?t(d):void 0)}})})}function u(o,t,s){o.on("error",n=>{s?.isCancellationRequested||t.onError(n)}),o.on("end",()=>{s?.isCancellationRequested||t.onEnd()}),o.on("data",n=>{s?.isCancellationRequested||t.onData(n)})}function P(o,t){return new Promise((s,n)=>{const d=new h.$Sc,l=[],m=y=>{if(l.push(y),l.length>t)return d.dispose(),o.pause(),s({stream:o,buffer:l,ended:!1})},E=y=>(d.dispose(),n(y)),S=()=>(d.dispose(),s({stream:o,buffer:l,ended:!0}));d.add((0,h.$Rc)(()=>o.removeListener("error",E))),o.on("error",E),d.add((0,h.$Rc)(()=>o.removeListener("end",S))),o.on("end",S),d.add((0,h.$Rc)(()=>o.removeListener("data",m))),o.on("data",m)})}function w(o,t){const s=R(t);return s.end(o),s}function a(){const o=R(()=>{throw new Error("not supported")});return o.end(),o}function $(o){let t=!1;return{read:()=>t?null:(t=!0,o)}}function f(o,t,s){const n=R(s);return u(o,{onData:d=>n.write(t.data(d)),onError:d=>n.error(t.error?t.error(d):d),onEnd:()=>n.end()}),n}function g(o,t,s){let n=!1;return{read:()=>{const d=t.read();return n?d:(n=!0,d!==null?s([o,d]):o)}}}function i(o,t,s){let n=!1;const d=R(s);return u(t,{onData:l=>n?d.write(l):(n=!0,d.write(s([o,l]))),onError:l=>d.error(l),onEnd:()=>{n||(n=!0,d.write(o)),d.end()}}),d}}),define(ke[21],Ie([1,0,49,105]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Le=void 0,e.$Me=c,e.$Ne=I,e.$Oe=D,e.$Pe=u,e.$Qe=P,e.$Re=w,e.$Se=a,e.$Te=$,e.$Ue=f,e.$Ve=g,e.$We=i,e.$Xe=o,e.$Ye=t,e.$Ze=s,e.$1e=n,e.$2e=d,e.$3e=l,e.$4e=m,e.$5e=E,e.$6e=k,h=Ue(h);const C=typeof Buffer<"u",T=new r.$T(()=>new Uint8Array(256));let L,R;class b{static alloc(p){return C?new b(Buffer.allocUnsafe(p)):new b(new Uint8Array(p))}static wrap(p){return C&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new b(p)}static fromString(p,v){return!(v?.dontUseNodeBuffer||!1)&&C?new b(Buffer.from(p)):(L||(L=new TextEncoder),new b(L.encode(p)))}static fromByteArray(p){const v=b.alloc(p.length);for(let F=0,N=p.length;F<N;F++)v.buffer[F]=p[F];return v}static concat(p,v){if(typeof v>"u"){v=0;for(let O=0,j=p.length;O<j;O++)v+=p[O].byteLength}const F=b.alloc(v);let N=0;for(let O=0,j=p.length;O<j;O++){const z=p[O];F.set(z,N),N+=z.byteLength}return F}constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}clone(){const p=b.alloc(this.byteLength);return p.set(this),p}toString(){return C?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(p,v){return new b(this.buffer.subarray(p,v))}set(p,v){if(p instanceof b)this.buffer.set(p.buffer,v);else if(p instanceof Uint8Array)this.buffer.set(p,v);else if(p instanceof ArrayBuffer)this.buffer.set(new Uint8Array(p),v);else if(ArrayBuffer.isView(p))this.buffer.set(new Uint8Array(p.buffer,p.byteOffset,p.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(p){return u(this.buffer,p)}writeUInt32BE(p,v){P(this.buffer,p,v)}readUInt32LE(p){return w(this.buffer,p)}writeUInt32LE(p,v){a(this.buffer,p,v)}readUInt8(p){return $(this.buffer,p)}writeUInt8(p,v){f(this.buffer,p,v)}indexOf(p,v=0){return c(this.buffer,p instanceof b?p.buffer:p,v)}}e.$Le=b;function c(A,p,v=0){const F=p.byteLength,N=A.byteLength;if(F===0)return 0;if(F===1)return A.indexOf(p[0]);if(F>N-v)return-1;const O=T.value;O.fill(p.length);for(let V=0;V<p.length;V++)O[p[V]]=p.length-V-1;let j=v+p.length-1,z=j,M=-1;for(;j<N;)if(A[j]===p[z]){if(z===0){M=j;break}j--,z--}else j+=Math.max(p.length-z,O[A[j]]),z=p.length-1;return M}function I(A,p){return A[p+0]<<0>>>0|A[p+1]<<8>>>0}function D(A,p,v){A[v+0]=p&255,p=p>>>8,A[v+1]=p&255}function u(A,p){return A[p]*2**24+A[p+1]*2**16+A[p+2]*2**8+A[p+3]}function P(A,p,v){A[v+3]=p,p=p>>>8,A[v+2]=p,p=p>>>8,A[v+1]=p,p=p>>>8,A[v]=p}function w(A,p){return A[p+0]<<0>>>0|A[p+1]<<8>>>0|A[p+2]<<16>>>0|A[p+3]<<24>>>0}function a(A,p,v){A[v+0]=p&255,p=p>>>8,A[v+1]=p&255,p=p>>>8,A[v+2]=p&255,p=p>>>8,A[v+3]=p&255}function $(A,p){return A[p]}function f(A,p,v){A[v]=p}function g(A){return h.$Ae(A,p=>b.concat(p))}function i(A){return h.$He(A)}function o(A){return h.$Ce(A,p=>b.concat(p))}async function t(A){return A.ended?b.concat(A.buffer):b.concat([...A.buffer,await o(A.stream)])}function s(A){return h.$Fe(A,p=>b.concat(p))}function n(A){return h.$Ie(A,{data:p=>typeof p=="string"?b.fromString(p):b.wrap(p)},p=>b.concat(p))}function d(A){return h.$ze(p=>b.concat(p),A)}function l(A,p){return h.$Je(A,p,v=>b.concat(v))}function m(A,p){return h.$Ke(A,p,v=>b.concat(v))}function E(A){let p=0,v=0,F=0;const N=new Uint8Array(Math.floor(A.length/4*3)),O=z=>{switch(v){case 3:N[F++]=p|z,v=0;break;case 2:N[F++]=p|z>>>2,p=z<<6,v=3;break;case 1:N[F++]=p|z>>>4,p=z<<4,v=2;break;default:p=z<<2,v=1}};for(let z=0;z<A.length;z++){const M=A.charCodeAt(z);if(M>=65&&M<=90)O(M-65);else if(M>=97&&M<=122)O(M-97+26);else if(M>=48&&M<=57)O(M-48+52);else if(M===43||M===45)O(62);else if(M===47||M===95)O(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${A[z]}`)}}const j=F;for(;v>0;)O(0);return b.wrap(N).slice(0,j)}const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function k({buffer:A},p=!0,v=!1){const F=v?y:S;let N="";const O=A.byteLength%3;let j=0;for(;j<A.byteLength-O;j+=3){const z=A[j+0],M=A[j+1],V=A[j+2];N+=F[z>>>2],N+=F[(z<<4|M>>>4)&63],N+=F[(M<<2|V>>>6)&63],N+=F[V&63]}if(O===1){const z=A[j+0];N+=F[z>>>2],N+=F[z<<4&63],p&&(N+="==")}else if(O===2){const z=A[j+0],M=A[j+1];N+=F[z>>>2],N+=F[(z<<4|M>>>4)&63],N+=F[M<<2&63],p&&(N+="=")}return N}}),define(ke[185],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=void 0,e.$ee=Symbol("MicrotaskDelay")}),define(ke[17],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cg=r,e.$dg=h,e.$eg=C,e.$fg=T,e.$gg=L,e.$hg=R,e.$ig=b,e.$jg=c,e.$kg=I,e.$lg=D,e.$mg=u,e.$ng=P,e.$og=w,e.$pg=$,e.$qg=f,e.$rg=g,e.$sg=i,e.$tg=o;function r(t){return typeof t=="string"}function h(t){return Array.isArray(t)&&t.every(s=>r(s))}function C(t){return typeof t=="object"&&t!==null&&!Array.isArray(t)&&!(t instanceof RegExp)&&!(t instanceof Date)}function T(t){const s=Object.getPrototypeOf(Uint8Array);return typeof t=="object"&&t instanceof s}function L(t){return typeof t=="number"&&!isNaN(t)}function R(t){return!!t&&typeof t[Symbol.iterator]=="function"}function b(t){return t===!0||t===!1}function c(t){return typeof t>"u"}function I(t){return!D(t)}function D(t){return c(t)||t===null}function u(t,s){if(!t)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}function P(t){if(D(t))throw new Error("Assertion Failed: argument is undefined or null");return t}function w(...t){const s=[];for(let n=0;n<t.length;n++){const d=t[n];if(D(d))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);s.push(d)}return s}const a=Object.prototype.hasOwnProperty;function $(t){if(!C(t))return!1;for(const s in t)if(a.call(t,s))return!1;return!0}function f(t){return typeof t=="function"}function g(...t){return t.length>0&&t.every(f)}function i(t,s){const n=Math.min(t.length,s.length);for(let d=0;d<n;d++)o(t[d],s[d])}function o(t,s){if(r(s)){if(typeof t!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(f(s)){try{if(t instanceof s)return}catch{}if(!D(t)&&t.constructor===s||s.length===1&&s.call(void 0,t)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ke[106],Ie([1,0,17]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wj=C,e.$Xj=T;const h=Object.create(null);function C(L,R){if((0,r.$cg)(R)){const b=h[R];if(b===void 0)throw new Error(`${L} references an unknown codicon: ${R}`);R=b}return h[L]=R,{id:L}}function T(){return h}}),define(ke[186],Ie([1,0,106]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yj=void 0,e.$Yj={add:(0,r.$Wj)("add",6e4),plus:(0,r.$Wj)("plus",6e4),gistNew:(0,r.$Wj)("gist-new",6e4),repoCreate:(0,r.$Wj)("repo-create",6e4),lightbulb:(0,r.$Wj)("lightbulb",60001),lightBulb:(0,r.$Wj)("light-bulb",60001),repo:(0,r.$Wj)("repo",60002),repoDelete:(0,r.$Wj)("repo-delete",60002),gistFork:(0,r.$Wj)("gist-fork",60003),repoForked:(0,r.$Wj)("repo-forked",60003),gitPullRequest:(0,r.$Wj)("git-pull-request",60004),gitPullRequestAbandoned:(0,r.$Wj)("git-pull-request-abandoned",60004),recordKeys:(0,r.$Wj)("record-keys",60005),keyboard:(0,r.$Wj)("keyboard",60005),tag:(0,r.$Wj)("tag",60006),gitPullRequestLabel:(0,r.$Wj)("git-pull-request-label",60006),tagAdd:(0,r.$Wj)("tag-add",60006),tagRemove:(0,r.$Wj)("tag-remove",60006),person:(0,r.$Wj)("person",60007),personFollow:(0,r.$Wj)("person-follow",60007),personOutline:(0,r.$Wj)("person-outline",60007),personFilled:(0,r.$Wj)("person-filled",60007),gitBranch:(0,r.$Wj)("git-branch",60008),gitBranchCreate:(0,r.$Wj)("git-branch-create",60008),gitBranchDelete:(0,r.$Wj)("git-branch-delete",60008),sourceControl:(0,r.$Wj)("source-control",60008),mirror:(0,r.$Wj)("mirror",60009),mirrorPublic:(0,r.$Wj)("mirror-public",60009),star:(0,r.$Wj)("star",60010),starAdd:(0,r.$Wj)("star-add",60010),starDelete:(0,r.$Wj)("star-delete",60010),starEmpty:(0,r.$Wj)("star-empty",60010),comment:(0,r.$Wj)("comment",60011),commentAdd:(0,r.$Wj)("comment-add",60011),alert:(0,r.$Wj)("alert",60012),warning:(0,r.$Wj)("warning",60012),search:(0,r.$Wj)("search",60013),searchSave:(0,r.$Wj)("search-save",60013),logOut:(0,r.$Wj)("log-out",60014),signOut:(0,r.$Wj)("sign-out",60014),logIn:(0,r.$Wj)("log-in",60015),signIn:(0,r.$Wj)("sign-in",60015),eye:(0,r.$Wj)("eye",60016),eyeUnwatch:(0,r.$Wj)("eye-unwatch",60016),eyeWatch:(0,r.$Wj)("eye-watch",60016),circleFilled:(0,r.$Wj)("circle-filled",60017),primitiveDot:(0,r.$Wj)("primitive-dot",60017),closeDirty:(0,r.$Wj)("close-dirty",60017),debugBreakpoint:(0,r.$Wj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,r.$Wj)("debug-breakpoint-disabled",60017),debugHint:(0,r.$Wj)("debug-hint",60017),terminalDecorationSuccess:(0,r.$Wj)("terminal-decoration-success",60017),primitiveSquare:(0,r.$Wj)("primitive-square",60018),edit:(0,r.$Wj)("edit",60019),pencil:(0,r.$Wj)("pencil",60019),info:(0,r.$Wj)("info",60020),issueOpened:(0,r.$Wj)("issue-opened",60020),gistPrivate:(0,r.$Wj)("gist-private",60021),gitForkPrivate:(0,r.$Wj)("git-fork-private",60021),lock:(0,r.$Wj)("lock",60021),mirrorPrivate:(0,r.$Wj)("mirror-private",60021),close:(0,r.$Wj)("close",60022),removeClose:(0,r.$Wj)("remove-close",60022),x:(0,r.$Wj)("x",60022),repoSync:(0,r.$Wj)("repo-sync",60023),sync:(0,r.$Wj)("sync",60023),clone:(0,r.$Wj)("clone",60024),desktopDownload:(0,r.$Wj)("desktop-download",60024),beaker:(0,r.$Wj)("beaker",60025),microscope:(0,r.$Wj)("microscope",60025),vm:(0,r.$Wj)("vm",60026),deviceDesktop:(0,r.$Wj)("device-desktop",60026),file:(0,r.$Wj)("file",60027),fileText:(0,r.$Wj)("file-text",60027),more:(0,r.$Wj)("more",60028),ellipsis:(0,r.$Wj)("ellipsis",60028),kebabHorizontal:(0,r.$Wj)("kebab-horizontal",60028),mailReply:(0,r.$Wj)("mail-reply",60029),reply:(0,r.$Wj)("reply",60029),organization:(0,r.$Wj)("organization",60030),organizationFilled:(0,r.$Wj)("organization-filled",60030),organizationOutline:(0,r.$Wj)("organization-outline",60030),newFile:(0,r.$Wj)("new-file",60031),fileAdd:(0,r.$Wj)("file-add",60031),newFolder:(0,r.$Wj)("new-folder",60032),fileDirectoryCreate:(0,r.$Wj)("file-directory-create",60032),trash:(0,r.$Wj)("trash",60033),trashcan:(0,r.$Wj)("trashcan",60033),history:(0,r.$Wj)("history",60034),clock:(0,r.$Wj)("clock",60034),folder:(0,r.$Wj)("folder",60035),fileDirectory:(0,r.$Wj)("file-directory",60035),symbolFolder:(0,r.$Wj)("symbol-folder",60035),logoGithub:(0,r.$Wj)("logo-github",60036),markGithub:(0,r.$Wj)("mark-github",60036),github:(0,r.$Wj)("github",60036),terminal:(0,r.$Wj)("terminal",60037),console:(0,r.$Wj)("console",60037),repl:(0,r.$Wj)("repl",60037),zap:(0,r.$Wj)("zap",60038),symbolEvent:(0,r.$Wj)("symbol-event",60038),error:(0,r.$Wj)("error",60039),stop:(0,r.$Wj)("stop",60039),variable:(0,r.$Wj)("variable",60040),symbolVariable:(0,r.$Wj)("symbol-variable",60040),array:(0,r.$Wj)("array",60042),symbolArray:(0,r.$Wj)("symbol-array",60042),symbolModule:(0,r.$Wj)("symbol-module",60043),symbolPackage:(0,r.$Wj)("symbol-package",60043),symbolNamespace:(0,r.$Wj)("symbol-namespace",60043),symbolObject:(0,r.$Wj)("symbol-object",60043),symbolMethod:(0,r.$Wj)("symbol-method",60044),symbolFunction:(0,r.$Wj)("symbol-function",60044),symbolConstructor:(0,r.$Wj)("symbol-constructor",60044),symbolBoolean:(0,r.$Wj)("symbol-boolean",60047),symbolNull:(0,r.$Wj)("symbol-null",60047),symbolNumeric:(0,r.$Wj)("symbol-numeric",60048),symbolNumber:(0,r.$Wj)("symbol-number",60048),symbolStructure:(0,r.$Wj)("symbol-structure",60049),symbolStruct:(0,r.$Wj)("symbol-struct",60049),symbolParameter:(0,r.$Wj)("symbol-parameter",60050),symbolTypeParameter:(0,r.$Wj)("symbol-type-parameter",60050),symbolKey:(0,r.$Wj)("symbol-key",60051),symbolText:(0,r.$Wj)("symbol-text",60051),symbolReference:(0,r.$Wj)("symbol-reference",60052),goToFile:(0,r.$Wj)("go-to-file",60052),symbolEnum:(0,r.$Wj)("symbol-enum",60053),symbolValue:(0,r.$Wj)("symbol-value",60053),symbolRuler:(0,r.$Wj)("symbol-ruler",60054),symbolUnit:(0,r.$Wj)("symbol-unit",60054),activateBreakpoints:(0,r.$Wj)("activate-breakpoints",60055),archive:(0,r.$Wj)("archive",60056),arrowBoth:(0,r.$Wj)("arrow-both",60057),arrowDown:(0,r.$Wj)("arrow-down",60058),arrowLeft:(0,r.$Wj)("arrow-left",60059),arrowRight:(0,r.$Wj)("arrow-right",60060),arrowSmallDown:(0,r.$Wj)("arrow-small-down",60061),arrowSmallLeft:(0,r.$Wj)("arrow-small-left",60062),arrowSmallRight:(0,r.$Wj)("arrow-small-right",60063),arrowSmallUp:(0,r.$Wj)("arrow-small-up",60064),arrowUp:(0,r.$Wj)("arrow-up",60065),bell:(0,r.$Wj)("bell",60066),bold:(0,r.$Wj)("bold",60067),book:(0,r.$Wj)("book",60068),bookmark:(0,r.$Wj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,r.$Wj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,r.$Wj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,r.$Wj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,r.$Wj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,r.$Wj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,r.$Wj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,r.$Wj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,r.$Wj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,r.$Wj)("debug-breakpoint-log-disabled",60075),briefcase:(0,r.$Wj)("briefcase",60076),broadcast:(0,r.$Wj)("broadcast",60077),browser:(0,r.$Wj)("browser",60078),bug:(0,r.$Wj)("bug",60079),calendar:(0,r.$Wj)("calendar",60080),caseSensitive:(0,r.$Wj)("case-sensitive",60081),check:(0,r.$Wj)("check",60082),checklist:(0,r.$Wj)("checklist",60083),chevronDown:(0,r.$Wj)("chevron-down",60084),chevronLeft:(0,r.$Wj)("chevron-left",60085),chevronRight:(0,r.$Wj)("chevron-right",60086),chevronUp:(0,r.$Wj)("chevron-up",60087),chromeClose:(0,r.$Wj)("chrome-close",60088),chromeMaximize:(0,r.$Wj)("chrome-maximize",60089),chromeMinimize:(0,r.$Wj)("chrome-minimize",60090),chromeRestore:(0,r.$Wj)("chrome-restore",60091),circleOutline:(0,r.$Wj)("circle-outline",60092),circle:(0,r.$Wj)("circle",60092),debugBreakpointUnverified:(0,r.$Wj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,r.$Wj)("terminal-decoration-incomplete",60092),circleSlash:(0,r.$Wj)("circle-slash",60093),circuitBoard:(0,r.$Wj)("circuit-board",60094),clearAll:(0,r.$Wj)("clear-all",60095),clippy:(0,r.$Wj)("clippy",60096),closeAll:(0,r.$Wj)("close-all",60097),cloudDownload:(0,r.$Wj)("cloud-download",60098),cloudUpload:(0,r.$Wj)("cloud-upload",60099),code:(0,r.$Wj)("code",60100),collapseAll:(0,r.$Wj)("collapse-all",60101),colorMode:(0,r.$Wj)("color-mode",60102),commentDiscussion:(0,r.$Wj)("comment-discussion",60103),creditCard:(0,r.$Wj)("credit-card",60105),dash:(0,r.$Wj)("dash",60108),dashboard:(0,r.$Wj)("dashboard",60109),database:(0,r.$Wj)("database",60110),debugContinue:(0,r.$Wj)("debug-continue",60111),debugDisconnect:(0,r.$Wj)("debug-disconnect",60112),debugPause:(0,r.$Wj)("debug-pause",60113),debugRestart:(0,r.$Wj)("debug-restart",60114),debugStart:(0,r.$Wj)("debug-start",60115),debugStepInto:(0,r.$Wj)("debug-step-into",60116),debugStepOut:(0,r.$Wj)("debug-step-out",60117),debugStepOver:(0,r.$Wj)("debug-step-over",60118),debugStop:(0,r.$Wj)("debug-stop",60119),debug:(0,r.$Wj)("debug",60120),deviceCameraVideo:(0,r.$Wj)("device-camera-video",60121),deviceCamera:(0,r.$Wj)("device-camera",60122),deviceMobile:(0,r.$Wj)("device-mobile",60123),diffAdded:(0,r.$Wj)("diff-added",60124),diffIgnored:(0,r.$Wj)("diff-ignored",60125),diffModified:(0,r.$Wj)("diff-modified",60126),diffRemoved:(0,r.$Wj)("diff-removed",60127),diffRenamed:(0,r.$Wj)("diff-renamed",60128),diff:(0,r.$Wj)("diff",60129),diffSidebyside:(0,r.$Wj)("diff-sidebyside",60129),discard:(0,r.$Wj)("discard",60130),editorLayout:(0,r.$Wj)("editor-layout",60131),emptyWindow:(0,r.$Wj)("empty-window",60132),exclude:(0,r.$Wj)("exclude",60133),extensions:(0,r.$Wj)("extensions",60134),eyeClosed:(0,r.$Wj)("eye-closed",60135),fileBinary:(0,r.$Wj)("file-binary",60136),fileCode:(0,r.$Wj)("file-code",60137),fileMedia:(0,r.$Wj)("file-media",60138),filePdf:(0,r.$Wj)("file-pdf",60139),fileSubmodule:(0,r.$Wj)("file-submodule",60140),fileSymlinkDirectory:(0,r.$Wj)("file-symlink-directory",60141),fileSymlinkFile:(0,r.$Wj)("file-symlink-file",60142),fileZip:(0,r.$Wj)("file-zip",60143),files:(0,r.$Wj)("files",60144),filter:(0,r.$Wj)("filter",60145),flame:(0,r.$Wj)("flame",60146),foldDown:(0,r.$Wj)("fold-down",60147),foldUp:(0,r.$Wj)("fold-up",60148),fold:(0,r.$Wj)("fold",60149),folderActive:(0,r.$Wj)("folder-active",60150),folderOpened:(0,r.$Wj)("folder-opened",60151),gear:(0,r.$Wj)("gear",60152),gift:(0,r.$Wj)("gift",60153),gistSecret:(0,r.$Wj)("gist-secret",60154),gist:(0,r.$Wj)("gist",60155),gitCommit:(0,r.$Wj)("git-commit",60156),gitCompare:(0,r.$Wj)("git-compare",60157),compareChanges:(0,r.$Wj)("compare-changes",60157),gitMerge:(0,r.$Wj)("git-merge",60158),githubAction:(0,r.$Wj)("github-action",60159),githubAlt:(0,r.$Wj)("github-alt",60160),globe:(0,r.$Wj)("globe",60161),grabber:(0,r.$Wj)("grabber",60162),graph:(0,r.$Wj)("graph",60163),gripper:(0,r.$Wj)("gripper",60164),heart:(0,r.$Wj)("heart",60165),home:(0,r.$Wj)("home",60166),horizontalRule:(0,r.$Wj)("horizontal-rule",60167),hubot:(0,r.$Wj)("hubot",60168),inbox:(0,r.$Wj)("inbox",60169),issueReopened:(0,r.$Wj)("issue-reopened",60171),issues:(0,r.$Wj)("issues",60172),italic:(0,r.$Wj)("italic",60173),jersey:(0,r.$Wj)("jersey",60174),json:(0,r.$Wj)("json",60175),kebabVertical:(0,r.$Wj)("kebab-vertical",60176),key:(0,r.$Wj)("key",60177),law:(0,r.$Wj)("law",60178),lightbulbAutofix:(0,r.$Wj)("lightbulb-autofix",60179),linkExternal:(0,r.$Wj)("link-external",60180),link:(0,r.$Wj)("link",60181),listOrdered:(0,r.$Wj)("list-ordered",60182),listUnordered:(0,r.$Wj)("list-unordered",60183),liveShare:(0,r.$Wj)("live-share",60184),loading:(0,r.$Wj)("loading",60185),location:(0,r.$Wj)("location",60186),mailRead:(0,r.$Wj)("mail-read",60187),mail:(0,r.$Wj)("mail",60188),markdown:(0,r.$Wj)("markdown",60189),megaphone:(0,r.$Wj)("megaphone",60190),mention:(0,r.$Wj)("mention",60191),milestone:(0,r.$Wj)("milestone",60192),gitPullRequestMilestone:(0,r.$Wj)("git-pull-request-milestone",60192),mortarBoard:(0,r.$Wj)("mortar-board",60193),move:(0,r.$Wj)("move",60194),multipleWindows:(0,r.$Wj)("multiple-windows",60195),mute:(0,r.$Wj)("mute",60196),noNewline:(0,r.$Wj)("no-newline",60197),note:(0,r.$Wj)("note",60198),octoface:(0,r.$Wj)("octoface",60199),openPreview:(0,r.$Wj)("open-preview",60200),package:(0,r.$Wj)("package",60201),paintcan:(0,r.$Wj)("paintcan",60202),pin:(0,r.$Wj)("pin",60203),play:(0,r.$Wj)("play",60204),run:(0,r.$Wj)("run",60204),plug:(0,r.$Wj)("plug",60205),preserveCase:(0,r.$Wj)("preserve-case",60206),preview:(0,r.$Wj)("preview",60207),project:(0,r.$Wj)("project",60208),pulse:(0,r.$Wj)("pulse",60209),question:(0,r.$Wj)("question",60210),quote:(0,r.$Wj)("quote",60211),radioTower:(0,r.$Wj)("radio-tower",60212),reactions:(0,r.$Wj)("reactions",60213),references:(0,r.$Wj)("references",60214),refresh:(0,r.$Wj)("refresh",60215),regex:(0,r.$Wj)("regex",60216),remoteExplorer:(0,r.$Wj)("remote-explorer",60217),remote:(0,r.$Wj)("remote",60218),remove:(0,r.$Wj)("remove",60219),replaceAll:(0,r.$Wj)("replace-all",60220),replace:(0,r.$Wj)("replace",60221),repoClone:(0,r.$Wj)("repo-clone",60222),repoForcePush:(0,r.$Wj)("repo-force-push",60223),repoPull:(0,r.$Wj)("repo-pull",60224),repoPush:(0,r.$Wj)("repo-push",60225),report:(0,r.$Wj)("report",60226),requestChanges:(0,r.$Wj)("request-changes",60227),rocket:(0,r.$Wj)("rocket",60228),rootFolderOpened:(0,r.$Wj)("root-folder-opened",60229),rootFolder:(0,r.$Wj)("root-folder",60230),rss:(0,r.$Wj)("rss",60231),ruby:(0,r.$Wj)("ruby",60232),saveAll:(0,r.$Wj)("save-all",60233),saveAs:(0,r.$Wj)("save-as",60234),save:(0,r.$Wj)("save",60235),screenFull:(0,r.$Wj)("screen-full",60236),screenNormal:(0,r.$Wj)("screen-normal",60237),searchStop:(0,r.$Wj)("search-stop",60238),server:(0,r.$Wj)("server",60240),settingsGear:(0,r.$Wj)("settings-gear",60241),settings:(0,r.$Wj)("settings",60242),shield:(0,r.$Wj)("shield",60243),smiley:(0,r.$Wj)("smiley",60244),sortPrecedence:(0,r.$Wj)("sort-precedence",60245),splitHorizontal:(0,r.$Wj)("split-horizontal",60246),splitVertical:(0,r.$Wj)("split-vertical",60247),squirrel:(0,r.$Wj)("squirrel",60248),starFull:(0,r.$Wj)("star-full",60249),starHalf:(0,r.$Wj)("star-half",60250),symbolClass:(0,r.$Wj)("symbol-class",60251),symbolColor:(0,r.$Wj)("symbol-color",60252),symbolConstant:(0,r.$Wj)("symbol-constant",60253),symbolEnumMember:(0,r.$Wj)("symbol-enum-member",60254),symbolField:(0,r.$Wj)("symbol-field",60255),symbolFile:(0,r.$Wj)("symbol-file",60256),symbolInterface:(0,r.$Wj)("symbol-interface",60257),symbolKeyword:(0,r.$Wj)("symbol-keyword",60258),symbolMisc:(0,r.$Wj)("symbol-misc",60259),symbolOperator:(0,r.$Wj)("symbol-operator",60260),symbolProperty:(0,r.$Wj)("symbol-property",60261),wrench:(0,r.$Wj)("wrench",60261),wrenchSubaction:(0,r.$Wj)("wrench-subaction",60261),symbolSnippet:(0,r.$Wj)("symbol-snippet",60262),tasklist:(0,r.$Wj)("tasklist",60263),telescope:(0,r.$Wj)("telescope",60264),textSize:(0,r.$Wj)("text-size",60265),threeBars:(0,r.$Wj)("three-bars",60266),thumbsdown:(0,r.$Wj)("thumbsdown",60267),thumbsup:(0,r.$Wj)("thumbsup",60268),tools:(0,r.$Wj)("tools",60269),triangleDown:(0,r.$Wj)("triangle-down",60270),triangleLeft:(0,r.$Wj)("triangle-left",60271),triangleRight:(0,r.$Wj)("triangle-right",60272),triangleUp:(0,r.$Wj)("triangle-up",60273),twitter:(0,r.$Wj)("twitter",60274),unfold:(0,r.$Wj)("unfold",60275),unlock:(0,r.$Wj)("unlock",60276),unmute:(0,r.$Wj)("unmute",60277),unverified:(0,r.$Wj)("unverified",60278),verified:(0,r.$Wj)("verified",60279),versions:(0,r.$Wj)("versions",60280),vmActive:(0,r.$Wj)("vm-active",60281),vmOutline:(0,r.$Wj)("vm-outline",60282),vmRunning:(0,r.$Wj)("vm-running",60283),watch:(0,r.$Wj)("watch",60284),whitespace:(0,r.$Wj)("whitespace",60285),wholeWord:(0,r.$Wj)("whole-word",60286),window:(0,r.$Wj)("window",60287),wordWrap:(0,r.$Wj)("word-wrap",60288),zoomIn:(0,r.$Wj)("zoom-in",60289),zoomOut:(0,r.$Wj)("zoom-out",60290),listFilter:(0,r.$Wj)("list-filter",60291),listFlat:(0,r.$Wj)("list-flat",60292),listSelection:(0,r.$Wj)("list-selection",60293),selection:(0,r.$Wj)("selection",60293),listTree:(0,r.$Wj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,r.$Wj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,r.$Wj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,r.$Wj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,r.$Wj)("debug-stackframe-active",60297),circleSmallFilled:(0,r.$Wj)("circle-small-filled",60298),debugStackframeDot:(0,r.$Wj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,r.$Wj)("terminal-decoration-mark",60298),debugStackframe:(0,r.$Wj)("debug-stackframe",60299),debugStackframeFocused:(0,r.$Wj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,r.$Wj)("debug-breakpoint-unsupported",60300),symbolString:(0,r.$Wj)("symbol-string",60301),debugReverseContinue:(0,r.$Wj)("debug-reverse-continue",60302),debugStepBack:(0,r.$Wj)("debug-step-back",60303),debugRestartFrame:(0,r.$Wj)("debug-restart-frame",60304),debugAlt:(0,r.$Wj)("debug-alt",60305),callIncoming:(0,r.$Wj)("call-incoming",60306),callOutgoing:(0,r.$Wj)("call-outgoing",60307),menu:(0,r.$Wj)("menu",60308),expandAll:(0,r.$Wj)("expand-all",60309),feedback:(0,r.$Wj)("feedback",60310),gitPullRequestReviewer:(0,r.$Wj)("git-pull-request-reviewer",60310),groupByRefType:(0,r.$Wj)("group-by-ref-type",60311),ungroupByRefType:(0,r.$Wj)("ungroup-by-ref-type",60312),account:(0,r.$Wj)("account",60313),gitPullRequestAssignee:(0,r.$Wj)("git-pull-request-assignee",60313),bellDot:(0,r.$Wj)("bell-dot",60314),debugConsole:(0,r.$Wj)("debug-console",60315),library:(0,r.$Wj)("library",60316),output:(0,r.$Wj)("output",60317),runAll:(0,r.$Wj)("run-all",60318),syncIgnored:(0,r.$Wj)("sync-ignored",60319),pinned:(0,r.$Wj)("pinned",60320),githubInverted:(0,r.$Wj)("github-inverted",60321),serverProcess:(0,r.$Wj)("server-process",60322),serverEnvironment:(0,r.$Wj)("server-environment",60323),pass:(0,r.$Wj)("pass",60324),issueClosed:(0,r.$Wj)("issue-closed",60324),stopCircle:(0,r.$Wj)("stop-circle",60325),playCircle:(0,r.$Wj)("play-circle",60326),record:(0,r.$Wj)("record",60327),debugAltSmall:(0,r.$Wj)("debug-alt-small",60328),vmConnect:(0,r.$Wj)("vm-connect",60329),cloud:(0,r.$Wj)("cloud",60330),merge:(0,r.$Wj)("merge",60331),export:(0,r.$Wj)("export",60332),graphLeft:(0,r.$Wj)("graph-left",60333),magnet:(0,r.$Wj)("magnet",60334),notebook:(0,r.$Wj)("notebook",60335),redo:(0,r.$Wj)("redo",60336),checkAll:(0,r.$Wj)("check-all",60337),pinnedDirty:(0,r.$Wj)("pinned-dirty",60338),passFilled:(0,r.$Wj)("pass-filled",60339),circleLargeFilled:(0,r.$Wj)("circle-large-filled",60340),circleLarge:(0,r.$Wj)("circle-large",60341),circleLargeOutline:(0,r.$Wj)("circle-large-outline",60341),combine:(0,r.$Wj)("combine",60342),gather:(0,r.$Wj)("gather",60342),table:(0,r.$Wj)("table",60343),variableGroup:(0,r.$Wj)("variable-group",60344),typeHierarchy:(0,r.$Wj)("type-hierarchy",60345),typeHierarchySub:(0,r.$Wj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,r.$Wj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,r.$Wj)("git-pull-request-create",60348),runAbove:(0,r.$Wj)("run-above",60349),runBelow:(0,r.$Wj)("run-below",60350),notebookTemplate:(0,r.$Wj)("notebook-template",60351),debugRerun:(0,r.$Wj)("debug-rerun",60352),workspaceTrusted:(0,r.$Wj)("workspace-trusted",60353),workspaceUntrusted:(0,r.$Wj)("workspace-untrusted",60354),workspaceUnknown:(0,r.$Wj)("workspace-unknown",60355),terminalCmd:(0,r.$Wj)("terminal-cmd",60356),terminalDebian:(0,r.$Wj)("terminal-debian",60357),terminalLinux:(0,r.$Wj)("terminal-linux",60358),terminalPowershell:(0,r.$Wj)("terminal-powershell",60359),terminalTmux:(0,r.$Wj)("terminal-tmux",60360),terminalUbuntu:(0,r.$Wj)("terminal-ubuntu",60361),terminalBash:(0,r.$Wj)("terminal-bash",60362),arrowSwap:(0,r.$Wj)("arrow-swap",60363),copy:(0,r.$Wj)("copy",60364),personAdd:(0,r.$Wj)("person-add",60365),filterFilled:(0,r.$Wj)("filter-filled",60366),wand:(0,r.$Wj)("wand",60367),debugLineByLine:(0,r.$Wj)("debug-line-by-line",60368),inspect:(0,r.$Wj)("inspect",60369),layers:(0,r.$Wj)("layers",60370),layersDot:(0,r.$Wj)("layers-dot",60371),layersActive:(0,r.$Wj)("layers-active",60372),compass:(0,r.$Wj)("compass",60373),compassDot:(0,r.$Wj)("compass-dot",60374),compassActive:(0,r.$Wj)("compass-active",60375),azure:(0,r.$Wj)("azure",60376),issueDraft:(0,r.$Wj)("issue-draft",60377),gitPullRequestClosed:(0,r.$Wj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,r.$Wj)("git-pull-request-draft",60379),debugAll:(0,r.$Wj)("debug-all",60380),debugCoverage:(0,r.$Wj)("debug-coverage",60381),runErrors:(0,r.$Wj)("run-errors",60382),folderLibrary:(0,r.$Wj)("folder-library",60383),debugContinueSmall:(0,r.$Wj)("debug-continue-small",60384),beakerStop:(0,r.$Wj)("beaker-stop",60385),graphLine:(0,r.$Wj)("graph-line",60386),graphScatter:(0,r.$Wj)("graph-scatter",60387),pieChart:(0,r.$Wj)("pie-chart",60388),bracket:(0,r.$Wj)("bracket",60175),bracketDot:(0,r.$Wj)("bracket-dot",60389),bracketError:(0,r.$Wj)("bracket-error",60390),lockSmall:(0,r.$Wj)("lock-small",60391),azureDevops:(0,r.$Wj)("azure-devops",60392),verifiedFilled:(0,r.$Wj)("verified-filled",60393),newline:(0,r.$Wj)("newline",60394),layout:(0,r.$Wj)("layout",60395),layoutActivitybarLeft:(0,r.$Wj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,r.$Wj)("layout-activitybar-right",60397),layoutPanelLeft:(0,r.$Wj)("layout-panel-left",60398),layoutPanelCenter:(0,r.$Wj)("layout-panel-center",60399),layoutPanelJustify:(0,r.$Wj)("layout-panel-justify",60400),layoutPanelRight:(0,r.$Wj)("layout-panel-right",60401),layoutPanel:(0,r.$Wj)("layout-panel",60402),layoutSidebarLeft:(0,r.$Wj)("layout-sidebar-left",60403),layoutSidebarRight:(0,r.$Wj)("layout-sidebar-right",60404),layoutStatusbar:(0,r.$Wj)("layout-statusbar",60405),layoutMenubar:(0,r.$Wj)("layout-menubar",60406),layoutCentered:(0,r.$Wj)("layout-centered",60407),target:(0,r.$Wj)("target",60408),indent:(0,r.$Wj)("indent",60409),recordSmall:(0,r.$Wj)("record-small",60410),errorSmall:(0,r.$Wj)("error-small",60411),terminalDecorationError:(0,r.$Wj)("terminal-decoration-error",60411),arrowCircleDown:(0,r.$Wj)("arrow-circle-down",60412),arrowCircleLeft:(0,r.$Wj)("arrow-circle-left",60413),arrowCircleRight:(0,r.$Wj)("arrow-circle-right",60414),arrowCircleUp:(0,r.$Wj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,r.$Wj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,r.$Wj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,r.$Wj)("layout-sidebar-left-off",60418),blank:(0,r.$Wj)("blank",60419),heartFilled:(0,r.$Wj)("heart-filled",60420),map:(0,r.$Wj)("map",60421),mapHorizontal:(0,r.$Wj)("map-horizontal",60421),foldHorizontal:(0,r.$Wj)("fold-horizontal",60421),mapFilled:(0,r.$Wj)("map-filled",60422),mapHorizontalFilled:(0,r.$Wj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,r.$Wj)("fold-horizontal-filled",60422),circleSmall:(0,r.$Wj)("circle-small",60423),bellSlash:(0,r.$Wj)("bell-slash",60424),bellSlashDot:(0,r.$Wj)("bell-slash-dot",60425),commentUnresolved:(0,r.$Wj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,r.$Wj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,r.$Wj)("git-pull-request-new-changes",60428),searchFuzzy:(0,r.$Wj)("search-fuzzy",60429),commentDraft:(0,r.$Wj)("comment-draft",60430),send:(0,r.$Wj)("send",60431),sparkle:(0,r.$Wj)("sparkle",60432),insert:(0,r.$Wj)("insert",60433),mic:(0,r.$Wj)("mic",60434),thumbsdownFilled:(0,r.$Wj)("thumbsdown-filled",60435),thumbsupFilled:(0,r.$Wj)("thumbsup-filled",60436),coffee:(0,r.$Wj)("coffee",60437),snake:(0,r.$Wj)("snake",60438),game:(0,r.$Wj)("game",60439),vr:(0,r.$Wj)("vr",60440),chip:(0,r.$Wj)("chip",60441),piano:(0,r.$Wj)("piano",60442),music:(0,r.$Wj)("music",60443),micFilled:(0,r.$Wj)("mic-filled",60444),repoFetch:(0,r.$Wj)("repo-fetch",60445),copilot:(0,r.$Wj)("copilot",60446),lightbulbSparkle:(0,r.$Wj)("lightbulb-sparkle",60447),robot:(0,r.$Wj)("robot",60448),sparkleFilled:(0,r.$Wj)("sparkle-filled",60449),diffSingle:(0,r.$Wj)("diff-single",60450),diffMultiple:(0,r.$Wj)("diff-multiple",60451),surroundWith:(0,r.$Wj)("surround-with",60452),share:(0,r.$Wj)("share",60453),gitStash:(0,r.$Wj)("git-stash",60454),gitStashApply:(0,r.$Wj)("git-stash-apply",60455),gitStashPop:(0,r.$Wj)("git-stash-pop",60456),vscode:(0,r.$Wj)("vscode",60457),vscodeInsiders:(0,r.$Wj)("vscode-insiders",60458),codeOss:(0,r.$Wj)("code-oss",60459),runCoverage:(0,r.$Wj)("run-coverage",60460),runAllCoverage:(0,r.$Wj)("run-all-coverage",60461),coverage:(0,r.$Wj)("coverage",60462),githubProject:(0,r.$Wj)("github-project",60463),mapVertical:(0,r.$Wj)("map-vertical",60464),foldVertical:(0,r.$Wj)("fold-vertical",60464),mapVerticalFilled:(0,r.$Wj)("map-vertical-filled",60465),foldVerticalFilled:(0,r.$Wj)("fold-vertical-filled",60465),goToSearch:(0,r.$Wj)("go-to-search",60466),percentage:(0,r.$Wj)("percentage",60467),sortPercentage:(0,r.$Wj)("sort-percentage",60467),attach:(0,r.$Wj)("attach",60468)}}),define(ke[82],Ie([1,0,106,186]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=e.$1j=void 0,e.$Zj=C;function C(){return Object.values(e.$2j)}e.$1j={dialogError:(0,r.$Wj)("dialog-error","error"),dialogWarning:(0,r.$Wj)("dialog-warning","warning"),dialogInfo:(0,r.$Wj)("dialog-info","info"),dialogClose:(0,r.$Wj)("dialog-close","close"),treeItemExpanded:(0,r.$Wj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,r.$Wj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,r.$Wj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,r.$Wj)("tree-filter-clear","close"),treeItemLoading:(0,r.$Wj)("tree-item-loading","loading"),menuSelection:(0,r.$Wj)("menu-selection","check"),menuSubmenu:(0,r.$Wj)("menu-submenu","chevron-right"),menuBarMore:(0,r.$Wj)("menubar-more","more"),scrollbarButtonLeft:(0,r.$Wj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,r.$Wj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,r.$Wj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,r.$Wj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,r.$Wj)("toolbar-more","more"),quickInputBack:(0,r.$Wj)("quick-input-back","arrow-left"),dropDownButton:(0,r.$Wj)("drop-down-button",60084),symbolCustomColor:(0,r.$Wj)("symbol-customcolor",60252),exportIcon:(0,r.$Wj)("export",60332),workspaceUnspecified:(0,r.$Wj)("workspace-unspecified",60355),newLine:(0,r.$Wj)("newline",60394),thumbsDownFilled:(0,r.$Wj)("thumbsdown-filled",60435),thumbsUpFilled:(0,r.$Wj)("thumbsup-filled",60436),gitFetch:(0,r.$Wj)("git-fetch",60445),lightbulbSparkleAutofix:(0,r.$Wj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,r.$Wj)("debug-breakpoint-pending",60377)},e.$2j={...h.$Yj,...e.$1j}}),define(ke[24],Ie([1,0,17]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ao=h,e.$bo=C,e.$co=L,e.$do=b,e.$eo=c,e.$fo=I,e.$go=D,e.$ho=u,e.$io=P,e.$jo=w,e.$ko=a,e.$lo=$,e.$mo=f;function h(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const i=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([o,t])=>{i[o]=t&&typeof t=="object"?h(t):t}),i}function C(g){if(!g||typeof g!="object")return g;const i=[g];for(;i.length>0;){const o=i.shift();Object.freeze(o);for(const t in o)if(T.call(o,t)){const s=o[t];typeof s=="object"&&!Object.isFrozen(s)&&!(0,r.$fg)(s)&&i.push(s)}}return g}const T=Object.prototype.hasOwnProperty;function L(g,i){return R(g,i,new Set)}function R(g,i,o){if((0,r.$lg)(g))return g;const t=i(g);if(typeof t<"u")return t;if(Array.isArray(g)){const s=[];for(const n of g)s.push(R(n,i,o));return s}if((0,r.$eg)(g)){if(o.has(g))throw new Error("Cannot clone recursive data-structure");o.add(g);const s={};for(const n in g)T.call(g,n)&&(s[n]=R(g[n],i,o));return o.delete(g),s}return g}function b(g,i,o=!0){return(0,r.$eg)(g)?((0,r.$eg)(i)&&Object.keys(i).forEach(t=>{t in g?o&&((0,r.$eg)(g[t])&&(0,r.$eg)(i[t])?b(g[t],i[t],o):g[t]=i[t]):g[t]=i[t]}),g):i}function c(g,i){if(g===i)return!0;if(g==null||i===null||i===void 0||typeof g!=typeof i||typeof g!="object"||Array.isArray(g)!==Array.isArray(i))return!1;let o,t;if(Array.isArray(g)){if(g.length!==i.length)return!1;for(o=0;o<g.length;o++)if(!c(g[o],i[o]))return!1}else{const s=[];for(t in g)s.push(t);s.sort();const n=[];for(t in i)n.push(t);if(n.sort(),!c(s,n))return!1;for(o=0;o<s.length;o++)if(!c(g[s[o]],i[s[o]]))return!1}return!0}function I(g){const i=new Set;return JSON.stringify(g,(o,t)=>{if((0,r.$eg)(t)||Array.isArray(t)){if(i.has(t))return"[Circular]";i.add(t)}return typeof t=="bigint"?`[BigInt ${t.toString()}]`:t})}function D(g,i){const o=Object.create(null);return!g||!i||Object.keys(i).forEach(s=>{const n=g[s],d=i[s];c(n,d)||(o[s]=d)}),o}function u(g,i){const o=i.toLowerCase(),t=Object.keys(g).find(s=>s.toLowerCase()===o);return t?g[t]:g[i]}function P(g,i){const o=Object.create(null);for(const[t,s]of Object.entries(g))i(t,s)&&(o[t]=s);return o}function w(g){let i=[];for(;Object.prototype!==g;)i=i.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return i}function a(g){const i=[];for(const o of w(g))typeof g[o]=="function"&&i.push(o);return i}function $(g,i){const o=s=>function(){const n=Array.prototype.slice.call(arguments,0);return i(s,n)},t={};for(const s of g)t[s]=o(s);return t}function f(g,i){const o={};for(const[t,s]of Object.entries(g))o[t]=i(s,t);return o}}),define(ke[50],Ie([1,0,82]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$3j=C;var h;(function(L){function R(b){return b&&typeof b=="object"&&typeof b.id=="string"}L.isThemeColor=R})(h||(e.ThemeColor=h={}));function C(L){return{id:L}}var T;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function b(g){const i=R.exec(g.id);if(!i)return b(r.$2j.error);const[,o,t]=i,s=["codicon","codicon-"+o];return t&&s.push("codicon-modifier-"+t.substring(1)),s}L.asClassNameArray=b;function c(g){return b(g).join(" ")}L.asClassName=c;function I(g){return"."+b(g).join(".")}L.asCSSSelector=I;function D(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||h.isThemeColor(g.color))}L.isThemeIcon=D;const u=new RegExp(`^\\$\\((${L.iconNameExpression}(?:${L.iconModifierExpression})?)\\)$`);function P(g){const i=u.exec(g);if(!i)return;const[,o]=i;return{id:o}}L.fromString=P;function w(g){return{id:g}}L.fromId=w;function a(g,i){let o=g.id;const t=o.lastIndexOf("~");return t!==-1&&(o=o.substring(0,t)),i&&(o=`${o}~${i}`),{id:o}}L.modify=a;function $(g){const i=g.id.lastIndexOf("~");if(i!==-1)return g.id.substring(i+1)}L.getModifier=$;function f(g,i){return g.id===i.id&&g.color?.id===i.color?.id}L.isEqual=f})(T||(e.ThemeIcon=T={}))}),define(ke[83],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$$e=h,e.$_e=C;var r;(function(T){T[T.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",T[T.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",T[T.MAX_UINT_8=255]="MAX_UINT_8",T[T.MAX_UINT_16=65535]="MAX_UINT_16",T[T.MAX_UINT_32=4294967295]="MAX_UINT_32",T[T.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(r||(e.Constants=r={}));function h(T){return T<0?0:T>r.MAX_UINT_8?r.MAX_UINT_8:T|0}function C(T){return T<0?0:T>r.MAX_UINT_32?r.MAX_UINT_32:T|0}}),define(ke[12],Ie([1,0,183,26,49,83]),function(me,e,r,h,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bg=e.$ag=e.$_f=e.GraphemeBreakType=e.$2f=e.$Tf=e.$Mf=e.$Lf=void 0,e.$af=L,e.$bf=b,e.$cf=I,e.$df=D,e.$ef=u,e.$ff=P,e.$gf=w,e.$hf=a,e.$if=$,e.$jf=f,e.$kf=g,e.$lf=i,e.$mf=o,e.$nf=t,e.$of=s,e.$pf=n,e.$qf=d,e.$rf=l,e.$sf=m,e.$tf=E,e.$uf=S,e.$vf=y,e.$wf=k,e.$xf=A,e.$yf=p,e.$zf=v,e.$Af=F,e.$Bf=N,e.$Cf=O,e.$Df=j,e.$Ef=z,e.$Ff=M,e.$Gf=V,e.$Hf=K,e.$If=ne,e.$Jf=B,e.$Kf=G,e.$Nf=re,e.$Of=ye,e.$Pf=$e,e.$Qf=J,e.$Rf=ae,e.$Sf=ce,e.$Uf=le,e.$Vf=Z,e.$Wf=oe,e.$Xf=pe,e.$Yf=Fe,e.$Zf=We,e.$1f=De,e.$3f=Te,e.$4f=U,e.$5f=q,e.$6f=X,e.$7f=_,e.$8f=de,e.$9f=be,e.$0f=Ne,e.$$f=ot;function L(Pe){return!Pe||typeof Pe!="string"?!0:Pe.trim().length===0}const R=/{(\d+)}/g;function b(Pe,...ze){return ze.length===0?Pe:Pe.replace(R,function(He,Oe){const je=parseInt(Oe,10);return isNaN(je)||je<0||je>=ze.length?He:ze[je]})}const c=/{([^}]+)}/g;function I(Pe,ze){return Object.keys(ze).length===0?Pe:Pe.replace(c,(He,Oe)=>ze[Oe]??He)}function D(Pe){return Pe.replace(/[<>"'&]/g,ze=>{switch(ze){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ze})}function u(Pe){return Pe.replace(/[<>&]/g,function(ze){switch(ze){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ze}})}function P(Pe){return Pe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function w(Pe,ze){let He=0,Oe=Pe.indexOf(ze);for(;Oe!==-1;)He++,Oe=Pe.indexOf(ze,Oe+ze.length);return He}function a(Pe,ze,He="\u2026"){return Pe.length<=ze?Pe:`${Pe.substr(0,ze)}${He}`}function $(Pe,ze,He="\u2026"){if(Pe.length<=ze)return Pe;const Oe=Math.ceil(ze/2)-He.length/2,je=Math.floor(ze/2)-He.length/2;return`${Pe.substr(0,Oe)}${He}${Pe.substr(Pe.length-je)}`}function f(Pe,ze=" "){const He=g(Pe,ze);return i(He,ze)}function g(Pe,ze){if(!Pe||!ze)return Pe;const He=ze.length;if(He===0||Pe.length===0)return Pe;let Oe=0;for(;Pe.indexOf(ze,Oe)===Oe;)Oe=Oe+He;return Pe.substring(Oe)}function i(Pe,ze){if(!Pe||!ze)return Pe;const He=ze.length,Oe=Pe.length;if(He===0||Oe===0)return Pe;let je=Oe,he=-1;for(;he=Pe.lastIndexOf(ze,je-1),!(he===-1||he+He!==je);){if(he===0)return"";je=he}return Pe.substring(0,je)}function o(Pe){return Pe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function t(Pe){return Pe.replace(/\*/g,"")}function s(Pe,ze,He={}){if(!Pe)throw new Error("Cannot create regex from empty string");ze||(Pe=P(Pe)),He.wholeWord&&(/\B/.test(Pe.charAt(0))||(Pe="\\b"+Pe),/\B/.test(Pe.charAt(Pe.length-1))||(Pe=Pe+"\\b"));let Oe="";return He.global&&(Oe+="g"),He.matchCase||(Oe+="i"),He.multiline&&(Oe+="m"),He.unicode&&(Oe+="u"),new RegExp(Pe,Oe)}function n(Pe){return Pe.source==="^"||Pe.source==="^$"||Pe.source==="$"||Pe.source==="^\\s*$"?!1:!!(Pe.exec("")&&Pe.lastIndex===0)}function d(Pe){return Pe.split(/\r\n|\r|\n/)}function l(Pe){const ze=[],He=Pe.split(/(\r\n|\r|\n)/);for(let Oe=0;Oe<Math.ceil(He.length/2);Oe++)ze.push(He[2*Oe]+(He[2*Oe+1]??""));return ze}function m(Pe){for(let ze=0,He=Pe.length;ze<He;ze++){const Oe=Pe.charCodeAt(ze);if(Oe!==h.CharCode.Space&&Oe!==h.CharCode.Tab)return ze}return-1}function E(Pe,ze=0,He=Pe.length){for(let Oe=ze;Oe<He;Oe++){const je=Pe.charCodeAt(Oe);if(je!==h.CharCode.Space&&je!==h.CharCode.Tab)return Pe.substring(ze,Oe)}return Pe.substring(ze,He)}function S(Pe,ze=Pe.length-1){for(let He=ze;He>=0;He--){const Oe=Pe.charCodeAt(He);if(Oe!==h.CharCode.Space&&Oe!==h.CharCode.Tab)return He}return-1}function y(Pe,ze,He){const Oe=[];let je=0;for(const he of Pe.matchAll(ze)){if(Oe.push(Pe.slice(je,he.index)),he.index===void 0)throw new Error("match.index should be defined");je=he.index+he[0].length,Oe.push(He(he[0],...he.slice(1),he.index,Pe,he.groups))}return Oe.push(Pe.slice(je)),Promise.all(Oe).then(he=>he.join(""))}function k(Pe,ze){return Pe<ze?-1:Pe>ze?1:0}function A(Pe,ze,He=0,Oe=Pe.length,je=0,he=ze.length){for(;He<Oe&&je<he;He++,je++){const Xe=Pe.charCodeAt(He),et=ze.charCodeAt(je);if(Xe<et)return-1;if(Xe>et)return 1}const x=Oe-He,Ce=he-je;return x<Ce?-1:x>Ce?1:0}function p(Pe,ze){return v(Pe,ze,0,Pe.length,0,ze.length)}function v(Pe,ze,He=0,Oe=Pe.length,je=0,he=ze.length){for(;He<Oe&&je<he;He++,je++){let Xe=Pe.charCodeAt(He),et=ze.charCodeAt(je);if(Xe===et)continue;if(Xe>=128||et>=128)return A(Pe.toLowerCase(),ze.toLowerCase(),He,Oe,je,he);N(Xe)&&(Xe-=32),N(et)&&(et-=32);const ut=Xe-et;if(ut!==0)return ut}const x=Oe-He,Ce=he-je;return x<Ce?-1:x>Ce?1:0}function F(Pe){return Pe>=h.CharCode.Digit0&&Pe<=h.CharCode.Digit9}function N(Pe){return Pe>=h.CharCode.a&&Pe<=h.CharCode.z}function O(Pe){return Pe>=h.CharCode.A&&Pe<=h.CharCode.Z}function j(Pe,ze){return Pe.length===ze.length&&v(Pe,ze)===0}function z(Pe,ze){const He=ze.length;return ze.length>Pe.length?!1:v(Pe,ze,0,He)===0}function M(Pe,ze){const He=Math.min(Pe.length,ze.length);let Oe;for(Oe=0;Oe<He;Oe++)if(Pe.charCodeAt(Oe)!==ze.charCodeAt(Oe))return Oe;return He}function V(Pe,ze){const He=Math.min(Pe.length,ze.length);let Oe;const je=Pe.length-1,he=ze.length-1;for(Oe=0;Oe<He;Oe++)if(Pe.charCodeAt(je-Oe)!==ze.charCodeAt(he-Oe))return Oe;return He}function K(Pe){return 55296<=Pe&&Pe<=56319}function ne(Pe){return 56320<=Pe&&Pe<=57343}function B(Pe,ze){return(Pe-55296<<10)+(ze-56320)+65536}function G(Pe,ze,He){const Oe=Pe.charCodeAt(He);if(K(Oe)&&He+1<ze){const je=Pe.charCodeAt(He+1);if(ne(je))return B(Oe,je)}return Oe}function Y(Pe,ze){const He=Pe.charCodeAt(ze-1);if(ne(He)&&ze>1){const Oe=Pe.charCodeAt(ze-2);if(K(Oe))return B(Oe,He)}return He}class ee{get offset(){return this.e}constructor(ze,He=0){this.c=ze,this.d=ze.length,this.e=He}setOffset(ze){this.e=ze}prevCodePoint(){const ze=Y(this.c,this.e);return this.e-=ze>=T.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ze}nextCodePoint(){const ze=G(this.c,this.d,this.e);return this.e+=ze>=T.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ze}eol(){return this.e>=this.d}}e.$Lf=ee;class ue{get offset(){return this.c.offset}constructor(ze,He=0){this.c=new ee(ze,He)}nextGraphemeLength(){const ze=tt.getInstance(),He=this.c,Oe=He.offset;let je=ze.getGraphemeBreakType(He.nextCodePoint());for(;!He.eol();){const he=He.offset,x=ze.getGraphemeBreakType(He.nextCodePoint());if(Ge(je,x)){He.setOffset(he);break}je=x}return He.offset-Oe}prevGraphemeLength(){const ze=tt.getInstance(),He=this.c,Oe=He.offset;let je=ze.getGraphemeBreakType(He.prevCodePoint());for(;He.offset>0;){const he=He.offset,x=ze.getGraphemeBreakType(He.prevCodePoint());if(Ge(x,je)){He.setOffset(he);break}je=x}return Oe-He.offset}eol(){return this.c.eol()}}e.$Mf=ue;function re(Pe,ze){return new ue(Pe,ze).nextGraphemeLength()}function ye(Pe,ze){return new ue(Pe,ze).prevGraphemeLength()}function $e(Pe,ze){ze>0&&ne(Pe.charCodeAt(ze))&&ze--;const He=ze+re(Pe,ze);return[He-ye(Pe,He),He]}function J(Pe){const ze=new ue(Pe);let He=0;for(;!ze.eol();)He++,ze.nextGraphemeLength();return He}let W;function se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ae(Pe){return W||(W=se()),W.test(Pe)}const te=/^[\t\n\r\x20-\x7E]*$/;function ce(Pe){return te.test(Pe)}e.$Tf=/[\u2028\u2029]/;function le(Pe){return e.$Tf.test(Pe)}function Z(Pe){return Pe>=11904&&Pe<=55215||Pe>=63744&&Pe<=64255||Pe>=65281&&Pe<=65374}function oe(Pe){return Pe>=127462&&Pe<=127487||Pe===8986||Pe===8987||Pe===9200||Pe===9203||Pe>=9728&&Pe<=10175||Pe===11088||Pe===11093||Pe>=127744&&Pe<=128591||Pe>=128640&&Pe<=128764||Pe>=128992&&Pe<=129008||Pe>=129280&&Pe<=129535||Pe>=129648&&Pe<=129782}function pe(Pe,ze,He=""){const Oe=Pe.trimStart();if(Oe.length<ze)return Oe;const je=/\b/g;let he=0;for(;je.test(Oe)&&!(Oe.length-je.lastIndex<ze);)he=je.lastIndex,je.lastIndex+=1;return he===0?Oe:He+Oe.substring(he).trimStart()}const we=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Fe(Pe){let ze=0;for(const He of Pe.matchAll(we))ze!==He.index&&(yield{isCode:!1,str:Pe.substring(ze,He.index)}),yield{isCode:!0,str:He[0]},ze=He.index+He[0].length;ze!==Pe.length&&(yield{isCode:!1,str:Pe.substring(ze)})}function We(Pe){return Pe&&(Pe=Pe.replace(we,"")),Pe}const Se=/\\\[.*?\\\]/g;function De(Pe){return We(Pe).replace(Se,"")}e.$2f=String.fromCharCode(h.CharCode.UTF8_BOM);function Te(Pe){return!!(Pe&&Pe.length>0&&Pe.charCodeAt(0)===h.CharCode.UTF8_BOM)}function U(Pe){return Te(Pe)?Pe.substr(1):Pe}function q(Pe,ze){if(!Pe||!ze||Pe.length<ze.length)return!1;const He=ze.length,Oe=Pe.toLowerCase();let je=0,he=-1;for(;je<He;){const x=Oe.indexOf(ze[je],he+1);if(x<0)return!1;he=x,je++}return!0}function X(Pe,ze=!1){return Pe?(ze&&(Pe=Pe.replace(/\\./g,"")),Pe.toLowerCase()!==Pe):!1}function _(Pe){return Pe.charAt(0).toUpperCase()+Pe.slice(1)}function de(Pe,ze=1){if(ze===0)return"";let He=-1;do He=Pe.indexOf(`
`,He+1),ze--;while(ze>0&&He>=0);return He===-1?Pe:(Pe[He-1]==="\r"&&He--,Pe.substr(0,He))}function be(Pe){const ze=h.CharCode.Z-h.CharCode.A+1;return Pe=Pe%(2*ze),Pe<ze?String.fromCharCode(h.CharCode.a+Pe):String.fromCharCode(h.CharCode.A+Pe-ze)}function Ne(Pe){return tt.getInstance().getGraphemeBreakType(Pe)}function Ge(Pe,ze){return Pe===Ke.Other?ze!==Ke.Extend&&ze!==Ke.SpacingMark:Pe===Ke.CR&&ze===Ke.LF?!1:Pe===Ke.Control||Pe===Ke.CR||Pe===Ke.LF||ze===Ke.Control||ze===Ke.CR||ze===Ke.LF?!0:!(Pe===Ke.L&&(ze===Ke.L||ze===Ke.V||ze===Ke.LV||ze===Ke.LVT)||(Pe===Ke.LV||Pe===Ke.V)&&(ze===Ke.V||ze===Ke.T)||(Pe===Ke.LVT||Pe===Ke.T)&&ze===Ke.T||ze===Ke.Extend||ze===Ke.ZWJ||ze===Ke.SpacingMark||Pe===Ke.Prepend||Pe===Ke.ZWJ&&ze===Ke.Extended_Pictographic||Pe===Ke.Regional_Indicator&&ze===Ke.Regional_Indicator)}var Ke;(function(Pe){Pe[Pe.Other=0]="Other",Pe[Pe.Prepend=1]="Prepend",Pe[Pe.CR=2]="CR",Pe[Pe.LF=3]="LF",Pe[Pe.Control=4]="Control",Pe[Pe.Extend=5]="Extend",Pe[Pe.Regional_Indicator=6]="Regional_Indicator",Pe[Pe.SpacingMark=7]="SpacingMark",Pe[Pe.L=8]="L",Pe[Pe.V=9]="V",Pe[Pe.T=10]="T",Pe[Pe.LV=11]="LV",Pe[Pe.LVT=12]="LVT",Pe[Pe.ZWJ=13]="ZWJ",Pe[Pe.Extended_Pictographic=14]="Extended_Pictographic"})(Ke||(e.GraphemeBreakType=Ke={}));class tt{static{this.c=null}static getInstance(){return tt.c||(tt.c=new tt),tt.c}constructor(){this.d=rt()}getGraphemeBreakType(ze){if(ze<32)return ze===h.CharCode.LineFeed?Ke.LF:ze===h.CharCode.CarriageReturn?Ke.CR:Ke.Control;if(ze<127)return Ke.Other;const He=this.d,Oe=He.length/3;let je=1;for(;je<=Oe;)if(ze<He[3*je])je=2*je;else if(ze>He[3*je+1])je=2*je+1;else return He[3*je+2];return Ke.Other}}function rt(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ot(Pe,ze){if(Pe===0)return 0;const He=nt(Pe,ze);if(He!==void 0)return He;const Oe=new ee(ze,Pe);return Oe.prevCodePoint(),Oe.offset}function nt(Pe,ze){const He=new ee(ze,Pe);let Oe=He.prevCodePoint();for(;at(Oe)||Oe===mt.emojiVariantSelector||Oe===mt.enclosingKeyCap;){if(He.offset===0)return;Oe=He.prevCodePoint()}if(!oe(Oe))return;let je=He.offset;return je>0&&He.prevCodePoint()===mt.zwj&&(je=He.offset),je}function at(Pe){return 127995<=Pe&&Pe<=127999}var mt;(function(Pe){Pe[Pe.zwj=8205]="zwj",Pe[Pe.emojiVariantSelector=65039]="emojiVariantSelector",Pe[Pe.enclosingKeyCap=8419]="enclosingKeyCap"})(mt||(mt={})),e.$_f="\xA0";class ht{static{this.c=new C.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new r.$9e({getCacheKey:JSON.stringify},ze=>{function He(ut){const gt=new Map;for(let Dt=0;Dt<ut.length;Dt+=2)gt.set(ut[Dt],ut[Dt+1]);return gt}function Oe(ut,gt){const Dt=new Map(ut);for(const[Ot,Ut]of gt)Dt.set(Ot,Ut);return Dt}function je(ut,gt){if(!ut)return gt;const Dt=new Map;for(const[Ot,Ut]of ut)gt.has(Ot)&&Dt.set(Ot,Ut);return Dt}const he=this.c.value;let x=ze.filter(ut=>!ut.startsWith("_")&&ut in he);x.length===0&&(x=["_default"]);let Ce;for(const ut of x){const gt=He(he[ut]);Ce=je(Ce,gt)}const Xe=He(he._common),et=Oe(Xe,Ce);return new ht(et)})}static getInstance(ze){return ht.d.get(Array.from(ze))}static{this.e=new C.$T(()=>Object.keys(ht.c.value).filter(ze=>!ze.startsWith("_")))}static getLocales(){return ht.e.value}constructor(ze){this.f=ze}isAmbiguous(ze){return this.f.has(ze)}containsAmbiguousCharacter(ze){for(let He=0;He<ze.length;He++){const Oe=ze.codePointAt(He);if(typeof Oe=="number"&&this.isAmbiguous(Oe))return!0}return!1}getPrimaryConfusable(ze){return this.f.get(ze)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$ag=ht;class ct{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(ct.c())),this.d}static isInvisibleCharacter(ze){return ct.e().has(ze)}static containsInvisibleCharacter(ze){for(let He=0;He<ze.length;He++){const Oe=ze.codePointAt(He);if(typeof Oe=="number"&&ct.isInvisibleCharacter(Oe))return!0}return!1}static get codePoints(){return ct.e()}}e.$bg=ct}),define(ke[31],Ie([1,0,26,16,10,12,17]),function(me,e,r,h,C,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ug=R,e.$vg=b,e.$wg=c,e.$xg=I,e.$yg=D,e.$zg=a,e.$Ag=$,e.$Bg=f,e.$Cg=g,e.$Dg=i,e.$Eg=o,e.$Fg=t,e.$Gg=s,e.$Hg=n,e.$Ig=d,e.$Jg=l,e.$Kg=S;function R(y){return y===r.CharCode.Slash||y===r.CharCode.Backslash}function b(y){return y.replace(/[\\/]/g,h.$fc.sep)}function c(y){return y.indexOf("/")===-1&&(y=b(y)),/^[a-zA-Z]:(\/|$)/.test(y)&&(y="/"+y),y}function I(y,k=h.$fc.sep){if(!y)return"";const A=y.length,p=y.charCodeAt(0);if(R(p)){if(R(y.charCodeAt(1))&&!R(y.charCodeAt(2))){let F=3;const N=F;for(;F<A&&!R(y.charCodeAt(F));F++);if(N!==F&&!R(y.charCodeAt(F+1))){for(F+=1;F<A;F++)if(R(y.charCodeAt(F)))return y.slice(0,F+1).replace(/[\\/]/g,k)}}return k}else if(g(p)&&y.charCodeAt(1)===r.CharCode.Colon)return R(y.charCodeAt(2))?y.slice(0,2)+k:y.slice(0,2);let v=y.indexOf("://");if(v!==-1){for(v+=3;v<A;v++)if(R(y.charCodeAt(v)))return y.slice(0,v+1)}return""}function D(y){if(!C.$j||!y||y.length<5)return!1;let k=y.charCodeAt(0);if(k!==r.CharCode.Backslash||(k=y.charCodeAt(1),k!==r.CharCode.Backslash))return!1;let A=2;const p=A;for(;A<y.length&&(k=y.charCodeAt(A),k!==r.CharCode.Backslash);A++);return!(p===A||(k=y.charCodeAt(A+1),isNaN(k)||k===r.CharCode.Backslash))}const u=/[\\/:\*\?"<>\|]/g,P=/[/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(y,k=C.$j){const A=k?u:P;return!(!y||y.length===0||/^\s+$/.test(y)||(A.lastIndex=0,A.test(y))||k&&w.test(y)||y==="."||y===".."||k&&y[y.length-1]==="."||k&&y.length!==y.trim().length||y.length>255)}function $(y,k,A){const p=y===k;return!A||p?p:!y||!k?!1:(0,T.$Df)(y,k)}function f(y,k,A,p=h.sep){if(y===k)return!0;if(!y||!k||k.length>y.length)return!1;if(A){if(!(0,T.$Ef)(y,k))return!1;if(k.length===y.length)return!0;let F=k.length;return k.charAt(k.length-1)===p&&F--,y.charAt(F)===p}return k.charAt(k.length-1)!==p&&(k+=p),y.indexOf(k)===0}function g(y){return y>=r.CharCode.A&&y<=r.CharCode.Z||y>=r.CharCode.a&&y<=r.CharCode.z}function i(y,k){return C.$j&&y.endsWith(":")&&(y+=h.sep),(0,h.$hc)(y)||(y=(0,h.$ic)(k,y)),y=(0,h.$gc)(y),o(y)}function o(y){return C.$j?(y=(0,T.$lf)(y,h.sep),y.endsWith(":")&&(y+=h.sep)):(y=(0,T.$lf)(y,h.sep),y||(y=h.sep)),y}function t(y){const k=(0,h.$gc)(y);return C.$j?y.length>3?!1:s(k)&&(y.length===2||k.charCodeAt(2)===r.CharCode.Backslash):k===h.$fc.sep}function s(y,k=C.$j){return k?g(y.charCodeAt(0))&&y.charCodeAt(1)===r.CharCode.Colon:!1}function n(y,k=C.$j){return s(y,k)?y[0]:void 0}function d(y,k,A){return k.length>y.length?-1:y===k?0:(A&&(y=y.toLowerCase(),k=k.toLowerCase()),y.indexOf(k))}function l(y){const k=y.split(":");let A,p,v;for(const F of k){const N=Number(F);(0,L.$gg)(N)?p===void 0?p=N:v===void 0&&(v=N):A=A?[A,F].join(":"):F}if(!A)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:A,line:p!==void 0?p:void 0,column:v!==void 0?v:p!==void 0?1:void 0}}const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",E="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function S(y,k,A=8){let p="";for(let F=0;F<A;F++){let N;F===0&&C.$j&&!k&&(A===3||A===4)?N=E:N=m,p+=N.charAt(Math.floor(Math.random()*N.length))}let v;return k?v=`${k}-${p}`:v=p,y?(0,h.$ic)(y,v):v}}),define(ke[135],Ie([1,0,26,28,178,12]),function(me,e,r,h,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pk=e.FuzzyScore=e.$Ek=e.$Dk=void 0,e.or=L,e.$Fk=b,e.$Gk=c,e.$Hk=u,e.$Ik=S,e.$Jk=y,e.$Kk=N,e.$Lk=O,e.$Mk=j,e.$Nk=z,e.$Ok=se,e.$Qk=le,e.$Rk=pe,e.$Sk=we,T=Ue(T);function L(...Se){return function(De,Te){for(let U=0,q=Se.length;U<q;U++){const X=Se[U](De,Te);if(X)return X}return null}}e.$Dk=R.bind(void 0,!1),e.$Ek=R.bind(void 0,!0);function R(Se,De,Te){if(!Te||Te.length<De.length)return null;let U;return Se?U=T.$Ef(Te,De):U=Te.indexOf(De)===0,U?De.length>0?[{start:0,end:De.length}]:[]:null}function b(Se,De){const Te=De.toLowerCase().indexOf(Se.toLowerCase());return Te===-1?null:[{start:Te,end:Te+Se.length}]}function c(Se,De){return I(Se.toLowerCase(),De.toLowerCase(),0,0)}function I(Se,De,Te,U){if(Te===Se.length)return[];if(U===De.length)return null;if(Se[Te]===De[U]){let q=null;return(q=I(Se,De,Te+1,U+1))?t({start:U,end:U+1},q):null}return I(Se,De,Te,U+1)}function D(Se){return r.CharCode.a<=Se&&Se<=r.CharCode.z}function u(Se){return r.CharCode.A<=Se&&Se<=r.CharCode.Z}function P(Se){return r.CharCode.Digit0<=Se&&Se<=r.CharCode.Digit9}function w(Se){return Se===r.CharCode.Space||Se===r.CharCode.Tab||Se===r.CharCode.LineFeed||Se===r.CharCode.CarriageReturn}const a=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Se=>a.add(Se.charCodeAt(0)));function $(Se){return w(Se)||a.has(Se)}function f(Se,De){return Se===De||$(Se)&&$(De)}const g=new Map;function i(Se){if(g.has(Se))return g.get(Se);let De;const Te=(0,C.$Bk)(Se);return Te&&(De=Te),g.set(Se,De),De}function o(Se){return D(Se)||u(Se)||P(Se)}function t(Se,De){return De.length===0?De=[Se]:Se.end===De[0].start?De[0].start=Se.start:De.unshift(Se),De}function s(Se,De){for(let Te=De;Te<Se.length;Te++){const U=Se.charCodeAt(Te);if(u(U)||P(U)||Te>0&&!o(Se.charCodeAt(Te-1)))return Te}return Se.length}function n(Se,De,Te,U){if(Te===Se.length)return[];if(U===De.length)return null;if(Se[Te]!==De[U].toLowerCase())return null;{let q=null,X=U+1;for(q=n(Se,De,Te+1,U+1);!q&&(X=s(De,X))<De.length;)q=n(Se,De,Te+1,X),X++;return q===null?null:t({start:U,end:U+1},q)}}function d(Se){let De=0,Te=0,U=0,q=0,X=0;for(let Ge=0;Ge<Se.length;Ge++)X=Se.charCodeAt(Ge),u(X)&&De++,D(X)&&Te++,o(X)&&U++,P(X)&&q++;const _=De/Se.length,de=Te/Se.length,be=U/Se.length,Ne=q/Se.length;return{upperPercent:_,lowerPercent:de,alphaPercent:be,numericPercent:Ne}}function l(Se){const{upperPercent:De,lowerPercent:Te}=Se;return Te===0&&De>.6}function m(Se){const{upperPercent:De,lowerPercent:Te,alphaPercent:U,numericPercent:q}=Se;return Te>.2&&De<.8&&U>.6&&q<.2}function E(Se){let De=0,Te=0,U=0,q=0;for(let X=0;X<Se.length;X++)U=Se.charCodeAt(X),u(U)&&De++,D(U)&&Te++,w(U)&&q++;return(De===0||Te===0)&&q===0?Se.length<=30:De<=5}function S(Se,De){if(!De||(De=De.trim(),De.length===0)||!E(Se))return null;De.length>60&&(De=De.substring(0,60));const Te=d(De);if(!m(Te)){if(!l(Te))return null;De=De.toLowerCase()}let U=null,q=0;for(Se=Se.toLowerCase();q<De.length&&(U=n(Se,De,0,q))===null;)q=s(De,q+1);return U}function y(Se,De,Te=!1){if(!De||De.length===0)return null;let U=null,q=0;for(Se=Se.toLowerCase(),De=De.toLowerCase();q<De.length&&(U=k(Se,De,0,q,Te),U===null);)q=A(De,q+1);return U}function k(Se,De,Te,U,q){let X=0;if(Te===Se.length)return[];if(U===De.length)return null;if(!f(Se.charCodeAt(Te),De.charCodeAt(U))){const be=i(Se.charCodeAt(Te));if(!be)return null;for(let Ne=0;Ne<be.length;Ne++)if(!f(be[Ne],De.charCodeAt(U+Ne)))return null;X+=be.length-1}let _=null,de=U+X+1;if(_=k(Se,De,Te+1,de,q),!q)for(;!_&&(de=A(De,de))<De.length;)_=k(Se,De,Te+1,de,q),de++;if(!_)return null;if(Se.charCodeAt(Te)!==De.charCodeAt(U)){const be=i(Se.charCodeAt(Te));if(!be)return _;for(let Ne=0;Ne<be.length;Ne++)if(be[Ne]!==De.charCodeAt(U+Ne))return _}return t({start:U,end:U+X+1},_)}function A(Se,De){for(let Te=De;Te<Se.length;Te++)if($(Se.charCodeAt(Te))||Te>0&&$(Se.charCodeAt(Te-1)))return Te;return Se.length}const p=L(e.$Ek,S,b),v=L(e.$Ek,S,c),F=new h.$Cc(1e4);function N(Se,De,Te=!1){if(typeof Se!="string"||typeof De!="string")return null;let U=F.get(Se);U||(U=new RegExp(T.$mf(Se),"i"),F.set(Se,U));const q=U.exec(De);return q?[{start:q.index,end:q.index+q[0].length}]:Te?v(Se,De):p(Se,De)}function O(Se,De){const Te=le(Se,Se.toLowerCase(),0,De,De.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Te?z(Te):null}function j(Se,De,Te,U,q,X){const _=Math.min(13,Se.length);for(;Te<_;Te++){const de=le(Se,De,Te,U,q,X,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(de)return de}return[0,X]}function z(Se){if(typeof Se>"u")return[];const De=[],Te=Se[1];for(let U=Se.length-1;U>1;U--){const q=Se[U]+Te,X=De[De.length-1];X&&X.end===q?X.end=q+1:De.push({start:q,end:q+1})}return De}const M=128;function V(){const Se=[],De=[];for(let Te=0;Te<=M;Te++)De[Te]=0;for(let Te=0;Te<=M;Te++)Se.push(De.slice(0));return Se}function K(Se){const De=[];for(let Te=0;Te<=Se;Te++)De[Te]=0;return De}const ne=K(2*M),B=K(2*M),G=V(),Y=V(),ee=V(),ue=!1;function re(Se,De,Te,U,q){function X(de,be,Ne=" "){for(;de.length<be;)de=Ne+de;return de}let _=` |   |${U.split("").map(de=>X(de,3)).join("|")}
`;for(let de=0;de<=Te;de++)de===0?_+=" |":_+=`${De[de-1]}|`,_+=Se[de].slice(0,q+1).map(be=>X(be.toString(),3)).join("|")+`
`;return _}function ye(Se,De,Te,U){Se=Se.substr(De),Te=Te.substr(U),console.log(re(Y,Se,Se.length,Te,Te.length)),console.log(re(ee,Se,Se.length,Te,Te.length)),console.log(re(G,Se,Se.length,Te,Te.length))}function $e(Se,De){if(De<0||De>=Se.length)return!1;const Te=Se.codePointAt(De);switch(Te){case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.Slash:case r.CharCode.Backslash:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:case r.CharCode.DollarSign:case r.CharCode.LessThan:case r.CharCode.GreaterThan:case r.CharCode.OpenParen:case r.CharCode.CloseParen:case r.CharCode.OpenSquareBracket:case r.CharCode.CloseSquareBracket:case r.CharCode.OpenCurlyBrace:case r.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!T.$Wf(Te)}}function J(Se,De){if(De<0||De>=Se.length)return!1;switch(Se.charCodeAt(De)){case r.CharCode.Space:case r.CharCode.Tab:return!0;default:return!1}}function W(Se,De,Te){return De[Se]!==Te[Se]}function se(Se,De,Te,U,q,X,_=!1){for(;De<Te&&q<X;)Se[De]===U[q]&&(_&&(ne[De]=q),De+=1),q+=1;return De===Te}var ae;(function(Se){Se[Se.Diag=1]="Diag",Se[Se.Left=2]="Left",Se[Se.LeftLeft=3]="LeftLeft"})(ae||(ae={}));var te;(function(Se){Se.Default=[-100,0];function De(Te){return!Te||Te.length===2&&Te[0]===-100&&Te[1]===0}Se.isDefault=De})(te||(e.FuzzyScore=te={}));class ce{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(De,Te){this.firstMatchCanBeWeak=De,this.boostFullMatch=Te}}e.$Pk=ce;function le(Se,De,Te,U,q,X,_=ce.default){const de=Se.length>M?M:Se.length,be=U.length>M?M:U.length;if(Te>=de||X>=be||de-Te>be-X||!se(De,Te,de,q,X,be,!0))return;Z(de,be,Te,X,De,q);let Ne=1,Ge=1,Ke=Te,tt=X;const rt=[!1];for(Ne=1,Ke=Te;Ke<de;Ne++,Ke++){const ht=ne[Ke],ct=B[Ke],Pe=Ke+1<de?B[Ke+1]:be;for(Ge=ht-X+1,tt=ht;tt<Pe;Ge++,tt++){let ze=Number.MIN_SAFE_INTEGER,He=!1;tt<=ct&&(ze=oe(Se,De,Ke,Te,U,q,tt,be,X,G[Ne-1][Ge-1]===0,rt));let Oe=0;ze!==Number.MAX_SAFE_INTEGER&&(He=!0,Oe=ze+Y[Ne-1][Ge-1]);const je=tt>ht,he=je?Y[Ne][Ge-1]+(G[Ne][Ge-1]>0?-5:0):0,x=tt>ht+1&&G[Ne][Ge-1]>0,Ce=x?Y[Ne][Ge-2]+(G[Ne][Ge-2]>0?-5:0):0;if(x&&(!je||Ce>=he)&&(!He||Ce>=Oe))Y[Ne][Ge]=Ce,ee[Ne][Ge]=ae.LeftLeft,G[Ne][Ge]=0;else if(je&&(!He||he>=Oe))Y[Ne][Ge]=he,ee[Ne][Ge]=ae.Left,G[Ne][Ge]=0;else if(He)Y[Ne][Ge]=Oe,ee[Ne][Ge]=ae.Diag,G[Ne][Ge]=G[Ne-1][Ge-1]+1;else throw new Error("not possible")}}if(ue&&ye(Se,Te,U,X),!rt[0]&&!_.firstMatchCanBeWeak)return;Ne--,Ge--;const ot=[Y[Ne][Ge],X];let nt=0,at=0;for(;Ne>=1;){let ht=Ge;do{const ct=ee[Ne][ht];if(ct===ae.LeftLeft)ht=ht-2;else if(ct===ae.Left)ht=ht-1;else break}while(ht>=1);nt>1&&De[Te+Ne-1]===q[X+Ge-1]&&!W(ht+X-1,U,q)&&nt+1>G[Ne][ht]&&(ht=Ge),ht===Ge?nt++:nt=1,at||(at=ht),Ne--,Ge=ht-1,ot.push(Ge)}be-X===de&&_.boostFullMatch&&(ot[0]+=2);const mt=at-de;return ot[0]-=mt,ot}function Z(Se,De,Te,U,q,X){let _=Se-1,de=De-1;for(;_>=Te&&de>=U;)q[_]===X[de]&&(B[_]=de,_--),de--}function oe(Se,De,Te,U,q,X,_,de,be,Ne,Ge){if(De[Te]!==X[_])return Number.MIN_SAFE_INTEGER;let Ke=1,tt=!1;return _===Te-U?Ke=Se[Te]===q[_]?7:5:W(_,q,X)&&(_===0||!W(_-1,q,X))?(Ke=Se[Te]===q[_]?7:5,tt=!0):$e(X,_)&&(_===0||!$e(X,_-1))?Ke=5:($e(X,_-1)||J(X,_-1))&&(Ke=5,tt=!0),Ke>1&&Te===U&&(Ge[0]=!0),tt||(tt=W(_,q,X)||$e(X,_-1)||J(X,_-1)),Te===U?_>be&&(Ke-=tt?3:5):Ne?Ke+=tt?2:0:Ke+=tt?0:1,_+1===de&&(Ke-=tt?3:5),Ke}function pe(Se,De,Te,U,q,X,_){return Fe(Se,De,Te,U,q,X,!0,_)}function we(Se,De,Te,U,q,X,_){return Fe(Se,De,Te,U,q,X,!1,_)}function Fe(Se,De,Te,U,q,X,_,de){let be=le(Se,De,Te,U,q,X,de);if(be&&!_)return be;if(Se.length>=3){const Ne=Math.min(7,Se.length-1);for(let Ge=Te+1;Ge<Ne;Ge++){const Ke=We(Se,Ge);if(Ke){const tt=le(Ke,Ke.toLowerCase(),Te,U,q,X,de);tt&&(tt[0]-=3,(!be||tt[0]>be[0])&&(be=tt))}}}return be}function We(Se,De){if(De+1>=Se.length)return;const Te=Se[De],U=Se[De+1];if(Te!==U)return Se.slice(0,De)+U+Te+Se.slice(De+2)}}),define(ke[60],Ie([1,0,12]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$uj=void 0,e.$qj=h,e.$rj=C,e.$sj=T,e.$tj=R,e.$vj=a,r=Ue(r);function h(f){return C(f,0)}function C(f,g){switch(typeof f){case"object":return f===null?T(349,g):Array.isArray(f)?b(f,g):c(f,g);case"string":return R(f,g);case"boolean":return L(f,g);case"number":return T(f,g);case"undefined":return T(937,g);default:return T(617,g)}}function T(f,g){return(g<<5)-g+f|0}function L(f,g){return T(f?433:863,g)}function R(f,g){g=T(149417,g);for(let i=0,o=f.length;i<o;i++)g=T(f.charCodeAt(i),g);return g}function b(f,g){return g=T(104579,g),f.reduce((i,o)=>C(o,i),g)}function c(f,g){return g=T(181387,g),Object.keys(f).sort().reduce((i,o)=>(i=R(o,i),C(f[o],i)),g)}class I{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=C(g,this.g),this.g}}e.$uj=I;var D;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(D||(D={}));function u(f,g,i=32){const o=i-g,t=~((1<<o)-1);return(f<<g|(t&f)>>>o)>>>0}function P(f,g=0,i=f.byteLength,o=0){for(let t=0;t<i;t++)f[g+t]=o}function w(f,g,i="0"){for(;f.length<g;)f=i+f;return f}function a(f,g=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(i=>i.toString(16).padStart(2,"0")).join(""):w((f>>>0).toString(16),g/4)}class ${static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(D.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const i=g.length;if(i===0)return;const o=this.p;let t=this.r,s=this.u,n,d;for(s!==0?(n=s,d=-1,s=0):(n=g.charCodeAt(0),d=0);;){let l=n;if(r.$Hf(n))if(d+1<i){const m=g.charCodeAt(d+1);r.$If(m)?(d++,l=r.$Jf(n,m)):l=D.UNICODE_REPLACEMENT}else{s=n;break}else r.$If(n)&&(l=D.UNICODE_REPLACEMENT);if(t=this.w(o,t,l),d++,d<i)n=g.charCodeAt(d);else break}this.r=t,this.u=s}w(g,i,o){return o<128?g[i++]=o:o<2048?(g[i++]=192|(o&1984)>>>6,g[i++]=128|(o&63)>>>0):o<65536?(g[i++]=224|(o&61440)>>>12,g[i++]=128|(o&4032)>>>6,g[i++]=128|(o&63)>>>0):(g[i++]=240|(o&1835008)>>>18,g[i++]=128|(o&258048)>>>12,g[i++]=128|(o&4032)>>>6,g[i++]=128|(o&63)>>>0),i>=D.BLOCK_SIZE&&(this.y(),i-=D.BLOCK_SIZE,this.t+=D.BLOCK_SIZE,g[0]=g[D.BLOCK_SIZE+0],g[1]=g[D.BLOCK_SIZE+1],g[2]=g[D.BLOCK_SIZE+2]),i}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,D.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),a(this.h)+a(this.l)+a(this.m)+a(this.n)+a(this.o)}x(){this.p[this.r++]=128,P(this.p,this.r),this.r>56&&(this.y(),P(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=$.g,i=this.q;for(let S=0;S<64;S+=4)g.setUint32(S,i.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)g.setUint32(S,u(g.getUint32(S-12,!1)^g.getUint32(S-32,!1)^g.getUint32(S-56,!1)^g.getUint32(S-64,!1),1),!1);let o=this.h,t=this.l,s=this.m,n=this.n,d=this.o,l,m,E;for(let S=0;S<80;S++)S<20?(l=t&s|~t&n,m=1518500249):S<40?(l=t^s^n,m=1859775393):S<60?(l=t&s|t&n|s&n,m=2400959708):(l=t^s^n,m=3395469782),E=u(o,5)+l+d+m+g.getUint32(S*4,!1)&4294967295,d=n,n=s,s=u(t,30),t=o,o=E;this.h=this.h+o&4294967295,this.l=this.l+t&4294967295,this.m=this.m+s&4294967295,this.n=this.n+n&4294967295,this.o=this.o+d&4294967295}}e.$wj=$}),define(ke[136],Ie([1,0,26,134,135,60,16,10,12]),function(me,e,r,h,C,T,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jr=D,e.$Kr=f,e.$Lr=l,e.$Mr=p,e.$Nr=z,e.$Or=V;const c=0,I=[c,[]];function D(K,ne,B,G){if(!K||!ne)return I;const Y=K.length,ee=ne.length;if(Y<ee)return I;const ue=K.toLowerCase();return u(ne,B,ee,K,ue,Y,G)}function u(K,ne,B,G,Y,ee,ue){const re=[],ye=[];for(let se=0;se<B;se++){const ae=se*ee,te=ae-ee,ce=se>0,le=K[se],Z=ne[se];for(let oe=0;oe<ee;oe++){const pe=oe>0,we=ae+oe,Fe=we-1,We=te+oe-1,Se=pe?re[Fe]:0,De=ce&&pe?re[We]:0,Te=ce&&pe?ye[We]:0;let U;!De&&ce?U=0:U=P(le,Z,G,Y,oe,Te),U&&De+U>=Se&&(ue||ce||Y.startsWith(ne,oe))?(ye[we]=Te+1,re[we]=De+U):(ye[we]=c,re[we]=Se)}}const $e=[];let J=B-1,W=ee-1;for(;J>=0&&W>=0;){const se=J*ee+W;ye[se]===c||($e.push(W),J--),W--}return[re[B*ee-1],$e.reverse()]}function P(K,ne,B,G,Y,ee){let ue=0;if(!w(ne,G[Y]))return ue;if(ue+=1,ee>0&&(ue+=ee*5),K===B[Y]&&(ue+=1),Y===0)ue+=8;else{const re=a(B.charCodeAt(Y-1));re?ue+=re:(0,C.$Hk)(B.charCodeAt(Y))&&ee===0&&(ue+=2)}return ue}function w(K,ne){return K===ne?!0:K==="/"||K==="\\"?ne==="/"||ne==="\\":!1}function a(K){switch(K){case r.CharCode.Slash:case r.CharCode.Backslash:return 5;case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:return 4;default:return 0}}const $=[void 0,[]];function f(K,ne,B=0,G=0){const Y=ne;return Y.values&&Y.values.length>1?g(K,Y.values,B,G):i(K,ne,B,G)}function g(K,ne,B,G){let Y=0;const ee=[];for(const ue of ne){const[re,ye]=i(K,ue,B,G);if(typeof re!="number")return $;Y+=re,ee.push(...ye)}return[Y,k(ee)]}function i(K,ne,B,G){const Y=(0,C.$Qk)(ne.original,ne.originalLowercase,B,K,K.toLowerCase(),G,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Y?[Y[0],(0,C.$Nk)(Y)]:$}const o=Object.freeze({score:0}),t=1<<18,s=1<<17,n=65536;function d(K,ne,B,G){const Y=G.values?G.values:[G];return(0,T.$qj)({[G.normalized]:{values:Y.map(ue=>({value:ue.normalized,expectContiguousMatch:ue.expectContiguousMatch})),label:K,description:ne,allowNonContiguousMatches:B}})}function l(K,ne,B,G,Y){if(!K||!ne.normalized)return o;const ee=G.getItemLabel(K);if(!ee)return o;const ue=G.getItemDescription(K),re=d(ee,ue,B,ne),ye=Y[re];if(ye)return ye;const $e=m(ee,ue,G.getItemPath(K),ne,B);return Y[re]=$e,$e}function m(K,ne,B,G,Y){const ee=!B||!G.containsPathSeparator;return B&&(R.$l?G.pathNormalized===B:(0,b.$Df)(G.pathNormalized,B))?{score:t,labelMatch:[{start:0,end:K.length}],descriptionMatch:ne?[{start:0,end:ne.length}]:void 0}:G.values&&G.values.length>1?E(K,ne,B,G.values,ee,Y):S(K,ne,B,G,ee,Y)}function E(K,ne,B,G,Y,ee){let ue=0;const re=[],ye=[];for(const $e of G){const{score:J,labelMatch:W,descriptionMatch:se}=S(K,ne,B,$e,Y,ee);if(J===c)return o;ue+=J,W&&re.push(...W),se&&ye.push(...se)}return{score:ue,labelMatch:k(re),descriptionMatch:k(ye)}}function S(K,ne,B,G,Y,ee){if(Y||!ne){const[ue,re]=D(K,G.normalized,G.normalizedLowercase,ee&&!G.expectContiguousMatch);if(ue){const ye=(0,C.$Ek)(G.normalized,K);let $e;if(ye){$e=s;const J=Math.round(G.normalized.length/K.length*100);$e+=J}else $e=n;return{score:$e+ue,labelMatch:ye||y(re)}}}if(ne){let ue=ne;B&&(ue=`${ne}${L.sep}`);const re=ue.length,ye=`${ue}${K}`,[$e,J]=D(ye,G.normalized,G.normalizedLowercase,ee&&!G.expectContiguousMatch);if($e){const W=y(J),se=[],ae=[];return W.forEach(te=>{te.start<re&&te.end>re?(se.push({start:0,end:te.end-re}),ae.push({start:te.start,end:re})):te.start>=re?se.push({start:te.start-re,end:te.end-re}):ae.push(te)}),{score:$e,labelMatch:se,descriptionMatch:ae}}}return o}function y(K){const ne=[];if(!K)return ne;let B;for(const G of K)B&&B.end===G?B.end+=1:(B={start:G,end:G+1},ne.push(B));return ne}function k(K){const ne=K.sort((Y,ee)=>Y.start-ee.start),B=[];let G;for(const Y of ne)!G||!A(G,Y)?(G=Y,B.push(Y)):(G.start=Math.min(G.start,Y.start),G.end=Math.max(G.end,Y.end));return B}function A(K,ne){return!(K.end<ne.start||ne.end<K.start)}function p(K,ne,B,G,Y,ee){const ue=l(K,B,G,Y,ee),re=l(ne,B,G,Y,ee),ye=ue.score,$e=re.score;if((ye===t||$e===t)&&ye!==$e)return ye===t?-1:1;if(ye>n||$e>n){if(ye!==$e)return ye>$e?-1:1;if(ye<s&&$e<s){const le=F(ue.labelMatch,re.labelMatch);if(le!==0)return le}const te=Y.getItemLabel(K)||"",ce=Y.getItemLabel(ne)||"";if(te.length!==ce.length)return te.length-ce.length}if(ye!==$e)return ye>$e?-1:1;const J=Array.isArray(ue.labelMatch)&&ue.labelMatch.length>0,W=Array.isArray(re.labelMatch)&&re.labelMatch.length>0;if(J&&!W)return-1;if(W&&!J)return 1;const se=v(K,ue,Y),ae=v(ne,re,Y);return se&&ae&&se!==ae?ae>se?-1:1:N(K,ne,B,Y)}function v(K,ne,B){let G=-1,Y=-1;if(ne.descriptionMatch&&ne.descriptionMatch.length?G=ne.descriptionMatch[0].start:ne.labelMatch&&ne.labelMatch.length&&(G=ne.labelMatch[0].start),ne.labelMatch&&ne.labelMatch.length){if(Y=ne.labelMatch[ne.labelMatch.length-1].end,ne.descriptionMatch&&ne.descriptionMatch.length){const ee=B.getItemDescription(K);ee&&(Y+=ee.length)}}else ne.descriptionMatch&&ne.descriptionMatch.length&&(Y=ne.descriptionMatch[ne.descriptionMatch.length-1].end);return Y-G}function F(K,ne){if(!K&&!ne||(!K||!K.length)&&(!ne||!ne.length))return 0;if(!ne||!ne.length)return-1;if(!K||!K.length)return 1;const B=K[0].start,Y=K[K.length-1].end-B,ee=ne[0].start,re=ne[ne.length-1].end-ee;return Y===re?0:re<Y?1:-1}function N(K,ne,B,G){const Y=G.getItemLabel(K)||"",ee=G.getItemLabel(ne)||"",ue=G.getItemDescription(K),re=G.getItemDescription(ne),ye=Y.length+(ue?ue.length:0),$e=ee.length+(re?re.length:0);if(ye!==$e)return ye-$e;const J=G.getItemPath(K),W=G.getItemPath(ne);return J&&W&&J.length!==W.length?J.length-W.length:Y!==ee?(0,h.$Hr)(Y,ee,B.normalized):ue&&re&&ue!==re?(0,h.$Hr)(ue,re,B.normalized):J&&W&&J!==W?(0,h.$Hr)(J,W,B.normalized):0}function O(K){return K.startsWith('"')&&K.endsWith('"')}const j=" ";function z(K){typeof K!="string"&&(K="");const ne=K.toLowerCase(),{pathNormalized:B,normalized:G,normalizedLowercase:Y}=M(K),ee=B.indexOf(L.sep)>=0,ue=O(K);let re;const ye=K.split(j);if(ye.length>1)for(const $e of ye){const J=O($e),{pathNormalized:W,normalized:se,normalizedLowercase:ae}=M($e);se&&(re||(re=[]),re.push({original:$e,originalLowercase:$e.toLowerCase(),pathNormalized:W,normalized:se,normalizedLowercase:ae,expectContiguousMatch:J}))}return{original:K,originalLowercase:ne,pathNormalized:B,normalized:G,normalizedLowercase:Y,values:re,containsPathSeparator:ee,expectContiguousMatch:ue}}function M(K){let ne;R.$j?ne=K.replace(/\//g,L.sep):ne=K.replace(/\\/g,L.sep);const B=(0,b.$nf)(ne).replace(/\s|"/g,"");return{pathNormalized:ne,normalized:B,normalizedLowercase:B.toLowerCase()}}function V(K){return Array.isArray(K)?z(K.map(ne=>ne.original).join(j)):z(K.original)}}),define(ke[137],Ie([1,0,135,12,50]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=b,e.$Uk=I,e.$Vk=u,e.$Wk=P,e.$Xk=a,e.$Yk=$;const T="$(",L=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${L.source}`,"g");function b(f){return f.replace(R,(g,i)=>i?g:`\\${g}`)}const c=new RegExp(`\\\\${L.source}`,"g");function I(f){return f.replace(c,g=>`\\${g}`)}const D=new RegExp(`(\\s)?(\\\\)?${L.source}(\\s)?`,"g");function u(f){return f.indexOf(T)===-1?f:f.replace(D,(g,i,o,t)=>o?g:i||t||"")}function P(f){return f?f.replace(/\$\((.*?)\)/g,(g,i)=>` ${i} `).trim():""}const w=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(f){w.lastIndex=0;let g="";const i=[];let o=0;for(;;){const t=w.lastIndex,s=w.exec(f),n=f.substring(t,s?.index);if(n.length>0){g+=n;for(let d=0;d<n.length;d++)i.push(o)}if(!s)break;o+=s[0].length}return{text:g,iconOffsets:i}}function $(f,g,i=!1){const{text:o,iconOffsets:t}=g;if(!t||t.length===0)return(0,r.$Kk)(f,o,i);const s=(0,h.$kf)(o," "),n=o.length-s.length,d=(0,r.$Kk)(f,s,i);if(d)for(const l of d){const m=t[l.start+n]+n;l.start+=m,l.end+=m}return d}}),define(ke[43],Ie([1,0,12]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r=Ue(r);var h;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(h||(h={})),function(C){const T="error",L="warning",R="warn",b="info",c="ignore";function I(u){return u?r.$Df(T,u)?C.Error:r.$Df(L,u)||r.$Df(R,u)?C.Warning:r.$Df(b,u)?C.Info:C.Ignore:C.Ignore}C.fromValue=I;function D(u){switch(u){case C.Error:return T;case C.Warning:return L;case C.Info:return b;default:return c}}C.toString=D}(h||(h={})),e.default=h}),define(ke[84],Ie([1,0,18,26,12]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=void 0;class T{constructor(){this.b="",this.c=0}reset(w){return this.b=w,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(w){const a=w.charCodeAt(0),$=this.b.charCodeAt(this.c);return a-$}value(){return this.b[this.c]}}e.$Ei=T;class L{constructor(w=!0){this.e=w}reset(w){return this.b=w,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let w=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===h.CharCode.Period)if(w)this.c++;else break;else w=!1;return this}cmp(w){return this.e?(0,C.$xf)(w,this.b,0,w.length,this.c,this.d):(0,C.$zf)(w,this.b,0,w.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Fi=L;class R{constructor(w=!0,a=!0){this.f=w,this.g=a}reset(w){this.d=0,this.e=0,this.b=w,this.c=w.length;for(let a=w.length-1;a>=0;a--,this.c--){const $=this.b.charCodeAt(a);if(!($===h.CharCode.Slash||this.f&&$===h.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let w=!0;for(;this.e<this.c;this.e++){const a=this.b.charCodeAt(this.e);if(a===h.CharCode.Slash||this.f&&a===h.CharCode.Backslash)if(w)this.d++;else break;else w=!1}return this}cmp(w){return this.g?(0,C.$xf)(w,this.b,0,w.length,this.d,this.e):(0,C.$zf)(w,this.b,0,w.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Gi=R;var b;(function(P){P[P.Scheme=1]="Scheme",P[P.Authority=2]="Authority",P[P.Path=3]="Path",P[P.Query=4]="Query",P[P.Fragment=5]="Fragment"})(b||(b={}));class c{constructor(w,a){this.f=w,this.g=a,this.d=[],this.e=0}reset(w){return this.c=w,this.d=[],this.c.scheme&&this.d.push(b.Scheme),this.c.authority&&this.d.push(b.Authority),this.c.path&&(this.b=new R(!1,!this.f(w)),this.b.reset(w.path),this.b.value()&&this.d.push(b.Path)),this.g(w)||(this.c.query&&this.d.push(b.Query),this.c.fragment&&this.d.push(b.Fragment)),this.e=0,this}next(){return this.d[this.e]===b.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===b.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(w){if(this.d[this.e]===b.Scheme)return(0,C.$yf)(w,this.c.scheme);if(this.d[this.e]===b.Authority)return(0,C.$yf)(w,this.c.authority);if(this.d[this.e]===b.Path)return this.b.cmp(w);if(this.d[this.e]===b.Query)return(0,C.$wf)(w,this.c.query);if(this.d[this.e]===b.Fragment)return(0,C.$wf)(w,this.c.fragment);throw new Error}value(){if(this.d[this.e]===b.Scheme)return this.c.scheme;if(this.d[this.e]===b.Authority)return this.c.authority;if(this.d[this.e]===b.Path)return this.b.value();if(this.d[this.e]===b.Query)return this.c.query;if(this.d[this.e]===b.Fragment)return this.c.fragment;throw new Error}}e.$Hi=c;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const w=this.right;return this.right=w.left,w.left=this,this.updateHeight(),w.updateHeight(),w}rotateRight(){const w=this.left;return this.left=w.right,w.right=this,this.updateHeight(),w.updateHeight(),w}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var D;(function(P){P[P.Left=-1]="Left",P[P.Mid=0]="Mid",P[P.Right=1]="Right"})(D||(D={}));class u{static forUris(w=()=>!1,a=()=>!1){return new u(new c(w,a))}static forPaths(w=!1){return new u(new R(void 0,!w))}static forStrings(){return new u(new T)}static forConfigKeys(){return new u(new L)}constructor(w){this.b=w}clear(){this.c=void 0}fill(w,a){if(a){const $=a.slice(0);(0,r.$Vb)($);for(const f of $)this.set(f,w)}else{const $=w.slice(0);(0,r.$Vb)($);for(const f of $)this.set(f[0],f[1])}}set(w,a){const $=this.b.reset(w);let f;this.c||(this.c=new I,this.c.segment=$.value());const g=[];for(f=this.c;;){const o=$.cmp(f.segment);if(o>0)f.left||(f.left=new I,f.left.segment=$.value()),g.push([D.Left,f]),f=f.left;else if(o<0)f.right||(f.right=new I,f.right.segment=$.value()),g.push([D.Right,f]),f=f.right;else if($.hasNext())$.next(),f.mid||(f.mid=new I,f.mid.segment=$.value()),g.push([D.Mid,f]),f=f.mid;else break}const i=f.value;f.value=a,f.key=w;for(let o=g.length-1;o>=0;o--){const t=g[o][1];t.updateHeight();const s=t.balanceFactor();if(s<-1||s>1){const n=g[o][0],d=g[o+1][0];if(n===D.Right&&d===D.Right)g[o][1]=t.rotateLeft();else if(n===D.Left&&d===D.Left)g[o][1]=t.rotateRight();else if(n===D.Right&&d===D.Left)t.right=g[o+1][1]=g[o+1][1].rotateRight(),g[o][1]=t.rotateLeft();else if(n===D.Left&&d===D.Right)t.left=g[o+1][1]=g[o+1][1].rotateLeft(),g[o][1]=t.rotateRight();else throw new Error;if(o>0)switch(g[o-1][0]){case D.Left:g[o-1][1].left=g[o][1];break;case D.Right:g[o-1][1].right=g[o][1];break;case D.Mid:g[o-1][1].mid=g[o][1];break}else this.c=g[0][1]}}return i}get(w){return this.d(w)?.value}d(w){const a=this.b.reset(w);let $=this.c;for(;$;){const f=a.cmp($.segment);if(f>0)$=$.left;else if(f<0)$=$.right;else if(a.hasNext())a.next(),$=$.mid;else break}return $}has(w){const a=this.d(w);return!(a?.value===void 0&&a?.mid===void 0)}delete(w){return this.e(w,!1)}deleteSuperstr(w){return this.e(w,!0)}e(w,a){const $=this.b.reset(w),f=[];let g=this.c;for(;g;){const i=$.cmp(g.segment);if(i>0)f.push([D.Left,g]),g=g.left;else if(i<0)f.push([D.Right,g]),g=g.right;else if($.hasNext())$.next(),f.push([D.Mid,g]),g=g.mid;else break}if(g){if(a?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const i=this.f(g.right);if(i.key){const{key:o,value:t,segment:s}=i;this.e(i.key,!1),g.key=o,g.value=t,g.segment=s}}else{const i=g.left??g.right;if(f.length>0){const[o,t]=f[f.length-1];switch(o){case D.Left:t.left=i;break;case D.Mid:t.mid=i;break;case D.Right:t.right=i;break}}else this.c=i}for(let i=f.length-1;i>=0;i--){const o=f[i][1];o.updateHeight();const t=o.balanceFactor();if(t>1?(o.right.balanceFactor()>=0||(o.right=o.right.rotateRight()),f[i][1]=o.rotateLeft()):t<-1&&(o.left.balanceFactor()<=0||(o.left=o.left.rotateLeft()),f[i][1]=o.rotateRight()),i>0)switch(f[i-1][0]){case D.Left:f[i-1][1].left=f[i][1];break;case D.Right:f[i-1][1].right=f[i][1];break;case D.Mid:f[i-1][1].mid=f[i][1];break}else this.c=f[0][1]}}}f(w){for(;w.left;)w=w.left;return w}findSubstr(w){const a=this.b.reset(w);let $=this.c,f;for(;$;){const g=a.cmp($.segment);if(g>0)$=$.left;else if(g<0)$=$.right;else if(a.hasNext())a.next(),f=$.value||f,$=$.mid;else break}return $&&$.value||f}findSuperstr(w){return this.g(w,!1)}g(w,a){const $=this.b.reset(w);let f=this.c;for(;f;){const g=$.cmp(f.segment);if(g>0)f=f.left;else if(g<0)f=f.right;else if($.hasNext())$.next(),f=f.mid;else return f.mid?this.h(f.mid):a?f.value:void 0}}hasElementOrSubtree(w){return this.g(w,!0)!==void 0}forEach(w){for(const[a,$]of this)w($,a)}*[Symbol.iterator](){yield*this.h(this.c)}h(w){const a=[];return this.j(w,a),a[Symbol.iterator]()}j(w,a){w&&(w.left&&this.j(w.left,a),w.value&&a.push([w.key,w.value]),w.mid&&this.j(w.mid,a),w.right&&this.j(w.right,a))}_isBalanced(){const w=a=>{if(!a)return!0;const $=a.balanceFactor();return $<-1||$>1?!1:w(a.left)&&w(a.right)};return w(this.c)}}e.$Ii=u}),define(ke[2],Ie([1,0,26,40,16,10]),function(me,e,r,h,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$uc=$,e.$vc=s,C=Ue(C);const L=/^\w[\w\d+.-]*$/,R=/^\//,b=/^\/\//;function c(E,S){if(!E.scheme&&S)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${E.authority}", path: "${E.path}", query: "${E.query}", fragment: "${E.fragment}"}`);if(E.scheme&&!L.test(E.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(E.path){if(E.authority){if(!R.test(E.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(b.test(E.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(E,S){return!E&&!S?"file":E}function D(E,S){switch(E){case"https":case"http":case"file":S?S[0]!==P&&(S=P+S):S=P;break}return S}const u="",P="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class a{static isUri(S){return S instanceof a?!0:S?typeof S.authority=="string"&&typeof S.fragment=="string"&&typeof S.path=="string"&&typeof S.query=="string"&&typeof S.scheme=="string"&&typeof S.fsPath=="string"&&typeof S.with=="function"&&typeof S.toString=="function":!1}constructor(S,y,k,A,p,v=!1){typeof S=="object"?(this.scheme=S.scheme||u,this.authority=S.authority||u,this.path=S.path||u,this.query=S.query||u,this.fragment=S.fragment||u):(this.scheme=I(S,v),this.authority=y||u,this.path=D(this.scheme,k||u),this.query=A||u,this.fragment=p||u,c(this,v))}get fsPath(){return s(this,!1)}with(S){if(!S)return this;let{scheme:y,authority:k,path:A,query:p,fragment:v}=S;return y===void 0?y=this.scheme:y===null&&(y=u),k===void 0?k=this.authority:k===null&&(k=u),A===void 0?A=this.path:A===null&&(A=u),p===void 0?p=this.query:p===null&&(p=u),v===void 0?v=this.fragment:v===null&&(v=u),y===this.scheme&&k===this.authority&&A===this.path&&p===this.query&&v===this.fragment?this:new g(y,k,A,p,v)}static parse(S,y=!1){const k=w.exec(S);return k?new g(k[2]||u,m(k[4]||u),m(k[5]||u),m(k[7]||u),m(k[9]||u),y):new g(u,u,u,u,u)}static file(S){let y=u;if(T.$j&&(S=S.replace(/\\/g,P)),S[0]===P&&S[1]===P){const k=S.indexOf(P,2);k===-1?(y=S.substring(2),S=P):(y=S.substring(2,k),S=S.substring(k)||P)}return new g("file",y,S,u,u)}static from(S,y){return new g(S.scheme,S.authority,S.path,S.query,S.fragment,y)}static joinPath(S,...y){if(!S.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let k;return T.$j&&S.scheme==="file"?k=a.file(C.$ec.join(s(S,!0),...y)).path:k=C.$fc.join(S.path,...y),S.with({path:k})}toString(S=!1){return n(this,S)}toJSON(){return this}static revive(S){if(S){if(S instanceof a)return S;{const y=new g(S);return y._formatted=S.external??null,y._fsPath=S._sep===f?S.fsPath??null:null,y}}else return S}}e.URI=a;function $(E){return!E||typeof E!="object"?!1:typeof E.scheme=="string"&&(typeof E.authority=="string"||typeof E.authority>"u")&&(typeof E.path=="string"||typeof E.path>"u")&&(typeof E.query=="string"||typeof E.query>"u")&&(typeof E.fragment=="string"||typeof E.fragment>"u")}const f=T.$j?1:void 0;class g extends a{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=s(this,!1)),this._fsPath}toString(S=!1){return S?n(this,!0):(this._formatted||(this._formatted=n(this,!1)),this._formatted)}toJSON(){const S={$mid:h.MarshalledId.Uri};return this._fsPath&&(S.fsPath=this._fsPath,S._sep=f),this._formatted&&(S.external=this._formatted),this.path&&(S.path=this.path),this.scheme&&(S.scheme=this.scheme),this.authority&&(S.authority=this.authority),this.query&&(S.query=this.query),this.fragment&&(S.fragment=this.fragment),S}}const i={[r.CharCode.Colon]:"%3A",[r.CharCode.Slash]:"%2F",[r.CharCode.QuestionMark]:"%3F",[r.CharCode.Hash]:"%23",[r.CharCode.OpenSquareBracket]:"%5B",[r.CharCode.CloseSquareBracket]:"%5D",[r.CharCode.AtSign]:"%40",[r.CharCode.ExclamationMark]:"%21",[r.CharCode.DollarSign]:"%24",[r.CharCode.Ampersand]:"%26",[r.CharCode.SingleQuote]:"%27",[r.CharCode.OpenParen]:"%28",[r.CharCode.CloseParen]:"%29",[r.CharCode.Asterisk]:"%2A",[r.CharCode.Plus]:"%2B",[r.CharCode.Comma]:"%2C",[r.CharCode.Semicolon]:"%3B",[r.CharCode.Equals]:"%3D",[r.CharCode.Space]:"%20"};function o(E,S,y){let k,A=-1;for(let p=0;p<E.length;p++){const v=E.charCodeAt(p);if(v>=r.CharCode.a&&v<=r.CharCode.z||v>=r.CharCode.A&&v<=r.CharCode.Z||v>=r.CharCode.Digit0&&v<=r.CharCode.Digit9||v===r.CharCode.Dash||v===r.CharCode.Period||v===r.CharCode.Underline||v===r.CharCode.Tilde||S&&v===r.CharCode.Slash||y&&v===r.CharCode.OpenSquareBracket||y&&v===r.CharCode.CloseSquareBracket||y&&v===r.CharCode.Colon)A!==-1&&(k+=encodeURIComponent(E.substring(A,p)),A=-1),k!==void 0&&(k+=E.charAt(p));else{k===void 0&&(k=E.substr(0,p));const F=i[v];F!==void 0?(A!==-1&&(k+=encodeURIComponent(E.substring(A,p)),A=-1),k+=F):A===-1&&(A=p)}}return A!==-1&&(k+=encodeURIComponent(E.substring(A))),k!==void 0?k:E}function t(E){let S;for(let y=0;y<E.length;y++){const k=E.charCodeAt(y);k===r.CharCode.Hash||k===r.CharCode.QuestionMark?(S===void 0&&(S=E.substr(0,y)),S+=i[k]):S!==void 0&&(S+=E[y])}return S!==void 0?S:E}function s(E,S){let y;return E.authority&&E.path.length>1&&E.scheme==="file"?y=`//${E.authority}${E.path}`:E.path.charCodeAt(0)===r.CharCode.Slash&&(E.path.charCodeAt(1)>=r.CharCode.A&&E.path.charCodeAt(1)<=r.CharCode.Z||E.path.charCodeAt(1)>=r.CharCode.a&&E.path.charCodeAt(1)<=r.CharCode.z)&&E.path.charCodeAt(2)===r.CharCode.Colon?S?y=E.path.substr(1):y=E.path[1].toLowerCase()+E.path.substr(2):y=E.path,T.$j&&(y=y.replace(/\//g,"\\")),y}function n(E,S){const y=S?t:o;let k="",{scheme:A,authority:p,path:v,query:F,fragment:N}=E;if(A&&(k+=A,k+=":"),(p||A==="file")&&(k+=P,k+=P),p){let O=p.indexOf("@");if(O!==-1){const j=p.substr(0,O);p=p.substr(O+1),O=j.lastIndexOf(":"),O===-1?k+=y(j,!1,!1):(k+=y(j.substr(0,O),!1,!1),k+=":",k+=y(j.substr(O+1),!1,!0)),k+="@"}p=p.toLowerCase(),O=p.lastIndexOf(":"),O===-1?k+=y(p,!1,!0):(k+=y(p.substr(0,O),!1,!0),k+=p.substr(O))}if(v){if(v.length>=3&&v.charCodeAt(0)===r.CharCode.Slash&&v.charCodeAt(2)===r.CharCode.Colon){const O=v.charCodeAt(1);O>=r.CharCode.A&&O<=r.CharCode.Z&&(v=`/${String.fromCharCode(O+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===r.CharCode.Colon){const O=v.charCodeAt(0);O>=r.CharCode.A&&O<=r.CharCode.Z&&(v=`${String.fromCharCode(O+32)}:${v.substr(2)}`)}k+=y(v,!0,!1)}return F&&(k+="?",k+=y(F,!1,!1)),N&&(k+="#",k+=S?N:o(N,!1,!1)),k}function d(E){try{return decodeURIComponent(E)}catch{return E.length>3?E.substr(0,3)+d(E.substr(3)):E}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function m(E){return E.match(l)?E.replace(l,S=>d(S)):E}}),define(ke[187],Ie([1,0,2]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=h,e.$ar=C,e.$br=T,e.log=R;function h(c){const I=c;return I&&typeof I.type=="string"&&typeof I.severity=="string"}function C(c){const I=[];let D;try{const u=JSON.parse(c.arguments),P=u[u.length-1];P&&P.__$stack&&(u.pop(),D=P.__$stack),I.push(...u)}catch{I.push("Unable to log remote console arguments",c.arguments)}return{args:I,stack:D}}function T(c){if(typeof c!="string")return T(C(c).stack);const I=c;if(I){const D=L(I),u=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(D||"");if(u&&u.length===4)return{uri:r.URI.file(u[1]),line:Number(u[2]),column:Number(u[3])}}}function L(c){if(!c)return c;const I=c.indexOf(`
`);return I===-1?c:c.substring(0,I)}function R(c,I){const{args:D,stack:u}=C(c),P=typeof D[0]=="string"&&D.length===1;let w=L(u);w&&(w=`(${w.trim()})`);let a=[];if(typeof D[0]=="string"?w&&P?a=[`%c[${I}] %c${D[0]} %c${w}`,b("blue"),b(""),b("grey")]:a=[`%c[${I}] %c${D[0]}`,b("blue"),b(""),...D.slice(1)]:a=[`%c[${I}]%`,b("blue"),...D],w&&!P&&a.push(w),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,a)}function b(c){return`color: ${c}`}}),define(ke[51],Ie([1,0,21,2,40]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=T,e.$$h=L,e.$_h=b;function T(c){return JSON.stringify(c,R)}function L(c){let I=JSON.parse(c);return I=b(I),I}function R(c,I){return I instanceof RegExp?{$mid:C.MarshalledId.Regexp,source:I.source,flags:I.flags}:I}function b(c,I=0){if(!c||I>200)return c;if(typeof c=="object"){switch(c.$mid){case C.MarshalledId.Uri:return h.URI.revive(c);case C.MarshalledId.Regexp:return new RegExp(c.source,c.flags);case C.MarshalledId.Date:return new Date(c.source)}if(c instanceof r.$Le||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let D=0;D<c.length;++D)c[D]=b(c[D],I+1);else for(const D in c)Object.hasOwnProperty.call(c,D)&&(c[D]=b(c[D],I+1))}return c}}),define(ke[14],Ie([1,0,13,10,12,2,16]),function(me,e,r,h,C,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Pg=e.$Og=e.$Ng=e.Schemas=void 0,e.$Lg=b,e.$Mg=c,e.$Qg=D,r=Ue(r),h=Ue(h),L=Ue(L);var R;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeManagedRemoteResource="vscode-managed-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.vscodeChatCodeBlock="vscode-chat-code-block",w.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",w.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",w.vscodeChatSesssion="vscode-chat-editor",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm",w.commentsInput="comment",w.codeSetting="code-setting"})(R||(e.Schemas=R={}));function b(w,a){return T.URI.isUri(w)?(0,C.$Df)(w.scheme,a):(0,C.$Ef)(w,a+":")}function c(w,...a){return a.some($=>b(w,$))}e.$Ng="vscode-tkn",e.$Og="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(a){this.d=a}setDelegate(a){this.e=a}setServerRootPath(a,$){this.f=D(a,$)}getServerRootPath(){return this.f}get g(){return L.$fc.join(this.f,R.vscodeRemoteResource)}set(a,$,f){this.a[a]=$,this.b[a]=f}setConnectionToken(a,$){this.c[a]=$}getPreferredWebSchema(){return this.d}rewrite(a){if(this.e)try{return this.e(a)}catch(t){return r.$Y(t),a}const $=a.authority;let f=this.a[$];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const g=this.b[$],i=this.c[$];let o=`path=${encodeURIComponent(a.path)}`;return typeof i=="string"&&(o+=`&${e.$Og}=${encodeURIComponent(i)}`),T.URI.from({scheme:h.$p?this.d:R.vscodeRemoteResource,authority:`${f}:${g}`,path:this.g,query:o})}}e.$Pg=new I;function D(w,a){return L.$fc.join(a??"/",`${w.quality??"oss"}-${w.commit??"dev"}`)}e.$Rg="vs/../../extensions",e.$Sg="vs/../../node_modules",e.$Tg="vs/../../node_modules.asar",e.$Ug="vs/../../node_modules.asar.unpacked",e.$Vg="vscode-app";class u{static{this.a=e.$Vg}asBrowserUri(a){const $=this.b(a,me);return this.uriToBrowserUri($)}uriToBrowserUri(a){return a.scheme===R.vscodeRemote?e.$Pg.rewrite(a):a.scheme===R.file&&(h.$n||h.$r===`${R.vscodeFileResource}://${u.a}`)?a.with({scheme:R.vscodeFileResource,authority:a.authority||u.a,query:null,fragment:null}):a}asFileUri(a){const $=this.b(a,me);return this.uriToFileUri($)}uriToFileUri(a){return a.scheme===R.vscodeFileResource?a.with({scheme:R.file,authority:a.authority!==u.a?a.authority:null,query:null,fragment:null}):a}b(a,$){return T.URI.isUri(a)?a:T.URI.parse($.toUrl(a))}}e.$Wg=new u;var P;(function(w){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(a.get("3"));const $="vscode-coi";function f(i){let o;typeof i=="string"?o=new URL(i).searchParams:i instanceof URL?o=i.searchParams:T.URI.isUri(i)&&(o=new URL(i.toString(!0)).searchParams);const t=o?.get($);if(t)return a.get(t)}w.getHeadersFromQuery=f;function g(i,o,t){if(!globalThis.crossOriginIsolated)return;const s=o&&t?"3":t?"2":"1";i instanceof URLSearchParams?i.set($,s):i[$]=s}w.addSearchParam=g})(P||(e.COI=P={}))}),define(ke[188],Ie([1,0,174,14,10,2]),function(me,e,r,h,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qE=I,C=Ue(C);class L{constructor(u,P,w){this.id=u,this.dependencies=P,this.callback=w}}class R{static{this.INSTANCE=new R}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(u,P,w)=>{typeof u!="string"&&(w=P,P=u,u=null),(typeof P!="object"||!Array.isArray(P))&&(w=P,P=null),this.c.push(new L(u,P,w))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){if(u.startsWith(window.location.origin)||u.startsWith("vscode-file://vscode-app"))return u;throw new Error(`[trusted_script_src] Invalid script url: ${u}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){return u}})))}async load(u){this.g();const P=await(this.a?this.i(u):this.b?this.h(u):this.j(u));if(!P)throw new Error(`Did not receive a define call from script ${u}`);if(Array.isArray(P.dependencies)&&P.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${u}. The dependencies are: ${P.dependencies.join(", ")}`);return typeof P.callback=="function"?P.callback([]):P.callback}h(u){return new Promise((P,w)=>{const a=document.createElement("script");a.setAttribute("async","async"),a.setAttribute("type","text/javascript");const $=()=>{a.removeEventListener("load",f),a.removeEventListener("error",g)},f=i=>{$(),P(this.c.pop())},g=i=>{$(),w(i)};a.addEventListener("load",f),a.addEventListener("error",g),this.f&&(u=this.f.createScriptURL(u)),a.setAttribute("src",u),window.document.getElementsByTagName("head")[0].appendChild(a)})}i(u){return new Promise((P,w)=>{try{this.f&&(u=this.f.createScriptURL(u)),importScripts(u),P(this.c.pop())}catch(a){w(a)}})}async j(u){try{const P=globalThis._VSCODE_NODE_MODULES.fs,w=globalThis._VSCODE_NODE_MODULES.vm,a=globalThis._VSCODE_NODE_MODULES.module,$=T.URI.parse(u).fsPath,f=P.readFileSync($).toString(),g=a.wrap(f.replace(/^#!.*/,""));return new w.Script(g).runInThisContext().apply(),this.c.pop()}catch(P){throw P}}}const b=new Map;let c={};typeof globalThis.require=="object"&&(c=globalThis.require.paths??{});async function I(D,u,P){if(r.$R){P===void 0&&(P=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),c[D]&&(D=c[D]);const w=`${D}/${u}`;if(b.has(w))return b.get(w);let a;if(/^\w[\w\d+.-]*:\/\//.test(w))a=w;else{const i=`${P&&!C.$p?h.$Tg:h.$Sg}/${w}`;a=h.$Wg.asBrowserUri(i).toString(!0)}const $=R.INSTANCE.load(a);return b.set(w,$),$}else return await new Promise((w,a)=>{me([D],w,a)}).then(Ue)}}),define(ke[22],Ie([1,0,26,31,14,16,10,12,2]),function(me,e,r,h,C,T,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=void 0,e.$4g=c,e.$mh=D,e.$nh=P,h=Ue(h),T=Ue(T);function c(w){return(0,b.$vc)(w,!0)}class I{constructor(a){this.a=a}compare(a,$,f=!1){return a===$?0:(0,R.$wf)(this.getComparisonKey(a,f),this.getComparisonKey($,f))}isEqual(a,$,f=!1){return a===$?!0:!a||!$?!1:this.getComparisonKey(a,f)===this.getComparisonKey($,f)}getComparisonKey(a,$=!1){return a.with({path:this.a(a)?a.path.toLowerCase():void 0,fragment:$?null:void 0}).toString()}ignorePathCasing(a){return this.a(a)}isEqualOrParent(a,$,f=!1){if(a.scheme===$.scheme){if(a.scheme===C.Schemas.file)return h.$Bg(c(a),c($),this.a(a))&&a.query===$.query&&(f||a.fragment===$.fragment);if((0,e.$ih)(a.authority,$.authority))return h.$Bg(a.path,$.path,this.a(a),"/")&&a.query===$.query&&(f||a.fragment===$.fragment)}return!1}joinPath(a,...$){return b.URI.joinPath(a,...$)}basenameOrAuthority(a){return(0,e.$ah)(a)||a.authority}basename(a){return T.$fc.basename(a.path)}extname(a){return T.$fc.extname(a.path)}dirname(a){if(a.path.length===0)return a;let $;return a.scheme===C.Schemas.file?$=b.URI.file(T.$lc(c(a))).path:($=T.$fc.dirname(a.path),a.authority&&$.length&&$.charCodeAt(0)!==r.CharCode.Slash&&(console.error(`dirname("${a.toString})) resulted in a relative path`),$="/")),a.with({path:$})}normalizePath(a){if(!a.path.length)return a;let $;return a.scheme===C.Schemas.file?$=b.URI.file(T.$gc(c(a))).path:$=T.$fc.normalize(a.path),a.with({path:$})}relativePath(a,$){if(a.scheme!==$.scheme||!(0,e.$ih)(a.authority,$.authority))return;if(a.scheme===C.Schemas.file){const i=T.$kc(c(a),c($));return L.$j?h.$vg(i):i}let f=a.path||"/";const g=$.path||"/";if(this.a(a)){let i=0;for(const o=Math.min(f.length,g.length);i<o&&!(f.charCodeAt(i)!==g.charCodeAt(i)&&f.charAt(i).toLowerCase()!==g.charAt(i).toLowerCase());i++);f=g.substr(0,i)+f.substr(i)}return T.$fc.relative(f,g)}resolvePath(a,$){if(a.scheme===C.Schemas.file){const f=b.URI.file(T.$jc(c(a),$));return a.with({authority:f.authority,path:f.path})}return $=h.$wg($),a.with({path:T.$fc.resolve(a.path,$)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,$){return a===$||a!==void 0&&$!==void 0&&(0,R.$Df)(a,$)}hasTrailingPathSeparator(a,$=T.sep){if(a.scheme===C.Schemas.file){const f=c(a);return f.length>h.$xg(f).length&&f[f.length-1]===$}else{const f=a.path;return f.length>1&&f.charCodeAt(f.length-1)===r.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,$=T.sep){return(0,e.$jh)(a,$)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,$=T.sep){let f=!1;if(a.scheme===C.Schemas.file){const g=c(a);f=g!==void 0&&g.length===h.$xg(g).length&&g[g.length-1]===$}else{$="/";const g=a.path;f=g.length===1&&g.charCodeAt(g.length-1)===r.CharCode.Slash}return!f&&!(0,e.$jh)(a,$)?a.with({path:a.path+"/"}):a}}e.$5g=I,e.$6g=new I(()=>!1),e.$7g=new I(w=>w.scheme===C.Schemas.file?!L.$l:!0),e.$8g=new I(w=>!0),e.$9g=e.$6g.isEqual.bind(e.$6g),e.$0g=e.$6g.isEqualOrParent.bind(e.$6g),e.$$g=e.$6g.getComparisonKey.bind(e.$6g),e.$_g=e.$6g.basenameOrAuthority.bind(e.$6g),e.$ah=e.$6g.basename.bind(e.$6g),e.$bh=e.$6g.extname.bind(e.$6g),e.$ch=e.$6g.dirname.bind(e.$6g),e.$dh=e.$6g.joinPath.bind(e.$6g),e.$eh=e.$6g.normalizePath.bind(e.$6g),e.$fh=e.$6g.relativePath.bind(e.$6g),e.$gh=e.$6g.resolvePath.bind(e.$6g),e.$hh=e.$6g.isAbsolutePath.bind(e.$6g),e.$ih=e.$6g.isEqualAuthority.bind(e.$6g),e.$jh=e.$6g.hasTrailingPathSeparator.bind(e.$6g),e.$kh=e.$6g.removeTrailingPathSeparator.bind(e.$6g),e.$lh=e.$6g.addTrailingPathSeparator.bind(e.$6g);function D(w,a){const $=[];for(let f=0;f<w.length;f++){const g=a(w[f]);w.some((i,o)=>o===f?!1:(0,e.$0g)(g,a(i)))||$.push(w[f])}return $}var u;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function a($){const f=new Map;$.path.substring($.path.indexOf(";")+1,$.path.lastIndexOf(";")).split(";").forEach(o=>{const[t,s]=o.split(":");t&&s&&f.set(t,s)});const i=$.path.substring(0,$.path.indexOf(";"));return i&&f.set(w.META_DATA_MIME,i),f}w.parseMetaData=a})(u||(e.DataUri=u={}));function P(w,a,$){if(a){let f=w.path;return f&&f[0]!==T.$fc.sep&&(f=T.$fc.sep+f),w.with({scheme:$,authority:a,path:f})}return w.with({scheme:$})}}),define(ke[7],Ie([1,0,20,13,4,3,22,10,185,49]),function(me,e,r,h,C,T,L,R,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$4h=e.$3h=e.$2h=e.$1h=e.Promises=e.$Zh=e.$Yh=e.$Xh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=void 0,e.$oh=I,e.$ph=D,e.$qh=u,e.$rh=P,e.$sh=w,e.$th=a,e.$uh=$,e.$vh=f,e.$Dh=E,e.$Eh=S,e.$Fh=y,e.$Gh=k,e.$Hh=A,e.$Wh=G,e.$5h=te;function I(le){return!!le&&typeof le.then=="function"}function D(le){const Z=new r.$ue,oe=le(Z.token),pe=new Promise((we,Fe)=>{const We=Z.token.onCancellationRequested(()=>{We.dispose(),Fe(new h.$4)});Promise.resolve(oe).then(Se=>{We.dispose(),Z.dispose(),we(Se)},Se=>{We.dispose(),Z.dispose(),Fe(Se)})});return new class{cancel(){Z.cancel(),Z.dispose()}then(we,Fe){return pe.then(we,Fe)}catch(we){return this.then(void 0,we)}finally(we){return pe.finally(we)}}}function u(le,Z,oe){return new Promise((pe,we)=>{const Fe=Z.onCancellationRequested(()=>{Fe.dispose(),pe(oe)});le.then(pe,we).finally(()=>Fe.dispose())})}function P(le,Z){return new Promise((oe,pe)=>{const we=Z.onCancellationRequested(()=>{we.dispose(),pe(new h.$4)});le.then(oe,pe).finally(()=>we.dispose())})}async function w(le){let Z=-1;const oe=le.map((pe,we)=>pe.then(Fe=>(Z=we,Fe)));try{return await Promise.race(oe)}finally{le.forEach((pe,we)=>{we!==Z&&pe.cancel()})}}function a(le,Z,oe){let pe;const we=setTimeout(()=>{pe?.(void 0),oe?.()},Z);return Promise.race([le.finally(()=>clearTimeout(we)),new Promise(Fe=>pe=Fe)])}function $(le){return new Promise((Z,oe)=>{const pe=le();I(pe)?pe.then(Z,oe):Z(pe)})}function f(){let le,Z;return{promise:new Promise((pe,we)=>{le=pe,Z=we}),resolve:le,reject:Z}}class g{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Z){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Z,!this.b){const oe=()=>{if(this.b=null,this.f)return;const pe=this.queue(this.d);return this.d=null,pe};this.b=new Promise(pe=>{this.a.then(oe,oe).then(pe)})}return new Promise((oe,pe)=>{this.b.then(oe,pe)})}return this.a=Z(),new Promise((oe,pe)=>{this.a.then(we=>{this.a=null,oe(we)},we=>{this.a=null,pe(we)})})}dispose(){this.f=!0}}e.$wh=g;class i{constructor(){this.a=Promise.resolve(null)}queue(Z){return this.a=this.a.then(()=>Z(),()=>Z())}}e.$xh=i;class o{constructor(){this.a=new Map}queue(Z,oe){const we=(this.a.get(Z)??Promise.resolve()).catch(()=>{}).then(oe).finally(()=>{this.a.get(Z)===we&&this.a.delete(Z)});return this.a.set(Z,we),we}}e.$yh=o;const t=(le,Z)=>{let oe=!0;const pe=setTimeout(()=>{oe=!1,Z()},le);return{isTriggered:()=>oe,dispose:()=>{clearTimeout(pe),oe=!1}}},s=le=>{let Z=!0;return queueMicrotask(()=>{Z&&(Z=!1,le())}),{isTriggered:()=>Z,dispose:()=>{Z=!1}}};class n{constructor(Z){this.defaultDelay=Z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Z,oe=this.defaultDelay){this.g=Z,this.h(),this.b||(this.b=new Promise((we,Fe)=>{this.d=we,this.f=Fe}).then(()=>{if(this.b=null,this.d=null,this.g){const we=this.g;return this.g=null,we()}}));const pe=()=>{this.a=null,this.d?.(null)};return this.a=oe===b.$ee?s(pe):t(oe,pe),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new h.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$zh=n;class d{constructor(Z){this.a=new n(Z),this.b=new g}trigger(Z,oe){return this.a.trigger(()=>this.b.queue(Z),oe)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ah=d;class l{constructor(){this.a=!1,this.b=new Promise((Z,oe)=>{this.d=Z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Bh=l;class m extends l{constructor(Z){super(),this.f=setTimeout(()=>this.open(),Z)}open(){clearTimeout(this.f),super.open()}}e.$Ch=m;function E(le,Z){return Z?new Promise((oe,pe)=>{const we=setTimeout(()=>{Fe.dispose(),oe()},le),Fe=Z.onCancellationRequested(()=>{clearTimeout(we),Fe.dispose(),pe(new h.$4)})}):D(oe=>E(le,oe))}function S(le,Z=0,oe){const pe=setTimeout(()=>{le(),oe&&we.dispose()},Z),we=(0,T.$Rc)(()=>{clearTimeout(pe),oe?.deleteAndLeak(we)});return oe?.add(we),we}function y(le){const Z=[];let oe=0;const pe=le.length;function we(){return oe<pe?le[oe++]():null}function Fe(We){We!=null&&Z.push(We);const Se=we();return Se?Se.then(Fe):Promise.resolve(Z)}return Promise.resolve(null).then(Fe)}function k(le,Z=pe=>!!pe,oe=null){let pe=0;const we=le.length,Fe=()=>{if(pe>=we)return Promise.resolve(oe);const We=le[pe++];return Promise.resolve(We()).then(De=>Z(De)?Promise.resolve(De):Fe())};return Fe()}function A(le,Z=pe=>!!pe,oe=null){if(le.length===0)return Promise.resolve(oe);let pe=le.length;const we=()=>{pe=-1;for(const Fe of le)Fe.cancel?.()};return new Promise((Fe,We)=>{for(const Se of le)Se.then(De=>{--pe>=0&&Z(De)?(we(),Fe(De)):pe===0&&Fe(oe)}).catch(De=>{--pe>=0&&(we(),We(De))})})}class p{constructor(Z){this.a=0,this.b=!1,this.f=Z,this.g=[],this.d=0,this.h=new C.$je}whenIdle(){return this.size>0?C.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Z){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((oe,pe)=>{this.g.push({factory:Z,c:oe,e:pe}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Z=this.g.shift();this.d++;const oe=Z.factory();oe.then(Z.c,Z.e),oe.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ih=p;class v extends p{constructor(){super(1)}}e.$Jh=v;class F{constructor(){this.a=new Y,this.b=0}queue(Z){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Z())):this.a.run(this.b++,Z())}}e.$Kh=F;class N{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Z=new re;return this.b.add(Z),Z.p}g(){for(const[,Z]of this.a)if(Z.size>0)return!1;return!0}queueSize(Z,oe=L.$6g){const pe=oe.getComparisonKey(Z);return this.a.get(pe)?.size??0}queueFor(Z,oe,pe=L.$6g){const we=pe.getComparisonKey(Z);let Fe=this.a.get(we);if(!Fe){Fe=new v;const We=this.f++,Se=C.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.a.delete(we),this.h(),this.d?.deleteAndDispose(We),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new T.$3c),this.d.set(We,Se),this.a.set(we,Fe)}return Fe.queue(oe)}h(){this.g()&&this.j()}j(){for(const Z of this.b)Z.complete();this.b.clear()}dispose(){for(const[,Z]of this.a)Z.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Lh=N;class O{constructor(Z,oe){this.b=!1,this.a=-1,typeof Z=="function"&&typeof oe=="number"&&this.setIfNotSet(Z,oe)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Z,oe){if(this.b)throw new h.$bb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,Z()},oe)}setIfNotSet(Z,oe){if(this.b)throw new h.$bb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Z()},oe))}}e.$Mh=O;class j{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Z,oe,pe=globalThis){if(this.f)throw new h.$bb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const we=pe.setInterval(()=>{Z()},oe);this.d=(0,T.$Rc)(()=>{pe.clearInterval(we),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Nh=j;class z{constructor(Z,oe){this.b=-1,this.a=Z,this.d=oe,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Z=this.d){this.cancel(),this.b=setTimeout(this.f,Z)}get delay(){return this.d}set delay(Z){this.d=Z}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Oh=z;class M{constructor(Z,oe){oe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${oe}ms is not a multiple of 1000ms.`),this.a=Z,this.b=oe,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Z=this.b){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Ph=M;class V extends z{constructor(Z,oe){super(Z,oe),this.j=[]}work(Z){this.j.push(Z),this.isScheduled()||this.schedule()}h(){const Z=this.j;this.j=[],this.a?.(Z)}dispose(){this.j=[],super.dispose()}}e.$Qh=V;class K extends T.$Tc{constructor(Z,oe){super(),this.g=Z,this.h=oe,this.a=[],this.b=this.B(new T.$Uc),this.f=!1}get pending(){return this.a.length}work(Z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Z.length>this.g.maxBufferedWork)return!1}else if(this.pending+Z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const oe of Z)this.a.push(oe);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Rh=K,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Th=(le,Z)=>{(0,R.$C)(()=>{if(oe)return;const pe=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let oe=!1;return{dispose(){oe||(oe=!0)}}}:e.$Th=(le,Z,oe)=>{const pe=le.requestIdleCallback(Z,typeof oe=="number"?{timeout:oe}:void 0);let we=!1;return{dispose(){we||(we=!0,le.cancelIdleCallback(pe))}}},e.$Sh=le=>(0,e.$Th)(globalThis,le)}();class ne{constructor(Z,oe){this.g=!1,this.d=()=>{try{this.j=oe()}catch(pe){this.l=pe}finally{this.g=!0}},this.f=(0,e.$Th)(Z,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Uh=ne;class B extends ne{constructor(Z){super(globalThis,Z)}}e.$Vh=B;async function G(le,Z,oe){let pe;for(let we=0;we<oe;we++)try{return await le()}catch(Fe){pe=Fe,await E(Z)}throw pe}class Y{isRunning(Z){return typeof Z=="number"?this.a?.taskId===Z:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Z,oe,pe){return this.a={taskId:Z,cancel:()=>pe?.(),promise:oe},oe.then(()=>this.d(Z),()=>this.d(Z)),oe}d(Z){this.a&&Z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Z=this.b;this.b=void 0,Z.run().then(Z.promiseResolve,Z.promiseReject)}}queue(Z){if(this.b)this.b.run=Z;else{const{promise:oe,resolve:pe,reject:we}=f();this.b={run:Z,promise:oe,promiseResolve:pe,promiseReject:we}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Xh=Y;class ee{constructor(Z,oe=()=>Date.now()){this.d=Z,this.f=oe,this.a=0,this.b=0}increment(){const Z=this.f();return Z-this.a>this.d&&(this.a=Z,this.b=0),this.b++,this.b}}e.$Yh=ee;var ue;(function(le){le[le.Resolved=0]="Resolved",le[le.Rejected=1]="Rejected"})(ue||(ue={}));class re{get isRejected(){return this.d?.outcome===ue.Rejected}get isResolved(){return this.d?.outcome===ue.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ue.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((Z,oe)=>{this.a=Z,this.b=oe})}complete(Z){return new Promise(oe=>{this.a(Z),this.d={outcome:ue.Resolved,value:Z},oe()})}error(Z){return new Promise(oe=>{this.b(Z),this.d={outcome:ue.Rejected,value:Z},oe()})}cancel(){return this.error(new h.$4)}}e.$Zh=re;var ye;(function(le){async function Z(pe){let we;const Fe=await Promise.all(pe.map(We=>We.then(Se=>Se,Se=>{we||(we=Se)})));if(typeof we<"u")throw we;return Fe}le.settled=Z;function oe(pe){return new Promise(async(we,Fe)=>{try{await pe(we,Fe)}catch(We){Fe(We)}})}le.withAsyncBody=oe})(ye||(e.Promises=ye={}));class $e{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Z){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Z.then(oe=>(this.a=oe,this.d=!0,oe),oe=>{throw this.b=oe,this.d=!0,oe})}requireValue(){if(!this.d)throw new h.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$1h=$e;class J{constructor(Z){this.b=Z,this.a=new c.$T(()=>new $e(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$2h=J;var W;(function(le){le[le.Initial=0]="Initial",le[le.DoneOK=1]="DoneOK",le[le.DoneError=2]="DoneError"})(W||(W={}));class se{static fromArray(Z){return new se(oe=>{oe.emitMany(Z)})}static fromPromise(Z){return new se(async oe=>{oe.emitMany(await Z)})}static fromPromises(Z){return new se(async oe=>{await Promise.all(Z.map(async pe=>oe.emitOne(await pe)))})}static merge(Z){return new se(async oe=>{await Promise.all(Z.map(async pe=>{for await(const we of pe)oe.emitOne(we)}))})}static{this.EMPTY=se.fromArray([])}constructor(Z,oe){this.a=W.Initial,this.b=[],this.d=null,this.f=oe,this.g=new C.$je,queueMicrotask(async()=>{const pe={emitOne:we=>this.h(we),emitMany:we=>this.j(we),reject:we=>this.l(we)};try{await Promise.resolve(Z(pe)),this.k()}catch(we){this.l(we)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let Z=0;return{next:async()=>{do{if(this.a===W.DoneError)throw this.d;if(Z<this.b.length)return{done:!1,value:this.b[Z++]};if(this.a===W.DoneOK)return{done:!0,value:void 0};await C.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Z,oe){return new se(async pe=>{for await(const we of Z)pe.emitOne(oe(we))})}map(Z){return se.map(this,Z)}static filter(Z,oe){return new se(async pe=>{for await(const we of Z)oe(we)&&pe.emitOne(we)})}filter(Z){return se.filter(this,Z)}static coalesce(Z){return se.filter(Z,oe=>!!oe)}coalesce(){return se.coalesce(this)}static async toPromise(Z){const oe=[];for await(const pe of Z)oe.push(pe);return oe}toPromise(){return se.toPromise(this)}h(Z){this.a===W.Initial&&(this.b.push(Z),this.g.fire())}j(Z){this.a===W.Initial&&(this.b=this.b.concat(Z),this.g.fire())}k(){this.a===W.Initial&&(this.a=W.DoneOK,this.g.fire())}l(Z){this.a===W.Initial&&(this.a=W.DoneError,this.d=Z,this.g.fire())}}e.$3h=se;class ae extends se{constructor(Z,oe){super(oe),this.m=Z}cancel(){this.m.cancel()}}e.$4h=ae;function te(le){const Z=new r.$ue,oe=le(Z.token);return new ae(Z,async pe=>{const we=Z.token.onCancellationRequested(()=>{we.dispose(),Z.dispose(),pe.reject(new h.$4)});try{for await(const Fe of oe){if(Z.token.isCancellationRequested)return;pe.emitOne(Fe)}we.dispose(),Z.dispose()}catch(Fe){we.dispose(),Z.dispose(),pe.reject(Fe)}})}class ce{constructor(Z){this.a=new re,this.b=new se(we=>{if(oe){we.reject(oe);return}return pe&&we.emitMany(pe),this.d=Fe=>we.reject(Fe),this.f=Fe=>we.emitOne(Fe),this.a.p},Z);let oe,pe;this.f=we=>{pe||(pe=[]),pe.push(we)},this.d=we=>{oe||(oe=we)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Z){this.d(Z),this.a.complete()}emitOne(Z){this.f(Z)}}e.$6h=ce}),define(ke[38],Ie([1,0,18,7,26,31,28,16,10,12]),function(me,e,r,h,C,T,L,R,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$sk=void 0,e.$rk=I,e.$uk=a,e.$vk=F,e.$wk=N,e.$xk=O,e.$yk=j,e.$zk=z,e.$Ak=ne;function I(){return Object.create(null)}e.$sk="**",e.$tk="/";const D="[/\\\\]",u="[^/\\\\]",P=/\//g;function w(B,G){switch(B){case 0:return"";case 1:return`${u}*?`;default:return`(?:${D}|${u}+${D}${G?`|${D}${u}+`:""})*?`}}function a(B,G){if(!B)return[];const Y=[];let ee=!1,ue=!1,re="";for(const ye of B){switch(ye){case G:if(!ee&&!ue){Y.push(re),re="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}re+=ye}return re&&Y.push(re),Y}function $(B){if(!B)return"";let G="";const Y=a(B,e.$tk);if(Y.every(ee=>ee===e.$sk))G=".*";else{let ee=!1;Y.forEach((ue,re)=>{if(ue===e.$sk){if(ee)return;G+=w(2,re===Y.length-1)}else{let ye=!1,$e="",J=!1,W="";for(const se of ue){if(se!=="}"&&ye){$e+=se;continue}if(J&&(se!=="]"||!W)){let ae;se==="-"?ae=se:(se==="^"||se==="!")&&!W?ae="^":se===e.$tk?ae="":ae=(0,c.$ff)(se),W+=ae;continue}switch(se){case"{":ye=!0;continue;case"[":J=!0;continue;case"}":{const te=`(?:${a($e,",").map(ce=>$(ce)).join("|")})`;G+=te,ye=!1,$e="";break}case"]":{G+="["+W+"]",J=!1,W="";break}case"?":G+=u;continue;case"*":G+=w(1);continue;default:G+=(0,c.$ff)(se)}}re<Y.length-1&&(Y[re+1]!==e.$sk||re+2<Y.length)&&(G+=D)}ee=ue===e.$sk})}return G}const f=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,o=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new L.$Cc(1e4),d=function(){return!1},l=function(){return null};function m(B,G){if(!B)return l;let Y;typeof B!="string"?Y=B.pattern:Y=B,Y=Y.trim();const ee=`${Y}_${!!G.trimForExclusions}`;let ue=n.get(ee);if(ue)return E(ue,B);let re;return f.test(Y)?ue=y(Y.substr(4),Y):(re=g.exec(S(Y,G)))?ue=k(re[1],Y):(G.trimForExclusions?o:i).test(Y)?ue=A(Y,G):(re=t.exec(S(Y,G)))?ue=p(re[1].substr(1),Y,!0):(re=s.exec(S(Y,G)))?ue=p(re[1],Y,!1):ue=v(Y),n.set(ee,ue),E(ue,B)}function E(B,G){if(typeof G=="string")return B;const Y=function(ee,ue){return(0,T.$Bg)(ee,G.base,!b.$l)?B((0,c.$kf)(ee.substr(G.base.length),R.sep),ue):null};return Y.allBasenames=B.allBasenames,Y.allPaths=B.allPaths,Y.basenames=B.basenames,Y.patterns=B.patterns,Y}function S(B,G){return G.trimForExclusions&&B.endsWith("/**")?B.substr(0,B.length-2):B}function y(B,G){return function(Y,ee){return typeof Y=="string"&&Y.endsWith(B)?G:null}}function k(B,G){const Y=`/${B}`,ee=`\\${B}`,ue=function(ye,$e){return typeof ye!="string"?null:$e?$e===B?G:null:ye===B||ye.endsWith(Y)||ye.endsWith(ee)?G:null},re=[B];return ue.basenames=re,ue.patterns=[G],ue.allBasenames=re,ue}function A(B,G){const Y=K(B.slice(1,-1).split(",").map($e=>m($e,G)).filter($e=>$e!==l),B),ee=Y.length;if(!ee)return l;if(ee===1)return Y[0];const ue=function($e,J){for(let W=0,se=Y.length;W<se;W++)if(Y[W]($e,J))return B;return null},re=Y.find($e=>!!$e.allBasenames);re&&(ue.allBasenames=re.allBasenames);const ye=Y.reduce(($e,J)=>J.allPaths?$e.concat(J.allPaths):$e,[]);return ye.length&&(ue.allPaths=ye),ue}function p(B,G,Y){const ee=R.sep===R.$fc.sep,ue=ee?B:B.replace(P,R.sep),re=R.sep+ue,ye=R.$fc.sep+B;let $e;return Y?$e=function(J,W){return typeof J=="string"&&(J===ue||J.endsWith(re)||!ee&&(J===B||J.endsWith(ye)))?G:null}:$e=function(J,W){return typeof J=="string"&&(J===ue||!ee&&J===B)?G:null},$e.allPaths=[(Y?"*/":"./")+B],$e}function v(B){try{const G=new RegExp(`^${$(B)}$`);return function(Y){return G.lastIndex=0,typeof Y=="string"&&G.test(Y)?B:null}}catch{return l}}function F(B,G,Y){return!B||typeof G!="string"?!1:N(B)(G,void 0,Y)}function N(B,G={}){if(!B)return d;if(typeof B=="string"||O(B)){const Y=m(B,G);if(Y===l)return d;const ee=function(ue,re){return!!Y(ue,re)};return Y.allBasenames&&(ee.allBasenames=Y.allBasenames),Y.allPaths&&(ee.allPaths=Y.allPaths),ee}return M(B,G)}function O(B){const G=B;return G?typeof G.base=="string"&&typeof G.pattern=="string":!1}function j(B){return B.allBasenames||[]}function z(B){return B.allPaths||[]}function M(B,G){const Y=K(Object.getOwnPropertyNames(B).map($e=>V($e,B[$e],G)).filter($e=>$e!==l)),ee=Y.length;if(!ee)return l;if(!Y.some($e=>!!$e.requiresSiblings)){if(ee===1)return Y[0];const $e=function(se,ae){let te;for(let ce=0,le=Y.length;ce<le;ce++){const Z=Y[ce](se,ae);if(typeof Z=="string")return Z;(0,h.$oh)(Z)&&(te||(te=[]),te.push(Z))}return te?(async()=>{for(const ce of te){const le=await ce;if(typeof le=="string")return le}return null})():null},J=Y.find(se=>!!se.allBasenames);J&&($e.allBasenames=J.allBasenames);const W=Y.reduce((se,ae)=>ae.allPaths?se.concat(ae.allPaths):se,[]);return W.length&&($e.allPaths=W),$e}const ue=function($e,J,W){let se,ae;for(let te=0,ce=Y.length;te<ce;te++){const le=Y[te];le.requiresSiblings&&W&&(J||(J=(0,R.$mc)($e)),se||(se=J.substr(0,J.length-(0,R.$nc)($e).length)));const Z=le($e,J,se,W);if(typeof Z=="string")return Z;(0,h.$oh)(Z)&&(ae||(ae=[]),ae.push(Z))}return ae?(async()=>{for(const te of ae){const ce=await te;if(typeof ce=="string")return ce}return null})():null},re=Y.find($e=>!!$e.allBasenames);re&&(ue.allBasenames=re.allBasenames);const ye=Y.reduce(($e,J)=>J.allPaths?$e.concat(J.allPaths):$e,[]);return ye.length&&(ue.allPaths=ye),ue}function V(B,G,Y){if(G===!1)return l;const ee=m(B,Y);if(ee===l)return l;if(typeof G=="boolean")return ee;if(G){const ue=G.when;if(typeof ue=="string"){const re=(ye,$e,J,W)=>{if(!W||!ee(ye,$e))return null;const se=ue.replace("$(basename)",()=>J),ae=W(se);return(0,h.$oh)(ae)?ae.then(te=>te?B:null):ae?B:null};return re.requiresSiblings=!0,re}}return ee}function K(B,G){const Y=B.filter($e=>!!$e.basenames);if(Y.length<2)return B;const ee=Y.reduce(($e,J)=>{const W=J.basenames;return W?$e.concat(W):$e},[]);let ue;if(G){ue=[];for(let $e=0,J=ee.length;$e<J;$e++)ue.push(G)}else ue=Y.reduce(($e,J)=>{const W=J.patterns;return W?$e.concat(W):$e},[]);const re=function($e,J){if(typeof $e!="string")return null;if(!J){let se;for(se=$e.length;se>0;se--){const ae=$e.charCodeAt(se-1);if(ae===C.CharCode.Slash||ae===C.CharCode.Backslash)break}J=$e.substr(se)}const W=ee.indexOf(J);return W!==-1?ue[W]:null};re.basenames=ee,re.patterns=ue,re.allBasenames=ee;const ye=B.filter($e=>!$e.basenames);return ye.push(re),ye}function ne(B,G){return(0,r.$tb)(B,G,(Y,ee)=>typeof Y=="string"&&typeof ee=="string"?Y===ee:typeof Y!="string"&&typeof ee!="string"?Y.base===ee.base&&Y.pattern===ee.pattern:!1)}}),define(ke[85],Ie([1,0,13,137,22,12,2]),function(me,e,r,h,C,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.MarkdownStringTextNewlineStyle=void 0,e.$1k=c,e.$2k=I,e.$3k=D,e.$4k=u,e.$5k=P,e.$6k=w,e.$7k=a,e.$8k=$;var R;(function(f){f[f.Paragraph=0]="Paragraph",f[f.Break=1]="Break"})(R||(e.MarkdownStringTextNewlineStyle=R={}));class b{constructor(g="",i=!1){if(this.value=g,typeof this.value!="string")throw(0,r.$6)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(g,i=R.Paragraph){return this.value+=u(this.supportThemeIcons?(0,h.$Tk)(g):g).replace(/([ \t]+)/g,(o,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===R.Break?`\\
`:`

`),this}appendMarkdown(g){return this.value+=g,this}appendCodeblock(g,i){return this.value+=`
${P(i,g)}
`,this}appendLink(g,i,o){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(g),")"),o&&(this.value+=` "${this.c(this.c(o,'"'),")")}"`),this.value+=")",this}c(g,i){const o=new RegExp((0,T.$ff)(i),"g");return g.replace(o,(t,s)=>g.charAt(s-1)!=="\\"?`\\${t}`:t)}}e.$Zk=b;function c(f){return I(f)?!f.value:Array.isArray(f)?f.every(c):!0}function I(f){return f instanceof b?!0:f&&typeof f=="object"?typeof f.value=="string"&&(typeof f.isTrusted=="boolean"||typeof f.isTrusted=="object"||f.isTrusted===void 0)&&(typeof f.supportThemeIcons=="boolean"||f.supportThemeIcons===void 0):!1}function D(f,g){return f===g?!0:!f||!g?!1:f.value===g.value&&f.isTrusted===g.isTrusted&&f.supportThemeIcons===g.supportThemeIcons&&f.supportHtml===g.supportHtml&&(f.baseUri===g.baseUri||!!f.baseUri&&!!g.baseUri&&(0,C.$9g)(L.URI.from(f.baseUri),L.URI.from(g.baseUri)))}function u(f){return f.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function P(f,g){const i=f.match(/^`+/gm)?.reduce((t,s)=>t.length>s.length?t:s).length??0,o=i>=3?i+1:3;return[`${"`".repeat(o)}${g}`,f,`${"`".repeat(o)}`].join(`
`)}function w(f){return f.replace(/"/g,"&quot;")}function a(f){return f&&f.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function $(f){const g=[],i=f.split("|").map(t=>t.trim());f=i[0];const o=i[1];if(o){const t=/height=(\d+)/.exec(o),s=/width=(\d+)/.exec(o),n=t?t[1]:"",d=s?s[1]:"",l=isFinite(parseInt(d)),m=isFinite(parseInt(n));l&&g.push(`width="${d}"`),m&&g.push(`height="${n}"`)}return{href:f,dimensions:g}}}),define(ke[107],Ie([1,0,18,31,16,10,22,12]),function(me,e,r,h,C,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uw=b,e.$Vw=I,e.$Ww=u,e.$Xw=P,e.$Yw=f,e.$Zw=i,e.$1w=o,e.$2w=t,e.$3w=s,e.$4w=n;function b(l,m){const{os:E,tildify:S,relative:y}=m;if(y){const p=c(l,y,E);if(typeof p=="string")return p}let k=l.fsPath;if(E===T.OperatingSystem.Windows&&!T.$j?k=k.replace(/\//g,"\\"):E!==T.OperatingSystem.Windows&&T.$j&&(k=k.replace(/\\/g,"/")),E!==T.OperatingSystem.Windows&&S?.userHome){const p=S.userHome.fsPath;let v;l.scheme!==S.userHome.scheme&&l.path[0]===C.$fc.sep&&l.path[1]!==C.$fc.sep?v=S.userHome.with({path:l.path}).fsPath:v=k,k=u(v,p,E)}return(E===T.OperatingSystem.Windows?C.$ec:C.$fc).normalize(I(k,E===T.OperatingSystem.Windows))}function c(l,m,E){const S=E===T.OperatingSystem.Windows?C.$ec:C.$fc,y=E===T.OperatingSystem.Linux?L.$6g:L.$8g,k=m.getWorkspace(),A=(0,r.$Nb)(k.folders);if(!A)return;l.scheme!==A.uri.scheme&&l.path[0]===C.$fc.sep&&l.path[1]!==C.$fc.sep&&(l=A.uri.with({path:l.path}));const p=m.getWorkspaceFolder(l);if(!p)return;let v;if(y.isEqual(p.uri,l)?v="":v=y.relativePath(p.uri,l)??"",v&&(v=S.normalize(v)),k.folders.length>1&&!m.noPrefix){const F=p.name?p.name:y.basenameOrAuthority(p.uri);v=v?`${F} \u2022 ${v}`:F}return v}function I(l,m=T.$j){return(0,h.$Gg)(l,m)?l.charAt(0).toUpperCase()+l.slice(1):l}let D=Object.create(null);function u(l,m,E=T.OS){if(E===T.OperatingSystem.Windows||!l||!m)return l;let S=D.original===m?D.normalized:void 0;S||(S=m,T.$j&&(S=(0,h.$vg)(S)),S=`${(0,R.$lf)(S,C.$fc.sep)}${C.$fc.sep}`,D={original:m,normalized:S});let y=l;return T.$j&&(y=(0,h.$vg)(y)),(E===T.OperatingSystem.Linux?y.startsWith(S):(0,R.$Ef)(y,S))?`~/${y.substr(S.length)}`:l}function P(l,m){return l.replace(/^~($|\/|\\)/,`${m}$1`)}const w="\u2026",a="\\\\",$="~";function f(l,m=C.sep){const E=new Array(l.length);let S=!1;for(let y=0;y<l.length;y++){const k=l[y];if(k===""){E[y]=`.${m}`;continue}if(!k){E[y]=k;continue}S=!0;let A="",p=k;p.indexOf(a)===0?(A=p.substr(0,p.indexOf(a)+a.length),p=p.substr(p.indexOf(a)+a.length)):p.indexOf(m)===0?(A=p.substr(0,p.indexOf(m)+m.length),p=p.substr(p.indexOf(m)+m.length)):p.indexOf($)===0&&(A=p.substr(0,p.indexOf($)+$.length),p=p.substr(p.indexOf($)+$.length));const v=p.split(m);for(let F=1;S&&F<=v.length;F++)for(let N=v.length-F;S&&N>=0;N--){S=!1;let O=v.slice(N,N+F).join(m);for(let j=0;!S&&j<l.length;j++)if(j!==y&&l[j]&&l[j].indexOf(O)>-1){const z=N+F===v.length,M=N>0&&l[j].indexOf(m)>-1?m+O:O,V=l[j].endsWith(M);S=!z||V}if(!S){let j="";(v[0].endsWith(":")||A!=="")&&(N===1&&(N=0,F++,O=v[0]+m+O),N>0&&(j=v[0]+m),j=A+j),N>0&&(j=j+w+m),j=j+O,N+F<v.length&&(j=j+m+w),E[y]=j}}S&&(E[y]=k)}return E}var g;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function i(l,m=Object.create(null)){const E=[];let S=!1,y="";for(const k of l)if(k==="$"||S&&k==="{")y&&E.push({value:y,type:g.TEXT}),y="",S=!0;else if(k==="}"&&S){const A=m[y];if(typeof A=="string")A.length&&E.push({value:A,type:g.VARIABLE});else if(A){const p=E[E.length-1];(!p||p.type!==g.SEPARATOR)&&E.push({value:A.label,type:g.SEPARATOR})}y="",S=!1}else y+=k;return y&&!S&&E.push({value:y,type:g.TEXT}),E.filter((k,A)=>{if(k.type===g.SEPARATOR){const p=E[A-1],v=E[A+1];return[p,v].every(F=>F&&(F.type===g.VARIABLE||F.type===g.TEXT)&&F.value.length>0)}return!0}).map(k=>k.value).join("")}function o(l,m){return T.$k||m?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.$k?"&":"&&"):l.replace(/&&|&/g,E=>E==="&"?"&&":"&")}function t(l,m){return T.$k||m?l.replace(/\(&&\w\)|&&/g,""):T.$j?l.replace(/&&|&/g,E=>E==="&"?"&&":"&"):l.replace(/&&/g,"_")}function s(l){return l.replace(/&/g,"&&")}function n(l){if(l.endsWith("]")){const m=l.lastIndexOf(" [",l.length-2);if(m!==-1){const E=d(l.substring(0,m)),S=l.substring(m);return{name:E.name+S,parentPath:E.parentPath}}}return d(l)}function d(l){const m=l.indexOf("/")!==-1?C.$fc:C.$ec,E=m.basename(l),S=m.dirname(l);return E.length?{name:E,parentPath:S}:{name:S,parentPath:""}}}),define(ke[138],Ie([1,0,21,40,2]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=void 0,e.$Kn=b,e.$Ln=I,e.$Mn=D;function T(u){return u.toJSON()}class L{constructor(P){this.a=P}transformIncoming(P){const w=this.a.transformIncoming(P);return w===P?P:T(C.URI.from(w))}transformOutgoing(P){const w=this.a.transformOutgoing(P);return w===P?P:T(C.URI.from(w))}transformOutgoingURI(P){const w=this.a.transformOutgoing(P);return w===P?P:C.URI.from(w)}transformOutgoingScheme(P){return this.a.transformOutgoingScheme(P)}}e.$In=L,e.$Jn=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function R(u,P,w){if(!u||w>200)return null;if(typeof u=="object"){if(u instanceof C.URI)return P.transformOutgoing(u);for(const a in u)if(Object.hasOwnProperty.call(u,a)){const $=R(u[a],P,w+1);$!==null&&(u[a]=$)}}return null}function b(u,P){const w=R(u,P,0);return w===null?u:w}function c(u,P,w,a){if(!u||a>200)return null;if(typeof u=="object"){if(u.$mid===h.MarshalledId.Uri)return w?C.URI.revive(P.transformIncoming(u)):P.transformIncoming(u);if(u instanceof r.$Le)return null;for(const $ in u)if(Object.hasOwnProperty.call(u,$)){const f=c(u[$],P,w,a+1);f!==null&&(u[$]=f)}}return null}function I(u,P){const w=c(u,P,!1,0);return w===null?u:w}function D(u,P){const w=c(u,P,!0,0);return w===null?u:w}}),define(ke[32],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yg=void 0,e.$Xg=h;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function h(C){return r.test(C)}e.$Yg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(R){for(let b=0;b<R.length;b++)R[b]=Math.floor(Math.random()*256);return R};const T=new Uint8Array(16),L=[];for(let R=0;R<256;R++)L.push(R.toString(16).padStart(2,"0"));return function(){C(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let b=0,c="";return c+=L[T[b++]],c+=L[T[b++]],c+=L[T[b++]],c+=L[T[b++]],c+="-",c+=L[T[b++]],c+=L[T[b++]],c+="-",c+=L[T[b++]],c+=L[T[b++]],c+="-",c+=L[T[b++]],c+=L[T[b++]],c+="-",c+=L[T[b++]],c+=L[T[b++]],c+=L[T[b++]],c+=L[T[b++]],c+=L[T[b++]],c+=L[T[b++]],c}}()}),define(ke[189],Ie([1,0,18,39,32]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ou=e.$mu=void 0,e.$ku=T,e.$lu=L,e.$nu=c;function T(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}function L(D,u,P){const w={id:(0,C.$Yg)(),name:D,uri:u,data:P};return{asString:async()=>"",asFile:()=>w,value:void 0}}class R{constructor(){this.a=new Map}get size(){let u=0;for(const P of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const P=[...this.a.keys()];return h.Iterable.some(this,([w,a])=>a.asFile())&&P.push("files"),I(b(u),P)}get(u){return this.a.get(this.b(u))?.[0]}append(u,P){const w=this.a.get(u);w?w.push(P):this.a.set(this.b(u),[P])}replace(u,P){this.a.set(this.b(u),[P])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,P]of this.a)for(const w of P)yield[u,w]}b(u){return b(u)}}e.$mu=R;function b(D){return D.toLowerCase()}function c(D,u){return I(b(D),u.map(b))}function I(D,u){if(D==="*/*")return u.length>0;if(u.includes(D))return!0;const P=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!P)return!1;const[w,a,$]=P;return $==="*"?u.some(f=>f.startsWith(a+"/")):!1}e.$ou=Object.freeze({create:D=>(0,r.$Lb)(D.map(u=>u.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.$ou.split(D).filter(u=>!u.startsWith("#"))})}),define(ke[33],Ie([1,0,44,66,359,7,31,81,16,10,22,2]),function(me,e,r,h,C,T,L,R,b,c,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=$,e.readdirSync=i,e.whenDeleted=s,e.configureFlushOnWrite=E,e.writeFileSync=y,r=Ue(r);var u;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(u||(e.RimRafMode=u={}));async function P(M,V=u.UNLINK,K){if((0,L.$Fg)(M))throw new Error("rimraf - will refuse to recursively delete root");return V===u.UNLINK?a(M):w(M,K)}async function w(M,V=(0,L.$Kg)((0,h.tmpdir)())){try{try{await r.promises.rename(M,V)}catch(K){return K.code==="ENOENT"?void 0:a(M)}a(V).catch(K=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function a(M){return r.promises.rm(M,{recursive:!0,force:!0,maxRetries:3})}function $(M){if((0,L.$Fg)(M))throw new Error("rimraf - will refuse to recursively delete root");r.rmSync(M,{recursive:!0,force:!0,maxRetries:3})}async function f(M,V){return o(await(V?g(M):r.promises.readdir(M)))}async function g(M){try{return await r.promises.readdir(M,{withFileTypes:!0})}catch(ne){console.warn("[node.js fs] readdir with filetypes failed with error: ",ne)}const V=[],K=await f(M);for(const ne of K){let B=!1,G=!1,Y=!1;try{const ee=await r.promises.lstat((0,b.$ic)(M,ne));B=ee.isFile(),G=ee.isDirectory(),Y=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}V.push({name:ne,isFile:()=>B,isDirectory:()=>G,isSymbolicLink:()=>Y})}return V}function i(M){return o(r.readdirSync(M))}function o(M){return M.map(V=>typeof V=="string"?c.$k?(0,R.$jm)(V):V:(V.name=c.$k?(0,R.$jm)(V.name):V.name,V))}async function t(M){const V=await f(M),K=[];for(const ne of V)await n.existsDirectory((0,b.$ic)(M,ne))&&K.push(ne);return K}function s(M,V=1e3){return new Promise(K=>{let ne=!1;const B=setInterval(()=>{ne||(ne=!0,r.access(M,G=>{ne=!1,G&&(clearInterval(B),K(void 0))}))},V)})}var n;(function(M){async function V(B){let G;try{if(G=await r.promises.lstat(B),!G.isSymbolicLink())return{stat:G}}catch{}try{return{stat:await r.promises.stat(B),symbolicLink:G?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};if(c.$j&&Y.code==="EACCES")try{return{stat:await r.promises.stat(await r.promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};throw ee}throw Y}}M.stat=V;async function K(B){try{const{stat:G,symbolicLink:Y}=await M.stat(B);return G.isFile()&&Y?.dangling!==!0}catch{}return!1}M.existsFile=K;async function ne(B){try{const{stat:G,symbolicLink:Y}=await M.stat(B);return G.isDirectory()&&Y?.dangling!==!0}catch{}return!1}M.existsDirectory=ne})(n||(e.SymlinkSupport=n={}));const d=new T.$Lh;function l(M,V,K){return d.queueFor(D.URI.file(M),()=>{const ne=k(K);return new Promise((B,G)=>S(M,V,ne,Y=>Y?G(Y):B()))},I.$7g)}let m=!0;function E(M){m=M}function S(M,V,K,ne){if(!m)return r.writeFile(M,V,{mode:K.mode,flag:K.flag},ne);r.open(M,K.flag,K.mode,(B,G)=>{if(B)return ne(B);r.writeFile(G,V,Y=>{if(Y)return r.close(G,()=>ne(Y));r.fdatasync(G,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),E(!1)),r.close(G,ue=>ne(ue))))})})}function y(M,V,K){const ne=k(K);if(!m)return r.writeFileSync(M,V,{mode:ne.mode,flag:ne.flag});const B=r.openSync(M,ne.flag,ne.mode);try{r.writeFileSync(B,V);try{r.fdatasyncSync(B)}catch(G){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",G),E(!1)}}finally{r.closeSync(B)}}function k(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function A(M,V,K=6e4){if(M!==V)try{c.$j&&typeof K=="number"?await p(M,V,Date.now(),K):await r.promises.rename(M,V)}catch(ne){if(M.toLowerCase()!==V.toLowerCase()&&ne.code==="EXDEV"||M.endsWith("."))await v(M,V,{preserveSymlinks:!1}),await P(M,u.MOVE);else throw ne}}async function p(M,V,K,ne,B=0){try{return await r.promises.rename(M,V)}catch(G){if(G.code!=="EACCES"&&G.code!=="EPERM"&&G.code!=="EBUSY")throw G;if(Date.now()-K>=ne)throw console.error(`[node.js fs] rename failed after ${B} retries with error: ${G}`),G;if(B===0){let Y=!1;try{const{stat:ee}=await n.stat(V);ee.isFile()||(Y=!0)}catch{}if(Y)throw G}return await(0,T.$Dh)(Math.min(100,B*10)),p(M,V,K,ne,B+1)}}async function v(M,V,K){return N(M,V,{root:{source:M,target:V},options:K,handledSourcePaths:new Set})}const F=511;async function N(M,V,K){if(K.handledSourcePaths.has(M))return;K.handledSourcePaths.add(M);const{stat:ne,symbolicLink:B}=await n.stat(M);if(B){if(K.options.preserveSymlinks)try{return await z(M,V,K)}catch{}if(B.dangling)return}return ne.isDirectory()?O(M,V,ne.mode&F,K):j(M,V,ne.mode&F)}async function O(M,V,K,ne){await r.promises.mkdir(V,{recursive:!0,mode:K});const B=await f(M);for(const G of B)await N((0,b.$ic)(M,G),(0,b.$ic)(V,G),ne)}async function j(M,V,K){await r.promises.copyFile(M,V),await r.promises.chmod(V,K)}async function z(M,V,K){let ne=await r.promises.readlink(M);(0,L.$Bg)(ne,K.root.source,!c.$l)&&(ne=(0,b.$ic)(K.root.target,ne.substr(K.root.source.length+1))),await r.promises.symlink(ne,V)}e.Promises=new class{get read(){return(M,V,K,ne,B)=>new Promise((G,Y)=>{r.read(M,V,K,ne,B,(ee,ue,re)=>ee?Y(ee):G({bytesRead:ue,buffer:re}))})}get write(){return(M,V,K,ne,B)=>new Promise((G,Y)=>{r.write(M,V,K,ne,B,(ee,ue,re)=>ee?Y(ee):G({bytesWritten:ue,buffer:re}))})}get fdatasync(){return(0,C.promisify)(r.fdatasync)}get open(){return(0,C.promisify)(r.open)}get close(){return(0,C.promisify)(r.close)}get realpath(){return(0,C.promisify)(r.realpath)}async exists(M){try{return await r.promises.access(M),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return t}get writeFile(){return l}get rm(){return P}get rename(){return A}get copy(){return v}}}),define(ke[108],Ie([1,0,44,16,10,12,33]),function(me,e,r,h,C,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=R,e.$ir=b,e.$jr=c,e.$kr=I,r=Ue(r);function R(u){if(C.$l)return u;const P=(0,h.$lc)(u);if(u===P)return u;const w=((0,h.$mc)(u)||u).toLowerCase();try{const $=(0,L.readdirSync)(P).filter(f=>f.toLowerCase()===w);if($.length===1){const f=R(P);if(f)return(0,h.$ic)(f,$[0])}else if($.length>1){const f=$.indexOf(w);if(f>=0){const g=R(P);if(g)return(0,h.$ic)(g,$[f])}}}catch{}return null}async function b(u,P){if(C.$l)return u;const w=(0,h.$lc)(u);if(u===w)return u;const a=((0,h.$mc)(u)||u).toLowerCase();try{if(P?.isCancellationRequested)return null;const f=(await L.Promises.readdir(w)).filter(g=>g.toLowerCase()===a);if(f.length===1){const g=await b(w,P);if(g)return(0,h.$ic)(g,f[0])}else if(f.length>1){const g=f.indexOf(a);if(g>=0){const i=await b(w,P);if(i)return(0,h.$ic)(i,f[g])}}}catch{}return null}async function c(u){try{return await L.Promises.realpath(u)}catch{const w=D(u);return await r.promises.access(w,r.constants.R_OK),w}}function I(u){try{return r.realpathSync(u)}catch{const w=D(u);return r.accessSync(w,r.constants.R_OK),w}}function D(u){return(0,T.$lf)((0,h.$gc)(u),h.sep)}}),define(ke[190],Ie([1,0,67]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=void 0,e.$1g=h,e.$3g=T,r=Ue(r);function h(R,b,c,I=1){let D=!1;return new Promise(u=>{const P=setTimeout(()=>{if(!D)return D=!0,u(0)},c);C(R,b,I,w=>{if(!D)return D=!0,clearTimeout(P),u(w)})})}function C(R,b,c,I){if(b===0)return I(0);const D=new r.Socket;D.once("connect",()=>(L(D),C(R+c,b-1,c,I))),D.once("data",()=>{}),D.once("error",u=>(L(D),u.code!=="ECONNREFUSED"?C(R+c,b-1,c,I):I(R))),D.connect(R,"127.0.0.1")}e.$2g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function T(R,b,c,I="127.0.0.1"){let D=!1,u,P=1;const w=r.createServer({pauseOnConnect:!0});function a($,f){D||(D=!0,w.removeAllListeners(),w.close(),u&&clearTimeout(u),f($))}return new Promise($=>{u=setTimeout(()=>{a(0,$)},c),w.on("listening",()=>{a(R,$)}),w.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&P<b?(R++,P++,w.listen(R,I)):a(0,$)}),w.on("close",()=>{a(0,$)}),w.listen(R,I)})}function L(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(b){console.error(b)}}}),define(ke[109],Ie([1,0,44,16,10,55,104,17,33]),function(me,e,r,h,C,T,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$um=c,e.$vm=I,h=Ue(h),C=Ue(C),T=Ue(T),R=Ue(R),b=Ue(b),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function c(u=T.env){return u.comspec||"cmd.exe"}function I(u){let P=[],w=!1;const a=function($){if(w){P.push($);return}(!u.send($,g=>{if(g&&console.error(g),w=!1,P.length>0){const i=P.slice(0);P=[],i.forEach(o=>a(o))}})||C.$j)&&(w=!0)};return{send:a}}var D;(function(u){async function P(w,a,$){if(h.$hc(w))return w;if(a===void 0&&(a=T.cwd()),h.$lc(w)!=="."||($===void 0&&R.$cg(T.env.PATH)&&($=T.env.PATH.split(h.$sc)),$===void 0||$.length===0))return h.$ic(a,w);async function g(i){if(await b.Promises.exists(i)){let o;try{o=await r.promises.stat(i)}catch(t){t.message.startsWith("EACCES")&&(o=await r.promises.lstat(i))}return o?!o.isDirectory():!1}return!1}for(const i of $){let o;if(h.$hc(i)?o=h.$ic(i,w):o=h.$ic(a,i,w),await g(o))return o;let t=o+".com";if(await g(t)||(t=o+".exe",await g(t)))return t}return h.$ic(a,w)}u.findExecutable=P})(D||(e.win32=D={}))});var Ye=this&&this.__decorate||function(me,e,r,h){var C=arguments.length,T=C<3?e:h===null?h=Object.getOwnPropertyDescriptor(e,r):h,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(me,e,r,h);else for(var R=me.length-1;R>=0;R--)(L=me[R])&&(T=(C<3?L(T):C>3?L(e,r,T):L(e,r))||T);return C>3&&T&&Object.defineProperty(e,r,T),T};define(ke[86],Ie([1,0,18,7,21,20,59,13,4,3,51,12,17]),function(me,e,r,h,C,T,L,R,b,c,I,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=e.ProxyChannel=e.$ki=e.$hi=e.$gi=e.$fi=e.RequestInitiator=e.$ei=e.$bi=e.$ai=void 0,e.$ci=E,e.$di=S,e.$ii=F,e.$ji=N,D=Ue(D);var P;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(P||(P={}));function w(B){switch(B){case P.Promise:return"req";case P.PromiseCancel:return"cancel";case P.EventListen:return"subscribe";case P.EventDispose:return"unsubscribe"}}var a;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(a||(a={}));function $(B){switch(B){case a.Initialize:return"init";case a.PromiseSuccess:return"reply:";case a.PromiseError:case a.PromiseErrorObj:return"replyErr:";case a.EventFire:return"event:"}}var f;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(f||(f={}));function g(B){let G=0;for(let Y=0;;Y+=7){const ee=B.read(1);if(G|=(ee.buffer[0]&127)<<Y,!(ee.buffer[0]&128))return G}}const i=d(0);function o(B,G){if(G===0){B.write(i);return}let Y=0;for(let ue=G;ue!==0;ue=ue>>>7)Y++;const ee=C.$Le.alloc(Y);for(let ue=0;G!==0;ue++)ee.buffer[ue]=G&127,G=G>>>7,G>0&&(ee.buffer[ue]|=128);B.write(ee)}class t{constructor(G){this.b=G,this.a=0}read(G){const Y=this.b.slice(this.a,this.a+G);return this.a+=Y.byteLength,Y}}e.$ai=t;class s{constructor(){this.a=[]}get buffer(){return C.$Le.concat(this.a)}write(G){this.a.push(G)}}e.$bi=s;var n;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(n||(n={}));function d(B){const G=C.$Le.alloc(1);return G.writeUInt8(B,0),G}const l={Undefined:d(n.Undefined),String:d(n.String),Buffer:d(n.Buffer),VSBuffer:d(n.VSBuffer),Array:d(n.Array),Object:d(n.Object),Uint:d(n.Int)},m=typeof Buffer<"u";function E(B,G){if(typeof G>"u")B.write(l.Undefined);else if(typeof G=="string"){const Y=C.$Le.fromString(G);B.write(l.String),o(B,Y.byteLength),B.write(Y)}else if(m&&Buffer.isBuffer(G)){const Y=C.$Le.wrap(G);B.write(l.Buffer),o(B,Y.byteLength),B.write(Y)}else if(G instanceof C.$Le)B.write(l.VSBuffer),o(B,G.byteLength),B.write(G);else if(Array.isArray(G)){B.write(l.Array),o(B,G.length);for(const Y of G)E(B,Y)}else if(typeof G=="number"&&(G|0)===G)B.write(l.Uint),o(B,G);else{const Y=C.$Le.fromString(JSON.stringify(G));B.write(l.Object),o(B,Y.byteLength),B.write(Y)}}function S(B){switch(B.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return B.read(g(B)).toString();case n.Buffer:return B.read(g(B)).buffer;case n.VSBuffer:return B.read(g(B));case n.Array:{const Y=g(B),ee=[];for(let ue=0;ue<Y;ue++)ee.push(S(B));return ee}case n.Object:return JSON.parse(B.read(g(B)).toString());case n.Int:return g(B)}}class y{constructor(G,Y,ee=null,ue=1e3){this.h=G,this.j=Y,this.k=ee,this.l=ue,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(re=>this.q(re)),this.m({type:a.Initialize})}registerChannel(G,Y){this.b.set(G,Y),setTimeout(()=>this.w(G),0)}m(G){switch(G.type){case a.Initialize:{const Y=this.o([G.type]);this.k?.logOutgoing(Y,0,k.OtherSide,$(G.type));return}case a.PromiseSuccess:case a.PromiseError:case a.EventFire:case a.PromiseErrorObj:{const Y=this.o([G.type,G.id],G.data);this.k?.logOutgoing(Y,G.id,k.OtherSide,$(G.type),G.data);return}}}o(G,Y=void 0){const ee=new s;return E(ee,G),E(ee,Y),this.p(ee.buffer)}p(G){try{return this.h.send(G),G.byteLength}catch{return 0}}q(G){const Y=new t(G),ee=S(Y),ue=S(Y),re=ee[0];switch(re){case P.Promise:return this.k?.logIncoming(G.byteLength,ee[1],k.OtherSide,`${w(re)}: ${ee[2]}.${ee[3]}`,ue),this.s({type:re,id:ee[1],channelName:ee[2],name:ee[3],arg:ue});case P.EventListen:return this.k?.logIncoming(G.byteLength,ee[1],k.OtherSide,`${w(re)}: ${ee[2]}.${ee[3]}`,ue),this.t({type:re,id:ee[1],channelName:ee[2],name:ee[3],arg:ue});case P.PromiseCancel:return this.k?.logIncoming(G.byteLength,ee[1],k.OtherSide,`${w(re)}`),this.u({type:re,id:ee[1]});case P.EventDispose:return this.k?.logIncoming(G.byteLength,ee[1],k.OtherSide,`${w(re)}`),this.u({type:re,id:ee[1]})}}s(G){const Y=this.b.get(G.channelName);if(!Y){this.v(G);return}const ee=new T.$ue;let ue;try{ue=Y.call(this.j,G.name,G.arg,ee.token)}catch($e){ue=Promise.reject($e)}const re=G.id;ue.then($e=>{this.m({id:re,data:$e,type:a.PromiseSuccess})},$e=>{$e instanceof Error?this.m({id:re,data:{message:$e.message,name:$e.name,stack:$e.stack?$e.stack.split(`
`):void 0},type:a.PromiseError}):this.m({id:re,data:$e,type:a.PromiseErrorObj})}).finally(()=>{ye.dispose(),this.d.delete(G.id)});const ye=(0,c.$Rc)(()=>ee.cancel());this.d.set(G.id,ye)}t(G){const Y=this.b.get(G.channelName);if(!Y){this.v(G);return}const ee=G.id,re=Y.listen(this.j,G.name,G.arg)(ye=>this.m({id:ee,data:ye,type:a.EventFire}));this.d.set(G.id,re)}u(G){const Y=this.d.get(G.id);Y&&(Y.dispose(),this.d.delete(G.id))}v(G){let Y=this.g.get(G.channelName);Y||(Y=[],this.g.set(G.channelName,Y));const ee=setTimeout(()=>{console.error(`Unknown channel: ${G.channelName}`),G.type===P.Promise&&this.m({id:G.id,data:{name:"Unknown channel",message:`Channel name '${G.channelName}' timed out after ${this.l}ms`,stack:void 0},type:a.PromiseError})},this.l);Y.push({request:G,timeoutTimer:ee})}w(G){const Y=this.g.get(G);if(Y){for(const ee of Y)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case P.Promise:this.s(ee.request);break;case P.EventListen:this.t(ee.request);break}this.g.delete(G)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Oc)(this.d.values()),this.d.clear()}}e.$ei=y;var k;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(k||(e.RequestInitiator=k={}));class A{constructor(G,Y=null){this.l=G,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new b.$je,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.s(ee)),this.j=Y}getChannel(G){const Y=this;return{call(ee,ue,re){return Y.a?Promise.reject(new R.$4):Y.m(G,ee,ue,re)},listen(ee,ue){return Y.a?b.Event.None:Y.o(G,ee,ue)}}}m(G,Y,ee,ue=T.CancellationToken.None){const re=this.g++,ye=P.Promise,$e={id:re,type:ye,channelName:G,name:Y,arg:ee};if(ue.isCancellationRequested)return Promise.reject(new R.$4);let J;return new Promise((se,ae)=>{if(ue.isCancellationRequested)return ae(new R.$4);const te=()=>{const oe=pe=>{switch(pe.type){case a.PromiseSuccess:this.f.delete(re),se(pe.data);break;case a.PromiseError:{this.f.delete(re);const we=new Error(pe.data.message);we.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,we.name=pe.data.name,ae(we);break}case a.PromiseErrorObj:this.f.delete(re),ae(pe.data);break}};this.f.set(re,oe),this.p($e)};let ce=null;this.b===f.Idle?te():(ce=(0,h.$ph)(oe=>this.u()),ce.then(()=>{ce=null,te()}));const le=()=>{ce?(ce.cancel(),ce=null):this.p({id:re,type:P.PromiseCancel}),ae(new R.$4)},Z=ue.onCancellationRequested(le);J=(0,c.$Qc)((0,c.$Rc)(le),Z),this.d.add(J)}).finally(()=>{J.dispose(),this.d.delete(J)})}o(G,Y,ee){const ue=this.g++,re=P.EventListen,ye={id:ue,type:re,channelName:G,name:Y,arg:ee};let $e=null;const J=new b.$je({onWillAddFirstListener:()=>{$e=(0,h.$ph)(se=>this.u()),$e.then(()=>{$e=null,this.d.add(J),this.p(ye)})},onDidRemoveLastListener:()=>{$e?($e.cancel(),$e=null):(this.d.delete(J),this.p({id:ue,type:P.EventDispose}))}}),W=se=>J.fire(se.data);return this.f.set(ue,W),J.event}p(G){switch(G.type){case P.Promise:case P.EventListen:{const Y=this.q([G.type,G.id,G.channelName,G.name],G.arg);this.j?.logOutgoing(Y,G.id,k.LocalSide,`${w(G.type)}: ${G.channelName}.${G.name}`,G.arg);return}case P.PromiseCancel:case P.EventDispose:{const Y=this.q([G.type,G.id]);this.j?.logOutgoing(Y,G.id,k.LocalSide,w(G.type));return}}}q(G,Y=void 0){const ee=new s;return E(ee,G),E(ee,Y),this.r(ee.buffer)}r(G){try{return this.l.send(G),G.byteLength}catch{return 0}}s(G){const Y=new t(G),ee=S(Y),ue=S(Y),re=ee[0];switch(re){case a.Initialize:return this.j?.logIncoming(G.byteLength,0,k.LocalSide,$(re)),this.t({type:ee[0]});case a.PromiseSuccess:case a.PromiseError:case a.EventFire:case a.PromiseErrorObj:return this.j?.logIncoming(G.byteLength,ee[1],k.LocalSide,$(re),ue),this.t({type:ee[0],id:ee[1],data:ue})}}t(G){if(G.type===a.Initialize){this.b=f.Idle,this.k.fire();return}this.f.get(G.id)?.(G)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Oc)(this.d.values()),this.d.clear()}}e.$fi=A,Ye([L.$7h],A.prototype,"onDidInitializePromise",null);class p{get connections(){const G=[];return this.f.forEach(Y=>G.push(Y)),G}constructor(G,Y,ee){this.a=new Map,this.f=new Set,this.g=new b.$je,this.onDidAddConnection=this.g.event,this.h=new b.$je,this.onDidRemoveConnection=this.h.event,this.j=new c.$Sc,this.j.add(G(({protocol:ue,onDidClientDisconnect:re})=>{const ye=b.Event.once(ue.onMessage);this.j.add(ye($e=>{const J=new t($e),W=S(J),se=new y(ue,W,Y,ee),ae=new A(ue,Y);this.a.forEach((ce,le)=>se.registerChannel(le,ce));const te={channelServer:se,channelClient:ae,ctx:W};this.f.add(te),this.g.fire(te),this.j.add(re(()=>{se.dispose(),ae.dispose(),this.f.delete(te),this.h.fire(te)}))}))}))}getChannel(G,Y){const ee=this;return{call(ue,re,ye){let $e;if((0,u.$qg)(Y)){const W=(0,r.$2b)(ee.connections.filter(Y));$e=W?Promise.resolve(W):b.Event.toPromise(b.Event.filter(ee.onDidAddConnection,Y))}else $e=Y.routeCall(ee,ue,re);const J=$e.then(W=>W.channelClient.getChannel(G));return F(J).call(ue,re,ye)},listen(ue,re){if((0,u.$qg)(Y))return ee.k(G,Y,ue,re);const ye=Y.routeEvent(ee,ue,re).then($e=>$e.channelClient.getChannel(G));return F(ye).listen(ue,re)}}}k(G,Y,ee,ue){const re=this;let ye;const $e=new b.$je({onWillAddFirstListener:()=>{ye=new c.$Sc;const J=new b.$pe,W=new Map,se=te=>{const le=te.channelClient.getChannel(G).listen(ee,ue),Z=J.add(le);W.set(te,Z)},ae=te=>{const ce=W.get(te);ce&&(ce.dispose(),W.delete(te))};re.connections.filter(Y).forEach(se),b.Event.filter(re.onDidAddConnection,Y)(se,void 0,ye),re.onDidRemoveConnection(ae,void 0,ye),J.event($e.fire,$e,ye),ye.add(J)},onDidRemoveLastListener:()=>{ye?.dispose(),ye=void 0}});return $e.event}registerChannel(G,Y){this.a.set(G,Y);for(const ee of this.f)ee.channelServer.registerChannel(G,Y)}dispose(){this.j.dispose();for(const G of this.f)G.channelClient.dispose(),G.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$gi=p;class v{constructor(G,Y,ee=null){const ue=new s;E(ue,Y),G.send(ue.buffer),this.a=new A(G,ee),this.d=new y(G,Y,ee)}getChannel(G){return this.a.getChannel(G)}registerChannel(G,Y){this.d.registerChannel(G,Y)}dispose(){this.a.dispose(),this.d.dispose()}}e.$hi=v;function F(B){return{call(G,Y,ee){return B.then(ue=>ue.call(G,Y,ee))},listen(G,Y){const ee=new b.$se;return B.then(ue=>ee.input=ue.listen(G,Y)),ee.event}}}function N(B){let G=!1;return{call(Y,ee,ue){return G?B.call(Y,ee,ue):(0,h.$Dh)(0).then(()=>G=!0).then(()=>B.call(Y,ee,ue))},listen(Y,ee){if(G)return B.listen(Y,ee);const ue=new b.$se;return(0,h.$Dh)(0).then(()=>G=!0).then(()=>ue.input=B.listen(Y,ee)),ue.event}}}class O{constructor(G){this.a=G}routeCall(G){return this.b(G)}routeEvent(G){return this.b(G)}async b(G){for(const Y of G.connections)if(await Promise.resolve(this.a(Y.ctx)))return Promise.resolve(Y);return await b.Event.toPromise(G.onDidAddConnection),await this.b(G)}}e.$ki=O;var j;(function(B){function G(re,ye,$e){const J=re,W=$e&&$e.disableMarshalling,se=new Map;for(const ae in J)ee(ae)&&se.set(ae,b.Event.buffer(J[ae],!0,void 0,ye));return new class{listen(ae,te,ce){const le=se.get(te);if(le)return le;const Z=J[te];if(typeof Z=="function"){if(ue(te))return Z.call(J,ce);if(ee(te))return se.set(te,b.Event.buffer(J[te],!0,void 0,ye)),se.get(te)}throw new R.$ab(`Event not found: ${te}`)}call(ae,te,ce){const le=J[te];if(typeof le=="function"){if(!W&&Array.isArray(ce))for(let oe=0;oe<ce.length;oe++)ce[oe]=(0,I.$_h)(ce[oe]);let Z=le.apply(J,ce);return Z instanceof Promise||(Z=Promise.resolve(Z)),Z}throw new R.$ab(`Method not found: ${te}`)}}}B.fromService=G;function Y(re,ye){const $e=ye&&ye.disableMarshalling;return new Proxy({},{get(J,W){if(typeof W=="string")return ye?.properties?.has(W)?ye.properties.get(W):ue(W)?function(se){return re.listen(W,se)}:ee(W)?re.listen(W):async function(...se){let ae;ye&&!(0,u.$lg)(ye.context)?ae=[ye.context,...se]:ae=se;const te=await re.call(W,ae);return $e?te:(0,I.$_h)(te)};throw new R.$ab(`Property not found: ${String(W)}`)}})}B.toService=Y;function ee(re){return re[0]==="o"&&re[1]==="n"&&D.$Cf(re.charCodeAt(2))}function ue(re){return/^onDynamic/.test(re)&&D.$Cf(re.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const G=B.toString();if(G!=="[object Object]")return G}return B}function V(B){return Array.isArray(B)?B.map(M):M(B)}function K(B,G,Y,ee,ue,re,ye){ye=V(ye);const $e=z[ue],J=$e[ee%$e.length];let W=[`%c[${B}]%c[${String(G).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${re}`,"color: darkgreen","color: grey","color: grey",`color: ${J}`];/\($/.test(re)?(W=W.concat(ye),W.push(")")):W.push(ye),console.log.apply(console,W)}class ne{constructor(G,Y){this.d=G,this.f=Y,this.a=0,this.b=0}logOutgoing(G,Y,ee,ue,re){this.b+=G,K(this.d,this.b,G,Y,ee,ue,re)}logIncoming(G,Y,ee,ue,re){this.a+=G,K(this.f,this.a,G,Y,ee,ue,re)}}e.$li=ne}),define(ke[68],Ie([1,0,21,4,3,86]),function(me,e,r,h,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$pi=e.$oi=e.$ni=e.ProtocolConstants=e.$mi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(l){l.Created="created",l.Read="read",l.Write="write",l.Open="open",l.Error="error",l.Close="close",l.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",l.NodeEndReceived="nodeEndReceived",l.NodeEndSent="nodeEndSent",l.NodeDrainBegin="nodeDrainBegin",l.NodeDrainEnd="nodeDrainEnd",l.zlibInflateError="zlibInflateError",l.zlibInflateData="zlibInflateData",l.zlibInflateInitialWrite="zlibInflateInitialWrite",l.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",l.zlibInflateWrite="zlibInflateWrite",l.zlibInflateFlushFired="zlibInflateFlushFired",l.zlibDeflateError="zlibDeflateError",l.zlibDeflateData="zlibDeflateData",l.zlibDeflateWrite="zlibDeflateWrite",l.zlibDeflateFlushFired="zlibDeflateFlushFired",l.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",l.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",l.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",l.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",l.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",l.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",l.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",l.ProtocolHeaderRead="protocolHeaderRead",l.ProtocolMessageRead="protocolMessageRead",l.ProtocolHeaderWrite="protocolHeaderWrite",l.ProtocolMessageWrite="protocolMessageWrite",l.ProtocolWrite="protocolWrite"})(L||(e.SocketDiagnosticsEventType=L={}));var R;(function(l){l.enableDiagnostics=!1,l.records=[];const m=new WeakMap;let E=0;function S(k,A){if(!m.has(k)){const p=String(++E);m.set(k,p)}return m.get(k)}function y(k,A,p,v){if(!l.enableDiagnostics)return;const F=S(k,A);if(v instanceof r.$Le||v instanceof Uint8Array||v instanceof ArrayBuffer||ArrayBuffer.isView(v)){const N=r.$Le.alloc(v.byteLength);N.set(v),l.records.push({timestamp:Date.now(),id:F,label:A,type:p,buff:N})}else l.records.push({timestamp:Date.now(),id:F,label:A,type:p,data:v})}l.traceSocketEvent=y})(R||(e.SocketDiagnostics=R={}));var b;(function(l){l[l.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",l[l.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b||(e.SocketCloseEventType=b={}));let c=null;function I(){return c||(c=r.$Le.alloc(0)),c}class D{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(m){this.a.push(m),this.b+=m.byteLength}read(m){return this.c(m,!0)}peek(m){return this.c(m,!1)}c(m,E){if(m===0)return I();if(m>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===m){const A=this.a[0];return E&&(this.a.shift(),this.b-=m),A}if(this.a[0].byteLength>m){const A=this.a[0].slice(0,m);return E&&(this.a[0]=this.a[0].slice(m),this.b-=m),A}const S=r.$Le.alloc(m);let y=0,k=0;for(;m>0;){const A=this.a[k];if(A.byteLength>m){const p=A.slice(0,m);S.set(p,y),y+=m,E&&(this.a[k]=A.slice(m),this.b-=m),m-=m}else S.set(A,y),y+=A.byteLength,E?(this.a.shift(),this.b-=A.byteLength):k++,m-=A.byteLength}return S}}e.$mi=D;var u;(function(l){l[l.None=0]="None",l[l.Regular=1]="Regular",l[l.Control=2]="Control",l[l.Ack=3]="Ack",l[l.Disconnect=5]="Disconnect",l[l.ReplayRequest=6]="ReplayRequest",l[l.Pause=7]="Pause",l[l.Resume=8]="Resume",l[l.KeepAlive=9]="KeepAlive"})(u||(u={}));function P(l){switch(l){case u.None:return"None";case u.Regular:return"Regular";case u.Control:return"Control";case u.Ack:return"Ack";case u.Disconnect:return"Disconnect";case u.ReplayRequest:return"ReplayRequest";case u.Pause:return"PauseWriting";case u.Resume:return"ResumeWriting";case u.KeepAlive:return"KeepAlive"}}var w;(function(l){l[l.HeaderLength=13]="HeaderLength",l[l.AcknowledgeTime=2e3]="AcknowledgeTime",l[l.TimeoutTime=2e4]="TimeoutTime",l[l.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",l[l.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",l[l.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(w||(e.ProtocolConstants=w={}));class a{constructor(m,E,S,y){this.type=m,this.id=E,this.ack=S,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class $ extends C.$Tc{constructor(m){super(),this.f=this.B(new h.$je),this.onMessage=this.f.event,this.g={readHead:!0,readLen:w.HeaderLength,messageType:u.None,id:0,ack:0},this.a=m,this.b=!1,this.c=new D,this.B(this.a.onData(E=>this.acceptChunk(E))),this.lastReadTime=Date.now()}acceptChunk(m){if(!(!m||m.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(m);this.c.byteLength>=this.g.readLen;){const E=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=E.readUInt32BE(9),this.g.messageType=E.readUInt8(0),this.g.id=E.readUInt32BE(1),this.g.ack=E.readUInt32BE(5),this.a.traceSocketEvent(L.ProtocolHeaderRead,{messageType:P(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const S=this.g.messageType,y=this.g.id,k=this.g.ack;if(this.g.readHead=!0,this.g.readLen=w.HeaderLength,this.g.messageType=u.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(L.ProtocolMessageRead,E),this.f.fire(new a(S,y,k,E)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class f{constructor(m){this.k=null,this.a=!1,this.b=!1,this.c=m,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(m){if(this.a)return;m.writtenTime=Date.now(),this.lastWriteTime=Date.now();const E=r.$Le.alloc(w.HeaderLength);E.writeUInt8(m.type,0),E.writeUInt32BE(m.id,1),E.writeUInt32BE(m.ack,5),E.writeUInt32BE(m.data.byteLength,9),this.c.traceSocketEvent(L.ProtocolHeaderWrite,{messageType:P(m.type),id:m.id,ack:m.ack,messageSize:m.data.byteLength}),this.c.traceSocketEvent(L.ProtocolMessageWrite,m.data),this.j(E,m.data)}g(m,E){const S=this.f===0;return this.d.push(m,E),this.f+=m.byteLength+E.byteLength,S}h(){const m=r.$Le.concat(this.d,this.f);return this.d.length=0,this.f=0,m}j(m,E){this.g(m,E)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const m=this.h();this.c.traceSocketEvent(L.ProtocolWrite,{byteLength:m.byteLength}),this.c.write(m)}}class g extends C.$Tc{constructor(m){super(),this.f=new h.$je,this.onMessage=this.f.event,this.g=new h.$je,this.onDidDispose=this.g.event,this.a=m,this.b=this.B(new f(this.a)),this.c=this.B(new $(this.a)),this.B(this.c.onMessage(E=>{E.type===u.Regular&&this.f.fire(E.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(m){this.b.write(new a(u.Regular,0,0,m))}}e.$ni=g;class i extends T.$hi{static fromSocket(m,E){return new i(new g(m),E)}get onDidDispose(){return this.b.onDidDispose}constructor(m,E,S=null){super(m,E,S),this.b=m}dispose(){super.dispose();const m=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),m.end()}}e.$oi=i;class o{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new h.$je({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(m){this.b?this.d.length>0?this.d.push(m):this.a.fire(m):this.d.push(m)}flushBuffer(){this.d=[]}}e.$pi=o;class t{constructor(m){this.data=m,this.next=null}}class s{constructor(){this.a=null,this.b=null}length(){let m=0,E=this.a;for(;E;)E=E.next,m++;return m}peek(){return this.a?this.a.data:null}toArray(){const m=[];let E=0,S=this.a;for(;S;)m[E++]=S.data,S=S.next;return m}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(m){const E=new t(m);if(!this.a){this.a=E,this.b=E;return}this.b.next=E,this.b=E}}class n{static{this.a=10}static{this.b=null}static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const m=Date.now();for(let E=0;E<n.a;E++)this.c[E]=m-1e3*E;setInterval(()=>{for(let E=n.a;E>=1;E--)this.c[E]=this.c[E-1];this.c[0]=Date.now()},1e3)}d(){const m=Date.now(),E=(1+n.a)*1e3;let S=0;for(let y=0;y<n.a;y++)m-this.c[y]<=E&&S++;return 1-S/n.a}hasHighLoad(){return this.d()>=.5}}class d{get unacknowledgedCount(){return this.d-this.f}constructor(m){this.v=new o,this.onControlMessage=this.v.event,this.w=new o,this.onMessage=this.w.event,this.x=new o,this.onDidDispose=this.x.event,this.y=new o,this.onSocketClose=this.y.event,this.z=new o,this.onSocketTimeout=this.z.event,this.t=m.loadEstimator??n.getInstance(),this.u=m.sendKeepAlive??!0,this.a=!1,this.c=new s,this.d=0,this.f=0,this.g=null,this.h=0,this.j=0,this.k=0,this.l=null,this.n=0,this.o=Date.now(),this.s=new C.$Sc,this.p=m.socket,this.q=this.s.add(new f(this.p)),this.r=this.s.add(new $(this.p)),this.s.add(this.r.onMessage(E=>this.A(E))),this.s.add(this.p.onClose(E=>this.y.fire(E))),m.initialChunk&&this.r.acceptChunk(m.initialChunk),this.u?this.m=setInterval(()=>{this.E()},w.KeepAliveSendTime):this.m=null}dispose(){this.g&&(clearTimeout(this.g),this.g=null),this.l&&(clearTimeout(this.l),this.l=null),this.m&&(clearInterval(this.m),this.m=null),this.s.dispose()}drain(){return this.q.drain()}sendDisconnect(){if(!this.b){this.b=!0;const m=new a(u.Disconnect,0,0,I());this.q.write(m),this.q.flush()}}sendPause(){const m=new a(u.Pause,0,0,I());this.q.write(m)}sendResume(){const m=new a(u.Resume,0,0,I());this.q.write(m)}pauseSocketWriting(){this.q.pause()}getSocket(){return this.p}getMillisSinceLastIncomingData(){return Date.now()-this.r.lastReadTime}beginAcceptReconnection(m,E){this.a=!0,this.s.dispose(),this.s=new C.$Sc,this.v.flushBuffer(),this.y.flushBuffer(),this.z.flushBuffer(),this.p.dispose(),this.n=0,this.o=Date.now(),this.p=m,this.q=this.s.add(new f(this.p)),this.r=this.s.add(new $(this.p)),this.s.add(this.r.onMessage(S=>this.A(S))),this.s.add(this.p.onClose(S=>this.y.fire(S))),this.r.acceptChunk(E)}endAcceptReconnection(){this.a=!1,this.j=this.h;const m=new a(u.Ack,0,this.j,I());this.q.write(m);const E=this.c.toArray();for(let S=0,y=E.length;S<y;S++)this.q.write(E[S]);this.C()}acceptDisconnect(){this.x.fire()}A(m){if(m.ack>this.f){this.f=m.ack;do{const E=this.c.peek();if(E&&E.id<=m.ack)this.c.pop();else break}while(!0)}switch(m.type){case u.None:break;case u.Regular:{if(m.id>this.h)if(m.id!==this.h+1){const E=Date.now();E-this.n>1e4&&(this.n=E,this.q.write(new a(u.ReplayRequest,0,0,I())))}else this.h=m.id,this.k=Date.now(),this.B(),this.w.fire(m.data);break}case u.Control:{this.v.fire(m.data);break}case u.Ack:break;case u.Disconnect:{this.x.fire();break}case u.ReplayRequest:{const E=this.c.toArray();for(let S=0,y=E.length;S<y;S++)this.q.write(E[S]);this.C();break}case u.Pause:{this.q.pause();break}case u.Resume:{this.q.resume();break}case u.KeepAlive:break}}readEntireBuffer(){return this.r.readEntireBuffer()}flush(){this.q.flush()}send(m){const E=++this.d;this.j=this.h;const S=new a(u.Regular,E,this.j,m);this.c.push(S),this.a||(this.q.write(S),this.C())}sendControl(m){const E=new a(u.Control,0,0,m);this.q.write(E)}B(){if(this.h<=this.j||this.l)return;const m=Date.now()-this.k;if(m>=w.AcknowledgeTime){this.D();return}this.l=setTimeout(()=>{this.l=null,this.B()},w.AcknowledgeTime-m+5)}C(){if(this.d<=this.f||this.g||this.a)return;const m=this.c.peek(),E=Date.now()-m.writtenTime,S=Date.now()-this.r.lastReadTime,y=Date.now()-this.o;if(E>=w.TimeoutTime&&S>=w.TimeoutTime&&y>=w.TimeoutTime&&!this.t.hasHighLoad()){this.o=Date.now(),this.z.fire({unacknowledgedMsgCount:this.c.length(),timeSinceOldestUnacknowledgedMsg:E,timeSinceLastReceivedSomeData:S});return}const k=Math.max(w.TimeoutTime-E,w.TimeoutTime-S,w.TimeoutTime-y,500);this.g=setTimeout(()=>{this.g=null,this.C()},k)}D(){if(this.h<=this.j)return;this.j=this.h;const m=new a(u.Ack,0,this.j,I());this.q.write(m)}E(){this.j=this.h;const m=new a(u.KeepAlive,0,this.j,I());this.q.write(m)}}e.$qi=d}),define(ke[191],Ie([1,0,56,7,21,20,187,13,4,3,24,109,104,86]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=e.$dr=void 0,R=Ue(R);class w extends P.$ei{constructor(f){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",g=>C.$Le.wrap(Buffer.from(g,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.$dr=w;class a{constructor(f,g){this.i=f,this.j=g,this.c=new Set,this.g=new Map,this.h=new b.$je,this.onDidProcessExit=this.h.event;const i=g&&g.timeout?g.timeout:6e4;this.b=new h.$zh(i),this.d=null,this.f=null}getChannel(f){const g=this;return{call(i,o,t){return g.k(f,i,o,t)},listen(i,o){return g.l(f,i,o)}}}k(f,g,i,o=T.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(R.$5());this.b.cancel();const t=this.n(f),s=(0,h.$ph)(l=>t.call(g,i,l)),n=o.onCancellationRequested(()=>s.cancel()),d=(0,c.$Rc)(()=>s.cancel());return this.c.add(d),s.finally(()=>{n.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),s}l(f,g,i){if(!this.b)return b.Event.None;this.b.cancel();let o;const t=new b.$je({onWillAddFirstListener:()=>{o=this.n(f).listen(g,i)(t.fire,t),this.c.add(o)},onDidRemoveLastListener:()=>{this.c.delete(o),o.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return t.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],g=Object.create(null);g.env={...(0,I.$ao)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(g.env={...g.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(g.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(E=>!/^--inspect(-brk)?=/.test(E)).filter(E=>!E.startsWith("--vscode-"))),(0,u.$im)(g.env),this.d=(0,r.fork)(this.i,f,g);const i=new b.$je,t=b.Event.fromNodeEventEmitter(this.d,"message",E=>E)(E=>{if((0,L.$_q)(E)){(0,L.log)(E,`IPC Library: ${this.j.serverName}`);return}i.fire(C.$Le.wrap(Buffer.from(E,"base64")))}),s=this.j.useQueue?(0,D.$vm)(this.d):this.d,n=E=>this.d&&this.d.connected&&s.send(E.buffer.toString("base64")),d=i.event,l={send:n,onMessage:d};this.f=new P.$fi(l);const m=()=>this.o();process.once("exit",m),this.d.on("error",E=>console.warn('IPC "'+this.j.serverName+'" errored with '+E)),this.d.on("exit",(E,S)=>{process.removeListener("exit",m),t.dispose(),this.c.forEach(y=>(0,c.$Oc)(y)),this.c.clear(),E!==0&&S!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+E+" and signal "+S),this.b?.cancel(),this.o(),this.h.fire({code:E,signal:S})})}return this.f}n(f){let g=this.g.get(f);return g||(g=this.m.getChannel(f),this.g.set(f,g)),g}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$er=a}),define(ke[192],Ie([1,0,7,4,3,51,17]),function(me,e,r,h,C,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=e.StorageState=e.StorageHint=void 0,e.$_p=b;var R;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function b(u){const P=u;return P?.changed instanceof Map||P?.deleted instanceof Set}var c;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(c||(e.StorageState=c={}));class I extends C.$Tc{static{this.a=100}constructor(P,w=Object.create(null)){super(),this.r=P,this.s=w,this.b=this.B(new h.$me),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new r.$Ah(I.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(P=>this.u(P)))}u(P){this.b.pause();try{P.changed?.forEach((w,a)=>this.w(a,w)),P.deleted?.forEach(w=>this.w(w,void 0))}finally{this.b.resume()}}w(P,w){if(this.c===c.Closed)return;let a=!1;(0,L.$lg)(w)?a=this.f.delete(P):this.f.get(P)!==w&&(this.f.set(P,w),a=!0),a&&this.b.fire({key:P,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(P,w){const a=this.f.get(P);return(0,L.$lg)(a)?w:a}getBoolean(P,w){const a=this.get(P);return(0,L.$lg)(a)?w:a==="true"}getNumber(P,w){const a=this.get(P);return(0,L.$lg)(a)?w:parseInt(a,10)}getObject(P,w){const a=this.get(P);return(0,L.$lg)(a)?w:(0,T.$$h)(a)}async set(P,w,a=!1){if(this.c===c.Closed)return;if((0,L.$lg)(w))return this.delete(P,a);const $=(0,L.$eg)(w)||Array.isArray(w)?(0,T.$0h)(w):String(w);if(this.f.get(P)!==$)return this.f.set(P,$),this.j.set(P,$),this.h.delete(P),this.b.fire({key:P,external:a}),this.D()}async delete(P,w=!1){if(!(this.c===c.Closed||!this.f.delete(P)))return this.h.has(P)||this.h.add(P),this.j.delete(P),this.b.fire({key:P,external:w}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const P={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(P).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(P){if(!(this.c===c.Closed||this.m))return this.D(P)}async D(P){return this.s.hint===R.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),P)}async whenFlushed(){if(this.z)return new Promise(P=>this.n.push(P))}isInMemory(){return this.s.hint===R.STORAGE_IN_MEMORY}}e.$aq=I;class D{constructor(){this.onDidChangeItemsExternal=h.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(P){P.insert?.forEach((w,a)=>this.a.set(a,w)),P.delete?.forEach(w=>this.a.delete(w))}async optimize(){}async close(){}}e.$bq=D}),define(ke[139],Ie([1,0,83]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$du=e.$cu=void 0;class h{constructor(R){const b=(0,r.$$e)(R);this.c=b,this.a=h.d(b),this.b=new Map}static d(R){const b=new Uint8Array(256);return b.fill(R),b}set(R,b){const c=(0,r.$$e)(b);R>=0&&R<256?this.a[R]=c:this.b.set(R,c)}get(R){return R>=0&&R<256?this.a[R]:this.b.get(R)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$cu=h;var C;(function(L){L[L.False=0]="False",L[L.True=1]="True"})(C||(C={}));class T{constructor(){this.a=new h(C.False)}add(R){this.a.set(R,C.True)}has(R){return this.a.get(R)===C.True}clear(){return this.a.clear()}}e.$du=T}),define(ke[193],Ie([1,0,26]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$uu=C;var h;(function(T){T[T.Unknown=0]="Unknown",T[T.Invalid=3]="Invalid",T[T.LF=1]="LF",T[T.CRLF=2]="CRLF"})(h||(e.StringEOL=h={}));function C(T){let L=0,R=0,b=0,c=h.Unknown;for(let I=0,D=T.length;I<D;I++){const u=T.charCodeAt(I);u===r.CharCode.CarriageReturn?(L===0&&(R=I),L++,I+1<D&&T.charCodeAt(I+1)===r.CharCode.LineFeed?(c|=h.CRLF,I++):c|=h.Invalid,b=I+1):u===r.CharCode.LineFeed&&(c|=h.LF,L===0&&(R=I),L++,b=I+1)}return L===0&&(R=T.length),[L,R,T.length-b,c]}}),define(ke[57],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jt=void 0;class r{constructor(C,T){this.lineNumber=C,this.column=T}with(C=this.lineNumber,T=this.column){return C===this.lineNumber&&T===this.column?this:new r(C,T)}delta(C=0,T=0){return this.with(this.lineNumber+C,this.column+T)}equals(C){return r.equals(this,C)}static equals(C,T){return!C&&!T?!0:!!C&&!!T&&C.lineNumber===T.lineNumber&&C.column===T.column}isBefore(C){return r.isBefore(this,C)}static isBefore(C,T){return C.lineNumber<T.lineNumber?!0:T.lineNumber<C.lineNumber?!1:C.column<T.column}isBeforeOrEqual(C){return r.isBeforeOrEqual(this,C)}static isBeforeOrEqual(C,T){return C.lineNumber<T.lineNumber?!0:T.lineNumber<C.lineNumber?!1:C.column<=T.column}static compare(C,T){const L=C.lineNumber|0,R=T.lineNumber|0;if(L===R){const b=C.column|0,c=T.column|0;return b-c}return L-R}clone(){return new r(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(C){return new r(C.lineNumber,C.column)}static isIPosition(C){return C&&typeof C.lineNumber=="number"&&typeof C.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Jt=r}),define(ke[30],Ie([1,0,57]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kt=void 0;class h{constructor(T,L,R,b){T>R||T===R&&L>b?(this.startLineNumber=R,this.startColumn=b,this.endLineNumber=T,this.endColumn=L):(this.startLineNumber=T,this.startColumn=L,this.endLineNumber=R,this.endColumn=b)}isEmpty(){return h.isEmpty(this)}static isEmpty(T){return T.startLineNumber===T.endLineNumber&&T.startColumn===T.endColumn}containsPosition(T){return h.containsPosition(this,T)}static containsPosition(T,L){return!(L.lineNumber<T.startLineNumber||L.lineNumber>T.endLineNumber||L.lineNumber===T.startLineNumber&&L.column<T.startColumn||L.lineNumber===T.endLineNumber&&L.column>T.endColumn)}static strictContainsPosition(T,L){return!(L.lineNumber<T.startLineNumber||L.lineNumber>T.endLineNumber||L.lineNumber===T.startLineNumber&&L.column<=T.startColumn||L.lineNumber===T.endLineNumber&&L.column>=T.endColumn)}containsRange(T){return h.containsRange(this,T)}static containsRange(T,L){return!(L.startLineNumber<T.startLineNumber||L.endLineNumber<T.startLineNumber||L.startLineNumber>T.endLineNumber||L.endLineNumber>T.endLineNumber||L.startLineNumber===T.startLineNumber&&L.startColumn<T.startColumn||L.endLineNumber===T.endLineNumber&&L.endColumn>T.endColumn)}strictContainsRange(T){return h.strictContainsRange(this,T)}static strictContainsRange(T,L){return!(L.startLineNumber<T.startLineNumber||L.endLineNumber<T.startLineNumber||L.startLineNumber>T.endLineNumber||L.endLineNumber>T.endLineNumber||L.startLineNumber===T.startLineNumber&&L.startColumn<=T.startColumn||L.endLineNumber===T.endLineNumber&&L.endColumn>=T.endColumn)}plusRange(T){return h.plusRange(this,T)}static plusRange(T,L){let R,b,c,I;return L.startLineNumber<T.startLineNumber?(R=L.startLineNumber,b=L.startColumn):L.startLineNumber===T.startLineNumber?(R=L.startLineNumber,b=Math.min(L.startColumn,T.startColumn)):(R=T.startLineNumber,b=T.startColumn),L.endLineNumber>T.endLineNumber?(c=L.endLineNumber,I=L.endColumn):L.endLineNumber===T.endLineNumber?(c=L.endLineNumber,I=Math.max(L.endColumn,T.endColumn)):(c=T.endLineNumber,I=T.endColumn),new h(R,b,c,I)}intersectRanges(T){return h.intersectRanges(this,T)}static intersectRanges(T,L){let R=T.startLineNumber,b=T.startColumn,c=T.endLineNumber,I=T.endColumn;const D=L.startLineNumber,u=L.startColumn,P=L.endLineNumber,w=L.endColumn;return R<D?(R=D,b=u):R===D&&(b=Math.max(b,u)),c>P?(c=P,I=w):c===P&&(I=Math.min(I,w)),R>c||R===c&&b>I?null:new h(R,b,c,I)}equalsRange(T){return h.equalsRange(this,T)}static equalsRange(T,L){return!T&&!L?!0:!!T&&!!L&&T.startLineNumber===L.startLineNumber&&T.startColumn===L.startColumn&&T.endLineNumber===L.endLineNumber&&T.endColumn===L.endColumn}getEndPosition(){return h.getEndPosition(this)}static getEndPosition(T){return new r.$Jt(T.endLineNumber,T.endColumn)}getStartPosition(){return h.getStartPosition(this)}static getStartPosition(T){return new r.$Jt(T.startLineNumber,T.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(T,L){return new h(this.startLineNumber,this.startColumn,T,L)}setStartPosition(T,L){return new h(T,L,this.endLineNumber,this.endColumn)}collapseToStart(){return h.collapseToStart(this)}static collapseToStart(T){return new h(T.startLineNumber,T.startColumn,T.startLineNumber,T.startColumn)}collapseToEnd(){return h.collapseToEnd(this)}static collapseToEnd(T){return new h(T.endLineNumber,T.endColumn,T.endLineNumber,T.endColumn)}delta(T){return new h(this.startLineNumber+T,this.startColumn,this.endLineNumber+T,this.endColumn)}static fromPositions(T,L=T){return new h(T.lineNumber,T.column,L.lineNumber,L.column)}static lift(T){return T?new h(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):null}static isIRange(T){return T&&typeof T.startLineNumber=="number"&&typeof T.startColumn=="number"&&typeof T.endLineNumber=="number"&&typeof T.endColumn=="number"}static areIntersectingOrTouching(T,L){return!(T.endLineNumber<L.startLineNumber||T.endLineNumber===L.startLineNumber&&T.endColumn<L.startColumn||L.endLineNumber<T.startLineNumber||L.endLineNumber===T.startLineNumber&&L.endColumn<T.startColumn)}static areIntersecting(T,L){return!(T.endLineNumber<L.startLineNumber||T.endLineNumber===L.startLineNumber&&T.endColumn<=L.startColumn||L.endLineNumber<T.startLineNumber||L.endLineNumber===T.startLineNumber&&L.endColumn<=T.startColumn)}static compareRangesUsingStarts(T,L){if(T&&L){const c=T.startLineNumber|0,I=L.startLineNumber|0;if(c===I){const D=T.startColumn|0,u=L.startColumn|0;if(D===u){const P=T.endLineNumber|0,w=L.endLineNumber|0;if(P===w){const a=T.endColumn|0,$=L.endColumn|0;return a-$}return P-w}return D-u}return c-I}return(T?1:0)-(L?1:0)}static compareRangesUsingEnds(T,L){return T.endLineNumber===L.endLineNumber?T.endColumn===L.endColumn?T.startLineNumber===L.startLineNumber?T.startColumn-L.startColumn:T.startLineNumber-L.startLineNumber:T.endColumn-L.endColumn:T.endLineNumber-L.endLineNumber}static spansMultipleLines(T){return T.endLineNumber>T.startLineNumber}toJSON(){return this}}e.$Kt=h}),define(ke[194],Ie([1,0,30]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lt=void 0;class h{static insert(T,L){return{range:new r.$Kt(T.lineNumber,T.column,T.lineNumber,T.column),text:L,forceMoveMarkers:!0}}static delete(T){return{range:T,text:null}}static replace(T,L){return{range:T,text:L}}static replaceMove(T,L){return{range:T,text:L,forceMoveMarkers:!0}}}e.$Lt=h}),define(ke[195],Ie([1,0,57,30]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mt=e.SelectionDirection=void 0;var C;(function(L){L[L.LTR=0]="LTR",L[L.RTL=1]="RTL"})(C||(e.SelectionDirection=C={}));class T extends h.$Kt{constructor(R,b,c,I){super(R,b,c,I),this.selectionStartLineNumber=R,this.selectionStartColumn=b,this.positionLineNumber=c,this.positionColumn=I}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(R){return T.selectionsEqual(this,R)}static selectionsEqual(R,b){return R.selectionStartLineNumber===b.selectionStartLineNumber&&R.selectionStartColumn===b.selectionStartColumn&&R.positionLineNumber===b.positionLineNumber&&R.positionColumn===b.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?C.LTR:C.RTL}setEndPosition(R,b){return this.getDirection()===C.LTR?new T(this.startLineNumber,this.startColumn,R,b):new T(R,b,this.startLineNumber,this.startColumn)}getPosition(){return new r.$Jt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new r.$Jt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(R,b){return this.getDirection()===C.LTR?new T(R,b,this.endLineNumber,this.endColumn):new T(this.endLineNumber,this.endColumn,R,b)}static fromPositions(R,b=R){return new T(R.lineNumber,R.column,b.lineNumber,b.column)}static fromRange(R,b){return b===C.LTR?new T(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):new T(R.endLineNumber,R.endColumn,R.startLineNumber,R.startColumn)}static liftSelection(R){return new T(R.selectionStartLineNumber,R.selectionStartColumn,R.positionLineNumber,R.positionColumn)}static selectionsArrEqual(R,b){if(R&&!b||!R&&b)return!1;if(!R&&!b)return!0;if(R.length!==b.length)return!1;for(let c=0,I=R.length;c<I;c++)if(!this.selectionsEqual(R[c],b[c]))return!1;return!0}static isISelection(R){return R&&typeof R.selectionStartLineNumber=="number"&&typeof R.selectionStartColumn=="number"&&typeof R.positionLineNumber=="number"&&typeof R.positionColumn=="number"}static createWithDirection(R,b,c,I,D){return D===C.LTR?new T(R,b,c,I):new T(c,I,R,b)}}e.$Mt=T}),define(ke[196],Ie([1,0,12,10,21]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_t=void 0,e.$0t=I,e.$$t=D,r=Ue(r),h=Ue(h),C=Ue(C);let T;function L(){return T||(T=new TextDecoder("UTF-16LE")),T}let R;function b(){return R||(R=new TextDecoder("UTF-16BE")),R}let c;function I(){return c||(c=h.$E()?L():b()),c}function D(w,a,$){const f=new Uint16Array(w.buffer,a,$);return $>0&&(f[0]===65279||f[0]===65534)?u(w,a,$):L().decode(f)}function u(w,a,$){const f=[];let g=0;for(let i=0;i<$;i++){const o=C.$Ne(w,a);a+=2,f[g++]=String.fromCharCode(o)}return f.join("")}class P{constructor(a){this.a=a|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const a=new Uint16Array(this.b.buffer,0,this.d);return I().decode(a)}f(){const a=this.e();this.d=0,this.c===null?this.c=[a]:this.c[this.c.length]=a}appendCharCode(a){const $=this.a-this.d;$<=1&&($===0||r.$Hf(a))&&this.f(),this.b[this.d++]=a}appendASCIICharCode(a){this.d===this.a&&this.f(),this.b[this.d++]=a}appendString(a){const $=a.length;if(this.d+$>=this.a){this.f(),this.c[this.c.length]=a;return}for(let f=0;f<$;f++)this.b[this.d++]=a.charCodeAt(f)}}e.$_t=P}),define(ke[197],Ie([1,0,21,196]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$au=void 0,e.$bu=L,r=Ue(r);function C(b){return b.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class T{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(c,I,D,u){this.oldPosition=c,this.oldText=I,this.newPosition=D,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${C(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${C(this.oldText)}")`:`(replace@${this.oldPosition} "${C(this.oldText)}" with "${C(this.newText)}")`}static a(c){return 4+2*c.length}static c(c,I,D){const u=I.length;r.$Qe(c,u,D),D+=4;for(let P=0;P<u;P++)r.$Oe(c,I.charCodeAt(P),D),D+=2;return D}static d(c,I){const D=r.$Pe(c,I);return I+=4,(0,h.$$t)(c,I,D)}writeSize(){return 8+T.a(this.oldText)+T.a(this.newText)}write(c,I){return r.$Qe(c,this.oldPosition,I),I+=4,r.$Qe(c,this.newPosition,I),I+=4,I=T.c(c,this.oldText,I),I=T.c(c,this.newText,I),I}static read(c,I,D){const u=r.$Pe(c,I);I+=4;const P=r.$Pe(c,I);I+=4;const w=T.d(c,I);I+=T.a(w);const a=T.d(c,I);return I+=T.a(a),D.push(new T(u,w,P,a)),I}}e.$au=T;function L(b,c){return b===null||b.length===0?c:new R(b,c).compress()}class R{constructor(c,I){this.a=c,this.c=I,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let c=0,I=0,D=this.n(c),u=this.l(I);for(;c<this.f||I<this.h;){if(D===null){this.k(u),u=this.l(++I);continue}if(u===null){this.m(D),D=this.n(++c);continue}if(u.oldEnd<=D.newPosition){this.k(u),u=this.l(++I);continue}if(D.newEnd<=u.oldPosition){this.m(D),D=this.n(++c);continue}if(u.oldPosition<D.newPosition){const[f,g]=R.r(u,D.newPosition-u.oldPosition);this.k(f),u=g;continue}if(D.newPosition<u.oldPosition){const[f,g]=R.q(D,u.oldPosition-D.newPosition);this.m(f),D=g;continue}let a,$;if(u.oldEnd===D.newEnd)a=D,$=u,D=this.n(++c),u=this.l(++I);else if(u.oldEnd<D.newEnd){const[f,g]=R.q(D,u.oldLength);a=f,$=u,D=g,u=this.l(++I)}else{const[f,g]=R.r(u,D.newLength);a=D,$=f,D=this.n(++c),u=g}this.d[this.e++]=new T(a.oldPosition,a.oldText,$.newPosition,$.newText),this.g+=a.newLength-a.oldLength,this.j+=$.newLength-$.oldLength}const P=R.s(this.d);return R.t(P)}k(c){this.d[this.e++]=R.o(this.g,c),this.j+=c.newLength-c.oldLength}l(c){return c<this.h?this.c[c]:null}m(c){this.d[this.e++]=R.p(this.j,c),this.g+=c.newLength-c.oldLength}n(c){return c<this.f?this.a[c]:null}static o(c,I){return new T(I.oldPosition-c,I.oldText,I.newPosition,I.newText)}static p(c,I){return new T(I.oldPosition,I.oldText,I.newPosition+c,I.newText)}static q(c,I){const D=c.newText.substr(0,I),u=c.newText.substr(I);return[new T(c.oldPosition,c.oldText,c.newPosition,D),new T(c.oldEnd,"",c.newPosition+I,u)]}static r(c,I){const D=c.oldText.substr(0,I),u=c.oldText.substr(I);return[new T(c.oldPosition,D,c.newPosition,c.newText),new T(c.oldPosition+I,u,c.newEnd,"")]}static s(c){if(c.length===0)return c;const I=[];let D=0,u=c[0];for(let P=1;P<c.length;P++){const w=c[P];u.oldEnd===w.oldPosition?u=new T(u.oldPosition,u.oldText+w.oldText,u.newPosition,u.newText+w.newText):(I[D++]=u,u=w)}return I[D++]=u,I}static t(c){if(c.length===0)return c;const I=[];let D=0;for(let u=0;u<c.length;u++){const P=c[u];P.oldText!==P.newText&&(I[D++]=P)}return I}}}),define(ke[198],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ht=void 0,e.$ht={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[199],Ie([1,0,26,28,139]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eu=e.WordCharacterClass=void 0,e.$fu=b;var T;(function(c){c[c.Regular=0]="Regular",c[c.Whitespace=1]="Whitespace",c[c.WordSeparator=2]="WordSeparator"})(T||(e.WordCharacterClass=T={}));class L extends C.$cu{constructor(I,D){super(T.Regular),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=D,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let u=0,P=I.length;u<P;u++)this.set(I.charCodeAt(u),T.WordSeparator);this.set(r.CharCode.Space,T.Whitespace),this.set(r.CharCode.Tab,T.Whitespace)}findPrevIntlWordBeforeOrAtOffset(I,D){let u=null;for(const P of this.h(I)){if(P.index>D)break;u=P}return u}findNextIntlWordAtOrAfterOffset(I,D){for(const u of this.h(I))if(!(u.index<D))return u;return null}h(I){return this.e?this.f===I?this.g:(this.f=I,this.g=this.j(this.e.segment(I)),this.g):[]}j(I){const D=[];for(const u of I)this.k(u)&&D.push(u);return D}k(I){return!!I.isWordLike}}e.$eu=L;const R=new h.$Cc(10);function b(c,I){const D=`${c}/${I.join(",")}`;let u=R.get(D);return u||(u=new L(c,I),R.set(D,u)),u}}),define(ke[140],Ie([1,0,39,3,80]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jt=e.$it=void 0,e.$kt=L,e.$lt=b,e.$mt=c,e.$it="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function T(D=""){let u="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.$it)D.indexOf(P)>=0||(u+="\\"+P);return u+="\\s]+)",new RegExp(u,"g")}e.$jt=T();function L(D){let u=e.$jt;if(D&&D instanceof RegExp)if(D.global)u=D;else{let P="g";D.ignoreCase&&(P+="i"),D.multiline&&(P+="m"),D.unicode&&(P+="u"),u=new RegExp(D.source,P)}return u.lastIndex=0,u}const R=new C.$4c;R.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function b(D){const u=R.unshift(D);return(0,h.$Rc)(u)}function c(D,u,P,w,a){if(u=L(u),a||(a=r.Iterable.first(R)),P.length>a.maxLen){let o=D-a.maxLen/2;return o<0?o=0:w+=o,P=P.substring(o,D+a.maxLen/2),c(D,u,P,w,a)}const $=Date.now(),f=D-1-w;let g=-1,i=null;for(let o=1;!(Date.now()-$>=a.timeBudget);o++){const t=f-a.windowSize*o;u.lastIndex=Math.max(0,t);const s=I(u,P,f,g);if(!s&&i||(i=s,t<=0))break;g=t}if(i){const o={word:i[0],startColumn:w+1+i.index,endColumn:w+1+i.index+i[0].length};return u.lastIndex=0,o}return null}function I(D,u,P,w){let a;for(;a=D.exec(u);){const $=a.index||0;if($<=P&&D.lastIndex>=P)return a;if(w>0&&$>w)return null}return null}}),define(ke[110],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qu=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var r;(function(b){b[b.Null=0]="Null",b[b.PlainText=1]="PlainText"})(r||(e.LanguageId=r={}));var h;(function(b){b[b.NotSet=-1]="NotSet",b[b.None=0]="None",b[b.Italic=1]="Italic",b[b.Bold=2]="Bold",b[b.Underline=4]="Underline",b[b.Strikethrough=8]="Strikethrough"})(h||(e.FontStyle=h={}));var C;(function(b){b[b.None=0]="None",b[b.DefaultForeground=1]="DefaultForeground",b[b.DefaultBackground=2]="DefaultBackground"})(C||(e.ColorId=C={}));var T;(function(b){b[b.Other=0]="Other",b[b.Comment=1]="Comment",b[b.String=2]="String",b[b.RegEx=3]="RegEx"})(T||(e.StandardTokenType=T={}));var L;(function(b){b[b.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",b[b.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",b[b.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",b[b.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",b[b.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",b[b.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",b[b.ITALIC_MASK=2048]="ITALIC_MASK",b[b.BOLD_MASK=4096]="BOLD_MASK",b[b.UNDERLINE_MASK=8192]="UNDERLINE_MASK",b[b.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",b[b.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",b[b.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",b[b.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",b[b.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",b[b.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",b[b.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",b[b.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",b[b.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",b[b.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",b[b.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",b[b.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",b[b.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(L||(e.MetadataConsts=L={}));class R{static getLanguageId(c){return(c&L.LANGUAGEID_MASK)>>>L.LANGUAGEID_OFFSET}static getTokenType(c){return(c&L.TOKEN_TYPE_MASK)>>>L.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(c){return(c&L.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(c){return(c&L.FONT_STYLE_MASK)>>>L.FONT_STYLE_OFFSET}static getForeground(c){return(c&L.FOREGROUND_MASK)>>>L.FOREGROUND_OFFSET}static getBackground(c){return(c&L.BACKGROUND_MASK)>>>L.BACKGROUND_OFFSET}static getClassNameFromMetadata(c){let D="mtk"+this.getForeground(c);const u=this.getFontStyle(c);return u&h.Italic&&(D+=" mtki"),u&h.Bold&&(D+=" mtkb"),u&h.Underline&&(D+=" mtku"),u&h.Strikethrough&&(D+=" mtks"),D}static getInlineStyleFromMetadata(c,I){const D=this.getForeground(c),u=this.getFontStyle(c);let P=`color: ${I[D]};`;u&h.Italic&&(P+="font-style: italic;"),u&h.Bold&&(P+="font-weight: bold;");let w="";return u&h.Underline&&(w+=" underline"),u&h.Strikethrough&&(w+=" line-through"),w&&(P+=`text-decoration:${w};`),P}static getPresentationFromMetadata(c){const I=this.getForeground(c),D=this.getFontStyle(c);return{foreground:I,italic:!!(D&h.Italic),bold:!!(D&h.Bold),underline:!!(D&h.Underline),strikethrough:!!(D&h.Strikethrough)}}}e.$qu=R}),define(ke[200],Ie([1,0,38,16]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ru=C,e.$su=T;function C(L,R,b,c,I,D){if(Array.isArray(L)){let u=0;for(const P of L){const w=C(P,R,b,c,I,D);if(w===10)return w;w>u&&(u=w)}return u}else{if(typeof L=="string")return c?L==="*"?5:L===b?10:0:0;if(L){const{language:u,pattern:P,scheme:w,hasAccessToAllModels:a,notebookType:$}=L;if(!c&&!a)return 0;$&&I&&(R=I);let f=0;if(w)if(w===R.scheme)f=10;else if(w==="*")f=5;else return 0;if(u)if(u===b)f=10;else if(u==="*")f=Math.max(f,5);else return 0;if($)if($===D)f=10;else if($==="*"&&D!==void 0)f=Math.max(f,5);else return 0;if(P){let g;if(typeof P=="string"?g=P:g={...P,base:(0,h.$gc)(P.base)},g===R.fsPath||(0,r.$vk)(g,R.fsPath))f=10;else return 0}return f}else return 0}}function T(L){return typeof L=="string"?!1:Array.isArray(L)?L.some(T):!!L.notebookType}}),define(ke[201],Ie([1,0,26,110]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Su=e.$Ru=e.IndentAction=void 0;var C;(function(b){b[b.None=0]="None",b[b.Indent=1]="Indent",b[b.IndentOutdent=2]="IndentOutdent",b[b.Outdent=3]="Outdent"})(C||(e.IndentAction=C={}));class T{constructor(c){if(this.e=null,this.f=!1,this.open=c.open,this.close=c.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(c.notIn))for(let I=0,D=c.notIn.length;I<D;I++)switch(c.notIn[I]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(c){switch(c){case h.StandardTokenType.Other:return!0;case h.StandardTokenType.Comment:return this.c;case h.StandardTokenType.String:return this.b;case h.StandardTokenType.RegEx:return this.d}}shouldAutoClose(c,I){if(c.getTokenCount()===0)return!0;const D=c.findTokenIndexAtOffset(I-2),u=c.getStandardTokenType(D);return this.isOK(u)}g(c,I){for(let D=c;D<=I;D++){const u=String.fromCharCode(D);if(!this.open.includes(u)&&!this.close.includes(u))return u}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(r.CharCode.Digit0,r.CharCode.Digit9)),this.e||(this.e=this.g(r.CharCode.a,r.CharCode.z)),this.e||(this.e=this.g(r.CharCode.A,r.CharCode.Z))),this.e}}e.$Ru=T;class L{constructor(c){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const I of c)R(this.autoClosingPairsOpenByStart,I.open.charAt(0),I),R(this.autoClosingPairsOpenByEnd,I.open.charAt(I.open.length-1),I),R(this.autoClosingPairsCloseByStart,I.close.charAt(0),I),R(this.autoClosingPairsCloseByEnd,I.close.charAt(I.close.length-1),I),I.close.length===1&&I.open.length===1&&R(this.autoClosingPairsCloseSingleChar,I.close,I)}}e.$Su=L;function R(b,c,I){b.has(c)?b.get(c).push(I):b.set(c,[I])}}),define(ke[202],Ie([1,0,26,139]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g4=e.$f4=e.State=void 0,e.$h4=P;var C;(function(w){w[w.Invalid=0]="Invalid",w[w.Start=1]="Start",w[w.H=2]="H",w[w.HT=3]="HT",w[w.HTT=4]="HTT",w[w.HTTP=5]="HTTP",w[w.F=6]="F",w[w.FI=7]="FI",w[w.FIL=8]="FIL",w[w.BeforeColon=9]="BeforeColon",w[w.AfterColon=10]="AfterColon",w[w.AlmostThere=11]="AlmostThere",w[w.End=12]="End",w[w.Accept=13]="Accept",w[w.LastKnownState=14]="LastKnownState"})(C||(e.State=C={}));class T{constructor(a,$,f){const g=new Uint8Array(a*$);for(let i=0,o=a*$;i<o;i++)g[i]=f;this.a=g,this.rows=a,this.cols=$}get(a,$){return this.a[a*this.cols+$]}set(a,$,f){this.a[a*this.cols+$]=f}}class L{constructor(a){let $=0,f=C.Invalid;for(let i=0,o=a.length;i<o;i++){const[t,s,n]=a[i];s>$&&($=s),t>f&&(f=t),n>f&&(f=n)}$++,f++;const g=new T(f,$,C.Invalid);for(let i=0,o=a.length;i<o;i++){const[t,s,n]=a[i];g.set(t,s,n)}this.a=g,this.b=$}nextState(a,$){return $<0||$>=this.b?C.Invalid:this.a.get(a,$)}}e.$f4=L;let R=null;function b(){return R===null&&(R=new L([[C.Start,r.CharCode.h,C.H],[C.Start,r.CharCode.H,C.H],[C.Start,r.CharCode.f,C.F],[C.Start,r.CharCode.F,C.F],[C.H,r.CharCode.t,C.HT],[C.H,r.CharCode.T,C.HT],[C.HT,r.CharCode.t,C.HTT],[C.HT,r.CharCode.T,C.HTT],[C.HTT,r.CharCode.p,C.HTTP],[C.HTT,r.CharCode.P,C.HTTP],[C.HTTP,r.CharCode.s,C.BeforeColon],[C.HTTP,r.CharCode.S,C.BeforeColon],[C.HTTP,r.CharCode.Colon,C.AfterColon],[C.F,r.CharCode.i,C.FI],[C.F,r.CharCode.I,C.FI],[C.FI,r.CharCode.l,C.FIL],[C.FI,r.CharCode.L,C.FIL],[C.FIL,r.CharCode.e,C.BeforeColon],[C.FIL,r.CharCode.E,C.BeforeColon],[C.BeforeColon,r.CharCode.Colon,C.AfterColon],[C.AfterColon,r.CharCode.Slash,C.AlmostThere],[C.AlmostThere,r.CharCode.Slash,C.End]])),R}var c;(function(w){w[w.None=0]="None",w[w.ForceTermination=1]="ForceTermination",w[w.CannotEndIn=2]="CannotEndIn"})(c||(c={}));let I=null;function D(){if(I===null){I=new h.$cu(c.None);const w=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let $=0;$<w.length;$++)I.set(w.charCodeAt($),c.ForceTermination);const a=".,;:";for(let $=0;$<a.length;$++)I.set(a.charCodeAt($),c.CannotEndIn)}return I}class u{static a(a,$,f,g,i){let o=i-1;do{const t=$.charCodeAt(o);if(a.get(t)!==c.CannotEndIn)break;o--}while(o>g);if(g>0){const t=$.charCodeAt(g-1),s=$.charCodeAt(o);(t===r.CharCode.OpenParen&&s===r.CharCode.CloseParen||t===r.CharCode.OpenSquareBracket&&s===r.CharCode.CloseSquareBracket||t===r.CharCode.OpenCurlyBrace&&s===r.CharCode.CloseCurlyBrace)&&o--}return{range:{startLineNumber:f,startColumn:g+1,endLineNumber:f,endColumn:o+2},url:$.substring(g,o+1)}}static computeLinks(a,$=b()){const f=D(),g=[];for(let i=1,o=a.getLineCount();i<=o;i++){const t=a.getLineContent(i),s=t.length;let n=0,d=0,l=0,m=C.Start,E=!1,S=!1,y=!1,k=!1;for(;n<s;){let A=!1;const p=t.charCodeAt(n);if(m===C.Accept){let v;switch(p){case r.CharCode.OpenParen:E=!0,v=c.None;break;case r.CharCode.CloseParen:v=E?c.None:c.ForceTermination;break;case r.CharCode.OpenSquareBracket:y=!0,S=!0,v=c.None;break;case r.CharCode.CloseSquareBracket:y=!1,v=S?c.None:c.ForceTermination;break;case r.CharCode.OpenCurlyBrace:k=!0,v=c.None;break;case r.CharCode.CloseCurlyBrace:v=k?c.None:c.ForceTermination;break;case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.BackTick:l===p?v=c.ForceTermination:l===r.CharCode.SingleQuote||l===r.CharCode.DoubleQuote||l===r.CharCode.BackTick?v=c.None:v=c.ForceTermination;break;case r.CharCode.Asterisk:v=l===r.CharCode.Asterisk?c.ForceTermination:c.None;break;case r.CharCode.Pipe:v=l===r.CharCode.Pipe?c.ForceTermination:c.None;break;case r.CharCode.Space:v=y?c.None:c.ForceTermination;break;default:v=f.get(p)}v===c.ForceTermination&&(g.push(u.a(f,t,i,d,n)),A=!0)}else if(m===C.End){let v;p===r.CharCode.OpenSquareBracket?(S=!0,v=c.None):v=f.get(p),v===c.ForceTermination?A=!0:m=C.Accept}else m=$.nextState(m,p),m===C.Invalid&&(A=!0);A&&(m=C.Start,E=!1,S=!1,k=!1,d=n+1,l=p),n++}m===C.Accept&&g.push(u.a(f,t,i,d,s))}return g}}e.$g4=u;function P(w){return!w||typeof w.getLineCount!="function"||typeof w.getLineContent!="function"?[]:u.computeLinks(w)}}),define(ke[58],Ie([1,0,24]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dw=e.$cw=e.$bw=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$_v=e.$$v=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$aw=w,e.$ew=o;var h;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(h||(e.OverviewRulerLane=h={}));var C;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=3]="Right"})(C||(e.GlyphMarginLane=C={}));var T;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(T||(e.MinimapPosition=T={}));var L;(function(t){t[t.Normal=1]="Normal",t[t.Underlined=2]="Underlined"})(L||(e.MinimapSectionHeaderStyle=L={}));var R;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(R||(e.InjectedTextCursorStops=R={}));var b;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(b||(e.EndOfLinePreference=b={}));var c;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(c||(e.DefaultEndOfLine=c={}));var I;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(I||(e.EndOfLineSequence=I={}));class D{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(s){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,s.tabSize|0),s.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,s.indentSize|0),this.a=!1),this.insertSpaces=!!s.insertSpaces,this.defaultEOL=s.defaultEOL|0,this.trimAutoWhitespace=!!s.trimAutoWhitespace,this.bracketPairColorizationOptions=s.bracketPairColorizationOptions}equals(s){return this.tabSize===s.tabSize&&this.a===s.a&&this.indentSize===s.indentSize&&this.insertSpaces===s.insertSpaces&&this.defaultEOL===s.defaultEOL&&this.trimAutoWhitespace===s.trimAutoWhitespace&&(0,r.$eo)(this.bracketPairColorizationOptions,s.bracketPairColorizationOptions)}createChangeEvent(s){return{tabSize:this.tabSize!==s.tabSize,indentSize:this.indentSize!==s.indentSize,insertSpaces:this.insertSpaces!==s.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==s.trimAutoWhitespace}}}e.$$v=D;class u{constructor(s,n){this._findMatchBrand=void 0,this.range=s,this.matches=n}}e.$_v=u;var P;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P||(e.TrackedRangeStickiness=P={}));function w(t){return t&&typeof t.read=="function"}var a;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(a||(e.PositionAffinity=a={}));var $;(function(t){t[t.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})($||(e.ModelConstants=$={}));class f{constructor(s,n,d,l,m,E){this.identifier=s,this.range=n,this.text=d,this.forceMoveMarkers=l,this.isAutoWhitespaceEdit=m,this._isTracked=E}}e.$bw=f;class g{constructor(s,n,d){this.regex=s,this.wordSeparators=n,this.simpleSearch=d}}e.$cw=g;class i{constructor(s,n,d){this.reverseEdits=s,this.changes=n,this.trimAutoWhitespaceLineNumbers=d}}e.$dw=i;function o(t){return!t.isTooLargeForSyncing()&&!t.isForSimpleWidget}}),define(ke[203],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2C=e.NodeColor=e.$1C=void 0,e.$3C=C,e.$4C=T,e.$5C=c,e.$6C=I,e.$7C=D,e.$8C=u,e.$9C=P,e.$0C=w;class r{constructor($,f){this.piece=$,this.color=f,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$2C)return C(this.right);let $=this;for(;$.parent!==e.$2C&&$.parent.left!==$;)$=$.parent;return $.parent===e.$2C?e.$2C:$.parent}prev(){if(this.left!==e.$2C)return T(this.left);let $=this;for(;$.parent!==e.$2C&&$.parent.right!==$;)$=$.parent;return $.parent===e.$2C?e.$2C:$.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$1C=r;var h;(function(a){a[a.Black=0]="Black",a[a.Red=1]="Red"})(h||(e.NodeColor=h={})),e.$2C=new r(null,h.Black),e.$2C.parent=e.$2C,e.$2C.left=e.$2C,e.$2C.right=e.$2C,e.$2C.color=h.Black;function C(a){for(;a.left!==e.$2C;)a=a.left;return a}function T(a){for(;a.right!==e.$2C;)a=a.right;return a}function L(a){return a===e.$2C?0:a.size_left+a.piece.length+L(a.right)}function R(a){return a===e.$2C?0:a.lf_left+a.piece.lineFeedCnt+R(a.right)}function b(){e.$2C.parent=e.$2C}function c(a,$){const f=$.right;f.size_left+=$.size_left+($.piece?$.piece.length:0),f.lf_left+=$.lf_left+($.piece?$.piece.lineFeedCnt:0),$.right=f.left,f.left!==e.$2C&&(f.left.parent=$),f.parent=$.parent,$.parent===e.$2C?a.root=f:$.parent.left===$?$.parent.left=f:$.parent.right=f,f.left=$,$.parent=f}function I(a,$){const f=$.left;$.left=f.right,f.right!==e.$2C&&(f.right.parent=$),f.parent=$.parent,$.size_left-=f.size_left+(f.piece?f.piece.length:0),$.lf_left-=f.lf_left+(f.piece?f.piece.lineFeedCnt:0),$.parent===e.$2C?a.root=f:$===$.parent.right?$.parent.right=f:$.parent.left=f,f.right=$,$.parent=f}function D(a,$){let f,g;if($.left===e.$2C?(g=$,f=g.right):$.right===e.$2C?(g=$,f=g.left):(g=C($.right),f=g.right),g===a.root){a.root=f,f.color=h.Black,$.detach(),b(),a.root.parent=e.$2C;return}const i=g.color===h.Red;if(g===g.parent.left?g.parent.left=f:g.parent.right=f,g===$?(f.parent=g.parent,w(a,f)):(g.parent===$?f.parent=g:f.parent=g.parent,w(a,f),g.left=$.left,g.right=$.right,g.parent=$.parent,g.color=$.color,$===a.root?a.root=g:$===$.parent.left?$.parent.left=g:$.parent.right=g,g.left!==e.$2C&&(g.left.parent=g),g.right!==e.$2C&&(g.right.parent=g),g.size_left=$.size_left,g.lf_left=$.lf_left,w(a,g)),$.detach(),f.parent.left===f){const t=L(f),s=R(f);if(t!==f.parent.size_left||s!==f.parent.lf_left){const n=t-f.parent.size_left,d=s-f.parent.lf_left;f.parent.size_left=t,f.parent.lf_left=s,P(a,f.parent,n,d)}}if(w(a,f.parent),i){b();return}let o;for(;f!==a.root&&f.color===h.Black;)f===f.parent.left?(o=f.parent.right,o.color===h.Red&&(o.color=h.Black,f.parent.color=h.Red,c(a,f.parent),o=f.parent.right),o.left.color===h.Black&&o.right.color===h.Black?(o.color=h.Red,f=f.parent):(o.right.color===h.Black&&(o.left.color=h.Black,o.color=h.Red,I(a,o),o=f.parent.right),o.color=f.parent.color,f.parent.color=h.Black,o.right.color=h.Black,c(a,f.parent),f=a.root)):(o=f.parent.left,o.color===h.Red&&(o.color=h.Black,f.parent.color=h.Red,I(a,f.parent),o=f.parent.left),o.left.color===h.Black&&o.right.color===h.Black?(o.color=h.Red,f=f.parent):(o.left.color===h.Black&&(o.right.color=h.Black,o.color=h.Red,c(a,o),o=f.parent.left),o.color=f.parent.color,f.parent.color=h.Black,o.left.color=h.Black,I(a,f.parent),f=a.root));f.color=h.Black,b()}function u(a,$){for(w(a,$);$!==a.root&&$.parent.color===h.Red;)if($.parent===$.parent.parent.left){const f=$.parent.parent.right;f.color===h.Red?($.parent.color=h.Black,f.color=h.Black,$.parent.parent.color=h.Red,$=$.parent.parent):($===$.parent.right&&($=$.parent,c(a,$)),$.parent.color=h.Black,$.parent.parent.color=h.Red,I(a,$.parent.parent))}else{const f=$.parent.parent.left;f.color===h.Red?($.parent.color=h.Black,f.color=h.Black,$.parent.parent.color=h.Red,$=$.parent.parent):($===$.parent.left&&($=$.parent,I(a,$)),$.parent.color=h.Black,$.parent.parent.color=h.Red,c(a,$.parent.parent))}a.root.color=h.Black}function P(a,$,f,g){for(;$!==a.root&&$!==e.$2C;)$.parent.left===$&&($.parent.size_left+=f,$.parent.lf_left+=g),$=$.parent}function w(a,$){let f=0,g=0;if($!==a.root){for(;$!==a.root&&$===$.parent.right;)$=$.parent;if($!==a.root)for($=$.parent,f=L($.left)-$.size_left,g=R($.left)-$.lf_left,$.size_left+=f,$.lf_left+=g;$!==a.root&&(f!==0||g!==0);)$.parent.left===$&&($.parent.size_left+=f,$.parent.lf_left+=g),$=$.parent}}}),define(ke[204],Ie([1,0,18,83]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jw=e.$iw=e.$hw=void 0;class C{constructor(b){this.a=b,this.b=new Uint32Array(b.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(b,c){b=(0,h.$_e)(b);const I=this.a,D=this.b,u=c.length;return u===0?!1:(this.a=new Uint32Array(I.length+u),this.a.set(I.subarray(0,b),0),this.a.set(I.subarray(b),b+u),this.a.set(c,b),b-1<this.c[0]&&(this.c[0]=b-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(D.subarray(0,this.c[0]+1)),!0)}setValue(b,c){return b=(0,h.$_e)(b),c=(0,h.$_e)(c),this.a[b]===c?!1:(this.a[b]=c,b-1<this.c[0]&&(this.c[0]=b-1),!0)}removeValues(b,c){b=(0,h.$_e)(b),c=(0,h.$_e)(c);const I=this.a,D=this.b;if(b>=I.length)return!1;const u=I.length-b;return c>=u&&(c=u),c===0?!1:(this.a=new Uint32Array(I.length-c),this.a.set(I.subarray(0,b),0),this.a.set(I.subarray(b+c),b),this.b=new Uint32Array(this.a.length),b-1<this.c[0]&&(this.c[0]=b-1),this.c[0]>=0&&this.b.set(D.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(b){return b<0?0:(b=(0,h.$_e)(b),this.d(b))}d(b){if(b<=this.c[0])return this.b[b];let c=this.c[0]+1;c===0&&(this.b[0]=this.a[0],c++),b>=this.a.length&&(b=this.a.length-1);for(let I=c;I<=b;I++)this.b[I]=this.b[I-1]+this.a[I];return this.c[0]=Math.max(this.c[0],b),this.b[b]}getIndexOf(b){b=Math.floor(b),this.getTotalSum();let c=0,I=this.a.length-1,D=0,u=0,P=0;for(;c<=I;)if(D=c+(I-c)/2|0,u=this.b[D],P=u-this.a[D],b<P)I=D-1;else if(b>=u)c=D+1;else break;return new L(D,b-P)}}e.$hw=C;class T{constructor(b){this.a=b,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(b){return this.g(),b===0?0:this.d[b-1]}getIndexOf(b){this.g();const c=this.e[b],I=c>0?this.d[c-1]:0;return new L(c,b-I)}removeValues(b,c){this.a.splice(b,c),this.f(b)}insertValues(b,c){this.a=(0,r.$Ub)(this.a,b,c),this.f(b)}f(b){this.b=!1,this.c=Math.min(this.c,b-1)}g(){if(!this.b){for(let b=this.c+1,c=this.a.length;b<c;b++){const I=this.a[b],D=b>0?this.d[b-1]:0;this.d[b]=D+I;for(let u=0;u<I;u++)this.e[D+u]=b}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(b,c){this.a[b]!==c&&(this.a[b]=c,this.f(b))}}e.$iw=T;class L{constructor(b,c){this.index=b,this.remainder=c,this._prefixSumIndexOfResultBrand=void 0,this.index=b,this.remainder=c}}e.$jw=L}),define(ke[205],Ie([1,0,12,57,204]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kw=void 0;class T{constructor(R,b,c,I){this.d=R,this.f=b,this.g=c,this.h=I,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(R){R.eol&&R.eol!==this.g&&(this.g=R.eol,this.j=null);const b=R.changes;for(const c of b)this.o(c.range),this.p(new h.$Jt(c.range.startLineNumber,c.range.startColumn),c.text);this.h=R.versionId,this.k=null}l(){if(!this.j){const R=this.g.length,b=this.f.length,c=new Uint32Array(b);for(let I=0;I<b;I++)c[I]=this.f[I].length+R;this.j=new C.$hw(c)}}n(R,b){this.f[R]=b,this.j&&this.j.setValue(R,this.f[R].length+this.g.length)}o(R){if(R.startLineNumber===R.endLineNumber){if(R.startColumn===R.endColumn)return;this.n(R.startLineNumber-1,this.f[R.startLineNumber-1].substring(0,R.startColumn-1)+this.f[R.startLineNumber-1].substring(R.endColumn-1));return}this.n(R.startLineNumber-1,this.f[R.startLineNumber-1].substring(0,R.startColumn-1)+this.f[R.endLineNumber-1].substring(R.endColumn-1)),this.f.splice(R.startLineNumber,R.endLineNumber-R.startLineNumber),this.j&&this.j.removeValues(R.startLineNumber,R.endLineNumber-R.startLineNumber)}p(R,b){if(b.length===0)return;const c=(0,r.$qf)(b);if(c.length===1){this.n(R.lineNumber-1,this.f[R.lineNumber-1].substring(0,R.column-1)+c[0]+this.f[R.lineNumber-1].substring(R.column-1));return}c[c.length-1]+=this.f[R.lineNumber-1].substring(R.column-1),this.n(R.lineNumber-1,this.f[R.lineNumber-1].substring(0,R.column-1)+c[0]);const I=new Uint32Array(c.length-1);for(let D=1;D<c.length;D++)this.f.splice(R.lineNumber+D-1,0,c[D]),I[D-1]=c[D].length+this.g.length;this.j&&this.j.insertValues(R.lineNumber,I)}}e.$kw=T}),define(ke[111],Ie([1,0,26,12,199,57,30,58]),function(me,e,r,h,C,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dD=e.$bD=e.$$C=void 0,e.$_C=I,e.$aD=D,e.$cD=$,h=Ue(h);const b=999;class c{constructor(i,o,t,s){this.searchString=i,this.isRegex=o,this.matchCase=t,this.wordSeparators=s}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=I(this.searchString):i=this.searchString.indexOf(`
`)>=0;let o=null;try{o=h.$of(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!o)return null;let t=!this.isRegex&&!i;return t&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(t=this.matchCase),new R.$cw(o,this.wordSeparators?(0,C.$fu)(this.wordSeparators,[]):null,t?this.searchString:null)}}e.$$C=c;function I(g){if(!g||g.length===0)return!1;for(let i=0,o=g.length;i<o;i++){const t=g.charCodeAt(i);if(t===r.CharCode.LineFeed)return!0;if(t===r.CharCode.Backslash){if(i++,i>=o)break;const s=g.charCodeAt(i);if(s===r.CharCode.n||s===r.CharCode.r||s===r.CharCode.W)return!0}}return!1}function D(g,i,o){if(!o)return new R.$_v(g,null);const t=[];for(let s=0,n=i.length;s<n;s++)t[s]=i[s];return new R.$_v(g,t)}class u{constructor(i){const o=[];let t=0;for(let s=0,n=i.length;s<n;s++)i.charCodeAt(s)===r.CharCode.LineFeed&&(o[t++]=s);this.a=o}findLineFeedCountBeforeOffset(i){const o=this.a;let t=0,s=o.length-1;if(s===-1||i<=o[0])return 0;for(;t<s;){const n=t+((s-t)/2>>0);o[n]>=i?s=n-1:o[n+1]>=i?(t=n,s=n):t=n+1}return t+1}}class P{static findMatches(i,o,t,s,n){const d=o.parseSearchRequest();return d?d.regex.multiline?this.b(i,t,new f(d.wordSeparators,d.regex),s,n):this.c(i,t,d,s,n):[]}static a(i,o,t,s,n,d){let l,m=0;s?(m=s.findLineFeedCountBeforeOffset(n),l=o+n+m):l=o+n;let E;if(s){const A=s.findLineFeedCountBeforeOffset(n+d.length)-m;E=l+d.length+A}else E=l+d.length;const S=i.getPositionAt(l),y=i.getPositionAt(E);return new L.$Kt(S.lineNumber,S.column,y.lineNumber,y.column)}static b(i,o,t,s,n){const d=i.getOffsetAt(o.getStartPosition()),l=i.getValueInRange(o,R.EndOfLinePreference.LF),m=i.getEOL()===`\r
`?new u(l):null,E=[];let S=0,y;for(t.reset(0);y=t.next(l);)if(E[S++]=D(this.a(i,d,l,m,y.index,y[0]),y,s),S>=n)return E;return E}static c(i,o,t,s,n){const d=[];let l=0;if(o.startLineNumber===o.endLineNumber){const E=i.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return l=this.d(t,E,o.startLineNumber,o.startColumn-1,l,d,s,n),d}const m=i.getLineContent(o.startLineNumber).substring(o.startColumn-1);l=this.d(t,m,o.startLineNumber,o.startColumn-1,l,d,s,n);for(let E=o.startLineNumber+1;E<o.endLineNumber&&l<n;E++)l=this.d(t,i.getLineContent(E),E,0,l,d,s,n);if(l<n){const E=i.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);l=this.d(t,E,o.endLineNumber,0,l,d,s,n)}return d}static d(i,o,t,s,n,d,l,m){const E=i.wordSeparators;if(!l&&i.simpleSearch){const k=i.simpleSearch,A=k.length,p=o.length;let v=-A;for(;(v=o.indexOf(k,v+A))!==-1;)if((!E||$(E,o,p,v,A))&&(d[n++]=new R.$_v(new L.$Kt(t,v+1+s,t,v+1+A+s),null),n>=m))return n;return n}const S=new f(i.wordSeparators,i.regex);let y;S.reset(0);do if(y=S.next(o),y&&(d[n++]=D(new L.$Kt(t,y.index+1+s,t,y.index+1+y[0].length+s),y,l),n>=m))return n;while(y);return n}static findNextMatch(i,o,t,s){const n=o.parseSearchRequest();if(!n)return null;const d=new f(n.wordSeparators,n.regex);return n.regex.multiline?this.e(i,t,d,s):this.f(i,t,d,s)}static e(i,o,t,s){const n=new T.$Jt(o.lineNumber,1),d=i.getOffsetAt(n),l=i.getLineCount(),m=i.getValueInRange(new L.$Kt(n.lineNumber,n.column,l,i.getLineMaxColumn(l)),R.EndOfLinePreference.LF),E=i.getEOL()===`\r
`?new u(m):null;t.reset(o.column-1);const S=t.next(m);return S?D(this.a(i,d,m,E,S.index,S[0]),S,s):o.lineNumber!==1||o.column!==1?this.e(i,new T.$Jt(1,1),t,s):null}static f(i,o,t,s){const n=i.getLineCount(),d=o.lineNumber,l=i.getLineContent(d),m=this.g(t,l,d,o.column,s);if(m)return m;for(let E=1;E<=n;E++){const S=(d+E-1)%n,y=i.getLineContent(S+1),k=this.g(t,y,S+1,1,s);if(k)return k}return null}static g(i,o,t,s,n){i.reset(s-1);const d=i.next(o);return d?D(new L.$Kt(t,d.index+1,t,d.index+1+d[0].length),d,n):null}static findPreviousMatch(i,o,t,s){const n=o.parseSearchRequest();if(!n)return null;const d=new f(n.wordSeparators,n.regex);return n.regex.multiline?this.h(i,t,d,s):this.j(i,t,d,s)}static h(i,o,t,s){const n=this.b(i,new L.$Kt(1,1,o.lineNumber,o.column),t,s,10*b);if(n.length>0)return n[n.length-1];const d=i.getLineCount();return o.lineNumber!==d||o.column!==i.getLineMaxColumn(d)?this.h(i,new T.$Jt(d,i.getLineMaxColumn(d)),t,s):null}static j(i,o,t,s){const n=i.getLineCount(),d=o.lineNumber,l=i.getLineContent(d).substring(0,o.column-1),m=this.k(t,l,d,s);if(m)return m;for(let E=1;E<=n;E++){const S=(n+d-E-1)%n,y=i.getLineContent(S+1),k=this.k(t,y,S+1,s);if(k)return k}return null}static k(i,o,t,s){let n=null,d;for(i.reset(0);d=i.next(o);)n=D(new L.$Kt(t,d.index+1,t,d.index+1+d[0].length),d,s);return n}}e.$bD=P;function w(g,i,o,t,s){if(t===0)return!0;const n=i.charCodeAt(t-1);if(g.get(n)!==C.WordCharacterClass.Regular||n===r.CharCode.CarriageReturn||n===r.CharCode.LineFeed)return!0;if(s>0){const d=i.charCodeAt(t);if(g.get(d)!==C.WordCharacterClass.Regular)return!0}return!1}function a(g,i,o,t,s){if(t+s===o)return!0;const n=i.charCodeAt(t+s);if(g.get(n)!==C.WordCharacterClass.Regular||n===r.CharCode.CarriageReturn||n===r.CharCode.LineFeed)return!0;if(s>0){const d=i.charCodeAt(t+s-1);if(g.get(d)!==C.WordCharacterClass.Regular)return!0}return!1}function $(g,i,o,t,s){return w(g,i,o,t,s)&&a(g,i,o,t,s)}class f{constructor(i,o){this._wordSeparators=i,this.a=o,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const o=i.length;let t;do{if(this.b+this.c===o||(t=this.a.exec(i),!t))return null;const s=t.index,n=t[0].length;if(s===this.b&&n===this.c){if(n===0){h.$Kf(i,o,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=s,this.c=n,!this._wordSeparators||$(this._wordSeparators,i,o,s,n))return t}while(t);return null}}e.$dD=f}),define(ke[141],Ie([1,0,26,57,30,58,203,111]),function(me,e,r,h,C,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iD=e.$hD=e.$gD=void 0,e.$eD=D,e.$fD=u;const b=65535;function c(g){let i;return g[g.length-1]<65536?i=new Uint16Array(g.length):i=new Uint32Array(g.length),i.set(g,0),i}class I{constructor(i,o,t,s,n){this.lineStarts=i,this.cr=o,this.lf=t,this.crlf=s,this.isBasicASCII=n}}function D(g,i=!0){const o=[0];let t=1;for(let s=0,n=g.length;s<n;s++){const d=g.charCodeAt(s);d===r.CharCode.CarriageReturn?s+1<n&&g.charCodeAt(s+1)===r.CharCode.LineFeed?(o[t++]=s+2,s++):o[t++]=s+1:d===r.CharCode.LineFeed&&(o[t++]=s+1)}return i?c(o):o}function u(g,i){g.length=0,g[0]=0;let o=1,t=0,s=0,n=0,d=!0;for(let m=0,E=i.length;m<E;m++){const S=i.charCodeAt(m);S===r.CharCode.CarriageReturn?m+1<E&&i.charCodeAt(m+1)===r.CharCode.LineFeed?(n++,g[o++]=m+2,m++):(t++,g[o++]=m+1):S===r.CharCode.LineFeed?(s++,g[o++]=m+1):d&&S!==r.CharCode.Tab&&(S<32||S>126)&&(d=!1)}const l=new I(c(g),t,s,n,d);return g.length=0,l}class P{constructor(i,o,t,s,n){this.bufferIndex=i,this.start=o,this.end=t,this.lineFeedCnt=s,this.length=n}}e.$gD=P;class w{constructor(i,o){this.buffer=i,this.lineStarts=o}}e.$hD=w;class a{constructor(i,o){this.a=[],this.c=i,this.d=o,this.b=0,i.root!==L.$2C&&i.iterate(i.root,t=>(t!==L.$2C&&this.a.push(t.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class ${constructor(i){this.a=i,this.b=[]}get(i){for(let o=this.b.length-1;o>=0;o--){const t=this.b[o];if(t.nodeStartOffset<=i&&t.nodeStartOffset+t.node.piece.length>=i)return t}return null}get2(i){for(let o=this.b.length-1;o>=0;o--){const t=this.b[o];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<i&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=i)return t}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let o=!1;const t=this.b;for(let s=0;s<t.length;s++){const n=t[s];if(n.node.parent===null||n.nodeStartOffset>=i){t[s]=null,o=!0;continue}}if(o){const s=[];for(const n of t)n!==null&&s.push(n);this.b=s}}}class f{constructor(i,o,t){this.create(i,o,t)}create(i,o,t){this.a=[new w("",[0])],this.g={line:0,column:0},this.root=L.$2C,this.b=1,this.c=0,this.d=o,this.e=o.length,this.f=t;let s=null;for(let n=0,d=i.length;n<d;n++)if(i[n].buffer.length>0){i[n].lineStarts||(i[n].lineStarts=D(i[n].buffer));const l=new P(n+1,{line:0,column:0},{line:i[n].lineStarts.length-1,column:i[n].buffer.length-i[n].lineStarts[i[n].lineStarts.length-1]},i[n].lineStarts.length-1,i[n].buffer.length);this.a.push(i[n]),s=this.S(s,l)}this.h=new $(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const o=b,t=o-Math.floor(o/3),s=t*2;let n="",d=0;const l=[];if(this.iterate(this.root,m=>{const E=this.R(m),S=E.length;if(d<=t||d+S<s)return n+=E,d+=S,!0;const y=n.replace(/\r\n|\r|\n/g,i);return l.push(new w(y,D(y))),n=E,d=S,!0}),d>0){const m=n.replace(/\r\n|\r|\n/g,i);l.push(new w(m,D(m)))}this.create(l,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new a(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let o=0;return this.iterate(this.root,s=>{if(s===L.$2C)return!0;const n=this.R(s),d=n.length,l=i.G(o),m=i.G(o+d),E=i.getValueInRange2(l,m);return o+=d,n===E})}getOffsetAt(i,o){let t=0,s=this.root;for(;s!==L.$2C;)if(s.left!==L.$2C&&s.lf_left+1>=i)s=s.left;else if(s.lf_left+s.piece.lineFeedCnt+1>=i){t+=s.size_left;const n=this.B(s,i-s.lf_left-2);return t+=n+o-1}else i-=s.lf_left+s.piece.lineFeedCnt,t+=s.size_left+s.piece.length,s=s.right;return t}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let o=this.root,t=0;const s=i;for(;o!==L.$2C;)if(o.size_left!==0&&o.size_left>=i)o=o.left;else if(o.size_left+o.piece.length>=i){const n=this.A(o,i-o.size_left);if(t+=o.lf_left+n.index,n.index===0){const d=this.getOffsetAt(t+1,1),l=s-d;return new h.$Jt(t+1,l+1)}return new h.$Jt(t+1,n.remainder+1)}else if(i-=o.size_left+o.piece.length,t+=o.lf_left+o.piece.lineFeedCnt,o.right===L.$2C){const n=this.getOffsetAt(t+1,1),d=s-i-n;return new h.$Jt(t+1,d+1)}else o=o.right;return new h.$Jt(1,1)}getValueInRange(i,o){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const t=this.H(i.startLineNumber,i.startColumn),s=this.H(i.endLineNumber,i.endColumn),n=this.getValueInRange2(t,s);return o?o!==this.d||!this.f?n.replace(/\r\n|\r|\n/g,o):o===this.getEOL()&&this.f?n:n.replace(/\r\n|\r|\n/g,o):n}getValueInRange2(i,o){if(i.node===o.node){const l=i.node,m=this.a[l.piece.bufferIndex].buffer,E=this.u(l.piece.bufferIndex,l.piece.start);return m.substring(E+i.remainder,E+o.remainder)}let t=i.node;const s=this.a[t.piece.bufferIndex].buffer,n=this.u(t.piece.bufferIndex,t.piece.start);let d=s.substring(n+i.remainder,n+t.piece.length);for(t=t.next();t!==L.$2C;){const l=this.a[t.piece.bufferIndex].buffer,m=this.u(t.piece.bufferIndex,t.piece.start);if(t===o.node){d+=l.substring(m,m+o.remainder);break}else d+=l.substr(m,t.piece.length);t=t.next()}return d}getLinesContent(){const i=[];let o=0,t="",s=!1;return this.iterate(this.root,n=>{if(n===L.$2C)return!0;const d=n.piece;let l=d.length;if(l===0)return!0;const m=this.a[d.bufferIndex].buffer,E=this.a[d.bufferIndex].lineStarts,S=d.start.line,y=d.end.line;let k=E[S]+d.start.column;if(s&&(m.charCodeAt(k)===r.CharCode.LineFeed&&(k++,l--),i[o++]=t,t="",s=!1,l===0))return!0;if(S===y)return!this.f&&m.charCodeAt(k+l-1)===r.CharCode.CarriageReturn?(s=!0,t+=m.substr(k,l-1)):t+=m.substr(k,l),!0;t+=this.f?m.substring(k,Math.max(k,E[S+1]-this.e)):m.substring(k,E[S+1]).replace(/(\r\n|\r|\n)$/,""),i[o++]=t;for(let A=S+1;A<y;A++)t=this.f?m.substring(E[A],E[A+1]-this.e):m.substring(E[A],E[A+1]).replace(/(\r\n|\r|\n)$/,""),i[o++]=t;return!this.f&&m.charCodeAt(E[y]+d.end.column-1)===r.CharCode.CarriageReturn?(s=!0,d.end.column===0?o--:t=m.substr(E[y],d.end.column-1)):t=m.substr(E[y],d.end.column),!0}),s&&(i[o++]=t,t=""),i[o++]=t,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const o=i.node.next();if(!o)return 0;const t=this.a[o.piece.bufferIndex],s=this.u(o.piece.bufferIndex,o.piece.start);return t.buffer.charCodeAt(s)}else{const o=this.a[i.node.piece.bufferIndex],s=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return o.buffer.charCodeAt(s)}}getLineCharCode(i,o){const t=this.H(i,o+1);return this.l(t)}getLineLength(i){if(i===this.getLineCount()){const o=this.getOffsetAt(i,1);return this.getLength()-o}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const o=this.G(i);return this.l(o)}getNearestChunk(i){const o=this.G(i);if(o.remainder===o.node.piece.length){const t=o.node.next();if(!t||t===L.$2C)return"";const s=this.a[t.piece.bufferIndex],n=this.u(t.piece.bufferIndex,t.piece.start);return s.buffer.substring(n,n+t.piece.length)}else{const t=this.a[o.node.piece.bufferIndex],s=this.u(o.node.piece.bufferIndex,o.node.piece.start),n=s+o.remainder,d=s+o.node.piece.length;return t.buffer.substring(n,d)}}findMatchesInNode(i,o,t,s,n,d,l,m,E,S,y){const k=this.a[i.piece.bufferIndex],A=this.u(i.piece.bufferIndex,i.piece.start),p=this.u(i.piece.bufferIndex,n),v=this.u(i.piece.bufferIndex,d);let F;const N={line:0,column:0};let O,j;o._wordSeparators?(O=k.buffer.substring(p,v),j=z=>z+p,o.reset(0)):(O=k.buffer,j=z=>z,o.reset(p));do if(F=o.next(O),F){if(j(F.index)>=v)return S;this.s(i,j(F.index)-A,N);const z=this.t(i.piece.bufferIndex,n,N),M=N.line===n.line?N.column-n.column+s:N.column+1,V=M+F[0].length;if(y[S++]=(0,R.$aD)(new C.$Kt(t+z,M,t+z,V),F,m),j(F.index)+F[0].length>=v||S>=E)return S}while(F);return S}findMatchesLineByLine(i,o,t,s){const n=[];let d=0;const l=new R.$dD(o.wordSeparators,o.regex);let m=this.H(i.startLineNumber,i.startColumn);if(m===null)return[];const E=this.H(i.endLineNumber,i.endColumn);if(E===null)return[];let S=this.s(m.node,m.remainder);const y=this.s(E.node,E.remainder);if(m.node===E.node)return this.findMatchesInNode(m.node,l,i.startLineNumber,i.startColumn,S,y,o,t,s,d,n),n;let k=i.startLineNumber,A=m.node;for(;A!==E.node;){const v=this.t(A.piece.bufferIndex,S,A.piece.end);if(v>=1){const N=this.a[A.piece.bufferIndex].lineStarts,O=this.u(A.piece.bufferIndex,A.piece.start),j=N[S.line+v],z=k===i.startLineNumber?i.startColumn:1;if(d=this.findMatchesInNode(A,l,k,z,S,this.s(A,j-O),o,t,s,d,n),d>=s)return n;k+=v}const F=k===i.startLineNumber?i.startColumn-1:0;if(k===i.endLineNumber){const N=this.getLineContent(k).substring(F,i.endColumn-1);return d=this.n(o,l,N,i.endLineNumber,F,d,n,t,s),n}if(d=this.n(o,l,this.getLineContent(k).substr(F),k,F,d,n,t,s),d>=s)return n;k++,m=this.H(k,1),A=m.node,S=this.s(m.node,m.remainder)}if(k===i.endLineNumber){const v=k===i.startLineNumber?i.startColumn-1:0,F=this.getLineContent(k).substring(v,i.endColumn-1);return d=this.n(o,l,F,i.endLineNumber,v,d,n,t,s),n}const p=k===i.startLineNumber?i.startColumn:1;return d=this.findMatchesInNode(E.node,l,k,p,S,y,o,t,s,d,n),n}n(i,o,t,s,n,d,l,m,E){const S=i.wordSeparators;if(!m&&i.simpleSearch){const k=i.simpleSearch,A=k.length,p=t.length;let v=-A;for(;(v=t.indexOf(k,v+A))!==-1;)if((!S||(0,R.$cD)(S,t,p,v,A))&&(l[d++]=new T.$_v(new C.$Kt(s,v+1+n,s,v+1+A+n),null),d>=E))return d;return d}let y;o.reset(0);do if(y=o.next(t),y&&(l[d++]=(0,R.$aD)(new C.$Kt(s,y.index+1+n,s,y.index+1+y[0].length+n),y,m),d>=E))return d;while(y);return d}insert(i,o,t=!1){if(this.f=this.f&&t,this.j.lineNumber=0,this.j.value="",this.root!==L.$2C){const{node:s,remainder:n,nodeStartOffset:d}=this.G(i),l=s.piece,m=l.bufferIndex,E=this.s(s,n);if(s.piece.bufferIndex===0&&l.end.line===this.g.line&&l.end.column===this.g.column&&d+l.length===i&&o.length<b){this.F(s,o),this.y();return}if(d===i)this.o(o,s),this.h.validate(i);else if(d+s.piece.length>i){const S=[];let y=new P(l.bufferIndex,E,l.end,this.t(l.bufferIndex,E,l.end),this.u(m,l.end)-this.u(m,E));if(this.K()&&this.M(o)&&this.I(s,n)===10){const v={line:y.start.line+1,column:0};y=new P(y.bufferIndex,v,y.end,this.t(y.bufferIndex,v,y.end),y.length-1),o+=`
`}if(this.K()&&this.L(o))if(this.I(s,n-1)===13){const v=this.s(s,n-1);this.C(s,v),o="\r"+o,s.piece.length===0&&S.push(s)}else this.C(s,E);else this.C(s,E);const k=this.w(o);y.length>0&&this.S(s,y);let A=s;for(let p=0;p<k.length;p++)A=this.S(A,k[p]);this.v(S)}else this.q(o,s)}else{const s=this.w(o);let n=this.T(null,s[0]);for(let d=1;d<s.length;d++)n=this.S(n,s[d])}this.y()}delete(i,o){if(this.j.lineNumber=0,this.j.value="",o<=0||this.root===L.$2C)return;const t=this.G(i),s=this.G(i+o),n=t.node,d=s.node;if(n===d){const k=this.s(n,t.remainder),A=this.s(n,s.remainder);if(t.nodeStartOffset===i){if(o===n.piece.length){const p=n.next();(0,L.$7C)(this,n),this.N(p),this.y();return}this.D(n,A),this.h.validate(i),this.N(n),this.y();return}if(t.nodeStartOffset+n.piece.length===i+o){this.C(n,k),this.O(n),this.y();return}this.E(n,k,A),this.y();return}const l=[],m=this.s(n,t.remainder);this.C(n,m),this.h.validate(i),n.piece.length===0&&l.push(n);const E=this.s(d,s.remainder);this.D(d,E),d.piece.length===0&&l.push(d);const S=n.next();for(let k=S;k!==L.$2C&&k!==d;k=k.next())l.push(k);const y=n.piece.length===0?n.prev():n;this.v(l),this.O(y),this.y()}o(i,o){const t=[];if(this.K()&&this.M(i)&&this.L(o)){const d=o.piece,l={line:d.start.line+1,column:0},m=new P(d.bufferIndex,l,d.end,this.t(d.bufferIndex,l,d.end),d.length-1);o.piece=m,i+=`
`,(0,L.$9C)(this,o,-1,-1),o.piece.length===0&&t.push(o)}const s=this.w(i);let n=this.T(o,s[s.length-1]);for(let d=s.length-2;d>=0;d--)n=this.T(n,s[d]);this.N(n),this.v(t)}q(i,o){this.Q(i,o)&&(i+=`
`);const t=this.w(i),s=this.S(o,t[0]);let n=s;for(let d=1;d<t.length;d++)n=this.S(n,t[d]);this.N(s)}s(i,o,t){const s=i.piece,n=i.piece.bufferIndex,d=this.a[n].lineStarts,m=d[s.start.line]+s.start.column+o;let E=s.start.line,S=s.end.line,y=0,k=0,A=0;for(;E<=S&&(y=E+(S-E)/2|0,A=d[y],y!==S);)if(k=d[y+1],m<A)S=y-1;else if(m>=k)E=y+1;else break;return t?(t.line=y,t.column=m-A,null):{line:y,column:m-A}}t(i,o,t){if(t.column===0)return t.line-o.line;const s=this.a[i].lineStarts;if(t.line===s.length-1)return t.line-o.line;const n=s[t.line+1],d=s[t.line]+t.column;if(n>d+1)return t.line-o.line;const l=d-1;return this.a[i].buffer.charCodeAt(l)===13?t.line-o.line+1:t.line-o.line}u(i,o){return this.a[i].lineStarts[o.line]+o.column}v(i){for(let o=0;o<i.length;o++)(0,L.$7C)(this,i[o])}w(i){if(i.length>b){const S=[];for(;i.length>b;){const k=i.charCodeAt(b-1);let A;k===r.CharCode.CarriageReturn||k>=55296&&k<=56319?(A=i.substring(0,b-1),i=i.substring(b-1)):(A=i.substring(0,b),i=i.substring(b));const p=D(A);S.push(new P(this.a.length,{line:0,column:0},{line:p.length-1,column:A.length-p[p.length-1]},p.length-1,A.length)),this.a.push(new w(A,p))}const y=D(i);return S.push(new P(this.a.length,{line:0,column:0},{line:y.length-1,column:i.length-y[y.length-1]},y.length-1,i.length)),this.a.push(new w(i,y)),S}let o=this.a[0].buffer.length;const t=D(i,!1);let s=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===o&&o!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},s=this.g;for(let S=0;S<t.length;S++)t[S]+=o+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+="_"+i,o+=1}else{if(o!==0)for(let S=0;S<t.length;S++)t[S]+=o;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+=i}const n=this.a[0].buffer.length,d=this.a[0].lineStarts.length-1,l=n-this.a[0].lineStarts[d],m={line:d,column:l},E=new P(0,s,m,this.t(0,s,m),n-o);return this.g=m,[E]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,o=0){let t=this.root,s="";const n=this.h.get2(i);if(n){t=n.node;const d=this.B(t,i-n.nodeStartLineNumber-1),l=this.a[t.piece.bufferIndex].buffer,m=this.u(t.piece.bufferIndex,t.piece.start);if(n.nodeStartLineNumber+t.piece.lineFeedCnt===i)s=l.substring(m+d,m+t.piece.length);else{const E=this.B(t,i-n.nodeStartLineNumber);return l.substring(m+d,m+E-o)}}else{let d=0;const l=i;for(;t!==L.$2C;)if(t.left!==L.$2C&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const m=this.B(t,i-t.lf_left-2),E=this.B(t,i-t.lf_left-1),S=this.a[t.piece.bufferIndex].buffer,y=this.u(t.piece.bufferIndex,t.piece.start);return d+=t.size_left,this.h.set({node:t,nodeStartOffset:d,nodeStartLineNumber:l-(i-1-t.lf_left)}),S.substring(y+m,y+E-o)}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const m=this.B(t,i-t.lf_left-2),E=this.a[t.piece.bufferIndex].buffer,S=this.u(t.piece.bufferIndex,t.piece.start);s=E.substring(S+m,S+t.piece.length);break}else i-=t.lf_left+t.piece.lineFeedCnt,d+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==L.$2C;){const d=this.a[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const l=this.B(t,0),m=this.u(t.piece.bufferIndex,t.piece.start);return s+=d.substring(m,m+l-o),s}else{const l=this.u(t.piece.bufferIndex,t.piece.start);s+=d.substr(l,t.piece.length)}t=t.next()}return s}y(){let i=this.root,o=1,t=0;for(;i!==L.$2C;)o+=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;this.b=o,this.c=t,this.h.validate(this.c)}A(i,o){const t=i.piece,s=this.s(i,o),n=s.line-t.start.line;if(this.u(t.bufferIndex,t.end)-this.u(t.bufferIndex,t.start)===o){const d=this.t(i.piece.bufferIndex,t.start,s);if(d!==n)return{index:d,remainder:0}}return{index:n,remainder:s.column}}B(i,o){if(o<0)return 0;const t=i.piece,s=this.a[t.bufferIndex].lineStarts,n=t.start.line+o+1;return n>t.end.line?s[t.end.line]+t.end.column-s[t.start.line]-t.start.column:s[n]-s[t.start.line]-t.start.column}C(i,o){const t=i.piece,s=t.lineFeedCnt,n=this.u(t.bufferIndex,t.end),d=o,l=this.u(t.bufferIndex,d),m=this.t(t.bufferIndex,t.start,d),E=m-s,S=l-n,y=t.length+S;i.piece=new P(t.bufferIndex,t.start,d,m,y),(0,L.$9C)(this,i,S,E)}D(i,o){const t=i.piece,s=t.lineFeedCnt,n=this.u(t.bufferIndex,t.start),d=o,l=this.t(t.bufferIndex,d,t.end),m=this.u(t.bufferIndex,d),E=l-s,S=n-m,y=t.length+S;i.piece=new P(t.bufferIndex,d,t.end,l,y),(0,L.$9C)(this,i,S,E)}E(i,o,t){const s=i.piece,n=s.start,d=s.end,l=s.length,m=s.lineFeedCnt,E=o,S=this.t(s.bufferIndex,s.start,E),y=this.u(s.bufferIndex,o)-this.u(s.bufferIndex,n);i.piece=new P(s.bufferIndex,s.start,E,S,y),(0,L.$9C)(this,i,y-l,S-m);const k=new P(s.bufferIndex,t,d,this.t(s.bufferIndex,t,d),this.u(s.bufferIndex,d)-this.u(s.bufferIndex,t)),A=this.S(i,k);this.N(A)}F(i,o){this.Q(o,i)&&(o+=`
`);const t=this.K()&&this.L(o)&&this.M(i),s=this.a[0].buffer.length;this.a[0].buffer+=o;const n=D(o,!1);for(let A=0;A<n.length;A++)n[A]+=s;if(t){const A=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:s-A}}this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1));const d=this.a[0].lineStarts.length-1,l=this.a[0].buffer.length-this.a[0].lineStarts[d],m={line:d,column:l},E=i.piece.length+o.length,S=i.piece.lineFeedCnt,y=this.t(0,i.piece.start,m),k=y-S;i.piece=new P(i.piece.bufferIndex,i.piece.start,m,y,E),this.g=m,(0,L.$9C)(this,i,o.length,k)}G(i){let o=this.root;const t=this.h.get(i);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:i-t.nodeStartOffset};let s=0;for(;o!==L.$2C;)if(o.size_left>i)o=o.left;else if(o.size_left+o.piece.length>=i){s+=o.size_left;const n={node:o,remainder:i-o.size_left,nodeStartOffset:s};return this.h.set(n),n}else i-=o.size_left+o.piece.length,s+=o.size_left+o.piece.length,o=o.right;return null}H(i,o){let t=this.root,s=0;for(;t!==L.$2C;)if(t.left!==L.$2C&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const n=this.B(t,i-t.lf_left-2),d=this.B(t,i-t.lf_left-1);return s+=t.size_left,{node:t,remainder:Math.min(n+o-1,d),nodeStartOffset:s}}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const n=this.B(t,i-t.lf_left-2);if(n+o-1<=t.piece.length)return{node:t,remainder:n+o-1,nodeStartOffset:s};o-=t.piece.length-n;break}else i-=t.lf_left+t.piece.lineFeedCnt,s+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==L.$2C;){if(t.piece.lineFeedCnt>0){const n=this.B(t,0),d=this.J(t);return{node:t,remainder:Math.min(o-1,n),nodeStartOffset:d}}else if(t.piece.length>=o-1){const n=this.J(t);return{node:t,remainder:o-1,nodeStartOffset:n}}else o-=t.piece.length;t=t.next()}return null}I(i,o){if(i.piece.lineFeedCnt<1)return-1;const t=this.a[i.piece.bufferIndex],s=this.u(i.piece.bufferIndex,i.piece.start)+o;return t.buffer.charCodeAt(s)}J(i){if(!i)return 0;let o=i.size_left;for(;i!==this.root;)i.parent.right===i&&(o+=i.parent.size_left+i.parent.piece.length),i=i.parent;return o}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===L.$2C||i.piece.lineFeedCnt===0)return!1;const o=i.piece,t=this.a[o.bufferIndex].lineStarts,s=o.start.line,n=t[s]+o.start.column;return s===t.length-1||t[s+1]>n+1?!1:this.a[o.bufferIndex].buffer.charCodeAt(n)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===L.$2C||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const o=i.prev();this.M(o)&&this.P(o,i)}}O(i){if(this.K()&&this.M(i)){const o=i.next();this.L(o)&&this.P(i,o)}}P(i,o){const t=[],s=this.a[i.piece.bufferIndex].lineStarts;let n;i.piece.end.column===0?n={line:i.piece.end.line-1,column:s[i.piece.end.line]-s[i.piece.end.line-1]-1}:n={line:i.piece.end.line,column:i.piece.end.column-1};const d=i.piece.length-1,l=i.piece.lineFeedCnt-1;i.piece=new P(i.piece.bufferIndex,i.piece.start,n,l,d),(0,L.$9C)(this,i,-1,-1),i.piece.length===0&&t.push(i);const m={line:o.piece.start.line+1,column:0},E=o.piece.length-1,S=this.t(o.piece.bufferIndex,m,o.piece.end);o.piece=new P(o.piece.bufferIndex,m,o.piece.end,S,E),(0,L.$9C)(this,o,-1,-1),o.piece.length===0&&t.push(o);const y=this.w(`\r
`);this.S(i,y[0]);for(let k=0;k<t.length;k++)(0,L.$7C)(this,t[k])}Q(i,o){if(this.K()&&this.M(i)){const t=o.next();if(this.L(t)){if(i+=`
`,t.piece.length===1)(0,L.$7C)(this,t);else{const s=t.piece,n={line:s.start.line+1,column:0},d=s.length-1,l=this.t(s.bufferIndex,n,s.end);t.piece=new P(s.bufferIndex,n,s.end,l,d),(0,L.$9C)(this,t,-1,-1)}return!0}}return!1}iterate(i,o){if(i===L.$2C)return o(L.$2C);const t=this.iterate(i.left,o);return t&&o(i)&&this.iterate(i.right,o)}R(i){if(i===L.$2C)return"";const o=this.a[i.piece.bufferIndex],t=i.piece,s=this.u(t.bufferIndex,t.start),n=this.u(t.bufferIndex,t.end);return o.buffer.substring(s,n)}getPieceContent(i){const o=this.a[i.bufferIndex],t=this.u(i.bufferIndex,i.start),s=this.u(i.bufferIndex,i.end);return o.buffer.substring(t,s)}S(i,o){const t=new L.$1C(o,L.NodeColor.Red);if(t.left=L.$2C,t.right=L.$2C,t.parent=L.$2C,t.size_left=0,t.lf_left=0,this.root===L.$2C)this.root=t,t.color=L.NodeColor.Black;else if(i.right===L.$2C)i.right=t,t.parent=i;else{const n=(0,L.$3C)(i.right);n.left=t,t.parent=n}return(0,L.$8C)(this,t),t}T(i,o){const t=new L.$1C(o,L.NodeColor.Red);if(t.left=L.$2C,t.right=L.$2C,t.parent=L.$2C,t.size_left=0,t.lf_left=0,this.root===L.$2C)this.root=t,t.color=L.NodeColor.Black;else if(i.left===L.$2C)i.left=t,t.parent=i;else{const s=(0,L.$4C)(i.left);s.right=t,t.parent=s}return(0,L.$8C)(this,t),t}U(i){let o="";return this.iterate(i,t=>(o+=this.R(t),!0)),o}}e.$iD=f}),define(ke[206],Ie([1,0,4,12,30,58,141,193,197,3]),function(me,e,r,h,C,T,L,R,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jD=void 0,h=Ue(h);class I extends c.$Tc{constructor(u,P,w,a,$,f,g){super(),this.m=this.B(new r.$je),this.onDidChangeContent=this.m.event,this.f=P,this.j=!f,this.g=a,this.h=$,this.c=new L.$iD(u,w,g)}equals(u){return!(u instanceof I)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,P){return this.c.getOffsetAt(u,P)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,P){const w=u+P,a=this.getPositionAt(u),$=this.getPositionAt(w);return new C.$Kt(a.lineNumber,a.column,$.lineNumber,$.column)}getValueInRange(u,P=T.EndOfLinePreference.TextDefined){if(u.isEmpty())return"";const w=this.n(P);return this.c.getValueInRange(u,w)}getValueLengthInRange(u,P=T.EndOfLinePreference.TextDefined){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const w=this.getOffsetAt(u.startLineNumber,u.startColumn),a=this.getOffsetAt(u.endLineNumber,u.endColumn);let $=0;const f=this.n(P),g=this.getEOL();if(f.length!==g.length){const i=f.length-g.length,o=u.endLineNumber-u.startLineNumber;$=i*o}return a-w+$}getCharacterCountInRange(u,P=T.EndOfLinePreference.TextDefined){if(this.j){let w=0;const a=u.startLineNumber,$=u.endLineNumber;for(let f=a;f<=$;f++){const g=this.getLineContent(f),i=f===a?u.startColumn-1:0,o=f===$?u.endColumn-1:g.length;for(let t=i;t<o;t++)h.$Hf(g.charCodeAt(t))?(w=w+1,t=t+1):w=w+1}return w+=this.n(P).length*($-a),w}return this.getValueLengthInRange(u,P)}getNearestChunk(u){return this.c.getNearestChunk(u)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,P){return this.c.getLineCharCode(u,P)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const P=h.$sf(this.getLineContent(u));return P===-1?0:P+1}getLineLastNonWhitespaceColumn(u){const P=h.$uf(this.getLineContent(u));return P===-1?0:P+2}n(u){switch(u){case T.EndOfLinePreference.LF:return`
`;case T.EndOfLinePreference.CRLF:return`\r
`;case T.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,P,w){let a=this.g,$=this.h,f=this.j,g=!0,i=[];for(let m=0;m<u.length;m++){const E=u[m];g&&E._isTracked&&(g=!1);const S=E.range;if(E.text){let v=!0;f||(v=!h.$Sf(E.text),f=v),!a&&v&&(a=h.$Rf(E.text)),!$&&v&&($=h.$Uf(E.text))}let y="",k=0,A=0,p=0;if(E.text){let v;[k,A,p,v]=(0,R.$uu)(E.text);const F=this.getEOL(),N=F===`\r
`?R.StringEOL.CRLF:R.StringEOL.LF;v===R.StringEOL.Unknown||v===N?y=E.text:y=E.text.replace(/\r\n|\r|\n/g,F)}i[m]={sortIndex:m,identifier:E.identifier||null,range:S,rangeOffset:this.getOffsetAt(S.startLineNumber,S.startColumn),rangeLength:this.getValueLengthInRange(S),text:y,eolCount:k,firstLineLength:A,lastLineLength:p,forceMoveMarkers:!!E.forceMoveMarkers,isAutoWhitespaceEdit:E.isAutoWhitespaceEdit||!1}}i.sort(I.u);let o=!1;for(let m=0,E=i.length-1;m<E;m++){const S=i[m].range.getEndPosition(),y=i[m+1].range.getStartPosition();if(y.isBeforeOrEqual(S)){if(y.isBefore(S))throw new Error("Overlapping ranges are not allowed!");o=!0}}g&&(i=this.s(i));const t=w||P?I._getInverseEditRanges(i):[],s=[];if(P)for(let m=0;m<i.length;m++){const E=i[m],S=t[m];if(E.isAutoWhitespaceEdit&&E.range.isEmpty())for(let y=S.startLineNumber;y<=S.endLineNumber;y++){let k="";y===S.startLineNumber&&(k=this.getLineContent(E.range.startLineNumber),h.$sf(k)!==-1)||s.push({lineNumber:y,oldContent:k})}}let n=null;if(w){let m=0;n=[];for(let E=0;E<i.length;E++){const S=i[E],y=t[E],k=this.getValueInRange(S.range),A=S.rangeOffset+m;m+=S.text.length-k.length,n[E]={sortIndex:S.sortIndex,identifier:S.identifier,range:y,text:k,textChange:new b.$au(S.rangeOffset,k,A,S.text)}}o||n.sort((E,S)=>E.sortIndex-S.sortIndex)}this.g=a,this.h=$,this.j=f;const d=this.t(i);let l=null;if(P&&s.length>0){s.sort((m,E)=>E.lineNumber-m.lineNumber),l=[];for(let m=0,E=s.length;m<E;m++){const S=s[m].lineNumber;if(m>0&&s[m-1].lineNumber===S)continue;const y=s[m].oldContent,k=this.getLineContent(S);k.length===0||k===y||h.$sf(k)!==-1||l.push(S)}}return this.m.fire(),new T.$dw(n,d,l)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let P=!1;const w=u[0].range,a=u[u.length-1].range,$=new C.$Kt(w.startLineNumber,w.startColumn,a.endLineNumber,a.endColumn);let f=w.startLineNumber,g=w.startColumn;const i=[];for(let d=0,l=u.length;d<l;d++){const m=u[d],E=m.range;P=P||m.forceMoveMarkers,i.push(this.getValueInRange(new C.$Kt(f,g,E.startLineNumber,E.startColumn))),m.text.length>0&&i.push(m.text),f=E.endLineNumber,g=E.endColumn}const o=i.join(""),[t,s,n]=(0,R.$uu)(o);return{sortIndex:0,identifier:u[0].identifier,range:$,rangeOffset:this.getOffsetAt($.startLineNumber,$.startColumn),rangeLength:this.getValueLengthInRange($,T.EndOfLinePreference.TextDefined),text:o,eolCount:t,firstLineLength:s,lastLineLength:n,forceMoveMarkers:P,isAutoWhitespaceEdit:!1}}t(u){u.sort(I.w);const P=[];for(let w=0;w<u.length;w++){const a=u[w],$=a.range.startLineNumber,f=a.range.startColumn,g=a.range.endLineNumber,i=a.range.endColumn;if($===g&&f===i&&a.text.length===0)continue;a.text?(this.c.delete(a.rangeOffset,a.rangeLength),this.c.insert(a.rangeOffset,a.text,!0)):this.c.delete(a.rangeOffset,a.rangeLength);const o=new C.$Kt($,f,g,i);P.push({range:o,rangeLength:a.rangeLength,text:a.text,rangeOffset:a.rangeOffset,forceMoveMarkers:a.forceMoveMarkers})}return P}findMatchesLineByLine(u,P,w,a){return this.c.findMatchesLineByLine(u,P,w,a)}getPieceTree(){return this.c}static _getInverseEditRange(u,P){const w=u.startLineNumber,a=u.startColumn,[$,f,g]=(0,R.$uu)(P);let i;if(P.length>0){const o=$+1;o===1?i=new C.$Kt(w,a,w,a+f):i=new C.$Kt(w,a,w+o-1,g+1)}else i=new C.$Kt(w,a,w,a);return i}static _getInverseEditRanges(u){const P=[];let w=0,a=0,$=null;for(let f=0,g=u.length;f<g;f++){const i=u[f];let o,t;$?$.range.endLineNumber===i.range.startLineNumber?(o=w,t=a+(i.range.startColumn-$.range.endColumn)):(o=w+(i.range.startLineNumber-$.range.endLineNumber),t=i.range.startColumn):(o=i.range.startLineNumber,t=i.range.startColumn);let s;if(i.text.length>0){const n=i.eolCount+1;n===1?s=new C.$Kt(o,t,o,t+i.firstLineLength):s=new C.$Kt(o,t,o+n-1,i.lastLineLength+1)}else s=new C.$Kt(o,t,o,t);w=s.endLineNumber,a=s.endColumn,P.push(s),$=i}return P}static u(u,P){const w=C.$Kt.compareRangesUsingEnds(u.range,P.range);return w===0?u.sortIndex-P.sortIndex:w}static w(u,P){const w=C.$Kt.compareRangesUsingEnds(u.range,P.range);return w===0?P.sortIndex-u.sortIndex:-w}}e.$jD=I}),define(ke[207],Ie([1,0,26,12,58,141,206]),function(me,e,r,h,C,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kD=void 0,h=Ue(h);class R{constructor(I,D,u,P,w,a,$,f,g){this.a=I,this.b=D,this.c=u,this.d=P,this.e=w,this.f=a,this.g=$,this.h=f,this.j=g}k(I){const D=this.c+this.d+this.e,u=this.c+this.e;return D===0?I===C.DefaultEndOfLine.LF?`
`:`\r
`:u>D/2?`\r
`:`
`}create(I){const D=this.k(I),u=this.a;if(this.j&&(D===`\r
`&&(this.c>0||this.d>0)||D===`
`&&(this.c>0||this.e>0)))for(let w=0,a=u.length;w<a;w++){const $=u[w].buffer.replace(/\r\n|\r|\n/g,D),f=(0,T.$eD)($);u[w]=new T.$hD($,f)}const P=new L.$jD(u,this.b,D,this.f,this.g,this.h,this.j);return{textBuffer:P,disposable:P}}getFirstLineText(I){return this.a[0].buffer.substr(0,I).split(/\r\n|\r|\n/)[0]}}class b{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(I){if(I.length===0)return;this.a.length===0&&h.$3f(I)&&(this.b=h.$2f,I=I.substr(1));const D=I.charCodeAt(I.length-1);D===r.CharCode.CarriageReturn||D>=55296&&D<=56319?(this.m(I.substr(0,I.length-1),!1),this.c=!0,this.d=D):(this.m(I,!1),this.c=!1,this.d=D)}m(I,D){!D&&I.length===0||(this.c?this.n(String.fromCharCode(this.d)+I):this.n(I))}n(I){const D=(0,T.$fD)(this.e,I);this.a.push(new T.$hD(I,D.lineStarts)),this.f+=D.cr,this.g+=D.lf,this.h+=D.crlf,D.isBasicASCII||(this.l=!1,this.j||(this.j=h.$Rf(I)),this.k||(this.k=h.$Uf(I)))}finish(I=!0){return this.o(),new R(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,I)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const I=this.a[this.a.length-1];I.buffer+=String.fromCharCode(this.d);const D=(0,T.$eD)(I.buffer);I.lineStarts=D,this.d===r.CharCode.CarriageReturn&&this.f++}}}e.$kD=b}),define(ke[142],Ie([1,0,21,10]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydb=b,e.$zdb=I,h=Ue(h);var C;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(C||(C={}));function T(D){for(let u=0,P=D.length;u<P;u+=4){const w=D[u+0],a=D[u+1],$=D[u+2],f=D[u+3];D[u+0]=f,D[u+1]=$,D[u+2]=a,D[u+3]=w}}function L(D){const u=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return h.$E()||T(u),r.$Le.wrap(u)}function R(D){const u=D.buffer;if(h.$E()||T(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const P=new Uint8Array(u.byteLength);return P.set(u),new Uint32Array(P.buffer,P.byteOffset,P.length/4)}}function b(D){const u=new Uint32Array(c(D));let P=0;if(u[P++]=D.id,D.type==="full")u[P++]=C.Full,u[P++]=D.data.length,u.set(D.data,P),P+=D.data.length;else{u[P++]=C.Delta,u[P++]=D.deltas.length;for(const w of D.deltas)u[P++]=w.start,u[P++]=w.deleteCount,w.data?(u[P++]=w.data.length,u.set(w.data,P),P+=w.data.length):u[P++]=0}return L(u)}function c(D){let u=0;if(u+=2,D.type==="full")u+=1+D.data.length;else{u+=1,u+=3*D.deltas.length;for(const P of D.deltas)P.data&&(u+=P.data.length)}return u}function I(D){const u=R(D);let P=0;const w=u[P++];if(u[P++]===C.Full){const g=u[P++],i=u.subarray(P,P+g);return P+=g,{id:w,type:"full",data:i}}const $=u[P++],f=[];for(let g=0;g<$;g++){const i=u[P++],o=u[P++],t=u[P++];let s;t>0&&(s=u.subarray(P,P+t),P+=t),f[g]={start:i,deleteCount:o,data:s}}return{id:w,type:"delta",deltas:f}}}),define(ke[208],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n_=e.$m_=void 0;class r{constructor(){this.a=new Map}removeDragOperationTransfer(T){if(T&&this.a.has(T)){const L=this.a.get(T);return this.a.delete(T),L}}addDragOperationTransfer(T,L){this.a.set(T,L)}}e.$m_=r;class h{constructor(T){this.identifier=T}}e.$n_=h}),define(ke[209],Ie([1,0,4,3,110]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tu=void 0;class T{constructor(){this.a=new Map,this.b=new Map,this.c=new r.$je,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,c){return this.a.set(b,c),this.handleChange([b]),(0,h.$Rc)(()=>{this.a.get(b)===c&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,c){this.b.get(b)?.dispose();const I=new L(this,b,c);return this.b.set(b,I),(0,h.$Rc)(()=>{const D=this.b.get(b);!D||D!==I||(this.b.delete(b),D.dispose())})}async getOrCreate(b){const c=this.get(b);if(c)return c;const I=this.b.get(b);return!I||I.isResolved?null:(await I.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const I=this.b.get(b);return!!(!I||I.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>C.ColorId.DefaultBackground?this.d[C.ColorId.DefaultBackground]:null}}e.$tu=T;class L extends h.$Tc{get isResolved(){return this.c}constructor(b,c,I){super(),this.f=b,this.g=c,this.h=I,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(ke[8],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=C,e.localize2=L;const r=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function h(R,b){let c;return b.length===0?c=R:c=R.replace(/\{(\d+)\}/g,(I,D)=>{const u=D[0],P=b[u];let w=I;return typeof P=="string"?w=P:(typeof P=="number"||typeof P=="boolean"||P===void 0||P===null)&&(w=String(P)),w}),r&&(c="\uFF3B"+c.replace(/[aouei]/g,"$&$&")+"\uFF3D"),c}function C(R,b,...c){return h(typeof R=="number"?T(R,b):b,c)}function T(R,b){const c=globalThis._VSCODE_NLS_MESSAGES?.[R];if(typeof c!="string"){if(typeof b=="string")return b;throw new Error(`!!! NLS MISSING: ${R} !!!`)}return c}function L(R,b,...c){let I;typeof R=="number"?I=T(R,b):I=b;const D=h(I,c);return{value:D,original:b===I?D:h(b,c)}}}),define(ke[210],Ie([1,0,4,3,8]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=void 0,e.$mj=I,C=Ue(C);class T extends h.$Tc{constructor(u,P="",w="",a=!0,$){super(),this.j=this.B(new r.$je),this.onDidChange=this.j.event,this.z=!0,this.m=u,this.n=P,this.w=w,this.z=a,this.D=$}get id(){return this.m}get label(){return this.n}set label(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.j.fire({label:u}))}get tooltip(){return this.u||""}set tooltip(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.j.fire({tooltip:u}))}get class(){return this.w}set class(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.j.fire({class:u}))}get enabled(){return this.z}set enabled(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.j.fire({enabled:u}))}get checked(){return this.C}set checked(u){this.J(u)}J(u){this.C!==u&&(this.C=u,this.j.fire({checked:u}))}async run(u,P){this.D&&await this.D(u)}}e.$hj=T;class L extends h.$Tc{constructor(){super(...arguments),this.f=this.B(new r.$je),this.onWillRun=this.f.event,this.m=this.B(new r.$je),this.onDidRun=this.m.event}async run(u,P){if(!u.enabled)return;this.f.fire({action:u});let w;try{await this.u(u,P)}catch(a){w=a}this.m.fire({action:u,error:w})}async u(u,P){await u.run(P)}}e.$ij=L;class R{constructor(){this.id=R.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let P=[];for(const w of u)w.length&&(P.length?P=[...P,new R,...w]:P=w);return P}static{this.ID="vs.actions.separator"}async run(){}}e.$jj=R;class b{get actions(){return this.a}constructor(u,P,w,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=P,this.class=a,this.a=w}async run(){}}e.$kj=b;class c extends T{static{this.ID="vs.actions.empty"}constructor(){super(c.ID,C.localize(12880,null),void 0,!1)}}e.$lj=c;function I(D){return{id:D.id,label:D.label,tooltip:D.tooltip??D.label,class:D.class,enabled:D.enabled??!0,checked:D.checked,run:async(...u)=>D.run(...u)}}}),define(ke[211],Ie([1,0,8]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=c,e.$Ym=I,e.$Zm=D;const h=60,C=h*60,T=C*24,L=T*7,R=T*30,b=T*365;function c(u,P,w,a){typeof u!="number"&&(u=u.getTime());const $=Math.round((new Date().getTime()-u)/1e3);if($<-30)return(0,r.localize)(12817,null,c(new Date().getTime()+$*1e3,!1));if(!a&&$<30)return(0,r.localize)(12818,null);let f;return $<h?(f=$,P?f===1?w?(0,r.localize)(12819,null,f):(0,r.localize)(12820,null,f):w?(0,r.localize)(12821,null,f):(0,r.localize)(12822,null,f):f===1?w?(0,r.localize)(12823,null,f):(0,r.localize)(12824,null,f):w?(0,r.localize)(12825,null,f):(0,r.localize)(12826,null,f)):$<C?(f=Math.floor($/h),P?f===1?w?(0,r.localize)(12827,null,f):(0,r.localize)(12828,null,f):w?(0,r.localize)(12829,null,f):(0,r.localize)(12830,null,f):f===1?w?(0,r.localize)(12831,null,f):(0,r.localize)(12832,null,f):w?(0,r.localize)(12833,null,f):(0,r.localize)(12834,null,f)):$<T?(f=Math.floor($/C),P?f===1?w?(0,r.localize)(12835,null,f):(0,r.localize)(12836,null,f):w?(0,r.localize)(12837,null,f):(0,r.localize)(12838,null,f):f===1?w?(0,r.localize)(12839,null,f):(0,r.localize)(12840,null,f):w?(0,r.localize)(12841,null,f):(0,r.localize)(12842,null,f)):$<L?(f=Math.floor($/T),P?f===1?(0,r.localize)(12843,null,f):(0,r.localize)(12844,null,f):f===1?(0,r.localize)(12845,null,f):(0,r.localize)(12846,null,f)):$<R?(f=Math.floor($/L),P?f===1?w?(0,r.localize)(12847,null,f):(0,r.localize)(12848,null,f):w?(0,r.localize)(12849,null,f):(0,r.localize)(12850,null,f):f===1?w?(0,r.localize)(12851,null,f):(0,r.localize)(12852,null,f):w?(0,r.localize)(12853,null,f):(0,r.localize)(12854,null,f)):$<b?(f=Math.floor($/R),P?f===1?w?(0,r.localize)(12855,null,f):(0,r.localize)(12856,null,f):w?(0,r.localize)(12857,null,f):(0,r.localize)(12858,null,f):f===1?w?(0,r.localize)(12859,null,f):(0,r.localize)(12860,null,f):w?(0,r.localize)(12861,null,f):(0,r.localize)(12862,null,f)):(f=Math.floor($/b),P?f===1?w?(0,r.localize)(12863,null,f):(0,r.localize)(12864,null,f):w?(0,r.localize)(12865,null,f):(0,r.localize)(12866,null,f):f===1?w?(0,r.localize)(12867,null,f):(0,r.localize)(12868,null,f):w?(0,r.localize)(12869,null,f):(0,r.localize)(12870,null,f))}function I(u,P){const w=Math.abs(u/1e3);return w<1?P?(0,r.localize)(12871,null,u):(0,r.localize)(12872,null,u):w<h?P?(0,r.localize)(12873,null,Math.round(u)/1e3):(0,r.localize)(12874,null,Math.round(u)/1e3):w<C?P?(0,r.localize)(12875,null,Math.round(u/(1e3*h))):(0,r.localize)(12876,null,Math.round(u/(1e3*h))):w<T?P?(0,r.localize)(12877,null,Math.round(u/(1e3*C))):(0,r.localize)(12878,null,Math.round(u/(1e3*C))):(0,r.localize)(12879,null,Math.round(u/(1e3*T)))}function D(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ke[52],Ie([1,0,18,17,8]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=b,e.$oj=c,e.$pj=I,r=Ue(r),h=Ue(h),C=Ue(C);function T(D,u){return u&&(D.stack||D.stacktrace)?C.localize(12811,null,R(D),L(D.stack)||L(D.stacktrace)):R(D)}function L(D){return Array.isArray(D)?D.join(`
`):D}function R(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?C.localize(12812,null,D.message):D.message||C.localize(12813,null)}function b(D=null,u=!1){if(!D)return C.localize(12814,null);if(Array.isArray(D)){const P=r.$Gb(D),w=b(P[0],u);return P.length>1?C.localize(12815,null,w,P.length):w}if(h.$cg(D))return D;if(D.detail){const P=D.detail;if(P.error)return T(P.error,u);if(P.exception)return T(P.exception,u)}return D.stack?T(D,u):D.message?D.message:C.localize(12816,null)}function c(D){const u=D;return u instanceof Error&&Array.isArray(u.actions)}function I(D,u){let P;return typeof D=="string"?P=new Error(D):P=D,P.actions=u,P}}),define(ke[87],Ie([1,0,82,2,194,30,209,8]),function(me,e,r,h,C,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$Mu=e.$Lu=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$Ku=e.$Ju=e.SymbolKinds=e.SymbolTag=e.$Hu=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$Fu=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$Eu=e.$Du=e.$Cu=void 0,e.$Gu=d,e.$Iu=m;class b{constructor(G,Y,ee){this.offset=G,this.type=Y,this.language=ee,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Cu=b;class c{constructor(G,Y){this.tokens=G,this.endState=Y,this._tokenizationResultBrand=void 0}}e.$Du=c;class I{constructor(G,Y){this.tokens=G,this.endState=Y,this._encodedTokenizationResultBrand=void 0}}e.$Eu=I;var D;(function(B){B[B.Increase=0]="Increase",B[B.Decrease=1]="Decrease"})(D||(e.HoverVerbosityAction=D={}));var u;(function(B){B[B.Method=0]="Method",B[B.Function=1]="Function",B[B.Constructor=2]="Constructor",B[B.Field=3]="Field",B[B.Variable=4]="Variable",B[B.Class=5]="Class",B[B.Struct=6]="Struct",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Event=10]="Event",B[B.Operator=11]="Operator",B[B.Unit=12]="Unit",B[B.Value=13]="Value",B[B.Constant=14]="Constant",B[B.Enum=15]="Enum",B[B.EnumMember=16]="EnumMember",B[B.Keyword=17]="Keyword",B[B.Text=18]="Text",B[B.Color=19]="Color",B[B.File=20]="File",B[B.Reference=21]="Reference",B[B.Customcolor=22]="Customcolor",B[B.Folder=23]="Folder",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue",B[B.Snippet=27]="Snippet"})(u||(e.CompletionItemKind=u={}));var P;(function(B){const G=new Map;G.set(u.Method,r.$2j.symbolMethod),G.set(u.Function,r.$2j.symbolFunction),G.set(u.Constructor,r.$2j.symbolConstructor),G.set(u.Field,r.$2j.symbolField),G.set(u.Variable,r.$2j.symbolVariable),G.set(u.Class,r.$2j.symbolClass),G.set(u.Struct,r.$2j.symbolStruct),G.set(u.Interface,r.$2j.symbolInterface),G.set(u.Module,r.$2j.symbolModule),G.set(u.Property,r.$2j.symbolProperty),G.set(u.Event,r.$2j.symbolEvent),G.set(u.Operator,r.$2j.symbolOperator),G.set(u.Unit,r.$2j.symbolUnit),G.set(u.Value,r.$2j.symbolValue),G.set(u.Enum,r.$2j.symbolEnum),G.set(u.Constant,r.$2j.symbolConstant),G.set(u.Enum,r.$2j.symbolEnum),G.set(u.EnumMember,r.$2j.symbolEnumMember),G.set(u.Keyword,r.$2j.symbolKeyword),G.set(u.Snippet,r.$2j.symbolSnippet),G.set(u.Text,r.$2j.symbolText),G.set(u.Color,r.$2j.symbolColor),G.set(u.File,r.$2j.symbolFile),G.set(u.Reference,r.$2j.symbolReference),G.set(u.Customcolor,r.$2j.symbolCustomColor),G.set(u.Folder,r.$2j.symbolFolder),G.set(u.TypeParameter,r.$2j.symbolTypeParameter),G.set(u.User,r.$2j.account),G.set(u.Issue,r.$2j.issues);function Y(re){let ye=G.get(re);return ye||(console.info("No codicon found for CompletionItemKind "+re),ye=r.$2j.symbolProperty),ye}B.toIcon=Y;const ee=new Map;ee.set("method",u.Method),ee.set("function",u.Function),ee.set("constructor",u.Constructor),ee.set("field",u.Field),ee.set("variable",u.Variable),ee.set("class",u.Class),ee.set("struct",u.Struct),ee.set("interface",u.Interface),ee.set("module",u.Module),ee.set("property",u.Property),ee.set("event",u.Event),ee.set("operator",u.Operator),ee.set("unit",u.Unit),ee.set("value",u.Value),ee.set("constant",u.Constant),ee.set("enum",u.Enum),ee.set("enum-member",u.EnumMember),ee.set("enumMember",u.EnumMember),ee.set("keyword",u.Keyword),ee.set("snippet",u.Snippet),ee.set("text",u.Text),ee.set("color",u.Color),ee.set("file",u.File),ee.set("reference",u.Reference),ee.set("customcolor",u.Customcolor),ee.set("folder",u.Folder),ee.set("type-parameter",u.TypeParameter),ee.set("typeParameter",u.TypeParameter),ee.set("account",u.User),ee.set("issue",u.Issue);function ue(re,ye){let $e=ee.get(re);return typeof $e>"u"&&!ye&&($e=u.Property),$e}B.fromString=ue})(P||(e.CompletionItemKinds=P={}));var w;(function(B){B[B.Deprecated=1]="Deprecated"})(w||(e.CompletionItemTag=w={}));var a;(function(B){B[B.None=0]="None",B[B.KeepWhitespace=1]="KeepWhitespace",B[B.InsertAsSnippet=4]="InsertAsSnippet"})(a||(e.CompletionItemInsertTextRule=a={}));var $;(function(B){B[B.Word=0]="Word",B[B.Line=1]="Line",B[B.Suggest=2]="Suggest"})($||(e.PartialAcceptTriggerKind=$={}));var f;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(f||(e.CompletionTriggerKind=f={}));var g;(function(B){B[B.Automatic=0]="Automatic",B[B.Explicit=1]="Explicit"})(g||(e.InlineCompletionTriggerKind=g={}));class i{constructor(G,Y,ee,ue){this.range=G,this.text=Y,this.completionKind=ee,this.isSnippetText=ue}equals(G){return T.$Kt.lift(this.range).equalsRange(G.range)&&this.text===G.text&&this.completionKind===G.completionKind&&this.isSnippetText===G.isSnippetText}}e.$Fu=i;var o;(function(B){B[B.Invoke=1]="Invoke",B[B.Auto=2]="Auto"})(o||(e.CodeActionTriggerType=o={}));var t;(function(B){B[B.Automatic=0]="Automatic",B[B.PasteAs=1]="PasteAs"})(t||(e.DocumentPasteTriggerKind=t={}));var s;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(s||(e.SignatureHelpTriggerKind=s={}));var n;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(n||(e.DocumentHighlightKind=n={}));function d(B){return B&&h.URI.isUri(B.uri)&&T.$Kt.isIRange(B.range)&&(T.$Kt.isIRange(B.originSelectionRange)||T.$Kt.isIRange(B.targetSelectionRange))}var l;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(l||(e.SymbolKind=l={})),e.$Hu={[l.Array]:(0,R.localize)(12678,null),[l.Boolean]:(0,R.localize)(12679,null),[l.Class]:(0,R.localize)(12680,null),[l.Constant]:(0,R.localize)(12681,null),[l.Constructor]:(0,R.localize)(12682,null),[l.Enum]:(0,R.localize)(12683,null),[l.EnumMember]:(0,R.localize)(12684,null),[l.Event]:(0,R.localize)(12685,null),[l.Field]:(0,R.localize)(12686,null),[l.File]:(0,R.localize)(12687,null),[l.Function]:(0,R.localize)(12688,null),[l.Interface]:(0,R.localize)(12689,null),[l.Key]:(0,R.localize)(12690,null),[l.Method]:(0,R.localize)(12691,null),[l.Module]:(0,R.localize)(12692,null),[l.Namespace]:(0,R.localize)(12693,null),[l.Null]:(0,R.localize)(12694,null),[l.Number]:(0,R.localize)(12695,null),[l.Object]:(0,R.localize)(12696,null),[l.Operator]:(0,R.localize)(12697,null),[l.Package]:(0,R.localize)(12698,null),[l.Property]:(0,R.localize)(12699,null),[l.String]:(0,R.localize)(12700,null),[l.Struct]:(0,R.localize)(12701,null),[l.TypeParameter]:(0,R.localize)(12702,null),[l.Variable]:(0,R.localize)(12703,null)};function m(B,G){return(0,R.localize)(12704,null,B,e.$Hu[G])}var E;(function(B){B[B.Deprecated=1]="Deprecated"})(E||(e.SymbolTag=E={}));var S;(function(B){const G=new Map;G.set(l.File,r.$2j.symbolFile),G.set(l.Module,r.$2j.symbolModule),G.set(l.Namespace,r.$2j.symbolNamespace),G.set(l.Package,r.$2j.symbolPackage),G.set(l.Class,r.$2j.symbolClass),G.set(l.Method,r.$2j.symbolMethod),G.set(l.Property,r.$2j.symbolProperty),G.set(l.Field,r.$2j.symbolField),G.set(l.Constructor,r.$2j.symbolConstructor),G.set(l.Enum,r.$2j.symbolEnum),G.set(l.Interface,r.$2j.symbolInterface),G.set(l.Function,r.$2j.symbolFunction),G.set(l.Variable,r.$2j.symbolVariable),G.set(l.Constant,r.$2j.symbolConstant),G.set(l.String,r.$2j.symbolString),G.set(l.Number,r.$2j.symbolNumber),G.set(l.Boolean,r.$2j.symbolBoolean),G.set(l.Array,r.$2j.symbolArray),G.set(l.Object,r.$2j.symbolObject),G.set(l.Key,r.$2j.symbolKey),G.set(l.Null,r.$2j.symbolNull),G.set(l.EnumMember,r.$2j.symbolEnumMember),G.set(l.Struct,r.$2j.symbolStruct),G.set(l.Event,r.$2j.symbolEvent),G.set(l.Operator,r.$2j.symbolOperator),G.set(l.TypeParameter,r.$2j.symbolTypeParameter);function Y(ee){let ue=G.get(ee);return ue||(console.info("No codicon found for SymbolKind "+ee),ue=r.$2j.symbolProperty),ue}B.toIcon=Y})(S||(e.SymbolKinds=S={}));class y{static asEditOperation(G){return C.$Lt.replace(T.$Kt.lift(G.range),G.text)}}e.$Ju=y;class k{static{this.Comment=new k("comment")}static{this.Imports=new k("imports")}static{this.Region=new k("region")}static fromValue(G){switch(G){case"comment":return k.Comment;case"imports":return k.Imports;case"region":return k.Region}return new k(G)}constructor(G){this.value=G}}e.$Ku=k;var A;(function(B){B[B.AIGenerated=1]="AIGenerated"})(A||(e.NewSymbolNameTag=A={}));var p;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(p||(e.NewSymbolNameTriggerKind=p={}));var v;(function(B){function G(Y){return!Y||typeof Y!="object"?!1:typeof Y.id=="string"&&typeof Y.title=="string"}B.is=G})(v||(e.Command=v={}));var F;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(F||(e.CommentThreadCollapsibleState=F={}));var N;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(N||(e.CommentThreadState=N={}));var O;(function(B){B[B.Current=0]="Current",B[B.Outdated=1]="Outdated"})(O||(e.CommentThreadApplicability=O={}));var j;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(j||(e.CommentMode=j={}));var z;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(z||(e.CommentState=z={}));var M;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(M||(e.InlayHintKind=M={}));class V{constructor(G){this.b=G,this.a=null}dispose(){this.a&&this.a.then(G=>{G&&G.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Lu=V,e.$Mu=new L.$tu;var K;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(K||(e.ExternalUriOpenerPriority=K={}));var ne;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(ne||(e.InlineEditTriggerKind=ne={}))}),define(ke[212],Ie([1,0,26,13,8]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.TokenType=void 0;var T;(function(I){I[I.LParen=0]="LParen",I[I.RParen=1]="RParen",I[I.Neg=2]="Neg",I[I.Eq=3]="Eq",I[I.NotEq=4]="NotEq",I[I.Lt=5]="Lt",I[I.LtEq=6]="LtEq",I[I.Gt=7]="Gt",I[I.GtEq=8]="GtEq",I[I.RegexOp=9]="RegexOp",I[I.RegexStr=10]="RegexStr",I[I.True=11]="True",I[I.False=12]="False",I[I.In=13]="In",I[I.Not=14]="Not",I[I.And=15]="And",I[I.Or=16]="Or",I[I.Str=17]="Str",I[I.QuotedStr=18]="QuotedStr",I[I.Error=19]="Error",I[I.EOF=20]="EOF"})(T||(e.TokenType=T={}));function L(...I){switch(I.length){case 1:return(0,C.localize)(11418,null,I[0]);case 2:return(0,C.localize)(11419,null,I[0],I[1]);case 3:return(0,C.localize)(11420,null,I[0],I[1],I[2]);default:return}}const R=(0,C.localize)(11421,null),b=(0,C.localize)(11422,null);class c{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(D){switch(D.type){case T.LParen:return"(";case T.RParen:return")";case T.Neg:return"!";case T.Eq:return D.isTripleEq?"===":"==";case T.NotEq:return D.isTripleEq?"!==":"!=";case T.Lt:return"<";case T.LtEq:return"<=";case T.Gt:return">=";case T.GtEq:return">=";case T.RegexOp:return"=~";case T.RegexStr:return D.lexeme;case T.True:return"true";case T.False:return"false";case T.In:return"in";case T.Not:return"not";case T.And:return"&&";case T.Or:return"||";case T.Str:return D.lexeme;case T.QuotedStr:return D.lexeme;case T.Error:return D.lexeme;case T.EOF:return"EOF";default:throw(0,h.$7)(`unhandled token type: ${JSON.stringify(D)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(D=>D.charCodeAt(0)))}static{this.b=new Map([["not",T.Not],["in",T.In],["false",T.False],["true",T.True]])}get errors(){return this.g}reset(D){return this.c=D,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case r.CharCode.OpenParen:this.k(T.LParen);break;case r.CharCode.CloseParen:this.k(T.RParen);break;case r.CharCode.ExclamationMark:if(this.h(r.CharCode.Equals)){const u=this.h(r.CharCode.Equals);this.f.push({type:T.NotEq,offset:this.d,isTripleEq:u})}else this.k(T.Neg);break;case r.CharCode.SingleQuote:this.o();break;case r.CharCode.Slash:this.q();break;case r.CharCode.Equals:if(this.h(r.CharCode.Equals)){const u=this.h(r.CharCode.Equals);this.f.push({type:T.Eq,offset:this.d,isTripleEq:u})}else this.h(r.CharCode.Tilde)?this.k(T.RegexOp):this.l(L("==","=~"));break;case r.CharCode.LessThan:this.k(this.h(r.CharCode.Equals)?T.LtEq:T.Lt);break;case r.CharCode.GreaterThan:this.k(this.h(r.CharCode.Equals)?T.GtEq:T.Gt);break;case r.CharCode.Ampersand:this.h(r.CharCode.Ampersand)?this.k(T.And):this.l(L("&&"));break;case r.CharCode.Pipe:this.h(r.CharCode.Pipe)?this.k(T.Or):this.l(L("||"));break;case r.CharCode.Space:case r.CharCode.CarriageReturn:case r.CharCode.Tab:case r.CharCode.LineFeed:case r.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(T.EOF),Array.from(this.f)}h(D){return this.r()||this.c.charCodeAt(this.e)!==D?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?r.CharCode.Null:this.c.charCodeAt(this.e)}k(D){this.f.push({type:D,offset:this.d})}l(D){const u=this.d,P=this.c.substring(this.d,this.e),w={type:T.Error,offset:this.d,lexeme:P};this.g.push({offset:u,lexeme:P,additionalInfo:D}),this.f.push(w)}n(){this.m.lastIndex=this.d;const D=this.m.exec(this.c);if(D){this.e=this.d+D[0].length;const u=this.c.substring(this.d,this.e),P=c.b.get(u);P?this.k(P):this.f.push({type:T.Str,lexeme:u,offset:this.d})}}o(){for(;this.j()!==r.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:T.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let D=this.e,u=!1,P=!1;for(;;){if(D>=this.c.length){this.e=D,this.l(b);return}const a=this.c.charCodeAt(D);if(u)u=!1;else if(a===r.CharCode.Slash&&!P){D++;break}else a===r.CharCode.OpenSquareBracket?P=!0:a===r.CharCode.Backslash?u=!0:a===r.CharCode.CloseSquareBracket&&(P=!1);D++}for(;D<this.c.length&&c.a.has(this.c.charCodeAt(D));)D++;this.e=D;const w=this.c.substring(this.d,this.e);this.f.push({type:T.RegexStr,lexeme:w,offset:this.d})}r(){return this.e>=this.c.length}}e.$xj=c}),define(ke[143],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const r={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(r)}),define(ke[112],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=void 0;class r{constructor(C,T=[],L=!1){this.ctor=C,this.staticArguments=T,this.supportsDelayedInstantiation=L}}e.$zi=r}),define(ke[88],Ie([1,0,112]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ns=T,e.$Os=L;const h=[];var C;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function T(R,b,c){b instanceof r.$zi||(b=new r.$zi(b,[],!!c)),h.push([R,b])}function L(){return h}}),define(ke[213],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=e.$qr=void 0;class r{constructor(T,L){this.key=T,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.$qr=r;class h{constructor(T){this.b=T,this.a=new Map}roots(){const T=[];for(const L of this.a.values())L.outgoing.size===0&&T.push(L);return T}insertEdge(T,L){const R=this.lookupOrInsertNode(T),b=this.lookupOrInsertNode(L);R.outgoing.set(b.key,b),b.incoming.set(R.key,R)}removeNode(T){const L=this.b(T);this.a.delete(L);for(const R of this.a.values())R.outgoing.delete(L),R.incoming.delete(L)}lookupOrInsertNode(T){const L=this.b(T);let R=this.a.get(L);return R||(R=new r(L,T),this.a.set(L,R)),R}lookup(T){return this.a.get(this.b(T))}isEmpty(){return this.a.size===0}toString(){const T=[];for(const[L,R]of this.a)T.push(`${L}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return T.join(`
`)}findCycleSlow(){for(const[T,L]of this.a){const R=new Set([T]),b=this.c(L,R);if(b)return b}}c(T,L){for(const[R,b]of T.outgoing){if(L.has(R))return[...L,R].join(" -> ");L.add(R);const c=this.c(b,L);if(c)return c;L.delete(R)}}}e.$rr=h}),define(ke[5],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=e._util=void 0,e.$Ci=C,e.$Di=T;var r;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function R(b){return b[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=R})(r||(e._util=r={})),e.$Bi=C("instantiationService");function h(L,R,b){R[r.DI_TARGET]===R?R[r.DI_DEPENDENCIES].push({id:L,index:b}):(R[r.DI_DEPENDENCIES]=[{id:L,index:b}],R[r.DI_TARGET]=R)}function C(L){if(r.serviceIds.has(L))return r.serviceIds.get(L);const R=function(b,c,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");h(R,b,I)};return R.toString=()=>L,r.serviceIds.set(L,R),R}function T(L){return L}}),define(ke[45],Ie([1,0,17,2,5]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$9i=void 0,e.$0i=T,e.$$i=L,e.$_i=b,e.$aj=c,e.$bj=I,e.$cj=D,e.$dj=u,e.$ej=w,e.$fj=a,e.$gj=$,r=Ue(r),e.$9i=(0,C.$Ci)("configurationService");function T(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof h.URI)}function L(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof h.URI)}var R;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function b(f){switch(f){case R.APPLICATION:return"APPLICATION";case R.USER:return"USER";case R.USER_LOCAL:return"USER_LOCAL";case R.USER_REMOTE:return"USER_REMOTE";case R.WORKSPACE:return"WORKSPACE";case R.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case R.DEFAULT:return"DEFAULT";case R.MEMORY:return"MEMORY"}}function c(f){return f.applicationValue!==void 0||f.userValue!==void 0||f.userLocalValue!==void 0||f.userRemoteValue!==void 0||f.workspaceValue!==void 0||f.workspaceFolderValue!==void 0}function I(f,g){const i=Object.create(null);for(const o in f)D(i,o,f[o],g);return i}function D(f,g,i,o){const t=g.split("."),s=t.pop();let n=f;for(let d=0;d<t.length;d++){const l=t[d];let m=n[l];switch(typeof m){case"undefined":m=n[l]=Object.create(null);break;case"object":if(m===null){o(`Ignoring ${g} as ${t.slice(0,d+1).join(".")} is null`);return}break;default:o(`Ignoring ${g} as ${t.slice(0,d+1).join(".")} is ${JSON.stringify(m)}`);return}n=m}if(typeof n=="object"&&n!==null)try{n[s]=i}catch{o(`Ignoring ${g} as ${t.join(".")} is ${JSON.stringify(n)}`)}else o(`Ignoring ${g} as ${t.join(".")} is ${JSON.stringify(n)}`)}function u(f,g){const i=g.split(".");P(f,i)}function P(f,g){const i=g.shift();if(g.length===0){delete f[i];return}if(Object.keys(f).indexOf(i)!==-1){const o=f[i];typeof o=="object"&&!Array.isArray(o)&&(P(o,g),Object.keys(o).length===0&&delete f[i])}}function w(f,g,i){function o(n,d){let l=n;for(const m of d){if(typeof l!="object"||l===null)return;l=l[m]}return l}const t=g.split("."),s=o(f,t);return typeof s>"u"?i:s}function a(f,g,i){Object.keys(g).forEach(o=>{o!=="__proto__"&&(o in f?r.$eg(f[o])&&r.$eg(g[o])?a(f[o],g[o],i):i&&(f[o]=g[o]):f[o]=g[o])})}function $(f){return f.replace(/[\[\]]/g,"")}}),define(ke[35],Ie([1,0,26,10,12,212,5,8,13]),function(me,e,r,h,C,T,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Aj=e.$zj=e.ContextKeyExprType=void 0,e.$yj=I,e.$Bj=d,e.$Cj=l,e.$Vj=re;const c=new Map;c.set("false",!1),c.set("true",!0),c.set("isMac",h.$k),c.set("isLinux",h.$l),c.set("isWindows",h.$j),c.set("isWeb",h.$p),c.set("isMacNative",h.$k&&!h.$p),c.set("isEdge",h.$I),c.set("isFirefox",h.$G),c.set("isChrome",h.$F),c.set("isSafari",h.$H);function I(J,W){if(c.get(J)!==void 0)throw(0,b.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");c.set(J,W)}const D=Object.prototype.hasOwnProperty;var u;(function(J){J[J.False=0]="False",J[J.True=1]="True",J[J.Defined=2]="Defined",J[J.Not=3]="Not",J[J.Equals=4]="Equals",J[J.NotEquals=5]="NotEquals",J[J.And=6]="And",J[J.Regex=7]="Regex",J[J.NotRegex=8]="NotRegex",J[J.Or=9]="Or",J[J.In=10]="In",J[J.NotIn=11]="NotIn",J[J.Greater=12]="Greater",J[J.GreaterEquals=13]="GreaterEquals",J[J.Smaller=14]="Smaller",J[J.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const P={regexParsingWithErrorRecovery:!0},w=(0,R.localize)(11432,null),a=(0,R.localize)(11433,null),$=(0,R.localize)(11434,null),f=(0,R.localize)(11435,null),g=(0,R.localize)(11436,null),i=(0,R.localize)(11437,null),o=(0,R.localize)(11438,null),t=(0,R.localize)(11439,null);class s{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(W=P){this.k=W,this.d=new T.$xj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(W){if(W===""){this.h.push({message:w,offset:0,lexeme:"",additionalInfo:a});return}this.f=this.d.reset(W).scan(),this.g=0,this.h=[];try{const se=this.l();if(!this.E()){const ae=this.D(),te=ae.type===T.TokenType.Str?i:void 0;throw this.h.push({message:g,offset:ae.offset,lexeme:T.$xj.getLexeme(ae),additionalInfo:te}),s.c}return se}catch(se){if(se!==s.c)throw se;return}}l(){return this.m()}m(){const W=[this.o()];for(;this.y(T.TokenType.Or);){const se=this.o();W.push(se)}return W.length===1?W[0]:n.or(...W)}o(){const W=[this.s()];for(;this.y(T.TokenType.And);){const se=this.s();W.push(se)}return W.length===1?W[0]:n.and(...W)}s(){if(this.y(T.TokenType.Neg)){const W=this.D();switch(W.type){case T.TokenType.True:return this.z(),E.INSTANCE;case T.TokenType.False:return this.z(),S.INSTANCE;case T.TokenType.LParen:{this.z();const se=this.l();return this.A(T.TokenType.RParen,f),se?.negate()}case T.TokenType.Str:return this.z(),F.create(W.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",W)}}return this.t()}t(){const W=this.D();switch(W.type){case T.TokenType.True:return this.z(),n.true();case T.TokenType.False:return this.z(),n.false();case T.TokenType.LParen:{this.z();const se=this.l();return this.A(T.TokenType.RParen,f),se}case T.TokenType.Str:{const se=W.lexeme;if(this.z(),this.y(T.TokenType.RegexOp)){const te=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),te.type!==T.TokenType.RegexStr)throw this.B("REGEX",te);const ce=te.lexeme,le=ce.lastIndexOf("/"),Z=le===ce.length-1?void 0:this.w(ce.substring(le+1));let oe;try{oe=new RegExp(ce.substring(1,le),Z)}catch{throw this.B("REGEX",te)}return V.create(se,oe)}switch(te.type){case T.TokenType.RegexStr:case T.TokenType.Error:{const ce=[te.lexeme];this.z();let le=this.D(),Z=0;for(let We=0;We<te.lexeme.length;We++)te.lexeme.charCodeAt(We)===r.CharCode.OpenParen?Z++:te.lexeme.charCodeAt(We)===r.CharCode.CloseParen&&Z--;for(;!this.E()&&le.type!==T.TokenType.And&&le.type!==T.TokenType.Or;){switch(le.type){case T.TokenType.LParen:Z++;break;case T.TokenType.RParen:Z--;break;case T.TokenType.RegexStr:case T.TokenType.QuotedStr:for(let We=0;We<le.lexeme.length;We++)le.lexeme.charCodeAt(We)===r.CharCode.OpenParen?Z++:te.lexeme.charCodeAt(We)===r.CharCode.CloseParen&&Z--}if(Z<0)break;ce.push(T.$xj.getLexeme(le)),this.z(),le=this.D()}const oe=ce.join(""),pe=oe.lastIndexOf("/"),we=pe===oe.length-1?void 0:this.w(oe.substring(pe+1));let Fe;try{Fe=new RegExp(oe.substring(1,pe),we)}catch{throw this.B("REGEX",te)}return n.regex(se,Fe)}case T.TokenType.QuotedStr:{const ce=te.lexeme;this.z();let le=null;if(!(0,C.$af)(ce)){const Z=ce.indexOf("/"),oe=ce.lastIndexOf("/");if(Z!==oe&&Z>=0){const pe=ce.slice(Z+1,oe),we=ce[oe+1]==="i"?"i":"";try{le=new RegExp(pe,we)}catch{throw this.B("REGEX",te)}}}if(le===null)throw this.B("REGEX",te);return V.create(se,le)}default:throw this.B("REGEX",this.D())}}if(this.y(T.TokenType.Not)){this.A(T.TokenType.In,$);const te=this.u();return n.notIn(se,te)}switch(this.D().type){case T.TokenType.Eq:{this.z();const te=this.u();if(this.x().type===T.TokenType.QuotedStr)return n.equals(se,te);switch(te){case"true":return n.has(se);case"false":return n.not(se);default:return n.equals(se,te)}}case T.TokenType.NotEq:{this.z();const te=this.u();if(this.x().type===T.TokenType.QuotedStr)return n.notEquals(se,te);switch(te){case"true":return n.not(se);case"false":return n.has(se);default:return n.notEquals(se,te)}}case T.TokenType.Lt:return this.z(),z.create(se,this.u());case T.TokenType.LtEq:return this.z(),M.create(se,this.u());case T.TokenType.Gt:return this.z(),O.create(se,this.u());case T.TokenType.GtEq:return this.z(),j.create(se,this.u());case T.TokenType.In:return this.z(),n.in(se,this.u());default:return n.has(se)}}case T.TokenType.EOF:throw this.h.push({message:o,offset:W.offset,lexeme:"",additionalInfo:t}),s.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const W=this.D();switch(W.type){case T.TokenType.Str:case T.TokenType.QuotedStr:return this.z(),W.lexeme;case T.TokenType.True:return this.z(),"true";case T.TokenType.False:return this.z(),"false";case T.TokenType.In:return this.z(),"in";default:return""}}w(W){return W.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(W){return this.C(W)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(W,se){if(this.C(W))return this.z();throw this.B(se,this.D())}B(W,se,ae){const te=(0,R.localize)(11440,null,W,T.$xj.getLexeme(se)),ce=se.offset,le=T.$xj.getLexeme(se);return this.h.push({message:te,offset:ce,lexeme:le,additionalInfo:ae}),s.c}C(W){return this.D().type===W}D(){return this.f[this.g]}E(){return this.D().type===T.TokenType.EOF}}e.$zj=s;class n{static false(){return E.INSTANCE}static true(){return S.INSTANCE}static has(W){return y.create(W)}static equals(W,se){return k.create(W,se)}static notEquals(W,se){return v.create(W,se)}static regex(W,se){return V.create(W,se)}static in(W,se){return A.create(W,se)}static notIn(W,se){return p.create(W,se)}static not(W){return F.create(W)}static and(...W){return B.create(W,null,!0)}static or(...W){return G.create(W,null,!0)}static greater(W,se){return O.create(W,se)}static greaterEquals(W,se){return j.create(W,se)}static smaller(W,se){return z.create(W,se)}static smallerEquals(W,se){return M.create(W,se)}static{this.c=new s({regexParsingWithErrorRecovery:!1})}static deserialize(W){return W==null?void 0:this.c.parse(W)}}e.$Aj=n;function d(J){const W=new s({regexParsingWithErrorRecovery:!1});return J.map(se=>(W.parse(se),W.lexingErrors.length>0?W.lexingErrors.map(ae=>({errorMessage:ae.additionalInfo?(0,R.localize)(11441,null,ae.additionalInfo):(0,R.localize)(11442,null),offset:ae.offset,length:ae.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(ae=>({errorMessage:ae.additionalInfo?`${ae.message}. ${ae.additionalInfo}`:ae.message,offset:ae.offset,length:ae.lexeme.length})):[]))}function l(J,W){const se=J?J.substituteConstants():void 0,ae=W?W.substituteConstants():void 0;return!se&&!ae?!0:!se||!ae?!1:se.equals(ae)}function m(J,W){return J.cmp(W)}class E{static{this.INSTANCE=new E}constructor(){this.type=u.False}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return S.INSTANCE}}e.$Dj=E;class S{static{this.INSTANCE=new S}constructor(){this.type=u.True}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return E.INSTANCE}}e.$Ej=S;class y{static create(W,se=null){const ae=c.get(W);return typeof ae=="boolean"?ae?S.INSTANCE:E.INSTANCE:new y(W,se)}constructor(W,se){this.key=W,this.c=se,this.type=u.Defined}cmp(W){return W.type!==this.type?this.type-W.type:ee(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=c.get(this.key);return typeof W=="boolean"?W?S.INSTANCE:E.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.c||(this.c=F.create(this.key,this)),this.c}}e.$Fj=y;class k{static create(W,se,ae=null){if(typeof se=="boolean")return se?y.create(W,ae):F.create(W,ae);const te=c.get(W);return typeof te=="boolean"?se===(te?"true":"false")?S.INSTANCE:E.INSTANCE:new k(W,se,ae)}constructor(W,se,ae){this.c=W,this.d=se,this.f=ae,this.type=u.Equals}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=c.get(this.c);if(typeof W=="boolean"){const se=W?"true":"false";return this.d===se?S.INSTANCE:E.INSTANCE}return this}evaluate(W){return W.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(W){return W.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Gj=k;class A{static create(W,se){return new A(W,se)}constructor(W,se){this.d=W,this.f=se,this.type=u.In,this.c=null}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.d,this.f,W.d,W.f)}equals(W){return W.type===this.type?this.d===W.d&&this.f===W.f:!1}substituteConstants(){return this}evaluate(W){const se=W.getValue(this.f),ae=W.getValue(this.d);return Array.isArray(se)?se.includes(ae):typeof ae=="string"&&typeof se=="object"&&se!==null?D.call(se,ae):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(W){return W.mapIn(this.d,this.f)}negate(){return this.c||(this.c=p.create(this.d,this.f)),this.c}}e.$Hj=A;class p{static create(W,se){return new p(W,se)}constructor(W,se){this.d=W,this.f=se,this.type=u.NotIn,this.c=A.create(W,se)}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(W){return W.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ij=p;class v{static create(W,se,ae=null){if(typeof se=="boolean")return se?F.create(W,ae):y.create(W,ae);const te=c.get(W);return typeof te=="boolean"?se===(te?"true":"false")?E.INSTANCE:S.INSTANCE:new v(W,se,ae)}constructor(W,se,ae){this.c=W,this.d=se,this.f=ae,this.type=u.NotEquals}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=c.get(this.c);if(typeof W=="boolean"){const se=W?"true":"false";return this.d===se?E.INSTANCE:S.INSTANCE}return this}evaluate(W){return W.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(W){return W.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Jj=v;class F{static create(W,se=null){const ae=c.get(W);return typeof ae=="boolean"?ae?E.INSTANCE:S.INSTANCE:new F(W,se)}constructor(W,se){this.c=W,this.d=se,this.type=u.Not}cmp(W){return W.type!==this.type?this.type-W.type:ee(this.c,W.c)}equals(W){return W.type===this.type?this.c===W.c:!1}substituteConstants(){const W=c.get(this.c);return typeof W=="boolean"?W?E.INSTANCE:S.INSTANCE:this}evaluate(W){return!W.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(W){return W.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.$Kj=F;function N(J,W){if(typeof J=="string"){const se=parseFloat(J);isNaN(se)||(J=se)}return typeof J=="string"||typeof J=="number"?W(J):E.INSTANCE}class O{static create(W,se,ae=null){return N(se,te=>new O(W,te,ae))}constructor(W,se,ae){this.c=W,this.d=se,this.f=ae,this.type=u.Greater}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Lj=O;class j{static create(W,se,ae=null){return N(se,te=>new j(W,te,ae))}constructor(W,se,ae){this.c=W,this.d=se,this.f=ae,this.type=u.GreaterEquals}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Mj=j;class z{static create(W,se,ae=null){return N(se,te=>new z(W,te,ae))}constructor(W,se,ae){this.c=W,this.d=se,this.f=ae,this.type=u.Smaller}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Nj=z;class M{static create(W,se,ae=null){return N(se,te=>new M(W,te,ae))}constructor(W,se,ae){this.c=W,this.d=se,this.f=ae,this.type=u.SmallerEquals}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Oj=M;class V{static create(W,se){return new V(W,se)}constructor(W,se){this.d=W,this.f=se,this.type=u.Regex,this.c=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.d<W.d)return-1;if(this.d>W.d)return 1;const se=this.f?this.f.source:"",ae=W.f?W.f.source:"";return se<ae?-1:se>ae?1:0}equals(W){if(W.type===this.type){const se=this.f?this.f.source:"",ae=W.f?W.f.source:"";return this.d===W.d&&se===ae}return!1}substituteConstants(){return this}evaluate(W){const se=W.getValue(this.d);return this.f?this.f.test(se):!1}serialize(){const W=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${W}`}keys(){return[this.d]}map(W){return W.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$Pj=V;class K{static create(W){return new K(W)}constructor(W){this.c=W,this.type=u.NotRegex}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(W){return new K(this.c.map(W))}negate(){return this.c}}e.$Qj=K;function ne(J){let W=null;for(let se=0,ae=J.length;se<ae;se++){const te=J[se].substituteConstants();if(J[se]!==te&&W===null){W=[];for(let ce=0;ce<se;ce++)W[ce]=J[ce]}W!==null&&(W[se]=te)}return W===null?J:W}class B{static create(W,se,ae){return B.d(W,se,ae)}constructor(W,se){this.expr=W,this.c=se,this.type=u.And}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let se=0,ae=this.expr.length;se<ae;se++){const te=m(this.expr[se],W.expr[se]);if(te!==0)return te}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let se=0,ae=this.expr.length;se<ae;se++)if(!this.expr[se].equals(W.expr[se]))return!1;return!0}return!1}substituteConstants(){const W=ne(this.expr);return W===this.expr?this:B.create(W,this.c,!1)}evaluate(W){for(let se=0,ae=this.expr.length;se<ae;se++)if(!this.expr[se].evaluate(W))return!1;return!0}static d(W,se,ae){const te=[];let ce=!1;for(const le of W)if(le){if(le.type===u.True){ce=!0;continue}if(le.type===u.False)return E.INSTANCE;if(le.type===u.And){te.push(...le.expr);continue}te.push(le)}if(te.length===0&&ce)return S.INSTANCE;if(te.length!==0){if(te.length===1)return te[0];te.sort(m);for(let le=1;le<te.length;le++)te[le-1].equals(te[le])&&(te.splice(le,1),le--);if(te.length===1)return te[0];for(;te.length>1;){const le=te[te.length-1];if(le.type!==u.Or)break;te.pop();const Z=te.pop(),oe=te.length===0,pe=G.create(le.expr.map(we=>B.create([we,Z],null,ae)),null,oe);pe&&(te.push(pe),te.sort(m))}if(te.length===1)return te[0];if(ae){for(let le=0;le<te.length;le++)for(let Z=le+1;Z<te.length;Z++)if(te[le].negate().equals(te[Z]))return E.INSTANCE;if(te.length===1)return te[0]}return new B(te,se)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const se of this.expr)W.push(...se.keys());return W}map(W){return new B(this.expr.map(se=>se.map(W)),null)}negate(){if(!this.c){const W=[];for(const se of this.expr)W.push(se.negate());this.c=G.create(W,this,!0)}return this.c}}e.$Rj=B;class G{static create(W,se,ae){return G.d(W,se,ae)}constructor(W,se){this.expr=W,this.c=se,this.type=u.Or}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let se=0,ae=this.expr.length;se<ae;se++){const te=m(this.expr[se],W.expr[se]);if(te!==0)return te}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let se=0,ae=this.expr.length;se<ae;se++)if(!this.expr[se].equals(W.expr[se]))return!1;return!0}return!1}substituteConstants(){const W=ne(this.expr);return W===this.expr?this:G.create(W,this.c,!1)}evaluate(W){for(let se=0,ae=this.expr.length;se<ae;se++)if(this.expr[se].evaluate(W))return!0;return!1}static d(W,se,ae){let te=[],ce=!1;if(W){for(let le=0,Z=W.length;le<Z;le++){const oe=W[le];if(oe){if(oe.type===u.False){ce=!0;continue}if(oe.type===u.True)return S.INSTANCE;if(oe.type===u.Or){te=te.concat(oe.expr);continue}te.push(oe)}}if(te.length===0&&ce)return E.INSTANCE;te.sort(m)}if(te.length!==0){if(te.length===1)return te[0];for(let le=1;le<te.length;le++)te[le-1].equals(te[le])&&(te.splice(le,1),le--);if(te.length===1)return te[0];if(ae){for(let le=0;le<te.length;le++)for(let Z=le+1;Z<te.length;Z++)if(te[le].negate().equals(te[Z]))return S.INSTANCE;if(te.length===1)return te[0]}return new G(te,se)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const se of this.expr)W.push(...se.keys());return W}map(W){return new G(this.expr.map(se=>se.map(W)),null)}negate(){if(!this.c){const W=[];for(const se of this.expr)W.push(se.negate());for(;W.length>1;){const se=W.shift(),ae=W.shift(),te=[];for(const ce of $e(se))for(const le of $e(ae))te.push(B.create([ce,le],null,!1));W.unshift(G.create(te,null,!1))}this.c=G.create(W,this,!0)}return this.c}}e.$Sj=G;class Y extends y{static{this.d=[]}static all(){return Y.d.values()}constructor(W,se,ae){super(W,null),this.f=se,typeof ae=="object"?Y.d.push({...ae,key:W}):ae!==!0&&Y.d.push({key:W,description:ae,type:se!=null?typeof se:void 0})}bindTo(W){return W.createKey(this.key,this.f)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return k.create(this.key,W)}notEqualsTo(W){return v.create(this.key,W)}}e.$Tj=Y,e.$Uj=(0,L.$Ci)("contextKeyService");function ee(J,W){return J<W?-1:J>W?1:0}function ue(J,W,se,ae){return J<se?-1:J>se?1:W<ae?-1:W>ae?1:0}function re(J,W){if(J.type===u.False||W.type===u.True)return!0;if(J.type===u.Or)return W.type===u.Or?ye(J.expr,W.expr):!1;if(W.type===u.Or){for(const se of W.expr)if(re(J,se))return!0;return!1}if(J.type===u.And){if(W.type===u.And)return ye(W.expr,J.expr);for(const se of J.expr)if(re(se,W))return!0;return!1}return J.equals(W)}function ye(J,W){let se=0,ae=0;for(;se<J.length&&ae<W.length;){const te=J[se].cmp(W[ae]);if(te<0)return!1;te===0&&se++,ae++}return se===J.length}function $e(J){return J.type===u.Or?J.expr:[J]}}),define(ke[214],Ie([1,0,35,5]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qt=e.$ot=e.AccessibilitySupport=e.$nt=void 0,e.$pt=T,e.$nt=(0,h.$Ci)("accessibilityService");var C;(function(L){L[L.Unknown=0]="Unknown",L[L.Disabled=1]="Disabled",L[L.Enabled=2]="Enabled"})(C||(e.AccessibilitySupport=C={})),e.$ot=new r.$Tj("accessibilityModeEnabled",!1);function T(L){return L&&typeof L=="object"&&typeof L.label=="string"&&(typeof L.role>"u"||typeof L.role=="string")}e.$qt="ACCESSIBLE_VIEW_SHOWN_"}),define(ke[113],Ie([1,0,18,24,10,184,83,198,140,8,214]),function(me,e,r,h,C,T,L,R,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=t,e.clampedFloat=n,e.stringSet=m,e.cursorStyleToString=N,e.filterValidationDecorations=De,r=Ue(r),h=Ue(h),C=Ue(C),c=Ue(c);var D;(function(he){he[he.None=0]="None",he[he.Keep=1]="Keep",he[he.Brackets=2]="Brackets",he[he.Advanced=3]="Advanced",he[he.Full=4]="Full"})(D||(e.EditorAutoIndentStrategy=D={})),e.MINIMAP_GUTTER_WIDTH=8;class u{constructor(x){this.c=x}hasChanged(x){return this.c[x]}}e.ConfigurationChangedEvent=u;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class w{constructor(x,Ce,Xe,et){this.id=x,this.name=Ce,this.defaultValue=Xe,this.schema=et}applyUpdate(x,Ce){return $(x,Ce)}compute(x,Ce,Xe){return Xe}}class a{constructor(x,Ce){this.newValue=x,this.didChange=Ce}}e.ApplyUpdateResult=a;function $(he,x){if(typeof he!="object"||typeof x!="object"||!he||!x)return new a(x,he!==x);if(Array.isArray(he)||Array.isArray(x)){const Xe=Array.isArray(he)&&Array.isArray(x)&&r.$tb(he,x);return new a(x,!Xe)}let Ce=!1;for(const Xe in x)if(x.hasOwnProperty(Xe)){const et=$(he[Xe],x[Xe]);et.didChange&&(he[Xe]=et.newValue,Ce=!0)}return new a(he,Ce)}class f{constructor(x){this.schema=void 0,this.id=x,this.name="_never_",this.defaultValue=void 0}applyUpdate(x,Ce){return $(x,Ce)}validate(x){return this.defaultValue}}class g{constructor(x,Ce,Xe,et){this.id=x,this.name=Ce,this.defaultValue=Xe,this.schema=et}applyUpdate(x,Ce){return $(x,Ce)}validate(x){return typeof x>"u"?this.defaultValue:x}compute(x,Ce,Xe){return Xe}}function i(he,x){return typeof he>"u"?x:he==="false"?!1:!!he}class o extends g{constructor(x,Ce,Xe,et=void 0){typeof et<"u"&&(et.type="boolean",et.default=Xe),super(x,Ce,Xe,et)}validate(x){return i(x,this.defaultValue)}}function t(he,x,Ce,Xe){if(typeof he>"u")return x;let et=parseInt(he,10);return isNaN(et)?x:(et=Math.max(Ce,et),et=Math.min(Xe,et),et|0)}class s extends g{static clampedInt(x,Ce,Xe,et){return t(x,Ce,Xe,et)}constructor(x,Ce,Xe,et,ut,gt=void 0){typeof gt<"u"&&(gt.type="integer",gt.default=Xe,gt.minimum=et,gt.maximum=ut),super(x,Ce,Xe,gt),this.minimum=et,this.maximum=ut}validate(x){return s.clampedInt(x,this.defaultValue,this.minimum,this.maximum)}}function n(he,x,Ce,Xe){if(typeof he>"u")return x;const et=d.float(he,x);return d.clamp(et,Ce,Xe)}class d extends g{static clamp(x,Ce,Xe){return x<Ce?Ce:x>Xe?Xe:x}static float(x,Ce){if(typeof x=="number")return x;if(typeof x>"u")return Ce;const Xe=parseFloat(x);return isNaN(Xe)?Ce:Xe}constructor(x,Ce,Xe,et,ut){typeof ut<"u"&&(ut.type="number",ut.default=Xe),super(x,Ce,Xe,ut),this.validationFn=et}validate(x){return this.validationFn(d.float(x,this.defaultValue))}}class l extends g{static string(x,Ce){return typeof x!="string"?Ce:x}constructor(x,Ce,Xe,et=void 0){typeof et<"u"&&(et.type="string",et.default=Xe),super(x,Ce,Xe,et)}validate(x){return l.string(x,this.defaultValue)}}function m(he,x,Ce,Xe){return typeof he!="string"?x:Xe&&he in Xe?Xe[he]:Ce.indexOf(he)===-1?x:he}class E extends g{constructor(x,Ce,Xe,et,ut=void 0){typeof ut<"u"&&(ut.type="string",ut.enum=et,ut.default=Xe),super(x,Ce,Xe,ut),this.c=et}validate(x){return m(x,this.defaultValue,this.c)}}class S extends w{constructor(x,Ce,Xe,et,ut,gt,Dt=void 0){typeof Dt<"u"&&(Dt.type="string",Dt.enum=ut,Dt.default=et),super(x,Ce,Xe,Dt),this.c=ut,this.d=gt}validate(x){return typeof x!="string"?this.defaultValue:this.c.indexOf(x)===-1?this.defaultValue:this.d(x)}}function y(he){switch(he){case"none":return D.None;case"keep":return D.Keep;case"brackets":return D.Brackets;case"advanced":return D.Advanced;case"full":return D.Full}}class k extends w{constructor(){super(je.accessibilitySupport,"accessibilitySupport",I.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(11608,null),c.localize(11609,null),c.localize(11610,null)],default:"auto",tags:["accessibility"],description:c.localize(11611,null)})}validate(x){switch(x){case"auto":return I.AccessibilitySupport.Unknown;case"off":return I.AccessibilitySupport.Disabled;case"on":return I.AccessibilitySupport.Enabled}return this.defaultValue}compute(x,Ce,Xe){return Xe===I.AccessibilitySupport.Unknown?x.accessibilitySupport:Xe}}class A extends w{constructor(){const x={insertSpace:!0,ignoreEmptyLines:!0};super(je.comments,"comments",x,{"editor.comments.insertSpace":{type:"boolean",default:x.insertSpace,description:c.localize(11612,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:x.ignoreEmptyLines,description:c.localize(11613,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return{insertSpace:i(Ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(Ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var p;(function(he){he[he.Hidden=0]="Hidden",he[he.Blink=1]="Blink",he[he.Smooth=2]="Smooth",he[he.Phase=3]="Phase",he[he.Expand=4]="Expand",he[he.Solid=5]="Solid"})(p||(e.TextEditorCursorBlinkingStyle=p={}));function v(he){switch(he){case"blink":return p.Blink;case"smooth":return p.Smooth;case"phase":return p.Phase;case"expand":return p.Expand;case"solid":return p.Solid}}var F;(function(he){he[he.Line=1]="Line",he[he.Block=2]="Block",he[he.Underline=3]="Underline",he[he.LineThin=4]="LineThin",he[he.BlockOutline=5]="BlockOutline",he[he.UnderlineThin=6]="UnderlineThin"})(F||(e.TextEditorCursorStyle=F={}));function N(he){switch(he){case F.Line:return"line";case F.Block:return"block";case F.Underline:return"underline";case F.LineThin:return"line-thin";case F.BlockOutline:return"block-outline";case F.UnderlineThin:return"underline-thin"}}function O(he){switch(he){case"line":return F.Line;case"block":return F.Block;case"underline":return F.Underline;case"line-thin":return F.LineThin;case"block-outline":return F.BlockOutline;case"underline-thin":return F.UnderlineThin}}class j extends f{constructor(){super(je.editorClassName)}compute(x,Ce,Xe){const et=["monaco-editor"];return Ce.get(je.extraEditorClassName)&&et.push(Ce.get(je.extraEditorClassName)),x.extraEditorClassName&&et.push(x.extraEditorClassName),Ce.get(je.mouseStyle)==="default"?et.push("mouse-default"):Ce.get(je.mouseStyle)==="copy"&&et.push("mouse-copy"),Ce.get(je.showUnused)&&et.push("showUnused"),Ce.get(je.showDeprecated)&&et.push("showDeprecated"),et.join(" ")}}class z extends o{constructor(){super(je.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:c.localize(11614,null)})}compute(x,Ce,Xe){return Xe&&x.emptySelectionClipboard}}class M extends w{constructor(){const x={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(je.find,"find",x,{"editor.find.cursorMoveOnType":{type:"boolean",default:x.cursorMoveOnType,description:c.localize(11615,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:x.seedSearchStringFromSelection,enumDescriptions:[c.localize(11616,null),c.localize(11617,null),c.localize(11618,null)],description:c.localize(11619,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:x.autoFindInSelection,enumDescriptions:[c.localize(11620,null),c.localize(11621,null),c.localize(11622,null)],description:c.localize(11623,null)},"editor.find.globalFindClipboard":{type:"boolean",default:x.globalFindClipboard,description:c.localize(11624,null),included:C.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:x.addExtraSpaceOnTop,description:c.localize(11625,null)},"editor.find.loop":{type:"boolean",default:x.loop,description:c.localize(11626,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return{cursorMoveOnType:i(Ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof x.seedSearchStringFromSelection=="boolean"?x.seedSearchStringFromSelection?"always":"never":m(Ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof x.autoFindInSelection=="boolean"?x.autoFindInSelection?"always":"never":m(Ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(Ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(Ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(Ce.loop,this.defaultValue.loop)}}}class V extends w{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(je.fontLigatures,"fontLigatures",V.OFF,{anyOf:[{type:"boolean",description:c.localize(11627,null)},{type:"string",description:c.localize(11628,null)}],description:c.localize(11629,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"||x.length===0?V.OFF:x==="true"?V.ON:x:x?V.ON:V.OFF}}e.EditorFontLigatures=V;class K extends w{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(je.fontVariations,"fontVariations",K.OFF,{anyOf:[{type:"boolean",description:c.localize(11630,null)},{type:"string",description:c.localize(11631,null)}],description:c.localize(11632,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"?K.OFF:x==="true"?K.TRANSLATE:x:x?K.TRANSLATE:K.OFF}compute(x,Ce,Xe){return x.fontInfo.fontVariationSettings}}e.EditorFontVariations=K;class ne extends f{constructor(){super(je.fontInfo)}compute(x,Ce,Xe){return x.fontInfo}}class B extends g{constructor(){super(je.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(11633,null)})}validate(x){const Ce=d.float(x,this.defaultValue);return Ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(Ce,6,100)}compute(x,Ce,Xe){return x.fontInfo.fontSize}}class G extends w{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(je.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:G.d,maximum:G.e,errorMessage:c.localize(11634,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:G.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(11635,null)})}validate(x){return x==="normal"||x==="bold"?x:String(s.clampedInt(x,e.EDITOR_FONT_DEFAULTS.fontWeight,G.d,G.e))}}class Y extends w{constructor(){const x={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:x.multiple,enumDescriptions:[c.localize(11636,null),c.localize(11637,null),c.localize(11638,null)]},Xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(je.gotoLocation,"gotoLocation",x,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(11639,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(11640,null),...Ce},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(11641,null),...Ce},"editor.gotoLocation.multipleDeclarations":{description:c.localize(11642,null),...Ce},"editor.gotoLocation.multipleImplementations":{description:c.localize(11643,null),...Ce},"editor.gotoLocation.multipleReferences":{description:c.localize(11644,null),...Ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:x.alternativeDefinitionCommand,enum:Xe,description:c.localize(11645,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:x.alternativeTypeDefinitionCommand,enum:Xe,description:c.localize(11646,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:x.alternativeDeclarationCommand,enum:Xe,description:c.localize(11647,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:x.alternativeImplementationCommand,enum:Xe,description:c.localize(11648,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:x.alternativeReferenceCommand,enum:Xe,description:c.localize(11649,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return{multiple:m(Ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ce.multipleDefinitions??m(Ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ce.multipleTypeDefinitions??m(Ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ce.multipleDeclarations??m(Ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ce.multipleImplementations??m(Ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ce.multipleReferences??m(Ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:l.string(Ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:l.string(Ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:l.string(Ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:l.string(Ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:l.string(Ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ee extends w{constructor(){const x={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(je.hover,"hover",x,{"editor.hover.enabled":{type:"boolean",default:x.enabled,description:c.localize(11650,null)},"editor.hover.delay":{type:"number",default:x.delay,minimum:0,maximum:1e4,description:c.localize(11651,null)},"editor.hover.sticky":{type:"boolean",default:x.sticky,description:c.localize(11652,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:x.hidingDelay,description:c.localize(11653,null)},"editor.hover.above":{type:"boolean",default:x.above,description:c.localize(11654,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return{enabled:i(Ce.enabled,this.defaultValue.enabled),delay:s.clampedInt(Ce.delay,this.defaultValue.delay,0,1e4),sticky:i(Ce.sticky,this.defaultValue.sticky),hidingDelay:s.clampedInt(Ce.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(Ce.above,this.defaultValue.above)}}}var ue;(function(he){he[he.None=0]="None",he[he.Text=1]="Text",he[he.Blocks=2]="Blocks"})(ue||(e.RenderMinimap=ue={}));class re extends f{constructor(){super(je.layoutInfo)}compute(x,Ce,Xe){return re.computeLayout(Ce,{memory:x.memory,outerWidth:x.outerWidth,outerHeight:x.outerHeight,isDominatedByLongLines:x.isDominatedByLongLines,lineHeight:x.fontInfo.lineHeight,viewLineCount:x.viewLineCount,lineNumbersDigitCount:x.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:x.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:x.fontInfo.maxDigitWidth,pixelRatio:x.pixelRatio,glyphMarginDecorationLaneCount:x.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(x){const Ce=x.height/x.lineHeight,Xe=Math.floor(x.paddingTop/x.lineHeight);let et=Math.floor(x.paddingBottom/x.lineHeight);x.scrollBeyondLastLine&&(et=Math.max(et,Ce-1));const ut=(Xe+x.viewLineCount+et)/(x.pixelRatio*x.height),gt=Math.floor(x.viewLineCount/ut);return{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:Xe,extraLinesBeyondLastLine:et,desiredRatio:ut,minimapLineCount:gt}}static c(x,Ce){const Xe=x.outerWidth,et=x.outerHeight,ut=x.pixelRatio;if(!x.minimap.enabled)return{renderMinimap:ue.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ut*et),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:et};const gt=Ce.stableMinimapLayoutInput,Dt=gt&&x.outerHeight===gt.outerHeight&&x.lineHeight===gt.lineHeight&&x.typicalHalfwidthCharacterWidth===gt.typicalHalfwidthCharacterWidth&&x.pixelRatio===gt.pixelRatio&&x.scrollBeyondLastLine===gt.scrollBeyondLastLine&&x.paddingTop===gt.paddingTop&&x.paddingBottom===gt.paddingBottom&&x.minimap.enabled===gt.minimap.enabled&&x.minimap.side===gt.minimap.side&&x.minimap.size===gt.minimap.size&&x.minimap.showSlider===gt.minimap.showSlider&&x.minimap.renderCharacters===gt.minimap.renderCharacters&&x.minimap.maxColumn===gt.minimap.maxColumn&&x.minimap.scale===gt.minimap.scale&&x.verticalScrollbarWidth===gt.verticalScrollbarWidth&&x.isViewportWrapping===gt.isViewportWrapping,Ot=x.lineHeight,Ut=x.typicalHalfwidthCharacterWidth,ui=x.scrollBeyondLastLine,ti=x.minimap.renderCharacters;let _e=ut>=2?Math.round(x.minimap.scale*2):x.minimap.scale;const Kt=x.minimap.maxColumn,Qt=x.minimap.size,pt=x.minimap.side,Pt=x.verticalScrollbarWidth,ii=x.viewLineCount,Zt=x.remainingWidth,qt=x.isViewportWrapping,vt=ti?2:3;let Nt=Math.floor(ut*et);const hi=Nt/ut;let Vt=!1,xe=!1,xt=vt*_e,ni=_e/ut,di=1;if(Qt==="fill"||Qt==="fit"){const{typicalViewportLineCount:si,extraLinesBeforeFirstLine:Gt,extraLinesBeyondLastLine:Jt,desiredRatio:oi,minimapLineCount:At}=re.computeContainedMinimapLineCount({viewLineCount:ii,scrollBeyondLastLine:ui,paddingTop:x.paddingTop,paddingBottom:x.paddingBottom,height:et,lineHeight:Ot,pixelRatio:ut});if(ii/At>1)Vt=!0,xe=!0,_e=1,xt=1,ni=_e/ut;else{let wt=!1,ei=_e+1;if(Qt==="fit"){const It=Math.ceil((Gt+ii+Jt)*xt);qt&&Dt&&Zt<=Ce.stableFitRemainingWidth?(wt=!0,ei=Ce.stableFitMaxMinimapScale):wt=It>Nt}if(Qt==="fill"||wt){Vt=!0;const It=_e;xt=Math.min(Ot*ut,Math.max(1,Math.floor(1/oi))),qt&&Dt&&Zt<=Ce.stableFitRemainingWidth&&(ei=Ce.stableFitMaxMinimapScale),_e=Math.min(ei,Math.max(1,Math.floor(xt/vt))),_e>It&&(di=Math.min(2,_e/It)),ni=_e/ut/di,Nt=Math.ceil(Math.max(si,Gt+ii+Jt)*xt),qt?(Ce.stableMinimapLayoutInput=x,Ce.stableFitRemainingWidth=Zt,Ce.stableFitMaxMinimapScale=_e):(Ce.stableMinimapLayoutInput=null,Ce.stableFitRemainingWidth=0)}}}const kt=Math.floor(Kt*ni),Ft=Math.min(kt,Math.max(0,Math.floor((Zt-Pt-2)*ni/(Ut+ni)))+e.MINIMAP_GUTTER_WIDTH);let Rt=Math.floor(ut*Ft);const Bt=Rt/ut;Rt=Math.floor(Rt*di);const ri=ti?ue.Text:ue.Blocks,_t=pt==="left"?0:Xe-Ft-Pt;return{renderMinimap:ri,minimapLeft:_t,minimapWidth:Ft,minimapHeightIsEditorHeight:Vt,minimapIsSampling:xe,minimapScale:_e,minimapLineHeight:xt,minimapCanvasInnerWidth:Rt,minimapCanvasInnerHeight:Nt,minimapCanvasOuterWidth:Bt,minimapCanvasOuterHeight:hi}}static computeLayout(x,Ce){const Xe=Ce.outerWidth|0,et=Ce.outerHeight|0,ut=Ce.lineHeight|0,gt=Ce.lineNumbersDigitCount|0,Dt=Ce.typicalHalfwidthCharacterWidth,Ot=Ce.maxDigitWidth,Ut=Ce.pixelRatio,ui=Ce.viewLineCount,ti=x.get(je.wordWrapOverride2),_e=ti==="inherit"?x.get(je.wordWrapOverride1):ti,Kt=_e==="inherit"?x.get(je.wordWrap):_e,Qt=x.get(je.wordWrapColumn),pt=Ce.isDominatedByLongLines,Pt=x.get(je.glyphMargin),ii=x.get(je.lineNumbers).renderType!==We.Off,Zt=x.get(je.lineNumbersMinChars),qt=x.get(je.scrollBeyondLastLine),vt=x.get(je.padding),Nt=x.get(je.minimap),hi=x.get(je.scrollbar),Vt=hi.verticalScrollbarSize,xe=hi.verticalHasArrows,xt=hi.arrowSize,ni=hi.horizontalScrollbarSize,di=x.get(je.folding),kt=x.get(je.showFoldingControls)!=="never";let Ft=x.get(je.lineDecorationsWidth);di&&kt&&(Ft+=16);let Rt=0;if(ii){const Ht=Math.max(gt,Zt);Rt=Math.round(Ht*Ot)}let Bt=0;Pt&&(Bt=ut*Ce.glyphMarginDecorationLaneCount);let ri=0,_t=ri+Bt,si=_t+Rt,Gt=si+Ft;const Jt=Xe-Bt-Rt-Ft;let oi=!1,At=!1,St=-1;_e==="inherit"&&pt?(oi=!0,At=!0):Kt==="on"||Kt==="bounded"?At=!0:Kt==="wordWrapColumn"&&(St=Qt);const wt=re.c({outerWidth:Xe,outerHeight:et,lineHeight:ut,typicalHalfwidthCharacterWidth:Dt,pixelRatio:Ut,scrollBeyondLastLine:qt,paddingTop:vt.top,paddingBottom:vt.bottom,minimap:Nt,verticalScrollbarWidth:Vt,viewLineCount:ui,remainingWidth:Jt,isViewportWrapping:At},Ce.memory||new P);wt.renderMinimap!==ue.None&&wt.minimapLeft===0&&(ri+=wt.minimapWidth,_t+=wt.minimapWidth,si+=wt.minimapWidth,Gt+=wt.minimapWidth);const ei=Jt-wt.minimapWidth,It=Math.max(1,Math.floor((ei-Vt-2)/Dt)),fi=xe?xt:0;return At&&(St=Math.max(1,It),Kt==="bounded"&&(St=Math.min(St,Qt))),{width:Xe,height:et,glyphMarginLeft:ri,glyphMarginWidth:Bt,glyphMarginDecorationLaneCount:Ce.glyphMarginDecorationLaneCount,lineNumbersLeft:_t,lineNumbersWidth:Rt,decorationsLeft:si,decorationsWidth:Ft,contentLeft:Gt,contentWidth:ei,minimap:wt,viewportColumn:It,isWordWrapMinified:oi,isViewportWrapping:At,wrappingColumn:St,verticalScrollbarWidth:Vt,horizontalScrollbarHeight:ni,overviewRuler:{top:fi,width:Vt,height:et-2*fi,right:0}}}}e.EditorLayoutInfoComputer=re;class ye extends w{constructor(){super(je.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[c.localize(11655,null),c.localize(11656,null)],type:"string",enum:["simple","advanced"],default:"simple",description:c.localize(11657,null)}})}validate(x){return m(x,"simple",["simple","advanced"])}compute(x,Ce,Xe){return Ce.get(je.accessibilitySupport)===I.AccessibilitySupport.Enabled?"advanced":Xe}}var $e;(function(he){he.Off="off",he.OnCode="onCode",he.On="on"})($e||(e.ShowLightbulbIconMode=$e={}));class J extends w{constructor(){const x={enabled:$e.On};super(je.lightbulb,"lightbulb",x,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[$e.Off,$e.OnCode,$e.On],default:x.enabled,enumDescriptions:[c.localize(11658,null),c.localize(11659,null),c.localize(11660,null)],description:c.localize(11661,null)}})}validate(x){return!x||typeof x!="object"?this.defaultValue:{enabled:m(x.enabled,this.defaultValue.enabled,[$e.Off,$e.OnCode,$e.On])}}}class W extends w{constructor(){const x={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(je.stickyScroll,"stickyScroll",x,{"editor.stickyScroll.enabled":{type:"boolean",default:x.enabled,description:c.localize(11662,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:x.maxLineCount,minimum:1,maximum:20,description:c.localize(11663,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:x.defaultModel,description:c.localize(11664,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:x.scrollWithEditor,description:c.localize(11665,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return{enabled:i(Ce.enabled,this.defaultValue.enabled),maxLineCount:s.clampedInt(Ce.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:m(Ce.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(Ce.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class se extends w{constructor(){const x={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(je.inlayHints,"inlayHints",x,{"editor.inlayHints.enabled":{type:"string",default:x.enabled,description:c.localize(11666,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[c.localize(11667,null),c.localize(11668,null,C.$k?"Ctrl+Option":"Ctrl+Alt"),c.localize(11669,null,C.$k?"Ctrl+Option":"Ctrl+Alt"),c.localize(11670,null)]},"editor.inlayHints.fontSize":{type:"number",default:x.fontSize,markdownDescription:c.localize(11671,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:x.fontFamily,markdownDescription:c.localize(11672,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:x.padding,description:c.localize(11673,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return typeof Ce.enabled=="boolean"&&(Ce.enabled=Ce.enabled?"on":"off"),{enabled:m(Ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:s.clampedInt(Ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:l.string(Ce.fontFamily,this.defaultValue.fontFamily),padding:i(Ce.padding,this.defaultValue.padding)}}}class ae extends w{constructor(){super(je.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(x){return typeof x=="string"&&/^\d+(\.\d+)?ch$/.test(x)?-parseFloat(x.substring(0,x.length-2)):s.clampedInt(x,this.defaultValue,0,1e3)}compute(x,Ce,Xe){return Xe<0?s.clampedInt(-Xe*x.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Xe}}class te extends d{constructor(){super(je.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,x=>d.clamp(x,0,150),{markdownDescription:c.localize(11674,null)})}compute(x,Ce,Xe){return x.fontInfo.lineHeight}}class ce extends w{constructor(){const x={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(je.minimap,"minimap",x,{"editor.minimap.enabled":{type:"boolean",default:x.enabled,description:c.localize(11675,null)},"editor.minimap.autohide":{type:"boolean",default:x.autohide,description:c.localize(11676,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(11677,null),c.localize(11678,null),c.localize(11679,null)],default:x.size,description:c.localize(11680,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:x.side,description:c.localize(11681,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:x.showSlider,description:c.localize(11682,null)},"editor.minimap.scale":{type:"number",default:x.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(11683,null)},"editor.minimap.renderCharacters":{type:"boolean",default:x.renderCharacters,description:c.localize(11684,null)},"editor.minimap.maxColumn":{type:"number",default:x.maxColumn,description:c.localize(11685,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:x.showRegionSectionHeaders,description:c.localize(11686,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:x.showMarkSectionHeaders,description:c.localize(11687,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:x.sectionHeaderFontSize,description:c.localize(11688,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:x.sectionHeaderLetterSpacing,description:c.localize(11689,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return{enabled:i(Ce.enabled,this.defaultValue.enabled),autohide:i(Ce.autohide,this.defaultValue.autohide),size:m(Ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:m(Ce.side,this.defaultValue.side,["right","left"]),showSlider:m(Ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(Ce.renderCharacters,this.defaultValue.renderCharacters),scale:s.clampedInt(Ce.scale,1,1,3),maxColumn:s.clampedInt(Ce.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(Ce.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(Ce.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:d.clamp(Ce.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:d.clamp(Ce.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function le(he){return he==="ctrlCmd"?C.$k?"metaKey":"ctrlKey":"altKey"}class Z extends w{constructor(){super(je.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(11690,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(11691,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return{top:s.clampedInt(Ce.top,0,0,1e3),bottom:s.clampedInt(Ce.bottom,0,0,1e3)}}}class oe extends w{constructor(){const x={enabled:!0,cycle:!0};super(je.parameterHints,"parameterHints",x,{"editor.parameterHints.enabled":{type:"boolean",default:x.enabled,description:c.localize(11692,null)},"editor.parameterHints.cycle":{type:"boolean",default:x.cycle,description:c.localize(11693,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return{enabled:i(Ce.enabled,this.defaultValue.enabled),cycle:i(Ce.cycle,this.defaultValue.cycle)}}}class pe extends f{constructor(){super(je.pixelRatio)}compute(x,Ce,Xe){return x.pixelRatio}}class we extends w{constructor(){super(je.placeholder,"placeholder",void 0)}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x:this.defaultValue}}class Fe extends w{constructor(){const x={other:"on",comments:"off",strings:"off"},Ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[c.localize(11694,null),c.localize(11695,null),c.localize(11696,null)]}];super(je.quickSuggestions,"quickSuggestions",x,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ce,default:x.strings,description:c.localize(11697,null)},comments:{anyOf:Ce,default:x.comments,description:c.localize(11698,null)},other:{anyOf:Ce,default:x.other,description:c.localize(11699,null)}},default:x,markdownDescription:c.localize(11700,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=x}validate(x){if(typeof x=="boolean"){const Ut=x?"on":"off";return{comments:Ut,strings:Ut,other:Ut}}if(!x||typeof x!="object")return this.defaultValue;const{other:Ce,comments:Xe,strings:et}=x,ut=["on","inline","off"];let gt,Dt,Ot;return typeof Ce=="boolean"?gt=Ce?"on":"off":gt=m(Ce,this.defaultValue.other,ut),typeof Xe=="boolean"?Dt=Xe?"on":"off":Dt=m(Xe,this.defaultValue.comments,ut),typeof et=="boolean"?Ot=et?"on":"off":Ot=m(et,this.defaultValue.strings,ut),{other:gt,comments:Dt,strings:Ot}}}var We;(function(he){he[he.Off=0]="Off",he[he.On=1]="On",he[he.Relative=2]="Relative",he[he.Interval=3]="Interval",he[he.Custom=4]="Custom"})(We||(e.RenderLineNumbersType=We={}));class Se extends w{constructor(){super(je.lineNumbers,"lineNumbers",{renderType:We.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(11701,null),c.localize(11702,null),c.localize(11703,null),c.localize(11704,null)],default:"on",description:c.localize(11705,null)})}validate(x){let Ce=this.defaultValue.renderType,Xe=this.defaultValue.renderFn;return typeof x<"u"&&(typeof x=="function"?(Ce=We.Custom,Xe=x):x==="interval"?Ce=We.Interval:x==="relative"?Ce=We.Relative:x==="on"?Ce=We.On:Ce=We.Off),{renderType:Ce,renderFn:Xe}}}function De(he){const x=he.get(je.renderValidationDecorations);return x==="editable"?he.get(je.readOnly):x!=="on"}class Te extends w{constructor(){const x=[],Ce={type:"number",description:c.localize(11706,null)};super(je.rulers,"rulers",x,{type:"array",items:{anyOf:[Ce,{type:["object"],properties:{column:Ce,color:{type:"string",description:c.localize(11707,null),format:"color-hex"}}}]},default:x,description:c.localize(11708,null)})}validate(x){if(Array.isArray(x)){const Ce=[];for(const Xe of x)if(typeof Xe=="number")Ce.push({column:s.clampedInt(Xe,0,0,1e4),color:null});else if(Xe&&typeof Xe=="object"){const et=Xe;Ce.push({column:s.clampedInt(et.column,0,0,1e4),color:et.color})}return Ce.sort((Xe,et)=>Xe.column-et.column),Ce}return this.defaultValue}}class U extends w{constructor(){super(je.readOnlyMessage,"readOnlyMessage",void 0)}validate(x){return!x||typeof x!="object"?this.defaultValue:x}}function q(he,x){if(typeof he!="string")return x;switch(he){case"hidden":return T.ScrollbarVisibility.Hidden;case"visible":return T.ScrollbarVisibility.Visible;default:return T.ScrollbarVisibility.Auto}}class X extends w{constructor(){const x={vertical:T.ScrollbarVisibility.Auto,horizontal:T.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(je.scrollbar,"scrollbar",x,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(11709,null),c.localize(11710,null),c.localize(11711,null)],default:"auto",description:c.localize(11712,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(11713,null),c.localize(11714,null),c.localize(11715,null)],default:"auto",description:c.localize(11716,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:x.verticalScrollbarSize,description:c.localize(11717,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:x.horizontalScrollbarSize,description:c.localize(11718,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:x.scrollByPage,description:c.localize(11719,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:x.ignoreHorizontalScrollbarInContentHeight,description:c.localize(11720,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x,Xe=s.clampedInt(Ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),et=s.clampedInt(Ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:s.clampedInt(Ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:q(Ce.vertical,this.defaultValue.vertical),horizontal:q(Ce.horizontal,this.defaultValue.horizontal),useShadows:i(Ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(Ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(Ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(Ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(Ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Xe,horizontalSliderSize:s.clampedInt(Ce.horizontalSliderSize,Xe,0,1e3),verticalScrollbarSize:et,verticalSliderSize:s.clampedInt(Ce.verticalSliderSize,et,0,1e3),scrollByPage:i(Ce.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(Ce.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class _ extends w{constructor(){const x={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(je.unicodeHighlighting,"unicodeHighlight",x,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.nonBasicASCII,description:c.localize(11721,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:x.invisibleCharacters,description:c.localize(11722,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:x.ambiguousCharacters,description:c.localize(11723,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeComments,description:c.localize(11724,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeStrings,description:c.localize(11725,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:x.allowedCharacters,description:c.localize(11726,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:x.allowedLocales,description:c.localize(11727,null)}})}applyUpdate(x,Ce){let Xe=!1;Ce.allowedCharacters&&x&&(h.$eo(x.allowedCharacters,Ce.allowedCharacters)||(x={...x,allowedCharacters:Ce.allowedCharacters},Xe=!0)),Ce.allowedLocales&&x&&(h.$eo(x.allowedLocales,Ce.allowedLocales)||(x={...x,allowedLocales:Ce.allowedLocales},Xe=!0));const et=super.applyUpdate(x,Ce);return Xe?new a(et.newValue,!0):et}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return{nonBasicASCII:Ke(Ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(Ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(Ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ke(Ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ke(Ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(x.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(x.allowedLocales,this.defaultValue.allowedLocales)}}c(x,Ce){if(typeof x!="object"||!x)return Ce;const Xe={};for(const[et,ut]of Object.entries(x))ut===!0&&(Xe[et]=!0);return Xe}}class de extends w{constructor(){const x={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(je.inlineSuggest,"inlineSuggest",x,{"editor.inlineSuggest.enabled":{type:"boolean",default:x.enabled,description:c.localize(11728,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:x.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(11729,null),c.localize(11730,null),c.localize(11731,null)],description:c.localize(11732,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:x.suppressSuggestions,description:c.localize(11733,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:x.fontFamily,description:c.localize(11734,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return{enabled:i(Ce.enabled,this.defaultValue.enabled),mode:m(Ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:m(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(Ce.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(Ce.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:l.string(Ce.fontFamily,this.defaultValue.fontFamily)}}}class be extends w{constructor(){const x={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(je.inlineEdit,"experimentalInlineEdit",x,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:x.enabled,description:c.localize(11735,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:x.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(11736,null),c.localize(11737,null),c.localize(11738,null)],description:c.localize(11739,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:x.fontFamily,description:c.localize(11740,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:x.backgroundColoring,description:c.localize(11741,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return{enabled:i(Ce.enabled,this.defaultValue.enabled),showToolbar:m(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:l.string(Ce.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(Ce.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:i(Ce.backgroundColoring,this.defaultValue.backgroundColoring)}}}class Ne extends w{constructor(){const x={enabled:R.$ht.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.$ht.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(je.bracketPairColorization,"bracketPairColorization",x,{"editor.bracketPairColorization.enabled":{type:"boolean",default:x.enabled,markdownDescription:c.localize(11742,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:x.independentColorPoolPerBracketType,description:c.localize(11743,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return{enabled:i(Ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(Ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ge extends w{constructor(){const x={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(je.guides,"guides",x,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(11744,null),c.localize(11745,null),c.localize(11746,null)],default:x.bracketPairs,description:c.localize(11747,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(11748,null),c.localize(11749,null),c.localize(11750,null)],default:x.bracketPairsHorizontal,description:c.localize(11751,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:x.highlightActiveBracketPair,description:c.localize(11752,null)},"editor.guides.indentation":{type:"boolean",default:x.indentation,description:c.localize(11753,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[c.localize(11754,null),c.localize(11755,null),c.localize(11756,null)],default:x.highlightActiveIndentation,description:c.localize(11757,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return{bracketPairs:Ke(Ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ke(Ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(Ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(Ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ke(Ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ke(he,x,Ce){const Xe=Ce.indexOf(he);return Xe===-1?x:Ce[Xe]}class tt extends w{constructor(){const x={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(je.suggest,"suggest",x,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(11758,null),c.localize(11759,null)],default:x.insertMode,description:c.localize(11760,null)},"editor.suggest.filterGraceful":{type:"boolean",default:x.filterGraceful,description:c.localize(11761,null)},"editor.suggest.localityBonus":{type:"boolean",default:x.localityBonus,description:c.localize(11762,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:x.shareSuggestSelections,markdownDescription:c.localize(11763,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[c.localize(11764,null),c.localize(11765,null),c.localize(11766,null),c.localize(11767,null)],default:x.selectionMode,markdownDescription:c.localize(11768,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:x.snippetsPreventQuickSuggestions,description:c.localize(11769,null)},"editor.suggest.showIcons":{type:"boolean",default:x.showIcons,description:c.localize(11770,null)},"editor.suggest.showStatusBar":{type:"boolean",default:x.showStatusBar,description:c.localize(11771,null)},"editor.suggest.preview":{type:"boolean",default:x.preview,description:c.localize(11772,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:x.showInlineDetails,description:c.localize(11773,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(11774,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(11775,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(11776,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(11777,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(11778,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(11779,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:c.localize(11780,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(11781,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(11782,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(11783,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(11784,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(11785,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(11786,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(11787,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(11788,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(11789,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(11790,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(11791,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(11792,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(11793,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(11794,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(11795,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(11796,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(11797,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(11798,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(11799,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(11800,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(11801,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(11802,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(11803,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(11804,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(11805,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return{insertMode:m(Ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(Ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(Ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(Ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(Ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:m(Ce.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(Ce.showIcons,this.defaultValue.showIcons),showStatusBar:i(Ce.showStatusBar,this.defaultValue.showStatusBar),preview:i(Ce.preview,this.defaultValue.preview),previewMode:m(Ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(Ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(Ce.showMethods,this.defaultValue.showMethods),showFunctions:i(Ce.showFunctions,this.defaultValue.showFunctions),showConstructors:i(Ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(Ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(Ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(Ce.showFields,this.defaultValue.showFields),showVariables:i(Ce.showVariables,this.defaultValue.showVariables),showClasses:i(Ce.showClasses,this.defaultValue.showClasses),showStructs:i(Ce.showStructs,this.defaultValue.showStructs),showInterfaces:i(Ce.showInterfaces,this.defaultValue.showInterfaces),showModules:i(Ce.showModules,this.defaultValue.showModules),showProperties:i(Ce.showProperties,this.defaultValue.showProperties),showEvents:i(Ce.showEvents,this.defaultValue.showEvents),showOperators:i(Ce.showOperators,this.defaultValue.showOperators),showUnits:i(Ce.showUnits,this.defaultValue.showUnits),showValues:i(Ce.showValues,this.defaultValue.showValues),showConstants:i(Ce.showConstants,this.defaultValue.showConstants),showEnums:i(Ce.showEnums,this.defaultValue.showEnums),showEnumMembers:i(Ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(Ce.showKeywords,this.defaultValue.showKeywords),showWords:i(Ce.showWords,this.defaultValue.showWords),showColors:i(Ce.showColors,this.defaultValue.showColors),showFiles:i(Ce.showFiles,this.defaultValue.showFiles),showReferences:i(Ce.showReferences,this.defaultValue.showReferences),showFolders:i(Ce.showFolders,this.defaultValue.showFolders),showTypeParameters:i(Ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(Ce.showSnippets,this.defaultValue.showSnippets),showUsers:i(Ce.showUsers,this.defaultValue.showUsers),showIssues:i(Ce.showIssues,this.defaultValue.showIssues)}}}class rt extends w{constructor(){super(je.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(11806,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:c.localize(11807,null),default:!0,type:"boolean"}})}validate(x){return!x||typeof x!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(x.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(x.selectSubwords,this.defaultValue.selectSubwords)}}}class ot extends w{constructor(){const x=[];super(je.wordSegmenterLocales,"wordSegmenterLocales",x,{anyOf:[{description:c.localize(11808,null),type:"string"},{description:c.localize(11809,null),type:"array",items:{type:"string"}}]})}validate(x){if(typeof x=="string"&&(x=[x]),Array.isArray(x)){const Ce=[];for(const Xe of x)if(typeof Xe=="string")try{Intl.Segmenter.supportedLocalesOf(Xe).length>0&&Ce.push(Xe)}catch{}return Ce}return this.defaultValue}}var nt;(function(he){he[he.None=0]="None",he[he.Same=1]="Same",he[he.Indent=2]="Indent",he[he.DeepIndent=3]="DeepIndent"})(nt||(e.WrappingIndent=nt={}));class at extends w{constructor(){super(je.wrappingIndent,"wrappingIndent",nt.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[c.localize(11810,null),c.localize(11811,null),c.localize(11812,null),c.localize(11813,null)],description:c.localize(11814,null),default:"same"}})}validate(x){switch(x){case"none":return nt.None;case"same":return nt.Same;case"indent":return nt.Indent;case"deepIndent":return nt.DeepIndent}return nt.Same}compute(x,Ce,Xe){return Ce.get(je.accessibilitySupport)===I.AccessibilitySupport.Enabled?nt.None:Xe}}class mt extends f{constructor(){super(je.wrappingInfo)}compute(x,Ce,Xe){const et=Ce.get(je.layoutInfo);return{isDominatedByLongLines:x.isDominatedByLongLines,isWordWrapMinified:et.isWordWrapMinified,isViewportWrapping:et.isViewportWrapping,wrappingColumn:et.wrappingColumn}}}class ht extends w{constructor(){const x={enabled:!0,showDropSelector:"afterDrop"};super(je.dropIntoEditor,"dropIntoEditor",x,{"editor.dropIntoEditor.enabled":{type:"boolean",default:x.enabled,markdownDescription:c.localize(11815,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:c.localize(11816,null),enum:["afterDrop","never"],enumDescriptions:[c.localize(11817,null),c.localize(11818,null)],default:"afterDrop"}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return{enabled:i(Ce.enabled,this.defaultValue.enabled),showDropSelector:m(Ce.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ct extends w{constructor(){const x={enabled:!0,showPasteSelector:"afterPaste"};super(je.pasteAs,"pasteAs",x,{"editor.pasteAs.enabled":{type:"boolean",default:x.enabled,markdownDescription:c.localize(11819,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:c.localize(11820,null),enum:["afterPaste","never"],enumDescriptions:[c.localize(11821,null),c.localize(11822,null)],default:"afterPaste"}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const Ce=x;return{enabled:i(Ce.enabled,this.defaultValue.enabled),showPasteSelector:m(Ce.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Pe="Consolas, 'Courier New', monospace",ze="Menlo, Monaco, 'Courier New', monospace",He="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$k?ze:C.$l?He:Pe,fontWeight:"normal",fontSize:C.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Oe(he){return e.editorOptionsRegistry[he.id]=he,he}var je;(function(he){he[he.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",he[he.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",he[he.accessibilitySupport=2]="accessibilitySupport",he[he.accessibilityPageSize=3]="accessibilityPageSize",he[he.ariaLabel=4]="ariaLabel",he[he.ariaRequired=5]="ariaRequired",he[he.autoClosingBrackets=6]="autoClosingBrackets",he[he.autoClosingComments=7]="autoClosingComments",he[he.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",he[he.autoClosingDelete=9]="autoClosingDelete",he[he.autoClosingOvertype=10]="autoClosingOvertype",he[he.autoClosingQuotes=11]="autoClosingQuotes",he[he.autoIndent=12]="autoIndent",he[he.automaticLayout=13]="automaticLayout",he[he.autoSurround=14]="autoSurround",he[he.bracketPairColorization=15]="bracketPairColorization",he[he.guides=16]="guides",he[he.codeLens=17]="codeLens",he[he.codeLensFontFamily=18]="codeLensFontFamily",he[he.codeLensFontSize=19]="codeLensFontSize",he[he.colorDecorators=20]="colorDecorators",he[he.colorDecoratorsLimit=21]="colorDecoratorsLimit",he[he.columnSelection=22]="columnSelection",he[he.comments=23]="comments",he[he.contextmenu=24]="contextmenu",he[he.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",he[he.cursorBlinking=26]="cursorBlinking",he[he.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",he[he.cursorStyle=28]="cursorStyle",he[he.cursorSurroundingLines=29]="cursorSurroundingLines",he[he.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",he[he.cursorWidth=31]="cursorWidth",he[he.disableLayerHinting=32]="disableLayerHinting",he[he.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",he[he.domReadOnly=34]="domReadOnly",he[he.dragAndDrop=35]="dragAndDrop",he[he.dropIntoEditor=36]="dropIntoEditor",he[he.emptySelectionClipboard=37]="emptySelectionClipboard",he[he.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",he[he.extraEditorClassName=39]="extraEditorClassName",he[he.fastScrollSensitivity=40]="fastScrollSensitivity",he[he.find=41]="find",he[he.fixedOverflowWidgets=42]="fixedOverflowWidgets",he[he.folding=43]="folding",he[he.foldingStrategy=44]="foldingStrategy",he[he.foldingHighlight=45]="foldingHighlight",he[he.foldingImportsByDefault=46]="foldingImportsByDefault",he[he.foldingMaximumRegions=47]="foldingMaximumRegions",he[he.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",he[he.fontFamily=49]="fontFamily",he[he.fontInfo=50]="fontInfo",he[he.fontLigatures=51]="fontLigatures",he[he.fontSize=52]="fontSize",he[he.fontWeight=53]="fontWeight",he[he.fontVariations=54]="fontVariations",he[he.formatOnPaste=55]="formatOnPaste",he[he.formatOnType=56]="formatOnType",he[he.glyphMargin=57]="glyphMargin",he[he.gotoLocation=58]="gotoLocation",he[he.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",he[he.hover=60]="hover",he[he.inDiffEditor=61]="inDiffEditor",he[he.inlineSuggest=62]="inlineSuggest",he[he.inlineEdit=63]="inlineEdit",he[he.letterSpacing=64]="letterSpacing",he[he.lightbulb=65]="lightbulb",he[he.lineDecorationsWidth=66]="lineDecorationsWidth",he[he.lineHeight=67]="lineHeight",he[he.lineNumbers=68]="lineNumbers",he[he.lineNumbersMinChars=69]="lineNumbersMinChars",he[he.linkedEditing=70]="linkedEditing",he[he.links=71]="links",he[he.matchBrackets=72]="matchBrackets",he[he.minimap=73]="minimap",he[he.mouseStyle=74]="mouseStyle",he[he.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",he[he.mouseWheelZoom=76]="mouseWheelZoom",he[he.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",he[he.multiCursorModifier=78]="multiCursorModifier",he[he.multiCursorPaste=79]="multiCursorPaste",he[he.multiCursorLimit=80]="multiCursorLimit",he[he.occurrencesHighlight=81]="occurrencesHighlight",he[he.overviewRulerBorder=82]="overviewRulerBorder",he[he.overviewRulerLanes=83]="overviewRulerLanes",he[he.padding=84]="padding",he[he.pasteAs=85]="pasteAs",he[he.parameterHints=86]="parameterHints",he[he.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",he[he.placeholder=88]="placeholder",he[he.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",he[he.quickSuggestions=90]="quickSuggestions",he[he.quickSuggestionsDelay=91]="quickSuggestionsDelay",he[he.readOnly=92]="readOnly",he[he.readOnlyMessage=93]="readOnlyMessage",he[he.renameOnType=94]="renameOnType",he[he.renderControlCharacters=95]="renderControlCharacters",he[he.renderFinalNewline=96]="renderFinalNewline",he[he.renderLineHighlight=97]="renderLineHighlight",he[he.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",he[he.renderValidationDecorations=99]="renderValidationDecorations",he[he.renderWhitespace=100]="renderWhitespace",he[he.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",he[he.roundedSelection=102]="roundedSelection",he[he.rulers=103]="rulers",he[he.scrollbar=104]="scrollbar",he[he.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",he[he.scrollBeyondLastLine=106]="scrollBeyondLastLine",he[he.scrollPredominantAxis=107]="scrollPredominantAxis",he[he.selectionClipboard=108]="selectionClipboard",he[he.selectionHighlight=109]="selectionHighlight",he[he.selectOnLineNumbers=110]="selectOnLineNumbers",he[he.showFoldingControls=111]="showFoldingControls",he[he.showUnused=112]="showUnused",he[he.snippetSuggestions=113]="snippetSuggestions",he[he.smartSelect=114]="smartSelect",he[he.smoothScrolling=115]="smoothScrolling",he[he.stickyScroll=116]="stickyScroll",he[he.stickyTabStops=117]="stickyTabStops",he[he.stopRenderingLineAfter=118]="stopRenderingLineAfter",he[he.suggest=119]="suggest",he[he.suggestFontSize=120]="suggestFontSize",he[he.suggestLineHeight=121]="suggestLineHeight",he[he.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",he[he.suggestSelection=123]="suggestSelection",he[he.tabCompletion=124]="tabCompletion",he[he.tabIndex=125]="tabIndex",he[he.unicodeHighlighting=126]="unicodeHighlighting",he[he.unusualLineTerminators=127]="unusualLineTerminators",he[he.useShadowDOM=128]="useShadowDOM",he[he.useTabStops=129]="useTabStops",he[he.wordBreak=130]="wordBreak",he[he.wordSegmenterLocales=131]="wordSegmenterLocales",he[he.wordSeparators=132]="wordSeparators",he[he.wordWrap=133]="wordWrap",he[he.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",he[he.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",he[he.wordWrapColumn=136]="wordWrapColumn",he[he.wordWrapOverride1=137]="wordWrapOverride1",he[he.wordWrapOverride2=138]="wordWrapOverride2",he[he.wrappingIndent=139]="wrappingIndent",he[he.wrappingStrategy=140]="wrappingStrategy",he[he.showDeprecated=141]="showDeprecated",he[he.inlayHints=142]="inlayHints",he[he.editorClassName=143]="editorClassName",he[he.pixelRatio=144]="pixelRatio",he[he.tabFocusMode=145]="tabFocusMode",he[he.layoutInfo=146]="layoutInfo",he[he.wrappingInfo=147]="wrappingInfo",he[he.defaultColorDecorators=148]="defaultColorDecorators",he[he.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",he[he.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(je||(e.EditorOption=je={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Oe(new o(je.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(11823,null)})),acceptSuggestionOnEnter:Oe(new E(je.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(11824,null),""],markdownDescription:c.localize(11825,null)})),accessibilitySupport:Oe(new k),accessibilityPageSize:Oe(new s(je.accessibilityPageSize,"accessibilityPageSize",10,1,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(11826,null),tags:["accessibility"]})),ariaLabel:Oe(new l(je.ariaLabel,"ariaLabel",c.localize(11827,null))),ariaRequired:Oe(new o(je.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Oe(new o(je.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:c.localize(11828,null),tags:["accessibility"]})),autoClosingBrackets:Oe(new E(je.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(11829,null),c.localize(11830,null),""],description:c.localize(11831,null)})),autoClosingComments:Oe(new E(je.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(11832,null),c.localize(11833,null),""],description:c.localize(11834,null)})),autoClosingDelete:Oe(new E(je.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(11835,null),""],description:c.localize(11836,null)})),autoClosingOvertype:Oe(new E(je.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(11837,null),""],description:c.localize(11838,null)})),autoClosingQuotes:Oe(new E(je.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(11839,null),c.localize(11840,null),""],description:c.localize(11841,null)})),autoIndent:Oe(new S(je.autoIndent,"autoIndent",D.Full,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[c.localize(11842,null),c.localize(11843,null),c.localize(11844,null),c.localize(11845,null),c.localize(11846,null)],description:c.localize(11847,null)})),automaticLayout:Oe(new o(je.automaticLayout,"automaticLayout",!1)),autoSurround:Oe(new E(je.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(11848,null),c.localize(11849,null),c.localize(11850,null),""],description:c.localize(11851,null)})),bracketPairColorization:Oe(new Ne),bracketPairGuides:Oe(new Ge),stickyTabStops:Oe(new o(je.stickyTabStops,"stickyTabStops",!1,{description:c.localize(11852,null)})),codeLens:Oe(new o(je.codeLens,"codeLens",!0,{description:c.localize(11853,null)})),codeLensFontFamily:Oe(new l(je.codeLensFontFamily,"codeLensFontFamily","",{description:c.localize(11854,null)})),codeLensFontSize:Oe(new s(je.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(11855,null)})),colorDecorators:Oe(new o(je.colorDecorators,"colorDecorators",!0,{description:c.localize(11856,null)})),colorDecoratorActivatedOn:Oe(new E(je.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[c.localize(11857,null),c.localize(11858,null),c.localize(11859,null)],description:c.localize(11860,null)})),colorDecoratorsLimit:Oe(new s(je.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:c.localize(11861,null)})),columnSelection:Oe(new o(je.columnSelection,"columnSelection",!1,{description:c.localize(11862,null)})),comments:Oe(new A),contextmenu:Oe(new o(je.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:Oe(new o(je.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:c.localize(11863,null)})),cursorBlinking:Oe(new S(je.cursorBlinking,"cursorBlinking",p.Blink,"blink",["blink","smooth","phase","expand","solid"],v,{description:c.localize(11864,null)})),cursorSmoothCaretAnimation:Oe(new E(je.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[c.localize(11865,null),c.localize(11866,null),c.localize(11867,null)],description:c.localize(11868,null)})),cursorStyle:Oe(new S(je.cursorStyle,"cursorStyle",F.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],O,{description:c.localize(11869,null)})),cursorSurroundingLines:Oe(new s(je.cursorSurroundingLines,"cursorSurroundingLines",0,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(11870,null)})),cursorSurroundingLinesStyle:Oe(new E(je.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(11871,null),c.localize(11872,null)],markdownDescription:c.localize(11873,null)})),cursorWidth:Oe(new s(je.cursorWidth,"cursorWidth",0,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(11874,null)})),disableLayerHinting:Oe(new o(je.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:Oe(new o(je.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:Oe(new o(je.domReadOnly,"domReadOnly",!1)),dragAndDrop:Oe(new o(je.dragAndDrop,"dragAndDrop",!0,{description:c.localize(11875,null)})),emptySelectionClipboard:Oe(new z),dropIntoEditor:Oe(new ht),stickyScroll:Oe(new W),experimentalWhitespaceRendering:Oe(new E(je.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[c.localize(11876,null),c.localize(11877,null),c.localize(11878,null)],description:c.localize(11879,null)})),extraEditorClassName:Oe(new l(je.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:Oe(new d(je.fastScrollSensitivity,"fastScrollSensitivity",5,he=>he<=0?5:he,{markdownDescription:c.localize(11880,null)})),find:Oe(new M),fixedOverflowWidgets:Oe(new o(je.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:Oe(new o(je.folding,"folding",!0,{description:c.localize(11881,null)})),foldingStrategy:Oe(new E(je.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(11882,null),c.localize(11883,null)],description:c.localize(11884,null)})),foldingHighlight:Oe(new o(je.foldingHighlight,"foldingHighlight",!0,{description:c.localize(11885,null)})),foldingImportsByDefault:Oe(new o(je.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:c.localize(11886,null)})),foldingMaximumRegions:Oe(new s(je.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:c.localize(11887,null)})),unfoldOnClickAfterEndOfLine:Oe(new o(je.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(11888,null)})),fontFamily:Oe(new l(je.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(11889,null)})),fontInfo:Oe(new ne),fontLigatures2:Oe(new V),fontSize:Oe(new B),fontWeight:Oe(new G),fontVariations:Oe(new K),formatOnPaste:Oe(new o(je.formatOnPaste,"formatOnPaste",!1,{description:c.localize(11890,null)})),formatOnType:Oe(new o(je.formatOnType,"formatOnType",!1,{description:c.localize(11891,null)})),glyphMargin:Oe(new o(je.glyphMargin,"glyphMargin",!0,{description:c.localize(11892,null)})),gotoLocation:Oe(new Y),hideCursorInOverviewRuler:Oe(new o(je.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:c.localize(11893,null)})),hover:Oe(new ee),inDiffEditor:Oe(new o(je.inDiffEditor,"inDiffEditor",!1)),letterSpacing:Oe(new d(je.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,he=>d.clamp(he,-5,20),{description:c.localize(11894,null)})),lightbulb:Oe(new J),lineDecorationsWidth:Oe(new ae),lineHeight:Oe(new te),lineNumbers:Oe(new Se),lineNumbersMinChars:Oe(new s(je.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:Oe(new o(je.linkedEditing,"linkedEditing",!1,{description:c.localize(11895,null)})),links:Oe(new o(je.links,"links",!0,{description:c.localize(11896,null)})),matchBrackets:Oe(new E(je.matchBrackets,"matchBrackets","always",["always","near","never"],{description:c.localize(11897,null)})),minimap:Oe(new ce),mouseStyle:Oe(new E(je.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Oe(new d(je.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,he=>he===0?1:he,{markdownDescription:c.localize(11898,null)})),mouseWheelZoom:Oe(new o(je.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:C.$k?c.localize(11899,null):c.localize(11900,null)})),multiCursorMergeOverlapping:Oe(new o(je.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:c.localize(11901,null)})),multiCursorModifier:Oe(new S(je.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],le,{markdownEnumDescriptions:[c.localize(11902,null),c.localize(11903,null)],markdownDescription:c.localize(11904,null)})),multiCursorPaste:Oe(new E(je.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(11905,null),c.localize(11906,null)],markdownDescription:c.localize(11907,null)})),multiCursorLimit:Oe(new s(je.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:c.localize(11908,null)})),occurrencesHighlight:Oe(new E(je.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[c.localize(11909,null),c.localize(11910,null),c.localize(11911,null)],markdownDescription:c.localize(11912,null)})),overviewRulerBorder:Oe(new o(je.overviewRulerBorder,"overviewRulerBorder",!0,{description:c.localize(11913,null)})),overviewRulerLanes:Oe(new s(je.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:Oe(new Z),pasteAs:Oe(new ct),parameterHints:Oe(new oe),peekWidgetDefaultFocus:Oe(new E(je.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(11914,null),c.localize(11915,null)],description:c.localize(11916,null)})),placeholder:Oe(new we),definitionLinkOpensInPeek:Oe(new o(je.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:c.localize(11917,null)})),quickSuggestions:Oe(new Fe),quickSuggestionsDelay:Oe(new s(je.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(11918,null)})),readOnly:Oe(new o(je.readOnly,"readOnly",!1)),readOnlyMessage:Oe(new U),renameOnType:Oe(new o(je.renameOnType,"renameOnType",!1,{description:c.localize(11919,null),markdownDeprecationMessage:c.localize(11920,null)})),renderControlCharacters:Oe(new o(je.renderControlCharacters,"renderControlCharacters",!0,{description:c.localize(11921,null),restricted:!0})),renderFinalNewline:Oe(new E(je.renderFinalNewline,"renderFinalNewline",C.$l?"dimmed":"on",["off","on","dimmed"],{description:c.localize(11922,null)})),renderLineHighlight:Oe(new E(je.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(11923,null)],description:c.localize(11924,null)})),renderLineHighlightOnlyWhenFocus:Oe(new o(je.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(11925,null)})),renderValidationDecorations:Oe(new E(je.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Oe(new E(je.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(11926,null),c.localize(11927,null),c.localize(11928,null),""],description:c.localize(11929,null)})),revealHorizontalRightPadding:Oe(new s(je.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Oe(new o(je.roundedSelection,"roundedSelection",!0,{description:c.localize(11930,null)})),rulers:Oe(new Te),scrollbar:Oe(new X),scrollBeyondLastColumn:Oe(new s(je.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(11931,null)})),scrollBeyondLastLine:Oe(new o(je.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:c.localize(11932,null)})),scrollPredominantAxis:Oe(new o(je.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:c.localize(11933,null)})),selectionClipboard:Oe(new o(je.selectionClipboard,"selectionClipboard",!0,{description:c.localize(11934,null),included:C.$l})),selectionHighlight:Oe(new o(je.selectionHighlight,"selectionHighlight",!0,{description:c.localize(11935,null)})),selectOnLineNumbers:Oe(new o(je.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:Oe(new E(je.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[c.localize(11936,null),c.localize(11937,null),c.localize(11938,null)],description:c.localize(11939,null)})),showUnused:Oe(new o(je.showUnused,"showUnused",!0,{description:c.localize(11940,null)})),showDeprecated:Oe(new o(je.showDeprecated,"showDeprecated",!0,{description:c.localize(11941,null)})),inlayHints:Oe(new se),snippetSuggestions:Oe(new E(je.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(11942,null),c.localize(11943,null),c.localize(11944,null),c.localize(11945,null)],description:c.localize(11946,null)})),smartSelect:Oe(new rt),smoothScrolling:Oe(new o(je.smoothScrolling,"smoothScrolling",!1,{description:c.localize(11947,null)})),stopRenderingLineAfter:Oe(new s(je.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,L.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:Oe(new tt),inlineSuggest:Oe(new de),inlineEdit:Oe(new be),inlineCompletionsAccessibilityVerbose:Oe(new o(je.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:c.localize(11948,null)})),suggestFontSize:Oe(new s(je.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(11949,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Oe(new s(je.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(11950,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Oe(new o(je.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:c.localize(11951,null)})),suggestSelection:Oe(new E(je.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(11952,null),c.localize(11953,null),c.localize(11954,null)],description:c.localize(11955,null)})),tabCompletion:Oe(new E(je.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(11956,null),c.localize(11957,null),c.localize(11958,null)],description:c.localize(11959,null)})),tabIndex:Oe(new s(je.tabIndex,"tabIndex",0,-1,L.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:Oe(new _),unusualLineTerminators:Oe(new E(je.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(11960,null),c.localize(11961,null),c.localize(11962,null)],description:c.localize(11963,null)})),useShadowDOM:Oe(new o(je.useShadowDOM,"useShadowDOM",!0)),useTabStops:Oe(new o(je.useTabStops,"useTabStops",!0,{description:c.localize(11964,null)})),wordBreak:Oe(new E(je.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[c.localize(11965,null),c.localize(11966,null)],description:c.localize(11967,null)})),wordSegmenterLocales:Oe(new ot),wordSeparators:Oe(new l(je.wordSeparators,"wordSeparators",b.$it,{description:c.localize(11968,null)})),wordWrap:Oe(new E(je.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(11969,null),c.localize(11970,null),c.localize(11971,null),c.localize(11972,null)],description:c.localize(11973,null)})),wordWrapBreakAfterCharacters:Oe(new l(je.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Oe(new l(je.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Oe(new s(je.wordWrapColumn,"wordWrapColumn",80,1,L.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(11974,null)})),wordWrapOverride1:Oe(new E(je.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Oe(new E(je.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Oe(new j),defaultColorDecorators:Oe(new o(je.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:c.localize(11975,null)})),pixelRatio:Oe(new pe),tabFocusMode:Oe(new o(je.tabFocusMode,"tabFocusMode",!1,{markdownDescription:c.localize(11976,null)})),layoutInfo:Oe(new re),wrappingInfo:Oe(new mt),wrappingIndent:Oe(new at),wrappingStrategy:Oe(new ye)}});var zt=this&&this.__importDefault||function(me){return me&&me.__esModule?me:{default:me}};define(ke[215],Ie([1,0,22,43,8,5,107,10,24]),function(me,e,r,h,C,T,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$7w=e.$6w=e.$5w=void 0,e.$8w=P,e.$9w=w,h=zt(h),e.$5w=(0,T.$Ci)("dialogService");var c;(function(a){a[a.Confirmation=1]="Confirmation",a[a.Prompt=2]="Prompt",a[a.Input=3]="Input"})(c||(c={}));class I{a($){return this.d($,c.Confirmation)}b($){return this.d($,c.Prompt)}c($){return this.d($,c.Input)}d($,f){const g=[];switch(f){case c.Confirmation:{const i=$;i.primaryButton?g.push(i.primaryButton):g.push((0,C.localize)(11409,null)),i.cancelButton?g.push(i.cancelButton):g.push((0,C.localize)(11410,null));break}case c.Prompt:{const i=$;Array.isArray(i.buttons)&&i.buttons.length>0&&g.push(...i.buttons.map(o=>o.label)),i.cancelButton&&(i.cancelButton===!0?g.push((0,C.localize)(11411,null)):typeof i.cancelButton=="string"?g.push(i.cancelButton):i.cancelButton.label?g.push(i.cancelButton.label):g.push((0,C.localize)(11412,null))),g.length===0&&g.push((0,C.localize)(11413,null));break}case c.Input:{const i=$;i.primaryButton?g.push(i.primaryButton):g.push((0,C.localize)(11414,null)),i.cancelButton?g.push(i.cancelButton):g.push((0,C.localize)(11415,null));break}}return g}e($){if(typeof $=="string")return $;if(typeof $=="number")return $===h.default.Info?"info":$===h.default.Error?"error":$===h.default.Warning?"warning":"none"}f($,f,g){const i=[...$.buttons??[]];$.cancelButton&&typeof $.cancelButton!="string"&&typeof $.cancelButton!="boolean"&&i.push($.cancelButton);let o=i[f]?.run({checkboxChecked:g});return o instanceof Promise||(o=Promise.resolve(o)),{result:o,checkboxChecked:g}}}e.$6w=I,e.$7w=(0,T.$Ci)("fileDialogService");var D;(function(a){a[a.SAVE=0]="SAVE",a[a.DONT_SAVE=1]="DONT_SAVE",a[a.CANCEL=2]="CANCEL"})(D||(e.ConfirmResult=D={}));const u=10;function P(a){const $=[];return $.push(...a.slice(0,u).map(f=>typeof f=="string"?f:(0,r.$ah)(f))),a.length>u&&(a.length-u===1?$.push((0,C.localize)(11416,null)):$.push((0,C.localize)(11417,null,a.length-u))),$.push(""),$.join(`
`)}function w(a,$){const f=(0,b.$ao)(a);let g=(f.buttons??[]).map(s=>(0,L.$2w)(s)),i=(a.buttons||[]).map((s,n)=>n),o=0,t=f.cancelId??g.length-1;if(g.length>1){const s=typeof t=="number"?g[t]:void 0;if(R.$l||R.$k){if(typeof s=="string"&&g.length>1&&t!==1){g.splice(t,1),g.splice(1,0,s);const n=i[t];i.splice(t,1),i.splice(1,0,n),t=1}R.$l&&g.length>1&&(g=g.reverse(),i=i.reverse(),o=g.length-1,typeof s=="string"&&(t=o-1))}else if(R.$j&&typeof s=="string"&&g.length>1&&t!==g.length-1){g.splice(t,1),g.push(s);const n=i[t];i.splice(t,1),i.push(n),t=g.length-1}}return f.buttons=g,f.defaultId=o,f.cancelId=t,f.noLink=!0,f.title=f.title||$.nameLong,{options:f,buttonIndeces:i}}}),define(ke[144],Ie([1,0,5]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=void 0,e.$Ji=(0,r.$Ci)("environmentService"),e.$Ki=(0,r.$Di)(e.$Ji)}),define(ke[216],Ie([1,0,5]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q9b=e.$P9b=void 0,e.$P9b=(0,r.$Ci)("externalTerminal"),e.$Q9b="Terminal.app"}),define(ke[217],Ie([1,0,56,59,14,16,10,104,33,109,8,216]),function(me,e,r,h,C,T,L,R,b,c,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efc=e.$Dfc=e.$Cfc=void 0,r=Ue(r),T=Ue(T),L=Ue(L),b=Ue(b),c=Ue(c),I=Ue(I);const u=I.localize(11260,null);class P{async getDefaultTerminalForPlatforms(){return{windows:w.getDefaultTerminalWindows(),linux:await $.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class w extends P{static{this.b="cmd.exe"}openTerminal(t,s){return this.spawnTerminal(r,t,c.$um(),s)}spawnTerminal(t,s,n,d){const l=s.windowsExec||w.getDefaultTerminalWindows();d&&d[1]===":"&&(d=d[0].toUpperCase()+d.substr(1));const m=T.$mc(l,".exe").toLowerCase();if(m==="cmder")return t.spawn(l,d?[d]:void 0),Promise.resolve(void 0);const E=["/c","start","/wait"];return l.indexOf(" ")>=0&&E.push('""'),E.push(l),m==="wt"&&E.push("-d ."),new Promise((S,y)=>{const k=f(process),A=t.spawn(n,E,{cwd:d,env:k,detached:!0});A.on("error",y),A.on("exit",()=>S())})}async runInTerminal(t,s,n,d,l){const m="windowsExec"in l&&l.windowsExec?l.windowsExec:w.getDefaultTerminalWindows(),E=await w.f();return new Promise((S,y)=>{const k=`"${s} - ${u}"`,A=`"${n.join('" "')}" & pause`,p=Object.assign({},f(process),d);Object.keys(p).filter(j=>p[j]===null).forEach(j=>delete p[j]);const v={cwd:s,env:p,windowsVerbatimArguments:!0};let F,N;T.$mc(m,".exe")==="wt"?(F=m,N=["-d",".",w.b,"/c",A]):E?(F=E,N=["-d",".",m,"/c",A]):(F=w.b,N=["/c","start",k,"/wait",m,"/c",`"${A}"`]),r.spawn(F,N,v).on("error",j=>{y(g(j))}),S(void 0)})}static getDefaultTerminalWindows(){if(!w.d){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");w.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return w.d}static async f(){try{const t=await c.win32.findExecutable("wt");return await b.Promises.exists(t)?t:void 0}catch{return}}}e.$Cfc=w,Ye([h.$7h],w,"f",null);class a extends P{static{this.b="/usr/bin/osascript"}openTerminal(t,s){return this.spawnTerminal(r,t,s)}runInTerminal(t,s,n,d,l){const m=l.osxExec||D.$Q9b;return new Promise((E,S)=>{if(m===D.$Q9b||m==="iTerm.app"){const y=m===D.$Q9b?"TerminalHelper":"iTermHelper",A=[C.$Wg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${y}.scpt`).fsPath,"-t",t||u,"-w",s];for(const F of n)A.push("-a"),A.push(F);if(d){const F=Object.assign({},f(process),d);for(const N in F){const O=F[N];O===null?(A.push("-u"),A.push(N)):(A.push("-e"),A.push(`${N}=${O}`))}}let p="";const v=r.spawn(a.b,A);v.on("error",F=>{S(g(F))}),v.stderr.on("data",F=>{p+=F.toString()}),v.on("exit",F=>{if(F===0)E(void 0);else if(p){const N=p.split(`
`,1);S(new Error(N[0]))}else S(new Error(I.localize(11261,null,y,F)))})}else S(new Error(I.localize(11262,null,m)))})}spawnTerminal(t,s,n){const d=s.osxExec||D.$Q9b;return new Promise((l,m)=>{const E=["-a",d];n&&E.push(n);const S=f(process),y=t.spawn("/usr/bin/open",E,{cwd:n,env:S});y.on("error",m),y.on("exit",()=>l())})}}e.$Dfc=a;class $ extends P{static{this.b=I.localize(11263,null)}openTerminal(t,s){return this.spawnTerminal(r,t,s)}runInTerminal(t,s,n,d,l){const m=l.linuxExec?Promise.resolve(l.linuxExec):$.getDefaultTerminalLinuxReady();return new Promise((E,S)=>{const y=[];m.then(k=>{k.indexOf("gnome-terminal")>=0?y.push("-x"):y.push("-e"),y.push("bash"),y.push("-c");const A=`${i(n)}; echo; read -p "${$.b}" -n1;`;y.push(`''${A}''`);const p=Object.assign({},f(process),d);Object.keys(p).filter(O=>p[O]===null).forEach(O=>delete p[O]);const v={cwd:s,env:p};let F="";const N=r.spawn(k,y,v);N.on("error",O=>{S(g(O))}),N.stderr.on("data",O=>{F+=O.toString()}),N.on("exit",O=>{if(O===0)E(void 0);else if(F){const j=F.split(`
`,1);S(new Error(j[0]))}else S(new Error(I.localize(11264,null,k,O)))})})})}static async getDefaultTerminalLinuxReady(){if(!$.d)if(!L.$l)$.d=Promise.resolve("xterm");else{const t=await b.Promises.exists("/etc/debian_version");$.d=new Promise(s=>{t?s("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?s("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?s("konsole"):process.env.COLORTERM?s(process.env.COLORTERM):process.env.TERM?s(process.env.TERM):s("xterm")})}return $.d}spawnTerminal(t,s,n){const d=s.linuxExec?Promise.resolve(s.linuxExec):$.getDefaultTerminalLinuxReady();return new Promise((l,m)=>{d.then(E=>{const S=f(process),y=t.spawn(E,[],{cwd:n,env:S});y.on("error",m),y.on("exit",()=>l())})})}}e.$Efc=$;function f(o){const t={...o.env};return(0,R.$hm)(t),t}function g(o){return"errno"in o&&o.errno==="ENOENT"&&"path"in o&&typeof o.path=="string"?new Error(I.localize(11265,null,o.path)):o}function i(o){let t="";for(const s of o)s.indexOf(" ")>=0?t+='"'+s+'"':t+=s,t+=" ";return t}}),define(ke[27],Ie([1,0,84,16,12,17,2,8,5,10,14,49]),function(me,e,r,h,C,T,L,R,b,c,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.$Bl=e.FileKind=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.FileOperationResult=e.$tl=e.$sl=e.$rl=e.$pl=e.FileChangeType=e.$ol=e.FileOperation=e.$il=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$9k=void 0,e.$0k=u,e.$$k=$,e.$_k=g,e.$al=i,e.$bl=o,e.$cl=t,e.$dl=s,e.$el=n,e.$fl=d,e.$gl=l,e.$hl=m,e.$jl=y,e.$kl=k,e.$ll=A,e.$ml=p,e.$nl=v,e.$ql=z,e.$Cl=G,e.$Dl=Y,e.$Fl=ue,e.$9k=(0,b.$Ci)("fileService");function u(re){return re.create===!0}var P;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(P||(e.FileType=P={}));var w;(function(re){re[re.Readonly=1]="Readonly",re[re.Locked=2]="Locked"})(w||(e.FilePermission=w={}));var a;(function(re){re[re.UPDATED=2]="UPDATED",re[re.ADDED=4]="ADDED",re[re.DELETED=8]="DELETED"})(a||(e.FileChangeFilter=a={}));function $(re){const ye=re;return!!ye&&typeof ye.onDidChange=="function"}var f;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileAtomicWrite=32768]="FileAtomicWrite",re[re.FileAtomicDelete=65536]="FileAtomicDelete",re[re.FileClone=131072]="FileClone"})(f||(e.FileSystemProviderCapabilities=f={}));function g(re){return!!(re.capabilities&f.FileReadWrite)}function i(re){return!!(re.capabilities&f.FileFolderCopy)}function o(re){return!!(re.capabilities&f.FileClone)}function t(re){return!!(re.capabilities&f.FileOpenReadWriteClose)}function s(re){return!!(re.capabilities&f.FileReadStream)}function n(re){return g(re)?!!(re.capabilities&f.FileAtomicRead):!1}function d(re){return g(re)?!!(re.capabilities&f.FileAtomicWrite):!1}function l(re){return!!(re.capabilities&f.FileAtomicDelete)}function m(re){return!!(re.capabilities&f.Readonly)}var E;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsStorageQuota="EntryExceedsStorageQuota",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(E||(e.FileSystemProviderErrorCode=E={}));class S extends Error{static create(ye,$e){const J=new S(ye.toString(),$e);return A(J,$e),J}constructor(ye,$e){super(ye),this.code=$e}}e.$il=S;function y(re,ye){return S.create(re,ye)}function k(re){return re||y((0,R.localize)(11219,null),E.Unknown)}function A(re,ye){return re.name=ye?`${ye} (FileSystemError)`:"FileSystemError",re}function p(re){if(!re)return E.Unknown;if(re instanceof S)return re.code;const ye=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!ye)return E.Unknown;switch(ye[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}function v(re){if(re instanceof M)return re.fileOperationResult;switch(p(re)){case E.FileNotFound:return ne.FILE_NOT_FOUND;case E.FileIsADirectory:return ne.FILE_IS_DIRECTORY;case E.FileNotADirectory:return ne.FILE_NOT_DIRECTORY;case E.FileWriteLocked:return ne.FILE_WRITE_LOCKED;case E.NoPermissions:return ne.FILE_PERMISSION_DENIED;case E.FileExists:return ne.FILE_MOVE_CONFLICT;case E.FileTooLarge:return ne.FILE_TOO_LARGE;default:return ne.FILE_OTHER_ERROR}}var F;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(F||(e.FileOperation=F={}));class N{constructor(ye,$e,J){this.resource=ye,this.operation=$e,this.target=J}isOperation(ye){return this.operation===ye}}e.$ol=N;var O;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(O||(e.FileChangeType=O={}));class j{static{this.a=null}constructor(ye,$e){this.c=$e,this.b=void 0,this.d=new D.$T(()=>{const J=r.$Ii.forUris(()=>this.c);return J.fill(this.rawAdded.map(W=>[W,!0])),J}),this.f=new D.$T(()=>{const J=r.$Ii.forUris(()=>this.c);return J.fill(this.rawUpdated.map(W=>[W,!0])),J}),this.g=new D.$T(()=>{const J=r.$Ii.forUris(()=>this.c);return J.fill(this.rawDeleted.map(W=>[W,!0])),J}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const J of ye){switch(J.type){case O.ADDED:this.rawAdded.push(J.resource);break;case O.UPDATED:this.rawUpdated.push(J.resource);break;case O.DELETED:this.rawDeleted.push(J.resource);break}this.b!==j.a&&(typeof J.cId=="number"?this.b===void 0?this.b=J.cId:this.b!==J.cId&&(this.b=j.a):this.b!==void 0&&(this.b=j.a))}}contains(ye,...$e){return this.h(ye,{includeChildren:!1},...$e)}affects(ye,...$e){return this.h(ye,{includeChildren:!0},...$e)}h(ye,$e,...J){if(!ye)return!1;const W=J.length>0;return!!((!W||J.includes(O.ADDED))&&(this.d.value.get(ye)||$e.includeChildren&&this.d.value.findSuperstr(ye))||(!W||J.includes(O.UPDATED))&&(this.f.value.get(ye)||$e.includeChildren&&this.f.value.findSuperstr(ye))||(!W||J.includes(O.DELETED))&&(this.g.value.findSubstr(ye)||$e.includeChildren&&this.g.value.findSuperstr(ye)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ye){return this.b===ye}hasCorrelation(){return typeof this.b=="number"}}e.$pl=j;function z(re,ye,$e){return!re||!ye||re===ye||ye.length>re.length?!1:(ye.charAt(ye.length-1)!==h.sep&&(ye+=h.sep),$e?(0,C.$Ef)(re,ye):re.indexOf(ye)===0)}class M extends Error{constructor(ye,$e,J){super(ye),this.fileOperationResult=$e,this.options=J}}e.$rl=M;class V extends M{constructor(ye,$e,J,W){super(ye,$e,W),this.fileOperationResult=$e,this.size=J}}e.$sl=V;class K extends M{constructor(ye,$e,J){super(ye,ne.FILE_NOT_MODIFIED_SINCE,J),this.stat=$e}}e.$tl=K;var ne;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ne||(e.FileOperationResult=ne={})),e.$ul={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$vl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$wl="files.associations",e.$xl="files.exclude",e.$yl="files.readonlyInclude",e.$zl="files.readonlyExclude",e.$Al="files.readonlyFromPermissions";var B;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(B||(e.FileKind=B={})),e.$Bl="";function G(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}async function Y(re,ye){if(!ye.hasProvider(L.URI.from({scheme:re.scheme})))return new Promise($e=>{const J=ye.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===re.scheme&&W.added&&(J.dispose(),$e())})})}class ee{static{this.KB=1024}static{this.MB=ee.KB*ee.KB}static{this.GB=ee.MB*ee.KB}static{this.TB=ee.GB*ee.KB}static formatSize(ye){return(0,T.$gg)(ye)||(ye=0),ye<ee.KB?(0,R.localize)(11220,null,ye.toFixed(0)):ye<ee.MB?(0,R.localize)(11221,null,(ye/ee.KB).toFixed(2)):ye<ee.GB?(0,R.localize)(11222,null,(ye/ee.MB).toFixed(2)):ye<ee.TB?(0,R.localize)(11223,null,(ye/ee.GB).toFixed(2)):(0,R.localize)(11224,null,(ye/ee.TB).toFixed(2))}}e.$El=ee;function ue(re){const ye=typeof re=="string"||re?.scheme===I.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===I.Schemas.file?1024*ee.MB:ye?10*ee.MB:c.$p?50*ee.MB:1024*ee.MB}}),define(ke[218],Ie([1,0,21,13,8,27]),function(me,e,r,h,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=L;async function L(I,D,u,P,w,a){let $;try{await R(I,D,u,P,w,a)}catch(f){$=f}finally{$&&w.errorTransformer&&($=w.errorTransformer($)),typeof $<"u"&&u.error($),u.end()}}async function R(I,D,u,P,w,a){b(a);const $=await I.open(D,{create:!1});try{b(a);let f=0,g=0,i=w&&typeof w.length=="number"?w.length:void 0,o=r.$Le.alloc(Math.min(w.bufferSize,typeof i=="number"?i:w.bufferSize)),t=w&&typeof w.position=="number"?w.position:0,s=0;do g=await I.read($,t,o.buffer,s,o.byteLength-s),t+=g,s+=g,f+=g,typeof i=="number"&&(i-=g),s===o.byteLength&&(await u.write(P(o)),o=r.$Le.alloc(Math.min(w.bufferSize,typeof i=="number"?i:w.bufferSize)),s=0);while(g>0&&(typeof i!="number"||i>0)&&b(a)&&c(f,w));if(s>0){let n=s;typeof i=="number"&&(n=Math.min(s,i)),u.write(P(o.slice(0,n)))}}catch(f){throw(0,T.$kl)(f)}finally{await I.close($)}}function b(I){if(I.isCancellationRequested)throw(0,h.$5)();return!0}function c(I,D){if(typeof D?.limits?.size=="number"&&I>D.limits.size)throw(0,T.$jl)((0,C.localize)(11218,null),T.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[69],Ie([1,0,38,3,16,10,2,27]),function(me,e,r,h,C,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=e.$3q=e.$2q=void 0,e.$Zq=b,e.$1q=c,e.$5q=P,e.$6q=w,e.$7q=a,e.$8q=$,e.$9q=g,e.$0q=i;function b(o){return typeof o.correlationId=="number"}function c(o){return o.recursive===!0}class I extends h.$Tc{static{this.a=5}constructor(t,s,n,d){super(),this.h=t,this.j=s,this.m=n,this.n=d,this.c=this.B(new h.$Uc),this.f=void 0,this.g=0}s(){const t=new h.$Sc;this.c.value=t,this.b=this.r(t),this.b.setVerboseLogging(this.m),t.add(this.b.onDidChangeFile(s=>this.h(s))),t.add(this.b.onDidLogMessage(s=>this.j(s))),t.add(this.b.onDidError(s=>this.t(s.error,s.request)))}t(t,s){this.u(t,s)?this.g<I.a&&this.f?(this.y(`restarting watcher after unexpected error: ${t}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${t}`):this.y(t)}u(t,s){return!(!this.n.restartOnError||s||t.indexOf("No space left on device")!==-1||t.indexOf("EMFILE")!==-1)}w(t){this.g++,this.s(),this.watch(t)}async watch(t){this.f=t,await this.b?.watch(t)}async setVerboseLogging(t){this.m=t,await this.b?.setVerboseLogging(t)}y(t){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${t}`})}z(t){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${t}`})}dispose(){return this.b=void 0,super.dispose()}}e.$2q=I;class D extends I{constructor(t,s,n){super(t,s,n,{type:"node.js",restartOnError:!1})}}e.$3q=D;class u extends I{constructor(t,s,n){super(t,s,n,{type:"universal",restartOnError:!0})}}e.$4q=u;function P(o){return o.map(t=>({type:t.type,resource:L.URI.revive(t.resource),cId:t.cId}))}function w(o){const t=new f;for(const s of o)t.processEvent(s);return t.coalesce()}function a(o,t){return typeof t=="string"&&!t.startsWith(r.$sk)&&!(0,C.$hc)(t)?{base:o,pattern:t}:t}function $(o,t){const s=[];for(const n of t)s.push((0,r.$wk)(a(o,n)));return s}class f{constructor(){this.a=new Set,this.b=new Map}c(t){return T.$l?t.resource.fsPath:t.resource.fsPath.toLowerCase()}processEvent(t){const s=this.b.get(this.c(t));let n=!1;if(s){const d=s.type,l=t.type;s.resource.fsPath!==t.resource.fsPath&&(t.type===R.FileChangeType.DELETED||t.type===R.FileChangeType.ADDED)?n=!0:d===R.FileChangeType.ADDED&&l===R.FileChangeType.DELETED?(this.b.delete(this.c(t)),this.a.delete(s)):d===R.FileChangeType.DELETED&&l===R.FileChangeType.ADDED?s.type=R.FileChangeType.UPDATED:d===R.FileChangeType.ADDED&&l===R.FileChangeType.UPDATED||(s.type=l)}else n=!0;n&&(this.a.add(t),this.b.set(this.c(t),t))}coalesce(){const t=[],s=[];return Array.from(this.a).filter(n=>n.type!==R.FileChangeType.DELETED?(t.push(n),!1):!0).sort((n,d)=>n.resource.fsPath.length-d.resource.fsPath.length).filter(n=>s.some(d=>(0,R.$ql)(n.resource.fsPath,d,!T.$l))?!1:(s.push(n.resource.fsPath),!0)).concat(t)}}function g(o,t){if(typeof t=="number")switch(o.type){case R.FileChangeType.ADDED:return(t&R.FileChangeFilter.ADDED)===0;case R.FileChangeType.DELETED:return(t&R.FileChangeFilter.DELETED)===0;case R.FileChangeType.UPDATED:return(t&R.FileChangeFilter.UPDATED)===0}return!1}function i(o){if(typeof o=="number"){const t=[];return o&R.FileChangeFilter.ADDED&&t.push("Added"),o&R.FileChangeFilter.DELETED&&t.push("Deleted"),o&R.FileChangeFilter.UPDATED&&t.push("Updated"),t.length===0?"<all>":`[${t.join(", ")}]`}return"<none>"}}),define(ke[219],Ie([1,0,44,3,69,4,27,2,7]),function(me,e,r,h,C,T,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=void 0;class c extends h.$Tc{constructor(){super(),this.a=this.B(new T.$je),this.onDidChangeFile=this.a.event,this.b=this.B(new T.$je),this.onDidLogMessage=this.b.event,this.c=this.B(new T.$je),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new h.$3c),this.m=new Set,this.n=this.B(new b.$Ah(this.y())),this.r=5007,this.s=new b.$Zh,this.R=!1,this.B(this.f(D=>this.t(D)))}t(D){this.u(D)&&this.z(D)}u(D){return(0,C.$Zq)(D)}async watch(D){this.s.isSettled||this.s.complete(),this.s=new b.$Zh;try{this.h.clear(),this.g.clear();for(const u of D)this.u(u)?this.h.set(u.correlationId,u):this.g.add(u);for(const[u]of this.j)this.h.has(u)||(this.j.deleteAndDispose(u),this.m.delete(u));return await this.w(!1)}finally{this.s.complete()}}w(D){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(u=>!this.j.has(u.correlationId))]),D?this.y():0)}y(){return 800}isSuspended(D){return typeof D.correlationId!="number"?!1:this.m.has(D.correlationId)?"polling":this.j.has(D.correlationId)}async z(D){if(this.j.has(D.correlationId))return;const u=new h.$Sc;this.j.set(D.correlationId,u),await this.s.p,!u.isDisposed&&(this.D(D,u),this.w(!0))}C(D){this.j.deleteAndDispose(D.correlationId),this.m.delete(D.correlationId),this.w(!1)}D(D,u){this.F(D,u)?(this.P(`reusing an existing recursive watcher to monitor ${D.path}`),this.m.delete(D.correlationId)):(this.G(D,u),this.m.add(D.correlationId))}F(D,u){const P=this.O?.subscribe(D.path,(w,a)=>{u.isDisposed||(w?this.D(D,u):a?.type===L.FileChangeType.ADDED&&this.H(D))});return P?(u.add(P),!0):!1}G(D,u){let P=!1;const w=(a,$)=>{if(u.isDisposed)return;const f=this.I(a),g=this.I($),i=P;P=f,!f&&(g||i)&&this.H(D)};this.P(`starting fs.watchFile() on ${D.path} (correlationId: ${D.correlationId})`);try{(0,r.watchFile)(D.path,{persistent:!1,interval:this.r},w)}catch(a){this.Q(`fs.watchFile() failed with error ${a} on path ${D.path} (correlationId: ${D.correlationId})`)}u.add((0,h.$Rc)(()=>{this.P(`stopping fs.watchFile() on ${D.path} (correlationId: ${D.correlationId})`);try{(0,r.unwatchFile)(D.path,w)}catch(a){this.Q(`fs.unwatchFile() failed with error ${a} on path ${D.path} (correlationId: ${D.correlationId})`)}}))}H(D){this.P(`detected ${D.path} exists again, resuming watcher (correlationId: ${D.correlationId})`);const u={resource:R.URI.file(D.path),type:L.FileChangeType.ADDED,cId:D.correlationId};this.a.fire([u]),this.J(u,D),this.C(D)}I(D){return D.ctimeMs===0&&D.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(D,u){if(this.R){const P=` >> normalized ${D.type===L.FileChangeType.ADDED?"[ADDED]":D.type===L.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${D.resource.fsPath}`;this.L(P,u)}}L(D,u){this.R&&this.P(`${D}${typeof u.correlationId=="number"?` <${u.correlationId}> `:""}`)}M(D){return`${D.path} (excludes: ${D.excludes.length>0?D.excludes:"<none>"}, includes: ${D.includes&&D.includes.length>0?JSON.stringify(D.includes):"<all>"}, filter: ${(0,C.$0q)(D.filter)}, correlationId: ${typeof D.correlationId=="number"?D.correlationId:"<none>"})`}async setVerboseLogging(D){this.R=D}}e.$gr=c}),define(ke[220],Ie([1,0,44,7,20,31,3,81,16,10,22,2,108,33,27,69]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=void 0,e.$mr=f;class $ extends L.$Tc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(i,o,t,s,n,d){super(),this.s=i,this.t=o,this.u=t,this.w=s,this.y=n,this.z=d,this.c=this.B(new h.$Rh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},l=>this.u(l))),this.f=this.B(new h.$Qh(l=>this.M(l),$.b)),this.g=(0,a.$8q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,a.$8q)(this.s.path,this.s.includes):void 0,this.j=(0,a.$Zq)(this.s)?this.s.filter:void 0,this.m=new C.$ue,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const i=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const o=await r.promises.stat(i);if(this.m.token.isCancellationRequested)return;this.B(await this.G(i,o.isDirectory()))}catch(i){i.code!=="ENOENT"?this.O(i):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${i})`),this.D()}}D(){this.r=!0,this.w?.()}async F(i){let o=i.path;try{o=await P.Promises.realpath(i.path),i.path===o&&(o=await(0,u.$ir)(i.path,this.m.token)??i.path),i.path!==o&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${o})`)}catch{}return o}async G(i,o){const t=new L.$Sc;return this.H(i,o,t)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(i,o,t)),t}H(i,o,t){if(o)return!1;const s=D.URI.file(this.s.path),n=this.t?.subscribe(this.s.path,async(d,l)=>{if(!t.isDisposed)if(d){const m=await this.G(i,o);t.isDisposed?m.dispose():t.add(m)}else l&&(typeof l.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:s,type:l.type,cId:this.s.correlationId},!0)});return n?(t.add(n),!0):!1}async I(i,o,t){if(c.$k&&(0,T.$Bg)(i,"/Volumes/",!0)){this.O(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const s=new C.$ue(this.m.token);t.add((0,L.$Rc)(()=>s.dispose(!0)));const n=new L.$Sc;t.add(n);try{const d=D.URI.file(this.s.path),l=(0,b.$mc)(i),m=(0,r.watch)(i);n.add((0,L.$Rc)(()=>{m.removeAllListeners(),m.close()})),this.Q(`Started watching: '${i}'`);const E=new Set;if(o)try{for(const y of await P.Promises.readdir(i))E.add(y)}catch(y){this.O(y)}if(s.token.isCancellationRequested)return;const S=new Map;n.add((0,L.$Rc)(()=>{for(const[,y]of S)y.dispose();S.clear()})),m.on("error",(y,k)=>{s.token.isCancellationRequested||(this.O(`Failed to watch ${i} for changes using fs.watch() (${y}, ${k})`),this.D())}),m.on("change",(y,k)=>{if(s.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${y}"] ${k}`);let A="";if(k&&(A=k.toString(),c.$k&&(A=(0,R.$jm)(A))),!(!A||y!=="change"&&y!=="rename"))if(o)if(y==="rename"){S.get(A)?.dispose();const p=setTimeout(async()=>{if(S.delete(A),A===l&&!await P.Promises.exists(i)){this.J(d);return}if(s.token.isCancellationRequested)return;const v=await this.N((0,b.$ic)(i,A));if(s.token.isCancellationRequested)return;let F;v?E.has(A)?F=w.FileChangeType.UPDATED:(F=w.FileChangeType.ADDED,E.add(A)):(E.delete(A),F=w.FileChangeType.DELETED),this.L({resource:(0,I.$dh)(d,A),type:F,cId:this.s.correlationId})},$.a);S.set(A,(0,L.$Rc)(()=>clearTimeout(p)))}else{let p;E.has(A)?p=w.FileChangeType.UPDATED:(p=w.FileChangeType.ADDED,E.add(A)),this.L({resource:(0,I.$dh)(d,A),type:p,cId:this.s.correlationId})}else if(y==="rename"||A!==l){const p=setTimeout(async()=>{const v=await P.Promises.exists(i);s.token.isCancellationRequested||(v?(this.L({resource:d,type:w.FileChangeType.UPDATED,cId:this.s.correlationId},!0),n.add(await this.G(i,!1))):this.J(d))},$.a);n.clear(),n.add((0,L.$Rc)(()=>clearTimeout(p)))}else this.L({resource:d,type:w.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(d){s.token.isCancellationRequested||this.O(`Failed to watch ${i} for changes using fs.watch() (${d.toString()})`),this.D()}}J(i){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:i,type:w.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(i,o=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${i.type===w.FileChangeType.ADDED?"[ADDED]":i.type===w.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!o&&this.g.some(t=>t(i.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${i.resource.fsPath}`):!o&&this.h&&this.h.length>0&&!this.h.some(t=>t(i.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}M(i){const o=(0,a.$6q)(i),t=[];for(const n of o){if((0,a.$9q)(n,this.j)){this.z&&this.R(` >> ignored (filtered) ${n.resource.fsPath}`);continue}t.push(n)}if(t.length===0)return;if(this.z)for(const n of t)this.R(` >> normalized ${n.type===w.FileChangeType.ADDED?"[ADDED]":n.type===w.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`);this.c.work(t)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${t.length}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(i){if(c.$l)return P.Promises.exists(i);try{const o=(0,b.$mc)(i);return(await P.Promises.readdir((0,b.$lc)(i))).some(s=>s===o)}catch(o){return this.Q(o),!1}}setVerboseLogging(i){this.z=i}O(i){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}P(i){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}Q(i){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}R(i){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${i}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$lr=$;async function f(g,i,o,t,s=512){const n=await P.Promises.open(g,"r"),d=Buffer.allocUnsafe(s),l=new C.$ue(t);let m,E=!1;const S={path:g,excludes:[],recursive:!1},y=new $(S,void 0,k=>{(async()=>{for(const{type:A}of k)if(A===w.FileChangeType.UPDATED){if(E)return;E=!0;try{for(;!l.token.isCancellationRequested;){const{bytesRead:p}=await P.Promises.read(n,d,0,s,null);if(!p||l.token.isCancellationRequested)break;i(d.slice(0,p))}}catch(p){m=new Error(p),l.dispose(!0)}finally{E=!1}}})()});return await y.ready,o(),new Promise((k,A)=>{l.token.onCancellationRequested(async()=>{y.dispose();try{await P.Promises.close(n)}catch(p){m=new Error(p)}m?A(m):k()})})}}),define(ke[221],Ie([1,0,4,38,219,10,220,31]),function(me,e,r,h,C,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=void 0;class b extends C.$gr{constructor(I){super(),this.O=I,this.onDidError=r.Event.None,this.watchers=new Set}async N(I){I=this.Z(I);const D=[],u=new Set(Array.from(this.watchers));for(const P of I){const w=this.W(P);w&&(0,h.$Ak)(w.request.excludes,P.excludes)&&(0,h.$Ak)(w.request.includes,P.includes)?u.delete(w):D.push(P)}D.length&&this.P(`Request to start watching: ${D.map(P=>this.M(P)).join(",")}`),u.size&&this.P(`Request to stop watching: ${Array.from(u).map(P=>this.M(P.request)).join(",")}`);for(const P of u)this.Y(P);for(const P of D)this.X(P)}W(I){for(const D of this.watchers)if(typeof I.correlationId=="number"||typeof D.request.correlationId=="number"){if(D.request.correlationId===I.correlationId)return D}else if((0,R.$Ag)(D.request.path,I.path,!T.$l))return D}X(I){const D=new L.$lr(I,this.O,P=>this.a.fire(P),()=>this.c.fire(I),P=>this.b.fire(P),this.R),u={request:I,instance:D};this.watchers.add(u)}async stop(){await super.stop();for(const I of this.watchers)this.Y(I)}Y(I){this.P("stopping file watcher",I),this.watchers.delete(I),I.instance.dispose()}Z(I){const D=new Map;for(const u of I){const P=T.$l?u.path:u.path.toLowerCase();let w=D.get(u.correlationId);w||(w=new Map,D.set(u.correlationId,w)),w.has(P)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(u)}`),w.set(P,u)}return Array.from(D.values()).map(u=>Array.from(u.values())).flat()}async setVerboseLogging(I){super.setVerboseLogging(I);for(const D of this.watchers)D.instance.setVerboseLogging(I)}P(I,D){this.R&&this.b.fire({type:"trace",message:this.bb(I,D)})}Q(I){this.b.fire({type:"warn",message:this.bb(I)})}bb(I,D){return D?`[File Watcher (node.js)] ${I} (${this.M(D.request)})`:`[File Watcher (node.js)] ${I}`}}e.$nr=b}),define(ke[222],Ie([1,0,69,221]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;class C extends r.$3q{constructor(L,R,b){super(L,R,b),this.s()}r(L){return L.add(new h.$nr(void 0))}}e.$or=C}),define(ke[223],Ie([1,0,14,86,191,69]),function(me,e,r,h,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=void 0;class L extends T.$4q{constructor(b,c,I){super(b,c,I),this.s()}r(b){const c=b.add(new C.$er(r.$Wg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(c.onDidProcessExit(({code:I,signal:D})=>this.t(`terminated by itself with code ${I}, signal: ${D} (ETERM)`))),h.ProxyChannel.toService((0,h.$ji)(c.getChannel("watcher")))}}e.$fr=L}),define(ke[114],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=void 0;class r{constructor(...C){this.a=new Map;for(const[T,L]of C)this.set(T,L)}set(C,T){const L=this.a.get(C);return this.a.set(C,T),L}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$Ai=r}),define(ke[224],Ie([1,0,7,13,3,112,213,5,114,80]),function(me,e,r,h,C,T,L,R,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=e.$sr=void 0;const I=!1;class D extends Error{constructor($){super("cyclic dependency between services"),this.message=$.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${$.toString()}`}}class u{constructor($=new b.$Ai,f=!1,g,i=I){this.i=$,this.j=f,this.k=g,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(R.$Bi,this),this._globalGraph=i?g?._globalGraph??new L.$rr(o=>o):void 0}dispose(){if(!this.f){this.f=!0,(0,C.$Oc)(this.h),this.h.clear();for(const $ of this.g)(0,C.$Nc)($)&&$.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild($,f){this.m();const g=this,i=new class extends u{dispose(){g.h.delete(i),super.dispose()}}($,this.j,this,this.l);return this.h.add(i),f?.add(i),i}invokeFunction($,...f){this.m();const g=w.traceInvocation(this.l,$);let i=!1;try{return $({get:t=>{if(i)throw(0,h.$7)("service accessor is only valid during the invocation of its target method");const s=this.s(t,g);if(!s)throw new Error(`[invokeFunction] unknown service '${t}'`);return s}},...f)}finally{i=!0,g.stop()}}createInstance($,...f){this.m();let g,i;return $ instanceof T.$zi?(g=w.traceCreation(this.l,$.ctor),i=this.o($.ctor,$.staticArguments.concat(f),g)):(g=w.traceCreation(this.l,$),i=this.o($,f,g)),g.stop(),i}o($,f=[],g){const i=R._util.getServiceDependencies($).sort((s,n)=>s.index-n.index),o=[];for(const s of i){const n=this.s(s.id,g);n||this.y(`[createInstance] ${$.name} depends on UNKNOWN service ${s.id}.`,!1),o.push(n)}const t=i.length>0?i[0].index:f.length;if(f.length!==t){console.trace(`[createInstance] First service dependency of ${$.name} at position ${t+1} conflicts with ${f.length} static arguments`);const s=t-f.length;s>0?f=f.concat(new Array(s)):f=f.slice(0,t)}return Reflect.construct($,f.concat(o))}q($,f){if(this.i.get($)instanceof T.$zi)this.i.set($,f);else if(this.k)this.k.q($,f);else throw new Error("illegalState - setting UNKNOWN service instance")}r($){const f=this.i.get($);return!f&&this.k?this.k.r($):f}s($,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String($));const g=this.r($);return g instanceof T.$zi?this.u($,g,f.branch($,!0)):(f.branch($,!1),g)}u($,f,g){if(this.t.has($))throw new Error(`illegal state - RECURSIVELY instantiating service '${$}'`);this.t.add($);try{return this.v($,f,g)}finally{this.t.delete($)}}v($,f,g){const i=new L.$rr(n=>n.id.toString());let o=0;const t=[{id:$,desc:f,_trace:g}],s=new Set;for(;t.length;){const n=t.pop();if(!s.has(String(n.id))){if(s.add(String(n.id)),i.lookupOrInsertNode(n),o++>1e3)throw new D(i);for(const d of R._util.getServiceDependencies(n.desc.ctor)){const l=this.r(d.id);if(l||this.y(`[createInstance] ${$} depends on ${d.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(d.id)),l instanceof T.$zi){const m={id:d.id,desc:l,_trace:n._trace.branch(d.id,!0)};i.insertEdge(n,m),t.push(m)}}}}for(;;){const n=i.roots();if(n.length===0){if(!i.isEmpty())throw new D(i);break}for(const{data:d}of n){if(this.r(d.id)instanceof T.$zi){const m=this.w(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this.q(d.id,m)}i.removeNode(d)}}return this.r($)}w($,f,g=[],i,o){if(this.i.get($)instanceof T.$zi)return this.x($,f,g,i,o,this.g);if(this.k)return this.k.w($,f,g,i,o);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}x($,f,g=[],i,o,t){if(i){const s=new u(void 0,this.j,this,this.l);s.c=String($);const n=new Map,d=new r.$Vh(()=>{const l=s.o(f,g,o);for(const[m,E]of n){const S=l[m];if(typeof S=="function")for(const y of E)y.disposable=S.apply(l,y.listener)}return n.clear(),t.add(l),l});return new Proxy(Object.create(null),{get(l,m){if(!d.isInitialized&&typeof m=="string"&&(m.startsWith("onDid")||m.startsWith("onWill"))){let y=n.get(m);return y||(y=new c.$4c,n.set(m,y)),(A,p,v)=>{if(d.isInitialized)return d.value[m](A,p,v);{const F={listener:[A,p,v],disposable:void 0},N=y.push(F);return(0,C.$Rc)(()=>{N(),F.disposable?.dispose()})}}}if(m in l)return l[m];const E=d.value;let S=E[m];return typeof S!="function"||(S=S.bind(E),l[m]=S),S},set(l,m,E){return d.value[m]=E,!0},getPrototypeOf(l){return f.prototype}})}else{const s=this.o(f,g,o);return t.add(s),s}}y($,f){if(f&&console.warn($),this.j)throw new Error($)}}e.$sr=u;var P;(function(a){a[a.None=0]="None",a[a.Creation=1]="Creation",a[a.Invocation=2]="Invocation",a[a.Branch=3]="Branch"})(P||(P={}));class w{static{this.all=new Set}static{this.c=new class extends w{constructor(){super(P.None,null)}stop(){}branch(){return this}}}static traceInvocation($,f){return $?new w(P.Invocation,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w.c}static traceCreation($,f){return $?new w(P.Creation,f.name):w.c}static{this.f=0}constructor($,f){this.type=$,this.name=f,this.g=Date.now(),this.h=[]}branch($,f){const g=new w(P.Branch,$.toString());return this.h.push([$,f,g]),g}stop(){const $=Date.now()-this.g;w.f+=$;let f=!1;function g(o,t){const s=[],n=new Array(o+1).join("	");for(const[d,l,m]of t.h)if(l&&m){f=!0,s.push(`${n}CREATES -> ${d}`);const E=g(o+1,m);E&&s.push(E)}else s.push(`${n}uses -> ${d}`);return s.join(`
`)}const i=[`${this.type===P.Creation?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${$.toFixed(2)}ms (grand total ${w.f.toFixed(2)}ms)`];($>2||f)&&w.all.add(i.join(`
`))}}e.$tr=w}),define(ke[11],Ie([1,0,8,52,4,60,3,28,10,22,17,2,35,5]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$_j=e.LogLevel=e.$0j=e.$9j=void 0,e.$$j=a,e.log=f,e.$kk=S,e.$lk=y,e.$mk=k,e.$nk=A,r=Ue(r),e.$9j=(0,P.$Ci)("logService"),e.$0j=(0,P.$Ci)("loggerService");function w(){return new Date().toISOString()}function a(p){return(0,I.$gg)(p)}var $;(function(p){p[p.Off=0]="Off",p[p.Trace=1]="Trace",p[p.Debug=2]="Debug",p[p.Info=3]="Info",p[p.Warning=4]="Warning",p[p.Error=5]="Error"})($||(e.LogLevel=$={})),e.$_j=$.Info;function f(p,v,F){switch(v){case $.Trace:p.trace(F);break;case $.Debug:p.debug(F);break;case $.Info:p.info(F);break;case $.Warning:p.warn(F);break;case $.Error:p.error(F);break;case $.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function g(p,v=!1){let F="";for(let N=0;N<p.length;N++){let O=p[N];if(O instanceof Error&&(O=(0,h.$nj)(O,v)),typeof O=="object")try{O=JSON.stringify(O)}catch{}F+=(N>0?" ":"")+O}return F}class i extends L.$Tc{constructor(){super(...arguments),this.b=e.$_j,this.c=this.B(new C.$je),this.onDidChangeLogLevel=this.c.event}setLevel(v){this.b!==v&&(this.b=v,this.c.fire(this.b))}getLevel(){return this.b}f(v){return this.b!==$.Off&&this.b<=v}}e.$bk=i;class o extends i{constructor(v){super(),this.h=v}f(v){return this.h||super.f(v)}trace(v,...F){this.f($.Trace)&&this.g($.Trace,g([v,...F],!0))}debug(v,...F){this.f($.Debug)&&this.g($.Debug,g([v,...F]))}info(v,...F){this.f($.Info)&&this.g($.Info,g([v,...F]))}warn(v,...F){this.f($.Warning)&&this.g($.Warning,g([v,...F]))}error(v,...F){if(this.f($.Error))if(v instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=v.stack,this.g($.Error,g(N))}else this.g($.Error,g([v,...F]))}flush(){}}e.$ck=o;class t extends i{constructor(v=e.$_j){super(),this.setLevel(v),this.g=!b.$j}trace(v,...F){this.f($.Trace)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,v,...F):console.log(`[main ${w()}]`,v,...F))}debug(v,...F){this.f($.Debug)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,v,...F):console.log(`[main ${w()}]`,v,...F))}info(v,...F){this.f($.Info)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,v,...F):console.log(`[main ${w()}]`,v,...F))}warn(v,...F){this.f($.Warning)&&(this.g?console.warn(`\x1B[93m[main ${w()}]\x1B[0m`,v,...F):console.warn(`[main ${w()}]`,v,...F))}error(v,...F){this.f($.Error)&&(this.g?console.error(`\x1B[91m[main ${w()}]\x1B[0m`,v,...F):console.error(`[main ${w()}]`,v,...F))}flush(){}}e.$dk=t;class s extends i{constructor(v=e.$_j,F=!0){super(),this.g=F,this.setLevel(v)}trace(v,...F){this.f($.Trace)&&(this.g?console.log("%cTRACE","color: #888",v,...F):console.log(v,...F))}debug(v,...F){this.f($.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",v,...F):console.log(v,...F))}info(v,...F){this.f($.Info)&&(this.g?console.log("%c INFO","color: #33f",v,...F):console.log(v,...F))}warn(v,...F){this.f($.Warning)&&(this.g?console.log("%c WARN","color: #993",v,...F):console.log(v,...F))}error(v,...F){this.f($.Error)&&(this.g?console.log("%c  ERR","color: #f33",v,...F):console.error(v,...F))}flush(){}}e.$ek=s;class n extends i{constructor(v,F=e.$_j){super(),this.g=v,this.setLevel(F)}trace(v,...F){this.f($.Trace)&&this.g.log($.Trace,[this.h(v),...F])}debug(v,...F){this.f($.Debug)&&this.g.log($.Debug,[this.h(v),...F])}info(v,...F){this.f($.Info)&&this.g.log($.Info,[this.h(v),...F])}warn(v,...F){this.f($.Warning)&&this.g.log($.Warning,[this.h(v),...F])}error(v,...F){this.f($.Error)&&this.g.log($.Error,[this.h(v),...F])}h(v){return typeof v=="string"?v:(0,h.$nj)(v,this.f($.Trace))}flush(){}}e.$fk=n;class d extends i{constructor(v){super(),this.g=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const F of this.g)F.setLevel(v);super.setLevel(v)}trace(v,...F){for(const N of this.g)N.trace(v,...F)}debug(v,...F){for(const N of this.g)N.debug(v,...F)}info(v,...F){for(const N of this.g)N.info(v,...F)}warn(v,...F){for(const N of this.g)N.warn(v,...F)}error(v,...F){for(const N of this.g)N.error(v,...F)}flush(){for(const v of this.g)v.flush()}dispose(){for(const v of this.g)v.dispose();super.dispose()}}e.$gk=d;class l extends L.$Tc{constructor(v,F,N){if(super(),this.h=v,this.j=F,this.b=new R.$zc,this.c=this.B(new C.$je),this.onDidChangeLoggers=this.c.event,this.f=this.B(new C.$je),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new C.$je),this.onDidChangeVisibility=this.g.event,N)for(const O of N)this.b.set(O.resource,{logger:void 0,info:O})}m(v){return(0,I.$cg)(v)?[...this.b.values()].find(F=>F.info.id===v):this.b.get(v)}getLogger(v){return this.m(v)?.logger}createLogger(v,F){const N=this.n(v),O=(0,I.$cg)(v)?v:F?.id??(0,T.$qj)(N.toString()).toString(16);let j=this.b.get(N)?.logger;const z=F?.logLevel==="always"?$.Trace:F?.logLevel;j||(j=this.s(N,z??this.getLogLevel(N)??this.h,{...F,id:O}));const M={logger:j,info:{resource:N,id:O,logLevel:z,name:F?.name,hidden:F?.hidden,extensionId:F?.extensionId,when:F?.when}};return this.registerLogger(M.info),this.b.set(N,M),j}n(v){return(0,I.$cg)(v)?(0,c.$dh)(this.j,`${v}.log`):v}setLogLevel(v,F){if(D.URI.isUri(v)){const N=v,O=F,j=this.b.get(N);j&&O!==j.info.logLevel&&(j.info.logLevel=O===this.h?void 0:O,j.logger?.setLevel(O),this.b.set(j.info.resource,j),this.f.fire([N,O]))}else{this.h=v;for(const[N,O]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&O.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(v,F){const N=this.m(v);N&&F!==!N.info.hidden&&(N.info.hidden=!F,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,F]))}getLogLevel(v){let F;return v&&(F=this.b.get(v)?.info.logLevel),F??this.h}registerLogger(v){const F=this.b.get(v.resource);F?F.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this.b.set(v.resource,{info:v,logger:void 0}),this.c.fire({added:[v],removed:[]}))}deregisterLogger(v){const F=this.b.get(v);F&&(F.logger&&F.logger.dispose(),this.b.delete(v),this.c.fire({added:[],removed:[F.info]}))}*getRegisteredLoggers(){for(const v of this.b.values())yield v.info}getRegisteredLogger(v){return this.b.get(v)?.info}dispose(){this.b.forEach(v=>v.logger?.dispose()),this.b.clear(),super.dispose()}}e.$hk=l;class m{constructor(){this.onDidChangeLogLevel=new C.$je().event}setLevel(v){}getLevel(){return $.Info}trace(v,...F){}debug(v,...F){}info(v,...F){}warn(v,...F){}error(v,...F){}critical(v,...F){}dispose(){}flush(){}}e.$ik=m;class E extends m{}e.$jk=E;function S(p){if(p.verbose)return $.Trace;if(typeof p.logLevel=="string"){const v=A(p.logLevel.toLowerCase());if(v!==void 0)return v}return e.$_j}function y(p){switch(p){case $.Trace:return"trace";case $.Debug:return"debug";case $.Info:return"info";case $.Warning:return"warn";case $.Error:return"error";case $.Off:return"off"}}function k(p){switch(p){case $.Trace:return{original:"Trace",value:r.localize(11152,null)};case $.Debug:return{original:"Debug",value:r.localize(11153,null)};case $.Info:return{original:"Info",value:r.localize(11154,null)};case $.Warning:return{original:"Warning",value:r.localize(11155,null)};case $.Error:return{original:"Error",value:r.localize(11156,null)};case $.Off:return{original:"Off",value:r.localize(11157,null)}}}function A(p){switch(p){case"trace":return $.Trace;case"debug":return $.Debug;case"info":return $.Info;case"warn":return $.Warning;case"error":return $.Error;case"critical":return $.Error;case"off":return $.Off}}e.$ok=new u.$Tj("logLevel",y($.Info))}),define(ke[225],Ie([1,0,18,7,13,4,31,3,16,69,11]),function(me,e,r,h,C,T,L,R,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;class D extends R.$Tc{constructor(P,w){super(),this.a=P,this.b=w,this.c=this.B(new T.$je),this.onDidChangeFile=this.c.event,this.g=this.B(new T.$je),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new h.$Ah(0)),this.w=[],this.y=this.B(new h.$Ah(0))}watch(P,w){return w.recursive||this.b?.watcher?.forceUniversal?this.n(P,w):this.z(P,w)}n(P,w){const a={path:this.J(P),excludes:w.excludes,includes:w.includes,recursive:w.recursive,filter:w.filter,correlationId:w.correlationId},$=(0,r.$Sb)(this.j,a);return this.r(),(0,R.$Rc)(()=>{$(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(P=>(0,C.$Y)(P))}s(){this.h||(this.h=this.B(this.t(w=>this.c.fire((0,c.$5q)(w)),w=>this.G(w),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)})));const P=this.b?.watcher?.recursive?.usePolling;if(P===!0)for(const w of this.j)(0,c.$1q)(w)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(P))for(const w of this.j)(0,c.$1q)(w)&&P.includes(w.path)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(P,w){const a={path:this.J(P),excludes:w.excludes,includes:w.includes,recursive:!1,filter:w.filter,correlationId:w.correlationId},$=(0,r.$Sb)(this.w,a);return this.C(),(0,R.$Rc)(()=>{$(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(P=>(0,C.$Y)(P))}D(){return this.u||(this.u=this.B(this.F(P=>this.c.fire((0,c.$5q)(P)),P=>this.G(P),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)}))),this.u.watch(this.w)}G(P){P.type==="error"&&this.g.fire(P.message),this.H(P)}H(P){this.a[P.type](P.message)}I(P){return(0,b.$gc)(P.fsPath)}J(P){const w=this.I(P);return(0,L.$Eg)(w)}}e.$$q=D}),define(ke[226],Ie([1,0,44,7,28,21,4,31,3,16,10,22,105,33,8,27,218,225,223,222]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a,$,f,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class o extends f.$$q{static{this.L=!1}constructor(s,n){super(s,n),this.onDidChangeCapabilities=L.Event.None,this.P=new C.$zc(d=>D.$7g.getComparisonKey(d)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=a.FileSystemProviderCapabilities.FileReadWrite|a.FileSystemProviderCapabilities.FileOpenReadWriteClose|a.FileSystemProviderCapabilities.FileReadStream|a.FileSystemProviderCapabilities.FileFolderCopy|a.FileSystemProviderCapabilities.FileWriteUnlock|a.FileSystemProviderCapabilities.FileAtomicRead|a.FileSystemProviderCapabilities.FileAtomicWrite|a.FileSystemProviderCapabilities.FileAtomicDelete|a.FileSystemProviderCapabilities.FileClone,I.$l&&(this.M|=a.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(s){try{const{stat:n,symbolicLink:d}=await P.SymlinkSupport.stat(this.I(s));return{type:this.O(n,d),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:a.FilePermission.Locked}}catch(n){throw this.hb(n)}}async N(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const n=await P.Promises.readdir(this.I(s),{withFileTypes:!0}),d=[];return await Promise.all(n.map(async l=>{try{let m;l.isSymbolicLink()?m=(await this.stat((0,D.$dh)(s,l.name))).type:m=this.O(l),d.push([l.name,m])}catch(m){this.a.trace(m)}})),d}catch(n){throw this.hb(n)}}O(s,n){let d;return n?.dangling?d=a.FileType.Unknown:s.isFile()?d=a.FileType.File:s.isDirectory()?d=a.FileType.Directory:d=a.FileType.Unknown,n&&(d|=a.FileType.SymbolicLink),d}async Q(s){const n=this.I(s);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let d;for(;d=this.P.get(s);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await d.wait();const l=new h.$Bh;return this.P.set(s,l),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,b.$Rc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.P.get(s)===l&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.P.delete(s)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),l.open()})}async readFile(s,n){let d;try{n?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(s)})`),d=await this.Q(s));const l=this.I(s);return await r.promises.readFile(l)}catch(l){throw this.hb(l)}finally{d?.dispose()}}R(s){o.L&&this.a.trace(s)}readFileStream(s,n,d){const l=(0,u.$ze)(m=>T.$Le.concat(m.map(E=>T.$Le.wrap(E))).buffer);return(0,$.$Xq)(this,s,l,m=>m.buffer,{...n,bufferSize:256*1024},d),l}async writeFile(s,n,d){return d?.atomic!==!1&&d?.atomic?.postfix&&await this.S(s)?this.U(s,(0,D.$dh)((0,D.$ch)(s),`${(0,D.$ah)(s)}${d.atomic.postfix}`),n,d):this.W(s,n,d)}async S(s){try{const n=this.I(s),{symbolicLink:d}=await P.SymlinkSupport.stat(n);if(d)return!1}catch{}return!0}async U(s,n,d,l){const m=new b.$Sc;try{m.add(await this.Q(s)),m.add(await this.Q(n)),await this.W(n,d,l,!0);try{await this.rename(n,s,{overwrite:!0})}catch(E){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw E}}finally{m.dispose()}}async W(s,n,d,l){let m;try{const E=this.I(s);if(!d.create||!d.overwrite){if(await P.Promises.exists(E)){if(!d.overwrite)throw(0,a.$jl)((0,w.localize)(11209,null),a.FileSystemProviderErrorCode.FileExists)}else if(!d.create)throw(0,a.$jl)((0,w.localize)(11210,null),a.FileSystemProviderErrorCode.FileNotFound)}m=await this.open(s,{create:!0,unlock:d.unlock},l),await this.write(m,0,n,0,n.byteLength)}catch(E){throw await this.ib(s,E)}finally{typeof m=="number"&&await this.close(m)}}static{this.$=!0}static configureFlushOnWrite(s){o.$=s}async open(s,n,d){const l=this.I(s);let m;(0,a.$0k)(n)&&!d&&(m=await this.Q(s));let E;try{if((0,a.$0k)(n)&&n.unlock)try{const{stat:y}=await P.SymlinkSupport.stat(l);y.mode&128||await r.promises.chmod(l,y.mode|128)}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}let S;if((0,a.$0k)(n)){if(I.$j)try{await r.promises.truncate(l,0),S="r+"}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}S||(S="w")}else S="r";E=await P.Promises.open(l,S)}catch(S){throw m?.dispose(),(0,a.$0k)(n)?await this.ib(s,S):this.hb(S)}if(this.X.set(E,0),(0,a.$0k)(n)&&this.Z.set(E,s),m){const S=this.Y.get(E);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${E} (${l})`),this.Y.set(E,m),S&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${E} (${l})`),S.dispose())}return E}async close(s){const n=this.Y.get(s);try{if(this.X.delete(s),this.Z.delete(s)&&o.$)try{await P.Promises.fdatasync(s)}catch(d){o.configureFlushOnWrite(!1),this.a.error(d)}return await P.Promises.close(s)}catch(d){throw this.hb(d)}finally{n&&(this.Y.get(s)===n&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.Y.delete(s)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),n.dispose())}}async read(s,n,d,l,m){const E=this.ab(s,n);let S=null;try{S=(await P.Promises.read(s,d,l,m,E)).bytesRead}catch(y){throw this.hb(y)}finally{this.bb(s,E,S)}return S}ab(s,n){return n===this.X.get(s)?null:n}bb(s,n,d){const l=this.X.get(s);typeof l=="number"&&(typeof n=="number"||(typeof d=="number"?this.X.set(s,l+d):this.X.delete(s)))}async write(s,n,d,l,m){return(0,h.$Wh)(()=>this.cb(s,n,d,l,m),100,3)}async cb(s,n,d,l,m){const E=this.ab(s,n);let S=null;try{S=(await P.Promises.write(s,d,l,m,E)).bytesWritten}catch(y){throw await this.ib(this.Z.get(s),y)}finally{this.bb(s,E,S)}return S}async mkdir(s){try{await r.promises.mkdir(this.I(s))}catch(n){throw this.hb(n)}}async delete(s,n){try{const d=this.I(s);if(n.recursive){let l;n?.atomic!==!1&&n.atomic.postfix&&(l=(0,c.$ic)((0,c.$lc)(d),`${(0,c.$mc)(d)}${n.atomic.postfix}`)),await P.Promises.rm(d,P.RimRafMode.MOVE,l)}else try{await r.promises.unlink(d)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let m=!1;try{const{stat:E,symbolicLink:S}=await P.SymlinkSupport.stat(d);m=E.isDirectory()&&!S}catch{}if(m)await r.promises.rmdir(d);else throw l}else throw l}}catch(d){throw this.hb(d)}}async rename(s,n,d){const l=this.I(s),m=this.I(n);if(l!==m)try{await this.db(s,n,"move",d.overwrite),await P.Promises.rename(l,m)}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,w.localize)(11211,null,(0,c.$mc)(l),(0,c.$mc)((0,c.$lc)(m)),E.toString()))),this.hb(E)}}async copy(s,n,d){const l=this.I(s),m=this.I(n);if(l!==m)try{await this.db(s,n,"copy",d.overwrite),await P.Promises.copy(l,m,{preserveSymlinks:!0})}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,w.localize)(11212,null,(0,c.$mc)(l),(0,c.$mc)((0,c.$lc)(m)),E.toString()))),this.hb(E)}}async db(s,n,d,l){const m=this.I(s),E=this.I(n);let S=!1;if(!!(this.capabilities&a.FileSystemProviderCapabilities.PathCaseSensitive)||(S=(0,R.$Ag)(m,E,!0)),S){if(d==="copy")throw(0,a.$jl)((0,w.localize)(11213,null),a.FileSystemProviderErrorCode.FileExists);if(d==="move")return}const k=await this.N(s);if(!k)throw(0,a.$jl)((0,w.localize)(11214,null),a.FileSystemProviderErrorCode.FileNotFound);const A=await this.N(n);if(A){if(!l)throw(0,a.$jl)((0,w.localize)(11215,null),a.FileSystemProviderErrorCode.FileExists);k.type&a.FileType.File&&A.type&a.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,n){return this.eb(s,n,!1)}async eb(s,n,d){const l=this.I(s),m=this.I(n),E=!!(this.capabilities&a.FileSystemProviderCapabilities.PathCaseSensitive);if((0,R.$Ag)(l,m,!E))return;const S=new b.$Sc;try{S.add(await this.Q(s)),S.add(await this.Q(n)),d&&await r.promises.mkdir((0,c.$lc)(m),{recursive:!0}),await r.promises.copyFile(l,m)}catch(y){if(y.code==="ENOENT"&&!d)return this.eb(s,n,!0);throw this.hb(y)}finally{S.dispose()}}t(s,n,d){return new g.$fr(l=>s(l),l=>n(l),d)}F(s,n,d){return new i.$or(l=>s(l),l=>n(l),d)}hb(s){if(s instanceof a.$il)return s;let n=s,d;switch(s.code){case"ENOENT":d=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":d=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":d=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":d=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":d=a.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,d=a.FileSystemProviderErrorCode.Unknown;break;default:d=a.FileSystemProviderErrorCode.Unknown}return(0,a.$jl)(n,d)}async ib(s,n){let d=this.hb(n);if(s&&d.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await P.SymlinkSupport.stat(this.I(s));l.mode&128||(d=(0,a.$jl)(n,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return d}}e.$pr=o}),define(ke[227],Ie([1,0,3,11]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oR=void 0;class C extends r.$Tc{constructor(L,R=[]){super(),this.a=new h.$gk([L,...R]),this.B(L.onDidChangeLogLevel(b=>this.setLevel(b)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...R){this.a.trace(L,...R)}debug(L,...R){this.a.debug(L,...R)}info(L,...R){this.a.info(L,...R)}warn(L,...R){this.a.warn(L,...R)}error(L,...R){this.a.error(L,...R)}flush(){this.a.flush()}}e.$oR=C}),define(ke[228],Ie([1,0,27,11]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dR=void 0;var C;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(C||(C={}));async function T(c,I,D,u,P){try{const w=await new Promise(($,f)=>{me(["@vscode/spdlog"],$,f)}).then(Ue);w.setFlushOn(C.Trace);const a=await w.createAsyncRotatingLogger(c,I,D,u);return P?a.clearFormatters():a.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),a}catch(w){console.error(w)}return null}function L(c,I,D){switch(I){case h.LogLevel.Trace:c.trace(D);break;case h.LogLevel.Debug:c.debug(D);break;case h.LogLevel.Info:c.info(D);break;case h.LogLevel.Warning:c.warn(D);break;case h.LogLevel.Error:c.error(D);break;case h.LogLevel.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function R(c,I){switch(I){case h.LogLevel.Trace:c.setLevel(C.Trace);break;case h.LogLevel.Debug:c.setLevel(C.Debug);break;case h.LogLevel.Info:c.setLevel(C.Info);break;case h.LogLevel.Warning:c.setLevel(C.Warning);break;case h.LogLevel.Error:c.setLevel(C.Error);break;case h.LogLevel.Off:c.setLevel(C.Off);break;default:throw new Error(`Invalid log level ${I}`)}}class b extends h.$ck{constructor(I,D,u,P,w){super(),this.m=[],this.setLevel(w),this.n=this.s(I,D,u,P),this.B(this.onDidChangeLogLevel(a=>{this.r&&R(this.r,a)}))}async s(I,D,u,P){const w=u?6:1,a=30/w*r.$El.MB,$=await T(I,D,a,w,P);if($){this.r=$,R(this.r,this.getLevel());for(const{level:f,message:g}of this.m)L(this.r,f,g);this.m=[]}}g(I,D){this.r?L(this.r,I,D):this.getLevel()<=I&&this.m.push({level:I,message:D})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$dR=b});var zt=this&&this.__importDefault||function(me){return me&&me.__esModule?me:{default:me}};define(ke[145],Ie([1,0,43,8,5]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,r=zt(r);var T;(function(b){b[b.Unnecessary=1]="Unnecessary",b[b.Deprecated=2]="Deprecated"})(T||(e.MarkerTag=T={}));var L;(function(b){b[b.Hint=1]="Hint",b[b.Info=2]="Info",b[b.Warning=4]="Warning",b[b.Error=8]="Error"})(L||(e.MarkerSeverity=L={})),function(b){function c(w,a){return a-w}b.compare=c;const I=Object.create(null);I[b.Error]=(0,h.localize)(11149,null),I[b.Warning]=(0,h.localize)(11150,null),I[b.Info]=(0,h.localize)(11151,null);function D(w){return I[w]||""}b.toString=D;function u(w){switch(w){case r.default.Error:return b.Error;case r.default.Warning:return b.Warning;case r.default.Info:return b.Info;case r.default.Ignore:return b.Hint}}b.fromSeverity=u;function P(w){switch(w){case b.Error:return r.default.Error;case b.Warning:return r.default.Warning;case b.Info:return r.default.Info;case b.Hint:return r.default.Ignore}}b.toSeverity=P}(L||(e.MarkerSeverity=L={}));var R;(function(b){const c="";function I(u){return D(u,!0)}b.makeKey=I;function D(u,P){const w=[c];return u.source?w.push(u.source.replace("\xA6","\\\xA6")):w.push(c),u.code?typeof u.code=="string"?w.push(u.code.replace("\xA6","\\\xA6")):w.push(u.code.value.replace("\xA6","\\\xA6")):w.push(c),u.severity!==void 0&&u.severity!==null?w.push(L.toString(u.severity)):w.push(c),u.message&&P?w.push(u.message.replace("\xA6","\\\xA6")):w.push(c),u.startLineNumber!==void 0&&u.startLineNumber!==null?w.push(u.startLineNumber.toString()):w.push(c),u.startColumn!==void 0&&u.startColumn!==null?w.push(u.startColumn.toString()):w.push(c),u.endLineNumber!==void 0&&u.endLineNumber!==null?w.push(u.endLineNumber.toString()):w.push(c),u.endColumn!==void 0&&u.endColumn!==null?w.push(u.endColumn.toString()):w.push(c),w.push(c),w.join("\xA6")}b.makeKeyOptionalMessage=D})(R||(e.IMarkerData=R={})),e.$Bu=(0,C.$Ci)("markerService")});var zt=this&&this.__importDefault||function(me){return me&&me.__esModule?me:{default:me}};define(ke[229],Ie([1,0,4,43,5]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rw=e.$qw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$ow=e.Severity=void 0,e.$pw=R,h=zt(h),e.Severity=h.default,e.$ow=(0,C.$Ci)("notificationService");var T;(function(D){D[D.DEFAULT=0]="DEFAULT",D[D.SILENT=1]="SILENT",D[D.URGENT=2]="URGENT"})(T||(e.NotificationPriority=T={}));var L;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.PROFILE=1]="PROFILE",D[D.APPLICATION=2]="APPLICATION"})(L||(e.NeverShowAgainScope=L={}));function R(D){if(D){const u=D;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var b;(function(D){D[D.OFF=0]="OFF",D[D.ERROR=1]="ERROR"})(b||(e.NotificationsFilter=b={}));class c{constructor(){this.progress=new I,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$qw=c;class I{infinite(){}done(){}total(u){}worked(u){}}e.$rw=I}),define(ke[230],Ie([1,0,55]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let h;const C=globalThis.vscode;if(typeof C<"u"&&typeof C.context<"u"){const T=C.context.configuration();if(T)h=T.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(h=globalThis._VSCODE_PRODUCT_JSON,r.env.VSCODE_DEV&&Object.assign(h,{nameShort:`${h.nameShort} Dev`,nameLong:`${h.nameLong} Dev`,dataFolderName:`${h.dataFolderName}-dev`,serverDataFolderName:h.serverDataFolderName?`${h.serverDataFolderName}-dev`:void 0}),!h.version){const T=globalThis._VSCODE_PACKAGE_JSON;Object.assign(h,{version:T.version})}}else h={},Object.keys(h).length===0&&Object.assign(h,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=h}),define(ke[115],Ie([1,0,5]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qk=e.$pk=void 0,e.$pk=(0,r.$Ci)("productService"),e.$qk="vscode://schemas/vscode-product"});var Ve=this&&this.__param||function(me,e){return function(r,h){e(r,h,me)}};define(ke[89],Ie([1,0,7,20,3,5]),function(me,e,r,h,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yw=e.$xw=e.$ww=e.$vw=e.$uw=e.$tw=e.ProgressLocation=e.$sw=void 0,e.$sw=(0,T.$Ci)("progressService");var L;(function(D){D[D.Explorer=1]="Explorer",D[D.Scm=3]="Scm",D[D.Extensions=5]="Extensions",D[D.Window=10]="Window",D[D.Notification=15]="Notification",D[D.Dialog=20]="Dialog"})(L||(e.ProgressLocation=L={})),e.$tw=Object.freeze({total(){},worked(){},done(){}});class R{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$uw=R;class b{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const P=this.d;this.d=()=>{P?.(),u()}}):Promise.resolve()}}e.$vw=b;let c=class extends C.$Tc{constructor(u,P){super(),this.a=new r.$Zh,P.withProgress(u,w=>(this.b=w,this.c&&w.report(this.c),this.a.p)),this.B((0,C.$Rc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$ww=c,e.$ww=c=Ye([Ve(1,e.$sw)],c);class I extends C.$Tc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new C.$Sc)}start(u){this.stop();const P=++this.a,w=new h.$ue;return this.f=setTimeout(()=>{P===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,C.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,C.$Rc)(()=>w.cancel())),this.b.add((0,C.$Rc)(()=>this.c?this.c.done():void 0)),{id:P,token:w.token,stop:()=>this.h(P),isCurrent:()=>this.a===P}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$xw=I,e.$yw=(0,T.$Ci)("editorProgressService")}),define(ke[36],Ie([1,0,65,17]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=void 0,r=Ue(r),h=Ue(h);class C{constructor(){this.a=new Map}add(L,R){r.ok(h.$cg(L)),r.ok(h.$eg(R)),r.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,R)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.$no=new C}),define(ke[116],Ie([1,0,4,36]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=void 0,h=Ue(h),e.$oo={JSONContribution:"base.contributions.json"};function C(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class T{constructor(){this.b=new r.$je,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(b,c){this.a[C(b)]=c,this.b.fire(b)}notifySchemaChanged(b){this.b.fire(b)}getSchemaContributions(){return{schemas:this.a}}}const L=new T;h.$no.add(e.$oo.JSONContribution,L)}),define(ke[70],Ie([1,0,18,4,17,8,45,116,36]),function(me,e,r,h,C,T,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.ConfigurationScope=e.$so=e.EditPresentationTypes=void 0,e.$Do=a,e.$Eo=$,e.$Fo=f,e.$Go=i,e.$Ho=o,e.$Io=t,e.$Jo=s,C=Ue(C),T=Ue(T);var c;(function(n){n.Multiline="multilineText",n.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$so={Configuration:"base.contributions.configuration"};var I;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.MACHINE=2]="MACHINE",n[n.WINDOW=3]="WINDOW",n[n.RESOURCE=4]="RESOURCE",n[n.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",n[n.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.$to={properties:{},patternProperties:{}},e.$uo={properties:{},patternProperties:{}},e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo="vscode://schemas/settings/resourceLanguage",e.$Ao="vscode://schemas/settings/configurationDefaults";const D=b.$no.as(R.$oo.JSONContribution);class u{constructor(){this.h=new Set,this.i=new h.$je,this.onDidSchemaChange=this.i.event,this.j=new h.$je,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:T.localize(11444,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.$zo,this.g),this.v()}registerConfiguration(d,l=!0){this.registerConfigurations([d],l)}registerConfigurations(d,l=!0){const m=new Set;this.n(d,l,m),D.registerSchema(e.$zo,this.g),this.i.fire(),this.j.fire({properties:m})}deregisterConfigurations(d){const l=new Set;this.o(d,l),D.registerSchema(e.$zo,this.g),this.i.fire(),this.j.fire({properties:l})}updateConfigurations({add:d,remove:l}){const m=new Set;this.o(l,m),this.n(d,!1,m),D.registerSchema(e.$zo,this.g),this.i.fire(),this.j.fire({properties:m})}registerDefaultConfigurations(d){const l=new Set;this.k(d,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}k(d,l){const m=[];for(const{overrides:E,source:S}of d)for(const y in E)if(l.add(y),e.$Co.test(y)){const k=this.a.get(y),A=k?.valuesSources??new Map,p=k?.value||{};for(const N of Object.keys(E[y])){const O=E[y][N];if(C.$eg(O)&&(C.$jg(p[N])||C.$eg(p[N]))){if(p[N]={...p[N]??{},...O},S){let z=A.get(N);if(z||(z=new Map,A.set(N,z)),!(z instanceof Map)){console.error("objectConfigurationSources is not a Map");continue}for(const M in O)z.set(M,S)}}else p[N]=O,S&&A.set(N,S)}this.a.set(y,{source:S,value:p,valuesSources:A});const v=(0,L.$gj)(y),F={type:"object",default:p,description:T.localize(11445,null,v),$ref:e.$zo,defaultDefaultValue:p,source:C.$cg(S)?void 0:S,defaultValueSource:S};m.push(...a(y)),this.d[y]=F,this.b.properties[y]=F}else{const k=this.d[y],A=this.a.get(y);let p=A?.value??k?.defaultDefaultValue,v=E[y],F=S;if(C.$eg(v)&&(k!==void 0&&k.type==="object"||k===void 0&&(C.$jg(p)||C.$eg(p)))){if(C.$eg(p)||(p={}),v={...p,...v},F=A?.source??new Map,!(F instanceof Map)){console.error("defaultValueSource is not a Map");continue}for(const O in E[y])S?F.set(O,S):F.delete(O)}this.a.set(y,{value:v,source:F}),k&&(this.w(y,k),this.r(y,k))}this.m(m)}deregisterDefaultConfigurations(d){const l=new Set;this.l(d,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}l(d,l){for(const{overrides:m,source:E}of d)for(const S in m){const y=C.$cg(E)?E:E?.id,k=this.a.get(S);if(k){if(e.$Co.test(S)){for(const p of Object.keys(m[S])){const v=m[S][p];if(C.$eg(v)){const F=k.valuesSources?.get(p);for(const N of Object.keys(v)){const O=F?.get(N);(C.$cg(O)?O:O?.id)===y&&(F?.delete(N),delete k.value[p][N])}Object.keys(k.value[p]).length===0&&(delete k.value[p],k.valuesSources?.delete(p))}else{const F=k.valuesSources?.get(p);(C.$cg(F)?F:F?.id)===y&&(k.valuesSources?.delete(p),delete k.value[p])}}const A=this.a.get(S);A&&Object.keys(A.value).length===0&&(this.a.delete(S),delete this.d[S],delete this.b.properties[S])}else{if(k.source instanceof Map){const p=k.source;for(const v in m[S]){const F=p.get(v);(C.$cg(F)?F:F?.id)===y&&(p.delete(v),delete k.value[v])}p.size===0&&this.a.delete(S)}else{const p=C.$cg(k.source)?k.source:k.source?.id;if(y!==p)continue;this.a.delete(S)}const A=this.d[S];A&&(this.w(S,A),this.r(S,A))}l.add(S)}}this.u()}deltaConfiguration(d){let l=!1;const m=new Set;d.removedDefaults&&(this.l(d.removedDefaults,m),l=!0),d.addedDefaults&&(this.k(d.addedDefaults,m),l=!0),d.removedConfigurations&&this.o(d.removedConfigurations,m),d.addedConfigurations&&this.n(d.addedConfigurations,!1,m),this.i.fire(),this.j.fire({properties:m,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...d){this.i.fire()}registerOverrideIdentifiers(d){this.m(d),this.i.fire()}m(d){for(const l of d)this.h.add(l);this.u()}n(d,l,m){d.forEach(E=>{this.p(E,l,E.extensionInfo,E.restrictedProperties,void 0,m),this.c.push(E),this.q(E)})}o(d,l){const m=E=>{if(E.properties)for(const S in E.properties){l.add(S);const y=this.d[S];y?.policy?.name&&this.e.delete(y.policy.name),delete this.d[S],this.s(S,E.properties[S])}E.allOf?.forEach(S=>m(S))};for(const E of d){m(E);const S=this.c.indexOf(E);S!==-1&&this.c.splice(S,1)}}p(d,l=!0,m,E,S=I.WINDOW,y){S=C.$lg(d.scope)?S:d.scope;const k=d.properties;if(k)for(const p in k){const v=k[p];if(l&&i(p,v)){delete k[p];continue}if(v.source=m,v.defaultDefaultValue=k[p].default,this.w(p,v),e.$Co.test(p)?v.scope=void 0:(v.scope=C.$lg(v.scope)?S:v.scope,v.restricted=C.$lg(v.restricted)?!!E?.includes(p):v.restricted),k[p].hasOwnProperty("included")&&!k[p].included){this.f[p]=k[p],delete k[p];continue}else this.d[p]=k[p],k[p].policy?.name&&this.e.set(k[p].policy.name,p);!k[p].deprecationMessage&&k[p].markdownDeprecationMessage&&(k[p].deprecationMessage=k[p].markdownDeprecationMessage),y.add(p)}const A=d.allOf;if(A)for(const p of A)this.p(p,l,m,E,S,y)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(d){const l=m=>{const E=m.properties;if(E)for(const y in E)this.r(y,E[y]);m.allOf?.forEach(l)};l(d)}r(d,l){switch(e.$to.properties[d]=l,l.scope){case I.APPLICATION:e.$uo.properties[d]=l;break;case I.MACHINE:e.$vo.properties[d]=l;break;case I.MACHINE_OVERRIDABLE:e.$wo.properties[d]=l;break;case I.WINDOW:e.$xo.properties[d]=l;break;case I.RESOURCE:e.$yo.properties[d]=l;break;case I.LANGUAGE_OVERRIDABLE:e.$yo.properties[d]=l,this.g.properties[d]=l;break}}s(d,l){switch(delete e.$to.properties[d],l.scope){case I.APPLICATION:delete e.$uo.properties[d];break;case I.MACHINE:delete e.$vo.properties[d];break;case I.MACHINE_OVERRIDABLE:delete e.$wo.properties[d];break;case I.WINDOW:delete e.$xo.properties[d];break;case I.RESOURCE:case I.LANGUAGE_OVERRIDABLE:delete e.$yo.properties[d],delete this.g.properties[d];break}}u(){for(const d of this.h.values()){const l=`[${d}]`,m={type:"object",description:T.localize(11446,null),errorMessage:T.localize(11447,null),$ref:e.$zo};this.w(l,m),e.$to.properties[l]=m,e.$uo.properties[l]=m,e.$vo.properties[l]=m,e.$wo.properties[l]=m,e.$xo.properties[l]=m,e.$yo.properties[l]=m}}v(){const d={type:"object",description:T.localize(11448,null),errorMessage:T.localize(11449,null),$ref:e.$zo};e.$to.patternProperties[e.$Bo]=d,e.$uo.patternProperties[e.$Bo]=d,e.$vo.patternProperties[e.$Bo]=d,e.$wo.patternProperties[e.$Bo]=d,e.$xo.patternProperties[e.$Bo]=d,e.$yo.patternProperties[e.$Bo]=d,this.i.fire()}w(d,l){const m=this.a.get(d);let E=m?.value,S=m?.source;C.$jg(E)&&(E=l.defaultDefaultValue,S=void 0),C.$jg(E)&&(E=f(l.type)),l.default=E,l.defaultValueSource=S}}const P="\\[([^\\]]+)\\]",w=new RegExp(P,"g");e.$Bo=`^(${P})+$`,e.$Co=new RegExp(e.$Bo);function a(n){const d=[];if(e.$Co.test(n)){let l=w.exec(n);for(;l?.length;){const m=l[1].trim();m&&d.push(m),l=w.exec(n)}}return(0,r.$Lb)(d)}function $(n){return n.reduce((d,l)=>`${d}[${l}]`,"")}function f(n){switch(Array.isArray(n)?n[0]:n){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const g=new u;b.$no.add(e.$so.Configuration,g);function i(n,d){return n.trim()?e.$Co.test(n)?T.localize(11451,null,n):g.getConfigurationProperties()[n]!==void 0?T.localize(11452,null,n):d.policy?.name&&g.getPolicyConfigurations().get(d.policy?.name)!==void 0?T.localize(11453,null,n,d.policy?.name,g.getPolicyConfigurations().get(d.policy?.name)):null:T.localize(11450,null)}function o(){const n=[],d=g.getConfigurationProperties();for(const l of Object.keys(d))n.push([l,d[l].scope]);return n.push(["launch",I.RESOURCE]),n.push(["task",I.RESOURCE]),n}function t(n){const d={};for(const l of n){const m=l.properties;if(C.$eg(m))for(const E in m)d[E]=m[E];l.allOf&&Object.assign(d,t(l.allOf))}return d}function s(n){switch(n){case"application":return I.APPLICATION;case"machine":return I.MACHINE;case"resource":return I.RESOURCE;case"machine-overridable":return I.MACHINE_OVERRIDABLE;case"language-overridable":return I.LANGUAGE_OVERRIDABLE;default:return I.WINDOW}}}),define(ke[231],Ie([1,0,18,4,176,3,28,24,17,2,45,70,27,36]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$No=e.$Mo=e.$Lo=e.$Ko=void 0,e.$Oo=o,r=Ue(r),C=Ue(C),R=Ue(R),b=Ue(b);function w(d){return Object.isFrozen(d)?d:R.$bo(d)}class a{static createEmptyModel(l){return new a({},[],[],void 0,l)}constructor(l,m,E,S,y){this.b=l,this.c=m,this.d=E,this.raw=S,this.f=y,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const l=this.raw.map(m=>{if(m instanceof a)return m;const E=new $("",this.f);return E.parseRaw(m),E.configurationModel});this.g=l.reduce((m,E)=>E===m?E:m.merge(E),l[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(l){return l?(0,I.$ej)(this.contents,l):this.contents}inspect(l,m){const E=this;return{get value(){return w(E.rawConfiguration.getValue(l))},get override(){return m?w(E.rawConfiguration.getOverrideValue(l,m)):void 0},get merged(){return w(m?E.rawConfiguration.override(m).getValue(l):E.rawConfiguration.getValue(l))},get overrides(){const S=[];for(const{contents:y,identifiers:k,keys:A}of E.rawConfiguration.overrides){const p=new a(y,A,[],void 0,E.f).getValue(l);p!==void 0&&S.push({identifiers:k,value:p})}return S.length?w(S):void 0}}}getOverrideValue(l,m){const E=this.j(m);return E?l?(0,I.$ej)(E,l):E:void 0}getKeysForOverrideIdentifier(l){const m=[];for(const E of this.overrides)E.identifiers.includes(l)&&m.push(...E.keys);return r.$Lb(m)}getAllOverrideIdentifiers(){const l=[];for(const m of this.overrides)l.push(...m.identifiers);return r.$Lb(l)}override(l){let m=this.a.get(l);return m||(m=this.h(l),this.a.set(l,m)),m}merge(...l){const m=R.$ao(this.contents),E=R.$ao(this.overrides),S=[...this.keys],y=this.raw?.length?[...this.raw]:[this];for(const k of l)if(y.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.i(m,k.contents);for(const A of k.overrides){const[p]=E.filter(v=>r.$tb(v.identifiers,A.identifiers));p?(this.i(p.contents,A.contents),p.keys.push(...A.keys),p.keys=r.$Lb(p.keys)):E.push(R.$ao(A))}for(const A of k.keys)S.indexOf(A)===-1&&S.push(A)}return new a(m,S,E,y.every(k=>k instanceof a)?void 0:y,this.f)}h(l){const m=this.j(l);if(!m||typeof m!="object"||!Object.keys(m).length)return this;const E={};for(const S of r.$Lb([...Object.keys(this.contents),...Object.keys(m)])){let y=this.contents[S];const k=m[S];k&&(typeof y=="object"&&typeof k=="object"?(y=R.$ao(y),this.i(y,k)):y=k),E[S]=y}return new a(E,this.keys,this.overrides,void 0,this.f)}i(l,m){for(const E of Object.keys(m)){if(E in l&&b.$eg(l[E])&&b.$eg(m[E])){this.i(l[E],m[E]);continue}l[E]=R.$ao(m[E])}}j(l){let m=null,E=null;const S=y=>{y&&(E?this.i(E,y):E=R.$ao(y))};for(const y of this.overrides)y.identifiers.length===1&&y.identifiers[0]===l?m=y.contents:y.identifiers.includes(l)&&S(y.contents);return S(m),E}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(l,m){this.k(l,m,!0)}setValue(l,m){this.k(l,m,!1)}removeValue(l){const m=this.keys.indexOf(l);m!==-1&&(this.keys.splice(m,1),(0,I.$dj)(this.contents,l),D.$Co.test(l)&&this.overrides.splice(this.overrides.findIndex(E=>r.$tb(E.identifiers,(0,D.$Do)(l))),1))}k(l,m,E){(0,I.$cj)(this.contents,l,m,S=>this.f.error(S)),E=E||this.keys.indexOf(l)===-1,E&&this.keys.push(l),D.$Co.test(l)&&this.overrides.push({identifiers:(0,D.$Do)(l),keys:Object.keys(this.contents[l]),contents:(0,I.$bj)(this.contents[l],S=>this.f.error(S))})}}e.$Ko=a;class ${constructor(l,m){this.f=l,this.g=m,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||a.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(l,m){if(!b.$lg(l)){const E=this.h(l);this.parseRaw(E,m)}}reparse(l){this.a&&this.parseRaw(this.a,l)}parseRaw(l,m){this.a=l;const{contents:E,keys:S,overrides:y,restricted:k,hasExcludedProperties:A}=this.i(l,m);this.b=new a(E,S,y,A?[l]:void 0,this.g),this.c=k||[]}h(l){let m={},E=null,S=[];const y=[],k=[];function A(v){Array.isArray(S)?S.push(v):E!==null&&(S[E]=v)}const p={onObjectBegin:()=>{const v={};A(v),y.push(S),S=v,E=null},onObjectProperty:v=>{E=v},onObjectEnd:()=>{S=y.pop()},onArrayBegin:()=>{const v=[];A(v),y.push(S),S=v,E=null},onArrayEnd:()=>{S=y.pop()},onLiteralValue:A,onError:(v,F,N)=>{k.push({error:v,offset:F,length:N})}};if(l)try{C.$2n(l,p),m=S[0]||{}}catch(v){this.g.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return m}i(l,m){const E=P.$no.as(D.$so.Configuration).getConfigurationProperties(),S=this.j(l,E,!0,m);l=S.raw;const y=(0,I.$bj)(l,p=>this.g.error(`Conflict in settings file ${this.f}: ${p}`)),k=Object.keys(l),A=this.l(l,p=>this.g.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:y,keys:k,overrides:A,restricted:S.restricted,hasExcludedProperties:S.hasExcludedProperties}}j(l,m,E,S){let y=!1;if(!S?.scopes&&!S?.skipRestricted&&!S?.exclude?.length)return{raw:l,restricted:[],hasExcludedProperties:y};const k={},A=[];for(const p in l)if(D.$Co.test(p)&&E){const v=this.j(l[p],m,!1,S);k[p]=v.raw,y=y||v.hasExcludedProperties,A.push(...v.restricted)}else{const v=m[p],F=v?typeof v.scope<"u"?v.scope:D.ConfigurationScope.WINDOW:void 0;v?.restricted&&A.push(p),!S.exclude?.includes(p)&&(S.include?.includes(p)||(F===void 0||S.scopes===void 0||S.scopes.includes(F))&&!(S.skipRestricted&&v?.restricted))?k[p]=l[p]:y=!0}return{raw:k,restricted:A,hasExcludedProperties:y}}l(l,m){const E=[];for(const S of Object.keys(l))if(D.$Co.test(S)){const y={};for(const k in l[S])y[k]=l[S][k];E.push({identifiers:(0,D.$Do)(S),keys:Object.keys(y),contents:(0,I.$bj)(y,m)})}return E}}e.$Lo=$;class f extends T.$Tc{constructor(l,m,E,S,y){super(),this.c=l,this.f=m,this.g=S,this.h=y,this.b=this.B(new h.$je),this.onDidChange=this.b.event,this.a=new $(this.c.toString(),y),this.B(this.g.watch(E.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(h.Event.any(h.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),h.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(u.FileOperation.CREATE)||k.isOperation(u.FileOperation.COPY)||k.isOperation(u.FileOperation.DELETE)||k.isOperation(u.FileOperation.WRITE))&&E.isEqual(k.resource,l)))(()=>this.b.fire()))}async loadConfiguration(){try{const l=await this.g.readFile(this.c);return this.a.parse(l.value.toString()||"{}",this.f),this.a.configurationModel}catch{return a.createEmptyModel(this.h)}}reparse(l){return l&&(this.f=l),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Mo=f;class g{constructor(l,m,E,S,y,k,A,p,v,F,N,O,j){this.a=l,this.b=m,this.c=E,this.overrideIdentifiers=S,this.d=y,this.f=k,this.g=A,this.h=p,this.i=v,this.j=F,this.k=N,this.l=O,this.m=j}get value(){return w(this.c)}n(l){return l?.value!==void 0||l?.override!==void 0||l?.overrides!==void 0?l:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(l,m,E,S,y,k,A,p,v,F){this.j=l,this.l=m,this.m=E,this.n=S,this.p=y,this.q=k,this.r=A,this.s=p,this.t=v,this.u=F,this.h=null,this.i=new L.$zc,this.v=null}getValue(l,m,E){return this.w(l,m,E).getValue(l)}updateValue(l,m,E={}){let S;E.resource?(S=this.t.get(E.resource),S||(S=a.createEmptyModel(this.u),this.t.set(E.resource,S))):S=this.s,m===void 0?S.removeValue(l):S.setValue(l,m),E.resource||(this.h=null)}inspect(l,m,E){const S=this.w(l,m,E),y=this.A(m.resource,E),k=m.resource?this.t.get(m.resource)||this.s:this.s,A=new Set;for(const p of S.overrides)for(const v of p.identifiers)S.getOverrideValue(l,v)!==void 0&&A.add(v);return new g(l,m,S.getValue(l),A.size?[...A]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,E?this.q:void 0,y||void 0,k)}keys(l){const m=this.A(void 0,l);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:m?m.keys.slice(0):[]}}updateDefaultConfiguration(l){this.j=l,this.h=null,this.i.clear()}updatePolicyConfiguration(l){this.l=l}updateApplicationConfiguration(l){this.m=l,this.h=null,this.i.clear()}updateLocalUserConfiguration(l){this.n=l,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(l){this.p=l,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(l){this.q=l,this.h=null,this.i.clear()}updateFolderConfiguration(l,m){this.r.set(l,m),this.i.delete(l)}deleteFolderConfiguration(l){this.folderConfigurations.delete(l),this.i.delete(l)}compareAndUpdateDefaultConfiguration(l,m){const E=[];if(!m){const{added:S,updated:y,removed:k}=s(this.j,l);m=[...S,...y,...k]}for(const S of m)for(const y of(0,D.$Do)(S)){const k=this.j.getKeysForOverrideIdentifier(y),A=l.getKeysForOverrideIdentifier(y),p=[...A.filter(v=>k.indexOf(v)===-1),...k.filter(v=>A.indexOf(v)===-1),...k.filter(v=>!R.$eo(this.j.override(y).getValue(v),l.override(y).getValue(v)))];E.push([y,p])}return this.updateDefaultConfiguration(l),{keys:m,overrides:E}}compareAndUpdatePolicyConfiguration(l){const{added:m,updated:E,removed:S}=s(this.l,l),y=[...m,...E,...S];return y.length&&this.updatePolicyConfiguration(l),{keys:y,overrides:[]}}compareAndUpdateApplicationConfiguration(l){const{added:m,updated:E,removed:S,overrides:y}=s(this.applicationConfiguration,l),k=[...m,...E,...S];return k.length&&this.updateApplicationConfiguration(l),{keys:k,overrides:y}}compareAndUpdateLocalUserConfiguration(l){const{added:m,updated:E,removed:S,overrides:y}=s(this.localUserConfiguration,l),k=[...m,...E,...S];return k.length&&this.updateLocalUserConfiguration(l),{keys:k,overrides:y}}compareAndUpdateRemoteUserConfiguration(l){const{added:m,updated:E,removed:S,overrides:y}=s(this.remoteUserConfiguration,l),k=[...m,...E,...S];return k.length&&this.updateRemoteUserConfiguration(l),{keys:k,overrides:y}}compareAndUpdateWorkspaceConfiguration(l){const{added:m,updated:E,removed:S,overrides:y}=s(this.workspaceConfiguration,l),k=[...m,...E,...S];return k.length&&this.updateWorkspaceConfiguration(l),{keys:k,overrides:y}}compareAndUpdateFolderConfiguration(l,m){const E=this.folderConfigurations.get(l),{added:S,updated:y,removed:k,overrides:A}=s(E,m),p=[...S,...y,...k];return(p.length||!E)&&this.updateFolderConfiguration(l,m),{keys:p,overrides:A}}compareAndDeleteFolderConfiguration(l){const m=this.folderConfigurations.get(l);if(!m)throw new Error("Unknown folder");this.deleteFolderConfiguration(l);const{added:E,updated:S,removed:y,overrides:k}=s(m,void 0);return{keys:[...E,...S,...y],overrides:k}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(l,m,E){let S=this.x(m,E);return m.overrideIdentifier&&(S=S.override(m.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(l)!==void 0&&(S=S.merge(this.l)),S}x({resource:l},m){let E=this.y();if(m&&l){const S=m.getFolder(l);S&&(E=this.z(S.uri)||E);const y=this.t.get(l);y&&(E=E.merge(y))}return E}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(l){let m=this.i.get(l);if(!m){const E=this.y(),S=this.r.get(l);S?(m=E.merge(S),this.i.set(l,m)):m=E}return m}A(l,m){if(m&&l){const E=m.getFolder(l);if(E)return this.r.get(E.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((l,m)=>{const{contents:E,overrides:S,keys:y}=this.r.get(m);return l.push([m,{contents:E,overrides:S,keys:y}]),l},[])}}allKeys(){const l=new Set;return this.j.keys.forEach(m=>l.add(m)),this.userConfiguration.keys.forEach(m=>l.add(m)),this.q.keys.forEach(m=>l.add(m)),this.r.forEach(m=>m.keys.forEach(E=>l.add(E))),[...l.values()]}B(){const l=new Set;return this.j.getAllOverrideIdentifiers().forEach(m=>l.add(m)),this.userConfiguration.getAllOverrideIdentifiers().forEach(m=>l.add(m)),this.q.getAllOverrideIdentifiers().forEach(m=>l.add(m)),this.r.forEach(m=>m.getAllOverrideIdentifiers().forEach(E=>l.add(E))),[...l.values()]}D(l){const m=new Set;return this.j.getKeysForOverrideIdentifier(l).forEach(E=>m.add(E)),this.userConfiguration.getKeysForOverrideIdentifier(l).forEach(E=>m.add(E)),this.q.getKeysForOverrideIdentifier(l).forEach(E=>m.add(E)),this.r.forEach(E=>E.getKeysForOverrideIdentifier(l).forEach(S=>m.add(S))),[...m.values()]}static parse(l,m){const E=this.E(l.defaults,m),S=this.E(l.policy,m),y=this.E(l.application,m),k=this.E(l.user,m),A=this.E(l.workspace,m),p=l.folders.reduce((v,F)=>(v.set(c.URI.revive(F[0]),this.E(F[1],m)),v),new L.$zc);return new i(E,S,y,k,a.createEmptyModel(m),A,p,a.createEmptyModel(m),new L.$zc,m)}static E(l,m){return new a(l.contents,l.keys,l.overrides,void 0,m)}}e.$No=i;function o(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const l=new Set,m=new Map;for(const S of d)S.keys.forEach(y=>l.add(y)),S.overrides.forEach(([y,k])=>{const A=(0,L.$wc)(m,y,new Set);k.forEach(p=>A.add(p))});const E=[];return m.forEach((S,y)=>E.push([y,[...S.values()]])),{keys:[...l.values()],overrides:E}}class t{constructor(l,m,E,S,y){this.change=l,this.f=m,this.g=E,this.h=S,this.i=y,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const k of l.keys)this.affectedKeys.add(k);for(const[,k]of l.overrides)for(const A of k)this.affectedKeys.add(A);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(l,m){const E=this.a+l,S=this.d.indexOf(E);if(S<0)return!1;const y=S+E.length;if(y>=this.d.length)return!1;const k=this.d.charCodeAt(y);if(k!==this.b&&k!==this.c)return!1;if(m){const A=this.previousConfiguration?this.previousConfiguration.getValue(l,m,this.f?.workspace):void 0,p=this.g.getValue(l,m,this.h);return!R.$eo(A,p)}return!0}}e.$Po=t;function s(d,l){const{added:m,removed:E,updated:S}=n(l?.rawConfiguration,d?.rawConfiguration),y=[],k=d?.getAllOverrideIdentifiers()||[],A=l?.getAllOverrideIdentifiers()||[];if(l){const p=A.filter(v=>!k.includes(v));for(const v of p)y.push([v,l.getKeysForOverrideIdentifier(v)])}if(d){const p=k.filter(v=>!A.includes(v));for(const v of p)y.push([v,d.getKeysForOverrideIdentifier(v)])}if(l&&d){for(const p of k)if(A.includes(p)){const v=n({contents:d.getOverrideValue(void 0,p)||{},keys:d.getKeysForOverrideIdentifier(p)},{contents:l.getOverrideValue(void 0,p)||{},keys:l.getKeysForOverrideIdentifier(p)});y.push([p,[...v.added,...v.removed,...v.updated]])}}return{added:m,removed:E,updated:S,overrides:y}}function n(d,l){const m=d?l?d.keys.filter(y=>l.keys.indexOf(y)===-1):[...d.keys]:[],E=l?d?l.keys.filter(y=>d.keys.indexOf(y)===-1):[...l.keys]:[],S=[];if(d&&l){for(const y of l.keys)if(d.keys.indexOf(y)!==-1){const k=(0,I.$ej)(l.contents,y),A=(0,I.$ej)(d.contents,y);R.$eo(k,A)||S.push(y)}}return{added:m,removed:E,updated:S}}}),define(ke[232],Ie([1,0,21,4,3,68]),function(me,e,r,h,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dxb=e.$bxb=e.$axb=void 0,e.$cxb=R;const L=(c,I,D)=>{const u=new Uint8Array(16);for(let a=0;a<16;a++)u[a]=Math.round(Math.random()*256);const P=(0,r.$6e)(r.$Le.wrap(u));return[`GET ws://localhost${c}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${P}`].join(`\r
`)+`\r
\r
`};e.$axb=L,e.$bxb=r.$Le.fromString(`\r
\r
`);async function R(c,I,D,u,P){c.write(r.$Le.fromString((0,e.$axb)(I,D,u)));const w=new C.$Sc;try{return await new Promise((a,$)=>{let f;w.add(c.onData(g=>{f?f=r.$Le.concat([f,g],f.byteLength+g.byteLength):f=g;const i=f.indexOf(e.$bxb);if(i===-1)return;a(c),c.pauseData();const o=f.slice(i+e.$bxb.byteLength);o.byteLength&&P.onData.fire(o)})),w.add(c.onClose(g=>$(g??new Error("socket closed")))),w.add(c.onEnd(()=>$(new Error("socket ended"))))})}catch(a){throw c.dispose(),a}finally{w.dispose()}}class b extends C.$Tc{constructor(I,D){super(),this.g=I,this.a=this.B(new h.$me),this.onData=(...u)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...u)),this.b=this.B(new h.$je),this.onDidDispose=this.b.event,this.f=!1,this.B(D.onData),this.B(D.onData.event(u=>this.a.fire(u))),this.onClose=this.B(D.onClose).event,this.onEnd=this.B(D.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(I,D){T.SocketDiagnostics.traceSocketEvent(this,this.g,I,D)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$dxb=b}),define(ke[71],Ie([1,0,13,5]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.RemoteAuthorityResolverErrorCode=e.$Pl=e.$Ol=e.RemoteConnectionType=e.$Nl=void 0,e.$Rl=c,e.$Nl=(0,h.$Ci)("remoteAuthorityResolverService");var C;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class T{constructor(D){this.id=D,this.type=C.Managed}toString(){return`Managed(${this.id})`}}e.$Ol=T;class L{constructor(D,u){this.host=D,this.port=u,this.type=C.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Pl=L;var R;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class b extends r.$ab{static isNotAvailable(D){return D instanceof b&&D._code===R.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof b&&D._code===R.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof b&&D._code===R.NoResolverFound}static isInvalidAuthority(D){return D instanceof b&&D._code===R.InvalidAuthority}static isHandled(D){return D instanceof b&&D.isHandled}constructor(D,u=R.Unknown,P){super(D),this._message=D,this._code=u,this._detail=P,this.isHandled=u===R.NotAvailable&&P===!0,Object.setPrototypeOf(this,b.prototype)}}e.$Ql=b;function c(I){const D=I.indexOf("+");return D===-1?I:I.substring(0,D)}}),define(ke[233],Ie([1,0,7,21,20,13,4,3,14,61,42,32,68,71]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Wl=y,e.$Xl=k,e.$Yl=p,c=Ue(c);const w=30*1e3;var a;(function($e){$e[$e.Management=1]="Management",$e[$e.ExtensionHost=2]="ExtensionHost",$e[$e.Tunnel=3]="Tunnel"})(a||(e.ConnectionType=a={}));function $($e){switch($e){case a.Management:return"Management";case a.ExtensionHost:return"ExtensionHost";case a.Tunnel:return"Tunnel"}}function f($e){const J=new C.$ue;return setTimeout(()=>J.cancel(),$e),J.token}function g($e,J){if($e.isCancellationRequested||J.isCancellationRequested)return C.CancellationToken.Cancelled;const W=new C.$ue;return $e.onCancellationRequested(()=>W.cancel()),J.onCancellationRequested(()=>W.cancel()),W.token}class i{get didTimeout(){return this.c==="timedout"}constructor(J){this.c="pending",this.d=new R.$Sc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,r.$vh)(),J.isCancellationRequested?this.h():this.d.add(J.onCancellationRequested(()=>this.h()))}registerDisposable(J){this.c==="pending"?this.d.add(J):J.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const J=new Error("Time limit reached");return J.code="ETIMEDOUT",J.syscall="connect",J}resolve(J){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(J))}reject(J){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(J))}}function o($e,J){const W=new i(J);return W.registerDisposable($e.onControlMessage(se=>{const ae=JSON.parse(se.toString()),te=G(ae);te?W.reject(te):W.resolve(ae)})),W.promise}function t($e,J,W,se,ae,te,ce,le){const Z=new i(le),oe=I.$de.create(!1);return $e.info(`Creating a socket (${ce})...`),c.mark(`code/willCreateSocket/${te}`),J.connect(W,se,ae,ce).then(pe=>{Z.didTimeout?(c.mark(`code/didCreateSocketError/${te}`),$e.info(`Creating a socket (${ce}) finished after ${oe.elapsed()} ms, but this is too late and has timed out already.`),pe?.dispose()):(c.mark(`code/didCreateSocketOK/${te}`),$e.info(`Creating a socket (${ce}) was successful after ${oe.elapsed()} ms.`),Z.resolve(pe))},pe=>{c.mark(`code/didCreateSocketError/${te}`),$e.info(`Creating a socket (${ce}) returned an error after ${oe.elapsed()} ms.`),$e.error(pe),Z.reject(pe)}),Z.promise}function s($e,J){const W=new i(J);return $e.then(se=>{W.didTimeout||W.resolve(se)},se=>{W.didTimeout||W.reject(se)}),W.promise}async function n($e,J,W,se){const ae=re($e,J);$e.logService.trace(`${ae} 1/6. invoking socketFactory.connect().`);let te;try{te=await t($e.logService,$e.remoteSocketFactoryService,$e.connectTo,b.$Pg.getServerRootPath(),`reconnectionToken=${$e.reconnectionToken}&reconnection=${$e.reconnectionProtocol?"true":"false"}`,$(J),`renderer-${$(J)}-${$e.reconnectionToken}`,se)}catch(pe){throw $e.logService.error(`${ae} socketFactory.connect() failed or timed out. Error:`),$e.logService.error(pe),pe}$e.logService.trace(`${ae} 2/6. socketFactory.connect() was successful.`);let ce,le;$e.reconnectionProtocol?($e.reconnectionProtocol.beginAcceptReconnection(te,null),ce=$e.reconnectionProtocol,le=!1):(ce=new u.$qi({socket:te}),le=!0),$e.logService.trace(`${ae} 3/6. sending AuthRequest control message.`);const Z=await s($e.signService.createNewMessage((0,D.$Yg)()),se),oe={type:"auth",auth:$e.connectionToken||"00000000000000000000",data:Z.data};ce.sendControl(h.$Le.fromString(JSON.stringify(oe)));try{const pe=await o(ce,g(se,f(1e4)));if(pe.type!=="sign"||typeof pe.data!="string"){const Se=new Error("Unexpected handshake message");throw Se.code="VSCODE_CONNECTION_ERROR",Se}if($e.logService.trace(`${ae} 4/6. received SignRequest control message.`),!await s($e.signService.validate(Z,pe.signedData),se)){const Se=new Error("Refused to connect to unsupported server");throw Se.code="VSCODE_CONNECTION_ERROR",Se}const Fe=await s($e.signService.sign(pe.data),se),We={type:"connectionType",commit:$e.commit,signedData:Fe,desiredConnectionType:J};return W&&(We.args=W),$e.logService.trace(`${ae} 5/6. sending ConnectionTypeRequest control message.`),ce.sendControl(h.$Le.fromString(JSON.stringify(We))),{protocol:ce,ownsProtocol:le}}catch(pe){throw pe&&pe.code==="ETIMEDOUT"&&($e.logService.error(`${ae} the handshake timed out. Error:`),$e.logService.error(pe)),pe&&pe.code==="VSCODE_CONNECTION_ERROR"&&($e.logService.error(`${ae} received error control message when negotiating connection. Error:`),$e.logService.error(pe)),le&&B(ce),pe}}async function d($e,J,W,se){const ae=Date.now(),te=re($e,J),{protocol:ce,ownsProtocol:le}=await n($e,J,W,se),Z=new i(se);return Z.registerDisposable(ce.onControlMessage(oe=>{const pe=JSON.parse(oe.toString()),we=G(pe);we?($e.logService.error(`${te} received error control message when negotiating connection. Error:`),$e.logService.error(we),le&&B(ce),Z.reject(we)):($e.reconnectionProtocol?.endAcceptReconnection(),$e.logService.trace(`${te} 6/6. handshake finished, connection is up and running after ${ye(ae)}!`),Z.resolve({protocol:ce,firstMessage:pe}))})),Z.promise}async function l($e,J){const{protocol:W}=await d($e,a.Management,void 0,J);return{protocol:W}}async function m($e,J,W){const{protocol:se,firstMessage:ae}=await d($e,a.ExtensionHost,J,W),te=ae&&ae.debugPort;return{protocol:se,debugPort:te}}async function E($e,J,W){const se=Date.now(),ae=re($e,a.Tunnel),{protocol:te}=await n($e,a.Tunnel,J,W);return $e.logService.trace(`${ae} 6/6. handshake finished, connection is up and running after ${ye(se)}!`),te}async function S($e,J,W){const{connectTo:se,connectionToken:ae}=await $e.addressProvider.getAddress();return{commit:$e.commit,quality:$e.quality,connectTo:se,connectionToken:ae,reconnectionToken:J,reconnectionProtocol:W,remoteSocketFactoryService:$e.remoteSocketFactoryService,signService:$e.signService,logService:$e.logService}}async function y($e,J,W){return A($e,async se=>{const{protocol:ae}=await l(se,C.CancellationToken.None);return new K($e,J,W,se.reconnectionToken,ae)})}async function k($e,J){return A($e,async W=>{const{protocol:se,debugPort:ae}=await m(W,J,C.CancellationToken.None);return new ne($e,J,W.reconnectionToken,se,ae)})}async function A($e,J){for(let se=1;;se++)try{const ae=(0,D.$Yg)(),te=await S($e,ae,null);return await J(te)}catch(ae){if(se<5)$e.logService.error(`[remote-connection][attempt ${se}] An error occurred in initial connection! Will retry... Error:`),$e.logService.error(ae);else throw $e.logService.error(`[remote-connection][attempt ${se}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),$e.logService.error(ae),V.triggerPermanentFailure(0,0,P.$Ql.isHandled(ae)),ae}}async function p($e,J,W){const se=await S($e,(0,D.$Yg)(),null);return await E(se,{host:J,port:W},C.CancellationToken.None)}function v($e){return(0,r.$ph)(J=>new Promise((W,se)=>{const ae=setTimeout(W,$e*1e3);J.onCancellationRequested(()=>{clearTimeout(ae),W()})}))}var F;(function($e){$e[$e.ConnectionLost=0]="ConnectionLost",$e[$e.ReconnectionWait=1]="ReconnectionWait",$e[$e.ReconnectionRunning=2]="ReconnectionRunning",$e[$e.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",$e[$e.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class N{constructor(J,W){this.reconnectionToken=J,this.millisSinceLastIncomingData=W,this.type=F.ConnectionLost}}e.$Zl=N;class O{constructor(J,W,se,ae){this.reconnectionToken=J,this.millisSinceLastIncomingData=W,this.durationSeconds=se,this.c=ae,this.type=F.ReconnectionWait}skipWait(){this.c.cancel()}}e.$1l=O;class j{constructor(J,W,se){this.reconnectionToken=J,this.millisSinceLastIncomingData=W,this.attempt=se,this.type=F.ReconnectionRunning}}e.$2l=j;class z{constructor(J,W,se){this.reconnectionToken=J,this.millisSinceLastIncomingData=W,this.attempt=se,this.type=F.ConnectionGain}}e.$3l=z;class M{constructor(J,W,se,ae){this.reconnectionToken=J,this.millisSinceLastIncomingData=W,this.attempt=se,this.handled=ae,this.type=F.ReconnectionPermanentFailure}}e.$4l=M;class V extends R.$Tc{static triggerPermanentFailure(J,W,se){this._permanentFailure=!0,this.f=J,this.g=W,this.h=se,this.j.forEach(ae=>ae.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(J=>J.y())}static debugPauseSocketWriting(){this.j.forEach(J=>J.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||V._permanentFailure}constructor(J,W,se,ae,te){super(),this.t=J,this.u=W,this.reconnectionToken=se,this.protocol=ae,this.w=te,this.m=this.B(new L.$je),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new z(this.reconnectionToken,0,0)),this.B(ae.onSocketClose(ce=>{const le=ue(this.t,this.reconnectionToken,!0);ce?ce.type===u.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${le} received socket close event (hadError: ${ce.hadError}).`),ce.error&&this.u.logService.error(ce.error)):(this.u.logService.info(`${le} received socket close event (wasClean: ${ce.wasClean}, code: ${ce.code}, reason: ${ce.reason}).`),ce.event&&this.u.logService.error(ce.event)):this.u.logService.info(`${le} received socket close event.`),this.y()})),this.B(ae.onSocketTimeout(ce=>{const le=ue(this.t,this.reconnectionToken,!0);this.u.logService.info(`${le} received socket timeout event (unacknowledgedMsgCount: ${ce.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ce.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ce.timeSinceLastReceivedSomeData}).`),this.y()})),V.j.push(this),this.B((0,R.$Rc)(()=>{const ce=V.j.indexOf(this);ce>=0&&V.j.splice(ce,1)})),this.n&&this.D(V.f,V.g,V.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const J=ue(this.t,this.reconnectionToken,!0);this.u.logService.info(`${J} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const W=[0,5,5,10,10,10,10,10,30];let se=-1;do{se++;const ae=se<W.length?W[se]:W[W.length-1];try{if(ae>0){const ce=v(ae);this.m.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ae,ce)),this.u.logService.info(`${J} waiting for ${ae} seconds before reconnecting...`);try{await ce}catch{}}if(this.n){this.u.logService.error(`${J} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se+1)),this.u.logService.info(`${J} resolving connection...`);const te=await S(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${J} connecting to ${te.connectTo}...`),await this.G(te,f(w)),this.u.logService.info(`${J} reconnected!`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se+1));break}catch(te){if(te.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${J} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}if(se>360){this.u.logService.error(`${J} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}if(P.$Ql.isTemporarilyNotAvailable(te)){this.u.logService.info(`${J} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(te);continue}if((te.code==="ETIMEDOUT"||te.code==="ENETUNREACH"||te.code==="ECONNREFUSED"||te.code==="ECONNRESET")&&te.syscall==="connect"){this.u.logService.info(`${J} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(te);continue}if((0,T.$3)(te)){this.u.logService.info(`${J} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(te);continue}if(te instanceof P.$Ql){this.u.logService.error(`${J} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,P.$Ql.isHandled(te));break}this.u.logService.error(`${J} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}}while(!this.n&&!this.s)}C(J,W,se){this.w?V.triggerPermanentFailure(J,W,se):this.D(J,W,se)}D(J,W,se){this.m.fire(new M(this.reconnectionToken,J,W,se)),B(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$5l=V;class K extends V{constructor(J,W,se,ae,te){super(a.Management,J,ae,te,!0),this.client=this.B(new u.$oi(te,{remoteAuthority:W,clientId:se},J.ipcLogger))}async G(J,W){await l(J,W)}}e.$6l=K;class ne extends V{constructor(J,W,se,ae,te){super(a.ExtensionHost,J,se,ae,!1),this.H=W,this.debugPort=te}async G(J,W){await m(J,this.H,W)}}e.$7l=ne;function B($e){try{$e.acceptDisconnect();const J=$e.getSocket();$e.dispose(),J.dispose()}catch(J){(0,T.$Y)(J)}}function G($e){if($e&&$e.type==="error"){const J=new Error(`Connection error: ${$e.reason}`);return J.code="VSCODE_CONNECTION_ERROR",J}return null}function Y($e,J){for(;$e.length<J;)$e+=" ";return $e}function ee($e,J){return`[remote-connection][${Y($($e),13)}][${J.substr(0,5)}\u2026]`}function ue($e,J,W){return`${ee($e,J)}[${W?"reconnect":"initial"}]`}function re($e,J){return`${ue(J,$e.reconnectionToken,!!$e.reconnectionProtocol)}[${$e.connectTo}]`}function ye($e){return`${Date.now()-$e} ms`}}),define(ke[90],Ie([1,0,14]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=h,e.$en=C,e.$fn=T,e.$gn=L;function h(b){return b.scheme===r.Schemas.vscodeRemote?b.authority:void 0}function C(b){if(!b)return;const c=b.indexOf("+");return c<0?b:b.substr(0,c)}function T(b){const{host:c,port:I}=R(b);if(typeof I>"u")throw new Error(`Invalid remote authority: ${b}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:I}}function L(b,c){let{host:I,port:D}=R(b);return typeof D>"u"&&(D=c),{host:I,port:D}}function R(b){const c=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const I=b.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const D=b.match(/(.*):(\d+)$/);return D?{host:D[1],port:parseInt(D[2],10)}:{host:b,port:void 0}}}),define(ke[23],Ie([1,0,12,5,90]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=e.$pn=e.$on=e.$nn=e.TargetPlatform=e.ExtensionType=e.$mn=e.$kn=e.$jn=e.$in=e.$hn=void 0,e.$ln=T,e.$qn=D,e.$rn=u,e.$sn=P,e.$tn=w,e.$un=a,e.$vn=$,r=Ue(r),e.$hn="extensions.user.cache",e.$in="extensions.builtin.cache",e.$jn="undefined_publisher",e.$kn=["ui","workspace","web"];function T(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.$mn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(L||(e.ExtensionType=L={}));var R;(function(f){f.WIN32_X64="win32-x64",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class b{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,i){if(typeof g>"u"||g===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof g=="string"||typeof i=="string"){const o=typeof g=="string"?g:g.value,t=typeof i=="string"?i:i.value;return r.$Df(o,t)}return g._lower===i._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$nn=b;class c{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const i of g)this.add(i)}add(g){this.c.add(b.toKey(g))}delete(g){return this.c.delete(b.toKey(g))}has(g){return this.c.has(b.toKey(g))}}e.$on=c;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete(b.toKey(g))}get(g){return this.c.get(b.toKey(g))}has(g){return this.c.has(b.toKey(g))}set(g,i){this.c.set(b.toKey(g),i)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$pn=I;function D(f){return u(f)}function u(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}function P(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}function w(f,g){if(g){const i=`onResolveRemoteAuthority:${(0,C.$en)(g)}`;return!!f.activationEvents?.includes(i)}return!1}function a(f){return f.map(g=>{const[i,o]=g.split("@");return{proposalName:i,version:o?parseInt(o):void 0}})}function $(f){return f.map(g=>g.split("@")[0])}e.$wn=(0,h.$Ci)("IBuiltinExtensionsScannerService")}),define(ke[146],Ie([1,0,10,8,23,5]),function(me,e,r,h,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.ExtensionManagementErrorCode=e.$ip=e.ExtensionGalleryErrorCode=e.$hp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=void 0,e.$bp=R,e.$cp=b,e.$dp=c,e.$ep=I,e.$fp=D,e.$gp=u,e.$7o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$8o=new RegExp(e.$7o),e.$9o="__web_extension",e.$0o="skipWalkthrough",e.$$o="extensionInstallSource",e.$_o="dependecyOrPackExtensionInstall",e.$ap="clientTargetPlatform";var L;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(L||(e.ExtensionInstallSource=L={}));function R(t){switch(t){case C.TargetPlatform.WIN32_X64:return"Windows 64 bit";case C.TargetPlatform.WIN32_ARM64:return"Windows ARM";case C.TargetPlatform.LINUX_X64:return"Linux 64 bit";case C.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case C.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case C.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case C.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case C.TargetPlatform.DARWIN_X64:return"Mac";case C.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case C.TargetPlatform.WEB:return"Web";case C.TargetPlatform.UNIVERSAL:return C.TargetPlatform.UNIVERSAL;case C.TargetPlatform.UNKNOWN:return C.TargetPlatform.UNKNOWN;case C.TargetPlatform.UNDEFINED:return C.TargetPlatform.UNDEFINED}}function b(t){switch(t){case C.TargetPlatform.WIN32_X64:return C.TargetPlatform.WIN32_X64;case C.TargetPlatform.WIN32_ARM64:return C.TargetPlatform.WIN32_ARM64;case C.TargetPlatform.LINUX_X64:return C.TargetPlatform.LINUX_X64;case C.TargetPlatform.LINUX_ARM64:return C.TargetPlatform.LINUX_ARM64;case C.TargetPlatform.LINUX_ARMHF:return C.TargetPlatform.LINUX_ARMHF;case C.TargetPlatform.ALPINE_X64:return C.TargetPlatform.ALPINE_X64;case C.TargetPlatform.ALPINE_ARM64:return C.TargetPlatform.ALPINE_ARM64;case C.TargetPlatform.DARWIN_X64:return C.TargetPlatform.DARWIN_X64;case C.TargetPlatform.DARWIN_ARM64:return C.TargetPlatform.DARWIN_ARM64;case C.TargetPlatform.WEB:return C.TargetPlatform.WEB;case C.TargetPlatform.UNIVERSAL:return C.TargetPlatform.UNIVERSAL;default:return C.TargetPlatform.UNKNOWN}}function c(t,s){switch(t){case r.Platform.Windows:return s==="x64"?C.TargetPlatform.WIN32_X64:s==="arm64"?C.TargetPlatform.WIN32_ARM64:C.TargetPlatform.UNKNOWN;case r.Platform.Linux:return s==="x64"?C.TargetPlatform.LINUX_X64:s==="arm64"?C.TargetPlatform.LINUX_ARM64:s==="arm"?C.TargetPlatform.LINUX_ARMHF:C.TargetPlatform.UNKNOWN;case"alpine":return s==="x64"?C.TargetPlatform.ALPINE_X64:s==="arm64"?C.TargetPlatform.ALPINE_ARM64:C.TargetPlatform.UNKNOWN;case r.Platform.Mac:return s==="x64"?C.TargetPlatform.DARWIN_X64:s==="arm64"?C.TargetPlatform.DARWIN_ARM64:C.TargetPlatform.UNKNOWN;case r.Platform.Web:return C.TargetPlatform.WEB}}function I(t,s){return s===C.TargetPlatform.WEB&&!t.includes(C.TargetPlatform.WEB)}function D(t,s,n){return I(s,n)?!1:t===C.TargetPlatform.UNDEFINED||t===C.TargetPlatform.UNIVERSAL?!0:t===C.TargetPlatform.UNKNOWN?!1:t===n}function u(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var P;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(P||(e.SortBy=P={}));var w;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(w||(e.SortOrder=w={}));var a;(function(t){t.Install="install",t.Uninstall="uninstall"})(a||(e.StatisticType=a={}));var $;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})($||(e.InstallOperation=$={})),e.$hp=(0,T.$Ci)("extensionGalleryService");var f;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})(f||(e.ExtensionGalleryErrorCode=f={}));class g extends Error{constructor(s,n){super(s),this.code=n,this.name=n}}e.$ip=g;var i;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateExistingMetadata="UpdateExistingMetadata",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class o extends Error{constructor(s,n){super(s),this.code=n,this.name=n}}e.$jp=o,e.$kp=(0,T.$Ci)("extensionManagementService"),e.$lp="extensionsIdentifiers/disabled",e.$mp="extensionsIdentifiers/enabled",e.$np=(0,T.$Ci)("IGlobalExtensionEnablementService"),e.$op=(0,T.$Ci)("IExtensionTipsService"),e.$pp=(0,h.localize2)(11334,"Extensions"),e.$qp=(0,h.localize2)(11335,"Preferences")}),define(ke[147],Ie([1,0,13,23]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KG=e.$JG=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(L,R){this.a.set(L,R)}readActivationEvents(L){return this.b.has(L)||this.b.set(L,this.c(L)),this.b.get(L)}createActivationEventsMap(L){const R=Object.create(null);for(const b of L){const c=this.readActivationEvents(b);c.length>0&&(R[h.$nn.toKey(b.identifier)]=c)}return R}c(L){if(typeof L.main>"u"&&typeof L.browser>"u")return[];const R=Array.isArray(L.activationEvents)?L.activationEvents.slice(0):[];for(let b=0;b<R.length;b++)R[b]==="onUri"&&(R[b]=`onUri:${h.$nn.toKey(L.identifier)}`);if(!L.contributes)return R;for(const b in L.contributes){const c=this.a.get(b);if(!c)continue;const I=L.contributes[b],D=Array.isArray(I)?I:[I];try{c(D,R)}catch(u){(0,r.$Y)(u)}}return R}}e.$JG=C,e.$KG=new C});var zt=this&&this.__importDefault||function(me){return me&&me.__esModule?me:{default:me}};define(ke[234],Ie([1,0,22,43,8,360,23,143]),function(me,e,r,h,C,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=I,e.$Wp=D,e.$Xp=u,e.$Yp=P,e.$Zp=w,e.$1p=a,e.$2p=$,e.$3p=f,h=zt(h),C=Ue(C),T=Ue(T);const b=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,c=/^-(\d{4})(\d{2})(\d{2})$/;function I(o){return o=o.trim(),o==="*"||b.test(o)}function D(o){if(!I(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=o.match(b);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function u(o){if(!o)return null;const t=o.majorBase,s=o.majorMustEqual,n=o.minorBase;let d=o.minorMustEqual;const l=o.patchBase;let m=o.patchMustEqual;o.hasCaret&&(t===0||(d=!1),m=!1);let E=0;if(o.preRelease){const S=c.exec(o.preRelease);if(S){const[,y,k,A]=S;E=Date.UTC(Number(y),Number(k)-1,Number(A))}}return{majorBase:t,majorMustEqual:s,minorBase:n,minorMustEqual:d,patchBase:l,patchMustEqual:m,isMinimum:o.hasGreaterEquals,notBefore:E}}function P(o,t,s){let n;typeof o=="string"?n=u(D(o)):n=o;let d;t instanceof Date?d=t.getTime():typeof t=="string"&&(d=new Date(t).getTime());let l;if(typeof s=="string"?l=u(D(s)):l=s,!n||!l)return!1;const m=n.majorBase,E=n.minorBase,S=n.patchBase;let y=l.majorBase,k=l.minorBase,A=l.patchBase;const p=l.notBefore;let v=l.majorMustEqual,F=l.minorMustEqual,N=l.patchMustEqual;return l.isMinimum?m>y?!0:m<y?!1:E>k?!0:E<k||d&&d<p?!1:S>=A:(m===1&&y===0&&(!v||!F||!N)&&(y=1,k=0,A=0,v=!0,F=!1,N=!1),m<y?!1:m>y?!v:E<k?!1:E>k?!F:S<A?!1:S>A?!N:!(d&&d<p))}function w(o,t,s,n,d,l){const m=[];if(typeof n.publisher<"u"&&typeof n.publisher!="string")return m.push([h.default.Error,C.localize(11266,null)]),m;if(typeof n.name!="string")return m.push([h.default.Error,C.localize(11267,null,"name")]),m;if(typeof n.version!="string")return m.push([h.default.Error,C.localize(11268,null,"version")]),m;if(!n.engines)return m.push([h.default.Error,C.localize(11269,null,"engines")]),m;if(typeof n.engines.vscode!="string")return m.push([h.default.Error,C.localize(11270,null,"engines.vscode")]),m;if(typeof n.extensionDependencies<"u"&&!i(n.extensionDependencies))return m.push([h.default.Error,C.localize(11271,null,"extensionDependencies")]),m;if(typeof n.activationEvents<"u"){if(!i(n.activationEvents))return m.push([h.default.Error,C.localize(11272,null,"activationEvents")]),m;if(typeof n.main>"u"&&typeof n.browser>"u")return m.push([h.default.Error,C.localize(11273,null,"activationEvents","main","browser")]),m}if(typeof n.extensionKind<"u"&&typeof n.main>"u"&&m.push([h.default.Warning,C.localize(11274,null,"extensionKind")]),typeof n.main<"u"){if(typeof n.main!="string")return m.push([h.default.Error,C.localize(11275,null,"main")]),m;{const y=(0,r.$dh)(s,n.main);(0,r.$0g)(y,s)||m.push([h.default.Warning,C.localize(11276,null,y.path,s.path)])}}if(typeof n.browser<"u"){if(typeof n.browser!="string")return m.push([h.default.Error,C.localize(11277,null,"browser")]),m;{const y=(0,r.$dh)(s,n.browser);(0,r.$0g)(y,s)||m.push([h.default.Warning,C.localize(11278,null,y.path,s.path)])}}if(!T.valid(n.version))return m.push([h.default.Error,C.localize(11279,null)]),m;const E=[];if(!a(o,t,n,d,E))for(const y of E)m.push([h.default.Error,y]);if(l&&n.enabledApiProposals?.length){const y=[];if(!f([...n.enabledApiProposals],y))for(const k of y)m.push([h.default.Error,k])}return m}function a(o,t,s,n,d){return n||typeof s.main>"u"&&typeof s.browser>"u"?!0:g(o,t,s.engines.vscode,d)}function $(o,t,s){return o==="*"||g(t,s,o)}function f(o,t){if(o.length===0)return!0;const s=Array.isArray(t)?t:void 0,n=(s?void 0:t)??R.allApiProposals,d=[],l=(0,L.$un)(o);for(const{proposalName:m,version:E}of l){const S=n[m];S&&E&&S.version!==E&&d.push(C.localize(11280,null,m))}return s?.push(...d),d.length===0}function g(o,t,s,n=[]){const d=u(D(s));if(!d)return n.push(C.localize(11281,null,s)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return n.push(C.localize(11282,null,s)),!1}else if(!d.majorMustEqual)return n.push(C.localize(11283,null,s)),!1;return P(o,t,d)?!0:(n.push(C.localize(11284,null,o,s)),!1)}function i(o){if(!Array.isArray(o))return!1;for(let t=0,s=o.length;t<s;t++)if(typeof o[t]!="string")return!1;return!0}}),define(ke[235],Ie([1,0,3,5]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=void 0,e.$Sl=(0,h.$Ci)("remoteSocketFactoryService");class C{constructor(){this.a={}}register(L,R){return this.a[L]??=[],this.a[L].push(R),(0,r.$Rc)(()=>{const b=this.a[L]?.indexOf(R);typeof b=="number"&&b>=0&&this.a[L]?.splice(b,1)})}b(L){return(this.a[L.type]||[]).find(b=>b.supports(L))}connect(L,R,b,c){const I=this.b(L);if(!I)throw new Error(`No socket factory found for ${L}`);return I.connect(L,R,b,c)}}e.$Tl=C}),define(ke[236],Ie([1,0,21,13,3,8,70,5,11,36]),function(me,e,r,h,C,T,L,R,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=void 0,e.$6p=u,e.$7p=P,e.$8p=w,e.$9p=a,e.$0p=$,e.$$p=f,e.$4p=(0,R.$Ci)("requestService");class I{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const s in this.b)s.toLowerCase()==="authorization"||s.toLowerCase()==="proxy-authorization"?t[s]="*****":t[s]=this.b[s];this.a=t}return this.a}}class D extends C.$Tc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,T.localize)(11053,null),when:b.$ok.isEqualTo((0,b.$lk)(b.LogLevel.Trace)).serialize()})}async c(t,s,n){const d=`${t} #${++this.b}: ${s.url}`;this.a.trace(`${d} - begin`,s.type,new I(s.headers??{}));try{const l=await n();return this.a.trace(`${d} - end`,s.type,l.res.statusCode,l.res.headers),l}catch(l){throw this.a.error(`${d} - error`,s.type,(0,h.$9)(l)),l}}}e.$5p=D;function u(o){return o.res.statusCode&&o.res.statusCode>=200&&o.res.statusCode<300||o.res.statusCode===1223}function P(o){return o.res.statusCode===204}async function w(o){return P(o)?null:(await(0,r.$Xe)(o.stream)).toString()}async function a(o){if(!u(o))throw new Error("Server returned "+o.res.statusCode);return w(o)}async function $(o){if(!u(o))throw new Error("Server returned "+o.res.statusCode);if(P(o))return null;const s=(await(0,r.$Xe)(o.stream)).toString();try{return JSON.parse(s)}catch(n){throw n.message+=`:
`+s,n}}function f(o){i(o)}let g;function i(o){const t=c.$no.as(L.$so.Configuration),s=g;g={id:"http",order:15,title:(0,T.localize)(11054,null),type:"object",scope:o,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,T.localize)(11055,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,T.localize)(11056,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,T.localize)(11057,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,T.localize)(11058,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,T.localize)(11059,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,T.localize)(11060,null),(0,T.localize)(11061,null),(0,T.localize)(11062,null),(0,T.localize)(11063,null)],default:"override",description:(0,T.localize)(11064,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,T.localize)(11065,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,T.localize)(11066,null),restricted:!0}}},t.updateConfigurations({add:[g],remove:s?[s]:[]})}i(L.ConfigurationScope.APPLICATION)}),define(ke[237],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Obc=void 0;class r{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(C){try{const T=await this.c();if(T){const L=String(r.a++);return this.b.set(L,T),{id:L,data:T.createNewMessage(C)}}}catch{}return{id:"",data:C}}async validate(C,T){if(!C.id)return!0;const L=this.b.get(C.id);if(!L)return!1;this.b.delete(C.id);try{return L.validate(T)==="ok"}catch{return!1}finally{L.dispose?.()}}async sign(C){try{return await this.d(C)}catch{}return C}}e.$Obc=r}),define(ke[117],Ie([1,0,5]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.$Ul=void 0,e.$Ul="signService",e.$Vl=(0,r.$Ci)(e.$Ul)}),define(ke[148],Ie([1,0,237]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ugc=void 0;class h extends r.$Obc{c(){return this.h().then(T=>new T.validator)}d(T){return this.h().then(L=>new L.signer().sign(T))}h(){return new Promise((T,L)=>me(["vsda"],T,L))}}e.$Ugc=h}),define(ke[238],Ie([1,0,10,55,32]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=L,e.$sp=R;function T(b){if(r.$v===r.Platform.Linux&&/^penguin(\.|$)/i.test(b))return"chromebook"}function L(b,c,I,D,u,P,w,a,$,f){const g=Object.create(null);g["common.machineId"]=P,g["common.sqmId"]=w,g["common.devDeviceId"]=a,g.sessionID=(0,C.$Yg)()+Date.now(),g.commitHash=D,g.version=u,g["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,r.$i)(r.$v),g["common.nodePlatform"]=h.$cc,g["common.nodeArch"]=I,g["common.product"]=f||"desktop",$&&(g["common.msftInternal"]=$);let i=0;const o=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),r.$m&&(g["common.snap"]="true");const t=T(c);return t&&(g["common.platformDetail"]=t),g}function R(b){const c=h.env.USERDNSDOMAIN;if(!c)return!1;const I=c.toLowerCase();return b.some(D=>I===D)}}),define(ke[149],Ie([1,0,5]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=void 0,e.$8l=(0,r.$Ci)("telemetryService"),e.$9l=(0,r.$Ci)("customEndpointTelemetryService"),e.$0l="telemetry.currentSessionDate",e.$$l="telemetry.firstSessionDate",e.$_l="telemetry.lastSessionDate",e.$am="telemetry.machineId",e.$bm="telemetry.sqmId",e.$cm="telemetry.devDeviceId",e.$dm="telemetry",e.$em="telemetry.telemetryLevel",e.$fm="telemetry.enableCrashReporter",e.$gm="telemetry.enableTelemetry";var h;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(h||(e.TelemetryLevel=h={}));var C;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(ke[91],Ie([1,0,24,17,90,238,149]),function(me,e,r,h,C,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=void 0,e.$Ap=I,e.$Bp=D,e.$Cp=u,e.$Dp=P,e.$Ep=a,e.$Fp=f,e.$Gp=g,e.$Hp=t;class R{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$tp=R;class b{constructor(){this.telemetryLevel=L.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$up=b,e.$vp=new b;class c{async publicLog(n,d,l){}async publicLogError(n,d,l){}}e.$wp=c,e.$xp="telemetry",e.$yp="extensionTelemetryLog",e.$zp={log:()=>null,flush:()=>Promise.resolve(null)};function I(s,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!s.enableTelemetry)}function D(s,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}function u(s){const n=s.getValue(L.$em),d=s.getValue(L.$fm);if(s.getValue(L.$gm)===!1||d===!1)return L.TelemetryLevel.NONE;switch(n??L.TelemetryConfiguration.ON){case L.TelemetryConfiguration.ON:return L.TelemetryLevel.USAGE;case L.TelemetryConfiguration.ERROR:return L.TelemetryLevel.ERROR;case L.TelemetryConfiguration.CRASH:return L.TelemetryLevel.CRASH;case L.TelemetryConfiguration.OFF:return L.TelemetryLevel.NONE}}function P(s){const n={},d={},l={};$(s,l);for(let m in l){m=m.length>150?m.substr(m.length-149):m;const E=l[m];typeof E=="number"?d[m]=E:typeof E=="boolean"?d[m]=E?1:0:typeof E=="string"?(E.length>8192&&console.warn(`Telemetry property: ${m} has been trimmed to 8192, the original length is ${E.length}`),n[m]=E.substring(0,8191)):typeof E<"u"&&E!==null&&(n[m]=E)}return{properties:n,measurements:d}}const w=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(s){if(!s)return"none";const n=(0,C.$en)(s);return w.has(n)?n:"other"}function $(s,n,d=0,l){if(s)for(const m of Object.getOwnPropertyNames(s)){const E=s[m],S=l?l+m:m;Array.isArray(E)?n[S]=(0,r.$fo)(E):E instanceof Date?n[S]=E.toISOString():(0,h.$eg)(E)?d<2?$(E,n,d+1,S+"."):n[S]=(0,r.$fo)(E):n[S]=E}}function f(s,n){const d=s.msftInternalDomains||[],l=n.getValue("telemetry.internalTesting");return(0,T.$sp)(d)||l}function g(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}function i(s,n){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let d=s;const l=[];for(const y of n)for(;;){const k=y.exec(s);if(!k)break;l.push([k.index,y.lastIndex])}const m=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,E=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(d="";;){const y=E.exec(s);if(!y)break;const k=l.some(([A,p])=>y.index<p&&A<E.lastIndex);!m.test(y[0])&&!k&&(d+=s.substring(S,y.index)+"<REDACTED: user-file-path>",S=E.lastIndex)}return S<s.length&&(d+=s.substr(S)),d}function o(s){if(!s)return s;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of n)if(d.regex.test(s))return`<REDACTED: ${d.label}>`;return s}function t(s,n){return(0,r.$co)(s,d=>{if(d instanceof R||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let l=d.replaceAll("%20"," ");l=i(l,n);for(const m of n)l=l.replace(m,"");return l=o(l),l}})}}),define(ke[239],Ie([1,0,12,146,23,10,2,13,55,91]),function(me,e,r,h,C,T,L,R,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Jp=void 0,e.$Ip=I,e.$Kp=w,e.$Lp=a,e.$Mp=$,e.$Np=f,e.$Op=g,e.$Pp=i,e.$Qp=o,e.$Sp=t,e.$Tp=n;function I(d,l){return d.uuid&&l.uuid?d.uuid===l.uuid:d.id===l.id?!0:(0,r.$yf)(d.id,l.id)===0}const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(l){const m=l.manifest?l.manifest.version:l.version,E=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new u(l.identifier,m,E)}static parse(l){const m=D.exec(l);return m&&m[1]&&m[2]?new u({id:m[1]},m[2],m[4]||void 0):null}constructor(l,m,E=C.TargetPlatform.UNDEFINED){this.identifier=l,this.version=m,this.targetPlatform=E,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==C.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof u?I(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.$Jp=u;const P=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(d){const l=P.exec(d);return l&&l[1]?[$(l[1]),l[2]]:[$(d),void 0]}function a(d,l){return`${d}.${l}`}function $(d){return d.toLowerCase()}function f(d,l){return $(a(d??C.$jn,l))}function g(d,l){const m=[],E=S=>{for(const y of m)if(y.some(k=>I(l(k),l(S))))return y;return null};for(const S of d){const y=E(S);y?y.push(S):m.push([S])}return m}function i(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}function o(d){return{id:new c.$tp(d.identifier.id),name:new c.$tp(d.name),version:d.version,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$Rp=new C.$nn("pprice.better-merge");function t(d,l){const m=[],E=l.manifest.extensionDependencies?.slice(0)??[];for(;E.length;){const S=E.shift();if(S&&m.every(y=>!I(y.identifier,{id:S}))){const y=d.filter(k=>I(k.identifier,{id:S}));y.length===1&&(m.push(y[0]),E.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return m}async function s(d,l){if(!T.$l)return!1;let m;try{m=(await d.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{m=(await d.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){l.debug("Error while getting the os-release file.",(0,R.$9)(S))}}return!!m&&(m.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(d,l){const m=await s(d,l),E=(0,h.$dp)(m?"alpine":T.$v,b.$dc);return l.debug("ComputeTargetPlatform:",E),E}}),define(ke[240],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bs=r,e.$Cs=h,e.$Ds=C,e.$Es=T,e.$Fs=L,e.$Gs=R;function r(b){return[...b.entries()]}function h(b){return b?[...b.entries()]:[]}function C(b){return new Map(b)}function T(b){return new Map(b??[])}function L(b){return Array.from(b.entries()).map(c=>[c[0],r(c[1].map),h(c[1].descriptionMap)])}function R(b){return new Map(b.map(c=>[c[0],{map:C(c[1]),descriptionMap:T(c[2])}]))}}),define(ke[241],Ie([1,0,5,35,36]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$os=e.$ns=e.$ms=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ls=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ks=void 0,e.$ks=new h.$Tj("terminalTabFocusMode",!1,!0);var T;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(T||(e.TerminalSettingPrefix=T={}));var L;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(L||(e.TerminalSettingId=L={}));var R;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(R||(e.PosixShellType=R={}));var b;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})(b||(e.WindowsShellType=b={}));var c;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var I;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(I||(e.TerminalIpcChannels=I={}));var D;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(D||(e.ProcessPropertyType=D={})),e.$ls=(0,r.$Ci)("ptyService");var u;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(u||(e.HeartbeatConstants=u={}));var P;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(P||(e.TerminalLocation=P={}));var w;(function(t){t.TerminalView="view",t.Editor="editor"})(w||(e.TerminalLocationString=w={}));var a;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(a||(e.LocalReconnectConstants=a={}));var $;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})($||(e.FlowControlConstants=$={}));var f;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(f||(e.ProfileSource=f={}));var g;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(g||(e.ShellIntegrationStatus=g={}));var i;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(i||(e.TerminalExitReason=i={})),e.$ms={Backend:"workbench.contributions.terminal.processBackend"};class o{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(s){const n=this.b(s.remoteAuthority);if(this.a.has(n))throw new Error(`A terminal backend with remote authority '${n}' was already registered.`);this.a.set(n,s)}getTerminalBackend(s){return this.a.get(this.b(s))}b(s){return s?.toLowerCase()??""}}C.$no.add(e.$ms.Backend,new o),e.$ns=(0,r.$Ci)("localPtyService"),e.$os=(0,r.$Ci)("terminalLogService")}),define(ke[242],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vxb=void 0;class r{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,T,L=5){const R=T(b=>{const c=typeof b=="string"?b:b.data;let I=this.a.get(C);if(I){I.data.push(c);return}const D=setTimeout(()=>this.flushBuffer(C),L);I={data:[c],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(C),R.dispose()}},this.a.set(C,I)});return R}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const T=this.a.get(C);T&&(this.a.delete(C),this.b(C,T.data.join("")))}}e.$vxb=r}),define(ke[243],Ie([1,0,7,82,106,50,4,17,2,8,116,36]),function(me,e,r,h,C,T,L,R,b,c,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dx=e.$Cx=e.$Bx=e.$Ax=e.$zx=e.$yx=e.IconFontDefinition=e.IconContribution=e.$vx=void 0,e.$wx=$,e.$xx=f,D=Ue(D),e.$vx={IconContribution:"base.contributions.icons"};var u;(function(t){function s(n,d){let l=n.defaults;for(;T.ThemeIcon.isThemeIcon(l);){const m=a.getIcon(l.id);if(!m)return;l=m.defaults}return l}t.getDefinition=s})(u||(e.IconContribution=u={}));var P;(function(t){function s(d){return{weight:d.weight,style:d.style,src:d.src.map(l=>({format:l.format,location:l.location.toString()}))}}t.toJSONObject=s;function n(d){const l=m=>(0,R.$cg)(m)?m:void 0;if(d&&Array.isArray(d.src)&&d.src.every(m=>(0,R.$cg)(m.format)&&(0,R.$cg)(m.location)))return{weight:l(d.weight),style:l(d.style),src:d.src.map(m=>({format:m.format,location:b.URI.parse(m.location)}))}}t.fromJSONObject=n})(P||(e.IconFontDefinition=P={}));class w{constructor(){this.a=new L.$je,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,c.localize)(10985,null)},fontCharacter:{type:"string",description:(0,c.localize)(10986,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${T.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(s,n,d,l){const m=this.b[s];if(m){if(d&&!m.description){m.description=d,this.d.properties[s].markdownDescription=`${d} $(${s})`;const y=this.e.enum.indexOf(s);y!==-1&&(this.e.enumDescriptions[y]=d),this.a.fire()}return m}const E={id:s,description:d,defaults:n,deprecationMessage:l};this.b[s]=E;const S={$ref:"#/definitions/icons"};return l&&(S.deprecationMessage=l),d&&(S.markdownDescription=`${d}: $(${s})`),this.d.properties[s]=S,this.e.enum.push(s),this.e.enumDescriptions.push(d||""),this.a.fire(),{id:s}}deregisterIcon(s){delete this.b[s],delete this.d.properties[s];const n=this.e.enum.indexOf(s);n!==-1&&(this.e.enum.splice(n,1),this.e.enumDescriptions.splice(n,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(s=>this.b[s])}getIcon(s){return this.b[s]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(s,n){const d=this.f[s];return d||(this.f[s]=n,this.a.fire(),n)}deregisterIconFont(s){delete this.f[s]}getIconFont(s){return this.f[s]}toString(){const s=(m,E)=>m.id.localeCompare(E.id),n=m=>{for(;T.ThemeIcon.isThemeIcon(m.defaults);)m=this.b[m.defaults.id];return`codicon codicon-${m?m.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.b).map(m=>this.b[m]);for(const m of l.filter(E=>!!E.description).sort(s))d.push(`|<i class="${n(m)}"></i>|${m.id}|${T.ThemeIcon.isThemeIcon(m.defaults)?m.defaults.id:m.id}|${m.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const m of l.filter(E=>!T.ThemeIcon.isThemeIcon(E.defaults)).sort(s))d.push(`|<i class="${n(m)}"></i>|${m.id}|`);return d.join(`
`)}}const a=new w;D.$no.add(e.$vx.IconContribution,a);function $(t,s,n,d){return a.registerIcon(t,s,n,d)}function f(){return a}function g(){const t=(0,C.$Xj)();for(const s in t){const n="\\"+t[s].toString(16);a.registerIcon(s,{fontCharacter:n})}}g(),e.$yx="vscode://schemas/icons";const i=D.$no.as(I.$oo.JSONContribution);i.registerSchema(e.$yx,a.getIconSchema());const o=new r.$Oh(()=>i.notifySchemaChanged(e.$yx),200);a.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.$zx=$("widget-close",h.$2j.close,(0,c.localize)(10987,null)),e.$Ax=$("goto-previous-location",h.$2j.arrowUp,(0,c.localize)(10988,null)),e.$Bx=$("goto-next-location",h.$2j.arrowDown,(0,c.localize)(10989,null)),e.$Cx=T.ThemeIcon.modify(h.$2j.sync,"spin"),e.$Dx=T.ThemeIcon.modify(h.$2j.loading,"spin")}),define(ke[92],Ie([1,0,4,3,10,2,45,5,11]),function(me,e,r,h,C,T,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kw=e.$Jw=e.$Gw=e.$Ew=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Aw=e.$zw=void 0,e.$Bw=D,e.$Cw=P,e.$Dw=w,e.$Fw=a,e.$Hw=$,e.$Iw=f,e.$zw=(0,R.$Ci)("tunnelService"),e.$Aw=(0,R.$Ci)("sharedTunnelsService");var c;(function(o){o.Http="http",o.Https="https"})(c||(e.TunnelProtocol=c={}));var I;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(I||(e.TunnelPrivacyId=I={}));function D(o){return!!o.forwardPort}var u;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function P(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(t)return{address:t[1],port:+t[2]}}function w(o){if(o.scheme!=="http"&&o.scheme!=="https"||!o.query)return;const t=o.query.split("&");for(const s of t){const n=s.split("=")[1];if(/^https?:/.exec(n)){const d=P(T.URI.parse(n));if(d)return d}}}e.$Ew=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function a(o){return e.$Ew.indexOf(o)>=0}e.$Gw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function $(o){return e.$Gw.indexOf(o)>=0}function f(o,t,s,n){if(s===C.OperatingSystem.Windows)return!1;if(s===C.OperatingSystem.Macintosh&&$(t)){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(n);if(d?.length===4&&parseInt(d[1])>=18)return!1}return o<1024}class g{constructor(t,s,n){this.remoteAddress=t,this.localAddress=s,this.b=n,this.a=new r.$je,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Jw=g;let i=class extends h.$Tc{constructor(t,s){super(),this.r=t,this.s=s,this.a=new r.$je,this.onTunnelOpened=this.a.event,this.b=new r.$je,this.onTunnelClosed=this.b.event,this.c=new r.$je,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],s=Array.from(this.f.values());for(const n of s){const d=Array.from(n.values());for(const l of d){const m=await l.value;m&&typeof m!="string"&&t.push(m)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:s}of t.values())await s.then(n=>typeof n!="string"?n?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,s,n,d,l){this.z(t,s,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:s,localAddress:n,privacy:d,protocol:l,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,s){($(t)||a(t))&&(t=e.$Ew[0]);const n=this.D(t,s);if(n)return++n.refcount,n.value}openTunnel(t,s,n,d,l,m=!1,E,S){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${s}:${n} on local port ${l}.`);const y=this.g??t;if(!y)return;if(s||(s="localhost"),d||(d=this.t),this.g&&this.n.has(n)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const k=this.F(y,s,n,d,l,m,E,S);return k?k.then(A=>{if(A){if(typeof A=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(s,n),A}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(s,n);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const p=this.w(A);return(A.tunnelRemoteHost!==s||A.tunnelRemotePort!==n)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),E&&A.privacy!==E&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(p),p}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),k)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const s=this.f.get(t.tunnelRemoteHost);if(s){const n=s.get(t.tunnelRemotePort);n&&(n.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,n))}}}}async y(t,s,n){if(n.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${s}.`);const d=n.value.then(async l=>{l&&typeof l!="string"&&(await l.dispose(!0),this.b.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(s),d}}async closeTunnel(t,s){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${s} `);const n=this.f.get(t);if(n&&n.has(s)){const d=n.get(s);d.refcount=0,await this.y(t,s,d)}}z(t,s,n){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(s,{refcount:1,value:n})}async C(t,s){const n=this.f.get(t);if(n){const d=n.get(s),l=d?await d.value:void 0;(!l||typeof l=="string")&&n.delete(s),n.size===0&&this.f.delete(t)}}D(t,s){const n=[t];a(t)?(n.push(...e.$Ew),n.push(...e.$Gw)):$(t)&&n.push(...e.$Gw);const d=n.map(l=>this.f.get(l));for(const l of d){const m=l?.get(s);if(m)return m}}canTunnel(t){return!!P(t)}G(t,s,n,d,l,m,E){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${s}:${n} on local port ${d}.`);const S=n;this.n.add(S);const y=d===void 0?n:d,k={elevationRequired:l?this.isPortPrivileged(y):!1},A={remoteAddress:{host:s,port:n},localAddressPort:d,privacy:m,public:m?m!==I.Private:void 0,protocol:E},p=t.forwardPort(A,k);return p?(this.z(s,n,p),p.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(S)})):this.n.delete(S),p}};e.$Kw=i,e.$Kw=i=Ye([Ve(0,b.$9j),Ve(1,L.$9i)],i)}),define(ke[244],Ie([1,0,5]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=void 0,e.$Gl=(0,r.$Ci)("IUriIdentityService")}),define(ke[245],Ie([1,0,5]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Lw=void 0,e.$Lw=(0,r.$Ci)("editSessionIdentityService");var h;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(h||(e.EditSessionIdentityMatch=h={}))}),define(ke[246],Ie([1,0,14]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2M=h,e.$3M=C,e.$4M=T,e.$5M=L,e.$6M=R;function h(b){return b.scheme!==r.Schemas.file&&b.scheme!==r.Schemas.vscodeRemote}function C(b){if(b.folders.length)return b.folders.every(c=>h(c.uri))?b.folders[0].uri:void 0;if(b.configuration&&h(b.configuration))return b.configuration}function T(b){return C(b)?.scheme}function L(b){return C(b)?.authority}function R(b){return C(b)!==void 0}}),define(ke[46],Ie([1,0,8,16,84,22,2,5,14]),function(me,e,r,h,C,T,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Wi=e.$Vi=e.WorkbenchState=e.$Pi=e.$Oi=e.$Li=void 0,e.$Mi=c,e.$Ni=I,e.$Qi=D,e.$Ri=u,e.$Si=P,e.$Ti=a,e.$Ui=$,e.$Xi=i,e.$3i=o,e.$4i=t,e.$6i=s,e.$7i=n,e.$8i=d,e.$Li=(0,R.$Ci)("contextService");function c(l){const m=l;return typeof m?.id=="string"&&L.URI.isUri(m.uri)}function I(l){return typeof l?.id=="string"&&!c(l)&&!u(l)}e.$Oi={id:"ext-dev"},e.$Pi={id:"empty-window"};function D(l,m){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,h.$mc)(l)}:m?e.$Oi:e.$Pi;const E=l;return E.configuration?{id:E.id,configPath:E.configuration}:E.folders.length===1?{id:E.id,uri:E.folders[0].uri}:{id:E.id}}function u(l){const m=l;return typeof m?.id=="string"&&L.URI.isUri(m.configPath)}function P(l){const m=l;if(m?.uri)return{id:m.id,uri:L.URI.revive(m.uri)};const E=l;if(E?.configPath)return{id:E.id,configPath:L.URI.revive(E.configPath)};if(l?.id)return{id:l.id}}var w;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(w||(e.WorkbenchState=w={}));function a(l){const m=l;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}function $(l){const m=l;return!!(m&&typeof m=="object"&&L.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}class f{constructor(m,E,S,y,k){this.h=m,this.j=S,this.k=y,this.l=k,this.c=C.$Ii.forUris(this.l,()=>!0),this.folders=E}update(m){this.h=m.id,this.k=m.configuration,this.j=m.transient,this.l=m.l,this.folders=m.folders}get folders(){return this.g}set folders(m){this.g=m,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(m){this.k=m}getFolder(m){return m&&this.c.findSubstr(m)||null}n(){this.c=C.$Ii.forUris(this.l,()=>!0);for(const m of this.folders)this.c.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Vi=f;class g{constructor(m,E){this.raw=E,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,T.$dh)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Wi=g;function i(l){return new g({uri:l,index:0,name:(0,T.$_g)(l)},{uri:l.toString()})}e.$Yi="code-workspace",e.$Zi=`.${e.$Yi}`,e.$1i=[{name:(0,r.localize)(10864,null),extensions:[e.$Yi]}],e.$2i="workspace.json";function o(l,m){return T.$7g.isEqualOrParent(l,m.untitledWorkspacesHome)}function t(l){let m;return L.URI.isUri(l)?m=l:m=l.configuration,m?.scheme===b.Schemas.tmp}e.$5i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function s(l){return l.id===e.$5i}function n(l,m){return!o(l,m)&&!t(l)}function d(l){return(typeof l=="string"?(0,h.$nc)(l):(0,T.$bh)(l))===e.$Zi}}),define(ke[150],Ie([1,0,60,4,3,22,2,8,144,27,5,11,46,28,244,7,32,12,17]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a,$,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=e.$Il=e.ProfileResourceType=void 0,e.$Hl=o,e.$Jl=t,e.$Kl=s;var i;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function o(l){const m=l;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&typeof m.isDefault=="boolean"&&typeof m.name=="string"&&L.URI.isUri(m.location)&&L.URI.isUri(m.globalStorageHome)&&L.URI.isUri(m.settingsResource)&&L.URI.isUri(m.keybindingsResource)&&L.URI.isUri(m.tasksResource)&&L.URI.isUri(m.snippetsHome)&&L.URI.isUri(m.extensionsResource))}e.$Il=(0,I.$Ci)("IUserDataProfilesService");function t(l,m){return{id:l.id,isDefault:l.isDefault,name:l.name,shortName:l.shortName,icon:l.icon,location:L.URI.revive(l.location).with({scheme:m}),globalStorageHome:L.URI.revive(l.globalStorageHome).with({scheme:m}),settingsResource:L.URI.revive(l.settingsResource).with({scheme:m}),keybindingsResource:L.URI.revive(l.keybindingsResource).with({scheme:m}),tasksResource:L.URI.revive(l.tasksResource).with({scheme:m}),snippetsHome:L.URI.revive(l.snippetsHome).with({scheme:m}),extensionsResource:L.URI.revive(l.extensionsResource).with({scheme:m}),cacheHome:L.URI.revive(l.cacheHome).with({scheme:m}),useDefaultFlags:l.useDefaultFlags,isTransient:l.isTransient}}function s(l,m,E,S,y,k){return{id:l,name:m,location:E,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:k&&y?.useDefaultFlags?.globalState?k.globalStorageHome:(0,T.$dh)(E,"globalStorage"),settingsResource:k&&y?.useDefaultFlags?.settings?k.settingsResource:(0,T.$dh)(E,"settings.json"),keybindingsResource:k&&y?.useDefaultFlags?.keybindings?k.keybindingsResource:(0,T.$dh)(E,"keybindings.json"),tasksResource:k&&y?.useDefaultFlags?.tasks?k.tasksResource:(0,T.$dh)(E,"tasks.json"),snippetsHome:k&&y?.useDefaultFlags?.snippets?k.snippetsHome:(0,T.$dh)(E,"snippets"),extensionsResource:k&&y?.useDefaultFlags?.extensions?k.extensionsResource:(0,T.$dh)(E,"extensions.json"),cacheHome:(0,T.$dh)(S,l),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let n=class extends C.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(m,E,S,y){super(),this.t=m,this.u=E,this.w=S,this.y=y,this.f=!0,this.h=this.B(new h.$je),this.onDidChangeProfiles=this.h.event,this.j=this.B(new h.$je),this.onWillCreateProfile=this.j.event,this.m=this.B(new h.$je),this.onWillRemoveProfile=this.m.event,this.n=this.B(new h.$je),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new P.$zc,workspaces:new P.$zc,emptyWindows:new Map},this.profilesHome=(0,T.$dh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,T.$dh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(m){this.f!==m&&(this.z=void 0,this.f=m)}isEnabled(){return this.f}get C(){if(!this.z){const m=this.D(),E=[m];if(this.f)try{for(const k of this.O()){if(!k.name||!(0,g.$cg)(k.name)||!k.location){this.y.warn("Skipping the invalid stored profile",k.location||k.name);continue}E.push(s((0,T.$ah)(k.location),k.name,k.location,this.g,{shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags},m))}}catch(k){this.y.error(k)}const S=new P.$zc,y=new Map;if(E.length)try{const k=this.Q();if(k.workspaces)for(const[A,p]of Object.entries(k.workspaces)){const v=L.URI.parse(A),F=E.find(N=>N.id===p);F&&S.set(v,F)}if(k.emptyWindows)for(const[A,p]of Object.entries(k.emptyWindows)){const v=E.find(F=>F.id===p);v&&y.set(A,v)}}catch(k){this.y.error(k)}this.z={profiles:E,workspaces:S,emptyWindows:y}}return this.z}D(){const m=s("__default__profile__",(0,R.localize)(10911,null),this.t.userRoamingDataHome,this.g);return{...m,extensionsResource:this.S()??m.extensionsResource,isDefault:!0}}async createTransientProfile(m){const E="Temp",S=new RegExp(`${(0,f.$ff)(E)}\\s(\\d+)`);let y=0;for(const A of this.profiles){const p=S.exec(A.name),v=p?parseInt(p[1]):0;y=v>y?v:y}const k=`${E} ${y+1}`;return this.createProfile((0,r.$qj)((0,$.$Yg)()).toString(16),k,{transient:!0},m)}async createNamedProfile(m,E,S){return this.createProfile((0,r.$qj)((0,$.$Yg)()).toString(16),m,E,S)}async createProfile(m,E,S,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=await this.F(m,E,S);return y&&await this.setProfileForWorkspace(y,k),k}async F(m,E,S){if(!(0,g.$cg)(E)||!E)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(E);return y||(y=(async()=>{try{if(this.profiles.find(v=>v.name===E||v.id===m))throw new Error(`Profile with ${E} name already exists`);const A=s(m,E,(0,T.$dh)(this.profilesHome,m),this.g,S,this.defaultProfile);await this.u.createFolder(A.location);const p=[];return this.j.fire({profile:A,join(v){p.push(v)}}),await a.Promises.settled(p),this.I([A],[],[]),A}finally{this.r.delete(E)}})(),this.r.set(E,y)),y}async updateProfile(m,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let S=this.profiles.find(y=>y.id===m.id);if(!S)throw new Error(`Profile '${m.name}' does not exist`);return S=s(S.id,E.name??S.name,S.location,this.g,{shortName:E.shortName??S.shortName,icon:E.icon===null?void 0:E.icon??S.icon,transient:E.transient??S.isTransient,useDefaultFlags:E.useDefaultFlags??S.useDefaultFlags},this.defaultProfile),this.I([],[],[S]),S}async removeProfile(m){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(m.isDefault)throw new Error("Cannot remove default profile");const E=this.profiles.find(y=>y.id===m.id);if(!E)throw new Error(`Profile '${m.name}' does not exist`);const S=[];this.m.fire({profile:E,join(y){S.push(y)}});try{await Promise.allSettled(S)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])E.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])E.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[E],[]);try{await this.u.del(E.cacheHome,{recursive:!0})}catch(y){(0,c.$nl)(y)!==c.FileOperationResult.FILE_NOT_FOUND&&this.y.error(y)}}async setProfileForWorkspace(m,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=this.profiles.find(y=>y.id===E.id);if(!S)throw new Error(`Profile '${E.name}' does not exist`);this.L(m,S)}unsetWorkspace(m,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(m,void 0,E)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const m=await this.u.resolve(this.profilesHome);await Promise.all((m.children||[]).filter(E=>E.isDirectory&&this.profiles.every(S=>!this.w.extUri.isEqual(S.location,E.resource))).map(E=>this.u.del(E.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const m=this.s.profiles.filter(E=>!this.H(E));await Promise.allSettled(m.map(E=>this.removeProfile(E)))}getProfileForWorkspace(m){const E=this.G(m),S=L.URI.isUri(E)?this.C.workspaces.get(E):this.C.emptyWindows.get(E);return S||((0,u.$Mi)(m)?this.s.folders.get(m.uri):(0,u.$Ri)(m)?this.s.workspaces.get(m.configPath):this.s.emptyWindows.get(m.id))}G(m){return(0,u.$Mi)(m)?m.uri:(0,u.$Ri)(m)?m.configPath:m.id}H(m){return!!([...this.C.emptyWindows.values()].some(E=>this.w.extUri.isEqual(E.location,m.location))||[...this.C.workspaces.values()].some(E=>this.w.extUri.isEqual(E.location,m.location))||[...this.s.emptyWindows.values()].some(E=>this.w.extUri.isEqual(E.location,m.location))||[...this.s.workspaces.values()].some(E=>this.w.extUri.isEqual(E.location,m.location))||[...this.s.folders.values()].some(E=>this.w.extUri.isEqual(E.location,m.location)))}I(m,E,S){const y=[...this.profiles,...m],k=[],A=this.s.profiles;this.s.profiles=[];for(let p of y){if(p.isDefault||E.some(F=>p.id===F.id))continue;p=S.find(F=>p.id===F.id)??p;const v=A.find(F=>p.id===F.id);if(p.isTransient)this.s.profiles.push(p);else{if(v){for(const[F,N]of this.s.emptyWindows.entries())if(p.id===N.id){this.L({id:F},p);break}for(const[F,N]of this.s.workspaces.entries())if(p.id===N.id){this.L({id:"",configPath:F},p);break}for(const[F,N]of this.s.folders.entries())if(p.id===N.id){this.L({id:"",uri:F},p);break}}k.push({location:p.location,name:p.name,shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags})}}this.P(k),this.z=void 0,this.J(m,E,S)}J(m,E,S){this.h.fire({added:m,removed:E,updated:S,all:this.profiles})}L(m,E,S){if(S=E?.isTransient?!0:S,S)(0,u.$Mi)(m)?(this.s.folders.delete(m.uri),E&&this.s.folders.set(m.uri,E)):(0,u.$Ri)(m)?(this.s.workspaces.delete(m.configPath),E&&this.s.workspaces.set(m.configPath,E)):(this.s.emptyWindows.delete(m.id),E&&this.s.emptyWindows.set(m.id,E));else{this.L(m,void 0,!0);const y=this.G(m);L.URI.isUri(y)?(this.C.workspaces.delete(y),E&&this.C.workspaces.set(y,E)):(this.C.emptyWindows.delete(y),E&&this.C.emptyWindows.set(y,E)),this.M()}}M(){const m={};for(const[S,y]of this.C.workspaces.entries())m[S.toString()]=y.id;const E={};for(const[S,y]of this.C.emptyWindows.entries())E[S.toString()]=y.id;this.R({workspaces:m,emptyWindows:E}),this.z=void 0}N(m){const E={},S=this.D();if(m.workspaces)for(const[k,A]of Object.entries(m.workspaces)){const p=L.URI.parse(A);E[k]=this.w.extUri.isEqual(p,S.location)?S.id:this.w.extUri.basename(p)}const y={};if(m.emptyWindows)for(const[k,A]of Object.entries(m.emptyWindows)){const p=L.URI.parse(A);y[k]=this.w.extUri.isEqual(p,S.location)?S.id:this.w.extUri.basename(p)}return{workspaces:E,emptyWindows:y}}O(){return[]}P(m){throw new Error("not implemented")}Q(){return{}}R(m){throw new Error("not implemented")}S(){}};e.$Ll=n,e.$Ll=n=Ye([Ve(0,b.$Ji),Ve(1,c.$9k),Ve(2,w.$Gl),Ve(3,D.$9j)],n);class d extends n{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(m){this.a=m}Q(){return this.X}R(m){this.X=m}}e.$Ml=d}),define(ke[151],Ie([1,0,7,4,3,61,17,192,5,150]),function(me,e,r,h,C,T,L,R,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$gq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$eq=e.$dq=e.$cq=void 0,e.$fq=P,e.$hq=a,e.$jq=f,e.$cq="__$__isNewStorageMarker",e.$dq="__$__targetStorageMarker",e.$eq=(0,b.$Ci)("storageService");var I;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var D;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(D||(e.StorageScope=D={}));var u;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(u||(e.StorageTarget=u={}));function P(g){const i=g.get(e.$dq);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class w extends C.$Tc{static{this.a=60*1e3}constructor(i={flushInterval:w.a}){super(),this.m=i,this.b=this.B(new h.$me),this.c=this.B(new h.$me),this.onDidChangeTarget=this.c.event,this.f=this.B(new h.$je),this.onWillSaveState=this.f.event,this.h=this.B(new r.$Oh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new C.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,o,t){return h.Event.filter(this.b.event,s=>s.scope===i&&(o===void 0||s.key===o),t)}n(){this.j.value=(0,r.$Sh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,C.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.O()}finally{(0,T.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,o){const{key:t,external:s}=o;if(t===e.$dq){switch(i){case D.APPLICATION:this.H=void 0;break;case D.PROFILE:this.F=void 0;break;case D.WORKSPACE:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:t,target:this.J(i)[t],external:s})}w(i){this.f.fire({reason:i})}get(i,o,t){return this.P(o)?.get(i,t)}getBoolean(i,o,t){return this.P(o)?.getBoolean(i,t)}getNumber(i,o,t){return this.P(o)?.getNumber(i,t)}getObject(i,o,t){return this.P(o)?.getObject(i,t)}storeAll(i,o){this.y(()=>{for(const t of i)this.store(t.key,t.value,t.scope,t.target,o)})}store(i,o,t,s,n=!1){if((0,L.$lg)(o)){this.remove(i,t,n);return}this.y(()=>{this.z(i,t,s),this.P(t)?.set(i,o,n)})}remove(i,o,t=!1){this.y(()=>{this.z(i,o,void 0),this.P(o)?.delete(i,t)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,o){const t=[],s=this.J(i);for(const n of Object.keys(s))s[n]===o&&t.push(n);return t}z(i,o,t,s=!1){const n=this.J(o);typeof t=="number"?n[i]!==t&&(n[i]=t,this.P(o)?.set(e.$dq,JSON.stringify(n),s)):typeof n[i]=="number"&&(delete n[i],this.P(o)?.set(e.$dq,JSON.stringify(n),s))}get D(){return this.C||(this.C=this.L(D.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(D.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(D.APPLICATION)),this.H}J(i){switch(i){case D.APPLICATION:return this.I;case D.PROFILE:return this.G;default:return this.D}}L(i){const o=this.P(i);return o?P(o):Object.create(null)}isNew(i){return this.getBoolean(e.$cq,i)===!0}async flush(i=I.NONE){this.f.fire({reason:i});const o=this.P(D.APPLICATION),t=this.P(D.PROFILE),s=this.P(D.WORKSPACE);switch(i){case I.NONE:await r.Promises.settled([o?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await r.Promises.settled([o?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(D.APPLICATION)?.items??new Map,o=this.P(D.PROFILE)?.items??new Map,t=this.P(D.WORKSPACE)?.items??new Map;return f(i,o,t,this.Q(D.APPLICATION)??"",this.Q(D.PROFILE)??"",this.Q(D.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,o){return this.w(I.NONE),(0,c.$Hl)(i)?this.R(i,o):this.S(i,o)}M(i,o){return!(i.id===o.id||a(o)&&a(i))}N(i,o,t){this.y(()=>{const s=new Set;for(const[n,d]of i)s.add(n),o.get(n)!==d&&this.u(t,{key:n,external:!0});for(const[n]of o.items)s.has(n)||this.u(t,{key:n,external:!0})})}}e.$gq=w;function a(g){return g.isDefault||!!g.useDefaultFlags?.globalState}class $ extends w{constructor(){super(),this.U=this.B(new R.$aq(new R.$bq,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new R.$aq(new R.$bq,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new R.$aq(new R.$bq,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(D.WORKSPACE,i))),this.B(this.W.onDidChangeStorage(i=>this.u(D.PROFILE,i))),this.B(this.U.onDidChangeStorage(i=>this.u(D.APPLICATION,i)))}P(i){switch(i){case D.APPLICATION:return this.U;case D.PROFILE:return this.W;default:return this.X}}Q(i){switch(i){case D.APPLICATION:return"inMemory (application)";case D.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$iq=$;async function f(g,i,o,t,s,n){const d=v=>{try{return JSON.parse(v)}catch{return v}},l=new Map,m=new Map;g.forEach((v,F)=>{l.set(F,v),m.set(F,d(v))});const E=new Map,S=new Map;i.forEach((v,F)=>{E.set(F,v),S.set(F,d(v))});const y=new Map,k=new Map;o.forEach((v,F)=>{y.set(F,v),k.set(F,d(v))}),console.group(t!==s?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const A=[];if(l.forEach((v,F)=>{A.push({key:F,value:v})}),console.table(A),console.groupEnd(),console.log(m),t!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const v=[];E.forEach((F,N)=>{v.push({key:N,value:F})}),console.table(v),console.groupEnd(),console.log(S)}console.group(`Storage: Workspace (path: ${n})`);const p=[];y.forEach((v,F)=>{p.push({key:F,value:v})}),console.table(p),console.groupEnd(),console.log(k)}}),define(ke[118],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$loc=void 0;class r{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const T=this.c++;return this.b.set(T,C),this.e(),T}get(C,T){return this.b.has(C)?this.b.get(C)[T]:void 0}delete(C){this.b.delete(C),this.e()}e(){r.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$loc=r}),define(ke[62],Ie([1,0,14,22,27,5]),function(me,e,r,h,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$roc=e.$qoc=void 0;class L{constructor(){this.a=new Set(Object.keys(r.Schemas)),this.b=new Map,this.extUri=new h.$5g(b=>{const c=this.b.get(b.scheme);return!(c===void 0||c&C.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(b,c){c===null?this.b.delete(b.scheme):this.b.set(b.scheme,c)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$qoc=L,e.$roc=(0,T.$Ci)("IExtHostFileSystemInfo")}),define(ke[29],Ie([1,0,5]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=void 0,e.$eQ=(0,r.$Ci)("IExtHostInitDataService")}),define(ke[247],Ie([1,0,8,11,227,29]),function(me,e,r,h,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zqc=void 0;let L=class extends C.$oR{constructor(b,c,I){const D=I.remote.isRemote?"remoteexthost":b?"workerexthost":"exthost",u=I.remote.isRemote?(0,r.localize)(10665,null):b?(0,r.localize)(10666,null):(0,r.localize)(10667,null);super(c.createLogger(D,{name:u}))}};e.$zqc=L,e.$zqc=L=Ye([Ve(1,h.$0j),Ve(2,T.$eQ)],L)}),define(ke[248],Ie([1,0,7]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0oc=e.$9oc=void 0;class h{constructor(L,R,b){this.h=new Map,this.a=L,this.b=R,this.c=b,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(c=>(this.f=c,this)),this.g=this.c.onDidChangeStorage(c=>{c.shared===this.b&&c.key===this.a&&(this.f=c.value)}),this.i=new r.$Oh(()=>{const c=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const I of c.values())I.complete()}catch(I){for(const D of c.values())D.error(I)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,L])=>L!==void 0).map(([L])=>L)}get whenReady(){return this.d}get(L,R){let b=this.f[L];return typeof b>"u"&&(b=R),b}update(L,R){this.f[L]=R;const b=this.h.get(L);if(b!==void 0)return b.p;const c=new r.$Zh;return this.h.set(L,c),this.i.isScheduled()||this.i.schedule(),c.p}dispose(){this.g.dispose()}}e.$9oc=h;class C extends h{setKeysForSync(L){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},L)}constructor(L,R){super(L.identifier.value,!0,R),this.j=L}}e.$0oc=C}),define(ke[249],Ie([1,0,4,2]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4pc=void 0;class C{constructor(L){this.c=L,this.a=new r.$je,this.onDidSaveNotebookDocument=this.a.event,this.b=new r.$je,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(L,R,b,c){const D=this.c.getNotebookDocument(h.URI.revive(L)).acceptModelChanged(R.value,b,c);this.b.fire(D)}$acceptDirtyStateChanged(L,R){this.c.getNotebookDocument(h.URI.revive(L)).acceptDirty(R)}$acceptModelSaved(L){const R=this.c.getNotebookDocument(h.URI.revive(L));this.a.fire(R.apiNotebook)}}e.$4pc=C}),define(ke[19],Ie([1,0,5]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2P=e.$1P=void 0,e.$1P=(0,r.$Ci)("IExtHostRpcService");class h{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.dispose=T.dispose.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.$2P=h}),define(ke[250],Ie([1,0,23,4,3]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gpc=void 0;class T{#e;constructor(R,b){this.disposables=new C.$Sc,this.a=r.$nn.toKey(R.identifier),this.#e=b,this.onDidChange=h.Event.map(h.Event.filter(this.#e.onDidChangePassword,c=>c.extensionId===this.a),c=>({key:c.key}),this.disposables)}dispose(){this.disposables.dispose()}get(R){return this.#e.get(this.a,R)}store(R,b){return this.#e.store(this.a,R,b)}delete(R){return this.#e.delete(this.a,R)}}e.$gpc=T}),define(ke[72],Ie([1,0,5]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hoc=e.$Goc=void 0,e.$Goc=(0,r.$Ci)("IURITransformerService");class h{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=L=>L,this.transformOutgoing=L=>L,this.transformOutgoingURI=L=>L,this.transformOutgoingScheme=L=>L)}}e.$Hoc=h}),define(ke[251],Ie([1,0,252,361,362,67,2,11,363]),function(me,e,r,h,C,T,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8qc=I,r=Ue(r),h=Ue(h),C=Ue(C),T=Ue(T);const c=!1;function I(i,o,t,s,n,d){const l=d.environment.useHostProxy,m=typeof l=="boolean"?l:!d.remote.isRemote,E={resolveProxy:k=>i.resolveProxy(k),lookupProxyAuthorization:$.bind(void 0,s,n,o,{},d.remote.isRemote),getProxyURL:()=>o.getConfiguration("http").get("proxy"),getProxySupport:()=>o.getConfiguration("http").get("proxySupport")||"off",getNoProxyConfig:()=>o.getConfiguration("http").get("noProxy")||[],addCertificatesV1:()=>u(o),addCertificatesV2:()=>P(o),log:s,getLogLevel:()=>{const k=s.getLevel();switch(k){case R.LogLevel.Trace:return b.LogLevel.Trace;case R.LogLevel.Debug:return b.LogLevel.Debug;case R.LogLevel.Info:return b.LogLevel.Info;case R.LogLevel.Warning:return b.LogLevel.Warning;case R.LogLevel.Error:return b.LogLevel.Error;case R.LogLevel.Off:return b.LogLevel.Off;default:return A(k)}function A(p){return s.error("Unknown log level",p),b.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:m,loadAdditionalCertificates:async()=>{const k=[];if(d.remote.isRemote&&k.push((0,b.loadSystemCertificates)({log:s})),m){s.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const A=i.loadCertificates();A.then(p=>s.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",p.length)),k.push(A)}return d.environment.extensionTestsLocationURI&&h.globalAgent.testCertificates?.length&&(s.trace("ProxyResolver#loadAdditionalCertificates: Loading test certificates"),k.push(Promise.resolve(h.globalAgent.testCertificates))),(await Promise.all(k)).flat()},env:process.env},S=(0,b.createProxyResolver)(E),y=D(E,S);return a(t,y)}function D(i,o){function t(s,n){return Object.assign(s.default||s,n)}return{http:t(r,(0,b.createHttpPatch)(i,r,o)),https:t(h,(0,b.createHttpPatch)(i,h,o)),net:t(T,(0,b.createNetPatch)(i,T)),tls:t(C,(0,b.createTlsPatch)(i,C))}}function u(i){const o=i.getConfiguration("http");return!o.get("experimental.systemCertificatesV2",c)&&!!o.get("systemCertificates")}function P(i){const o=i.getConfiguration("http");return!!o.get("experimental.systemCertificatesV2",c)&&!!o.get("systemCertificates")}const w=new Map;function a(i,o){return i.getExtensionPathIndex().then(t=>{const s=globalThis._VSCODE_NODE_MODULES.module,n=s._load;s._load=function(l,m,E){if(l==="net")return o.net;if(l==="tls")return o.tls;if(l!=="http"&&l!=="https")return n.apply(this,arguments);const S=t.findSubstr(L.URI.file(m.filename));let y=w.get(S);if(y||w.set(S,y={}),!y[l]){const k=o[l];y[l]={...k}}return y[l]}})}async function $(i,o,t,s,n,d,l,m){const E=s[d];l&&(s[d]=l),i.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${d}`,`proxyAuthenticate:${l}`,`proxyAuthenticateCache:${E}`);const S=l||E,y=Array.isArray(S)?S:typeof S=="string"?[S]:[];if(g(o,y,n),y.some(k=>/^(Negotiate|Kerberos)( |$)/i.test(k))&&!m.kerberosRequested)try{m.kerberosRequested=!0;const k=await new Promise((N,O)=>{me(["kerberos"],N,O)}).then(Ue),A=new URL(d),p=t.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${A.hostname}`:`HTTP@${A.hostname}`);return i.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${d}`,`spn:${p}`),"Negotiate "+await(await k.initializeClient(p)).step("")}catch(k){i.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",k)}}let f=!1;function g(i,o,t){f||!o.length||(f=!0,i.$publicLog2("proxyAuthenticationRequest",{authenticationType:o.map(s=>s.split(" ")[0]).join(","),extensionHostType:t?"remote":"local"}))}}),define(ke[253],Ie([1,0,138]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=C;function h(T){return{transformIncoming:L=>L.scheme==="vscode-remote"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="file"?{scheme:"vscode-local",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoing:L=>L.scheme==="file"?{scheme:"vscode-remote",authority:T,path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="vscode-local"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoingScheme:L=>L==="file"?"vscode-remote":L==="vscode-local"?"file":L}}function C(T){return new r.$In(h(T))}});var zt=this&&this.__importDefault||function(me){return me&&me.__esModule?me:{default:me}};define(ke[152],Ie([1,0,8,17,2,3,5,36,27,14,52,210,43]),function(me,e,r,h,C,T,L,R,b,c,I,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$cG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$5F=e.EditorInputCapabilities=e.$4F=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$TF=e.$SF=e.$RF=e.$QF=e.$PF=void 0,e.$UF=a,e.$VF=$,e.$WF=f,e.$XF=g,e.$YF=i,e.$ZF=o,e.$1F=t,e.$2F=s,e.$3F=n,e.$6F=y,e.$7F=A,e.$8F=p,e.$9F=v,e.$0F=F,e.$$F=N,e.$_F=O,e.$aG=j,e.$bG=B,e.$dG=ee,e.$eG=re,e.$fG=ye,e.$gG=$e,u=zt(u),e.$PF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$QF={id:"default",displayName:(0,r.localize)(12306,null),providerDisplayName:(0,r.localize)(12307,null)},e.$RF="workbench.editor.sidebysideEditor",e.$SF="workbench.editors.textDiffEditor",e.$TF="workbench.editors.binaryResourceDiffEditor";var P;(function(J){J[J.PROGRAMMATIC=1]="PROGRAMMATIC",J[J.USER=2]="USER",J[J.EDIT=3]="EDIT",J[J.NAVIGATION=4]="NAVIGATION",J[J.JUMP=5]="JUMP"})(P||(e.EditorPaneSelectionChangeReason=P={}));var w;(function(J){J[J.IDENTICAL=1]="IDENTICAL",J[J.SIMILAR=2]="SIMILAR",J[J.DIFFERENT=3]="DIFFERENT"})(w||(e.EditorPaneSelectionCompareResult=w={}));function a(J){const W=J;return!!W&&typeof W.getSelection=="function"&&!!W.onDidChangeSelection}function $(J){const W=J;return!!W&&typeof W.getScrollPosition=="function"&&typeof W.setScrollPosition=="function"&&!!W.onDidChangeScroll}function f(J,W,se){for(const ae of se.visibleEditorPanes)if(ae.group.id===W&&J.matches(ae.input))return ae.getViewState()}function g(J){if(y(J))return!1;const W=J;return C.URI.isUri(W?.resource)}function i(J){if(y(J))return!1;const W=J;return W?.original!==void 0&&W.modified!==void 0}function o(J){if(y(J))return!1;const W=J;return!W||W.resources&&!Array.isArray(W.resources)?!1:!!W.resources||!!W.multiDiffSource}function t(J){if(y(J)||i(J))return!1;const W=J;return W?.primary!==void 0&&W.secondary!==void 0}function s(J){if(y(J))return!1;const W=J;return W?W.resource===void 0||W.resource.scheme===c.Schemas.untitled||W.forceUntitled===!0:!1}function n(J){if(y(J))return!1;const W=J;return C.URI.isUri(W?.base?.resource)&&C.URI.isUri(W?.input1?.resource)&&C.URI.isUri(W?.input2?.resource)&&C.URI.isUri(W?.result?.resource)}var d;(function(J){J[J.SHORT=0]="SHORT",J[J.MEDIUM=1]="MEDIUM",J[J.LONG=2]="LONG"})(d||(e.Verbosity=d={}));var l;(function(J){J[J.EXPLICIT=1]="EXPLICIT",J[J.AUTO=2]="AUTO",J[J.FOCUS_CHANGE=3]="FOCUS_CHANGE",J[J.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l||(e.SaveReason=l={}));class m{constructor(){this.a=new Map}registerSource(W,se){let ae=this.a.get(W);return ae||(ae={source:W,label:se},this.a.set(W,ae)),ae.source}getSourceLabel(W){return this.a.get(W)?.label??W}}e.$4F=new m;var E;(function(J){J[J.None=0]="None",J[J.Readonly=2]="Readonly",J[J.Untitled=4]="Untitled",J[J.Singleton=8]="Singleton",J[J.RequiresTrust=16]="RequiresTrust",J[J.CanSplitInGroup=32]="CanSplitInGroup",J[J.ForceDescription=64]="ForceDescription",J[J.CanDropIntoEditor=128]="CanDropIntoEditor",J[J.MultipleEditors=256]="MultipleEditors",J[J.Scratchpad=512]="Scratchpad"})(E||(e.EditorInputCapabilities=E={}));class S extends T.$Tc{}e.$5F=S;function y(J){return J instanceof S}function k(J){const W=J;return C.URI.isUri(W?.preferredResource)}function A(J){const W=J;return y(W?.primary)&&y(W?.secondary)}function p(J){const W=J;return y(W?.modified)&&y(W?.original)}function v(J,W,se,ae,te){return $e(ae,[(0,D.$mj)({id:"workbench.action.openLargeFile",label:(0,r.localize)(12308,null),run:()=>{const ce={...se,limits:{size:Number.MAX_VALUE}};J.openEditor(W,ce)}}),(0,D.$mj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,r.localize)(12309,null),run:()=>te.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function F(J){return y(J?.editor)}function N(J){const W=J;return F(J)&&W?.group!==void 0}function O(J){const W=J;return typeof W?.groupId=="number"&&y(W.editor)}function j(J){return typeof J?.groupId=="number"}var z;(function(J){J[J.UNKNOWN=0]="UNKNOWN",J[J.REPLACE=1]="REPLACE",J[J.MOVE=2]="MOVE",J[J.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var M;(function(J){J[J.GROUP_ACTIVE=0]="GROUP_ACTIVE",J[J.GROUP_INDEX=1]="GROUP_INDEX",J[J.GROUP_LABEL=2]="GROUP_LABEL",J[J.GROUP_LOCKED=3]="GROUP_LOCKED",J[J.EDITORS_SELECTION=4]="EDITORS_SELECTION",J[J.EDITOR_OPEN=5]="EDITOR_OPEN",J[J.EDITOR_CLOSE=6]="EDITOR_CLOSE",J[J.EDITOR_MOVE=7]="EDITOR_MOVE",J[J.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",J[J.EDITOR_LABEL=9]="EDITOR_LABEL",J[J.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",J[J.EDITOR_PIN=11]="EDITOR_PIN",J[J.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",J[J.EDITOR_STICKY=13]="EDITOR_STICKY",J[J.EDITOR_DIRTY=14]="EDITOR_DIRTY",J[J.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(M||(e.GroupModelChangeKind=M={}));var V;(function(J){J[J.PRIMARY=1]="PRIMARY",J[J.SECONDARY=2]="SECONDARY",J[J.BOTH=3]="BOTH",J[J.ANY=4]="ANY"})(V||(e.SideBySideEditor=V={}));class K{getOriginalUri(W,se){if(!W)return;if(n(W))return e.$cG.getOriginalUri(W.result,se);if(se?.supportSideBySide){const{primary:te,secondary:ce}=this.a(W);if(te&&ce){if(se?.supportSideBySide===V.BOTH)return{primary:this.getOriginalUri(te,{filterByScheme:se.filterByScheme}),secondary:this.getOriginalUri(ce,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===V.ANY)return this.getOriginalUri(te,{filterByScheme:se.filterByScheme})??this.getOriginalUri(ce,{filterByScheme:se.filterByScheme});W=se.supportSideBySide===V.PRIMARY?te:ce}}if(i(W)||o(W)||t(W)||n(W))return;const ae=k(W)?W.preferredResource:W.resource;return!ae||!se||!se.filterByScheme?ae:this.b(ae,se.filterByScheme)}a(W){return A(W)||t(W)?{primary:W.primary,secondary:W.secondary}:p(W)||i(W)?{primary:W.modified,secondary:W.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(W,se){if(!W)return;if(n(W))return e.$cG.getCanonicalUri(W.result,se);if(se?.supportSideBySide){const{primary:te,secondary:ce}=this.a(W);if(te&&ce){if(se?.supportSideBySide===V.BOTH)return{primary:this.getCanonicalUri(te,{filterByScheme:se.filterByScheme}),secondary:this.getCanonicalUri(ce,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===V.ANY)return this.getCanonicalUri(te,{filterByScheme:se.filterByScheme})??this.getCanonicalUri(ce,{filterByScheme:se.filterByScheme});W=se.supportSideBySide===V.PRIMARY?te:ce}}if(i(W)||o(W)||t(W)||n(W))return;const ae=W.resource;return!ae||!se||!se.filterByScheme?ae:this.b(ae,se.filterByScheme)}b(W,se){if(Array.isArray(se)){if(se.some(ae=>W.scheme===ae))return W}else if(se===W.scheme)return W}}var ne;(function(J){J[J.UNKNOWN=0]="UNKNOWN",J[J.KEYBOARD=1]="KEYBOARD",J[J.MOUSE=2]="MOUSE"})(ne||(e.EditorCloseMethod=ne={}));function B(J,W,se,ae){if(!J.isSticky(W))return!1;switch(ae.preventPinnedEditorClose){case"keyboardAndMouse":return se===ne.MOUSE||se===ne.KEYBOARD;case"mouse":return se===ne.MOUSE;case"keyboard":return se===ne.KEYBOARD}return!1}e.$cG=new K;var G;(function(J){J[J.LEFT=0]="LEFT",J[J.RIGHT=1]="RIGHT"})(G||(e.CloseDirection=G={}));class Y{constructor(){this.c=new Map,this.d=new Map}start(W){const se=this.a=W.get(L.$Bi);for(const[ae,te]of this.c)this.e(ae,te,se);this.c.clear()}e(W,se,ae){const te=ae.createInstance(se);this.d.set(W,te)}registerFileEditorFactory(W){if(this.b)throw new Error("Can only register one file editor factory.");this.b=W}getFileEditorFactory(){return(0,h.$ng)(this.b)}registerEditorSerializer(W,se){if(this.c.has(W)||this.d.has(W))throw new Error(`A editor serializer with type ID '${W}' was already registered.`);return this.a?this.e(W,se,this.a):this.c.set(W,se),(0,T.$Rc)(()=>{this.c.delete(W),this.d.delete(W)})}getEditorSerializer(W){return this.d.get(typeof W=="string"?W:W.typeId)}}R.$no.add(e.$PF.EditorFactory,new Y);async function ee(J,W,se){return!J||!J.length?[]:await Promise.all(J.map(async ae=>{const te=C.URI.revive(ae.fileUri);if(!te){se.info("Cannot resolve the path because it is not valid.",ae);return}if(!await W.canHandleResource(te)){se.info("Cannot resolve the path because it cannot be handled",ae);return}let le=ae.exists,Z=ae.type;if(typeof le!="boolean"||typeof Z!="number")try{Z=(await W.stat(te)).isDirectory?b.FileType.Directory:b.FileType.Unknown,le=!0}catch(pe){se.error(pe),le=!1}if(!le&&ae.openOnlyIfExists){se.info("Cannot resolve the path because it does not exist",ae);return}if(Z===b.FileType.Directory){se.info("Cannot resolve the path because it is a directory",ae);return}const oe={...ae.options,pinned:!0};return le?{resource:te,options:oe}:{resource:te,options:oe,forceUntitled:!0}}))}var ue;(function(J){J[J.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",J[J.SEQUENTIAL=1]="SEQUENTIAL"})(ue||(e.EditorsOrder=ue={}));function re(J){const W=J;if(!W)return!1;const se=W;if(se.modified)return re(se.modified);const ae=W;return!!(ae.contributionsState&&ae.viewState&&Array.isArray(ae.cursorState))}function ye(J){return(0,I.$oj)(J)}function $e(J,W,se){const ae=(0,I.$pj)(J,W);return ae.forceMessage=se?.forceMessage,ae.forceSeverity=se?.forceSeverity,ae.allowDialog=se?.allowDialog,ae}}),define(ke[254],Ie([1,0,4,8,5,3,28,36,24,82,243]),function(me,e,r,h,C,T,L,R,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oG=e.$nG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$mG=e.ViewContentGroups=e.$kG=e.ViewContainerLocation=e.Extensions=e.$jG=e.$iG=e.$hG=void 0,e.$lG=P,e.$hG="views",e.$iG=(0,h.localize)(12146,null),e.$jG=(0,I.$wx)("default-view-icon",c.$2j.window,(0,h.localize)(12147,null));var D;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(D||(e.Extensions=D={}));var u;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(u||(e.ViewContainerLocation=u={})),e.$kG=[u.Sidebar,u.Panel,u.AuxiliaryBar];function P(s){switch(s){case u.Sidebar:return"sidebar";case u.Panel:return"panel";case u.AuxiliaryBar:return"auxiliarybar"}}class w extends T.$Tc{constructor(){super(...arguments),this.c=this.B(new r.$je),this.onDidRegister=this.c.event,this.f=this.B(new r.$je),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(n,d,l){const m=this.get(n.id);if(m)return m;const E=n;return E.openCommandActionDescriptor=l?.doNotRegisterOpenCommand?void 0:E.openCommandActionDescriptor??{id:E.id},(0,L.$wc)(this.g,d,[]).push(E),l?.isDefault&&this.h.push(E),this.c.fire({viewContainer:E,viewContainerLocation:d}),E}deregisterViewContainer(n){for(const d of this.g.keys()){const l=this.g.get(d),m=l?.indexOf(n);if(m!==-1){l?.splice(m,1),l.length===0&&this.g.delete(d),this.f.fire({viewContainer:n,viewContainerLocation:d});return}}}get(n){return this.all.filter(d=>d.id===n)[0]}getViewContainers(n){return[...this.g.get(n)||[]]}getViewContainerLocation(n){return[...this.g.keys()].filter(d=>this.getViewContainers(d).filter(l=>l?.id===n.id).length>0)[0]}getDefaultViewContainer(n){return this.h.find(d=>this.getViewContainerLocation(d)===n)}}R.$no.add(D.ViewContainersRegistry,new w);var a;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(a||(e.ViewContentGroups=a={}));function $(s,n){const d=s.group??a.More,l=n.group??a.More;return d!==l?d.localeCompare(l):(s.order??5)-(n.order??5)}class f extends T.$Tc{constructor(){super(...arguments),this.c=this.B(new r.$je),this.onViewsRegistered=this.c.event,this.f=this.B(new r.$je),this.onViewsDeregistered=this.f.event,this.g=this.B(new r.$je),this.onDidChangeContainer=this.g.event,this.h=this.B(new r.$je),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new L.$Gc}registerViews(n,d){this.registerViews2([{views:n,viewContainer:d}])}registerViews2(n){n.forEach(({views:d,viewContainer:l})=>this.r(d,l)),this.c.fire(n)}deregisterViews(n,d){const l=this.s(n,d);l.length&&this.f.fire({views:l,viewContainer:d})}moveViews(n,d){for(const l of this.m.keys())if(l!==d){const m=this.s(n,l);m.length&&(this.r(m,d),this.g.fire({views:m,from:l,to:d}))}}getViews(n){return this.m.get(n)||[]}getView(n){for(const d of this.j){const l=(this.m.get(d)||[]).filter(m=>m.id===n)[0];if(l)return l}return null}getViewContainer(n){for(const d of this.j)if((this.m.get(d)||[]).filter(m=>m.id===n)[0])return d;return null}registerViewWelcomeContent(n,d){return this.n.add(n,d),this.h.fire(n),(0,T.$Rc)(()=>{this.n.delete(n,d),this.h.fire(n)})}registerViewWelcomeContent2(n,d){const l=new Map;for(const[m,E]of d)this.n.add(n,E),l.set(m,(0,T.$Rc)(()=>{this.n.delete(n,E),this.h.fire(n)}));return this.h.fire(n),l}getViewWelcomeContent(n){const d=[];return this.n.forEach(n,l=>d.push(l)),d.sort($)}r(n,d){let l=this.m.get(d);l||(l=[],this.m.set(d,l),this.j.push(d));for(const m of n){if(this.getView(m.id)!==null)throw new Error((0,h.localize)(12148,null,m.id));l.push(m)}}s(n,d){const l=this.m.get(d);if(!l)return[];const m=[],E=[];for(const S of l)n.includes(S)?m.push(S):E.push(S);return m.length&&(E.length?this.m.set(d,E):(this.m.delete(d),this.j.splice(this.j.indexOf(d),1))),m}}R.$no.add(D.ViewsRegistry,new f),e.$mG=(0,C.$Ci)("viewDescriptorService");var g;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(g||(e.ViewVisibilityState=g={}));var i;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class o{constructor(n,d){this.c=!1,this.d=!1,(0,b.$do)(this,n),this.d=!!d,this.resolve=async l=>{if(d&&!this.c){const m=await d(l);m&&(this.tooltip=this.tooltip??m.tooltip,this.command=this.command??m.command)}l.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$nG=o;class t extends Error{constructor(n){super((0,h.localize)(12149,null,n)),this.name="NoTreeViewError"}static is(n){return n.name==="NoTreeViewError"}}e.$oG=t}),define(ke[255],Ie([1,0,8,35]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=void 0,e.$sG=new h.$Tj("chatSessionResponseVote","",{type:"string",description:(0,r.localize)(8291,null)}),e.$tG=new h.$Tj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,r.localize)(8292,null)}),e.$uG=new h.$Tj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,r.localize)(8293,null)}),e.$vG=new h.$Tj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,r.localize)(8294,null)}),e.$wG=new h.$Tj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,r.localize)(8295,null)}),e.$xG=new h.$Tj("chatResponse",!1,{type:"boolean",description:(0,r.localize)(8296,null)}),e.$yG=new h.$Tj("chatRequest",!1,{type:"boolean",description:(0,r.localize)(8297,null)}),e.$zG=new h.$Tj("chatEditApplied",!1,{type:"boolean",description:(0,r.localize)(8298,null)}),e.$AG=new h.$Tj("chatInputHasText",!1,{type:"boolean",description:(0,r.localize)(8299,null)}),e.$BG=new h.$Tj("chatInputHasFocus",!1,{type:"boolean",description:(0,r.localize)(8300,null)}),e.$CG=new h.$Tj("inChatInput",!1,{type:"boolean",description:(0,r.localize)(8301,null)}),e.$DG=new h.$Tj("inChat",!1,{type:"boolean",description:(0,r.localize)(8302,null)}),e.$EG=new h.$Tj("chatIsEnabled",!1,{type:"boolean",description:(0,r.localize)(8303,null)}),e.$FG=new h.$Tj("chatCursorAtTop",!1),e.$GG=new h.$Tj("chatInputHasAgent",!1),e.$HG=new h.$Tj("chatLocation",void 0),e.$IG=new h.$Tj("quickChatHasFocus",!1,{type:"boolean",description:(0,r.localize)(8304,null)})}),define(ke[153],Ie([1,0,131,7,20,4,39,3,51,181,12,35,23,5,11,115,236,151,255]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a,$,f,g){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.ChatAgentLocation=void 0,e.$MH=d,e.$NH=l;var o;(function(m){m.Panel="panel",m.Terminal="terminal",m.Notebook="notebook",m.Editor="editor"})(o||(e.ChatAgentLocation=o={})),function(m){function E(S){switch(S){case"panel":return m.Panel;case"terminal":return m.Terminal;case"notebook":return m.Notebook;case"editor":return m.Editor}return m.Panel}m.fromRaw=E}(o||(e.ChatAgentLocation=o={})),e.$HH=(0,P.$Ci)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(E){this.f=E,this.b=new Map,this.d=new T.$je,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=g.$EG.bindTo(this.f)}registerAgent(E,S){if(this.getAgent(E))throw new Error(`Agent already registered: ${JSON.stringify(E)}`);const k=this,A=S.slashCommands;S={...S,get slashCommands(){return A.filter(v=>!v.when||k.f.contextMatchesRules(D.$Aj.deserialize(v.when)))}};const p={data:S};return this.b.set(E,p),(0,R.$Rc)(()=>{this.b.delete(E),this.d.fire(void 0)})}registerAgentImplementation(E,S){const y=this.b.get(E);if(!y)throw new Error(`Unknown agent: ${JSON.stringify(E)}`);if(y.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(E)}`);return y.data.isDefault&&this.e.set(!0),y.impl=S,this.d.fire(new s(y.data,S)),(0,R.$Rc)(()=>{y.impl=void 0,this.d.fire(void 0),y.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(E,S){E.isDynamic=!0;const y={data:E,impl:S};return this.b.set(E.id,y),this.d.fire(new s(E,S)),(0,R.$Rc)(()=>{this.b.delete(E.id),this.d.fire(void 0)})}registerAgentCompletionProvider(E,S){return this.g.set(E,S),{dispose:()=>{this.g.delete(E)}}}async getAgentCompletionItems(E,S,y){return await this.g.get(E)?.(S,y)??[]}updateAgent(E,S){const y=this.b.get(E);if(!y?.impl)throw new Error(`No activated agent with id ${JSON.stringify(E)} registered`);y.data.metadata={...y.data.metadata,...S},this.d.fire(new s(y.data,y.impl))}getDefaultAgent(E){return(0,r.$eb)(this.getActivatedAgents(),S=>!!S.isDefault&&S.locations.includes(E))}getContributedDefaultAgent(E){return this.getAgents().find(S=>!!S.isDefault&&S.locations.includes(E))}getSecondaryAgent(){return L.Iterable.find(this.b.values(),E=>!!E.data.metadata.isSecondary)?.data}getAgent(E){if(this.h(E))return this.b.get(E)?.data}h(E){const S=this.b.get(E);return!S?.data.when||this.f.contextMatchesRules(D.$Aj.deserialize(S.data.when))}getAgentByFullyQualifiedId(E){const S=L.Iterable.find(this.b.values(),y=>d(y.data)===E)?.data;if(!(S&&!this.h(S.id)))return S}getAgents(){return Array.from(this.b.values()).map(E=>E.data).filter(E=>this.h(E.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(E=>!!E.impl).filter(E=>this.h(E.data.id)).map(E=>new s(E.data,E.impl))}getAgentsByName(E){return this.getAgents().filter(S=>S.name===E)}agentHasDupeName(E){const S=this.getAgent(E);return S?this.getAgentsByName(S.name).filter(y=>y.extensionId.value!==S.extensionId.value).length>0:!1}async invokeAgent(E,S,y,k,A){const p=this.b.get(E);if(!p?.impl)throw new Error(`No activated agent with id "${E}"`);return await p.impl.invoke(S,y,k,A)}async getFollowups(E,S,y,k,A){const p=this.b.get(E);if(!p?.impl)throw new Error(`No activated agent with id "${E}"`);return p.impl?.provideFollowups?p.impl.provideFollowups(S,y,k,A):[]}};e.$IH=t,e.$IH=t=Ye([Ve(0,D.$Uj)],t);class s{constructor(E,S){this.b=E,this.d=S}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get locations(){return this.b.locations}async invoke(E,S,y,k){return this.d.invoke(E,S,y,k)}async provideFollowups(E,S,y,k){return this.d.provideFollowups?this.d.provideFollowups(E,S,y,k):[]}provideWelcomeMessage(E,S){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(E,S)}provideSampleQuestions(E,S){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(E,S)}}e.$JH=s,e.$KH=(0,P.$Ci)("chatAgentNameService");let n=class{static{i=this}static{this.b="chat.participantNameRegistry"}constructor(E,S,y,k){if(this.g=S,this.h=y,this.i=k,this.e=(0,c.$4d)(this,Object.create(null)),this.f=!1,!E.chatParticipantRegistry)return;this.d=E.chatParticipantRegistry;const A=k.get(i.b,f.StorageScope.APPLICATION);try{this.e.set(JSON.parse(A??"{}"),void 0)}catch{k.remove(i.b,f.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(E=>this.h.warn("Failed to fetch chat participant registry",E)).then(()=>(0,h.$Dh)(5*60*1e3)).then(()=>this.j())}async k(){const E=await this.g.request({type:"GET",url:this.d},C.CancellationToken.None);if(E.res.statusCode!==200)throw new Error("Could not get extensions report.");const S=await(0,$.$0p)(E);if(!S||S.version!==1)throw new Error("Unexpected chat participant registry response.");const y=S.restrictedChatParticipants;this.e.set(y,void 0),this.i.store(i.b,JSON.stringify(y),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE)}getAgentNameRestriction(E){const S=this.l(E.name,E).get(),y=!E.fullName||this.l(E.fullName.replace(/\s/g,""),E).get();return S&&y}l(E,S){return this.e.map(k=>k[E.toLowerCase()]).map(k=>k?k.some(A=>(0,I.$Df)(A,A.includes(".")?S.extensionId.value:S.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$LH=n,e.$LH=n=i=Ye([Ve(0,a.$pk),Ve(1,$.$4p),Ve(2,w.$9j),Ve(3,f.$eq)],n);function d(m){return`${m.extensionId.value}.${m.id}`}function l(m){const E="name"in m?m:{...m,name:m.id};return"extensionPublisherId"in E||(E.extensionPublisherId=E.extensionPublisher??""),"extensionDisplayName"in E||(E.extensionDisplayName=""),"extensionId"in E||(E.extensionId=new u.$nn("")),(0,b.$_h)(E)}}),define(ke[256],Ie([1,0,2,30,5]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gH=e.$fH=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.$dH=T,e.$eH=L;function T(c){return!!c&&typeof c=="object"&&"uri"in c&&c.uri instanceof r.URI&&"version"in c&&typeof c.version=="number"&&"ranges"in c&&Array.isArray(c.ranges)&&c.ranges.every(h.$Kt.isIRange)}function L(c){return!!c&&typeof c=="object"&&"documents"in c&&Array.isArray(c.documents)&&c.documents.every(T)}var R;(function(c){c[c.Down=0]="Down",c[c.Up=1]="Up"})(R||(e.ChatAgentVoteDirection=R={}));var b;(function(c){c[c.Action=1]="Action",c[c.Toolbar=2]="Toolbar"})(b||(e.ChatCopyKind=b={})),e.$fH=(0,C.$Ci)("IChatService"),e.$gH="accessibility.voice.keywordActivation"}),define(ke[154],Ie([1,0,4,7,8]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Htb=void 0;class T{constructor(){this.f=new Map,this.m=[],this.n=new r.$je,this.o=new r.$je,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(R){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=R}onEvent(R){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=R}onRequest(R){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=R}sendResponse(R){R.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${R.command}`)):this.u("response",R)}sendRequest(R,b,c,I){const D={command:R};if(b&&Object.keys(b).length>0&&(D.arguments=b),this.u("request",D),typeof I=="number"){const u=setTimeout(()=>{clearTimeout(u);const P=this.f.get(D.seq);if(P){this.f.delete(D.seq);const w={type:"response",seq:0,request_seq:D.seq,success:!1,command:R,message:(0,C.localize)(7429,null,I,R)};P(w)}},I)}return c&&this.f.set(D.seq,c),D.seq}acceptMessage(R){this.k?this.k(R):(this.m.push(R),this.m.length===1&&this.s())}q(R,b){return R.type!=="event"||b.type!=="event"}async s(){let R;for(;this.m.length;){if((!R||this.q(this.m[0],R))&&await(0,h.$Dh)(0),R=this.m.shift(),!R)return;switch(R.type){case"event":this.j?.(R);break;case"request":this.g?.(R);break;case"response":{const b=R,c=this.f.get(b.request_seq);c&&(this.f.delete(b.request_seq),c(b));break}}}}u(R,b){b.type=R,b.seq=this.d++,this.sendMessage(b)}async w(){if(this.f.size===0)return Promise.resolve();const R=new Map;this.f.forEach((b,c)=>R.set(c,b)),await(0,h.$Dh)(500),R.forEach((b,c)=>{b({type:"response",seq:0,request_seq:c,success:!1,command:"canceled",message:"canceled"}),this.f.delete(c)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Htb=T}),define(ke[119],Ie([1,0,2,8,35,5]),function(me,e,r,h,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$AK=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$yK=e.MemoryRangeType=e.State=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=void 0,e.$xK=b,e.$zK=I,h=Ue(h),e.$lJ="workbench.view.debug",e.$mJ="workbench.debug.variablesView",e.$nJ="workbench.debug.watchExpressionsView",e.$oJ="workbench.debug.callStackView",e.$pJ="workbench.debug.loadedScriptsView",e.$qJ="workbench.debug.breakPointsView",e.$rJ="workbench.debug.disassemblyView",e.$sJ="workbench.panel.repl",e.$tJ="workbench.panel.repl.view",e.$uJ=new C.$Tj("debugType",void 0,{type:"string",description:h.localize(7366,null)}),e.$vJ=new C.$Tj("debugConfigurationType",void 0,{type:"string",description:h.localize(7367,null)}),e.$wJ=new C.$Tj("debugState","inactive",{type:"string",description:h.localize(7368,null)}),e.$xJ="debugUx",e.$yJ=new C.$Tj(e.$xJ,"default",{type:"string",description:h.localize(7369,null)}),e.$zJ=new C.$Tj("hasDebugged",!1,{type:"boolean",description:h.localize(7370,null)}),e.$AJ=new C.$Tj("inDebugMode",!1,{type:"boolean",description:h.localize(7371,null)}),e.$BJ=new C.$Tj("inDebugRepl",!1,{type:"boolean",description:h.localize(7372,null)}),e.$CJ=new C.$Tj("breakpointWidgetVisible",!1,{type:"boolean",description:h.localize(7373,null)}),e.$DJ=new C.$Tj("inBreakpointWidget",!1,{type:"boolean",description:h.localize(7374,null)}),e.$EJ=new C.$Tj("breakpointsFocused",!0,{type:"boolean",description:h.localize(7375,null)}),e.$FJ=new C.$Tj("watchExpressionsFocused",!0,{type:"boolean",description:h.localize(7376,null)}),e.$GJ=new C.$Tj("watchExpressionsExist",!1,{type:"boolean",description:h.localize(7377,null)}),e.$HJ=new C.$Tj("variablesFocused",!0,{type:"boolean",description:h.localize(7378,null)}),e.$IJ=new C.$Tj("expressionSelected",!1,{type:"boolean",description:h.localize(7379,null)}),e.$JJ=new C.$Tj("breakpointInputFocused",!1,{type:"boolean",description:h.localize(7380,null)}),e.$KJ=new C.$Tj("callStackItemType",void 0,{type:"string",description:h.localize(7381,null)}),e.$LJ=new C.$Tj("callStackSessionIsAttach",!1,{type:"boolean",description:h.localize(7382,null)}),e.$MJ=new C.$Tj("callStackItemStopped",!1,{type:"boolean",description:h.localize(7383,null)}),e.$NJ=new C.$Tj("callStackSessionHasOneThread",!1,{type:"boolean",description:h.localize(7384,null)}),e.$OJ=new C.$Tj("watchItemType",void 0,{type:"string",description:h.localize(7385,null)}),e.$PJ=new C.$Tj("canViewMemory",void 0,{type:"boolean",description:h.localize(7386,null)}),e.$QJ=new C.$Tj("breakpointItemType",void 0,{type:"string",description:h.localize(7387,null)}),e.$RJ=new C.$Tj("breakpointItemBytes",void 0,{type:"boolean",description:h.localize(7388,null)}),e.$SJ=new C.$Tj("breakpointHasModes",!1,{type:"boolean",description:h.localize(7389,null)}),e.$TJ=new C.$Tj("breakpointSupportsCondition",!1,{type:"boolean",description:h.localize(7390,null)}),e.$UJ=new C.$Tj("loadedScriptsSupported",!1,{type:"boolean",description:h.localize(7391,null)}),e.$VJ=new C.$Tj("loadedScriptsItemType",void 0,{type:"string",description:h.localize(7392,null)}),e.$WJ=new C.$Tj("focusedSessionIsAttach",!1,{type:"boolean",description:h.localize(7393,null)}),e.$XJ=new C.$Tj("focusedSessionIsNoDebug",!1,{type:"boolean",description:h.localize(7394,null)}),e.$YJ=new C.$Tj("stepBackSupported",!1,{type:"boolean",description:h.localize(7395,null)}),e.$ZJ=new C.$Tj("restartFrameSupported",!1,{type:"boolean",description:h.localize(7396,null)}),e.$1J=new C.$Tj("stackFrameSupportsRestart",!1,{type:"boolean",description:h.localize(7397,null)}),e.$2J=new C.$Tj("jumpToCursorSupported",!1,{type:"boolean",description:h.localize(7398,null)}),e.$3J=new C.$Tj("stepIntoTargetsSupported",!1,{type:"boolean",description:h.localize(7399,null)}),e.$4J=new C.$Tj("breakpointsExist",!1,{type:"boolean",description:h.localize(7400,null)}),e.$5J=new C.$Tj("debuggersAvailable",!1,{type:"boolean",description:h.localize(7401,null)}),e.$6J=new C.$Tj("debugExtensionAvailable",!0,{type:"boolean",description:h.localize(7402,null)}),e.$7J=new C.$Tj("debugProtocolVariableMenuContext",void 0,{type:"string",description:h.localize(7403,null)}),e.$8J=new C.$Tj("debugSetVariableSupported",!1,{type:"boolean",description:h.localize(7404,null)}),e.$9J=new C.$Tj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:h.localize(7405,null)}),e.$0J=new C.$Tj("debugSetExpressionSupported",!1,{type:"boolean",description:h.localize(7406,null)}),e.$$J=new C.$Tj("breakWhenValueChangesSupported",!1,{type:"boolean",description:h.localize(7407,null)}),e.$_J=new C.$Tj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:h.localize(7408,null)}),e.$aK=new C.$Tj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:h.localize(7409,null)}),e.$bK=new C.$Tj("terminateDebuggeeSupported",!1,{type:"boolean",description:h.localize(7410,null)}),e.$cK=new C.$Tj("suspendDebuggeeSupported",!1,{type:"boolean",description:h.localize(7411,null)}),e.$dK=new C.$Tj("variableEvaluateNamePresent",!1,{type:"boolean",description:h.localize(7412,null)}),e.$eK=new C.$Tj("variableIsReadonly",!1,{type:"boolean",description:h.localize(7413,null)}),e.$fK=new C.$Tj("variableValue",!1,{type:"string",description:h.localize(7414,null)}),e.$gK=new C.$Tj("variableType",!1,{type:"string",description:h.localize(7415,null)}),e.$hK=new C.$Tj("variableInterfaces",!1,{type:"array",description:h.localize(7416,null)}),e.$iK=new C.$Tj("variableName",!1,{type:"string",description:h.localize(7417,null)}),e.$jK=new C.$Tj("variableLanguage",!1,{type:"string",description:h.localize(7418,null)}),e.$kK=new C.$Tj("variableExtensionId",!1,{type:"string",description:h.localize(7419,null)}),e.$lK=new C.$Tj("exceptionWidgetVisible",!1,{type:"boolean",description:h.localize(7420,null)}),e.$mK=new C.$Tj("multiSessionRepl",!1,{type:"boolean",description:h.localize(7421,null)}),e.$nK=new C.$Tj("multiSessionDebug",!1,{type:"boolean",description:h.localize(7422,null)}),e.$oK=new C.$Tj("disassembleRequestSupported",!1,{type:"boolean",description:h.localize(7423,null)}),e.$pK=new C.$Tj("disassemblyViewFocus",!1,{type:"boolean",description:h.localize(7424,null)}),e.$qK=new C.$Tj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:h.localize(7425,null)}),e.$rK=new C.$Tj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:h.localize(7426,null)});const L=i=>h.localize(7427,null,i);e.$sK=L,e.$tK="editor.contrib.debug",e.$uK="editor.contrib.breakpoint",e.$vK="debug",e.$wK={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:h.localize(7428,null)};var R;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(R||(e.State=R={}));function b(i){switch(i){case R.Initializing:return"initializing";case R.Stopped:return"stopped";case R.Running:return"running";default:return"inactive"}}var c;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(c||(e.MemoryRangeType=c={})),e.$yK="vscode-debug-memory";function I(i){const o=i.presentationHint??i.source.presentationHint;return o==="deemphasize"||o==="subtle"}var D;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(D||(e.DataBreakpointSetType=D={}));var u;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var P;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.$AK=(0,T.$Ci)("debugService");var w;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(w||(e.BreakpointWidgetContext=w={}));var a;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(a||(e.DebugVisualizationType=a={}));var $;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})($||(e.DebugTreeItemCollapsibleState=$={}));var f;(function(i){i.deserialize=o=>o,i.serialize=o=>o})(f||(e.IDebugVisualizationTreeItem=f={}));var g;(function(i){i.deserialize=o=>({id:o.id,name:o.name,iconPath:o.iconPath&&{light:r.URI.revive(o.iconPath.light),dark:r.URI.revive(o.iconPath.dark)},iconClass:o.iconClass,visualization:o.visualization}),i.serialize=o=>o})(g||(e.IDebugVisualization=g={}))}),define(ke[257],Ie([1,0,12,2,16,24,14,30,20,18]),function(me,e,r,h,C,T,L,R,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5H=void 0,e.$SH=D,e.$TH=u,e.$UH=P,e.$VH=w,e.$WH=a,e.$XH=$,e.$YH=f,e.$ZH=i,e.$1H=s,e.$2H=n,e.$3H=l,e.$4H=E;const I=/{([^}]+)}/g;function D(y,k,A){return y.replace(I,function(p,v){return k&&v.length>0&&v[0]!=="_"?p:A&&A.hasOwnProperty(v)?A[v]:p})}function u(y){const k={};for(const A of Object.keys(y))A.startsWith("!")||(k[A]=y[A]);return k}function P(y){return y.configuration.request==="attach"&&!w(y)&&(!y.parentSession||P(y.parentSession))}function w(y){let k=y.configuration.type;if(k)return k==="vslsShare"&&(k=y.configuration.adapterProxy.configuration.type),(0,r.$Df)(k,"extensionhost")||(0,r.$Df)(k,"pwa-extensionhost")?y:y.parentSession?w(y.parentSession):void 0}function a(y){return y.type&&(y.label||y.program||y.runtime)}function $(y,k,A){let p,v=0;const F=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let N=null;for(;N=F.exec(y);){const O=N.index+1,j=O+N[0].length;if(O<=k&&j>=A){p=N[0],v=O;break}}if(p){const O=/\w+/g;let j=null;for(;(j=O.exec(p))&&!(j.index+1+v+j[0].length>=A););j&&(p=p.substring(0,O.lastIndex))}return p?{start:v,end:v+p.length-1}:{start:0,end:0}}async function f(y,k,A,p){if(y.evaluatableExpressionProvider.has(k)){const v=y.evaluatableExpressionProvider.ordered(k),F=(0,c.$Gb)(await Promise.all(v.map(async N=>{try{return await N.provideEvaluatableExpression(k,A,p??b.CancellationToken.None)}catch{return}})));if(F.length>0){let N=F[0].expression;const O=F[0].range;return N||(N=k.getLineContent(A.lineNumber).substring(O.startColumn-1,O.endColumn-1)),{range:O,matchingExpression:N}}}else{const v=k.getLineContent(A.lineNumber),{start:F,end:N}=$(v,A.column,A.column),O=v.substring(F-1,N);return{matchingExpression:O,range:new R.$Kt(A.lineNumber,F,A.lineNumber,F+O.length)}}return null}const g=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(y){return!!(y&&y.match(g))}function o(y){if(typeof y.path=="string"&&!(typeof y.sourceReference=="number"&&y.sourceReference>0)){if(i(y.path))return h.URI.parse(y.path);if((0,C.$hc)(y.path))return h.URI.file(y.path)}return y.path}function t(y){if(typeof y.path=="object"){const k=h.URI.revive(y.path);if(k)return k.scheme===L.Schemas.file?k.fsPath:k.toString()}return y.path}function s(y,k){const A=k?o:t,p=(0,T.$ao)(y);return d(p,(v,F)=>{v&&F&&(F.path=A(F))}),p}function n(y,k){const A=k?o:t,p=(0,T.$ao)(y);return d(p,(v,F)=>{!v&&F&&(F.path=A(F))}),p}function d(y,k){switch(y.type){case"event":{const A=y;switch(A.event){case"output":k(!1,A.body.source);break;case"loadedSource":k(!1,A.body.source);break;case"breakpoint":k(!1,A.body.breakpoint.source);break;default:break}break}case"request":{const A=y;switch(A.command){case"setBreakpoints":k(!0,A.arguments.source);break;case"breakpointLocations":k(!0,A.arguments.source);break;case"source":k(!0,A.arguments.source);break;case"gotoTargets":k(!0,A.arguments.source);break;case"launchVSCode":A.arguments.args.forEach(p=>k(!1,p));break;default:break}break}case"response":{const A=y;if(A.success&&A.body)switch(A.command){case"stackTrace":A.body.stackFrames.forEach(p=>k(!1,p.source));break;case"loadedSources":A.body.sources.forEach(p=>k(!1,p));break;case"scopes":A.body.scopes.forEach(p=>k(!1,p.source));break;case"setFunctionBreakpoints":A.body.breakpoints.forEach(p=>k(!1,p.source));break;case"setBreakpoints":A.body.breakpoints.forEach(p=>k(!1,p.source));break;case"disassemble":A.body?.instructions.forEach(v=>k(!1,v.location));break;default:break}break}}}function l(y){return y.filter(k=>!k.presentation?.hidden).sort((k,A)=>k.presentation?A.presentation?k.presentation.group?A.presentation.group?k.presentation.group!==A.presentation.group?k.presentation.group.localeCompare(A.presentation.group):m(k.presentation.order,A.presentation.order):-1:A.presentation.group?1:m(k.presentation.order,A.presentation.order):-1:A.presentation?1:0)}function m(y,k){return typeof y!="number"?typeof k!="number"?0:1:typeof k!="number"?-1:y-k}async function E(y,k){const A=y.getValue("debug.saveBeforeStart",{overrideIdentifier:k.activeTextEditorLanguageId});if(A!=="none"&&(await k.saveAll(),A==="allEditorsInActiveGroup")){const p=k.activeEditorPane;p&&p.input.resource?.scheme===L.Schemas.untitled&&await k.save({editor:p.input,groupId:p.group.id})}await y.reloadConfiguration()}const S=(y,k)=>!y||!k?y===k:y.name===k.name&&y.path===k.path&&y.sourceReference===k.sourceReference;e.$5H=S}),define(ke[258],Ie([1,0,56,67,24,16,10,12,33,8,154]),function(me,e,r,h,C,T,L,R,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jqc=e.$Iqc=e.$Hqc=e.$Gqc=e.$Fqc=void 0,r=Ue(r),h=Ue(h),C=Ue(C),T=Ue(T),L=Ue(L),R=Ue(R),c=Ue(c);class D extends I.$Htb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(f,g){this.l=g,this.p=Buffer.allocUnsafe(0),this.r=-1,f.on("data",i=>this.v(i))}sendMessage(f){if(this.l){const g=JSON.stringify(f);this.l.write(`Content-Length: ${Buffer.byteLength(g,"utf8")}${D.a}${g}`,"utf8")}}v(f){for(this.p=Buffer.concat([this.p,f]);;){if(this.r>=0){if(this.p.length>=this.r){const g=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,g.length>0)try{this.acceptMessage(JSON.parse(g))}catch(i){this.n.fire(new Error((i.message||i)+`
`+g))}continue}}else{const g=this.p.indexOf(D.a);if(g!==-1){const o=this.p.toString("utf8",0,g).split(D.b);for(const t of o){const s=t.split(D.i);s[0]==="Content-Length"&&(this.r=Number(s[1]))}this.p=this.p.slice(g+D.a.length);continue}}break}}}e.$Fqc=D;class u extends D{startSession(){return new Promise((f,g)=>{let i=!1;this.x=this.y(()=>{this.t(this.x,this.x),f(),i=!0}),this.x.on("close",()=>{i?this.n.fire(new Error("connection closed")):g(new Error("connection closed"))}),this.x.on("error",o=>{i?this.n.fire(o):g(o)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$Gqc=u;class P extends u{constructor(f){super(),this.z=f}y(f){return h.createConnection(this.z.port,this.z.host||"127.0.0.1",f)}}e.$Hqc=P;class w extends u{constructor(f){super(),this.z=f}y(f){return h.createConnection(this.z.path,f)}}e.$Iqc=w;class a extends D{constructor(f,g){super(),this.y=f,this.z=g}async startSession(){const f=this.y.command,g=this.y.args,i=this.y.options||{};try{if(f)if(T.$hc(f)){if(!await b.Promises.exists(f))throw new Error(c.localize(7289,null,f))}else f.indexOf("/")<0&&f.indexOf("\\")<0;else throw new Error(c.localize(7290,null,this.z));let o=process.env;if(i.env&&Object.keys(i.env).length>0&&(o=C.$do(C.$ao(process.env),i.env)),f==="node")if(Array.isArray(g)&&g.length>0){const t=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:o,execArgv:t?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};i.cwd&&(s.cwd=i.cwd);const n=r.fork(g[0],g.slice(1),s);if(!n.pid)throw new Error(c.localize(7291,null,g[0]));this.x=n}else throw new Error(c.localize(7292,null));else{const t={env:o};i.cwd&&(t.cwd=i.cwd),this.x=r.spawn(f,g,t)}this.x.on("error",t=>{this.n.fire(t)}),this.x.on("exit",(t,s)=>{this.o.fire(t)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",t=>{this.n.fire(t)}),this.x.stdin.on("error",t=>{this.n.fire(t)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(o){this.n.fire(o)}}async stopSession(){return this.x?(await this.w(),L.$j?new Promise((f,g)=>{const i=r.exec(`taskkill /F /T /PID ${this.x.pid}`,function(o,t,s){if(o)return g(o)});i.on("exit",f),i.on("error",g)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(f,g){if(!f)return;const i=Object.create(null);f.runtime&&(f.runtime.indexOf("./")===0?i.runtime=T.$ic(g,f.runtime):i.runtime=f.runtime),f.runtimeArgs&&(i.runtimeArgs=f.runtimeArgs),f.program&&(T.$hc(f.program)?i.program=f.program:i.program=T.$ic(g,f.program)),f.args&&(i.args=f.args);const o=f;return o.win&&(i.win=a.A(o.win,g)),o.winx86&&(i.winx86=a.A(o.winx86,g)),o.windows&&(i.windows=a.A(o.windows,g)),o.osx&&(i.osx=a.A(o.osx,g)),o.linux&&(i.linux=a.A(o.linux,g)),i}static platformAdapterExecutable(f,g){let i=Object.create(null);g=g.toLowerCase();for(const l of f)if(l.contributes){const m=l.contributes.debuggers;m&&m.length>0&&m.filter(E=>typeof E.type=="string"&&R.$Df(E.type,g)).forEach(E=>{const S=a.A(E,l.extensionLocation.fsPath);i=C.$do(i,S,l.isBuiltin)})}let o;L.$j&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?o=i.winx86||i.win||i.windows:L.$j?o=i.win||i.windows:L.$k?o=i.osx:L.$l&&(o=i.linux),o=o||i;const t=o.program||i.program,s=o.args||i.args,n=o.runtime||i.runtime,d=o.runtimeArgs||i.runtimeArgs;if(n)return{type:"executable",command:n,args:(d||[]).concat(typeof t=="string"?[t]:[]).concat(s||[])};if(t)return{type:"executable",command:t,args:s||[]}}}e.$Jqc=a}),define(ke[259],Ie([1,0,56,31,10]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kqc=L,e.$Lqc=b,r=Ue(r),C=Ue(C);function T(c,I){return new Promise((D,u)=>{let P="";const w=r.spawn(c,I);w.pid&&w.stdout.on("data",a=>{P+=a.toString()}),w.on("error",a=>{u(a)}),w.on("close",a=>{D(P)})})}async function L(c){if(c)if(C.$j){const I=await new Promise((D,u)=>{me(["@vscode/windows-process-tree"],D,u)}).then(Ue);return new Promise(D=>{I.getProcessTree(c,u=>{D(!!u&&u.children.length>0)})})}else return T("/usr/bin/pgrep",["-lP",String(c)]).then(I=>{const D=I.trim();return!(D.length===0||D.indexOf(" tmux")>=0)},I=>!0);return Promise.resolve(!0)}var R;(function(c){c[c.cmd=0]="cmd",c[c.powershell=1]="powershell",c[c.bash=2]="bash"})(R||(R={}));function b(c,I,D,u,P){c=c.trim().toLowerCase();let w;c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0?w=R.powershell:c.indexOf("cmd.exe")>=0?w=R.cmd:c.indexOf("bash")>=0?w=R.bash:C.$j?w=R.cmd:w=R.bash;let a,$=" ";switch(w){case R.powershell:if(a=f=>(f=f.replace(/\'/g,"''"),f.length>0&&f.charAt(f.length-1)==="\\"?`'${f}\\'`:`'${f}'`),u){const f=(0,h.$Hg)(u);f&&($+=`${f}:; `),$+=`cd ${a(u)}; `}if(P)for(const f in P){const g=P[f];g===null?$+=`Remove-Item env:${f}; `:$+=`\${env:${f}}='${g}'; `}if(I.length>0){const f=I.shift(),g=D?f:a(f);$+=g[0]==="'"?`& ${g} `:`${g} `;for(const i of I)$+=i==="<"||i===">"||D?i:a(i),$+=" "}break;case R.cmd:if(a=f=>(f=f.replace(/\"/g,'""'),f=f.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(g=>f.includes(g))||f.length===0?`"${f}"`:f),u){const f=(0,h.$Hg)(u);f&&($+=`${f}: && `),$+=`cd ${a(u)} && `}if(P){$+='cmd /C "';for(const f in P){let g=P[f];g===null?$+=`set "${f}=" && `:(g=g.replace(/[&^|<>]/g,i=>`^${i}`),$+=`set "${f}=${g}" && `)}}for(const f of I)$+=f==="<"||f===">"||D?f:a(f),$+=" ";P&&($+='"');break;case R.bash:{a=g=>(g=g.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),g.length===0?'""':g);const f=g=>/[^\w@%\/+=,.:^-]/.test(g)?`'${g.replace(/'/g,"'\\''")}'`:g;if(u&&($+=`cd ${a(u)} ; `),P){$+="/usr/bin/env";for(const g in P){const i=P[g];i===null?$+=` -u ${f(g)}`:$+=` ${f(`${g}=${i}`)}`}$+=" "}for(const g of I)$+=g==="<"||g===">"||D?g:a(g),$+=" ";break}}return $}}),define(ke[260],Ie([1,0,5]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IK=e.CellExecutionUpdateType=void 0;var h;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(h||(e.CellExecutionUpdateType=h={})),e.$IK=(0,r.$Ci)("INotebookExecutionService")}),define(ke[261],Ie([1,0,5]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MK=e.$LK=e.ProxyKernelState=e.$KK=void 0,e.$KK=100;var h;(function(C){C[C.Disconnected=1]="Disconnected",C[C.Connected=2]="Connected",C[C.Initializing=3]="Initializing"})(h||(e.ProxyKernelState=h={})),e.$LK=(0,r.$Ci)("INotebookKernelService"),e.$MK=(0,r.$Ci)("INotebookKernelHistoryService")}),define(ke[262],Ie([1,0,3,30,58,207,111]),function(me,e,r,h,C,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BZb=void 0;class R extends r.$Tc{constructor(c,I,D){super(),this._source=c,this.b=I,this.c=D,this.a=void 0}f(c){const I=c.getLineCount();return new h.$Kt(1,1,I,this.g(c,I))}g(c,I){if(I<1||I>c.getLineCount())throw new Error("Illegal value for lineNumber");return c.getLineLength(I)+1}get inputTextBuffer(){if(!this.b){const c=new T.$kD;c.acceptChunk(this._source);const I=c.finish(!0),{textBuffer:D,disposable:u}=I.create(C.DefaultEndOfLine.LF);this.b=D,this.B(u)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(c=>{const I=new T.$kD;I.acceptChunk(c);const D=I.finish(!0),{textBuffer:u,disposable:P}=D.create(C.DefaultEndOfLine.LF);return this.B(P),u})),this.a}findInInputs(c){const D=new L.$$C(c,!1,!1,null).parseSearchRequest();if(!D)return[];const u=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(u,D,!0,5e3)}findInOutputs(c){const D=new L.$$C(c,!1,!1,null).parseSearchRequest();return D?this.outputTextBuffers.map(u=>{const P=u.findMatchesLineByLine(this.f(u),D,!0,5e3);if(P.length!==0)return{textBuffer:u,matches:P}}).filter(u=>!!u):[]}}e.$BZb=R}),define(ke[73],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RI=e.TestPosition=e.TestIdPathParts=void 0;var r;(function(T){T.Delimiter="\0"})(r||(e.TestIdPathParts=r={}));var h;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(h||(e.TestPosition=h={}));class C{static fromExtHostTestItem(L,R,b=L.parent){if(L._isRoot)return new C([R]);const c=[L.id];for(let I=b;I&&I.id!==R;I=I.parent)c.push(I.id);return c.push(R),new C(c.reverse())}static isRoot(L){return!L.includes(r.Delimiter)}static root(L){const R=L.indexOf(r.Delimiter);return R===-1?L:L.slice(0,R)}static fromString(L){return new C(L.split(r.Delimiter))}static join(L,R){return new C([...L.path,R])}static joinToString(L,R){return L.toString()+r.Delimiter+R}static parentId(L){const R=L.lastIndexOf(r.Delimiter);return R===-1?void 0:L.slice(0,R)}static localId(L){const R=L.lastIndexOf(r.Delimiter);return R===-1?L:L.slice(R+r.Delimiter.length)}static isChild(L,R){return R[L.length]===r.Delimiter&&R.startsWith(L)}static compare(L,R){return L===R?h.IsSame:C.isChild(L,R)?h.IsChild:C.isChild(R,L)?h.IsParent:h.Disconnected}static getLengthOfCommonPrefix(L,R){if(L===0)return 0;let b=0;for(;b<L-1;){for(let c=1;c<L;c++){const I=R(c-1),D=R(c);if(I.path[b]!==D.path[b])return b}b++}return b}constructor(L,R=L.length){if(this.path=L,this.d=R,L.length===0||R<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let L=1;L<=this.d;L++)yield new C(this.path,L)}*idsToRoot(){for(let L=this.d;L>0;L--)yield new C(this.path,L)}compare(L){if(typeof L=="string")return C.compare(this.toString(),L);for(let R=0;R<L.d&&R<this.d;R++)if(L.path[R]!==this.path[R])return h.Disconnected;return L.d>this.d?h.IsChild:L.d<this.d?h.IsParent:h.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let L=1;L<this.d;L++)this.c+=r.Delimiter,this.c+=this.path[L]}return this.c}}e.$RI=C}),define(ke[74],Ie([1,0,2,57,30,73]),function(me,e,r,h,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1I=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$ZI=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$YI=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$XI=e.$WI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$VI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$UI=e.$TI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$SI=e.TestResultState=void 0;var L;(function(z){z[z.Unset=0]="Unset",z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(L||(e.TestResultState=L={})),e.$SI={[L.Unset]:"unset",[L.Queued]:"queued",[L.Running]:"running",[L.Passed]:"passed",[L.Failed]:"failed",[L.Skipped]:"skipped",[L.Errored]:"errored"};var R;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var b;(function(z){z[z.Run=2]="Run",z[z.Debug=4]="Debug",z[z.Coverage=8]="Coverage",z[z.HasNonDefaultProfile=16]="HasNonDefaultProfile",z[z.HasConfigurable=32]="HasConfigurable",z[z.SupportsContinuousRun=64]="SupportsContinuousRun"})(b||(e.TestRunProfileBitset=b={})),e.$TI=[b.Run,b.Debug,b.Coverage,b.HasNonDefaultProfile,b.HasConfigurable,b.SupportsContinuousRun];const c=z=>"runId"in z;e.$UI=c;var I;(function(z){z.serialize=M=>({range:M.range.toJSON(),uri:M.uri.toJSON()}),z.deserialize=(M,V)=>({range:C.$Kt.lift(V.range),uri:M.asCanonicalUri(r.URI.revive(V.uri))})})(I||(e.IRichLocation=I={}));var D;(function(z){z[z.Error=0]="Error",z[z.Output=1]="Output"})(D||(e.TestMessageType=D={}));var u;(function(z){z.serialize=M=>({message:M.message,type:D.Error,expected:M.expected,actual:M.actual,contextValue:M.contextValue,location:M.location&&I.serialize(M.location)}),z.deserialize=(M,V)=>({message:V.message,type:D.Error,expected:V.expected,actual:V.actual,contextValue:V.contextValue,location:V.location&&I.deserialize(M,V.location)})})(u||(e.ITestErrorMessage=u={}));const P=(z,M)=>`${M?"s":"e"}${z}`;e.$VI=P;var w;(function(z){z.serialize=M=>({message:M.message,type:D.Output,offset:M.offset,length:M.length,location:M.location&&I.serialize(M.location)}),z.deserialize=(M,V)=>({message:V.message,type:D.Output,offset:V.offset,length:V.length,location:V.location&&I.deserialize(M,V.location)})})(w||(e.ITestOutputMessage=w={}));var a;(function(z){z.serialize=M=>M.type===D.Error?u.serialize(M):w.serialize(M),z.deserialize=(M,V)=>V.type===D.Error?u.deserialize(M,V):w.deserialize(M,V)})(a||(e.ITestMessage=a={}));var $;(function(z){z.serializeWithoutMessages=M=>({state:M.state,duration:M.duration,messages:[]}),z.serialize=M=>({state:M.state,duration:M.duration,messages:M.messages.map(a.serialize)}),z.deserialize=(M,V)=>({state:V.state,duration:V.duration,messages:V.messages.map(K=>a.deserialize(M,K))})})($||(e.ITestTaskState=$={}));const f="\0",g=(z,M)=>z+f+M;e.$WI=g;const i=z=>{const M=z.indexOf(f);return{ctrlId:z.slice(0,M),tagId:z.slice(M+1)}};e.$XI=i;var o;(function(z){z.serialize=M=>({extId:M.extId,label:M.label,tags:M.tags,busy:M.busy,children:void 0,uri:M.uri?.toJSON(),range:M.range?.toJSON()||null,description:M.description,error:M.error,sortText:M.sortText}),z.deserialize=(M,V)=>({extId:V.extId,label:V.label,tags:V.tags,busy:V.busy,children:void 0,uri:V.uri?M.asCanonicalUri(r.URI.revive(V.uri)):void 0,range:V.range?C.$Kt.lift(V.range):null,description:V.description,error:V.error,sortText:V.sortText})})(o||(e.ITestItem=o={}));var t;(function(z){z[z.NotExpandable=0]="NotExpandable",z[z.Expandable=1]="Expandable",z[z.BusyExpanding=2]="BusyExpanding",z[z.Expanded=3]="Expanded"})(t||(e.TestItemExpandState=t={}));var s;(function(z){z.serialize=M=>({expand:M.expand,item:o.serialize(M.item)}),z.deserialize=(M,V)=>({controllerId:T.$RI.root(V.item.extId),expand:V.expand,item:o.deserialize(M,V.item)})})(s||(e.InternalTestItem=s={}));var n;(function(z){z.serialize=M=>{let V;return M.item&&(V={},M.item.label!==void 0&&(V.label=M.item.label),M.item.tags!==void 0&&(V.tags=M.item.tags),M.item.busy!==void 0&&(V.busy=M.item.busy),M.item.uri!==void 0&&(V.uri=M.item.uri?.toJSON()),M.item.range!==void 0&&(V.range=M.item.range?.toJSON()),M.item.description!==void 0&&(V.description=M.item.description),M.item.error!==void 0&&(V.error=M.item.error),M.item.sortText!==void 0&&(V.sortText=M.item.sortText)),{extId:M.extId,expand:M.expand,item:V}},z.deserialize=M=>{let V;return M.item&&(V={},M.item.label!==void 0&&(V.label=M.item.label),M.item.tags!==void 0&&(V.tags=M.item.tags),M.item.busy!==void 0&&(V.busy=M.item.busy),M.item.range!==void 0&&(V.range=M.item.range?C.$Kt.lift(M.item.range):null),M.item.description!==void 0&&(V.description=M.item.description),M.item.error!==void 0&&(V.error=M.item.error),M.item.sortText!==void 0&&(V.sortText=M.item.sortText)),{extId:M.extId,expand:M.expand,item:V}}})(n||(e.ITestItemUpdate=n={}));const d=(z,M)=>{M.expand!==void 0&&(z.expand=M.expand),M.item!==void 0&&(z.item=z.item?Object.assign(z.item,M.item):M.item)};e.$YI=d;var l;(function(z){z.serializeWithoutMessages=M=>({...s.serialize(M),ownComputedState:M.ownComputedState,computedState:M.computedState,tasks:M.tasks.map($.serializeWithoutMessages)}),z.serialize=M=>({...s.serialize(M),ownComputedState:M.ownComputedState,computedState:M.computedState,tasks:M.tasks.map($.serialize)}),z.deserialize=(M,V)=>({...s.deserialize(M,V),ownComputedState:V.ownComputedState,computedState:V.computedState,tasks:V.tasks.map(K=>$.deserialize(M,K)),retired:!0})})(l||(e.TestResultItem=l={}));var m;(function(z){z.empty=()=>({covered:0,total:0}),z.sum=(M,V)=>{M.covered+=V.covered,M.total+=V.total}})(m||(e.ICoverageCount=m={}));var E;(function(z){z.serialize=M=>({id:M.id,statement:M.statement,branch:M.branch,declaration:M.declaration,testIds:M.testIds,uri:M.uri.toJSON()}),z.deserialize=(M,V)=>({id:V.id,statement:V.statement,branch:V.branch,declaration:V.declaration,testIds:V.testIds,uri:M.asCanonicalUri(r.URI.revive(V.uri))}),z.empty=(M,V)=>({id:M,uri:V,statement:m.empty()})})(E||(e.IFileCoverage=E={}));function S(z){return{...z,location:z.location?.toJSON()}}function y(z){return z.location=z.location?h.$Jt.isIPosition(z.location)?h.$Jt.lift(z.location):C.$Kt.lift(z.location):void 0,z}e.$ZI=3;var k;(function(z){z[z.Declaration=0]="Declaration",z[z.Statement=1]="Statement",z[z.Branch=2]="Branch"})(k||(e.DetailType=k={}));var A;(function(z){z.serialize=M=>M.type===k.Declaration?v.serialize(M):F.serialize(M),z.deserialize=M=>M.type===k.Declaration?v.deserialize(M):F.deserialize(M)})(A||(e.CoverageDetails=A={}));var p;(function(z){z.serialize=S,z.deserialize=y})(p||(e.IBranchCoverage=p={}));var v;(function(z){z.serialize=S,z.deserialize=y})(v||(e.IDeclarationCoverage=v={}));var F;(function(z){z.serialize=M=>({...S(M),branches:M.branches?.map(p.serialize)}),z.deserialize=M=>({...y(M),branches:M.branches?.map(p.deserialize)})})(F||(e.IStatementCoverage=F={}));var N;(function(z){z[z.Add=0]="Add",z[z.Update=1]="Update",z[z.DocumentSynced=2]="DocumentSynced",z[z.Remove=3]="Remove",z[z.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",z[z.Retire=5]="Retire",z[z.AddTag=6]="AddTag",z[z.RemoveTag=7]="RemoveTag"})(N||(e.TestDiffOpType=N={}));var O;(function(z){z.deserialize=(M,V)=>V.op===N.Add?{op:V.op,item:s.deserialize(M,V.item)}:V.op===N.Update?{op:V.op,item:n.deserialize(V.item)}:V.op===N.DocumentSynced?{op:V.op,uri:M.asCanonicalUri(r.URI.revive(V.uri)),docv:V.docv}:V,z.serialize=M=>M.op===N.Add?{op:M.op,item:s.serialize(M.item)}:M.op===N.Update?{op:M.op,item:n.serialize(M.item)}:M})(O||(e.TestsDiffOp=O={}));class j{constructor(M){this.k=M,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(M){const V=this.w();for(const K of M)switch(K.op){case N.Add:this.l(s.deserialize(this.k,K.item),V);break;case N.Update:this.p(n.deserialize(K.item),V);break;case N.Remove:this.q(K.itemId,V);break;case N.Retire:this.v(K.itemId);break;case N.IncrementPendingExtHosts:this.updatePendingRoots(K.amount);break;case N.AddTag:this.c.set(K.tag.id,K.tag);break;case N.RemoveTag:this.c.delete(K.id);break}V.complete?.()}l(M,V){const K=T.$RI.parentId(M.item.extId)?.toString();let ne;if(!K)ne=this.x(M),this.g.add(ne),this.f.set(M.item.extId,ne);else if(this.f.has(K)){const B=this.f.get(K);B.children.add(M.item.extId),ne=this.x(M,B),this.f.set(M.item.extId,ne)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(M)}`);return}return V.add?.(ne),M.expand===t.BusyExpanding&&this.h++,ne}p(M,V){const K=this.f.get(M.extId);if(K)return M.expand!==void 0&&(K.expand===t.BusyExpanding&&this.h--,M.expand===t.BusyExpanding&&this.h++),(0,e.$YI)(K,M),V.update?.(K),K}q(M,V){const K=this.f.get(M);if(!K)return;const ne=T.$RI.parentId(K.item.extId)?.toString();ne?this.f.get(ne).children.delete(K.item.extId):this.g.delete(K);const B=[[M]];for(;B.length;)for(const G of B.pop()){const Y=this.f.get(G);Y&&(B.push(Y.children),this.f.delete(G),V.remove?.(Y,Y!==K),Y.expand===t.BusyExpanding&&this.h--)}}v(M){}updatePendingRoots(M){this.j+=M}w(){return{}}}e.$1I=j}),define(ke[263],Ie([1,0,137,8,74]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$kGb=e.$jGb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var T;(function(D){D.ViewletId="workbench.view.extension.test",D.ExplorerViewId="workbench.view.testing",D.OutputPeekContributionId="editor.contrib.testingOutputPeek",D.DecorationsContributionId="editor.contrib.testingDecorations",D.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",D.CoverageViewId="workbench.view.testCoverage",D.ResultsPanelId="workbench.panel.testResults",D.ResultsViewId="workbench.panel.testResults.view",D.MessageLanguageId="vscodeInternalTestMessage"})(T||(e.Testing=T={}));var L;(function(D){D.List="list",D.Tree="true"})(L||(e.TestExplorerViewMode=L={}));var R;(function(D){D.ByLocation="location",D.ByStatus="status",D.ByDuration="duration"})(R||(e.TestExplorerViewSorting=R={}));const b={[C.TestResultState.Errored]:(0,h.localize)(3112,null),[C.TestResultState.Failed]:(0,h.localize)(3113,null),[C.TestResultState.Passed]:(0,h.localize)(3114,null),[C.TestResultState.Queued]:(0,h.localize)(3115,null),[C.TestResultState.Running]:(0,h.localize)(3116,null),[C.TestResultState.Skipped]:(0,h.localize)(3117,null),[C.TestResultState.Unset]:(0,h.localize)(3118,null)},c=(D,u)=>(0,h.localize)(3119,null,(0,r.$Vk)(D),b[u]);e.$jGb=c,e.$kGb={[C.TestRunProfileBitset.Debug]:(0,h.localize)(3120,null),[C.TestRunProfileBitset.Run]:(0,h.localize)(3121,null),[C.TestRunProfileBitset.Coverage]:(0,h.localize)(3122,null)};var I;(function(D){D.CancelTestRefreshAction="testing.cancelTestRefresh",D.CancelTestRunAction="testing.cancelRun",D.ClearTestResultsAction="testing.clearTestResults",D.CollapseAllAction="testing.collapseAll",D.ConfigureTestProfilesAction="testing.configureProfile",D.ContinousRunUsingForTest="testing.continuousRunUsingForTest",D.CoverageAtCursor="testing.coverageAtCursor",D.CoverageByUri="testing.coverage.uri",D.CoverageClear="testing.coverage.close",D.CoverageCurrentFile="testing.coverageCurrentFile",D.CoverageFilterToTest="testing.coverageFilterToTest",D.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",D.CoverageLastRun="testing.coverageLastRun",D.CoverageSelectedAction="testing.coverageSelected",D.CoverageToggleToolbar="testing.coverageToggleToolbar",D.CoverageViewChangeSorting="testing.coverageViewChangeSorting",D.DebugAction="testing.debug",D.DebugAllAction="testing.debugAll",D.DebugAtCursor="testing.debugAtCursor",D.DebugByUri="testing.debug.uri",D.DebugCurrentFile="testing.debugCurrentFile",D.DebugFailedTests="testing.debugFailTests",D.DebugLastRun="testing.debugLastRun",D.DebugSelectedAction="testing.debugSelected",D.FilterAction="workbench.actions.treeView.testExplorer.filter",D.GetExplorerSelection="_testing.getExplorerSelection",D.GetSelectedProfiles="testing.getSelectedProfiles",D.GoToTest="testing.editFocusedTest",D.HideTestAction="testing.hideTest",D.OpenCoverage="testing.openCoverage",D.OpenOutputPeek="testing.openOutputPeek",D.RefreshTestsAction="testing.refreshTests",D.ReRunFailedTests="testing.reRunFailTests",D.ReRunLastRun="testing.reRunLastRun",D.RunAction="testing.run",D.RunAllAction="testing.runAll",D.RunAllWithCoverageAction="testing.coverageAll",D.RunAtCursor="testing.runAtCursor",D.RunByUri="testing.run.uri",D.RunCurrentFile="testing.runCurrentFile",D.RunSelectedAction="testing.runSelected",D.RunUsingProfileAction="testing.runUsing",D.RunWithCoverageAction="testing.coverage",D.SearchForTestExtension="testing.searchForTestExtension",D.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",D.ShowMostRecentOutputAction="testing.showMostRecentOutput",D.StartContinousRun="testing.startContinuousRun",D.StopContinousRun="testing.stopContinuousRun",D.TestingSortByDurationAction="testing.sortByDuration",D.TestingSortByLocationAction="testing.sortByLocation",D.TestingSortByStatusAction="testing.sortByStatus",D.TestingViewAsListAction="testing.viewAsList",D.TestingViewAsTreeAction="testing.viewAsTree",D.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",D.ToggleInlineTestOutput="testing.toggleInlineTestOutput",D.UnhideAllTestsAction="testing.unhideAllTests",D.UnhideTestAction="testing.unhideTest"})(I||(e.TestCommandId=I={}))}),define(ke[120],Ie([1,0,7,4,3,65,74,73]),function(me,e,r,h,C,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UP=e.$TP=e.$SP=e.$RP=e.$QP=e.TestItemEventOp=void 0;var b;(function(g){g[g.Upsert=0]="Upsert",g[g.SetTags=1]="SetTags",g[g.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",g[g.RemoveChild=3]="RemoveChild",g[g.SetProp=4]="SetProp",g[g.Bulk=5]="Bulk",g[g.DocumentSynced=6]="DocumentSynced"})(b||(e.TestItemEventOp=b={}));const c=(g,i)=>g===i,D=Object.entries({range:(g,i)=>g===i?!0:!g||!i?!1:g.equalsRange(i),busy:c,label:c,description:c,error:c,sortText:c,tags:(g,i)=>!(g.length!==i.length||g.some(o=>!i.includes(o)))}),u=(g,i)=>{let o;for(const[t,s]of D)s(g[t],i[t])||(o?o[t]=i[t]:o={[t]:i[t]});return o};class P extends C.$Tc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new r.$Oh(()=>this.flushDiff(),200)),this.g=this.B(new h.$je),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const o of this.tree.values())this.J(o)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case L.TestDiffOpType.DocumentSynced:{for(const o of this.m)if(o.op===L.TestDiffOpType.DocumentSynced&&o.uri===i.uri){o.docv=i.docv;return}break}case L.TestDiffOpType.Update:{const o=this.m[this.m.length-1];if(o){if(o.op===L.TestDiffOpType.Update&&o.item.extId===i.item.extId){(0,L.$YI)(o.item,i.item);return}if(o.op===L.TestDiffOpType.Add&&o.item.item.extId===i.item.extId){(0,L.$YI)(o.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,o){const t=this.tree.get(i);if(t){if((t.expandLevels===void 0||o>t.expandLevels)&&(t.expandLevels=o),t.expand===L.TestItemExpandState.Expandable){const s=this.M(t);return s.isOpen()?this.L(t,o-1):s.wait().then(()=>this.L(t,o-1))}else if(t.expand===L.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.L(t,o-1)):this.L(t,o-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,o){switch(o.op){case b.RemoveChild:this.O(R.$RI.joinToString(i.fullId,o.id));break;case b.Upsert:this.z(o.item,i);break;case b.Bulk:for(const t of o.ops)this.w(i,t);break;case b.SetTags:this.C(o.new,o.old,i.fullId.toString());break;case b.UpdateCanResolveChildren:this.J(i);break;case b.SetProp:this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:o.update}});break;case b.DocumentSynced:this.y(i.actual.uri);break;default:(0,T.$dd)(o)}}y(i){i&&this.pushDiff({op:L.TestDiffOpType.DocumentSynced,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,o){const t=R.$RI.fromExtHostTestItem(i,this.root.id,o?.actual),s=this.s.getApiFor(i);s.parent&&s.parent!==o?.actual&&this.s.getChildren(s.parent).delete(i.id);let n=this.tree.get(t.toString());if(!n){n={fullId:t,actual:i,expandLevels:o?.expandLevels?o.expandLevels-1:void 0,expand:L.TestItemExpandState.NotExpandable},i.tags.forEach(this.D,this),this.tree.set(n.fullId.toString(),n),this.G(i,o),this.pushDiff({op:L.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:n.expand,item:this.s.toITestItem(i)}}),this.I(i,n,o);return}if(n.actual===i){this.H(i,n,o);return}if(n.actual.uri?.toString()!==i.uri?.toString())return this.O(t.toString()),this.z(i,o);const d=this.s.getChildren(n.actual),l=n.actual,m=u(this.s.toITestItem(l),this.s.toITestItem(i));this.s.getApiFor(l).listener=void 0,n.actual=i,n.resolveBarrier=void 0,n.expand=L.TestItemExpandState.NotExpandable,m&&(m.hasOwnProperty("tags")&&(this.C(i.tags,l.tags,t.toString()),delete m.tags),this.w(n,{op:b.SetProp,update:m})),this.I(i,n,o);for(const[S,y]of d)this.s.getChildren(i).get(y.id)||this.O(R.$RI.joinToString(t,y.id));const E=n.expandLevels;E!==void 0&&queueMicrotask(()=>{n.expand===L.TestItemExpandState.Expandable&&(n.expandLevels=void 0,this.expand(t.toString(),E))}),this.y(n.actual.uri)}C(i,o,t){const s=new Set(o.map(n=>n.id));for(const n of i)s.delete(n.id)||this.D(n);this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:t,item:{tags:i.map(n=>(0,L.$WI)(this.s.controllerId,n.id))}}}),s.forEach(this.F,this)}D(i){const o=this.j.get(i.id);o?o.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:L.TestDiffOpType.AddTag,tag:{id:(0,L.$WI)(this.s.controllerId,i.id)}}))}F(i){const o=this.j.get(i);o&&!--o.refCount&&(this.j.delete(i),this.pushDiff({op:L.TestDiffOpType.RemoveTag,id:(0,L.$WI)(this.s.controllerId,i)}))}G(i,o){this.s.getApiFor(i).parent=o&&o.actual!==this.root?o.actual:void 0}H(i,o,t){this.G(i,t);const s=this.s.getApiFor(i);s.parent=t?.actual,s.listener=n=>this.w(o,n),this.J(o)}I(i,o,t){this.H(i,o,t);for(const[s,n]of this.s.getChildren(i))this.z(n,o)}J(i){let o;this.h?i.resolveBarrier?o=i.resolveBarrier.isOpen()?L.TestItemExpandState.Expanded:L.TestItemExpandState.BusyExpanding:o=i.actual.canResolveChildren?L.TestItemExpandState.Expandable:L.TestItemExpandState.NotExpandable:o=L.TestItemExpandState.NotExpandable,o!==i.expand&&(i.expand=o,this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:o}}),o===L.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.M(i))}L(i,o){if(o<0)return;const t=[];for(const[s,n]of this.s.getChildren(i.actual)){const d=this.expand(R.$RI.joinToString(i.fullId,n.id),o);(0,r.$oh)(d)&&t.push(d)}if(t.length)return Promise.all(t).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const n=new r.$Bh;return n.open(),n}i.expand=L.TestItemExpandState.BusyExpanding,this.N(i);const o=i.resolveBarrier=new r.$Bh,t=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,n)};let s;try{s=this.h(i.actual===this.root?void 0:i.actual)}catch(n){t(n)}return(0,r.$oh)(s)?s.catch(t).then(()=>{o.open(),this.J(i)}):(o.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const o=this.tree.get(i);if(!o)throw new Error("attempting to remove non-existent child");this.pushDiff({op:L.TestDiffOpType.Remove,itemId:i});const t=[o];for(;t.length;){const s=t.pop();if(s){this.s.getApiFor(s.actual).listener=void 0;for(const n of s.actual.tags)this.F(n.id);this.tree.delete(s.fullId.toString());for(const[n,d]of this.s.getChildren(s.actual))t.push(this.tree.get(R.$RI.joinToString(s.fullId,d.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$QP=P;class w extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$RP=w;class a extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$SP=a;class $ extends Error{constructor(i,o,t){super(`TestItem with ID "${i}" is from controller "${o}" and cannot be added as a child of an item from controller "${t}".`)}}e.$TP=$;const f=(g,i,o)=>{let t=new Map;return{get size(){return t.size},forEach(s,n){for(const d of t.values())s.call(n,d,this)},[Symbol.iterator](){return t.entries()},replace(s){const n=new Map,d=new Set(t.keys()),l={op:b.Bulk,ops:[]};for(const m of s){if(!(m instanceof o))throw new a(m.id);const E=i(m).controllerId;if(E!==g.controllerId)throw new $(m.id,E,g.controllerId);if(n.has(m.id))throw new w(m.id);n.set(m.id,m),d.delete(m.id),l.ops.push({op:b.Upsert,item:m})}for(const m of d.keys())l.ops.push({op:b.RemoveChild,id:m});g.listener?.(l),t=n},add(s){if(!(s instanceof o))throw new a(s.id);t.set(s.id,s),g.listener?.({op:b.Upsert,item:s})},delete(s){t.delete(s)&&g.listener?.({op:b.RemoveChild,id:s})},get(s){return t.get(s)},toJSON(){return Array.from(t.values())}}};e.$UP=f}),define(ke[155],Ie([1,0,120]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WP=e.$VP=void 0;const h=new WeakMap,C=(L,R)=>{const b={controllerId:R};return h.set(L,b),b};e.$VP=C;const T=L=>{const R=h.get(L);if(!R)throw new r.$SP(L?.id||"<unknown>");return R};e.$WP=T}),define(ke[121],Ie([1,0,26,14,2]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dDb=e.$cDb=e.$bDb=void 0,e.$eDb=T,e.$fDb=R,e.$bDb="vscode-cdn.net",e.$cDb=`vscode-resource.${e.$bDb}`,e.$dDb=`'self' https://*.${e.$bDb}`;function T(b,c){return b.scheme===h.Schemas.http||b.scheme===h.Schemas.https?b:(c&&c.authority&&c.isRemote&&b.scheme===h.Schemas.file&&(b=C.URI.from({scheme:h.Schemas.vscodeRemote,authority:c.authority,path:b.path})),C.URI.from({scheme:h.Schemas.https,authority:`${b.scheme}+${L(b.authority)}.${e.$cDb}`,path:b.path,fragment:b.fragment,query:b.query}))}function L(b){return b.replace(/./g,c=>{const I=c.charCodeAt(0);return I>=r.CharCode.a&&I<=r.CharCode.z||I>=r.CharCode.A&&I<=r.CharCode.Z||I>=r.CharCode.Digit0&&I<=r.CharCode.Digit9?c:"-"+I.toString(16).padStart(4,"0")})}function R(b){return b.replace(/-([0-9a-f]{4})/g,(c,I)=>String.fromCharCode(parseInt(I,16)))}}),define(ke[264],Ie([1,0,4,3,121]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eoc=void 0;class T{constructor(R,b,c){this.d=R,this.e=b,this.f=c,this.a=0,this.b=new h.$Sc,this.c=new Map,this.b.add(b.onDidChangeVisibleTextEditors(()=>{const I=b.getVisibleTextEditors();for(const D of this.c.values())I.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach(R=>R.inset.dispose()),this.b.dispose()}createWebviewEditorInset(R,b,c,I,D){let u;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===R){u=i;break}if(!u)throw new Error("not a visible editor");const P=this,w=this.a++,a=new r.$je,$=new r.$je,f=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,C.$eDb)(i,P.f)}get cspSource(){return C.$dDb}set options(i){this.b=i,P.d.$setOptions(w,i)}get options(){return this.b}set html(i){this.a=i,P.d.$setHtml(w,i)}get html(){return this.a}get onDidReceiveMessage(){return a.event}postMessage(i){return P.d.$postMessage(w,i)}},g=new class{constructor(){this.editor=R,this.line=b,this.height=c,this.webview=f,this.onDidDispose=$.event}dispose(){P.c.has(w)&&(P.c.delete(w),P.d.$disposeEditorInset(w),$.fire(),$.dispose(),a.dispose())}};return this.d.$createEditorInset(w,u.id,u.value.document.uri,b+1,c,I||{},D.identifier,D.extensionLocation),this.c.set(w,{editor:R,inset:g,onDidReceiveMessage:a}),g}$onDidDispose(R){const b=this.c.get(R);b&&b.inset.dispose()}$onDidReceiveMessage(R,b){this.c.get(R)?.onDidReceiveMessage.fire(b)}}e.$Eoc=T}),define(ke[156],Ie([1,0,5]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wM=e.$vM=e.$uM=void 0,e.$uM="__",e.$vM=(0,r.$Ci)("IAuthenticationService"),e.$wM=(0,r.$Ci)("IAuthenticationExtensionsService")}),define(ke[265],Ie([1,0,5]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PQ=e.VariableKind=e.$OQ=void 0,e.$OQ=(0,r.$Ci)("configurationResolverService");var h;(function(T){T.Unknown="unknown",T.Env="env",T.Config="config",T.Command="command",T.Input="input",T.ExtensionInstallFolder="extensionInstallFolder",T.WorkspaceFolder="workspaceFolder",T.Cwd="cwd",T.WorkspaceFolderBasename="workspaceFolderBasename",T.UserHome="userHome",T.LineNumber="lineNumber",T.SelectedText="selectedText",T.File="file",T.FileWorkspaceFolder="fileWorkspaceFolder",T.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",T.RelativeFile="relativeFile",T.RelativeFileDirname="relativeFileDirname",T.FileDirname="fileDirname",T.FileExtname="fileExtname",T.FileBasename="fileBasename",T.FileBasenameNoExtension="fileBasenameNoExtension",T.FileDirnameBasename="fileDirnameBasename",T.ExecPath="execPath",T.ExecInstallFolder="execInstallFolder",T.PathSeparator="pathSeparator",T.PathSeparatorAlias="/"})(h||(e.VariableKind=h={}));class C extends Error{constructor(L,R){super(R),this.variable=L}}e.$PQ=C}),define(ke[266],Ie([1,0,16,55,17,24,10,107,8,265,12]),function(me,e,r,h,C,T,L,R,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Q=void 0,r=Ue(r),h=Ue(h),C=Ue(C),T=Ue(T);class D{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(P,w,a,$){this.h=new Map,this.a=P,this.b=w,this.g=a,$&&(this.c=$.then(f=>this.i(f)))}i(P){if(L.$j){const w=Object.create(null);return Object.keys(P).forEach(a=>{w[a.toLowerCase()]=P[a]}),w}return P}resolveWithEnvironment(P,w,a){return this.l({env:this.i(P),userHome:void 0},w?w.uri:void 0,a)}async resolveAsync(P,w){const a={env:await this.c,userHome:await this.g};return this.l(a,P?P.uri:void 0,w)}async j(P,w,a,$){const f=T.$ao(w);L.$j&&f.windows?Object.keys(f.windows).forEach(i=>f[i]=f.windows[i]):L.$k&&f.osx?Object.keys(f.osx).forEach(i=>f[i]=f.osx[i]):L.$l&&f.linux&&Object.keys(f.linux).forEach(i=>f[i]=f.linux[i]),delete f.windows,delete f.osx,delete f.linux;const g={env:await this.c,userHome:await this.g};return this.l(g,P?P.uri:void 0,f,a,$)}async resolveAnyAsync(P,w,a){return this.j(P,w,a)}async resolveAnyMap(P,w,a){const $=new Map;return{newConfig:await this.j(P,w,a,$),resolvedVariables:$}}resolveWithInteractionReplace(P,w,a,$){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,w,a,$){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,w){if(this.h.has(P))throw new Error("Variable "+P+" is contributed twice.");this.h.set(P,w)}async l(P,w,a,$,f){if(C.$cg(a))return this.m(P,w,a,$,f);if(Array.isArray(a))return Promise.all(a.map(g=>this.l(P,w,g,$,f)));if(C.$eg(a)){const g=Object.create(null),i=await Promise.all(Object.keys(a).map(async o=>[await this.m(P,w,o,$,f),await this.l(P,w,a[o],$,f)]));for(const[o,t]of i)g[o]=t;return g}return a}m(P,w,a,$,f){return(0,I.$vf)(a,D.VARIABLE_REGEXP,async(g,i)=>{if(i.includes(D.VARIABLE_LHS))return g;let o=await this.o(P,g,i,w,$);return f?.set(i,o),o!==g&&C.$cg(o)&&o.match(D.VARIABLE_REGEXP)&&(o=await this.m(P,w,o,$,f)),o})}n(P){return this.b?this.b.getUriLabel(P,{noPrefix:!0}):P.fsPath}async o(P,w,a,$,f){let g;const i=a.split(":");i.length>1&&(a=i[0],g=i[1]);const o=n=>{const d=this.a.getFilePath();if(d)return(0,R.$Vw)(d);throw new c.$PQ(n,(0,b.localize)(2029,null,w))},t=n=>{const d=o(n);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,R.$Vw)(l)}throw new c.$PQ(n,(0,b.localize)(2030,null,w,r.$mc(d)))},s=n=>{if(g){const d=this.a.getFolderUri(g);if(d)return d;throw new c.$PQ(n,(0,b.localize)(2031,null,w,g))}if($)return $;throw this.a.getWorkspaceFolderCount()>1?new c.$PQ(n,(0,b.localize)(2032,null,w)):new c.$PQ(n,(0,b.localize)(2033,null,w))};switch(a){case"env":if(g){if(P.env){const n=P.env[L.$j?g.toLowerCase():g];if(C.$cg(n))return n}return""}throw new c.$PQ(c.VariableKind.Env,(0,b.localize)(2034,null,w));case"config":if(g){const n=this.a.getConfigurationValue($,g);if(C.$lg(n))throw new c.$PQ(c.VariableKind.Config,(0,b.localize)(2035,null,w,g));if(C.$eg(n))throw new c.$PQ(c.VariableKind.Config,(0,b.localize)(2036,null,w,g));return n}throw new c.$PQ(c.VariableKind.Config,(0,b.localize)(2037,null,w));case"command":return this.p(c.VariableKind.Command,w,g,f,"command");case"input":return this.p(c.VariableKind.Input,w,g,f,"input");case"extensionInstallFolder":if(g){const n=await this.a.getExtension(g);if(!n)throw new c.$PQ(c.VariableKind.ExtensionInstallFolder,(0,b.localize)(2038,null,w,g));return this.n(n.extensionLocation)}throw new c.$PQ(c.VariableKind.ExtensionInstallFolder,(0,b.localize)(2039,null,w));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,R.$Vw)(this.n(s(c.VariableKind.WorkspaceFolder)));case"cwd":return $||g?(0,R.$Vw)(this.n(s(c.VariableKind.Cwd))):h.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,R.$Vw)(r.$mc(this.n(s(c.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(P.userHome)return P.userHome;throw new c.$PQ(c.VariableKind.UserHome,(0,b.localize)(2040,null,w))}case"lineNumber":{const n=this.a.getLineNumber();if(n)return n;throw new c.$PQ(c.VariableKind.LineNumber,(0,b.localize)(2041,null,w))}case"selectedText":{const n=this.a.getSelectedText();if(n)return n;throw new c.$PQ(c.VariableKind.SelectedText,(0,b.localize)(2042,null,w))}case"file":return o(c.VariableKind.File);case"fileWorkspaceFolder":return t(c.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return r.$mc(t(c.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return $||g?r.$kc(this.n(s(c.VariableKind.RelativeFile)),o(c.VariableKind.RelativeFile)):o(c.VariableKind.RelativeFile);case"relativeFileDirname":{const n=r.$lc(o(c.VariableKind.RelativeFileDirname));if($||g){const d=r.$kc(this.n(s(c.VariableKind.RelativeFileDirname)),n);return d.length===0?".":d}return n}case"fileDirname":return r.$lc(o(c.VariableKind.FileDirname));case"fileExtname":return r.$nc(o(c.VariableKind.FileExtname));case"fileBasename":return r.$mc(o(c.VariableKind.FileBasename));case"fileBasenameNoExtension":{const n=r.$mc(o(c.VariableKind.FileBasenameNoExtension));return n.slice(0,n.length-r.$nc(n).length)}case"fileDirnameBasename":return r.$mc(r.$lc(o(c.VariableKind.FileDirnameBasename)));case"execPath":{const n=this.a.getExecPath();return n||w}case"execInstallFolder":{const n=this.a.getAppRoot();return n||w}case"pathSeparator":case"/":return r.sep;default:try{const n=g?`${a}:${g}`:a;return this.p(c.VariableKind.Unknown,w,n,f,void 0)}catch{return w}}}}p(P,w,a,$,f){if(a&&$){const g=f===void 0?$[a]:$[f+":"+a];if(typeof g=="string")return g;throw new c.$PQ(P,(0,b.localize)(2043,null,w))}return w}}e.$5Q=D}),define(ke[157],Ie([1,0,5,152]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$hE=void 0,e.$iE=c,e.$jE=u,e.$kE=P,e.$hE=(0,r.$Ci)("editorGroupsService");var C;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var T;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(T||(e.GroupOrientation=T={}));var L;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(L||(e.GroupLocation=L={}));var R;(function(w){w[w.MAXIMIZE=0]="MAXIMIZE",w[w.EXPAND=1]="EXPAND",w[w.EVEN=2]="EVEN"})(R||(e.GroupsArrangement=R={}));var b;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(b||(e.MergeGroupMode=b={}));function c(w){const a=w;return(0,h.$6F)(a?.editor)&&(0,h.$6F)(a?.replacement)}var I;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I||(e.GroupsOrder=I={}));var D;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function u(w){const a=w;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}function P(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?C.DOWN:C.RIGHT}}),define(ke[267],Ie([1,0,5,157]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oE=e.$nE=e.$mE=e.$lE=void 0,e.$pE=C,e.$lE=(0,r.$Ci)("editorService"),e.$mE=-1,e.$nE=-2,e.$oE=-3;function C(T){const L=T;return typeof T=="number"||(0,h.$jE)(L)}}),define(ke[158],Ie([1,0,5,144]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PM=void 0,e.$PM=(0,r.$Di)(h.$Ji)}),define(ke[159],Ie([1,0,23,4,16,3,7]),function(me,e,r,h,C,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=e.$Qcc=e.$Pcc=e.$Occ=e.$Ncc=void 0,C=Ue(C);class R{constructor(g,i){this.versionId=g,this.removedDueToLooping=i}}e.$Ncc=R;class b{static isHostExtension(g,i,o){if(i.getExtensionDescription(g))return!1;const t=o.getExtensionDescription(g);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(g,i){this.j=g,this.c=new h.$je,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(a),this.f=new r.$pn,this.g=[],this.h=new Map;for(const g of this.e){if(this.f.has(g.identifier)){console.error("Extension `"+g.identifier.value+"` is already registered");continue}this.f.set(g.identifier,g),this.g.push(g);const i=this.j.readActivationEvents(g);for(const o of i)this.h.has(o)||this.h.set(o,[]),this.h.get(o).push(g)}}set(g){return this.e=g,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(g,i){this.e=$(this.e,i),this.e=this.e.concat(g);const o=b.l(this.e);return this.e=$(this.e,o.map(t=>t.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,o)}static l(g){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(d){this.d.has(d)||(this.d.add(d),this.e.push(d))}addArc(d,l){this.addNode(d),this.addNode(l),this.c.has(d)?this.c.get(d).push(l):this.c.set(d,[l])}getArcs(d){return this.c.has(d)?this.c.get(d):[]}hasOnlyGoodArcs(d,l){const m=i.getArcs(d);for(let E=0;E<m.length;E++)if(!l.has(m[E]))return!1;return!0}getNodes(){return this.e}},o=new r.$pn;for(const d of g)if(o.set(d.identifier,d),d.extensionDependencies)for(const l of d.extensionDependencies)i.addArc(r.$nn.toKey(d.identifier),r.$nn.toKey(l));const t=new Set;i.getNodes().filter(d=>i.getArcs(d).length===0).forEach(d=>t.add(d));const s=i.getNodes().filter(d=>!t.has(d));let n;do{n=!1;for(let d=0;d<s.length;d++){const l=s[d];i.hasOnlyGoodArcs(l,t)&&(s.splice(d,1),d--,t.add(l),n=!0)}}while(n);return s.map(d=>o.get(d))}containsActivationEvent(g){return this.h.has(g)}containsExtension(g){return this.f.has(g)}getExtensionDescriptionsForActivationEvent(g){const i=this.h.get(g);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new c(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(g){const i=this.f.get(g);return i||void 0}getExtensionDescriptionByUUID(g){for(const i of this.g)if(i.uuid===g)return i}getExtensionDescriptionByIdOrUUID(g,i){return this.getExtensionDescription(g)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$Occ=b;class c{constructor(g,i){this.versionId=g,this.extensions=i}}e.$Pcc=c;class I{constructor(g){this.d=new P,this.c=new b(g,[])}async acquireLock(g){const i=await this.d.acquire(g);return new D(this,i)}deltaExtensions(g,i,o){if(!g.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,o)}containsActivationEvent(g){return this.c.containsActivationEvent(g)}containsExtension(g){return this.c.containsExtension(g)}getExtensionDescriptionsForActivationEvent(g){return this.c.getExtensionDescriptionsForActivationEvent(g)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(g){return this.c.getExtensionDescription(g)}getExtensionDescriptionByUUID(g){return this.c.getExtensionDescriptionByUUID(g)}getExtensionDescriptionByIdOrUUID(g,i){return this.c.getExtensionDescriptionByIdOrUUID(g,i)}}e.$Qcc=I;class D extends T.$Tc{constructor(g,i){super(),this.f=g,this.c=!1,this.B(i)}isAcquiredFor(g){return!this.c&&this.f===g}}e.$Rcc=D;class u{constructor(g){this.name=g;const i=(0,L.$vh)();this.promise=i.promise,this.c=i.resolve}resolve(g){this.c(g)}}class P{constructor(){this.c=[],this.d=!1}async acquire(g){const i=new u(g);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const g=this.c.shift();this.d=!0;let i=!0;const o=setTimeout(()=>{i&&console.warn(`The customer named ${g.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{i&&(clearTimeout(o),i=!1,this.d=!1,this.e())};g.resolve((0,T.$Rc)(t))}}var w;(function(f){f[f.Builtin=0]="Builtin",f[f.User=1]="User",f[f.Dev=2]="Dev"})(w||(w={}));function a(f,g){const i=f.isBuiltin?w.Builtin:f.isUnderDevelopment?w.Dev:w.User,o=g.isBuiltin?w.Builtin:g.isUnderDevelopment?w.Dev:w.User;if(i!==o)return i-o;const t=C.$fc.basename(f.extensionLocation.path),s=C.$fc.basename(g.extensionLocation.path);return t<s?-1:t>s?1:0}function $(f,g){const i=new r.$on(g);return f.filter(o=>!i.has(o.identifier))}}),define(ke[268],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$an=e.$_m=e.$$m=e.ExtHostConnectionType=void 0,e.$bn=R,e.$cn=b;var r;(function(I){I[I.IPC=1]="IPC",I[I.Socket=2]="Socket",I[I.MessagePort=3]="MessagePort"})(r||(e.ExtHostConnectionType=r={}));class h{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(D){this.pipeName=D,this.type=r.IPC}serialize(D){D[h.ENV_KEY]=this.pipeName}}e.$$m=h;class C{constructor(){this.type=r.Socket}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(D){D[C.ENV_KEY]="1"}}e.$_m=C;class T{constructor(){this.type=r.MessagePort}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(D){D[T.ENV_KEY]="1"}}e.$an=T;function L(I){delete I[h.ENV_KEY],delete I[C.ENV_KEY],delete I[T.ENV_KEY]}function R(I,D){L(D),I.serialize(D)}function b(I){if(I[h.ENV_KEY])return c(I,new h(I[h.ENV_KEY]));if(I[C.ENV_KEY])return c(I,new C);if(I[T.ENV_KEY])return c(I,new T);throw new Error("No connection information defined in environment!")}function c(I,D){return L(I),D}}),define(ke[93],Ie([1,0,21]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$xn=L,e.$yn=R;var h;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(h||(e.UIKind=h={}));var C;(function(c){c[c.VersionMismatch=55]="VersionMismatch",c[c.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var T;(function(c){c[c.Initialized=0]="Initialized",c[c.Ready=1]="Ready",c[c.Terminate=2]="Terminate"})(T||(e.MessageType=T={}));function L(c){const I=r.$Le.alloc(1);switch(c){case T.Initialized:I.writeUInt8(1,0);break;case T.Ready:I.writeUInt8(2,0);break;case T.Terminate:I.writeUInt8(3,0);break}return I}function R(c,I){if(c.byteLength!==1)return!1;switch(c.readUInt8(0)){case 1:return I===T.Initialized;case 2:return I===T.Ready;case 3:return I===T.Terminate;default:return!1}}var b;(function(c){c.Start="START_NATIVE_LOG",c.End="END_NATIVE_LOG"})(b||(e.NativeLogMarkers=b={}))}),define(ke[94],Ie([1,0,5,4,149,11,29,93,90,91,24,2,3,8]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iQ=e.$gQ=e.$fQ=void 0,e.$hQ=$;let w=class extends u.$Tc{constructor(g,i){super(),this.s=g,this.t=i,this.a=this.B(new h.$je),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new h.$je),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=C.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=D.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:c.$yp,name:(0,P.localize)(10660,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(o=>{(0,T.$$j)(o)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===T.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===C.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=C.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=C.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=C.TelemetryLevel.USAGE:!1}}instantiateLogger(g,i,o){const t=this.getTelemetryDetails(),s=new a(i,o,g,this.n,this.j,this.getBuiltInCommonProperties(g),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),n=this.r.get(g.identifier.value)??[];return this.r.set(g.identifier.value,[...n,s]),s.apiTelemetryLogger}$initializeTelemetryLevel(g,i,o){this.f=g,this.g=i,this.c=o??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(g){const i=Object.create(null);switch(i["common.extname"]=`${g.publisher}.${g.name}`,i["common.extversion"]=g.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=$(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:i["common.uikind"]="web";break;case R.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,b.$en)((0,c.$Ep)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(g){this.h=this.getTelemetryConfiguration(),this.f=g;const i=this.getTelemetryDetails();this.r.forEach((o,t)=>{const s=o.filter(n=>!n.isDisposed);s.length===0?this.r.delete(t):this.r.set(t,s)}),this.r.forEach(o=>{for(const t of o)t.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(g,i){const t=this.r.get(g.value)?.filter(n=>!n.isDisposed);if(!t)return this.r.delete(g.value),!1;let s=!1;for(const n of t)n.ignoreUnhandledExtHostErrors||(n.logError(i),s=!0);return s}};e.$fQ=w,e.$fQ=w=Ye([Ve(0,L.$eQ),Ve(1,T.$0j)],w);class a{static validateSender(g){if(typeof g!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof g.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof g.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof g.flush<"u"&&typeof g.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(g,i,o,t,s,n,d){this.g=o,this.h=t,this.i=s,this.j=n,this.a=new h.$je,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=g,this.d={isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}}updateTelemetryEnablements(g,i){this.e&&(this.d={isUsageEnabled:g,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(g){let i="properties"in g?g.properties??{}:g;return i=(0,c.$Hp)(i,[]),this.c&&(i=(0,I.$do)(i,this.c)),this.b||(i=(0,I.$do)(i,this.j)),"properties"in g?g.properties=i:g=i,g}k(g,i){this.f&&(this.g.publisher==="vscode"?g=this.g.name+"/"+g:g=this.g.identifier.value+"/"+g,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(g,i),this.h.trace(g,i))}logUsage(g,i){this.d.isUsageEnabled&&this.k(g,i)}logError(g,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof g=="string")this.k(g,i);else{const o={name:g.name,message:g.message,stack:g.stack,cause:g.cause},t=(0,c.$Hp)(o,[]),s=new Error(t.message,{cause:t.cause});s.stack=t.stack,s.name=t.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(s,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const g=this,i={logUsage:g.logUsage.bind(g),get isUsageEnabled(){return g.d.isUsageEnabled},get isErrorsEnabled(){return g.d.isErrorsEnabled},logError:g.logError.bind(g),dispose:g.dispose.bind(g),onDidChangeEnableStates:g.a.event.bind(g)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let g=this.f;this.f=void 0,Promise.resolve(g.flush()).then(g=void 0),this.e=void 0}else this.f=void 0}}e.$gQ=a;function $(f){const g=Date.now()-new Date(f).getTime();return isNaN(g)?!1:g<1e3*60*60*24}e.$iQ=(0,r.$Ci)("IExtHostTelemetry")}),define(ke[25],Ie([1,0,4,2,239,147,23,5]),function(me,e,r,h,C,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0G=e.ActivationKind=e.$7G=e.$6G=e.$3G=e.ExtensionHostStartup=e.$2G=e.$1G=e.$ZG=e.$YG=void 0,e.$4G=u,e.$5G=P,e.$8G=f,e.$9G=g,e.$YG=Object.freeze({identifier:new L.$nn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:h.URI.parse("void:location"),isBuiltin:!1,targetPlatform:L.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$ZG="extensions.webWorker",e.$1G=(0,R.$Ci)("extensionService");class b{constructor(t){this.dependency=t}}e.$2G=b;var c;(function(o){o[o.EagerAutoStart=1]="EagerAutoStart",o[o.EagerManualStart=2]="EagerManualStart",o[o.Lazy=3]="Lazy"})(c||(e.ExtensionHostStartup=c={}));class I{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(t,s,n){this.c=t,this.d=s.slice(0),this.e=n.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:T.$KG.createActivationEventsMap(this.d)}}set(t,s,n){if(this.c>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this.c})`);const d=[],l=[],m=[],E=[],S=D(this.d),y=D(s),k=(N,O)=>N.extensionLocation.toString()===O.extensionLocation.toString()||N.isBuiltin===O.isBuiltin||N.isUserBuiltin===O.isUserBuiltin||N.isUnderDevelopment===O.isUnderDevelopment;for(const N of this.d){const O=y.get(N.identifier);if(!O){d.push(N.identifier),S.delete(N.identifier);continue}if(!k(N,O)){d.push(N.identifier),S.delete(N.identifier);continue}}for(const N of s){const O=S.get(N.identifier);if(!O){l.push(N);continue}if(!k(O,N)){d.push(O.identifier),S.delete(O.identifier);continue}}const A=new L.$on(this.e),p=new L.$on(n);for(const N of this.e)p.has(N)||m.push(N);for(const N of n)A.has(N)||E.push(N);const v=T.$KG.createActivationEventsMap(l),F={versionId:t,toRemove:d,toAdd:l,addActivationEvents:v,myToRemove:m,myToAdd:E};return this.delta(F),F}delta(t){if(this.c>=t.versionId)return null;const{toRemove:s,toAdd:n,myToRemove:d,myToAdd:l}=t,m=new L.$on(s),E=new L.$on(d);for(let S=0;S<this.d.length;S++)m.has(this.d[S].identifier)&&(this.d.splice(S,1),S--);for(let S=0;S<this.e.length;S++)E.has(this.e[S])&&(this.e.splice(S,1),S--);for(const S of n)this.d.push(S);for(const S of l)this.e.push(S);return this.f=null,t}containsExtension(t){for(const s of this.e)if(L.$nn.equals(s,t))return!0;return!1}containsActivationEvent(t){return this.f||(this.f=this.g()),this.f.has(t)}g(){const t=new Set;for(const s of this.d){if(!this.containsExtension(s.identifier))continue;const n=T.$KG.readActivationEvents(s);for(const d of n)t.add(d)}return t}}e.$3G=I;function D(o){const t=new L.$pn;for(const s of o)t.set(s.identifier,s);return t}function u(o,t){return o.enabledApiProposals?o.enabledApiProposals.includes(t):!1}function P(o,t){if(!u(o,t))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}class w{constructor(t,s,n,d){this.codeLoadingTime=t,this.activateCallTime=s,this.activateResolvedTime=n,this.activationReason=d}}e.$6G=w;class a{constructor(t,s){this.description=t,this.value=s}}e.$7G=a;var $;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})($||(e.ActivationKind=$={}));function f(o){return{type:o.isBuiltin?L.ExtensionType.System:L.ExtensionType.User,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,C.$Np)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}function g(o,t){const s=(0,C.$Lp)(o.manifest.publisher,o.manifest.name);return{id:s,identifier:new L.$nn(s),isBuiltin:o.type===L.ExtensionType.System,isUserBuiltin:o.type===L.ExtensionType.User&&o.isBuiltin,isUnderDevelopment:!!t,extensionLocation:o.location,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform,publisherDisplayName:o.publisherDisplayName,...o.manifest}}class i{constructor(){this.onDidRegisterExtensions=r.Event.None,this.onDidChangeExtensionsStatus=r.Event.None,this.onDidChangeExtensions=r.Event.None,this.onWillActivateByEvent=r.Event.None,this.onDidChangeResponsiveChange=r.Event.None,this.onWillStop=r.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,s){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,s){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$0G=i}),define(ke[269],Ie([1,0,13,159,23,25,11,7]),function(me,e,r,h,C,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6oc=e.$5oc=e.$4oc=e.$3oc=e.$2oc=e.$1oc=void 0,r=Ue(r);class b{static{this.NONE=new b(!1,-1,-1,-1)}constructor(f,g,i,o){this.startup=f,this.codeLoadingTime=g,this.activateCallTime=i,this.activateResolvedTime=o}}e.$1oc=b;class c{constructor(f){this.a=f,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(f,g){return f===-1||g===-1?-1:g-f}build(){return new b(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$2oc=c;class I{constructor(f,g,i,o,t,s){this.activationFailed=f,this.activationFailedError=g,this.activationTimes=i,this.module=o,this.exports=t,this.subscriptions=s}}e.$3oc=I;class D extends I{constructor(f){super(!1,null,f,{activate:void 0,deactivate:void 0},void 0,[])}}e.$4oc=D;class u extends I{constructor(){super(!1,null,b.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$5oc=u;class P extends I{constructor(f){super(!0,f,b.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let w=class{constructor(f,g,i,o){this.g=o,this.a=f,this.b=g,this.c=i,this.d=new C.$pn,this.f=Object.create(null)}dispose(){for(const[f,g]of this.d)g.dispose()}async waitForActivatingExtensions(){const f=[];for(const[g,i]of this.d)f.push(i.wait());await Promise.all(f)}isActivated(f){const g=this.d.get(f);return!!(g&&g.value)}getActivatedExtension(f){const g=this.d.get(f);if(!g||!g.value)throw new Error(`Extension '${f.value}' is not known or not activated`);return g.value}async activateByEvent(f,g){if(this.f[f])return;const i=this.a.getExtensionDescriptionsForActivationEvent(f);await this.h(i.map(o=>({id:o.identifier,reason:{startup:g,extensionId:o.identifier,activationEvent:f}}))),this.f[f]=!0}activateById(f,g){const i=this.a.getExtensionDescription(f);if(!i)throw new Error(`Extension '${f.value}' is not known`);return this.h([{id:i.identifier,reason:g}])}async h(f){const g=f.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(g.map(i=>i.wait()))}j(f){if(this.d.has(f.id))return this.d.get(f.id);if(this.l(f.id))return this.k(f,null,[],null);const g=this.a.getExtensionDescription(f.id);if(!g){const t=new Error(`Cannot activate unknown extension '${f.id.value}'`),s=this.k(f,null,[],new P(t));return this.c.onExtensionActivationError(f.id,t,new T.$2G(f.id.value)),s}const i=[],o=typeof g.extensionDependencies>"u"?[]:g.extensionDependencies;for(const t of o){if(this.m(t))continue;const s=this.d.get(t);if(s){i.push(s);continue}if(this.l(t)){i.push(this.j({id:this.b.getExtensionDescription(t).identifier,reason:f.reason}));continue}const n=this.a.getExtensionDescription(t);if(n){if(!n.main&&!n.browser)continue;i.push(this.j({id:n.identifier,reason:f.reason}));continue}const d=g.displayName||g.identifier.value,l=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${t}'`),m=this.k(f,g.displayName,[],new P(l));return this.c.onExtensionActivationError(g.identifier,l,new T.$2G(t)),m}return this.k(f,g.displayName,i,null)}k(f,g,i,o){const t=new a(f.id,g,f.reason,i,o,this.c,this.g);return this.d.set(f.id,t),t}l(f){return h.$Occ.isHostExtension(f,this.a,this.b)}m(f){const g=this.b.getExtensionDescription(f);return g?!g.main&&!g.browser:!1}};e.$6oc=w,e.$6oc=w=Ye([Ve(3,L.$9j)],w);let a=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(f,g,i,o,t,s,n){this.c=f,this.d=g,this.f=i,this.g=o,this.h=t,this.j=s,this.k=n,this.a=new R.$Bh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let f=0;f<this.g.length;f++){const g=this.g[f];if(g.value&&!g.value.activationFailed){this.g.splice(f,1),f--;continue}if(g.value&&g.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${g.friendlyName}' failed to activate`);i.detail=g.value.activationFailedError,this.h=new P(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(f=>f.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(f){const g=new Error;if(f&&f.name&&(g.name=f.name),f&&f.message?g.message=`Activating extension '${this.c.value}' failed: ${f.message}.`:g.message=`Activating extension '${this.c.value}' failed: ${f}.`,f&&f.stack&&(g.stack=f.stack),this.h=new P(g),this.b&&r.$3(f))return;this.j.onExtensionActivationError(this.c,g,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(f)}}};a=Ye([Ve(6,L.$9j)],a)});var zt=this&&this.__importDefault||function(me){return me&&me.__esModule?me:{default:me}};define(ke[160],Ie([1,0,8,13,43,146,116,36,23,115,147,143]),function(me,e,r,h,C,T,L,R,b,c,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=void 0,r=Ue(r),C=zt(C);const u=R.$no.as(L.$oo.JSONContribution);class P{constructor(t,s,n){this.a=t,this.b=s,this.c=n}d(t,s){this.a({type:t,message:s,extensionId:this.b.identifier,extensionPointId:this.c})}error(t){this.d(C.default.Error,t)}warn(t){this.d(C.default.Warning,t)}info(t){this.d(C.default.Info,t)}}e.$SG=P;class w{static a(t){const s=new b.$on;for(let n=0,d=t.length;n<d;n++)s.add(t[n].description.identifier);return s}static compute(t,s){if(!t||!t.length)return new w(s,[]);if(!s||!s.length)return new w([],t);const n=this.a(t),d=this.a(s),l=s.filter(E=>!n.has(E.description.identifier)),m=t.filter(E=>!d.has(E.description.identifier));return new w(l,m)}constructor(t,s){this.added=t,this.removed=s}}e.$TG=w;class a{constructor(t,s){this.name=t,this.defaultExtensionKind=s,this.a=null,this.b=null,this.c=null}setHandler(t){if(this.a!==null)throw new Error("Handler already set!");return this.a=t,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(t){this.c=w.compute(this.b,t),this.b=t,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(t){(0,h.$Y)(t)}}}e.$UG=a;const $={type:"string",enum:["ui","workspace"],enumDescriptions:[r.localize(1794,null),r.localize(1795,null)]},f="vscode://schemas/vscode-extensions";e.$VG={properties:{engines:{type:"object",description:r.localize(1796,null),properties:{vscode:{type:"string",description:r.localize(1797,null),default:"^1.22.0"}}},publisher:{description:r.localize(1798,null),type:"string"},displayName:{description:r.localize(1799,null),type:"string"},categories:{description:r.localize(1800,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:b.$mn},{type:"string",const:"Languages",deprecationMessage:r.localize(1801,null)}]}},galleryBanner:{type:"object",description:r.localize(1802,null),properties:{color:{description:r.localize(1803,null),type:"string"},theme:{description:r.localize(1804,null),type:"string",enum:["dark","light"]}}},contributes:{description:r.localize(1805,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:r.localize(1806,null)},enableProposedApi:{type:"boolean",deprecationMessage:r.localize(1807,null)},enabledApiProposals:{markdownDescription:r.localize(1808,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals).map(o=>o),markdownEnumDescriptions:Object.values(D.allApiProposals).map(o=>o.proposal)}},api:{markdownDescription:r.localize(1809,null),type:"string",enum:["none"],enumDescriptions:[r.localize(1810,null)]},activationEvents:{description:r.localize(1811,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:r.localize(1812,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:r.localize(1813,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:r.localize(1814,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:r.localize(1815,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:r.localize(1816,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:r.localize(1817,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:r.localize(1818,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:r.localize(1819,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:r.localize(1820,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:r.localize(1821,null),body:"onStartupFinished"},{label:"onTaskType",description:r.localize(1822,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:r.localize(1823,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:r.localize(1824,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:r.localize(1825,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:r.localize(1826,null)},{label:"onUri",body:"onUri",description:r.localize(1827,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:r.localize(1828,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:r.localize(1829,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:r.localize(1830,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:r.localize(1831,null)},{label:"onRenderer",description:r.localize(1832,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:r.localize(1833,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:r.localize(1834,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:r.localize(1835,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:r.localize(1836,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:r.localize(1837,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolName}",description:r.localize(1838,null)},{label:"*",description:r.localize(1839,null),body:"*"}]}},badges:{type:"array",description:r.localize(1840,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:r.localize(1841,null)},href:{type:"string",description:r.localize(1842,null)},description:{type:"string",description:r.localize(1843,null)}}}},markdown:{type:"string",description:r.localize(1844,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:r.localize(1845,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:r.localize(1846,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.$7o}},extensionPack:{description:r.localize(1847,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.$7o}},extensionKind:{description:r.localize(1848,null),type:"array",items:$,default:["workspace"],defaultSnippets:[{body:["ui"],description:r.localize(1849,null)},{body:["workspace"],description:r.localize(1850,null)},{body:["ui","workspace"],description:r.localize(1851,null)},{body:["workspace","ui"],description:r.localize(1852,null)},{body:[],description:r.localize(1853,null)}]},capabilities:{description:r.localize(1854,null),type:"object",properties:{virtualWorkspaces:{description:r.localize(1855,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:r.localize(1856,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(1857,null),r.localize(1858,null),r.localize(1859,null)]},description:{type:"string",markdownDescription:r.localize(1860,null)}}},untrustedWorkspaces:{description:r.localize(1861,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:r.localize(1862,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(1863,null),r.localize(1864,null),r.localize(1865,null)]},restrictedConfigurations:{description:r.localize(1866,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:r.localize(1867,null)}}}}},sponsor:{description:r.localize(1868,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:r.localize(1869,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:r.localize(1870,null),type:"string"},"vscode:uninstall":{description:r.localize(1871,null),type:"string"}}},icon:{type:"string",description:r.localize(1872,null)},l10n:{type:"string",description:r.localize(1873,null)},pricing:{type:"string",markdownDescription:r.localize(1874,null),enum:["Free","Trial"],default:"Free"}}};class g{constructor(){this.a=new Map}registerExtensionPoint(t){if(this.a.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const s=new a(t.extensionPoint,t.defaultExtensionKind);return this.a.set(t.extensionPoint,s),t.activationEventsGenerator&&I.$KG.register(t.extensionPoint,t.activationEventsGenerator),e.$VG.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,u.registerSchema(f,e.$VG),s}getExtensionPoints(){return Array.from(this.a.values())}}e.$WG=g;const i={ExtensionsRegistry:"ExtensionsRegistry"};R.$no.add(i.ExtensionsRegistry,new g),e.$XG=R.$no.as(i.ExtensionsRegistry),u.registerSchema(f,e.$VG),u.registerSchema(c.$qk,{properties:{extensionEnabledApiProposals:{description:r.localize(1875,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals).map(o=>o.proposal)}}]}}}})}),define(ke[270],Ie([1,0,4,39,3,12,8,23,5,11,25,160]),function(me,e,r,h,C,T,L,R,b,c,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aH=e.$_G=e.$$G=e.ChatMessageRole=void 0;var u;(function(a){a[a.System=0]="System",a[a.User=1]="User",a[a.Assistant=2]="Assistant"})(u||(e.ChatMessageRole=u={})),e.$$G=(0,b.$Ci)("ILanguageModelsService");const P={type:"object",properties:{vendor:{type:"string",description:(0,L.localize)(8281,null)}}};e.$_G=D.$XG.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,L.localize)(8282,null),oneOf:[P,{type:"array",items:P}]},activationEventsGenerator:(a,$)=>{for(const f of a)$.push(`onLanguageModelChat:${f.vendor}`)}});let w=class{constructor($,f){this.e=$,this.f=f,this.a=new C.$Sc,this.b=new Map,this.c=new Set,this.d=this.a.add(new r.$je),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$_G.setHandler(g=>{this.c.clear();for(const o of g){if(!(0,I.$4G)(o.description,"chatProvider")){o.collector.error((0,L.localize)(8283,null));continue}for(const t of h.Iterable.wrap(o.value)){if(this.c.has(t.vendor)){o.collector.error((0,L.localize)(8284,null,t.vendor));continue}if((0,T.$af)(t.vendor)){o.collector.error((0,L.localize)(8285,null));continue}if(t.vendor.trim()!==t.vendor){o.collector.error((0,L.localize)(8286,null));continue}this.c.add(t.vendor)}}const i=[];for(const[o,t]of this.b)this.c.has(t.metadata.vendor)||(this.b.delete(o),i.push(o));i.length>0&&this.d.fire({removed:i})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel($){return this.b.get($)?.metadata}async selectLanguageModels($){if($.vendor)await this.e.activateByEvent(`onLanguageModelChat:${$.vendor}}`);else{const g=Array.from(this.c).map(i=>this.e.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all(g)}const f=[];for(const[g,i]of this.b)($.vendor===void 0||i.metadata.vendor===$.vendor)&&($.family===void 0||i.metadata.family===$.family)&&($.version===void 0||i.metadata.version===$.version)&&($.identifier===void 0||i.metadata.id===$.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(o=>R.$nn.equals(o,$.extension)))&&f.push(g);return this.f.trace("[LM] selected language models",$,f),f}registerLanguageModelChat($,f){if(this.f.trace("[LM] registering language model chat",$,f.metadata),!this.c.has(f.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${f.metadata.vendor}.`);if(this.b.has($))throw new Error(`Chat response provider with identifier ${$} is already registered.`);return this.b.set($,f),this.d.fire({added:[{identifier:$,metadata:f.metadata}]}),(0,C.$Rc)(()=>{this.b.delete($)&&(this.d.fire({removed:[$]}),this.f.trace("[LM] UNregistered language model chat",$,f.metadata))})}async sendChatRequest($,f,g,i,o){const t=this.b.get($);if(!t)throw new Error(`Chat response provider with identifier ${$} is not registered.`);return t.sendChatRequest(g,f,i,o)}computeTokenLength($,f,g){const i=this.b.get($);if(!i)throw new Error(`Chat response provider with identifier ${$} is not registered.`);return i.provideTokenCount(f,g)}};e.$aH=w,e.$aH=w=Ye([Ve(0,I.$1G),Ve(1,c.$9j)],w)}),define(ke[271],Ie([1,0,8,17,24,160,35,4]),function(me,e,r,h,C,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FI=void 0,r=Ue(r),h=Ue(h),C=Ue(C);const b={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:r.localize(3862,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:r.localize(3863,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:r.localize(3864,null),default:""}}};var c;(function(u){function P(w,a,$){if(!w)return;const f=h.$cg(w.type)?w.type:void 0;if(!f||f.length===0){$.error(r.localize(3865,null));return}const g=[];if(Array.isArray(w.required))for(const i of w.required)h.$cg(i)&&g.push(i);return{extensionId:a.value,taskType:f,required:g,properties:w.properties?C.$ao(w.properties):{},when:w.when?L.$Aj.deserialize(w.when):void 0}}u.from=P})(c||(c={}));const I=T.$XG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,P)=>{for(const w of u)w.type&&P.push(`onTaskType:${w.type}`)},jsonSchema:{description:r.localize(3866,null),type:"array",items:b}});class D{constructor(){this.d=new R.$je,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((P,w)=>{I.setHandler((a,$)=>{this.c=void 0;try{for(const f of $.removed){const g=f.value;for(const i of g)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const f of $.added){const g=f.value;for(const i of g){const o=c.from(i,f.description.identifier,f.collector);o&&(this.a[o.taskType]=o)}}($.removed.length>0||$.added.length>0)&&this.d.fire()}catch{}P(void 0)})})}onReady(){return this.b}get(P){return this.a[P]}all(){return Object.keys(this.a).map(P=>this.a[P])}getJsonSchema(){if(this.c===void 0){const P=[];for(const w of this.all()){const a={type:"object",additionalProperties:!1};w.required.length>0&&(a.required=w.required.slice(0)),w.properties!==void 0?a.properties=C.$ao(w.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[w.taskType]},P.push(a)}this.c={oneOf:P}}return this.c}}e.$FI=new D}),define(ke[272],Ie([1,0,8,17,22,24,35,271,45]),function(me,e,r,h,C,T,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$PI=e.JsonSchemaVersion=e.ExecutionEngine=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$JI=e.ShellQuoting=e.$II=e.$HI=e.$GI=void 0,r=Ue(r),h=Ue(h),C=Ue(C),T=Ue(T),e.$GI="settings",e.$HI=new L.$Tj("taskRunning",!1,r.localize(3850,null)),e.$II=r.localize2(3852,"Tasks");var c;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(c||(e.ShellQuoting=c={})),e.$JI="$customized",function(M){function V(K){if(!K)return M.Strong;switch(K.toLowerCase()){case"escape":return M.Escape;case"strong":return M.Strong;case"weak":return M.Weak;default:return M.Strong}}M.from=V}(c||(e.ShellQuoting=c={}));var I;(function(M){M.defaults={cwd:"${workspaceFolder}"}})(I||(e.CommandOptions=I={}));var D;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(D||(e.RevealKind=D={})),function(M){function V(K){switch(K.toLowerCase()){case"always":return M.Always;case"silent":return M.Silent;case"never":return M.Never;default:return M.Always}}M.fromString=V}(D||(e.RevealKind=D={}));var u;(function(M){M[M.Never=1]="Never",M[M.OnProblem=2]="OnProblem",M[M.Always=3]="Always"})(u||(e.RevealProblemKind=u={})),function(M){function V(K){switch(K.toLowerCase()){case"always":return M.Always;case"never":return M.Never;case"onproblem":return M.OnProblem;default:return M.OnProblem}}M.fromString=V}(u||(e.RevealProblemKind=u={}));var P;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(P||(e.PanelKind=P={})),function(M){function V(K){switch(K.toLowerCase()){case"shared":return M.Shared;case"dedicated":return M.Dedicated;case"new":return M.New;default:return M.Shared}}M.fromString=V}(P||(e.PanelKind=P={}));var w;(function(M){M.defaults={echo:!0,reveal:D.Always,revealProblems:u.Never,focus:!1,panel:P.Shared,showReuseMessage:!0,clear:!1}})(w||(e.PresentationOptions=w={}));var a;(function(M){M[M.Shell=1]="Shell",M[M.Process=2]="Process",M[M.CustomExecution=3]="CustomExecution"})(a||(e.RuntimeType=a={})),function(M){function V(ne){switch(ne.toLowerCase()){case"shell":return M.Shell;case"process":return M.Process;case"customExecution":return M.CustomExecution;default:return M.Process}}M.fromString=V;function K(ne){switch(ne){case M.Shell:return"shell";case M.Process:return"process";case M.CustomExecution:return"customExecution";default:return"process"}}M.toString=K}(a||(e.RuntimeType=a={}));var $;(function(M){function V(K){return h.$cg(K)?K:K.value}M.value=V})($||(e.CommandString=$={}));var f;(function(M){M.Clean={_id:"clean",isDefault:!1},M.Build={_id:"build",isDefault:!1},M.Rebuild={_id:"rebuild",isDefault:!1},M.Test={_id:"test",isDefault:!1};function V(ne){return ne===M.Clean._id||ne===M.Build._id||ne===M.Rebuild._id||ne===M.Test._id}M.is=V;function K(ne){if(ne!==void 0)return h.$cg(ne)?V(ne)?{_id:ne,isDefault:!1}:void 0:ne}M.from=K})(f||(e.TaskGroup=f={}));var g;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.Folder=3]="Folder"})(g||(e.TaskScope=g={}));var i;(function(M){M.Workspace="workspace",M.Extension="extension",M.InMemory="inMemory",M.WorkspaceFile="workspaceFile",M.User="user";function V(K){switch(K){case M.User:return b.ConfigurationTarget.USER;case M.WorkspaceFile:return b.ConfigurationTarget.WORKSPACE;default:return b.ConfigurationTarget.WORKSPACE_FOLDER}}M.toConfigurationTarget=V})(i||(e.TaskSourceKind=i={}));var o;(function(M){M.parallel="parallel",M.sequence="sequence"})(o||(e.DependsOrder=o={}));var t;(function(M){M[M.default=1]="default",M[M.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var s;(function(M){M.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(s||(e.RunOptions=s={}));class n{constructor(V,K,ne,B,G,Y){this._label="",this._id=V,K&&(this._label=K),ne&&(this.type=ne),this.runOptions=B,this.configurationProperties=G,this._source=Y}getDefinition(V){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const V={folder:this.d(),id:this._id};return JSON.stringify(V)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(V,K=!1){if(V===void 0)return!1;if(h.$cg(V))return V===this._label||V===this.configurationProperties.identifier||K&&V===this._id;const ne=this.getDefinition(!0);return ne!==void 0&&ne._key===V._key}getQualifiedLabel(){const V=this.getWorkspaceFolder();return V?`${this._label} (${V.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(V){this.c===void 0&&(this.c=[]),V&&(this.c=this.c.concat(V))}get taskLoadMessages(){return this.c}}e.$KI=n;class d extends n{constructor(V,K,ne,B,G,Y,ee,ue){super(V,ne,void 0,ee,ue,K),this.command={},this._source=K,this.hasDefinedMatchers=Y,G&&(this.command=G)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(V=!1){if(V&&this._source.customizes!==void 0)return this._source.customizes;{let K;switch(this.command?this.command.runtime:void 0){case a.Shell:K="shell";break;case a.Process:K="process";break;case a.CustomExecution:K="customExecution";break;case void 0:K="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:K,_key:this._id,id:this._id}}}static is(V){return V instanceof d}getMapKey(){const V=this._source.config.workspaceFolder;return V?`${V.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$GI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const V=this.d();if(!V)return;let K=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(K+=this._source.kind);const ne={type:e.$JI,folder:V,id:K};return JSON.stringify(ne)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$ah(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(V){return new d(V._id,V._source,V._label,V.type,V.command,V.hasDefinedMatchers,V.runOptions,V.configurationProperties)}}e.$LI=d;class l extends n{constructor(V,K,ne,B,G,Y,ee){super(V,ne,B,Y,ee,K),this._source=K,this.configures=G}static is(V){return V instanceof l}f(V){return V}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$ah(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$GI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const V=this.d();if(!V)return;let K=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(K+=this._source.kind);const ne={type:e.$JI,folder:V,id:K};return JSON.stringify(ne)}}e.$MI=l;class m extends n{constructor(V,K,ne,B,G,Y,ee,ue,re){super(V,ne,B,ue,re,K),this.defines=G,this.hasDefinedMatchers=ee,this.command=Y,this.icon=re.icon,this.hide=re.hide}clone(){return new m(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(V){return V instanceof m}getMapKey(){const V=this._source.workspaceFolder;return V?`${this._source.scope.toString()}|${V.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===g.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const V={type:"contributed",scope:this._source.scope,id:this._id};return V.folder=this.d(),JSON.stringify(V)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(V){return new m(V._id,V._source,V._label,V.type,V.defines,V.command,V.hasDefinedMatchers,V.runOptions,V.configurationProperties)}}e.$NI=m;class E extends n{constructor(V,K,ne,B,G,Y){super(V,ne,B,G,Y,K),this._source=K}clone(){return new E(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(V){return V instanceof E}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(V){return new E(V._id,V._source,V._label,V.type,V.runOptions,V.configurationProperties)}}e.$OI=E;var S;(function(M){M[M.Process=1]="Process",M[M.Terminal=2]="Terminal"})(S||(e.ExecutionEngine=S={})),function(M){M._default=M.Terminal}(S||(e.ExecutionEngine=S={}));var y;(function(M){M[M.V0_1_0=1]="V0_1_0",M[M.V2_0_0=2]="V2_0_0"})(y||(e.JsonSchemaVersion=y={}));class k{constructor(V){this.c=new Map;for(let K=0;K<V.length;K++)this.c.set(V[K].uri.toString(),K)}compare(V,K){const ne=V.getWorkspaceFolder(),B=K.getWorkspaceFolder();if(ne&&B){let G=this.c.get(ne.uri.toString());G=G===void 0?0:G+1;let Y=this.c.get(B.uri.toString());return Y=Y===void 0?0:Y+1,G===Y?V._label.localeCompare(K._label):G-Y}else return!ne&&B?-1:ne&&!B?1:0}}e.$PI=k;var A;(function(M){M.DependsOnStarted="dependsOnStarted",M.AcquiredInput="acquiredInput",M.Start="start",M.ProcessStarted="processStarted",M.Active="active",M.Inactive="inactive",M.Changed="changed",M.Terminated="terminated",M.ProcessEnded="processEnded",M.End="end"})(A||(e.TaskEventKind=A={}));var p;(function(M){M.SingleRun="singleRun",M.Background="background"})(p||(e.TaskRunType=p={}));var v;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.FolderOpen=2]="FolderOpen",M[M.ConfigurationChange=3]="ConfigurationChange",M[M.Reconnect=4]="Reconnect"})(v||(e.TaskRunSource=v={}));var F;(function(M){function V(ue){return{taskId:ue._id,taskName:ue.configurationProperties.name,runType:ue.configurationProperties.isBackground?p.Background:p.SingleRun,group:ue.configurationProperties.group,__task:ue}}function K(ue,re,ye){return{...V(ue),kind:A.Start,terminalId:re,resolvedVariables:ye}}M.start=K;function ne(ue,re,ye){return{...V(ue),kind:A.ProcessStarted,terminalId:re,processId:ye}}M.processStarted=ne;function B(ue,re,ye){return{...V(ue),kind:A.ProcessEnded,terminalId:re,exitCode:ye}}M.processEnded=B;function G(ue,re,ye){return{...V(ue),kind:A.Terminated,exitReason:ye,terminalId:re}}M.terminated=G;function Y(ue,re,ye){return{...V(re),kind:ue,terminalId:ye}}M.general=Y;function ee(){return{kind:A.Changed}}M.changed=ee})(F||(e.TaskEvent=F={}));var N;(function(M){function V(ne){const B=Object.keys(ne).sort();let G="";for(const Y of B){let ee=ne[Y];ee instanceof Object?ee=V(ee):typeof ee=="string"&&(ee=ee.replace(/,/g,",,")),G+=Y+","+ee+","}return G}function K(ne){const G={_key:V(ne),type:ne.taskType};return Object.assign(G,ne),G}M.create=K})(N||(e.KeyedTaskIdentifier=N={}));var O;(function(M){M.AutoDetect="task.autoDetect",M.SaveBeforeRun="task.saveBeforeRun",M.ShowDecorations="task.showDecorations",M.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",M.SlowProviderWarning="task.slowProviderWarning",M.QuickOpenHistory="task.quickOpen.history",M.QuickOpenDetail="task.quickOpen.detail",M.QuickOpenSkip="task.quickOpen.skip",M.QuickOpenShowAll="task.quickOpen.showAll",M.AllowAutomaticTasks="task.allowAutomaticTasks",M.Reconnection="task.reconnection",M.VerboseLogging="task.verboseLogging"})(O||(e.TaskSettingId=O={}));var j;(function(M){M.Tasks="tasks",M.SuppressTaskName="tasks.suppressTaskName",M.Windows="tasks.windows",M.Osx="tasks.osx",M.Linux="tasks.linux",M.ShowOutput="tasks.showOutput",M.IsShellCommand="tasks.isShellCommand",M.ServiceTestSetting="tasks.service.testSetting"})(j||(e.TasksSchemaProperties=j={}));var z;(function(M){function V(K,ne){const B=R.$FI.get(K.type);if(B===void 0){const ue=T.$ao(K);return delete ue._key,N.create(ue)}const G=Object.create(null);G.type=B.taskType;const Y=new Set;B.required.forEach(ue=>Y.add(ue));const ee=B.properties;for(const ue of Object.keys(ee)){const re=K[ue];if(re!=null)G[ue]=re;else if(Y.has(ue)){const ye=ee[ue];if(ye.default!==void 0)G[ue]=T.$ao(ye.default);else switch(ye.type){case"boolean":G[ue]=!1;break;case"number":case"integer":G[ue]=0;break;case"string":G[ue]="";break;default:ne.error(r.localize(3851,null,JSON.stringify(K,void 0,0),ue));return}}}return N.create(G)}M.createTaskIdentifier=V})(z||(e.TaskDefinition=z={}))}),define(ke[273],Ie([1,0,13]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tcc=e.$Scc=void 0;class h{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((L,R)=>{this.b=L,this.d=R,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(L){this.f||this.h||(this.f=!0,this.g=L,this.a&&this.b(L))}resolveErr(L){this.f||this.h||(this.h=!0,this.i=L,this.a?this.d(L):(0,r.$Y)(L))}then(L,R){return this.j().then(L,R)}catch(L){return this.j().then(void 0,L)}finally(L){return this.j().finally(L)}}e.$Scc=h;class C extends h{constructor(){super(),this.h=!0,this.i=new r.$4}}e.$Tcc=C}),define(ke[53],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sw=e.$Pw=void 0,e.$Qw=C,e.$Rw=T;class r{static{this.count=0}constructor(b){this._proxyIdentifierBrand=void 0,this.sid=b,this.nid=++r.count}}e.$Pw=r;const h=[];function C(R){const b=new r(R);return h[b.nid]=b,b}function T(R){return h[R].sid}class L{constructor(b){this.value=b}}e.$Sw=L}),define(ke[6],Ie([1,0,53]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tN=e.$sN=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$rN=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var h;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(h||(e.TextEditorRevealType=h={}));var C;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput",a[a.ChatEditorInput=10]="ChatEditorInput",a[a.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(C||(e.TabInputKind=C={}));var T;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(T||(e.TabModelOperationKind=T={}));var L;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(L||(e.WebviewEditorCapabilities=L={}));var R;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(R||(e.WebviewMessageArrayBufferViewType=R={}));var b;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(b||(e.CellOutputKind=b={}));var c;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(c||(e.NotebookEditorRevealType=c={}));var I;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output",a[a.Hybrid=3]="Hybrid"})(I||(e.CandidatePortSource=I={}));class D{static{this.a=0}static mixin($){return $._id=D.a++,$}}e.$rN=D;var u;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.kindModifier="m",a.commandIdent="n",a.commandId="o",a.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var P;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(P||(e.ISuggestResultDtoField=P={}));var w;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(w||(e.ExtHostTestingResource=w={})),e.$sN={MainThreadAuthentication:(0,r.$Qw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,r.$Qw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,r.$Qw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,r.$Qw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,r.$Qw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,r.$Qw)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,r.$Qw)("MainThreadChatSkills"),MainThreadClipboard:(0,r.$Qw)("MainThreadClipboard"),MainThreadCommands:(0,r.$Qw)("MainThreadCommands"),MainThreadComments:(0,r.$Qw)("MainThreadComments"),MainThreadConfiguration:(0,r.$Qw)("MainThreadConfiguration"),MainThreadConsole:(0,r.$Qw)("MainThreadConsole"),MainThreadDebugService:(0,r.$Qw)("MainThreadDebugService"),MainThreadDecorations:(0,r.$Qw)("MainThreadDecorations"),MainThreadDiagnostics:(0,r.$Qw)("MainThreadDiagnostics"),MainThreadDialogs:(0,r.$Qw)("MainThreadDiaglogs"),MainThreadDocuments:(0,r.$Qw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,r.$Qw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,r.$Qw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,r.$Qw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,r.$Qw)("MainThreadEditorTabs"),MainThreadErrors:(0,r.$Qw)("MainThreadErrors"),MainThreadTreeViews:(0,r.$Qw)("MainThreadTreeViews"),MainThreadDownloadService:(0,r.$Qw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,r.$Qw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,r.$Qw)("MainThreadLanguages"),MainThreadLogger:(0,r.$Qw)("MainThreadLogger"),MainThreadMessageService:(0,r.$Qw)("MainThreadMessageService"),MainThreadOutputService:(0,r.$Qw)("MainThreadOutputService"),MainThreadProgress:(0,r.$Qw)("MainThreadProgress"),MainThreadQuickDiff:(0,r.$Qw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,r.$Qw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,r.$Qw)("MainThreadStatusBar"),MainThreadSecretState:(0,r.$Qw)("MainThreadSecretState"),MainThreadStorage:(0,r.$Qw)("MainThreadStorage"),MainThreadSpeech:(0,r.$Qw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,r.$Qw)("MainThreadTelemetry"),MainThreadTerminalService:(0,r.$Qw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,r.$Qw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,r.$Qw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,r.$Qw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,r.$Qw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,r.$Qw)("MainThreadCustomEditors"),MainThreadUrls:(0,r.$Qw)("MainThreadUrls"),MainThreadUriOpeners:(0,r.$Qw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,r.$Qw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,r.$Qw)("MainThreadWorkspace"),MainThreadFileSystem:(0,r.$Qw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,r.$Qw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,r.$Qw)("MainThreadExtensionService"),MainThreadSCM:(0,r.$Qw)("MainThreadSCM"),MainThreadSearch:(0,r.$Qw)("MainThreadSearch"),MainThreadShare:(0,r.$Qw)("MainThreadShare"),MainThreadTask:(0,r.$Qw)("MainThreadTask"),MainThreadWindow:(0,r.$Qw)("MainThreadWindow"),MainThreadLabelService:(0,r.$Qw)("MainThreadLabelService"),MainThreadNotebook:(0,r.$Qw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,r.$Qw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,r.$Qw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,r.$Qw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,r.$Qw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,r.$Qw)("MainThreadInteractive"),MainThreadTheming:(0,r.$Qw)("MainThreadTheming"),MainThreadTunnelService:(0,r.$Qw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,r.$Qw)("MainThreadManagedSockets"),MainThreadTimeline:(0,r.$Qw)("MainThreadTimeline"),MainThreadTesting:(0,r.$Qw)("MainThreadTesting"),MainThreadLocalization:(0,r.$Qw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,r.$Qw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,r.$Qw)("MainThreadAiEmbeddingVector")},e.$tN={ExtHostCommands:(0,r.$Qw)("ExtHostCommands"),ExtHostConfiguration:(0,r.$Qw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,r.$Qw)("ExtHostDiagnostics"),ExtHostDebugService:(0,r.$Qw)("ExtHostDebugService"),ExtHostDecorations:(0,r.$Qw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,r.$Qw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,r.$Qw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,r.$Qw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,r.$Qw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,r.$Qw)("ExtHostEditors"),ExtHostTreeViews:(0,r.$Qw)("ExtHostTreeViews"),ExtHostFileSystem:(0,r.$Qw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,r.$Qw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,r.$Qw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,r.$Qw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,r.$Qw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,r.$Qw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,r.$Qw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,r.$Qw)("ExtHostStatusBar"),ExtHostShare:(0,r.$Qw)("ExtHostShare"),ExtHostExtensionService:(0,r.$Qw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,r.$Qw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,r.$Qw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,r.$Qw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,r.$Qw)("ExtHostSCM"),ExtHostSearch:(0,r.$Qw)("ExtHostSearch"),ExtHostTask:(0,r.$Qw)("ExtHostTask"),ExtHostWorkspace:(0,r.$Qw)("ExtHostWorkspace"),ExtHostWindow:(0,r.$Qw)("ExtHostWindow"),ExtHostWebviews:(0,r.$Qw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,r.$Qw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,r.$Qw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,r.$Qw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,r.$Qw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,r.$Qw)("ExtHostEditorTabs"),ExtHostProgress:(0,r.$Qw)("ExtHostProgress"),ExtHostComments:(0,r.$Qw)("ExtHostComments"),ExtHostSecretState:(0,r.$Qw)("ExtHostSecretState"),ExtHostStorage:(0,r.$Qw)("ExtHostStorage"),ExtHostUrls:(0,r.$Qw)("ExtHostUrls"),ExtHostUriOpeners:(0,r.$Qw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,r.$Qw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,r.$Qw)("ExtHostOutputService"),ExtHostLabelService:(0,r.$Qw)("ExtHostLabelService"),ExtHostNotebook:(0,r.$Qw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,r.$Qw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,r.$Qw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,r.$Qw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,r.$Qw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,r.$Qw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,r.$Qw)("ExtHostInteractive"),ExtHostChatAgents2:(0,r.$Qw)("ExtHostChatAgents"),ExtHostChatVariables:(0,r.$Qw)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,r.$Qw)("ExtHostChatSkills"),ExtHostChatProvider:(0,r.$Qw)("ExtHostChatProvider"),ExtHostSpeech:(0,r.$Qw)("ExtHostSpeech"),ExtHostEmbeddings:(0,r.$Qw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,r.$Qw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,r.$Qw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,r.$Qw)("ExtHostTheming"),ExtHostTunnelService:(0,r.$Qw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,r.$Qw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,r.$Qw)("ExtHostAuthentication"),ExtHostTimeline:(0,r.$Qw)("ExtHostTimeline"),ExtHostTesting:(0,r.$Qw)("ExtHostTesting"),ExtHostTelemetry:(0,r.$Qw)("ExtHostTelemetry"),ExtHostLocalization:(0,r.$Qw)("ExtHostLocalization")}}),define(ke[95],Ie([1,0,5,11,6,19]),function(me,e,r,h,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$poc=e.$ooc=e.$noc=void 0,C=Ue(C),e.$noc=(0,r.$Ci)("IExtHostApiDeprecationService");let L=class{constructor(b,c){this.c=c,this.a=new Set,this.b=b.getProxy(C.$sN.MainThreadTelemetry)}report(b,c,I){const D=this.d(b,c);this.a.has(D)||(this.a.add(D),c.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${b}' is deprecated. ${I}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:c.identifier.value,apiId:b}))}d(b,c){return`${b}-${c.identifier.value}`}};e.$ooc=L,e.$ooc=L=Ye([Ve(0,T.$1P),Ve(1,h.$9j)],L),e.$poc=Object.freeze(new class{report(R,b,c){}})}),define(ke[274],Ie([1,0,6]),function(me,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Coc=void 0;class h{constructor(T){const L=T.getProxy(r.$sN.MainThreadClipboard);this.value=Object.freeze({readText(){return L.$readText()},writeText(R){return L.$writeText(R)}})}}e.$Coc=h}),define(ke[275],Ie([1,0,24,6,29,19]),function(me,e,r,h,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yqc=void 0;let L=class{constructor(I,D){this.a=I.getProxy(h.$sN.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(I,D){const u=this,P=console[I];Object.defineProperty(console,I,{set:()=>{},get:()=>function(){u.e(I,D,P,arguments)}})}e(I,D,u,P){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:b(P,this.b)}),this.c&&this.f(I,u,P)}};e.$yqc=L,e.$yqc=L=Ye([Ve(0,T.$1P),Ve(1,C.$eQ)],L);const R=1e5;function b(c,I){const D=[];if(c.length)for(let u=0;u<c.length;u++){let P=c[u];if(typeof P>"u")P="undefined";else if(P instanceof Error){const w=P;w.stack?P=w.stack:P=w.toString()}D.push(P)}if(I){const u=new Error().stack;u&&D.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,r.$fo)(D);return u.length>R?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(ke[276],Ie([1,0,2,6,25]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Epc=void 0;class T{constructor(R){this.a=R.getProxy(h.$sN.MainThreadDialogs)}showOpenDialog(R,b){return b?.allowUIResources&&(0,C.$5G)(R,"showLocal"),this.a.$showOpenDialog(b).then(c=>c?c.map(I=>r.URI.revive(I)):void 0)}showSaveDialog(R){return this.a.$showSaveDialog(R).then(b=>b?r.URI.revive(b):void 0)}}e.$Epc=T}),define(ke[277],Ie([1,0,20,4,3,6]),function(me,e,r,h,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hpc=void 0;class L{constructor(b){this.b=new Map,this.c=new h.$je,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=b.getProxy(T.$sN.MainThreadEmbeddings)}registerEmbeddingsProvider(b,c,I){if(this.d.has(c))throw new Error("An embeddings provider for this model is already registered");const D=this.e++;return this.a.$registerEmbeddingProvider(D,c),this.b.set(D,{id:c,provider:I}),(0,C.$Rc)(()=>{this.a.$unregisterEmbeddingProvider(D),this.b.delete(D)})}async computeEmbeddings(b,c,I){I??=r.CancellationToken.None;let D=!1;typeof c=="string"&&(c=[c],D=!0);const u=await this.a.$computeEmbeddings(b,c,I);if(u.length!==c.length)throw new Error;if(D){if(u.length!==1)throw new Error;return u[0]}return u}async $provideEmbeddings(b,c,I){const D=this.b.get(b);if(!D)return[];const u=await D.provider.provideEmbeddings(c,I);return u||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(b){this.d=new Set(b),this.c.fire()}}e.$Hpc=L}),define(ke[278],Ie([1,0,3,6]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ypc=void 0;class C{constructor(L){this.b=0,this.a=L.getProxy(h.$sN.MainThreadLabelService)}$registerResourceLabelFormatter(L){const R=this.b++;return this.a.$registerResourceLabelFormatter(R,L),(0,r.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(R)})}}e.$Ypc=C}),define(ke[122],Ie([1,0,10,12,2,5,11,6,29,19]),function(me,e,r,h,C,T,L,R,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ipc=e.$hpc=void 0;let I=class{constructor(u,P,w){this.f=w,this.d=new Map,this.a=P.getProxy(R.$sN.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===r.$h}getMessage(u,P){const{message:w,args:a,comment:$}=P;if(this.c)return(0,h.$cf)(w,a??{});let f=w;$&&$.length>0&&(f+=`/${Array.isArray($)?$.join(""):$}`);const g=this.d.get(u)?.contents[f];return g||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${f}`),(0,h.$cf)(g??w,a??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let P;const w=await this.g(u);if(!w){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const a=await this.a.$fetchBundleContents(w),$=JSON.parse(a);P=u.isBuiltin?$.contents?.bundle:$}catch(a){this.f.error(`Failed to load translations for ${u.identifier.value} from ${w}: ${a.message}`);return}P&&this.d.set(u.identifier.value,{contents:P,uri:w})}async g(u){if(u.isBuiltin){const P=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return C.URI.revive(P)}return u.l10n?C.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$hpc=I,e.$hpc=I=Ye([Ve(0,b.$eQ),Ve(1,c.$1P),Ve(2,L.$9j)],I),e.$ipc=(0,T.$Ci)("IExtHostLocalizationService")}),define(ke[161],Ie([1,0,11,6,29,19,2,51]),function(me,e,r,h,C,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xqc=void 0;let b=class extends r.$hk{constructor(D,u){super(u.logLevel,u.logsLocation,u.loggers.map(P=>(0,R.$_h)(P))),this.r=D.getProxy(h.$sN.MainThreadLogger)}$setLogLevel(D,u){u?this.setLogLevel(L.URI.revive(u),D):this.setLogLevel(D)}setVisibility(D,u){super.setVisibility(D,u),this.r.$setVisibility(D,u)}s(D,u,P){return new c(this.r,D,u,P)}};e.$xqc=b,e.$xqc=b=Ye([Ve(0,T.$1P),Ve(1,C.$eQ)],b);class c extends r.$ck{constructor(D,u,P,w){super(w?.logLevel==="always"),this.r=D,this.s=u,this.m=!1,this.n=[],this.setLevel(P),this.r.$createLogger(u,w).then(()=>{this.u(this.n),this.m=!0})}g(D,u){const P=[[D,u]];this.m?this.u(P):this.n.push(...P)}u(D){this.r.$log(this.s,D)}flush(){this.r.$flush(this.s)}}}),define(ke[123],Ie([1,0,6,5,3,19,21]),function(me,e,r,h,C,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kpc=e.$jpc=void 0,e.$jpc=(0,h.$Ci)("IExtHostManagedSockets");let R=class{constructor(D){this.b=0,this.c=null,this.d=new Map,this.a=D.getProxy(r.$sN.MainThreadManagedSockets)}setFactory(D,u){for(const P of this.d.values())P.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new b(D,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(D){if(!this.c||this.c.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const u=++this.b,P=await this.c.makeConnection(),w=new C.$Sc;return this.d.set(u,new c(u,P,w)),w.add((0,C.$Rc)(()=>this.d.delete(u))),w.add(P.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),w.dispose()})),w.add(P.onDidClose(a=>{this.a.$onDidManagedSocketClose(u,a?.stack??a?.message),w.dispose()})),w.add(P.onDidReceiveMessage(a=>this.a.$onDidManagedSocketHaveData(u,L.$Le.wrap(a)))),u}$remoteSocketWrite(D,u){this.d.get(D)?.actual.send(u.buffer)}$remoteSocketEnd(D){const u=this.d.get(D);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(D){await this.d.get(D)?.actual.drain?.()}};e.$kpc=R,e.$kpc=R=Ye([Ve(0,T.$1P)],R);class b{constructor(D,u){this.socketFactoryId=D,this.makeConnection=u}}class c extends C.$Tc{constructor(D,u,P){super(),this.socketId=D,this.actual=u,this.B(P)}}}),define(ke[279],Ie([1,0,6,11,25]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2pc=void 0;function T(R){return R&&R.title}let L=class{constructor(b,c){this.b=c,this.a=b.getProxy(r.$sN.MainThreadMessageService)}showMessage(b,c,I,D,u){const P={source:{identifier:b.identifier,label:b.displayName||b.name}};let w;typeof D=="string"||T(D)?w=[D,...u]:(P.modal=D?.modal,P.useCustom=D?.useCustom,P.detail=D?.detail,w=u),P.useCustom&&(0,C.$5G)(b,"resolvers");const a=[];let $=!1;for(let f=0;f<w.length;f++){const g=w[f];if(typeof g=="string")a.push({title:g,handle:f,isCloseAffordance:!1});else if(typeof g=="object"){const{title:i,isCloseAffordance:o}=g;a.push({title:i,isCloseAffordance:!!o,handle:f}),o&&($?this.b.warn(`[${b.identifier}] Only one message item can have 'isCloseAffordance':`,g):$=!0)}else this.b.warn(`[${b.identifier}] Invalid message item:`,g)}return this.a.$showMessage(c,I,P,a).then(f=>{if(typeof f=="number")return w[f]})}};e.$2pc=L,e.$2pc=L=Ye([Ve(1,h.$9j)],L)}),define(ke[280],Ie([1,0,3,17,2,25,6]),function(me,e,r,h,C,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$pc=void 0;class R{constructor(c){this.b=new Map,this.a=c.getProxy(L.$sN.MainThreadProfileContentHandlers)}registerProfileContentHandler(c,I,D){if((0,T.$5G)(c,"profileContentHandlers"),this.b.has(I))throw new Error(`Handler with id '${I}' already registered`);return this.b.set(I,D),this.a.$registerProfileContentHandler(I,D.name,D.description,c.identifier.value),(0,r.$Rc)(()=>{this.b.delete(I),this.a.$unregisterProfileContentHandler(I)})}async $saveProfile(c,I,D,u){const P=this.b.get(c);if(!P)throw new Error(`Unknown handler with id: ${c}`);return P.saveProfile(I,D,u)}async $readProfile(c,I,D){const u=this.b.get(c);if(!u)throw new Error(`Unknown handler with id: ${c}`);return u.readProfile((0,h.$cg)(I)?I:C.URI.revive(I),D)}}e.$$pc=R}),define(ke[124],Ie([1,0,6,4,5]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fpc=e.$epc=void 0;class T{constructor(R){this.b=new h.$je,this.onDidChangePassword=this.b.event,this.a=R.getProxy(r.$sN.MainThreadSecretState)}async $onDidChangePassword(R){this.b.fire(R)}get(R,b){return this.a.$getPassword(R,b)}store(R,b,c){return this.a.$setPassword(R,b,c)}delete(R,b){return this.a.$deletePassword(R,b)}}e.$epc=T,e.$fpc=(0,C.$Ci)("IExtHostSecretState")}),define(ke[281],Ie([1,0,20,3,6]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fqc=void 0;class T{static{this.a=1}constructor(R){this.c=new Map,this.d=new Map,this.f=new Map,this.b=R.getProxy(C.$sN.MainThreadSpeech)}async $createSpeechToTextSession(R,b,c){const I=this.c.get(R);if(!I)return;const D=new h.$Sc,u=new r.$ue;this.d.set(b,u);const P=await I.provideSpeechToTextSession(u.token,c?{language:c}:void 0);P&&(D.add(P.onDidChange(w=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(b,w)})),D.add(u.token.onCancellationRequested(()=>D.dispose())))}async $cancelSpeechToTextSession(R){this.d.get(R)?.dispose(!0),this.d.delete(R)}async $createTextToSpeechSession(R,b,c){const I=this.c.get(R);if(!I)return;const D=new h.$Sc,u=new r.$ue;this.d.set(b,u);const P=await I.provideTextToSpeechSession(u.token,c?{language:c}:void 0);P&&(this.f.set(b,P),D.add(P.onDidChange(w=>{u.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(b,w)})),D.add(u.token.onCancellationRequested(()=>D.dispose())))}async $synthesizeSpeech(R,b){this.f.get(R)?.synthesize(b)}async $cancelTextToSpeechSession(R){this.d.get(R)?.dispose(!0),this.d.delete(R),this.f.delete(R)}async $createKeywordRecognitionSession(R,b){const c=this.c.get(R);if(!c)return;const I=new h.$Sc,D=new r.$ue;this.d.set(b,D);const u=await c.provideKeywordRecognitionSession(D.token);u&&(I.add(u.onDidChange(P=>{D.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(b,P)})),I.add(D.token.onCancellationRequested(()=>I.dispose())))}async $cancelKeywordRecognitionSession(R){this.d.get(R)?.dispose(!0),this.d.delete(R)}registerProvider(R,b,c){const I=T.a++;return this.c.set(I,c),this.b.$registerProvider(I,b,{extension:R,displayName:R.value}),(0,h.$Rc)(()=>{this.b.$unregisterProvider(I),this.c.delete(I)})}}e.$fqc=T}),define(ke[125],Ie([1,0,6,4,5]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8oc=e.$7oc=void 0;class T{constructor(R,b){this.c=b,this.b=new h.$je,this.onDidChangeStorage=this.b.event,this.a=R.getProxy(r.$sN.MainThreadStorage)}registerExtensionStorageKeysToSync(R,b){this.a.$registerExtensionStorageKeysToSync(R,b)}async initializeExtensionStorage(R,b,c){const I=await this.a.$initializeExtensionStorage(R,b);let D;return I&&(D=this.d(R,b,I)),D||c}setValue(R,b,c){return this.a.$setValue(R,b,c)}$acceptValue(R,b,c){const I=this.d(R,b,c);I&&this.b.fire({shared:R,key:b,value:I})}d(R,b,c){try{return JSON.parse(c)}catch(I){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${b}, global: ${R}): ${I}`)}}}e.$7oc=T,e.$8oc=(0,C.$Ci)("IExtHostStorage")}),define(ke[282],Ie([1,0,3,14,2,6]),function(me,e,r,h,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rqc=void 0;class L{static{this.a=new Set([h.Schemas.http,h.Schemas.https])}constructor(b){this.c=new Map,this.b=b.getProxy(T.$sN.MainThreadUriOpeners)}registerExternalUriOpener(b,c,I,D){if(this.c.has(c))throw new Error(`Opener with id '${c}' already registered`);const u=D.schemes.find(P=>!L.a.has(P));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(c,I),this.b.$registerUriOpener(c,D.schemes,b,D.label),(0,r.$Rc)(()=>{this.c.delete(c),this.b.$unregisterUriOpener(c)})}async $canOpenUri(b,c,I){const D=this.c.get(b);if(!D)throw new Error(`Unknown opener with id: ${b}`);const u=C.URI.revive(c);return D.canOpenExternalUri(u,I)}async $openUri(b,c,I){const D=this.c.get(b);if(!D)throw new Error(`Unknown opener id: '${b}'`);return D.openExternalUri(C.URI.revive(c.resolvedUri),{sourceUri:C.URI.revive(c.sourceUri)},I)}}e.$rqc=L}),define(ke[283],Ie([1,0,6,2,3,13,23]),function(me,e,r,h,C,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sqc=void 0;class R{static{this.a=0}constructor(c){this.c=new L.$on,this.d=new Map,this.b=c.getProxy(r.$sN.MainThreadUrls)}registerUriHandler(c,I){const D=c.identifier;if(this.c.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const u=R.a++;return this.c.add(D),this.d.set(u,I),this.b.$registerUriHandler(u,D,c.displayName||c.name),(0,C.$Rc)(()=>{this.c.delete(D),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(c,I){const D=this.d.get(c);if(!D)return Promise.resolve(void 0);try{D.handleUri(h.URI.revive(I))}catch(u){(0,T.$Y)(u)}return Promise.resolve(void 0)}async createAppUri(c){return h.URI.revive(await this.b.$createAppUri(c))}}e.$sqc=R}),define(ke[284],Ie([1,0,21,6]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$utb=T,e.$vtb=R,h=Ue(h);class C{constructor(){this.buffers=[]}add(c){let I=this.buffers.indexOf(c);return I<0&&(I=this.buffers.length,this.buffers.push(c)),I}}function T(b,c){if(c.serializeBuffersForPostMessage){const I=new C,u=JSON.stringify(b,(w,a)=>{if(a instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:I.add(a)};if(ArrayBuffer.isView(a)){const $=L(a);if($)return{$$vscode_array_buffer_reference$$:!0,index:I.add(a.buffer),view:{type:$,byteLength:a.byteLength,byteOffset:a.byteOffset}}}return a}),P=I.buffers.map(w=>{const a=new Uint8Array(w);return r.$Le.wrap(a)});return{message:u,buffers:P}}else return{message:JSON.stringify(b),buffers:[]}}function L(b){switch(b.constructor.name){case"Int8Array":return h.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return h.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return h.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return h.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return h.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return h.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return h.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return h.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return h.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return h.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return h.WebviewMessageArrayBufferViewType.BigUint64Array}}function R(b,c){const I=c.map(P=>{const w=new ArrayBuffer(P.byteLength);return new Uint8Array(w).set(P.buffer),w}),D=c.length?(P,w)=>{if(w&&typeof w=="object"&&w.$$vscode_array_buffer_reference$$){const a=w,{index:$}=a,f=I[$];if(a.view)switch(a.view.type){case h.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(f,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(f,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(f,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(f,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(f,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(f,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(f,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(f,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(f,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(f,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(f,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return f}return w}:void 0;return{message:JSON.parse(b,D),arrayBuffers:I}}}),define(ke[96],Ie([1,0,4,3,14,24,2,234,284,121,6]),function(me,e,r,h,C,T,L,R,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Toc=e.$Roc=void 0,e.$Soc=u,e.$Uoc=a,e.$Voc=$,T=Ue(T),I=Ue(I);class D{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;constructor(o,t,s,n,d,l,m){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new r.$je,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new r.$je,this._onDidDispose=this.#h.event,this.#e=o,this.#t=t,this.#o=s,this.#n=n,this.#s=d,this.#r=l,this.#u=u(l),this.#d=P(l),this.#i=m}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return this.#l=!0,(0,c.$eDb)(o,this.#n)}get cspSource(){const o=this.#r.extensionLocation;if(o.scheme===C.Schemas.https||o.scheme===C.Schemas.http){let t=o.toString();return t.endsWith("/")||(t+="/"),t+" "+c.$dDb}return c.$dDb}get html(){return this.a(),this.#a}set html(o){this.a(),this.#a!==o&&(this.#a=o,this.#d&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(o)))}get options(){return this.a(),this.#o}set options(o){this.a(),T.$eo(this.#o,o)||this.#t.$setOptions(this.#e,$(this.#r,this.#s,o)),this.#o=o}async postMessage(o){if(this.#c)return!1;const t=(0,b.$utb)(o,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(o){if(!this.#d)return o;const t=this.#r.extensionLocation?.scheme===C.Schemas.vscodeRemote,s=this.#r.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return o.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,d,l,m,E,S)=>{const y=L.URI.from({scheme:m||"file",path:decodeURIComponent(E)}),k=(0,c.$eDb)(y,{isRemote:t,authority:s}).toString();return`${d}${k}${S}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,d,l,m,E,S)=>{const y=L.URI.from({scheme:m||"file",path:decodeURIComponent(E)}),k=(0,c.$eDb)(y,{isRemote:t,authority:s}).toString();return`${d}${k}${S}`})}}e.$Roc=D;function u(i){try{const o=(0,R.$Xp)((0,R.$Wp)(i.engines.vscode));return!!o&&o.majorBase>=1&&o.minorBase>=57}catch{return!1}}function P(i){try{const o=(0,R.$Xp)((0,R.$Wp)(i.engines.vscode));return o?o.majorBase<1||o.majorBase===1&&o.minorBase<60:!1}catch{return!1}}class w extends h.$Tc{constructor(o,t,s,n,d){super(),this.c=t,this.f=s,this.g=n,this.h=d,this.b=new Map,this.a=o.getProxy(I.$sN.MainThreadWebviews)}dispose(){super.dispose();for(const o of this.b.values())o.dispose();this.b.clear()}$onMessage(o,t,s){const n=this.j(o);if(n){const{message:d}=(0,b.$vtb)(t,s.value);n._onMessageEmitter.fire(d)}}$onMissingCsp(o,t){this.g.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,t,s){const n=new D(o,this.a,f(t),this.c,this.f,s,this.h);this.b.set(o,n);const d=n._onDidDispose(()=>{d.dispose(),this.deleteWebview(o)});return n}deleteWebview(o){this.b.delete(o)}j(o){return this.b.get(o)}}e.$Toc=w;function a(i){return{id:i.identifier,location:i.extensionLocation}}function $(i,o,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||g(i,o)}}function f(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(o=>L.URI.from(o))}}function g(i,o){return[...(o?.getWorkspaceFolders()||[]).map(t=>t.uri),i.extensionLocation]}}),define(ke[162],Ie([1,0,4,14,12,2,5,19,6]),function(me,e,r,h,C,T,L,R,b){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$vqc=e.$uqc=void 0;let I=class{static{c=this}static{this.a={focused:!0,active:!0}}getState(){const u=this.d;return{get focused(){return u.focused},get active(){return u.active}}}constructor(u){this.c=new r.$je,this.onDidChangeWindowState=this.c.event,this.d=c.a,this.b=u.getProxy(b.$sN.MainThreadWindow),this.b.$getInitialState().then(({isFocused:P,isActive:w})=>{this.onDidChangeWindowProperty("focused",P),this.onDidChangeWindowProperty("active",w)})}$onDidChangeWindowFocus(u){this.onDidChangeWindowProperty("focused",u)}$onDidChangeWindowActive(u){this.onDidChangeWindowProperty("active",u)}onDidChangeWindowProperty(u,P){P!==this.d[u]&&(this.d={...this.d,[u]:P},this.c.fire(this.d))}openUri(u,P){let w;if(typeof u=="string"){w=u;try{u=T.URI.parse(u)}catch{return Promise.reject(`Invalid uri - '${u}'`)}}return(0,C.$af)(u.scheme)?Promise.reject("Invalid scheme - cannot be empty"):u.scheme===h.Schemas.command?Promise.reject(`Invalid scheme '${u.scheme}'`):this.b.$openUri(u,w,P)}async asExternalUri(u,P){if((0,C.$af)(u.scheme))return Promise.reject("Invalid scheme - cannot be empty");const w=await this.b.$asExternalUri(u,P);return T.URI.from(w)}};e.$uqc=I,e.$uqc=I=c=Ye([Ve(0,R.$1P)],I),e.$vqc=(0,L.$Ci)("IExtHostWindow")}),define(ke[285],Ie([1,0,275,29,19,93]),function(me,e,r,h,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0qc=void 0;const L=1024*1024;let R=class extends r.$yqc{constructor(c,I){super(c,I),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(c,I,D){const u=c==="error"||c==="warn"?process.stderr:process.stdout;this.g=!0,u.write(`
${T.NativeLogMarkers.Start}
`),I.apply(console,D),u.write(`
${T.NativeLogMarkers.End}
`),this.g=!1}j(c,I){const D=process[c],u=D.write;let P="";Object.defineProperty(D,"write",{set:()=>{},get:()=>(w,a,$)=>{if(!this.g){P+=w.toString(a);const f=P.length>L?P.length:P.lastIndexOf(`
`);f!==-1&&(console[I](P.slice(0,f)),P=P.slice(f+1))}u.call(D,w,a,$)}})}};e.$0qc=R,e.$0qc=R=Ye([Ve(0,C.$1P),Ve(1,h.$eQ)],R)}),define(ke[286],Ie([1,0,161,14,228,32]),function(me,e,r,h,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jrc=void 0;class L extends r.$xqc{s(b,c,I){return b.scheme===h.Schemas.file?new C.$dR(I?.name||(0,T.$Yg)(),b.fsPath,!I?.donotRotate,!!I?.donotUseFormatters,c):super.s(b,c,I)}registerLogger(b){super.registerLogger(b),this.r.$registerLogger(b)}deregisterLogger(b){super.deregisterLogger(b),this.r.$deregisterLogger(b)}}e.$jrc=L}),define(ke[287],Ie([1,0,7,21,20,26,13,4,3,40,138,273,53]),function(me,e,r,h,C,T,L,R,b,c,I,D,u){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Wcc=e.ResponsiveState=e.RequestInitiator=void 0,e.$Ucc=g,e.$Vcc=i,L=Ue(L);function w(F,N){try{return JSON.stringify(F,N)}catch{return"null"}}const a="$$ref$$",$={[a]:-1};class f{constructor(N,O){this.jsonString=N,this.referencedBuffers=O}}function g(F,N=null,O=!1){const j=[];return{jsonString:(O?w:JSON.stringify)(F,(M,V)=>{if(typeof V>"u")return $;if(typeof V=="object"){if(V instanceof h.$Le){const K=j.push(V)-1;return{[a]:K}}if(N)return N(M,V)}return V}),referencedBuffers:j}}function i(F,N,O){return JSON.parse(F,(j,z)=>{if(z){const M=z[a];if(typeof M=="number")return N[M];if(O&&z.$mid===c.MarshalledId.Uri)return O.transformIncoming(z)}return z})}function o(F,N){return JSON.stringify(F,N)}function t(F){return F?(N,O)=>O&&O.$mid===c.MarshalledId.Uri?F.transformOutgoing(O):O:null}var s;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(s||(e.RequestInitiator=s={}));var n;(function(F){F[F.Responsive=0]="Responsive",F[F.Unresponsive=1]="Unresponsive"})(n||(e.ResponsiveState=n={}));const d=()=>{},l=Symbol.for("rpcProtocol"),m=Symbol.for("rpcProxy");class E extends b.$Tc{static{P=l}static{this.a=3*1e3}constructor(N,O=null,j=null){super(),this[P]=!0,this.b=this.B(new R.$je),this.onDidChangeResponsiveState=this.b.event,this.c=N,this.f=O,this.g=j,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let z=0,M=u.$Pw.count;z<M;z++)this.m[z]=null,this.s[z]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=n.Responsive,this.z=0,this.C=0,this.D=this.B(new r.$Oh(()=>this.H(),1e3)),this.B(this.c.onMessage(z=>this.L(z)))}dispose(){this.j=!0,Object.keys(this.w).forEach(N=>{const O=this.w[N];delete this.w[N],O.resolveErr(L.$5())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(N){this.z===0&&(this.C=Date.now()+E.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(N){this.C=Date.now()+E.a,this.z--,this.z===0&&this.D.cancel(),this.I(n.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(n.Unresponsive):this.D.schedule())}I(N){this.y!==N&&(this.y=N,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(N){return this.g?(0,I.$Ln)(N,this.g):N}getProxy(N){const{nid:O,sid:j}=N;return this.s[O]||(this.s[O]=this.J(O,j)),this.s[O]}J(N,O){const j={get:(z,M)=>(typeof M=="string"&&!z[M]&&M.charCodeAt(0)===T.CharCode.DollarSign&&(z[M]=(...V)=>this.U(N,M,V)),M===m?O:z[M])};return new Proxy(Object.create(null),j)}set(N,O){return this.m[N.nid]=O,O}assertRegistered(N){for(let O=0,j=N.length;O<j;O++){const z=N[O];if(!this.m[z.nid])throw new Error(`Missing proxy instance ${z.sid}`)}}L(N){if(this.j)return;const O=N.byteLength,j=y.read(N,0),z=j.readUInt8(),M=j.readUInt32();switch(z){case p.RequestJSONArgs:case p.RequestJSONArgsWithCancellation:{let{rpcId:V,method:K,args:ne}=A.deserializeRequestJSONArgs(j);this.g&&(ne=(0,I.$Ln)(ne,this.g)),this.M(O,M,V,K,ne,z===p.RequestJSONArgsWithCancellation);break}case p.RequestMixedArgs:case p.RequestMixedArgsWithCancellation:{let{rpcId:V,method:K,args:ne}=A.deserializeRequestMixedArgs(j);this.g&&(ne=(0,I.$Ln)(ne,this.g)),this.M(O,M,V,K,ne,z===p.RequestMixedArgsWithCancellation);break}case p.Acknowledged:{this.f?.logIncoming(O,M,s.LocalSide,"ack"),this.G(M);break}case p.Cancel:{this.N(O,M);break}case p.ReplyOKEmpty:{this.O(O,M,void 0);break}case p.ReplyOKJSON:{let V=A.deserializeReplyOKJSON(j);this.g&&(V=(0,I.$Ln)(V,this.g)),this.O(O,M,V);break}case p.ReplyOKJSONWithBuffers:{const V=A.deserializeReplyOKJSONWithBuffers(j,this.g);this.O(O,M,V);break}case p.ReplyOKVSBuffer:{const V=A.deserializeReplyOKVSBuffer(j);this.O(O,M,V);break}case p.ReplyErrError:{let V=A.deserializeReplyErrError(j);this.g&&(V=(0,I.$Ln)(V,this.g)),this.P(O,M,V);break}case p.ReplyErrEmpty:{this.P(O,M,void 0);break}default:console.error("received unexpected message"),console.error(N)}}M(N,O,j,z,M,V){this.f?.logIncoming(N,O,s.OtherSide,`receiveRequest ${(0,u.$Rw)(j)}.${z}(`,M);const K=String(O);let ne,B;if(V){const Y=new C.$ue;M.push(Y.token),ne=this.Q(j,z,M),B=()=>Y.cancel()}else ne=this.Q(j,z,M),B=d;this.u[K]=B;const G=A.serializeAcknowledged(O);this.f?.logOutgoing(G.byteLength,O,s.OtherSide,"ack"),this.c.send(G),ne.then(Y=>{delete this.u[K];const ee=A.serializeReplyOK(O,Y,this.h);this.f?.logOutgoing(ee.byteLength,O,s.OtherSide,"reply:",Y),this.c.send(ee)},Y=>{delete this.u[K];const ee=A.serializeReplyErr(O,Y);this.f?.logOutgoing(ee.byteLength,O,s.OtherSide,"replyErr:",Y),this.c.send(ee)})}N(N,O){this.f?.logIncoming(N,O,s.OtherSide,"receiveCancel");const j=String(O);this.u[j]?.()}O(N,O,j){this.f?.logIncoming(N,O,s.LocalSide,"receiveReply:",j);const z=String(O);if(!this.w.hasOwnProperty(z))return;const M=this.w[z];delete this.w[z],M.resolveOk(j)}P(N,O,j){this.f?.logIncoming(N,O,s.LocalSide,"receiveReplyErr:",j);const z=String(O);if(!this.w.hasOwnProperty(z))return;const M=this.w[z];delete this.w[z];let V;j&&(j.$isError?(V=new Error,V.name=j.name,V.message=j.message,V.stack=j.stack):V=j),M.resolveErr(V)}Q(N,O,j){try{return Promise.resolve(this.S(N,O,j))}catch(z){return Promise.reject(z)}}S(N,O,j){const z=this.m[N];if(!z)throw new Error("Unknown actor "+(0,u.$Rw)(N));const M=z[O];if(typeof M!="function")throw new Error("Unknown method "+O+" on actor "+(0,u.$Rw)(N));return M.apply(z,j)}U(N,O,j){if(this.j)return new D.$Tcc;let z=null;if(j.length>0&&C.CancellationToken.isCancellationToken(j[j.length-1])&&(z=j.pop()),z&&z.isCancellationRequested)return Promise.reject(L.$5());const M=A.serializeRequestArguments(j,this.h),V=++this.t,K=String(V),ne=new D.$Scc,B=new b.$Sc;z&&B.add(z.onCancellationRequested(()=>{const Y=A.serializeCancel(V);this.f?.logOutgoing(Y.byteLength,V,s.LocalSide,"cancel"),this.c.send(A.serializeCancel(V))})),this.w[K]=new S(ne,B),this.F(V);const G=A.serializeRequest(V,N,O,M,!!z);return this.f?.logOutgoing(G.byteLength,V,s.LocalSide,`request: ${(0,u.$Rw)(N)}.${O}(`,j),this.c.send(G),ne}}e.$Wcc=E;class S{constructor(N,O){this.a=N,this.b=O}resolveOk(N){this.a.resolveOk(N),this.b.dispose()}resolveErr(N){this.a.resolveErr(N),this.b.dispose()}}class y{static alloc(N,O,j){const z=new y(h.$Le.alloc(j+1+4),0);return z.writeUInt8(N),z.writeUInt32(O),z}static read(N,O){return new y(N,O)}get buffer(){return this.a}constructor(N,O){this.a=N,this.b=O}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(N){this.a.writeUInt8(N,this.b),this.b+=1}readUInt8(){const N=this.a.readUInt8(this.b);return this.b+=1,N}writeUInt32(N){this.a.writeUInt32BE(N,this.b),this.b+=4}readUInt32(){const N=this.a.readUInt32BE(this.b);return this.b+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this.a.writeUInt8(N.byteLength,this.b),this.b+=1,this.a.set(N,this.b),this.b+=N.byteLength}readShortString(){const N=this.a.readUInt8(this.b);this.b+=1;const j=this.a.slice(this.b,this.b+N).toString();return this.b+=N,j}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readLongString(){const N=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+N).toString();return this.b+=N,j}writeBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readVSBuffer(){const N=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+N);return this.b+=N,O}static sizeMixedArray(N){let O=0;O+=1;for(let j=0,z=N.length;j<z;j++){const M=N[j];switch(O+=1,M.type){case v.String:O+=this.sizeLongString(M.value);break;case v.VSBuffer:O+=this.sizeVSBuffer(M.value);break;case v.SerializedObjectWithBuffers:O+=this.sizeUInt32,O+=this.sizeLongString(M.value);for(let V=0;V<M.buffers.length;++V)O+=this.sizeVSBuffer(M.buffers[V]);break;case v.Undefined:break}}return O}writeMixedArray(N){this.a.writeUInt8(N.length,this.b),this.b+=1;for(let O=0,j=N.length;O<j;O++){const z=N[O];switch(z.type){case v.String:this.writeUInt8(v.String),this.writeLongString(z.value);break;case v.VSBuffer:this.writeUInt8(v.VSBuffer),this.writeVSBuffer(z.value);break;case v.SerializedObjectWithBuffers:this.writeUInt8(v.SerializedObjectWithBuffers),this.writeUInt32(z.buffers.length),this.writeLongString(z.value);for(let M=0;M<z.buffers.length;++M)this.writeBuffer(z.buffers[M]);break;case v.Undefined:this.writeUInt8(v.Undefined);break}}}readMixedArray(){const N=this.a.readUInt8(this.b);this.b+=1;const O=new Array(N);for(let j=0;j<N;j++)switch(this.readUInt8()){case v.String:O[j]=this.readLongString();break;case v.VSBuffer:O[j]=this.readVSBuffer();break;case v.SerializedObjectWithBuffers:{const M=this.readUInt32(),V=this.readLongString(),K=[];for(let ne=0;ne<M;++ne)K.push(this.readVSBuffer());O[j]=new u.$Sw(i(V,K,null));break}case v.Undefined:O[j]=void 0;break}return O}}var k;(function(F){F[F.Simple=0]="Simple",F[F.Mixed=1]="Mixed"})(k||(k={}));class A{static a(N){for(let O=0,j=N.length;O<j;O++)if(N[O]instanceof h.$Le||N[O]instanceof u.$Sw||typeof N[O]>"u")return!0;return!1}static serializeRequestArguments(N,O){if(this.a(N)){const j=[];for(let z=0,M=N.length;z<M;z++){const V=N[z];if(V instanceof h.$Le)j[z]={type:v.VSBuffer,value:V};else if(typeof V>"u")j[z]={type:v.Undefined};else if(V instanceof u.$Sw){const{jsonString:K,referencedBuffers:ne}=g(V.value,O);j[z]={type:v.SerializedObjectWithBuffers,value:h.$Le.fromString(K),buffers:ne}}else j[z]={type:v.String,value:h.$Le.fromString(o(V,O))}}return{type:k.Mixed,args:j}}return{type:k.Simple,args:o(N,O)}}static serializeRequest(N,O,j,z,M){switch(z.type){case k.Simple:return this.b(N,O,j,z.args,M);case k.Mixed:return this.c(N,O,j,z.args,M)}}static b(N,O,j,z,M){const V=h.$Le.fromString(j),K=h.$Le.fromString(z);let ne=0;ne+=y.sizeUInt8(),ne+=y.sizeShortString(V),ne+=y.sizeLongString(K);const B=y.alloc(M?p.RequestJSONArgsWithCancellation:p.RequestJSONArgs,N,ne);return B.writeUInt8(O),B.writeShortString(V),B.writeLongString(K),B.buffer}static deserializeRequestJSONArgs(N){const O=N.readUInt8(),j=N.readShortString(),z=N.readLongString();return{rpcId:O,method:j,args:JSON.parse(z)}}static c(N,O,j,z,M){const V=h.$Le.fromString(j);let K=0;K+=y.sizeUInt8(),K+=y.sizeShortString(V),K+=y.sizeMixedArray(z);const ne=y.alloc(M?p.RequestMixedArgsWithCancellation:p.RequestMixedArgs,N,K);return ne.writeUInt8(O),ne.writeShortString(V),ne.writeMixedArray(z),ne.buffer}static deserializeRequestMixedArgs(N){const O=N.readUInt8(),j=N.readShortString(),z=N.readMixedArray(),M=new Array(z.length);for(let V=0,K=z.length;V<K;V++){const ne=z[V];typeof ne=="string"?M[V]=JSON.parse(ne):M[V]=ne}return{rpcId:O,method:j,args:M}}static serializeAcknowledged(N){return y.alloc(p.Acknowledged,N,0).buffer}static serializeCancel(N){return y.alloc(p.Cancel,N,0).buffer}static serializeReplyOK(N,O,j){if(typeof O>"u")return this.d(N);if(O instanceof h.$Le)return this.e(N,O);if(O instanceof u.$Sw){const{jsonString:z,referencedBuffers:M}=g(O.value,j,!0);return this.g(N,z,M)}else return this.f(N,w(O,j))}static d(N){return y.alloc(p.ReplyOKEmpty,N,0).buffer}static e(N,O){let j=0;j+=y.sizeVSBuffer(O);const z=y.alloc(p.ReplyOKVSBuffer,N,j);return z.writeVSBuffer(O),z.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static f(N,O){const j=h.$Le.fromString(O);let z=0;z+=y.sizeLongString(j);const M=y.alloc(p.ReplyOKJSON,N,z);return M.writeLongString(j),M.buffer}static g(N,O,j){const z=h.$Le.fromString(O);let M=0;M+=y.sizeUInt32,M+=y.sizeLongString(z);for(const K of j)M+=y.sizeVSBuffer(K);const V=y.alloc(p.ReplyOKJSONWithBuffers,N,M);V.writeUInt32(j.length),V.writeLongString(z);for(const K of j)V.writeBuffer(K);return V.buffer}static deserializeReplyOKJSON(N){const O=N.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(N,O){const j=N.readUInt32(),z=N.readLongString(),M=[];for(let V=0;V<j;++V)M.push(N.readVSBuffer());return new u.$Sw(i(z,M,O))}static serializeReplyErr(N,O){const j=O?w(L.$1(O),null):void 0;if(typeof j!="string")return this.h(N);const z=h.$Le.fromString(j);let M=0;M+=y.sizeLongString(z);const V=y.alloc(p.ReplyErrError,N,M);return V.writeLongString(z),V.buffer}static deserializeReplyErrError(N){const O=N.readLongString();return JSON.parse(O)}static h(N){return y.alloc(p.ReplyErrEmpty,N,0).buffer}}var p;(function(F){F[F.RequestJSONArgs=1]="RequestJSONArgs",F[F.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",F[F.RequestMixedArgs=3]="RequestMixedArgs",F[F.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",F[F.Acknowledged=5]="Acknowledged",F[F.Cancel=6]="Cancel",F[F.ReplyOKEmpty=7]="ReplyOKEmpty",F[F.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",F[F.ReplyOKJSON=9]="ReplyOKJSON",F[F.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",F[F.ReplyErrError=11]="ReplyErrError",F[F.ReplyErrEmpty=12]="ReplyErrEmpty"})(p||(p={}));var v;(function(F){F[F.String=1]="String",F[F.VSBuffer=2]="VSBuffer",F[F.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",F[F.Undefined=4]="Undefined"})(v||(v={}))}),define(ke[288],Ie([1,0,21,28,14,88,5]),function(me,e,r,h,C,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fL=e.$cL=void 0,e.$dL=I,e.$eL=D,e.$cL=(0,L.$Ci)("notebookDocumentService");const R=["W","X","Y","Z","a","b","c","d","e","f"],b=new RegExp(`^[${R.join("")}]+`),c=7;function I(P){if(P.scheme!==C.Schemas.vscodeNotebookCell)return;const w=P.fragment.indexOf("s");if(w<0)return;const a=parseInt(P.fragment.substring(0,w).replace(b,""),c),$=(0,r.$5e)(P.fragment.substring(w+1)).toString();if(!isNaN(a))return{handle:a,notebook:P.with({scheme:$,fragment:null})}}function D(P,w){const a=w.toString(c),f=`${a.length<R.length?R[a.length-1]:"z"}${a}s${(0,r.$6e)(r.$Le.fromString(P.scheme),!0,!0)}`;return P.with({scheme:C.Schemas.vscodeNotebookCell,fragment:f})}class u{constructor(){this.a=new h.$zc}getNotebook(w){if(w.scheme===C.Schemas.vscodeNotebookCell){const a=I(w);if(a){const $=this.a.get(a.notebook);if($)return $}}return this.a.get(w)}addNotebookDocument(w){this.a.set(w.uri,w)}removeNotebookDocument(w){this.a.delete(w.uri)}}e.$fL=u,(0,T.$Ns)(e.$cL,u,T.InstantiationType.Delayed)}),define(ke[126],Ie([1,0,21,38,39,103,14,16,10,35,288]),function(me,e,r,h,C,T,L,R,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zL=e.$wL=e.CellStatusbarAlignment=e.$vL=e.NotebookFindScopeType=e.NotebookEditorPriority=e.$sL=e.$rL=e.$pL=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$oL=e.$nL=e.$mL=e.$lL=e.CellKind=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=void 0,e.$qL=n,e.$tL=m,e.$uL=E,e.$xL=k,e.$yL=p,h=Ue(h),e.$gL="workbench.editor.notebook",e.$hL="workbench.editor.notebookTextDiffEditor",e.$iL="workbench.editor.interactive",e.$jL="workbench.editor.repl",e.$kL="replNotebook.input.execute";var D;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(D||(e.CellKind=D={})),e.$lL=["application/json","application/javascript","text/html","image/svg+xml",T.$7s.latex,T.$7s.markdown,"image/png","image/jpeg",T.$7s.text],e.$mL=[T.$7s.latex,T.$7s.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",T.$7s.text],e.$nL=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$oL="_notAvailable";var u;(function(K){K[K.Running=1]="Running",K[K.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var P;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(P||(e.NotebookCellExecutionState=P={}));var w;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(w||(e.NotebookExecutionState=w={}));var a;(function(K){K[K.WithHardKernelDependency=0]="WithHardKernelDependency",K[K.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",K[K.Pure=2]="Pure",K[K.Never=3]="Never"})(a||(e.NotebookRendererMatch=a={}));var $;(function(K){K.Always="always",K.Never="never",K.Optional="optional"})($||(e.RendererMessagingSpec=$={}));var f;(function(K){K[K.ModelChange=1]="ModelChange",K[K.Move=2]="Move",K[K.ChangeCellLanguage=5]="ChangeCellLanguage",K[K.Initialize=6]="Initialize",K[K.ChangeCellMetadata=7]="ChangeCellMetadata",K[K.Output=8]="Output",K[K.OutputItem=9]="OutputItem",K[K.ChangeCellContent=10]="ChangeCellContent",K[K.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",K[K.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",K[K.ChangeCellMime=13]="ChangeCellMime",K[K.Unknown=100]="Unknown"})(f||(e.NotebookCellsChangeType=f={}));var g;(function(K){K[K.Handle=0]="Handle",K[K.Index=1]="Index"})(g||(e.SelectionStateType=g={}));var i;(function(K){K[K.Replace=1]="Replace",K[K.Output=2]="Output",K[K.Metadata=3]="Metadata",K[K.CellLanguage=4]="CellLanguage",K[K.DocumentMetadata=5]="DocumentMetadata",K[K.Move=6]="Move",K[K.OutputItems=7]="OutputItems",K[K.PartialMetadata=8]="PartialMetadata",K[K.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var o;(function(K){K.scheme=L.Schemas.vscodeNotebookCell;function ne(re,ye){return(0,I.$eL)(re,ye)}K.generate=ne;function B(re){return(0,I.$dL)(re)}K.parse=B;function G(re,ye){return re.with({scheme:L.Schemas.vscodeNotebookCellOutput,fragment:`op${ye??""},${re.scheme!==L.Schemas.file?re.scheme:""}`})}K.generateCellOutputUri=G;function Y(re){if(re.scheme!==L.Schemas.vscodeNotebookCellOutput)return;const ye=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(re.fragment);if(!ye)return;const $e=ye[1]&&ye[1]!==""?ye[1]:void 0,J=ye[2];return{outputId:$e,notebook:re.with({scheme:J||L.Schemas.file,fragment:null})}}K.parseCellOutputUri=Y;function ee(re,ye,$e){return K.generate(re,ye).with({scheme:$e})}K.generateCellPropertyUri=ee;function ue(re,ye){if(re.scheme===ye)return K.parse(re.with({scheme:K.scheme}))}K.parseCellPropertyUri=ue})(o||(e.CellUri=o={}));const t=K=>b.$j?K.replace(/\//g,"\\"):K;class s{constructor(ne=[],B=e.$lL){this.e=B,this.d=[...new Set(ne)].map(G=>({pattern:G,matches:h.$wk(t(G))}))}sort(ne){const B=new Map(C.Iterable.map(ne,Y=>[Y,t(Y)]));let G=[];for(const{matches:Y}of this.d)for(const[ee,ue]of B)if(Y(ue)){G.push(ee),B.delete(ee);break}return B.size&&(G=G.concat([...B.keys()].sort((Y,ee)=>this.e.indexOf(Y)-this.e.indexOf(ee)))),G}prioritize(ne,B){const G=this.f(ne);if(G===-1){this.d.unshift({pattern:ne,matches:h.$wk(t(ne))});return}const Y=new Set(B.map(ue=>this.f(ue,G)));Y.delete(-1);const ee=Array.from(Y).sort();this.d.splice(G+1,0,...ee.map(ue=>this.d[ue]));for(let ue=ee.length-1;ue>=0;ue--)this.d.splice(ee[ue],1)}toArray(){return this.d.map(ne=>ne.pattern)}f(ne,B=this.d.length){const G=t(ne);for(let Y=0;Y<B;Y++)if(this.d[Y].matches(G))return Y;return-1}}e.$pL=s;function n(K,ne,B,G=(Y,ee)=>Y===ee){const Y=[];function ee(ye,$e,J){if($e===0&&J.length===0)return;const W=Y[Y.length-1];W&&W.start+W.deleteCount===ye?(W.deleteCount+=$e,W.toInsert.push(...J)):Y.push({start:ye,deleteCount:$e,toInsert:J})}let ue=0,re=0;for(;;){if(ue===K.length){ee(ue,0,ne.slice(re));break}if(re===ne.length){ee(ue,K.length-ue,[]);break}const ye=K[ue],$e=ne[re];if(G(ye,$e)){ue+=1,re+=1;continue}B($e)?(ee(ue,1,[]),ue+=1):(ee(ue,0,[$e]),re+=1)}return Y}e.$rL=new c.$Tj("notebookEditorCursorAtBoundary","none"),e.$sL=new c.$Tj("notebookEditorCursorAtLineBoundary","none");var d;(function(K){K.default="default",K.option="option"})(d||(e.NotebookEditorPriority=d={}));var l;(function(K){K.Cells="cells",K.Text="text",K.None="none"})(l||(e.NotebookFindScopeType=l={}));function m(K){const ne=K;return!!((typeof ne.include=="string"||h.$xk(ne.include))&&(typeof ne.exclude=="string"||h.$xk(ne.exclude)))}function E(K,ne,B){if(Array.isArray(K.viewType)&&K.viewType.indexOf(ne)>=0||K.viewType===ne)return!0;if(K.filenamePattern){const G=m(K.filenamePattern)?K.filenamePattern.include:K.filenamePattern,Y=m(K.filenamePattern)?K.filenamePattern.exclude:void 0;if(h.$vk(G,(0,R.$mc)(B.fsPath).toLowerCase()))return!(Y&&h.$vk(Y,(0,R.$mc)(B.fsPath).toLowerCase()))}return!1}e.$vL={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var S;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(S||(e.CellStatusbarAlignment=S={}));class y{static{this.d="notebook/"}static create(ne){return`${y.d}${ne}`}static parse(ne){if(ne.startsWith(y.d))return ne.substring(y.d.length)}}e.$wL=y;function k(K){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(K)}const A=new TextDecoder;function p(K){const ne=[];let B=!1;for(const ue of K)(ne.length===0||B)&&(ne.push(ue),B=!0);let G=N(ne);const Y=r.$Le.concat(ne.map(ue=>r.$Le.wrap(ue))),ee=V(Y);return G=G||ee.byteLength!==Y.byteLength,{data:ee,didCompression:G}}e.$zL="\x1B[A";const v=e.$zL.split("").map(K=>K.charCodeAt(0)),F=10;function N(K){let ne=!1;return K.forEach((B,G)=>{if(G===0||B.length<e.$zL.length)return;const Y=K[G-1],ee=B.subarray(0,e.$zL.length);if(ee[0]===v[0]&&ee[1]===v[1]&&ee[2]===v[2]){const ue=Y.lastIndexOf(F);if(ue===-1)return;ne=!0,K[G-1]=Y.subarray(0,ue),K[G]=B.subarray(e.$zL.length)}}),ne}function O(K){let ne=K;do K=ne,ne=K.replace(/[^\n]\x08/gm,"");while(ne.length<K.length);return K}function j(K){for(K=K.replace(/\r+\n/gm,`
`);K.search(/\r[^$]/g)>-1;){const ne=K.match(/^(.*)\r+/m)[1];let B=K.match(/\r+(.*)$/m)[1];B=B+ne.slice(B.length,ne.length),K=K.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,B)}return K}const z=8,M=13;function V(K){return!K.buffer.includes(z)&&!K.buffer.includes(M)?K:r.$Le.fromString(j(O(A.decode(K.buffer))))}}),define(ke[9],Ie([1,0,18,13,85,28,103,12,17,2,32,23,27,71,126]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w){"use strict";var a,$,f,g,i,o,t,s,n,d,l,m,E,S,y,k,A;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$PP=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$OP=e.$NP=e.$MP=e.$LP=e.$KP=e.$JP=e.$IP=e.$HP=e.LanguageModelChatMessageRole=e.$GP=e.$FP=e.ChatLocation=e.$EP=e.$DP=e.$CP=e.$BP=e.$AP=e.$zP=e.$yP=e.$xP=e.$wP=e.$vP=e.$uP=e.$tP=e.$sP=e.$rP=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$qP=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$pP=e.$oP=e.$nP=e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=e.$hP=e.$gP=e.$fP=e.$eP=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$dP=e.$cP=e.$bP=e.$aP=e.$$O=e.$0O=e.$9O=e.$8O=e.TestRunProfileKind=e.TestResultState=e.$7O=e.$6O=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$5O=e.NotebookVariablesRequestKind=e.$4O=e.$3O=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$2O=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$1O=e.$ZO=e.$YO=e.$XO=e.$WO=e.ColorThemeKind=e.$VO=e.$UO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$TO=e.$SO=e.DebugConsoleMode=e.$RO=e.$QO=e.$PO=e.$OO=e.$NO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$MO=e.$LO=e.FileChangeType=e.$KO=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$JO=e.$IO=e.$HO=e.$GO=e.InlineCompletionTriggerKind=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=e.$yO=e.$xO=e.$wO=e.$vO=e.$tO=e.ConfigurationTarget=e.$sO=e.$rO=e.$qO=e.$pO=e.DocumentPasteTriggerKind=e.$oO=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$iO=e.ViewBadge=e.ProgressLocation=e.$hO=e.$gO=e.TaskScope=e.ShellQuoting=e.$fO=e.$eO=e.$dO=e.TaskPanelKind=e.TaskRevealKind=e.$cO=e.TerminalLocation=e.$bO=e.$aO=e.$_N=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$$N=e.$0N=e.$9N=e.$8N=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$6N=e.$5N=e.$4N=e.$3N=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$2N=e.$1N=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=e.LanguageStatusSeverity=e.$UN=e.$TN=e.$SN=e.$RN=e.$QN=e.$PN=e.CodeActionTriggerKind=e.$ON=e.$NN=e.SymbolTag=e.SymbolKind=e.$MN=e.$LN=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$KN=e.$JN=e.$IN=e.$HN=e.$GN=e.DiagnosticSeverity=e.DiagnosticTag=e.$FN=e.$EN=e.FileEditType=e.$DN=e.$CN=e.$BN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$AN=e.$zN=e.$yN=e.$xN=e.$wN=e.$vN=e.$uN=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$7N=et,e.$uO=Di,e.$_O=Ri;function p(Q){return Object.assign(Q,{apply:function(...ge){if(ge.length===0)return Reflect.construct(Q,[]);{const Le=ge.length===1?[]:ge[1];return Reflect.construct(Q,Le,ge[0].constructor)}},call:function(...ge){if(ge.length===0)return Reflect.construct(Q,[]);{const[Le,...Ze]=ge;return Reflect.construct(Q,Ze,Le.constructor)}}})}var v;(function(Q){Q[Q.Top=0]="Top",Q[Q.Bottom=1]="Bottom"})(v||(e.TerminalOutputAnchor=v={}));var F;(function(Q){Q[Q.TerminalCommand=0]="TerminalCommand",Q[Q.Opener=1]="Opener",Q[Q.Command=3]="Command"})(F||(e.TerminalQuickFixType=F={}));let N=a=class{static from(...H){let ge=H;return new a(function(){if(ge){for(const Le of ge)Le&&typeof Le.dispose=="function"&&Le.dispose();ge=void 0}})}#e;constructor(H){this.#e=H}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$uN=N,e.$uN=N=a=Ye([p],N);let O=$=class{static Min(...H){if(H.length===0)throw new TypeError;let ge=H[0];for(let Le=1;Le<H.length;Le++){const Ze=H[Le];Ze.isBefore(ge)&&(ge=Ze)}return ge}static Max(...H){if(H.length===0)throw new TypeError;let ge=H[0];for(let Le=1;Le<H.length;Le++){const Ze=H[Le];Ze.isAfter(ge)&&(ge=Ze)}return ge}static isPosition(H){if(!H)return!1;if(H instanceof $)return!0;const{line:ge,character:Le}=H;return typeof ge=="number"&&typeof Le=="number"}static of(H){if(H instanceof $)return H;if(this.isPosition(H))return new $(H.line,H.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(H,ge){if(H<0)throw(0,h.$6)("line must be non-negative");if(ge<0)throw(0,h.$6)("character must be non-negative");this.c=H,this.e=ge}isBefore(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<H.e}isBeforeOrEqual(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<=H.e}isAfter(H){return!this.isBeforeOrEqual(H)}isAfterOrEqual(H){return!this.isBefore(H)}isEqual(H){return this.c===H.c&&this.e===H.e}compareTo(H){return this.c<H.c?-1:this.c>H.line?1:this.e<H.e?-1:this.e>H.e?1:0}translate(H,ge=0){if(H===null||ge===null)throw(0,h.$6)();let Le;return typeof H>"u"?Le=0:typeof H=="number"?Le=H:(Le=typeof H.lineDelta=="number"?H.lineDelta:0,ge=typeof H.characterDelta=="number"?H.characterDelta:0),Le===0&&ge===0?this:new $(this.line+Le,this.character+ge)}with(H,ge=this.character){if(H===null||ge===null)throw(0,h.$6)();let Le;return typeof H>"u"?Le=this.line:typeof H=="number"?Le=H:(Le=typeof H.line=="number"?H.line:this.line,ge=typeof H.character=="number"?H.character:this.character),Le===this.line&&ge===this.character?this:new $(Le,ge)}toJSON(){return{line:this.line,character:this.character}}};e.$vN=O,e.$vN=O=$=Ye([p],O);let j=f=class{static isRange(H){return H instanceof f?!0:H?O.isPosition(H.start)&&O.isPosition(H.end):!1}static of(H){if(H instanceof f)return H;if(this.isRange(H))return new f(H.start,H.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(H,ge,Le,Ze){let st,$t;if(typeof H=="number"&&typeof ge=="number"&&typeof Le=="number"&&typeof Ze=="number"?(st=new O(H,ge),$t=new O(Le,Ze)):O.isPosition(H)&&O.isPosition(ge)&&(st=O.of(H),$t=O.of(ge)),!st||!$t)throw new Error("Invalid arguments");st.isBefore($t)?(this.c=st,this.e=$t):(this.c=$t,this.e=st)}contains(H){return f.isRange(H)?this.contains(H.start)&&this.contains(H.end):O.isPosition(H)?!(O.of(H).isBefore(this.c)||this.e.isBefore(H)):!1}isEqual(H){return this.c.isEqual(H.c)&&this.e.isEqual(H.e)}intersection(H){const ge=O.Max(H.start,this.c),Le=O.Min(H.end,this.e);if(!ge.isAfter(Le))return new f(ge,Le)}union(H){if(this.contains(H))return this;if(H.contains(this))return H;const ge=O.Min(H.start,this.c),Le=O.Max(H.end,this.end);return new f(ge,Le)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(H,ge=this.end){if(H===null||ge===null)throw(0,h.$6)();let Le;return H?O.isPosition(H)?Le=H:(Le=H.start||this.start,ge=H.end||this.end):Le=this.start,Le.isEqual(this.c)&&ge.isEqual(this.end)?this:new f(Le,ge)}toJSON(){return[this.start,this.end]}};e.$wN=j,e.$wN=j=f=Ye([p],j);let z=g=class extends j{static isSelection(H){return H instanceof g?!0:H?j.isRange(H)&&O.isPosition(H.anchor)&&O.isPosition(H.active)&&typeof H.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(H,ge,Le,Ze){let st,$t;if(typeof H=="number"&&typeof ge=="number"&&typeof Le=="number"&&typeof Ze=="number"?(st=new O(H,ge),$t=new O(Le,Ze)):O.isPosition(H)&&O.isPosition(ge)&&(st=O.of(H),$t=O.of(ge)),!st||!$t)throw new Error("Invalid arguments");super(st,$t),this.f=st,this.g=$t}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$xN=z,e.$xN=z=g=Ye([p],z);const M=Q=>{if(typeof Q!="string"||Q.length===0||!/^[0-9A-Za-z_\-]+$/.test(Q))throw(0,h.$6)("connectionToken")};class V{static isResolvedAuthority(H){return H&&typeof H=="object"&&typeof H.host=="string"&&typeof H.port=="number"&&(H.connectionToken===void 0||typeof H.connectionToken=="string")}constructor(H,ge,Le){if(typeof H!="string"||H.length===0)throw(0,h.$6)("host");if(typeof ge!="number"||ge===0||Math.round(ge)!==ge)throw(0,h.$6)("port");typeof Le<"u"&&M(Le),this.host=H,this.port=Math.round(ge),this.connectionToken=Le}}e.$yN=V;class K{static isManagedResolvedAuthority(H){return H&&typeof H=="object"&&typeof H.makeConnection=="function"&&(H.connectionToken===void 0||typeof H.connectionToken=="string")}constructor(H,ge){this.makeConnection=H,this.connectionToken=ge,typeof ge<"u"&&M(ge)}}e.$zN=K;class ne extends Error{static NotAvailable(H,ge){return new ne(H,P.RemoteAuthorityResolverErrorCode.NotAvailable,ge)}static TemporarilyNotAvailable(H){return new ne(H,P.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(H,ge=P.RemoteAuthorityResolverErrorCode.Unknown,Le){super(H),this._message=H,this._code=ge,this._detail=Le,Object.setPrototypeOf(this,ne.prototype)}}e.$AN=ne;var B;(function(Q){Q[Q.LF=1]="LF",Q[Q.CRLF=2]="CRLF"})(B||(e.EndOfLine=B={}));var G;(function(Q){Q[Q.Replace=1]="Replace",Q[Q.Append=2]="Append",Q[Q.Prepend=3]="Prepend"})(G||(e.EnvironmentVariableMutatorType=G={}));let Y=i=class{static isTextEdit(H){return H instanceof i?!0:H?j.isRange(H)&&typeof H.newText=="string":!1}static replace(H,ge){return new i(H,ge)}static insert(H,ge){return i.replace(new j(H,H),ge)}static delete(H){return i.replace(H,"")}static setEndOfLine(H){const ge=new i(new j(new O(0,0),new O(0,0)),"");return ge.newEol=H,ge}get range(){return this.c}set range(H){if(H&&!j.isRange(H))throw(0,h.$6)("range");this.c=H}get newText(){return this.e||""}set newText(H){if(H&&typeof H!="string")throw(0,h.$6)("newText");this.e=H}get newEol(){return this.f}set newEol(H){if(H&&typeof H!="number")throw(0,h.$6)("newEol");this.f=H}constructor(H,ge){this.c=H,this.e=ge}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$BN=Y,e.$BN=Y=i=Ye([p],Y);let ee=o=class{static isNotebookCellEdit(H){return H instanceof o?!0:H?bt.isNotebookRange(H)&&Array.isArray(H.newCells):!1}static replaceCells(H,ge){return new o(H,ge)}static insertCells(H,ge){return new o(new bt(H,H),ge)}static deleteCells(H){return new o(H,[])}static updateCellMetadata(H,ge){const Le=new o(new bt(H,H),[]);return Le.newCellMetadata=ge,Le}static updateNotebookMetadata(H){const ge=new o(new bt(0,0),[]);return ge.newNotebookMetadata=H,ge}constructor(H,ge){this.range=H,this.newCells=ge}};e.$CN=ee,e.$CN=ee=o=Ye([p],ee);class ue{static isSnippetTextEdit(H){return H instanceof ue?!0:H?j.isRange(H.range)&&$e.isSnippetString(H.snippet):!1}static replace(H,ge){return new ue(H,ge)}static insert(H,ge){return ue.replace(new j(H,H),ge)}constructor(H,ge){this.range=H,this.snippet=ge}}e.$DN=ue;var re;(function(Q){Q[Q.File=1]="File",Q[Q.Text=2]="Text",Q[Q.Cell=3]="Cell",Q[Q.CellReplace=5]="CellReplace",Q[Q.Snippet=6]="Snippet"})(re||(e.FileEditType=re={}));let ye=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(H,ge,Le,Ze){this.c.push({_type:re.File,from:H,to:ge,options:Le,metadata:Ze})}createFile(H,ge,Le){this.c.push({_type:re.File,from:void 0,to:H,options:ge,metadata:Le})}deleteFile(H,ge,Le){this.c.push({_type:re.File,from:H,to:void 0,options:ge,metadata:Le})}e(H,ge,Le){this.c.push({_type:re.Cell,metadata:Le,uri:H,edit:{editType:w.CellEditType.DocumentMetadata,metadata:ge},notebookMetadata:ge})}f(H,ge,Le,Ze){const st=ge.start,$t=ge.end;(st!==$t||Le.length>0)&&this.c.push({_type:re.CellReplace,uri:H,index:st,count:$t-st,cells:Le,metadata:Ze})}g(H,ge,Le,Ze){this.c.push({_type:re.Cell,metadata:Ze,uri:H,edit:{editType:w.CellEditType.Metadata,index:ge,metadata:Le}})}replace(H,ge,Le,Ze){this.c.push({_type:re.Text,uri:H,edit:new Y(ge,Le),metadata:Ze})}insert(H,ge,Le,Ze){this.replace(H,new j(ge,ge),Le,Ze)}delete(H,ge,Le){this.replace(H,ge,"",Le)}has(H){return this.c.some(ge=>ge._type===re.Text&&ge.uri.toString()===H.toString())}set(H,ge){if(ge)for(const Le of ge){if(!Le)continue;let Ze,st;Array.isArray(Le)?(Ze=Le[0],st=Le[1]):Ze=Le,ee.isNotebookCellEdit(Ze)?Ze.newCellMetadata?this.g(H,Ze.range.start,Ze.newCellMetadata,st):Ze.newNotebookMetadata?this.e(H,Ze.newNotebookMetadata,st):this.f(H,Ze.range,Ze.newCells,st):ue.isSnippetTextEdit(Ze)?this.c.push({_type:re.Snippet,uri:H,range:Ze.range,edit:Ze.snippet,metadata:st}):this.c.push({_type:re.Text,uri:H,edit:Ze,metadata:st})}else{for(let Le=0;Le<this.c.length;Le++){const Ze=this.c[Le];switch(Ze._type){case re.Text:case re.Snippet:case re.Cell:case re.CellReplace:Ze.uri.toString()===H.toString()&&(this.c[Le]=void 0);break}}(0,r.$Hb)(this.c)}}get(H){const ge=[];for(const Le of this.c)Le._type===re.Text&&Le.uri.toString()===H.toString()&&ge.push(Le.edit);return ge}entries(){const H=new T.$zc;for(const ge of this.c)if(ge._type===re.Text){let Le=H.get(ge.uri);Le||(Le=[ge.uri,[]],H.set(ge.uri,Le)),Le[1].push(ge.edit)}return[...H.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$EN=ye,e.$EN=ye=Ye([p],ye);let $e=t=class{static isSnippetString(H){return H instanceof t?!0:H?typeof H.value=="string":!1}static c(H){return H.replace(/\$|}|\\/g,"\\$&")}constructor(H){this.e=1,this.value=H||""}appendText(H){return this.value+=t.c(H),this}appendTabstop(H=this.e++){return this.value+="$",this.value+=H,this}appendPlaceholder(H,ge=this.e++){if(typeof H=="function"){const Le=new t;Le.e=this.e,H(Le),this.e=Le.e,H=Le.value}else H=t.c(H);return this.value+="${",this.value+=ge,this.value+=":",this.value+=H,this.value+="}",this}appendChoice(H,ge=this.e++){const Le=H.map(Ze=>Ze.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ge,this.value+="|",this.value+=Le,this.value+="|}",this}appendVariable(H,ge){if(typeof ge=="function"){const Le=new t;Le.e=this.e,ge(Le),this.e=Le.e,ge=Le.value}else typeof ge=="string"&&(ge=ge.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=H,ge&&(this.value+=":",this.value+=ge),this.value+="}",this}};e.$FN=$e,e.$FN=$e=t=Ye([p],$e);var J;(function(Q){Q[Q.Unnecessary=1]="Unnecessary",Q[Q.Deprecated=2]="Deprecated"})(J||(e.DiagnosticTag=J={}));var W;(function(Q){Q[Q.Hint=3]="Hint",Q[Q.Information=2]="Information",Q[Q.Warning=1]="Warning",Q[Q.Error=0]="Error"})(W||(e.DiagnosticSeverity=W={}));let se=s=class{static isLocation(H){return H instanceof s?!0:H?j.isRange(H.range)&&c.URI.isUri(H.uri):!1}constructor(H,ge){if(this.uri=H,ge)if(j.isRange(ge))this.range=j.of(ge);else if(O.isPosition(ge))this.range=new j(ge,ge);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$GN=se,e.$GN=se=s=Ye([p],se);let ae=class{static is(H){return H?typeof H.message=="string"&&H.location&&j.isRange(H.location.range)&&c.URI.isUri(H.location.uri):!1}constructor(H,ge){this.location=H,this.message=ge}static isEqual(H,ge){return H===ge?!0:!H||!ge?!1:H.message===ge.message&&H.location.range.isEqual(ge.location.range)&&H.location.uri.toString()===ge.location.uri.toString()}};e.$HN=ae,e.$HN=ae=Ye([p],ae);let te=class{constructor(H,ge,Le=W.Error){if(!j.isRange(H))throw new TypeError("range must be set");if(!ge)throw new TypeError("message must be set");this.range=H,this.message=ge,this.severity=Le}toJSON(){return{severity:W[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(H,ge){return H===ge?!0:!H||!ge?!1:H.message===ge.message&&H.severity===ge.severity&&H.code===ge.code&&H.severity===ge.severity&&H.source===ge.source&&H.range.isEqual(ge.range)&&(0,r.$tb)(H.tags,ge.tags)&&(0,r.$tb)(H.relatedInformation,ge.relatedInformation,ae.isEqual)}};e.$IN=te,e.$IN=te=Ye([p],te);let ce=class{constructor(H,ge){if(!H)throw new Error("Illegal argument, contents must be defined");Array.isArray(H)?this.contents=H:this.contents=[H],this.range=ge}};e.$JN=ce,e.$JN=ce=Ye([p],ce);let le=class extends ce{constructor(H,ge,Le,Ze){super(H,ge),this.canIncreaseHover=Le,this.canDecreaseHover=Ze}};e.$KN=le,e.$KN=le=Ye([p],le);var Z;(function(Q){Q[Q.Increase=0]="Increase",Q[Q.Decrease=1]="Decrease"})(Z||(e.HoverVerbosityAction=Z={}));var oe;(function(Q){Q[Q.Text=0]="Text",Q[Q.Read=1]="Read",Q[Q.Write=2]="Write"})(oe||(e.DocumentHighlightKind=oe={}));let pe=class{constructor(H,ge=oe.Text){this.range=H,this.kind=ge}toJSON(){return{range:this.range,kind:oe[this.kind]}}};e.$LN=pe,e.$LN=pe=Ye([p],pe);let we=class{constructor(H,ge){this.uri=H,this.highlights=ge}toJSON(){return{uri:this.uri,highlights:this.highlights.map(H=>H.toJSON())}}};e.$MN=we,e.$MN=we=Ye([p],we);var Fe;(function(Q){Q[Q.File=0]="File",Q[Q.Module=1]="Module",Q[Q.Namespace=2]="Namespace",Q[Q.Package=3]="Package",Q[Q.Class=4]="Class",Q[Q.Method=5]="Method",Q[Q.Property=6]="Property",Q[Q.Field=7]="Field",Q[Q.Constructor=8]="Constructor",Q[Q.Enum=9]="Enum",Q[Q.Interface=10]="Interface",Q[Q.Function=11]="Function",Q[Q.Variable=12]="Variable",Q[Q.Constant=13]="Constant",Q[Q.String=14]="String",Q[Q.Number=15]="Number",Q[Q.Boolean=16]="Boolean",Q[Q.Array=17]="Array",Q[Q.Object=18]="Object",Q[Q.Key=19]="Key",Q[Q.Null=20]="Null",Q[Q.EnumMember=21]="EnumMember",Q[Q.Struct=22]="Struct",Q[Q.Event=23]="Event",Q[Q.Operator=24]="Operator",Q[Q.TypeParameter=25]="TypeParameter"})(Fe||(e.SymbolKind=Fe={}));var We;(function(Q){Q[Q.Deprecated=1]="Deprecated"})(We||(e.SymbolTag=We={}));let Se=n=class{static validate(H){if(!H.name)throw new Error("name must not be falsy")}constructor(H,ge,Le,Ze,st){this.name=H,this.kind=ge,this.containerName=st,typeof Le=="string"&&(this.containerName=Le),Ze instanceof se?this.location=Ze:Le instanceof j&&(this.location=new se(Ze,Le)),n.validate(this)}toJSON(){return{name:this.name,kind:Fe[this.kind],location:this.location,containerName:this.containerName}}};e.$NN=Se,e.$NN=Se=n=Ye([p],Se);let De=d=class{static validate(H){if(!H.name)throw new Error("name must not be falsy");if(!H.range.contains(H.selectionRange))throw new Error("selectionRange must be contained in fullRange");H.children?.forEach(d.validate)}constructor(H,ge,Le,Ze,st){this.name=H,this.detail=ge,this.kind=Le,this.range=Ze,this.selectionRange=st,this.children=[],d.validate(this)}};e.$ON=De,e.$ON=De=d=Ye([p],De);var Te;(function(Q){Q[Q.Invoke=1]="Invoke",Q[Q.Automatic=2]="Automatic"})(Te||(e.CodeActionTriggerKind=Te={}));let U=class{constructor(H,ge){this.title=H,this.kind=ge}};e.$PN=U,e.$PN=U=Ye([p],U);let q=class{static{l=this}static{this.c="."}constructor(H){this.value=H}append(H){return new l(this.value?this.value+l.c+H:H)}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+l.c)}};e.$QN=q,e.$QN=q=l=Ye([p],q),q.Empty=new q(""),q.QuickFix=q.Empty.append("quickfix"),q.Refactor=q.Empty.append("refactor"),q.RefactorExtract=q.Refactor.append("extract"),q.RefactorInline=q.Refactor.append("inline"),q.RefactorMove=q.Refactor.append("move"),q.RefactorRewrite=q.Refactor.append("rewrite"),q.Source=q.Empty.append("source"),q.SourceOrganizeImports=q.Source.append("organizeImports"),q.SourceFixAll=q.Source.append("fixAll"),q.Notebook=q.Empty.append("notebook");let X=class{constructor(H,ge){if(this.range=H,this.parent=ge,ge&&!ge.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$RN=X,e.$RN=X=Ye([p],X);class _{constructor(H,ge,Le,Ze,st,$t){this.kind=H,this.name=ge,this.detail=Le,this.uri=Ze,this.range=st,this.selectionRange=$t}}e.$SN=_;class de{constructor(H,ge){this.fromRanges=ge,this.from=H}}e.$TN=de;class be{constructor(H,ge){this.fromRanges=ge,this.to=H}}e.$UN=be;var Ne;(function(Q){Q[Q.Information=0]="Information",Q[Q.Warning=1]="Warning",Q[Q.Error=2]="Error"})(Ne||(e.LanguageStatusSeverity=Ne={}));let Ge=class{constructor(H,ge){this.range=H,this.command=ge}get isResolved(){return!!this.command}};e.$VN=Ge,e.$VN=Ge=Ye([p],Ge);let Ke=m=class{#e;static isMarkdownString(H){return H instanceof m?!0:H&&H.appendCodeblock&&H.appendMarkdown&&H.appendText&&H.value!==void 0}constructor(H,ge=!1){this.#e=new C.$Zk(H,{supportThemeIcons:ge})}get value(){return this.#e.value}set value(H){this.#e.value=H}get isTrusted(){return this.#e.isTrusted}set isTrusted(H){this.#e.isTrusted=H}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(H){this.#e.supportThemeIcons=H}get supportHtml(){return this.#e.supportHtml}set supportHtml(H){this.#e.supportHtml=H}get baseUri(){return this.#e.baseUri}set baseUri(H){this.#e.baseUri=H}appendText(H){return this.#e.appendText(H),this}appendMarkdown(H){return this.#e.appendMarkdown(H),this}appendCodeblock(H,ge){return this.#e.appendCodeblock(ge??"",H),this}};e.$WN=Ke,e.$WN=Ke=m=Ye([p],Ke);let tt=class{constructor(H,ge){this.label=H,this.documentation=ge}};e.$XN=tt,e.$XN=tt=Ye([p],tt);let rt=class{constructor(H,ge){this.label=H,this.documentation=ge,this.parameters=[]}};e.$YN=rt,e.$YN=rt=Ye([p],rt);let ot=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$ZN=ot,e.$ZN=ot=Ye([p],ot);var nt;(function(Q){Q[Q.Invoke=1]="Invoke",Q[Q.TriggerCharacter=2]="TriggerCharacter",Q[Q.ContentChange=3]="ContentChange"})(nt||(e.SignatureHelpTriggerKind=nt={}));var at;(function(Q){Q[Q.Type=1]="Type",Q[Q.Parameter=2]="Parameter"})(at||(e.InlayHintKind=at={}));let mt=class{constructor(H){this.value=H}};e.$1N=mt,e.$1N=mt=Ye([p],mt);let ht=class{constructor(H,ge,Le){this.position=H,this.label=ge,this.kind=Le}};e.$2N=ht,e.$2N=ht=Ye([p],ht);var ct;(function(Q){Q[Q.Invoke=0]="Invoke",Q[Q.TriggerCharacter=1]="TriggerCharacter",Q[Q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ct||(e.CompletionTriggerKind=ct={}));var Pe;(function(Q){Q[Q.Text=0]="Text",Q[Q.Method=1]="Method",Q[Q.Function=2]="Function",Q[Q.Constructor=3]="Constructor",Q[Q.Field=4]="Field",Q[Q.Variable=5]="Variable",Q[Q.Class=6]="Class",Q[Q.Interface=7]="Interface",Q[Q.Module=8]="Module",Q[Q.Property=9]="Property",Q[Q.Unit=10]="Unit",Q[Q.Value=11]="Value",Q[Q.Enum=12]="Enum",Q[Q.Keyword=13]="Keyword",Q[Q.Snippet=14]="Snippet",Q[Q.Color=15]="Color",Q[Q.File=16]="File",Q[Q.Reference=17]="Reference",Q[Q.Folder=18]="Folder",Q[Q.EnumMember=19]="EnumMember",Q[Q.Constant=20]="Constant",Q[Q.Struct=21]="Struct",Q[Q.Event=22]="Event",Q[Q.Operator=23]="Operator",Q[Q.TypeParameter=24]="TypeParameter",Q[Q.User=25]="User",Q[Q.Issue=26]="Issue"})(Pe||(e.CompletionItemKind=Pe={}));var ze;(function(Q){Q[Q.Deprecated=1]="Deprecated"})(ze||(e.CompletionItemTag=ze={}));let He=class{constructor(H,ge){this.label=H,this.kind=ge}toJSON(){return{label:this.label,kind:this.kind&&Pe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$3N=He,e.$3N=He=Ye([p],He);let Oe=class{constructor(H=[],ge=!1){this.items=H,this.isIncomplete=ge}};e.$4N=Oe,e.$4N=Oe=Ye([p],Oe);let je=class{constructor(H,ge,Le){this.insertText=H,this.range=ge,this.command=Le}};e.$5N=je,e.$5N=je=Ye([p],je);let he=class{constructor(H){this.commands=void 0,this.suppressSuggestions=void 0,this.items=H}};e.$6N=he,e.$6N=he=Ye([p],he);var x;(function(Q){Q[Q.Unknown=0]="Unknown",Q[Q.Word=1]="Word",Q[Q.Line=2]="Line",Q[Q.Suggest=3]="Suggest"})(x||(e.PartialAcceptTriggerKind=x={}));var Ce;(function(Q){Q[Q.Active=-1]="Active",Q[Q.Beside=-2]="Beside",Q[Q.One=1]="One",Q[Q.Two=2]="Two",Q[Q.Three=3]="Three",Q[Q.Four=4]="Four",Q[Q.Five=5]="Five",Q[Q.Six=6]="Six",Q[Q.Seven=7]="Seven",Q[Q.Eight=8]="Eight",Q[Q.Nine=9]="Nine"})(Ce||(e.ViewColumn=Ce={}));var Xe;(function(Q){Q[Q.Left=1]="Left",Q[Q.Right=2]="Right"})(Xe||(e.StatusBarAlignment=Xe={}));function et(Q,H){return`${D.$nn.toKey(Q)}.${H}`}var ut;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval"})(ut||(e.TextEditorLineNumbersStyle=ut={}));var gt;(function(Q){Q[Q.Manual=1]="Manual",Q[Q.AfterDelay=2]="AfterDelay",Q[Q.FocusOut=3]="FocusOut"})(gt||(e.TextDocumentSaveReason=gt={}));var Dt;(function(Q){Q[Q.Default=0]="Default",Q[Q.InCenter=1]="InCenter",Q[Q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",Q[Q.AtTop=3]="AtTop"})(Dt||(e.TextEditorRevealType=Dt={}));var Ot;(function(Q){Q[Q.Keyboard=1]="Keyboard",Q[Q.Mouse=2]="Mouse",Q[Q.Command=3]="Command"})(Ot||(e.TextEditorSelectionChangeKind=Ot={}));var Ut;(function(Q){Q[Q.Undo=1]="Undo",Q[Q.Redo=2]="Redo"})(Ut||(e.TextDocumentChangeReason=Ut={}));var ui;(function(Q){Q[Q.OpenOpen=0]="OpenOpen",Q[Q.ClosedClosed=1]="ClosedClosed",Q[Q.OpenClosed=2]="OpenClosed",Q[Q.ClosedOpen=3]="ClosedOpen"})(ui||(e.DecorationRangeBehavior=ui={})),function(Q){function H(ge){switch(ge){case"keyboard":return Q.Keyboard;case"mouse":return Q.Mouse;case"api":return Q.Command}}Q.fromValue=H}(Ot||(e.TextEditorSelectionChangeKind=Ot={}));var ti;(function(Q){Q[Q.Other=0]="Other",Q[Q.Comment=1]="Comment",Q[Q.String=2]="String",Q[Q.RegEx=3]="RegEx"})(ti||(e.SyntaxTokenType=ti={})),function(Q){function H(ge){switch(ge){case Q.Other:return"other";case Q.Comment:return"comment";case Q.String:return"string";case Q.RegEx:return"regex"}return"other"}Q.toString=H}(ti||(e.SyntaxTokenType=ti={}));let _e=class{constructor(H,ge){if(ge&&!c.URI.isUri(ge))throw(0,h.$6)("target");if(!j.isRange(H)||H.isEmpty)throw(0,h.$6)("range");this.range=H,this.target=ge}};e.$8N=_e,e.$8N=_e=Ye([p],_e);let Kt=class{constructor(H,ge,Le,Ze){this.red=H,this.green=ge,this.blue=Le,this.alpha=Ze}};e.$9N=Kt,e.$9N=Kt=Ye([p],Kt);let Qt=class{constructor(H,ge){if(ge&&!(ge instanceof Kt))throw(0,h.$6)("color");if(!j.isRange(H)||H.isEmpty)throw(0,h.$6)("range");this.range=H,this.color=ge}};e.$0N=Qt,e.$0N=Qt=Ye([p],Qt);let pt=class{constructor(H){if(!H||typeof H!="string")throw(0,h.$6)("label");this.label=H}};e.$$N=pt,e.$$N=pt=Ye([p],pt);var Pt;(function(Q){Q[Q.RGB=0]="RGB",Q[Q.HEX=1]="HEX",Q[Q.HSL=2]="HSL"})(Pt||(e.ColorFormat=Pt={}));var ii;(function(Q){Q[Q.Error=0]="Error",Q[Q.Warning=1]="Warning",Q[Q.Information=2]="Information"})(ii||(e.SourceControlInputBoxValidationType=ii={}));var Zt;(function(Q){Q[Q.Unknown=0]="Unknown",Q[Q.Shutdown=1]="Shutdown",Q[Q.Process=2]="Process",Q[Q.User=3]="User",Q[Q.Extension=4]="Extension"})(Zt||(e.TerminalExitReason=Zt={}));var qt;(function(Q){Q[Q.Low=0]="Low",Q[Q.Medium=1]="Medium",Q[Q.High=2]="High"})(qt||(e.TerminalShellExecutionCommandLineConfidence=qt={}));class vt{constructor(H,ge,Le){if(this.startIndex=H,this.length=ge,this.tooltip=Le,typeof H!="number"||H<0)throw(0,h.$6)("startIndex");if(typeof ge!="number"||ge<1)throw(0,h.$6)("length");if(Le!==void 0&&typeof Le!="string")throw(0,h.$6)("tooltip")}}e.$_N=vt;class Nt{constructor(H){this.uri=H}}e.$aO=Nt;class hi{constructor(H){this.terminalCommand=H}}e.$bO=hi;var Vt;(function(Q){Q[Q.Panel=1]="Panel",Q[Q.Editor=2]="Editor"})(Vt||(e.TerminalLocation=Vt={}));class xe{constructor(H){if(this.options=H,typeof H!="object")throw(0,h.$6)("options")}}e.$cO=xe;var xt;(function(Q){Q[Q.Always=1]="Always",Q[Q.Silent=2]="Silent",Q[Q.Never=3]="Never"})(xt||(e.TaskRevealKind=xt={}));var ni;(function(Q){Q[Q.Shared=1]="Shared",Q[Q.Dedicated=2]="Dedicated",Q[Q.New=3]="New"})(ni||(e.TaskPanelKind=ni={}));let di=class{static{E=this}static{this.Clean=new E("clean","Clean")}static{this.Build=new E("build","Build")}static{this.Rebuild=new E("rebuild","Rebuild")}static{this.Test=new E("test","Test")}static from(H){switch(H){case"clean":return E.Clean;case"build":return E.Build;case"rebuild":return E.Rebuild;case"test":return E.Test;default:return}}constructor(H,ge){if(this.label=ge,typeof H!="string"||typeof ge!="string")throw(0,h.$6)("name");this.c=H}get id(){return this.c}};e.$dO=di,e.$dO=di=E=Ye([p],di);function kt(Q){let H="";for(let ge=0;ge<Q.length;ge++)H+=Q[ge].replace(/,/g,",,")+",";return H}let Ft=class{constructor(H,ge,Le){if(typeof H!="string")throw(0,h.$6)("process");this.e=[],this.c=H,ge!==void 0&&(Array.isArray(ge)?(this.e=ge,this.f=Le):this.f=ge)}get process(){return this.c}set process(H){if(typeof H!="string")throw(0,h.$6)("process");this.c=H}get args(){return this.e}set args(H){Array.isArray(H)||(H=[]),this.e=H}get options(){return this.f}set options(H){this.f=H}computeId(){const H=[];if(H.push("process"),this.c!==void 0&&H.push(this.c),this.e&&this.e.length>0)for(const ge of this.e)H.push(ge);return kt(H)}};e.$eO=Ft,e.$eO=Ft=Ye([p],Ft);let Rt=class{constructor(H,ge,Le){if(this.f=[],Array.isArray(ge)){if(!H)throw(0,h.$6)("command can't be undefined or null");if(typeof H!="string"&&typeof H.value!="string")throw(0,h.$6)("command");this.e=H,this.f=ge,this.g=Le}else{if(typeof H!="string")throw(0,h.$6)("commandLine");this.c=H,this.g=ge}}get commandLine(){return this.c}set commandLine(H){if(typeof H!="string")throw(0,h.$6)("commandLine");this.c=H}get command(){return this.e?this.e:""}set command(H){if(typeof H!="string"&&typeof H.value!="string")throw(0,h.$6)("command");this.e=H}get args(){return this.f}set args(H){this.f=H||[]}get options(){return this.g}set options(H){this.g=H}computeId(){const H=[];if(H.push("shell"),this.c!==void 0&&H.push(this.c),this.e!==void 0&&H.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ge of this.f)H.push(typeof ge=="string"?ge:ge.value);return kt(H)}};e.$fO=Rt,e.$fO=Rt=Ye([p],Rt);var Bt;(function(Q){Q[Q.Escape=1]="Escape",Q[Q.Strong=2]="Strong",Q[Q.Weak=3]="Weak"})(Bt||(e.ShellQuoting=Bt={}));var ri;(function(Q){Q[Q.Global=1]="Global",Q[Q.Workspace=2]="Workspace"})(ri||(e.TaskScope=ri={}));class _t{constructor(H){this.c=H}computeId(){return"customExecution"+(0,I.$Yg)()}set callback(H){this.c=H}get callback(){return this.c}}e.$gO=_t;let si=class{static{S=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(H,ge,Le,Ze,st,$t){this.k=!1,this.l=this.definition=H;let Et;typeof ge=="string"?(this.o=this.name=ge,this.w=this.source=Le,this.execution=Ze,Et=st,this.k=!0):ge===ri.Global||ge===ri.Workspace?(this.target=ge,this.o=this.name=Le,this.w=this.source=Ze,this.execution=st,Et=$t):(this.target=ge,this.o=this.name=Le,this.w=this.source=Ze,this.execution=st,Et=$t),typeof Et=="string"?(this.r=[Et],this.t=!0):Array.isArray(Et)?(this.r=Et,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(H){this.j=H}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Ft?this.l={type:S.e,id:this.q.computeId()}:this.q instanceof Rt?this.l={type:S.f,id:this.q.computeId()}:this.q instanceof _t?this.l={type:S.c,id:this.q.computeId()}:this.l={type:S.g,id:(0,I.$Yg)()}}get definition(){return this.l}set definition(H){if(H==null)throw(0,h.$6)("Kind can't be undefined or null");this.B(),this.l=H}get scope(){return this.m}set target(H){this.B(),this.m=H}get name(){return this.o}set name(H){if(typeof H!="string")throw(0,h.$6)("name");this.B(),this.o=H}get execution(){return this.q}set execution(H){H===null&&(H=void 0),this.B(),this.q=H;const ge=this.l.type;(S.g===ge||S.e===ge||S.f===ge||S.c===ge)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(H){if(Array.isArray(H))this.B(),this.r=H,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(H){H!==!0&&H!==!1&&(H=!1),this.B(),this.u=H}get source(){return this.w}set source(H){if(typeof H!="string"||H.length===0)throw(0,h.$6)("source must be a string of length > 0");this.B(),this.w=H}get group(){return this.x}set group(H){H===null&&(H=void 0),this.B(),this.x=H}get detail(){return this.A}set detail(H){H===null&&(H=void 0),this.A=H}get presentationOptions(){return this.y}set presentationOptions(H){H==null&&(H=Object.create(null)),this.B(),this.y=H}get runOptions(){return this.z}set runOptions(H){H==null&&(H=Object.create(null)),this.B(),this.z=H}};e.$hO=si,e.$hO=si=S=Ye([p],si);var Gt;(function(Q){Q[Q.SourceControl=1]="SourceControl",Q[Q.Window=10]="Window",Q[Q.Notification=15]="Notification"})(Gt||(e.ProgressLocation=Gt={}));var Jt;(function(Q){function H(ge){const Le=ge;return(0,b.$gg)(Le.value)?Le.tooltip&&!(0,b.$cg)(Le.tooltip)?(console.log("INVALID view badge, invalid tooltip",Le.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Le.value),!1)}Q.isViewBadge=H})(Jt||(e.ViewBadge=Jt={}));let oi=y=class{static isTreeItem(H,ge){const Le=H;if(Le.checkboxState!==void 0){const Ze=(0,b.$gg)(Le.checkboxState)?Le.checkboxState:(0,b.$eg)(Le.checkboxState)&&(0,b.$gg)(Le.checkboxState.state)?Le.checkboxState.state:void 0,st=!(0,b.$gg)(Le.checkboxState)&&(0,b.$eg)(Le.checkboxState)?Le.checkboxState.tooltip:void 0;if(Ze===void 0||Ze!==St.Checked&&Ze!==St.Unchecked||st!==void 0&&!(0,b.$cg)(st))return console.log("INVALID tree item, invalid checkboxState",Le.checkboxState),!1}if(H instanceof y)return!0;if(Le.label!==void 0&&!(0,b.$cg)(Le.label)&&!Le.label?.label)return console.log("INVALID tree item, invalid label",Le.label),!1;if(Le.id!==void 0&&!(0,b.$cg)(Le.id))return console.log("INVALID tree item, invalid id",Le.id),!1;if(Le.iconPath!==void 0&&!(0,b.$cg)(Le.iconPath)&&!c.URI.isUri(Le.iconPath)&&(!Le.iconPath||!(0,b.$cg)(Le.iconPath.id))){const Ze=Le.iconPath;if(!Ze||!(0,b.$cg)(Ze.light)&&!c.URI.isUri(Ze.light)&&!(0,b.$cg)(Ze.dark)&&!c.URI.isUri(Ze.dark))return console.log("INVALID tree item, invalid iconPath",Le.iconPath),!1}return Le.description!==void 0&&!(0,b.$cg)(Le.description)&&typeof Le.description!="boolean"?(console.log("INVALID tree item, invalid description",Le.description),!1):Le.resourceUri!==void 0&&!c.URI.isUri(Le.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Le.resourceUri),!1):Le.tooltip!==void 0&&!(0,b.$cg)(Le.tooltip)&&!(Le.tooltip instanceof Ke)?(console.log("INVALID tree item, invalid tooltip",Le.tooltip),!1):Le.command!==void 0&&!Le.command.command?(console.log("INVALID tree item, invalid command",Le.command),!1):Le.collapsibleState!==void 0&&Le.collapsibleState<At.None&&Le.collapsibleState>At.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Le.collapsibleState),!1):Le.contextValue!==void 0&&!(0,b.$cg)(Le.contextValue)?(console.log("INVALID tree item, invalid contextValue",Le.contextValue),!1):Le.accessibilityInformation!==void 0&&!Le.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Le.accessibilityInformation),!1):!0}constructor(H,ge=At.None){this.collapsibleState=ge,c.URI.isUri(H)?this.resourceUri=H:this.label=H}};e.$iO=oi,e.$iO=oi=y=Ye([p],oi);var At;(function(Q){Q[Q.None=0]="None",Q[Q.Collapsed=1]="Collapsed",Q[Q.Expanded=2]="Expanded"})(At||(e.TreeItemCollapsibleState=At={}));var St;(function(Q){Q[Q.Unchecked=0]="Unchecked",Q[Q.Checked=1]="Checked"})(St||(e.TreeItemCheckboxState=St={}));let wt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(H){this.value=H}};e.$jO=wt,e.$jO=wt=Ye([p],wt);class ei extends wt{}e.$kO=ei;class It extends ei{#e;constructor(H){super(""),this.#e=H}asFile(){return this.#e}}e.$lO=It;class fi{constructor(H,ge,Le,Ze){this.name=H,this.uri=ge,this._itemId=Le,this.c=Ze}data(){return this.c()}}e.$mO=fi;let Ht=class{#e=new Map;constructor(H){for(const[ge,Le]of H??[]){const Ze=this.#e.get(this.#t(ge));Ze?Ze.push(Le):this.#e.set(this.#t(ge),[Le])}}get(H){return this.#e.get(this.#t(H))?.[0]}set(H,ge){this.#e.set(this.#t(H),[ge])}forEach(H,ge){for(const[Le,Ze]of this.#e)for(const st of Ze)H.call(ge,st,Le,this)}*[Symbol.iterator](){for(const[H,ge]of this.#e)for(const Le of ge)yield[H,Le]}#t(H){return H.toLowerCase()}};e.$nO=Ht,e.$nO=Ht=Ye([p],Ht);let wi=class{constructor(H,ge,Le){this.insertText=H,this.title=ge,this.kind=Le}};e.$oO=wi,e.$oO=wi=Ye([p],wi);var vi;(function(Q){Q[Q.Automatic=0]="Automatic",Q[Q.PasteAs=1]="PasteAs"})(vi||(e.DocumentPasteTriggerKind=vi={}));class gi{static{this.c="."}constructor(H){this.value=H}append(...H){return new gi((this.value?[this.value,...H]:H).join(gi.c))}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+gi.c)}}e.$pO=gi,gi.Empty=new gi("");class jt{constructor(H,ge,Le){this.title=ge,this.insertText=H,this.kind=Le}}e.$qO=jt;let ai=class{constructor(H,ge){this.id=H,this.color=ge}static isThemeIcon(H){return typeof H.id!="string"?(console.log("INVALID ThemeIcon, invalid id",H.id),!1):!0}};e.$rO=ai,e.$rO=ai=Ye([p],ai),ai.File=new ai("file"),ai.Folder=new ai("folder");let Pi=class{constructor(H){this.id=H}};e.$sO=Pi,e.$sO=Pi=Ye([p],Pi);var Tt;(function(Q){Q[Q.Global=1]="Global",Q[Q.Workspace=2]="Workspace",Q[Q.WorkspaceFolder=3]="WorkspaceFolder"})(Tt||(e.ConfigurationTarget=Tt={}));let Si=class{get base(){return this.c}set base(H){this.c=H,this.e=c.URI.file(H)}get baseUri(){return this.e}set baseUri(H){this.e=H,this.c=H.fsPath}constructor(H,ge){if(typeof H!="string"&&(!H||!c.URI.isUri(H)&&!c.URI.isUri(H.uri)))throw(0,h.$6)("base");if(typeof ge!="string")throw(0,h.$6)("pattern");typeof H=="string"?this.baseUri=c.URI.file(H):c.URI.isUri(H)?this.baseUri=H:this.baseUri=H.uri,this.pattern=ge}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$tO=Si,e.$tO=Si=Ye([p],Si);const Ci=new WeakMap;function Di(Q,H){Ci.set(Q,H)}let $i=class{constructor(H,ge,Le,Ze,st){this.enabled=typeof H=="boolean"?H:!0,typeof ge=="string"&&(this.condition=ge),typeof Le=="string"&&(this.hitCondition=Le),typeof Ze=="string"&&(this.logMessage=Ze),typeof st=="string"&&(this.mode=st)}get id(){return this.c||(this.c=Ci.get(this)??(0,I.$Yg)()),this.c}};e.$vO=$i,e.$vO=$i=Ye([p],$i);let Ai=class extends $i{constructor(H,ge,Le,Ze,st,$t){if(super(ge,Le,Ze,st,$t),H===null)throw(0,h.$6)("location");this.location=H}};e.$wO=Ai,e.$wO=Ai=Ye([p],Ai);let Wt=class extends $i{constructor(H,ge,Le,Ze,st,$t){super(ge,Le,Ze,st,$t),this.functionName=H}};e.$xO=Wt,e.$xO=Wt=Ye([p],Wt);let Ae=class extends $i{constructor(H,ge,Le,Ze,st,$t,Et,Xt){if(super(Ze,st,$t,Et,Xt),!ge)throw(0,h.$6)("dataId");this.label=H,this.dataId=ge,this.canPersist=Le}};e.$yO=Ae,e.$yO=Ae=Ye([p],Ae);let Me=class{constructor(H,ge,Le){this.command=H,this.args=ge||[],this.options=Le}};e.$zO=Me,e.$zO=Me=Ye([p],Me);let ve=class{constructor(H,ge){this.port=H,this.host=ge}};e.$AO=ve,e.$AO=ve=Ye([p],ve);let ie=class{constructor(H){this.path=H}};e.$BO=ie,e.$BO=ie=Ye([p],ie);let Re=class{constructor(H){this.implementation=H}};e.$CO=Re,e.$CO=Re=Ye([p],Re);class Qe{constructor(H,ge,Le){this.session=H,this.threadId=ge,this.frameId=Le}}e.$DO=Qe;class it{constructor(H,ge){this.session=H,this.threadId=ge}}e.$EO=it;let Je=class{constructor(H,ge){this.range=H,this.expression=ge}};e.$FO=Je,e.$FO=Je=Ye([p],Je);var ft;(function(Q){Q[Q.Invoke=0]="Invoke",Q[Q.Automatic=1]="Automatic"})(ft||(e.InlineCompletionTriggerKind=ft={}));let Ct=class{constructor(H,ge){this.range=H,this.text=ge}};e.$GO=Ct,e.$GO=Ct=Ye([p],Ct);let Yt=class{constructor(H,ge,Le=!0){this.range=H,this.variableName=ge,this.caseSensitiveLookup=Le}};e.$HO=Yt,e.$HO=Yt=Ye([p],Yt);let ci=class{constructor(H,ge){this.range=H,this.expression=ge}};e.$IO=ci,e.$IO=ci=Ye([p],ci);let Mt=class{constructor(H,ge){this.frameId=H,this.stoppedLocation=ge}};e.$JO=Mt,e.$JO=Mt=Ye([p],Mt);var li;(function(Q){Q[Q.AIGenerated=1]="AIGenerated"})(li||(e.NewSymbolNameTag=li={}));var qi;(function(Q){Q[Q.Invoke=0]="Invoke",Q[Q.Automatic=1]="Automatic"})(qi||(e.NewSymbolNameTriggerKind=qi={}));class pn{constructor(H,ge){this.newSymbolName=H,this.tags=ge}}e.$KO=pn;var Fi;(function(Q){Q[Q.Changed=1]="Changed",Q[Q.Created=2]="Created",Q[Q.Deleted=3]="Deleted"})(Fi||(e.FileChangeType=Fi={}));let Li=k=class extends Error{static FileExists(H){return new k(H,u.FileSystemProviderErrorCode.FileExists,k.FileExists)}static FileNotFound(H){return new k(H,u.FileSystemProviderErrorCode.FileNotFound,k.FileNotFound)}static FileNotADirectory(H){return new k(H,u.FileSystemProviderErrorCode.FileNotADirectory,k.FileNotADirectory)}static FileIsADirectory(H){return new k(H,u.FileSystemProviderErrorCode.FileIsADirectory,k.FileIsADirectory)}static NoPermissions(H){return new k(H,u.FileSystemProviderErrorCode.NoPermissions,k.NoPermissions)}static Unavailable(H){return new k(H,u.FileSystemProviderErrorCode.Unavailable,k.Unavailable)}constructor(H,ge=u.FileSystemProviderErrorCode.Unknown,Le){super(c.URI.isUri(H)?H.toString(!0):H),this.code=Le?.name??"Unknown",(0,u.$ll)(this,ge),Object.setPrototypeOf(this,k.prototype),typeof Error.captureStackTrace=="function"&&typeof Le=="function"&&Error.captureStackTrace(this,Le)}};e.$LO=Li,e.$LO=Li=k=Ye([p],Li);let Vi=class{constructor(H,ge,Le){this.start=H,this.end=ge,this.kind=Le}};e.$MO=Vi,e.$MO=Vi=Ye([p],Vi);var xi;(function(Q){Q[Q.Comment=1]="Comment",Q[Q.Imports=2]="Imports",Q[Q.Region=3]="Region"})(xi||(e.FoldingRangeKind=xi={}));var ki;(function(Q){Q[Q.Collapsed=0]="Collapsed",Q[Q.Expanded=1]="Expanded"})(ki||(e.CommentThreadCollapsibleState=ki={}));var _i;(function(Q){Q[Q.Editing=0]="Editing",Q[Q.Preview=1]="Preview"})(_i||(e.CommentMode=_i={}));var en;(function(Q){Q[Q.Published=0]="Published",Q[Q.Draft=1]="Draft"})(en||(e.CommentState=en={}));var Mi;(function(Q){Q[Q.Unresolved=0]="Unresolved",Q[Q.Resolved=1]="Resolved"})(Mi||(e.CommentThreadState=Mi={}));var tn;(function(Q){Q[Q.Current=0]="Current",Q[Q.Outdated=1]="Outdated"})(tn||(e.CommentThreadApplicability=tn={}));class Gi{constructor(H,ge=[]){this.tokenTypes=H,this.tokenModifiers=ge}}e.$NO=Gi;function nn(Q){return typeof Q>"u"||(0,b.$dg)(Q)}class Hi{constructor(H){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,H){this.m=!0;for(let ge=0,Le=H.tokenTypes.length;ge<Le;ge++)this.k.set(H.tokenTypes[ge],ge);for(let ge=0,Le=H.tokenModifiers.length;ge<Le;ge++)this.l.set(H.tokenModifiers[ge],ge)}}push(H,ge,Le,Ze,st){if(typeof H=="number"&&typeof ge=="number"&&typeof Le=="number"&&typeof Ze=="number"&&(typeof st=="number"||typeof st>"u"))return typeof st>"u"&&(st=0),this.q(H,ge,Le,Ze,st);if(j.isRange(H)&&typeof ge=="string"&&nn(Le))return this.o(H,ge,Le);throw(0,h.$6)()}o(H,ge,Le){if(!this.m)throw new Error("Legend must be provided in constructor");if(H.start.line!==H.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ge))throw new Error("`tokenType` is not in the provided legend");const Ze=H.start.line,st=H.start.character,$t=H.end.character-H.start.character,Et=this.k.get(ge);let Xt=0;if(Le)for(const pi of Le){if(!this.l.has(pi))throw new Error("`tokenModifier` is not in the provided legend");const bi=this.l.get(pi);Xt|=1<<bi>>>0}this.q(Ze,st,$t,Et,Xt)}q(H,ge,Le,Ze,st){if(this.f&&(H<this.c||H===this.c&&ge<this.e)){this.f=!1;const Xt=this.g.length/5|0;let pi=0,bi=0;for(let yi=0;yi<Xt;yi++){let Ii=this.g[5*yi],Xi=this.g[5*yi+1];Ii===0?(Ii=pi,Xi+=bi):Ii+=pi,this.g[5*yi]=Ii,this.g[5*yi+1]=Xi,pi=Ii,bi=Xi}}let $t=H,Et=ge;this.f&&this.j>0&&($t-=this.c,$t===0&&(Et-=this.e)),this.g[this.j++]=$t,this.g[this.j++]=Et,this.g[this.j++]=Le,this.g[this.j++]=Ze,this.g[this.j++]=st,this.c=H,this.e=ge}static r(H){const ge=[],Le=H.length/5|0;for(let Et=0;Et<Le;Et++)ge[Et]=Et;ge.sort((Et,Xt)=>{const pi=H[5*Et],bi=H[5*Xt];if(pi===bi){const yi=H[5*Et+1],Ii=H[5*Xt+1];return yi-Ii}return pi-bi});const Ze=new Uint32Array(H.length);let st=0,$t=0;for(let Et=0;Et<Le;Et++){const Xt=5*ge[Et],pi=H[Xt+0],bi=H[Xt+1],yi=H[Xt+2],Ii=H[Xt+3],Xi=H[Xt+4],Bn=pi-st,Pr=Bn===0?bi-$t:bi,Zi=5*Et;Ze[Zi+0]=Bn,Ze[Zi+1]=Pr,Ze[Zi+2]=yi,Ze[Zi+3]=Ii,Ze[Zi+4]=Xi,st=pi,$t=bi}return Ze}build(H){return this.f?new ji(new Uint32Array(this.g),H):new ji(Hi.r(this.g),H)}}e.$OO=Hi;class ji{constructor(H,ge){this.resultId=ge,this.data=H}}e.$PO=ji;class bn{constructor(H,ge,Le){this.start=H,this.deleteCount=ge,this.data=Le}}e.$QO=bn;class Oi{constructor(H,ge){this.resultId=ge,this.edits=H}}e.$RO=Oi;var rn;(function(Q){Q[Q.Separate=0]="Separate",Q[Q.MergeWithParent=1]="MergeWithParent"})(rn||(e.DebugConsoleMode=rn={}));class wn{constructor(H){this.name=H}}e.$SO=wn;let Ki=class{static{this.Back={iconPath:new ai("arrow-left")}}constructor(){}};e.$TO=Ki,e.$TO=Ki=Ye([p],Ki);var zi;(function(Q){Q[Q.Separator=-1]="Separator",Q[Q.Default=0]="Default"})(zi||(e.QuickPickItemKind=zi={}));var Qi;(function(Q){Q[Q.Info=1]="Info",Q[Q.Warning=2]="Warning",Q[Q.Error=3]="Error"})(Qi||(e.InputBoxValidationSeverity=Qi={}));var qe;(function(Q){Q[Q.UI=1]="UI",Q[Q.Workspace=2]="Workspace"})(qe||(e.ExtensionKind=qe={}));class Ei{static validate(H){if(typeof H.badge=="string"){let ge=(0,R.$Nf)(H.badge,0);if(ge<H.badge.length&&(ge+=(0,R.$Nf)(H.badge,ge)),H.badge.length>ge)throw new Error("The 'badge'-property must be undefined or a short character")}else if(H.badge&&!ai.isThemeIcon(H.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!H.color&&!H.badge&&!H.tooltip)throw new Error("The decoration is empty");return!0}constructor(H,ge,Le){this.badge=H,this.tooltip=ge,this.color=Le}}e.$UO=Ei;let Bi=class{constructor(H){this.kind=H}};e.$VO=Bi,e.$VO=Bi=Ye([p],Bi);var lt;(function(Q){Q[Q.Light=1]="Light",Q[Q.Dark=2]="Dark",Q[Q.HighContrast=3]="HighContrast",Q[Q.HighContrastLight=4]="HighContrastLight"})(lt||(e.ColorThemeKind=lt={}));class bt{static isNotebookRange(H){return H instanceof bt?!0:H?typeof H.start=="number"&&typeof H.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(H,ge){if(H<0)throw(0,h.$6)("start must be positive");if(ge<0)throw(0,h.$6)("end must be positive");H<=ge?(this.c=H,this.e=ge):(this.c=ge,this.e=H)}with(H){let ge=this.c,Le=this.e;return H.start!==void 0&&(ge=H.start),H.end!==void 0&&(Le=H.end),ge===this.c&&Le===this.e?this:new bt(ge,Le)}}e.$WO=bt;class Wi{static validate(H){if(typeof H.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof H.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof H.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(H){return Array.isArray(H)&&H.every(ge=>Wi.isNotebookCellData(ge))}static isNotebookCellData(H){return!0}constructor(H,ge,Le,Ze,st,$t,Et){this.kind=H,this.value=ge,this.languageId=Le,this.mime=Ze,this.outputs=st??[],this.metadata=$t,this.executionSummary=Et,Wi.validate(this)}}e.$XO=Wi;class vn{constructor(H){this.cells=H}}e.$YO=vn;class mi{static isNotebookCellOutputItem(H){return H instanceof mi?!0:H?typeof H.mime=="string"&&H.data instanceof Uint8Array:!1}static error(H){const ge={name:H.name,message:H.message,stack:H.stack};return mi.json(ge,"application/vnd.code.notebook.error")}static stdout(H){return mi.text(H,"application/vnd.code.notebook.stdout")}static stderr(H){return mi.text(H,"application/vnd.code.notebook.stderr")}static bytes(H,ge="application/octet-stream"){return new mi(H,ge)}static#e=new TextEncoder;static text(H,ge=L.$7s.text){const Le=mi.#e.encode(String(H));return new mi(Le,ge)}static json(H,ge="text/x-json"){const Le=JSON.stringify(H,void 0,"	");return mi.text(Le,ge)}constructor(H,ge){this.data=H,this.mime=ge;const Le=(0,L.$$s)(ge,!0);if(!Le)throw new Error(`INVALID mime type: ${ge}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Le}}e.$ZO=mi;class Ui{static isNotebookCellOutput(H){return H instanceof Ui?!0:!H||typeof H!="object"?!1:typeof H.id=="string"&&Array.isArray(H.items)}static ensureUniqueMimeTypes(H,ge=!1){const Le=new Set,Ze=new Set;for(let st=0;st<H.length;st++){const $t=H[st],Et=(0,L.$$s)($t.mime);if(!Le.has(Et)||(0,w.$xL)(Et)){Le.add(Et);continue}Ze.add(st),ge&&console.warn(`DUPLICATED mime type '${$t.mime}' will be dropped`)}return Ze.size===0?H:H.filter((st,$t)=>!Ze.has($t))}constructor(H,ge,Le){this.items=Ui.ensureUniqueMimeTypes(H,!0),typeof ge=="string"?(this.id=ge,this.metadata=Le):(this.id=(0,I.$Yg)(),this.metadata=ge??Le)}}e.$1O=Ui;var Ni;(function(Q){Q[Q.Markup=1]="Markup",Q[Q.Code=2]="Code"})(Ni||(e.NotebookCellKind=Ni={}));var sn;(function(Q){Q[Q.Idle=1]="Idle",Q[Q.Pending=2]="Pending",Q[Q.Executing=3]="Executing"})(sn||(e.NotebookCellExecutionState=sn={}));var on;(function(Q){Q[Q.Left=1]="Left",Q[Q.Right=2]="Right"})(on||(e.NotebookCellStatusBarAlignment=on={}));var an;(function(Q){Q[Q.Default=0]="Default",Q[Q.InCenter=1]="InCenter",Q[Q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",Q[Q.AtTop=3]="AtTop"})(an||(e.NotebookEditorRevealType=an={}));class cn{constructor(H,ge){this.text=H,this.alignment=ge}}e.$2O=cn;var ln;(function(Q){Q[Q.Default=1]="Default",Q[Q.Preferred=2]="Preferred"})(ln||(e.NotebookControllerAffinity=ln={}));var un;(function(Q){Q[Q.Default=1]="Default",Q[Q.Preferred=2]="Preferred",Q[Q.Hidden=-1]="Hidden"})(un||(e.NotebookControllerAffinity2=un={}));class En{constructor(H,ge=[]){this.uri=H,this.provides=(0,r.$1b)(ge)}}e.$3O=En;class yn{constructor(H){this.label=H}}e.$4O=yn;var hn;(function(Q){Q[Q.Named=1]="Named",Q[Q.Indexed=2]="Indexed"})(hn||(e.NotebookVariablesRequestKind=hn={}));let Ji=class{constructor(H,ge){this.label=H,this.timestamp=ge}};e.$5O=Ji,e.$5O=Ji=Ye([p],Ji);var dn;(function(Q){Q[Q.Production=1]="Production",Q[Q.Development=2]="Development",Q[Q.Test=3]="Test"})(dn||(e.ExtensionMode=dn={}));var fn;(function(Q){Q[Q.Node=1]="Node",Q[Q.Webworker=2]="Webworker"})(fn||(e.ExtensionRuntime=fn={}));var gn;(function(Q){Q[Q.Other=0]="Other",Q[Q.Comment=1]="Comment",Q[Q.String=2]="String",Q[Q.RegEx=3]="RegEx"})(gn||(e.StandardTokenType=gn={}));class Sn{constructor(H,ge){this.ranges=H,this.wordPattern=ge}}e.$6O=Sn;class Dn{constructor(H){this.c=H}get autoForwardAction(){return this.c}}e.$7O=Dn;var fe;(function(Q){Q[Q.Queued=1]="Queued",Q[Q.Running=2]="Running",Q[Q.Passed=3]="Passed",Q[Q.Failed=4]="Failed",Q[Q.Skipped=5]="Skipped",Q[Q.Errored=6]="Errored"})(fe||(e.TestResultState=fe={}));var Ee;(function(Q){Q[Q.Run=1]="Run",Q[Q.Debug=2]="Debug",Q[Q.Coverage=3]="Coverage"})(Ee||(e.TestRunProfileKind=Ee={}));let Be=class{constructor(H=void 0,ge=void 0,Le=void 0,Ze=!1,st=!0){this.include=H,this.exclude=ge,this.profile=Le,this.continuous=Ze,this.preserveFocus=st}};e.$8O=Be,e.$8O=Be=Ye([p],Be);let dt=A=class{static diff(H,ge,Le){const Ze=new A(H);return Ze.expectedOutput=ge,Ze.actualOutput=Le,Ze}constructor(H){this.message=H}};e.$9O=dt,e.$9O=dt=A=Ye([p],dt);let yt=class{constructor(H){this.id=H}};e.$0O=yt,e.$0O=yt=Ye([p],yt);class Lt{constructor(H,ge){this.covered=H,this.total=ge,Ri(this)}}e.$$O=Lt;function Ri(Q){if(Q){if(Q.covered>Q.total)throw new Error(`The total number of covered items (${Q.covered}) cannot be greater than the total (${Q.total})`);if(Q.total<0)throw new Error(`The number of covered items (${Q.total}) cannot be negative`)}}class Yi{static fromDetails(H,ge){const Le=new Lt(0,0),Ze=new Lt(0,0),st=new Lt(0,0);for(const Et of ge)if("branches"in Et){Le.total+=1,Le.covered+=Et.executed?1:0;for(const Xt of Et.branches)Ze.total+=1,Ze.covered+=Xt.executed?1:0}else st.total+=1,st.covered+=Et.executed?1:0;const $t=new Yi(H,Le,Ze.total>0?Ze:void 0,st.total>0?st:void 0);return $t.detailedCoverage=ge,$t}constructor(H,ge,Le,Ze,st=[]){this.uri=H,this.statementCoverage=ge,this.branchCoverage=Le,this.declarationCoverage=Ze,this.fromTests=st}}e.$aP=Yi;class qn{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,ge,Le=[]){this.executed=H,this.location=ge,this.branches=Le}}e.$bP=qn;class Vn{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,ge,Le){this.executed=H,this.location=ge,this.label=Le}}e.$cP=Vn;class Gn{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,ge,Le){this.name=H,this.executed=ge,this.location=Le}}e.$dP=Gn;var kn;(function(Q){Q[Q.None=0]="None",Q[Q.Option=1]="Option",Q[Q.Default=2]="Default",Q[Q.Preferred=3]="Preferred"})(kn||(e.ExternalUriOpenerPriority=kn={}));var In;(function(Q){Q[Q.Untrusted=0]="Untrusted",Q[Q.Trusted=1]="Trusted",Q[Q.Unspecified=2]="Unspecified"})(In||(e.WorkspaceTrustState=In={}));var Pn;(function(Q){Q[Q.Notify=1]="Notify",Q[Q.OpenBrowser=2]="OpenBrowser",Q[Q.OpenPreview=3]="OpenPreview",Q[Q.Silent=4]="Silent",Q[Q.Ignore=5]="Ignore",Q[Q.OpenBrowserOnce=6]="OpenBrowserOnce"})(Pn||(e.PortAutoForwardAction=Pn={}));class Hn{constructor(H,ge,Le,Ze,st,$t){this.kind=H,this.name=ge,this.detail=Le,this.uri=Ze,this.range=st,this.selectionRange=$t}}e.$eP=Hn;class Kn{constructor(H){this.uri=H}}e.$fP=Kn;class Qn{constructor(H,ge){this.original=H,this.modified=ge}}e.$gP=Qn;class Jn{constructor(H,ge,Le,Ze){this.base=H,this.input1=ge,this.input2=Le,this.result=Ze}}e.$hP=Jn;class Yn{constructor(H,ge){this.uri=H,this.viewType=ge}}e.$iP=Yn;class Xn{constructor(H){this.viewType=H}}e.$jP=Xn;class Zn{constructor(H,ge){this.uri=H,this.notebookType=ge}}e.$kP=Zn;class xn{constructor(H,ge,Le){this.original=H,this.modified=ge,this.notebookType=Le}}e.$lP=xn;class _n{constructor(){}}e.$mP=_n;class er{constructor(H,ge){this.uri=H,this.inputBoxUri=ge}}e.$nP=er;class tr{constructor(){}}e.$oP=tr;class ir{constructor(H){this.textDiffs=H}}e.$pP=ir;var Cn;(function(Q){Q[Q.Down=0]="Down",Q[Q.Up=1]="Up"})(Cn||(e.InteractiveSessionVoteDirection=Cn={}));var An;(function(Q){Q[Q.Action=1]="Action",Q[Q.Toolbar=2]="Toolbar"})(An||(e.ChatCopyKind=An={}));var Rn;(function(Q){Q[Q.Short=1]="Short",Q[Q.Medium=2]="Medium",Q[Q.Full=3]="Full"})(Rn||(e.ChatVariableLevel=Rn={}));class nr{constructor(H,ge,Le){this.id=H,this.label=ge,this.values=Le}}e.$qP=nr;var Tn;(function(Q){Q[Q.Unhelpful=0]="Unhelpful",Q[Q.Helpful=1]="Helpful",Q[Q.Undone=2]="Undone",Q[Q.Accepted=3]="Accepted",Q[Q.Bug=4]="Bug"})(Tn||(e.InteractiveEditorResponseFeedbackKind=Tn={}));var Ln;(function(Q){Q[Q.Unhelpful=0]="Unhelpful",Q[Q.Helpful=1]="Helpful"})(Ln||(e.ChatResultFeedbackKind=Ln={}));class rr{constructor(H){if(typeof H!="string"&&H.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof H=="string"?new Ke(H):H}}e.$rP=rr;class sr{constructor(H,ge){if(typeof H!="string"&&H.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof H=="string"?new Ke(H):H,this.vulnerabilities=ge}}e.$sP=sr;class or{constructor(H,ge){this.participant=H,this.command=ge}}e.$tP=or;class ar{constructor(H,ge,Le){this.title=H,this.message=ge,this.data=Le}}e.$uP=ar;class cr{constructor(H,ge){this.value=H,this.baseUri=ge}}e.$vP=cr;class lr{constructor(H,ge){this.value=H,this.title=ge}}e.$wP=lr;class ur{constructor(H){this.value=H}}e.$xP=ur;class hr{constructor(H,ge){this.value=H,this.task=ge}}e.$yP=hr;class dr{constructor(H){if(typeof H!="string"&&H.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof H=="string"?new Ke(H):H}}e.$zP=dr;class fr{constructor(H){this.value=H}}e.$AP=fr;class gr{constructor(H,ge){this.value=H,this.iconPath=ge}}e.$BP=gr;class mr{constructor(H,ge){this.uri=H,this.edits=Array.isArray(ge)?ge:[ge]}}e.$CP=mr;class $r{constructor(H,ge,Le,Ze){this.prompt=H,this.command=ge,this.references=Le,this.participant=Ze}}e.$DP=$r;class pr{constructor(H,ge,Le,Ze){this.response=H,this.result=ge,this.participant=Le,this.command=Ze}}e.$EP=pr;var On;(function(Q){Q[Q.Panel=1]="Panel",Q[Q.Terminal=2]="Terminal",Q[Q.Notebook=3]="Notebook",Q[Q.Editor=4]="Editor"})(On||(e.ChatLocation=On={}));class br{constructor(H,ge,Le){this.document=H,this.selection=ge,this.wholeRange=Le}}e.$FP=br;class wr{constructor(H){this.cell=H}}e.$GP=wr;var mn;(function(Q){Q[Q.User=1]="User",Q[Q.Assistant=2]="Assistant",Q[Q.System=3]="System"})(mn||(e.LanguageModelChatMessageRole=mn={}));class vr{constructor(H,ge,Le){this.name=H,this.content=ge,this.isError=Le??!1}}e.$HP=vr;class $n{static User(H,ge){const Le=new $n(mn.User,typeof H=="string"?H:"",ge);return Le.content2=H,Le}static Assistant(H,ge){return new $n(mn.Assistant,H,ge)}constructor(H,ge,Le){this.role=H,this.content=ge,this.content2=ge,this.name=Le}}e.$IP=$n;class Er{constructor(H,ge){this.name=H,this.parameters=ge}}e.$JP=Er;class yr{constructor(H){this.value=H}}e.$KP=yr;class Sr{constructor(H){this.content=H}}e.$LP=Sr;class Dr{constructor(H,ge){this.content=H,this.name=ge}}e.$MP=Dr;class kr{constructor(H,ge){this.content=H,this.name=ge}}e.$NP=kr;class Ti extends Error{static NotFound(H){return new Ti(H,Ti.NotFound.name)}static NoPermissions(H){return new Ti(H,Ti.NoPermissions.name)}static Blocked(H){return new Ti(H,Ti.Blocked.name)}constructor(H,ge,Le){super(H,{cause:Le}),this.name="LanguageModelError",this.code=ge??""}}e.$OP=Ti;var Nn;(function(Q){Q[Q.SymbolInformation=1]="SymbolInformation",Q[Q.CommandInformation=2]="CommandInformation",Q[Q.SearchInformation=3]="SearchInformation",Q[Q.SettingInformation=4]="SettingInformation"})(Nn||(e.RelatedInformationType=Nn={}));var Fn;(function(Q){Q[Q.Started=1]="Started",Q[Q.Recognizing=2]="Recognizing",Q[Q.Recognized=3]="Recognized",Q[Q.Stopped=4]="Stopped",Q[Q.Error=5]="Error"})(Fn||(e.SpeechToTextStatus=Fn={}));var Mn;(function(Q){Q[Q.Started=1]="Started",Q[Q.Stopped=2]="Stopped",Q[Q.Error=3]="Error"})(Mn||(e.TextToSpeechStatus=Mn={}));var jn;(function(Q){Q[Q.Recognized=1]="Recognized",Q[Q.Stopped=2]="Stopped"})(jn||(e.KeywordRecognitionStatus=jn={}));class Ir{constructor(H,ge){this.text=H,this.range=ge}}e.$PP=Ir;var zn;(function(Q){Q[Q.Invoke=0]="Invoke",Q[Q.Automatic=1]="Automatic"})(zn||(e.InlineEditTriggerKind=zn={}))}),define(ke[289],Ie([1,0,6,9]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$moc=void 0;class C{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(r.$sN.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(L,R,b){if(this.a.size===0)throw new Error("No related information providers registered");const c=this.a.get(L);if(!c)throw new Error("related information provider not found");return await c.provideRelatedInformation(R,b)??[]}getRelatedInformation(L,R,b){return this.c.$getAiRelatedInformation(R,b)}registerRelatedInformationProvider(L,R,b){const c=this.b;return this.b++,this.a.set(c,b),this.c.$registerAiRelatedInformationProvider(c,R),new h.$uN(()=>{this.c.$unregisterAiRelatedInformationProvider(c),this.a.delete(c)})}}e.$moc=C}),define(ke[127],Ie([1,0,4,6,9,23,156,5,19]),function(me,e,r,h,C,T,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yoc=e.$xoc=void 0,e.$xoc=(0,R.$Ci)("IExtHostAuthentication");let c=class{constructor(u){this.b=new Map,this.c=new r.$je,this.onDidChangeSessions=this.c.event,this.d=new I,this.a=u.getProxy(h.$sN.MainThreadAuthentication)}async getSession(u,P,w,a={}){const $=T.$nn.toKey(u.identifier),f=[...w].sort().join(" ");return await this.d.getOrCreate(`${$} ${P} ${f}`,async()=>{await this.a.$ensureProvider(P);const g=u.displayName||u.name;return this.a.$getSession(P,w,$,g,a)})}async getAccounts(u){return await this.a.$ensureProvider(u),await this.a.$getAccounts(u)}async removeSession(u,P){const w=this.b.get(u);return w?w.provider.removeSession(P):this.a.$removeSession(u,P)}registerAuthenticationProvider(u,P,w,a){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:P,provider:w,options:a??{supportsMultipleAccounts:!1}});const $=w.onDidChangeSessions(f=>this.a.$sendDidChangeSessions(u,f));return this.a.$registerAuthenticationProvider(u,P,a?.supportsMultipleAccounts??!1),new C.$uN(()=>{$.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}async $createSession(u,P,w){const a=this.b.get(u);if(a)return await a.provider.createSession(P,w);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $removeSession(u,P){const w=this.b.get(u);if(w)return await w.provider.removeSession(P);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $getSessions(u,P,w){const a=this.b.get(u);if(a)return await a.provider.getSessions(P,w);throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,P){return u.startsWith(L.$uM)||this.c.fire({provider:{id:u,label:P}}),Promise.resolve()}};e.$yoc=c,e.$yoc=c=Ye([Ve(0,b.$1P)],c);class I{constructor(){this.a=new Map}getOrCreate(u,P){const w=this.a.get(u);if(w)return w;const a=P().finally(()=>this.a.delete(u));return this.a.set(u,a),a}}}),define(ke[163],Ie([1,0,2,6,9,5,19,11,18,12,16,25]),function(me,e,r,h,C,T,L,R,b,c,I,D){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dpc=e.$Cpc=void 0;let P=class{static{u=this}static{this.c=0}static{this.d=250}constructor(a,$){this.h=$,this.f=new Map,this.g=a.getProxy(h.$sN.MainThreadDecorations)}registerFileDecorationProvider(a,$){const f=u.c++;this.f.set(f,{provider:a,extensionDescription:$}),this.g.$registerDecorationProvider(f,$.identifier.value);const g=a.onDidChangeFileDecorations&&a.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(f,null);return}const o=(0,b.$1b)(i);if(o.length<=u.d){this.g.$onDidChange(f,o);return}this.h.warn("[Decorations] CAPPING events from decorations provider",$.identifier.value,o.length);const t=o.map(d=>({uri:d,rank:(0,c.$gf)(d.path,"/")})),s=(0,b.$yb)(t,(d,l)=>d.rank-l.rank||(0,c.$wf)(d.uri.path,l.uri.path)),n=[];e:for(const d of s){let l;for(const m of d){const E=(0,I.$lc)(m.uri.path);if(l!==E&&(l=E,n.push(m.uri)>=u.d))break e}}this.g.$onDidChange(f,n)});return new C.$uN(()=>{g?.dispose(),this.g.$unregisterDecorationProvider(f),this.f.delete(f)})}async $provideDecorations(a,$,f){if(!this.f.has(a))return Object.create(null);const g=Object.create(null),{provider:i,extensionDescription:o}=this.f.get(a);return await Promise.all($.map(async t=>{try{const{uri:s,id:n}=t,d=await Promise.resolve(i.provideFileDecoration(r.URI.revive(s),f));if(!d)return;try{C.$UO.validate(d),d.badge&&typeof d.badge!="string"&&(0,D.$5G)(o,"codiconDecoration"),g[n]=[d.propagate,d.tooltip,d.badge,d.color]}catch(l){this.h.warn(`INVALID decoration from extension '${o.identifier.value}': ${l}`)}}catch(s){this.h.error(s)}})),g}};e.$Cpc=P,e.$Cpc=P=u=Ye([Ve(0,L.$1P),Ve(1,R.$9j)],P),e.$Dpc=(0,T.$Ci)("IExtHostDecorations")}),define(ke[290],Ie([1,0,13,2,9,6,14,20,12]),function(me,e,r,h,C,T,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fpc=void 0;class c{static{this.a=0}constructor(D,u,P){this.d=u,this.e=P,this.b=new Map,this.c=D.getProxy(T.$sN.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,u){if(Object.keys(L.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const P=c.a++;this.b.set(P,u),this.c.$registerTextContentProvider(P,D);let w;if(typeof u.onDidChange=="function"){let a;w=u.onDidChange(async $=>{if($.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${$.scheme}' which will be IGNORED`);return}if(!this.d.getDocument($))return;a&&await a;const f=this.$provideTextDocumentContent(P,$).then(async g=>{if(!g&&typeof g!="string")return;const i=this.d.getDocument($);if(!i)return;const o=(0,b.$qf)(g);if(!i.equalLines(o))return this.c.$onVirtualDocumentChange($,g)}).catch(r.$Y).finally(()=>{a===f&&(a=void 0)});a=f})}return new C.$uN(()=>{this.b.delete(P)&&this.c.$unregisterTextContentProvider(P),w&&(w.dispose(),w=void 0)})}$provideTextDocumentContent(D,u){const P=this.b.get(D);return P?Promise.resolve(P.provideTextDocumentContent(h.URI.revive(u),R.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$Fpc=c}),define(ke[164],Ie([1,0,65,14,12,205,140,9,18]),function(me,e,r,h,C,T,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5P=e.$4P=void 0,e.$3P=I;const c=new Map;function I(w,a){a?c.set(w,a):c.delete(w)}function D(w){return c.get(w)}class u extends T.$kw{constructor(a,$,f,g,i,o,t){super($,f,g,i),this.c=a,this.m=o,this.q=t,this.b=!1}dispose(){(0,r.ok)(!this.b),this.b=!0,this.q=!1}equalLines(a){return(0,b.$tb)(this.f,a)}get document(){if(!this.a){const a=this;this.a={get uri(){return a.d},get fileName(){return a.d.fsPath},get isUntitled(){return a.d.scheme===h.Schemas.untitled},get languageId(){return a.m},get version(){return a.h},get isClosed(){return a.b},get isDirty(){return a.q},save(){return a.r()},getText($){return $?a.s($):a.getText()},get eol(){return a.g===`
`?R.EndOfLine.LF:R.EndOfLine.CRLF},get lineCount(){return a.f.length},lineAt($){return a.t($)},offsetAt($){return a.u($)},positionAt($){return a.v($)},validateRange($){return a.w($)},validatePosition($){return a.x($)},getWordRangeAtPosition($,f){return a.y($,f)}}}return Object.freeze(this.a)}_acceptLanguageId(a){(0,r.ok)(!this.b),this.m=a}_acceptIsDirty(a){(0,r.ok)(!this.b),this.q=a}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(a){const $=this.w(a);if($.isEmpty)return"";if($.isSingleLine)return this.f[$.start.line].substring($.start.character,$.end.character);const f=this.g,g=$.start.line,i=$.end.line,o=[];o.push(this.f[g].substring($.start.character));for(let t=g+1;t<i;t++)o.push(this.f[t]);return o.push(this.f[i].substring(0,$.end.character)),o.join(f)}t(a){let $;if(a instanceof R.$vN?$=a.line:typeof a=="number"&&($=a),typeof $!="number"||$<0||$>=this.f.length||Math.floor($)!==$)throw new Error("Illegal value for `line`");return new P($,this.f[$],$===this.f.length-1)}u(a){return a=this.x(a),this.l(),this.j.getPrefixSum(a.line-1)+a.character}v(a){a=Math.floor(a),a=Math.max(0,a),this.l();const $=this.j.getIndexOf(a),f=this.f[$.index].length;return new R.$vN($.index,Math.min($.remainder,f))}w(a){if(!(a instanceof R.$wN))throw new Error("Invalid argument");const $=this.x(a.start),f=this.x(a.end);return $===a.start&&f===a.end?a:new R.$wN($.line,$.character,f.line,f.character)}x(a){if(!(a instanceof R.$vN))throw new Error("Invalid argument");if(this.f.length===0)return a.with(0,0);let{line:$,character:f}=a,g=!1;if($<0)$=0,f=0,g=!0;else if($>=this.f.length)$=this.f.length-1,f=this.f[$].length,g=!0;else{const i=this.f[$].length;f<0?(f=0,g=!0):f>i&&(f=i,g=!0)}return g?new R.$vN($,f):a}y(a,$){const f=this.x(a);if(!$)$=D(this.m);else if((0,C.$pf)($))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${$.source}' because it matches the empty string.`);const g=(0,L.$mt)(f.character+1,(0,L.$kt)($),this.f[f.line],0);if(g)return new R.$wN(f.line,g.startColumn-1,f.line,g.endColumn-1)}}e.$4P=u;class P{constructor(a,$,f){this.a=a,this.b=$,this.c=f}get lineNumber(){return this.a}get text(){return this.b}get range(){return new R.$wN(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new R.$wN(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$5P=P}),define(ke[291],Ie([1,0,6,9]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ipc=void 0;class C{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(r.$sN.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(L,R,b){if(this.a.size===0)throw new Error("No embedding vector providers registered");const c=this.a.get(L);if(!c)throw new Error("Embedding vector provider not found");const I=await c.provideEmbeddingVector(R,b);if(!I)throw new Error("Embedding vector provider returned undefined");return I}registerEmbeddingVectorProvider(L,R,b){const c=this.b;return this.b++,this.a.set(c,b),this.c.$registerAiEmbeddingVectorProvider(R,c),new h.$uN(()=>{this.c.$unregisterAiEmbeddingVectorProvider(c),this.a.delete(c)})}}e.$Ipc=C}),define(ke[75],Ie([1,0,6,27,9,21,5,19,62,3,7,22,14]),function(me,e,r,h,C,T,L,R,b,c,I,D,u){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ooc=e.$Noc=void 0,h=Ue(h);let w=P=class{constructor($,f){this.b=new Map,this.c=new I.$Lh,this.a=$.getProxy(r.$sN.MainThreadFileSystem);const g=this;this.value=Object.freeze({async stat(i){try{let o;const t=g.b.get(i.scheme);return t?(await g.a.$ensureActivation(i.scheme),o=await t.impl.stat(i)):o=await g.a.$stat(i),{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions===h.FilePermission.Readonly?1:void 0}}catch(o){P.e(o)}},async readDirectory(i){try{const o=g.b.get(i.scheme);return o?(await g.a.$ensureActivation(i.scheme),(await o.impl.readDirectory(i)).slice()):await g.a.$readdir(i)}catch(o){return P.e(o)}},async createDirectory(i){try{const o=g.b.get(i.scheme);return o&&!o.isReadonly?(await g.a.$ensureActivation(i.scheme),await g.d(o.impl,o.extUri,i)):await g.a.$mkdir(i)}catch(o){return P.e(o)}},async readFile(i){try{const o=g.b.get(i.scheme);return o?(await g.a.$ensureActivation(i.scheme),(await o.impl.readFile(i)).slice()):(await g.a.$readFile(i)).buffer}catch(o){return P.e(o)}},async writeFile(i,o){try{const t=g.b.get(i.scheme);return t&&!t.isReadonly?(await g.a.$ensureActivation(i.scheme),await g.d(t.impl,t.extUri,t.extUri.dirname(i)),await g.c.queueFor(i,()=>Promise.resolve(t.impl.writeFile(i,o,{create:!0,overwrite:!0})))):await g.a.$writeFile(i,T.$Le.wrap(o))}catch(t){return P.e(t)}},async delete(i,o){try{const t=g.b.get(i.scheme);return t&&!t.isReadonly&&!o?.useTrash?(await g.a.$ensureActivation(i.scheme),await t.impl.delete(i,{recursive:!1,...o})):await g.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...o})}catch(t){return P.e(t)}},async rename(i,o,t){try{return await g.a.$rename(i,o,{overwrite:!1,...t})}catch(s){return P.e(s)}},async copy(i,o,t){try{return await g.a.$copy(i,o,{overwrite:!1,...t})}catch(s){return P.e(s)}},isWritableFileSystem(i){const o=f.getCapabilities(i);if(typeof o=="number")return!(o&h.FileSystemProviderCapabilities.Readonly)}})}async d($,f,g){const i=[];for(;!f.isEqual(g,f.dirname(g));)try{if(!((await $.stat(g)).type&h.FileType.Directory))throw C.$LO.FileExists(`Unable to create folder '${g.scheme===u.Schemas.file?g.fsPath:g.toString(!0)}' that already exists but is not a directory`);break}catch(o){if(h.$ml(o)!==h.FileSystemProviderErrorCode.FileNotFound)throw o;i.push(f.basename(g)),g=f.dirname(g)}for(let o=i.length-1;o>=0;o--){g=f.joinPath(g,i[o]);try{await $.createDirectory(g)}catch(t){if(h.$ml(t)!==h.FileSystemProviderErrorCode.FileExists)throw t}}}static e($){if($ instanceof C.$LO)throw $;if($ instanceof h.$il)switch($.code){case h.FileSystemProviderErrorCode.FileExists:throw C.$LO.FileExists($.message);case h.FileSystemProviderErrorCode.FileNotFound:throw C.$LO.FileNotFound($.message);case h.FileSystemProviderErrorCode.FileNotADirectory:throw C.$LO.FileNotADirectory($.message);case h.FileSystemProviderErrorCode.FileIsADirectory:throw C.$LO.FileIsADirectory($.message);case h.FileSystemProviderErrorCode.NoPermissions:throw C.$LO.NoPermissions($.message);case h.FileSystemProviderErrorCode.Unavailable:throw C.$LO.Unavailable($.message);default:throw new C.$LO($.message,$.name)}if(!($ instanceof Error))throw new C.$LO(String($));if($.name==="ENOPRO"||$.message.includes("ENOPRO"))throw C.$LO.Unavailable($.message);switch($.name){case h.FileSystemProviderErrorCode.FileExists:throw C.$LO.FileExists($.message);case h.FileSystemProviderErrorCode.FileNotFound:throw C.$LO.FileNotFound($.message);case h.FileSystemProviderErrorCode.FileNotADirectory:throw C.$LO.FileNotADirectory($.message);case h.FileSystemProviderErrorCode.FileIsADirectory:throw C.$LO.FileIsADirectory($.message);case h.FileSystemProviderErrorCode.NoPermissions:throw C.$LO.NoPermissions($.message);case h.FileSystemProviderErrorCode.Unavailable:throw C.$LO.Unavailable($.message);default:throw new C.$LO($.message,$.name)}}addFileSystemProvider($,f,g){return this.b.set($,{impl:f,extUri:g?.isCaseSensitive?D.$6g:D.$8g,isReadonly:!!g?.isReadonly}),(0,c.$Rc)(()=>this.b.delete($))}getFileSystemProviderExtUri($){return this.b.get($)?.extUri??D.$6g}};e.$Noc=w,e.$Noc=w=P=Ye([Ve(0,R.$1P),Ve(1,b.$roc)],w),e.$Ooc=(0,L.$Ci)("IExtHostConsumerFileSystem")}),define(ke[97],Ie([1,0,5,29,11,75,2]),function(me,e,r,h,C,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qoc=e.$Poc=void 0,e.$Poc=(0,r.$Ci)("IExtensionStoragePaths");let R=class{constructor(c,I,D){this.d=I,this.f=D,this.a=c.workspace??void 0,this.b=c.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(c){return L.URI.joinPath(this.b.workspaceStorageHome,c)}async h(){if(!this.a)return Promise.resolve(void 0);const c=this.a.id,I=await this.g(c);try{return await this.f.value.stat(I),this.d.trace("[ExtHostStorage] storage dir already exists",I),I}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",I),await this.f.value.createDirectory(I),await this.f.value.writeFile(L.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:L.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),I}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(c){if(this.c)return L.URI.joinPath(this.c,c.identifier.value)}globalValue(c){return L.URI.joinPath(this.b.globalStorageHome,c.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Qoc=R,e.$Qoc=R=Ye([Ve(0,h.$eQ),Ve(1,C.$9j),Ve(2,T.$Ooc)],R)}),define(ke[292],Ie([1,0,9,19,4]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nqc=void 0;let T=class{constructor(R){this.a=new r.$VO(r.ColorThemeKind.Dark),this.b=new C.$je}get activeColorTheme(){return this.a}$onColorThemeChange(R){let b;switch(R){case"light":b=r.ColorThemeKind.Light;break;case"hcDark":b=r.ColorThemeKind.HighContrast;break;case"hcLight":b=r.ColorThemeKind.HighContrastLight;break;default:b=r.ColorThemeKind.Dark}this.a=new r.$VO(b),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$nqc=T,e.$nqc=T=Ye([Ve(0,h.$1P)],T)}),define(ke[76],Ie([1,0,20,4,3,8,5,11,92,6,29,19,9]),function(me,e,r,h,C,T,L,R,b,c,I,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TFb=e.$SFb=e.TunnelDtoConverter=void 0,T=Ue(T),u=Ue(u);class P extends b.$Jw{}var w;(function($){function f(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?b.TunnelPrivacyId.Public:b.TunnelPrivacyId.Private),protocol:i.protocol}}$.fromApiTunnel=f;function g(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==b.TunnelPrivacyId.ConstantPrivate&&i.privacy!==b.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}$.fromServiceTunnel=g})(w||(e.TunnelDtoConverter=w={})),e.$SFb=(0,L.$Ci)("IExtHostTunnelService");let a=class extends C.$Tc{constructor(f,g,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new h.$je,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=f.getProxy(c.$sN.MainThreadTunnelService)}async openTunnel(f,g){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${f.identifier.value} called openTunnel API for ${g.remoteAddress.host}:${g.remoteAddress.port}.`);const i=await this.a.$openTunnel(g,f.displayName);if(i){const o=new P(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(o),o}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(f,g){f.portRange===void 0&&f.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:f,provider:g}),this.a.$registerPortsAttributesProvider(f,i),new u.$uN(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(f,g,i,o,t){const s=[];for(const d of f){const l=this.r.get(d);if(!l)return[];s.push(...await Promise.all(g.map(async m=>{let E;try{E=await l.provider.providePortAttributes({port:m,pid:i,commandLine:o},t)}catch{E=await l.provider.providePortAttributes(m,i,o,t)}return{providedAttributes:E,port:m}})))}const n=s.filter(d=>!!d.providedAttributes);return n.length>0?n.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder(f){}registerTunnelProvider(f,g){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(o,t)=>await f.provideTunnel(o,t,r.CancellationToken.None)??void 0;const i=g.tunnelFeatures?{elevation:!!g.tunnelFeatures?.elevation,privacyOptions:g.tunnelFeatures?.privacyOptions,protocol:g.tunnelFeatures.protocol===void 0?!0:g.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,C.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(f,g){if(f){f.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(f.candidatePortSource),f.showCandidatePort&&(this.f=f.showCandidatePort,this.a.$setCandidateFilter());const i=f.tunnelFactory??(g?this.w(g):void 0);if(i){this.b=i;let o=f.tunnelFeatures?.privacyOptions??[];f.tunnelFeatures?.public&&o.length===0&&(o=[{id:"private",label:T.localize(10656,null),themeIcon:"lock"},{id:"public",label:T.localize(10657,null),themeIcon:"eye"}]);const t=f.tunnelFeatures?{elevation:!!f.tunnelFeatures?.elevation,public:!!f.tunnelFeatures?.public,privacyOptions:o,protocol:!0}:void 0;this.a.$setTunnelProvider(t)}}else this.b=void 0;return(0,C.$Rc)(()=>{this.b=void 0})}w(f){}async $closeTunnel(f,g){if(this.g.has(f.host)){const i=this.g.get(f.host);i.has(f.port)&&(g&&i.get(f.port).disposeListener.dispose(),await i.get(f.port).tunnel.dispose(),i.delete(f.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(f,g){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(f,g);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const o=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),o===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(f.remoteAddress.host)||this.g.set(f.remoteAddress.host,new Map);const t=this.B(o.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(o.remoteAddress))));return this.g.get(f.remoteAddress.host).set(f.remoteAddress.port,{tunnel:o,disposeListener:t}),w.fromApiTunnel(o)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(f){const g=await Promise.all(f.map(o=>this.f(o.host,o.port,o.detail??""))),i=f.filter((o,t)=>g[t]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${f.map(o=>o.port).join(", ")} to ${i.map(o=>o.port).join(", ")}`),i}};e.$TFb=a,e.$TFb=a=Ye([Ve(0,D.$1P),Ve(1,I.$eQ),Ve(2,R.$9j)],a)}),define(ke[15],Ie([1,0,18,21,189,79,85,28,177,51,103,24,182,22,50,17,2,113,30,110,87,58,145,89,155,152,153,270,119,126,73,74,267,9]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a,$,f,g,i,o,t,s,n,d,l,m,E,S,y,k,A,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$XP=ee,e.$YP=re,e.$ZP=ye,L=Ue(L),g=Ue(g),i=Ue(i),o=Ue(o),E=Ue(E),y=Ue(y),v=Ue(v);var F;(function(Ae){function Me(ie){const{selectionStartLineNumber:Re,selectionStartColumn:Qe,positionLineNumber:it,positionColumn:Je}=ie,ft=new v.$vN(Re-1,Qe-1),Ct=new v.$vN(it-1,Je-1);return new v.$xN(ft,Ct)}Ae.to=Me;function ve(ie){const{anchor:Re,active:Qe}=ie;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:Qe.line+1,positionColumn:Qe.character+1}}Ae.from=ve})(F||(e.Selection=F={}));var N;(function(Ae){function Me(ie){if(!ie)return;const{start:Re,end:Qe}=ie;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:Qe.line+1,endColumn:Qe.character+1}}Ae.from=Me;function ve(ie){if(!ie)return;const{startLineNumber:Re,startColumn:Qe,endLineNumber:it,endColumn:Je}=ie;return new v.$wN(Re-1,Qe-1,it-1,Je-1)}Ae.to=ve})(N||(e.Range=N={}));var O;(function(Ae){function Me(ie){return{uri:ie.uri,range:N.from(ie.range)}}Ae.from=Me;function ve(ie){return new v.$GN($.URI.revive(ie.uri),N.to(ie.range))}Ae.to=ve})(O||(e.Location=O={}));var j;(function(Ae){function Me(ve){switch(ve){case i.StandardTokenType.Comment:return v.StandardTokenType.Comment;case i.StandardTokenType.Other:return v.StandardTokenType.Other;case i.StandardTokenType.RegEx:return v.StandardTokenType.RegEx;case i.StandardTokenType.String:return v.StandardTokenType.String}}Ae.to=Me})(j||(e.TokenType=j={}));var z;(function(Ae){function Me(ie){return new v.$vN(ie.lineNumber-1,ie.column-1)}Ae.to=Me;function ve(ie){return{lineNumber:ie.line+1,column:ie.character+1}}Ae.from=ve})(z||(e.Position=z={}));var M;(function(Ae){function Me(Re,Qe,it){return(0,r.$Gb)((0,r.$1b)(Re).map(Je=>ve(Je,Qe,it)))}Ae.from=Me;function ve(Re,Qe,it){if(typeof Re=="string")return{$serialized:!0,language:Re,isBuiltin:it?.isBuiltin};if(Re)return{$serialized:!0,language:Re.language,scheme:ie(Re.scheme,Qe),pattern:et.from(Re.pattern)??void 0,exclusive:Re.exclusive,notebookType:Re.notebookType,isBuiltin:it?.isBuiltin}}function ie(Re,Qe){return Qe&&typeof Re=="string"?Qe.transformOutgoingScheme(Re):Re}})(M||(e.DocumentSelector=M={}));var V;(function(Ae){function Me(ie){switch(ie){case v.DiagnosticTag.Unnecessary:return s.MarkerTag.Unnecessary;case v.DiagnosticTag.Deprecated:return s.MarkerTag.Deprecated}}Ae.from=Me;function ve(ie){switch(ie){case s.MarkerTag.Unnecessary:return v.DiagnosticTag.Unnecessary;case s.MarkerTag.Deprecated:return v.DiagnosticTag.Deprecated;default:return}}Ae.to=ve})(V||(e.DiagnosticTag=V={}));var K;(function(Ae){function Me(ie){let Re;return ie.code&&((0,a.$cg)(ie.code)||(0,a.$gg)(ie.code)?Re=String(ie.code):Re={value:String(ie.code.value),target:ie.code.target}),{...N.from(ie.range),message:ie.message,source:ie.source,code:Re,severity:B.from(ie.severity),relatedInformation:ie.relatedInformation&&ie.relatedInformation.map(ne.from),tags:Array.isArray(ie.tags)?(0,r.$Gb)(ie.tags.map(V.from)):void 0}}Ae.from=Me;function ve(ie){const Re=new v.$IN(N.to(ie),ie.message,B.to(ie.severity));return Re.source=ie.source,Re.code=(0,a.$cg)(ie.code)?ie.code:ie.code?.value,Re.relatedInformation=ie.relatedInformation&&ie.relatedInformation.map(ne.to),Re.tags=ie.tags&&(0,r.$Gb)(ie.tags.map(V.to)),Re}Ae.to=ve})(K||(e.Diagnostic=K={}));var ne;(function(Ae){function Me(ie){return{...N.from(ie.location.range),message:ie.message,resource:ie.location.uri}}Ae.from=Me;function ve(ie){return new v.$HN(new v.$GN(ie.resource,N.to(ie)),ie.message)}Ae.to=ve})(ne||(e.DiagnosticRelatedInformation=ne={}));var B;(function(Ae){function Me(ie){switch(ie){case v.DiagnosticSeverity.Error:return s.MarkerSeverity.Error;case v.DiagnosticSeverity.Warning:return s.MarkerSeverity.Warning;case v.DiagnosticSeverity.Information:return s.MarkerSeverity.Info;case v.DiagnosticSeverity.Hint:return s.MarkerSeverity.Hint}return s.MarkerSeverity.Error}Ae.from=Me;function ve(ie){switch(ie){case s.MarkerSeverity.Info:return v.DiagnosticSeverity.Information;case s.MarkerSeverity.Warning:return v.DiagnosticSeverity.Warning;case s.MarkerSeverity.Error:return v.DiagnosticSeverity.Error;case s.MarkerSeverity.Hint:return v.DiagnosticSeverity.Hint;default:return v.DiagnosticSeverity.Error}}Ae.to=ve})(B||(e.DiagnosticSeverity=B={}));var G;(function(Ae){function Me(ie){return typeof ie=="number"&&ie>=v.ViewColumn.One?ie-1:ie===v.ViewColumn.Beside?p.$nE:p.$mE}Ae.from=Me;function ve(ie){if(typeof ie=="number"&&ie>=0)return ie+1;throw new Error("invalid 'EditorGroupColumn'")}Ae.to=ve})(G||(e.ViewColumn=G={}));function Y(Ae){return typeof Ae.range<"u"}function ee(Ae){return Ae.length===0?!0:!!Y(Ae[0])}var ue;(function(Ae){function Me(Je){return Je.map(Ae.from)}Ae.fromMany=Me;function ve(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function ie(Je){let ft;if(ve(Je)){const{language:Mt,value:li}=Je;ft={value:"```"+Mt+`
`+li+"\n```\n"}}else v.$WN.isMarkdownString(Je)?ft={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?ft={value:Je}:ft={value:""};const Ct=Object.create(null);ft.uris=Ct;const Yt=Mt=>{try{let li=$.URI.parse(Mt,!0);li=li.with({query:Re(li.query,Ct)}),Ct[Mt]=li}catch{}return""},ci=new b.marked.Renderer;return ci.link=Yt,ci.image=Mt=>typeof Mt=="string"?Yt(L.$8k(Mt).href):"",(0,b.marked)(ft.value,{renderer:ci}),ft}Ae.from=ie;function Re(Je,ft){if(!Je)return Je;let Ct;try{Ct=(0,c.$$h)(Je)}catch{}if(!Ct)return Je;let Yt=!1;return Ct=(0,D.$co)(Ct,ci=>{if($.URI.isUri(ci)){const Mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ft[Mt]=ci,Yt=!0,Mt}else return}),Yt?JSON.stringify(Ct):Je}function Qe(Je){const ft=new v.$WN(Je.value,Je.supportThemeIcons);return ft.isTrusted=Je.isTrusted,ft.supportHtml=Je.supportHtml,ft.baseUri=Je.baseUri?$.URI.from(Je.baseUri):void 0,ft}Ae.to=Qe;function it(Je){if(Je)return typeof Je=="string"?Je:Ae.from(Je)}Ae.fromStrict=it})(ue||(e.MarkdownString=ue={}));function re(Ae){return ee(Ae)?Ae.map(Me=>({range:N.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?ue.fromMany(Me.hoverMessage):Me.hoverMessage?ue.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):Ae.map(Me=>({range:N.from(Me)}))}function ye(Ae){return typeof Ae>"u"?Ae:typeof Ae=="string"?$.URI.file(Ae):Ae}var $e;(function(Ae){function Me(ve){return typeof ve>"u"?ve:{contentText:ve.contentText,contentIconPath:ve.contentIconPath?ye(ve.contentIconPath):void 0,border:ve.border,borderColor:ve.borderColor,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,color:ve.color,backgroundColor:ve.backgroundColor,margin:ve.margin,width:ve.width,height:ve.height}}Ae.from=Me})($e||(e.ThemableDecorationAttachmentRenderOptions=$e={}));var J;(function(Ae){function Me(ve){return typeof ve>"u"?ve:{backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?ye(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?$e.from(ve.before):void 0,after:ve.after?$e.from(ve.after):void 0}}Ae.from=Me})(J||(e.ThemableDecorationRenderOptions=J={}));var W;(function(Ae){function Me(ve){if(typeof ve>"u")return ve;switch(ve){case v.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case v.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case v.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case v.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}Ae.from=Me})(W||(e.DecorationRangeBehavior=W={}));var se;(function(Ae){function Me(ve){return{isWholeLine:ve.isWholeLine,rangeBehavior:ve.rangeBehavior?W.from(ve.rangeBehavior):void 0,overviewRulerLane:ve.overviewRulerLane,light:ve.light?J.from(ve.light):void 0,dark:ve.dark?J.from(ve.dark):void 0,backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?ye(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?$e.from(ve.before):void 0,after:ve.after?$e.from(ve.after):void 0}}Ae.from=Me})(se||(e.DecorationRenderOptions=se={}));var ae;(function(Ae){function Me(ie){return{text:ie.newText,eol:ie.newEol&&je.from(ie.newEol),range:N.from(ie.range)}}Ae.from=Me;function ve(ie){const Re=new v.$BN(N.to(ie.range),ie.text);return Re.newEol=typeof ie.eol>"u"?void 0:je.to(ie.eol),Re}Ae.to=ve})(ae||(e.TextEdit=ae={}));var te;(function(Ae){function Me(ie,Re){const Qe={edits:[]};if(ie instanceof v.$EN){const it=new R.$Ac;for(const Je of ie._allEntries())Je._type===v.FileEditType.File&&$.URI.isUri(Je.to)&&Je.from===void 0&&it.add(Je.to);for(const Je of ie._allEntries())if(Je._type===v.FileEditType.File){let ft;Je.options?.contents&&(ArrayBuffer.isView(Je.options.contents)?ft={type:"base64",value:(0,h.$6e)(h.$Le.wrap(Je.options.contents))}:ft={type:"dataTransferItem",id:Je.options.contents._itemId}),Qe.edits.push({oldResource:Je.from,newResource:Je.to,options:{...Je.options,contents:ft},metadata:Je.metadata})}else Je._type===v.FileEditType.Text?Qe.edits.push({resource:Je.uri,textEdit:ae.from(Je.edit),versionId:it.has(Je.uri)?void 0:Re?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===v.FileEditType.Snippet?Qe.edits.push({resource:Je.uri,textEdit:{range:N.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:it.has(Je.uri)?void 0:Re?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===v.FileEditType.Cell?Qe.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Re?.getNotebookDocumentVersion(Je.uri)}):Je._type===v.FileEditType.CellReplace&&Qe.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Re?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:y.CellEditType.Replace,index:Je.index,count:Je.count,cells:Je.cells.map(_e.from)}})}return Qe}Ae.from=Me;function ve(ie){const Re=new v.$EN,Qe=new R.$zc;for(const it of ie.edits)if(it.textEdit){const Je=it,ft=$.URI.revive(Je.resource),Ct=N.to(Je.textEdit.range),Yt=Je.textEdit.text,ci=Je.textEdit.insertAsSnippet;let Mt;ci?Mt=v.$DN.replace(Ct,new v.$FN(Yt)):Mt=v.$BN.replace(Ct,Yt);const li=Qe.get(ft);li?li.push(Mt):Qe.set(ft,[Mt])}else Re.renameFile($.URI.revive(it.oldResource),$.URI.revive(it.newResource),it.options);for(const[it,Je]of Qe)Re.set(it,Je);return Re}Ae.to=ve})(te||(e.WorkspaceEdit=te={}));var ce;(function(Ae){const Me=Object.create(null);Me[v.SymbolKind.File]=o.SymbolKind.File,Me[v.SymbolKind.Module]=o.SymbolKind.Module,Me[v.SymbolKind.Namespace]=o.SymbolKind.Namespace,Me[v.SymbolKind.Package]=o.SymbolKind.Package,Me[v.SymbolKind.Class]=o.SymbolKind.Class,Me[v.SymbolKind.Method]=o.SymbolKind.Method,Me[v.SymbolKind.Property]=o.SymbolKind.Property,Me[v.SymbolKind.Field]=o.SymbolKind.Field,Me[v.SymbolKind.Constructor]=o.SymbolKind.Constructor,Me[v.SymbolKind.Enum]=o.SymbolKind.Enum,Me[v.SymbolKind.Interface]=o.SymbolKind.Interface,Me[v.SymbolKind.Function]=o.SymbolKind.Function,Me[v.SymbolKind.Variable]=o.SymbolKind.Variable,Me[v.SymbolKind.Constant]=o.SymbolKind.Constant,Me[v.SymbolKind.String]=o.SymbolKind.String,Me[v.SymbolKind.Number]=o.SymbolKind.Number,Me[v.SymbolKind.Boolean]=o.SymbolKind.Boolean,Me[v.SymbolKind.Array]=o.SymbolKind.Array,Me[v.SymbolKind.Object]=o.SymbolKind.Object,Me[v.SymbolKind.Key]=o.SymbolKind.Key,Me[v.SymbolKind.Null]=o.SymbolKind.Null,Me[v.SymbolKind.EnumMember]=o.SymbolKind.EnumMember,Me[v.SymbolKind.Struct]=o.SymbolKind.Struct,Me[v.SymbolKind.Event]=o.SymbolKind.Event,Me[v.SymbolKind.Operator]=o.SymbolKind.Operator,Me[v.SymbolKind.TypeParameter]=o.SymbolKind.TypeParameter;function ve(Re){return typeof Me[Re]=="number"?Me[Re]:o.SymbolKind.Property}Ae.from=ve;function ie(Re){for(const Qe in Me)if(Me[Qe]===Re)return Number(Qe);return v.SymbolKind.Property}Ae.to=ie})(ce||(e.SymbolKind=ce={}));var le;(function(Ae){function Me(ie){switch(ie){case v.SymbolTag.Deprecated:return o.SymbolTag.Deprecated}}Ae.from=Me;function ve(ie){switch(ie){case o.SymbolTag.Deprecated:return v.SymbolTag.Deprecated}}Ae.to=ve})(le||(e.SymbolTag=le={}));var Z;(function(Ae){function Me(ie){return{name:ie.name,kind:ce.from(ie.kind),tags:ie.tags&&ie.tags.map(le.from),containerName:ie.containerName,location:We.from(ie.location)}}Ae.from=Me;function ve(ie){const Re=new v.$NN(ie.name,ce.to(ie.kind),ie.containerName,We.to(ie.location));return Re.tags=ie.tags&&ie.tags.map(le.to),Re}Ae.to=ve})(Z||(e.WorkspaceSymbol=Z={}));var oe;(function(Ae){function Me(ie){const Re={name:ie.name||"!!MISSING: name!!",detail:ie.detail,range:N.from(ie.range),selectionRange:N.from(ie.selectionRange),kind:ce.from(ie.kind),tags:ie.tags?.map(le.from)??[]};return ie.children&&(Re.children=ie.children.map(Me)),Re}Ae.from=Me;function ve(ie){const Re=new v.$ON(ie.name,ie.detail,ce.to(ie.kind),N.to(ie.range),N.to(ie.selectionRange));return(0,r.$Kb)(ie.tags)&&(Re.tags=ie.tags.map(le.to)),ie.children&&(Re.children=ie.children.map(ve)),Re}Ae.to=ve})(oe||(e.DocumentSymbol=oe={}));var pe;(function(Ae){function Me(ie){const Re=new v.$SN(ce.to(ie.kind),ie.name,ie.detail||"",$.URI.revive(ie.uri),N.to(ie.range),N.to(ie.selectionRange));return Re._sessionId=ie._sessionId,Re._itemId=ie._itemId,Re}Ae.to=Me;function ve(ie,Re,Qe){if(Re=Re??ie._sessionId,Qe=Qe??ie._itemId,Re===void 0||Qe===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Qe,name:ie.name,detail:ie.detail,kind:ce.from(ie.kind),uri:ie.uri,range:N.from(ie.range),selectionRange:N.from(ie.selectionRange),tags:ie.tags?.map(le.from)}}Ae.from=ve})(pe||(e.CallHierarchyItem=pe={}));var we;(function(Ae){function Me(ve){return new v.$TN(pe.to(ve.from),ve.fromRanges.map(ie=>N.to(ie)))}Ae.to=Me})(we||(e.CallHierarchyIncomingCall=we={}));var Fe;(function(Ae){function Me(ve){return new v.$UN(pe.to(ve.to),ve.fromRanges.map(ie=>N.to(ie)))}Ae.to=Me})(Fe||(e.CallHierarchyOutgoingCall=Fe={}));var We;(function(Ae){function Me(ie){return{range:ie.range&&N.from(ie.range),uri:ie.uri}}Ae.from=Me;function ve(ie){return new v.$GN($.URI.revive(ie.uri),N.to(ie.range))}Ae.to=ve})(We||(e.location=We={}));var Se;(function(Ae){function Me(ie){const Re=ie,Qe=ie;return{originSelectionRange:Re.originSelectionRange?N.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:Qe.uri,range:N.from(Re.targetRange?Re.targetRange:Qe.range),targetSelectionRange:Re.targetSelectionRange?N.from(Re.targetSelectionRange):void 0}}Ae.from=Me;function ve(ie){return{targetUri:$.URI.revive(ie.uri),targetRange:N.to(ie.range),targetSelectionRange:ie.targetSelectionRange?N.to(ie.targetSelectionRange):void 0,originSelectionRange:ie.originSelectionRange?N.to(ie.originSelectionRange):void 0}}Ae.to=ve})(Se||(e.DefinitionLink=Se={}));var De;(function(Ae){function Me(ie){return{range:N.from(ie.range),contents:ue.fromMany(ie.contents),canIncreaseVerbosity:ie.canIncreaseVerbosity,canDecreaseVerbosity:ie.canDecreaseVerbosity}}Ae.from=Me;function ve(ie){const Re=ie.contents.map(ue.to),Qe=N.to(ie.range),it=ie.canIncreaseVerbosity,Je=ie.canDecreaseVerbosity;return new v.$KN(Re,Qe,it,Je)}Ae.to=ve})(De||(e.Hover=De={}));var Te;(function(Ae){function Me(ie){return{range:N.from(ie.range),expression:ie.expression}}Ae.from=Me;function ve(ie){return new v.$FO(N.to(ie.range),ie.expression)}Ae.to=ve})(Te||(e.EvaluatableExpression=Te={}));var U;(function(Ae){function Me(ie){if(ie instanceof v.$GO)return{type:"text",range:N.from(ie.range),text:ie.text};if(ie instanceof v.$HO)return{type:"variable",range:N.from(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};if(ie instanceof v.$IO)return{type:"expression",range:N.from(ie.range),expression:ie.expression};throw new Error("Unknown 'InlineValue' type")}Ae.from=Me;function ve(ie){switch(ie.type){case"text":return{range:N.to(ie.range),text:ie.text};case"variable":return{range:N.to(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};case"expression":return{range:N.to(ie.range),expression:ie.expression}}}Ae.to=ve})(U||(e.InlineValue=U={}));var q;(function(Ae){function Me(ie){return{frameId:ie.frameId,stoppedLocation:N.from(ie.stoppedLocation)}}Ae.from=Me;function ve(ie){return new v.$JO(ie.frameId,N.to(ie.stoppedLocation))}Ae.to=ve})(q||(e.InlineValueContext=q={}));var X;(function(Ae){function Me(ie){return{range:N.from(ie.range),kind:ie.kind}}Ae.from=Me;function ve(ie){return new v.$LN(N.to(ie.range),ie.kind)}Ae.to=ve})(X||(e.DocumentHighlight=X={}));var _;(function(Ae){function Me(ie){return{uri:ie.uri,highlights:ie.highlights.map(X.from)}}Ae.from=Me;function ve(ie){return new v.$MN($.URI.revive(ie.uri),ie.highlights.map(X.to))}Ae.to=ve})(_||(e.MultiDocumentHighlight=_={}));var de;(function(Ae){function Me(ve){switch(ve){case o.CompletionTriggerKind.TriggerCharacter:return v.CompletionTriggerKind.TriggerCharacter;case o.CompletionTriggerKind.TriggerForIncompleteCompletions:return v.CompletionTriggerKind.TriggerForIncompleteCompletions;case o.CompletionTriggerKind.Invoke:default:return v.CompletionTriggerKind.Invoke}}Ae.to=Me})(de||(e.CompletionTriggerKind=de={}));var be;(function(Ae){function Me(ve){return{triggerKind:de.to(ve.triggerKind),triggerCharacter:ve.triggerCharacter}}Ae.to=Me})(be||(e.CompletionContext=be={}));var Ne;(function(Ae){function Me(ie){switch(ie){case v.CompletionItemTag.Deprecated:return o.CompletionItemTag.Deprecated}}Ae.from=Me;function ve(ie){switch(ie){case o.CompletionItemTag.Deprecated:return v.CompletionItemTag.Deprecated}}Ae.to=ve})(Ne||(e.CompletionItemTag=Ne={}));var Ge;(function(Ae){const Me=new Map([[v.CompletionItemKind.Method,o.CompletionItemKind.Method],[v.CompletionItemKind.Function,o.CompletionItemKind.Function],[v.CompletionItemKind.Constructor,o.CompletionItemKind.Constructor],[v.CompletionItemKind.Field,o.CompletionItemKind.Field],[v.CompletionItemKind.Variable,o.CompletionItemKind.Variable],[v.CompletionItemKind.Class,o.CompletionItemKind.Class],[v.CompletionItemKind.Interface,o.CompletionItemKind.Interface],[v.CompletionItemKind.Struct,o.CompletionItemKind.Struct],[v.CompletionItemKind.Module,o.CompletionItemKind.Module],[v.CompletionItemKind.Property,o.CompletionItemKind.Property],[v.CompletionItemKind.Unit,o.CompletionItemKind.Unit],[v.CompletionItemKind.Value,o.CompletionItemKind.Value],[v.CompletionItemKind.Constant,o.CompletionItemKind.Constant],[v.CompletionItemKind.Enum,o.CompletionItemKind.Enum],[v.CompletionItemKind.EnumMember,o.CompletionItemKind.EnumMember],[v.CompletionItemKind.Keyword,o.CompletionItemKind.Keyword],[v.CompletionItemKind.Snippet,o.CompletionItemKind.Snippet],[v.CompletionItemKind.Text,o.CompletionItemKind.Text],[v.CompletionItemKind.Color,o.CompletionItemKind.Color],[v.CompletionItemKind.File,o.CompletionItemKind.File],[v.CompletionItemKind.Reference,o.CompletionItemKind.Reference],[v.CompletionItemKind.Folder,o.CompletionItemKind.Folder],[v.CompletionItemKind.Event,o.CompletionItemKind.Event],[v.CompletionItemKind.Operator,o.CompletionItemKind.Operator],[v.CompletionItemKind.TypeParameter,o.CompletionItemKind.TypeParameter],[v.CompletionItemKind.Issue,o.CompletionItemKind.Issue],[v.CompletionItemKind.User,o.CompletionItemKind.User]]);function ve(Qe){return Me.get(Qe)??o.CompletionItemKind.Property}Ae.from=ve;const ie=new Map([[o.CompletionItemKind.Method,v.CompletionItemKind.Method],[o.CompletionItemKind.Function,v.CompletionItemKind.Function],[o.CompletionItemKind.Constructor,v.CompletionItemKind.Constructor],[o.CompletionItemKind.Field,v.CompletionItemKind.Field],[o.CompletionItemKind.Variable,v.CompletionItemKind.Variable],[o.CompletionItemKind.Class,v.CompletionItemKind.Class],[o.CompletionItemKind.Interface,v.CompletionItemKind.Interface],[o.CompletionItemKind.Struct,v.CompletionItemKind.Struct],[o.CompletionItemKind.Module,v.CompletionItemKind.Module],[o.CompletionItemKind.Property,v.CompletionItemKind.Property],[o.CompletionItemKind.Unit,v.CompletionItemKind.Unit],[o.CompletionItemKind.Value,v.CompletionItemKind.Value],[o.CompletionItemKind.Constant,v.CompletionItemKind.Constant],[o.CompletionItemKind.Enum,v.CompletionItemKind.Enum],[o.CompletionItemKind.EnumMember,v.CompletionItemKind.EnumMember],[o.CompletionItemKind.Keyword,v.CompletionItemKind.Keyword],[o.CompletionItemKind.Snippet,v.CompletionItemKind.Snippet],[o.CompletionItemKind.Text,v.CompletionItemKind.Text],[o.CompletionItemKind.Color,v.CompletionItemKind.Color],[o.CompletionItemKind.File,v.CompletionItemKind.File],[o.CompletionItemKind.Reference,v.CompletionItemKind.Reference],[o.CompletionItemKind.Folder,v.CompletionItemKind.Folder],[o.CompletionItemKind.Event,v.CompletionItemKind.Event],[o.CompletionItemKind.Operator,v.CompletionItemKind.Operator],[o.CompletionItemKind.TypeParameter,v.CompletionItemKind.TypeParameter],[o.CompletionItemKind.User,v.CompletionItemKind.User],[o.CompletionItemKind.Issue,v.CompletionItemKind.Issue]]);function Re(Qe){return ie.get(Qe)??v.CompletionItemKind.Property}Ae.to=Re})(Ge||(e.CompletionItemKind=Ge={}));var Ke;(function(Ae){function Me(ve,ie){const Re=new v.$3N(ve.label);return Re.insertText=ve.insertText,Re.kind=Ge.to(ve.kind),Re.tags=ve.tags?.map(Ne.to),Re.detail=ve.detail,Re.documentation=L.$2k(ve.documentation)?ue.to(ve.documentation):ve.documentation,Re.sortText=ve.sortText,Re.filterText=ve.filterText,Re.preselect=ve.preselect,Re.commitCharacters=ve.commitCharacters,g.$Kt.isIRange(ve.range)?Re.range=N.to(ve.range):typeof ve.range=="object"&&(Re.range={inserting:N.to(ve.range.insert),replacing:N.to(ve.range.replace)}),Re.keepWhitespace=typeof ve.insertTextRules>"u"?!1:!!(ve.insertTextRules&o.CompletionItemInsertTextRule.KeepWhitespace),typeof ve.insertTextRules<"u"&&ve.insertTextRules&o.CompletionItemInsertTextRule.InsertAsSnippet?Re.insertText=new v.$FN(ve.insertText):(Re.insertText=ve.insertText,Re.textEdit=Re.range instanceof v.$wN?new v.$BN(Re.range,Re.insertText):void 0),ve.additionalTextEdits&&ve.additionalTextEdits.length>0&&(Re.additionalTextEdits=ve.additionalTextEdits.map(Qe=>ae.to(Qe))),Re.command=ie&&ve.command?ie.fromInternal(ve.command):void 0,Re}Ae.to=Me})(Ke||(e.CompletionItem=Ke={}));var tt;(function(Ae){function Me(ie){if(typeof ie.label!="string"&&!Array.isArray(ie.label))throw new TypeError("Invalid label");return{label:ie.label,documentation:ue.fromStrict(ie.documentation)}}Ae.from=Me;function ve(ie){return{label:ie.label,documentation:L.$2k(ie.documentation)?ue.to(ie.documentation):ie.documentation}}Ae.to=ve})(tt||(e.ParameterInformation=tt={}));var rt;(function(Ae){function Me(ie){return{label:ie.label,documentation:ue.fromStrict(ie.documentation),parameters:Array.isArray(ie.parameters)?ie.parameters.map(tt.from):[],activeParameter:ie.activeParameter}}Ae.from=Me;function ve(ie){return{label:ie.label,documentation:L.$2k(ie.documentation)?ue.to(ie.documentation):ie.documentation,parameters:Array.isArray(ie.parameters)?ie.parameters.map(tt.to):[],activeParameter:ie.activeParameter}}Ae.to=ve})(rt||(e.SignatureInformation=rt={}));var ot;(function(Ae){function Me(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(rt.from):[]}}Ae.from=Me;function ve(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(rt.to):[]}}Ae.to=ve})(ot||(e.SignatureHelp=ot={}));var nt;(function(Ae){function Me(ve,ie){const Re=new v.$2N(z.to(ie.position),typeof ie.label=="string"?ie.label:ie.label.map(at.to.bind(void 0,ve)),ie.kind&&mt.to(ie.kind));return Re.textEdits=ie.textEdits&&ie.textEdits.map(ae.to),Re.tooltip=L.$2k(ie.tooltip)?ue.to(ie.tooltip):ie.tooltip,Re.paddingLeft=ie.paddingLeft,Re.paddingRight=ie.paddingRight,Re}Ae.to=Me})(nt||(e.InlayHint=nt={}));var at;(function(Ae){function Me(ve,ie){const Re=new v.$1N(ie.label);return Re.tooltip=L.$2k(ie.tooltip)?ue.to(ie.tooltip):ie.tooltip,o.Command.is(ie.command)&&(Re.command=ve.fromInternal(ie.command)),ie.location&&(Re.location=We.to(ie.location)),Re}Ae.to=Me})(at||(e.InlayHintLabelPart=at={}));var mt;(function(Ae){function Me(ie){return ie}Ae.from=Me;function ve(ie){return ie}Ae.to=ve})(mt||(e.InlayHintKind=mt={}));var ht;(function(Ae){function Me(ie){return{range:N.from(ie.range),url:ie.target,tooltip:ie.tooltip}}Ae.from=Me;function ve(ie){let Re;if(ie.url)try{Re=typeof ie.url=="string"?$.URI.parse(ie.url,!0):$.URI.revive(ie.url)}catch{}const Qe=new v.$8N(N.to(ie.range),Re);return Qe.tooltip=ie.tooltip,Qe}Ae.to=ve})(ht||(e.DocumentLink=ht={}));var ct;(function(Ae){function Me(ie){const Re=new v.$$N(ie.label);return ie.textEdit&&(Re.textEdit=ae.to(ie.textEdit)),ie.additionalTextEdits&&(Re.additionalTextEdits=ie.additionalTextEdits.map(Qe=>ae.to(Qe))),Re}Ae.to=Me;function ve(ie){return{label:ie.label,textEdit:ie.textEdit?ae.from(ie.textEdit):void 0,additionalTextEdits:ie.additionalTextEdits?ie.additionalTextEdits.map(Re=>ae.from(Re)):void 0}}Ae.from=ve})(ct||(e.ColorPresentation=ct={}));var Pe;(function(Ae){function Me(ie){return new v.$9N(ie[0],ie[1],ie[2],ie[3])}Ae.to=Me;function ve(ie){return[ie.red,ie.green,ie.blue,ie.alpha]}Ae.from=ve})(Pe||(e.Color=Pe={}));var ze;(function(Ae){function Me(ie){return{range:N.from(ie.range)}}Ae.from=Me;function ve(ie){return new v.$RN(N.to(ie.range))}Ae.to=ve})(ze||(e.SelectionRange=ze={}));var He;(function(Ae){function Me(ve){switch(ve){case l.SaveReason.AUTO:return v.TextDocumentSaveReason.AfterDelay;case l.SaveReason.EXPLICIT:return v.TextDocumentSaveReason.Manual;case l.SaveReason.FOCUS_CHANGE:case l.SaveReason.WINDOW_CHANGE:return v.TextDocumentSaveReason.FocusOut}}Ae.to=Me})(He||(e.TextDocumentSaveReason=He={}));var Oe;(function(Ae){function Me(ie){switch(ie){case v.TextEditorLineNumbersStyle.Off:return f.RenderLineNumbersType.Off;case v.TextEditorLineNumbersStyle.Relative:return f.RenderLineNumbersType.Relative;case v.TextEditorLineNumbersStyle.Interval:return f.RenderLineNumbersType.Interval;case v.TextEditorLineNumbersStyle.On:default:return f.RenderLineNumbersType.On}}Ae.from=Me;function ve(ie){switch(ie){case f.RenderLineNumbersType.Off:return v.TextEditorLineNumbersStyle.Off;case f.RenderLineNumbersType.Relative:return v.TextEditorLineNumbersStyle.Relative;case f.RenderLineNumbersType.Interval:return v.TextEditorLineNumbersStyle.Interval;case f.RenderLineNumbersType.On:default:return v.TextEditorLineNumbersStyle.On}}Ae.to=ve})(Oe||(e.TextEditorLineNumbersStyle=Oe={}));var je;(function(Ae){function Me(ie){if(ie===v.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(ie===v.EndOfLine.LF)return t.EndOfLineSequence.LF}Ae.from=Me;function ve(ie){if(ie===t.EndOfLineSequence.CRLF)return v.EndOfLine.CRLF;if(ie===t.EndOfLineSequence.LF)return v.EndOfLine.LF}Ae.to=ve})(je||(e.EndOfLine=je={}));var he;(function(Ae){function Me(ve){if(typeof ve=="object")return ve.viewId;switch(ve){case v.ProgressLocation.SourceControl:return n.ProgressLocation.Scm;case v.ProgressLocation.Window:return n.ProgressLocation.Window;case v.ProgressLocation.Notification:return n.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}Ae.from=Me})(he||(e.ProgressLocation=he={}));var x;(function(Ae){function Me(ie){const Re={start:ie.start+1,end:ie.end+1};return ie.kind&&(Re.kind=Ce.from(ie.kind)),Re}Ae.from=Me;function ve(ie){const Re={start:ie.start-1,end:ie.end-1};return ie.kind&&(Re.kind=Ce.to(ie.kind)),Re}Ae.to=ve})(x||(e.FoldingRange=x={}));var Ce;(function(Ae){function Me(ie){if(ie)switch(ie){case v.FoldingRangeKind.Comment:return o.$Ku.Comment;case v.FoldingRangeKind.Imports:return o.$Ku.Imports;case v.FoldingRangeKind.Region:return o.$Ku.Region}}Ae.from=Me;function ve(ie){if(ie)switch(ie.value){case o.$Ku.Comment.value:return v.FoldingRangeKind.Comment;case o.$Ku.Imports.value:return v.FoldingRangeKind.Imports;case o.$Ku.Region.value:return v.FoldingRangeKind.Region}}Ae.to=ve})(Ce||(e.FoldingRangeKind=Ce={}));var Xe;(function(Ae){function Me(ve){if(ve)return{pinned:typeof ve.preview=="boolean"?!ve.preview:void 0,inactive:ve.background,preserveFocus:ve.preserveFocus,selection:typeof ve.selection=="object"?N.from(ve.selection):void 0,override:typeof ve.override=="boolean"?l.$QF.id:void 0}}Ae.from=Me})(Xe||(e.TextEditorOpenOptions=Xe={}));var et;(function(Ae){function Me(Qe){return Qe instanceof v.$tO?Qe.toJSON():typeof Qe=="string"?Qe:ve(Qe)||ie(Qe)?new v.$tO(Qe.baseUri??Qe.base,Qe.pattern).toJSON():Qe}Ae.from=Me;function ve(Qe){const it=Qe;return it?$.URI.isUri(it.baseUri)&&typeof it.pattern=="string":!1}function ie(Qe){const it=Qe;return it?typeof it.base=="string"&&typeof it.pattern=="string":!1}function Re(Qe){return typeof Qe=="string"?Qe:new v.$tO($.URI.revive(Qe.baseUri),Qe.pattern)}Ae.to=Re})(et||(e.GlobPattern=et={}));var ut;(function(Ae){function Me(ve){if(ve){if(Array.isArray(ve))return ve.map(Me);if(typeof ve=="string")return ve;{const ie=ve;return{language:ie.language,scheme:ie.scheme,pattern:et.from(ie.pattern),exclusive:ie.exclusive,notebookType:ie.notebookType}}}else return}Ae.from=Me})(ut||(e.LanguageSelector=ut={}));var gt;(function(Ae){function Me(ie){return!!ie&&typeof ie=="object"&&"documents"in ie&&Array.isArray(ie.documents)&&ie.documents.every(Re=>Array.isArray(Re)&&Re.every(Qe=>Qe&&typeof Qe=="object"&&"uri"in Qe&&$.URI.isUri(Qe.uri)&&"version"in Qe&&typeof Qe.version=="number"&&"ranges"in Qe&&Array.isArray(Qe.ranges)&&Qe.ranges.every(it=>it instanceof v.$wN)))}Ae.is=Me;function ve(ie){return{documents:ie.documents.map(Re=>Re.map(Qe=>({uri:$.URI.from(Qe.uri),version:Qe.version,ranges:Qe.ranges.map(it=>N.from(it))})))}}Ae.from=ve})(gt||(e.MappedEditsContext=gt={}));var Dt;(function(Ae){function Me(ie){return{start:ie.start,end:ie.end}}Ae.from=Me;function ve(ie){return new v.$WO(ie.start,ie.end)}Ae.to=ve})(Dt||(e.NotebookRange=Dt={}));var Ot;(function(Ae){function Me(ie){return{timing:typeof ie.runStartTime=="number"&&typeof ie.runEndTime=="number"?{startTime:ie.runStartTime,endTime:ie.runEndTime}:void 0,executionOrder:ie.executionOrder,success:ie.lastRunSuccess}}Ae.to=Me;function ve(ie){return{lastRunSuccess:ie.success,runStartTime:ie.timing?.startTime,runEndTime:ie.timing?.endTime,executionOrder:ie.executionOrder}}Ae.from=ve})(Ot||(e.NotebookCellExecutionSummary=Ot={}));var Ut;(function(Ae){function Me(ve){if(ve===y.NotebookCellExecutionState.Unconfirmed)return v.NotebookCellExecutionState.Pending;if(ve===y.NotebookCellExecutionState.Pending)return;if(ve===y.NotebookCellExecutionState.Executing)return v.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ve}`)}Ae.to=Me})(Ut||(e.NotebookCellExecutionState=Ut={}));var ui;(function(Ae){function Me(ie){switch(ie){case v.NotebookCellKind.Markup:return y.CellKind.Markup;case v.NotebookCellKind.Code:default:return y.CellKind.Code}}Ae.from=Me;function ve(ie){switch(ie){case y.CellKind.Markup:return v.NotebookCellKind.Markup;case y.CellKind.Code:default:return v.NotebookCellKind.Code}}Ae.to=ve})(ui||(e.NotebookCellKind=ui={}));var ti;(function(Ae){function Me(ie){const Re={metadata:ie.metadata??Object.create(null),cells:[]};for(const Qe of ie.cells)v.$XO.validate(Qe),Re.cells.push(_e.from(Qe));return Re}Ae.from=Me;function ve(ie){const Re=new v.$YO(ie.cells.map(_e.to));return(0,a.$pg)(ie.metadata)||(Re.metadata=ie.metadata),Re}Ae.to=ve})(ti||(e.NotebookData=ti={}));var _e;(function(Ae){function Me(ie){return{cellKind:ui.from(ie.kind),language:ie.languageId,mime:ie.mime,source:ie.value,metadata:ie.metadata,internalMetadata:Ot.from(ie.executionSummary??{}),outputs:ie.outputs?ie.outputs.map(Qt.from):[]}}Ae.from=Me;function ve(ie){return new v.$XO(ui.to(ie.cellKind),ie.source,ie.language,ie.mime,ie.outputs?ie.outputs.map(Qt.to):void 0,ie.metadata,ie.internalMetadata?Ot.to(ie.internalMetadata):void 0)}Ae.to=ve})(_e||(e.NotebookCellData=_e={}));var Kt;(function(Ae){function Me(ie){return{mime:ie.mime,valueBytes:h.$Le.wrap(ie.data)}}Ae.from=Me;function ve(ie){return new v.$ZO(ie.valueBytes.buffer,ie.mime)}Ae.to=ve})(Kt||(e.NotebookCellOutputItem=Kt={}));var Qt;(function(Ae){function Me(ie){return{outputId:ie.id,items:ie.items.map(Kt.from),metadata:ie.metadata}}Ae.from=Me;function ve(ie){const Re=ie.items.map(Kt.to);return new v.$1O(Re,ie.outputId,ie.metadata)}Ae.to=ve})(Qt||(e.NotebookCellOutput=Qt={}));var pt;(function(Ae){function Me(Re){return ie(Re)?{include:et.from(Re.include)??void 0,exclude:et.from(Re.exclude)??void 0}:et.from(Re)??void 0}Ae.from=Me;function ve(Re){return ie(Re)?{include:et.to(Re.include),exclude:et.to(Re.exclude)}:et.to(Re)}Ae.to=ve;function ie(Re){const Qe=Re;return Qe?!(0,a.$lg)(Qe.include)&&!(0,a.$lg)(Qe.exclude):!1}})(pt||(e.NotebookExclusiveDocumentPattern=pt={}));var Pt;(function(Ae){function Me(ve,ie,Re){const Qe=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{alignment:ve.alignment===v.NotebookCellStatusBarAlignment.Left?y.CellStatusbarAlignment.Left:y.CellStatusbarAlignment.Right,command:ie.toInternal(Qe,Re),text:ve.text,tooltip:ve.tooltip,accessibilityInformation:ve.accessibilityInformation,priority:ve.priority}}Ae.from=Me})(Pt||(e.NotebookStatusBarItem=Pt={}));var ii;(function(Ae){function Me(ve,ie,Re){const Qe=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{command:ie.toInternal(Qe,Re),label:ve.label,description:ve.description,detail:ve.detail,documentation:ve.documentation}}Ae.from=Me})(ii||(e.NotebookKernelSourceAction=ii={}));var Zt;(function(Ae){function Me(ve){return{transientOutputs:ve?.transientOutputs??!1,transientCellMetadata:ve?.transientCellMetadata??{},transientDocumentMetadata:ve?.transientDocumentMetadata??{},cellContentMetadata:ve?.cellContentMetadata??{}}}Ae.from=Me})(Zt||(e.NotebookDocumentContentOptions=Zt={}));var qt;(function(Ae){function Me(ie){return{uri:ie.uri,provides:ie.provides}}Ae.from=Me;function ve(ie){return new v.$3O($.URI.revive(ie.uri),ie.provides)}Ae.to=ve})(qt||(e.NotebookRendererScript=qt={}));var vt;(function(Ae){function Me(ie){return{message:ue.fromStrict(ie.message)||"",type:A.TestMessageType.Error,expected:ie.expectedOutput,actual:ie.actualOutput,contextValue:ie.contextValue,location:ie.location&&{range:N.from(ie.location.range),uri:ie.location.uri}}}Ae.from=Me;function ve(ie){const Re=new v.$9O(typeof ie.message=="string"?ie.message:ue.to(ie.message));return Re.actualOutput=ie.actual,Re.expectedOutput=ie.expected,Re.contextValue=ie.contextValue,Re.location=ie.location?We.to(ie.location):void 0,Re}Ae.to=ve})(vt||(e.TestMessage=vt={}));var Nt;(function(Ae){Ae.namespace=A.$WI,Ae.denamespace=A.$XI})(Nt||(e.TestTag=Nt={}));var hi;(function(Ae){function Me(ie){const Re=(0,d.$WP)(ie).controllerId;return{extId:k.$RI.fromExtHostTestItem(ie,Re).toString(),label:ie.label,uri:$.URI.revive(ie.uri),busy:ie.busy,tags:ie.tags.map(Qe=>Nt.namespace(Re,Qe.id)),range:g.$Kt.lift(N.from(ie.range)),description:ie.description||null,sortText:ie.sortText||null,error:ie.error&&ue.fromStrict(ie.error)||null}}Ae.from=Me;function ve(ie){return{parent:void 0,error:void 0,id:k.$RI.fromString(ie.extId).localId,label:ie.label,uri:$.URI.revive(ie.uri),tags:(ie.tags||[]).map(Re=>{const{tagId:Qe}=Nt.denamespace(Re);return new v.$0O(Qe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:N.to(ie.range||void 0),canResolveChildren:!1,busy:ie.busy,description:ie.description||void 0,sortText:ie.sortText||void 0}}Ae.toPlain=ve})(hi||(e.TestItem=hi={})),function(Ae){function Me(ie){return{id:ie.id}}Ae.from=Me;function ve(ie){return new v.$0O(ie.id)}Ae.to=ve}(Nt||(e.TestTag=Nt={}));var Vt;(function(Ae){const Me=(ie,Re)=>{const Qe=ie.value;if(!Qe)return;const it={...hi.toPlain(Qe.item),parent:Re,taskStates:Qe.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(ft=>ft.type===A.TestMessageType.Error).map(vt.to)})),children:[]};if(ie.children)for(const Je of ie.children.values()){const ft=Me(Je,it);ft&&it.children.push(ft)}return it};function ve(ie){const Re=new u.$QI;for(const Je of ie.items)Re.insert(k.$RI.fromString(Je.item.extId).path,Je);const Qe=[Re.nodes],it=[];for(;Qe.length;)for(const Je of Qe.pop())Je.value?it.push(Je):Je.children&&Qe.push(Je.children.values());return{completedAt:ie.completedAt,results:it.map(Je=>Me(Je)).filter(a.$kg)}}Ae.to=ve})(Vt||(e.TestResults=Vt={}));var xe;(function(Ae){function Me(Qe){return{covered:Qe.covered,total:Qe.total}}function ve(Qe){return"line"in Qe?z.from(Qe):N.from(Qe)}function ie(Qe){if(typeof Qe.executed=="number"&&Qe.executed<0)throw new Error(`Invalid coverage count ${Qe.executed}`);return"branches"in Qe?{count:Qe.executed,location:ve(Qe.location),type:A.DetailType.Statement,branches:Qe.branches.length?Qe.branches.map(it=>({count:it.executed,location:it.location&&ve(it.location),label:it.label})):void 0}:{type:A.DetailType.Declaration,name:Qe.name,count:Qe.executed,location:ve(Qe.location)}}Ae.fromDetails=ie;function Re(Qe,it,Je){return v.$_O(Je.statementCoverage),v.$_O(Je.branchCoverage),v.$_O(Je.declarationCoverage),{id:it,uri:Je.uri,statement:Me(Je.statementCoverage),branch:Je.branchCoverage&&Me(Je.branchCoverage),declaration:Je.declarationCoverage&&Me(Je.declarationCoverage),testIds:Je instanceof v.$aP&&Je.fromTests.length?Je.fromTests.map(ft=>k.$RI.fromExtHostTestItem(ft,Qe).toString()):void 0}}Ae.fromFile=Re})(xe||(e.TestCoverage=xe={}));var xt;(function(Ae){function Me(ve){switch(ve){case o.CodeActionTriggerType.Invoke:return v.CodeActionTriggerKind.Invoke;case o.CodeActionTriggerType.Auto:return v.CodeActionTriggerKind.Automatic}}Ae.to=Me})(xt||(e.CodeActionTriggerKind=xt={}));var ni;(function(Ae){function Me(ie){const Re=new v.$eP(ce.to(ie.kind),ie.name,ie.detail||"",$.URI.revive(ie.uri),N.to(ie.range),N.to(ie.selectionRange));return Re._sessionId=ie._sessionId,Re._itemId=ie._itemId,Re}Ae.to=Me;function ve(ie,Re,Qe){if(Re=Re??ie._sessionId,Qe=Qe??ie._itemId,Re===void 0||Qe===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Qe,kind:ce.from(ie.kind),name:ie.name,detail:ie.detail??"",uri:ie.uri,range:N.from(ie.range),selectionRange:N.from(ie.selectionRange),tags:ie.tags?.map(le.from)}}Ae.from=ve})(ni||(e.TypeHierarchyItem=ni={}));var di;(function(Ae){function Me(ve){if(ve)return{value:ve.value,tooltip:ve.tooltip}}Ae.from=Me})(di||(e.ViewBadge=di={}));var kt;(function(Ae){function Me(Qe,it,Je){const ft=it.fileData;return ft?new v.$lO(new v.$mO(ft.name,$.URI.revive(ft.uri),ft.id,(0,T.$cb)(()=>Je(ft.id)))):Qe===I.$7s.uriList&&it.uriListData?new v.$kO(Re(it.uriListData)):new v.$kO(it.asString)}Ae.to=Me;async function ve(Qe,it){const Je=await it.asString();if(Qe===I.$7s.uriList)return{asString:Je,fileData:void 0,uriListData:ie(Je)};const ft=it.asFile();return{asString:Je,fileData:ft?{name:ft.name,uri:ft.uri,id:ft._itemId??ft.id}:void 0}}Ae.from=ve;function ie(Qe){return C.$ou.split(Qe).map(it=>{if(it.startsWith("#"))return it;try{return $.URI.parse(it)}catch{}return it})}function Re(Qe){return C.$ou.create(Qe.map(it=>typeof it=="string"?it:$.URI.revive(it)))}})(kt||(e.DataTransferItem=kt={}));var Ft;(function(Ae){function Me(ie,Re){const Qe=ie.items.map(([it,Je])=>[it,kt.to(it,Je,Re)]);return new v.$nO(Qe)}Ae.toDataTransfer=Me;async function ve(ie){const Re={items:[]},Qe=[];for(const[it,Je]of ie)Qe.push((async()=>{Re.items.push([it,await kt.from(it,Je)])})());return await Promise.all(Qe),Re}Ae.from=ve})(Ft||(e.DataTransfer=Ft={}));var Rt;(function(Ae){function Me(ie,Re){return{kind:"reply",agentId:ie.participant??Re?.agentId??"",subCommand:ie.command??Re?.command,message:ie.prompt,title:ie.label}}Ae.from=Me;function ve(ie){return{prompt:ie.message,label:ie.title,participant:ie.agentId,command:ie.subCommand}}Ae.to=ve})(Rt||(e.ChatFollowup=Rt={}));var Bt;(function(Ae){function Me(ie){switch(ie){case E.ChatMessageRole.System:return v.LanguageModelChatMessageRole.System;case E.ChatMessageRole.User:return v.LanguageModelChatMessageRole.User;case E.ChatMessageRole.Assistant:return v.LanguageModelChatMessageRole.Assistant}}Ae.to=Me;function ve(ie){switch(ie){case v.LanguageModelChatMessageRole.System:return E.ChatMessageRole.System;case v.LanguageModelChatMessageRole.User:return E.ChatMessageRole.User;case v.LanguageModelChatMessageRole.Assistant:return E.ChatMessageRole.Assistant}return E.ChatMessageRole.User}Ae.from=ve})(Bt||(e.LanguageModelChatMessageRole=Bt={}));var ri;(function(Ae){function Me(ie){let Re="",Qe;ie.content.type==="text"?Re=ie.content.value:Qe=new v.$HP(ie.content.name,ie.content.value,ie.content.isError);const it=Bt.to(ie.role),Je=new v.$IP(it,Re,ie.name);return Qe!==void 0&&(Je.content2=Qe),Je}Ae.to=Me;function ve(ie){const Re=Bt.from(ie.role),Qe=ie.name;let it;return ie.content2 instanceof v.$HP?it={type:"function_result",name:ie.content2.name,value:ie.content2.content,isError:ie.content2.isError}:it={type:"text",value:ie.content},{role:Re,name:Qe,content:it}}Ae.from=ve})(ri||(e.LanguageModelChatMessage=ri={}));var _t;(function(Ae){function Me(ie){return{kind:"markdownContent",content:ue.from(ie.value)}}Ae.from=Me;function ve(ie){return new v.$rP(ue.to(ie.content))}Ae.to=ve})(_t||(e.ChatResponseMarkdownPart=_t={}));var si;(function(Ae){function Me(ie){return{kind:"markdownVuln",content:ue.from(ie.value),vulnerabilities:ie.vulnerabilities}}Ae.from=Me;function ve(ie){return new v.$sP(ue.to(ie.content),ie.vulnerabilities)}Ae.to=ve})(si||(e.ChatResponseMarkdownWithVulnerabilitiesPart=si={}));var Gt;(function(Ae){function Me(ie){return{kind:"agentDetection",agentId:ie.participant,command:ie.command}}Ae.from=Me;function ve(ie){return new v.$tP(ie.agentId,ie.command)}Ae.to=ve})(Gt||(e.ChatResponseDetectedParticipantPart=Gt={}));var Jt;(function(Ae){function Me(ve){return{kind:"confirmation",title:ve.title,message:ve.message,data:ve.data}}Ae.from=Me})(Jt||(e.ChatResponseConfirmationPart=Jt={}));var oi;(function(Ae){function Me(ie){const{value:Re,baseUri:Qe}=ie;function it(Je,ft){return Je.map(Ct=>{const Yt=$.URI.joinPath(ft,Ct.name);return{label:Ct.name,uri:Yt,children:Ct.children&&it(Ct.children,Yt)}})}return{kind:"treeData",treeData:{label:(0,P.$ah)(Qe),uri:Qe,children:it(Re,Qe)}}}Ae.from=Me;function ve(ie){const Re=(0,c.$_h)(ie.treeData);function Qe(ft){return ft.map(Ct=>({name:Ct.label,children:Ct.children&&Qe(Ct.children)}))}const it=Re.uri,Je=Re.children?Qe(Re.children):[];return new v.$vP(Je,it)}Ae.to=ve})(oi||(e.ChatResponseFilesPart=oi={}));var At;(function(Ae){function Me(ie){const Re=Qe=>$.URI.isUri(Qe);return{kind:"inlineReference",name:ie.title,inlineReference:Re(ie.value)?ie.value:O.from(ie.value)}}Ae.from=Me;function ve(ie){const Re=(0,c.$_h)(ie);return new v.$wP($.URI.isUri(Re.inlineReference)?Re.inlineReference:O.to(Re.inlineReference),ie.name)}Ae.to=ve})(At||(e.ChatResponseAnchorPart=At={}));var St;(function(Ae){function Me(ie){return{kind:"progressMessage",content:ue.from(ie.value)}}Ae.from=Me;function ve(ie){return new v.$xP(ie.content.value)}Ae.to=ve})(St||(e.ChatResponseProgressPart=St={}));var wt;(function(Ae){function Me(ie){return{kind:"warning",content:ue.from(ie.value)}}Ae.from=Me;function ve(ie){return new v.$zP(ie.content.value)}Ae.to=ve})(wt||(e.ChatResponseWarningPart=wt={}));var ei;(function(Ae){function Me(ve){return{kind:"progressTask",content:ue.from(ve.value)}}Ae.from=Me})(ei||(e.ChatTask=ei={}));var It;(function(Ae){function Me(ve){return{kind:"progressTaskResult",content:typeof ve=="string"?ue.from(ve):void 0}}Ae.from=Me})(It||(e.ChatTaskResult=It={}));var fi;(function(Ae){function Me(ie,Re,Qe){return{kind:"command",command:Re.toInternal(ie.value,Qe)??{command:ie.value.command,title:ie.value.title}}}Ae.from=Me;function ve(ie,Re){return new v.$AP(Re.fromInternal(ie.command)??{command:ie.command.id,title:ie.command.title})}Ae.to=ve})(fi||(e.ChatResponseCommandButtonPart=fi={}));var Ht;(function(Ae){function Me(ie){return{kind:"textEdit",uri:ie.uri,edits:ie.edits.map(Re=>ae.from(Re))}}Ae.from=Me;function ve(ie){return new v.$CP($.URI.revive(ie.uri),ie.edits.map(Re=>ae.to(Re)))}Ae.to=ve})(Ht||(e.ChatResponseTextEditPart=Ht={}));var wi;(function(Ae){function Me(ie){const Re=w.ThemeIcon.isThemeIcon(ie.iconPath)?ie.iconPath:$.URI.isUri(ie.iconPath)?{light:$.URI.revive(ie.iconPath)}:ie.iconPath&&"light"in ie.iconPath&&"dark"in ie.iconPath&&$.URI.isUri(ie.iconPath.light)&&$.URI.isUri(ie.iconPath.dark)?{light:$.URI.revive(ie.iconPath.light),dark:$.URI.revive(ie.iconPath.dark)}:void 0;return"variableName"in ie.value?{kind:"reference",reference:{variableName:ie.value.variableName,value:$.URI.isUri(ie.value.value)||!ie.value.value?ie.value.value:O.from(ie.value.value)},iconPath:Re}:{kind:"reference",reference:$.URI.isUri(ie.value)?ie.value:O.from(ie.value),iconPath:Re}}Ae.from=Me;function ve(ie){const Re=(0,c.$_h)(ie),Qe=it=>$.URI.isUri(it)?it:O.to(it);return new v.$BP("variableName"in Re.reference?{variableName:Re.reference.variableName,value:Re.reference.value&&Qe(Re.reference.value)}:Qe(Re.reference))}Ae.to=ve})(wi||(e.ChatResponseReferencePart=wi={}));var vi;(function(Ae){function Me(Re,Qe,it){return Re instanceof v.$rP?_t.from(Re):Re instanceof v.$wP?At.from(Re):Re instanceof v.$BP?wi.from(Re):Re instanceof v.$xP?St.from(Re):Re instanceof v.$vP?oi.from(Re):Re instanceof v.$AP?fi.from(Re,Qe,it):Re instanceof v.$CP?Ht.from(Re):Re instanceof v.$sP?si.from(Re):Re instanceof v.$tP?Gt.from(Re):Re instanceof v.$zP?wt.from(Re):{kind:"markdownContent",content:ue.from("")}}Ae.from=Me;function ve(Re,Qe){switch(Re.kind){case"reference":return wi.to(Re);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return ie(Re,Qe)}}Ae.to=ve;function ie(Re,Qe){switch(Re.kind){case"markdownContent":return _t.to(Re);case"inlineReference":return At.to(Re);case"progressMessage":return;case"treeData":return oi.to(Re);case"command":return fi.to(Re,Qe)}}Ae.toContent=ie})(vi||(e.ChatResponsePart=vi={}));var gi;(function(Ae){function Me(ve,ie){return{prompt:ve.message,command:ve.command,attempt:ve.attempt??0,enableCommandDetection:ve.enableCommandDetection??!0,references:ve.variables.variables.map(ai.to),location:jt.to(ve.location),acceptedConfirmationData:ve.acceptedConfirmationData,rejectedConfirmationData:ve.rejectedConfirmationData,location2:ie}}Ae.to=Me})(gi||(e.ChatAgentRequest=gi={}));var jt;(function(Ae){function Me(ie){switch(ie){case m.ChatAgentLocation.Notebook:return v.ChatLocation.Notebook;case m.ChatAgentLocation.Terminal:return v.ChatLocation.Terminal;case m.ChatAgentLocation.Panel:return v.ChatLocation.Panel;case m.ChatAgentLocation.Editor:return v.ChatLocation.Editor}}Ae.to=Me;function ve(ie){switch(ie){case v.ChatLocation.Notebook:return m.ChatAgentLocation.Notebook;case v.ChatLocation.Terminal:return m.ChatAgentLocation.Terminal;case v.ChatLocation.Panel:return m.ChatAgentLocation.Panel;case v.ChatLocation.Editor:return m.ChatAgentLocation.Editor}}Ae.from=ve})(jt||(e.ChatLocation=jt={}));var ai;(function(Ae){function Me(ve){const ie=ve.value;if(!ie)throw new Error("Invalid value reference");return{id:ve.id,name:ve.name,range:ve.range&&[ve.range.start,ve.range.endExclusive],value:(0,$.$uc)(ie)?$.URI.revive(ie):ie&&typeof ie=="object"&&"uri"in ie&&"range"in ie&&(0,$.$uc)(ie.uri)?O.to((0,c.$_h)(ie)):ie,modelDescription:ve.modelDescription}}Ae.to=Me})(ai||(e.ChatAgentValueReference=ai={}));var Pi;(function(Ae){function Me(ve,ie,Re){return{id:ve.id,label:ve.label,fullName:ve.fullName,icon:ve.icon?.id,value:ve.values[0].value,insertText:ve.insertText,detail:ve.detail,documentation:ve.documentation,command:ie.toInternal(ve.command,Re)}}Ae.from=Me})(Pi||(e.ChatAgentCompletionItem=Pi={}));var Tt;(function(Ae){function Me(ve){return{errorDetails:ve.errorDetails,metadata:ve.metadata}}Ae.to=Me})(Tt||(e.ChatAgentResult=Tt={}));var Si;(function(Ae){function Me(ve,ie,Re){if(ie.action.kind==="vote")return;const Qe=Tt.to(ve);if(ie.action.kind==="command"){const it=ie.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Re.fromInternal(it)??{command:it.id,title:it.title}}},result:Qe}}else return ie.action.kind==="followUp"?{action:{kind:"followUp",followup:Rt.to(ie.action.followup)},result:Qe}:ie.action.kind==="inlineChat"?{action:{kind:"editor",accepted:ie.action.action==="accepted"},result:Qe}:{action:ie.action,result:Qe}}Ae.to=Me})(Si||(e.ChatAgentUserActionEvent=Si={}));var Ci;(function(Ae){function Me(ve,ie,Re){return"terminalCommand"in ve?{terminalCommand:ve.terminalCommand,shouldExecute:ve.shouldExecute}:"uri"in ve?{uri:ve.uri}:ie.toInternal(ve,Re)}Ae.from=Me})(Ci||(e.TerminalQuickFix=Ci={}));var Di;(function(Ae){function Me(ve){return{kind:$i.to(ve.kind)}}Ae.to=Me})(Di||(e.PartialAcceptInfo=Di={}));var $i;(function(Ae){function Me(ve){switch(ve){case o.PartialAcceptTriggerKind.Word:return v.PartialAcceptTriggerKind.Word;case o.PartialAcceptTriggerKind.Line:return v.PartialAcceptTriggerKind.Line;case o.PartialAcceptTriggerKind.Suggest:return v.PartialAcceptTriggerKind.Suggest;default:return v.PartialAcceptTriggerKind.Unknown}}Ae.to=Me})($i||(e.PartialAcceptTriggerKind=$i={}));var Ai;(function(Ae){function Me(ve,ie){return{id:ie,label:ve.label,description:ve.description,canEdit:ve.canEdit,collapsibleState:ve.collapsibleState||S.DebugTreeItemCollapsibleState.None,contextValue:ve.contextValue}}Ae.from=Me})(Ai||(e.DebugTreeItem=Ai={}));var Wt;(function(Ae){function Me(ve){return{name:ve.name,description:ve.description,parametersSchema:ve.parametersSchema}}Ae.to=Me})(Wt||(e.LanguageModelToolDescription=Wt={}))}),define(ke[293],Ie([1,0,6,19,15,53]),function(me,e,r,h,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zoc=void 0;let L=class{constructor(b,c){this.a=b.getProxy(r.$sN.MainThreadBulkEdits),this.b={getTextDocumentVersion:I=>c.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,c,I){const D=new T.$Sw(C.WorkspaceEdit.from(b,this.b));return this.a.$tryApplyWorkspaceEdit(D,void 0,I?.isRefactoring??!1)}};e.$zoc=L,e.$zoc=L=Ye([Ve(0,h.$1P)],L)}),define(ke[294],Ie([1,0,18,7,52,4,39,3,51,42,17,2,23,6,15,9,153,256,25]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a,$,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aoc=void 0,w=Ue(w),a=Ue(a);class i{constructor(n,d,l,m,E){this.j=n,this.k=d,this.l=l,this.m=m,this.n=E,this.b=c.$de.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let d=function(m){if(n.c){const E=new Error("Response stream has been closed");throw Error.captureStackTrace(E,m),E}};const n=this;this.b.reset();const l=(m,E)=>{if(typeof this.d>"u"&&"content"in m&&(this.d=this.b.elapsed()),E){const S=this.l.$handleProgressChunk(this.k.requestId,m),y={report:k=>{S?.then(A=>{A&&(a.$WN.isMarkdownString(k.value)?this.l.$handleProgressChunk(this.k.requestId,w.ChatResponseWarningPart.from(k),A):this.l.$handleProgressChunk(this.k.requestId,w.ChatResponseReferencePart.from(k),A))})}};Promise.all([S,E?.(y)]).then(([k,A])=>{k!==void 0&&A!==void 0&&this.l.$handleProgressChunk(this.k.requestId,w.ChatTaskResult.from(A),k)})}else this.l.$handleProgressChunk(this.k.requestId,m)};this.g={markdown(m){d(this.markdown);const E=new a.$rP(m),S=w.ChatResponseMarkdownPart.from(E);return l(S),this},markdownWithVulnerabilities(m,E){d(this.markdown),E&&(0,g.$5G)(n.j,"chatParticipantAdditions");const S=new a.$sP(m,E),y=w.ChatResponseMarkdownWithVulnerabilitiesPart.from(S);return l(y),this},filetree(m,E){d(this.filetree);const S=new a.$vP(m,E),y=w.ChatResponseFilesPart.from(S);return l(y),this},anchor(m,E){d(this.anchor);const S=new a.$wP(m,E),y=w.ChatResponseAnchorPart.from(S);return l(y),this},button(m){d(this.anchor);const E=new a.$AP(m),S=w.ChatResponseCommandButtonPart.from(E,n.m,n.n);return l(S),this},progress(m,E){d(this.progress);const S=new a.$yP(m,E),y=E?w.ChatTask.from(S):w.ChatResponseProgressPart.from(S);return l(y,E),this},warning(m){d(this.progress),(0,g.$5G)(n.j,"chatParticipantAdditions");const E=new a.$zP(m),S=w.ChatResponseWarningPart.from(E);return l(S),this},reference(m,E){if(d(this.reference),"variableName"in m&&(0,g.$5G)(n.j,"chatParticipantAdditions"),"variableName"in m&&!m.value){const S=n.k.variables.variables.find(y=>y.name===m.variableName);if(S){let y;if(S.references?.length)y=S.references.map(k=>({kind:"reference",reference:{variableName:m.variableName,value:k.reference}}));else{const k=new a.$BP(m,E);y=[w.ChatResponseReferencePart.from(k)]}return y.forEach(k=>l(k)),this}}else{const S=new a.$BP(m,E),y=w.ChatResponseReferencePart.from(S);l(y)}return this},textEdit(m,E){d(this.textEdit),(0,g.$5G)(n.j,"chatParticipantAdditions");const S=new a.$CP(m,E),y=w.ChatResponseTextEditPart.from(S);return l(y),this},detectedParticipant(m,E){d(this.detectedParticipant),(0,g.$5G)(n.j,"chatParticipantAdditions");const S=new a.$tP(m,E),y=w.ChatResponseDetectedParticipantPart.from(S);return l(y),this},confirmation(m,E,S){d(this.confirmation),(0,g.$5G)(n.j,"chatParticipantAdditions");const y=new a.$uP(m,E,S),k=w.ChatResponseConfirmationPart.from(y);return l(k),this},push(m){if(d(this.push),(m instanceof a.$CP||m instanceof a.$sP||m instanceof a.$tP||m instanceof a.$zP||m instanceof a.$uP)&&(0,g.$5G)(n.j,"chatParticipantAdditions"),m instanceof a.$BP)this.reference(m.value,m.iconPath);else{const E=w.ChatResponsePart.from(m,n.m,n.n);l(E)}return this}}}return this.g}}class o extends R.$Tc{static{this.b=0}constructor(n,d,l,m){super(),this.n=d,this.s=l,this.t=m,this.c=new Map,this.j=this.B(new R.$3c),this.m=this.B(new R.$3c),this.g=n.getProxy(P.$sN.MainThreadChatAgents2)}transferActiveChat(n){this.g.$transferActiveChatSession(n)}createChatAgent(n,d,l){const m=o.b++,E=new t(n,d,this.g,m,l);return this.c.set(m,E),this.g.$registerAgent(m,n.identifier,d,{},void 0),E.apiAgent}createDynamicChatAgent(n,d,l,m){const E=o.b++,S=new t(n,d,this.g,E,m);return this.c.set(E,S),this.g.$registerAgent(E,n.identifier,d,{isSticky:!0},l),S.apiAgent}async $invokeAgent(n,d,l,m){const E=this.c.get(n);if(!E)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);const S=(0,b.$_h)(d);let y=this.j.get(S.sessionId);y||(y=new R.$Sc,this.j.set(S.sessionId,y));const k=new i(E.extension,S,this.g,this.s.converter,y);try{const A=await this.u(S.agentId,l);let p;if(S.locationData?.type===$.ChatAgentLocation.Editor){const F=this.t.getDocument(S.locationData.document);p=new a.$FP(F,w.Selection.to(S.locationData.selection),w.Range.to(S.locationData.wholeRange))}else if(S.locationData?.type===$.ChatAgentLocation.Notebook){const F=this.t.getDocument(S.locationData.sessionInputUri);p=new a.$GP(F)}else S.locationData?.type,$.ChatAgentLocation.Terminal;const v=E.invoke(w.ChatAgentRequest.to(S,p),{history:A},k.apiObject,m);return await(0,h.$qh)(Promise.resolve(v).then(F=>{if(F?.metadata)try{JSON.stringify(F.metadata)}catch(O){const j=`result.metadata MUST be JSON.stringify-able. Got error: ${O.message}`;return this.n.error(`[${E.extension.identifier.value}] [@${E.id}] ${j}`,E.extension),{errorDetails:{message:j},timings:k.timings}}let N;return F?.errorDetails&&(N={...F.errorDetails,responseIsIncomplete:!0}),N?.responseIsRedacted&&(0,g.$5G)(E.extension,"chatParticipantPrivate"),{errorDetails:N,timings:k.timings,metadata:F?.metadata}}),m)}catch(A){return this.n.error(A,E.extension),A instanceof a.$OP&&A.cause&&(A=A.cause),{errorDetails:{message:(0,C.$nj)(A),responseIsIncomplete:!0}}}finally{k.close()}}async u(n,d){const l=[];for(const m of d.history){const E=w.ChatAgentResult.to(m.result),S=n===m.request.agentId?E:{...E,metadata:void 0};l.push(new a.$DP(m.request.message,m.request.command,m.request.variables.variables.map(w.ChatAgentValueReference.to),m.request.agentId));const y=(0,r.$Gb)(m.response.map(k=>w.ChatResponsePart.toContent(k,this.s.converter)));l.push(new a.$EP(y,S,m.request.agentId,m.request.command))}return l}$releaseSession(n){this.j.deleteAndDispose(n)}async $provideFollowups(n,d,l,m,E){const S=this.c.get(d);if(!S)return Promise.resolve([]);const y=(0,b.$_h)(n),k=await this.u(S.id,m),A=w.ChatAgentResult.to(l);return(await S.provideFollowups(A,{history:k},E)).filter(p=>{const v=!p.participant||L.Iterable.some(this.c.values(),F=>F.id===p.participant&&u.$nn.equals(F.extension.identifier,S.extension.identifier));return v||this.n.warn(`[@${S.id}] ChatFollowup refers to an unknown participant: ${p.participant}`),v}).map(p=>w.ChatFollowup.from(p,y))}$acceptFeedback(n,d,l,m){const E=this.c.get(n);if(!E)return;const S=w.ChatAgentResult.to(d);let y;switch(l){case f.ChatAgentVoteDirection.Down:y=a.ChatResultFeedbackKind.Unhelpful;break;case f.ChatAgentVoteDirection.Up:y=a.ChatResultFeedbackKind.Helpful;break}E.acceptFeedback(Object.freeze(m?{result:S,kind:y,reportIssue:m}:{result:S,kind:y}))}$acceptAction(n,d,l){const m=this.c.get(n);if(!m||l.action.kind==="vote")return;const E=w.ChatAgentUserActionEvent.to(d,l,this.s.converter);E&&m.acceptAction(Object.freeze(E))}async $invokeCompletionProvider(n,d,l){const m=this.c.get(n);if(!m)return[];let E=this.m.get(n);return E?E.clear():(E=new R.$Sc,this.m.set(n,E)),(await m.invokeCompletionProvider(d,l)).map(y=>w.ChatAgentCompletionItem.from(y,this.s.converter,E))}async $provideWelcomeMessage(n,d,l){const m=this.c.get(n);if(m)return await m.provideWelcomeMessage(w.ChatLocation.to(d),l)}async $provideSampleQuestions(n,d,l){const m=this.c.get(n);if(m)return(await m.provideSampleQuestions(w.ChatLocation.to(d),l)).map(E=>w.ChatFollowup.from(E,void 0))}}e.$Aoc=o;class t{constructor(n,d,l,m,E){this.extension=n,this.id=d,this.w=l,this.x=m,this.y=E,this.m=new T.$je,this.n=new T.$je}acceptFeedback(n){this.m.fire(n)}acceptAction(n){this.n.fire(n)}async invokeCompletionProvider(n,d){return this.q?await this.q.provider.provideCompletionItems(n,d)??[]:[]}async provideFollowups(n,d,l){if(!this.b)return[];const m=await this.b.provideFollowups(n,d,l);return m?m.filter(E=>!(E&&"commandId"in E)).filter(E=>!(E&&"message"in E)):[]}async provideWelcomeMessage(n,d){if(!this.s)return[];const l=await this.s.provideWelcomeMessage(n,d);return l?l.map(m=>typeof m=="string"?m:w.MarkdownString.from(m)):[]}async provideSampleQuestions(n,d){if(!this.s||!this.s.provideSampleQuestions)return[];const l=await this.s.provideSampleQuestions(n,d);return l||[]}get apiAgent(){let n=!1,d=!1;const l=()=>{n||d||(d=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{icon:this.c?this.c instanceof D.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof a.$rO?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:w.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:w.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:w.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),d=!1}))},m=this;return{get id(){return m.id},get iconPath(){return m.c},set iconPath(E){m.c=E,l()},get requestHandler(){return m.y},set requestHandler(E){(0,I.$mg)(typeof E=="function","Invalid request handler"),m.y=E},get followupProvider(){return m.b},set followupProvider(E){m.b=E,l()},get isDefault(){return(0,g.$5G)(m.extension,"defaultChatParticipant"),m.d},set isDefault(E){(0,g.$5G)(m.extension,"defaultChatParticipant"),m.d=E,l()},get helpTextPrefix(){return(0,g.$5G)(m.extension,"defaultChatParticipant"),m.g},set helpTextPrefix(E){(0,g.$5G)(m.extension,"defaultChatParticipant"),m.g=E,l()},get helpTextVariablesPrefix(){return(0,g.$5G)(m.extension,"defaultChatParticipant"),m.j},set helpTextVariablesPrefix(E){(0,g.$5G)(m.extension,"defaultChatParticipant"),m.j=E,l()},get helpTextPostfix(){return(0,g.$5G)(m.extension,"defaultChatParticipant"),m.k},set helpTextPostfix(E){(0,g.$5G)(m.extension,"defaultChatParticipant"),m.k=E,l()},get isSecondary(){return(0,g.$5G)(m.extension,"defaultChatParticipant"),m.l},set isSecondary(E){(0,g.$5G)(m.extension,"defaultChatParticipant"),m.l=E,l()},get supportIssueReporting(){return(0,g.$5G)(m.extension,"chatParticipantPrivate"),m.o},set supportIssueReporting(E){(0,g.$5G)(m.extension,"chatParticipantPrivate"),m.o=E,l()},get onDidReceiveFeedback(){return m.m.event},set participantVariableProvider(E){if((0,g.$5G)(m.extension,"chatParticipantAdditions"),m.q=E,E){if(!E.triggerCharacters.length)throw new Error("triggerCharacters are required");m.w.$registerAgentCompletionsProvider(m.x,m.id,E.triggerCharacters)}else m.w.$unregisterAgentCompletionsProvider(m.x,m.id)},get participantVariableProvider(){return(0,g.$5G)(m.extension,"chatParticipantAdditions"),m.q},set welcomeMessageProvider(E){(0,g.$5G)(m.extension,"defaultChatParticipant"),m.s=E,l()},get welcomeMessageProvider(){return(0,g.$5G)(m.extension,"defaultChatParticipant"),m.s},onDidPerformAction:(0,g.$4G)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(E){m.t=E,l()},get requester(){return m.t},set supportsSlowReferences(E){(0,g.$5G)(m.extension,"chatParticipantPrivate"),m.u=E,l()},get supportsSlowReferences(){return(0,g.$5G)(m.extension,"chatParticipantPrivate"),m.u},dispose(){n=!0,m.b=void 0,m.m.dispose(),m.w.$unregisterAgent(m.x)}}}invoke(n,d,l,m){return this.y(n,d,l,m)}}}),define(ke[295],Ie([1,0,13,3,50,6,15,9,25]),function(me,e,r,h,C,T,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Boc=void 0,L=Ue(L),R=Ue(R);class c{static{this.a=0}constructor(u){this.b=new Map,this.c=u.getProxy(T.$sN.MainThreadChatVariables)}async $resolveVariable(u,P,w,a){const $=this.b.get(u);if($)try{if($.resolver.resolve2){(0,b.$5G)($.extension,"chatParticipantAdditions");const f=new I(P,this.c),g=await $.resolver.resolve2($.data.name,{prompt:w},f.apiObject,a);if(g&&g[0])return g[0].value}else{const f=await $.resolver.resolve($.data.name,{prompt:w},a);if(f&&f[0])return f[0].value}}catch(f){(0,r.$Z)(f)}}registerVariableResolver(u,P,w,a,$,f,g,i,o){const t=c.a++,s=o?C.ThemeIcon.fromId(o):void 0;return this.b.set(t,{extension:u,data:{id:P,name:w,description:a,modelDescription:$,icon:s},resolver:g}),this.c.$registerVariable(t,{id:P,name:w,description:a,modelDescription:$,isSlow:f,fullName:i,icon:s}),(0,h.$Rc)(()=>{this.b.delete(t),this.c.$unregisterVariable(t)})}}e.$Boc=c;class I{constructor(u,P){this.c=u,this.d=P,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let P=function(a){if(u.a){const $=new Error("Response stream has been closed");throw Error.captureStackTrace($,a),$}};const u=this,w=a=>{this.d.$handleProgressChunk(this.c,a)};this.b={progress(a){P(this.progress);const $=new R.$xP(a),f=L.ChatResponseProgressPart.from($);return w(f),this},reference(a){P(this.reference);const $=new R.$BP(a),f=L.ChatResponseReferencePart.from($);return w(f),this},push(a){return P(this.push),a instanceof R.$BP?w(L.ChatResponseReferencePart.from(a)):a instanceof R.$xP&&w(L.ChatResponseProgressPart.from(a)),this}}}return this.b}}}),define(ke[296],Ie([1,0,7,59,4,3,40,2,87,23,15,9,6,25]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Foc=w,b=Ue(b),I=Ue(I),D=Ue(D);function w(a,$,f){const g=a.getProxy(u.$sN.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new c.$pn,$.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===L.MarshalledId.CommentController){const k=this.b.get(y.handle);return k?k.value:y}else if(y&&y.$mid===L.MarshalledId.CommentThread){const k=y,A=this.b.get(k.commentControlHandle);if(!A)return k;const p=A.getCommentThread(k.commentThreadHandle);return p?p.value:k}else if(y&&(y.$mid===L.MarshalledId.CommentThreadReply||y.$mid===L.MarshalledId.CommentThreadInstance)){const k=this.b.get(y.thread.commentControlHandle);if(!k)return y;const A=k.getCommentThread(y.thread.commentThreadHandle);return A?y.$mid===L.MarshalledId.CommentThreadInstance?A.value:{thread:A.value,text:y.text}:y}else if(y&&y.$mid===L.MarshalledId.CommentNode){const k=this.b.get(y.thread.commentControlHandle);if(!k)return y;const A=k.getCommentThread(y.thread.commentThreadHandle);if(!A)return y;const p=y.commentUniqueId,v=A.getCommentByUniqueId(p);return v||y}else if(y&&y.$mid===L.MarshalledId.CommentThreadNode){const k=this.b.get(y.thread.commentControlHandle);if(!k)return y;const A=k.getCommentThread(y.thread.commentThreadHandle);if(!A)return y;const p=y.text,v=y.commentUniqueId,F=A.getCommentByUniqueId(v);return F?(typeof F.body=="string"?F.body=p:F.body=new D.$WN(p),F):y}return y}})}createCommentController(y,k,A){const p=i.a++,v=new t(y,p,k,A);this.b.set(v.handle,v);const F=this.c.get(y.identifier)||[];return F.push(v),this.c.set(y.identifier,F),v.value}async $createCommentThreadTemplate(y,k,A,p){const v=this.b.get(y);v&&v.$createCommentThreadTemplate(k,A,p)}async $setActiveComment(y,k){const A=this.b.get(y);A&&A.$setActiveComment(k??void 0)}async $updateCommentThreadTemplate(y,k,A){const p=this.b.get(y);p&&p.$updateCommentThreadTemplate(k,A)}$deleteCommentThread(y,k){this.b.get(y)?.$deleteCommentThread(k)}async $provideCommentingRanges(y,k,A){const p=this.b.get(y);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const v=await f.ensureDocumentData(R.URI.revive(k));return(0,r.$uh)(async()=>{const F=await p.commentingRangeProvider.provideCommentingRanges(v.document,A);let N;return Array.isArray(F)?N={ranges:F,fileComments:!1}:F?N={ranges:F.ranges||[],fileComments:F.enableFileComments||!1}:N=F??void 0,N}).then(F=>{let N;return F&&(N={ranges:F.ranges.map(O=>I.Range.from(O)),fileComments:F.fileComments}),N})}$toggleReaction(y,k,A,p,v){const F=this.b.get(y);return!F||!F.reactionHandler?Promise.resolve(void 0):(0,r.$uh)(()=>{const N=F.getCommentThread(k);if(N){const O=N.getCommentByUniqueId(p.uniqueIdInThread);if(F!==void 0&&O&&F.reactionHandler)return F.reactionHandler(O,d(v))}return Promise.resolve(void 0)})}}class o{static{this.a=0}set threadId(y){this.n=y}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(y){(y===void 0!=(this.p===void 0)||!y||!this.p||!y.isEqual(this.p))&&(this.p=y,this.b.range=y,this.c.fire())}get range(){return this.p}set canReply(y){this.d!==y&&(this.d=y,this.b.canReply=y,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(y){this.e=y,this.b.label=y,this.c.fire()}get contextValue(){return this.f}set contextValue(y){this.f=y,this.b.contextValue=y,this.c.fire()}get comments(){return this.q}set comments(y){this.q=y,this.b.comments=y,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(y){this.g=y,this.b.collapsibleState=y,this.c.fire()}get state(){return this.h}set state(y){this.h=y,typeof y=="object"?((0,P.$5G)(this.extensionDescription,"commentThreadApplicability"),this.b.state=y.resolved,this.b.applicability=y.applicability):this.b.state=y,this.c.fire()}get isDisposed(){return this.j}constructor(y,k,A,p,v,F,N,O,j){this.m=k,this.n=A,this.o=p,this.p=v,this.q=F,this.extensionDescription=N,this.r=O,this.handle=o.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$je,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new T.$Uc,this.l.value=new T.$Sc,this.n===void 0&&(this.n=`${y}.${this.handle}`),g.$createCommentThread(k,this.handle,this.n,this.o,I.Range.from(this.p),this.q.map(M=>s(this,M,this.k,this.extensionDescription)),N.identifier,this.r,j),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.i.push({dispose:()=>{g.$deleteCommentThread(k,this.handle)}});const z=this;this.value={get uri(){return z.uri},get range(){return z.range},set range(M){z.range=M},get comments(){return z.comments},set comments(M){z.comments=M},get collapsibleState(){return z.collapsibleState},set collapsibleState(M){z.collapsibleState=M},get canReply(){return z.canReply},set canReply(M){z.canReply=M},get contextValue(){return z.contextValue},set contextValue(M){z.contextValue=M},get label(){return z.label},set label(M){z.label=M},get state(){return z.state},set state(M){z.state=M},reveal:M=>z.reveal(M),dispose:()=>{z.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new T.$Sc);const y=A=>Object.prototype.hasOwnProperty.call(this.b,A),k={};y("range")&&(k.range=I.Range.from(this.p)),y("label")&&(k.label=this.label),y("contextValue")&&(k.contextValue=this.contextValue??null),y("comments")&&(k.comments=this.q.map(A=>s(this,A,this.k,this.extensionDescription))),y("collapsibleState")&&(k.collapseState=l(this.g)),y("canReply")&&(k.canReply=this.canReply),y("state")&&(k.state=m(this.h)),y("applicability")&&(k.applicability=E(this.h)),y("isTemplate")&&(k.isTemplate=this.r),this.b={},g.$updateCommentThread(this.m,this.handle,this.n,this.o,k)}getCommentByUniqueId(y){for(const k of this.k){const A=k[0],p=k[1];if(y===p)return A}}async reveal(y){return(0,P.$5G)(this.extensionDescription,"commentReveal"),g.$revealCommentThread(this.m,this.handle,{preserveFocus:!1,focusReply:!1,...y})}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(y=>y.dispose())}}Ye([(0,h.$8h)(100)],o.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(y){this.b=y,y?.resourceHints&&(0,P.$5G)(this.h,"commentingRangeHint"),g.$updateCommentingRanges(this.handle,y?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(y){this.c=y,g.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!y})}get options(){return this.d}set options(y){this.d=y,g.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,P.$5G)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,P.$5G)(this.h,"activeComment"),this.f}constructor(y,k,A,p){this.h=y,this.i=k,this.j=A,this.k=p,this.a=new Map,g.$registerCommentController(this.handle,A,p,this.h.identifier.value);const v=this;this.value=Object.freeze({id:v.id,label:v.label,get options(){return v.options},set options(F){v.options=F},get commentingRangeProvider(){return v.commentingRangeProvider},set commentingRangeProvider(F){v.commentingRangeProvider=F},get reactionHandler(){return v.reactionHandler},set reactionHandler(F){v.reactionHandler=F},get activeCommentThread(){return v.activeCommentThread},createCommentThread(F,N,O){return v.createCommentThread(F,N,O).value},dispose:()=>{v.dispose()}}),this.g=[],this.g.push({dispose:()=>{g.$unregisterCommentController(this.handle)}})}createCommentThread(y,k,A){k===void 0&&(0,P.$5G)(this.h,"fileComments");const p=new o(this.id,this.handle,void 0,y,k,A,this.h,!1);return this.a.set(p.handle,p),p}$setActiveComment(y){if(!y){this.e=void 0,this.f=void 0;return}const k=this.a.get(y.commentThreadHandle);k&&(this.e=y.uniqueIdInThread?k.getCommentByUniqueId(y.uniqueIdInThread):void 0,this.f=k)}$createCommentThreadTemplate(y,k,A){const p=new o(this.id,this.handle,void 0,R.URI.revive(y),I.Range.to(k),[],this.h,!0,A);return p.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(p.handle,p),p}$updateCommentThreadTemplate(y,k){const A=this.a.get(y);A&&(A.range=I.Range.to(k))}$deleteCommentThread(y){this.a.get(y)?.dispose(),this.a.delete(y)}getCommentThread(y){return this.a.get(y)}dispose(){this.a.forEach(y=>{y.dispose()}),this.g.forEach(y=>y.dispose())}}function s(S,y,k,A){let p=k.get(y);return p||(p=++S.commentHandle,k.set(y,p)),y.state!==void 0&&(0,P.$5G)(A,"commentsDraftState"),y.reactions?.some(v=>v.reactors!==void 0)&&(0,P.$5G)(A,"commentReactor"),{mode:y.mode,contextValue:y.contextValue,uniqueIdInThread:p,body:typeof y.body=="string"?y.body:I.MarkdownString.from(y.body),userName:y.author.name,userIconPath:y.author.iconPath,label:y.label,commentReactions:y.reactions?y.reactions.map(v=>n(v)):void 0,state:y.state,timestamp:y.timestamp?.toJSON()}}function n(S){return{label:S.label,iconPath:S.iconPath?I.$ZP(S.iconPath):void 0,count:S.count,hasReacted:S.authorHasReacted,reactors:S.reactors&&S.reactors.length>0&&typeof S.reactors[0]!="string"?S.reactors.map(y=>y.name):S.reactors}}function d(S){return{label:S.label||"",count:S.count||0,iconPath:S.iconPath?R.URI.revive(S.iconPath):"",authorHasReacted:S.hasReacted||!1,reactors:S.reactors?.map(y=>({name:y}))}}function l(S){if(S!==void 0)switch(S){case D.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case D.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function m(S){let y;if(typeof S=="object"?y=S.resolved:y=S,y!==void 0)switch(y){case D.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case D.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}function E(S){let y;if(typeof S=="object"&&(y=S.applicability),y!==void 0)switch(y){case D.CommentThreadApplicability.Current:return b.CommentThreadApplicability.Current;case D.CommentThreadApplicability.Outdated:return b.CommentThreadApplicability.Outdated}return b.CommentThreadApplicability.Current}return new i}}),define(ke[297],Ie([1,0,20,60,3,14,22,2,15,96,118,6,9]),function(me,e,r,h,C,T,L,R,b,c,I,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xoc=void 0,b=Ue(b),D=Ue(D),u=Ue(u);class P{constructor(n,d){this.document=n,this.b=d,this.a=1,this.c=new I.$loc("custom documents")}addEdit(n){return this.c.add([n])}async undo(n,d){await this.f(n).undo(),d||this.disposeBackup()}async redo(n,d){await this.f(n).redo(),d||this.disposeBackup()}disposeEdits(n){for(const d of n)this.c.delete(d)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const n=t(this.document.uri)+this.a++;return(0,L.$dh)(this.b,n)}updateBackup(n){this.d?.delete(),this.d=n}disposeBackup(){this.d?.delete(),this.d=void 0}f(n){const d=this.c.get(n,0);if(!d)throw new Error("No edit found");return d}}class w{constructor(){this.a=new Map}get(n,d){return this.a.get(this.b(n,d))}add(n,d,l){const m=this.b(n,d.uri);if(this.a.has(m))throw new Error(`Document already exists for viewType:${n} resource:${d.uri}`);const E=new P(d,l);return this.a.set(m,E),E}delete(n,d){const l=this.b(n,d.uri);this.a.delete(l)}b(n,d){return`${n}@@@${d}`}}var a;(function(s){s[s.Text=0]="Text",s[s.Custom=1]="Custom"})(a||(a={}));class ${constructor(){this.a=new Map}addTextProvider(n,d,l){return this.b(n,{type:a.Text,extension:d,provider:l})}addCustomProvider(n,d,l){return this.b(n,{type:a.Custom,extension:d,provider:l})}get(n){return this.a.get(n)}b(n,d){if(this.a.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this.a.set(n,d),new u.$uN(()=>this.a.delete(n))}}class f{constructor(n,d,l,m,E){this.d=d,this.f=l,this.g=m,this.h=E,this.b=new $,this.c=new w,this.a=n.getProxy(D.$sN.MainThreadCustomEditors)}registerCustomEditorProvider(n,d,l,m){const E=new C.$Sc;return i(l)?(E.add(this.b.addTextProvider(d,n,l)),this.a.$registerTextEditorProvider((0,c.$Uoc)(n),d,m.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,c.$Soc)(n))):(E.add(this.b.addCustomProvider(d,n,l)),g(l)&&E.add(l.onDidChangeCustomDocument(S=>{const y=this.i(d,S.document.uri);if(o(S)){const k=y.addEdit(S);this.a.$onDidEdit(S.document.uri,d,k,S.label)}else this.a.$onContentChange(S.document.uri,d)})),this.a.$registerCustomEditorProvider((0,c.$Uoc)(n),d,m.webviewOptions||{},!!m.supportsMultipleEditorsPerDocument,(0,c.$Soc)(n))),u.$uN.from(E,new u.$uN(()=>{this.a.$unregisterEditorProvider(d)}))}async $createCustomDocument(n,d,l,m,E){const S=this.b.get(d);if(!S)throw new Error(`No provider found for '${d}'`);if(S.type!==a.Custom)throw new Error(`Invalid provide type for '${d}'`);const y=R.URI.revive(n),k=await S.provider.openCustomDocument(y,{backupId:l,untitledDocumentData:m?.buffer},E);let A;return g(S.provider)&&this.f&&(A=this.f.workspaceValue(S.extension)??this.f.globalValue(S.extension)),this.c.add(d,k,A),{editable:g(S.provider)}}async $disposeCustomDocument(n,d){const l=this.b.get(d);if(!l)throw new Error(`No provider found for '${d}'`);if(l.type!==a.Custom)throw new Error(`Invalid provider type for '${d}'`);const m=R.URI.revive(n),{document:E}=this.i(d,m);this.c.delete(d,E),E.dispose()}async $resolveCustomEditor(n,d,l,m,E,S){const y=this.b.get(l);if(!y)throw new Error(`No provider found for '${l}'`);const k=b.ViewColumn.to(E),A=this.g.createNewWebview(d,m.contentOptions,y.extension),p=this.h.createNewWebviewPanel(d,l,m.title,k,m.options,A,m.active),v=R.URI.revive(n);switch(y.type){case a.Custom:{const{document:F}=this.i(l,v);return y.provider.resolveCustomEditor(F,p,S)}case a.Text:{const F=this.d.getDocument(v);return y.provider.resolveCustomTextEditor(F,p,S)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(n,d,l){this.i(d,n).disposeEdits(l)}async $onMoveCustomEditor(n,d,l){const m=this.b.get(l);if(!m)throw new Error(`No provider found for '${l}'`);if(!m.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const E=this.h.getWebviewPanel(n);if(!E)throw new Error("No webview found");const S=R.URI.revive(d),y=this.d.getDocument(S);await m.provider.moveCustomTextEditor(y,E,r.CancellationToken.None)}async $undo(n,d,l,m){return this.i(d,n).undo(l,m)}async $redo(n,d,l,m){return this.i(d,n).redo(l,m)}async $revert(n,d,l){const m=this.i(d,n);await this.j(d).revertCustomDocument(m.document,l),m.disposeBackup()}async $onSave(n,d,l){const m=this.i(d,n);await this.j(d).saveCustomDocument(m.document,l),m.disposeBackup()}async $onSaveAs(n,d,l,m){const E=this.i(d,n);return this.j(d).saveCustomDocumentAs(E.document,R.URI.revive(l),m)}async $backup(n,d,l){const m=this.i(d,n),S=await this.j(d).backupCustomDocument(m.document,{destination:m.getNewBackupUri()},l);return m.updateBackup(S),S.id}i(n,d){const l=this.c.get(n,R.URI.revive(d));if(!l)throw new Error("No custom document found");return l}j(n){const l=this.b.get(n)?.provider;if(!l||!g(l))throw new Error("Custom document is not editable");return l}}e.$Xoc=f;function g(s){return!!s.onDidChangeCustomDocument}function i(s){return typeof s.resolveCustomTextEditor=="function"}function o(s){return typeof s.undo=="function"&&typeof s.redo=="function"}function t(s){const n=s.scheme===T.Schemas.file||s.scheme===T.Schemas.untitled?s.fsPath:s.toString();return(0,h.$qj)(n)+""}}),define(ke[298],Ie([1,0,8,145,2,6,9,15,4,11,28,62]),function(me,e,r,h,C,T,L,R,b,c,I,D){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$toc=e.$soc=void 0,R=Ue(R);class P{#e;#t;#i;constructor($,f,g,i,o,t,s,n){this.d=$,this.e=f,this.f=g,this.g=i,this.h=o,this.c=!1,this.f=Math.max(i,g),this.#i=new I.$zc(d=>t.getComparisonKey(d)),this.#e=s,this.#t=n}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set($,f){if(!$){this.clear();return}this.j();let g=[];if(C.URI.isUri($)){if(!f){this.delete($);return}this.#i.set($,f.slice()),g=[$]}else if(Array.isArray($)){g=[];let t;$=[...$].sort(P.k);for(const s of $){const[n,d]=s;if((!t||n.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=n,g.push(n),this.#i.set(n,[])),d)this.#i.get(n)?.push(...d);else{const l=this.#i.get(n);l&&(l.length=0)}}}if(this.#t.fire(g),!this.#e)return;const i=[];let o=0;for(const t of g){let s=[];const n=this.#i.get(t);if(n)if(n.length>this.g){s=[];const d=[L.DiagnosticSeverity.Error,L.DiagnosticSeverity.Warning,L.DiagnosticSeverity.Information,L.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const m of n)if(m.severity===d[l]&&s.push({...R.Diagnostic.from(m),modelVersionId:this.h(t)})===this.g)break e;s.push({severity:h.MarkerSeverity.Info,message:(0,r.localize)(10673,null,n.length-this.g),startLineNumber:s[s.length-1].startLineNumber,startColumn:s[s.length-1].startColumn,endLineNumber:s[s.length-1].endLineNumber,endColumn:s[s.length-1].endColumn})}else s=n.map(d=>({...R.Diagnostic.from(d),modelVersionId:this.h(t)}));if(i.push([t,s]),o+=s.length,o>this.f)break}this.#e.$changeMany(this.e,i)}delete($){this.j(),this.#t.fire([$]),this.#i.delete($),this.#e?.$changeMany(this.e,[[$,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach($,f){this.j();for(const[g,i]of this)$.call(f,g,i,this)}*[Symbol.iterator](){this.j();for(const $ of this.#i.keys())yield[$,this.get($)]}get($){this.j();const f=this.#i.get($);return Array.isArray(f)?Object.freeze(f.slice(0)):[]}has($){return this.j(),Array.isArray(this.#i.get($))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k($,f){return $[0].toString()<f[0].toString()?-1:$[0].toString()>f[0].toString()?1:0}}e.$soc=P;let w=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper($){const f=new I.$zc;for(const g of $)f.set(g,g);return{uris:Object.freeze(Array.from(f.values()))}}constructor($,f,g,i){this.j=f,this.k=g,this.l=i,this.g=new Map,this.h=new b.$ne({merge:o=>o.flat(),delay:50}),this.onDidChangeDiagnostics=b.Event.map(this.h.event,u._mapper),this.f=$.getProxy(T.$sN.MainThreadDiagnostics)}createDiagnosticCollection($,f){const{g,f:i,h:o,j:t,k:s,l:n}=this,d=new class{$changeMany(E,S){i.$changeMany(E,S),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",$.value,E,S.length===0?"CLEARING":S)}$clear(E){i.$clear(E),t.trace("[DiagnosticCollection] remove all (extension, owner)",$.value,E)}dispose(){i.dispose()}};let l;if(!f)f="_generated_diagnostic_collection_name_#"+u.c++,l=f;else if(!g.has(f))l=f;else{this.j.warn(`DiagnosticCollection with name '${f}' does already exist.`);do l=f+u.c++;while(g.has(l))}return new class extends P{constructor(){super(f,l,u.e,u.d,E=>n.getDocument(E)?.version,s.extUri,d,o),g.set(l,this)}dispose(){super.dispose(),g.delete(l)}}}getDiagnostics($){if($)return this.m($);{const f=new Map,g=[];for(const i of this.g.values())i.forEach((o,t)=>{let s=f.get(o.toString());typeof s>"u"&&(s=g.length,f.set(o.toString(),s),g.push([o,[]])),g[s][1]=g[s][1].concat(...t)});return g}}m($){let f=[];for(const g of this.g.values())g.has($)&&(f=f.concat(g.get($)));return f}$acceptMarkersChange($){if(!this.n){const f="_generated_mirror",g=new P(f,f,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(f,g),this.n=g}for(const[f,g]of $)this.n.set(C.URI.revive(f),g.map(R.Diagnostic.to))}};e.$toc=w,e.$toc=w=u=Ye([Ve(1,c.$9j),Ve(2,D.$roc)],w)}),define(ke[299],Ie([1,0,2,13,9,15,80,53]),function(me,e,r,h,C,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gpc=void 0;class b{constructor(I,D,u,P={timeout:1500,errors:3}){this.c=I,this.d=D,this.f=u,this.g=P,this.a=new L.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(I){return(D,u,P)=>{const a={dispose:this.a.push([D,u,I])};return Array.isArray(P)&&P.push(a),a}}async $participateInSave(I,D){const u=r.URI.revive(I);let P=!1;const w=setTimeout(()=>P=!0,this.g.timeout),a=[];try{for(const $ of[...this.a]){if(P)break;const f=this.d.getDocument(u),g=await this.h($,{document:f,reason:T.TextDocumentSaveReason.to(D)});a.push(g)}}finally{clearTimeout(w)}return a}h([I,D,u],P){const w=this.b.get(I);return typeof w=="number"&&w>this.g.errors?Promise.resolve(!1):this.i(u,I,D,P).then(()=>!0,a=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this.c.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const $=this.b.get(I);this.b.set(I,$?$+1:1),typeof $=="number"&&$>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(I,D,u,P){const w=[],a=Date.now(),{document:$,reason:f}=P,{version:g}=$,i=Object.freeze({document:$,reason:f,waitUntil(o){if(Object.isFrozen(w))throw(0,h.$7)("waitUntil can not be called async");w.push(Promise.resolve(o))}});try{D.apply(u,[i])}catch(o){return Promise.reject(o)}return Object.freeze(w),new Promise((o,t)=>{const s=setTimeout(()=>t(new Error("timeout")),this.g.timeout);return Promise.all(w).then(n=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(s),o(n)}).catch(n=>{clearTimeout(s),t(n)})}).then(o=>{const t={edits:[]};for(const s of o)if(Array.isArray(s)&&s.every(n=>n instanceof C.$BN))for(const{newText:n,newEol:d,range:l}of s)t.edits.push({resource:$.uri,versionId:void 0,textEdit:{range:l&&T.Range.from(l),text:n,eol:d&&T.EndOfLine.from(d)}});if(t.edits.length!==0)return g===$.version?this.f.$tryApplyWorkspaceEdit(new R.$Sw(t)):Promise.reject(new Error("concurrent_edits"))})}}e.$Gpc=b}),define(ke[300],Ie([1,0,4,3,2,6,164,15,17,24,9]),function(me,e,r,h,C,T,L,R,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uoc=void 0,R=Ue(R);class D{constructor(P,w){this.a=new r.$je,this.b=new r.$je,this.c=new r.$je,this.d=new r.$je,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new h.$Sc,this.h=new Map,this.f=P.getProxy(T.$sN.MainThreadDocuments),this.g=w,this.g.onDidRemoveDocuments(a=>{for(const $ of a)this.b.fire($.document)},void 0,this.e),this.g.onDidAddDocuments(a=>{for(const $ of a)this.a.fire($.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(P){if(!P)return;const w=this.g.getDocument(P);if(w)return w}getDocument(P){const w=this.getDocumentData(P);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${P}'`);return w.document}ensureDocumentData(P){const w=this.g.getDocument(P);if(w)return Promise.resolve(w);let a=this.h.get(P.toString());return a||(a=this.f.$tryOpenDocument(P).then($=>{this.h.delete(P.toString());const f=C.URI.revive($);return(0,b.$ng)(this.g.getDocument(f))},$=>(this.h.delete(P.toString()),Promise.reject($))),this.h.set(P.toString(),a)),a}createDocumentData(P){return this.f.$tryCreateDocument(P).then(w=>C.URI.revive(w))}$acceptModelLanguageChanged(P,w){const a=C.URI.revive(P),$=this.g.getDocument(a);if(!$)throw new Error("unknown document");this.b.fire($.document),$._acceptLanguageId(w),this.a.fire($.document)}$acceptModelSaved(P){const w=C.URI.revive(P),a=this.g.getDocument(w);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(P,!1),this.d.fire(a.document)}$acceptDirtyStateChanged(P,w){const a=C.URI.revive(P),$=this.g.getDocument(a);if(!$)throw new Error("unknown document");$._acceptIsDirty(w),this.c.fire({document:$.document,contentChanges:[],reason:void 0})}$acceptModelChanged(P,w,a){const $=C.URI.revive(P),f=this.g.getDocument($);if(!f)throw new Error("unknown document");f._acceptIsDirty(a),f.onEvents(w);let g;w.isUndoing?g=I.TextDocumentChangeReason.Undo:w.isRedoing&&(g=I.TextDocumentChangeReason.Redo),this.c.fire((0,c.$bo)({document:f.document,contentChanges:w.changes.map(i=>({range:R.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:g}))}setWordDefinitionFor(P,w){(0,L.$3P)(P,w)}}e.$uoc=D}),define(ke[77],Ie([1,0,78,4,17,2,5,6,19,15,9]),function(me,e,r,h,C,T,L,R,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zoc=e.$Yoc=void 0,c=Ue(c),e.$Yoc=(0,L.$Ci)("IExtHostEditorTabs");class D{constructor($,f,g){this.e=g,this.d=f,this.acceptDtoUpdate($)}get apiObject(){if(!this.a){const $=this,f={get isActive(){return $.b.id===$.e()},get label(){return $.b.label},get input(){return $.c},get isDirty(){return $.b.isDirty},get isPinned(){return $.b.isPinned},get isPreview(){return $.b.isPreview},get group(){return $.d.apiObject}};this.a=Object.freeze(f)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate($){this.b=$,this.c=this.f()}f(){switch(this.b.input.kind){case R.TabInputKind.TextInput:return new I.$fP(T.URI.revive(this.b.input.uri));case R.TabInputKind.TextDiffInput:return new I.$gP(T.URI.revive(this.b.input.original),T.URI.revive(this.b.input.modified));case R.TabInputKind.TextMergeInput:return new I.$hP(T.URI.revive(this.b.input.base),T.URI.revive(this.b.input.input1),T.URI.revive(this.b.input.input2),T.URI.revive(this.b.input.result));case R.TabInputKind.CustomEditorInput:return new I.$iP(T.URI.revive(this.b.input.uri),this.b.input.viewType);case R.TabInputKind.WebviewEditorInput:return new I.$jP(this.b.input.viewType);case R.TabInputKind.NotebookInput:return new I.$kP(T.URI.revive(this.b.input.uri),this.b.input.notebookType);case R.TabInputKind.NotebookDiffInput:return new I.$lP(T.URI.revive(this.b.input.original),T.URI.revive(this.b.input.modified),this.b.input.notebookType);case R.TabInputKind.TerminalEditorInput:return new I.$mP;case R.TabInputKind.InteractiveEditorInput:return new I.$nP(T.URI.revive(this.b.input.uri),T.URI.revive(this.b.input.inputBoxUri));case R.TabInputKind.ChatEditorInput:return new I.$oP;case R.TabInputKind.MultiDiffEditorInput:return new I.$pP(this.b.input.diffEditors.map($=>new I.$gP(T.URI.revive($.original),T.URI.revive($.modified))));default:return}}}class u{constructor($,f){this.c=[],this.d="",this.b=$,this.e=f;for(const g of $.tabs)g.isActive&&(this.d=g.id),this.c.push(new D(g,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const $=this,f={get isActive(){return $.b.groupId===$.e()},get viewColumn(){return c.ViewColumn.to($.b.viewColumn)},get activeTab(){return $.c.find(g=>g.tabId===$.d)?.apiObject},get tabs(){return Object.freeze($.c.map(g=>g.apiObject))}};this.a=Object.freeze(f)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate($){this.b=$}acceptTabOperation($){if($.kind===R.TabModelOperationKind.TAB_OPEN){const g=new D($.tabDto,this,()=>this.activeTabId());return this.c.splice($.index,0,g),$.tabDto.isActive&&(this.d=g.tabId),g}else if($.kind===R.TabModelOperationKind.TAB_CLOSE){const g=this.c.splice($.index,1)[0];if(!g)throw new Error(`Tab close updated received for index ${$.index} which does not exist`);return g.tabId===this.d&&(this.d=""),g}else if($.kind===R.TabModelOperationKind.TAB_MOVE){if($.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const g=this.c.splice($.oldIndex,1)[0];if(!g)throw new Error(`Tab move updated received for index ${$.oldIndex} which does not exist`);return this.c.splice($.index,0,g),g}const f=this.c.find(g=>g.tabId===$.tabDto.id);if(!f)throw new Error("INVALID tab");return $.tabDto.isActive?this.d=$.tabDto.id:this.d===$.tabDto.id&&!$.tabDto.isActive&&(this.d=""),f.acceptDtoUpdate($.tabDto),f}activeTabId(){return this.d}}let P=class{constructor($){this.b=new h.$je,this.c=new h.$je,this.e=[],this.a=$.getProxy(R.$sN.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const $=this,f={onDidChangeTabGroups:$.c.event,onDidChangeTabs:$.b.event,get all(){return Object.freeze($.e.map(g=>g.apiObject))},get activeTabGroup(){const g=$.d;return(0,C.$ng)($.e.find(o=>o.groupId===g)?.apiObject)},close:async(g,i)=>{const o=Array.isArray(g)?g:[g];return o.length?w(o[0])?this.j(o,i):this.i(o,i):!0}};this.f=Object.freeze(f)}return this.f}$acceptEditorTabModel($){const f=new Set(this.e.map(d=>d.groupId)),g=new Set($.map(d=>d.groupId)),i=(0,r.$d)(f,g),o=this.e.filter(d=>i.removed.includes(d.groupId)).map(d=>d.apiObject),t=[],s=[];this.e=$.map(d=>{const l=new u(d,()=>this.d);return i.added.includes(l.groupId)?t.push(l.apiObject):s.push(l.apiObject),l});const n=(0,C.$ng)($.find(d=>d.isActive===!0)?.groupId);n!==void 0&&this.d!==n&&(this.d=n),this.c.fire(Object.freeze({opened:t,closed:o,changed:s}))}$acceptTabGroupUpdate($){const f=this.e.find(g=>g.groupId===$.groupId);if(!f)throw new Error("Update Group IPC call received before group creation.");f.acceptGroupDtoUpdate($),$.isActive&&(this.d=$.groupId),this.c.fire(Object.freeze({changed:[f.apiObject],opened:[],closed:[]}))}$acceptTabOperation($){const f=this.e.find(i=>i.groupId===$.groupId);if(!f)throw new Error("Update Tabs IPC call received before group creation.");const g=f.acceptTabOperation($);switch($.kind){case R.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[g.apiObject],closed:[],changed:[]}));return;case R.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[g.apiObject],changed:[]}));return;case R.TabModelOperationKind.TAB_MOVE:case R.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[g.apiObject]}));return}}g($){for(const f of this.e)for(const g of f.tabs)if(g.apiObject===$)return g}h($){return this.e.find(f=>f.apiObject===$)}async i($,f){const g=[];for(const i of $){const o=this.g(i);if(!o)throw new Error("Tab close: Invalid tab not found!");g.push(o.tabId)}return this.a.$closeTab(g,f)}async j($,f){const g=[];for(const i of $){const o=this.h(i);if(!o)throw new Error("Group close: Invalid group not found!");g.push(o.groupId)}return this.a.$closeGroup(g,f)}};e.$Zoc=P,e.$Zoc=P=Ye([Ve(0,b.$1P)],P);function w(a){return a.tabs!==void 0}}),define(ke[301],Ie([1,0,2,6,27,3,9,15,202,12,26,21,25,85]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jpc=void 0,C=Ue(C),R=Ue(R);class w{constructor(){this.a=[]}add(f){this.b=void 0,this.a.push(f)}delete(f){const g=this.a.indexOf(f);g>=0&&(this.a.splice(g,1),this.b=void 0)}c(){if(!this.b){const f=this.a.sort(),g=[];let i,o,t=b.State.LastKnownState,s=b.State.LastKnownState;for(const n of f){let d=i?(0,c.$Ff)(i,n):0;for(d===0?o=b.State.Start:o=s;d<n.length;d++)d+1===n.length?(t=s,s=b.State.BeforeColon):s+=1,g.push([o,n.toUpperCase().charCodeAt(d),s]),g.push([o,n.toLowerCase().charCodeAt(d),s]),o=s;i=n,s=t}g.push([b.State.BeforeColon,I.CharCode.Colon,b.State.AfterColon]),g.push([b.State.AfterColon,I.CharCode.Slash,b.State.End]),this.b=new b.$f4(g)}}provideDocumentLinks(f){this.c();const g=[],i=b.$g4.computeLinks({getLineContent(o){return f.lineAt(o-1).text},getLineCount(){return f.lineCount}},this.b);for(const o of i){const t=R.DocumentLink.to(o);t.target&&g.push(t)}return g}}class a{constructor(f,g){this.i=g,this.b=new w,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=f.getProxy(h.$sN.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(f,g,i,o={}){if(a.j(i),this.d.has(g))throw new Error(`a provider for the scheme '${g}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(f,"*",this.b));const t=this.h++;this.b.add(g),this.d.add(g),this.c.set(t,i);let s=C.FileSystemProviderCapabilities.FileReadWrite;o.isCaseSensitive&&(s+=C.FileSystemProviderCapabilities.PathCaseSensitive),o.isReadonly&&(s+=C.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(s+=C.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,u.$5G)(f,"fsChunks"),s+=C.FileSystemProviderCapabilities.FileOpenReadWriteClose);let n;o.isReadonly&&(0,P.$2k)(o.isReadonly)&&o.isReadonly.value!==""&&(n={value:o.isReadonly.value,isTrusted:o.isReadonly.isTrusted,supportThemeIcons:o.isReadonly.supportThemeIcons,supportHtml:o.isReadonly.supportHtml,baseUri:o.isReadonly.baseUri,uris:o.isReadonly.uris}),this.a.$registerFileSystemProvider(t,g,s,n).catch(l=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${g}`),console.error(l)});const d=i.onDidChangeFile(l=>{const m=[];for(const E of l){const{uri:S,type:y}=E;if(S.scheme!==g)continue;let k;switch(y){case L.FileChangeType.Changed:k=C.FileChangeType.UPDATED;break;case L.FileChangeType.Created:k=C.FileChangeType.ADDED;break;case L.FileChangeType.Deleted:k=C.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}m.push({resource:S,type:k})}this.a.$onFileSystemChange(t,m)});return(0,T.$Rc)(()=>{d.dispose(),this.b.delete(g),this.d.delete(g),this.c.delete(t),this.a.$unregisterProvider(t)})}static j(f){if(!f)throw new Error("MISSING provider");if(typeof f.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof f.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof f.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof f.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof f.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof f.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof f.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof f.rename!="function")throw new Error("Provider does NOT implement rename")}static k(f){const{type:g,ctime:i,mtime:o,size:t,permissions:s}=f;return{type:g,ctime:i,mtime:o,size:t,permissions:s}}$stat(f,g){return Promise.resolve(this.l(f).stat(r.URI.revive(g))).then(i=>a.k(i))}$readdir(f,g){return Promise.resolve(this.l(f).readDirectory(r.URI.revive(g)))}$readFile(f,g){return Promise.resolve(this.l(f).readFile(r.URI.revive(g))).then(i=>D.$Le.wrap(i))}$writeFile(f,g,i,o){return Promise.resolve(this.l(f).writeFile(r.URI.revive(g),i.buffer,o))}$delete(f,g,i){return Promise.resolve(this.l(f).delete(r.URI.revive(g),i))}$rename(f,g,i,o){return Promise.resolve(this.l(f).rename(r.URI.revive(g),r.URI.revive(i),o))}$copy(f,g,i,o){const t=this.l(f);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(r.URI.revive(g),r.URI.revive(i),o))}$mkdir(f,g){return Promise.resolve(this.l(f).createDirectory(r.URI.revive(g)))}$watch(f,g,i,o){const t=this.l(f).watch(r.URI.revive(i),o);this.f.set(g,t)}$unwatch(f,g){const i=this.f.get(g);i&&(i.dispose(),this.f.delete(g))}$open(f,g,i){const o=this.l(f);if(!o.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(o.open(r.URI.revive(g),i))}$close(f,g){const i=this.l(f);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(g))}$read(f,g,i,o){const t=this.l(f);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const s=D.$Le.alloc(o);return Promise.resolve(t.read(g,i,s.buffer,0,o)).then(n=>s.slice(0,n))}$write(f,g,i,o){const t=this.l(f);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(g,i,o.buffer,0,o.byteLength))}l(f){const g=this.c.get(f);if(!g){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return g}}e.$Jpc=a}),define(ke[302],Ie([1,0,4,38,2,6,15,9,27,49]),function(me,e,r,h,C,T,L,R,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kpc=void 0,L=Ue(L);class I{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(w,a,$,f,g,i){this.a=Math.random(),this.b=new r.$je,this.c=new r.$je,this.d=new r.$je,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const o=(0,h.$wk)(g),t=typeof g=="string",s=i?.correlate,n=f(d=>{if(!(typeof d.session=="number"&&d.session!==this.a)&&!(s&&typeof d.session>"u")){if(!i?.ignoreCreateEvents)for(const l of d.created){const m=C.URI.revive(l);o(m.fsPath)&&(!t||a.getWorkspaceFolder(m))&&this.b.fire(m)}if(!i?.ignoreChangeEvents)for(const l of d.changed){const m=C.URI.revive(l);o(m.fsPath)&&(!t||a.getWorkspaceFolder(m))&&this.c.fire(m)}if(!i?.ignoreDeleteEvents)for(const l of d.deleted){const m=C.URI.revive(l);o(m.fsPath)&&(!t||a.getWorkspaceFolder(m))&&this.d.fire(m)}}});this.g=R.$uN.from(this.i(w,$,g,i,i?.correlate),this.b,this.c,this.d,n)}i(w,a,$,f,g){const i=R.$uN.from();if(typeof $=="string"||f?.ignoreChangeEvents&&f?.ignoreCreateEvents&&f?.ignoreDeleteEvents)return i;const o=w.getProxy(T.$sN.MainThreadFileSystemEventService);let t=!1;($.pattern.includes(h.$sk)||$.pattern.includes(h.$tk))&&(t=!0);let s;return g&&(f?.ignoreChangeEvents||f?.ignoreCreateEvents||f?.ignoreDeleteEvents)&&(s=b.FileChangeFilter.UPDATED|b.FileChangeFilter.ADDED|b.FileChangeFilter.DELETED,f?.ignoreChangeEvents&&(s&=~b.FileChangeFilter.UPDATED),f?.ignoreCreateEvents&&(s&=~b.FileChangeFilter.ADDED),f?.ignoreDeleteEvents&&(s&=~b.FileChangeFilter.DELETED)),o.$watch(a.identifier.value,this.a,$.baseUri,{recursive:t,excludes:f?.excludes??[],filter:s},!!g),R.$uN.from({dispose:()=>o.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class D{constructor(w){this.a=w,this.session=this.a.session,this.b=new c.$T(()=>this.a.created.map(C.URI.revive)),this.c=new c.$T(()=>this.a.changed.map(C.URI.revive)),this.d=new c.$T(()=>this.a.deleted.map(C.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class u{constructor(w,a,$){this.j=w,this.k=a,this.l=$,this.a=new r.$je,this.b=new r.$je,this.c=new r.$je,this.d=new r.$je,this.g=new r.$le,this.h=new r.$le,this.i=new r.$le,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(w,a,$,f){return new I(this.j,w,a,this.a.event,L.GlobPattern.from($),f)}$onFileEvent(w){this.a.fire(new D(w))}$onDidRunFileOperation(w,a){switch(w){case b.FileOperation.MOVE:this.b.fire(Object.freeze({files:a.map($=>({oldUri:C.URI.revive($.source),newUri:C.URI.revive($.target)}))}));break;case b.FileOperation.DELETE:this.d.fire(Object.freeze({files:a.map($=>C.URI.revive($.target))}));break;case b.FileOperation.CREATE:case b.FileOperation.COPY:this.c.fire(Object.freeze({files:a.map($=>C.URI.revive($.target))}));break;default:}}getOnWillRenameFileEvent(w){return this.m(w,this.g)}getOnWillCreateFileEvent(w){return this.m(w,this.h)}getOnWillDeleteFileEvent(w){return this.m(w,this.i)}m(w,a){return($,f,g)=>{const i=function(t){$.call(f,t)};return i.extension=w,a.event(i,void 0,g)}}async $onWillRunFileOperation(w,a,$,f){switch(w){case b.FileOperation.MOVE:return await this.n(this.g,{files:a.map(g=>({oldUri:C.URI.revive(g.source),newUri:C.URI.revive(g.target)}))},$,f);case b.FileOperation.DELETE:return await this.n(this.i,{files:a.map(g=>C.URI.revive(g.target))},$,f);case b.FileOperation.CREATE:case b.FileOperation.COPY:return await this.n(this.h,{files:a.map(g=>C.URI.revive(g.target))},$,f)}}async n(w,a,$,f){const g=new Set,i=[];if(await w.fireAsync(a,f,async(t,s)=>{const n=Date.now(),d=await Promise.resolve(t);d instanceof R.$EN&&(i.push([s.extension,d]),g.add(s.extension.displayName??s.extension.identifier.value)),Date.now()-n>$&&this.k.warn("SLOW file-participant",s.extension.identifier)}),f.isCancellationRequested||i.length===0)return;const o={edits:[]};for(const[,t]of i){const{edits:s}=L.WorkspaceEdit.from(t,{getTextDocumentVersion:n=>this.l.getDocument(n)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(s)}return{edit:o,extensionNames:Array.from(g)}}}e.$Kpc=u}),define(ke[303],Ie([1,0,18,7,20,13,132,3,24,42,12,17,2,30,195,87,142,8,23,15,9,25,118,6]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a,$,f,g,i,o,t,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$voc=void 0,a=Ue(a),i=Ue(i),n=Ue(n);class d{constructor(U,q){this.d=U,this.e=q}async provideDocumentSymbols(U,q){const X=this.d.getDocument(U),_=await this.e.provideDocumentSymbols(X,q);if(!(0,r.$Jb)(_))return _[0]instanceof o.$ON?_.map(i.DocumentSymbol.from):d.f(_)}static f(U){U=U.slice(0).sort((_,de)=>{let be=_.location.range.start.compareTo(de.location.range.start);return be===0&&(be=de.location.range.end.compareTo(_.location.range.end)),be});const q=[],X=[];for(const _ of U){const de={name:_.name||"!!MISSING: name!!",kind:i.SymbolKind.from(_.kind),tags:_.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:_.containerName,range:i.Range.from(_.location.range),selectionRange:i.Range.from(_.location.range),children:[]};for(;;){if(X.length===0){X.push(de),q.push(de);break}const be=X[X.length-1];if(P.$Kt.containsRange(be.range,de.range)&&!P.$Kt.equalsRange(be.range,de.range)){be.children?.push(de),X.push(de);break}X.pop()}}return q}}class l{constructor(U,q,X,_,de,be){this.f=U,this.g=q,this.h=X,this.j=_,this.k=de,this.l=be,this.d=new s.$loc("CodeLens"),this.e=new Map}async provideCodeLenses(U,q){const X=this.f.getDocument(U),_=await this.h.provideCodeLenses(X,q);if(!_||q.isCancellationRequested)return;const de=this.d.add(_),be=new R.$Sc;this.e.set(de,be);const Ne={cacheId:de,lenses:[]};for(let Ge=0;Ge<_.length;Ge++)Ne.lenses.push({cacheId:[de,Ge],range:i.Range.from(_[Ge].range),command:this.g.toInternal(_[Ge].command,be)});return Ne}async resolveCodeLens(U,q){const X=U.cacheId&&this.d.get(...U.cacheId);if(!X)return;let _;if(typeof this.h.resolveCodeLens!="function"||X.isResolved?_=X:_=await this.h.resolveCodeLens(X,q),_||(_=X),q.isCancellationRequested)return;const de=U.cacheId&&this.e.get(U.cacheId[0]);if(de){if(!_.command){const be=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,be),this.l.error(be);return}return U.command=this.g.toInternal(_.command,de),U}}releaseCodeLenses(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}}function m(Te){return Array.isArray(Te)?Te.map(i.DefinitionLink.from):Te?[i.DefinitionLink.from(Te)]:[]}class E{constructor(U,q){this.d=U,this.e=q}async provideDefinition(U,q,X){const _=this.d.getDocument(U),de=i.Position.to(q),be=await this.e.provideDefinition(_,de,X);return m(be)}}class S{constructor(U,q){this.d=U,this.e=q}async provideDeclaration(U,q,X){const _=this.d.getDocument(U),de=i.Position.to(q),be=await this.e.provideDeclaration(_,de,X);return m(be)}}class y{constructor(U,q){this.d=U,this.e=q}async provideImplementation(U,q,X){const _=this.d.getDocument(U),de=i.Position.to(q),be=await this.e.provideImplementation(_,de,X);return m(be)}}class k{constructor(U,q){this.d=U,this.e=q}async provideTypeDefinition(U,q,X){const _=this.d.getDocument(U),de=i.Position.to(q),be=await this.e.provideTypeDefinition(_,de,X);return m(be)}}class A{static{this.f=10}constructor(U,q){this.g=U,this.h=q,this.d=0,this.e=new Map}async provideHover(U,q,X,_){const de=this.g.getDocument(U),be=i.Position.to(q);let Ne;if(X&&X.verbosityRequest){const rt=X.verbosityRequest.previousHover.id,ot=this.e.get(rt);if(!ot)throw new Error(`Hover with id ${rt} not found`);const nt={verbosityDelta:X.verbosityRequest.verbosityDelta,previousHover:ot};Ne=await this.h.provideHover(de,be,_,nt)}else Ne=await this.h.provideHover(de,be,_);if(!Ne||(0,r.$Jb)(Ne.contents))return;Ne.range||(Ne.range=de.getWordRangeAtPosition(be)),Ne.range||(Ne.range=new o.$wN(be,be));const Ge=i.Hover.from(Ne),Ke=this.d;if(this.e.size===A.f){const rt=Math.min(...this.e.keys());this.e.delete(rt)}return this.e.set(Ke,Ne),this.d+=1,{...Ge,id:Ke}}releaseHover(U){this.e.delete(U)}}class p{constructor(U,q){this.d=U,this.e=q}async provideEvaluatableExpression(U,q,X){const _=this.d.getDocument(U),de=i.Position.to(q),be=await this.e.provideEvaluatableExpression(_,de,X);if(be)return i.EvaluatableExpression.from(be)}}class v{constructor(U,q){this.d=U,this.e=q}async provideInlineValues(U,q,X,_){const de=this.d.getDocument(U),be=await this.e.provideInlineValues(de,i.Range.to(q),i.InlineValueContext.to(X),_);if(Array.isArray(be))return be.map(Ne=>i.InlineValue.from(Ne))}}class F{constructor(U,q){this.d=U,this.e=q}async provideDocumentHighlights(U,q,X){const _=this.d.getDocument(U),de=i.Position.to(q),be=await this.e.provideDocumentHighlights(_,de,X);if(Array.isArray(be))return be.map(i.DocumentHighlight.from)}}class N{constructor(U,q){this.d=U,this.e=q}async provideMultiDocumentHighlights(U,q,X,_){const de=this.d.getDocument(U),be=X.map(Ke=>this.d.getDocument(Ke)),Ne=i.Position.to(q),Ge=await this.e.provideMultiDocumentHighlights(de,Ne,be,_);if(Array.isArray(Ge))return Ge.map(i.MultiDocumentHighlight.from)}}class O{constructor(U,q){this.d=U,this.e=q}async provideLinkedEditingRanges(U,q,X){const _=this.d.getDocument(U),de=i.Position.to(q),be=await this.e.provideLinkedEditingRanges(_,de,X);if(be&&Array.isArray(be.ranges))return{ranges:(0,r.$Gb)(be.ranges.map(i.Range.from)),wordPattern:be.wordPattern}}}class j{constructor(U,q){this.d=U,this.e=q}async provideReferences(U,q,X,_){const de=this.d.getDocument(U),be=i.Position.to(q),Ne=await this.e.provideReferences(de,be,X,_);if(Array.isArray(Ne))return Ne.map(i.location.from)}}class z{static{this.d=1e3}constructor(U,q,X,_,de,be,Ne){this.g=U,this.h=q,this.j=X,this.k=_,this.l=de,this.m=be,this.n=Ne,this.e=new s.$loc("CodeAction"),this.f=new Map}async provideCodeActions(U,q,X,_){const de=this.g.getDocument(U),be=w.$Mt.isISelection(q)?i.Selection.to(q):i.Range.to(q),Ne=[];for(const nt of this.j.getDiagnostics(U))if(be.intersection(nt.range)&&Ne.push(nt)>z.d)break;const Ge={diagnostics:Ne,only:X.only?new o.$QN(X.only):void 0,triggerKind:i.CodeActionTriggerKind.to(X.trigger)},Ke=await this.k.provideCodeActions(de,be,Ge,_);if(!(0,r.$Kb)(Ke)||_.isCancellationRequested)return;const tt=this.e.add(Ke),rt=new R.$Sc;this.f.set(tt,rt);const ot=[];for(let nt=0;nt<Ke.length;nt++){const at=Ke[nt];if(at)if(z.o(at))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),ot.push({_isSynthetic:!0,title:at.title,command:this.h.toInternal(at,rt)});else{Ge.only&&(at.kind?Ge.only.contains(at.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ge.only.value}' requested but returned code action is of kind '${at.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ge.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const mt=at.ranges??[];ot.push({cacheId:[tt,nt],title:at.title,command:at.command&&this.h.toInternal(at.command,rt),diagnostics:at.diagnostics&&at.diagnostics.map(i.Diagnostic.from),edit:at.edit&&i.WorkspaceEdit.from(at.edit,void 0),kind:at.kind&&at.kind.value,isPreferred:at.isPreferred,isAI:(0,t.$4G)(this.m,"codeActionAI")?at.isAI:!1,ranges:(0,t.$4G)(this.m,"codeActionRanges")?(0,r.$Gb)(mt.map(i.Range.from)):void 0,disabled:at.disabled?.reason})}}return{cacheId:tt,actions:ot}}async resolveCodeAction(U,q){const[X,_]=U,de=this.e.get(X,_);if(!de||z.o(de))return{};if(!this.k.resolveCodeAction)return{};const be=await this.k.resolveCodeAction(de,q)??de;let Ne;be.edit&&(Ne=i.WorkspaceEdit.from(be.edit,void 0));let Ge;if(be.command){const Ke=this.f.get(X);Ke&&(Ge=this.h.toInternal(be.command,Ke))}return{edit:Ne,command:Ge}}releaseCodeActions(U){this.f.get(U)?.dispose(),this.f.delete(U),this.e.delete(U)}static o(U){return typeof U.command=="string"&&typeof U.title=="string"}}class M{constructor(U,q,X,_,de){this.e=U,this.f=q,this.g=X,this.h=_,this.j=de,this.d=new s.$loc("DocumentPasteEdit")}async prepareDocumentPaste(U,q,X,_){if(!this.g.prepareDocumentPaste)return;const de=this.f.getDocument(U),be=q.map(Ke=>i.Range.to(Ke)),Ne=i.DataTransfer.toDataTransfer(X,()=>{throw new T.$0});if(await this.g.prepareDocumentPaste(de,be,Ne,_),_.isCancellationRequested)return;const Ge=Array.from(Ne).filter(([,Ke])=>!(Ke instanceof o.$kO));return i.DataTransfer.from(Ge)}async providePasteEdits(U,q,X,_,de,be){if(!this.g.provideDocumentPasteEdits)return[];const Ne=this.f.getDocument(q),Ge=X.map(ot=>i.Range.to(ot)),Ke=i.DataTransfer.toDataTransfer(_,async ot=>(await this.e.$resolvePasteFileData(this.h,U,ot)).buffer),tt=await this.g.provideDocumentPasteEdits(Ne,Ge,Ke,{only:de.only?new o.$pO(de.only):void 0,triggerKind:de.triggerKind},be);if(!tt||be.isCancellationRequested)return[];const rt=this.d.add(tt);return tt.map((ot,nt)=>({_cacheId:[rt,nt],title:ot.title??(0,f.localize)(10669,null,this.j.displayName||this.j.name),kind:ot.kind,yieldTo:ot.yieldTo?.map(at=>at.value),insertText:typeof ot.insertText=="string"?ot.insertText:{snippet:ot.insertText.value},additionalEdit:ot.additionalEdit?i.WorkspaceEdit.from(ot.additionalEdit,void 0):void 0}))}async resolvePasteEdit(U,q){const[X,_]=U,de=this.d.get(X,_);if(!de||!this.g.resolveDocumentPasteEdit)return{};const be=await this.g.resolveDocumentPasteEdit(de,q)??de;return{additionalEdit:be.additionalEdit?i.WorkspaceEdit.from(be.additionalEdit,void 0):void 0}}releasePasteEdits(U){this.d.delete(U)}}class V{constructor(U,q){this.d=U,this.e=q}async provideDocumentFormattingEdits(U,q,X){const _=this.d.getDocument(U),de=await this.e.provideDocumentFormattingEdits(_,q,X);if(Array.isArray(de))return de.map(i.TextEdit.from)}}class K{constructor(U,q){this.d=U,this.e=q}async provideDocumentRangeFormattingEdits(U,q,X,_){const de=this.d.getDocument(U),be=i.Range.to(q),Ne=await this.e.provideDocumentRangeFormattingEdits(de,be,X,_);if(Array.isArray(Ne))return Ne.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(U,q,X,_){(0,D.$mg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const de=this.d.getDocument(U),be=q.map(i.Range.to),Ne=await this.e.provideDocumentRangesFormattingEdits(de,be,X,_);if(Array.isArray(Ne))return Ne.map(i.TextEdit.from)}}class ne{constructor(U,q){this.d=U,this.e=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,q,X,_,de){const be=this.d.getDocument(U),Ne=i.Position.to(q),Ge=await this.e.provideOnTypeFormattingEdits(be,Ne,X,_,de);if(Array.isArray(Ge))return Ge.map(i.TextEdit.from)}}class B{constructor(U,q){this.e=U,this.f=q,this.d=new s.$loc("WorkspaceSymbols")}async provideWorkspaceSymbols(U,q){const X=await this.e.provideWorkspaceSymbols(U,q);if(!(0,r.$Kb)(X))return{symbols:[]};const _=this.d.add(X),de={cacheId:_,symbols:[]};for(let be=0;be<X.length;be++){const Ne=X[be];if(!Ne||!Ne.name){this.f.warn("INVALID SymbolInformation",Ne);continue}de.symbols.push({...i.WorkspaceSymbol.from(Ne),cacheId:[_,be]})}return de}async resolveWorkspaceSymbol(U,q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!U.cacheId)return U;const X=this.d.get(...U.cacheId);if(X){const _=await this.e.resolveWorkspaceSymbol(X,q);return _&&(0,b.$do)(U,i.WorkspaceSymbol.from(_),!0)}}releaseWorkspaceSymbols(U){this.d.delete(U)}}class G{static supportsResolving(U){return typeof U.prepareRename=="function"}constructor(U,q,X){this.d=U,this.e=q,this.f=X}async provideRenameEdits(U,q,X,_){const de=this.d.getDocument(U),be=i.Position.to(q);try{const Ne=await this.e.provideRenameEdits(de,be,X,_);return Ne?i.WorkspaceEdit.from(Ne):void 0}catch(Ne){const Ge=G.g(Ne);return Ge?{rejectReason:Ge,edits:void 0}:Promise.reject(Ne)}}async resolveRenameLocation(U,q,X){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const _=this.d.getDocument(U),de=i.Position.to(q);try{const be=await this.e.prepareRename(_,de,X);let Ne,Ge;if(o.$wN.isRange(be)?(Ne=be,Ge=_.getText(be)):(0,D.$eg)(be)&&(Ne=be.range,Ge=be.placeholder),!Ne||!Ge)return;if(Ne.start.line>de.line||Ne.end.line<de.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Ne),text:Ge}}catch(be){const Ne=G.g(be);return Ne?{rejectReason:Ne,range:void 0,text:void 0}:Promise.reject(be)}}static g(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class Y{static{this.d={[a.NewSymbolNameTriggerKind.Invoke]:o.NewSymbolNameTriggerKind.Invoke,[a.NewSymbolNameTriggerKind.Automatic]:o.NewSymbolNameTriggerKind.Automatic}}constructor(U,q,X){this.e=U,this.f=q,this.g=X}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(U,q,X,_){const de=this.e.getDocument(U),be=i.Range.to(q);try{const Ne=Y.d[X],Ge=await this.f.provideNewSymbolNames(de,be,Ne,_);return Ge?Ge.map(Ke=>typeof Ke=="string"?{newSymbolName:Ke}:{newSymbolName:Ke.newSymbolName,tags:Ke.tags}):void 0}catch(Ne){this.g.error(Y.h(Ne)??JSON.stringify(Ne,null,"	"));return}}static h(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class ee{constructor(U,q){this.resultId=U,this.tokens=q}}class ue{constructor(U,q){this.f=U,this.g=q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(U,q,X){const _=this.f.getDocument(U),de=q!==0?this.d.get(q):null;let be=typeof de?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(_,de.resultId,X):await this.g.provideDocumentSemanticTokens(_,X);return de&&this.d.delete(q),be?(be=ue.h(be),this.o(ue.n(de,be),be)):null}async releaseDocumentSemanticColoring(U){this.d.delete(U)}static h(U){return ue.j(U)?ue.k(U)?U:new o.$PO(new Uint32Array(U.data),U.resultId):ue.l(U)?ue.m(U)?U:new o.$RO(U.edits.map(q=>new o.$QO(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),U.resultId):U}static j(U){return U&&!!U.data}static k(U){return U.data instanceof Uint32Array}static l(U){return U&&Array.isArray(U.edits)}static m(U){for(const q of U.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static n(U,q){if(!ue.j(q)||!U||!U.tokens)return q;const X=U.tokens,_=X.length,de=q.data,be=de.length;let Ne=0;const Ge=Math.min(_,be);for(;Ne<Ge&&X[Ne]===de[Ne];)Ne++;if(Ne===_&&Ne===be)return new o.$RO([],q.resultId);let Ke=0;const tt=Ge-Ne;for(;Ke<tt&&X[_-Ke-1]===de[be-Ke-1];)Ke++;return new o.$RO([{start:Ne,deleteCount:_-Ne-Ke,data:de.subarray(Ne,be-Ke)}],q.resultId)}o(U,q){if(ue.j(U)){const X=this.e++;return this.d.set(X,new ee(U.resultId,U.data)),(0,$.$ydb)({id:X,type:"full",data:U.data})}if(ue.l(U)){const X=this.e++;return ue.j(q)?this.d.set(X,new ee(q.resultId,q.data)):this.d.set(X,new ee(U.resultId)),(0,$.$ydb)({id:X,type:"delta",deltas:(U.edits||[]).map(_=>({start:_.start,deleteCount:_.deleteCount,data:_.data}))})}return null}}class re{constructor(U,q){this.d=U,this.e=q}async provideDocumentRangeSemanticTokens(U,q,X){const _=this.d.getDocument(U),de=await this.e.provideDocumentRangeSemanticTokens(_,i.Range.to(q),X);return de?this.f(de):null}f(U){return(0,$.$ydb)({id:0,type:"full",data:U.data})}}class ye{static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}constructor(U,q,X,_,de){this.f=U,this.g=q,this.h=X,this.j=_,this.k=de,this.d=new s.$loc("CompletionItem"),this.e=new Map}async provideCompletionItems(U,q,X,_){const de=this.f.getDocument(U),be=i.Position.to(q),Ne=de.getWordRangeAtPosition(be)||new o.$wN(be,be),Ge=Ne.with({end:be}),Ke=new c.$de,tt=await this.h.provideCompletionItems(de,be,_,i.CompletionContext.to(X));if(!tt||_.isCancellationRequested)return;const rt=Array.isArray(tt)?new o.$4N(tt):tt,ot=ye.supportsResolving(this.h)?this.d.add(rt.items):this.d.add([]),nt=new R.$Sc;this.e.set(ot,nt);const at=[],mt={x:ot,[n.ISuggestResultDtoField.completions]:at,[n.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(Ne),insert:i.Range.from(Ge)},[n.ISuggestResultDtoField.isIncomplete]:rt.isIncomplete||void 0,[n.ISuggestResultDtoField.duration]:Ke.elapsed()};for(let ht=0;ht<rt.items.length;ht++){const ct=rt.items[ht],Pe=this.l(ct,[ot,ht],Ge,Ne);at.push(Pe)}return mt}async resolveCompletionItem(U,q){if(typeof this.h.resolveCompletionItem!="function")return;const X=this.d.get(...U);if(!X)return;const _=this.l(X,U),de=await this.h.resolveCompletionItem(X,q);if(!de)return;const be=this.l(de,U);return(_[n.ISuggestDataDtoField.insertText]!==be[n.ISuggestDataDtoField.insertText]||_[n.ISuggestDataDtoField.insertTextRules]!==be[n.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(_[n.ISuggestDataDtoField.commandIdent]!==be[n.ISuggestDataDtoField.commandIdent]||_[n.ISuggestDataDtoField.commandId]!==be[n.ISuggestDataDtoField.commandId]||!(0,b.$eo)(_[n.ISuggestDataDtoField.commandArguments],be[n.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{..._,[n.ISuggestDataDtoField.documentation]:be[n.ISuggestDataDtoField.documentation],[n.ISuggestDataDtoField.detail]:be[n.ISuggestDataDtoField.detail],[n.ISuggestDataDtoField.additionalTextEdits]:be[n.ISuggestDataDtoField.additionalTextEdits],[n.ISuggestDataDtoField.insertText]:be[n.ISuggestDataDtoField.insertText],[n.ISuggestDataDtoField.insertTextRules]:be[n.ISuggestDataDtoField.insertTextRules],[n.ISuggestDataDtoField.commandIdent]:be[n.ISuggestDataDtoField.commandIdent],[n.ISuggestDataDtoField.commandId]:be[n.ISuggestDataDtoField.commandId],[n.ISuggestDataDtoField.commandArguments]:be[n.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,q,X,_){const de=this.e.get(q[0]);if(!de)throw Error("DisposableStore is missing...");const be=this.g.toInternal(U.command,de),Ne={x:q,[n.ISuggestDataDtoField.label]:U.label,[n.ISuggestDataDtoField.kind]:U.kind!==void 0?i.CompletionItemKind.from(U.kind):void 0,[n.ISuggestDataDtoField.kindModifier]:U.tags&&U.tags.map(i.CompletionItemTag.from),[n.ISuggestDataDtoField.detail]:U.detail,[n.ISuggestDataDtoField.documentation]:typeof U.documentation>"u"?void 0:i.MarkdownString.fromStrict(U.documentation),[n.ISuggestDataDtoField.sortText]:U.sortText!==U.label?U.sortText:void 0,[n.ISuggestDataDtoField.filterText]:U.filterText!==U.label?U.filterText:void 0,[n.ISuggestDataDtoField.preselect]:U.preselect||void 0,[n.ISuggestDataDtoField.insertTextRules]:U.keepWhitespace?a.CompletionItemInsertTextRule.KeepWhitespace:a.CompletionItemInsertTextRule.None,[n.ISuggestDataDtoField.commitCharacters]:U.commitCharacters?.join(""),[n.ISuggestDataDtoField.additionalTextEdits]:U.additionalTextEdits&&U.additionalTextEdits.map(i.TextEdit.from),[n.ISuggestDataDtoField.commandIdent]:be?.$ident,[n.ISuggestDataDtoField.commandId]:be?.id,[n.ISuggestDataDtoField.commandArguments]:be?.$ident?void 0:be?.arguments};U.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ne[n.ISuggestDataDtoField.insertText]=U.textEdit.newText):typeof U.insertText=="string"?Ne[n.ISuggestDataDtoField.insertText]=U.insertText:U.insertText instanceof o.$FN&&(Ne[n.ISuggestDataDtoField.insertText]=U.insertText.value,Ne[n.ISuggestDataDtoField.insertTextRules]|=a.CompletionItemInsertTextRule.InsertAsSnippet);let Ge;return U.textEdit?Ge=U.textEdit.range:U.range&&(Ge=U.range),o.$wN.isRange(Ge)?Ne[n.ISuggestDataDtoField.range]=i.Range.from(Ge):Ge&&(!X?.isEqual(Ge.inserting)||!_?.isEqual(Ge.replacing))&&(Ne[n.ISuggestDataDtoField.range]={insert:i.Range.from(Ge.inserting),replace:i.Range.from(Ge.replacing)}),Ne}}class $e{async provideInlineCompletions(U,q,X,_){}async provideInlineEdits(U,q,X,_){}disposeCompletions(U){}handleDidShowCompletionItem(U,q,X){}handlePartialAccept(U,q,X,_){}}class J extends $e{constructor(U,q,X,_){super(),this.f=U,this.g=q,this.h=X,this.j=_,this.d=new se,this.e=(0,t.$4G)(this.f,"inlineCompletionsAdditions"),this.k={[a.InlineCompletionTriggerKind.Automatic]:o.InlineCompletionTriggerKind.Automatic,[a.InlineCompletionTriggerKind.Explicit]:o.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$4G)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(U,q,X,_){const de=this.g.getDocument(U),be=i.Position.to(q),Ne=await this.h.provideInlineCompletionItems(de,be,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:i.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[X.triggerKind]},_);if(!Ne||_.isCancellationRequested)return;const Ge=Array.isArray(Ne)?Ne:Ne.items,Ke=this.e?Array.isArray(Ne)?[]:Ne.commands||[]:[],tt=this.e&&!Array.isArray(Ne)?Ne.enableForwardStability:void 0;let rt;return{pid:this.d.createReferenceId({dispose(){rt?.dispose()},items:Ge}),items:Ge.map((nt,at)=>{let mt;nt.command&&(rt||(rt=new R.$Sc),mt=this.j.toInternal(nt.command,rt));const ht=nt.insertText;return{insertText:typeof ht=="string"?ht:{snippet:ht.value},filterText:nt.filterText,range:nt.range?i.Range.from(nt.range):void 0,command:mt,idx:at,completeBracketPairs:this.e?nt.completeBracketPairs:!1}}),commands:Ke.map(nt=>(rt||(rt=new R.$Sc),this.j.toInternal(nt,rt))),suppressSuggestions:!1,enableForwardStability:tt}}async provideInlineEdits(U,q,X,_){if(!this.h.provideInlineEdits)return;(0,t.$5G)(this.f,"inlineCompletionsAdditions");const de=this.g.getDocument(U),be=i.Range.to(q),Ne=await this.h.provideInlineEdits(de,be,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:i.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[X.triggerKind],userPrompt:X.userPrompt},_);if(!Ne||_.isCancellationRequested)return;const Ge=Array.isArray(Ne)?Ne:Ne.items,Ke=this.e?Array.isArray(Ne)?[]:Ne.commands||[]:[],tt=this.e&&!Array.isArray(Ne)?Ne.enableForwardStability:void 0;let rt;return{pid:this.d.createReferenceId({dispose(){rt?.dispose()},items:Ge}),items:Ge.map((nt,at)=>{let mt;nt.command&&(rt||(rt=new R.$Sc),mt=this.j.toInternal(nt.command,rt));const ht=nt.insertText;return{insertText:typeof ht=="string"?ht:{snippet:ht.value},filterText:nt.filterText,range:nt.range?i.Range.from(nt.range):void 0,command:mt,idx:at,completeBracketPairs:this.e?nt.completeBracketPairs:!1}}),commands:Ke.map(nt=>(rt||(rt=new R.$Sc),this.j.toInternal(nt,rt))),suppressSuggestions:!1,enableForwardStability:tt}}disposeCompletions(U){this.d.disposeReferenceId(U)?.dispose()}handleDidShowCompletionItem(U,q,X){const _=this.d.get(U)?.items[q];_&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(_,X)}handlePartialAccept(U,q,X,_){const de=this.d.get(U)?.items[q];de&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(de,X),this.h.handleDidPartiallyAcceptCompletionItem(de,i.PartialAcceptInfo.to(_)))}}class W{async provideInlineEdits(U,q,X){const _=this.f.getDocument(U),de=await this.g.provideInlineEdit(_,{triggerKind:this.e[q.triggerKind]},X);if(!de||X.isCancellationRequested)return;let be;const Ne=this.d.createReferenceId({dispose(){be?.dispose()},item:de});let Ge;de.accepted&&(be||(be=new R.$Sc),Ge=this.h.toInternal(de.accepted,be));let Ke;return de.rejected&&(be||(be=new R.$Sc),Ke=this.h.toInternal(de.rejected,be)),{pid:Ne,text:de.text,range:i.Range.from(de.range),accepted:Ge,rejected:Ke}}disposeEdit(U){this.d.disposeReferenceId(U)?.dispose()}constructor(U,q,X,_){this.f=q,this.g=X,this.h=_,this.d=new se,this.e={[a.InlineEditTriggerKind.Automatic]:o.InlineEditTriggerKind.Automatic,[a.InlineEditTriggerKind.Invoke]:o.InlineEditTriggerKind.Invoke}}}class se{constructor(){this.d=new Map,this.e=1}createReferenceId(U){const q=this.e++;return this.d.set(q,U),q}disposeReferenceId(U){const q=this.d.get(U);return this.d.delete(U),q}get(U){return this.d.get(U)}}class ae{constructor(U,q){this.e=U,this.f=q,this.d=new s.$loc("SignatureHelp")}async provideSignatureHelp(U,q,X,_){const de=this.e.getDocument(U),be=i.Position.to(q),Ne=this.g(X),Ge=await this.f.provideSignatureHelp(de,be,_,Ne);if(Ge){const Ke=this.d.add([Ge]);return{...i.SignatureHelp.from(Ge),id:Ke}}}g(U){let q;if(U.activeSignatureHelp){const X=i.SignatureHelp.to(U.activeSignatureHelp),_=this.d.get(U.activeSignatureHelp.id,0);_?(q=_,q.activeSignature=X.activeSignature,q.activeParameter=X.activeParameter):q=X}return{...U,activeSignatureHelp:q}}releaseSignatureHelp(U){this.d.delete(U)}}class te{constructor(U,q,X,_,de){this.f=U,this.g=q,this.h=X,this.j=_,this.k=de,this.d=new s.$loc("InlayHints"),this.e=new Map}async provideInlayHints(U,q,X){const _=this.f.getDocument(U),de=i.Range.to(q),be=await this.h.provideInlayHints(_,de,X);if(!Array.isArray(be)||be.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`);return}if(X.isCancellationRequested)return;const Ne=this.d.add(be);this.e.set(Ne,new R.$Sc);const Ge={hints:[],cacheId:Ne};for(let Ke=0;Ke<be.length;Ke++)this.l(be[Ke],de)&&Ge.hints.push(this.m(be[Ke],[Ne,Ke]));return this.j.trace(`[InlayHints] ${Ge.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`),Ge}async resolveInlayHint(U,q){if(typeof this.h.resolveInlayHint!="function")return;const X=this.d.get(...U);if(!X)return;const _=await this.h.resolveInlayHint(X,q);if(_&&this.l(_))return this.m(_,U)}releaseHints(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,q){return U.label.length===0||Array.isArray(U.label)&&U.label.every(X=>X.value.length===0)?(console.log("INVALID inlay hint, empty label",U),!1):!(q&&!q.contains(U.position))}m(U,q){const X=this.e.get(q[0]);if(!X)throw Error("DisposableStore is missing...");const _={label:"",cacheId:q,tooltip:i.MarkdownString.fromStrict(U.tooltip),position:i.Position.from(U.position),textEdits:U.textEdits&&U.textEdits.map(i.TextEdit.from),kind:U.kind&&i.InlayHintKind.from(U.kind),paddingLeft:U.paddingLeft,paddingRight:U.paddingRight};if(typeof U.label=="string")_.label=U.label;else{const de=[];_.label=de;for(const be of U.label){if(!be.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ne={label:be.value,tooltip:i.MarkdownString.fromStrict(be.tooltip)};o.$GN.isLocation(be.location)&&(Ne.location=i.location.from(be.location)),be.command&&(Ne.command=this.g.toInternal(be.command,X)),de.push(Ne)}}return _}}class ce{constructor(U,q){this.e=U,this.f=q,this.d=new s.$loc("DocumentLink")}async provideLinks(U,q){const X=this.e.getDocument(U),_=await this.f.provideDocumentLinks(X,q);if(!(!Array.isArray(_)||_.length===0)&&!q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:_.filter(ce.g).map(i.DocumentLink.from)};{const de=this.d.add(_),be={links:[],cacheId:de};for(let Ne=0;Ne<_.length;Ne++){if(!ce.g(_[Ne]))continue;const Ge=i.DocumentLink.from(_[Ne]);Ge.cacheId=[de,Ne],be.links.push(Ge)}return be}}}static g(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,q){if(typeof this.f.resolveDocumentLink!="function")return;const X=this.d.get(...U);if(!X)return;const _=await this.f.resolveDocumentLink(X,q);if(!(!_||!ce.g(_)))return i.DocumentLink.from(_)}releaseLinks(U){this.d.delete(U)}}class le{constructor(U,q){this.d=U,this.e=q}async provideColors(U,q){const X=this.d.getDocument(U),_=await this.e.provideDocumentColors(X,q);return Array.isArray(_)?_.map(be=>({color:i.Color.from(be.color),range:i.Range.from(be.range)})):[]}async provideColorPresentations(U,q,X){const _=this.d.getDocument(U),de=i.Range.to(q.range),be=i.Color.to(q.color),Ne=await this.e.provideColorPresentations(be,{document:_,range:de},X);if(Array.isArray(Ne))return Ne.map(i.ColorPresentation.from)}}class Z{constructor(U,q){this.d=U,this.e=q}async provideFoldingRanges(U,q,X){const _=this.d.getDocument(U),de=await this.e.provideFoldingRanges(_,q,X);if(Array.isArray(de))return de.map(i.FoldingRange.from)}}class oe{constructor(U,q,X){this.d=U,this.e=q,this.f=X}async provideSelectionRanges(U,q,X){const _=this.d.getDocument(U),de=q.map(i.Position.to),be=await this.e.provideSelectionRanges(_,de,X);if(!(0,r.$Kb)(be))return[];if(be.length!==de.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ne=[];for(let Ge=0;Ge<de.length;Ge++){const Ke=[];Ne.push(Ke);let tt=de[Ge],rt=be[Ge];for(;;){if(!rt.range.contains(tt))throw new Error("INVALID selection range, must contain the previous range");if(Ke.push(i.SelectionRange.from(rt)),!rt.parent)break;tt=rt.range,rt=rt.parent}}return Ne}}class pe{constructor(U,q){this.f=U,this.g=q,this.d=new L.$6P(""),this.e=new Map}async prepareSession(U,q,X){const _=this.f.getDocument(U),de=i.Position.to(q),be=await this.g.prepareCallHierarchy(_,de,X);if(!be)return;const Ne=this.d.nextId();return this.e.set(Ne,new Map),Array.isArray(be)?be.map(Ge=>this.h(Ne,Ge)):[this.h(Ne,be)]}async provideCallsTo(U,q,X){const _=this.j(U,q);if(!_)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyIncomingCalls(_,X);if(de)return de.map(be=>({from:this.h(U,be.from),fromRanges:be.fromRanges.map(Ne=>i.Range.from(Ne))}))}async provideCallsFrom(U,q,X){const _=this.j(U,q);if(!_)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyOutgoingCalls(_,X);if(de)return de.map(be=>({to:this.h(U,be.to),fromRanges:be.fromRanges.map(Ne=>i.Range.from(Ne))}))}releaseSession(U){this.e.delete(U)}h(U,q){const X=this.e.get(U),_=i.CallHierarchyItem.from(q,U,X.size.toString(36));return X.set(_._itemId,q),_}j(U,q){return this.e.get(U)?.get(q)}}class we{constructor(U,q){this.f=U,this.g=q,this.d=new L.$6P(""),this.e=new Map}async prepareSession(U,q,X){const _=this.f.getDocument(U),de=i.Position.to(q),be=await this.g.prepareTypeHierarchy(_,de,X);if(!be)return;const Ne=this.d.nextId();return this.e.set(Ne,new Map),Array.isArray(be)?be.map(Ge=>this.h(Ne,Ge)):[this.h(Ne,be)]}async provideSupertypes(U,q,X){const _=this.j(U,q);if(!_)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySupertypes(_,X);if(de)return de.map(be=>this.h(U,be))}async provideSubtypes(U,q,X){const _=this.j(U,q);if(!_)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySubtypes(_,X);if(de)return de.map(be=>this.h(U,be))}releaseSession(U){this.e.delete(U)}h(U,q){const X=this.e.get(U),_=i.TypeHierarchyItem.from(q,U,X.size.toString(36));return X.set(_._itemId,q),_}j(U,q){return this.e.get(U)?.get(q)}}class Fe{constructor(U,q,X,_,de){this.e=U,this.f=q,this.g=X,this.h=_,this.j=de,this.d=new s.$loc("DocumentDropEdit")}async provideDocumentOnDropEdits(U,q,X,_,de){const be=this.f.getDocument(q),Ne=i.Position.to(X),Ge=i.DataTransfer.toDataTransfer(_,async ot=>(await this.e.$resolveDocumentOnDropFileData(this.h,U,ot)).buffer),Ke=await this.g.provideDocumentDropEdits(be,Ne,Ge,de);if(!Ke)return;const tt=(0,r.$1b)(Ke),rt=this.d.add(tt);return tt.map((ot,nt)=>({_cacheId:[rt,nt],title:ot.title??(0,f.localize)(10670,null,this.j.displayName||this.j.name),kind:ot.kind?.value,yieldTo:ot.yieldTo?.map(at=>at.value),insertText:typeof ot.insertText=="string"?ot.insertText:{snippet:ot.insertText.value},additionalEdit:ot.additionalEdit?i.WorkspaceEdit.from(ot.additionalEdit,void 0):void 0}))}async resolveDropEdit(U,q){const[X,_]=U,de=this.d.get(X,_);if(!de||!this.g.resolveDocumentDropEdit)return{};const be=await this.g.resolveDocumentDropEdit(de,q)??de;return{additionalEdit:be.additionalEdit?i.WorkspaceEdit.from(be.additionalEdit,void 0):void 0}}releaseDropEdits(U){this.d.delete(U)}}class We{constructor(U,q){this.d=U,this.e=q}async provideMappedEdits(U,q,X,_){const de=u.URI.revive(U),be=this.d.getDocument(de),Ne=X.documents.map(tt=>tt.map(rt=>({uri:u.URI.revive(rt.uri),version:rt.version,ranges:rt.ranges.map(ot=>i.Range.to(ot))}))),Ge={documents:Ne,selections:Ne[0]?.[0]?.ranges??[]},Ke=await this.e.provideMappedEdits(be,q,Ge,_);return Ke?i.WorkspaceEdit.from(Ke):null}}class Se{constructor(U,q){this.adapter=U,this.extension=q}}class De{static{this.d=0}constructor(U,q,X,_,de,be,Ne,Ge){this.g=q,this.h=X,this.j=_,this.k=de,this.l=be,this.m=Ne,this.n=Ge,this.f=new Map,this.e=U.getProxy(n.$sN.MainThreadLanguageFeatures)}o(U,q){return i.DocumentSelector.from(U,this.g,q)}p(U){return new o.$uN(()=>{this.f.delete(U),this.e.$unregister(U)})}q(){return De.d++}async s(U,q,X,_,de,be=!1){const Ne=this.f.get(U);if(!Ne||!(Ne.adapter instanceof q))return _;const Ge=Date.now();be||this.l.trace(`[${Ne.extension.identifier.value}] INVOKE provider '${X.toString().replace(/[\r\n]/g,"")}'`);const Ke=X(Ne.adapter,Ne.extension);return Promise.resolve(Ke).catch(tt=>{(0,T.$3)(tt)||(this.l.error(`[${Ne.extension.identifier.value}] provider FAILED`),this.l.error(tt),this.n.onExtensionError(Ne.extension.identifier,tt))}).finally(()=>{be||this.l.trace(`[${Ne.extension.identifier.value}] provider DONE after ${Date.now()-Ge}ms`)}),C.CancellationToken.isCancellationToken(de)?(0,h.$rh)(Ke,de):Ke}t(U,q){const X=this.q();return this.f.set(X,new Se(U,q)),X}static u(U){return U.displayName||U.name}static w(U){return U.identifier.value}registerDocumentSymbolProvider(U,q,X,_){const de=this.t(new d(this.h,X),U),be=_&&_.label||De.u(U);return this.e.$registerDocumentSymbolProvider(de,this.o(q,U),be),this.p(de)}$provideDocumentSymbols(U,q,X){return this.s(U,d,_=>_.provideDocumentSymbols(u.URI.revive(q),X),void 0,X)}registerCodeLensProvider(U,q,X){const _=this.q(),de=typeof X.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(_,new Se(new l(this.h,this.j.converter,X,U,this.n,this.l),U)),this.e.$registerCodeLensSupport(_,this.o(q,U),de);let be=this.p(_);if(de!==void 0){const Ne=X.onDidChangeCodeLenses(Ge=>this.e.$emitCodeLensEvent(de));be=o.$uN.from(be,Ne)}return be}$provideCodeLenses(U,q,X){return this.s(U,l,_=>_.provideCodeLenses(u.URI.revive(q),X),void 0,X)}$resolveCodeLens(U,q,X){return this.s(U,l,_=>_.resolveCodeLens(q,X),void 0,void 0)}$releaseCodeLenses(U,q){this.s(U,l,X=>Promise.resolve(X.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(U,q,X){const _=this.t(new E(this.h,X),U);return this.e.$registerDefinitionSupport(_,this.o(q,U)),this.p(_)}$provideDefinition(U,q,X,_){return this.s(U,E,de=>de.provideDefinition(u.URI.revive(q),X,_),[],_)}registerDeclarationProvider(U,q,X){const _=this.t(new S(this.h,X),U);return this.e.$registerDeclarationSupport(_,this.o(q,U)),this.p(_)}$provideDeclaration(U,q,X,_){return this.s(U,S,de=>de.provideDeclaration(u.URI.revive(q),X,_),[],_)}registerImplementationProvider(U,q,X){const _=this.t(new y(this.h,X),U);return this.e.$registerImplementationSupport(_,this.o(q,U)),this.p(_)}$provideImplementation(U,q,X,_){return this.s(U,y,de=>de.provideImplementation(u.URI.revive(q),X,_),[],_)}registerTypeDefinitionProvider(U,q,X){const _=this.t(new k(this.h,X),U);return this.e.$registerTypeDefinitionSupport(_,this.o(q,U)),this.p(_)}$provideTypeDefinition(U,q,X,_){return this.s(U,k,de=>de.provideTypeDefinition(u.URI.revive(q),X,_),[],_)}registerHoverProvider(U,q,X,_){const de=this.t(new A(this.h,X),U);return this.e.$registerHoverProvider(de,this.o(q,U)),this.p(de)}$provideHover(U,q,X,_,de){return this.s(U,A,be=>be.provideHover(u.URI.revive(q),X,_,de),void 0,de)}$releaseHover(U,q){this.s(U,A,X=>Promise.resolve(X.releaseHover(q)),void 0,void 0)}registerEvaluatableExpressionProvider(U,q,X,_){const de=this.t(new p(this.h,X),U);return this.e.$registerEvaluatableExpressionProvider(de,this.o(q,U)),this.p(de)}$provideEvaluatableExpression(U,q,X,_){return this.s(U,p,de=>de.provideEvaluatableExpression(u.URI.revive(q),X,_),void 0,_)}registerInlineValuesProvider(U,q,X,_){const de=typeof X.onDidChangeInlineValues=="function"?this.q():void 0,be=this.t(new v(this.h,X),U);this.e.$registerInlineValuesProvider(be,this.o(q,U),de);let Ne=this.p(be);if(de!==void 0){const Ge=X.onDidChangeInlineValues(Ke=>this.e.$emitInlineValuesEvent(de));Ne=o.$uN.from(Ne,Ge)}return Ne}$provideInlineValues(U,q,X,_,de){return this.s(U,v,be=>be.provideInlineValues(u.URI.revive(q),X,_,de),void 0,de)}registerDocumentHighlightProvider(U,q,X){const _=this.t(new F(this.h,X),U);return this.e.$registerDocumentHighlightProvider(_,this.o(q,U)),this.p(_)}registerMultiDocumentHighlightProvider(U,q,X){const _=this.t(new N(this.h,X),U);return this.e.$registerMultiDocumentHighlightProvider(_,this.o(q,U)),this.p(_)}$provideDocumentHighlights(U,q,X,_){return this.s(U,F,de=>de.provideDocumentHighlights(u.URI.revive(q),X,_),void 0,_)}$provideMultiDocumentHighlights(U,q,X,_,de){return this.s(U,N,be=>be.provideMultiDocumentHighlights(u.URI.revive(q),X,_.map(Ne=>u.URI.revive(Ne)),de),void 0,de)}registerLinkedEditingRangeProvider(U,q,X){const _=this.t(new O(this.h,X),U);return this.e.$registerLinkedEditingRangeProvider(_,this.o(q,U)),this.p(_)}$provideLinkedEditingRanges(U,q,X,_){return this.s(U,O,async de=>{const be=await de.provideLinkedEditingRanges(u.URI.revive(q),X,_);if(be)return{ranges:be.ranges,wordPattern:be.wordPattern?De.y(be.wordPattern):void 0}},void 0,_)}registerReferenceProvider(U,q,X){const _=this.t(new j(this.h,X),U);return this.e.$registerReferenceSupport(_,this.o(q,U)),this.p(_)}$provideReferences(U,q,X,_,de){return this.s(U,j,be=>be.provideReferences(u.URI.revive(q),X,_,de),void 0,de)}registerCodeActionProvider(U,q,X,_){const de=new R.$Sc,be=this.t(new z(this.h,this.j.converter,this.k,X,this.l,U,this.m),U);return this.e.$registerCodeActionSupport(be,this.o(q,U),{providedKinds:_?.providedCodeActionKinds?.map(Ne=>Ne.value),documentation:_?.documentation?.map(Ne=>({kind:Ne.kind.value,command:this.j.converter.toInternal(Ne.command,de)}))},De.u(U),De.w(U),!!X.resolveCodeAction),de.add(this.p(be)),de}$provideCodeActions(U,q,X,_,de){return this.s(U,z,be=>be.provideCodeActions(u.URI.revive(q),X,_,de),void 0,de)}$resolveCodeAction(U,q,X){return this.s(U,z,_=>_.resolveCodeAction(q,X),{},void 0)}$releaseCodeActions(U,q){this.s(U,z,X=>Promise.resolve(X.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(U,q,X){const _=this.t(new V(this.h,X),U);return this.e.$registerDocumentFormattingSupport(_,this.o(q,U),U.identifier,U.displayName||U.name),this.p(_)}$provideDocumentFormattingEdits(U,q,X,_){return this.s(U,V,de=>de.provideDocumentFormattingEdits(u.URI.revive(q),X,_),void 0,_)}registerDocumentRangeFormattingEditProvider(U,q,X){const _=typeof X.provideDocumentRangesFormattingEdits=="function",de=this.t(new K(this.h,X),U);return this.e.$registerRangeFormattingSupport(de,this.o(q,U),U.identifier,U.displayName||U.name,_),this.p(de)}$provideDocumentRangeFormattingEdits(U,q,X,_,de){return this.s(U,K,be=>be.provideDocumentRangeFormattingEdits(u.URI.revive(q),X,_,de),void 0,de)}$provideDocumentRangesFormattingEdits(U,q,X,_,de){return this.s(U,K,be=>be.provideDocumentRangesFormattingEdits(u.URI.revive(q),X,_,de),void 0,de)}registerOnTypeFormattingEditProvider(U,q,X,_){const de=this.t(new ne(this.h,X),U);return this.e.$registerOnTypeFormattingSupport(de,this.o(q,U),_,U.identifier),this.p(de)}$provideOnTypeFormattingEdits(U,q,X,_,de,be){return this.s(U,ne,Ne=>Ne.provideOnTypeFormattingEdits(u.URI.revive(q),X,_,de,be),void 0,be)}registerWorkspaceSymbolProvider(U,q){const X=this.t(new B(q,this.l),U);return this.e.$registerNavigateTypeSupport(X,typeof q.resolveWorkspaceSymbol=="function"),this.p(X)}$provideWorkspaceSymbols(U,q,X){return this.s(U,B,_=>_.provideWorkspaceSymbols(q,X),{symbols:[]},X)}$resolveWorkspaceSymbol(U,q,X){return this.s(U,B,_=>_.resolveWorkspaceSymbol(q,X),void 0,void 0)}$releaseWorkspaceSymbols(U,q){this.s(U,B,X=>X.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(U,q,X){const _=this.t(new G(this.h,X,this.l),U);return this.e.$registerRenameSupport(_,this.o(q,U),G.supportsResolving(X)),this.p(_)}$provideRenameEdits(U,q,X,_,de){return this.s(U,G,be=>be.provideRenameEdits(u.URI.revive(q),X,_,de),void 0,de)}$resolveRenameLocation(U,q,X,_){return this.s(U,G,de=>de.resolveRenameLocation(u.URI.revive(q),X,_),void 0,_)}registerNewSymbolNamesProvider(U,q,X){const _=this.t(new Y(this.h,X,this.l),U);return this.e.$registerNewSymbolNamesProvider(_,this.o(q,U)),this.p(_)}$supportsAutomaticNewSymbolNamesTriggerKind(U){return this.s(U,Y,q=>q.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(U,q,X,_,de){return this.s(U,Y,be=>be.provideNewSymbolNames(u.URI.revive(q),X,_,de),void 0,de)}registerDocumentSemanticTokensProvider(U,q,X,_){const de=this.t(new ue(this.h,X),U),be=typeof X.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(de,this.o(q,U),_,be);let Ne=this.p(de);if(be){const Ge=X.onDidChangeSemanticTokens(Ke=>this.e.$emitDocumentSemanticTokensEvent(be));Ne=o.$uN.from(Ne,Ge)}return Ne}$provideDocumentSemanticTokens(U,q,X,_){return this.s(U,ue,de=>de.provideDocumentSemanticTokens(u.URI.revive(q),X,_),null,_)}$releaseDocumentSemanticTokens(U,q){this.s(U,ue,X=>X.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(U,q,X,_){const de=this.t(new re(this.h,X),U);return this.e.$registerDocumentRangeSemanticTokensProvider(de,this.o(q,U),_),this.p(de)}$provideDocumentRangeSemanticTokens(U,q,X,_){return this.s(U,re,de=>de.provideDocumentRangeSemanticTokens(u.URI.revive(q),X,_),null,_)}registerCompletionItemProvider(U,q,X,_){const de=this.t(new ye(this.h,this.j.converter,X,this.m,U),U);return this.e.$registerCompletionsProvider(de,this.o(q,U),_,ye.supportsResolving(X),U.identifier),this.p(de)}$provideCompletionItems(U,q,X,_,de){return this.s(U,ye,be=>be.provideCompletionItems(u.URI.revive(q),X,_,de),void 0,de)}$resolveCompletionItem(U,q,X){return this.s(U,ye,_=>_.resolveCompletionItem(q,X),void 0,X)}$releaseCompletionItems(U,q){this.s(U,ye,X=>X.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(U,q,X,_){const de=new J(U,this.h,X,this.j.converter),be=this.t(de,U);return this.e.$registerInlineCompletionsSupport(be,this.o(q,U),de.supportsHandleEvents,g.$nn.toKey(U.identifier.value),_?.yieldTo?.map(Ne=>g.$nn.toKey(Ne))||[]),this.p(be)}$provideInlineCompletions(U,q,X,_,de){return this.s(U,$e,be=>be.provideInlineCompletions(u.URI.revive(q),X,_,de),void 0,de)}$provideInlineEdits(U,q,X,_,de){return this.s(U,$e,be=>be.provideInlineEdits(u.URI.revive(q),X,_,de),void 0,de)}$handleInlineCompletionDidShow(U,q,X,_){this.s(U,$e,async de=>{de.handleDidShowCompletionItem(q,X,_)},void 0,void 0)}$handleInlineCompletionPartialAccept(U,q,X,_,de){this.s(U,$e,async be=>{be.handlePartialAccept(q,X,_,de)},void 0,void 0)}$freeInlineCompletionsList(U,q){this.s(U,$e,async X=>{X.disposeCompletions(q)},void 0,void 0)}registerInlineEditProvider(U,q,X){const _=new W(U,this.h,X,this.j.converter),de=this.t(_,U);return this.e.$registerInlineEditProvider(de,this.o(q,U),U.identifier),this.p(de)}$provideInlineEdit(U,q,X,_){return this.s(U,W,de=>de.provideInlineEdits(u.URI.revive(q),X,_),void 0,_)}$freeInlineEdit(U,q){this.s(U,W,async X=>{X.disposeEdit(q)},void 0,void 0)}registerSignatureHelpProvider(U,q,X,_){const de=Array.isArray(_)?{triggerCharacters:_,retriggerCharacters:[]}:_,be=this.t(new ae(this.h,X),U);return this.e.$registerSignatureHelpProvider(be,this.o(q,U),de),this.p(be)}$provideSignatureHelp(U,q,X,_,de){return this.s(U,ae,be=>be.provideSignatureHelp(u.URI.revive(q),X,_,de),void 0,de)}$releaseSignatureHelp(U,q){this.s(U,ae,X=>X.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(U,q,X){const _=typeof X.onDidChangeInlayHints=="function"?this.q():void 0,de=this.t(new te(this.h,this.j.converter,X,this.l,U),U);this.e.$registerInlayHintsProvider(de,this.o(q,U),typeof X.resolveInlayHint=="function",_,De.u(U));let be=this.p(de);if(_!==void 0){const Ne=X.onDidChangeInlayHints(Ge=>this.e.$emitInlayHintsEvent(_));be=o.$uN.from(be,Ne)}return be}$provideInlayHints(U,q,X,_){return this.s(U,te,de=>de.provideInlayHints(u.URI.revive(q),X,_),void 0,_)}$resolveInlayHint(U,q,X){return this.s(U,te,_=>_.resolveInlayHint(q,X),void 0,X)}$releaseInlayHints(U,q){this.s(U,te,X=>X.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(U,q,X){const _=this.t(new ce(this.h,X),U);return this.e.$registerDocumentLinkProvider(_,this.o(q,U),typeof X.resolveDocumentLink=="function"),this.p(_)}$provideDocumentLinks(U,q,X){return this.s(U,ce,_=>_.provideLinks(u.URI.revive(q),X),void 0,X,q.scheme==="output")}$resolveDocumentLink(U,q,X){return this.s(U,ce,_=>_.resolveLink(q,X),void 0,void 0,!0)}$releaseDocumentLinks(U,q){this.s(U,ce,X=>X.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(U,q,X){const _=this.t(new le(this.h,X),U);return this.e.$registerDocumentColorProvider(_,this.o(q,U)),this.p(_)}$provideDocumentColors(U,q,X){return this.s(U,le,_=>_.provideColors(u.URI.revive(q),X),[],X)}$provideColorPresentations(U,q,X,_){return this.s(U,le,de=>de.provideColorPresentations(u.URI.revive(q),X,_),void 0,_)}registerFoldingRangeProvider(U,q,X){const _=this.q(),de=typeof X.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(_,new Se(new Z(this.h,X),U)),this.e.$registerFoldingRangeProvider(_,this.o(q,U),U.identifier,de);let be=this.p(_);if(de!==void 0){const Ne=X.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(de));be=o.$uN.from(be,Ne)}return be}$provideFoldingRanges(U,q,X,_){return this.s(U,Z,de=>de.provideFoldingRanges(u.URI.revive(q),X,_),void 0,_)}registerSelectionRangeProvider(U,q,X){const _=this.t(new oe(this.h,X,this.l),U);return this.e.$registerSelectionRangeProvider(_,this.o(q,U)),this.p(_)}$provideSelectionRanges(U,q,X,_){return this.s(U,oe,de=>de.provideSelectionRanges(u.URI.revive(q),X,_),[],_)}registerCallHierarchyProvider(U,q,X){const _=this.t(new pe(this.h,X),U);return this.e.$registerCallHierarchyProvider(_,this.o(q,U)),this.p(_)}$prepareCallHierarchy(U,q,X,_){return this.s(U,pe,de=>Promise.resolve(de.prepareSession(u.URI.revive(q),X,_)),void 0,_)}$provideCallHierarchyIncomingCalls(U,q,X,_){return this.s(U,pe,de=>de.provideCallsTo(q,X,_),void 0,_)}$provideCallHierarchyOutgoingCalls(U,q,X,_){return this.s(U,pe,de=>de.provideCallsFrom(q,X,_),void 0,_)}$releaseCallHierarchy(U,q){this.s(U,pe,X=>Promise.resolve(X.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(U,q,X){const _=this.t(new we(this.h,X),U);return this.e.$registerTypeHierarchyProvider(_,this.o(q,U)),this.p(_)}$prepareTypeHierarchy(U,q,X,_){return this.s(U,we,de=>Promise.resolve(de.prepareSession(u.URI.revive(q),X,_)),void 0,_)}$provideTypeHierarchySupertypes(U,q,X,_){return this.s(U,we,de=>de.provideSupertypes(q,X,_),void 0,_)}$provideTypeHierarchySubtypes(U,q,X,_){return this.s(U,we,de=>de.provideSubtypes(q,X,_),void 0,_)}$releaseTypeHierarchy(U,q){this.s(U,we,X=>Promise.resolve(X.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(U,q,X,_){const de=this.q();return this.f.set(de,new Se(new Fe(this.e,this.h,X,de,U),U)),this.e.$registerDocumentOnDropEditProvider(de,this.o(q,U),(0,t.$4G)(U,"documentPaste")&&_?{supportsResolve:!!X.resolveDocumentDropEdit,dropMimeTypes:_.dropMimeTypes}:void 0),this.p(de)}$provideDocumentOnDropEdits(U,q,X,_,de,be){return this.s(U,Fe,Ne=>Promise.resolve(Ne.provideDocumentOnDropEdits(q,u.URI.revive(X),_,de,be)),void 0,void 0)}$resolveDropEdit(U,q,X){return this.s(U,Fe,_=>_.resolveDropEdit(q,X),{},void 0)}$releaseDocumentOnDropEdits(U,q){this.s(U,Fe,X=>Promise.resolve(X.releaseDropEdits(q)),void 0,void 0)}registerMappedEditsProvider(U,q,X){const _=this.t(new We(this.h,X),U);return this.e.$registerMappedEditsProvider(_,this.o(q,U)),this.p(_)}$provideMappedEdits(U,q,X,_,de){return this.s(U,We,be=>Promise.resolve(be.provideMappedEdits(q,X,_,de)),null,de)}registerDocumentPasteEditProvider(U,q,X,_){const de=this.q();return this.f.set(de,new Se(new M(this.e,this.h,X,de,U),U)),this.e.$registerPasteEditProvider(de,this.o(q,U),{supportsCopy:!!X.prepareDocumentPaste,supportsPaste:!!X.provideDocumentPasteEdits,supportsResolve:!!X.resolveDocumentPasteEdit,providedPasteEditKinds:_.providedPasteEditKinds?.map(be=>be.value),copyMimeTypes:_.copyMimeTypes,pasteMimeTypes:_.pasteMimeTypes}),this.p(de)}$prepareDocumentPaste(U,q,X,_,de){return this.s(U,M,be=>be.prepareDocumentPaste(u.URI.revive(q),X,_,de),void 0,de)}$providePasteEdits(U,q,X,_,de,be,Ne){return this.s(U,M,Ge=>Ge.providePasteEdits(q,u.URI.revive(X),_,de,be,Ne),void 0,Ne)}$resolvePasteEdit(U,q,X){return this.s(U,M,_=>_.resolvePasteEdit(q,X),{},void 0)}$releasePasteEdits(U,q){this.s(U,M,X=>Promise.resolve(X.releasePasteEdits(q)),void 0,void 0)}static y(U){return{pattern:U.source,flags:U.flags}}static z(U){return{decreaseIndentPattern:De.y(U.decreaseIndentPattern),increaseIndentPattern:De.y(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?De.y(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?De.y(U.unIndentedLinePattern):void 0}}static B(U){return{beforeText:De.y(U.beforeText),afterText:U.afterText?De.y(U.afterText):void 0,previousLineText:U.previousLineText?De.y(U.previousLineText):void 0,action:U.action}}static C(U){return U.map(De.B)}static D(U){return{open:U.open,close:U.close,notIn:U.notIn?U.notIn.map(q=>o.SyntaxTokenType.toString(q)):void 0}}static E(U){return U.map(De.D)}setLanguageConfiguration(U,q,X){const{wordPattern:_}=X;if(_&&(0,I.$pf)(_))throw new Error(`Invalid language configuration: wordPattern '${_}' is not allowed to match the empty string.`);_?this.h.setWordDefinitionFor(q,_):this.h.setWordDefinitionFor(q,void 0),X.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),X.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const de=this.q(),be={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?De.y(X.wordPattern):void 0,indentationRules:X.indentationRules?De.z(X.indentationRules):void 0,onEnterRules:X.onEnterRules?De.C(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport,autoClosingPairs:X.autoClosingPairs?De.E(X.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(de,q,be),this.p(de)}$setWordDefinitions(U){for(const q of U)this.h.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.$voc=De}),define(ke[304],Ie([1,0,3,6,15]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zpc=void 0,C=Ue(C);class T{constructor(R){this.a=new Map,this.c=new Map,this.b=R.getProxy(h.$sN.MainThreadLanguageModelTools),this.b.$getTools().then(b=>{for(const c of b)this.c.set(c.name,c)})}async invokeTool(R,b,c){return await this.b.$invokeTool(R,b,c)}async $acceptToolDelta(R){R.added&&this.c.set(R.added.name,R.added),R.removed&&this.c.delete(R.removed)}get tools(){return Array.from(this.c.values()).map(R=>C.LanguageModelToolDescription.to(R))}async $invokeTool(R,b,c){const I=this.a.get(R);if(!I)throw new Error(`Unknown tool ${R}`);return await I.tool.invoke(b,c)}registerTool(R,b,c){return this.a.set(b,{extension:R,tool:c}),this.b.$registerTool(b),(0,r.$Rc)(()=>{this.a.delete(b),this.b.$unregisterTool(b)})}}e.$Zpc=T}),define(ke[128],Ie([1,0,7,20,52,13,4,39,3,8,23,5,11,89,6,127,19,15,9,156,25]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a,$,f,g,i,o){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$dpc=e.$cpc=void 0,f=Ue(f),g=Ue(g),e.$cpc=(0,D.$Ci)("IExtHostLanguageModels");class s{constructor(m,E){this.option=m,this.stream=new r.$6h,this.stream=E??new r.$6h}}class n{constructor(){this.a=new Map,this.b=new r.$6h,this.c=!1;const m=this;this.apiObject={get stream(){return m.b.asyncIterable},get text(){return r.$3h.map(m.b.asyncIterable,E=>{if(E instanceof g.$KP)return E.value}).coalesce()}}}*d(){if(this.a.size>0)for(const[,m]of this.a)yield m.stream;else yield this.b}handleFragment(m){if(this.c)return;let E=this.a.get(m.index);E||(this.a.size===0?E=new s(m.index,this.b):E=new s(m.index),this.a.set(m.index,E));let S;m.part.type==="text"?S=new g.$KP(m.part.value):S=new g.$JP(m.part.name,m.part.parameters),E.stream.emitOne(S)}reject(m){this.c=!0;for(const E of this.d())E.reject(m)}resolve(){this.c=!0;for(const m of this.d())m.resolve()}}let d=class{static{t=this}static{this.a=1}constructor(m,E,S){this.j=E,this.k=S,this.c=new L.$je,this.d=new L.$je,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new I.$pn,this.i=new Map,this.s=new Set,this.b=m.getProxy(w.$sN.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(m,E,S,y){const k=t.a++;this.f.set(k,{extension:m.identifier,provider:S,languageModelId:E});let A;y.auth&&(A={providerLabel:m.displayName||m.name,accountLabel:typeof y.auth=="object"?y.auth.label:void 0}),this.b.$registerLanguageModelProvider(k,`${I.$nn.toKey(m.identifier)}/${k}/${E}`,{extension:m.identifier,id:E,vendor:y.vendor??I.$nn.toKey(m.identifier),name:y.name??"",family:y.family??"",version:y.version,maxInputTokens:y.maxInputTokens,maxOutputTokens:y.maxOutputTokens,auth:A,targetExtensions:y.extensions});const p=S.onDidReceiveLanguageModelResponse2?.(({extensionId:v,participant:F,tokenCount:N})=>{this.b.$whenLanguageModelChatRequestMade(E,new I.$nn(v),F,N)});return(0,b.$Rc)(()=>{this.f.delete(k),this.b.$unregisterProvider(k),p?.dispose()})}async $startChatRequest(m,E,S,y,k,A){const p=this.f.get(m);if(!p)throw new Error("Provider not found");const v=new P.$uw(async N=>{if(A.isCancellationRequested){this.j.warn(`[CHAT](${p.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let O;if(N.part instanceof g.$JP?O={type:"function_use",name:N.part.name,parameters:N.part.parameters}:N.part instanceof g.$KP&&(O={type:"text",value:N.part.value}),!O){this.j.warn(`[CHAT](${p.extension.value}) UNKNOWN part ${JSON.stringify(N)}`);return}this.b.$reportResponsePart(E,{index:N.index,part:O})});let F;if(p.provider.provideLanguageModelResponse2)F=Promise.resolve(p.provider.provideLanguageModelResponse2(y.map(f.LanguageModelChatMessage.to),k,I.$nn.toKey(S),v,A));else{const N=new P.$uw(async O=>{v.report({index:O.index,part:new g.$KP(O.part)})});F=Promise.resolve(p.provider.provideLanguageModelResponse(y.map(f.LanguageModelChatMessage.to),k?.modelOptions??{},I.$nn.toKey(S),N,A))}F.then(()=>{this.b.$reportResponseDone(E,void 0)},N=>{this.b.$reportResponseDone(E,(0,T.$1)(N))})}$provideTokenLength(m,E,S){const y=this.f.get(m);return y?Promise.resolve(y.provider.provideTokenCount(E,S)):Promise.resolve(0)}$acceptChatModelMetadata(m){if(m.added)for(const{identifier:E,metadata:S}of m.added)this.g.set(E,{metadata:S,apiObjects:new I.$pn});if(m.removed)for(const E of m.removed){this.g.delete(E);for(const[S,y]of this.i)y.languageModelId===E&&(y.res.reject(new T.$4),this.i.delete(S))}m.added?.forEach(E=>this.q(E.metadata)),this.d.fire(void 0)}async selectLanguageModels(m,E){const S=await this.b.$selectChatModels({...E,extension:m.identifier}),y=[],k=this;for(const A of S){const p=this.g.get(A);if(!p)continue;this.o(m.identifier,p.metadata)&&await this.q(p.metadata);let v=p.apiObjects.get(m.identifier);v||(v={id:A,vendor:p.metadata.vendor,family:p.metadata.family,version:p.metadata.version,name:p.metadata.name,maxInputTokens:p.metadata.maxInputTokens,countTokens(F,N){if(!k.g.has(A))throw g.$OP.NotFound(A);return k.r(A,F,N??h.CancellationToken.None)},sendRequest(F,N,O){if(!k.g.has(A))throw g.$OP.NotFound(A);return k.l(m,A,F,N??{},O??h.CancellationToken.None)}},Object.freeze(v),p.apiObjects.set(m.identifier,v)),y.push(v)}return y}async l(m,E,S,y,k){const A=this.m(m,S),p=m.identifier,v=this.g.get(E)?.metadata;if(!v||!this.g.has(E))throw g.$OP.NotFound(`Language model '${E}' is unknown.`);if(this.o(p,v)&&(!await this.n(m,{identifier:v.extension,displayName:v.auth.providerLabel},y.justification,!1)||!this.h.get(p)?.has(v.extension)))throw g.$OP.NoPermissions(`Language model '${E}' cannot be used by '${p.value}'.`);try{const F=Math.random()*1e6|0,N=new n;this.i.set(F,{languageModelId:E,res:N});try{await this.b.$tryStartChatRequest(p,E,F,A,y,k)}catch(O){throw this.i.delete(F),O}return N.apiObject}catch(F){throw F.name===g.$OP.name?F:new g.$OP(`Language model '${E}' errored: ${(0,C.$nj)(F)}`,"Unknown",F)}}m(m,E){const S=[];for(const y of E)y.role===g.LanguageModelChatMessageRole.System&&(0,o.$5G)(m,"languageModelSystem"),y.content2 instanceof g.$HP&&(0,o.$5G)(m,"lmTools"),S.push(f.LanguageModelChatMessage.from(y));return S}async $acceptResponsePart(m,E){const S=this.i.get(m);S&&S.res.handleFragment(E)}async $acceptResponseDone(m,E){const S=this.i.get(m);S&&(this.i.delete(m),E?S.res.reject((0,T.$2)(E)):S.res.resolve())}async n(m,E,S,y){const k=i.$uM+E.identifier.value;if(await this.k.getSession(m,k,[],{silent:!0}))return this.$updateModelAccesslist([{from:m.identifier,to:E.identifier,enabled:!0}]),!0;if(y)return!1;try{const p=S?(0,c.localize)(10668,null,E.displayName,S):void 0;return await this.k.getSession(m,k,[],{forceNewSession:{detail:p}}),this.$updateModelAccesslist([{from:m.identifier,to:E.identifier,enabled:!0}]),!0}catch{return!1}}o(m,E){return!!E.auth&&!I.$nn.equals(E.extension,m)}async q(m){if(m.auth)for(const E of this.s)try{await this.n(E,{identifier:m.extension,displayName:""},void 0,!0)}catch(S){this.j.error("Fake Auth request failed"),this.j.error(S)}}async r(m,E,S){if(!this.g.get(m))throw g.$OP.NotFound(`Language model '${m}' is unknown.`);const k=R.Iterable.find(this.f.values(),A=>A.languageModelId===m);return k?k.provider.provideTokenCount(E,S):this.b.$countTokens(m,typeof E=="string"?E:f.LanguageModelChatMessage.from(E),S)}$updateModelAccesslist(m){const E=new Array;for(const{from:S,to:y,enabled:k}of m){const A=this.h.get(S)??new I.$on;if(A.has(y)!==k){k?A.add(y):A.delete(y),this.h.set(S,A);const v={from:S,to:y};E.push(v),this.c.fire(v)}}}createLanguageModelAccessInformation(m){this.s.add(m);const E=this,S=L.Event.signal(L.Event.filter(this.c.event,k=>I.$nn.equals(k.from,m.identifier))),y=L.Event.signal(this.d.event);return{get onDidChange(){return L.Event.any(S,y)},canSendRequest(k){let A;e:for(const[v,F]of E.g)for(const N of F.apiObjects.values())if(N===k){A=F.metadata;break e}if(!A)return;if(!E.o(m.identifier,A))return!0;const p=E.h.get(m.identifier);if(p)return p.has(A.extension)}}}};e.$dpc=d,e.$dpc=d=t=Ye([Ve(0,$.$1P),Ve(1,u.$9j),Ve(2,a.$xoc)],d)});var zt=this&&this.__importDefault||function(me){return me&&me.__esModule?me:{default:me}};define(ke[305],Ie([1,0,6,15,9,43,7,3,25]),function(me,e,r,h,C,T,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1pc=void 0,h=Ue(h),T=zt(T);class c{constructor(D,u,P,w){this.c=u,this.d=P,this.e=w,this.b=[],this.f=0,this.g=new Set,this.a=D.getProxy(r.$sN.MainThreadLanguages)}$acceptLanguageIds(D){this.b=D}async getLanguages(){return this.b.slice(0)}async changeLanguage(D,u){await this.a.$changeLanguage(D,u);const P=this.c.getDocumentData(D);if(!P)throw new Error(`document '${D.toString()}' NOT found`);return P.document}async tokenAtPosition(D,u){const P=D.version,w=h.Position.from(u),a=await this.a.$tokensAtPosition(D.uri,w),$={type:C.StandardTokenType.Other,range:D.getWordRangeAtPosition(u)??new C.$wN(u.line,u.character,u.line,u.character)};if(!a)return $;const f={range:h.Range.to(a.range),type:h.TokenType.to(a.type)};return!f.range.contains(u)||P!==D.version?$:f}createLanguageStatusItem(D,u,P){const w=this.f++,a=this.a,$=this.g,f=`${D.identifier.value}/${u}`;if($.has(f))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);$.add(f);const g={selector:P,id:u,name:D.displayName??D.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const o=new R.$Sc,t=()=>{if(i?.dispose(),!$.has(f)){console.warn(`LanguageStatusItem (${u}) from ${D.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,L.$Eh)(()=>{o.clear(),this.a.$setLanguageStatus(w,{id:f,name:g.name??D.displayName??D.name,source:D.displayName??D.name,selector:h.DocumentSelector.from(g.selector,this.e),label:g.text,detail:g.detail??"",severity:g.severity===C.LanguageStatusSeverity.Error?T.default.Error:g.severity===C.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info,command:g.command&&this.d.toInternal(g.command,o),accessibilityInfo:g.accessibilityInformation,busy:g.busy})},0)},s={dispose(){o.dispose(),i?.dispose(),a.$removeLanguageStatus(w),$.delete(f)},get id(){return g.id},get name(){return g.name},set name(n){g.name=n,t()},get selector(){return g.selector},set selector(n){g.selector=n,t()},get text(){return g.text},set text(n){g.text=n,t()},set text2(n){(0,b.$5G)(D,"languageStatusText"),g.text=n,t()},get text2(){return(0,b.$5G)(D,"languageStatusText"),g.text},get detail(){return g.detail},set detail(n){g.detail=n,t()},get severity(){return g.severity},set severity(n){g.severity=n,t()},get accessibilityInformation(){return g.accessibilityInformation},set accessibilityInformation(n){g.accessibilityInformation=n,t()},get command(){return g.command},set command(n){g.command=n,t()},get busy(){return g.busy},set busy(n){g.busy=n,t()}};return t(),s}}e.$1pc=c}),define(ke[306],Ie([1,0,14,2,15,9,126]),function(me,e,r,h,C,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mpc=e.$Lpc=void 0,C=Ue(C),L=Ue(L);class R{constructor(D,u,P,w){this.start=D,this.deletedCount=u,this.deletedItems=P,this.items=w}asApiEvent(){return{range:new T.$WO(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class b{static asModelAddData(D){return{EOL:D.eol,lines:D.source,languageId:D.language,uri:D.uri,isDirty:!1,versionId:1}}constructor(D,u,P){this.notebook=D,this.h=u,this.j=P,this.handle=P.handle,this.uri=h.URI.revive(P.uri),this.cellKind=P.cellKind,this.a=P.outputs.map(C.NotebookCellOutput.to),this.e=P.internalMetadata??{},this.b=Object.freeze(P.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(P.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const P={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return D.g},set mime(w){D.g=w},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(P)}return this.f}setOutputs(D){this.a=D.map(C.NotebookCellOutput.to)}setOutputItems(D,u,P){const w=P.map(C.NotebookCellOutputItem.to),a=this.a.find($=>$.id===D);if(a&&(u||(a.items.length=0),a.items.push(...w),a.items.length>1&&a.items.every($=>L.$xL($.mime)))){const $=new Map,f=[];a.items.forEach(g=>{let i;$.has(g.mime)?i=$.get(g.mime):(i=[],$.set(g.mime,i),f.push(g.mime)),i.push(g.data)}),a.items.length=0,f.forEach(g=>{const i=L.$yL($.get(g));a.items.push({mime:g,data:i.data.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.$Lpc=b;class c{static{this.a=0}constructor(D,u,P,w,a){this.k=D,this.l=u,this.m=P,this.uri=w,this.handle=c.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=a.viewType,this.f=Object.freeze(a.metadata??Object.create(null)),this.r([[0,0,a.cells]],!0,void 0),this.g=a.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const D=this,u={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===r.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(P){return P=D.n(P),D.b[P].apiCell},getCells(P){return(P?D.p(P):D.b).map(a=>a.apiCell)},save(){return D.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,u,P){this.g=D.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:P});const w={notebook:this.apiNotebook,metadata:P,cellChanges:[],contentChanges:[]},a=[];for(const f of D.rawEvents)f.kind===L.NotebookCellsChangeType.ModelChange?this.r(f.changes,!1,w.contentChanges):f.kind===L.NotebookCellsChangeType.Move?this.s(f.index,f.length,f.newIdx,w.contentChanges):f.kind===L.NotebookCellsChangeType.Output?(this.t(f.index,f.outputs),a.push({cell:this.b[f.index].apiCell,outputs:this.b[f.index].apiCell.outputs})):f.kind===L.NotebookCellsChangeType.OutputItem?(this.u(f.index,f.outputId,f.append,f.outputItems),a.push({cell:this.b[f.index].apiCell,outputs:this.b[f.index].apiCell.outputs})):f.kind===L.NotebookCellsChangeType.ChangeCellLanguage?(this.v(f.index,f.language),a.push({cell:this.b[f.index].apiCell,document:this.b[f.index].apiCell.document})):f.kind===L.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this.b[f.index].apiCell,document:this.b[f.index].apiCell.document}):f.kind===L.NotebookCellsChangeType.ChangeCellMime?this.w(f.index,f.mime):f.kind===L.NotebookCellsChangeType.ChangeCellMetadata?(this.x(f.index,f.metadata),a.push({cell:this.b[f.index].apiCell,metadata:this.b[f.index].apiCell.metadata})):f.kind===L.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(f.index,f.internalMetadata),a.push({cell:this.b[f.index].apiCell,executionSummary:this.b[f.index].apiCell.executionSummary}));const $=new Map;for(let f=0;f<a.length;f++){const g=a[f],i=$.get(g.cell);if(i===void 0){const o=w.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...g});$.set(g.cell,o-1)}else w.cellChanges[i]={...w.cellChanges[i],...g}}return Object.freeze(w),Object.freeze(w.cellChanges),Object.freeze(w.contentChanges),w}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let u=D.start|0,P=D.end|0;return u<0&&(u=0),P>this.b.length&&(P=this.b.length),D.with({start:u,end:P})}p(D){D=this.o(D);const u=[];for(let P=D.start;P<D.end;P++)u.push(this.b[P]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,u,P){if(this.j)return;const w=[],a=[],$=[];if(D.reverse().forEach(f=>{const i=f[2].map(s=>{const n=new b(this,this.l,s);return u||a.push(b.asModelAddData(s)),n}),o=new R(f[0],f[1],[],i),t=this.b.splice(f[0],f[1],...i);for(const s of t)$.push(s.uri),o.deletedItems.push(s.apiCell);w.push(o)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:$}),P)for(const f of w)P.push(f.asApiEvent())}s(D,u,P,w){const a=this.b.splice(D,u);this.b.splice(P,0,...a);const $=[new R(D,u,a.map(f=>f.apiCell),[]),new R(P,0,[],a)];for(const f of $)w.push(f.asApiEvent())}t(D,u){this.b[D].setOutputs(u)}u(D,u,P,w){this.b[D].setOutputItems(u,P,w)}v(D,u){const P=this.b[D];P.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(P.uri,u)}w(D,u){const P=this.b[D];P.apiCell.mime=u}x(D,u){this.b[D].setMetadata(u)}y(D,u){this.b[D].setInternalMetadata(u)}getCellFromApiCell(D){return this.b.find(u=>u.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(u=>u.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.$Mpc=c}),define(ke[307],Ie([1,0,4,2,15,9,53]),function(me,e,r,h,C,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3pc=void 0;class R{constructor(c,I,D,u={timeout:1500,errors:3}){this.b=c,this.c=I,this.d=D,this.f=u,this.a=new r.$le}dispose(){}getOnWillSaveNotebookDocumentEvent(c){return(I,D,u)=>{const P=function(a){I.call(D,a)};return P.extension=c,this.a.event(P,void 0,u)}}async $participateInSave(c,I,D){const u=h.URI.revive(c),P=this.c.getNotebookDocument(u);if(!P)throw new Error("Unable to resolve notebook document");const w=[];if(await this.a.fireAsync({notebook:P.apiNotebook,reason:C.TextDocumentSaveReason.to(I)},D,async($,f)=>{const g=Date.now(),i=await await Promise.resolve($);Date.now()-g>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",f.extension.identifier),!D.isCancellationRequested&&i&&(i instanceof T.$EN?w.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",f.extension.identifier,"ignored due to invalid data"))}),D.isCancellationRequested)return!1;if(w.length===0)return!0;const a={edits:[]};for(const $ of w){const{edits:f}=C.WorkspaceEdit.from($);a.edits=a.edits.concat(f)}return this.d.$tryApplyWorkspaceEdit(new L.$Sw(a))}}e.$3pc=R}),define(ke[165],Ie([1,0,13,15,9]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Npc=void 0,h=Ue(h),C=Ue(C);class T{static{this.apiEditorsToExtHost=new WeakMap}constructor(R,b,c,I,D,u){this.id=R,this.f=b,this.notebookData=c,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=I,this.c=u}get apiEditor(){if(!this.e){const R=this;this.e={get notebook(){return R.notebookData.apiNotebook},get selection(){return R.a[0]},set selection(b){this.selections=[b]},get selections(){return R.a},set selections(b){if(!Array.isArray(b)||!b.every(C.$WO.isNotebookRange))throw(0,r.$6)("selections");R.a=b,R.g(b)},get visibleRanges(){return R.b},revealRange(b,c){R.f.$tryRevealRange(R.id,h.NotebookRange.from(b),c??C.NotebookEditorRevealType.Default)},get viewColumn(){return R.c}},T.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(R){this.d=R}_acceptVisibleRanges(R){this.b=R}_acceptSelections(R){this.a=R}g(R){this.f.$trySetSelections(this.id,R.map(h.NotebookRange.from))}_acceptViewColumn(R){this.c=R}}e.$Npc=T}),define(ke[308],Ie([1,0,4,11,15]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5pc=void 0,C=Ue(C);let T=class{constructor(R,b){this.c=R,this.d=b,this.a=new r.$je,this.b=new r.$je,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(R,b){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",R,b);const c=this.d.getEditorById(R);b.visibleRanges&&c._acceptVisibleRanges(b.visibleRanges.ranges.map(C.NotebookRange.to)),b.selections&&c._acceptSelections(b.selections.selections.map(C.NotebookRange.to)),b.visibleRanges&&this.b.fire({notebookEditor:c.apiEditor,visibleRanges:c.apiEditor.visibleRanges}),b.selections&&this.a.fire(Object.freeze({notebookEditor:c.apiEditor,selections:c.apiEditor.selections}))}$acceptEditorViewColumns(R){for(const b in R)this.d.getEditorById(b)._acceptViewColumn(C.ViewColumn.to(R[b]))}};e.$5pc=T,e.$5pc=T=Ye([Ve(0,h.$9j)],T)}),define(ke[309],Ie([1,0,4,6,165]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8pc=void 0;class T{constructor(R,b){this.c=b,this.a=new Map,this.b=R.getProxy(h.$sN.MainThreadNotebookRenderers)}$postRendererMessage(R,b,c){const I=this.c.getEditorById(R);this.a.get(b)?.fire({editor:I.apiEditor,message:c})}createRendererMessaging(R,b){if(!R.contributes?.notebookRenderer?.some(I=>I.id===b))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${b})`);return{onDidReceiveMessage:(I,D,u)=>this.d(b).event(I,D,u),postMessage:(I,D)=>{C.$Npc.apiEditorsToExtHost.has(I)&&([I,D]=[D,I]);const u=D&&C.$Npc.apiEditorsToExtHost.get(D);return this.b.$postMessage(u?.id,b,I)}}}d(R){let b=this.a.get(R);return b||(b=new r.$je({onDidRemoveLastListener:()=>{b?.dispose(),this.a.delete(R)}}),this.a.set(R,b),b)}}e.$8pc=T}),define(ke[310],Ie([1,0,15,89,20,59,13]),function(me,e,r,h,C,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_pc=void 0;class R{constructor(D){this.b=0,this.c=new Map,this.a=D}async withProgress(D,u,P){const w=this.b++,{title:a,location:$,cancellable:f}=u,g={label:D.displayName||D.name,id:D.identifier.value};return this.a.$startProgress(w,{location:r.ProgressLocation.from($),title:a,source:g,cancellable:f},D.isUnderDevelopment?void 0:D.identifier.value).catch(L.$Z),this.d(w,P,!!f)}d(D,u,P){let w;P&&(w=new C.$ue,this.c.set(D,w));const a=f=>{this.a.$progressEnd(f),this.c.delete(f),w?.dispose()};let $;try{$=u(new c(this.a,D),P&&w?w.token:C.CancellationToken.None)}catch(f){throw a(D),f}return $.then(f=>a(D),f=>a(D)),$}$acceptProgressCanceled(D){const u=this.c.get(D);u&&(u.cancel(),this.c.delete(D))}}e.$_pc=R;function b(I,D){return I.message=D.message,typeof D.increment=="number"&&(typeof I.increment=="number"?I.increment+=D.increment:I.increment=D.increment),I}class c extends h.$uw{constructor(D,u){super(P=>this.throttledReport(P)),this.c=D,this.d=u}throttledReport(D){this.c.$progressReport(this.d,D)}}Ye([(0,T.$9h)(100,(I,D)=>b(I,D),()=>Object.create(null))],c.prototype,"throttledReport",null)}),define(ke[311],Ie([1,0,2,6,7,15]),function(me,e,r,h,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aqc=void 0;class L{static{this.a=0}constructor(b,c){this.d=c,this.c=new Map,this.b=b.getProxy(h.$sN.MainThreadQuickDiff)}$provideOriginalResource(b,c,I){const D=r.URI.revive(c),u=this.c.get(b);return u?(0,C.$uh)(()=>u.provideOriginalResource(D,I)).then(P=>P||null):Promise.resolve(null)}registerQuickDiffProvider(b,c,I,D){const u=L.a++;return this.c.set(u,c),this.b.$registerQuickDiffProvider(u,T.DocumentSelector.from(b,this.d),I,D),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$aqc=L});var zt=this&&this.__importDefault||function(me){return me&&me.__esModule?me:{default:me}};define(ke[312],Ie([1,0,20,4,3,6,2,9,13,18,43,50,25,15]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bqc=w,I=zt(I);function w(a,$,f){const g=a.getProxy(T.$sN.MainThreadQuickOpen);class i{constructor(S,y){this.e=new Map,this.f=0,this.a=S,this.b=y}showQuickPick(S,y,k,A=r.CancellationToken.None){this.c=void 0;const p=Promise.resolve(y),v=++this.f,F=g.$show(v,{title:k?.title,placeHolder:k?.placeHolder,matchOnDescription:k?.matchOnDescription,matchOnDetail:k?.matchOnDetail,ignoreFocusLost:k?.ignoreFocusOut,canPickMany:k?.canPickMany},A),N={},O=F.then(()=>N);return Promise.race([O,p]).then(j=>{if(j===N)return;const z=(0,u.$4G)(S,"quickPickItemTooltip");return p.then(M=>{const V=[];for(let K=0;K<M.length;K++){const ne=M[K];if(typeof ne=="string")V.push({label:ne,handle:K});else if(ne.kind===R.QuickPickItemKind.Separator)V.push({type:"separator",label:ne.label});else{ne.tooltip&&!z&&console.warn(`Extension '${S.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${S.identifier.value}`);const B=ne.iconPath?d(ne.iconPath):void 0;V.push({label:ne.label,iconPath:B?.iconPath,iconClass:B?.iconClass,description:ne.description,detail:ne.detail,picked:ne.picked,alwaysShow:ne.alwaysShow,tooltip:z?P.MarkdownString.fromStrict(ne.tooltip):void 0,handle:K})}}return k&&typeof k.onDidSelectItem=="function"&&(this.c=K=>{k.onDidSelectItem(M[K])}),g.$setItems(v,V),F.then(K=>{if(typeof K=="number")return M[K];if(Array.isArray(K))return K.map(ne=>M[ne])})})}).then(void 0,j=>{if(!(0,b.$3)(j))return g.$setError(v,j),Promise.reject(j)})}$onItemSelected(S){this.c?.(S)}showInput(S,y=r.CancellationToken.None){return this.d=S?.validateInput,g.$input(S,typeof this.d=="function",y).then(void 0,k=>{if(!(0,b.$3)(k))return Promise.reject(k)})}async $validateInput(S){if(!this.d)return;const y=await this.d(S);if(!y||typeof y=="string")return y;let k;switch(y.severity){case R.InputBoxValidationSeverity.Info:k=I.default.Info;break;case R.InputBoxValidationSeverity.Warning:k=I.default.Warning;break;case R.InputBoxValidationSeverity.Error:k=I.default.Error;break;default:k=y.message?I.default.Error:I.default.Ignore;break}return{content:y.message,severity:k}}async showWorkspaceFolderPick(S,y=r.CancellationToken.None){const k=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[S]);if(!k)return;const A=await this.a.getWorkspaceFolders2();if(A)return A.find(p=>p.uri.toString()===k.uri.toString())}createQuickPick(S){const y=new l(S,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}createInputBox(S){const y=new m(S,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}$onDidChangeValue(S,y){this.e.get(S)?._fireDidChangeValue(y)}$onDidAccept(S){this.e.get(S)?._fireDidAccept()}$onDidChangeActive(S,y){const k=this.e.get(S);k instanceof l&&k._fireDidChangeActive(y)}$onDidChangeSelection(S,y){const k=this.e.get(S);k instanceof l&&k._fireDidChangeSelection(y)}$onDidTriggerButton(S,y){this.e.get(S)?._fireDidTriggerButton(y)}$onDidTriggerItemButton(S,y,k){const A=this.e.get(S);A instanceof l&&A._fireDidTriggerItemButton(y,k)}$onDidHide(S){this.e.get(S)?._fireDidHide()}}class o{static{this.a=1}constructor(S,y){this.x=S,this.y=y,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new h.$je,this.q=new h.$je,this.r=new h.$je,this.s=new h.$je,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(S){this.b=S,this.z({title:S})}get step(){return this.c}set step(S){this.c=S,this.z({step:S})}get totalSteps(){return this.d}set totalSteps(S){this.d=S,this.z({totalSteps:S})}get enabled(){return this.g}set enabled(S){this.g=S,this.z({enabled:S})}get busy(){return this.j}set busy(S){this.j=S,this.z({busy:S})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(S){this.k=S,this.z({ignoreFocusOut:S})}get value(){return this.l}set value(S){this.l=S,this.z({value:S})}get placeholder(){return this.m}set placeholder(S){this.m=S,this.z({placeholder:S})}get buttons(){return this.n}set buttons(S){this.n=S.slice(),this.o.clear(),S.forEach((y,k)=>{const A=y===R.$TO.Back?-1:k;this.o.set(A,y)}),this.z({buttons:S.map((y,k)=>({...d(y.iconPath),tooltip:y.tooltip,handle:y===R.$TO.Back?-1:k}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(S){this.l=S,this.q.fire(S)}_fireDidTriggerButton(S){const y=this.o.get(S);y&&this.r.fire(y)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),g.$dispose(this._id))}z(S){if(!this.v){for(const y of Object.keys(S)){const k=S[y];this.u[y]=k===void 0?null:k}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){g.$createOrUpdate(this.u),this.u={id:this._id}}}function t(E){if(E instanceof R.$rO)return{id:E.id};const S=n(E),y=s(E);return{dark:typeof S=="string"?L.URI.file(S):S,light:typeof y=="string"?L.URI.file(y):y}}function s(E){return typeof E=="object"&&"light"in E?E.light:E}function n(E){return typeof E=="object"&&"dark"in E?E.dark:E}function d(E){const S=t(E);let y,k;return"id"in S?k=D.ThemeIcon.asClassName(S):y=S,{iconPath:y,iconClass:k}}class l extends o{constructor(S,y){super(S.identifier,y),this.O=S,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new h.$je,this.L=[],this.M=new h.$je,this.N=new h.$je,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(S){this.B=S.slice(),this.C.clear(),this.D.clear(),S.forEach((A,p)=>{this.C.set(p,A),this.D.set(A,p)});const y=(0,u.$4G)(this.O,"quickPickItemTooltip"),k=[];for(let A=0;A<S.length;A++){const p=S[A];if(p.kind===R.QuickPickItemKind.Separator)k.push({type:"separator",label:p.label});else{p.tooltip&&!y&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const v=p.iconPath?d(p.iconPath):void 0;k.push({handle:A,label:p.label,iconPath:v?.iconPath,iconClass:v?.iconClass,description:p.description,detail:p.detail,picked:p.picked,alwaysShow:p.alwaysShow,tooltip:y?P.MarkdownString.fromStrict(p.tooltip):void 0,buttons:p.buttons?.map((F,N)=>({...d(F.iconPath),tooltip:F.tooltip,handle:N}))})}}this.z({items:k})}get canSelectMany(){return this.E}set canSelectMany(S){this.E=S,this.z({canSelectMany:S})}get matchOnDescription(){return this.F}set matchOnDescription(S){this.F=S,this.z({matchOnDescription:S})}get matchOnDetail(){return this.G}set matchOnDetail(S){this.G=S,this.z({matchOnDetail:S})}get sortByLabel(){return this.H}set sortByLabel(S){this.H=S,this.z({sortByLabel:S})}get keepScrollPosition(){return this.I}set keepScrollPosition(S){this.I=S,this.z({keepScrollPosition:S})}get activeItems(){return this.J}set activeItems(S){this.J=S.filter(y=>this.D.has(y)),this.z({activeItems:this.J.map(y=>this.D.get(y))})}get selectedItems(){return this.L}set selectedItems(S){this.L=S.filter(y=>this.D.has(y)),this.z({selectedItems:this.L.map(y=>this.D.get(y))})}_fireDidChangeActive(S){const y=(0,c.$Gb)(S.map(k=>this.C.get(k)));this.J=y,this.K.fire(y)}_fireDidChangeSelection(S){const y=(0,c.$Gb)(S.map(k=>this.C.get(k)));this.L=y,this.M.fire(y)}_fireDidTriggerItemButton(S,y){const k=this.C.get(S);if(!k||!k.buttons||!k.buttons.length)return;const A=k.buttons[y];A&&this.N.fire({button:A,item:k})}}class m extends o{constructor(S,y){super(S.identifier,y),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(S){this.B=S,this.z({password:S})}get prompt(){return this.C}set prompt(S){this.C=S,this.z({prompt:S})}get valueSelection(){return this.D}set valueSelection(S){this.D=S,this.z({valueSelection:S})}get validationMessage(){return this.E}set validationMessage(S){this.E=S,S?typeof S=="string"?this.z({validationMessage:S,severity:I.default.Error}):this.z({validationMessage:S.message,severity:S.severity??I.default.Error}):this.z({validationMessage:void 0,severity:I.default.Ignore})}}return new i($,f)}}),define(ke[313],Ie([1,0,2,4,59,3,7,6,18,134,11,23,40,50,15,25,14,10]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a,$,f){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$dqc=e.$cqc=void 0;function i(N){return N instanceof r.URI}function o(N,O){return N.scheme===$.Schemas.file&&O.scheme===$.Schemas.file&&f.$l?N.toString()===O.toString():N.toString().toLowerCase()===O.toString().toLowerCase()}function t(N){if(N)return typeof N.iconPath=="string"?r.URI.file(N.iconPath):r.URI.isUri(N.iconPath)||P.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function s(N){if(N){if(r.URI.isUri(N))return N;if(P.ThemeIcon.isThemeIcon(N))return N;{const O=N;return{light:O.light,dark:O.dark}}}else return}function n(N){const O=s(N.icon),j=N.labels?.map(z=>({title:z.title,icon:s(z.icon)}));return{...N,icon:O,labels:j}}function d(N,O){if(!N.iconPath&&!O.iconPath)return 0;if(N.iconPath){if(!O.iconPath)return 1}else return-1;const j=typeof N.iconPath=="string"?N.iconPath:r.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,z=typeof O.iconPath=="string"?O.iconPath:r.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id;return(0,c.$Gr)(j,z)}function l(N,O){let j=0;if(N.strikeThrough!==O.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==O.faded)return N.faded?1:-1;if(N.tooltip!==O.tooltip)return(N.tooltip||"").localeCompare(O.tooltip||"");if(j=d(N,O),j!==0)return j;if(N.light&&O.light)j=d(N.light,O.light);else{if(N.light)return 1;if(O.light)return-1}if(j!==0)return j;if(N.dark&&O.dark)j=d(N.dark,O.dark);else{if(N.dark)return 1;if(O.dark)return-1}return j}function m(N,O){if(N.command!==O.command)return N.command<O.command?-1:1;if(N.title!==O.title)return N.title<O.title?-1:1;if(N.tooltip!==O.tooltip){if(N.tooltip!==void 0&&O.tooltip!==void 0)return N.tooltip<O.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(O.tooltip!==void 0)return-1}if(N.arguments===O.arguments)return 0;if(N.arguments)if(O.arguments){if(N.arguments.length!==O.arguments.length)return N.arguments.length-O.arguments.length}else return 1;else return-1;for(let j=0;j<N.arguments.length;j++){const z=N.arguments[j],M=O.arguments[j];if(z!==M&&!(i(z)&&i(M)&&o(z,M)))return z<M?-1:1}return 0}function E(N,O){let j=(0,c.$Gr)(N.resourceUri.fsPath,O.resourceUri.fsPath,!0);if(j!==0)return j;if(N.command&&O.command)j=m(N.command,O.command);else{if(N.command)return 1;if(O.command)return-1}if(j!==0)return j;if(N.decorations&&O.decorations)j=l(N.decorations,O.decorations);else{if(N.decorations)return 1;if(O.decorations)return-1}if(N.multiFileDiffEditorModifiedUri&&O.multiFileDiffEditorModifiedUri)j=(0,c.$Gr)(N.multiFileDiffEditorModifiedUri.fsPath,O.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(N.multiFileDiffEditorModifiedUri)return 1;if(O.multiFileDiffEditorModifiedUri)return-1}if(N.multiDiffEditorOriginalUri&&O.multiDiffEditorOriginalUri)j=(0,c.$Gr)(N.multiDiffEditorOriginalUri.fsPath,O.multiDiffEditorOriginalUri.fsPath,!0);else{if(N.multiDiffEditorOriginalUri)return 1;if(O.multiDiffEditorOriginalUri)return-1}return j}function S(N,O){for(let j=0;j<N.length;j++)if(N[j]!==O[j])return!1;return!0}function y(N,O){return N.command===O.command&&N.title===O.title&&N.tooltip===O.tooltip&&(N.arguments&&O.arguments?S(N.arguments,O.arguments):N.arguments===O.arguments)}function k(N,O){return(0,b.$tb)(N,O,y)}class A{#e;#t;get value(){return this.d}set value(O){O=O??"",this.#e.$setInputBoxValue(this.m,O),this.o(O)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(O){this.#e.$setInputBoxPlaceholder(this.m,O),this.f=O}get validateInput(){return(0,a.$5G)(this.k,"scmValidation"),this.g}set validateInput(O){if((0,a.$5G)(this.k,"scmValidation"),O&&typeof O!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=O,this.#e.$setValidationProviderIsEnabled(this.m,!!O)}get enabled(){return this.h}set enabled(O){O=!!O,this.h!==O&&(this.h=O,this.#e.$setInputBoxEnablement(this.m,O))}get visible(){return this.j}set visible(O){O=!!O,this.j!==O&&(this.j=O,this.#e.$setInputBoxVisibility(this.m,O))}get document(){return(0,a.$5G)(this.k,"scmTextDocument"),this.#t.getDocument(this.n)}constructor(O,j,z,M,V){this.k=O,this.m=M,this.n=V,this.d="",this.e=new h.$je,this.f="",this.h=!0,this.j=!0,this.#t=j,this.#e=z}showValidationMessage(O,j){(0,a.$5G)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.m,O,j)}$onInputBoxValueChange(O){this.o(O)}o(O){this.d=O,this.e.fire(O)}}e.$cqc=A;class p{static{this.d=0}get disposed(){return this.m}get id(){return this.v}get label(){return this.w}set label(O){this.w=O,this.s.$updateGroupLabel(this.u,this.handle,O)}get hideWhenEmpty(){return this.q}set hideWhenEmpty(O){this.q=O,this.s.$updateGroup(this.u,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(O){this.f=[...O],this.k.fire()}constructor(O,j,z,M,V,K,ne){this.s=O,this.t=j,this.u=z,this.v=M,this.w=V,this.multiDiffEditorEnableViewChanges=K,this.x=ne,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new h.$je,this.onDidUpdateResourceStates=this.k.event,this.m=!1,this.n=new h.$je,this.onDidDispose=this.n.event,this.o=[],this.p=[],this.q=void 0,this.handle=p.d++}getResourceState(O){return this.g.get(O)}$executeResourceCommand(O,j){const z=this.h.get(O);return z?(0,L.$uh)(()=>this.t.executeCommand(z.command,...z.arguments||[],j)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const O=[...this.f].sort(E),z=(0,b.$Cb)(this.p,O,E).map(K=>{const ne=K.toInsert.map(B=>{const G=this.e++;this.g.set(G,B);const Y=B.resourceUri;let ee;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"||B.command.command==="vscode.changes"){const oe=new T.$Sc;ee=this.t.converter.toInternal(B.command,oe),this.j.set(G,oe)}else this.h.set(G,B.command);const ue=(0,a.$4G)(this.x,"scmMultiDiffEditor"),re=ue?B.multiDiffEditorOriginalUri:void 0,ye=ue?B.multiFileDiffEditorModifiedUri:void 0,$e=t(B.decorations),J=B.decorations&&t(B.decorations.light)||$e,W=B.decorations&&t(B.decorations.dark)||$e,se=[J,W],ae=B.decorations&&B.decorations.tooltip||"",te=B.decorations&&!!B.decorations.strikeThrough,ce=B.decorations&&!!B.decorations.faded,le=B.contextValue||"";return{rawResource:[G,Y,se,ae,te,ce,le,ee,re,ye],handle:G}});return{start:K.start,deleteCount:K.deleteCount,toInsert:ne}}),M=z.map(({start:K,deleteCount:ne,toInsert:B})=>[K,ne,B.map(G=>G.rawResource)]),V=z.reverse();for(const{start:K,deleteCount:ne,toInsert:B}of V){const G=B.map(ee=>ee.handle),Y=this.o.splice(K,ne,...G);for(const ee of Y)this.g.delete(ee),this.h.delete(ee),this.j.get(ee)?.dispose(),this.j.delete(ee)}return this.p=O,M}dispose(){this.m=!0,this.n.fire()}}class v{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(O){this.g!==O&&(this.g=O,this.#e.$updateSourceControl(this.x,{count:O}))}get quickDiffProvider(){return this.h}set quickDiffProvider(O){this.h=O;let j;(0,a.$4G)(this.y,"quickDiffProvider")&&(j=O?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!O,quickDiffLabel:j})}get historyProvider(){return(0,a.$5G)(this.y,"scmHistoryProvider"),this.j}set historyProvider(O){(0,a.$5G)(this.y,"scmHistoryProvider"),this.j=O,this.k.value=new T.$Sc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!O}),O&&this.k.value.add(O.onDidChangeCurrentHistoryItemGroup(()=>{this.m=O?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.m)}))}get commitTemplate(){return this.n}set commitTemplate(O){O!==this.n&&(this.n=O,this.#e.$updateSourceControl(this.x,{commitTemplate:O}))}get acceptInputCommand(){return this.p}set acceptInputCommand(O){this.o.value=new T.$Sc,this.p=O;const j=this.z.converter.toInternal(O,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:j})}get actionButton(){return(0,a.$5G)(this.y,"scmActionButton"),this.s}set actionButton(O){(0,a.$5G)(this.y,"scmActionButton"),this.q.value=new T.$Sc,this.s=O;const j=O!==void 0?{command:this.z.converter.toInternal(O.command,this.q.value),secondaryCommands:O.secondaryCommands?.map(z=>z.map(M=>this.z.converter.toInternal(M,this.q.value))),description:O.description,enabled:O.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:j??null})}get statusBarCommands(){return this.u}set statusBarCommands(O){if(this.u&&O&&k(this.u,O))return;this.t.value=new T.$Sc,this.u=O;const j=(O||[]).map(z=>this.z.converter.toInternal(z,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:j})}get selected(){return this.v}constructor(O,j,z,M,V,K,ne){this.y=O,this.z=M,this.A=V,this.B=K,this.C=ne,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new T.$Uc,this.n=void 0,this.o=new T.$Uc,this.p=void 0,this.q=new T.$Uc,this.t=new T.$Uc,this.u=void 0,this.v=!1,this.w=new h.$je,this.onDidChangeSelection=this.w.event,this.x=v.d++,this.D=new Map,this.E=new Set,this.#e=z;const B=r.URI.from({scheme:$.Schemas.vscodeSourceControl,path:`${V}/scm${this.x}/input`,query:ne?`rootUri=${encodeURIComponent(ne.toString())}`:void 0});this.f=new A(O,j,this.#e,this.x,B),this.#e.$registerSourceControl(this.x,V,K,ne,B)}createResourceGroup(O,j,z){const M=(0,a.$4G)(this.y,"scmMultiDiffEditor")&&z?.multiDiffEditorEnableViewChanges===!0,V=new p(this.#e,this.z,this.x,O,j,M,this.y),K=h.Event.once(V.onDidDispose)(()=>this.D.delete(V));return this.D.set(V,K),this.eventuallyAddResourceGroups(),V}eventuallyAddResourceGroups(){const O=[],j=[];for(const[z,M]of this.D){M.dispose();const V=z.onDidUpdateResourceStates(()=>{this.E.add(z),this.eventuallyUpdateResourceStates()});h.Event.once(z.onDidDispose)(()=>{this.E.delete(z),V.dispose(),this.e.delete(z.handle),this.#e.$unregisterGroup(this.x,z.handle)}),O.push([z.handle,z.id,z.label,z.features,z.multiDiffEditorEnableViewChanges]);const K=z._takeResourceStateSnapshot();K.length>0&&j.push([z.handle,K]),this.e.set(z.handle,z)}this.#e.$registerGroups(this.x,O,j),this.D.clear()}eventuallyUpdateResourceStates(){const O=[];this.E.forEach(j=>{const z=j._takeResourceStateSnapshot();z.length!==0&&O.push([j.handle,z])}),O.length>0&&this.#e.$spliceResourceStates(this.x,O),this.E.clear()}getResourceGroup(O){return this.e.get(O)}setSelectionState(O){this.v=O,this.w.fire(O)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(O=>O.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ye([(0,C.$8h)(100)],v.prototype,"eventuallyAddResourceGroups",null),Ye([(0,C.$8h)(100)],v.prototype,"eventuallyUpdateResourceStates",null);let F=class{static{g=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(O,j,z,M){this.m=j,this.n=z,this.o=M,this.g=new Map,this.h=new D.$pn,this.j=new h.$je,this.e=O.getProxy(R.$sN.MainThreadSCM),this.f=O.getProxy(R.$sN.MainThreadTelemetry),j.registerArgumentProcessor({processArgument:V=>{if(V&&V.$mid===u.MarshalledId.ScmResource){const K=this.g.get(V.sourceControlHandle);if(!K)return V;const ne=K.getResourceGroup(V.groupHandle);return ne?ne.getResourceState(V.handle):V}else if(V&&V.$mid===u.MarshalledId.ScmResourceGroup){const K=this.g.get(V.sourceControlHandle);return K?K.getResourceGroup(V.groupHandle):V}else if(V&&V.$mid===u.MarshalledId.ScmProvider){const K=this.g.get(V.handle);return K||V}return V}})}createSourceControl(O,j,z,M){this.o.trace("ExtHostSCM#createSourceControl",O.identifier.value,j,z,M),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:O.identifier.value});const V=g.d++,K=new v(O,this.n,this.e,this.m,j,z,M);this.g.set(V,K);const ne=this.h.get(O.identifier)||[];return ne.push(K),this.h.set(O.identifier,ne),K}getLastInputBox(O){this.o.trace("ExtHostSCM#getLastInputBox",O.identifier.value);const j=this.h.get(O.identifier),z=j&&j[j.length-1];return z&&z.inputBox}$provideOriginalResource(O,j,z){const M=r.URI.revive(j);this.o.trace("ExtHostSCM#$provideOriginalResource",O,M.toString());const V=this.g.get(O);return!V||!V.quickDiffProvider||!V.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,L.$uh)(()=>V.quickDiffProvider.provideOriginalResource(M,z)).then(K=>K||null)}$onInputBoxValueChange(O,j){this.o.trace("ExtHostSCM#$onInputBoxValueChange",O);const z=this.g.get(O);return z&&z.inputBox.$onInputBoxValueChange(j),Promise.resolve(void 0)}$executeResourceCommand(O,j,z,M){this.o.trace("ExtHostSCM#$executeResourceCommand",O,j,z);const V=this.g.get(O);if(!V)return Promise.resolve(void 0);const K=V.getResourceGroup(j);return K?K.$executeResourceCommand(z,M):Promise.resolve(void 0)}$validateInput(O,j,z){this.o.trace("ExtHostSCM#$validateInput",O);const M=this.g.get(O);return!M||!M.inputBox.validateInput?Promise.resolve(void 0):(0,L.$uh)(()=>M.inputBox.validateInput(j,z)).then(V=>{if(!V)return Promise.resolve(void 0);const K=w.MarkdownString.fromStrict(V.message);return K?Promise.resolve([K,V.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(O){return this.o.trace("ExtHostSCM#$setSelectedSourceControl",O),O!==void 0&&this.g.get(O)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=O,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(O,j,z,M){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(j,z,M)??void 0}async $provideHistoryItems(O,j,z,M){return(await this.g.get(O)?.historyProvider?.provideHistoryItems(j,z,M))?.map(ne=>n(ne))??void 0}async $provideHistoryItems2(O,j,z){return(await this.g.get(O)?.historyProvider?.provideHistoryItems2(j,z))?.map(K=>n(K))??void 0}async $provideHistoryItemSummary(O,j,z,M){const V=this.g.get(O)?.historyProvider;if(typeof V?.provideHistoryItemSummary!="function")return;const K=await V.provideHistoryItemSummary(j,z,M);return K?n(K):void 0}async $provideHistoryItemChanges(O,j,z,M){return await this.g.get(O)?.historyProvider?.provideHistoryItemChanges(j,z,M)??void 0}};e.$dqc=F,e.$dqc=F=g=Ye([Ve(3,I.$9j)],F)}),define(ke[314],Ie([1,0,6,15,2]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eqc=void 0;class T{static{this.a=0}constructor(R,b){this.d=b,this.c=new Map,this.b=R.getProxy(r.$sN.MainThreadShare)}async $provideShare(R,b,c){return await this.c.get(R)?.provideShare({selection:h.Range.to(b.selection),resourceUri:C.URI.revive(b.resourceUri)},c)??void 0}registerShareProvider(R,b){const c=T.a++;return this.c.set(c,b),this.b.$registerShareProvider(c,h.DocumentSelector.from(R,this.d),b.id,b.label,b.priority),{dispose:()=>{this.b.$unregisterShareProvider(c),this.c.delete(c)}}}}e.$eqc=T}),define(ke[315],Ie([1,0,9,6,8,3,15,17]),function(me,e,r,h,C,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hqc=e.$gqc=void 0;class b{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new r.$sO("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new r.$sO("statusBarItem.warningForeground")]])}#e;#t;constructor(u,P,w,a,$,f=r.StatusBarAlignment.Left,g){if(this.i=!1,this.k="",this.q=new T.$Sc,this.#e=u,this.#t=P,$&&a){this.c=(0,r.$7N)(a.identifier,$);const i=w.get(this.c);i&&(f=i.alignLeft?r.StatusBarAlignment.Left:r.StatusBarAlignment.Right,g=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(b.a++);this.e=a,this.f=$,this.g=f,this.h=this.u(g)}u(u){if((0,R.$gg)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!b.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new T.$Sc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let P;this.m?P=this.m:P=(0,C.localize)(10661,null,this.e.displayName||this.e.name);let w=this.n;this.o&&(w=b.b.get(this.o.id));const a=L.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,P,this.k,a,this.r?.internal,w,this.o,this.g===r.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$gqc=b;class c{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",r.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(10662,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const P={message:u};return this.b.unshift(P),this.c(),new r.$uN(()=>{const w=this.b.indexOf(P);w>=0&&(this.b.splice(w,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class I{constructor(u,P){this.e=new Map,this.a=u.getProxy(h.$sN.MainThreadStatusBar),this.b=P,this.c=new c(this)}$acceptStaticEntries(u){for(const P of u)this.e.set(P.entryId,P)}createStatusBarEntry(u,P,w,a){return new b(this.a,this.b,this.e,u,P,w,a)}setStatusBarMessage(u,P){const w=this.c.setMessage(u);let a;return typeof P=="number"?a=setTimeout(()=>w.dispose(),P):typeof P<"u"&&P.then(()=>w.dispose(),()=>w.dispose()),new r.$uN(()=>{w.dispose(),clearTimeout(a)})}}e.$hqc=I}),define(ke[166],Ie([1,0,30,155,73,120,74,15,2]),function(me,e,r,h,C,T,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dQ=e.$cQ=e.$bQ=e.$aQ=void 0,r=Ue(r),R=Ue(R);const c=(i,o,t,s)=>{let n=o;return{enumerable:!0,configurable:!1,get(){return n},set(d){if(!t(n,d)){const l=n;n=d,i.listener?.(s(d,l))}}}},I=(i,o)=>i===o,D={range:(i,o)=>i===o?!0:!i||!o?!1:i.isEqual(o),label:I,description:I,sortText:I,busy:I,error:I,canResolveChildren:I,tags:(i,o)=>!(i.length!==o.length||i.some(t=>!o.find(s=>t.id===s.id)))},u=i=>o=>({op:T.TestItemEventOp.SetProp,update:i(o)}),P=(i,o)=>({range:(()=>{let t;const s=u(n=>({range:r.$Kt.lift(R.Range.from(n))}));return{enumerable:!0,configurable:!1,get(){return t},set(n){i.listener?.({op:T.TestItemEventOp.DocumentSynced}),D.range(t,n)||(t=n,i.listener?.(s(n)))}}})(),label:c(i,o,D.label,u(t=>({label:t}))),description:c(i,void 0,D.description,u(t=>({description:t}))),sortText:c(i,void 0,D.sortText,u(t=>({sortText:t}))),canResolveChildren:c(i,!1,D.canResolveChildren,t=>({op:T.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:c(i,!1,D.busy,u(t=>({busy:t}))),error:c(i,void 0,D.error,u(t=>({error:R.MarkdownString.fromStrict(t)||null}))),tags:c(i,[],D.tags,(t,s)=>({op:T.TestItemEventOp.SetTags,new:t.map(R.TestTag.from),old:s.map(R.TestTag.from)}))}),w=i=>{const o=C.$RI.fromString(i.extId),t=new $(o.controllerId,o.localId,i.label,b.URI.revive(i.uri)||void 0);return t.range=R.Range.to(i.range||void 0),t.description=i.description||void 0,t.sortText=i.sortText||void 0,t.tags=i.tags.map(s=>R.TestTag.to({id:(0,L.$XI)(s).tagId})),t},a=i=>{let o;for(const t of i.tests){const s=w(t.item);(0,h.$WP)(s).parent=o,o=s}return o};e.$aQ=a;class ${constructor(o,t,s,n){if(t.includes(C.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const d=(0,h.$VP)(this,o);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof f?void 0:d.parent}},children:{value:(0,T.$UP)(d,h.$WP,$),enumerable:!0,writable:!1},...P(d,s)})}}e.$bQ=$;class f extends ${constructor(o,t){super(o,o,t,void 0),this._isRoot=!0}}e.$cQ=f;class g extends T.$QP{constructor(o,t,s){super({controllerId:o,getDocumentVersion:n=>n&&s.getDocument(n)?.version,getApiFor:h.$WP,getChildren:n=>n.children,root:new f(o,t),toITestItem:R.TestItem.from})}}e.$dQ=g}),define(ke[34],Ie([1,0,17,9,15,24,6,18,11,51,30,57,2,3,5,19,166,21,53,52,42,91,94,32]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a,$,f,g,i,o,t,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oQ=e.$nQ=e.$mQ=e.$lQ=e.$kQ=e.$jQ=void 0,h=Ue(h),C=Ue(C);let d=class{#e;#t;#i;constructor(k,A,p){this.b=new Map,this.c=new Map,this.#e=k.getProxy(L.$sN.MainThreadCommands),this.d=A,this.#i=p,this.#t=k.getProxy(L.$sN.MainThreadTelemetry),this.converter=new l(this,v=>{const F=this.c.get(v);return F?.result===E.Void?F:void 0},A),this.f=[{processArgument(v){return(0,c.$_h)(v)}},{processArgument(v){return(0,T.$co)(v,function(F){if(I.$Kt.isIRange(F))return C.Range.to(F);if(D.$Jt.isIPosition(F))return C.Position.to(F);if(I.$Kt.isIRange(F.range)&&u.URI.isUri(F.uri))return C.location.to(F);if(F instanceof f.$Le)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(k){this.f.push(k)}registerApiCommand(k){const A=this.registerCommand(!1,k.id,async(...p)=>{const v=k.args.map((N,O)=>{if(!N.validate(p[O]))throw new Error(`Invalid argument '${N.name}' when running '${k.id}', received: ${typeof p[O]=="object"?JSON.stringify(p[O],null,"	"):p[O]} `);return N.convert(p[O])}),F=await this.executeCommand(k.internalId,...v);return k.result.convert(F,p,this.converter)},void 0,{description:k.description,args:k.args,returns:k.result.description});return this.c.set(k.id,k),new h.$uN(()=>{A.dispose(),this.c.delete(k.id)})}registerCommand(k,A,p,v,F,N){if(this.d.trace("ExtHostCommands#registerCommand",A),!A.trim().length)throw new Error("invalid id");if(this.b.has(A))throw new Error(`command '${A}' already exists`);return this.b.set(A,{callback:p,thisArg:v,metadata:F,extension:N}),k&&this.#e.$registerCommand(A),new h.$uN(()=>{this.b.delete(A)&&k&&this.#e.$unregisterCommand(A)})}executeCommand(k,...A){return this.d.trace("ExtHostCommands#executeCommand",k),this.g(k,A,!0)}async g(k,A,p){if(this.b.has(k))return this.#e.$fireCommandActivationEvent(k),this.h(k,A,!1);{let v=!1;const F=(0,T.$co)(A,function(N){if(N instanceof h.$vN)return C.Position.from(N);if(N instanceof h.$wN)return C.Range.from(N);if(N instanceof h.$GN)return C.location.from(N);if(h.$WO.isNotebookRange(N))return C.NotebookRange.from(N);if(N instanceof ArrayBuffer)return v=!0,f.$Le.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return v=!0,f.$Le.wrap(N);if(N instanceof f.$Le)return v=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(k,v?new g.$Sw(F):F,p);return(0,c.$_h)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(k,A,!1);throw N}}}async h(k,A,p){const v=this.b.get(k);if(!v)throw new Error("Unknown command");const{callback:F,thisArg:N,metadata:O}=v;if(O?.args)for(let z=0;z<O.args.length;z++)try{(0,r.$tg)(A[z],O.args[z].constraint)}catch{throw new Error(`Running the contributed command: '${k}' failed. Illegal argument '${O.args[z].name}' - ${O.args[z].description}`)}const j=o.$de.create();try{return await F.apply(N,A)}catch(z){if(k===this.converter.delegatingCommandId){const M=this.converter.getActualCommand(...A);M&&(k=M.command)}if(this.d.error(z,k,v.extension?.identifier),!p)throw z;if(v.extension?.identifier){const M=this.#i.onExtensionError(v.extension.identifier,z);this.d.trace("forwarded error to extension?",M,v.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$nj)(z)),this.id=k,this.source=v.extension?.displayName??v.extension?.name}}}finally{this.j(v,k,j.elapsed())}}j(k,A,p){k.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:k.extension.identifier.value,id:new t.$tp(A),duration:p})}$executeContributedCommand(k,...A){this.d.trace("ExtHostCommands#$executeContributedCommand",k);const p=this.b.get(k);return p?(A=A.map(v=>this.f.reduce((F,N)=>N.processArgument(F,p.extension?.identifier),v)),this.h(k,A,!0)):Promise.reject(new Error(`Contributed command '${k}' does not exist.`))}getCommands(k=!1){return this.d.trace("ExtHostCommands#getCommands",k),this.#e.$getCommands().then(A=>(k&&(A=A.filter(p=>p[0]!=="_")),A))}$getContributedCommandMetadata(){const k=Object.create(null);for(const[A,p]of this.b){const{metadata:v}=p;v&&(k[A]=v)}return Promise.resolve(k)}};e.$jQ=d,e.$jQ=d=Ye([Ve(0,a.$1P),Ve(1,b.$9j),Ve(2,s.$iQ)],d),e.$kQ=(0,w.$Ci)("IExtHostCommands");class l{constructor(k,A,p){this.d=k,this.f=A,this.g=p,this.delegatingCommandId=`__vsc${(0,n.$Yg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(k,A){if(!k)return;const p={$ident:void 0,id:k.command,title:k.title,tooltip:k.tooltip};if(!k.command)return p;const v=this.f(k.command);if(v)p.id=v.internalId,p.arguments=v.args.map((F,N)=>F.convert(k.arguments&&k.arguments[N]));else if((0,R.$Kb)(k.arguments)){const F=`${k.command} /${++this.c}`;this.b.set(F,k),A.add((0,P.$Rc)(()=>{this.b.delete(F),this.g.trace("CommandsConverter#DISPOSE",F)})),p.$ident=F,p.id=this.delegatingCommandId,p.arguments=[F],this.g.trace("CommandsConverter#CREATE",k.command,F)}return p}fromInternal(k){return typeof k.$ident=="string"?this.b.get(k.$ident):{command:k.id,title:k.title,arguments:k.arguments}}getActualCommand(...k){return this.b.get(k[0])}h(...k){const A=this.getActualCommand(...k);return this.g.trace("CommandsConverter#EXECUTE",k[0],A?A.command:"MISSING"),A?this.d.executeCommand(A.command,...A.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${k[0]}`)}}e.$lQ=l;class m{static{this.Uri=new m("uri","Uri of a text document",k=>u.URI.isUri(k),k=>k)}static{this.Position=new m("position","A position in a text document",k=>h.$vN.isPosition(k),C.Position.from)}static{this.Range=new m("range","A range in a text document",k=>h.$wN.isRange(k),C.Range.from)}static{this.Selection=new m("selection","A selection in a text document",k=>h.$xN.isSelection(k),C.Selection.from)}static{this.Number=new m("number","",k=>typeof k=="number",k=>k)}static{this.String=new m("string","",k=>typeof k=="string",k=>k)}static{this.StringArray=m.Arr(m.String)}static Arr(k){return new m(`${k.name}_array`,`Array of ${k.name}, ${k.description}`,A=>Array.isArray(A)&&A.every(p=>k.validate(p)),A=>A.map(p=>k.convert(p)))}static{this.CallHierarchyItem=new m("item","A call hierarchy item",k=>k instanceof h.$SN,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new m("item","A type hierarchy item",k=>k instanceof h.$eP,C.TypeHierarchyItem.from)}static{this.TestItem=new m("testItem","A VS Code TestItem",k=>k instanceof $.$bQ,C.TestItem.from)}constructor(k,A,p,v){this.name=k,this.description=A,this.validate=p,this.convert=v}optional(){return new m(this.name,`(optional) ${this.description}`,k=>k==null||this.validate(k),k=>k===void 0?void 0:k===null?null:this.convert(k))}with(k,A){return new m(k??this.name,A??this.description,this.validate,this.convert)}}e.$mQ=m;class E{static{this.Void=new E("no result",k=>k)}constructor(k,A){this.description=k,this.convert=A}}e.$nQ=E;class S{constructor(k,A,p,v,F){this.id=k,this.internalId=A,this.description=p,this.args=v,this.result=F}}e.$oQ=S}),define(ke[316],Ie([1,0,18,14,2,87,142,35,34,15,9]),function(me,e,r,h,C,T,L,R,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$woc=void 0,T=Ue(T),c=Ue(c),I=Ue(I);const D=[new b.$oQ("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[b.$mQ.Uri,b.$mQ.Position],new b.$nQ("A promise that resolves to an array of DocumentHighlight-instances.",P(c.DocumentHighlight.to))),new b.$oQ("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[b.$mQ.Uri],new b.$nQ("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,$)=>{if((0,r.$Jb)(a))return;class f extends I.$NN{static to(i){const o=new f(i.name,c.SymbolKind.to(i.kind),i.containerName||"",new I.$GN($[0],c.Range.to(i.range)));return o.detail=i.detail,o.range=o.location.range,o.selectionRange=c.Range.to(i.selectionRange),o.children=i.children?i.children.map(f.to):[],o}}return a.map(f.to)})),new b.$oQ("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[b.$mQ.Uri,new b.$mQ("options","Formatting options",a=>!0,a=>a)],new b.$nQ("A promise that resolves to an array of TextEdits.",P(c.TextEdit.to))),new b.$oQ("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[b.$mQ.Uri,b.$mQ.Range,new b.$mQ("options","Formatting options",a=>!0,a=>a)],new b.$nQ("A promise that resolves to an array of TextEdits.",P(c.TextEdit.to))),new b.$oQ("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[b.$mQ.Uri,b.$mQ.Position,new b.$mQ("ch","Trigger character",a=>typeof a=="string",a=>a),new b.$mQ("options","Formatting options",a=>!0,a=>a)],new b.$nQ("A promise that resolves to an array of TextEdits.",P(c.TextEdit.to))),new b.$oQ("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[b.$mQ.Uri,b.$mQ.Position],new b.$nQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new b.$oQ("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[b.$mQ.Uri,b.$mQ.Position],new b.$nQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new b.$oQ("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[b.$mQ.Uri,b.$mQ.Position],new b.$nQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new b.$oQ("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[b.$mQ.Uri,b.$mQ.Position],new b.$nQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new b.$oQ("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[b.$mQ.Uri,b.$mQ.Position],new b.$nQ("A promise that resolves to an array of Location-instances.",P(c.location.to))),new b.$oQ("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[b.$mQ.Uri,b.$mQ.Position],new b.$nQ("A promise that resolves to an array of Hover-instances.",P(c.Hover.to))),new b.$oQ("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[b.$mQ.Uri,new b.$mQ("position","A position in a text document",a=>Array.isArray(a)&&a.every($=>I.$vN.isPosition($)),a=>a.map(c.Position.from))],new b.$nQ("A promise that resolves to an array of ranges.",a=>a.map($=>{let f;for(const g of $.reverse())f=new I.$RN(c.Range.to(g),f);return f}))),new b.$oQ("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[b.$mQ.String.with("query","Search string")],new b.$nQ("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(c.WorkspaceSymbol.to))),new b.$oQ("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[b.$mQ.Uri,b.$mQ.Position],new b.$nQ("A promise that resolves to an array of CallHierarchyItem-instances",a=>a.map(c.CallHierarchyItem.to))),new b.$oQ("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[b.$mQ.CallHierarchyItem],new b.$nQ("A promise that resolves to an array of CallHierarchyIncomingCall-instances",a=>a.map(c.CallHierarchyIncomingCall.to))),new b.$oQ("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[b.$mQ.CallHierarchyItem],new b.$nQ("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",a=>a.map(c.CallHierarchyOutgoingCall.to))),new b.$oQ("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[b.$mQ.Uri,b.$mQ.Position],new b.$nQ("A promise that resolves to a range and placeholder text.",a=>{if(a)return{range:c.Range.to(a.range),placeholder:a.text}})),new b.$oQ("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[b.$mQ.Uri,b.$mQ.Position,b.$mQ.String.with("newName","The new symbol name")],new b.$nQ("A promise that resolves to a WorkspaceEdit.",a=>{if(a){if(a.rejectReason)throw new Error(a.rejectReason);return c.WorkspaceEdit.to(a)}})),new b.$oQ("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[b.$mQ.Uri,b.$mQ.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new b.$nQ("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(c.DocumentLink.to))),new b.$oQ("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[b.$mQ.Uri],new b.$nQ("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new I.$NO(a.tokenTypes,a.tokenModifiers)})),new b.$oQ("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[b.$mQ.Uri],new b.$nQ("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const $=(0,L.$zdb)(a);if($.type==="full")return new I.$PO($.data,void 0)})),new b.$oQ("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[b.$mQ.Uri,b.$mQ.Range.optional()],new b.$nQ("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new I.$NO(a.tokenTypes,a.tokenModifiers)})),new b.$oQ("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[b.$mQ.Uri,b.$mQ.Range],new b.$nQ("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const $=(0,L.$zdb)(a);if($.type==="full")return new I.$PO($.data,void 0)})),new b.$oQ("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[b.$mQ.Uri,b.$mQ.Position,b.$mQ.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),b.$mQ.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new b.$nQ("A promise that resolves to a CompletionList-instance.",(a,$,f)=>{if(!a)return new I.$4N([]);const g=a.suggestions.map(i=>c.CompletionItem.to(i,f));return new I.$4N(g,a.incomplete)})),new b.$oQ("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[b.$mQ.Uri,b.$mQ.Position,b.$mQ.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new b.$nQ("A promise that resolves to SignatureHelp.",a=>{if(a)return c.SignatureHelp.to(a)})),new b.$oQ("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[b.$mQ.Uri,b.$mQ.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new b.$nQ("A promise that resolves to an array of CodeLens-instances.",(a,$,f)=>P(g=>new I.$VN(c.Range.to(g.range),g.command&&f.fromInternal(g.command)))(a))),new b.$oQ("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[b.$mQ.Uri,new b.$mQ("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>I.$wN.isRange(a),a=>I.$xN.isSelection(a)?c.Selection.from(a):c.Range.from(a)),b.$mQ.String.with("kind","Code action kind to return code actions for").optional(),b.$mQ.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new b.$nQ("A promise that resolves to an array of Command-instances.",(a,$,f)=>P(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return f.fromInternal(g.command)}else{const i=new I.$PN(g.title,g.kind?new I.$QN(g.kind):void 0);return g.edit&&(i.edit=c.WorkspaceEdit.to(g.edit)),g.command&&(i.command=f.fromInternal(g.command)),i.isPreferred=g.isPreferred,i}})(a))),new b.$oQ("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[b.$mQ.Uri],new b.$nQ("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map($=>new I.$0N(c.Range.to($.range),c.Color.to($.color))):[])),new b.$oQ("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new b.$mQ("color","The color to show and insert",a=>a instanceof I.$9N,c.Color.from),new b.$mQ("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:c.Range.from(a.range)}))],new b.$nQ("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(c.ColorPresentation.to):[])),new b.$oQ("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[b.$mQ.Uri,b.$mQ.Range],new b.$nQ("A promise that resolves to an array of Inlay objects",(a,$,f)=>a.map(c.InlayHint.to.bind(void 0,f)))),new b.$oQ("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[b.$mQ.Uri],new b.$nQ("A promise that resolves to an array of FoldingRange objects",(a,$)=>{if(a)return a.map(c.FoldingRange.to)})),new b.$oQ("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new b.$nQ("A promise that resolves to an array of NotebookContentProvider static info objects.",P(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map($=>c.NotebookExclusiveDocumentPattern.to($))})))),new b.$oQ("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[b.$mQ.Uri,b.$mQ.Range,new b.$mQ("context","An InlineValueContext",a=>a&&typeof a.frameId=="number"&&a.stoppedLocation instanceof I.$wN,a=>c.InlineValueContext.from(a))],new b.$nQ("A promise that resolves to an array of InlineValue objects",a=>a.map(c.InlineValue.to))),new b.$oQ("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new b.$mQ("uriOrString","Uri-instance or string (only http/https)",a=>C.URI.isUri(a)||typeof a=="string"&&(0,h.$Mg)(a,h.Schemas.http,h.Schemas.https),a=>a),new b.$mQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[c.ViewColumn.from(a),void 0]:[c.ViewColumn.from(a.viewColumn),c.TextEditorOpenOptions.from(a)])).optional(),b.$mQ.String.with("label","").optional()],b.$nQ.Void),new b.$oQ("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[b.$mQ.Uri.with("resource","Resource to open"),b.$mQ.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new b.$mQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[c.ViewColumn.from(a),void 0]:[c.ViewColumn.from(a.viewColumn),c.TextEditorOpenOptions.from(a)])).optional()],b.$nQ.Void),new b.$oQ("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[b.$mQ.Uri.with("left","Left-hand side resource of the diff editor"),b.$mQ.Uri.with("right","Right-hand side resource of the diff editor"),b.$mQ.String.with("title","Human readable title for the diff editor").optional(),new b.$mQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[c.ViewColumn.from(a.viewColumn),c.TextEditorOpenOptions.from(a)]).optional()],b.$nQ.Void),new b.$oQ("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[b.$mQ.String.with("title","Human readable title for the changes editor"),new b.$mQ("resourceList","List of resources to compare",a=>{for(const $ of a){if($.length!==3)return!1;const[f,g,i]=$;if(!C.URI.isUri(f)||!C.URI.isUri(g)&&g!==void 0&&g!==null||!C.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},a=>a)],b.$nQ.Void),new b.$oQ("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[b.$mQ.Uri,b.$mQ.Position],new b.$nQ("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(c.TypeHierarchyItem.to))),new b.$oQ("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[b.$mQ.TypeHierarchyItem],new b.$nQ("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(c.TypeHierarchyItem.to))),new b.$oQ("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[b.$mQ.TypeHierarchyItem],new b.$nQ("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(c.TypeHierarchyItem.to))),new b.$oQ("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[b.$mQ.TestItem],b.$nQ.Void),new b.$oQ("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[b.$mQ.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],b.$nQ.Void),new b.$oQ("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[b.$mQ.String.with("name","The context key name"),new b.$mQ("value","The context key value",()=>!0,a=>a)],b.$nQ.Void),new b.$oQ("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[b.$mQ.Uri,b.$mQ.StringArray,new b.$mQ("MappedEditsContext","Mapped Edits Context",a=>c.MappedEditsContext.is(a),a=>c.MappedEditsContext.from(a))],new b.$nQ("A promise that resolves to a workspace edit or null",a=>a?c.WorkspaceEdit.to(a):null)),new b.$oQ("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new b.$mQ("Run arguments","",a=>!0,a=>{if(a)return{initialRange:a.initialRange?c.Range.from(a.initialRange):void 0,initialSelection:I.$xN.isSelection(a.initialSelection)?c.Selection.from(a.initialSelection):void 0,message:a.message,autoSend:a.autoSend,position:a.position?c.Position.from(a.position):void 0}})],b.$nQ.Void)];class u{static register($){D.forEach($.registerApiCommand,$),this.a($)}static a($){$.registerCommand(!1,"_validateWhenClauses",R.$Bj)}}e.$woc=u;function P(a){return $=>{if(Array.isArray($))return $.map(a)}}function w(a){if(!Array.isArray(a))return;const $=[];for(const f of a)T.$Gu(f)?$.push(c.DefinitionLink.to(f)):$.push(c.location.to(f));return $}}),define(ke[317],Ie([1,0,2,34]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xpc=void 0;class C{constructor(L,R,b,c,I){this.a=R,this.b=b,this.c=c;const D=new h.$oQ("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new h.$mQ("showOptions","Show Options",u=>!0,u=>u),new h.$mQ("resource","Interactive resource Uri",u=>!0,u=>u),new h.$mQ("controllerId","Notebook controller Id",u=>!0,u=>u),new h.$mQ("title","Interactive editor title",u=>!0,u=>u)],new h.$nQ("Notebook and input URI",u=>{if(I.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const P=this.a.getEditorById(u.notebookEditorId);return I.debug("[ExtHostInteractive] notebook editor found",P.id),{notebookUri:r.URI.revive(u.notebookUri),inputUri:r.URI.revive(u.inputUri),notebookEditor:P.apiEditor}}return I.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:r.URI.revive(u.notebookUri),inputUri:r.URI.revive(u.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(L,R,b,c){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:R,lines:[""],languageId:b,uri:L,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(L,R){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[L]})}}e.$Xpc=C}),define(ke[318],Ie([1,0,18,7,20,4,3,28,2,23,11,6,34,15,9,121,260,25,53,261]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a,$,f,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6pc=void 0,e.$7pc=m,P=Ue(P);let o=class{constructor(S,y,k,A,p){this.m=y,this.n=k,this.o=A,this.q=p,this.b=new R.$zc,this.c=new R.$zc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new T.$je,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=S.getProxy(D.$sN.MainThreadNotebookKernels);const v=new u.$oQ("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$mQ("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const O=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:O}}else if(N&&"notebookEditor"in N){const O=this.n.getIdByEditor(N.notebookEditor);if(O===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:O}}return N})],u.$nQ.Void),F=new u.$oQ("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$mQ.Uri],new u.$nQ("A promise that resolves to an array of variables",(N,O)=>N.map(j=>({variable:{name:j.name,value:j.value,expression:j.expression,type:j.type,language:j.language},hasNamedChildren:j.hasNamedChildren,indexedChildrenCount:j.indexedChildrenCount}))));this.o.registerApiCommand(v),this.o.registerApiCommand(F)}createNotebookController(S,y,k,A,p,v){for(const re of this.j.values())if(re.controller.id===y&&c.$nn.equals(S.identifier,re.extensionId))throw new Error(`notebook controller with id '${y}' ALREADY exist`);const F=this.k++,N=this;this.q.trace(`NotebookController[${F}], CREATED by ${S.identifier.value}, ${y}`);const O=()=>console.warn(`NO execute handler from notebook controller '${V.id}' of extension: '${S.identifier}'`);let j=!1;const z=new T.$je,M=new T.$je,V={id:m(S.identifier,y),notebookType:k,extensionId:S.identifier,extensionLocation:S.extensionLocation,label:A||S.identifier.value,preloads:v?v.map(P.NotebookRendererScript.from):[]};let K=p??O,ne,B;this.a.$addKernel(F,V).catch(re=>{console.log(re),j=!0});let G=0;const Y=()=>{if(j)return;const re=++G;Promise.resolve().then(()=>{re===G&&this.a.$updateKernel(F,V)})},ee=new R.$zc,ue={get id(){return y},get notebookType(){return V.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return V.label},set label(re){V.label=re??S.displayName??S.name,Y()},get detail(){return V.detail??""},set detail(re){V.detail=re,Y()},get description(){return V.description??""},set description(re){V.description=re,Y()},get supportedLanguages(){return V.supportedLanguages},set supportedLanguages(re){V.supportedLanguages=re,Y()},get supportsExecutionOrder(){return V.supportsExecutionOrder??!1},set supportsExecutionOrder(re){V.supportsExecutionOrder=re,Y()},get rendererScripts(){return V.preloads?V.preloads.map(P.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(re){K=re??O},get interruptHandler(){return ne},set interruptHandler(re){ne=re,V.supportsInterrupt=!!re,Y()},set variableProvider(re){(0,f.$5G)(S,"notebookVariableProvider"),B=re,V.hasVariableProvider=!!re,re?.onDidChangeVariables(ye=>N.a.$variablesUpdated(ye.uri)),Y()},get variableProvider(){return B},createNotebookCellExecution(re){if(j)throw new Error("notebook controller is DISPOSED");if(!ee.has(re.notebook.uri))throw N.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ee.keys()).map(ye=>ye.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.notebook.uri.toString()}`);return N._createNotebookCellExecution(re,m(S.identifier,this.id))},createNotebookExecution(re){if((0,f.$5G)(S,"notebookExecution"),j)throw new Error("notebook controller is DISPOSED");if(!ee.has(re.uri))throw N.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ee.keys()).map(ye=>ye.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.uri.toString()}`);return N._createNotebookExecution(re,m(S.identifier,this.id))},dispose:()=>{j||(this.q.trace(`NotebookController[${F}], DISPOSED`),j=!0,this.j.delete(F),z.dispose(),M.dispose(),this.a.$removeKernel(F))},updateNotebookAffinity(re,ye){ye===w.NotebookControllerAffinity2.Hidden&&(0,f.$5G)(S,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(F,re.uri,ye)},onDidReceiveMessage:M.event,postMessage(re,ye){return(0,f.$5G)(S,"notebookMessaging"),N.a.$postMessage(F,ye&&N.n.getIdByEditor(ye),re)},asWebviewUri(re){return(0,f.$5G)(S,"notebookMessaging"),(0,a.$eDb)(re,N.m.remote)}};return this.j.set(F,{extensionId:S.identifier,controller:ue,onDidReceiveMessage:M,onDidChangeSelection:z,associatedNotebooks:ee}),ue}getIdByController(S){for(const[y,k]of this.j)if(k.controller===S)return m(k.extensionId,S.id);return null}createNotebookControllerDetectionTask(S,y){const k=this.g++,A=this;this.q.trace(`NotebookControllerDetectionTask[${k}], CREATED by ${S.identifier.value}`),this.a.$addKernelDetectionTask(k,y);const p={dispose:()=>{this.f.delete(k),A.a.$removeKernelDetectionTask(k)}};return this.f.set(k,p),p}registerKernelSourceActionProvider(S,y,k){const A=this.i++,p=typeof k.onDidChangeNotebookKernelSourceActions=="function"?A:void 0,v=this;this.h.set(A,k),this.q.trace(`NotebookKernelSourceActionProvider[${A}], CREATED by ${S.identifier.value}`),this.a.$addKernelSourceActionProvider(A,A,y);let F;return p!==void 0&&(F=k.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(p))),{dispose:()=>{this.h.delete(A),v.a.$removeKernelSourceActionProvider(A,A),F?.dispose()}}}async $provideKernelSourceActions(S,y){const k=this.h.get(S);if(k){const A=new L.$Sc;return(await k.provideNotebookKernelSourceActions(y)??[]).map(v=>P.NotebookKernelSourceAction.from(v,this.o.converter,A))}return[]}$acceptNotebookAssociation(S,y,k){const A=this.j.get(S);if(A){const p=this.n.getNotebookDocument(b.URI.revive(y));k?A.associatedNotebooks.set(p.uri,!0):A.associatedNotebooks.delete(p.uri),this.q.trace(`NotebookController[${S}] ASSOCIATE notebook`,p.uri.toString(),k),A.onDidChangeSelection.fire({selected:k,notebook:p.apiNotebook})}}async $executeCells(S,y,k){const A=this.j.get(S);if(!A)return;const p=this.n.getNotebookDocument(b.URI.revive(y)),v=[];for(const F of k){const N=p.getCell(F);N&&v.push(N.apiCell)}try{this.q.trace(`NotebookController[${S}] EXECUTE cells`,p.uri.toString(),v.length),await A.controller.executeHandler.call(A.controller,v,p.apiNotebook,A.controller)}catch(F){this.q.error(`NotebookController[${S}] execute cells FAILED`,F),console.error(F)}}async $cancelCells(S,y,k){const A=this.j.get(S);if(!A)return;const p=this.n.getNotebookDocument(b.URI.revive(y));if(A.controller.interruptHandler)await A.controller.interruptHandler.call(A.controller,p.apiNotebook);else for(const v of k){const F=p.getCell(v);F&&this.b.get(F.uri)?.cancel()}if(A.controller.interruptHandler){const v=this.c.get(p.uri);this.c.delete(p.uri),k.length&&Array.isArray(v)&&v.length&&v.forEach(F=>F.dispose())}}async $provideVariables(S,y,k,A,p,v,F){const N=this.j.get(S);if(!N)return;const O=this.n.getNotebookDocument(b.URI.revive(k)),j=N.controller.variableProvider;if(!j)return;let z;if(A!==void 0){if(z=this.s[A],!z)return}else this.s={};const M=p==="named"?w.NotebookVariablesRequestKind.Named:w.NotebookVariablesRequestKind.Indexed,V=j.provideVariables(O.apiNotebook,z,M,v,F);let K=0;for await(const ne of V){if(F.isCancellationRequested)return;const B={id:this.r++,name:ne.variable.name,value:ne.variable.value,type:ne.variable.type,interfaces:ne.variable.interfaces,language:ne.variable.language,expression:ne.variable.expression,hasNamedChildren:ne.hasNamedChildren,indexedChildrenCount:ne.indexedChildrenCount,extensionId:N.extensionId.value};if(this.s[B.id]=ne.variable,this.a.$receiveVariable(y,B),K++>=i.$KK)return}}$acceptKernelMessageFromRenderer(S,y,k){const A=this.j.get(S);if(!A)return;const p=this.n.getEditorById(y);A.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:k}))}$cellExecutionChanged(S,y,k){const p=this.n.getNotebookDocument(b.URI.revive(S)).getCell(y);if(p){const v=k?P.NotebookCellExecutionState.to(k):w.NotebookCellExecutionState.Idle;v!==void 0&&this.l.fire({cell:p.apiCell,state:v})}}_createNotebookCellExecution(S,y){if(S.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const A=this.n.getNotebookDocument(S.notebook.uri).getCellFromApiCell(S);if(!A)throw new Error("invalid cell");if(this.b.has(A.uri))throw new Error(`duplicate execution for ${A.uri}`);const p=new s(y,A,this.a);this.b.set(A.uri,p);const v=p.onDidChangeState(()=>{p.state===t.Resolved&&(p.dispose(),v.dispose(),this.b.delete(A.uri))});return p.asApiObject()}_createNotebookExecution(S,y){const k=this.n.getNotebookDocument(S.uri),A=S.getCells().find(F=>{const N=k.getCellFromApiCell(F);return N&&this.b.has(N.uri)});if(A)throw new Error(`duplicate cell execution for ${A.document.uri}`);if(this.c.has(k.uri))throw new Error(`duplicate notebook execution for ${k.uri}`);const p=new d(y,k,this.a),v=p.onDidChangeState(()=>{p.state===n.Resolved&&(p.dispose(),v.dispose(),this.c.delete(k.uri))});return this.c.set(k.uri,[p,v]),p.asApiObject()}};e.$6pc=o,e.$6pc=o=Ye([Ve(4,I.$9j)],o);var t;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(t||(t={}));class s extends L.$Tc{static{this.a=0}get state(){return this.f}constructor(S,y,k){super(),this.m=y,this.n=k,this.b=s.a++,this.c=new T.$je,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new C.$ue),this.h=new l(10,A=>this.s(A)),this.j=y.internalMetadata.executionOrder,this.n.$createExecution(this.b,S,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(S){await this.h.addItem(S)}async s(S){const y=Array.isArray(S)?S:[S];return this.n.$updateExecution(this.b,new g.$Sw(y))}t(){if(this.f===t.Init)throw new Error("Must call start before modifying cell output");if(this.f===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(S){let y=this.m;if(S&&(y=this.m.notebook.getCellFromApiCell(S)),!y)throw new Error("INVALID cell");return y.handle}y(S){return S.map(y=>{const k=w.$1O.ensureUniqueMimeTypes(y.items,!0);return k===y.items?P.NotebookCellOutput.from(y):P.NotebookCellOutput.from({items:k,id:y.id,metadata:y.metadata})})}async z(S,y,k){const A=this.w(y),p=this.y((0,r.$1b)(S));return this.r({editType:$.CellExecutionUpdateType.Output,cellHandle:A,append:k,outputs:p})}async C(S,y,k){return S=w.$1O.ensureUniqueMimeTypes((0,r.$1b)(S),!0),this.r({editType:$.CellExecutionUpdateType.OutputItems,items:S.map(P.NotebookCellOutputItem.from),outputId:y.id,append:k})}asApiObject(){const S=this;return Object.freeze({get token(){return S.g.token},get cell(){return S.m.apiCell},get executionOrder(){return S.j},set executionOrder(k){S.j=k,S.s([{editType:$.CellExecutionUpdateType.ExecutionState,executionOrder:S.j}])},start(k){if(S.f===t.Resolved||S.f===t.Started)throw new Error("Cannot call start again");S.f=t.Started,S.c.fire(),S.s({editType:$.CellExecutionUpdateType.ExecutionState,runStartTime:k})},end(k,A,p){if(S.f===t.Resolved)throw new Error("Cannot call resolve twice");S.f=t.Resolved,S.c.fire(),S.h.flush();const v=p?{message:p.message,stack:p.stack,location:p?.location?{startLineNumber:p.location.start.line,startColumn:p.location.start.character,endLineNumber:p.location.end.line,endColumn:p.location.end.character}:void 0,uri:p.uri}:void 0;S.n.$completeExecution(S.b,new g.$Sw({runEndTime:A,lastRunSuccess:k,error:v}))},clearOutput(k){return S.t(),S.z([],k,!1)},appendOutput(k,A){return S.t(),S.z(k,A,!0)},replaceOutput(k,A){return S.t(),S.z(k,A,!1)},appendOutputItems(k,A){return S.t(),S.C(k,A,!0)},replaceOutputItems(k,A){return S.t(),S.C(k,A,!1)}})}}var n;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(n||(n={}));class d extends L.$Tc{static{this.a=0}get state(){return this.f}constructor(S,y,k){super(),this.h=y,this.j=k,this.b=d.a++,this.c=new T.$je,this.onDidChangeState=this.c.event,this.f=n.Init,this.g=this.B(new C.$ue),this.j.$createNotebookExecution(this.b,S,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===n.Resolved||this.f===n.Started)throw new Error("Cannot call start again");this.f=n.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===n.Resolved)throw new Error("Cannot call resolve twice");this.f=n.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class l{constructor(S,y){this.f=S,this.g=y,this.a=[],this.b=Date.now()}addItem(S){return this.a.push(S),this.c||(this.c=new h.$Zh,this.b=Date.now(),(0,h.$Dh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const S=this.c;this.c=void 0;const y=this.a;return this.a=[],this.g(y).finally(()=>S.complete())}}function m(E,S){return`${E.value}/${S}`}}),define(ke[47],Ie([1,0,4,6,5,2,19,3,9,8,13,240,20,32,241,242,50,7,15,34,40]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a,$,f,g,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bpc=e.$apc=e.$_oc=e.$$oc=void 0,e.$$oc=(0,C.$Ci)("IExtHostTerminalService");class t extends R.$Tc{constructor(p,v,F,N){super(),this.u=p,this._id=v,this.w=F,this.y=N,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new r.$je),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(j=>this.g=j);const O=this;this.value={get name(){return O.y||""},get processId(){return O.b},get creationOptions(){return O.w},get exitStatus(){return O.j},get state(){return O.m},get selection(){return O.n},get shellIntegration(){return O.shellIntegration},sendText(j,z=!0){O.C(),O.u.$sendText(O._id,j,z)},show(j){O.C(),O.u.$show(O._id,j)},hide(){O.C(),O.u.$hide(O._id)},dispose(){O.a||(O.a=!0,O.u.$dispose(O._id))},get dimensions(){if(!(O.f===void 0||O.h===void 0))return{columns:O.f,rows:O.h}}}}dispose(){this.s.fire(),super.dispose()}async create(p,v){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:p.name,shellPath:p.shellPath??void 0,shellArgs:p.shellArgs??void 0,cwd:p.cwd??v?.cwd??void 0,env:p.env??void 0,icon:S(p.iconPath)??void 0,color:$.ThemeColor.isThemeColor(p.color)?p.color.id:void 0,initialText:p.message??void 0,strictEnv:p.strictEnv??void 0,hideFromUser:p.hideFromUser??void 0,forceShellIntegration:v?.forceShellIntegration??void 0,isFeatureTerminal:v?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:v?.useShellEnvironment??void 0,location:v?.location||this.z(p.location,v?.resolvedExtHostIdentifier),isTransient:p.isTransient??void 0})}async createExtensionTerminal(p,v,F,N,O){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:N,color:$.ThemeColor.isThemeColor(O)?O.id:void 0,location:v?.location||this.z(p,F),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(p,v){return typeof p=="object"?"parentTerminal"in p&&p.parentTerminal&&v?{parentTerminal:v}:"viewColumn"in p?{viewColumn:g.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus}:void 0:p}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(p){this.y=p}setExitStatus(p,v){this.j=Object.freeze({code:p,reason:v})}setDimensions(p,v){return p===this.f&&v===this.h||p===0||v===0?!1:(this.f=p,this.h=v,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(p){this.n=p}_setProcessId(p){this.g?(this.g(p),this.g=void 0):this.b.then(v=>{v!==p&&(this.b=Promise.resolve(p))})}}e.$_oc=t;class s{get onProcessReady(){return this.b.event}constructor(p){this.g=p,this.id=0,this.shouldPersist=!1,this.a=new r.$je,this.onProcessData=this.a.event,this.b=new r.$je,this.d=new r.$je,this.onDidChangeProperty=this.d.event,this.f=new r.$je,this.onProcessExit=this.f.event}refreshProperty(p){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${p}`)}updateProperty(p,v){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${p}, value: ${v}`)}async start(){}shutdown(){this.g.close()}input(p){this.g.handleInput?.(p)}resize(p,v){this.g.setDimensions?.({columns:p,rows:v})}clearBuffer(){}async processBinary(p){}acknowledgeDataEvent(p){}async setUnicodeVersion(p){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(p){this.g.onDidWrite(v=>this.a.fire(v)),this.g.onDidClose?.((v=void 0)=>{this.f.fire(v===void 0?void 0:v)}),this.g.onDidOverrideDimensions?.(v=>{v&&this.d.fire({type:w.ProcessPropertyType.OverrideDimensions,value:{cols:v.columns,rows:v.rows}})}),this.g.onDidChangeName?.(v=>{this.d.fire({type:w.ProcessPropertyType.Title,value:v})}),this.g.open(p||void 0),p&&this.g.setDimensions?.(p),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let n=1,d=class extends R.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(p=>p.value)}constructor(p,v,F){super(),this.Q=v,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new R.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new r.$je,this.onDidCloseTerminal=this.H.event,this.I=new r.$je,this.onDidOpenTerminal=this.I.event,this.J=new r.$je,this.onDidChangeActiveTerminal=this.J.event,this.L=new r.$je,this.onDidChangeTerminalDimensions=this.L.event,this.M=new r.$je,this.onDidChangeTerminalState=this.M.event,this.N=new r.$je,this.onDidChangeShell=this.N.event,this.O=new r.$je({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new r.$je({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=F.getProxy(h.$sN.MainThreadTerminalService),this.y=new a.$vxb(this.a.$sendProcessData),this.a.$registerProcessSupport(p),this.Q.registerArgumentProcessor({processArgument:N=>{const O=j=>{const z=j;return this.getTerminalById(z.instanceId)?.value};switch(N?.$mid){case o.MarshalledId.TerminalContext:return O(N);default:{if(Array.isArray(N))for(let j=0;j<N.length&&N[j].$mid===o.MarshalledId.TerminalContext;j++)N[j]=O(N[j]);return N}}}}),this.B({dispose:()=>{for(const[N,O]of this.g)O.shutdown(!0)}})}getDefaultShell(p){return(p?this.u:this.s)?.path||""}getDefaultShellArgs(p){return(p?this.u:this.s)?.args||[]}createExtensionTerminal(p,v){const F=new t(this.a,(0,P.$Yg)(),p,p.name),N=new s(p.pty);return F.createExtensionTerminal(p.location,v,this.R(p,v).resolvedExtHostIdentifier,S(p.iconPath),y(p.color)).then(O=>{const j=this.S(O,N);this.h[O]=j}),this.f.push(F),F.value}R(p,v){if(v=v||{},p.location&&typeof p.location=="object"&&"parentTerminal"in p.location){const F=p.location.parentTerminal;if(F){const N=this.f.find(O=>O.value===F);N&&(v.resolvedExtHostIdentifier=N._id)}}else p.location&&typeof p.location!="object"?v.location=p.location:v.location&&typeof v.location=="object"&&"splitActiveTerminal"in v.location&&(v.location={splitActiveTerminal:!0});return v}attachPtyToTerminal(p,v){if(!this.getTerminalById(p))throw new Error(`Cannot resolve terminal with id ${p} for virtual process`);const N=new s(v),O=this.S(p,N);this.h[p]=O}async $acceptActiveTerminalChanged(p){const v=this.b;if(p===null){this.b=void 0,v!==this.b&&this.J.fire(this.b);return}const F=this.getTerminalById(p);F&&(this.b=F,v!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(p,v){const F=this.getTerminalById(p);F&&this.O.fire({terminal:F.value,data:v})}async $acceptTerminalDimensions(p,v,F){const N=this.getTerminalById(p);N&&N.setDimensions(v,F)&&this.L.fire({terminal:N.value,dimensions:N.value.dimensions})}async $acceptDidExecuteCommand(p,v){const F=this.getTerminalById(p);F&&this.P.fire({terminal:F.value,...v})}async $acceptTerminalMaximumDimensions(p,v,F){this.g.get(p)?.resize(v,F)}async $acceptTerminalTitleChange(p,v){const F=this.getTerminalById(p);F&&(F.name=v)}async $acceptTerminalClosed(p,v,F){const N=this.X(this.f,p);if(N!==null){const O=this.f.splice(N,1)[0];O.setExitStatus(v,F),this.H.fire(O.value)}}$acceptTerminalOpened(p,v,F,N){if(v){const z=this.X(this.f,v);if(z!==null){this.f[z]._id=p,this.I.fire(this.terminals[z]),this.f[z].isOpen=!0;return}}const O={name:N.name,shellPath:N.executable,shellArgs:N.args,cwd:typeof N.cwd=="string"?N.cwd:T.URI.revive(N.cwd),env:N.env,hideFromUser:N.hideFromUser},j=new t(this.a,p,O,F);this.f.push(j),this.I.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(p,v){this.getTerminalById(p)?._setProcessId(v)}async $startExtensionTerminal(p,v){const F=this.getTerminalById(p);if(!F)return{message:(0,c.localize)(10659,null,p)};F.isOpen||await new Promise(O=>{const j=this.onDidOpenTerminal(async z=>{z===F.value&&(j.dispose(),O())})});const N=this.g.get(p);N?N.startSendingEvents(v):this.j[p]={initialDimensions:v}}S(p,v){const F=new R.$Sc;F.add(v.onProcessReady(O=>this.a.$sendProcessReady(p,O.pid,O.cwd,O.windowsPty))),F.add(v.onDidChangeProperty(O=>this.a.$sendProcessProperty(p,O))),this.y.startBuffering(p,v.onProcessData),F.add(v.onProcessExit(O=>this.U(p,O))),this.g.set(p,v);const N=this.j[p];return N&&v instanceof s&&(v.startSendingEvents(N.initialDimensions),delete this.j[p]),F}$acceptProcessAckDataEvent(p,v){this.g.get(p)?.acknowledgeDataEvent(v)}$acceptProcessInput(p,v){this.g.get(p)?.input(v)}$acceptTerminalInteraction(p){const v=this.getTerminalById(p);v?.setInteractedWith()&&this.M.fire(v.value)}$acceptTerminalSelection(p,v){this.getTerminalById(p)?.setSelection(v)}$acceptProcessResize(p,v,F){try{this.g.get(p)?.resize(v,F)}catch(N){if(N.code!=="EPIPE"&&N.code!=="ERR_IPC_CHANNEL_CLOSED")throw N}}$acceptProcessShutdown(p,v){this.g.get(p)?.shutdown(v)}$acceptProcessRequestInitialCwd(p){this.g.get(p)?.getInitialCwd().then(v=>this.a.$sendProcessProperty(p,{type:w.ProcessPropertyType.InitialCwd,value:v}))}$acceptProcessRequestCwd(p){this.g.get(p)?.getCwd().then(v=>this.a.$sendProcessProperty(p,{type:w.ProcessPropertyType.Cwd,value:v}))}$acceptProcessRequestLatency(p){return Promise.resolve(p)}registerLinkProvider(p){return this.z.add(p),this.z.size===1&&this.a.$startLinkProvider(),new b.$uN(()=>{this.z.delete(p),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(p,v,F){if(this.C.has(v))throw new Error(`Terminal profile provider "${v}" already registered`);return this.C.set(v,F),this.a.$registerProfileProvider(v,p.identifier.value),new b.$uN(()=>{this.C.delete(v),this.a.$unregisterProfileProvider(v)})}registerTerminalQuickFixProvider(p,v,F){if(this.D.has(p))throw new Error(`Terminal quick fix provider "${p}" is already registered`);return this.D.set(p,F),this.a.$registerQuickFixProvider(p,v),new b.$uN(()=>{this.D.delete(p),this.a.$unregisterQuickFixProvider(p)})}async $provideTerminalQuickFixes(p,v){const F=new u.$ue().token;if(F.isCancellationRequested)return;const N=this.D.get(p);if(!N)return;const O=await N.provideTerminalQuickFixes(v,F);if(O===null||Array.isArray(O)&&O.length===0)return;const j=new R.$Sc;if(this.w.value=j,!Array.isArray(O))return O?g.TerminalQuickFix.from(O,this.Q.converter,j):void 0;const z=[];for(const M of O){const V=g.TerminalQuickFix.from(M,this.Q.converter,j);V&&z.push(V)}return z}async $createContributedProfileTerminal(p,v){const F=new u.$ue().token;let N=await this.C.get(p)?.provideTerminalProfile(F);if(!F.isCancellationRequested){if(N&&!("options"in N)&&(N={options:N}),!N||!("options"in N))throw new Error(`No terminal profile options provided for id "${p}"`);if("pty"in N.options){this.createExtensionTerminal(N.options,v);return}this.createTerminalFromOptions(N.options,v)}}async $provideLinks(p,v){const F=this.getTerminalById(p);if(!F)return[];this.F.delete(p),this.G.get(p)?.dispose(!0);const O=new u.$ue;this.G.set(p,O);const j=[],z={terminal:F.value,line:v},M=[];for(const ne of this.z)M.push(f.Promises.withAsyncBody(async B=>{O.token.onCancellationRequested(()=>B({provider:ne,links:[]}));const G=await ne.provideTerminalLinks(z,O.token)||[];O.token.isCancellationRequested||B({provider:ne,links:G})}));const V=await Promise.all(M);if(O.token.isCancellationRequested)return[];const K=new Map;for(const ne of V)ne&&ne.links.length>0&&j.push(...ne.links.map(B=>{const G={id:n++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return K.set(G.id,{provider:ne.provider,link:B}),G}));return this.F.set(p,K),j}$activateLink(p,v){const F=this.F.get(p)?.get(v);F&&F.provider.handleTerminalLink(F.link)}U(p,v){this.y.stopBuffering(p),this.g.delete(p),delete this.j[p];const F=this.h[p];F&&(F.dispose(),delete this.h[p]),this.a.$sendProcessExit(p,v)}getTerminalById(p){return this.W(this.f,p)}getTerminalIdByApiObject(p){const v=this.f.findIndex(F=>F.value===p);return v>=0?v:null}W(p,v){const F=this.X(p,v);return F!==null?p[F]:null}X(p,v){const F=p.findIndex(N=>N._id===v);return F>=0?F:null}getEnvironmentVariableCollection(p){let v=this.n.get(p.identifier.value);return v||(v=this.B(new l),this.Z(p.identifier.value,v)),v.getScopedEnvironmentVariableCollection(void 0)}Y(p,v){const F=(0,D.$Bs)(v.map),N=(0,D.$Cs)(v.descriptionMap);this.a.$setEnvironmentVariableCollection(p,v.persistent,F.length===0?void 0:F,N)}$initEnvironmentVariableCollections(p){p.forEach(v=>{const F=v[0],N=this.B(new l(v[1]));this.Z(F,N)})}$acceptDefaultProfile(p,v){const F=this.s;this.s=p,this.u=v,F?.path!==p.path&&this.N.fire(p.path)}Z(p,v){this.n.set(p,v),this.B(v.onDidChangeCollection(()=>{this.Y(p,v)}))}};e.$apc=d,e.$apc=d=Ye([Ve(1,i.$kQ),Ve(2,L.$1P)],d);class l extends R.$Tc{get persistent(){return this.b}set persistent(p){this.b=p,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(p){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new r.$je,this.map=new Map(p)}getScopedEnvironmentVariableCollection(p){const v=this.j(p);let F=this.a.get(v);return F||(F=new m(this,p),this.a.set(v,F),this.B(F.onDidChangeCollection(()=>this.f.fire()))),F}replace(p,v,F,N){this.g(p,{value:v,type:b.EnvironmentVariableMutatorType.Replace,options:F??{applyAtProcessCreation:!0},scope:N})}append(p,v,F,N){this.g(p,{value:v,type:b.EnvironmentVariableMutatorType.Append,options:F??{applyAtProcessCreation:!0},scope:N})}prepend(p,v,F,N){this.g(p,{value:v,type:b.EnvironmentVariableMutatorType.Prepend,options:F??{applyAtProcessCreation:!0},scope:N})}g(p,v){if(v.options&&v.options.applyAtProcessCreation===!1&&!v.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const F=this.h(p,v.scope),N=this.map.get(F),O=v.options?{applyAtProcessCreation:v.options.applyAtProcessCreation??!1,applyAtShellIntegration:v.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!N||N.value!==v.value||N.type!==v.type||N.options?.applyAtProcessCreation!==O.applyAtProcessCreation||N.options?.applyAtShellIntegration!==O.applyAtShellIntegration||N.scope?.workspaceFolder?.index!==v.scope?.workspaceFolder?.index){const j=this.h(p,v.scope),z={variable:p,...v,options:O};this.map.set(j,z),this.f.fire()}}get(p,v){const F=this.h(p,v),N=this.map.get(F);return N?k(N):void 0}h(p,v){const F=this.j(v);return F.length?`${p}:::${F}`:p}j(p){return this.m(p?.workspaceFolder)??""}m(p){return p?p.uri.toString():void 0}getVariableMap(p){const v=new Map;for(const[F,N]of this.map)this.j(N.scope)===this.j(p)&&v.set(N.variable,k(N));return v}delete(p,v){const F=this.h(p,v);this.map.delete(F),this.f.fire()}clear(p){if(p?.workspaceFolder){for(const[v,F]of this.map)F.scope?.workspaceFolder?.index===p.workspaceFolder.index&&this.map.delete(v);this.n(p)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(p,v){const F=this.j(v),N=this.descriptionMap.get(F);if(!N||N.description!==p){let O;typeof p=="string"?O=p:O=p?.value.split(`

`)[0];const j={description:O,scope:v};this.descriptionMap.set(F,j),this.f.fire()}}getDescription(p){const v=this.j(p);return this.descriptionMap.get(v)?.description}n(p){const v=this.j(p);this.descriptionMap.delete(v)}}class m{get persistent(){return this.b.persistent}set persistent(p){this.b.persistent=p}get onDidChangeCollection(){return this.a&&this.a.event}constructor(p,v){this.b=p,this.d=v,this.a=new r.$je}getScoped(p){return this.b.getScopedEnvironmentVariableCollection(p)}replace(p,v,F){this.b.replace(p,v,F,this.d)}append(p,v,F){this.b.append(p,v,F,this.d)}prepend(p,v,F){this.b.prepend(p,v,F,this.d)}get(p){return this.b.get(p,this.d)}forEach(p,v){this.b.getVariableMap(this.d).forEach((F,N)=>p.call(v,N,F,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(p){this.b.delete(p,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(p){this.b.setDescription(p,this.d)}get description(){return this.b.getDescription(this.d)}}let E=class extends d{constructor(p,v){super(!1,p,v)}createTerminal(p,v,F){throw new I.$$}createTerminalFromOptions(p,v){throw new I.$$}};e.$bpc=E,e.$bpc=E=Ye([Ve(0,i.$kQ),Ve(1,L.$1P)],E);function S(A){if(!(!A||typeof A=="string"))return"id"in A?{id:A.id,color:A.color}:A}function y(A){return $.ThemeColor.isThemeColor(A)?A:void 0}function k(A){const p={...A};return delete p.scope,p.options=p.options??void 0,delete p.variable,p}}),define(ke[167],Ie([1,0,9,3,5,6,19,47,4,2,7]),function(me,e,r,h,C,T,L,R,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mqc=e.$lqc=void 0,e.$lqc=(0,C.$Ci)("IExtHostTerminalShellIntegration");let D=class extends h.$Tc{constructor($,f){super(),this.h=f,this.b=new Map,this.c=new b.$je,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new b.$je,this.onDidStartTerminalShellExecution=this.f.event,this.g=new b.$je,this.onDidEndTerminalShellExecution=this.g.event,this.a=$.getProxy(T.$sN.MainThreadTerminalShellIntegration),this.B((0,h.$Rc)(()=>{for(const[g,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange($){const f=this.h.getTerminalById($);if(!f)return;const g=f.value;let i=this.b.get($);i||(i=new u(f.value,this.f),this.b.set($,i),i.store.add(f.onWillDispose(()=>this.b.get($)?.dispose())),i.store.add(i.onDidRequestShellExecution(o=>this.a.$executeCommand($,o))),i.store.add(i.onDidRequestEndExecution(o=>this.g.fire(o))),i.store.add(i.onDidRequestChangeShellIntegration(o=>this.c.fire(o))),f.shellIntegration=i.value),this.c.fire({terminal:g,shellIntegration:i.value})}$shellExecutionStart($,f,g,i,o){this.b.has($)||this.$shellIntegrationChange($);const t={value:f,confidence:g,isTrusted:i};this.b.get($)?.startShellExecution(t,o)}$shellExecutionEnd($,f,g,i,o){const t={value:f,confidence:g,isTrusted:i};this.b.get($)?.endShellExecution(t,o)}$shellExecutionData($,f){this.b.get($)?.emitData(f)}$cwdChange($,f){this.b.get($)?.setCwd((0,c.$uc)(f)?c.URI.revive(f):f)}$closeTerminal($){this.b.get($)?.dispose(),this.b.delete($)}};e.$mqc=D,e.$mqc=D=Ye([Ve(0,L.$1P),Ve(1,R.$$oc)],D);class u extends h.$Tc{get currentExecution(){return this.a}constructor($,f){super(),this.j=$,this.m=f,this.b=!1,this.store=this.B(new h.$Sc),this.f=this.B(new b.$je),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new b.$je),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new b.$je),this.onDidRequestEndExecution=this.h.event;const g=this;this.value={get cwd(){return g.c},executeCommand(i,o){let t=i;o&&(t+=` "${o.map(d=>`${d.replaceAll('"','\\"')}`).join('" "')}"`),g.g.fire(t);const s={value:t,confidence:r.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},n=g.startShellExecution(s,g.c,!0).value;return g.b=!0,n}}}startShellExecution($,f,g){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new P($,f);g?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData($){this.currentExecution?.emitData($)}endShellExecution($,f){this.a&&(this.a.endExecution($),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:f}),this.a=void 0)}setCwd($){let f=!1;c.URI.isUri(this.c)?f=!c.URI.isUri($)||this.c.toString()!==$.toString():this.c!==$&&(f=!0),f&&(this.c=$,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class P{constructor($,f){this.c=$,this.cwd=f,this.b=!1;const g=this;this.value={get commandLine(){return g.c},get cwd(){return g.cwd},read(){return g.d()}}}d(){if(!this.a){if(this.b)return I.$3h.EMPTY;this.a=new w}return this.a.createIterable()}emitData($){this.a?.emitData($)}endExecution($){$&&(this.c=$),this.a?.endExecution(),this.a=void 0,this.b=!0}}class w extends h.$Tc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new I.$Bh);const $=this.a;return new I.$3h(async g=>{this.b.push(g),await $.wait()})}emitData($){for(const f of this.b)f.emitOne($)}endExecution(){this.a?.open(),this.a=void 0}}}),define(ke[168],Ie([1,0,65,13,132,15,9]),function(me,e,r,h,C,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0P=e.$9P=e.$8P=void 0,T=Ue(T);class R{static{this.c=new C.$6P("TextEditorDecorationType")}constructor(u,P,w){const a=R.c.nextId();u.$registerTextEditorDecorationType(P.identifier,a,T.DecorationRenderOptions.from(w)),this.value=Object.freeze({key:a,dispose(){u.$removeTextEditorDecorationType(a)}})}}e.$8P=R;class b{constructor(u,P){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=P.undoStopBefore,this.f=P.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,P){this.k();let w=null;if(u instanceof L.$vN)w=new L.$wN(u,u);else if(u instanceof L.$wN)w=u;else throw new Error("Unrecognized location");this.l(w,P,!1)}insert(u,P){this.k(),this.l(new L.$wN(u,u),P,!0)}delete(u){this.k();let P=null;if(u instanceof L.$wN)P=u;else throw new Error("Unrecognized location");this.l(P,null,!0)}l(u,P,w){const a=this.c.validateRange(u);this.g.push({range:a,text:P,forceMoveMarkers:w})}setEndOfLine(u){if(this.k(),u!==L.EndOfLine.LF&&u!==L.EndOfLine.CRLF)throw(0,h.$6)("endOfLine");this.h=u}}class c{constructor(u,P,w,a){this.c=u,this.d=P,this._accept(w),this.e=a;const $=this;this.value={get tabSize(){return $.f},set tabSize(f){$.n(f)},get indentSize(){return $.g},set indentSize(f){$.p(f)},get insertSpaces(){return $.j},set insertSpaces(f){$.s(f)},get cursorStyle(){return $.k},set cursorStyle(f){$.t(f)},get lineNumbers(){return $.l},set lineNumbers(f){$.u(f)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=T.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const P=Math.floor(u);return P>0?P:null}if(typeof u=="string"){const P=parseInt(u,10);return isNaN(P)?null:P>0?P:null}return null}n(u){const P=this.m(u);if(P!==null){if(typeof P=="number"){if(this.f===P)return;this.f=P}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:P}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const P=Math.floor(u);return P>0?P:null}if(typeof u=="string"){const P=parseInt(u,10);return isNaN(P)?null:P>0?P:null}return null}p(u){const P=this.o(u);if(P!==null){if(typeof P=="number"){if(this.h===P)return;this.g=P,this.h=P}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:P}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const P=this.q(u);if(typeof P=="boolean"){if(this.j===P)return;this.j=P}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:P}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:T.TextEditorLineNumbersStyle.from(u)})))}assign(u){const P={};let w=!1;if(typeof u.tabSize<"u"){const a=this.m(u.tabSize);a==="auto"?(w=!0,P.tabSize=a):typeof a=="number"&&this.f!==a&&(this.f=a,w=!0,P.tabSize=a)}if(typeof u.indentSize<"u"){const a=this.o(u.indentSize);a==="tabSize"?(w=!0,P.indentSize=a):typeof a=="number"&&this.h!==a&&(this.g=a,this.h=a,w=!0,P.indentSize=a)}if(typeof u.insertSpaces<"u"){const a=this.q(u.insertSpaces);a==="auto"?(w=!0,P.insertSpaces=a):this.j!==a&&(this.j=a,w=!0,P.insertSpaces=a)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,w=!0,P.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,w=!0,P.lineNumbers=T.TextEditorLineNumbersStyle.from(u.lineNumbers)),w&&this.v("setOptions",this.c.$trySetOptions(this.d,P))}v(u,P){P.catch(w=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(w)})}}e.$9P=c;class I{constructor(u,P,w,a,$,f,g,i){this.id=u,this.j=P,this.k=w,this.g=!1,this.h=new Set,this.c=$,this.d=new c(this.j,this.id,f,w),this.e=g,this.f=i;const o=this;this.value=Object.freeze({get document(){return a.value},set document(t){throw new h.$8("document")},get selection(){return o.c&&o.c[0]},set selection(t){if(!(t instanceof L.$xN))throw(0,h.$6)("selection");o.c=[t],o.l()},get selections(){return o.c},set selections(t){if(!Array.isArray(t)||t.some(s=>!(s instanceof L.$xN)))throw(0,h.$6)("selections");o.c=t,o.l()},get visibleRanges(){return o.e},set visibleRanges(t){throw new h.$8("visibleRanges")},get options(){return o.d.value},set options(t){o.g||o.d.assign(t)},get viewColumn(){return o.f},set viewColumn(t){throw new h.$8("viewColumn")},edit(t,s={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new b(a.value,s);return t(n),o.m(n)},insertSnippet(t,s,n={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!s||Array.isArray(s)&&s.length===0)d=o.c.map(l=>T.Range.from(l));else if(s instanceof L.$vN){const{lineNumber:l,column:m}=T.Position.from(s);d=[{startLineNumber:l,startColumn:m,endLineNumber:l,endColumn:m}]}else if(s instanceof L.$wN)d=[T.Range.from(s)];else{d=[];for(const l of s)if(l instanceof L.$wN)d.push(T.Range.from(l));else{const{lineNumber:m,column:E}=T.Position.from(l);d.push({startLineNumber:m,startColumn:E,endLineNumber:m,endColumn:E})}}return P.$tryInsertSnippet(u,a.value.version,t.value,d,n)},setDecorations(t,s){const n=s.length===0;n&&!o.h.has(t.key)||(n?o.h.delete(t.key):o.h.add(t.key),o.n(()=>{if(T.$XP(s))return P.$trySetDecorations(u,t.key,T.$YP(s));{const d=new Array(4*s.length);for(let l=0,m=s.length;l<m;l++){const E=s[l];d[4*l]=E.start.line+1,d[4*l+1]=E.start.character+1,d[4*l+2]=E.end.line+1,d[4*l+3]=E.end.character+1}return P.$trySetDecorationsFast(u,t.key,d)}}))},revealRange(t,s){o.n(()=>P.$tryRevealRange(u,T.Range.from(t),s||L.TextEditorRevealType.Default))},show(t){P.$tryShowEditor(u,T.ViewColumn.from(t))},hide(){P.$tryHideEditor(u)}})}dispose(){(0,r.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,r.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,r.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,r.ok)(!this.g),this.f=u}_acceptSelections(u){(0,r.ok)(!this.g),this.c=u}async l(){const u=this.c.map(T.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const P=u.finalize();if(P.edits.length===0&&!P.setEndOfLine)return Promise.resolve(!0);const w=P.edits.map($=>$.range);w.sort(($,f)=>$.end.line===f.end.line?$.end.character===f.end.character?$.start.line===f.start.line?$.start.character-f.start.character:$.start.line-f.start.line:$.end.character-f.end.character:$.end.line-f.end.line);for(let $=0,f=w.length-1;$<f;$++){const g=w[$].end;if(w[$+1].start.isBefore(g))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=P.edits.map($=>({range:T.Range.from($.range),text:$.text,forceMoveMarkers:$.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,P.documentVersionId,a,{setEndOfLine:typeof P.setEndOfLine=="number"?T.EndOfLine.from(P.setEndOfLine):void 0,undoStopBefore:P.undoStopBefore,undoStopAfter:P.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,P=>(P instanceof Error&&P.name==="DISPOSED"||this.k.warn(P),null))}}e.$0P=I}),define(ke[63],Ie([1,0,65,4,3,2,5,6,164,19,168,15,11,28,14,39,49]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_P=e.$$P=void 0,r=Ue(r),D=Ue(D);class f{constructor(o){this.value=o,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let g=class{constructor(o,t){this.h=o,this.i=t,this.a=null,this.b=new Map,this.c=new P.$zc,this.d=new h.$je,this.e=new h.$je,this.f=new h.$je,this.g=new h.$je,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const t=[],s=[],n=[];if(o.removedDocuments)for(const d of o.removedDocuments){const l=T.URI.revive(d),m=this.c.get(l);m?.unref()&&(this.c.delete(l),t.push(m.value))}if(o.addedDocuments)for(const d of o.addedDocuments){const l=T.URI.revive(d.uri);let m=this.c.get(l);if(m&&l.scheme!==w.Schemas.vscodeNotebookCell&&l.scheme!==w.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);m||(m=new f(new b.$4P(this.h.getProxy(R.$sN.MainThreadDocuments),l,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty)),this.c.set(l,m),s.push(m.value)),m.ref()}if(o.removedEditors)for(const d of o.removedEditors){const l=this.b.get(d);this.b.delete(d),l&&n.push(l)}if(o.addedEditors)for(const d of o.addedEditors){const l=T.URI.revive(d.documentUri);r.ok(this.c.has(l),`document '${l}' does not exist`),r.ok(!this.b.has(d.id),`editor '${d.id}' already exists!`);const m=this.c.get(l).value,E=new I.$0P(d.id,this.h.getProxy(R.$sN.MainThreadTextEditors),this.i,new $.$T(()=>m.document),d.selections.map(D.Selection.to),d.options,d.visibleRanges.map(S=>D.Range.to(S)),typeof d.editorPosition=="number"?D.ViewColumn.to(d.editorPosition):void 0);this.b.set(d.id,E)}o.newActiveEditor!==void 0&&(r.ok(o.newActiveEditor===null||this.b.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this.a=o.newActiveEditor),(0,C.$Oc)(t),(0,C.$Oc)(n),o.removedDocuments&&this.e.fire(t),o.addedDocuments&&this.d.fire(s),(o.removedEditors||o.addedEditors)&&this.f.fire(this.allEditors().map(d=>d.value)),o.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(o){return this.c.get(o)?.value}allDocuments(){return a.Iterable.map(this.c.values(),o=>o.value)}getEditor(o){return this.b.get(o)}activeEditor(o){if(!this.a)return;const t=this.b.get(this.a);return o?t:t?.value}allEditors(){return[...this.b.values()]}};e.$$P=g,e.$$P=g=Ye([Ve(0,c.$1P),Ve(1,u.$9j)],g),e.$_P=(0,L.$Ci)("IExtHostDocumentsAndEditors")}),define(ke[98],Ie([1,0,7,21,20,4,79,60,3,40,17,32,5,11,6,34,63,19,166,15,9,263,73,120,74,25]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a,$,f,g,i,o,t,s,n,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wpc=e.$vpc=e.$upc=e.$tpc=e.$spc=void 0,i=Ue(i);let m=0;const E=new WeakMap;e.$spc=(0,u.$Ci)("IExtHostTesting");let S=class extends b.$Tc{constructor(B,G,Y,ee){super(),this.C=G,this.D=Y,this.F=ee,this.f=this.B(new T.$je),this.g=new Map,this.w=this.B(new T.$je),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=B.getProxy(w.$sN.MainThreadTesting),this.m=new j(this.h),this.j=new p(this.h,G),Y.registerArgumentProcessor({processArgument:ue=>{switch(ue?.$mid){case c.MarshalledId.TestItemContext:{const re=ue,ye=re.tests[re.tests.length-1].item.extId;return this.g.get(s.$RI.root(ye))?.collection.tree.get(ye)?.actual??(0,g.$aQ)(ue)}case c.MarshalledId.TestMessageMenuArgs:{const{test:re,message:ye}=ue,$e=re.item.extId;return{test:this.g.get(s.$RI.root($e))?.collection.tree.get($e)?.actual??(0,g.$aQ)({$mid:c.MarshalledId.TestItemContext,tests:[re]}),message:i.TestMessage.to(ye)}}default:return ue}}}),Y.registerCommand(!1,"testing.getExplorerSelection",async()=>{const ue=await Y.executeCommand(t.TestCommandId.GetExplorerSelection),re=ye=>{const $e=this.g.get(s.$RI.root(ye));if($e)return s.$RI.isRoot(ye)?$e.controller:$e.collection.tree.get(ye)?.actual};return{include:ue?.include.map(re).filter(I.$kg)||[],exclude:ue?.exclude.map(re).filter(I.$kg)||[]}})}createTestController(B,G,Y,ee){if(this.g.has(G))throw new Error(`Attempt to insert a duplicate controller with ID "${G}"`);const ue=new b.$Sc,re=ue.add(new g.$dQ(G,Y,this.F));re.root.label=Y;const ye=new Map,$e=new Set,J=this.h,W={items:re.root.children,get label(){return Y},set label(ae){Y=ae,re.root.label=ae,J.$updateController(G,{label:Y})},get refreshHandler(){return ee},set refreshHandler(ae){ee=ae,J.$updateController(G,{canRefresh:!!ae})},get id(){return G},createRunProfile:(ae,te,ce,le,Z,oe)=>{let pe=(0,R.$qj)(ae);for(;ye.has(pe);)pe++;return new M(this.h,ye,$e,this.w.event,G,pe,ae,te,ce,le,Z,oe)},createTestItem(ae,te,ce){return new g.$bQ(G,ae,te,ce)},createTestRun:(ae,te,ce=!0)=>this.j.createTestRun(B,G,re,ae,te,ce),invalidateTestResults:ae=>{if(ae===void 0)this.h.$markTestRetired(void 0);else{const te=ae instanceof Array?ae:[ae];this.h.$markTestRetired(te.map(ce=>s.$RI.fromExtHostTestItem(ce,G).toString()))}},set resolveHandler(ae){re.resolveHandler=ae},get resolveHandler(){return re.resolveHandler},dispose:()=>{ue.dispose()}};J.$registerTestController(G,Y,!!ee),ue.add((0,b.$Rc)(()=>J.$unregisterTestController(G)));const se={controller:W,collection:re,profiles:ye,extension:B,activeProfiles:$e};return this.g.set(G,se),ue.add((0,b.$Rc)(()=>this.g.delete(G))),ue.add(re.onDidGenerateDiff(ae=>J.$publishDiff(G,ae.map(d.TestsDiffOp.serialize)))),W}createTestObserver(){return this.m.checkout()}async runTests(B,G=C.CancellationToken.None){const Y=v(B);if(!Y)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ee=this.g.get(Y.controllerId);if(!ee)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:B.preserveFocus??!0,group:V[Y.kind],targets:[{testIds:B.include?.map(ue=>s.$RI.fromExtHostTestItem(ue,ee.collection.root.id).toString())??[ee.collection.root.id],profileId:Y.profileId,controllerId:Y.controllerId}],exclude:B.exclude?.map(ue=>ue.id)},G)}registerTestFollowupProvider(B){return this.y.add(B),{dispose:()=>{this.y.delete(B)}}}$syncTests(){for(const{collection:B}of this.g.values())B.flushDiff();return Promise.resolve()}async $getCoverageDetails(B,G,Y){return(await this.j.getCoverageDetails(B,G,Y))?.map(i.TestCoverage.fromDetails)}async $disposeRun(B){this.j.disposeTestRun(B)}$configureRunProfile(B,G){this.g.get(B)?.profiles.get(G)?.configureHandler?.()}$setDefaultRunProfiles(B){const G=new Map;for(const[Y,ee]of Object.entries(B)){const ue=this.g.get(Y);if(!ue)continue;const re=new Map,ye=ee.filter(J=>!ue.activeProfiles.has(J)),$e=[...ue.activeProfiles].filter(J=>!ee.includes(J));for(const J of ye)re.set(J,!0),ue.activeProfiles.add(J);for(const J of $e)re.set(J,!1),ue.activeProfiles.delete(J);re.size&&G.set(Y,re)}this.w.fire(G)}async $refreshTests(B,G){await this.g.get(B)?.controller.refreshHandler?.(G)}$publishTestResults(B){this.results=Object.freeze(B.map(G=>{const Y=i.TestResults.to(G);return E.set(Y,G.id),Y}).concat(this.results).sort((G,Y)=>Y.completedAt-G.completedAt).slice(0,32)),this.f.fire()}async $expandTest(B,G){const Y=this.g.get(s.$RI.fromString(B).controllerId)?.collection;Y&&(await Y.expand(B,G<0?1/0:G),Y.flushDiff())}$acceptDiff(B){this.m.applyDiff(B.map(G=>d.TestsDiffOp.deserialize({asCanonicalUri:Y=>Y},G)))}async $runControllerTests(B,G){return Promise.all(B.map(Y=>this.G(Y,!1,G)))}async $startContinuousRun(B,G){const Y=new C.$ue(G),ee=await Promise.all(B.map(ue=>this.G(ue,!0,Y.token)));return!G.isCancellationRequested&&!ee.some(ue=>ue.error)&&await new Promise(ue=>G.onCancellationRequested(ue)),Y.dispose(!0),ee}async $provideTestFollowups(B,G){const Y=this.results.find(re=>E.get(re)===B.resultId),ee=Y&&K(s.$RI.fromString(B.extId),Y?.results);if(!ee)return[];let ue=[];return await Promise.all([...this.y].map(async re=>{try{const ye=await re.provideFollowup(Y,ee,B.taskIndex,B.messageIndex,G);ye&&(ue=ue.concat(ye))}catch(ye){this.C.error("Error thrown while providing followup for test message",ye)}})),G.isCancellationRequested?[]:ue.map(re=>{const ye=m++;return this.z.set(ye,re),{title:re.title,id:ye}})}$disposeTestFollowups(B){for(const G of B)this.z.delete(G)}$executeTestFollowup(B){const G=this.z.get(B);return G?this.D.executeCommand(G.command,...G.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(B){B===void 0?this.j.cancelAllRuns():this.j.cancelRunById(B)}getMetadataForRun(B){for(const G of this.j.trackers){const Y=G.getTaskIdForRun(B);if(Y)return{taskId:Y,runId:G.id}}}async G(B,G,Y){const ee=this.g.get(B.controllerId);if(!ee)return{};const{collection:ue,profiles:re,extension:ye}=ee,$e=re.get(B.profileId);if(!$e)return{};const J=B.testIds.map(te=>ue.tree.get(te)).filter(I.$kg),W=B.excludeExtIds.map(te=>ee.collection.tree.get(te)).filter(I.$kg).filter(te=>J.some(ce=>ce.fullId.compare(te.fullId)===s.TestPosition.IsChild));if(!J.length)return{};const se=new o.$8O(J.some(te=>te.actual instanceof g.$cQ)?void 0:J.map(te=>te.actual),W.map(te=>te.actual),$e,G),ae=(0,d.$UI)(B)&&this.j.prepareForMainThreadTestRun(ye,se,F.fromInternal(B,ee.collection),$e,Y);try{return await $e.runHandler(se,Y),{}}catch(te){return{error:String(te)}}finally{ae&&ae.hasRunningTasks&&!Y.isCancellationRequested&&await T.Event.toPromise(ae.onEnd)}}};e.$tpc=S,e.$tpc=S=Ye([Ve(0,f.$1P),Ve(1,P.$9j),Ve(2,a.$kQ),Ve(3,$.$_P)],S);const y=1e4;var k;(function(ne){ne[ne.Running=0]="Running",ne[ne.Cancelling=1]="Cancelling",ne[ne.Ended=2]="Ended"})(k||(k={}));class A extends b.$Tc{get hasRunningTasks(){return this.f>0}get id(){return this.z.id}constructor(B,G,Y,ee,ue,re){super(),this.z=B,this.C=G,this.D=Y,this.F=ee,this.G=ue,this.c=k.Running,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new T.$je),this.y=new Map,this.onEnd=this.m.event,this.j=this.B(new C.$ue(re));const ye=this.B(new r.$Oh(()=>this.H(),y));this.B(this.j.token.onCancellationRequested(()=>ye.schedule()));const $e=new T.$je;this.w=$e.event,this.B((0,b.$Rc)(()=>{$e.fire(),$e.dispose()}))}getTaskIdForRun(B){for(const[G,{run:Y}]of this.g)if(Y===B)return G}cancel(){this.c===k.Running?(this.j.cancel(),this.c=k.Cancelling):this.c===k.Cancelling&&this.H()}async getCoverageDetails(B,G,Y){const[,ee]=s.$RI.fromString(B).path,ue=this.y.get(B);if(!ue)return[];const{report:re,extIds:ye}=ue,$e=this.g.get(ee);if(!$e)throw new Error("unreachable: run task was not found");let J;if(G&&re instanceof o.$aP){const se=ye.indexOf(G);if(se===-1)return[];J=re.fromTests[se]}return await(J?this.F?.loadDetailedCoverageForTest?.($e.run,re,J,Y):this.F?.loadDetailedCoverage?.($e.run,re,Y))??[]}createRun(B){const G=this.z.id,Y=this.z.controllerId,ee=(0,D.$Yg)(),ue=J=>(W,...se)=>{if(ye){this.D.warn(`Setting the state of test "${W.id}" is a no-op after the run ends.`);return}this.J(W),J(W,...se)},re=(J,W)=>{const se=W instanceof Array?W.map(i.TestMessage.from):[i.TestMessage.from(W)];if(J.uri&&J.range){const ae={range:i.Range.from(J.range),uri:J.uri};for(const te of se)te.location=te.location||ae}this.C.$appendTestMessagesInRun(G,ee,s.$RI.fromExtHostTestItem(J,Y).toString(),se)};let ye=!1;const $e={isPersisted:this.z.isPersisted,token:this.j.token,name:B,onDidDispose:this.w,addCoverage:J=>{if(ye)return;const W=J instanceof o.$aP?J.fromTests:[];if(W.length){(0,l.$5G)(this.G,"attributableCoverage");for(const te of W)this.J(te)}const se=J.uri.toString(),ae=new s.$RI([G,ee,se]).toString();this.y.set(ae,{report:J,extIds:W.map(te=>s.$RI.fromExtHostTestItem(te,Y).toString())}),this.C.$appendCoverage(G,ee,i.TestCoverage.fromFile(Y,ae,J))},enqueued:ue(J=>{this.C.$updateTestStateInRun(G,ee,s.$RI.fromExtHostTestItem(J,Y).toString(),d.TestResultState.Queued)}),skipped:ue(J=>{this.C.$updateTestStateInRun(G,ee,s.$RI.fromExtHostTestItem(J,Y).toString(),d.TestResultState.Skipped)}),started:ue(J=>{this.C.$updateTestStateInRun(G,ee,s.$RI.fromExtHostTestItem(J,Y).toString(),d.TestResultState.Running)}),errored:ue((J,W,se)=>{re(J,W),this.C.$updateTestStateInRun(G,ee,s.$RI.fromExtHostTestItem(J,Y).toString(),d.TestResultState.Errored,se)}),failed:ue((J,W,se)=>{re(J,W),this.C.$updateTestStateInRun(G,ee,s.$RI.fromExtHostTestItem(J,Y).toString(),d.TestResultState.Failed,se)}),passed:ue((J,W)=>{this.C.$updateTestStateInRun(G,ee,s.$RI.fromExtHostTestItem(J,this.z.controllerId).toString(),d.TestResultState.Passed,W)}),appendOutput:(J,W,se)=>{ye||(se&&this.J(se),this.C.$appendOutputToRun(G,ee,h.$Le.fromString(J),W&&i.location.from(W),se&&s.$RI.fromExtHostTestItem(se,Y).toString()))},end:()=>{ye||(ye=!0,this.C.$finishedTestRunTask(G,ee),--this.f||this.I())}};return this.f++,this.g.set(ee,{run:$e}),this.C.$startedTestRunTask(G,{id:ee,name:B,running:!0}),$e}H(){for(const{run:B}of this.g.values())B.end()}I(){this.c!==k.Ended&&(this.c=k.Ended,this.m.fire())}J(B){if(!(B instanceof g.$bQ))throw new n.$SP(B.id);if(this.h.has(s.$RI.fromExtHostTestItem(B,this.z.controllerId).toString()))return;const G=[],Y=this.z.colllection.root;for(;;){const ee=i.TestItem.from(B);if(G.unshift(ee),this.h.has(ee.extId)||(this.h.add(ee.extId),B===Y))break;B=B.parent||Y}this.C.$addTestsToRun(this.z.controllerId,this.z.id,G)}dispose(){this.I(),super.dispose()}}class p{get trackers(){return this.c.values()}constructor(B,G){this.g=B,this.h=G,this.c=new Map,this.f=new Map}getCoverageDetails(B,G,Y){const ee=s.$RI.root(B);return this.f.get(ee)?.getCoverageDetails(B,G,Y)||[]}disposeTestRun(B){this.f.get(B)?.dispose(),this.f.delete(B);for(const[G,{id:Y}]of this.c)Y===B&&this.c.delete(G)}prepareForMainThreadTestRun(B,G,Y,ee,ue){return this.j(G,Y,ee,B,ue)}cancelRunById(B){this.f.get(B)?.cancel()}cancelAllRuns(){for(const B of this.c.values())B.cancel()}createTestRun(B,G,Y,ee,ue,re){const ye=this.c.get(ee);if(ye)return ye.createRun(ue);const $e=F.fromPublic(G,Y,ee,re),J=v(ee);this.g.$startedExtensionTestRun({controllerId:G,continuous:!!ee.continuous,profile:J&&{group:V[J.kind],id:J.profileId},exclude:ee.exclude?.map(se=>s.$RI.fromExtHostTestItem(se,Y.root.id).toString())??[],id:$e.id,include:ee.include?.map(se=>s.$RI.fromExtHostTestItem(se,Y.root.id).toString())??[Y.root.id],preserveFocus:ee.preserveFocus??!0,persist:re});const W=this.j(ee,$e,ee.profile,B);return T.Event.once(W.onEnd)(()=>{this.g.$finishedExtensionTestRun($e.id)}),W.createRun(ue)}j(B,G,Y,ee,ue){const re=new A(G,this.g,this.h,Y,ee,ue);return this.c.set(B,re),this.f.set(re.id,re),re}}e.$upc=p;const v=ne=>{if(ne.profile){if(!(ne.profile instanceof M))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return ne.profile}};class F{static fromPublic(B,G,Y,ee){return new F(B,(0,D.$Yg)(),ee,G)}static fromInternal(B,G){return new F(B.controllerId,B.runId,!0,G)}constructor(B,G,Y,ee){this.controllerId=B,this.id=G,this.isPersisted=Y,this.colllection=ee}}e.$vpc=F;class N{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(B){this.j=B,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(B){this.c.add(B)}update(B){Object.assign(B.revived,i.TestItem.toPlain(B.item)),this.c.has(B)||this.f.add(B)}remove(B){if(this.c.has(B)){this.c.delete(B);return}this.f.delete(B);const G=s.$RI.parentId(B.item.extId);if(G&&this.h.has(G.toString())){this.h.add(B.item.extId);return}this.g.add(B)}getChangeEvent(){const{c:B,f:G,g:Y}=this;return{get added(){return[...B].map(ee=>ee.revived)},get updated(){return[...G].map(ee=>ee.revived)},get removed(){return[...Y].map(ee=>ee.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class O extends d.$1I{constructor(){super(...arguments),this.y=new T.$je,this.onDidChangeTests=this.y.event}get rootTests(){return this.g}getMirroredTestDataById(B){return this.f.get(B)}getMirroredTestDataByReference(B){return this.f.get(B.id)}x(B,G){return{...B,revived:i.TestItem.toPlain(B.item),depth:G?G.depth+1:0,children:new Set}}w(){return new N(this.y)}}class j{constructor(B){this.f=B}checkout(){this.c||(this.c=this.g());const B=this.c;return B.observers++,{onDidChangeTest:B.tests.onDidChangeTests,get tests(){return[...B.tests.rootTests].map(G=>G.revived)},dispose:(0,L.$cb)(()=>{--B.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(B){return this.c?.tests.getMirroredTestDataByReference(B)}applyDiff(B){this.c?.tests.apply(B)}g(){const B=new O({asCanonicalUri:G=>G});return this.f.$subscribeToDiffs(),{observers:0,tests:B}}}const z=(ne,B,G,Y)=>{G?Object.assign(G,Y):B.$updateTestRunConfig(ne.controllerId,ne.profileId,Y)};class M{#e;#t;#i;#n;#s;get label(){return this.f}set label(B){B!==this.f&&(this.f=B,z(this,this.#e,this.#n,{label:B}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(B){B!==this.g&&(this.g=B,z(this,this.#e,this.#n,{supportsContinuousRun:B}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(B){B!==this.isDefault&&(B?this.#t.add(this.profileId):this.#t.delete(this.profileId),z(this,this.#e,this.#n,{isDefault:B}))}get tag(){return this._tag}set tag(B){B?.id!==this._tag?.id&&(this._tag=B,z(this,this.#e,this.#n,{tag:B?i.TestTag.namespace(this.controllerId,B.id):null}))}get configureHandler(){return this.c}set configureHandler(B){B!==this.c&&(this.c=B,z(this,this.#e,this.#n,{hasConfigurationHandler:!!B}))}get onDidChangeDefault(){return T.Event.chain(this.#i,B=>B.map(G=>G.get(this.controllerId)?.get(this.profileId)).filter(I.$kg))}constructor(B,G,Y,ee,ue,re,ye,$e,J,W=!1,se=void 0,ae=!1){this.controllerId=ue,this.profileId=re,this.f=ye,this.kind=$e,this.runHandler=J,this._tag=se,this.g=ae,this.#e=B,this.#s=G,this.#t=Y,this.#i=ee,G.set(re,this);const te=V[$e];if(typeof te!="number")throw new Error(`Unknown TestRunProfile.group ${$e}`);W&&Y.add(re),this.#n={profileId:re,controllerId:ue,tag:se?i.TestTag.namespace(this.controllerId,se.id):null,label:ye,group:te,isDefault:W,hasConfigurationHandler:!1,supportsContinuousRun:ae},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$wpc=M;const V={[o.TestRunProfileKind.Coverage]:d.TestRunProfileBitset.Coverage,[o.TestRunProfileKind.Debug]:d.TestRunProfileBitset.Debug,[o.TestRunProfileKind.Run]:d.TestRunProfileBitset.Run};function K(ne,B){for(let G=0;G<ne.path.length;G++){const Y=B.find(ee=>ee.id===ne.path[G]);if(!Y)return;if(G===ne.path.length-1)return Y;B=Y.children}}}),define(ke[319],Ie([1,0,18,4,3,6,168,15,9]),function(me,e,r,h,C,T,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Doc=void 0,r=Ue(r),R=Ue(R);class c extends C.$Tc{constructor(D,u){super(),this.m=u,this.a=new h.$je,this.b=new h.$je,this.c=new h.$je,this.f=new h.$je,this.g=new h.$je,this.h=new h.$je,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=D.getProxy(T.$sN.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(P=>this.h.fire(P))),this.B(this.m.onDidChangeActiveTextEditor(P=>this.g.fire(P)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(D){const u=this.m.allEditors();return D?u:u.map(P=>P.value)}async showTextDocument(D,u,P){let w;typeof u=="number"?w={position:R.ViewColumn.from(u),preserveFocus:P}:typeof u=="object"?w={position:R.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?R.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:w={preserveFocus:!1};const a=await this.j.$tryShowTextDocument(D.uri,w),$=a&&this.m.getEditor(a);if($)return $.value;throw a?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}createTextEditorDecorationType(D,u){return new L.$8P(this.j,D,u).value}$acceptEditorPropertiesChanged(D,u){const P=this.m.getEditor(D);if(!P)throw new Error("unknown text editor");if(u.options&&P._acceptOptions(u.options),u.selections){const w=u.selections.selections.map(R.Selection.to);P._acceptSelections(w)}if(u.visibleRanges){const w=r.$Gb(u.visibleRanges.map(R.Range.to));P._acceptVisibleRanges(w)}if(u.options&&this.b.fire({textEditor:P.value,options:{...u.options,lineNumbers:R.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const w=b.TextEditorSelectionChangeKind.fromValue(u.selections.source),a=u.selections.selections.map(R.Selection.to);this.a.fire({textEditor:P.value,selections:a,kind:w})}if(u.visibleRanges){const w=r.$Gb(u.visibleRanges.map(R.Range.to));this.c.fire({textEditor:P.value,visibleRanges:w})}}$acceptEditorPositionData(D){for(const u in D){const P=this.m.getEditor(u);if(!P)throw new Error("Unknown text editor");const w=R.ViewColumn.to(D[u]);P.value.viewColumn!==w&&(P._acceptViewColumn(w),this.f.fire({textEditor:P.value,viewColumn:w}))}}getDiffInformation(D){return Promise.resolve(this.j.$getDiffInformation(D))}}e.$Doc=c}),define(ke[320],Ie([1,0,2,5,6,3,9,15,23,40,17]),function(me,e,r,h,C,T,L,R,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pqc=e.$oqc=void 0,e.$oqc=(0,h.$Ci)("IExtHostTimeline");class D{constructor(w,a){this.b=new Map,this.c=new Map,this.a=w.getProxy(C.$sN.MainThreadTimeline),a.registerArgumentProcessor({processArgument:($,f)=>{if($&&$.$mid===c.MarshalledId.TimelineActionContext)if(this.b.get($.source)&&b.$nn.equals(f,this.b.get($.source)?.extension)){const g=$.uri===void 0?void 0:r.URI.revive($.uri);return this.c.get($.source)?.get(u(g))?.get($.handle)}else return;return $}})}async $getTimeline(w,a,$,f){return this.b.get(w)?.provider.provideTimeline(r.URI.revive(a),$,f)}registerTimelineProvider(w,a,$,f){const g=new T.$Sc,i=this.d(a.id,f,g).bind(this);let o;a.onDidChange&&(o=a.onDidChange(s=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...s,id:a.id}),this));const t=this.c;return this.f({...a,scheme:w,onDidChange:void 0,async provideTimeline(s,n,d){n?.resetCache&&(g.clear(),t.get(a.id)?.clear());const l=await a.provideTimeline(s,n,d);if(l==null)return;const m=i(s,n);return{...l,source:a.id,items:l.items.map(m)}},dispose(){for(const s of t.values())s.get(a.id)?.clear();o?.dispose(),g.dispose()}},$)}d(w,a,$){return(f,g)=>{let i;if(g?.cacheResults){let o=this.c.get(w);o===void 0&&(o=new Map,this.c.set(w,o));const t=u(f);i=o.get(t),i===void 0&&(i=new Map,o.set(t,i))}return o=>{const{iconPath:t,...s}=o,n=`${w}|${o.id??o.timestamp}`;i?.set(n,o);let d,l,m;o.iconPath&&(t instanceof L.$rO?m={id:t.id,color:t.color}:r.URI.isUri(t)?(d=t,l=t):{light:d,dark:l}=t);let E;return L.$WN.isMarkdownString(s.tooltip)?E=R.MarkdownString.from(s.tooltip):(0,I.$cg)(s.tooltip)?E=s.tooltip:L.$WN.isMarkdownString(s.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=R.MarkdownString.from(s.detail)):(0,I.$cg)(s.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=s.detail),{...s,id:s.id??void 0,handle:n,source:w,command:o.command?a.toInternal(o.command,$):void 0,icon:d,iconDark:l,themeIcon:m,tooltip:E,accessibilityInformation:o.accessibilityInformation}}}}f(w,a){if(this.b.get(w.id))throw new Error(`Timeline Provider ${w.id} already exists.`);return this.a.$registerTimelineProvider({id:w.id,label:w.label,scheme:w.scheme}),this.b.set(w.id,{provider:w,extension:a}),(0,T.$Rc)(()=>{for(const f of this.c.values())f.get(w.id)?.clear();this.b.delete(w.id),this.a.$unregisterTimelineProvider(w.id),w.dispose()})}}e.$pqc=D;function u(P){return P?.toString()}}),define(ke[321],Ie([1,0,8,22,2,4,3,254,7,9,17,18,15,85,20,208,25]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qqc=void 0,c=Ue(c);function f(o,t){if((0,I.$cg)(o))return{label:o};if(o&&typeof o=="object"&&typeof o.label=="string"){let s;return Array.isArray(o.highlights)&&(s=o.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),s=s.length?s:void 0),{label:o.label,highlights:s}}}class g extends L.$Tc{constructor(t,s,n){super(),this.f=t,this.g=s,this.h=n,this.a=new Map,this.b=new a.$m_;function d(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}s.registerArgumentProcessor({processArgument:l=>d(l)?this.r(l):Array.isArray(l)&&l.length>0?l.map(m=>d(m)?this.r(m):m):l})}registerTreeDataProvider(t,s,n){const d=this.createTreeView(t,{treeDataProvider:s},n);return{dispose:()=>d.dispose()}}createTreeView(t,s,n){if(!s||!s.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=s.dragAndDropController?.dropMimeTypes??[],l=s.dragAndDropController?.dragMimeTypes??[],m=!!s.dragAndDropController?.handleDrag,E=!!s.dragAndDropController?.handleDrop,S=this.m(t,s,n),y={showCollapseAll:!!s.showCollapseAll,canSelectMany:!!s.canSelectMany,dropMimeTypes:d,dragMimeTypes:l,hasHandleDrag:m,hasHandleDrop:E,manuallyManageCheckboxes:!!s.manageCheckboxStateManually},k=this.f.$registerTreeViewDataProvider(t,y),A={get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get activeItem(){return(0,$.$5G)(n,"treeViewActiveItem"),S.focusedElement},get onDidChangeActiveItem(){return(0,$.$5G)(n,"treeViewActiveItem"),S.onDidChangeActiveItem},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get onDidChangeCheckboxState(){return S.onDidChangeCheckboxState},get message(){return S.message},set message(p){(0,P.$2k)(p)&&(0,$.$5G)(n,"treeViewMarkdownMessage"),S.message=p},get title(){return S.title},set title(p){S.title=p},get description(){return S.description},set description(p){S.description=p},get badge(){return S.badge},set badge(p){p!==void 0&&c.ViewBadge.isViewBadge(p)?S.badge={value:Math.floor(Math.abs(p.value)),tooltip:p.tooltip}:p===void 0&&(S.badge=void 0)},reveal:(p,v)=>S.reveal(p,v),dispose:async()=>{await k,this.a.delete(t),S.dispose()}};return this.B(A),A}$getChildren(t,s){const n=this.a.get(t);return n?n.getChildren(s):Promise.reject(new R.$oG(t))}async $handleDrop(t,s,n,d,l,m,E,S){const y=this.a.get(t);if(!y)return Promise.reject(new R.$oG(t));const k=u.DataTransfer.toDataTransfer(n,async A=>(await this.f.$resolveDropFileData(t,s,A)).buffer);return E===t&&S&&await this.j(k,y,S,l,m),y.onDrop(k,d,l)}async j(t,s,n,d,l){const m=this.b.removeDragOperationTransfer(l);if(m)(await m)?.forEach((E,S)=>{E&&t.set(S,E)});else if(l&&s.handleDrag){const E=s.handleDrag(n,t,d);this.b.addDragOperationTransfer(l,E),await E}return t}async $handleDrag(t,s,n,d){const l=this.a.get(t);if(!l)return Promise.reject(new R.$oG(t));const m=await this.j(new c.$nO,l,s,d,n);if(!(!m||d.isCancellationRequested))return u.DataTransfer.from(m)}async $hasResolve(t){const s=this.a.get(t);if(!s)throw new R.$oG(t);return s.hasResolve}$resolve(t,s,n){const d=this.a.get(t);if(!d)throw new R.$oG(t);return d.resolveTreeItem(s,n)}$setExpanded(t,s,n){const d=this.a.get(t);if(!d)throw new R.$oG(t);d.setExpanded(s,n)}$setSelectionAndFocus(t,s,n){const d=this.a.get(t);if(!d)throw new R.$oG(t);d.setSelectionAndFocus(s,n)}$setVisible(t,s){const n=this.a.get(t);if(!n){if(!s)return;throw new R.$oG(t)}n.setVisible(s)}$changeCheckboxState(t,s){const n=this.a.get(t);if(!n)throw new R.$oG(t);n.setCheckboxState(s)}m(t,s,n){const d=this.B(new i(t,s,this.f,this.g.converter,this.h,n));return this.a.set(t,d),d}r(t){const s=this.a.get(t.$treeViewId);return s&&"$treeItemHandle"in t?s.getExtensionElement(t.$treeItemHandle):s&&"$focusedTreeItem"in t&&t.$focusedTreeItem?s.focusedElement:null}}e.$qqc=g;class i extends L.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(t=>this.getExtensionElement(t)).filter(t=>!(0,I.$lg)(t))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(t,s,n,d,l,m){if(super(),this.I=t,this.J=n,this.L=d,this.M=l,this.N=m,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new T.$je),this.onDidExpandElement=this.u.event,this.w=this.B(new T.$je),this.onDidCollapseElement=this.w.event,this.y=this.B(new T.$je),this.onDidChangeSelection=this.y.event,this.z=this.B(new T.$je),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new T.$je),this.onDidChangeVisibility=this.C.event,this.D=this.B(new T.$je),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new T.$je),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new w.$ue,m.contributes&&m.contributes.views)for(const k in m.contributes.views)for(const A of m.contributes.views[k])A.id===t&&(this.P=A.name);this.f=s.treeDataProvider,this.g=s.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(k=>{Array.isArray(k)&&k.length===0||this.F.fire({message:!1,element:k})}));let E,S;const y=T.Event.debounce(this.F.event,(k,A)=>(k||(k={message:!1,elements:[]}),A.element!==!1&&(E||(E=new Promise(p=>S=p),this.G=this.G.then(()=>E)),Array.isArray(A.element)?k.elements.push(...A.element):k.elements.push(A.element)),A.message&&(k.message=!0),k),200,!0);this.B(y(({message:k,elements:A})=>{A.length&&(this.H=this.H.then(()=>{const p=S;return E=null,this.$(A).then(()=>p())})),k&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(t){const s=t?this.getExtensionElement(t):void 0;if(t&&!s)return this.M.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let n=this.X(t);return n||(n=await this.Y(s)),n?n.map(d=>d.item):void 0}getExtensionElement(t){return this.j.get(t)}reveal(t,s){s=s||{select:!0,focus:!1};const n=(0,I.$lg)(s.select)?!0:s.select,d=(0,I.$lg)(s.focus)?!1:s.focus,l=(0,I.$lg)(s.expand)?!1:s.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.G.then(()=>this.S(t)).then(m=>this.W(t,m[m.length-1]).then(E=>this.J.$reveal(this.I,{item:E.item,parentChain:m.map(S=>S.item)},{select:n,focus:d,expand:l})),m=>this.M.error(m)):this.J.$reveal(this.I,void 0,{select:n,focus:d,expand:l})}get message(){return this.O}set message(t){this.O=t,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(t){this.P=t,this.J.$setTitle(this.I,t,this.Q)}get description(){return this.Q}set description(t){this.Q=t,this.J.$setTitle(this.I,this.P,t)}get badge(){return this.R}set badge(t){this.R?.value===t?.value&&this.R?.tooltip===t?.tooltip||(this.R=u.ViewBadge.from(t),this.J.$setBadge(this.I,t))}setExpanded(t,s){const n=this.getExtensionElement(t);n&&(s?this.u.fire(Object.freeze({element:n})):this.w.fire(Object.freeze({element:n})))}setSelectionAndFocus(t,s){const n=!(0,D.$tb)(this.s,t);this.s=t;const d=this.t!==s;this.t=s,n&&this.y.fire(Object.freeze({selection:this.selectedElements})),d&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this.r&&(this.r=t,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(t){const s=(await Promise.all(t.map(async n=>{const d=this.getExtensionElement(n.treeItemHandle);return d?{extensionItem:d,treeItem:await this.f.getTreeItem(d),newState:n.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(n=>n!==void 0);s.forEach(n=>{n.treeItem.checkboxState=n.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}),this.D.fire({items:s.map(n=>[n.extensionItem,n.newState])})}async handleDrag(t,s,n){const d=[];for(const l of t){const m=this.getExtensionElement(l);m&&d.push(m)}if(!(!this.g?.handleDrag||d.length===0))return await this.g.handleDrag(d,s,n),s}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(t,s,n){const d=s?this.getExtensionElement(s):void 0;if(!(!d&&s||!this.g?.handleDrop))return(0,b.$uh)(()=>this.g?.handleDrop?this.g.handleDrop(d,t,n):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(t,s){if(!this.f.resolveTreeItem)return;const n=this.j.get(t);if(n){const d=this.m.get(n);if(d){const l=await this.f.resolveTreeItem(d.extensionItem,n,s)??d.extensionItem;return this.hb(l),d.item.tooltip=this.eb(l.tooltip),d.item.command=this.fb(d.disposableStore,l.command),d.item}}}S(t){return this.U(t).then(s=>s?this.S(s).then(n=>this.W(s,n[n.length-1]).then(d=>(n.push(d),n))):Promise.resolve([]))}U(t){const s=this.m.get(t);return s?Promise.resolve(s.parent?this.j.get(s.parent.item.handle):void 0):(0,b.$uh)(()=>this.f.getParent(t))}W(t,s){const n=this.m.get(t);return n?Promise.resolve(n):(0,b.$uh)(()=>this.f.getTreeItem(t)).then(d=>this.kb(t,d,s,!0)).then(d=>this.getChildren(s?s.item.handle:void 0).then(()=>{const l=this.getExtensionElement(d);if(l){const m=this.m.get(l);if(m)return Promise.resolve(m)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.N.identifier.value}`)}))}X(t){if(t){let s;if(typeof t=="string"){const n=this.getExtensionElement(t);s=n?this.m.get(n):void 0}else s=t;return s&&s.children||void 0}return this.h}async Y(t){this.rb(t);const s=new w.$ue(this.Z.token);try{const n=t?this.m.get(t):void 0,d=await this.f.getChildren(t);if(s.token.isCancellationRequested)return;const l=(0,D.$Gb)(d||[]),m=await Promise.all((0,D.$Gb)(l).map(S=>this.f.getTreeItem(S)));if(s.token.isCancellationRequested)return;const E=m.map((S,y)=>S?this.db(l[y],S,n):null);return(0,D.$Gb)(E)}finally{s.dispose()}}$(t){if(t.some(n=>!n))return this.Z.dispose(!0),this.Z=new w.$ue,this.tb(),this.J.$refresh(this.I);{const n=this.ab(t);if(n.length)return this.bb(n)}return Promise.resolve(void 0)}ab(t){const s=new Set,n=t.map(l=>this.m.get(l));for(const l of n)if(l&&!s.has(l.item.handle)){let m=l;for(;m&&m.parent&&n.findIndex(E=>m&&m.parent&&E&&E.item.handle===m.parent.item.handle)===-1;){const E=this.j.get(m.parent.item.handle);m=E?this.m.get(E):void 0}m&&!m.parent&&s.add(l.item.handle)}const d=[];return s.forEach(l=>{const m=this.j.get(l);if(m){const E=this.m.get(m);E&&(!E.parent||!s.has(E.parent.item.handle))&&d.push(l)}}),d}bb(t){const s={};return Promise.all(t.map(n=>this.cb(n).then(d=>{d&&(s[n]=d.item)}))).then(()=>Object.keys(s).length?this.J.$refresh(this.I,s):void 0)}cb(t){const s=this.getExtensionElement(t);if(s){const n=this.m.get(s);if(n)return this.rb(s),(0,b.$uh)(()=>this.f.getTreeItem(s)).then(d=>{if(d){const l=this.ib(s,d,n.parent);return this.pb(s,l,n,n.parent),n.dispose(),l}return null})}return Promise.resolve(null)}db(t,s,n){const d=this.ib(t,s,n);if(s.id&&this.j.has(d.item.handle))throw new Error((0,r.localize)(10658,null,s.id));return this.ob(t,d),this.qb(d,n),d}eb(t){return c.$WN.isMarkdownString(t)?u.MarkdownString.from(t):t}fb(t,s){return s?{...this.L.toInternal(s,t),originalId:s.command}:void 0}gb(t){if(t.checkboxState===void 0)return;let s,n,d;return typeof t.checkboxState=="number"?s=t.checkboxState:(s=t.checkboxState.state,n=t.checkboxState.tooltip,d=t.checkboxState.accessibilityInformation),{isChecked:s===c.TreeItemCheckboxState.Checked,tooltip:n,accessibilityInformation:d}}hb(t){if(!c.$iO.isTreeItem(t,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(t,s,n){this.hb(s);const d=this.B(new L.$Sc),l=this.kb(t,s,n),m=this.lb(s);return{item:{handle:l,parentHandle:n?n.item.handle:void 0,label:f(s.label,this.N),description:s.description,resourceUri:s.resourceUri,tooltip:this.eb(s.tooltip),command:this.fb(d,s.command),contextValue:s.contextValue,icon:m,iconDark:this.mb(s)||m,themeIcon:this.jb(s),collapsibleState:(0,I.$lg)(s.collapsibleState)?c.TreeItemCollapsibleState.None:s.collapsibleState,accessibilityInformation:s.accessibilityInformation,checkbox:this.gb(s)},extensionItem:s,parent:n,children:void 0,disposableStore:d,dispose(){d.dispose()}}}jb(t){return t.iconPath instanceof c.$rO?t.iconPath:void 0}kb(t,{id:s,label:n,resourceUri:d},l,m){if(s)return`${i.b}/${s}`;const E=f(n,this.N),S=l?l.item.handle:i.a;let y=E?E.label:d?(0,h.$ah)(d):"";y=y.indexOf("/")!==-1?y.replace("/","//"):y;const k=this.m.has(t)?this.m.get(t).item.handle:void 0,A=this.X(l)||[];let p,v=0;do{if(p=`${S}/${v}:${y}`,m||!this.j.has(p)||k===p)break;v++}while(v<=A.length);return p}lb(t){if(t.iconPath&&!(t.iconPath instanceof c.$rO))return typeof t.iconPath=="string"||C.URI.isUri(t.iconPath)?this.nb(t.iconPath):this.nb(t.iconPath.light)}mb(t){if(t.iconPath&&!(t.iconPath instanceof c.$rO)&&t.iconPath.dark)return this.nb(t.iconPath.dark)}nb(t){return C.URI.isUri(t)?t:C.URI.file(t)}ob(t,s){this.j.set(s.item.handle,t),this.m.set(t,s)}pb(t,s,n,d){this.j.delete(s.item.handle),this.m.delete(t),s.item.handle!==n.item.handle&&this.j.delete(n.item.handle),this.ob(t,s);const l=this.X(d)||[],m=l.filter(E=>E.item.handle===n.item.handle)[0];m&&l.splice(l.indexOf(m),1,s)}qb(t,s){s?(s.children||(s.children=[]),s.children.push(t)):(this.h||(this.h=[]),this.h.push(t))}rb(t){if(t){const s=this.m.get(t);if(s){if(s.children)for(const n of s.children){const d=this.j.get(n.item.handle);d&&this.sb(d)}s.children=void 0}}else this.tb()}sb(t){const s=this.m.get(t);if(s){if(s.children)for(const n of s.children){const d=this.j.get(n.item.handle);d&&this.sb(d)}this.m.delete(t),this.j.delete(s.item.handle),s.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(t=>t.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[322],Ie([1,0,4,3,2,32,15,96,6,9]),function(me,e,r,h,C,T,L,R,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Woc=void 0,L=Ue(L),b=Ue(b),c=Ue(c);class I extends h.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;#h;constructor(w,a,$,f){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#d=this.B(new r.$je),this.onDidDispose=this.#d.event,this.#h=this.B(new r.$je),this.onDidChangeViewState=this.#h.event,this.#e=w,this.#t=a,this.#n=$,this.#i=f.viewType,this.#s=f.panelOptions,this.#o=f.viewColumn,this.#r=f.title,this.#l=f.active}dispose(){this.#u||(this.#u=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(w){this.c(),this.#r!==w&&(this.#r=w,this.#t.$setTitle(this.#e,w))}get iconPath(){return this.c(),this.#a}set iconPath(w){this.c(),this.#a!==w&&(this.#a=w,this.#t.$setIconPath(this.#e,C.URI.isUri(w)?{light:w,dark:w}:w))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#l}get visible(){return this.c(),this.#c}_updateViewState(w){this.#u||(this.active!==w.active||this.visible!==w.visible||this.viewColumn!==w.viewColumn)&&(this.#l=w.active,this.#c=w.visible,this.#o=w.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(w,a){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof w>"u"?void 0:L.ViewColumn.from(w),preserveFocus:!!a})}c(){if(this.#u)throw new Error("Webview is disposed")}}class D extends h.$Tc{static c(){return(0,T.$Yg)()}constructor(w,a,$){super(),this.j=a,this.m=$,this.g=new Map,this.h=new Map,this.f=w.getProxy(b.$sN.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(w=>w.dispose()),this.g.clear()}createWebviewPanel(w,a,$,f,g={}){const i=typeof f=="object"?f.viewColumn:f,o={viewColumn:L.ViewColumn.from(i),preserveFocus:typeof f=="object"&&!!f.preserveFocus},t=(0,R.$Soc)(w),s=D.c();this.f.$createWebviewPanel((0,R.$Uoc)(w),s,a,{title:$,panelOptions:u(g),webviewOptions:(0,R.$Voc)(w,this.m,g),serializeBuffersForPostMessage:t},o);const n=this.j.createNewWebview(s,g,w);return this.createNewWebviewPanel(s,a,$,i,g,n,!0)}$onDidChangeWebviewPanelViewStates(w){const a=Object.keys(w);a.sort(($,f)=>{const g=w[$],i=w[f];return g.active?1:i.active?-1:+g.visible-+i.visible});for(const $ of a){const f=this.getWebviewPanel($);if(!f)continue;const g=w[$];f._updateViewState({active:g.active,visible:g.visible,viewColumn:L.ViewColumn.to(g.position)})}}async $onDidDisposeWebviewPanel(w){this.getWebviewPanel(w)?.dispose(),this.g.delete(w),this.j.deleteWebview(w)}registerWebviewPanelSerializer(w,a,$){if(this.h.has(a))throw new Error(`Serializer for '${a}' already registered`);return this.h.set(a,{serializer:$,extension:w}),this.f.$registerSerializer(a,{serializeBuffersForPostMessage:(0,R.$Soc)(w)}),new c.$uN(()=>{this.h.delete(a),this.f.$unregisterSerializer(a)})}async $deserializeWebviewPanel(w,a,$,f){const g=this.h.get(a);if(!g)throw new Error(`No serializer found for '${a}'`);const{serializer:i,extension:o}=g,t=this.j.createNewWebview(w,$.webviewOptions,o),s=this.createNewWebviewPanel(w,a,$.title,f,$.panelOptions,t,$.active);await i.deserializeWebviewPanel(s,$.state)}createNewWebviewPanel(w,a,$,f,g,i,o){const t=new I(w,this.f,i,{viewType:a,title:$,viewColumn:f,panelOptions:g,active:o});return this.g.set(w,t),t}getWebviewPanel(w){return this.g.get(w)}}e.$Woc=D;function u(P){return{enableFindWidget:P.enableFindWidget,retainContextWhenHidden:P.retainContextWhenHidden}}}),define(ke[323],Ie([1,0,4,3,96,15,6,9]),function(me,e,r,h,C,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tqc=void 0,L=Ue(L),R=Ue(R);class b extends h.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(D,u,P,w,a,$){super(),this.#s=!1,this.#l=this.B(new r.$je),this.onDidChangeVisibility=this.#l.event,this.#u=this.B(new r.$je),this.onDidDispose=this.#u.event,this.#i=P,this.#a=w,this.#e=D,this.#t=u,this.#n=a,this.#r=$}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.a(),this.#a}set title(D){this.a(),this.#a!==D&&(this.#a=D,this.#t.$setWebviewViewTitle(this.#e,D))}get description(){return this.a(),this.#o}set description(D){this.a(),this.#o!==D&&(this.#o=D,this.#t.$setWebviewViewDescription(this.#e,D))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(D){D===this.#r||this.#s||(this.#r=D,this.#l.fire())}get badge(){return this.a(),this.#c}set badge(D){this.a(),!(D?.value===this.#c?.value&&D?.tooltip===this.#c?.tooltip)&&(this.#c=T.ViewBadge.from(D),this.#t.$setWebviewViewBadge(this.#e,D))}show(D){this.a(),this.#t.$show(this.#e,!!D)}a(){if(this.#s)throw new Error("Webview is disposed")}}class c{constructor(D,u){this.d=u,this.b=new Map,this.c=new Map,this.a=D.getProxy(L.$sN.MainThreadWebviewViews)}registerWebviewViewProvider(D,u,P,w){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:P,extension:D}),this.a.$registerWebviewViewProvider((0,C.$Uoc)(D),u,{retainContextWhenHidden:w?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$Soc)(D)}),new R.$uN(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(D,u,P,w,a){const $=this.b.get(u);if(!$)throw new Error(`No view provider found for '${u}'`);const{provider:f,extension:g}=$,i=this.d.createNewWebview(D,{},g),o=new b(D,this.a,u,P,i,!0);this.c.set(D,o),await f.resolveWebviewView(o,{state:w},a)}async $onDidChangeWebviewViewVisibility(D,u){this.e(D)._setVisible(u)}async $disposeWebviewView(D){const u=this.e(D);this.c.delete(D),u.dispose(),this.d.deleteWebview(D)}e(D){const u=this.c.get(D);if(!u)throw new Error("No webview found");return u}}e.$tqc=c}),define(ke[324],Ie([1,0,75,14,11,226,27,10]),function(me,e,r,h,C,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$qc=void 0;let b=class{constructor(D,u){D.addFileSystemProvider(h.Schemas.file,new c(u),{isCaseSensitive:R.$l})}};e.$$qc=b,e.$$qc=b=Ye([Ve(0,r.$Ooc),Ve(1,C.$9j)],b);class c{constructor(D){this.b=D,this.a=new T.$pr(this.b)}async stat(D){const u=await this.a.stat(D);return{type:u.type,ctime:u.ctime,mtime:u.mtime,size:u.size,permissions:u.permissions===L.FilePermission.Readonly?1:void 0}}readDirectory(D){return this.a.readdir(D)}createDirectory(D){return this.a.mkdir(D)}readFile(D){return this.a.readFile(D)}writeFile(D,u,P){return this.a.writeFile(D,u,{...P,unlock:!1,atomic:!1})}delete(D,u){return this.a.delete(D,{...u,useTrash:!1,atomic:!1})}rename(D,u,P){return this.a.rename(D,u,P)}copy(D,u,P){return this.a.copy(D,u,P)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(D,u){throw new Error("Method not implemented.")}}}),define(ke[325],Ie([1,0,16,66,32,34,3,6,2,19]),function(me,e,r,h,C,T,L,R,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9qc=void 0;let I=class extends L.$Tc{constructor(u,P){super();const w=u.getProxy(R.$sN.MainThreadDownloadService);P.registerCommand(!1,"_workbench.downloadResource",async a=>{const $=b.URI.file((0,r.$ic)((0,h.tmpdir)(),(0,C.$Yg)()));return await w.$download(a,$),$})}};e.$9qc=I,e.$9qc=I=Ye([Ve(0,c.$1P),Ve(1,T.$kQ)],I)}),define(ke[326],Ie([1,0,44,16,2,97,3,14,7,33]),function(me,e,r,h,C,T,L,R,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$irc=void 0,r=Ue(r),h=Ue(h);class I extends T.$Qoc{constructor(){super(...arguments),this.i=null}async g(s){const n=await super.g(s);if(n.scheme!==R.Schemas.file)return n;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${n.fsPath}.`),n;const d=n.fsPath;let l=0;do{let m;l===0?m=d:m=/[/\\]$/.test(d)?`${d.substr(0,d.length-1)}-${l}`:`${d}-${l}`,await D(m);const E=h.$ic(m,"vscode.lock"),S=await a(this.d,E,!1);if(S)return this.i=S,process.on("exit",()=>{S.dispose()}),C.URI.file(m);l++}while(l<10);return n}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$irc=I;async function D(t){try{await r.promises.stat(t);return}catch{}try{await r.promises.mkdir(t,{recursive:!0})}catch{}}const u=1e3,P=10*60*1e3;class w extends L.$Tc{constructor(s,n){super(),this.b=s,this.c=n,this.a=this.B(new b.$Nh),this.a.cancelAndSet(async()=>{const d=await $(s,n);(!d||d.pid!==process.pid)&&(s.info(`Lock '${n}': The lock was lost unexpectedly.`),this.a.cancel());try{await r.promises.utimes(n,new Date,new Date)}catch(l){s.error(l),s.info(`Lock '${n}': Could not update mtime.`)}},u)}dispose(){super.dispose();try{r.unlinkSync(this.c)}catch{}}async setWillRelease(s){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${s} ms.`);try{const n={pid:process.pid,willReleaseAt:Date.now()+s};await c.Promises.writeFile(this.c,JSON.stringify(n),{flag:"w"})}catch(n){this.b.error(n)}}}async function a(t,s,n){try{const l={pid:process.pid,willReleaseAt:0};await c.Promises.writeFile(s,JSON.stringify(l),{flag:"wx"})}catch(l){t.error(l)}const d=await $(t,s);return!d||d.pid!==process.pid?n?(t.info(`Lock '${s}': Could not acquire lock, giving up.`),null):(t.info(`Lock '${s}': Could not acquire lock, checking if the file is stale.`),i(t,s)):(t.info(`Lock '${s}': Lock acquired.`),new w(t,s))}async function $(t,s){let n;try{n=await r.promises.readFile(s)}catch(d){return t.error(d),null}try{return JSON.parse(String(n))}catch(d){return t.error(d),null}}async function f(t,s){let n;try{n=await r.promises.stat(s)}catch(d){return t.error(d),0}return n.mtime.getTime()}function g(t){try{return process.kill(t,0),!0}catch{return!1}}async function i(t,s){const n=await $(t,s);if(!n)return t.info(`Lock '${s}': Could not read pid of lock holder.`),o(t,s);if(n.willReleaseAt){let S=n.willReleaseAt-Date.now();if(S<5e3){for(S>0?t.info(`Lock '${s}': The lockfile is scheduled to be released in ${S} ms.`):t.info(`Lock '${s}': The lockfile is scheduled to have been released.`);S>0;){if(await(0,b.$Dh)(Math.min(100,S)),await f(t,s)===0)return o(t,s);S=n.willReleaseAt-Date.now()}return o(t,s)}}if(!g(n.pid))return t.info(`Lock '${s}': The pid ${n.pid} appears to be gone.`),o(t,s);const d=await f(t,s),l=Date.now()-d;if(l<=P)return t.info(`Lock '${s}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null;t.info(`Lock '${s}': The lock looks stale, waiting for 2s.`),await(0,b.$Dh)(2e3);const m=await f(t,s),E=Date.now()-m;return E<=P?(t.info(`Lock '${s}': The lock does not look stale, elapsed: ${E} ms, giving up.`),null):(t.info(`Lock '${s}': The lock looks stale even after waiting for 2s.`),o(t,s))}async function o(t,s){t.info(`Lock '${s}': Deleting a stale lock.`);try{await r.promises.unlink(s)}catch{}return a(t,s,!0)}}),define(ke[327],Ie([1,0,32,19,47,34]),function(me,e,r,h,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dqc=void 0;let L=class extends C.$apc{constructor(b,c){super(!0,b,c)}createTerminal(b,c,I){return this.createTerminalFromOptions({name:b,shellPath:c,shellArgs:I})}createTerminalFromOptions(b,c){const I=new C.$_oc(this.a,(0,r.$Yg)(),b,b.name);return this.f.push(I),I.create(b,this.R(b,c)),I.value}};e.$Dqc=L,e.$Dqc=L=Ye([Ve(0,T.$kQ),Ve(1,h.$1P)],L)}),define(ke[328],Ie([1,0,4,36,35,5]),function(me,e,r,h,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OM=e.$NM=e.OutputChannelUpdateMode=e.$MM=e.$LM=e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.$FM=e.$EM=e.$DM=e.$CM=e.$BM=e.$AM=void 0,e.$AM="text/x-code-output",e.$BM="output",e.$CM="Log",e.$DM="text/x-code-log-output",e.$EM="log",e.$FM="workbench.panel.output",e.$GM=new C.$Tj("inOutput",!1),e.$HM=new C.$Tj("activeLogOutput",!1),e.$IM=new C.$Tj("activeLogOutput.levelSettable",!1),e.$JM=new C.$Tj("activeLogOutput.level",""),e.$KM=new C.$Tj("activeLogOutput.levelIsDefault",!1),e.$LM=new C.$Tj("outputView.scrollLock",!1),e.$MM=(0,T.$Ci)("outputService");var L;(function(b){b[b.Append=1]="Append",b[b.Replace=2]="Replace",b[b.Clear=3]="Clear"})(L||(e.OutputChannelUpdateMode=L={})),e.$NM={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.a=new Map,this.b=new r.$je,this.onDidRegisterChannel=this.b.event,this.c=new r.$je,this.onDidRemoveChannel=this.c.event}registerChannel(c){this.a.has(c.id)||(this.a.set(c.id,c),this.b.fire(c.id))}getChannels(){const c=[];return this.a.forEach(I=>c.push(I)),c}getChannel(c){return this.a.get(c)}removeChannel(c){this.a.delete(c),this.c.fire(c)}}h.$no.add(e.$NM.OutputChannels,new R),e.$OM=new C.$Tj("activeOutputChannel","")}),define(ke[169],Ie([1,0,6,5,19,23,11,328,75,29,62,211,21,17,27,4,3]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0pc=e.$9pc=void 0;class f extends L.$ck{get disposed(){return this.n}constructor(t,s,n,d,l){super(),this.id=t,this.name=s,this.r=n,this.s=d,this.extension=l,this.m=0,this.n=!1,this.visible=!1,this.setLevel(n.getLevel()),this.B(n.onDidChangeLogLevel(m=>this.setLevel(m)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.m;this.r.flush(),this.s.$update(this.id,R.OutputChannelUpdateMode.Clear,t)}replace(t){const s=this.m;this.info(t),this.s.$update(this.id,R.OutputChannelUpdateMode.Replace,s),this.visible&&this.r.flush()}show(t,s){this.r.flush(),this.s.$reveal(this.id,!!(typeof t=="boolean"?t:s))}hide(){this.s.$close(this.id)}g(t,s){this.m+=u.$Le.fromString(s).byteLength,(0,L.log)(this.r,t,s),this.visible&&(this.r.flush(),this.s.$update(this.id,R.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class g extends f{appendLine(t){this.append(t)}}let i=class{constructor(t,s,n,d,l,m){this.i=s,this.j=n,this.k=d,this.l=l,this.m=m,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=t.getProxy(r.$sN.MainThreadOutputService),this.b=this.k.extUri.joinPath(s.logsLocation,`output_logging_${(0,D.$Zm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.h=t;for(const[s,n]of this.g)n.visible=s===this.h}createOutputChannel(t,s,n){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const d=typeof s=="object"&&s.log,l=(0,P.$cg)(s)?s:void 0;if((0,P.$cg)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let m;const E=this.i.environment.extensionLogLevel?.find(([y])=>T.$nn.equals(n.identifier,y))?.[1];E&&(m=(0,L.$nk)(E));const S=d?this.o(t,m,n):this.n(t,l,n);return S.then(y=>{this.g.set(y.id,y),y.visible=y.id===this.h}),d?this.r(t,m??this.m.getLevel(),S):this.q(t,S)}async n(t,s,n){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const d=await this.c,l=this.k.extUri.joinPath(d,`${this.f++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),m=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),E=await this.a.$register(t,l,s,n.identifier.value);return new f(E,t,m,this.a,n)}async o(t,s,n){const d=await this.p(n),l=t.replace(/[\\/:\*\?"<>\|]/g,""),m=this.k.extUri.joinPath(d,`${l}.log`),E=`${n.identifier.value}.${l}`,S=this.l.createLogger(m,{id:E,name:t,logLevel:s,extensionId:n.identifier.value});return new g(E,t,S,this.a,n)}p(t){let s=this.d.get(t.identifier.value);if(!s){const n=this.k.extUri.joinPath(this.i.logsLocation,t.identifier.value);this.d.set(t.identifier.value,s=(async()=>{try{await this.j.value.createDirectory(n)}catch(d){if((0,w.$ml)(d)!==w.FileSystemProviderErrorCode.FileExists)throw d}return n})())}return s}q(t,s){let n=!1;const d=()=>{if(n)throw new Error("Channel has been closed")};return{get name(){return t},append(l){d(),s.then(m=>m.append(l))},appendLine(l){d(),s.then(m=>m.appendLine(l))},clear(){d(),s.then(l=>l.clear())},replace(l){d(),s.then(m=>m.replace(l))},show(l,m){d(),s.then(E=>E.show(l,m))},hide(){d(),s.then(l=>l.hide())},dispose(){n=!0,s.then(l=>l.dispose())}}}r(t,s,n){const d=new $.$Sc,l=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},m=d.add(new a.$je);function E(S){s=S,m.fire(S)}return n.then(S=>{d.add(S),S.logLevel!==s&&E(S.logLevel),d.add(S.onDidChangeLogLevel(y=>E(y)))}),{...this.q(t,n),get logLevel(){return s},onDidChangeLogLevel:m.event,trace(S,...y){l(),n.then(k=>k.trace(S,...y))},debug(S,...y){l(),n.then(k=>k.debug(S,...y))},info(S,...y){l(),n.then(k=>k.info(S,...y))},warn(S,...y){l(),n.then(k=>k.warn(S,...y))},error(S,...y){l(),n.then(k=>k.error(S,...y))},dispose(){d.dispose()}}}};e.$9pc=i,e.$9pc=i=Ye([Ve(0,C.$1P),Ve(1,c.$eQ),Ve(2,b.$Ooc),Ve(3,I.$roc),Ve(4,L.$0j),Ve(5,L.$9j)],i),e.$0pc=(0,h.$Ci)("IExtHostOutputService")}),define(ke[170],Ie([1,0,5,7]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=void 0,e.$Sm=(0,r.$Ci)("remoteAgentService"),e.$Tm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let T=1/0;for(let R=0;R<this.maxSampleCount;R++){const b=await C.getRoundTripTime();if(b===void 0)return;T=Math.min(T,b/2),await(0,h.$Dh)(this.sampleDelay)}this.average.push(T),this.average.length>this.maxAverageCount&&this.average.shift();let L;return this.initial.length<this.maxInitialCount?this.initial.push(T):L=this.initial.reduce((R,b)=>R+b,0)/this.initial.length,this.lastMeasurement={initial:L,current:T,average:this.average.reduce((R,b)=>R+b,0)/this.average.length,high:typeof L>"u"?!1:T>this.highLatencyMaxThreshold||T>this.highLatencyMinThreshold&&T>L*this.highLatencyMultiple},this.lastMeasurement}}}),define(ke[329],Ie([1,0,8,70,36,46,45,3,4,170,10,24,7,150]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0K=e.$9K=e.$8K=e.$7K=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=void 0,e.$1K=Object.freeze({id:"application",order:100,title:(0,r.localize)(12380,null),type:"object"}),e.$2K=Object.freeze({id:"workbench",order:7,title:(0,r.localize)(12381,null),type:"object"}),e.$3K=Object.freeze({id:"security",scope:h.ConfigurationScope.APPLICATION,title:(0,r.localize)(12382,null),type:"object",order:7}),e.$4K=Object.freeze({id:"problems",title:(0,r.localize)(12383,null),type:"object",order:101}),e.$5K=Object.freeze({id:"window",order:8,title:(0,r.localize)(12384,null),type:"object"}),e.$6K={ConfigurationMigration:"base.contributions.configuration.migration"};class w{constructor(){this.migrations=[],this.a=new b.$je,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(o){this.migrations.push(...o)}}const a=new w;C.$no.add(e.$6K.ConfigurationMigration,a);let $=class extends R.$Tc{static{this.ID="workbench.contrib.configurationMigration"}constructor(o,t){super(),this.a=o,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async s=>{for(const n of s.added)await this.f(n,a.migrations)})),this.c(a.migrations),this.B(a.onDidRegisterConfigurationMigration(s=>this.c(s)))}async c(o){await this.f(void 0,o);for(const t of this.b.getWorkspace().folders)await this.f(t,o)}async f(o,t){await Promise.all([t.map(s=>this.g(s,o?.uri))])}async g(o,t){const s=this.a.inspect(o.key,{resource:t}),n=this.b.getWorkbenchState()===T.WorkbenchState.WORKSPACE?[["user",L.ConfigurationTarget.USER],["userLocal",L.ConfigurationTarget.USER_LOCAL],["userRemote",L.ConfigurationTarget.USER_REMOTE],["workspace",L.ConfigurationTarget.WORKSPACE],["workspaceFolder",L.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",L.ConfigurationTarget.USER],["userLocal",L.ConfigurationTarget.USER_LOCAL],["userRemote",L.ConfigurationTarget.USER_REMOTE],["workspace",L.ConfigurationTarget.WORKSPACE]];for(const[d,l]of n){const m=s[d];if(!m)continue;const E=[];if(m.value!==void 0){const S=await this.h(o,d,m.value,t,void 0);for(const y of S??[])E.push([y,[]])}for(const{identifiers:S,value:y}of m.overrides??[])if(y!==void 0){const k=await this.h(o,d,y,t,S);for(const A of k??[])E.push([A,S])}E.length&&await Promise.allSettled(E.map(async([[S,y],k])=>this.a.updateValue(S,y.value,{resource:t,overrideIdentifiers:k},l)))}}async h(o,t,s,n,d){const l=E=>{const y=this.a.inspect(E,{resource:n})[t];if(y)return d?y.overrides?.find(({identifiers:k})=>(0,D.$eo)(k,d))?.value:y.value},m=await o.migrateFn(s,l);return Array.isArray(m)?m:[[o.key,m]]}};e.$7K=$,e.$7K=$=Ye([Ve(0,L.$9i),Ve(1,T.$Li)],$);let f=class extends R.$Tc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(o){super(),this.b=o,this.a=new u.$Zh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!I.$j&&(await this.b.getEnvironment())?.os!==I.OperatingSystem.Windows)return;C.$no.as(h.$so.Configuration).registerConfiguration({...e.$3K,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,r.localize)(12385,null)},default:[],markdownDescription:(0,r.localize)(12386,null),scope:h.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,r.localize)(12387,null),scope:h.ConfigurationScope.MACHINE}}})}};e.$8K=f,e.$8K=f=Ye([Ve(0,c.$Sm)],f),e.$9K="window.newWindowProfile";let g=class extends R.$Tc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(o,t){super(),this.c=o,this.f=t,this.g(),this.B(this.c.onDidChangeProfiles(s=>this.g())),this.h(),this.j(),this.B(t.onDidChangeConfiguration(s=>{s.source!==L.ConfigurationTarget.DEFAULT&&s.affectsConfiguration(e.$9K)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const o=C.$no.as(h.$so.Configuration),t={...e.$5K,properties:{[e.$9K]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(s=>s.name),null],enumItemLabels:[...this.c.profiles.map(s=>""),(0,r.localize)(12388,null)],description:(0,r.localize)(12389,null),scope:h.ConfigurationScope.APPLICATION}}};this.a?o.updateConfigurations({add:[t],remove:[this.a]}):o.registerConfiguration(t),this.a=t}h(){const o=this.f.getValue(e.$9K);this.b=o?this.c.profiles.find(t=>t.name===o):void 0}j(){const o=this.f.getValue(e.$9K);if(!o)return;const t=this.b?this.c.profiles.find(s=>s.id===this.b.id):void 0;o!==t?.name&&this.f.updateValue(e.$9K,t?.name)}};e.$0K=g,e.$0K=g=Ye([Ve(0,P.$Il),Ve(1,L.$9i)],g)}),define(ke[330],Ie([1,0,38,14,16,22,8,329,70,5,36]),function(me,e,r,h,C,T,L,R,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$_K=e.$$K=void 0,e.$aL=a,e.$bL=$,r=Ue(r),e.$$K=(0,c.$Ci)("editorResolverService"),e.$_K="workbench.editorAssociations";const D=I.$no.as(b.$so.Configuration),u={...R.$2K,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,L.localize)(1976,null),additionalProperties:{type:"string"}}}};D.registerConfiguration(u);var P;(function(f){f.builtin="builtin",f.option="option",f.exclusive="exclusive",f.default="default"})(P||(e.RegisteredEditorPriority=P={}));var w;(function(f){f[f.ABORT=1]="ABORT",f[f.NONE=2]="NONE"})(w||(e.ResolvedStatus=w={}));function a(f){switch(f){case P.exclusive:return 5;case P.default:return 4;case P.builtin:return 3;case P.option:default:return 1}}function $(f,g){if(new Set([h.Schemas.extension,h.Schemas.webviewPanel,h.Schemas.vscodeWorkspaceTrust,h.Schemas.vscodeSettings]).has(g.scheme))return!1;const t=typeof f=="string"&&f.indexOf(C.$fc.sep)>=0?`${g.scheme}:${g.path}`:(0,T.$ah)(g);return r.$vk(typeof f=="string"?f.toLowerCase():f,t.toLowerCase())}}),define(ke[331],Ie([1,0,31,14,16,10,22,2,5,246,46,158,170]),function(me,e,r,h,C,T,L,R,b,c,I,D,u){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=e.$7M=void 0,e.$7M=(0,b.$Ci)("pathService");let w=P=class{constructor($,f,g,i){this.d=$,this.e=f,this.f=g,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||T.OS)(),this.b=(async()=>{const o=await this.e.getEnvironment();return this.c=o?.userHome??$})()}hasValidBasename($,f,g){return typeof f=="string"||typeof f>"u"?this.a.then(i=>this.h($,i,f)):this.h($,f,g)}h($,f,g){return $.scheme===h.Schemas.file||$.scheme===h.Schemas.vscodeRemote?(0,r.$zg)(g??(0,L.$ah)($),f===T.OperatingSystem.Windows):!0}get defaultUriScheme(){return P.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme($,f){if($.remoteAuthority)return h.Schemas.vscodeRemote;const g=(0,c.$4M)(f.getWorkspace());if(g)return g;const i=f.getWorkspace().folders[0];if(i)return i.uri.scheme;const o=f.getWorkspace().configuration;return o?o.scheme:h.Schemas.file}userHome($){return $?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then($=>$===T.OperatingSystem.Windows?C.$ec:C.$fc)}async fileURI($){let f="";if(await this.a===T.OperatingSystem.Windows&&($=$.replace(/\\/g,"/")),$[0]==="/"&&$[1]==="/"){const i=$.indexOf("/",2);i===-1?(f=$.substring(2),$="/"):(f=$.substring(2,i),$=$.substring(i)||"/")}return R.URI.from({scheme:h.Schemas.file,authority:f,path:$,query:"",fragment:""})}};e.$8M=w,e.$8M=w=P=Ye([Ve(1,u.$Sm),Ve(2,D.$PM),Ve(3,I.$Li)],w)}),define(ke[332],Ie([1,0,8,59,4,60,3,2,45,215,11,71,151,92,46,158,25,20,17,24,35]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a,$,f,g,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1M=e.$ZM=e.OnPortForward=e.$UM=e.$TM=e.TunnelSource=e.TunnelCloseReason=e.$RM=e.$QM=void 0,e.$SM=l,e.$VM=S,e.$WM=y,e.$XM=k,e.$YM=p,r=Ue(r);const t=10*1e3,s="remote.tunnels.toRestore",n="remote.tunnels.toRestoreExpiration",d=1e3*60*60*24*14;e.$QM="onTunnel",e.$RM=new o.$Tj("forwardedPortsViewEnabled",!1,r.localize(1590,null));function l(N){const O=N.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(O)return{host:O[1]?.substring(0,O[1].length-1)||"localhost",port:Number(O[2])}}var m;(function(N){N.Other="Other",N.User="User",N.AutoForwardEnd="AutoForwardEnd"})(m||(e.TunnelCloseReason=m={}));var E;(function(N){N[N.User=0]="User",N[N.Auto=1]="Auto",N[N.Extension=2]="Extension"})(E||(e.TunnelSource=E={})),e.$TM={source:E.User,description:r.localize(1591,null)},e.$UM={source:E.Auto,description:r.localize(1592,null)};function S(N,O,j){const z=N.get(k(O,j));if(z)return z;if((0,P.$Fw)(O))for(const M of P.$Ew){const V=k(M,j);if(N.has(V))return N.get(V)}else if((0,P.$Hw)(O))for(const M of P.$Gw){const V=k(M,j);if(N.has(V))return N.get(V)}}function y(N,O,j){const z=S(N,O,j);if(z)return z;const M=(0,P.$Hw)(O)?"localhost":(0,P.$Fw)(O)?"0.0.0.0":void 0;if(M)return S(N,M,j)}function k(N,O){return N+":"+O}var A;(function(N){N.Notify="notify",N.OpenBrowser="openBrowser",N.OpenBrowserOnce="openBrowserOnce",N.OpenPreview="openPreview",N.Silent="silent",N.Ignore="ignore"})(A||(e.OnPortForward=A={}));function p(N){return N&&"host"in N&&typeof N.host=="string"&&"port"in N&&typeof N.port=="number"&&(!("detail"in N)||typeof N.detail=="string")&&(!("pid"in N)||typeof N.pid=="string")}class v extends L.$Tc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(O){super(),this.r=O,this.j=[],this.n=new C.$je,this.onDidChangeAttributes=this.n.event,this.B(O.onDidChangeConfiguration(j=>{(j.affectsConfiguration(v.c)||j.affectsConfiguration(v.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(O,j,z){let M=this.w(O,j,z,this.j,0);const V={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;M>=0;){const K=this.j[M];K.key===O?(V.onAutoForward=K.onAutoForward??V.onAutoForward,V.elevateIfNeeded=K.elevateIfNeeded!==void 0?K.elevateIfNeeded:V.elevateIfNeeded,V.label=K.label??V.label,V.requireLocalPort=K.requireLocalPort,V.protocol=K.protocol):(V.onAutoForward=V.onAutoForward??K.onAutoForward,V.elevateIfNeeded=V.elevateIfNeeded!==void 0?V.elevateIfNeeded:K.elevateIfNeeded,V.label=V.label??K.label,V.requireLocalPort=V.requireLocalPort!==void 0?V.requireLocalPort:void 0,V.protocol=V.protocol??K.protocol),M=this.w(O,j,z,this.j,M+1)}return V.onAutoForward!==void 0||V.elevateIfNeeded!==void 0||V.label!==void 0||V.requireLocalPort!==void 0||V.protocol!==void 0?V:this.C()}t(O){return O.start!==void 0&&O.end!==void 0}u(O){return O.host!==void 0&&O.port!==void 0&&(0,g.$cg)(O.host)&&(0,g.$gg)(O.port)}w(O,j,z,M,V){if(V>=M.length)return-1;const K=!(0,P.$Fw)(j)&&!(0,P.$Hw)(j),B=M.slice(V).findIndex(G=>(0,g.$gg)(G.key)?K?!1:G.key===O:this.t(G.key)?K?!1:O>=G.key.start&&O<=G.key.end:this.u(G.key)?O===G.key.port&&j===G.key.host:z?G.key.test(z):!1);return B>=0?B+V:-1}y(){const O=this.r.getValue(v.c);if(!O||!(0,g.$eg)(O))return[];const j=[];for(const M in O){if(M===void 0)continue;const V=O[M];let K;if(Number(M))K=Number(M);else if((0,g.$cg)(M))if(v.g.test(M)){const ne=M.match(v.g);K={start:Number(ne[1]),end:Number(ne[2])}}else if(v.h.test(M)){const ne=M.match(v.h);K={host:ne[1],port:Number(ne[2])}}else{let ne;try{ne=RegExp(M)}catch{}ne&&(K=ne)}K&&j.push({key:K,elevateIfNeeded:V.elevateIfNeeded,onAutoForward:V.onAutoForward,label:V.label,requireLocalPort:V.requireLocalPort,protocol:V.protocol})}const z=this.r.getValue(v.f);return z&&(this.m={elevateIfNeeded:z.elevateIfNeeded,label:z.label,onAutoForward:z.onAutoForward,requireLocalPort:z.requireLocalPort,protocol:z.protocol}),this.z(j)}z(O){function j(z,M){return(0,g.$gg)(z.key)?z.key:M.t(z.key)?z.key.start:M.u(z.key)?z.key.port:Number.MAX_VALUE}return O.sort((z,M)=>j(z,this)-j(M,this))}C(){return this.m}static providedActionToAction(O){switch(O){case P.ProvidedOnAutoForward.Notify:return A.Notify;case P.ProvidedOnAutoForward.OpenBrowser:return A.OpenBrowser;case P.ProvidedOnAutoForward.OpenBrowserOnce:return A.OpenBrowserOnce;case P.ProvidedOnAutoForward.OpenPreview:return A.OpenPreview;case P.ProvidedOnAutoForward.Silent:return A.Silent;case P.ProvidedOnAutoForward.Ignore:return A.Ignore;default:return}}async addAttributes(O,j,z){const V=this.r.inspect(v.c).userRemoteValue;let K;!V||!(0,g.$eg)(V)?K={}:K=(0,i.$ao)(V),K[`${O}`]||(K[`${O}`]={});for(const ne in j)K[`${O}`][ne]=j[ne];return this.r.updateValue(v.c,K,z)}}e.$ZM=v;let F=class extends L.$Tc{constructor(O,j,z,M,V,K,ne,B,G,Y){super(),this.H=O,this.I=j,this.J=z,this.L=M,this.M=V,this.N=K,this.O=ne,this.P=B,this.Q=G,this.R=Y,this.c=new Map,this.g=new C.$je,this.onForwardPort=this.g.event,this.h=new C.$je,this.onClosePort=this.h.event,this.j=new C.$je,this.onPortName=this.j.event,this.n=new C.$je,this.onCandidatesChanged=this.n.event,this.t=new C.$je,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new C.$je,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new v(z),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async ee=>{const ue=await this.getAttributes(ee.map(re=>({port:re.tunnelRemotePort,host:re.tunnelRemoteHost})));for(const re of ee)if(re.localAddress){const ye=k(re.tunnelRemoteHost,re.tunnelRemotePort),$e=y(this.m??new Map,re.tunnelRemoteHost,re.tunnelRemotePort);this.forwarded.set(ye,{remotePort:re.tunnelRemotePort,remoteHost:re.tunnelRemoteHost,localAddress:re.localAddress,protocol:ue?.get(re.tunnelRemotePort)?.protocol??P.TunnelProtocol.Http,localUri:await this.X(re.localAddress,ue?.get(re.tunnelRemotePort)),localPort:re.tunnelLocalPort,runningProcess:$e?.detail,hasRunningProcess:!!$e,pid:$e?.pid,privacy:re.privacy,source:e.$TM}),this.f.set(ye,re)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async ee=>{const ue=k(ee.tunnelRemoteHost,ee.tunnelRemotePort);if(!y(this.forwarded,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&!y(this.detected,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&!y(this.c,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&ee.localAddress){const re=y(this.m??new Map,ee.tunnelRemoteHost,ee.tunnelRemotePort),ye=(await this.getAttributes([{port:ee.tunnelRemotePort,host:ee.tunnelRemoteHost}]))?.get(ee.tunnelRemotePort);this.forwarded.set(ue,{remoteHost:ee.tunnelRemoteHost,remotePort:ee.tunnelRemotePort,localAddress:ee.localAddress,protocol:ye?.protocol??P.TunnelProtocol.Http,localUri:await this.X(ee.localAddress,ye),localPort:ee.tunnelLocalPort,closeable:!0,runningProcess:re?.detail,hasRunningProcess:!!re,pid:re?.pid,privacy:ee.privacy,source:e.$TM})}await this.cb(),this.f.set(ue,ee),this.g.fire(this.forwarded.get(ue))})),this.B(this.H.onTunnelClosed(ee=>this.W(ee,m.Other))),this.U()}S(){return this.Q.extensions.find(O=>O.activationEvents?.includes(e.$QM))?(this.R.createKey(e.$RM.key,!0),!0):!1}U(){if(this.S())return;const O=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&O.dispose()}))}async W(O,j){const z=k(O.host,O.port);this.forwarded.has(z)&&(this.forwarded.delete(z),await this.cb(),this.h.fire(O))}X(O,j){if(O.startsWith("http"))return R.URI.parse(O);const z=j?.protocol??"http";return R.URI.parse(`${z}://${O}`)}async Y(O){const j=this.N.getWorkspace(),z=j.configuration?(0,T.$qj)(j.configuration.path):j.folders.length>0?(0,T.$qj)(j.folders[0].uri.path):void 0;if(z===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${O}.${this.L.remoteAuthority}.${z}`}async Z(){return this.Y(s)}async $(){return this.Y(n)}async ab(){const O=this.I.get(s,u.StorageScope.WORKSPACE);if(O)return this.I.remove(s,u.StorageScope.WORKSPACE),await this.cb(),O;const j=await this.Z();if(j)return this.I.get(j,u.StorageScope.PROFILE)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const O=await this.s;if(O&&O!==this.y){const j=JSON.parse(O)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${j.map(z=>z.remotePort).join(", ")}`);for(const z of j){const M=y(this.detected,z.remoteHost,z.remotePort);z.source.source!==E.Extension&&!M||z.source.source===E.Extension&&M?await this.fb({remote:{host:z.remoteHost,port:z.remotePort},local:z.localPort,name:z.name,elevateIfNeeded:!0,source:z.source}):z.source.source===E.Extension&&!M&&this.D.set(k(z.remoteHost,z.remotePort),z)}}}if(this.z=!0,this.C.fire(),!this.w){const O=await this.Z();this.w=this.B(new L.$Sc),this.w.add(this.I.onDidChangeValue(u.StorageScope.PROFILE,void 0,this.w)(async j=>{j.key===O&&(this.s=Promise.resolve(this.I.get(O,u.StorageScope.PROFILE)),await this.restoreForwarded())}))}}bb(){const O=this.I.keys(u.StorageScope.PROFILE,u.StorageTarget.USER).filter(j=>j.startsWith(n));for(const j of O){const z=this.I.getNumber(j,u.StorageScope.PROFILE);if(z&&z<Date.now()){this.s=Promise.resolve(void 0);const M=j.replace(n,s);this.I.remove(j,u.StorageScope.PROFILE),this.I.remove(M,u.StorageScope.PROFILE)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const O=Array.from(this.forwarded.values()),j=O.map(K=>({remoteHost:K.remoteHost,remotePort:K.remotePort,localPort:K.localPort,name:K.name,localAddress:K.localAddress,localUri:K.localUri,protocol:K.protocol,source:K.source}));let z;O.length>0&&(z=JSON.stringify(j));const M=await this.Z(),V=await this.$();!z&&M&&V?(this.I.remove(M,u.StorageScope.PROFILE),this.I.remove(V,u.StorageScope.PROFILE)):z!==this.y&&M&&V&&(this.I.store(M,z,u.StorageScope.PROFILE,u.StorageTarget.USER),this.I.store(V,Date.now()+d,u.StorageScope.PROFILE,u.StorageTarget.USER)),this.y=z}}async eb(O,j,z){if(!O.tunnelLocalPort||!z?.requireLocalPort||O.tunnelLocalPort===j)return;const M=new Date;if(this.db.getTime()+t>M.getTime())return;this.db=M;const V=r.localize(1593,null,j,O.tunnelRemotePort,O.tunnelLocalPort);return this.P.info(V)}async forward(O,j){return!this.z&&this.L.remoteAuthority&&await C.Event.toPromise(this.C.event),this.fb(O,j)}async fb(O,j){await this.Q.activateByEvent(e.$QM);const z=y(this.forwarded,O.remote.host,O.remote.port);j=j??(j!==null?(await this.getAttributes([O.remote]))?.get(O.remote.port):void 0);const M=O.local!==void 0?O.local:O.remote.port;let V;if(z)return this.hb(z,O,j);{const K=this.L.remoteAuthority,ne=K?{getAddress:async()=>(await this.M.resolveAuthority(K)).authority}:void 0,B=k(O.remote.host,O.remote.port);this.c.set(B,!0),O=this.gb(B,O);const G=await this.H.openTunnel(ne,O.remote.host,O.remote.port,void 0,M,O.elevateIfNeeded?O.elevateIfNeeded:j?.elevateIfNeeded,O.privacy,j?.protocol);if(typeof G=="string")V=G;else if(G&&G.localAddress){const Y=y(this.m??new Map,O.remote.host,O.remote.port),ee=G.protocol?G.protocol===P.TunnelProtocol.Https?P.TunnelProtocol.Https:P.TunnelProtocol.Http:j?.protocol??P.TunnelProtocol.Http,ue={remoteHost:G.tunnelRemoteHost,remotePort:G.tunnelRemotePort,localPort:G.tunnelLocalPort,name:j?.label??O.name,closeable:!0,localAddress:G.localAddress,protocol:ee,localUri:await this.X(G.localAddress,j),runningProcess:Y?.detail,hasRunningProcess:!!Y,pid:Y?.pid,source:O.source??e.$TM,privacy:G.privacy};return this.forwarded.set(B,ue),this.f.set(B,G),this.c.delete(B),await this.cb(),await this.eb(G,M,j),this.g.fire(ue),G}this.c.delete(B)}return V}gb(O,j){const z=this.D.has(O)?this.D:this.F.has(O)?this.F:void 0;if(z){const M=z.get(O);z.delete(O),M&&(j.name=M.name??j.name,j.local=("local"in M?M.local:"localPort"in M?M.localPort:void 0)??j.local,j.privacy=j.privacy)}return j}async hb(O,j,z){const M=z?.label??j.name;let V;(function(ne){ne[ne.None=0]="None",ne[ne.Fire=1]="Fire",ne[ne.Reopen=2]="Reopen"})(V||(V={}));let K=V.None;switch(M!==O.name&&(O.name=M,K=V.Fire),(z?.protocol||O.protocol!==P.TunnelProtocol.Http)&&z?.protocol!==O.protocol&&(j.source=O.source,K=V.Reopen),j.privacy&&O.privacy!==j.privacy&&(K=V.Reopen),K){case V.Fire:{this.g.fire();break}case V.Reopen:await this.close(O.remoteHost,O.remotePort,m.User),await this.fb(j,z)}return y(this.f,j.remote.host,j.remote.port)}async name(O,j,z){const M=y(this.forwarded,O,j),V=k(O,j);if(M){M.name=z,await this.cb(),this.j.fire({host:O,port:j});return}else this.detected.has(V)&&(this.detected.get(V).name=z,this.j.fire({host:O,port:j}))}async close(O,j,z){const M=k(O,j),V=this.forwarded.get(M);return z===m.AutoForwardEnd&&V&&V.source.source===E.Auto&&this.F.set(M,{local:V.localPort,name:V.name,privacy:V.privacy}),await this.H.closeTunnel(O,j),this.W({host:O,port:j},z)}address(O,j){const z=k(O,j);return(this.forwarded.get(z)||this.detected.get(z))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(O){if(O)for(const j of O){const z=y(this.m??new Map,j.remoteAddress.host,j.remoteAddress.port),M=typeof j.localAddress=="string"?j.localAddress:k(j.localAddress.host,j.localAddress.port);this.detected.set(k(j.remoteAddress.host,j.remoteAddress.port),{remoteHost:j.remoteAddress.host,remotePort:j.remoteAddress.port,localAddress:M,protocol:P.TunnelProtocol.Http,localUri:this.X(M),closeable:!1,runningProcess:z?.detail,hasRunningProcess:!!z,pid:z?.pid,privacy:P.TunnelPrivacyId.ConstantPrivate,source:{source:E.Extension,description:r.localize(1594,null)}}),this.H.setEnvironmentTunnel(j.remoteAddress.host,j.remoteAddress.port,M,P.TunnelPrivacyId.ConstantPrivate,P.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(O){this.r=O}async setCandidates(O){let j=O;this.r&&(j=await this.r(O));const z=this.ib(j);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(z.values()).map(M=>M.port).join(", ")}`),this.n.fire(z)}ib(O){const j=this.m??new Map,z=new Map;return this.m=z,O.forEach(M=>{const V=k(M.host,M.port);z.set(V,{host:M.host,port:M.port,detail:M.detail,pid:M.pid}),j.has(V)&&j.delete(V);const K=y(this.forwarded,M.host,M.port);K&&(K.runningProcess=M.detail,K.hasRunningProcess=!0,K.pid=M.pid)}),j.forEach((M,V)=>{const K=l(V);if(!K)return;const ne=y(this.forwarded,K.host,K.port);ne&&(ne.runningProcess=void 0,ne.hasRunningProcess=!1,ne.pid=void 0);const B=y(this.detected,K.host,K.port);B&&(B.runningProcess=void 0,B.hasRunningProcess=!1,B.pid=void 0)}),j}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const O=Array.from(this.forwarded.values()),j=await this.getAttributes(O.map(z=>({port:z.remotePort,host:z.remoteHost})),!1);if(j)for(const z of O){const M=j.get(z.remotePort);(M?.protocol||z.protocol!==P.TunnelProtocol.Http)&&M?.protocol!==z.protocol&&await this.fb({remote:{host:z.remoteHost,port:z.remotePort},local:z.localPort,name:z.name,source:z.source},M),M&&M.label&&M.label!==z.name&&await this.name(z.remoteHost,z.remotePort,M.label)}}async getAttributes(O,j=!0){const z=new Map,M=new Map;O.forEach(G=>{const Y=y(this.m??new Map,P.$Ew[0],G.port)??G;if(Y){z.set(G.port,Y);const ee=p(Y)?Y.pid:void 0;M.has(ee)||M.set(ee,[]),M.get(ee)?.push(G.port)}});const V=new Map;if(O.forEach(G=>{const Y=this.configPortsAttributes.getAttributes(G.port,G.host,z.get(G.port)?.detail);Y&&V.set(G.port,Y)}),this.G.length===0||!j)return V.size>0?V:void 0;const K=await Promise.all(this.G.flatMap(G=>Array.from(M.entries()).map(Y=>{const ee=Y[1],ue=z.get(ee[0]);return G.providePortAttributes(ee,ue?.pid,ue?.detail,f.CancellationToken.None)}))),ne=new Map;if(K.forEach(G=>G.forEach(Y=>{Y&&ne.set(Y.port,Y)})),!V&&!ne)return;const B=new Map;return O.forEach(G=>{const Y=V.get(G.port),ee=ne.get(G.port);B.set(G.port,{elevateIfNeeded:Y?.elevateIfNeeded,label:Y?.label,onAutoForward:Y?.onAutoForward??v.providedActionToAction(ee?.autoForwardAction),requireLocalPort:Y?.requireLocalPort,protocol:Y?.protocol})}),B}addAttributesProvider(O){this.G.push(O)}};e.$1M=F,Ye([(0,h.$8h)(1e3)],F.prototype,"cb",null),e.$1M=F=Ye([Ve(0,P.$zw),Ve(1,u.$eq),Ve(2,b.$9i),Ve(3,a.$PM),Ve(4,D.$Nl),Ve(5,w.$Li),Ve(6,I.$9j),Ve(7,c.$5w),Ve(8,$.$1G),Ve(9,o.$Uj)],F)}),define(ke[99],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$IL=e.$HL=void 0;class r{constructor(L,R){this.line=L,this.character=R}isBefore(L){return!1}isBeforeOrEqual(L){return!1}isAfter(L){return!1}isAfterOrEqual(L){return!1}isEqual(L){return!1}compareTo(L){return 0}translate(L,R){return new r(0,0)}with(L){return new r(0,0)}}e.$HL=r;class h{constructor(L,R,b,c){this.isEmpty=!1,this.isSingleLine=!1,this.start=new r(L,R),this.end=new r(b,c)}contains(L){return!1}isEqual(L){return!1}intersection(L){}union(L){return new h(0,0,0,0)}with(L){return new h(0,0,0,0)}}e.$IL=h;var C;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(ke[37],Ie([1,0,18,38,24,31,12,5,16,13,99,7]),function(me,e,r,h,C,T,L,R,b,c,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9L=e.$7L=e.$ZL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$WL=e.$VL=e.$UL=e.$TL=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.TextSearchCompleteMessageType=void 0,e.$QL=f,e.$RL=g,e.$SL=i,e.$XL=S,e.$YL=y,e.$1L=p,e.$2L=v,e.$3L=F,e.$4L=N,e.$5L=O,e.$6L=j,e.$8L=M,e.$0L=ne,e.$$L=B,h=Ue(h),C=Ue(C),T=Ue(T),b=Ue(b),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return I.TextSearchCompleteMessageType}}),e.$JL="workbench.view.search",e.$KL="workbench.panel.search",e.$LL="workbench.view.search",e.$ML="search-result",e.$NL="search.exclude",e.$OL=2e4;const u="\u27EA ",P=" characters skipped \u27EB",w=(u.length+P.length+5)*2;e.$PL=(0,R.$Ci)("searchService");var a;(function(Y){Y[Y.file=0]="file",Y[Y.text=1]="text",Y[Y.aiText=2]="aiText"})(a||(e.SearchProviderType=a={}));var $;(function(Y){Y[Y.File=1]="File",Y[Y.Text=2]="Text",Y[Y.aiText=3]="aiText"})($||(e.QueryType=$={}));function f(Y){return!!Y.preview}function g(Y){return!!Y.resource}function i(Y){return!!Y.message}var o;(function(Y){Y[Y.Normal=0]="Normal",Y[Y.NewSearchStarted=1]="NewSearchStarted"})(o||(e.SearchCompletionExitCode=o={}));class t{constructor(ee){this.resource=ee,this.results=[]}}e.$TL=t;class s{constructor(ee,ue,re,ye){this.ranges=ue,this.webviewIndex=ye;const $e=Array.isArray(ue)?ue:[ue];if(re&&re.matchLines===1&&n($e)){ee=(0,L.$8f)(ee,re.matchLines);let J="",W=0,se=0;const ae=Math.floor(re.charsPerLine/5),te=[];for(const ce of $e){const le=Math.max(ce.startColumn-ae,0),Z=ce.startColumn+re.charsPerLine;if(le>se+ae+w){const oe=u+(le-se)+P;J+=oe+ee.slice(le,Z),W+=le-(se+oe.length)}else J+=ee.slice(se,Z);te.push(new l(0,ce.startColumn-W,ce.endColumn-W)),se=Z}this.preview={text:J,matches:Array.isArray(this.ranges)?te:te[0]}}else{const J=Array.isArray(ue)?ue[0].startLineNumber:ue.startLineNumber;this.preview={text:ee,matches:(0,r.$Zb)(ue,W=>new d(W.startLineNumber-J,W.startColumn,W.endLineNumber-J,W.endColumn))}}}}e.$UL=s;function n(Y){const ee=Y[0].startLineNumber;for(const ue of Y)if(ue.startLineNumber!==ee||ue.endLineNumber!==ee)return!1;return!0}class d{constructor(ee,ue,re,ye){this.startLineNumber=ee,this.startColumn=ue,this.endLineNumber=re,this.endColumn=ye}}e.$VL=d;class l extends d{constructor(ee,ue,re){super(ee,ue,ee,re)}}e.$WL=l;var m;(function(Y){Y.List="list",Y.Tree="tree"})(m||(e.ViewMode=m={}));var E;(function(Y){Y.Default="default",Y.FileNames="fileNames",Y.Type="type",Y.Modified="modified",Y.CountDescending="countDescending",Y.CountAscending="countAscending"})(E||(e.SearchSortOrder=E={}));function S(Y,ee=!0){const ue=Y&&Y.files&&Y.files.exclude,re=ee&&Y&&Y.search&&Y.search.exclude;if(!ue&&!re)return;if(!ue||!re)return ue||re;let ye=Object.create(null);return ye=C.$do(ye,C.$ao(ue)),ye=C.$do(ye,C.$ao(re),!0),ye}function y(Y,ee){return Y.excludePattern&&h.$vk(Y.excludePattern,ee)?!1:Y.includePattern||Y.usingSearchPaths?Y.includePattern&&h.$vk(Y.includePattern,ee)?!0:Y.usingSearchPaths?!!Y.folderQueries&&Y.folderQueries.some(ue=>{const re=ue.folder.fsPath;if(T.$Bg(ee,re)){const ye=b.$kc(re,ee);return!ue.includePattern||!!h.$vk(ue.includePattern,ye)}else return!1}):!1:!0}var k;(function(Y){Y[Y.unknownEncoding=1]="unknownEncoding",Y[Y.regexParseError=2]="regexParseError",Y[Y.globParseError=3]="globParseError",Y[Y.invalidLiteral=4]="invalidLiteral",Y[Y.rgProcessError=5]="rgProcessError",Y[Y.other=6]="other",Y[Y.canceled=7]="canceled"})(k||(e.SearchErrorCode=k={}));class A extends Error{constructor(ee,ue){super(ee),this.code=ue}}e.$ZL=A;function p(Y){const ee=Y.message;if((0,c.$3)(Y))return new A(ee,k.canceled);try{const ue=JSON.parse(ee);return new A(ue.message,ue.code)}catch{return new A(ee,k.other)}}function v(Y){const ee={message:Y.message,code:Y.code};return new Error(JSON.stringify(ee))}function F(Y){return Y.type==="error"?!0:Y.type==="success"}function N(Y){return Y.type==="success"}function O(Y){return!!Y.path}function j(Y,ee,ue=!0){const re=Y.searchPath?Y.searchPath:Y.relativePath;return ue?(0,L.$5f)(re,ee):h.$vk(ee,re)}class z{constructor(ee){this.path=ee,this.results=[]}addMatch(ee){this.results.push(ee)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$7L=z;function M(Y,ee){const ue={...Y||{},...ee||{}};return Object.keys(ue).filter(re=>{const ye=ue[re];return typeof ye=="boolean"&&ye})}class V{constructor(ee,ue){this.c=null,this.a={...ee.excludePattern||{},...ue.excludePattern||{}},this.b=h.$wk(this.a);let re=ee.includePattern;ue.includePattern&&(re?re={...re,...ue.includePattern}:re=ue.includePattern),re&&(this.c=h.$wk(re))}matchesExcludesSync(ee,ue,re){return!!(this.b&&this.b(ee,ue,re))}includedInQuerySync(ee,ue,re){return!(this.b&&this.b(ee,ue,re)||this.c&&!this.c(ee,ue,re))}includedInQuery(ee,ue,re){const ye=this.b(ee,ue,re),$e=()=>this.c?!!this.c(ee,ue,re):!0;return(0,D.$oh)(ye)?ye.then(J=>J?!1:$e()):$e()}hasSiblingExcludeClauses(){return K(this.a)}}e.$9L=V;function K(Y){for(const ee in Y)if(typeof Y[ee]!="boolean")return!0;return!1}function ne(Y){if(!Y)return;let ee;return ue=>(ee||(ee=(Y()||Promise.resolve([])).then(re=>re?G(re):{})),ee.then(re=>!!re[ue]))}function B(Y){if(!Y)return;let ee;return ue=>{if(!ee){const re=Y();ee=re?G(re):{}}return!!ee[ue]}}function G(Y){const ee={};for(const ue of Y)ee[ue]=!0;return ee}}),define(ke[48],Ie([1,0,18,7,20,4,3,84,14,133,22,12,2,8,27,5,11,229,46,62,29,19,15,9,72,37,6,51]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a,$,f,g,i,o,t,s,n,d,l,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Joc=e.$Ioc=void 0;function S(O,j,z){return new I.$5g(M=>p(M,z)).isEqual(O,j)}function y(O,j,z){return S(O.uri,j.uri,z)?0:(0,D.$wf)(O.uri.toString(),j.uri.toString())}function k(O,j,z){return O.index!==j.index?O.index<j.index?-1:1:S(O.uri,j.uri,z)?(0,D.$wf)(O.name,j.name):(0,D.$wf)(O.uri.toString(),j.uri.toString())}function A(O,j,z,M){const V=O.slice(0).sort((ne,B)=>z(ne,B,M)),K=j.slice(0).sort((ne,B)=>z(ne,B,M));return(0,r.$Db)(V,K,(ne,B)=>z(ne,B,M))}function p(O,j){const z=j.getCapabilities(O.scheme);return!(z&&z&w.FileSystemProviderCapabilities.PathCaseSensitive)}class v extends g.$Vi{static toExtHostWorkspace(j,z,M,V){if(!j)return{workspace:null,added:[],removed:[]};const{id:K,name:ne,folders:B,configuration:G,transient:Y,isUntitled:ee}=j,ue=[],re=z;z?B.forEach((W,se)=>{const ae=u.URI.revive(W.uri),te=v.o(M||z,ae,V);te?(te.name=W.name,te.index=W.index,ue.push(te)):ue.push({uri:ae,name:W.name,index:se})}):ue.push(...B.map(({uri:W,name:se,index:ae})=>({uri:u.URI.revive(W),name:se,index:ae}))),ue.sort((W,se)=>W.index<se.index?-1:1);const ye=new v(K,ne,ue,!!Y,G?u.URI.revive(G):null,!!ee,W=>p(W,V)),{added:$e,removed:J}=A(re?re.workspaceFolders:[],ye.workspaceFolders,y,V);return{workspace:ye,added:$e,removed:J}}static o(j,z,M){for(let V=0;V<j.folders.length;V++){const K=j.workspaceFolders[V];if(S(K.uri,z,M))return K}}constructor(j,z,M,V,K,ne,B){super(j,M.map(G=>new g.$Wi(G)),V,K,B),this.t=z,this.u=ne,this.q=[],this.s=R.$Ii.forUris(B,()=>!0),M.forEach(G=>{this.q.push(G),this.s.set(G.uri,G)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(j,z){return z&&this.s.get(j)&&(j=(0,I.$ch)(j)),this.s.findSubstr(j)}resolveWorkspaceFolder(j){return this.s.get(j)}}let F=class{constructor(j,z,M,V,K){this.c=new T.$je,this.onDidChangeWorkspace=this.c.event,this.g=new T.$je,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new T.$le,this.C=new Map,this.h=V,this.s=M,this.t=K,this.j=new c.$Jm,this.k=new h.$Bh,this.o=j.getProxy(m.$sN.MainThreadWorkspace),this.q=j.getProxy(m.$sN.MainThreadMessageService);const ne=z.workspace;this.l=ne?new v(ne.id,ne.name,[],!!ne.transient,ne.configuration?u.URI.revive(ne.configuration):null,!!ne.isUntitled,B=>p(B,M)):void 0}$initializeWorkspace(j,z){this.v=z,this.$acceptWorkspaceData(j),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:b.Schemas.untitled,path:(0,I.$ah)((0,I.$ch)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(j,z,M,...V){const K=[];if(Array.isArray(V)&&V.forEach(ee=>{u.URI.isUri(ee.uri)&&!K.some(ue=>S(ue.uri,ee.uri,this.s))&&K.push({uri:ee.uri,name:ee.name||(0,I.$_g)(ee.uri)})}),this.n||[z,M].some(ee=>typeof ee!="number"||ee<0)||M===0&&K.length===0)return!1;const ne=this.x?this.x.workspaceFolders:[];if(z+M>ne.length)return!1;const B=ne.slice(0);B.splice(z,M,...K.map(ee=>({uri:ee.uri,name:ee.name||(0,I.$_g)(ee.uri),index:void 0})));for(let ee=0;ee<B.length;ee++){const ue=B[ee];if(B.some((re,ye)=>ye!==ee&&S(ue.uri,re.uri,this.s)))return!1}B.forEach((ee,ue)=>ee.index=ue);const{added:G,removed:Y}=A(ne,B,k,this.s);if(G.length===0&&Y.length===0)return!1;if(this.o){const ee=j.displayName||j.name;this.o.$updateWorkspaceFolders(ee,z,M,K).then(void 0,ue=>{this.n=void 0;const re={source:{identifier:j.identifier,label:j.displayName||j.name}};this.q.$showMessage(f.Severity.Error,(0,P.localize)(10655,null,ee,ue.toString()),re,[])})}return this.y(B),!0}getWorkspaceFolder(j,z){if(this.x)return this.x.getWorkspaceFolder(j,z)}async getWorkspaceFolder2(j,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(j,z)}async resolveWorkspaceFolder(j){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(j)}getPath(){if(!this.x)return;const{folders:j}=this.x;if(j.length!==0)return j[0].uri.fsPath}getRelativePath(j,z){let M,V="";if(typeof j=="string"?(M=u.URI.file(j),V=j):typeof j<"u"&&(M=j,V=j.fsPath),!M)return V;const K=this.getWorkspaceFolder(M,!0);if(!K)return V;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let ne=(0,I.$fh)(K.uri,M);return z&&K.name&&(ne=`${K.name}/${ne}`),ne}y(j){this.x&&(this.n=v.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:j,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(j){const{workspace:z,added:M,removed:V}=v.toExtHostWorkspace(j,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:M,removed:V}))}findFiles(j,z,M,V,K=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${V.value}, entryPoint: findFiles`);let ne="",B=!0;return z===null?B=!1:z!==void 0&&(typeof z=="string"?ne=z:ne=z.pattern),this.z(j,void 0,{exclude:ne,maxResults:M,useDefaultExcludes:B,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},K)}findFiles2(j,z={},M,V=C.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${M.value}, entryPoint: findFiles2`),this.z(void 0,j,z,V)}async z(j,z,M,V=C.CancellationToken.None){if(V&&V.isCancellationRequested)return Promise.resolve([]);const K=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,ne={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof M.useDefaultSearchExcludes=="boolean"?!M.useDefaultSearchExcludes:!1,maxResults:M.maxResults,excludePattern:K,shouldGlobSearch:typeof M.fuzzy=="boolean"?!M.fuzzy:!0,_reason:"startFileSearch"};let B;if(j){const{includePattern:G,folder:Y}=N(s.GlobPattern.from(j));B=Y,ne.includePattern=G}else{const{includePattern:G,folder:Y}=N(s.GlobPattern.from(z));B=Y,ne.filePattern=G}return this.o.$startFileSearch(B??null,ne,V).then(G=>Array.isArray(G)?G.map(Y=>u.URI.revive(Y)):[])}async findTextInFiles(j,z,M,V,K=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${V.value}, entryPoint: findTextInFiles`);const ne=this.j.getNext(),B=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:G,folder:Y}=N(s.GlobPattern.from(z.include)),ee=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,ue={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:B,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:G,excludePattern:ee},re=!1;if(this.u[ne]=ye=>{if(re)return;const $e=u.URI.revive(ye.resource);ye.results.forEach(J=>{const W=(0,E.$_h)(J);(0,l.$QL)(W)?M({uri:$e,preview:{text:W.preview.text,matches:(0,r.$Zb)(W.preview.matches,se=>new n.$wN(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))},ranges:(0,r.$Zb)(W.ranges,se=>new n.$wN(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))}):M({uri:$e,text:W.text,lineNumber:W.lineNumber})})},K.isCancellationRequested)return{};try{const ye=await this.o.$startTextSearch(j,Y??null,ue,ne,K);return delete this.u[ne],ye||{}}catch(ye){throw delete this.u[ne],ye}}$handleTextSearchResult(j,z){this.u[z]?.(j)}async save(j){const z=await this.o.$save(j,{saveAs:!1});return u.URI.revive(z)}async saveAs(j){const z=await this.o.$save(j,{saveAs:!0});return u.URI.revive(z)}saveAll(j){return this.o.$saveAll(j)}resolveProxy(j){return this.o.$resolveProxy(j)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(j){return this.o.$requestWorkspaceTrust(j)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(j,z){if(this.w.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.w.set(j,z);const M=this.t.transformOutgoingScheme(j),V=this.A++;return this.o.$registerEditSessionIdentityProvider(V,M),(0,L.$Rc)(()=>{this.w.delete(j),this.o.$unregisterEditSessionIdentityProvider(V)})}async $getEditSessionIdentifier(j,z){this.h.info("Getting edit session identifier for workspaceFolder",j);const M=await this.resolveWorkspaceFolder(u.URI.revive(j));if(!M){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const V=this.w.get(M.uri.scheme);if(this.h.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!V),!V)return;const K=await V.provideEditSessionIdentity(M,z);if(this.h.info("Provider returned edit session identifier: ",K),!!K)return K}async $provideEditSessionIdentityMatch(j,z,M,V){this.h.info("Getting edit session identifier for workspaceFolder",j);const K=await this.resolveWorkspaceFolder(u.URI.revive(j));if(!K){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",K);const ne=this.w.get(K.uri.scheme);if(this.h.info(`Provider for scheme ${K.uri.scheme} is defined: `,!!ne),!ne)return;const B=await ne.provideEditSessionIdentityMatch?.(z,M,V);if(this.h.info("Provider returned edit session identifier match result: ",B),!!B)return B}getOnWillCreateEditSessionIdentityEvent(j){return(z,M,V)=>{const K=function(B){z.call(M,B)};return K.extension=j,this.B.event(K,void 0,V)}}async $onWillCreateEditSessionIdentity(j,z,M){const V=await this.resolveWorkspaceFolder(u.URI.revive(j));if(V===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:V},z,async(K,ne)=>{const B=Date.now();await Promise.resolve(K),Date.now()-B>M&&this.h.warn("SLOW edit session create-participant",ne.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(j,z){if(this.C.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.C.set(j,z);const M=this.t.transformOutgoingScheme(j),V=this.A++;return this.o.$registerCanonicalUriProvider(V,M),(0,L.$Rc)(()=>{this.C.delete(j),this.o.$unregisterCanonicalUriProvider(V)})}async provideCanonicalUri(j,z,M){const V=this.C.get(j.scheme);if(!V)return;const K=await V.provideCanonicalUri?.(u.URI.revive(j),z,M);if(K)return K}async $provideCanonicalUri(j,z,M){return this.provideCanonicalUri(u.URI.revive(j),{targetScheme:z},M)}};e.$Ioc=F,e.$Ioc=F=Ye([Ve(0,t.$1P),Ve(1,o.$eQ),Ve(2,i.$roc),Ve(3,$.$9j),Ve(4,d.$Goc)],F),e.$Joc=(0,a.$Ci)("IExtHostWorkspace");function N(O){let j,z;return O&&(typeof O=="string"?j=O:(j=O.pattern,z=u.URI.revive(O.baseUri))),{includePattern:j,folder:z}}}),define(ke[41],Ie([1,0,24,4,48,6,9,45,231,70,17,7,5,19,11,2]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Moc=e.$Loc=e.$Koc=void 0;function $(d,l){if(l){const m=l.split(".");let E=d;for(let S=0;E&&S<m.length;S++)E=E[m[S]];return E}}function f(d){return d instanceof a.URI}function g(d){return d&&d.uri instanceof a.URI&&d.languageId&&typeof d.languageId=="string"}function i(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function o(d){return d&&d.uri instanceof a.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function t(d){if(f(d))return{resource:d};if(g(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(i(d))return{overrideIdentifier:d.languageId};if(o(d))return{resource:d.uri};if(d===null)return{resource:null}}let s=class{constructor(l,m,E){this.a=l.getProxy(T.$sN.MainThreadConfiguration),this.c=m,this.b=E,this.d=new D.$Bh,this.e=null}getConfigProvider(){return this.d.wait().then(l=>this.e)}$initializeConfiguration(l){this.e=new n(this.a,this.c,l,this.b),this.d.open()}$acceptConfigurationChanged(l,m){this.getConfigProvider().then(E=>E.$acceptConfigurationChanged(l,m))}};e.$Koc=s,e.$Koc=s=Ye([Ve(0,P.$1P),Ve(1,C.$Joc),Ve(2,w.$9j)],s);class n{constructor(l,m,E,S){this.a=new h.$je,this.b=l,this.f=S,this.c=m,this.e=b.$No.parse(E,S),this.d=this.k(E.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(l,m){const E={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$No.parse(l,this.f),this.d=this.k(l.configurationScopes),this.a.fire(this.j(m,E))}getConfiguration(l,m,E){const S=t(m)||{},y=this.g(l?$(this.e.getValue(void 0,S,this.c.workspace),l):this.e.getValue(void 0,S,this.c.workspace));l&&this.h(l,S,E?.identifier);function k(p){if(p==null)return null;if(typeof p=="boolean")return p?R.ConfigurationTarget.USER:R.ConfigurationTarget.WORKSPACE;switch(p){case L.ConfigurationTarget.Global:return R.ConfigurationTarget.USER;case L.ConfigurationTarget.Workspace:return R.ConfigurationTarget.WORKSPACE;case L.ConfigurationTarget.WorkspaceFolder:return R.ConfigurationTarget.WORKSPACE_FOLDER}}const A={has(p){return typeof $(y,p)<"u"},get:(p,v)=>{this.h(l?`${l}.${p}`:p,S,E?.identifier);let F=$(y,p);if(typeof F>"u")F=v;else{let N;const O=(j,z)=>{if((0,I.$eg)(j)){let M;const V=()=>{N=N||(0,r.$ao)(y),M=M||$(N,z)};return new Proxy(j,{get:(K,ne)=>{if(typeof ne=="string"&&ne.toLowerCase()==="tojson")return V(),()=>M;if(N)return M=M||$(N,z),M[ne];const B=K[ne];return typeof ne=="string"?O(B,`${z}.${ne}`):B},set:(K,ne,B)=>(V(),M&&(M[ne]=B),!0),deleteProperty:(K,ne)=>(V(),M&&delete M[ne],!0),defineProperty:(K,ne,B)=>(V(),M&&Object.defineProperty(M,ne,B),!0)})}return Array.isArray(j)?(0,r.$ao)(j):j};F=O(F,p)}return F},update:(p,v,F,N)=>{p=l?`${l}.${p}`:p;const O=k(F);return v!==void 0?this.b.$updateConfigurationOption(O,p,v,S,N):this.b.$removeConfigurationOption(O,p,S,N)},inspect:p=>{p=l?`${l}.${p}`:p;const v=this.e.inspect(p,S,this.c.workspace);if(v)return{key:p,defaultValue:(0,r.$ao)(v.policy?.value??v.default?.value),globalValue:(0,r.$ao)(v.user?.value??v.application?.value),workspaceValue:(0,r.$ao)(v.workspace?.value),workspaceFolderValue:(0,r.$ao)(v.workspaceFolder?.value),defaultLanguageValue:(0,r.$ao)(v.default?.override),globalLanguageValue:(0,r.$ao)(v.user?.override??v.application?.override),workspaceLanguageValue:(0,r.$ao)(v.workspace?.override),workspaceFolderLanguageValue:(0,r.$ao)(v.workspaceFolder?.override),languageIds:(0,r.$ao)(v.overrideIdentifiers)}}};return typeof y=="object"&&(0,r.$do)(A,y,!1),Object.freeze(A)}g(l){const m=E=>(0,I.$eg)(E)?new Proxy(E,{get:(S,y)=>m(S[y]),set:(S,y,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(y)}' of object`)},deleteProperty:(S,y)=>{throw new Error(`TypeError: Cannot delete read only property '${String(y)}' of object`)},defineProperty:(S,y)=>{throw new Error(`TypeError: Cannot define property '${String(y)}' for a readonly object`)},setPrototypeOf:S=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):E;return m(l)}h(l,m,E){const S=c.$Co.test(l)?c.ConfigurationScope.RESOURCE:this.d.get(l),y=E?`[${E.value}] `:"";if(c.ConfigurationScope.RESOURCE===S){typeof m?.resource>"u"&&this.f.warn(`${y}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${l}', provide the URI of a resource or 'null' for any resource.`);return}if(c.ConfigurationScope.WINDOW===S){m?.resource&&this.f.warn(`${y}Accessing a window scoped configuration for a resource is not expected. To associate '${l}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(l,m){const E=new b.$Po(l,m,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(S,y)=>E.affectsConfiguration(S,t(y))})}k(l){return l.reduce((m,E)=>(m.set(E[0],E[1]),m),new Map)}}e.$Loc=n,e.$Moc=(0,u.$Ci)("IExtHostConfiguration")}),define(ke[100],Ie([1,0,2,7,4,6,9,48,63,41,20,47,19,29,5,14,10,11,95,272,13]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a,$,f,g,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kqc=e.$jqc=e.$iqc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,L=Ue(L),$=Ue($);var t;(function(N){function O(z){if(z!=null)return z}N.from=O;function j(z){if(z!=null)return z}N.to=j})(t||(t={}));var s;(function(N){function O(z){if(z!=null)return z}N.from=O;function j(z){if(z!=null)return z}N.to=j})(s||(s={}));var n;(function(N){function O(z){if(z!=null)return z}N.from=O;function j(z){if(z!=null)return z}N.to=j})(n||(n={}));var d;(function(N){function O(M){if(M){const V=M;return V&&!!V.process}else return!1}N.is=O;function j(M){if(M==null)return;const V={process:M.process,args:M.args};return M.options&&(V.options=n.from(M.options)),V}N.from=j;function z(M){if(M!=null)return new L.$eO(M.process,M.args,M.options)}N.to=z})(d||(d={}));var l;(function(N){function O(z){if(z!=null)return z}N.from=O;function j(z){if(z!=null)return z}N.to=j})(l||(l={}));var m;(function(N){function O(M){if(M){const V=M;return V&&(!!V.commandLine||!!V.command)}else return!1}N.is=O;function j(M){if(M==null)return;const V={};return M.commandLine!==void 0?V.commandLine=M.commandLine:(V.command=M.command,V.args=M.args),M.options&&(V.options=l.from(M.options)),V}N.from=j;function z(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new L.$fO(M.commandLine,M.options):new L.$fO(M.command,M.args?M.args:[],M.options)}N.to=z})(m||(m={}));var E;(function(N){function O(M){if(M){const V=M;return V&&V.customExecution==="customExecution"}else return!1}N.is=O;function j(M){return{customExecution:"customExecution"}}N.from=j;function z(M,V){return V.get(M)}N.to=z})(E||(e.CustomExecutionDTO=E={}));var S;(function(N){function O(j,z){let M;return j.scope!==void 0&&typeof j.scope!="number"?M=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===L.TaskScope.Workspace&&z&&z.workspaceFile?M=z.workspaceFile:M=i.$GI),{id:j._id,workspaceFolder:M}}N.from=O})(S||(e.TaskHandleDTO=S={}));var y;(function(N){function O(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}N.from=O})(y||(y={}));var k;(function(N){function O(M,V){if(M==null)return[];const K=[];for(const ne of M){const B=j(ne,V);B&&K.push(B)}return K}N.fromMany=O;function j(M,V){if(M==null)return;let K;M.execution instanceof L.$eO?K=d.from(M.execution):M.execution instanceof L.$fO?K=m.from(M.execution):M.execution&&M.execution instanceof L.$gO&&(K=E.from(M.execution));const ne=t.from(M.definition);let B;return M.scope?typeof M.scope=="number"?B=M.scope:B=M.scope.uri:B=L.TaskScope.Workspace,!ne||!B?void 0:{_id:M._id,definition:ne,name:M.name,source:{extensionId:V.identifier.value,label:M.source,scope:B},execution:K,isBackground:M.isBackground,group:y.from(M.group),presentationOptions:s.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}N.from=j;async function z(M,V,K){if(M==null)return;let ne;d.is(M.execution)?ne=d.to(M.execution):m.is(M.execution)?ne=m.to(M.execution):E.is(M.execution)&&(ne=E.to(M._id,K));const B=t.to(M.definition);let G;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?G=M.source.scope:G=await V.resolveWorkspaceFolder(r.URI.revive(M.source.scope)):G=L.TaskScope.Workspace),!B||!G)return;const Y=new L.$hO(B,G,M.name,M.source.label,ne,M.problemMatchers);return M.isBackground!==void 0&&(Y.isBackground=M.isBackground),M.group!==void 0&&(Y.group=L.$dO.from(M.group._id),Y.group&&M.group.isDefault&&(Y.group=new L.$dO(Y.group.id,Y.group.label),M.group.isDefault===!0&&(Y.group.isDefault=M.group.isDefault))),M.presentationOptions&&(Y.presentationOptions=s.to(M.presentationOptions)),M._id&&(Y._id=M._id),M.detail&&(Y.detail=M.detail),Y}N.to=z})(k||(e.TaskDTO=k={}));var A;(function(N){function O(z){return z}N.from=O;function j(z){if(z)return Object.assign(Object.create(null),z)}N.to=j})(A||(A={}));class p{#e;constructor(O,j,z){this._id=j,this.a=z,this.#e=O}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(O){}fireDidEndProcess(O){}}let v=class{constructor(O,j,z,M,V,K,ne,B){this.q=new C.$je,this.r=new C.$je,this.s=new C.$je,this.u=new C.$je,this.a=O.getProxy(T.$sN.MainThreadTask),this.b=z,this.c=M,this.d=V,this.e=K,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ne,this.g=B,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(O,j,z){if(!z)return new L.$uN(()=>{});const M=this.x();return this.j.set(M,{type:j,provider:z,extension:O}),this.a.$registerTaskProvider(M,j),new L.$uN(()=>{this.j.delete(M),this.a.$unregisterTaskProvider(M)})}registerTaskSystem(O,j){this.a.$registerTaskSystem(O,j)}fetchTasks(O){return this.a.$fetchTasks(A.from(O)).then(async j=>{const z=[];for(const M of j){const V=await k.to(M,this.b,this.m);V&&z.push(V)}return z})}get taskExecutions(){const O=[];return this.k.forEach(j=>O.push(j)),O}terminateTask(O){if(!(O instanceof p))throw new Error("No valid task execution provided");return this.a.$terminateTask(O._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(O,j,z){const M=this.m.get(O.id);M&&(this.o.set(O.id,M),this.e.attachPtyToTerminal(j,await M.callback(z))),this.p=O.id,this.q.fire({execution:await this.z(O)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(O){if(!this.l.has(O.id))return;const j=await this.z(O);this.l.delete(O.id),this.k.delete(O.id),this.B(O),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(O){const j=await this.z(O.id);this.s.fire({execution:j,processId:O.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(O){const j=await this.z(O.id);this.u.fire({execution:j,exitCode:O.exitCode})}$provideTasks(O,j){const z=this.j.get(O);if(!z)return Promise.reject(new Error("no handler found"));const M=[],V=(0,h.$uh)(()=>z.provider.provideTasks(I.CancellationToken.None)).then(K=>this.v(j,M,z,K));return new Promise(K=>{V.then(ne=>{Promise.all(M).then(()=>{K(ne)})})})}async $resolveTask(O,j){const z=this.j.get(O);if(!z)return Promise.reject(new Error("no handler found"));if(j.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${z.type}].`);const M=await k.to(j,this.b,this.m);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const V=await z.provider.resolveTask(M,I.CancellationToken.None);if(!V)return;this.A(V,z);const K=k.from(V,z.extension);if(!K)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return E.is(K.execution)&&await this.y(K,V,!0),await this.w(K)}x(){return this.h++}async y(O,j,z){const M=await this.a.$createTaskId(O);!z&&!this.m.has(M)&&(this.n.add(M),this.o.set(M,j.execution)),this.m.set(M,j.execution)}async z(O,j){if(typeof O=="string"){const V=this.l.get(O);if(!V)throw new o.$ab("Unexpected: The specified task is missing an execution");return V}const z=this.l.get(O.id);if(z)return z;let M;return j?M=Promise.resolve(new p(this,O.id,j)):M=k.to(O.task,this.b,this.m).then(V=>{if(!V)throw new o.$ab("Unexpected: Task does not exist.");return new p(this,O.id,V)}),this.l.set(O.id,M),M.then(V=>(this.k.set(O.id,V),V))}A(O,j){O._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}B(O){this.o.get(O.id)&&this.o.delete(O.id),this.n.has(O.id)&&this.p!==O.id&&(this.m.delete(O.id),this.n.delete(O.id));const z=this.n.values();let M=z.next();for(;!M.done;)!this.o.has(M.value)&&this.p!==M.value&&(this.m.delete(M.value),this.n.delete(M.value)),M=z.next()}};e.$iqc=v,e.$iqc=v=Ye([Ve(0,u.$1P),Ve(1,P.$eQ),Ve(2,R.$Joc),Ve(3,b.$_P),Ve(4,c.$Moc),Ve(5,D.$$oc),Ve(6,f.$9j),Ve(7,g.$noc)],v);let F=class extends v{constructor(O,j,z,M,V,K,ne,B){super(O,j,z,M,V,K,ne,B),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:$.$i($.Platform.Web)})}async executeTask(O,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const z=k.from(j,O);if(z===void 0)throw new Error("Task is not valid");if(E.is(z.execution))await this.y(z,j,!1);else throw new o.$$;const M=await this.z(await this.a.$getTaskExecution(z),j);return this.a.$executeTask(z).catch(V=>{throw new Error(V)}),M}v(O,j,z,M){const V=[];if(M)for(const K of M){if(this.A(K,z),!K.definition||!O[K.definition.type]){const B=K.source?K.source:"No task source";this.f.warn(`The task [${B}, ${K.name}] uses an undefined task type. The task will be ignored in the future.`)}const ne=k.from(K,z.extension);ne&&E.is(ne.execution)?(V.push(ne),j.push(this.y(ne,K,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:V,extension:z.extension}}async w(O){if(E.is(O.execution))return O;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(O,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(O,j,z){}};e.$jqc=F,e.$jqc=F=Ye([Ve(0,u.$1P),Ve(1,P.$eQ),Ve(2,R.$Joc),Ve(3,b.$_P),Ve(4,c.$Moc),Ve(5,D.$$oc),Ve(6,f.$9j),Ve(7,g.$noc)],F),e.$kqc=(0,w.$Ci)("IExtHostTask")}),define(ke[333],Ie([1,0,37,30]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fM=void 0,e.$eM=C,e.$gM=T;function C(L){return"cellResults"in L}e.$fM="rawCell#";function T(L,R){let b=-1;const c=[];let I=[];return L.forEach(u=>{u.range.startLineNumber!==b&&I.length>0&&(c.push([...I]),I=[]),I.push(u),b=u.range.endLineNumber}),I.length>0&&c.push([...I]),c.map(u=>{const P=[],w=u[0].range.startLineNumber,a=u[u.length-1].range.endLineNumber;for(let $=w;$<=a;$++)P.push(R.getLineContent($));return new r.$UL(P.join(`
`)+`
`,u.map($=>new h.$Kt($.range.startLineNumber-1,$.range.startColumn-1,$.range.endLineNumber-1,$.range.endColumn-1)))})}}),define(ke[334],Ie([1,0,8,21,4,3,28,40,12,17,2,27,118,6,34,15,9,53,306,165,24,14,37,262,333,330]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a,$,f,g,i,o,t,s,n,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wpc=void 0,D=Ue(D),a=Ue(a),$=Ue($);class m{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(S=>S.apiEditor)}constructor(S,y,k,A,p,v,F){this.q=k,this.r=A,this.s=p,this.t=v,this.u=F,this.f=new Map,this.g=new L.$zc,this.h=new Map,this.j=new C.$je,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$je,this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$je,this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$je,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new u.$loc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=S.getProxy(P.$sN.MainThreadNotebook),this.c=S.getProxy(P.$sN.MainThreadNotebookDocuments),this.d=S.getProxy(P.$sN.MainThreadNotebookEditors),this.i=y.converter,y.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===R.MarshalledId.NotebookCellActionContext){const O=N.notebookEditor?.notebookUri,j=N.cell.handle,M=this.g.get(O)?.getCell(j);if(M)return M.apiCell}if(N&&N.$mid===R.MarshalledId.NotebookActionContext){const O=N.uri,j=this.g.get(O);if(j)return j.apiNotebook}return N}}),m.C(y)}getEditorById(S){const y=this.h.get(S);if(!y)throw new Error(`unknown text editor: ${S}. known editors: ${[...this.h.keys()]} `);return y}getIdByEditor(S){for(const[y,k]of this.h)if(k.apiEditor===S)return y}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(S,y){const k=this.g.get(S);if(!k&&!y)throw new Error(`NO notebook document for '${S}'`);return k}static w(S,y){if(!y)return;const k=y.filenamePattern.map(A=>a.NotebookExclusiveDocumentPattern.from(A)).filter(A=>A!==void 0);if(y.filenamePattern&&!k){console.warn(`Notebook content provider view options file name pattern is invalid ${y.filenamePattern}`);return}return{extension:S.identifier,providerDisplayName:S.displayName||S.name,displayName:y.displayName,filenamePattern:k,priority:y.exclusive?l.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(S,y,k){const A=m.a++,p=typeof k.onDidChangeCellStatusBarItems=="function"?m.a++:void 0;this.f.set(A,k),this.b.$registerNotebookCellStatusBarItemProvider(A,p,y);let v;return p!==void 0&&(v=k.onDidChangeCellStatusBarItems(F=>this.b.$emitCellStatusBarEvent(p))),new $.$uN(()=>{this.f.delete(A),this.b.$unregisterNotebookCellStatusBarItemProvider(A,p),v?.dispose()})}async createNotebookDocument(S){const y=await this.c.$tryCreateNotebook({viewType:S.viewType,content:S.content&&a.NotebookData.from(S.content)});return I.URI.revive(y)}async openNotebookDocument(S){const y=this.g.get(S);if(y)return y.apiNotebook;const k=await this.c.$tryOpenNotebook(S),A=this.g.get(I.URI.revive(k));return(0,c.$ng)(A?.apiNotebook)}async showNotebookDocument(S,y){I.URI.isUri(S)&&(S=await this.openNotebookDocument(S));let k;typeof y=="object"?k={position:a.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selections:y.selections&&y.selections.map(a.NotebookRange.from),pinned:typeof y.preview=="boolean"?!y.preview:void 0}:k={preserveFocus:!1};const A=await this.d.$tryShowNotebookDocument(S.uri,S.notebookType,k),p=A&&this.h.get(A)?.apiEditor;if(p)return p;throw A?new Error(`Could NOT open editor for "${S.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${S.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(S,y,k,A){const p=this.f.get(S),v=I.URI.revive(y),F=this.g.get(v);if(!F||!p)return;const N=F.getCellFromIndex(k);if(!N)return;const O=await p.provideCellStatusBarItems(N.apiCell,A);if(!O)return;const j=new T.$Sc,z=this.p.add([j]),V=(Array.isArray(O)?O:[O]).map(K=>a.NotebookStatusBarItem.from(K,this.i,j));return{cacheId:z,items:V}}$releaseNotebookCellStatusBarItems(S){this.p.delete(S)}registerNotebookSerializer(S,y,k,A,p){if((0,b.$af)(y))throw new Error("viewType cannot be empty or just whitespace");const v=this.x++;return this.y.set(v,{viewType:y,serializer:k,options:A}),this.b.$registerNotebookSerializer(v,{id:S.identifier,location:S.extensionLocation},y,a.NotebookDocumentContentOptions.from(A),m.w(S,p)),(0,T.$Rc)(()=>{this.b.$unregisterNotebookSerializer(v)})}async $dataToNotebook(S,y,k){const A=this.y.get(S);if(!A)throw new Error("NO serializer found");const p=await A.serializer.deserializeNotebook(y.buffer,k);return new f.$Sw(a.NotebookData.from(p))}async $notebookToData(S,y,k){const A=this.y.get(S);if(!A)throw new Error("NO serializer found");const p=await A.serializer.serializeNotebook(a.NotebookData.to(y.value),k);return h.$Le.wrap(p)}async $saveNotebook(S,y,k,A,p){const v=I.URI.revive(y),F=this.y.get(S);if(this.D(`enter saveNotebook(versionId: ${k}, ${v.toString()})`),!F)throw new Error("NO serializer found");const N=this.g.get(v);if(!N)throw new Error("Document NOT found");if(N.versionId!==k)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(v.scheme))throw new D.$rl((0,r.localize)(10663,null,this.A(v)),D.FileOperationResult.FILE_PERMISSION_DENIED);const O={metadata:(0,o.$io)(N.apiNotebook.metadata,K=>!(F.options?.transientDocumentMetadata??{})[K]),cells:[]};for(const K of N.apiNotebook.getCells()){const ne=new $.$XO(K.kind,K.document.getText(),K.document.languageId,K.mime,F.options?.transientOutputs?[]:[...K.outputs],K.metadata,K.executionSummary);ne.metadata=(0,o.$io)(K.metadata,B=>!(F.options?.transientCellMetadata??{})[B]),O.cells.push(ne)}if(await this.z(v,A),p.isCancellationRequested)throw new Error("canceled");const j=await F.serializer.serializeNotebook(O,p);if(p.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${k} ${v.toString()}`),await this.s.value.writeFile(v,j),this.D(`Finished write versionId: ${k} ${v.toString()}`);const z=this.s.getFileSystemProviderExtUri(v.scheme),M=await this.s.value.stat(v),V={name:z.basename(v),isFile:(M.type&D.FileType.File)!==0,isDirectory:(M.type&D.FileType.Directory)!==0,isSymbolicLink:(M.type&D.FileType.SymbolicLink)!==0,mtime:M.mtime,ctime:M.ctime,size:M.size,readonly:!!((M.permissions??0)&D.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(v.scheme),locked:!!((M.permissions??0)&D.FilePermission.Locked),etag:D.$Cl({mtime:M.mtime,size:M.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${k}, ${v.toString()})`),V}async $searchInNotebooks(S,y,k,A,p){const v=this.y.get(S)?.serializer;if(!v)return{limitHit:!1,results:[]};const F=new L.$Ac;await(async(M,V,K)=>{await Promise.all(M.map(async ne=>await Promise.all(ne.filenamePatterns.map(B=>{const G={_reason:K._reason,folderQueries:K.folderQueries,includePattern:K.includePattern,excludePattern:K.excludePattern,maxResults:K.maxResults,type:s.QueryType.File,filePattern:B};return this.t.doInternalFileSearchWithCustomCallback(G,V,Y=>{Y.forEach(ee=>{F.has(ee)||A.some(re=>ne.isFromSettings&&!re.isFromSettings?!1:re.filenamePatterns.some(ye=>(0,l.$bL)(ye,ee)))||F.add(ee)})}).catch(Y=>{if(Y.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw Y})}))))})(k,p,y);const O=new L.$zc;let j=!1;const z=Array.from(F).map(async M=>{const V=[];try{if(p.isCancellationRequested)return;if(y.maxResults&&[...O.values()].reduce((G,Y)=>G+Y.cellResults.length,0)>y.maxResults){j=!0;return}const K=[],ne=this.g.get(M);if(ne)ne.apiNotebook.getCells().forEach(Y=>K.push({input:Y.document.getText(),outputs:Y.outputs.flatMap(ee=>ee.items.map(ue=>ue.data.toString()))}));else{const G=await this.s.value.readFile(M),Y=h.$Le.fromString(G.toString()),ee=await v.deserializeNotebook(Y.buffer,p);if(p.isCancellationRequested)return;a.NotebookData.from(ee).cells.forEach(re=>K.push({input:re.source,outputs:re.outputs.flatMap(ye=>ye.items.map($e=>$e.valueBytes.toString()))}))}if(p.isCancellationRequested)return;K.forEach((G,Y)=>{const ee=y.contentPattern.pattern,ue=new n.$BZb(G.input,void 0,G.outputs),re=ue.findInInputs(ee),ye=ue.findInOutputs(ee),$e=ye.flatMap(J=>(0,d.$gM)(J.matches,J.textBuffer)).map((J,W)=>(J.webviewIndex=W,J));if(re.length>0||ye.length>0){const J={index:Y,contentResults:(0,d.$gM)(re,ue.inputTextBuffer),webviewResults:$e};V.push(J)}});const B={resource:M,cellResults:V};O.set(M,B);return}catch{return}});return await Promise.all(z),{limitHit:j,results:[...O.values()]}}async z(S,y){const k=await this.s.value.stat(S);if(typeof y?.mtime=="number"&&typeof y.etag=="string"&&y.etag!==D.$Bl&&typeof k.mtime=="number"&&typeof k.size=="number"&&y.mtime<k.mtime&&y.etag!==D.$Cl({mtime:y.mtime,size:k.size}))throw new D.$rl((0,r.localize)(10664,null),D.FileOperationResult.FILE_MODIFIED_SINCE,y)}A(S){return S.scheme===t.Schemas.file?S.fsPath:S.toString()}B(S,y,k){if(this.h.has(y))throw new Error(`editor with id ALREADY EXSIST: ${y}`);const A=new i.$Npc(y,this.d,S,k.visibleRanges.map(a.NotebookRange.to),k.selections.map(a.NotebookRange.to),typeof k.viewColumn=="number"?a.ViewColumn.to(k.viewColumn):void 0);this.h.set(y,A)}$acceptDocumentAndEditorsDelta(S){if(S.value.removedDocuments)for(const k of S.value.removedDocuments){const A=I.URI.revive(k),p=this.g.get(A);p&&(p.dispose(),this.g.delete(A),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(v=>v.document.uri)}),this.n.fire(p.apiNotebook));for(const v of this.h.values())v.notebookData.uri.toString()===A.toString()&&this.h.delete(v.id)}if(S.value.addedDocuments){const k=[];for(const A of S.value.addedDocuments){const p=I.URI.revive(A.uri);if(this.g.has(p))throw new Error(`adding EXISTING notebook ${p} `);const v=new g.$Mpc(this.c,this.q,this.r,p,A);k.push(...A.cells.map(F=>g.$Lpc.asModelAddData(F))),this.g.get(p)?.dispose(),this.g.set(p,v),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:k}),this.m.fire(v.apiNotebook)}}if(S.value.addedEditors)for(const k of S.value.addedEditors){if(this.h.has(k.id))return;const A=I.URI.revive(k.documentUri),p=this.g.get(A);p&&this.B(p,k.id,k)}const y=[];if(S.value.removedEditors)for(const k of S.value.removedEditors){const A=this.h.get(k);A&&(this.h.delete(k),this.k?.id===A.id&&(this.k=void 0),y.push(A))}if(S.value.visibleEditors){this.l=S.value.visibleEditors.map(A=>this.h.get(A)).filter(A=>!!A);const k=new Set;this.l.forEach(A=>k.add(A.id));for(const A of this.h.values()){const p=k.has(A.id);A._acceptVisibility(p)}this.l=[...this.h.values()].map(A=>A).filter(A=>A.visible),this.o.fire(this.visibleNotebookEditors)}S.value.newActiveEditor===null?this.k=void 0:S.value.newActiveEditor&&(this.h.get(S.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${S.value.newActiveEditor}`),this.k=this.h.get(S.value.newActiveEditor)),S.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(S){const y=w.$mQ.String.with("notebookType","A notebook type"),k=new w.$oQ("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[y,new w.$mQ("data","Bytes to convert to data",p=>p instanceof Uint8Array,p=>h.$Le.wrap(p))],new w.$nQ("Notebook Data",p=>a.NotebookData.to(p.value))),A=new w.$oQ("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[y,new w.$mQ("NotebookData","Notebook data to convert to bytes",p=>!0,p=>new f.$Sw(a.NotebookData.from(p)))],new w.$nQ("Bytes",p=>p.buffer));S.registerApiCommand(k),S.registerApiCommand(A)}D(S){this.u.trace(`[Extension Host Notebook] ${S}`)}}e.$Wpc=m}),define(ke[335],Ie([1,0,16,20,52,38,22,42,37]),function(me,e,r,h,C,T,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Opc=void 0,r=Ue(r),T=Ue(T),L=Ue(L);class c{constructor(u,P,w){this.k=u,this.l=P,this.o=w,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&T.$wk(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&T.$wk(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const P=this.k.folderQueries||[];return new Promise((w,a)=>{const $=f=>{this.f++,u(f)};if(this.g)return w({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(f=>{const g=f.toString(),i=r.$mc(g);this.j&&this.j(g,i)||this.v($,{base:f,basename:i})}),Promise.all(P.map(f=>this.p(f,$))).then(f=>{w({limitHit:this.e,stats:f[0]||void 0})},f=>{a(new Error((0,C.$nj)(f)))})})}async p(u,P){const w=new h.$ue,a=this.q(u),$=this.r(),f=new b.$9L(this.k,u),g=!f.hasSiblingExcludeClauses();let i;try{this.h.add(w),i=R.$de.create();const o=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},a,w.token),t=i.elapsed(),s=R.$de.create();return this.g&&!this.e||(o&&o.forEach(n=>{const d=r.$fc.relative(u.folder.path,n.path);if(g){const l=r.$mc(n.path);this.v(P,{base:u.folder,relativePath:d,basename:l});return}this.s($,u.folder,d,P)}),this.g&&!this.e)?null:(this.u($,f,P),{providerTime:t,postProcessTime:s.elapsed()})}finally{w.dispose(),this.h.delete(w)}}q(u){const P=(0,b.$8L)(this.k.includePattern,u.includePattern),w=(0,b.$8L)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:w,includes:P,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},P,w,a){if(w===this.a){const f=r.$mc(this.a);this.v(a,{base:P,relativePath:this.a,basename:f})}function $(f){const g=r.$mc(f),i=r.$lc(f);let o=u[i];o||(o=u[i]=[],$(i)),o.push({base:P,relativePath:f,basename:g})}$(w)}u({rootEntries:u,pathToEntries:P},w,a){const $=this,f=this.a;function g(i){const o=(0,b.$$L)(()=>i.map(t=>t.basename));for(let t=0,s=i.length;t<s;t++){const n=i[t],{relativePath:d,basename:l}=n;if(w.matchesExcludesSync(d,l,f!==l?o:void 0))continue;const m=P[d];if(m)g(m);else{if(d===f)continue;$.v(a,n)}if($.e)break}}g(u)}v(u,P){(!this.b||P.relativePath&&this.b(P.relativePath,P.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(P))}}class I{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,P,w,a){const $=this.c(u.cacheKey),f=new c(u,P,$&&$.token);let g=0;const i=o=>{g+=o.length,w(o.map(t=>this.d(t)))};return this.e(f,I.a,i,a).then(o=>({limitHit:o.limitHit,stats:o.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:g,detailStats:o.stats}:void 0,messages:[]}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new h.$ue),this.b.get(u)}d(u){return u.relativePath?{resource:L.$dh(u.base,u.relativePath)}:{resource:u.base}}e(u,P,w,a){const $=a.onCancellationRequested(()=>{u.cancel()}),f=i=>{i&&(g.push(i),P>0&&g.length>=P&&(w(g),g=[]))};let g=[];return u.search(f).then(i=>(g.length&&w(g),$.dispose(),i),i=>(g.length&&w(g),$.dispose(),Promise.reject(i)))}}e.$Opc=I}),define(ke[336],Ie([1,0,18,78,38,107,28,14,16,22,12,17,2,111,8,45,11,46,157,331,37]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a,$,f,g,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9M=void 0,e.$0M=y,r=Ue(r),h=Ue(h),C=Ue(C),b=Ue(b),I=Ue(I),w=Ue(w);let t=class{constructor(A,p,v,F,N){this.a=A,this.b=p,this.c=v,this.d=F,this.e=N}text(A,p,v={}){A=this.f(A,v);const F=this.a.getValue(),N=p&&p.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(p?.map(f.$Xi),v),type:o.QueryType.Text,contentPattern:A,previewOptions:v.previewOptions,maxFileSize:v.maxFileSize,usePCRE2:F.search.usePCRE2||N||!1,beforeContext:v.beforeContext,afterContext:v.afterContext,userDisabledExcludesAndIgnoreFiles:v.disregardExcludeSettings&&v.disregardIgnoreFiles}}f(A,p){const v=this.a.getValue();A.isRegExp&&(A.pattern=A.pattern.replace(/\r?\n/g,"\\n"));const F={...A,wordSeparators:v.editor.wordSeparators};return this.j(A,p)&&(F.isCaseSensitive=!0),this.k(A)&&(F.isMultiline=!0),p.notebookSearchConfig?.includeMarkupInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownInput=p.notebookSearchConfig.includeMarkupInput),p.notebookSearchConfig?.includeMarkupPreview&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownPreview=p.notebookSearchConfig.includeMarkupPreview),p.notebookSearchConfig?.includeCodeInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellInput=p.notebookSearchConfig.includeCodeInput),p.notebookSearchConfig?.includeOutput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellOutput=p.notebookSearchConfig.includeOutput),F}file(A,p={}){return{...this.h(A,p),type:o.QueryType.File,filePattern:p.filePattern?p.filePattern.trim():p.filePattern,exists:p.exists,sortByScore:p.sortByScore,cacheKey:p.cacheKey,shouldGlobMatchFilePattern:p.shouldGlobSearch}}g(A,p){return A?(A=Array.isArray(A)?A.map(m):m(A),p?this.parseSearchPaths(A):{pattern:n(...Array.isArray(A)?A:[A])}):{}}h(A=[],p={}){const v=this.g(p.includePattern,p.expandPatterns),F=this.g(p.excludePattern,p.expandPatterns),N=A.length>1,O=(v.searchPaths&&v.searchPaths.length?v.searchPaths.map(M=>this.q(M,p,F)):A.map(M=>this.r(M,p,F,N))).filter(M=>!!M),j={_reason:p._reason,folderQueries:O,usingSearchPaths:!!(v.searchPaths&&v.searchPaths.length),extraFileResources:p.extraFileResources,excludePattern:F.pattern,includePattern:v.pattern,onlyOpenEditors:p.onlyOpenEditors,maxResults:p.maxResults};if(p.onlyOpenEditors){const M=r.$Gb(this.c.groups.flatMap(ne=>ne.editors.map(B=>B.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(M));const V=M.filter(ne=>(0,o.$YL)(j,ne.fsPath)),K=this.i(V);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(K)),{...j,...K}}const z=p.extraFileResources&&p.extraFileResources.filter(M=>(0,o.$YL)(j,M.fsPath));return j.extraFileResources=z&&z.length?z:void 0,j}i(A){const p=[],v=new L.$zc,F={};let N=!1;return A.forEach(O=>{if(O.scheme===R.Schemas.walkThrough)return;if((0,c.$hh)(O)){const z=this.b.getWorkspaceFolder(O)?.uri??O.with({path:b.$lc(O.fsPath)});let M=v.get(z);M||(N=!0,M={folder:z,includePattern:{}},p.push(M),v.set(z,M));const V=b.$kc(z.fsPath,O.fsPath);(0,D.$ng)(M.includePattern)[V.replace(/\\/g,"/")]=!0}else O.fsPath&&(N=!0,F[O.fsPath]=!0)}),{folderQueries:p,includePattern:F,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}j(A,p){if(p.isSmartCase){if(A.isRegExp){if(I.$6f(A.pattern,!0))return!0}else if(I.$6f(A.pattern))return!0}return!!A.isCaseSensitive}k(A){return A.isMultiline||A.isRegExp&&(0,P.$_C)(A.pattern)||A.pattern.indexOf(`
`)>=0?!0:!!A.isMultiline}parseSearchPaths(A){const p=K=>b.$hc(K)||/^\.\.?([\/\\]|$)/.test(K),F=(Array.isArray(A)?A:d(A)).map(K=>{const ne=this.e.resolvedUserHome;return ne?(0,T.$Xw)(K,ne.scheme===R.Schemas.file?ne.fsPath:ne.path):K}),N=h.$c(F,K=>p(K)?"searchPaths":"exprSegments"),O=(N.exprSegments||[]).map(K=>I.$lf(K,"/")).map(K=>I.$lf(K,"\\")).map(K=>(K[0]==="."&&(K="*"+K),l(K))),j={},z=this.m(N.searchPaths||[]);z&&z.length&&(j.searchPaths=z);const M=O.flat(),V=n(...M);return V&&(j.pattern=V),j}l(A,p){return p.disregardExcludeSettings?void 0:(0,o.$XL)(A,!p.disregardSearchExcludeSettings)}m(A){if(!A||!A.length)return[];const p=A.flatMap(F=>{let{pathPortion:N,globPortion:O}=s(F);return O&&(O=E(O)),this.n(N).flatMap(z=>this.o(z,O))}),v=new Map;return p.forEach(F=>{const N=F.searchPath.toString(),O=v.get(N);O?F.pattern&&(O.pattern=O.pattern||{},O.pattern[F.pattern]=!0):v.set(N,{searchPath:F.searchPath,pattern:F.pattern?n(F.pattern):void 0})}),Array.from(v.values())}n(A){if(b.$hc(A)){const p=this.b.getWorkspace().folders;return p[0]&&p[0].uri.scheme!==R.Schemas.file?[{searchPath:p[0].uri.with({path:A})}]:[{searchPath:u.URI.file(b.$gc(A))}]}if(this.b.getWorkbenchState()===f.WorkbenchState.FOLDER){const p=this.b.getWorkspace().folders[0].uri;if(A=m(A),A.startsWith("../")||A===".."){const F=b.$fc.resolve(p.path,A);return[{searchPath:p.with({path:F})}]}const v=E(A);return[{searchPath:p,pattern:v}]}else{if(A==="./"||A===".\\")return[];{const p=A.replace(/^\.[\/\\]/,""),F=this.b.getWorkspace().folders.map(N=>{const O=p.match(new RegExp(`^${I.$ff(N.name)}(?:/(.*)|$)`));return O?{match:O,folder:N}:null}).filter(D.$kg);if(F.length)return F.map(N=>{const O=N.match[1];return{searchPath:N.folder.uri,pattern:O&&E(O)}});{const N=A.match(/\.[\/\\](.+)[\/\\]?/),O=N?N[1]:A,j=w.localize(1584,null,O);throw new Error(j)}}}}o(A,p){const v=A.pattern&&p?`${A.pattern}/${p}`:A.pattern||p,F=[{searchPath:A.searchPath,pattern:v}];return v&&!v.endsWith("**")&&F.push({searchPath:A.searchPath,pattern:v+"/**"}),F}q(A,p,v){const F=this.r((0,f.$Xi)(A.searchPath),p,v,!1);return F?{...F,includePattern:A.pattern}:null}r(A,p,v,F){let N;const O=u.URI.isUri(A)?A:A.uri;if(v.searchPaths){const K=v.searchPaths.filter(ne=>(0,c.$9g)(ne.searchPath,O))[0];if(K&&!K.pattern)return null;K&&(N=K.pattern)}const j=this.a.getValue({resource:O}),M={...this.l(j,p)||{},...N||{}},V=u.URI.isUri(A)?(0,c.$ah)(A):A.name;return{folder:O,folderName:F?V:void 0,excludePattern:Object.keys(M).length>0?M:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof p.disregardIgnoreFiles=="boolean"?p.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof p.disregardGlobalIgnoreFiles=="boolean"?p.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof p.disregardParentIgnoreFiles=="boolean"?p.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof p.ignoreSymlinks=="boolean"?p.ignoreSymlinks:!j.search.followSymlinks}}};e.$9M=t,e.$9M=t=Ye([Ve(0,a.$9i),Ve(1,f.$Li),Ve(2,g.$hE),Ve(3,$.$9j),Ve(4,i.$7M)],t);function s(k){const A=k.match(/[\*\{\}\(\)\[\]\?]/);if(A){const p=A.index,v=k.substr(0,p).match(/[/|\\][^/\\]*$/);if(v){let F=k.substr(0,v.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:k.substr((v.index||0)+1)}}}return{pathPortion:k}}function n(...k){return k.length?k.reduce((A,p)=>(A[p]=!0,A),Object.create(null)):void 0}function d(k){return C.$uk(k,",").map(A=>A.trim()).filter(A=>!!A.length)}function l(k){return[`**/${k}/**`,`**/${k}`].map(p=>p.replace(/\*\*\/\*\*/g,"**"))}function m(k){return k.replace(/\\/g,"/")}function E(k){return m(k).replace(/^\.\//,"").replace(/\/+$/g,"")}function S(k){return k.replace(/([?*[\]])/g,"[$1]")}function y(k,A){k=r.$Lb(k,F=>F.toString());const p=[],v=A.getWorkspace();return k&&k.forEach(F=>{let N;if(A.getWorkbenchState()===f.WorkbenchState.FOLDER)N=(0,c.$fh)(v.folders[0].uri,F),N&&N!=="."&&(N="./"+N);else{const O=A.getWorkspaceFolder(F);if(O){const j=O.name;if(v.folders.filter(M=>M.name===j).length===1){const M=(0,c.$fh)(O.uri,F);M===""?N=`./${O.name}`:N=`./${O.name}/${M}`}else N=F.fsPath}}N&&p.push(S(N))}),p}}),define(ke[337],Ie([1,0,22,2,20,13,5,336,37,46,7]),function(me,e,r,h,C,T,L,R,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$byb=u,e.$cyb=a,r=Ue(r),T=Ue(T);const D=7e3;function u($,f){const g=f.activationEvents;if(!g)return Promise.resolve(void 0);const i=[],o=[];for(const m of g)if(/^workspaceContains:/.test(m)){const E=m.substr(18);E.indexOf("*")>=0||E.indexOf("?")>=0||$.forceUsingSearch?o.push(E):i.push(E)}if(i.length===0&&o.length===0)return Promise.resolve(void 0);const{promise:t,resolve:s}=(0,I.$vh)(),n=m=>s({activationEvent:m}),d=Promise.all(i.map(m=>P($,m,n))).then(()=>{}),l=w($,f.identifier,o,n);return Promise.all([d,l]).then(()=>{s(void 0)}),t}async function P($,f,g){for(const i of $.folders)if(await $.exists(r.$dh(h.URI.revive(i),f))){g(`workspaceContains:${f}`);return}}async function w($,f,g,i){if(g.length===0)return Promise.resolve(void 0);const o=new C.$ue,t=$.checkExists($.folders,g,o.token),s=setTimeout(async()=>{o.cancel(),$.logService.info(`Not activating extension '${f.value}': Timed out while searching for 'workspaceContains' pattern ${g.join(",")}`)},D);let n=!1;try{n=await t}catch(d){T.$3(d)||T.$Y(d)}o.dispose(),clearTimeout(s),n&&i(`workspaceContains:${g.join(",")}`)}function a($,f,g,i){const o=$.get(L.$Bi),t=$.get(b.$PL),n=o.createInstance(R.$9M).file(f.map(d=>(0,c.$Xi)(h.URI.revive(d))),{_reason:"checkExists",includePattern:g,exists:!0});return t.fileSearch(n,i).then(d=>!!d.limitHit,d=>T.$3(d)?!1:Promise.reject(d))}}),define(ke[54],Ie([1,0,8,16,61,22,7,3,84,2,11,6,41,269,125,48,25,159,13,23,21,248,9,71,5,29,97,19,114,76,47,128,4,337,124,250,14,122,42,10,123]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a,$,f,g,i,o,t,s,n,d,l,m,E,S,y,k,A,p,v,F,N,O,j,z,M,V){"use strict";var K;Object.defineProperty(e,"__esModule",{value:!0}),e.$ppc=e.$opc=e.$npc=e.$mpc=e.$lpc=void 0,r=Ue(r),h=Ue(h),C=Ue(C),g=Ue(g),e.$lpc=(0,d.$Ci)("IHostUtils");let ne=K=class extends R.$Tc{constructor(J,W,se,ae,te,ce,le,Z,oe,pe,we,Fe,We){super(),this.Y=Fe,this.Z=We,this.a=this.B(new p.$je),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=W,this.g=se,this.f=le,this.j=ae,this.m=te,this.s=ce,this.t=oe,this.u=pe,this.w=we,this.y=this.g.getProxy(D.$sN.MainThreadWorkspace),this.z=this.g.getProxy(D.$sN.MainThreadTelemetry),this.C=this.g.getProxy(D.$sN.MainThreadExtensionService),this.D=new L.$Bh,this.F=new L.$Bh,this.G=new L.$Bh,this.H=new L.$Bh,this.I=new ye(this.f.extensions.activationEvents),this.L=new f.$Occ(this.I,this.f.extensions.allExtensions);const Se=new i.$on(this.f.extensions.myExtensions);this.J=new f.$Occ(this.I,ue(this.L,Se)),M.$u&&(this.s.info(`Creating extension host with the following global extensions: ${Y(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Y(this.J)}`)),this.M=new w.$7oc(this.g,this.s),this.N=new F.$epc(this.g),this.O=Z,this.h=J.createChild(new S.$Ai([w.$8oc,this.M],[F.$fpc,this.N])),this.P=this.B(new P.$6oc(this.J,this.L,{onExtensionActivationError:(De,Te,U)=>{this.C.$onExtensionActivationError(De,g.$1(Te),U)},actualActivateExtension:async(De,Te)=>{if(f.$Occ.isHostExtension(De,this.J,this.L))return await this.C.$activateExtension(De,Te),new P.$5oc;const U=this.J.getExtensionDescription(De);return this.fb(U,Te)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(J){g.$Y(J)}}async $(){this.O.onWillDeactivateAll();let J=[];try{J=this.J.getAllExtensionDescriptions().map(te=>te.identifier).filter(te=>this.isActivated(te)).map(te=>this.eb(te))}catch{}await Promise.all(J)}terminate(J,W=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${J}`),this.s.flush(),this.u.dispose(),this.P.dispose(),g.setUnexpectedErrorHandler(ae=>{this.s.error(ae)}),this.g.dispose();const se=this.$();Promise.race([(0,L.$Dh)(5e3),se]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${W}`):this.s.info(`Extension host exiting with code ${W}`),this.s.flush(),this.s.dispose(),this.c.exit(W)})}isActivated(J){return this.G.isOpen()?this.P.isActivated(J):!1}async getExtension(J){const W=await this.C.$getExtension(J);return W&&{...W,identifier:new i.$nn(W.identifier.value),extensionLocation:c.URI.revive(W.extensionLocation)}}ab(J,W){return this.P.activateByEvent(J,W)}bb(J,W){return this.P.activateById(J,W)}activateByIdWithErrors(J,W){return this.bb(J,W).then(()=>{const se=this.P.getActivatedExtension(J);if(se.activationFailed)return Promise.reject(se.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(J=>this.J)}getExtensionExports(J){if(this.G.isOpen())return this.P.getActivatedExtension(J).exports;try{return this.P.getActivatedExtension(J).exports}catch{return null}}async cb(J){if(J.scheme===O.Schemas.file&&this.c.fsRealpath){const W=J.fsPath;this.R.has(W)||this.R.set(W,this.c.fsRealpath(W));const se=await this.R.get(W);return c.URI.file(se)}return J}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(J=>new re(J))),this.Q}async db(J){const W=b.$Ii.forUris(se=>T.$7g.ignorePathCasing(se));return await Promise.all(J.map(async se=>{if(this.wb(se)){const ae=await this.cb(se.extensionLocation);W.set(ae,se)}})),W}eb(J){let W=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(J))return W;const se=this.P.getActivatedExtension(J);if(!se)return W;try{typeof se.module.deactivate=="function"&&(W=Promise.resolve(se.module.deactivate()).then(void 0,ae=>(this.s.error(ae),Promise.resolve(void 0))))}catch(ae){this.s.error(`An error occurred when deactivating the extension '${J.value}':`),this.s.error(ae)}try{(0,R.$Oc)(se.subscriptions)}catch(ae){this.s.error(`An error occurred when deactivating the subscriptions for extension '${J.value}':`),this.s.error(ae)}return W}async fb(J,W){return this.f.remote.isRemote?this.C.$onWillActivateExtension(J.identifier):await this.C.$onWillActivateExtension(J.identifier),this.hb(J,W).then(se=>{const ae=se.activationTimes;return this.C.$onDidActivateExtension(J.identifier,ae.codeLoadingTime,ae.activateCallTime,ae.activateResolvedTime,W),this.gb(J,W,"success",ae),se},se=>{throw this.gb(J,W,"failure"),se})}gb(J,W,se,ae){const te=G(J,W);this.z.$publicLog2("extensionActivationTimes",{...te,...ae||{},outcome:se})}hb(J,W){const se=G(J,W);this.z.$publicLog2("activatePlugin",se);const ae=this.wb(J);if(!ae)return Promise.resolve(new P.$4oc(P.$1oc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${J.identifier.value}, startup: ${W.startup}, activationEvent: '${W.activationEvent}'${J.identifier.value!==W.extensionId.value?`, root cause: ${W.extensionId.value}`:""}`),this.s.flush();const te=new P.$2oc(W.startup);return Promise.all([this.xb(J,(0,T.$dh)(J.extensionLocation,ae),te),this.ib(J)]).then(ce=>(C.mark(`code/extHost/willActivateExtension/${J.identifier.value}`),K.jb(this.s,J.identifier,ce[0],ce[1],te))).then(ce=>(C.mark(`code/extHost/didActivateExtension/${J.identifier.value}`),ce))}ib(J){const W=this.Z.createLanguageModelAccessInformation(J),se=this.B(new t.$0oc(J,this.M)),ae=this.B(new t.$9oc(J.identifier.value,!1,this.M)),te=this.B(new N.$gpc(J,this.N)),ce=J.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?s.ExtensionMode.Test:s.ExtensionMode.Development:s.ExtensionMode.Production,le=this.f.remote.isRemote?s.ExtensionKind.Workspace:s.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${J.identifier.value}`),Promise.all([se.whenReady,ae.whenReady,this.O.whenReady]).then(()=>{const Z=this;let oe,pe;const we=(0,$.$4G)(J,"ipc")?this.f.messagePorts?.get(i.$nn.toKey(J.identifier)):void 0;return Object.freeze({globalState:se,workspaceState:ae,secrets:te,subscriptions:[],get languageModelAccessInformation(){return W},get extensionUri(){return J.extensionLocation},get extensionPath(){return J.extensionLocation.fsPath},asAbsolutePath(Fe){return h.$ic(J.extensionLocation.fsPath,Fe)},get storagePath(){return Z.O.workspaceValue(J)?.fsPath},get globalStoragePath(){return Z.O.globalValue(J).fsPath},get logPath(){return h.$ic(Z.f.logsLocation.fsPath,J.identifier.value)},get logUri(){return c.URI.joinPath(Z.f.logsLocation,J.identifier.value)},get storageUri(){return Z.O.workspaceValue(J)},get globalStorageUri(){return Z.O.globalValue(J)},get extensionMode(){return ce},get extension(){return oe===void 0&&(oe=new ee(Z,J.identifier,J,le,!1)),oe},get extensionRuntime(){return(0,$.$5G)(J,"extensionRuntime"),Z.extensionRuntime},get environmentVariableCollection(){return Z.u.getEnvironmentVariableCollection(J)},get messagePassingProtocol(){if(!pe){if(!we)return;const Fe=p.Event.buffer(p.Event.fromDOMEventEmitter(we,"message",We=>We.data));we.start(),pe={onDidReceiveMessage:Fe,postMessage:we.postMessage.bind(we)}}return pe}})})}static jb(J,W,se,ae,te){return se=se||{activate:void 0,deactivate:void 0},this.kb(J,W,se,ae,te).then(ce=>new P.$3oc(!1,null,te.build(),se,ce,ae.subscriptions))}static kb(J,W,se,ae,te){if(typeof se.activate=="function")try{te.activateCallStart(),J.trace(`ExtensionService#_callActivateOptional ${W.value}`);const ce=typeof global=="object"?global:self,le=se.activate.apply(ce,[ae]);return te.activateCallStop(),te.activateResolveStart(),Promise.resolve(le).then(Z=>(te.activateResolveStop(),Z))}catch(ce){return Promise.reject(ce)}else return Promise.resolve(se)}lb(J,W){this.bb(J.identifier,{startup:!1,extensionId:J.identifier,activationEvent:W}).then(void 0,se=>{this.s.error(se)})}mb(J,W=0){const ae=Date.now();(0,M.$C)(()=>{for(let te=W;te<J.length;te+=1){const ce=J[te];for(const le of ce.activationEvents??[])if(le==="onStartupFinished")if(Date.now()-ae>50){this.mb(J,te);break}else this.lb(ce,le)}})}nb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then(J=>{const W=J.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),se=this.J.getAllExtensionDescriptions();if(W)this.mb(se);else for(const ae of se)if(ae.activationEvents)for(const te of ae.activationEvents)te==="onStartupFinished"&&this.lb(ae,te)})}ob(){const J=this.ab("*",!0).then(void 0,ce=>{this.s.error(ce)});this.B(this.j.onDidChangeWorkspace(ce=>this.pb(ce.added)));const W=this.j.workspace?this.j.workspace.folders:[],se=this.pb(W),ae=this.rb(),te=Promise.all([ae,J,se]).then(()=>{});return Promise.race([te,(0,L.$Dh)(1e4)]).then(()=>{this.nb()}),te}pb(J){return J.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(W=>this.qb(J,W))).then(()=>{})}async qb(J,W){if(this.isActivated(W.identifier))return;const se=!this.f.remote.isRemote&&!!this.f.remote.authority,ae={logService:this.s,folders:J.map(ce=>ce.uri),forceUsingSearch:se||!this.c.fsExists,exists:ce=>this.c.fsExists(ce.fsPath),checkExists:(ce,le,Z)=>this.y.$checkExists(ce,le,Z)},te=await(0,v.$byb)(ae,W);if(te)return this.bb(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:te.activationEvent}).then(void 0,ce=>this.s.error(ce))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(J){throw console.error(J),J}}async sb(){const{extensionDevelopmentLocationURI:J,extensionTestsLocationURI:W}=this.f.environment;if(!J||!W)throw new Error(r.localize(10671,null));const se=await this.xb(null,W,new P.$2oc(!1));if(!se||typeof se.run!="function")throw new Error(r.localize(10672,null,W.toString()));return new Promise((ae,te)=>{const ce=(oe,pe)=>{oe?(M.$u&&this.s.error("Test runner called back with error",oe),te(oe)):(M.$u&&(pe?this.s.info(`Test runner called back with ${pe} failures.`):this.s.info("Test runner called back with successful outcome.")),ae(typeof pe=="number"&&pe>0?1:0))},le=(0,T.$4g)(W),Z=se.run(le,ce);Z&&Z.then&&Z.then(()=>{M.$u&&this.s.info("Test runner finished successfully."),ae(0)}).catch(oe=>{M.$u&&this.s.error("Test runner finished with error",oe),te(oe instanceof Error&&oe.stack?oe.stack:String(oe))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,L.$Dh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(J,W){return this.S[J]=W,(0,R.$Rc)(()=>{delete this.S[J]})}async getRemoteExecServer(J){const{resolver:W}=await this.ub(J);return W?.resolveExecServer?.(J,{resolveAttempt:0})}async ub(J){const W=J.indexOf("+");if(W===-1)throw new s.$AN("Not an authority that can be resolved!",n.RemoteAuthorityResolverErrorCode.InvalidAuthority);const se=J.substr(0,W);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${se}`,!1),{authorityPrefix:se,resolver:this.S[se]}}async $resolveAuthority(J,W){const se=z.$de.create(!1),ae=()=>`[resolveAuthority(${(0,n.$Rl)(J)},${W})][${se.elapsed()}ms] `,te=q=>this.s.info(`${ae()}${q}`),ce=q=>this.s.warn(`${ae()}${q}`),le=(q,X=void 0)=>this.s.error(`${ae()}${q}`,X),Z=q=>{if(q instanceof s.$AN)return{type:"error",error:{code:q._code,message:q._message,detail:q._detail}};throw q},oe=async q=>{te(`activating resolver for ${q}...`);const{resolver:X,authorityPrefix:_}=await this.ub(q);if(!X)throw le(`no resolver for ${_}`),new s.$AN(`No remote extension installed to resolve ${_}.`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:X,authorityPrefix:_,remoteAuthority:q}},pe=J.split(/@|%40/g).reverse();te(`activating remote resolvers ${pe.join(" -> ")}`);let we;try{we=await Promise.all(pe.map(oe)).catch(async q=>{if(!(q instanceof s.$AN)||q._code!==n.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw q;return ce(`resolving nested authorities failed: ${q.message}`),[await oe(J)]})}catch(q){return Z(q)}const Fe=new L.$Nh;Fe.cancelAndSet(()=>te("waiting..."),1e3);let We,Se;for(const[q,{authorityPrefix:X,resolver:_,remoteAuthority:de}]of we.entries())try{if(q===we.length-1)te("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${X}`),We=await _.resolve(de,{resolveAttempt:W,execServer:Se}),C.mark(`code/extHost/didResolveAuthorityOK/${X}`),te("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(_,s.$zN.isManagedResolvedAuthority(We)?We:void 0));else{if(te(`invoking resolveExecServer() for ${de}`),C.mark(`code/extHost/willResolveExecServer/${X}`),Se=await _.resolveExecServer?.(de,{resolveAttempt:W,execServer:Se}),!Se)throw new s.$AN(`Exec server was not available for ${de}`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${X}`)}}catch(be){return C.mark(`code/extHost/didResolveAuthorityError/${X}`),le("returned an error",be),Fe.dispose(),Z(be)}Fe.dispose();const De={environmentTunnels:We.environmentTunnels,features:We.tunnelFeatures?{elevation:We.tunnelFeatures.elevation,privacyOptions:We.tunnelFeatures.privacyOptions,protocol:We.tunnelFeatures.protocol===void 0?!0:We.tunnelFeatures.protocol}:void 0},Te={extensionHostEnv:We.extensionHostEnv,isTrusted:We.isTrusted,authenticationSession:We.authenticationSessionForInitializingExtensions?{id:We.authenticationSessionForInitializingExtensions.id,providerId:We.authenticationSessionForInitializingExtensions.providerId}:void 0};te(`returned ${s.$zN.isManagedResolvedAuthority(We)?"managed authority":`${We.host}:${We.port}`}`);let U;if(s.$zN.isManagedResolvedAuthority(We)){const q=W;this.Y.setFactory(q,We.makeConnection),U={authority:J,connectTo:new n.$Ol(q),connectionToken:We.connectionToken}}else U={authority:J,connectTo:new n.$Pl(We.host,We.port),connectionToken:We.connectionToken};return{type:"ok",value:{authority:U,options:Te,tunnelInformation:De}}}async $getCanonicalURI(J,W){this.s.info(`$getCanonicalURI invoked for authority (${(0,n.$Rl)(J)})`);const{resolver:se}=await this.ub(J);if(!se)return null;const ae=c.URI.revive(W);if(typeof se.getCanonicalURI>"u")return ae;const te=await(0,L.$uh)(()=>se.getCanonicalURI(ae));return te||ae}async $startExtensionHost(J){J.toAdd.forEach(ce=>ce.extensionLocation=c.URI.revive(ce.extensionLocation));const{globalRegistry:W,myExtensions:se}=B(this.I,this.L,this.J,J),ae=await this.db(se);return(await this.getExtensionPathIndex()).setSearchTree(ae),this.L.set(W.getAllExtensionDescriptions()),this.J.set(se),M.$u&&(this.s.info(`$startExtensionHost: global extensions: ${Y(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Y(this.J)}`)),this.tb()}$activateByEvent(J,W){return W===$.ActivationKind.Immediate?this.D.wait().then(se=>this.ab(J,!1)):this.G.wait().then(se=>this.ab(J,!1))}async $activate(J,W){return await this.G.wait(),this.J.getExtensionDescription(J)?(await this.bb(J,W),!0):!1}async $deltaExtensions(J){J.toAdd.forEach(ce=>ce.extensionLocation=c.URI.revive(ce.extensionLocation));const{globalRegistry:W,myExtensions:se}=B(this.I,this.L,this.J,J),ae=await this.db(se);return(await this.getExtensionPathIndex()).setSearchTree(ae),this.L.set(W.getAllExtensionDescriptions()),this.J.set(se),M.$u&&(this.s.info(`$deltaExtensions: global extensions: ${Y(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Y(this.J)}`)),Promise.resolve(void 0)}async $test_latency(J){return J}async $test_up(J){return J.byteLength}async $test_down(J){const W=o.$Le.alloc(J),se=Math.random()%256;for(let ae=0;ae<J;ae++)W.writeUInt8(se,ae);return W}async $updateRemoteConnectionData(J){this.X=J,this.a.fire()}};e.$mpc=ne,e.$mpc=ne=K=Ye([Ve(0,d.$Bi),Ve(1,e.$lpc),Ve(2,E.$1P),Ve(3,a.$Joc),Ve(4,u.$Moc),Ve(5,I.$9j),Ve(6,l.$eQ),Ve(7,m.$Poc),Ve(8,y.$SFb),Ve(9,k.$$oc),Ve(10,j.$ipc),Ve(11,V.$jpc),Ve(12,A.$cpc)],ne);function B($e,J,W,se){$e.addActivationEvents(se.addActivationEvents);const ae=new f.$Occ($e,J.getAllExtensionDescriptions());ae.deltaExtensions(se.toAdd,se.toRemove);const te=new i.$on(W.getAllExtensionDescriptions().map(le=>le.identifier));for(const le of se.myToRemove)te.delete(le);for(const le of se.myToAdd)te.add(le);const ce=ue(ae,te);return{globalRegistry:ae,myExtensions:ce}}function G($e,J){return{id:$e.identifier.value,name:$e.name,extensionVersion:$e.version,publisherDisplayName:$e.publisher,activationEvents:$e.activationEvents?$e.activationEvents.join(","):null,isBuiltin:$e.isBuiltin,reason:J.activationEvent,reasonId:J.extensionId.value}}function Y($e){return $e.getAllExtensionDescriptions().map(J=>J.identifier.value).join(",")}e.$npc=(0,d.$Ci)("IExtHostExtensionService");class ee{#e;#t;#i;constructor(J,W,se,ae,te){this.#e=J,this.#t=W,this.#i=se.identifier,this.id=se.identifier.value,this.extensionUri=se.extensionLocation,this.extensionPath=h.$gc((0,T.$4g)(se.extensionLocation)),this.packageJSON=se,this.extensionKind=ae,this.isFromDifferentExtensionHost=te}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$opc=ee;function ue($e,J){return $e.getAllExtensionDescriptions().filter(W=>J.has(W.identifier))}class re{constructor(J){this.a=J}setSearchTree(J){this.a=J}findSubstr(J){return this.a.findSubstr(J)}forEach(J){return this.a.forEach(J)}}e.$ppc=re;class ye{constructor(J){this.a=new i.$pn,this.addActivationEvents(J)}readActivationEvents(J){return this.a.get(J.identifier)??[]}addActivationEvents(J){for(const W of Object.keys(J))this.a.set(W,J[W])}}}),define(ke[338],Ie([1,0,61,2,6,41,25,23,19,29,5,54,11,12]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$Aqc=void 0,r=Ue(r);let a=class{constructor(o,t,s,n,d,l,m){this.c=o,this.d=t,this.e=s,this.f=n,this.g=d,this.h=l,this.i=m,this.a=new Map,this.b=[]}async install(){this.j(),r.mark("code/extHost/willWaitForConfig");const o=await this.f.getConfigProvider();r.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new f(this.c,t,this.d,o,this.i)),this.register(this.e.createInstance($)),this.h.remote.isRemote&&this.register(this.e.createInstance(g,t,this.h.environment.appUriScheme))}register(o){if("nodeModuleName"in o)if(Array.isArray(o.nodeModuleName))for(const t of o.nodeModuleName)this.a.set(t,o);else this.a.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this.b.push(t=>o.alternativeModuleName(t))}};e.$Aqc=a,e.$Aqc=a=Ye([Ve(2,I.$Bi),Ve(3,T.$Moc),Ve(4,D.$npc),Ve(5,c.$eQ),Ve(6,u.$9j)],a);let $=class{static{w=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(o){if(o.environment.appRoot&&w.a.size){const t=(0,P.$ff)(this.c(o.environment.appRoot.fsPath)),s="[a-z0-9_.-]",n=`@${s}+\\/${s}+|${s}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${d}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(o){if(!this.b)return;const t=this.b.exec(this.c(o));if(!t)return;const[,s,n,d]=t,l=w.a.get(n);if(l!==void 0)return console.warn(`${n} as been renamed to ${l}, please update your imports`),s+l+d}c(o){return o.replace(/\\/g,"/")}};$=w=Ye([Ve(0,c.$eQ)],$);class f{constructor(o,t,s,n,d){this.c=o,this.d=t,this.e=s,this.f=n,this.g=d,this.nodeModuleName="vscode",this.a=new R.$pn}load(o,t){const s=this.d.findSubstr(t);if(s){let n=this.a.get(s.identifier);return n||(n=this.c(s,this.e,this.f),this.a.set(s.identifier,n)),n}if(!this.b){let n="";this.d.forEach((d,l)=>n+=`	${l} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${n}`),this.b=this.c(L.$YG,this.e,this.f)}return this.b}}let g=class{constructor(o,t,s){this.e=o,this.f=t,this.nodeModuleName=["open","opn"],this.d=s.getProxy(C.$sN.MainThreadTelemetry);const n=s.getProxy(C.$sN.MainThreadWindow);this.c=(d,l)=>{const m=h.URI.parse(d);return l?this.g(d,l):m.scheme==="http"||m.scheme==="https"?n.$openUri(m,d,{allowTunneling:!0}):m.scheme==="mailto"||m.scheme===this.f?n.$openUri(m,d,{}):this.g(d,l)}}load(o,t,s){const n=this.e.findSubstr(t);return n&&(this.a=n.identifier.value,this.h()),this.b=s(o),this.c}g(o,t){return this.i(),this.b(o,t)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};g=Ye([Ve(2,b.$1P)],g)}),define(ke[64],Ie([1,0,49,3,16,55,5,63,77,54,9,48,266,41]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rpc=e.$qpc=void 0,C=Ue(C),T=Ue(T),e.$qpc=(0,L.$Ci)("IExtHostVariableResolverProvider");class w extends u.$5Q{constructor(f,g,i,o,t,s,n){function d(){if(i){const l=i.activeEditor();if(l)return l.document.uri;const m=o.tabGroups.all.find(E=>E.isActive)?.activeTab;if(m!==void 0){if(m.input instanceof I.$gP||m.input instanceof I.$lP)return m.input.modified;if(m.input instanceof I.$fP||m.input instanceof I.$kP||m.input instanceof I.$iP)return m.input.uri}}}super({getFolderUri:l=>{const m=s.folders.filter(E=>E.name===l);if(m&&m.length>0)return m[0].uri},getWorkspaceFolderCount:()=>s.folders.length,getConfigurationValue:(l,m)=>t.getConfiguration(void 0,l).get(m),getAppRoot:()=>T.cwd(),getExecPath:()=>T.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=d();if(l)return C.$gc(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(g){const l=d();if(l){const m=g.getWorkspaceFolder(l);if(m)return C.$gc(m.uri.fsPath)}}},getSelectedText:()=>{if(i){const l=i.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(i){const l=i.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>f.getExtension(l)},void 0,n?Promise.resolve(n):void 0,Promise.resolve(T.env))}}let a=class extends h.$Tc{constructor(f,g,i,o,t){super(),this.b=f,this.c=g,this.g=i,this.h=o,this.j=t,this.a=new r.$T(async()=>{const s=await this.h.getConfigProvider(),d={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{d.folders=await this.c.getWorkspaceFolders2()||[]})),new w(this.b,this.c,this.g,this.j,s,d,this.m())})}getResolver(){return this.a.value}m(){}};e.$rpc=a,e.$rpc=a=Ye([Ve(0,c.$npc),Ve(1,D.$Joc),Ve(2,R.$_P),Ve(3,P.$Moc),Ve(4,b.$Yoc)],a)}),define(ke[101],Ie([1,0,7,4,2,3,23,5,6,77,54,19,9,48,154,119,257,41,64,50,34,15,18,98]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a,$,f,g,i,o,t,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bpc=e.$Apc=e.$zpc=e.$ypc=e.$xpc=void 0,t=Ue(t),e.$xpc=(0,R.$Ci)("IExtHostDebugService");let d=class extends T.$Tc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(A,p,v,F,N,O,j,z){super(),this.Y=p,this.Z=v,this.$=F,this.ab=N,this.bb=O,this.cb=j,this.db=z,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new h.$je),this.z=this.B(new h.$je),this.C=this.B(new h.$je),this.F=this.B(new h.$je),this.u=A.getProxy(b.$sN.MainThreadDebugService),this.I=this.B(new h.$je),this.L=this.B(new h.$je),this.G=new m(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(M=>{this.B(M.onDidChange(V=>{this.fb(M)})),this.fb(M)})}async $getVisualizerTreeItem(A,p){const v=this.gb(p);if(!v)return;const F=await this.Q.get(A)?.getTreeItem?.(v);return F?this.eb(A,F):void 0}registerDebugVisualizationTree(A,p,v){const F=L.$nn.toKey(A.identifier),N=this.ub(F,p);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${p}' is already registered`);return this.Q.set(N,v),this.u.$registerDebugVisualizerTree(N,!!v.editItem),(0,T.$Rc)(()=>{this.u.$unregisterDebugVisualizerTree(N),this.Q.delete(p)})}async $getVisualizerTreeItemChildren(A,p){const v=this.S.get(p)?.item;return v?(await this.Q.get(A)?.getChildren?.(v))?.map(N=>this.eb(A,N))||[]:[]}async $editVisualizerTreeItem(A,p){const v=this.S.get(A);if(!v)return;const F=await this.Q.get(v.provider)?.editItem?.(v.item,p);return this.eb(v.provider,F||v.item)}$disposeVisualizedTree(A){const p=this.S.get(A);if(!p)return;const v=[p.children];for(const F of v)if(F)for(const N of F)v.push(this.S.get(N)?.children),this.S.delete(N)}eb(A,p){let v=this.R.get(p);return v||(v=this.O++,this.R.set(p,v),this.S.set(v,{provider:A,item:p})),t.DebugTreeItem.from(p,v)}asDebugSourceUri(A,p){const v=A;if(typeof v.sourceReference=="number"&&v.sourceReference>0){let F=`debug:${encodeURIComponent(v.path||"")}`,N="?";return p&&(F+=`${N}session=${encodeURIComponent(p.id)}`,N="&"),F+=`${N}ref=${v.sourceReference}`,C.URI.parse(F)}else{if(v.path)return C.URI.file(v.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(A){const p=[];for(const v of A.getAllExtensionDescriptions())if(v.contributes){const F=v.contributes.debuggers;if(F&&F.length>0)for(const N of F)(0,$.$WH)(N)&&p.push(N.type)}this.u.$registerDebugTypes(p)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const A=[];return this.H.forEach(p=>A.push(p)),A}async $resolveDebugVisualizer(A,p){const v=this.W.get(A);if(!v)throw new Error(`No debug visualizer found with id '${A}'`);let{v:F,provider:N,extensionId:O}=v;if(F.visualization||(F=await N.resolveDebugVisualization?.(F,p)||F,v.v=F),!F.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${N}'`);return this.vb(O,F.visualization)}async $executeDebugVisualizerCommand(A){const p=this.W.get(A);if(!p)throw new Error(`No debug visualizer found with id '${A}'`);const v=p.v.visualization;v&&"command"in v&&this.cb.executeCommand(v.command,...v.arguments||[])}gb(A){const p=this.w.get(A.sessionId);return p&&{session:p.api,variable:A.variable,containerId:A.containerId,frameId:A.frameId,threadId:A.threadId}}async $provideDebugVisualizers(A,p,v,F){const N=this.gb(v),O=this.ub(A,p),j=this.P.get(O);if(!N||!j)return[];const z=await j.provideDebugVisualization(N,F);return z?z.map(M=>{const V=++this.X;this.W.set(V,{v:M,provider:j,extensionId:A});const K=M.iconPath?this.wb(M.iconPath):void 0;return{id:V,name:M.name,iconClass:K?.iconClass,iconPath:K?.iconPath,visualization:this.vb(A,M.visualization)}}):[]}$disposeDebugVisualizers(A){for(const p of A)this.W.delete(p)}registerDebugVisualizationProvider(A,p,v){if(!A.contributes?.debugVisualizers?.some(O=>O.id===p))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${p})`);const F=L.$nn.toKey(A.identifier),N=this.ub(F,p);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${p}' is already registered`);return this.P.set(N,v),this.u.$registerDebugVisualizer(F,p),(0,T.$Rc)(()=>{this.u.$unregisterDebugVisualizer(F,p),this.P.delete(p)})}addBreakpoints(A){const p=A.filter(N=>{const O=N.id;return this.H.has(O)?!1:(this.H.set(O,N),!0)});this.rb(p,[],[]);const v=[],F=new Map;for(const N of p)if(N instanceof u.$wO){let O=F.get(N.location.uri.toString());O||(O={type:"sourceMulti",uri:N.location.uri,lines:[]},F.set(N.location.uri.toString(),O),v.push(O)),O.lines.push({id:N.id,enabled:N.enabled,condition:N.condition,hitCondition:N.hitCondition,logMessage:N.logMessage,line:N.location.range.start.line,character:N.location.range.start.character,mode:N.mode})}else N instanceof u.$xO&&v.push({type:"function",id:N.id,enabled:N.enabled,hitCondition:N.hitCondition,logMessage:N.logMessage,condition:N.condition,functionName:N.functionName,mode:N.mode});return this.u.$registerBreakpoints(v)}removeBreakpoints(A){const p=A.filter(O=>this.H.delete(O.id));this.rb([],p,[]);const v=p.filter(O=>O instanceof u.$wO).map(O=>O.id),F=p.filter(O=>O instanceof u.$xO).map(O=>O.id),N=p.filter(O=>O instanceof u.$yO).map(O=>O.id);return this.u.$unregisterBreakpoints(v,F,N)}startDebugging(A,p,v){const F=v.testRun&&this.db.getMetadataForRun(v.testRun);return this.u.$startDebugging(A?A.uri:void 0,p,{parentSessionID:v.parentSession?v.parentSession.id:void 0,lifecycleManagedByParent:v.lifecycleManagedByParent,repl:v.consoleMode===u.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:v.noDebug,compact:v.compact,suppressSaveBeforeStart:v.suppressSaveBeforeStart,testRun:F&&{runId:F.runId,taskId:F.taskId},suppressDebugStatusbar:v.suppressDebugStatusbar??v.debugUI?.simple,suppressDebugToolbar:v.suppressDebugToolbar??v.debugUI?.simple,suppressDebugView:v.suppressDebugView??v.debugUI?.simple})}stopDebugging(A){return this.u.$stopDebugging(A?A.id:void 0)}registerDebugConfigurationProvider(A,p,v){if(!p)return new u.$uN(()=>{});const F=this.f++;return this.g.push({type:A,handle:F,provider:p}),this.u.$registerDebugConfigurationProvider(A,v,!!p.provideDebugConfigurations,!!p.resolveDebugConfiguration,!!p.resolveDebugConfigurationWithSubstitutedVariables,F),new u.$uN(()=>{this.g=this.g.filter(N=>N.provider!==p),this.u.$unregisterDebugConfigurationProvider(F)})}registerDebugAdapterDescriptorFactory(A,p,v){if(!v)return new u.$uN(()=>{});if(!this.nb(A,p))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${p}' debugger.`);if(this.kb(p))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const F=this.h++;return this.j.push({type:p,handle:F,factory:v}),this.u.$registerDebugAdapterDescriptorFactory(p,F),new u.$uN(()=>{this.j=this.j.filter(N=>N.factory!==v),this.u.$unregisterDebugAdapterDescriptorFactory(F)})}registerDebugAdapterTrackerFactory(A,p){if(!p)return new u.$uN(()=>{});const v=this.m++;return this.n.push({type:A,handle:v,factory:p}),new u.$uN(()=>{this.n=this.n.filter(F=>F.factory!==p)})}async $runInTerminal(A,p){return Promise.resolve(void 0)}async $substituteVariables(A,p){let v;const F=await this.tb(A);return F&&(v={uri:F.uri,name:F.name,index:F.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(v,p)}hb(A,p){if(A.type==="implementation")return new S(A.implementation)}ib(){}async $startDASession(A,p){const v=this,F=await this.sb(p);return this.pb(this.kb(F.type),F).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${F.type}' (extension might have failed to activate)`);const O=this.jb(N),j=this.hb(O,F);if(!j)throw new Error(`Couldn't create a debug adapter for type '${F.type}'.`);const z=j;return this.M.set(A,z),this.ob(F).then(M=>(M&&this.N.set(A,M),z.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const K=V,ne={type:"response",seq:0,command:K.command,request_seq:K.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const B=await this.U.sign(K.arguments.value);ne.body={signature:B},z.sendResponse(ne)}else throw new Error("no signer")}catch(B){ne.success=!1,ne.message=B.message,z.sendResponse(ne)}}else M&&M.onDidSendMessage&&M.onDidSendMessage(V),V=(0,$.$2H)(V,!0),v.u.$acceptDAMessage(A,V)}),z.onError(V=>{M&&M.onError&&M.onError(V),this.u.$acceptDAError(A,V.name,V.message,V.stack)}),z.onExit(V=>{M&&M.onExit&&M.onExit(V??void 0,void 0),this.u.$acceptDAExit(A,V??void 0,void 0)}),M&&M.onWillStartSession&&M.onWillStartSession(),z.startSession()))})}$sendDAMessage(A,p){p=(0,$.$1H)(p,!1);const v=this.N.get(A);v&&v.onWillReceiveMessage&&v.onWillReceiveMessage(p),this.M.get(A)?.sendMessage(p)}$stopDASession(A){const p=this.N.get(A);this.N.delete(A),p&&p.onWillStopSession&&p.onWillStopSession();const v=this.M.get(A);return this.M.delete(A),v?v.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(A){const p=[],v=[],F=[];if(A.added)for(const N of A.added){const O=N.id;if(O&&!this.H.has(O)){let j;if(N.type==="function")j=new u.$xO(N.functionName,N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode);else if(N.type==="data")j=new u.$yO(N.label,N.dataId,N.canPersist,N.enabled,N.hitCondition,N.condition,N.logMessage,N.mode);else{const z=C.URI.revive(N.uri);j=new u.$wO(new u.$GN(z,new u.$vN(N.line,N.character)),N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode)}(0,u.$uO)(j,O),this.H.set(O,j),p.push(j)}}if(A.removed)for(const N of A.removed){const O=this.H.get(N);O&&(this.H.delete(N),v.push(O))}if(A.changed){for(const N of A.changed)if(N.id){const O=this.H.get(N.id);if(O){if(O instanceof u.$xO&&N.type==="function"){const j=O;j.enabled=N.enabled,j.condition=N.condition,j.hitCondition=N.hitCondition,j.logMessage=N.logMessage,j.functionName=N.functionName}else if(O instanceof u.$wO&&N.type==="source"){const j=O;j.enabled=N.enabled,j.condition=N.condition,j.hitCondition=N.hitCondition,j.logMessage=N.logMessage,j.location=new u.$GN(C.URI.revive(N.uri),new u.$vN(N.line,N.character))}F.push(O)}}}this.rb(p,v,F)}async $acceptStackFrameFocus(A){let p;if(A){const v=await this.sb(A.sessionId);A.kind==="thread"?p=new u.$EO(v.api,A.threadId):p=new u.$DO(v.api,A.threadId,A.frameId)}this.J=p,this.L.fire(this.J)}$provideDebugConfigurations(A,p,v){return(0,r.$uh)(async()=>{const F=this.mb(A);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const N=await this.tb(p);return F.provideDebugConfigurations(N,v)}).then(F=>{if(!F)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return F})}$resolveDebugConfiguration(A,p,v,F){return(0,r.$uh)(async()=>{const N=this.mb(A);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const O=await this.tb(p);return N.resolveDebugConfiguration(O,v,F)})}$resolveDebugConfigurationWithSubstitutedVariables(A,p,v,F){return(0,r.$uh)(async()=>{const N=this.mb(A);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const O=await this.tb(p);return N.resolveDebugConfigurationWithSubstitutedVariables(O,v,F)})}async $provideDebugAdapter(A,p){const v=this.lb(A);if(!v)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const F=await this.sb(p);return this.pb(v,F).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${F.type}'`);return this.jb(N)})}async $acceptDebugSessionStarted(A){const p=await this.sb(A);this.y.fire(p.api)}async $acceptDebugSessionTerminated(A){const p=await this.sb(A);p&&(this.z.fire(p.api),this.w.delete(p.id))}async $acceptDebugSessionActiveChanged(A){this.D=A?await this.sb(A):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(A,p){(await this.sb(A))?._acceptNameChanged(p)}async $acceptDebugSessionCustomEvent(A,p){const F={session:(await this.sb(A)).api,event:p.event,body:p.body};this.F.fire(F)}jb(A){if(A instanceof u.$zO)return{type:"executable",command:A.command,args:A.args,options:A.options};if(A instanceof u.$AO)return{type:"server",port:A.port,host:A.host};if(A instanceof u.$BO)return{type:"pipeServer",path:A.path};if(A instanceof u.$CO)return{type:"implementation",implementation:A.implementation};throw new Error("convertToDto unexpected type")}kb(A){const p=this.j.filter(v=>v.type===A);if(p.length>0)return p[0].factory}lb(A){const p=this.j.filter(v=>v.handle===A);if(p.length>0)return p[0].factory}mb(A){const p=this.g.filter(v=>v.handle===A);if(p.length>0)return p[0].provider}nb(A,p){if(A.contributes){const v=A.contributes.debuggers;if(v&&v.length>0){for(const F of v)if(F.label&&F.type&&F.type===p)return!0}}return!1}ob(A){const v=A.configuration.type,F=this.n.filter(N=>N.type===v||N.type==="*").map(N=>(0,r.$uh)(()=>N.factory.createDebugAdapterTracker(A.api)).then(O=>O,O=>null));return Promise.race([Promise.all(F).then(N=>{const O=(0,s.$Gb)(N);if(O.length>0)return new E(O)}),new Promise(N=>setTimeout(()=>N(void 0),1e3))]).catch(N=>{})}async pb(A,p){const v=p.configuration.debugServer;if(typeof v=="number")return Promise.resolve(new u.$AO(v));if(A){const N=await this.Z.getExtensionRegistry();return(0,r.$uh)(()=>A.createDebugAdapterDescriptor(p.api,this.qb(p,N))).then(O=>{if(O)return O})}const F=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb(p,F))}qb(A,p){}rb(A,p,v){(A.length>0||p.length>0||v.length>0)&&this.I.fire(Object.freeze({added:A,removed:p,changed:v}))}async sb(A){if(A)if(typeof A=="string"){const p=this.w.get(A);if(p)return p}else{let p=this.w.get(A.id);if(!p){const v=await this.tb(A.folderUri),F=A.parent?this.w.get(A.parent):void 0;p=new l(this.u,A.id,A.type,A.name,v,A.configuration,F?.api),this.w.set(p.id,p),this.u.$sessionCached(p.id)}return p}throw new Error("cannot find session")}tb(A){if(A){const p=C.URI.revive(A);return this.Y.resolveWorkspaceFolder(p)}return Promise.resolve(void 0)}ub(A,p){return`${A}\0${p}`}vb(A,p){if(p){if("title"in p&&"command"in p)return{type:a.DebugVisualizationType.Command};if("treeId"in p)return{type:a.DebugVisualizationType.Tree,id:`${A}\0${p.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(A){const p=this.xb(A);let v,F;return"id"in p?F=i.ThemeIcon.asClassName(p):v=p,{iconPath:v,iconClass:F}}xb(A){if(A instanceof u.$rO)return{id:A.id};const p=typeof A=="object"&&"dark"in A?A.dark:A,v=typeof A=="object"&&"light"in A?A.light:A;return{dark:typeof p=="string"?C.URI.file(p):p,light:typeof v=="string"?C.URI.file(v):v}}};e.$ypc=d,e.$ypc=d=Ye([Ve(0,D.$1P),Ve(1,P.$Joc),Ve(2,I.$npc),Ve(3,f.$Moc),Ve(4,c.$Yoc),Ve(5,g.$qpc),Ve(6,o.$kQ),Ve(7,n.$spc)],d);class l{constructor(A,p,v,F,N,O,j){this.f=A,this.g=p,this.h=v,this.j=F,this.k=N,this.l=O,this.m=j}get api(){const A=this;return this.d??=Object.freeze({id:A.g,type:A.h,get name(){return A.j},set name(p){A.j=p,A.f.$setDebugSessionName(A.g,p)},parentSession:A.m,workspaceFolder:A.k,configuration:A.l,customRequest(p,v){return A.f.$customDebugAdapterRequest(A.g,p,v)},getDebugProtocolBreakpoint(p){return A.f.$getDebugProtocolBreakpoint(A.g,p.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(A){this.j=A}get configuration(){return this.l}}e.$zpc=l;class m{constructor(A){this.value=Object.freeze({append(p){A.$appendDebugConsole(p)},appendLine(p){this.append(p+`
`)}})}}e.$Apc=m;class E{constructor(A){this.d=A}onWillStartSession(){this.d.forEach(A=>A.onWillStartSession?A.onWillStartSession():void 0)}onWillReceiveMessage(A){this.d.forEach(p=>p.onWillReceiveMessage?p.onWillReceiveMessage(A):void 0)}onDidSendMessage(A){this.d.forEach(p=>p.onDidSendMessage?p.onDidSendMessage(A):void 0)}onWillStopSession(){this.d.forEach(A=>A.onWillStopSession?A.onWillStopSession():void 0)}onError(A){this.d.forEach(p=>p.onError?p.onError(A):void 0)}onExit(A,p){this.d.forEach(v=>v.onExit?v.onExit(A,p):void 0)}}class S extends w.$Htb{constructor(A){super(),this.h=A,A.onDidSendMessage(p=>{this.acceptMessage(p)})}startSession(){return Promise.resolve(void 0)}sendMessage(A){this.h.handleMessage(A)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let y=class extends d{constructor(A,p,v,F,N,O,j,z){super(A,p,v,F,N,O,j,z)}};e.$Bpc=y,e.$Bpc=y=Ye([Ve(0,D.$1P),Ve(1,P.$Joc),Ve(2,I.$npc),Ve(3,f.$Moc),Ve(4,c.$Yoc),Ve(5,g.$qpc),Ve(6,o.$kQ),Ve(7,n.$spc)],y)}),define(ke[339],Ie([1,0,13,61,2,6,287,11,88,114,29,224,19,72,54,94]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cqc=e.$Bqc=void 0,r=Ue(r),h=Ue(h);class ${static async installEarlyHandler(i){Error.stackTraceLimit=100;const o=i.get(R.$9j),s=i.get(u.$1P).getProxy(T.$sN.MainThreadErrors);r.setUnexpectedErrorHandler(n=>{o.error(n);const d=r.$1(n);s.$onUnexpectedError(d)})}static async installFullHandler(i){const o=i.get(R.$9j),t=i.get(u.$1P),s=i.get(w.$npc),n=i.get(a.$iQ),d=t.getProxy(T.$sN.MainThreadExtensionService),l=t.getProxy(T.$sN.MainThreadErrors),m=await s.getExtensionPathIndex(),E=new WeakMap;function S(A,p){if(E.has(A))return E.get(A).stack;let v="",F,N;for(const j of p)v+=`
	at ${j.toString()}`,N=j.getFileName(),!F&&N&&(F=m.findSubstr(C.URI.file(N)));const O=`${A.name||"Error"}: ${A.message||""}${v}`;return E.set(A,{extensionIdentifier:F?.identifier,stack:O}),O}const y=Symbol("prepareStackTrace wrapped");let k=S;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return k},set(A){if(A===S||!A||A[y]){k=A||S;return}k=function(p,v){return S(p,v),A.call(Error,p,v)},Object.assign(k,{[y]:!0})}}),r.setUnexpectedErrorHandler(A=>{o.error(A);const p=r.$1(A),v=E.get(A);if(!v?.extensionIdentifier){l.$onUnexpectedError(p);return}d.$onExtensionRuntimeError(v.extensionIdentifier,p);const F=n.onExtensionError(v.extensionIdentifier,A);o.trace("forwarded error to extension?",F,v)})}}e.$Bqc=$;class f{constructor(i,o,t,s,n){this.a=t,this.b=new L.$Wcc(i,null,s),o=f.e(o,this.b);const d=new c.$Ai(...(0,b.$Os)());d.set(I.$eQ,{_serviceBrand:void 0,...o,messagePorts:n}),d.set(u.$1P,new u.$2P(this.b)),d.set(P.$Goc,new P.$Hoc(s)),d.set(w.$lpc,t);const l=new D.$sr(d,!0);l.invokeFunction($.installEarlyHandler),this.d=l.invokeFunction(m=>m.get(R.$9j)),h.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",o),this.c=l.invokeFunction(m=>m.get(w.$npc)),this.c.initialize(),l.invokeFunction($.installFullHandler)}async asBrowserUri(i){const o=this.b.getProxy(T.$sN.MainThreadExtensionService);return C.URI.revive(await o.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,o){i.extensions.allExtensions.forEach(s=>{s.extensionLocation=C.URI.revive(o.transformIncomingURIs(s.extensionLocation))}),i.environment.appRoot=C.URI.revive(o.transformIncomingURIs(i.environment.appRoot));const t=i.environment.extensionDevelopmentLocationURI;return t&&(i.environment.extensionDevelopmentLocationURI=t.map(s=>C.URI.revive(o.transformIncomingURIs(s)))),i.environment.extensionTestsLocationURI=C.URI.revive(o.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=C.URI.revive(o.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=C.URI.revive(o.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=C.URI.revive(o.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=C.URI.revive(o.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=C.URI.revive(o.transformIncomingURIs(i.logsLocation)),i.workspace=o.transformIncomingURIs(i.workspace),i}}e.$Cqc=f}),define(ke[340],Ie([1,0,7,10,8,217,148,101,77,54,19,47,9,64,48,258,259,41,34,98]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a,$,f,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mqc=void 0,h=Ue(h),C=Ue(C);let o=class extends R.$ypc{constructor(l,m,E,S,y,k,A,p,v){super(l,m,E,S,k,A,p,v),this.Ab=y,this.yb=new n}hb(l,m){switch(l.type){case"server":return new a.$Hqc(l);case"pipeServer":return new a.$Iqc(l);case"executable":return new a.$Jqc(l,m.type)}return super.hb(l,m)}qb(l,m){const E=a.$Jqc.platformAdapterExecutable(m.getAllExtensionDescriptions(),l.type);if(E)return new u.$zO(E.command,E.args,E.options)}ib(){return new L.$Ugc}async $runInTerminal(l,m){if(l.kind==="integrated"){this.zb||(this.zb=this.B(this.Ab.onDidCloseTerminal(z=>{this.yb.onTerminalClosed(z)})));const E=await this.$.getConfigProvider(),S=this.Ab.getDefaultShell(!0),y=this.Ab.getDefaultShellArgs(!0),k=l.title||C.localize(10642,null),A=JSON.stringify({shell:S,shellArgs:y});let p=await this.yb.checkout(A,k),v,F=!1;if(p)v=l.cwd;else{const z={shellPath:S,shellArgs:y,cwd:l.cwd,name:k,iconPath:new u.$rO("debug")};F=!0,p=this.Ab.createTerminalFromOptions(z,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.yb.insert(p,A)}p.show(!0);const N=await p.processId;F?await new Promise(z=>setTimeout(z,1e3)):(p.state.isInteractedWith&&(p.sendText(""),await(0,r.$Dh)(200)),E.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(S.indexOf("powershell")>=0||S.indexOf("pwsh")>=0||S.indexOf("cmd.exe")>=0?p.sendText("cls"):S.indexOf("bash")>=0?p.sendText("clear"):h.$j?p.sendText("cls"):p.sendText("clear")));const O=(0,$.$Lqc)(S,l.args,!!l.argsCanBeInterpretedByShell,v,l.env);p.sendText(O);const j=this.onDidTerminateDebugSession(z=>{z.id===m&&(this.yb.free(p),j.dispose())});return N}else if(l.kind==="external")return s(l,await this.$.getConfigProvider());return super.$runInTerminal(l,m)}};e.$Mqc=o,e.$Mqc=o=Ye([Ve(0,I.$1P),Ve(1,w.$Joc),Ve(2,c.$npc),Ve(3,f.$Moc),Ve(4,D.$$oc),Ve(5,b.$Yoc),Ve(6,P.$qpc),Ve(7,g.$kQ),Ve(8,i.$spc)],o);let t;function s(d,l){if(!t)if(h.$j)t=new T.$Cfc;else if(h.$k)t=new T.$Dfc;else if(h.$l)t=new T.$Efc;else throw new Error("external terminals not supported on this platform");const m=l.getConfiguration("terminal");return t.runInTerminal(d.title,d.cwd,d.args,d.env||{},m.external||{})}class n{constructor(){this.b=new Map}static{this.a=1e3}async checkout(l,m,E=!1){const y=[...this.b.entries()].map(([k,A])=>(0,r.$ph)(async p=>{if(k.name!==m||A.lastUsedAt!==-1&&await(0,$.$Kqc)(await k.processId))return null;const v=Date.now();return A.lastUsedAt+n.a>v||p.isCancellationRequested?null:A.config!==l?(E&&k.dispose(),null):(A.lastUsedAt=v,k)}));return await(0,r.$Hh)(y,k=>!!k)}insert(l,m){this.b.set(l,{lastUsedAt:Date.now(),config:m})}free(l){const m=this.b.get(l);m&&(m.lastUsedAt=-1)}onTerminalClosed(l){this.b.delete(l)}}}),define(ke[341],Ie([1,0,16,2,109,48,63,41,46,47,19,29,100,14,11,95,22,66,64]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a,$,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eqc=void 0,r=Ue(r),$=Ue($);let i=class extends u.$iqc{constructor(t,s,n,d,l,m,E,S,y){super(t,s,n,d,l,m,E,S),this.C=n,this.D=y,s.remote.isRemote&&s.remote.authority?this.registerTaskSystem(P.Schemas.vscodeRemote,{scheme:P.Schemas.vscodeRemote,authority:s.remote.authority,platform:process.platform}):this.registerTaskSystem(P.Schemas.file,{scheme:P.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,s){const n=s;if(!s.execution&&n._id===void 0)throw new Error("Tasks to execute must include an execution");if(n._id!==void 0){const d=u.TaskHandleDTO.from(n,this.C),l=await this.a.$getTaskExecution(d);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const m=await this.z(l,s);return this.a.$executeTask(d).catch(()=>{}),m}else{const d=u.TaskDTO.from(s,t);if(d===void 0)return Promise.reject(new Error("Task is not valid"));u.CustomExecutionDTO.is(d.execution)&&await this.y(d,s,!1);const l=await this.z(await this.a.$getTaskExecution(d),s);return this.a.$executeTask(d).catch(()=>{}),l}}v(t,s,n,d){const l=[];if(d)for(const m of d){this.A(m,n),(!m.definition||!t[m.definition.type])&&this.f.warn(`The task [${m.source}, ${m.name}] uses an undefined task type. The task will be ignored in the future.`);const E=u.TaskDTO.from(m,n.extension);E&&(l.push(E),u.CustomExecutionDTO.is(E.execution)&&s.push(this.y(E,m,!0)))}return{tasks:l,extension:n.extension}}async w(t){return t}async G(t){let s=t&&t.length>0?t[0]:void 0;if(!s){const n=h.URI.file((0,f.homedir)());s=new b.$Wi({uri:n,name:$.$ah(n),index:0})}return{uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,s){const n=h.URI.revive(t),d={process:void 0,variables:Object.create(null)},l=await this.b.resolveWorkspaceFolder(n),m=await this.b.getWorkspaceFolders2()??[],E=await this.D.getResolver(),S=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(m);for(const y of s.variables)d.variables[y]=await E.resolveAsync(S,y);if(s.process!==void 0){let y;if(s.process.path!==void 0){y=s.process.path.split(r.$sc);for(let k=0;k<y.length;k++)y[k]=await E.resolveAsync(S,y[k])}d.process=await C.win32.findExecutable(await E.resolveAsync(S,s.process.name),s.process.cwd!==void 0?await E.resolveAsync(S,s.process.cwd):void 0,y)}return d}async $jsonTasksSupported(){return!0}async $findExecutable(t,s,n){return C.win32.findExecutable(t,s,n)}};e.$Eqc=i,e.$Eqc=i=Ye([Ve(0,I.$1P),Ve(1,D.$eQ),Ve(2,T.$Joc),Ve(3,L.$_P),Ve(4,R.$Moc),Ve(5,c.$$oc),Ve(6,w.$9j),Ve(7,a.$noc),Ve(8,g.$qpc)],i)}),define(ke[342],Ie([1,0,66,64]),function(me,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$krc=void 0;class C extends h.$rpc{m(){return(0,r.homedir)()}}e.$krc=C}),define(ke[171],Ie([1,0,18,7,20,52,14,16,22,2,37]),function(me,e,r,h,C,T,L,R,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Spc=e.$Qpc=e.$Ppc=void 0,e.$Rpc=a,R=Ue(R),b=Ue(b);class D{constructor(g,i,o){this.d=g,this.e=i,this.f=o,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(g,i){const o=this.g.folderQueries||[],t=new C.$ue(i);return new Promise((s,n)=>{this.a=new P(g);let d=!1;const l=(m,E)=>{if(!d&&!this.b){const S=this.h(m);a(m)&&typeof this.g.maxResults=="number"&&this.c+S>this.g.maxResults&&(this.b=!0,d=!0,t.cancel(),m=this.j(m,this.g.maxResults-this.c));const y=this.h(m);this.c+=y,(y>0||!a(m))&&this.a.add(m,E)}};Promise.all(o.map((m,E)=>this.k(m,S=>l(S,E),t.token))).then(m=>{t.dispose(),this.a.flush();const E=m.some(S=>!!S&&!!S.limitHit);s({limitHit:this.b||E,messages:m.flatMap(S=>S?.message?Array.isArray(S.message)?S.message:[S.message]:[]),stats:{type:this.f}})},m=>{t.dispose();const E=(0,T.$nj)(m);n(new Error(E))})})}h(g){return a(g)?Array.isArray(g.ranges)?g.ranges.length:1:0}j(g,i){const o=Array.isArray(g.ranges)?g.ranges:[g.ranges],t=Array.isArray(g.preview.matches)?g.preview.matches:[g.preview.matches];return{ranges:o.slice(0,i),preview:{matches:t.slice(0,i),text:g.preview.text},uri:g.uri}}async k(g,i,o){const t=new I.$9L(this.g,g),s=[],n={report:m=>{if(!this.l(m))return;const E=g.folder.scheme===L.Schemas.file?(0,I.$0L)(()=>this.e.readdir(b.$ch(m.uri))):void 0,S=b.$fh(g.folder,m.uri);if(S){const y=t.includedInQuery(S,R.$mc(S),E);(0,h.$oh)(y)?s.push(y.then(k=>{k&&i(m)})):y&&i(m)}}},d=this.n(g);let l;return this.d.query.type===I.QueryType.aiText?l=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,d,n,o):l=await this.d.provider.provideTextSearchResults(u(this.d.query.contentPattern),d,n,o),s.length&&await Promise.all(s),l}l(g){if(a(g)){if(Array.isArray(g.ranges)){if(!Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(g.preview.matches.length!==g.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(g){const i=(0,I.$8L)(this.g.includePattern,g.includePattern),o=(0,I.$8L)(this.g.excludePattern,g.excludePattern),t={folder:c.URI.from(g.folder),excludes:o,includes:i,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,encoding:g.fileEncoding&&this.e.toCanonicalName(g.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??I.$OL,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(t.usePCRE2=this.g.usePCRE2),t}}e.$Ppc=D;function u(f){return{isCaseSensitive:f.isCaseSensitive||!1,isRegExp:f.isRegExp||!1,isWordMatch:f.isWordMatch||!1,isMultiline:f.isMultiline||!1,pattern:f.pattern}}class P{constructor(g){this.e=g,this.b=-1,this.d=null,this.a=new $(512,i=>this.g(i))}add(g,i){this.d&&(this.b!==i||!b.$9g(this.c,g.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:g.uri,results:[]}),this.d.results.push(w(g))}f(){const g=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,g)}flush(){this.f(),this.a.flush()}g(g){this.e(g)}}e.$Qpc=P;function w(f){return a(f)?{preview:{matches:(0,r.$Zb)(f.preview.matches,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character})),text:f.preview.text},ranges:(0,r.$Zb)(f.ranges,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character}))}:{text:f.text,lineNumber:f.lineNumber}}function a(f){return!!f.preview}class ${static{this.a=4e3}static{this.b=50}constructor(g,i){this.g=g,this.h=i,this.c=0,this.d=[],this.e=0}addItem(g,i){g&&this.j(g,i)}addItems(g,i){g&&this.k(g,i)}j(g,i){this.d.push(g),this.e+=i,this.l()}k(g,i){this.d=this.d.concat(g),this.e+=i,this.l()}l(){this.c<$.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},$.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Spc=$}),define(ke[102],Ie([1,0,3,6,5,335,19,72,11,2,171]),function(me,e,r,h,C,T,L,R,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Upc=e.$Tpc=void 0,e.$Vpc=u,e.$Tpc=(0,C.$Ci)("IExtHostSearch");let D=class{constructor(a,$,f){this.n=a,this.o=$,this.q=f,this.c=this.n.getProxy(h.$sN.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new T.$Opc}s(a){return this.o.transformOutgoingScheme(a)}registerTextSearchProvider(a,$){if(this.g.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this.g.add(a);const f=this.d++;return this.e.set(f,$),this.c.$registerTextSearchProvider(f,this.s(a)),(0,r.$Rc)(()=>{this.g.delete(a),this.e.delete(f),this.c.$unregisterProvider(f)})}registerAITextSearchProvider(a,$){if(this.i.has(a))throw new Error(`an AI text search provider for the scheme '${a}'is already registered`);this.i.add(a);const f=this.d++;return this.h.set(f,$),this.c.$registerAITextSearchProvider(f,this.s(a)),(0,r.$Rc)(()=>{this.i.delete(a),this.h.delete(f),this.c.$unregisterProvider(f)})}registerFileSearchProvider(a,$){if(this.k.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this.k.add(a);const f=this.d++;return this.j.set(f,$),this.c.$registerFileSearchProvider(f,this.s(a)),(0,r.$Rc)(()=>{this.k.delete(a),this.j.delete(f),this.c.$unregisterProvider(f)})}$provideFileSearchResults(a,$,f,g){const i=u(f),o=this.j.get(a);if(o)return this.l.fileSearch(i,o,t=>{this.c.$handleFileMatch(a,$,t.map(s=>s.resource))},g);throw new Error("3 unknown provider: "+a)}async doInternalFileSearchWithCustomCallback(a,$,f){return{messages:[]}}$clearCache(a){return this.l.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,$,f,g){const i=this.e.get(a);if(!i||!i.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${a}`);const o=u(f);return this.t(o,i).search(s=>this.c.$handleTextMatch(a,$,s),g)}$provideAITextSearchResults(a,$,f,g){const i=this.h.get(a);if(!i||!i.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${a}`);const o=u(f);return this.v(o,i).search(s=>this.c.$handleTextMatch(a,$,s),g)}$enableExtensionHostSearch(){}t(a,$){return new I.$Ppc({query:a,provider:$},{readdir:f=>Promise.resolve([]),toCanonicalName:f=>f},"textSearchProvider")}v(a,$){return new I.$Ppc({query:a,provider:$},{readdir:f=>Promise.resolve([]),toCanonicalName:f=>f},"aiTextSearchProvider")}};e.$Upc=D,e.$Upc=D=Ye([Ve(0,L.$1P),Ve(1,R.$Goc),Ve(2,b.$9j)],D);function u(w){return{...w,folderQueries:w.folderQueries&&w.folderQueries.map(P),extraFileResources:w.extraFileResources&&w.extraFileResources.map(a=>c.URI.revive(a))}}function P(w){return{...w,folder:c.URI.revive(w.folder)}}});var zt=this&&this.__importDefault||function(me){return me&&me.__esModule?me:{default:me}};define(ke[343],Ie([1,0,20,13,4,3,14,43,2,113,200,201,58,23,27,11,90,91,245,6,289,316,95,127,293,294,295,274,264,34,296,41,297,101,163,298,276,290,299,300,63,77,277,291,54,301,75,302,62,29,317,278,303,304,128,305,122,123,279,334,307,249,308,318,309,169,280,310,311,312,19,313,102,124,314,281,315,125,97,100,94,47,167,98,319,292,320,321,76,15,9,282,72,283,96,322,323,162,48,119,93,25,99]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a,$,f,g,i,o,t,s,n,d,l,m,E,S,y,k,A,p,v,F,N,O,j,z,M,V,K,ne,B,G,Y,ee,ue,re,ye,$e,J,W,se,ae,te,ce,le,Z,oe,pe,we,Fe,We,Se,De,Te,U,q,X,_,de,be,Ne,Ge,Ke,tt,rt,ot,nt,at,mt,ht,ct,Pe,ze,He,Oe,je,he,x,Ce,Xe,et,ut,gt,Dt,Ot,Ut,ui,ti,_e,Kt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wqc=Qt,h=Ue(h),R=zt(R),D=Ue(D),w=Ue(w),he=Ue(he),x=Ue(x);function Qt(pt){const Pt=pt.get(ye.$eQ),ii=pt.get(re.$roc),Zt=pt.get(ee.$Ooc),qt=pt.get(G.$npc),vt=pt.get(Ut.$Joc),Nt=pt.get(at.$iQ),hi=pt.get(A.$Moc),Vt=pt.get(Xe.$Goc),xe=pt.get(_.$1P),xt=pt.get(rt.$8oc),ni=pt.get(ot.$Poc),di=pt.get(a.$0j),kt=pt.get(a.$9j),Ft=pt.get(je.$SFb),Rt=pt.get(s.$noc),Bt=pt.get(Ot.$vqc),ri=pt.get(Ne.$fpc),_t=pt.get(K.$Yoc),si=pt.get(le.$jpc),Gt=pt.get(n.$xoc),Jt=pt.get(ae.$cpc);xe.set(i.$tN.ExtHostFileSystemInfo,ii),xe.set(i.$tN.ExtHostLogLevelServiceShape,di),xe.set(i.$tN.ExtHostWorkspace,vt),xe.set(i.$tN.ExtHostConfiguration,hi),xe.set(i.$tN.ExtHostExtensionService,qt),xe.set(i.$tN.ExtHostStorage,xt),xe.set(i.$tN.ExtHostTunnelService,Ft),xe.set(i.$tN.ExtHostWindow,Bt),xe.set(i.$tN.ExtHostSecretState,ri),xe.set(i.$tN.ExtHostTelemetry,Nt),xe.set(i.$tN.ExtHostEditorTabs,_t),xe.set(i.$tN.ExtHostManagedSockets,si),xe.set(i.$tN.ExtHostAuthentication,Gt),xe.set(i.$tN.ExtHostChatProvider,Jt);const oi=xe.set(i.$tN.ExtHostDecorations,pt.get(F.$Dpc)),At=xe.set(i.$tN.ExtHostDocumentsAndEditors,pt.get(V.$_P)),St=xe.set(i.$tN.ExtHostCommands,pt.get(y.$kQ)),wt=xe.set(i.$tN.ExtHostTerminalService,pt.get(mt.$$oc)),ei=xe.set(i.$tN.ExtHostTerminalShellIntegration,pt.get(ht.$lqc)),It=xe.set(i.$tN.ExtHostDebugService,pt.get(v.$xpc)),fi=xe.set(i.$tN.ExtHostSearch,pt.get(be.$Tpc)),Ht=xe.set(i.$tN.ExtHostTask,pt.get(nt.$kqc)),wi=xe.set(i.$tN.ExtHostOutputService,pt.get(De.$0pc)),vi=xe.set(i.$tN.ExtHostLocalization,pt.get(ce.$ipc)),gi=xe.set(i.$tN.ExtHostUrls,new et.$sqc(xe)),jt=xe.set(i.$tN.ExtHostDocuments,new M.$uoc(xe,At)),ai=xe.set(i.$tN.ExtHostDocumentContentProviders,new j.$Fpc(xe,At,kt)),Pi=xe.set(i.$tN.ExtHostDocumentSaveParticipant,new z.$Gpc(kt,jt,xe.getProxy(i.$sN.MainThreadBulkEdits))),Tt=xe.set(i.$tN.ExtHostNotebook,new oe.$Wpc(xe,St,At,jt,Zt,fi,kt)),Si=xe.set(i.$tN.ExtHostNotebookDocuments,new we.$4pc(Tt)),Ci=xe.set(i.$tN.ExtHostNotebookEditors,new Fe.$5pc(kt,Tt)),Di=xe.set(i.$tN.ExtHostNotebookKernels,new We.$6pc(xe,Pt,Tt,St,kt)),$i=xe.set(i.$tN.ExtHostNotebookRenderers,new Se.$8pc(xe,Tt)),Ai=xe.set(i.$tN.ExtHostNotebookDocumentSaveParticipant,new pe.$3pc(kt,Tt,xe.getProxy(i.$sN.MainThreadBulkEdits))),Wt=xe.set(i.$tN.ExtHostEditors,new Pe.$Doc(xe,At)),Ae=xe.set(i.$tN.ExtHostTreeViews,new Oe.$qqc(xe.getProxy(i.$sN.MainThreadTreeViews),St,kt)),Me=xe.set(i.$tN.ExtHostEditorInsets,new S.$Eoc(xe.getProxy(i.$sN.MainThreadEditorInsets),Wt,Pt.remote)),ve=xe.set(i.$tN.ExtHostDiagnostics,new N.$toc(xe,kt,ii,At)),ie=xe.set(i.$tN.ExtHostLanguages,new te.$1pc(xe,jt,St.converter,Vt)),Re=xe.set(i.$tN.ExtHostLanguageFeatures,new W.$voc(xe,Vt,jt,St,ve,kt,Rt,Nt)),Qe=xe.set(i.$tN.ExtHostFileSystem,new Y.$Jpc(xe,Re)),it=xe.set(i.$tN.ExtHostFileSystemEventService,new ue.$Kpc(xe,kt,At)),Je=xe.set(i.$tN.ExtHostQuickOpen,(0,X.$bqc)(xe,vt,St)),ft=xe.set(i.$tN.ExtHostSCM,new de.$dqc(xe,St,jt,kt)),Ct=xe.set(i.$tN.ExtHostQuickDiff,new q.$aqc(xe,Vt)),Yt=xe.set(i.$tN.ExtHostShare,new Ge.$eqc(xe,Vt)),ci=xe.set(i.$tN.ExtHostComments,(0,k.$Foc)(xe,St,jt)),Mt=xe.set(i.$tN.ExtHostProgress,new U.$_pc(xe.getProxy(i.$sN.MainThreadProgress))),li=xe.set(i.$tN.ExtHostLabelService,new J.$Ypc(xe)),qi=xe.set(i.$tN.ExtHostTheming,new ze.$nqc(xe)),pn=xe.set(i.$tN.ExtHostTimeline,new He.$pqc(xe,St)),Fi=xe.set(i.$tN.ExtHostWebviews,new ut.$Toc(xe,Pt.remote,vt,kt,Rt)),Li=xe.set(i.$tN.ExtHostWebviewPanels,new gt.$Woc(xe,Fi,vt)),Vi=xe.set(i.$tN.ExtHostCustomEditors,new p.$Xoc(xe,jt,ni,Fi,Li)),xi=xe.set(i.$tN.ExtHostWebviewViews,new Dt.$tqc(xe,Fi)),ki=xe.set(i.$tN.ExtHostTesting,pt.get(ct.$spc)),_i=xe.set(i.$tN.ExtHostUriOpeners,new Ce.$rqc(xe)),en=xe.set(i.$tN.ExtHostProfileContentHandlers,new Te.$$pc(xe));xe.set(i.$tN.ExtHostInteractive,new $e.$Xpc(xe,Tt,At,St,kt));const Mi=xe.set(i.$tN.ExtHostChatAgents2,new l.$Aoc(xe,kt,St,jt)),tn=xe.set(i.$tN.ExtHostChatVariables,new m.$Boc(xe)),Gi=xe.set(i.$tN.ExtHostLanguageModelTools,new se.$Zpc(xe)),nn=xe.set(i.$tN.ExtHostAiRelatedInformation,new o.$moc(xe)),Hi=xe.set(i.$tN.ExtHostAiEmbeddingVector,new B.$Ipc(xe)),ji=xe.set(i.$tN.ExtHostStatusBar,new tt.$hqc(xe,St.converter)),bn=xe.set(i.$tN.ExtHostSpeech,new Ke.$fqc(xe)),Oi=xe.set(i.$tN.ExtHostEmbeddings,new ne.$Hpc(xe)),rn=Object.values(i.$tN);xe.assertRegistered(rn);const wn=new d.$zoc(xe,At),Ki=new E.$Coc(xe),zi=new Z.$2pc(xe,kt),Qi=new O.$Epc(xe);return t.$woc.register(St),function(qe,Ei,Bi){function lt(fe){return(Ee,Be,dt)=>{const yt=fe(Lt=>{try{Ee.call(Be,Lt)}catch(Ri){h.$Z(new Error(`[ExtensionListenerError] Extension '${qe.identifier.value}' FAILED to handle event: ${Ri.toString()}`,{cause:Ri})),Nt.onExtensionError(qe.identifier,Ri)}});return dt?.push(yt),yt}}const bt=function(){let fe=!qe.isUnderDevelopment;function Ee(){fe||(kt.info(`Extension '${qe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),fe=!0)}return function Be(dt){if(Array.isArray(dt))dt.forEach(Be);else if(typeof dt=="string")Ee();else{const yt=dt;typeof yt.scheme>"u"&&Ee(),typeof yt.exclusive=="boolean"&&(0,_e.$5G)(qe,"documentFiltersExclusive")}return dt}}(),Wi={getSession(fe,Ee,Be){return typeof Be?.forceNewSession=="object"&&Be.forceNewSession.learnMore&&(0,_e.$5G)(qe,"authLearnMore"),Be?.account&&(0,_e.$5G)(qe,"authGetSessions"),Gt.getSession(qe,fe,Ee,Be)},getAccounts(fe){return(0,_e.$5G)(qe,"authGetSessions"),Gt.getAccounts(fe)},async hasSession(fe,Ee){return(0,_e.$5G)(qe,"authSession"),!!await Gt.getSession(qe,fe,Ee,{silent:!0})},get onDidChangeSessions(){return lt(Gt.onDidChangeSessions)},registerAuthenticationProvider(fe,Ee,Be,dt){return Gt.registerAuthenticationProvider(fe,Ee,Be,dt)}},vn={registerCommand(fe,Ee,Be){return St.registerCommand(!0,fe,Ee,Be,void 0,qe)},registerTextEditorCommand(fe,Ee,Be){return St.registerCommand(!0,fe,(...dt)=>{const yt=Wt.getActiveTextEditor();if(!yt){kt.warn("Cannot execute "+fe+" because there is no active text editor.");return}return yt.edit(Lt=>{Ee.apply(Be,[yt,Lt,...dt])}).then(Lt=>{Lt||kt.warn("Edits from command "+fe+" were not applied.")},Lt=>{kt.warn("An error occurred while running command "+fe,Lt)})},void 0,void 0,qe)},registerDiffInformationCommand:(fe,Ee,Be)=>((0,_e.$5G)(qe,"diffCommand"),St.registerCommand(!0,fe,async(...dt)=>{const yt=At.activeEditor(!0);if(!yt){kt.warn("Cannot execute "+fe+" because there is no active text editor.");return}const Lt=await Wt.getDiffInformation(yt.id);Ee.apply(Be,[Lt,...dt])},void 0,void 0,qe)),executeCommand(fe,...Ee){return St.executeCommand(fe,...Ee)},getCommands(fe=!1){return St.getCommands(fe)}},mi={get machineId(){return Pt.telemetryInfo.machineId},get sessionId(){return Pt.telemetryInfo.sessionId},get language(){return Pt.environment.appLanguage},get appName(){return Pt.environment.appName},get appRoot(){return Pt.environment.appRoot?.fsPath??""},get appHost(){return Pt.environment.appHost},get uriScheme(){return Pt.environment.appUriScheme},get clipboard(){return Ki.value},get shell(){return wt.getDefaultShell(!1)},get onDidChangeShell(){return lt(wt.onDidChangeShell)},get isTelemetryEnabled(){return Nt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return lt(Nt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,_e.$5G)(qe,"telemetry"),Nt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,_e.$5G)(qe,"telemetry"),lt(Nt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,at.$hQ)(Pt.telemetryInfo.firstSessionDate)},createTelemetryLogger(fe,Ee){return at.$gQ.validateSender(fe),Nt.instantiateLogger(qe,fe,Ee)},openExternal(fe,Ee){return Bt.openUri(fe,{allowTunneling:!!Pt.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri(fe){if(fe.scheme===Pt.environment.appUriScheme)return gi.createAppUri(fe);try{return await Bt.asExternalUri(fe,{allowTunneling:!!Pt.remote.authority})}catch(Ee){if((0,L.$Lg)(fe,L.Schemas.http)||(0,L.$Lg)(fe,L.Schemas.https))return fe;throw Ee}},get remoteName(){return(0,$.$en)(Pt.remote.authority)},get remoteAuthority(){return(0,_e.$5G)(qe,"resolvers"),Pt.remote.authority},get uiKind(){return Pt.uiKind},get logLevel(){return kt.getLevel()},get onDidChangeLogLevel(){return lt(kt.onDidChangeLogLevel)},get appQuality(){return(0,_e.$5G)(qe,"resolvers"),Pt.quality},get appCommit(){return(0,_e.$5G)(qe,"resolvers"),Pt.commit}};Pt.environment.extensionTestsLocationURI||Object.freeze(mi);const Ui={createTestController(fe,Ee,Be){return ki.createTestController(qe,fe,Ee,Be)},createTestObserver(){return(0,_e.$5G)(qe,"testObserver"),ki.createTestObserver()},runTests(fe){return(0,_e.$5G)(qe,"testObserver"),ki.runTests(fe)},registerTestFollowupProvider(fe){return(0,_e.$5G)(qe,"testObserver"),ki.registerTestFollowupProvider(fe)},get onDidChangeTestResults(){return(0,_e.$5G)(qe,"testObserver"),lt(ki.onResultsChanged)},get testResults(){return(0,_e.$5G)(qe,"testObserver"),ki.results}},Ni=Pt.remote.isRemote?x.ExtensionKind.Workspace:x.ExtensionKind.UI,sn={getExtension(fe,Ee){(0,_e.$4G)(qe,"extensionsAny")||(Ee=!1);const Be=Ei.mine.getExtensionDescription(fe);if(Be)return new G.$opc(qt,qe.identifier,Be,Ni,!1);if(Ee){const dt=Ei.all.getExtensionDescription(fe);if(dt)return new G.$opc(qt,qe.identifier,dt,Ni,!0)}},get all(){const fe=[];for(const Ee of Ei.mine.getAllExtensionDescriptions())fe.push(new G.$opc(qt,qe.identifier,Ee,Ni,!1));return fe},get allAcrossExtensionHosts(){(0,_e.$5G)(qe,"extensionsAny");const fe=new P.$on(Ei.mine.getAllExtensionDescriptions().map(Be=>Be.identifier)),Ee=[];for(const Be of Ei.all.getAllExtensionDescriptions()){const dt=!fe.has(Be.identifier);Ee.push(new G.$opc(qt,qe.identifier,Be,Ni,dt))}return Ee},get onDidChange(){return(0,_e.$4G)(qe,"extensionsAny")?lt(C.Event.any(Ei.mine.onDidChange,Ei.all.onDidChange)):lt(Ei.mine.onDidChange)}},on={createDiagnosticCollection(fe){return ve.createDiagnosticCollection(qe.identifier,fe)},get onDidChangeDiagnostics(){return lt(ve.onDidChangeDiagnostics)},getDiagnostics:fe=>ve.getDiagnostics(fe),getLanguages(){return ie.getLanguages()},setTextDocumentLanguage(fe,Ee){return ie.changeLanguage(fe.uri,Ee)},match(fe,Ee){const Be=he.LanguageSelector.from(fe);let dt;return(0,I.$su)(Be)&&(dt=Tt.notebookDocuments.find(yt=>yt.apiNotebook.getCells().find(Lt=>Lt.document===Ee))?.apiNotebook),(0,I.$ru)(Be,Ee.uri,Ee.languageId,!0,dt?.uri,dt?.notebookType)},registerCodeActionsProvider(fe,Ee,Be){return Re.registerCodeActionProvider(qe,bt(fe),Ee,Be)},registerDocumentPasteEditProvider(fe,Ee,Be){return(0,_e.$5G)(qe,"documentPaste"),Re.registerDocumentPasteEditProvider(qe,bt(fe),Ee,Be)},registerCodeLensProvider(fe,Ee){return Re.registerCodeLensProvider(qe,bt(fe),Ee)},registerDefinitionProvider(fe,Ee){return Re.registerDefinitionProvider(qe,bt(fe),Ee)},registerDeclarationProvider(fe,Ee){return Re.registerDeclarationProvider(qe,bt(fe),Ee)},registerImplementationProvider(fe,Ee){return Re.registerImplementationProvider(qe,bt(fe),Ee)},registerTypeDefinitionProvider(fe,Ee){return Re.registerTypeDefinitionProvider(qe,bt(fe),Ee)},registerHoverProvider(fe,Ee){return Re.registerHoverProvider(qe,bt(fe),Ee,qe.identifier)},registerEvaluatableExpressionProvider(fe,Ee){return Re.registerEvaluatableExpressionProvider(qe,bt(fe),Ee,qe.identifier)},registerInlineValuesProvider(fe,Ee){return Re.registerInlineValuesProvider(qe,bt(fe),Ee,qe.identifier)},registerDocumentHighlightProvider(fe,Ee){return Re.registerDocumentHighlightProvider(qe,bt(fe),Ee)},registerMultiDocumentHighlightProvider(fe,Ee){return Re.registerMultiDocumentHighlightProvider(qe,bt(fe),Ee)},registerLinkedEditingRangeProvider(fe,Ee){return Re.registerLinkedEditingRangeProvider(qe,bt(fe),Ee)},registerReferenceProvider(fe,Ee){return Re.registerReferenceProvider(qe,bt(fe),Ee)},registerRenameProvider(fe,Ee){return Re.registerRenameProvider(qe,bt(fe),Ee)},registerNewSymbolNamesProvider(fe,Ee){return(0,_e.$5G)(qe,"newSymbolNamesProvider"),Re.registerNewSymbolNamesProvider(qe,bt(fe),Ee)},registerDocumentSymbolProvider(fe,Ee,Be){return Re.registerDocumentSymbolProvider(qe,bt(fe),Ee,Be)},registerWorkspaceSymbolProvider(fe){return Re.registerWorkspaceSymbolProvider(qe,fe)},registerDocumentFormattingEditProvider(fe,Ee){return Re.registerDocumentFormattingEditProvider(qe,bt(fe),Ee)},registerDocumentRangeFormattingEditProvider(fe,Ee){return Re.registerDocumentRangeFormattingEditProvider(qe,bt(fe),Ee)},registerOnTypeFormattingEditProvider(fe,Ee,Be,...dt){return Re.registerOnTypeFormattingEditProvider(qe,bt(fe),Ee,[Be].concat(dt))},registerDocumentSemanticTokensProvider(fe,Ee,Be){return Re.registerDocumentSemanticTokensProvider(qe,bt(fe),Ee,Be)},registerDocumentRangeSemanticTokensProvider(fe,Ee,Be){return Re.registerDocumentRangeSemanticTokensProvider(qe,bt(fe),Ee,Be)},registerSignatureHelpProvider(fe,Ee,Be,...dt){return typeof Be=="object"?Re.registerSignatureHelpProvider(qe,bt(fe),Ee,Be):Re.registerSignatureHelpProvider(qe,bt(fe),Ee,typeof Be>"u"?[]:[Be,...dt])},registerCompletionItemProvider(fe,Ee,...Be){return Re.registerCompletionItemProvider(qe,bt(fe),Ee,Be)},registerInlineCompletionItemProvider(fe,Ee,Be){return Ee.handleDidShowCompletionItem&&(0,_e.$5G)(qe,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,_e.$5G)(qe,"inlineCompletionsAdditions"),Be&&(0,_e.$5G)(qe,"inlineCompletionsAdditions"),Re.registerInlineCompletionsProvider(qe,bt(fe),Ee,Be)},registerInlineEditProvider(fe,Ee){return(0,_e.$5G)(qe,"inlineEdit"),Re.registerInlineEditProvider(qe,bt(fe),Ee)},registerDocumentLinkProvider(fe,Ee){return Re.registerDocumentLinkProvider(qe,bt(fe),Ee)},registerColorProvider(fe,Ee){return Re.registerColorProvider(qe,bt(fe),Ee)},registerFoldingRangeProvider(fe,Ee){return Re.registerFoldingRangeProvider(qe,bt(fe),Ee)},registerSelectionRangeProvider(fe,Ee){return Re.registerSelectionRangeProvider(qe,fe,Ee)},registerCallHierarchyProvider(fe,Ee){return Re.registerCallHierarchyProvider(qe,fe,Ee)},registerTypeHierarchyProvider(fe,Ee){return Re.registerTypeHierarchyProvider(qe,fe,Ee)},setLanguageConfiguration:(fe,Ee)=>Re.setLanguageConfiguration(qe,fe,Ee),getTokenInformationAtPosition(fe,Ee){return(0,_e.$5G)(qe,"tokenInformation"),ie.tokenAtPosition(fe,Ee)},registerInlayHintsProvider(fe,Ee){return Re.registerInlayHintsProvider(qe,fe,Ee)},createLanguageStatusItem(fe,Ee){return ie.createLanguageStatusItem(qe,fe,Ee)},registerDocumentDropEditProvider(fe,Ee,Be){return Re.registerDocumentOnDropEditProvider(qe,fe,Ee,(0,_e.$4G)(qe,"documentPaste")?Be:void 0)}},an={get activeTextEditor(){return Wt.getActiveTextEditor()},get visibleTextEditors(){return Wt.getVisibleTextEditors()},get activeTerminal(){return wt.activeTerminal},get terminals(){return wt.terminals},async showTextDocument(fe,Ee,Be){b.URI.isUri(fe)&&fe.scheme===L.Schemas.vscodeRemote&&!fe.authority&&Rt.report("workspace.showTextDocument",qe,"A URI of 'vscode-remote' scheme requires an authority.");const dt=await(b.URI.isUri(fe)?Promise.resolve(cn.openTextDocument(fe)):Promise.resolve(fe));return Wt.showTextDocument(dt,Ee,Be)},createTextEditorDecorationType(fe){return Wt.createTextEditorDecorationType(qe,fe)},onDidChangeActiveTextEditor(fe,Ee,Be){return lt(Wt.onDidChangeActiveTextEditor)(fe,Ee,Be)},onDidChangeVisibleTextEditors(fe,Ee,Be){return lt(Wt.onDidChangeVisibleTextEditors)(fe,Ee,Be)},onDidChangeTextEditorSelection(fe,Ee,Be){return lt(Wt.onDidChangeTextEditorSelection)(fe,Ee,Be)},onDidChangeTextEditorOptions(fe,Ee,Be){return lt(Wt.onDidChangeTextEditorOptions)(fe,Ee,Be)},onDidChangeTextEditorVisibleRanges(fe,Ee,Be){return lt(Wt.onDidChangeTextEditorVisibleRanges)(fe,Ee,Be)},onDidChangeTextEditorViewColumn(fe,Ee,Be){return lt(Wt.onDidChangeTextEditorViewColumn)(fe,Ee,Be)},onDidCloseTerminal(fe,Ee,Be){return lt(wt.onDidCloseTerminal)(fe,Ee,Be)},onDidOpenTerminal(fe,Ee,Be){return lt(wt.onDidOpenTerminal)(fe,Ee,Be)},onDidChangeActiveTerminal(fe,Ee,Be){return lt(wt.onDidChangeActiveTerminal)(fe,Ee,Be)},onDidChangeTerminalDimensions(fe,Ee,Be){return(0,_e.$5G)(qe,"terminalDimensions"),lt(wt.onDidChangeTerminalDimensions)(fe,Ee,Be)},onDidChangeTerminalState(fe,Ee,Be){return lt(wt.onDidChangeTerminalState)(fe,Ee,Be)},onDidWriteTerminalData(fe,Ee,Be){return(0,_e.$5G)(qe,"terminalDataWriteEvent"),lt(wt.onDidWriteTerminalData)(fe,Ee,Be)},onDidExecuteTerminalCommand(fe,Ee,Be){return(0,_e.$5G)(qe,"terminalExecuteCommandEvent"),lt(wt.onDidExecuteTerminalCommand)(fe,Ee,Be)},onDidChangeTerminalShellIntegration(fe,Ee,Be){return(0,_e.$5G)(qe,"terminalShellIntegration"),lt(ei.onDidChangeTerminalShellIntegration)(fe,Ee,Be)},onDidStartTerminalShellExecution(fe,Ee,Be){return(0,_e.$5G)(qe,"terminalShellIntegration"),lt(ei.onDidStartTerminalShellExecution)(fe,Ee,Be)},onDidEndTerminalShellExecution(fe,Ee,Be){return(0,_e.$5G)(qe,"terminalShellIntegration"),lt(ei.onDidEndTerminalShellExecution)(fe,Ee,Be)},get state(){return Bt.getState()},onDidChangeWindowState(fe,Ee,Be){return lt(Bt.onDidChangeWindowState)(fe,Ee,Be)},showInformationMessage(fe,...Ee){return zi.showMessage(qe,R.default.Info,fe,Ee[0],Ee.slice(1))},showWarningMessage(fe,...Ee){return zi.showMessage(qe,R.default.Warning,fe,Ee[0],Ee.slice(1))},showErrorMessage(fe,...Ee){return zi.showMessage(qe,R.default.Error,fe,Ee[0],Ee.slice(1))},showQuickPick(fe,Ee,Be){return Je.showQuickPick(qe,fe,Ee,Be)},showWorkspaceFolderPick(fe){return Je.showWorkspaceFolderPick(fe)},showInputBox(fe,Ee){return Je.showInput(fe,Ee)},showOpenDialog(fe){return Qi.showOpenDialog(qe,fe)},showSaveDialog(fe){return Qi.showSaveDialog(fe)},createStatusBarItem(fe,Ee,Be){let dt,yt,Lt;return typeof fe=="string"?(dt=fe,yt=Ee,Lt=Be):(yt=fe,Lt=Ee),ji.createStatusBarEntry(qe,dt,yt,Lt)},setStatusBarMessage(fe,Ee){return ji.setStatusBarMessage(fe,Ee)},withScmProgress(fe){return Rt.report("window.withScmProgress",qe,"Use 'withProgress' instead."),Mt.withProgress(qe,{location:x.ProgressLocation.SourceControl},(Ee,Be)=>fe({report(dt){}}))},withProgress(fe,Ee){return Mt.withProgress(qe,fe,Ee)},createOutputChannel(fe,Ee){return wi.createOutputChannel(fe,Ee,qe)},createWebviewPanel(fe,Ee,Be,dt){return Li.createWebviewPanel(qe,fe,Ee,Be,dt)},createWebviewTextEditorInset(fe,Ee,Be,dt){return(0,_e.$5G)(qe,"editorInsets"),Me.createWebviewEditorInset(fe,Ee,Be,dt,qe)},createTerminal(fe,Ee,Be){return typeof fe=="object"?"pty"in fe?wt.createExtensionTerminal(fe):wt.createTerminalFromOptions(fe):wt.createTerminal(fe,Ee,Be)},registerTerminalLinkProvider(fe){return wt.registerLinkProvider(fe)},registerTerminalProfileProvider(fe,Ee){return wt.registerProfileProvider(qe,fe,Ee)},registerTerminalQuickFixProvider(fe,Ee){return(0,_e.$5G)(qe,"terminalQuickFixProvider"),wt.registerTerminalQuickFixProvider(fe,qe.identifier.value,Ee)},registerTreeDataProvider(fe,Ee){return Ae.registerTreeDataProvider(fe,Ee,qe)},createTreeView(fe,Ee){return Ae.createTreeView(fe,Ee,qe)},registerWebviewPanelSerializer:(fe,Ee)=>Li.registerWebviewPanelSerializer(qe,fe,Ee),registerCustomEditorProvider:(fe,Ee,Be={})=>Vi.registerCustomEditorProvider(qe,fe,Ee,Be),registerFileDecorationProvider(fe){return oi.registerFileDecorationProvider(fe,qe)},registerUriHandler(fe){return gi.registerUriHandler(qe,fe)},createQuickPick(){return Je.createQuickPick(qe)},createInputBox(){return Je.createInputBox(qe)},get activeColorTheme(){return qi.activeColorTheme},onDidChangeActiveColorTheme(fe,Ee,Be){return lt(qi.onDidChangeActiveColorTheme)(fe,Ee,Be)},registerWebviewViewProvider(fe,Ee,Be){return xi.registerWebviewViewProvider(qe,fe,Ee,Be?.webviewOptions)},get activeNotebookEditor(){return Tt.activeNotebookEditor},onDidChangeActiveNotebookEditor(fe,Ee,Be){return lt(Tt.onDidChangeActiveNotebookEditor)(fe,Ee,Be)},get visibleNotebookEditors(){return Tt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return lt(Tt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(fe,Ee,Be){return lt(Ci.onDidChangeNotebookEditorSelection)(fe,Ee,Be)},onDidChangeNotebookEditorVisibleRanges(fe,Ee,Be){return lt(Ci.onDidChangeNotebookEditorVisibleRanges)(fe,Ee,Be)},showNotebookDocument(fe,Ee){return Tt.showNotebookDocument(fe,Ee)},registerExternalUriOpener(fe,Ee,Be){return(0,_e.$5G)(qe,"externalUriOpener"),_i.registerExternalUriOpener(qe.identifier,fe,Ee,Be)},registerProfileContentHandler(fe,Ee){return(0,_e.$5G)(qe,"profileContentHandlers"),en.registerProfileContentHandler(qe,fe,Ee)},registerQuickDiffProvider(fe,Ee,Be,dt){return(0,_e.$5G)(qe,"quickDiffProvider"),Ct.registerQuickDiffProvider(bt(fe),Ee,Be,dt)},get tabGroups(){return _t.tabGroups},registerShareProvider(fe,Ee){return(0,_e.$5G)(qe,"shareProvider"),Yt.registerShareProvider(bt(fe),Ee)}},cn={get rootPath(){return Rt.report("workspace.rootPath",qe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),vt.getPath()},set rootPath(fe){throw new h.$8("rootPath")},getWorkspaceFolder(fe){return vt.getWorkspaceFolder(fe)},get workspaceFolders(){return vt.getWorkspaceFolders()},get name(){return vt.name},set name(fe){throw new h.$8("name")},get workspaceFile(){return vt.workspaceFile},set workspaceFile(fe){throw new h.$8("workspaceFile")},updateWorkspaceFolders:(fe,Ee,...Be)=>vt.updateWorkspaceFolders(qe,fe,Ee||0,...Be),onDidChangeWorkspaceFolders:function(fe,Ee,Be){return lt(vt.onDidChangeWorkspace)(fe,Ee,Be)},asRelativePath:(fe,Ee)=>vt.getRelativePath(fe,Ee),findFiles:(fe,Ee,Be,dt)=>vt.findFiles(fe,Ee,Be,qe.identifier,dt),findFiles2:(fe,Ee,Be)=>((0,_e.$5G)(qe,"findFiles2"),vt.findFiles2(fe,Ee,qe.identifier,Be)),findTextInFiles:(fe,Ee,Be,dt)=>{(0,_e.$5G)(qe,"findTextInFiles");let yt,Lt;return typeof Ee=="object"?(yt=Ee,Lt=Be):(yt={},Lt=Ee,dt=Be),vt.findTextInFiles(fe,yt||{},Lt,qe.identifier,dt)},save:fe=>vt.save(fe),saveAs:fe=>vt.saveAs(fe),saveAll:fe=>vt.saveAll(fe),applyEdit(fe,Ee){return wn.applyWorkspaceEdit(fe,qe,Ee)},createFileSystemWatcher:(fe,Ee,Be,dt)=>{let yt;return typeof Ee=="boolean"?yt={ignoreCreateEvents:!!Ee,ignoreChangeEvents:!!Be,ignoreDeleteEvents:!!dt,correlate:!1}:Ee&&((0,_e.$5G)(qe,"createFileSystemWatcher"),yt={...Ee,correlate:!0}),it.createFileSystemWatcher(vt,qe,fe,yt)},get textDocuments(){return jt.getAllDocumentData().map(fe=>fe.document)},set textDocuments(fe){throw new h.$8("textDocuments")},openTextDocument(fe){let Ee;const Be=fe;if(typeof fe=="string")Ee=Promise.resolve(b.URI.file(fe));else if(b.URI.isUri(fe))Ee=Promise.resolve(fe);else if(!Be||typeof Be=="object")Ee=jt.createDocumentData(Be);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(dt=>(dt.scheme===L.Schemas.vscodeRemote&&!dt.authority&&Rt.report("workspace.openTextDocument",qe,"A URI of 'vscode-remote' scheme requires an authority."),jt.ensureDocumentData(dt).then(yt=>yt.document)))},onDidOpenTextDocument:(fe,Ee,Be)=>lt(jt.onDidAddDocument)(fe,Ee,Be),onDidCloseTextDocument:(fe,Ee,Be)=>lt(jt.onDidRemoveDocument)(fe,Ee,Be),onDidChangeTextDocument:(fe,Ee,Be)=>lt(jt.onDidChangeDocument)(fe,Ee,Be),onDidSaveTextDocument:(fe,Ee,Be)=>lt(jt.onDidSaveDocument)(fe,Ee,Be),onWillSaveTextDocument:(fe,Ee,Be)=>lt(Pi.getOnWillSaveTextDocumentEvent(qe))(fe,Ee,Be),get notebookDocuments(){return Tt.notebookDocuments.map(fe=>fe.apiNotebook)},async openNotebookDocument(fe,Ee){let Be;if(b.URI.isUri(fe))Be=fe,await Tt.openNotebookDocument(fe);else if(typeof fe=="string")Be=b.URI.revive(await Tt.createNotebookDocument({viewType:fe,content:Ee}));else throw new Error("Invalid arguments");return Tt.getNotebookDocument(Be).apiNotebook},onDidSaveNotebookDocument(fe,Ee,Be){return lt(Si.onDidSaveNotebookDocument)(fe,Ee,Be)},onDidChangeNotebookDocument(fe,Ee,Be){return lt(Si.onDidChangeNotebookDocument)(fe,Ee,Be)},onWillSaveNotebookDocument(fe,Ee,Be){return lt(Ai.getOnWillSaveNotebookDocumentEvent(qe))(fe,Ee,Be)},get onDidOpenNotebookDocument(){return lt(Tt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return lt(Tt.onDidCloseNotebookDocument)},registerNotebookSerializer(fe,Ee,Be,dt){return Tt.registerNotebookSerializer(qe,fe,Ee,Be,(0,_e.$4G)(qe,"notebookLiveShare")?dt:void 0)},onDidChangeConfiguration:(fe,Ee,Be)=>lt(Bi.onDidChangeConfiguration)(fe,Ee,Be),getConfiguration(fe,Ee){return Ee=arguments.length===1?void 0:Ee,Bi.getConfiguration(fe,Ee,qe)},registerTextDocumentContentProvider(fe,Ee){return ai.registerTextDocumentContentProvider(fe,Ee)},registerTaskProvider:(fe,Ee)=>(Rt.report("window.registerTaskProvider",qe,"Use the corresponding function on the 'tasks' namespace instead"),Ht.registerTaskProvider(qe,fe,Ee)),registerFileSystemProvider(fe,Ee,Be){return(0,T.$Qc)(Qe.registerFileSystemProvider(qe,fe,Ee,Be),Zt.addFileSystemProvider(fe,Ee,Be))},get fs(){return Zt.value},registerFileSearchProvider:(fe,Ee)=>((0,_e.$5G)(qe,"fileSearchProvider"),fi.registerFileSearchProvider(fe,Ee)),registerTextSearchProvider:(fe,Ee)=>((0,_e.$5G)(qe,"textSearchProvider"),fi.registerTextSearchProvider(fe,Ee)),registerAITextSearchProvider:(fe,Ee)=>((0,_e.$5G)(qe,"aiTextSearchProvider"),(0,_e.$5G)(qe,"textSearchProvider"),fi.registerAITextSearchProvider(fe,Ee)),registerRemoteAuthorityResolver:(fe,Ee)=>((0,_e.$5G)(qe,"resolvers"),qt.registerRemoteAuthorityResolver(fe,Ee)),registerResourceLabelFormatter:fe=>((0,_e.$5G)(qe,"resolvers"),li.$registerResourceLabelFormatter(fe)),getRemoteExecServer:fe=>((0,_e.$5G)(qe,"resolvers"),qt.getRemoteExecServer(fe)),onDidCreateFiles:(fe,Ee,Be)=>lt(it.onDidCreateFile)(fe,Ee,Be),onDidDeleteFiles:(fe,Ee,Be)=>lt(it.onDidDeleteFile)(fe,Ee,Be),onDidRenameFiles:(fe,Ee,Be)=>lt(it.onDidRenameFile)(fe,Ee,Be),onWillCreateFiles:(fe,Ee,Be)=>lt(it.getOnWillCreateFileEvent(qe))(fe,Ee,Be),onWillDeleteFiles:(fe,Ee,Be)=>lt(it.getOnWillDeleteFileEvent(qe))(fe,Ee,Be),onWillRenameFiles:(fe,Ee,Be)=>lt(it.getOnWillRenameFileEvent(qe))(fe,Ee,Be),openTunnel:fe=>((0,_e.$5G)(qe,"tunnels"),Ft.openTunnel(qe,fe).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,_e.$5G)(qe,"tunnels"),Ft.getTunnels()},onDidChangeTunnels:(fe,Ee,Be)=>((0,_e.$5G)(qe,"tunnels"),lt(Ft.onDidChangeTunnels)(fe,Ee,Be)),registerPortAttributesProvider:(fe,Ee)=>((0,_e.$5G)(qe,"portsAttributes"),Ft.registerPortsAttributesProvider(fe,Ee)),registerTunnelProvider:(fe,Ee)=>((0,_e.$5G)(qe,"tunnelFactory"),Ft.registerTunnelProvider(fe,Ee)),registerTimelineProvider:(fe,Ee)=>((0,_e.$5G)(qe,"timeline"),pn.registerTimelineProvider(fe,Ee,qe.identifier,St.converter)),get isTrusted(){return vt.trusted},requestWorkspaceTrust:fe=>((0,_e.$5G)(qe,"workspaceTrust"),vt.requestWorkspaceTrust(fe)),onDidGrantWorkspaceTrust:(fe,Ee,Be)=>lt(vt.onDidGrantWorkspaceTrust)(fe,Ee,Be),registerEditSessionIdentityProvider:(fe,Ee)=>((0,_e.$5G)(qe,"editSessionIdentityProvider"),vt.registerEditSessionIdentityProvider(fe,Ee)),onWillCreateEditSessionIdentity:(fe,Ee,Be)=>((0,_e.$5G)(qe,"editSessionIdentityProvider"),lt(vt.getOnWillCreateEditSessionIdentityEvent(qe))(fe,Ee,Be)),registerCanonicalUriProvider:(fe,Ee)=>((0,_e.$5G)(qe,"canonicalUriProvider"),vt.registerCanonicalUriProvider(fe,Ee)),getCanonicalUri:(fe,Ee,Be)=>((0,_e.$5G)(qe,"canonicalUriProvider"),vt.provideCanonicalUri(fe,Ee,Be))},ln={get inputBox(){return Rt.report("scm.inputBox",qe,"Use 'SourceControl.inputBox' instead"),ft.getLastInputBox(qe)},createSourceControl(fe,Ee,Be){return ft.createSourceControl(qe,fe,Ee,Be)}},un={createCommentController(fe,Ee){return ci.createCommentController(qe,fe,Ee)}},En={get activeDebugSession(){return It.activeDebugSession},get activeDebugConsole(){return It.activeDebugConsole},get breakpoints(){return It.breakpoints},get activeStackItem(){return It.activeStackItem},registerDebugVisualizationProvider(fe,Ee){return(0,_e.$5G)(qe,"debugVisualization"),It.registerDebugVisualizationProvider(qe,fe,Ee)},registerDebugVisualizationTreeProvider(fe,Ee){return(0,_e.$5G)(qe,"debugVisualization"),It.registerDebugVisualizationTree(qe,fe,Ee)},onDidStartDebugSession(fe,Ee,Be){return lt(It.onDidStartDebugSession)(fe,Ee,Be)},onDidTerminateDebugSession(fe,Ee,Be){return lt(It.onDidTerminateDebugSession)(fe,Ee,Be)},onDidChangeActiveDebugSession(fe,Ee,Be){return lt(It.onDidChangeActiveDebugSession)(fe,Ee,Be)},onDidReceiveDebugSessionCustomEvent(fe,Ee,Be){return lt(It.onDidReceiveDebugSessionCustomEvent)(fe,Ee,Be)},onDidChangeBreakpoints(fe,Ee,Be){return lt(It.onDidChangeBreakpoints)(fe,Ee,Be)},onDidChangeActiveStackItem(fe,Ee,Be){return lt(It.onDidChangeActiveStackItem)(fe,Ee,Be)},registerDebugConfigurationProvider(fe,Ee,Be){return It.registerDebugConfigurationProvider(fe,Ee,Be||ui.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(fe,Ee){return It.registerDebugAdapterDescriptorFactory(qe,fe,Ee)},registerDebugAdapterTrackerFactory(fe,Ee){return It.registerDebugAdapterTrackerFactory(fe,Ee)},startDebugging(fe,Ee,Be){return!Be||typeof Be=="object"&&"configuration"in Be?It.startDebugging(fe,Ee,{parentSession:Be}):It.startDebugging(fe,Ee,Be||{})},stopDebugging(fe){return It.stopDebugging(fe)},addBreakpoints(fe){return It.addBreakpoints(fe)},removeBreakpoints(fe){return It.removeBreakpoints(fe)},asDebugSourceUri(fe,Ee){return It.asDebugSourceUri(fe,Ee)}},yn={registerTaskProvider:(fe,Ee)=>Ht.registerTaskProvider(qe,fe,Ee),fetchTasks:fe=>Ht.fetchTasks(fe),executeTask:fe=>Ht.executeTask(qe,fe),get taskExecutions(){return Ht.taskExecutions},onDidStartTask:(fe,Ee,Be)=>lt(Ht.onDidStartTask)(fe,Ee,Be),onDidEndTask:(fe,Ee,Be)=>lt(Ht.onDidEndTask)(fe,Ee,Be),onDidStartTaskProcess:(fe,Ee,Be)=>lt(Ht.onDidStartTaskProcess)(fe,Ee,Be),onDidEndTaskProcess:(fe,Ee,Be)=>lt(Ht.onDidEndTaskProcess)(fe,Ee,Be)},hn={createNotebookController(fe,Ee,Be,dt,yt){return Di.createNotebookController(qe,fe,Ee,Be,dt,(0,_e.$4G)(qe,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(fe,Ee)=>Tt.registerNotebookCellStatusBarItemProvider(qe,fe,Ee),createRendererMessaging(fe){return $i.createRendererMessaging(qe,fe)},createNotebookControllerDetectionTask(fe){return(0,_e.$5G)(qe,"notebookKernelSource"),Di.createNotebookControllerDetectionTask(qe,fe)},registerKernelSourceActionProvider(fe,Ee){return(0,_e.$5G)(qe,"notebookKernelSource"),Di.registerKernelSourceActionProvider(qe,fe,Ee)},onDidChangeNotebookCellExecutionState(fe,Ee,Be){return(0,_e.$5G)(qe,"notebookCellExecutionState"),lt(Di.onDidChangeNotebookCellExecutionState)(fe,Ee,Be)}},Ji={t(...fe){if(typeof fe[0]=="string"){const Ee=fe.shift(),Be=!fe||typeof fe[0]!="object"?fe:fe[0];return vi.getMessage(qe.identifier.value,{message:Ee,args:Be})}return vi.getMessage(qe.identifier.value,fe[0])},get bundle(){return vi.getBundle(qe.identifier.value)},get uri(){return vi.getBundleUri(qe.identifier.value)}},dn={_version:1,transferActiveChat(fe){return(0,_e.$5G)(qe,"interactive"),Mi.transferActiveChat(fe)}},fn={getRelatedInformation(fe,Ee){return(0,_e.$5G)(qe,"aiRelatedInformation"),nn.getRelatedInformation(qe,fe,Ee)},registerRelatedInformationProvider(fe,Ee){return(0,_e.$5G)(qe,"aiRelatedInformation"),nn.registerRelatedInformationProvider(qe,fe,Ee)},registerEmbeddingVectorProvider(fe,Ee){return(0,_e.$5G)(qe,"aiRelatedInformation"),Hi.registerEmbeddingVectorProvider(qe,fe,Ee)}},gn={_version:1,registerChatResponseProvider(fe,Ee,Be){return(0,_e.$5G)(qe,"chatProvider"),Jt.registerLanguageModel(qe,fe,Ee,Be)},registerChatVariableResolver(fe,Ee,Be,dt,yt,Lt,Ri,Yi){return(0,_e.$5G)(qe,"chatVariableResolver"),tn.registerVariableResolver(qe,fe,Ee,Be,dt,yt,Lt,Ri,Yi?.id)},registerMappedEditsProvider(fe,Ee){return(0,_e.$5G)(qe,"mappedEditsProvider"),Re.registerMappedEditsProvider(qe,fe,Ee)},createChatParticipant(fe,Ee){return Mi.createChatAgent(qe,fe,Ee)},createDynamicChatParticipant(fe,Ee,Be){return(0,_e.$5G)(qe,"chatParticipantPrivate"),Mi.createDynamicChatAgent(qe,fe,Ee,Be)}},Sn={selectChatModels:fe=>Jt.selectLanguageModels(qe,fe??{}),onDidChangeChatModels:(fe,Ee,Be)=>Jt.onDidChangeProviders(fe,Ee,Be),registerChatModelProvider:(fe,Ee,Be)=>((0,_e.$5G)(qe,"chatProvider"),Jt.registerLanguageModel(qe,fe,Ee,Be)),get embeddingModels(){return(0,_e.$5G)(qe,"embeddings"),Oi.embeddingsModels},onDidChangeEmbeddingModels:(fe,Ee,Be)=>((0,_e.$5G)(qe,"embeddings"),Oi.onDidChange(fe,Ee,Be)),registerEmbeddingsProvider(fe,Ee){return(0,_e.$5G)(qe,"embeddings"),Oi.registerEmbeddingsProvider(qe,fe,Ee)},async computeEmbeddings(fe,Ee,Be){return(0,_e.$5G)(qe,"embeddings"),Oi.computeEmbeddings(fe,Ee,Be)},registerTool(fe,Ee){return(0,_e.$5G)(qe,"lmTools"),Gi.registerTool(qe,fe,Ee)},invokeTool(fe,Ee,Be){return(0,_e.$5G)(qe,"lmTools"),Gi.invokeTool(fe,Ee,Be)},get tools(){return(0,_e.$5G)(qe,"lmTools"),Gi.tools}},Dn={registerSpeechProvider(fe,Ee){return(0,_e.$5G)(qe,"speech"),bn.registerProvider(qe.identifier,fe,Ee)}};return{version:Pt.version,ai:fn,authentication:Wi,commands:vn,comments:un,chat:gn,debug:En,env:mi,extensions:sn,interactive:dn,l10n:Ji,languages:on,lm:Sn,notebooks:hn,scm:ln,speech:Dn,tasks:yn,tests:Ui,window:an,workspace:cn,Breakpoint:x.$vO,TerminalOutputAnchor:x.TerminalOutputAnchor,ChatResultFeedbackKind:x.ChatResultFeedbackKind,ChatVariableLevel:x.ChatVariableLevel,ChatCompletionItem:x.$qP,CallHierarchyIncomingCall:x.$TN,CallHierarchyItem:x.$SN,CallHierarchyOutgoingCall:x.$UN,CancellationError:h.$4,CancellationTokenSource:r.$ue,CandidatePortSource:i.CandidatePortSource,CodeAction:x.$PN,CodeActionKind:x.$QN,CodeActionTriggerKind:x.CodeActionTriggerKind,CodeLens:x.$VN,Color:x.$9N,ColorInformation:x.$0N,ColorPresentation:x.$$N,ColorThemeKind:x.ColorThemeKind,CommentMode:x.CommentMode,CommentState:x.CommentState,CommentThreadCollapsibleState:x.CommentThreadCollapsibleState,CommentThreadState:x.CommentThreadState,CommentThreadApplicability:x.CommentThreadApplicability,CompletionItem:x.$3N,CompletionItemKind:x.CompletionItemKind,CompletionItemTag:x.CompletionItemTag,CompletionList:x.$4N,CompletionTriggerKind:x.CompletionTriggerKind,ConfigurationTarget:x.ConfigurationTarget,CustomExecution:x.$gO,DebugAdapterExecutable:x.$zO,DebugAdapterInlineImplementation:x.$CO,DebugAdapterNamedPipeServer:x.$BO,DebugAdapterServer:x.$AO,DebugConfigurationProviderTriggerKind:ui.DebugConfigurationProviderTriggerKind,DebugConsoleMode:x.DebugConsoleMode,DebugVisualization:x.$SO,DecorationRangeBehavior:x.DecorationRangeBehavior,Diagnostic:x.$IN,DiagnosticRelatedInformation:x.$HN,DiagnosticSeverity:x.DiagnosticSeverity,DiagnosticTag:x.DiagnosticTag,Disposable:x.$uN,DocumentHighlight:x.$LN,DocumentHighlightKind:x.DocumentHighlightKind,MultiDocumentHighlight:x.$MN,DocumentLink:x.$8N,DocumentSymbol:x.$ON,EndOfLine:x.EndOfLine,EnvironmentVariableMutatorType:x.EnvironmentVariableMutatorType,EvaluatableExpression:x.$FO,InlineValueText:x.$GO,InlineValueVariableLookup:x.$HO,InlineValueEvaluatableExpression:x.$IO,InlineCompletionTriggerKind:x.InlineCompletionTriggerKind,EventEmitter:C.$je,ExtensionKind:x.ExtensionKind,ExtensionMode:x.ExtensionMode,ExternalUriOpenerPriority:x.ExternalUriOpenerPriority,FileChangeType:x.FileChangeType,FileDecoration:x.$UO,FileDecoration2:x.$UO,FileSystemError:x.$LO,FileType:w.FileType,FilePermission:w.FilePermission,FoldingRange:x.$MO,FoldingRangeKind:x.FoldingRangeKind,FunctionBreakpoint:x.$xO,InlineCompletionItem:x.$5N,InlineCompletionList:x.$6N,Hover:x.$JN,VerboseHover:x.$KN,HoverVerbosityAction:x.HoverVerbosityAction,IndentAction:D.IndentAction,Location:x.$GN,MarkdownString:x.$WN,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:x.$XN,PortAutoForwardAction:x.PortAutoForwardAction,Position:x.$vN,ProcessExecution:x.$eO,ProgressLocation:x.ProgressLocation,QuickInputButtons:x.$TO,Range:x.$wN,RelativePattern:x.$tO,Selection:x.$xN,SelectionRange:x.$RN,SemanticTokens:x.$PO,SemanticTokensBuilder:x.$OO,SemanticTokensEdit:x.$QO,SemanticTokensEdits:x.$RO,SemanticTokensLegend:x.$NO,ShellExecution:x.$fO,ShellQuoting:x.ShellQuoting,SignatureHelp:x.$ZN,SignatureHelpTriggerKind:x.SignatureHelpTriggerKind,SignatureInformation:x.$YN,SnippetString:x.$FN,SourceBreakpoint:x.$wO,StandardTokenType:x.StandardTokenType,StatusBarAlignment:x.StatusBarAlignment,SymbolInformation:x.$NN,SymbolKind:x.SymbolKind,SymbolTag:x.SymbolTag,Task:x.$hO,TaskGroup:x.$dO,TaskPanelKind:x.TaskPanelKind,TaskRevealKind:x.TaskRevealKind,TaskScope:x.TaskScope,TerminalLink:x.$_N,TerminalQuickFixTerminalCommand:x.$bO,TerminalQuickFixOpener:x.$aO,TerminalLocation:x.TerminalLocation,TerminalProfile:x.$cO,TerminalExitReason:x.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:x.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:x.TextDocumentSaveReason,TextEdit:x.$BN,SnippetTextEdit:x.$DN,TextEditorCursorStyle:c.TextEditorCursorStyle,TextEditorLineNumbersStyle:x.TextEditorLineNumbersStyle,TextEditorRevealType:x.TextEditorRevealType,TextEditorSelectionChangeKind:x.TextEditorSelectionChangeKind,SyntaxTokenType:x.SyntaxTokenType,TextDocumentChangeReason:x.TextDocumentChangeReason,ThemeColor:x.$sO,ThemeIcon:x.$rO,TreeItem:x.$iO,TreeItemCheckboxState:x.TreeItemCheckboxState,TreeItemCollapsibleState:x.TreeItemCollapsibleState,TypeHierarchyItem:x.$eP,UIKind:ti.UIKind,Uri:b.URI,ViewColumn:x.ViewColumn,WorkspaceEdit:x.$EN,DocumentPasteTriggerKind:x.DocumentPasteTriggerKind,DocumentDropEdit:x.$oO,DocumentDropOrPasteEditKind:x.$pO,DocumentPasteEdit:x.$qO,InlayHint:x.$2N,InlayHintLabelPart:x.$1N,InlayHintKind:x.InlayHintKind,RemoteAuthorityResolverError:x.$AN,ResolvedAuthority:x.$yN,ManagedResolvedAuthority:x.$zN,SourceControlInputBoxValidationType:x.SourceControlInputBoxValidationType,ExtensionRuntime:x.ExtensionRuntime,TimelineItem:x.$5O,NotebookRange:x.$WO,NotebookCellKind:x.NotebookCellKind,NotebookCellExecutionState:x.NotebookCellExecutionState,NotebookCellData:x.$XO,NotebookData:x.$YO,NotebookRendererScript:x.$3O,NotebookCellStatusBarAlignment:x.NotebookCellStatusBarAlignment,NotebookEditorRevealType:x.NotebookEditorRevealType,NotebookCellOutput:x.$1O,NotebookCellOutputItem:x.$ZO,NotebookCellStatusBarItem:x.$2O,NotebookControllerAffinity:x.NotebookControllerAffinity,NotebookControllerAffinity2:x.NotebookControllerAffinity2,NotebookEdit:x.$CN,NotebookKernelSourceAction:x.$4O,NotebookVariablesRequestKind:x.NotebookVariablesRequestKind,PortAttributes:x.$7O,LinkedEditingRanges:x.$6O,TestResultState:x.TestResultState,TestRunRequest:x.$8O,TestMessage:x.$9O,TestTag:x.$0O,TestRunProfileKind:x.TestRunProfileKind,TextSearchCompleteMessageType:Kt.TextSearchCompleteMessageType,DataTransfer:x.$nO,DataTransferItem:x.$jO,TestCoverageCount:x.$$O,FileCoverage:x.$aP,FileCoverage2:x.$aP,StatementCoverage:x.$bP,BranchCoverage:x.$cP,DeclarationCoverage:x.$dP,WorkspaceTrustState:x.WorkspaceTrustState,LanguageStatusSeverity:x.LanguageStatusSeverity,QuickPickItemKind:x.QuickPickItemKind,InputBoxValidationSeverity:x.InputBoxValidationSeverity,TabInputText:x.$fP,TabInputTextDiff:x.$gP,TabInputTextMerge:x.$hP,TabInputCustom:x.$iP,TabInputNotebook:x.$kP,TabInputNotebookDiff:x.$lP,TabInputWebview:x.$jP,TabInputTerminal:x.$mP,TabInputInteractiveWindow:x.$nP,TabInputChat:x.$oP,TabInputTextMultiDiff:x.$pP,TelemetryTrustedValue:f.$tp,LogLevel:a.LogLevel,EditSessionIdentityMatch:g.EditSessionIdentityMatch,InteractiveSessionVoteDirection:x.InteractiveSessionVoteDirection,ChatCopyKind:x.ChatCopyKind,InteractiveEditorResponseFeedbackKind:x.InteractiveEditorResponseFeedbackKind,DebugStackFrame:x.$DO,DebugThread:x.$EO,RelatedInformationType:x.RelatedInformationType,SpeechToTextStatus:x.SpeechToTextStatus,TextToSpeechStatus:x.TextToSpeechStatus,PartialAcceptTriggerKind:x.PartialAcceptTriggerKind,KeywordRecognitionStatus:x.KeywordRecognitionStatus,ChatResponseMarkdownPart:x.$rP,ChatResponseFileTreePart:x.$vP,ChatResponseAnchorPart:x.$wP,ChatResponseProgressPart:x.$xP,ChatResponseProgressPart2:x.$yP,ChatResponseReferencePart:x.$BP,ChatResponseWarningPart:x.$zP,ChatResponseTextEditPart:x.$CP,ChatResponseMarkdownWithVulnerabilitiesPart:x.$sP,ChatResponseCommandButtonPart:x.$AP,ChatResponseDetectedParticipantPart:x.$tP,ChatResponseConfirmationPart:x.$uP,ChatRequestTurn:x.$DP,ChatResponseTurn:x.$EP,ChatLocation:x.ChatLocation,ChatRequestEditorData:x.$FP,ChatRequestNotebookData:x.$GP,LanguageModelChatMessageRole:x.LanguageModelChatMessageRole,LanguageModelChatMessage:x.$IP,LanguageModelChatMessageFunctionResultPart:x.$HP,LanguageModelChatResponseTextPart:x.$KP,LanguageModelChatResponseFunctionUsePart:x.$JP,LanguageModelError:x.$OP,NewSymbolName:x.$KO,NewSymbolNameTag:x.NewSymbolNameTag,NewSymbolNameTriggerKind:x.NewSymbolNameTriggerKind,InlineEdit:x.$PP,InlineEditTriggerKind:x.InlineEditTriggerKind}}}}),define(ke[344],Ie([1,0,88,169,48,163,41,34,63,47,100,101,102,125,76,95,162,75,62,124,94,77,161,11,64,122,123,127,128,167,98]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a,$,f,g,i,o,t,s,n,d,l,m,E,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.$Ns)(l.$ipc,l.$hpc,r.InstantiationType.Delayed),(0,r.$Ns)(n.$0j,s.$xqc,r.InstantiationType.Delayed),(0,r.$Ns)(a.$noc,a.$ooc,r.InstantiationType.Delayed),(0,r.$Ns)(R.$kQ,R.$jQ,r.InstantiationType.Eager),(0,r.$Ns)(E.$xoc,E.$yoc,r.InstantiationType.Eager),(0,r.$Ns)(S.$cpc,S.$dpc,r.InstantiationType.Eager),(0,r.$Ns)(L.$Moc,L.$Koc,r.InstantiationType.Eager),(0,r.$Ns)(f.$Ooc,f.$Noc,r.InstantiationType.Eager),(0,r.$Ns)(k.$spc,k.$tpc,r.InstantiationType.Eager),(0,r.$Ns)(D.$xpc,D.$Bpc,r.InstantiationType.Eager),(0,r.$Ns)(T.$Dpc,T.$Cpc,r.InstantiationType.Eager),(0,r.$Ns)(b.$_P,b.$$P,r.InstantiationType.Eager),(0,r.$Ns)(m.$jpc,m.$kpc,r.InstantiationType.Eager),(0,r.$Ns)(g.$roc,g.$qoc,r.InstantiationType.Eager),(0,r.$Ns)(h.$0pc,h.$9pc,r.InstantiationType.Delayed),(0,r.$Ns)(u.$Tpc,u.$Upc,r.InstantiationType.Eager),(0,r.$Ns)(P.$8oc,P.$7oc,r.InstantiationType.Eager),(0,r.$Ns)(I.$kqc,I.$jqc,r.InstantiationType.Eager),(0,r.$Ns)(c.$$oc,c.$bpc,r.InstantiationType.Eager),(0,r.$Ns)(y.$lqc,y.$mqc,r.InstantiationType.Eager),(0,r.$Ns)(w.$SFb,w.$TFb,r.InstantiationType.Eager),(0,r.$Ns)($.$vqc,$.$uqc,r.InstantiationType.Eager),(0,r.$Ns)(C.$Joc,C.$Ioc,r.InstantiationType.Eager),(0,r.$Ns)(i.$fpc,i.$epc,r.InstantiationType.Eager),(0,r.$Ns)(o.$iQ,o.$fQ,r.InstantiationType.Eager),(0,r.$Ns)(t.$Yoc,t.$Zoc,r.InstantiationType.Eager),(0,r.$Ns)(d.$qpc,d.$rpc,r.InstantiationType.Eager)}),define(ke[129],Ie([1,0,18,11,37,99]),function(me,e,r,h,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pqc=void 0,e.$Nqc=L,e.$Oqc=R,T=Ue(T);function L(D){return D.startsWith("**")||D.startsWith("/")?D:`/${D}`}function R(D,u,P,w){const a=(0,r.$Zb)(P,b),$=new C.$UL(u,a,w),f=$.preview.matches;return{ranges:(0,r.$Zb)(a,c),uri:D,preview:{text:$.preview.text,matches:(0,r.$Zb)(f,c)}}}function b(D){return new C.$VL(D.start.line,D.start.character,D.end.line,D.end.character)}function c(D){return new T.$IL(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn)}let I=class{constructor(u,P){this.a=u,this.b=P}appendLine(u){this.b.debug(`${this.a}#search`,u)}};e.$Pqc=I,e.$Pqc=I=Ye([Ve(1,h.$9j)],I)}),define(ke[345],Ie([1,0,56,16,81,31,10,12,129,346]),function(me,e,r,h,C,T,L,R,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qqc=D,e.$Rqc=$,e.$Sqc=g,r=Ue(r),h=Ue(h),T=Ue(T),R=Ue(R);const I=c.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function D(i,o,t,s,n){const d=u(i,o,t,s,n),l=o.folder.fsPath;return{cmd:r.spawn(I,d.args,{cwd:l}),rgDiskPath:I,siblingClauses:d.siblingClauses,rgArgs:d,cwd:l}}function u(i,o,t,s,n){const d=["--files","--hidden","--case-sensitive","--no-require-git"];w([o],t,!1).forEach(m=>{const E=(0,b.$Nqc)(m);if(d.push("-g",E),L.$k){const S=(0,C.$km)(E);S!==E&&d.push("-g",S)}});const l=P([o],s,void 0,!1);return l.globArgs.forEach(m=>{const E=`!${(0,b.$Nqc)(m)}`;if(d.push("-g",E),L.$k){const S=(0,C.$km)(E);S!==E&&d.push("-g",S)}}),o.disregardIgnoreFiles!==!1?d.push("--no-ignore"):o.disregardParentIgnoreFiles!==!1&&d.push("--no-ignore-parent"),o.ignoreSymlinks||d.push("--follow"),i.exists&&d.push("--quiet"),n&&d.push("--threads",`${n}`),d.push("--no-config"),o.disregardGlobalIgnoreFiles&&d.push("--no-ignore-global"),{args:d,siblingClauses:l.siblingClauses}}function P(i,o,t,s=!0){const n=[];let d={};return i.forEach(l=>{const m=Object.assign({},l.excludePattern||{},o||{}),E=a(m,s?l.folder.fsPath:void 0,t);n.push(...E.globArgs),E.siblingClauses&&(d=Object.assign(d,E.siblingClauses))}),{globArgs:n,siblingClauses:d}}function w(i,o,t=!0){const s=[];return i.forEach(n=>{const d=Object.assign({},o||{},n.includePattern||{}),l=a(d,t?n.folder.fsPath:void 0);s.push(...l.globArgs)}),s}function a(i,o,t){const s=[],n={};return Object.keys(i).forEach(d=>{if(t&&t.has(d)||!d)return;const l=i[d];d=f(o?$(o,d):d),d.startsWith("\\\\")?d="\\\\"+d.substr(2).replace(/\\/g,"/"):d=d.replace(/\\/g,"/"),typeof l=="boolean"&&l?(d.startsWith("\\\\")&&(d+="**"),s.push(g(d))):l&&l.when&&(n[d]=l)}),{globArgs:s,siblingClauses:n}}function $(i,o){return h.$hc(o)?o:h.$ic(i,o)}function f(i){return i=R.$lf(i,"\\"),R.$lf(i,"/")}function g(i){return T.$xg(i).toLowerCase()==="c:/"?i.replace(/^c:[/\\]/i,"/"):i}}),define(ke[347],Ie([1,0,56,44,16,348,18,52,38,81,31,10,42,12,17,33,37,345,136]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a,$,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uqc=e.$Tqc=void 0,r=Ue(r),h=Ue(h),C=Ue(C),L=Ue(L),b=Ue(b),c=Ue(c),D=Ue(D),P=Ue(P),w=Ue(w);const i=new Set;process.on("exit",()=>{i.forEach(d=>d())});class o{constructor(l){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=l,this.b=l.filePattern||"",this.d=l.includePattern&&b.$wk(l.includePattern),this.f=l.maxResults||null,this.g=!!l.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=l.shouldGlobMatchFilePattern?null:(0,g.$Nr)(this.b).normalizedLowercase),this.u=l.excludePattern&&b.$wk(l.excludePattern),this.t=new Map,l.folderQueries.forEach(m=>{const E=Object.assign({},m.excludePattern||{},this.a.excludePattern||{}),S=m.folder.fsPath;l.folderQueries.map(y=>y.folder.fsPath).filter(y=>y!==S).forEach(y=>{(0,I.$Bg)(y,S)&&(E[C.$kc(S,y)]=!0)}),this.t.set(S,new s(E,S))})}cancel(){this.l=!0,i.forEach(l=>l())}walk(l,m,E,S,y,k){if(this.m=u.$de.create(!1),this.l)return k(null,this.j);m.forEach(A=>{const p=C.$mc(A.fsPath);this.u&&this.u(A.fsPath,p)||this.J(S,{relativePath:A.fsPath,searchPath:void 0})}),this.r=u.$de.create(!1),this.w(l,(A,p)=>{this.x(this.y,this,A,E,S,y,v=>{if(v){const F=(0,R.$nj)(v);console.error(F),this.q.push(F),p(v,void 0)}else p(null,void 0)})},(A,p)=>{this.m.stop();const v=A?L.$Gb(A)[0]:null;k(v,this.j)})}w(l,m,E){const S=new Array(l.length),y=new Array(l.length);let k=!1,A=0;if(l.length===0)return E(null,[]);l.forEach((p,v)=>{m(p,(F,N)=>{if(F?(k=!0,S[v]=null,y[v]=F):(S[v]=N,y[v]=null),++A===l.length)return E(k?y:null,S)})})}x(l,m,...E){try{l.apply(m,E)}catch(S){E[E.length-1](S)}}y(l,m,E,S,y){const k=l.folder.fsPath,A=D.$k,p=()=>j&&j.kill();i.add(p);let v=K=>{i.delete(p),v=()=>{},y(K)},F="";const N=this.D(),O=(0,f.$Qqc)(this.a,l,this.a.includePattern,this.t.get(l.folder.fsPath).expression,m),j=O.cmd,z=!Object.keys(O.siblingClauses).length,M=O.rgArgs.args.map(K=>K.match(/^-/)?K:`'${K}'`).join(" ");let V=`${O.rgDiskPath} ${M}
 - cwd: ${O.cwd}`;O.rgArgs.siblingClauses&&(V+=`
 - Sibling clauses: ${JSON.stringify(O.rgArgs.siblingClauses)}`),S({message:V}),this.s=0,this.z(j,"utf8",S,(K,ne,B)=>{if(K){v(K);return}if(this.j){v();return}const Y=(F+(A?c.$jm(ne||""):ne)).split(`
`);if(B){const ee=Y.length;Y[ee-1]=Y[ee-1].trim(),Y[ee-1]||Y.pop()}else F=Y.pop()||"";if(Y.length&&Y[0].indexOf(`
`)!==-1){v(new Error("Splitting up files failed"));return}if(this.s+=Y.length,z){for(const ee of Y)if(this.J(E,{base:k,relativePath:ee,searchPath:this.N(l,ee)}),this.j){p();break}(B||this.j)&&v();return}this.G(l,N,k,Y,E),B&&(this.H(N,k,E),v())})}spawnFindCmd(l){const m=this.t.get(l.folder.fsPath),E=m.getBasenameTerms(),S=m.getPathTerms(),y=["-L","."];if(E.length||S.length){y.push("-not","(","(");for(const k of E)y.push("-name",k),y.push("-o");for(const k of S)y.push("-path",k),y.push("-o");y.pop(),y.push(")","-prune",")")}return y.push("-type","f"),r.spawn("find",y,{cwd:l.folder.fsPath})}readStdout(l,m,E){let S="";this.z(l,m,()=>{},(y,k,A)=>{if(y){E(y);return}S+=k,A&&E(null,S)})}z(l,m,E,S){let y=(p,v,F)=>{(p||F)&&(y=()=>{},this.r?.stop()),S(p,v,F)},k=!1;l.stdout?(this.A(l.stdout,m,y),l.stdout.once("data",()=>k=!0)):E({message:"stdout is null"});let A;l.stderr?A=this.B(l.stderr):E({message:"stderr is null"}),l.on("error",p=>{y(p)}),l.on("close",p=>{let v;!k&&(v=this.C(A,m))&&n(v)?y(new Error(`command failed with error code ${p}: ${this.C(A,m)}`)):(this.g&&p===0&&(this.j=!0),y(null,"",!0))})}A(l,m,E){const S=new T.StringDecoder(m);return l.on("data",y=>{E(null,S.write(y))}),S}B(l){const m=[];return l.on("data",E=>{m.push(E)}),m}C(l,m){const E=new T.StringDecoder(m);return l.map(S=>E.write(S)).join("")}D(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}G(l,{pathToEntries:m},E,S,y){S.indexOf(this.b)!==-1&&this.J(y,{base:E,relativePath:this.b,searchPath:this.N(l,this.b)});const k=A=>{const p=C.$mc(A),v=C.$lc(A);let F=m[v];F||(F=m[v]=[],k(v)),F.push({base:E,relativePath:A,basename:p,searchPath:this.N(l,A)})};S.forEach(k)}H({rootEntries:l,pathToEntries:m},E,S){const y=this,k=this.t.get(E),A=this.b;function p(v){y.o++;const F=(0,$.$$L)(()=>v.map(N=>N.basename));for(let N=0,O=v.length;N<O;N++){const j=v[N],{relativePath:z,basename:M}=j;if(k.test(z,M,A!==M?F:void 0))continue;const V=m[z];if(V)p(V);else{if(y.p++,z===A)continue;y.J(S,j)}if(y.j)break}}p(l)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(l,m,E,S,y){const k=l.folder,A=(0,$.$$L)(()=>E);this.w(E,(p,v)=>{if(this.l||this.j)return v(null);const F=m?[m,p].join(C.sep):p;if(this.t.get(l.folder.fsPath).test(F,p,this.a.filePattern!==p?A:void 0))return v(null);const N=[k.fsPath,F].join(C.sep);h.lstat(N,(O,j)=>{if(O||this.l||this.j)return v(null);this.L(N,j,(z,M)=>z||this.l||this.j?v(null):M.isDirectory()?(this.o++,this.M(N,j,(V,K)=>V||this.l||this.j||(K=K||"",this.v[K])?v(null):(this.v[K]=!0,a.Promises.readdir(N).then(ne=>{if(this.l||this.j)return v(null);this.I(l,F,ne,S,B=>v(B||null))},ne=>{v(null)})))):(this.p++,F===this.b||this.h&&w.$gg(M.size)&&M.size>this.h||this.J(S,{base:k.fsPath,relativePath:F,searchPath:this.N(l,F)}),v(null,void 0)))})},p=>{const v=p&&L.$Gb(p);return y(v&&v.length>0?v[0]:void 0)})}J(l,m){this.K(m)&&(!this.d||this.d(m.relativePath,C.$mc(m.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||l(m))}K(l){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,$.$6L)(l,this.c);if(this.b)return(0,$.$6L)(l,this.b,!1)}return!0}L(l,m,E){return m.isSymbolicLink()?h.stat(l,E):E(null,m)}M(l,m,E){return m.isSymbolicLink()?h.realpath(l,(S,y)=>S?E(S):E(null,y)):E(null,l)}N(l,m){return l.folderName?C.$ic(l.folderName,m):m}}e.$Tqc=o;class t{constructor(l,m){this.a=l.folderQueries,this.b=l.extraFileResources||[],this.d=m,this.c=new o(l)}search(l,m,E){this.c.walk(this.a,this.b,this.d,l,m,(S,y)=>{E(S,{limitHit:y,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$Uqc=t;class s{constructor(l,m){this.expression=l,this.c=m,this.d(l)}d(l){let m,E;Object.keys(l).filter(S=>l[S]).forEach(S=>{C.$hc(S)?(m=m||b.$rk(),m[S]=l[S]):(E=E||b.$rk(),E[S]=l[S])}),this.a=m&&b.$wk(m,{trimForExclusions:!0}),this.b=E&&b.$wk(E,{trimForExclusions:!0})}test(l,m,E){return this.b&&this.b(l,m,E)||this.a&&this.a(C.$ic(this.c,l),m,E)}getBasenameTerms(){const l=[];return this.a&&l.push(...b.$yk(this.a)),this.b&&l.push(...b.$yk(this.b)),l}getPathTerms(){const l=[];return this.a&&l.push(...b.$zk(this.a)),this.b&&l.push(...b.$zk(this.b)),l}}function n(d){const l=d.trim().split(`
`),m=l[0].trim();if(m.startsWith("Error parsing regex"))return m;if(m.startsWith("regex parse error"))return P.$7f(l[l.length-1].trim());if(m.startsWith("error parsing glob")||m.startsWith("unsupported encoding"))return m.charAt(0).toUpperCase()+m.substr(1);if(m==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(m.startsWith("Literal "))return m}}),define(ke[349],Ie([1,0,105,21,188,20,18]),function(me,e,r,h,C,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IE=e.$HE=e.$zE=e.DecodeStreamErrorKind=e.$yE=e.$xE=e.$wE=e.$uE=e.$tE=e.$sE=e.$rE=void 0,e.$vE=R,e.$AE=a,e.$BE=$,e.$CE=f,e.$DE=g,e.$EE=i,e.$FE=E,e.$GE=S,e.$rE="utf8",e.$sE="utf8bom",e.$tE="utf16be",e.$uE="utf16le";function R(y){return[e.$rE,e.$sE,e.$tE,e.$uE].some(k=>k===y)}e.$wE=[254,255],e.$xE=[255,254],e.$yE=[239,187,191];const b=512,c=512,I=512*8,D=512*128;var u;(function(y){y[y.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(u||(e.DecodeStreamErrorKind=u={}));class P extends Error{constructor(k,A){super(k),this.decodeStreamErrorKind=A}}e.$zE=P;class w{static async create(k){let A;if(k!==e.$rE)A=(await(0,C.$qE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(g(k));else{const p=new TextDecoder;A={write(v){return p.decode(v,{stream:!0})},end(){return p.decode()}}}return new w(A)}constructor(k){this.a=k}write(k){return this.a.write(k)}end(){return this.a.end()}}function a(y,k){const A=k.minBytesRequiredForDetection??k.guessEncoding?I:c;return new Promise((p,v)=>{const F=(0,r.$ze)(V=>V.join("")),N=[];let O=0,j;const z=new T.$ue,M=async()=>{try{const V=await S({buffer:h.$Le.concat(N),bytesRead:O},k.guessEncoding,k.candidateGuessEncodings);if(V.seemsBinary&&k.acceptTextOnly)throw new P("Stream is binary but only text is accepted for decoding",u.STREAM_IS_BINARY);V.encoding=await k.overwriteEncoding(V.encoding),j=await w.create(V.encoding);const K=j.write(h.$Le.concat(N).buffer);F.write(K),N.length=0,O=0,p({stream:F,detected:V})}catch(V){z.cancel(),F.destroy(),v(V)}};(0,r.$De)(y,{onData:async V=>{j?F.write(j.write(V.buffer)):(N.push(V),O+=V.byteLength,O>=A&&(y.pause(),await M(),setTimeout(()=>y.resume())))},onError:V=>F.error(V),onEnd:async()=>{j||await M(),F.end(j?.end())}},z.token)})}async function $(y,k,A){const v=(await(0,C.$qE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(g(k),A);let F=!1,N=!1;return{read(){if(N)return null;const O=y.read();if(typeof O!="string"){if(N=!0,!F&&A?.addBOM)switch(k){case e.$rE:case e.$sE:return h.$Le.wrap(Uint8Array.from(e.$yE));case e.$tE:return h.$Le.wrap(Uint8Array.from(e.$wE));case e.$uE:return h.$Le.wrap(Uint8Array.from(e.$xE))}const j=v.end();return j&&j.length>0?(F=!0,h.$Le.wrap(j)):null}return F=!0,h.$Le.wrap(v.write(O))}}}async function f(y){return(await(0,C.$qE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(g(y))}function g(y){return y===e.$sE||y===null?e.$rE:y}function i(y,k){if(!y||k<e.$wE.length)return null;const A=y.readUInt8(0),p=y.readUInt8(1);if(A===e.$wE[0]&&p===e.$wE[1])return e.$tE;if(A===e.$xE[0]&&p===e.$xE[1])return e.$uE;if(k<e.$yE.length)return null;const v=y.readUInt8(2);return A===e.$yE[0]&&p===e.$yE[1]&&v===e.$yE[2]?e.$sE:null}const o=["ascii","utf-16","utf-32"];async function t(y,k){const A=await(0,C.$qE)("jschardet","dist/jschardet.min.js"),p=y.slice(0,D),v=m(p.buffer);k&&(k=(0,L.$Gb)(k.map(O=>l(O))),k.length===0&&(k=void 0));const F=A.detect(v,k?{detectEncodings:k}:void 0);if(!F||!F.encoding)return null;const N=F.encoding.toLowerCase();return 0<=o.indexOf(N)?null:d(F.encoding)}const s={ibm866:"cp866",big5:"cp950"};function n(y){return y.replace(/[^a-zA-Z0-9]/g,"").toLowerCase()}function d(y){const k=n(y);return s[k]||k}function l(y){const k=n(y);return e.$IE[k].guessableName}function m(y){let k="";for(let A=0;A<y.length;A++)k+=String.fromCharCode(y[A]);return k}function E(y){switch(y){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const k=y.match(/windows(\d+)/);return k?"windows-"+k[1]:y}}}function S({buffer:y,bytesRead:k},A,p){let v=i(y,k),F=!1;if(v!==e.$tE&&v!==e.$uE&&y){let N=!0,O=!0,j=!1;for(let z=0;z<k&&z<b;z++){const M=z%2===1,V=y.readUInt8(z)===0;if(V&&(j=!0),N&&(M&&!V||!M&&V)&&(N=!1),O&&(M&&V||!M&&!V)&&(O=!1),V&&!N&&!O)break}j&&(N?v=e.$uE:O?v=e.$tE:F=!0)}return A&&!F&&!v&&y?t(y.slice(0,k),p).then(N=>({seemsBinary:!1,encoding:N})):{seemsBinary:F,encoding:v}}e.$HE={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom",guessableName:"UTF-8"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3,guessableName:"UTF-16LE"},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4,guessableName:"UTF-16BE"},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5,guessableName:"windows-1252"},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16,guessableName:"windows-1250"},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17,guessableName:"ISO-8859-2"},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19,guessableName:"windows-1251"},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20,guessableName:"IBM866"},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21,guessableName:"ISO-8859-5"},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22,guessableName:"KOI8-R"},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25,guessableName:"windows-1253"},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26,guessableName:"ISO-8859-7"},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27,guessableName:"windows-1255"},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28,guessableName:"ISO-8859-8"},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36,guessableName:"Big5"},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38,guessableName:"SHIFT_JIS"},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39,guessableName:"EUC-JP"},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40,guessableName:"EUC-KR"},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45,guessableName:"GB2312"},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}},e.$IE=(()=>{const y={};for(const k in e.$HE)e.$HE[k].guessableName&&(y[k]=e.$HE[k]);return y})()}),define(ke[172],Ie([1,0,349,33,171]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3qc=void 0,h=Ue(h);class T extends C.$Ppc{constructor(R,b,c=h,I="searchProcess"){super({query:R,provider:b},{readdir:D=>c.Promises.readdir(D.fsPath),toCanonicalName:D=>(0,r.$FE)(D)},I)}}e.$3qc=T}),define(ke[173],Ie([1,0,56,364,348,18,78,38,12,2,37,99,365,346,129]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wqc=e.$Vqc=void 0,e.$Xqc=s,e.$Yqc=d,e.$Zqc=m,e.$1qc=E,e.$2qc=y,r=Ue(r);const a=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class ${constructor(A,p){this.a=A,this.b=p}provideTextSearchResults(A,p,v,F){return this.a.appendLine(`provideTextSearchResults ${A.pattern}, ${JSON.stringify({...p,folder:p.folder.toString()})}`),new Promise((N,O)=>{F.onCancellationRequested(()=>Y());const j={...p,numThreads:this.b},z=s(A,j),M=p.folder.fsPath,V=z.map($e=>$e.match(/^-/)?$e:`'${$e}'`).join(" ");this.a.appendLine(`${a} ${V}
 - cwd: ${M}`);let K=r.spawn(a,z,{cwd:M});K.on("error",$e=>{console.error($e),this.a.appendLine("Error: "+($e&&$e.message)),O((0,I.$2L)(new I.$ZL($e&&$e.message,I.SearchErrorCode.rgProcessError)))});let ne=!1;const B=new i(p.maxResults,p.folder,p.previewOptions);B.on("result",$e=>{ne=!0,ue="",v.report($e)});let G=!1;const Y=()=>{G=!0,K?.kill(),B?.cancel()};let ee=!1;B.on("hitLimit",()=>{ee=!0,Y()});let ue="";K.stdout.on("data",$e=>{B.handleData($e),ne||(ue+=$e)});let re=!1;K.stdout.once("data",()=>re=!0);let ye="";K.stderr.on("data",$e=>{const J=$e.toString();this.a.appendLine(J),ye.length+J.length<1e6&&(ye+=J)}),K.on("close",()=>{if(this.a.appendLine(re?"Got data from stdout":"No data from stdout"),this.a.appendLine(ne?"Got result from parser":"No result from parser"),ue&&this.a.appendLine(`Got data without result: ${ue}`),this.a.appendLine(""),G)N({limitHit:ee});else{B.flush(),K=null;let $e;ye&&!re&&($e=f(ye))?O((0,I.$2L)(new I.$ZL($e.message,$e.code))):N({limitHit:ee})}})})}}e.$Vqc=$;function f(k){const A=k.split(`
`),p=A[0].trim();if(A.some(F=>F.startsWith("regex parse error")))return new I.$ZL(g(A),I.SearchErrorCode.regexParseError);const v=p.match(/grep config error: unknown encoding: (.*)/);if(v)return new I.$ZL(`Unknown encoding: ${v[1]}`,I.SearchErrorCode.unknownEncoding);if(p.startsWith("error parsing glob"))return new I.$ZL(p.charAt(0).toUpperCase()+p.substr(1),I.SearchErrorCode.globParseError);if(p.startsWith("the literal"))return new I.$ZL(p.charAt(0).toUpperCase()+p.substr(1),I.SearchErrorCode.invalidLiteral);if(p.startsWith("PCRE2: error compiling pattern"))return new I.$ZL(p,I.SearchErrorCode.regexParseError)}function g(k){const A=["Regex parse error"],p=k.filter(v=>v.startsWith("PCRE2:"));if(p.length>=1){const v=p[0].replace("PCRE2:","");if(v.indexOf(":")!==-1&&v.split(":").length>=2){const F=v.split(":")[1];A.push(":"+F)}}return A.join("")}class i extends h.EventEmitter{constructor(A,p,v){super(),this.g=A,this.h=p,this.j=v,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new C.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(A,p){return super.on(A,p),this}handleData(A){if(this.b)return;const p=typeof A=="string"?A:this.d.write(A);this.k(p)}k(A){let p=A.indexOf(`
`);const v=this.a+A;if(p>=0)p+=this.a.length;else{this.a=v;return}let F=0;for(;p>=0;)this.m(v.substring(F,p).trim()),F=p+1,p=v.indexOf(`
`,F);this.a=v.substring(F)}m(A){if(this.b||!A)return;let p;try{p=JSON.parse(A)}catch{throw new Error(`malformed line from rg: ${A}`)}if(p.type==="match"){const v=o(p.data.path),F=c.URI.joinPath(this.h,v),N=this.n(p.data,F);this.p(N),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(p.type==="context"){const v=o(p.data.path),F=c.URI.joinPath(this.h,v);this.o(p.data,F).forEach(O=>this.p(O))}}n(A,p){const v=A.line_number-1,F=o(A.lines),N=Buffer.from(F);let O=0,j=0,z=v;A.submatches.length===0&&A.submatches.push(F.length?{start:0,end:1,match:{text:F[0]}}:{start:0,end:0,match:{text:""}});const M=(0,T.$Gb)(A.submatches.map((V,K)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ne=o(V.match),B=N.slice(O,V.start).toString(),G=t(B),Y=G.numLines>0?G.lastLineLength:G.lastLineLength+j,ee=t(ne),ue=G.numLines+z,re=ee.numLines+ue,ye=ee.numLines>0?ee.lastLineLength:ee.lastLineLength+Y;return O=V.end,j=ye,z=re,new D.$IL(ue,Y,re,ye)}));return(0,w.$Oqc)(p,F,M,this.j)}o(A,p){const v=o(A.lines),F=A.line_number;return v.replace(/\r?\n$/,"").split(`
`).map((N,O)=>({text:N,uri:p,lineNumber:F+O}))}p(A){this.emit("result",A)}}e.$Wqc=i;function o(k){return k.bytes?Buffer.from(k.bytes,"base64").toString():k.text}function t(k){const A=/\n/g;let p=0,v=-1,F;for(;F=A.exec(k);)p++,v=F.index;const N=v>=0?k.length-v-1:k.length;return{numLines:p,lastLineLength:N}}function s(k,A){const p=["--hidden","--no-require-git"];p.push(k.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:v,otherIncludes:F}=(0,L.$c)(A.includes,O=>O.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(F&&F.length){const O=new Set;F.forEach(j=>{O.add(j)}),p.push("-g","!*"),O.forEach(j=>{n(j).map(w.$Nqc).forEach(z=>{p.push("-g",z)})})}v&&v.length&&v.forEach(O=>{p.push("-g",O)}),A.excludes.map(w.$Nqc).forEach(O=>p.push("-g",`!${O}`)),A.maxFileSize&&p.push("--max-filesize",A.maxFileSize+""),A.useIgnoreFiles?A.useParentIgnoreFiles||p.push("--no-ignore-parent"):p.push("--no-ignore"),A.followSymlinks&&p.push("--follow"),A.encoding&&A.encoding!=="utf8"&&p.push("--encoding",A.encoding),A.numThreads&&p.push("--threads",`${A.numThreads}`),k.pattern==="--"&&(k.isRegExp=!0,k.pattern="\\-\\-"),k.isMultiline&&!k.isRegExp&&(k.pattern=(0,b.$ff)(k.pattern),k.isRegExp=!0),A.usePCRE2&&p.push("--pcre2"),p.push("--crlf"),k.isRegExp&&(k.pattern=d(k.pattern),p.push("--engine","auto"));let N;if(k.isWordMatch){const j=(0,b.$of)(k.pattern,!!k.isRegExp,{wholeWord:k.isWordMatch}).source.replace(/\\\//g,"/");p.push("--regexp",j)}else if(k.isRegExp){let O=m(k.pattern);O=E(O),p.push("--regexp",O)}else N=k.pattern,p.push("--fixed-strings");return p.push("--no-config"),A.useGlobalIgnoreFiles||p.push("--no-ignore-global"),p.push("--json"),k.isMultiline&&p.push("--multiline"),A.beforeContext&&p.push("--before-context",A.beforeContext+""),A.afterContext&&p.push("--after-context",A.afterContext+""),p.push("--"),N&&p.push(N),p.push("."),p}function n(k){return y(k).flatMap(p=>{const v=(0,R.$uk)(p,"/");return v.map((F,N)=>v.slice(0,N+1).join("/"))})}function d(k){const A=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;k.match(A);)k=k.replace(A,"$1\\x{$2}");const p=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;k.match(p);)k=k.replace(p,"$1\\x{$2}");return k}const l=k=>k.type==="Assertion"&&k.kind==="lookbehind";function m(k){let A;try{A=new u.RegExpParser().parsePattern(k)}catch{return k}let p="",v=0;const F=(j,z,M)=>{p+=k.slice(v,j)+M,v=z},N=[];return new u.RegExpVisitor({onCharacterEnter(j){if(j.raw!=="\\n")return;const z=N[0];if(!z)F(j.start,j.end,"\\r?\\n");else if(!N.some(l))if(z.type==="CharacterClass")if(z.negate){const M=k.slice(z.start+2,j.start)+k.slice(j.end,z.end-1);z.parent?.type==="Quantifier"?F(z.start,z.end,M?`[^${M}]`:"."):F(z.start,z.end,"(?!\\r?\\n"+(M?`|[${M}]`:"")+")")}else{const M=k.slice(z.start+1,j.start)+k.slice(j.end,z.end-1);F(z.start,z.end,M===""?"\\r?\\n":`(?:[${M}]|\\r?\\n)`)}else z.type==="Quantifier"&&F(j.start,j.end,"(?:\\r?\\n)")},onQuantifierEnter(j){N.unshift(j)},onQuantifierLeave(){N.shift()},onCharacterClassRangeEnter(j){N.unshift(j)},onCharacterClassRangeLeave(){N.shift()},onCharacterClassEnter(j){N.unshift(j)},onCharacterClassLeave(){N.shift()},onAssertionEnter(j){l(j)&&N.push(j)},onAssertionLeave(j){N[0]===j&&N.shift()}}).visit(A),p+=k.slice(v),p}function E(k){return k.replace(/\n/g,"\\r?\\n")}function S(k){let A=!1,p=!1,v="",F="";for(let N=0;N<k.length;N++){const O=k[N];switch(O){case"\\":p?(A?F+="\\"+O:v+="\\"+O,p=!1):p=!0;break;case"{":if(p)A?F+=O:v+=O,p=!1;else{if(A)return{strInBraces:v+"{"+F+"{"+k.substring(N+1)};A=!0}break;case"}":if(p)A?F+=O:v+=O,p=!1;else{if(A)return{fixedStart:v,strInBraces:F,fixedEnd:k.substring(N+1)};v+=O}break;default:A?F+=(p?"\\":"")+O:v+=(p?"\\":"")+O,p=!1;break}}return{strInBraces:v+(A?"{"+F:"")}}function y(k){const{fixedStart:A,strInBraces:p,fixedEnd:v}=S(k);if(A===void 0||v===void 0)return[p];let F=(0,R.$uk)(p,",");F.length||(F=[""]);const N=y(v);return F.flatMap(O=>{const j=A+O;return N.map(z=>j+z)})}}),define(ke[350],Ie([1,0,20,173,89,14]),function(me,e,r,h,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6qc=void 0;class L{constructor(c,I){this.b=c,this.c=I,this.a=new Set,process.once("exit",()=>this.e())}async provideTextSearchResults(c,I,D,u){const P=await this.c(),w=new h.$Vqc(this.b,P),a={...I,numThreads:P};if(I.folder.scheme===T.Schemas.vscodeUserData){const $={...a,folder:I.folder.with({scheme:T.Schemas.file})},f=new C.$uw(g=>D.report({...g,uri:g.uri.with({scheme:I.folder.scheme})}));return this.d(u,g=>w.provideTextSearchResults(c,$,f,g))}else return this.d(u,$=>w.provideTextSearchResults(c,a,D,$))}async d(c,I){const D=R(c);this.a.add(D);const u=await I(D.token);return this.a.delete(D),u}e(){this.a.forEach(c=>c.cancel())}}e.$6qc=L;function R(b){const c=new r.$ue;return b.onCancellationRequested(()=>c.cancel()),c}}),define(ke[351],Ie([1,0,33,173,172]),function(me,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4qc=void 0,r=Ue(r);class T{constructor(b,c){this.a=b,this.b=c}search(b,c,I){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"},messages:[]});const D={appendLine(P){I({message:P})}},u=new C.$3qc(this.a,new h.$Vqc(D,this.b),r);return new Promise((P,w)=>u.search(a=>{c(a.map(L))},b).then(a=>P({limitHit:a.limitHit??!1,type:"success",stats:a.stats,messages:[]}),w))}}e.$4qc=T;function L(R){return{path:R.resource&&R.resource.fsPath,results:R.results,numMatches:(R.results||[]).reduce((b,c)=>{if(c.ranges){const I=c;return b+(Array.isArray(I.ranges)?I.ranges.length:1)}else return b+1},0)}}}),define(ke[352],Ie([1,0,18,7,13,4,136,16,42,2,27,37,347,351]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5qc=void 0,r=Ue(r);class w{static{this.a=512}constructor(o="searchProcess",t){this.d=o,this.f=t,this.b=Object.create(null)}fileSearch(o){let t;const s=f(o),n=new T.$je({onDidAddFirstListener:()=>{t=(0,h.$ph)(async d=>{const l=await this.f?.();return this.doFileSearchWithEngine(u.$Uqc,s,m=>n.fire(m),d,w.a,l)}),t.then(d=>n.fire(d),d=>n.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{t.cancel()}});return n.event}textSearch(o){let t;const s=f(o),n=new T.$je({onDidAddFirstListener:()=>{t=(0,h.$ph)(d=>this.g(s,l=>n.fire(l),d)),t.then(d=>n.fire(d),d=>n.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{t.cancel()}});return n.event}async g(o,t,s){o.maxFileSize=this.h().maxFileSize;const n=await this.f?.();return new P.$4qc(o,n).search(s,t,t)}h(){return{maxFileSize:16*I.$El.GB}}doFileSearch(o,t,s,n){return this.doFileSearchWithEngine(u.$Uqc,o,s,n,w.a,t)}doFileSearchWithEngine(o,t,s,n,d=w.a,l){let m=0;const E=y=>{Array.isArray(y)?(m+=y.length,s(y.map(k=>this.j(k)))):y.relativePath?(m++,s(this.j(y))):s(y)};if(t.sortByScore){let y=this.n(t,E,n);if(!y){const k=t.maxResults?Object.assign({},t,{maxResults:null}):t,A=new o(k,l);y=this.k(A,t,s,E,n)}return new Promise((k,A)=>{y.then(([p,v])=>{const F=v.map(N=>this.j(N));this.q(F,s,d),k(p)},A)})}const S=new o(t,l);return this.s(S,E,d,n).then(y=>({limitHit:y.limitHit,type:"success",stats:{detailStats:y.stats,type:this.d,fromCache:!1,resultCount:m,sortingTime:void 0},messages:[]}))}j(o){return{path:o.base?(0,R.$ic)(o.base,o.relativePath):o.relativePath}}k(o,t,s,n,d){const l=new T.$je;let m=(0,h.$ph)(S=>{let y=[];const k=A=>{Array.isArray(A)?y=A:(n(A),l.fire(A))};return this.s(o,k,-1,S).then(A=>[A,y])}),E;if(t.cacheKey){E=this.l(t.cacheKey);const S={promise:m,event:l.event,resolved:!1};E.resultsToSearchCache[t.filePattern||""]=S,m.then(()=>{S.resolved=!0},y=>{delete E.resultsToSearchCache[t.filePattern||""]}),m=this.t(m)}return m.then(([S,y])=>{const k=E?E.scorerCache:Object.create(null),A=(typeof t.maxResults!="number"||t.maxResults>0)&&b.$de.create(!1);return this.o(t,y,k,d).then(p=>{const v=A?A.elapsed():-1;return[{type:"success",stats:{detailStats:S.stats,sortingTime:v,fromCache:!1,type:this.d,resultCount:p.length},messages:S.messages,limitHit:S.limitHit||typeof t.maxResults=="number"&&y.length>t.maxResults},p]})})}l(o){const t=this.b[o];return t||(this.b[o]=new a)}n(o,t,s){const n=o.cacheKey&&this.b[o.cacheKey];if(!n)return;const d=this.r(n,o.filePattern||"",t,s);if(d)return d.then(([l,m,E])=>{const S=b.$de.create(!1);return this.o(o,m,n.scorerCache,s).then(y=>{const k=S.elapsed(),A={fromCache:!0,detailStats:E,type:this.d,resultCount:m.length,sortingTime:k};return[{type:"success",limitHit:l.limitHit||typeof o.maxResults=="number"&&m.length>o.maxResults,stats:A,messages:[]},y]})})}o(o,t,s,n){const d=(0,L.$Nr)(o.filePattern||""),l=(E,S)=>(0,L.$Mr)(E,S,d,!0,$,s),m=typeof o.maxResults=="number"?o.maxResults:D.$OL;return r.$Fb(t,l,m,1e4,n)}q(o,t,s){if(s&&s>0)for(let n=0;n<o.length;n+=s)t(o.slice(n,n+s));else t(o)}r(o,t,s,n){const d=b.$de.create(!1),l=t.indexOf(R.sep)>=0;let m;for(const k in o.resultsToSearchCache)if(t.startsWith(k)){if(l&&k.indexOf(R.sep)<0&&k!=="")continue;const A=o.resultsToSearchCache[k];m={promise:this.t(A.promise),event:A.event,resolved:A.resolved};break}if(!m)return null;const E=d.elapsed(),S=b.$de.create(!1),y=m.event(s);return n&&n.onCancellationRequested(()=>{y.dispose()}),m.promise.then(([k,A])=>{if(n&&n.isCancellationRequested)throw(0,C.$5)();const p=[],v=(0,L.$Nr)(t).normalizedLowercase;for(const F of A)(0,D.$6L)(F,v)&&p.push(F);return[k,p,{cacheWasResolved:m.resolved,cacheLookupTime:E,cacheFilterTime:S.elapsed(),cacheEntryCount:A.length}]})}s(o,t,s,n){return new Promise((d,l)=>{let m=[];n?.onCancellationRequested(()=>o.cancel()),o.search(E=>{E&&(s?(m.push(E),s>0&&m.length>=s&&(t(m),m=[])):t(E))},E=>{t(E)},(E,S)=>{m.length&&t(m),E?(t({message:"Search finished. Error: "+E.message}),l(E)):(t({message:"Search finished. Stats: "+JSON.stringify(S.stats)}),d(S))})})}clearCache(o){return delete this.b[o],Promise.resolve(void 0)}t(o){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(t,s){return o.then(t,s)}catch(t){return this.then(void 0,t)}finally(t){return o.finally(t)}}}}e.$5qc=w;class a{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const $=new class{getItemLabel(i){return(0,R.$mc)(i.relativePath)}getItemDescription(i){return(0,R.$lc)(i.relativePath)}getItemPath(i){return i.relativePath}};function f(i){return{...i,folderQueries:i.folderQueries&&i.folderQueries.map(g),extraFileResources:i.extraFileResources&&i.extraFileResources.map(o=>c.URI.revive(o))}}function g(i){return{...i,folder:c.URI.revive(i.folder)}}}),define(ke[353],Ie([1,0,3,14,2,33,11,41,29,19,102,72,37,352,350,129,172]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7qc=void 0,T=Ue(T);let f=class extends I.$Upc{constructor(i,o,t,s,n){super(i,t,n),this.D=s,this.w=T,this.x=-1,this.y=null,this.z=!1,this.B=new r.$Sc,this.C=!1,this.getNumThreads=this.getNumThreads.bind(this),this.getNumThreadsCached=this.getNumThreadsCached.bind(this),this.E=this.E.bind(this);const d=new a.$Pqc("RipgrepSearchUD",this.q);this.B.add(this.registerTextSearchProvider(h.Schemas.vscodeUserData,new w.$6qc(d,this.getNumThreadsCached))),o.remote.isRemote&&o.remote.authority&&this.F(),s.getConfigProvider().then(l=>{this.C||this.B.add(l.onDidChangeConfiguration(this.E))})}E(i){i.affectsConfiguration("search")&&(this.A=void 0)}async getNumThreads(){return(await this.D.getConfigProvider()).getConfiguration("search").get("ripgrep.maxThreads")}async getNumThreadsCached(){return this.A||(this.A=this.getNumThreads()),this.A}dispose(){this.C=!0,this.B.dispose()}$enableExtensionHostSearch(){this.F()}F(){if(this.z)return;this.z=!0;const i=new a.$Pqc("RipgrepSearchEH",this.q);this.B.add(this.registerTextSearchProvider(h.Schemas.file,new w.$6qc(i,this.getNumThreadsCached))),this.B.add(this.G(h.Schemas.file,new P.$5qc("fileSearchProvider",this.getNumThreadsCached)))}G(i,o){const t=this.d++;return this.y=o,this.x=t,this.c.$registerFileSearchProvider(t,this.s(i)),(0,r.$Rc)(()=>{this.y=null,this.c.$unregisterProvider(t)})}$provideFileSearchResults(i,o,t,s){const n=(0,I.$Vpc)(t);if(i===this.x){const d=Date.now();return this.H(i,o,n,s).then(l=>{const m=Date.now()-d;return this.q.debug(`Ext host file search time: ${m}ms`),l})}return super.$provideFileSearchResults(i,o,t,s)}async doInternalFileSearchWithCustomCallback(i,o,t){const s=d=>{if((0,u.$5L)(d)&&(d=[d]),Array.isArray(d)){t(d.map(l=>C.URI.file(l.path)));return}d.message&&this.q.debug("ExtHostSearch",d.message)};if(!this.y)throw new Error("No internal file search handler");const n=await this.getNumThreadsCached();return this.y.doFileSearch(i,n,s,o)}async H(i,o,t,s){return this.doInternalFileSearchWithCustomCallback(t,s,n=>{this.c.$handleFileMatch(i,o,n)})}$clearCache(i){return this.y?.clearCache(i),super.$clearCache(i)}t(i,o){return new $.$3qc(i,o,void 0,"textSearchProvider")}};e.$7qc=f,e.$7qc=f=Ye([Ve(0,c.$1P),Ve(1,b.$eQ),Ve(2,D.$Goc),Ve(3,R.$Moc),Ve(4,L.$9j)],f)}),define(ke[130],Ie([1,0,366,67,66,367,21,13,4,3,16,10,32,86,68]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$ti=e.$si=e.$ri=void 0,e.$ui=l,e.$vi=m,e.$xi=y,e.$yi=k;const a=3e4;class ${traceSocketEvent(p,v){w.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,p,v)}constructor(p,v=""){this.f=!0,this.debugLabel=v,this.socket=p,this.traceSocketEvent(w.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=N=>{if(this.traceSocketEvent(w.SocketDiagnosticsEventType.Error,{code:N?.code,message:N?.message}),N){if(N.code==="EPIPE")return;(0,R.$Y)(N)}},this.socket.on("error",this.a);let F;this.b=N=>{this.traceSocketEvent(w.SocketDiagnosticsEventType.Close,{hadError:N}),this.f=!1,F&&clearTimeout(F)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,F=setTimeout(()=>p.destroy(),a)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(p){const v=F=>{this.traceSocketEvent(w.SocketDiagnosticsEventType.Read,F),p(L.$Le.wrap(F))};return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose(p){const v=F=>{p({type:w.SocketCloseEventType.NodeSocketCloseEvent,hadError:F,error:void 0})};return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(p){const v=()=>{p()};return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(p){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(w.SocketDiagnosticsEventType.Write,p),this.socket.write(p.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,R.$Y)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,R.$Y)(v)}}end(){this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((p,v)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeDrainEnd),p();return}const F=()=>{this.socket.off("close",F),this.socket.off("end",F),this.socket.off("error",F),this.socket.off("timeout",F),this.socket.off("drain",F),this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeDrainEnd),p()};this.socket.on("close",F),this.socket.on("end",F),this.socket.on("error",F),this.socket.on("timeout",F),this.socket.on("drain",F)})}}e.$ri=$;var f;(function(A){A[A.MinHeaderByteSize=2]="MinHeaderByteSize",A[A.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var g;(function(A){A[A.PeekHeader=1]="PeekHeader",A[A.ReadHeader=2]="ReadHeader",A[A.ReadBody=3]="ReadBody",A[A.Fin=4]="Fin"})(g||(g={}));class i extends c.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(p,v){this.socket.traceSocketEvent(p,v)}constructor(p,v,F,N){super(),this.f=this.B(new b.$je),this.g=this.B(new b.$je),this.h=!1,this.j={state:g.PeekHeader,readLen:f.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=p,this.traceSocketEvent(w.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:v,inflateBytesLength:F?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new o(this,v,F,N,this.f,(O,j)=>this.m(O,j))),this.B(this.a.onError(O=>{console.error(O),(0,R.$Y)(O),this.g.fire({type:w.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:O})})),this.b=new w.$mi,this.B(this.socket.onData(O=>this.n(O))),this.B(this.socket.onClose(async O=>{this.a.isProcessingReadQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(O)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(p){return this.f.event(p)}onClose(p){return this.g.event(p)}onEnd(p){return this.socket.onEnd(p)}write(p){let v=0;for(;v<p.byteLength;)this.a.writeMessage(p.slice(v,Math.min(v+f.MaxWebSocketMessageLength,p.byteLength)),{compressed:!0,opcode:2}),v+=f.MaxWebSocketMessageLength}m(p,{compressed:v,opcode:F}){if(this.h)return;this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,p);let N=f.MinHeaderByteSize;p.byteLength<126?N+=0:p.byteLength<2**16?N+=2:N+=8;const O=L.$Le.alloc(N),j=v?64:0,z=F&15;if(O.writeUInt8(128|j|z,0),p.byteLength<126)O.writeUInt8(p.byteLength,1);else if(p.byteLength<2**16){O.writeUInt8(126,1);let M=1;O.writeUInt8(p.byteLength>>>8&255,++M),O.writeUInt8(p.byteLength>>>0&255,++M)}else{O.writeUInt8(127,1);let M=1;O.writeUInt8(0,++M),O.writeUInt8(0,++M),O.writeUInt8(0,++M),O.writeUInt8(0,++M),O.writeUInt8(p.byteLength>>>24&255,++M),O.writeUInt8(p.byteLength>>>16&255,++M),O.writeUInt8(p.byteLength>>>8&255,++M),O.writeUInt8(p.byteLength>>>0&255,++M)}this.socket.write(L.$Le.concat([O,p]))}end(){this.h=!0,this.socket.end()}n(p){if(p.byteLength!==0){for(this.b.acceptChunk(p);this.b.byteLength>=this.j.readLen;)if(this.j.state===g.PeekHeader){const v=this.b.peek(this.j.readLen),F=v.readUInt8(0),N=(F&128)>>>7,O=(F&64)>>>6,j=F&15,z=v.readUInt8(1),M=(z&128)>>>7,V=z&127;this.j.state=g.ReadHeader,this.j.readLen=f.MinHeaderByteSize+(M?4:0)+(V===126?2:0)+(V===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!O),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=j,this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===g.ReadHeader){const v=this.b.read(this.j.readLen),F=v.readUInt8(1),N=(F&128)>>>7;let O=F&127,j=1;O===126?O=v.readUInt8(++j)*2**8+v.readUInt8(++j):O===127&&(O=v.readUInt8(++j)*0+v.readUInt8(++j)*0+v.readUInt8(++j)*0+v.readUInt8(++j)*0+v.readUInt8(++j)*2**24+v.readUInt8(++j)*2**16+v.readUInt8(++j)*2**8+v.readUInt8(++j));let z=0;N&&(z=v.readUInt8(++j)*2**24+v.readUInt8(++j)*2**16+v.readUInt8(++j)*2**8+v.readUInt8(++j)),this.j.state=g.ReadBody,this.j.readLen=O,this.j.mask=z,this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===g.ReadBody){const v=this.b.read(this.j.readLen);this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,v),n(v,this.j.mask),this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,v),this.j.state=g.PeekHeader,this.j.readLen=f.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(v,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(v,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$si=i;class o extends c.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:L.$Le.alloc(0)}constructor(p,v,F,N,O,j){super(),this.n=p,this.r=O,this.s=j,this.a=this.B(new b.$je),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new b.$je),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new b.$je),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,v?(this.b=this.B(new t(this.n,N,F,{windowBits:15})),this.f=this.B(new s(this.n,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(p,v){this.g.push({data:p,options:v}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:p,options:v}=this.g.shift();if(this.f&&v.compressed){const F=await this.w(this.f,p);this.s(F,v)}else this.s(p,{...v,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(p,v){return new Promise((F,N)=>{p.write(v),p.flush(O=>F(O))})}acceptFrame(p,v,F){this.h.push({data:p,isCompressed:v,isLastFrameOfMessage:F}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const p=this.h.shift();if(this.b&&p.isCompressed){const v=await this.C(this.b,p.data,p.isLastFrameOfMessage);this.r.fire(v)}else this.r.fire(p.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(p,v,F){return new Promise((N,O)=>{p.write(v),F&&p.write(L.$Le.fromByteArray([0,0,255,255])),p.flush(j=>N(j))})}}class t extends c.$Tc{get recordedInflateBytes(){return this.j?L.$Le.concat(this.f):L.$Le.alloc(0)}constructor(p,v,F,N){super(),this.h=p,this.j=v,this.a=this.B(new b.$je),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,T.createInflateRaw)(N),this.b.on("error",O=>{this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateError,{message:O?.message,code:O?.code}),this.a.fire(O)}),this.b.on("data",O=>{this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateData,O),this.g.push(L.$Le.wrap(O))}),F&&(this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateInitialWrite,F.buffer),this.b.write(F.buffer),this.b.flush(()=>{this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(p){this.j&&this.f.push(p.clone()),this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateWrite,p),this.b.write(p.buffer)}flush(p){this.b.flush(()=>{this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateFlushFired);const v=L.$Le.concat(this.g);this.g.length=0,p(v)})}}class s extends c.$Tc{constructor(p,v){super(),this.g=p,this.a=this.B(new b.$je),this.onError=this.a.event,this.f=[],this.b=(0,T.createDeflateRaw)({windowBits:15}),this.b.on("error",F=>{this.g.traceSocketEvent(w.SocketDiagnosticsEventType.zlibDeflateError,{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.g.traceSocketEvent(w.SocketDiagnosticsEventType.zlibDeflateData,F),this.f.push(L.$Le.wrap(F))})}write(p){this.g.traceSocketEvent(w.SocketDiagnosticsEventType.zlibDeflateWrite,p.buffer),this.b.write(p.buffer)}flush(p){this.b.flush(2,()=>{this.g.traceSocketEvent(w.SocketDiagnosticsEventType.zlibDeflateFlushFired);let v=L.$Le.concat(this.f);this.f.length=0,v=v.slice(0,v.byteLength-4),p(v)})}}function n(A,p){if(p===0)return;const v=A.byteLength>>>2;for(let M=0;M<v;M++){const V=A.readUInt32BE(M*4);A.writeUInt32BE(V^p,M*4)}const F=v*4,N=A.byteLength-F,O=p>>>24&255,j=p>>>16&255,z=p>>>8&255;N>=1&&A.writeUInt8(A.readUInt8(F)^O,F),N>=2&&A.writeUInt8(A.readUInt8(F+1)^j,F+1),N>=3&&A.writeUInt8(A.readUInt8(F+2)^z,F+2)}e.$ti=process.env.XDG_RUNTIME_DIR;const d={[D.Platform.Linux]:107,[D.Platform.Mac]:103};function l(){const A=(0,u.$Yg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${A}-sock`;const p=process.platform!=="darwin"&&e.$ti?e.$ti:(0,C.tmpdir)(),v=(0,I.$ic)(p,`vscode-ipc-${A}.sock`);return E(v),v}function m(A,p,v){const N=(0,r.createHash)("sha256").update(A).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${v}-${p}-sock`;const O=v.substr(0,4),j=p.substr(0,6);let z;return process.platform!=="darwin"&&e.$ti&&!process.env.VSCODE_PORTABLE?z=(0,I.$ic)(e.$ti,`vscode-${N}-${O}-${j}.sock`):z=(0,I.$ic)(A,`${O}-${j}.sock`),E(z),z}function E(A){const p=d[D.$v];typeof p=="number"&&A.length>=p&&console.warn(`WARNING: IPC handle "${A}" is longer than ${p} chars, try a shorter --user-data-dir`)}class S extends P.$gi{static b(p){const v=b.Event.fromNodeEventEmitter(p,"connection");return b.Event.map(v,F=>({protocol:new w.$ni(new $(F,"ipc-server-connection")),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(F,"close"))}))}constructor(p){super(S.b(p)),this.d=p}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$wi=S;function y(A){return new Promise((p,v)=>{const F=(0,h.createServer)();F.on("error",v),F.listen(A,()=>{F.removeListener("error",v),p(new S(F))})})}function k(A,p){return new Promise((v,F)=>{const N=(0,h.createConnection)(A,()=>{N.removeListener("error",F),v(w.$oi.fromSocket(new $(N,`ipc-client${p}`),p))});N.once("error",F)})}}),define(ke[354],Ie([1,0,67,66,190,130,7,3,10,45,11,115,233,235,117,92,21]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sgc=e.$Rgc=e.$Qgc=e.$Pgc=void 0,r=Ue(r),h=Ue(h);async function f(s,n,d,l,m){let E;for(let S=3;S&&(E?.dispose(),E=await new g(s,n,d,l,m).waitForReady(),!(m&&C.$2g[m]||!C.$2g[E.tunnelLocalPort]));S--);return E}class g extends R.$Tc{constructor(n,d,l,m,E){super(),this.m=d,this.n=E,this.privacy=a.TunnelPrivacyId.Private,this.j=new Map,this.a=n,this.b=r.createServer(),this.c=new L.$Bh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=S=>this.r(S),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=m,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(d=>{d()})}async waitForReady(){const n=this.n??this.tunnelRemotePort,d=(0,a.$Hw)(this.m)?"0.0.0.0":"127.0.0.1";let l=await(0,C.$3g)(n,2,1e3,d),m=null;return this.b.listen(l,this.m),await this.c.wait(),m=this.b.address(),m||(l=0,this.b.listen(l,this.m),await this.c.wait(),m=this.b.address()),this.tunnelLocalPort=m.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${m.port}`,this}async r(n){n.pause();const d=(0,a.$Fw)(this.tunnelRemoteHost)||(0,a.$Hw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,u.$Yl)(this.a,d,this.tunnelRemotePort),m=l.getSocket(),E=l.readEntireBuffer();l.dispose(),E.byteLength>0&&n.write(E.buffer),n.on("end",()=>{n.localAddress&&this.j.delete(n.localAddress),m.end()}),n.on("close",()=>m.end()),n.on("error",()=>{n.localAddress&&this.j.delete(n.localAddress),m instanceof T.$ri?m.socket.destroy():m.end()}),m instanceof T.$ri?this.t(n,m):this.s(n,m),n.localAddress&&this.j.set(n.localAddress,()=>{n.end(),m.end()})}s(n,d){d.onClose(()=>n.destroy()),d.onEnd(()=>n.end()),d.onData(l=>n.write(l.buffer)),n.on("data",l=>d.write($.$Le.wrap(l))),n.resume()}t(n,d){const l=d.socket;l.on("end",()=>n.end()),l.on("close",()=>n.end()),l.on("error",()=>{n.destroy()}),l.pipe(n),n.pipe(l)}}e.$Pgc=g;let i=class extends a.$Kw{constructor(n,d,l,m,E){super(d,E),this.H=n,this.I=l,this.J=m}isPortPrivileged(n){return(0,a.$Iw)(n,this.t,b.OS,h.release())}F(n,d,l,m,E,S,y,k){const A=this.D(d,l);if(A)return++A.refcount,A.value;if((0,a.$Bw)(n))return this.G(n,d,l,E,S,y,k);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${l} on local port ${E}.`);const p={commit:this.J.commit,quality:this.J.quality,addressProvider:n,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},v=f(p,m,d,l,E);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(d,l,v),v}}};e.$Qgc=i,e.$Qgc=i=Ye([Ve(0,P.$Sl),Ve(1,I.$9j),Ve(2,w.$Vl),Ve(3,D.$pk),Ve(4,c.$9i)],i);let o=class extends i{constructor(n,d,l,m,E){super(n,d,l,m,E)}};e.$Rgc=o,e.$Rgc=o=Ye([Ve(0,P.$Sl),Ve(1,I.$9j),Ve(2,w.$Vl),Ve(3,D.$pk),Ve(4,c.$9i)],o);let t=class extends R.$Tc{constructor(n,d,l,m,E){super(),this.b=n,this.c=d,this.f=l,this.g=m,this.h=E,this.a=new Map}async openTunnel(n,d,l,m,E,S,y,k,A){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${m} on local port ${S}.`),!this.a.has(n)){const p=new o(this.b,this.c,this.g,this.f,this.h);this.B(p),this.a.set(n,p),p.onTunnelClosed(async()=>{(await p.tunnels).length===0&&(p.dispose(),this.a.delete(n))})}return this.a.get(n).openTunnel(d,l,m,E,S,y,k,A)}};e.$Sgc=t,e.$Sgc=t=Ye([Ve(0,P.$Sl),Ve(1,I.$9j),Ve(2,D.$pk),Ve(3,w.$Vl),Ve(4,c.$9i)],t)}),define(ke[355],Ie([1,0,130,252,44,34,2,11,46]),function(me,e,r,h,C,T,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qQ=e.$pQ=void 0,h=Ue(h),C=Ue(C);class c{constructor(u,P,w){this.b=u,this.c=P,this.f=w,this.a=h.createServer((a,$)=>this.h(a,$)),this.g().catch(a=>(P.error(a),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",u=>this.c.error(u))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(u,P){const w=($,f)=>{P.writeHead($,{"content-type":"application/json"}),P.end(JSON.stringify(f||null),g=>g&&this.c.error(g))},a=[];u.setEncoding("utf8"),u.on("data",$=>a.push($)),u.on("end",async()=>{try{const $=JSON.parse(a.join(""));let f;switch($.type){case"open":f=await this.i($);break;case"openExternal":f=await this.j($);break;case"status":f=await this.l($);break;case"extensionManagement":f=await this.k($);break;default:w(404,`Unknown message type: ${$.type}`);break}w(200,f)}catch($){const f=$ instanceof Error?$.message:JSON.stringify($);w(500,f),this.c.error("Error while processing pipe request",$)}})}async i(u){const{fileURIs:P,folderURIs:w,forceNewWindow:a,diffMode:$,mergeMode:f,addMode:g,forceReuseWindow:i,gotoLineMode:o,waitMarkerFilePath:t,remoteAuthority:s}=u,n=[];if(Array.isArray(w))for(const E of w)try{n.push({folderUri:L.URI.parse(E)})}catch{}if(Array.isArray(P))for(const E of P)try{(0,b.$8i)(E)?n.push({workspaceUri:L.URI.parse(E)}):n.push({fileUri:L.URI.parse(E)})}catch{}const d=t?L.URI.file(t):void 0,m={forceNewWindow:a,diffMode:$,mergeMode:f,addMode:g,gotoLineMode:o,forceReuseWindow:i,preferNewWindow:!i&&!d&&!g,waitMarkerFileURI:d,remoteAuthority:s};this.b.executeCommand("_remoteCLI.windowOpen",n,m)}async j(u){for(const P of u.uris){const w=L.URI.parse(P),a=w.scheme==="file"?w:P;await this.b.executeCommand("_remoteCLI.openExternal",a)}}async k(u){const P=a=>a?.map($=>/\.vsix$/i.test($)?L.URI.parse($):$),w={list:u.list,install:P(u.install),uninstall:P(u.uninstall),force:u.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",w)}async l(u){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&C.existsSync(this.f)&&C.unlinkSync(this.f)}}e.$pQ=c;let I=class extends c{constructor(u,P){super(u,P,(0,r.$ui)())}};e.$qQ=I,e.$qQ=I=Ye([Ve(0,T.$kQ),Ve(1,R.$9j)],I)}),define(ke[356],Ie([1,0,61,343,338,251,54,325,2,14,9,355,108,285,324]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_qc=void 0,r=Ue(r);class a extends C.$Aqc{j(){const g=this,i=globalThis._VSCODE_NODE_MODULES.module,o=i._load;i._load=function(d,l,m){return d=s(d),g.a.has(d)?g.a.get(d).load(d,b.URI.file((0,u.$kr)(l.filename)),E=>o.apply(this,[E,l,m])):o.apply(this,arguments)};const t=i._resolveLookupPaths;i._resolveLookupPaths=(n,d)=>t.call(this,s(n),d);const s=n=>{for(const d of g.b){const l=d(n);if(l){n=l;break}}return n}}}class $ extends L.$mpc{constructor(){super(...arguments),this.extensionRuntime=I.ExtensionRuntime.Node}async vb(){this.h.createInstance(P.$0qc);const g=this.h.invokeFunction(h.$wqc);if(this.h.createInstance(R.$9qc),this.f.remote.isRemote&&this.f.remote.authority){const t=this.h.createInstance(D.$qQ);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}this.h.createInstance(w.$$qc),await this.h.createInstance(a,g,{mine:this.J,all:this.L}).install(),r.mark("code/extHost/didInitAPI");const o=await this.m.getConfigProvider();await(0,T.$8qc)(this.j,o,this,this.s,this.z,this.f),r.mark("code/extHost/didInitProxyResolver")}wb(g){return g.main}async xb(g,i,o){if(i.scheme!==c.Schemas.file)throw new Error(`Cannot load URI: '${i}', must be of file-scheme`);let t=null;o.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${i.toString(!0)}`),this.s.flush();const s=g?.identifier.value;g&&await this.w.initializeLocalizedMessages(g);try{s&&r.mark(`code/extHost/willLoadExtensionCode/${s}`),t=me.__$__nodeRequire(i.fsPath)}finally{s&&r.mark(`code/extHost/didLoadExtensionCode/${s}`),o.codeLoadingStop()}return t}async $setRemoteEnvironment(g){if(this.f.remote.isRemote)for(const i in g){const o=g[i];o===null?delete process.env[i]:process.env[i]=o}}}e.$_qc=$}),define(ke[357],Ie([1,0,44,56,21,4,3,133,10,22,2,33,68,11,232,71,117,92,354,29,19,76,332]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a,$,f,g,i,o,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hrc=void 0,e.$arc=n,e.$brc=d,e.$crc=l,e.$drc=m,e.$erc=S,e.$frc=y,e.$grc=k,r=Ue(r),c=Ue(c),D=Ue(D);function n(v){const F=v.trim().split(`
`),N=[];return F.forEach(j=>{const z=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(j);z&&z.length>=3&&N.push({pid:parseInt(z[1],10),socket:parseInt(z[2],10)})}),N.reduce((j,z)=>(j[z.socket]=z,j),{})}function d(...v){const F=[].concat(...v.map(m));return[...new Map(F.filter(N=>N.st==="0A").map(N=>{const O=N.local_address.split(":");return{socket:parseInt(N.inode,10),ip:l(O[0]),port:parseInt(O[1],16)}}).map(N=>[N.ip+":"+N.port,N])).values()]}function l(v){let F="";if(v.length===8)for(let N=v.length-2;N>=0;N-=2)F+=parseInt(v.substr(N,2),16),N!==0&&(F+=".");else for(let N=0;N<v.length;N+=8){const O=v.substring(N,N+8);let j="";for(let z=8;z>=2;z-=2)j+=O.substring(z-2,z),(z===6||z===2)&&(j=parseInt(j,16).toString(16),F+=`${j}`,j="",N+z!==v.length-6&&(F+=":"))}return F}function m(v){const F=v.trim().split(`
`),N=F.shift().trim().split(/\s+/).filter(j=>j!=="rx_queue"&&j!=="tm->when");return F.map(j=>j.trim().split(/\s+/).reduce((z,M,V)=>(z[N[V]||V]=M,z),{}))}function E(v){return!!v.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||v.indexOf("out/server-main.js")!==-1||v.indexOf("_productName=VSCode")!==-1}function S(v){const F=v.trim().split(`
`),N=[];return F.forEach(O=>{const j=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(O);j&&j.length>=4&&N.push({pid:parseInt(j[1],10),ppid:parseInt(j[2]),cmd:j[3]})}),N}async function y(v,F,N){const O=N.reduce((z,M)=>(z[M.pid]=M,z),{}),j=[];return v.forEach(({socket:z,ip:M,port:V})=>{const K=F[z]?F[z].pid:void 0,ne=K?O[K]?.cmd:void 0;K&&ne&&!E(ne)&&j.push({host:M,port:V,detail:ne,pid:K})}),j}function k(v,F,N){const O=new Map,j=S(F);for(const z of v){const M=N.get(z.port);if(M){O.set(z.port,M);continue}const V=j.find(K=>K.cmd.includes(`${z.port}`));if(V){let K=V,ne;do ne=j.find(B=>B.ppid===K.pid),ne&&(K=ne);while(ne);O.set(z.port,{host:z.ip,port:z.port,pid:K.pid,detail:K.cmd,ppid:K.ppid})}else O.set(z.port,{host:z.ip,port:z.port,ppid:Number.MAX_VALUE})}return O}let A=class extends t.$TFb{constructor(F,N,O,j){super(F,N,O),this.D=N,this.F=j,this.y=void 0,this.z=new Map,this.C=!1,b.$l&&N.remote.isRemote&&N.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(F){if(F&&this.C)return;this.C=F;let N;this.y&&(N=this.y,await this.a.$onFoundNewCandidates(this.y));const O=new R.$Km;let j=0;for(;this.C;){const z=new Date().getTime(),M=(await this.I()).filter(ne=>(0,f.$Fw)(ne.host)||(0,f.$Hw)(ne.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${M.map(ne=>ne.port).join(", ")}`);const V=new Date().getTime()-z;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${V} ms.`),j++>3&&O.update(V),(!N||JSON.stringify(N)!==JSON.stringify(M))&&(N=M,await this.a.$onFoundNewCandidates(N));const K=this.G(O.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${K} ms.`),await new Promise(ne=>setTimeout(()=>ne(),K))}}G(F){return Math.max(F*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(F=>F.port).join(", ")}`)}async I(){let F="",N="";try{F=await r.promises.readFile("/proc/net/tcp","utf8"),N=await r.promises.readFile("/proc/net/tcp6","utf8")}catch{}const O=d(F,N),j=await new Promise(Y=>{(0,h.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(ee,ue,re)=>{Y(ue)})}),z=n(j),M=await D.Promises.readdir("/proc"),V=[];for(const Y of M)try{const ee=Number(Y),ue=c.$dh(I.URI.file("/proc"),Y);if((await r.promises.stat(ue.fsPath)).isDirectory()&&!isNaN(ee)){const ye=await r.promises.readlink(c.$dh(ue,"cwd").fsPath),$e=await r.promises.readFile(c.$dh(ue,"cmdline").fsPath,"utf8");V.push({pid:ee,cwd:ye,cmd:$e})}}catch{}const K=[],ne=O.filter(Y=>{const ee=z[Y.socket];return ee||K.push(Y),ee}),B=y(ne,z,V);let G;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${K.length}`),K.length>0){const Y=await new Promise(ee=>{(0,h.exec)("ps -F -A -l | grep root",(ue,re,ye)=>{ee(re)})});this.z=k(K,Y,this.z),G=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${G.map(ee=>ee.port).join(", ")}`)}return B.then(Y=>G?Y.concat(G):Y)}w(F){return async N=>{const O=new g.$Pgc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(z,M,V,K){const ne=await F.makeConnection();return p.connect(ne,M,V,K)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new a.$Ol(0),connectionToken:F.connectionToken})}},signService:this.F},"localhost",N.remoteAddress.host||"localhost",N.remoteAddress.port,N.localAddressPort);await O.waitForReady();const j=new T.$je;return{localAddress:(0,s.$SM)(O.localAddress)??O.localAddress,remoteAddress:{port:O.tunnelRemotePort,host:O.tunnelRemoteHost},onDidDispose:j.event,dispose:()=>{O.dispose(),j.fire(),j.dispose()}}}}};e.$hrc=A,e.$hrc=A=Ye([Ve(0,o.$1P),Ve(1,i.$eQ),Ve(2,P.$9j),Ve(3,$.$Vl)],A);class p extends w.$dxb{static connect(F,N,O,j){const z=new L.$Sc,M={onClose:z.add(new T.$je),onData:z.add(new T.$je),onEnd:z.add(new T.$je)};z.add(F.onDidReceiveMessage(K=>M.onData.fire(C.$Le.wrap(K)))),z.add(F.onDidEnd(()=>M.onEnd.fire())),z.add(F.onDidClose(K=>M.onClose.fire({type:u.SocketCloseEventType.NodeSocketCloseEvent,error:K,hadError:!!K})));const V=new p(F,j,M);return V.B(z),(0,w.$cxb)(V,N,O,j,M)}constructor(F,N,O){super(N,O),this.n=F}write(F){this.n.send(F.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[358],Ie([1,0,88,327,341,340,353,356,357,101,54,102,100,47,76,97,326,286,11,342,64,247,112,117,148]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a,$,f,g,i,o,t,s,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.$Ns)(I.$npc,R.$_qc,r.InstantiationType.Eager),(0,r.$Ns)(g.$0j,f.$jrc,r.InstantiationType.Delayed),(0,r.$Ns)(g.$9j,new s.$zi(t.$zqc,[!1],!0)),(0,r.$Ns)(n.$Vl,d.$Ugc,r.InstantiationType.Delayed),(0,r.$Ns)(a.$Poc,$.$irc,r.InstantiationType.Eager),(0,r.$Ns)(c.$xpc,T.$Mqc,r.InstantiationType.Eager),(0,r.$Ns)(D.$Tpc,L.$7qc,r.InstantiationType.Eager),(0,r.$Ns)(u.$kqc,C.$Eqc,r.InstantiationType.Eager),(0,r.$Ns)(P.$$oc,h.$Dqc,r.InstantiationType.Eager),(0,r.$Ns)(w.$SFb,b.$hrc,r.InstantiationType.Eager),(0,r.$Ns)(o.$qpc,i.$krc,r.InstantiationType.Eager)});var zt=this&&this.__importDefault||function(me){return me&&me.__esModule?me:{default:me}};define(ke[368],Ie([1,0,369,67,7,21,13,61,108,33,68,130,113,230,339,253,268,93,344,358]),function(me,e,r,h,C,T,L,R,b,c,I,D,u,P,w,a,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r=zt(r),h=Ue(h),R=Ue(R),P=zt(P),function(){for(let S=0;S<process.execArgv.length;S++)process.execArgv[S]==="--inspect-port=0"&&(process.execArgv.splice(S,1),S--)}();const g=(0,r.default)(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const E=globalThis._VSCODE_NODE_MODULES.module,S=E._load;E._load=function(y){if(y==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return S.apply(this,arguments)}})();const i=process.exit.bind(process),o=process.on.bind(process);function t(E){process.exit=function(S){if(E)i(S);else{const y=new Error("An extension called process.exit() and this was prevented.");console.warn(y.stack)}},process.crash=function(){const S=new Error("An extension called process.crash() and this was prevented.");console.warn(S.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(S,y){S==="uncaughtException"&&(y=function(){try{return y.call(void 0,arguments)}catch{}}),o(S,y)}}let s=function(E){i()};function n(){const E=(0,$.$cn)(process.env);if(E.type===$.ExtHostConnectionType.MessagePort)return new Promise((S,y)=>{const k=A=>{const p=A[0],v=new I.$pi;p.on("message",F=>v.fire(T.$Le.wrap(F.data))),p.on("close",()=>{s("renderer closed the MessagePort")}),p.start(),S({onMessage:v.event,send:F=>p.postMessage(F.buffer)})};process.parentPort.on("message",A=>k(A.ports))});if(E.type===$.ExtHostConnectionType.Socket)return new Promise((S,y)=>{let k=null;const A=setTimeout(()=>{s("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),p=I.ProtocolConstants.ReconnectionGraceTime,v=I.ProtocolConstants.ReconnectionShortGraceTime,F=new C.$Ph(()=>s("renderer disconnected for too long (1)"),p),N=new C.$Ph(()=>s("renderer disconnected for too long (2)"),v);process.on("message",(j,z)=>{if(j&&j.type==="VSCODE_EXTHOST_IPC_SOCKET"){z.setNoDelay(!0);const M=T.$Le.wrap(Buffer.from(j.initialDataChunk,"base64"));let V;if(j.skipWebSocketFrames)V=new D.$ri(z,"extHost-socket");else{const K=T.$Le.wrap(Buffer.from(j.inflateBytes,"base64"));V=new D.$si(new D.$ri(z,"extHost-socket"),j.permessageDeflate,K,!1)}k?(F.cancel(),N.cancel(),k.beginAcceptReconnection(V,M),k.endAcceptReconnection(),k.sendResume()):(clearTimeout(A),k=new I.$qi({socket:V,initialChunk:M}),k.sendResume(),k.onDidDispose(()=>s("renderer disconnected")),S(k),k.onSocketClose(()=>{F.schedule()}))}if(j&&j.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(N.isScheduled())return;F.isScheduled()&&N.schedule()}});const O={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(O)});{const S=E.pipeName;return new Promise((y,k)=>{const A=h.createConnection(S,()=>{A.removeListener("error",k);const p=new I.$qi({socket:new D.$ri(A,"extHost-renderer")});p.sendResume(),y(p)});A.once("error",k),A.on("close",()=>{s("renderer closed the socket")})})}}async function d(){const E=await n();return new class{constructor(){this.a=new I.$pi,this.onMessage=this.a.event,this.b=!1,this.d=E.onMessage(S=>{(0,f.$yn)(S,f.MessageType.Terminate)?(this.b=!0,this.d.dispose(),s("received terminate message from renderer")):this.a.fire(S)})}send(S){this.b||E.send(S)}async drain(){if(E.drain)return E.drain()}}}function l(E){return new Promise(S=>{const y=E.onMessage(k=>{y.dispose();const A=JSON.parse(k.toString()),p=A.commit,v=P.default.commit;if(p&&v&&p!==v&&i(f.ExtensionHostExitCode.VersionMismatch),A.parentPid){let F=0;setInterval(function(){try{process.kill(A.parentPid,0),F=0}catch(O){O&&O.code==="EPERM"?(F++,F>=3&&s(`parent process ${A.parentPid} does not exist anymore (3 x EPERM): ${O.message} (code: ${O.code}) (errno: ${O.errno})`)):s(`parent process ${A.parentPid} does not exist anymore: ${O.message} (code: ${O.code}) (errno: ${O.errno})`)}},1e3);let N;try{N=globalThis._VSCODE_NODE_MODULES["native-watchdog"],N.start(A.parentPid)}catch(O){(0,L.$Y)(O)}}E.send((0,f.$xn)(f.MessageType.Initialized)),S({protocol:E,initData:A})});E.send((0,f.$xn)(f.MessageType.Ready))})}async function m(){const E=[];process.on("unhandledRejection",(F,N)=>{E.push(N),setTimeout(()=>{const O=E.indexOf(N);O>=0&&N.catch(j=>{E.splice(O,1),(0,L.$3)(j)||(console.warn(`rejected promise not handled within 1 second: ${j}`),j&&j.stack&&console.warn(`stack trace: ${j.stack}`),F&&(0,L.$Y)(F))})},1e3)}),process.on("rejectionHandled",F=>{const N=E.indexOf(F);N>=0&&E.splice(N,1)}),process.on("uncaughtException",function(F){(0,L.$X)(F)||(0,L.$Y)(F)}),R.mark("code/extHost/willConnectToRenderer");const S=await d();R.mark("code/extHost/didConnectToRenderer");const y=await l(S);R.mark("code/extHost/didWaitForInitData");const{initData:k}=y;t(!!k.environment.extensionTestsLocationURI),k.environment.useHostProxy=g.useHostProxy!==void 0?g.useHostProxy!=="false":void 0,k.environment.skipWorkspaceStorageLock=(0,u.boolean)(g.skipWorkspaceStorageLock,!1);const A=new class{constructor(){this.pid=process.pid}exit(N){i(N)}fsExists(N){return c.Promises.exists(N)}fsRealpath(N){return(0,b.$jr)(N)}};let p=null;k.remote.authority&&g.transformURIs&&(p=(0,a.$Rs)(k.remote.authority));const v=new w.$Cqc(y.protocol,k,A,p);s=F=>v.terminate(F)}m().catch(E=>console.log(E))})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/e6a828c5957959b7a18de37a567d850880101641/core/vs/workbench/api/node/extensionHostProcess.js.map
