/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ne=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/lifecycle","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/extensions/common/extensions","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/charCode","vs/base/common/map","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/editor/common/core/range","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/severity","vs/base/common/marshallingIds","vs/base/common/uuid","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/iterator","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/extpath","vs/editor/common/model","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/workbench/api/common/extHostTesting","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iconLabels","vs/base/common/labels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model/textModelSearch","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/common/editor","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/comparers","vs/base/common/scrollable","vs/base/common/stream","vs/base/common/symbols","vs/base/common/filters","vs/base/common/uriIpc","vs/base/common/dataTransfer","vs/base/parts/storage/common/storage","vs/editor/common/core/eolCounter","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/base/common/actions","vs/base/common/date","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/core/wordHelper","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensionValidator","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/uint","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/base/common/arraysFind","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Oe=function(we){for(var e=[],v=0,I=we.length;v<I;v++)e[v]=Ne[we[v]];return e};define(Ne[71],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=I,e.$8h=C,e.$9h=N;function v(A){return(T,$,a)=>{let R=null,y=null;if(typeof a.value=="function"?(R="value",y=a.value):typeof a.get=="function"&&(R="get",y=a.get),!y)throw new Error("not supported");a[R]=A(y,$)}}function I(A,T,$){let a=null,R=null;if(typeof $.value=="function"?(a="value",R=$.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(a="get",R=$.get),!R)throw new Error("not supported");const y=`$memoize$${T}`;$[a]=function(...c){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,c)}),this[y]}}function C(A,T,$){return v((a,R)=>{const y=`$debounce$${R}`,c=`$debounce$result$${R}`;return function(...S){this[c]||(this[c]=$?$():void 0),clearTimeout(this[y]),T&&(this[c]=T(this[c],...S),S=[this[c]]),this[y]=setTimeout(()=>{a.apply(this,S),this[c]=$?$():void 0},A)}})}function N(A,T,$){return v((a,R)=>{const y=`$throttle$timer$${R}`,c=`$throttle$result$${R}`,S=`$throttle$lastRun$${R}`,f=`$throttle$pending$${R}`;return function(...n){if(this[c]||(this[c]=$?$():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),T&&(this[c]=T(this[c],...n)),this[f])return;const o=this[S]+A;o<=Date.now()?(this[S]=Date.now(),a.apply(this,[this[c]]),this[c]=$?$():void 0):(this[f]=!0,this[y]=setTimeout(()=>{this[f]=!1,this[S]=Date.now(),a.apply(this,[this[c]]),this[c]=$?$():void 0},o-Date.now()))}})}});var Bn=this&&this.__createBinding||(Object.create?function(we,e,v,I){I===void 0&&(I=v);var C=Object.getOwnPropertyDescriptor(e,v);(!C||("get"in C?!e.__esModule:C.writable||C.configurable))&&(C={enumerable:!0,get:function(){return e[v]}}),Object.defineProperty(we,I,C)}:function(we,e,v,I){I===void 0&&(I=v),we[I]=e[v]}),Wn=this&&this.__setModuleDefault||(Object.create?function(we,e){Object.defineProperty(we,"default",{enumerable:!0,value:e})}:function(we,e){we.default=e}),Ve=this&&this.__importStar||function(we){if(we&&we.__esModule)return we;var e={};if(we!=null)for(var v in we)v!=="default"&&Object.prototype.hasOwnProperty.call(we,v)&&Bn(e,we,v);return Wn(e,we),e};define(Ne[135],Oe([1,0,17]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0,e.$6c=C,e.$7c=N,e.$8c=A,e.$9c=T,e.$0c=$,e.$$c=a,v=Ve(v);const I=(S,f)=>S===f;e.$5c=I;function C(S=e.$5c){return(f,n)=>v.$tb(f,n,S)}function N(){return(S,f)=>JSON.stringify(S)===JSON.stringify(f)}function A(){return(S,f)=>S.equals(f)}function T(S,f,n){if(n!==void 0){const o=S;return o==null||f===void 0||f===null?f===o:n(o,f)}else{const o=S;return(s,l)=>s==null||l===void 0||l===null?l===s:o(s,l)}}function $(S,f){if(S===f)return!0;if(Array.isArray(S)&&Array.isArray(f)){if(S.length!==f.length)return!1;for(let n=0;n<S.length;n++)if(!$(S[n],f[n]))return!1;return!0}if(S&&typeof S=="object"&&f&&typeof f=="object"&&Object.getPrototypeOf(S)===Object.prototype&&Object.getPrototypeOf(f)===Object.prototype){const n=S,o=f,s=Object.keys(n),l=Object.keys(o),i=new Set(l);if(s.length!==l.length)return!1;for(const r of s)if(!i.has(r)||!$(n[r],o[r]))return!1;return!0}return!1}function a(S){return JSON.stringify(c(S))}let R=0;const y=new WeakMap;function c(S){if(Array.isArray(S))return S.map(c);if(S&&typeof S=="object")if(Object.getPrototypeOf(S)===Object.prototype){const f=S,n=Object.create(null);for(const o of Object.keys(f).sort())n[o]=c(f[o]);return n}else{let f=y.get(S);return f===void 0&&(f=R++,y.set(S,f)),f+"----2b76a038c20c4bcc"}return S}}),define(Ne[96],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7P=e.$6P=void 0;class v{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$6P=v,e.$7P=new v("id#")}),define(Ne[136],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Sn=A,e.$Tn=y,e.$Un=c,e.$Vn=S,e.$Wn=f,e.$Xn=n,e.$Yn=o,e.$Zn=s,e.$1n=l,e.$2n=i,e.$3n=r;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v||(e.ScanError=v={}));var I;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(I||(e.SyntaxKind=I={}));var C;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var N;(function(t){t.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function A(t,g=!1){let u=0;const p=t.length;let m="",d=0,E=I.Unknown,D=v.None;function w(F){let q=0,B=0;for(;q<F;){const L=t.charCodeAt(u);if(L>=R._0&&L<=R._9)B=B*16+L-R._0;else if(L>=R.A&&L<=R.F)B=B*16+L-R.A+10;else if(L>=R.a&&L<=R.f)B=B*16+L-R.a+10;else break;u++,q++}return q<F&&(B=-1),B}function k(F){u=F,m="",d=0,E=I.Unknown,D=v.None}function P(){const F=u;if(t.charCodeAt(u)===R._0)u++;else for(u++;u<t.length&&a(t.charCodeAt(u));)u++;if(u<t.length&&t.charCodeAt(u)===R.dot)if(u++,u<t.length&&a(t.charCodeAt(u)))for(u++;u<t.length&&a(t.charCodeAt(u));)u++;else return D=v.UnexpectedEndOfNumber,t.substring(F,u);let q=u;if(u<t.length&&(t.charCodeAt(u)===R.E||t.charCodeAt(u)===R.e))if(u++,(u<t.length&&t.charCodeAt(u)===R.plus||t.charCodeAt(u)===R.minus)&&u++,u<t.length&&a(t.charCodeAt(u))){for(u++;u<t.length&&a(t.charCodeAt(u));)u++;q=u}else D=v.UnexpectedEndOfNumber;return t.substring(F,q)}function h(){let F="",q=u;for(;;){if(u>=p){F+=t.substring(q,u),D=v.UnexpectedEndOfString;break}const B=t.charCodeAt(u);if(B===R.doubleQuote){F+=t.substring(q,u),u++;break}if(B===R.backslash){if(F+=t.substring(q,u),u++,u>=p){D=v.UnexpectedEndOfString;break}switch(t.charCodeAt(u++)){case R.doubleQuote:F+='"';break;case R.backslash:F+="\\";break;case R.slash:F+="/";break;case R.b:F+="\b";break;case R.f:F+="\f";break;case R.n:F+=`
`;break;case R.r:F+="\r";break;case R.t:F+="	";break;case R.u:{const Y=w(4);Y>=0?F+=String.fromCharCode(Y):D=v.InvalidUnicode;break}default:D=v.InvalidEscapeCharacter}q=u;continue}if(B>=0&&B<=31)if($(B)){F+=t.substring(q,u),D=v.UnexpectedEndOfString;break}else D=v.InvalidCharacter;u++}return F}function b(){if(m="",D=v.None,d=u,u>=p)return d=p,E=I.EOF;let F=t.charCodeAt(u);if(T(F)){do u++,m+=String.fromCharCode(F),F=t.charCodeAt(u);while(T(F));return E=I.Trivia}if($(F))return u++,m+=String.fromCharCode(F),F===R.carriageReturn&&t.charCodeAt(u)===R.lineFeed&&(u++,m+=`
`),E=I.LineBreakTrivia;switch(F){case R.openBrace:return u++,E=I.OpenBraceToken;case R.closeBrace:return u++,E=I.CloseBraceToken;case R.openBracket:return u++,E=I.OpenBracketToken;case R.closeBracket:return u++,E=I.CloseBracketToken;case R.colon:return u++,E=I.ColonToken;case R.comma:return u++,E=I.CommaToken;case R.doubleQuote:return u++,m=h(),E=I.StringLiteral;case R.slash:{const q=u-1;if(t.charCodeAt(u+1)===R.slash){for(u+=2;u<p&&!$(t.charCodeAt(u));)u++;return m=t.substring(q,u),E=I.LineCommentTrivia}if(t.charCodeAt(u+1)===R.asterisk){u+=2;const B=p-1;let L=!1;for(;u<B;){if(t.charCodeAt(u)===R.asterisk&&t.charCodeAt(u+1)===R.slash){u+=2,L=!0;break}u++}return L||(u++,D=v.UnexpectedEndOfComment),m=t.substring(q,u),E=I.BlockCommentTrivia}return m+=String.fromCharCode(F),u++,E=I.Unknown}case R.minus:if(m+=String.fromCharCode(F),u++,u===p||!a(t.charCodeAt(u)))return E=I.Unknown;case R._0:case R._1:case R._2:case R._3:case R._4:case R._5:case R._6:case R._7:case R._8:case R._9:return m+=P(),E=I.NumericLiteral;default:for(;u<p&&M(F);)u++,F=t.charCodeAt(u);if(d!==u){switch(m=t.substring(d,u),m){case"true":return E=I.TrueKeyword;case"false":return E=I.FalseKeyword;case"null":return E=I.NullKeyword}return E=I.Unknown}return m+=String.fromCharCode(F),u++,E=I.Unknown}}function M(F){if(T(F)||$(F))return!1;switch(F){case R.closeBrace:case R.closeBracket:case R.openBrace:case R.openBracket:case R.doubleQuote:case R.colon:case R.comma:case R.slash:return!1}return!0}function O(){let F;do F=b();while(F>=I.LineCommentTrivia&&F<=I.Trivia);return F}return{setPosition:k,getPosition:()=>u,scan:g?O:b,getToken:()=>E,getTokenValue:()=>m,getTokenOffset:()=>d,getTokenLength:()=>u-d,getTokenError:()=>D}}function T(t){return t===R.space||t===R.tab||t===R.verticalTab||t===R.formFeed||t===R.nonBreakingSpace||t===R.ogham||t>=R.enQuad&&t<=R.zeroWidthSpace||t===R.narrowNoBreakSpace||t===R.mathematicalSpace||t===R.ideographicSpace||t===R.byteOrderMark}function $(t){return t===R.lineFeed||t===R.carriageReturn||t===R.lineSeparator||t===R.paragraphSeparator}function a(t){return t>=R._0&&t<=R._9}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function y(t,g){const u=[],p=new Object;let m;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function D(w,k,P,h){d.value=w,d.offset=k,d.length=P,d.type=h,d.colonOffset=void 0,m=d}try{i(t,{onObjectBegin:(w,k)=>{if(g<=w)throw p;m=void 0,E=g>w,u.push("")},onObjectProperty:(w,k,P)=>{if(g<k||(D(w,k,P,"property"),u[u.length-1]=w,g<=k+P))throw p},onObjectEnd:(w,k)=>{if(g<=w)throw p;m=void 0,u.pop()},onArrayBegin:(w,k)=>{if(g<=w)throw p;m=void 0,u.push(0)},onArrayEnd:(w,k)=>{if(g<=w)throw p;m=void 0,u.pop()},onLiteralValue:(w,k,P)=>{if(g<k||(D(w,k,P,r(w)),g<=k+P))throw p},onSeparator:(w,k,P)=>{if(g<=k)throw p;if(w===":"&&m&&m.type==="property")m.colonOffset=k,E=!1,m=void 0;else if(w===","){const h=u[u.length-1];typeof h=="number"?u[u.length-1]=h+1:(E=!0,u[u.length-1]=""),m=void 0}}})}catch(w){if(w!==p)throw w}return{path:u,previousNode:m,isAtPropertyKey:E,matches:w=>{let k=0;for(let P=0;k<w.length&&P<u.length;P++)if(w[k]===u[P]||w[k]==="*")k++;else if(w[k]!=="**")return!1;return k===w.length}}}function c(t,g=[],u=N.DEFAULT){let p=null,m=[];const d=[];function E(w){Array.isArray(m)?m.push(w):p!==null&&(m[p]=w)}return i(t,{onObjectBegin:()=>{const w={};E(w),d.push(m),m=w,p=null},onObjectProperty:w=>{p=w},onObjectEnd:()=>{m=d.pop()},onArrayBegin:()=>{const w=[];E(w),d.push(m),m=w,p=null},onArrayEnd:()=>{m=d.pop()},onLiteralValue:E,onError:(w,k,P)=>{g.push({error:w,offset:k,length:P})}},u),m[0]}function S(t,g=[],u=N.DEFAULT){let p={type:"array",offset:-1,length:-1,children:[],parent:void 0};function m(w){p.type==="property"&&(p.length=w-p.offset,p=p.parent)}function d(w){return p.children.push(w),w}i(t,{onObjectBegin:w=>{p=d({type:"object",offset:w,length:-1,parent:p,children:[]})},onObjectProperty:(w,k,P)=>{p=d({type:"property",offset:k,length:-1,parent:p,children:[]}),p.children.push({type:"string",value:w,offset:k,length:P,parent:p})},onObjectEnd:(w,k)=>{p.length=w+k-p.offset,p=p.parent,m(w+k)},onArrayBegin:(w,k)=>{p=d({type:"array",offset:w,length:-1,parent:p,children:[]})},onArrayEnd:(w,k)=>{p.length=w+k-p.offset,p=p.parent,m(w+k)},onLiteralValue:(w,k,P)=>{d({type:r(w),offset:k,length:P,parent:p,value:w}),m(k+P)},onSeparator:(w,k,P)=>{p.type==="property"&&(w===":"?p.colonOffset=k:w===","&&m(k))},onError:(w,k,P)=>{g.push({error:w,offset:k,length:P})}},u);const D=p.children[0];return D&&delete D.parent,D}function f(t,g){if(!t)return;let u=t;for(const p of g)if(typeof p=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let m=!1;for(const d of u.children)if(Array.isArray(d.children)&&d.children[0].value===p){u=d.children[1],m=!0;break}if(!m)return}else{const m=p;if(u.type!=="array"||m<0||!Array.isArray(u.children)||m>=u.children.length)return;u=u.children[m]}return u}function n(t){if(!t.parent||!t.parent.children)return[];const g=n(t.parent);if(t.parent.type==="property"){const u=t.parent.children[0].value;g.push(u)}else if(t.parent.type==="array"){const u=t.parent.children.indexOf(t);u!==-1&&g.push(u)}return g}function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const g=Object.create(null);for(const u of t.children){const p=u.children[1];p&&(g[u.children[0].value]=o(p))}return g}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function s(t,g,u=!1){return g>=t.offset&&g<t.offset+t.length||u&&g===t.offset+t.length}function l(t,g,u=!1){if(s(t,g,u)){const p=t.children;if(Array.isArray(p))for(let m=0;m<p.length&&p[m].offset<=g;m++){const d=l(p[m],g,u);if(d)return d}return t}}function i(t,g,u=N.DEFAULT){const p=A(t,!1);function m(ae){return ae?()=>ae(p.getTokenOffset(),p.getTokenLength()):()=>!0}function d(ae){return ae?$e=>ae($e,p.getTokenOffset(),p.getTokenLength()):()=>!0}const E=m(g.onObjectBegin),D=d(g.onObjectProperty),w=m(g.onObjectEnd),k=m(g.onArrayBegin),P=m(g.onArrayEnd),h=d(g.onLiteralValue),b=d(g.onSeparator),M=m(g.onComment),O=d(g.onError),F=u&&u.disallowComments,q=u&&u.allowTrailingComma;function B(){for(;;){const ae=p.scan();switch(p.getTokenError()){case v.InvalidUnicode:L(C.InvalidUnicode);break;case v.InvalidEscapeCharacter:L(C.InvalidEscapeCharacter);break;case v.UnexpectedEndOfNumber:L(C.UnexpectedEndOfNumber);break;case v.UnexpectedEndOfComment:F||L(C.UnexpectedEndOfComment);break;case v.UnexpectedEndOfString:L(C.UnexpectedEndOfString);break;case v.InvalidCharacter:L(C.InvalidCharacter);break}switch(ae){case I.LineCommentTrivia:case I.BlockCommentTrivia:F?L(C.InvalidCommentToken):M();break;case I.Unknown:L(C.InvalidSymbol);break;case I.Trivia:case I.LineBreakTrivia:break;default:return ae}}}function L(ae,$e=[],oe=[]){if(O(ae),$e.length+oe.length>0){let Ce=p.getToken();for(;Ce!==I.EOF;){if($e.indexOf(Ce)!==-1){B();break}else if(oe.indexOf(Ce)!==-1)break;Ce=B()}}}function Y(ae){const $e=p.getTokenValue();return ae?h($e):D($e),B(),!0}function Z(){switch(p.getToken()){case I.NumericLiteral:{let ae=0;try{ae=JSON.parse(p.getTokenValue()),typeof ae!="number"&&(L(C.InvalidNumberFormat),ae=0)}catch{L(C.InvalidNumberFormat)}h(ae);break}case I.NullKeyword:h(null);break;case I.TrueKeyword:h(!0);break;case I.FalseKeyword:h(!1);break;default:return!1}return B(),!0}function fe(){return p.getToken()!==I.StringLiteral?(L(C.PropertyNameExpected,[],[I.CloseBraceToken,I.CommaToken]),!1):(Y(!1),p.getToken()===I.ColonToken?(b(":"),B(),se()||L(C.ValueExpected,[],[I.CloseBraceToken,I.CommaToken])):L(C.ColonExpected,[],[I.CloseBraceToken,I.CommaToken]),!0)}function _(){E(),B();let ae=!1;for(;p.getToken()!==I.CloseBraceToken&&p.getToken()!==I.EOF;){if(p.getToken()===I.CommaToken){if(ae||L(C.ValueExpected,[],[]),b(","),B(),p.getToken()===I.CloseBraceToken&&q)break}else ae&&L(C.CommaExpected,[],[]);fe()||L(C.ValueExpected,[],[I.CloseBraceToken,I.CommaToken]),ae=!0}return w(),p.getToken()!==I.CloseBraceToken?L(C.CloseBraceExpected,[I.CloseBraceToken],[]):B(),!0}function ge(){k(),B();let ae=!1;for(;p.getToken()!==I.CloseBracketToken&&p.getToken()!==I.EOF;){if(p.getToken()===I.CommaToken){if(ae||L(C.ValueExpected,[],[]),b(","),B(),p.getToken()===I.CloseBracketToken&&q)break}else ae&&L(C.CommaExpected,[],[]);se()||L(C.ValueExpected,[],[I.CloseBracketToken,I.CommaToken]),ae=!0}return P(),p.getToken()!==I.CloseBracketToken?L(C.CloseBracketExpected,[I.CloseBracketToken],[]):B(),!0}function se(){switch(p.getToken()){case I.OpenBracketToken:return ge();case I.OpenBraceToken:return _();case I.StringLiteral:return Y(!0);default:return Z()}}return B(),p.getToken()===I.EOF?u.allowEmptyContent?!0:(L(C.ValueExpected,[],[]),!1):se()?(p.getToken()!==I.EOF&&L(C.EndOfFileExpected,[],[]),!0):(L(C.ValueExpected,[],[]),!1)}function r(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function(we,e){typeof define=="function"&&define.amd?define(Ne[137],Oe([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(we=typeof globalThis<"u"?globalThis:we||self,e(we.marked={}))}(this,function(we){"use strict";function e(ce,be){for(var he=0;he<be.length;he++){var J=be[he];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(ce,J.key,J)}}function v(ce,be,he){return be&&e(ce.prototype,be),he&&e(ce,he),Object.defineProperty(ce,"prototype",{writable:!1}),ce}function I(ce,be){if(ce){if(typeof ce=="string")return C(ce,be);var he=Object.prototype.toString.call(ce).slice(8,-1);if(he==="Object"&&ce.constructor&&(he=ce.constructor.name),he==="Map"||he==="Set")return Array.from(ce);if(he==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(he))return C(ce,be)}}function C(ce,be){(be==null||be>ce.length)&&(be=ce.length);for(var he=0,J=new Array(be);he<be;he++)J[he]=ce[he];return J}function N(ce,be){var he=typeof Symbol<"u"&&ce[Symbol.iterator]||ce["@@iterator"];if(he)return(he=he.call(ce)).next.bind(he);if(Array.isArray(ce)||(he=I(ce))||be&&ce&&typeof ce.length=="number"){he&&(ce=he);var J=0;return function(){return J>=ce.length?{done:!0}:{done:!1,value:ce[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}we.defaults=A();function T(ce){we.defaults=ce}var $=/[&<>"']/,a=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},S=function(be){return c[be]};function f(ce,be){if(be){if($.test(ce))return ce.replace(a,S)}else if(R.test(ce))return ce.replace(y,S);return ce}var n=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(ce){return ce.replace(n,function(be,he){return he=he.toLowerCase(),he==="colon"?":":he.charAt(0)==="#"?he.charAt(1)==="x"?String.fromCharCode(parseInt(he.substring(2),16)):String.fromCharCode(+he.substring(1)):""})}var s=/(^|[^\[])\^/g;function l(ce,be){ce=typeof ce=="string"?ce:ce.source,be=be||"";var he={replace:function(x,me){return me=me.source||me,me=me.replace(s,"$1"),ce=ce.replace(x,me),he},getRegex:function(){return new RegExp(ce,be)}};return he}var i=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function t(ce,be,he){if(ce){var J;try{J=decodeURIComponent(o(he)).replace(i,"").toLowerCase()}catch{return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}be&&!r.test(he)&&(he=d(be,he));try{he=encodeURI(he).replace(/%25/g,"%")}catch{return null}return he}var g={},u=/^[^:]+:\/*[^/]*$/,p=/^([^:]+:)[\s\S]*$/,m=/^([^:]+:\/*[^/]*)[\s\S]*$/;function d(ce,be){g[" "+ce]||(u.test(ce)?g[" "+ce]=ce+"/":g[" "+ce]=k(ce,"/",!0)),ce=g[" "+ce];var he=ce.indexOf(":")===-1;return be.substring(0,2)==="//"?he?be:ce.replace(p,"$1")+be:be.charAt(0)==="/"?he?be:ce.replace(m,"$1")+be:ce+be}var E={exec:function(){}};function D(ce){for(var be=1,he,J;be<arguments.length;be++){he=arguments[be];for(J in he)Object.prototype.hasOwnProperty.call(he,J)&&(ce[J]=he[J])}return ce}function w(ce,be){var he=ce.replace(/\|/g,function(me,pe,Ae){for(var ze=!1,ke=pe;--ke>=0&&Ae[ke]==="\\";)ze=!ze;return ze?"|":" |"}),J=he.split(/ \|/),x=0;if(J[0].trim()||J.shift(),J.length>0&&!J[J.length-1].trim()&&J.pop(),J.length>be)J.splice(be);else for(;J.length<be;)J.push("");for(;x<J.length;x++)J[x]=J[x].trim().replace(/\\\|/g,"|");return J}function k(ce,be,he){var J=ce.length;if(J===0)return"";for(var x=0;x<J;){var me=ce.charAt(J-x-1);if(me===be&&!he)x++;else if(me!==be&&he)x++;else break}return ce.slice(0,J-x)}function P(ce,be){if(ce.indexOf(be[1])===-1)return-1;for(var he=ce.length,J=0,x=0;x<he;x++)if(ce[x]==="\\")x++;else if(ce[x]===be[0])J++;else if(ce[x]===be[1]&&(J--,J<0))return x;return-1}function h(ce){ce&&ce.sanitize&&!ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function b(ce,be){if(be<1)return"";for(var he="";be>1;)be&1&&(he+=ce),be>>=1,ce+=ce;return he+ce}function M(ce,be,he,J){var x=be.href,me=be.title?f(be.title):null,pe=ce[1].replace(/\\([\[\]])/g,"$1");if(ce[0].charAt(0)!=="!"){J.state.inLink=!0;var Ae={type:"link",raw:he,href:x,title:me,text:pe,tokens:J.inlineTokens(pe)};return J.state.inLink=!1,Ae}return{type:"image",raw:he,href:x,title:me,text:f(pe)}}function O(ce,be){var he=ce.match(/^(\s+)(?:```)/);if(he===null)return be;var J=he[1];return be.split(`
`).map(function(x){var me=x.match(/^\s+/);if(me===null)return x;var pe=me[0];return pe.length>=J.length?x.slice(J.length):x}).join(`
`)}var F=function(){function ce(he){this.options=he||we.defaults}var be=ce.prototype;return be.space=function(J){var x=this.rules.block.newline.exec(J);if(x&&x[0].length>0)return{type:"space",raw:x[0]}},be.code=function(J){var x=this.rules.block.code.exec(J);if(x){var me=x[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:x[0],codeBlockStyle:"indented",text:this.options.pedantic?me:k(me,`
`)}}},be.fences=function(J){var x=this.rules.block.fences.exec(J);if(x){var me=x[0],pe=O(me,x[3]||"");return{type:"code",raw:me,lang:x[2]?x[2].trim():x[2],text:pe}}},be.heading=function(J){var x=this.rules.block.heading.exec(J);if(x){var me=x[2].trim();if(/#$/.test(me)){var pe=k(me,"#");(this.options.pedantic||!pe||/ $/.test(pe))&&(me=pe.trim())}return{type:"heading",raw:x[0],depth:x[1].length,text:me,tokens:this.lexer.inline(me)}}},be.hr=function(J){var x=this.rules.block.hr.exec(J);if(x)return{type:"hr",raw:x[0]}},be.blockquote=function(J){var x=this.rules.block.blockquote.exec(J);if(x){var me=x[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:x[0],tokens:this.lexer.blockTokens(me,[]),text:me}}},be.list=function(J){var x=this.rules.block.list.exec(J);if(x){var me,pe,Ae,ze,ke,Pe,Te,U,j,G,Q,ne,de=x[1].trim(),Ie=de.length>1,je={type:"list",raw:"",ordered:Ie,start:Ie?+de.slice(0,-1):"",loose:!1,items:[]};de=Ie?"\\d{1,9}\\"+de.slice(-1):"\\"+de,this.options.pedantic&&(de=Ie?de:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+de+")((?:[	 ][^\\n]*)?(?:\\n|$))");J&&(ne=!1,!(!(x=Ke.exec(J))||this.rules.block.hr.test(J)));){if(me=x[0],J=J.substring(me.length),U=x[2].split(`
`,1)[0],j=J.split(`
`,1)[0],this.options.pedantic?(ze=2,Q=U.trimLeft()):(ze=x[2].search(/[^ ]/),ze=ze>4?1:ze,Q=U.slice(ze),ze+=x[1].length),Pe=!1,!U&&/^ *$/.test(j)&&(me+=j+`
`,J=J.substring(j.length+1),ne=!0),!ne)for(var _e=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,ze-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:```|~~~)"),et=new RegExp("^ {0,"+Math.min(3,ze-1)+"}#");J&&(G=J.split(`
`,1)[0],U=G,this.options.pedantic&&(U=U.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(U)||et.test(U)||_e.test(U)||tt.test(J)));){if(U.search(/[^ ]/)>=ze||!U.trim())Q+=`
`+U.slice(ze);else if(!Pe)Q+=`
`+U;else break;!Pe&&!U.trim()&&(Pe=!0),me+=G+`
`,J=J.substring(G.length+1)}je.loose||(Te?je.loose=!0:/\n *\n *$/.test(me)&&(Te=!0)),this.options.gfm&&(pe=/^\[[ xX]\] /.exec(Q),pe&&(Ae=pe[0]!=="[ ] ",Q=Q.replace(/^\[[ xX]\] +/,""))),je.items.push({type:"list_item",raw:me,task:!!pe,checked:Ae,loose:!1,text:Q}),je.raw+=me}je.items[je.items.length-1].raw=me.trimRight(),je.items[je.items.length-1].text=Q.trimRight(),je.raw=je.raw.trimRight();var rt=je.items.length;for(ke=0;ke<rt;ke++){this.lexer.state.top=!1,je.items[ke].tokens=this.lexer.blockTokens(je.items[ke].text,[]);var ft=je.items[ke].tokens.filter(function(st){return st.type==="space"}),ct=ft.every(function(st){for(var lt=st.raw.split(""),gt=0,pt=N(lt),Be;!(Be=pt()).done;){var Ue=Be.value;if(Ue===`
`&&(gt+=1),gt>1)return!0}return!1});!je.loose&&ft.length&&ct&&(je.loose=!0,je.items[ke].loose=!0)}return je}},be.html=function(J){var x=this.rules.block.html.exec(J);if(x){var me={type:"html",raw:x[0],pre:!this.options.sanitizer&&(x[1]==="pre"||x[1]==="script"||x[1]==="style"),text:x[0]};if(this.options.sanitize){var pe=this.options.sanitizer?this.options.sanitizer(x[0]):f(x[0]);me.type="paragraph",me.text=pe,me.tokens=this.lexer.inline(pe)}return me}},be.def=function(J){var x=this.rules.block.def.exec(J);if(x){x[3]&&(x[3]=x[3].substring(1,x[3].length-1));var me=x[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:me,raw:x[0],href:x[2],title:x[3]}}},be.table=function(J){var x=this.rules.block.table.exec(J);if(x){var me={type:"table",header:w(x[1]).map(function(Te){return{text:Te}}),align:x[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:x[3]&&x[3].trim()?x[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(me.header.length===me.align.length){me.raw=x[0];var pe=me.align.length,Ae,ze,ke,Pe;for(Ae=0;Ae<pe;Ae++)/^ *-+: *$/.test(me.align[Ae])?me.align[Ae]="right":/^ *:-+: *$/.test(me.align[Ae])?me.align[Ae]="center":/^ *:-+ *$/.test(me.align[Ae])?me.align[Ae]="left":me.align[Ae]=null;for(pe=me.rows.length,Ae=0;Ae<pe;Ae++)me.rows[Ae]=w(me.rows[Ae],me.header.length).map(function(Te){return{text:Te}});for(pe=me.header.length,ze=0;ze<pe;ze++)me.header[ze].tokens=this.lexer.inline(me.header[ze].text);for(pe=me.rows.length,ze=0;ze<pe;ze++)for(Pe=me.rows[ze],ke=0;ke<Pe.length;ke++)Pe[ke].tokens=this.lexer.inline(Pe[ke].text);return me}}},be.lheading=function(J){var x=this.rules.block.lheading.exec(J);if(x)return{type:"heading",raw:x[0],depth:x[2].charAt(0)==="="?1:2,text:x[1],tokens:this.lexer.inline(x[1])}},be.paragraph=function(J){var x=this.rules.block.paragraph.exec(J);if(x){var me=x[1].charAt(x[1].length-1)===`
`?x[1].slice(0,-1):x[1];return{type:"paragraph",raw:x[0],text:me,tokens:this.lexer.inline(me)}}},be.text=function(J){var x=this.rules.block.text.exec(J);if(x)return{type:"text",raw:x[0],text:x[0],tokens:this.lexer.inline(x[0])}},be.escape=function(J){var x=this.rules.inline.escape.exec(J);if(x)return{type:"escape",raw:x[0],text:f(x[1])}},be.tag=function(J){var x=this.rules.inline.tag.exec(J);if(x)return!this.lexer.state.inLink&&/^<a /i.test(x[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(x[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(x[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(x[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:x[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):f(x[0]):x[0]}},be.link=function(J){var x=this.rules.inline.link.exec(J);if(x){var me=x[2].trim();if(!this.options.pedantic&&/^</.test(me)){if(!/>$/.test(me))return;var pe=k(me.slice(0,-1),"\\");if((me.length-pe.length)%2===0)return}else{var Ae=P(x[2],"()");if(Ae>-1){var ze=x[0].indexOf("!")===0?5:4,ke=ze+x[1].length+Ae;x[2]=x[2].substring(0,Ae),x[0]=x[0].substring(0,ke).trim(),x[3]=""}}var Pe=x[2],Te="";if(this.options.pedantic){var U=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Pe);U&&(Pe=U[1],Te=U[3])}else Te=x[3]?x[3].slice(1,-1):"";return Pe=Pe.trim(),/^</.test(Pe)&&(this.options.pedantic&&!/>$/.test(me)?Pe=Pe.slice(1):Pe=Pe.slice(1,-1)),M(x,{href:Pe&&Pe.replace(this.rules.inline._escapes,"$1"),title:Te&&Te.replace(this.rules.inline._escapes,"$1")},x[0],this.lexer)}},be.reflink=function(J,x){var me;if((me=this.rules.inline.reflink.exec(J))||(me=this.rules.inline.nolink.exec(J))){var pe=(me[2]||me[1]).replace(/\s+/g," ");if(pe=x[pe.toLowerCase()],!pe||!pe.href){var Ae=me[0].charAt(0);return{type:"text",raw:Ae,text:Ae}}return M(me,pe,me[0],this.lexer)}},be.emStrong=function(J,x,me){me===void 0&&(me="");var pe=this.rules.inline.emStrong.lDelim.exec(J);if(pe&&!(pe[3]&&me.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ae=pe[1]||pe[2]||"";if(!Ae||Ae&&(me===""||this.rules.inline.punctuation.exec(me))){var ze=pe[0].length-1,ke,Pe,Te=ze,U=0,j=pe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(j.lastIndex=0,x=x.slice(-1*J.length+ze);(pe=j.exec(x))!=null;)if(ke=pe[1]||pe[2]||pe[3]||pe[4]||pe[5]||pe[6],!!ke){if(Pe=ke.length,pe[3]||pe[4]){Te+=Pe;continue}else if((pe[5]||pe[6])&&ze%3&&!((ze+Pe)%3)){U+=Pe;continue}if(Te-=Pe,!(Te>0)){if(Pe=Math.min(Pe,Pe+Te+U),Math.min(ze,Pe)%2){var G=J.slice(1,ze+pe.index+Pe);return{type:"em",raw:J.slice(0,ze+pe.index+Pe+1),text:G,tokens:this.lexer.inlineTokens(G)}}var Q=J.slice(2,ze+pe.index+Pe-1);return{type:"strong",raw:J.slice(0,ze+pe.index+Pe+1),text:Q,tokens:this.lexer.inlineTokens(Q)}}}}}},be.codespan=function(J){var x=this.rules.inline.code.exec(J);if(x){var me=x[2].replace(/\n/g," "),pe=/[^ ]/.test(me),Ae=/^ /.test(me)&&/ $/.test(me);return pe&&Ae&&(me=me.substring(1,me.length-1)),me=f(me,!0),{type:"codespan",raw:x[0],text:me}}},be.br=function(J){var x=this.rules.inline.br.exec(J);if(x)return{type:"br",raw:x[0]}},be.del=function(J){var x=this.rules.inline.del.exec(J);if(x)return{type:"del",raw:x[0],text:x[2],tokens:this.lexer.inlineTokens(x[2])}},be.autolink=function(J,x){var me=this.rules.inline.autolink.exec(J);if(me){var pe,Ae;return me[2]==="@"?(pe=f(this.options.mangle?x(me[1]):me[1]),Ae="mailto:"+pe):(pe=f(me[1]),Ae=pe),{type:"link",raw:me[0],text:pe,href:Ae,tokens:[{type:"text",raw:pe,text:pe}]}}},be.url=function(J,x){var me;if(me=this.rules.inline.url.exec(J)){var pe,Ae;if(me[2]==="@")pe=f(this.options.mangle?x(me[0]):me[0]),Ae="mailto:"+pe;else{var ze;do ze=me[0],me[0]=this.rules.inline._backpedal.exec(me[0])[0];while(ze!==me[0]);pe=f(me[0]),me[1]==="www."?Ae="http://"+pe:Ae=pe}return{type:"link",raw:me[0],text:pe,href:Ae,tokens:[{type:"text",raw:pe,text:pe}]}}},be.inlineText=function(J,x){var me=this.rules.inline.text.exec(J);if(me){var pe;return this.lexer.state.inRawBlock?pe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):f(me[0]):me[0]:pe=f(this.options.smartypants?x(me[0]):me[0]),{type:"text",raw:me[0],text:pe}}},ce}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:E,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=l(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=l(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=l(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=l(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=l(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=l(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=D({},q),q.gfm=D({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=l(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=l(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=D({},q.normal,{html:l(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:E,paragraph:l(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var B={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:E,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:E,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};B._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",B.punctuation=l(B.punctuation).replace(/punctuation/g,B._punctuation).getRegex(),B.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,B.escapedEmSt=/\\\*|\\_/g,B._comment=l(q._comment).replace("(?:-->|$)","-->").getRegex(),B.emStrong.lDelim=l(B.emStrong.lDelim).replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimAst=l(B.emStrong.rDelimAst,"g").replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimUnd=l(B.emStrong.rDelimUnd,"g").replace(/punct/g,B._punctuation).getRegex(),B._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,B._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,B._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,B.autolink=l(B.autolink).replace("scheme",B._scheme).replace("email",B._email).getRegex(),B._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,B.tag=l(B.tag).replace("comment",B._comment).replace("attribute",B._attribute).getRegex(),B._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,B._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,B._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,B.link=l(B.link).replace("label",B._label).replace("href",B._href).replace("title",B._title).getRegex(),B.reflink=l(B.reflink).replace("label",B._label).replace("ref",q._label).getRegex(),B.nolink=l(B.nolink).replace("ref",q._label).getRegex(),B.reflinkSearch=l(B.reflinkSearch,"g").replace("reflink",B.reflink).replace("nolink",B.nolink).getRegex(),B.normal=D({},B),B.pedantic=D({},B.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:l(/^!?\[(label)\]\((.*?)\)/).replace("label",B._label).getRegex(),reflink:l(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",B._label).getRegex()}),B.gfm=D({},B.normal,{escape:l(B.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),B.gfm.url=l(B.gfm.url,"i").replace("email",B.gfm._extended_email).getRegex(),B.breaks=D({},B.gfm,{br:l(B.br).replace("{2,}","*").getRegex(),text:l(B.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function L(ce){return ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Y(ce){var be="",he,J,x=ce.length;for(he=0;he<x;he++)J=ce.charCodeAt(he),Math.random()>.5&&(J="x"+J.toString(16)),be+="&#"+J+";";return be}var Z=function(){function ce(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||we.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var J={block:q.normal,inline:B.normal};this.options.pedantic?(J.block=q.pedantic,J.inline=B.pedantic):this.options.gfm&&(J.block=q.gfm,this.options.breaks?J.inline=B.breaks:J.inline=B.gfm),this.tokenizer.rules=J}ce.lex=function(J,x){var me=new ce(x);return me.lex(J)},ce.lexInline=function(J,x){var me=new ce(x);return me.inlineTokens(J)};var be=ce.prototype;return be.lex=function(J){J=J.replace(/\r\n|\r/g,`
`),this.blockTokens(J,this.tokens);for(var x;x=this.inlineQueue.shift();)this.inlineTokens(x.src,x.tokens);return this.tokens},be.blockTokens=function(J,x){var me=this;x===void 0&&(x=[]),this.options.pedantic?J=J.replace(/\t/g,"    ").replace(/^ +$/gm,""):J=J.replace(/^( *)(\t+)/gm,function(Te,U,j){return U+"    ".repeat(j.length)});for(var pe,Ae,ze,ke;J;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Te){return(pe=Te.call({lexer:me},J,x))?(J=J.substring(pe.raw.length),x.push(pe),!0):!1}))){if(pe=this.tokenizer.space(J)){J=J.substring(pe.raw.length),pe.raw.length===1&&x.length>0?x[x.length-1].raw+=`
`:x.push(pe);continue}if(pe=this.tokenizer.code(J)){J=J.substring(pe.raw.length),Ae=x[x.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.text,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):x.push(pe);continue}if(pe=this.tokenizer.fences(J)){J=J.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.heading(J)){J=J.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.hr(J)){J=J.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.blockquote(J)){J=J.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.list(J)){J=J.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.html(J)){J=J.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.def(J)){J=J.substring(pe.raw.length),Ae=x[x.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):this.tokens.links[pe.tag]||(this.tokens.links[pe.tag]={href:pe.href,title:pe.title});continue}if(pe=this.tokenizer.table(J)){J=J.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.lheading(J)){J=J.substring(pe.raw.length),x.push(pe);continue}if(ze=J,this.options.extensions&&this.options.extensions.startBlock&&function(){var Te=1/0,U=J.slice(1),j=void 0;me.options.extensions.startBlock.forEach(function(G){j=G.call({lexer:this},U),typeof j=="number"&&j>=0&&(Te=Math.min(Te,j))}),Te<1/0&&Te>=0&&(ze=J.substring(0,Te+1))}(),this.state.top&&(pe=this.tokenizer.paragraph(ze))){Ae=x[x.length-1],ke&&Ae.type==="paragraph"?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):x.push(pe),ke=ze.length!==J.length,J=J.substring(pe.raw.length);continue}if(pe=this.tokenizer.text(J)){J=J.substring(pe.raw.length),Ae=x[x.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):x.push(pe);continue}if(J){var Pe="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(Pe);break}else throw new Error(Pe)}}return this.state.top=!0,x},be.inline=function(J,x){return x===void 0&&(x=[]),this.inlineQueue.push({src:J,tokens:x}),x},be.inlineTokens=function(J,x){var me=this;x===void 0&&(x=[]);var pe,Ae,ze,ke=J,Pe,Te,U;if(this.tokens.links){var j=Object.keys(this.tokens.links);if(j.length>0)for(;(Pe=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)j.includes(Pe[0].slice(Pe[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Pe.index)+"["+b("a",Pe[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Pe=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Pe.index)+"["+b("a",Pe[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Pe=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Pe.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;)if(Te||(U=""),Te=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Q){return(pe=Q.call({lexer:me},J,x))?(J=J.substring(pe.raw.length),x.push(pe),!0):!1}))){if(pe=this.tokenizer.escape(J)){J=J.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.tag(J)){J=J.substring(pe.raw.length),Ae=x[x.length-1],Ae&&pe.type==="text"&&Ae.type==="text"?(Ae.raw+=pe.raw,Ae.text+=pe.text):x.push(pe);continue}if(pe=this.tokenizer.link(J)){J=J.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring(pe.raw.length),Ae=x[x.length-1],Ae&&pe.type==="text"&&Ae.type==="text"?(Ae.raw+=pe.raw,Ae.text+=pe.text):x.push(pe);continue}if(pe=this.tokenizer.emStrong(J,ke,U)){J=J.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.codespan(J)){J=J.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.br(J)){J=J.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.del(J)){J=J.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.autolink(J,Y)){J=J.substring(pe.raw.length),x.push(pe);continue}if(!this.state.inLink&&(pe=this.tokenizer.url(J,Y))){J=J.substring(pe.raw.length),x.push(pe);continue}if(ze=J,this.options.extensions&&this.options.extensions.startInline&&function(){var Q=1/0,ne=J.slice(1),de=void 0;me.options.extensions.startInline.forEach(function(Ie){de=Ie.call({lexer:this},ne),typeof de=="number"&&de>=0&&(Q=Math.min(Q,de))}),Q<1/0&&Q>=0&&(ze=J.substring(0,Q+1))}(),pe=this.tokenizer.inlineText(ze,L)){J=J.substring(pe.raw.length),pe.raw.slice(-1)!=="_"&&(U=pe.raw.slice(-1)),Te=!0,Ae=x[x.length-1],Ae&&Ae.type==="text"?(Ae.raw+=pe.raw,Ae.text+=pe.text):x.push(pe);continue}if(J){var G="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(G);break}else throw new Error(G)}}return x},v(ce,null,[{key:"rules",get:function(){return{block:q,inline:B}}}]),ce}(),fe=function(){function ce(he){this.options=he||we.defaults}var be=ce.prototype;return be.code=function(J,x,me){var pe=(x||"").match(/\S*/)[0];if(this.options.highlight){var Ae=this.options.highlight(J,pe);Ae!=null&&Ae!==J&&(me=!0,J=Ae)}return J=J.replace(/\n$/,"")+`
`,pe?'<pre><code class="'+this.options.langPrefix+f(pe,!0)+'">'+(me?J:f(J,!0))+`</code></pre>
`:"<pre><code>"+(me?J:f(J,!0))+`</code></pre>
`},be.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},be.html=function(J){return J},be.heading=function(J,x,me,pe){if(this.options.headerIds){var Ae=this.options.headerPrefix+pe.slug(me);return"<h"+x+' id="'+Ae+'">'+J+"</h"+x+`>
`}return"<h"+x+">"+J+"</h"+x+`>
`},be.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},be.list=function(J,x,me){var pe=x?"ol":"ul",Ae=x&&me!==1?' start="'+me+'"':"";return"<"+pe+Ae+`>
`+J+"</"+pe+`>
`},be.listitem=function(J){return"<li>"+J+`</li>
`},be.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},be.paragraph=function(J){return"<p>"+J+`</p>
`},be.table=function(J,x){return x&&(x="<tbody>"+x+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+x+`</table>
`},be.tablerow=function(J){return`<tr>
`+J+`</tr>
`},be.tablecell=function(J,x){var me=x.header?"th":"td",pe=x.align?"<"+me+' align="'+x.align+'">':"<"+me+">";return pe+J+("</"+me+`>
`)},be.strong=function(J){return"<strong>"+J+"</strong>"},be.em=function(J){return"<em>"+J+"</em>"},be.codespan=function(J){return"<code>"+J+"</code>"},be.br=function(){return this.options.xhtml?"<br/>":"<br>"},be.del=function(J){return"<del>"+J+"</del>"},be.link=function(J,x,me){if(J=t(this.options.sanitize,this.options.baseUrl,J),J===null)return me;var pe='<a href="'+f(J)+'"';return x&&(pe+=' title="'+x+'"'),pe+=">"+me+"</a>",pe},be.image=function(J,x,me){if(J=t(this.options.sanitize,this.options.baseUrl,J),J===null)return me;var pe='<img src="'+J+'" alt="'+me+'"';return x&&(pe+=' title="'+x+'"'),pe+=this.options.xhtml?"/>":">",pe},be.text=function(J){return J},ce}(),_=function(){function ce(){}var be=ce.prototype;return be.strong=function(J){return J},be.em=function(J){return J},be.codespan=function(J){return J},be.del=function(J){return J},be.html=function(J){return J},be.text=function(J){return J},be.link=function(J,x,me){return""+me},be.image=function(J,x,me){return""+me},be.br=function(){return""},ce}(),ge=function(){function ce(){this.seen={}}var be=ce.prototype;return be.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},be.getNextSafeSlug=function(J,x){var me=J,pe=0;if(this.seen.hasOwnProperty(me)){pe=this.seen[J];do pe++,me=J+"-"+pe;while(this.seen.hasOwnProperty(me))}return x||(this.seen[J]=pe,this.seen[me]=0),me},be.slug=function(J,x){x===void 0&&(x={});var me=this.serialize(J);return this.getNextSafeSlug(me,x.dryrun)},ce}(),se=function(){function ce(he){this.options=he||we.defaults,this.options.renderer=this.options.renderer||new fe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new _,this.slugger=new ge}ce.parse=function(J,x){var me=new ce(x);return me.parse(J)},ce.parseInline=function(J,x){var me=new ce(x);return me.parseInline(J)};var be=ce.prototype;return be.parse=function(J,x){x===void 0&&(x=!0);var me="",pe,Ae,ze,ke,Pe,Te,U,j,G,Q,ne,de,Ie,je,Ke,_e,tt,nt,et,rt=J.length;for(pe=0;pe<rt;pe++){if(Q=J[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Q.type]&&(et=this.options.extensions.renderers[Q.type].call({parser:this},Q),et!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Q.type))){me+=et||"";continue}switch(Q.type){case"space":continue;case"hr":{me+=this.renderer.hr();continue}case"heading":{me+=this.renderer.heading(this.parseInline(Q.tokens),Q.depth,o(this.parseInline(Q.tokens,this.textRenderer)),this.slugger);continue}case"code":{me+=this.renderer.code(Q.text,Q.lang,Q.escaped);continue}case"table":{for(j="",U="",ke=Q.header.length,Ae=0;Ae<ke;Ae++)U+=this.renderer.tablecell(this.parseInline(Q.header[Ae].tokens),{header:!0,align:Q.align[Ae]});for(j+=this.renderer.tablerow(U),G="",ke=Q.rows.length,Ae=0;Ae<ke;Ae++){for(Te=Q.rows[Ae],U="",Pe=Te.length,ze=0;ze<Pe;ze++)U+=this.renderer.tablecell(this.parseInline(Te[ze].tokens),{header:!1,align:Q.align[ze]});G+=this.renderer.tablerow(U)}me+=this.renderer.table(j,G);continue}case"blockquote":{G=this.parse(Q.tokens),me+=this.renderer.blockquote(G);continue}case"list":{for(ne=Q.ordered,de=Q.start,Ie=Q.loose,ke=Q.items.length,G="",Ae=0;Ae<ke;Ae++)Ke=Q.items[Ae],_e=Ke.checked,tt=Ke.task,je="",Ke.task&&(nt=this.renderer.checkbox(_e),Ie?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=nt+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=nt+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:nt}):je+=nt),je+=this.parse(Ke.tokens,Ie),G+=this.renderer.listitem(je,tt,_e);me+=this.renderer.list(G,ne,de);continue}case"html":{me+=this.renderer.html(Q.text);continue}case"paragraph":{me+=this.renderer.paragraph(this.parseInline(Q.tokens));continue}case"text":{for(G=Q.tokens?this.parseInline(Q.tokens):Q.text;pe+1<rt&&J[pe+1].type==="text";)Q=J[++pe],G+=`
`+(Q.tokens?this.parseInline(Q.tokens):Q.text);me+=x?this.renderer.paragraph(G):G;continue}default:{var ft='Token with "'+Q.type+'" type was not found.';if(this.options.silent){console.error(ft);return}else throw new Error(ft)}}}return me},be.parseInline=function(J,x){x=x||this.renderer;var me="",pe,Ae,ze,ke=J.length;for(pe=0;pe<ke;pe++){if(Ae=J[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&(ze=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),ze!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ae.type))){me+=ze||"";continue}switch(Ae.type){case"escape":{me+=x.text(Ae.text);break}case"html":{me+=x.html(Ae.text);break}case"link":{me+=x.link(Ae.href,Ae.title,this.parseInline(Ae.tokens,x));break}case"image":{me+=x.image(Ae.href,Ae.title,Ae.text);break}case"strong":{me+=x.strong(this.parseInline(Ae.tokens,x));break}case"em":{me+=x.em(this.parseInline(Ae.tokens,x));break}case"codespan":{me+=x.codespan(Ae.text);break}case"br":{me+=x.br();break}case"del":{me+=x.del(this.parseInline(Ae.tokens,x));break}case"text":{me+=x.text(Ae.text);break}default:{var Pe='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(Pe);return}else throw new Error(Pe)}}}return me},ce}();function ae(ce,be,he){if(typeof ce>"u"||ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ce)+", string expected");if(typeof be=="function"&&(he=be,be=null),be=D({},ae.defaults,be||{}),h(be),he){var J=be.highlight,x;try{x=Z.lex(ce,be)}catch(ke){return he(ke)}var me=function(Pe){var Te;if(!Pe)try{be.walkTokens&&ae.walkTokens(x,be.walkTokens),Te=se.parse(x,be)}catch(U){Pe=U}return be.highlight=J,Pe?he(Pe):he(null,Te)};if(!J||J.length<3||(delete be.highlight,!x.length))return me();var pe=0;ae.walkTokens(x,function(ke){ke.type==="code"&&(pe++,setTimeout(function(){J(ke.text,ke.lang,function(Pe,Te){if(Pe)return me(Pe);Te!=null&&Te!==ke.text&&(ke.text=Te,ke.escaped=!0),pe--,pe===0&&me()})},0))}),pe===0&&me();return}function Ae(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+f(ke.message+"",!0)+"</pre>";throw ke}try{var ze=Z.lex(ce,be);if(be.walkTokens){if(be.async)return Promise.all(ae.walkTokens(ze,be.walkTokens)).then(function(){return se.parse(ze,be)}).catch(Ae);ae.walkTokens(ze,be.walkTokens)}return se.parse(ze,be)}catch(ke){Ae(ke)}}ae.options=ae.setOptions=function(ce){return D(ae.defaults,ce),T(ae.defaults),ae},ae.getDefaults=A,ae.defaults=we.defaults,ae.use=function(){for(var ce=arguments.length,be=new Array(ce),he=0;he<ce;he++)be[he]=arguments[he];var J=D.apply(void 0,[{}].concat(be)),x=ae.defaults.extensions||{renderers:{},childTokens:{}},me;be.forEach(function(pe){if(pe.extensions&&(me=!0,pe.extensions.forEach(function(ze){if(!ze.name)throw new Error("extension name required");if(ze.renderer){var ke=x.renderers?x.renderers[ze.name]:null;ke?x.renderers[ze.name]=function(){for(var Pe=arguments.length,Te=new Array(Pe),U=0;U<Pe;U++)Te[U]=arguments[U];var j=ze.renderer.apply(this,Te);return j===!1&&(j=ke.apply(this,Te)),j}:x.renderers[ze.name]=ze.renderer}if(ze.tokenizer){if(!ze.level||ze.level!=="block"&&ze.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");x[ze.level]?x[ze.level].unshift(ze.tokenizer):x[ze.level]=[ze.tokenizer],ze.start&&(ze.level==="block"?x.startBlock?x.startBlock.push(ze.start):x.startBlock=[ze.start]:ze.level==="inline"&&(x.startInline?x.startInline.push(ze.start):x.startInline=[ze.start]))}ze.childTokens&&(x.childTokens[ze.name]=ze.childTokens)})),pe.renderer&&function(){var ze=ae.defaults.renderer||new fe,ke=function(U){var j=ze[U];ze[U]=function(){for(var G=arguments.length,Q=new Array(G),ne=0;ne<G;ne++)Q[ne]=arguments[ne];var de=pe.renderer[U].apply(ze,Q);return de===!1&&(de=j.apply(ze,Q)),de}};for(var Pe in pe.renderer)ke(Pe);J.renderer=ze}(),pe.tokenizer&&function(){var ze=ae.defaults.tokenizer||new F,ke=function(U){var j=ze[U];ze[U]=function(){for(var G=arguments.length,Q=new Array(G),ne=0;ne<G;ne++)Q[ne]=arguments[ne];var de=pe.tokenizer[U].apply(ze,Q);return de===!1&&(de=j.apply(ze,Q)),de}};for(var Pe in pe.tokenizer)ke(Pe);J.tokenizer=ze}(),pe.walkTokens){var Ae=ae.defaults.walkTokens;J.walkTokens=function(ze){var ke=[];return ke.push(pe.walkTokens.call(this,ze)),Ae&&(ke=ke.concat(Ae.call(this,ze))),ke}}me&&(J.extensions=x),ae.setOptions(J)})},ae.walkTokens=function(ce,be){for(var he=[],J=function(){var Ae=me.value;switch(he=he.concat(be.call(ae,Ae)),Ae.type){case"table":{for(var ze=N(Ae.header),ke;!(ke=ze()).done;){var Pe=ke.value;he=he.concat(ae.walkTokens(Pe.tokens,be))}for(var Te=N(Ae.rows),U;!(U=Te()).done;)for(var j=U.value,G=N(j),Q;!(Q=G()).done;){var ne=Q.value;he=he.concat(ae.walkTokens(ne.tokens,be))}break}case"list":{he=he.concat(ae.walkTokens(Ae.items,be));break}default:ae.defaults.extensions&&ae.defaults.extensions.childTokens&&ae.defaults.extensions.childTokens[Ae.type]?ae.defaults.extensions.childTokens[Ae.type].forEach(function(de){he=he.concat(ae.walkTokens(Ae[de],be))}):Ae.tokens&&(he=he.concat(ae.walkTokens(Ae.tokens,be)))}},x=N(ce),me;!(me=x()).done;)J();return he},ae.parseInline=function(ce,be){if(typeof ce>"u"||ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ce)+", string expected");be=D({},ae.defaults,be||{}),h(be);try{var he=Z.lexInline(ce,be);return be.walkTokens&&ae.walkTokens(he,be.walkTokens),se.parseInline(he,be)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+f(J.message+"",!0)+"</pre>";throw J}},ae.Parser=se,ae.parser=se.parse,ae.Renderer=fe,ae.TextRenderer=_,ae.Lexer=Z,ae.lexer=Z.lex,ae.Tokenizer=F,ae.Slugger=ge,ae.parse=ae;var $e=ae.options,oe=ae.setOptions,Ce=ae.use,Fe=ae.walkTokens,X=ae.parseInline,V=ae,te=se.parse,ve=Z.lex;we.Lexer=Z,we.Parser=se,we.Renderer=fe,we.Slugger=ge,we.TextRenderer=_,we.Tokenizer=F,we.getDefaults=A,we.lexer=ve,we.marked=ae,we.options=$e,we.parse=V,we.parseInline=X,we.parser=te,we.setOptions=oe,we.use=Ce,we.walkTokens=Fe,Object.defineProperty(we,"__esModule",{value:!0})}),define(Ne[138],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bk=v;function v(n){const o=N(n);if(o&&o.length>0)return new Uint32Array(o)}let I=0;const C=new Uint32Array(10);function N(n){if(I=0,A(n,y,$.InitialConsonant),I>0||(A(n,c,$.Vowel),I>0)||(A(n,S,$.FinalConsonant),I>0)||(A(n,f,$.CompatibilityJamo),I))return C.subarray(0,I);if(n>=44032&&n<=55203){const o=n-44032,s=o%588,l=Math.floor(o/588),i=Math.floor(s/28),r=s%28-1;if(l<y.length?A(l,y,0):$.InitialConsonant+l-$.CompatibilityJamo<f.length&&A($.InitialConsonant+l,f,$.CompatibilityJamo),i<c.length?A(i,c,0):$.Vowel+i-$.CompatibilityJamo<f.length&&A($.Vowel+i-$.CompatibilityJamo,f,$.CompatibilityJamo),r>=0&&(r<S.length?A(r,S,0):$.FinalConsonant+r-$.CompatibilityJamo<f.length&&A($.FinalConsonant+r-$.CompatibilityJamo,f,$.CompatibilityJamo)),I>0)return C.subarray(0,I)}}function A(n,o,s){n>=s&&n<s+o.length&&T(o[n-s])}function T(n){n!==a.NUL&&(C[I++]=n&255,n>>8&&(C[I++]=n>>8&255),n>>16&&(C[I++]=n>>16&255))}var $;(function(n){n[n.InitialConsonant=4352]="InitialConsonant",n[n.Vowel=4449]="Vowel",n[n.FinalConsonant=4520]="FinalConsonant",n[n.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var a;(function(n){n[n.NUL=0]="NUL",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z"})(a||(a={}));var R;(function(n){n[n.fa=24934]="fa",n[n.fg=26470]="fg",n[n.fq=29030]="fq",n[n.fr=29286]="fr",n[n.ft=29798]="ft",n[n.fv=30310]="fv",n[n.fx=30822]="fx",n[n.hk=27496]="hk",n[n.hl=27752]="hl",n[n.ho=28520]="ho",n[n.ml=27757]="ml",n[n.nj=27246]="nj",n[n.nl=27758]="nl",n[n.np=28782]="np",n[n.qt=29809]="qt",n[n.rt=29810]="rt",n[n.sg=26483]="sg",n[n.sw=30579]="sw"})(R||(R={}));const y=new Uint8Array([a.r,a.R,a.s,a.e,a.E,a.f,a.a,a.q,a.Q,a.t,a.T,a.d,a.w,a.W,a.c,a.z,a.x,a.v,a.g]),c=new Uint16Array([a.k,a.o,a.i,a.O,a.j,a.p,a.u,a.P,a.h,R.hk,R.ho,R.hl,a.y,a.n,R.nj,R.np,R.nl,a.b,a.m,R.ml,a.l]),S=new Uint16Array([a.r,a.R,R.rt,a.s,R.sw,R.sg,a.e,a.f,R.fr,R.fa,R.fq,R.ft,R.fx,R.fv,R.fg,a.a,a.q,R.qt,a.t,a.T,a.d,a.w,a.c,a.z,a.x,a.v,a.g]),f=new Uint16Array([a.r,a.R,R.rt,a.s,R.sw,R.sg,a.e,a.E,a.f,R.fr,R.fa,R.fq,R.ft,R.fx,R.fv,R.fg,a.a,a.q,a.Q,R.qt,a.t,a.T,a.d,a.w,a.W,a.c,a.z,a.x,a.v,a.g,a.k,a.o,a.i,a.O,a.j,a.p,a.u,a.P,a.h,R.hk,R.ho,R.hl,a.y,a.n,R.nj,R.np,R.nl,a.b,a.m,R.ml,a.l])}),define(Ne[139],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=e.$Km=e.$Jm=void 0,e.$Hm=v,e.rot=I,e.$Mm=T;function v($,a,R){return Math.min(Math.max($,a),R)}function I($,a){return(a+$%a)%a}class C{constructor(){this.a=0}getNext(){return this.a++}}e.$Jm=C;class N{constructor(){this.a=1,this.b=0}update(a){return this.b=this.b+(a-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Km=N;class A{constructor(a){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(a),this.c.fill(0,0,a)}update(a){const R=this.c[this.d];return this.c[this.d]=a,this.d=(this.d+1)%this.c.length,this.e-=R,this.e+=a,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Lm=A;function T($,a,R,y,c,S,f,n){const o=f-R,s=n-y,l=c-R,i=S-y,r=$-R,t=a-y,g=o*o+s*s,u=o*l+s*i,p=o*r+s*t,m=l*l+i*i,d=l*r+i*t,E=1/(g*m-u*u),D=(m*p-u*d)*E,w=(g*d-u*p)*E;return D>=0&&w>=0&&D+w<1}}),define(Ne[140],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_c=void 0,e.$ad=N,e.$bd=c;class v{constructor(f,n,o){this.owner=f,this.debugNameSource=n,this.referenceFn=o}getDebugName(f){return N(f,this)}}e.$_c=v;const I=new Map,C=new WeakMap;function N(S,f){const n=C.get(S);if(n)return n;const o=A(S,f);if(o){let s=I.get(o)??0;s++,I.set(o,s);const l=s===1?o:`${o}#${s}`;return C.set(S,l),l}}function A(S,f){const n=C.get(S);if(n)return n;const o=f.owner?R(f.owner)+".":"";let s;const l=f.debugNameSource;if(l!==void 0)if(typeof l=="function"){if(s=l(),s!==void 0)return o+s}else return o+l;const i=f.referenceFn;if(i!==void 0&&(s=c(i),s!==void 0))return o+s;if(f.owner!==void 0){const r=T(f.owner,S);if(r!==void 0)return o+r}}function T(S,f){for(const n in S)if(S[n]===f)return n}const $=new Map,a=new WeakMap;function R(S){const f=a.get(S);if(f)return f;const n=y(S);let o=$.get(n)??0;o++,$.set(n,o);const s=o===1?n:`${n}#${o}`;return a.set(S,s),s}function y(S){const f=S.constructor;return f?f.name:"Object"}function c(S){const f=S.toString(),o=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(f);return(o?o[1]:void 0)?.trim()}}),define(Ne[141],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Id=I,e.$Jd=C;let v;function I(n){v=n}function C(){return v}class N{constructor(){this.a=0,this.d=new WeakMap}b(o){return A([T(S("|  ",this.a)),o])}c(o){return o.hadValue?o.didChange?[T(" "),a(R(o.oldValue,70),{color:"red",strikeThrough:!0}),T(" "),a(R(o.newValue,60),{color:"green"})]:[T(" (unchanged)")]:[T(" "),a(R(o.newValue,60),{color:"green"}),T(" (initial)")]}handleObservableChanged(o,s){console.log(...this.b([$("observable value changed"),a(o.debugName,{color:"BlueViolet"}),...this.c(s)]))}formatChanges(o){if(o.size!==0)return a(" (changed deps: "+[...o].map(s=>s.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(o){const s=o.handleChange;this.d.set(o,new Set),o.handleChange=(l,i)=>(this.d.get(o).add(l),s.apply(o,[l,i]))}handleDerivedRecomputed(o,s){const l=this.d.get(o);console.log(...this.b([$("derived recomputed"),a(o.debugName,{color:"BlueViolet"}),...this.c(s),this.formatChanges(l),{data:[{fn:o._debugNameData.referenceFn??o._computeFn}]}])),l.clear()}handleFromEventObservableTriggered(o,s){console.log(...this.b([$("observable from event triggered"),a(o.debugName,{color:"BlueViolet"}),...this.c(s),{data:[{fn:o._getValue}]}]))}handleAutorunCreated(o){const s=o.handleChange;this.d.set(o,new Set),o.handleChange=(l,i)=>(this.d.get(o).add(l),s.apply(o,[l,i]))}handleAutorunTriggered(o){const s=this.d.get(o);console.log(...this.b([$("autorun"),a(o.debugName,{color:"BlueViolet"}),this.formatChanges(s),{data:[{fn:o._debugNameData.referenceFn??o._runFn}]}])),s.clear(),this.a++}handleAutorunFinished(o){this.a--}handleBeginTransaction(o){let s=o.getDebugName();s===void 0&&(s=""),console.log(...this.b([$("transaction"),a(s,{color:"BlueViolet"}),{data:[{fn:o._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Kd=N;function A(n){const o=new Array,s=[];let l="";function i(t){if("length"in t)for(const g of t)g&&i(g);else"text"in t?(l+=`%c${t.text}`,o.push(t.style),t.data&&s.push(...t.data)):"data"in t&&s.push(...t.data)}i(n);const r=[l,...o];return r.push(...s),r}function T(n){return a(n,{color:"black"})}function $(n){return a(f(`${n}: `,10),{color:"black",bold:!0})}function a(n,o={color:"black"}){function s(i){return Object.entries(i).reduce((r,[t,g])=>`${r}${t}:${g};`,"")}const l={color:o.color};return o.strikeThrough&&(l["text-decoration"]="line-through"),o.bold&&(l["font-weight"]="bold"),{text:n,style:s(l)}}function R(n,o){switch(typeof n){case"number":return""+n;case"string":return n.length+2<=o?`"${n}"`:`"${n.substr(0,o-7)}"+...`;case"boolean":return n?"true":"false";case"undefined":return"undefined";case"object":return n===null?"null":Array.isArray(n)?y(n,o):c(n,o);case"symbol":return n.toString();case"function":return`[[Function${n.name?" "+n.name:""}]]`;default:return""+n}}function y(n,o){let s="[ ",l=!0;for(const i of n){if(l||(s+=", "),s.length-5>o){s+="...";break}l=!1,s+=`${R(i,o-s.length)}`}return s+=" ]",s}function c(n,o){let s="{ ",l=!0;for(const[i,r]of Object.entries(n)){if(l||(s+=", "),s.length-5>o){s+="...";break}l=!1,s+=`${i}: ${R(r,o-s.length)}`}return s+=" }",s}function S(n,o){let s="";for(let l=1;l<=o;l++)s+=n;return s}function f(n,o){for(;n.length<o;)n+=" ";return n}}),define(Ne[142],Oe([1,0,135,140,141]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.$5d=e.$3d=e.$Xd=e.$Wd=void 0,e.$Td=A,e.$Ud=$,e.$Vd=R,e.$Yd=S,e.$Zd=n,e.$1d=o,e.$2d=s,e.$4d=i,e.$6d=t;let N;function A(u){N=u}let T;function $(u){T=u}let a;function R(u){a=u}class y{get TChange(){return null}reportChanges(){this.get()}read(p){return p?p.readObservable(this):this.get()}map(p,m){const d=m===void 0?void 0:p,E=m===void 0?p:m;return a({owner:d,debugName:()=>{const D=(0,I.$bd)(E);if(D!==void 0)return D;const k=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(E.toString());if(k)return`${this.debugName}.${k[2]}`;if(!d)return`${this.debugName} (mapped)`},debugReferenceFn:E},D=>E(this.read(D),D))}recomputeInitiallyAndOnChange(p,m){return p.add(N(this,m)),this}keepObserved(p){return p.add(T(this)),this}get a(){return this.get()}}e.$Wd=y;class c extends y{constructor(){super(...arguments),this.b=new Set}addObserver(p){const m=this.b.size;this.b.add(p),m===0&&this.c()}removeObserver(p){this.b.delete(p)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Xd=c;function S(u,p){const m=new l(u,p);try{u(m)}finally{m.finish()}}let f;function n(u){if(f)u(f);else{const p=new l(u,void 0);f=p;try{u(p)}finally{p.finish(),f=void 0}}}async function o(u,p){const m=new l(u,p);try{await u(m)}finally{m.finish()}}function s(u,p,m){u?p(u):S(p,m)}class l{constructor(p,m){this._fn=p,this.b=m,this.a=[],(0,C.$Jd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,I.$bd)(this._fn)}updateObserver(p,m){this.a.push({observer:p,observable:m}),p.beginUpdate(m)}finish(){const p=this.a;for(let m=0;m<p.length;m++){const{observer:d,observable:E}=p[m];d.endUpdate(E)}this.a=null,(0,C.$Jd)()?.handleEndTransaction()}}e.$3d=l;function i(u,p){let m;return typeof u=="string"?m=new I.$_c(void 0,u,void 0):m=new I.$_c(u,void 0,void 0),new r(m,p,v.$5c)}class r extends c{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(p,m,d){super(),this.e=p,this.g=d,this.d=m}get(){return this.d}set(p,m,d){if(d===void 0&&this.g(this.d,p))return;let E;m||(m=E=new l(()=>{},()=>`Setting ${this.debugName}`));try{const D=this.d;this.h(p),(0,C.$Jd)()?.handleObservableChanged(this,{oldValue:D,newValue:p,change:d,didChange:!0,hadValue:!0});for(const w of this.b)m.updateObserver(w,this),w.handleChange(this,d)}finally{E&&E.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(p){this.d=p}}e.$5d=r;function t(u,p){let m;return typeof u=="string"?m=new I.$_c(void 0,u,void 0):m=new I.$_c(u,void 0,void 0),new g(m,p,v.$5c)}class g extends r{h(p){this.d!==p&&(this.d&&this.d.dispose(),this.d=p)}dispose(){this.d?.dispose()}}e.$7d=g}),function(){function we(C){const N=[];typeof C=="number"&&N.push("code/timeOrigin",C);function A($){N.push($,Date.now())}function T(){const $=[];for(let a=0;a<N.length;a+=2)$.push({name:N[a],startTime:N[a+1]});return $}return{mark:A,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?we():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const A of performance.getEntriesByType("mark"))N.push({name:A.name,startTime:Math.round(C+A.startTime)});return N}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return we(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),we()}function v(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=v(I))}(),define(Ne[143],Oe([1,0,39]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QI=void 0;const I=Symbol("unset");class C{constructor(){this.a=new A,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||v.Iterable.empty()}get entries(){return this.a.children?.entries()||v.Iterable.empty()}insert($,a,R){this.d($,y=>y._value=a,R)}mutate($,a){this.d($,R=>R._value=a(R._value===I?void 0:R._value))}mutatePath($,a){this.d($,()=>{},R=>a(R))}delete($){const a=this.c($);if(!a)return;let R=a.length-1;const y=a[R].node._value;if(y!==I){for(this.b--,a[R].node._value=I;R>0;R--){const{node:c,part:S}=a[R];if(c.children?.size||c._value!==I)break;a[R-1].node.children.delete(S)}return y}}*deleteRecursive($){const a=this.c($);if(!a)return;const R=a[a.length-1].node;for(let y=a.length-1;y>0;y--){const c=a[y-1];if(c.node.children.delete(a[y].part),c.node.children.size>0||c.node._value!==I)break}for(const y of N(R))y._value!==I&&(this.b--,yield y._value)}find($){let a=this.a;for(const R of $){const y=a.children?.get(R);if(!y)return;a=y}return a._value===I?void 0:a._value}hasKeyOrParent($){let a=this.a;for(const R of $){const y=a.children?.get(R);if(!y)return!1;if(y._value!==I)return!0;a=y}return!1}hasKeyOrChildren($){let a=this.a;for(const R of $){const y=a.children?.get(R);if(!y)return!1;a=y}return!0}hasKey($){let a=this.a;for(const R of $){const y=a.children?.get(R);if(!y)return!1;a=y}return a._value!==I}c($){const a=[{part:"",node:this.a}];let R=0;for(const y of $){const c=a[R].node.children?.get(y);if(!c)return;a.push({part:y,node:c}),R++}return a}d($,a,R){let y=this.a;for(const f of $){if(y.children)if(y.children.has(f))y=y.children.get(f);else{const n=new A;y.children.set(f,n),y=n}else{const n=new A;y.children=new Map([[f,n]]),y=n}R?.(y)}const c=y._value===I?0:1;a(y);const S=y._value===I?0:1;this.b+=S-c}*values(){for(const{_value:$}of N(this.a))$!==I&&(yield $)}}e.$QI=C;function*N(T){const $=[T];for(;$.length>0;){const a=$.pop();if(yield a,a.children)for(const R of a.children.values())$.push(R)}}class A{constructor(){this._value=I}get value(){return this._value===I?void 0:this._value}set value($){this._value=$===void 0?I:$}}}),define(Ne[144],Oe([1,0,48,19]),function(we,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=T,e.$xr=$,e.$yr=a,e.$zr=R,e.$Ar=y,e.$Br=c,e.$Cr=S,e.$Dr=f,e.$Er=n,e.$Fr=o,e.$Gr=d,e.$Hr=E,e.$Ir=D;const C=new v.$T(()=>{const w=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:w,collatorIsNumeric:w.resolvedOptions().numeric}}),N=new v.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new v.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(w,k,P=!1){const h=w||"",b=k||"",M=C.value.collator.compare(h,b);return C.value.collatorIsNumeric&&M===0&&h!==b?h<b?-1:1:M}function $(w,k){const P=N.value.collator;return w=w||"",k=k||"",r(P,w,k)}function a(w,k){const P=N.value.collator;return w=w||"",k=k||"",p(w,k)||r(P,w,k)}function R(w,k){const P=N.value.collator;return w=w||"",k=k||"",u(w,k)||r(P,w,k)}function y(w,k){return w=w||"",k=k||"",w===k?0:w<k?-1:1}function c(w,k){const[P,h]=l(w),[b,M]=l(k);let O=C.value.collator.compare(h,M);if(O===0){if(C.value.collatorIsNumeric&&h!==M)return h<M?-1:1;if(O=C.value.collator.compare(P,b),C.value.collatorIsNumeric&&O===0&&P!==b)return P<b?-1:1}return O}function S(w,k){w=w||"",k=k||"";const P=i(w),h=i(k),b=N.value.collator,M=A.value.collator;return r(M,P,h)||r(b,w,k)}function f(w,k){w=w||"",k=k||"";const P=i(w),h=i(k),b=N.value.collator,M=A.value.collator;return r(M,P,h)||p(w,k)||r(b,w,k)}function n(w,k){w=w||"",k=k||"";const P=i(w),h=i(k),b=N.value.collator,M=A.value.collator;return r(M,P,h)||u(w,k)||r(b,w,k)}function o(w,k){w=w||"",k=k||"";const P=i(w).toLowerCase(),h=i(k).toLowerCase();return P!==h?P<h?-1:1:w!==k?w<k?-1:1:0}const s=/^(.*?)(\.([^.]*))?$/;function l(w,k=!1){const P=w?s.exec(w):[];let h=[P&&P[1]||"",P&&P[3]||""];return k&&(!h[0]&&h[1]||h[0]&&h[0].charAt(0)===".")&&(h=[h[0]+"."+h[1],""]),h}function i(w){const k=w?s.exec(w):[];return k&&k[1]&&k[1].charAt(0)!=="."&&k[3]||""}function r(w,k,P){const h=w.compare(k,P);return h!==0?h:k.length!==P.length?k.length<P.length?-1:1:0}function t(w){const k=w.charAt(0);return k.toLocaleUpperCase()!==k}function g(w){const k=w.charAt(0);return k.toLocaleLowerCase()!==k}function u(w,k){return t(w)&&g(k)?-1:g(w)&&t(k)?1:0}function p(w,k){return g(w)&&t(k)?-1:t(w)&&g(k)?1:0}function m(w,k,P=!1){return P||(w=w&&w.toLowerCase(),k=k&&k.toLowerCase()),w===k?0:w<k?-1:1}function d(w,k,P=!1){const h=w.split(I.sep),b=k.split(I.sep),M=h.length-1,O=b.length-1;let F,q;for(let B=0;;B++){if(F=M===B,q=O===B,F&&q)return T(h[B],b[B],P);if(F)return-1;if(q)return 1;const L=m(h[B],b[B],P);if(L!==0)return L}}function E(w,k,P){const h=w.toLowerCase(),b=k.toLowerCase(),M=D(w,k,P);if(M)return M;const O=h.endsWith(P),F=b.endsWith(P);if(O!==F)return O?-1:1;const q=T(h,b);return q!==0?q:h.localeCompare(b)}function D(w,k,P){const h=w.toLowerCase(),b=k.toLowerCase(),M=h.startsWith(P),O=b.startsWith(P);if(M!==O)return M?-1:1;if(M&&O){if(h.length<b.length)return-1;if(h.length>b.length)return 1}return 0}}),define(Ne[72],Oe([1,0,19]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7s=void 0,e.$8s=N,e.$9s=A,e.$0s=T,e.$$s=a,e.$7s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const I={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function N(R){const y=(0,v.$nc)(R),c=I[y.toLowerCase()];return c!==void 0?c:A(R)}function A(R){const y=(0,v.$nc)(R);return C[y.toLowerCase()]}function T(R){for(const y in C)if(C[y]===R)return y}const $=/^(.+)\/(.+?)(;.+)?$/;function a(R,y){const c=$.exec(R);return c?`${c[1].toLowerCase()}/${c[2].toLowerCase()}${c[3]??""}`:y?void 0:R}}),function(we,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var I in v)(typeof exports=="object"?exports:we)[I]=v[I]}}(typeof self<"u"?self:this,function(){return function(we){var e={};function v(I){if(e[I])return e[I].exports;var C=e[I]={i:I,l:!1,exports:{}};return we[I].call(C.exports,C,C.exports,v),C.l=!0,C.exports}return v.m=we,v.c=e,v.d=function(I,C,N){v.o(I,C)||Object.defineProperty(I,C,{enumerable:!0,get:N})},v.r=function(I){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(I,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(I,"__esModule",{value:!0})},v.t=function(I,C){if(1&C&&(I=v(I)),8&C||4&C&&typeof I=="object"&&I&&I.__esModule)return I;var N=Object.create(null);if(v.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:I}),2&C&&typeof I!="string")for(var A in I)v.d(N,A,function(T){return I[T]}.bind(null,A));return N},v.n=function(I){var C=I&&I.__esModule?function(){return I.default}:function(){return I};return v.d(C,"a",C),C},v.o=function(I,C){return Object.prototype.hasOwnProperty.call(I,C)},v.p="",v(v.s=0)}([function(we,e,v){(function(I){var C;e=we.exports=Ce,C=typeof I=="object"&&I.env&&I.env.NODE_DEBUG&&/\bsemver\b/i.test(I.env.NODE_DEBUG)?function(){var j=Array.prototype.slice.call(arguments,0);j.unshift("SEMVER"),console.log.apply(console,j)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],$=e.src=[],a=0,R=a++;$[R]="0|[1-9]\\d*";var y=a++;$[y]="[0-9]+";var c=a++;$[c]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=a++;$[S]="("+$[R]+")\\.("+$[R]+")\\.("+$[R]+")";var f=a++;$[f]="("+$[y]+")\\.("+$[y]+")\\.("+$[y]+")";var n=a++;$[n]="(?:"+$[R]+"|"+$[c]+")";var o=a++;$[o]="(?:"+$[y]+"|"+$[c]+")";var s=a++;$[s]="(?:-("+$[n]+"(?:\\."+$[n]+")*))";var l=a++;$[l]="(?:-?("+$[o]+"(?:\\."+$[o]+")*))";var i=a++;$[i]="[0-9A-Za-z-]+";var r=a++;$[r]="(?:\\+("+$[i]+"(?:\\."+$[i]+")*))";var t=a++,g="v?"+$[S]+$[s]+"?"+$[r]+"?";$[t]="^"+g+"$";var u="[v=\\s]*"+$[f]+$[l]+"?"+$[r]+"?",p=a++;$[p]="^"+u+"$";var m=a++;$[m]="((?:<|>)?=?)";var d=a++;$[d]=$[y]+"|x|X|\\*";var E=a++;$[E]=$[R]+"|x|X|\\*";var D=a++;$[D]="[v=\\s]*("+$[E]+")(?:\\.("+$[E]+")(?:\\.("+$[E]+")(?:"+$[s]+")?"+$[r]+"?)?)?";var w=a++;$[w]="[v=\\s]*("+$[d]+")(?:\\.("+$[d]+")(?:\\.("+$[d]+")(?:"+$[l]+")?"+$[r]+"?)?)?";var k=a++;$[k]="^"+$[m]+"\\s*"+$[D]+"$";var P=a++;$[P]="^"+$[m]+"\\s*"+$[w]+"$";var h=a++;$[h]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var b=a++;$[b]="(?:~>?)";var M=a++;$[M]="(\\s*)"+$[b]+"\\s+",T[M]=new RegExp($[M],"g");var O=a++;$[O]="^"+$[b]+$[D]+"$";var F=a++;$[F]="^"+$[b]+$[w]+"$";var q=a++;$[q]="(?:\\^)";var B=a++;$[B]="(\\s*)"+$[q]+"\\s+",T[B]=new RegExp($[B],"g");var L=a++;$[L]="^"+$[q]+$[D]+"$";var Y=a++;$[Y]="^"+$[q]+$[w]+"$";var Z=a++;$[Z]="^"+$[m]+"\\s*("+u+")$|^$";var fe=a++;$[fe]="^"+$[m]+"\\s*("+g+")$|^$";var _=a++;$[_]="(\\s*)"+$[m]+"\\s*("+u+"|"+$[D]+")",T[_]=new RegExp($[_],"g");var ge=a++;$[ge]="^\\s*("+$[D]+")\\s+-\\s+("+$[D]+")\\s*$";var se=a++;$[se]="^\\s*("+$[w]+")\\s+-\\s+("+$[w]+")\\s*$";var ae=a++;$[ae]="(<|>)?=?\\s*\\*";for(var $e=0;$e<35;$e++)C($e,$[$e]),T[$e]||(T[$e]=new RegExp($[$e]));function oe(j,G){if(j instanceof Ce)return j;if(typeof j!="string"||j.length>N||!(G?T[p]:T[t]).test(j))return null;try{return new Ce(j,G)}catch{return null}}function Ce(j,G){if(j instanceof Ce){if(j.loose===G)return j;j=j.version}else if(typeof j!="string")throw new TypeError("Invalid Version: "+j);if(j.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof Ce))return new Ce(j,G);C("SemVer",j,G),this.loose=G;var Q=j.trim().match(G?T[p]:T[t]);if(!Q)throw new TypeError("Invalid Version: "+j);if(this.raw=j,this.major=+Q[1],this.minor=+Q[2],this.patch=+Q[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");Q[4]?this.prerelease=Q[4].split(".").map(function(ne){if(/^[0-9]+$/.test(ne)){var de=+ne;if(de>=0&&de<A)return de}return ne}):this.prerelease=[],this.build=Q[5]?Q[5].split("."):[],this.format()}e.parse=oe,e.valid=function(j,G){var Q=oe(j,G);return Q?Q.version:null},e.clean=function(j,G){var Q=oe(j.trim().replace(/^[=v]+/,""),G);return Q?Q.version:null},e.SemVer=Ce,Ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Ce.prototype.toString=function(){return this.version},Ce.prototype.compare=function(j){return C("SemVer.compare",this.version,this.loose,j),j instanceof Ce||(j=new Ce(j,this.loose)),this.compareMain(j)||this.comparePre(j)},Ce.prototype.compareMain=function(j){return j instanceof Ce||(j=new Ce(j,this.loose)),X(this.major,j.major)||X(this.minor,j.minor)||X(this.patch,j.patch)},Ce.prototype.comparePre=function(j){if(j instanceof Ce||(j=new Ce(j,this.loose)),this.prerelease.length&&!j.prerelease.length)return-1;if(!this.prerelease.length&&j.prerelease.length)return 1;if(!this.prerelease.length&&!j.prerelease.length)return 0;var G=0;do{var Q=this.prerelease[G],ne=j.prerelease[G];if(C("prerelease compare",G,Q,ne),Q===void 0&&ne===void 0)return 0;if(ne===void 0)return 1;if(Q===void 0)return-1;if(Q!==ne)return X(Q,ne)}while(++G)},Ce.prototype.inc=function(j,G){switch(j){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Q=this.prerelease.length;--Q>=0;)typeof this.prerelease[Q]=="number"&&(this.prerelease[Q]++,Q=-2);Q===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+j)}return this.format(),this.raw=this.version,this},e.inc=function(j,G,Q,ne){typeof Q=="string"&&(ne=Q,Q=void 0);try{return new Ce(j,Q).inc(G,ne).version}catch{return null}},e.diff=function(j,G){if(ce(j,G))return null;var Q=oe(j),ne=oe(G);if(Q.prerelease.length||ne.prerelease.length){for(var de in Q)if((de==="major"||de==="minor"||de==="patch")&&Q[de]!==ne[de])return"pre"+de;return"prerelease"}for(var de in Q)if((de==="major"||de==="minor"||de==="patch")&&Q[de]!==ne[de])return de},e.compareIdentifiers=X;var Fe=/^[0-9]+$/;function X(j,G){var Q=Fe.test(j),ne=Fe.test(G);return Q&&ne&&(j=+j,G=+G),Q&&!ne?-1:ne&&!Q?1:j<G?-1:j>G?1:0}function V(j,G,Q){return new Ce(j,Q).compare(new Ce(G,Q))}function te(j,G,Q){return V(j,G,Q)>0}function ve(j,G,Q){return V(j,G,Q)<0}function ce(j,G,Q){return V(j,G,Q)===0}function be(j,G,Q){return V(j,G,Q)!==0}function he(j,G,Q){return V(j,G,Q)>=0}function J(j,G,Q){return V(j,G,Q)<=0}function x(j,G,Q,ne){var de;switch(G){case"===":typeof j=="object"&&(j=j.version),typeof Q=="object"&&(Q=Q.version),de=j===Q;break;case"!==":typeof j=="object"&&(j=j.version),typeof Q=="object"&&(Q=Q.version),de=j!==Q;break;case"":case"=":case"==":de=ce(j,Q,ne);break;case"!=":de=be(j,Q,ne);break;case">":de=te(j,Q,ne);break;case">=":de=he(j,Q,ne);break;case"<":de=ve(j,Q,ne);break;case"<=":de=J(j,Q,ne);break;default:throw new TypeError("Invalid operator: "+G)}return de}function me(j,G){if(j instanceof me){if(j.loose===G)return j;j=j.value}if(!(this instanceof me))return new me(j,G);C("comparator",j,G),this.loose=G,this.parse(j),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(j,G){return X(G,j)},e.major=function(j,G){return new Ce(j,G).major},e.minor=function(j,G){return new Ce(j,G).minor},e.patch=function(j,G){return new Ce(j,G).patch},e.compare=V,e.compareLoose=function(j,G){return V(j,G,!0)},e.rcompare=function(j,G,Q){return V(G,j,Q)},e.sort=function(j,G){return j.sort(function(Q,ne){return e.compare(Q,ne,G)})},e.rsort=function(j,G){return j.sort(function(Q,ne){return e.rcompare(Q,ne,G)})},e.gt=te,e.lt=ve,e.eq=ce,e.neq=be,e.gte=he,e.lte=J,e.cmp=x,e.Comparator=me;var pe={};function Ae(j,G){if(j instanceof Ae)return j.loose===G?j:new Ae(j.raw,G);if(j instanceof me)return new Ae(j.value,G);if(!(this instanceof Ae))return new Ae(j,G);if(this.loose=G,this.raw=j,this.set=j.split(/\s*\|\|\s*/).map(function(Q){return this.parseRange(Q.trim())},this).filter(function(Q){return Q.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+j);this.format()}function ze(j){return!j||j.toLowerCase()==="x"||j==="*"}function ke(j,G,Q,ne,de,Ie,je,Ke,_e,tt,nt,et,rt){return((G=ze(Q)?"":ze(ne)?">="+Q+".0.0":ze(de)?">="+Q+"."+ne+".0":">="+G)+" "+(Ke=ze(_e)?"":ze(tt)?"<"+(+_e+1)+".0.0":ze(nt)?"<"+_e+"."+(+tt+1)+".0":et?"<="+_e+"."+tt+"."+nt+"-"+et:"<="+Ke)).trim()}function Pe(j,G){for(var Q=0;Q<j.length;Q++)if(!j[Q].test(G))return!1;if(G.prerelease.length){for(Q=0;Q<j.length;Q++)if(C(j[Q].semver),j[Q].semver!==pe&&j[Q].semver.prerelease.length>0){var ne=j[Q].semver;if(ne.major===G.major&&ne.minor===G.minor&&ne.patch===G.patch)return!0}return!1}return!0}function Te(j,G,Q){try{G=new Ae(G,Q)}catch{return!1}return G.test(j)}function U(j,G,Q,ne){var de,Ie,je,Ke,_e;switch(j=new Ce(j,ne),G=new Ae(G,ne),Q){case">":de=te,Ie=J,je=ve,Ke=">",_e=">=";break;case"<":de=ve,Ie=he,je=te,Ke="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Te(j,G,ne))return!1;for(var tt=0;tt<G.set.length;++tt){var nt=G.set[tt],et=null,rt=null;if(nt.forEach(function(ft){ft.semver===pe&&(ft=new me(">=0.0.0")),et=et||ft,rt=rt||ft,de(ft.semver,et.semver,ne)?et=ft:je(ft.semver,rt.semver,ne)&&(rt=ft)}),et.operator===Ke||et.operator===_e||(!rt.operator||rt.operator===Ke)&&Ie(j,rt.semver)||rt.operator===_e&&je(j,rt.semver))return!1}return!0}me.prototype.parse=function(j){var G=this.loose?T[Z]:T[fe],Q=j.match(G);if(!Q)throw new TypeError("Invalid comparator: "+j);this.operator=Q[1],this.operator==="="&&(this.operator=""),Q[2]?this.semver=new Ce(Q[2],this.loose):this.semver=pe},me.prototype.toString=function(){return this.value},me.prototype.test=function(j){return C("Comparator.test",j,this.loose),this.semver===pe||(typeof j=="string"&&(j=new Ce(j,this.loose)),x(j,this.operator,this.semver,this.loose))},me.prototype.intersects=function(j,G){if(!(j instanceof me))throw new TypeError("a Comparator is required");var Q;if(this.operator==="")return Q=new Ae(j.value,G),Te(this.value,Q,G);if(j.operator==="")return Q=new Ae(this.value,G),Te(j.semver,Q,G);var ne=!(this.operator!==">="&&this.operator!==">"||j.operator!==">="&&j.operator!==">"),de=!(this.operator!=="<="&&this.operator!=="<"||j.operator!=="<="&&j.operator!=="<"),Ie=this.semver.version===j.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||j.operator!==">="&&j.operator!=="<="),Ke=x(this.semver,"<",j.semver,G)&&(this.operator===">="||this.operator===">")&&(j.operator==="<="||j.operator==="<"),_e=x(this.semver,">",j.semver,G)&&(this.operator==="<="||this.operator==="<")&&(j.operator===">="||j.operator===">");return ne||de||Ie&&je||Ke||_e},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function(j){return j.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function(j){var G=this.loose;j=j.trim(),C("range",j,G);var Q=G?T[se]:T[ge];j=j.replace(Q,ke),C("hyphen replace",j),j=j.replace(T[_],"$1$2$3"),C("comparator trim",j,T[_]),j=(j=(j=j.replace(T[M],"$1~")).replace(T[B],"$1^")).split(/\s+/).join(" ");var ne=G?T[Z]:T[fe],de=j.split(" ").map(function(Ie){return function(je,Ke){return C("comp",je),je=function(_e,tt){return _e.trim().split(/\s+/).map(function(nt){return function(et,rt){C("caret",et,rt);var ft=rt?T[Y]:T[L];return et.replace(ft,function(ct,st,lt,gt,pt){var Be;return C("caret",et,ct,st,lt,gt,pt),ze(st)?Be="":ze(lt)?Be=">="+st+".0.0 <"+(+st+1)+".0.0":ze(gt)?Be=st==="0"?">="+st+"."+lt+".0 <"+st+"."+(+lt+1)+".0":">="+st+"."+lt+".0 <"+(+st+1)+".0.0":pt?(C("replaceCaret pr",pt),pt.charAt(0)!=="-"&&(pt="-"+pt),Be=st==="0"?lt==="0"?">="+st+"."+lt+"."+gt+pt+" <"+st+"."+lt+"."+(+gt+1):">="+st+"."+lt+"."+gt+pt+" <"+st+"."+(+lt+1)+".0":">="+st+"."+lt+"."+gt+pt+" <"+(+st+1)+".0.0"):(C("no pr"),Be=st==="0"?lt==="0"?">="+st+"."+lt+"."+gt+" <"+st+"."+lt+"."+(+gt+1):">="+st+"."+lt+"."+gt+" <"+st+"."+(+lt+1)+".0":">="+st+"."+lt+"."+gt+" <"+(+st+1)+".0.0"),C("caret return",Be),Be})}(nt,tt)}).join(" ")}(je,Ke),C("caret",je),je=function(_e,tt){return _e.trim().split(/\s+/).map(function(nt){return function(et,rt){var ft=rt?T[F]:T[O];return et.replace(ft,function(ct,st,lt,gt,pt){var Be;return C("tilde",et,ct,st,lt,gt,pt),ze(st)?Be="":ze(lt)?Be=">="+st+".0.0 <"+(+st+1)+".0.0":ze(gt)?Be=">="+st+"."+lt+".0 <"+st+"."+(+lt+1)+".0":pt?(C("replaceTilde pr",pt),pt.charAt(0)!=="-"&&(pt="-"+pt),Be=">="+st+"."+lt+"."+gt+pt+" <"+st+"."+(+lt+1)+".0"):Be=">="+st+"."+lt+"."+gt+" <"+st+"."+(+lt+1)+".0",C("tilde return",Be),Be})}(nt,tt)}).join(" ")}(je,Ke),C("tildes",je),je=function(_e,tt){return C("replaceXRanges",_e,tt),_e.split(/\s+/).map(function(nt){return function(et,rt){et=et.trim();var ft=rt?T[P]:T[k];return et.replace(ft,function(ct,st,lt,gt,pt,Be){C("xRange",et,ct,st,lt,gt,pt,Be);var Ue=ze(lt),ee=Ue||ze(gt),K=ee||ze(pt);return st==="="&&K&&(st=""),Ue?ct=st===">"||st==="<"?"<0.0.0":"*":st&&K?(ee&&(gt=0),K&&(pt=0),st===">"?(st=">=",ee?(lt=+lt+1,gt=0,pt=0):K&&(gt=+gt+1,pt=0)):st==="<="&&(st="<",ee?lt=+lt+1:gt=+gt+1),ct=st+lt+"."+gt+"."+pt):ee?ct=">="+lt+".0.0 <"+(+lt+1)+".0.0":K&&(ct=">="+lt+"."+gt+".0 <"+lt+"."+(+gt+1)+".0"),C("xRange return",ct),ct})}(nt,tt)}).join(" ")}(je,Ke),C("xrange",je),je=function(_e,tt){return C("replaceStars",_e,tt),_e.trim().replace(T[ae],"")}(je,Ke),C("stars",je),je}(Ie,G)}).join(" ").split(/\s+/);return this.loose&&(de=de.filter(function(Ie){return!!Ie.match(ne)})),de=de.map(function(Ie){return new me(Ie,G)})},Ae.prototype.intersects=function(j,G){if(!(j instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(Q){return Q.every(function(ne){return j.set.some(function(de){return de.every(function(Ie){return ne.intersects(Ie,G)})})})})},e.toComparators=function(j,G){return new Ae(j,G).set.map(function(Q){return Q.map(function(ne){return ne.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function(j){if(!j)return!1;typeof j=="string"&&(j=new Ce(j,this.loose));for(var G=0;G<this.set.length;G++)if(Pe(this.set[G],j))return!0;return!1},e.satisfies=Te,e.maxSatisfying=function(j,G,Q){var ne=null,de=null;try{var Ie=new Ae(G,Q)}catch{return null}return j.forEach(function(je){Ie.test(je)&&(ne&&de.compare(je)!==-1||(de=new Ce(ne=je,Q)))}),ne},e.minSatisfying=function(j,G,Q){var ne=null,de=null;try{var Ie=new Ae(G,Q)}catch{return null}return j.forEach(function(je){Ie.test(je)&&(ne&&de.compare(je)!==1||(de=new Ce(ne=je,Q)))}),ne},e.validRange=function(j,G){try{return new Ae(j,G).range||"*"}catch{return null}},e.ltr=function(j,G,Q){return U(j,G,"<",Q)},e.gtr=function(j,G,Q){return U(j,G,">",Q)},e.outside=U,e.prerelease=function(j,G){var Q=oe(j,G);return Q&&Q.prerelease.length?Q.prerelease:null},e.intersects=function(j,G,Q){return j=new Ae(j,Q),G=new Ae(G,Q),j.intersects(G)},e.coerce=function(j){if(j instanceof Ce)return j;if(typeof j!="string")return null;var G=j.match(T[h]);return G==null?null:oe((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,v(1))},function(we,e){var v,I,C=we.exports={};function N(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function T(o){if(v===setTimeout)return setTimeout(o,0);if((v===N||!v)&&setTimeout)return v=setTimeout,setTimeout(o,0);try{return v(o,0)}catch{try{return v.call(null,o,0)}catch{return v.call(this,o,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:N}catch{v=N}try{I=typeof clearTimeout=="function"?clearTimeout:A}catch{I=A}})();var $,a=[],R=!1,y=-1;function c(){R&&$&&(R=!1,$.length?a=$.concat(a):y=-1,a.length&&S())}function S(){if(!R){var o=T(c);R=!0;for(var s=a.length;s;){for($=a,a=[];++y<s;)$&&$[y].run();y=-1,s=a.length}$=null,R=!1,function(l){if(I===clearTimeout)return clearTimeout(l);if((I===A||!I)&&clearTimeout)return I=clearTimeout,clearTimeout(l);try{I(l)}catch{try{return I.call(null,l)}catch{return I.call(this,l)}}}(o)}}function f(o,s){this.fun=o,this.array=s}function n(){}C.nextTick=function(o){var s=new Array(arguments.length-1);if(arguments.length>1)for(var l=1;l<arguments.length;l++)s[l-1]=arguments[l];a.push(new f(o,s)),a.length!==1||R||T(S)},f.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=n,C.addListener=n,C.once=n,C.off=n,C.removeListener=n,C.removeAllListeners=n,C.emit=n,C.prependListener=n,C.prependOnceListener=n,C.listeners=function(o){return[]},C.binding=function(o){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(o){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Ne[145],Oe([1,0,6,4]),function(we,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=e.$bt=e.$at=e.$_s=e.ScrollbarVisibility=void 0;var C;(function(S){S[S.Auto=1]="Auto",S[S.Hidden=2]="Hidden",S[S.Visible=3]="Visible"})(C||(e.ScrollbarVisibility=C={}));class N{constructor(f,n,o,s,l,i,r){this.c=f,this._scrollStateBrand=void 0,this.c&&(n=n|0,o=o|0,s=s|0,l=l|0,i=i|0,r=r|0),this.rawScrollLeft=s,this.rawScrollTop=r,n<0&&(n=0),s+n>o&&(s=o-n),s<0&&(s=0),l<0&&(l=0),r+l>i&&(r=i-l),r<0&&(r=0),this.width=n,this.scrollWidth=o,this.scrollLeft=s,this.height=l,this.scrollHeight=i,this.scrollTop=r}equals(f){return this.rawScrollLeft===f.rawScrollLeft&&this.rawScrollTop===f.rawScrollTop&&this.width===f.width&&this.scrollWidth===f.scrollWidth&&this.scrollLeft===f.scrollLeft&&this.height===f.height&&this.scrollHeight===f.scrollHeight&&this.scrollTop===f.scrollTop}withScrollDimensions(f,n){return new N(this.c,typeof f.width<"u"?f.width:this.width,typeof f.scrollWidth<"u"?f.scrollWidth:this.scrollWidth,n?this.rawScrollLeft:this.scrollLeft,typeof f.height<"u"?f.height:this.height,typeof f.scrollHeight<"u"?f.scrollHeight:this.scrollHeight,n?this.rawScrollTop:this.scrollTop)}withScrollPosition(f){return new N(this.c,this.width,this.scrollWidth,typeof f.scrollLeft<"u"?f.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof f.scrollTop<"u"?f.scrollTop:this.rawScrollTop)}createScrollEvent(f,n){const o=this.width!==f.width,s=this.scrollWidth!==f.scrollWidth,l=this.scrollLeft!==f.scrollLeft,i=this.height!==f.height,r=this.scrollHeight!==f.scrollHeight,t=this.scrollTop!==f.scrollTop;return{inSmoothScrolling:n,oldWidth:f.width,oldScrollWidth:f.scrollWidth,oldScrollLeft:f.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:f.height,oldScrollHeight:f.scrollHeight,oldScrollTop:f.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:o,scrollWidthChanged:s,scrollLeftChanged:l,heightChanged:i,scrollHeightChanged:r,scrollTopChanged:t}}}e.$_s=N;class A extends I.$Tc{constructor(f){super(),this._scrollableBrand=void 0,this.j=this.B(new v.$je),this.onScroll=this.j.event,this.c=f.smoothScrollDuration,this.f=f.scheduleAtNextAnimationFrame,this.g=new N(f.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(f){this.c=f}validateScrollPosition(f){return this.g.withScrollPosition(f)}getScrollDimensions(){return this.g}setScrollDimensions(f,n){const o=this.g.withScrollDimensions(f,n);this.n(o,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(f){const n=this.g.withScrollPosition(f);this.h&&(this.h.dispose(),this.h=null),this.n(n,!1)}setScrollPositionSmooth(f,n){if(this.c===0)return this.setScrollPositionNow(f);if(this.h){f={scrollLeft:typeof f.scrollLeft>"u"?this.h.to.scrollLeft:f.scrollLeft,scrollTop:typeof f.scrollTop>"u"?this.h.to.scrollTop:f.scrollTop};const o=this.g.withScrollPosition(f);if(this.h.to.scrollLeft===o.scrollLeft&&this.h.to.scrollTop===o.scrollTop)return;let s;n?s=new R(this.h.from,o,this.h.startTime,this.h.duration):s=this.h.combine(this.g,o,this.c),this.h.dispose(),this.h=s}else{const o=this.g.withScrollPosition(f);this.h=R.start(this.g,o,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const f=this.h.tick(),n=this.g.withScrollPosition(f);if(this.n(n,!0),!!this.h){if(f.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(f,n){const o=this.g;o.equals(f)||(this.g=f,this.j.fire(this.g.createScrollEvent(o,n)))}}e.$at=A;class T{constructor(f,n,o){this.scrollLeft=f,this.scrollTop=n,this.isDone=o}}e.$bt=T;function $(S,f){const n=f-S;return function(o){return S+n*c(o)}}function a(S,f,n){return function(o){return o<n?S(o/n):f((o-n)/(1-n))}}class R{constructor(f,n,o,s){this.from=f,this.to=n,this.duration=s,this.startTime=o,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(f,n,o){if(Math.abs(f-n)>2.5*o){let l,i;return f<n?(l=f+.75*o,i=n-.75*o):(l=f-.75*o,i=n+.75*o),a($(f,l),$(i,n),.33)}return $(f,n)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(f){this.to=f.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(f){const n=(f-this.startTime)/this.duration;if(n<1){const o=this.c(n),s=this.d(n);return new T(o,s,!1)}return new T(this.to.scrollLeft,this.to.scrollTop,!0)}combine(f,n,o){return R.start(f,n,o)}static start(f,n,o){o=o+10;const s=Date.now()-10;return new R(f,n,s,o)}}e.$ct=R;function y(S){return Math.pow(S,3)}function c(S){return 1-y(1-S)}}),define(Ne[146],Oe([1,0,13,4]),function(we,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=C,e.$xe=N,e.$ye=A,e.$ze=T,e.$Ae=a,e.$Be=R,e.$Ce=y,e.$De=c,e.$Ee=S,e.$Fe=f,e.$Ge=n,e.$He=o,e.$Ie=s,e.$Je=l,e.$Ke=i;function C(r){const t=r;return t?typeof t.read=="function":!1}function N(r){const t=r;return t?[t.on,t.pause,t.resume,t.destroy].every(g=>typeof g=="function"):!1}function A(r){const t=r;return t?N(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function T(r,t){return new $(r,t)}class ${constructor(t,g){this.e=t,this.f=g,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(g=>this.d.push(g))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(g=>g(t))}h(t){this.c.error.length===0?(0,v.$Y)(t):this.c.error.slice(0).forEach(g=>g(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,g){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(g),this.resume();break;case"end":this.c.end.push(g),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(g),this.a.flowing&&this.k();break}}removeListener(t,g){if(this.a.destroyed)return;let u;switch(t){case"data":u=this.c.data;break;case"end":u=this.c.end;break;case"error":u=this.c.error;break}if(u){const p=u.indexOf(g);p>=0&&u.splice(p,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const g=[...this.d];this.d.length=0,g.forEach(u=>u())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(r,t){const g=[];let u;for(;(u=r.read())!==null;)g.push(u);return t(g)}function R(r,t,g){const u=[];let p;for(;(p=r.read())!==null&&u.length<g;)u.push(p);return p===null&&u.length>0?t(u):{read:()=>{if(u.length>0)return u.shift();if(typeof p<"u"){const m=p;return p=void 0,m}return r.read()}}}function y(r,t){return new Promise((g,u)=>{const p=[];c(r,{onData:m=>{t&&p.push(m)},onError:m=>{t?u(m):g(void 0)},onEnd:()=>{g(t?t(p):void 0)}})})}function c(r,t,g){r.on("error",u=>{g?.isCancellationRequested||t.onError(u)}),r.on("end",()=>{g?.isCancellationRequested||t.onEnd()}),r.on("data",u=>{g?.isCancellationRequested||t.onData(u)})}function S(r,t){return new Promise((g,u)=>{const p=new I.$Sc,m=[],d=w=>{if(m.push(w),m.length>t)return p.dispose(),r.pause(),g({stream:r,buffer:m,ended:!1})},E=w=>(p.dispose(),u(w)),D=()=>(p.dispose(),g({stream:r,buffer:m,ended:!0}));p.add((0,I.$Rc)(()=>r.removeListener("error",E))),r.on("error",E),p.add((0,I.$Rc)(()=>r.removeListener("end",D))),r.on("end",D),p.add((0,I.$Rc)(()=>r.removeListener("data",d))),r.on("data",d)})}function f(r,t){const g=T(t);return g.end(r),g}function n(){const r=T(()=>{throw new Error("not supported")});return r.end(),r}function o(r){let t=!1;return{read:()=>t?null:(t=!0,r)}}function s(r,t,g){const u=T(g);return c(r,{onData:p=>u.write(t.data(p)),onError:p=>u.error(t.error?t.error(p):p),onEnd:()=>u.end()}),u}function l(r,t,g){let u=!1;return{read:()=>{const p=t.read();return u?p:(u=!0,p!==null?g([r,p]):r)}}}function i(r,t,g){let u=!1;const p=T(g);return c(t,{onData:m=>u?p.write(m):(u=!0,p.write(g([r,m]))),onError:m=>p.error(m),onEnd:()=>{u||(u=!0,p.write(r)),p.end()}}),p}}),define(Ne[22],Oe([1,0,48,146]),function(we,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Le=void 0,e.$Me=a,e.$Ne=R,e.$Oe=y,e.$Pe=c,e.$Qe=S,e.$Re=f,e.$Se=n,e.$Te=o,e.$Ue=s,e.$Ve=l,e.$We=i,e.$Xe=r,e.$Ye=t,e.$Ze=g,e.$1e=u,e.$2e=p,e.$3e=m,e.$4e=d,e.$5e=E,e.$6e=k,I=Ve(I);const C=typeof Buffer<"u",N=new v.$T(()=>new Uint8Array(256));let A,T;class ${static alloc(h){return C?new $(Buffer.allocUnsafe(h)):new $(new Uint8Array(h))}static wrap(h){return C&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new $(h)}static fromString(h,b){return!(b?.dontUseNodeBuffer||!1)&&C?new $(Buffer.from(h)):(A||(A=new TextEncoder),new $(A.encode(h)))}static fromByteArray(h){const b=$.alloc(h.length);for(let M=0,O=h.length;M<O;M++)b.buffer[M]=h[M];return b}static concat(h,b){if(typeof b>"u"){b=0;for(let F=0,q=h.length;F<q;F++)b+=h[F].byteLength}const M=$.alloc(b);let O=0;for(let F=0,q=h.length;F<q;F++){const B=h[F];M.set(B,O),O+=B.byteLength}return M}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=$.alloc(this.byteLength);return h.set(this),h}toString(){return C?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(h,b){return new $(this.buffer.subarray(h,b))}set(h,b){if(h instanceof $)this.buffer.set(h.buffer,b);else if(h instanceof Uint8Array)this.buffer.set(h,b);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),b);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),b);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return c(this.buffer,h)}writeUInt32BE(h,b){S(this.buffer,h,b)}readUInt32LE(h){return f(this.buffer,h)}writeUInt32LE(h,b){n(this.buffer,h,b)}readUInt8(h){return o(this.buffer,h)}writeUInt8(h,b){s(this.buffer,h,b)}indexOf(h,b=0){return a(this.buffer,h instanceof $?h.buffer:h,b)}}e.$Le=$;function a(P,h,b=0){const M=h.byteLength,O=P.byteLength;if(M===0)return 0;if(M===1)return P.indexOf(h[0]);if(M>O-b)return-1;const F=N.value;F.fill(h.length);for(let Y=0;Y<h.length;Y++)F[h[Y]]=h.length-Y-1;let q=b+h.length-1,B=q,L=-1;for(;q<O;)if(P[q]===h[B]){if(B===0){L=q;break}q--,B--}else q+=Math.max(h.length-B,F[P[q]]),B=h.length-1;return L}function R(P,h){return P[h+0]<<0>>>0|P[h+1]<<8>>>0}function y(P,h,b){P[b+0]=h&255,h=h>>>8,P[b+1]=h&255}function c(P,h){return P[h]*2**24+P[h+1]*2**16+P[h+2]*2**8+P[h+3]}function S(P,h,b){P[b+3]=h,h=h>>>8,P[b+2]=h,h=h>>>8,P[b+1]=h,h=h>>>8,P[b]=h}function f(P,h){return P[h+0]<<0>>>0|P[h+1]<<8>>>0|P[h+2]<<16>>>0|P[h+3]<<24>>>0}function n(P,h,b){P[b+0]=h&255,h=h>>>8,P[b+1]=h&255,h=h>>>8,P[b+2]=h&255,h=h>>>8,P[b+3]=h&255}function o(P,h){return P[h]}function s(P,h,b){P[b]=h}function l(P){return I.$Ae(P,h=>$.concat(h))}function i(P){return I.$He(P)}function r(P){return I.$Ce(P,h=>$.concat(h))}async function t(P){return P.ended?$.concat(P.buffer):$.concat([...P.buffer,await r(P.stream)])}function g(P){return I.$Fe(P,h=>$.concat(h))}function u(P){return I.$Ie(P,{data:h=>typeof h=="string"?$.fromString(h):$.wrap(h)},h=>$.concat(h))}function p(P){return I.$ze(h=>$.concat(h),P)}function m(P,h){return I.$Je(P,h,b=>$.concat(b))}function d(P,h){return I.$Ke(P,h,b=>$.concat(b))}function E(P){let h=0,b=0,M=0;const O=new Uint8Array(Math.floor(P.length/4*3)),F=B=>{switch(b){case 3:O[M++]=h|B,b=0;break;case 2:O[M++]=h|B>>>2,h=B<<6,b=3;break;case 1:O[M++]=h|B>>>4,h=B<<4,b=2;break;default:h=B<<2,b=1}};for(let B=0;B<P.length;B++){const L=P.charCodeAt(B);if(L>=65&&L<=90)F(L-65);else if(L>=97&&L<=122)F(L-97+26);else if(L>=48&&L<=57)F(L-48+52);else if(L===43||L===45)F(62);else if(L===47||L===95)F(63);else{if(L===61)break;throw new SyntaxError(`Unexpected base64 character ${P[B]}`)}}const q=M;for(;b>0;)F(0);return $.wrap(O).slice(0,q)}const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function k({buffer:P},h=!0,b=!1){const M=b?w:D;let O="";const F=P.byteLength%3;let q=0;for(;q<P.byteLength-F;q+=3){const B=P[q+0],L=P[q+1],Y=P[q+2];O+=M[B>>>2],O+=M[(B<<4|L>>>4)&63],O+=M[(L<<2|Y>>>6)&63],O+=M[Y&63]}if(F===1){const B=P[q+0];O+=M[B>>>2],O+=M[B<<4&63],h&&(O+="==")}else if(F===2){const B=P[q+0],L=P[q+1];O+=M[B>>>2],O+=M[(B<<4|L>>>4)&63],O+=M[L<<2&63],h&&(O+="=")}return O}}),define(Ne[147],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=void 0,e.$ee=Symbol("MicrotaskDelay")}),define(Ne[34],Oe([1,0,97]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$3j=C;var I;(function(A){function T($){return $&&typeof $=="object"&&typeof $.id=="string"}A.isThemeColor=T})(I||(e.ThemeColor=I={}));function C(A){return{id:A}}var N;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function $(l){const i=T.exec(l.id);if(!i)return $(v.$2j.error);const[,r,t]=i,g=["codicon","codicon-"+r];return t&&g.push("codicon-modifier-"+t.substring(1)),g}A.asClassNameArray=$;function a(l){return $(l).join(" ")}A.asClassName=a;function R(l){return"."+$(l).join(".")}A.asCSSSelector=R;function y(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color>"u"||I.isThemeColor(l.color))}A.isThemeIcon=y;const c=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function S(l){const i=c.exec(l);if(!i)return;const[,r]=i;return{id:r}}A.fromString=S;function f(l){return{id:l}}A.fromId=f;function n(l,i){let r=l.id;const t=r.lastIndexOf("~");return t!==-1&&(r=r.substring(0,t)),i&&(r=`${r}~${i}`),{id:r}}A.modify=n;function o(l){const i=l.id.lastIndexOf("~");if(i!==-1)return l.id.substring(i+1)}A.getModifier=o;function s(l,i){return l.id===i.id&&l.color?.id===i.color?.id}A.isEqual=s})(N||(e.ThemeIcon=N={}))}),define(Ne[51],Oe([1,0,27,19,20,12,14]),function(we,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ug=T,e.$vg=$,e.$wg=a,e.$xg=R,e.$yg=y,e.$zg=n,e.$Ag=o,e.$Bg=s,e.$Cg=l,e.$Dg=i,e.$Eg=r,e.$Fg=t,e.$Gg=g,e.$Hg=u,e.$Ig=p,e.$Jg=m,e.$Kg=D;function T(w){return w===v.CharCode.Slash||w===v.CharCode.Backslash}function $(w){return w.replace(/[\\/]/g,I.$fc.sep)}function a(w){return w.indexOf("/")===-1&&(w=$(w)),/^[a-zA-Z]:(\/|$)/.test(w)&&(w="/"+w),w}function R(w,k=I.$fc.sep){if(!w)return"";const P=w.length,h=w.charCodeAt(0);if(T(h)){if(T(w.charCodeAt(1))&&!T(w.charCodeAt(2))){let M=3;const O=M;for(;M<P&&!T(w.charCodeAt(M));M++);if(O!==M&&!T(w.charCodeAt(M+1))){for(M+=1;M<P;M++)if(T(w.charCodeAt(M)))return w.slice(0,M+1).replace(/[\\/]/g,k)}}return k}else if(l(h)&&w.charCodeAt(1)===v.CharCode.Colon)return T(w.charCodeAt(2))?w.slice(0,2)+k:w.slice(0,2);let b=w.indexOf("://");if(b!==-1){for(b+=3;b<P;b++)if(T(w.charCodeAt(b)))return w.slice(0,b+1)}return""}function y(w){if(!C.$j||!w||w.length<5)return!1;let k=w.charCodeAt(0);if(k!==v.CharCode.Backslash||(k=w.charCodeAt(1),k!==v.CharCode.Backslash))return!1;let P=2;const h=P;for(;P<w.length&&(k=w.charCodeAt(P),k!==v.CharCode.Backslash);P++);return!(h===P||(k=w.charCodeAt(P+1),isNaN(k)||k===v.CharCode.Backslash))}const c=/[\\/:\*\?"<>\|]/g,S=/[/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n(w,k=C.$j){const P=k?c:S;return!(!w||w.length===0||/^\s+$/.test(w)||(P.lastIndex=0,P.test(w))||k&&f.test(w)||w==="."||w===".."||k&&w[w.length-1]==="."||k&&w.length!==w.trim().length||w.length>255)}function o(w,k,P){const h=w===k;return!P||h?h:!w||!k?!1:(0,N.$Df)(w,k)}function s(w,k,P,h=I.sep){if(w===k)return!0;if(!w||!k||k.length>w.length)return!1;if(P){if(!(0,N.$Ef)(w,k))return!1;if(k.length===w.length)return!0;let M=k.length;return k.charAt(k.length-1)===h&&M--,w.charAt(M)===h}return k.charAt(k.length-1)!==h&&(k+=h),w.indexOf(k)===0}function l(w){return w>=v.CharCode.A&&w<=v.CharCode.Z||w>=v.CharCode.a&&w<=v.CharCode.z}function i(w,k){return C.$j&&w.endsWith(":")&&(w+=I.sep),(0,I.$hc)(w)||(w=(0,I.$ic)(k,w)),w=(0,I.$gc)(w),r(w)}function r(w){return C.$j?(w=(0,N.$lf)(w,I.sep),w.endsWith(":")&&(w+=I.sep)):(w=(0,N.$lf)(w,I.sep),w||(w=I.sep)),w}function t(w){const k=(0,I.$gc)(w);return C.$j?w.length>3?!1:g(k)&&(w.length===2||k.charCodeAt(2)===v.CharCode.Backslash):k===I.$fc.sep}function g(w,k=C.$j){return k?l(w.charCodeAt(0))&&w.charCodeAt(1)===v.CharCode.Colon:!1}function u(w,k=C.$j){return g(w,k)?w[0]:void 0}function p(w,k,P){return k.length>w.length?-1:w===k?0:(P&&(w=w.toLowerCase(),k=k.toLowerCase()),w.indexOf(k))}function m(w){const k=w.split(":");let P,h,b;for(const M of k){const O=Number(M);(0,A.$gg)(O)?h===void 0?h=O:b===void 0&&(b=O):P=P?[P,M].join(":"):M}if(!P)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:P,line:h!==void 0?h:void 0,column:b!==void 0?b:h!==void 0?1:void 0}}const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",E="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(w,k,P=8){let h="";for(let M=0;M<P;M++){let O;M===0&&C.$j&&!k&&(P===3||P===4)?O=E:O=d,h+=O.charAt(Math.floor(Math.random()*O.length))}let b;return k?b=`${k}-${h}`:b=h,w?(0,I.$ic)(w,b):b}}),define(Ne[148],Oe([1,0,27,28,138,12]),function(we,e,v,I,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pk=e.FuzzyScore=e.$Ek=e.$Dk=void 0,e.or=A,e.$Fk=$,e.$Gk=a,e.$Hk=c,e.$Ik=D,e.$Jk=w,e.$Kk=O,e.$Lk=F,e.$Mk=q,e.$Nk=B,e.$Ok=te,e.$Qk=he,e.$Rk=me,e.$Sk=pe,N=Ve(N);function A(...ke){return function(Pe,Te){for(let U=0,j=ke.length;U<j;U++){const G=ke[U](Pe,Te);if(G)return G}return null}}e.$Dk=T.bind(void 0,!1),e.$Ek=T.bind(void 0,!0);function T(ke,Pe,Te){if(!Te||Te.length<Pe.length)return null;let U;return ke?U=N.$Ef(Te,Pe):U=Te.indexOf(Pe)===0,U?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function $(ke,Pe){const Te=Pe.toLowerCase().indexOf(ke.toLowerCase());return Te===-1?null:[{start:Te,end:Te+ke.length}]}function a(ke,Pe){return R(ke.toLowerCase(),Pe.toLowerCase(),0,0)}function R(ke,Pe,Te,U){if(Te===ke.length)return[];if(U===Pe.length)return null;if(ke[Te]===Pe[U]){let j=null;return(j=R(ke,Pe,Te+1,U+1))?t({start:U,end:U+1},j):null}return R(ke,Pe,Te,U+1)}function y(ke){return v.CharCode.a<=ke&&ke<=v.CharCode.z}function c(ke){return v.CharCode.A<=ke&&ke<=v.CharCode.Z}function S(ke){return v.CharCode.Digit0<=ke&&ke<=v.CharCode.Digit9}function f(ke){return ke===v.CharCode.Space||ke===v.CharCode.Tab||ke===v.CharCode.LineFeed||ke===v.CharCode.CarriageReturn}const n=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ke=>n.add(ke.charCodeAt(0)));function o(ke){return f(ke)||n.has(ke)}function s(ke,Pe){return ke===Pe||o(ke)&&o(Pe)}const l=new Map;function i(ke){if(l.has(ke))return l.get(ke);let Pe;const Te=(0,C.$Bk)(ke);return Te&&(Pe=Te),l.set(ke,Pe),Pe}function r(ke){return y(ke)||c(ke)||S(ke)}function t(ke,Pe){return Pe.length===0?Pe=[ke]:ke.end===Pe[0].start?Pe[0].start=ke.start:Pe.unshift(ke),Pe}function g(ke,Pe){for(let Te=Pe;Te<ke.length;Te++){const U=ke.charCodeAt(Te);if(c(U)||S(U)||Te>0&&!r(ke.charCodeAt(Te-1)))return Te}return ke.length}function u(ke,Pe,Te,U){if(Te===ke.length)return[];if(U===Pe.length)return null;if(ke[Te]!==Pe[U].toLowerCase())return null;{let j=null,G=U+1;for(j=u(ke,Pe,Te+1,U+1);!j&&(G=g(Pe,G))<Pe.length;)j=u(ke,Pe,Te+1,G),G++;return j===null?null:t({start:U,end:U+1},j)}}function p(ke){let Pe=0,Te=0,U=0,j=0,G=0;for(let je=0;je<ke.length;je++)G=ke.charCodeAt(je),c(G)&&Pe++,y(G)&&Te++,r(G)&&U++,S(G)&&j++;const Q=Pe/ke.length,ne=Te/ke.length,de=U/ke.length,Ie=j/ke.length;return{upperPercent:Q,lowerPercent:ne,alphaPercent:de,numericPercent:Ie}}function m(ke){const{upperPercent:Pe,lowerPercent:Te}=ke;return Te===0&&Pe>.6}function d(ke){const{upperPercent:Pe,lowerPercent:Te,alphaPercent:U,numericPercent:j}=ke;return Te>.2&&Pe<.8&&U>.6&&j<.2}function E(ke){let Pe=0,Te=0,U=0,j=0;for(let G=0;G<ke.length;G++)U=ke.charCodeAt(G),c(U)&&Pe++,y(U)&&Te++,f(U)&&j++;return(Pe===0||Te===0)&&j===0?ke.length<=30:Pe<=5}function D(ke,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!E(ke))return null;Pe.length>60&&(Pe=Pe.substring(0,60));const Te=p(Pe);if(!d(Te)){if(!m(Te))return null;Pe=Pe.toLowerCase()}let U=null,j=0;for(ke=ke.toLowerCase();j<Pe.length&&(U=u(ke,Pe,0,j))===null;)j=g(Pe,j+1);return U}function w(ke,Pe,Te=!1){if(!Pe||Pe.length===0)return null;let U=null,j=0;for(ke=ke.toLowerCase(),Pe=Pe.toLowerCase();j<Pe.length&&(U=k(ke,Pe,0,j,Te),U===null);)j=P(Pe,j+1);return U}function k(ke,Pe,Te,U,j){let G=0;if(Te===ke.length)return[];if(U===Pe.length)return null;if(!s(ke.charCodeAt(Te),Pe.charCodeAt(U))){const de=i(ke.charCodeAt(Te));if(!de)return null;for(let Ie=0;Ie<de.length;Ie++)if(!s(de[Ie],Pe.charCodeAt(U+Ie)))return null;G+=de.length-1}let Q=null,ne=U+G+1;if(Q=k(ke,Pe,Te+1,ne,j),!j)for(;!Q&&(ne=P(Pe,ne))<Pe.length;)Q=k(ke,Pe,Te+1,ne,j),ne++;if(!Q)return null;if(ke.charCodeAt(Te)!==Pe.charCodeAt(U)){const de=i(ke.charCodeAt(Te));if(!de)return Q;for(let Ie=0;Ie<de.length;Ie++)if(de[Ie]!==Pe.charCodeAt(U+Ie))return Q}return t({start:U,end:U+G+1},Q)}function P(ke,Pe){for(let Te=Pe;Te<ke.length;Te++)if(o(ke.charCodeAt(Te))||Te>0&&o(ke.charCodeAt(Te-1)))return Te;return ke.length}const h=A(e.$Ek,D,$),b=A(e.$Ek,D,a),M=new I.$Cc(1e4);function O(ke,Pe,Te=!1){if(typeof ke!="string"||typeof Pe!="string")return null;let U=M.get(ke);U||(U=new RegExp(N.$mf(ke),"i"),M.set(ke,U));const j=U.exec(Pe);return j?[{start:j.index,end:j.index+j[0].length}]:Te?b(ke,Pe):h(ke,Pe)}function F(ke,Pe){const Te=he(ke,ke.toLowerCase(),0,Pe,Pe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Te?B(Te):null}function q(ke,Pe,Te,U,j,G){const Q=Math.min(13,ke.length);for(;Te<Q;Te++){const ne=he(ke,Pe,Te,U,j,G,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ne)return ne}return[0,G]}function B(ke){if(typeof ke>"u")return[];const Pe=[],Te=ke[1];for(let U=ke.length-1;U>1;U--){const j=ke[U]+Te,G=Pe[Pe.length-1];G&&G.end===j?G.end=j+1:Pe.push({start:j,end:j+1})}return Pe}const L=128;function Y(){const ke=[],Pe=[];for(let Te=0;Te<=L;Te++)Pe[Te]=0;for(let Te=0;Te<=L;Te++)ke.push(Pe.slice(0));return ke}function Z(ke){const Pe=[];for(let Te=0;Te<=ke;Te++)Pe[Te]=0;return Pe}const fe=Z(2*L),_=Z(2*L),ge=Y(),se=Y(),ae=Y(),$e=!1;function oe(ke,Pe,Te,U,j){function G(ne,de,Ie=" "){for(;ne.length<de;)ne=Ie+ne;return ne}let Q=` |   |${U.split("").map(ne=>G(ne,3)).join("|")}
`;for(let ne=0;ne<=Te;ne++)ne===0?Q+=" |":Q+=`${Pe[ne-1]}|`,Q+=ke[ne].slice(0,j+1).map(de=>G(de.toString(),3)).join("|")+`
`;return Q}function Ce(ke,Pe,Te,U){ke=ke.substr(Pe),Te=Te.substr(U),console.log(oe(se,ke,ke.length,Te,Te.length)),console.log(oe(ae,ke,ke.length,Te,Te.length)),console.log(oe(ge,ke,ke.length,Te,Te.length))}function Fe(ke,Pe){if(Pe<0||Pe>=ke.length)return!1;const Te=ke.codePointAt(Pe);switch(Te){case v.CharCode.Underline:case v.CharCode.Dash:case v.CharCode.Period:case v.CharCode.Space:case v.CharCode.Slash:case v.CharCode.Backslash:case v.CharCode.SingleQuote:case v.CharCode.DoubleQuote:case v.CharCode.Colon:case v.CharCode.DollarSign:case v.CharCode.LessThan:case v.CharCode.GreaterThan:case v.CharCode.OpenParen:case v.CharCode.CloseParen:case v.CharCode.OpenSquareBracket:case v.CharCode.CloseSquareBracket:case v.CharCode.OpenCurlyBrace:case v.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!N.$Wf(Te)}}function X(ke,Pe){if(Pe<0||Pe>=ke.length)return!1;switch(ke.charCodeAt(Pe)){case v.CharCode.Space:case v.CharCode.Tab:return!0;default:return!1}}function V(ke,Pe,Te){return Pe[ke]!==Te[ke]}function te(ke,Pe,Te,U,j,G,Q=!1){for(;Pe<Te&&j<G;)ke[Pe]===U[j]&&(Q&&(fe[Pe]=j),Pe+=1),j+=1;return Pe===Te}var ve;(function(ke){ke[ke.Diag=1]="Diag",ke[ke.Left=2]="Left",ke[ke.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var ce;(function(ke){ke.Default=[-100,0];function Pe(Te){return!Te||Te.length===2&&Te[0]===-100&&Te[1]===0}ke.isDefault=Pe})(ce||(e.FuzzyScore=ce={}));class be{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Pe,Te){this.firstMatchCanBeWeak=Pe,this.boostFullMatch=Te}}e.$Pk=be;function he(ke,Pe,Te,U,j,G,Q=be.default){const ne=ke.length>L?L:ke.length,de=U.length>L?L:U.length;if(Te>=ne||G>=de||ne-Te>de-G||!te(Pe,Te,ne,j,G,de,!0))return;J(ne,de,Te,G,Pe,j);let Ie=1,je=1,Ke=Te,_e=G;const tt=[!1];for(Ie=1,Ke=Te;Ke<ne;Ie++,Ke++){const ct=fe[Ke],st=_[Ke],lt=Ke+1<ne?_[Ke+1]:de;for(je=ct-G+1,_e=ct;_e<lt;je++,_e++){let gt=Number.MIN_SAFE_INTEGER,pt=!1;_e<=st&&(gt=x(ke,Pe,Ke,Te,U,j,_e,de,G,ge[Ie-1][je-1]===0,tt));let Be=0;gt!==Number.MAX_SAFE_INTEGER&&(pt=!0,Be=gt+se[Ie-1][je-1]);const Ue=_e>ct,ee=Ue?se[Ie][je-1]+(ge[Ie][je-1]>0?-5:0):0,K=_e>ct+1&&ge[Ie][je-1]>0,De=K?se[Ie][je-2]+(ge[Ie][je-2]>0?-5:0):0;if(K&&(!Ue||De>=ee)&&(!pt||De>=Be))se[Ie][je]=De,ae[Ie][je]=ve.LeftLeft,ge[Ie][je]=0;else if(Ue&&(!pt||ee>=Be))se[Ie][je]=ee,ae[Ie][je]=ve.Left,ge[Ie][je]=0;else if(pt)se[Ie][je]=Be,ae[Ie][je]=ve.Diag,ge[Ie][je]=ge[Ie-1][je-1]+1;else throw new Error("not possible")}}if($e&&Ce(ke,Te,U,G),!tt[0]&&!Q.firstMatchCanBeWeak)return;Ie--,je--;const nt=[se[Ie][je],G];let et=0,rt=0;for(;Ie>=1;){let ct=je;do{const st=ae[Ie][ct];if(st===ve.LeftLeft)ct=ct-2;else if(st===ve.Left)ct=ct-1;else break}while(ct>=1);et>1&&Pe[Te+Ie-1]===j[G+je-1]&&!V(ct+G-1,U,j)&&et+1>ge[Ie][ct]&&(ct=je),ct===je?et++:et=1,rt||(rt=ct),Ie--,je=ct-1,nt.push(je)}de-G===ne&&Q.boostFullMatch&&(nt[0]+=2);const ft=rt-ne;return nt[0]-=ft,nt}function J(ke,Pe,Te,U,j,G){let Q=ke-1,ne=Pe-1;for(;Q>=Te&&ne>=U;)j[Q]===G[ne]&&(_[Q]=ne,Q--),ne--}function x(ke,Pe,Te,U,j,G,Q,ne,de,Ie,je){if(Pe[Te]!==G[Q])return Number.MIN_SAFE_INTEGER;let Ke=1,_e=!1;return Q===Te-U?Ke=ke[Te]===j[Q]?7:5:V(Q,j,G)&&(Q===0||!V(Q-1,j,G))?(Ke=ke[Te]===j[Q]?7:5,_e=!0):Fe(G,Q)&&(Q===0||!Fe(G,Q-1))?Ke=5:(Fe(G,Q-1)||X(G,Q-1))&&(Ke=5,_e=!0),Ke>1&&Te===U&&(je[0]=!0),_e||(_e=V(Q,j,G)||Fe(G,Q-1)||X(G,Q-1)),Te===U?Q>de&&(Ke-=_e?3:5):Ie?Ke+=_e?2:0:Ke+=_e?0:1,Q+1===ne&&(Ke-=_e?3:5),Ke}function me(ke,Pe,Te,U,j,G,Q){return Ae(ke,Pe,Te,U,j,G,!0,Q)}function pe(ke,Pe,Te,U,j,G,Q){return Ae(ke,Pe,Te,U,j,G,!1,Q)}function Ae(ke,Pe,Te,U,j,G,Q,ne){let de=he(ke,Pe,Te,U,j,G,ne);if(de&&!Q)return de;if(ke.length>=3){const Ie=Math.min(7,ke.length-1);for(let je=Te+1;je<Ie;je++){const Ke=ze(ke,je);if(Ke){const _e=he(Ke,Ke.toLowerCase(),Te,U,j,G,ne);_e&&(_e[0]-=3,(!de||_e[0]>de[0])&&(de=_e))}}}return de}function ze(ke,Pe){if(Pe+1>=ke.length)return;const Te=ke[Pe],U=ke[Pe+1];if(Te!==U)return ke.slice(0,Pe)+U+Te+ke.slice(Pe+2)}}),define(Ne[98],Oe([1,0,148,12,34]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=$,e.$Uk=R,e.$Vk=c,e.$Wk=S,e.$Xk=n,e.$Yk=o;const N="$(",A=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${A.source}`,"g");function $(s){return s.replace(T,(l,i)=>i?l:`\\${l}`)}const a=new RegExp(`\\\\${A.source}`,"g");function R(s){return s.replace(a,l=>`\\${l}`)}const y=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function c(s){return s.indexOf(N)===-1?s:s.replace(y,(l,i,r,t)=>r?l:i||t||"")}function S(s){return s?s.replace(/\$\((.*?)\)/g,(l,i)=>` ${i} `).trim():""}const f=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function n(s){f.lastIndex=0;let l="";const i=[];let r=0;for(;;){const t=f.lastIndex,g=f.exec(s),u=s.substring(t,g?.index);if(u.length>0){l+=u;for(let p=0;p<u.length;p++)i.push(r)}if(!g)break;r+=g[0].length}return{text:l,iconOffsets:i}}function o(s,l,i=!1){const{text:r,iconOffsets:t}=l;if(!t||t.length===0)return(0,v.$Kk)(s,r,i);const g=(0,I.$kf)(r," "),u=r.length-g.length,p=(0,v.$Kk)(s,g,i);if(p)for(const m of p){const d=t[m.start+u]+u;m.start+=d,m.end+=d}return p}}),define(Ne[35],Oe([1,0,12]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v=Ve(v);var I;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(I||(I={})),function(C){const N="error",A="warning",T="warn",$="info",a="ignore";function R(c){return c?v.$Df(N,c)?C.Error:v.$Df(A,c)||v.$Df(T,c)?C.Warning:v.$Df($,c)?C.Info:C.Ignore:C.Ignore}C.fromValue=R;function y(c){switch(c){case C.Error:return N;case C.Warning:return A;case C.Info:return $;default:return a}}C.toString=y}(I||(I={})),e.default=I}),define(Ne[58],Oe([1,0,17,27,12]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=void 0;class N{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const n=f.charCodeAt(0),o=this.b.charCodeAt(this.c);return n-o}value(){return this.b[this.c]}}e.$Ei=N;class A{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===I.CharCode.Period)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,C.$xf)(f,this.b,0,f.length,this.c,this.d):(0,C.$zf)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Fi=A;class T{constructor(f=!0,n=!0){this.f=f,this.g=n}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let n=f.length-1;n>=0;n--,this.c--){const o=this.b.charCodeAt(n);if(!(o===I.CharCode.Slash||this.f&&o===I.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const n=this.b.charCodeAt(this.e);if(n===I.CharCode.Slash||this.f&&n===I.CharCode.Backslash)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,C.$xf)(f,this.b,0,f.length,this.d,this.e):(0,C.$zf)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Gi=T;var $;(function(S){S[S.Scheme=1]="Scheme",S[S.Authority=2]="Authority",S[S.Path=3]="Path",S[S.Query=4]="Query",S[S.Fragment=5]="Fragment"})($||($={}));class a{constructor(f,n){this.f=f,this.g=n,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push($.Scheme),this.c.authority&&this.d.push($.Authority),this.c.path&&(this.b=new T(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push($.Path)),this.g(f)||(this.c.query&&this.d.push($.Query),this.c.fragment&&this.d.push($.Fragment)),this.e=0,this}next(){return this.d[this.e]===$.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===$.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===$.Scheme)return(0,C.$yf)(f,this.c.scheme);if(this.d[this.e]===$.Authority)return(0,C.$yf)(f,this.c.authority);if(this.d[this.e]===$.Path)return this.b.cmp(f);if(this.d[this.e]===$.Query)return(0,C.$wf)(f,this.c.query);if(this.d[this.e]===$.Fragment)return(0,C.$wf)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===$.Scheme)return this.c.scheme;if(this.d[this.e]===$.Authority)return this.c.authority;if(this.d[this.e]===$.Path)return this.b.value();if(this.d[this.e]===$.Query)return this.c.query;if(this.d[this.e]===$.Fragment)return this.c.fragment;throw new Error}}e.$Hi=a;class R{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(S){S[S.Left=-1]="Left",S[S.Mid=0]="Mid",S[S.Right=1]="Right"})(y||(y={}));class c{static forUris(f=()=>!1,n=()=>!1){return new c(new a(f,n))}static forPaths(f=!1){return new c(new T(void 0,!f))}static forStrings(){return new c(new N)}static forConfigKeys(){return new c(new A)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,n){if(n){const o=n.slice(0);(0,v.$Vb)(o);for(const s of o)this.set(s,f)}else{const o=f.slice(0);(0,v.$Vb)(o);for(const s of o)this.set(s[0],s[1])}}set(f,n){const o=this.b.reset(f);let s;this.c||(this.c=new R,this.c.segment=o.value());const l=[];for(s=this.c;;){const r=o.cmp(s.segment);if(r>0)s.left||(s.left=new R,s.left.segment=o.value()),l.push([y.Left,s]),s=s.left;else if(r<0)s.right||(s.right=new R,s.right.segment=o.value()),l.push([y.Right,s]),s=s.right;else if(o.hasNext())o.next(),s.mid||(s.mid=new R,s.mid.segment=o.value()),l.push([y.Mid,s]),s=s.mid;else break}const i=s.value;s.value=n,s.key=f;for(let r=l.length-1;r>=0;r--){const t=l[r][1];t.updateHeight();const g=t.balanceFactor();if(g<-1||g>1){const u=l[r][0],p=l[r+1][0];if(u===y.Right&&p===y.Right)l[r][1]=t.rotateLeft();else if(u===y.Left&&p===y.Left)l[r][1]=t.rotateRight();else if(u===y.Right&&p===y.Left)t.right=l[r+1][1]=l[r+1][1].rotateRight(),l[r][1]=t.rotateLeft();else if(u===y.Left&&p===y.Right)t.left=l[r+1][1]=l[r+1][1].rotateLeft(),l[r][1]=t.rotateRight();else throw new Error;if(r>0)switch(l[r-1][0]){case y.Left:l[r-1][1].left=l[r][1];break;case y.Right:l[r-1][1].right=l[r][1];break;case y.Mid:l[r-1][1].mid=l[r][1];break}else this.c=l[0][1]}}return i}get(f){return this.d(f)?.value}d(f){const n=this.b.reset(f);let o=this.c;for(;o;){const s=n.cmp(o.segment);if(s>0)o=o.left;else if(s<0)o=o.right;else if(n.hasNext())n.next(),o=o.mid;else break}return o}has(f){const n=this.d(f);return!(n?.value===void 0&&n?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,n){const o=this.b.reset(f),s=[];let l=this.c;for(;l;){const i=o.cmp(l.segment);if(i>0)s.push([y.Left,l]),l=l.left;else if(i<0)s.push([y.Right,l]),l=l.right;else if(o.hasNext())o.next(),s.push([y.Mid,l]),l=l.mid;else break}if(l){if(n?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const i=this.f(l.right);if(i.key){const{key:r,value:t,segment:g}=i;this.e(i.key,!1),l.key=r,l.value=t,l.segment=g}}else{const i=l.left??l.right;if(s.length>0){const[r,t]=s[s.length-1];switch(r){case y.Left:t.left=i;break;case y.Mid:t.mid=i;break;case y.Right:t.right=i;break}}else this.c=i}for(let i=s.length-1;i>=0;i--){const r=s[i][1];r.updateHeight();const t=r.balanceFactor();if(t>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),s[i][1]=r.rotateLeft()):t<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),s[i][1]=r.rotateRight()),i>0)switch(s[i-1][0]){case y.Left:s[i-1][1].left=s[i][1];break;case y.Right:s[i-1][1].right=s[i][1];break;case y.Mid:s[i-1][1].mid=s[i][1];break}else this.c=s[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const n=this.b.reset(f);let o=this.c,s;for(;o;){const l=n.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(n.hasNext())n.next(),s=o.value||s,o=o.mid;else break}return o&&o.value||s}findSuperstr(f){return this.g(f,!1)}g(f,n){const o=this.b.reset(f);let s=this.c;for(;s;){const l=o.cmp(s.segment);if(l>0)s=s.left;else if(l<0)s=s.right;else if(o.hasNext())o.next(),s=s.mid;else return s.mid?this.h(s.mid):n?s.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[n,o]of this)f(o,n)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const n=[];return this.j(f,n),n[Symbol.iterator]()}j(f,n){f&&(f.left&&this.j(f.left,n),f.value&&n.push([f.key,f.value]),f.mid&&this.j(f.mid,n),f.right&&this.j(f.right,n))}_isBalanced(){const f=n=>{if(!n)return!0;const o=n.balanceFactor();return o<-1||o>1?!1:f(n.left)&&f(n.right)};return f(this.c)}}e.$Ii=c}),define(Ne[40],Oe([1,0,22,2,36]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=N,e.$$h=A,e.$_h=$;function N(a){return JSON.stringify(a,T)}function A(a){let R=JSON.parse(a);return R=$(R),R}function T(a,R){return R instanceof RegExp?{$mid:C.MarshalledId.Regexp,source:R.source,flags:R.flags}:R}function $(a,R=0){if(!a||R>200)return a;if(typeof a=="object"){switch(a.$mid){case C.MarshalledId.Uri:return I.URI.revive(a);case C.MarshalledId.Regexp:return new RegExp(a.source,a.flags);case C.MarshalledId.Date:return new Date(a.source)}if(a instanceof v.$Le||a instanceof Uint8Array)return a;if(Array.isArray(a))for(let y=0;y<a.length;++y)a[y]=$(a[y],R+1);else for(const y in a)Object.hasOwnProperty.call(a,y)&&(a[y]=$(a[y],R+1))}return a}}),define(Ne[15],Oe([1,0,13,20,12,2,19]),function(we,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Pg=e.$Og=e.$Ng=e.Schemas=void 0,e.$Lg=$,e.$Mg=a,e.$Qg=y,v=Ve(v),I=Ve(I),A=Ve(A);var T;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatCodeBlock="vscode-chat-code-block",f.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",f.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm",f.commentsInput="comment",f.codeSetting="code-setting"})(T||(e.Schemas=T={}));function $(f,n){return N.URI.isUri(f)?(0,C.$Df)(f.scheme,n):(0,C.$Ef)(f,n+":")}function a(f,...n){return n.some(o=>$(f,o))}e.$Ng="vscode-tkn",e.$Og="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(n){this.d=n}setDelegate(n){this.e=n}setServerRootPath(n,o){this.f=y(n,o)}getServerRootPath(){return this.f}get g(){return A.$fc.join(this.f,T.vscodeRemoteResource)}set(n,o,s){this.a[n]=o,this.b[n]=s}setConnectionToken(n,o){this.c[n]=o}getPreferredWebSchema(){return this.d}rewrite(n){if(this.e)try{return this.e(n)}catch(t){return v.$Y(t),n}const o=n.authority;let s=this.a[o];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const l=this.b[o],i=this.c[o];let r=`path=${encodeURIComponent(n.path)}`;return typeof i=="string"&&(r+=`&${e.$Og}=${encodeURIComponent(i)}`),N.URI.from({scheme:I.$p?this.d:T.vscodeRemoteResource,authority:`${s}:${l}`,path:this.g,query:r})}}e.$Pg=new R;function y(f,n){return A.$fc.join(n??"/",`${f.quality??"oss"}-${f.commit??"dev"}`)}e.$Rg="vs/../../extensions",e.$Sg="vs/../../node_modules",e.$Tg="vs/../../node_modules.asar",e.$Ug="vs/../../node_modules.asar.unpacked",e.$Vg="vscode-app";class c{static{this.a=e.$Vg}asBrowserUri(n){const o=this.b(n,we);return this.uriToBrowserUri(o)}uriToBrowserUri(n){return n.scheme===T.vscodeRemote?e.$Pg.rewrite(n):n.scheme===T.file&&(I.$n||I.$r===`${T.vscodeFileResource}://${c.a}`)?n.with({scheme:T.vscodeFileResource,authority:n.authority||c.a,query:null,fragment:null}):n}asFileUri(n){const o=this.b(n,we);return this.uriToFileUri(o)}uriToFileUri(n){return n.scheme===T.vscodeFileResource?n.with({scheme:T.file,authority:n.authority!==c.a?n.authority:null,query:null,fragment:null}):n}b(n,o){return N.URI.isUri(n)?n:N.URI.parse(o.toUrl(n))}}e.$Wg=new c;var S;(function(f){const n=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(n.get("3"));const o="vscode-coi";function s(i){let r;typeof i=="string"?r=new URL(i).searchParams:i instanceof URL?r=i.searchParams:N.URI.isUri(i)&&(r=new URL(i.toString(!0)).searchParams);const t=r?.get(o);if(t)return n.get(t)}f.getHeadersFromQuery=s;function l(i,r,t){if(!globalThis.crossOriginIsolated)return;const g=r&&t?"3":t?"2":"1";i instanceof URLSearchParams?i.set(o,g):i[o]=g}f.addSearchParam=l})(S||(e.COI=S={}))}),define(Ne[23],Oe([1,0,27,51,15,19,20,12,2]),function(we,e,v,I,C,N,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=void 0,e.$4g=a,e.$mh=y,e.$nh=S,I=Ve(I),N=Ve(N);function a(f){return(0,$.$vc)(f,!0)}class R{constructor(n){this.a=n}compare(n,o,s=!1){return n===o?0:(0,T.$wf)(this.getComparisonKey(n,s),this.getComparisonKey(o,s))}isEqual(n,o,s=!1){return n===o?!0:!n||!o?!1:this.getComparisonKey(n,s)===this.getComparisonKey(o,s)}getComparisonKey(n,o=!1){return n.with({path:this.a(n)?n.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(n){return this.a(n)}isEqualOrParent(n,o,s=!1){if(n.scheme===o.scheme){if(n.scheme===C.Schemas.file)return I.$Bg(a(n),a(o),this.a(n))&&n.query===o.query&&(s||n.fragment===o.fragment);if((0,e.$ih)(n.authority,o.authority))return I.$Bg(n.path,o.path,this.a(n),"/")&&n.query===o.query&&(s||n.fragment===o.fragment)}return!1}joinPath(n,...o){return $.URI.joinPath(n,...o)}basenameOrAuthority(n){return(0,e.$ah)(n)||n.authority}basename(n){return N.$fc.basename(n.path)}extname(n){return N.$fc.extname(n.path)}dirname(n){if(n.path.length===0)return n;let o;return n.scheme===C.Schemas.file?o=$.URI.file(N.$lc(a(n))).path:(o=N.$fc.dirname(n.path),n.authority&&o.length&&o.charCodeAt(0)!==v.CharCode.Slash&&(console.error(`dirname("${n.toString})) resulted in a relative path`),o="/")),n.with({path:o})}normalizePath(n){if(!n.path.length)return n;let o;return n.scheme===C.Schemas.file?o=$.URI.file(N.$gc(a(n))).path:o=N.$fc.normalize(n.path),n.with({path:o})}relativePath(n,o){if(n.scheme!==o.scheme||!(0,e.$ih)(n.authority,o.authority))return;if(n.scheme===C.Schemas.file){const i=N.$kc(a(n),a(o));return A.$j?I.$vg(i):i}let s=n.path||"/";const l=o.path||"/";if(this.a(n)){let i=0;for(const r=Math.min(s.length,l.length);i<r&&!(s.charCodeAt(i)!==l.charCodeAt(i)&&s.charAt(i).toLowerCase()!==l.charAt(i).toLowerCase());i++);s=l.substr(0,i)+s.substr(i)}return N.$fc.relative(s,l)}resolvePath(n,o){if(n.scheme===C.Schemas.file){const s=$.URI.file(N.$jc(a(n),o));return n.with({authority:s.authority,path:s.path})}return o=I.$wg(o),n.with({path:N.$fc.resolve(n.path,o)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,o){return n===o||n!==void 0&&o!==void 0&&(0,T.$Df)(n,o)}hasTrailingPathSeparator(n,o=N.sep){if(n.scheme===C.Schemas.file){const s=a(n);return s.length>I.$xg(s).length&&s[s.length-1]===o}else{const s=n.path;return s.length>1&&s.charCodeAt(s.length-1)===v.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,o=N.sep){return(0,e.$jh)(n,o)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,o=N.sep){let s=!1;if(n.scheme===C.Schemas.file){const l=a(n);s=l!==void 0&&l.length===I.$xg(l).length&&l[l.length-1]===o}else{o="/";const l=n.path;s=l.length===1&&l.charCodeAt(l.length-1)===v.CharCode.Slash}return!s&&!(0,e.$jh)(n,o)?n.with({path:n.path+"/"}):n}}e.$5g=R,e.$6g=new R(()=>!1),e.$7g=new R(f=>f.scheme===C.Schemas.file?!A.$l:!0),e.$8g=new R(f=>!0),e.$9g=e.$6g.isEqual.bind(e.$6g),e.$0g=e.$6g.isEqualOrParent.bind(e.$6g),e.$$g=e.$6g.getComparisonKey.bind(e.$6g),e.$_g=e.$6g.basenameOrAuthority.bind(e.$6g),e.$ah=e.$6g.basename.bind(e.$6g),e.$bh=e.$6g.extname.bind(e.$6g),e.$ch=e.$6g.dirname.bind(e.$6g),e.$dh=e.$6g.joinPath.bind(e.$6g),e.$eh=e.$6g.normalizePath.bind(e.$6g),e.$fh=e.$6g.relativePath.bind(e.$6g),e.$gh=e.$6g.resolvePath.bind(e.$6g),e.$hh=e.$6g.isAbsolutePath.bind(e.$6g),e.$ih=e.$6g.isEqualAuthority.bind(e.$6g),e.$jh=e.$6g.hasTrailingPathSeparator.bind(e.$6g),e.$kh=e.$6g.removeTrailingPathSeparator.bind(e.$6g),e.$lh=e.$6g.addTrailingPathSeparator.bind(e.$6g);function y(f,n){const o=[];for(let s=0;s<f.length;s++){const l=n(f[s]);f.some((i,r)=>r===s?!1:(0,e.$0g)(l,n(i)))||o.push(f[s])}return o}var c;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function n(o){const s=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(r=>{const[t,g]=r.split(":");t&&g&&s.set(t,g)});const i=o.path.substring(0,o.path.indexOf(";"));return i&&s.set(f.META_DATA_MIME,i),s}f.parseMetaData=n})(c||(e.DataUri=c={}));function S(f,n,o){if(n){let s=f.path;return s&&s[0]!==N.$fc.sep&&(s=N.$fc.sep+s),f.with({scheme:o,authority:n,path:s})}return f.with({scheme:o})}}),define(Ne[10],Oe([1,0,21,13,6,4,23,20,147,48]),function(we,e,v,I,C,N,A,T,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$4h=e.$3h=e.$2h=e.$1h=e.Promises=e.$Zh=e.$Yh=e.$Xh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=void 0,e.$oh=R,e.$ph=y,e.$qh=c,e.$rh=S,e.$sh=f,e.$th=n,e.$uh=o,e.$vh=s,e.$Dh=E,e.$Eh=D,e.$Fh=w,e.$Gh=k,e.$Hh=P,e.$Wh=ge,e.$5h=ce;function R(he){return!!he&&typeof he.then=="function"}function y(he){const J=new v.$ue,x=he(J.token),me=new Promise((pe,Ae)=>{const ze=J.token.onCancellationRequested(()=>{ze.dispose(),Ae(new I.$4)});Promise.resolve(x).then(ke=>{ze.dispose(),J.dispose(),pe(ke)},ke=>{ze.dispose(),J.dispose(),Ae(ke)})});return new class{cancel(){J.cancel(),J.dispose()}then(pe,Ae){return me.then(pe,Ae)}catch(pe){return this.then(void 0,pe)}finally(pe){return me.finally(pe)}}}function c(he,J,x){return new Promise((me,pe)=>{const Ae=J.onCancellationRequested(()=>{Ae.dispose(),me(x)});he.then(me,pe).finally(()=>Ae.dispose())})}function S(he,J){return new Promise((x,me)=>{const pe=J.onCancellationRequested(()=>{pe.dispose(),me(new I.$4)});he.then(x,me).finally(()=>pe.dispose())})}async function f(he){let J=-1;const x=he.map((me,pe)=>me.then(Ae=>(J=pe,Ae)));try{return await Promise.race(x)}finally{he.forEach((me,pe)=>{pe!==J&&me.cancel()})}}function n(he,J,x){let me;const pe=setTimeout(()=>{me?.(void 0),x?.()},J);return Promise.race([he.finally(()=>clearTimeout(pe)),new Promise(Ae=>me=Ae)])}function o(he){return new Promise((J,x)=>{const me=he();R(me)?me.then(J,x):J(me)})}function s(){let he,J;return{promise:new Promise((me,pe)=>{he=me,J=pe}),resolve:he,reject:J}}class l{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(J){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=J,!this.b){const x=()=>{if(this.b=null,this.f)return;const me=this.queue(this.d);return this.d=null,me};this.b=new Promise(me=>{this.a.then(x,x).then(me)})}return new Promise((x,me)=>{this.b.then(x,me)})}return this.a=J(),new Promise((x,me)=>{this.a.then(pe=>{this.a=null,x(pe)},pe=>{this.a=null,me(pe)})})}dispose(){this.f=!0}}e.$wh=l;class i{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.$xh=i;class r{constructor(){this.a=new Map}queue(J,x){const pe=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.a.get(J)===pe&&this.a.delete(J)});return this.a.set(J,pe),pe}}e.$yh=r;const t=(he,J)=>{let x=!0;const me=setTimeout(()=>{x=!1,J()},he);return{isTriggered:()=>x,dispose:()=>{clearTimeout(me),x=!1}}},g=he=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,he())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class u{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,x=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((pe,Ae)=>{this.d=pe,this.f=Ae}).then(()=>{if(this.b=null,this.d=null,this.g){const pe=this.g;return this.g=null,pe()}}));const me=()=>{this.a=null,this.d?.(null)};return this.a=x===$.$ee?g(me):t(x,me),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new I.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$zh=u;class p{constructor(J){this.a=new u(J),this.b=new l}trigger(J,x){return this.a.trigger(()=>this.b.queue(J),x)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ah=p;class m{constructor(){this.a=!1,this.b=new Promise((J,x)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Bh=m;class d extends m{constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.$Ch=d;function E(he,J){return J?new Promise((x,me)=>{const pe=setTimeout(()=>{Ae.dispose(),x()},he),Ae=J.onCancellationRequested(()=>{clearTimeout(pe),Ae.dispose(),me(new I.$4)})}):y(x=>E(he,x))}function D(he,J=0,x){const me=setTimeout(()=>{he(),x&&pe.dispose()},J),pe=(0,N.$Rc)(()=>{clearTimeout(me),x?.deleteAndLeak(pe)});return x?.add(pe),pe}function w(he){const J=[];let x=0;const me=he.length;function pe(){return x<me?he[x++]():null}function Ae(ze){ze!=null&&J.push(ze);const ke=pe();return ke?ke.then(Ae):Promise.resolve(J)}return Promise.resolve(null).then(Ae)}function k(he,J=me=>!!me,x=null){let me=0;const pe=he.length,Ae=()=>{if(me>=pe)return Promise.resolve(x);const ze=he[me++];return Promise.resolve(ze()).then(Pe=>J(Pe)?Promise.resolve(Pe):Ae())};return Ae()}function P(he,J=me=>!!me,x=null){if(he.length===0)return Promise.resolve(x);let me=he.length;const pe=()=>{me=-1;for(const Ae of he)Ae.cancel?.()};return new Promise((Ae,ze)=>{for(const ke of he)ke.then(Pe=>{--me>=0&&J(Pe)?(pe(),Ae(Pe)):me===0&&Ae(x)}).catch(Pe=>{--me>=0&&(pe(),ze(Pe))})})}class h{constructor(J){this.a=0,this.b=!1,this.f=J,this.g=[],this.d=0,this.h=new C.$je}whenIdle(){return this.size>0?C.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(J){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((x,me)=>{this.g.push({factory:J,c:x,e:me}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const J=this.g.shift();this.d++;const x=J.factory();x.then(J.c,J.e),x.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ih=h;class b extends h{constructor(){super(1)}}e.$Jh=b;class M{constructor(){this.a=new se,this.b=0}queue(J){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,J())):this.a.run(this.b++,J())}}e.$Kh=M;class O{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const J=new oe;return this.b.add(J),J.p}g(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueSize(J,x=A.$6g){const me=x.getComparisonKey(J);return this.a.get(me)?.size??0}queueFor(J,x,me=A.$6g){const pe=me.getComparisonKey(J);let Ae=this.a.get(pe);if(!Ae){Ae=new b;const ze=this.f++,ke=C.Event.once(Ae.onDrained)(()=>{Ae?.dispose(),this.a.delete(pe),this.h(),this.d?.deleteAndDispose(ze),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new N.$3c),this.d.set(ze,ke),this.a.set(pe,Ae)}return Ae.queue(x)}h(){this.g()&&this.j()}j(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Lh=O;class F{constructor(J,x){this.b=!1,this.a=-1,typeof J=="function"&&typeof x=="number"&&this.setIfNotSet(J,x)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,x){if(this.b)throw new I.$bb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},x)}setIfNotSet(J,x){if(this.b)throw new I.$bb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},x))}}e.$Mh=F;class q{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(J,x,me=globalThis){if(this.f)throw new I.$bb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const pe=me.setInterval(()=>{J()},x);this.d=(0,N.$Rc)(()=>{me.clearInterval(pe),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Nh=q;class B{constructor(J,x){this.b=-1,this.a=J,this.d=x,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Oh=B;class L{constructor(J,x){x%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.a=J,this.b=x,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Ph=L;class Y extends B{constructor(J,x){super(J,x),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.$Qh=Y;class Z extends N.$Tc{constructor(J,x){super(),this.g=J,this.h=x,this.a=[],this.b=this.B(new N.$Uc),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const x of J)this.a.push(x);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new B(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Rh=Z,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Th=(he,J)=>{(0,T.$C)(()=>{if(x)return;const me=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let x=!1;return{dispose(){x||(x=!0)}}}:e.$Th=(he,J,x)=>{const me=he.requestIdleCallback(J,typeof x=="number"?{timeout:x}:void 0);let pe=!1;return{dispose(){pe||(pe=!0,he.cancelIdleCallback(me))}}},e.$Sh=he=>(0,e.$Th)(globalThis,he)}();class fe{constructor(J,x){this.g=!1,this.d=()=>{try{this.j=x()}catch(me){this.l=me}finally{this.g=!0}},this.f=(0,e.$Th)(J,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Uh=fe;class _ extends fe{constructor(J){super(globalThis,J)}}e.$Vh=_;async function ge(he,J,x){let me;for(let pe=0;pe<x;pe++)try{return await he()}catch(Ae){me=Ae,await E(J)}throw me}class se{isRunning(J){return typeof J=="number"?this.a?.taskId===J:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(J,x,me){return this.a={taskId:J,cancel:()=>me?.(),promise:x},x.then(()=>this.d(J),()=>this.d(J)),x}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this.b)this.b.run=J;else{const{promise:x,resolve:me,reject:pe}=s();this.b={run:J,promise:x,promiseResolve:me,promiseReject:pe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Xh=se;class ae{constructor(J,x=()=>Date.now()){this.d=J,this.f=x,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.$Yh=ae;var $e;(function(he){he[he.Resolved=0]="Resolved",he[he.Rejected=1]="Rejected"})($e||($e={}));class oe{get isRejected(){return this.d?.outcome===$e.Rejected}get isResolved(){return this.d?.outcome===$e.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===$e.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((J,x)=>{this.a=J,this.b=x})}complete(J){return new Promise(x=>{this.a(J),this.d={outcome:$e.Resolved,value:J},x()})}error(J){return new Promise(x=>{this.b(J),this.d={outcome:$e.Rejected,value:J},x()})}cancel(){return this.error(new I.$4)}}e.$Zh=oe;var Ce;(function(he){async function J(me){let pe;const Ae=await Promise.all(me.map(ze=>ze.then(ke=>ke,ke=>{pe||(pe=ke)})));if(typeof pe<"u")throw pe;return Ae}he.settled=J;function x(me){return new Promise(async(pe,Ae)=>{try{await me(pe,Ae)}catch(ze){Ae(ze)}})}he.withAsyncBody=x})(Ce||(e.Promises=Ce={}));class Fe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(J){this.a=void 0,this.b=void 0,this.d=!1,this.promise=J.then(x=>(this.a=x,this.d=!0,x),x=>{throw this.b=x,this.d=!0,x})}requireValue(){if(!this.d)throw new I.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$1h=Fe;class X{constructor(J){this.b=J,this.a=new a.$T(()=>new Fe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$2h=X;var V;(function(he){he[he.Initial=0]="Initial",he[he.DoneOK=1]="DoneOK",he[he.DoneError=2]="DoneError"})(V||(V={}));class te{static fromArray(J){return new te(x=>{x.emitMany(J)})}static fromPromise(J){return new te(async x=>{x.emitMany(await J)})}static fromPromises(J){return new te(async x=>{await Promise.all(J.map(async me=>x.emitOne(await me)))})}static merge(J){return new te(async x=>{await Promise.all(J.map(async me=>{for await(const pe of me)x.emitOne(pe)}))})}static{this.EMPTY=te.fromArray([])}constructor(J,x){this.a=V.Initial,this.b=[],this.d=null,this.f=x,this.g=new C.$je,queueMicrotask(async()=>{const me={emitOne:pe=>this.h(pe),emitMany:pe=>this.j(pe),reject:pe=>this.l(pe)};try{await Promise.resolve(J(me)),this.k()}catch(pe){this.l(pe)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===V.DoneError)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===V.DoneOK)return{done:!0,value:void 0};await C.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(J,x){return new te(async me=>{for await(const pe of J)me.emitOne(x(pe))})}map(J){return te.map(this,J)}static filter(J,x){return new te(async me=>{for await(const pe of J)x(pe)&&me.emitOne(pe)})}filter(J){return te.filter(this,J)}static coalesce(J){return te.filter(J,x=>!!x)}coalesce(){return te.coalesce(this)}static async toPromise(J){const x=[];for await(const me of J)x.push(me);return x}toPromise(){return te.toPromise(this)}h(J){this.a===V.Initial&&(this.b.push(J),this.g.fire())}j(J){this.a===V.Initial&&(this.b=this.b.concat(J),this.g.fire())}k(){this.a===V.Initial&&(this.a=V.DoneOK,this.g.fire())}l(J){this.a===V.Initial&&(this.a=V.DoneError,this.d=J,this.g.fire())}}e.$3h=te;class ve extends te{constructor(J,x){super(x),this.m=J}cancel(){this.m.cancel()}}e.$4h=ve;function ce(he){const J=new v.$ue,x=he(J.token);return new ve(J,async me=>{const pe=J.token.onCancellationRequested(()=>{pe.dispose(),J.dispose(),me.reject(new I.$4)});try{for await(const Ae of x){if(J.token.isCancellationRequested)return;me.emitOne(Ae)}pe.dispose(),J.dispose()}catch(Ae){pe.dispose(),J.dispose(),me.reject(Ae)}})}class be{constructor(J){this.a=new oe,this.b=new te(pe=>{if(x){pe.reject(x);return}return me&&pe.emitMany(me),this.d=Ae=>pe.reject(Ae),this.f=Ae=>pe.emitOne(Ae),this.a.p},J);let x,me;this.f=pe=>{me||(me=[]),me.push(pe)},this.d=pe=>{x||(x=pe)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(J){this.d(J),this.a.complete()}emitOne(J){this.f(J)}}e.$6h=be}),define(Ne[41],Oe([1,0,17,10,27,51,28,19,20,12]),function(we,e,v,I,C,N,A,T,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$sk=void 0,e.$rk=R,e.$uk=n,e.$vk=M,e.$wk=O,e.$xk=F,e.$yk=q,e.$zk=B,e.$Ak=fe;function R(){return Object.create(null)}e.$sk="**",e.$tk="/";const y="[/\\\\]",c="[^/\\\\]",S=/\//g;function f(_,ge){switch(_){case 0:return"";case 1:return`${c}*?`;default:return`(?:${y}|${c}+${y}${ge?`|${y}${c}+`:""})*?`}}function n(_,ge){if(!_)return[];const se=[];let ae=!1,$e=!1,oe="";for(const Ce of _){switch(Ce){case ge:if(!ae&&!$e){se.push(oe),oe="";continue}break;case"{":ae=!0;break;case"}":ae=!1;break;case"[":$e=!0;break;case"]":$e=!1;break}oe+=Ce}return oe&&se.push(oe),se}function o(_){if(!_)return"";let ge="";const se=n(_,e.$tk);if(se.every(ae=>ae===e.$sk))ge=".*";else{let ae=!1;se.forEach(($e,oe)=>{if($e===e.$sk){if(ae)return;ge+=f(2,oe===se.length-1)}else{let Ce=!1,Fe="",X=!1,V="";for(const te of $e){if(te!=="}"&&Ce){Fe+=te;continue}if(X&&(te!=="]"||!V)){let ve;te==="-"?ve=te:(te==="^"||te==="!")&&!V?ve="^":te===e.$tk?ve="":ve=(0,a.$ff)(te),V+=ve;continue}switch(te){case"{":Ce=!0;continue;case"[":X=!0;continue;case"}":{const ce=`(?:${n(Fe,",").map(be=>o(be)).join("|")})`;ge+=ce,Ce=!1,Fe="";break}case"]":{ge+="["+V+"]",X=!1,V="";break}case"?":ge+=c;continue;case"*":ge+=f(1);continue;default:ge+=(0,a.$ff)(te)}}oe<se.length-1&&(se[oe+1]!==e.$sk||oe+2<se.length)&&(ge+=y)}ae=$e===e.$sk})}return ge}const s=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,r=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,u=new A.$Cc(1e4),p=function(){return!1},m=function(){return null};function d(_,ge){if(!_)return m;let se;typeof _!="string"?se=_.pattern:se=_,se=se.trim();const ae=`${se}_${!!ge.trimForExclusions}`;let $e=u.get(ae);if($e)return E($e,_);let oe;return s.test(se)?$e=w(se.substr(4),se):(oe=l.exec(D(se,ge)))?$e=k(oe[1],se):(ge.trimForExclusions?r:i).test(se)?$e=P(se,ge):(oe=t.exec(D(se,ge)))?$e=h(oe[1].substr(1),se,!0):(oe=g.exec(D(se,ge)))?$e=h(oe[1],se,!1):$e=b(se),u.set(ae,$e),E($e,_)}function E(_,ge){if(typeof ge=="string")return _;const se=function(ae,$e){return(0,N.$Bg)(ae,ge.base,!$.$l)?_((0,a.$kf)(ae.substr(ge.base.length),T.sep),$e):null};return se.allBasenames=_.allBasenames,se.allPaths=_.allPaths,se.basenames=_.basenames,se.patterns=_.patterns,se}function D(_,ge){return ge.trimForExclusions&&_.endsWith("/**")?_.substr(0,_.length-2):_}function w(_,ge){return function(se,ae){return typeof se=="string"&&se.endsWith(_)?ge:null}}function k(_,ge){const se=`/${_}`,ae=`\\${_}`,$e=function(Ce,Fe){return typeof Ce!="string"?null:Fe?Fe===_?ge:null:Ce===_||Ce.endsWith(se)||Ce.endsWith(ae)?ge:null},oe=[_];return $e.basenames=oe,$e.patterns=[ge],$e.allBasenames=oe,$e}function P(_,ge){const se=Z(_.slice(1,-1).split(",").map(Fe=>d(Fe,ge)).filter(Fe=>Fe!==m),_),ae=se.length;if(!ae)return m;if(ae===1)return se[0];const $e=function(Fe,X){for(let V=0,te=se.length;V<te;V++)if(se[V](Fe,X))return _;return null},oe=se.find(Fe=>!!Fe.allBasenames);oe&&($e.allBasenames=oe.allBasenames);const Ce=se.reduce((Fe,X)=>X.allPaths?Fe.concat(X.allPaths):Fe,[]);return Ce.length&&($e.allPaths=Ce),$e}function h(_,ge,se){const ae=T.sep===T.$fc.sep,$e=ae?_:_.replace(S,T.sep),oe=T.sep+$e,Ce=T.$fc.sep+_;let Fe;return se?Fe=function(X,V){return typeof X=="string"&&(X===$e||X.endsWith(oe)||!ae&&(X===_||X.endsWith(Ce)))?ge:null}:Fe=function(X,V){return typeof X=="string"&&(X===$e||!ae&&X===_)?ge:null},Fe.allPaths=[(se?"*/":"./")+_],Fe}function b(_){try{const ge=new RegExp(`^${o(_)}$`);return function(se){return ge.lastIndex=0,typeof se=="string"&&ge.test(se)?_:null}}catch{return m}}function M(_,ge,se){return!_||typeof ge!="string"?!1:O(_)(ge,void 0,se)}function O(_,ge={}){if(!_)return p;if(typeof _=="string"||F(_)){const se=d(_,ge);if(se===m)return p;const ae=function($e,oe){return!!se($e,oe)};return se.allBasenames&&(ae.allBasenames=se.allBasenames),se.allPaths&&(ae.allPaths=se.allPaths),ae}return L(_,ge)}function F(_){const ge=_;return ge?typeof ge.base=="string"&&typeof ge.pattern=="string":!1}function q(_){return _.allBasenames||[]}function B(_){return _.allPaths||[]}function L(_,ge){const se=Z(Object.getOwnPropertyNames(_).map(Fe=>Y(Fe,_[Fe],ge)).filter(Fe=>Fe!==m)),ae=se.length;if(!ae)return m;if(!se.some(Fe=>!!Fe.requiresSiblings)){if(ae===1)return se[0];const Fe=function(te,ve){let ce;for(let be=0,he=se.length;be<he;be++){const J=se[be](te,ve);if(typeof J=="string")return J;(0,I.$oh)(J)&&(ce||(ce=[]),ce.push(J))}return ce?(async()=>{for(const be of ce){const he=await be;if(typeof he=="string")return he}return null})():null},X=se.find(te=>!!te.allBasenames);X&&(Fe.allBasenames=X.allBasenames);const V=se.reduce((te,ve)=>ve.allPaths?te.concat(ve.allPaths):te,[]);return V.length&&(Fe.allPaths=V),Fe}const $e=function(Fe,X,V){let te,ve;for(let ce=0,be=se.length;ce<be;ce++){const he=se[ce];he.requiresSiblings&&V&&(X||(X=(0,T.$mc)(Fe)),te||(te=X.substr(0,X.length-(0,T.$nc)(Fe).length)));const J=he(Fe,X,te,V);if(typeof J=="string")return J;(0,I.$oh)(J)&&(ve||(ve=[]),ve.push(J))}return ve?(async()=>{for(const ce of ve){const be=await ce;if(typeof be=="string")return be}return null})():null},oe=se.find(Fe=>!!Fe.allBasenames);oe&&($e.allBasenames=oe.allBasenames);const Ce=se.reduce((Fe,X)=>X.allPaths?Fe.concat(X.allPaths):Fe,[]);return Ce.length&&($e.allPaths=Ce),$e}function Y(_,ge,se){if(ge===!1)return m;const ae=d(_,se);if(ae===m)return m;if(typeof ge=="boolean")return ae;if(ge){const $e=ge.when;if(typeof $e=="string"){const oe=(Ce,Fe,X,V)=>{if(!V||!ae(Ce,Fe))return null;const te=$e.replace("$(basename)",()=>X),ve=V(te);return(0,I.$oh)(ve)?ve.then(ce=>ce?_:null):ve?_:null};return oe.requiresSiblings=!0,oe}}return ae}function Z(_,ge){const se=_.filter(Fe=>!!Fe.basenames);if(se.length<2)return _;const ae=se.reduce((Fe,X)=>{const V=X.basenames;return V?Fe.concat(V):Fe},[]);let $e;if(ge){$e=[];for(let Fe=0,X=ae.length;Fe<X;Fe++)$e.push(ge)}else $e=se.reduce((Fe,X)=>{const V=X.patterns;return V?Fe.concat(V):Fe},[]);const oe=function(Fe,X){if(typeof Fe!="string")return null;if(!X){let te;for(te=Fe.length;te>0;te--){const ve=Fe.charCodeAt(te-1);if(ve===C.CharCode.Slash||ve===C.CharCode.Backslash)break}X=Fe.substr(te)}const V=ae.indexOf(X);return V!==-1?$e[V]:null};oe.basenames=ae,oe.patterns=$e,oe.allBasenames=ae;const Ce=_.filter(Fe=>!Fe.basenames);return Ce.push(oe),Ce}function fe(_,ge){return(0,v.$tb)(_,ge,(se,ae)=>typeof se=="string"&&typeof ae=="string"?se===ae:typeof se!="string"&&typeof ae!="string"?se.base===ae.base&&se.pattern===ae.pattern:!1)}}),define(Ne[59],Oe([1,0,13,98,23,12,2]),function(we,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.MarkdownStringTextNewlineStyle=void 0,e.$1k=a,e.$2k=R,e.$3k=y,e.$4k=c,e.$5k=S,e.$6k=f,e.$7k=n,e.$8k=o;var T;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(T||(e.MarkdownStringTextNewlineStyle=T={}));class ${constructor(l="",i=!1){if(this.value=l,typeof this.value!="string")throw(0,v.$6)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(l,i=T.Paragraph){return this.value+=c(this.supportThemeIcons?(0,I.$Tk)(l):l).replace(/([ \t]+)/g,(r,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===T.Break?`\\
`:`

`),this}appendMarkdown(l){return this.value+=l,this}appendCodeblock(l,i){return this.value+=`
${S(i,l)}
`,this}appendLink(l,i,r){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(l),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(l,i){const r=new RegExp((0,N.$ff)(i),"g");return l.replace(r,(t,g)=>l.charAt(g-1)!=="\\"?`\\${t}`:t)}}e.$Zk=$;function a(s){return R(s)?!s.value:Array.isArray(s)?s.every(a):!0}function R(s){return s instanceof $?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}function y(s,l){return s===l?!0:!s||!l?!1:s.value===l.value&&s.isTrusted===l.isTrusted&&s.supportThemeIcons===l.supportThemeIcons&&s.supportHtml===l.supportHtml&&(s.baseUri===l.baseUri||!!s.baseUri&&!!l.baseUri&&(0,C.$9g)(A.URI.from(s.baseUri),A.URI.from(l.baseUri)))}function c(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function S(s,l){const i=s.match(/^`+/gm)?.reduce((t,g)=>t.length>g.length?t:g).length??0,r=i>=3?i+1:3;return[`${"`".repeat(r)}${l}`,s,`${"`".repeat(r)}`].join(`
`)}function f(s){return s.replace(/"/g,"&quot;")}function n(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(s){const l=[],i=s.split("|").map(t=>t.trim());s=i[0];const r=i[1];if(r){const t=/height=(\d+)/.exec(r),g=/width=(\d+)/.exec(r),u=t?t[1]:"",p=g?g[1]:"",m=isFinite(parseInt(p)),d=isFinite(parseInt(u));m&&l.push(`width="${p}"`),d&&l.push(`height="${u}"`)}return{href:s,dimensions:l}}}),define(Ne[99],Oe([1,0,17,51,19,20,23,12]),function(we,e,v,I,C,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uw=$,e.$Vw=R,e.$Ww=c,e.$Xw=S,e.$Yw=s,e.$Zw=i,e.$1w=r,e.$2w=t,e.$3w=g,e.$4w=u;function $(m,d){const{os:E,tildify:D,relative:w}=d;if(w){const h=a(m,w,E);if(typeof h=="string")return h}let k=m.fsPath;if(E===N.OperatingSystem.Windows&&!N.$j?k=k.replace(/\//g,"\\"):E!==N.OperatingSystem.Windows&&N.$j&&(k=k.replace(/\\/g,"/")),E!==N.OperatingSystem.Windows&&D?.userHome){const h=D.userHome.fsPath;let b;m.scheme!==D.userHome.scheme&&m.path[0]===C.$fc.sep&&m.path[1]!==C.$fc.sep?b=D.userHome.with({path:m.path}).fsPath:b=k,k=c(b,h,E)}return(E===N.OperatingSystem.Windows?C.$ec:C.$fc).normalize(R(k,E===N.OperatingSystem.Windows))}function a(m,d,E){const D=E===N.OperatingSystem.Windows?C.$ec:C.$fc,w=E===N.OperatingSystem.Linux?A.$6g:A.$8g,k=d.getWorkspace(),P=(0,v.$Nb)(k.folders);if(!P)return;m.scheme!==P.uri.scheme&&m.path[0]===C.$fc.sep&&m.path[1]!==C.$fc.sep&&(m=P.uri.with({path:m.path}));const h=d.getWorkspaceFolder(m);if(!h)return;let b;if(w.isEqual(h.uri,m)?b="":b=w.relativePath(h.uri,m)??"",b&&(b=D.normalize(b)),k.folders.length>1&&!d.noPrefix){const M=h.name?h.name:w.basenameOrAuthority(h.uri);b=b?`${M} \u2022 ${b}`:M}return b}function R(m,d=N.$j){return(0,I.$Gg)(m,d)?m.charAt(0).toUpperCase()+m.slice(1):m}let y=Object.create(null);function c(m,d,E=N.OS){if(E===N.OperatingSystem.Windows||!m||!d)return m;let D=y.original===d?y.normalized:void 0;D||(D=d,N.$j&&(D=(0,I.$vg)(D)),D=`${(0,T.$lf)(D,C.$fc.sep)}${C.$fc.sep}`,y={original:d,normalized:D});let w=m;return N.$j&&(w=(0,I.$vg)(w)),(E===N.OperatingSystem.Linux?w.startsWith(D):(0,T.$Ef)(w,D))?`~/${w.substr(D.length)}`:m}function S(m,d){return m.replace(/^~($|\/|\\)/,`${d}$1`)}const f="\u2026",n="\\\\",o="~";function s(m,d=C.sep){const E=new Array(m.length);let D=!1;for(let w=0;w<m.length;w++){const k=m[w];if(k===""){E[w]=`.${d}`;continue}if(!k){E[w]=k;continue}D=!0;let P="",h=k;h.indexOf(n)===0?(P=h.substr(0,h.indexOf(n)+n.length),h=h.substr(h.indexOf(n)+n.length)):h.indexOf(d)===0?(P=h.substr(0,h.indexOf(d)+d.length),h=h.substr(h.indexOf(d)+d.length)):h.indexOf(o)===0&&(P=h.substr(0,h.indexOf(o)+o.length),h=h.substr(h.indexOf(o)+o.length));const b=h.split(d);for(let M=1;D&&M<=b.length;M++)for(let O=b.length-M;D&&O>=0;O--){D=!1;let F=b.slice(O,O+M).join(d);for(let q=0;!D&&q<m.length;q++)if(q!==w&&m[q]&&m[q].indexOf(F)>-1){const B=O+M===b.length,L=O>0&&m[q].indexOf(d)>-1?d+F:F,Y=m[q].endsWith(L);D=!B||Y}if(!D){let q="";(b[0].endsWith(":")||P!=="")&&(O===1&&(O=0,M++,F=b[0]+d+F),O>0&&(q=b[0]+d),q=P+q),O>0&&(q=q+f+d),q=q+F,O+M<b.length&&(q=q+d+f),E[w]=q}}D&&(E[w]=k)}return E}var l;(function(m){m[m.TEXT=0]="TEXT",m[m.VARIABLE=1]="VARIABLE",m[m.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function i(m,d=Object.create(null)){const E=[];let D=!1,w="";for(const k of m)if(k==="$"||D&&k==="{")w&&E.push({value:w,type:l.TEXT}),w="",D=!0;else if(k==="}"&&D){const P=d[w];if(typeof P=="string")P.length&&E.push({value:P,type:l.VARIABLE});else if(P){const h=E[E.length-1];(!h||h.type!==l.SEPARATOR)&&E.push({value:P.label,type:l.SEPARATOR})}w="",D=!1}else w+=k;return w&&!D&&E.push({value:w,type:l.TEXT}),E.filter((k,P)=>{if(k.type===l.SEPARATOR){const h=E[P-1],b=E[P+1];return[h,b].every(M=>M&&(M.type===l.VARIABLE||M.type===l.TEXT)&&M.value.length>0)}return!0}).map(k=>k.value).join("")}function r(m,d){return N.$k||d?m.replace(/\(&&\w\)|&&/g,"").replace(/&/g,N.$k?"&":"&&"):m.replace(/&&|&/g,E=>E==="&"?"&&":"&")}function t(m,d){return N.$k||d?m.replace(/\(&&\w\)|&&/g,""):N.$j?m.replace(/&&|&/g,E=>E==="&"?"&&":"&"):m.replace(/&&/g,"_")}function g(m){return m.replace(/&/g,"&&")}function u(m){if(m.endsWith("]")){const d=m.lastIndexOf(" [",m.length-2);if(d!==-1){const E=p(m.substring(0,d)),D=m.substring(d);return{name:E.name+D,parentPath:E.parentPath}}}return p(m)}function p(m){const d=m.indexOf("/")!==-1?C.$fc:C.$ec,E=d.basename(m),D=d.dirname(m);return E.length?{name:E,parentPath:D}:{name:D,parentPath:""}}}),define(Ne[149],Oe([1,0,22,36,2]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=void 0,e.$Kn=$,e.$Ln=R,e.$Mn=y;function N(c){return c.toJSON()}class A{constructor(S){this.a=S}transformIncoming(S){const f=this.a.transformIncoming(S);return f===S?S:N(C.URI.from(f))}transformOutgoing(S){const f=this.a.transformOutgoing(S);return f===S?S:N(C.URI.from(f))}transformOutgoingURI(S){const f=this.a.transformOutgoing(S);return f===S?S:C.URI.from(f)}transformOutgoingScheme(S){return this.a.transformOutgoingScheme(S)}}e.$In=A,e.$Jn=new class{transformIncoming(c){return c}transformOutgoing(c){return c}transformOutgoingURI(c){return c}transformOutgoingScheme(c){return c}};function T(c,S,f){if(!c||f>200)return null;if(typeof c=="object"){if(c instanceof C.URI)return S.transformOutgoing(c);for(const n in c)if(Object.hasOwnProperty.call(c,n)){const o=T(c[n],S,f+1);o!==null&&(c[n]=o)}}return null}function $(c,S){const f=T(c,S,0);return f===null?c:f}function a(c,S,f,n){if(!c||n>200)return null;if(typeof c=="object"){if(c.$mid===I.MarshalledId.Uri)return f?C.URI.revive(S.transformIncoming(c)):S.transformIncoming(c);if(c instanceof v.$Le)return null;for(const o in c)if(Object.hasOwnProperty.call(c,o)){const s=a(c[o],S,f,n+1);s!==null&&(c[o]=s)}}return null}function R(c,S){const f=a(c,S,!1,0);return f===null?c:f}function y(c,S){const f=a(c,S,!0,0);return f===null?c:f}}),define(Ne[37],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yg=void 0,e.$Xg=I;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(C){return v.test(C)}e.$Yg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(T){for(let $=0;$<T.length;$++)T[$]=Math.floor(Math.random()*256);return T};const N=new Uint8Array(16),A=[];for(let T=0;T<256;T++)A.push(T.toString(16).padStart(2,"0"));return function(){C(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let $=0,a="";return a+=A[N[$++]],a+=A[N[$++]],a+=A[N[$++]],a+=A[N[$++]],a+="-",a+=A[N[$++]],a+=A[N[$++]],a+="-",a+=A[N[$++]],a+=A[N[$++]],a+="-",a+=A[N[$++]],a+=A[N[$++]],a+="-",a+=A[N[$++]],a+=A[N[$++]],a+=A[N[$++]],a+=A[N[$++]],a+=A[N[$++]],a+=A[N[$++]],a}}()}),define(Ne[150],Oe([1,0,17,39,37]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ou=e.$mu=void 0,e.$ku=N,e.$lu=A,e.$nu=a;function N(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function A(y,c,S){const f={id:(0,C.$Yg)(),name:y,uri:c,data:S};return{asString:async()=>"",asFile:()=>f,value:void 0}}class T{constructor(){this.a=new Map}get size(){let c=0;for(const S of this.a)c++;return c}has(c){return this.a.has(this.b(c))}matches(c){const S=[...this.a.keys()];return I.Iterable.some(this,([f,n])=>n.asFile())&&S.push("files"),R($(c),S)}get(c){return this.a.get(this.b(c))?.[0]}append(c,S){const f=this.a.get(c);f?f.push(S):this.a.set(this.b(c),[S])}replace(c,S){this.a.set(this.b(c),[S])}delete(c){this.a.delete(this.b(c))}*[Symbol.iterator](){for(const[c,S]of this.a)for(const f of S)yield[c,f]}b(c){return $(c)}}e.$mu=T;function $(y){return y.toLowerCase()}function a(y,c){return R($(y),c.map($))}function R(y,c){if(y==="*/*")return c.length>0;if(c.includes(y))return!0;const S=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!S)return!1;const[f,n,o]=S;return o==="*"?c.some(s=>s.startsWith(n+"/")):!1}e.$ou=Object.freeze({create:y=>(0,v.$Lb)(y.map(c=>c.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.$ou.split(y).filter(c=>!c.startsWith("#"))})}),define(Ne[151],Oe([1,0,10,6,4,40,14]),function(we,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=e.StorageState=e.StorageHint=void 0,e.$_p=$;var T;(function(c){c[c.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",c[c.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(T||(e.StorageHint=T={}));function $(c){const S=c;return S?.changed instanceof Map||S?.deleted instanceof Set}var a;(function(c){c[c.None=0]="None",c[c.Initialized=1]="Initialized",c[c.Closed=2]="Closed"})(a||(e.StorageState=a={}));class R extends C.$Tc{static{this.a=100}constructor(S,f=Object.create(null)){super(),this.r=S,this.s=f,this.b=this.B(new I.$me),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new v.$Ah(R.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(S=>this.u(S)))}u(S){this.b.pause();try{S.changed?.forEach((f,n)=>this.w(n,f)),S.deleted?.forEach(f=>this.w(f,void 0))}finally{this.b.resume()}}w(S,f){if(this.c===a.Closed)return;let n=!1;(0,A.$lg)(f)?n=this.f.delete(S):this.f.get(S)!==f&&(this.f.set(S,f),n=!0),n&&this.b.fire({key:S,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(S,f){const n=this.f.get(S);return(0,A.$lg)(n)?f:n}getBoolean(S,f){const n=this.get(S);return(0,A.$lg)(n)?f:n==="true"}getNumber(S,f){const n=this.get(S);return(0,A.$lg)(n)?f:parseInt(n,10)}getObject(S,f){const n=this.get(S);return(0,A.$lg)(n)?f:(0,N.$$h)(n)}async set(S,f,n=!1){if(this.c===a.Closed)return;if((0,A.$lg)(f))return this.delete(S,n);const o=(0,A.$eg)(f)||Array.isArray(f)?(0,N.$0h)(f):String(f);if(this.f.get(S)!==o)return this.f.set(S,o),this.j.set(S,o),this.h.delete(S),this.b.fire({key:S,external:n}),this.D()}async delete(S,f=!1){if(!(this.c===a.Closed||!this.f.delete(S)))return this.h.has(S)||this.h.add(S),this.j.delete(S),this.b.fire({key:S,external:f}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const S={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(S).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(S){if(!(this.c===a.Closed||this.m))return this.D(S)}async D(S){return this.s.hint===T.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),S)}async whenFlushed(){if(this.z)return new Promise(S=>this.n.push(S))}isInMemory(){return this.s.hint===T.STORAGE_IN_MEMORY}}e.$aq=R;class y{constructor(){this.onDidChangeItemsExternal=I.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(S){S.insert?.forEach((f,n)=>this.a.set(n,f)),S.delete?.forEach(f=>this.a.delete(f))}async optimize(){}async close(){}}e.$bq=y}),define(Ne[152],Oe([1,0,27]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$uu=C;var I;(function(N){N[N.Unknown=0]="Unknown",N[N.Invalid=3]="Invalid",N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function C(N){let A=0,T=0,$=0,a=I.Unknown;for(let R=0,y=N.length;R<y;R++){const c=N.charCodeAt(R);c===v.CharCode.CarriageReturn?(A===0&&(T=R),A++,R+1<y&&N.charCodeAt(R+1)===v.CharCode.LineFeed?(a|=I.CRLF,R++):a|=I.Invalid,$=R+1):c===v.CharCode.LineFeed&&(a|=I.LF,A===0&&(T=R),A++,$=R+1)}return A===0&&(T=N.length),[A,T,N.length-$,a]}}),define(Ne[153],Oe([1,0,12,20,22]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_t=void 0,e.$0t=R,e.$$t=y,v=Ve(v),I=Ve(I),C=Ve(C);let N;function A(){return N||(N=new TextDecoder("UTF-16LE")),N}let T;function $(){return T||(T=new TextDecoder("UTF-16BE")),T}let a;function R(){return a||(a=I.$E()?A():$()),a}function y(f,n,o){const s=new Uint16Array(f.buffer,n,o);return o>0&&(s[0]===65279||s[0]===65534)?c(f,n,o):A().decode(s)}function c(f,n,o){const s=[];let l=0;for(let i=0;i<o;i++){const r=C.$Ne(f,n);n+=2,s[l++]=String.fromCharCode(r)}return s.join("")}class S{constructor(n){this.a=n|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const n=new Uint16Array(this.b.buffer,0,this.d);return R().decode(n)}f(){const n=this.e();this.d=0,this.c===null?this.c=[n]:this.c[this.c.length]=n}appendCharCode(n){const o=this.a-this.d;o<=1&&(o===0||v.$Hf(n))&&this.f(),this.b[this.d++]=n}appendASCIICharCode(n){this.d===this.a&&this.f(),this.b[this.d++]=n}appendString(n){const o=n.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=n;return}for(let s=0;s<o;s++)this.b[this.d++]=n.charCodeAt(s)}}e.$_t=S}),define(Ne[154],Oe([1,0,22,153]),function(we,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$au=void 0,e.$bu=A,v=Ve(v);function C($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class N{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(a,R,y,c){this.oldPosition=a,this.oldText=R,this.newPosition=y,this.newText=c}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${C(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${C(this.oldText)}")`:`(replace@${this.oldPosition} "${C(this.oldText)}" with "${C(this.newText)}")`}static a(a){return 4+2*a.length}static c(a,R,y){const c=R.length;v.$Qe(a,c,y),y+=4;for(let S=0;S<c;S++)v.$Oe(a,R.charCodeAt(S),y),y+=2;return y}static d(a,R){const y=v.$Pe(a,R);return R+=4,(0,I.$$t)(a,R,y)}writeSize(){return 8+N.a(this.oldText)+N.a(this.newText)}write(a,R){return v.$Qe(a,this.oldPosition,R),R+=4,v.$Qe(a,this.newPosition,R),R+=4,R=N.c(a,this.oldText,R),R=N.c(a,this.newText,R),R}static read(a,R,y){const c=v.$Pe(a,R);R+=4;const S=v.$Pe(a,R);R+=4;const f=N.d(a,R);R+=N.a(f);const n=N.d(a,R);return R+=N.a(n),y.push(new N(c,f,S,n)),R}}e.$au=N;function A($,a){return $===null||$.length===0?a:new T($,a).compress()}class T{constructor(a,R){this.a=a,this.c=R,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let a=0,R=0,y=this.n(a),c=this.l(R);for(;a<this.f||R<this.h;){if(y===null){this.k(c),c=this.l(++R);continue}if(c===null){this.m(y),y=this.n(++a);continue}if(c.oldEnd<=y.newPosition){this.k(c),c=this.l(++R);continue}if(y.newEnd<=c.oldPosition){this.m(y),y=this.n(++a);continue}if(c.oldPosition<y.newPosition){const[s,l]=T.r(c,y.newPosition-c.oldPosition);this.k(s),c=l;continue}if(y.newPosition<c.oldPosition){const[s,l]=T.q(y,c.oldPosition-y.newPosition);this.m(s),y=l;continue}let n,o;if(c.oldEnd===y.newEnd)n=y,o=c,y=this.n(++a),c=this.l(++R);else if(c.oldEnd<y.newEnd){const[s,l]=T.q(y,c.oldLength);n=s,o=c,y=l,c=this.l(++R)}else{const[s,l]=T.r(c,y.newLength);n=y,o=s,y=this.n(++a),c=l}this.d[this.e++]=new N(n.oldPosition,n.oldText,o.newPosition,o.newText),this.g+=n.newLength-n.oldLength,this.j+=o.newLength-o.oldLength}const S=T.s(this.d);return T.t(S)}k(a){this.d[this.e++]=T.o(this.g,a),this.j+=a.newLength-a.oldLength}l(a){return a<this.h?this.c[a]:null}m(a){this.d[this.e++]=T.p(this.j,a),this.g+=a.newLength-a.oldLength}n(a){return a<this.f?this.a[a]:null}static o(a,R){return new N(R.oldPosition-a,R.oldText,R.newPosition,R.newText)}static p(a,R){return new N(R.oldPosition,R.oldText,R.newPosition+a,R.newText)}static q(a,R){const y=a.newText.substr(0,R),c=a.newText.substr(R);return[new N(a.oldPosition,a.oldText,a.newPosition,y),new N(a.oldEnd,"",a.newPosition+R,c)]}static r(a,R){const y=a.oldText.substr(0,R),c=a.oldText.substr(R);return[new N(a.oldPosition,y,a.newPosition,a.newText),new N(a.oldPosition+R,c,a.newEnd,"")]}static s(a){if(a.length===0)return a;const R=[];let y=0,c=a[0];for(let S=1;S<a.length;S++){const f=a[S];c.oldEnd===f.oldPosition?c=new N(c.oldPosition,c.oldText+f.oldText,c.newPosition,c.newText+f.newText):(R[y++]=c,c=f)}return R[y++]=c,R}static t(a){if(a.length===0)return a;const R=[];let y=0;for(let c=0;c<a.length;c++){const S=a[c];S.oldText!==S.newText&&(R[y++]=S)}return R}}}),define(Ne[155],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ht=void 0,e.$ht={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ne[156],Oe([1,0,41,19]),function(we,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ru=C,e.$su=N;function C(A,T,$,a,R,y){if(Array.isArray(A)){let c=0;for(const S of A){const f=C(S,T,$,a,R,y);if(f===10)return f;f>c&&(c=f)}return c}else{if(typeof A=="string")return a?A==="*"?5:A===$?10:0:0;if(A){const{language:c,pattern:S,scheme:f,hasAccessToAllModels:n,notebookType:o}=A;if(!a&&!n)return 0;o&&R&&(T=R);let s=0;if(f)if(f===T.scheme)s=10;else if(f==="*")s=5;else return 0;if(c)if(c===$)s=10;else if(c==="*")s=Math.max(s,5);else return 0;if(o)if(o===y)s=10;else if(o==="*"&&y!==void 0)s=Math.max(s,5);else return 0;if(S){let l;if(typeof S=="string"?l=S:l={...S,base:(0,I.$gc)(S.base)},l===T.fsPath||(0,v.$vk)(l,T.fsPath))s=10;else return 0}return s}else return 0}}function N(A){return typeof A=="string"?!1:Array.isArray(A)?A.some(N):!!A.notebookType}}),define(Ne[157],Oe([1,0,27,158]),function(we,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Su=e.$Ru=e.IndentAction=void 0;var C;(function($){$[$.None=0]="None",$[$.Indent=1]="Indent",$[$.IndentOutdent=2]="IndentOutdent",$[$.Outdent=3]="Outdent"})(C||(e.IndentAction=C={}));class N{constructor(a){if(this.e=null,this.f=!1,this.open=a.open,this.close=a.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(a.notIn))for(let R=0,y=a.notIn.length;R<y;R++)switch(a.notIn[R]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(a){switch(a){case I.StandardTokenType.Other:return!0;case I.StandardTokenType.Comment:return this.c;case I.StandardTokenType.String:return this.b;case I.StandardTokenType.RegEx:return this.d}}shouldAutoClose(a,R){if(a.getTokenCount()===0)return!0;const y=a.findTokenIndexAtOffset(R-2),c=a.getStandardTokenType(y);return this.isOK(c)}g(a,R){for(let y=a;y<=R;y++){const c=String.fromCharCode(y);if(!this.open.includes(c)&&!this.close.includes(c))return c}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(v.CharCode.Digit0,v.CharCode.Digit9)),this.e||(this.e=this.g(v.CharCode.a,v.CharCode.z)),this.e||(this.e=this.g(v.CharCode.A,v.CharCode.Z))),this.e}}e.$Ru=N;class A{constructor(a){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const R of a)T(this.autoClosingPairsOpenByStart,R.open.charAt(0),R),T(this.autoClosingPairsOpenByEnd,R.open.charAt(R.open.length-1),R),T(this.autoClosingPairsCloseByStart,R.close.charAt(0),R),T(this.autoClosingPairsCloseByEnd,R.close.charAt(R.close.length-1),R),R.close.length===1&&R.open.length===1&&T(this.autoClosingPairsCloseSingleChar,R.close,R)}}e.$Su=A;function T($,a,R){$.has(a)?$.get(a).push(R):$.set(a,[R])}}),define(Ne[159],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2C=e.NodeColor=e.$1C=void 0,e.$3C=C,e.$4C=N,e.$5C=a,e.$6C=R,e.$7C=y,e.$8C=c,e.$9C=S,e.$0C=f;class v{constructor(o,s){this.piece=o,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$2C)return C(this.right);let o=this;for(;o.parent!==e.$2C&&o.parent.left!==o;)o=o.parent;return o.parent===e.$2C?e.$2C:o.parent}prev(){if(this.left!==e.$2C)return N(this.left);let o=this;for(;o.parent!==e.$2C&&o.parent.right!==o;)o=o.parent;return o.parent===e.$2C?e.$2C:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$1C=v;var I;(function(n){n[n.Black=0]="Black",n[n.Red=1]="Red"})(I||(e.NodeColor=I={})),e.$2C=new v(null,I.Black),e.$2C.parent=e.$2C,e.$2C.left=e.$2C,e.$2C.right=e.$2C,e.$2C.color=I.Black;function C(n){for(;n.left!==e.$2C;)n=n.left;return n}function N(n){for(;n.right!==e.$2C;)n=n.right;return n}function A(n){return n===e.$2C?0:n.size_left+n.piece.length+A(n.right)}function T(n){return n===e.$2C?0:n.lf_left+n.piece.lineFeedCnt+T(n.right)}function $(){e.$2C.parent=e.$2C}function a(n,o){const s=o.right;s.size_left+=o.size_left+(o.piece?o.piece.length:0),s.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=s.left,s.left!==e.$2C&&(s.left.parent=o),s.parent=o.parent,o.parent===e.$2C?n.root=s:o.parent.left===o?o.parent.left=s:o.parent.right=s,s.left=o,o.parent=s}function R(n,o){const s=o.left;o.left=s.right,s.right!==e.$2C&&(s.right.parent=o),s.parent=o.parent,o.size_left-=s.size_left+(s.piece?s.piece.length:0),o.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),o.parent===e.$2C?n.root=s:o===o.parent.right?o.parent.right=s:o.parent.left=s,s.right=o,o.parent=s}function y(n,o){let s,l;if(o.left===e.$2C?(l=o,s=l.right):o.right===e.$2C?(l=o,s=l.left):(l=C(o.right),s=l.right),l===n.root){n.root=s,s.color=I.Black,o.detach(),$(),n.root.parent=e.$2C;return}const i=l.color===I.Red;if(l===l.parent.left?l.parent.left=s:l.parent.right=s,l===o?(s.parent=l.parent,f(n,s)):(l.parent===o?s.parent=l:s.parent=l.parent,f(n,s),l.left=o.left,l.right=o.right,l.parent=o.parent,l.color=o.color,o===n.root?n.root=l:o===o.parent.left?o.parent.left=l:o.parent.right=l,l.left!==e.$2C&&(l.left.parent=l),l.right!==e.$2C&&(l.right.parent=l),l.size_left=o.size_left,l.lf_left=o.lf_left,f(n,l)),o.detach(),s.parent.left===s){const t=A(s),g=T(s);if(t!==s.parent.size_left||g!==s.parent.lf_left){const u=t-s.parent.size_left,p=g-s.parent.lf_left;s.parent.size_left=t,s.parent.lf_left=g,S(n,s.parent,u,p)}}if(f(n,s.parent),i){$();return}let r;for(;s!==n.root&&s.color===I.Black;)s===s.parent.left?(r=s.parent.right,r.color===I.Red&&(r.color=I.Black,s.parent.color=I.Red,a(n,s.parent),r=s.parent.right),r.left.color===I.Black&&r.right.color===I.Black?(r.color=I.Red,s=s.parent):(r.right.color===I.Black&&(r.left.color=I.Black,r.color=I.Red,R(n,r),r=s.parent.right),r.color=s.parent.color,s.parent.color=I.Black,r.right.color=I.Black,a(n,s.parent),s=n.root)):(r=s.parent.left,r.color===I.Red&&(r.color=I.Black,s.parent.color=I.Red,R(n,s.parent),r=s.parent.left),r.left.color===I.Black&&r.right.color===I.Black?(r.color=I.Red,s=s.parent):(r.left.color===I.Black&&(r.right.color=I.Black,r.color=I.Red,a(n,r),r=s.parent.left),r.color=s.parent.color,s.parent.color=I.Black,r.left.color=I.Black,R(n,s.parent),s=n.root));s.color=I.Black,$()}function c(n,o){for(f(n,o);o!==n.root&&o.parent.color===I.Red;)if(o.parent===o.parent.parent.left){const s=o.parent.parent.right;s.color===I.Red?(o.parent.color=I.Black,s.color=I.Black,o.parent.parent.color=I.Red,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,a(n,o)),o.parent.color=I.Black,o.parent.parent.color=I.Red,R(n,o.parent.parent))}else{const s=o.parent.parent.left;s.color===I.Red?(o.parent.color=I.Black,s.color=I.Black,o.parent.parent.color=I.Red,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,R(n,o)),o.parent.color=I.Black,o.parent.parent.color=I.Red,a(n,o.parent.parent))}n.root.color=I.Black}function S(n,o,s,l){for(;o!==n.root&&o!==e.$2C;)o.parent.left===o&&(o.parent.size_left+=s,o.parent.lf_left+=l),o=o.parent}function f(n,o){let s=0,l=0;if(o!==n.root){for(;o!==n.root&&o===o.parent.right;)o=o.parent;if(o!==n.root)for(o=o.parent,s=A(o.left)-o.size_left,l=T(o.left)-o.lf_left,o.size_left+=s,o.lf_left+=l;o!==n.root&&(s!==0||l!==0);)o.parent.left===o&&(o.parent.size_left+=s,o.parent.lf_left+=l),o=o.parent}}}),define(Ne[100],Oe([1,0,27,101,32,52,159,102]),function(we,e,v,I,C,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iD=e.$hD=e.$gD=void 0,e.$eD=y,e.$fD=c;const $=65535;function a(l){let i;return l[l.length-1]<65536?i=new Uint16Array(l.length):i=new Uint32Array(l.length),i.set(l,0),i}class R{constructor(i,r,t,g,u){this.lineStarts=i,this.cr=r,this.lf=t,this.crlf=g,this.isBasicASCII=u}}function y(l,i=!0){const r=[0];let t=1;for(let g=0,u=l.length;g<u;g++){const p=l.charCodeAt(g);p===v.CharCode.CarriageReturn?g+1<u&&l.charCodeAt(g+1)===v.CharCode.LineFeed?(r[t++]=g+2,g++):r[t++]=g+1:p===v.CharCode.LineFeed&&(r[t++]=g+1)}return i?a(r):r}function c(l,i){l.length=0,l[0]=0;let r=1,t=0,g=0,u=0,p=!0;for(let d=0,E=i.length;d<E;d++){const D=i.charCodeAt(d);D===v.CharCode.CarriageReturn?d+1<E&&i.charCodeAt(d+1)===v.CharCode.LineFeed?(u++,l[r++]=d+2,d++):(t++,l[r++]=d+1):D===v.CharCode.LineFeed?(g++,l[r++]=d+1):p&&D!==v.CharCode.Tab&&(D<32||D>126)&&(p=!1)}const m=new R(a(l),t,g,u,p);return l.length=0,m}class S{constructor(i,r,t,g,u){this.bufferIndex=i,this.start=r,this.end=t,this.lineFeedCnt=g,this.length=u}}e.$gD=S;class f{constructor(i,r){this.buffer=i,this.lineStarts=r}}e.$hD=f;class n{constructor(i,r){this.a=[],this.c=i,this.d=r,this.b=0,i.root!==A.$2C&&i.iterate(i.root,t=>(t!==A.$2C&&this.a.push(t.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class o{constructor(i){this.a=i,this.b=[]}get(i){for(let r=this.b.length-1;r>=0;r--){const t=this.b[r];if(t.nodeStartOffset<=i&&t.nodeStartOffset+t.node.piece.length>=i)return t}return null}get2(i){for(let r=this.b.length-1;r>=0;r--){const t=this.b[r];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<i&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=i)return t}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let r=!1;const t=this.b;for(let g=0;g<t.length;g++){const u=t[g];if(u.node.parent===null||u.nodeStartOffset>=i){t[g]=null,r=!0;continue}}if(r){const g=[];for(const u of t)u!==null&&g.push(u);this.b=g}}}class s{constructor(i,r,t){this.create(i,r,t)}create(i,r,t){this.a=[new f("",[0])],this.g={line:0,column:0},this.root=A.$2C,this.b=1,this.c=0,this.d=r,this.e=r.length,this.f=t;let g=null;for(let u=0,p=i.length;u<p;u++)if(i[u].buffer.length>0){i[u].lineStarts||(i[u].lineStarts=y(i[u].buffer));const m=new S(u+1,{line:0,column:0},{line:i[u].lineStarts.length-1,column:i[u].buffer.length-i[u].lineStarts[i[u].lineStarts.length-1]},i[u].lineStarts.length-1,i[u].buffer.length);this.a.push(i[u]),g=this.S(g,m)}this.h=new o(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const r=$,t=r-Math.floor(r/3),g=t*2;let u="",p=0;const m=[];if(this.iterate(this.root,d=>{const E=this.R(d),D=E.length;if(p<=t||p+D<g)return u+=E,p+=D,!0;const w=u.replace(/\r\n|\r|\n/g,i);return m.push(new f(w,y(w))),u=E,p=D,!0}),p>0){const d=u.replace(/\r\n|\r|\n/g,i);m.push(new f(d,y(d)))}this.create(m,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new n(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let r=0;return this.iterate(this.root,g=>{if(g===A.$2C)return!0;const u=this.R(g),p=u.length,m=i.G(r),d=i.G(r+p),E=i.getValueInRange2(m,d);return r+=p,u===E})}getOffsetAt(i,r){let t=0,g=this.root;for(;g!==A.$2C;)if(g.left!==A.$2C&&g.lf_left+1>=i)g=g.left;else if(g.lf_left+g.piece.lineFeedCnt+1>=i){t+=g.size_left;const u=this.B(g,i-g.lf_left-2);return t+=u+r-1}else i-=g.lf_left+g.piece.lineFeedCnt,t+=g.size_left+g.piece.length,g=g.right;return t}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let r=this.root,t=0;const g=i;for(;r!==A.$2C;)if(r.size_left!==0&&r.size_left>=i)r=r.left;else if(r.size_left+r.piece.length>=i){const u=this.A(r,i-r.size_left);if(t+=r.lf_left+u.index,u.index===0){const p=this.getOffsetAt(t+1,1),m=g-p;return new I.$Jt(t+1,m+1)}return new I.$Jt(t+1,u.remainder+1)}else if(i-=r.size_left+r.piece.length,t+=r.lf_left+r.piece.lineFeedCnt,r.right===A.$2C){const u=this.getOffsetAt(t+1,1),p=g-i-u;return new I.$Jt(t+1,p+1)}else r=r.right;return new I.$Jt(1,1)}getValueInRange(i,r){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const t=this.H(i.startLineNumber,i.startColumn),g=this.H(i.endLineNumber,i.endColumn),u=this.getValueInRange2(t,g);return r?r!==this.d||!this.f?u.replace(/\r\n|\r|\n/g,r):r===this.getEOL()&&this.f?u:u.replace(/\r\n|\r|\n/g,r):u}getValueInRange2(i,r){if(i.node===r.node){const m=i.node,d=this.a[m.piece.bufferIndex].buffer,E=this.u(m.piece.bufferIndex,m.piece.start);return d.substring(E+i.remainder,E+r.remainder)}let t=i.node;const g=this.a[t.piece.bufferIndex].buffer,u=this.u(t.piece.bufferIndex,t.piece.start);let p=g.substring(u+i.remainder,u+t.piece.length);for(t=t.next();t!==A.$2C;){const m=this.a[t.piece.bufferIndex].buffer,d=this.u(t.piece.bufferIndex,t.piece.start);if(t===r.node){p+=m.substring(d,d+r.remainder);break}else p+=m.substr(d,t.piece.length);t=t.next()}return p}getLinesContent(){const i=[];let r=0,t="",g=!1;return this.iterate(this.root,u=>{if(u===A.$2C)return!0;const p=u.piece;let m=p.length;if(m===0)return!0;const d=this.a[p.bufferIndex].buffer,E=this.a[p.bufferIndex].lineStarts,D=p.start.line,w=p.end.line;let k=E[D]+p.start.column;if(g&&(d.charCodeAt(k)===v.CharCode.LineFeed&&(k++,m--),i[r++]=t,t="",g=!1,m===0))return!0;if(D===w)return!this.f&&d.charCodeAt(k+m-1)===v.CharCode.CarriageReturn?(g=!0,t+=d.substr(k,m-1)):t+=d.substr(k,m),!0;t+=this.f?d.substring(k,Math.max(k,E[D+1]-this.e)):d.substring(k,E[D+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=t;for(let P=D+1;P<w;P++)t=this.f?d.substring(E[P],E[P+1]-this.e):d.substring(E[P],E[P+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=t;return!this.f&&d.charCodeAt(E[w]+p.end.column-1)===v.CharCode.CarriageReturn?(g=!0,p.end.column===0?r--:t=d.substr(E[w],p.end.column-1)):t=d.substr(E[w],p.end.column),!0}),g&&(i[r++]=t,t=""),i[r++]=t,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const r=i.node.next();if(!r)return 0;const t=this.a[r.piece.bufferIndex],g=this.u(r.piece.bufferIndex,r.piece.start);return t.buffer.charCodeAt(g)}else{const r=this.a[i.node.piece.bufferIndex],g=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return r.buffer.charCodeAt(g)}}getLineCharCode(i,r){const t=this.H(i,r+1);return this.l(t)}getLineLength(i){if(i===this.getLineCount()){const r=this.getOffsetAt(i,1);return this.getLength()-r}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const r=this.G(i);return this.l(r)}getNearestChunk(i){const r=this.G(i);if(r.remainder===r.node.piece.length){const t=r.node.next();if(!t||t===A.$2C)return"";const g=this.a[t.piece.bufferIndex],u=this.u(t.piece.bufferIndex,t.piece.start);return g.buffer.substring(u,u+t.piece.length)}else{const t=this.a[r.node.piece.bufferIndex],g=this.u(r.node.piece.bufferIndex,r.node.piece.start),u=g+r.remainder,p=g+r.node.piece.length;return t.buffer.substring(u,p)}}findMatchesInNode(i,r,t,g,u,p,m,d,E,D,w){const k=this.a[i.piece.bufferIndex],P=this.u(i.piece.bufferIndex,i.piece.start),h=this.u(i.piece.bufferIndex,u),b=this.u(i.piece.bufferIndex,p);let M;const O={line:0,column:0};let F,q;r._wordSeparators?(F=k.buffer.substring(h,b),q=B=>B+h,r.reset(0)):(F=k.buffer,q=B=>B,r.reset(h));do if(M=r.next(F),M){if(q(M.index)>=b)return D;this.s(i,q(M.index)-P,O);const B=this.t(i.piece.bufferIndex,u,O),L=O.line===u.line?O.column-u.column+g:O.column+1,Y=L+M[0].length;if(w[D++]=(0,T.$aD)(new C.$Kt(t+B,L,t+B,Y),M,d),q(M.index)+M[0].length>=b||D>=E)return D}while(M);return D}findMatchesLineByLine(i,r,t,g){const u=[];let p=0;const m=new T.$dD(r.wordSeparators,r.regex);let d=this.H(i.startLineNumber,i.startColumn);if(d===null)return[];const E=this.H(i.endLineNumber,i.endColumn);if(E===null)return[];let D=this.s(d.node,d.remainder);const w=this.s(E.node,E.remainder);if(d.node===E.node)return this.findMatchesInNode(d.node,m,i.startLineNumber,i.startColumn,D,w,r,t,g,p,u),u;let k=i.startLineNumber,P=d.node;for(;P!==E.node;){const b=this.t(P.piece.bufferIndex,D,P.piece.end);if(b>=1){const O=this.a[P.piece.bufferIndex].lineStarts,F=this.u(P.piece.bufferIndex,P.piece.start),q=O[D.line+b],B=k===i.startLineNumber?i.startColumn:1;if(p=this.findMatchesInNode(P,m,k,B,D,this.s(P,q-F),r,t,g,p,u),p>=g)return u;k+=b}const M=k===i.startLineNumber?i.startColumn-1:0;if(k===i.endLineNumber){const O=this.getLineContent(k).substring(M,i.endColumn-1);return p=this.n(r,m,O,i.endLineNumber,M,p,u,t,g),u}if(p=this.n(r,m,this.getLineContent(k).substr(M),k,M,p,u,t,g),p>=g)return u;k++,d=this.H(k,1),P=d.node,D=this.s(d.node,d.remainder)}if(k===i.endLineNumber){const b=k===i.startLineNumber?i.startColumn-1:0,M=this.getLineContent(k).substring(b,i.endColumn-1);return p=this.n(r,m,M,i.endLineNumber,b,p,u,t,g),u}const h=k===i.startLineNumber?i.startColumn:1;return p=this.findMatchesInNode(E.node,m,k,h,D,w,r,t,g,p,u),u}n(i,r,t,g,u,p,m,d,E){const D=i.wordSeparators;if(!d&&i.simpleSearch){const k=i.simpleSearch,P=k.length,h=t.length;let b=-P;for(;(b=t.indexOf(k,b+P))!==-1;)if((!D||(0,T.$cD)(D,t,h,b,P))&&(m[p++]=new N.$_v(new C.$Kt(g,b+1+u,g,b+1+P+u),null),p>=E))return p;return p}let w;r.reset(0);do if(w=r.next(t),w&&(m[p++]=(0,T.$aD)(new C.$Kt(g,w.index+1+u,g,w.index+1+w[0].length+u),w,d),p>=E))return p;while(w);return p}insert(i,r,t=!1){if(this.f=this.f&&t,this.j.lineNumber=0,this.j.value="",this.root!==A.$2C){const{node:g,remainder:u,nodeStartOffset:p}=this.G(i),m=g.piece,d=m.bufferIndex,E=this.s(g,u);if(g.piece.bufferIndex===0&&m.end.line===this.g.line&&m.end.column===this.g.column&&p+m.length===i&&r.length<$){this.F(g,r),this.y();return}if(p===i)this.o(r,g),this.h.validate(i);else if(p+g.piece.length>i){const D=[];let w=new S(m.bufferIndex,E,m.end,this.t(m.bufferIndex,E,m.end),this.u(d,m.end)-this.u(d,E));if(this.K()&&this.M(r)&&this.I(g,u)===10){const b={line:w.start.line+1,column:0};w=new S(w.bufferIndex,b,w.end,this.t(w.bufferIndex,b,w.end),w.length-1),r+=`
`}if(this.K()&&this.L(r))if(this.I(g,u-1)===13){const b=this.s(g,u-1);this.C(g,b),r="\r"+r,g.piece.length===0&&D.push(g)}else this.C(g,E);else this.C(g,E);const k=this.w(r);w.length>0&&this.S(g,w);let P=g;for(let h=0;h<k.length;h++)P=this.S(P,k[h]);this.v(D)}else this.q(r,g)}else{const g=this.w(r);let u=this.T(null,g[0]);for(let p=1;p<g.length;p++)u=this.S(u,g[p])}this.y()}delete(i,r){if(this.j.lineNumber=0,this.j.value="",r<=0||this.root===A.$2C)return;const t=this.G(i),g=this.G(i+r),u=t.node,p=g.node;if(u===p){const k=this.s(u,t.remainder),P=this.s(u,g.remainder);if(t.nodeStartOffset===i){if(r===u.piece.length){const h=u.next();(0,A.$7C)(this,u),this.N(h),this.y();return}this.D(u,P),this.h.validate(i),this.N(u),this.y();return}if(t.nodeStartOffset+u.piece.length===i+r){this.C(u,k),this.O(u),this.y();return}this.E(u,k,P),this.y();return}const m=[],d=this.s(u,t.remainder);this.C(u,d),this.h.validate(i),u.piece.length===0&&m.push(u);const E=this.s(p,g.remainder);this.D(p,E),p.piece.length===0&&m.push(p);const D=u.next();for(let k=D;k!==A.$2C&&k!==p;k=k.next())m.push(k);const w=u.piece.length===0?u.prev():u;this.v(m),this.O(w),this.y()}o(i,r){const t=[];if(this.K()&&this.M(i)&&this.L(r)){const p=r.piece,m={line:p.start.line+1,column:0},d=new S(p.bufferIndex,m,p.end,this.t(p.bufferIndex,m,p.end),p.length-1);r.piece=d,i+=`
`,(0,A.$9C)(this,r,-1,-1),r.piece.length===0&&t.push(r)}const g=this.w(i);let u=this.T(r,g[g.length-1]);for(let p=g.length-2;p>=0;p--)u=this.T(u,g[p]);this.N(u),this.v(t)}q(i,r){this.Q(i,r)&&(i+=`
`);const t=this.w(i),g=this.S(r,t[0]);let u=g;for(let p=1;p<t.length;p++)u=this.S(u,t[p]);this.N(g)}s(i,r,t){const g=i.piece,u=i.piece.bufferIndex,p=this.a[u].lineStarts,d=p[g.start.line]+g.start.column+r;let E=g.start.line,D=g.end.line,w=0,k=0,P=0;for(;E<=D&&(w=E+(D-E)/2|0,P=p[w],w!==D);)if(k=p[w+1],d<P)D=w-1;else if(d>=k)E=w+1;else break;return t?(t.line=w,t.column=d-P,null):{line:w,column:d-P}}t(i,r,t){if(t.column===0)return t.line-r.line;const g=this.a[i].lineStarts;if(t.line===g.length-1)return t.line-r.line;const u=g[t.line+1],p=g[t.line]+t.column;if(u>p+1)return t.line-r.line;const m=p-1;return this.a[i].buffer.charCodeAt(m)===13?t.line-r.line+1:t.line-r.line}u(i,r){return this.a[i].lineStarts[r.line]+r.column}v(i){for(let r=0;r<i.length;r++)(0,A.$7C)(this,i[r])}w(i){if(i.length>$){const D=[];for(;i.length>$;){const k=i.charCodeAt($-1);let P;k===v.CharCode.CarriageReturn||k>=55296&&k<=56319?(P=i.substring(0,$-1),i=i.substring($-1)):(P=i.substring(0,$),i=i.substring($));const h=y(P);D.push(new S(this.a.length,{line:0,column:0},{line:h.length-1,column:P.length-h[h.length-1]},h.length-1,P.length)),this.a.push(new f(P,h))}const w=y(i);return D.push(new S(this.a.length,{line:0,column:0},{line:w.length-1,column:i.length-w[w.length-1]},w.length-1,i.length)),this.a.push(new f(i,w)),D}let r=this.a[0].buffer.length;const t=y(i,!1);let g=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===r&&r!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},g=this.g;for(let D=0;D<t.length;D++)t[D]+=r+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+="_"+i,r+=1}else{if(r!==0)for(let D=0;D<t.length;D++)t[D]+=r;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+=i}const u=this.a[0].buffer.length,p=this.a[0].lineStarts.length-1,m=u-this.a[0].lineStarts[p],d={line:p,column:m},E=new S(0,g,d,this.t(0,g,d),u-r);return this.g=d,[E]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,r=0){let t=this.root,g="";const u=this.h.get2(i);if(u){t=u.node;const p=this.B(t,i-u.nodeStartLineNumber-1),m=this.a[t.piece.bufferIndex].buffer,d=this.u(t.piece.bufferIndex,t.piece.start);if(u.nodeStartLineNumber+t.piece.lineFeedCnt===i)g=m.substring(d+p,d+t.piece.length);else{const E=this.B(t,i-u.nodeStartLineNumber);return m.substring(d+p,d+E-r)}}else{let p=0;const m=i;for(;t!==A.$2C;)if(t.left!==A.$2C&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const d=this.B(t,i-t.lf_left-2),E=this.B(t,i-t.lf_left-1),D=this.a[t.piece.bufferIndex].buffer,w=this.u(t.piece.bufferIndex,t.piece.start);return p+=t.size_left,this.h.set({node:t,nodeStartOffset:p,nodeStartLineNumber:m-(i-1-t.lf_left)}),D.substring(w+d,w+E-r)}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const d=this.B(t,i-t.lf_left-2),E=this.a[t.piece.bufferIndex].buffer,D=this.u(t.piece.bufferIndex,t.piece.start);g=E.substring(D+d,D+t.piece.length);break}else i-=t.lf_left+t.piece.lineFeedCnt,p+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==A.$2C;){const p=this.a[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const m=this.B(t,0),d=this.u(t.piece.bufferIndex,t.piece.start);return g+=p.substring(d,d+m-r),g}else{const m=this.u(t.piece.bufferIndex,t.piece.start);g+=p.substr(m,t.piece.length)}t=t.next()}return g}y(){let i=this.root,r=1,t=0;for(;i!==A.$2C;)r+=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;this.b=r,this.c=t,this.h.validate(this.c)}A(i,r){const t=i.piece,g=this.s(i,r),u=g.line-t.start.line;if(this.u(t.bufferIndex,t.end)-this.u(t.bufferIndex,t.start)===r){const p=this.t(i.piece.bufferIndex,t.start,g);if(p!==u)return{index:p,remainder:0}}return{index:u,remainder:g.column}}B(i,r){if(r<0)return 0;const t=i.piece,g=this.a[t.bufferIndex].lineStarts,u=t.start.line+r+1;return u>t.end.line?g[t.end.line]+t.end.column-g[t.start.line]-t.start.column:g[u]-g[t.start.line]-t.start.column}C(i,r){const t=i.piece,g=t.lineFeedCnt,u=this.u(t.bufferIndex,t.end),p=r,m=this.u(t.bufferIndex,p),d=this.t(t.bufferIndex,t.start,p),E=d-g,D=m-u,w=t.length+D;i.piece=new S(t.bufferIndex,t.start,p,d,w),(0,A.$9C)(this,i,D,E)}D(i,r){const t=i.piece,g=t.lineFeedCnt,u=this.u(t.bufferIndex,t.start),p=r,m=this.t(t.bufferIndex,p,t.end),d=this.u(t.bufferIndex,p),E=m-g,D=u-d,w=t.length+D;i.piece=new S(t.bufferIndex,p,t.end,m,w),(0,A.$9C)(this,i,D,E)}E(i,r,t){const g=i.piece,u=g.start,p=g.end,m=g.length,d=g.lineFeedCnt,E=r,D=this.t(g.bufferIndex,g.start,E),w=this.u(g.bufferIndex,r)-this.u(g.bufferIndex,u);i.piece=new S(g.bufferIndex,g.start,E,D,w),(0,A.$9C)(this,i,w-m,D-d);const k=new S(g.bufferIndex,t,p,this.t(g.bufferIndex,t,p),this.u(g.bufferIndex,p)-this.u(g.bufferIndex,t)),P=this.S(i,k);this.N(P)}F(i,r){this.Q(r,i)&&(r+=`
`);const t=this.K()&&this.L(r)&&this.M(i),g=this.a[0].buffer.length;this.a[0].buffer+=r;const u=y(r,!1);for(let P=0;P<u.length;P++)u[P]+=g;if(t){const P=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:g-P}}this.a[0].lineStarts=this.a[0].lineStarts.concat(u.slice(1));const p=this.a[0].lineStarts.length-1,m=this.a[0].buffer.length-this.a[0].lineStarts[p],d={line:p,column:m},E=i.piece.length+r.length,D=i.piece.lineFeedCnt,w=this.t(0,i.piece.start,d),k=w-D;i.piece=new S(i.piece.bufferIndex,i.piece.start,d,w,E),this.g=d,(0,A.$9C)(this,i,r.length,k)}G(i){let r=this.root;const t=this.h.get(i);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:i-t.nodeStartOffset};let g=0;for(;r!==A.$2C;)if(r.size_left>i)r=r.left;else if(r.size_left+r.piece.length>=i){g+=r.size_left;const u={node:r,remainder:i-r.size_left,nodeStartOffset:g};return this.h.set(u),u}else i-=r.size_left+r.piece.length,g+=r.size_left+r.piece.length,r=r.right;return null}H(i,r){let t=this.root,g=0;for(;t!==A.$2C;)if(t.left!==A.$2C&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const u=this.B(t,i-t.lf_left-2),p=this.B(t,i-t.lf_left-1);return g+=t.size_left,{node:t,remainder:Math.min(u+r-1,p),nodeStartOffset:g}}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const u=this.B(t,i-t.lf_left-2);if(u+r-1<=t.piece.length)return{node:t,remainder:u+r-1,nodeStartOffset:g};r-=t.piece.length-u;break}else i-=t.lf_left+t.piece.lineFeedCnt,g+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==A.$2C;){if(t.piece.lineFeedCnt>0){const u=this.B(t,0),p=this.J(t);return{node:t,remainder:Math.min(r-1,u),nodeStartOffset:p}}else if(t.piece.length>=r-1){const u=this.J(t);return{node:t,remainder:r-1,nodeStartOffset:u}}else r-=t.piece.length;t=t.next()}return null}I(i,r){if(i.piece.lineFeedCnt<1)return-1;const t=this.a[i.piece.bufferIndex],g=this.u(i.piece.bufferIndex,i.piece.start)+r;return t.buffer.charCodeAt(g)}J(i){if(!i)return 0;let r=i.size_left;for(;i!==this.root;)i.parent.right===i&&(r+=i.parent.size_left+i.parent.piece.length),i=i.parent;return r}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===A.$2C||i.piece.lineFeedCnt===0)return!1;const r=i.piece,t=this.a[r.bufferIndex].lineStarts,g=r.start.line,u=t[g]+r.start.column;return g===t.length-1||t[g+1]>u+1?!1:this.a[r.bufferIndex].buffer.charCodeAt(u)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===A.$2C||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const r=i.prev();this.M(r)&&this.P(r,i)}}O(i){if(this.K()&&this.M(i)){const r=i.next();this.L(r)&&this.P(i,r)}}P(i,r){const t=[],g=this.a[i.piece.bufferIndex].lineStarts;let u;i.piece.end.column===0?u={line:i.piece.end.line-1,column:g[i.piece.end.line]-g[i.piece.end.line-1]-1}:u={line:i.piece.end.line,column:i.piece.end.column-1};const p=i.piece.length-1,m=i.piece.lineFeedCnt-1;i.piece=new S(i.piece.bufferIndex,i.piece.start,u,m,p),(0,A.$9C)(this,i,-1,-1),i.piece.length===0&&t.push(i);const d={line:r.piece.start.line+1,column:0},E=r.piece.length-1,D=this.t(r.piece.bufferIndex,d,r.piece.end);r.piece=new S(r.piece.bufferIndex,d,r.piece.end,D,E),(0,A.$9C)(this,r,-1,-1),r.piece.length===0&&t.push(r);const w=this.w(`\r
`);this.S(i,w[0]);for(let k=0;k<t.length;k++)(0,A.$7C)(this,t[k])}Q(i,r){if(this.K()&&this.M(i)){const t=r.next();if(this.L(t)){if(i+=`
`,t.piece.length===1)(0,A.$7C)(this,t);else{const g=t.piece,u={line:g.start.line+1,column:0},p=g.length-1,m=this.t(g.bufferIndex,u,g.end);t.piece=new S(g.bufferIndex,u,g.end,m,p),(0,A.$9C)(this,t,-1,-1)}return!0}}return!1}iterate(i,r){if(i===A.$2C)return r(A.$2C);const t=this.iterate(i.left,r);return t&&r(i)&&this.iterate(i.right,r)}R(i){if(i===A.$2C)return"";const r=this.a[i.piece.bufferIndex],t=i.piece,g=this.u(t.bufferIndex,t.start),u=this.u(t.bufferIndex,t.end);return r.buffer.substring(g,u)}getPieceContent(i){const r=this.a[i.bufferIndex],t=this.u(i.bufferIndex,i.start),g=this.u(i.bufferIndex,i.end);return r.buffer.substring(t,g)}S(i,r){const t=new A.$1C(r,A.NodeColor.Red);if(t.left=A.$2C,t.right=A.$2C,t.parent=A.$2C,t.size_left=0,t.lf_left=0,this.root===A.$2C)this.root=t,t.color=A.NodeColor.Black;else if(i.right===A.$2C)i.right=t,t.parent=i;else{const u=(0,A.$3C)(i.right);u.left=t,t.parent=u}return(0,A.$8C)(this,t),t}T(i,r){const t=new A.$1C(r,A.NodeColor.Red);if(t.left=A.$2C,t.right=A.$2C,t.parent=A.$2C,t.size_left=0,t.lf_left=0,this.root===A.$2C)this.root=t,t.color=A.NodeColor.Black;else if(i.left===A.$2C)i.left=t,t.parent=i;else{const g=(0,A.$4C)(i.left);g.right=t,t.parent=g}return(0,A.$8C)(this,t),t}U(i){let r="";return this.iterate(i,t=>(r+=this.R(t),!0)),r}}e.$iD=s}),define(Ne[160],Oe([1,0,6,12,32,52,100,152,154,4]),function(we,e,v,I,C,N,A,T,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jD=void 0,I=Ve(I);class R extends a.$Tc{constructor(c,S,f,n,o,s,l){super(),this.m=this.B(new v.$je),this.onDidChangeContent=this.m.event,this.f=S,this.j=!s,this.g=n,this.h=o,this.c=new A.$iD(c,f,l)}equals(c){return!(c instanceof R)||this.f!==c.f||this.getEOL()!==c.getEOL()?!1:this.c.equal(c.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(c){return this.c.createSnapshot(c?this.f:"")}getOffsetAt(c,S){return this.c.getOffsetAt(c,S)}getPositionAt(c){return this.c.getPositionAt(c)}getRangeAt(c,S){const f=c+S,n=this.getPositionAt(c),o=this.getPositionAt(f);return new C.$Kt(n.lineNumber,n.column,o.lineNumber,o.column)}getValueInRange(c,S=N.EndOfLinePreference.TextDefined){if(c.isEmpty())return"";const f=this.n(S);return this.c.getValueInRange(c,f)}getValueLengthInRange(c,S=N.EndOfLinePreference.TextDefined){if(c.isEmpty())return 0;if(c.startLineNumber===c.endLineNumber)return c.endColumn-c.startColumn;const f=this.getOffsetAt(c.startLineNumber,c.startColumn),n=this.getOffsetAt(c.endLineNumber,c.endColumn);let o=0;const s=this.n(S),l=this.getEOL();if(s.length!==l.length){const i=s.length-l.length,r=c.endLineNumber-c.startLineNumber;o=i*r}return n-f+o}getCharacterCountInRange(c,S=N.EndOfLinePreference.TextDefined){if(this.j){let f=0;const n=c.startLineNumber,o=c.endLineNumber;for(let s=n;s<=o;s++){const l=this.getLineContent(s),i=s===n?c.startColumn-1:0,r=s===o?c.endColumn-1:l.length;for(let t=i;t<r;t++)I.$Hf(l.charCodeAt(t))?(f=f+1,t=t+1):f=f+1}return f+=this.n(S).length*(o-n),f}return this.getValueLengthInRange(c,S)}getNearestChunk(c){return this.c.getNearestChunk(c)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(c){return this.c.getLineContent(c)}getLineCharCode(c,S){return this.c.getLineCharCode(c,S)}getCharCode(c){return this.c.getCharCode(c)}getLineLength(c){return this.c.getLineLength(c)}getLineMinColumn(c){return 1}getLineMaxColumn(c){return this.getLineLength(c)+1}getLineFirstNonWhitespaceColumn(c){const S=I.$sf(this.getLineContent(c));return S===-1?0:S+1}getLineLastNonWhitespaceColumn(c){const S=I.$uf(this.getLineContent(c));return S===-1?0:S+2}n(c){switch(c){case N.EndOfLinePreference.LF:return`
`;case N.EndOfLinePreference.CRLF:return`\r
`;case N.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(c){this.c.setEOL(c)}applyEdits(c,S,f){let n=this.g,o=this.h,s=this.j,l=!0,i=[];for(let d=0;d<c.length;d++){const E=c[d];l&&E._isTracked&&(l=!1);const D=E.range;if(E.text){let b=!0;s||(b=!I.$Sf(E.text),s=b),!n&&b&&(n=I.$Rf(E.text)),!o&&b&&(o=I.$Uf(E.text))}let w="",k=0,P=0,h=0;if(E.text){let b;[k,P,h,b]=(0,T.$uu)(E.text);const M=this.getEOL(),O=M===`\r
`?T.StringEOL.CRLF:T.StringEOL.LF;b===T.StringEOL.Unknown||b===O?w=E.text:w=E.text.replace(/\r\n|\r|\n/g,M)}i[d]={sortIndex:d,identifier:E.identifier||null,range:D,rangeOffset:this.getOffsetAt(D.startLineNumber,D.startColumn),rangeLength:this.getValueLengthInRange(D),text:w,eolCount:k,firstLineLength:P,lastLineLength:h,forceMoveMarkers:!!E.forceMoveMarkers,isAutoWhitespaceEdit:E.isAutoWhitespaceEdit||!1}}i.sort(R.u);let r=!1;for(let d=0,E=i.length-1;d<E;d++){const D=i[d].range.getEndPosition(),w=i[d+1].range.getStartPosition();if(w.isBeforeOrEqual(D)){if(w.isBefore(D))throw new Error("Overlapping ranges are not allowed!");r=!0}}l&&(i=this.s(i));const t=f||S?R._getInverseEditRanges(i):[],g=[];if(S)for(let d=0;d<i.length;d++){const E=i[d],D=t[d];if(E.isAutoWhitespaceEdit&&E.range.isEmpty())for(let w=D.startLineNumber;w<=D.endLineNumber;w++){let k="";w===D.startLineNumber&&(k=this.getLineContent(E.range.startLineNumber),I.$sf(k)!==-1)||g.push({lineNumber:w,oldContent:k})}}let u=null;if(f){let d=0;u=[];for(let E=0;E<i.length;E++){const D=i[E],w=t[E],k=this.getValueInRange(D.range),P=D.rangeOffset+d;d+=D.text.length-k.length,u[E]={sortIndex:D.sortIndex,identifier:D.identifier,range:w,text:k,textChange:new $.$au(D.rangeOffset,k,P,D.text)}}r||u.sort((E,D)=>E.sortIndex-D.sortIndex)}this.g=n,this.h=o,this.j=s;const p=this.t(i);let m=null;if(S&&g.length>0){g.sort((d,E)=>E.lineNumber-d.lineNumber),m=[];for(let d=0,E=g.length;d<E;d++){const D=g[d].lineNumber;if(d>0&&g[d-1].lineNumber===D)continue;const w=g[d].oldContent,k=this.getLineContent(D);k.length===0||k===w||I.$sf(k)!==-1||m.push(D)}}return this.m.fire(),new N.$dw(u,p,m)}s(c){return c.length<1e3?c:[this._toSingleEditOperation(c)]}_toSingleEditOperation(c){let S=!1;const f=c[0].range,n=c[c.length-1].range,o=new C.$Kt(f.startLineNumber,f.startColumn,n.endLineNumber,n.endColumn);let s=f.startLineNumber,l=f.startColumn;const i=[];for(let p=0,m=c.length;p<m;p++){const d=c[p],E=d.range;S=S||d.forceMoveMarkers,i.push(this.getValueInRange(new C.$Kt(s,l,E.startLineNumber,E.startColumn))),d.text.length>0&&i.push(d.text),s=E.endLineNumber,l=E.endColumn}const r=i.join(""),[t,g,u]=(0,T.$uu)(r);return{sortIndex:0,identifier:c[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,N.EndOfLinePreference.TextDefined),text:r,eolCount:t,firstLineLength:g,lastLineLength:u,forceMoveMarkers:S,isAutoWhitespaceEdit:!1}}t(c){c.sort(R.w);const S=[];for(let f=0;f<c.length;f++){const n=c[f],o=n.range.startLineNumber,s=n.range.startColumn,l=n.range.endLineNumber,i=n.range.endColumn;if(o===l&&s===i&&n.text.length===0)continue;n.text?(this.c.delete(n.rangeOffset,n.rangeLength),this.c.insert(n.rangeOffset,n.text,!0)):this.c.delete(n.rangeOffset,n.rangeLength);const r=new C.$Kt(o,s,l,i);S.push({range:r,rangeLength:n.rangeLength,text:n.text,rangeOffset:n.rangeOffset,forceMoveMarkers:n.forceMoveMarkers})}return S}findMatchesLineByLine(c,S,f,n){return this.c.findMatchesLineByLine(c,S,f,n)}getPieceTree(){return this.c}static _getInverseEditRange(c,S){const f=c.startLineNumber,n=c.startColumn,[o,s,l]=(0,T.$uu)(S);let i;if(S.length>0){const r=o+1;r===1?i=new C.$Kt(f,n,f,n+s):i=new C.$Kt(f,n,f+r-1,l+1)}else i=new C.$Kt(f,n,f,n);return i}static _getInverseEditRanges(c){const S=[];let f=0,n=0,o=null;for(let s=0,l=c.length;s<l;s++){const i=c[s];let r,t;o?o.range.endLineNumber===i.range.startLineNumber?(r=f,t=n+(i.range.startColumn-o.range.endColumn)):(r=f+(i.range.startLineNumber-o.range.endLineNumber),t=i.range.startColumn):(r=i.range.startLineNumber,t=i.range.startColumn);let g;if(i.text.length>0){const u=i.eolCount+1;u===1?g=new C.$Kt(r,t,r,t+i.firstLineLength):g=new C.$Kt(r,t,r+u-1,i.lastLineLength+1)}else g=new C.$Kt(r,t,r,t);f=g.endLineNumber,n=g.endColumn,S.push(g),o=i}return S}static u(c,S){const f=C.$Kt.compareRangesUsingEnds(c.range,S.range);return f===0?c.sortIndex-S.sortIndex:f}static w(c,S){const f=C.$Kt.compareRangesUsingEnds(c.range,S.range);return f===0?S.sortIndex-c.sortIndex:-f}}e.$jD=R}),define(Ne[161],Oe([1,0,27,12,52,100,160]),function(we,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kD=void 0,I=Ve(I);class T{constructor(R,y,c,S,f,n,o,s,l){this.a=R,this.b=y,this.c=c,this.d=S,this.e=f,this.f=n,this.g=o,this.h=s,this.j=l}k(R){const y=this.c+this.d+this.e,c=this.c+this.e;return y===0?R===C.DefaultEndOfLine.LF?`
`:`\r
`:c>y/2?`\r
`:`
`}create(R){const y=this.k(R),c=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let f=0,n=c.length;f<n;f++){const o=c[f].buffer.replace(/\r\n|\r|\n/g,y),s=(0,N.$eD)(o);c[f]=new N.$hD(o,s)}const S=new A.$jD(c,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:S,disposable:S}}getFirstLineText(R){return this.a[0].buffer.substr(0,R).split(/\r\n|\r|\n/)[0]}}class ${constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(R){if(R.length===0)return;this.a.length===0&&I.$3f(R)&&(this.b=I.$2f,R=R.substr(1));const y=R.charCodeAt(R.length-1);y===v.CharCode.CarriageReturn||y>=55296&&y<=56319?(this.m(R.substr(0,R.length-1),!1),this.c=!0,this.d=y):(this.m(R,!1),this.c=!1,this.d=y)}m(R,y){!y&&R.length===0||(this.c?this.n(String.fromCharCode(this.d)+R):this.n(R))}n(R){const y=(0,N.$fD)(this.e,R);this.a.push(new N.$hD(R,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=I.$Rf(R)),this.k||(this.k=I.$Uf(R)))}finish(R=!0){return this.o(),new T(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,R)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const R=this.a[this.a.length-1];R.buffer+=String.fromCharCode(this.d);const y=(0,N.$eD)(R.buffer);R.lineStarts=y,this.d===v.CharCode.CarriageReturn&&this.f++}}}e.$kD=$}),define(Ne[103],Oe([1,0,22,20]),function(we,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydb=$,e.$zdb=R,I=Ve(I);var C;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(C||(C={}));function N(y){for(let c=0,S=y.length;c<S;c+=4){const f=y[c+0],n=y[c+1],o=y[c+2],s=y[c+3];y[c+0]=s,y[c+1]=o,y[c+2]=n,y[c+3]=f}}function A(y){const c=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return I.$E()||N(c),v.$Le.wrap(c)}function T(y){const c=y.buffer;if(I.$E()||N(c),c.byteOffset%4===0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const S=new Uint8Array(c.byteLength);return S.set(c),new Uint32Array(S.buffer,S.byteOffset,S.length/4)}}function $(y){const c=new Uint32Array(a(y));let S=0;if(c[S++]=y.id,y.type==="full")c[S++]=C.Full,c[S++]=y.data.length,c.set(y.data,S),S+=y.data.length;else{c[S++]=C.Delta,c[S++]=y.deltas.length;for(const f of y.deltas)c[S++]=f.start,c[S++]=f.deleteCount,f.data?(c[S++]=f.data.length,c.set(f.data,S),S+=f.data.length):c[S++]=0}return A(c)}function a(y){let c=0;if(c+=2,y.type==="full")c+=1+y.data.length;else{c+=1,c+=3*y.deltas.length;for(const S of y.deltas)S.data&&(c+=S.data.length)}return c}function R(y){const c=T(y);let S=0;const f=c[S++];if(c[S++]===C.Full){const l=c[S++],i=c.subarray(S,S+l);return S+=l,{id:f,type:"full",data:i}}const o=c[S++],s=[];for(let l=0;l<o;l++){const i=c[S++],r=c[S++],t=c[S++];let g;t>0&&(g=c.subarray(S,S+t),S+=t),s[l]={start:i,deleteCount:r,data:g}}return{id:f,type:"delta",deltas:s}}}),define(Ne[162],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n_=e.$m_=void 0;class v{constructor(){this.a=new Map}removeDragOperationTransfer(N){if(N&&this.a.has(N)){const A=this.a.get(N);return this.a.delete(N),A}}addDragOperationTransfer(N,A){this.a.set(N,A)}}e.$m_=v;class I{constructor(N){this.identifier=N}}e.$n_=I}),define(Ne[163],Oe([1,0,6,4,9]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=void 0,e.$mj=R,C=Ve(C);class N extends I.$Tc{constructor(c,S="",f="",n=!0,o){super(),this.j=this.B(new v.$je),this.onDidChange=this.j.event,this.z=!0,this.m=c,this.n=S,this.w=f,this.z=n,this.D=o}get id(){return this.m}get label(){return this.n}set label(c){this.F(c)}F(c){this.n!==c&&(this.n=c,this.j.fire({label:c}))}get tooltip(){return this.u||""}set tooltip(c){this.G(c)}G(c){this.u!==c&&(this.u=c,this.j.fire({tooltip:c}))}get class(){return this.w}set class(c){this.H(c)}H(c){this.w!==c&&(this.w=c,this.j.fire({class:c}))}get enabled(){return this.z}set enabled(c){this.I(c)}I(c){this.z!==c&&(this.z=c,this.j.fire({enabled:c}))}get checked(){return this.C}set checked(c){this.J(c)}J(c){this.C!==c&&(this.C=c,this.j.fire({checked:c}))}async run(c,S){this.D&&await this.D(c)}}e.$hj=N;class A extends I.$Tc{constructor(){super(...arguments),this.f=this.B(new v.$je),this.onWillRun=this.f.event,this.m=this.B(new v.$je),this.onDidRun=this.m.event}async run(c,S){if(!c.enabled)return;this.f.fire({action:c});let f;try{await this.u(c,S)}catch(n){f=n}this.m.fire({action:c,error:f})}async u(c,S){await c.run(S)}}e.$ij=A;class T{constructor(){this.id=T.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...c){let S=[];for(const f of c)f.length&&(S.length?S=[...S,new T,...f]:S=f);return S}static{this.ID="vs.actions.separator"}async run(){}}e.$jj=T;class ${get actions(){return this.a}constructor(c,S,f,n){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=c,this.label=S,this.class=n,this.a=f}async run(){}}e.$kj=$;class a extends N{static{this.ID="vs.actions.empty"}constructor(){super(a.ID,C.localize(12880,null),void 0,!1)}}e.$lj=a;function R(y){return{id:y.id,label:y.label,tooltip:y.tooltip??y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...c)=>y.run(...c)}}}),define(Ne[164],Oe([1,0,9]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=a,e.$Ym=R,e.$Zm=y;const I=60,C=I*60,N=C*24,A=N*7,T=N*30,$=N*365;function a(c,S,f,n){typeof c!="number"&&(c=c.getTime());const o=Math.round((new Date().getTime()-c)/1e3);if(o<-30)return(0,v.localize)(12817,null,a(new Date().getTime()+o*1e3,!1));if(!n&&o<30)return(0,v.localize)(12818,null);let s;return o<I?(s=o,S?s===1?f?(0,v.localize)(12819,null,s):(0,v.localize)(12820,null,s):f?(0,v.localize)(12821,null,s):(0,v.localize)(12822,null,s):s===1?f?(0,v.localize)(12823,null,s):(0,v.localize)(12824,null,s):f?(0,v.localize)(12825,null,s):(0,v.localize)(12826,null,s)):o<C?(s=Math.floor(o/I),S?s===1?f?(0,v.localize)(12827,null,s):(0,v.localize)(12828,null,s):f?(0,v.localize)(12829,null,s):(0,v.localize)(12830,null,s):s===1?f?(0,v.localize)(12831,null,s):(0,v.localize)(12832,null,s):f?(0,v.localize)(12833,null,s):(0,v.localize)(12834,null,s)):o<N?(s=Math.floor(o/C),S?s===1?f?(0,v.localize)(12835,null,s):(0,v.localize)(12836,null,s):f?(0,v.localize)(12837,null,s):(0,v.localize)(12838,null,s):s===1?f?(0,v.localize)(12839,null,s):(0,v.localize)(12840,null,s):f?(0,v.localize)(12841,null,s):(0,v.localize)(12842,null,s)):o<A?(s=Math.floor(o/N),S?s===1?(0,v.localize)(12843,null,s):(0,v.localize)(12844,null,s):s===1?(0,v.localize)(12845,null,s):(0,v.localize)(12846,null,s)):o<T?(s=Math.floor(o/A),S?s===1?f?(0,v.localize)(12847,null,s):(0,v.localize)(12848,null,s):f?(0,v.localize)(12849,null,s):(0,v.localize)(12850,null,s):s===1?f?(0,v.localize)(12851,null,s):(0,v.localize)(12852,null,s):f?(0,v.localize)(12853,null,s):(0,v.localize)(12854,null,s)):o<$?(s=Math.floor(o/T),S?s===1?f?(0,v.localize)(12855,null,s):(0,v.localize)(12856,null,s):f?(0,v.localize)(12857,null,s):(0,v.localize)(12858,null,s):s===1?f?(0,v.localize)(12859,null,s):(0,v.localize)(12860,null,s):f?(0,v.localize)(12861,null,s):(0,v.localize)(12862,null,s)):(s=Math.floor(o/$),S?s===1?f?(0,v.localize)(12863,null,s):(0,v.localize)(12864,null,s):f?(0,v.localize)(12865,null,s):(0,v.localize)(12866,null,s):s===1?f?(0,v.localize)(12867,null,s):(0,v.localize)(12868,null,s):f?(0,v.localize)(12869,null,s):(0,v.localize)(12870,null,s))}function R(c,S){const f=Math.abs(c/1e3);return f<1?S?(0,v.localize)(12871,null,c):(0,v.localize)(12872,null,c):f<I?S?(0,v.localize)(12873,null,Math.round(c)/1e3):(0,v.localize)(12874,null,Math.round(c)/1e3):f<C?S?(0,v.localize)(12875,null,Math.round(c/(1e3*I))):(0,v.localize)(12876,null,Math.round(c/(1e3*I))):f<N?S?(0,v.localize)(12877,null,Math.round(c/(1e3*C))):(0,v.localize)(12878,null,Math.round(c/(1e3*C))):(0,v.localize)(12879,null,Math.round(c/(1e3*N)))}function y(c){return c.getFullYear()+"-"+String(c.getMonth()+1).padStart(2,"0")+"-"+String(c.getDate()).padStart(2,"0")+"T"+String(c.getHours()).padStart(2,"0")+":"+String(c.getMinutes()).padStart(2,"0")+":"+String(c.getSeconds()).padStart(2,"0")+"."+(c.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ne[42],Oe([1,0,17,14,9]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=$,e.$oj=a,e.$pj=R,v=Ve(v),I=Ve(I),C=Ve(C);function N(y,c){return c&&(y.stack||y.stacktrace)?C.localize(12811,null,T(y),A(y.stack)||A(y.stacktrace)):T(y)}function A(y){return Array.isArray(y)?y.join(`
`):y}function T(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?C.localize(12812,null,y.message):y.message||C.localize(12813,null)}function $(y=null,c=!1){if(!y)return C.localize(12814,null);if(Array.isArray(y)){const S=v.$Gb(y),f=$(S[0],c);return S.length>1?C.localize(12815,null,f,S.length):f}if(I.$cg(y))return y;if(y.detail){const S=y.detail;if(S.error)return N(S.error,c);if(S.exception)return N(S.exception,c)}return y.stack?N(y,c):y.message?y.message:C.localize(12816,null)}function a(y){const c=y;return c instanceof Error&&Array.isArray(c.actions)}function R(y,c){let S;return typeof y=="string"?S=new Error(y):S=y,S.actions=c,S}}),define(Ne[165],Oe([1,0,27,13,9]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.TokenType=void 0;var N;(function(R){R[R.LParen=0]="LParen",R[R.RParen=1]="RParen",R[R.Neg=2]="Neg",R[R.Eq=3]="Eq",R[R.NotEq=4]="NotEq",R[R.Lt=5]="Lt",R[R.LtEq=6]="LtEq",R[R.Gt=7]="Gt",R[R.GtEq=8]="GtEq",R[R.RegexOp=9]="RegexOp",R[R.RegexStr=10]="RegexStr",R[R.True=11]="True",R[R.False=12]="False",R[R.In=13]="In",R[R.Not=14]="Not",R[R.And=15]="And",R[R.Or=16]="Or",R[R.Str=17]="Str",R[R.QuotedStr=18]="QuotedStr",R[R.Error=19]="Error",R[R.EOF=20]="EOF"})(N||(e.TokenType=N={}));function A(...R){switch(R.length){case 1:return(0,C.localize)(11418,null,R[0]);case 2:return(0,C.localize)(11419,null,R[0],R[1]);case 3:return(0,C.localize)(11420,null,R[0],R[1],R[2]);default:return}}const T=(0,C.localize)(11421,null),$=(0,C.localize)(11422,null);class a{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case N.LParen:return"(";case N.RParen:return")";case N.Neg:return"!";case N.Eq:return y.isTripleEq?"===":"==";case N.NotEq:return y.isTripleEq?"!==":"!=";case N.Lt:return"<";case N.LtEq:return"<=";case N.Gt:return">=";case N.GtEq:return">=";case N.RegexOp:return"=~";case N.RegexStr:return y.lexeme;case N.True:return"true";case N.False:return"false";case N.In:return"in";case N.Not:return"not";case N.And:return"&&";case N.Or:return"||";case N.Str:return y.lexeme;case N.QuotedStr:return y.lexeme;case N.Error:return y.lexeme;case N.EOF:return"EOF";default:throw(0,I.$7)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",N.Not],["in",N.In],["false",N.False],["true",N.True]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case v.CharCode.OpenParen:this.k(N.LParen);break;case v.CharCode.CloseParen:this.k(N.RParen);break;case v.CharCode.ExclamationMark:if(this.h(v.CharCode.Equals)){const c=this.h(v.CharCode.Equals);this.f.push({type:N.NotEq,offset:this.d,isTripleEq:c})}else this.k(N.Neg);break;case v.CharCode.SingleQuote:this.o();break;case v.CharCode.Slash:this.q();break;case v.CharCode.Equals:if(this.h(v.CharCode.Equals)){const c=this.h(v.CharCode.Equals);this.f.push({type:N.Eq,offset:this.d,isTripleEq:c})}else this.h(v.CharCode.Tilde)?this.k(N.RegexOp):this.l(A("==","=~"));break;case v.CharCode.LessThan:this.k(this.h(v.CharCode.Equals)?N.LtEq:N.Lt);break;case v.CharCode.GreaterThan:this.k(this.h(v.CharCode.Equals)?N.GtEq:N.Gt);break;case v.CharCode.Ampersand:this.h(v.CharCode.Ampersand)?this.k(N.And):this.l(A("&&"));break;case v.CharCode.Pipe:this.h(v.CharCode.Pipe)?this.k(N.Or):this.l(A("||"));break;case v.CharCode.Space:case v.CharCode.CarriageReturn:case v.CharCode.Tab:case v.CharCode.LineFeed:case v.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(N.EOF),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?v.CharCode.Null:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const c=this.d,S=this.c.substring(this.d,this.e),f={type:N.Error,offset:this.d,lexeme:S};this.g.push({offset:c,lexeme:S,additionalInfo:y}),this.f.push(f)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const c=this.c.substring(this.d,this.e),S=a.b.get(c);S?this.k(S):this.f.push({type:N.Str,lexeme:c,offset:this.d})}}o(){for(;this.j()!==v.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(T);return}this.i(),this.f.push({type:N.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,c=!1,S=!1;for(;;){if(y>=this.c.length){this.e=y,this.l($);return}const n=this.c.charCodeAt(y);if(c)c=!1;else if(n===v.CharCode.Slash&&!S){y++;break}else n===v.CharCode.OpenSquareBracket?S=!0:n===v.CharCode.Backslash?c=!0:n===v.CharCode.CloseSquareBracket&&(S=!1);y++}for(;y<this.c.length&&a.a.has(this.c.charCodeAt(y));)y++;this.e=y;const f=this.c.substring(this.d,this.e);this.f.push({type:N.RegexStr,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$xj=a}),define(Ne[104],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const v={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(v)}),define(Ne[73],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=void 0;class v{constructor(C,N=[],A=!1){this.ctor=C,this.staticArguments=N,this.supportsDelayedInstantiation=A}}e.$zi=v}),define(Ne[60],Oe([1,0,73]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ns=N,e.$Os=A;const I=[];var C;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function N(T,$,a){$ instanceof v.$zi||($=new v.$zi($,[],!!a)),I.push([T,$])}function A(){return I}}),define(Ne[166],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=e.$qr=void 0;class v{constructor(N,A){this.key=N,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$qr=v;class I{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const A of this.a.values())A.outgoing.size===0&&N.push(A);return N}insertEdge(N,A){const T=this.lookupOrInsertNode(N),$=this.lookupOrInsertNode(A);T.outgoing.set($.key,$),$.incoming.set(T.key,T)}removeNode(N){const A=this.b(N);this.a.delete(A);for(const T of this.a.values())T.outgoing.delete(A),T.incoming.delete(A)}lookupOrInsertNode(N){const A=this.b(N);let T=this.a.get(A);return T||(T=new v(A,N),this.a.set(A,T)),T}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[A,T]of this.a)N.push(`${A}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,A]of this.a){const T=new Set([N]),$=this.c(A,T);if($)return $}}c(N,A){for(const[T,$]of N.outgoing){if(A.has(T))return[...A,T].join(" -> ");A.add(T);const a=this.c($,A);if(a)return a;A.delete(T)}}}e.$rr=I}),define(Ne[3],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=e._util=void 0,e.$Ci=C,e.$Di=N;var v;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function T($){return $[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=T})(v||(e._util=v={})),e.$Bi=C("instantiationService");function I(A,T,$){T[v.DI_TARGET]===T?T[v.DI_DEPENDENCIES].push({id:A,index:$}):(T[v.DI_DEPENDENCIES]=[{id:A,index:$}],T[v.DI_TARGET]=T)}function C(A){if(v.serviceIds.has(A))return v.serviceIds.get(A);const T=function($,a,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");I(T,$,R)};return T.toString=()=>A,v.serviceIds.set(A,T),T}function N(A){return A}}),define(Ne[43],Oe([1,0,14,2,3]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$9i=void 0,e.$0i=N,e.$$i=A,e.$_i=$,e.$aj=a,e.$bj=R,e.$cj=y,e.$dj=c,e.$ej=f,e.$fj=n,e.$gj=o,v=Ve(v),e.$9i=(0,C.$Ci)("configurationService");function N(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof I.URI)}function A(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof I.URI)}var T;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(T||(e.ConfigurationTarget=T={}));function $(s){switch(s){case T.APPLICATION:return"APPLICATION";case T.USER:return"USER";case T.USER_LOCAL:return"USER_LOCAL";case T.USER_REMOTE:return"USER_REMOTE";case T.WORKSPACE:return"WORKSPACE";case T.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case T.DEFAULT:return"DEFAULT";case T.MEMORY:return"MEMORY"}}function a(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}function R(s,l){const i=Object.create(null);for(const r in s)y(i,r,s[r],l);return i}function y(s,l,i,r){const t=l.split("."),g=t.pop();let u=s;for(let p=0;p<t.length;p++){const m=t[p];let d=u[m];switch(typeof d){case"undefined":d=u[m]=Object.create(null);break;case"object":if(d===null){r(`Ignoring ${l} as ${t.slice(0,p+1).join(".")} is null`);return}break;default:r(`Ignoring ${l} as ${t.slice(0,p+1).join(".")} is ${JSON.stringify(d)}`);return}u=d}if(typeof u=="object"&&u!==null)try{u[g]=i}catch{r(`Ignoring ${l} as ${t.join(".")} is ${JSON.stringify(u)}`)}else r(`Ignoring ${l} as ${t.join(".")} is ${JSON.stringify(u)}`)}function c(s,l){const i=l.split(".");S(s,i)}function S(s,l){const i=l.shift();if(l.length===0){delete s[i];return}if(Object.keys(s).indexOf(i)!==-1){const r=s[i];typeof r=="object"&&!Array.isArray(r)&&(S(r,l),Object.keys(r).length===0&&delete s[i])}}function f(s,l,i){function r(u,p){let m=u;for(const d of p){if(typeof m!="object"||m===null)return;m=m[d]}return m}const t=l.split("."),g=r(s,t);return typeof g>"u"?i:g}function n(s,l,i){Object.keys(l).forEach(r=>{r!=="__proto__"&&(r in s?v.$eg(s[r])&&v.$eg(l[r])?n(s[r],l[r],i):i&&(s[r]=l[r]):s[r]=l[r])})}function o(s){return s.replace(/[\[\]]/g,"")}}),define(Ne[31],Oe([1,0,27,20,12,165,3,9,13]),function(we,e,v,I,C,N,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Aj=e.$zj=e.ContextKeyExprType=void 0,e.$yj=R,e.$Bj=p,e.$Cj=m,e.$Vj=oe;const a=new Map;a.set("false",!1),a.set("true",!0),a.set("isMac",I.$k),a.set("isLinux",I.$l),a.set("isWindows",I.$j),a.set("isWeb",I.$p),a.set("isMacNative",I.$k&&!I.$p),a.set("isEdge",I.$I),a.set("isFirefox",I.$G),a.set("isChrome",I.$F),a.set("isSafari",I.$H);function R(X,V){if(a.get(X)!==void 0)throw(0,$.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");a.set(X,V)}const y=Object.prototype.hasOwnProperty;var c;(function(X){X[X.False=0]="False",X[X.True=1]="True",X[X.Defined=2]="Defined",X[X.Not=3]="Not",X[X.Equals=4]="Equals",X[X.NotEquals=5]="NotEquals",X[X.And=6]="And",X[X.Regex=7]="Regex",X[X.NotRegex=8]="NotRegex",X[X.Or=9]="Or",X[X.In=10]="In",X[X.NotIn=11]="NotIn",X[X.Greater=12]="Greater",X[X.GreaterEquals=13]="GreaterEquals",X[X.Smaller=14]="Smaller",X[X.SmallerEquals=15]="SmallerEquals"})(c||(e.ContextKeyExprType=c={}));const S={regexParsingWithErrorRecovery:!0},f=(0,T.localize)(11432,null),n=(0,T.localize)(11433,null),o=(0,T.localize)(11434,null),s=(0,T.localize)(11435,null),l=(0,T.localize)(11436,null),i=(0,T.localize)(11437,null),r=(0,T.localize)(11438,null),t=(0,T.localize)(11439,null);class g{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(V=S){this.k=V,this.d=new N.$xj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(V){if(V===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:n});return}this.f=this.d.reset(V).scan(),this.g=0,this.h=[];try{const te=this.l();if(!this.E()){const ve=this.D(),ce=ve.type===N.TokenType.Str?i:void 0;throw this.h.push({message:l,offset:ve.offset,lexeme:N.$xj.getLexeme(ve),additionalInfo:ce}),g.c}return te}catch(te){if(te!==g.c)throw te;return}}l(){return this.m()}m(){const V=[this.o()];for(;this.y(N.TokenType.Or);){const te=this.o();V.push(te)}return V.length===1?V[0]:u.or(...V)}o(){const V=[this.s()];for(;this.y(N.TokenType.And);){const te=this.s();V.push(te)}return V.length===1?V[0]:u.and(...V)}s(){if(this.y(N.TokenType.Neg)){const V=this.D();switch(V.type){case N.TokenType.True:return this.z(),E.INSTANCE;case N.TokenType.False:return this.z(),D.INSTANCE;case N.TokenType.LParen:{this.z();const te=this.l();return this.A(N.TokenType.RParen,s),te?.negate()}case N.TokenType.Str:return this.z(),M.create(V.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",V)}}return this.t()}t(){const V=this.D();switch(V.type){case N.TokenType.True:return this.z(),u.true();case N.TokenType.False:return this.z(),u.false();case N.TokenType.LParen:{this.z();const te=this.l();return this.A(N.TokenType.RParen,s),te}case N.TokenType.Str:{const te=V.lexeme;if(this.z(),this.y(N.TokenType.RegexOp)){const ce=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ce.type!==N.TokenType.RegexStr)throw this.B("REGEX",ce);const be=ce.lexeme,he=be.lastIndexOf("/"),J=he===be.length-1?void 0:this.w(be.substring(he+1));let x;try{x=new RegExp(be.substring(1,he),J)}catch{throw this.B("REGEX",ce)}return Y.create(te,x)}switch(ce.type){case N.TokenType.RegexStr:case N.TokenType.Error:{const be=[ce.lexeme];this.z();let he=this.D(),J=0;for(let ze=0;ze<ce.lexeme.length;ze++)ce.lexeme.charCodeAt(ze)===v.CharCode.OpenParen?J++:ce.lexeme.charCodeAt(ze)===v.CharCode.CloseParen&&J--;for(;!this.E()&&he.type!==N.TokenType.And&&he.type!==N.TokenType.Or;){switch(he.type){case N.TokenType.LParen:J++;break;case N.TokenType.RParen:J--;break;case N.TokenType.RegexStr:case N.TokenType.QuotedStr:for(let ze=0;ze<he.lexeme.length;ze++)he.lexeme.charCodeAt(ze)===v.CharCode.OpenParen?J++:ce.lexeme.charCodeAt(ze)===v.CharCode.CloseParen&&J--}if(J<0)break;be.push(N.$xj.getLexeme(he)),this.z(),he=this.D()}const x=be.join(""),me=x.lastIndexOf("/"),pe=me===x.length-1?void 0:this.w(x.substring(me+1));let Ae;try{Ae=new RegExp(x.substring(1,me),pe)}catch{throw this.B("REGEX",ce)}return u.regex(te,Ae)}case N.TokenType.QuotedStr:{const be=ce.lexeme;this.z();let he=null;if(!(0,C.$af)(be)){const J=be.indexOf("/"),x=be.lastIndexOf("/");if(J!==x&&J>=0){const me=be.slice(J+1,x),pe=be[x+1]==="i"?"i":"";try{he=new RegExp(me,pe)}catch{throw this.B("REGEX",ce)}}}if(he===null)throw this.B("REGEX",ce);return Y.create(te,he)}default:throw this.B("REGEX",this.D())}}if(this.y(N.TokenType.Not)){this.A(N.TokenType.In,o);const ce=this.u();return u.notIn(te,ce)}switch(this.D().type){case N.TokenType.Eq:{this.z();const ce=this.u();if(this.x().type===N.TokenType.QuotedStr)return u.equals(te,ce);switch(ce){case"true":return u.has(te);case"false":return u.not(te);default:return u.equals(te,ce)}}case N.TokenType.NotEq:{this.z();const ce=this.u();if(this.x().type===N.TokenType.QuotedStr)return u.notEquals(te,ce);switch(ce){case"true":return u.not(te);case"false":return u.has(te);default:return u.notEquals(te,ce)}}case N.TokenType.Lt:return this.z(),B.create(te,this.u());case N.TokenType.LtEq:return this.z(),L.create(te,this.u());case N.TokenType.Gt:return this.z(),F.create(te,this.u());case N.TokenType.GtEq:return this.z(),q.create(te,this.u());case N.TokenType.In:return this.z(),u.in(te,this.u());default:return u.has(te)}}case N.TokenType.EOF:throw this.h.push({message:r,offset:V.offset,lexeme:"",additionalInfo:t}),g.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const V=this.D();switch(V.type){case N.TokenType.Str:case N.TokenType.QuotedStr:return this.z(),V.lexeme;case N.TokenType.True:return this.z(),"true";case N.TokenType.False:return this.z(),"false";case N.TokenType.In:return this.z(),"in";default:return""}}w(V){return V.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(V){return this.C(V)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(V,te){if(this.C(V))return this.z();throw this.B(te,this.D())}B(V,te,ve){const ce=(0,T.localize)(11440,null,V,N.$xj.getLexeme(te)),be=te.offset,he=N.$xj.getLexeme(te);return this.h.push({message:ce,offset:be,lexeme:he,additionalInfo:ve}),g.c}C(V){return this.D().type===V}D(){return this.f[this.g]}E(){return this.D().type===N.TokenType.EOF}}e.$zj=g;class u{static false(){return E.INSTANCE}static true(){return D.INSTANCE}static has(V){return w.create(V)}static equals(V,te){return k.create(V,te)}static notEquals(V,te){return b.create(V,te)}static regex(V,te){return Y.create(V,te)}static in(V,te){return P.create(V,te)}static notIn(V,te){return h.create(V,te)}static not(V){return M.create(V)}static and(...V){return _.create(V,null,!0)}static or(...V){return ge.create(V,null,!0)}static greater(V,te){return F.create(V,te)}static greaterEquals(V,te){return q.create(V,te)}static smaller(V,te){return B.create(V,te)}static smallerEquals(V,te){return L.create(V,te)}static{this.c=new g({regexParsingWithErrorRecovery:!1})}static deserialize(V){return V==null?void 0:this.c.parse(V)}}e.$Aj=u;function p(X){const V=new g({regexParsingWithErrorRecovery:!1});return X.map(te=>(V.parse(te),V.lexingErrors.length>0?V.lexingErrors.map(ve=>({errorMessage:ve.additionalInfo?(0,T.localize)(11441,null,ve.additionalInfo):(0,T.localize)(11442,null),offset:ve.offset,length:ve.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(ve=>({errorMessage:ve.additionalInfo?`${ve.message}. ${ve.additionalInfo}`:ve.message,offset:ve.offset,length:ve.lexeme.length})):[]))}function m(X,V){const te=X?X.substituteConstants():void 0,ve=V?V.substituteConstants():void 0;return!te&&!ve?!0:!te||!ve?!1:te.equals(ve)}function d(X,V){return X.cmp(V)}class E{static{this.INSTANCE=new E}constructor(){this.type=c.False}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return D.INSTANCE}}e.$Dj=E;class D{static{this.INSTANCE=new D}constructor(){this.type=c.True}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return E.INSTANCE}}e.$Ej=D;class w{static create(V,te=null){const ve=a.get(V);return typeof ve=="boolean"?ve?D.INSTANCE:E.INSTANCE:new w(V,te)}constructor(V,te){this.key=V,this.c=te,this.type=c.Defined}cmp(V){return V.type!==this.type?this.type-V.type:ae(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=a.get(this.key);return typeof V=="boolean"?V?D.INSTANCE:E.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Fj=w;class k{static create(V,te,ve=null){if(typeof te=="boolean")return te?w.create(V,ve):M.create(V,ve);const ce=a.get(V);return typeof ce=="boolean"?te===(ce?"true":"false")?D.INSTANCE:E.INSTANCE:new k(V,te,ve)}constructor(V,te,ve){this.c=V,this.d=te,this.f=ve,this.type=c.Equals}cmp(V){return V.type!==this.type?this.type-V.type:$e(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=a.get(this.c);if(typeof V=="boolean"){const te=V?"true":"false";return this.d===te?D.INSTANCE:E.INSTANCE}return this}evaluate(V){return V.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(V){return V.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$Gj=k;class P{static create(V,te){return new P(V,te)}constructor(V,te){this.d=V,this.f=te,this.type=c.In,this.c=null}cmp(V){return V.type!==this.type?this.type-V.type:$e(this.d,this.f,V.d,V.f)}equals(V){return V.type===this.type?this.d===V.d&&this.f===V.f:!1}substituteConstants(){return this}evaluate(V){const te=V.getValue(this.f),ve=V.getValue(this.d);return Array.isArray(te)?te.includes(ve):typeof ve=="string"&&typeof te=="object"&&te!==null?y.call(te,ve):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(V){return V.mapIn(this.d,this.f)}negate(){return this.c||(this.c=h.create(this.d,this.f)),this.c}}e.$Hj=P;class h{static create(V,te){return new h(V,te)}constructor(V,te){this.d=V,this.f=te,this.type=c.NotIn,this.c=P.create(V,te)}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(V){return V.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ij=h;class b{static create(V,te,ve=null){if(typeof te=="boolean")return te?M.create(V,ve):w.create(V,ve);const ce=a.get(V);return typeof ce=="boolean"?te===(ce?"true":"false")?E.INSTANCE:D.INSTANCE:new b(V,te,ve)}constructor(V,te,ve){this.c=V,this.d=te,this.f=ve,this.type=c.NotEquals}cmp(V){return V.type!==this.type?this.type-V.type:$e(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=a.get(this.c);if(typeof V=="boolean"){const te=V?"true":"false";return this.d===te?E.INSTANCE:D.INSTANCE}return this}evaluate(V){return V.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(V){return V.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Jj=b;class M{static create(V,te=null){const ve=a.get(V);return typeof ve=="boolean"?ve?E.INSTANCE:D.INSTANCE:new M(V,te)}constructor(V,te){this.c=V,this.d=te,this.type=c.Not}cmp(V){return V.type!==this.type?this.type-V.type:ae(this.c,V.c)}equals(V){return V.type===this.type?this.c===V.c:!1}substituteConstants(){const V=a.get(this.c);return typeof V=="boolean"?V?E.INSTANCE:D.INSTANCE:this}evaluate(V){return!V.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(V){return V.mapNot(this.c)}negate(){return this.d||(this.d=w.create(this.c,this)),this.d}}e.$Kj=M;function O(X,V){if(typeof X=="string"){const te=parseFloat(X);isNaN(te)||(X=te)}return typeof X=="string"||typeof X=="number"?V(X):E.INSTANCE}class F{static create(V,te,ve=null){return O(te,ce=>new F(V,ce,ve))}constructor(V,te,ve){this.c=V,this.d=te,this.f=ve,this.type=c.Greater}cmp(V){return V.type!==this.type?this.type-V.type:$e(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$Lj=F;class q{static create(V,te,ve=null){return O(te,ce=>new q(V,ce,ve))}constructor(V,te,ve){this.c=V,this.d=te,this.f=ve,this.type=c.GreaterEquals}cmp(V){return V.type!==this.type?this.type-V.type:$e(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Mj=q;class B{static create(V,te,ve=null){return O(te,ce=>new B(V,ce,ve))}constructor(V,te,ve){this.c=V,this.d=te,this.f=ve,this.type=c.Smaller}cmp(V){return V.type!==this.type?this.type-V.type:$e(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Nj=B;class L{static create(V,te,ve=null){return O(te,ce=>new L(V,ce,ve))}constructor(V,te,ve){this.c=V,this.d=te,this.f=ve,this.type=c.SmallerEquals}cmp(V){return V.type!==this.type?this.type-V.type:$e(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Oj=L;class Y{static create(V,te){return new Y(V,te)}constructor(V,te){this.d=V,this.f=te,this.type=c.Regex,this.c=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.d<V.d)return-1;if(this.d>V.d)return 1;const te=this.f?this.f.source:"",ve=V.f?V.f.source:"";return te<ve?-1:te>ve?1:0}equals(V){if(V.type===this.type){const te=this.f?this.f.source:"",ve=V.f?V.f.source:"";return this.d===V.d&&te===ve}return!1}substituteConstants(){return this}evaluate(V){const te=V.getValue(this.d);return this.f?this.f.test(te):!1}serialize(){const V=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${V}`}keys(){return[this.d]}map(V){return V.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Z.create(this)),this.c}}e.$Pj=Y;class Z{static create(V){return new Z(V)}constructor(V){this.c=V,this.type=c.NotRegex}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(V){return new Z(this.c.map(V))}negate(){return this.c}}e.$Qj=Z;function fe(X){let V=null;for(let te=0,ve=X.length;te<ve;te++){const ce=X[te].substituteConstants();if(X[te]!==ce&&V===null){V=[];for(let be=0;be<te;be++)V[be]=X[be]}V!==null&&(V[te]=ce)}return V===null?X:V}class _{static create(V,te,ve){return _.d(V,te,ve)}constructor(V,te){this.expr=V,this.c=te,this.type=c.And}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let te=0,ve=this.expr.length;te<ve;te++){const ce=d(this.expr[te],V.expr[te]);if(ce!==0)return ce}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let te=0,ve=this.expr.length;te<ve;te++)if(!this.expr[te].equals(V.expr[te]))return!1;return!0}return!1}substituteConstants(){const V=fe(this.expr);return V===this.expr?this:_.create(V,this.c,!1)}evaluate(V){for(let te=0,ve=this.expr.length;te<ve;te++)if(!this.expr[te].evaluate(V))return!1;return!0}static d(V,te,ve){const ce=[];let be=!1;for(const he of V)if(he){if(he.type===c.True){be=!0;continue}if(he.type===c.False)return E.INSTANCE;if(he.type===c.And){ce.push(...he.expr);continue}ce.push(he)}if(ce.length===0&&be)return D.INSTANCE;if(ce.length!==0){if(ce.length===1)return ce[0];ce.sort(d);for(let he=1;he<ce.length;he++)ce[he-1].equals(ce[he])&&(ce.splice(he,1),he--);if(ce.length===1)return ce[0];for(;ce.length>1;){const he=ce[ce.length-1];if(he.type!==c.Or)break;ce.pop();const J=ce.pop(),x=ce.length===0,me=ge.create(he.expr.map(pe=>_.create([pe,J],null,ve)),null,x);me&&(ce.push(me),ce.sort(d))}if(ce.length===1)return ce[0];if(ve){for(let he=0;he<ce.length;he++)for(let J=he+1;J<ce.length;J++)if(ce[he].negate().equals(ce[J]))return E.INSTANCE;if(ce.length===1)return ce[0]}return new _(ce,te)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const te of this.expr)V.push(...te.keys());return V}map(V){return new _(this.expr.map(te=>te.map(V)),null)}negate(){if(!this.c){const V=[];for(const te of this.expr)V.push(te.negate());this.c=ge.create(V,this,!0)}return this.c}}e.$Rj=_;class ge{static create(V,te,ve){return ge.d(V,te,ve)}constructor(V,te){this.expr=V,this.c=te,this.type=c.Or}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let te=0,ve=this.expr.length;te<ve;te++){const ce=d(this.expr[te],V.expr[te]);if(ce!==0)return ce}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let te=0,ve=this.expr.length;te<ve;te++)if(!this.expr[te].equals(V.expr[te]))return!1;return!0}return!1}substituteConstants(){const V=fe(this.expr);return V===this.expr?this:ge.create(V,this.c,!1)}evaluate(V){for(let te=0,ve=this.expr.length;te<ve;te++)if(this.expr[te].evaluate(V))return!0;return!1}static d(V,te,ve){let ce=[],be=!1;if(V){for(let he=0,J=V.length;he<J;he++){const x=V[he];if(x){if(x.type===c.False){be=!0;continue}if(x.type===c.True)return D.INSTANCE;if(x.type===c.Or){ce=ce.concat(x.expr);continue}ce.push(x)}}if(ce.length===0&&be)return E.INSTANCE;ce.sort(d)}if(ce.length!==0){if(ce.length===1)return ce[0];for(let he=1;he<ce.length;he++)ce[he-1].equals(ce[he])&&(ce.splice(he,1),he--);if(ce.length===1)return ce[0];if(ve){for(let he=0;he<ce.length;he++)for(let J=he+1;J<ce.length;J++)if(ce[he].negate().equals(ce[J]))return D.INSTANCE;if(ce.length===1)return ce[0]}return new ge(ce,te)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const te of this.expr)V.push(...te.keys());return V}map(V){return new ge(this.expr.map(te=>te.map(V)),null)}negate(){if(!this.c){const V=[];for(const te of this.expr)V.push(te.negate());for(;V.length>1;){const te=V.shift(),ve=V.shift(),ce=[];for(const be of Fe(te))for(const he of Fe(ve))ce.push(_.create([be,he],null,!1));V.unshift(ge.create(ce,null,!1))}this.c=ge.create(V,this,!0)}return this.c}}e.$Sj=ge;class se extends w{static{this.d=[]}static all(){return se.d.values()}constructor(V,te,ve){super(V,null),this.f=te,typeof ve=="object"?se.d.push({...ve,key:V}):ve!==!0&&se.d.push({key:V,description:ve,type:te!=null?typeof te:void 0})}bindTo(V){return V.createKey(this.key,this.f)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return k.create(this.key,V)}notEqualsTo(V){return b.create(this.key,V)}}e.$Tj=se,e.$Uj=(0,A.$Ci)("contextKeyService");function ae(X,V){return X<V?-1:X>V?1:0}function $e(X,V,te,ve){return X<te?-1:X>te?1:V<ve?-1:V>ve?1:0}function oe(X,V){if(X.type===c.False||V.type===c.True)return!0;if(X.type===c.Or)return V.type===c.Or?Ce(X.expr,V.expr):!1;if(V.type===c.Or){for(const te of V.expr)if(oe(X,te))return!0;return!1}if(X.type===c.And){if(V.type===c.And)return Ce(V.expr,X.expr);for(const te of X.expr)if(oe(te,V))return!0;return!1}return X.equals(V)}function Ce(X,V){let te=0,ve=0;for(;te<X.length&&ve<V.length;){const ce=X[te].cmp(V[ve]);if(ce<0)return!1;ce===0&&te++,ve++}return te===X.length}function Fe(X){return X.type===c.Or?X.expr:[X]}}),define(Ne[167],Oe([1,0,31,3]),function(we,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qt=e.$ot=e.AccessibilitySupport=e.$nt=void 0,e.$pt=N,e.$nt=(0,I.$Ci)("accessibilityService");var C;(function(A){A[A.Unknown=0]="Unknown",A[A.Disabled=1]="Disabled",A[A.Enabled=2]="Enabled"})(C||(e.AccessibilitySupport=C={})),e.$ot=new v.$Tj("accessibilityModeEnabled",!1);function N(A){return A&&typeof A=="object"&&typeof A.label=="string"&&(typeof A.role>"u"||typeof A.role=="string")}e.$qt="ACCESSIBLE_VIEW_SHOWN_"}),define(Ne[105],Oe([1,0,17,25,20,145,279,155,168,9,167]),function(we,e,v,I,C,N,A,T,$,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=t,e.clampedFloat=u,e.stringSet=d,e.cursorStyleToString=O,e.filterValidationDecorations=Pe,v=Ve(v),I=Ve(I),C=Ve(C),a=Ve(a);var y;(function(ee){ee[ee.None=0]="None",ee[ee.Keep=1]="Keep",ee[ee.Brackets=2]="Brackets",ee[ee.Advanced=3]="Advanced",ee[ee.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class c{constructor(K){this.c=K}hasChanged(K){return this.c[K]}}e.ConfigurationChangedEvent=c;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class f{constructor(K,De,Je,xe){this.id=K,this.name=De,this.defaultValue=Je,this.schema=xe}applyUpdate(K,De){return o(K,De)}compute(K,De,Je){return Je}}class n{constructor(K,De){this.newValue=K,this.didChange=De}}e.ApplyUpdateResult=n;function o(ee,K){if(typeof ee!="object"||typeof K!="object"||!ee||!K)return new n(K,ee!==K);if(Array.isArray(ee)||Array.isArray(K)){const Je=Array.isArray(ee)&&Array.isArray(K)&&v.$tb(ee,K);return new n(K,!Je)}let De=!1;for(const Je in K)if(K.hasOwnProperty(Je)){const xe=o(ee[Je],K[Je]);xe.didChange&&(ee[Je]=xe.newValue,De=!0)}return new n(ee,De)}class s{constructor(K){this.schema=void 0,this.id=K,this.name="_never_",this.defaultValue=void 0}applyUpdate(K,De){return o(K,De)}validate(K){return this.defaultValue}}class l{constructor(K,De,Je,xe){this.id=K,this.name=De,this.defaultValue=Je,this.schema=xe}applyUpdate(K,De){return o(K,De)}validate(K){return typeof K>"u"?this.defaultValue:K}compute(K,De,Je){return Je}}function i(ee,K){return typeof ee>"u"?K:ee==="false"?!1:!!ee}class r extends l{constructor(K,De,Je,xe=void 0){typeof xe<"u"&&(xe.type="boolean",xe.default=Je),super(K,De,Je,xe)}validate(K){return i(K,this.defaultValue)}}function t(ee,K,De,Je){if(typeof ee>"u")return K;let xe=parseInt(ee,10);return isNaN(xe)?K:(xe=Math.max(De,xe),xe=Math.min(Je,xe),xe|0)}class g extends l{static clampedInt(K,De,Je,xe){return t(K,De,Je,xe)}constructor(K,De,Je,xe,ht,$t=void 0){typeof $t<"u"&&($t.type="integer",$t.default=Je,$t.minimum=xe,$t.maximum=ht),super(K,De,Je,$t),this.minimum=xe,this.maximum=ht}validate(K){return g.clampedInt(K,this.defaultValue,this.minimum,this.maximum)}}function u(ee,K,De,Je){if(typeof ee>"u")return K;const xe=p.float(ee,K);return p.clamp(xe,De,Je)}class p extends l{static clamp(K,De,Je){return K<De?De:K>Je?Je:K}static float(K,De){if(typeof K=="number")return K;if(typeof K>"u")return De;const Je=parseFloat(K);return isNaN(Je)?De:Je}constructor(K,De,Je,xe,ht){typeof ht<"u"&&(ht.type="number",ht.default=Je),super(K,De,Je,ht),this.validationFn=xe}validate(K){return this.validationFn(p.float(K,this.defaultValue))}}class m extends l{static string(K,De){return typeof K!="string"?De:K}constructor(K,De,Je,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.default=Je),super(K,De,Je,xe)}validate(K){return m.string(K,this.defaultValue)}}function d(ee,K,De,Je){return typeof ee!="string"?K:Je&&ee in Je?Je[ee]:De.indexOf(ee)===-1?K:ee}class E extends l{constructor(K,De,Je,xe,ht=void 0){typeof ht<"u"&&(ht.type="string",ht.enum=xe,ht.default=Je),super(K,De,Je,ht),this.c=xe}validate(K){return d(K,this.defaultValue,this.c)}}class D extends f{constructor(K,De,Je,xe,ht,$t,Ot=void 0){typeof Ot<"u"&&(Ot.type="string",Ot.enum=ht,Ot.default=xe),super(K,De,Je,Ot),this.c=ht,this.d=$t}validate(K){return typeof K!="string"?this.defaultValue:this.c.indexOf(K)===-1?this.defaultValue:this.d(K)}}function w(ee){switch(ee){case"none":return y.None;case"keep":return y.Keep;case"brackets":return y.Brackets;case"advanced":return y.Advanced;case"full":return y.Full}}class k extends f{constructor(){super(Ue.accessibilitySupport,"accessibilitySupport",R.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(11608,null),a.localize(11609,null),a.localize(11610,null)],default:"auto",tags:["accessibility"],description:a.localize(11611,null)})}validate(K){switch(K){case"auto":return R.AccessibilitySupport.Unknown;case"off":return R.AccessibilitySupport.Disabled;case"on":return R.AccessibilitySupport.Enabled}return this.defaultValue}compute(K,De,Je){return Je===R.AccessibilitySupport.Unknown?K.accessibilitySupport:Je}}class P extends f{constructor(){const K={insertSpace:!0,ignoreEmptyLines:!0};super(Ue.comments,"comments",K,{"editor.comments.insertSpace":{type:"boolean",default:K.insertSpace,description:a.localize(11612,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:K.ignoreEmptyLines,description:a.localize(11613,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const De=K;return{insertSpace:i(De.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(De.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var h;(function(ee){ee[ee.Hidden=0]="Hidden",ee[ee.Blink=1]="Blink",ee[ee.Smooth=2]="Smooth",ee[ee.Phase=3]="Phase",ee[ee.Expand=4]="Expand",ee[ee.Solid=5]="Solid"})(h||(e.TextEditorCursorBlinkingStyle=h={}));function b(ee){switch(ee){case"blink":return h.Blink;case"smooth":return h.Smooth;case"phase":return h.Phase;case"expand":return h.Expand;case"solid":return h.Solid}}var M;(function(ee){ee[ee.Line=1]="Line",ee[ee.Block=2]="Block",ee[ee.Underline=3]="Underline",ee[ee.LineThin=4]="LineThin",ee[ee.BlockOutline=5]="BlockOutline",ee[ee.UnderlineThin=6]="UnderlineThin"})(M||(e.TextEditorCursorStyle=M={}));function O(ee){switch(ee){case M.Line:return"line";case M.Block:return"block";case M.Underline:return"underline";case M.LineThin:return"line-thin";case M.BlockOutline:return"block-outline";case M.UnderlineThin:return"underline-thin"}}function F(ee){switch(ee){case"line":return M.Line;case"block":return M.Block;case"underline":return M.Underline;case"line-thin":return M.LineThin;case"block-outline":return M.BlockOutline;case"underline-thin":return M.UnderlineThin}}class q extends s{constructor(){super(Ue.editorClassName)}compute(K,De,Je){const xe=["monaco-editor"];return De.get(Ue.extraEditorClassName)&&xe.push(De.get(Ue.extraEditorClassName)),K.extraEditorClassName&&xe.push(K.extraEditorClassName),De.get(Ue.mouseStyle)==="default"?xe.push("mouse-default"):De.get(Ue.mouseStyle)==="copy"&&xe.push("mouse-copy"),De.get(Ue.showUnused)&&xe.push("showUnused"),De.get(Ue.showDeprecated)&&xe.push("showDeprecated"),xe.join(" ")}}class B extends r{constructor(){super(Ue.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:a.localize(11614,null)})}compute(K,De,Je){return Je&&K.emptySelectionClipboard}}class L extends f{constructor(){const K={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(Ue.find,"find",K,{"editor.find.cursorMoveOnType":{type:"boolean",default:K.cursorMoveOnType,description:a.localize(11615,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:K.seedSearchStringFromSelection,enumDescriptions:[a.localize(11616,null),a.localize(11617,null),a.localize(11618,null)],description:a.localize(11619,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:K.autoFindInSelection,enumDescriptions:[a.localize(11620,null),a.localize(11621,null),a.localize(11622,null)],description:a.localize(11623,null)},"editor.find.globalFindClipboard":{type:"boolean",default:K.globalFindClipboard,description:a.localize(11624,null),included:C.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:K.addExtraSpaceOnTop,description:a.localize(11625,null)},"editor.find.loop":{type:"boolean",default:K.loop,description:a.localize(11626,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const De=K;return{cursorMoveOnType:i(De.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof K.seedSearchStringFromSelection=="boolean"?K.seedSearchStringFromSelection?"always":"never":d(De.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof K.autoFindInSelection=="boolean"?K.autoFindInSelection?"always":"never":d(De.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(De.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(De.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(De.loop,this.defaultValue.loop)}}}class Y extends f{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(Ue.fontLigatures,"fontLigatures",Y.OFF,{anyOf:[{type:"boolean",description:a.localize(11627,null)},{type:"string",description:a.localize(11628,null)}],description:a.localize(11629,null),default:!1})}validate(K){return typeof K>"u"?this.defaultValue:typeof K=="string"?K==="false"||K.length===0?Y.OFF:K==="true"?Y.ON:K:K?Y.ON:Y.OFF}}e.EditorFontLigatures=Y;class Z extends f{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(Ue.fontVariations,"fontVariations",Z.OFF,{anyOf:[{type:"boolean",description:a.localize(11630,null)},{type:"string",description:a.localize(11631,null)}],description:a.localize(11632,null),default:!1})}validate(K){return typeof K>"u"?this.defaultValue:typeof K=="string"?K==="false"?Z.OFF:K==="true"?Z.TRANSLATE:K:K?Z.TRANSLATE:Z.OFF}compute(K,De,Je){return K.fontInfo.fontVariationSettings}}e.EditorFontVariations=Z;class fe extends s{constructor(){super(Ue.fontInfo)}compute(K,De,Je){return K.fontInfo}}class _ extends l{constructor(){super(Ue.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(11633,null)})}validate(K){const De=p.float(K,this.defaultValue);return De===0?e.EDITOR_FONT_DEFAULTS.fontSize:p.clamp(De,6,100)}compute(K,De,Je){return K.fontInfo.fontSize}}class ge extends f{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(Ue.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ge.d,maximum:ge.e,errorMessage:a.localize(11634,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ge.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(11635,null)})}validate(K){return K==="normal"||K==="bold"?K:String(g.clampedInt(K,e.EDITOR_FONT_DEFAULTS.fontWeight,ge.d,ge.e))}}class se extends f{constructor(){const K={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},De={type:"string",enum:["peek","gotoAndPeek","goto"],default:K.multiple,enumDescriptions:[a.localize(11636,null),a.localize(11637,null),a.localize(11638,null)]},Je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(Ue.gotoLocation,"gotoLocation",K,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(11639,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(11640,null),...De},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(11641,null),...De},"editor.gotoLocation.multipleDeclarations":{description:a.localize(11642,null),...De},"editor.gotoLocation.multipleImplementations":{description:a.localize(11643,null),...De},"editor.gotoLocation.multipleReferences":{description:a.localize(11644,null),...De},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:K.alternativeDefinitionCommand,enum:Je,description:a.localize(11645,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:K.alternativeTypeDefinitionCommand,enum:Je,description:a.localize(11646,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:K.alternativeDeclarationCommand,enum:Je,description:a.localize(11647,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:K.alternativeImplementationCommand,enum:Je,description:a.localize(11648,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:K.alternativeReferenceCommand,enum:Je,description:a.localize(11649,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const De=K;return{multiple:d(De.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:De.multipleDefinitions??d(De.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:De.multipleTypeDefinitions??d(De.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:De.multipleDeclarations??d(De.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:De.multipleImplementations??d(De.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:De.multipleReferences??d(De.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:m.string(De.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:m.string(De.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:m.string(De.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:m.string(De.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:m.string(De.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ae extends f{constructor(){const K={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(Ue.hover,"hover",K,{"editor.hover.enabled":{type:"boolean",default:K.enabled,description:a.localize(11650,null)},"editor.hover.delay":{type:"number",default:K.delay,minimum:0,maximum:1e4,description:a.localize(11651,null)},"editor.hover.sticky":{type:"boolean",default:K.sticky,description:a.localize(11652,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:K.hidingDelay,description:a.localize(11653,null)},"editor.hover.above":{type:"boolean",default:K.above,description:a.localize(11654,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const De=K;return{enabled:i(De.enabled,this.defaultValue.enabled),delay:g.clampedInt(De.delay,this.defaultValue.delay,0,1e4),sticky:i(De.sticky,this.defaultValue.sticky),hidingDelay:g.clampedInt(De.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(De.above,this.defaultValue.above)}}}var $e;(function(ee){ee[ee.None=0]="None",ee[ee.Text=1]="Text",ee[ee.Blocks=2]="Blocks"})($e||(e.RenderMinimap=$e={}));class oe extends s{constructor(){super(Ue.layoutInfo)}compute(K,De,Je){return oe.computeLayout(De,{memory:K.memory,outerWidth:K.outerWidth,outerHeight:K.outerHeight,isDominatedByLongLines:K.isDominatedByLongLines,lineHeight:K.fontInfo.lineHeight,viewLineCount:K.viewLineCount,lineNumbersDigitCount:K.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:K.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:K.fontInfo.maxDigitWidth,pixelRatio:K.pixelRatio,glyphMarginDecorationLaneCount:K.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(K){const De=K.height/K.lineHeight,Je=Math.floor(K.paddingTop/K.lineHeight);let xe=Math.floor(K.paddingBottom/K.lineHeight);K.scrollBeyondLastLine&&(xe=Math.max(xe,De-1));const ht=(Je+K.viewLineCount+xe)/(K.pixelRatio*K.height),$t=Math.floor(K.viewLineCount/ht);return{typicalViewportLineCount:De,extraLinesBeforeFirstLine:Je,extraLinesBeyondLastLine:xe,desiredRatio:ht,minimapLineCount:$t}}static c(K,De){const Je=K.outerWidth,xe=K.outerHeight,ht=K.pixelRatio;if(!K.minimap.enabled)return{renderMinimap:$e.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ht*xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:xe};const $t=De.stableMinimapLayoutInput,Ot=$t&&K.outerHeight===$t.outerHeight&&K.lineHeight===$t.lineHeight&&K.typicalHalfwidthCharacterWidth===$t.typicalHalfwidthCharacterWidth&&K.pixelRatio===$t.pixelRatio&&K.scrollBeyondLastLine===$t.scrollBeyondLastLine&&K.paddingTop===$t.paddingTop&&K.paddingBottom===$t.paddingBottom&&K.minimap.enabled===$t.minimap.enabled&&K.minimap.side===$t.minimap.side&&K.minimap.size===$t.minimap.size&&K.minimap.showSlider===$t.minimap.showSlider&&K.minimap.renderCharacters===$t.minimap.renderCharacters&&K.minimap.maxColumn===$t.minimap.maxColumn&&K.minimap.scale===$t.minimap.scale&&K.verticalScrollbarWidth===$t.verticalScrollbarWidth&&K.isViewportWrapping===$t.isViewportWrapping,zt=K.lineHeight,ei=K.typicalHalfwidthCharacterWidth,ui=K.scrollBeyondLastLine,ti=K.minimap.renderCharacters;let Ye=ht>=2?Math.round(K.minimap.scale*2):K.minimap.scale;const Gt=K.minimap.maxColumn,Kt=K.minimap.size,mt=K.minimap.side,Ct=K.verticalScrollbarWidth,ii=K.viewLineCount,Xt=K.remainingWidth,Bt=K.isViewportWrapping,vt=ti?2:3;let Nt=Math.floor(ht*xe);const hi=Nt/ht;let Wt=!1,Xe=!1,Yt=vt*Ye,ni=Ye/ht,di=1;if(Kt==="fill"||Kt==="fit"){const{typicalViewportLineCount:si,extraLinesBeforeFirstLine:Vt,extraLinesBeyondLastLine:Qt,desiredRatio:oi,minimapLineCount:Pt}=oe.computeContainedMinimapLineCount({viewLineCount:ii,scrollBeyondLastLine:ui,paddingTop:K.paddingTop,paddingBottom:K.paddingBottom,height:xe,lineHeight:zt,pixelRatio:ht});if(ii/Pt>1)Wt=!0,Xe=!0,Ye=1,Yt=1,ni=Ye/ht;else{let bt=!1,xt=Ye+1;if(Kt==="fit"){const kt=Math.ceil((Vt+ii+Qt)*Yt);Bt&&Ot&&Xt<=De.stableFitRemainingWidth?(bt=!0,xt=De.stableFitMaxMinimapScale):bt=kt>Nt}if(Kt==="fill"||bt){Wt=!0;const kt=Ye;Yt=Math.min(zt*ht,Math.max(1,Math.floor(1/oi))),Bt&&Ot&&Xt<=De.stableFitRemainingWidth&&(xt=De.stableFitMaxMinimapScale),Ye=Math.min(xt,Math.max(1,Math.floor(Yt/vt))),Ye>kt&&(di=Math.min(2,Ye/kt)),ni=Ye/ht/di,Nt=Math.ceil(Math.max(si,Vt+ii+Qt)*Yt),Bt?(De.stableMinimapLayoutInput=K,De.stableFitRemainingWidth=Xt,De.stableFitMaxMinimapScale=Ye):(De.stableMinimapLayoutInput=null,De.stableFitRemainingWidth=0)}}}const St=Math.floor(Gt*ni),Lt=Math.min(St,Math.max(0,Math.floor((Xt-Ct-2)*ni/(ei+ni)))+e.MINIMAP_GUTTER_WIDTH);let Rt=Math.floor(ht*Lt);const jt=Rt/ht;Rt=Math.floor(Rt*di);const ri=ti?$e.Text:$e.Blocks,Zt=mt==="left"?0:Je-Lt-Ct;return{renderMinimap:ri,minimapLeft:Zt,minimapWidth:Lt,minimapHeightIsEditorHeight:Wt,minimapIsSampling:Xe,minimapScale:Ye,minimapLineHeight:Yt,minimapCanvasInnerWidth:Rt,minimapCanvasInnerHeight:Nt,minimapCanvasOuterWidth:jt,minimapCanvasOuterHeight:hi}}static computeLayout(K,De){const Je=De.outerWidth|0,xe=De.outerHeight|0,ht=De.lineHeight|0,$t=De.lineNumbersDigitCount|0,Ot=De.typicalHalfwidthCharacterWidth,zt=De.maxDigitWidth,ei=De.pixelRatio,ui=De.viewLineCount,ti=K.get(Ue.wordWrapOverride2),Ye=ti==="inherit"?K.get(Ue.wordWrapOverride1):ti,Gt=Ye==="inherit"?K.get(Ue.wordWrap):Ye,Kt=K.get(Ue.wordWrapColumn),mt=De.isDominatedByLongLines,Ct=K.get(Ue.glyphMargin),ii=K.get(Ue.lineNumbers).renderType!==ze.Off,Xt=K.get(Ue.lineNumbersMinChars),Bt=K.get(Ue.scrollBeyondLastLine),vt=K.get(Ue.padding),Nt=K.get(Ue.minimap),hi=K.get(Ue.scrollbar),Wt=hi.verticalScrollbarSize,Xe=hi.verticalHasArrows,Yt=hi.arrowSize,ni=hi.horizontalScrollbarSize,di=K.get(Ue.folding),St=K.get(Ue.showFoldingControls)!=="never";let Lt=K.get(Ue.lineDecorationsWidth);di&&St&&(Lt+=16);let Rt=0;if(ii){const qt=Math.max($t,Xt);Rt=Math.round(qt*zt)}let jt=0;Ct&&(jt=ht*De.glyphMarginDecorationLaneCount);let ri=0,Zt=ri+jt,si=Zt+Rt,Vt=si+Lt;const Qt=Je-jt-Rt-Lt;let oi=!1,Pt=!1,Dt=-1;Ye==="inherit"&&mt?(oi=!0,Pt=!0):Gt==="on"||Gt==="bounded"?Pt=!0:Gt==="wordWrapColumn"&&(Dt=Kt);const bt=oe.c({outerWidth:Je,outerHeight:xe,lineHeight:ht,typicalHalfwidthCharacterWidth:Ot,pixelRatio:ei,scrollBeyondLastLine:Bt,paddingTop:vt.top,paddingBottom:vt.bottom,minimap:Nt,verticalScrollbarWidth:Wt,viewLineCount:ui,remainingWidth:Qt,isViewportWrapping:Pt},De.memory||new S);bt.renderMinimap!==$e.None&&bt.minimapLeft===0&&(ri+=bt.minimapWidth,Zt+=bt.minimapWidth,si+=bt.minimapWidth,Vt+=bt.minimapWidth);const xt=Qt-bt.minimapWidth,kt=Math.max(1,Math.floor((xt-Wt-2)/Ot)),fi=Xe?Yt:0;return Pt&&(Dt=Math.max(1,kt),Gt==="bounded"&&(Dt=Math.min(Dt,Kt))),{width:Je,height:xe,glyphMarginLeft:ri,glyphMarginWidth:jt,glyphMarginDecorationLaneCount:De.glyphMarginDecorationLaneCount,lineNumbersLeft:Zt,lineNumbersWidth:Rt,decorationsLeft:si,decorationsWidth:Lt,contentLeft:Vt,contentWidth:xt,minimap:bt,viewportColumn:kt,isWordWrapMinified:oi,isViewportWrapping:Pt,wrappingColumn:Dt,verticalScrollbarWidth:Wt,horizontalScrollbarHeight:ni,overviewRuler:{top:fi,width:Wt,height:xe-2*fi,right:0}}}}e.EditorLayoutInfoComputer=oe;class Ce extends f{constructor(){super(Ue.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[a.localize(11655,null),a.localize(11656,null)],type:"string",enum:["simple","advanced"],default:"simple",description:a.localize(11657,null)}})}validate(K){return d(K,"simple",["simple","advanced"])}compute(K,De,Je){return De.get(Ue.accessibilitySupport)===R.AccessibilitySupport.Enabled?"advanced":Je}}var Fe;(function(ee){ee.Off="off",ee.OnCode="onCode",ee.On="on"})(Fe||(e.ShowLightbulbIconMode=Fe={}));class X extends f{constructor(){const K={enabled:Fe.On};super(Ue.lightbulb,"lightbulb",K,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Fe.Off,Fe.OnCode,Fe.On],default:K.enabled,enumDescriptions:[a.localize(11658,null),a.localize(11659,null),a.localize(11660,null)],description:a.localize(11661,null)}})}validate(K){return!K||typeof K!="object"?this.defaultValue:{enabled:d(K.enabled,this.defaultValue.enabled,[Fe.Off,Fe.OnCode,Fe.On])}}}class V extends f{constructor(){const K={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(Ue.stickyScroll,"stickyScroll",K,{"editor.stickyScroll.enabled":{type:"boolean",default:K.enabled,description:a.localize(11662,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:K.maxLineCount,minimum:1,maximum:20,description:a.localize(11663,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:K.defaultModel,description:a.localize(11664,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:K.scrollWithEditor,description:a.localize(11665,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const De=K;return{enabled:i(De.enabled,this.defaultValue.enabled),maxLineCount:g.clampedInt(De.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:d(De.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(De.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class te extends f{constructor(){const K={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(Ue.inlayHints,"inlayHints",K,{"editor.inlayHints.enabled":{type:"string",default:K.enabled,description:a.localize(11666,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[a.localize(11667,null),a.localize(11668,null,C.$k?"Ctrl+Option":"Ctrl+Alt"),a.localize(11669,null,C.$k?"Ctrl+Option":"Ctrl+Alt"),a.localize(11670,null)]},"editor.inlayHints.fontSize":{type:"number",default:K.fontSize,markdownDescription:a.localize(11671,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:K.fontFamily,markdownDescription:a.localize(11672,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:K.padding,description:a.localize(11673,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const De=K;return typeof De.enabled=="boolean"&&(De.enabled=De.enabled?"on":"off"),{enabled:d(De.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:g.clampedInt(De.fontSize,this.defaultValue.fontSize,0,100),fontFamily:m.string(De.fontFamily,this.defaultValue.fontFamily),padding:i(De.padding,this.defaultValue.padding)}}}class ve extends f{constructor(){super(Ue.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(K){return typeof K=="string"&&/^\d+(\.\d+)?ch$/.test(K)?-parseFloat(K.substring(0,K.length-2)):g.clampedInt(K,this.defaultValue,0,1e3)}compute(K,De,Je){return Je<0?g.clampedInt(-Je*K.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Je}}class ce extends p{constructor(){super(Ue.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,K=>p.clamp(K,0,150),{markdownDescription:a.localize(11674,null)})}compute(K,De,Je){return K.fontInfo.lineHeight}}class be extends f{constructor(){const K={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(Ue.minimap,"minimap",K,{"editor.minimap.enabled":{type:"boolean",default:K.enabled,description:a.localize(11675,null)},"editor.minimap.autohide":{type:"boolean",default:K.autohide,description:a.localize(11676,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(11677,null),a.localize(11678,null),a.localize(11679,null)],default:K.size,description:a.localize(11680,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:K.side,description:a.localize(11681,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:K.showSlider,description:a.localize(11682,null)},"editor.minimap.scale":{type:"number",default:K.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(11683,null)},"editor.minimap.renderCharacters":{type:"boolean",default:K.renderCharacters,description:a.localize(11684,null)},"editor.minimap.maxColumn":{type:"number",default:K.maxColumn,description:a.localize(11685,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:K.showRegionSectionHeaders,description:a.localize(11686,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:K.showMarkSectionHeaders,description:a.localize(11687,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:K.sectionHeaderFontSize,description:a.localize(11688,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:K.sectionHeaderLetterSpacing,description:a.localize(11689,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const De=K;return{enabled:i(De.enabled,this.defaultValue.enabled),autohide:i(De.autohide,this.defaultValue.autohide),size:d(De.size,this.defaultValue.size,["proportional","fill","fit"]),side:d(De.side,this.defaultValue.side,["right","left"]),showSlider:d(De.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(De.renderCharacters,this.defaultValue.renderCharacters),scale:g.clampedInt(De.scale,1,1,3),maxColumn:g.clampedInt(De.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(De.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(De.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:p.clamp(De.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:p.clamp(De.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function he(ee){return ee==="ctrlCmd"?C.$k?"metaKey":"ctrlKey":"altKey"}class J extends f{constructor(){super(Ue.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(11690,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(11691,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const De=K;return{top:g.clampedInt(De.top,0,0,1e3),bottom:g.clampedInt(De.bottom,0,0,1e3)}}}class x extends f{constructor(){const K={enabled:!0,cycle:!0};super(Ue.parameterHints,"parameterHints",K,{"editor.parameterHints.enabled":{type:"boolean",default:K.enabled,description:a.localize(11692,null)},"editor.parameterHints.cycle":{type:"boolean",default:K.cycle,description:a.localize(11693,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const De=K;return{enabled:i(De.enabled,this.defaultValue.enabled),cycle:i(De.cycle,this.defaultValue.cycle)}}}class me extends s{constructor(){super(Ue.pixelRatio)}compute(K,De,Je){return K.pixelRatio}}class pe extends f{constructor(){super(Ue.placeholder,"placeholder",void 0)}validate(K){return typeof K>"u"?this.defaultValue:typeof K=="string"?K:this.defaultValue}}class Ae extends f{constructor(){const K={other:"on",comments:"off",strings:"off"},De=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[a.localize(11694,null),a.localize(11695,null),a.localize(11696,null)]}];super(Ue.quickSuggestions,"quickSuggestions",K,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:De,default:K.strings,description:a.localize(11697,null)},comments:{anyOf:De,default:K.comments,description:a.localize(11698,null)},other:{anyOf:De,default:K.other,description:a.localize(11699,null)}},default:K,markdownDescription:a.localize(11700,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=K}validate(K){if(typeof K=="boolean"){const ei=K?"on":"off";return{comments:ei,strings:ei,other:ei}}if(!K||typeof K!="object")return this.defaultValue;const{other:De,comments:Je,strings:xe}=K,ht=["on","inline","off"];let $t,Ot,zt;return typeof De=="boolean"?$t=De?"on":"off":$t=d(De,this.defaultValue.other,ht),typeof Je=="boolean"?Ot=Je?"on":"off":Ot=d(Je,this.defaultValue.comments,ht),typeof xe=="boolean"?zt=xe?"on":"off":zt=d(xe,this.defaultValue.strings,ht),{other:$t,comments:Ot,strings:zt}}}var ze;(function(ee){ee[ee.Off=0]="Off",ee[ee.On=1]="On",ee[ee.Relative=2]="Relative",ee[ee.Interval=3]="Interval",ee[ee.Custom=4]="Custom"})(ze||(e.RenderLineNumbersType=ze={}));class ke extends f{constructor(){super(Ue.lineNumbers,"lineNumbers",{renderType:ze.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(11701,null),a.localize(11702,null),a.localize(11703,null),a.localize(11704,null)],default:"on",description:a.localize(11705,null)})}validate(K){let De=this.defaultValue.renderType,Je=this.defaultValue.renderFn;return typeof K<"u"&&(typeof K=="function"?(De=ze.Custom,Je=K):K==="interval"?De=ze.Interval:K==="relative"?De=ze.Relative:K==="on"?De=ze.On:De=ze.Off),{renderType:De,renderFn:Je}}}function Pe(ee){const K=ee.get(Ue.renderValidationDecorations);return K==="editable"?ee.get(Ue.readOnly):K!=="on"}class Te extends f{constructor(){const K=[],De={type:"number",description:a.localize(11706,null)};super(Ue.rulers,"rulers",K,{type:"array",items:{anyOf:[De,{type:["object"],properties:{column:De,color:{type:"string",description:a.localize(11707,null),format:"color-hex"}}}]},default:K,description:a.localize(11708,null)})}validate(K){if(Array.isArray(K)){const De=[];for(const Je of K)if(typeof Je=="number")De.push({column:g.clampedInt(Je,0,0,1e4),color:null});else if(Je&&typeof Je=="object"){const xe=Je;De.push({column:g.clampedInt(xe.column,0,0,1e4),color:xe.color})}return De.sort((Je,xe)=>Je.column-xe.column),De}return this.defaultValue}}class U extends f{constructor(){super(Ue.readOnlyMessage,"readOnlyMessage",void 0)}validate(K){return!K||typeof K!="object"?this.defaultValue:K}}function j(ee,K){if(typeof ee!="string")return K;switch(ee){case"hidden":return N.ScrollbarVisibility.Hidden;case"visible":return N.ScrollbarVisibility.Visible;default:return N.ScrollbarVisibility.Auto}}class G extends f{constructor(){const K={vertical:N.ScrollbarVisibility.Auto,horizontal:N.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(Ue.scrollbar,"scrollbar",K,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(11709,null),a.localize(11710,null),a.localize(11711,null)],default:"auto",description:a.localize(11712,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(11713,null),a.localize(11714,null),a.localize(11715,null)],default:"auto",description:a.localize(11716,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:K.verticalScrollbarSize,description:a.localize(11717,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:K.horizontalScrollbarSize,description:a.localize(11718,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:K.scrollByPage,description:a.localize(11719,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:K.ignoreHorizontalScrollbarInContentHeight,description:a.localize(11720,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const De=K,Je=g.clampedInt(De.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),xe=g.clampedInt(De.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:g.clampedInt(De.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:j(De.vertical,this.defaultValue.vertical),horizontal:j(De.horizontal,this.defaultValue.horizontal),useShadows:i(De.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(De.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(De.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(De.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(De.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Je,horizontalSliderSize:g.clampedInt(De.horizontalSliderSize,Je,0,1e3),verticalScrollbarSize:xe,verticalSliderSize:g.clampedInt(De.verticalSliderSize,xe,0,1e3),scrollByPage:i(De.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(De.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Q extends f{constructor(){const K={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(Ue.unicodeHighlighting,"unicodeHighlight",K,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:K.nonBasicASCII,description:a.localize(11721,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:K.invisibleCharacters,description:a.localize(11722,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:K.ambiguousCharacters,description:a.localize(11723,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:K.includeComments,description:a.localize(11724,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:K.includeStrings,description:a.localize(11725,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:K.allowedCharacters,description:a.localize(11726,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:K.allowedLocales,description:a.localize(11727,null)}})}applyUpdate(K,De){let Je=!1;De.allowedCharacters&&K&&(I.$eo(K.allowedCharacters,De.allowedCharacters)||(K={...K,allowedCharacters:De.allowedCharacters},Je=!0)),De.allowedLocales&&K&&(I.$eo(K.allowedLocales,De.allowedLocales)||(K={...K,allowedLocales:De.allowedLocales},Je=!0));const xe=super.applyUpdate(K,De);return Je?new n(xe.newValue,!0):xe}validate(K){if(!K||typeof K!="object")return this.defaultValue;const De=K;return{nonBasicASCII:Ke(De.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(De.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(De.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ke(De.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ke(De.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(K.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(K.allowedLocales,this.defaultValue.allowedLocales)}}c(K,De){if(typeof K!="object"||!K)return De;const Je={};for(const[xe,ht]of Object.entries(K))ht===!0&&(Je[xe]=!0);return Je}}class ne extends f{constructor(){const K={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(Ue.inlineSuggest,"inlineSuggest",K,{"editor.inlineSuggest.enabled":{type:"boolean",default:K.enabled,description:a.localize(11728,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:K.showToolbar,enum:["always","onHover","never"],enumDescriptions:[a.localize(11729,null),a.localize(11730,null),a.localize(11731,null)],description:a.localize(11732,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:K.suppressSuggestions,description:a.localize(11733,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:K.fontFamily,description:a.localize(11734,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const De=K;return{enabled:i(De.enabled,this.defaultValue.enabled),mode:d(De.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:d(De.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(De.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(De.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:m.string(De.fontFamily,this.defaultValue.fontFamily)}}}class de extends f{constructor(){const K={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(Ue.inlineEdit,"experimentalInlineEdit",K,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:K.enabled,description:a.localize(11735,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:K.showToolbar,enum:["always","onHover","never"],enumDescriptions:[a.localize(11736,null),a.localize(11737,null),a.localize(11738,null)],description:a.localize(11739,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:K.fontFamily,description:a.localize(11740,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:K.backgroundColoring,description:a.localize(11741,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const De=K;return{enabled:i(De.enabled,this.defaultValue.enabled),showToolbar:d(De.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:m.string(De.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(De.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:i(De.backgroundColoring,this.defaultValue.backgroundColoring)}}}class Ie extends f{constructor(){const K={enabled:T.$ht.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.$ht.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(Ue.bracketPairColorization,"bracketPairColorization",K,{"editor.bracketPairColorization.enabled":{type:"boolean",default:K.enabled,markdownDescription:a.localize(11742,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:K.independentColorPoolPerBracketType,description:a.localize(11743,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const De=K;return{enabled:i(De.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(De.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class je extends f{constructor(){const K={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(Ue.guides,"guides",K,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(11744,null),a.localize(11745,null),a.localize(11746,null)],default:K.bracketPairs,description:a.localize(11747,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(11748,null),a.localize(11749,null),a.localize(11750,null)],default:K.bracketPairsHorizontal,description:a.localize(11751,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:K.highlightActiveBracketPair,description:a.localize(11752,null)},"editor.guides.indentation":{type:"boolean",default:K.indentation,description:a.localize(11753,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[a.localize(11754,null),a.localize(11755,null),a.localize(11756,null)],default:K.highlightActiveIndentation,description:a.localize(11757,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const De=K;return{bracketPairs:Ke(De.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ke(De.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(De.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(De.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ke(De.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ke(ee,K,De){const Je=De.indexOf(ee);return Je===-1?K:De[Je]}class _e extends f{constructor(){const K={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(Ue.suggest,"suggest",K,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(11758,null),a.localize(11759,null)],default:K.insertMode,description:a.localize(11760,null)},"editor.suggest.filterGraceful":{type:"boolean",default:K.filterGraceful,description:a.localize(11761,null)},"editor.suggest.localityBonus":{type:"boolean",default:K.localityBonus,description:a.localize(11762,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:K.shareSuggestSelections,markdownDescription:a.localize(11763,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[a.localize(11764,null),a.localize(11765,null),a.localize(11766,null),a.localize(11767,null)],default:K.selectionMode,markdownDescription:a.localize(11768,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:K.snippetsPreventQuickSuggestions,description:a.localize(11769,null)},"editor.suggest.showIcons":{type:"boolean",default:K.showIcons,description:a.localize(11770,null)},"editor.suggest.showStatusBar":{type:"boolean",default:K.showStatusBar,description:a.localize(11771,null)},"editor.suggest.preview":{type:"boolean",default:K.preview,description:a.localize(11772,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:K.showInlineDetails,description:a.localize(11773,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(11774,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(11775,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(11776,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(11777,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(11778,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(11779,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:a.localize(11780,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(11781,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(11782,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(11783,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(11784,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(11785,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(11786,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(11787,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(11788,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(11789,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(11790,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(11791,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(11792,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(11793,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(11794,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(11795,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(11796,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(11797,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(11798,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(11799,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(11800,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(11801,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(11802,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(11803,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(11804,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(11805,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const De=K;return{insertMode:d(De.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(De.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(De.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(De.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(De.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:d(De.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(De.showIcons,this.defaultValue.showIcons),showStatusBar:i(De.showStatusBar,this.defaultValue.showStatusBar),preview:i(De.preview,this.defaultValue.preview),previewMode:d(De.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(De.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(De.showMethods,this.defaultValue.showMethods),showFunctions:i(De.showFunctions,this.defaultValue.showFunctions),showConstructors:i(De.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(De.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(De.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(De.showFields,this.defaultValue.showFields),showVariables:i(De.showVariables,this.defaultValue.showVariables),showClasses:i(De.showClasses,this.defaultValue.showClasses),showStructs:i(De.showStructs,this.defaultValue.showStructs),showInterfaces:i(De.showInterfaces,this.defaultValue.showInterfaces),showModules:i(De.showModules,this.defaultValue.showModules),showProperties:i(De.showProperties,this.defaultValue.showProperties),showEvents:i(De.showEvents,this.defaultValue.showEvents),showOperators:i(De.showOperators,this.defaultValue.showOperators),showUnits:i(De.showUnits,this.defaultValue.showUnits),showValues:i(De.showValues,this.defaultValue.showValues),showConstants:i(De.showConstants,this.defaultValue.showConstants),showEnums:i(De.showEnums,this.defaultValue.showEnums),showEnumMembers:i(De.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(De.showKeywords,this.defaultValue.showKeywords),showWords:i(De.showWords,this.defaultValue.showWords),showColors:i(De.showColors,this.defaultValue.showColors),showFiles:i(De.showFiles,this.defaultValue.showFiles),showReferences:i(De.showReferences,this.defaultValue.showReferences),showFolders:i(De.showFolders,this.defaultValue.showFolders),showTypeParameters:i(De.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(De.showSnippets,this.defaultValue.showSnippets),showUsers:i(De.showUsers,this.defaultValue.showUsers),showIssues:i(De.showIssues,this.defaultValue.showIssues)}}}class tt extends f{constructor(){super(Ue.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(11806,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:a.localize(11807,null),default:!0,type:"boolean"}})}validate(K){return!K||typeof K!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(K.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(K.selectSubwords,this.defaultValue.selectSubwords)}}}class nt extends f{constructor(){const K=[];super(Ue.wordSegmenterLocales,"wordSegmenterLocales",K,{anyOf:[{description:a.localize(11808,null),type:"string"},{description:a.localize(11809,null),type:"array",items:{type:"string"}}]})}validate(K){if(typeof K=="string"&&(K=[K]),Array.isArray(K)){const De=[];for(const Je of K)if(typeof Je=="string")try{Intl.Segmenter.supportedLocalesOf(Je).length>0&&De.push(Je)}catch{}return De}return this.defaultValue}}var et;(function(ee){ee[ee.None=0]="None",ee[ee.Same=1]="Same",ee[ee.Indent=2]="Indent",ee[ee.DeepIndent=3]="DeepIndent"})(et||(e.WrappingIndent=et={}));class rt extends f{constructor(){super(Ue.wrappingIndent,"wrappingIndent",et.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[a.localize(11810,null),a.localize(11811,null),a.localize(11812,null),a.localize(11813,null)],description:a.localize(11814,null),default:"same"}})}validate(K){switch(K){case"none":return et.None;case"same":return et.Same;case"indent":return et.Indent;case"deepIndent":return et.DeepIndent}return et.Same}compute(K,De,Je){return De.get(Ue.accessibilitySupport)===R.AccessibilitySupport.Enabled?et.None:Je}}class ft extends s{constructor(){super(Ue.wrappingInfo)}compute(K,De,Je){const xe=De.get(Ue.layoutInfo);return{isDominatedByLongLines:K.isDominatedByLongLines,isWordWrapMinified:xe.isWordWrapMinified,isViewportWrapping:xe.isViewportWrapping,wrappingColumn:xe.wrappingColumn}}}class ct extends f{constructor(){const K={enabled:!0,showDropSelector:"afterDrop"};super(Ue.dropIntoEditor,"dropIntoEditor",K,{"editor.dropIntoEditor.enabled":{type:"boolean",default:K.enabled,markdownDescription:a.localize(11815,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:a.localize(11816,null),enum:["afterDrop","never"],enumDescriptions:[a.localize(11817,null),a.localize(11818,null)],default:"afterDrop"}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const De=K;return{enabled:i(De.enabled,this.defaultValue.enabled),showDropSelector:d(De.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends f{constructor(){const K={enabled:!0,showPasteSelector:"afterPaste"};super(Ue.pasteAs,"pasteAs",K,{"editor.pasteAs.enabled":{type:"boolean",default:K.enabled,markdownDescription:a.localize(11819,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:a.localize(11820,null),enum:["afterPaste","never"],enumDescriptions:[a.localize(11821,null),a.localize(11822,null)],default:"afterPaste"}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const De=K;return{enabled:i(De.enabled,this.defaultValue.enabled),showPasteSelector:d(De.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const lt="Consolas, 'Courier New', monospace",gt="Menlo, Monaco, 'Courier New', monospace",pt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$k?gt:C.$l?pt:lt,fontWeight:"normal",fontSize:C.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Be(ee){return e.editorOptionsRegistry[ee.id]=ee,ee}var Ue;(function(ee){ee[ee.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ee[ee.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ee[ee.accessibilitySupport=2]="accessibilitySupport",ee[ee.accessibilityPageSize=3]="accessibilityPageSize",ee[ee.ariaLabel=4]="ariaLabel",ee[ee.ariaRequired=5]="ariaRequired",ee[ee.autoClosingBrackets=6]="autoClosingBrackets",ee[ee.autoClosingComments=7]="autoClosingComments",ee[ee.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ee[ee.autoClosingDelete=9]="autoClosingDelete",ee[ee.autoClosingOvertype=10]="autoClosingOvertype",ee[ee.autoClosingQuotes=11]="autoClosingQuotes",ee[ee.autoIndent=12]="autoIndent",ee[ee.automaticLayout=13]="automaticLayout",ee[ee.autoSurround=14]="autoSurround",ee[ee.bracketPairColorization=15]="bracketPairColorization",ee[ee.guides=16]="guides",ee[ee.codeLens=17]="codeLens",ee[ee.codeLensFontFamily=18]="codeLensFontFamily",ee[ee.codeLensFontSize=19]="codeLensFontSize",ee[ee.colorDecorators=20]="colorDecorators",ee[ee.colorDecoratorsLimit=21]="colorDecoratorsLimit",ee[ee.columnSelection=22]="columnSelection",ee[ee.comments=23]="comments",ee[ee.contextmenu=24]="contextmenu",ee[ee.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ee[ee.cursorBlinking=26]="cursorBlinking",ee[ee.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ee[ee.cursorStyle=28]="cursorStyle",ee[ee.cursorSurroundingLines=29]="cursorSurroundingLines",ee[ee.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ee[ee.cursorWidth=31]="cursorWidth",ee[ee.disableLayerHinting=32]="disableLayerHinting",ee[ee.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ee[ee.domReadOnly=34]="domReadOnly",ee[ee.dragAndDrop=35]="dragAndDrop",ee[ee.dropIntoEditor=36]="dropIntoEditor",ee[ee.emptySelectionClipboard=37]="emptySelectionClipboard",ee[ee.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ee[ee.extraEditorClassName=39]="extraEditorClassName",ee[ee.fastScrollSensitivity=40]="fastScrollSensitivity",ee[ee.find=41]="find",ee[ee.fixedOverflowWidgets=42]="fixedOverflowWidgets",ee[ee.folding=43]="folding",ee[ee.foldingStrategy=44]="foldingStrategy",ee[ee.foldingHighlight=45]="foldingHighlight",ee[ee.foldingImportsByDefault=46]="foldingImportsByDefault",ee[ee.foldingMaximumRegions=47]="foldingMaximumRegions",ee[ee.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ee[ee.fontFamily=49]="fontFamily",ee[ee.fontInfo=50]="fontInfo",ee[ee.fontLigatures=51]="fontLigatures",ee[ee.fontSize=52]="fontSize",ee[ee.fontWeight=53]="fontWeight",ee[ee.fontVariations=54]="fontVariations",ee[ee.formatOnPaste=55]="formatOnPaste",ee[ee.formatOnType=56]="formatOnType",ee[ee.glyphMargin=57]="glyphMargin",ee[ee.gotoLocation=58]="gotoLocation",ee[ee.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ee[ee.hover=60]="hover",ee[ee.inDiffEditor=61]="inDiffEditor",ee[ee.inlineSuggest=62]="inlineSuggest",ee[ee.inlineEdit=63]="inlineEdit",ee[ee.letterSpacing=64]="letterSpacing",ee[ee.lightbulb=65]="lightbulb",ee[ee.lineDecorationsWidth=66]="lineDecorationsWidth",ee[ee.lineHeight=67]="lineHeight",ee[ee.lineNumbers=68]="lineNumbers",ee[ee.lineNumbersMinChars=69]="lineNumbersMinChars",ee[ee.linkedEditing=70]="linkedEditing",ee[ee.links=71]="links",ee[ee.matchBrackets=72]="matchBrackets",ee[ee.minimap=73]="minimap",ee[ee.mouseStyle=74]="mouseStyle",ee[ee.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ee[ee.mouseWheelZoom=76]="mouseWheelZoom",ee[ee.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ee[ee.multiCursorModifier=78]="multiCursorModifier",ee[ee.multiCursorPaste=79]="multiCursorPaste",ee[ee.multiCursorLimit=80]="multiCursorLimit",ee[ee.occurrencesHighlight=81]="occurrencesHighlight",ee[ee.overviewRulerBorder=82]="overviewRulerBorder",ee[ee.overviewRulerLanes=83]="overviewRulerLanes",ee[ee.padding=84]="padding",ee[ee.pasteAs=85]="pasteAs",ee[ee.parameterHints=86]="parameterHints",ee[ee.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ee[ee.placeholder=88]="placeholder",ee[ee.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",ee[ee.quickSuggestions=90]="quickSuggestions",ee[ee.quickSuggestionsDelay=91]="quickSuggestionsDelay",ee[ee.readOnly=92]="readOnly",ee[ee.readOnlyMessage=93]="readOnlyMessage",ee[ee.renameOnType=94]="renameOnType",ee[ee.renderControlCharacters=95]="renderControlCharacters",ee[ee.renderFinalNewline=96]="renderFinalNewline",ee[ee.renderLineHighlight=97]="renderLineHighlight",ee[ee.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",ee[ee.renderValidationDecorations=99]="renderValidationDecorations",ee[ee.renderWhitespace=100]="renderWhitespace",ee[ee.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",ee[ee.roundedSelection=102]="roundedSelection",ee[ee.rulers=103]="rulers",ee[ee.scrollbar=104]="scrollbar",ee[ee.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",ee[ee.scrollBeyondLastLine=106]="scrollBeyondLastLine",ee[ee.scrollPredominantAxis=107]="scrollPredominantAxis",ee[ee.selectionClipboard=108]="selectionClipboard",ee[ee.selectionHighlight=109]="selectionHighlight",ee[ee.selectOnLineNumbers=110]="selectOnLineNumbers",ee[ee.showFoldingControls=111]="showFoldingControls",ee[ee.showUnused=112]="showUnused",ee[ee.snippetSuggestions=113]="snippetSuggestions",ee[ee.smartSelect=114]="smartSelect",ee[ee.smoothScrolling=115]="smoothScrolling",ee[ee.stickyScroll=116]="stickyScroll",ee[ee.stickyTabStops=117]="stickyTabStops",ee[ee.stopRenderingLineAfter=118]="stopRenderingLineAfter",ee[ee.suggest=119]="suggest",ee[ee.suggestFontSize=120]="suggestFontSize",ee[ee.suggestLineHeight=121]="suggestLineHeight",ee[ee.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",ee[ee.suggestSelection=123]="suggestSelection",ee[ee.tabCompletion=124]="tabCompletion",ee[ee.tabIndex=125]="tabIndex",ee[ee.unicodeHighlighting=126]="unicodeHighlighting",ee[ee.unusualLineTerminators=127]="unusualLineTerminators",ee[ee.useShadowDOM=128]="useShadowDOM",ee[ee.useTabStops=129]="useTabStops",ee[ee.wordBreak=130]="wordBreak",ee[ee.wordSegmenterLocales=131]="wordSegmenterLocales",ee[ee.wordSeparators=132]="wordSeparators",ee[ee.wordWrap=133]="wordWrap",ee[ee.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",ee[ee.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",ee[ee.wordWrapColumn=136]="wordWrapColumn",ee[ee.wordWrapOverride1=137]="wordWrapOverride1",ee[ee.wordWrapOverride2=138]="wordWrapOverride2",ee[ee.wrappingIndent=139]="wrappingIndent",ee[ee.wrappingStrategy=140]="wrappingStrategy",ee[ee.showDeprecated=141]="showDeprecated",ee[ee.inlayHints=142]="inlayHints",ee[ee.editorClassName=143]="editorClassName",ee[ee.pixelRatio=144]="pixelRatio",ee[ee.tabFocusMode=145]="tabFocusMode",ee[ee.layoutInfo=146]="layoutInfo",ee[ee.wrappingInfo=147]="wrappingInfo",ee[ee.defaultColorDecorators=148]="defaultColorDecorators",ee[ee.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",ee[ee.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(Ue||(e.EditorOption=Ue={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Be(new r(Ue.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(11823,null)})),acceptSuggestionOnEnter:Be(new E(Ue.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(11824,null),""],markdownDescription:a.localize(11825,null)})),accessibilitySupport:Be(new k),accessibilityPageSize:Be(new g(Ue.accessibilityPageSize,"accessibilityPageSize",10,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(11826,null),tags:["accessibility"]})),ariaLabel:Be(new m(Ue.ariaLabel,"ariaLabel",a.localize(11827,null))),ariaRequired:Be(new r(Ue.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Be(new r(Ue.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:a.localize(11828,null),tags:["accessibility"]})),autoClosingBrackets:Be(new E(Ue.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(11829,null),a.localize(11830,null),""],description:a.localize(11831,null)})),autoClosingComments:Be(new E(Ue.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(11832,null),a.localize(11833,null),""],description:a.localize(11834,null)})),autoClosingDelete:Be(new E(Ue.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(11835,null),""],description:a.localize(11836,null)})),autoClosingOvertype:Be(new E(Ue.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(11837,null),""],description:a.localize(11838,null)})),autoClosingQuotes:Be(new E(Ue.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(11839,null),a.localize(11840,null),""],description:a.localize(11841,null)})),autoIndent:Be(new D(Ue.autoIndent,"autoIndent",y.Full,"full",["none","keep","brackets","advanced","full"],w,{enumDescriptions:[a.localize(11842,null),a.localize(11843,null),a.localize(11844,null),a.localize(11845,null),a.localize(11846,null)],description:a.localize(11847,null)})),automaticLayout:Be(new r(Ue.automaticLayout,"automaticLayout",!1)),autoSurround:Be(new E(Ue.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(11848,null),a.localize(11849,null),a.localize(11850,null),""],description:a.localize(11851,null)})),bracketPairColorization:Be(new Ie),bracketPairGuides:Be(new je),stickyTabStops:Be(new r(Ue.stickyTabStops,"stickyTabStops",!1,{description:a.localize(11852,null)})),codeLens:Be(new r(Ue.codeLens,"codeLens",!0,{description:a.localize(11853,null)})),codeLensFontFamily:Be(new m(Ue.codeLensFontFamily,"codeLensFontFamily","",{description:a.localize(11854,null)})),codeLensFontSize:Be(new g(Ue.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(11855,null)})),colorDecorators:Be(new r(Ue.colorDecorators,"colorDecorators",!0,{description:a.localize(11856,null)})),colorDecoratorActivatedOn:Be(new E(Ue.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[a.localize(11857,null),a.localize(11858,null),a.localize(11859,null)],description:a.localize(11860,null)})),colorDecoratorsLimit:Be(new g(Ue.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:a.localize(11861,null)})),columnSelection:Be(new r(Ue.columnSelection,"columnSelection",!1,{description:a.localize(11862,null)})),comments:Be(new P),contextmenu:Be(new r(Ue.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:Be(new r(Ue.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:a.localize(11863,null)})),cursorBlinking:Be(new D(Ue.cursorBlinking,"cursorBlinking",h.Blink,"blink",["blink","smooth","phase","expand","solid"],b,{description:a.localize(11864,null)})),cursorSmoothCaretAnimation:Be(new E(Ue.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[a.localize(11865,null),a.localize(11866,null),a.localize(11867,null)],description:a.localize(11868,null)})),cursorStyle:Be(new D(Ue.cursorStyle,"cursorStyle",M.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],F,{description:a.localize(11869,null)})),cursorSurroundingLines:Be(new g(Ue.cursorSurroundingLines,"cursorSurroundingLines",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(11870,null)})),cursorSurroundingLinesStyle:Be(new E(Ue.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(11871,null),a.localize(11872,null)],markdownDescription:a.localize(11873,null)})),cursorWidth:Be(new g(Ue.cursorWidth,"cursorWidth",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:a.localize(11874,null)})),disableLayerHinting:Be(new r(Ue.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:Be(new r(Ue.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:Be(new r(Ue.domReadOnly,"domReadOnly",!1)),dragAndDrop:Be(new r(Ue.dragAndDrop,"dragAndDrop",!0,{description:a.localize(11875,null)})),emptySelectionClipboard:Be(new B),dropIntoEditor:Be(new ct),stickyScroll:Be(new V),experimentalWhitespaceRendering:Be(new E(Ue.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[a.localize(11876,null),a.localize(11877,null),a.localize(11878,null)],description:a.localize(11879,null)})),extraEditorClassName:Be(new m(Ue.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:Be(new p(Ue.fastScrollSensitivity,"fastScrollSensitivity",5,ee=>ee<=0?5:ee,{markdownDescription:a.localize(11880,null)})),find:Be(new L),fixedOverflowWidgets:Be(new r(Ue.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:Be(new r(Ue.folding,"folding",!0,{description:a.localize(11881,null)})),foldingStrategy:Be(new E(Ue.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(11882,null),a.localize(11883,null)],description:a.localize(11884,null)})),foldingHighlight:Be(new r(Ue.foldingHighlight,"foldingHighlight",!0,{description:a.localize(11885,null)})),foldingImportsByDefault:Be(new r(Ue.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:a.localize(11886,null)})),foldingMaximumRegions:Be(new g(Ue.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:a.localize(11887,null)})),unfoldOnClickAfterEndOfLine:Be(new r(Ue.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(11888,null)})),fontFamily:Be(new m(Ue.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:a.localize(11889,null)})),fontInfo:Be(new fe),fontLigatures2:Be(new Y),fontSize:Be(new _),fontWeight:Be(new ge),fontVariations:Be(new Z),formatOnPaste:Be(new r(Ue.formatOnPaste,"formatOnPaste",!1,{description:a.localize(11890,null)})),formatOnType:Be(new r(Ue.formatOnType,"formatOnType",!1,{description:a.localize(11891,null)})),glyphMargin:Be(new r(Ue.glyphMargin,"glyphMargin",!0,{description:a.localize(11892,null)})),gotoLocation:Be(new se),hideCursorInOverviewRuler:Be(new r(Ue.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:a.localize(11893,null)})),hover:Be(new ae),inDiffEditor:Be(new r(Ue.inDiffEditor,"inDiffEditor",!1)),letterSpacing:Be(new p(Ue.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ee=>p.clamp(ee,-5,20),{description:a.localize(11894,null)})),lightbulb:Be(new X),lineDecorationsWidth:Be(new ve),lineHeight:Be(new ce),lineNumbers:Be(new ke),lineNumbersMinChars:Be(new g(Ue.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:Be(new r(Ue.linkedEditing,"linkedEditing",!1,{description:a.localize(11895,null)})),links:Be(new r(Ue.links,"links",!0,{description:a.localize(11896,null)})),matchBrackets:Be(new E(Ue.matchBrackets,"matchBrackets","always",["always","near","never"],{description:a.localize(11897,null)})),minimap:Be(new be),mouseStyle:Be(new E(Ue.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Be(new p(Ue.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,ee=>ee===0?1:ee,{markdownDescription:a.localize(11898,null)})),mouseWheelZoom:Be(new r(Ue.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:C.$k?a.localize(11899,null):a.localize(11900,null)})),multiCursorMergeOverlapping:Be(new r(Ue.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:a.localize(11901,null)})),multiCursorModifier:Be(new D(Ue.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],he,{markdownEnumDescriptions:[a.localize(11902,null),a.localize(11903,null)],markdownDescription:a.localize(11904,null)})),multiCursorPaste:Be(new E(Ue.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(11905,null),a.localize(11906,null)],markdownDescription:a.localize(11907,null)})),multiCursorLimit:Be(new g(Ue.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:a.localize(11908,null)})),occurrencesHighlight:Be(new E(Ue.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[a.localize(11909,null),a.localize(11910,null),a.localize(11911,null)],markdownDescription:a.localize(11912,null)})),overviewRulerBorder:Be(new r(Ue.overviewRulerBorder,"overviewRulerBorder",!0,{description:a.localize(11913,null)})),overviewRulerLanes:Be(new g(Ue.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:Be(new J),pasteAs:Be(new st),parameterHints:Be(new x),peekWidgetDefaultFocus:Be(new E(Ue.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(11914,null),a.localize(11915,null)],description:a.localize(11916,null)})),placeholder:Be(new pe),definitionLinkOpensInPeek:Be(new r(Ue.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:a.localize(11917,null)})),quickSuggestions:Be(new Ae),quickSuggestionsDelay:Be(new g(Ue.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(11918,null)})),readOnly:Be(new r(Ue.readOnly,"readOnly",!1)),readOnlyMessage:Be(new U),renameOnType:Be(new r(Ue.renameOnType,"renameOnType",!1,{description:a.localize(11919,null),markdownDeprecationMessage:a.localize(11920,null)})),renderControlCharacters:Be(new r(Ue.renderControlCharacters,"renderControlCharacters",!0,{description:a.localize(11921,null),restricted:!0})),renderFinalNewline:Be(new E(Ue.renderFinalNewline,"renderFinalNewline",C.$l?"dimmed":"on",["off","on","dimmed"],{description:a.localize(11922,null)})),renderLineHighlight:Be(new E(Ue.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(11923,null)],description:a.localize(11924,null)})),renderLineHighlightOnlyWhenFocus:Be(new r(Ue.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(11925,null)})),renderValidationDecorations:Be(new E(Ue.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Be(new E(Ue.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(11926,null),a.localize(11927,null),a.localize(11928,null),""],description:a.localize(11929,null)})),revealHorizontalRightPadding:Be(new g(Ue.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Be(new r(Ue.roundedSelection,"roundedSelection",!0,{description:a.localize(11930,null)})),rulers:Be(new Te),scrollbar:Be(new G),scrollBeyondLastColumn:Be(new g(Ue.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(11931,null)})),scrollBeyondLastLine:Be(new r(Ue.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:a.localize(11932,null)})),scrollPredominantAxis:Be(new r(Ue.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:a.localize(11933,null)})),selectionClipboard:Be(new r(Ue.selectionClipboard,"selectionClipboard",!0,{description:a.localize(11934,null),included:C.$l})),selectionHighlight:Be(new r(Ue.selectionHighlight,"selectionHighlight",!0,{description:a.localize(11935,null)})),selectOnLineNumbers:Be(new r(Ue.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:Be(new E(Ue.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[a.localize(11936,null),a.localize(11937,null),a.localize(11938,null)],description:a.localize(11939,null)})),showUnused:Be(new r(Ue.showUnused,"showUnused",!0,{description:a.localize(11940,null)})),showDeprecated:Be(new r(Ue.showDeprecated,"showDeprecated",!0,{description:a.localize(11941,null)})),inlayHints:Be(new te),snippetSuggestions:Be(new E(Ue.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(11942,null),a.localize(11943,null),a.localize(11944,null),a.localize(11945,null)],description:a.localize(11946,null)})),smartSelect:Be(new tt),smoothScrolling:Be(new r(Ue.smoothScrolling,"smoothScrolling",!1,{description:a.localize(11947,null)})),stopRenderingLineAfter:Be(new g(Ue.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:Be(new _e),inlineSuggest:Be(new ne),inlineEdit:Be(new de),inlineCompletionsAccessibilityVerbose:Be(new r(Ue.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:a.localize(11948,null)})),suggestFontSize:Be(new g(Ue.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(11949,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Be(new g(Ue.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(11950,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Be(new r(Ue.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:a.localize(11951,null)})),suggestSelection:Be(new E(Ue.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(11952,null),a.localize(11953,null),a.localize(11954,null)],description:a.localize(11955,null)})),tabCompletion:Be(new E(Ue.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(11956,null),a.localize(11957,null),a.localize(11958,null)],description:a.localize(11959,null)})),tabIndex:Be(new g(Ue.tabIndex,"tabIndex",0,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:Be(new Q),unusualLineTerminators:Be(new E(Ue.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(11960,null),a.localize(11961,null),a.localize(11962,null)],description:a.localize(11963,null)})),useShadowDOM:Be(new r(Ue.useShadowDOM,"useShadowDOM",!0)),useTabStops:Be(new r(Ue.useTabStops,"useTabStops",!0,{description:a.localize(11964,null)})),wordBreak:Be(new E(Ue.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[a.localize(11965,null),a.localize(11966,null)],description:a.localize(11967,null)})),wordSegmenterLocales:Be(new nt),wordSeparators:Be(new m(Ue.wordSeparators,"wordSeparators",$.$it,{description:a.localize(11968,null)})),wordWrap:Be(new E(Ue.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(11969,null),a.localize(11970,null),a.localize(11971,null),a.localize(11972,null)],description:a.localize(11973,null)})),wordWrapBreakAfterCharacters:Be(new m(Ue.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Be(new m(Ue.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Be(new g(Ue.wordWrapColumn,"wordWrapColumn",80,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:a.localize(11974,null)})),wordWrapOverride1:Be(new E(Ue.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Be(new E(Ue.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Be(new q),defaultColorDecorators:Be(new r(Ue.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:a.localize(11975,null)})),pixelRatio:Be(new me),tabFocusMode:Be(new r(Ue.tabFocusMode,"tabFocusMode",!1,{markdownDescription:a.localize(11976,null)})),layoutInfo:Be(new oe),wrappingInfo:Be(new ft),wrappingIndent:Be(new rt),wrappingStrategy:Be(new Ce)}}),define(Ne[106],Oe([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=void 0,e.$Ji=(0,v.$Ci)("environmentService"),e.$Ki=(0,v.$Di)(e.$Ji)}),define(Ne[29],Oe([1,0,58,19,12,14,2,9,3,20,15,48]),function(we,e,v,I,C,N,A,T,$,a,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.$Bl=e.FileKind=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.FileOperationResult=e.$tl=e.$sl=e.$rl=e.$pl=e.FileChangeType=e.$ol=e.FileOperation=e.$il=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$9k=void 0,e.$0k=c,e.$$k=o,e.$_k=l,e.$al=i,e.$bl=r,e.$cl=t,e.$dl=g,e.$el=u,e.$fl=p,e.$gl=m,e.$hl=d,e.$jl=w,e.$kl=k,e.$ll=P,e.$ml=h,e.$nl=b,e.$ql=B,e.$Cl=ge,e.$Dl=se,e.$Fl=$e,e.$9k=(0,$.$Ci)("fileService");function c(oe){return oe.create===!0}var S;(function(oe){oe[oe.Unknown=0]="Unknown",oe[oe.File=1]="File",oe[oe.Directory=2]="Directory",oe[oe.SymbolicLink=64]="SymbolicLink"})(S||(e.FileType=S={}));var f;(function(oe){oe[oe.Readonly=1]="Readonly",oe[oe.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var n;(function(oe){oe[oe.UPDATED=2]="UPDATED",oe[oe.ADDED=4]="ADDED",oe[oe.DELETED=8]="DELETED"})(n||(e.FileChangeFilter=n={}));function o(oe){const Ce=oe;return!!Ce&&typeof Ce.onDidChange=="function"}var s;(function(oe){oe[oe.None=0]="None",oe[oe.FileReadWrite=2]="FileReadWrite",oe[oe.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",oe[oe.FileReadStream=16]="FileReadStream",oe[oe.FileFolderCopy=8]="FileFolderCopy",oe[oe.PathCaseSensitive=1024]="PathCaseSensitive",oe[oe.Readonly=2048]="Readonly",oe[oe.Trash=4096]="Trash",oe[oe.FileWriteUnlock=8192]="FileWriteUnlock",oe[oe.FileAtomicRead=16384]="FileAtomicRead",oe[oe.FileAtomicWrite=32768]="FileAtomicWrite",oe[oe.FileAtomicDelete=65536]="FileAtomicDelete",oe[oe.FileClone=131072]="FileClone"})(s||(e.FileSystemProviderCapabilities=s={}));function l(oe){return!!(oe.capabilities&s.FileReadWrite)}function i(oe){return!!(oe.capabilities&s.FileFolderCopy)}function r(oe){return!!(oe.capabilities&s.FileClone)}function t(oe){return!!(oe.capabilities&s.FileOpenReadWriteClose)}function g(oe){return!!(oe.capabilities&s.FileReadStream)}function u(oe){return l(oe)?!!(oe.capabilities&s.FileAtomicRead):!1}function p(oe){return l(oe)?!!(oe.capabilities&s.FileAtomicWrite):!1}function m(oe){return!!(oe.capabilities&s.FileAtomicDelete)}function d(oe){return!!(oe.capabilities&s.Readonly)}var E;(function(oe){oe.FileExists="EntryExists",oe.FileNotFound="EntryNotFound",oe.FileNotADirectory="EntryNotADirectory",oe.FileIsADirectory="EntryIsADirectory",oe.FileExceedsStorageQuota="EntryExceedsStorageQuota",oe.FileTooLarge="EntryTooLarge",oe.FileWriteLocked="EntryWriteLocked",oe.NoPermissions="NoPermissions",oe.Unavailable="Unavailable",oe.Unknown="Unknown"})(E||(e.FileSystemProviderErrorCode=E={}));class D extends Error{static create(Ce,Fe){const X=new D(Ce.toString(),Fe);return P(X,Fe),X}constructor(Ce,Fe){super(Ce),this.code=Fe}}e.$il=D;function w(oe,Ce){return D.create(oe,Ce)}function k(oe){return oe||w((0,T.localize)(11219,null),E.Unknown)}function P(oe,Ce){return oe.name=Ce?`${Ce} (FileSystemError)`:"FileSystemError",oe}function h(oe){if(!oe)return E.Unknown;if(oe instanceof D)return oe.code;const Ce=/^(.+) \(FileSystemError\)$/.exec(oe.name);if(!Ce)return E.Unknown;switch(Ce[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}function b(oe){if(oe instanceof L)return oe.fileOperationResult;switch(h(oe)){case E.FileNotFound:return fe.FILE_NOT_FOUND;case E.FileIsADirectory:return fe.FILE_IS_DIRECTORY;case E.FileNotADirectory:return fe.FILE_NOT_DIRECTORY;case E.FileWriteLocked:return fe.FILE_WRITE_LOCKED;case E.NoPermissions:return fe.FILE_PERMISSION_DENIED;case E.FileExists:return fe.FILE_MOVE_CONFLICT;case E.FileTooLarge:return fe.FILE_TOO_LARGE;default:return fe.FILE_OTHER_ERROR}}var M;(function(oe){oe[oe.CREATE=0]="CREATE",oe[oe.DELETE=1]="DELETE",oe[oe.MOVE=2]="MOVE",oe[oe.COPY=3]="COPY",oe[oe.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class O{constructor(Ce,Fe,X){this.resource=Ce,this.operation=Fe,this.target=X}isOperation(Ce){return this.operation===Ce}}e.$ol=O;var F;(function(oe){oe[oe.UPDATED=0]="UPDATED",oe[oe.ADDED=1]="ADDED",oe[oe.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class q{static{this.a=null}constructor(Ce,Fe){this.c=Fe,this.b=void 0,this.d=new y.$T(()=>{const X=v.$Ii.forUris(()=>this.c);return X.fill(this.rawAdded.map(V=>[V,!0])),X}),this.f=new y.$T(()=>{const X=v.$Ii.forUris(()=>this.c);return X.fill(this.rawUpdated.map(V=>[V,!0])),X}),this.g=new y.$T(()=>{const X=v.$Ii.forUris(()=>this.c);return X.fill(this.rawDeleted.map(V=>[V,!0])),X}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const X of Ce){switch(X.type){case F.ADDED:this.rawAdded.push(X.resource);break;case F.UPDATED:this.rawUpdated.push(X.resource);break;case F.DELETED:this.rawDeleted.push(X.resource);break}this.b!==q.a&&(typeof X.cId=="number"?this.b===void 0?this.b=X.cId:this.b!==X.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(Ce,...Fe){return this.h(Ce,{includeChildren:!1},...Fe)}affects(Ce,...Fe){return this.h(Ce,{includeChildren:!0},...Fe)}h(Ce,Fe,...X){if(!Ce)return!1;const V=X.length>0;return!!((!V||X.includes(F.ADDED))&&(this.d.value.get(Ce)||Fe.includeChildren&&this.d.value.findSuperstr(Ce))||(!V||X.includes(F.UPDATED))&&(this.f.value.get(Ce)||Fe.includeChildren&&this.f.value.findSuperstr(Ce))||(!V||X.includes(F.DELETED))&&(this.g.value.findSubstr(Ce)||Fe.includeChildren&&this.g.value.findSuperstr(Ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Ce){return this.b===Ce}hasCorrelation(){return typeof this.b=="number"}}e.$pl=q;function B(oe,Ce,Fe){return!oe||!Ce||oe===Ce||Ce.length>oe.length?!1:(Ce.charAt(Ce.length-1)!==I.sep&&(Ce+=I.sep),Fe?(0,C.$Ef)(oe,Ce):oe.indexOf(Ce)===0)}class L extends Error{constructor(Ce,Fe,X){super(Ce),this.fileOperationResult=Fe,this.options=X}}e.$rl=L;class Y extends L{constructor(Ce,Fe,X,V){super(Ce,Fe,V),this.fileOperationResult=Fe,this.size=X}}e.$sl=Y;class Z extends L{constructor(Ce,Fe,X){super(Ce,fe.FILE_NOT_MODIFIED_SINCE,X),this.stat=Fe}}e.$tl=Z;var fe;(function(oe){oe[oe.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",oe[oe.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",oe[oe.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",oe[oe.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",oe[oe.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",oe[oe.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",oe[oe.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",oe[oe.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",oe[oe.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",oe[oe.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",oe[oe.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(fe||(e.FileOperationResult=fe={})),e.$ul={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$vl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$wl="files.associations",e.$xl="files.exclude",e.$yl="files.readonlyInclude",e.$zl="files.readonlyExclude",e.$Al="files.readonlyFromPermissions";var _;(function(oe){oe[oe.FILE=0]="FILE",oe[oe.FOLDER=1]="FOLDER",oe[oe.ROOT_FOLDER=2]="ROOT_FOLDER"})(_||(e.FileKind=_={})),e.$Bl="";function ge(oe){if(!(typeof oe.size!="number"||typeof oe.mtime!="number"))return oe.mtime.toString(29)+oe.size.toString(31)}async function se(oe,Ce){if(!Ce.hasProvider(A.URI.from({scheme:oe.scheme})))return new Promise(Fe=>{const X=Ce.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===oe.scheme&&V.added&&(X.dispose(),Fe())})})}class ae{static{this.KB=1024}static{this.MB=ae.KB*ae.KB}static{this.GB=ae.MB*ae.KB}static{this.TB=ae.GB*ae.KB}static formatSize(Ce){return(0,N.$gg)(Ce)||(Ce=0),Ce<ae.KB?(0,T.localize)(11220,null,Ce.toFixed(0)):Ce<ae.MB?(0,T.localize)(11221,null,(Ce/ae.KB).toFixed(2)):Ce<ae.GB?(0,T.localize)(11222,null,(Ce/ae.MB).toFixed(2)):Ce<ae.TB?(0,T.localize)(11223,null,(Ce/ae.GB).toFixed(2)):(0,T.localize)(11224,null,(Ce/ae.TB).toFixed(2))}}e.$El=ae;function $e(oe){const Ce=typeof oe=="string"||oe?.scheme===R.Schemas.vscodeRemote;return typeof oe!="string"&&oe?.scheme===R.Schemas.file?1024*ae.MB:Ce?10*ae.MB:a.$p?50*ae.MB:1024*ae.MB}}),define(Ne[74],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=void 0;class v{constructor(...C){this.a=new Map;for(const[N,A]of C)this.set(N,A)}set(C,N){const A=this.a.get(C);return this.a.set(C,N),A}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$Ai=v}),define(Ne[169],Oe([1,0,10,13,4,73,166,3,74,170]),function(we,e,v,I,C,N,A,T,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=e.$sr=void 0;const R=!1;class y extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class c{constructor(o=new $.$Ai,s=!1,l,i=R){this.i=o,this.j=s,this.k=l,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(T.$Bi,this),this._globalGraph=i?l?._globalGraph??new A.$rr(r=>r):void 0}dispose(){if(!this.f){this.f=!0,(0,C.$Oc)(this.h),this.h.clear();for(const o of this.g)(0,C.$Nc)(o)&&o.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(o,s){this.m();const l=this,i=new class extends c{dispose(){l.h.delete(i),super.dispose()}}(o,this.j,this,this.l);return this.h.add(i),s?.add(i),i}invokeFunction(o,...s){this.m();const l=f.traceInvocation(this.l,o);let i=!1;try{return o({get:t=>{if(i)throw(0,I.$7)("service accessor is only valid during the invocation of its target method");const g=this.s(t,l);if(!g)throw new Error(`[invokeFunction] unknown service '${t}'`);return g}},...s)}finally{i=!0,l.stop()}}createInstance(o,...s){this.m();let l,i;return o instanceof N.$zi?(l=f.traceCreation(this.l,o.ctor),i=this.o(o.ctor,o.staticArguments.concat(s),l)):(l=f.traceCreation(this.l,o),i=this.o(o,s,l)),l.stop(),i}o(o,s=[],l){const i=T._util.getServiceDependencies(o).sort((g,u)=>g.index-u.index),r=[];for(const g of i){const u=this.s(g.id,l);u||this.y(`[createInstance] ${o.name} depends on UNKNOWN service ${g.id}.`,!1),r.push(u)}const t=i.length>0?i[0].index:s.length;if(s.length!==t){console.trace(`[createInstance] First service dependency of ${o.name} at position ${t+1} conflicts with ${s.length} static arguments`);const g=t-s.length;g>0?s=s.concat(new Array(g)):s=s.slice(0,t)}return Reflect.construct(o,s.concat(r))}q(o,s){if(this.i.get(o)instanceof N.$zi)this.i.set(o,s);else if(this.k)this.k.q(o,s);else throw new Error("illegalState - setting UNKNOWN service instance")}r(o){const s=this.i.get(o);return!s&&this.k?this.k.r(o):s}s(o,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const l=this.r(o);return l instanceof N.$zi?this.u(o,l,s.branch(o,!0)):(s.branch(o,!1),l)}u(o,s,l){if(this.t.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.t.add(o);try{return this.v(o,s,l)}finally{this.t.delete(o)}}v(o,s,l){const i=new A.$rr(u=>u.id.toString());let r=0;const t=[{id:o,desc:s,_trace:l}],g=new Set;for(;t.length;){const u=t.pop();if(!g.has(String(u.id))){if(g.add(String(u.id)),i.lookupOrInsertNode(u),r++>1e3)throw new y(i);for(const p of T._util.getServiceDependencies(u.desc.ctor)){const m=this.r(p.id);if(m||this.y(`[createInstance] ${o} depends on ${p.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(u.id),String(p.id)),m instanceof N.$zi){const d={id:p.id,desc:m,_trace:u._trace.branch(p.id,!0)};i.insertEdge(u,d),t.push(d)}}}}for(;;){const u=i.roots();if(u.length===0){if(!i.isEmpty())throw new y(i);break}for(const{data:p}of u){if(this.r(p.id)instanceof N.$zi){const d=this.w(p.id,p.desc.ctor,p.desc.staticArguments,p.desc.supportsDelayedInstantiation,p._trace);this.q(p.id,d)}i.removeNode(p)}}return this.r(o)}w(o,s,l=[],i,r){if(this.i.get(o)instanceof N.$zi)return this.x(o,s,l,i,r,this.g);if(this.k)return this.k.w(o,s,l,i,r);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}x(o,s,l=[],i,r,t){if(i){const g=new c(void 0,this.j,this,this.l);g.c=String(o);const u=new Map,p=new v.$Vh(()=>{const m=g.o(s,l,r);for(const[d,E]of u){const D=m[d];if(typeof D=="function")for(const w of E)w.disposable=D.apply(m,w.listener)}return u.clear(),t.add(m),m});return new Proxy(Object.create(null),{get(m,d){if(!p.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let w=u.get(d);return w||(w=new a.$4c,u.set(d,w)),(P,h,b)=>{if(p.isInitialized)return p.value[d](P,h,b);{const M={listener:[P,h,b],disposable:void 0},O=w.push(M);return(0,C.$Rc)(()=>{O(),M.disposable?.dispose()})}}}if(d in m)return m[d];const E=p.value;let D=E[d];return typeof D!="function"||(D=D.bind(E),m[d]=D),D},set(m,d,E){return p.value[d]=E,!0},getPrototypeOf(m){return s.prototype}})}else{const g=this.o(s,l,r);return t.add(g),g}}y(o,s){if(s&&console.warn(o),this.j)throw new Error(o)}}e.$sr=c;var S;(function(n){n[n.None=0]="None",n[n.Creation=1]="Creation",n[n.Invocation=2]="Invocation",n[n.Branch=3]="Branch"})(S||(S={}));class f{static{this.all=new Set}static{this.c=new class extends f{constructor(){super(S.None,null)}stop(){}branch(){return this}}}static traceInvocation(o,s){return o?new f(S.Invocation,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(o,s){return o?new f(S.Creation,s.name):f.c}static{this.f=0}constructor(o,s){this.type=o,this.name=s,this.g=Date.now(),this.h=[]}branch(o,s){const l=new f(S.Branch,o.toString());return this.h.push([o,s,l]),l}stop(){const o=Date.now()-this.g;f.f+=o;let s=!1;function l(r,t){const g=[],u=new Array(r+1).join("	");for(const[p,m,d]of t.h)if(m&&d){s=!0,g.push(`${u}CREATES -> ${p}`);const E=l(r+1,d);E&&g.push(E)}else g.push(`${u}uses -> ${p}`);return g.join(`
`)}const i=[`${this.type===S.Creation?"CREATE":"CALL"} ${this.name}`,`${l(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(o>2||s)&&f.all.add(i.join(`
`))}}e.$tr=f}),define(Ne[11],Oe([1,0,9,42,6,75,4,28,20,23,14,2,31,3]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$_j=e.LogLevel=e.$0j=e.$9j=void 0,e.$$j=n,e.log=s,e.$kk=D,e.$lk=w,e.$mk=k,e.$nk=P,v=Ve(v),e.$9j=(0,S.$Ci)("logService"),e.$0j=(0,S.$Ci)("loggerService");function f(){return new Date().toISOString()}function n(h){return(0,R.$gg)(h)}var o;(function(h){h[h.Off=0]="Off",h[h.Trace=1]="Trace",h[h.Debug=2]="Debug",h[h.Info=3]="Info",h[h.Warning=4]="Warning",h[h.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$_j=o.Info;function s(h,b,M){switch(b){case o.Trace:h.trace(M);break;case o.Debug:h.debug(M);break;case o.Info:h.info(M);break;case o.Warning:h.warn(M);break;case o.Error:h.error(M);break;case o.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function l(h,b=!1){let M="";for(let O=0;O<h.length;O++){let F=h[O];if(F instanceof Error&&(F=(0,I.$nj)(F,b)),typeof F=="object")try{F=JSON.stringify(F)}catch{}M+=(O>0?" ":"")+F}return M}class i extends A.$Tc{constructor(){super(...arguments),this.b=e.$_j,this.c=this.B(new C.$je),this.onDidChangeLogLevel=this.c.event}setLevel(b){this.b!==b&&(this.b=b,this.c.fire(this.b))}getLevel(){return this.b}f(b){return this.b!==o.Off&&this.b<=b}}e.$bk=i;class r extends i{constructor(b){super(),this.h=b}f(b){return this.h||super.f(b)}trace(b,...M){this.f(o.Trace)&&this.g(o.Trace,l([b,...M],!0))}debug(b,...M){this.f(o.Debug)&&this.g(o.Debug,l([b,...M]))}info(b,...M){this.f(o.Info)&&this.g(o.Info,l([b,...M]))}warn(b,...M){this.f(o.Warning)&&this.g(o.Warning,l([b,...M]))}error(b,...M){if(this.f(o.Error))if(b instanceof Error){const O=Array.prototype.slice.call(arguments);O[0]=b.stack,this.g(o.Error,l(O))}else this.g(o.Error,l([b,...M]))}flush(){}}e.$ck=r;class t extends i{constructor(b=e.$_j){super(),this.setLevel(b),this.g=!$.$j}trace(b,...M){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,b,...M):console.log(`[main ${f()}]`,b,...M))}debug(b,...M){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,b,...M):console.log(`[main ${f()}]`,b,...M))}info(b,...M){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,b,...M):console.log(`[main ${f()}]`,b,...M))}warn(b,...M){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,b,...M):console.warn(`[main ${f()}]`,b,...M))}error(b,...M){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,b,...M):console.error(`[main ${f()}]`,b,...M))}flush(){}}e.$dk=t;class g extends i{constructor(b=e.$_j,M=!0){super(),this.g=M,this.setLevel(b)}trace(b,...M){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",b,...M):console.log(b,...M))}debug(b,...M){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",b,...M):console.log(b,...M))}info(b,...M){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",b,...M):console.log(b,...M))}warn(b,...M){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",b,...M):console.log(b,...M))}error(b,...M){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",b,...M):console.error(b,...M))}flush(){}}e.$ek=g;class u extends i{constructor(b,M=e.$_j){super(),this.g=b,this.setLevel(M)}trace(b,...M){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(b),...M])}debug(b,...M){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(b),...M])}info(b,...M){this.f(o.Info)&&this.g.log(o.Info,[this.h(b),...M])}warn(b,...M){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(b),...M])}error(b,...M){this.f(o.Error)&&this.g.log(o.Error,[this.h(b),...M])}h(b){return typeof b=="string"?b:(0,I.$nj)(b,this.f(o.Trace))}flush(){}}e.$fk=u;class p extends i{constructor(b){super(),this.g=b,b.length&&this.setLevel(b[0].getLevel())}setLevel(b){for(const M of this.g)M.setLevel(b);super.setLevel(b)}trace(b,...M){for(const O of this.g)O.trace(b,...M)}debug(b,...M){for(const O of this.g)O.debug(b,...M)}info(b,...M){for(const O of this.g)O.info(b,...M)}warn(b,...M){for(const O of this.g)O.warn(b,...M)}error(b,...M){for(const O of this.g)O.error(b,...M)}flush(){for(const b of this.g)b.flush()}dispose(){for(const b of this.g)b.dispose();super.dispose()}}e.$gk=p;class m extends A.$Tc{constructor(b,M,O){if(super(),this.h=b,this.j=M,this.b=new T.$zc,this.c=this.B(new C.$je),this.onDidChangeLoggers=this.c.event,this.f=this.B(new C.$je),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new C.$je),this.onDidChangeVisibility=this.g.event,O)for(const F of O)this.b.set(F.resource,{logger:void 0,info:F})}m(b){return(0,R.$cg)(b)?[...this.b.values()].find(M=>M.info.id===b):this.b.get(b)}getLogger(b){return this.m(b)?.logger}createLogger(b,M){const O=this.n(b),F=(0,R.$cg)(b)?b:M?.id??(0,N.$qj)(O.toString()).toString(16);let q=this.b.get(O)?.logger;const B=M?.logLevel==="always"?o.Trace:M?.logLevel;q||(q=this.s(O,B??this.getLogLevel(O)??this.h,{...M,id:F}));const L={logger:q,info:{resource:O,id:F,logLevel:B,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(L.info),this.b.set(O,L),q}n(b){return(0,R.$cg)(b)?(0,a.$dh)(this.j,`${b}.log`):b}setLogLevel(b,M){if(y.URI.isUri(b)){const O=b,F=M,q=this.b.get(O);q&&F!==q.info.logLevel&&(q.info.logLevel=F===this.h?void 0:F,q.logger?.setLevel(F),this.b.set(q.info.resource,q),this.f.fire([O,F]))}else{this.h=b;for(const[O,F]of this.b.entries())this.b.get(O)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(b,M){const O=this.m(b);O&&M!==!O.info.hidden&&(O.info.hidden=!M,this.b.set(O.info.resource,O),this.g.fire([O.info.resource,M]))}getLogLevel(b){let M;return b&&(M=this.b.get(b)?.info.logLevel),M??this.h}registerLogger(b){const M=this.b.get(b.resource);M?M.info.hidden!==b.hidden&&this.setVisibility(b.resource,!b.hidden):(this.b.set(b.resource,{info:b,logger:void 0}),this.c.fire({added:[b],removed:[]}))}deregisterLogger(b){const M=this.b.get(b);M&&(M.logger&&M.logger.dispose(),this.b.delete(b),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const b of this.b.values())yield b.info}getRegisteredLogger(b){return this.b.get(b)?.info}dispose(){this.b.forEach(b=>b.logger?.dispose()),this.b.clear(),super.dispose()}}e.$hk=m;class d{constructor(){this.onDidChangeLogLevel=new C.$je().event}setLevel(b){}getLevel(){return o.Info}trace(b,...M){}debug(b,...M){}info(b,...M){}warn(b,...M){}error(b,...M){}critical(b,...M){}dispose(){}flush(){}}e.$ik=d;class E extends d{}e.$jk=E;function D(h){if(h.verbose)return o.Trace;if(typeof h.logLevel=="string"){const b=P(h.logLevel.toLowerCase());if(b!==void 0)return b}return e.$_j}function w(h){switch(h){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function k(h){switch(h){case o.Trace:return{original:"Trace",value:v.localize(11152,null)};case o.Debug:return{original:"Debug",value:v.localize(11153,null)};case o.Info:return{original:"Info",value:v.localize(11154,null)};case o.Warning:return{original:"Warning",value:v.localize(11155,null)};case o.Error:return{original:"Error",value:v.localize(11156,null)};case o.Off:return{original:"Off",value:v.localize(11157,null)}}}function P(h){switch(h){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$ok=new c.$Tj("logLevel",w(o.Info))}),define(Ne[171],Oe([1,0,4,11]),function(we,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oR=void 0;class C extends v.$Tc{constructor(A,T=[]){super(),this.a=new I.$gk([A,...T]),this.B(A.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...T){this.a.trace(A,...T)}debug(A,...T){this.a.debug(A,...T)}info(A,...T){this.a.info(A,...T)}warn(A,...T){this.a.warn(A,...T)}error(A,...T){this.a.error(A,...T)}flush(){this.a.flush()}}e.$oR=C});var _t=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Ne[107],Oe([1,0,35,9,3]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,v=_t(v);var N;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(N||(e.MarkerTag=N={}));var A;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function($){function a(f,n){return n-f}$.compare=a;const R=Object.create(null);R[$.Error]=(0,I.localize)(11149,null),R[$.Warning]=(0,I.localize)(11150,null),R[$.Info]=(0,I.localize)(11151,null);function y(f){return R[f]||""}$.toString=y;function c(f){switch(f){case v.default.Error:return $.Error;case v.default.Warning:return $.Warning;case v.default.Info:return $.Info;case v.default.Ignore:return $.Hint}}$.fromSeverity=c;function S(f){switch(f){case $.Error:return v.default.Error;case $.Warning:return v.default.Warning;case $.Info:return v.default.Info;case $.Hint:return v.default.Ignore}}$.toSeverity=S}(A||(e.MarkerSeverity=A={}));var T;(function($){const a="";function R(c){return y(c,!0)}$.makeKey=R;function y(c,S){const f=[a];return c.source?f.push(c.source.replace("\xA6","\\\xA6")):f.push(a),c.code?typeof c.code=="string"?f.push(c.code.replace("\xA6","\\\xA6")):f.push(c.code.value.replace("\xA6","\\\xA6")):f.push(a),c.severity!==void 0&&c.severity!==null?f.push(A.toString(c.severity)):f.push(a),c.message&&S?f.push(c.message.replace("\xA6","\\\xA6")):f.push(a),c.startLineNumber!==void 0&&c.startLineNumber!==null?f.push(c.startLineNumber.toString()):f.push(a),c.startColumn!==void 0&&c.startColumn!==null?f.push(c.startColumn.toString()):f.push(a),c.endLineNumber!==void 0&&c.endLineNumber!==null?f.push(c.endLineNumber.toString()):f.push(a),c.endColumn!==void 0&&c.endColumn!==null?f.push(c.endColumn.toString()):f.push(a),f.push(a),f.join("\xA6")}$.makeKeyOptionalMessage=y})(T||(e.IMarkerData=T={})),e.$Bu=(0,C.$Ci)("markerService")});var _t=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Ne[172],Oe([1,0,6,35,3]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rw=e.$qw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$ow=e.Severity=void 0,e.$pw=T,I=_t(I),e.Severity=I.default,e.$ow=(0,C.$Ci)("notificationService");var N;(function(y){y[y.DEFAULT=0]="DEFAULT",y[y.SILENT=1]="SILENT",y[y.URGENT=2]="URGENT"})(N||(e.NotificationPriority=N={}));var A;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.PROFILE=1]="PROFILE",y[y.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function T(y){if(y){const c=y;return typeof c.id=="string"&&typeof c.label=="string"}return!1}var $;(function(y){y[y.OFF=0]="OFF",y[y.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class a{constructor(){this.progress=new R,this.onDidClose=v.Event.None,this.onDidChangeVisibility=v.Event.None}updateSeverity(c){}updateMessage(c){}updateActions(c){}close(){}}e.$qw=a;class R{infinite(){}done(){}total(c){}worked(c){}}e.$rw=R}),define(Ne[108],Oe([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qk=e.$pk=void 0,e.$pk=(0,v.$Ci)("productService"),e.$qk="vscode://schemas/vscode-product"});var Qe=this&&this.__decorate||function(we,e,v,I){var C=arguments.length,N=C<3?e:I===null?I=Object.getOwnPropertyDescriptor(e,v):I,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(we,e,v,I);else for(var T=we.length-1;T>=0;T--)(A=we[T])&&(N=(C<3?A(N):C>3?A(e,v,N):A(e,v))||N);return C>3&&N&&Object.defineProperty(e,v,N),N},qe=this&&this.__param||function(we,e){return function(v,I){e(v,I,we)}};define(Ne[76],Oe([1,0,10,21,4,3]),function(we,e,v,I,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yw=e.$xw=e.$ww=e.$vw=e.$uw=e.$tw=e.ProgressLocation=e.$sw=void 0,e.$sw=(0,N.$Ci)("progressService");var A;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$tw=Object.freeze({total(){},worked(){},done(){}});class T{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(c){this.b=c}report(c){this.a=c,this.b(this.a)}}e.$uw=T;class ${get value(){return this.a}constructor(c){this.e=c}report(c){this.b?this.b.push(c):this.b=[c],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const c=this.b.shift();this.a=c,await this.e(this.a)}}finally{this.c=!1;const c=this.d;this.d=void 0,c?.()}}drain(){return this.c?new Promise(c=>{const S=this.d;this.d=()=>{S?.(),c()}}):Promise.resolve()}}e.$vw=$;let a=class extends C.$Tc{constructor(c,S){super(),this.a=new v.$Zh,S.withProgress(c,f=>(this.b=f,this.c&&f.report(this.c),this.a.p)),this.B((0,C.$Rc)(()=>this.a.complete()))}report(c){this.b?this.b.report(c):this.c=c}};e.$ww=a,e.$ww=a=Qe([qe(1,e.$sw)],a);class R extends C.$Tc{constructor(c){super(),this.g=c,this.a=0,this.b=this.B(new C.$Sc)}start(c){this.stop();const S=++this.a,f=new I.$ue;return this.f=setTimeout(()=>{S===this.a&&(this.c=this.g.show(!0))},c),this.b.add((0,C.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,C.$Rc)(()=>f.cancel())),this.b.add((0,C.$Rc)(()=>this.c?this.c.done():void 0)),{id:S,token:f.token,stop:()=>this.h(S),isCurrent:()=>this.a===S}}stop(){this.h(this.a)}h(c){this.a===c&&this.b.clear()}}e.$xw=R,e.$yw=(0,N.$Ci)("editorProgressService")}),define(Ne[30],Oe([1,0,61,14]),function(we,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=void 0,v=Ve(v),I=Ve(I);class C{constructor(){this.a=new Map}add(A,T){v.ok(I.$cg(A)),v.ok(I.$eg(T)),v.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,T)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$no=new C}),define(Ne[77],Oe([1,0,6,30]),function(we,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=void 0,I=Ve(I),e.$oo={JSONContribution:"base.contributions.json"};function C(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class N{constructor(){this.b=new v.$je,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,a){this.a[C($)]=a,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const A=new N;I.$no.add(e.$oo.JSONContribution,A)}),define(Ne[53],Oe([1,0,17,6,14,9,43,77,30]),function(we,e,v,I,C,N,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.ConfigurationScope=e.$so=e.EditPresentationTypes=void 0,e.$Do=n,e.$Eo=o,e.$Fo=s,e.$Go=i,e.$Ho=r,e.$Io=t,e.$Jo=g,C=Ve(C),N=Ve(N);var a;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$so={Configuration:"base.contributions.configuration"};var R;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$to={properties:{},patternProperties:{}},e.$uo={properties:{},patternProperties:{}},e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo="vscode://schemas/settings/resourceLanguage",e.$Ao="vscode://schemas/settings/configurationDefaults";const y=$.$no.as(T.$oo.JSONContribution);class c{constructor(){this.h=new Set,this.i=new I.$je,this.onDidSchemaChange=this.i.event,this.j=new I.$je,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:N.localize(11444,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$zo,this.g),this.v()}registerConfiguration(p,m=!0){this.registerConfigurations([p],m)}registerConfigurations(p,m=!0){const d=new Set;this.n(p,m,d),y.registerSchema(e.$zo,this.g),this.i.fire(),this.j.fire({properties:d})}deregisterConfigurations(p){const m=new Set;this.o(p,m),y.registerSchema(e.$zo,this.g),this.i.fire(),this.j.fire({properties:m})}updateConfigurations({add:p,remove:m}){const d=new Set;this.o(m,d),this.n(p,!1,d),y.registerSchema(e.$zo,this.g),this.i.fire(),this.j.fire({properties:d})}registerDefaultConfigurations(p){const m=new Set;this.k(p,m),this.i.fire(),this.j.fire({properties:m,defaultsOverrides:!0})}k(p,m){const d=[];for(const{overrides:E,source:D}of p)for(const w in E)if(m.add(w),e.$Co.test(w)){const k=this.a.get(w),P=k?.valuesSources??new Map,h=k?.value||{};for(const O of Object.keys(E[w])){const F=E[w][O];if(C.$eg(F)&&(C.$jg(h[O])||C.$eg(h[O]))){if(h[O]={...h[O]??{},...F},D){let B=P.get(O);if(B||(B=new Map,P.set(O,B)),!(B instanceof Map)){console.error("objectConfigurationSources is not a Map");continue}for(const L in F)B.set(L,D)}}else h[O]=F,D&&P.set(O,D)}this.a.set(w,{source:D,value:h,valuesSources:P});const b=(0,A.$gj)(w),M={type:"object",default:h,description:N.localize(11445,null,b),$ref:e.$zo,defaultDefaultValue:h,source:C.$cg(D)?void 0:D,defaultValueSource:D};d.push(...n(w)),this.d[w]=M,this.b.properties[w]=M}else{const k=this.d[w],P=this.a.get(w);let h=P?.value??k?.defaultDefaultValue,b=E[w],M=D;if(C.$eg(b)&&(k!==void 0&&k.type==="object"||k===void 0&&(C.$jg(h)||C.$eg(h)))){if(C.$eg(h)||(h={}),b={...h,...b},M=P?.source??new Map,!(M instanceof Map)){console.error("defaultValueSource is not a Map");continue}for(const F in E[w])D?M.set(F,D):M.delete(F)}this.a.set(w,{value:b,source:M}),k&&(this.w(w,k),this.r(w,k))}this.m(d)}deregisterDefaultConfigurations(p){const m=new Set;this.l(p,m),this.i.fire(),this.j.fire({properties:m,defaultsOverrides:!0})}l(p,m){for(const{overrides:d,source:E}of p)for(const D in d){const w=C.$cg(E)?E:E?.id,k=this.a.get(D);if(k){if(e.$Co.test(D)){for(const h of Object.keys(d[D])){const b=d[D][h];if(C.$eg(b)){const M=k.valuesSources?.get(h);for(const O of Object.keys(b)){const F=M?.get(O);(C.$cg(F)?F:F?.id)===w&&(M?.delete(O),delete k.value[h][O])}Object.keys(k.value[h]).length===0&&(delete k.value[h],k.valuesSources?.delete(h))}else{const M=k.valuesSources?.get(h);(C.$cg(M)?M:M?.id)===w&&(k.valuesSources?.delete(h),delete k.value[h])}}const P=this.a.get(D);P&&Object.keys(P.value).length===0&&(this.a.delete(D),delete this.d[D],delete this.b.properties[D])}else{if(k.source instanceof Map){const h=k.source;for(const b in d[D]){const M=h.get(b);(C.$cg(M)?M:M?.id)===w&&(h.delete(b),delete k.value[b])}h.size===0&&this.a.delete(D)}else{const h=C.$cg(k.source)?k.source:k.source?.id;if(w!==h)continue;this.a.delete(D)}const P=this.d[D];P&&(this.w(D,P),this.r(D,P))}m.add(D)}}this.u()}deltaConfiguration(p){let m=!1;const d=new Set;p.removedDefaults&&(this.l(p.removedDefaults,d),m=!0),p.addedDefaults&&(this.k(p.addedDefaults,d),m=!0),p.removedConfigurations&&this.o(p.removedConfigurations,d),p.addedConfigurations&&this.n(p.addedConfigurations,!1,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:m})}notifyConfigurationSchemaUpdated(...p){this.i.fire()}registerOverrideIdentifiers(p){this.m(p),this.i.fire()}m(p){for(const m of p)this.h.add(m);this.u()}n(p,m,d){p.forEach(E=>{this.p(E,m,E.extensionInfo,E.restrictedProperties,void 0,d),this.c.push(E),this.q(E)})}o(p,m){const d=E=>{if(E.properties)for(const D in E.properties){m.add(D);const w=this.d[D];w?.policy?.name&&this.e.delete(w.policy.name),delete this.d[D],this.s(D,E.properties[D])}E.allOf?.forEach(D=>d(D))};for(const E of p){d(E);const D=this.c.indexOf(E);D!==-1&&this.c.splice(D,1)}}p(p,m=!0,d,E,D=R.WINDOW,w){D=C.$lg(p.scope)?D:p.scope;const k=p.properties;if(k)for(const h in k){const b=k[h];if(m&&i(h,b)){delete k[h];continue}if(b.source=d,b.defaultDefaultValue=k[h].default,this.w(h,b),e.$Co.test(h)?b.scope=void 0:(b.scope=C.$lg(b.scope)?D:b.scope,b.restricted=C.$lg(b.restricted)?!!E?.includes(h):b.restricted),k[h].hasOwnProperty("included")&&!k[h].included){this.f[h]=k[h],delete k[h];continue}else this.d[h]=k[h],k[h].policy?.name&&this.e.set(k[h].policy.name,h);!k[h].deprecationMessage&&k[h].markdownDeprecationMessage&&(k[h].deprecationMessage=k[h].markdownDeprecationMessage),w.add(h)}const P=p.allOf;if(P)for(const h of P)this.p(h,m,d,E,D,w)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(p){const m=d=>{const E=d.properties;if(E)for(const w in E)this.r(w,E[w]);d.allOf?.forEach(m)};m(p)}r(p,m){switch(e.$to.properties[p]=m,m.scope){case R.APPLICATION:e.$uo.properties[p]=m;break;case R.MACHINE:e.$vo.properties[p]=m;break;case R.MACHINE_OVERRIDABLE:e.$wo.properties[p]=m;break;case R.WINDOW:e.$xo.properties[p]=m;break;case R.RESOURCE:e.$yo.properties[p]=m;break;case R.LANGUAGE_OVERRIDABLE:e.$yo.properties[p]=m,this.g.properties[p]=m;break}}s(p,m){switch(delete e.$to.properties[p],m.scope){case R.APPLICATION:delete e.$uo.properties[p];break;case R.MACHINE:delete e.$vo.properties[p];break;case R.MACHINE_OVERRIDABLE:delete e.$wo.properties[p];break;case R.WINDOW:delete e.$xo.properties[p];break;case R.RESOURCE:case R.LANGUAGE_OVERRIDABLE:delete e.$yo.properties[p],delete this.g.properties[p];break}}u(){for(const p of this.h.values()){const m=`[${p}]`,d={type:"object",description:N.localize(11446,null),errorMessage:N.localize(11447,null),$ref:e.$zo};this.w(m,d),e.$to.properties[m]=d,e.$uo.properties[m]=d,e.$vo.properties[m]=d,e.$wo.properties[m]=d,e.$xo.properties[m]=d,e.$yo.properties[m]=d}}v(){const p={type:"object",description:N.localize(11448,null),errorMessage:N.localize(11449,null),$ref:e.$zo};e.$to.patternProperties[e.$Bo]=p,e.$uo.patternProperties[e.$Bo]=p,e.$vo.patternProperties[e.$Bo]=p,e.$wo.patternProperties[e.$Bo]=p,e.$xo.patternProperties[e.$Bo]=p,e.$yo.patternProperties[e.$Bo]=p,this.i.fire()}w(p,m){const d=this.a.get(p);let E=d?.value,D=d?.source;C.$jg(E)&&(E=m.defaultDefaultValue,D=void 0),C.$jg(E)&&(E=s(m.type)),m.default=E,m.defaultValueSource=D}}const S="\\[([^\\]]+)\\]",f=new RegExp(S,"g");e.$Bo=`^(${S})+$`,e.$Co=new RegExp(e.$Bo);function n(u){const p=[];if(e.$Co.test(u)){let m=f.exec(u);for(;m?.length;){const d=m[1].trim();d&&p.push(d),m=f.exec(u)}}return(0,v.$Lb)(p)}function o(u){return u.reduce((p,m)=>`${p}[${m}]`,"")}function s(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const l=new c;$.$no.add(e.$so.Configuration,l);function i(u,p){return u.trim()?e.$Co.test(u)?N.localize(11451,null,u):l.getConfigurationProperties()[u]!==void 0?N.localize(11452,null,u):p.policy?.name&&l.getPolicyConfigurations().get(p.policy?.name)!==void 0?N.localize(11453,null,u,p.policy?.name,l.getPolicyConfigurations().get(p.policy?.name)):null:N.localize(11450,null)}function r(){const u=[],p=l.getConfigurationProperties();for(const m of Object.keys(p))u.push([m,p[m].scope]);return u.push(["launch",R.RESOURCE]),u.push(["task",R.RESOURCE]),u}function t(u){const p={};for(const m of u){const d=m.properties;if(C.$eg(d))for(const E in d)p[E]=d[E];m.allOf&&Object.assign(p,t(m.allOf))}return p}function g(u){switch(u){case"application":return R.APPLICATION;case"machine":return R.MACHINE;case"resource":return R.RESOURCE;case"machine-overridable":return R.MACHINE_OVERRIDABLE;case"language-overridable":return R.LANGUAGE_OVERRIDABLE;default:return R.WINDOW}}}),define(Ne[173],Oe([1,0,17,6,136,4,28,25,14,2,43,53,29,30]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$No=e.$Mo=e.$Lo=e.$Ko=void 0,e.$Oo=r,v=Ve(v),C=Ve(C),T=Ve(T),$=Ve($);function f(p){return Object.isFrozen(p)?p:T.$bo(p)}class n{static createEmptyModel(m){return new n({},[],[],void 0,m)}constructor(m,d,E,D,w){this.b=m,this.c=d,this.d=E,this.raw=D,this.f=w,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const m=this.raw.map(d=>{if(d instanceof n)return d;const E=new o("",this.f);return E.parseRaw(d),E.configurationModel});this.g=m.reduce((d,E)=>E===d?E:d.merge(E),m[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(m){return m?(0,R.$ej)(this.contents,m):this.contents}inspect(m,d){const E=this;return{get value(){return f(E.rawConfiguration.getValue(m))},get override(){return d?f(E.rawConfiguration.getOverrideValue(m,d)):void 0},get merged(){return f(d?E.rawConfiguration.override(d).getValue(m):E.rawConfiguration.getValue(m))},get overrides(){const D=[];for(const{contents:w,identifiers:k,keys:P}of E.rawConfiguration.overrides){const h=new n(w,P,[],void 0,E.f).getValue(m);h!==void 0&&D.push({identifiers:k,value:h})}return D.length?f(D):void 0}}}getOverrideValue(m,d){const E=this.j(d);return E?m?(0,R.$ej)(E,m):E:void 0}getKeysForOverrideIdentifier(m){const d=[];for(const E of this.overrides)E.identifiers.includes(m)&&d.push(...E.keys);return v.$Lb(d)}getAllOverrideIdentifiers(){const m=[];for(const d of this.overrides)m.push(...d.identifiers);return v.$Lb(m)}override(m){let d=this.a.get(m);return d||(d=this.h(m),this.a.set(m,d)),d}merge(...m){const d=T.$ao(this.contents),E=T.$ao(this.overrides),D=[...this.keys],w=this.raw?.length?[...this.raw]:[this];for(const k of m)if(w.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.i(d,k.contents);for(const P of k.overrides){const[h]=E.filter(b=>v.$tb(b.identifiers,P.identifiers));h?(this.i(h.contents,P.contents),h.keys.push(...P.keys),h.keys=v.$Lb(h.keys)):E.push(T.$ao(P))}for(const P of k.keys)D.indexOf(P)===-1&&D.push(P)}return new n(d,D,E,w.every(k=>k instanceof n)?void 0:w,this.f)}h(m){const d=this.j(m);if(!d||typeof d!="object"||!Object.keys(d).length)return this;const E={};for(const D of v.$Lb([...Object.keys(this.contents),...Object.keys(d)])){let w=this.contents[D];const k=d[D];k&&(typeof w=="object"&&typeof k=="object"?(w=T.$ao(w),this.i(w,k)):w=k),E[D]=w}return new n(E,this.keys,this.overrides,void 0,this.f)}i(m,d){for(const E of Object.keys(d)){if(E in m&&$.$eg(m[E])&&$.$eg(d[E])){this.i(m[E],d[E]);continue}m[E]=T.$ao(d[E])}}j(m){let d=null,E=null;const D=w=>{w&&(E?this.i(E,w):E=T.$ao(w))};for(const w of this.overrides)w.identifiers.length===1&&w.identifiers[0]===m?d=w.contents:w.identifiers.includes(m)&&D(w.contents);return D(d),E}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(m,d){this.k(m,d,!0)}setValue(m,d){this.k(m,d,!1)}removeValue(m){const d=this.keys.indexOf(m);d!==-1&&(this.keys.splice(d,1),(0,R.$dj)(this.contents,m),y.$Co.test(m)&&this.overrides.splice(this.overrides.findIndex(E=>v.$tb(E.identifiers,(0,y.$Do)(m))),1))}k(m,d,E){(0,R.$cj)(this.contents,m,d,D=>this.f.error(D)),E=E||this.keys.indexOf(m)===-1,E&&this.keys.push(m),y.$Co.test(m)&&this.overrides.push({identifiers:(0,y.$Do)(m),keys:Object.keys(this.contents[m]),contents:(0,R.$bj)(this.contents[m],D=>this.f.error(D))})}}e.$Ko=n;class o{constructor(m,d){this.f=m,this.g=d,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||n.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(m,d){if(!$.$lg(m)){const E=this.h(m);this.parseRaw(E,d)}}reparse(m){this.a&&this.parseRaw(this.a,m)}parseRaw(m,d){this.a=m;const{contents:E,keys:D,overrides:w,restricted:k,hasExcludedProperties:P}=this.i(m,d);this.b=new n(E,D,w,P?[m]:void 0,this.g),this.c=k||[]}h(m){let d={},E=null,D=[];const w=[],k=[];function P(b){Array.isArray(D)?D.push(b):E!==null&&(D[E]=b)}const h={onObjectBegin:()=>{const b={};P(b),w.push(D),D=b,E=null},onObjectProperty:b=>{E=b},onObjectEnd:()=>{D=w.pop()},onArrayBegin:()=>{const b=[];P(b),w.push(D),D=b,E=null},onArrayEnd:()=>{D=w.pop()},onLiteralValue:P,onError:(b,M,O)=>{k.push({error:b,offset:M,length:O})}};if(m)try{C.$2n(m,h),d=D[0]||{}}catch(b){this.g.error(`Error while parsing settings file ${this.f}: ${b}`),this.d=[b]}return d}i(m,d){const E=S.$no.as(y.$so.Configuration).getConfigurationProperties(),D=this.j(m,E,!0,d);m=D.raw;const w=(0,R.$bj)(m,h=>this.g.error(`Conflict in settings file ${this.f}: ${h}`)),k=Object.keys(m),P=this.l(m,h=>this.g.error(`Conflict in settings file ${this.f}: ${h}`));return{contents:w,keys:k,overrides:P,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}j(m,d,E,D){let w=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:m,restricted:[],hasExcludedProperties:w};const k={},P=[];for(const h in m)if(y.$Co.test(h)&&E){const b=this.j(m[h],d,!1,D);k[h]=b.raw,w=w||b.hasExcludedProperties,P.push(...b.restricted)}else{const b=d[h],M=b?typeof b.scope<"u"?b.scope:y.ConfigurationScope.WINDOW:void 0;b?.restricted&&P.push(h),!D.exclude?.includes(h)&&(D.include?.includes(h)||(M===void 0||D.scopes===void 0||D.scopes.includes(M))&&!(D.skipRestricted&&b?.restricted))?k[h]=m[h]:w=!0}return{raw:k,restricted:P,hasExcludedProperties:w}}l(m,d){const E=[];for(const D of Object.keys(m))if(y.$Co.test(D)){const w={};for(const k in m[D])w[k]=m[D][k];E.push({identifiers:(0,y.$Do)(D),keys:Object.keys(w),contents:(0,R.$bj)(w,d)})}return E}}e.$Lo=o;class s extends N.$Tc{constructor(m,d,E,D,w){super(),this.c=m,this.f=d,this.g=D,this.h=w,this.b=this.B(new I.$je),this.onDidChange=this.b.event,this.a=new o(this.c.toString(),w),this.B(this.g.watch(E.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(I.Event.any(I.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),I.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(c.FileOperation.CREATE)||k.isOperation(c.FileOperation.COPY)||k.isOperation(c.FileOperation.DELETE)||k.isOperation(c.FileOperation.WRITE))&&E.isEqual(k.resource,m)))(()=>this.b.fire()))}async loadConfiguration(){try{const m=await this.g.readFile(this.c);return this.a.parse(m.value.toString()||"{}",this.f),this.a.configurationModel}catch{return n.createEmptyModel(this.h)}}reparse(m){return m&&(this.f=m),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Mo=s;class l{constructor(m,d,E,D,w,k,P,h,b,M,O,F,q){this.a=m,this.b=d,this.c=E,this.overrideIdentifiers=D,this.d=w,this.f=k,this.g=P,this.h=h,this.i=b,this.j=M,this.k=O,this.l=F,this.m=q}get value(){return f(this.c)}n(m){return m?.value!==void 0||m?.override!==void 0||m?.overrides!==void 0?m:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(m,d,E,D,w,k,P,h,b,M){this.j=m,this.l=d,this.m=E,this.n=D,this.p=w,this.q=k,this.r=P,this.s=h,this.t=b,this.u=M,this.h=null,this.i=new A.$zc,this.v=null}getValue(m,d,E){return this.w(m,d,E).getValue(m)}updateValue(m,d,E={}){let D;E.resource?(D=this.t.get(E.resource),D||(D=n.createEmptyModel(this.u),this.t.set(E.resource,D))):D=this.s,d===void 0?D.removeValue(m):D.setValue(m,d),E.resource||(this.h=null)}inspect(m,d,E){const D=this.w(m,d,E),w=this.A(d.resource,E),k=d.resource?this.t.get(d.resource)||this.s:this.s,P=new Set;for(const h of D.overrides)for(const b of h.identifiers)D.getOverrideValue(m,b)!==void 0&&P.add(b);return new l(m,d,D.getValue(m),P.size?[...P]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,E?this.q:void 0,w||void 0,k)}keys(m){const d=this.A(void 0,m);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:d?d.keys.slice(0):[]}}updateDefaultConfiguration(m){this.j=m,this.h=null,this.i.clear()}updatePolicyConfiguration(m){this.l=m}updateApplicationConfiguration(m){this.m=m,this.h=null,this.i.clear()}updateLocalUserConfiguration(m){this.n=m,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(m){this.p=m,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(m){this.q=m,this.h=null,this.i.clear()}updateFolderConfiguration(m,d){this.r.set(m,d),this.i.delete(m)}deleteFolderConfiguration(m){this.folderConfigurations.delete(m),this.i.delete(m)}compareAndUpdateDefaultConfiguration(m,d){const E=[];if(!d){const{added:D,updated:w,removed:k}=g(this.j,m);d=[...D,...w,...k]}for(const D of d)for(const w of(0,y.$Do)(D)){const k=this.j.getKeysForOverrideIdentifier(w),P=m.getKeysForOverrideIdentifier(w),h=[...P.filter(b=>k.indexOf(b)===-1),...k.filter(b=>P.indexOf(b)===-1),...k.filter(b=>!T.$eo(this.j.override(w).getValue(b),m.override(w).getValue(b)))];E.push([w,h])}return this.updateDefaultConfiguration(m),{keys:d,overrides:E}}compareAndUpdatePolicyConfiguration(m){const{added:d,updated:E,removed:D}=g(this.l,m),w=[...d,...E,...D];return w.length&&this.updatePolicyConfiguration(m),{keys:w,overrides:[]}}compareAndUpdateApplicationConfiguration(m){const{added:d,updated:E,removed:D,overrides:w}=g(this.applicationConfiguration,m),k=[...d,...E,...D];return k.length&&this.updateApplicationConfiguration(m),{keys:k,overrides:w}}compareAndUpdateLocalUserConfiguration(m){const{added:d,updated:E,removed:D,overrides:w}=g(this.localUserConfiguration,m),k=[...d,...E,...D];return k.length&&this.updateLocalUserConfiguration(m),{keys:k,overrides:w}}compareAndUpdateRemoteUserConfiguration(m){const{added:d,updated:E,removed:D,overrides:w}=g(this.remoteUserConfiguration,m),k=[...d,...E,...D];return k.length&&this.updateRemoteUserConfiguration(m),{keys:k,overrides:w}}compareAndUpdateWorkspaceConfiguration(m){const{added:d,updated:E,removed:D,overrides:w}=g(this.workspaceConfiguration,m),k=[...d,...E,...D];return k.length&&this.updateWorkspaceConfiguration(m),{keys:k,overrides:w}}compareAndUpdateFolderConfiguration(m,d){const E=this.folderConfigurations.get(m),{added:D,updated:w,removed:k,overrides:P}=g(E,d),h=[...D,...w,...k];return(h.length||!E)&&this.updateFolderConfiguration(m,d),{keys:h,overrides:P}}compareAndDeleteFolderConfiguration(m){const d=this.folderConfigurations.get(m);if(!d)throw new Error("Unknown folder");this.deleteFolderConfiguration(m);const{added:E,updated:D,removed:w,overrides:k}=g(d,void 0);return{keys:[...E,...D,...w],overrides:k}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(m,d,E){let D=this.x(d,E);return d.overrideIdentifier&&(D=D.override(d.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(m)!==void 0&&(D=D.merge(this.l)),D}x({resource:m},d){let E=this.y();if(d&&m){const D=d.getFolder(m);D&&(E=this.z(D.uri)||E);const w=this.t.get(m);w&&(E=E.merge(w))}return E}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(m){let d=this.i.get(m);if(!d){const E=this.y(),D=this.r.get(m);D?(d=E.merge(D),this.i.set(m,d)):d=E}return d}A(m,d){if(d&&m){const E=d.getFolder(m);if(E)return this.r.get(E.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((m,d)=>{const{contents:E,overrides:D,keys:w}=this.r.get(d);return m.push([d,{contents:E,overrides:D,keys:w}]),m},[])}}allKeys(){const m=new Set;return this.j.keys.forEach(d=>m.add(d)),this.userConfiguration.keys.forEach(d=>m.add(d)),this.q.keys.forEach(d=>m.add(d)),this.r.forEach(d=>d.keys.forEach(E=>m.add(E))),[...m.values()]}B(){const m=new Set;return this.j.getAllOverrideIdentifiers().forEach(d=>m.add(d)),this.userConfiguration.getAllOverrideIdentifiers().forEach(d=>m.add(d)),this.q.getAllOverrideIdentifiers().forEach(d=>m.add(d)),this.r.forEach(d=>d.getAllOverrideIdentifiers().forEach(E=>m.add(E))),[...m.values()]}D(m){const d=new Set;return this.j.getKeysForOverrideIdentifier(m).forEach(E=>d.add(E)),this.userConfiguration.getKeysForOverrideIdentifier(m).forEach(E=>d.add(E)),this.q.getKeysForOverrideIdentifier(m).forEach(E=>d.add(E)),this.r.forEach(E=>E.getKeysForOverrideIdentifier(m).forEach(D=>d.add(D))),[...d.values()]}static parse(m,d){const E=this.E(m.defaults,d),D=this.E(m.policy,d),w=this.E(m.application,d),k=this.E(m.user,d),P=this.E(m.workspace,d),h=m.folders.reduce((b,M)=>(b.set(a.URI.revive(M[0]),this.E(M[1],d)),b),new A.$zc);return new i(E,D,w,k,n.createEmptyModel(d),P,h,n.createEmptyModel(d),new A.$zc,d)}static E(m,d){return new n(m.contents,m.keys,m.overrides,void 0,d)}}e.$No=i;function r(...p){if(p.length===0)return{keys:[],overrides:[]};if(p.length===1)return p[0];const m=new Set,d=new Map;for(const D of p)D.keys.forEach(w=>m.add(w)),D.overrides.forEach(([w,k])=>{const P=(0,A.$wc)(d,w,new Set);k.forEach(h=>P.add(h))});const E=[];return d.forEach((D,w)=>E.push([w,[...D.values()]])),{keys:[...m.values()],overrides:E}}class t{constructor(m,d,E,D,w){this.change=m,this.f=d,this.g=E,this.h=D,this.i=w,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const k of m.keys)this.affectedKeys.add(k);for(const[,k]of m.overrides)for(const P of k)this.affectedKeys.add(P);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(m,d){const E=this.a+m,D=this.d.indexOf(E);if(D<0)return!1;const w=D+E.length;if(w>=this.d.length)return!1;const k=this.d.charCodeAt(w);if(k!==this.b&&k!==this.c)return!1;if(d){const P=this.previousConfiguration?this.previousConfiguration.getValue(m,d,this.f?.workspace):void 0,h=this.g.getValue(m,d,this.h);return!T.$eo(P,h)}return!0}}e.$Po=t;function g(p,m){const{added:d,removed:E,updated:D}=u(m?.rawConfiguration,p?.rawConfiguration),w=[],k=p?.getAllOverrideIdentifiers()||[],P=m?.getAllOverrideIdentifiers()||[];if(m){const h=P.filter(b=>!k.includes(b));for(const b of h)w.push([b,m.getKeysForOverrideIdentifier(b)])}if(p){const h=k.filter(b=>!P.includes(b));for(const b of h)w.push([b,p.getKeysForOverrideIdentifier(b)])}if(m&&p){for(const h of k)if(P.includes(h)){const b=u({contents:p.getOverrideValue(void 0,h)||{},keys:p.getKeysForOverrideIdentifier(h)},{contents:m.getOverrideValue(void 0,h)||{},keys:m.getKeysForOverrideIdentifier(h)});w.push([h,[...b.added,...b.removed,...b.updated]])}}return{added:d,removed:E,updated:D,overrides:w}}function u(p,m){const d=p?m?p.keys.filter(w=>m.keys.indexOf(w)===-1):[...p.keys]:[],E=m?p?m.keys.filter(w=>p.keys.indexOf(w)===-1):[...m.keys]:[],D=[];if(p&&m){for(const w of m.keys)if(p.keys.indexOf(w)!==-1){const k=(0,R.$ej)(m.contents,w),P=(0,R.$ej)(p.contents,w);T.$eo(k,P)||D.push(w)}}return{added:d,removed:E,updated:D}}}),define(Ne[109],Oe([1,0,13,3]),function(we,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.RemoteAuthorityResolverErrorCode=e.$Pl=e.$Ol=e.RemoteConnectionType=e.$Nl=void 0,e.$Rl=a,e.$Nl=(0,I.$Ci)("remoteAuthorityResolverService");var C;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class N{constructor(y){this.id=y,this.type=C.Managed}toString(){return`Managed(${this.id})`}}e.$Ol=N;class A{constructor(y,c){this.host=y,this.port=c,this.type=C.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Pl=A;var T;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(T||(e.RemoteAuthorityResolverErrorCode=T={}));class $ extends v.$ab{static isNotAvailable(y){return y instanceof $&&y._code===T.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof $&&y._code===T.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof $&&y._code===T.NoResolverFound}static isInvalidAuthority(y){return y instanceof $&&y._code===T.InvalidAuthority}static isHandled(y){return y instanceof $&&y.isHandled}constructor(y,c=T.Unknown,S){super(y),this._message=y,this._code=c,this._detail=S,this.isHandled=c===T.NotAvailable&&S===!0,Object.setPrototypeOf(this,$.prototype)}}e.$Ql=$;function a(R){const y=R.indexOf("+");return y===-1?R:R.substring(0,y)}}),define(Ne[62],Oe([1,0,15]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=I,e.$en=C,e.$fn=N,e.$gn=A;function I($){return $.scheme===v.Schemas.vscodeRemote?$.authority:void 0}function C($){if(!$)return;const a=$.indexOf("+");return a<0?$:$.substr(0,a)}function N($){const{host:a,port:R}=T($);if(typeof R>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:R}}function A($,a){let{host:R,port:y}=T($);return typeof y>"u"&&(y=a),{host:R,port:y}}function T($){const a=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const R=$.match(/^(\[[0-9a-z:]+\])$/);if(R)return{host:R[1],port:void 0};const y=$.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:$,port:void 0}}}),define(Ne[18],Oe([1,0,12,3,62]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=e.$pn=e.$on=e.$nn=e.TargetPlatform=e.ExtensionType=e.$mn=e.$kn=e.$jn=e.$in=e.$hn=void 0,e.$ln=N,e.$qn=y,e.$rn=c,e.$sn=S,e.$tn=f,e.$un=n,e.$vn=o,v=Ve(v),e.$hn="extensions.user.cache",e.$in="extensions.builtin.cache",e.$jn="undefined_publisher",e.$kn=["ui","workspace","web"];function N(s){if(typeof s=="object"&&s!==null&&s.supported!==!0)return s.description}e.$mn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(s){s[s.System=0]="System",s[s.User=1]="User"})(A||(e.ExtensionType=A={}));var T;(function(s){s.WIN32_X64="win32-x64",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(T||(e.TargetPlatform=T={}));class ${constructor(l){this.value=l,this._lower=l.toLowerCase()}static equals(l,i){if(typeof l>"u"||l===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof l=="string"||typeof i=="string"){const r=typeof l=="string"?l:l.value,t=typeof i=="string"?i:i.value;return v.$Df(r,t)}return l._lower===i._lower}static toKey(l){return typeof l=="string"?l.toLowerCase():l._lower}}e.$nn=$;class a{get size(){return this.c.size}constructor(l){if(this.c=new Set,l)for(const i of l)this.add(i)}add(l){this.c.add($.toKey(l))}delete(l){return this.c.delete($.toKey(l))}has(l){return this.c.has($.toKey(l))}}e.$on=a;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(l){this.c.delete($.toKey(l))}get(l){return this.c.get($.toKey(l))}has(l){return this.c.has($.toKey(l))}set(l,i){this.c.set($.toKey(l),i)}values(){return this.c.values()}forEach(l){this.c.forEach(l)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$pn=R;function y(s){return c(s)}function c(s){return s.contributes&&s.contributes.localizations?s.contributes.localizations.length>0:!1}function S(s){return s.contributes&&s.contributes.authentication?s.contributes.authentication.length>0:!1}function f(s,l){if(l){const i=`onResolveRemoteAuthority:${(0,C.$en)(l)}`;return!!s.activationEvents?.includes(i)}return!1}function n(s){return s.map(l=>{const[i,r]=l.split("@");return{proposalName:i,version:r?parseInt(r):void 0}})}function o(s){return s.map(l=>l.split("@")[0])}e.$wn=(0,I.$Ci)("IBuiltinExtensionsScannerService")}),define(Ne[110],Oe([1,0,20,9,18,3]),function(we,e,v,I,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.ExtensionManagementErrorCode=e.$ip=e.ExtensionGalleryErrorCode=e.$hp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=void 0,e.$bp=T,e.$cp=$,e.$dp=a,e.$ep=R,e.$fp=y,e.$gp=c,e.$7o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$8o=new RegExp(e.$7o),e.$9o="__web_extension",e.$0o="skipWalkthrough",e.$$o="extensionInstallSource",e.$_o="dependecyOrPackExtensionInstall",e.$ap="clientTargetPlatform";var A;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(A||(e.ExtensionInstallSource=A={}));function T(t){switch(t){case C.TargetPlatform.WIN32_X64:return"Windows 64 bit";case C.TargetPlatform.WIN32_ARM64:return"Windows ARM";case C.TargetPlatform.LINUX_X64:return"Linux 64 bit";case C.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case C.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case C.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case C.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case C.TargetPlatform.DARWIN_X64:return"Mac";case C.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case C.TargetPlatform.WEB:return"Web";case C.TargetPlatform.UNIVERSAL:return C.TargetPlatform.UNIVERSAL;case C.TargetPlatform.UNKNOWN:return C.TargetPlatform.UNKNOWN;case C.TargetPlatform.UNDEFINED:return C.TargetPlatform.UNDEFINED}}function $(t){switch(t){case C.TargetPlatform.WIN32_X64:return C.TargetPlatform.WIN32_X64;case C.TargetPlatform.WIN32_ARM64:return C.TargetPlatform.WIN32_ARM64;case C.TargetPlatform.LINUX_X64:return C.TargetPlatform.LINUX_X64;case C.TargetPlatform.LINUX_ARM64:return C.TargetPlatform.LINUX_ARM64;case C.TargetPlatform.LINUX_ARMHF:return C.TargetPlatform.LINUX_ARMHF;case C.TargetPlatform.ALPINE_X64:return C.TargetPlatform.ALPINE_X64;case C.TargetPlatform.ALPINE_ARM64:return C.TargetPlatform.ALPINE_ARM64;case C.TargetPlatform.DARWIN_X64:return C.TargetPlatform.DARWIN_X64;case C.TargetPlatform.DARWIN_ARM64:return C.TargetPlatform.DARWIN_ARM64;case C.TargetPlatform.WEB:return C.TargetPlatform.WEB;case C.TargetPlatform.UNIVERSAL:return C.TargetPlatform.UNIVERSAL;default:return C.TargetPlatform.UNKNOWN}}function a(t,g){switch(t){case v.Platform.Windows:return g==="x64"?C.TargetPlatform.WIN32_X64:g==="arm64"?C.TargetPlatform.WIN32_ARM64:C.TargetPlatform.UNKNOWN;case v.Platform.Linux:return g==="x64"?C.TargetPlatform.LINUX_X64:g==="arm64"?C.TargetPlatform.LINUX_ARM64:g==="arm"?C.TargetPlatform.LINUX_ARMHF:C.TargetPlatform.UNKNOWN;case"alpine":return g==="x64"?C.TargetPlatform.ALPINE_X64:g==="arm64"?C.TargetPlatform.ALPINE_ARM64:C.TargetPlatform.UNKNOWN;case v.Platform.Mac:return g==="x64"?C.TargetPlatform.DARWIN_X64:g==="arm64"?C.TargetPlatform.DARWIN_ARM64:C.TargetPlatform.UNKNOWN;case v.Platform.Web:return C.TargetPlatform.WEB}}function R(t,g){return g===C.TargetPlatform.WEB&&!t.includes(C.TargetPlatform.WEB)}function y(t,g,u){return R(g,u)?!1:t===C.TargetPlatform.UNDEFINED||t===C.TargetPlatform.UNIVERSAL?!0:t===C.TargetPlatform.UNKNOWN?!1:t===u}function c(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var S;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(S||(e.SortBy=S={}));var f;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(f||(e.SortOrder=f={}));var n;(function(t){t.Install="install",t.Uninstall="uninstall"})(n||(e.StatisticType=n={}));var o;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(o||(e.InstallOperation=o={})),e.$hp=(0,N.$Ci)("extensionGalleryService");var s;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})(s||(e.ExtensionGalleryErrorCode=s={}));class l extends Error{constructor(g,u){super(g),this.code=u,this.name=u}}e.$ip=l;var i;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateExistingMetadata="UpdateExistingMetadata",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class r extends Error{constructor(g,u){super(g),this.code=u,this.name=u}}e.$jp=r,e.$kp=(0,N.$Ci)("extensionManagementService"),e.$lp="extensionsIdentifiers/disabled",e.$mp="extensionsIdentifiers/enabled",e.$np=(0,N.$Ci)("IGlobalExtensionEnablementService"),e.$op=(0,N.$Ci)("IExtensionTipsService"),e.$pp=(0,I.localize2)(11334,"Extensions"),e.$qp=(0,I.localize2)(11335,"Preferences")}),define(Ne[111],Oe([1,0,13,18]),function(we,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KG=e.$JG=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(A,T){this.a.set(A,T)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const T=Object.create(null);for(const $ of A){const a=this.readActivationEvents($);a.length>0&&(T[I.$nn.toKey($.identifier)]=a)}return T}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const T=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let $=0;$<T.length;$++)T[$]==="onUri"&&(T[$]=`onUri:${I.$nn.toKey(A.identifier)}`);if(!A.contributes)return T;for(const $ in A.contributes){const a=this.a.get($);if(!a)continue;const R=A.contributes[$],y=Array.isArray(R)?R:[R];try{a(y,T)}catch(c){(0,v.$Y)(c)}}return T}}e.$JG=C,e.$KG=new C});var _t=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Ne[174],Oe([1,0,23,35,9,280,18,104]),function(we,e,v,I,C,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=R,e.$Wp=y,e.$Xp=c,e.$Yp=S,e.$Zp=f,e.$1p=n,e.$2p=o,e.$3p=s,I=_t(I),C=Ve(C),N=Ve(N);const $=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,a=/^-(\d{4})(\d{2})(\d{2})$/;function R(r){return r=r.trim(),r==="*"||$.test(r)}function y(r){if(!R(r))return null;if(r=r.trim(),r==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=r.match($);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function c(r){if(!r)return null;const t=r.majorBase,g=r.majorMustEqual,u=r.minorBase;let p=r.minorMustEqual;const m=r.patchBase;let d=r.patchMustEqual;r.hasCaret&&(t===0||(p=!1),d=!1);let E=0;if(r.preRelease){const D=a.exec(r.preRelease);if(D){const[,w,k,P]=D;E=Date.UTC(Number(w),Number(k)-1,Number(P))}}return{majorBase:t,majorMustEqual:g,minorBase:u,minorMustEqual:p,patchBase:m,patchMustEqual:d,isMinimum:r.hasGreaterEquals,notBefore:E}}function S(r,t,g){let u;typeof r=="string"?u=c(y(r)):u=r;let p;t instanceof Date?p=t.getTime():typeof t=="string"&&(p=new Date(t).getTime());let m;if(typeof g=="string"?m=c(y(g)):m=g,!u||!m)return!1;const d=u.majorBase,E=u.minorBase,D=u.patchBase;let w=m.majorBase,k=m.minorBase,P=m.patchBase;const h=m.notBefore;let b=m.majorMustEqual,M=m.minorMustEqual,O=m.patchMustEqual;return m.isMinimum?d>w?!0:d<w?!1:E>k?!0:E<k||p&&p<h?!1:D>=P:(d===1&&w===0&&(!b||!M||!O)&&(w=1,k=0,P=0,b=!0,M=!1,O=!1),d<w?!1:d>w?!b:E<k?!1:E>k?!M:D<P?!1:D>P?!O:!(p&&p<h))}function f(r,t,g,u,p,m){const d=[];if(typeof u.publisher<"u"&&typeof u.publisher!="string")return d.push([I.default.Error,C.localize(11266,null)]),d;if(typeof u.name!="string")return d.push([I.default.Error,C.localize(11267,null,"name")]),d;if(typeof u.version!="string")return d.push([I.default.Error,C.localize(11268,null,"version")]),d;if(!u.engines)return d.push([I.default.Error,C.localize(11269,null,"engines")]),d;if(typeof u.engines.vscode!="string")return d.push([I.default.Error,C.localize(11270,null,"engines.vscode")]),d;if(typeof u.extensionDependencies<"u"&&!i(u.extensionDependencies))return d.push([I.default.Error,C.localize(11271,null,"extensionDependencies")]),d;if(typeof u.activationEvents<"u"){if(!i(u.activationEvents))return d.push([I.default.Error,C.localize(11272,null,"activationEvents")]),d;if(typeof u.main>"u"&&typeof u.browser>"u")return d.push([I.default.Error,C.localize(11273,null,"activationEvents","main","browser")]),d}if(typeof u.extensionKind<"u"&&typeof u.main>"u"&&d.push([I.default.Warning,C.localize(11274,null,"extensionKind")]),typeof u.main<"u"){if(typeof u.main!="string")return d.push([I.default.Error,C.localize(11275,null,"main")]),d;{const w=(0,v.$dh)(g,u.main);(0,v.$0g)(w,g)||d.push([I.default.Warning,C.localize(11276,null,w.path,g.path)])}}if(typeof u.browser<"u"){if(typeof u.browser!="string")return d.push([I.default.Error,C.localize(11277,null,"browser")]),d;{const w=(0,v.$dh)(g,u.browser);(0,v.$0g)(w,g)||d.push([I.default.Warning,C.localize(11278,null,w.path,g.path)])}}if(!N.valid(u.version))return d.push([I.default.Error,C.localize(11279,null)]),d;const E=[];if(!n(r,t,u,p,E))for(const w of E)d.push([I.default.Error,w]);if(m&&u.enabledApiProposals?.length){const w=[];if(!s([...u.enabledApiProposals],w))for(const k of w)d.push([I.default.Error,k])}return d}function n(r,t,g,u,p){return u||typeof g.main>"u"&&typeof g.browser>"u"?!0:l(r,t,g.engines.vscode,p)}function o(r,t,g){return r==="*"||l(t,g,r)}function s(r,t){if(r.length===0)return!0;const g=Array.isArray(t)?t:void 0,u=(g?void 0:t)??T.allApiProposals,p=[],m=(0,A.$un)(r);for(const{proposalName:d,version:E}of m){const D=u[d];D&&E&&D.version!==E&&p.push(C.localize(11280,null,d))}return g?.push(...p),p.length===0}function l(r,t,g,u=[]){const p=c(y(g));if(!p)return u.push(C.localize(11281,null,g)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return u.push(C.localize(11282,null,g)),!1}else if(!p.majorMustEqual)return u.push(C.localize(11283,null,g)),!1;return S(r,t,p)?!0:(u.push(C.localize(11284,null,r,g)),!1)}function i(r){if(!Array.isArray(r))return!1;for(let t=0,g=r.length;t<g;t++)if(typeof r[t]!="string")return!1;return!0}}),define(Ne[175],Oe([1,0,22,13,4,9,53,3,11,30]),function(we,e,v,I,C,N,A,T,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=void 0,e.$6p=c,e.$7p=S,e.$8p=f,e.$9p=n,e.$0p=o,e.$$p=s,e.$4p=(0,T.$Ci)("requestService");class R{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const g in this.b)g.toLowerCase()==="authorization"||g.toLowerCase()==="proxy-authorization"?t[g]="*****":t[g]=this.b[g];this.a=t}return this.a}}class y extends C.$Tc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,N.localize)(11053,null),when:$.$ok.isEqualTo((0,$.$lk)($.LogLevel.Trace)).serialize()})}async c(t,g,u){const p=`${t} #${++this.b}: ${g.url}`;this.a.trace(`${p} - begin`,g.type,new R(g.headers??{}));try{const m=await u();return this.a.trace(`${p} - end`,g.type,m.res.statusCode,m.res.headers),m}catch(m){throw this.a.error(`${p} - error`,g.type,(0,I.$9)(m)),m}}}e.$5p=y;function c(r){return r.res.statusCode&&r.res.statusCode>=200&&r.res.statusCode<300||r.res.statusCode===1223}function S(r){return r.res.statusCode===204}async function f(r){return S(r)?null:(await(0,v.$Xe)(r.stream)).toString()}async function n(r){if(!c(r))throw new Error("Server returned "+r.res.statusCode);return f(r)}async function o(r){if(!c(r))throw new Error("Server returned "+r.res.statusCode);if(S(r))return null;const g=(await(0,v.$Xe)(r.stream)).toString();try{return JSON.parse(g)}catch(u){throw u.message+=`:
`+g,u}}function s(r){i(r)}let l;function i(r){const t=a.$no.as(A.$so.Configuration),g=l;l={id:"http",order:15,title:(0,N.localize)(11054,null),type:"object",scope:r,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,N.localize)(11055,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,N.localize)(11056,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,N.localize)(11057,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,N.localize)(11058,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,N.localize)(11059,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,N.localize)(11060,null),(0,N.localize)(11061,null),(0,N.localize)(11062,null),(0,N.localize)(11063,null)],default:"override",description:(0,N.localize)(11064,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,N.localize)(11065,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,N.localize)(11066,null),restricted:!0}}},t.updateConfigurations({add:[l],remove:g?[g]:[]})}i(A.ConfigurationScope.APPLICATION)}),define(Ne[176],Oe([1,0,20,78,37]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=A,e.$sp=T;function N($){if(v.$v===v.Platform.Linux&&/^penguin(\.|$)/i.test($))return"chromebook"}function A($,a,R,y,c,S,f,n,o,s){const l=Object.create(null);l["common.machineId"]=S,l["common.sqmId"]=f,l["common.devDeviceId"]=n,l.sessionID=(0,C.$Yg)()+Date.now(),l.commitHash=y,l.version=c,l["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,v.$i)(v.$v),l["common.nodePlatform"]=I.$cc,l["common.nodeArch"]=R,l["common.product"]=s||"desktop",o&&(l["common.msftInternal"]=o);let i=0;const r=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),v.$m&&(l["common.snap"]="true");const t=N(a);return t&&(l["common.platformDetail"]=t),l}function T($){const a=I.env.USERDNSDOMAIN;if(!a)return!1;const R=a.toLowerCase();return $.some(y=>R===y)}}),define(Ne[112],Oe([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=void 0,e.$8l=(0,v.$Ci)("telemetryService"),e.$9l=(0,v.$Ci)("customEndpointTelemetryService"),e.$0l="telemetry.currentSessionDate",e.$$l="telemetry.firstSessionDate",e.$_l="telemetry.lastSessionDate",e.$am="telemetry.machineId",e.$bm="telemetry.sqmId",e.$cm="telemetry.devDeviceId",e.$dm="telemetry",e.$em="telemetry.telemetryLevel",e.$fm="telemetry.enableCrashReporter",e.$gm="telemetry.enableTelemetry";var I;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(I||(e.TelemetryLevel=I={}));var C;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Ne[63],Oe([1,0,25,14,62,176,112]),function(we,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=void 0,e.$Ap=R,e.$Bp=y,e.$Cp=c,e.$Dp=S,e.$Ep=n,e.$Fp=s,e.$Gp=l,e.$Hp=t;class T{constructor(u){this.value=u,this.isTrustedTelemetryValue=!0}}e.$tp=T;class ${constructor(){this.telemetryLevel=A.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$up=$,e.$vp=new $;class a{async publicLog(u,p,m){}async publicLogError(u,p,m){}}e.$wp=a,e.$xp="telemetry",e.$yp="extensionTelemetryLog",e.$zp={log:()=>null,flush:()=>Promise.resolve(null)};function R(g,u){return!u.isBuilt&&!u.disableTelemetry?!0:!(u.disableTelemetry||!g.enableTelemetry)}function y(g,u){return u.extensionTestsLocationURI?!0:!(u.isBuilt||u.disableTelemetry||g.enableTelemetry&&g.aiConfig?.ariaKey)}function c(g){const u=g.getValue(A.$em),p=g.getValue(A.$fm);if(g.getValue(A.$gm)===!1||p===!1)return A.TelemetryLevel.NONE;switch(u??A.TelemetryConfiguration.ON){case A.TelemetryConfiguration.ON:return A.TelemetryLevel.USAGE;case A.TelemetryConfiguration.ERROR:return A.TelemetryLevel.ERROR;case A.TelemetryConfiguration.CRASH:return A.TelemetryLevel.CRASH;case A.TelemetryConfiguration.OFF:return A.TelemetryLevel.NONE}}function S(g){const u={},p={},m={};o(g,m);for(let d in m){d=d.length>150?d.substr(d.length-149):d;const E=m[d];typeof E=="number"?p[d]=E:typeof E=="boolean"?p[d]=E?1:0:typeof E=="string"?(E.length>8192&&console.warn(`Telemetry property: ${d} has been trimmed to 8192, the original length is ${E.length}`),u[d]=E.substring(0,8191)):typeof E<"u"&&E!==null&&(u[d]=E)}return{properties:u,measurements:p}}const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function n(g){if(!g)return"none";const u=(0,C.$en)(g);return f.has(u)?u:"other"}function o(g,u,p=0,m){if(g)for(const d of Object.getOwnPropertyNames(g)){const E=g[d],D=m?m+d:d;Array.isArray(E)?u[D]=(0,v.$fo)(E):E instanceof Date?u[D]=E.toISOString():(0,I.$eg)(E)?p<2?o(E,u,p+1,D+"."):u[D]=(0,v.$fo)(E):u[D]=E}}function s(g,u){const p=g.msftInternalDomains||[],m=u.getValue("telemetry.internalTesting");return(0,N.$sp)(p)||m}function l(g){return[g.appRoot,g.extensionsPath,g.userHome.fsPath,g.tmpDir.fsPath,g.userDataPath]}function i(g,u){if(!g||!g.includes("/")&&!g.includes("\\"))return g;let p=g;const m=[];for(const w of u)for(;;){const k=w.exec(g);if(!k)break;m.push([k.index,w.lastIndex])}const d=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,E=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(p="";;){const w=E.exec(g);if(!w)break;const k=m.some(([P,h])=>w.index<h&&P<E.lastIndex);!d.test(w[0])&&!k&&(p+=g.substring(D,w.index)+"<REDACTED: user-file-path>",D=E.lastIndex)}return D<g.length&&(p+=g.substr(D)),p}function r(g){if(!g)return g;const u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const p of u)if(p.regex.test(g))return`<REDACTED: ${p.label}>`;return g}function t(g,u){return(0,v.$co)(g,p=>{if(p instanceof T||Object.hasOwnProperty.call(p,"isTrustedTelemetryValue"))return p.value;if(typeof p=="string"){let m=p.replaceAll("%20"," ");m=i(m,u);for(const d of u)m=m.replace(d,"");return m=r(m),m}})}}),define(Ne[177],Oe([1,0,12,110,18,20,2,13,78,63]),function(we,e,v,I,C,N,A,T,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Jp=void 0,e.$Ip=R,e.$Kp=f,e.$Lp=n,e.$Mp=o,e.$Np=s,e.$Op=l,e.$Pp=i,e.$Qp=r,e.$Sp=t,e.$Tp=u;function R(p,m){return p.uuid&&m.uuid?p.uuid===m.uuid:p.id===m.id?!0:(0,v.$yf)(p.id,m.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class c{static create(m){const d=m.manifest?m.manifest.version:m.version,E=m.manifest?m.targetPlatform:m.properties.targetPlatform;return new c(m.identifier,d,E)}static parse(m){const d=y.exec(m);return d&&d[1]&&d[2]?new c({id:d[1]},d[2],d[4]||void 0):null}constructor(m,d,E=C.TargetPlatform.UNDEFINED){this.identifier=m,this.version=d,this.targetPlatform=E,this.id=m.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==C.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(m){return m instanceof c?R(this,m)&&this.version===m.version&&this.targetPlatform===m.targetPlatform:!1}}e.$Jp=c;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(p){const m=S.exec(p);return m&&m[1]?[o(m[1]),m[2]]:[o(p),void 0]}function n(p,m){return`${p}.${m}`}function o(p){return p.toLowerCase()}function s(p,m){return o(n(p??C.$jn,m))}function l(p,m){const d=[],E=D=>{for(const w of d)if(w.some(k=>R(m(k),m(D))))return w;return null};for(const D of p){const w=E(D);w?w.push(D):d.push([D])}return d}function i(p){return{id:p.identifier.id,name:p.manifest.name,galleryId:null,publisherId:p.publisherId,publisherName:p.manifest.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:p.manifest.extensionDependencies&&p.manifest.extensionDependencies.length>0}}function r(p){return{id:new a.$tp(p.identifier.id),name:new a.$tp(p.name),version:p.version,galleryId:p.identifier.uuid,publisherId:p.publisherId,publisherName:p.publisher,publisherDisplayName:p.publisherDisplayName,isPreReleaseVersion:p.properties.isPreReleaseVersion,dependencies:!!(p.properties.dependencies&&p.properties.dependencies.length>0),isSigned:p.isSigned,...p.telemetryData}}e.$Rp=new C.$nn("pprice.better-merge");function t(p,m){const d=[],E=m.manifest.extensionDependencies?.slice(0)??[];for(;E.length;){const D=E.shift();if(D&&d.every(w=>!R(w.identifier,{id:D}))){const w=p.filter(k=>R(k.identifier,{id:D}));w.length===1&&(d.push(w[0]),E.push(...w[0].manifest.extensionDependencies?.slice(0)??[]))}}return d}async function g(p,m){if(!N.$l)return!1;let d;try{d=(await p.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{d=(await p.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){m.debug("Error while getting the os-release file.",(0,T.$9)(D))}}return!!d&&(d.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function u(p,m){const d=await g(p,m),E=(0,I.$dp)(d?"alpine":N.$v,$.$dc);return m.debug("ComputeTargetPlatform:",E),E}}),define(Ne[178],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bs=v,e.$Cs=I,e.$Ds=C,e.$Es=N,e.$Fs=A,e.$Gs=T;function v($){return[...$.entries()]}function I($){return $?[...$.entries()]:[]}function C($){return new Map($)}function N($){return new Map($??[])}function A($){return Array.from($.entries()).map(a=>[a[0],v(a[1].map),I(a[1].descriptionMap)])}function T($){return new Map($.map(a=>[a[0],{map:C(a[1]),descriptionMap:N(a[2])}]))}}),define(Ne[179],Oe([1,0,3,31,30]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$os=e.$ns=e.$ms=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ls=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ks=void 0,e.$ks=new I.$Tj("terminalTabFocusMode",!1,!0);var N;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(N||(e.TerminalSettingPrefix=N={}));var A;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(A||(e.TerminalSettingId=A={}));var T;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(T||(e.PosixShellType=T={}));var $;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})($||(e.WindowsShellType=$={}));var a;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(a||(e.TitleEventSource=a={}));var R;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(R||(e.TerminalIpcChannels=R={}));var y;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(y||(e.ProcessPropertyType=y={})),e.$ls=(0,v.$Ci)("ptyService");var c;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(c||(e.HeartbeatConstants=c={}));var S;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(S||(e.TerminalLocation=S={}));var f;(function(t){t.TerminalView="view",t.Editor="editor"})(f||(e.TerminalLocationString=f={}));var n;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(n||(e.LocalReconnectConstants=n={}));var o;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(o||(e.FlowControlConstants=o={}));var s;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(s||(e.ProfileSource=s={}));var l;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(l||(e.ShellIntegrationStatus=l={}));var i;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(i||(e.TerminalExitReason=i={})),e.$ms={Backend:"workbench.contributions.terminal.processBackend"};class r{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(g){const u=this.b(g.remoteAuthority);if(this.a.has(u))throw new Error(`A terminal backend with remote authority '${u}' was already registered.`);this.a.set(u,g)}getTerminalBackend(g){return this.a.get(this.b(g))}b(g){return g?.toLowerCase()??""}}C.$no.add(e.$ms.Backend,new r),e.$ns=(0,v.$Ci)("localPtyService"),e.$os=(0,v.$Ci)("terminalLogService")}),define(Ne[180],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vxb=void 0;class v{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,N,A=5){const T=N($=>{const a=typeof $=="string"?$:$.data;let R=this.a.get(C);if(R){R.data.push(a);return}const y=setTimeout(()=>this.flushBuffer(C),A);R={data:[a],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(C),T.dispose()}},this.a.set(C,R)});return T}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const N=this.a.get(C);N&&(this.a.delete(C),this.b(C,N.data.join("")))}}e.$vxb=v}),define(Ne[181],Oe([1,0,10,97,281,34,6,14,2,9,77,30]),function(we,e,v,I,C,N,A,T,$,a,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dx=e.$Cx=e.$Bx=e.$Ax=e.$zx=e.$yx=e.IconFontDefinition=e.IconContribution=e.$vx=void 0,e.$wx=o,e.$xx=s,y=Ve(y),e.$vx={IconContribution:"base.contributions.icons"};var c;(function(t){function g(u,p){let m=u.defaults;for(;N.ThemeIcon.isThemeIcon(m);){const d=n.getIcon(m.id);if(!d)return;m=d.defaults}return m}t.getDefinition=g})(c||(e.IconContribution=c={}));var S;(function(t){function g(p){return{weight:p.weight,style:p.style,src:p.src.map(m=>({format:m.format,location:m.location.toString()}))}}t.toJSONObject=g;function u(p){const m=d=>(0,T.$cg)(d)?d:void 0;if(p&&Array.isArray(p.src)&&p.src.every(d=>(0,T.$cg)(d.format)&&(0,T.$cg)(d.location)))return{weight:m(p.weight),style:m(p.style),src:p.src.map(d=>({format:d.format,location:$.URI.parse(d.location)}))}}t.fromJSONObject=u})(S||(e.IconFontDefinition=S={}));class f{constructor(){this.a=new A.$je,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,a.localize)(10985,null)},fontCharacter:{type:"string",description:(0,a.localize)(10986,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${N.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(g,u,p,m){const d=this.b[g];if(d){if(p&&!d.description){d.description=p,this.d.properties[g].markdownDescription=`${p} $(${g})`;const w=this.e.enum.indexOf(g);w!==-1&&(this.e.enumDescriptions[w]=p),this.a.fire()}return d}const E={id:g,description:p,defaults:u,deprecationMessage:m};this.b[g]=E;const D={$ref:"#/definitions/icons"};return m&&(D.deprecationMessage=m),p&&(D.markdownDescription=`${p}: $(${g})`),this.d.properties[g]=D,this.e.enum.push(g),this.e.enumDescriptions.push(p||""),this.a.fire(),{id:g}}deregisterIcon(g){delete this.b[g],delete this.d.properties[g];const u=this.e.enum.indexOf(g);u!==-1&&(this.e.enum.splice(u,1),this.e.enumDescriptions.splice(u,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(g=>this.b[g])}getIcon(g){return this.b[g]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(g,u){const p=this.f[g];return p||(this.f[g]=u,this.a.fire(),u)}deregisterIconFont(g){delete this.f[g]}getIconFont(g){return this.f[g]}toString(){const g=(d,E)=>d.id.localeCompare(E.id),u=d=>{for(;N.ThemeIcon.isThemeIcon(d.defaults);)d=this.b[d.defaults.id];return`codicon codicon-${d?d.id:""}`},p=[];p.push("| preview     | identifier                        | default codicon ID                | description"),p.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const m=Object.keys(this.b).map(d=>this.b[d]);for(const d of m.filter(E=>!!E.description).sort(g))p.push(`|<i class="${u(d)}"></i>|${d.id}|${N.ThemeIcon.isThemeIcon(d.defaults)?d.defaults.id:d.id}|${d.description||""}|`);p.push("| preview     | identifier                        "),p.push("| ----------- | --------------------------------- |");for(const d of m.filter(E=>!N.ThemeIcon.isThemeIcon(E.defaults)).sort(g))p.push(`|<i class="${u(d)}"></i>|${d.id}|`);return p.join(`
`)}}const n=new f;y.$no.add(e.$vx.IconContribution,n);function o(t,g,u,p){return n.registerIcon(t,g,u,p)}function s(){return n}function l(){const t=(0,C.$Xj)();for(const g in t){const u="\\"+t[g].toString(16);n.registerIcon(g,{fontCharacter:u})}}l(),e.$yx="vscode://schemas/icons";const i=y.$no.as(R.$oo.JSONContribution);i.registerSchema(e.$yx,n.getIconSchema());const r=new v.$Oh(()=>i.notifySchemaChanged(e.$yx),200);n.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.$zx=o("widget-close",I.$2j.close,(0,a.localize)(10987,null)),e.$Ax=o("goto-previous-location",I.$2j.arrowUp,(0,a.localize)(10988,null)),e.$Bx=o("goto-next-location",I.$2j.arrowDown,(0,a.localize)(10989,null)),e.$Cx=N.ThemeIcon.modify(I.$2j.sync,"spin"),e.$Dx=N.ThemeIcon.modify(I.$2j.loading,"spin")}),define(Ne[182],Oe([1,0,6,4,20,2,43,3,11]),function(we,e,v,I,C,N,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kw=e.$Jw=e.$Gw=e.$Ew=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Aw=e.$zw=void 0,e.$Bw=y,e.$Cw=S,e.$Dw=f,e.$Fw=n,e.$Hw=o,e.$Iw=s,e.$zw=(0,T.$Ci)("tunnelService"),e.$Aw=(0,T.$Ci)("sharedTunnelsService");var a;(function(r){r.Http="http",r.Https="https"})(a||(e.TunnelProtocol=a={}));var R;(function(r){r.ConstantPrivate="constantPrivate",r.Private="private",r.Public="public"})(R||(e.TunnelPrivacyId=R={}));function y(r){return!!r.forwardPort}var c;(function(r){r[r.Notify=1]="Notify",r[r.OpenBrowser=2]="OpenBrowser",r[r.OpenPreview=3]="OpenPreview",r[r.Silent=4]="Silent",r[r.Ignore=5]="Ignore",r[r.OpenBrowserOnce=6]="OpenBrowserOnce"})(c||(e.ProvidedOnAutoForward=c={}));function S(r){if(r.scheme!=="http"&&r.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(r.authority);if(t)return{address:t[1],port:+t[2]}}function f(r){if(r.scheme!=="http"&&r.scheme!=="https"||!r.query)return;const t=r.query.split("&");for(const g of t){const u=g.split("=")[1];if(/^https?:/.exec(u)){const p=S(N.URI.parse(u));if(p)return p}}}e.$Ew=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function n(r){return e.$Ew.indexOf(r)>=0}e.$Gw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function o(r){return e.$Gw.indexOf(r)>=0}function s(r,t,g,u){if(g===C.OperatingSystem.Windows)return!1;if(g===C.OperatingSystem.Macintosh&&o(t)){const p=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(p?.length===4&&parseInt(p[1])>=18)return!1}return r<1024}class l{constructor(t,g,u){this.remoteAddress=t,this.localAddress=g,this.b=u,this.a=new v.$je,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Jw=l;let i=class extends I.$Tc{constructor(t,g){super(),this.r=t,this.s=g,this.a=new v.$je,this.onTunnelOpened=this.a.event,this.b=new v.$je,this.onTunnelClosed=this.b.event,this.c=new v.$je,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],g=Array.from(this.f.values());for(const u of g){const p=Array.from(u.values());for(const m of p){const d=await m.value;d&&typeof d!="string"&&t.push(d)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:g}of t.values())await g.then(u=>typeof u!="string"?u?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,g,u,p,m){this.z(t,g,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:g,localAddress:u,privacy:p,protocol:m,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,g){(o(t)||n(t))&&(t=e.$Ew[0]);const u=this.D(t,g);if(u)return++u.refcount,u.value}openTunnel(t,g,u,p,m,d=!1,E,D){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${u} on local port ${m}.`);const w=this.g??t;if(!w)return;if(g||(g="localhost"),p||(p=this.t),this.g&&this.n.has(u)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const k=this.F(w,g,u,p,m,d,E,D);return k?k.then(P=>{if(P){if(typeof P=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(g,u),P}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(g,u);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const h=this.w(P);return(P.tunnelRemoteHost!==g||P.tunnelRemotePort!==u)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),E&&P.privacy!==E&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(h),h}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),k)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const g=this.f.get(t.tunnelRemoteHost);if(g){const u=g.get(t.tunnelRemotePort);u&&(u.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,u))}}}}async y(t,g,u){if(u.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${g}.`);const p=u.value.then(async m=>{m&&typeof m!="string"&&(await m.dispose(!0),this.b.fire({host:m.tunnelRemoteHost,port:m.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(g),p}}async closeTunnel(t,g){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${g} `);const u=this.f.get(t);if(u&&u.has(g)){const p=u.get(g);p.refcount=0,await this.y(t,g,p)}}z(t,g,u){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(g,{refcount:1,value:u})}async C(t,g){const u=this.f.get(t);if(u){const p=u.get(g),m=p?await p.value:void 0;(!m||typeof m=="string")&&u.delete(g),u.size===0&&this.f.delete(t)}}D(t,g){const u=[t];n(t)?(u.push(...e.$Ew),u.push(...e.$Gw)):o(t)&&u.push(...e.$Gw);const p=u.map(m=>this.f.get(m));for(const m of p){const d=m?.get(g);if(d)return d}}canTunnel(t){return!!S(t)}G(t,g,u,p,m,d,E){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${u} on local port ${p}.`);const D=u;this.n.add(D);const w=p===void 0?u:p,k={elevationRequired:m?this.isPortPrivileged(w):!1},P={remoteAddress:{host:g,port:u},localAddressPort:p,privacy:d,public:d?d!==R.Private:void 0,protocol:E},h=t.forwardPort(P,k);return h?(this.z(g,u,h),h.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(D)})):this.n.delete(D),h}};e.$Kw=i,e.$Kw=i=Qe([qe(0,$.$9j),qe(1,A.$9i)],i)}),define(Ne[183],Oe([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=void 0,e.$Gl=(0,v.$Ci)("IUriIdentityService")}),define(Ne[184],Oe([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Lw=void 0,e.$Lw=(0,v.$Ci)("editSessionIdentityService");var I;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(I||(e.EditSessionIdentityMatch=I={}))}),define(Ne[185],Oe([1,0,15]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2M=I,e.$3M=C,e.$4M=N,e.$5M=A,e.$6M=T;function I($){return $.scheme!==v.Schemas.file&&$.scheme!==v.Schemas.vscodeRemote}function C($){if($.folders.length)return $.folders.every(a=>I(a.uri))?$.folders[0].uri:void 0;if($.configuration&&I($.configuration))return $.configuration}function N($){return C($)?.scheme}function A($){return C($)?.authority}function T($){return C($)!==void 0}}),define(Ne[49],Oe([1,0,9,19,58,23,2,3,15]),function(we,e,v,I,C,N,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Wi=e.$Vi=e.WorkbenchState=e.$Pi=e.$Oi=e.$Li=void 0,e.$Mi=a,e.$Ni=R,e.$Qi=y,e.$Ri=c,e.$Si=S,e.$Ti=n,e.$Ui=o,e.$Xi=i,e.$3i=r,e.$4i=t,e.$6i=g,e.$7i=u,e.$8i=p,e.$Li=(0,T.$Ci)("contextService");function a(m){const d=m;return typeof d?.id=="string"&&A.URI.isUri(d.uri)}function R(m){return typeof m?.id=="string"&&!a(m)&&!c(m)}e.$Oi={id:"ext-dev"},e.$Pi={id:"empty-window"};function y(m,d){if(typeof m=="string"||typeof m>"u")return typeof m=="string"?{id:(0,I.$mc)(m)}:d?e.$Oi:e.$Pi;const E=m;return E.configuration?{id:E.id,configPath:E.configuration}:E.folders.length===1?{id:E.id,uri:E.folders[0].uri}:{id:E.id}}function c(m){const d=m;return typeof d?.id=="string"&&A.URI.isUri(d.configPath)}function S(m){const d=m;if(d?.uri)return{id:d.id,uri:A.URI.revive(d.uri)};const E=m;if(E?.configPath)return{id:E.id,configPath:A.URI.revive(E.configPath)};if(m?.id)return{id:m.id}}var f;(function(m){m[m.EMPTY=1]="EMPTY",m[m.FOLDER=2]="FOLDER",m[m.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function n(m){const d=m;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&Array.isArray(d.folders))}function o(m){const d=m;return!!(d&&typeof d=="object"&&A.URI.isUri(d.uri)&&typeof d.name=="string"&&typeof d.toResource=="function")}class s{constructor(d,E,D,w,k){this.h=d,this.j=D,this.k=w,this.l=k,this.c=C.$Ii.forUris(this.l,()=>!0),this.folders=E}update(d){this.h=d.id,this.k=d.configuration,this.j=d.transient,this.l=d.l,this.folders=d.folders}get folders(){return this.g}set folders(d){this.g=d,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(d){this.k=d}getFolder(d){return d&&this.c.findSubstr(d)||null}n(){this.c=C.$Ii.forUris(this.l,()=>!0);for(const d of this.folders)this.c.set(d.uri,d)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Vi=s;class l{constructor(d,E){this.raw=E,this.uri=d.uri,this.index=d.index,this.name=d.name}toResource(d){return(0,N.$dh)(this.uri,d)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Wi=l;function i(m){return new l({uri:m,index:0,name:(0,N.$_g)(m)},{uri:m.toString()})}e.$Yi="code-workspace",e.$Zi=`.${e.$Yi}`,e.$1i=[{name:(0,v.localize)(10864,null),extensions:[e.$Yi]}],e.$2i="workspace.json";function r(m,d){return N.$7g.isEqualOrParent(m,d.untitledWorkspacesHome)}function t(m){let d;return A.URI.isUri(m)?d=m:d=m.configuration,d?.scheme===$.Schemas.tmp}e.$5i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function g(m){return m.id===e.$5i}function u(m,d){return!r(m,d)&&!t(m)}function p(m){return(typeof m=="string"?(0,I.$nc)(m):(0,N.$bh)(m))===e.$Zi}}),define(Ne[113],Oe([1,0,75,6,4,23,2,9,106,29,3,11,49,28,183,10,37,12,14]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S,f,n,o,s,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=e.$Il=e.ProfileResourceType=void 0,e.$Hl=r,e.$Jl=t,e.$Kl=g;var i;(function(m){m.Settings="settings",m.Keybindings="keybindings",m.Snippets="snippets",m.Tasks="tasks",m.Extensions="extensions",m.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function r(m){const d=m;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&typeof d.isDefault=="boolean"&&typeof d.name=="string"&&A.URI.isUri(d.location)&&A.URI.isUri(d.globalStorageHome)&&A.URI.isUri(d.settingsResource)&&A.URI.isUri(d.keybindingsResource)&&A.URI.isUri(d.tasksResource)&&A.URI.isUri(d.snippetsHome)&&A.URI.isUri(d.extensionsResource))}e.$Il=(0,R.$Ci)("IUserDataProfilesService");function t(m,d){return{id:m.id,isDefault:m.isDefault,name:m.name,shortName:m.shortName,icon:m.icon,location:A.URI.revive(m.location).with({scheme:d}),globalStorageHome:A.URI.revive(m.globalStorageHome).with({scheme:d}),settingsResource:A.URI.revive(m.settingsResource).with({scheme:d}),keybindingsResource:A.URI.revive(m.keybindingsResource).with({scheme:d}),tasksResource:A.URI.revive(m.tasksResource).with({scheme:d}),snippetsHome:A.URI.revive(m.snippetsHome).with({scheme:d}),extensionsResource:A.URI.revive(m.extensionsResource).with({scheme:d}),cacheHome:A.URI.revive(m.cacheHome).with({scheme:d}),useDefaultFlags:m.useDefaultFlags,isTransient:m.isTransient}}function g(m,d,E,D,w,k){return{id:m,name:d,location:E,isDefault:!1,shortName:w?.shortName,icon:w?.icon,globalStorageHome:k&&w?.useDefaultFlags?.globalState?k.globalStorageHome:(0,N.$dh)(E,"globalStorage"),settingsResource:k&&w?.useDefaultFlags?.settings?k.settingsResource:(0,N.$dh)(E,"settings.json"),keybindingsResource:k&&w?.useDefaultFlags?.keybindings?k.keybindingsResource:(0,N.$dh)(E,"keybindings.json"),tasksResource:k&&w?.useDefaultFlags?.tasks?k.tasksResource:(0,N.$dh)(E,"tasks.json"),snippetsHome:k&&w?.useDefaultFlags?.snippets?k.snippetsHome:(0,N.$dh)(E,"snippets"),extensionsResource:k&&w?.useDefaultFlags?.extensions?k.extensionsResource:(0,N.$dh)(E,"extensions.json"),cacheHome:(0,N.$dh)(D,m),useDefaultFlags:w?.useDefaultFlags,isTransient:w?.transient}}let u=class extends C.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(d,E,D,w){super(),this.t=d,this.u=E,this.w=D,this.y=w,this.f=!0,this.h=this.B(new I.$je),this.onDidChangeProfiles=this.h.event,this.j=this.B(new I.$je),this.onWillCreateProfile=this.j.event,this.m=this.B(new I.$je),this.onWillRemoveProfile=this.m.event,this.n=this.B(new I.$je),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new S.$zc,workspaces:new S.$zc,emptyWindows:new Map},this.profilesHome=(0,N.$dh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,N.$dh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(d){this.f!==d&&(this.z=void 0,this.f=d)}isEnabled(){return this.f}get C(){if(!this.z){const d=this.D(),E=[d];if(this.f)try{for(const k of this.O()){if(!k.name||!(0,l.$cg)(k.name)||!k.location){this.y.warn("Skipping the invalid stored profile",k.location||k.name);continue}E.push(g((0,N.$ah)(k.location),k.name,k.location,this.g,{shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags},d))}}catch(k){this.y.error(k)}const D=new S.$zc,w=new Map;if(E.length)try{const k=this.Q();if(k.workspaces)for(const[P,h]of Object.entries(k.workspaces)){const b=A.URI.parse(P),M=E.find(O=>O.id===h);M&&D.set(b,M)}if(k.emptyWindows)for(const[P,h]of Object.entries(k.emptyWindows)){const b=E.find(M=>M.id===h);b&&w.set(P,b)}}catch(k){this.y.error(k)}this.z={profiles:E,workspaces:D,emptyWindows:w}}return this.z}D(){const d=g("__default__profile__",(0,T.localize)(10911,null),this.t.userRoamingDataHome,this.g);return{...d,extensionsResource:this.S()??d.extensionsResource,isDefault:!0}}async createTransientProfile(d){const E="Temp",D=new RegExp(`${(0,s.$ff)(E)}\\s(\\d+)`);let w=0;for(const P of this.profiles){const h=D.exec(P.name),b=h?parseInt(h[1]):0;w=b>w?b:w}const k=`${E} ${w+1}`;return this.createProfile((0,v.$qj)((0,o.$Yg)()).toString(16),k,{transient:!0},d)}async createNamedProfile(d,E,D){return this.createProfile((0,v.$qj)((0,o.$Yg)()).toString(16),d,E,D)}async createProfile(d,E,D,w){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=await this.F(d,E,D);return w&&await this.setProfileForWorkspace(w,k),k}async F(d,E,D){if(!(0,l.$cg)(E)||!E)throw new Error("Name of the profile is mandatory and must be of type `string`");let w=this.r.get(E);return w||(w=(async()=>{try{if(this.profiles.find(b=>b.name===E||b.id===d))throw new Error(`Profile with ${E} name already exists`);const P=g(d,E,(0,N.$dh)(this.profilesHome,d),this.g,D,this.defaultProfile);await this.u.createFolder(P.location);const h=[];return this.j.fire({profile:P,join(b){h.push(b)}}),await n.Promises.settled(h),this.I([P],[],[]),P}finally{this.r.delete(E)}})(),this.r.set(E,w)),w}async updateProfile(d,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let D=this.profiles.find(w=>w.id===d.id);if(!D)throw new Error(`Profile '${d.name}' does not exist`);return D=g(D.id,E.name??D.name,D.location,this.g,{shortName:E.shortName??D.shortName,icon:E.icon===null?void 0:E.icon??D.icon,transient:E.transient??D.isTransient,useDefaultFlags:E.useDefaultFlags??D.useDefaultFlags},this.defaultProfile),this.I([],[],[D]),D}async removeProfile(d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(d.isDefault)throw new Error("Cannot remove default profile");const E=this.profiles.find(w=>w.id===d.id);if(!E)throw new Error(`Profile '${d.name}' does not exist`);const D=[];this.m.fire({profile:E,join(w){D.push(w)}});try{await Promise.allSettled(D)}catch(w){this.y.error(w)}for(const w of[...this.C.emptyWindows.keys()])E.id===this.C.emptyWindows.get(w)?.id&&this.C.emptyWindows.delete(w);for(const w of[...this.C.workspaces.keys()])E.id===this.C.workspaces.get(w)?.id&&this.C.workspaces.delete(w);this.M(),this.I([],[E],[]);try{await this.u.del(E.cacheHome,{recursive:!0})}catch(w){(0,a.$nl)(w)!==a.FileOperationResult.FILE_NOT_FOUND&&this.y.error(w)}}async setProfileForWorkspace(d,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=this.profiles.find(w=>w.id===E.id);if(!D)throw new Error(`Profile '${E.name}' does not exist`);this.L(d,D)}unsetWorkspace(d,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(d,void 0,E)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const d=await this.u.resolve(this.profilesHome);await Promise.all((d.children||[]).filter(E=>E.isDirectory&&this.profiles.every(D=>!this.w.extUri.isEqual(D.location,E.resource))).map(E=>this.u.del(E.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const d=this.s.profiles.filter(E=>!this.H(E));await Promise.allSettled(d.map(E=>this.removeProfile(E)))}getProfileForWorkspace(d){const E=this.G(d),D=A.URI.isUri(E)?this.C.workspaces.get(E):this.C.emptyWindows.get(E);return D||((0,c.$Mi)(d)?this.s.folders.get(d.uri):(0,c.$Ri)(d)?this.s.workspaces.get(d.configPath):this.s.emptyWindows.get(d.id))}G(d){return(0,c.$Mi)(d)?d.uri:(0,c.$Ri)(d)?d.configPath:d.id}H(d){return!!([...this.C.emptyWindows.values()].some(E=>this.w.extUri.isEqual(E.location,d.location))||[...this.C.workspaces.values()].some(E=>this.w.extUri.isEqual(E.location,d.location))||[...this.s.emptyWindows.values()].some(E=>this.w.extUri.isEqual(E.location,d.location))||[...this.s.workspaces.values()].some(E=>this.w.extUri.isEqual(E.location,d.location))||[...this.s.folders.values()].some(E=>this.w.extUri.isEqual(E.location,d.location)))}I(d,E,D){const w=[...this.profiles,...d],k=[],P=this.s.profiles;this.s.profiles=[];for(let h of w){if(h.isDefault||E.some(M=>h.id===M.id))continue;h=D.find(M=>h.id===M.id)??h;const b=P.find(M=>h.id===M.id);if(h.isTransient)this.s.profiles.push(h);else{if(b){for(const[M,O]of this.s.emptyWindows.entries())if(h.id===O.id){this.L({id:M},h);break}for(const[M,O]of this.s.workspaces.entries())if(h.id===O.id){this.L({id:"",configPath:M},h);break}for(const[M,O]of this.s.folders.entries())if(h.id===O.id){this.L({id:"",uri:M},h);break}}k.push({location:h.location,name:h.name,shortName:h.shortName,icon:h.icon,useDefaultFlags:h.useDefaultFlags})}}this.P(k),this.z=void 0,this.J(d,E,D)}J(d,E,D){this.h.fire({added:d,removed:E,updated:D,all:this.profiles})}L(d,E,D){if(D=E?.isTransient?!0:D,D)(0,c.$Mi)(d)?(this.s.folders.delete(d.uri),E&&this.s.folders.set(d.uri,E)):(0,c.$Ri)(d)?(this.s.workspaces.delete(d.configPath),E&&this.s.workspaces.set(d.configPath,E)):(this.s.emptyWindows.delete(d.id),E&&this.s.emptyWindows.set(d.id,E));else{this.L(d,void 0,!0);const w=this.G(d);A.URI.isUri(w)?(this.C.workspaces.delete(w),E&&this.C.workspaces.set(w,E)):(this.C.emptyWindows.delete(w),E&&this.C.emptyWindows.set(w,E)),this.M()}}M(){const d={};for(const[D,w]of this.C.workspaces.entries())d[D.toString()]=w.id;const E={};for(const[D,w]of this.C.emptyWindows.entries())E[D.toString()]=w.id;this.R({workspaces:d,emptyWindows:E}),this.z=void 0}N(d){const E={},D=this.D();if(d.workspaces)for(const[k,P]of Object.entries(d.workspaces)){const h=A.URI.parse(P);E[k]=this.w.extUri.isEqual(h,D.location)?D.id:this.w.extUri.basename(h)}const w={};if(d.emptyWindows)for(const[k,P]of Object.entries(d.emptyWindows)){const h=A.URI.parse(P);w[k]=this.w.extUri.isEqual(h,D.location)?D.id:this.w.extUri.basename(h)}return{workspaces:E,emptyWindows:w}}O(){return[]}P(d){throw new Error("not implemented")}Q(){return{}}R(d){throw new Error("not implemented")}S(){}};e.$Ll=u,e.$Ll=u=Qe([qe(0,$.$Ji),qe(1,a.$9k),qe(2,f.$Gl),qe(3,y.$9j)],u);class p extends u{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(d){this.a=d}Q(){return this.X}R(d){this.X=d}}e.$Ml=p}),define(Ne[186],Oe([1,0,10,6,4,64,14,151,3,113]),function(we,e,v,I,C,N,A,T,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$gq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$eq=e.$dq=e.$cq=void 0,e.$fq=S,e.$hq=n,e.$jq=s,e.$cq="__$__isNewStorageMarker",e.$dq="__$__targetStorageMarker",e.$eq=(0,$.$Ci)("storageService");var R;(function(l){l[l.NONE=0]="NONE",l[l.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var y;(function(l){l[l.APPLICATION=-1]="APPLICATION",l[l.PROFILE=0]="PROFILE",l[l.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var c;(function(l){l[l.USER=0]="USER",l[l.MACHINE=1]="MACHINE"})(c||(e.StorageTarget=c={}));function S(l){const i=l.get(e.$dq);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class f extends C.$Tc{static{this.a=60*1e3}constructor(i={flushInterval:f.a}){super(),this.m=i,this.b=this.B(new I.$me),this.c=this.B(new I.$me),this.onDidChangeTarget=this.c.event,this.f=this.B(new I.$je),this.onWillSaveState=this.f.event,this.h=this.B(new v.$Oh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new C.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,r,t){return I.Event.filter(this.b.event,g=>g.scope===i&&(r===void 0||g.key===r),t)}n(){this.j.value=(0,v.$Sh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,C.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,N.mark)("code/willInitStorage");try{await this.O()}finally{(0,N.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,r){const{key:t,external:g}=r;if(t===e.$dq){switch(i){case y.APPLICATION:this.H=void 0;break;case y.PROFILE:this.F=void 0;break;case y.WORKSPACE:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:t,target:this.J(i)[t],external:g})}w(i){this.f.fire({reason:i})}get(i,r,t){return this.P(r)?.get(i,t)}getBoolean(i,r,t){return this.P(r)?.getBoolean(i,t)}getNumber(i,r,t){return this.P(r)?.getNumber(i,t)}getObject(i,r,t){return this.P(r)?.getObject(i,t)}storeAll(i,r){this.y(()=>{for(const t of i)this.store(t.key,t.value,t.scope,t.target,r)})}store(i,r,t,g,u=!1){if((0,A.$lg)(r)){this.remove(i,t,u);return}this.y(()=>{this.z(i,t,g),this.P(t)?.set(i,r,u)})}remove(i,r,t=!1){this.y(()=>{this.z(i,r,void 0),this.P(r)?.delete(i,t)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,r){const t=[],g=this.J(i);for(const u of Object.keys(g))g[u]===r&&t.push(u);return t}z(i,r,t,g=!1){const u=this.J(r);typeof t=="number"?u[i]!==t&&(u[i]=t,this.P(r)?.set(e.$dq,JSON.stringify(u),g)):typeof u[i]=="number"&&(delete u[i],this.P(r)?.set(e.$dq,JSON.stringify(u),g))}get D(){return this.C||(this.C=this.L(y.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(y.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(y.APPLICATION)),this.H}J(i){switch(i){case y.APPLICATION:return this.I;case y.PROFILE:return this.G;default:return this.D}}L(i){const r=this.P(i);return r?S(r):Object.create(null)}isNew(i){return this.getBoolean(e.$cq,i)===!0}async flush(i=R.NONE){this.f.fire({reason:i});const r=this.P(y.APPLICATION),t=this.P(y.PROFILE),g=this.P(y.WORKSPACE);switch(i){case R.NONE:await v.Promises.settled([r?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await v.Promises.settled([r?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(y.APPLICATION)?.items??new Map,r=this.P(y.PROFILE)?.items??new Map,t=this.P(y.WORKSPACE)?.items??new Map;return s(i,r,t,this.Q(y.APPLICATION)??"",this.Q(y.PROFILE)??"",this.Q(y.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,r){return this.w(R.NONE),(0,a.$Hl)(i)?this.R(i,r):this.S(i,r)}M(i,r){return!(i.id===r.id||n(r)&&n(i))}N(i,r,t){this.y(()=>{const g=new Set;for(const[u,p]of i)g.add(u),r.get(u)!==p&&this.u(t,{key:u,external:!0});for(const[u]of r.items)g.has(u)||this.u(t,{key:u,external:!0})})}}e.$gq=f;function n(l){return l.isDefault||!!l.useDefaultFlags?.globalState}class o extends f{constructor(){super(),this.U=this.B(new T.$aq(new T.$bq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new T.$aq(new T.$bq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new T.$aq(new T.$bq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(y.WORKSPACE,i))),this.B(this.W.onDidChangeStorage(i=>this.u(y.PROFILE,i))),this.B(this.U.onDidChangeStorage(i=>this.u(y.APPLICATION,i)))}P(i){switch(i){case y.APPLICATION:return this.U;case y.PROFILE:return this.W;default:return this.X}}Q(i){switch(i){case y.APPLICATION:return"inMemory (application)";case y.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$iq=o;async function s(l,i,r,t,g,u){const p=b=>{try{return JSON.parse(b)}catch{return b}},m=new Map,d=new Map;l.forEach((b,M)=>{m.set(M,b),d.set(M,p(b))});const E=new Map,D=new Map;i.forEach((b,M)=>{E.set(M,b),D.set(M,p(b))});const w=new Map,k=new Map;r.forEach((b,M)=>{w.set(M,b),k.set(M,p(b))}),console.group(t!==g?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const P=[];if(m.forEach((b,M)=>{P.push({key:M,value:b})}),console.table(P),console.groupEnd(),console.log(d),t!==g){console.group(`Storage: Profile (path: ${g}, profile specific)`);const b=[];E.forEach((M,O)=>{b.push({key:O,value:M})}),console.table(b),console.groupEnd(),console.log(D)}console.group(`Storage: Workspace (path: ${u})`);const h=[];w.forEach((b,M)=>{h.push({key:M,value:b})}),console.table(h),console.groupEnd(),console.log(k)}}),define(Ne[79],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$loc=void 0;class v{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const N=this.c++;return this.b.set(N,C),this.e(),N}get(C,N){return this.b.has(C)?this.b.get(C)[N]:void 0}delete(C){this.b.delete(C),this.e()}e(){v.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$loc=v}),define(Ne[50],Oe([1,0,15,23,29,3]),function(we,e,v,I,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$roc=e.$qoc=void 0;class A{constructor(){this.a=new Set(Object.keys(v.Schemas)),this.b=new Map,this.extUri=new I.$5g($=>{const a=this.b.get($.scheme);return!(a===void 0||a&C.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos($,a){a===null?this.b.delete($.scheme):this.b.set($.scheme,a)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$qoc=A,e.$roc=(0,N.$Ci)("IExtHostFileSystemInfo")}),define(Ne[26],Oe([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=void 0,e.$eQ=(0,v.$Ci)("IExtHostInitDataService")}),define(Ne[187],Oe([1,0,9,11,171,26]),function(we,e,v,I,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zqc=void 0;let A=class extends C.$oR{constructor($,a,R){const y=R.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",c=R.remote.isRemote?(0,v.localize)(10665,null):$?(0,v.localize)(10666,null):(0,v.localize)(10667,null);super(a.createLogger(y,{name:c}))}};e.$zqc=A,e.$zqc=A=Qe([qe(1,I.$0j),qe(2,N.$eQ)],A)}),define(Ne[188],Oe([1,0,10]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0oc=e.$9oc=void 0;class I{constructor(A,T,$){this.h=new Map,this.a=A,this.b=T,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(a=>(this.f=a,this)),this.g=this.c.onDidChangeStorage(a=>{a.shared===this.b&&a.key===this.a&&(this.f=a.value)}),this.i=new v.$Oh(()=>{const a=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of a.values())R.complete()}catch(R){for(const y of a.values())y.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,T){let $=this.f[A];return typeof $>"u"&&($=T),$}update(A,T){this.f[A]=T;const $=this.h.get(A);if($!==void 0)return $.p;const a=new v.$Zh;return this.h.set(A,a),this.i.isScheduled()||this.i.schedule(),a.p}dispose(){this.g.dispose()}}e.$9oc=I;class C extends I{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,T){super(A.identifier.value,!0,T),this.j=A}}e.$0oc=C}),define(Ne[189],Oe([1,0,6,2]),function(we,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4pc=void 0;class C{constructor(A){this.c=A,this.a=new v.$je,this.onDidSaveNotebookDocument=this.a.event,this.b=new v.$je,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,T,$,a){const y=this.c.getNotebookDocument(I.URI.revive(A)).acceptModelChanged(T.value,$,a);this.b.fire(y)}$acceptDirtyStateChanged(A,T){this.c.getNotebookDocument(I.URI.revive(A)).acceptDirty(T)}$acceptModelSaved(A){const T=this.c.getNotebookDocument(I.URI.revive(A));this.a.fire(T.apiNotebook)}}e.$4pc=C}),define(Ne[16],Oe([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2P=e.$1P=void 0,e.$1P=(0,v.$Ci)("IExtHostRpcService");class I{constructor(N){this.getProxy=N.getProxy.bind(N),this.set=N.set.bind(N),this.dispose=N.dispose.bind(N),this.assertRegistered=N.assertRegistered.bind(N),this.drain=N.drain.bind(N)}}e.$2P=I}),define(Ne[190],Oe([1,0,18,6,4]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gpc=void 0;class N{#e;constructor(T,$){this.disposables=new C.$Sc,this.a=v.$nn.toKey(T.identifier),this.#e=$,this.onDidChange=I.Event.map(I.Event.filter(this.#e.onDidChangePassword,a=>a.extensionId===this.a),a=>({key:a.key}),this.disposables)}dispose(){this.disposables.dispose()}get(T){return this.#e.get(this.a,T)}store(T,$){return this.#e.store(this.a,T,$)}delete(T){return this.#e.delete(this.a,T)}}e.$gpc=N}),define(Ne[65],Oe([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hoc=e.$Goc=void 0,e.$Goc=(0,v.$Ci)("IURITransformerService");class I{constructor(N){N?(this.transformIncoming=N.transformIncoming.bind(N),this.transformOutgoing=N.transformOutgoing.bind(N),this.transformOutgoingURI=N.transformOutgoingURI.bind(N),this.transformOutgoingScheme=N.transformOutgoingScheme.bind(N)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Hoc=I});var _t=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Ne[114],Oe([1,0,9,14,2,4,3,30,29,15,42,163,35]),function(we,e,v,I,C,N,A,T,$,a,R,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$cG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$5F=e.EditorInputCapabilities=e.$4F=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$TF=e.$SF=e.$RF=e.$QF=e.$PF=void 0,e.$UF=n,e.$VF=o,e.$WF=s,e.$XF=l,e.$YF=i,e.$ZF=r,e.$1F=t,e.$2F=g,e.$3F=u,e.$6F=w,e.$7F=P,e.$8F=h,e.$9F=b,e.$0F=M,e.$$F=O,e.$_F=F,e.$aG=q,e.$bG=_,e.$dG=ae,e.$eG=oe,e.$fG=Ce,e.$gG=Fe,c=_t(c),e.$PF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$QF={id:"default",displayName:(0,v.localize)(12306,null),providerDisplayName:(0,v.localize)(12307,null)},e.$RF="workbench.editor.sidebysideEditor",e.$SF="workbench.editors.textDiffEditor",e.$TF="workbench.editors.binaryResourceDiffEditor";var S;(function(X){X[X.PROGRAMMATIC=1]="PROGRAMMATIC",X[X.USER=2]="USER",X[X.EDIT=3]="EDIT",X[X.NAVIGATION=4]="NAVIGATION",X[X.JUMP=5]="JUMP"})(S||(e.EditorPaneSelectionChangeReason=S={}));var f;(function(X){X[X.IDENTICAL=1]="IDENTICAL",X[X.SIMILAR=2]="SIMILAR",X[X.DIFFERENT=3]="DIFFERENT"})(f||(e.EditorPaneSelectionCompareResult=f={}));function n(X){const V=X;return!!V&&typeof V.getSelection=="function"&&!!V.onDidChangeSelection}function o(X){const V=X;return!!V&&typeof V.getScrollPosition=="function"&&typeof V.setScrollPosition=="function"&&!!V.onDidChangeScroll}function s(X,V,te){for(const ve of te.visibleEditorPanes)if(ve.group.id===V&&X.matches(ve.input))return ve.getViewState()}function l(X){if(w(X))return!1;const V=X;return C.URI.isUri(V?.resource)}function i(X){if(w(X))return!1;const V=X;return V?.original!==void 0&&V.modified!==void 0}function r(X){if(w(X))return!1;const V=X;return!V||V.resources&&!Array.isArray(V.resources)?!1:!!V.resources||!!V.multiDiffSource}function t(X){if(w(X)||i(X))return!1;const V=X;return V?.primary!==void 0&&V.secondary!==void 0}function g(X){if(w(X))return!1;const V=X;return V?V.resource===void 0||V.resource.scheme===a.Schemas.untitled||V.forceUntitled===!0:!1}function u(X){if(w(X))return!1;const V=X;return C.URI.isUri(V?.base?.resource)&&C.URI.isUri(V?.input1?.resource)&&C.URI.isUri(V?.input2?.resource)&&C.URI.isUri(V?.result?.resource)}var p;(function(X){X[X.SHORT=0]="SHORT",X[X.MEDIUM=1]="MEDIUM",X[X.LONG=2]="LONG"})(p||(e.Verbosity=p={}));var m;(function(X){X[X.EXPLICIT=1]="EXPLICIT",X[X.AUTO=2]="AUTO",X[X.FOCUS_CHANGE=3]="FOCUS_CHANGE",X[X.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(m||(e.SaveReason=m={}));class d{constructor(){this.a=new Map}registerSource(V,te){let ve=this.a.get(V);return ve||(ve={source:V,label:te},this.a.set(V,ve)),ve.source}getSourceLabel(V){return this.a.get(V)?.label??V}}e.$4F=new d;var E;(function(X){X[X.None=0]="None",X[X.Readonly=2]="Readonly",X[X.Untitled=4]="Untitled",X[X.Singleton=8]="Singleton",X[X.RequiresTrust=16]="RequiresTrust",X[X.CanSplitInGroup=32]="CanSplitInGroup",X[X.ForceDescription=64]="ForceDescription",X[X.CanDropIntoEditor=128]="CanDropIntoEditor",X[X.MultipleEditors=256]="MultipleEditors",X[X.Scratchpad=512]="Scratchpad"})(E||(e.EditorInputCapabilities=E={}));class D extends N.$Tc{}e.$5F=D;function w(X){return X instanceof D}function k(X){const V=X;return C.URI.isUri(V?.preferredResource)}function P(X){const V=X;return w(V?.primary)&&w(V?.secondary)}function h(X){const V=X;return w(V?.modified)&&w(V?.original)}function b(X,V,te,ve,ce){return Fe(ve,[(0,y.$mj)({id:"workbench.action.openLargeFile",label:(0,v.localize)(12308,null),run:()=>{const be={...te,limits:{size:Number.MAX_VALUE}};X.openEditor(V,be)}}),(0,y.$mj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,v.localize)(12309,null),run:()=>ce.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:c.default.Warning})}function M(X){return w(X?.editor)}function O(X){const V=X;return M(X)&&V?.group!==void 0}function F(X){const V=X;return typeof V?.groupId=="number"&&w(V.editor)}function q(X){return typeof X?.groupId=="number"}var B;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.REPLACE=1]="REPLACE",X[X.MOVE=2]="MOVE",X[X.UNPIN=3]="UNPIN"})(B||(e.EditorCloseContext=B={}));var L;(function(X){X[X.GROUP_ACTIVE=0]="GROUP_ACTIVE",X[X.GROUP_INDEX=1]="GROUP_INDEX",X[X.GROUP_LABEL=2]="GROUP_LABEL",X[X.GROUP_LOCKED=3]="GROUP_LOCKED",X[X.EDITORS_SELECTION=4]="EDITORS_SELECTION",X[X.EDITOR_OPEN=5]="EDITOR_OPEN",X[X.EDITOR_CLOSE=6]="EDITOR_CLOSE",X[X.EDITOR_MOVE=7]="EDITOR_MOVE",X[X.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",X[X.EDITOR_LABEL=9]="EDITOR_LABEL",X[X.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",X[X.EDITOR_PIN=11]="EDITOR_PIN",X[X.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",X[X.EDITOR_STICKY=13]="EDITOR_STICKY",X[X.EDITOR_DIRTY=14]="EDITOR_DIRTY",X[X.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(L||(e.GroupModelChangeKind=L={}));var Y;(function(X){X[X.PRIMARY=1]="PRIMARY",X[X.SECONDARY=2]="SECONDARY",X[X.BOTH=3]="BOTH",X[X.ANY=4]="ANY"})(Y||(e.SideBySideEditor=Y={}));class Z{getOriginalUri(V,te){if(!V)return;if(u(V))return e.$cG.getOriginalUri(V.result,te);if(te?.supportSideBySide){const{primary:ce,secondary:be}=this.a(V);if(ce&&be){if(te?.supportSideBySide===Y.BOTH)return{primary:this.getOriginalUri(ce,{filterByScheme:te.filterByScheme}),secondary:this.getOriginalUri(be,{filterByScheme:te.filterByScheme})};if(te?.supportSideBySide===Y.ANY)return this.getOriginalUri(ce,{filterByScheme:te.filterByScheme})??this.getOriginalUri(be,{filterByScheme:te.filterByScheme});V=te.supportSideBySide===Y.PRIMARY?ce:be}}if(i(V)||r(V)||t(V)||u(V))return;const ve=k(V)?V.preferredResource:V.resource;return!ve||!te||!te.filterByScheme?ve:this.b(ve,te.filterByScheme)}a(V){return P(V)||t(V)?{primary:V.primary,secondary:V.secondary}:h(V)||i(V)?{primary:V.modified,secondary:V.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(V,te){if(!V)return;if(u(V))return e.$cG.getCanonicalUri(V.result,te);if(te?.supportSideBySide){const{primary:ce,secondary:be}=this.a(V);if(ce&&be){if(te?.supportSideBySide===Y.BOTH)return{primary:this.getCanonicalUri(ce,{filterByScheme:te.filterByScheme}),secondary:this.getCanonicalUri(be,{filterByScheme:te.filterByScheme})};if(te?.supportSideBySide===Y.ANY)return this.getCanonicalUri(ce,{filterByScheme:te.filterByScheme})??this.getCanonicalUri(be,{filterByScheme:te.filterByScheme});V=te.supportSideBySide===Y.PRIMARY?ce:be}}if(i(V)||r(V)||t(V)||u(V))return;const ve=V.resource;return!ve||!te||!te.filterByScheme?ve:this.b(ve,te.filterByScheme)}b(V,te){if(Array.isArray(te)){if(te.some(ve=>V.scheme===ve))return V}else if(te===V.scheme)return V}}var fe;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.KEYBOARD=1]="KEYBOARD",X[X.MOUSE=2]="MOUSE"})(fe||(e.EditorCloseMethod=fe={}));function _(X,V,te,ve){if(!X.isSticky(V))return!1;switch(ve.preventPinnedEditorClose){case"keyboardAndMouse":return te===fe.MOUSE||te===fe.KEYBOARD;case"mouse":return te===fe.MOUSE;case"keyboard":return te===fe.KEYBOARD}return!1}e.$cG=new Z;var ge;(function(X){X[X.LEFT=0]="LEFT",X[X.RIGHT=1]="RIGHT"})(ge||(e.CloseDirection=ge={}));class se{constructor(){this.c=new Map,this.d=new Map}start(V){const te=this.a=V.get(A.$Bi);for(const[ve,ce]of this.c)this.e(ve,ce,te);this.c.clear()}e(V,te,ve){const ce=ve.createInstance(te);this.d.set(V,ce)}registerFileEditorFactory(V){if(this.b)throw new Error("Can only register one file editor factory.");this.b=V}getFileEditorFactory(){return(0,I.$ng)(this.b)}registerEditorSerializer(V,te){if(this.c.has(V)||this.d.has(V))throw new Error(`A editor serializer with type ID '${V}' was already registered.`);return this.a?this.e(V,te,this.a):this.c.set(V,te),(0,N.$Rc)(()=>{this.c.delete(V),this.d.delete(V)})}getEditorSerializer(V){return this.d.get(typeof V=="string"?V:V.typeId)}}T.$no.add(e.$PF.EditorFactory,new se);async function ae(X,V,te){return!X||!X.length?[]:await Promise.all(X.map(async ve=>{const ce=C.URI.revive(ve.fileUri);if(!ce){te.info("Cannot resolve the path because it is not valid.",ve);return}if(!await V.canHandleResource(ce)){te.info("Cannot resolve the path because it cannot be handled",ve);return}let he=ve.exists,J=ve.type;if(typeof he!="boolean"||typeof J!="number")try{J=(await V.stat(ce)).isDirectory?$.FileType.Directory:$.FileType.Unknown,he=!0}catch(me){te.error(me),he=!1}if(!he&&ve.openOnlyIfExists){te.info("Cannot resolve the path because it does not exist",ve);return}if(J===$.FileType.Directory){te.info("Cannot resolve the path because it is a directory",ve);return}const x={...ve.options,pinned:!0};return he?{resource:ce,options:x}:{resource:ce,options:x,forceUntitled:!0}}))}var $e;(function(X){X[X.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",X[X.SEQUENTIAL=1]="SEQUENTIAL"})($e||(e.EditorsOrder=$e={}));function oe(X){const V=X;if(!V)return!1;const te=V;if(te.modified)return oe(te.modified);const ve=V;return!!(ve.contributionsState&&ve.viewState&&Array.isArray(ve.cursorState))}function Ce(X){return(0,R.$oj)(X)}function Fe(X,V,te){const ve=(0,R.$pj)(X,V);return ve.forceMessage=te?.forceMessage,ve.forceSeverity=te?.forceSeverity,ve.allowDialog=te?.allowDialog,ve}}),define(Ne[191],Oe([1,0,6,9,3,4,28,30,25,97,181]),function(we,e,v,I,C,N,A,T,$,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oG=e.$nG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$mG=e.ViewContentGroups=e.$kG=e.ViewContainerLocation=e.Extensions=e.$jG=e.$iG=e.$hG=void 0,e.$lG=S,e.$hG="views",e.$iG=(0,I.localize)(12146,null),e.$jG=(0,R.$wx)("default-view-icon",a.$2j.window,(0,I.localize)(12147,null));var y;(function(g){g.ViewContainersRegistry="workbench.registry.view.containers",g.ViewsRegistry="workbench.registry.view"})(y||(e.Extensions=y={}));var c;(function(g){g[g.Sidebar=0]="Sidebar",g[g.Panel=1]="Panel",g[g.AuxiliaryBar=2]="AuxiliaryBar"})(c||(e.ViewContainerLocation=c={})),e.$kG=[c.Sidebar,c.Panel,c.AuxiliaryBar];function S(g){switch(g){case c.Sidebar:return"sidebar";case c.Panel:return"panel";case c.AuxiliaryBar:return"auxiliarybar"}}class f extends N.$Tc{constructor(){super(...arguments),this.c=this.B(new v.$je),this.onDidRegister=this.c.event,this.f=this.B(new v.$je),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(u,p,m){const d=this.get(u.id);if(d)return d;const E=u;return E.openCommandActionDescriptor=m?.doNotRegisterOpenCommand?void 0:E.openCommandActionDescriptor??{id:E.id},(0,A.$wc)(this.g,p,[]).push(E),m?.isDefault&&this.h.push(E),this.c.fire({viewContainer:E,viewContainerLocation:p}),E}deregisterViewContainer(u){for(const p of this.g.keys()){const m=this.g.get(p),d=m?.indexOf(u);if(d!==-1){m?.splice(d,1),m.length===0&&this.g.delete(p),this.f.fire({viewContainer:u,viewContainerLocation:p});return}}}get(u){return this.all.filter(p=>p.id===u)[0]}getViewContainers(u){return[...this.g.get(u)||[]]}getViewContainerLocation(u){return[...this.g.keys()].filter(p=>this.getViewContainers(p).filter(m=>m?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.h.find(p=>this.getViewContainerLocation(p)===u)}}T.$no.add(y.ViewContainersRegistry,new f);var n;(function(g){g.Open="2_open",g.Debug="4_debug",g.SCM="5_scm",g.More="9_more"})(n||(e.ViewContentGroups=n={}));function o(g,u){const p=g.group??n.More,m=u.group??n.More;return p!==m?p.localeCompare(m):(g.order??5)-(u.order??5)}class s extends N.$Tc{constructor(){super(...arguments),this.c=this.B(new v.$je),this.onViewsRegistered=this.c.event,this.f=this.B(new v.$je),this.onViewsDeregistered=this.f.event,this.g=this.B(new v.$je),this.onDidChangeContainer=this.g.event,this.h=this.B(new v.$je),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Gc}registerViews(u,p){this.registerViews2([{views:u,viewContainer:p}])}registerViews2(u){u.forEach(({views:p,viewContainer:m})=>this.r(p,m)),this.c.fire(u)}deregisterViews(u,p){const m=this.s(u,p);m.length&&this.f.fire({views:m,viewContainer:p})}moveViews(u,p){for(const m of this.m.keys())if(m!==p){const d=this.s(u,m);d.length&&(this.r(d,p),this.g.fire({views:d,from:m,to:p}))}}getViews(u){return this.m.get(u)||[]}getView(u){for(const p of this.j){const m=(this.m.get(p)||[]).filter(d=>d.id===u)[0];if(m)return m}return null}getViewContainer(u){for(const p of this.j)if((this.m.get(p)||[]).filter(d=>d.id===u)[0])return p;return null}registerViewWelcomeContent(u,p){return this.n.add(u,p),this.h.fire(u),(0,N.$Rc)(()=>{this.n.delete(u,p),this.h.fire(u)})}registerViewWelcomeContent2(u,p){const m=new Map;for(const[d,E]of p)this.n.add(u,E),m.set(d,(0,N.$Rc)(()=>{this.n.delete(u,E),this.h.fire(u)}));return this.h.fire(u),m}getViewWelcomeContent(u){const p=[];return this.n.forEach(u,m=>p.push(m)),p.sort(o)}r(u,p){let m=this.m.get(p);m||(m=[],this.m.set(p,m),this.j.push(p));for(const d of u){if(this.getView(d.id)!==null)throw new Error((0,I.localize)(12148,null,d.id));m.push(d)}}s(u,p){const m=this.m.get(p);if(!m)return[];const d=[],E=[];for(const D of m)u.includes(D)?d.push(D):E.push(D);return d.length&&(E.length?this.m.set(p,E):(this.m.delete(p),this.j.splice(this.j.indexOf(p),1))),d}}T.$no.add(y.ViewsRegistry,new s),e.$mG=(0,C.$Ci)("viewDescriptorService");var l;(function(g){g[g.Default=0]="Default",g[g.Expand=1]="Expand"})(l||(e.ViewVisibilityState=l={}));var i;(function(g){g[g.None=0]="None",g[g.Collapsed=1]="Collapsed",g[g.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class r{constructor(u,p){this.c=!1,this.d=!1,(0,$.$do)(this,u),this.d=!!p,this.resolve=async m=>{if(p&&!this.c){const d=await p(m);d&&(this.tooltip=this.tooltip??d.tooltip,this.command=this.command??d.command)}m.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$nG=r;class t extends Error{constructor(u){super((0,I.localize)(12149,null,u)),this.name="NoTreeViewError"}static is(u){return u.name==="NoTreeViewError"}}e.$oG=t}),define(Ne[192],Oe([1,0,9,31]),function(we,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=void 0,e.$sG=new I.$Tj("chatSessionResponseVote","",{type:"string",description:(0,v.localize)(8291,null)}),e.$tG=new I.$Tj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,v.localize)(8292,null)}),e.$uG=new I.$Tj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,v.localize)(8293,null)}),e.$vG=new I.$Tj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,v.localize)(8294,null)}),e.$wG=new I.$Tj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,v.localize)(8295,null)}),e.$xG=new I.$Tj("chatResponse",!1,{type:"boolean",description:(0,v.localize)(8296,null)}),e.$yG=new I.$Tj("chatRequest",!1,{type:"boolean",description:(0,v.localize)(8297,null)}),e.$zG=new I.$Tj("chatEditApplied",!1,{type:"boolean",description:(0,v.localize)(8298,null)}),e.$AG=new I.$Tj("chatInputHasText",!1,{type:"boolean",description:(0,v.localize)(8299,null)}),e.$BG=new I.$Tj("chatInputHasFocus",!1,{type:"boolean",description:(0,v.localize)(8300,null)}),e.$CG=new I.$Tj("inChatInput",!1,{type:"boolean",description:(0,v.localize)(8301,null)}),e.$DG=new I.$Tj("inChat",!1,{type:"boolean",description:(0,v.localize)(8302,null)}),e.$EG=new I.$Tj("chatIsEnabled",!1,{type:"boolean",description:(0,v.localize)(8303,null)}),e.$FG=new I.$Tj("chatCursorAtTop",!1),e.$GG=new I.$Tj("chatInputHasAgent",!1),e.$HG=new I.$Tj("chatLocation",void 0),e.$IG=new I.$Tj("quickChatHasFocus",!1,{type:"boolean",description:(0,v.localize)(8304,null)})}),define(Ne[115],Oe([1,0,282,10,21,6,39,4,40,142,12,31,18,3,11,108,175,186,192]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S,f,n,o,s,l){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.ChatAgentLocation=void 0,e.$MH=p,e.$NH=m;var r;(function(d){d.Panel="panel",d.Terminal="terminal",d.Notebook="notebook",d.Editor="editor"})(r||(e.ChatAgentLocation=r={})),function(d){function E(D){switch(D){case"panel":return d.Panel;case"terminal":return d.Terminal;case"notebook":return d.Notebook;case"editor":return d.Editor}return d.Panel}d.fromRaw=E}(r||(e.ChatAgentLocation=r={})),e.$HH=(0,S.$Ci)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(E){this.f=E,this.b=new Map,this.d=new N.$je,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=l.$EG.bindTo(this.f)}registerAgent(E,D){if(this.getAgent(E))throw new Error(`Agent already registered: ${JSON.stringify(E)}`);const k=this,P=D.slashCommands;D={...D,get slashCommands(){return P.filter(b=>!b.when||k.f.contextMatchesRules(y.$Aj.deserialize(b.when)))}};const h={data:D};return this.b.set(E,h),(0,T.$Rc)(()=>{this.b.delete(E),this.d.fire(void 0)})}registerAgentImplementation(E,D){const w=this.b.get(E);if(!w)throw new Error(`Unknown agent: ${JSON.stringify(E)}`);if(w.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(E)}`);return w.data.isDefault&&this.e.set(!0),w.impl=D,this.d.fire(new g(w.data,D)),(0,T.$Rc)(()=>{w.impl=void 0,this.d.fire(void 0),w.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(E,D){E.isDynamic=!0;const w={data:E,impl:D};return this.b.set(E.id,w),this.d.fire(new g(E,D)),(0,T.$Rc)(()=>{this.b.delete(E.id),this.d.fire(void 0)})}registerAgentCompletionProvider(E,D){return this.g.set(E,D),{dispose:()=>{this.g.delete(E)}}}async getAgentCompletionItems(E,D,w){return await this.g.get(E)?.(D,w)??[]}updateAgent(E,D){const w=this.b.get(E);if(!w?.impl)throw new Error(`No activated agent with id ${JSON.stringify(E)} registered`);w.data.metadata={...w.data.metadata,...D},this.d.fire(new g(w.data,w.impl))}getDefaultAgent(E){return(0,v.$eb)(this.getActivatedAgents(),D=>!!D.isDefault&&D.locations.includes(E))}getContributedDefaultAgent(E){return this.getAgents().find(D=>!!D.isDefault&&D.locations.includes(E))}getSecondaryAgent(){return A.Iterable.find(this.b.values(),E=>!!E.data.metadata.isSecondary)?.data}getAgent(E){if(this.h(E))return this.b.get(E)?.data}h(E){const D=this.b.get(E);return!D?.data.when||this.f.contextMatchesRules(y.$Aj.deserialize(D.data.when))}getAgentByFullyQualifiedId(E){const D=A.Iterable.find(this.b.values(),w=>p(w.data)===E)?.data;if(!(D&&!this.h(D.id)))return D}getAgents(){return Array.from(this.b.values()).map(E=>E.data).filter(E=>this.h(E.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(E=>!!E.impl).filter(E=>this.h(E.data.id)).map(E=>new g(E.data,E.impl))}getAgentsByName(E){return this.getAgents().filter(D=>D.name===E)}agentHasDupeName(E){const D=this.getAgent(E);return D?this.getAgentsByName(D.name).filter(w=>w.extensionId.value!==D.extensionId.value).length>0:!1}async invokeAgent(E,D,w,k,P){const h=this.b.get(E);if(!h?.impl)throw new Error(`No activated agent with id "${E}"`);return await h.impl.invoke(D,w,k,P)}async getFollowups(E,D,w,k,P){const h=this.b.get(E);if(!h?.impl)throw new Error(`No activated agent with id "${E}"`);return h.impl?.provideFollowups?h.impl.provideFollowups(D,w,k,P):[]}};e.$IH=t,e.$IH=t=Qe([qe(0,y.$Uj)],t);class g{constructor(E,D){this.b=E,this.d=D}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get locations(){return this.b.locations}async invoke(E,D,w,k){return this.d.invoke(E,D,w,k)}async provideFollowups(E,D,w,k){return this.d.provideFollowups?this.d.provideFollowups(E,D,w,k):[]}provideWelcomeMessage(E,D){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(E,D)}provideSampleQuestions(E,D){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(E,D)}}e.$JH=g,e.$KH=(0,S.$Ci)("chatAgentNameService");let u=class{static{i=this}static{this.b="chat.participantNameRegistry"}constructor(E,D,w,k){if(this.g=D,this.h=w,this.i=k,this.e=(0,a.$4d)(this,Object.create(null)),this.f=!1,!E.chatParticipantRegistry)return;this.d=E.chatParticipantRegistry;const P=k.get(i.b,s.StorageScope.APPLICATION);try{this.e.set(JSON.parse(P??"{}"),void 0)}catch{k.remove(i.b,s.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(E=>this.h.warn("Failed to fetch chat participant registry",E)).then(()=>(0,I.$Dh)(5*60*1e3)).then(()=>this.j())}async k(){const E=await this.g.request({type:"GET",url:this.d},C.CancellationToken.None);if(E.res.statusCode!==200)throw new Error("Could not get extensions report.");const D=await(0,o.$0p)(E);if(!D||D.version!==1)throw new Error("Unexpected chat participant registry response.");const w=D.restrictedChatParticipants;this.e.set(w,void 0),this.i.store(i.b,JSON.stringify(w),s.StorageScope.APPLICATION,s.StorageTarget.MACHINE)}getAgentNameRestriction(E){const D=this.l(E.name,E).get(),w=!E.fullName||this.l(E.fullName.replace(/\s/g,""),E).get();return D&&w}l(E,D){return this.e.map(k=>k[E.toLowerCase()]).map(k=>k?k.some(P=>(0,R.$Df)(P,P.includes(".")?D.extensionId.value:D.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$LH=u,e.$LH=u=i=Qe([qe(0,n.$pk),qe(1,o.$4p),qe(2,f.$9j),qe(3,s.$eq)],u);function p(d){return`${d.extensionId.value}.${d.id}`}function m(d){const E="name"in d?d:{...d,name:d.id};return"extensionPublisherId"in E||(E.extensionPublisherId=E.extensionPublisher??""),"extensionDisplayName"in E||(E.extensionDisplayName=""),"extensionId"in E||(E.extensionId=new c.$nn("")),(0,$.$_h)(E)}}),define(Ne[193],Oe([1,0,2,32,3]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gH=e.$fH=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.$dH=N,e.$eH=A;function N(a){return!!a&&typeof a=="object"&&"uri"in a&&a.uri instanceof v.URI&&"version"in a&&typeof a.version=="number"&&"ranges"in a&&Array.isArray(a.ranges)&&a.ranges.every(I.$Kt.isIRange)}function A(a){return!!a&&typeof a=="object"&&"documents"in a&&Array.isArray(a.documents)&&a.documents.every(N)}var T;(function(a){a[a.Down=0]="Down",a[a.Up=1]="Up"})(T||(e.ChatAgentVoteDirection=T={}));var $;(function(a){a[a.Action=1]="Action",a[a.Toolbar=2]="Toolbar"})($||(e.ChatCopyKind=$={})),e.$fH=(0,C.$Ci)("IChatService"),e.$gH="accessibility.voice.keywordActivation"}),define(Ne[194],Oe([1,0,6,10,9]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Htb=void 0;class N{constructor(){this.f=new Map,this.m=[],this.n=new v.$je,this.o=new v.$je,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(T){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=T}onEvent(T){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=T}onRequest(T){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=T}sendResponse(T){T.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.u("response",T)}sendRequest(T,$,a,R){const y={command:T};if($&&Object.keys($).length>0&&(y.arguments=$),this.u("request",y),typeof R=="number"){const c=setTimeout(()=>{clearTimeout(c);const S=this.f.get(y.seq);if(S){this.f.delete(y.seq);const f={type:"response",seq:0,request_seq:y.seq,success:!1,command:T,message:(0,C.localize)(7429,null,R,T)};S(f)}},R)}return a&&this.f.set(y.seq,a),y.seq}acceptMessage(T){this.k?this.k(T):(this.m.push(T),this.m.length===1&&this.s())}q(T,$){return T.type!=="event"||$.type!=="event"}async s(){let T;for(;this.m.length;){if((!T||this.q(this.m[0],T))&&await(0,I.$Dh)(0),T=this.m.shift(),!T)return;switch(T.type){case"event":this.j?.(T);break;case"request":this.g?.(T);break;case"response":{const $=T,a=this.f.get($.request_seq);a&&(this.f.delete($.request_seq),a($));break}}}}u(T,$){$.type=T,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const T=new Map;this.f.forEach(($,a)=>T.set(a,$)),await(0,I.$Dh)(500),T.forEach(($,a)=>{$({type:"response",seq:0,request_seq:a,success:!1,command:"canceled",message:"canceled"}),this.f.delete(a)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Htb=N}),define(Ne[80],Oe([1,0,2,9,31,3]),function(we,e,v,I,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$AK=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$yK=e.MemoryRangeType=e.State=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=void 0,e.$xK=$,e.$zK=R,I=Ve(I),e.$lJ="workbench.view.debug",e.$mJ="workbench.debug.variablesView",e.$nJ="workbench.debug.watchExpressionsView",e.$oJ="workbench.debug.callStackView",e.$pJ="workbench.debug.loadedScriptsView",e.$qJ="workbench.debug.breakPointsView",e.$rJ="workbench.debug.disassemblyView",e.$sJ="workbench.panel.repl",e.$tJ="workbench.panel.repl.view",e.$uJ=new C.$Tj("debugType",void 0,{type:"string",description:I.localize(7366,null)}),e.$vJ=new C.$Tj("debugConfigurationType",void 0,{type:"string",description:I.localize(7367,null)}),e.$wJ=new C.$Tj("debugState","inactive",{type:"string",description:I.localize(7368,null)}),e.$xJ="debugUx",e.$yJ=new C.$Tj(e.$xJ,"default",{type:"string",description:I.localize(7369,null)}),e.$zJ=new C.$Tj("hasDebugged",!1,{type:"boolean",description:I.localize(7370,null)}),e.$AJ=new C.$Tj("inDebugMode",!1,{type:"boolean",description:I.localize(7371,null)}),e.$BJ=new C.$Tj("inDebugRepl",!1,{type:"boolean",description:I.localize(7372,null)}),e.$CJ=new C.$Tj("breakpointWidgetVisible",!1,{type:"boolean",description:I.localize(7373,null)}),e.$DJ=new C.$Tj("inBreakpointWidget",!1,{type:"boolean",description:I.localize(7374,null)}),e.$EJ=new C.$Tj("breakpointsFocused",!0,{type:"boolean",description:I.localize(7375,null)}),e.$FJ=new C.$Tj("watchExpressionsFocused",!0,{type:"boolean",description:I.localize(7376,null)}),e.$GJ=new C.$Tj("watchExpressionsExist",!1,{type:"boolean",description:I.localize(7377,null)}),e.$HJ=new C.$Tj("variablesFocused",!0,{type:"boolean",description:I.localize(7378,null)}),e.$IJ=new C.$Tj("expressionSelected",!1,{type:"boolean",description:I.localize(7379,null)}),e.$JJ=new C.$Tj("breakpointInputFocused",!1,{type:"boolean",description:I.localize(7380,null)}),e.$KJ=new C.$Tj("callStackItemType",void 0,{type:"string",description:I.localize(7381,null)}),e.$LJ=new C.$Tj("callStackSessionIsAttach",!1,{type:"boolean",description:I.localize(7382,null)}),e.$MJ=new C.$Tj("callStackItemStopped",!1,{type:"boolean",description:I.localize(7383,null)}),e.$NJ=new C.$Tj("callStackSessionHasOneThread",!1,{type:"boolean",description:I.localize(7384,null)}),e.$OJ=new C.$Tj("watchItemType",void 0,{type:"string",description:I.localize(7385,null)}),e.$PJ=new C.$Tj("canViewMemory",void 0,{type:"boolean",description:I.localize(7386,null)}),e.$QJ=new C.$Tj("breakpointItemType",void 0,{type:"string",description:I.localize(7387,null)}),e.$RJ=new C.$Tj("breakpointItemBytes",void 0,{type:"boolean",description:I.localize(7388,null)}),e.$SJ=new C.$Tj("breakpointHasModes",!1,{type:"boolean",description:I.localize(7389,null)}),e.$TJ=new C.$Tj("breakpointSupportsCondition",!1,{type:"boolean",description:I.localize(7390,null)}),e.$UJ=new C.$Tj("loadedScriptsSupported",!1,{type:"boolean",description:I.localize(7391,null)}),e.$VJ=new C.$Tj("loadedScriptsItemType",void 0,{type:"string",description:I.localize(7392,null)}),e.$WJ=new C.$Tj("focusedSessionIsAttach",!1,{type:"boolean",description:I.localize(7393,null)}),e.$XJ=new C.$Tj("focusedSessionIsNoDebug",!1,{type:"boolean",description:I.localize(7394,null)}),e.$YJ=new C.$Tj("stepBackSupported",!1,{type:"boolean",description:I.localize(7395,null)}),e.$ZJ=new C.$Tj("restartFrameSupported",!1,{type:"boolean",description:I.localize(7396,null)}),e.$1J=new C.$Tj("stackFrameSupportsRestart",!1,{type:"boolean",description:I.localize(7397,null)}),e.$2J=new C.$Tj("jumpToCursorSupported",!1,{type:"boolean",description:I.localize(7398,null)}),e.$3J=new C.$Tj("stepIntoTargetsSupported",!1,{type:"boolean",description:I.localize(7399,null)}),e.$4J=new C.$Tj("breakpointsExist",!1,{type:"boolean",description:I.localize(7400,null)}),e.$5J=new C.$Tj("debuggersAvailable",!1,{type:"boolean",description:I.localize(7401,null)}),e.$6J=new C.$Tj("debugExtensionAvailable",!0,{type:"boolean",description:I.localize(7402,null)}),e.$7J=new C.$Tj("debugProtocolVariableMenuContext",void 0,{type:"string",description:I.localize(7403,null)}),e.$8J=new C.$Tj("debugSetVariableSupported",!1,{type:"boolean",description:I.localize(7404,null)}),e.$9J=new C.$Tj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:I.localize(7405,null)}),e.$0J=new C.$Tj("debugSetExpressionSupported",!1,{type:"boolean",description:I.localize(7406,null)}),e.$$J=new C.$Tj("breakWhenValueChangesSupported",!1,{type:"boolean",description:I.localize(7407,null)}),e.$_J=new C.$Tj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:I.localize(7408,null)}),e.$aK=new C.$Tj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:I.localize(7409,null)}),e.$bK=new C.$Tj("terminateDebuggeeSupported",!1,{type:"boolean",description:I.localize(7410,null)}),e.$cK=new C.$Tj("suspendDebuggeeSupported",!1,{type:"boolean",description:I.localize(7411,null)}),e.$dK=new C.$Tj("variableEvaluateNamePresent",!1,{type:"boolean",description:I.localize(7412,null)}),e.$eK=new C.$Tj("variableIsReadonly",!1,{type:"boolean",description:I.localize(7413,null)}),e.$fK=new C.$Tj("variableValue",!1,{type:"string",description:I.localize(7414,null)}),e.$gK=new C.$Tj("variableType",!1,{type:"string",description:I.localize(7415,null)}),e.$hK=new C.$Tj("variableInterfaces",!1,{type:"array",description:I.localize(7416,null)}),e.$iK=new C.$Tj("variableName",!1,{type:"string",description:I.localize(7417,null)}),e.$jK=new C.$Tj("variableLanguage",!1,{type:"string",description:I.localize(7418,null)}),e.$kK=new C.$Tj("variableExtensionId",!1,{type:"string",description:I.localize(7419,null)}),e.$lK=new C.$Tj("exceptionWidgetVisible",!1,{type:"boolean",description:I.localize(7420,null)}),e.$mK=new C.$Tj("multiSessionRepl",!1,{type:"boolean",description:I.localize(7421,null)}),e.$nK=new C.$Tj("multiSessionDebug",!1,{type:"boolean",description:I.localize(7422,null)}),e.$oK=new C.$Tj("disassembleRequestSupported",!1,{type:"boolean",description:I.localize(7423,null)}),e.$pK=new C.$Tj("disassemblyViewFocus",!1,{type:"boolean",description:I.localize(7424,null)}),e.$qK=new C.$Tj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:I.localize(7425,null)}),e.$rK=new C.$Tj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:I.localize(7426,null)});const A=i=>I.localize(7427,null,i);e.$sK=A,e.$tK="editor.contrib.debug",e.$uK="editor.contrib.breakpoint",e.$vK="debug",e.$wK={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:I.localize(7428,null)};var T;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(T||(e.State=T={}));function $(i){switch(i){case T.Initializing:return"initializing";case T.Stopped:return"stopped";case T.Running:return"running";default:return"inactive"}}var a;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(a||(e.MemoryRangeType=a={})),e.$yK="vscode-debug-memory";function R(i){const r=i.presentationHint??i.source.presentationHint;return r==="deemphasize"||r==="subtle"}var y;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(y||(e.DataBreakpointSetType=y={}));var c;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(c||(e.DebugConfigurationProviderTriggerKind=c={}));var S;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(S||(e.DebuggerString=S={})),e.$AK=(0,N.$Ci)("debugService");var f;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(f||(e.BreakpointWidgetContext=f={}));var n;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(n||(e.DebugVisualizationType=n={}));var o;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(o||(e.DebugTreeItemCollapsibleState=o={}));var s;(function(i){i.deserialize=r=>r,i.serialize=r=>r})(s||(e.IDebugVisualizationTreeItem=s={}));var l;(function(i){i.deserialize=r=>({id:r.id,name:r.name,iconPath:r.iconPath&&{light:v.URI.revive(r.iconPath.light),dark:v.URI.revive(r.iconPath.dark)},iconClass:r.iconClass,visualization:r.visualization}),i.serialize=r=>r})(l||(e.IDebugVisualization=l={}))}),define(Ne[195],Oe([1,0,12,2,19,25,15,32,21,17]),function(we,e,v,I,C,N,A,T,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5H=void 0,e.$SH=y,e.$TH=c,e.$UH=S,e.$VH=f,e.$WH=n,e.$XH=o,e.$YH=s,e.$ZH=i,e.$1H=g,e.$2H=u,e.$3H=m,e.$4H=E;const R=/{([^}]+)}/g;function y(w,k,P){return w.replace(R,function(h,b){return k&&b.length>0&&b[0]!=="_"?h:P&&P.hasOwnProperty(b)?P[b]:h})}function c(w){const k={};for(const P of Object.keys(w))P.startsWith("!")||(k[P]=w[P]);return k}function S(w){return w.configuration.request==="attach"&&!f(w)&&(!w.parentSession||S(w.parentSession))}function f(w){let k=w.configuration.type;if(k)return k==="vslsShare"&&(k=w.configuration.adapterProxy.configuration.type),(0,v.$Df)(k,"extensionhost")||(0,v.$Df)(k,"pwa-extensionhost")?w:w.parentSession?f(w.parentSession):void 0}function n(w){return w.type&&(w.label||w.program||w.runtime)}function o(w,k,P){let h,b=0;const M=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let O=null;for(;O=M.exec(w);){const F=O.index+1,q=F+O[0].length;if(F<=k&&q>=P){h=O[0],b=F;break}}if(h){const F=/\w+/g;let q=null;for(;(q=F.exec(h))&&!(q.index+1+b+q[0].length>=P););q&&(h=h.substring(0,F.lastIndex))}return h?{start:b,end:b+h.length-1}:{start:0,end:0}}async function s(w,k,P,h){if(w.evaluatableExpressionProvider.has(k)){const b=w.evaluatableExpressionProvider.ordered(k),M=(0,a.$Gb)(await Promise.all(b.map(async O=>{try{return await O.provideEvaluatableExpression(k,P,h??$.CancellationToken.None)}catch{return}})));if(M.length>0){let O=M[0].expression;const F=M[0].range;return O||(O=k.getLineContent(P.lineNumber).substring(F.startColumn-1,F.endColumn-1)),{range:F,matchingExpression:O}}}else{const b=k.getLineContent(P.lineNumber),{start:M,end:O}=o(b,P.column,P.column),F=b.substring(M-1,O);return{matchingExpression:F,range:new T.$Kt(P.lineNumber,M,P.lineNumber,M+F.length)}}return null}const l=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(w){return!!(w&&w.match(l))}function r(w){if(typeof w.path=="string"&&!(typeof w.sourceReference=="number"&&w.sourceReference>0)){if(i(w.path))return I.URI.parse(w.path);if((0,C.$hc)(w.path))return I.URI.file(w.path)}return w.path}function t(w){if(typeof w.path=="object"){const k=I.URI.revive(w.path);if(k)return k.scheme===A.Schemas.file?k.fsPath:k.toString()}return w.path}function g(w,k){const P=k?r:t,h=(0,N.$ao)(w);return p(h,(b,M)=>{b&&M&&(M.path=P(M))}),h}function u(w,k){const P=k?r:t,h=(0,N.$ao)(w);return p(h,(b,M)=>{!b&&M&&(M.path=P(M))}),h}function p(w,k){switch(w.type){case"event":{const P=w;switch(P.event){case"output":k(!1,P.body.source);break;case"loadedSource":k(!1,P.body.source);break;case"breakpoint":k(!1,P.body.breakpoint.source);break;default:break}break}case"request":{const P=w;switch(P.command){case"setBreakpoints":k(!0,P.arguments.source);break;case"breakpointLocations":k(!0,P.arguments.source);break;case"source":k(!0,P.arguments.source);break;case"gotoTargets":k(!0,P.arguments.source);break;case"launchVSCode":P.arguments.args.forEach(h=>k(!1,h));break;default:break}break}case"response":{const P=w;if(P.success&&P.body)switch(P.command){case"stackTrace":P.body.stackFrames.forEach(h=>k(!1,h.source));break;case"loadedSources":P.body.sources.forEach(h=>k(!1,h));break;case"scopes":P.body.scopes.forEach(h=>k(!1,h.source));break;case"setFunctionBreakpoints":P.body.breakpoints.forEach(h=>k(!1,h.source));break;case"setBreakpoints":P.body.breakpoints.forEach(h=>k(!1,h.source));break;case"disassemble":P.body?.instructions.forEach(b=>k(!1,b.location));break;default:break}break}}}function m(w){return w.filter(k=>!k.presentation?.hidden).sort((k,P)=>k.presentation?P.presentation?k.presentation.group?P.presentation.group?k.presentation.group!==P.presentation.group?k.presentation.group.localeCompare(P.presentation.group):d(k.presentation.order,P.presentation.order):-1:P.presentation.group?1:d(k.presentation.order,P.presentation.order):-1:P.presentation?1:0)}function d(w,k){return typeof w!="number"?typeof k!="number"?0:1:typeof k!="number"?-1:w-k}async function E(w,k){const P=w.getValue("debug.saveBeforeStart",{overrideIdentifier:k.activeTextEditorLanguageId});if(P!=="none"&&(await k.saveAll(),P==="allEditorsInActiveGroup")){const h=k.activeEditorPane;h&&h.input.resource?.scheme===A.Schemas.untitled&&await k.save({editor:h.input,groupId:h.group.id})}await w.reloadConfiguration()}const D=(w,k)=>!w||!k?w===k:w.name===k.name&&w.path===k.path&&w.sourceReference===k.sourceReference;e.$5H=D}),define(Ne[196],Oe([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IK=e.CellExecutionUpdateType=void 0;var I;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(I||(e.CellExecutionUpdateType=I={})),e.$IK=(0,v.$Ci)("INotebookExecutionService")}),define(Ne[197],Oe([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MK=e.$LK=e.ProxyKernelState=e.$KK=void 0,e.$KK=100;var I;(function(C){C[C.Disconnected=1]="Disconnected",C[C.Connected=2]="Connected",C[C.Initializing=3]="Initializing"})(I||(e.ProxyKernelState=I={})),e.$LK=(0,v.$Ci)("INotebookKernelService"),e.$MK=(0,v.$Ci)("INotebookKernelHistoryService")}),define(Ne[198],Oe([1,0,4,32,52,161,102]),function(we,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BZb=void 0;class T extends v.$Tc{constructor(a,R,y){super(),this._source=a,this.b=R,this.c=y,this.a=void 0}f(a){const R=a.getLineCount();return new I.$Kt(1,1,R,this.g(a,R))}g(a,R){if(R<1||R>a.getLineCount())throw new Error("Illegal value for lineNumber");return a.getLineLength(R)+1}get inputTextBuffer(){if(!this.b){const a=new N.$kD;a.acceptChunk(this._source);const R=a.finish(!0),{textBuffer:y,disposable:c}=R.create(C.DefaultEndOfLine.LF);this.b=y,this.B(c)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(a=>{const R=new N.$kD;R.acceptChunk(a);const y=R.finish(!0),{textBuffer:c,disposable:S}=y.create(C.DefaultEndOfLine.LF);return this.B(S),c})),this.a}findInInputs(a){const y=new A.$$C(a,!1,!1,null).parseSearchRequest();if(!y)return[];const c=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(c,y,!0,5e3)}findInOutputs(a){const y=new A.$$C(a,!1,!1,null).parseSearchRequest();return y?this.outputTextBuffers.map(c=>{const S=c.findMatchesLineByLine(this.f(c),y,!0,5e3);if(S.length!==0)return{textBuffer:c,matches:S}}).filter(c=>!!c):[]}}e.$BZb=T}),define(Ne[54],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RI=e.TestPosition=e.TestIdPathParts=void 0;var v;(function(N){N.Delimiter="\0"})(v||(e.TestIdPathParts=v={}));var I;(function(N){N[N.IsSame=0]="IsSame",N[N.Disconnected=1]="Disconnected",N[N.IsChild=2]="IsChild",N[N.IsParent=3]="IsParent"})(I||(e.TestPosition=I={}));class C{static fromExtHostTestItem(A,T,$=A.parent){if(A._isRoot)return new C([T]);const a=[A.id];for(let R=$;R&&R.id!==T;R=R.parent)a.push(R.id);return a.push(T),new C(a.reverse())}static isRoot(A){return!A.includes(v.Delimiter)}static root(A){const T=A.indexOf(v.Delimiter);return T===-1?A:A.slice(0,T)}static fromString(A){return new C(A.split(v.Delimiter))}static join(A,T){return new C([...A.path,T])}static joinToString(A,T){return A.toString()+v.Delimiter+T}static parentId(A){const T=A.lastIndexOf(v.Delimiter);return T===-1?void 0:A.slice(0,T)}static localId(A){const T=A.lastIndexOf(v.Delimiter);return T===-1?A:A.slice(T+v.Delimiter.length)}static isChild(A,T){return T[A.length]===v.Delimiter&&T.startsWith(A)}static compare(A,T){return A===T?I.IsSame:C.isChild(A,T)?I.IsChild:C.isChild(T,A)?I.IsParent:I.Disconnected}static getLengthOfCommonPrefix(A,T){if(A===0)return 0;let $=0;for(;$<A-1;){for(let a=1;a<A;a++){const R=T(a-1),y=T(a);if(R.path[$]!==y.path[$])return $}$++}return $}constructor(A,T=A.length){if(this.path=A,this.d=T,A.length===0||T<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new C(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new C(this.path,A)}compare(A){if(typeof A=="string")return C.compare(this.toString(),A);for(let T=0;T<A.d&&T<this.d;T++)if(A.path[T]!==this.path[T])return I.Disconnected;return A.d>this.d?I.IsChild:A.d<this.d?I.IsParent:I.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+=v.Delimiter,this.c+=this.path[A]}return this.c}}e.$RI=C}),define(Ne[55],Oe([1,0,2,101,32,54]),function(we,e,v,I,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1I=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$ZI=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$YI=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$XI=e.$WI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$VI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$UI=e.$TI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$SI=e.TestResultState=void 0;var A;(function(B){B[B.Unset=0]="Unset",B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(A||(e.TestResultState=A={})),e.$SI={[A.Unset]:"unset",[A.Queued]:"queued",[A.Running]:"running",[A.Passed]:"passed",[A.Failed]:"failed",[A.Skipped]:"skipped",[A.Errored]:"errored"};var T;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(T||(e.ExtTestRunProfileKind=T={}));var $;(function(B){B[B.Run=2]="Run",B[B.Debug=4]="Debug",B[B.Coverage=8]="Coverage",B[B.HasNonDefaultProfile=16]="HasNonDefaultProfile",B[B.HasConfigurable=32]="HasConfigurable",B[B.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$TI=[$.Run,$.Debug,$.Coverage,$.HasNonDefaultProfile,$.HasConfigurable,$.SupportsContinuousRun];const a=B=>"runId"in B;e.$UI=a;var R;(function(B){B.serialize=L=>({range:L.range.toJSON(),uri:L.uri.toJSON()}),B.deserialize=(L,Y)=>({range:C.$Kt.lift(Y.range),uri:L.asCanonicalUri(v.URI.revive(Y.uri))})})(R||(e.IRichLocation=R={}));var y;(function(B){B[B.Error=0]="Error",B[B.Output=1]="Output"})(y||(e.TestMessageType=y={}));var c;(function(B){B.serialize=L=>({message:L.message,type:y.Error,expected:L.expected,actual:L.actual,contextValue:L.contextValue,location:L.location&&R.serialize(L.location)}),B.deserialize=(L,Y)=>({message:Y.message,type:y.Error,expected:Y.expected,actual:Y.actual,contextValue:Y.contextValue,location:Y.location&&R.deserialize(L,Y.location)})})(c||(e.ITestErrorMessage=c={}));const S=(B,L)=>`${L?"s":"e"}${B}`;e.$VI=S;var f;(function(B){B.serialize=L=>({message:L.message,type:y.Output,offset:L.offset,length:L.length,location:L.location&&R.serialize(L.location)}),B.deserialize=(L,Y)=>({message:Y.message,type:y.Output,offset:Y.offset,length:Y.length,location:Y.location&&R.deserialize(L,Y.location)})})(f||(e.ITestOutputMessage=f={}));var n;(function(B){B.serialize=L=>L.type===y.Error?c.serialize(L):f.serialize(L),B.deserialize=(L,Y)=>Y.type===y.Error?c.deserialize(L,Y):f.deserialize(L,Y)})(n||(e.ITestMessage=n={}));var o;(function(B){B.serializeWithoutMessages=L=>({state:L.state,duration:L.duration,messages:[]}),B.serialize=L=>({state:L.state,duration:L.duration,messages:L.messages.map(n.serialize)}),B.deserialize=(L,Y)=>({state:Y.state,duration:Y.duration,messages:Y.messages.map(Z=>n.deserialize(L,Z))})})(o||(e.ITestTaskState=o={}));const s="\0",l=(B,L)=>B+s+L;e.$WI=l;const i=B=>{const L=B.indexOf(s);return{ctrlId:B.slice(0,L),tagId:B.slice(L+1)}};e.$XI=i;var r;(function(B){B.serialize=L=>({extId:L.extId,label:L.label,tags:L.tags,busy:L.busy,children:void 0,uri:L.uri?.toJSON(),range:L.range?.toJSON()||null,description:L.description,error:L.error,sortText:L.sortText}),B.deserialize=(L,Y)=>({extId:Y.extId,label:Y.label,tags:Y.tags,busy:Y.busy,children:void 0,uri:Y.uri?L.asCanonicalUri(v.URI.revive(Y.uri)):void 0,range:Y.range?C.$Kt.lift(Y.range):null,description:Y.description,error:Y.error,sortText:Y.sortText})})(r||(e.ITestItem=r={}));var t;(function(B){B[B.NotExpandable=0]="NotExpandable",B[B.Expandable=1]="Expandable",B[B.BusyExpanding=2]="BusyExpanding",B[B.Expanded=3]="Expanded"})(t||(e.TestItemExpandState=t={}));var g;(function(B){B.serialize=L=>({expand:L.expand,item:r.serialize(L.item)}),B.deserialize=(L,Y)=>({controllerId:N.$RI.root(Y.item.extId),expand:Y.expand,item:r.deserialize(L,Y.item)})})(g||(e.InternalTestItem=g={}));var u;(function(B){B.serialize=L=>{let Y;return L.item&&(Y={},L.item.label!==void 0&&(Y.label=L.item.label),L.item.tags!==void 0&&(Y.tags=L.item.tags),L.item.busy!==void 0&&(Y.busy=L.item.busy),L.item.uri!==void 0&&(Y.uri=L.item.uri?.toJSON()),L.item.range!==void 0&&(Y.range=L.item.range?.toJSON()),L.item.description!==void 0&&(Y.description=L.item.description),L.item.error!==void 0&&(Y.error=L.item.error),L.item.sortText!==void 0&&(Y.sortText=L.item.sortText)),{extId:L.extId,expand:L.expand,item:Y}},B.deserialize=L=>{let Y;return L.item&&(Y={},L.item.label!==void 0&&(Y.label=L.item.label),L.item.tags!==void 0&&(Y.tags=L.item.tags),L.item.busy!==void 0&&(Y.busy=L.item.busy),L.item.range!==void 0&&(Y.range=L.item.range?C.$Kt.lift(L.item.range):null),L.item.description!==void 0&&(Y.description=L.item.description),L.item.error!==void 0&&(Y.error=L.item.error),L.item.sortText!==void 0&&(Y.sortText=L.item.sortText)),{extId:L.extId,expand:L.expand,item:Y}}})(u||(e.ITestItemUpdate=u={}));const p=(B,L)=>{L.expand!==void 0&&(B.expand=L.expand),L.item!==void 0&&(B.item=B.item?Object.assign(B.item,L.item):L.item)};e.$YI=p;var m;(function(B){B.serializeWithoutMessages=L=>({...g.serialize(L),ownComputedState:L.ownComputedState,computedState:L.computedState,tasks:L.tasks.map(o.serializeWithoutMessages)}),B.serialize=L=>({...g.serialize(L),ownComputedState:L.ownComputedState,computedState:L.computedState,tasks:L.tasks.map(o.serialize)}),B.deserialize=(L,Y)=>({...g.deserialize(L,Y),ownComputedState:Y.ownComputedState,computedState:Y.computedState,tasks:Y.tasks.map(Z=>o.deserialize(L,Z)),retired:!0})})(m||(e.TestResultItem=m={}));var d;(function(B){B.empty=()=>({covered:0,total:0}),B.sum=(L,Y)=>{L.covered+=Y.covered,L.total+=Y.total}})(d||(e.ICoverageCount=d={}));var E;(function(B){B.serialize=L=>({id:L.id,statement:L.statement,branch:L.branch,declaration:L.declaration,testIds:L.testIds,uri:L.uri.toJSON()}),B.deserialize=(L,Y)=>({id:Y.id,statement:Y.statement,branch:Y.branch,declaration:Y.declaration,testIds:Y.testIds,uri:L.asCanonicalUri(v.URI.revive(Y.uri))}),B.empty=(L,Y)=>({id:L,uri:Y,statement:d.empty()})})(E||(e.IFileCoverage=E={}));function D(B){return{...B,location:B.location?.toJSON()}}function w(B){return B.location=B.location?I.$Jt.isIPosition(B.location)?I.$Jt.lift(B.location):C.$Kt.lift(B.location):void 0,B}e.$ZI=3;var k;(function(B){B[B.Declaration=0]="Declaration",B[B.Statement=1]="Statement",B[B.Branch=2]="Branch"})(k||(e.DetailType=k={}));var P;(function(B){B.serialize=L=>L.type===k.Declaration?b.serialize(L):M.serialize(L),B.deserialize=L=>L.type===k.Declaration?b.deserialize(L):M.deserialize(L)})(P||(e.CoverageDetails=P={}));var h;(function(B){B.serialize=D,B.deserialize=w})(h||(e.IBranchCoverage=h={}));var b;(function(B){B.serialize=D,B.deserialize=w})(b||(e.IDeclarationCoverage=b={}));var M;(function(B){B.serialize=L=>({...D(L),branches:L.branches?.map(h.serialize)}),B.deserialize=L=>({...w(L),branches:L.branches?.map(h.deserialize)})})(M||(e.IStatementCoverage=M={}));var O;(function(B){B[B.Add=0]="Add",B[B.Update=1]="Update",B[B.DocumentSynced=2]="DocumentSynced",B[B.Remove=3]="Remove",B[B.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",B[B.Retire=5]="Retire",B[B.AddTag=6]="AddTag",B[B.RemoveTag=7]="RemoveTag"})(O||(e.TestDiffOpType=O={}));var F;(function(B){B.deserialize=(L,Y)=>Y.op===O.Add?{op:Y.op,item:g.deserialize(L,Y.item)}:Y.op===O.Update?{op:Y.op,item:u.deserialize(Y.item)}:Y.op===O.DocumentSynced?{op:Y.op,uri:L.asCanonicalUri(v.URI.revive(Y.uri)),docv:Y.docv}:Y,B.serialize=L=>L.op===O.Add?{op:L.op,item:g.serialize(L.item)}:L.op===O.Update?{op:L.op,item:u.serialize(L.item)}:L})(F||(e.TestsDiffOp=F={}));class q{constructor(L){this.k=L,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(L){const Y=this.w();for(const Z of L)switch(Z.op){case O.Add:this.l(g.deserialize(this.k,Z.item),Y);break;case O.Update:this.p(u.deserialize(Z.item),Y);break;case O.Remove:this.q(Z.itemId,Y);break;case O.Retire:this.v(Z.itemId);break;case O.IncrementPendingExtHosts:this.updatePendingRoots(Z.amount);break;case O.AddTag:this.c.set(Z.tag.id,Z.tag);break;case O.RemoveTag:this.c.delete(Z.id);break}Y.complete?.()}l(L,Y){const Z=N.$RI.parentId(L.item.extId)?.toString();let fe;if(!Z)fe=this.x(L),this.g.add(fe),this.f.set(L.item.extId,fe);else if(this.f.has(Z)){const _=this.f.get(Z);_.children.add(L.item.extId),fe=this.x(L,_),this.f.set(L.item.extId,fe)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(L)}`);return}return Y.add?.(fe),L.expand===t.BusyExpanding&&this.h++,fe}p(L,Y){const Z=this.f.get(L.extId);if(Z)return L.expand!==void 0&&(Z.expand===t.BusyExpanding&&this.h--,L.expand===t.BusyExpanding&&this.h++),(0,e.$YI)(Z,L),Y.update?.(Z),Z}q(L,Y){const Z=this.f.get(L);if(!Z)return;const fe=N.$RI.parentId(Z.item.extId)?.toString();fe?this.f.get(fe).children.delete(Z.item.extId):this.g.delete(Z);const _=[[L]];for(;_.length;)for(const ge of _.pop()){const se=this.f.get(ge);se&&(_.push(se.children),this.f.delete(ge),Y.remove?.(se,se!==Z),se.expand===t.BusyExpanding&&this.h--)}}v(L){}updatePendingRoots(L){this.j+=L}w(){return{}}}e.$1I=q}),define(Ne[199],Oe([1,0,98,9,55]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$kGb=e.$jGb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var N;(function(y){y.ViewletId="workbench.view.extension.test",y.ExplorerViewId="workbench.view.testing",y.OutputPeekContributionId="editor.contrib.testingOutputPeek",y.DecorationsContributionId="editor.contrib.testingDecorations",y.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",y.CoverageViewId="workbench.view.testCoverage",y.ResultsPanelId="workbench.panel.testResults",y.ResultsViewId="workbench.panel.testResults.view",y.MessageLanguageId="vscodeInternalTestMessage"})(N||(e.Testing=N={}));var A;(function(y){y.List="list",y.Tree="true"})(A||(e.TestExplorerViewMode=A={}));var T;(function(y){y.ByLocation="location",y.ByStatus="status",y.ByDuration="duration"})(T||(e.TestExplorerViewSorting=T={}));const $={[C.TestResultState.Errored]:(0,I.localize)(3112,null),[C.TestResultState.Failed]:(0,I.localize)(3113,null),[C.TestResultState.Passed]:(0,I.localize)(3114,null),[C.TestResultState.Queued]:(0,I.localize)(3115,null),[C.TestResultState.Running]:(0,I.localize)(3116,null),[C.TestResultState.Skipped]:(0,I.localize)(3117,null),[C.TestResultState.Unset]:(0,I.localize)(3118,null)},a=(y,c)=>(0,I.localize)(3119,null,(0,v.$Vk)(y),$[c]);e.$jGb=a,e.$kGb={[C.TestRunProfileBitset.Debug]:(0,I.localize)(3120,null),[C.TestRunProfileBitset.Run]:(0,I.localize)(3121,null),[C.TestRunProfileBitset.Coverage]:(0,I.localize)(3122,null)};var R;(function(y){y.CancelTestRefreshAction="testing.cancelTestRefresh",y.CancelTestRunAction="testing.cancelRun",y.ClearTestResultsAction="testing.clearTestResults",y.CollapseAllAction="testing.collapseAll",y.ConfigureTestProfilesAction="testing.configureProfile",y.ContinousRunUsingForTest="testing.continuousRunUsingForTest",y.CoverageAtCursor="testing.coverageAtCursor",y.CoverageByUri="testing.coverage.uri",y.CoverageClear="testing.coverage.close",y.CoverageCurrentFile="testing.coverageCurrentFile",y.CoverageFilterToTest="testing.coverageFilterToTest",y.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",y.CoverageLastRun="testing.coverageLastRun",y.CoverageSelectedAction="testing.coverageSelected",y.CoverageToggleToolbar="testing.coverageToggleToolbar",y.CoverageViewChangeSorting="testing.coverageViewChangeSorting",y.DebugAction="testing.debug",y.DebugAllAction="testing.debugAll",y.DebugAtCursor="testing.debugAtCursor",y.DebugByUri="testing.debug.uri",y.DebugCurrentFile="testing.debugCurrentFile",y.DebugFailedTests="testing.debugFailTests",y.DebugLastRun="testing.debugLastRun",y.DebugSelectedAction="testing.debugSelected",y.FilterAction="workbench.actions.treeView.testExplorer.filter",y.GetExplorerSelection="_testing.getExplorerSelection",y.GetSelectedProfiles="testing.getSelectedProfiles",y.GoToTest="testing.editFocusedTest",y.HideTestAction="testing.hideTest",y.OpenCoverage="testing.openCoverage",y.OpenOutputPeek="testing.openOutputPeek",y.RefreshTestsAction="testing.refreshTests",y.ReRunFailedTests="testing.reRunFailTests",y.ReRunLastRun="testing.reRunLastRun",y.RunAction="testing.run",y.RunAllAction="testing.runAll",y.RunAllWithCoverageAction="testing.coverageAll",y.RunAtCursor="testing.runAtCursor",y.RunByUri="testing.run.uri",y.RunCurrentFile="testing.runCurrentFile",y.RunSelectedAction="testing.runSelected",y.RunUsingProfileAction="testing.runUsing",y.RunWithCoverageAction="testing.coverage",y.SearchForTestExtension="testing.searchForTestExtension",y.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",y.ShowMostRecentOutputAction="testing.showMostRecentOutput",y.StartContinousRun="testing.startContinuousRun",y.StopContinousRun="testing.stopContinuousRun",y.TestingSortByDurationAction="testing.sortByDuration",y.TestingSortByLocationAction="testing.sortByLocation",y.TestingSortByStatusAction="testing.sortByStatus",y.TestingViewAsListAction="testing.viewAsList",y.TestingViewAsTreeAction="testing.viewAsTree",y.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",y.ToggleInlineTestOutput="testing.toggleInlineTestOutput",y.UnhideAllTestsAction="testing.unhideAllTests",y.UnhideTestAction="testing.unhideTest"})(R||(e.TestCommandId=R={}))}),define(Ne[81],Oe([1,0,10,6,4,61,55,54]),function(we,e,v,I,C,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UP=e.$TP=e.$SP=e.$RP=e.$QP=e.TestItemEventOp=void 0;var $;(function(l){l[l.Upsert=0]="Upsert",l[l.SetTags=1]="SetTags",l[l.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",l[l.RemoveChild=3]="RemoveChild",l[l.SetProp=4]="SetProp",l[l.Bulk=5]="Bulk",l[l.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const a=(l,i)=>l===i,y=Object.entries({range:(l,i)=>l===i?!0:!l||!i?!1:l.equalsRange(i),busy:a,label:a,description:a,error:a,sortText:a,tags:(l,i)=>!(l.length!==i.length||l.some(r=>!i.includes(r)))}),c=(l,i)=>{let r;for(const[t,g]of y)g(l[t],i[t])||(r?r[t]=i[t]:r={[t]:i[t]});return r};class S extends C.$Tc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new v.$Oh(()=>this.flushDiff(),200)),this.g=this.B(new I.$je),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const r of this.tree.values())this.J(r)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case A.TestDiffOpType.DocumentSynced:{for(const r of this.m)if(r.op===A.TestDiffOpType.DocumentSynced&&r.uri===i.uri){r.docv=i.docv;return}break}case A.TestDiffOpType.Update:{const r=this.m[this.m.length-1];if(r){if(r.op===A.TestDiffOpType.Update&&r.item.extId===i.item.extId){(0,A.$YI)(r.item,i.item);return}if(r.op===A.TestDiffOpType.Add&&r.item.item.extId===i.item.extId){(0,A.$YI)(r.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,r){const t=this.tree.get(i);if(t){if((t.expandLevels===void 0||r>t.expandLevels)&&(t.expandLevels=r),t.expand===A.TestItemExpandState.Expandable){const g=this.M(t);return g.isOpen()?this.L(t,r-1):g.wait().then(()=>this.L(t,r-1))}else if(t.expand===A.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.L(t,r-1)):this.L(t,r-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,r){switch(r.op){case $.RemoveChild:this.O(T.$RI.joinToString(i.fullId,r.id));break;case $.Upsert:this.z(r.item,i);break;case $.Bulk:for(const t of r.ops)this.w(i,t);break;case $.SetTags:this.C(r.new,r.old,i.fullId.toString());break;case $.UpdateCanResolveChildren:this.J(i);break;case $.SetProp:this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:r.update}});break;case $.DocumentSynced:this.y(i.actual.uri);break;default:(0,N.$dd)(r)}}y(i){i&&this.pushDiff({op:A.TestDiffOpType.DocumentSynced,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,r){const t=T.$RI.fromExtHostTestItem(i,this.root.id,r?.actual),g=this.s.getApiFor(i);g.parent&&g.parent!==r?.actual&&this.s.getChildren(g.parent).delete(i.id);let u=this.tree.get(t.toString());if(!u){u={fullId:t,actual:i,expandLevels:r?.expandLevels?r.expandLevels-1:void 0,expand:A.TestItemExpandState.NotExpandable},i.tags.forEach(this.D,this),this.tree.set(u.fullId.toString(),u),this.G(i,r),this.pushDiff({op:A.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:u.expand,item:this.s.toITestItem(i)}}),this.I(i,u,r);return}if(u.actual===i){this.H(i,u,r);return}if(u.actual.uri?.toString()!==i.uri?.toString())return this.O(t.toString()),this.z(i,r);const p=this.s.getChildren(u.actual),m=u.actual,d=c(this.s.toITestItem(m),this.s.toITestItem(i));this.s.getApiFor(m).listener=void 0,u.actual=i,u.resolveBarrier=void 0,u.expand=A.TestItemExpandState.NotExpandable,d&&(d.hasOwnProperty("tags")&&(this.C(i.tags,m.tags,t.toString()),delete d.tags),this.w(u,{op:$.SetProp,update:d})),this.I(i,u,r);for(const[D,w]of p)this.s.getChildren(i).get(w.id)||this.O(T.$RI.joinToString(t,w.id));const E=u.expandLevels;E!==void 0&&queueMicrotask(()=>{u.expand===A.TestItemExpandState.Expandable&&(u.expandLevels=void 0,this.expand(t.toString(),E))}),this.y(u.actual.uri)}C(i,r,t){const g=new Set(r.map(u=>u.id));for(const u of i)g.delete(u.id)||this.D(u);this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:t,item:{tags:i.map(u=>(0,A.$WI)(this.s.controllerId,u.id))}}}),g.forEach(this.F,this)}D(i){const r=this.j.get(i.id);r?r.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:A.TestDiffOpType.AddTag,tag:{id:(0,A.$WI)(this.s.controllerId,i.id)}}))}F(i){const r=this.j.get(i);r&&!--r.refCount&&(this.j.delete(i),this.pushDiff({op:A.TestDiffOpType.RemoveTag,id:(0,A.$WI)(this.s.controllerId,i)}))}G(i,r){this.s.getApiFor(i).parent=r&&r.actual!==this.root?r.actual:void 0}H(i,r,t){this.G(i,t);const g=this.s.getApiFor(i);g.parent=t?.actual,g.listener=u=>this.w(r,u),this.J(r)}I(i,r,t){this.H(i,r,t);for(const[g,u]of this.s.getChildren(i))this.z(u,r)}J(i){let r;this.h?i.resolveBarrier?r=i.resolveBarrier.isOpen()?A.TestItemExpandState.Expanded:A.TestItemExpandState.BusyExpanding:r=i.actual.canResolveChildren?A.TestItemExpandState.Expandable:A.TestItemExpandState.NotExpandable:r=A.TestItemExpandState.NotExpandable,r!==i.expand&&(i.expand=r,this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:r}}),r===A.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.M(i))}L(i,r){if(r<0)return;const t=[];for(const[g,u]of this.s.getChildren(i.actual)){const p=this.expand(T.$RI.joinToString(i.fullId,u.id),r);(0,v.$oh)(p)&&t.push(p)}if(t.length)return Promise.all(t).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const u=new v.$Bh;return u.open(),u}i.expand=A.TestItemExpandState.BusyExpanding,this.N(i);const r=i.resolveBarrier=new v.$Bh,t=u=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,u)};let g;try{g=this.h(i.actual===this.root?void 0:i.actual)}catch(u){t(u)}return(0,v.$oh)(g)?g.catch(t).then(()=>{r.open(),this.J(i)}):(r.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const r=this.tree.get(i);if(!r)throw new Error("attempting to remove non-existent child");this.pushDiff({op:A.TestDiffOpType.Remove,itemId:i});const t=[r];for(;t.length;){const g=t.pop();if(g){this.s.getApiFor(g.actual).listener=void 0;for(const u of g.actual.tags)this.F(u.id);this.tree.delete(g.fullId.toString());for(const[u,p]of this.s.getChildren(g.actual))t.push(this.tree.get(T.$RI.joinToString(g.fullId,p.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$QP=S;class f extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$RP=f;class n extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$SP=n;class o extends Error{constructor(i,r,t){super(`TestItem with ID "${i}" is from controller "${r}" and cannot be added as a child of an item from controller "${t}".`)}}e.$TP=o;const s=(l,i,r)=>{let t=new Map;return{get size(){return t.size},forEach(g,u){for(const p of t.values())g.call(u,p,this)},[Symbol.iterator](){return t.entries()},replace(g){const u=new Map,p=new Set(t.keys()),m={op:$.Bulk,ops:[]};for(const d of g){if(!(d instanceof r))throw new n(d.id);const E=i(d).controllerId;if(E!==l.controllerId)throw new o(d.id,E,l.controllerId);if(u.has(d.id))throw new f(d.id);u.set(d.id,d),p.delete(d.id),m.ops.push({op:$.Upsert,item:d})}for(const d of p.keys())m.ops.push({op:$.RemoveChild,id:d});l.listener?.(m),t=u},add(g){if(!(g instanceof r))throw new n(g.id);t.set(g.id,g),l.listener?.({op:$.Upsert,item:g})},delete(g){t.delete(g)&&l.listener?.({op:$.RemoveChild,id:g})},get(g){return t.get(g)},toJSON(){return Array.from(t.values())}}};e.$UP=s}),define(Ne[116],Oe([1,0,81]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WP=e.$VP=void 0;const I=new WeakMap,C=(A,T)=>{const $={controllerId:T};return I.set(A,$),$};e.$VP=C;const N=A=>{const T=I.get(A);if(!T)throw new v.$SP(A?.id||"<unknown>");return T};e.$WP=N}),define(Ne[82],Oe([1,0,27,15,2]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dDb=e.$cDb=e.$bDb=void 0,e.$eDb=N,e.$fDb=T,e.$bDb="vscode-cdn.net",e.$cDb=`vscode-resource.${e.$bDb}`,e.$dDb=`'self' https://*.${e.$bDb}`;function N($,a){return $.scheme===I.Schemas.http||$.scheme===I.Schemas.https?$:(a&&a.authority&&a.isRemote&&$.scheme===I.Schemas.file&&($=C.URI.from({scheme:I.Schemas.vscodeRemote,authority:a.authority,path:$.path})),C.URI.from({scheme:I.Schemas.https,authority:`${$.scheme}+${A($.authority)}.${e.$cDb}`,path:$.path,fragment:$.fragment,query:$.query}))}function A($){return $.replace(/./g,a=>{const R=a.charCodeAt(0);return R>=v.CharCode.a&&R<=v.CharCode.z||R>=v.CharCode.A&&R<=v.CharCode.Z||R>=v.CharCode.Digit0&&R<=v.CharCode.Digit9?a:"-"+R.toString(16).padStart(4,"0")})}function T($){return $.replace(/-([0-9a-f]{4})/g,(a,R)=>String.fromCharCode(parseInt(R,16)))}}),define(Ne[200],Oe([1,0,6,4,82]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eoc=void 0;class N{constructor(T,$,a){this.d=T,this.e=$,this.f=a,this.a=0,this.b=new I.$Sc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const R=$.getVisibleTextEditors();for(const y of this.c.values())R.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this.c.forEach(T=>T.inset.dispose()),this.b.dispose()}createWebviewEditorInset(T,$,a,R,y){let c;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===T){c=i;break}if(!c)throw new Error("not a visible editor");const S=this,f=this.a++,n=new v.$je,o=new v.$je,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,C.$eDb)(i,S.f)}get cspSource(){return C.$dDb}set options(i){this.b=i,S.d.$setOptions(f,i)}get options(){return this.b}set html(i){this.a=i,S.d.$setHtml(f,i)}get html(){return this.a}get onDidReceiveMessage(){return n.event}postMessage(i){return S.d.$postMessage(f,i)}},l=new class{constructor(){this.editor=T,this.line=$,this.height=a,this.webview=s,this.onDidDispose=o.event}dispose(){S.c.has(f)&&(S.c.delete(f),S.d.$disposeEditorInset(f),o.fire(),o.dispose(),n.dispose())}};return this.d.$createEditorInset(f,c.id,c.value.document.uri,$+1,a,R||{},y.identifier,y.extensionLocation),this.c.set(f,{editor:T,inset:l,onDidReceiveMessage:n}),l}$onDidDispose(T){const $=this.c.get(T);$&&$.inset.dispose()}$onDidReceiveMessage(T,$){this.c.get(T)?.onDidReceiveMessage.fire($)}}e.$Eoc=N}),define(Ne[117],Oe([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wM=e.$vM=e.$uM=void 0,e.$uM="__",e.$vM=(0,v.$Ci)("IAuthenticationService"),e.$wM=(0,v.$Ci)("IAuthenticationExtensionsService")}),define(Ne[201],Oe([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PQ=e.VariableKind=e.$OQ=void 0,e.$OQ=(0,v.$Ci)("configurationResolverService");var I;(function(N){N.Unknown="unknown",N.Env="env",N.Config="config",N.Command="command",N.Input="input",N.ExtensionInstallFolder="extensionInstallFolder",N.WorkspaceFolder="workspaceFolder",N.Cwd="cwd",N.WorkspaceFolderBasename="workspaceFolderBasename",N.UserHome="userHome",N.LineNumber="lineNumber",N.SelectedText="selectedText",N.File="file",N.FileWorkspaceFolder="fileWorkspaceFolder",N.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",N.RelativeFile="relativeFile",N.RelativeFileDirname="relativeFileDirname",N.FileDirname="fileDirname",N.FileExtname="fileExtname",N.FileBasename="fileBasename",N.FileBasenameNoExtension="fileBasenameNoExtension",N.FileDirnameBasename="fileDirnameBasename",N.ExecPath="execPath",N.ExecInstallFolder="execInstallFolder",N.PathSeparator="pathSeparator",N.PathSeparatorAlias="/"})(I||(e.VariableKind=I={}));class C extends Error{constructor(A,T){super(T),this.variable=A}}e.$PQ=C}),define(Ne[202],Oe([1,0,19,78,14,25,20,99,9,201,12]),function(we,e,v,I,C,N,A,T,$,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Q=void 0,v=Ve(v),I=Ve(I),C=Ve(C),N=Ve(N);class y{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(S,f,n,o){this.h=new Map,this.a=S,this.b=f,this.g=n,o&&(this.c=o.then(s=>this.i(s)))}i(S){if(A.$j){const f=Object.create(null);return Object.keys(S).forEach(n=>{f[n.toLowerCase()]=S[n]}),f}return S}resolveWithEnvironment(S,f,n){return this.l({env:this.i(S),userHome:void 0},f?f.uri:void 0,n)}async resolveAsync(S,f){const n={env:await this.c,userHome:await this.g};return this.l(n,S?S.uri:void 0,f)}async j(S,f,n,o){const s=N.$ao(f);A.$j&&s.windows?Object.keys(s.windows).forEach(i=>s[i]=s.windows[i]):A.$k&&s.osx?Object.keys(s.osx).forEach(i=>s[i]=s.osx[i]):A.$l&&s.linux&&Object.keys(s.linux).forEach(i=>s[i]=s.linux[i]),delete s.windows,delete s.osx,delete s.linux;const l={env:await this.c,userHome:await this.g};return this.l(l,S?S.uri:void 0,s,n,o)}async resolveAnyAsync(S,f,n){return this.j(S,f,n)}async resolveAnyMap(S,f,n){const o=new Map;return{newConfig:await this.j(S,f,n,o),resolvedVariables:o}}resolveWithInteractionReplace(S,f,n,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,f,n,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,f){if(this.h.has(S))throw new Error("Variable "+S+" is contributed twice.");this.h.set(S,f)}async l(S,f,n,o,s){if(C.$cg(n))return this.m(S,f,n,o,s);if(Array.isArray(n))return Promise.all(n.map(l=>this.l(S,f,l,o,s)));if(C.$eg(n)){const l=Object.create(null),i=await Promise.all(Object.keys(n).map(async r=>[await this.m(S,f,r,o,s),await this.l(S,f,n[r],o,s)]));for(const[r,t]of i)l[r]=t;return l}return n}m(S,f,n,o,s){return(0,R.$vf)(n,y.VARIABLE_REGEXP,async(l,i)=>{if(i.includes(y.VARIABLE_LHS))return l;let r=await this.o(S,l,i,f,o);return s?.set(i,r),r!==l&&C.$cg(r)&&r.match(y.VARIABLE_REGEXP)&&(r=await this.m(S,f,r,o,s)),r})}n(S){return this.b?this.b.getUriLabel(S,{noPrefix:!0}):S.fsPath}async o(S,f,n,o,s){let l;const i=n.split(":");i.length>1&&(n=i[0],l=i[1]);const r=u=>{const p=this.a.getFilePath();if(p)return(0,T.$Vw)(p);throw new a.$PQ(u,(0,$.localize)(2029,null,f))},t=u=>{const p=r(u);if(this.a.getWorkspaceFolderPathForFile){const m=this.a.getWorkspaceFolderPathForFile();if(m)return(0,T.$Vw)(m)}throw new a.$PQ(u,(0,$.localize)(2030,null,f,v.$mc(p)))},g=u=>{if(l){const p=this.a.getFolderUri(l);if(p)return p;throw new a.$PQ(u,(0,$.localize)(2031,null,f,l))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new a.$PQ(u,(0,$.localize)(2032,null,f)):new a.$PQ(u,(0,$.localize)(2033,null,f))};switch(n){case"env":if(l){if(S.env){const u=S.env[A.$j?l.toLowerCase():l];if(C.$cg(u))return u}return""}throw new a.$PQ(a.VariableKind.Env,(0,$.localize)(2034,null,f));case"config":if(l){const u=this.a.getConfigurationValue(o,l);if(C.$lg(u))throw new a.$PQ(a.VariableKind.Config,(0,$.localize)(2035,null,f,l));if(C.$eg(u))throw new a.$PQ(a.VariableKind.Config,(0,$.localize)(2036,null,f,l));return u}throw new a.$PQ(a.VariableKind.Config,(0,$.localize)(2037,null,f));case"command":return this.p(a.VariableKind.Command,f,l,s,"command");case"input":return this.p(a.VariableKind.Input,f,l,s,"input");case"extensionInstallFolder":if(l){const u=await this.a.getExtension(l);if(!u)throw new a.$PQ(a.VariableKind.ExtensionInstallFolder,(0,$.localize)(2038,null,f,l));return this.n(u.extensionLocation)}throw new a.$PQ(a.VariableKind.ExtensionInstallFolder,(0,$.localize)(2039,null,f));default:switch(n){case"workspaceRoot":case"workspaceFolder":return(0,T.$Vw)(this.n(g(a.VariableKind.WorkspaceFolder)));case"cwd":return o||l?(0,T.$Vw)(this.n(g(a.VariableKind.Cwd))):I.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,T.$Vw)(v.$mc(this.n(g(a.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(S.userHome)return S.userHome;throw new a.$PQ(a.VariableKind.UserHome,(0,$.localize)(2040,null,f))}case"lineNumber":{const u=this.a.getLineNumber();if(u)return u;throw new a.$PQ(a.VariableKind.LineNumber,(0,$.localize)(2041,null,f))}case"selectedText":{const u=this.a.getSelectedText();if(u)return u;throw new a.$PQ(a.VariableKind.SelectedText,(0,$.localize)(2042,null,f))}case"file":return r(a.VariableKind.File);case"fileWorkspaceFolder":return t(a.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return v.$mc(t(a.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||l?v.$kc(this.n(g(a.VariableKind.RelativeFile)),r(a.VariableKind.RelativeFile)):r(a.VariableKind.RelativeFile);case"relativeFileDirname":{const u=v.$lc(r(a.VariableKind.RelativeFileDirname));if(o||l){const p=v.$kc(this.n(g(a.VariableKind.RelativeFileDirname)),u);return p.length===0?".":p}return u}case"fileDirname":return v.$lc(r(a.VariableKind.FileDirname));case"fileExtname":return v.$nc(r(a.VariableKind.FileExtname));case"fileBasename":return v.$mc(r(a.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=v.$mc(r(a.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-v.$nc(u).length)}case"fileDirnameBasename":return v.$mc(v.$lc(r(a.VariableKind.FileDirnameBasename)));case"execPath":{const u=this.a.getExecPath();return u||f}case"execInstallFolder":{const u=this.a.getAppRoot();return u||f}case"pathSeparator":case"/":return v.sep;default:try{const u=l?`${n}:${l}`:n;return this.p(a.VariableKind.Unknown,f,u,s,void 0)}catch{return f}}}}p(S,f,n,o,s){if(n&&o){const l=s===void 0?o[n]:o[s+":"+n];if(typeof l=="string")return l;throw new a.$PQ(S,(0,$.localize)(2043,null,f))}return f}}e.$5Q=y}),define(Ne[118],Oe([1,0,3,114]),function(we,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$hE=void 0,e.$iE=a,e.$jE=c,e.$kE=S,e.$hE=(0,v.$Ci)("editorGroupsService");var C;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var N;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(N||(e.GroupOrientation=N={}));var A;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var T;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EXPAND=1]="EXPAND",f[f.EVEN=2]="EVEN"})(T||(e.GroupsArrangement=T={}));var $;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function a(f){const n=f;return(0,I.$6F)(n?.editor)&&(0,I.$6F)(n?.replacement)}var R;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var y;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function c(f){const n=f;return!!n&&typeof n.id=="number"&&Array.isArray(n.editors)}function S(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?C.DOWN:C.RIGHT}}),define(Ne[203],Oe([1,0,3,118]),function(we,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oE=e.$nE=e.$mE=e.$lE=void 0,e.$pE=C,e.$lE=(0,v.$Ci)("editorService"),e.$mE=-1,e.$nE=-2,e.$oE=-3;function C(N){const A=N;return typeof N=="number"||(0,I.$jE)(A)}}),define(Ne[204],Oe([1,0,3,106]),function(we,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PM=void 0,e.$PM=(0,v.$Di)(I.$Ji)}),define(Ne[119],Oe([1,0,18,6,19,4,10]),function(we,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=e.$Qcc=e.$Pcc=e.$Occ=e.$Ncc=void 0,C=Ve(C);class T{constructor(l,i){this.versionId=l,this.removedDueToLooping=i}}e.$Ncc=T;class ${static isHostExtension(l,i,r){if(i.getExtensionDescription(l))return!1;const t=r.getExtensionDescription(l);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(l,i){this.j=l,this.c=new I.$je,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(n),this.f=new v.$pn,this.g=[],this.h=new Map;for(const l of this.e){if(this.f.has(l.identifier)){console.error("Extension `"+l.identifier.value+"` is already registered");continue}this.f.set(l.identifier,l),this.g.push(l);const i=this.j.readActivationEvents(l);for(const r of i)this.h.has(r)||this.h.set(r,[]),this.h.get(r).push(l)}}set(l){return this.e=l,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(l,i){this.e=o(this.e,i),this.e=this.e.concat(l);const r=$.l(this.e);return this.e=o(this.e,r.map(t=>t.identifier)),this.k(),this.d++,this.c.fire(void 0),new T(this.d,r)}static l(l){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(p){this.d.has(p)||(this.d.add(p),this.e.push(p))}addArc(p,m){this.addNode(p),this.addNode(m),this.c.has(p)?this.c.get(p).push(m):this.c.set(p,[m])}getArcs(p){return this.c.has(p)?this.c.get(p):[]}hasOnlyGoodArcs(p,m){const d=i.getArcs(p);for(let E=0;E<d.length;E++)if(!m.has(d[E]))return!1;return!0}getNodes(){return this.e}},r=new v.$pn;for(const p of l)if(r.set(p.identifier,p),p.extensionDependencies)for(const m of p.extensionDependencies)i.addArc(v.$nn.toKey(p.identifier),v.$nn.toKey(m));const t=new Set;i.getNodes().filter(p=>i.getArcs(p).length===0).forEach(p=>t.add(p));const g=i.getNodes().filter(p=>!t.has(p));let u;do{u=!1;for(let p=0;p<g.length;p++){const m=g[p];i.hasOnlyGoodArcs(m,t)&&(g.splice(p,1),p--,t.add(m),u=!0)}}while(u);return g.map(p=>r.get(p))}containsActivationEvent(l){return this.h.has(l)}containsExtension(l){return this.f.has(l)}getExtensionDescriptionsForActivationEvent(l){const i=this.h.get(l);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new a(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(l){const i=this.f.get(l);return i||void 0}getExtensionDescriptionByUUID(l){for(const i of this.g)if(i.uuid===l)return i}getExtensionDescriptionByIdOrUUID(l,i){return this.getExtensionDescription(l)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$Occ=$;class a{constructor(l,i){this.versionId=l,this.extensions=i}}e.$Pcc=a;class R{constructor(l){this.d=new S,this.c=new $(l,[])}async acquireLock(l){const i=await this.d.acquire(l);return new y(this,i)}deltaExtensions(l,i,r){if(!l.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,r)}containsActivationEvent(l){return this.c.containsActivationEvent(l)}containsExtension(l){return this.c.containsExtension(l)}getExtensionDescriptionsForActivationEvent(l){return this.c.getExtensionDescriptionsForActivationEvent(l)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(l){return this.c.getExtensionDescription(l)}getExtensionDescriptionByUUID(l){return this.c.getExtensionDescriptionByUUID(l)}getExtensionDescriptionByIdOrUUID(l,i){return this.c.getExtensionDescriptionByIdOrUUID(l,i)}}e.$Qcc=R;class y extends N.$Tc{constructor(l,i){super(),this.f=l,this.c=!1,this.B(i)}isAcquiredFor(l){return!this.c&&this.f===l}}e.$Rcc=y;class c{constructor(l){this.name=l;const i=(0,A.$vh)();this.promise=i.promise,this.c=i.resolve}resolve(l){this.c(l)}}class S{constructor(){this.c=[],this.d=!1}async acquire(l){const i=new c(l);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const l=this.c.shift();this.d=!0;let i=!0;const r=setTimeout(()=>{i&&console.warn(`The customer named ${l.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{i&&(clearTimeout(r),i=!1,this.d=!1,this.e())};l.resolve((0,N.$Rc)(t))}}var f;(function(s){s[s.Builtin=0]="Builtin",s[s.User=1]="User",s[s.Dev=2]="Dev"})(f||(f={}));function n(s,l){const i=s.isBuiltin?f.Builtin:s.isUnderDevelopment?f.Dev:f.User,r=l.isBuiltin?f.Builtin:l.isUnderDevelopment?f.Dev:f.User;if(i!==r)return i-r;const t=C.$fc.basename(s.extensionLocation.path),g=C.$fc.basename(l.extensionLocation.path);return t<g?-1:t>g?1:0}function o(s,l){const i=new v.$on(l);return s.filter(r=>!i.has(r.identifier))}}),define(Ne[83],Oe([1,0,22]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$xn=A,e.$yn=T;var I;(function(a){a[a.Desktop=1]="Desktop",a[a.Web=2]="Web"})(I||(e.UIKind=I={}));var C;(function(a){a[a.VersionMismatch=55]="VersionMismatch",a[a.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var N;(function(a){a[a.Initialized=0]="Initialized",a[a.Ready=1]="Ready",a[a.Terminate=2]="Terminate"})(N||(e.MessageType=N={}));function A(a){const R=v.$Le.alloc(1);switch(a){case N.Initialized:R.writeUInt8(1,0);break;case N.Ready:R.writeUInt8(2,0);break;case N.Terminate:R.writeUInt8(3,0);break}return R}function T(a,R){if(a.byteLength!==1)return!1;switch(a.readUInt8(0)){case 1:return R===N.Initialized;case 2:return R===N.Ready;case 3:return R===N.Terminate;default:return!1}}var $;(function(a){a.Start="START_NATIVE_LOG",a.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(Ne[66],Oe([1,0,3,6,112,11,26,83,62,63,25,2,4,9]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iQ=e.$gQ=e.$fQ=void 0,e.$hQ=o;let f=class extends c.$Tc{constructor(l,i){super(),this.s=l,this.t=i,this.a=this.B(new I.$je),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new I.$je),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=C.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=y.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:a.$yp,name:(0,S.localize)(10660,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(r=>{(0,N.$$j)(r)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===N.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===C.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=C.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=C.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=C.TelemetryLevel.USAGE:!1}}instantiateLogger(l,i,r){const t=this.getTelemetryDetails(),g=new n(i,r,l,this.n,this.j,this.getBuiltInCommonProperties(l),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),u=this.r.get(l.identifier.value)??[];return this.r.set(l.identifier.value,[...u,g]),g.apiTelemetryLogger}$initializeTelemetryLevel(l,i,r){this.f=l,this.g=i,this.c=r??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(l){const i=Object.create(null);switch(i["common.extname"]=`${l.publisher}.${l.name}`,i["common.extversion"]=l.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=o(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case T.UIKind.Web:i["common.uikind"]="web";break;case T.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,$.$en)((0,a.$Ep)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(l){this.h=this.getTelemetryConfiguration(),this.f=l;const i=this.getTelemetryDetails();this.r.forEach((r,t)=>{const g=r.filter(u=>!u.isDisposed);g.length===0?this.r.delete(t):this.r.set(t,g)}),this.r.forEach(r=>{for(const t of r)t.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(l,i){const t=this.r.get(l.value)?.filter(u=>!u.isDisposed);if(!t)return this.r.delete(l.value),!1;let g=!1;for(const u of t)u.ignoreUnhandledExtHostErrors||(u.logError(i),g=!0);return g}};e.$fQ=f,e.$fQ=f=Qe([qe(0,A.$eQ),qe(1,N.$0j)],f);class n{static validateSender(l){if(typeof l!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof l.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof l.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof l.flush<"u"&&typeof l.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(l,i,r,t,g,u,p){this.g=r,this.h=t,this.i=g,this.j=u,this.a=new I.$je,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=l,this.d={isUsageEnabled:p.isUsageEnabled,isErrorsEnabled:p.isErrorsEnabled}}updateTelemetryEnablements(l,i){this.e&&(this.d={isUsageEnabled:l,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(l){let i="properties"in l?l.properties??{}:l;return i=(0,a.$Hp)(i,[]),this.c&&(i=(0,R.$do)(i,this.c)),this.b||(i=(0,R.$do)(i,this.j)),"properties"in l?l.properties=i:l=i,l}k(l,i){this.f&&(this.g.publisher==="vscode"?l=this.g.name+"/"+l:l=this.g.identifier.value+"/"+l,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(l,i),this.h.trace(l,i))}logUsage(l,i){this.d.isUsageEnabled&&this.k(l,i)}logError(l,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof l=="string")this.k(l,i);else{const r={name:l.name,message:l.message,stack:l.stack,cause:l.cause},t=(0,a.$Hp)(r,[]),g=new Error(t.message,{cause:t.cause});g.stack=t.stack,g.name=t.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(g,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const l=this,i={logUsage:l.logUsage.bind(l),get isUsageEnabled(){return l.d.isUsageEnabled},get isErrorsEnabled(){return l.d.isErrorsEnabled},logError:l.logError.bind(l),dispose:l.dispose.bind(l),onDidChangeEnableStates:l.a.event.bind(l)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let l=this.f;this.f=void 0,Promise.resolve(l.flush()).then(l=void 0),this.e=void 0}else this.f=void 0}}e.$gQ=n;function o(s){const l=Date.now()-new Date(s).getTime();return isNaN(l)?!1:l<1e3*60*60*24}e.$iQ=(0,v.$Ci)("IExtHostTelemetry")}),define(Ne[24],Oe([1,0,6,2,177,111,18,3]),function(we,e,v,I,C,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0G=e.ActivationKind=e.$7G=e.$6G=e.$3G=e.ExtensionHostStartup=e.$2G=e.$1G=e.$ZG=e.$YG=void 0,e.$4G=c,e.$5G=S,e.$8G=s,e.$9G=l,e.$YG=Object.freeze({identifier:new A.$nn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:I.URI.parse("void:location"),isBuiltin:!1,targetPlatform:A.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$ZG="extensions.webWorker",e.$1G=(0,T.$Ci)("extensionService");class ${constructor(t){this.dependency=t}}e.$2G=$;var a;(function(r){r[r.EagerAutoStart=1]="EagerAutoStart",r[r.EagerManualStart=2]="EagerManualStart",r[r.Lazy=3]="Lazy"})(a||(e.ExtensionHostStartup=a={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(t,g,u){this.c=t,this.d=g.slice(0),this.e=u.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:N.$KG.createActivationEventsMap(this.d)}}set(t,g,u){if(this.c>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this.c})`);const p=[],m=[],d=[],E=[],D=y(this.d),w=y(g),k=(O,F)=>O.extensionLocation.toString()===F.extensionLocation.toString()||O.isBuiltin===F.isBuiltin||O.isUserBuiltin===F.isUserBuiltin||O.isUnderDevelopment===F.isUnderDevelopment;for(const O of this.d){const F=w.get(O.identifier);if(!F){p.push(O.identifier),D.delete(O.identifier);continue}if(!k(O,F)){p.push(O.identifier),D.delete(O.identifier);continue}}for(const O of g){const F=D.get(O.identifier);if(!F){m.push(O);continue}if(!k(F,O)){p.push(F.identifier),D.delete(F.identifier);continue}}const P=new A.$on(this.e),h=new A.$on(u);for(const O of this.e)h.has(O)||d.push(O);for(const O of u)P.has(O)||E.push(O);const b=N.$KG.createActivationEventsMap(m),M={versionId:t,toRemove:p,toAdd:m,addActivationEvents:b,myToRemove:d,myToAdd:E};return this.delta(M),M}delta(t){if(this.c>=t.versionId)return null;const{toRemove:g,toAdd:u,myToRemove:p,myToAdd:m}=t,d=new A.$on(g),E=new A.$on(p);for(let D=0;D<this.d.length;D++)d.has(this.d[D].identifier)&&(this.d.splice(D,1),D--);for(let D=0;D<this.e.length;D++)E.has(this.e[D])&&(this.e.splice(D,1),D--);for(const D of u)this.d.push(D);for(const D of m)this.e.push(D);return this.f=null,t}containsExtension(t){for(const g of this.e)if(A.$nn.equals(g,t))return!0;return!1}containsActivationEvent(t){return this.f||(this.f=this.g()),this.f.has(t)}g(){const t=new Set;for(const g of this.d){if(!this.containsExtension(g.identifier))continue;const u=N.$KG.readActivationEvents(g);for(const p of u)t.add(p)}return t}}e.$3G=R;function y(r){const t=new A.$pn;for(const g of r)t.set(g.identifier,g);return t}function c(r,t){return r.enabledApiProposals?r.enabledApiProposals.includes(t):!1}function S(r,t){if(!c(r,t))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}class f{constructor(t,g,u,p){this.codeLoadingTime=t,this.activateCallTime=g,this.activateResolvedTime=u,this.activationReason=p}}e.$6G=f;class n{constructor(t,g){this.description=t,this.value=g}}e.$7G=n;var o;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function s(r){return{type:r.isBuiltin?A.ExtensionType.System:A.ExtensionType.User,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,C.$Np)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}function l(r,t){const g=(0,C.$Lp)(r.manifest.publisher,r.manifest.name);return{id:g,identifier:new A.$nn(g),isBuiltin:r.type===A.ExtensionType.System,isUserBuiltin:r.type===A.ExtensionType.User&&r.isBuiltin,isUnderDevelopment:!!t,extensionLocation:r.location,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform,publisherDisplayName:r.publisherDisplayName,...r.manifest}}class i{constructor(){this.onDidRegisterExtensions=v.Event.None,this.onDidChangeExtensionsStatus=v.Event.None,this.onDidChangeExtensions=v.Event.None,this.onWillActivateByEvent=v.Event.None,this.onDidChangeResponsiveChange=v.Event.None,this.onWillStop=v.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,g){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,g){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$0G=i}),define(Ne[205],Oe([1,0,13,119,18,24,11,10]),function(we,e,v,I,C,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6oc=e.$5oc=e.$4oc=e.$3oc=e.$2oc=e.$1oc=void 0,v=Ve(v);class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(s,l,i,r){this.startup=s,this.codeLoadingTime=l,this.activateCallTime=i,this.activateResolvedTime=r}}e.$1oc=$;class a{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,l){return s===-1||l===-1?-1:l-s}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$2oc=a;class R{constructor(s,l,i,r,t,g){this.activationFailed=s,this.activationFailedError=l,this.activationTimes=i,this.module=r,this.exports=t,this.subscriptions=g}}e.$3oc=R;class y extends R{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$4oc=y;class c extends R{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$5oc=c;class S extends R{constructor(s){super(!0,s,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let f=class{constructor(s,l,i,r){this.g=r,this.a=s,this.b=l,this.c=i,this.d=new C.$pn,this.f=Object.create(null)}dispose(){for(const[s,l]of this.d)l.dispose()}async waitForActivatingExtensions(){const s=[];for(const[l,i]of this.d)s.push(i.wait());await Promise.all(s)}isActivated(s){const l=this.d.get(s);return!!(l&&l.value)}getActivatedExtension(s){const l=this.d.get(s);if(!l||!l.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return l.value}async activateByEvent(s,l){if(this.f[s])return;const i=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(i.map(r=>({id:r.identifier,reason:{startup:l,extensionId:r.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,l){const i=this.a.getExtensionDescription(s);if(!i)throw new Error(`Extension '${s.value}' is not known`);return this.h([{id:i.identifier,reason:l}])}async h(s){const l=s.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(l.map(i=>i.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const l=this.a.getExtensionDescription(s.id);if(!l){const t=new Error(`Cannot activate unknown extension '${s.id.value}'`),g=this.k(s,null,[],new S(t));return this.c.onExtensionActivationError(s.id,t,new N.$2G(s.id.value)),g}const i=[],r=typeof l.extensionDependencies>"u"?[]:l.extensionDependencies;for(const t of r){if(this.m(t))continue;const g=this.d.get(t);if(g){i.push(g);continue}if(this.l(t)){i.push(this.j({id:this.b.getExtensionDescription(t).identifier,reason:s.reason}));continue}const u=this.a.getExtensionDescription(t);if(u){if(!u.main&&!u.browser)continue;i.push(this.j({id:u.identifier,reason:s.reason}));continue}const p=l.displayName||l.identifier.value,m=new Error(`Cannot activate the '${p}' extension because it depends on unknown extension '${t}'`),d=this.k(s,l.displayName,[],new S(m));return this.c.onExtensionActivationError(l.identifier,m,new N.$2G(t)),d}return this.k(s,l.displayName,i,null)}k(s,l,i,r){const t=new n(s.id,l,s.reason,i,r,this.c,this.g);return this.d.set(s.id,t),t}l(s){return I.$Occ.isHostExtension(s,this.a,this.b)}m(s){const l=this.b.getExtensionDescription(s);return l?!l.main&&!l.browser:!1}};e.$6oc=f,e.$6oc=f=Qe([qe(3,A.$9j)],f);let n=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,l,i,r,t,g,u){this.c=s,this.d=l,this.f=i,this.g=r,this.h=t,this.j=g,this.k=u,this.a=new T.$Bh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const l=this.g[s];if(l.value&&!l.value.activationFailed){this.g.splice(s,1),s--;continue}if(l.value&&l.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${l.friendlyName}' failed to activate`);i.detail=l.value.activationFailedError,this.h=new S(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const l=new Error;if(s&&s.name&&(l.name=s.name),s&&s.message?l.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:l.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(l.stack=s.stack),this.h=new S(l),this.b&&v.$3(s))return;this.j.onExtensionActivationError(this.c,l,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};n=Qe([qe(6,A.$9j)],n)});var _t=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Ne[120],Oe([1,0,9,13,35,110,77,30,18,108,111,104]),function(we,e,v,I,C,N,A,T,$,a,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=void 0,v=Ve(v),C=_t(C);const c=T.$no.as(A.$oo.JSONContribution);class S{constructor(t,g,u){this.a=t,this.b=g,this.c=u}d(t,g){this.a({type:t,message:g,extensionId:this.b.identifier,extensionPointId:this.c})}error(t){this.d(C.default.Error,t)}warn(t){this.d(C.default.Warning,t)}info(t){this.d(C.default.Info,t)}}e.$SG=S;class f{static a(t){const g=new $.$on;for(let u=0,p=t.length;u<p;u++)g.add(t[u].description.identifier);return g}static compute(t,g){if(!t||!t.length)return new f(g,[]);if(!g||!g.length)return new f([],t);const u=this.a(t),p=this.a(g),m=g.filter(E=>!u.has(E.description.identifier)),d=t.filter(E=>!p.has(E.description.identifier));return new f(m,d)}constructor(t,g){this.added=t,this.removed=g}}e.$TG=f;class n{constructor(t,g){this.name=t,this.defaultExtensionKind=g,this.a=null,this.b=null,this.c=null}setHandler(t){if(this.a!==null)throw new Error("Handler already set!");return this.a=t,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(t){this.c=f.compute(this.b,t),this.b=t,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(t){(0,I.$Y)(t)}}}e.$UG=n;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[v.localize(1794,null),v.localize(1795,null)]},s="vscode://schemas/vscode-extensions";e.$VG={properties:{engines:{type:"object",description:v.localize(1796,null),properties:{vscode:{type:"string",description:v.localize(1797,null),default:"^1.22.0"}}},publisher:{description:v.localize(1798,null),type:"string"},displayName:{description:v.localize(1799,null),type:"string"},categories:{description:v.localize(1800,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$mn},{type:"string",const:"Languages",deprecationMessage:v.localize(1801,null)}]}},galleryBanner:{type:"object",description:v.localize(1802,null),properties:{color:{description:v.localize(1803,null),type:"string"},theme:{description:v.localize(1804,null),type:"string",enum:["dark","light"]}}},contributes:{description:v.localize(1805,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:v.localize(1806,null)},enableProposedApi:{type:"boolean",deprecationMessage:v.localize(1807,null)},enabledApiProposals:{markdownDescription:v.localize(1808,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals).map(r=>r),markdownEnumDescriptions:Object.values(y.allApiProposals).map(r=>r.proposal)}},api:{markdownDescription:v.localize(1809,null),type:"string",enum:["none"],enumDescriptions:[v.localize(1810,null)]},activationEvents:{description:v.localize(1811,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:v.localize(1812,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:v.localize(1813,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:v.localize(1814,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:v.localize(1815,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:v.localize(1816,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:v.localize(1817,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:v.localize(1818,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:v.localize(1819,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:v.localize(1820,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:v.localize(1821,null),body:"onStartupFinished"},{label:"onTaskType",description:v.localize(1822,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:v.localize(1823,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:v.localize(1824,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:v.localize(1825,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:v.localize(1826,null)},{label:"onUri",body:"onUri",description:v.localize(1827,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:v.localize(1828,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:v.localize(1829,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:v.localize(1830,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:v.localize(1831,null)},{label:"onRenderer",description:v.localize(1832,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:v.localize(1833,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:v.localize(1834,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:v.localize(1835,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:v.localize(1836,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:v.localize(1837,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolName}",description:v.localize(1838,null)},{label:"*",description:v.localize(1839,null),body:"*"}]}},badges:{type:"array",description:v.localize(1840,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:v.localize(1841,null)},href:{type:"string",description:v.localize(1842,null)},description:{type:"string",description:v.localize(1843,null)}}}},markdown:{type:"string",description:v.localize(1844,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:v.localize(1845,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:v.localize(1846,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$7o}},extensionPack:{description:v.localize(1847,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$7o}},extensionKind:{description:v.localize(1848,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:v.localize(1849,null)},{body:["workspace"],description:v.localize(1850,null)},{body:["ui","workspace"],description:v.localize(1851,null)},{body:["workspace","ui"],description:v.localize(1852,null)},{body:[],description:v.localize(1853,null)}]},capabilities:{description:v.localize(1854,null),type:"object",properties:{virtualWorkspaces:{description:v.localize(1855,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:v.localize(1856,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(1857,null),v.localize(1858,null),v.localize(1859,null)]},description:{type:"string",markdownDescription:v.localize(1860,null)}}},untrustedWorkspaces:{description:v.localize(1861,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:v.localize(1862,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(1863,null),v.localize(1864,null),v.localize(1865,null)]},restrictedConfigurations:{description:v.localize(1866,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:v.localize(1867,null)}}}}},sponsor:{description:v.localize(1868,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:v.localize(1869,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:v.localize(1870,null),type:"string"},"vscode:uninstall":{description:v.localize(1871,null),type:"string"}}},icon:{type:"string",description:v.localize(1872,null)},l10n:{type:"string",description:v.localize(1873,null)},pricing:{type:"string",markdownDescription:v.localize(1874,null),enum:["Free","Trial"],default:"Free"}}};class l{constructor(){this.a=new Map}registerExtensionPoint(t){if(this.a.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const g=new n(t.extensionPoint,t.defaultExtensionKind);return this.a.set(t.extensionPoint,g),t.activationEventsGenerator&&R.$KG.register(t.extensionPoint,t.activationEventsGenerator),e.$VG.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,c.registerSchema(s,e.$VG),g}getExtensionPoints(){return Array.from(this.a.values())}}e.$WG=l;const i={ExtensionsRegistry:"ExtensionsRegistry"};T.$no.add(i.ExtensionsRegistry,new l),e.$XG=T.$no.as(i.ExtensionsRegistry),c.registerSchema(s,e.$VG),c.registerSchema(a.$qk,{properties:{extensionEnabledApiProposals:{description:v.localize(1875,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals).map(r=>r.proposal)}}]}}}})}),define(Ne[206],Oe([1,0,6,39,4,12,9,18,3,11,24,120]),function(we,e,v,I,C,N,A,T,$,a,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aH=e.$_G=e.$$G=e.ChatMessageRole=void 0;var c;(function(n){n[n.System=0]="System",n[n.User=1]="User",n[n.Assistant=2]="Assistant"})(c||(e.ChatMessageRole=c={})),e.$$G=(0,$.$Ci)("ILanguageModelsService");const S={type:"object",properties:{vendor:{type:"string",description:(0,A.localize)(8281,null)}}};e.$_G=y.$XG.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,A.localize)(8282,null),oneOf:[S,{type:"array",items:S}]},activationEventsGenerator:(n,o)=>{for(const s of n)o.push(`onLanguageModelChat:${s.vendor}`)}});let f=class{constructor(o,s){this.e=o,this.f=s,this.a=new C.$Sc,this.b=new Map,this.c=new Set,this.d=this.a.add(new v.$je),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$_G.setHandler(l=>{this.c.clear();for(const r of l){if(!(0,R.$4G)(r.description,"chatProvider")){r.collector.error((0,A.localize)(8283,null));continue}for(const t of I.Iterable.wrap(r.value)){if(this.c.has(t.vendor)){r.collector.error((0,A.localize)(8284,null,t.vendor));continue}if((0,N.$af)(t.vendor)){r.collector.error((0,A.localize)(8285,null));continue}if(t.vendor.trim()!==t.vendor){r.collector.error((0,A.localize)(8286,null));continue}this.c.add(t.vendor)}}const i=[];for(const[r,t]of this.b)this.c.has(t.metadata.vendor)||(this.b.delete(r),i.push(r));i.length>0&&this.d.fire({removed:i})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(o){return this.b.get(o)?.metadata}async selectLanguageModels(o){if(o.vendor)await this.e.activateByEvent(`onLanguageModelChat:${o.vendor}}`);else{const l=Array.from(this.c).map(i=>this.e.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all(l)}const s=[];for(const[l,i]of this.b)(o.vendor===void 0||i.metadata.vendor===o.vendor)&&(o.family===void 0||i.metadata.family===o.family)&&(o.version===void 0||i.metadata.version===o.version)&&(o.identifier===void 0||i.metadata.id===o.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(r=>T.$nn.equals(r,o.extension)))&&s.push(l);return this.f.trace("[LM] selected language models",o,s),s}registerLanguageModelChat(o,s){if(this.f.trace("[LM] registering language model chat",o,s.metadata),!this.c.has(s.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${s.metadata.vendor}.`);if(this.b.has(o))throw new Error(`Chat response provider with identifier ${o} is already registered.`);return this.b.set(o,s),this.d.fire({added:[{identifier:o,metadata:s.metadata}]}),(0,C.$Rc)(()=>{this.b.delete(o)&&(this.d.fire({removed:[o]}),this.f.trace("[LM] UNregistered language model chat",o,s.metadata))})}async sendChatRequest(o,s,l,i,r){const t=this.b.get(o);if(!t)throw new Error(`Chat response provider with identifier ${o} is not registered.`);return t.sendChatRequest(l,s,i,r)}computeTokenLength(o,s,l){const i=this.b.get(o);if(!i)throw new Error(`Chat response provider with identifier ${o} is not registered.`);return i.provideTokenCount(s,l)}};e.$aH=f,e.$aH=f=Qe([qe(0,R.$1G),qe(1,a.$9j)],f)}),define(Ne[207],Oe([1,0,9,14,25,120,31,6]),function(we,e,v,I,C,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FI=void 0,v=Ve(v),I=Ve(I),C=Ve(C);const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:v.localize(3862,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:v.localize(3863,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:v.localize(3864,null),default:""}}};var a;(function(c){function S(f,n,o){if(!f)return;const s=I.$cg(f.type)?f.type:void 0;if(!s||s.length===0){o.error(v.localize(3865,null));return}const l=[];if(Array.isArray(f.required))for(const i of f.required)I.$cg(i)&&l.push(i);return{extensionId:n.value,taskType:s,required:l,properties:f.properties?C.$ao(f.properties):{},when:f.when?A.$Aj.deserialize(f.when):void 0}}c.from=S})(a||(a={}));const R=N.$XG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(c,S)=>{for(const f of c)f.type&&S.push(`onTaskType:${f.type}`)},jsonSchema:{description:v.localize(3866,null),type:"array",items:$}});class y{constructor(){this.d=new T.$je,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((S,f)=>{R.setHandler((n,o)=>{this.c=void 0;try{for(const s of o.removed){const l=s.value;for(const i of l)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const s of o.added){const l=s.value;for(const i of l){const r=a.from(i,s.description.identifier,s.collector);r&&(this.a[r.taskType]=r)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}S(void 0)})})}onReady(){return this.b}get(S){return this.a[S]}all(){return Object.keys(this.a).map(S=>this.a[S])}getJsonSchema(){if(this.c===void 0){const S=[];for(const f of this.all()){const n={type:"object",additionalProperties:!1};f.required.length>0&&(n.required=f.required.slice(0)),f.properties!==void 0?n.properties=C.$ao(f.properties):n.properties=Object.create(null),n.properties.type={type:"string",enum:[f.taskType]},S.push(n)}this.c={oneOf:S}}return this.c}}e.$FI=new y}),define(Ne[208],Oe([1,0,9,14,23,25,31,207,43]),function(we,e,v,I,C,N,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$PI=e.JsonSchemaVersion=e.ExecutionEngine=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$JI=e.ShellQuoting=e.$II=e.$HI=e.$GI=void 0,v=Ve(v),I=Ve(I),C=Ve(C),N=Ve(N),e.$GI="settings",e.$HI=new A.$Tj("taskRunning",!1,v.localize(3850,null)),e.$II=v.localize2(3852,"Tasks");var a;(function(L){L[L.Escape=1]="Escape",L[L.Strong=2]="Strong",L[L.Weak=3]="Weak"})(a||(e.ShellQuoting=a={})),e.$JI="$customized",function(L){function Y(Z){if(!Z)return L.Strong;switch(Z.toLowerCase()){case"escape":return L.Escape;case"strong":return L.Strong;case"weak":return L.Weak;default:return L.Strong}}L.from=Y}(a||(e.ShellQuoting=a={}));var R;(function(L){L.defaults={cwd:"${workspaceFolder}"}})(R||(e.CommandOptions=R={}));var y;(function(L){L[L.Always=1]="Always",L[L.Silent=2]="Silent",L[L.Never=3]="Never"})(y||(e.RevealKind=y={})),function(L){function Y(Z){switch(Z.toLowerCase()){case"always":return L.Always;case"silent":return L.Silent;case"never":return L.Never;default:return L.Always}}L.fromString=Y}(y||(e.RevealKind=y={}));var c;(function(L){L[L.Never=1]="Never",L[L.OnProblem=2]="OnProblem",L[L.Always=3]="Always"})(c||(e.RevealProblemKind=c={})),function(L){function Y(Z){switch(Z.toLowerCase()){case"always":return L.Always;case"never":return L.Never;case"onproblem":return L.OnProblem;default:return L.OnProblem}}L.fromString=Y}(c||(e.RevealProblemKind=c={}));var S;(function(L){L[L.Shared=1]="Shared",L[L.Dedicated=2]="Dedicated",L[L.New=3]="New"})(S||(e.PanelKind=S={})),function(L){function Y(Z){switch(Z.toLowerCase()){case"shared":return L.Shared;case"dedicated":return L.Dedicated;case"new":return L.New;default:return L.Shared}}L.fromString=Y}(S||(e.PanelKind=S={}));var f;(function(L){L.defaults={echo:!0,reveal:y.Always,revealProblems:c.Never,focus:!1,panel:S.Shared,showReuseMessage:!0,clear:!1}})(f||(e.PresentationOptions=f={}));var n;(function(L){L[L.Shell=1]="Shell",L[L.Process=2]="Process",L[L.CustomExecution=3]="CustomExecution"})(n||(e.RuntimeType=n={})),function(L){function Y(fe){switch(fe.toLowerCase()){case"shell":return L.Shell;case"process":return L.Process;case"customExecution":return L.CustomExecution;default:return L.Process}}L.fromString=Y;function Z(fe){switch(fe){case L.Shell:return"shell";case L.Process:return"process";case L.CustomExecution:return"customExecution";default:return"process"}}L.toString=Z}(n||(e.RuntimeType=n={}));var o;(function(L){function Y(Z){return I.$cg(Z)?Z:Z.value}L.value=Y})(o||(e.CommandString=o={}));var s;(function(L){L.Clean={_id:"clean",isDefault:!1},L.Build={_id:"build",isDefault:!1},L.Rebuild={_id:"rebuild",isDefault:!1},L.Test={_id:"test",isDefault:!1};function Y(fe){return fe===L.Clean._id||fe===L.Build._id||fe===L.Rebuild._id||fe===L.Test._id}L.is=Y;function Z(fe){if(fe!==void 0)return I.$cg(fe)?Y(fe)?{_id:fe,isDefault:!1}:void 0:fe}L.from=Z})(s||(e.TaskGroup=s={}));var l;(function(L){L[L.Global=1]="Global",L[L.Workspace=2]="Workspace",L[L.Folder=3]="Folder"})(l||(e.TaskScope=l={}));var i;(function(L){L.Workspace="workspace",L.Extension="extension",L.InMemory="inMemory",L.WorkspaceFile="workspaceFile",L.User="user";function Y(Z){switch(Z){case L.User:return $.ConfigurationTarget.USER;case L.WorkspaceFile:return $.ConfigurationTarget.WORKSPACE;default:return $.ConfigurationTarget.WORKSPACE_FOLDER}}L.toConfigurationTarget=Y})(i||(e.TaskSourceKind=i={}));var r;(function(L){L.parallel="parallel",L.sequence="sequence"})(r||(e.DependsOrder=r={}));var t;(function(L){L[L.default=1]="default",L[L.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var g;(function(L){L.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(g||(e.RunOptions=g={}));class u{constructor(Y,Z,fe,_,ge,se){this._label="",this._id=Y,Z&&(this._label=Z),fe&&(this.type=fe),this.runOptions=_,this.configurationProperties=ge,this._source=se}getDefinition(Y){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const Y={folder:this.d(),id:this._id};return JSON.stringify(Y)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(Y,Z=!1){if(Y===void 0)return!1;if(I.$cg(Y))return Y===this._label||Y===this.configurationProperties.identifier||Z&&Y===this._id;const fe=this.getDefinition(!0);return fe!==void 0&&fe._key===Y._key}getQualifiedLabel(){const Y=this.getWorkspaceFolder();return Y?`${this._label} (${Y.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(Y){this.c===void 0&&(this.c=[]),Y&&(this.c=this.c.concat(Y))}get taskLoadMessages(){return this.c}}e.$KI=u;class p extends u{constructor(Y,Z,fe,_,ge,se,ae,$e){super(Y,fe,void 0,ae,$e,Z),this.command={},this._source=Z,this.hasDefinedMatchers=se,ge&&(this.command=ge)}clone(){return new p(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(Y=!1){if(Y&&this._source.customizes!==void 0)return this._source.customizes;{let Z;switch(this.command?this.command.runtime:void 0){case n.Shell:Z="shell";break;case n.Process:Z="process";break;case n.CustomExecution:Z="customExecution";break;case void 0:Z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:Z,_key:this._id,id:this._id}}}static is(Y){return Y instanceof p}getMapKey(){const Y=this._source.config.workspaceFolder;return Y?`${Y.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$GI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const Y=this.d();if(!Y)return;let Z=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(Z+=this._source.kind);const fe={type:e.$JI,folder:Y,id:Z};return JSON.stringify(fe)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$ah(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(Y){return new p(Y._id,Y._source,Y._label,Y.type,Y.command,Y.hasDefinedMatchers,Y.runOptions,Y.configurationProperties)}}e.$LI=p;class m extends u{constructor(Y,Z,fe,_,ge,se,ae){super(Y,fe,_,se,ae,Z),this._source=Z,this.configures=ge}static is(Y){return Y instanceof m}f(Y){return Y}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$ah(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$GI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const Y=this.d();if(!Y)return;let Z=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(Z+=this._source.kind);const fe={type:e.$JI,folder:Y,id:Z};return JSON.stringify(fe)}}e.$MI=m;class d extends u{constructor(Y,Z,fe,_,ge,se,ae,$e,oe){super(Y,fe,_,$e,oe,Z),this.defines=ge,this.hasDefinedMatchers=ae,this.command=se,this.icon=oe.icon,this.hide=oe.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(Y){return Y instanceof d}getMapKey(){const Y=this._source.workspaceFolder;return Y?`${this._source.scope.toString()}|${Y.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===l.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const Y={type:"contributed",scope:this._source.scope,id:this._id};return Y.folder=this.d(),JSON.stringify(Y)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(Y){return new d(Y._id,Y._source,Y._label,Y.type,Y.defines,Y.command,Y.hasDefinedMatchers,Y.runOptions,Y.configurationProperties)}}e.$NI=d;class E extends u{constructor(Y,Z,fe,_,ge,se){super(Y,fe,_,ge,se,Z),this._source=Z}clone(){return new E(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(Y){return Y instanceof E}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(Y){return new E(Y._id,Y._source,Y._label,Y.type,Y.runOptions,Y.configurationProperties)}}e.$OI=E;var D;(function(L){L[L.Process=1]="Process",L[L.Terminal=2]="Terminal"})(D||(e.ExecutionEngine=D={})),function(L){L._default=L.Terminal}(D||(e.ExecutionEngine=D={}));var w;(function(L){L[L.V0_1_0=1]="V0_1_0",L[L.V2_0_0=2]="V2_0_0"})(w||(e.JsonSchemaVersion=w={}));class k{constructor(Y){this.c=new Map;for(let Z=0;Z<Y.length;Z++)this.c.set(Y[Z].uri.toString(),Z)}compare(Y,Z){const fe=Y.getWorkspaceFolder(),_=Z.getWorkspaceFolder();if(fe&&_){let ge=this.c.get(fe.uri.toString());ge=ge===void 0?0:ge+1;let se=this.c.get(_.uri.toString());return se=se===void 0?0:se+1,ge===se?Y._label.localeCompare(Z._label):ge-se}else return!fe&&_?-1:fe&&!_?1:0}}e.$PI=k;var P;(function(L){L.DependsOnStarted="dependsOnStarted",L.AcquiredInput="acquiredInput",L.Start="start",L.ProcessStarted="processStarted",L.Active="active",L.Inactive="inactive",L.Changed="changed",L.Terminated="terminated",L.ProcessEnded="processEnded",L.End="end"})(P||(e.TaskEventKind=P={}));var h;(function(L){L.SingleRun="singleRun",L.Background="background"})(h||(e.TaskRunType=h={}));var b;(function(L){L[L.System=0]="System",L[L.User=1]="User",L[L.FolderOpen=2]="FolderOpen",L[L.ConfigurationChange=3]="ConfigurationChange",L[L.Reconnect=4]="Reconnect"})(b||(e.TaskRunSource=b={}));var M;(function(L){function Y($e){return{taskId:$e._id,taskName:$e.configurationProperties.name,runType:$e.configurationProperties.isBackground?h.Background:h.SingleRun,group:$e.configurationProperties.group,__task:$e}}function Z($e,oe,Ce){return{...Y($e),kind:P.Start,terminalId:oe,resolvedVariables:Ce}}L.start=Z;function fe($e,oe,Ce){return{...Y($e),kind:P.ProcessStarted,terminalId:oe,processId:Ce}}L.processStarted=fe;function _($e,oe,Ce){return{...Y($e),kind:P.ProcessEnded,terminalId:oe,exitCode:Ce}}L.processEnded=_;function ge($e,oe,Ce){return{...Y($e),kind:P.Terminated,exitReason:Ce,terminalId:oe}}L.terminated=ge;function se($e,oe,Ce){return{...Y(oe),kind:$e,terminalId:Ce}}L.general=se;function ae(){return{kind:P.Changed}}L.changed=ae})(M||(e.TaskEvent=M={}));var O;(function(L){function Y(fe){const _=Object.keys(fe).sort();let ge="";for(const se of _){let ae=fe[se];ae instanceof Object?ae=Y(ae):typeof ae=="string"&&(ae=ae.replace(/,/g,",,")),ge+=se+","+ae+","}return ge}function Z(fe){const ge={_key:Y(fe),type:fe.taskType};return Object.assign(ge,fe),ge}L.create=Z})(O||(e.KeyedTaskIdentifier=O={}));var F;(function(L){L.AutoDetect="task.autoDetect",L.SaveBeforeRun="task.saveBeforeRun",L.ShowDecorations="task.showDecorations",L.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",L.SlowProviderWarning="task.slowProviderWarning",L.QuickOpenHistory="task.quickOpen.history",L.QuickOpenDetail="task.quickOpen.detail",L.QuickOpenSkip="task.quickOpen.skip",L.QuickOpenShowAll="task.quickOpen.showAll",L.AllowAutomaticTasks="task.allowAutomaticTasks",L.Reconnection="task.reconnection",L.VerboseLogging="task.verboseLogging"})(F||(e.TaskSettingId=F={}));var q;(function(L){L.Tasks="tasks",L.SuppressTaskName="tasks.suppressTaskName",L.Windows="tasks.windows",L.Osx="tasks.osx",L.Linux="tasks.linux",L.ShowOutput="tasks.showOutput",L.IsShellCommand="tasks.isShellCommand",L.ServiceTestSetting="tasks.service.testSetting"})(q||(e.TasksSchemaProperties=q={}));var B;(function(L){function Y(Z,fe){const _=T.$FI.get(Z.type);if(_===void 0){const $e=N.$ao(Z);return delete $e._key,O.create($e)}const ge=Object.create(null);ge.type=_.taskType;const se=new Set;_.required.forEach($e=>se.add($e));const ae=_.properties;for(const $e of Object.keys(ae)){const oe=Z[$e];if(oe!=null)ge[$e]=oe;else if(se.has($e)){const Ce=ae[$e];if(Ce.default!==void 0)ge[$e]=N.$ao(Ce.default);else switch(Ce.type){case"boolean":ge[$e]=!1;break;case"number":case"integer":ge[$e]=0;break;case"string":ge[$e]="";break;default:fe.error(v.localize(3851,null,JSON.stringify(Z,void 0,0),$e));return}}}return O.create(ge)}L.createTaskIdentifier=Y})(B||(e.TaskDefinition=B={}))}),define(Ne[209],Oe([1,0,13]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tcc=e.$Scc=void 0;class I{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,T)=>{this.b=A,this.d=T,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,v.$Y)(A))}then(A,T){return this.j().then(A,T)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$Scc=I;class C extends I{constructor(){super(),this.h=!0,this.i=new v.$4}}e.$Tcc=C}),define(Ne[38],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sw=e.$Pw=void 0,e.$Qw=C,e.$Rw=N;class v{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++v.count}}e.$Pw=v;const I=[];function C(T){const $=new v(T);return I[$.nid]=$,$}function N(T){return I[T].sid}class A{constructor($){this.value=$}}e.$Sw=A}),define(Ne[5],Oe([1,0,38]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tN=e.$sN=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$rN=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var I;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(I||(e.TextEditorRevealType=I={}));var C;(function(n){n[n.UnknownInput=0]="UnknownInput",n[n.TextInput=1]="TextInput",n[n.TextDiffInput=2]="TextDiffInput",n[n.TextMergeInput=3]="TextMergeInput",n[n.NotebookInput=4]="NotebookInput",n[n.NotebookDiffInput=5]="NotebookDiffInput",n[n.CustomEditorInput=6]="CustomEditorInput",n[n.WebviewEditorInput=7]="WebviewEditorInput",n[n.TerminalEditorInput=8]="TerminalEditorInput",n[n.InteractiveEditorInput=9]="InteractiveEditorInput",n[n.ChatEditorInput=10]="ChatEditorInput",n[n.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(C||(e.TabInputKind=C={}));var N;(function(n){n[n.TAB_OPEN=0]="TAB_OPEN",n[n.TAB_CLOSE=1]="TAB_CLOSE",n[n.TAB_UPDATE=2]="TAB_UPDATE",n[n.TAB_MOVE=3]="TAB_MOVE"})(N||(e.TabModelOperationKind=N={}));var A;(function(n){n[n.Editable=0]="Editable",n[n.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var T;(function(n){n[n.Int8Array=1]="Int8Array",n[n.Uint8Array=2]="Uint8Array",n[n.Uint8ClampedArray=3]="Uint8ClampedArray",n[n.Int16Array=4]="Int16Array",n[n.Uint16Array=5]="Uint16Array",n[n.Int32Array=6]="Int32Array",n[n.Uint32Array=7]="Uint32Array",n[n.Float32Array=8]="Float32Array",n[n.Float64Array=9]="Float64Array",n[n.BigInt64Array=10]="BigInt64Array",n[n.BigUint64Array=11]="BigUint64Array"})(T||(e.WebviewMessageArrayBufferViewType=T={}));var $;(function(n){n[n.Text=1]="Text",n[n.Error=2]="Error",n[n.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var a;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(a||(e.NotebookEditorRevealType=a={}));var R;(function(n){n[n.None=0]="None",n[n.Process=1]="Process",n[n.Output=2]="Output",n[n.Hybrid=3]="Hybrid"})(R||(e.CandidatePortSource=R={}));class y{static{this.a=0}static mixin(o){return o._id=y.a++,o}}e.$rN=y;var c;(function(n){n.label="a",n.kind="b",n.detail="c",n.documentation="d",n.sortText="e",n.filterText="f",n.preselect="g",n.insertText="h",n.insertTextRules="i",n.range="j",n.commitCharacters="k",n.additionalTextEdits="l",n.kindModifier="m",n.commandIdent="n",n.commandId="o",n.commandArguments="p"})(c||(e.ISuggestDataDtoField=c={}));var S;(function(n){n.defaultRanges="a",n.completions="b",n.isIncomplete="c",n.duration="d"})(S||(e.ISuggestResultDtoField=S={}));var f;(function(n){n[n.Workspace=0]="Workspace",n[n.TextDocument=1]="TextDocument"})(f||(e.ExtHostTestingResource=f={})),e.$sN={MainThreadAuthentication:(0,v.$Qw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,v.$Qw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,v.$Qw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,v.$Qw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,v.$Qw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,v.$Qw)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,v.$Qw)("MainThreadChatSkills"),MainThreadClipboard:(0,v.$Qw)("MainThreadClipboard"),MainThreadCommands:(0,v.$Qw)("MainThreadCommands"),MainThreadComments:(0,v.$Qw)("MainThreadComments"),MainThreadConfiguration:(0,v.$Qw)("MainThreadConfiguration"),MainThreadConsole:(0,v.$Qw)("MainThreadConsole"),MainThreadDebugService:(0,v.$Qw)("MainThreadDebugService"),MainThreadDecorations:(0,v.$Qw)("MainThreadDecorations"),MainThreadDiagnostics:(0,v.$Qw)("MainThreadDiagnostics"),MainThreadDialogs:(0,v.$Qw)("MainThreadDiaglogs"),MainThreadDocuments:(0,v.$Qw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,v.$Qw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,v.$Qw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,v.$Qw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,v.$Qw)("MainThreadEditorTabs"),MainThreadErrors:(0,v.$Qw)("MainThreadErrors"),MainThreadTreeViews:(0,v.$Qw)("MainThreadTreeViews"),MainThreadDownloadService:(0,v.$Qw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,v.$Qw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,v.$Qw)("MainThreadLanguages"),MainThreadLogger:(0,v.$Qw)("MainThreadLogger"),MainThreadMessageService:(0,v.$Qw)("MainThreadMessageService"),MainThreadOutputService:(0,v.$Qw)("MainThreadOutputService"),MainThreadProgress:(0,v.$Qw)("MainThreadProgress"),MainThreadQuickDiff:(0,v.$Qw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,v.$Qw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,v.$Qw)("MainThreadStatusBar"),MainThreadSecretState:(0,v.$Qw)("MainThreadSecretState"),MainThreadStorage:(0,v.$Qw)("MainThreadStorage"),MainThreadSpeech:(0,v.$Qw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,v.$Qw)("MainThreadTelemetry"),MainThreadTerminalService:(0,v.$Qw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,v.$Qw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,v.$Qw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,v.$Qw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,v.$Qw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,v.$Qw)("MainThreadCustomEditors"),MainThreadUrls:(0,v.$Qw)("MainThreadUrls"),MainThreadUriOpeners:(0,v.$Qw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,v.$Qw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,v.$Qw)("MainThreadWorkspace"),MainThreadFileSystem:(0,v.$Qw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,v.$Qw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,v.$Qw)("MainThreadExtensionService"),MainThreadSCM:(0,v.$Qw)("MainThreadSCM"),MainThreadSearch:(0,v.$Qw)("MainThreadSearch"),MainThreadShare:(0,v.$Qw)("MainThreadShare"),MainThreadTask:(0,v.$Qw)("MainThreadTask"),MainThreadWindow:(0,v.$Qw)("MainThreadWindow"),MainThreadLabelService:(0,v.$Qw)("MainThreadLabelService"),MainThreadNotebook:(0,v.$Qw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,v.$Qw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,v.$Qw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,v.$Qw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,v.$Qw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,v.$Qw)("MainThreadInteractive"),MainThreadTheming:(0,v.$Qw)("MainThreadTheming"),MainThreadTunnelService:(0,v.$Qw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,v.$Qw)("MainThreadManagedSockets"),MainThreadTimeline:(0,v.$Qw)("MainThreadTimeline"),MainThreadTesting:(0,v.$Qw)("MainThreadTesting"),MainThreadLocalization:(0,v.$Qw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,v.$Qw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,v.$Qw)("MainThreadAiEmbeddingVector")},e.$tN={ExtHostCommands:(0,v.$Qw)("ExtHostCommands"),ExtHostConfiguration:(0,v.$Qw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,v.$Qw)("ExtHostDiagnostics"),ExtHostDebugService:(0,v.$Qw)("ExtHostDebugService"),ExtHostDecorations:(0,v.$Qw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,v.$Qw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,v.$Qw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,v.$Qw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,v.$Qw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,v.$Qw)("ExtHostEditors"),ExtHostTreeViews:(0,v.$Qw)("ExtHostTreeViews"),ExtHostFileSystem:(0,v.$Qw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,v.$Qw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,v.$Qw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,v.$Qw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,v.$Qw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,v.$Qw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,v.$Qw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,v.$Qw)("ExtHostStatusBar"),ExtHostShare:(0,v.$Qw)("ExtHostShare"),ExtHostExtensionService:(0,v.$Qw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,v.$Qw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,v.$Qw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,v.$Qw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,v.$Qw)("ExtHostSCM"),ExtHostSearch:(0,v.$Qw)("ExtHostSearch"),ExtHostTask:(0,v.$Qw)("ExtHostTask"),ExtHostWorkspace:(0,v.$Qw)("ExtHostWorkspace"),ExtHostWindow:(0,v.$Qw)("ExtHostWindow"),ExtHostWebviews:(0,v.$Qw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,v.$Qw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,v.$Qw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,v.$Qw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,v.$Qw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,v.$Qw)("ExtHostEditorTabs"),ExtHostProgress:(0,v.$Qw)("ExtHostProgress"),ExtHostComments:(0,v.$Qw)("ExtHostComments"),ExtHostSecretState:(0,v.$Qw)("ExtHostSecretState"),ExtHostStorage:(0,v.$Qw)("ExtHostStorage"),ExtHostUrls:(0,v.$Qw)("ExtHostUrls"),ExtHostUriOpeners:(0,v.$Qw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,v.$Qw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,v.$Qw)("ExtHostOutputService"),ExtHostLabelService:(0,v.$Qw)("ExtHostLabelService"),ExtHostNotebook:(0,v.$Qw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,v.$Qw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,v.$Qw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,v.$Qw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,v.$Qw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,v.$Qw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,v.$Qw)("ExtHostInteractive"),ExtHostChatAgents2:(0,v.$Qw)("ExtHostChatAgents"),ExtHostChatVariables:(0,v.$Qw)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,v.$Qw)("ExtHostChatSkills"),ExtHostChatProvider:(0,v.$Qw)("ExtHostChatProvider"),ExtHostSpeech:(0,v.$Qw)("ExtHostSpeech"),ExtHostEmbeddings:(0,v.$Qw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,v.$Qw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,v.$Qw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,v.$Qw)("ExtHostTheming"),ExtHostTunnelService:(0,v.$Qw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,v.$Qw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,v.$Qw)("ExtHostAuthentication"),ExtHostTimeline:(0,v.$Qw)("ExtHostTimeline"),ExtHostTesting:(0,v.$Qw)("ExtHostTesting"),ExtHostTelemetry:(0,v.$Qw)("ExtHostTelemetry"),ExtHostLocalization:(0,v.$Qw)("ExtHostLocalization")}}),define(Ne[84],Oe([1,0,3,11,5,16]),function(we,e,v,I,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$poc=e.$ooc=e.$noc=void 0,C=Ve(C),e.$noc=(0,v.$Ci)("IExtHostApiDeprecationService");let A=class{constructor($,a){this.c=a,this.a=new Set,this.b=$.getProxy(C.$sN.MainThreadTelemetry)}report($,a,R){const y=this.d($,a);this.a.has(y)||(this.a.add(y),a.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:a.identifier.value,apiId:$}))}d($,a){return`${$}-${a.identifier.value}`}};e.$ooc=A,e.$ooc=A=Qe([qe(0,N.$1P),qe(1,I.$9j)],A),e.$poc=Object.freeze(new class{report(T,$,a){}})}),define(Ne[210],Oe([1,0,5]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Coc=void 0;class I{constructor(N){const A=N.getProxy(v.$sN.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(T){return A.$writeText(T)}})}}e.$Coc=I}),define(Ne[211],Oe([1,0,25,5,26,16]),function(we,e,v,I,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yqc=void 0;let A=class{constructor(R,y){this.a=R.getProxy(I.$sN.MainThreadConsole),this.b=y.consoleForward.includeStack,this.c=y.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(R,y){const c=this,S=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){c.e(R,y,S,arguments)}})}e(R,y,c,S){this.a.$logExtensionHostMessage({type:"__$console",severity:y,arguments:$(S,this.b)}),this.c&&this.f(R,c,S)}};e.$yqc=A,e.$yqc=A=Qe([qe(0,N.$1P),qe(1,C.$eQ)],A);const T=1e5;function $(a,R){const y=[];if(a.length)for(let c=0;c<a.length;c++){let S=a[c];if(typeof S>"u")S="undefined";else if(S instanceof Error){const f=S;f.stack?S=f.stack:S=f.toString()}y.push(S)}if(R){const c=new Error().stack;c&&y.push({__$stack:c.split(`
`).slice(3).join(`
`)})}try{const c=(0,v.$fo)(y);return c.length>T?"Output omitted for a large object that exceeds the limits":c}catch(c){return`Output omitted for an object that cannot be inspected ('${c.toString()}')`}}}),define(Ne[212],Oe([1,0,2,5,24]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Epc=void 0;class N{constructor(T){this.a=T.getProxy(I.$sN.MainThreadDialogs)}showOpenDialog(T,$){return $?.allowUIResources&&(0,C.$5G)(T,"showLocal"),this.a.$showOpenDialog($).then(a=>a?a.map(R=>v.URI.revive(R)):void 0)}showSaveDialog(T){return this.a.$showSaveDialog(T).then($=>$?v.URI.revive($):void 0)}}e.$Epc=N}),define(Ne[213],Oe([1,0,21,6,4,5]),function(we,e,v,I,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hpc=void 0;class A{constructor($){this.b=new Map,this.c=new I.$je,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=$.getProxy(N.$sN.MainThreadEmbeddings)}registerEmbeddingsProvider($,a,R){if(this.d.has(a))throw new Error("An embeddings provider for this model is already registered");const y=this.e++;return this.a.$registerEmbeddingProvider(y,a),this.b.set(y,{id:a,provider:R}),(0,C.$Rc)(()=>{this.a.$unregisterEmbeddingProvider(y),this.b.delete(y)})}async computeEmbeddings($,a,R){R??=v.CancellationToken.None;let y=!1;typeof a=="string"&&(a=[a],y=!0);const c=await this.a.$computeEmbeddings($,a,R);if(c.length!==a.length)throw new Error;if(y){if(c.length!==1)throw new Error;return c[0]}return c}async $provideEmbeddings($,a,R){const y=this.b.get($);if(!y)return[];const c=await y.provider.provideEmbeddings(a,R);return c||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels($){this.d=new Set($),this.c.fire()}}e.$Hpc=A}),define(Ne[214],Oe([1,0,4,5]),function(we,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ypc=void 0;class C{constructor(A){this.b=0,this.a=A.getProxy(I.$sN.MainThreadLabelService)}$registerResourceLabelFormatter(A){const T=this.b++;return this.a.$registerResourceLabelFormatter(T,A),(0,v.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(T)})}}e.$Ypc=C}),define(Ne[85],Oe([1,0,20,12,2,3,11,5,26,16]),function(we,e,v,I,C,N,A,T,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ipc=e.$hpc=void 0;let R=class{constructor(c,S,f){this.f=f,this.d=new Map,this.a=S.getProxy(T.$sN.MainThreadLocalization),this.b=c.environment.appLanguage,this.c=this.b===v.$h}getMessage(c,S){const{message:f,args:n,comment:o}=S;if(this.c)return(0,I.$cf)(f,n??{});let s=f;o&&o.length>0&&(s+=`/${Array.isArray(o)?o.join(""):o}`);const l=this.d.get(c)?.contents[s];return l||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,I.$cf)(l??f,n??{})}getBundle(c){return this.d.get(c)?.contents}getBundleUri(c){return this.d.get(c)?.uri}async initializeLocalizedMessages(c){if(this.c||!c.l10n&&!c.isBuiltin||this.d.has(c.identifier.value))return;let S;const f=await this.g(c);if(!f){this.f.error(`No bundle location found for extension ${c.identifier.value}`);return}try{const n=await this.a.$fetchBundleContents(f),o=JSON.parse(n);S=c.isBuiltin?o.contents?.bundle:o}catch(n){this.f.error(`Failed to load translations for ${c.identifier.value} from ${f}: ${n.message}`);return}S&&this.d.set(c.identifier.value,{contents:S,uri:f})}async g(c){if(c.isBuiltin){const S=await this.a.$fetchBuiltInBundleUri(c.identifier.value,this.b);return C.URI.revive(S)}return c.l10n?C.URI.joinPath(c.extensionLocation,c.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$hpc=R,e.$hpc=R=Qe([qe(0,$.$eQ),qe(1,a.$1P),qe(2,A.$9j)],R),e.$ipc=(0,N.$Ci)("IExtHostLocalizationService")}),define(Ne[215],Oe([1,0,11,5,26,16,2,40]),function(we,e,v,I,C,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xqc=void 0;let $=class extends v.$hk{constructor(y,c){super(c.logLevel,c.logsLocation,c.loggers.map(S=>(0,T.$_h)(S))),this.r=y.getProxy(I.$sN.MainThreadLogger)}$setLogLevel(y,c){c?this.setLogLevel(A.URI.revive(c),y):this.setLogLevel(y)}setVisibility(y,c){super.setVisibility(y,c),this.r.$setVisibility(y,c)}s(y,c,S){return new a(this.r,y,c,S)}};e.$xqc=$,e.$xqc=$=Qe([qe(0,N.$1P),qe(1,C.$eQ)],$);class a extends v.$ck{constructor(y,c,S,f){super(f?.logLevel==="always"),this.r=y,this.s=c,this.m=!1,this.n=[],this.setLevel(S),this.r.$createLogger(c,f).then(()=>{this.u(this.n),this.m=!0})}g(y,c){const S=[[y,c]];this.m?this.u(S):this.n.push(...S)}u(y){this.r.$log(this.s,y)}flush(){this.r.$flush(this.s)}}}),define(Ne[86],Oe([1,0,5,3,4,16,22]),function(we,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kpc=e.$jpc=void 0,e.$jpc=(0,I.$Ci)("IExtHostManagedSockets");let T=class{constructor(y){this.b=0,this.c=null,this.d=new Map,this.a=y.getProxy(v.$sN.MainThreadManagedSockets)}setFactory(y,c){for(const S of this.d.values())S.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(y,c),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(y){if(!this.c||this.c.socketFactoryId!==y)throw new Error(`No socket factory with id ${y}`);const c=++this.b,S=await this.c.makeConnection(),f=new C.$Sc;return this.d.set(c,new a(c,S,f)),f.add((0,C.$Rc)(()=>this.d.delete(c))),f.add(S.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(c),f.dispose()})),f.add(S.onDidClose(n=>{this.a.$onDidManagedSocketClose(c,n?.stack??n?.message),f.dispose()})),f.add(S.onDidReceiveMessage(n=>this.a.$onDidManagedSocketHaveData(c,A.$Le.wrap(n)))),c}$remoteSocketWrite(y,c){this.d.get(y)?.actual.send(c.buffer)}$remoteSocketEnd(y){const c=this.d.get(y);c&&(c.actual.end(),c.dispose())}async $remoteSocketDrain(y){await this.d.get(y)?.actual.drain?.()}};e.$kpc=T,e.$kpc=T=Qe([qe(0,N.$1P)],T);class ${constructor(y,c){this.socketFactoryId=y,this.makeConnection=c}}class a extends C.$Tc{constructor(y,c,S){super(),this.socketId=y,this.actual=c,this.B(S)}}}),define(Ne[216],Oe([1,0,5,11,24]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2pc=void 0;function N(T){return T&&T.title}let A=class{constructor($,a){this.b=a,this.a=$.getProxy(v.$sN.MainThreadMessageService)}showMessage($,a,R,y,c){const S={source:{identifier:$.identifier,label:$.displayName||$.name}};let f;typeof y=="string"||N(y)?f=[y,...c]:(S.modal=y?.modal,S.useCustom=y?.useCustom,S.detail=y?.detail,f=c),S.useCustom&&(0,C.$5G)($,"resolvers");const n=[];let o=!1;for(let s=0;s<f.length;s++){const l=f[s];if(typeof l=="string")n.push({title:l,handle:s,isCloseAffordance:!1});else if(typeof l=="object"){const{title:i,isCloseAffordance:r}=l;n.push({title:i,isCloseAffordance:!!r,handle:s}),r&&(o?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,l):o=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,l)}return this.a.$showMessage(a,R,S,n).then(s=>{if(typeof s=="number")return f[s]})}};e.$2pc=A,e.$2pc=A=Qe([qe(1,I.$9j)],A)}),define(Ne[217],Oe([1,0,4,14,2,24,5]),function(we,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$pc=void 0;class T{constructor(a){this.b=new Map,this.a=a.getProxy(A.$sN.MainThreadProfileContentHandlers)}registerProfileContentHandler(a,R,y){if((0,N.$5G)(a,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,y),this.a.$registerProfileContentHandler(R,y.name,y.description,a.identifier.value),(0,v.$Rc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(a,R,y,c){const S=this.b.get(a);if(!S)throw new Error(`Unknown handler with id: ${a}`);return S.saveProfile(R,y,c)}async $readProfile(a,R,y){const c=this.b.get(a);if(!c)throw new Error(`Unknown handler with id: ${a}`);return c.readProfile((0,I.$cg)(R)?R:C.URI.revive(R),y)}}e.$$pc=T}),define(Ne[87],Oe([1,0,5,6,3]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fpc=e.$epc=void 0;class N{constructor(T){this.b=new I.$je,this.onDidChangePassword=this.b.event,this.a=T.getProxy(v.$sN.MainThreadSecretState)}async $onDidChangePassword(T){this.b.fire(T)}get(T,$){return this.a.$getPassword(T,$)}store(T,$,a){return this.a.$setPassword(T,$,a)}delete(T,$){return this.a.$deletePassword(T,$)}}e.$epc=N,e.$fpc=(0,C.$Ci)("IExtHostSecretState")}),define(Ne[218],Oe([1,0,21,4,5]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fqc=void 0;class N{static{this.a=1}constructor(T){this.c=new Map,this.d=new Map,this.f=new Map,this.b=T.getProxy(C.$sN.MainThreadSpeech)}async $createSpeechToTextSession(T,$,a){const R=this.c.get(T);if(!R)return;const y=new I.$Sc,c=new v.$ue;this.d.set($,c);const S=await R.provideSpeechToTextSession(c.token,a?{language:a}:void 0);S&&(y.add(S.onDidChange(f=>{c.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,f)})),y.add(c.token.onCancellationRequested(()=>y.dispose())))}async $cancelSpeechToTextSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}async $createTextToSpeechSession(T,$,a){const R=this.c.get(T);if(!R)return;const y=new I.$Sc,c=new v.$ue;this.d.set($,c);const S=await R.provideTextToSpeechSession(c.token,a?{language:a}:void 0);S&&(this.f.set($,S),y.add(S.onDidChange(f=>{c.token.isCancellationRequested||this.b.$emitTextToSpeechEvent($,f)})),y.add(c.token.onCancellationRequested(()=>y.dispose())))}async $synthesizeSpeech(T,$){this.f.get(T)?.synthesize($)}async $cancelTextToSpeechSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T),this.f.delete(T)}async $createKeywordRecognitionSession(T,$){const a=this.c.get(T);if(!a)return;const R=new I.$Sc,y=new v.$ue;this.d.set($,y);const c=await a.provideKeywordRecognitionSession(y.token);c&&(R.add(c.onDidChange(S=>{y.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,S)})),R.add(y.token.onCancellationRequested(()=>R.dispose())))}async $cancelKeywordRecognitionSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}registerProvider(T,$,a){const R=N.a++;return this.c.set(R,a),this.b.$registerProvider(R,$,{extension:T,displayName:T.value}),(0,I.$Rc)(()=>{this.b.$unregisterProvider(R),this.c.delete(R)})}}e.$fqc=N}),define(Ne[88],Oe([1,0,5,6,3]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8oc=e.$7oc=void 0;class N{constructor(T,$){this.c=$,this.b=new I.$je,this.onDidChangeStorage=this.b.event,this.a=T.getProxy(v.$sN.MainThreadStorage)}registerExtensionStorageKeysToSync(T,$){this.a.$registerExtensionStorageKeysToSync(T,$)}async initializeExtensionStorage(T,$,a){const R=await this.a.$initializeExtensionStorage(T,$);let y;return R&&(y=this.d(T,$,R)),y||a}setValue(T,$,a){return this.a.$setValue(T,$,a)}$acceptValue(T,$,a){const R=this.d(T,$,a);R&&this.b.fire({shared:T,key:$,value:R})}d(T,$,a){try{return JSON.parse(a)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${T}): ${R}`)}}}e.$7oc=N,e.$8oc=(0,C.$Ci)("IExtHostStorage")}),define(Ne[219],Oe([1,0,4,15,2,5]),function(we,e,v,I,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rqc=void 0;class A{static{this.a=new Set([I.Schemas.http,I.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(N.$sN.MainThreadUriOpeners)}registerExternalUriOpener($,a,R,y){if(this.c.has(a))throw new Error(`Opener with id '${a}' already registered`);const c=y.schemes.find(S=>!A.a.has(S));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this.c.set(a,R),this.b.$registerUriOpener(a,y.schemes,$,y.label),(0,v.$Rc)(()=>{this.c.delete(a),this.b.$unregisterUriOpener(a)})}async $canOpenUri($,a,R){const y=this.c.get($);if(!y)throw new Error(`Unknown opener with id: ${$}`);const c=C.URI.revive(a);return y.canOpenExternalUri(c,R)}async $openUri($,a,R){const y=this.c.get($);if(!y)throw new Error(`Unknown opener id: '${$}'`);return y.openExternalUri(C.URI.revive(a.resolvedUri),{sourceUri:C.URI.revive(a.sourceUri)},R)}}e.$rqc=A}),define(Ne[220],Oe([1,0,5,2,4,13,18]),function(we,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sqc=void 0;class T{static{this.a=0}constructor(a){this.c=new A.$on,this.d=new Map,this.b=a.getProxy(v.$sN.MainThreadUrls)}registerUriHandler(a,R){const y=a.identifier;if(this.c.has(y))throw new Error(`Protocol handler already registered for extension ${y}`);const c=T.a++;return this.c.add(y),this.d.set(c,R),this.b.$registerUriHandler(c,y,a.displayName||a.name),(0,C.$Rc)(()=>{this.c.delete(y),this.d.delete(c),this.b.$unregisterUriHandler(c)})}$handleExternalUri(a,R){const y=this.d.get(a);if(!y)return Promise.resolve(void 0);try{y.handleUri(I.URI.revive(R))}catch(c){(0,N.$Y)(c)}return Promise.resolve(void 0)}async createAppUri(a){return I.URI.revive(await this.b.$createAppUri(a))}}e.$sqc=T}),define(Ne[221],Oe([1,0,22,5]),function(we,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$utb=N,e.$vtb=T,I=Ve(I);class C{constructor(){this.buffers=[]}add(a){let R=this.buffers.indexOf(a);return R<0&&(R=this.buffers.length,this.buffers.push(a)),R}}function N($,a){if(a.serializeBuffersForPostMessage){const R=new C,c=JSON.stringify($,(f,n)=>{if(n instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:R.add(n)};if(ArrayBuffer.isView(n)){const o=A(n);if(o)return{$$vscode_array_buffer_reference$$:!0,index:R.add(n.buffer),view:{type:o,byteLength:n.byteLength,byteOffset:n.byteOffset}}}return n}),S=R.buffers.map(f=>{const n=new Uint8Array(f);return v.$Le.wrap(n)});return{message:c,buffers:S}}else return{message:JSON.stringify($),buffers:[]}}function A($){switch($.constructor.name){case"Int8Array":return I.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return I.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return I.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return I.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return I.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return I.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return I.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return I.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return I.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return I.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return I.WebviewMessageArrayBufferViewType.BigUint64Array}}function T($,a){const R=a.map(S=>{const f=new ArrayBuffer(S.byteLength);return new Uint8Array(f).set(S.buffer),f}),y=a.length?(S,f)=>{if(f&&typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const n=f,{index:o}=n,s=R[o];if(n.view)switch(n.view.type){case I.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(s,n.view.byteOffset,n.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(s,n.view.byteOffset,n.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(s,n.view.byteOffset,n.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(s,n.view.byteOffset,n.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(s,n.view.byteOffset,n.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(s,n.view.byteOffset,n.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(s,n.view.byteOffset,n.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(s,n.view.byteOffset,n.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(s,n.view.byteOffset,n.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(s,n.view.byteOffset,n.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(s,n.view.byteOffset,n.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return s}return f}:void 0;return{message:JSON.parse($,y),arrayBuffers:R}}}),define(Ne[67],Oe([1,0,6,4,15,25,2,174,221,82,5]),function(we,e,v,I,C,N,A,T,$,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Toc=e.$Roc=void 0,e.$Soc=c,e.$Uoc=n,e.$Voc=o,N=Ve(N),R=Ve(R);class y{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;constructor(r,t,g,u,p,m,d){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new v.$je,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new v.$je,this._onDidDispose=this.#h.event,this.#e=r,this.#t=t,this.#o=g,this.#n=u,this.#s=p,this.#r=m,this.#u=c(m),this.#d=S(m),this.#i=d}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(r){return this.#l=!0,(0,a.$eDb)(r,this.#n)}get cspSource(){const r=this.#r.extensionLocation;if(r.scheme===C.Schemas.https||r.scheme===C.Schemas.http){let t=r.toString();return t.endsWith("/")||(t+="/"),t+" "+a.$dDb}return a.$dDb}get html(){return this.a(),this.#a}set html(r){this.a(),this.#a!==r&&(this.#a=r,this.#d&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(r)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(r)))}get options(){return this.a(),this.#o}set options(r){this.a(),N.$eo(this.#o,r)||this.#t.$setOptions(this.#e,o(this.#r,this.#s,r)),this.#o=r}async postMessage(r){if(this.#c)return!1;const t=(0,$.$utb)(r,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(r){if(!this.#d)return r;const t=this.#r.extensionLocation?.scheme===C.Schemas.vscodeRemote,g=this.#r.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return r.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,p,m,d,E,D)=>{const w=A.URI.from({scheme:d||"file",path:decodeURIComponent(E)}),k=(0,a.$eDb)(w,{isRemote:t,authority:g}).toString();return`${p}${k}${D}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,p,m,d,E,D)=>{const w=A.URI.from({scheme:d||"file",path:decodeURIComponent(E)}),k=(0,a.$eDb)(w,{isRemote:t,authority:g}).toString();return`${p}${k}${D}`})}}e.$Roc=y;function c(i){try{const r=(0,T.$Xp)((0,T.$Wp)(i.engines.vscode));return!!r&&r.majorBase>=1&&r.minorBase>=57}catch{return!1}}function S(i){try{const r=(0,T.$Xp)((0,T.$Wp)(i.engines.vscode));return r?r.majorBase<1||r.majorBase===1&&r.minorBase<60:!1}catch{return!1}}class f extends I.$Tc{constructor(r,t,g,u,p){super(),this.c=t,this.f=g,this.g=u,this.h=p,this.b=new Map,this.a=r.getProxy(R.$sN.MainThreadWebviews)}dispose(){super.dispose();for(const r of this.b.values())r.dispose();this.b.clear()}$onMessage(r,t,g){const u=this.j(r);if(u){const{message:p}=(0,$.$vtb)(t,g.value);u._onMessageEmitter.fire(p)}}$onMissingCsp(r,t){this.g.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(r,t,g){const u=new y(r,this.a,s(t),this.c,this.f,g,this.h);this.b.set(r,u);const p=u._onDidDispose(()=>{p.dispose(),this.deleteWebview(r)});return u}deleteWebview(r){this.b.delete(r)}j(r){return this.b.get(r)}}e.$Toc=f;function n(i){return{id:i.identifier,location:i.extensionLocation}}function o(i,r,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||l(i,r)}}function s(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(r=>A.URI.from(r))}}function l(i,r){return[...(r?.getWorkspaceFolders()||[]).map(t=>t.uri),i.extensionLocation]}}),define(Ne[121],Oe([1,0,6,15,12,2,3,16,5]),function(we,e,v,I,C,N,A,T,$){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$vqc=e.$uqc=void 0;let R=class{static{a=this}static{this.a={focused:!0,active:!0}}getState(){const c=this.d;return{get focused(){return c.focused},get active(){return c.active}}}constructor(c){this.c=new v.$je,this.onDidChangeWindowState=this.c.event,this.d=a.a,this.b=c.getProxy($.$sN.MainThreadWindow),this.b.$getInitialState().then(({isFocused:S,isActive:f})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",f)})}$onDidChangeWindowFocus(c){this.onDidChangeWindowProperty("focused",c)}$onDidChangeWindowActive(c){this.onDidChangeWindowProperty("active",c)}onDidChangeWindowProperty(c,S){S!==this.d[c]&&(this.d={...this.d,[c]:S},this.c.fire(this.d))}openUri(c,S){let f;if(typeof c=="string"){f=c;try{c=N.URI.parse(c)}catch{return Promise.reject(`Invalid uri - '${c}'`)}}return(0,C.$af)(c.scheme)?Promise.reject("Invalid scheme - cannot be empty"):c.scheme===I.Schemas.command?Promise.reject(`Invalid scheme '${c.scheme}'`):this.b.$openUri(c,f,S)}async asExternalUri(c,S){if((0,C.$af)(c.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this.b.$asExternalUri(c,S);return N.URI.from(f)}};e.$uqc=R,e.$uqc=R=a=Qe([qe(0,T.$1P)],R),e.$vqc=(0,A.$Ci)("IExtHostWindow")}),define(Ne[222],Oe([1,0,211,26,16]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Isc=void 0;let N=class extends v.$yqc{constructor(T,$){super(T,$)}f(T,$,a){$.apply(console,a)}};e.$Isc=N,e.$Isc=N=Qe([qe(0,C.$1P),qe(1,I.$eQ)],N)}),define(Ne[223],Oe([1,0,10,22,21,27,13,6,4,36,149,209,38]),function(we,e,v,I,C,N,A,T,$,a,R,y,c){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Wcc=e.ResponsiveState=e.RequestInitiator=void 0,e.$Ucc=l,e.$Vcc=i,A=Ve(A);function f(M,O){try{return JSON.stringify(M,O)}catch{return"null"}}const n="$$ref$$",o={[n]:-1};class s{constructor(O,F){this.jsonString=O,this.referencedBuffers=F}}function l(M,O=null,F=!1){const q=[];return{jsonString:(F?f:JSON.stringify)(M,(L,Y)=>{if(typeof Y>"u")return o;if(typeof Y=="object"){if(Y instanceof I.$Le){const Z=q.push(Y)-1;return{[n]:Z}}if(O)return O(L,Y)}return Y}),referencedBuffers:q}}function i(M,O,F){return JSON.parse(M,(q,B)=>{if(B){const L=B[n];if(typeof L=="number")return O[L];if(F&&B.$mid===a.MarshalledId.Uri)return F.transformIncoming(B)}return B})}function r(M,O){return JSON.stringify(M,O)}function t(M){return M?(O,F)=>F&&F.$mid===a.MarshalledId.Uri?M.transformOutgoing(F):F:null}var g;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(g||(e.RequestInitiator=g={}));var u;(function(M){M[M.Responsive=0]="Responsive",M[M.Unresponsive=1]="Unresponsive"})(u||(e.ResponsiveState=u={}));const p=()=>{},m=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class E extends $.$Tc{static{S=m}static{this.a=3*1e3}constructor(O,F=null,q=null){super(),this[S]=!0,this.b=this.B(new T.$je),this.onDidChangeResponsiveState=this.b.event,this.c=O,this.f=F,this.g=q,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let B=0,L=c.$Pw.count;B<L;B++)this.m[B]=null,this.s[B]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=u.Responsive,this.z=0,this.C=0,this.D=this.B(new v.$Oh(()=>this.H(),1e3)),this.B(this.c.onMessage(B=>this.L(B)))}dispose(){this.j=!0,Object.keys(this.w).forEach(O=>{const F=this.w[O];delete this.w[O],F.resolveErr(A.$5())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(O){this.z===0&&(this.C=Date.now()+E.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(O){this.C=Date.now()+E.a,this.z--,this.z===0&&this.D.cancel(),this.I(u.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(u.Unresponsive):this.D.schedule())}I(O){this.y!==O&&(this.y=O,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(O){return this.g?(0,R.$Ln)(O,this.g):O}getProxy(O){const{nid:F,sid:q}=O;return this.s[F]||(this.s[F]=this.J(F,q)),this.s[F]}J(O,F){const q={get:(B,L)=>(typeof L=="string"&&!B[L]&&L.charCodeAt(0)===N.CharCode.DollarSign&&(B[L]=(...Y)=>this.U(O,L,Y)),L===d?F:B[L])};return new Proxy(Object.create(null),q)}set(O,F){return this.m[O.nid]=F,F}assertRegistered(O){for(let F=0,q=O.length;F<q;F++){const B=O[F];if(!this.m[B.nid])throw new Error(`Missing proxy instance ${B.sid}`)}}L(O){if(this.j)return;const F=O.byteLength,q=w.read(O,0),B=q.readUInt8(),L=q.readUInt32();switch(B){case h.RequestJSONArgs:case h.RequestJSONArgsWithCancellation:{let{rpcId:Y,method:Z,args:fe}=P.deserializeRequestJSONArgs(q);this.g&&(fe=(0,R.$Ln)(fe,this.g)),this.M(F,L,Y,Z,fe,B===h.RequestJSONArgsWithCancellation);break}case h.RequestMixedArgs:case h.RequestMixedArgsWithCancellation:{let{rpcId:Y,method:Z,args:fe}=P.deserializeRequestMixedArgs(q);this.g&&(fe=(0,R.$Ln)(fe,this.g)),this.M(F,L,Y,Z,fe,B===h.RequestMixedArgsWithCancellation);break}case h.Acknowledged:{this.f?.logIncoming(F,L,g.LocalSide,"ack"),this.G(L);break}case h.Cancel:{this.N(F,L);break}case h.ReplyOKEmpty:{this.O(F,L,void 0);break}case h.ReplyOKJSON:{let Y=P.deserializeReplyOKJSON(q);this.g&&(Y=(0,R.$Ln)(Y,this.g)),this.O(F,L,Y);break}case h.ReplyOKJSONWithBuffers:{const Y=P.deserializeReplyOKJSONWithBuffers(q,this.g);this.O(F,L,Y);break}case h.ReplyOKVSBuffer:{const Y=P.deserializeReplyOKVSBuffer(q);this.O(F,L,Y);break}case h.ReplyErrError:{let Y=P.deserializeReplyErrError(q);this.g&&(Y=(0,R.$Ln)(Y,this.g)),this.P(F,L,Y);break}case h.ReplyErrEmpty:{this.P(F,L,void 0);break}default:console.error("received unexpected message"),console.error(O)}}M(O,F,q,B,L,Y){this.f?.logIncoming(O,F,g.OtherSide,`receiveRequest ${(0,c.$Rw)(q)}.${B}(`,L);const Z=String(F);let fe,_;if(Y){const se=new C.$ue;L.push(se.token),fe=this.Q(q,B,L),_=()=>se.cancel()}else fe=this.Q(q,B,L),_=p;this.u[Z]=_;const ge=P.serializeAcknowledged(F);this.f?.logOutgoing(ge.byteLength,F,g.OtherSide,"ack"),this.c.send(ge),fe.then(se=>{delete this.u[Z];const ae=P.serializeReplyOK(F,se,this.h);this.f?.logOutgoing(ae.byteLength,F,g.OtherSide,"reply:",se),this.c.send(ae)},se=>{delete this.u[Z];const ae=P.serializeReplyErr(F,se);this.f?.logOutgoing(ae.byteLength,F,g.OtherSide,"replyErr:",se),this.c.send(ae)})}N(O,F){this.f?.logIncoming(O,F,g.OtherSide,"receiveCancel");const q=String(F);this.u[q]?.()}O(O,F,q){this.f?.logIncoming(O,F,g.LocalSide,"receiveReply:",q);const B=String(F);if(!this.w.hasOwnProperty(B))return;const L=this.w[B];delete this.w[B],L.resolveOk(q)}P(O,F,q){this.f?.logIncoming(O,F,g.LocalSide,"receiveReplyErr:",q);const B=String(F);if(!this.w.hasOwnProperty(B))return;const L=this.w[B];delete this.w[B];let Y;q&&(q.$isError?(Y=new Error,Y.name=q.name,Y.message=q.message,Y.stack=q.stack):Y=q),L.resolveErr(Y)}Q(O,F,q){try{return Promise.resolve(this.S(O,F,q))}catch(B){return Promise.reject(B)}}S(O,F,q){const B=this.m[O];if(!B)throw new Error("Unknown actor "+(0,c.$Rw)(O));const L=B[F];if(typeof L!="function")throw new Error("Unknown method "+F+" on actor "+(0,c.$Rw)(O));return L.apply(B,q)}U(O,F,q){if(this.j)return new y.$Tcc;let B=null;if(q.length>0&&C.CancellationToken.isCancellationToken(q[q.length-1])&&(B=q.pop()),B&&B.isCancellationRequested)return Promise.reject(A.$5());const L=P.serializeRequestArguments(q,this.h),Y=++this.t,Z=String(Y),fe=new y.$Scc,_=new $.$Sc;B&&_.add(B.onCancellationRequested(()=>{const se=P.serializeCancel(Y);this.f?.logOutgoing(se.byteLength,Y,g.LocalSide,"cancel"),this.c.send(P.serializeCancel(Y))})),this.w[Z]=new D(fe,_),this.F(Y);const ge=P.serializeRequest(Y,O,F,L,!!B);return this.f?.logOutgoing(ge.byteLength,Y,g.LocalSide,`request: ${(0,c.$Rw)(O)}.${F}(`,q),this.c.send(ge),fe}}e.$Wcc=E;class D{constructor(O,F){this.a=O,this.b=F}resolveOk(O){this.a.resolveOk(O),this.b.dispose()}resolveErr(O){this.a.resolveErr(O),this.b.dispose()}}class w{static alloc(O,F,q){const B=new w(I.$Le.alloc(q+1+4),0);return B.writeUInt8(O),B.writeUInt32(F),B}static read(O,F){return new w(O,F)}get buffer(){return this.a}constructor(O,F){this.a=O,this.b=F}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(O){this.a.writeUInt8(O,this.b),this.b+=1}readUInt8(){const O=this.a.readUInt8(this.b);return this.b+=1,O}writeUInt32(O){this.a.writeUInt32BE(O,this.b),this.b+=4}readUInt32(){const O=this.a.readUInt32BE(this.b);return this.b+=4,O}static sizeShortString(O){return 1+O.byteLength}writeShortString(O){this.a.writeUInt8(O.byteLength,this.b),this.b+=1,this.a.set(O,this.b),this.b+=O.byteLength}readShortString(){const O=this.a.readUInt8(this.b);this.b+=1;const q=this.a.slice(this.b,this.b+O).toString();return this.b+=O,q}static sizeLongString(O){return 4+O.byteLength}writeLongString(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}readLongString(){const O=this.a.readUInt32BE(this.b);this.b+=4;const q=this.a.slice(this.b,this.b+O).toString();return this.b+=O,q}writeBuffer(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}static sizeVSBuffer(O){return 4+O.byteLength}writeVSBuffer(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}readVSBuffer(){const O=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+O);return this.b+=O,F}static sizeMixedArray(O){let F=0;F+=1;for(let q=0,B=O.length;q<B;q++){const L=O[q];switch(F+=1,L.type){case b.String:F+=this.sizeLongString(L.value);break;case b.VSBuffer:F+=this.sizeVSBuffer(L.value);break;case b.SerializedObjectWithBuffers:F+=this.sizeUInt32,F+=this.sizeLongString(L.value);for(let Y=0;Y<L.buffers.length;++Y)F+=this.sizeVSBuffer(L.buffers[Y]);break;case b.Undefined:break}}return F}writeMixedArray(O){this.a.writeUInt8(O.length,this.b),this.b+=1;for(let F=0,q=O.length;F<q;F++){const B=O[F];switch(B.type){case b.String:this.writeUInt8(b.String),this.writeLongString(B.value);break;case b.VSBuffer:this.writeUInt8(b.VSBuffer),this.writeVSBuffer(B.value);break;case b.SerializedObjectWithBuffers:this.writeUInt8(b.SerializedObjectWithBuffers),this.writeUInt32(B.buffers.length),this.writeLongString(B.value);for(let L=0;L<B.buffers.length;++L)this.writeBuffer(B.buffers[L]);break;case b.Undefined:this.writeUInt8(b.Undefined);break}}}readMixedArray(){const O=this.a.readUInt8(this.b);this.b+=1;const F=new Array(O);for(let q=0;q<O;q++)switch(this.readUInt8()){case b.String:F[q]=this.readLongString();break;case b.VSBuffer:F[q]=this.readVSBuffer();break;case b.SerializedObjectWithBuffers:{const L=this.readUInt32(),Y=this.readLongString(),Z=[];for(let fe=0;fe<L;++fe)Z.push(this.readVSBuffer());F[q]=new c.$Sw(i(Y,Z,null));break}case b.Undefined:F[q]=void 0;break}return F}}var k;(function(M){M[M.Simple=0]="Simple",M[M.Mixed=1]="Mixed"})(k||(k={}));class P{static a(O){for(let F=0,q=O.length;F<q;F++)if(O[F]instanceof I.$Le||O[F]instanceof c.$Sw||typeof O[F]>"u")return!0;return!1}static serializeRequestArguments(O,F){if(this.a(O)){const q=[];for(let B=0,L=O.length;B<L;B++){const Y=O[B];if(Y instanceof I.$Le)q[B]={type:b.VSBuffer,value:Y};else if(typeof Y>"u")q[B]={type:b.Undefined};else if(Y instanceof c.$Sw){const{jsonString:Z,referencedBuffers:fe}=l(Y.value,F);q[B]={type:b.SerializedObjectWithBuffers,value:I.$Le.fromString(Z),buffers:fe}}else q[B]={type:b.String,value:I.$Le.fromString(r(Y,F))}}return{type:k.Mixed,args:q}}return{type:k.Simple,args:r(O,F)}}static serializeRequest(O,F,q,B,L){switch(B.type){case k.Simple:return this.b(O,F,q,B.args,L);case k.Mixed:return this.c(O,F,q,B.args,L)}}static b(O,F,q,B,L){const Y=I.$Le.fromString(q),Z=I.$Le.fromString(B);let fe=0;fe+=w.sizeUInt8(),fe+=w.sizeShortString(Y),fe+=w.sizeLongString(Z);const _=w.alloc(L?h.RequestJSONArgsWithCancellation:h.RequestJSONArgs,O,fe);return _.writeUInt8(F),_.writeShortString(Y),_.writeLongString(Z),_.buffer}static deserializeRequestJSONArgs(O){const F=O.readUInt8(),q=O.readShortString(),B=O.readLongString();return{rpcId:F,method:q,args:JSON.parse(B)}}static c(O,F,q,B,L){const Y=I.$Le.fromString(q);let Z=0;Z+=w.sizeUInt8(),Z+=w.sizeShortString(Y),Z+=w.sizeMixedArray(B);const fe=w.alloc(L?h.RequestMixedArgsWithCancellation:h.RequestMixedArgs,O,Z);return fe.writeUInt8(F),fe.writeShortString(Y),fe.writeMixedArray(B),fe.buffer}static deserializeRequestMixedArgs(O){const F=O.readUInt8(),q=O.readShortString(),B=O.readMixedArray(),L=new Array(B.length);for(let Y=0,Z=B.length;Y<Z;Y++){const fe=B[Y];typeof fe=="string"?L[Y]=JSON.parse(fe):L[Y]=fe}return{rpcId:F,method:q,args:L}}static serializeAcknowledged(O){return w.alloc(h.Acknowledged,O,0).buffer}static serializeCancel(O){return w.alloc(h.Cancel,O,0).buffer}static serializeReplyOK(O,F,q){if(typeof F>"u")return this.d(O);if(F instanceof I.$Le)return this.e(O,F);if(F instanceof c.$Sw){const{jsonString:B,referencedBuffers:L}=l(F.value,q,!0);return this.g(O,B,L)}else return this.f(O,f(F,q))}static d(O){return w.alloc(h.ReplyOKEmpty,O,0).buffer}static e(O,F){let q=0;q+=w.sizeVSBuffer(F);const B=w.alloc(h.ReplyOKVSBuffer,O,q);return B.writeVSBuffer(F),B.buffer}static deserializeReplyOKVSBuffer(O){return O.readVSBuffer()}static f(O,F){const q=I.$Le.fromString(F);let B=0;B+=w.sizeLongString(q);const L=w.alloc(h.ReplyOKJSON,O,B);return L.writeLongString(q),L.buffer}static g(O,F,q){const B=I.$Le.fromString(F);let L=0;L+=w.sizeUInt32,L+=w.sizeLongString(B);for(const Z of q)L+=w.sizeVSBuffer(Z);const Y=w.alloc(h.ReplyOKJSONWithBuffers,O,L);Y.writeUInt32(q.length),Y.writeLongString(B);for(const Z of q)Y.writeBuffer(Z);return Y.buffer}static deserializeReplyOKJSON(O){const F=O.readLongString();return JSON.parse(F)}static deserializeReplyOKJSONWithBuffers(O,F){const q=O.readUInt32(),B=O.readLongString(),L=[];for(let Y=0;Y<q;++Y)L.push(O.readVSBuffer());return new c.$Sw(i(B,L,F))}static serializeReplyErr(O,F){const q=F?f(A.$1(F),null):void 0;if(typeof q!="string")return this.h(O);const B=I.$Le.fromString(q);let L=0;L+=w.sizeLongString(B);const Y=w.alloc(h.ReplyErrError,O,L);return Y.writeLongString(B),Y.buffer}static deserializeReplyErrError(O){const F=O.readLongString();return JSON.parse(F)}static h(O){return w.alloc(h.ReplyErrEmpty,O,0).buffer}}var h;(function(M){M[M.RequestJSONArgs=1]="RequestJSONArgs",M[M.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",M[M.RequestMixedArgs=3]="RequestMixedArgs",M[M.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",M[M.Acknowledged=5]="Acknowledged",M[M.Cancel=6]="Cancel",M[M.ReplyOKEmpty=7]="ReplyOKEmpty",M[M.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",M[M.ReplyOKJSON=9]="ReplyOKJSON",M[M.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",M[M.ReplyErrError=11]="ReplyErrError",M[M.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var b;(function(M){M[M.String=1]="String",M[M.VSBuffer=2]="VSBuffer",M[M.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",M[M.Undefined=4]="Undefined"})(b||(b={}))}),define(Ne[224],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ksc=void 0;const v=function(N){const A=T=>{globalThis.removeEventListener("message",A);const $=T.data;Object.defineProperties(globalThis,{postMessage:{value(a,R){$.postMessage(a,R)}},onmessage:{get(){return $.onmessage},set(a){$.onmessage=a}}}),$.addEventListener("message",a=>{globalThis.dispatchEvent(new MessageEvent("message",{data:a.data,ports:a.ports?[...a.ports]:void 0}))}),$.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(N)};globalThis.addEventListener("message",A)}.toString();class I extends EventTarget{constructor(N,A,T){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const $=`((${v})('${A}'))`,a=new Blob([$],{type:"application/javascript"}),R=URL.createObjectURL(a),y=new MessageChannel,c=R,S={type:"_newWorker",id:c,port:y.port2,url:R,options:T};N(S,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{N({type:"_terminateWorker",id:c}),URL.revokeObjectURL(R),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(f){y.port1.onmessage=f}},onmessageerror:{get(){return y.port1.onmessageerror},set(f){y.port1.onmessageerror=f}}}),y.port1.addEventListener("messageerror",f=>{const n=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(n)}),y.port1.addEventListener("message",f=>{const n=new MessageEvent("message",{data:f.data});this.dispatchEvent(n)}),y.port1.start()}}e.$Ksc=I}),define(Ne[225],Oe([1,0,22,28,15,60,3]),function(we,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fL=e.$cL=void 0,e.$dL=R,e.$eL=y,e.$cL=(0,A.$Ci)("notebookDocumentService");const T=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${T.join("")}]+`),a=7;function R(S){if(S.scheme!==C.Schemas.vscodeNotebookCell)return;const f=S.fragment.indexOf("s");if(f<0)return;const n=parseInt(S.fragment.substring(0,f).replace($,""),a),o=(0,v.$5e)(S.fragment.substring(f+1)).toString();if(!isNaN(n))return{handle:n,notebook:S.with({scheme:o,fragment:null})}}function y(S,f){const n=f.toString(a),s=`${n.length<T.length?T[n.length-1]:"z"}${n}s${(0,v.$6e)(v.$Le.fromString(S.scheme),!0,!0)}`;return S.with({scheme:C.Schemas.vscodeNotebookCell,fragment:s})}class c{constructor(){this.a=new I.$zc}getNotebook(f){if(f.scheme===C.Schemas.vscodeNotebookCell){const n=R(f);if(n){const o=this.a.get(n.notebook);if(o)return o}}return this.a.get(f)}addNotebookDocument(f){this.a.set(f.uri,f)}removeNotebookDocument(f){this.a.delete(f.uri)}}e.$fL=c,(0,N.$Ns)(e.$cL,c,N.InstantiationType.Delayed)}),define(Ne[89],Oe([1,0,22,41,39,72,15,19,20,31,225]),function(we,e,v,I,C,N,A,T,$,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zL=e.$wL=e.CellStatusbarAlignment=e.$vL=e.NotebookFindScopeType=e.NotebookEditorPriority=e.$sL=e.$rL=e.$pL=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$oL=e.$nL=e.$mL=e.$lL=e.CellKind=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=void 0,e.$qL=u,e.$tL=d,e.$uL=E,e.$xL=k,e.$yL=h,I=Ve(I),e.$gL="workbench.editor.notebook",e.$hL="workbench.editor.notebookTextDiffEditor",e.$iL="workbench.editor.interactive",e.$jL="workbench.editor.repl",e.$kL="replNotebook.input.execute";var y;(function(Z){Z[Z.Markup=1]="Markup",Z[Z.Code=2]="Code"})(y||(e.CellKind=y={})),e.$lL=["application/json","application/javascript","text/html","image/svg+xml",N.$7s.latex,N.$7s.markdown,"image/png","image/jpeg",N.$7s.text],e.$mL=[N.$7s.latex,N.$7s.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",N.$7s.text],e.$nL=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$oL="_notAvailable";var c;(function(Z){Z[Z.Running=1]="Running",Z[Z.Idle=2]="Idle"})(c||(e.NotebookRunState=c={}));var S;(function(Z){Z[Z.Unconfirmed=1]="Unconfirmed",Z[Z.Pending=2]="Pending",Z[Z.Executing=3]="Executing"})(S||(e.NotebookCellExecutionState=S={}));var f;(function(Z){Z[Z.Unconfirmed=1]="Unconfirmed",Z[Z.Pending=2]="Pending",Z[Z.Executing=3]="Executing"})(f||(e.NotebookExecutionState=f={}));var n;(function(Z){Z[Z.WithHardKernelDependency=0]="WithHardKernelDependency",Z[Z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",Z[Z.Pure=2]="Pure",Z[Z.Never=3]="Never"})(n||(e.NotebookRendererMatch=n={}));var o;(function(Z){Z.Always="always",Z.Never="never",Z.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var s;(function(Z){Z[Z.ModelChange=1]="ModelChange",Z[Z.Move=2]="Move",Z[Z.ChangeCellLanguage=5]="ChangeCellLanguage",Z[Z.Initialize=6]="Initialize",Z[Z.ChangeCellMetadata=7]="ChangeCellMetadata",Z[Z.Output=8]="Output",Z[Z.OutputItem=9]="OutputItem",Z[Z.ChangeCellContent=10]="ChangeCellContent",Z[Z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",Z[Z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",Z[Z.ChangeCellMime=13]="ChangeCellMime",Z[Z.Unknown=100]="Unknown"})(s||(e.NotebookCellsChangeType=s={}));var l;(function(Z){Z[Z.Handle=0]="Handle",Z[Z.Index=1]="Index"})(l||(e.SelectionStateType=l={}));var i;(function(Z){Z[Z.Replace=1]="Replace",Z[Z.Output=2]="Output",Z[Z.Metadata=3]="Metadata",Z[Z.CellLanguage=4]="CellLanguage",Z[Z.DocumentMetadata=5]="DocumentMetadata",Z[Z.Move=6]="Move",Z[Z.OutputItems=7]="OutputItems",Z[Z.PartialMetadata=8]="PartialMetadata",Z[Z.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var r;(function(Z){Z.scheme=A.Schemas.vscodeNotebookCell;function fe(oe,Ce){return(0,R.$eL)(oe,Ce)}Z.generate=fe;function _(oe){return(0,R.$dL)(oe)}Z.parse=_;function ge(oe,Ce){return oe.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${Ce??""},${oe.scheme!==A.Schemas.file?oe.scheme:""}`})}Z.generateCellOutputUri=ge;function se(oe){if(oe.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const Ce=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(oe.fragment);if(!Ce)return;const Fe=Ce[1]&&Ce[1]!==""?Ce[1]:void 0,X=Ce[2];return{outputId:Fe,notebook:oe.with({scheme:X||A.Schemas.file,fragment:null})}}Z.parseCellOutputUri=se;function ae(oe,Ce,Fe){return Z.generate(oe,Ce).with({scheme:Fe})}Z.generateCellPropertyUri=ae;function $e(oe,Ce){if(oe.scheme===Ce)return Z.parse(oe.with({scheme:Z.scheme}))}Z.parseCellPropertyUri=$e})(r||(e.CellUri=r={}));const t=Z=>$.$j?Z.replace(/\//g,"\\"):Z;class g{constructor(fe=[],_=e.$lL){this.e=_,this.d=[...new Set(fe)].map(ge=>({pattern:ge,matches:I.$wk(t(ge))}))}sort(fe){const _=new Map(C.Iterable.map(fe,se=>[se,t(se)]));let ge=[];for(const{matches:se}of this.d)for(const[ae,$e]of _)if(se($e)){ge.push(ae),_.delete(ae);break}return _.size&&(ge=ge.concat([..._.keys()].sort((se,ae)=>this.e.indexOf(se)-this.e.indexOf(ae)))),ge}prioritize(fe,_){const ge=this.f(fe);if(ge===-1){this.d.unshift({pattern:fe,matches:I.$wk(t(fe))});return}const se=new Set(_.map($e=>this.f($e,ge)));se.delete(-1);const ae=Array.from(se).sort();this.d.splice(ge+1,0,...ae.map($e=>this.d[$e]));for(let $e=ae.length-1;$e>=0;$e--)this.d.splice(ae[$e],1)}toArray(){return this.d.map(fe=>fe.pattern)}f(fe,_=this.d.length){const ge=t(fe);for(let se=0;se<_;se++)if(this.d[se].matches(ge))return se;return-1}}e.$pL=g;function u(Z,fe,_,ge=(se,ae)=>se===ae){const se=[];function ae(Ce,Fe,X){if(Fe===0&&X.length===0)return;const V=se[se.length-1];V&&V.start+V.deleteCount===Ce?(V.deleteCount+=Fe,V.toInsert.push(...X)):se.push({start:Ce,deleteCount:Fe,toInsert:X})}let $e=0,oe=0;for(;;){if($e===Z.length){ae($e,0,fe.slice(oe));break}if(oe===fe.length){ae($e,Z.length-$e,[]);break}const Ce=Z[$e],Fe=fe[oe];if(ge(Ce,Fe)){$e+=1,oe+=1;continue}_(Fe)?(ae($e,1,[]),$e+=1):(ae($e,0,[Fe]),oe+=1)}return se}e.$rL=new a.$Tj("notebookEditorCursorAtBoundary","none"),e.$sL=new a.$Tj("notebookEditorCursorAtLineBoundary","none");var p;(function(Z){Z.default="default",Z.option="option"})(p||(e.NotebookEditorPriority=p={}));var m;(function(Z){Z.Cells="cells",Z.Text="text",Z.None="none"})(m||(e.NotebookFindScopeType=m={}));function d(Z){const fe=Z;return!!((typeof fe.include=="string"||I.$xk(fe.include))&&(typeof fe.exclude=="string"||I.$xk(fe.exclude)))}function E(Z,fe,_){if(Array.isArray(Z.viewType)&&Z.viewType.indexOf(fe)>=0||Z.viewType===fe)return!0;if(Z.filenamePattern){const ge=d(Z.filenamePattern)?Z.filenamePattern.include:Z.filenamePattern,se=d(Z.filenamePattern)?Z.filenamePattern.exclude:void 0;if(I.$vk(ge,(0,T.$mc)(_.fsPath).toLowerCase()))return!(se&&I.$vk(se,(0,T.$mc)(_.fsPath).toLowerCase()))}return!1}e.$vL={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var D;(function(Z){Z[Z.Left=1]="Left",Z[Z.Right=2]="Right"})(D||(e.CellStatusbarAlignment=D={}));class w{static{this.d="notebook/"}static create(fe){return`${w.d}${fe}`}static parse(fe){if(fe.startsWith(w.d))return fe.substring(w.d.length)}}e.$wL=w;function k(Z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(Z)}const P=new TextDecoder;function h(Z){const fe=[];let _=!1;for(const $e of Z)(fe.length===0||_)&&(fe.push($e),_=!0);let ge=O(fe);const se=v.$Le.concat(fe.map($e=>v.$Le.wrap($e))),ae=Y(se);return ge=ge||ae.byteLength!==se.byteLength,{data:ae,didCompression:ge}}e.$zL="\x1B[A";const b=e.$zL.split("").map(Z=>Z.charCodeAt(0)),M=10;function O(Z){let fe=!1;return Z.forEach((_,ge)=>{if(ge===0||_.length<e.$zL.length)return;const se=Z[ge-1],ae=_.subarray(0,e.$zL.length);if(ae[0]===b[0]&&ae[1]===b[1]&&ae[2]===b[2]){const $e=se.lastIndexOf(M);if($e===-1)return;fe=!0,Z[ge-1]=se.subarray(0,$e),Z[ge]=_.subarray(e.$zL.length)}}),fe}function F(Z){let fe=Z;do Z=fe,fe=Z.replace(/[^\n]\x08/gm,"");while(fe.length<Z.length);return Z}function q(Z){for(Z=Z.replace(/\r+\n/gm,`
`);Z.search(/\r[^$]/g)>-1;){const fe=Z.match(/^(.*)\r+/m)[1];let _=Z.match(/\r+(.*)$/m)[1];_=_+fe.slice(_.length,fe.length),Z=Z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,_)}return Z}const B=8,L=13;function Y(Z){return!Z.buffer.includes(B)&&!Z.buffer.includes(L)?Z:v.$Le.fromString(q(F(P.decode(Z.buffer))))}}),define(Ne[7],Oe([1,0,17,13,59,28,72,12,14,2,37,18,29,109,89]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S,f){"use strict";var n,o,s,l,i,r,t,g,u,p,m,d,E,D,w,k,P;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$PP=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$OP=e.$NP=e.$MP=e.$LP=e.$KP=e.$JP=e.$IP=e.$HP=e.LanguageModelChatMessageRole=e.$GP=e.$FP=e.ChatLocation=e.$EP=e.$DP=e.$CP=e.$BP=e.$AP=e.$zP=e.$yP=e.$xP=e.$wP=e.$vP=e.$uP=e.$tP=e.$sP=e.$rP=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$qP=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$pP=e.$oP=e.$nP=e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=e.$hP=e.$gP=e.$fP=e.$eP=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$dP=e.$cP=e.$bP=e.$aP=e.$$O=e.$0O=e.$9O=e.$8O=e.TestRunProfileKind=e.TestResultState=e.$7O=e.$6O=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$5O=e.NotebookVariablesRequestKind=e.$4O=e.$3O=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$2O=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$1O=e.$ZO=e.$YO=e.$XO=e.$WO=e.ColorThemeKind=e.$VO=e.$UO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$TO=e.$SO=e.DebugConsoleMode=e.$RO=e.$QO=e.$PO=e.$OO=e.$NO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$MO=e.$LO=e.FileChangeType=e.$KO=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$JO=e.$IO=e.$HO=e.$GO=e.InlineCompletionTriggerKind=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=e.$yO=e.$xO=e.$wO=e.$vO=e.$tO=e.ConfigurationTarget=e.$sO=e.$rO=e.$qO=e.$pO=e.DocumentPasteTriggerKind=e.$oO=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$iO=e.ViewBadge=e.ProgressLocation=e.$hO=e.$gO=e.TaskScope=e.ShellQuoting=e.$fO=e.$eO=e.$dO=e.TaskPanelKind=e.TaskRevealKind=e.$cO=e.TerminalLocation=e.$bO=e.$aO=e.$_N=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$$N=e.$0N=e.$9N=e.$8N=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$6N=e.$5N=e.$4N=e.$3N=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$2N=e.$1N=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=e.LanguageStatusSeverity=e.$UN=e.$TN=e.$SN=e.$RN=e.$QN=e.$PN=e.CodeActionTriggerKind=e.$ON=e.$NN=e.SymbolTag=e.SymbolKind=e.$MN=e.$LN=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$KN=e.$JN=e.$IN=e.$HN=e.$GN=e.DiagnosticSeverity=e.DiagnosticTag=e.$FN=e.$EN=e.FileEditType=e.$DN=e.$CN=e.$BN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$AN=e.$zN=e.$yN=e.$xN=e.$wN=e.$vN=e.$uN=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$7N=xe,e.$uO=Si,e.$_O=Ai;function h(W){return Object.assign(W,{apply:function(...re){if(re.length===0)return Reflect.construct(W,[]);{const Se=re.length===1?[]:re[1];return Reflect.construct(W,Se,re[0].constructor)}},call:function(...re){if(re.length===0)return Reflect.construct(W,[]);{const[Se,...He]=re;return Reflect.construct(W,He,Se.constructor)}}})}var b;(function(W){W[W.Top=0]="Top",W[W.Bottom=1]="Bottom"})(b||(e.TerminalOutputAnchor=b={}));var M;(function(W){W[W.TerminalCommand=0]="TerminalCommand",W[W.Opener=1]="Opener",W[W.Command=3]="Command"})(M||(e.TerminalQuickFixType=M={}));let O=n=class{static from(...z){let re=z;return new n(function(){if(re){for(const Se of re)Se&&typeof Se.dispose=="function"&&Se.dispose();re=void 0}})}#e;constructor(z){this.#e=z}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$uN=O,e.$uN=O=n=Qe([h],O);let F=o=class{static Min(...z){if(z.length===0)throw new TypeError;let re=z[0];for(let Se=1;Se<z.length;Se++){const He=z[Se];He.isBefore(re)&&(re=He)}return re}static Max(...z){if(z.length===0)throw new TypeError;let re=z[0];for(let Se=1;Se<z.length;Se++){const He=z[Se];He.isAfter(re)&&(re=He)}return re}static isPosition(z){if(!z)return!1;if(z instanceof o)return!0;const{line:re,character:Se}=z;return typeof re=="number"&&typeof Se=="number"}static of(z){if(z instanceof o)return z;if(this.isPosition(z))return new o(z.line,z.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(z,re){if(z<0)throw(0,I.$6)("line must be non-negative");if(re<0)throw(0,I.$6)("character must be non-negative");this.c=z,this.e=re}isBefore(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<z.e}isBeforeOrEqual(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<=z.e}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this.c===z.c&&this.e===z.e}compareTo(z){return this.c<z.c?-1:this.c>z.line?1:this.e<z.e?-1:this.e>z.e?1:0}translate(z,re=0){if(z===null||re===null)throw(0,I.$6)();let Se;return typeof z>"u"?Se=0:typeof z=="number"?Se=z:(Se=typeof z.lineDelta=="number"?z.lineDelta:0,re=typeof z.characterDelta=="number"?z.characterDelta:0),Se===0&&re===0?this:new o(this.line+Se,this.character+re)}with(z,re=this.character){if(z===null||re===null)throw(0,I.$6)();let Se;return typeof z>"u"?Se=this.line:typeof z=="number"?Se=z:(Se=typeof z.line=="number"?z.line:this.line,re=typeof z.character=="number"?z.character:this.character),Se===this.line&&re===this.character?this:new o(Se,re)}toJSON(){return{line:this.line,character:this.character}}};e.$vN=F,e.$vN=F=o=Qe([h],F);let q=s=class{static isRange(z){return z instanceof s?!0:z?F.isPosition(z.start)&&F.isPosition(z.end):!1}static of(z){if(z instanceof s)return z;if(this.isRange(z))return new s(z.start,z.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(z,re,Se,He){let it,dt;if(typeof z=="number"&&typeof re=="number"&&typeof Se=="number"&&typeof He=="number"?(it=new F(z,re),dt=new F(Se,He)):F.isPosition(z)&&F.isPosition(re)&&(it=F.of(z),dt=F.of(re)),!it||!dt)throw new Error("Invalid arguments");it.isBefore(dt)?(this.c=it,this.e=dt):(this.c=dt,this.e=it)}contains(z){return s.isRange(z)?this.contains(z.start)&&this.contains(z.end):F.isPosition(z)?!(F.of(z).isBefore(this.c)||this.e.isBefore(z)):!1}isEqual(z){return this.c.isEqual(z.c)&&this.e.isEqual(z.e)}intersection(z){const re=F.Max(z.start,this.c),Se=F.Min(z.end,this.e);if(!re.isAfter(Se))return new s(re,Se)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const re=F.Min(z.start,this.c),Se=F.Max(z.end,this.end);return new s(re,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(z,re=this.end){if(z===null||re===null)throw(0,I.$6)();let Se;return z?F.isPosition(z)?Se=z:(Se=z.start||this.start,re=z.end||this.end):Se=this.start,Se.isEqual(this.c)&&re.isEqual(this.end)?this:new s(Se,re)}toJSON(){return[this.start,this.end]}};e.$wN=q,e.$wN=q=s=Qe([h],q);let B=l=class extends q{static isSelection(z){return z instanceof l?!0:z?q.isRange(z)&&F.isPosition(z.anchor)&&F.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(z,re,Se,He){let it,dt;if(typeof z=="number"&&typeof re=="number"&&typeof Se=="number"&&typeof He=="number"?(it=new F(z,re),dt=new F(Se,He)):F.isPosition(z)&&F.isPosition(re)&&(it=F.of(z),dt=F.of(re)),!it||!dt)throw new Error("Invalid arguments");super(it,dt),this.f=it,this.g=dt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$xN=B,e.$xN=B=l=Qe([h],B);const L=W=>{if(typeof W!="string"||W.length===0||!/^[0-9A-Za-z_\-]+$/.test(W))throw(0,I.$6)("connectionToken")};class Y{static isResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.host=="string"&&typeof z.port=="number"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,re,Se){if(typeof z!="string"||z.length===0)throw(0,I.$6)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,I.$6)("port");typeof Se<"u"&&L(Se),this.host=z,this.port=Math.round(re),this.connectionToken=Se}}e.$yN=Y;class Z{static isManagedResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.makeConnection=="function"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,re){this.makeConnection=z,this.connectionToken=re,typeof re<"u"&&L(re)}}e.$zN=Z;class fe extends Error{static NotAvailable(z,re){return new fe(z,S.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(z){return new fe(z,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(z,re=S.RemoteAuthorityResolverErrorCode.Unknown,Se){super(z),this._message=z,this._code=re,this._detail=Se,Object.setPrototypeOf(this,fe.prototype)}}e.$AN=fe;var _;(function(W){W[W.LF=1]="LF",W[W.CRLF=2]="CRLF"})(_||(e.EndOfLine=_={}));var ge;(function(W){W[W.Replace=1]="Replace",W[W.Append=2]="Append",W[W.Prepend=3]="Prepend"})(ge||(e.EnvironmentVariableMutatorType=ge={}));let se=i=class{static isTextEdit(z){return z instanceof i?!0:z?q.isRange(z)&&typeof z.newText=="string":!1}static replace(z,re){return new i(z,re)}static insert(z,re){return i.replace(new q(z,z),re)}static delete(z){return i.replace(z,"")}static setEndOfLine(z){const re=new i(new q(new F(0,0),new F(0,0)),"");return re.newEol=z,re}get range(){return this.c}set range(z){if(z&&!q.isRange(z))throw(0,I.$6)("range");this.c=z}get newText(){return this.e||""}set newText(z){if(z&&typeof z!="string")throw(0,I.$6)("newText");this.e=z}get newEol(){return this.f}set newEol(z){if(z&&typeof z!="number")throw(0,I.$6)("newEol");this.f=z}constructor(z,re){this.c=z,this.e=re}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$BN=se,e.$BN=se=i=Qe([h],se);let ae=r=class{static isNotebookCellEdit(z){return z instanceof r?!0:z?wt.isNotebookRange(z)&&Array.isArray(z.newCells):!1}static replaceCells(z,re){return new r(z,re)}static insertCells(z,re){return new r(new wt(z,z),re)}static deleteCells(z){return new r(z,[])}static updateCellMetadata(z,re){const Se=new r(new wt(z,z),[]);return Se.newCellMetadata=re,Se}static updateNotebookMetadata(z){const re=new r(new wt(0,0),[]);return re.newNotebookMetadata=z,re}constructor(z,re){this.range=z,this.newCells=re}};e.$CN=ae,e.$CN=ae=r=Qe([h],ae);class $e{static isSnippetTextEdit(z){return z instanceof $e?!0:z?q.isRange(z.range)&&Fe.isSnippetString(z.snippet):!1}static replace(z,re){return new $e(z,re)}static insert(z,re){return $e.replace(new q(z,z),re)}constructor(z,re){this.range=z,this.snippet=re}}e.$DN=$e;var oe;(function(W){W[W.File=1]="File",W[W.Text=2]="Text",W[W.Cell=3]="Cell",W[W.CellReplace=5]="CellReplace",W[W.Snippet=6]="Snippet"})(oe||(e.FileEditType=oe={}));let Ce=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(z,re,Se,He){this.c.push({_type:oe.File,from:z,to:re,options:Se,metadata:He})}createFile(z,re,Se){this.c.push({_type:oe.File,from:void 0,to:z,options:re,metadata:Se})}deleteFile(z,re,Se){this.c.push({_type:oe.File,from:z,to:void 0,options:re,metadata:Se})}e(z,re,Se){this.c.push({_type:oe.Cell,metadata:Se,uri:z,edit:{editType:f.CellEditType.DocumentMetadata,metadata:re},notebookMetadata:re})}f(z,re,Se,He){const it=re.start,dt=re.end;(it!==dt||Se.length>0)&&this.c.push({_type:oe.CellReplace,uri:z,index:it,count:dt-it,cells:Se,metadata:He})}g(z,re,Se,He){this.c.push({_type:oe.Cell,metadata:He,uri:z,edit:{editType:f.CellEditType.Metadata,index:re,metadata:Se}})}replace(z,re,Se,He){this.c.push({_type:oe.Text,uri:z,edit:new se(re,Se),metadata:He})}insert(z,re,Se,He){this.replace(z,new q(re,re),Se,He)}delete(z,re,Se){this.replace(z,re,"",Se)}has(z){return this.c.some(re=>re._type===oe.Text&&re.uri.toString()===z.toString())}set(z,re){if(re)for(const Se of re){if(!Se)continue;let He,it;Array.isArray(Se)?(He=Se[0],it=Se[1]):He=Se,ae.isNotebookCellEdit(He)?He.newCellMetadata?this.g(z,He.range.start,He.newCellMetadata,it):He.newNotebookMetadata?this.e(z,He.newNotebookMetadata,it):this.f(z,He.range,He.newCells,it):$e.isSnippetTextEdit(He)?this.c.push({_type:oe.Snippet,uri:z,range:He.range,edit:He.snippet,metadata:it}):this.c.push({_type:oe.Text,uri:z,edit:He,metadata:it})}else{for(let Se=0;Se<this.c.length;Se++){const He=this.c[Se];switch(He._type){case oe.Text:case oe.Snippet:case oe.Cell:case oe.CellReplace:He.uri.toString()===z.toString()&&(this.c[Se]=void 0);break}}(0,v.$Hb)(this.c)}}get(z){const re=[];for(const Se of this.c)Se._type===oe.Text&&Se.uri.toString()===z.toString()&&re.push(Se.edit);return re}entries(){const z=new N.$zc;for(const re of this.c)if(re._type===oe.Text){let Se=z.get(re.uri);Se||(Se=[re.uri,[]],z.set(re.uri,Se)),Se[1].push(re.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$EN=Ce,e.$EN=Ce=Qe([h],Ce);let Fe=t=class{static isSnippetString(z){return z instanceof t?!0:z?typeof z.value=="string":!1}static c(z){return z.replace(/\$|}|\\/g,"\\$&")}constructor(z){this.e=1,this.value=z||""}appendText(z){return this.value+=t.c(z),this}appendTabstop(z=this.e++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,re=this.e++){if(typeof z=="function"){const Se=new t;Se.e=this.e,z(Se),this.e=Se.e,z=Se.value}else z=t.c(z);return this.value+="${",this.value+=re,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,re=this.e++){const Se=z.map(He=>He.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(z,re){if(typeof re=="function"){const Se=new t;Se.e=this.e,re(Se),this.e=Se.e,re=Se.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,re&&(this.value+=":",this.value+=re),this.value+="}",this}};e.$FN=Fe,e.$FN=Fe=t=Qe([h],Fe);var X;(function(W){W[W.Unnecessary=1]="Unnecessary",W[W.Deprecated=2]="Deprecated"})(X||(e.DiagnosticTag=X={}));var V;(function(W){W[W.Hint=3]="Hint",W[W.Information=2]="Information",W[W.Warning=1]="Warning",W[W.Error=0]="Error"})(V||(e.DiagnosticSeverity=V={}));let te=g=class{static isLocation(z){return z instanceof g?!0:z?q.isRange(z.range)&&a.URI.isUri(z.uri):!1}constructor(z,re){if(this.uri=z,re)if(q.isRange(re))this.range=q.of(re);else if(F.isPosition(re))this.range=new q(re,re);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$GN=te,e.$GN=te=g=Qe([h],te);let ve=class{static is(z){return z?typeof z.message=="string"&&z.location&&q.isRange(z.location.range)&&a.URI.isUri(z.location.uri):!1}constructor(z,re){this.location=z,this.message=re}static isEqual(z,re){return z===re?!0:!z||!re?!1:z.message===re.message&&z.location.range.isEqual(re.location.range)&&z.location.uri.toString()===re.location.uri.toString()}};e.$HN=ve,e.$HN=ve=Qe([h],ve);let ce=class{constructor(z,re,Se=V.Error){if(!q.isRange(z))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=z,this.message=re,this.severity=Se}toJSON(){return{severity:V[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,re){return z===re?!0:!z||!re?!1:z.message===re.message&&z.severity===re.severity&&z.code===re.code&&z.severity===re.severity&&z.source===re.source&&z.range.isEqual(re.range)&&(0,v.$tb)(z.tags,re.tags)&&(0,v.$tb)(z.relatedInformation,re.relatedInformation,ve.isEqual)}};e.$IN=ce,e.$IN=ce=Qe([h],ce);let be=class{constructor(z,re){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=re}};e.$JN=be,e.$JN=be=Qe([h],be);let he=class extends be{constructor(z,re,Se,He){super(z,re),this.canIncreaseHover=Se,this.canDecreaseHover=He}};e.$KN=he,e.$KN=he=Qe([h],he);var J;(function(W){W[W.Increase=0]="Increase",W[W.Decrease=1]="Decrease"})(J||(e.HoverVerbosityAction=J={}));var x;(function(W){W[W.Text=0]="Text",W[W.Read=1]="Read",W[W.Write=2]="Write"})(x||(e.DocumentHighlightKind=x={}));let me=class{constructor(z,re=x.Text){this.range=z,this.kind=re}toJSON(){return{range:this.range,kind:x[this.kind]}}};e.$LN=me,e.$LN=me=Qe([h],me);let pe=class{constructor(z,re){this.uri=z,this.highlights=re}toJSON(){return{uri:this.uri,highlights:this.highlights.map(z=>z.toJSON())}}};e.$MN=pe,e.$MN=pe=Qe([h],pe);var Ae;(function(W){W[W.File=0]="File",W[W.Module=1]="Module",W[W.Namespace=2]="Namespace",W[W.Package=3]="Package",W[W.Class=4]="Class",W[W.Method=5]="Method",W[W.Property=6]="Property",W[W.Field=7]="Field",W[W.Constructor=8]="Constructor",W[W.Enum=9]="Enum",W[W.Interface=10]="Interface",W[W.Function=11]="Function",W[W.Variable=12]="Variable",W[W.Constant=13]="Constant",W[W.String=14]="String",W[W.Number=15]="Number",W[W.Boolean=16]="Boolean",W[W.Array=17]="Array",W[W.Object=18]="Object",W[W.Key=19]="Key",W[W.Null=20]="Null",W[W.EnumMember=21]="EnumMember",W[W.Struct=22]="Struct",W[W.Event=23]="Event",W[W.Operator=24]="Operator",W[W.TypeParameter=25]="TypeParameter"})(Ae||(e.SymbolKind=Ae={}));var ze;(function(W){W[W.Deprecated=1]="Deprecated"})(ze||(e.SymbolTag=ze={}));let ke=u=class{static validate(z){if(!z.name)throw new Error("name must not be falsy")}constructor(z,re,Se,He,it){this.name=z,this.kind=re,this.containerName=it,typeof Se=="string"&&(this.containerName=Se),He instanceof te?this.location=He:Se instanceof q&&(this.location=new te(He,Se)),u.validate(this)}toJSON(){return{name:this.name,kind:Ae[this.kind],location:this.location,containerName:this.containerName}}};e.$NN=ke,e.$NN=ke=u=Qe([h],ke);let Pe=p=class{static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children?.forEach(p.validate)}constructor(z,re,Se,He,it){this.name=z,this.detail=re,this.kind=Se,this.range=He,this.selectionRange=it,this.children=[],p.validate(this)}};e.$ON=Pe,e.$ON=Pe=p=Qe([h],Pe);var Te;(function(W){W[W.Invoke=1]="Invoke",W[W.Automatic=2]="Automatic"})(Te||(e.CodeActionTriggerKind=Te={}));let U=class{constructor(z,re){this.title=z,this.kind=re}};e.$PN=U,e.$PN=U=Qe([h],U);let j=class{static{m=this}static{this.c="."}constructor(z){this.value=z}append(z){return new m(this.value?this.value+m.c+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+m.c)}};e.$QN=j,e.$QN=j=m=Qe([h],j),j.Empty=new j(""),j.QuickFix=j.Empty.append("quickfix"),j.Refactor=j.Empty.append("refactor"),j.RefactorExtract=j.Refactor.append("extract"),j.RefactorInline=j.Refactor.append("inline"),j.RefactorMove=j.Refactor.append("move"),j.RefactorRewrite=j.Refactor.append("rewrite"),j.Source=j.Empty.append("source"),j.SourceOrganizeImports=j.Source.append("organizeImports"),j.SourceFixAll=j.Source.append("fixAll"),j.Notebook=j.Empty.append("notebook");let G=class{constructor(z,re){if(this.range=z,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$RN=G,e.$RN=G=Qe([h],G);class Q{constructor(z,re,Se,He,it,dt){this.kind=z,this.name=re,this.detail=Se,this.uri=He,this.range=it,this.selectionRange=dt}}e.$SN=Q;class ne{constructor(z,re){this.fromRanges=re,this.from=z}}e.$TN=ne;class de{constructor(z,re){this.fromRanges=re,this.to=z}}e.$UN=de;var Ie;(function(W){W[W.Information=0]="Information",W[W.Warning=1]="Warning",W[W.Error=2]="Error"})(Ie||(e.LanguageStatusSeverity=Ie={}));let je=class{constructor(z,re){this.range=z,this.command=re}get isResolved(){return!!this.command}};e.$VN=je,e.$VN=je=Qe([h],je);let Ke=d=class{#e;static isMarkdownString(z){return z instanceof d?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}constructor(z,re=!1){this.#e=new C.$Zk(z,{supportThemeIcons:re})}get value(){return this.#e.value}set value(z){this.#e.value=z}get isTrusted(){return this.#e.isTrusted}set isTrusted(z){this.#e.isTrusted=z}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(z){this.#e.supportThemeIcons=z}get supportHtml(){return this.#e.supportHtml}set supportHtml(z){this.#e.supportHtml=z}get baseUri(){return this.#e.baseUri}set baseUri(z){this.#e.baseUri=z}appendText(z){return this.#e.appendText(z),this}appendMarkdown(z){return this.#e.appendMarkdown(z),this}appendCodeblock(z,re){return this.#e.appendCodeblock(re??"",z),this}};e.$WN=Ke,e.$WN=Ke=d=Qe([h],Ke);let _e=class{constructor(z,re){this.label=z,this.documentation=re}};e.$XN=_e,e.$XN=_e=Qe([h],_e);let tt=class{constructor(z,re){this.label=z,this.documentation=re,this.parameters=[]}};e.$YN=tt,e.$YN=tt=Qe([h],tt);let nt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$ZN=nt,e.$ZN=nt=Qe([h],nt);var et;(function(W){W[W.Invoke=1]="Invoke",W[W.TriggerCharacter=2]="TriggerCharacter",W[W.ContentChange=3]="ContentChange"})(et||(e.SignatureHelpTriggerKind=et={}));var rt;(function(W){W[W.Type=1]="Type",W[W.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let ft=class{constructor(z){this.value=z}};e.$1N=ft,e.$1N=ft=Qe([h],ft);let ct=class{constructor(z,re,Se){this.position=z,this.label=re,this.kind=Se}};e.$2N=ct,e.$2N=ct=Qe([h],ct);var st;(function(W){W[W.Invoke=0]="Invoke",W[W.TriggerCharacter=1]="TriggerCharacter",W[W.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st||(e.CompletionTriggerKind=st={}));var lt;(function(W){W[W.Text=0]="Text",W[W.Method=1]="Method",W[W.Function=2]="Function",W[W.Constructor=3]="Constructor",W[W.Field=4]="Field",W[W.Variable=5]="Variable",W[W.Class=6]="Class",W[W.Interface=7]="Interface",W[W.Module=8]="Module",W[W.Property=9]="Property",W[W.Unit=10]="Unit",W[W.Value=11]="Value",W[W.Enum=12]="Enum",W[W.Keyword=13]="Keyword",W[W.Snippet=14]="Snippet",W[W.Color=15]="Color",W[W.File=16]="File",W[W.Reference=17]="Reference",W[W.Folder=18]="Folder",W[W.EnumMember=19]="EnumMember",W[W.Constant=20]="Constant",W[W.Struct=21]="Struct",W[W.Event=22]="Event",W[W.Operator=23]="Operator",W[W.TypeParameter=24]="TypeParameter",W[W.User=25]="User",W[W.Issue=26]="Issue"})(lt||(e.CompletionItemKind=lt={}));var gt;(function(W){W[W.Deprecated=1]="Deprecated"})(gt||(e.CompletionItemTag=gt={}));let pt=class{constructor(z,re){this.label=z,this.kind=re}toJSON(){return{label:this.label,kind:this.kind&&lt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$3N=pt,e.$3N=pt=Qe([h],pt);let Be=class{constructor(z=[],re=!1){this.items=z,this.isIncomplete=re}};e.$4N=Be,e.$4N=Be=Qe([h],Be);let Ue=class{constructor(z,re,Se){this.insertText=z,this.range=re,this.command=Se}};e.$5N=Ue,e.$5N=Ue=Qe([h],Ue);let ee=class{constructor(z){this.commands=void 0,this.suppressSuggestions=void 0,this.items=z}};e.$6N=ee,e.$6N=ee=Qe([h],ee);var K;(function(W){W[W.Unknown=0]="Unknown",W[W.Word=1]="Word",W[W.Line=2]="Line",W[W.Suggest=3]="Suggest"})(K||(e.PartialAcceptTriggerKind=K={}));var De;(function(W){W[W.Active=-1]="Active",W[W.Beside=-2]="Beside",W[W.One=1]="One",W[W.Two=2]="Two",W[W.Three=3]="Three",W[W.Four=4]="Four",W[W.Five=5]="Five",W[W.Six=6]="Six",W[W.Seven=7]="Seven",W[W.Eight=8]="Eight",W[W.Nine=9]="Nine"})(De||(e.ViewColumn=De={}));var Je;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(Je||(e.StatusBarAlignment=Je={}));function xe(W,z){return`${y.$nn.toKey(W)}.${z}`}var ht;(function(W){W[W.Off=0]="Off",W[W.On=1]="On",W[W.Relative=2]="Relative",W[W.Interval=3]="Interval"})(ht||(e.TextEditorLineNumbersStyle=ht={}));var $t;(function(W){W[W.Manual=1]="Manual",W[W.AfterDelay=2]="AfterDelay",W[W.FocusOut=3]="FocusOut"})($t||(e.TextDocumentSaveReason=$t={}));var Ot;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(Ot||(e.TextEditorRevealType=Ot={}));var zt;(function(W){W[W.Keyboard=1]="Keyboard",W[W.Mouse=2]="Mouse",W[W.Command=3]="Command"})(zt||(e.TextEditorSelectionChangeKind=zt={}));var ei;(function(W){W[W.Undo=1]="Undo",W[W.Redo=2]="Redo"})(ei||(e.TextDocumentChangeReason=ei={}));var ui;(function(W){W[W.OpenOpen=0]="OpenOpen",W[W.ClosedClosed=1]="ClosedClosed",W[W.OpenClosed=2]="OpenClosed",W[W.ClosedOpen=3]="ClosedOpen"})(ui||(e.DecorationRangeBehavior=ui={})),function(W){function z(re){switch(re){case"keyboard":return W.Keyboard;case"mouse":return W.Mouse;case"api":return W.Command}}W.fromValue=z}(zt||(e.TextEditorSelectionChangeKind=zt={}));var ti;(function(W){W[W.Other=0]="Other",W[W.Comment=1]="Comment",W[W.String=2]="String",W[W.RegEx=3]="RegEx"})(ti||(e.SyntaxTokenType=ti={})),function(W){function z(re){switch(re){case W.Other:return"other";case W.Comment:return"comment";case W.String:return"string";case W.RegEx:return"regex"}return"other"}W.toString=z}(ti||(e.SyntaxTokenType=ti={}));let Ye=class{constructor(z,re){if(re&&!a.URI.isUri(re))throw(0,I.$6)("target");if(!q.isRange(z)||z.isEmpty)throw(0,I.$6)("range");this.range=z,this.target=re}};e.$8N=Ye,e.$8N=Ye=Qe([h],Ye);let Gt=class{constructor(z,re,Se,He){this.red=z,this.green=re,this.blue=Se,this.alpha=He}};e.$9N=Gt,e.$9N=Gt=Qe([h],Gt);let Kt=class{constructor(z,re){if(re&&!(re instanceof Gt))throw(0,I.$6)("color");if(!q.isRange(z)||z.isEmpty)throw(0,I.$6)("range");this.range=z,this.color=re}};e.$0N=Kt,e.$0N=Kt=Qe([h],Kt);let mt=class{constructor(z){if(!z||typeof z!="string")throw(0,I.$6)("label");this.label=z}};e.$$N=mt,e.$$N=mt=Qe([h],mt);var Ct;(function(W){W[W.RGB=0]="RGB",W[W.HEX=1]="HEX",W[W.HSL=2]="HSL"})(Ct||(e.ColorFormat=Ct={}));var ii;(function(W){W[W.Error=0]="Error",W[W.Warning=1]="Warning",W[W.Information=2]="Information"})(ii||(e.SourceControlInputBoxValidationType=ii={}));var Xt;(function(W){W[W.Unknown=0]="Unknown",W[W.Shutdown=1]="Shutdown",W[W.Process=2]="Process",W[W.User=3]="User",W[W.Extension=4]="Extension"})(Xt||(e.TerminalExitReason=Xt={}));var Bt;(function(W){W[W.Low=0]="Low",W[W.Medium=1]="Medium",W[W.High=2]="High"})(Bt||(e.TerminalShellExecutionCommandLineConfidence=Bt={}));class vt{constructor(z,re,Se){if(this.startIndex=z,this.length=re,this.tooltip=Se,typeof z!="number"||z<0)throw(0,I.$6)("startIndex");if(typeof re!="number"||re<1)throw(0,I.$6)("length");if(Se!==void 0&&typeof Se!="string")throw(0,I.$6)("tooltip")}}e.$_N=vt;class Nt{constructor(z){this.uri=z}}e.$aO=Nt;class hi{constructor(z){this.terminalCommand=z}}e.$bO=hi;var Wt;(function(W){W[W.Panel=1]="Panel",W[W.Editor=2]="Editor"})(Wt||(e.TerminalLocation=Wt={}));class Xe{constructor(z){if(this.options=z,typeof z!="object")throw(0,I.$6)("options")}}e.$cO=Xe;var Yt;(function(W){W[W.Always=1]="Always",W[W.Silent=2]="Silent",W[W.Never=3]="Never"})(Yt||(e.TaskRevealKind=Yt={}));var ni;(function(W){W[W.Shared=1]="Shared",W[W.Dedicated=2]="Dedicated",W[W.New=3]="New"})(ni||(e.TaskPanelKind=ni={}));let di=class{static{E=this}static{this.Clean=new E("clean","Clean")}static{this.Build=new E("build","Build")}static{this.Rebuild=new E("rebuild","Rebuild")}static{this.Test=new E("test","Test")}static from(z){switch(z){case"clean":return E.Clean;case"build":return E.Build;case"rebuild":return E.Rebuild;case"test":return E.Test;default:return}}constructor(z,re){if(this.label=re,typeof z!="string"||typeof re!="string")throw(0,I.$6)("name");this.c=z}get id(){return this.c}};e.$dO=di,e.$dO=di=E=Qe([h],di);function St(W){let z="";for(let re=0;re<W.length;re++)z+=W[re].replace(/,/g,",,")+",";return z}let Lt=class{constructor(z,re,Se){if(typeof z!="string")throw(0,I.$6)("process");this.e=[],this.c=z,re!==void 0&&(Array.isArray(re)?(this.e=re,this.f=Se):this.f=re)}get process(){return this.c}set process(z){if(typeof z!="string")throw(0,I.$6)("process");this.c=z}get args(){return this.e}set args(z){Array.isArray(z)||(z=[]),this.e=z}get options(){return this.f}set options(z){this.f=z}computeId(){const z=[];if(z.push("process"),this.c!==void 0&&z.push(this.c),this.e&&this.e.length>0)for(const re of this.e)z.push(re);return St(z)}};e.$eO=Lt,e.$eO=Lt=Qe([h],Lt);let Rt=class{constructor(z,re,Se){if(this.f=[],Array.isArray(re)){if(!z)throw(0,I.$6)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,I.$6)("command");this.e=z,this.f=re,this.g=Se}else{if(typeof z!="string")throw(0,I.$6)("commandLine");this.c=z,this.g=re}}get commandLine(){return this.c}set commandLine(z){if(typeof z!="string")throw(0,I.$6)("commandLine");this.c=z}get command(){return this.e?this.e:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,I.$6)("command");this.e=z}get args(){return this.f}set args(z){this.f=z||[]}get options(){return this.g}set options(z){this.g=z}computeId(){const z=[];if(z.push("shell"),this.c!==void 0&&z.push(this.c),this.e!==void 0&&z.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const re of this.f)z.push(typeof re=="string"?re:re.value);return St(z)}};e.$fO=Rt,e.$fO=Rt=Qe([h],Rt);var jt;(function(W){W[W.Escape=1]="Escape",W[W.Strong=2]="Strong",W[W.Weak=3]="Weak"})(jt||(e.ShellQuoting=jt={}));var ri;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace"})(ri||(e.TaskScope=ri={}));class Zt{constructor(z){this.c=z}computeId(){return"customExecution"+(0,R.$Yg)()}set callback(z){this.c=z}get callback(){return this.c}}e.$gO=Zt;let si=class{static{D=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(z,re,Se,He,it,dt){this.k=!1,this.l=this.definition=z;let yt;typeof re=="string"?(this.o=this.name=re,this.w=this.source=Se,this.execution=He,yt=it,this.k=!0):re===ri.Global||re===ri.Workspace?(this.target=re,this.o=this.name=Se,this.w=this.source=He,this.execution=it,yt=dt):(this.target=re,this.o=this.name=Se,this.w=this.source=He,this.execution=it,yt=dt),typeof yt=="string"?(this.r=[yt],this.t=!0):Array.isArray(yt)?(this.r=yt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(z){this.j=z}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Lt?this.l={type:D.e,id:this.q.computeId()}:this.q instanceof Rt?this.l={type:D.f,id:this.q.computeId()}:this.q instanceof Zt?this.l={type:D.c,id:this.q.computeId()}:this.l={type:D.g,id:(0,R.$Yg)()}}get definition(){return this.l}set definition(z){if(z==null)throw(0,I.$6)("Kind can't be undefined or null");this.B(),this.l=z}get scope(){return this.m}set target(z){this.B(),this.m=z}get name(){return this.o}set name(z){if(typeof z!="string")throw(0,I.$6)("name");this.B(),this.o=z}get execution(){return this.q}set execution(z){z===null&&(z=void 0),this.B(),this.q=z;const re=this.l.type;(D.g===re||D.e===re||D.f===re||D.c===re)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(z){if(Array.isArray(z))this.B(),this.r=z,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.B(),this.u=z}get source(){return this.w}set source(z){if(typeof z!="string"||z.length===0)throw(0,I.$6)("source must be a string of length > 0");this.B(),this.w=z}get group(){return this.x}set group(z){z===null&&(z=void 0),this.B(),this.x=z}get detail(){return this.A}set detail(z){z===null&&(z=void 0),this.A=z}get presentationOptions(){return this.y}set presentationOptions(z){z==null&&(z=Object.create(null)),this.B(),this.y=z}get runOptions(){return this.z}set runOptions(z){z==null&&(z=Object.create(null)),this.B(),this.z=z}};e.$hO=si,e.$hO=si=D=Qe([h],si);var Vt;(function(W){W[W.SourceControl=1]="SourceControl",W[W.Window=10]="Window",W[W.Notification=15]="Notification"})(Vt||(e.ProgressLocation=Vt={}));var Qt;(function(W){function z(re){const Se=re;return(0,$.$gg)(Se.value)?Se.tooltip&&!(0,$.$cg)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}W.isViewBadge=z})(Qt||(e.ViewBadge=Qt={}));let oi=w=class{static isTreeItem(z,re){const Se=z;if(Se.checkboxState!==void 0){const He=(0,$.$gg)(Se.checkboxState)?Se.checkboxState:(0,$.$eg)(Se.checkboxState)&&(0,$.$gg)(Se.checkboxState.state)?Se.checkboxState.state:void 0,it=!(0,$.$gg)(Se.checkboxState)&&(0,$.$eg)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(He===void 0||He!==Dt.Checked&&He!==Dt.Unchecked||it!==void 0&&!(0,$.$cg)(it))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(z instanceof w)return!0;if(Se.label!==void 0&&!(0,$.$cg)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,$.$cg)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,$.$cg)(Se.iconPath)&&!a.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,$.$cg)(Se.iconPath.id))){const He=Se.iconPath;if(!He||!(0,$.$cg)(He.light)&&!a.URI.isUri(He.light)&&!(0,$.$cg)(He.dark)&&!a.URI.isUri(He.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,$.$cg)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!a.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,$.$cg)(Se.tooltip)&&!(Se.tooltip instanceof Ke)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<Pt.None&&Se.collapsibleState>Pt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,$.$cg)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(z,re=Pt.None){this.collapsibleState=re,a.URI.isUri(z)?this.resourceUri=z:this.label=z}};e.$iO=oi,e.$iO=oi=w=Qe([h],oi);var Pt;(function(W){W[W.None=0]="None",W[W.Collapsed=1]="Collapsed",W[W.Expanded=2]="Expanded"})(Pt||(e.TreeItemCollapsibleState=Pt={}));var Dt;(function(W){W[W.Unchecked=0]="Unchecked",W[W.Checked=1]="Checked"})(Dt||(e.TreeItemCheckboxState=Dt={}));let bt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(z){this.value=z}};e.$jO=bt,e.$jO=bt=Qe([h],bt);class xt extends bt{}e.$kO=xt;class kt extends xt{#e;constructor(z){super(""),this.#e=z}asFile(){return this.#e}}e.$lO=kt;class fi{constructor(z,re,Se,He){this.name=z,this.uri=re,this._itemId=Se,this.c=He}data(){return this.c()}}e.$mO=fi;let qt=class{#e=new Map;constructor(z){for(const[re,Se]of z??[]){const He=this.#e.get(this.#t(re));He?He.push(Se):this.#e.set(this.#t(re),[Se])}}get(z){return this.#e.get(this.#t(z))?.[0]}set(z,re){this.#e.set(this.#t(z),[re])}forEach(z,re){for(const[Se,He]of this.#e)for(const it of He)z.call(re,it,Se,this)}*[Symbol.iterator](){for(const[z,re]of this.#e)for(const Se of re)yield[z,Se]}#t(z){return z.toLowerCase()}};e.$nO=qt,e.$nO=qt=Qe([h],qt);let bi=class{constructor(z,re,Se){this.insertText=z,this.title=re,this.kind=Se}};e.$oO=bi,e.$oO=bi=Qe([h],bi);var vi;(function(W){W[W.Automatic=0]="Automatic",W[W.PasteAs=1]="PasteAs"})(vi||(e.DocumentPasteTriggerKind=vi={}));class gi{static{this.c="."}constructor(z){this.value=z}append(...z){return new gi((this.value?[this.value,...z]:z).join(gi.c))}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+gi.c)}}e.$pO=gi,gi.Empty=new gi("");class Mt{constructor(z,re,Se){this.title=re,this.insertText=z,this.kind=Se}}e.$qO=Mt;let ai=class{constructor(z,re){this.id=z,this.color=re}static isThemeIcon(z){return typeof z.id!="string"?(console.log("INVALID ThemeIcon, invalid id",z.id),!1):!0}};e.$rO=ai,e.$rO=ai=Qe([h],ai),ai.File=new ai("file"),ai.Folder=new ai("folder");let Ii=class{constructor(z){this.id=z}};e.$sO=Ii,e.$sO=Ii=Qe([h],Ii);var At;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace",W[W.WorkspaceFolder=3]="WorkspaceFolder"})(At||(e.ConfigurationTarget=At={}));let Di=class{get base(){return this.c}set base(z){this.c=z,this.e=a.URI.file(z)}get baseUri(){return this.e}set baseUri(z){this.e=z,this.c=z.fsPath}constructor(z,re){if(typeof z!="string"&&(!z||!a.URI.isUri(z)&&!a.URI.isUri(z.uri)))throw(0,I.$6)("base");if(typeof re!="string")throw(0,I.$6)("pattern");typeof z=="string"?this.baseUri=a.URI.file(z):a.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=re}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$tO=Di,e.$tO=Di=Qe([h],Di);const Pi=new WeakMap;function Si(W,z){Pi.set(W,z)}let pi=class{constructor(z,re,Se,He,it){this.enabled=typeof z=="boolean"?z:!0,typeof re=="string"&&(this.condition=re),typeof Se=="string"&&(this.hitCondition=Se),typeof He=="string"&&(this.logMessage=He),typeof it=="string"&&(this.mode=it)}get id(){return this.c||(this.c=Pi.get(this)??(0,R.$Yg)()),this.c}};e.$vO=pi,e.$vO=pi=Qe([h],pi);let Ri=class extends pi{constructor(z,re,Se,He,it,dt){if(super(re,Se,He,it,dt),z===null)throw(0,I.$6)("location");this.location=z}};e.$wO=Ri,e.$wO=Ri=Qe([h],Ri);let Ut=class extends pi{constructor(z,re,Se,He,it,dt){super(re,Se,He,it,dt),this.functionName=z}};e.$xO=Ut,e.$xO=Ut=Qe([h],Ut);let ye=class extends pi{constructor(z,re,Se,He,it,dt,yt,Jt){if(super(He,it,dt,yt,Jt),!re)throw(0,I.$6)("dataId");this.label=z,this.dataId=re,this.canPersist=Se}};e.$yO=ye,e.$yO=ye=Qe([h],ye);let Re=class{constructor(z,re,Se){this.command=z,this.args=re||[],this.options=Se}};e.$zO=Re,e.$zO=Re=Qe([h],Re);let le=class{constructor(z,re){this.port=z,this.host=re}};e.$AO=le,e.$AO=le=Qe([h],le);let H=class{constructor(z){this.path=z}};e.$BO=H,e.$BO=H=Qe([h],H);let Ee=class{constructor(z){this.implementation=z}};e.$CO=Ee,e.$CO=Ee=Qe([h],Ee);class We{constructor(z,re,Se){this.session=z,this.threadId=re,this.frameId=Se}}e.$DO=We;class Ze{constructor(z,re){this.session=z,this.threadId=re}}e.$EO=Ze;let Ge=class{constructor(z,re){this.range=z,this.expression=re}};e.$FO=Ge,e.$FO=Ge=Qe([h],Ge);var ut;(function(W){W[W.Invoke=0]="Invoke",W[W.Automatic=1]="Automatic"})(ut||(e.InlineCompletionTriggerKind=ut={}));let It=class{constructor(z,re){this.range=z,this.text=re}};e.$GO=It,e.$GO=It=Qe([h],It);let Ht=class{constructor(z,re,Se=!0){this.range=z,this.variableName=re,this.caseSensitiveLookup=Se}};e.$HO=Ht,e.$HO=Ht=Qe([h],Ht);let ci=class{constructor(z,re){this.range=z,this.expression=re}};e.$IO=ci,e.$IO=ci=Qe([h],ci);let Ft=class{constructor(z,re){this.frameId=z,this.stoppedLocation=re}};e.$JO=Ft,e.$JO=Ft=Qe([h],Ft);var li;(function(W){W[W.AIGenerated=1]="AIGenerated"})(li||(e.NewSymbolNameTag=li={}));var Vi;(function(W){W[W.Invoke=0]="Invoke",W[W.Automatic=1]="Automatic"})(Vi||(e.NewSymbolNameTriggerKind=Vi={}));class $n{constructor(z,re){this.newSymbolName=z,this.tags=re}}e.$KO=$n;var Fi;(function(W){W[W.Changed=1]="Changed",W[W.Created=2]="Created",W[W.Deleted=3]="Deleted"})(Fi||(e.FileChangeType=Fi={}));let Ni=k=class extends Error{static FileExists(z){return new k(z,c.FileSystemProviderErrorCode.FileExists,k.FileExists)}static FileNotFound(z){return new k(z,c.FileSystemProviderErrorCode.FileNotFound,k.FileNotFound)}static FileNotADirectory(z){return new k(z,c.FileSystemProviderErrorCode.FileNotADirectory,k.FileNotADirectory)}static FileIsADirectory(z){return new k(z,c.FileSystemProviderErrorCode.FileIsADirectory,k.FileIsADirectory)}static NoPermissions(z){return new k(z,c.FileSystemProviderErrorCode.NoPermissions,k.NoPermissions)}static Unavailable(z){return new k(z,c.FileSystemProviderErrorCode.Unavailable,k.Unavailable)}constructor(z,re=c.FileSystemProviderErrorCode.Unknown,Se){super(a.URI.isUri(z)?z.toString(!0):z),this.code=Se?.name??"Unknown",(0,c.$ll)(this,re),Object.setPrototypeOf(this,k.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$LO=Ni,e.$LO=Ni=k=Qe([h],Ni);let qi=class{constructor(z,re,Se){this.start=z,this.end=re,this.kind=Se}};e.$MO=qi,e.$MO=qi=Qe([h],qi);var xi;(function(W){W[W.Comment=1]="Comment",W[W.Imports=2]="Imports",W[W.Region=3]="Region"})(xi||(e.FoldingRangeKind=xi={}));var ki;(function(W){W[W.Collapsed=0]="Collapsed",W[W.Expanded=1]="Expanded"})(ki||(e.CommentThreadCollapsibleState=ki={}));var _i;(function(W){W[W.Editing=0]="Editing",W[W.Preview=1]="Preview"})(_i||(e.CommentMode=_i={}));var en;(function(W){W[W.Published=0]="Published",W[W.Draft=1]="Draft"})(en||(e.CommentState=en={}));var Mi;(function(W){W[W.Unresolved=0]="Unresolved",W[W.Resolved=1]="Resolved"})(Mi||(e.CommentThreadState=Mi={}));var tn;(function(W){W[W.Current=0]="Current",W[W.Outdated=1]="Outdated"})(tn||(e.CommentThreadApplicability=tn={}));class Gi{constructor(z,re=[]){this.tokenTypes=z,this.tokenModifiers=re}}e.$NO=Gi;function nn(W){return typeof W>"u"||(0,$.$dg)(W)}class Ki{constructor(z){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,z){this.m=!0;for(let re=0,Se=z.tokenTypes.length;re<Se;re++)this.k.set(z.tokenTypes[re],re);for(let re=0,Se=z.tokenModifiers.length;re<Se;re++)this.l.set(z.tokenModifiers[re],re)}}push(z,re,Se,He,it){if(typeof z=="number"&&typeof re=="number"&&typeof Se=="number"&&typeof He=="number"&&(typeof it=="number"||typeof it>"u"))return typeof it>"u"&&(it=0),this.q(z,re,Se,He,it);if(q.isRange(z)&&typeof re=="string"&&nn(Se))return this.o(z,re,Se);throw(0,I.$6)()}o(z,re,Se){if(!this.m)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(re))throw new Error("`tokenType` is not in the provided legend");const He=z.start.line,it=z.start.character,dt=z.end.character-z.start.character,yt=this.k.get(re);let Jt=0;if(Se)for(const $i of Se){if(!this.l.has($i))throw new Error("`tokenModifier` is not in the provided legend");const wi=this.l.get($i);Jt|=1<<wi>>>0}this.q(He,it,dt,yt,Jt)}q(z,re,Se,He,it){if(this.f&&(z<this.c||z===this.c&&re<this.e)){this.f=!1;const Jt=this.g.length/5|0;let $i=0,wi=0;for(let Ei=0;Ei<Jt;Ei++){let Ci=this.g[5*Ei],Yi=this.g[5*Ei+1];Ci===0?(Ci=$i,Yi+=wi):Ci+=$i,this.g[5*Ei]=Ci,this.g[5*Ei+1]=Yi,$i=Ci,wi=Yi}}let dt=z,yt=re;this.f&&this.j>0&&(dt-=this.c,dt===0&&(yt-=this.e)),this.g[this.j++]=dt,this.g[this.j++]=yt,this.g[this.j++]=Se,this.g[this.j++]=He,this.g[this.j++]=it,this.c=z,this.e=re}static r(z){const re=[],Se=z.length/5|0;for(let yt=0;yt<Se;yt++)re[yt]=yt;re.sort((yt,Jt)=>{const $i=z[5*yt],wi=z[5*Jt];if($i===wi){const Ei=z[5*yt+1],Ci=z[5*Jt+1];return Ei-Ci}return $i-wi});const He=new Uint32Array(z.length);let it=0,dt=0;for(let yt=0;yt<Se;yt++){const Jt=5*re[yt],$i=z[Jt+0],wi=z[Jt+1],Ei=z[Jt+2],Ci=z[Jt+3],Yi=z[Jt+4],Un=$i-it,Ir=Un===0?wi-dt:wi,Zi=5*yt;He[Zi+0]=Un,He[Zi+1]=Ir,He[Zi+2]=Ei,He[Zi+3]=Ci,He[Zi+4]=Yi,it=$i,dt=wi}return He}build(z){return this.f?new zi(new Uint32Array(this.g),z):new zi(Ki.r(this.g),z)}}e.$OO=Ki;class zi{constructor(z,re){this.resultId=re,this.data=z}}e.$PO=zi;class wn{constructor(z,re,Se){this.start=z,this.deleteCount=re,this.data=Se}}e.$QO=wn;class Oi{constructor(z,re){this.resultId=re,this.edits=z}}e.$RO=Oi;var rn;(function(W){W[W.Separate=0]="Separate",W[W.MergeWithParent=1]="MergeWithParent"})(rn||(e.DebugConsoleMode=rn={}));class bn{constructor(z){this.name=z}}e.$SO=bn;let Qi=class{static{this.Back={iconPath:new ai("arrow-left")}}constructor(){}};e.$TO=Qi,e.$TO=Qi=Qe([h],Qi);var ji;(function(W){W[W.Separator=-1]="Separator",W[W.Default=0]="Default"})(ji||(e.QuickPickItemKind=ji={}));var Hi;(function(W){W[W.Info=1]="Info",W[W.Warning=2]="Warning",W[W.Error=3]="Error"})(Hi||(e.InputBoxValidationSeverity=Hi={}));var Me;(function(W){W[W.UI=1]="UI",W[W.Workspace=2]="Workspace"})(Me||(e.ExtensionKind=Me={}));class yi{static validate(z){if(typeof z.badge=="string"){let re=(0,T.$Nf)(z.badge,0);if(re<z.badge.length&&(re+=(0,T.$Nf)(z.badge,re)),z.badge.length>re)throw new Error("The 'badge'-property must be undefined or a short character")}else if(z.badge&&!ai.isThemeIcon(z.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}constructor(z,re,Se){this.badge=z,this.tooltip=re,this.color=Se}}e.$UO=yi;let Ui=class{constructor(z){this.kind=z}};e.$VO=Ui,e.$VO=Ui=Qe([h],Ui);var ot;(function(W){W[W.Light=1]="Light",W[W.Dark=2]="Dark",W[W.HighContrast=3]="HighContrast",W[W.HighContrastLight=4]="HighContrastLight"})(ot||(e.ColorThemeKind=ot={}));class wt{static isNotebookRange(z){return z instanceof wt?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(z,re){if(z<0)throw(0,I.$6)("start must be positive");if(re<0)throw(0,I.$6)("end must be positive");z<=re?(this.c=z,this.e=re):(this.c=re,this.e=z)}with(z){let re=this.c,Se=this.e;return z.start!==void 0&&(re=z.start),z.end!==void 0&&(Se=z.end),re===this.c&&Se===this.e?this:new wt(re,Se)}}e.$WO=wt;class Bi{static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(re=>Bi.isNotebookCellData(re))}static isNotebookCellData(z){return!0}constructor(z,re,Se,He,it,dt,yt){this.kind=z,this.value=re,this.languageId=Se,this.mime=He,this.outputs=it??[],this.metadata=dt,this.executionSummary=yt,Bi.validate(this)}}e.$XO=Bi;class vn{constructor(z){this.cells=z}}e.$YO=vn;class mi{static isNotebookCellOutputItem(z){return z instanceof mi?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const re={name:z.name,message:z.message,stack:z.stack};return mi.json(re,"application/vnd.code.notebook.error")}static stdout(z){return mi.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return mi.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,re="application/octet-stream"){return new mi(z,re)}static#e=new TextEncoder;static text(z,re=A.$7s.text){const Se=mi.#e.encode(String(z));return new mi(Se,re)}static json(z,re="text/x-json"){const Se=JSON.stringify(z,void 0,"	");return mi.text(Se,re)}constructor(z,re){this.data=z,this.mime=re;const Se=(0,A.$$s)(re,!0);if(!Se)throw new Error(`INVALID mime type: ${re}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$ZO=mi;class Wi{static isNotebookCellOutput(z){return z instanceof Wi?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&Array.isArray(z.items)}static ensureUniqueMimeTypes(z,re=!1){const Se=new Set,He=new Set;for(let it=0;it<z.length;it++){const dt=z[it],yt=(0,A.$$s)(dt.mime);if(!Se.has(yt)||(0,f.$xL)(yt)){Se.add(yt);continue}He.add(it),re&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return He.size===0?z:z.filter((it,dt)=>!He.has(dt))}constructor(z,re,Se){this.items=Wi.ensureUniqueMimeTypes(z,!0),typeof re=="string"?(this.id=re,this.metadata=Se):(this.id=(0,R.$Yg)(),this.metadata=re??Se)}}e.$1O=Wi;var Li;(function(W){W[W.Markup=1]="Markup",W[W.Code=2]="Code"})(Li||(e.NotebookCellKind=Li={}));var sn;(function(W){W[W.Idle=1]="Idle",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(sn||(e.NotebookCellExecutionState=sn={}));var on;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(on||(e.NotebookCellStatusBarAlignment=on={}));var an;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(an||(e.NotebookEditorRevealType=an={}));class cn{constructor(z,re){this.text=z,this.alignment=re}}e.$2O=cn;var ln;(function(W){W[W.Default=1]="Default",W[W.Preferred=2]="Preferred"})(ln||(e.NotebookControllerAffinity=ln={}));var un;(function(W){W[W.Default=1]="Default",W[W.Preferred=2]="Preferred",W[W.Hidden=-1]="Hidden"})(un||(e.NotebookControllerAffinity2=un={}));class yn{constructor(z,re=[]){this.uri=z,this.provides=(0,v.$1b)(re)}}e.$3O=yn;class En{constructor(z){this.label=z}}e.$4O=En;var hn;(function(W){W[W.Named=1]="Named",W[W.Indexed=2]="Indexed"})(hn||(e.NotebookVariablesRequestKind=hn={}));let Ji=class{constructor(z,re){this.label=z,this.timestamp=re}};e.$5O=Ji,e.$5O=Ji=Qe([h],Ji);var dn;(function(W){W[W.Production=1]="Production",W[W.Development=2]="Development",W[W.Test=3]="Test"})(dn||(e.ExtensionMode=dn={}));var fn;(function(W){W[W.Node=1]="Node",W[W.Webworker=2]="Webworker"})(fn||(e.ExtensionRuntime=fn={}));var gn;(function(W){W[W.Other=0]="Other",W[W.Comment=1]="Comment",W[W.String=2]="String",W[W.RegEx=3]="RegEx"})(gn||(e.StandardTokenType=gn={}));class Dn{constructor(z,re){this.ranges=z,this.wordPattern=re}}e.$6O=Dn;class Sn{constructor(z){this.c=z}get autoForwardAction(){return this.c}}e.$7O=Sn;var ie;(function(W){W[W.Queued=1]="Queued",W[W.Running=2]="Running",W[W.Passed=3]="Passed",W[W.Failed=4]="Failed",W[W.Skipped=5]="Skipped",W[W.Errored=6]="Errored"})(ie||(e.TestResultState=ie={}));var ue;(function(W){W[W.Run=1]="Run",W[W.Debug=2]="Debug",W[W.Coverage=3]="Coverage"})(ue||(e.TestRunProfileKind=ue={}));let Le=class{constructor(z=void 0,re=void 0,Se=void 0,He=!1,it=!0){this.include=z,this.exclude=re,this.profile=Se,this.continuous=He,this.preserveFocus=it}};e.$8O=Le,e.$8O=Le=Qe([h],Le);let at=P=class{static diff(z,re,Se){const He=new P(z);return He.expectedOutput=re,He.actualOutput=Se,He}constructor(z){this.message=z}};e.$9O=at,e.$9O=at=P=Qe([h],at);let Et=class{constructor(z){this.id=z}};e.$0O=Et,e.$0O=Et=Qe([h],Et);class Tt{constructor(z,re){this.covered=z,this.total=re,Ai(this)}}e.$$O=Tt;function Ai(W){if(W){if(W.covered>W.total)throw new Error(`The total number of covered items (${W.covered}) cannot be greater than the total (${W.total})`);if(W.total<0)throw new Error(`The number of covered items (${W.total}) cannot be negative`)}}class Xi{static fromDetails(z,re){const Se=new Tt(0,0),He=new Tt(0,0),it=new Tt(0,0);for(const yt of re)if("branches"in yt){Se.total+=1,Se.covered+=yt.executed?1:0;for(const Jt of yt.branches)He.total+=1,He.covered+=Jt.executed?1:0}else it.total+=1,it.covered+=yt.executed?1:0;const dt=new Xi(z,Se,He.total>0?He:void 0,it.total>0?it:void 0);return dt.detailedCoverage=re,dt}constructor(z,re,Se,He,it=[]){this.uri=z,this.statementCoverage=re,this.branchCoverage=Se,this.declarationCoverage=He,this.fromTests=it}}e.$aP=Xi;class Vn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,re,Se=[]){this.executed=z,this.location=re,this.branches=Se}}e.$bP=Vn;class qn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,re,Se){this.executed=z,this.location=re,this.label=Se}}e.$cP=qn;class Gn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,re,Se){this.name=z,this.executed=re,this.location=Se}}e.$dP=Gn;var kn;(function(W){W[W.None=0]="None",W[W.Option=1]="Option",W[W.Default=2]="Default",W[W.Preferred=3]="Preferred"})(kn||(e.ExternalUriOpenerPriority=kn={}));var Cn;(function(W){W[W.Untrusted=0]="Untrusted",W[W.Trusted=1]="Trusted",W[W.Unspecified=2]="Unspecified"})(Cn||(e.WorkspaceTrustState=Cn={}));var In;(function(W){W[W.Notify=1]="Notify",W[W.OpenBrowser=2]="OpenBrowser",W[W.OpenPreview=3]="OpenPreview",W[W.Silent=4]="Silent",W[W.Ignore=5]="Ignore",W[W.OpenBrowserOnce=6]="OpenBrowserOnce"})(In||(e.PortAutoForwardAction=In={}));class Kn{constructor(z,re,Se,He,it,dt){this.kind=z,this.name=re,this.detail=Se,this.uri=He,this.range=it,this.selectionRange=dt}}e.$eP=Kn;class Qn{constructor(z){this.uri=z}}e.$fP=Qn;class Hn{constructor(z,re){this.original=z,this.modified=re}}e.$gP=Hn;class Jn{constructor(z,re,Se,He){this.base=z,this.input1=re,this.input2=Se,this.result=He}}e.$hP=Jn;class Xn{constructor(z,re){this.uri=z,this.viewType=re}}e.$iP=Xn;class Yn{constructor(z){this.viewType=z}}e.$jP=Yn;class Zn{constructor(z,re){this.uri=z,this.notebookType=re}}e.$kP=Zn;class xn{constructor(z,re,Se){this.original=z,this.modified=re,this.notebookType=Se}}e.$lP=xn;class _n{constructor(){}}e.$mP=_n;class er{constructor(z,re){this.uri=z,this.inputBoxUri=re}}e.$nP=er;class tr{constructor(){}}e.$oP=tr;class ir{constructor(z){this.textDiffs=z}}e.$pP=ir;var Pn;(function(W){W[W.Down=0]="Down",W[W.Up=1]="Up"})(Pn||(e.InteractiveSessionVoteDirection=Pn={}));var Rn;(function(W){W[W.Action=1]="Action",W[W.Toolbar=2]="Toolbar"})(Rn||(e.ChatCopyKind=Rn={}));var An;(function(W){W[W.Short=1]="Short",W[W.Medium=2]="Medium",W[W.Full=3]="Full"})(An||(e.ChatVariableLevel=An={}));class nr{constructor(z,re,Se){this.id=z,this.label=re,this.values=Se}}e.$qP=nr;var Tn;(function(W){W[W.Unhelpful=0]="Unhelpful",W[W.Helpful=1]="Helpful",W[W.Undone=2]="Undone",W[W.Accepted=3]="Accepted",W[W.Bug=4]="Bug"})(Tn||(e.InteractiveEditorResponseFeedbackKind=Tn={}));var Nn;(function(W){W[W.Unhelpful=0]="Unhelpful",W[W.Helpful=1]="Helpful"})(Nn||(e.ChatResultFeedbackKind=Nn={}));class rr{constructor(z){if(typeof z!="string"&&z.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof z=="string"?new Ke(z):z}}e.$rP=rr;class sr{constructor(z,re){if(typeof z!="string"&&z.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof z=="string"?new Ke(z):z,this.vulnerabilities=re}}e.$sP=sr;class or{constructor(z,re){this.participant=z,this.command=re}}e.$tP=or;class ar{constructor(z,re,Se){this.title=z,this.message=re,this.data=Se}}e.$uP=ar;class cr{constructor(z,re){this.value=z,this.baseUri=re}}e.$vP=cr;class lr{constructor(z,re){this.value=z,this.title=re}}e.$wP=lr;class ur{constructor(z){this.value=z}}e.$xP=ur;class hr{constructor(z,re){this.value=z,this.task=re}}e.$yP=hr;class dr{constructor(z){if(typeof z!="string"&&z.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof z=="string"?new Ke(z):z}}e.$zP=dr;class fr{constructor(z){this.value=z}}e.$AP=fr;class gr{constructor(z,re){this.value=z,this.iconPath=re}}e.$BP=gr;class mr{constructor(z,re){this.uri=z,this.edits=Array.isArray(re)?re:[re]}}e.$CP=mr;class pr{constructor(z,re,Se,He){this.prompt=z,this.command=re,this.references=Se,this.participant=He}}e.$DP=pr;class $r{constructor(z,re,Se,He){this.response=z,this.result=re,this.participant=Se,this.command=He}}e.$EP=$r;var On;(function(W){W[W.Panel=1]="Panel",W[W.Terminal=2]="Terminal",W[W.Notebook=3]="Notebook",W[W.Editor=4]="Editor"})(On||(e.ChatLocation=On={}));class wr{constructor(z,re,Se){this.document=z,this.selection=re,this.wholeRange=Se}}e.$FP=wr;class br{constructor(z){this.cell=z}}e.$GP=br;var mn;(function(W){W[W.User=1]="User",W[W.Assistant=2]="Assistant",W[W.System=3]="System"})(mn||(e.LanguageModelChatMessageRole=mn={}));class vr{constructor(z,re,Se){this.name=z,this.content=re,this.isError=Se??!1}}e.$HP=vr;class pn{static User(z,re){const Se=new pn(mn.User,typeof z=="string"?z:"",re);return Se.content2=z,Se}static Assistant(z,re){return new pn(mn.Assistant,z,re)}constructor(z,re,Se){this.role=z,this.content=re,this.content2=re,this.name=Se}}e.$IP=pn;class yr{constructor(z,re){this.name=z,this.parameters=re}}e.$JP=yr;class Er{constructor(z){this.value=z}}e.$KP=Er;class Dr{constructor(z){this.content=z}}e.$LP=Dr;class Sr{constructor(z,re){this.content=z,this.name=re}}e.$MP=Sr;class kr{constructor(z,re){this.content=z,this.name=re}}e.$NP=kr;class Ti extends Error{static NotFound(z){return new Ti(z,Ti.NotFound.name)}static NoPermissions(z){return new Ti(z,Ti.NoPermissions.name)}static Blocked(z){return new Ti(z,Ti.Blocked.name)}constructor(z,re,Se){super(z,{cause:Se}),this.name="LanguageModelError",this.code=re??""}}e.$OP=Ti;var Ln;(function(W){W[W.SymbolInformation=1]="SymbolInformation",W[W.CommandInformation=2]="CommandInformation",W[W.SearchInformation=3]="SearchInformation",W[W.SettingInformation=4]="SettingInformation"})(Ln||(e.RelatedInformationType=Ln={}));var Fn;(function(W){W[W.Started=1]="Started",W[W.Recognizing=2]="Recognizing",W[W.Recognized=3]="Recognized",W[W.Stopped=4]="Stopped",W[W.Error=5]="Error"})(Fn||(e.SpeechToTextStatus=Fn={}));var Mn;(function(W){W[W.Started=1]="Started",W[W.Stopped=2]="Stopped",W[W.Error=3]="Error"})(Mn||(e.TextToSpeechStatus=Mn={}));var zn;(function(W){W[W.Recognized=1]="Recognized",W[W.Stopped=2]="Stopped"})(zn||(e.KeywordRecognitionStatus=zn={}));class Cr{constructor(z,re){this.text=z,this.range=re}}e.$PP=Cr;var jn;(function(W){W[W.Invoke=0]="Invoke",W[W.Automatic=1]="Automatic"})(jn||(e.InlineEditTriggerKind=jn={}))}),define(Ne[226],Oe([1,0,5,7]),function(we,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$moc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(v.$sN.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,T,$){if(this.a.size===0)throw new Error("No related information providers registered");const a=this.a.get(A);if(!a)throw new Error("related information provider not found");return await a.provideRelatedInformation(T,$)??[]}getRelatedInformation(A,T,$){return this.c.$getAiRelatedInformation(T,$)}registerRelatedInformationProvider(A,T,$){const a=this.b;return this.b++,this.a.set(a,$),this.c.$registerAiRelatedInformationProvider(a,T),new I.$uN(()=>{this.c.$unregisterAiRelatedInformationProvider(a),this.a.delete(a)})}}e.$moc=C}),define(Ne[90],Oe([1,0,6,5,7,18,117,3,16]),function(we,e,v,I,C,N,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yoc=e.$xoc=void 0,e.$xoc=(0,T.$Ci)("IExtHostAuthentication");let a=class{constructor(c){this.b=new Map,this.c=new v.$je,this.onDidChangeSessions=this.c.event,this.d=new R,this.a=c.getProxy(I.$sN.MainThreadAuthentication)}async getSession(c,S,f,n={}){const o=N.$nn.toKey(c.identifier),s=[...f].sort().join(" ");return await this.d.getOrCreate(`${o} ${S} ${s}`,async()=>{await this.a.$ensureProvider(S);const l=c.displayName||c.name;return this.a.$getSession(S,f,o,l,n)})}async getAccounts(c){return await this.a.$ensureProvider(c),await this.a.$getAccounts(c)}async removeSession(c,S){const f=this.b.get(c);return f?f.provider.removeSession(S):this.a.$removeSession(c,S)}registerAuthenticationProvider(c,S,f,n){if(this.b.get(c))throw new Error(`An authentication provider with id '${c}' is already registered.`);this.b.set(c,{label:S,provider:f,options:n??{supportsMultipleAccounts:!1}});const o=f.onDidChangeSessions(s=>this.a.$sendDidChangeSessions(c,s));return this.a.$registerAuthenticationProvider(c,S,n?.supportsMultipleAccounts??!1),new C.$uN(()=>{o.dispose(),this.b.delete(c),this.a.$unregisterAuthenticationProvider(c)})}async $createSession(c,S,f){const n=this.b.get(c);if(n)return await n.provider.createSession(S,f);throw new Error(`Unable to find authentication provider with handle: ${c}`)}async $removeSession(c,S){const f=this.b.get(c);if(f)return await f.provider.removeSession(S);throw new Error(`Unable to find authentication provider with handle: ${c}`)}async $getSessions(c,S,f){const n=this.b.get(c);if(n)return await n.provider.getSessions(S,f);throw new Error(`Unable to find authentication provider with handle: ${c}`)}$onDidChangeAuthenticationSessions(c,S){return c.startsWith(A.$uM)||this.c.fire({provider:{id:c,label:S}}),Promise.resolve()}};e.$yoc=a,e.$yoc=a=Qe([qe(0,$.$1P)],a);class R{constructor(){this.a=new Map}getOrCreate(c,S){const f=this.a.get(c);if(f)return f;const n=S().finally(()=>this.a.delete(c));return this.a.set(c,n),n}}}),define(Ne[122],Oe([1,0,2,5,7,3,16,11,17,12,19,24]),function(we,e,v,I,C,N,A,T,$,a,R,y){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dpc=e.$Cpc=void 0;let S=class{static{c=this}static{this.c=0}static{this.d=250}constructor(n,o){this.h=o,this.f=new Map,this.g=n.getProxy(I.$sN.MainThreadDecorations)}registerFileDecorationProvider(n,o){const s=c.c++;this.f.set(s,{provider:n,extensionDescription:o}),this.g.$registerDecorationProvider(s,o.identifier.value);const l=n.onDidChangeFileDecorations&&n.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(s,null);return}const r=(0,$.$1b)(i);if(r.length<=c.d){this.g.$onDidChange(s,r);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,r.length);const t=r.map(p=>({uri:p,rank:(0,a.$gf)(p.path,"/")})),g=(0,$.$yb)(t,(p,m)=>p.rank-m.rank||(0,a.$wf)(p.uri.path,m.uri.path)),u=[];e:for(const p of g){let m;for(const d of p){const E=(0,R.$lc)(d.uri.path);if(m!==E&&(m=E,u.push(d.uri)>=c.d))break e}}this.g.$onDidChange(s,u)});return new C.$uN(()=>{l?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(n,o,s){if(!this.f.has(n))return Object.create(null);const l=Object.create(null),{provider:i,extensionDescription:r}=this.f.get(n);return await Promise.all(o.map(async t=>{try{const{uri:g,id:u}=t,p=await Promise.resolve(i.provideFileDecoration(v.URI.revive(g),s));if(!p)return;try{C.$UO.validate(p),p.badge&&typeof p.badge!="string"&&(0,y.$5G)(r,"codiconDecoration"),l[u]=[p.propagate,p.tooltip,p.badge,p.color]}catch(m){this.h.warn(`INVALID decoration from extension '${r.identifier.value}': ${m}`)}}catch(g){this.h.error(g)}})),l}};e.$Cpc=S,e.$Cpc=S=c=Qe([qe(0,A.$1P),qe(1,T.$9j)],S),e.$Dpc=(0,N.$Ci)("IExtHostDecorations")}),define(Ne[227],Oe([1,0,13,2,7,5,15,21,12]),function(we,e,v,I,C,N,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fpc=void 0;class a{static{this.a=0}constructor(y,c,S){this.d=c,this.e=S,this.b=new Map,this.c=y.getProxy(N.$sN.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,c){if(Object.keys(A.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const S=a.a++;this.b.set(S,c),this.c.$registerTextContentProvider(S,y);let f;if(typeof c.onDidChange=="function"){let n;f=c.onDidChange(async o=>{if(o.scheme!==y){this.e.warn(`Provider for scheme '${y}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;n&&await n;const s=this.$provideTextDocumentContent(S,o).then(async l=>{if(!l&&typeof l!="string")return;const i=this.d.getDocument(o);if(!i)return;const r=(0,$.$qf)(l);if(!i.equalLines(r))return this.c.$onVirtualDocumentChange(o,l)}).catch(v.$Y).finally(()=>{n===s&&(n=void 0)});n=s})}return new C.$uN(()=>{this.b.delete(S)&&this.c.$unregisterTextContentProvider(S),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(y,c){const S=this.b.get(y);return S?Promise.resolve(S.provideTextDocumentContent(I.URI.revive(c),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.$Fpc=a}),define(Ne[123],Oe([1,0,61,15,12,283,168,7,17]),function(we,e,v,I,C,N,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5P=e.$4P=void 0,e.$3P=R;const a=new Map;function R(f,n){n?a.set(f,n):a.delete(f)}function y(f){return a.get(f)}class c extends N.$kw{constructor(n,o,s,l,i,r,t){super(o,s,l,i),this.c=n,this.m=r,this.q=t,this.b=!1}dispose(){(0,v.ok)(!this.b),this.b=!0,this.q=!1}equalLines(n){return(0,$.$tb)(this.f,n)}get document(){if(!this.a){const n=this;this.a={get uri(){return n.d},get fileName(){return n.d.fsPath},get isUntitled(){return n.d.scheme===I.Schemas.untitled},get languageId(){return n.m},get version(){return n.h},get isClosed(){return n.b},get isDirty(){return n.q},save(){return n.r()},getText(o){return o?n.s(o):n.getText()},get eol(){return n.g===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return n.f.length},lineAt(o){return n.t(o)},offsetAt(o){return n.u(o)},positionAt(o){return n.v(o)},validateRange(o){return n.w(o)},validatePosition(o){return n.x(o)},getWordRangeAtPosition(o,s){return n.y(o,s)}}}return Object.freeze(this.a)}_acceptLanguageId(n){(0,v.ok)(!this.b),this.m=n}_acceptIsDirty(n){(0,v.ok)(!this.b),this.q=n}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(n){const o=this.w(n);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const s=this.g,l=o.start.line,i=o.end.line,r=[];r.push(this.f[l].substring(o.start.character));for(let t=l+1;t<i;t++)r.push(this.f[t]);return r.push(this.f[i].substring(0,o.end.character)),r.join(s)}t(n){let o;if(n instanceof T.$vN?o=n.line:typeof n=="number"&&(o=n),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new S(o,this.f[o],o===this.f.length-1)}u(n){return n=this.x(n),this.l(),this.j.getPrefixSum(n.line-1)+n.character}v(n){n=Math.floor(n),n=Math.max(0,n),this.l();const o=this.j.getIndexOf(n),s=this.f[o.index].length;return new T.$vN(o.index,Math.min(o.remainder,s))}w(n){if(!(n instanceof T.$wN))throw new Error("Invalid argument");const o=this.x(n.start),s=this.x(n.end);return o===n.start&&s===n.end?n:new T.$wN(o.line,o.character,s.line,s.character)}x(n){if(!(n instanceof T.$vN))throw new Error("Invalid argument");if(this.f.length===0)return n.with(0,0);let{line:o,character:s}=n,l=!1;if(o<0)o=0,s=0,l=!0;else if(o>=this.f.length)o=this.f.length-1,s=this.f[o].length,l=!0;else{const i=this.f[o].length;s<0?(s=0,l=!0):s>i&&(s=i,l=!0)}return l?new T.$vN(o,s):n}y(n,o){const s=this.x(n);if(!o)o=y(this.m);else if((0,C.$pf)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const l=(0,A.$mt)(s.character+1,(0,A.$kt)(o),this.f[s.line],0);if(l)return new T.$wN(s.line,l.startColumn-1,s.line,l.endColumn-1)}}e.$4P=c;class S{constructor(n,o,s){this.a=n,this.b=o,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new T.$wN(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new T.$wN(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$5P=S}),define(Ne[228],Oe([1,0,5,7]),function(we,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ipc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(v.$sN.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,T,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const a=this.a.get(A);if(!a)throw new Error("Embedding vector provider not found");const R=await a.provideEmbeddingVector(T,$);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(A,T,$){const a=this.b;return this.b++,this.a.set(a,$),this.c.$registerAiEmbeddingVectorProvider(T,a),new I.$uN(()=>{this.c.$unregisterAiEmbeddingVectorProvider(a),this.a.delete(a)})}}e.$Ipc=C}),define(Ne[68],Oe([1,0,5,29,7,22,3,16,50,4,10,23,15]),function(we,e,v,I,C,N,A,T,$,a,R,y,c){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ooc=e.$Noc=void 0,I=Ve(I);let f=S=class{constructor(o,s){this.b=new Map,this.c=new R.$Lh,this.a=o.getProxy(v.$sN.MainThreadFileSystem);const l=this;this.value=Object.freeze({async stat(i){try{let r;const t=l.b.get(i.scheme);return t?(await l.a.$ensureActivation(i.scheme),r=await t.impl.stat(i)):r=await l.a.$stat(i),{type:r.type,ctime:r.ctime,mtime:r.mtime,size:r.size,permissions:r.permissions===I.FilePermission.Readonly?1:void 0}}catch(r){S.e(r)}},async readDirectory(i){try{const r=l.b.get(i.scheme);return r?(await l.a.$ensureActivation(i.scheme),(await r.impl.readDirectory(i)).slice()):await l.a.$readdir(i)}catch(r){return S.e(r)}},async createDirectory(i){try{const r=l.b.get(i.scheme);return r&&!r.isReadonly?(await l.a.$ensureActivation(i.scheme),await l.d(r.impl,r.extUri,i)):await l.a.$mkdir(i)}catch(r){return S.e(r)}},async readFile(i){try{const r=l.b.get(i.scheme);return r?(await l.a.$ensureActivation(i.scheme),(await r.impl.readFile(i)).slice()):(await l.a.$readFile(i)).buffer}catch(r){return S.e(r)}},async writeFile(i,r){try{const t=l.b.get(i.scheme);return t&&!t.isReadonly?(await l.a.$ensureActivation(i.scheme),await l.d(t.impl,t.extUri,t.extUri.dirname(i)),await l.c.queueFor(i,()=>Promise.resolve(t.impl.writeFile(i,r,{create:!0,overwrite:!0})))):await l.a.$writeFile(i,N.$Le.wrap(r))}catch(t){return S.e(t)}},async delete(i,r){try{const t=l.b.get(i.scheme);return t&&!t.isReadonly&&!r?.useTrash?(await l.a.$ensureActivation(i.scheme),await t.impl.delete(i,{recursive:!1,...r})):await l.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...r})}catch(t){return S.e(t)}},async rename(i,r,t){try{return await l.a.$rename(i,r,{overwrite:!1,...t})}catch(g){return S.e(g)}},async copy(i,r,t){try{return await l.a.$copy(i,r,{overwrite:!1,...t})}catch(g){return S.e(g)}},isWritableFileSystem(i){const r=s.getCapabilities(i);if(typeof r=="number")return!(r&I.FileSystemProviderCapabilities.Readonly)}})}async d(o,s,l){const i=[];for(;!s.isEqual(l,s.dirname(l));)try{if(!((await o.stat(l)).type&I.FileType.Directory))throw C.$LO.FileExists(`Unable to create folder '${l.scheme===c.Schemas.file?l.fsPath:l.toString(!0)}' that already exists but is not a directory`);break}catch(r){if(I.$ml(r)!==I.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(s.basename(l)),l=s.dirname(l)}for(let r=i.length-1;r>=0;r--){l=s.joinPath(l,i[r]);try{await o.createDirectory(l)}catch(t){if(I.$ml(t)!==I.FileSystemProviderErrorCode.FileExists)throw t}}}static e(o){if(o instanceof C.$LO)throw o;if(o instanceof I.$il)switch(o.code){case I.FileSystemProviderErrorCode.FileExists:throw C.$LO.FileExists(o.message);case I.FileSystemProviderErrorCode.FileNotFound:throw C.$LO.FileNotFound(o.message);case I.FileSystemProviderErrorCode.FileNotADirectory:throw C.$LO.FileNotADirectory(o.message);case I.FileSystemProviderErrorCode.FileIsADirectory:throw C.$LO.FileIsADirectory(o.message);case I.FileSystemProviderErrorCode.NoPermissions:throw C.$LO.NoPermissions(o.message);case I.FileSystemProviderErrorCode.Unavailable:throw C.$LO.Unavailable(o.message);default:throw new C.$LO(o.message,o.name)}if(!(o instanceof Error))throw new C.$LO(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw C.$LO.Unavailable(o.message);switch(o.name){case I.FileSystemProviderErrorCode.FileExists:throw C.$LO.FileExists(o.message);case I.FileSystemProviderErrorCode.FileNotFound:throw C.$LO.FileNotFound(o.message);case I.FileSystemProviderErrorCode.FileNotADirectory:throw C.$LO.FileNotADirectory(o.message);case I.FileSystemProviderErrorCode.FileIsADirectory:throw C.$LO.FileIsADirectory(o.message);case I.FileSystemProviderErrorCode.NoPermissions:throw C.$LO.NoPermissions(o.message);case I.FileSystemProviderErrorCode.Unavailable:throw C.$LO.Unavailable(o.message);default:throw new C.$LO(o.message,o.name)}}addFileSystemProvider(o,s,l){return this.b.set(o,{impl:s,extUri:l?.isCaseSensitive?y.$6g:y.$8g,isReadonly:!!l?.isReadonly}),(0,a.$Rc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??y.$6g}};e.$Noc=f,e.$Noc=f=S=Qe([qe(0,T.$1P),qe(1,$.$roc)],f),e.$Ooc=(0,A.$Ci)("IExtHostConsumerFileSystem")}),define(Ne[91],Oe([1,0,3,26,11,68,2]),function(we,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qoc=e.$Poc=void 0,e.$Poc=(0,v.$Ci)("IExtensionStoragePaths");let T=class{constructor(a,R,y){this.d=R,this.f=y,this.a=a.workspace??void 0,this.b=a.environment,this.whenReady=this.h().then(c=>this.c=c)}async g(a){return A.URI.joinPath(this.b.workspaceStorageHome,a)}async h(){if(!this.a)return Promise.resolve(void 0);const a=this.a.id,R=await this.g(a);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(y){this.d.error("[ExtHostStorage]",y);return}}workspaceValue(a){if(this.c)return A.URI.joinPath(this.c,a.identifier.value)}globalValue(a){return A.URI.joinPath(this.b.globalStorageHome,a.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Qoc=T,e.$Qoc=T=Qe([qe(0,I.$eQ),qe(1,C.$9j),qe(2,N.$Ooc)],T)}),define(Ne[229],Oe([1,0,7,16,6]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nqc=void 0;let N=class{constructor(T){this.a=new v.$VO(v.ColorThemeKind.Dark),this.b=new C.$je}get activeColorTheme(){return this.a}$onColorThemeChange(T){let $;switch(T){case"light":$=v.ColorThemeKind.Light;break;case"hcDark":$=v.ColorThemeKind.HighContrast;break;case"hcLight":$=v.ColorThemeKind.HighContrastLight;break;default:$=v.ColorThemeKind.Dark}this.a=new v.$VO($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$nqc=N,e.$nqc=N=Qe([qe(0,I.$1P)],N)}),define(Ne[92],Oe([1,0,21,6,4,9,3,11,182,5,26,16,7]),function(we,e,v,I,C,N,A,T,$,a,R,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TFb=e.$SFb=e.TunnelDtoConverter=void 0,N=Ve(N),c=Ve(c);class S extends $.$Jw{}var f;(function(o){function s(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:i.protocol}}o.fromApiTunnel=s;function l(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==$.TunnelPrivacyId.ConstantPrivate&&i.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}o.fromServiceTunnel=l})(f||(e.TunnelDtoConverter=f={})),e.$SFb=(0,A.$Ci)("IExtHostTunnelService");let n=class extends C.$Tc{constructor(s,l,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new I.$je,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(a.$sN.MainThreadTunnelService)}async openTunnel(s,l){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${l.remoteAddress.host}:${l.remoteAddress.port}.`);const i=await this.a.$openTunnel(l,s.displayName);if(i){const r=new S(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(r),r}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,l){s.portRange===void 0&&s.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:s,provider:l}),this.a.$registerPortsAttributesProvider(s,i),new c.$uN(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(s,l,i,r,t){const g=[];for(const p of s){const m=this.r.get(p);if(!m)return[];g.push(...await Promise.all(l.map(async d=>{let E;try{E=await m.provider.providePortAttributes({port:d,pid:i,commandLine:r},t)}catch{E=await m.provider.providePortAttributes(d,i,r,t)}return{providedAttributes:E,port:d}})))}const u=g.filter(p=>!!p.providedAttributes);return u.length>0?u.map(p=>({autoForwardAction:p.providedAttributes.autoForwardAction,port:p.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,l){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(r,t)=>await s.provideTunnel(r,t,v.CancellationToken.None)??void 0;const i=l.tunnelFeatures?{elevation:!!l.tunnelFeatures?.elevation,privacyOptions:l.tunnelFeatures?.privacyOptions,protocol:l.tunnelFeatures.protocol===void 0?!0:l.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,C.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,l){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const i=s.tunnelFactory??(l?this.w(l):void 0);if(i){this.b=i;let r=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&r.length===0&&(r=[{id:"private",label:N.localize(10656,null),themeIcon:"lock"},{id:"public",label:N.localize(10657,null),themeIcon:"eye"}]);const t=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:r,protocol:!0}:void 0;this.a.$setTunnelProvider(t)}}else this.b=void 0;return(0,C.$Rc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,l){if(this.g.has(s.host)){const i=this.g.get(s.host);i.has(s.port)&&(l&&i.get(s.port).disposeListener.dispose(),await i.get(s.port).tunnel.dispose(),i.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,l){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(s,l);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const r=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),r===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const t=this.B(r.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(r.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:r,disposeListener:t}),f.fromApiTunnel(r)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(s){const l=await Promise.all(s.map(r=>this.f(r.host,r.port,r.detail??""))),i=s.filter((r,t)=>l[t]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(r=>r.port).join(", ")} to ${i.map(r=>r.port).join(", ")}`),i}};e.$TFb=n,e.$TFb=n=Qe([qe(0,y.$1P),qe(1,R.$eQ),qe(2,T.$9j)],n)}),define(Ne[8],Oe([1,0,17,22,150,230,59,28,137,40,72,25,143,23,34,14,2,105,32,158,93,52,107,76,116,114,115,206,80,89,54,55,203,7]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S,f,n,o,s,l,i,r,t,g,u,p,m,d,E,D,w,k,P,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$XP=ae,e.$YP=oe,e.$ZP=Ce,A=Ve(A),l=Ve(l),i=Ve(i),r=Ve(r),E=Ve(E),w=Ve(w),b=Ve(b);var M;(function(ye){function Re(H){const{selectionStartLineNumber:Ee,selectionStartColumn:We,positionLineNumber:Ze,positionColumn:Ge}=H,ut=new b.$vN(Ee-1,We-1),It=new b.$vN(Ze-1,Ge-1);return new b.$xN(ut,It)}ye.to=Re;function le(H){const{anchor:Ee,active:We}=H;return{selectionStartLineNumber:Ee.line+1,selectionStartColumn:Ee.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}ye.from=le})(M||(e.Selection=M={}));var O;(function(ye){function Re(H){if(!H)return;const{start:Ee,end:We}=H;return{startLineNumber:Ee.line+1,startColumn:Ee.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}ye.from=Re;function le(H){if(!H)return;const{startLineNumber:Ee,startColumn:We,endLineNumber:Ze,endColumn:Ge}=H;return new b.$wN(Ee-1,We-1,Ze-1,Ge-1)}ye.to=le})(O||(e.Range=O={}));var F;(function(ye){function Re(H){return{uri:H.uri,range:O.from(H.range)}}ye.from=Re;function le(H){return new b.$GN(o.URI.revive(H.uri),O.to(H.range))}ye.to=le})(F||(e.Location=F={}));var q;(function(ye){function Re(le){switch(le){case i.StandardTokenType.Comment:return b.StandardTokenType.Comment;case i.StandardTokenType.Other:return b.StandardTokenType.Other;case i.StandardTokenType.RegEx:return b.StandardTokenType.RegEx;case i.StandardTokenType.String:return b.StandardTokenType.String}}ye.to=Re})(q||(e.TokenType=q={}));var B;(function(ye){function Re(H){return new b.$vN(H.lineNumber-1,H.column-1)}ye.to=Re;function le(H){return{lineNumber:H.line+1,column:H.character+1}}ye.from=le})(B||(e.Position=B={}));var L;(function(ye){function Re(Ee,We,Ze){return(0,v.$Gb)((0,v.$1b)(Ee).map(Ge=>le(Ge,We,Ze)))}ye.from=Re;function le(Ee,We,Ze){if(typeof Ee=="string")return{$serialized:!0,language:Ee,isBuiltin:Ze?.isBuiltin};if(Ee)return{$serialized:!0,language:Ee.language,scheme:H(Ee.scheme,We),pattern:xe.from(Ee.pattern)??void 0,exclusive:Ee.exclusive,notebookType:Ee.notebookType,isBuiltin:Ze?.isBuiltin}}function H(Ee,We){return We&&typeof Ee=="string"?We.transformOutgoingScheme(Ee):Ee}})(L||(e.DocumentSelector=L={}));var Y;(function(ye){function Re(H){switch(H){case b.DiagnosticTag.Unnecessary:return g.MarkerTag.Unnecessary;case b.DiagnosticTag.Deprecated:return g.MarkerTag.Deprecated}}ye.from=Re;function le(H){switch(H){case g.MarkerTag.Unnecessary:return b.DiagnosticTag.Unnecessary;case g.MarkerTag.Deprecated:return b.DiagnosticTag.Deprecated;default:return}}ye.to=le})(Y||(e.DiagnosticTag=Y={}));var Z;(function(ye){function Re(H){let Ee;return H.code&&((0,n.$cg)(H.code)||(0,n.$gg)(H.code)?Ee=String(H.code):Ee={value:String(H.code.value),target:H.code.target}),{...O.from(H.range),message:H.message,source:H.source,code:Ee,severity:_.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(fe.from),tags:Array.isArray(H.tags)?(0,v.$Gb)(H.tags.map(Y.from)):void 0}}ye.from=Re;function le(H){const Ee=new b.$IN(O.to(H),H.message,_.to(H.severity));return Ee.source=H.source,Ee.code=(0,n.$cg)(H.code)?H.code:H.code?.value,Ee.relatedInformation=H.relatedInformation&&H.relatedInformation.map(fe.to),Ee.tags=H.tags&&(0,v.$Gb)(H.tags.map(Y.to)),Ee}ye.to=le})(Z||(e.Diagnostic=Z={}));var fe;(function(ye){function Re(H){return{...O.from(H.location.range),message:H.message,resource:H.location.uri}}ye.from=Re;function le(H){return new b.$HN(new b.$GN(H.resource,O.to(H)),H.message)}ye.to=le})(fe||(e.DiagnosticRelatedInformation=fe={}));var _;(function(ye){function Re(H){switch(H){case b.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}ye.from=Re;function le(H){switch(H){case g.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}ye.to=le})(_||(e.DiagnosticSeverity=_={}));var ge;(function(ye){function Re(H){return typeof H=="number"&&H>=b.ViewColumn.One?H-1:H===b.ViewColumn.Beside?h.$nE:h.$mE}ye.from=Re;function le(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}ye.to=le})(ge||(e.ViewColumn=ge={}));function se(ye){return typeof ye.range<"u"}function ae(ye){return ye.length===0?!0:!!se(ye[0])}var $e;(function(ye){function Re(Ge){return Ge.map(ye.from)}ye.fromMany=Re;function le(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function H(Ge){let ut;if(le(Ge)){const{language:Ft,value:li}=Ge;ut={value:"```"+Ft+`
`+li+"\n```\n"}}else b.$WN.isMarkdownString(Ge)?ut={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?ut={value:Ge}:ut={value:""};const It=Object.create(null);ut.uris=It;const Ht=Ft=>{try{let li=o.URI.parse(Ft,!0);li=li.with({query:Ee(li.query,It)}),It[Ft]=li}catch{}return""},ci=new $.marked.Renderer;return ci.link=Ht,ci.image=Ft=>typeof Ft=="string"?Ht(A.$8k(Ft).href):"",(0,$.marked)(ut.value,{renderer:ci}),ut}ye.from=H;function Ee(Ge,ut){if(!Ge)return Ge;let It;try{It=(0,a.$$h)(Ge)}catch{}if(!It)return Ge;let Ht=!1;return It=(0,y.$co)(It,ci=>{if(o.URI.isUri(ci)){const Ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[Ft]=ci,Ht=!0,Ft}else return}),Ht?JSON.stringify(It):Ge}function We(Ge){const ut=new b.$WN(Ge.value,Ge.supportThemeIcons);return ut.isTrusted=Ge.isTrusted,ut.supportHtml=Ge.supportHtml,ut.baseUri=Ge.baseUri?o.URI.from(Ge.baseUri):void 0,ut}ye.to=We;function Ze(Ge){if(Ge)return typeof Ge=="string"?Ge:ye.from(Ge)}ye.fromStrict=Ze})($e||(e.MarkdownString=$e={}));function oe(ye){return ae(ye)?ye.map(Re=>({range:O.from(Re.range),hoverMessage:Array.isArray(Re.hoverMessage)?$e.fromMany(Re.hoverMessage):Re.hoverMessage?$e.from(Re.hoverMessage):void 0,renderOptions:Re.renderOptions})):ye.map(Re=>({range:O.from(Re)}))}function Ce(ye){return typeof ye>"u"?ye:typeof ye=="string"?o.URI.file(ye):ye}var Fe;(function(ye){function Re(le){return typeof le>"u"?le:{contentText:le.contentText,contentIconPath:le.contentIconPath?Ce(le.contentIconPath):void 0,border:le.border,borderColor:le.borderColor,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,color:le.color,backgroundColor:le.backgroundColor,margin:le.margin,width:le.width,height:le.height}}ye.from=Re})(Fe||(e.ThemableDecorationAttachmentRenderOptions=Fe={}));var X;(function(ye){function Re(le){return typeof le>"u"?le:{backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?Ce(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?Fe.from(le.before):void 0,after:le.after?Fe.from(le.after):void 0}}ye.from=Re})(X||(e.ThemableDecorationRenderOptions=X={}));var V;(function(ye){function Re(le){if(typeof le>"u")return le;switch(le){case b.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case b.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case b.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case b.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}ye.from=Re})(V||(e.DecorationRangeBehavior=V={}));var te;(function(ye){function Re(le){return{isWholeLine:le.isWholeLine,rangeBehavior:le.rangeBehavior?V.from(le.rangeBehavior):void 0,overviewRulerLane:le.overviewRulerLane,light:le.light?X.from(le.light):void 0,dark:le.dark?X.from(le.dark):void 0,backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?Ce(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?Fe.from(le.before):void 0,after:le.after?Fe.from(le.after):void 0}}ye.from=Re})(te||(e.DecorationRenderOptions=te={}));var ve;(function(ye){function Re(H){return{text:H.newText,eol:H.newEol&&Ue.from(H.newEol),range:O.from(H.range)}}ye.from=Re;function le(H){const Ee=new b.$BN(O.to(H.range),H.text);return Ee.newEol=typeof H.eol>"u"?void 0:Ue.to(H.eol),Ee}ye.to=le})(ve||(e.TextEdit=ve={}));var ce;(function(ye){function Re(H,Ee){const We={edits:[]};if(H instanceof b.$EN){const Ze=new T.$Ac;for(const Ge of H._allEntries())Ge._type===b.FileEditType.File&&o.URI.isUri(Ge.to)&&Ge.from===void 0&&Ze.add(Ge.to);for(const Ge of H._allEntries())if(Ge._type===b.FileEditType.File){let ut;Ge.options?.contents&&(ArrayBuffer.isView(Ge.options.contents)?ut={type:"base64",value:(0,I.$6e)(I.$Le.wrap(Ge.options.contents))}:ut={type:"dataTransferItem",id:Ge.options.contents._itemId}),We.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contents:ut},metadata:Ge.metadata})}else Ge._type===b.FileEditType.Text?We.edits.push({resource:Ge.uri,textEdit:ve.from(Ge.edit),versionId:Ze.has(Ge.uri)?void 0:Ee?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===b.FileEditType.Snippet?We.edits.push({resource:Ge.uri,textEdit:{range:O.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:Ze.has(Ge.uri)?void 0:Ee?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===b.FileEditType.Cell?We.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Ee?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===b.FileEditType.CellReplace&&We.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Ee?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:w.CellEditType.Replace,index:Ge.index,count:Ge.count,cells:Ge.cells.map(Ye.from)}})}return We}ye.from=Re;function le(H){const Ee=new b.$EN,We=new T.$zc;for(const Ze of H.edits)if(Ze.textEdit){const Ge=Ze,ut=o.URI.revive(Ge.resource),It=O.to(Ge.textEdit.range),Ht=Ge.textEdit.text,ci=Ge.textEdit.insertAsSnippet;let Ft;ci?Ft=b.$DN.replace(It,new b.$FN(Ht)):Ft=b.$BN.replace(It,Ht);const li=We.get(ut);li?li.push(Ft):We.set(ut,[Ft])}else Ee.renameFile(o.URI.revive(Ze.oldResource),o.URI.revive(Ze.newResource),Ze.options);for(const[Ze,Ge]of We)Ee.set(Ze,Ge);return Ee}ye.to=le})(ce||(e.WorkspaceEdit=ce={}));var be;(function(ye){const Re=Object.create(null);Re[b.SymbolKind.File]=r.SymbolKind.File,Re[b.SymbolKind.Module]=r.SymbolKind.Module,Re[b.SymbolKind.Namespace]=r.SymbolKind.Namespace,Re[b.SymbolKind.Package]=r.SymbolKind.Package,Re[b.SymbolKind.Class]=r.SymbolKind.Class,Re[b.SymbolKind.Method]=r.SymbolKind.Method,Re[b.SymbolKind.Property]=r.SymbolKind.Property,Re[b.SymbolKind.Field]=r.SymbolKind.Field,Re[b.SymbolKind.Constructor]=r.SymbolKind.Constructor,Re[b.SymbolKind.Enum]=r.SymbolKind.Enum,Re[b.SymbolKind.Interface]=r.SymbolKind.Interface,Re[b.SymbolKind.Function]=r.SymbolKind.Function,Re[b.SymbolKind.Variable]=r.SymbolKind.Variable,Re[b.SymbolKind.Constant]=r.SymbolKind.Constant,Re[b.SymbolKind.String]=r.SymbolKind.String,Re[b.SymbolKind.Number]=r.SymbolKind.Number,Re[b.SymbolKind.Boolean]=r.SymbolKind.Boolean,Re[b.SymbolKind.Array]=r.SymbolKind.Array,Re[b.SymbolKind.Object]=r.SymbolKind.Object,Re[b.SymbolKind.Key]=r.SymbolKind.Key,Re[b.SymbolKind.Null]=r.SymbolKind.Null,Re[b.SymbolKind.EnumMember]=r.SymbolKind.EnumMember,Re[b.SymbolKind.Struct]=r.SymbolKind.Struct,Re[b.SymbolKind.Event]=r.SymbolKind.Event,Re[b.SymbolKind.Operator]=r.SymbolKind.Operator,Re[b.SymbolKind.TypeParameter]=r.SymbolKind.TypeParameter;function le(Ee){return typeof Re[Ee]=="number"?Re[Ee]:r.SymbolKind.Property}ye.from=le;function H(Ee){for(const We in Re)if(Re[We]===Ee)return Number(We);return b.SymbolKind.Property}ye.to=H})(be||(e.SymbolKind=be={}));var he;(function(ye){function Re(H){switch(H){case b.SymbolTag.Deprecated:return r.SymbolTag.Deprecated}}ye.from=Re;function le(H){switch(H){case r.SymbolTag.Deprecated:return b.SymbolTag.Deprecated}}ye.to=le})(he||(e.SymbolTag=he={}));var J;(function(ye){function Re(H){return{name:H.name,kind:be.from(H.kind),tags:H.tags&&H.tags.map(he.from),containerName:H.containerName,location:ze.from(H.location)}}ye.from=Re;function le(H){const Ee=new b.$NN(H.name,be.to(H.kind),H.containerName,ze.to(H.location));return Ee.tags=H.tags&&H.tags.map(he.to),Ee}ye.to=le})(J||(e.WorkspaceSymbol=J={}));var x;(function(ye){function Re(H){const Ee={name:H.name||"!!MISSING: name!!",detail:H.detail,range:O.from(H.range),selectionRange:O.from(H.selectionRange),kind:be.from(H.kind),tags:H.tags?.map(he.from)??[]};return H.children&&(Ee.children=H.children.map(Re)),Ee}ye.from=Re;function le(H){const Ee=new b.$ON(H.name,H.detail,be.to(H.kind),O.to(H.range),O.to(H.selectionRange));return(0,v.$Kb)(H.tags)&&(Ee.tags=H.tags.map(he.to)),H.children&&(Ee.children=H.children.map(le)),Ee}ye.to=le})(x||(e.DocumentSymbol=x={}));var me;(function(ye){function Re(H){const Ee=new b.$SN(be.to(H.kind),H.name,H.detail||"",o.URI.revive(H.uri),O.to(H.range),O.to(H.selectionRange));return Ee._sessionId=H._sessionId,Ee._itemId=H._itemId,Ee}ye.to=Re;function le(H,Ee,We){if(Ee=Ee??H._sessionId,We=We??H._itemId,Ee===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:We,name:H.name,detail:H.detail,kind:be.from(H.kind),uri:H.uri,range:O.from(H.range),selectionRange:O.from(H.selectionRange),tags:H.tags?.map(he.from)}}ye.from=le})(me||(e.CallHierarchyItem=me={}));var pe;(function(ye){function Re(le){return new b.$TN(me.to(le.from),le.fromRanges.map(H=>O.to(H)))}ye.to=Re})(pe||(e.CallHierarchyIncomingCall=pe={}));var Ae;(function(ye){function Re(le){return new b.$UN(me.to(le.to),le.fromRanges.map(H=>O.to(H)))}ye.to=Re})(Ae||(e.CallHierarchyOutgoingCall=Ae={}));var ze;(function(ye){function Re(H){return{range:H.range&&O.from(H.range),uri:H.uri}}ye.from=Re;function le(H){return new b.$GN(o.URI.revive(H.uri),O.to(H.range))}ye.to=le})(ze||(e.location=ze={}));var ke;(function(ye){function Re(H){const Ee=H,We=H;return{originSelectionRange:Ee.originSelectionRange?O.from(Ee.originSelectionRange):void 0,uri:Ee.targetUri?Ee.targetUri:We.uri,range:O.from(Ee.targetRange?Ee.targetRange:We.range),targetSelectionRange:Ee.targetSelectionRange?O.from(Ee.targetSelectionRange):void 0}}ye.from=Re;function le(H){return{targetUri:o.URI.revive(H.uri),targetRange:O.to(H.range),targetSelectionRange:H.targetSelectionRange?O.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?O.to(H.originSelectionRange):void 0}}ye.to=le})(ke||(e.DefinitionLink=ke={}));var Pe;(function(ye){function Re(H){return{range:O.from(H.range),contents:$e.fromMany(H.contents),canIncreaseVerbosity:H.canIncreaseVerbosity,canDecreaseVerbosity:H.canDecreaseVerbosity}}ye.from=Re;function le(H){const Ee=H.contents.map($e.to),We=O.to(H.range),Ze=H.canIncreaseVerbosity,Ge=H.canDecreaseVerbosity;return new b.$KN(Ee,We,Ze,Ge)}ye.to=le})(Pe||(e.Hover=Pe={}));var Te;(function(ye){function Re(H){return{range:O.from(H.range),expression:H.expression}}ye.from=Re;function le(H){return new b.$FO(O.to(H.range),H.expression)}ye.to=le})(Te||(e.EvaluatableExpression=Te={}));var U;(function(ye){function Re(H){if(H instanceof b.$GO)return{type:"text",range:O.from(H.range),text:H.text};if(H instanceof b.$HO)return{type:"variable",range:O.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof b.$IO)return{type:"expression",range:O.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}ye.from=Re;function le(H){switch(H.type){case"text":return{range:O.to(H.range),text:H.text};case"variable":return{range:O.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:O.to(H.range),expression:H.expression}}}ye.to=le})(U||(e.InlineValue=U={}));var j;(function(ye){function Re(H){return{frameId:H.frameId,stoppedLocation:O.from(H.stoppedLocation)}}ye.from=Re;function le(H){return new b.$JO(H.frameId,O.to(H.stoppedLocation))}ye.to=le})(j||(e.InlineValueContext=j={}));var G;(function(ye){function Re(H){return{range:O.from(H.range),kind:H.kind}}ye.from=Re;function le(H){return new b.$LN(O.to(H.range),H.kind)}ye.to=le})(G||(e.DocumentHighlight=G={}));var Q;(function(ye){function Re(H){return{uri:H.uri,highlights:H.highlights.map(G.from)}}ye.from=Re;function le(H){return new b.$MN(o.URI.revive(H.uri),H.highlights.map(G.to))}ye.to=le})(Q||(e.MultiDocumentHighlight=Q={}));var ne;(function(ye){function Re(le){switch(le){case r.CompletionTriggerKind.TriggerCharacter:return b.CompletionTriggerKind.TriggerCharacter;case r.CompletionTriggerKind.TriggerForIncompleteCompletions:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case r.CompletionTriggerKind.Invoke:default:return b.CompletionTriggerKind.Invoke}}ye.to=Re})(ne||(e.CompletionTriggerKind=ne={}));var de;(function(ye){function Re(le){return{triggerKind:ne.to(le.triggerKind),triggerCharacter:le.triggerCharacter}}ye.to=Re})(de||(e.CompletionContext=de={}));var Ie;(function(ye){function Re(H){switch(H){case b.CompletionItemTag.Deprecated:return r.CompletionItemTag.Deprecated}}ye.from=Re;function le(H){switch(H){case r.CompletionItemTag.Deprecated:return b.CompletionItemTag.Deprecated}}ye.to=le})(Ie||(e.CompletionItemTag=Ie={}));var je;(function(ye){const Re=new Map([[b.CompletionItemKind.Method,r.CompletionItemKind.Method],[b.CompletionItemKind.Function,r.CompletionItemKind.Function],[b.CompletionItemKind.Constructor,r.CompletionItemKind.Constructor],[b.CompletionItemKind.Field,r.CompletionItemKind.Field],[b.CompletionItemKind.Variable,r.CompletionItemKind.Variable],[b.CompletionItemKind.Class,r.CompletionItemKind.Class],[b.CompletionItemKind.Interface,r.CompletionItemKind.Interface],[b.CompletionItemKind.Struct,r.CompletionItemKind.Struct],[b.CompletionItemKind.Module,r.CompletionItemKind.Module],[b.CompletionItemKind.Property,r.CompletionItemKind.Property],[b.CompletionItemKind.Unit,r.CompletionItemKind.Unit],[b.CompletionItemKind.Value,r.CompletionItemKind.Value],[b.CompletionItemKind.Constant,r.CompletionItemKind.Constant],[b.CompletionItemKind.Enum,r.CompletionItemKind.Enum],[b.CompletionItemKind.EnumMember,r.CompletionItemKind.EnumMember],[b.CompletionItemKind.Keyword,r.CompletionItemKind.Keyword],[b.CompletionItemKind.Snippet,r.CompletionItemKind.Snippet],[b.CompletionItemKind.Text,r.CompletionItemKind.Text],[b.CompletionItemKind.Color,r.CompletionItemKind.Color],[b.CompletionItemKind.File,r.CompletionItemKind.File],[b.CompletionItemKind.Reference,r.CompletionItemKind.Reference],[b.CompletionItemKind.Folder,r.CompletionItemKind.Folder],[b.CompletionItemKind.Event,r.CompletionItemKind.Event],[b.CompletionItemKind.Operator,r.CompletionItemKind.Operator],[b.CompletionItemKind.TypeParameter,r.CompletionItemKind.TypeParameter],[b.CompletionItemKind.Issue,r.CompletionItemKind.Issue],[b.CompletionItemKind.User,r.CompletionItemKind.User]]);function le(We){return Re.get(We)??r.CompletionItemKind.Property}ye.from=le;const H=new Map([[r.CompletionItemKind.Method,b.CompletionItemKind.Method],[r.CompletionItemKind.Function,b.CompletionItemKind.Function],[r.CompletionItemKind.Constructor,b.CompletionItemKind.Constructor],[r.CompletionItemKind.Field,b.CompletionItemKind.Field],[r.CompletionItemKind.Variable,b.CompletionItemKind.Variable],[r.CompletionItemKind.Class,b.CompletionItemKind.Class],[r.CompletionItemKind.Interface,b.CompletionItemKind.Interface],[r.CompletionItemKind.Struct,b.CompletionItemKind.Struct],[r.CompletionItemKind.Module,b.CompletionItemKind.Module],[r.CompletionItemKind.Property,b.CompletionItemKind.Property],[r.CompletionItemKind.Unit,b.CompletionItemKind.Unit],[r.CompletionItemKind.Value,b.CompletionItemKind.Value],[r.CompletionItemKind.Constant,b.CompletionItemKind.Constant],[r.CompletionItemKind.Enum,b.CompletionItemKind.Enum],[r.CompletionItemKind.EnumMember,b.CompletionItemKind.EnumMember],[r.CompletionItemKind.Keyword,b.CompletionItemKind.Keyword],[r.CompletionItemKind.Snippet,b.CompletionItemKind.Snippet],[r.CompletionItemKind.Text,b.CompletionItemKind.Text],[r.CompletionItemKind.Color,b.CompletionItemKind.Color],[r.CompletionItemKind.File,b.CompletionItemKind.File],[r.CompletionItemKind.Reference,b.CompletionItemKind.Reference],[r.CompletionItemKind.Folder,b.CompletionItemKind.Folder],[r.CompletionItemKind.Event,b.CompletionItemKind.Event],[r.CompletionItemKind.Operator,b.CompletionItemKind.Operator],[r.CompletionItemKind.TypeParameter,b.CompletionItemKind.TypeParameter],[r.CompletionItemKind.User,b.CompletionItemKind.User],[r.CompletionItemKind.Issue,b.CompletionItemKind.Issue]]);function Ee(We){return H.get(We)??b.CompletionItemKind.Property}ye.to=Ee})(je||(e.CompletionItemKind=je={}));var Ke;(function(ye){function Re(le,H){const Ee=new b.$3N(le.label);return Ee.insertText=le.insertText,Ee.kind=je.to(le.kind),Ee.tags=le.tags?.map(Ie.to),Ee.detail=le.detail,Ee.documentation=A.$2k(le.documentation)?$e.to(le.documentation):le.documentation,Ee.sortText=le.sortText,Ee.filterText=le.filterText,Ee.preselect=le.preselect,Ee.commitCharacters=le.commitCharacters,l.$Kt.isIRange(le.range)?Ee.range=O.to(le.range):typeof le.range=="object"&&(Ee.range={inserting:O.to(le.range.insert),replacing:O.to(le.range.replace)}),Ee.keepWhitespace=typeof le.insertTextRules>"u"?!1:!!(le.insertTextRules&r.CompletionItemInsertTextRule.KeepWhitespace),typeof le.insertTextRules<"u"&&le.insertTextRules&r.CompletionItemInsertTextRule.InsertAsSnippet?Ee.insertText=new b.$FN(le.insertText):(Ee.insertText=le.insertText,Ee.textEdit=Ee.range instanceof b.$wN?new b.$BN(Ee.range,Ee.insertText):void 0),le.additionalTextEdits&&le.additionalTextEdits.length>0&&(Ee.additionalTextEdits=le.additionalTextEdits.map(We=>ve.to(We))),Ee.command=H&&le.command?H.fromInternal(le.command):void 0,Ee}ye.to=Re})(Ke||(e.CompletionItem=Ke={}));var _e;(function(ye){function Re(H){if(typeof H.label!="string"&&!Array.isArray(H.label))throw new TypeError("Invalid label");return{label:H.label,documentation:$e.fromStrict(H.documentation)}}ye.from=Re;function le(H){return{label:H.label,documentation:A.$2k(H.documentation)?$e.to(H.documentation):H.documentation}}ye.to=le})(_e||(e.ParameterInformation=_e={}));var tt;(function(ye){function Re(H){return{label:H.label,documentation:$e.fromStrict(H.documentation),parameters:Array.isArray(H.parameters)?H.parameters.map(_e.from):[],activeParameter:H.activeParameter}}ye.from=Re;function le(H){return{label:H.label,documentation:A.$2k(H.documentation)?$e.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(_e.to):[],activeParameter:H.activeParameter}}ye.to=le})(tt||(e.SignatureInformation=tt={}));var nt;(function(ye){function Re(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(tt.from):[]}}ye.from=Re;function le(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(tt.to):[]}}ye.to=le})(nt||(e.SignatureHelp=nt={}));var et;(function(ye){function Re(le,H){const Ee=new b.$2N(B.to(H.position),typeof H.label=="string"?H.label:H.label.map(rt.to.bind(void 0,le)),H.kind&&ft.to(H.kind));return Ee.textEdits=H.textEdits&&H.textEdits.map(ve.to),Ee.tooltip=A.$2k(H.tooltip)?$e.to(H.tooltip):H.tooltip,Ee.paddingLeft=H.paddingLeft,Ee.paddingRight=H.paddingRight,Ee}ye.to=Re})(et||(e.InlayHint=et={}));var rt;(function(ye){function Re(le,H){const Ee=new b.$1N(H.label);return Ee.tooltip=A.$2k(H.tooltip)?$e.to(H.tooltip):H.tooltip,r.Command.is(H.command)&&(Ee.command=le.fromInternal(H.command)),H.location&&(Ee.location=ze.to(H.location)),Ee}ye.to=Re})(rt||(e.InlayHintLabelPart=rt={}));var ft;(function(ye){function Re(H){return H}ye.from=Re;function le(H){return H}ye.to=le})(ft||(e.InlayHintKind=ft={}));var ct;(function(ye){function Re(H){return{range:O.from(H.range),url:H.target,tooltip:H.tooltip}}ye.from=Re;function le(H){let Ee;if(H.url)try{Ee=typeof H.url=="string"?o.URI.parse(H.url,!0):o.URI.revive(H.url)}catch{}const We=new b.$8N(O.to(H.range),Ee);return We.tooltip=H.tooltip,We}ye.to=le})(ct||(e.DocumentLink=ct={}));var st;(function(ye){function Re(H){const Ee=new b.$$N(H.label);return H.textEdit&&(Ee.textEdit=ve.to(H.textEdit)),H.additionalTextEdits&&(Ee.additionalTextEdits=H.additionalTextEdits.map(We=>ve.to(We))),Ee}ye.to=Re;function le(H){return{label:H.label,textEdit:H.textEdit?ve.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(Ee=>ve.from(Ee)):void 0}}ye.from=le})(st||(e.ColorPresentation=st={}));var lt;(function(ye){function Re(H){return new b.$9N(H[0],H[1],H[2],H[3])}ye.to=Re;function le(H){return[H.red,H.green,H.blue,H.alpha]}ye.from=le})(lt||(e.Color=lt={}));var gt;(function(ye){function Re(H){return{range:O.from(H.range)}}ye.from=Re;function le(H){return new b.$RN(O.to(H.range))}ye.to=le})(gt||(e.SelectionRange=gt={}));var pt;(function(ye){function Re(le){switch(le){case m.SaveReason.AUTO:return b.TextDocumentSaveReason.AfterDelay;case m.SaveReason.EXPLICIT:return b.TextDocumentSaveReason.Manual;case m.SaveReason.FOCUS_CHANGE:case m.SaveReason.WINDOW_CHANGE:return b.TextDocumentSaveReason.FocusOut}}ye.to=Re})(pt||(e.TextDocumentSaveReason=pt={}));var Be;(function(ye){function Re(H){switch(H){case b.TextEditorLineNumbersStyle.Off:return s.RenderLineNumbersType.Off;case b.TextEditorLineNumbersStyle.Relative:return s.RenderLineNumbersType.Relative;case b.TextEditorLineNumbersStyle.Interval:return s.RenderLineNumbersType.Interval;case b.TextEditorLineNumbersStyle.On:default:return s.RenderLineNumbersType.On}}ye.from=Re;function le(H){switch(H){case s.RenderLineNumbersType.Off:return b.TextEditorLineNumbersStyle.Off;case s.RenderLineNumbersType.Relative:return b.TextEditorLineNumbersStyle.Relative;case s.RenderLineNumbersType.Interval:return b.TextEditorLineNumbersStyle.Interval;case s.RenderLineNumbersType.On:default:return b.TextEditorLineNumbersStyle.On}}ye.to=le})(Be||(e.TextEditorLineNumbersStyle=Be={}));var Ue;(function(ye){function Re(H){if(H===b.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(H===b.EndOfLine.LF)return t.EndOfLineSequence.LF}ye.from=Re;function le(H){if(H===t.EndOfLineSequence.CRLF)return b.EndOfLine.CRLF;if(H===t.EndOfLineSequence.LF)return b.EndOfLine.LF}ye.to=le})(Ue||(e.EndOfLine=Ue={}));var ee;(function(ye){function Re(le){if(typeof le=="object")return le.viewId;switch(le){case b.ProgressLocation.SourceControl:return u.ProgressLocation.Scm;case b.ProgressLocation.Window:return u.ProgressLocation.Window;case b.ProgressLocation.Notification:return u.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}ye.from=Re})(ee||(e.ProgressLocation=ee={}));var K;(function(ye){function Re(H){const Ee={start:H.start+1,end:H.end+1};return H.kind&&(Ee.kind=De.from(H.kind)),Ee}ye.from=Re;function le(H){const Ee={start:H.start-1,end:H.end-1};return H.kind&&(Ee.kind=De.to(H.kind)),Ee}ye.to=le})(K||(e.FoldingRange=K={}));var De;(function(ye){function Re(H){if(H)switch(H){case b.FoldingRangeKind.Comment:return r.$Ku.Comment;case b.FoldingRangeKind.Imports:return r.$Ku.Imports;case b.FoldingRangeKind.Region:return r.$Ku.Region}}ye.from=Re;function le(H){if(H)switch(H.value){case r.$Ku.Comment.value:return b.FoldingRangeKind.Comment;case r.$Ku.Imports.value:return b.FoldingRangeKind.Imports;case r.$Ku.Region.value:return b.FoldingRangeKind.Region}}ye.to=le})(De||(e.FoldingRangeKind=De={}));var Je;(function(ye){function Re(le){if(le)return{pinned:typeof le.preview=="boolean"?!le.preview:void 0,inactive:le.background,preserveFocus:le.preserveFocus,selection:typeof le.selection=="object"?O.from(le.selection):void 0,override:typeof le.override=="boolean"?m.$QF.id:void 0}}ye.from=Re})(Je||(e.TextEditorOpenOptions=Je={}));var xe;(function(ye){function Re(We){return We instanceof b.$tO?We.toJSON():typeof We=="string"?We:le(We)||H(We)?new b.$tO(We.baseUri??We.base,We.pattern).toJSON():We}ye.from=Re;function le(We){const Ze=We;return Ze?o.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function H(We){const Ze=We;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Ee(We){return typeof We=="string"?We:new b.$tO(o.URI.revive(We.baseUri),We.pattern)}ye.to=Ee})(xe||(e.GlobPattern=xe={}));var ht;(function(ye){function Re(le){if(le){if(Array.isArray(le))return le.map(Re);if(typeof le=="string")return le;{const H=le;return{language:H.language,scheme:H.scheme,pattern:xe.from(H.pattern),exclusive:H.exclusive,notebookType:H.notebookType}}}else return}ye.from=Re})(ht||(e.LanguageSelector=ht={}));var $t;(function(ye){function Re(H){return!!H&&typeof H=="object"&&"documents"in H&&Array.isArray(H.documents)&&H.documents.every(Ee=>Array.isArray(Ee)&&Ee.every(We=>We&&typeof We=="object"&&"uri"in We&&o.URI.isUri(We.uri)&&"version"in We&&typeof We.version=="number"&&"ranges"in We&&Array.isArray(We.ranges)&&We.ranges.every(Ze=>Ze instanceof b.$wN)))}ye.is=Re;function le(H){return{documents:H.documents.map(Ee=>Ee.map(We=>({uri:o.URI.from(We.uri),version:We.version,ranges:We.ranges.map(Ze=>O.from(Ze))})))}}ye.from=le})($t||(e.MappedEditsContext=$t={}));var Ot;(function(ye){function Re(H){return{start:H.start,end:H.end}}ye.from=Re;function le(H){return new b.$WO(H.start,H.end)}ye.to=le})(Ot||(e.NotebookRange=Ot={}));var zt;(function(ye){function Re(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}ye.to=Re;function le(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}ye.from=le})(zt||(e.NotebookCellExecutionSummary=zt={}));var ei;(function(ye){function Re(le){if(le===w.NotebookCellExecutionState.Unconfirmed)return b.NotebookCellExecutionState.Pending;if(le===w.NotebookCellExecutionState.Pending)return;if(le===w.NotebookCellExecutionState.Executing)return b.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${le}`)}ye.to=Re})(ei||(e.NotebookCellExecutionState=ei={}));var ui;(function(ye){function Re(H){switch(H){case b.NotebookCellKind.Markup:return w.CellKind.Markup;case b.NotebookCellKind.Code:default:return w.CellKind.Code}}ye.from=Re;function le(H){switch(H){case w.CellKind.Markup:return b.NotebookCellKind.Markup;case w.CellKind.Code:default:return b.NotebookCellKind.Code}}ye.to=le})(ui||(e.NotebookCellKind=ui={}));var ti;(function(ye){function Re(H){const Ee={metadata:H.metadata??Object.create(null),cells:[]};for(const We of H.cells)b.$XO.validate(We),Ee.cells.push(Ye.from(We));return Ee}ye.from=Re;function le(H){const Ee=new b.$YO(H.cells.map(Ye.to));return(0,n.$pg)(H.metadata)||(Ee.metadata=H.metadata),Ee}ye.to=le})(ti||(e.NotebookData=ti={}));var Ye;(function(ye){function Re(H){return{cellKind:ui.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:zt.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(Kt.from):[]}}ye.from=Re;function le(H){return new b.$XO(ui.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(Kt.to):void 0,H.metadata,H.internalMetadata?zt.to(H.internalMetadata):void 0)}ye.to=le})(Ye||(e.NotebookCellData=Ye={}));var Gt;(function(ye){function Re(H){return{mime:H.mime,valueBytes:I.$Le.wrap(H.data)}}ye.from=Re;function le(H){return new b.$ZO(H.valueBytes.buffer,H.mime)}ye.to=le})(Gt||(e.NotebookCellOutputItem=Gt={}));var Kt;(function(ye){function Re(H){return{outputId:H.id,items:H.items.map(Gt.from),metadata:H.metadata}}ye.from=Re;function le(H){const Ee=H.items.map(Gt.to);return new b.$1O(Ee,H.outputId,H.metadata)}ye.to=le})(Kt||(e.NotebookCellOutput=Kt={}));var mt;(function(ye){function Re(Ee){return H(Ee)?{include:xe.from(Ee.include)??void 0,exclude:xe.from(Ee.exclude)??void 0}:xe.from(Ee)??void 0}ye.from=Re;function le(Ee){return H(Ee)?{include:xe.to(Ee.include),exclude:xe.to(Ee.exclude)}:xe.to(Ee)}ye.to=le;function H(Ee){const We=Ee;return We?!(0,n.$lg)(We.include)&&!(0,n.$lg)(We.exclude):!1}})(mt||(e.NotebookExclusiveDocumentPattern=mt={}));var Ct;(function(ye){function Re(le,H,Ee){const We=typeof le.command=="string"?{title:"",command:le.command}:le.command;return{alignment:le.alignment===b.NotebookCellStatusBarAlignment.Left?w.CellStatusbarAlignment.Left:w.CellStatusbarAlignment.Right,command:H.toInternal(We,Ee),text:le.text,tooltip:le.tooltip,accessibilityInformation:le.accessibilityInformation,priority:le.priority}}ye.from=Re})(Ct||(e.NotebookStatusBarItem=Ct={}));var ii;(function(ye){function Re(le,H,Ee){const We=typeof le.command=="string"?{title:"",command:le.command}:le.command;return{command:H.toInternal(We,Ee),label:le.label,description:le.description,detail:le.detail,documentation:le.documentation}}ye.from=Re})(ii||(e.NotebookKernelSourceAction=ii={}));var Xt;(function(ye){function Re(le){return{transientOutputs:le?.transientOutputs??!1,transientCellMetadata:le?.transientCellMetadata??{},transientDocumentMetadata:le?.transientDocumentMetadata??{},cellContentMetadata:le?.cellContentMetadata??{}}}ye.from=Re})(Xt||(e.NotebookDocumentContentOptions=Xt={}));var Bt;(function(ye){function Re(H){return{uri:H.uri,provides:H.provides}}ye.from=Re;function le(H){return new b.$3O(o.URI.revive(H.uri),H.provides)}ye.to=le})(Bt||(e.NotebookRendererScript=Bt={}));var vt;(function(ye){function Re(H){return{message:$e.fromStrict(H.message)||"",type:P.TestMessageType.Error,expected:H.expectedOutput,actual:H.actualOutput,contextValue:H.contextValue,location:H.location&&{range:O.from(H.location.range),uri:H.location.uri}}}ye.from=Re;function le(H){const Ee=new b.$9O(typeof H.message=="string"?H.message:$e.to(H.message));return Ee.actualOutput=H.actual,Ee.expectedOutput=H.expected,Ee.contextValue=H.contextValue,Ee.location=H.location?ze.to(H.location):void 0,Ee}ye.to=le})(vt||(e.TestMessage=vt={}));var Nt;(function(ye){ye.namespace=P.$WI,ye.denamespace=P.$XI})(Nt||(e.TestTag=Nt={}));var hi;(function(ye){function Re(H){const Ee=(0,p.$WP)(H).controllerId;return{extId:k.$RI.fromExtHostTestItem(H,Ee).toString(),label:H.label,uri:o.URI.revive(H.uri),busy:H.busy,tags:H.tags.map(We=>Nt.namespace(Ee,We.id)),range:l.$Kt.lift(O.from(H.range)),description:H.description||null,sortText:H.sortText||null,error:H.error&&$e.fromStrict(H.error)||null}}ye.from=Re;function le(H){return{parent:void 0,error:void 0,id:k.$RI.fromString(H.extId).localId,label:H.label,uri:o.URI.revive(H.uri),tags:(H.tags||[]).map(Ee=>{const{tagId:We}=Nt.denamespace(Ee);return new b.$0O(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:O.to(H.range||void 0),canResolveChildren:!1,busy:H.busy,description:H.description||void 0,sortText:H.sortText||void 0}}ye.toPlain=le})(hi||(e.TestItem=hi={})),function(ye){function Re(H){return{id:H.id}}ye.from=Re;function le(H){return new b.$0O(H.id)}ye.to=le}(Nt||(e.TestTag=Nt={}));var Wt;(function(ye){const Re=(H,Ee)=>{const We=H.value;if(!We)return;const Ze={...hi.toPlain(We.item),parent:Ee,taskStates:We.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(ut=>ut.type===P.TestMessageType.Error).map(vt.to)})),children:[]};if(H.children)for(const Ge of H.children.values()){const ut=Re(Ge,Ze);ut&&Ze.children.push(ut)}return Ze};function le(H){const Ee=new c.$QI;for(const Ge of H.items)Ee.insert(k.$RI.fromString(Ge.item.extId).path,Ge);const We=[Ee.nodes],Ze=[];for(;We.length;)for(const Ge of We.pop())Ge.value?Ze.push(Ge):Ge.children&&We.push(Ge.children.values());return{completedAt:H.completedAt,results:Ze.map(Ge=>Re(Ge)).filter(n.$kg)}}ye.to=le})(Wt||(e.TestResults=Wt={}));var Xe;(function(ye){function Re(We){return{covered:We.covered,total:We.total}}function le(We){return"line"in We?B.from(We):O.from(We)}function H(We){if(typeof We.executed=="number"&&We.executed<0)throw new Error(`Invalid coverage count ${We.executed}`);return"branches"in We?{count:We.executed,location:le(We.location),type:P.DetailType.Statement,branches:We.branches.length?We.branches.map(Ze=>({count:Ze.executed,location:Ze.location&&le(Ze.location),label:Ze.label})):void 0}:{type:P.DetailType.Declaration,name:We.name,count:We.executed,location:le(We.location)}}ye.fromDetails=H;function Ee(We,Ze,Ge){return b.$_O(Ge.statementCoverage),b.$_O(Ge.branchCoverage),b.$_O(Ge.declarationCoverage),{id:Ze,uri:Ge.uri,statement:Re(Ge.statementCoverage),branch:Ge.branchCoverage&&Re(Ge.branchCoverage),declaration:Ge.declarationCoverage&&Re(Ge.declarationCoverage),testIds:Ge instanceof b.$aP&&Ge.fromTests.length?Ge.fromTests.map(ut=>k.$RI.fromExtHostTestItem(ut,We).toString()):void 0}}ye.fromFile=Ee})(Xe||(e.TestCoverage=Xe={}));var Yt;(function(ye){function Re(le){switch(le){case r.CodeActionTriggerType.Invoke:return b.CodeActionTriggerKind.Invoke;case r.CodeActionTriggerType.Auto:return b.CodeActionTriggerKind.Automatic}}ye.to=Re})(Yt||(e.CodeActionTriggerKind=Yt={}));var ni;(function(ye){function Re(H){const Ee=new b.$eP(be.to(H.kind),H.name,H.detail||"",o.URI.revive(H.uri),O.to(H.range),O.to(H.selectionRange));return Ee._sessionId=H._sessionId,Ee._itemId=H._itemId,Ee}ye.to=Re;function le(H,Ee,We){if(Ee=Ee??H._sessionId,We=We??H._itemId,Ee===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:We,kind:be.from(H.kind),name:H.name,detail:H.detail??"",uri:H.uri,range:O.from(H.range),selectionRange:O.from(H.selectionRange),tags:H.tags?.map(he.from)}}ye.from=le})(ni||(e.TypeHierarchyItem=ni={}));var di;(function(ye){function Re(le){if(le)return{value:le.value,tooltip:le.tooltip}}ye.from=Re})(di||(e.ViewBadge=di={}));var St;(function(ye){function Re(We,Ze,Ge){const ut=Ze.fileData;return ut?new b.$lO(new b.$mO(ut.name,o.URI.revive(ut.uri),ut.id,(0,N.$cb)(()=>Ge(ut.id)))):We===R.$7s.uriList&&Ze.uriListData?new b.$kO(Ee(Ze.uriListData)):new b.$kO(Ze.asString)}ye.to=Re;async function le(We,Ze){const Ge=await Ze.asString();if(We===R.$7s.uriList)return{asString:Ge,fileData:void 0,uriListData:H(Ge)};const ut=Ze.asFile();return{asString:Ge,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}ye.from=le;function H(We){return C.$ou.split(We).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return o.URI.parse(Ze)}catch{}return Ze})}function Ee(We){return C.$ou.create(We.map(Ze=>typeof Ze=="string"?Ze:o.URI.revive(Ze)))}})(St||(e.DataTransferItem=St={}));var Lt;(function(ye){function Re(H,Ee){const We=H.items.map(([Ze,Ge])=>[Ze,St.to(Ze,Ge,Ee)]);return new b.$nO(We)}ye.toDataTransfer=Re;async function le(H){const Ee={items:[]},We=[];for(const[Ze,Ge]of H)We.push((async()=>{Ee.items.push([Ze,await St.from(Ze,Ge)])})());return await Promise.all(We),Ee}ye.from=le})(Lt||(e.DataTransfer=Lt={}));var Rt;(function(ye){function Re(H,Ee){return{kind:"reply",agentId:H.participant??Ee?.agentId??"",subCommand:H.command??Ee?.command,message:H.prompt,title:H.label}}ye.from=Re;function le(H){return{prompt:H.message,label:H.title,participant:H.agentId,command:H.subCommand}}ye.to=le})(Rt||(e.ChatFollowup=Rt={}));var jt;(function(ye){function Re(H){switch(H){case E.ChatMessageRole.System:return b.LanguageModelChatMessageRole.System;case E.ChatMessageRole.User:return b.LanguageModelChatMessageRole.User;case E.ChatMessageRole.Assistant:return b.LanguageModelChatMessageRole.Assistant}}ye.to=Re;function le(H){switch(H){case b.LanguageModelChatMessageRole.System:return E.ChatMessageRole.System;case b.LanguageModelChatMessageRole.User:return E.ChatMessageRole.User;case b.LanguageModelChatMessageRole.Assistant:return E.ChatMessageRole.Assistant}return E.ChatMessageRole.User}ye.from=le})(jt||(e.LanguageModelChatMessageRole=jt={}));var ri;(function(ye){function Re(H){let Ee="",We;H.content.type==="text"?Ee=H.content.value:We=new b.$HP(H.content.name,H.content.value,H.content.isError);const Ze=jt.to(H.role),Ge=new b.$IP(Ze,Ee,H.name);return We!==void 0&&(Ge.content2=We),Ge}ye.to=Re;function le(H){const Ee=jt.from(H.role),We=H.name;let Ze;return H.content2 instanceof b.$HP?Ze={type:"function_result",name:H.content2.name,value:H.content2.content,isError:H.content2.isError}:Ze={type:"text",value:H.content},{role:Ee,name:We,content:Ze}}ye.from=le})(ri||(e.LanguageModelChatMessage=ri={}));var Zt;(function(ye){function Re(H){return{kind:"markdownContent",content:$e.from(H.value)}}ye.from=Re;function le(H){return new b.$rP($e.to(H.content))}ye.to=le})(Zt||(e.ChatResponseMarkdownPart=Zt={}));var si;(function(ye){function Re(H){return{kind:"markdownVuln",content:$e.from(H.value),vulnerabilities:H.vulnerabilities}}ye.from=Re;function le(H){return new b.$sP($e.to(H.content),H.vulnerabilities)}ye.to=le})(si||(e.ChatResponseMarkdownWithVulnerabilitiesPart=si={}));var Vt;(function(ye){function Re(H){return{kind:"agentDetection",agentId:H.participant,command:H.command}}ye.from=Re;function le(H){return new b.$tP(H.agentId,H.command)}ye.to=le})(Vt||(e.ChatResponseDetectedParticipantPart=Vt={}));var Qt;(function(ye){function Re(le){return{kind:"confirmation",title:le.title,message:le.message,data:le.data}}ye.from=Re})(Qt||(e.ChatResponseConfirmationPart=Qt={}));var oi;(function(ye){function Re(H){const{value:Ee,baseUri:We}=H;function Ze(Ge,ut){return Ge.map(It=>{const Ht=o.URI.joinPath(ut,It.name);return{label:It.name,uri:Ht,children:It.children&&Ze(It.children,Ht)}})}return{kind:"treeData",treeData:{label:(0,S.$ah)(We),uri:We,children:Ze(Ee,We)}}}ye.from=Re;function le(H){const Ee=(0,a.$_h)(H.treeData);function We(ut){return ut.map(It=>({name:It.label,children:It.children&&We(It.children)}))}const Ze=Ee.uri,Ge=Ee.children?We(Ee.children):[];return new b.$vP(Ge,Ze)}ye.to=le})(oi||(e.ChatResponseFilesPart=oi={}));var Pt;(function(ye){function Re(H){const Ee=We=>o.URI.isUri(We);return{kind:"inlineReference",name:H.title,inlineReference:Ee(H.value)?H.value:F.from(H.value)}}ye.from=Re;function le(H){const Ee=(0,a.$_h)(H);return new b.$wP(o.URI.isUri(Ee.inlineReference)?Ee.inlineReference:F.to(Ee.inlineReference),H.name)}ye.to=le})(Pt||(e.ChatResponseAnchorPart=Pt={}));var Dt;(function(ye){function Re(H){return{kind:"progressMessage",content:$e.from(H.value)}}ye.from=Re;function le(H){return new b.$xP(H.content.value)}ye.to=le})(Dt||(e.ChatResponseProgressPart=Dt={}));var bt;(function(ye){function Re(H){return{kind:"warning",content:$e.from(H.value)}}ye.from=Re;function le(H){return new b.$zP(H.content.value)}ye.to=le})(bt||(e.ChatResponseWarningPart=bt={}));var xt;(function(ye){function Re(le){return{kind:"progressTask",content:$e.from(le.value)}}ye.from=Re})(xt||(e.ChatTask=xt={}));var kt;(function(ye){function Re(le){return{kind:"progressTaskResult",content:typeof le=="string"?$e.from(le):void 0}}ye.from=Re})(kt||(e.ChatTaskResult=kt={}));var fi;(function(ye){function Re(H,Ee,We){return{kind:"command",command:Ee.toInternal(H.value,We)??{command:H.value.command,title:H.value.title}}}ye.from=Re;function le(H,Ee){return new b.$AP(Ee.fromInternal(H.command)??{command:H.command.id,title:H.command.title})}ye.to=le})(fi||(e.ChatResponseCommandButtonPart=fi={}));var qt;(function(ye){function Re(H){return{kind:"textEdit",uri:H.uri,edits:H.edits.map(Ee=>ve.from(Ee))}}ye.from=Re;function le(H){return new b.$CP(o.URI.revive(H.uri),H.edits.map(Ee=>ve.to(Ee)))}ye.to=le})(qt||(e.ChatResponseTextEditPart=qt={}));var bi;(function(ye){function Re(H){const Ee=f.ThemeIcon.isThemeIcon(H.iconPath)?H.iconPath:o.URI.isUri(H.iconPath)?{light:o.URI.revive(H.iconPath)}:H.iconPath&&"light"in H.iconPath&&"dark"in H.iconPath&&o.URI.isUri(H.iconPath.light)&&o.URI.isUri(H.iconPath.dark)?{light:o.URI.revive(H.iconPath.light),dark:o.URI.revive(H.iconPath.dark)}:void 0;return"variableName"in H.value?{kind:"reference",reference:{variableName:H.value.variableName,value:o.URI.isUri(H.value.value)||!H.value.value?H.value.value:F.from(H.value.value)},iconPath:Ee}:{kind:"reference",reference:o.URI.isUri(H.value)?H.value:F.from(H.value),iconPath:Ee}}ye.from=Re;function le(H){const Ee=(0,a.$_h)(H),We=Ze=>o.URI.isUri(Ze)?Ze:F.to(Ze);return new b.$BP("variableName"in Ee.reference?{variableName:Ee.reference.variableName,value:Ee.reference.value&&We(Ee.reference.value)}:We(Ee.reference))}ye.to=le})(bi||(e.ChatResponseReferencePart=bi={}));var vi;(function(ye){function Re(Ee,We,Ze){return Ee instanceof b.$rP?Zt.from(Ee):Ee instanceof b.$wP?Pt.from(Ee):Ee instanceof b.$BP?bi.from(Ee):Ee instanceof b.$xP?Dt.from(Ee):Ee instanceof b.$vP?oi.from(Ee):Ee instanceof b.$AP?fi.from(Ee,We,Ze):Ee instanceof b.$CP?qt.from(Ee):Ee instanceof b.$sP?si.from(Ee):Ee instanceof b.$tP?Vt.from(Ee):Ee instanceof b.$zP?bt.from(Ee):{kind:"markdownContent",content:$e.from("")}}ye.from=Re;function le(Ee,We){switch(Ee.kind){case"reference":return bi.to(Ee);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return H(Ee,We)}}ye.to=le;function H(Ee,We){switch(Ee.kind){case"markdownContent":return Zt.to(Ee);case"inlineReference":return Pt.to(Ee);case"progressMessage":return;case"treeData":return oi.to(Ee);case"command":return fi.to(Ee,We)}}ye.toContent=H})(vi||(e.ChatResponsePart=vi={}));var gi;(function(ye){function Re(le,H){return{prompt:le.message,command:le.command,attempt:le.attempt??0,enableCommandDetection:le.enableCommandDetection??!0,references:le.variables.variables.map(ai.to),location:Mt.to(le.location),acceptedConfirmationData:le.acceptedConfirmationData,rejectedConfirmationData:le.rejectedConfirmationData,location2:H}}ye.to=Re})(gi||(e.ChatAgentRequest=gi={}));var Mt;(function(ye){function Re(H){switch(H){case d.ChatAgentLocation.Notebook:return b.ChatLocation.Notebook;case d.ChatAgentLocation.Terminal:return b.ChatLocation.Terminal;case d.ChatAgentLocation.Panel:return b.ChatLocation.Panel;case d.ChatAgentLocation.Editor:return b.ChatLocation.Editor}}ye.to=Re;function le(H){switch(H){case b.ChatLocation.Notebook:return d.ChatAgentLocation.Notebook;case b.ChatLocation.Terminal:return d.ChatAgentLocation.Terminal;case b.ChatLocation.Panel:return d.ChatAgentLocation.Panel;case b.ChatLocation.Editor:return d.ChatAgentLocation.Editor}}ye.from=le})(Mt||(e.ChatLocation=Mt={}));var ai;(function(ye){function Re(le){const H=le.value;if(!H)throw new Error("Invalid value reference");return{id:le.id,name:le.name,range:le.range&&[le.range.start,le.range.endExclusive],value:(0,o.$uc)(H)?o.URI.revive(H):H&&typeof H=="object"&&"uri"in H&&"range"in H&&(0,o.$uc)(H.uri)?F.to((0,a.$_h)(H)):H,modelDescription:le.modelDescription}}ye.to=Re})(ai||(e.ChatAgentValueReference=ai={}));var Ii;(function(ye){function Re(le,H,Ee){return{id:le.id,label:le.label,fullName:le.fullName,icon:le.icon?.id,value:le.values[0].value,insertText:le.insertText,detail:le.detail,documentation:le.documentation,command:H.toInternal(le.command,Ee)}}ye.from=Re})(Ii||(e.ChatAgentCompletionItem=Ii={}));var At;(function(ye){function Re(le){return{errorDetails:le.errorDetails,metadata:le.metadata}}ye.to=Re})(At||(e.ChatAgentResult=At={}));var Di;(function(ye){function Re(le,H,Ee){if(H.action.kind==="vote")return;const We=At.to(le);if(H.action.kind==="command"){const Ze=H.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Ee.fromInternal(Ze)??{command:Ze.id,title:Ze.title}}},result:We}}else return H.action.kind==="followUp"?{action:{kind:"followUp",followup:Rt.to(H.action.followup)},result:We}:H.action.kind==="inlineChat"?{action:{kind:"editor",accepted:H.action.action==="accepted"},result:We}:{action:H.action,result:We}}ye.to=Re})(Di||(e.ChatAgentUserActionEvent=Di={}));var Pi;(function(ye){function Re(le,H,Ee){return"terminalCommand"in le?{terminalCommand:le.terminalCommand,shouldExecute:le.shouldExecute}:"uri"in le?{uri:le.uri}:H.toInternal(le,Ee)}ye.from=Re})(Pi||(e.TerminalQuickFix=Pi={}));var Si;(function(ye){function Re(le){return{kind:pi.to(le.kind)}}ye.to=Re})(Si||(e.PartialAcceptInfo=Si={}));var pi;(function(ye){function Re(le){switch(le){case r.PartialAcceptTriggerKind.Word:return b.PartialAcceptTriggerKind.Word;case r.PartialAcceptTriggerKind.Line:return b.PartialAcceptTriggerKind.Line;case r.PartialAcceptTriggerKind.Suggest:return b.PartialAcceptTriggerKind.Suggest;default:return b.PartialAcceptTriggerKind.Unknown}}ye.to=Re})(pi||(e.PartialAcceptTriggerKind=pi={}));var Ri;(function(ye){function Re(le,H){return{id:H,label:le.label,description:le.description,canEdit:le.canEdit,collapsibleState:le.collapsibleState||D.DebugTreeItemCollapsibleState.None,contextValue:le.contextValue}}ye.from=Re})(Ri||(e.DebugTreeItem=Ri={}));var Ut;(function(ye){function Re(le){return{name:le.name,description:le.description,parametersSchema:le.parametersSchema}}ye.to=Re})(Ut||(e.LanguageModelToolDescription=Ut={}))}),define(Ne[231],Oe([1,0,5,16,8,38]),function(we,e,v,I,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zoc=void 0;let A=class{constructor($,a){this.a=$.getProxy(v.$sN.MainThreadBulkEdits),this.b={getTextDocumentVersion:R=>a.getDocument(R)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,a,R){const y=new N.$Sw(C.WorkspaceEdit.from($,this.b));return this.a.$tryApplyWorkspaceEdit(y,void 0,R?.isRefactoring??!1)}};e.$zoc=A,e.$zoc=A=Qe([qe(0,I.$1P)],A)}),define(Ne[232],Oe([1,0,17,10,42,6,39,4,40,69,14,2,18,5,8,7,115,193,24]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S,f,n,o,s,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aoc=void 0,f=Ve(f),n=Ve(n);class i{constructor(u,p,m,d,E){this.j=u,this.k=p,this.l=m,this.m=d,this.n=E,this.b=a.$de.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let p=function(d){if(u.c){const E=new Error("Response stream has been closed");throw Error.captureStackTrace(E,d),E}};const u=this;this.b.reset();const m=(d,E)=>{if(typeof this.d>"u"&&"content"in d&&(this.d=this.b.elapsed()),E){const D=this.l.$handleProgressChunk(this.k.requestId,d),w={report:k=>{D?.then(P=>{P&&(n.$WN.isMarkdownString(k.value)?this.l.$handleProgressChunk(this.k.requestId,f.ChatResponseWarningPart.from(k),P):this.l.$handleProgressChunk(this.k.requestId,f.ChatResponseReferencePart.from(k),P))})}};Promise.all([D,E?.(w)]).then(([k,P])=>{k!==void 0&&P!==void 0&&this.l.$handleProgressChunk(this.k.requestId,f.ChatTaskResult.from(P),k)})}else this.l.$handleProgressChunk(this.k.requestId,d)};this.g={markdown(d){p(this.markdown);const E=new n.$rP(d),D=f.ChatResponseMarkdownPart.from(E);return m(D),this},markdownWithVulnerabilities(d,E){p(this.markdown),E&&(0,l.$5G)(u.j,"chatParticipantAdditions");const D=new n.$sP(d,E),w=f.ChatResponseMarkdownWithVulnerabilitiesPart.from(D);return m(w),this},filetree(d,E){p(this.filetree);const D=new n.$vP(d,E),w=f.ChatResponseFilesPart.from(D);return m(w),this},anchor(d,E){p(this.anchor);const D=new n.$wP(d,E),w=f.ChatResponseAnchorPart.from(D);return m(w),this},button(d){p(this.anchor);const E=new n.$AP(d),D=f.ChatResponseCommandButtonPart.from(E,u.m,u.n);return m(D),this},progress(d,E){p(this.progress);const D=new n.$yP(d,E),w=E?f.ChatTask.from(D):f.ChatResponseProgressPart.from(D);return m(w,E),this},warning(d){p(this.progress),(0,l.$5G)(u.j,"chatParticipantAdditions");const E=new n.$zP(d),D=f.ChatResponseWarningPart.from(E);return m(D),this},reference(d,E){if(p(this.reference),"variableName"in d&&(0,l.$5G)(u.j,"chatParticipantAdditions"),"variableName"in d&&!d.value){const D=u.k.variables.variables.find(w=>w.name===d.variableName);if(D){let w;if(D.references?.length)w=D.references.map(k=>({kind:"reference",reference:{variableName:d.variableName,value:k.reference}}));else{const k=new n.$BP(d,E);w=[f.ChatResponseReferencePart.from(k)]}return w.forEach(k=>m(k)),this}}else{const D=new n.$BP(d,E),w=f.ChatResponseReferencePart.from(D);m(w)}return this},textEdit(d,E){p(this.textEdit),(0,l.$5G)(u.j,"chatParticipantAdditions");const D=new n.$CP(d,E),w=f.ChatResponseTextEditPart.from(D);return m(w),this},detectedParticipant(d,E){p(this.detectedParticipant),(0,l.$5G)(u.j,"chatParticipantAdditions");const D=new n.$tP(d,E),w=f.ChatResponseDetectedParticipantPart.from(D);return m(w),this},confirmation(d,E,D){p(this.confirmation),(0,l.$5G)(u.j,"chatParticipantAdditions");const w=new n.$uP(d,E,D),k=f.ChatResponseConfirmationPart.from(w);return m(k),this},push(d){if(p(this.push),(d instanceof n.$CP||d instanceof n.$sP||d instanceof n.$tP||d instanceof n.$zP||d instanceof n.$uP)&&(0,l.$5G)(u.j,"chatParticipantAdditions"),d instanceof n.$BP)this.reference(d.value,d.iconPath);else{const E=f.ChatResponsePart.from(d,u.m,u.n);m(E)}return this}}}return this.g}}class r extends T.$Tc{static{this.b=0}constructor(u,p,m,d){super(),this.n=p,this.s=m,this.t=d,this.c=new Map,this.j=this.B(new T.$3c),this.m=this.B(new T.$3c),this.g=u.getProxy(S.$sN.MainThreadChatAgents2)}transferActiveChat(u){this.g.$transferActiveChatSession(u)}createChatAgent(u,p,m){const d=r.b++,E=new t(u,p,this.g,d,m);return this.c.set(d,E),this.g.$registerAgent(d,u.identifier,p,{},void 0),E.apiAgent}createDynamicChatAgent(u,p,m,d){const E=r.b++,D=new t(u,p,this.g,E,d);return this.c.set(E,D),this.g.$registerAgent(E,u.identifier,p,{isSticky:!0},m),D.apiAgent}async $invokeAgent(u,p,m,d){const E=this.c.get(u);if(!E)throw new Error(`[CHAT](${u}) CANNOT invoke agent because the agent is not registered`);const D=(0,$.$_h)(p);let w=this.j.get(D.sessionId);w||(w=new T.$Sc,this.j.set(D.sessionId,w));const k=new i(E.extension,D,this.g,this.s.converter,w);try{const P=await this.u(D.agentId,m);let h;if(D.locationData?.type===o.ChatAgentLocation.Editor){const M=this.t.getDocument(D.locationData.document);h=new n.$FP(M,f.Selection.to(D.locationData.selection),f.Range.to(D.locationData.wholeRange))}else if(D.locationData?.type===o.ChatAgentLocation.Notebook){const M=this.t.getDocument(D.locationData.sessionInputUri);h=new n.$GP(M)}else D.locationData?.type,o.ChatAgentLocation.Terminal;const b=E.invoke(f.ChatAgentRequest.to(D,h),{history:P},k.apiObject,d);return await(0,I.$qh)(Promise.resolve(b).then(M=>{if(M?.metadata)try{JSON.stringify(M.metadata)}catch(F){const q=`result.metadata MUST be JSON.stringify-able. Got error: ${F.message}`;return this.n.error(`[${E.extension.identifier.value}] [@${E.id}] ${q}`,E.extension),{errorDetails:{message:q},timings:k.timings}}let O;return M?.errorDetails&&(O={...M.errorDetails,responseIsIncomplete:!0}),O?.responseIsRedacted&&(0,l.$5G)(E.extension,"chatParticipantPrivate"),{errorDetails:O,timings:k.timings,metadata:M?.metadata}}),d)}catch(P){return this.n.error(P,E.extension),P instanceof n.$OP&&P.cause&&(P=P.cause),{errorDetails:{message:(0,C.$nj)(P),responseIsIncomplete:!0}}}finally{k.close()}}async u(u,p){const m=[];for(const d of p.history){const E=f.ChatAgentResult.to(d.result),D=u===d.request.agentId?E:{...E,metadata:void 0};m.push(new n.$DP(d.request.message,d.request.command,d.request.variables.variables.map(f.ChatAgentValueReference.to),d.request.agentId));const w=(0,v.$Gb)(d.response.map(k=>f.ChatResponsePart.toContent(k,this.s.converter)));m.push(new n.$EP(w,D,d.request.agentId,d.request.command))}return m}$releaseSession(u){this.j.deleteAndDispose(u)}async $provideFollowups(u,p,m,d,E){const D=this.c.get(p);if(!D)return Promise.resolve([]);const w=(0,$.$_h)(u),k=await this.u(D.id,d),P=f.ChatAgentResult.to(m);return(await D.provideFollowups(P,{history:k},E)).filter(h=>{const b=!h.participant||A.Iterable.some(this.c.values(),M=>M.id===h.participant&&c.$nn.equals(M.extension.identifier,D.extension.identifier));return b||this.n.warn(`[@${D.id}] ChatFollowup refers to an unknown participant: ${h.participant}`),b}).map(h=>f.ChatFollowup.from(h,w))}$acceptFeedback(u,p,m,d){const E=this.c.get(u);if(!E)return;const D=f.ChatAgentResult.to(p);let w;switch(m){case s.ChatAgentVoteDirection.Down:w=n.ChatResultFeedbackKind.Unhelpful;break;case s.ChatAgentVoteDirection.Up:w=n.ChatResultFeedbackKind.Helpful;break}E.acceptFeedback(Object.freeze(d?{result:D,kind:w,reportIssue:d}:{result:D,kind:w}))}$acceptAction(u,p,m){const d=this.c.get(u);if(!d||m.action.kind==="vote")return;const E=f.ChatAgentUserActionEvent.to(p,m,this.s.converter);E&&d.acceptAction(Object.freeze(E))}async $invokeCompletionProvider(u,p,m){const d=this.c.get(u);if(!d)return[];let E=this.m.get(u);return E?E.clear():(E=new T.$Sc,this.m.set(u,E)),(await d.invokeCompletionProvider(p,m)).map(w=>f.ChatAgentCompletionItem.from(w,this.s.converter,E))}async $provideWelcomeMessage(u,p,m){const d=this.c.get(u);if(d)return await d.provideWelcomeMessage(f.ChatLocation.to(p),m)}async $provideSampleQuestions(u,p,m){const d=this.c.get(u);if(d)return(await d.provideSampleQuestions(f.ChatLocation.to(p),m)).map(E=>f.ChatFollowup.from(E,void 0))}}e.$Aoc=r;class t{constructor(u,p,m,d,E){this.extension=u,this.id=p,this.w=m,this.x=d,this.y=E,this.m=new N.$je,this.n=new N.$je}acceptFeedback(u){this.m.fire(u)}acceptAction(u){this.n.fire(u)}async invokeCompletionProvider(u,p){return this.q?await this.q.provider.provideCompletionItems(u,p)??[]:[]}async provideFollowups(u,p,m){if(!this.b)return[];const d=await this.b.provideFollowups(u,p,m);return d?d.filter(E=>!(E&&"commandId"in E)).filter(E=>!(E&&"message"in E)):[]}async provideWelcomeMessage(u,p){if(!this.s)return[];const m=await this.s.provideWelcomeMessage(u,p);return m?m.map(d=>typeof d=="string"?d:f.MarkdownString.from(d)):[]}async provideSampleQuestions(u,p){if(!this.s||!this.s.provideSampleQuestions)return[];const m=await this.s.provideSampleQuestions(u,p);return m||[]}get apiAgent(){let u=!1,p=!1;const m=()=>{u||p||(p=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{icon:this.c?this.c instanceof y.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof n.$rO?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:f.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:f.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:f.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),p=!1}))},d=this;return{get id(){return d.id},get iconPath(){return d.c},set iconPath(E){d.c=E,m()},get requestHandler(){return d.y},set requestHandler(E){(0,R.$mg)(typeof E=="function","Invalid request handler"),d.y=E},get followupProvider(){return d.b},set followupProvider(E){d.b=E,m()},get isDefault(){return(0,l.$5G)(d.extension,"defaultChatParticipant"),d.d},set isDefault(E){(0,l.$5G)(d.extension,"defaultChatParticipant"),d.d=E,m()},get helpTextPrefix(){return(0,l.$5G)(d.extension,"defaultChatParticipant"),d.g},set helpTextPrefix(E){(0,l.$5G)(d.extension,"defaultChatParticipant"),d.g=E,m()},get helpTextVariablesPrefix(){return(0,l.$5G)(d.extension,"defaultChatParticipant"),d.j},set helpTextVariablesPrefix(E){(0,l.$5G)(d.extension,"defaultChatParticipant"),d.j=E,m()},get helpTextPostfix(){return(0,l.$5G)(d.extension,"defaultChatParticipant"),d.k},set helpTextPostfix(E){(0,l.$5G)(d.extension,"defaultChatParticipant"),d.k=E,m()},get isSecondary(){return(0,l.$5G)(d.extension,"defaultChatParticipant"),d.l},set isSecondary(E){(0,l.$5G)(d.extension,"defaultChatParticipant"),d.l=E,m()},get supportIssueReporting(){return(0,l.$5G)(d.extension,"chatParticipantPrivate"),d.o},set supportIssueReporting(E){(0,l.$5G)(d.extension,"chatParticipantPrivate"),d.o=E,m()},get onDidReceiveFeedback(){return d.m.event},set participantVariableProvider(E){if((0,l.$5G)(d.extension,"chatParticipantAdditions"),d.q=E,E){if(!E.triggerCharacters.length)throw new Error("triggerCharacters are required");d.w.$registerAgentCompletionsProvider(d.x,d.id,E.triggerCharacters)}else d.w.$unregisterAgentCompletionsProvider(d.x,d.id)},get participantVariableProvider(){return(0,l.$5G)(d.extension,"chatParticipantAdditions"),d.q},set welcomeMessageProvider(E){(0,l.$5G)(d.extension,"defaultChatParticipant"),d.s=E,m()},get welcomeMessageProvider(){return(0,l.$5G)(d.extension,"defaultChatParticipant"),d.s},onDidPerformAction:(0,l.$4G)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(E){d.t=E,m()},get requester(){return d.t},set supportsSlowReferences(E){(0,l.$5G)(d.extension,"chatParticipantPrivate"),d.u=E,m()},get supportsSlowReferences(){return(0,l.$5G)(d.extension,"chatParticipantPrivate"),d.u},dispose(){u=!0,d.b=void 0,d.m.dispose(),d.w.$unregisterAgent(d.x)}}}invoke(u,p,m,d){return this.y(u,p,m,d)}}}),define(Ne[233],Oe([1,0,13,4,34,5,8,7,24]),function(we,e,v,I,C,N,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Boc=void 0,A=Ve(A),T=Ve(T);class a{static{this.a=0}constructor(c){this.b=new Map,this.c=c.getProxy(N.$sN.MainThreadChatVariables)}async $resolveVariable(c,S,f,n){const o=this.b.get(c);if(o)try{if(o.resolver.resolve2){(0,$.$5G)(o.extension,"chatParticipantAdditions");const s=new R(S,this.c),l=await o.resolver.resolve2(o.data.name,{prompt:f},s.apiObject,n);if(l&&l[0])return l[0].value}else{const s=await o.resolver.resolve(o.data.name,{prompt:f},n);if(s&&s[0])return s[0].value}}catch(s){(0,v.$Z)(s)}}registerVariableResolver(c,S,f,n,o,s,l,i,r){const t=a.a++,g=r?C.ThemeIcon.fromId(r):void 0;return this.b.set(t,{extension:c,data:{id:S,name:f,description:n,modelDescription:o,icon:g},resolver:l}),this.c.$registerVariable(t,{id:S,name:f,description:n,modelDescription:o,isSlow:s,fullName:i,icon:g}),(0,I.$Rc)(()=>{this.b.delete(t),this.c.$unregisterVariable(t)})}}e.$Boc=a;class R{constructor(c,S){this.c=c,this.d=S,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let S=function(n){if(c.a){const o=new Error("Response stream has been closed");throw Error.captureStackTrace(o,n),o}};const c=this,f=n=>{this.d.$handleProgressChunk(this.c,n)};this.b={progress(n){S(this.progress);const o=new T.$xP(n),s=A.ChatResponseProgressPart.from(o);return f(s),this},reference(n){S(this.reference);const o=new T.$BP(n),s=A.ChatResponseReferencePart.from(o);return f(s),this},push(n){return S(this.push),n instanceof T.$BP?f(A.ChatResponseReferencePart.from(n)):n instanceof T.$xP&&f(A.ChatResponseProgressPart.from(n)),this}}}return this.b}}}),define(Ne[234],Oe([1,0,10,71,6,4,36,2,93,18,8,7,5,24]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Foc=f,$=Ve($),R=Ve(R),y=Ve(y);function f(n,o,s){const l=n.getProxy(c.$sN.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new a.$pn,o.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===A.MarshalledId.CommentController){const k=this.b.get(w.handle);return k?k.value:w}else if(w&&w.$mid===A.MarshalledId.CommentThread){const k=w,P=this.b.get(k.commentControlHandle);if(!P)return k;const h=P.getCommentThread(k.commentThreadHandle);return h?h.value:k}else if(w&&(w.$mid===A.MarshalledId.CommentThreadReply||w.$mid===A.MarshalledId.CommentThreadInstance)){const k=this.b.get(w.thread.commentControlHandle);if(!k)return w;const P=k.getCommentThread(w.thread.commentThreadHandle);return P?w.$mid===A.MarshalledId.CommentThreadInstance?P.value:{thread:P.value,text:w.text}:w}else if(w&&w.$mid===A.MarshalledId.CommentNode){const k=this.b.get(w.thread.commentControlHandle);if(!k)return w;const P=k.getCommentThread(w.thread.commentThreadHandle);if(!P)return w;const h=w.commentUniqueId,b=P.getCommentByUniqueId(h);return b||w}else if(w&&w.$mid===A.MarshalledId.CommentThreadNode){const k=this.b.get(w.thread.commentControlHandle);if(!k)return w;const P=k.getCommentThread(w.thread.commentThreadHandle);if(!P)return w;const h=w.text,b=w.commentUniqueId,M=P.getCommentByUniqueId(b);return M?(typeof M.body=="string"?M.body=h:M.body=new y.$WN(h),M):w}return w}})}createCommentController(w,k,P){const h=i.a++,b=new t(w,h,k,P);this.b.set(b.handle,b);const M=this.c.get(w.identifier)||[];return M.push(b),this.c.set(w.identifier,M),b.value}async $createCommentThreadTemplate(w,k,P,h){const b=this.b.get(w);b&&b.$createCommentThreadTemplate(k,P,h)}async $setActiveComment(w,k){const P=this.b.get(w);P&&P.$setActiveComment(k??void 0)}async $updateCommentThreadTemplate(w,k,P){const h=this.b.get(w);h&&h.$updateCommentThreadTemplate(k,P)}$deleteCommentThread(w,k){this.b.get(w)?.$deleteCommentThread(k)}async $provideCommentingRanges(w,k,P){const h=this.b.get(w);if(!h||!h.commentingRangeProvider)return Promise.resolve(void 0);const b=await s.ensureDocumentData(T.URI.revive(k));return(0,v.$uh)(async()=>{const M=await h.commentingRangeProvider.provideCommentingRanges(b.document,P);let O;return Array.isArray(M)?O={ranges:M,fileComments:!1}:M?O={ranges:M.ranges||[],fileComments:M.enableFileComments||!1}:O=M??void 0,O}).then(M=>{let O;return M&&(O={ranges:M.ranges.map(F=>R.Range.from(F)),fileComments:M.fileComments}),O})}$toggleReaction(w,k,P,h,b){const M=this.b.get(w);return!M||!M.reactionHandler?Promise.resolve(void 0):(0,v.$uh)(()=>{const O=M.getCommentThread(k);if(O){const F=O.getCommentByUniqueId(h.uniqueIdInThread);if(M!==void 0&&F&&M.reactionHandler)return M.reactionHandler(F,p(b))}return Promise.resolve(void 0)})}}class r{static{this.a=0}set threadId(w){this.n=w}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(w){(w===void 0!=(this.p===void 0)||!w||!this.p||!w.isEqual(this.p))&&(this.p=w,this.b.range=w,this.c.fire())}get range(){return this.p}set canReply(w){this.d!==w&&(this.d=w,this.b.canReply=w,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(w){this.e=w,this.b.label=w,this.c.fire()}get contextValue(){return this.f}set contextValue(w){this.f=w,this.b.contextValue=w,this.c.fire()}get comments(){return this.q}set comments(w){this.q=w,this.b.comments=w,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(w){this.g=w,this.b.collapsibleState=w,this.c.fire()}get state(){return this.h}set state(w){this.h=w,typeof w=="object"?((0,S.$5G)(this.extensionDescription,"commentThreadApplicability"),this.b.state=w.resolved,this.b.applicability=w.applicability):this.b.state=w,this.c.fire()}get isDisposed(){return this.j}constructor(w,k,P,h,b,M,O,F,q){this.m=k,this.n=P,this.o=h,this.p=b,this.q=M,this.extensionDescription=O,this.r=F,this.handle=r.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$je,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new N.$Uc,this.l.value=new N.$Sc,this.n===void 0&&(this.n=`${w}.${this.handle}`),l.$createCommentThread(k,this.handle,this.n,this.o,R.Range.from(this.p),this.q.map(L=>g(this,L,this.k,this.extensionDescription)),O.identifier,this.r,q),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.i.push({dispose:()=>{l.$deleteCommentThread(k,this.handle)}});const B=this;this.value={get uri(){return B.uri},get range(){return B.range},set range(L){B.range=L},get comments(){return B.comments},set comments(L){B.comments=L},get collapsibleState(){return B.collapsibleState},set collapsibleState(L){B.collapsibleState=L},get canReply(){return B.canReply},set canReply(L){B.canReply=L},get contextValue(){return B.contextValue},set contextValue(L){B.contextValue=L},get label(){return B.label},set label(L){B.label=L},get state(){return B.state},set state(L){B.state=L},reveal:L=>B.reveal(L),dispose:()=>{B.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new N.$Sc);const w=P=>Object.prototype.hasOwnProperty.call(this.b,P),k={};w("range")&&(k.range=R.Range.from(this.p)),w("label")&&(k.label=this.label),w("contextValue")&&(k.contextValue=this.contextValue??null),w("comments")&&(k.comments=this.q.map(P=>g(this,P,this.k,this.extensionDescription))),w("collapsibleState")&&(k.collapseState=m(this.g)),w("canReply")&&(k.canReply=this.canReply),w("state")&&(k.state=d(this.h)),w("applicability")&&(k.applicability=E(this.h)),w("isTemplate")&&(k.isTemplate=this.r),this.b={},l.$updateCommentThread(this.m,this.handle,this.n,this.o,k)}getCommentByUniqueId(w){for(const k of this.k){const P=k[0],h=k[1];if(w===h)return P}}async reveal(w){return(0,S.$5G)(this.extensionDescription,"commentReveal"),l.$revealCommentThread(this.m,this.handle,{preserveFocus:!1,focusReply:!1,...w})}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(w=>w.dispose())}}Qe([(0,I.$8h)(100)],r.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(w){this.b=w,w?.resourceHints&&(0,S.$5G)(this.h,"commentingRangeHint"),l.$updateCommentingRanges(this.handle,w?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(w){this.c=w,l.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!w})}get options(){return this.d}set options(w){this.d=w,l.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,S.$5G)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,S.$5G)(this.h,"activeComment"),this.f}constructor(w,k,P,h){this.h=w,this.i=k,this.j=P,this.k=h,this.a=new Map,l.$registerCommentController(this.handle,P,h,this.h.identifier.value);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(M){b.options=M},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(M){b.commentingRangeProvider=M},get reactionHandler(){return b.reactionHandler},set reactionHandler(M){b.reactionHandler=M},get activeCommentThread(){return b.activeCommentThread},createCommentThread(M,O,F){return b.createCommentThread(M,O,F).value},dispose:()=>{b.dispose()}}),this.g=[],this.g.push({dispose:()=>{l.$unregisterCommentController(this.handle)}})}createCommentThread(w,k,P){k===void 0&&(0,S.$5G)(this.h,"fileComments");const h=new r(this.id,this.handle,void 0,w,k,P,this.h,!1);return this.a.set(h.handle,h),h}$setActiveComment(w){if(!w){this.e=void 0,this.f=void 0;return}const k=this.a.get(w.commentThreadHandle);k&&(this.e=w.uniqueIdInThread?k.getCommentByUniqueId(w.uniqueIdInThread):void 0,this.f=k)}$createCommentThreadTemplate(w,k,P){const h=new r(this.id,this.handle,void 0,T.URI.revive(w),R.Range.to(k),[],this.h,!0,P);return h.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(h.handle,h),h}$updateCommentThreadTemplate(w,k){const P=this.a.get(w);P&&(P.range=R.Range.to(k))}$deleteCommentThread(w){this.a.get(w)?.dispose(),this.a.delete(w)}getCommentThread(w){return this.a.get(w)}dispose(){this.a.forEach(w=>{w.dispose()}),this.g.forEach(w=>w.dispose())}}function g(D,w,k,P){let h=k.get(w);return h||(h=++D.commentHandle,k.set(w,h)),w.state!==void 0&&(0,S.$5G)(P,"commentsDraftState"),w.reactions?.some(b=>b.reactors!==void 0)&&(0,S.$5G)(P,"commentReactor"),{mode:w.mode,contextValue:w.contextValue,uniqueIdInThread:h,body:typeof w.body=="string"?w.body:R.MarkdownString.from(w.body),userName:w.author.name,userIconPath:w.author.iconPath,label:w.label,commentReactions:w.reactions?w.reactions.map(b=>u(b)):void 0,state:w.state,timestamp:w.timestamp?.toJSON()}}function u(D){return{label:D.label,iconPath:D.iconPath?R.$ZP(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted,reactors:D.reactors&&D.reactors.length>0&&typeof D.reactors[0]!="string"?D.reactors.map(w=>w.name):D.reactors}}function p(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?T.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1,reactors:D.reactors?.map(w=>({name:w}))}}function m(D){if(D!==void 0)switch(D){case y.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case y.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function d(D){let w;if(typeof D=="object"?w=D.resolved:w=D,w!==void 0)switch(w){case y.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case y.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}function E(D){let w;if(typeof D=="object"&&(w=D.applicability),w!==void 0)switch(w){case y.CommentThreadApplicability.Current:return $.CommentThreadApplicability.Current;case y.CommentThreadApplicability.Outdated:return $.CommentThreadApplicability.Outdated}return $.CommentThreadApplicability.Current}return new i}}),define(Ne[235],Oe([1,0,21,75,4,15,23,2,8,67,79,5,7]),function(we,e,v,I,C,N,A,T,$,a,R,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xoc=void 0,$=Ve($),y=Ve(y),c=Ve(c);class S{constructor(u,p){this.document=u,this.b=p,this.a=1,this.c=new R.$loc("custom documents")}addEdit(u){return this.c.add([u])}async undo(u,p){await this.f(u).undo(),p||this.disposeBackup()}async redo(u,p){await this.f(u).redo(),p||this.disposeBackup()}disposeEdits(u){for(const p of u)this.c.delete(p)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const u=t(this.document.uri)+this.a++;return(0,A.$dh)(this.b,u)}updateBackup(u){this.d?.delete(),this.d=u}disposeBackup(){this.d?.delete(),this.d=void 0}f(u){const p=this.c.get(u,0);if(!p)throw new Error("No edit found");return p}}class f{constructor(){this.a=new Map}get(u,p){return this.a.get(this.b(u,p))}add(u,p,m){const d=this.b(u,p.uri);if(this.a.has(d))throw new Error(`Document already exists for viewType:${u} resource:${p.uri}`);const E=new S(p,m);return this.a.set(d,E),E}delete(u,p){const m=this.b(u,p.uri);this.a.delete(m)}b(u,p){return`${u}@@@${p}`}}var n;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(n||(n={}));class o{constructor(){this.a=new Map}addTextProvider(u,p,m){return this.b(u,{type:n.Text,extension:p,provider:m})}addCustomProvider(u,p,m){return this.b(u,{type:n.Custom,extension:p,provider:m})}get(u){return this.a.get(u)}b(u,p){if(this.a.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this.a.set(u,p),new c.$uN(()=>this.a.delete(u))}}class s{constructor(u,p,m,d,E){this.d=p,this.f=m,this.g=d,this.h=E,this.b=new o,this.c=new f,this.a=u.getProxy(y.$sN.MainThreadCustomEditors)}registerCustomEditorProvider(u,p,m,d){const E=new C.$Sc;return i(m)?(E.add(this.b.addTextProvider(p,u,m)),this.a.$registerTextEditorProvider((0,a.$Uoc)(u),p,d.webviewOptions||{},{supportsMove:!!m.moveCustomTextEditor},(0,a.$Soc)(u))):(E.add(this.b.addCustomProvider(p,u,m)),l(m)&&E.add(m.onDidChangeCustomDocument(D=>{const w=this.i(p,D.document.uri);if(r(D)){const k=w.addEdit(D);this.a.$onDidEdit(D.document.uri,p,k,D.label)}else this.a.$onContentChange(D.document.uri,p)})),this.a.$registerCustomEditorProvider((0,a.$Uoc)(u),p,d.webviewOptions||{},!!d.supportsMultipleEditorsPerDocument,(0,a.$Soc)(u))),c.$uN.from(E,new c.$uN(()=>{this.a.$unregisterEditorProvider(p)}))}async $createCustomDocument(u,p,m,d,E){const D=this.b.get(p);if(!D)throw new Error(`No provider found for '${p}'`);if(D.type!==n.Custom)throw new Error(`Invalid provide type for '${p}'`);const w=T.URI.revive(u),k=await D.provider.openCustomDocument(w,{backupId:m,untitledDocumentData:d?.buffer},E);let P;return l(D.provider)&&this.f&&(P=this.f.workspaceValue(D.extension)??this.f.globalValue(D.extension)),this.c.add(p,k,P),{editable:l(D.provider)}}async $disposeCustomDocument(u,p){const m=this.b.get(p);if(!m)throw new Error(`No provider found for '${p}'`);if(m.type!==n.Custom)throw new Error(`Invalid provider type for '${p}'`);const d=T.URI.revive(u),{document:E}=this.i(p,d);this.c.delete(p,E),E.dispose()}async $resolveCustomEditor(u,p,m,d,E,D){const w=this.b.get(m);if(!w)throw new Error(`No provider found for '${m}'`);const k=$.ViewColumn.to(E),P=this.g.createNewWebview(p,d.contentOptions,w.extension),h=this.h.createNewWebviewPanel(p,m,d.title,k,d.options,P,d.active),b=T.URI.revive(u);switch(w.type){case n.Custom:{const{document:M}=this.i(m,b);return w.provider.resolveCustomEditor(M,h,D)}case n.Text:{const M=this.d.getDocument(b);return w.provider.resolveCustomTextEditor(M,h,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(u,p,m){this.i(p,u).disposeEdits(m)}async $onMoveCustomEditor(u,p,m){const d=this.b.get(m);if(!d)throw new Error(`No provider found for '${m}'`);if(!d.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${m}'`);const E=this.h.getWebviewPanel(u);if(!E)throw new Error("No webview found");const D=T.URI.revive(p),w=this.d.getDocument(D);await d.provider.moveCustomTextEditor(w,E,v.CancellationToken.None)}async $undo(u,p,m,d){return this.i(p,u).undo(m,d)}async $redo(u,p,m,d){return this.i(p,u).redo(m,d)}async $revert(u,p,m){const d=this.i(p,u);await this.j(p).revertCustomDocument(d.document,m),d.disposeBackup()}async $onSave(u,p,m){const d=this.i(p,u);await this.j(p).saveCustomDocument(d.document,m),d.disposeBackup()}async $onSaveAs(u,p,m,d){const E=this.i(p,u);return this.j(p).saveCustomDocumentAs(E.document,T.URI.revive(m),d)}async $backup(u,p,m){const d=this.i(p,u),D=await this.j(p).backupCustomDocument(d.document,{destination:d.getNewBackupUri()},m);return d.updateBackup(D),D.id}i(u,p){const m=this.c.get(u,T.URI.revive(p));if(!m)throw new Error("No custom document found");return m}j(u){const m=this.b.get(u)?.provider;if(!m||!l(m))throw new Error("Custom document is not editable");return m}}e.$Xoc=s;function l(g){return!!g.onDidChangeCustomDocument}function i(g){return typeof g.resolveCustomTextEditor=="function"}function r(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function t(g){const u=g.scheme===N.Schemas.file||g.scheme===N.Schemas.untitled?g.fsPath:g.toString();return(0,I.$qj)(u)+""}}),define(Ne[236],Oe([1,0,9,107,2,5,7,8,6,11,28,50]),function(we,e,v,I,C,N,A,T,$,a,R,y){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$toc=e.$soc=void 0,T=Ve(T);class S{#e;#t;#i;constructor(o,s,l,i,r,t,g,u){this.d=o,this.e=s,this.f=l,this.g=i,this.h=r,this.c=!1,this.f=Math.max(i,l),this.#i=new R.$zc(p=>t.getComparisonKey(p)),this.#e=g,this.#t=u}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,s){if(!o){this.clear();return}this.j();let l=[];if(C.URI.isUri(o)){if(!s){this.delete(o);return}this.#i.set(o,s.slice()),l=[o]}else if(Array.isArray(o)){l=[];let t;o=[...o].sort(S.k);for(const g of o){const[u,p]=g;if((!t||u.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=u,l.push(u),this.#i.set(u,[])),p)this.#i.get(u)?.push(...p);else{const m=this.#i.get(u);m&&(m.length=0)}}}if(this.#t.fire(l),!this.#e)return;const i=[];let r=0;for(const t of l){let g=[];const u=this.#i.get(t);if(u)if(u.length>this.g){g=[];const p=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let m=0;m<4;m++)for(const d of u)if(d.severity===p[m]&&g.push({...T.Diagnostic.from(d),modelVersionId:this.h(t)})===this.g)break e;g.push({severity:I.MarkerSeverity.Info,message:(0,v.localize)(10673,null,u.length-this.g),startLineNumber:g[g.length-1].startLineNumber,startColumn:g[g.length-1].startColumn,endLineNumber:g[g.length-1].endLineNumber,endColumn:g[g.length-1].endColumn})}else g=u.map(p=>({...T.Diagnostic.from(p),modelVersionId:this.h(t)}));if(i.push([t,g]),r+=g.length,r>this.f)break}this.#e.$changeMany(this.e,i)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,s){this.j();for(const[l,i]of this)o.call(s,l,i,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const s=this.#i.get(o);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,s){return o[0].toString()<s[0].toString()?-1:o[0].toString()>s[0].toString()?1:0}}e.$soc=S;let f=class{static{c=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*c.d}static _mapper(o){const s=new R.$zc;for(const l of o)s.set(l,l);return{uris:Object.freeze(Array.from(s.values()))}}constructor(o,s,l,i){this.j=s,this.k=l,this.l=i,this.g=new Map,this.h=new $.$ne({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,c._mapper),this.f=o.getProxy(N.$sN.MainThreadDiagnostics)}createDiagnosticCollection(o,s){const{g:l,f:i,h:r,j:t,k:g,l:u}=this,p=new class{$changeMany(E,D){i.$changeMany(E,D),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,E,D.length===0?"CLEARING":D)}$clear(E){i.$clear(E),t.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,E)}dispose(){i.dispose()}};let m;if(!s)s="_generated_diagnostic_collection_name_#"+c.c++,m=s;else if(!l.has(s))m=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do m=s+c.c++;while(l.has(m))}return new class extends S{constructor(){super(s,m,c.e,c.d,E=>u.getDocument(E)?.version,g.extUri,p,r),l.set(m,this)}dispose(){super.dispose(),l.delete(m)}}}getDiagnostics(o){if(o)return this.m(o);{const s=new Map,l=[];for(const i of this.g.values())i.forEach((r,t)=>{let g=s.get(r.toString());typeof g>"u"&&(g=l.length,s.set(r.toString(),g),l.push([r,[]])),l[g][1]=l[g][1].concat(...t)});return l}}m(o){let s=[];for(const l of this.g.values())l.has(o)&&(s=s.concat(l.get(o)));return s}$acceptMarkersChange(o){if(!this.n){const s="_generated_mirror",l=new S(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(s,l),this.n=l}for(const[s,l]of o)this.n.set(C.URI.revive(s),l.map(T.Diagnostic.to))}};e.$toc=f,e.$toc=f=c=Qe([qe(1,a.$9j),qe(2,y.$roc)],f)}),define(Ne[237],Oe([1,0,2,13,7,8,170,38]),function(we,e,v,I,C,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gpc=void 0;class ${constructor(R,y,c,S={timeout:1500,errors:3}){this.c=R,this.d=y,this.f=c,this.g=S,this.a=new A.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(R){return(y,c,S)=>{const n={dispose:this.a.push([y,c,R])};return Array.isArray(S)&&S.push(n),n}}async $participateInSave(R,y){const c=v.URI.revive(R);let S=!1;const f=setTimeout(()=>S=!0,this.g.timeout),n=[];try{for(const o of[...this.a]){if(S)break;const s=this.d.getDocument(c),l=await this.h(o,{document:s,reason:N.TextDocumentSaveReason.to(y)});n.push(l)}}finally{clearTimeout(f)}return n}h([R,y,c],S){const f=this.b.get(R);return typeof f=="number"&&f>this.g.errors?Promise.resolve(!1):this.i(c,R,y,S).then(()=>!0,n=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${c.identifier.value}' threw ERROR`),this.c.error(n),!(n instanceof Error)||n.message!=="concurrent_edits"){const o=this.b.get(R);this.b.set(R,o?o+1:1),typeof o=="number"&&o>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${c.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(R,y,c,S){const f=[],n=Date.now(),{document:o,reason:s}=S,{version:l}=o,i=Object.freeze({document:o,reason:s,waitUntil(r){if(Object.isFrozen(f))throw(0,I.$7)("waitUntil can not be called async");f.push(Promise.resolve(r))}});try{y.apply(c,[i])}catch(r){return Promise.reject(r)}return Object.freeze(f),new Promise((r,t)=>{const g=setTimeout(()=>t(new Error("timeout")),this.g.timeout);return Promise.all(f).then(u=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${R.identifier.value}' finished after ${Date.now()-n}ms`),clearTimeout(g),r(u)}).catch(u=>{clearTimeout(g),t(u)})}).then(r=>{const t={edits:[]};for(const g of r)if(Array.isArray(g)&&g.every(u=>u instanceof C.$BN))for(const{newText:u,newEol:p,range:m}of g)t.edits.push({resource:o.uri,versionId:void 0,textEdit:{range:m&&N.Range.from(m),text:u,eol:p&&N.EndOfLine.from(p)}});if(t.edits.length!==0)return l===o.version?this.f.$tryApplyWorkspaceEdit(new T.$Sw(t)):Promise.reject(new Error("concurrent_edits"))})}}e.$Gpc=$}),define(Ne[238],Oe([1,0,6,4,2,5,123,8,14,25,7]),function(we,e,v,I,C,N,A,T,$,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uoc=void 0,T=Ve(T);class y{constructor(S,f){this.a=new v.$je,this.b=new v.$je,this.c=new v.$je,this.d=new v.$je,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new I.$Sc,this.h=new Map,this.f=S.getProxy(N.$sN.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(n=>{for(const o of n)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(n=>{for(const o of n)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(S){if(!S)return;const f=this.g.getDocument(S);if(f)return f}getDocument(S){const f=this.getDocumentData(S);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${S}'`);return f.document}ensureDocumentData(S){const f=this.g.getDocument(S);if(f)return Promise.resolve(f);let n=this.h.get(S.toString());return n||(n=this.f.$tryOpenDocument(S).then(o=>{this.h.delete(S.toString());const s=C.URI.revive(o);return(0,$.$ng)(this.g.getDocument(s))},o=>(this.h.delete(S.toString()),Promise.reject(o))),this.h.set(S.toString(),n)),n}createDocumentData(S){return this.f.$tryCreateDocument(S).then(f=>C.URI.revive(f))}$acceptModelLanguageChanged(S,f){const n=C.URI.revive(S),o=this.g.getDocument(n);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(f),this.a.fire(o.document)}$acceptModelSaved(S){const f=C.URI.revive(S),n=this.g.getDocument(f);if(!n)throw new Error("unknown document");this.$acceptDirtyStateChanged(S,!1),this.d.fire(n.document)}$acceptDirtyStateChanged(S,f){const n=C.URI.revive(S),o=this.g.getDocument(n);if(!o)throw new Error("unknown document");o._acceptIsDirty(f),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(S,f,n){const o=C.URI.revive(S),s=this.g.getDocument(o);if(!s)throw new Error("unknown document");s._acceptIsDirty(n),s.onEvents(f);let l;f.isUndoing?l=R.TextDocumentChangeReason.Undo:f.isRedoing&&(l=R.TextDocumentChangeReason.Redo),this.c.fire((0,a.$bo)({document:s.document,contentChanges:f.changes.map(i=>({range:T.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:l}))}setWordDefinitionFor(S,f){(0,A.$3P)(S,f)}}e.$uoc=y}),define(Ne[70],Oe([1,0,239,6,14,2,3,5,16,8,7]),function(we,e,v,I,C,N,A,T,$,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zoc=e.$Yoc=void 0,a=Ve(a),e.$Yoc=(0,A.$Ci)("IExtHostEditorTabs");class y{constructor(o,s,l){this.e=l,this.d=s,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,s={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case T.TabInputKind.TextInput:return new R.$fP(N.URI.revive(this.b.input.uri));case T.TabInputKind.TextDiffInput:return new R.$gP(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified));case T.TabInputKind.TextMergeInput:return new R.$hP(N.URI.revive(this.b.input.base),N.URI.revive(this.b.input.input1),N.URI.revive(this.b.input.input2),N.URI.revive(this.b.input.result));case T.TabInputKind.CustomEditorInput:return new R.$iP(N.URI.revive(this.b.input.uri),this.b.input.viewType);case T.TabInputKind.WebviewEditorInput:return new R.$jP(this.b.input.viewType);case T.TabInputKind.NotebookInput:return new R.$kP(N.URI.revive(this.b.input.uri),this.b.input.notebookType);case T.TabInputKind.NotebookDiffInput:return new R.$lP(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified),this.b.input.notebookType);case T.TabInputKind.TerminalEditorInput:return new R.$mP;case T.TabInputKind.InteractiveEditorInput:return new R.$nP(N.URI.revive(this.b.input.uri),N.URI.revive(this.b.input.inputBoxUri));case T.TabInputKind.ChatEditorInput:return new R.$oP;case T.TabInputKind.MultiDiffEditorInput:return new R.$pP(this.b.input.diffEditors.map(o=>new R.$gP(N.URI.revive(o.original),N.URI.revive(o.modified))));default:return}}}class c{constructor(o,s){this.c=[],this.d="",this.b=o,this.e=s;for(const l of o.tabs)l.isActive&&(this.d=l.id),this.c.push(new y(l,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,s={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return a.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(l=>l.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(l=>l.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===T.TabModelOperationKind.TAB_OPEN){const l=new y(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,l),o.tabDto.isActive&&(this.d=l.tabId),l}else if(o.kind===T.TabModelOperationKind.TAB_CLOSE){const l=this.c.splice(o.index,1)[0];if(!l)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return l.tabId===this.d&&(this.d=""),l}else if(o.kind===T.TabModelOperationKind.TAB_MOVE){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const l=this.c.splice(o.oldIndex,1)[0];if(!l)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,l),l}const s=this.c.find(l=>l.tabId===o.tabDto.id);if(!s)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(o.tabDto),s}activeTabId(){return this.d}}let S=class{constructor(o){this.b=new I.$je,this.c=new I.$je,this.e=[],this.a=o.getProxy(T.$sN.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,s={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(l=>l.apiObject))},get activeTabGroup(){const l=o.d;return(0,C.$ng)(o.e.find(r=>r.groupId===l)?.apiObject)},close:async(l,i)=>{const r=Array.isArray(l)?l:[l];return r.length?f(r[0])?this.j(r,i):this.i(r,i):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(o){const s=new Set(this.e.map(p=>p.groupId)),l=new Set(o.map(p=>p.groupId)),i=(0,v.$d)(s,l),r=this.e.filter(p=>i.removed.includes(p.groupId)).map(p=>p.apiObject),t=[],g=[];this.e=o.map(p=>{const m=new c(p,()=>this.d);return i.added.includes(m.groupId)?t.push(m.apiObject):g.push(m.apiObject),m});const u=(0,C.$ng)(o.find(p=>p.isActive===!0)?.groupId);u!==void 0&&this.d!==u&&(this.d=u),this.c.fire(Object.freeze({opened:t,closed:r,changed:g}))}$acceptTabGroupUpdate(o){const s=this.e.find(l=>l.groupId===o.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const s=this.e.find(i=>i.groupId===o.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const l=s.acceptTabOperation(o);switch(o.kind){case T.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[l.apiObject],closed:[],changed:[]}));return;case T.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[l.apiObject],changed:[]}));return;case T.TabModelOperationKind.TAB_MOVE:case T.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[l.apiObject]}));return}}g(o){for(const s of this.e)for(const l of s.tabs)if(l.apiObject===o)return l}h(o){return this.e.find(s=>s.apiObject===o)}async i(o,s){const l=[];for(const i of o){const r=this.g(i);if(!r)throw new Error("Tab close: Invalid tab not found!");l.push(r.tabId)}return this.a.$closeTab(l,s)}async j(o,s){const l=[];for(const i of o){const r=this.h(i);if(!r)throw new Error("Group close: Invalid group not found!");l.push(r.groupId)}return this.a.$closeGroup(l,s)}};e.$Zoc=S,e.$Zoc=S=Qe([qe(0,$.$1P)],S);function f(n){return n.tabs!==void 0}}),define(Ne[240],Oe([1,0,2,5,29,4,7,8,284,12,27,22,24,59]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jpc=void 0,C=Ve(C),T=Ve(T);class f{constructor(){this.a=[]}add(s){this.b=void 0,this.a.push(s)}delete(s){const l=this.a.indexOf(s);l>=0&&(this.a.splice(l,1),this.b=void 0)}c(){if(!this.b){const s=this.a.sort(),l=[];let i,r,t=$.State.LastKnownState,g=$.State.LastKnownState;for(const u of s){let p=i?(0,a.$Ff)(i,u):0;for(p===0?r=$.State.Start:r=g;p<u.length;p++)p+1===u.length?(t=g,g=$.State.BeforeColon):g+=1,l.push([r,u.toUpperCase().charCodeAt(p),g]),l.push([r,u.toLowerCase().charCodeAt(p),g]),r=g;i=u,g=t}l.push([$.State.BeforeColon,R.CharCode.Colon,$.State.AfterColon]),l.push([$.State.AfterColon,R.CharCode.Slash,$.State.End]),this.b=new $.$f4(l)}}provideDocumentLinks(s){this.c();const l=[],i=$.$g4.computeLinks({getLineContent(r){return s.lineAt(r-1).text},getLineCount(){return s.lineCount}},this.b);for(const r of i){const t=T.DocumentLink.to(r);t.target&&l.push(t)}return l}}class n{constructor(s,l){this.i=l,this.b=new f,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=s.getProxy(I.$sN.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(s,l,i,r={}){if(n.j(i),this.d.has(l))throw new Error(`a provider for the scheme '${l}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(s,"*",this.b));const t=this.h++;this.b.add(l),this.d.add(l),this.c.set(t,i);let g=C.FileSystemProviderCapabilities.FileReadWrite;r.isCaseSensitive&&(g+=C.FileSystemProviderCapabilities.PathCaseSensitive),r.isReadonly&&(g+=C.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(g+=C.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,c.$5G)(s,"fsChunks"),g+=C.FileSystemProviderCapabilities.FileOpenReadWriteClose);let u;r.isReadonly&&(0,S.$2k)(r.isReadonly)&&r.isReadonly.value!==""&&(u={value:r.isReadonly.value,isTrusted:r.isReadonly.isTrusted,supportThemeIcons:r.isReadonly.supportThemeIcons,supportHtml:r.isReadonly.supportHtml,baseUri:r.isReadonly.baseUri,uris:r.isReadonly.uris}),this.a.$registerFileSystemProvider(t,l,g,u).catch(m=>{console.error(`FAILED to register filesystem provider of ${s.identifier.value}-extension for the scheme ${l}`),console.error(m)});const p=i.onDidChangeFile(m=>{const d=[];for(const E of m){const{uri:D,type:w}=E;if(D.scheme!==l)continue;let k;switch(w){case A.FileChangeType.Changed:k=C.FileChangeType.UPDATED;break;case A.FileChangeType.Created:k=C.FileChangeType.ADDED;break;case A.FileChangeType.Deleted:k=C.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}d.push({resource:D,type:k})}this.a.$onFileSystemChange(t,d)});return(0,N.$Rc)(()=>{p.dispose(),this.b.delete(l),this.d.delete(l),this.c.delete(t),this.a.$unregisterProvider(t)})}static j(s){if(!s)throw new Error("MISSING provider");if(typeof s.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof s.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof s.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof s.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof s.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof s.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof s.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof s.rename!="function")throw new Error("Provider does NOT implement rename")}static k(s){const{type:l,ctime:i,mtime:r,size:t,permissions:g}=s;return{type:l,ctime:i,mtime:r,size:t,permissions:g}}$stat(s,l){return Promise.resolve(this.l(s).stat(v.URI.revive(l))).then(i=>n.k(i))}$readdir(s,l){return Promise.resolve(this.l(s).readDirectory(v.URI.revive(l)))}$readFile(s,l){return Promise.resolve(this.l(s).readFile(v.URI.revive(l))).then(i=>y.$Le.wrap(i))}$writeFile(s,l,i,r){return Promise.resolve(this.l(s).writeFile(v.URI.revive(l),i.buffer,r))}$delete(s,l,i){return Promise.resolve(this.l(s).delete(v.URI.revive(l),i))}$rename(s,l,i,r){return Promise.resolve(this.l(s).rename(v.URI.revive(l),v.URI.revive(i),r))}$copy(s,l,i,r){const t=this.l(s);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(v.URI.revive(l),v.URI.revive(i),r))}$mkdir(s,l){return Promise.resolve(this.l(s).createDirectory(v.URI.revive(l)))}$watch(s,l,i,r){const t=this.l(s).watch(v.URI.revive(i),r);this.f.set(l,t)}$unwatch(s,l){const i=this.f.get(l);i&&(i.dispose(),this.f.delete(l))}$open(s,l,i){const r=this.l(s);if(!r.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(r.open(v.URI.revive(l),i))}$close(s,l){const i=this.l(s);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(l))}$read(s,l,i,r){const t=this.l(s);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const g=y.$Le.alloc(r);return Promise.resolve(t.read(l,i,g.buffer,0,r)).then(u=>g.slice(0,u))}$write(s,l,i,r){const t=this.l(s);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(l,i,r.buffer,0,r.byteLength))}l(s){const l=this.c.get(s);if(!l){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return l}}e.$Jpc=n}),define(Ne[241],Oe([1,0,6,41,2,5,8,7,29,48]),function(we,e,v,I,C,N,A,T,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kpc=void 0,A=Ve(A);class R{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(f,n,o,s,l,i){this.a=Math.random(),this.b=new v.$je,this.c=new v.$je,this.d=new v.$je,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const r=(0,I.$wk)(l),t=typeof l=="string",g=i?.correlate,u=s(p=>{if(!(typeof p.session=="number"&&p.session!==this.a)&&!(g&&typeof p.session>"u")){if(!i?.ignoreCreateEvents)for(const m of p.created){const d=C.URI.revive(m);r(d.fsPath)&&(!t||n.getWorkspaceFolder(d))&&this.b.fire(d)}if(!i?.ignoreChangeEvents)for(const m of p.changed){const d=C.URI.revive(m);r(d.fsPath)&&(!t||n.getWorkspaceFolder(d))&&this.c.fire(d)}if(!i?.ignoreDeleteEvents)for(const m of p.deleted){const d=C.URI.revive(m);r(d.fsPath)&&(!t||n.getWorkspaceFolder(d))&&this.d.fire(d)}}});this.g=T.$uN.from(this.i(f,o,l,i,i?.correlate),this.b,this.c,this.d,u)}i(f,n,o,s,l){const i=T.$uN.from();if(typeof o=="string"||s?.ignoreChangeEvents&&s?.ignoreCreateEvents&&s?.ignoreDeleteEvents)return i;const r=f.getProxy(N.$sN.MainThreadFileSystemEventService);let t=!1;(o.pattern.includes(I.$sk)||o.pattern.includes(I.$tk))&&(t=!0);let g;return l&&(s?.ignoreChangeEvents||s?.ignoreCreateEvents||s?.ignoreDeleteEvents)&&(g=$.FileChangeFilter.UPDATED|$.FileChangeFilter.ADDED|$.FileChangeFilter.DELETED,s?.ignoreChangeEvents&&(g&=~$.FileChangeFilter.UPDATED),s?.ignoreCreateEvents&&(g&=~$.FileChangeFilter.ADDED),s?.ignoreDeleteEvents&&(g&=~$.FileChangeFilter.DELETED)),r.$watch(n.identifier.value,this.a,o.baseUri,{recursive:t,excludes:s?.excludes??[],filter:g},!!l),T.$uN.from({dispose:()=>r.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class y{constructor(f){this.a=f,this.session=this.a.session,this.b=new a.$T(()=>this.a.created.map(C.URI.revive)),this.c=new a.$T(()=>this.a.changed.map(C.URI.revive)),this.d=new a.$T(()=>this.a.deleted.map(C.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class c{constructor(f,n,o){this.j=f,this.k=n,this.l=o,this.a=new v.$je,this.b=new v.$je,this.c=new v.$je,this.d=new v.$je,this.g=new v.$le,this.h=new v.$le,this.i=new v.$le,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(f,n,o,s){return new R(this.j,f,n,this.a.event,A.GlobPattern.from(o),s)}$onFileEvent(f){this.a.fire(new y(f))}$onDidRunFileOperation(f,n){switch(f){case $.FileOperation.MOVE:this.b.fire(Object.freeze({files:n.map(o=>({oldUri:C.URI.revive(o.source),newUri:C.URI.revive(o.target)}))}));break;case $.FileOperation.DELETE:this.d.fire(Object.freeze({files:n.map(o=>C.URI.revive(o.target))}));break;case $.FileOperation.CREATE:case $.FileOperation.COPY:this.c.fire(Object.freeze({files:n.map(o=>C.URI.revive(o.target))}));break;default:}}getOnWillRenameFileEvent(f){return this.m(f,this.g)}getOnWillCreateFileEvent(f){return this.m(f,this.h)}getOnWillDeleteFileEvent(f){return this.m(f,this.i)}m(f,n){return(o,s,l)=>{const i=function(t){o.call(s,t)};return i.extension=f,n.event(i,void 0,l)}}async $onWillRunFileOperation(f,n,o,s){switch(f){case $.FileOperation.MOVE:return await this.n(this.g,{files:n.map(l=>({oldUri:C.URI.revive(l.source),newUri:C.URI.revive(l.target)}))},o,s);case $.FileOperation.DELETE:return await this.n(this.i,{files:n.map(l=>C.URI.revive(l.target))},o,s);case $.FileOperation.CREATE:case $.FileOperation.COPY:return await this.n(this.h,{files:n.map(l=>C.URI.revive(l.target))},o,s)}}async n(f,n,o,s){const l=new Set,i=[];if(await f.fireAsync(n,s,async(t,g)=>{const u=Date.now(),p=await Promise.resolve(t);p instanceof T.$EN&&(i.push([g.extension,p]),l.add(g.extension.displayName??g.extension.identifier.value)),Date.now()-u>o&&this.k.warn("SLOW file-participant",g.extension.identifier)}),s.isCancellationRequested||i.length===0)return;const r={edits:[]};for(const[,t]of i){const{edits:g}=A.WorkspaceEdit.from(t,{getTextDocumentVersion:u=>this.l.getDocument(u)?.version,getNotebookDocumentVersion:()=>{}});r.edits=r.edits.concat(g)}return{edit:r,extensionNames:Array.from(l)}}}e.$Kpc=c}),define(Ne[242],Oe([1,0,17,10,21,13,96,4,25,69,12,14,2,32,285,93,103,9,18,8,7,24,79,5]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S,f,n,o,s,l,i,r,t,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$voc=void 0,n=Ve(n),i=Ve(i),u=Ve(u);class p{constructor(U,j){this.d=U,this.e=j}async provideDocumentSymbols(U,j){const G=this.d.getDocument(U),Q=await this.e.provideDocumentSymbols(G,j);if(!(0,v.$Jb)(Q))return Q[0]instanceof r.$ON?Q.map(i.DocumentSymbol.from):p.f(Q)}static f(U){U=U.slice(0).sort((Q,ne)=>{let de=Q.location.range.start.compareTo(ne.location.range.start);return de===0&&(de=ne.location.range.end.compareTo(Q.location.range.end)),de});const j=[],G=[];for(const Q of U){const ne={name:Q.name||"!!MISSING: name!!",kind:i.SymbolKind.from(Q.kind),tags:Q.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:i.Range.from(Q.location.range),selectionRange:i.Range.from(Q.location.range),children:[]};for(;;){if(G.length===0){G.push(ne),j.push(ne);break}const de=G[G.length-1];if(S.$Kt.containsRange(de.range,ne.range)&&!S.$Kt.equalsRange(de.range,ne.range)){de.children?.push(ne),G.push(ne);break}G.pop()}}return j}}class m{constructor(U,j,G,Q,ne,de){this.f=U,this.g=j,this.h=G,this.j=Q,this.k=ne,this.l=de,this.d=new g.$loc("CodeLens"),this.e=new Map}async provideCodeLenses(U,j){const G=this.f.getDocument(U),Q=await this.h.provideCodeLenses(G,j);if(!Q||j.isCancellationRequested)return;const ne=this.d.add(Q),de=new T.$Sc;this.e.set(ne,de);const Ie={cacheId:ne,lenses:[]};for(let je=0;je<Q.length;je++)Ie.lenses.push({cacheId:[ne,je],range:i.Range.from(Q[je].range),command:this.g.toInternal(Q[je].command,de)});return Ie}async resolveCodeLens(U,j){const G=U.cacheId&&this.d.get(...U.cacheId);if(!G)return;let Q;if(typeof this.h.resolveCodeLens!="function"||G.isResolved?Q=G:Q=await this.h.resolveCodeLens(G,j),Q||(Q=G),j.isCancellationRequested)return;const ne=U.cacheId&&this.e.get(U.cacheId[0]);if(ne){if(!Q.command){const de=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,de),this.l.error(de);return}return U.command=this.g.toInternal(Q.command,ne),U}}releaseCodeLenses(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}}function d(Te){return Array.isArray(Te)?Te.map(i.DefinitionLink.from):Te?[i.DefinitionLink.from(Te)]:[]}class E{constructor(U,j){this.d=U,this.e=j}async provideDefinition(U,j,G){const Q=this.d.getDocument(U),ne=i.Position.to(j),de=await this.e.provideDefinition(Q,ne,G);return d(de)}}class D{constructor(U,j){this.d=U,this.e=j}async provideDeclaration(U,j,G){const Q=this.d.getDocument(U),ne=i.Position.to(j),de=await this.e.provideDeclaration(Q,ne,G);return d(de)}}class w{constructor(U,j){this.d=U,this.e=j}async provideImplementation(U,j,G){const Q=this.d.getDocument(U),ne=i.Position.to(j),de=await this.e.provideImplementation(Q,ne,G);return d(de)}}class k{constructor(U,j){this.d=U,this.e=j}async provideTypeDefinition(U,j,G){const Q=this.d.getDocument(U),ne=i.Position.to(j),de=await this.e.provideTypeDefinition(Q,ne,G);return d(de)}}class P{static{this.f=10}constructor(U,j){this.g=U,this.h=j,this.d=0,this.e=new Map}async provideHover(U,j,G,Q){const ne=this.g.getDocument(U),de=i.Position.to(j);let Ie;if(G&&G.verbosityRequest){const tt=G.verbosityRequest.previousHover.id,nt=this.e.get(tt);if(!nt)throw new Error(`Hover with id ${tt} not found`);const et={verbosityDelta:G.verbosityRequest.verbosityDelta,previousHover:nt};Ie=await this.h.provideHover(ne,de,Q,et)}else Ie=await this.h.provideHover(ne,de,Q);if(!Ie||(0,v.$Jb)(Ie.contents))return;Ie.range||(Ie.range=ne.getWordRangeAtPosition(de)),Ie.range||(Ie.range=new r.$wN(de,de));const je=i.Hover.from(Ie),Ke=this.d;if(this.e.size===P.f){const tt=Math.min(...this.e.keys());this.e.delete(tt)}return this.e.set(Ke,Ie),this.d+=1,{...je,id:Ke}}releaseHover(U){this.e.delete(U)}}class h{constructor(U,j){this.d=U,this.e=j}async provideEvaluatableExpression(U,j,G){const Q=this.d.getDocument(U),ne=i.Position.to(j),de=await this.e.provideEvaluatableExpression(Q,ne,G);if(de)return i.EvaluatableExpression.from(de)}}class b{constructor(U,j){this.d=U,this.e=j}async provideInlineValues(U,j,G,Q){const ne=this.d.getDocument(U),de=await this.e.provideInlineValues(ne,i.Range.to(j),i.InlineValueContext.to(G),Q);if(Array.isArray(de))return de.map(Ie=>i.InlineValue.from(Ie))}}class M{constructor(U,j){this.d=U,this.e=j}async provideDocumentHighlights(U,j,G){const Q=this.d.getDocument(U),ne=i.Position.to(j),de=await this.e.provideDocumentHighlights(Q,ne,G);if(Array.isArray(de))return de.map(i.DocumentHighlight.from)}}class O{constructor(U,j){this.d=U,this.e=j}async provideMultiDocumentHighlights(U,j,G,Q){const ne=this.d.getDocument(U),de=G.map(Ke=>this.d.getDocument(Ke)),Ie=i.Position.to(j),je=await this.e.provideMultiDocumentHighlights(ne,Ie,de,Q);if(Array.isArray(je))return je.map(i.MultiDocumentHighlight.from)}}class F{constructor(U,j){this.d=U,this.e=j}async provideLinkedEditingRanges(U,j,G){const Q=this.d.getDocument(U),ne=i.Position.to(j),de=await this.e.provideLinkedEditingRanges(Q,ne,G);if(de&&Array.isArray(de.ranges))return{ranges:(0,v.$Gb)(de.ranges.map(i.Range.from)),wordPattern:de.wordPattern}}}class q{constructor(U,j){this.d=U,this.e=j}async provideReferences(U,j,G,Q){const ne=this.d.getDocument(U),de=i.Position.to(j),Ie=await this.e.provideReferences(ne,de,G,Q);if(Array.isArray(Ie))return Ie.map(i.location.from)}}class B{static{this.d=1e3}constructor(U,j,G,Q,ne,de,Ie){this.g=U,this.h=j,this.j=G,this.k=Q,this.l=ne,this.m=de,this.n=Ie,this.e=new g.$loc("CodeAction"),this.f=new Map}async provideCodeActions(U,j,G,Q){const ne=this.g.getDocument(U),de=f.$Mt.isISelection(j)?i.Selection.to(j):i.Range.to(j),Ie=[];for(const et of this.j.getDiagnostics(U))if(de.intersection(et.range)&&Ie.push(et)>B.d)break;const je={diagnostics:Ie,only:G.only?new r.$QN(G.only):void 0,triggerKind:i.CodeActionTriggerKind.to(G.trigger)},Ke=await this.k.provideCodeActions(ne,de,je,Q);if(!(0,v.$Kb)(Ke)||Q.isCancellationRequested)return;const _e=this.e.add(Ke),tt=new T.$Sc;this.f.set(_e,tt);const nt=[];for(let et=0;et<Ke.length;et++){const rt=Ke[et];if(rt)if(B.o(rt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,tt)});else{je.only&&(rt.kind?je.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value}' requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ft=rt.ranges??[];nt.push({cacheId:[_e,et],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,tt),diagnostics:rt.diagnostics&&rt.diagnostics.map(i.Diagnostic.from),edit:rt.edit&&i.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,t.$4G)(this.m,"codeActionAI")?rt.isAI:!1,ranges:(0,t.$4G)(this.m,"codeActionRanges")?(0,v.$Gb)(ft.map(i.Range.from)):void 0,disabled:rt.disabled?.reason})}}return{cacheId:_e,actions:nt}}async resolveCodeAction(U,j){const[G,Q]=U,ne=this.e.get(G,Q);if(!ne||B.o(ne))return{};if(!this.k.resolveCodeAction)return{};const de=await this.k.resolveCodeAction(ne,j)??ne;let Ie;de.edit&&(Ie=i.WorkspaceEdit.from(de.edit,void 0));let je;if(de.command){const Ke=this.f.get(G);Ke&&(je=this.h.toInternal(de.command,Ke))}return{edit:Ie,command:je}}releaseCodeActions(U){this.f.get(U)?.dispose(),this.f.delete(U),this.e.delete(U)}static o(U){return typeof U.command=="string"&&typeof U.title=="string"}}class L{constructor(U,j,G,Q,ne){this.e=U,this.f=j,this.g=G,this.h=Q,this.j=ne,this.d=new g.$loc("DocumentPasteEdit")}async prepareDocumentPaste(U,j,G,Q){if(!this.g.prepareDocumentPaste)return;const ne=this.f.getDocument(U),de=j.map(Ke=>i.Range.to(Ke)),Ie=i.DataTransfer.toDataTransfer(G,()=>{throw new N.$0});if(await this.g.prepareDocumentPaste(ne,de,Ie,Q),Q.isCancellationRequested)return;const je=Array.from(Ie).filter(([,Ke])=>!(Ke instanceof r.$kO));return i.DataTransfer.from(je)}async providePasteEdits(U,j,G,Q,ne,de){if(!this.g.provideDocumentPasteEdits)return[];const Ie=this.f.getDocument(j),je=G.map(nt=>i.Range.to(nt)),Ke=i.DataTransfer.toDataTransfer(Q,async nt=>(await this.e.$resolvePasteFileData(this.h,U,nt)).buffer),_e=await this.g.provideDocumentPasteEdits(Ie,je,Ke,{only:ne.only?new r.$pO(ne.only):void 0,triggerKind:ne.triggerKind},de);if(!_e||de.isCancellationRequested)return[];const tt=this.d.add(_e);return _e.map((nt,et)=>({_cacheId:[tt,et],title:nt.title??(0,s.localize)(10669,null,this.j.displayName||this.j.name),kind:nt.kind,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(U,j){const[G,Q]=U,ne=this.d.get(G,Q);if(!ne||!this.g.resolveDocumentPasteEdit)return{};const de=await this.g.resolveDocumentPasteEdit(ne,j)??ne;return{additionalEdit:de.additionalEdit?i.WorkspaceEdit.from(de.additionalEdit,void 0):void 0}}releasePasteEdits(U){this.d.delete(U)}}class Y{constructor(U,j){this.d=U,this.e=j}async provideDocumentFormattingEdits(U,j,G){const Q=this.d.getDocument(U),ne=await this.e.provideDocumentFormattingEdits(Q,j,G);if(Array.isArray(ne))return ne.map(i.TextEdit.from)}}class Z{constructor(U,j){this.d=U,this.e=j}async provideDocumentRangeFormattingEdits(U,j,G,Q){const ne=this.d.getDocument(U),de=i.Range.to(j),Ie=await this.e.provideDocumentRangeFormattingEdits(ne,de,G,Q);if(Array.isArray(Ie))return Ie.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(U,j,G,Q){(0,y.$mg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ne=this.d.getDocument(U),de=j.map(i.Range.to),Ie=await this.e.provideDocumentRangesFormattingEdits(ne,de,G,Q);if(Array.isArray(Ie))return Ie.map(i.TextEdit.from)}}class fe{constructor(U,j){this.d=U,this.e=j,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,j,G,Q,ne){const de=this.d.getDocument(U),Ie=i.Position.to(j),je=await this.e.provideOnTypeFormattingEdits(de,Ie,G,Q,ne);if(Array.isArray(je))return je.map(i.TextEdit.from)}}class _{constructor(U,j){this.e=U,this.f=j,this.d=new g.$loc("WorkspaceSymbols")}async provideWorkspaceSymbols(U,j){const G=await this.e.provideWorkspaceSymbols(U,j);if(!(0,v.$Kb)(G))return{symbols:[]};const Q=this.d.add(G),ne={cacheId:Q,symbols:[]};for(let de=0;de<G.length;de++){const Ie=G[de];if(!Ie||!Ie.name){this.f.warn("INVALID SymbolInformation",Ie);continue}ne.symbols.push({...i.WorkspaceSymbol.from(Ie),cacheId:[Q,de]})}return ne}async resolveWorkspaceSymbol(U,j){if(typeof this.e.resolveWorkspaceSymbol!="function"||!U.cacheId)return U;const G=this.d.get(...U.cacheId);if(G){const Q=await this.e.resolveWorkspaceSymbol(G,j);return Q&&(0,$.$do)(U,i.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(U){this.d.delete(U)}}class ge{static supportsResolving(U){return typeof U.prepareRename=="function"}constructor(U,j,G){this.d=U,this.e=j,this.f=G}async provideRenameEdits(U,j,G,Q){const ne=this.d.getDocument(U),de=i.Position.to(j);try{const Ie=await this.e.provideRenameEdits(ne,de,G,Q);return Ie?i.WorkspaceEdit.from(Ie):void 0}catch(Ie){const je=ge.g(Ie);return je?{rejectReason:je,edits:void 0}:Promise.reject(Ie)}}async resolveRenameLocation(U,j,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Q=this.d.getDocument(U),ne=i.Position.to(j);try{const de=await this.e.prepareRename(Q,ne,G);let Ie,je;if(r.$wN.isRange(de)?(Ie=de,je=Q.getText(de)):(0,y.$eg)(de)&&(Ie=de.range,je=de.placeholder),!Ie||!je)return;if(Ie.start.line>ne.line||Ie.end.line<ne.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Ie),text:je}}catch(de){const Ie=ge.g(de);return Ie?{rejectReason:Ie,range:void 0,text:void 0}:Promise.reject(de)}}static g(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class se{static{this.d={[n.NewSymbolNameTriggerKind.Invoke]:r.NewSymbolNameTriggerKind.Invoke,[n.NewSymbolNameTriggerKind.Automatic]:r.NewSymbolNameTriggerKind.Automatic}}constructor(U,j,G){this.e=U,this.f=j,this.g=G}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(U,j,G,Q){const ne=this.e.getDocument(U),de=i.Range.to(j);try{const Ie=se.d[G],je=await this.f.provideNewSymbolNames(ne,de,Ie,Q);return je?je.map(Ke=>typeof Ke=="string"?{newSymbolName:Ke}:{newSymbolName:Ke.newSymbolName,tags:Ke.tags}):void 0}catch(Ie){this.g.error(se.h(Ie)??JSON.stringify(Ie,null,"	"));return}}static h(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class ae{constructor(U,j){this.resultId=U,this.tokens=j}}class $e{constructor(U,j){this.f=U,this.g=j,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(U,j,G){const Q=this.f.getDocument(U),ne=j!==0?this.d.get(j):null;let de=typeof ne?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Q,ne.resultId,G):await this.g.provideDocumentSemanticTokens(Q,G);return ne&&this.d.delete(j),de?(de=$e.h(de),this.o($e.n(ne,de),de)):null}async releaseDocumentSemanticColoring(U){this.d.delete(U)}static h(U){return $e.j(U)?$e.k(U)?U:new r.$PO(new Uint32Array(U.data),U.resultId):$e.l(U)?$e.m(U)?U:new r.$RO(U.edits.map(j=>new r.$QO(j.start,j.deleteCount,j.data?new Uint32Array(j.data):j.data)),U.resultId):U}static j(U){return U&&!!U.data}static k(U){return U.data instanceof Uint32Array}static l(U){return U&&Array.isArray(U.edits)}static m(U){for(const j of U.edits)if(!(j.data instanceof Uint32Array))return!1;return!0}static n(U,j){if(!$e.j(j)||!U||!U.tokens)return j;const G=U.tokens,Q=G.length,ne=j.data,de=ne.length;let Ie=0;const je=Math.min(Q,de);for(;Ie<je&&G[Ie]===ne[Ie];)Ie++;if(Ie===Q&&Ie===de)return new r.$RO([],j.resultId);let Ke=0;const _e=je-Ie;for(;Ke<_e&&G[Q-Ke-1]===ne[de-Ke-1];)Ke++;return new r.$RO([{start:Ie,deleteCount:Q-Ie-Ke,data:ne.subarray(Ie,de-Ke)}],j.resultId)}o(U,j){if($e.j(U)){const G=this.e++;return this.d.set(G,new ae(U.resultId,U.data)),(0,o.$ydb)({id:G,type:"full",data:U.data})}if($e.l(U)){const G=this.e++;return $e.j(j)?this.d.set(G,new ae(j.resultId,j.data)):this.d.set(G,new ae(U.resultId)),(0,o.$ydb)({id:G,type:"delta",deltas:(U.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}class oe{constructor(U,j){this.d=U,this.e=j}async provideDocumentRangeSemanticTokens(U,j,G){const Q=this.d.getDocument(U),ne=await this.e.provideDocumentRangeSemanticTokens(Q,i.Range.to(j),G);return ne?this.f(ne):null}f(U){return(0,o.$ydb)({id:0,type:"full",data:U.data})}}class Ce{static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}constructor(U,j,G,Q,ne){this.f=U,this.g=j,this.h=G,this.j=Q,this.k=ne,this.d=new g.$loc("CompletionItem"),this.e=new Map}async provideCompletionItems(U,j,G,Q){const ne=this.f.getDocument(U),de=i.Position.to(j),Ie=ne.getWordRangeAtPosition(de)||new r.$wN(de,de),je=Ie.with({end:de}),Ke=new a.$de,_e=await this.h.provideCompletionItems(ne,de,Q,i.CompletionContext.to(G));if(!_e||Q.isCancellationRequested)return;const tt=Array.isArray(_e)?new r.$4N(_e):_e,nt=Ce.supportsResolving(this.h)?this.d.add(tt.items):this.d.add([]),et=new T.$Sc;this.e.set(nt,et);const rt=[],ft={x:nt,[u.ISuggestResultDtoField.completions]:rt,[u.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(Ie),insert:i.Range.from(je)},[u.ISuggestResultDtoField.isIncomplete]:tt.isIncomplete||void 0,[u.ISuggestResultDtoField.duration]:Ke.elapsed()};for(let ct=0;ct<tt.items.length;ct++){const st=tt.items[ct],lt=this.l(st,[nt,ct],je,Ie);rt.push(lt)}return ft}async resolveCompletionItem(U,j){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...U);if(!G)return;const Q=this.l(G,U),ne=await this.h.resolveCompletionItem(G,j);if(!ne)return;const de=this.l(ne,U);return(Q[u.ISuggestDataDtoField.insertText]!==de[u.ISuggestDataDtoField.insertText]||Q[u.ISuggestDataDtoField.insertTextRules]!==de[u.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Q[u.ISuggestDataDtoField.commandIdent]!==de[u.ISuggestDataDtoField.commandIdent]||Q[u.ISuggestDataDtoField.commandId]!==de[u.ISuggestDataDtoField.commandId]||!(0,$.$eo)(Q[u.ISuggestDataDtoField.commandArguments],de[u.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Q,[u.ISuggestDataDtoField.documentation]:de[u.ISuggestDataDtoField.documentation],[u.ISuggestDataDtoField.detail]:de[u.ISuggestDataDtoField.detail],[u.ISuggestDataDtoField.additionalTextEdits]:de[u.ISuggestDataDtoField.additionalTextEdits],[u.ISuggestDataDtoField.insertText]:de[u.ISuggestDataDtoField.insertText],[u.ISuggestDataDtoField.insertTextRules]:de[u.ISuggestDataDtoField.insertTextRules],[u.ISuggestDataDtoField.commandIdent]:de[u.ISuggestDataDtoField.commandIdent],[u.ISuggestDataDtoField.commandId]:de[u.ISuggestDataDtoField.commandId],[u.ISuggestDataDtoField.commandArguments]:de[u.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,j,G,Q){const ne=this.e.get(j[0]);if(!ne)throw Error("DisposableStore is missing...");const de=this.g.toInternal(U.command,ne),Ie={x:j,[u.ISuggestDataDtoField.label]:U.label,[u.ISuggestDataDtoField.kind]:U.kind!==void 0?i.CompletionItemKind.from(U.kind):void 0,[u.ISuggestDataDtoField.kindModifier]:U.tags&&U.tags.map(i.CompletionItemTag.from),[u.ISuggestDataDtoField.detail]:U.detail,[u.ISuggestDataDtoField.documentation]:typeof U.documentation>"u"?void 0:i.MarkdownString.fromStrict(U.documentation),[u.ISuggestDataDtoField.sortText]:U.sortText!==U.label?U.sortText:void 0,[u.ISuggestDataDtoField.filterText]:U.filterText!==U.label?U.filterText:void 0,[u.ISuggestDataDtoField.preselect]:U.preselect||void 0,[u.ISuggestDataDtoField.insertTextRules]:U.keepWhitespace?n.CompletionItemInsertTextRule.KeepWhitespace:n.CompletionItemInsertTextRule.None,[u.ISuggestDataDtoField.commitCharacters]:U.commitCharacters?.join(""),[u.ISuggestDataDtoField.additionalTextEdits]:U.additionalTextEdits&&U.additionalTextEdits.map(i.TextEdit.from),[u.ISuggestDataDtoField.commandIdent]:de?.$ident,[u.ISuggestDataDtoField.commandId]:de?.id,[u.ISuggestDataDtoField.commandArguments]:de?.$ident?void 0:de?.arguments};U.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ie[u.ISuggestDataDtoField.insertText]=U.textEdit.newText):typeof U.insertText=="string"?Ie[u.ISuggestDataDtoField.insertText]=U.insertText:U.insertText instanceof r.$FN&&(Ie[u.ISuggestDataDtoField.insertText]=U.insertText.value,Ie[u.ISuggestDataDtoField.insertTextRules]|=n.CompletionItemInsertTextRule.InsertAsSnippet);let je;return U.textEdit?je=U.textEdit.range:U.range&&(je=U.range),r.$wN.isRange(je)?Ie[u.ISuggestDataDtoField.range]=i.Range.from(je):je&&(!G?.isEqual(je.inserting)||!Q?.isEqual(je.replacing))&&(Ie[u.ISuggestDataDtoField.range]={insert:i.Range.from(je.inserting),replace:i.Range.from(je.replacing)}),Ie}}class Fe{async provideInlineCompletions(U,j,G,Q){}async provideInlineEdits(U,j,G,Q){}disposeCompletions(U){}handleDidShowCompletionItem(U,j,G){}handlePartialAccept(U,j,G,Q){}}class X extends Fe{constructor(U,j,G,Q){super(),this.f=U,this.g=j,this.h=G,this.j=Q,this.d=new te,this.e=(0,t.$4G)(this.f,"inlineCompletionsAdditions"),this.k={[n.InlineCompletionTriggerKind.Automatic]:r.InlineCompletionTriggerKind.Automatic,[n.InlineCompletionTriggerKind.Explicit]:r.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$4G)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(U,j,G,Q){const ne=this.g.getDocument(U),de=i.Position.to(j),Ie=await this.h.provideInlineCompletionItems(ne,de,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:i.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},Q);if(!Ie||Q.isCancellationRequested)return;const je=Array.isArray(Ie)?Ie:Ie.items,Ke=this.e?Array.isArray(Ie)?[]:Ie.commands||[]:[],_e=this.e&&!Array.isArray(Ie)?Ie.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:je}),items:je.map((et,rt)=>{let ft;et.command&&(tt||(tt=new T.$Sc),ft=this.j.toInternal(et.command,tt));const ct=et.insertText;return{insertText:typeof ct=="string"?ct:{snippet:ct.value},filterText:et.filterText,range:et.range?i.Range.from(et.range):void 0,command:ft,idx:rt,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:Ke.map(et=>(tt||(tt=new T.$Sc),this.j.toInternal(et,tt))),suppressSuggestions:!1,enableForwardStability:_e}}async provideInlineEdits(U,j,G,Q){if(!this.h.provideInlineEdits)return;(0,t.$5G)(this.f,"inlineCompletionsAdditions");const ne=this.g.getDocument(U),de=i.Range.to(j),Ie=await this.h.provideInlineEdits(ne,de,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:i.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind],userPrompt:G.userPrompt},Q);if(!Ie||Q.isCancellationRequested)return;const je=Array.isArray(Ie)?Ie:Ie.items,Ke=this.e?Array.isArray(Ie)?[]:Ie.commands||[]:[],_e=this.e&&!Array.isArray(Ie)?Ie.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:je}),items:je.map((et,rt)=>{let ft;et.command&&(tt||(tt=new T.$Sc),ft=this.j.toInternal(et.command,tt));const ct=et.insertText;return{insertText:typeof ct=="string"?ct:{snippet:ct.value},filterText:et.filterText,range:et.range?i.Range.from(et.range):void 0,command:ft,idx:rt,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:Ke.map(et=>(tt||(tt=new T.$Sc),this.j.toInternal(et,tt))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(U){this.d.disposeReferenceId(U)?.dispose()}handleDidShowCompletionItem(U,j,G){const Q=this.d.get(U)?.items[j];Q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Q,G)}handlePartialAccept(U,j,G,Q){const ne=this.d.get(U)?.items[j];ne&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ne,G),this.h.handleDidPartiallyAcceptCompletionItem(ne,i.PartialAcceptInfo.to(Q)))}}class V{async provideInlineEdits(U,j,G){const Q=this.f.getDocument(U),ne=await this.g.provideInlineEdit(Q,{triggerKind:this.e[j.triggerKind]},G);if(!ne||G.isCancellationRequested)return;let de;const Ie=this.d.createReferenceId({dispose(){de?.dispose()},item:ne});let je;ne.accepted&&(de||(de=new T.$Sc),je=this.h.toInternal(ne.accepted,de));let Ke;return ne.rejected&&(de||(de=new T.$Sc),Ke=this.h.toInternal(ne.rejected,de)),{pid:Ie,text:ne.text,range:i.Range.from(ne.range),accepted:je,rejected:Ke}}disposeEdit(U){this.d.disposeReferenceId(U)?.dispose()}constructor(U,j,G,Q){this.f=j,this.g=G,this.h=Q,this.d=new te,this.e={[n.InlineEditTriggerKind.Automatic]:r.InlineEditTriggerKind.Automatic,[n.InlineEditTriggerKind.Invoke]:r.InlineEditTriggerKind.Invoke}}}class te{constructor(){this.d=new Map,this.e=1}createReferenceId(U){const j=this.e++;return this.d.set(j,U),j}disposeReferenceId(U){const j=this.d.get(U);return this.d.delete(U),j}get(U){return this.d.get(U)}}class ve{constructor(U,j){this.e=U,this.f=j,this.d=new g.$loc("SignatureHelp")}async provideSignatureHelp(U,j,G,Q){const ne=this.e.getDocument(U),de=i.Position.to(j),Ie=this.g(G),je=await this.f.provideSignatureHelp(ne,de,Q,Ie);if(je){const Ke=this.d.add([je]);return{...i.SignatureHelp.from(je),id:Ke}}}g(U){let j;if(U.activeSignatureHelp){const G=i.SignatureHelp.to(U.activeSignatureHelp),Q=this.d.get(U.activeSignatureHelp.id,0);Q?(j=Q,j.activeSignature=G.activeSignature,j.activeParameter=G.activeParameter):j=G}return{...U,activeSignatureHelp:j}}releaseSignatureHelp(U){this.d.delete(U)}}class ce{constructor(U,j,G,Q,ne){this.f=U,this.g=j,this.h=G,this.j=Q,this.k=ne,this.d=new g.$loc("InlayHints"),this.e=new Map}async provideInlayHints(U,j,G){const Q=this.f.getDocument(U),ne=i.Range.to(j),de=await this.h.provideInlayHints(Q,ne,G);if(!Array.isArray(de)||de.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(j)}`);return}if(G.isCancellationRequested)return;const Ie=this.d.add(de);this.e.set(Ie,new T.$Sc);const je={hints:[],cacheId:Ie};for(let Ke=0;Ke<de.length;Ke++)this.l(de[Ke],ne)&&je.hints.push(this.m(de[Ke],[Ie,Ke]));return this.j.trace(`[InlayHints] ${je.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(j)}`),je}async resolveInlayHint(U,j){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...U);if(!G)return;const Q=await this.h.resolveInlayHint(G,j);if(Q&&this.l(Q))return this.m(Q,U)}releaseHints(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,j){return U.label.length===0||Array.isArray(U.label)&&U.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",U),!1):!(j&&!j.contains(U.position))}m(U,j){const G=this.e.get(j[0]);if(!G)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:j,tooltip:i.MarkdownString.fromStrict(U.tooltip),position:i.Position.from(U.position),textEdits:U.textEdits&&U.textEdits.map(i.TextEdit.from),kind:U.kind&&i.InlayHintKind.from(U.kind),paddingLeft:U.paddingLeft,paddingRight:U.paddingRight};if(typeof U.label=="string")Q.label=U.label;else{const ne=[];Q.label=ne;for(const de of U.label){if(!de.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ie={label:de.value,tooltip:i.MarkdownString.fromStrict(de.tooltip)};r.$GN.isLocation(de.location)&&(Ie.location=i.location.from(de.location)),de.command&&(Ie.command=this.g.toInternal(de.command,G)),ne.push(Ie)}}return Q}}class be{constructor(U,j){this.e=U,this.f=j,this.d=new g.$loc("DocumentLink")}async provideLinks(U,j){const G=this.e.getDocument(U),Q=await this.f.provideDocumentLinks(G,j);if(!(!Array.isArray(Q)||Q.length===0)&&!j.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Q.filter(be.g).map(i.DocumentLink.from)};{const ne=this.d.add(Q),de={links:[],cacheId:ne};for(let Ie=0;Ie<Q.length;Ie++){if(!be.g(Q[Ie]))continue;const je=i.DocumentLink.from(Q[Ie]);je.cacheId=[ne,Ie],de.links.push(je)}return de}}}static g(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,j){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...U);if(!G)return;const Q=await this.f.resolveDocumentLink(G,j);if(!(!Q||!be.g(Q)))return i.DocumentLink.from(Q)}releaseLinks(U){this.d.delete(U)}}class he{constructor(U,j){this.d=U,this.e=j}async provideColors(U,j){const G=this.d.getDocument(U),Q=await this.e.provideDocumentColors(G,j);return Array.isArray(Q)?Q.map(de=>({color:i.Color.from(de.color),range:i.Range.from(de.range)})):[]}async provideColorPresentations(U,j,G){const Q=this.d.getDocument(U),ne=i.Range.to(j.range),de=i.Color.to(j.color),Ie=await this.e.provideColorPresentations(de,{document:Q,range:ne},G);if(Array.isArray(Ie))return Ie.map(i.ColorPresentation.from)}}class J{constructor(U,j){this.d=U,this.e=j}async provideFoldingRanges(U,j,G){const Q=this.d.getDocument(U),ne=await this.e.provideFoldingRanges(Q,j,G);if(Array.isArray(ne))return ne.map(i.FoldingRange.from)}}class x{constructor(U,j,G){this.d=U,this.e=j,this.f=G}async provideSelectionRanges(U,j,G){const Q=this.d.getDocument(U),ne=j.map(i.Position.to),de=await this.e.provideSelectionRanges(Q,ne,G);if(!(0,v.$Kb)(de))return[];if(de.length!==ne.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ie=[];for(let je=0;je<ne.length;je++){const Ke=[];Ie.push(Ke);let _e=ne[je],tt=de[je];for(;;){if(!tt.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Ke.push(i.SelectionRange.from(tt)),!tt.parent)break;_e=tt.range,tt=tt.parent}}return Ie}}class me{constructor(U,j){this.f=U,this.g=j,this.d=new A.$6P(""),this.e=new Map}async prepareSession(U,j,G){const Q=this.f.getDocument(U),ne=i.Position.to(j),de=await this.g.prepareCallHierarchy(Q,ne,G);if(!de)return;const Ie=this.d.nextId();return this.e.set(Ie,new Map),Array.isArray(de)?de.map(je=>this.h(Ie,je)):[this.h(Ie,de)]}async provideCallsTo(U,j,G){const Q=this.j(U,j);if(!Q)throw new Error("missing call hierarchy item");const ne=await this.g.provideCallHierarchyIncomingCalls(Q,G);if(ne)return ne.map(de=>({from:this.h(U,de.from),fromRanges:de.fromRanges.map(Ie=>i.Range.from(Ie))}))}async provideCallsFrom(U,j,G){const Q=this.j(U,j);if(!Q)throw new Error("missing call hierarchy item");const ne=await this.g.provideCallHierarchyOutgoingCalls(Q,G);if(ne)return ne.map(de=>({to:this.h(U,de.to),fromRanges:de.fromRanges.map(Ie=>i.Range.from(Ie))}))}releaseSession(U){this.e.delete(U)}h(U,j){const G=this.e.get(U),Q=i.CallHierarchyItem.from(j,U,G.size.toString(36));return G.set(Q._itemId,j),Q}j(U,j){return this.e.get(U)?.get(j)}}class pe{constructor(U,j){this.f=U,this.g=j,this.d=new A.$6P(""),this.e=new Map}async prepareSession(U,j,G){const Q=this.f.getDocument(U),ne=i.Position.to(j),de=await this.g.prepareTypeHierarchy(Q,ne,G);if(!de)return;const Ie=this.d.nextId();return this.e.set(Ie,new Map),Array.isArray(de)?de.map(je=>this.h(Ie,je)):[this.h(Ie,de)]}async provideSupertypes(U,j,G){const Q=this.j(U,j);if(!Q)throw new Error("missing type hierarchy item");const ne=await this.g.provideTypeHierarchySupertypes(Q,G);if(ne)return ne.map(de=>this.h(U,de))}async provideSubtypes(U,j,G){const Q=this.j(U,j);if(!Q)throw new Error("missing type hierarchy item");const ne=await this.g.provideTypeHierarchySubtypes(Q,G);if(ne)return ne.map(de=>this.h(U,de))}releaseSession(U){this.e.delete(U)}h(U,j){const G=this.e.get(U),Q=i.TypeHierarchyItem.from(j,U,G.size.toString(36));return G.set(Q._itemId,j),Q}j(U,j){return this.e.get(U)?.get(j)}}class Ae{constructor(U,j,G,Q,ne){this.e=U,this.f=j,this.g=G,this.h=Q,this.j=ne,this.d=new g.$loc("DocumentDropEdit")}async provideDocumentOnDropEdits(U,j,G,Q,ne){const de=this.f.getDocument(j),Ie=i.Position.to(G),je=i.DataTransfer.toDataTransfer(Q,async nt=>(await this.e.$resolveDocumentOnDropFileData(this.h,U,nt)).buffer),Ke=await this.g.provideDocumentDropEdits(de,Ie,je,ne);if(!Ke)return;const _e=(0,v.$1b)(Ke),tt=this.d.add(_e);return _e.map((nt,et)=>({_cacheId:[tt,et],title:nt.title??(0,s.localize)(10670,null,this.j.displayName||this.j.name),kind:nt.kind?.value,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolveDropEdit(U,j){const[G,Q]=U,ne=this.d.get(G,Q);if(!ne||!this.g.resolveDocumentDropEdit)return{};const de=await this.g.resolveDocumentDropEdit(ne,j)??ne;return{additionalEdit:de.additionalEdit?i.WorkspaceEdit.from(de.additionalEdit,void 0):void 0}}releaseDropEdits(U){this.d.delete(U)}}class ze{constructor(U,j){this.d=U,this.e=j}async provideMappedEdits(U,j,G,Q){const ne=c.URI.revive(U),de=this.d.getDocument(ne),Ie=G.documents.map(_e=>_e.map(tt=>({uri:c.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(nt=>i.Range.to(nt))}))),je={documents:Ie,selections:Ie[0]?.[0]?.ranges??[]},Ke=await this.e.provideMappedEdits(de,j,je,Q);return Ke?i.WorkspaceEdit.from(Ke):null}}class ke{constructor(U,j){this.adapter=U,this.extension=j}}class Pe{static{this.d=0}constructor(U,j,G,Q,ne,de,Ie,je){this.g=j,this.h=G,this.j=Q,this.k=ne,this.l=de,this.m=Ie,this.n=je,this.f=new Map,this.e=U.getProxy(u.$sN.MainThreadLanguageFeatures)}o(U,j){return i.DocumentSelector.from(U,this.g,j)}p(U){return new r.$uN(()=>{this.f.delete(U),this.e.$unregister(U)})}q(){return Pe.d++}async s(U,j,G,Q,ne,de=!1){const Ie=this.f.get(U);if(!Ie||!(Ie.adapter instanceof j))return Q;const je=Date.now();de||this.l.trace(`[${Ie.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Ke=G(Ie.adapter,Ie.extension);return Promise.resolve(Ke).catch(_e=>{(0,N.$3)(_e)||(this.l.error(`[${Ie.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Ie.extension.identifier,_e))}).finally(()=>{de||this.l.trace(`[${Ie.extension.identifier.value}] provider DONE after ${Date.now()-je}ms`)}),C.CancellationToken.isCancellationToken(ne)?(0,I.$rh)(Ke,ne):Ke}t(U,j){const G=this.q();return this.f.set(G,new ke(U,j)),G}static u(U){return U.displayName||U.name}static w(U){return U.identifier.value}registerDocumentSymbolProvider(U,j,G,Q){const ne=this.t(new p(this.h,G),U),de=Q&&Q.label||Pe.u(U);return this.e.$registerDocumentSymbolProvider(ne,this.o(j,U),de),this.p(ne)}$provideDocumentSymbols(U,j,G){return this.s(U,p,Q=>Q.provideDocumentSymbols(c.URI.revive(j),G),void 0,G)}registerCodeLensProvider(U,j,G){const Q=this.q(),ne=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Q,new ke(new m(this.h,this.j.converter,G,U,this.n,this.l),U)),this.e.$registerCodeLensSupport(Q,this.o(j,U),ne);let de=this.p(Q);if(ne!==void 0){const Ie=G.onDidChangeCodeLenses(je=>this.e.$emitCodeLensEvent(ne));de=r.$uN.from(de,Ie)}return de}$provideCodeLenses(U,j,G){return this.s(U,m,Q=>Q.provideCodeLenses(c.URI.revive(j),G),void 0,G)}$resolveCodeLens(U,j,G){return this.s(U,m,Q=>Q.resolveCodeLens(j,G),void 0,void 0)}$releaseCodeLenses(U,j){this.s(U,m,G=>Promise.resolve(G.releaseCodeLenses(j)),void 0,void 0)}registerDefinitionProvider(U,j,G){const Q=this.t(new E(this.h,G),U);return this.e.$registerDefinitionSupport(Q,this.o(j,U)),this.p(Q)}$provideDefinition(U,j,G,Q){return this.s(U,E,ne=>ne.provideDefinition(c.URI.revive(j),G,Q),[],Q)}registerDeclarationProvider(U,j,G){const Q=this.t(new D(this.h,G),U);return this.e.$registerDeclarationSupport(Q,this.o(j,U)),this.p(Q)}$provideDeclaration(U,j,G,Q){return this.s(U,D,ne=>ne.provideDeclaration(c.URI.revive(j),G,Q),[],Q)}registerImplementationProvider(U,j,G){const Q=this.t(new w(this.h,G),U);return this.e.$registerImplementationSupport(Q,this.o(j,U)),this.p(Q)}$provideImplementation(U,j,G,Q){return this.s(U,w,ne=>ne.provideImplementation(c.URI.revive(j),G,Q),[],Q)}registerTypeDefinitionProvider(U,j,G){const Q=this.t(new k(this.h,G),U);return this.e.$registerTypeDefinitionSupport(Q,this.o(j,U)),this.p(Q)}$provideTypeDefinition(U,j,G,Q){return this.s(U,k,ne=>ne.provideTypeDefinition(c.URI.revive(j),G,Q),[],Q)}registerHoverProvider(U,j,G,Q){const ne=this.t(new P(this.h,G),U);return this.e.$registerHoverProvider(ne,this.o(j,U)),this.p(ne)}$provideHover(U,j,G,Q,ne){return this.s(U,P,de=>de.provideHover(c.URI.revive(j),G,Q,ne),void 0,ne)}$releaseHover(U,j){this.s(U,P,G=>Promise.resolve(G.releaseHover(j)),void 0,void 0)}registerEvaluatableExpressionProvider(U,j,G,Q){const ne=this.t(new h(this.h,G),U);return this.e.$registerEvaluatableExpressionProvider(ne,this.o(j,U)),this.p(ne)}$provideEvaluatableExpression(U,j,G,Q){return this.s(U,h,ne=>ne.provideEvaluatableExpression(c.URI.revive(j),G,Q),void 0,Q)}registerInlineValuesProvider(U,j,G,Q){const ne=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,de=this.t(new b(this.h,G),U);this.e.$registerInlineValuesProvider(de,this.o(j,U),ne);let Ie=this.p(de);if(ne!==void 0){const je=G.onDidChangeInlineValues(Ke=>this.e.$emitInlineValuesEvent(ne));Ie=r.$uN.from(Ie,je)}return Ie}$provideInlineValues(U,j,G,Q,ne){return this.s(U,b,de=>de.provideInlineValues(c.URI.revive(j),G,Q,ne),void 0,ne)}registerDocumentHighlightProvider(U,j,G){const Q=this.t(new M(this.h,G),U);return this.e.$registerDocumentHighlightProvider(Q,this.o(j,U)),this.p(Q)}registerMultiDocumentHighlightProvider(U,j,G){const Q=this.t(new O(this.h,G),U);return this.e.$registerMultiDocumentHighlightProvider(Q,this.o(j,U)),this.p(Q)}$provideDocumentHighlights(U,j,G,Q){return this.s(U,M,ne=>ne.provideDocumentHighlights(c.URI.revive(j),G,Q),void 0,Q)}$provideMultiDocumentHighlights(U,j,G,Q,ne){return this.s(U,O,de=>de.provideMultiDocumentHighlights(c.URI.revive(j),G,Q.map(Ie=>c.URI.revive(Ie)),ne),void 0,ne)}registerLinkedEditingRangeProvider(U,j,G){const Q=this.t(new F(this.h,G),U);return this.e.$registerLinkedEditingRangeProvider(Q,this.o(j,U)),this.p(Q)}$provideLinkedEditingRanges(U,j,G,Q){return this.s(U,F,async ne=>{const de=await ne.provideLinkedEditingRanges(c.URI.revive(j),G,Q);if(de)return{ranges:de.ranges,wordPattern:de.wordPattern?Pe.y(de.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(U,j,G){const Q=this.t(new q(this.h,G),U);return this.e.$registerReferenceSupport(Q,this.o(j,U)),this.p(Q)}$provideReferences(U,j,G,Q,ne){return this.s(U,q,de=>de.provideReferences(c.URI.revive(j),G,Q,ne),void 0,ne)}registerCodeActionProvider(U,j,G,Q){const ne=new T.$Sc,de=this.t(new B(this.h,this.j.converter,this.k,G,this.l,U,this.m),U);return this.e.$registerCodeActionSupport(de,this.o(j,U),{providedKinds:Q?.providedCodeActionKinds?.map(Ie=>Ie.value),documentation:Q?.documentation?.map(Ie=>({kind:Ie.kind.value,command:this.j.converter.toInternal(Ie.command,ne)}))},Pe.u(U),Pe.w(U),!!G.resolveCodeAction),ne.add(this.p(de)),ne}$provideCodeActions(U,j,G,Q,ne){return this.s(U,B,de=>de.provideCodeActions(c.URI.revive(j),G,Q,ne),void 0,ne)}$resolveCodeAction(U,j,G){return this.s(U,B,Q=>Q.resolveCodeAction(j,G),{},void 0)}$releaseCodeActions(U,j){this.s(U,B,G=>Promise.resolve(G.releaseCodeActions(j)),void 0,void 0)}registerDocumentFormattingEditProvider(U,j,G){const Q=this.t(new Y(this.h,G),U);return this.e.$registerDocumentFormattingSupport(Q,this.o(j,U),U.identifier,U.displayName||U.name),this.p(Q)}$provideDocumentFormattingEdits(U,j,G,Q){return this.s(U,Y,ne=>ne.provideDocumentFormattingEdits(c.URI.revive(j),G,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(U,j,G){const Q=typeof G.provideDocumentRangesFormattingEdits=="function",ne=this.t(new Z(this.h,G),U);return this.e.$registerRangeFormattingSupport(ne,this.o(j,U),U.identifier,U.displayName||U.name,Q),this.p(ne)}$provideDocumentRangeFormattingEdits(U,j,G,Q,ne){return this.s(U,Z,de=>de.provideDocumentRangeFormattingEdits(c.URI.revive(j),G,Q,ne),void 0,ne)}$provideDocumentRangesFormattingEdits(U,j,G,Q,ne){return this.s(U,Z,de=>de.provideDocumentRangesFormattingEdits(c.URI.revive(j),G,Q,ne),void 0,ne)}registerOnTypeFormattingEditProvider(U,j,G,Q){const ne=this.t(new fe(this.h,G),U);return this.e.$registerOnTypeFormattingSupport(ne,this.o(j,U),Q,U.identifier),this.p(ne)}$provideOnTypeFormattingEdits(U,j,G,Q,ne,de){return this.s(U,fe,Ie=>Ie.provideOnTypeFormattingEdits(c.URI.revive(j),G,Q,ne,de),void 0,de)}registerWorkspaceSymbolProvider(U,j){const G=this.t(new _(j,this.l),U);return this.e.$registerNavigateTypeSupport(G,typeof j.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(U,j,G){return this.s(U,_,Q=>Q.provideWorkspaceSymbols(j,G),{symbols:[]},G)}$resolveWorkspaceSymbol(U,j,G){return this.s(U,_,Q=>Q.resolveWorkspaceSymbol(j,G),void 0,void 0)}$releaseWorkspaceSymbols(U,j){this.s(U,_,G=>G.releaseWorkspaceSymbols(j),void 0,void 0)}registerRenameProvider(U,j,G){const Q=this.t(new ge(this.h,G,this.l),U);return this.e.$registerRenameSupport(Q,this.o(j,U),ge.supportsResolving(G)),this.p(Q)}$provideRenameEdits(U,j,G,Q,ne){return this.s(U,ge,de=>de.provideRenameEdits(c.URI.revive(j),G,Q,ne),void 0,ne)}$resolveRenameLocation(U,j,G,Q){return this.s(U,ge,ne=>ne.resolveRenameLocation(c.URI.revive(j),G,Q),void 0,Q)}registerNewSymbolNamesProvider(U,j,G){const Q=this.t(new se(this.h,G,this.l),U);return this.e.$registerNewSymbolNamesProvider(Q,this.o(j,U)),this.p(Q)}$supportsAutomaticNewSymbolNamesTriggerKind(U){return this.s(U,se,j=>j.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(U,j,G,Q,ne){return this.s(U,se,de=>de.provideNewSymbolNames(c.URI.revive(j),G,Q,ne),void 0,ne)}registerDocumentSemanticTokensProvider(U,j,G,Q){const ne=this.t(new $e(this.h,G),U),de=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ne,this.o(j,U),Q,de);let Ie=this.p(ne);if(de){const je=G.onDidChangeSemanticTokens(Ke=>this.e.$emitDocumentSemanticTokensEvent(de));Ie=r.$uN.from(Ie,je)}return Ie}$provideDocumentSemanticTokens(U,j,G,Q){return this.s(U,$e,ne=>ne.provideDocumentSemanticTokens(c.URI.revive(j),G,Q),null,Q)}$releaseDocumentSemanticTokens(U,j){this.s(U,$e,G=>G.releaseDocumentSemanticColoring(j),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(U,j,G,Q){const ne=this.t(new oe(this.h,G),U);return this.e.$registerDocumentRangeSemanticTokensProvider(ne,this.o(j,U),Q),this.p(ne)}$provideDocumentRangeSemanticTokens(U,j,G,Q){return this.s(U,oe,ne=>ne.provideDocumentRangeSemanticTokens(c.URI.revive(j),G,Q),null,Q)}registerCompletionItemProvider(U,j,G,Q){const ne=this.t(new Ce(this.h,this.j.converter,G,this.m,U),U);return this.e.$registerCompletionsProvider(ne,this.o(j,U),Q,Ce.supportsResolving(G),U.identifier),this.p(ne)}$provideCompletionItems(U,j,G,Q,ne){return this.s(U,Ce,de=>de.provideCompletionItems(c.URI.revive(j),G,Q,ne),void 0,ne)}$resolveCompletionItem(U,j,G){return this.s(U,Ce,Q=>Q.resolveCompletionItem(j,G),void 0,G)}$releaseCompletionItems(U,j){this.s(U,Ce,G=>G.releaseCompletionItems(j),void 0,void 0)}registerInlineCompletionsProvider(U,j,G,Q){const ne=new X(U,this.h,G,this.j.converter),de=this.t(ne,U);return this.e.$registerInlineCompletionsSupport(de,this.o(j,U),ne.supportsHandleEvents,l.$nn.toKey(U.identifier.value),Q?.yieldTo?.map(Ie=>l.$nn.toKey(Ie))||[]),this.p(de)}$provideInlineCompletions(U,j,G,Q,ne){return this.s(U,Fe,de=>de.provideInlineCompletions(c.URI.revive(j),G,Q,ne),void 0,ne)}$provideInlineEdits(U,j,G,Q,ne){return this.s(U,Fe,de=>de.provideInlineEdits(c.URI.revive(j),G,Q,ne),void 0,ne)}$handleInlineCompletionDidShow(U,j,G,Q){this.s(U,Fe,async ne=>{ne.handleDidShowCompletionItem(j,G,Q)},void 0,void 0)}$handleInlineCompletionPartialAccept(U,j,G,Q,ne){this.s(U,Fe,async de=>{de.handlePartialAccept(j,G,Q,ne)},void 0,void 0)}$freeInlineCompletionsList(U,j){this.s(U,Fe,async G=>{G.disposeCompletions(j)},void 0,void 0)}registerInlineEditProvider(U,j,G){const Q=new V(U,this.h,G,this.j.converter),ne=this.t(Q,U);return this.e.$registerInlineEditProvider(ne,this.o(j,U),U.identifier),this.p(ne)}$provideInlineEdit(U,j,G,Q){return this.s(U,V,ne=>ne.provideInlineEdits(c.URI.revive(j),G,Q),void 0,Q)}$freeInlineEdit(U,j){this.s(U,V,async G=>{G.disposeEdit(j)},void 0,void 0)}registerSignatureHelpProvider(U,j,G,Q){const ne=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,de=this.t(new ve(this.h,G),U);return this.e.$registerSignatureHelpProvider(de,this.o(j,U),ne),this.p(de)}$provideSignatureHelp(U,j,G,Q,ne){return this.s(U,ve,de=>de.provideSignatureHelp(c.URI.revive(j),G,Q,ne),void 0,ne)}$releaseSignatureHelp(U,j){this.s(U,ve,G=>G.releaseSignatureHelp(j),void 0,void 0)}registerInlayHintsProvider(U,j,G){const Q=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,ne=this.t(new ce(this.h,this.j.converter,G,this.l,U),U);this.e.$registerInlayHintsProvider(ne,this.o(j,U),typeof G.resolveInlayHint=="function",Q,Pe.u(U));let de=this.p(ne);if(Q!==void 0){const Ie=G.onDidChangeInlayHints(je=>this.e.$emitInlayHintsEvent(Q));de=r.$uN.from(de,Ie)}return de}$provideInlayHints(U,j,G,Q){return this.s(U,ce,ne=>ne.provideInlayHints(c.URI.revive(j),G,Q),void 0,Q)}$resolveInlayHint(U,j,G){return this.s(U,ce,Q=>Q.resolveInlayHint(j,G),void 0,G)}$releaseInlayHints(U,j){this.s(U,ce,G=>G.releaseHints(j),void 0,void 0)}registerDocumentLinkProvider(U,j,G){const Q=this.t(new be(this.h,G),U);return this.e.$registerDocumentLinkProvider(Q,this.o(j,U),typeof G.resolveDocumentLink=="function"),this.p(Q)}$provideDocumentLinks(U,j,G){return this.s(U,be,Q=>Q.provideLinks(c.URI.revive(j),G),void 0,G,j.scheme==="output")}$resolveDocumentLink(U,j,G){return this.s(U,be,Q=>Q.resolveLink(j,G),void 0,void 0,!0)}$releaseDocumentLinks(U,j){this.s(U,be,G=>G.releaseLinks(j),void 0,void 0,!0)}registerColorProvider(U,j,G){const Q=this.t(new he(this.h,G),U);return this.e.$registerDocumentColorProvider(Q,this.o(j,U)),this.p(Q)}$provideDocumentColors(U,j,G){return this.s(U,he,Q=>Q.provideColors(c.URI.revive(j),G),[],G)}$provideColorPresentations(U,j,G,Q){return this.s(U,he,ne=>ne.provideColorPresentations(c.URI.revive(j),G,Q),void 0,Q)}registerFoldingRangeProvider(U,j,G){const Q=this.q(),ne=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Q,new ke(new J(this.h,G),U)),this.e.$registerFoldingRangeProvider(Q,this.o(j,U),U.identifier,ne);let de=this.p(Q);if(ne!==void 0){const Ie=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ne));de=r.$uN.from(de,Ie)}return de}$provideFoldingRanges(U,j,G,Q){return this.s(U,J,ne=>ne.provideFoldingRanges(c.URI.revive(j),G,Q),void 0,Q)}registerSelectionRangeProvider(U,j,G){const Q=this.t(new x(this.h,G,this.l),U);return this.e.$registerSelectionRangeProvider(Q,this.o(j,U)),this.p(Q)}$provideSelectionRanges(U,j,G,Q){return this.s(U,x,ne=>ne.provideSelectionRanges(c.URI.revive(j),G,Q),[],Q)}registerCallHierarchyProvider(U,j,G){const Q=this.t(new me(this.h,G),U);return this.e.$registerCallHierarchyProvider(Q,this.o(j,U)),this.p(Q)}$prepareCallHierarchy(U,j,G,Q){return this.s(U,me,ne=>Promise.resolve(ne.prepareSession(c.URI.revive(j),G,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(U,j,G,Q){return this.s(U,me,ne=>ne.provideCallsTo(j,G,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(U,j,G,Q){return this.s(U,me,ne=>ne.provideCallsFrom(j,G,Q),void 0,Q)}$releaseCallHierarchy(U,j){this.s(U,me,G=>Promise.resolve(G.releaseSession(j)),void 0,void 0)}registerTypeHierarchyProvider(U,j,G){const Q=this.t(new pe(this.h,G),U);return this.e.$registerTypeHierarchyProvider(Q,this.o(j,U)),this.p(Q)}$prepareTypeHierarchy(U,j,G,Q){return this.s(U,pe,ne=>Promise.resolve(ne.prepareSession(c.URI.revive(j),G,Q)),void 0,Q)}$provideTypeHierarchySupertypes(U,j,G,Q){return this.s(U,pe,ne=>ne.provideSupertypes(j,G,Q),void 0,Q)}$provideTypeHierarchySubtypes(U,j,G,Q){return this.s(U,pe,ne=>ne.provideSubtypes(j,G,Q),void 0,Q)}$releaseTypeHierarchy(U,j){this.s(U,pe,G=>Promise.resolve(G.releaseSession(j)),void 0,void 0)}registerDocumentOnDropEditProvider(U,j,G,Q){const ne=this.q();return this.f.set(ne,new ke(new Ae(this.e,this.h,G,ne,U),U)),this.e.$registerDocumentOnDropEditProvider(ne,this.o(j,U),(0,t.$4G)(U,"documentPaste")&&Q?{supportsResolve:!!G.resolveDocumentDropEdit,dropMimeTypes:Q.dropMimeTypes}:void 0),this.p(ne)}$provideDocumentOnDropEdits(U,j,G,Q,ne,de){return this.s(U,Ae,Ie=>Promise.resolve(Ie.provideDocumentOnDropEdits(j,c.URI.revive(G),Q,ne,de)),void 0,void 0)}$resolveDropEdit(U,j,G){return this.s(U,Ae,Q=>Q.resolveDropEdit(j,G),{},void 0)}$releaseDocumentOnDropEdits(U,j){this.s(U,Ae,G=>Promise.resolve(G.releaseDropEdits(j)),void 0,void 0)}registerMappedEditsProvider(U,j,G){const Q=this.t(new ze(this.h,G),U);return this.e.$registerMappedEditsProvider(Q,this.o(j,U)),this.p(Q)}$provideMappedEdits(U,j,G,Q,ne){return this.s(U,ze,de=>Promise.resolve(de.provideMappedEdits(j,G,Q,ne)),null,ne)}registerDocumentPasteEditProvider(U,j,G,Q){const ne=this.q();return this.f.set(ne,new ke(new L(this.e,this.h,G,ne,U),U)),this.e.$registerPasteEditProvider(ne,this.o(j,U),{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,supportsResolve:!!G.resolveDocumentPasteEdit,providedPasteEditKinds:Q.providedPasteEditKinds?.map(de=>de.value),copyMimeTypes:Q.copyMimeTypes,pasteMimeTypes:Q.pasteMimeTypes}),this.p(ne)}$prepareDocumentPaste(U,j,G,Q,ne){return this.s(U,L,de=>de.prepareDocumentPaste(c.URI.revive(j),G,Q,ne),void 0,ne)}$providePasteEdits(U,j,G,Q,ne,de,Ie){return this.s(U,L,je=>je.providePasteEdits(j,c.URI.revive(G),Q,ne,de,Ie),void 0,Ie)}$resolvePasteEdit(U,j,G){return this.s(U,L,Q=>Q.resolvePasteEdit(j,G),{},void 0)}$releasePasteEdits(U,j){this.s(U,L,G=>Promise.resolve(G.releasePasteEdits(j)),void 0,void 0)}static y(U){return{pattern:U.source,flags:U.flags}}static z(U){return{decreaseIndentPattern:Pe.y(U.decreaseIndentPattern),increaseIndentPattern:Pe.y(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?Pe.y(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?Pe.y(U.unIndentedLinePattern):void 0}}static B(U){return{beforeText:Pe.y(U.beforeText),afterText:U.afterText?Pe.y(U.afterText):void 0,previousLineText:U.previousLineText?Pe.y(U.previousLineText):void 0,action:U.action}}static C(U){return U.map(Pe.B)}static D(U){return{open:U.open,close:U.close,notIn:U.notIn?U.notIn.map(j=>r.SyntaxTokenType.toString(j)):void 0}}static E(U){return U.map(Pe.D)}setLanguageConfiguration(U,j,G){const{wordPattern:Q}=G;if(Q&&(0,R.$pf)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this.h.setWordDefinitionFor(j,Q):this.h.setWordDefinitionFor(j,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const ne=this.q(),de={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?Pe.y(G.wordPattern):void 0,indentationRules:G.indentationRules?Pe.z(G.indentationRules):void 0,onEnterRules:G.onEnterRules?Pe.C(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?Pe.E(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ne,j,de),this.p(ne)}$setWordDefinitions(U){for(const j of U)this.h.setWordDefinitionFor(j.languageId,new RegExp(j.regexSource,j.regexFlags))}}e.$voc=Pe}),define(Ne[243],Oe([1,0,4,5,8]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zpc=void 0,C=Ve(C);class N{constructor(T){this.a=new Map,this.c=new Map,this.b=T.getProxy(I.$sN.MainThreadLanguageModelTools),this.b.$getTools().then($=>{for(const a of $)this.c.set(a.name,a)})}async invokeTool(T,$,a){return await this.b.$invokeTool(T,$,a)}async $acceptToolDelta(T){T.added&&this.c.set(T.added.name,T.added),T.removed&&this.c.delete(T.removed)}get tools(){return Array.from(this.c.values()).map(T=>C.LanguageModelToolDescription.to(T))}async $invokeTool(T,$,a){const R=this.a.get(T);if(!R)throw new Error(`Unknown tool ${T}`);return await R.tool.invoke($,a)}registerTool(T,$,a){return this.a.set($,{extension:T,tool:a}),this.b.$registerTool($),(0,v.$Rc)(()=>{this.a.delete($),this.b.$unregisterTool($)})}}e.$Zpc=N}),define(Ne[94],Oe([1,0,10,21,42,13,6,39,4,9,18,3,11,76,5,90,16,8,7,117,24]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S,f,n,o,s,l,i,r){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$dpc=e.$cpc=void 0,s=Ve(s),l=Ve(l),e.$cpc=(0,y.$Ci)("IExtHostLanguageModels");class g{constructor(d,E){this.option=d,this.stream=new v.$6h,this.stream=E??new v.$6h}}class u{constructor(){this.a=new Map,this.b=new v.$6h,this.c=!1;const d=this;this.apiObject={get stream(){return d.b.asyncIterable},get text(){return v.$3h.map(d.b.asyncIterable,E=>{if(E instanceof l.$KP)return E.value}).coalesce()}}}*d(){if(this.a.size>0)for(const[,d]of this.a)yield d.stream;else yield this.b}handleFragment(d){if(this.c)return;let E=this.a.get(d.index);E||(this.a.size===0?E=new g(d.index,this.b):E=new g(d.index),this.a.set(d.index,E));let D;d.part.type==="text"?D=new l.$KP(d.part.value):D=new l.$JP(d.part.name,d.part.parameters),E.stream.emitOne(D)}reject(d){this.c=!0;for(const E of this.d())E.reject(d)}resolve(){this.c=!0;for(const d of this.d())d.resolve()}}let p=class{static{t=this}static{this.a=1}constructor(d,E,D){this.j=E,this.k=D,this.c=new A.$je,this.d=new A.$je,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new R.$pn,this.i=new Map,this.s=new Set,this.b=d.getProxy(f.$sN.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(d,E,D,w){const k=t.a++;this.f.set(k,{extension:d.identifier,provider:D,languageModelId:E});let P;w.auth&&(P={providerLabel:d.displayName||d.name,accountLabel:typeof w.auth=="object"?w.auth.label:void 0}),this.b.$registerLanguageModelProvider(k,`${R.$nn.toKey(d.identifier)}/${k}/${E}`,{extension:d.identifier,id:E,vendor:w.vendor??R.$nn.toKey(d.identifier),name:w.name??"",family:w.family??"",version:w.version,maxInputTokens:w.maxInputTokens,maxOutputTokens:w.maxOutputTokens,auth:P,targetExtensions:w.extensions});const h=D.onDidReceiveLanguageModelResponse2?.(({extensionId:b,participant:M,tokenCount:O})=>{this.b.$whenLanguageModelChatRequestMade(E,new R.$nn(b),M,O)});return(0,$.$Rc)(()=>{this.f.delete(k),this.b.$unregisterProvider(k),h?.dispose()})}async $startChatRequest(d,E,D,w,k,P){const h=this.f.get(d);if(!h)throw new Error("Provider not found");const b=new S.$uw(async O=>{if(P.isCancellationRequested){this.j.warn(`[CHAT](${h.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let F;if(O.part instanceof l.$JP?F={type:"function_use",name:O.part.name,parameters:O.part.parameters}:O.part instanceof l.$KP&&(F={type:"text",value:O.part.value}),!F){this.j.warn(`[CHAT](${h.extension.value}) UNKNOWN part ${JSON.stringify(O)}`);return}this.b.$reportResponsePart(E,{index:O.index,part:F})});let M;if(h.provider.provideLanguageModelResponse2)M=Promise.resolve(h.provider.provideLanguageModelResponse2(w.map(s.LanguageModelChatMessage.to),k,R.$nn.toKey(D),b,P));else{const O=new S.$uw(async F=>{b.report({index:F.index,part:new l.$KP(F.part)})});M=Promise.resolve(h.provider.provideLanguageModelResponse(w.map(s.LanguageModelChatMessage.to),k?.modelOptions??{},R.$nn.toKey(D),O,P))}M.then(()=>{this.b.$reportResponseDone(E,void 0)},O=>{this.b.$reportResponseDone(E,(0,N.$1)(O))})}$provideTokenLength(d,E,D){const w=this.f.get(d);return w?Promise.resolve(w.provider.provideTokenCount(E,D)):Promise.resolve(0)}$acceptChatModelMetadata(d){if(d.added)for(const{identifier:E,metadata:D}of d.added)this.g.set(E,{metadata:D,apiObjects:new R.$pn});if(d.removed)for(const E of d.removed){this.g.delete(E);for(const[D,w]of this.i)w.languageModelId===E&&(w.res.reject(new N.$4),this.i.delete(D))}d.added?.forEach(E=>this.q(E.metadata)),this.d.fire(void 0)}async selectLanguageModels(d,E){const D=await this.b.$selectChatModels({...E,extension:d.identifier}),w=[],k=this;for(const P of D){const h=this.g.get(P);if(!h)continue;this.o(d.identifier,h.metadata)&&await this.q(h.metadata);let b=h.apiObjects.get(d.identifier);b||(b={id:P,vendor:h.metadata.vendor,family:h.metadata.family,version:h.metadata.version,name:h.metadata.name,maxInputTokens:h.metadata.maxInputTokens,countTokens(M,O){if(!k.g.has(P))throw l.$OP.NotFound(P);return k.r(P,M,O??I.CancellationToken.None)},sendRequest(M,O,F){if(!k.g.has(P))throw l.$OP.NotFound(P);return k.l(d,P,M,O??{},F??I.CancellationToken.None)}},Object.freeze(b),h.apiObjects.set(d.identifier,b)),w.push(b)}return w}async l(d,E,D,w,k){const P=this.m(d,D),h=d.identifier,b=this.g.get(E)?.metadata;if(!b||!this.g.has(E))throw l.$OP.NotFound(`Language model '${E}' is unknown.`);if(this.o(h,b)&&(!await this.n(d,{identifier:b.extension,displayName:b.auth.providerLabel},w.justification,!1)||!this.h.get(h)?.has(b.extension)))throw l.$OP.NoPermissions(`Language model '${E}' cannot be used by '${h.value}'.`);try{const M=Math.random()*1e6|0,O=new u;this.i.set(M,{languageModelId:E,res:O});try{await this.b.$tryStartChatRequest(h,E,M,P,w,k)}catch(F){throw this.i.delete(M),F}return O.apiObject}catch(M){throw M.name===l.$OP.name?M:new l.$OP(`Language model '${E}' errored: ${(0,C.$nj)(M)}`,"Unknown",M)}}m(d,E){const D=[];for(const w of E)w.role===l.LanguageModelChatMessageRole.System&&(0,r.$5G)(d,"languageModelSystem"),w.content2 instanceof l.$HP&&(0,r.$5G)(d,"lmTools"),D.push(s.LanguageModelChatMessage.from(w));return D}async $acceptResponsePart(d,E){const D=this.i.get(d);D&&D.res.handleFragment(E)}async $acceptResponseDone(d,E){const D=this.i.get(d);D&&(this.i.delete(d),E?D.res.reject((0,N.$2)(E)):D.res.resolve())}async n(d,E,D,w){const k=i.$uM+E.identifier.value;if(await this.k.getSession(d,k,[],{silent:!0}))return this.$updateModelAccesslist([{from:d.identifier,to:E.identifier,enabled:!0}]),!0;if(w)return!1;try{const h=D?(0,a.localize)(10668,null,E.displayName,D):void 0;return await this.k.getSession(d,k,[],{forceNewSession:{detail:h}}),this.$updateModelAccesslist([{from:d.identifier,to:E.identifier,enabled:!0}]),!0}catch{return!1}}o(d,E){return!!E.auth&&!R.$nn.equals(E.extension,d)}async q(d){if(d.auth)for(const E of this.s)try{await this.n(E,{identifier:d.extension,displayName:""},void 0,!0)}catch(D){this.j.error("Fake Auth request failed"),this.j.error(D)}}async r(d,E,D){if(!this.g.get(d))throw l.$OP.NotFound(`Language model '${d}' is unknown.`);const k=T.Iterable.find(this.f.values(),P=>P.languageModelId===d);return k?k.provider.provideTokenCount(E,D):this.b.$countTokens(d,typeof E=="string"?E:s.LanguageModelChatMessage.from(E),D)}$updateModelAccesslist(d){const E=new Array;for(const{from:D,to:w,enabled:k}of d){const P=this.h.get(D)??new R.$on;if(P.has(w)!==k){k?P.add(w):P.delete(w),this.h.set(D,P);const b={from:D,to:w};E.push(b),this.c.fire(b)}}}createLanguageModelAccessInformation(d){this.s.add(d);const E=this,D=A.Event.signal(A.Event.filter(this.c.event,k=>R.$nn.equals(k.from,d.identifier))),w=A.Event.signal(this.d.event);return{get onDidChange(){return A.Event.any(D,w)},canSendRequest(k){let P;e:for(const[b,M]of E.g)for(const O of M.apiObjects.values())if(O===k){P=M.metadata;break e}if(!P)return;if(!E.o(d.identifier,P))return!0;const h=E.h.get(d.identifier);if(h)return h.has(P.extension)}}}};e.$dpc=p,e.$dpc=p=t=Qe([qe(0,o.$1P),qe(1,c.$9j),qe(2,n.$xoc)],p)});var _t=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Ne[244],Oe([1,0,5,8,7,35,10,4,24]),function(we,e,v,I,C,N,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1pc=void 0,I=Ve(I),N=_t(N);class a{constructor(y,c,S,f){this.c=c,this.d=S,this.e=f,this.b=[],this.f=0,this.g=new Set,this.a=y.getProxy(v.$sN.MainThreadLanguages)}$acceptLanguageIds(y){this.b=y}async getLanguages(){return this.b.slice(0)}async changeLanguage(y,c){await this.a.$changeLanguage(y,c);const S=this.c.getDocumentData(y);if(!S)throw new Error(`document '${y.toString()}' NOT found`);return S.document}async tokenAtPosition(y,c){const S=y.version,f=I.Position.from(c),n=await this.a.$tokensAtPosition(y.uri,f),o={type:C.StandardTokenType.Other,range:y.getWordRangeAtPosition(c)??new C.$wN(c.line,c.character,c.line,c.character)};if(!n)return o;const s={range:I.Range.to(n.range),type:I.TokenType.to(n.type)};return!s.range.contains(c)||S!==y.version?o:s}createLanguageStatusItem(y,c,S){const f=this.f++,n=this.a,o=this.g,s=`${y.identifier.value}/${c}`;if(o.has(s))throw new Error(`LanguageStatusItem with id '${c}' ALREADY exists`);o.add(s);const l={selector:S,id:c,name:y.displayName??y.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const r=new T.$Sc,t=()=>{if(i?.dispose(),!o.has(s)){console.warn(`LanguageStatusItem (${c}) from ${y.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,A.$Eh)(()=>{r.clear(),this.a.$setLanguageStatus(f,{id:s,name:l.name??y.displayName??y.name,source:y.displayName??y.name,selector:I.DocumentSelector.from(l.selector,this.e),label:l.text,detail:l.detail??"",severity:l.severity===C.LanguageStatusSeverity.Error?N.default.Error:l.severity===C.LanguageStatusSeverity.Warning?N.default.Warning:N.default.Info,command:l.command&&this.d.toInternal(l.command,r),accessibilityInfo:l.accessibilityInformation,busy:l.busy})},0)},g={dispose(){r.dispose(),i?.dispose(),n.$removeLanguageStatus(f),o.delete(s)},get id(){return l.id},get name(){return l.name},set name(u){l.name=u,t()},get selector(){return l.selector},set selector(u){l.selector=u,t()},get text(){return l.text},set text(u){l.text=u,t()},set text2(u){(0,$.$5G)(y,"languageStatusText"),l.text=u,t()},get text2(){return(0,$.$5G)(y,"languageStatusText"),l.text},get detail(){return l.detail},set detail(u){l.detail=u,t()},get severity(){return l.severity},set severity(u){l.severity=u,t()},get accessibilityInformation(){return l.accessibilityInformation},set accessibilityInformation(u){l.accessibilityInformation=u,t()},get command(){return l.command},set command(u){l.command=u,t()},get busy(){return l.busy},set busy(u){l.busy=u,t()}};return t(),g}}e.$1pc=a}),define(Ne[245],Oe([1,0,15,2,8,7,89]),function(we,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mpc=e.$Lpc=void 0,C=Ve(C),A=Ve(A);class T{constructor(y,c,S,f){this.start=y,this.deletedCount=c,this.deletedItems=S,this.items=f}asApiEvent(){return{range:new N.$WO(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(y){return{EOL:y.eol,lines:y.source,languageId:y.language,uri:y.uri,isDirty:!1,versionId:1}}constructor(y,c,S){this.notebook=y,this.h=c,this.j=S,this.handle=S.handle,this.uri=I.URI.revive(S.uri),this.cellKind=S.cellKind,this.a=S.outputs.map(C.NotebookCellOutput.to),this.e=S.internalMetadata??{},this.b=Object.freeze(S.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(S.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const y=this,c=this.h.getDocument(this.uri);if(!c)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const S={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:c.document,get mime(){return y.g},set mime(f){y.g=f},get outputs(){return y.a.slice(0)},get metadata(){return y.b},get executionSummary(){return y.d}};this.f=Object.freeze(S)}return this.f}setOutputs(y){this.a=y.map(C.NotebookCellOutput.to)}setOutputItems(y,c,S){const f=S.map(C.NotebookCellOutputItem.to),n=this.a.find(o=>o.id===y);if(n&&(c||(n.items.length=0),n.items.push(...f),n.items.length>1&&n.items.every(o=>A.$xL(o.mime)))){const o=new Map,s=[];n.items.forEach(l=>{let i;o.has(l.mime)?i=o.get(l.mime):(i=[],o.set(l.mime,i),s.push(l.mime)),i.push(l.data)}),n.items.length=0,s.forEach(l=>{const i=A.$yL(o.get(l));n.items.push({mime:l,data:i.data.buffer})})}}setMetadata(y){this.b=Object.freeze(y)}setInternalMetadata(y){this.e=y,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.$Lpc=$;class a{static{this.a=0}constructor(y,c,S,f,n){this.k=y,this.l=c,this.m=S,this.uri=f,this.handle=a.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=n.viewType,this.f=Object.freeze(n.metadata??Object.create(null)),this.r([[0,0,n.cells]],!0,void 0),this.g=n.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const y=this,c={get uri(){return y.uri},get version(){return y.g},get notebookType(){return y.d},get isDirty(){return y.h},get isUntitled(){return y.uri.scheme===v.Schemas.untitled},get isClosed(){return y.j},get metadata(){return y.f},get cellCount(){return y.b.length},cellAt(S){return S=y.n(S),y.b[S].apiCell},getCells(S){return(S?y.p(S):y.b).map(n=>n.apiCell)},save(){return y.q()}};this.e=Object.freeze(c)}return this.e}acceptDocumentPropertiesChanged(y){y.metadata&&(this.f=Object.freeze({...this.f,...y.metadata}))}acceptDirty(y){this.h=y}acceptModelChanged(y,c,S){this.g=y.versionId,this.h=c,this.acceptDocumentPropertiesChanged({metadata:S});const f={notebook:this.apiNotebook,metadata:S,cellChanges:[],contentChanges:[]},n=[];for(const s of y.rawEvents)s.kind===A.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,f.contentChanges):s.kind===A.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,f.contentChanges):s.kind===A.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),n.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===A.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),n.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),n.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===A.NotebookCellsChangeType.ChangeCellContent?n.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),n.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),n.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const o=new Map;for(let s=0;s<n.length;s++){const l=n[s],i=o.get(l.cell);if(i===void 0){const r=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...l});o.set(l.cell,r-1)}else f.cellChanges[i]={...f.cellChanges[i],...l}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}n(y){return y=y|0,y<0?0:y>=this.b.length?this.b.length-1:y}o(y){let c=y.start|0,S=y.end|0;return c<0&&(c=0),S>this.b.length&&(S=this.b.length),y.with({start:c,end:S})}p(y){y=this.o(y);const c=[];for(let S=y.start;S<y.end;S++)c.push(this.b[S]);return c}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(y,c,S){if(this.j)return;const f=[],n=[],o=[];if(y.reverse().forEach(s=>{const i=s[2].map(g=>{const u=new $(this,this.l,g);return c||n.push($.asModelAddData(g)),u}),r=new T(s[0],s[1],[],i),t=this.b.splice(s[0],s[1],...i);for(const g of t)o.push(g.uri),r.deletedItems.push(g.apiCell);f.push(r)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:n,removedDocuments:o}),S)for(const s of f)S.push(s.asApiEvent())}s(y,c,S,f){const n=this.b.splice(y,c);this.b.splice(S,0,...n);const o=[new T(y,c,n.map(s=>s.apiCell),[]),new T(S,0,[],n)];for(const s of o)f.push(s.asApiEvent())}t(y,c){this.b[y].setOutputs(c)}u(y,c,S,f){this.b[y].setOutputItems(c,S,f)}v(y,c){const S=this.b[y];S.apiCell.document.languageId!==c&&this.m.$acceptModelLanguageChanged(S.uri,c)}w(y,c){const S=this.b[y];S.apiCell.mime=c}x(y,c){this.b[y].setMetadata(c)}y(y,c){this.b[y].setInternalMetadata(c)}getCellFromApiCell(y){return this.b.find(c=>c.apiCell===y)}getCellFromIndex(y){return this.b[y]}getCell(y){return this.b.find(c=>c.handle===y)}getCellIndex(y){return this.b.indexOf(y)}}e.$Mpc=a}),define(Ne[246],Oe([1,0,6,2,8,7,38]),function(we,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3pc=void 0;class T{constructor(a,R,y,c={timeout:1500,errors:3}){this.b=a,this.c=R,this.d=y,this.f=c,this.a=new v.$le}dispose(){}getOnWillSaveNotebookDocumentEvent(a){return(R,y,c)=>{const S=function(n){R.call(y,n)};return S.extension=a,this.a.event(S,void 0,c)}}async $participateInSave(a,R,y){const c=I.URI.revive(a),S=this.c.getNotebookDocument(c);if(!S)throw new Error("Unable to resolve notebook document");const f=[];if(await this.a.fireAsync({notebook:S.apiNotebook,reason:C.TextDocumentSaveReason.to(R)},y,async(o,s)=>{const l=Date.now(),i=await await Promise.resolve(o);Date.now()-l>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier),!y.isCancellationRequested&&i&&(i instanceof N.$EN?f.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier,"ignored due to invalid data"))}),y.isCancellationRequested)return!1;if(f.length===0)return!0;const n={edits:[]};for(const o of f){const{edits:s}=C.WorkspaceEdit.from(o);n.edits=n.edits.concat(s)}return this.d.$tryApplyWorkspaceEdit(new A.$Sw(n))}}e.$3pc=T}),define(Ne[124],Oe([1,0,13,8,7]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Npc=void 0,I=Ve(I),C=Ve(C);class N{static{this.apiEditorsToExtHost=new WeakMap}constructor(T,$,a,R,y,c){this.id=T,this.f=$,this.notebookData=a,this.a=[],this.b=[],this.d=!1,this.a=y,this.b=R,this.c=c}get apiEditor(){if(!this.e){const T=this;this.e={get notebook(){return T.notebookData.apiNotebook},get selection(){return T.a[0]},set selection($){this.selections=[$]},get selections(){return T.a},set selections($){if(!Array.isArray($)||!$.every(C.$WO.isNotebookRange))throw(0,v.$6)("selections");T.a=$,T.g($)},get visibleRanges(){return T.b},revealRange($,a){T.f.$tryRevealRange(T.id,I.NotebookRange.from($),a??C.NotebookEditorRevealType.Default)},get viewColumn(){return T.c}},N.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(T){this.d=T}_acceptVisibleRanges(T){this.b=T}_acceptSelections(T){this.a=T}g(T){this.f.$trySetSelections(this.id,T.map(I.NotebookRange.from))}_acceptViewColumn(T){this.c=T}}e.$Npc=N}),define(Ne[247],Oe([1,0,6,11,8]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5pc=void 0,C=Ve(C);let N=class{constructor(T,$){this.c=T,this.d=$,this.a=new v.$je,this.b=new v.$je,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(T,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,$);const a=this.d.getEditorById(T);$.visibleRanges&&a._acceptVisibleRanges($.visibleRanges.ranges.map(C.NotebookRange.to)),$.selections&&a._acceptSelections($.selections.selections.map(C.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:a.apiEditor,visibleRanges:a.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:a.apiEditor,selections:a.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const $ in T)this.d.getEditorById($)._acceptViewColumn(C.ViewColumn.to(T[$]))}};e.$5pc=N,e.$5pc=N=Qe([qe(0,I.$9j)],N)}),define(Ne[248],Oe([1,0,6,5,124]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8pc=void 0;class N{constructor(T,$){this.c=$,this.a=new Map,this.b=T.getProxy(I.$sN.MainThreadNotebookRenderers)}$postRendererMessage(T,$,a){const R=this.c.getEditorById(T);this.a.get($)?.fire({editor:R.apiEditor,message:a})}createRendererMessaging(T,$){if(!T.contributes?.notebookRenderer?.some(R=>R.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(R,y,c)=>this.d($).event(R,y,c),postMessage:(R,y)=>{C.$Npc.apiEditorsToExtHost.has(R)&&([R,y]=[y,R]);const c=y&&C.$Npc.apiEditorsToExtHost.get(y);return this.b.$postMessage(c?.id,$,R)}}}d(T){let $=this.a.get(T);return $||($=new v.$je({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(T)}}),this.a.set(T,$),$)}}e.$8pc=N}),define(Ne[249],Oe([1,0,8,76,21,71,13]),function(we,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_pc=void 0;class T{constructor(y){this.b=0,this.c=new Map,this.a=y}async withProgress(y,c,S){const f=this.b++,{title:n,location:o,cancellable:s}=c,l={label:y.displayName||y.name,id:y.identifier.value};return this.a.$startProgress(f,{location:v.ProgressLocation.from(o),title:n,source:l,cancellable:s},y.isUnderDevelopment?void 0:y.identifier.value).catch(A.$Z),this.d(f,S,!!s)}d(y,c,S){let f;S&&(f=new C.$ue,this.c.set(y,f));const n=s=>{this.a.$progressEnd(s),this.c.delete(s),f?.dispose()};let o;try{o=c(new a(this.a,y),S&&f?f.token:C.CancellationToken.None)}catch(s){throw n(y),s}return o.then(s=>n(y),s=>n(y)),o}$acceptProgressCanceled(y){const c=this.c.get(y);c&&(c.cancel(),this.c.delete(y))}}e.$_pc=T;function $(R,y){return R.message=y.message,typeof y.increment=="number"&&(typeof R.increment=="number"?R.increment+=y.increment:R.increment=y.increment),R}class a extends I.$uw{constructor(y,c){super(S=>this.throttledReport(S)),this.c=y,this.d=c}throttledReport(y){this.c.$progressReport(this.d,y)}}Qe([(0,N.$9h)(100,(R,y)=>$(R,y),()=>Object.create(null))],a.prototype,"throttledReport",null)}),define(Ne[250],Oe([1,0,2,5,10,8]),function(we,e,v,I,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aqc=void 0;class A{static{this.a=0}constructor($,a){this.d=a,this.c=new Map,this.b=$.getProxy(I.$sN.MainThreadQuickDiff)}$provideOriginalResource($,a,R){const y=v.URI.revive(a),c=this.c.get($);return c?(0,C.$uh)(()=>c.provideOriginalResource(y,R)).then(S=>S||null):Promise.resolve(null)}registerQuickDiffProvider($,a,R,y){const c=A.a++;return this.c.set(c,a),this.b.$registerQuickDiffProvider(c,N.DocumentSelector.from($,this.d),R,y),{dispose:()=>{this.b.$unregisterQuickDiffProvider(c),this.c.delete(c)}}}}e.$aqc=A});var _t=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Ne[251],Oe([1,0,21,6,4,5,2,7,13,17,35,34,24,8]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bqc=f,R=_t(R);function f(n,o,s){const l=n.getProxy(N.$sN.MainThreadQuickOpen);class i{constructor(D,w){this.e=new Map,this.f=0,this.a=D,this.b=w}showQuickPick(D,w,k,P=v.CancellationToken.None){this.c=void 0;const h=Promise.resolve(w),b=++this.f,M=l.$show(b,{title:k?.title,placeHolder:k?.placeHolder,matchOnDescription:k?.matchOnDescription,matchOnDetail:k?.matchOnDetail,ignoreFocusLost:k?.ignoreFocusOut,canPickMany:k?.canPickMany},P),O={},F=M.then(()=>O);return Promise.race([F,h]).then(q=>{if(q===O)return;const B=(0,c.$4G)(D,"quickPickItemTooltip");return h.then(L=>{const Y=[];for(let Z=0;Z<L.length;Z++){const fe=L[Z];if(typeof fe=="string")Y.push({label:fe,handle:Z});else if(fe.kind===T.QuickPickItemKind.Separator)Y.push({type:"separator",label:fe.label});else{fe.tooltip&&!B&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const _=fe.iconPath?p(fe.iconPath):void 0;Y.push({label:fe.label,iconPath:_?.iconPath,iconClass:_?.iconClass,description:fe.description,detail:fe.detail,picked:fe.picked,alwaysShow:fe.alwaysShow,tooltip:B?S.MarkdownString.fromStrict(fe.tooltip):void 0,handle:Z})}}return k&&typeof k.onDidSelectItem=="function"&&(this.c=Z=>{k.onDidSelectItem(L[Z])}),l.$setItems(b,Y),M.then(Z=>{if(typeof Z=="number")return L[Z];if(Array.isArray(Z))return Z.map(fe=>L[fe])})})}).then(void 0,q=>{if(!(0,$.$3)(q))return l.$setError(b,q),Promise.reject(q)})}$onItemSelected(D){this.c?.(D)}showInput(D,w=v.CancellationToken.None){return this.d=D?.validateInput,l.$input(D,typeof this.d=="function",w).then(void 0,k=>{if(!(0,$.$3)(k))return Promise.reject(k)})}async $validateInput(D){if(!this.d)return;const w=await this.d(D);if(!w||typeof w=="string")return w;let k;switch(w.severity){case T.InputBoxValidationSeverity.Info:k=R.default.Info;break;case T.InputBoxValidationSeverity.Warning:k=R.default.Warning;break;case T.InputBoxValidationSeverity.Error:k=R.default.Error;break;default:k=w.message?R.default.Error:R.default.Ignore;break}return{content:w.message,severity:k}}async showWorkspaceFolderPick(D,w=v.CancellationToken.None){const k=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!k)return;const P=await this.a.getWorkspaceFolders2();if(P)return P.find(h=>h.uri.toString()===k.uri.toString())}createQuickPick(D){const w=new m(D,()=>this.e.delete(w._id));return this.e.set(w._id,w),w}createInputBox(D){const w=new d(D,()=>this.e.delete(w._id));return this.e.set(w._id,w),w}$onDidChangeValue(D,w){this.e.get(D)?._fireDidChangeValue(w)}$onDidAccept(D){this.e.get(D)?._fireDidAccept()}$onDidChangeActive(D,w){const k=this.e.get(D);k instanceof m&&k._fireDidChangeActive(w)}$onDidChangeSelection(D,w){const k=this.e.get(D);k instanceof m&&k._fireDidChangeSelection(w)}$onDidTriggerButton(D,w){this.e.get(D)?._fireDidTriggerButton(w)}$onDidTriggerItemButton(D,w,k){const P=this.e.get(D);P instanceof m&&P._fireDidTriggerItemButton(w,k)}$onDidHide(D){this.e.get(D)?._fireDidHide()}}class r{static{this.a=1}constructor(D,w){this.x=D,this.y=w,this._id=m.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new I.$je,this.q=new I.$je,this.r=new I.$je,this.s=new I.$je,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(D){this.b=D,this.z({title:D})}get step(){return this.c}set step(D){this.c=D,this.z({step:D})}get totalSteps(){return this.d}set totalSteps(D){this.d=D,this.z({totalSteps:D})}get enabled(){return this.g}set enabled(D){this.g=D,this.z({enabled:D})}get busy(){return this.j}set busy(D){this.j=D,this.z({busy:D})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(D){this.k=D,this.z({ignoreFocusOut:D})}get value(){return this.l}set value(D){this.l=D,this.z({value:D})}get placeholder(){return this.m}set placeholder(D){this.m=D,this.z({placeholder:D})}get buttons(){return this.n}set buttons(D){this.n=D.slice(),this.o.clear(),D.forEach((w,k)=>{const P=w===T.$TO.Back?-1:k;this.o.set(P,w)}),this.z({buttons:D.map((w,k)=>({...p(w.iconPath),tooltip:w.tooltip,handle:w===T.$TO.Back?-1:k}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(D){this.l=D,this.q.fire(D)}_fireDidTriggerButton(D){const w=this.o.get(D);w&&this.r.fire(w)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),l.$dispose(this._id))}z(D){if(!this.v){for(const w of Object.keys(D)){const k=D[w];this.u[w]=k===void 0?null:k}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){l.$createOrUpdate(this.u),this.u={id:this._id}}}function t(E){if(E instanceof T.$rO)return{id:E.id};const D=u(E),w=g(E);return{dark:typeof D=="string"?A.URI.file(D):D,light:typeof w=="string"?A.URI.file(w):w}}function g(E){return typeof E=="object"&&"light"in E?E.light:E}function u(E){return typeof E=="object"&&"dark"in E?E.dark:E}function p(E){const D=t(E);let w,k;return"id"in D?k=y.ThemeIcon.asClassName(D):w=D,{iconPath:w,iconClass:k}}class m extends r{constructor(D,w){super(D.identifier,w),this.O=D,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new I.$je,this.L=[],this.M=new I.$je,this.N=new I.$je,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(D){this.B=D.slice(),this.C.clear(),this.D.clear(),D.forEach((P,h)=>{this.C.set(h,P),this.D.set(P,h)});const w=(0,c.$4G)(this.O,"quickPickItemTooltip"),k=[];for(let P=0;P<D.length;P++){const h=D[P];if(h.kind===T.QuickPickItemKind.Separator)k.push({type:"separator",label:h.label});else{h.tooltip&&!w&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const b=h.iconPath?p(h.iconPath):void 0;k.push({handle:P,label:h.label,iconPath:b?.iconPath,iconClass:b?.iconClass,description:h.description,detail:h.detail,picked:h.picked,alwaysShow:h.alwaysShow,tooltip:w?S.MarkdownString.fromStrict(h.tooltip):void 0,buttons:h.buttons?.map((M,O)=>({...p(M.iconPath),tooltip:M.tooltip,handle:O}))})}}this.z({items:k})}get canSelectMany(){return this.E}set canSelectMany(D){this.E=D,this.z({canSelectMany:D})}get matchOnDescription(){return this.F}set matchOnDescription(D){this.F=D,this.z({matchOnDescription:D})}get matchOnDetail(){return this.G}set matchOnDetail(D){this.G=D,this.z({matchOnDetail:D})}get sortByLabel(){return this.H}set sortByLabel(D){this.H=D,this.z({sortByLabel:D})}get keepScrollPosition(){return this.I}set keepScrollPosition(D){this.I=D,this.z({keepScrollPosition:D})}get activeItems(){return this.J}set activeItems(D){this.J=D.filter(w=>this.D.has(w)),this.z({activeItems:this.J.map(w=>this.D.get(w))})}get selectedItems(){return this.L}set selectedItems(D){this.L=D.filter(w=>this.D.has(w)),this.z({selectedItems:this.L.map(w=>this.D.get(w))})}_fireDidChangeActive(D){const w=(0,a.$Gb)(D.map(k=>this.C.get(k)));this.J=w,this.K.fire(w)}_fireDidChangeSelection(D){const w=(0,a.$Gb)(D.map(k=>this.C.get(k)));this.L=w,this.M.fire(w)}_fireDidTriggerItemButton(D,w){const k=this.C.get(D);if(!k||!k.buttons||!k.buttons.length)return;const P=k.buttons[w];P&&this.N.fire({button:P,item:k})}}class d extends r{constructor(D,w){super(D.identifier,w),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(D){this.B=D,this.z({password:D})}get prompt(){return this.C}set prompt(D){this.C=D,this.z({prompt:D})}get valueSelection(){return this.D}set valueSelection(D){this.D=D,this.z({valueSelection:D})}get validationMessage(){return this.E}set validationMessage(D){this.E=D,D?typeof D=="string"?this.z({validationMessage:D,severity:R.default.Error}):this.z({validationMessage:D.message,severity:D.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new i(o,s)}}),define(Ne[252],Oe([1,0,2,6,71,4,10,5,17,144,11,18,36,34,8,24,15,20]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S,f,n,o,s){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$dqc=e.$cqc=void 0;function i(O){return O instanceof v.URI}function r(O,F){return O.scheme===o.Schemas.file&&F.scheme===o.Schemas.file&&s.$l?O.toString()===F.toString():O.toString().toLowerCase()===F.toString().toLowerCase()}function t(O){if(O)return typeof O.iconPath=="string"?v.URI.file(O.iconPath):v.URI.isUri(O.iconPath)||S.ThemeIcon.isThemeIcon(O.iconPath)?O.iconPath:void 0}function g(O){if(O){if(v.URI.isUri(O))return O;if(S.ThemeIcon.isThemeIcon(O))return O;{const F=O;return{light:F.light,dark:F.dark}}}else return}function u(O){const F=g(O.icon),q=O.labels?.map(B=>({title:B.title,icon:g(B.icon)}));return{...O,icon:F,labels:q}}function p(O,F){if(!O.iconPath&&!F.iconPath)return 0;if(O.iconPath){if(!F.iconPath)return 1}else return-1;const q=typeof O.iconPath=="string"?O.iconPath:v.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id,B=typeof F.iconPath=="string"?F.iconPath:v.URI.isUri(F.iconPath)?F.iconPath.fsPath:F.iconPath.id;return(0,a.$Gr)(q,B)}function m(O,F){let q=0;if(O.strikeThrough!==F.strikeThrough)return O.strikeThrough?1:-1;if(O.faded!==F.faded)return O.faded?1:-1;if(O.tooltip!==F.tooltip)return(O.tooltip||"").localeCompare(F.tooltip||"");if(q=p(O,F),q!==0)return q;if(O.light&&F.light)q=p(O.light,F.light);else{if(O.light)return 1;if(F.light)return-1}if(q!==0)return q;if(O.dark&&F.dark)q=p(O.dark,F.dark);else{if(O.dark)return 1;if(F.dark)return-1}return q}function d(O,F){if(O.command!==F.command)return O.command<F.command?-1:1;if(O.title!==F.title)return O.title<F.title?-1:1;if(O.tooltip!==F.tooltip){if(O.tooltip!==void 0&&F.tooltip!==void 0)return O.tooltip<F.tooltip?-1:1;if(O.tooltip!==void 0)return 1;if(F.tooltip!==void 0)return-1}if(O.arguments===F.arguments)return 0;if(O.arguments)if(F.arguments){if(O.arguments.length!==F.arguments.length)return O.arguments.length-F.arguments.length}else return 1;else return-1;for(let q=0;q<O.arguments.length;q++){const B=O.arguments[q],L=F.arguments[q];if(B!==L&&!(i(B)&&i(L)&&r(B,L)))return B<L?-1:1}return 0}function E(O,F){let q=(0,a.$Gr)(O.resourceUri.fsPath,F.resourceUri.fsPath,!0);if(q!==0)return q;if(O.command&&F.command)q=d(O.command,F.command);else{if(O.command)return 1;if(F.command)return-1}if(q!==0)return q;if(O.decorations&&F.decorations)q=m(O.decorations,F.decorations);else{if(O.decorations)return 1;if(F.decorations)return-1}if(O.multiFileDiffEditorModifiedUri&&F.multiFileDiffEditorModifiedUri)q=(0,a.$Gr)(O.multiFileDiffEditorModifiedUri.fsPath,F.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(O.multiFileDiffEditorModifiedUri)return 1;if(F.multiFileDiffEditorModifiedUri)return-1}if(O.multiDiffEditorOriginalUri&&F.multiDiffEditorOriginalUri)q=(0,a.$Gr)(O.multiDiffEditorOriginalUri.fsPath,F.multiDiffEditorOriginalUri.fsPath,!0);else{if(O.multiDiffEditorOriginalUri)return 1;if(F.multiDiffEditorOriginalUri)return-1}return q}function D(O,F){for(let q=0;q<O.length;q++)if(O[q]!==F[q])return!1;return!0}function w(O,F){return O.command===F.command&&O.title===F.title&&O.tooltip===F.tooltip&&(O.arguments&&F.arguments?D(O.arguments,F.arguments):O.arguments===F.arguments)}function k(O,F){return(0,$.$tb)(O,F,w)}class P{#e;#t;get value(){return this.d}set value(F){F=F??"",this.#e.$setInputBoxValue(this.m,F),this.o(F)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(F){this.#e.$setInputBoxPlaceholder(this.m,F),this.f=F}get validateInput(){return(0,n.$5G)(this.k,"scmValidation"),this.g}set validateInput(F){if((0,n.$5G)(this.k,"scmValidation"),F&&typeof F!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=F,this.#e.$setValidationProviderIsEnabled(this.m,!!F)}get enabled(){return this.h}set enabled(F){F=!!F,this.h!==F&&(this.h=F,this.#e.$setInputBoxEnablement(this.m,F))}get visible(){return this.j}set visible(F){F=!!F,this.j!==F&&(this.j=F,this.#e.$setInputBoxVisibility(this.m,F))}get document(){return(0,n.$5G)(this.k,"scmTextDocument"),this.#t.getDocument(this.n)}constructor(F,q,B,L,Y){this.k=F,this.m=L,this.n=Y,this.d="",this.e=new I.$je,this.f="",this.h=!0,this.j=!0,this.#t=q,this.#e=B}showValidationMessage(F,q){(0,n.$5G)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.m,F,q)}$onInputBoxValueChange(F){this.o(F)}o(F){this.d=F,this.e.fire(F)}}e.$cqc=P;class h{static{this.d=0}get disposed(){return this.m}get id(){return this.v}get label(){return this.w}set label(F){this.w=F,this.s.$updateGroupLabel(this.u,this.handle,F)}get hideWhenEmpty(){return this.q}set hideWhenEmpty(F){this.q=F,this.s.$updateGroup(this.u,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(F){this.f=[...F],this.k.fire()}constructor(F,q,B,L,Y,Z,fe){this.s=F,this.t=q,this.u=B,this.v=L,this.w=Y,this.multiDiffEditorEnableViewChanges=Z,this.x=fe,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new I.$je,this.onDidUpdateResourceStates=this.k.event,this.m=!1,this.n=new I.$je,this.onDidDispose=this.n.event,this.o=[],this.p=[],this.q=void 0,this.handle=h.d++}getResourceState(F){return this.g.get(F)}$executeResourceCommand(F,q){const B=this.h.get(F);return B?(0,A.$uh)(()=>this.t.executeCommand(B.command,...B.arguments||[],q)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const F=[...this.f].sort(E),B=(0,$.$Cb)(this.p,F,E).map(Z=>{const fe=Z.toInsert.map(_=>{const ge=this.e++;this.g.set(ge,_);const se=_.resourceUri;let ae;if(_.command)if(_.command.command==="vscode.open"||_.command.command==="vscode.diff"||_.command.command==="vscode.changes"){const x=new N.$Sc;ae=this.t.converter.toInternal(_.command,x),this.j.set(ge,x)}else this.h.set(ge,_.command);const $e=(0,n.$4G)(this.x,"scmMultiDiffEditor"),oe=$e?_.multiDiffEditorOriginalUri:void 0,Ce=$e?_.multiFileDiffEditorModifiedUri:void 0,Fe=t(_.decorations),X=_.decorations&&t(_.decorations.light)||Fe,V=_.decorations&&t(_.decorations.dark)||Fe,te=[X,V],ve=_.decorations&&_.decorations.tooltip||"",ce=_.decorations&&!!_.decorations.strikeThrough,be=_.decorations&&!!_.decorations.faded,he=_.contextValue||"";return{rawResource:[ge,se,te,ve,ce,be,he,ae,oe,Ce],handle:ge}});return{start:Z.start,deleteCount:Z.deleteCount,toInsert:fe}}),L=B.map(({start:Z,deleteCount:fe,toInsert:_})=>[Z,fe,_.map(ge=>ge.rawResource)]),Y=B.reverse();for(const{start:Z,deleteCount:fe,toInsert:_}of Y){const ge=_.map(ae=>ae.handle),se=this.o.splice(Z,fe,...ge);for(const ae of se)this.g.delete(ae),this.h.delete(ae),this.j.get(ae)?.dispose(),this.j.delete(ae)}return this.p=F,L}dispose(){this.m=!0,this.n.fire()}}class b{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(F){this.g!==F&&(this.g=F,this.#e.$updateSourceControl(this.x,{count:F}))}get quickDiffProvider(){return this.h}set quickDiffProvider(F){this.h=F;let q;(0,n.$4G)(this.y,"quickDiffProvider")&&(q=F?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!F,quickDiffLabel:q})}get historyProvider(){return(0,n.$5G)(this.y,"scmHistoryProvider"),this.j}set historyProvider(F){(0,n.$5G)(this.y,"scmHistoryProvider"),this.j=F,this.k.value=new N.$Sc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!F}),F&&this.k.value.add(F.onDidChangeCurrentHistoryItemGroup(()=>{this.m=F?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.m)}))}get commitTemplate(){return this.n}set commitTemplate(F){F!==this.n&&(this.n=F,this.#e.$updateSourceControl(this.x,{commitTemplate:F}))}get acceptInputCommand(){return this.p}set acceptInputCommand(F){this.o.value=new N.$Sc,this.p=F;const q=this.z.converter.toInternal(F,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:q})}get actionButton(){return(0,n.$5G)(this.y,"scmActionButton"),this.s}set actionButton(F){(0,n.$5G)(this.y,"scmActionButton"),this.q.value=new N.$Sc,this.s=F;const q=F!==void 0?{command:this.z.converter.toInternal(F.command,this.q.value),secondaryCommands:F.secondaryCommands?.map(B=>B.map(L=>this.z.converter.toInternal(L,this.q.value))),description:F.description,enabled:F.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:q??null})}get statusBarCommands(){return this.u}set statusBarCommands(F){if(this.u&&F&&k(this.u,F))return;this.t.value=new N.$Sc,this.u=F;const q=(F||[]).map(B=>this.z.converter.toInternal(B,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:q})}get selected(){return this.v}constructor(F,q,B,L,Y,Z,fe){this.y=F,this.z=L,this.A=Y,this.B=Z,this.C=fe,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new N.$Uc,this.n=void 0,this.o=new N.$Uc,this.p=void 0,this.q=new N.$Uc,this.t=new N.$Uc,this.u=void 0,this.v=!1,this.w=new I.$je,this.onDidChangeSelection=this.w.event,this.x=b.d++,this.D=new Map,this.E=new Set,this.#e=B;const _=v.URI.from({scheme:o.Schemas.vscodeSourceControl,path:`${Y}/scm${this.x}/input`,query:fe?`rootUri=${encodeURIComponent(fe.toString())}`:void 0});this.f=new P(F,q,this.#e,this.x,_),this.#e.$registerSourceControl(this.x,Y,Z,fe,_)}createResourceGroup(F,q,B){const L=(0,n.$4G)(this.y,"scmMultiDiffEditor")&&B?.multiDiffEditorEnableViewChanges===!0,Y=new h(this.#e,this.z,this.x,F,q,L,this.y),Z=I.Event.once(Y.onDidDispose)(()=>this.D.delete(Y));return this.D.set(Y,Z),this.eventuallyAddResourceGroups(),Y}eventuallyAddResourceGroups(){const F=[],q=[];for(const[B,L]of this.D){L.dispose();const Y=B.onDidUpdateResourceStates(()=>{this.E.add(B),this.eventuallyUpdateResourceStates()});I.Event.once(B.onDidDispose)(()=>{this.E.delete(B),Y.dispose(),this.e.delete(B.handle),this.#e.$unregisterGroup(this.x,B.handle)}),F.push([B.handle,B.id,B.label,B.features,B.multiDiffEditorEnableViewChanges]);const Z=B._takeResourceStateSnapshot();Z.length>0&&q.push([B.handle,Z]),this.e.set(B.handle,B)}this.#e.$registerGroups(this.x,F,q),this.D.clear()}eventuallyUpdateResourceStates(){const F=[];this.E.forEach(q=>{const B=q._takeResourceStateSnapshot();B.length!==0&&F.push([q.handle,B])}),F.length>0&&this.#e.$spliceResourceStates(this.x,F),this.E.clear()}getResourceGroup(F){return this.e.get(F)}setSelectionState(F){this.v=F,this.w.fire(F)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(F=>F.dispose()),this.#e.$unregisterSourceControl(this.x)}}Qe([(0,C.$8h)(100)],b.prototype,"eventuallyAddResourceGroups",null),Qe([(0,C.$8h)(100)],b.prototype,"eventuallyUpdateResourceStates",null);let M=class{static{l=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(F,q,B,L){this.m=q,this.n=B,this.o=L,this.g=new Map,this.h=new y.$pn,this.j=new I.$je,this.e=F.getProxy(T.$sN.MainThreadSCM),this.f=F.getProxy(T.$sN.MainThreadTelemetry),q.registerArgumentProcessor({processArgument:Y=>{if(Y&&Y.$mid===c.MarshalledId.ScmResource){const Z=this.g.get(Y.sourceControlHandle);if(!Z)return Y;const fe=Z.getResourceGroup(Y.groupHandle);return fe?fe.getResourceState(Y.handle):Y}else if(Y&&Y.$mid===c.MarshalledId.ScmResourceGroup){const Z=this.g.get(Y.sourceControlHandle);return Z?Z.getResourceGroup(Y.groupHandle):Y}else if(Y&&Y.$mid===c.MarshalledId.ScmProvider){const Z=this.g.get(Y.handle);return Z||Y}return Y}})}createSourceControl(F,q,B,L){this.o.trace("ExtHostSCM#createSourceControl",F.identifier.value,q,B,L),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:F.identifier.value});const Y=l.d++,Z=new b(F,this.n,this.e,this.m,q,B,L);this.g.set(Y,Z);const fe=this.h.get(F.identifier)||[];return fe.push(Z),this.h.set(F.identifier,fe),Z}getLastInputBox(F){this.o.trace("ExtHostSCM#getLastInputBox",F.identifier.value);const q=this.h.get(F.identifier),B=q&&q[q.length-1];return B&&B.inputBox}$provideOriginalResource(F,q,B){const L=v.URI.revive(q);this.o.trace("ExtHostSCM#$provideOriginalResource",F,L.toString());const Y=this.g.get(F);return!Y||!Y.quickDiffProvider||!Y.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$uh)(()=>Y.quickDiffProvider.provideOriginalResource(L,B)).then(Z=>Z||null)}$onInputBoxValueChange(F,q){this.o.trace("ExtHostSCM#$onInputBoxValueChange",F);const B=this.g.get(F);return B&&B.inputBox.$onInputBoxValueChange(q),Promise.resolve(void 0)}$executeResourceCommand(F,q,B,L){this.o.trace("ExtHostSCM#$executeResourceCommand",F,q,B);const Y=this.g.get(F);if(!Y)return Promise.resolve(void 0);const Z=Y.getResourceGroup(q);return Z?Z.$executeResourceCommand(B,L):Promise.resolve(void 0)}$validateInput(F,q,B){this.o.trace("ExtHostSCM#$validateInput",F);const L=this.g.get(F);return!L||!L.inputBox.validateInput?Promise.resolve(void 0):(0,A.$uh)(()=>L.inputBox.validateInput(q,B)).then(Y=>{if(!Y)return Promise.resolve(void 0);const Z=f.MarkdownString.fromStrict(Y.message);return Z?Promise.resolve([Z,Y.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(F){return this.o.trace("ExtHostSCM#$setSelectedSourceControl",F),F!==void 0&&this.g.get(F)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=F,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(F,q,B,L){return await this.g.get(F)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(q,B,L)??void 0}async $provideHistoryItems(F,q,B,L){return(await this.g.get(F)?.historyProvider?.provideHistoryItems(q,B,L))?.map(fe=>u(fe))??void 0}async $provideHistoryItems2(F,q,B){return(await this.g.get(F)?.historyProvider?.provideHistoryItems2(q,B))?.map(Z=>u(Z))??void 0}async $provideHistoryItemSummary(F,q,B,L){const Y=this.g.get(F)?.historyProvider;if(typeof Y?.provideHistoryItemSummary!="function")return;const Z=await Y.provideHistoryItemSummary(q,B,L);return Z?u(Z):void 0}async $provideHistoryItemChanges(F,q,B,L){return await this.g.get(F)?.historyProvider?.provideHistoryItemChanges(q,B,L)??void 0}};e.$dqc=M,e.$dqc=M=l=Qe([qe(3,R.$9j)],M)}),define(Ne[253],Oe([1,0,5,8,2]),function(we,e,v,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eqc=void 0;class N{static{this.a=0}constructor(T,$){this.d=$,this.c=new Map,this.b=T.getProxy(v.$sN.MainThreadShare)}async $provideShare(T,$,a){return await this.c.get(T)?.provideShare({selection:I.Range.to($.selection),resourceUri:C.URI.revive($.resourceUri)},a)??void 0}registerShareProvider(T,$){const a=N.a++;return this.c.set(a,$),this.b.$registerShareProvider(a,I.DocumentSelector.from(T,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(a),this.c.delete(a)}}}}e.$eqc=N}),define(Ne[254],Oe([1,0,7,5,9,4,8,14]),function(we,e,v,I,C,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hqc=e.$gqc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new v.$sO("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new v.$sO("statusBarItem.warningForeground")]])}#e;#t;constructor(c,S,f,n,o,s=v.StatusBarAlignment.Left,l){if(this.i=!1,this.k="",this.q=new N.$Sc,this.#e=c,this.#t=S,o&&n){this.c=(0,v.$7N)(n.identifier,o);const i=f.get(this.c);i&&(s=i.alignLeft?v.StatusBarAlignment.Left:v.StatusBarAlignment.Right,l=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String($.a++);this.e=n,this.f=o,this.g=s,this.h=this.u(l)}u(c){if((0,T.$gg)(c))return c===Number.POSITIVE_INFINITY?Number.MAX_VALUE:c===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:c}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(c){this.k=c,this.v()}set name(c){this.m=c,this.v()}set tooltip(c){this.l=c,this.v()}set color(c){this.n=c,this.v()}set backgroundColor(c){c&&!$.b.has(c.id)&&(c=void 0),this.o=c,this.v()}set command(c){this.r?.fromApi!==c&&(this.p&&this.q.add(this.p),this.p=new N.$Sc,typeof c=="string"?this.r={fromApi:c,internal:this.#t.toInternal({title:"",command:c},this.p)}:c?this.r={fromApi:c,internal:this.#t.toInternal(c,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(c){this.t=c,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let c;this.e?this.f?c=`${this.e.identifier.value}.${this.f}`:c=this.e.identifier.value:c=this.f;let S;this.m?S=this.m:S=(0,C.localize)(10661,null,this.e.displayName||this.e.name);let f=this.n;this.o&&(f=$.b.get(this.o.id));const n=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,c,this.e?.identifier.value,S,this.k,n,this.r?.internal,f,this.o,this.g===v.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$gqc=$;class a{constructor(c){this.b=[],this.a=c.createStatusBarEntry(void 0,"status.extensionMessage",v.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(10662,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(c){const S={message:c};return this.b.unshift(S),this.c(),new v.$uN(()=>{const f=this.b.indexOf(S);f>=0&&(this.b.splice(f,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(c,S){this.e=new Map,this.a=c.getProxy(I.$sN.MainThreadStatusBar),this.b=S,this.c=new a(this)}$acceptStaticEntries(c){for(const S of c)this.e.set(S.entryId,S)}createStatusBarEntry(c,S,f,n){return new $(this.a,this.b,this.e,c,S,f,n)}setStatusBarMessage(c,S){const f=this.c.setMessage(c);let n;return typeof S=="number"?n=setTimeout(()=>f.dispose(),S):typeof S<"u"&&S.then(()=>f.dispose(),()=>f.dispose()),new v.$uN(()=>{f.dispose(),clearTimeout(n)})}}e.$hqc=R}),define(Ne[125],Oe([1,0,32,116,54,81,55,8,2]),function(we,e,v,I,C,N,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dQ=e.$cQ=e.$bQ=e.$aQ=void 0,v=Ve(v),T=Ve(T);const a=(i,r,t,g)=>{let u=r;return{enumerable:!0,configurable:!1,get(){return u},set(p){if(!t(u,p)){const m=u;u=p,i.listener?.(g(p,m))}}}},R=(i,r)=>i===r,y={range:(i,r)=>i===r?!0:!i||!r?!1:i.isEqual(r),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(i,r)=>!(i.length!==r.length||i.some(t=>!r.find(g=>t.id===g.id)))},c=i=>r=>({op:N.TestItemEventOp.SetProp,update:i(r)}),S=(i,r)=>({range:(()=>{let t;const g=c(u=>({range:v.$Kt.lift(T.Range.from(u))}));return{enumerable:!0,configurable:!1,get(){return t},set(u){i.listener?.({op:N.TestItemEventOp.DocumentSynced}),y.range(t,u)||(t=u,i.listener?.(g(u)))}}})(),label:a(i,r,y.label,c(t=>({label:t}))),description:a(i,void 0,y.description,c(t=>({description:t}))),sortText:a(i,void 0,y.sortText,c(t=>({sortText:t}))),canResolveChildren:a(i,!1,y.canResolveChildren,t=>({op:N.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:a(i,!1,y.busy,c(t=>({busy:t}))),error:a(i,void 0,y.error,c(t=>({error:T.MarkdownString.fromStrict(t)||null}))),tags:a(i,[],y.tags,(t,g)=>({op:N.TestItemEventOp.SetTags,new:t.map(T.TestTag.from),old:g.map(T.TestTag.from)}))}),f=i=>{const r=C.$RI.fromString(i.extId),t=new o(r.controllerId,r.localId,i.label,$.URI.revive(i.uri)||void 0);return t.range=T.Range.to(i.range||void 0),t.description=i.description||void 0,t.sortText=i.sortText||void 0,t.tags=i.tags.map(g=>T.TestTag.to({id:(0,A.$XI)(g).tagId})),t},n=i=>{let r;for(const t of i.tests){const g=f(t.item);(0,I.$WP)(g).parent=r,r=g}return r};e.$aQ=n;class o{constructor(r,t,g,u){if(t.includes(C.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const p=(0,I.$VP)(this,r);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return p.parent instanceof s?void 0:p.parent}},children:{value:(0,N.$UP)(p,I.$WP,o),enumerable:!0,writable:!1},...S(p,g)})}}e.$bQ=o;class s extends o{constructor(r,t){super(r,r,t,void 0),this._isRoot=!0}}e.$cQ=s;class l extends N.$QP{constructor(r,t,g){super({controllerId:r,getDocumentVersion:u=>u&&g.getDocument(u)?.version,getApiFor:I.$WP,getChildren:u=>u.children,root:new s(r,t),toITestItem:T.TestItem.from})}}e.$dQ=l}),define(Ne[33],Oe([1,0,14,7,8,25,5,17,11,40,32,101,2,4,3,16,125,22,38,42,69,63,66,37]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S,f,n,o,s,l,i,r,t,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oQ=e.$nQ=e.$mQ=e.$lQ=e.$kQ=e.$jQ=void 0,I=Ve(I),C=Ve(C);let p=class{#e;#t;#i;constructor(k,P,h){this.b=new Map,this.c=new Map,this.#e=k.getProxy(A.$sN.MainThreadCommands),this.d=P,this.#i=h,this.#t=k.getProxy(A.$sN.MainThreadTelemetry),this.converter=new m(this,b=>{const M=this.c.get(b);return M?.result===E.Void?M:void 0},P),this.f=[{processArgument(b){return(0,a.$_h)(b)}},{processArgument(b){return(0,N.$co)(b,function(M){if(R.$Kt.isIRange(M))return C.Range.to(M);if(y.$Jt.isIPosition(M))return C.Position.to(M);if(R.$Kt.isIRange(M.range)&&c.URI.isUri(M.uri))return C.location.to(M);if(M instanceof s.$Le)return M.buffer.buffer;if(!Array.isArray(M))return M})}}]}registerArgumentProcessor(k){this.f.push(k)}registerApiCommand(k){const P=this.registerCommand(!1,k.id,async(...h)=>{const b=k.args.map((O,F)=>{if(!O.validate(h[F]))throw new Error(`Invalid argument '${O.name}' when running '${k.id}', received: ${typeof h[F]=="object"?JSON.stringify(h[F],null,"	"):h[F]} `);return O.convert(h[F])}),M=await this.executeCommand(k.internalId,...b);return k.result.convert(M,h,this.converter)},void 0,{description:k.description,args:k.args,returns:k.result.description});return this.c.set(k.id,k),new I.$uN(()=>{P.dispose(),this.c.delete(k.id)})}registerCommand(k,P,h,b,M,O){if(this.d.trace("ExtHostCommands#registerCommand",P),!P.trim().length)throw new Error("invalid id");if(this.b.has(P))throw new Error(`command '${P}' already exists`);return this.b.set(P,{callback:h,thisArg:b,metadata:M,extension:O}),k&&this.#e.$registerCommand(P),new I.$uN(()=>{this.b.delete(P)&&k&&this.#e.$unregisterCommand(P)})}executeCommand(k,...P){return this.d.trace("ExtHostCommands#executeCommand",k),this.g(k,P,!0)}async g(k,P,h){if(this.b.has(k))return this.#e.$fireCommandActivationEvent(k),this.h(k,P,!1);{let b=!1;const M=(0,N.$co)(P,function(O){if(O instanceof I.$vN)return C.Position.from(O);if(O instanceof I.$wN)return C.Range.from(O);if(O instanceof I.$GN)return C.location.from(O);if(I.$WO.isNotebookRange(O))return C.NotebookRange.from(O);if(O instanceof ArrayBuffer)return b=!0,s.$Le.wrap(new Uint8Array(O));if(O instanceof Uint8Array)return b=!0,s.$Le.wrap(O);if(O instanceof s.$Le)return b=!0,O;if(!Array.isArray(O))return O});try{const O=await this.#e.$executeCommand(k,b?new l.$Sw(M):M,h);return(0,a.$_h)(O)}catch(O){if(O instanceof Error&&O.message==="$executeCommand:retry")return this.g(k,P,!1);throw O}}}async h(k,P,h){const b=this.b.get(k);if(!b)throw new Error("Unknown command");const{callback:M,thisArg:O,metadata:F}=b;if(F?.args)for(let B=0;B<F.args.length;B++)try{(0,v.$tg)(P[B],F.args[B].constraint)}catch{throw new Error(`Running the contributed command: '${k}' failed. Illegal argument '${F.args[B].name}' - ${F.args[B].description}`)}const q=r.$de.create();try{return await M.apply(O,P)}catch(B){if(k===this.converter.delegatingCommandId){const L=this.converter.getActualCommand(...P);L&&(k=L.command)}if(this.d.error(B,k,b.extension?.identifier),!h)throw B;if(b.extension?.identifier){const L=this.#i.onExtensionError(b.extension.identifier,B);this.d.trace("forwarded error to extension?",L,b.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$nj)(B)),this.id=k,this.source=b.extension?.displayName??b.extension?.name}}}finally{this.j(b,k,q.elapsed())}}j(k,P,h){k.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:k.extension.identifier.value,id:new t.$tp(P),duration:h})}$executeContributedCommand(k,...P){this.d.trace("ExtHostCommands#$executeContributedCommand",k);const h=this.b.get(k);return h?(P=P.map(b=>this.f.reduce((M,O)=>O.processArgument(M,h.extension?.identifier),b)),this.h(k,P,!0)):Promise.reject(new Error(`Contributed command '${k}' does not exist.`))}getCommands(k=!1){return this.d.trace("ExtHostCommands#getCommands",k),this.#e.$getCommands().then(P=>(k&&(P=P.filter(h=>h[0]!=="_")),P))}$getContributedCommandMetadata(){const k=Object.create(null);for(const[P,h]of this.b){const{metadata:b}=h;b&&(k[P]=b)}return Promise.resolve(k)}};e.$jQ=p,e.$jQ=p=Qe([qe(0,n.$1P),qe(1,$.$9j),qe(2,g.$iQ)],p),e.$kQ=(0,f.$Ci)("IExtHostCommands");class m{constructor(k,P,h){this.d=k,this.f=P,this.g=h,this.delegatingCommandId=`__vsc${(0,u.$Yg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(k,P){if(!k)return;const h={$ident:void 0,id:k.command,title:k.title,tooltip:k.tooltip};if(!k.command)return h;const b=this.f(k.command);if(b)h.id=b.internalId,h.arguments=b.args.map((M,O)=>M.convert(k.arguments&&k.arguments[O]));else if((0,T.$Kb)(k.arguments)){const M=`${k.command} /${++this.c}`;this.b.set(M,k),P.add((0,S.$Rc)(()=>{this.b.delete(M),this.g.trace("CommandsConverter#DISPOSE",M)})),h.$ident=M,h.id=this.delegatingCommandId,h.arguments=[M],this.g.trace("CommandsConverter#CREATE",k.command,M)}return h}fromInternal(k){return typeof k.$ident=="string"?this.b.get(k.$ident):{command:k.id,title:k.title,arguments:k.arguments}}getActualCommand(...k){return this.b.get(k[0])}h(...k){const P=this.getActualCommand(...k);return this.g.trace("CommandsConverter#EXECUTE",k[0],P?P.command:"MISSING"),P?this.d.executeCommand(P.command,...P.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${k[0]}`)}}e.$lQ=m;class d{static{this.Uri=new d("uri","Uri of a text document",k=>c.URI.isUri(k),k=>k)}static{this.Position=new d("position","A position in a text document",k=>I.$vN.isPosition(k),C.Position.from)}static{this.Range=new d("range","A range in a text document",k=>I.$wN.isRange(k),C.Range.from)}static{this.Selection=new d("selection","A selection in a text document",k=>I.$xN.isSelection(k),C.Selection.from)}static{this.Number=new d("number","",k=>typeof k=="number",k=>k)}static{this.String=new d("string","",k=>typeof k=="string",k=>k)}static{this.StringArray=d.Arr(d.String)}static Arr(k){return new d(`${k.name}_array`,`Array of ${k.name}, ${k.description}`,P=>Array.isArray(P)&&P.every(h=>k.validate(h)),P=>P.map(h=>k.convert(h)))}static{this.CallHierarchyItem=new d("item","A call hierarchy item",k=>k instanceof I.$SN,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new d("item","A type hierarchy item",k=>k instanceof I.$eP,C.TypeHierarchyItem.from)}static{this.TestItem=new d("testItem","A VS Code TestItem",k=>k instanceof o.$bQ,C.TestItem.from)}constructor(k,P,h,b){this.name=k,this.description=P,this.validate=h,this.convert=b}optional(){return new d(this.name,`(optional) ${this.description}`,k=>k==null||this.validate(k),k=>k===void 0?void 0:k===null?null:this.convert(k))}with(k,P){return new d(k??this.name,P??this.description,this.validate,this.convert)}}e.$mQ=d;class E{static{this.Void=new E("no result",k=>k)}constructor(k,P){this.description=k,this.convert=P}}e.$nQ=E;class D{constructor(k,P,h,b,M){this.id=k,this.internalId=P,this.description=h,this.args=b,this.result=M}}e.$oQ=D}),define(Ne[255],Oe([1,0,17,15,2,93,103,31,33,8,7]),function(we,e,v,I,C,N,A,T,$,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$woc=void 0,N=Ve(N),a=Ve(a),R=Ve(R);const y=[new $.$oQ("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$mQ.Uri,$.$mQ.Position],new $.$nQ("A promise that resolves to an array of DocumentHighlight-instances.",S(a.DocumentHighlight.to))),new $.$oQ("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$mQ.Uri],new $.$nQ("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,o)=>{if((0,v.$Jb)(n))return;class s extends R.$NN{static to(i){const r=new s(i.name,a.SymbolKind.to(i.kind),i.containerName||"",new R.$GN(o[0],a.Range.to(i.range)));return r.detail=i.detail,r.range=r.location.range,r.selectionRange=a.Range.to(i.selectionRange),r.children=i.children?i.children.map(s.to):[],r}}return n.map(s.to)})),new $.$oQ("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$mQ.Uri,new $.$mQ("options","Formatting options",n=>!0,n=>n)],new $.$nQ("A promise that resolves to an array of TextEdits.",S(a.TextEdit.to))),new $.$oQ("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$mQ.Uri,$.$mQ.Range,new $.$mQ("options","Formatting options",n=>!0,n=>n)],new $.$nQ("A promise that resolves to an array of TextEdits.",S(a.TextEdit.to))),new $.$oQ("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$mQ.Uri,$.$mQ.Position,new $.$mQ("ch","Trigger character",n=>typeof n=="string",n=>n),new $.$mQ("options","Formatting options",n=>!0,n=>n)],new $.$nQ("A promise that resolves to an array of TextEdits.",S(a.TextEdit.to))),new $.$oQ("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$mQ.Uri,$.$mQ.Position],new $.$nQ("A promise that resolves to an array of Location or LocationLink instances.",f)),new $.$oQ("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$mQ.Uri,$.$mQ.Position],new $.$nQ("A promise that resolves to an array of Location or LocationLink instances.",f)),new $.$oQ("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$mQ.Uri,$.$mQ.Position],new $.$nQ("A promise that resolves to an array of Location or LocationLink instances.",f)),new $.$oQ("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$mQ.Uri,$.$mQ.Position],new $.$nQ("A promise that resolves to an array of Location or LocationLink instances.",f)),new $.$oQ("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$mQ.Uri,$.$mQ.Position],new $.$nQ("A promise that resolves to an array of Location-instances.",S(a.location.to))),new $.$oQ("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$mQ.Uri,$.$mQ.Position],new $.$nQ("A promise that resolves to an array of Hover-instances.",S(a.Hover.to))),new $.$oQ("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$mQ.Uri,new $.$mQ("position","A position in a text document",n=>Array.isArray(n)&&n.every(o=>R.$vN.isPosition(o)),n=>n.map(a.Position.from))],new $.$nQ("A promise that resolves to an array of ranges.",n=>n.map(o=>{let s;for(const l of o.reverse())s=new R.$RN(a.Range.to(l),s);return s}))),new $.$oQ("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$mQ.String.with("query","Search string")],new $.$nQ("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(a.WorkspaceSymbol.to))),new $.$oQ("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$mQ.Uri,$.$mQ.Position],new $.$nQ("A promise that resolves to an array of CallHierarchyItem-instances",n=>n.map(a.CallHierarchyItem.to))),new $.$oQ("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$mQ.CallHierarchyItem],new $.$nQ("A promise that resolves to an array of CallHierarchyIncomingCall-instances",n=>n.map(a.CallHierarchyIncomingCall.to))),new $.$oQ("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$mQ.CallHierarchyItem],new $.$nQ("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",n=>n.map(a.CallHierarchyOutgoingCall.to))),new $.$oQ("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$mQ.Uri,$.$mQ.Position],new $.$nQ("A promise that resolves to a range and placeholder text.",n=>{if(n)return{range:a.Range.to(n.range),placeholder:n.text}})),new $.$oQ("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$mQ.Uri,$.$mQ.Position,$.$mQ.String.with("newName","The new symbol name")],new $.$nQ("A promise that resolves to a WorkspaceEdit.",n=>{if(n){if(n.rejectReason)throw new Error(n.rejectReason);return a.WorkspaceEdit.to(n)}})),new $.$oQ("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$mQ.Uri,$.$mQ.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$nQ("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(a.DocumentLink.to))),new $.$oQ("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$mQ.Uri],new $.$nQ("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new R.$NO(n.tokenTypes,n.tokenModifiers)})),new $.$oQ("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$mQ.Uri],new $.$nQ("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const o=(0,A.$zdb)(n);if(o.type==="full")return new R.$PO(o.data,void 0)})),new $.$oQ("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$mQ.Uri,$.$mQ.Range.optional()],new $.$nQ("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new R.$NO(n.tokenTypes,n.tokenModifiers)})),new $.$oQ("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$mQ.Uri,$.$mQ.Range],new $.$nQ("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const o=(0,A.$zdb)(n);if(o.type==="full")return new R.$PO(o.data,void 0)})),new $.$oQ("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$mQ.Uri,$.$mQ.Position,$.$mQ.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$mQ.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$nQ("A promise that resolves to a CompletionList-instance.",(n,o,s)=>{if(!n)return new R.$4N([]);const l=n.suggestions.map(i=>a.CompletionItem.to(i,s));return new R.$4N(l,n.incomplete)})),new $.$oQ("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$mQ.Uri,$.$mQ.Position,$.$mQ.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$nQ("A promise that resolves to SignatureHelp.",n=>{if(n)return a.SignatureHelp.to(n)})),new $.$oQ("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$mQ.Uri,$.$mQ.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$nQ("A promise that resolves to an array of CodeLens-instances.",(n,o,s)=>S(l=>new R.$VN(a.Range.to(l.range),l.command&&s.fromInternal(l.command)))(n))),new $.$oQ("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$mQ.Uri,new $.$mQ("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>R.$wN.isRange(n),n=>R.$xN.isSelection(n)?a.Selection.from(n):a.Range.from(n)),$.$mQ.String.with("kind","Code action kind to return code actions for").optional(),$.$mQ.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$nQ("A promise that resolves to an array of Command-instances.",(n,o,s)=>S(l=>{if(l._isSynthetic){if(!l.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(l.command)}else{const i=new R.$PN(l.title,l.kind?new R.$QN(l.kind):void 0);return l.edit&&(i.edit=a.WorkspaceEdit.to(l.edit)),l.command&&(i.command=s.fromInternal(l.command)),i.isPreferred=l.isPreferred,i}})(n))),new $.$oQ("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$mQ.Uri],new $.$nQ("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(o=>new R.$0N(a.Range.to(o.range),a.Color.to(o.color))):[])),new $.$oQ("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$mQ("color","The color to show and insert",n=>n instanceof R.$9N,a.Color.from),new $.$mQ("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:a.Range.from(n.range)}))],new $.$nQ("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(a.ColorPresentation.to):[])),new $.$oQ("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$mQ.Uri,$.$mQ.Range],new $.$nQ("A promise that resolves to an array of Inlay objects",(n,o,s)=>n.map(a.InlayHint.to.bind(void 0,s)))),new $.$oQ("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$mQ.Uri],new $.$nQ("A promise that resolves to an array of FoldingRange objects",(n,o)=>{if(n)return n.map(a.FoldingRange.to)})),new $.$oQ("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$nQ("A promise that resolves to an array of NotebookContentProvider static info objects.",S(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(o=>a.NotebookExclusiveDocumentPattern.to(o))})))),new $.$oQ("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$mQ.Uri,$.$mQ.Range,new $.$mQ("context","An InlineValueContext",n=>n&&typeof n.frameId=="number"&&n.stoppedLocation instanceof R.$wN,n=>a.InlineValueContext.from(n))],new $.$nQ("A promise that resolves to an array of InlineValue objects",n=>n.map(a.InlineValue.to))),new $.$oQ("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$mQ("uriOrString","Uri-instance or string (only http/https)",n=>C.URI.isUri(n)||typeof n=="string"&&(0,I.$Mg)(n,I.Schemas.http,I.Schemas.https),n=>n),new $.$mQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[a.ViewColumn.from(n),void 0]:[a.ViewColumn.from(n.viewColumn),a.TextEditorOpenOptions.from(n)])).optional(),$.$mQ.String.with("label","").optional()],$.$nQ.Void),new $.$oQ("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$mQ.Uri.with("resource","Resource to open"),$.$mQ.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$mQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[a.ViewColumn.from(n),void 0]:[a.ViewColumn.from(n.viewColumn),a.TextEditorOpenOptions.from(n)])).optional()],$.$nQ.Void),new $.$oQ("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$mQ.Uri.with("left","Left-hand side resource of the diff editor"),$.$mQ.Uri.with("right","Right-hand side resource of the diff editor"),$.$mQ.String.with("title","Human readable title for the diff editor").optional(),new $.$mQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[a.ViewColumn.from(n.viewColumn),a.TextEditorOpenOptions.from(n)]).optional()],$.$nQ.Void),new $.$oQ("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$mQ.String.with("title","Human readable title for the changes editor"),new $.$mQ("resourceList","List of resources to compare",n=>{for(const o of n){if(o.length!==3)return!1;const[s,l,i]=o;if(!C.URI.isUri(s)||!C.URI.isUri(l)&&l!==void 0&&l!==null||!C.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},n=>n)],$.$nQ.Void),new $.$oQ("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$mQ.Uri,$.$mQ.Position],new $.$nQ("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(a.TypeHierarchyItem.to))),new $.$oQ("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$mQ.TypeHierarchyItem],new $.$nQ("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(a.TypeHierarchyItem.to))),new $.$oQ("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$mQ.TypeHierarchyItem],new $.$nQ("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(a.TypeHierarchyItem.to))),new $.$oQ("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$mQ.TestItem],$.$nQ.Void),new $.$oQ("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$mQ.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$nQ.Void),new $.$oQ("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$mQ.String.with("name","The context key name"),new $.$mQ("value","The context key value",()=>!0,n=>n)],$.$nQ.Void),new $.$oQ("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$mQ.Uri,$.$mQ.StringArray,new $.$mQ("MappedEditsContext","Mapped Edits Context",n=>a.MappedEditsContext.is(n),n=>a.MappedEditsContext.from(n))],new $.$nQ("A promise that resolves to a workspace edit or null",n=>n?a.WorkspaceEdit.to(n):null)),new $.$oQ("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$mQ("Run arguments","",n=>!0,n=>{if(n)return{initialRange:n.initialRange?a.Range.from(n.initialRange):void 0,initialSelection:R.$xN.isSelection(n.initialSelection)?a.Selection.from(n.initialSelection):void 0,message:n.message,autoSend:n.autoSend,position:n.position?a.Position.from(n.position):void 0}})],$.$nQ.Void)];class c{static register(o){y.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",T.$Bj)}}e.$woc=c;function S(n){return o=>{if(Array.isArray(o))return o.map(n)}}function f(n){if(!Array.isArray(n))return;const o=[];for(const s of n)N.$Gu(s)?o.push(a.DefinitionLink.to(s)):o.push(a.location.to(s));return o}}),define(Ne[256],Oe([1,0,2,33]),function(we,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xpc=void 0;class C{constructor(A,T,$,a,R){this.a=T,this.b=$,this.c=a;const y=new I.$oQ("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new I.$mQ("showOptions","Show Options",c=>!0,c=>c),new I.$mQ("resource","Interactive resource Uri",c=>!0,c=>c),new I.$mQ("controllerId","Notebook controller Id",c=>!0,c=>c),new I.$mQ("title","Interactive editor title",c=>!0,c=>c)],new I.$nQ("Notebook and input URI",c=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",c.notebookEditorId),c.notebookEditorId!==void 0){const S=this.a.getEditorById(c.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",S.id),{notebookUri:v.URI.revive(c.notebookUri),inputUri:v.URI.revive(c.inputUri),notebookEditor:S.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",c.notebookUri,c.inputUri),{notebookUri:v.URI.revive(c.notebookUri),inputUri:v.URI.revive(c.inputUri)}}));this.c.registerApiCommand(y)}$willAddInteractiveDocument(A,T,$,a){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:$,uri:A,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(A,T){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$Xpc=C}),define(Ne[257],Oe([1,0,17,10,21,6,4,28,2,18,11,5,33,8,7,82,196,24,38,197]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S,f,n,o,s,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6pc=void 0,e.$7pc=d,S=Ve(S);let r=class{constructor(D,w,k,P,h){this.m=w,this.n=k,this.o=P,this.q=h,this.b=new T.$zc,this.c=new T.$zc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new N.$je,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=D.getProxy(y.$sN.MainThreadNotebookKernels);const b=new c.$oQ("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new c.$mQ("options","Select kernel options",O=>!0,O=>{if(O&&"notebookEditor"in O&&"id"in O){const F=this.n.getIdByEditor(O.notebookEditor);return{id:O.id,extension:O.extension,notebookEditorId:F}}else if(O&&"notebookEditor"in O){const F=this.n.getIdByEditor(O.notebookEditor);if(F===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${O.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:F}}return O})],c.$nQ.Void),M=new c.$oQ("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[c.$mQ.Uri],new c.$nQ("A promise that resolves to an array of variables",(O,F)=>O.map(q=>({variable:{name:q.name,value:q.value,expression:q.expression,type:q.type,language:q.language},hasNamedChildren:q.hasNamedChildren,indexedChildrenCount:q.indexedChildrenCount}))));this.o.registerApiCommand(b),this.o.registerApiCommand(M)}createNotebookController(D,w,k,P,h,b){for(const oe of this.j.values())if(oe.controller.id===w&&a.$nn.equals(D.identifier,oe.extensionId))throw new Error(`notebook controller with id '${w}' ALREADY exist`);const M=this.k++,O=this;this.q.trace(`NotebookController[${M}], CREATED by ${D.identifier.value}, ${w}`);const F=()=>console.warn(`NO execute handler from notebook controller '${Y.id}' of extension: '${D.identifier}'`);let q=!1;const B=new N.$je,L=new N.$je,Y={id:d(D.identifier,w),notebookType:k,extensionId:D.identifier,extensionLocation:D.extensionLocation,label:P||D.identifier.value,preloads:b?b.map(S.NotebookRendererScript.from):[]};let Z=h??F,fe,_;this.a.$addKernel(M,Y).catch(oe=>{console.log(oe),q=!0});let ge=0;const se=()=>{if(q)return;const oe=++ge;Promise.resolve().then(()=>{oe===ge&&this.a.$updateKernel(M,Y)})},ae=new T.$zc,$e={get id(){return w},get notebookType(){return Y.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return Y.label},set label(oe){Y.label=oe??D.displayName??D.name,se()},get detail(){return Y.detail??""},set detail(oe){Y.detail=oe,se()},get description(){return Y.description??""},set description(oe){Y.description=oe,se()},get supportedLanguages(){return Y.supportedLanguages},set supportedLanguages(oe){Y.supportedLanguages=oe,se()},get supportsExecutionOrder(){return Y.supportsExecutionOrder??!1},set supportsExecutionOrder(oe){Y.supportsExecutionOrder=oe,se()},get rendererScripts(){return Y.preloads?Y.preloads.map(S.NotebookRendererScript.to):[]},get executeHandler(){return Z},set executeHandler(oe){Z=oe??F},get interruptHandler(){return fe},set interruptHandler(oe){fe=oe,Y.supportsInterrupt=!!oe,se()},set variableProvider(oe){(0,s.$5G)(D,"notebookVariableProvider"),_=oe,Y.hasVariableProvider=!!oe,oe?.onDidChangeVariables(Ce=>O.a.$variablesUpdated(Ce.uri)),se()},get variableProvider(){return _},createNotebookCellExecution(oe){if(q)throw new Error("notebook controller is DISPOSED");if(!ae.has(oe.notebook.uri))throw O.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ae.keys()).map(Ce=>Ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.notebook.uri.toString()}`);return O._createNotebookCellExecution(oe,d(D.identifier,this.id))},createNotebookExecution(oe){if((0,s.$5G)(D,"notebookExecution"),q)throw new Error("notebook controller is DISPOSED");if(!ae.has(oe.uri))throw O.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ae.keys()).map(Ce=>Ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.uri.toString()}`);return O._createNotebookExecution(oe,d(D.identifier,this.id))},dispose:()=>{q||(this.q.trace(`NotebookController[${M}], DISPOSED`),q=!0,this.j.delete(M),B.dispose(),L.dispose(),this.a.$removeKernel(M))},updateNotebookAffinity(oe,Ce){Ce===f.NotebookControllerAffinity2.Hidden&&(0,s.$5G)(D,"notebookControllerAffinityHidden"),O.a.$updateNotebookPriority(M,oe.uri,Ce)},onDidReceiveMessage:L.event,postMessage(oe,Ce){return(0,s.$5G)(D,"notebookMessaging"),O.a.$postMessage(M,Ce&&O.n.getIdByEditor(Ce),oe)},asWebviewUri(oe){return(0,s.$5G)(D,"notebookMessaging"),(0,n.$eDb)(oe,O.m.remote)}};return this.j.set(M,{extensionId:D.identifier,controller:$e,onDidReceiveMessage:L,onDidChangeSelection:B,associatedNotebooks:ae}),$e}getIdByController(D){for(const[w,k]of this.j)if(k.controller===D)return d(k.extensionId,D.id);return null}createNotebookControllerDetectionTask(D,w){const k=this.g++,P=this;this.q.trace(`NotebookControllerDetectionTask[${k}], CREATED by ${D.identifier.value}`),this.a.$addKernelDetectionTask(k,w);const h={dispose:()=>{this.f.delete(k),P.a.$removeKernelDetectionTask(k)}};return this.f.set(k,h),h}registerKernelSourceActionProvider(D,w,k){const P=this.i++,h=typeof k.onDidChangeNotebookKernelSourceActions=="function"?P:void 0,b=this;this.h.set(P,k),this.q.trace(`NotebookKernelSourceActionProvider[${P}], CREATED by ${D.identifier.value}`),this.a.$addKernelSourceActionProvider(P,P,w);let M;return h!==void 0&&(M=k.onDidChangeNotebookKernelSourceActions(O=>this.a.$emitNotebookKernelSourceActionsChangeEvent(h))),{dispose:()=>{this.h.delete(P),b.a.$removeKernelSourceActionProvider(P,P),M?.dispose()}}}async $provideKernelSourceActions(D,w){const k=this.h.get(D);if(k){const P=new A.$Sc;return(await k.provideNotebookKernelSourceActions(w)??[]).map(b=>S.NotebookKernelSourceAction.from(b,this.o.converter,P))}return[]}$acceptNotebookAssociation(D,w,k){const P=this.j.get(D);if(P){const h=this.n.getNotebookDocument($.URI.revive(w));k?P.associatedNotebooks.set(h.uri,!0):P.associatedNotebooks.delete(h.uri),this.q.trace(`NotebookController[${D}] ASSOCIATE notebook`,h.uri.toString(),k),P.onDidChangeSelection.fire({selected:k,notebook:h.apiNotebook})}}async $executeCells(D,w,k){const P=this.j.get(D);if(!P)return;const h=this.n.getNotebookDocument($.URI.revive(w)),b=[];for(const M of k){const O=h.getCell(M);O&&b.push(O.apiCell)}try{this.q.trace(`NotebookController[${D}] EXECUTE cells`,h.uri.toString(),b.length),await P.controller.executeHandler.call(P.controller,b,h.apiNotebook,P.controller)}catch(M){this.q.error(`NotebookController[${D}] execute cells FAILED`,M),console.error(M)}}async $cancelCells(D,w,k){const P=this.j.get(D);if(!P)return;const h=this.n.getNotebookDocument($.URI.revive(w));if(P.controller.interruptHandler)await P.controller.interruptHandler.call(P.controller,h.apiNotebook);else for(const b of k){const M=h.getCell(b);M&&this.b.get(M.uri)?.cancel()}if(P.controller.interruptHandler){const b=this.c.get(h.uri);this.c.delete(h.uri),k.length&&Array.isArray(b)&&b.length&&b.forEach(M=>M.dispose())}}async $provideVariables(D,w,k,P,h,b,M){const O=this.j.get(D);if(!O)return;const F=this.n.getNotebookDocument($.URI.revive(k)),q=O.controller.variableProvider;if(!q)return;let B;if(P!==void 0){if(B=this.s[P],!B)return}else this.s={};const L=h==="named"?f.NotebookVariablesRequestKind.Named:f.NotebookVariablesRequestKind.Indexed,Y=q.provideVariables(F.apiNotebook,B,L,b,M);let Z=0;for await(const fe of Y){if(M.isCancellationRequested)return;const _={id:this.r++,name:fe.variable.name,value:fe.variable.value,type:fe.variable.type,interfaces:fe.variable.interfaces,language:fe.variable.language,expression:fe.variable.expression,hasNamedChildren:fe.hasNamedChildren,indexedChildrenCount:fe.indexedChildrenCount,extensionId:O.extensionId.value};if(this.s[_.id]=fe.variable,this.a.$receiveVariable(w,_),Z++>=i.$KK)return}}$acceptKernelMessageFromRenderer(D,w,k){const P=this.j.get(D);if(!P)return;const h=this.n.getEditorById(w);P.onDidReceiveMessage.fire(Object.freeze({editor:h.apiEditor,message:k}))}$cellExecutionChanged(D,w,k){const h=this.n.getNotebookDocument($.URI.revive(D)).getCell(w);if(h){const b=k?S.NotebookCellExecutionState.to(k):f.NotebookCellExecutionState.Idle;b!==void 0&&this.l.fire({cell:h.apiCell,state:b})}}_createNotebookCellExecution(D,w){if(D.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const P=this.n.getNotebookDocument(D.notebook.uri).getCellFromApiCell(D);if(!P)throw new Error("invalid cell");if(this.b.has(P.uri))throw new Error(`duplicate execution for ${P.uri}`);const h=new g(w,P,this.a);this.b.set(P.uri,h);const b=h.onDidChangeState(()=>{h.state===t.Resolved&&(h.dispose(),b.dispose(),this.b.delete(P.uri))});return h.asApiObject()}_createNotebookExecution(D,w){const k=this.n.getNotebookDocument(D.uri),P=D.getCells().find(M=>{const O=k.getCellFromApiCell(M);return O&&this.b.has(O.uri)});if(P)throw new Error(`duplicate cell execution for ${P.document.uri}`);if(this.c.has(k.uri))throw new Error(`duplicate notebook execution for ${k.uri}`);const h=new p(w,k,this.a),b=h.onDidChangeState(()=>{h.state===u.Resolved&&(h.dispose(),b.dispose(),this.c.delete(k.uri))});return this.c.set(k.uri,[h,b]),h.asApiObject()}};e.$6pc=r,e.$6pc=r=Qe([qe(4,R.$9j)],r);var t;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(t||(t={}));class g extends A.$Tc{static{this.a=0}get state(){return this.f}constructor(D,w,k){super(),this.m=w,this.n=k,this.b=g.a++,this.c=new N.$je,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new C.$ue),this.h=new m(10,P=>this.s(P)),this.j=w.internalMetadata.executionOrder,this.n.$createExecution(this.b,D,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(D){await this.h.addItem(D)}async s(D){const w=Array.isArray(D)?D:[D];return this.n.$updateExecution(this.b,new l.$Sw(w))}t(){if(this.f===t.Init)throw new Error("Must call start before modifying cell output");if(this.f===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(D){let w=this.m;if(D&&(w=this.m.notebook.getCellFromApiCell(D)),!w)throw new Error("INVALID cell");return w.handle}y(D){return D.map(w=>{const k=f.$1O.ensureUniqueMimeTypes(w.items,!0);return k===w.items?S.NotebookCellOutput.from(w):S.NotebookCellOutput.from({items:k,id:w.id,metadata:w.metadata})})}async z(D,w,k){const P=this.w(w),h=this.y((0,v.$1b)(D));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:P,append:k,outputs:h})}async C(D,w,k){return D=f.$1O.ensureUniqueMimeTypes((0,v.$1b)(D),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:D.map(S.NotebookCellOutputItem.from),outputId:w.id,append:k})}asApiObject(){const D=this;return Object.freeze({get token(){return D.g.token},get cell(){return D.m.apiCell},get executionOrder(){return D.j},set executionOrder(k){D.j=k,D.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:D.j}])},start(k){if(D.f===t.Resolved||D.f===t.Started)throw new Error("Cannot call start again");D.f=t.Started,D.c.fire(),D.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:k})},end(k,P,h){if(D.f===t.Resolved)throw new Error("Cannot call resolve twice");D.f=t.Resolved,D.c.fire(),D.h.flush();const b=h?{message:h.message,stack:h.stack,location:h?.location?{startLineNumber:h.location.start.line,startColumn:h.location.start.character,endLineNumber:h.location.end.line,endColumn:h.location.end.character}:void 0,uri:h.uri}:void 0;D.n.$completeExecution(D.b,new l.$Sw({runEndTime:P,lastRunSuccess:k,error:b}))},clearOutput(k){return D.t(),D.z([],k,!1)},appendOutput(k,P){return D.t(),D.z(k,P,!0)},replaceOutput(k,P){return D.t(),D.z(k,P,!1)},appendOutputItems(k,P){return D.t(),D.C(k,P,!0)},replaceOutputItems(k,P){return D.t(),D.C(k,P,!1)}})}}var u;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(u||(u={}));class p extends A.$Tc{static{this.a=0}get state(){return this.f}constructor(D,w,k){super(),this.h=w,this.j=k,this.b=p.a++,this.c=new N.$je,this.onDidChangeState=this.c.event,this.f=u.Init,this.g=this.B(new C.$ue),this.j.$createNotebookExecution(this.b,D,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===u.Resolved||this.f===u.Started)throw new Error("Cannot call start again");this.f=u.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===u.Resolved)throw new Error("Cannot call resolve twice");this.f=u.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class m{constructor(D,w){this.f=D,this.g=w,this.a=[],this.b=Date.now()}addItem(D){return this.a.push(D),this.c||(this.c=new I.$Zh,this.b=Date.now(),(0,I.$Dh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const D=this.c;this.c=void 0;const w=this.a;return this.a=[],this.g(w).finally(()=>D.complete())}}function d(E,D){return`${E.value}/${D}`}}),define(Ne[56],Oe([1,0,6,5,3,2,16,4,7,9,13,178,21,37,179,180,34,10,8,33,36]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S,f,n,o,s,l,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bpc=e.$apc=e.$_oc=e.$$oc=void 0,e.$$oc=(0,C.$Ci)("IExtHostTerminalService");class t extends T.$Tc{constructor(h,b,M,O){super(),this.u=h,this._id=b,this.w=M,this.y=O,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new v.$je),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(q=>this.g=q);const F=this;this.value={get name(){return F.y||""},get processId(){return F.b},get creationOptions(){return F.w},get exitStatus(){return F.j},get state(){return F.m},get selection(){return F.n},get shellIntegration(){return F.shellIntegration},sendText(q,B=!0){F.C(),F.u.$sendText(F._id,q,B)},show(q){F.C(),F.u.$show(F._id,q)},hide(){F.C(),F.u.$hide(F._id)},dispose(){F.a||(F.a=!0,F.u.$dispose(F._id))},get dimensions(){if(!(F.f===void 0||F.h===void 0))return{columns:F.f,rows:F.h}}}}dispose(){this.s.fire(),super.dispose()}async create(h,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:h.name,shellPath:h.shellPath??void 0,shellArgs:h.shellArgs??void 0,cwd:h.cwd??b?.cwd??void 0,env:h.env??void 0,icon:D(h.iconPath)??void 0,color:o.ThemeColor.isThemeColor(h.color)?h.color.id:void 0,initialText:h.message??void 0,strictEnv:h.strictEnv??void 0,hideFromUser:h.hideFromUser??void 0,forceShellIntegration:b?.forceShellIntegration??void 0,isFeatureTerminal:b?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:b?.useShellEnvironment??void 0,location:b?.location||this.z(h.location,b?.resolvedExtHostIdentifier),isTransient:h.isTransient??void 0})}async createExtensionTerminal(h,b,M,O,F){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:O,color:o.ThemeColor.isThemeColor(F)?F.id:void 0,location:b?.location||this.z(h,M),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(h,b){return typeof h=="object"?"parentTerminal"in h&&h.parentTerminal&&b?{parentTerminal:b}:"viewColumn"in h?{viewColumn:l.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus}:void 0:h}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(h){this.y=h}setExitStatus(h,b){this.j=Object.freeze({code:h,reason:b})}setDimensions(h,b){return h===this.f&&b===this.h||h===0||b===0?!1:(this.f=h,this.h=b,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(h){this.n=h}_setProcessId(h){this.g?(this.g(h),this.g=void 0):this.b.then(b=>{b!==h&&(this.b=Promise.resolve(h))})}}e.$_oc=t;class g{get onProcessReady(){return this.b.event}constructor(h){this.g=h,this.id=0,this.shouldPersist=!1,this.a=new v.$je,this.onProcessData=this.a.event,this.b=new v.$je,this.d=new v.$je,this.onDidChangeProperty=this.d.event,this.f=new v.$je,this.onProcessExit=this.f.event}refreshProperty(h){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${h}`)}updateProperty(h,b){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${h}, value: ${b}`)}async start(){}shutdown(){this.g.close()}input(h){this.g.handleInput?.(h)}resize(h,b){this.g.setDimensions?.({columns:h,rows:b})}clearBuffer(){}async processBinary(h){}acknowledgeDataEvent(h){}async setUnicodeVersion(h){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(h){this.g.onDidWrite(b=>this.a.fire(b)),this.g.onDidClose?.((b=void 0)=>{this.f.fire(b===void 0?void 0:b)}),this.g.onDidOverrideDimensions?.(b=>{b&&this.d.fire({type:f.ProcessPropertyType.OverrideDimensions,value:{cols:b.columns,rows:b.rows}})}),this.g.onDidChangeName?.(b=>{this.d.fire({type:f.ProcessPropertyType.Title,value:b})}),this.g.open(h||void 0),h&&this.g.setDimensions?.(h),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let u=1,p=class extends T.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(h=>h.value)}constructor(h,b,M){super(),this.Q=b,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new T.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new v.$je,this.onDidCloseTerminal=this.H.event,this.I=new v.$je,this.onDidOpenTerminal=this.I.event,this.J=new v.$je,this.onDidChangeActiveTerminal=this.J.event,this.L=new v.$je,this.onDidChangeTerminalDimensions=this.L.event,this.M=new v.$je,this.onDidChangeTerminalState=this.M.event,this.N=new v.$je,this.onDidChangeShell=this.N.event,this.O=new v.$je({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new v.$je({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=M.getProxy(I.$sN.MainThreadTerminalService),this.y=new n.$vxb(this.a.$sendProcessData),this.a.$registerProcessSupport(h),this.Q.registerArgumentProcessor({processArgument:O=>{const F=q=>{const B=q;return this.getTerminalById(B.instanceId)?.value};switch(O?.$mid){case r.MarshalledId.TerminalContext:return F(O);default:{if(Array.isArray(O))for(let q=0;q<O.length&&O[q].$mid===r.MarshalledId.TerminalContext;q++)O[q]=F(O[q]);return O}}}}),this.B({dispose:()=>{for(const[O,F]of this.g)F.shutdown(!0)}})}getDefaultShell(h){return(h?this.u:this.s)?.path||""}getDefaultShellArgs(h){return(h?this.u:this.s)?.args||[]}createExtensionTerminal(h,b){const M=new t(this.a,(0,S.$Yg)(),h,h.name),O=new g(h.pty);return M.createExtensionTerminal(h.location,b,this.R(h,b).resolvedExtHostIdentifier,D(h.iconPath),w(h.color)).then(F=>{const q=this.S(F,O);this.h[F]=q}),this.f.push(M),M.value}R(h,b){if(b=b||{},h.location&&typeof h.location=="object"&&"parentTerminal"in h.location){const M=h.location.parentTerminal;if(M){const O=this.f.find(F=>F.value===M);O&&(b.resolvedExtHostIdentifier=O._id)}}else h.location&&typeof h.location!="object"?b.location=h.location:b.location&&typeof b.location=="object"&&"splitActiveTerminal"in b.location&&(b.location={splitActiveTerminal:!0});return b}attachPtyToTerminal(h,b){if(!this.getTerminalById(h))throw new Error(`Cannot resolve terminal with id ${h} for virtual process`);const O=new g(b),F=this.S(h,O);this.h[h]=F}async $acceptActiveTerminalChanged(h){const b=this.b;if(h===null){this.b=void 0,b!==this.b&&this.J.fire(this.b);return}const M=this.getTerminalById(h);M&&(this.b=M,b!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(h,b){const M=this.getTerminalById(h);M&&this.O.fire({terminal:M.value,data:b})}async $acceptTerminalDimensions(h,b,M){const O=this.getTerminalById(h);O&&O.setDimensions(b,M)&&this.L.fire({terminal:O.value,dimensions:O.value.dimensions})}async $acceptDidExecuteCommand(h,b){const M=this.getTerminalById(h);M&&this.P.fire({terminal:M.value,...b})}async $acceptTerminalMaximumDimensions(h,b,M){this.g.get(h)?.resize(b,M)}async $acceptTerminalTitleChange(h,b){const M=this.getTerminalById(h);M&&(M.name=b)}async $acceptTerminalClosed(h,b,M){const O=this.X(this.f,h);if(O!==null){const F=this.f.splice(O,1)[0];F.setExitStatus(b,M),this.H.fire(F.value)}}$acceptTerminalOpened(h,b,M,O){if(b){const B=this.X(this.f,b);if(B!==null){this.f[B]._id=h,this.I.fire(this.terminals[B]),this.f[B].isOpen=!0;return}}const F={name:O.name,shellPath:O.executable,shellArgs:O.args,cwd:typeof O.cwd=="string"?O.cwd:N.URI.revive(O.cwd),env:O.env,hideFromUser:O.hideFromUser},q=new t(this.a,h,F,M);this.f.push(q),this.I.fire(q.value),q.isOpen=!0}async $acceptTerminalProcessId(h,b){this.getTerminalById(h)?._setProcessId(b)}async $startExtensionTerminal(h,b){const M=this.getTerminalById(h);if(!M)return{message:(0,a.localize)(10659,null,h)};M.isOpen||await new Promise(F=>{const q=this.onDidOpenTerminal(async B=>{B===M.value&&(q.dispose(),F())})});const O=this.g.get(h);O?O.startSendingEvents(b):this.j[h]={initialDimensions:b}}S(h,b){const M=new T.$Sc;M.add(b.onProcessReady(F=>this.a.$sendProcessReady(h,F.pid,F.cwd,F.windowsPty))),M.add(b.onDidChangeProperty(F=>this.a.$sendProcessProperty(h,F))),this.y.startBuffering(h,b.onProcessData),M.add(b.onProcessExit(F=>this.U(h,F))),this.g.set(h,b);const O=this.j[h];return O&&b instanceof g&&(b.startSendingEvents(O.initialDimensions),delete this.j[h]),M}$acceptProcessAckDataEvent(h,b){this.g.get(h)?.acknowledgeDataEvent(b)}$acceptProcessInput(h,b){this.g.get(h)?.input(b)}$acceptTerminalInteraction(h){const b=this.getTerminalById(h);b?.setInteractedWith()&&this.M.fire(b.value)}$acceptTerminalSelection(h,b){this.getTerminalById(h)?.setSelection(b)}$acceptProcessResize(h,b,M){try{this.g.get(h)?.resize(b,M)}catch(O){if(O.code!=="EPIPE"&&O.code!=="ERR_IPC_CHANNEL_CLOSED")throw O}}$acceptProcessShutdown(h,b){this.g.get(h)?.shutdown(b)}$acceptProcessRequestInitialCwd(h){this.g.get(h)?.getInitialCwd().then(b=>this.a.$sendProcessProperty(h,{type:f.ProcessPropertyType.InitialCwd,value:b}))}$acceptProcessRequestCwd(h){this.g.get(h)?.getCwd().then(b=>this.a.$sendProcessProperty(h,{type:f.ProcessPropertyType.Cwd,value:b}))}$acceptProcessRequestLatency(h){return Promise.resolve(h)}registerLinkProvider(h){return this.z.add(h),this.z.size===1&&this.a.$startLinkProvider(),new $.$uN(()=>{this.z.delete(h),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(h,b,M){if(this.C.has(b))throw new Error(`Terminal profile provider "${b}" already registered`);return this.C.set(b,M),this.a.$registerProfileProvider(b,h.identifier.value),new $.$uN(()=>{this.C.delete(b),this.a.$unregisterProfileProvider(b)})}registerTerminalQuickFixProvider(h,b,M){if(this.D.has(h))throw new Error(`Terminal quick fix provider "${h}" is already registered`);return this.D.set(h,M),this.a.$registerQuickFixProvider(h,b),new $.$uN(()=>{this.D.delete(h),this.a.$unregisterQuickFixProvider(h)})}async $provideTerminalQuickFixes(h,b){const M=new c.$ue().token;if(M.isCancellationRequested)return;const O=this.D.get(h);if(!O)return;const F=await O.provideTerminalQuickFixes(b,M);if(F===null||Array.isArray(F)&&F.length===0)return;const q=new T.$Sc;if(this.w.value=q,!Array.isArray(F))return F?l.TerminalQuickFix.from(F,this.Q.converter,q):void 0;const B=[];for(const L of F){const Y=l.TerminalQuickFix.from(L,this.Q.converter,q);Y&&B.push(Y)}return B}async $createContributedProfileTerminal(h,b){const M=new c.$ue().token;let O=await this.C.get(h)?.provideTerminalProfile(M);if(!M.isCancellationRequested){if(O&&!("options"in O)&&(O={options:O}),!O||!("options"in O))throw new Error(`No terminal profile options provided for id "${h}"`);if("pty"in O.options){this.createExtensionTerminal(O.options,b);return}this.createTerminalFromOptions(O.options,b)}}async $provideLinks(h,b){const M=this.getTerminalById(h);if(!M)return[];this.F.delete(h),this.G.get(h)?.dispose(!0);const F=new c.$ue;this.G.set(h,F);const q=[],B={terminal:M.value,line:b},L=[];for(const fe of this.z)L.push(s.Promises.withAsyncBody(async _=>{F.token.onCancellationRequested(()=>_({provider:fe,links:[]}));const ge=await fe.provideTerminalLinks(B,F.token)||[];F.token.isCancellationRequested||_({provider:fe,links:ge})}));const Y=await Promise.all(L);if(F.token.isCancellationRequested)return[];const Z=new Map;for(const fe of Y)fe&&fe.links.length>0&&q.push(...fe.links.map(_=>{const ge={id:u++,startIndex:_.startIndex,length:_.length,label:_.tooltip};return Z.set(ge.id,{provider:fe.provider,link:_}),ge}));return this.F.set(h,Z),q}$activateLink(h,b){const M=this.F.get(h)?.get(b);M&&M.provider.handleTerminalLink(M.link)}U(h,b){this.y.stopBuffering(h),this.g.delete(h),delete this.j[h];const M=this.h[h];M&&(M.dispose(),delete this.h[h]),this.a.$sendProcessExit(h,b)}getTerminalById(h){return this.W(this.f,h)}getTerminalIdByApiObject(h){const b=this.f.findIndex(M=>M.value===h);return b>=0?b:null}W(h,b){const M=this.X(h,b);return M!==null?h[M]:null}X(h,b){const M=h.findIndex(O=>O._id===b);return M>=0?M:null}getEnvironmentVariableCollection(h){let b=this.n.get(h.identifier.value);return b||(b=this.B(new m),this.Z(h.identifier.value,b)),b.getScopedEnvironmentVariableCollection(void 0)}Y(h,b){const M=(0,y.$Bs)(b.map),O=(0,y.$Cs)(b.descriptionMap);this.a.$setEnvironmentVariableCollection(h,b.persistent,M.length===0?void 0:M,O)}$initEnvironmentVariableCollections(h){h.forEach(b=>{const M=b[0],O=this.B(new m(b[1]));this.Z(M,O)})}$acceptDefaultProfile(h,b){const M=this.s;this.s=h,this.u=b,M?.path!==h.path&&this.N.fire(h.path)}Z(h,b){this.n.set(h,b),this.B(b.onDidChangeCollection(()=>{this.Y(h,b)}))}};e.$apc=p,e.$apc=p=Qe([qe(1,i.$kQ),qe(2,A.$1P)],p);class m extends T.$Tc{get persistent(){return this.b}set persistent(h){this.b=h,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(h){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new v.$je,this.map=new Map(h)}getScopedEnvironmentVariableCollection(h){const b=this.j(h);let M=this.a.get(b);return M||(M=new d(this,h),this.a.set(b,M),this.B(M.onDidChangeCollection(()=>this.f.fire()))),M}replace(h,b,M,O){this.g(h,{value:b,type:$.EnvironmentVariableMutatorType.Replace,options:M??{applyAtProcessCreation:!0},scope:O})}append(h,b,M,O){this.g(h,{value:b,type:$.EnvironmentVariableMutatorType.Append,options:M??{applyAtProcessCreation:!0},scope:O})}prepend(h,b,M,O){this.g(h,{value:b,type:$.EnvironmentVariableMutatorType.Prepend,options:M??{applyAtProcessCreation:!0},scope:O})}g(h,b){if(b.options&&b.options.applyAtProcessCreation===!1&&!b.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const M=this.h(h,b.scope),O=this.map.get(M),F=b.options?{applyAtProcessCreation:b.options.applyAtProcessCreation??!1,applyAtShellIntegration:b.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!O||O.value!==b.value||O.type!==b.type||O.options?.applyAtProcessCreation!==F.applyAtProcessCreation||O.options?.applyAtShellIntegration!==F.applyAtShellIntegration||O.scope?.workspaceFolder?.index!==b.scope?.workspaceFolder?.index){const q=this.h(h,b.scope),B={variable:h,...b,options:F};this.map.set(q,B),this.f.fire()}}get(h,b){const M=this.h(h,b),O=this.map.get(M);return O?k(O):void 0}h(h,b){const M=this.j(b);return M.length?`${h}:::${M}`:h}j(h){return this.m(h?.workspaceFolder)??""}m(h){return h?h.uri.toString():void 0}getVariableMap(h){const b=new Map;for(const[M,O]of this.map)this.j(O.scope)===this.j(h)&&b.set(O.variable,k(O));return b}delete(h,b){const M=this.h(h,b);this.map.delete(M),this.f.fire()}clear(h){if(h?.workspaceFolder){for(const[b,M]of this.map)M.scope?.workspaceFolder?.index===h.workspaceFolder.index&&this.map.delete(b);this.n(h)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(h,b){const M=this.j(b),O=this.descriptionMap.get(M);if(!O||O.description!==h){let F;typeof h=="string"?F=h:F=h?.value.split(`

`)[0];const q={description:F,scope:b};this.descriptionMap.set(M,q),this.f.fire()}}getDescription(h){const b=this.j(h);return this.descriptionMap.get(b)?.description}n(h){const b=this.j(h);this.descriptionMap.delete(b)}}class d{get persistent(){return this.b.persistent}set persistent(h){this.b.persistent=h}get onDidChangeCollection(){return this.a&&this.a.event}constructor(h,b){this.b=h,this.d=b,this.a=new v.$je}getScoped(h){return this.b.getScopedEnvironmentVariableCollection(h)}replace(h,b,M){this.b.replace(h,b,M,this.d)}append(h,b,M){this.b.append(h,b,M,this.d)}prepend(h,b,M){this.b.prepend(h,b,M,this.d)}get(h){return this.b.get(h,this.d)}forEach(h,b){this.b.getVariableMap(this.d).forEach((M,O)=>h.call(b,O,M,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(h){this.b.delete(h,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(h){this.b.setDescription(h,this.d)}get description(){return this.b.getDescription(this.d)}}let E=class extends p{constructor(h,b){super(!1,h,b)}createTerminal(h,b,M){throw new R.$$}createTerminalFromOptions(h,b){throw new R.$$}};e.$bpc=E,e.$bpc=E=Qe([qe(0,i.$kQ),qe(1,A.$1P)],E);function D(P){if(!(!P||typeof P=="string"))return"id"in P?{id:P.id,color:P.color}:P}function w(P){return o.ThemeColor.isThemeColor(P)?P:void 0}function k(P){const h={...P};return delete h.scope,h.options=h.options??void 0,delete h.variable,h}}),define(Ne[126],Oe([1,0,7,4,3,5,16,56,6,2,10]),function(we,e,v,I,C,N,A,T,$,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mqc=e.$lqc=void 0,e.$lqc=(0,C.$Ci)("IExtHostTerminalShellIntegration");let y=class extends I.$Tc{constructor(o,s){super(),this.h=s,this.b=new Map,this.c=new $.$je,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new $.$je,this.onDidStartTerminalShellExecution=this.f.event,this.g=new $.$je,this.onDidEndTerminalShellExecution=this.g.event,this.a=o.getProxy(N.$sN.MainThreadTerminalShellIntegration),this.B((0,I.$Rc)(()=>{for(const[l,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(o){const s=this.h.getTerminalById(o);if(!s)return;const l=s.value;let i=this.b.get(o);i||(i=new c(s.value,this.f),this.b.set(o,i),i.store.add(s.onWillDispose(()=>this.b.get(o)?.dispose())),i.store.add(i.onDidRequestShellExecution(r=>this.a.$executeCommand(o,r))),i.store.add(i.onDidRequestEndExecution(r=>this.g.fire(r))),i.store.add(i.onDidRequestChangeShellIntegration(r=>this.c.fire(r))),s.shellIntegration=i.value),this.c.fire({terminal:l,shellIntegration:i.value})}$shellExecutionStart(o,s,l,i,r){this.b.has(o)||this.$shellIntegrationChange(o);const t={value:s,confidence:l,isTrusted:i};this.b.get(o)?.startShellExecution(t,r)}$shellExecutionEnd(o,s,l,i,r){const t={value:s,confidence:l,isTrusted:i};this.b.get(o)?.endShellExecution(t,r)}$shellExecutionData(o,s){this.b.get(o)?.emitData(s)}$cwdChange(o,s){this.b.get(o)?.setCwd((0,a.$uc)(s)?a.URI.revive(s):s)}$closeTerminal(o){this.b.get(o)?.dispose(),this.b.delete(o)}};e.$mqc=y,e.$mqc=y=Qe([qe(0,A.$1P),qe(1,T.$$oc)],y);class c extends I.$Tc{get currentExecution(){return this.a}constructor(o,s){super(),this.j=o,this.m=s,this.b=!1,this.store=this.B(new I.$Sc),this.f=this.B(new $.$je),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new $.$je),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new $.$je),this.onDidRequestEndExecution=this.h.event;const l=this;this.value={get cwd(){return l.c},executeCommand(i,r){let t=i;r&&(t+=` "${r.map(p=>`${p.replaceAll('"','\\"')}`).join('" "')}"`),l.g.fire(t);const g={value:t,confidence:v.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},u=l.startShellExecution(g,l.c,!0).value;return l.b=!0,u}}}startShellExecution(o,s,l){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new S(o,s);l?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(o){this.currentExecution?.emitData(o)}endShellExecution(o,s){this.a&&(this.a.endExecution(o),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:s}),this.a=void 0)}setCwd(o){let s=!1;a.URI.isUri(this.c)?s=!a.URI.isUri(o)||this.c.toString()!==o.toString():this.c!==o&&(s=!0),s&&(this.c=o,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class S{constructor(o,s){this.c=o,this.cwd=s,this.b=!1;const l=this;this.value={get commandLine(){return l.c},get cwd(){return l.cwd},read(){return l.d()}}}d(){if(!this.a){if(this.b)return R.$3h.EMPTY;this.a=new f}return this.a.createIterable()}emitData(o){this.a?.emitData(o)}endExecution(o){o&&(this.c=o),this.a?.endExecution(),this.a=void 0,this.b=!0}}class f extends I.$Tc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new R.$Bh);const o=this.a;return new R.$3h(async l=>{this.b.push(l),await o.wait()})}emitData(o){for(const s of this.b)s.emitOne(o)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Ne[127],Oe([1,0,61,13,96,8,7]),function(we,e,v,I,C,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0P=e.$9P=e.$8P=void 0,N=Ve(N);class T{static{this.c=new C.$6P("TextEditorDecorationType")}constructor(c,S,f){const n=T.c.nextId();c.$registerTextEditorDecorationType(S.identifier,n,N.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:n,dispose(){c.$removeTextEditorDecorationType(n)}})}}e.$8P=T;class ${constructor(c,S){this.g=[],this.h=void 0,this.j=!1,this.c=c,this.d=c.version,this.e=S.undoStopBefore,this.f=S.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(c,S){this.k();let f=null;if(c instanceof A.$vN)f=new A.$wN(c,c);else if(c instanceof A.$wN)f=c;else throw new Error("Unrecognized location");this.l(f,S,!1)}insert(c,S){this.k(),this.l(new A.$wN(c,c),S,!0)}delete(c){this.k();let S=null;if(c instanceof A.$wN)S=c;else throw new Error("Unrecognized location");this.l(S,null,!0)}l(c,S,f){const n=this.c.validateRange(c);this.g.push({range:n,text:S,forceMoveMarkers:f})}setEndOfLine(c){if(this.k(),c!==A.EndOfLine.LF&&c!==A.EndOfLine.CRLF)throw(0,I.$6)("endOfLine");this.h=c}}class a{constructor(c,S,f,n){this.c=c,this.d=S,this._accept(f),this.e=n;const o=this;this.value={get tabSize(){return o.f},set tabSize(s){o.n(s)},get indentSize(){return o.g},set indentSize(s){o.p(s)},get insertSpaces(){return o.j},set insertSpaces(s){o.s(s)},get cursorStyle(){return o.k},set cursorStyle(s){o.t(s)},get lineNumbers(){return o.l},set lineNumbers(s){o.u(s)}}}_accept(c){this.f=c.tabSize,this.g=c.indentSize,this.h=c.originalIndentSize,this.j=c.insertSpaces,this.k=c.cursorStyle,this.l=N.TextEditorLineNumbersStyle.to(c.lineNumbers)}m(c){if(c==="auto")return"auto";if(typeof c=="number"){const S=Math.floor(c);return S>0?S:null}if(typeof c=="string"){const S=parseInt(c,10);return isNaN(S)?null:S>0?S:null}return null}n(c){const S=this.m(c);if(S!==null){if(typeof S=="number"){if(this.f===S)return;this.f=S}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:S}))}}o(c){if(c==="tabSize")return"tabSize";if(typeof c=="number"){const S=Math.floor(c);return S>0?S:null}if(typeof c=="string"){const S=parseInt(c,10);return isNaN(S)?null:S>0?S:null}return null}p(c){const S=this.o(c);if(S!==null){if(typeof S=="number"){if(this.h===S)return;this.g=S,this.h=S}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:S}))}}q(c){return c==="auto"?"auto":c==="false"?!1:!!c}s(c){const S=this.q(c);if(typeof S=="boolean"){if(this.j===S)return;this.j=S}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:S}))}t(c){this.k!==c&&(this.k=c,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:c})))}u(c){this.l!==c&&(this.l=c,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:N.TextEditorLineNumbersStyle.from(c)})))}assign(c){const S={};let f=!1;if(typeof c.tabSize<"u"){const n=this.m(c.tabSize);n==="auto"?(f=!0,S.tabSize=n):typeof n=="number"&&this.f!==n&&(this.f=n,f=!0,S.tabSize=n)}if(typeof c.indentSize<"u"){const n=this.o(c.indentSize);n==="tabSize"?(f=!0,S.indentSize=n):typeof n=="number"&&this.h!==n&&(this.g=n,this.h=n,f=!0,S.indentSize=n)}if(typeof c.insertSpaces<"u"){const n=this.q(c.insertSpaces);n==="auto"?(f=!0,S.insertSpaces=n):this.j!==n&&(this.j=n,f=!0,S.insertSpaces=n)}typeof c.cursorStyle<"u"&&this.k!==c.cursorStyle&&(this.k=c.cursorStyle,f=!0,S.cursorStyle=c.cursorStyle),typeof c.lineNumbers<"u"&&this.l!==c.lineNumbers&&(this.l=c.lineNumbers,f=!0,S.lineNumbers=N.TextEditorLineNumbersStyle.from(c.lineNumbers)),f&&this.v("setOptions",this.c.$trySetOptions(this.d,S))}v(c,S){S.catch(f=>{this.e.warn(`ExtHostTextEditorOptions '${c}' failed:'`),this.e.warn(f)})}}e.$9P=a;class R{constructor(c,S,f,n,o,s,l,i){this.id=c,this.j=S,this.k=f,this.g=!1,this.h=new Set,this.c=o,this.d=new a(this.j,this.id,s,f),this.e=l,this.f=i;const r=this;this.value=Object.freeze({get document(){return n.value},set document(t){throw new I.$8("document")},get selection(){return r.c&&r.c[0]},set selection(t){if(!(t instanceof A.$xN))throw(0,I.$6)("selection");r.c=[t],r.l()},get selections(){return r.c},set selections(t){if(!Array.isArray(t)||t.some(g=>!(g instanceof A.$xN)))throw(0,I.$6)("selections");r.c=t,r.l()},get visibleRanges(){return r.e},set visibleRanges(t){throw new I.$8("visibleRanges")},get options(){return r.d.value},set options(t){r.g||r.d.assign(t)},get viewColumn(){return r.f},set viewColumn(t){throw new I.$8("viewColumn")},edit(t,g={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new $(n.value,g);return t(u),r.m(u)},insertSnippet(t,g,u={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let p;if(!g||Array.isArray(g)&&g.length===0)p=r.c.map(m=>N.Range.from(m));else if(g instanceof A.$vN){const{lineNumber:m,column:d}=N.Position.from(g);p=[{startLineNumber:m,startColumn:d,endLineNumber:m,endColumn:d}]}else if(g instanceof A.$wN)p=[N.Range.from(g)];else{p=[];for(const m of g)if(m instanceof A.$wN)p.push(N.Range.from(m));else{const{lineNumber:d,column:E}=N.Position.from(m);p.push({startLineNumber:d,startColumn:E,endLineNumber:d,endColumn:E})}}return S.$tryInsertSnippet(c,n.value.version,t.value,p,u)},setDecorations(t,g){const u=g.length===0;u&&!r.h.has(t.key)||(u?r.h.delete(t.key):r.h.add(t.key),r.n(()=>{if(N.$XP(g))return S.$trySetDecorations(c,t.key,N.$YP(g));{const p=new Array(4*g.length);for(let m=0,d=g.length;m<d;m++){const E=g[m];p[4*m]=E.start.line+1,p[4*m+1]=E.start.character+1,p[4*m+2]=E.end.line+1,p[4*m+3]=E.end.character+1}return S.$trySetDecorationsFast(c,t.key,p)}}))},revealRange(t,g){r.n(()=>S.$tryRevealRange(c,N.Range.from(t),g||A.TextEditorRevealType.Default))},show(t){S.$tryShowEditor(c,N.ViewColumn.from(t))},hide(){S.$tryHideEditor(c)}})}dispose(){(0,v.ok)(!this.g),this.g=!0}_acceptOptions(c){(0,v.ok)(!this.g),this.d._accept(c)}_acceptVisibleRanges(c){(0,v.ok)(!this.g),this.e=c}_acceptViewColumn(c){(0,v.ok)(!this.g),this.f=c}_acceptSelections(c){(0,v.ok)(!this.g),this.c=c}async l(){const c=this.c.map(N.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,c)),this.value}m(c){const S=c.finalize();if(S.edits.length===0&&!S.setEndOfLine)return Promise.resolve(!0);const f=S.edits.map(o=>o.range);f.sort((o,s)=>o.end.line===s.end.line?o.end.character===s.end.character?o.start.line===s.start.line?o.start.character-s.start.character:o.start.line-s.start.line:o.end.character-s.end.character:o.end.line-s.end.line);for(let o=0,s=f.length-1;o<s;o++){const l=f[o].end;if(f[o+1].start.isBefore(l))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const n=S.edits.map(o=>({range:N.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,S.documentVersionId,n,{setEndOfLine:typeof S.setEndOfLine=="number"?N.EndOfLine.from(S.setEndOfLine):void 0,undoStopBefore:S.undoStopBefore,undoStopAfter:S.undoStopAfter})}n(c){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,S=>(S instanceof Error&&S.name==="DISPOSED"||this.k.warn(S),null))}}e.$0P=R}),define(Ne[57],Oe([1,0,61,6,4,2,3,5,123,16,127,8,11,28,15,39,48]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S,f,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_P=e.$$P=void 0,v=Ve(v),y=Ve(y);class s{constructor(r){this.value=r,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let l=class{constructor(r,t){this.h=r,this.i=t,this.a=null,this.b=new Map,this.c=new S.$zc,this.d=new I.$je,this.e=new I.$je,this.f=new I.$je,this.g=new I.$je,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const t=[],g=[],u=[];if(r.removedDocuments)for(const p of r.removedDocuments){const m=N.URI.revive(p),d=this.c.get(m);d?.unref()&&(this.c.delete(m),t.push(d.value))}if(r.addedDocuments)for(const p of r.addedDocuments){const m=N.URI.revive(p.uri);let d=this.c.get(m);if(d&&m.scheme!==f.Schemas.vscodeNotebookCell&&m.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${m} already exists!'`);d||(d=new s(new $.$4P(this.h.getProxy(T.$sN.MainThreadDocuments),m,p.lines,p.EOL,p.versionId,p.languageId,p.isDirty)),this.c.set(m,d),g.push(d.value)),d.ref()}if(r.removedEditors)for(const p of r.removedEditors){const m=this.b.get(p);this.b.delete(p),m&&u.push(m)}if(r.addedEditors)for(const p of r.addedEditors){const m=N.URI.revive(p.documentUri);v.ok(this.c.has(m),`document '${m}' does not exist`),v.ok(!this.b.has(p.id),`editor '${p.id}' already exists!`);const d=this.c.get(m).value,E=new R.$0P(p.id,this.h.getProxy(T.$sN.MainThreadTextEditors),this.i,new o.$T(()=>d.document),p.selections.map(y.Selection.to),p.options,p.visibleRanges.map(D=>y.Range.to(D)),typeof p.editorPosition=="number"?y.ViewColumn.to(p.editorPosition):void 0);this.b.set(p.id,E)}r.newActiveEditor!==void 0&&(v.ok(r.newActiveEditor===null||this.b.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this.a=r.newActiveEditor),(0,C.$Oc)(t),(0,C.$Oc)(u),r.removedDocuments&&this.e.fire(t),r.addedDocuments&&this.d.fire(g),(r.removedEditors||r.addedEditors)&&this.f.fire(this.allEditors().map(p=>p.value)),r.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(r){return this.c.get(r)?.value}allDocuments(){return n.Iterable.map(this.c.values(),r=>r.value)}getEditor(r){return this.b.get(r)}activeEditor(r){if(!this.a)return;const t=this.b.get(this.a);return r?t:t?.value}allEditors(){return[...this.b.values()]}};e.$$P=l,e.$$P=l=Qe([qe(0,a.$1P),qe(1,c.$9j)],l),e.$_P=(0,A.$Ci)("IExtHostDocumentsAndEditors")}),define(Ne[95],Oe([1,0,10,22,21,6,230,75,4,36,14,37,3,11,5,33,57,16,125,8,7,199,54,81,55,24]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S,f,n,o,s,l,i,r,t,g,u,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wpc=e.$vpc=e.$upc=e.$tpc=e.$spc=void 0,i=Ve(i);let d=0;const E=new WeakMap;e.$spc=(0,c.$Ci)("IExtHostTesting");let D=class extends $.$Tc{constructor(_,ge,se,ae){super(),this.C=ge,this.D=se,this.F=ae,this.f=this.B(new N.$je),this.g=new Map,this.w=this.B(new N.$je),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=_.getProxy(f.$sN.MainThreadTesting),this.m=new q(this.h),this.j=new h(this.h,ge),se.registerArgumentProcessor({processArgument:$e=>{switch($e?.$mid){case a.MarshalledId.TestItemContext:{const oe=$e,Ce=oe.tests[oe.tests.length-1].item.extId;return this.g.get(g.$RI.root(Ce))?.collection.tree.get(Ce)?.actual??(0,l.$aQ)($e)}case a.MarshalledId.TestMessageMenuArgs:{const{test:oe,message:Ce}=$e,Fe=oe.item.extId;return{test:this.g.get(g.$RI.root(Fe))?.collection.tree.get(Fe)?.actual??(0,l.$aQ)({$mid:a.MarshalledId.TestItemContext,tests:[oe]}),message:i.TestMessage.to(Ce)}}default:return $e}}}),se.registerCommand(!1,"testing.getExplorerSelection",async()=>{const $e=await se.executeCommand(t.TestCommandId.GetExplorerSelection),oe=Ce=>{const Fe=this.g.get(g.$RI.root(Ce));if(Fe)return g.$RI.isRoot(Ce)?Fe.controller:Fe.collection.tree.get(Ce)?.actual};return{include:$e?.include.map(oe).filter(R.$kg)||[],exclude:$e?.exclude.map(oe).filter(R.$kg)||[]}})}createTestController(_,ge,se,ae){if(this.g.has(ge))throw new Error(`Attempt to insert a duplicate controller with ID "${ge}"`);const $e=new $.$Sc,oe=$e.add(new l.$dQ(ge,se,this.F));oe.root.label=se;const Ce=new Map,Fe=new Set,X=this.h,V={items:oe.root.children,get label(){return se},set label(ve){se=ve,oe.root.label=ve,X.$updateController(ge,{label:se})},get refreshHandler(){return ae},set refreshHandler(ve){ae=ve,X.$updateController(ge,{canRefresh:!!ve})},get id(){return ge},createRunProfile:(ve,ce,be,he,J,x)=>{let me=(0,T.$qj)(ve);for(;Ce.has(me);)me++;return new L(this.h,Ce,Fe,this.w.event,ge,me,ve,ce,be,he,J,x)},createTestItem(ve,ce,be){return new l.$bQ(ge,ve,ce,be)},createTestRun:(ve,ce,be=!0)=>this.j.createTestRun(_,ge,oe,ve,ce,be),invalidateTestResults:ve=>{if(ve===void 0)this.h.$markTestRetired(void 0);else{const ce=ve instanceof Array?ve:[ve];this.h.$markTestRetired(ce.map(be=>g.$RI.fromExtHostTestItem(be,ge).toString()))}},set resolveHandler(ve){oe.resolveHandler=ve},get resolveHandler(){return oe.resolveHandler},dispose:()=>{$e.dispose()}};X.$registerTestController(ge,se,!!ae),$e.add((0,$.$Rc)(()=>X.$unregisterTestController(ge)));const te={controller:V,collection:oe,profiles:Ce,extension:_,activeProfiles:Fe};return this.g.set(ge,te),$e.add((0,$.$Rc)(()=>this.g.delete(ge))),$e.add(oe.onDidGenerateDiff(ve=>X.$publishDiff(ge,ve.map(p.TestsDiffOp.serialize)))),V}createTestObserver(){return this.m.checkout()}async runTests(_,ge=C.CancellationToken.None){const se=b(_);if(!se)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ae=this.g.get(se.controllerId);if(!ae)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:_.preserveFocus??!0,group:Y[se.kind],targets:[{testIds:_.include?.map($e=>g.$RI.fromExtHostTestItem($e,ae.collection.root.id).toString())??[ae.collection.root.id],profileId:se.profileId,controllerId:se.controllerId}],exclude:_.exclude?.map($e=>$e.id)},ge)}registerTestFollowupProvider(_){return this.y.add(_),{dispose:()=>{this.y.delete(_)}}}$syncTests(){for(const{collection:_}of this.g.values())_.flushDiff();return Promise.resolve()}async $getCoverageDetails(_,ge,se){return(await this.j.getCoverageDetails(_,ge,se))?.map(i.TestCoverage.fromDetails)}async $disposeRun(_){this.j.disposeTestRun(_)}$configureRunProfile(_,ge){this.g.get(_)?.profiles.get(ge)?.configureHandler?.()}$setDefaultRunProfiles(_){const ge=new Map;for(const[se,ae]of Object.entries(_)){const $e=this.g.get(se);if(!$e)continue;const oe=new Map,Ce=ae.filter(X=>!$e.activeProfiles.has(X)),Fe=[...$e.activeProfiles].filter(X=>!ae.includes(X));for(const X of Ce)oe.set(X,!0),$e.activeProfiles.add(X);for(const X of Fe)oe.set(X,!1),$e.activeProfiles.delete(X);oe.size&&ge.set(se,oe)}this.w.fire(ge)}async $refreshTests(_,ge){await this.g.get(_)?.controller.refreshHandler?.(ge)}$publishTestResults(_){this.results=Object.freeze(_.map(ge=>{const se=i.TestResults.to(ge);return E.set(se,ge.id),se}).concat(this.results).sort((ge,se)=>se.completedAt-ge.completedAt).slice(0,32)),this.f.fire()}async $expandTest(_,ge){const se=this.g.get(g.$RI.fromString(_).controllerId)?.collection;se&&(await se.expand(_,ge<0?1/0:ge),se.flushDiff())}$acceptDiff(_){this.m.applyDiff(_.map(ge=>p.TestsDiffOp.deserialize({asCanonicalUri:se=>se},ge)))}async $runControllerTests(_,ge){return Promise.all(_.map(se=>this.G(se,!1,ge)))}async $startContinuousRun(_,ge){const se=new C.$ue(ge),ae=await Promise.all(_.map($e=>this.G($e,!0,se.token)));return!ge.isCancellationRequested&&!ae.some($e=>$e.error)&&await new Promise($e=>ge.onCancellationRequested($e)),se.dispose(!0),ae}async $provideTestFollowups(_,ge){const se=this.results.find(oe=>E.get(oe)===_.resultId),ae=se&&Z(g.$RI.fromString(_.extId),se?.results);if(!ae)return[];let $e=[];return await Promise.all([...this.y].map(async oe=>{try{const Ce=await oe.provideFollowup(se,ae,_.taskIndex,_.messageIndex,ge);Ce&&($e=$e.concat(Ce))}catch(Ce){this.C.error("Error thrown while providing followup for test message",Ce)}})),ge.isCancellationRequested?[]:$e.map(oe=>{const Ce=d++;return this.z.set(Ce,oe),{title:oe.title,id:Ce}})}$disposeTestFollowups(_){for(const ge of _)this.z.delete(ge)}$executeTestFollowup(_){const ge=this.z.get(_);return ge?this.D.executeCommand(ge.command,...ge.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(_){_===void 0?this.j.cancelAllRuns():this.j.cancelRunById(_)}getMetadataForRun(_){for(const ge of this.j.trackers){const se=ge.getTaskIdForRun(_);if(se)return{taskId:se,runId:ge.id}}}async G(_,ge,se){const ae=this.g.get(_.controllerId);if(!ae)return{};const{collection:$e,profiles:oe,extension:Ce}=ae,Fe=oe.get(_.profileId);if(!Fe)return{};const X=_.testIds.map(ce=>$e.tree.get(ce)).filter(R.$kg),V=_.excludeExtIds.map(ce=>ae.collection.tree.get(ce)).filter(R.$kg).filter(ce=>X.some(be=>be.fullId.compare(ce.fullId)===g.TestPosition.IsChild));if(!X.length)return{};const te=new r.$8O(X.some(ce=>ce.actual instanceof l.$cQ)?void 0:X.map(ce=>ce.actual),V.map(ce=>ce.actual),Fe,ge),ve=(0,p.$UI)(_)&&this.j.prepareForMainThreadTestRun(Ce,te,M.fromInternal(_,ae.collection),Fe,se);try{return await Fe.runHandler(te,se),{}}catch(ce){return{error:String(ce)}}finally{ve&&ve.hasRunningTasks&&!se.isCancellationRequested&&await N.Event.toPromise(ve.onEnd)}}};e.$tpc=D,e.$tpc=D=Qe([qe(0,s.$1P),qe(1,S.$9j),qe(2,n.$kQ),qe(3,o.$_P)],D);const w=1e4;var k;(function(fe){fe[fe.Running=0]="Running",fe[fe.Cancelling=1]="Cancelling",fe[fe.Ended=2]="Ended"})(k||(k={}));class P extends $.$Tc{get hasRunningTasks(){return this.f>0}get id(){return this.z.id}constructor(_,ge,se,ae,$e,oe){super(),this.z=_,this.C=ge,this.D=se,this.F=ae,this.G=$e,this.c=k.Running,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new N.$je),this.y=new Map,this.onEnd=this.m.event,this.j=this.B(new C.$ue(oe));const Ce=this.B(new v.$Oh(()=>this.H(),w));this.B(this.j.token.onCancellationRequested(()=>Ce.schedule()));const Fe=new N.$je;this.w=Fe.event,this.B((0,$.$Rc)(()=>{Fe.fire(),Fe.dispose()}))}getTaskIdForRun(_){for(const[ge,{run:se}]of this.g)if(se===_)return ge}cancel(){this.c===k.Running?(this.j.cancel(),this.c=k.Cancelling):this.c===k.Cancelling&&this.H()}async getCoverageDetails(_,ge,se){const[,ae]=g.$RI.fromString(_).path,$e=this.y.get(_);if(!$e)return[];const{report:oe,extIds:Ce}=$e,Fe=this.g.get(ae);if(!Fe)throw new Error("unreachable: run task was not found");let X;if(ge&&oe instanceof r.$aP){const te=Ce.indexOf(ge);if(te===-1)return[];X=oe.fromTests[te]}return await(X?this.F?.loadDetailedCoverageForTest?.(Fe.run,oe,X,se):this.F?.loadDetailedCoverage?.(Fe.run,oe,se))??[]}createRun(_){const ge=this.z.id,se=this.z.controllerId,ae=(0,y.$Yg)(),$e=X=>(V,...te)=>{if(Ce){this.D.warn(`Setting the state of test "${V.id}" is a no-op after the run ends.`);return}this.J(V),X(V,...te)},oe=(X,V)=>{const te=V instanceof Array?V.map(i.TestMessage.from):[i.TestMessage.from(V)];if(X.uri&&X.range){const ve={range:i.Range.from(X.range),uri:X.uri};for(const ce of te)ce.location=ce.location||ve}this.C.$appendTestMessagesInRun(ge,ae,g.$RI.fromExtHostTestItem(X,se).toString(),te)};let Ce=!1;const Fe={isPersisted:this.z.isPersisted,token:this.j.token,name:_,onDidDispose:this.w,addCoverage:X=>{if(Ce)return;const V=X instanceof r.$aP?X.fromTests:[];if(V.length){(0,m.$5G)(this.G,"attributableCoverage");for(const ce of V)this.J(ce)}const te=X.uri.toString(),ve=new g.$RI([ge,ae,te]).toString();this.y.set(ve,{report:X,extIds:V.map(ce=>g.$RI.fromExtHostTestItem(ce,se).toString())}),this.C.$appendCoverage(ge,ae,i.TestCoverage.fromFile(se,ve,X))},enqueued:$e(X=>{this.C.$updateTestStateInRun(ge,ae,g.$RI.fromExtHostTestItem(X,se).toString(),p.TestResultState.Queued)}),skipped:$e(X=>{this.C.$updateTestStateInRun(ge,ae,g.$RI.fromExtHostTestItem(X,se).toString(),p.TestResultState.Skipped)}),started:$e(X=>{this.C.$updateTestStateInRun(ge,ae,g.$RI.fromExtHostTestItem(X,se).toString(),p.TestResultState.Running)}),errored:$e((X,V,te)=>{oe(X,V),this.C.$updateTestStateInRun(ge,ae,g.$RI.fromExtHostTestItem(X,se).toString(),p.TestResultState.Errored,te)}),failed:$e((X,V,te)=>{oe(X,V),this.C.$updateTestStateInRun(ge,ae,g.$RI.fromExtHostTestItem(X,se).toString(),p.TestResultState.Failed,te)}),passed:$e((X,V)=>{this.C.$updateTestStateInRun(ge,ae,g.$RI.fromExtHostTestItem(X,this.z.controllerId).toString(),p.TestResultState.Passed,V)}),appendOutput:(X,V,te)=>{Ce||(te&&this.J(te),this.C.$appendOutputToRun(ge,ae,I.$Le.fromString(X),V&&i.location.from(V),te&&g.$RI.fromExtHostTestItem(te,se).toString()))},end:()=>{Ce||(Ce=!0,this.C.$finishedTestRunTask(ge,ae),--this.f||this.I())}};return this.f++,this.g.set(ae,{run:Fe}),this.C.$startedTestRunTask(ge,{id:ae,name:_,running:!0}),Fe}H(){for(const{run:_}of this.g.values())_.end()}I(){this.c!==k.Ended&&(this.c=k.Ended,this.m.fire())}J(_){if(!(_ instanceof l.$bQ))throw new u.$SP(_.id);if(this.h.has(g.$RI.fromExtHostTestItem(_,this.z.controllerId).toString()))return;const ge=[],se=this.z.colllection.root;for(;;){const ae=i.TestItem.from(_);if(ge.unshift(ae),this.h.has(ae.extId)||(this.h.add(ae.extId),_===se))break;_=_.parent||se}this.C.$addTestsToRun(this.z.controllerId,this.z.id,ge)}dispose(){this.I(),super.dispose()}}class h{get trackers(){return this.c.values()}constructor(_,ge){this.g=_,this.h=ge,this.c=new Map,this.f=new Map}getCoverageDetails(_,ge,se){const ae=g.$RI.root(_);return this.f.get(ae)?.getCoverageDetails(_,ge,se)||[]}disposeTestRun(_){this.f.get(_)?.dispose(),this.f.delete(_);for(const[ge,{id:se}]of this.c)se===_&&this.c.delete(ge)}prepareForMainThreadTestRun(_,ge,se,ae,$e){return this.j(ge,se,ae,_,$e)}cancelRunById(_){this.f.get(_)?.cancel()}cancelAllRuns(){for(const _ of this.c.values())_.cancel()}createTestRun(_,ge,se,ae,$e,oe){const Ce=this.c.get(ae);if(Ce)return Ce.createRun($e);const Fe=M.fromPublic(ge,se,ae,oe),X=b(ae);this.g.$startedExtensionTestRun({controllerId:ge,continuous:!!ae.continuous,profile:X&&{group:Y[X.kind],id:X.profileId},exclude:ae.exclude?.map(te=>g.$RI.fromExtHostTestItem(te,se.root.id).toString())??[],id:Fe.id,include:ae.include?.map(te=>g.$RI.fromExtHostTestItem(te,se.root.id).toString())??[se.root.id],preserveFocus:ae.preserveFocus??!0,persist:oe});const V=this.j(ae,Fe,ae.profile,_);return N.Event.once(V.onEnd)(()=>{this.g.$finishedExtensionTestRun(Fe.id)}),V.createRun($e)}j(_,ge,se,ae,$e){const oe=new P(ge,this.g,this.h,se,ae,$e);return this.c.set(_,oe),this.f.set(oe.id,oe),oe}}e.$upc=h;const b=fe=>{if(fe.profile){if(!(fe.profile instanceof L))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return fe.profile}};class M{static fromPublic(_,ge,se,ae){return new M(_,(0,y.$Yg)(),ae,ge)}static fromInternal(_,ge){return new M(_.controllerId,_.runId,!0,ge)}constructor(_,ge,se,ae){this.controllerId=_,this.id=ge,this.isPersisted=se,this.colllection=ae}}e.$vpc=M;class O{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(_){this.j=_,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(_){this.c.add(_)}update(_){Object.assign(_.revived,i.TestItem.toPlain(_.item)),this.c.has(_)||this.f.add(_)}remove(_){if(this.c.has(_)){this.c.delete(_);return}this.f.delete(_);const ge=g.$RI.parentId(_.item.extId);if(ge&&this.h.has(ge.toString())){this.h.add(_.item.extId);return}this.g.add(_)}getChangeEvent(){const{c:_,f:ge,g:se}=this;return{get added(){return[..._].map(ae=>ae.revived)},get updated(){return[...ge].map(ae=>ae.revived)},get removed(){return[...se].map(ae=>ae.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class F extends p.$1I{constructor(){super(...arguments),this.y=new N.$je,this.onDidChangeTests=this.y.event}get rootTests(){return this.g}getMirroredTestDataById(_){return this.f.get(_)}getMirroredTestDataByReference(_){return this.f.get(_.id)}x(_,ge){return{..._,revived:i.TestItem.toPlain(_.item),depth:ge?ge.depth+1:0,children:new Set}}w(){return new O(this.y)}}class q{constructor(_){this.f=_}checkout(){this.c||(this.c=this.g());const _=this.c;return _.observers++,{onDidChangeTest:_.tests.onDidChangeTests,get tests(){return[..._.tests.rootTests].map(ge=>ge.revived)},dispose:(0,A.$cb)(()=>{--_.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(_){return this.c?.tests.getMirroredTestDataByReference(_)}applyDiff(_){this.c?.tests.apply(_)}g(){const _=new F({asCanonicalUri:ge=>ge});return this.f.$subscribeToDiffs(),{observers:0,tests:_}}}const B=(fe,_,ge,se)=>{ge?Object.assign(ge,se):_.$updateTestRunConfig(fe.controllerId,fe.profileId,se)};class L{#e;#t;#i;#n;#s;get label(){return this.f}set label(_){_!==this.f&&(this.f=_,B(this,this.#e,this.#n,{label:_}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(_){_!==this.g&&(this.g=_,B(this,this.#e,this.#n,{supportsContinuousRun:_}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(_){_!==this.isDefault&&(_?this.#t.add(this.profileId):this.#t.delete(this.profileId),B(this,this.#e,this.#n,{isDefault:_}))}get tag(){return this._tag}set tag(_){_?.id!==this._tag?.id&&(this._tag=_,B(this,this.#e,this.#n,{tag:_?i.TestTag.namespace(this.controllerId,_.id):null}))}get configureHandler(){return this.c}set configureHandler(_){_!==this.c&&(this.c=_,B(this,this.#e,this.#n,{hasConfigurationHandler:!!_}))}get onDidChangeDefault(){return N.Event.chain(this.#i,_=>_.map(ge=>ge.get(this.controllerId)?.get(this.profileId)).filter(R.$kg))}constructor(_,ge,se,ae,$e,oe,Ce,Fe,X,V=!1,te=void 0,ve=!1){this.controllerId=$e,this.profileId=oe,this.f=Ce,this.kind=Fe,this.runHandler=X,this._tag=te,this.g=ve,this.#e=_,this.#s=ge,this.#t=se,this.#i=ae,ge.set(oe,this);const ce=Y[Fe];if(typeof ce!="number")throw new Error(`Unknown TestRunProfile.group ${Fe}`);V&&se.add(oe),this.#n={profileId:oe,controllerId:$e,tag:te?i.TestTag.namespace(this.controllerId,te.id):null,label:Ce,group:ce,isDefault:V,hasConfigurationHandler:!1,supportsContinuousRun:ve},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$wpc=L;const Y={[r.TestRunProfileKind.Coverage]:p.TestRunProfileBitset.Coverage,[r.TestRunProfileKind.Debug]:p.TestRunProfileBitset.Debug,[r.TestRunProfileKind.Run]:p.TestRunProfileBitset.Run};function Z(fe,_){for(let ge=0;ge<fe.path.length;ge++){const se=_.find(ae=>ae.id===fe.path[ge]);if(!se)return;if(ge===fe.path.length-1)return se;_=se.children}}}),define(Ne[258],Oe([1,0,17,6,4,5,127,8,7]),function(we,e,v,I,C,N,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Doc=void 0,v=Ve(v),T=Ve(T);class a extends C.$Tc{constructor(y,c){super(),this.m=c,this.a=new I.$je,this.b=new I.$je,this.c=new I.$je,this.f=new I.$je,this.g=new I.$je,this.h=new I.$je,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=y.getProxy(N.$sN.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(S=>this.h.fire(S))),this.B(this.m.onDidChangeActiveTextEditor(S=>this.g.fire(S)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(y){const c=this.m.allEditors();return y?c:c.map(S=>S.value)}async showTextDocument(y,c,S){let f;typeof c=="number"?f={position:T.ViewColumn.from(c),preserveFocus:S}:typeof c=="object"?f={position:T.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selection:typeof c.selection=="object"?T.Range.from(c.selection):void 0,pinned:typeof c.preview=="boolean"?!c.preview:void 0}:f={preserveFocus:!1};const n=await this.j.$tryShowTextDocument(y.uri,f),o=n&&this.m.getEditor(n);if(o)return o.value;throw n?new Error(`Could NOT open editor for "${y.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${y.uri.toString()}".`)}createTextEditorDecorationType(y,c){return new A.$8P(this.j,y,c).value}$acceptEditorPropertiesChanged(y,c){const S=this.m.getEditor(y);if(!S)throw new Error("unknown text editor");if(c.options&&S._acceptOptions(c.options),c.selections){const f=c.selections.selections.map(T.Selection.to);S._acceptSelections(f)}if(c.visibleRanges){const f=v.$Gb(c.visibleRanges.map(T.Range.to));S._acceptVisibleRanges(f)}if(c.options&&this.b.fire({textEditor:S.value,options:{...c.options,lineNumbers:T.TextEditorLineNumbersStyle.to(c.options.lineNumbers)}}),c.selections){const f=$.TextEditorSelectionChangeKind.fromValue(c.selections.source),n=c.selections.selections.map(T.Selection.to);this.a.fire({textEditor:S.value,selections:n,kind:f})}if(c.visibleRanges){const f=v.$Gb(c.visibleRanges.map(T.Range.to));this.c.fire({textEditor:S.value,visibleRanges:f})}}$acceptEditorPositionData(y){for(const c in y){const S=this.m.getEditor(c);if(!S)throw new Error("Unknown text editor");const f=T.ViewColumn.to(y[c]);S.value.viewColumn!==f&&(S._acceptViewColumn(f),this.f.fire({textEditor:S.value,viewColumn:f}))}}getDiffInformation(y){return Promise.resolve(this.j.$getDiffInformation(y))}}e.$Doc=a}),define(Ne[259],Oe([1,0,2,3,5,4,7,8,18,36,14]),function(we,e,v,I,C,N,A,T,$,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pqc=e.$oqc=void 0,e.$oqc=(0,I.$Ci)("IExtHostTimeline");class y{constructor(f,n){this.b=new Map,this.c=new Map,this.a=f.getProxy(C.$sN.MainThreadTimeline),n.registerArgumentProcessor({processArgument:(o,s)=>{if(o&&o.$mid===a.MarshalledId.TimelineActionContext)if(this.b.get(o.source)&&$.$nn.equals(s,this.b.get(o.source)?.extension)){const l=o.uri===void 0?void 0:v.URI.revive(o.uri);return this.c.get(o.source)?.get(c(l))?.get(o.handle)}else return;return o}})}async $getTimeline(f,n,o,s){return this.b.get(f)?.provider.provideTimeline(v.URI.revive(n),o,s)}registerTimelineProvider(f,n,o,s){const l=new N.$Sc,i=this.d(n.id,s,l).bind(this);let r;n.onDidChange&&(r=n.onDidChange(g=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...g,id:n.id}),this));const t=this.c;return this.f({...n,scheme:f,onDidChange:void 0,async provideTimeline(g,u,p){u?.resetCache&&(l.clear(),t.get(n.id)?.clear());const m=await n.provideTimeline(g,u,p);if(m==null)return;const d=i(g,u);return{...m,source:n.id,items:m.items.map(d)}},dispose(){for(const g of t.values())g.get(n.id)?.clear();r?.dispose(),l.dispose()}},o)}d(f,n,o){return(s,l)=>{let i;if(l?.cacheResults){let r=this.c.get(f);r===void 0&&(r=new Map,this.c.set(f,r));const t=c(s);i=r.get(t),i===void 0&&(i=new Map,r.set(t,i))}return r=>{const{iconPath:t,...g}=r,u=`${f}|${r.id??r.timestamp}`;i?.set(u,r);let p,m,d;r.iconPath&&(t instanceof A.$rO?d={id:t.id,color:t.color}:v.URI.isUri(t)?(p=t,m=t):{light:p,dark:m}=t);let E;return A.$WN.isMarkdownString(g.tooltip)?E=T.MarkdownString.from(g.tooltip):(0,R.$cg)(g.tooltip)?E=g.tooltip:A.$WN.isMarkdownString(g.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=T.MarkdownString.from(g.detail)):(0,R.$cg)(g.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=g.detail),{...g,id:g.id??void 0,handle:u,source:f,command:r.command?n.toInternal(r.command,o):void 0,icon:p,iconDark:m,themeIcon:d,tooltip:E,accessibilityInformation:r.accessibilityInformation}}}}f(f,n){if(this.b.get(f.id))throw new Error(`Timeline Provider ${f.id} already exists.`);return this.a.$registerTimelineProvider({id:f.id,label:f.label,scheme:f.scheme}),this.b.set(f.id,{provider:f,extension:n}),(0,N.$Rc)(()=>{for(const s of this.c.values())s.get(f.id)?.clear();this.b.delete(f.id),this.a.$unregisterTimelineProvider(f.id),f.dispose()})}}e.$pqc=y;function c(S){return S?.toString()}}),define(Ne[260],Oe([1,0,9,23,2,6,4,191,10,7,14,17,8,59,21,162,24]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S,f,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qqc=void 0,a=Ve(a);function s(r,t){if((0,R.$cg)(r))return{label:r};if(r&&typeof r=="object"&&typeof r.label=="string"){let g;return Array.isArray(r.highlights)&&(g=r.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),g=g.length?g:void 0),{label:r.label,highlights:g}}}class l extends A.$Tc{constructor(t,g,u){super(),this.f=t,this.g=g,this.h=u,this.a=new Map,this.b=new n.$m_;function p(m){return m&&m.$treeViewId&&(m.$treeItemHandle||m.$selectedTreeItems||m.$focusedTreeItem)}g.registerArgumentProcessor({processArgument:m=>p(m)?this.r(m):Array.isArray(m)&&m.length>0?m.map(d=>p(d)?this.r(d):d):m})}registerTreeDataProvider(t,g,u){const p=this.createTreeView(t,{treeDataProvider:g},u);return{dispose:()=>p.dispose()}}createTreeView(t,g,u){if(!g||!g.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const p=g.dragAndDropController?.dropMimeTypes??[],m=g.dragAndDropController?.dragMimeTypes??[],d=!!g.dragAndDropController?.handleDrag,E=!!g.dragAndDropController?.handleDrop,D=this.m(t,g,u),w={showCollapseAll:!!g.showCollapseAll,canSelectMany:!!g.canSelectMany,dropMimeTypes:p,dragMimeTypes:m,hasHandleDrag:d,hasHandleDrop:E,manuallyManageCheckboxes:!!g.manageCheckboxStateManually},k=this.f.$registerTreeViewDataProvider(t,w),P={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,o.$5G)(u,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,o.$5G)(u,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message(h){(0,S.$2k)(h)&&(0,o.$5G)(u,"treeViewMarkdownMessage"),D.message=h},get title(){return D.title},set title(h){D.title=h},get description(){return D.description},set description(h){D.description=h},get badge(){return D.badge},set badge(h){h!==void 0&&a.ViewBadge.isViewBadge(h)?D.badge={value:Math.floor(Math.abs(h.value)),tooltip:h.tooltip}:h===void 0&&(D.badge=void 0)},reveal:(h,b)=>D.reveal(h,b),dispose:async()=>{await k,this.a.delete(t),D.dispose()}};return this.B(P),P}$getChildren(t,g){const u=this.a.get(t);return u?u.getChildren(g):Promise.reject(new T.$oG(t))}async $handleDrop(t,g,u,p,m,d,E,D){const w=this.a.get(t);if(!w)return Promise.reject(new T.$oG(t));const k=c.DataTransfer.toDataTransfer(u,async P=>(await this.f.$resolveDropFileData(t,g,P)).buffer);return E===t&&D&&await this.j(k,w,D,m,d),w.onDrop(k,p,m)}async j(t,g,u,p,m){const d=this.b.removeDragOperationTransfer(m);if(d)(await d)?.forEach((E,D)=>{E&&t.set(D,E)});else if(m&&g.handleDrag){const E=g.handleDrag(u,t,p);this.b.addDragOperationTransfer(m,E),await E}return t}async $handleDrag(t,g,u,p){const m=this.a.get(t);if(!m)return Promise.reject(new T.$oG(t));const d=await this.j(new a.$nO,m,g,p,u);if(!(!d||p.isCancellationRequested))return c.DataTransfer.from(d)}async $hasResolve(t){const g=this.a.get(t);if(!g)throw new T.$oG(t);return g.hasResolve}$resolve(t,g,u){const p=this.a.get(t);if(!p)throw new T.$oG(t);return p.resolveTreeItem(g,u)}$setExpanded(t,g,u){const p=this.a.get(t);if(!p)throw new T.$oG(t);p.setExpanded(g,u)}$setSelectionAndFocus(t,g,u){const p=this.a.get(t);if(!p)throw new T.$oG(t);p.setSelectionAndFocus(g,u)}$setVisible(t,g){const u=this.a.get(t);if(!u){if(!g)return;throw new T.$oG(t)}u.setVisible(g)}$changeCheckboxState(t,g){const u=this.a.get(t);if(!u)throw new T.$oG(t);u.setCheckboxState(g)}m(t,g,u){const p=this.B(new i(t,g,this.f,this.g.converter,this.h,u));return this.a.set(t,p),p}r(t){const g=this.a.get(t.$treeViewId);return g&&"$treeItemHandle"in t?g.getExtensionElement(t.$treeItemHandle):g&&"$focusedTreeItem"in t&&t.$focusedTreeItem?g.focusedElement:null}}e.$qqc=l;class i extends A.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(t=>this.getExtensionElement(t)).filter(t=>!(0,R.$lg)(t))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(t,g,u,p,m,d){if(super(),this.I=t,this.J=u,this.L=p,this.M=m,this.N=d,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new N.$je),this.onDidExpandElement=this.u.event,this.w=this.B(new N.$je),this.onDidCollapseElement=this.w.event,this.y=this.B(new N.$je),this.onDidChangeSelection=this.y.event,this.z=this.B(new N.$je),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new N.$je),this.onDidChangeVisibility=this.C.event,this.D=this.B(new N.$je),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new N.$je),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new f.$ue,d.contributes&&d.contributes.views)for(const k in d.contributes.views)for(const P of d.contributes.views[k])P.id===t&&(this.P=P.name);this.f=g.treeDataProvider,this.g=g.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(k=>{Array.isArray(k)&&k.length===0||this.F.fire({message:!1,element:k})}));let E,D;const w=N.Event.debounce(this.F.event,(k,P)=>(k||(k={message:!1,elements:[]}),P.element!==!1&&(E||(E=new Promise(h=>D=h),this.G=this.G.then(()=>E)),Array.isArray(P.element)?k.elements.push(...P.element):k.elements.push(P.element)),P.message&&(k.message=!0),k),200,!0);this.B(w(({message:k,elements:P})=>{P.length&&(this.H=this.H.then(()=>{const h=D;return E=null,this.$(P).then(()=>h())})),k&&this.J.$setMessage(this.I,c.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(t){const g=t?this.getExtensionElement(t):void 0;if(t&&!g)return this.M.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let u=this.X(t);return u||(u=await this.Y(g)),u?u.map(p=>p.item):void 0}getExtensionElement(t){return this.j.get(t)}reveal(t,g){g=g||{select:!0,focus:!1};const u=(0,R.$lg)(g.select)?!0:g.select,p=(0,R.$lg)(g.focus)?!1:g.focus,m=(0,R.$lg)(g.expand)?!1:g.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.G.then(()=>this.S(t)).then(d=>this.W(t,d[d.length-1]).then(E=>this.J.$reveal(this.I,{item:E.item,parentChain:d.map(D=>D.item)},{select:u,focus:p,expand:m})),d=>this.M.error(d)):this.J.$reveal(this.I,void 0,{select:u,focus:p,expand:m})}get message(){return this.O}set message(t){this.O=t,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(t){this.P=t,this.J.$setTitle(this.I,t,this.Q)}get description(){return this.Q}set description(t){this.Q=t,this.J.$setTitle(this.I,this.P,t)}get badge(){return this.R}set badge(t){this.R?.value===t?.value&&this.R?.tooltip===t?.tooltip||(this.R=c.ViewBadge.from(t),this.J.$setBadge(this.I,t))}setExpanded(t,g){const u=this.getExtensionElement(t);u&&(g?this.u.fire(Object.freeze({element:u})):this.w.fire(Object.freeze({element:u})))}setSelectionAndFocus(t,g){const u=!(0,y.$tb)(this.s,t);this.s=t;const p=this.t!==g;this.t=g,u&&this.y.fire(Object.freeze({selection:this.selectedElements})),p&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this.r&&(this.r=t,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(t){const g=(await Promise.all(t.map(async u=>{const p=this.getExtensionElement(u.treeItemHandle);return p?{extensionItem:p,treeItem:await this.f.getTreeItem(p),newState:u.newState?a.TreeItemCheckboxState.Checked:a.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(u=>u!==void 0);g.forEach(u=>{u.treeItem.checkboxState=u.newState?a.TreeItemCheckboxState.Checked:a.TreeItemCheckboxState.Unchecked}),this.D.fire({items:g.map(u=>[u.extensionItem,u.newState])})}async handleDrag(t,g,u){const p=[];for(const m of t){const d=this.getExtensionElement(m);d&&p.push(d)}if(!(!this.g?.handleDrag||p.length===0))return await this.g.handleDrag(p,g,u),g}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(t,g,u){const p=g?this.getExtensionElement(g):void 0;if(!(!p&&g||!this.g?.handleDrop))return(0,$.$uh)(()=>this.g?.handleDrop?this.g.handleDrop(p,t,u):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(t,g){if(!this.f.resolveTreeItem)return;const u=this.j.get(t);if(u){const p=this.m.get(u);if(p){const m=await this.f.resolveTreeItem(p.extensionItem,u,g)??p.extensionItem;return this.hb(m),p.item.tooltip=this.eb(m.tooltip),p.item.command=this.fb(p.disposableStore,m.command),p.item}}}S(t){return this.U(t).then(g=>g?this.S(g).then(u=>this.W(g,u[u.length-1]).then(p=>(u.push(p),u))):Promise.resolve([]))}U(t){const g=this.m.get(t);return g?Promise.resolve(g.parent?this.j.get(g.parent.item.handle):void 0):(0,$.$uh)(()=>this.f.getParent(t))}W(t,g){const u=this.m.get(t);return u?Promise.resolve(u):(0,$.$uh)(()=>this.f.getTreeItem(t)).then(p=>this.kb(t,p,g,!0)).then(p=>this.getChildren(g?g.item.handle:void 0).then(()=>{const m=this.getExtensionElement(p);if(m){const d=this.m.get(m);if(d)return Promise.resolve(d)}throw new Error(`Cannot resolve tree item for element ${p} from extension ${this.N.identifier.value}`)}))}X(t){if(t){let g;if(typeof t=="string"){const u=this.getExtensionElement(t);g=u?this.m.get(u):void 0}else g=t;return g&&g.children||void 0}return this.h}async Y(t){this.rb(t);const g=new f.$ue(this.Z.token);try{const u=t?this.m.get(t):void 0,p=await this.f.getChildren(t);if(g.token.isCancellationRequested)return;const m=(0,y.$Gb)(p||[]),d=await Promise.all((0,y.$Gb)(m).map(D=>this.f.getTreeItem(D)));if(g.token.isCancellationRequested)return;const E=d.map((D,w)=>D?this.db(m[w],D,u):null);return(0,y.$Gb)(E)}finally{g.dispose()}}$(t){if(t.some(u=>!u))return this.Z.dispose(!0),this.Z=new f.$ue,this.tb(),this.J.$refresh(this.I);{const u=this.ab(t);if(u.length)return this.bb(u)}return Promise.resolve(void 0)}ab(t){const g=new Set,u=t.map(m=>this.m.get(m));for(const m of u)if(m&&!g.has(m.item.handle)){let d=m;for(;d&&d.parent&&u.findIndex(E=>d&&d.parent&&E&&E.item.handle===d.parent.item.handle)===-1;){const E=this.j.get(d.parent.item.handle);d=E?this.m.get(E):void 0}d&&!d.parent&&g.add(m.item.handle)}const p=[];return g.forEach(m=>{const d=this.j.get(m);if(d){const E=this.m.get(d);E&&(!E.parent||!g.has(E.parent.item.handle))&&p.push(m)}}),p}bb(t){const g={};return Promise.all(t.map(u=>this.cb(u).then(p=>{p&&(g[u]=p.item)}))).then(()=>Object.keys(g).length?this.J.$refresh(this.I,g):void 0)}cb(t){const g=this.getExtensionElement(t);if(g){const u=this.m.get(g);if(u)return this.rb(g),(0,$.$uh)(()=>this.f.getTreeItem(g)).then(p=>{if(p){const m=this.ib(g,p,u.parent);return this.pb(g,m,u,u.parent),u.dispose(),m}return null})}return Promise.resolve(null)}db(t,g,u){const p=this.ib(t,g,u);if(g.id&&this.j.has(p.item.handle))throw new Error((0,v.localize)(10658,null,g.id));return this.ob(t,p),this.qb(p,u),p}eb(t){return a.$WN.isMarkdownString(t)?c.MarkdownString.from(t):t}fb(t,g){return g?{...this.L.toInternal(g,t),originalId:g.command}:void 0}gb(t){if(t.checkboxState===void 0)return;let g,u,p;return typeof t.checkboxState=="number"?g=t.checkboxState:(g=t.checkboxState.state,u=t.checkboxState.tooltip,p=t.checkboxState.accessibilityInformation),{isChecked:g===a.TreeItemCheckboxState.Checked,tooltip:u,accessibilityInformation:p}}hb(t){if(!a.$iO.isTreeItem(t,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(t,g,u){this.hb(g);const p=this.B(new A.$Sc),m=this.kb(t,g,u),d=this.lb(g);return{item:{handle:m,parentHandle:u?u.item.handle:void 0,label:s(g.label,this.N),description:g.description,resourceUri:g.resourceUri,tooltip:this.eb(g.tooltip),command:this.fb(p,g.command),contextValue:g.contextValue,icon:d,iconDark:this.mb(g)||d,themeIcon:this.jb(g),collapsibleState:(0,R.$lg)(g.collapsibleState)?a.TreeItemCollapsibleState.None:g.collapsibleState,accessibilityInformation:g.accessibilityInformation,checkbox:this.gb(g)},extensionItem:g,parent:u,children:void 0,disposableStore:p,dispose(){p.dispose()}}}jb(t){return t.iconPath instanceof a.$rO?t.iconPath:void 0}kb(t,{id:g,label:u,resourceUri:p},m,d){if(g)return`${i.b}/${g}`;const E=s(u,this.N),D=m?m.item.handle:i.a;let w=E?E.label:p?(0,I.$ah)(p):"";w=w.indexOf("/")!==-1?w.replace("/","//"):w;const k=this.m.has(t)?this.m.get(t).item.handle:void 0,P=this.X(m)||[];let h,b=0;do{if(h=`${D}/${b}:${w}`,d||!this.j.has(h)||k===h)break;b++}while(b<=P.length);return h}lb(t){if(t.iconPath&&!(t.iconPath instanceof a.$rO))return typeof t.iconPath=="string"||C.URI.isUri(t.iconPath)?this.nb(t.iconPath):this.nb(t.iconPath.light)}mb(t){if(t.iconPath&&!(t.iconPath instanceof a.$rO)&&t.iconPath.dark)return this.nb(t.iconPath.dark)}nb(t){return C.URI.isUri(t)?t:C.URI.file(t)}ob(t,g){this.j.set(g.item.handle,t),this.m.set(t,g)}pb(t,g,u,p){this.j.delete(g.item.handle),this.m.delete(t),g.item.handle!==u.item.handle&&this.j.delete(u.item.handle),this.ob(t,g);const m=this.X(p)||[],d=m.filter(E=>E.item.handle===u.item.handle)[0];d&&m.splice(m.indexOf(d),1,g)}qb(t,g){g?(g.children||(g.children=[]),g.children.push(t)):(this.h||(this.h=[]),this.h.push(t))}rb(t){if(t){const g=this.m.get(t);if(g){if(g.children)for(const u of g.children){const p=this.j.get(u.item.handle);p&&this.sb(p)}g.children=void 0}}else this.tb()}sb(t){const g=this.m.get(t);if(g){if(g.children)for(const u of g.children){const p=this.j.get(u.item.handle);p&&this.sb(p)}this.m.delete(t),this.j.delete(g.item.handle),g.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(t=>t.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ne[261],Oe([1,0,6,4,2,37,8,67,5,7]),function(we,e,v,I,C,N,A,T,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Woc=void 0,A=Ve(A),$=Ve($),a=Ve(a);class R extends I.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;#h;constructor(f,n,o,s){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#d=this.B(new v.$je),this.onDidDispose=this.#d.event,this.#h=this.B(new v.$je),this.onDidChangeViewState=this.#h.event,this.#e=f,this.#t=n,this.#n=o,this.#i=s.viewType,this.#s=s.panelOptions,this.#o=s.viewColumn,this.#r=s.title,this.#l=s.active}dispose(){this.#u||(this.#u=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(f){this.c(),this.#r!==f&&(this.#r=f,this.#t.$setTitle(this.#e,f))}get iconPath(){return this.c(),this.#a}set iconPath(f){this.c(),this.#a!==f&&(this.#a=f,this.#t.$setIconPath(this.#e,C.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#l}get visible(){return this.c(),this.#c}_updateViewState(f){this.#u||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(this.#l=f.active,this.#c=f.visible,this.#o=f.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(f,n){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof f>"u"?void 0:A.ViewColumn.from(f),preserveFocus:!!n})}c(){if(this.#u)throw new Error("Webview is disposed")}}class y extends I.$Tc{static c(){return(0,N.$Yg)()}constructor(f,n,o){super(),this.j=n,this.m=o,this.g=new Map,this.h=new Map,this.f=f.getProxy($.$sN.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(f=>f.dispose()),this.g.clear()}createWebviewPanel(f,n,o,s,l={}){const i=typeof s=="object"?s.viewColumn:s,r={viewColumn:A.ViewColumn.from(i),preserveFocus:typeof s=="object"&&!!s.preserveFocus},t=(0,T.$Soc)(f),g=y.c();this.f.$createWebviewPanel((0,T.$Uoc)(f),g,n,{title:o,panelOptions:c(l),webviewOptions:(0,T.$Voc)(f,this.m,l),serializeBuffersForPostMessage:t},r);const u=this.j.createNewWebview(g,l,f);return this.createNewWebviewPanel(g,n,o,i,l,u,!0)}$onDidChangeWebviewPanelViewStates(f){const n=Object.keys(f);n.sort((o,s)=>{const l=f[o],i=f[s];return l.active?1:i.active?-1:+l.visible-+i.visible});for(const o of n){const s=this.getWebviewPanel(o);if(!s)continue;const l=f[o];s._updateViewState({active:l.active,visible:l.visible,viewColumn:A.ViewColumn.to(l.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this.g.delete(f),this.j.deleteWebview(f)}registerWebviewPanelSerializer(f,n,o){if(this.h.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.h.set(n,{serializer:o,extension:f}),this.f.$registerSerializer(n,{serializeBuffersForPostMessage:(0,T.$Soc)(f)}),new a.$uN(()=>{this.h.delete(n),this.f.$unregisterSerializer(n)})}async $deserializeWebviewPanel(f,n,o,s){const l=this.h.get(n);if(!l)throw new Error(`No serializer found for '${n}'`);const{serializer:i,extension:r}=l,t=this.j.createNewWebview(f,o.webviewOptions,r),g=this.createNewWebviewPanel(f,n,o.title,s,o.panelOptions,t,o.active);await i.deserializeWebviewPanel(g,o.state)}createNewWebviewPanel(f,n,o,s,l,i,r){const t=new R(f,this.f,i,{viewType:n,title:o,viewColumn:s,panelOptions:l,active:r});return this.g.set(f,t),t}getWebviewPanel(f){return this.g.get(f)}}e.$Woc=y;function c(S){return{enableFindWidget:S.enableFindWidget,retainContextWhenHidden:S.retainContextWhenHidden}}}),define(Ne[262],Oe([1,0,6,4,67,8,5,7]),function(we,e,v,I,C,N,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tqc=void 0,A=Ve(A),T=Ve(T);class $ extends I.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(y,c,S,f,n,o){super(),this.#s=!1,this.#l=this.B(new v.$je),this.onDidChangeVisibility=this.#l.event,this.#u=this.B(new v.$je),this.onDidDispose=this.#u.event,this.#i=S,this.#a=f,this.#e=y,this.#t=c,this.#n=n,this.#r=o}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.a(),this.#a}set title(y){this.a(),this.#a!==y&&(this.#a=y,this.#t.$setWebviewViewTitle(this.#e,y))}get description(){return this.a(),this.#o}set description(y){this.a(),this.#o!==y&&(this.#o=y,this.#t.$setWebviewViewDescription(this.#e,y))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(y){y===this.#r||this.#s||(this.#r=y,this.#l.fire())}get badge(){return this.a(),this.#c}set badge(y){this.a(),!(y?.value===this.#c?.value&&y?.tooltip===this.#c?.tooltip)&&(this.#c=N.ViewBadge.from(y),this.#t.$setWebviewViewBadge(this.#e,y))}show(y){this.a(),this.#t.$show(this.#e,!!y)}a(){if(this.#s)throw new Error("Webview is disposed")}}class a{constructor(y,c){this.d=c,this.b=new Map,this.c=new Map,this.a=y.getProxy(A.$sN.MainThreadWebviewViews)}registerWebviewViewProvider(y,c,S,f){if(this.b.has(c))throw new Error(`View provider for '${c}' already registered`);return this.b.set(c,{provider:S,extension:y}),this.a.$registerWebviewViewProvider((0,C.$Uoc)(y),c,{retainContextWhenHidden:f?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$Soc)(y)}),new T.$uN(()=>{this.b.delete(c),this.a.$unregisterWebviewViewProvider(c)})}async $resolveWebviewView(y,c,S,f,n){const o=this.b.get(c);if(!o)throw new Error(`No view provider found for '${c}'`);const{provider:s,extension:l}=o,i=this.d.createNewWebview(y,{},l),r=new $(y,this.a,c,S,i,!0);this.c.set(y,r),await s.resolveWebviewView(r,{state:f},n)}async $onDidChangeWebviewViewVisibility(y,c){this.e(y)._setVisible(c)}async $disposeWebviewView(y){const c=this.e(y);this.c.delete(y),c.dispose(),this.d.deleteWebview(y)}e(y){const c=this.c.get(y);if(!c)throw new Error("No webview found");return c}}e.$tqc=a}),define(Ne[263],Oe([1,0,6,30,31,3]),function(we,e,v,I,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OM=e.$NM=e.OutputChannelUpdateMode=e.$MM=e.$LM=e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.$FM=e.$EM=e.$DM=e.$CM=e.$BM=e.$AM=void 0,e.$AM="text/x-code-output",e.$BM="output",e.$CM="Log",e.$DM="text/x-code-log-output",e.$EM="log",e.$FM="workbench.panel.output",e.$GM=new C.$Tj("inOutput",!1),e.$HM=new C.$Tj("activeLogOutput",!1),e.$IM=new C.$Tj("activeLogOutput.levelSettable",!1),e.$JM=new C.$Tj("activeLogOutput.level",""),e.$KM=new C.$Tj("activeLogOutput.levelIsDefault",!1),e.$LM=new C.$Tj("outputView.scrollLock",!1),e.$MM=(0,N.$Ci)("outputService");var A;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$NM={OutputChannels:"workbench.contributions.outputChannels"};class T{constructor(){this.a=new Map,this.b=new v.$je,this.onDidRegisterChannel=this.b.event,this.c=new v.$je,this.onDidRemoveChannel=this.c.event}registerChannel(a){this.a.has(a.id)||(this.a.set(a.id,a),this.b.fire(a.id))}getChannels(){const a=[];return this.a.forEach(R=>a.push(R)),a}getChannel(a){return this.a.get(a)}removeChannel(a){this.a.delete(a),this.c.fire(a)}}I.$no.add(e.$NM.OutputChannels,new T),e.$OM=new C.$Tj("activeOutputChannel","")}),define(Ne[128],Oe([1,0,5,3,16,18,11,263,68,26,50,164,22,14,29,6,4]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S,f,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0pc=e.$9pc=void 0;class s extends A.$ck{get disposed(){return this.n}constructor(t,g,u,p,m){super(),this.id=t,this.name=g,this.r=u,this.s=p,this.extension=m,this.m=0,this.n=!1,this.visible=!1,this.setLevel(u.getLevel()),this.B(u.onDidChangeLogLevel(d=>this.setLevel(d)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.m;this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Clear,t)}replace(t){const g=this.m;this.info(t),this.s.$update(this.id,T.OutputChannelUpdateMode.Replace,g),this.visible&&this.r.flush()}show(t,g){this.r.flush(),this.s.$reveal(this.id,!!(typeof t=="boolean"?t:g))}hide(){this.s.$close(this.id)}g(t,g){this.m+=c.$Le.fromString(g).byteLength,(0,A.log)(this.r,t,g),this.visible&&(this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class l extends s{appendLine(t){this.append(t)}}let i=class{constructor(t,g,u,p,m,d){this.i=g,this.j=u,this.k=p,this.l=m,this.m=d,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=t.getProxy(v.$sN.MainThreadOutputService),this.b=this.k.extUri.joinPath(g.logsLocation,`output_logging_${(0,y.$Zm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.h=t;for(const[g,u]of this.g)u.visible=g===this.h}createOutputChannel(t,g,u){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const p=typeof g=="object"&&g.log,m=(0,S.$cg)(g)?g:void 0;if((0,S.$cg)(m)&&!m.trim())throw new Error("illegal argument `languageId`. must not be empty");let d;const E=this.i.environment.extensionLogLevel?.find(([w])=>N.$nn.equals(u.identifier,w))?.[1];E&&(d=(0,A.$nk)(E));const D=p?this.o(t,d,u):this.n(t,m,u);return D.then(w=>{this.g.set(w.id,w),w.visible=w.id===this.h}),p?this.r(t,d??this.m.getLevel(),D):this.q(t,D)}async n(t,g,u){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const p=await this.c,m=this.k.extUri.joinPath(p,`${this.f++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),d=this.l.createLogger(m,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),E=await this.a.$register(t,m,g,u.identifier.value);return new s(E,t,d,this.a,u)}async o(t,g,u){const p=await this.p(u),m=t.replace(/[\\/:\*\?"<>\|]/g,""),d=this.k.extUri.joinPath(p,`${m}.log`),E=`${u.identifier.value}.${m}`,D=this.l.createLogger(d,{id:E,name:t,logLevel:g,extensionId:u.identifier.value});return new l(E,t,D,this.a,u)}p(t){let g=this.d.get(t.identifier.value);if(!g){const u=this.k.extUri.joinPath(this.i.logsLocation,t.identifier.value);this.d.set(t.identifier.value,g=(async()=>{try{await this.j.value.createDirectory(u)}catch(p){if((0,f.$ml)(p)!==f.FileSystemProviderErrorCode.FileExists)throw p}return u})())}return g}q(t,g){let u=!1;const p=()=>{if(u)throw new Error("Channel has been closed")};return{get name(){return t},append(m){p(),g.then(d=>d.append(m))},appendLine(m){p(),g.then(d=>d.appendLine(m))},clear(){p(),g.then(m=>m.clear())},replace(m){p(),g.then(d=>d.replace(m))},show(m,d){p(),g.then(E=>E.show(m,d))},hide(){p(),g.then(m=>m.hide())},dispose(){u=!0,g.then(m=>m.dispose())}}}r(t,g,u){const p=new o.$Sc,m=()=>{if(p.isDisposed)throw new Error("Channel has been closed")},d=p.add(new n.$je);function E(D){g=D,d.fire(D)}return u.then(D=>{p.add(D),D.logLevel!==g&&E(D.logLevel),p.add(D.onDidChangeLogLevel(w=>E(w)))}),{...this.q(t,u),get logLevel(){return g},onDidChangeLogLevel:d.event,trace(D,...w){m(),u.then(k=>k.trace(D,...w))},debug(D,...w){m(),u.then(k=>k.debug(D,...w))},info(D,...w){m(),u.then(k=>k.info(D,...w))},warn(D,...w){m(),u.then(k=>k.warn(D,...w))},error(D,...w){m(),u.then(k=>k.error(D,...w))},dispose(){p.dispose()}}}};e.$9pc=i,e.$9pc=i=Qe([qe(0,C.$1P),qe(1,a.$eQ),qe(2,$.$Ooc),qe(3,R.$roc),qe(4,A.$0j),qe(5,A.$9j)],i),e.$0pc=(0,I.$Ci)("IExtHostOutputService")}),define(Ne[129],Oe([1,0,3,10]),function(we,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=void 0,e.$Sm=(0,v.$Ci)("remoteAgentService"),e.$Tm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let N=1/0;for(let T=0;T<this.maxSampleCount;T++){const $=await C.getRoundTripTime();if($===void 0)return;N=Math.min(N,$/2),await(0,I.$Dh)(this.sampleDelay)}this.average.push(N),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(N):A=this.initial.reduce((T,$)=>T+$,0)/this.initial.length,this.lastMeasurement={initial:A,current:N,average:this.average.reduce((T,$)=>T+$,0)/this.average.length,high:typeof A>"u"?!1:N>this.highLatencyMaxThreshold||N>this.highLatencyMinThreshold&&N>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ne[264],Oe([1,0,9,53,30,49,43,4,6,129,20,25,10,113]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0K=e.$9K=e.$8K=e.$7K=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=void 0,e.$1K=Object.freeze({id:"application",order:100,title:(0,v.localize)(12380,null),type:"object"}),e.$2K=Object.freeze({id:"workbench",order:7,title:(0,v.localize)(12381,null),type:"object"}),e.$3K=Object.freeze({id:"security",scope:I.ConfigurationScope.APPLICATION,title:(0,v.localize)(12382,null),type:"object",order:7}),e.$4K=Object.freeze({id:"problems",title:(0,v.localize)(12383,null),type:"object",order:101}),e.$5K=Object.freeze({id:"window",order:8,title:(0,v.localize)(12384,null),type:"object"}),e.$6K={ConfigurationMigration:"base.contributions.configuration.migration"};class f{constructor(){this.migrations=[],this.a=new $.$je,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(r){this.migrations.push(...r)}}const n=new f;C.$no.add(e.$6K.ConfigurationMigration,n);let o=class extends T.$Tc{static{this.ID="workbench.contrib.configurationMigration"}constructor(r,t){super(),this.a=r,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async g=>{for(const u of g.added)await this.f(u,n.migrations)})),this.c(n.migrations),this.B(n.onDidRegisterConfigurationMigration(g=>this.c(g)))}async c(r){await this.f(void 0,r);for(const t of this.b.getWorkspace().folders)await this.f(t,r)}async f(r,t){await Promise.all([t.map(g=>this.g(g,r?.uri))])}async g(r,t){const g=this.a.inspect(r.key,{resource:t}),u=this.b.getWorkbenchState()===N.WorkbenchState.WORKSPACE?[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE],["workspaceFolder",A.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE]];for(const[p,m]of u){const d=g[p];if(!d)continue;const E=[];if(d.value!==void 0){const D=await this.h(r,p,d.value,t,void 0);for(const w of D??[])E.push([w,[]])}for(const{identifiers:D,value:w}of d.overrides??[])if(w!==void 0){const k=await this.h(r,p,w,t,D);for(const P of k??[])E.push([P,D])}E.length&&await Promise.allSettled(E.map(async([[D,w],k])=>this.a.updateValue(D,w.value,{resource:t,overrideIdentifiers:k},m)))}}async h(r,t,g,u,p){const m=E=>{const w=this.a.inspect(E,{resource:u})[t];if(w)return p?w.overrides?.find(({identifiers:k})=>(0,y.$eo)(k,p))?.value:w.value},d=await r.migrateFn(g,m);return Array.isArray(d)?d:[[r.key,d]]}};e.$7K=o,e.$7K=o=Qe([qe(0,A.$9i),qe(1,N.$Li)],o);let s=class extends T.$Tc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(r){super(),this.b=r,this.a=new c.$Zh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!R.$j&&(await this.b.getEnvironment())?.os!==R.OperatingSystem.Windows)return;C.$no.as(I.$so.Configuration).registerConfiguration({...e.$3K,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,v.localize)(12385,null)},default:[],markdownDescription:(0,v.localize)(12386,null),scope:I.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,v.localize)(12387,null),scope:I.ConfigurationScope.MACHINE}}})}};e.$8K=s,e.$8K=s=Qe([qe(0,a.$Sm)],s),e.$9K="window.newWindowProfile";let l=class extends T.$Tc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(r,t){super(),this.c=r,this.f=t,this.g(),this.B(this.c.onDidChangeProfiles(g=>this.g())),this.h(),this.j(),this.B(t.onDidChangeConfiguration(g=>{g.source!==A.ConfigurationTarget.DEFAULT&&g.affectsConfiguration(e.$9K)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const r=C.$no.as(I.$so.Configuration),t={...e.$5K,properties:{[e.$9K]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(g=>g.name),null],enumItemLabels:[...this.c.profiles.map(g=>""),(0,v.localize)(12388,null)],description:(0,v.localize)(12389,null),scope:I.ConfigurationScope.APPLICATION}}};this.a?r.updateConfigurations({add:[t],remove:[this.a]}):r.registerConfiguration(t),this.a=t}h(){const r=this.f.getValue(e.$9K);this.b=r?this.c.profiles.find(t=>t.name===r):void 0}j(){const r=this.f.getValue(e.$9K);if(!r)return;const t=this.b?this.c.profiles.find(g=>g.id===this.b.id):void 0;r!==t?.name&&this.f.updateValue(e.$9K,t?.name)}};e.$0K=l,e.$0K=l=Qe([qe(0,S.$Il),qe(1,A.$9i)],l)}),define(Ne[265],Oe([1,0,41,15,19,23,9,264,53,3,30]),function(we,e,v,I,C,N,A,T,$,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$_K=e.$$K=void 0,e.$aL=n,e.$bL=o,v=Ve(v),e.$$K=(0,a.$Ci)("editorResolverService"),e.$_K="workbench.editorAssociations";const y=R.$no.as($.$so.Configuration),c={...T.$2K,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(1976,null),additionalProperties:{type:"string"}}}};y.registerConfiguration(c);var S;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})(S||(e.RegisteredEditorPriority=S={}));var f;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})(f||(e.ResolvedStatus=f={}));function n(s){switch(s){case S.exclusive:return 5;case S.default:return 4;case S.builtin:return 3;case S.option:default:return 1}}function o(s,l){if(new Set([I.Schemas.extension,I.Schemas.webviewPanel,I.Schemas.vscodeWorkspaceTrust,I.Schemas.vscodeSettings]).has(l.scheme))return!1;const t=typeof s=="string"&&s.indexOf(C.$fc.sep)>=0?`${l.scheme}:${l.path}`:(0,N.$ah)(l);return v.$vk(typeof s=="string"?s.toLowerCase():s,t.toLowerCase())}}),define(Ne[266],Oe([1,0,51,15,19,20,23,2,3,185,49,204,129]),function(we,e,v,I,C,N,A,T,$,a,R,y,c){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=e.$7M=void 0,e.$7M=(0,$.$Ci)("pathService");let f=S=class{constructor(o,s,l,i){this.d=o,this.e=s,this.f=l,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||N.OS)(),this.b=(async()=>{const r=await this.e.getEnvironment();return this.c=r?.userHome??o})()}hasValidBasename(o,s,l){return typeof s=="string"||typeof s>"u"?this.a.then(i=>this.h(o,i,s)):this.h(o,s,l)}h(o,s,l){return o.scheme===I.Schemas.file||o.scheme===I.Schemas.vscodeRemote?(0,v.$zg)(l??(0,A.$ah)(o),s===N.OperatingSystem.Windows):!0}get defaultUriScheme(){return S.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,s){if(o.remoteAuthority)return I.Schemas.vscodeRemote;const l=(0,a.$4M)(s.getWorkspace());if(l)return l;const i=s.getWorkspace().folders[0];if(i)return i.uri.scheme;const r=s.getWorkspace().configuration;return r?r.scheme:I.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===N.OperatingSystem.Windows?C.$ec:C.$fc)}async fileURI(o){let s="";if(await this.a===N.OperatingSystem.Windows&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const i=o.indexOf("/",2);i===-1?(s=o.substring(2),o="/"):(s=o.substring(2,i),o=o.substring(i)||"/")}return T.URI.from({scheme:I.Schemas.file,authority:s,path:o,query:"",fragment:""})}};e.$8M=f,e.$8M=f=S=Qe([qe(1,c.$Sm),qe(2,y.$PM),qe(3,R.$Li)],f)}),define(Ne[130],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$IL=e.$HL=void 0;class v{constructor(A,T){this.line=A,this.character=T}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,T){return new v(0,0)}with(A){return new v(0,0)}}e.$HL=v;class I{constructor(A,T,$,a){this.isEmpty=!1,this.isSingleLine=!1,this.start=new v(A,T),this.end=new v($,a)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new I(0,0,0,0)}with(A){return new I(0,0,0,0)}}e.$IL=I;var C;(function(N){N[N.Information=1]="Information",N[N.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Ne[44],Oe([1,0,17,41,25,51,12,3,19,13,130,10]),function(we,e,v,I,C,N,A,T,$,a,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9L=e.$7L=e.$ZL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$WL=e.$VL=e.$UL=e.$TL=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.TextSearchCompleteMessageType=void 0,e.$QL=s,e.$RL=l,e.$SL=i,e.$XL=D,e.$YL=w,e.$1L=h,e.$2L=b,e.$3L=M,e.$4L=O,e.$5L=F,e.$6L=q,e.$8L=L,e.$0L=fe,e.$$L=_,I=Ve(I),C=Ve(C),N=Ve(N),$=Ve($),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$JL="workbench.view.search",e.$KL="workbench.panel.search",e.$LL="workbench.view.search",e.$ML="search-result",e.$NL="search.exclude",e.$OL=2e4;const c="\u27EA ",S=" characters skipped \u27EB",f=(c.length+S.length+5)*2;e.$PL=(0,T.$Ci)("searchService");var n;(function(se){se[se.file=0]="file",se[se.text=1]="text",se[se.aiText=2]="aiText"})(n||(e.SearchProviderType=n={}));var o;(function(se){se[se.File=1]="File",se[se.Text=2]="Text",se[se.aiText=3]="aiText"})(o||(e.QueryType=o={}));function s(se){return!!se.preview}function l(se){return!!se.resource}function i(se){return!!se.message}var r;(function(se){se[se.Normal=0]="Normal",se[se.NewSearchStarted=1]="NewSearchStarted"})(r||(e.SearchCompletionExitCode=r={}));class t{constructor(ae){this.resource=ae,this.results=[]}}e.$TL=t;class g{constructor(ae,$e,oe,Ce){this.ranges=$e,this.webviewIndex=Ce;const Fe=Array.isArray($e)?$e:[$e];if(oe&&oe.matchLines===1&&u(Fe)){ae=(0,A.$8f)(ae,oe.matchLines);let X="",V=0,te=0;const ve=Math.floor(oe.charsPerLine/5),ce=[];for(const be of Fe){const he=Math.max(be.startColumn-ve,0),J=be.startColumn+oe.charsPerLine;if(he>te+ve+f){const x=c+(he-te)+S;X+=x+ae.slice(he,J),V+=he-(te+x.length)}else X+=ae.slice(te,J);ce.push(new m(0,be.startColumn-V,be.endColumn-V)),te=J}this.preview={text:X,matches:Array.isArray(this.ranges)?ce:ce[0]}}else{const X=Array.isArray($e)?$e[0].startLineNumber:$e.startLineNumber;this.preview={text:ae,matches:(0,v.$Zb)($e,V=>new p(V.startLineNumber-X,V.startColumn,V.endLineNumber-X,V.endColumn))}}}}e.$UL=g;function u(se){const ae=se[0].startLineNumber;for(const $e of se)if($e.startLineNumber!==ae||$e.endLineNumber!==ae)return!1;return!0}class p{constructor(ae,$e,oe,Ce){this.startLineNumber=ae,this.startColumn=$e,this.endLineNumber=oe,this.endColumn=Ce}}e.$VL=p;class m extends p{constructor(ae,$e,oe){super(ae,$e,ae,oe)}}e.$WL=m;var d;(function(se){se.List="list",se.Tree="tree"})(d||(e.ViewMode=d={}));var E;(function(se){se.Default="default",se.FileNames="fileNames",se.Type="type",se.Modified="modified",se.CountDescending="countDescending",se.CountAscending="countAscending"})(E||(e.SearchSortOrder=E={}));function D(se,ae=!0){const $e=se&&se.files&&se.files.exclude,oe=ae&&se&&se.search&&se.search.exclude;if(!$e&&!oe)return;if(!$e||!oe)return $e||oe;let Ce=Object.create(null);return Ce=C.$do(Ce,C.$ao($e)),Ce=C.$do(Ce,C.$ao(oe),!0),Ce}function w(se,ae){return se.excludePattern&&I.$vk(se.excludePattern,ae)?!1:se.includePattern||se.usingSearchPaths?se.includePattern&&I.$vk(se.includePattern,ae)?!0:se.usingSearchPaths?!!se.folderQueries&&se.folderQueries.some($e=>{const oe=$e.folder.fsPath;if(N.$Bg(ae,oe)){const Ce=$.$kc(oe,ae);return!$e.includePattern||!!I.$vk($e.includePattern,Ce)}else return!1}):!1:!0}var k;(function(se){se[se.unknownEncoding=1]="unknownEncoding",se[se.regexParseError=2]="regexParseError",se[se.globParseError=3]="globParseError",se[se.invalidLiteral=4]="invalidLiteral",se[se.rgProcessError=5]="rgProcessError",se[se.other=6]="other",se[se.canceled=7]="canceled"})(k||(e.SearchErrorCode=k={}));class P extends Error{constructor(ae,$e){super(ae),this.code=$e}}e.$ZL=P;function h(se){const ae=se.message;if((0,a.$3)(se))return new P(ae,k.canceled);try{const $e=JSON.parse(ae);return new P($e.message,$e.code)}catch{return new P(ae,k.other)}}function b(se){const ae={message:se.message,code:se.code};return new Error(JSON.stringify(ae))}function M(se){return se.type==="error"?!0:se.type==="success"}function O(se){return se.type==="success"}function F(se){return!!se.path}function q(se,ae,$e=!0){const oe=se.searchPath?se.searchPath:se.relativePath;return $e?(0,A.$5f)(oe,ae):I.$vk(ae,oe)}class B{constructor(ae){this.path=ae,this.results=[]}addMatch(ae){this.results.push(ae)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$7L=B;function L(se,ae){const $e={...se||{},...ae||{}};return Object.keys($e).filter(oe=>{const Ce=$e[oe];return typeof Ce=="boolean"&&Ce})}class Y{constructor(ae,$e){this.c=null,this.a={...ae.excludePattern||{},...$e.excludePattern||{}},this.b=I.$wk(this.a);let oe=ae.includePattern;$e.includePattern&&(oe?oe={...oe,...$e.includePattern}:oe=$e.includePattern),oe&&(this.c=I.$wk(oe))}matchesExcludesSync(ae,$e,oe){return!!(this.b&&this.b(ae,$e,oe))}includedInQuerySync(ae,$e,oe){return!(this.b&&this.b(ae,$e,oe)||this.c&&!this.c(ae,$e,oe))}includedInQuery(ae,$e,oe){const Ce=this.b(ae,$e,oe),Fe=()=>this.c?!!this.c(ae,$e,oe):!0;return(0,y.$oh)(Ce)?Ce.then(X=>X?!1:Fe()):Fe()}hasSiblingExcludeClauses(){return Z(this.a)}}e.$9L=Y;function Z(se){for(const ae in se)if(typeof se[ae]!="boolean")return!0;return!1}function fe(se){if(!se)return;let ae;return $e=>(ae||(ae=(se()||Promise.resolve([])).then(oe=>oe?ge(oe):{})),ae.then(oe=>!!oe[$e]))}function _(se){if(!se)return;let ae;return $e=>{if(!ae){const oe=se();ae=oe?ge(oe):{}}return!!ae[$e]}}function ge(se){const ae={};for(const $e of se)ae[$e]=!0;return ae}}),define(Ne[45],Oe([1,0,17,10,21,6,4,58,15,139,23,12,2,9,29,3,11,172,49,50,26,16,8,7,65,44,5,40]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S,f,n,o,s,l,i,r,t,g,u,p,m,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Joc=e.$Ioc=void 0;function D(F,q,B){return new R.$5g(L=>h(L,B)).isEqual(F,q)}function w(F,q,B){return D(F.uri,q.uri,B)?0:(0,y.$wf)(F.uri.toString(),q.uri.toString())}function k(F,q,B){return F.index!==q.index?F.index<q.index?-1:1:D(F.uri,q.uri,B)?(0,y.$wf)(F.name,q.name):(0,y.$wf)(F.uri.toString(),q.uri.toString())}function P(F,q,B,L){const Y=F.slice(0).sort((fe,_)=>B(fe,_,L)),Z=q.slice(0).sort((fe,_)=>B(fe,_,L));return(0,v.$Db)(Y,Z,(fe,_)=>B(fe,_,L))}function h(F,q){const B=q.getCapabilities(F.scheme);return!(B&&B&f.FileSystemProviderCapabilities.PathCaseSensitive)}class b extends l.$Vi{static toExtHostWorkspace(q,B,L,Y){if(!q)return{workspace:null,added:[],removed:[]};const{id:Z,name:fe,folders:_,configuration:ge,transient:se,isUntitled:ae}=q,$e=[],oe=B;B?_.forEach((V,te)=>{const ve=c.URI.revive(V.uri),ce=b.o(L||B,ve,Y);ce?(ce.name=V.name,ce.index=V.index,$e.push(ce)):$e.push({uri:ve,name:V.name,index:te})}):$e.push(..._.map(({uri:V,name:te,index:ve})=>({uri:c.URI.revive(V),name:te,index:ve}))),$e.sort((V,te)=>V.index<te.index?-1:1);const Ce=new b(Z,fe,$e,!!se,ge?c.URI.revive(ge):null,!!ae,V=>h(V,Y)),{added:Fe,removed:X}=P(oe?oe.workspaceFolders:[],Ce.workspaceFolders,w,Y);return{workspace:Ce,added:Fe,removed:X}}static o(q,B,L){for(let Y=0;Y<q.folders.length;Y++){const Z=q.workspaceFolders[Y];if(D(Z.uri,B,L))return Z}}constructor(q,B,L,Y,Z,fe,_){super(q,L.map(ge=>new l.$Wi(ge)),Y,Z,_),this.t=B,this.u=fe,this.q=[],this.s=T.$Ii.forUris(_,()=>!0),L.forEach(ge=>{this.q.push(ge),this.s.set(ge.uri,ge)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(q,B){return B&&this.s.get(q)&&(q=(0,R.$ch)(q)),this.s.findSubstr(q)}resolveWorkspaceFolder(q){return this.s.get(q)}}let M=class{constructor(q,B,L,Y,Z){this.c=new N.$je,this.onDidChangeWorkspace=this.c.event,this.g=new N.$je,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new N.$le,this.C=new Map,this.h=Y,this.s=L,this.t=Z,this.j=new a.$Jm,this.k=new I.$Bh,this.o=q.getProxy(d.$sN.MainThreadWorkspace),this.q=q.getProxy(d.$sN.MainThreadMessageService);const fe=B.workspace;this.l=fe?new b(fe.id,fe.name,[],!!fe.transient,fe.configuration?c.URI.revive(fe.configuration):null,!!fe.isUntitled,_=>h(_,L)):void 0}$initializeWorkspace(q,B){this.v=B,this.$acceptWorkspaceData(q),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?c.URI.from({scheme:$.Schemas.untitled,path:(0,R.$ah)((0,R.$ch)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(q,B,L,...Y){const Z=[];if(Array.isArray(Y)&&Y.forEach(ae=>{c.URI.isUri(ae.uri)&&!Z.some($e=>D($e.uri,ae.uri,this.s))&&Z.push({uri:ae.uri,name:ae.name||(0,R.$_g)(ae.uri)})}),this.n||[B,L].some(ae=>typeof ae!="number"||ae<0)||L===0&&Z.length===0)return!1;const fe=this.x?this.x.workspaceFolders:[];if(B+L>fe.length)return!1;const _=fe.slice(0);_.splice(B,L,...Z.map(ae=>({uri:ae.uri,name:ae.name||(0,R.$_g)(ae.uri),index:void 0})));for(let ae=0;ae<_.length;ae++){const $e=_[ae];if(_.some((oe,Ce)=>Ce!==ae&&D($e.uri,oe.uri,this.s)))return!1}_.forEach((ae,$e)=>ae.index=$e);const{added:ge,removed:se}=P(fe,_,k,this.s);if(ge.length===0&&se.length===0)return!1;if(this.o){const ae=q.displayName||q.name;this.o.$updateWorkspaceFolders(ae,B,L,Z).then(void 0,$e=>{this.n=void 0;const oe={source:{identifier:q.identifier,label:q.displayName||q.name}};this.q.$showMessage(s.Severity.Error,(0,S.localize)(10655,null,ae,$e.toString()),oe,[])})}return this.y(_),!0}getWorkspaceFolder(q,B){if(this.x)return this.x.getWorkspaceFolder(q,B)}async getWorkspaceFolder2(q,B){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(q,B)}async resolveWorkspaceFolder(q){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(q)}getPath(){if(!this.x)return;const{folders:q}=this.x;if(q.length!==0)return q[0].uri.fsPath}getRelativePath(q,B){let L,Y="";if(typeof q=="string"?(L=c.URI.file(q),Y=q):typeof q<"u"&&(L=q,Y=q.fsPath),!L)return Y;const Z=this.getWorkspaceFolder(L,!0);if(!Z)return Y;typeof B>"u"&&this.x&&(B=this.x.folders.length>1);let fe=(0,R.$fh)(Z.uri,L);return B&&Z.name&&(fe=`${Z.name}/${fe}`),fe}y(q){this.x&&(this.n=b.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:q,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(q){const{workspace:B,added:L,removed:Y}=b.toExtHostWorkspace(q,this.l,this.n,this.s);this.l=B||void 0,this.n=void 0,this.c.fire(Object.freeze({added:L,removed:Y}))}findFiles(q,B,L,Y,Z=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${Y.value}, entryPoint: findFiles`);let fe="",_=!0;return B===null?_=!1:B!==void 0&&(typeof B=="string"?fe=B:fe=B.pattern),this.z(q,void 0,{exclude:fe,maxResults:L,useDefaultExcludes:_,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},Z)}findFiles2(q,B={},L,Y=C.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${L.value}, entryPoint: findFiles2`),this.z(void 0,q,B,Y)}async z(q,B,L,Y=C.CancellationToken.None){if(Y&&Y.isCancellationRequested)return Promise.resolve([]);const Z=typeof L.exclude=="string"?L.exclude:L.exclude?L.exclude.pattern:void 0,fe={ignoreSymlinks:typeof L.followSymlinks=="boolean"?!L.followSymlinks:void 0,disregardIgnoreFiles:typeof L.useIgnoreFiles=="boolean"?!L.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof L.useGlobalIgnoreFiles=="boolean"?!L.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof L.useParentIgnoreFiles=="boolean"?!L.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof L.useDefaultExcludes=="boolean"?!L.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof L.useDefaultSearchExcludes=="boolean"?!L.useDefaultSearchExcludes:!1,maxResults:L.maxResults,excludePattern:Z,shouldGlobSearch:typeof L.fuzzy=="boolean"?!L.fuzzy:!0,_reason:"startFileSearch"};let _;if(q){const{includePattern:ge,folder:se}=O(g.GlobPattern.from(q));_=se,fe.includePattern=ge}else{const{includePattern:ge,folder:se}=O(g.GlobPattern.from(B));_=se,fe.filePattern=ge}return this.o.$startFileSearch(_??null,fe,Y).then(ge=>Array.isArray(ge)?ge.map(se=>c.URI.revive(se)):[])}async findTextInFiles(q,B,L,Y,Z=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${Y.value}, entryPoint: findTextInFiles`);const fe=this.j.getNext(),_=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:ge,folder:se}=O(g.GlobPattern.from(B.include)),ae=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,$e={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:_,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:ge,excludePattern:ae},oe=!1;if(this.u[fe]=Ce=>{if(oe)return;const Fe=c.URI.revive(Ce.resource);Ce.results.forEach(X=>{const V=(0,E.$_h)(X);(0,m.$QL)(V)?L({uri:Fe,preview:{text:V.preview.text,matches:(0,v.$Zb)(V.preview.matches,te=>new u.$wN(te.startLineNumber,te.startColumn,te.endLineNumber,te.endColumn))},ranges:(0,v.$Zb)(V.ranges,te=>new u.$wN(te.startLineNumber,te.startColumn,te.endLineNumber,te.endColumn))}):L({uri:Fe,text:V.text,lineNumber:V.lineNumber})})},Z.isCancellationRequested)return{};try{const Ce=await this.o.$startTextSearch(q,se??null,$e,fe,Z);return delete this.u[fe],Ce||{}}catch(Ce){throw delete this.u[fe],Ce}}$handleTextSearchResult(q,B){this.u[B]?.(q)}async save(q){const B=await this.o.$save(q,{saveAs:!1});return c.URI.revive(B)}async saveAs(q){const B=await this.o.$save(q,{saveAs:!0});return c.URI.revive(B)}saveAll(q){return this.o.$saveAll(q)}resolveProxy(q){return this.o.$resolveProxy(q)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(q){return this.o.$requestWorkspaceTrust(q)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(q,B){if(this.w.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this.w.set(q,B);const L=this.t.transformOutgoingScheme(q),Y=this.A++;return this.o.$registerEditSessionIdentityProvider(Y,L),(0,A.$Rc)(()=>{this.w.delete(q),this.o.$unregisterEditSessionIdentityProvider(Y)})}async $getEditSessionIdentifier(q,B){this.h.info("Getting edit session identifier for workspaceFolder",q);const L=await this.resolveWorkspaceFolder(c.URI.revive(q));if(!L){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",L);const Y=this.w.get(L.uri.scheme);if(this.h.info(`Provider for scheme ${L.uri.scheme} is defined: `,!!Y),!Y)return;const Z=await Y.provideEditSessionIdentity(L,B);if(this.h.info("Provider returned edit session identifier: ",Z),!!Z)return Z}async $provideEditSessionIdentityMatch(q,B,L,Y){this.h.info("Getting edit session identifier for workspaceFolder",q);const Z=await this.resolveWorkspaceFolder(c.URI.revive(q));if(!Z){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",Z);const fe=this.w.get(Z.uri.scheme);if(this.h.info(`Provider for scheme ${Z.uri.scheme} is defined: `,!!fe),!fe)return;const _=await fe.provideEditSessionIdentityMatch?.(B,L,Y);if(this.h.info("Provider returned edit session identifier match result: ",_),!!_)return _}getOnWillCreateEditSessionIdentityEvent(q){return(B,L,Y)=>{const Z=function(_){B.call(L,_)};return Z.extension=q,this.B.event(Z,void 0,Y)}}async $onWillCreateEditSessionIdentity(q,B,L){const Y=await this.resolveWorkspaceFolder(c.URI.revive(q));if(Y===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:Y},B,async(Z,fe)=>{const _=Date.now();await Promise.resolve(Z),Date.now()-_>L&&this.h.warn("SLOW edit session create-participant",fe.extension.identifier)}),B.isCancellationRequested}registerCanonicalUriProvider(q,B){if(this.C.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this.C.set(q,B);const L=this.t.transformOutgoingScheme(q),Y=this.A++;return this.o.$registerCanonicalUriProvider(Y,L),(0,A.$Rc)(()=>{this.C.delete(q),this.o.$unregisterCanonicalUriProvider(Y)})}async provideCanonicalUri(q,B,L){const Y=this.C.get(q.scheme);if(!Y)return;const Z=await Y.provideCanonicalUri?.(c.URI.revive(q),B,L);if(Z)return Z}async $provideCanonicalUri(q,B,L){return this.provideCanonicalUri(c.URI.revive(q),{targetScheme:B},L)}};e.$Ioc=M,e.$Ioc=M=Qe([qe(0,t.$1P),qe(1,r.$eQ),qe(2,i.$roc),qe(3,o.$9j),qe(4,p.$Goc)],M),e.$Joc=(0,n.$Ci)("IExtHostWorkspace");function O(F){let q,B;return F&&(typeof F=="string"?q=F:(q=F.pattern,B=c.URI.revive(F.baseUri))),{includePattern:q,folder:B}}}),define(Ne[46],Oe([1,0,25,6,45,5,7,43,173,53,14,10,3,16,11,2]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Moc=e.$Loc=e.$Koc=void 0;function o(p,m){if(m){const d=m.split(".");let E=p;for(let D=0;E&&D<d.length;D++)E=E[d[D]];return E}}function s(p){return p instanceof n.URI}function l(p){return p&&p.uri instanceof n.URI&&p.languageId&&typeof p.languageId=="string"}function i(p){return p&&!p.uri&&p.languageId&&typeof p.languageId=="string"}function r(p){return p&&p.uri instanceof n.URI&&(!p.name||typeof p.name=="string")&&(!p.index||typeof p.index=="number")}function t(p){if(s(p))return{resource:p};if(l(p))return{resource:p.uri,overrideIdentifier:p.languageId};if(i(p))return{overrideIdentifier:p.languageId};if(r(p))return{resource:p.uri};if(p===null)return{resource:null}}let g=class{constructor(m,d,E){this.a=m.getProxy(N.$sN.MainThreadConfiguration),this.c=d,this.b=E,this.d=new y.$Bh,this.e=null}getConfigProvider(){return this.d.wait().then(m=>this.e)}$initializeConfiguration(m){this.e=new u(this.a,this.c,m,this.b),this.d.open()}$acceptConfigurationChanged(m,d){this.getConfigProvider().then(E=>E.$acceptConfigurationChanged(m,d))}};e.$Koc=g,e.$Koc=g=Qe([qe(0,S.$1P),qe(1,C.$Joc),qe(2,f.$9j)],g);class u{constructor(m,d,E,D){this.a=new I.$je,this.b=m,this.f=D,this.c=d,this.e=$.$No.parse(E,D),this.d=this.k(E.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(m,d){const E={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$No.parse(m,this.f),this.d=this.k(m.configurationScopes),this.a.fire(this.j(d,E))}getConfiguration(m,d,E){const D=t(d)||{},w=this.g(m?o(this.e.getValue(void 0,D,this.c.workspace),m):this.e.getValue(void 0,D,this.c.workspace));m&&this.h(m,D,E?.identifier);function k(h){if(h==null)return null;if(typeof h=="boolean")return h?T.ConfigurationTarget.USER:T.ConfigurationTarget.WORKSPACE;switch(h){case A.ConfigurationTarget.Global:return T.ConfigurationTarget.USER;case A.ConfigurationTarget.Workspace:return T.ConfigurationTarget.WORKSPACE;case A.ConfigurationTarget.WorkspaceFolder:return T.ConfigurationTarget.WORKSPACE_FOLDER}}const P={has(h){return typeof o(w,h)<"u"},get:(h,b)=>{this.h(m?`${m}.${h}`:h,D,E?.identifier);let M=o(w,h);if(typeof M>"u")M=b;else{let O;const F=(q,B)=>{if((0,R.$eg)(q)){let L;const Y=()=>{O=O||(0,v.$ao)(w),L=L||o(O,B)};return new Proxy(q,{get:(Z,fe)=>{if(typeof fe=="string"&&fe.toLowerCase()==="tojson")return Y(),()=>L;if(O)return L=L||o(O,B),L[fe];const _=Z[fe];return typeof fe=="string"?F(_,`${B}.${fe}`):_},set:(Z,fe,_)=>(Y(),L&&(L[fe]=_),!0),deleteProperty:(Z,fe)=>(Y(),L&&delete L[fe],!0),defineProperty:(Z,fe,_)=>(Y(),L&&Object.defineProperty(L,fe,_),!0)})}return Array.isArray(q)?(0,v.$ao)(q):q};M=F(M,h)}return M},update:(h,b,M,O)=>{h=m?`${m}.${h}`:h;const F=k(M);return b!==void 0?this.b.$updateConfigurationOption(F,h,b,D,O):this.b.$removeConfigurationOption(F,h,D,O)},inspect:h=>{h=m?`${m}.${h}`:h;const b=this.e.inspect(h,D,this.c.workspace);if(b)return{key:h,defaultValue:(0,v.$ao)(b.policy?.value??b.default?.value),globalValue:(0,v.$ao)(b.user?.value??b.application?.value),workspaceValue:(0,v.$ao)(b.workspace?.value),workspaceFolderValue:(0,v.$ao)(b.workspaceFolder?.value),defaultLanguageValue:(0,v.$ao)(b.default?.override),globalLanguageValue:(0,v.$ao)(b.user?.override??b.application?.override),workspaceLanguageValue:(0,v.$ao)(b.workspace?.override),workspaceFolderLanguageValue:(0,v.$ao)(b.workspaceFolder?.override),languageIds:(0,v.$ao)(b.overrideIdentifiers)}}};return typeof w=="object"&&(0,v.$do)(P,w,!1),Object.freeze(P)}g(m){const d=E=>(0,R.$eg)(E)?new Proxy(E,{get:(D,w)=>d(D[w]),set:(D,w,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(w)}' of object`)},deleteProperty:(D,w)=>{throw new Error(`TypeError: Cannot delete read only property '${String(w)}' of object`)},defineProperty:(D,w)=>{throw new Error(`TypeError: Cannot define property '${String(w)}' for a readonly object`)},setPrototypeOf:D=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):E;return d(m)}h(m,d,E){const D=a.$Co.test(m)?a.ConfigurationScope.RESOURCE:this.d.get(m),w=E?`[${E.value}] `:"";if(a.ConfigurationScope.RESOURCE===D){typeof d?.resource>"u"&&this.f.warn(`${w}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${m}', provide the URI of a resource or 'null' for any resource.`);return}if(a.ConfigurationScope.WINDOW===D){d?.resource&&this.f.warn(`${w}Accessing a window scoped configuration for a resource is not expected. To associate '${m}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(m,d){const E=new $.$Po(m,d,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(D,w)=>E.affectsConfiguration(D,t(w))})}k(m){return m.reduce((d,E)=>(d.set(E[0],E[1]),d),new Map)}}e.$Loc=u,e.$Moc=(0,c.$Ci)("IExtHostConfiguration")}),define(Ne[131],Oe([1,0,2,10,6,5,7,45,57,46,21,56,16,26,3,15,20,11,84,208,13]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S,f,n,o,s,l,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kqc=e.$jqc=e.$iqc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,A=Ve(A),o=Ve(o);var t;(function(O){function F(B){if(B!=null)return B}O.from=F;function q(B){if(B!=null)return B}O.to=q})(t||(t={}));var g;(function(O){function F(B){if(B!=null)return B}O.from=F;function q(B){if(B!=null)return B}O.to=q})(g||(g={}));var u;(function(O){function F(B){if(B!=null)return B}O.from=F;function q(B){if(B!=null)return B}O.to=q})(u||(u={}));var p;(function(O){function F(L){if(L){const Y=L;return Y&&!!Y.process}else return!1}O.is=F;function q(L){if(L==null)return;const Y={process:L.process,args:L.args};return L.options&&(Y.options=u.from(L.options)),Y}O.from=q;function B(L){if(L!=null)return new A.$eO(L.process,L.args,L.options)}O.to=B})(p||(p={}));var m;(function(O){function F(B){if(B!=null)return B}O.from=F;function q(B){if(B!=null)return B}O.to=q})(m||(m={}));var d;(function(O){function F(L){if(L){const Y=L;return Y&&(!!Y.commandLine||!!Y.command)}else return!1}O.is=F;function q(L){if(L==null)return;const Y={};return L.commandLine!==void 0?Y.commandLine=L.commandLine:(Y.command=L.command,Y.args=L.args),L.options&&(Y.options=m.from(L.options)),Y}O.from=q;function B(L){if(!(L==null||L.command===void 0&&L.commandLine===void 0))return L.commandLine?new A.$fO(L.commandLine,L.options):new A.$fO(L.command,L.args?L.args:[],L.options)}O.to=B})(d||(d={}));var E;(function(O){function F(L){if(L){const Y=L;return Y&&Y.customExecution==="customExecution"}else return!1}O.is=F;function q(L){return{customExecution:"customExecution"}}O.from=q;function B(L,Y){return Y.get(L)}O.to=B})(E||(e.CustomExecutionDTO=E={}));var D;(function(O){function F(q,B){let L;return q.scope!==void 0&&typeof q.scope!="number"?L=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===A.TaskScope.Workspace&&B&&B.workspaceFile?L=B.workspaceFile:L=i.$GI),{id:q._id,workspaceFolder:L}}O.from=F})(D||(e.TaskHandleDTO=D={}));var w;(function(O){function F(q){if(q!=null)return{_id:q.id,isDefault:q.isDefault}}O.from=F})(w||(w={}));var k;(function(O){function F(L,Y){if(L==null)return[];const Z=[];for(const fe of L){const _=q(fe,Y);_&&Z.push(_)}return Z}O.fromMany=F;function q(L,Y){if(L==null)return;let Z;L.execution instanceof A.$eO?Z=p.from(L.execution):L.execution instanceof A.$fO?Z=d.from(L.execution):L.execution&&L.execution instanceof A.$gO&&(Z=E.from(L.execution));const fe=t.from(L.definition);let _;return L.scope?typeof L.scope=="number"?_=L.scope:_=L.scope.uri:_=A.TaskScope.Workspace,!fe||!_?void 0:{_id:L._id,definition:fe,name:L.name,source:{extensionId:Y.identifier.value,label:L.source,scope:_},execution:Z,isBackground:L.isBackground,group:w.from(L.group),presentationOptions:g.from(L.presentationOptions),problemMatchers:L.problemMatchers,hasDefinedMatchers:L.hasDefinedMatchers,runOptions:L.runOptions?L.runOptions:{reevaluateOnRerun:!0},detail:L.detail}}O.from=q;async function B(L,Y,Z){if(L==null)return;let fe;p.is(L.execution)?fe=p.to(L.execution):d.is(L.execution)?fe=d.to(L.execution):E.is(L.execution)&&(fe=E.to(L._id,Z));const _=t.to(L.definition);let ge;if(L.source&&(L.source.scope!==void 0?typeof L.source.scope=="number"?ge=L.source.scope:ge=await Y.resolveWorkspaceFolder(v.URI.revive(L.source.scope)):ge=A.TaskScope.Workspace),!_||!ge)return;const se=new A.$hO(_,ge,L.name,L.source.label,fe,L.problemMatchers);return L.isBackground!==void 0&&(se.isBackground=L.isBackground),L.group!==void 0&&(se.group=A.$dO.from(L.group._id),se.group&&L.group.isDefault&&(se.group=new A.$dO(se.group.id,se.group.label),L.group.isDefault===!0&&(se.group.isDefault=L.group.isDefault))),L.presentationOptions&&(se.presentationOptions=g.to(L.presentationOptions)),L._id&&(se._id=L._id),L.detail&&(se.detail=L.detail),se}O.to=B})(k||(e.TaskDTO=k={}));var P;(function(O){function F(B){return B}O.from=F;function q(B){if(B)return Object.assign(Object.create(null),B)}O.to=q})(P||(P={}));class h{#e;constructor(F,q,B){this._id=q,this.a=B,this.#e=F}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(F){}fireDidEndProcess(F){}}let b=class{constructor(F,q,B,L,Y,Z,fe,_){this.q=new C.$je,this.r=new C.$je,this.s=new C.$je,this.u=new C.$je,this.a=F.getProxy(N.$sN.MainThreadTask),this.b=B,this.c=L,this.d=Y,this.e=Z,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=fe,this.g=_,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(F,q,B){if(!B)return new A.$uN(()=>{});const L=this.x();return this.j.set(L,{type:q,provider:B,extension:F}),this.a.$registerTaskProvider(L,q),new A.$uN(()=>{this.j.delete(L),this.a.$unregisterTaskProvider(L)})}registerTaskSystem(F,q){this.a.$registerTaskSystem(F,q)}fetchTasks(F){return this.a.$fetchTasks(P.from(F)).then(async q=>{const B=[];for(const L of q){const Y=await k.to(L,this.b,this.m);Y&&B.push(Y)}return B})}get taskExecutions(){const F=[];return this.k.forEach(q=>F.push(q)),F}terminateTask(F){if(!(F instanceof h))throw new Error("No valid task execution provided");return this.a.$terminateTask(F._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(F,q,B){const L=this.m.get(F.id);L&&(this.o.set(F.id,L),this.e.attachPtyToTerminal(q,await L.callback(B))),this.p=F.id,this.q.fire({execution:await this.z(F)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(F){if(!this.l.has(F.id))return;const q=await this.z(F);this.l.delete(F.id),this.k.delete(F.id),this.B(F),this.r.fire({execution:q})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(F){const q=await this.z(F.id);this.s.fire({execution:q,processId:F.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(F){const q=await this.z(F.id);this.u.fire({execution:q,exitCode:F.exitCode})}$provideTasks(F,q){const B=this.j.get(F);if(!B)return Promise.reject(new Error("no handler found"));const L=[],Y=(0,I.$uh)(()=>B.provider.provideTasks(R.CancellationToken.None)).then(Z=>this.v(q,L,B,Z));return new Promise(Z=>{Y.then(fe=>{Promise.all(L).then(()=>{Z(fe)})})})}async $resolveTask(F,q){const B=this.j.get(F);if(!B)return Promise.reject(new Error("no handler found"));if(q.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${B.type}].`);const L=await k.to(q,this.b,this.m);if(!L)throw new Error("Unexpected: Task cannot be resolved.");const Y=await B.provider.resolveTask(L,R.CancellationToken.None);if(!Y)return;this.A(Y,B);const Z=k.from(Y,B.extension);if(!Z)throw new Error("Unexpected: Task cannot be resolved.");if(Y.definition!==L.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return E.is(Z.execution)&&await this.y(Z,Y,!0),await this.w(Z)}x(){return this.h++}async y(F,q,B){const L=await this.a.$createTaskId(F);!B&&!this.m.has(L)&&(this.n.add(L),this.o.set(L,q.execution)),this.m.set(L,q.execution)}async z(F,q){if(typeof F=="string"){const Y=this.l.get(F);if(!Y)throw new r.$ab("Unexpected: The specified task is missing an execution");return Y}const B=this.l.get(F.id);if(B)return B;let L;return q?L=Promise.resolve(new h(this,F.id,q)):L=k.to(F.task,this.b,this.m).then(Y=>{if(!Y)throw new r.$ab("Unexpected: Task does not exist.");return new h(this,F.id,Y)}),this.l.set(F.id,L),L.then(Y=>(this.k.set(F.id,Y),Y))}A(F,q){F._deprecated&&this.g.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}B(F){this.o.get(F.id)&&this.o.delete(F.id),this.n.has(F.id)&&this.p!==F.id&&(this.m.delete(F.id),this.n.delete(F.id));const B=this.n.values();let L=B.next();for(;!L.done;)!this.o.has(L.value)&&this.p!==L.value&&(this.m.delete(L.value),this.n.delete(L.value)),L=B.next()}};e.$iqc=b,e.$iqc=b=Qe([qe(0,c.$1P),qe(1,S.$eQ),qe(2,T.$Joc),qe(3,$.$_P),qe(4,a.$Moc),qe(5,y.$$oc),qe(6,s.$9j),qe(7,l.$noc)],b);let M=class extends b{constructor(F,q,B,L,Y,Z,fe,_){super(F,q,B,L,Y,Z,fe,_),this.registerTaskSystem(n.Schemas.vscodeRemote,{scheme:n.Schemas.vscodeRemote,authority:"",platform:o.$i(o.Platform.Web)})}async executeTask(F,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const B=k.from(q,F);if(B===void 0)throw new Error("Task is not valid");if(E.is(B.execution))await this.y(B,q,!1);else throw new r.$$;const L=await this.z(await this.a.$getTaskExecution(B),q);return this.a.$executeTask(B).catch(Y=>{throw new Error(Y)}),L}v(F,q,B,L){const Y=[];if(L)for(const Z of L){if(this.A(Z,B),!Z.definition||!F[Z.definition.type]){const _=Z.source?Z.source:"No task source";this.f.warn(`The task [${_}, ${Z.name}] uses an undefined task type. The task will be ignored in the future.`)}const fe=k.from(Z,B.extension);fe&&E.is(fe.execution)?(Y.push(fe),q.push(this.y(fe,Z,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:Y,extension:B.extension}}async w(F){if(E.is(F.execution))return F;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(F,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(F,q,B){}};e.$jqc=M,e.$jqc=M=Qe([qe(0,c.$1P),qe(1,S.$eQ),qe(2,T.$Joc),qe(3,$.$_P),qe(4,a.$Moc),qe(5,y.$$oc),qe(6,s.$9j),qe(7,l.$noc)],M),e.$kqc=(0,f.$Ci)("IExtHostTask")}),define(Ne[267],Oe([1,0,44,32]),function(we,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fM=void 0,e.$eM=C,e.$gM=N;function C(A){return"cellResults"in A}e.$fM="rawCell#";function N(A,T){let $=-1;const a=[];let R=[];return A.forEach(c=>{c.range.startLineNumber!==$&&R.length>0&&(a.push([...R]),R=[]),R.push(c),$=c.range.endLineNumber}),R.length>0&&a.push([...R]),a.map(c=>{const S=[],f=c[0].range.startLineNumber,n=c[c.length-1].range.endLineNumber;for(let o=f;o<=n;o++)S.push(T.getLineContent(o));return new v.$UL(S.join(`
`)+`
`,c.map(o=>new I.$Kt(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(Ne[268],Oe([1,0,9,22,6,4,28,36,12,14,2,29,79,5,33,8,7,38,245,124,25,15,44,198,267,265]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S,f,n,o,s,l,i,r,t,g,u,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wpc=void 0,y=Ve(y),n=Ve(n),o=Ve(o);class d{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(D=>D.apiEditor)}constructor(D,w,k,P,h,b,M){this.q=k,this.r=P,this.s=h,this.t=b,this.u=M,this.f=new Map,this.g=new A.$zc,this.h=new Map,this.j=new C.$je,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$je,this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$je,this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$je,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new c.$loc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=D.getProxy(S.$sN.MainThreadNotebook),this.c=D.getProxy(S.$sN.MainThreadNotebookDocuments),this.d=D.getProxy(S.$sN.MainThreadNotebookEditors),this.i=w.converter,w.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===T.MarshalledId.NotebookCellActionContext){const F=O.notebookEditor?.notebookUri,q=O.cell.handle,L=this.g.get(F)?.getCell(q);if(L)return L.apiCell}if(O&&O.$mid===T.MarshalledId.NotebookActionContext){const F=O.uri,q=this.g.get(F);if(q)return q.apiNotebook}return O}}),d.C(w)}getEditorById(D){const w=this.h.get(D);if(!w)throw new Error(`unknown text editor: ${D}. known editors: ${[...this.h.keys()]} `);return w}getIdByEditor(D){for(const[w,k]of this.h)if(k.apiEditor===D)return w}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(D,w){const k=this.g.get(D);if(!k&&!w)throw new Error(`NO notebook document for '${D}'`);return k}static w(D,w){if(!w)return;const k=w.filenamePattern.map(P=>n.NotebookExclusiveDocumentPattern.from(P)).filter(P=>P!==void 0);if(w.filenamePattern&&!k){console.warn(`Notebook content provider view options file name pattern is invalid ${w.filenamePattern}`);return}return{extension:D.identifier,providerDisplayName:D.displayName||D.name,displayName:w.displayName,filenamePattern:k,priority:w.exclusive?m.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(D,w,k){const P=d.a++,h=typeof k.onDidChangeCellStatusBarItems=="function"?d.a++:void 0;this.f.set(P,k),this.b.$registerNotebookCellStatusBarItemProvider(P,h,w);let b;return h!==void 0&&(b=k.onDidChangeCellStatusBarItems(M=>this.b.$emitCellStatusBarEvent(h))),new o.$uN(()=>{this.f.delete(P),this.b.$unregisterNotebookCellStatusBarItemProvider(P,h),b?.dispose()})}async createNotebookDocument(D){const w=await this.c.$tryCreateNotebook({viewType:D.viewType,content:D.content&&n.NotebookData.from(D.content)});return R.URI.revive(w)}async openNotebookDocument(D){const w=this.g.get(D);if(w)return w.apiNotebook;const k=await this.c.$tryOpenNotebook(D),P=this.g.get(R.URI.revive(k));return(0,a.$ng)(P?.apiNotebook)}async showNotebookDocument(D,w){R.URI.isUri(D)&&(D=await this.openNotebookDocument(D));let k;typeof w=="object"?k={position:n.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selections:w.selections&&w.selections.map(n.NotebookRange.from),pinned:typeof w.preview=="boolean"?!w.preview:void 0}:k={preserveFocus:!1};const P=await this.d.$tryShowNotebookDocument(D.uri,D.notebookType,k),h=P&&this.h.get(P)?.apiEditor;if(h)return h;throw P?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(D,w,k,P){const h=this.f.get(D),b=R.URI.revive(w),M=this.g.get(b);if(!M||!h)return;const O=M.getCellFromIndex(k);if(!O)return;const F=await h.provideCellStatusBarItems(O.apiCell,P);if(!F)return;const q=new N.$Sc,B=this.p.add([q]),Y=(Array.isArray(F)?F:[F]).map(Z=>n.NotebookStatusBarItem.from(Z,this.i,q));return{cacheId:B,items:Y}}$releaseNotebookCellStatusBarItems(D){this.p.delete(D)}registerNotebookSerializer(D,w,k,P,h){if((0,$.$af)(w))throw new Error("viewType cannot be empty or just whitespace");const b=this.x++;return this.y.set(b,{viewType:w,serializer:k,options:P}),this.b.$registerNotebookSerializer(b,{id:D.identifier,location:D.extensionLocation},w,n.NotebookDocumentContentOptions.from(P),d.w(D,h)),(0,N.$Rc)(()=>{this.b.$unregisterNotebookSerializer(b)})}async $dataToNotebook(D,w,k){const P=this.y.get(D);if(!P)throw new Error("NO serializer found");const h=await P.serializer.deserializeNotebook(w.buffer,k);return new s.$Sw(n.NotebookData.from(h))}async $notebookToData(D,w,k){const P=this.y.get(D);if(!P)throw new Error("NO serializer found");const h=await P.serializer.serializeNotebook(n.NotebookData.to(w.value),k);return I.$Le.wrap(h)}async $saveNotebook(D,w,k,P,h){const b=R.URI.revive(w),M=this.y.get(D);if(this.D(`enter saveNotebook(versionId: ${k}, ${b.toString()})`),!M)throw new Error("NO serializer found");const O=this.g.get(b);if(!O)throw new Error("Document NOT found");if(O.versionId!==k)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(b.scheme))throw new y.$rl((0,v.localize)(10663,null,this.A(b)),y.FileOperationResult.FILE_PERMISSION_DENIED);const F={metadata:(0,r.$io)(O.apiNotebook.metadata,Z=>!(M.options?.transientDocumentMetadata??{})[Z]),cells:[]};for(const Z of O.apiNotebook.getCells()){const fe=new o.$XO(Z.kind,Z.document.getText(),Z.document.languageId,Z.mime,M.options?.transientOutputs?[]:[...Z.outputs],Z.metadata,Z.executionSummary);fe.metadata=(0,r.$io)(Z.metadata,_=>!(M.options?.transientCellMetadata??{})[_]),F.cells.push(fe)}if(await this.z(b,P),h.isCancellationRequested)throw new Error("canceled");const q=await M.serializer.serializeNotebook(F,h);if(h.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${k} ${b.toString()}`),await this.s.value.writeFile(b,q),this.D(`Finished write versionId: ${k} ${b.toString()}`);const B=this.s.getFileSystemProviderExtUri(b.scheme),L=await this.s.value.stat(b),Y={name:B.basename(b),isFile:(L.type&y.FileType.File)!==0,isDirectory:(L.type&y.FileType.Directory)!==0,isSymbolicLink:(L.type&y.FileType.SymbolicLink)!==0,mtime:L.mtime,ctime:L.ctime,size:L.size,readonly:!!((L.permissions??0)&y.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(b.scheme),locked:!!((L.permissions??0)&y.FilePermission.Locked),etag:y.$Cl({mtime:L.mtime,size:L.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${k}, ${b.toString()})`),Y}async $searchInNotebooks(D,w,k,P,h){const b=this.y.get(D)?.serializer;if(!b)return{limitHit:!1,results:[]};const M=new A.$Ac;await(async(L,Y,Z)=>{await Promise.all(L.map(async fe=>await Promise.all(fe.filenamePatterns.map(_=>{const ge={_reason:Z._reason,folderQueries:Z.folderQueries,includePattern:Z.includePattern,excludePattern:Z.excludePattern,maxResults:Z.maxResults,type:g.QueryType.File,filePattern:_};return this.t.doInternalFileSearchWithCustomCallback(ge,Y,se=>{se.forEach(ae=>{M.has(ae)||P.some(oe=>fe.isFromSettings&&!oe.isFromSettings?!1:oe.filenamePatterns.some(Ce=>(0,m.$bL)(Ce,ae)))||M.add(ae)})}).catch(se=>{if(se.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw se})}))))})(k,h,w);const F=new A.$zc;let q=!1;const B=Array.from(M).map(async L=>{const Y=[];try{if(h.isCancellationRequested)return;if(w.maxResults&&[...F.values()].reduce((ge,se)=>ge+se.cellResults.length,0)>w.maxResults){q=!0;return}const Z=[],fe=this.g.get(L);if(fe)fe.apiNotebook.getCells().forEach(se=>Z.push({input:se.document.getText(),outputs:se.outputs.flatMap(ae=>ae.items.map($e=>$e.data.toString()))}));else{const ge=await this.s.value.readFile(L),se=I.$Le.fromString(ge.toString()),ae=await b.deserializeNotebook(se.buffer,h);if(h.isCancellationRequested)return;n.NotebookData.from(ae).cells.forEach(oe=>Z.push({input:oe.source,outputs:oe.outputs.flatMap(Ce=>Ce.items.map(Fe=>Fe.valueBytes.toString()))}))}if(h.isCancellationRequested)return;Z.forEach((ge,se)=>{const ae=w.contentPattern.pattern,$e=new u.$BZb(ge.input,void 0,ge.outputs),oe=$e.findInInputs(ae),Ce=$e.findInOutputs(ae),Fe=Ce.flatMap(X=>(0,p.$gM)(X.matches,X.textBuffer)).map((X,V)=>(X.webviewIndex=V,X));if(oe.length>0||Ce.length>0){const X={index:se,contentResults:(0,p.$gM)(oe,$e.inputTextBuffer),webviewResults:Fe};Y.push(X)}});const _={resource:L,cellResults:Y};F.set(L,_);return}catch{return}});return await Promise.all(B),{limitHit:q,results:[...F.values()]}}async z(D,w){const k=await this.s.value.stat(D);if(typeof w?.mtime=="number"&&typeof w.etag=="string"&&w.etag!==y.$Bl&&typeof k.mtime=="number"&&typeof k.size=="number"&&w.mtime<k.mtime&&w.etag!==y.$Cl({mtime:w.mtime,size:k.size}))throw new y.$rl((0,v.localize)(10664,null),y.FileOperationResult.FILE_MODIFIED_SINCE,w)}A(D){return D.scheme===t.Schemas.file?D.fsPath:D.toString()}B(D,w,k){if(this.h.has(w))throw new Error(`editor with id ALREADY EXSIST: ${w}`);const P=new i.$Npc(w,this.d,D,k.visibleRanges.map(n.NotebookRange.to),k.selections.map(n.NotebookRange.to),typeof k.viewColumn=="number"?n.ViewColumn.to(k.viewColumn):void 0);this.h.set(w,P)}$acceptDocumentAndEditorsDelta(D){if(D.value.removedDocuments)for(const k of D.value.removedDocuments){const P=R.URI.revive(k),h=this.g.get(P);h&&(h.dispose(),this.g.delete(P),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:h.apiNotebook.getCells().map(b=>b.document.uri)}),this.n.fire(h.apiNotebook));for(const b of this.h.values())b.notebookData.uri.toString()===P.toString()&&this.h.delete(b.id)}if(D.value.addedDocuments){const k=[];for(const P of D.value.addedDocuments){const h=R.URI.revive(P.uri);if(this.g.has(h))throw new Error(`adding EXISTING notebook ${h} `);const b=new l.$Mpc(this.c,this.q,this.r,h,P);k.push(...P.cells.map(M=>l.$Lpc.asModelAddData(M))),this.g.get(h)?.dispose(),this.g.set(h,b),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:k}),this.m.fire(b.apiNotebook)}}if(D.value.addedEditors)for(const k of D.value.addedEditors){if(this.h.has(k.id))return;const P=R.URI.revive(k.documentUri),h=this.g.get(P);h&&this.B(h,k.id,k)}const w=[];if(D.value.removedEditors)for(const k of D.value.removedEditors){const P=this.h.get(k);P&&(this.h.delete(k),this.k?.id===P.id&&(this.k=void 0),w.push(P))}if(D.value.visibleEditors){this.l=D.value.visibleEditors.map(P=>this.h.get(P)).filter(P=>!!P);const k=new Set;this.l.forEach(P=>k.add(P.id));for(const P of this.h.values()){const h=k.has(P.id);P._acceptVisibility(h)}this.l=[...this.h.values()].map(P=>P).filter(P=>P.visible),this.o.fire(this.visibleNotebookEditors)}D.value.newActiveEditor===null?this.k=void 0:D.value.newActiveEditor&&(this.h.get(D.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${D.value.newActiveEditor}`),this.k=this.h.get(D.value.newActiveEditor)),D.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(D){const w=f.$mQ.String.with("notebookType","A notebook type"),k=new f.$oQ("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[w,new f.$mQ("data","Bytes to convert to data",h=>h instanceof Uint8Array,h=>I.$Le.wrap(h))],new f.$nQ("Notebook Data",h=>n.NotebookData.to(h.value))),P=new f.$oQ("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[w,new f.$mQ("NotebookData","Notebook data to convert to bytes",h=>!0,h=>new s.$Sw(n.NotebookData.from(h)))],new f.$nQ("Bytes",h=>h.buffer));D.registerApiCommand(k),D.registerApiCommand(P)}D(D){this.u.trace(`[Extension Host Notebook] ${D}`)}}e.$Wpc=d}),define(Ne[269],Oe([1,0,19,21,42,41,23,69,44]),function(we,e,v,I,C,N,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Opc=void 0,v=Ve(v),N=Ve(N),A=Ve(A);class a{constructor(c,S,f){this.k=c,this.l=S,this.o=f,this.e=!1,this.f=0,this.g=!1,this.a=c.filePattern,this.b=c.includePattern&&N.$wk(c.includePattern),this.c=c.maxResults||void 0,this.d=c.exists,this.h=new Set,this.j=c.excludePattern&&N.$wk(c.excludePattern)}cancel(){this.g=!0,this.h.forEach(c=>c.cancel()),this.h=new Set}search(c){const S=this.k.folderQueries||[];return new Promise((f,n)=>{const o=s=>{this.f++,c(s)};if(this.g)return f({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const l=s.toString(),i=v.$mc(l);this.j&&this.j(l,i)||this.v(o,{base:s,basename:i})}),Promise.all(S.map(s=>this.p(s,o))).then(s=>{f({limitHit:this.e,stats:s[0]||void 0})},s=>{n(new Error((0,C.$nj)(s)))})})}async p(c,S){const f=new I.$ue,n=this.q(c),o=this.r(),s=new $.$9L(this.k,c),l=!s.hasSiblingExcludeClauses();let i;try{this.h.add(f),i=T.$de.create();const r=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},n,f.token),t=i.elapsed(),g=T.$de.create();return this.g&&!this.e||(r&&r.forEach(u=>{const p=v.$fc.relative(c.folder.path,u.path);if(l){const m=v.$mc(u.path);this.v(S,{base:c.folder,relativePath:p,basename:m});return}this.s(o,c.folder,p,S)}),this.g&&!this.e)?null:(this.u(o,s,S),{providerTime:t,postProcessTime:g.elapsed()})}finally{f.dispose(),this.h.delete(f)}}q(c){const S=(0,$.$8L)(this.k.includePattern,c.includePattern),f=(0,$.$8L)(this.k.excludePattern,c.excludePattern);return{folder:c.folder,excludes:f,includes:S,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}s({pathToEntries:c},S,f,n){if(f===this.a){const s=v.$mc(this.a);this.v(n,{base:S,relativePath:this.a,basename:s})}function o(s){const l=v.$mc(s),i=v.$lc(s);let r=c[i];r||(r=c[i]=[],o(i)),r.push({base:S,relativePath:s,basename:l})}o(f)}u({rootEntries:c,pathToEntries:S},f,n){const o=this,s=this.a;function l(i){const r=(0,$.$$L)(()=>i.map(t=>t.basename));for(let t=0,g=i.length;t<g;t++){const u=i[t],{relativePath:p,basename:m}=u;if(f.matchesExcludesSync(p,m,s!==m?r:void 0))continue;const d=S[p];if(d)l(d);else{if(p===s)continue;o.v(n,u)}if(o.e)break}}l(c)}v(c,S){(!this.b||S.relativePath&&this.b(S.relativePath,S.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||c(S))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(c,S,f,n){const o=this.c(c.cacheKey),s=new a(c,S,o&&o.token);let l=0;const i=r=>{l+=r.length,f(r.map(t=>this.d(t)))};return this.e(s,R.a,i,n).then(r=>({limitHit:r.limitHit,stats:r.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:l,detailStats:r.stats}:void 0,messages:[]}))}clearCache(c){this.c(c)?.cancel()}c(c){if(c)return this.b.has(c)||this.b.set(c,new I.$ue),this.b.get(c)}d(c){return c.relativePath?{resource:A.$dh(c.base,c.relativePath)}:{resource:c.base}}e(c,S,f,n){const o=n.onCancellationRequested(()=>{c.cancel()}),s=i=>{i&&(l.push(i),S>0&&l.length>=S&&(f(l),l=[]))};let l=[];return c.search(s).then(i=>(l.length&&f(l),o.dispose(),i),i=>(l.length&&f(l),o.dispose(),Promise.reject(i)))}}e.$Opc=R}),define(Ne[270],Oe([1,0,17,239,41,99,28,15,19,23,12,14,2,102,9,43,11,49,118,266,44]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S,f,n,o,s,l,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9M=void 0,e.$0M=w,v=Ve(v),I=Ve(I),C=Ve(C),$=Ve($),R=Ve(R),f=Ve(f);let t=class{constructor(P,h,b,M,O){this.a=P,this.b=h,this.c=b,this.d=M,this.e=O}text(P,h,b={}){P=this.f(P,b);const M=this.a.getValue(),O=h&&h.some(q=>!this.a.getValue({resource:q}).search.useRipgrep);return{...this.h(h?.map(s.$Xi),b),type:r.QueryType.Text,contentPattern:P,previewOptions:b.previewOptions,maxFileSize:b.maxFileSize,usePCRE2:M.search.usePCRE2||O||!1,beforeContext:b.beforeContext,afterContext:b.afterContext,userDisabledExcludesAndIgnoreFiles:b.disregardExcludeSettings&&b.disregardIgnoreFiles}}f(P,h){const b=this.a.getValue();P.isRegExp&&(P.pattern=P.pattern.replace(/\r?\n/g,"\\n"));const M={...P,wordSeparators:b.editor.wordSeparators};return this.j(P,h)&&(M.isCaseSensitive=!0),this.k(P)&&(M.isMultiline=!0),h.notebookSearchConfig?.includeMarkupInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownInput=h.notebookSearchConfig.includeMarkupInput),h.notebookSearchConfig?.includeMarkupPreview&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownPreview=h.notebookSearchConfig.includeMarkupPreview),h.notebookSearchConfig?.includeCodeInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellInput=h.notebookSearchConfig.includeCodeInput),h.notebookSearchConfig?.includeOutput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellOutput=h.notebookSearchConfig.includeOutput),M}file(P,h={}){return{...this.h(P,h),type:r.QueryType.File,filePattern:h.filePattern?h.filePattern.trim():h.filePattern,exists:h.exists,sortByScore:h.sortByScore,cacheKey:h.cacheKey,shouldGlobMatchFilePattern:h.shouldGlobSearch}}g(P,h){return P?(P=Array.isArray(P)?P.map(d):d(P),h?this.parseSearchPaths(P):{pattern:u(...Array.isArray(P)?P:[P])}):{}}h(P=[],h={}){const b=this.g(h.includePattern,h.expandPatterns),M=this.g(h.excludePattern,h.expandPatterns),O=P.length>1,F=(b.searchPaths&&b.searchPaths.length?b.searchPaths.map(L=>this.q(L,h,M)):P.map(L=>this.r(L,h,M,O))).filter(L=>!!L),q={_reason:h._reason,folderQueries:F,usingSearchPaths:!!(b.searchPaths&&b.searchPaths.length),extraFileResources:h.extraFileResources,excludePattern:M.pattern,includePattern:b.pattern,onlyOpenEditors:h.onlyOpenEditors,maxResults:h.maxResults};if(h.onlyOpenEditors){const L=v.$Gb(this.c.groups.flatMap(fe=>fe.editors.map(_=>_.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(L));const Y=L.filter(fe=>(0,r.$YL)(q,fe.fsPath)),Z=this.i(Y);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Z)),{...q,...Z}}const B=h.extraFileResources&&h.extraFileResources.filter(L=>(0,r.$YL)(q,L.fsPath));return q.extraFileResources=B&&B.length?B:void 0,q}i(P){const h=[],b=new A.$zc,M={};let O=!1;return P.forEach(F=>{if(F.scheme===T.Schemas.walkThrough)return;if((0,a.$hh)(F)){const B=this.b.getWorkspaceFolder(F)?.uri??F.with({path:$.$lc(F.fsPath)});let L=b.get(B);L||(O=!0,L={folder:B,includePattern:{}},h.push(L),b.set(B,L));const Y=$.$kc(B.fsPath,F.fsPath);(0,y.$ng)(L.includePattern)[Y.replace(/\\/g,"/")]=!0}else F.fsPath&&(O=!0,M[F.fsPath]=!0)}),{folderQueries:h,includePattern:M,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}j(P,h){if(h.isSmartCase){if(P.isRegExp){if(R.$6f(P.pattern,!0))return!0}else if(R.$6f(P.pattern))return!0}return!!P.isCaseSensitive}k(P){return P.isMultiline||P.isRegExp&&(0,S.$_C)(P.pattern)||P.pattern.indexOf(`
`)>=0?!0:!!P.isMultiline}parseSearchPaths(P){const h=Z=>$.$hc(Z)||/^\.\.?([\/\\]|$)/.test(Z),M=(Array.isArray(P)?P:p(P)).map(Z=>{const fe=this.e.resolvedUserHome;return fe?(0,N.$Xw)(Z,fe.scheme===T.Schemas.file?fe.fsPath:fe.path):Z}),O=I.$c(M,Z=>h(Z)?"searchPaths":"exprSegments"),F=(O.exprSegments||[]).map(Z=>R.$lf(Z,"/")).map(Z=>R.$lf(Z,"\\")).map(Z=>(Z[0]==="."&&(Z="*"+Z),m(Z))),q={},B=this.m(O.searchPaths||[]);B&&B.length&&(q.searchPaths=B);const L=F.flat(),Y=u(...L);return Y&&(q.pattern=Y),q}l(P,h){return h.disregardExcludeSettings?void 0:(0,r.$XL)(P,!h.disregardSearchExcludeSettings)}m(P){if(!P||!P.length)return[];const h=P.flatMap(M=>{let{pathPortion:O,globPortion:F}=g(M);return F&&(F=E(F)),this.n(O).flatMap(B=>this.o(B,F))}),b=new Map;return h.forEach(M=>{const O=M.searchPath.toString(),F=b.get(O);F?M.pattern&&(F.pattern=F.pattern||{},F.pattern[M.pattern]=!0):b.set(O,{searchPath:M.searchPath,pattern:M.pattern?u(M.pattern):void 0})}),Array.from(b.values())}n(P){if($.$hc(P)){const h=this.b.getWorkspace().folders;return h[0]&&h[0].uri.scheme!==T.Schemas.file?[{searchPath:h[0].uri.with({path:P})}]:[{searchPath:c.URI.file($.$gc(P))}]}if(this.b.getWorkbenchState()===s.WorkbenchState.FOLDER){const h=this.b.getWorkspace().folders[0].uri;if(P=d(P),P.startsWith("../")||P===".."){const M=$.$fc.resolve(h.path,P);return[{searchPath:h.with({path:M})}]}const b=E(P);return[{searchPath:h,pattern:b}]}else{if(P==="./"||P===".\\")return[];{const h=P.replace(/^\.[\/\\]/,""),M=this.b.getWorkspace().folders.map(O=>{const F=h.match(new RegExp(`^${R.$ff(O.name)}(?:/(.*)|$)`));return F?{match:F,folder:O}:null}).filter(y.$kg);if(M.length)return M.map(O=>{const F=O.match[1];return{searchPath:O.folder.uri,pattern:F&&E(F)}});{const O=P.match(/\.[\/\\](.+)[\/\\]?/),F=O?O[1]:P,q=f.localize(1584,null,F);throw new Error(q)}}}}o(P,h){const b=P.pattern&&h?`${P.pattern}/${h}`:P.pattern||h,M=[{searchPath:P.searchPath,pattern:b}];return b&&!b.endsWith("**")&&M.push({searchPath:P.searchPath,pattern:b+"/**"}),M}q(P,h,b){const M=this.r((0,s.$Xi)(P.searchPath),h,b,!1);return M?{...M,includePattern:P.pattern}:null}r(P,h,b,M){let O;const F=c.URI.isUri(P)?P:P.uri;if(b.searchPaths){const Z=b.searchPaths.filter(fe=>(0,a.$9g)(fe.searchPath,F))[0];if(Z&&!Z.pattern)return null;Z&&(O=Z.pattern)}const q=this.a.getValue({resource:F}),L={...this.l(q,h)||{},...O||{}},Y=c.URI.isUri(P)?(0,a.$ah)(P):P.name;return{folder:F,folderName:M?Y:void 0,excludePattern:Object.keys(L).length>0?L:void 0,fileEncoding:q.files&&q.files.encoding,disregardIgnoreFiles:typeof h.disregardIgnoreFiles=="boolean"?h.disregardIgnoreFiles:!q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof h.disregardGlobalIgnoreFiles=="boolean"?h.disregardGlobalIgnoreFiles:!q.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof h.disregardParentIgnoreFiles=="boolean"?h.disregardParentIgnoreFiles:!q.search.useParentIgnoreFiles,ignoreSymlinks:typeof h.ignoreSymlinks=="boolean"?h.ignoreSymlinks:!q.search.followSymlinks}}};e.$9M=t,e.$9M=t=Qe([qe(0,n.$9i),qe(1,s.$Li),qe(2,l.$hE),qe(3,o.$9j),qe(4,i.$7M)],t);function g(k){const P=k.match(/[\*\{\}\(\)\[\]\?]/);if(P){const h=P.index,b=k.substr(0,h).match(/[/|\\][^/\\]*$/);if(b){let M=k.substr(0,b.index);return M.match(/[/\\]/)||(M+="/"),{pathPortion:M,globPortion:k.substr((b.index||0)+1)}}}return{pathPortion:k}}function u(...k){return k.length?k.reduce((P,h)=>(P[h]=!0,P),Object.create(null)):void 0}function p(k){return C.$uk(k,",").map(P=>P.trim()).filter(P=>!!P.length)}function m(k){return[`**/${k}/**`,`**/${k}`].map(h=>h.replace(/\*\*\/\*\*/g,"**"))}function d(k){return k.replace(/\\/g,"/")}function E(k){return d(k).replace(/^\.\//,"").replace(/\/+$/g,"")}function D(k){return k.replace(/([?*[\]])/g,"[$1]")}function w(k,P){k=v.$Lb(k,M=>M.toString());const h=[],b=P.getWorkspace();return k&&k.forEach(M=>{let O;if(P.getWorkbenchState()===s.WorkbenchState.FOLDER)O=(0,a.$fh)(b.folders[0].uri,M),O&&O!=="."&&(O="./"+O);else{const F=P.getWorkspaceFolder(M);if(F){const q=F.name;if(b.folders.filter(L=>L.name===q).length===1){const L=(0,a.$fh)(F.uri,M);L===""?O=`./${F.name}`:O=`./${F.name}/${L}`}else O=M.fsPath}}O&&h.push(D(O))}),h}}),define(Ne[271],Oe([1,0,23,2,21,13,3,270,44,49,10]),function(we,e,v,I,C,N,A,T,$,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$byb=c,e.$cyb=n,v=Ve(v),N=Ve(N);const y=7e3;function c(o,s){const l=s.activationEvents;if(!l)return Promise.resolve(void 0);const i=[],r=[];for(const d of l)if(/^workspaceContains:/.test(d)){const E=d.substr(18);E.indexOf("*")>=0||E.indexOf("?")>=0||o.forceUsingSearch?r.push(E):i.push(E)}if(i.length===0&&r.length===0)return Promise.resolve(void 0);const{promise:t,resolve:g}=(0,R.$vh)(),u=d=>g({activationEvent:d}),p=Promise.all(i.map(d=>S(o,d,u))).then(()=>{}),m=f(o,s.identifier,r,u);return Promise.all([p,m]).then(()=>{g(void 0)}),t}async function S(o,s,l){for(const i of o.folders)if(await o.exists(v.$dh(I.URI.revive(i),s))){l(`workspaceContains:${s}`);return}}async function f(o,s,l,i){if(l.length===0)return Promise.resolve(void 0);const r=new C.$ue,t=o.checkExists(o.folders,l,r.token),g=setTimeout(async()=>{r.cancel(),o.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${l.join(",")}`)},y);let u=!1;try{u=await t}catch(p){N.$3(p)||N.$Y(p)}r.dispose(),clearTimeout(g),u&&i(`workspaceContains:${l.join(",")}`)}function n(o,s,l,i){const r=o.get(A.$Bi),t=o.get($.$PL),u=r.createInstance(T.$9M).file(s.map(p=>(0,a.$Xi)(I.URI.revive(p))),{_reason:"checkExists",includePattern:l,exists:!0});return t.fileSearch(u,i).then(p=>!!p.limitHit,p=>N.$3(p)?!1:Promise.reject(p))}}),define(Ne[47],Oe([1,0,9,19,64,23,10,4,58,2,11,5,46,205,88,45,24,119,13,18,22,188,7,109,3,26,91,16,74,92,56,94,6,271,87,190,15,85,69,20,86]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S,f,n,o,s,l,i,r,t,g,u,p,m,d,E,D,w,k,P,h,b,M,O,F,q,B,L,Y){"use strict";var Z;Object.defineProperty(e,"__esModule",{value:!0}),e.$ppc=e.$opc=e.$npc=e.$mpc=e.$lpc=void 0,v=Ve(v),I=Ve(I),C=Ve(C),l=Ve(l),e.$lpc=(0,p.$Ci)("IHostUtils");let fe=Z=class extends T.$Tc{constructor(X,V,te,ve,ce,be,he,J,x,me,pe,Ae,ze){super(),this.Y=Ae,this.Z=ze,this.a=this.B(new h.$je),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=V,this.g=te,this.f=he,this.j=ve,this.m=ce,this.s=be,this.t=x,this.u=me,this.w=pe,this.y=this.g.getProxy(y.$sN.MainThreadWorkspace),this.z=this.g.getProxy(y.$sN.MainThreadTelemetry),this.C=this.g.getProxy(y.$sN.MainThreadExtensionService),this.D=new A.$Bh,this.F=new A.$Bh,this.G=new A.$Bh,this.H=new A.$Bh,this.I=new Ce(this.f.extensions.activationEvents),this.L=new s.$Occ(this.I,this.f.extensions.allExtensions);const ke=new i.$on(this.f.extensions.myExtensions);this.J=new s.$Occ(this.I,$e(this.L,ke)),L.$u&&(this.s.info(`Creating extension host with the following global extensions: ${se(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${se(this.J)}`)),this.M=new f.$7oc(this.g,this.s),this.N=new M.$epc(this.g),this.O=J,this.h=X.createChild(new D.$Ai([f.$8oc,this.M],[M.$fpc,this.N])),this.P=this.B(new S.$6oc(this.J,this.L,{onExtensionActivationError:(Pe,Te,U)=>{this.C.$onExtensionActivationError(Pe,l.$1(Te),U)},actualActivateExtension:async(Pe,Te)=>{if(s.$Occ.isHostExtension(Pe,this.J,this.L))return await this.C.$activateExtension(Pe,Te),new S.$5oc;const U=this.J.getExtensionDescription(Pe);return this.fb(U,Te)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(X){l.$Y(X)}}async $(){this.O.onWillDeactivateAll();let X=[];try{X=this.J.getAllExtensionDescriptions().map(ce=>ce.identifier).filter(ce=>this.isActivated(ce)).map(ce=>this.eb(ce))}catch{}await Promise.all(X)}terminate(X,V=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${X}`),this.s.flush(),this.u.dispose(),this.P.dispose(),l.setUnexpectedErrorHandler(ve=>{this.s.error(ve)}),this.g.dispose();const te=this.$();Promise.race([(0,A.$Dh)(5e3),te]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${V}`):this.s.info(`Extension host exiting with code ${V}`),this.s.flush(),this.s.dispose(),this.c.exit(V)})}isActivated(X){return this.G.isOpen()?this.P.isActivated(X):!1}async getExtension(X){const V=await this.C.$getExtension(X);return V&&{...V,identifier:new i.$nn(V.identifier.value),extensionLocation:a.URI.revive(V.extensionLocation)}}ab(X,V){return this.P.activateByEvent(X,V)}bb(X,V){return this.P.activateById(X,V)}activateByIdWithErrors(X,V){return this.bb(X,V).then(()=>{const te=this.P.getActivatedExtension(X);if(te.activationFailed)return Promise.reject(te.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(X=>this.J)}getExtensionExports(X){if(this.G.isOpen())return this.P.getActivatedExtension(X).exports;try{return this.P.getActivatedExtension(X).exports}catch{return null}}async cb(X){if(X.scheme===F.Schemas.file&&this.c.fsRealpath){const V=X.fsPath;this.R.has(V)||this.R.set(V,this.c.fsRealpath(V));const te=await this.R.get(V);return a.URI.file(te)}return X}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(X=>new oe(X))),this.Q}async db(X){const V=$.$Ii.forUris(te=>N.$7g.ignorePathCasing(te));return await Promise.all(X.map(async te=>{if(this.wb(te)){const ve=await this.cb(te.extensionLocation);V.set(ve,te)}})),V}eb(X){let V=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(X))return V;const te=this.P.getActivatedExtension(X);if(!te)return V;try{typeof te.module.deactivate=="function"&&(V=Promise.resolve(te.module.deactivate()).then(void 0,ve=>(this.s.error(ve),Promise.resolve(void 0))))}catch(ve){this.s.error(`An error occurred when deactivating the extension '${X.value}':`),this.s.error(ve)}try{(0,T.$Oc)(te.subscriptions)}catch(ve){this.s.error(`An error occurred when deactivating the subscriptions for extension '${X.value}':`),this.s.error(ve)}return V}async fb(X,V){return this.f.remote.isRemote?this.C.$onWillActivateExtension(X.identifier):await this.C.$onWillActivateExtension(X.identifier),this.hb(X,V).then(te=>{const ve=te.activationTimes;return this.C.$onDidActivateExtension(X.identifier,ve.codeLoadingTime,ve.activateCallTime,ve.activateResolvedTime,V),this.gb(X,V,"success",ve),te},te=>{throw this.gb(X,V,"failure"),te})}gb(X,V,te,ve){const ce=ge(X,V);this.z.$publicLog2("extensionActivationTimes",{...ce,...ve||{},outcome:te})}hb(X,V){const te=ge(X,V);this.z.$publicLog2("activatePlugin",te);const ve=this.wb(X);if(!ve)return Promise.resolve(new S.$4oc(S.$1oc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${X.identifier.value}, startup: ${V.startup}, activationEvent: '${V.activationEvent}'${X.identifier.value!==V.extensionId.value?`, root cause: ${V.extensionId.value}`:""}`),this.s.flush();const ce=new S.$2oc(V.startup);return Promise.all([this.xb(X,(0,N.$dh)(X.extensionLocation,ve),ce),this.ib(X)]).then(be=>(C.mark(`code/extHost/willActivateExtension/${X.identifier.value}`),Z.jb(this.s,X.identifier,be[0],be[1],ce))).then(be=>(C.mark(`code/extHost/didActivateExtension/${X.identifier.value}`),be))}ib(X){const V=this.Z.createLanguageModelAccessInformation(X),te=this.B(new t.$0oc(X,this.M)),ve=this.B(new t.$9oc(X.identifier.value,!1,this.M)),ce=this.B(new O.$gpc(X,this.N)),be=X.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?g.ExtensionMode.Test:g.ExtensionMode.Development:g.ExtensionMode.Production,he=this.f.remote.isRemote?g.ExtensionKind.Workspace:g.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${X.identifier.value}`),Promise.all([te.whenReady,ve.whenReady,this.O.whenReady]).then(()=>{const J=this;let x,me;const pe=(0,o.$4G)(X,"ipc")?this.f.messagePorts?.get(i.$nn.toKey(X.identifier)):void 0;return Object.freeze({globalState:te,workspaceState:ve,secrets:ce,subscriptions:[],get languageModelAccessInformation(){return V},get extensionUri(){return X.extensionLocation},get extensionPath(){return X.extensionLocation.fsPath},asAbsolutePath(Ae){return I.$ic(X.extensionLocation.fsPath,Ae)},get storagePath(){return J.O.workspaceValue(X)?.fsPath},get globalStoragePath(){return J.O.globalValue(X).fsPath},get logPath(){return I.$ic(J.f.logsLocation.fsPath,X.identifier.value)},get logUri(){return a.URI.joinPath(J.f.logsLocation,X.identifier.value)},get storageUri(){return J.O.workspaceValue(X)},get globalStorageUri(){return J.O.globalValue(X)},get extensionMode(){return be},get extension(){return x===void 0&&(x=new ae(J,X.identifier,X,he,!1)),x},get extensionRuntime(){return(0,o.$5G)(X,"extensionRuntime"),J.extensionRuntime},get environmentVariableCollection(){return J.u.getEnvironmentVariableCollection(X)},get messagePassingProtocol(){if(!me){if(!pe)return;const Ae=h.Event.buffer(h.Event.fromDOMEventEmitter(pe,"message",ze=>ze.data));pe.start(),me={onDidReceiveMessage:Ae,postMessage:pe.postMessage.bind(pe)}}return me}})})}static jb(X,V,te,ve,ce){return te=te||{activate:void 0,deactivate:void 0},this.kb(X,V,te,ve,ce).then(be=>new S.$3oc(!1,null,ce.build(),te,be,ve.subscriptions))}static kb(X,V,te,ve,ce){if(typeof te.activate=="function")try{ce.activateCallStart(),X.trace(`ExtensionService#_callActivateOptional ${V.value}`);const be=typeof global=="object"?global:self,he=te.activate.apply(be,[ve]);return ce.activateCallStop(),ce.activateResolveStart(),Promise.resolve(he).then(J=>(ce.activateResolveStop(),J))}catch(be){return Promise.reject(be)}else return Promise.resolve(te)}lb(X,V){this.bb(X.identifier,{startup:!1,extensionId:X.identifier,activationEvent:V}).then(void 0,te=>{this.s.error(te)})}mb(X,V=0){const ve=Date.now();(0,L.$C)(()=>{for(let ce=V;ce<X.length;ce+=1){const be=X[ce];for(const he of be.activationEvents??[])if(he==="onStartupFinished")if(Date.now()-ve>50){this.mb(X,ce);break}else this.lb(be,he)}})}nb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then(X=>{const V=X.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),te=this.J.getAllExtensionDescriptions();if(V)this.mb(te);else for(const ve of te)if(ve.activationEvents)for(const ce of ve.activationEvents)ce==="onStartupFinished"&&this.lb(ve,ce)})}ob(){const X=this.ab("*",!0).then(void 0,be=>{this.s.error(be)});this.B(this.j.onDidChangeWorkspace(be=>this.pb(be.added)));const V=this.j.workspace?this.j.workspace.folders:[],te=this.pb(V),ve=this.rb(),ce=Promise.all([ve,X,te]).then(()=>{});return Promise.race([ce,(0,A.$Dh)(1e4)]).then(()=>{this.nb()}),ce}pb(X){return X.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(V=>this.qb(X,V))).then(()=>{})}async qb(X,V){if(this.isActivated(V.identifier))return;const te=!this.f.remote.isRemote&&!!this.f.remote.authority,ve={logService:this.s,folders:X.map(be=>be.uri),forceUsingSearch:te||!this.c.fsExists,exists:be=>this.c.fsExists(be.fsPath),checkExists:(be,he,J)=>this.y.$checkExists(be,he,J)},ce=await(0,b.$byb)(ve,V);if(ce)return this.bb(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:ce.activationEvent}).then(void 0,be=>this.s.error(be))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(X){throw console.error(X),X}}async sb(){const{extensionDevelopmentLocationURI:X,extensionTestsLocationURI:V}=this.f.environment;if(!X||!V)throw new Error(v.localize(10671,null));const te=await this.xb(null,V,new S.$2oc(!1));if(!te||typeof te.run!="function")throw new Error(v.localize(10672,null,V.toString()));return new Promise((ve,ce)=>{const be=(x,me)=>{x?(L.$u&&this.s.error("Test runner called back with error",x),ce(x)):(L.$u&&(me?this.s.info(`Test runner called back with ${me} failures.`):this.s.info("Test runner called back with successful outcome.")),ve(typeof me=="number"&&me>0?1:0))},he=(0,N.$4g)(V),J=te.run(he,be);J&&J.then&&J.then(()=>{L.$u&&this.s.info("Test runner finished successfully."),ve(0)}).catch(x=>{L.$u&&this.s.error("Test runner finished with error",x),ce(x instanceof Error&&x.stack?x.stack:String(x))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Dh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(X,V){return this.S[X]=V,(0,T.$Rc)(()=>{delete this.S[X]})}async getRemoteExecServer(X){const{resolver:V}=await this.ub(X);return V?.resolveExecServer?.(X,{resolveAttempt:0})}async ub(X){const V=X.indexOf("+");if(V===-1)throw new g.$AN("Not an authority that can be resolved!",u.RemoteAuthorityResolverErrorCode.InvalidAuthority);const te=X.substr(0,V);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${te}`,!1),{authorityPrefix:te,resolver:this.S[te]}}async $resolveAuthority(X,V){const te=B.$de.create(!1),ve=()=>`[resolveAuthority(${(0,u.$Rl)(X)},${V})][${te.elapsed()}ms] `,ce=j=>this.s.info(`${ve()}${j}`),be=j=>this.s.warn(`${ve()}${j}`),he=(j,G=void 0)=>this.s.error(`${ve()}${j}`,G),J=j=>{if(j instanceof g.$AN)return{type:"error",error:{code:j._code,message:j._message,detail:j._detail}};throw j},x=async j=>{ce(`activating resolver for ${j}...`);const{resolver:G,authorityPrefix:Q}=await this.ub(j);if(!G)throw he(`no resolver for ${Q}`),new g.$AN(`No remote extension installed to resolve ${Q}.`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:G,authorityPrefix:Q,remoteAuthority:j}},me=X.split(/@|%40/g).reverse();ce(`activating remote resolvers ${me.join(" -> ")}`);let pe;try{pe=await Promise.all(me.map(x)).catch(async j=>{if(!(j instanceof g.$AN)||j._code!==u.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw j;return be(`resolving nested authorities failed: ${j.message}`),[await x(X)]})}catch(j){return J(j)}const Ae=new A.$Nh;Ae.cancelAndSet(()=>ce("waiting..."),1e3);let ze,ke;for(const[j,{authorityPrefix:G,resolver:Q,remoteAuthority:ne}]of pe.entries())try{if(j===pe.length-1)ce("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${G}`),ze=await Q.resolve(ne,{resolveAttempt:V,execServer:ke}),C.mark(`code/extHost/didResolveAuthorityOK/${G}`),ce("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Q,g.$zN.isManagedResolvedAuthority(ze)?ze:void 0));else{if(ce(`invoking resolveExecServer() for ${ne}`),C.mark(`code/extHost/willResolveExecServer/${G}`),ke=await Q.resolveExecServer?.(ne,{resolveAttempt:V,execServer:ke}),!ke)throw new g.$AN(`Exec server was not available for ${ne}`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${G}`)}}catch(de){return C.mark(`code/extHost/didResolveAuthorityError/${G}`),he("returned an error",de),Ae.dispose(),J(de)}Ae.dispose();const Pe={environmentTunnels:ze.environmentTunnels,features:ze.tunnelFeatures?{elevation:ze.tunnelFeatures.elevation,privacyOptions:ze.tunnelFeatures.privacyOptions,protocol:ze.tunnelFeatures.protocol===void 0?!0:ze.tunnelFeatures.protocol}:void 0},Te={extensionHostEnv:ze.extensionHostEnv,isTrusted:ze.isTrusted,authenticationSession:ze.authenticationSessionForInitializingExtensions?{id:ze.authenticationSessionForInitializingExtensions.id,providerId:ze.authenticationSessionForInitializingExtensions.providerId}:void 0};ce(`returned ${g.$zN.isManagedResolvedAuthority(ze)?"managed authority":`${ze.host}:${ze.port}`}`);let U;if(g.$zN.isManagedResolvedAuthority(ze)){const j=V;this.Y.setFactory(j,ze.makeConnection),U={authority:X,connectTo:new u.$Ol(j),connectionToken:ze.connectionToken}}else U={authority:X,connectTo:new u.$Pl(ze.host,ze.port),connectionToken:ze.connectionToken};return{type:"ok",value:{authority:U,options:Te,tunnelInformation:Pe}}}async $getCanonicalURI(X,V){this.s.info(`$getCanonicalURI invoked for authority (${(0,u.$Rl)(X)})`);const{resolver:te}=await this.ub(X);if(!te)return null;const ve=a.URI.revive(V);if(typeof te.getCanonicalURI>"u")return ve;const ce=await(0,A.$uh)(()=>te.getCanonicalURI(ve));return ce||ve}async $startExtensionHost(X){X.toAdd.forEach(be=>be.extensionLocation=a.URI.revive(be.extensionLocation));const{globalRegistry:V,myExtensions:te}=_(this.I,this.L,this.J,X),ve=await this.db(te);return(await this.getExtensionPathIndex()).setSearchTree(ve),this.L.set(V.getAllExtensionDescriptions()),this.J.set(te),L.$u&&(this.s.info(`$startExtensionHost: global extensions: ${se(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${se(this.J)}`)),this.tb()}$activateByEvent(X,V){return V===o.ActivationKind.Immediate?this.D.wait().then(te=>this.ab(X,!1)):this.G.wait().then(te=>this.ab(X,!1))}async $activate(X,V){return await this.G.wait(),this.J.getExtensionDescription(X)?(await this.bb(X,V),!0):!1}async $deltaExtensions(X){X.toAdd.forEach(be=>be.extensionLocation=a.URI.revive(be.extensionLocation));const{globalRegistry:V,myExtensions:te}=_(this.I,this.L,this.J,X),ve=await this.db(te);return(await this.getExtensionPathIndex()).setSearchTree(ve),this.L.set(V.getAllExtensionDescriptions()),this.J.set(te),L.$u&&(this.s.info(`$deltaExtensions: global extensions: ${se(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${se(this.J)}`)),Promise.resolve(void 0)}async $test_latency(X){return X}async $test_up(X){return X.byteLength}async $test_down(X){const V=r.$Le.alloc(X),te=Math.random()%256;for(let ve=0;ve<X;ve++)V.writeUInt8(te,ve);return V}async $updateRemoteConnectionData(X){this.X=X,this.a.fire()}};e.$mpc=fe,e.$mpc=fe=Z=Qe([qe(0,p.$Bi),qe(1,e.$lpc),qe(2,E.$1P),qe(3,n.$Joc),qe(4,c.$Moc),qe(5,R.$9j),qe(6,m.$eQ),qe(7,d.$Poc),qe(8,w.$SFb),qe(9,k.$$oc),qe(10,q.$ipc),qe(11,Y.$jpc),qe(12,P.$cpc)],fe);function _(Fe,X,V,te){Fe.addActivationEvents(te.addActivationEvents);const ve=new s.$Occ(Fe,X.getAllExtensionDescriptions());ve.deltaExtensions(te.toAdd,te.toRemove);const ce=new i.$on(V.getAllExtensionDescriptions().map(he=>he.identifier));for(const he of te.myToRemove)ce.delete(he);for(const he of te.myToAdd)ce.add(he);const be=$e(ve,ce);return{globalRegistry:ve,myExtensions:be}}function ge(Fe,X){return{id:Fe.identifier.value,name:Fe.name,extensionVersion:Fe.version,publisherDisplayName:Fe.publisher,activationEvents:Fe.activationEvents?Fe.activationEvents.join(","):null,isBuiltin:Fe.isBuiltin,reason:X.activationEvent,reasonId:X.extensionId.value}}function se(Fe){return Fe.getAllExtensionDescriptions().map(X=>X.identifier.value).join(",")}e.$npc=(0,p.$Ci)("IExtHostExtensionService");class ae{#e;#t;#i;constructor(X,V,te,ve,ce){this.#e=X,this.#t=V,this.#i=te.identifier,this.id=te.identifier.value,this.extensionUri=te.extensionLocation,this.extensionPath=I.$gc((0,N.$4g)(te.extensionLocation)),this.packageJSON=te,this.extensionKind=ve,this.isFromDifferentExtensionHost=ce}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$opc=ae;function $e(Fe,X){return Fe.getAllExtensionDescriptions().filter(V=>X.has(V.identifier))}class oe{constructor(X){this.a=X}setSearchTree(X){this.a=X}findSubstr(X){return this.a.findSubstr(X)}forEach(X){return this.a.forEach(X)}}e.$ppc=oe;class Ce{constructor(X){this.a=new i.$pn,this.addActivationEvents(X)}readActivationEvents(X){return this.a.get(X.identifier)??[]}addActivationEvents(X){for(const V of Object.keys(X))this.a.set(V,X[V])}}}),define(Ne[272],Oe([1,0,64,2,5,46,24,18,16,26,3,47,11,12]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Aqc=void 0,v=Ve(v);let n=class{constructor(r,t,g,u,p,m,d){this.c=r,this.d=t,this.e=g,this.f=u,this.g=p,this.h=m,this.i=d,this.a=new Map,this.b=[]}async install(){this.j(),v.mark("code/extHost/willWaitForConfig");const r=await this.f.getConfigProvider();v.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new s(this.c,t,this.d,r,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(l,t,this.h.environment.appUriScheme))}register(r){if("nodeModuleName"in r)if(Array.isArray(r.nodeModuleName))for(const t of r.nodeModuleName)this.a.set(t,r);else this.a.set(r.nodeModuleName,r);typeof r.alternativeModuleName=="function"&&this.b.push(t=>r.alternativeModuleName(t))}};e.$Aqc=n,e.$Aqc=n=Qe([qe(2,R.$Bi),qe(3,N.$Moc),qe(4,y.$npc),qe(5,a.$eQ),qe(6,c.$9j)],n);let o=class{static{f=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(r){if(r.environment.appRoot&&f.a.size){const t=(0,S.$ff)(this.c(r.environment.appRoot.fsPath)),g="[a-z0-9_.-]",u=`@${g}+\\/${g}+|${g}+`,p="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${p}\\/)(${u})(.*)$`,"i")}}alternativeModuleName(r){if(!this.b)return;const t=this.b.exec(this.c(r));if(!t)return;const[,g,u,p]=t,m=f.a.get(u);if(m!==void 0)return console.warn(`${u} as been renamed to ${m}, please update your imports`),g+m+p}c(r){return r.replace(/\\/g,"/")}};o=f=Qe([qe(0,a.$eQ)],o);class s{constructor(r,t,g,u,p){this.c=r,this.d=t,this.e=g,this.f=u,this.g=p,this.nodeModuleName="vscode",this.a=new T.$pn}load(r,t){const g=this.d.findSubstr(t);if(g){let u=this.a.get(g.identifier);return u||(u=this.c(g,this.e,this.f),this.a.set(g.identifier,u)),u}if(!this.b){let u="";this.d.forEach((p,m)=>u+=`	${m} -> ${p.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${u}`),this.b=this.c(A.$YG,this.e,this.f)}return this.b}}let l=class{constructor(r,t,g){this.e=r,this.f=t,this.nodeModuleName=["open","opn"],this.d=g.getProxy(C.$sN.MainThreadTelemetry);const u=g.getProxy(C.$sN.MainThreadWindow);this.c=(p,m)=>{const d=I.URI.parse(p);return m?this.g(p,m):d.scheme==="http"||d.scheme==="https"?u.$openUri(d,p,{allowTunneling:!0}):d.scheme==="mailto"||d.scheme===this.f?u.$openUri(d,p,{}):this.g(p,m)}}load(r,t,g){const u=this.e.findSubstr(t);return u&&(this.a=u.identifier.value,this.h()),this.b=g(r),this.c}g(r,t){return this.i(),this.b(r,t)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};l=Qe([qe(2,$.$1P)],l)}),define(Ne[132],Oe([1,0,48,4,19,78,3,57,70,47,7,45,202,46]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rpc=e.$qpc=void 0,C=Ve(C),N=Ve(N),e.$qpc=(0,A.$Ci)("IExtHostVariableResolverProvider");class f extends c.$5Q{constructor(s,l,i,r,t,g,u){function p(){if(i){const m=i.activeEditor();if(m)return m.document.uri;const d=r.tabGroups.all.find(E=>E.isActive)?.activeTab;if(d!==void 0){if(d.input instanceof R.$gP||d.input instanceof R.$lP)return d.input.modified;if(d.input instanceof R.$fP||d.input instanceof R.$kP||d.input instanceof R.$iP)return d.input.uri}}}super({getFolderUri:m=>{const d=g.folders.filter(E=>E.name===m);if(d&&d.length>0)return d[0].uri},getWorkspaceFolderCount:()=>g.folders.length,getConfigurationValue:(m,d)=>t.getConfiguration(void 0,m).get(d),getAppRoot:()=>N.cwd(),getExecPath:()=>N.env.VSCODE_EXEC_PATH,getFilePath:()=>{const m=p();if(m)return C.$gc(m.fsPath)},getWorkspaceFolderPathForFile:()=>{if(l){const m=p();if(m){const d=l.getWorkspaceFolder(m);if(d)return C.$gc(d.uri.fsPath)}}},getSelectedText:()=>{if(i){const m=i.activeEditor();if(m&&!m.selection.isEmpty)return m.document.getText(m.selection)}},getLineNumber:()=>{if(i){const m=i.activeEditor();if(m)return String(m.selection.end.line+1)}},getExtension:m=>s.getExtension(m)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(N.env))}}let n=class extends I.$Tc{constructor(s,l,i,r,t){super(),this.b=s,this.c=l,this.g=i,this.h=r,this.j=t,this.a=new v.$T(async()=>{const g=await this.h.getConfigProvider(),p={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async m=>{p.folders=await this.c.getWorkspaceFolders2()||[]})),new f(this.b,this.c,this.g,this.j,g,p,this.m())})}getResolver(){return this.a.value}m(){}};e.$rpc=n,e.$rpc=n=Qe([qe(0,a.$npc),qe(1,y.$Joc),qe(2,T.$_P),qe(3,S.$Moc),qe(4,$.$Yoc)],n)}),define(Ne[133],Oe([1,0,10,6,2,4,18,3,5,70,47,16,7,45,194,80,195,46,132,34,33,8,17,95]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S,f,n,o,s,l,i,r,t,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bpc=e.$Apc=e.$zpc=e.$ypc=e.$xpc=void 0,t=Ve(t),e.$xpc=(0,T.$Ci)("IExtHostDebugService");let p=class extends N.$Tc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(P,h,b,M,O,F,q,B){super(),this.Y=h,this.Z=b,this.$=M,this.ab=O,this.bb=F,this.cb=q,this.db=B,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new I.$je),this.z=this.B(new I.$je),this.C=this.B(new I.$je),this.F=this.B(new I.$je),this.u=P.getProxy($.$sN.MainThreadDebugService),this.I=this.B(new I.$je),this.L=this.B(new I.$je),this.G=new d(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(L=>{this.B(L.onDidChange(Y=>{this.fb(L)})),this.fb(L)})}async $getVisualizerTreeItem(P,h){const b=this.gb(h);if(!b)return;const M=await this.Q.get(P)?.getTreeItem?.(b);return M?this.eb(P,M):void 0}registerDebugVisualizationTree(P,h,b){const M=A.$nn.toKey(P.identifier),O=this.ub(M,h);if(this.P.has(O))throw new Error(`A debug visualization provider with id '${h}' is already registered`);return this.Q.set(O,b),this.u.$registerDebugVisualizerTree(O,!!b.editItem),(0,N.$Rc)(()=>{this.u.$unregisterDebugVisualizerTree(O),this.Q.delete(h)})}async $getVisualizerTreeItemChildren(P,h){const b=this.S.get(h)?.item;return b?(await this.Q.get(P)?.getChildren?.(b))?.map(O=>this.eb(P,O))||[]:[]}async $editVisualizerTreeItem(P,h){const b=this.S.get(P);if(!b)return;const M=await this.Q.get(b.provider)?.editItem?.(b.item,h);return this.eb(b.provider,M||b.item)}$disposeVisualizedTree(P){const h=this.S.get(P);if(!h)return;const b=[h.children];for(const M of b)if(M)for(const O of M)b.push(this.S.get(O)?.children),this.S.delete(O)}eb(P,h){let b=this.R.get(h);return b||(b=this.O++,this.R.set(h,b),this.S.set(b,{provider:P,item:h})),t.DebugTreeItem.from(h,b)}asDebugSourceUri(P,h){const b=P;if(typeof b.sourceReference=="number"&&b.sourceReference>0){let M=`debug:${encodeURIComponent(b.path||"")}`,O="?";return h&&(M+=`${O}session=${encodeURIComponent(h.id)}`,O="&"),M+=`${O}ref=${b.sourceReference}`,C.URI.parse(M)}else{if(b.path)return C.URI.file(b.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(P){const h=[];for(const b of P.getAllExtensionDescriptions())if(b.contributes){const M=b.contributes.debuggers;if(M&&M.length>0)for(const O of M)(0,o.$WH)(O)&&h.push(O.type)}this.u.$registerDebugTypes(h)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const P=[];return this.H.forEach(h=>P.push(h)),P}async $resolveDebugVisualizer(P,h){const b=this.W.get(P);if(!b)throw new Error(`No debug visualizer found with id '${P}'`);let{v:M,provider:O,extensionId:F}=b;if(M.visualization||(M=await O.resolveDebugVisualization?.(M,h)||M,b.v=M),!M.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${O}'`);return this.vb(F,M.visualization)}async $executeDebugVisualizerCommand(P){const h=this.W.get(P);if(!h)throw new Error(`No debug visualizer found with id '${P}'`);const b=h.v.visualization;b&&"command"in b&&this.cb.executeCommand(b.command,...b.arguments||[])}gb(P){const h=this.w.get(P.sessionId);return h&&{session:h.api,variable:P.variable,containerId:P.containerId,frameId:P.frameId,threadId:P.threadId}}async $provideDebugVisualizers(P,h,b,M){const O=this.gb(b),F=this.ub(P,h),q=this.P.get(F);if(!O||!q)return[];const B=await q.provideDebugVisualization(O,M);return B?B.map(L=>{const Y=++this.X;this.W.set(Y,{v:L,provider:q,extensionId:P});const Z=L.iconPath?this.wb(L.iconPath):void 0;return{id:Y,name:L.name,iconClass:Z?.iconClass,iconPath:Z?.iconPath,visualization:this.vb(P,L.visualization)}}):[]}$disposeDebugVisualizers(P){for(const h of P)this.W.delete(h)}registerDebugVisualizationProvider(P,h,b){if(!P.contributes?.debugVisualizers?.some(F=>F.id===h))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${h})`);const M=A.$nn.toKey(P.identifier),O=this.ub(M,h);if(this.P.has(O))throw new Error(`A debug visualization provider with id '${h}' is already registered`);return this.P.set(O,b),this.u.$registerDebugVisualizer(M,h),(0,N.$Rc)(()=>{this.u.$unregisterDebugVisualizer(M,h),this.P.delete(h)})}addBreakpoints(P){const h=P.filter(O=>{const F=O.id;return this.H.has(F)?!1:(this.H.set(F,O),!0)});this.rb(h,[],[]);const b=[],M=new Map;for(const O of h)if(O instanceof c.$wO){let F=M.get(O.location.uri.toString());F||(F={type:"sourceMulti",uri:O.location.uri,lines:[]},M.set(O.location.uri.toString(),F),b.push(F)),F.lines.push({id:O.id,enabled:O.enabled,condition:O.condition,hitCondition:O.hitCondition,logMessage:O.logMessage,line:O.location.range.start.line,character:O.location.range.start.character,mode:O.mode})}else O instanceof c.$xO&&b.push({type:"function",id:O.id,enabled:O.enabled,hitCondition:O.hitCondition,logMessage:O.logMessage,condition:O.condition,functionName:O.functionName,mode:O.mode});return this.u.$registerBreakpoints(b)}removeBreakpoints(P){const h=P.filter(F=>this.H.delete(F.id));this.rb([],h,[]);const b=h.filter(F=>F instanceof c.$wO).map(F=>F.id),M=h.filter(F=>F instanceof c.$xO).map(F=>F.id),O=h.filter(F=>F instanceof c.$yO).map(F=>F.id);return this.u.$unregisterBreakpoints(b,M,O)}startDebugging(P,h,b){const M=b.testRun&&this.db.getMetadataForRun(b.testRun);return this.u.$startDebugging(P?P.uri:void 0,h,{parentSessionID:b.parentSession?b.parentSession.id:void 0,lifecycleManagedByParent:b.lifecycleManagedByParent,repl:b.consoleMode===c.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:b.noDebug,compact:b.compact,suppressSaveBeforeStart:b.suppressSaveBeforeStart,testRun:M&&{runId:M.runId,taskId:M.taskId},suppressDebugStatusbar:b.suppressDebugStatusbar??b.debugUI?.simple,suppressDebugToolbar:b.suppressDebugToolbar??b.debugUI?.simple,suppressDebugView:b.suppressDebugView??b.debugUI?.simple})}stopDebugging(P){return this.u.$stopDebugging(P?P.id:void 0)}registerDebugConfigurationProvider(P,h,b){if(!h)return new c.$uN(()=>{});const M=this.f++;return this.g.push({type:P,handle:M,provider:h}),this.u.$registerDebugConfigurationProvider(P,b,!!h.provideDebugConfigurations,!!h.resolveDebugConfiguration,!!h.resolveDebugConfigurationWithSubstitutedVariables,M),new c.$uN(()=>{this.g=this.g.filter(O=>O.provider!==h),this.u.$unregisterDebugConfigurationProvider(M)})}registerDebugAdapterDescriptorFactory(P,h,b){if(!b)return new c.$uN(()=>{});if(!this.nb(P,h))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${h}' debugger.`);if(this.kb(h))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const M=this.h++;return this.j.push({type:h,handle:M,factory:b}),this.u.$registerDebugAdapterDescriptorFactory(h,M),new c.$uN(()=>{this.j=this.j.filter(O=>O.factory!==b),this.u.$unregisterDebugAdapterDescriptorFactory(M)})}registerDebugAdapterTrackerFactory(P,h){if(!h)return new c.$uN(()=>{});const b=this.m++;return this.n.push({type:P,handle:b,factory:h}),new c.$uN(()=>{this.n=this.n.filter(M=>M.factory!==h)})}async $runInTerminal(P,h){return Promise.resolve(void 0)}async $substituteVariables(P,h){let b;const M=await this.tb(P);return M&&(b={uri:M.uri,name:M.name,index:M.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(b,h)}hb(P,h){if(P.type==="implementation")return new D(P.implementation)}ib(){}async $startDASession(P,h){const b=this,M=await this.sb(h);return this.pb(this.kb(M.type),M).then(O=>{if(!O)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${M.type}' (extension might have failed to activate)`);const F=this.jb(O),q=this.hb(F,M);if(!q)throw new Error(`Couldn't create a debug adapter for type '${M.type}'.`);const B=q;return this.M.set(P,B),this.ob(M).then(L=>(L&&this.N.set(P,L),B.onMessage(async Y=>{if(Y.type==="request"&&Y.command==="handshake"){const Z=Y,fe={type:"response",seq:0,command:Z.command,request_seq:Z.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const _=await this.U.sign(Z.arguments.value);fe.body={signature:_},B.sendResponse(fe)}else throw new Error("no signer")}catch(_){fe.success=!1,fe.message=_.message,B.sendResponse(fe)}}else L&&L.onDidSendMessage&&L.onDidSendMessage(Y),Y=(0,o.$2H)(Y,!0),b.u.$acceptDAMessage(P,Y)}),B.onError(Y=>{L&&L.onError&&L.onError(Y),this.u.$acceptDAError(P,Y.name,Y.message,Y.stack)}),B.onExit(Y=>{L&&L.onExit&&L.onExit(Y??void 0,void 0),this.u.$acceptDAExit(P,Y??void 0,void 0)}),L&&L.onWillStartSession&&L.onWillStartSession(),B.startSession()))})}$sendDAMessage(P,h){h=(0,o.$1H)(h,!1);const b=this.N.get(P);b&&b.onWillReceiveMessage&&b.onWillReceiveMessage(h),this.M.get(P)?.sendMessage(h)}$stopDASession(P){const h=this.N.get(P);this.N.delete(P),h&&h.onWillStopSession&&h.onWillStopSession();const b=this.M.get(P);return this.M.delete(P),b?b.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(P){const h=[],b=[],M=[];if(P.added)for(const O of P.added){const F=O.id;if(F&&!this.H.has(F)){let q;if(O.type==="function")q=new c.$xO(O.functionName,O.enabled,O.condition,O.hitCondition,O.logMessage,O.mode);else if(O.type==="data")q=new c.$yO(O.label,O.dataId,O.canPersist,O.enabled,O.hitCondition,O.condition,O.logMessage,O.mode);else{const B=C.URI.revive(O.uri);q=new c.$wO(new c.$GN(B,new c.$vN(O.line,O.character)),O.enabled,O.condition,O.hitCondition,O.logMessage,O.mode)}(0,c.$uO)(q,F),this.H.set(F,q),h.push(q)}}if(P.removed)for(const O of P.removed){const F=this.H.get(O);F&&(this.H.delete(O),b.push(F))}if(P.changed){for(const O of P.changed)if(O.id){const F=this.H.get(O.id);if(F){if(F instanceof c.$xO&&O.type==="function"){const q=F;q.enabled=O.enabled,q.condition=O.condition,q.hitCondition=O.hitCondition,q.logMessage=O.logMessage,q.functionName=O.functionName}else if(F instanceof c.$wO&&O.type==="source"){const q=F;q.enabled=O.enabled,q.condition=O.condition,q.hitCondition=O.hitCondition,q.logMessage=O.logMessage,q.location=new c.$GN(C.URI.revive(O.uri),new c.$vN(O.line,O.character))}M.push(F)}}}this.rb(h,b,M)}async $acceptStackFrameFocus(P){let h;if(P){const b=await this.sb(P.sessionId);P.kind==="thread"?h=new c.$EO(b.api,P.threadId):h=new c.$DO(b.api,P.threadId,P.frameId)}this.J=h,this.L.fire(this.J)}$provideDebugConfigurations(P,h,b){return(0,v.$uh)(async()=>{const M=this.mb(P);if(!M)throw new Error("no DebugConfigurationProvider found");if(!M.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const O=await this.tb(h);return M.provideDebugConfigurations(O,b)}).then(M=>{if(!M)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return M})}$resolveDebugConfiguration(P,h,b,M){return(0,v.$uh)(async()=>{const O=this.mb(P);if(!O)throw new Error("no DebugConfigurationProvider found");if(!O.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const F=await this.tb(h);return O.resolveDebugConfiguration(F,b,M)})}$resolveDebugConfigurationWithSubstitutedVariables(P,h,b,M){return(0,v.$uh)(async()=>{const O=this.mb(P);if(!O)throw new Error("no DebugConfigurationProvider found");if(!O.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const F=await this.tb(h);return O.resolveDebugConfigurationWithSubstitutedVariables(F,b,M)})}async $provideDebugAdapter(P,h){const b=this.lb(P);if(!b)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const M=await this.sb(h);return this.pb(b,M).then(O=>{if(!O)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${M.type}'`);return this.jb(O)})}async $acceptDebugSessionStarted(P){const h=await this.sb(P);this.y.fire(h.api)}async $acceptDebugSessionTerminated(P){const h=await this.sb(P);h&&(this.z.fire(h.api),this.w.delete(h.id))}async $acceptDebugSessionActiveChanged(P){this.D=P?await this.sb(P):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(P,h){(await this.sb(P))?._acceptNameChanged(h)}async $acceptDebugSessionCustomEvent(P,h){const M={session:(await this.sb(P)).api,event:h.event,body:h.body};this.F.fire(M)}jb(P){if(P instanceof c.$zO)return{type:"executable",command:P.command,args:P.args,options:P.options};if(P instanceof c.$AO)return{type:"server",port:P.port,host:P.host};if(P instanceof c.$BO)return{type:"pipeServer",path:P.path};if(P instanceof c.$CO)return{type:"implementation",implementation:P.implementation};throw new Error("convertToDto unexpected type")}kb(P){const h=this.j.filter(b=>b.type===P);if(h.length>0)return h[0].factory}lb(P){const h=this.j.filter(b=>b.handle===P);if(h.length>0)return h[0].factory}mb(P){const h=this.g.filter(b=>b.handle===P);if(h.length>0)return h[0].provider}nb(P,h){if(P.contributes){const b=P.contributes.debuggers;if(b&&b.length>0){for(const M of b)if(M.label&&M.type&&M.type===h)return!0}}return!1}ob(P){const b=P.configuration.type,M=this.n.filter(O=>O.type===b||O.type==="*").map(O=>(0,v.$uh)(()=>O.factory.createDebugAdapterTracker(P.api)).then(F=>F,F=>null));return Promise.race([Promise.all(M).then(O=>{const F=(0,g.$Gb)(O);if(F.length>0)return new E(F)}),new Promise(O=>setTimeout(()=>O(void 0),1e3))]).catch(O=>{})}async pb(P,h){const b=h.configuration.debugServer;if(typeof b=="number")return Promise.resolve(new c.$AO(b));if(P){const O=await this.Z.getExtensionRegistry();return(0,v.$uh)(()=>P.createDebugAdapterDescriptor(h.api,this.qb(h,O))).then(F=>{if(F)return F})}const M=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb(h,M))}qb(P,h){}rb(P,h,b){(P.length>0||h.length>0||b.length>0)&&this.I.fire(Object.freeze({added:P,removed:h,changed:b}))}async sb(P){if(P)if(typeof P=="string"){const h=this.w.get(P);if(h)return h}else{let h=this.w.get(P.id);if(!h){const b=await this.tb(P.folderUri),M=P.parent?this.w.get(P.parent):void 0;h=new m(this.u,P.id,P.type,P.name,b,P.configuration,M?.api),this.w.set(h.id,h),this.u.$sessionCached(h.id)}return h}throw new Error("cannot find session")}tb(P){if(P){const h=C.URI.revive(P);return this.Y.resolveWorkspaceFolder(h)}return Promise.resolve(void 0)}ub(P,h){return`${P}\0${h}`}vb(P,h){if(h){if("title"in h&&"command"in h)return{type:n.DebugVisualizationType.Command};if("treeId"in h)return{type:n.DebugVisualizationType.Tree,id:`${P}\0${h.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(P){const h=this.xb(P);let b,M;return"id"in h?M=i.ThemeIcon.asClassName(h):b=h,{iconPath:b,iconClass:M}}xb(P){if(P instanceof c.$rO)return{id:P.id};const h=typeof P=="object"&&"dark"in P?P.dark:P,b=typeof P=="object"&&"light"in P?P.light:P;return{dark:typeof h=="string"?C.URI.file(h):h,light:typeof b=="string"?C.URI.file(b):b}}};e.$ypc=p,e.$ypc=p=Qe([qe(0,y.$1P),qe(1,S.$Joc),qe(2,R.$npc),qe(3,s.$Moc),qe(4,a.$Yoc),qe(5,l.$qpc),qe(6,r.$kQ),qe(7,u.$spc)],p);class m{constructor(P,h,b,M,O,F,q){this.f=P,this.g=h,this.h=b,this.j=M,this.k=O,this.l=F,this.m=q}get api(){const P=this;return this.d??=Object.freeze({id:P.g,type:P.h,get name(){return P.j},set name(h){P.j=h,P.f.$setDebugSessionName(P.g,h)},parentSession:P.m,workspaceFolder:P.k,configuration:P.l,customRequest(h,b){return P.f.$customDebugAdapterRequest(P.g,h,b)},getDebugProtocolBreakpoint(h){return P.f.$getDebugProtocolBreakpoint(P.g,h.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(P){this.j=P}get configuration(){return this.l}}e.$zpc=m;class d{constructor(P){this.value=Object.freeze({append(h){P.$appendDebugConsole(h)},appendLine(h){this.append(h+`
`)}})}}e.$Apc=d;class E{constructor(P){this.d=P}onWillStartSession(){this.d.forEach(P=>P.onWillStartSession?P.onWillStartSession():void 0)}onWillReceiveMessage(P){this.d.forEach(h=>h.onWillReceiveMessage?h.onWillReceiveMessage(P):void 0)}onDidSendMessage(P){this.d.forEach(h=>h.onDidSendMessage?h.onDidSendMessage(P):void 0)}onWillStopSession(){this.d.forEach(P=>P.onWillStopSession?P.onWillStopSession():void 0)}onError(P){this.d.forEach(h=>h.onError?h.onError(P):void 0)}onExit(P,h){this.d.forEach(b=>b.onExit?b.onExit(P,h):void 0)}}class D extends f.$Htb{constructor(P){super(),this.h=P,P.onDidSendMessage(h=>{this.acceptMessage(h)})}startSession(){return Promise.resolve(void 0)}sendMessage(P){this.h.handleMessage(P)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let w=class extends p{constructor(P,h,b,M,O,F,q,B){super(P,h,b,M,O,F,q,B)}};e.$Bpc=w,e.$Bpc=w=Qe([qe(0,y.$1P),qe(1,S.$Joc),qe(2,R.$npc),qe(3,s.$Moc),qe(4,a.$Yoc),qe(5,l.$qpc),qe(6,r.$kQ),qe(7,u.$spc)],w)}),define(Ne[273],Oe([1,0,13,64,2,5,223,11,60,74,26,169,16,65,47,66]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cqc=e.$Bqc=void 0,v=Ve(v),I=Ve(I);class o{static async installEarlyHandler(i){Error.stackTraceLimit=100;const r=i.get(T.$9j),g=i.get(c.$1P).getProxy(N.$sN.MainThreadErrors);v.setUnexpectedErrorHandler(u=>{r.error(u);const p=v.$1(u);g.$onUnexpectedError(p)})}static async installFullHandler(i){const r=i.get(T.$9j),t=i.get(c.$1P),g=i.get(f.$npc),u=i.get(n.$iQ),p=t.getProxy(N.$sN.MainThreadExtensionService),m=t.getProxy(N.$sN.MainThreadErrors),d=await g.getExtensionPathIndex(),E=new WeakMap;function D(P,h){if(E.has(P))return E.get(P).stack;let b="",M,O;for(const q of h)b+=`
	at ${q.toString()}`,O=q.getFileName(),!M&&O&&(M=d.findSubstr(C.URI.file(O)));const F=`${P.name||"Error"}: ${P.message||""}${b}`;return E.set(P,{extensionIdentifier:M?.identifier,stack:F}),F}const w=Symbol("prepareStackTrace wrapped");let k=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return k},set(P){if(P===D||!P||P[w]){k=P||D;return}k=function(h,b){return D(h,b),P.call(Error,h,b)},Object.assign(k,{[w]:!0})}}),v.setUnexpectedErrorHandler(P=>{r.error(P);const h=v.$1(P),b=E.get(P);if(!b?.extensionIdentifier){m.$onUnexpectedError(h);return}p.$onExtensionRuntimeError(b.extensionIdentifier,h);const M=u.onExtensionError(b.extensionIdentifier,P);r.trace("forwarded error to extension?",M,b)})}}e.$Bqc=o;class s{constructor(i,r,t,g,u){this.a=t,this.b=new A.$Wcc(i,null,g),r=s.e(r,this.b);const p=new a.$Ai(...(0,$.$Os)());p.set(R.$eQ,{_serviceBrand:void 0,...r,messagePorts:u}),p.set(c.$1P,new c.$2P(this.b)),p.set(S.$Goc,new S.$Hoc(g)),p.set(f.$lpc,t);const m=new y.$sr(p,!0);m.invokeFunction(o.installEarlyHandler),this.d=m.invokeFunction(d=>d.get(T.$9j)),I.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",r),this.c=m.invokeFunction(d=>d.get(f.$npc)),this.c.initialize(),m.invokeFunction(o.installFullHandler)}async asBrowserUri(i){const r=this.b.getProxy(N.$sN.MainThreadExtensionService);return C.URI.revive(await r.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,r){i.extensions.allExtensions.forEach(g=>{g.extensionLocation=C.URI.revive(r.transformIncomingURIs(g.extensionLocation))}),i.environment.appRoot=C.URI.revive(r.transformIncomingURIs(i.environment.appRoot));const t=i.environment.extensionDevelopmentLocationURI;return t&&(i.environment.extensionDevelopmentLocationURI=t.map(g=>C.URI.revive(r.transformIncomingURIs(g)))),i.environment.extensionTestsLocationURI=C.URI.revive(r.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=C.URI.revive(r.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=C.URI.revive(r.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=C.URI.revive(r.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=C.URI.revive(r.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=C.URI.revive(r.transformIncomingURIs(i.logsLocation)),i.workspace=r.transformIncomingURIs(i.workspace),i}}e.$Cqc=s}),define(Ne[274],Oe([1,0,17,10,21,42,15,19,23,2,44]),function(we,e,v,I,C,N,A,T,$,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Spc=e.$Qpc=e.$Ppc=void 0,e.$Rpc=n,T=Ve(T),$=Ve($);class y{constructor(l,i,r){this.d=l,this.e=i,this.f=r,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(l,i){const r=this.g.folderQueries||[],t=new C.$ue(i);return new Promise((g,u)=>{this.a=new S(l);let p=!1;const m=(d,E)=>{if(!p&&!this.b){const D=this.h(d);n(d)&&typeof this.g.maxResults=="number"&&this.c+D>this.g.maxResults&&(this.b=!0,p=!0,t.cancel(),d=this.j(d,this.g.maxResults-this.c));const w=this.h(d);this.c+=w,(w>0||!n(d))&&this.a.add(d,E)}};Promise.all(r.map((d,E)=>this.k(d,D=>m(D,E),t.token))).then(d=>{t.dispose(),this.a.flush();const E=d.some(D=>!!D&&!!D.limitHit);g({limitHit:this.b||E,messages:d.flatMap(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[]),stats:{type:this.f}})},d=>{t.dispose();const E=(0,N.$nj)(d);u(new Error(E))})})}h(l){return n(l)?Array.isArray(l.ranges)?l.ranges.length:1:0}j(l,i){const r=Array.isArray(l.ranges)?l.ranges:[l.ranges],t=Array.isArray(l.preview.matches)?l.preview.matches:[l.preview.matches];return{ranges:r.slice(0,i),preview:{matches:t.slice(0,i),text:l.preview.text},uri:l.uri}}async k(l,i,r){const t=new R.$9L(this.g,l),g=[],u={report:d=>{if(!this.l(d))return;const E=l.folder.scheme===A.Schemas.file?(0,R.$0L)(()=>this.e.readdir($.$ch(d.uri))):void 0,D=$.$fh(l.folder,d.uri);if(D){const w=t.includedInQuery(D,T.$mc(D),E);(0,I.$oh)(w)?g.push(w.then(k=>{k&&i(d)})):w&&i(d)}}},p=this.n(l);let m;return this.d.query.type===R.QueryType.aiText?m=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,p,u,r):m=await this.d.provider.provideTextSearchResults(c(this.d.query.contentPattern),p,u,r),g.length&&await Promise.all(g),m}l(l){if(n(l)){if(Array.isArray(l.ranges)){if(!Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(l.preview.matches.length!==l.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(l){const i=(0,R.$8L)(this.g.includePattern,l.includePattern),r=(0,R.$8L)(this.g.excludePattern,l.excludePattern),t={folder:a.URI.from(l.folder),excludes:r,includes:i,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,encoding:l.fileEncoding&&this.e.toCanonicalName(l.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??R.$OL,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(t.usePCRE2=this.g.usePCRE2),t}}e.$Ppc=y;function c(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class S{constructor(l){this.e=l,this.b=-1,this.d=null,this.a=new o(512,i=>this.g(i))}add(l,i){this.d&&(this.b!==i||!$.$9g(this.c,l.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:l.uri,results:[]}),this.d.results.push(f(l))}f(){const l=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,l)}flush(){this.f(),this.a.flush()}g(l){this.e(l)}}e.$Qpc=S;function f(s){return n(s)?{preview:{matches:(0,v.$Zb)(s.preview.matches,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character})),text:s.preview.text},ranges:(0,v.$Zb)(s.ranges,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function n(s){return!!s.preview}class o{static{this.a=4e3}static{this.b=50}constructor(l,i){this.g=l,this.h=i,this.c=0,this.d=[],this.e=0}addItem(l,i){l&&this.j(l,i)}addItems(l,i){l&&this.k(l,i)}j(l,i){this.d.push(l),this.e+=i,this.l()}k(l,i){this.d=this.d.concat(l),this.e+=i,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Spc=o}),define(Ne[134],Oe([1,0,4,5,3,269,16,65,11,2,274]),function(we,e,v,I,C,N,A,T,$,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Upc=e.$Tpc=void 0,e.$Vpc=c,e.$Tpc=(0,C.$Ci)("IExtHostSearch");let y=class{constructor(n,o,s){this.n=n,this.o=o,this.q=s,this.c=this.n.getProxy(I.$sN.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new N.$Opc}s(n){return this.o.transformOutgoingScheme(n)}registerTextSearchProvider(n,o){if(this.g.has(n))throw new Error(`a text search provider for the scheme '${n}' is already registered`);this.g.add(n);const s=this.d++;return this.e.set(s,o),this.c.$registerTextSearchProvider(s,this.s(n)),(0,v.$Rc)(()=>{this.g.delete(n),this.e.delete(s),this.c.$unregisterProvider(s)})}registerAITextSearchProvider(n,o){if(this.i.has(n))throw new Error(`an AI text search provider for the scheme '${n}'is already registered`);this.i.add(n);const s=this.d++;return this.h.set(s,o),this.c.$registerAITextSearchProvider(s,this.s(n)),(0,v.$Rc)(()=>{this.i.delete(n),this.h.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(n,o){if(this.k.has(n))throw new Error(`a file search provider for the scheme '${n}' is already registered`);this.k.add(n);const s=this.d++;return this.j.set(s,o),this.c.$registerFileSearchProvider(s,this.s(n)),(0,v.$Rc)(()=>{this.k.delete(n),this.j.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(n,o,s,l){const i=c(s),r=this.j.get(n);if(r)return this.l.fileSearch(i,r,t=>{this.c.$handleFileMatch(n,o,t.map(g=>g.resource))},l);throw new Error("3 unknown provider: "+n)}async doInternalFileSearchWithCustomCallback(n,o,s){return{messages:[]}}$clearCache(n){return this.l.clearCache(n),Promise.resolve(void 0)}$provideTextSearchResults(n,o,s,l){const i=this.e.get(n);if(!i||!i.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${n}`);const r=c(s);return this.t(r,i).search(g=>this.c.$handleTextMatch(n,o,g),l)}$provideAITextSearchResults(n,o,s,l){const i=this.h.get(n);if(!i||!i.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${n}`);const r=c(s);return this.v(r,i).search(g=>this.c.$handleTextMatch(n,o,g),l)}$enableExtensionHostSearch(){}t(n,o){return new R.$Ppc({query:n,provider:o},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}v(n,o){return new R.$Ppc({query:n,provider:o},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"aiTextSearchProvider")}};e.$Upc=y,e.$Upc=y=Qe([qe(0,A.$1P),qe(1,T.$Goc),qe(2,$.$9j)],y);function c(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(S),extraFileResources:f.extraFileResources&&f.extraFileResources.map(n=>a.URI.revive(n))}}function S(f){return{...f,folder:a.URI.revive(f.folder)}}});var _t=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Ne[275],Oe([1,0,21,13,6,4,15,35,2,105,156,157,52,18,29,11,62,63,184,5,226,255,84,90,231,232,233,210,200,33,234,46,235,133,122,236,212,227,237,238,57,70,213,228,47,240,68,241,50,26,256,214,242,243,94,244,85,86,216,268,246,189,247,257,248,128,217,249,250,251,16,252,134,87,253,218,254,88,91,131,66,56,126,95,258,229,259,260,92,8,7,219,65,220,67,261,262,121,45,80,83,24,130]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S,f,n,o,s,l,i,r,t,g,u,p,m,d,E,D,w,k,P,h,b,M,O,F,q,B,L,Y,Z,fe,_,ge,se,ae,$e,oe,Ce,Fe,X,V,te,ve,ce,be,he,J,x,me,pe,Ae,ze,ke,Pe,Te,U,j,G,Q,ne,de,Ie,je,Ke,_e,tt,nt,et,rt,ft,ct,st,lt,gt,pt,Be,Ue,ee,K,De,Je,xe,ht,$t,Ot,zt,ei,ui,ti,Ye,Gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wqc=Kt,I=Ve(I),T=_t(T),y=Ve(y),f=Ve(f),ee=Ve(ee),K=Ve(K);function Kt(mt){const Ct=mt.get(Ce.$eQ),ii=mt.get(oe.$roc),Xt=mt.get(ae.$Ooc),Bt=mt.get(ge.$npc),vt=mt.get(ei.$Joc),Nt=mt.get(rt.$iQ),hi=mt.get(P.$Moc),Wt=mt.get(Je.$Goc),Xe=mt.get(Q.$1P),Yt=mt.get(tt.$8oc),ni=mt.get(nt.$Poc),di=mt.get(n.$0j),St=mt.get(n.$9j),Lt=mt.get(Ue.$SFb),Rt=mt.get(g.$noc),jt=mt.get(zt.$vqc),ri=mt.get(Ie.$fpc),Zt=mt.get(Z.$Yoc),si=mt.get(he.$jpc),Vt=mt.get(u.$xoc),Qt=mt.get(ve.$cpc);Xe.set(i.$tN.ExtHostFileSystemInfo,ii),Xe.set(i.$tN.ExtHostLogLevelServiceShape,di),Xe.set(i.$tN.ExtHostWorkspace,vt),Xe.set(i.$tN.ExtHostConfiguration,hi),Xe.set(i.$tN.ExtHostExtensionService,Bt),Xe.set(i.$tN.ExtHostStorage,Yt),Xe.set(i.$tN.ExtHostTunnelService,Lt),Xe.set(i.$tN.ExtHostWindow,jt),Xe.set(i.$tN.ExtHostSecretState,ri),Xe.set(i.$tN.ExtHostTelemetry,Nt),Xe.set(i.$tN.ExtHostEditorTabs,Zt),Xe.set(i.$tN.ExtHostManagedSockets,si),Xe.set(i.$tN.ExtHostAuthentication,Vt),Xe.set(i.$tN.ExtHostChatProvider,Qt);const oi=Xe.set(i.$tN.ExtHostDecorations,mt.get(M.$Dpc)),Pt=Xe.set(i.$tN.ExtHostDocumentsAndEditors,mt.get(Y.$_P)),Dt=Xe.set(i.$tN.ExtHostCommands,mt.get(w.$kQ)),bt=Xe.set(i.$tN.ExtHostTerminalService,mt.get(ft.$$oc)),xt=Xe.set(i.$tN.ExtHostTerminalShellIntegration,mt.get(ct.$lqc)),kt=Xe.set(i.$tN.ExtHostDebugService,mt.get(b.$xpc)),fi=Xe.set(i.$tN.ExtHostSearch,mt.get(de.$Tpc)),qt=Xe.set(i.$tN.ExtHostTask,mt.get(et.$kqc)),bi=Xe.set(i.$tN.ExtHostOutputService,mt.get(Pe.$0pc)),vi=Xe.set(i.$tN.ExtHostLocalization,mt.get(be.$ipc)),gi=Xe.set(i.$tN.ExtHostUrls,new xe.$sqc(Xe)),Mt=Xe.set(i.$tN.ExtHostDocuments,new L.$uoc(Xe,Pt)),ai=Xe.set(i.$tN.ExtHostDocumentContentProviders,new q.$Fpc(Xe,Pt,St)),Ii=Xe.set(i.$tN.ExtHostDocumentSaveParticipant,new B.$Gpc(St,Mt,Xe.getProxy(i.$sN.MainThreadBulkEdits))),At=Xe.set(i.$tN.ExtHostNotebook,new x.$Wpc(Xe,Dt,Pt,Mt,Xt,fi,St)),Di=Xe.set(i.$tN.ExtHostNotebookDocuments,new pe.$4pc(At)),Pi=Xe.set(i.$tN.ExtHostNotebookEditors,new Ae.$5pc(St,At)),Si=Xe.set(i.$tN.ExtHostNotebookKernels,new ze.$6pc(Xe,Ct,At,Dt,St)),pi=Xe.set(i.$tN.ExtHostNotebookRenderers,new ke.$8pc(Xe,At)),Ri=Xe.set(i.$tN.ExtHostNotebookDocumentSaveParticipant,new me.$3pc(St,At,Xe.getProxy(i.$sN.MainThreadBulkEdits))),Ut=Xe.set(i.$tN.ExtHostEditors,new lt.$Doc(Xe,Pt)),ye=Xe.set(i.$tN.ExtHostTreeViews,new Be.$qqc(Xe.getProxy(i.$sN.MainThreadTreeViews),Dt,St)),Re=Xe.set(i.$tN.ExtHostEditorInsets,new D.$Eoc(Xe.getProxy(i.$sN.MainThreadEditorInsets),Ut,Ct.remote)),le=Xe.set(i.$tN.ExtHostDiagnostics,new O.$toc(Xe,St,ii,Pt)),H=Xe.set(i.$tN.ExtHostLanguages,new ce.$1pc(Xe,Mt,Dt.converter,Wt)),Ee=Xe.set(i.$tN.ExtHostLanguageFeatures,new V.$voc(Xe,Wt,Mt,Dt,le,St,Rt,Nt)),We=Xe.set(i.$tN.ExtHostFileSystem,new se.$Jpc(Xe,Ee)),Ze=Xe.set(i.$tN.ExtHostFileSystemEventService,new $e.$Kpc(Xe,St,Pt)),Ge=Xe.set(i.$tN.ExtHostQuickOpen,(0,G.$bqc)(Xe,vt,Dt)),ut=Xe.set(i.$tN.ExtHostSCM,new ne.$dqc(Xe,Dt,Mt,St)),It=Xe.set(i.$tN.ExtHostQuickDiff,new j.$aqc(Xe,Wt)),Ht=Xe.set(i.$tN.ExtHostShare,new je.$eqc(Xe,Wt)),ci=Xe.set(i.$tN.ExtHostComments,(0,k.$Foc)(Xe,Dt,Mt)),Ft=Xe.set(i.$tN.ExtHostProgress,new U.$_pc(Xe.getProxy(i.$sN.MainThreadProgress))),li=Xe.set(i.$tN.ExtHostLabelService,new X.$Ypc(Xe)),Vi=Xe.set(i.$tN.ExtHostTheming,new gt.$nqc(Xe)),$n=Xe.set(i.$tN.ExtHostTimeline,new pt.$pqc(Xe,Dt)),Fi=Xe.set(i.$tN.ExtHostWebviews,new ht.$Toc(Xe,Ct.remote,vt,St,Rt)),Ni=Xe.set(i.$tN.ExtHostWebviewPanels,new $t.$Woc(Xe,Fi,vt)),qi=Xe.set(i.$tN.ExtHostCustomEditors,new h.$Xoc(Xe,Mt,ni,Fi,Ni)),xi=Xe.set(i.$tN.ExtHostWebviewViews,new Ot.$tqc(Xe,Fi)),ki=Xe.set(i.$tN.ExtHostTesting,mt.get(st.$spc)),_i=Xe.set(i.$tN.ExtHostUriOpeners,new De.$rqc(Xe)),en=Xe.set(i.$tN.ExtHostProfileContentHandlers,new Te.$$pc(Xe));Xe.set(i.$tN.ExtHostInteractive,new Fe.$Xpc(Xe,At,Pt,Dt,St));const Mi=Xe.set(i.$tN.ExtHostChatAgents2,new m.$Aoc(Xe,St,Dt,Mt)),tn=Xe.set(i.$tN.ExtHostChatVariables,new d.$Boc(Xe)),Gi=Xe.set(i.$tN.ExtHostLanguageModelTools,new te.$Zpc(Xe)),nn=Xe.set(i.$tN.ExtHostAiRelatedInformation,new r.$moc(Xe)),Ki=Xe.set(i.$tN.ExtHostAiEmbeddingVector,new _.$Ipc(Xe)),zi=Xe.set(i.$tN.ExtHostStatusBar,new _e.$hqc(Xe,Dt.converter)),wn=Xe.set(i.$tN.ExtHostSpeech,new Ke.$fqc(Xe)),Oi=Xe.set(i.$tN.ExtHostEmbeddings,new fe.$Hpc(Xe)),rn=Object.values(i.$tN);Xe.assertRegistered(rn);const bn=new p.$zoc(Xe,Pt),Qi=new E.$Coc(Xe),ji=new J.$2pc(Xe,St),Hi=new F.$Epc(Xe);return t.$woc.register(Dt),function(Me,yi,Ui){function ot(ie){return(ue,Le,at)=>{const Et=ie(Tt=>{try{ue.call(Le,Tt)}catch(Ai){I.$Z(new Error(`[ExtensionListenerError] Extension '${Me.identifier.value}' FAILED to handle event: ${Ai.toString()}`,{cause:Ai})),Nt.onExtensionError(Me.identifier,Ai)}});return at?.push(Et),Et}}const wt=function(){let ie=!Me.isUnderDevelopment;function ue(){ie||(St.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Le(at){if(Array.isArray(at))at.forEach(Le);else if(typeof at=="string")ue();else{const Et=at;typeof Et.scheme>"u"&&ue(),typeof Et.exclusive=="boolean"&&(0,Ye.$5G)(Me,"documentFiltersExclusive")}return at}}(),Bi={getSession(ie,ue,Le){return typeof Le?.forceNewSession=="object"&&Le.forceNewSession.learnMore&&(0,Ye.$5G)(Me,"authLearnMore"),Le?.account&&(0,Ye.$5G)(Me,"authGetSessions"),Vt.getSession(Me,ie,ue,Le)},getAccounts(ie){return(0,Ye.$5G)(Me,"authGetSessions"),Vt.getAccounts(ie)},async hasSession(ie,ue){return(0,Ye.$5G)(Me,"authSession"),!!await Vt.getSession(Me,ie,ue,{silent:!0})},get onDidChangeSessions(){return ot(Vt.onDidChangeSessions)},registerAuthenticationProvider(ie,ue,Le,at){return Vt.registerAuthenticationProvider(ie,ue,Le,at)}},vn={registerCommand(ie,ue,Le){return Dt.registerCommand(!0,ie,ue,Le,void 0,Me)},registerTextEditorCommand(ie,ue,Le){return Dt.registerCommand(!0,ie,(...at)=>{const Et=Ut.getActiveTextEditor();if(!Et){St.warn("Cannot execute "+ie+" because there is no active text editor.");return}return Et.edit(Tt=>{ue.apply(Le,[Et,Tt,...at])}).then(Tt=>{Tt||St.warn("Edits from command "+ie+" were not applied.")},Tt=>{St.warn("An error occurred while running command "+ie,Tt)})},void 0,void 0,Me)},registerDiffInformationCommand:(ie,ue,Le)=>((0,Ye.$5G)(Me,"diffCommand"),Dt.registerCommand(!0,ie,async(...at)=>{const Et=Pt.activeEditor(!0);if(!Et){St.warn("Cannot execute "+ie+" because there is no active text editor.");return}const Tt=await Ut.getDiffInformation(Et.id);ue.apply(Le,[Tt,...at])},void 0,void 0,Me)),executeCommand(ie,...ue){return Dt.executeCommand(ie,...ue)},getCommands(ie=!1){return Dt.getCommands(ie)}},mi={get machineId(){return Ct.telemetryInfo.machineId},get sessionId(){return Ct.telemetryInfo.sessionId},get language(){return Ct.environment.appLanguage},get appName(){return Ct.environment.appName},get appRoot(){return Ct.environment.appRoot?.fsPath??""},get appHost(){return Ct.environment.appHost},get uriScheme(){return Ct.environment.appUriScheme},get clipboard(){return Qi.value},get shell(){return bt.getDefaultShell(!1)},get onDidChangeShell(){return ot(bt.onDidChangeShell)},get isTelemetryEnabled(){return Nt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(Nt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ye.$5G)(Me,"telemetry"),Nt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ye.$5G)(Me,"telemetry"),ot(Nt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,rt.$hQ)(Ct.telemetryInfo.firstSessionDate)},createTelemetryLogger(ie,ue){return rt.$gQ.validateSender(ie),Nt.instantiateLogger(Me,ie,ue)},openExternal(ie,ue){return jt.openUri(ie,{allowTunneling:!!Ct.remote.authority,allowContributedOpeners:ue?.allowContributedOpeners})},async asExternalUri(ie){if(ie.scheme===Ct.environment.appUriScheme)return gi.createAppUri(ie);try{return await jt.asExternalUri(ie,{allowTunneling:!!Ct.remote.authority})}catch(ue){if((0,A.$Lg)(ie,A.Schemas.http)||(0,A.$Lg)(ie,A.Schemas.https))return ie;throw ue}},get remoteName(){return(0,o.$en)(Ct.remote.authority)},get remoteAuthority(){return(0,Ye.$5G)(Me,"resolvers"),Ct.remote.authority},get uiKind(){return Ct.uiKind},get logLevel(){return St.getLevel()},get onDidChangeLogLevel(){return ot(St.onDidChangeLogLevel)},get appQuality(){return(0,Ye.$5G)(Me,"resolvers"),Ct.quality},get appCommit(){return(0,Ye.$5G)(Me,"resolvers"),Ct.commit}};Ct.environment.extensionTestsLocationURI||Object.freeze(mi);const Wi={createTestController(ie,ue,Le){return ki.createTestController(Me,ie,ue,Le)},createTestObserver(){return(0,Ye.$5G)(Me,"testObserver"),ki.createTestObserver()},runTests(ie){return(0,Ye.$5G)(Me,"testObserver"),ki.runTests(ie)},registerTestFollowupProvider(ie){return(0,Ye.$5G)(Me,"testObserver"),ki.registerTestFollowupProvider(ie)},get onDidChangeTestResults(){return(0,Ye.$5G)(Me,"testObserver"),ot(ki.onResultsChanged)},get testResults(){return(0,Ye.$5G)(Me,"testObserver"),ki.results}},Li=Ct.remote.isRemote?K.ExtensionKind.Workspace:K.ExtensionKind.UI,sn={getExtension(ie,ue){(0,Ye.$4G)(Me,"extensionsAny")||(ue=!1);const Le=yi.mine.getExtensionDescription(ie);if(Le)return new ge.$opc(Bt,Me.identifier,Le,Li,!1);if(ue){const at=yi.all.getExtensionDescription(ie);if(at)return new ge.$opc(Bt,Me.identifier,at,Li,!0)}},get all(){const ie=[];for(const ue of yi.mine.getAllExtensionDescriptions())ie.push(new ge.$opc(Bt,Me.identifier,ue,Li,!1));return ie},get allAcrossExtensionHosts(){(0,Ye.$5G)(Me,"extensionsAny");const ie=new S.$on(yi.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),ue=[];for(const Le of yi.all.getAllExtensionDescriptions()){const at=!ie.has(Le.identifier);ue.push(new ge.$opc(Bt,Me.identifier,Le,Li,at))}return ue},get onDidChange(){return(0,Ye.$4G)(Me,"extensionsAny")?ot(C.Event.any(yi.mine.onDidChange,yi.all.onDidChange)):ot(yi.mine.onDidChange)}},on={createDiagnosticCollection(ie){return le.createDiagnosticCollection(Me.identifier,ie)},get onDidChangeDiagnostics(){return ot(le.onDidChangeDiagnostics)},getDiagnostics:ie=>le.getDiagnostics(ie),getLanguages(){return H.getLanguages()},setTextDocumentLanguage(ie,ue){return H.changeLanguage(ie.uri,ue)},match(ie,ue){const Le=ee.LanguageSelector.from(ie);let at;return(0,R.$su)(Le)&&(at=At.notebookDocuments.find(Et=>Et.apiNotebook.getCells().find(Tt=>Tt.document===ue))?.apiNotebook),(0,R.$ru)(Le,ue.uri,ue.languageId,!0,at?.uri,at?.notebookType)},registerCodeActionsProvider(ie,ue,Le){return Ee.registerCodeActionProvider(Me,wt(ie),ue,Le)},registerDocumentPasteEditProvider(ie,ue,Le){return(0,Ye.$5G)(Me,"documentPaste"),Ee.registerDocumentPasteEditProvider(Me,wt(ie),ue,Le)},registerCodeLensProvider(ie,ue){return Ee.registerCodeLensProvider(Me,wt(ie),ue)},registerDefinitionProvider(ie,ue){return Ee.registerDefinitionProvider(Me,wt(ie),ue)},registerDeclarationProvider(ie,ue){return Ee.registerDeclarationProvider(Me,wt(ie),ue)},registerImplementationProvider(ie,ue){return Ee.registerImplementationProvider(Me,wt(ie),ue)},registerTypeDefinitionProvider(ie,ue){return Ee.registerTypeDefinitionProvider(Me,wt(ie),ue)},registerHoverProvider(ie,ue){return Ee.registerHoverProvider(Me,wt(ie),ue,Me.identifier)},registerEvaluatableExpressionProvider(ie,ue){return Ee.registerEvaluatableExpressionProvider(Me,wt(ie),ue,Me.identifier)},registerInlineValuesProvider(ie,ue){return Ee.registerInlineValuesProvider(Me,wt(ie),ue,Me.identifier)},registerDocumentHighlightProvider(ie,ue){return Ee.registerDocumentHighlightProvider(Me,wt(ie),ue)},registerMultiDocumentHighlightProvider(ie,ue){return Ee.registerMultiDocumentHighlightProvider(Me,wt(ie),ue)},registerLinkedEditingRangeProvider(ie,ue){return Ee.registerLinkedEditingRangeProvider(Me,wt(ie),ue)},registerReferenceProvider(ie,ue){return Ee.registerReferenceProvider(Me,wt(ie),ue)},registerRenameProvider(ie,ue){return Ee.registerRenameProvider(Me,wt(ie),ue)},registerNewSymbolNamesProvider(ie,ue){return(0,Ye.$5G)(Me,"newSymbolNamesProvider"),Ee.registerNewSymbolNamesProvider(Me,wt(ie),ue)},registerDocumentSymbolProvider(ie,ue,Le){return Ee.registerDocumentSymbolProvider(Me,wt(ie),ue,Le)},registerWorkspaceSymbolProvider(ie){return Ee.registerWorkspaceSymbolProvider(Me,ie)},registerDocumentFormattingEditProvider(ie,ue){return Ee.registerDocumentFormattingEditProvider(Me,wt(ie),ue)},registerDocumentRangeFormattingEditProvider(ie,ue){return Ee.registerDocumentRangeFormattingEditProvider(Me,wt(ie),ue)},registerOnTypeFormattingEditProvider(ie,ue,Le,...at){return Ee.registerOnTypeFormattingEditProvider(Me,wt(ie),ue,[Le].concat(at))},registerDocumentSemanticTokensProvider(ie,ue,Le){return Ee.registerDocumentSemanticTokensProvider(Me,wt(ie),ue,Le)},registerDocumentRangeSemanticTokensProvider(ie,ue,Le){return Ee.registerDocumentRangeSemanticTokensProvider(Me,wt(ie),ue,Le)},registerSignatureHelpProvider(ie,ue,Le,...at){return typeof Le=="object"?Ee.registerSignatureHelpProvider(Me,wt(ie),ue,Le):Ee.registerSignatureHelpProvider(Me,wt(ie),ue,typeof Le>"u"?[]:[Le,...at])},registerCompletionItemProvider(ie,ue,...Le){return Ee.registerCompletionItemProvider(Me,wt(ie),ue,Le)},registerInlineCompletionItemProvider(ie,ue,Le){return ue.handleDidShowCompletionItem&&(0,Ye.$5G)(Me,"inlineCompletionsAdditions"),ue.handleDidPartiallyAcceptCompletionItem&&(0,Ye.$5G)(Me,"inlineCompletionsAdditions"),Le&&(0,Ye.$5G)(Me,"inlineCompletionsAdditions"),Ee.registerInlineCompletionsProvider(Me,wt(ie),ue,Le)},registerInlineEditProvider(ie,ue){return(0,Ye.$5G)(Me,"inlineEdit"),Ee.registerInlineEditProvider(Me,wt(ie),ue)},registerDocumentLinkProvider(ie,ue){return Ee.registerDocumentLinkProvider(Me,wt(ie),ue)},registerColorProvider(ie,ue){return Ee.registerColorProvider(Me,wt(ie),ue)},registerFoldingRangeProvider(ie,ue){return Ee.registerFoldingRangeProvider(Me,wt(ie),ue)},registerSelectionRangeProvider(ie,ue){return Ee.registerSelectionRangeProvider(Me,ie,ue)},registerCallHierarchyProvider(ie,ue){return Ee.registerCallHierarchyProvider(Me,ie,ue)},registerTypeHierarchyProvider(ie,ue){return Ee.registerTypeHierarchyProvider(Me,ie,ue)},setLanguageConfiguration:(ie,ue)=>Ee.setLanguageConfiguration(Me,ie,ue),getTokenInformationAtPosition(ie,ue){return(0,Ye.$5G)(Me,"tokenInformation"),H.tokenAtPosition(ie,ue)},registerInlayHintsProvider(ie,ue){return Ee.registerInlayHintsProvider(Me,ie,ue)},createLanguageStatusItem(ie,ue){return H.createLanguageStatusItem(Me,ie,ue)},registerDocumentDropEditProvider(ie,ue,Le){return Ee.registerDocumentOnDropEditProvider(Me,ie,ue,(0,Ye.$4G)(Me,"documentPaste")?Le:void 0)}},an={get activeTextEditor(){return Ut.getActiveTextEditor()},get visibleTextEditors(){return Ut.getVisibleTextEditors()},get activeTerminal(){return bt.activeTerminal},get terminals(){return bt.terminals},async showTextDocument(ie,ue,Le){$.URI.isUri(ie)&&ie.scheme===A.Schemas.vscodeRemote&&!ie.authority&&Rt.report("workspace.showTextDocument",Me,"A URI of 'vscode-remote' scheme requires an authority.");const at=await($.URI.isUri(ie)?Promise.resolve(cn.openTextDocument(ie)):Promise.resolve(ie));return Ut.showTextDocument(at,ue,Le)},createTextEditorDecorationType(ie){return Ut.createTextEditorDecorationType(Me,ie)},onDidChangeActiveTextEditor(ie,ue,Le){return ot(Ut.onDidChangeActiveTextEditor)(ie,ue,Le)},onDidChangeVisibleTextEditors(ie,ue,Le){return ot(Ut.onDidChangeVisibleTextEditors)(ie,ue,Le)},onDidChangeTextEditorSelection(ie,ue,Le){return ot(Ut.onDidChangeTextEditorSelection)(ie,ue,Le)},onDidChangeTextEditorOptions(ie,ue,Le){return ot(Ut.onDidChangeTextEditorOptions)(ie,ue,Le)},onDidChangeTextEditorVisibleRanges(ie,ue,Le){return ot(Ut.onDidChangeTextEditorVisibleRanges)(ie,ue,Le)},onDidChangeTextEditorViewColumn(ie,ue,Le){return ot(Ut.onDidChangeTextEditorViewColumn)(ie,ue,Le)},onDidCloseTerminal(ie,ue,Le){return ot(bt.onDidCloseTerminal)(ie,ue,Le)},onDidOpenTerminal(ie,ue,Le){return ot(bt.onDidOpenTerminal)(ie,ue,Le)},onDidChangeActiveTerminal(ie,ue,Le){return ot(bt.onDidChangeActiveTerminal)(ie,ue,Le)},onDidChangeTerminalDimensions(ie,ue,Le){return(0,Ye.$5G)(Me,"terminalDimensions"),ot(bt.onDidChangeTerminalDimensions)(ie,ue,Le)},onDidChangeTerminalState(ie,ue,Le){return ot(bt.onDidChangeTerminalState)(ie,ue,Le)},onDidWriteTerminalData(ie,ue,Le){return(0,Ye.$5G)(Me,"terminalDataWriteEvent"),ot(bt.onDidWriteTerminalData)(ie,ue,Le)},onDidExecuteTerminalCommand(ie,ue,Le){return(0,Ye.$5G)(Me,"terminalExecuteCommandEvent"),ot(bt.onDidExecuteTerminalCommand)(ie,ue,Le)},onDidChangeTerminalShellIntegration(ie,ue,Le){return(0,Ye.$5G)(Me,"terminalShellIntegration"),ot(xt.onDidChangeTerminalShellIntegration)(ie,ue,Le)},onDidStartTerminalShellExecution(ie,ue,Le){return(0,Ye.$5G)(Me,"terminalShellIntegration"),ot(xt.onDidStartTerminalShellExecution)(ie,ue,Le)},onDidEndTerminalShellExecution(ie,ue,Le){return(0,Ye.$5G)(Me,"terminalShellIntegration"),ot(xt.onDidEndTerminalShellExecution)(ie,ue,Le)},get state(){return jt.getState()},onDidChangeWindowState(ie,ue,Le){return ot(jt.onDidChangeWindowState)(ie,ue,Le)},showInformationMessage(ie,...ue){return ji.showMessage(Me,T.default.Info,ie,ue[0],ue.slice(1))},showWarningMessage(ie,...ue){return ji.showMessage(Me,T.default.Warning,ie,ue[0],ue.slice(1))},showErrorMessage(ie,...ue){return ji.showMessage(Me,T.default.Error,ie,ue[0],ue.slice(1))},showQuickPick(ie,ue,Le){return Ge.showQuickPick(Me,ie,ue,Le)},showWorkspaceFolderPick(ie){return Ge.showWorkspaceFolderPick(ie)},showInputBox(ie,ue){return Ge.showInput(ie,ue)},showOpenDialog(ie){return Hi.showOpenDialog(Me,ie)},showSaveDialog(ie){return Hi.showSaveDialog(ie)},createStatusBarItem(ie,ue,Le){let at,Et,Tt;return typeof ie=="string"?(at=ie,Et=ue,Tt=Le):(Et=ie,Tt=ue),zi.createStatusBarEntry(Me,at,Et,Tt)},setStatusBarMessage(ie,ue){return zi.setStatusBarMessage(ie,ue)},withScmProgress(ie){return Rt.report("window.withScmProgress",Me,"Use 'withProgress' instead."),Ft.withProgress(Me,{location:K.ProgressLocation.SourceControl},(ue,Le)=>ie({report(at){}}))},withProgress(ie,ue){return Ft.withProgress(Me,ie,ue)},createOutputChannel(ie,ue){return bi.createOutputChannel(ie,ue,Me)},createWebviewPanel(ie,ue,Le,at){return Ni.createWebviewPanel(Me,ie,ue,Le,at)},createWebviewTextEditorInset(ie,ue,Le,at){return(0,Ye.$5G)(Me,"editorInsets"),Re.createWebviewEditorInset(ie,ue,Le,at,Me)},createTerminal(ie,ue,Le){return typeof ie=="object"?"pty"in ie?bt.createExtensionTerminal(ie):bt.createTerminalFromOptions(ie):bt.createTerminal(ie,ue,Le)},registerTerminalLinkProvider(ie){return bt.registerLinkProvider(ie)},registerTerminalProfileProvider(ie,ue){return bt.registerProfileProvider(Me,ie,ue)},registerTerminalQuickFixProvider(ie,ue){return(0,Ye.$5G)(Me,"terminalQuickFixProvider"),bt.registerTerminalQuickFixProvider(ie,Me.identifier.value,ue)},registerTreeDataProvider(ie,ue){return ye.registerTreeDataProvider(ie,ue,Me)},createTreeView(ie,ue){return ye.createTreeView(ie,ue,Me)},registerWebviewPanelSerializer:(ie,ue)=>Ni.registerWebviewPanelSerializer(Me,ie,ue),registerCustomEditorProvider:(ie,ue,Le={})=>qi.registerCustomEditorProvider(Me,ie,ue,Le),registerFileDecorationProvider(ie){return oi.registerFileDecorationProvider(ie,Me)},registerUriHandler(ie){return gi.registerUriHandler(Me,ie)},createQuickPick(){return Ge.createQuickPick(Me)},createInputBox(){return Ge.createInputBox(Me)},get activeColorTheme(){return Vi.activeColorTheme},onDidChangeActiveColorTheme(ie,ue,Le){return ot(Vi.onDidChangeActiveColorTheme)(ie,ue,Le)},registerWebviewViewProvider(ie,ue,Le){return xi.registerWebviewViewProvider(Me,ie,ue,Le?.webviewOptions)},get activeNotebookEditor(){return At.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,ue,Le){return ot(At.onDidChangeActiveNotebookEditor)(ie,ue,Le)},get visibleNotebookEditors(){return At.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(At.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ie,ue,Le){return ot(Pi.onDidChangeNotebookEditorSelection)(ie,ue,Le)},onDidChangeNotebookEditorVisibleRanges(ie,ue,Le){return ot(Pi.onDidChangeNotebookEditorVisibleRanges)(ie,ue,Le)},showNotebookDocument(ie,ue){return At.showNotebookDocument(ie,ue)},registerExternalUriOpener(ie,ue,Le){return(0,Ye.$5G)(Me,"externalUriOpener"),_i.registerExternalUriOpener(Me.identifier,ie,ue,Le)},registerProfileContentHandler(ie,ue){return(0,Ye.$5G)(Me,"profileContentHandlers"),en.registerProfileContentHandler(Me,ie,ue)},registerQuickDiffProvider(ie,ue,Le,at){return(0,Ye.$5G)(Me,"quickDiffProvider"),It.registerQuickDiffProvider(wt(ie),ue,Le,at)},get tabGroups(){return Zt.tabGroups},registerShareProvider(ie,ue){return(0,Ye.$5G)(Me,"shareProvider"),Ht.registerShareProvider(wt(ie),ue)}},cn={get rootPath(){return Rt.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),vt.getPath()},set rootPath(ie){throw new I.$8("rootPath")},getWorkspaceFolder(ie){return vt.getWorkspaceFolder(ie)},get workspaceFolders(){return vt.getWorkspaceFolders()},get name(){return vt.name},set name(ie){throw new I.$8("name")},get workspaceFile(){return vt.workspaceFile},set workspaceFile(ie){throw new I.$8("workspaceFile")},updateWorkspaceFolders:(ie,ue,...Le)=>vt.updateWorkspaceFolders(Me,ie,ue||0,...Le),onDidChangeWorkspaceFolders:function(ie,ue,Le){return ot(vt.onDidChangeWorkspace)(ie,ue,Le)},asRelativePath:(ie,ue)=>vt.getRelativePath(ie,ue),findFiles:(ie,ue,Le,at)=>vt.findFiles(ie,ue,Le,Me.identifier,at),findFiles2:(ie,ue,Le)=>((0,Ye.$5G)(Me,"findFiles2"),vt.findFiles2(ie,ue,Me.identifier,Le)),findTextInFiles:(ie,ue,Le,at)=>{(0,Ye.$5G)(Me,"findTextInFiles");let Et,Tt;return typeof ue=="object"?(Et=ue,Tt=Le):(Et={},Tt=ue,at=Le),vt.findTextInFiles(ie,Et||{},Tt,Me.identifier,at)},save:ie=>vt.save(ie),saveAs:ie=>vt.saveAs(ie),saveAll:ie=>vt.saveAll(ie),applyEdit(ie,ue){return bn.applyWorkspaceEdit(ie,Me,ue)},createFileSystemWatcher:(ie,ue,Le,at)=>{let Et;return typeof ue=="boolean"?Et={ignoreCreateEvents:!!ue,ignoreChangeEvents:!!Le,ignoreDeleteEvents:!!at,correlate:!1}:ue&&((0,Ye.$5G)(Me,"createFileSystemWatcher"),Et={...ue,correlate:!0}),Ze.createFileSystemWatcher(vt,Me,ie,Et)},get textDocuments(){return Mt.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw new I.$8("textDocuments")},openTextDocument(ie){let ue;const Le=ie;if(typeof ie=="string")ue=Promise.resolve($.URI.file(ie));else if($.URI.isUri(ie))ue=Promise.resolve(ie);else if(!Le||typeof Le=="object")ue=Mt.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(at=>(at.scheme===A.Schemas.vscodeRemote&&!at.authority&&Rt.report("workspace.openTextDocument",Me,"A URI of 'vscode-remote' scheme requires an authority."),Mt.ensureDocumentData(at).then(Et=>Et.document)))},onDidOpenTextDocument:(ie,ue,Le)=>ot(Mt.onDidAddDocument)(ie,ue,Le),onDidCloseTextDocument:(ie,ue,Le)=>ot(Mt.onDidRemoveDocument)(ie,ue,Le),onDidChangeTextDocument:(ie,ue,Le)=>ot(Mt.onDidChangeDocument)(ie,ue,Le),onDidSaveTextDocument:(ie,ue,Le)=>ot(Mt.onDidSaveDocument)(ie,ue,Le),onWillSaveTextDocument:(ie,ue,Le)=>ot(Ii.getOnWillSaveTextDocumentEvent(Me))(ie,ue,Le),get notebookDocuments(){return At.notebookDocuments.map(ie=>ie.apiNotebook)},async openNotebookDocument(ie,ue){let Le;if($.URI.isUri(ie))Le=ie,await At.openNotebookDocument(ie);else if(typeof ie=="string")Le=$.URI.revive(await At.createNotebookDocument({viewType:ie,content:ue}));else throw new Error("Invalid arguments");return At.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(ie,ue,Le){return ot(Di.onDidSaveNotebookDocument)(ie,ue,Le)},onDidChangeNotebookDocument(ie,ue,Le){return ot(Di.onDidChangeNotebookDocument)(ie,ue,Le)},onWillSaveNotebookDocument(ie,ue,Le){return ot(Ri.getOnWillSaveNotebookDocumentEvent(Me))(ie,ue,Le)},get onDidOpenNotebookDocument(){return ot(At.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(At.onDidCloseNotebookDocument)},registerNotebookSerializer(ie,ue,Le,at){return At.registerNotebookSerializer(Me,ie,ue,Le,(0,Ye.$4G)(Me,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(ie,ue,Le)=>ot(Ui.onDidChangeConfiguration)(ie,ue,Le),getConfiguration(ie,ue){return ue=arguments.length===1?void 0:ue,Ui.getConfiguration(ie,ue,Me)},registerTextDocumentContentProvider(ie,ue){return ai.registerTextDocumentContentProvider(ie,ue)},registerTaskProvider:(ie,ue)=>(Rt.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),qt.registerTaskProvider(Me,ie,ue)),registerFileSystemProvider(ie,ue,Le){return(0,N.$Qc)(We.registerFileSystemProvider(Me,ie,ue,Le),Xt.addFileSystemProvider(ie,ue,Le))},get fs(){return Xt.value},registerFileSearchProvider:(ie,ue)=>((0,Ye.$5G)(Me,"fileSearchProvider"),fi.registerFileSearchProvider(ie,ue)),registerTextSearchProvider:(ie,ue)=>((0,Ye.$5G)(Me,"textSearchProvider"),fi.registerTextSearchProvider(ie,ue)),registerAITextSearchProvider:(ie,ue)=>((0,Ye.$5G)(Me,"aiTextSearchProvider"),(0,Ye.$5G)(Me,"textSearchProvider"),fi.registerAITextSearchProvider(ie,ue)),registerRemoteAuthorityResolver:(ie,ue)=>((0,Ye.$5G)(Me,"resolvers"),Bt.registerRemoteAuthorityResolver(ie,ue)),registerResourceLabelFormatter:ie=>((0,Ye.$5G)(Me,"resolvers"),li.$registerResourceLabelFormatter(ie)),getRemoteExecServer:ie=>((0,Ye.$5G)(Me,"resolvers"),Bt.getRemoteExecServer(ie)),onDidCreateFiles:(ie,ue,Le)=>ot(Ze.onDidCreateFile)(ie,ue,Le),onDidDeleteFiles:(ie,ue,Le)=>ot(Ze.onDidDeleteFile)(ie,ue,Le),onDidRenameFiles:(ie,ue,Le)=>ot(Ze.onDidRenameFile)(ie,ue,Le),onWillCreateFiles:(ie,ue,Le)=>ot(Ze.getOnWillCreateFileEvent(Me))(ie,ue,Le),onWillDeleteFiles:(ie,ue,Le)=>ot(Ze.getOnWillDeleteFileEvent(Me))(ie,ue,Le),onWillRenameFiles:(ie,ue,Le)=>ot(Ze.getOnWillRenameFileEvent(Me))(ie,ue,Le),openTunnel:ie=>((0,Ye.$5G)(Me,"tunnels"),Lt.openTunnel(Me,ie).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,Ye.$5G)(Me,"tunnels"),Lt.getTunnels()},onDidChangeTunnels:(ie,ue,Le)=>((0,Ye.$5G)(Me,"tunnels"),ot(Lt.onDidChangeTunnels)(ie,ue,Le)),registerPortAttributesProvider:(ie,ue)=>((0,Ye.$5G)(Me,"portsAttributes"),Lt.registerPortsAttributesProvider(ie,ue)),registerTunnelProvider:(ie,ue)=>((0,Ye.$5G)(Me,"tunnelFactory"),Lt.registerTunnelProvider(ie,ue)),registerTimelineProvider:(ie,ue)=>((0,Ye.$5G)(Me,"timeline"),$n.registerTimelineProvider(ie,ue,Me.identifier,Dt.converter)),get isTrusted(){return vt.trusted},requestWorkspaceTrust:ie=>((0,Ye.$5G)(Me,"workspaceTrust"),vt.requestWorkspaceTrust(ie)),onDidGrantWorkspaceTrust:(ie,ue,Le)=>ot(vt.onDidGrantWorkspaceTrust)(ie,ue,Le),registerEditSessionIdentityProvider:(ie,ue)=>((0,Ye.$5G)(Me,"editSessionIdentityProvider"),vt.registerEditSessionIdentityProvider(ie,ue)),onWillCreateEditSessionIdentity:(ie,ue,Le)=>((0,Ye.$5G)(Me,"editSessionIdentityProvider"),ot(vt.getOnWillCreateEditSessionIdentityEvent(Me))(ie,ue,Le)),registerCanonicalUriProvider:(ie,ue)=>((0,Ye.$5G)(Me,"canonicalUriProvider"),vt.registerCanonicalUriProvider(ie,ue)),getCanonicalUri:(ie,ue,Le)=>((0,Ye.$5G)(Me,"canonicalUriProvider"),vt.provideCanonicalUri(ie,ue,Le))},ln={get inputBox(){return Rt.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),ut.getLastInputBox(Me)},createSourceControl(ie,ue,Le){return ut.createSourceControl(Me,ie,ue,Le)}},un={createCommentController(ie,ue){return ci.createCommentController(Me,ie,ue)}},yn={get activeDebugSession(){return kt.activeDebugSession},get activeDebugConsole(){return kt.activeDebugConsole},get breakpoints(){return kt.breakpoints},get activeStackItem(){return kt.activeStackItem},registerDebugVisualizationProvider(ie,ue){return(0,Ye.$5G)(Me,"debugVisualization"),kt.registerDebugVisualizationProvider(Me,ie,ue)},registerDebugVisualizationTreeProvider(ie,ue){return(0,Ye.$5G)(Me,"debugVisualization"),kt.registerDebugVisualizationTree(Me,ie,ue)},onDidStartDebugSession(ie,ue,Le){return ot(kt.onDidStartDebugSession)(ie,ue,Le)},onDidTerminateDebugSession(ie,ue,Le){return ot(kt.onDidTerminateDebugSession)(ie,ue,Le)},onDidChangeActiveDebugSession(ie,ue,Le){return ot(kt.onDidChangeActiveDebugSession)(ie,ue,Le)},onDidReceiveDebugSessionCustomEvent(ie,ue,Le){return ot(kt.onDidReceiveDebugSessionCustomEvent)(ie,ue,Le)},onDidChangeBreakpoints(ie,ue,Le){return ot(kt.onDidChangeBreakpoints)(ie,ue,Le)},onDidChangeActiveStackItem(ie,ue,Le){return ot(kt.onDidChangeActiveStackItem)(ie,ue,Le)},registerDebugConfigurationProvider(ie,ue,Le){return kt.registerDebugConfigurationProvider(ie,ue,Le||ui.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,ue){return kt.registerDebugAdapterDescriptorFactory(Me,ie,ue)},registerDebugAdapterTrackerFactory(ie,ue){return kt.registerDebugAdapterTrackerFactory(ie,ue)},startDebugging(ie,ue,Le){return!Le||typeof Le=="object"&&"configuration"in Le?kt.startDebugging(ie,ue,{parentSession:Le}):kt.startDebugging(ie,ue,Le||{})},stopDebugging(ie){return kt.stopDebugging(ie)},addBreakpoints(ie){return kt.addBreakpoints(ie)},removeBreakpoints(ie){return kt.removeBreakpoints(ie)},asDebugSourceUri(ie,ue){return kt.asDebugSourceUri(ie,ue)}},En={registerTaskProvider:(ie,ue)=>qt.registerTaskProvider(Me,ie,ue),fetchTasks:ie=>qt.fetchTasks(ie),executeTask:ie=>qt.executeTask(Me,ie),get taskExecutions(){return qt.taskExecutions},onDidStartTask:(ie,ue,Le)=>ot(qt.onDidStartTask)(ie,ue,Le),onDidEndTask:(ie,ue,Le)=>ot(qt.onDidEndTask)(ie,ue,Le),onDidStartTaskProcess:(ie,ue,Le)=>ot(qt.onDidStartTaskProcess)(ie,ue,Le),onDidEndTaskProcess:(ie,ue,Le)=>ot(qt.onDidEndTaskProcess)(ie,ue,Le)},hn={createNotebookController(ie,ue,Le,at,Et){return Si.createNotebookController(Me,ie,ue,Le,at,(0,Ye.$4G)(Me,"notebookMessaging")?Et:void 0)},registerNotebookCellStatusBarItemProvider:(ie,ue)=>At.registerNotebookCellStatusBarItemProvider(Me,ie,ue),createRendererMessaging(ie){return pi.createRendererMessaging(Me,ie)},createNotebookControllerDetectionTask(ie){return(0,Ye.$5G)(Me,"notebookKernelSource"),Si.createNotebookControllerDetectionTask(Me,ie)},registerKernelSourceActionProvider(ie,ue){return(0,Ye.$5G)(Me,"notebookKernelSource"),Si.registerKernelSourceActionProvider(Me,ie,ue)},onDidChangeNotebookCellExecutionState(ie,ue,Le){return(0,Ye.$5G)(Me,"notebookCellExecutionState"),ot(Si.onDidChangeNotebookCellExecutionState)(ie,ue,Le)}},Ji={t(...ie){if(typeof ie[0]=="string"){const ue=ie.shift(),Le=!ie||typeof ie[0]!="object"?ie:ie[0];return vi.getMessage(Me.identifier.value,{message:ue,args:Le})}return vi.getMessage(Me.identifier.value,ie[0])},get bundle(){return vi.getBundle(Me.identifier.value)},get uri(){return vi.getBundleUri(Me.identifier.value)}},dn={_version:1,transferActiveChat(ie){return(0,Ye.$5G)(Me,"interactive"),Mi.transferActiveChat(ie)}},fn={getRelatedInformation(ie,ue){return(0,Ye.$5G)(Me,"aiRelatedInformation"),nn.getRelatedInformation(Me,ie,ue)},registerRelatedInformationProvider(ie,ue){return(0,Ye.$5G)(Me,"aiRelatedInformation"),nn.registerRelatedInformationProvider(Me,ie,ue)},registerEmbeddingVectorProvider(ie,ue){return(0,Ye.$5G)(Me,"aiRelatedInformation"),Ki.registerEmbeddingVectorProvider(Me,ie,ue)}},gn={_version:1,registerChatResponseProvider(ie,ue,Le){return(0,Ye.$5G)(Me,"chatProvider"),Qt.registerLanguageModel(Me,ie,ue,Le)},registerChatVariableResolver(ie,ue,Le,at,Et,Tt,Ai,Xi){return(0,Ye.$5G)(Me,"chatVariableResolver"),tn.registerVariableResolver(Me,ie,ue,Le,at,Et,Tt,Ai,Xi?.id)},registerMappedEditsProvider(ie,ue){return(0,Ye.$5G)(Me,"mappedEditsProvider"),Ee.registerMappedEditsProvider(Me,ie,ue)},createChatParticipant(ie,ue){return Mi.createChatAgent(Me,ie,ue)},createDynamicChatParticipant(ie,ue,Le){return(0,Ye.$5G)(Me,"chatParticipantPrivate"),Mi.createDynamicChatAgent(Me,ie,ue,Le)}},Dn={selectChatModels:ie=>Qt.selectLanguageModels(Me,ie??{}),onDidChangeChatModels:(ie,ue,Le)=>Qt.onDidChangeProviders(ie,ue,Le),registerChatModelProvider:(ie,ue,Le)=>((0,Ye.$5G)(Me,"chatProvider"),Qt.registerLanguageModel(Me,ie,ue,Le)),get embeddingModels(){return(0,Ye.$5G)(Me,"embeddings"),Oi.embeddingsModels},onDidChangeEmbeddingModels:(ie,ue,Le)=>((0,Ye.$5G)(Me,"embeddings"),Oi.onDidChange(ie,ue,Le)),registerEmbeddingsProvider(ie,ue){return(0,Ye.$5G)(Me,"embeddings"),Oi.registerEmbeddingsProvider(Me,ie,ue)},async computeEmbeddings(ie,ue,Le){return(0,Ye.$5G)(Me,"embeddings"),Oi.computeEmbeddings(ie,ue,Le)},registerTool(ie,ue){return(0,Ye.$5G)(Me,"lmTools"),Gi.registerTool(Me,ie,ue)},invokeTool(ie,ue,Le){return(0,Ye.$5G)(Me,"lmTools"),Gi.invokeTool(ie,ue,Le)},get tools(){return(0,Ye.$5G)(Me,"lmTools"),Gi.tools}},Sn={registerSpeechProvider(ie,ue){return(0,Ye.$5G)(Me,"speech"),wn.registerProvider(Me.identifier,ie,ue)}};return{version:Ct.version,ai:fn,authentication:Bi,commands:vn,comments:un,chat:gn,debug:yn,env:mi,extensions:sn,interactive:dn,l10n:Ji,languages:on,lm:Dn,notebooks:hn,scm:ln,speech:Sn,tasks:En,tests:Wi,window:an,workspace:cn,Breakpoint:K.$vO,TerminalOutputAnchor:K.TerminalOutputAnchor,ChatResultFeedbackKind:K.ChatResultFeedbackKind,ChatVariableLevel:K.ChatVariableLevel,ChatCompletionItem:K.$qP,CallHierarchyIncomingCall:K.$TN,CallHierarchyItem:K.$SN,CallHierarchyOutgoingCall:K.$UN,CancellationError:I.$4,CancellationTokenSource:v.$ue,CandidatePortSource:i.CandidatePortSource,CodeAction:K.$PN,CodeActionKind:K.$QN,CodeActionTriggerKind:K.CodeActionTriggerKind,CodeLens:K.$VN,Color:K.$9N,ColorInformation:K.$0N,ColorPresentation:K.$$N,ColorThemeKind:K.ColorThemeKind,CommentMode:K.CommentMode,CommentState:K.CommentState,CommentThreadCollapsibleState:K.CommentThreadCollapsibleState,CommentThreadState:K.CommentThreadState,CommentThreadApplicability:K.CommentThreadApplicability,CompletionItem:K.$3N,CompletionItemKind:K.CompletionItemKind,CompletionItemTag:K.CompletionItemTag,CompletionList:K.$4N,CompletionTriggerKind:K.CompletionTriggerKind,ConfigurationTarget:K.ConfigurationTarget,CustomExecution:K.$gO,DebugAdapterExecutable:K.$zO,DebugAdapterInlineImplementation:K.$CO,DebugAdapterNamedPipeServer:K.$BO,DebugAdapterServer:K.$AO,DebugConfigurationProviderTriggerKind:ui.DebugConfigurationProviderTriggerKind,DebugConsoleMode:K.DebugConsoleMode,DebugVisualization:K.$SO,DecorationRangeBehavior:K.DecorationRangeBehavior,Diagnostic:K.$IN,DiagnosticRelatedInformation:K.$HN,DiagnosticSeverity:K.DiagnosticSeverity,DiagnosticTag:K.DiagnosticTag,Disposable:K.$uN,DocumentHighlight:K.$LN,DocumentHighlightKind:K.DocumentHighlightKind,MultiDocumentHighlight:K.$MN,DocumentLink:K.$8N,DocumentSymbol:K.$ON,EndOfLine:K.EndOfLine,EnvironmentVariableMutatorType:K.EnvironmentVariableMutatorType,EvaluatableExpression:K.$FO,InlineValueText:K.$GO,InlineValueVariableLookup:K.$HO,InlineValueEvaluatableExpression:K.$IO,InlineCompletionTriggerKind:K.InlineCompletionTriggerKind,EventEmitter:C.$je,ExtensionKind:K.ExtensionKind,ExtensionMode:K.ExtensionMode,ExternalUriOpenerPriority:K.ExternalUriOpenerPriority,FileChangeType:K.FileChangeType,FileDecoration:K.$UO,FileDecoration2:K.$UO,FileSystemError:K.$LO,FileType:f.FileType,FilePermission:f.FilePermission,FoldingRange:K.$MO,FoldingRangeKind:K.FoldingRangeKind,FunctionBreakpoint:K.$xO,InlineCompletionItem:K.$5N,InlineCompletionList:K.$6N,Hover:K.$JN,VerboseHover:K.$KN,HoverVerbosityAction:K.HoverVerbosityAction,IndentAction:y.IndentAction,Location:K.$GN,MarkdownString:K.$WN,OverviewRulerLane:c.OverviewRulerLane,ParameterInformation:K.$XN,PortAutoForwardAction:K.PortAutoForwardAction,Position:K.$vN,ProcessExecution:K.$eO,ProgressLocation:K.ProgressLocation,QuickInputButtons:K.$TO,Range:K.$wN,RelativePattern:K.$tO,Selection:K.$xN,SelectionRange:K.$RN,SemanticTokens:K.$PO,SemanticTokensBuilder:K.$OO,SemanticTokensEdit:K.$QO,SemanticTokensEdits:K.$RO,SemanticTokensLegend:K.$NO,ShellExecution:K.$fO,ShellQuoting:K.ShellQuoting,SignatureHelp:K.$ZN,SignatureHelpTriggerKind:K.SignatureHelpTriggerKind,SignatureInformation:K.$YN,SnippetString:K.$FN,SourceBreakpoint:K.$wO,StandardTokenType:K.StandardTokenType,StatusBarAlignment:K.StatusBarAlignment,SymbolInformation:K.$NN,SymbolKind:K.SymbolKind,SymbolTag:K.SymbolTag,Task:K.$hO,TaskGroup:K.$dO,TaskPanelKind:K.TaskPanelKind,TaskRevealKind:K.TaskRevealKind,TaskScope:K.TaskScope,TerminalLink:K.$_N,TerminalQuickFixTerminalCommand:K.$bO,TerminalQuickFixOpener:K.$aO,TerminalLocation:K.TerminalLocation,TerminalProfile:K.$cO,TerminalExitReason:K.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:K.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:K.TextDocumentSaveReason,TextEdit:K.$BN,SnippetTextEdit:K.$DN,TextEditorCursorStyle:a.TextEditorCursorStyle,TextEditorLineNumbersStyle:K.TextEditorLineNumbersStyle,TextEditorRevealType:K.TextEditorRevealType,TextEditorSelectionChangeKind:K.TextEditorSelectionChangeKind,SyntaxTokenType:K.SyntaxTokenType,TextDocumentChangeReason:K.TextDocumentChangeReason,ThemeColor:K.$sO,ThemeIcon:K.$rO,TreeItem:K.$iO,TreeItemCheckboxState:K.TreeItemCheckboxState,TreeItemCollapsibleState:K.TreeItemCollapsibleState,TypeHierarchyItem:K.$eP,UIKind:ti.UIKind,Uri:$.URI,ViewColumn:K.ViewColumn,WorkspaceEdit:K.$EN,DocumentPasteTriggerKind:K.DocumentPasteTriggerKind,DocumentDropEdit:K.$oO,DocumentDropOrPasteEditKind:K.$pO,DocumentPasteEdit:K.$qO,InlayHint:K.$2N,InlayHintLabelPart:K.$1N,InlayHintKind:K.InlayHintKind,RemoteAuthorityResolverError:K.$AN,ResolvedAuthority:K.$yN,ManagedResolvedAuthority:K.$zN,SourceControlInputBoxValidationType:K.SourceControlInputBoxValidationType,ExtensionRuntime:K.ExtensionRuntime,TimelineItem:K.$5O,NotebookRange:K.$WO,NotebookCellKind:K.NotebookCellKind,NotebookCellExecutionState:K.NotebookCellExecutionState,NotebookCellData:K.$XO,NotebookData:K.$YO,NotebookRendererScript:K.$3O,NotebookCellStatusBarAlignment:K.NotebookCellStatusBarAlignment,NotebookEditorRevealType:K.NotebookEditorRevealType,NotebookCellOutput:K.$1O,NotebookCellOutputItem:K.$ZO,NotebookCellStatusBarItem:K.$2O,NotebookControllerAffinity:K.NotebookControllerAffinity,NotebookControllerAffinity2:K.NotebookControllerAffinity2,NotebookEdit:K.$CN,NotebookKernelSourceAction:K.$4O,NotebookVariablesRequestKind:K.NotebookVariablesRequestKind,PortAttributes:K.$7O,LinkedEditingRanges:K.$6O,TestResultState:K.TestResultState,TestRunRequest:K.$8O,TestMessage:K.$9O,TestTag:K.$0O,TestRunProfileKind:K.TestRunProfileKind,TextSearchCompleteMessageType:Gt.TextSearchCompleteMessageType,DataTransfer:K.$nO,DataTransferItem:K.$jO,TestCoverageCount:K.$$O,FileCoverage:K.$aP,FileCoverage2:K.$aP,StatementCoverage:K.$bP,BranchCoverage:K.$cP,DeclarationCoverage:K.$dP,WorkspaceTrustState:K.WorkspaceTrustState,LanguageStatusSeverity:K.LanguageStatusSeverity,QuickPickItemKind:K.QuickPickItemKind,InputBoxValidationSeverity:K.InputBoxValidationSeverity,TabInputText:K.$fP,TabInputTextDiff:K.$gP,TabInputTextMerge:K.$hP,TabInputCustom:K.$iP,TabInputNotebook:K.$kP,TabInputNotebookDiff:K.$lP,TabInputWebview:K.$jP,TabInputTerminal:K.$mP,TabInputInteractiveWindow:K.$nP,TabInputChat:K.$oP,TabInputTextMultiDiff:K.$pP,TelemetryTrustedValue:s.$tp,LogLevel:n.LogLevel,EditSessionIdentityMatch:l.EditSessionIdentityMatch,InteractiveSessionVoteDirection:K.InteractiveSessionVoteDirection,ChatCopyKind:K.ChatCopyKind,InteractiveEditorResponseFeedbackKind:K.InteractiveEditorResponseFeedbackKind,DebugStackFrame:K.$DO,DebugThread:K.$EO,RelatedInformationType:K.RelatedInformationType,SpeechToTextStatus:K.SpeechToTextStatus,TextToSpeechStatus:K.TextToSpeechStatus,PartialAcceptTriggerKind:K.PartialAcceptTriggerKind,KeywordRecognitionStatus:K.KeywordRecognitionStatus,ChatResponseMarkdownPart:K.$rP,ChatResponseFileTreePart:K.$vP,ChatResponseAnchorPart:K.$wP,ChatResponseProgressPart:K.$xP,ChatResponseProgressPart2:K.$yP,ChatResponseReferencePart:K.$BP,ChatResponseWarningPart:K.$zP,ChatResponseTextEditPart:K.$CP,ChatResponseMarkdownWithVulnerabilitiesPart:K.$sP,ChatResponseCommandButtonPart:K.$AP,ChatResponseDetectedParticipantPart:K.$tP,ChatResponseConfirmationPart:K.$uP,ChatRequestTurn:K.$DP,ChatResponseTurn:K.$EP,ChatLocation:K.ChatLocation,ChatRequestEditorData:K.$FP,ChatRequestNotebookData:K.$GP,LanguageModelChatMessageRole:K.LanguageModelChatMessageRole,LanguageModelChatMessage:K.$IP,LanguageModelChatMessageFunctionResultPart:K.$HP,LanguageModelChatResponseTextPart:K.$KP,LanguageModelChatResponseFunctionUsePart:K.$JP,LanguageModelError:K.$OP,NewSymbolName:K.$KO,NewSymbolNameTag:K.NewSymbolNameTag,NewSymbolNameTriggerKind:K.NewSymbolNameTriggerKind,InlineEdit:K.$PP,InlineEditTriggerKind:K.InlineEditTriggerKind}}}}),define(Ne[276],Oe([1,0,60,128,45,122,46,33,57,56,131,133,134,88,92,84,121,68,50,87,66,70,215,11,132,85,86,90,94,126,95]),function(we,e,v,I,C,N,A,T,$,a,R,y,c,S,f,n,o,s,l,i,r,t,g,u,p,m,d,E,D,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.$Ns)(m.$ipc,m.$hpc,v.InstantiationType.Delayed),(0,v.$Ns)(u.$0j,g.$xqc,v.InstantiationType.Delayed),(0,v.$Ns)(n.$noc,n.$ooc,v.InstantiationType.Delayed),(0,v.$Ns)(T.$kQ,T.$jQ,v.InstantiationType.Eager),(0,v.$Ns)(E.$xoc,E.$yoc,v.InstantiationType.Eager),(0,v.$Ns)(D.$cpc,D.$dpc,v.InstantiationType.Eager),(0,v.$Ns)(A.$Moc,A.$Koc,v.InstantiationType.Eager),(0,v.$Ns)(s.$Ooc,s.$Noc,v.InstantiationType.Eager),(0,v.$Ns)(k.$spc,k.$tpc,v.InstantiationType.Eager),(0,v.$Ns)(y.$xpc,y.$Bpc,v.InstantiationType.Eager),(0,v.$Ns)(N.$Dpc,N.$Cpc,v.InstantiationType.Eager),(0,v.$Ns)($.$_P,$.$$P,v.InstantiationType.Eager),(0,v.$Ns)(d.$jpc,d.$kpc,v.InstantiationType.Eager),(0,v.$Ns)(l.$roc,l.$qoc,v.InstantiationType.Eager),(0,v.$Ns)(I.$0pc,I.$9pc,v.InstantiationType.Delayed),(0,v.$Ns)(c.$Tpc,c.$Upc,v.InstantiationType.Eager),(0,v.$Ns)(S.$8oc,S.$7oc,v.InstantiationType.Eager),(0,v.$Ns)(R.$kqc,R.$jqc,v.InstantiationType.Eager),(0,v.$Ns)(a.$$oc,a.$bpc,v.InstantiationType.Eager),(0,v.$Ns)(w.$lqc,w.$mqc,v.InstantiationType.Eager),(0,v.$Ns)(f.$SFb,f.$TFb,v.InstantiationType.Eager),(0,v.$Ns)(o.$vqc,o.$uqc,v.InstantiationType.Eager),(0,v.$Ns)(C.$Joc,C.$Ioc,v.InstantiationType.Eager),(0,v.$Ns)(i.$fpc,i.$epc,v.InstantiationType.Eager),(0,v.$Ns)(r.$iQ,r.$fQ,v.InstantiationType.Eager),(0,v.$Ns)(t.$Yoc,t.$Zoc,v.InstantiationType.Eager),(0,v.$Ns)(p.$qpc,p.$rpc,v.InstantiationType.Eager)}),define(Ne[277],Oe([1,0,275,47,2,272,7,10,222]),function(we,e,v,I,C,N,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jsc=void 0;class a extends N.$Aqc{j(){}getModule(S,f){for(const n of this.b){const o=n(S);if(o){S=o;break}}if(this.a.has(S))return this.a.get(S).load(S,f,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends I.$mpc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async vb(){this.h.createInstance($.$Isc);const S=this.h.invokeFunction(v.$wqc);this.r=this.h.createInstance(a,S,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(S){return S.browser}async xb(S,f,n){f=f.with({path:y(f.path,".js")});const o=S?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const s=C.URI.revive(await this.C.$asBrowserUri(f)),l=await fetch(s.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),l.status!==200)throw new Error(l.statusText);const i=await l.text(),r=`${f.toString(!0)}#vscode-extension`,t=`${i}
//# sourceURL=${r}`;let g;try{g=new Function("module","exports","require",t)}catch(d){throw console.error(o?`Loading code for extension ${o} failed: ${d.message}`:`Loading code failed: ${d.message}`),console.error(`${f.toString(!0)}${typeof d.line=="number"?` line ${d.line}`:""}${typeof d.column=="number"?` column ${d.column}`:""}`),console.error(d),d}S&&await this.w.initializeLocalizedMessages(S);const u={},p={exports:u},m=d=>{const E=this.r.getModule(d,f);if(E===void 0)throw new Error(`Cannot load module '${d}'`);return E};try{return n.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),g(p,u,m),p.exports!==u?p.exports:u}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),n.codeLoadingStop()}}async $setRemoteEnvironment(S){}async Bb(S=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const f=Date.now()+S;for(;Date.now()<f&&!("__jsDebugIsReady"in globalThis);)await(0,T.$Dh)(10)}}e.$Jsc=R;function y(c,S){return c.endsWith(S)?c:c+S}}),define(Ne[278],Oe([1,0,73,60,11,47,187,91,277]),function(we,e,v,I,C,N,A,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$Ns)(C.$9j,new v.$zi(A.$zqc,[!0],!0)),(0,I.$Ns)(N.$npc,$.$Jsc,I.InstantiationType.Eager),(0,I.$Ns)(T.$Poc,T.$Qoc,I.InstantiationType.Eager)}),define(Ne[286],Oe([1,0,22,6,83,273,224,19,64,15,2,276,278]),function(we,e,v,I,C,N,A,T,$,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=t,T=Ve(T),$=Ve($);const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const c=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function S(g){return/^(file|vscode-remote):/i.test(g)}const f=fetch.bind(self);function n(g){self.fetch=async function(u,p){return u instanceof Request||S(String(u))&&(u=(await g(R.URI.parse(String(u)))).toString(!0)),f(u,p)},self.XMLHttpRequest=class extends XMLHttpRequest{open(u,p,m,d,E){(async()=>(S(p.toString())&&(p=(await g(R.URI.parse(p.toString()))).toString(!0)),super.open(u,p,m??!0,d,E)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const g=self.Worker;Worker=function(u,p){if(/^file:/i.test(u.toString()))u=a.$Wg.uriToBrowserUri(R.URI.parse(u.toString())).toString(!0);else if(/^vscode-remote:/i.test(u.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const d=`(${function(k){function P(M){return typeof M=="string"||M instanceof URL?String(M).replace(/^file:\/\//i,"vscode-file://vscode-app"):M}const h=fetch.bind(self);self.fetch=function(M,O){return M instanceof Request?h(M,O):h(P(M),O)},self.XMLHttpRequest=class extends XMLHttpRequest{open(M,O,F,q,B){return super.open(M,P(O),F??!0,q,B)}};const b=importScripts.bind(self);self.importScripts=(...M)=>{b(...M.map(P))},b(k)}.toString()}('${u}'))`;p=p||{},p.name=`${name} -> ${p.name||T.$mc(u.toString())}`;const E=new Blob([d],{type:"application/javascript"}),D=URL.createObjectURL(E);return new g(D,p)}}else self.Worker=class extends A.$Ksc{constructor(g,u){super(c,g,{name:T.$mc(g.toString()),...u})}};const o=new class{constructor(){this.pid=void 0}exit(g){y()}};class s{constructor(){const u=new MessageChannel,p=new I.$je;let m=!1;c(u.port2,[u.port2]),u.port1.onmessage=d=>{const{data:E}=d;if(!(E instanceof ArrayBuffer)){console.warn("UNKNOWN data received",E);return}const D=v.$Le.wrap(new Uint8Array(E,0,E.byteLength));if((0,C.$yn)(D,C.MessageType.Terminate)){m=!0,i("received terminate message from renderer");return}p.fire(D)},this.protocol={onMessage:p.event,send:d=>{if(!m){const E=d.buffer.buffer.slice(d.buffer.byteOffset,d.buffer.byteOffset+d.buffer.byteLength);u.port1.postMessage(E,[E])}}}}}function l(g){return new Promise(u=>{const p=g.onMessage(m=>{p.dispose();const d=JSON.parse(m.toString());g.send((0,C.$xn)(C.MessageType.Initialized)),u({protocol:g,initData:d})});g.send((0,C.$xn)(C.MessageType.Ready))})}let i=g=>y();function r(g){return!!g&&typeof g=="object"&&g.type==="vscode.init"&&g.data instanceof Map}function t(){$.mark("code/extHost/willConnectToRenderer");const g=new s;return{onmessage(u){r(u)&&l(g.protocol).then(p=>{$.mark("code/extHost/didWaitForInitData");const m=new N.$Cqc(p.protocol,p.initData,o,null,u.data);n(d=>m.asBrowserUri(d)),i=d=>m.terminate(d)})}}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/e6a828c5957959b7a18de37a567d850880101641/core/vs/workbench/api/worker/extensionHostWorker.js.map
